/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/nls!vs/code/electron-main/main","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/objects","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/issue/electron-main/processMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ae=function(V){for(var e=[],n=0,o=V.length;n<o;n++)e[n]=oe[V[n]];return e};define(oe[138],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=n,e.findLastIdx=o,e.findLastMonotonous=I,e.findLastIdxMonotonous=k,e.findFirstMonotonous=C,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=y,e.findFirstMax=h,e.findLastMax=f,e.findFirstMin=g,e.findMaxIdx=w,e.mapFindFirst=d;function n(v,E){const p=o(v,E);if(p!==-1)return v[p]}function o(v,E,p=v.length-1){for(let m=p;m>=0;m--){const b=v[m];if(E(b))return m}return-1}function I(v,E){const p=k(v,E);return p===-1?void 0:v[p]}function k(v,E,p=0,m=v.length){let b=p,D=m;for(;b<D;){const t=Math.floor((b+D)/2);E(v[t])?b=t+1:D=t}return b-1}function C(v,E){const p=R(v,E);return p===v.length?void 0:v[p]}function R(v,E,p=0,m=v.length){let b=p,D=m;for(;b<D;){const t=Math.floor((b+D)/2);E(v[t])?D=t:b=t+1}return b}function y(v,E,p=0,m=v.length){const b=R(v,E,p,m);return b===v.length?-1:b}class a{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const m of this._array)if(this._prevFindLastPredicate(m)&&!E(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const p=k(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=a;function h(v,E){if(v.length===0)return;let p=v[0];for(let m=1;m<v.length;m++){const b=v[m];E(b,p)>0&&(p=b)}return p}function f(v,E){if(v.length===0)return;let p=v[0];for(let m=1;m<v.length;m++){const b=v[m];E(b,p)>=0&&(p=b)}return p}function g(v,E){return h(v,(p,m)=>-E(p,m))}function w(v,E){if(v.length===0)return-1;let p=0;for(let m=1;m<v.length;m++){const b=v[m];E(b,v[p])>0&&(p=m)}return p}function d(v,E){for(const p of v){const m=E(p);if(m!==void 0)return m}}}),define(oe[39],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(o){o[o.Null=0]="Null",o[o.Backspace=8]="Backspace",o[o.Tab=9]="Tab",o[o.LineFeed=10]="LineFeed",o[o.CarriageReturn=13]="CarriageReturn",o[o.Space=32]="Space",o[o.ExclamationMark=33]="ExclamationMark",o[o.DoubleQuote=34]="DoubleQuote",o[o.Hash=35]="Hash",o[o.DollarSign=36]="DollarSign",o[o.PercentSign=37]="PercentSign",o[o.Ampersand=38]="Ampersand",o[o.SingleQuote=39]="SingleQuote",o[o.OpenParen=40]="OpenParen",o[o.CloseParen=41]="CloseParen",o[o.Asterisk=42]="Asterisk",o[o.Plus=43]="Plus",o[o.Comma=44]="Comma",o[o.Dash=45]="Dash",o[o.Period=46]="Period",o[o.Slash=47]="Slash",o[o.Digit0=48]="Digit0",o[o.Digit1=49]="Digit1",o[o.Digit2=50]="Digit2",o[o.Digit3=51]="Digit3",o[o.Digit4=52]="Digit4",o[o.Digit5=53]="Digit5",o[o.Digit6=54]="Digit6",o[o.Digit7=55]="Digit7",o[o.Digit8=56]="Digit8",o[o.Digit9=57]="Digit9",o[o.Colon=58]="Colon",o[o.Semicolon=59]="Semicolon",o[o.LessThan=60]="LessThan",o[o.Equals=61]="Equals",o[o.GreaterThan=62]="GreaterThan",o[o.QuestionMark=63]="QuestionMark",o[o.AtSign=64]="AtSign",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.OpenSquareBracket=91]="OpenSquareBracket",o[o.Backslash=92]="Backslash",o[o.CloseSquareBracket=93]="CloseSquareBracket",o[o.Caret=94]="Caret",o[o.Underline=95]="Underline",o[o.BackTick=96]="BackTick",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.OpenCurlyBrace=123]="OpenCurlyBrace",o[o.Pipe=124]="Pipe",o[o.CloseCurlyBrace=125]="CloseCurlyBrace",o[o.Tilde=126]="Tilde",o[o.NoBreakSpace=160]="NoBreakSpace",o[o.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",o[o.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",o[o.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",o[o.U_Combining_Tilde=771]="U_Combining_Tilde",o[o.U_Combining_Macron=772]="U_Combining_Macron",o[o.U_Combining_Overline=773]="U_Combining_Overline",o[o.U_Combining_Breve=774]="U_Combining_Breve",o[o.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",o[o.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",o[o.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",o[o.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",o[o.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",o[o.U_Combining_Caron=780]="U_Combining_Caron",o[o.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",o[o.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",o[o.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",o[o.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",o[o.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",o[o.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",o[o.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",o[o.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",o[o.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",o[o.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",o[o.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",o[o.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",o[o.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",o[o.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",o[o.U_Combining_Horn=795]="U_Combining_Horn",o[o.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",o[o.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",o[o.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",o[o.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",o[o.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",o[o.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",o[o.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",o[o.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",o[o.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",o[o.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",o[o.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",o[o.U_Combining_Cedilla=807]="U_Combining_Cedilla",o[o.U_Combining_Ogonek=808]="U_Combining_Ogonek",o[o.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",o[o.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",o[o.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",o[o.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",o[o.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",o[o.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",o[o.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",o[o.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",o[o.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",o[o.U_Combining_Low_Line=818]="U_Combining_Low_Line",o[o.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",o[o.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",o[o.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",o[o.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",o[o.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",o[o.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",o[o.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",o[o.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",o[o.U_Combining_Square_Below=827]="U_Combining_Square_Below",o[o.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",o[o.U_Combining_X_Above=829]="U_Combining_X_Above",o[o.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",o[o.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",o[o.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",o[o.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",o[o.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",o[o.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",o[o.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",o[o.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",o[o.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",o[o.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",o[o.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",o[o.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",o[o.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",o[o.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",o[o.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",o[o.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",o[o.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",o[o.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",o[o.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",o[o.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",o[o.U_Combining_Fermata=850]="U_Combining_Fermata",o[o.U_Combining_X_Below=851]="U_Combining_X_Below",o[o.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",o[o.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",o[o.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",o[o.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",o[o.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",o[o.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",o[o.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",o[o.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",o[o.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",o[o.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",o[o.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",o[o.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",o[o.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",o[o.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",o[o.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",o[o.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",o[o.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",o[o.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",o[o.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",o[o.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",o[o.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",o[o.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",o[o.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",o[o.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",o[o.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",o[o.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",o[o.LINE_SEPARATOR=8232]="LINE_SEPARATOR",o[o.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",o[o.NEXT_LINE=133]="NEXT_LINE",o[o.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",o[o.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",o[o.U_DIAERESIS=168]="U_DIAERESIS",o[o.U_MACRON=175]="U_MACRON",o[o.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",o[o.U_CEDILLA=184]="U_CEDILLA",o[o.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",o[o.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",o[o.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",o[o.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",o[o.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",o[o.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",o[o.U_BREVE=728]="U_BREVE",o[o.U_DOT_ABOVE=729]="U_DOT_ABOVE",o[o.U_RING_ABOVE=730]="U_RING_ABOVE",o[o.U_OGONEK=731]="U_OGONEK",o[o.U_SMALL_TILDE=732]="U_SMALL_TILDE",o[o.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",o[o.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",o[o.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",o[o.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",o[o.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",o[o.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",o[o.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",o[o.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",o[o.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",o[o.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",o[o.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",o[o.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",o[o.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",o[o.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",o[o.U_GREEK_TONOS=900]="U_GREEK_TONOS",o[o.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",o[o.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",o[o.U_GREEK_PSILI=8127]="U_GREEK_PSILI",o[o.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",o[o.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",o[o.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",o[o.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",o[o.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",o[o.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",o[o.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",o[o.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",o[o.U_GREEK_VARIA=8175]="U_GREEK_VARIA",o[o.U_GREEK_OXIA=8189]="U_GREEK_OXIA",o[o.U_GREEK_DASIA=8190]="U_GREEK_DASIA",o[o.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",o[o.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",o[o.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",o[o.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",o[o.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",o[o.U_OVERLINE=8254]="U_OVERLINE",o[o.UTF8_BOM=65279]="UTF8_BOM",o[o.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",o[o.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(oe[139],ae([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=o,e.diffSets=I,e.diffMaps=k,e.intersection=C;function o(y,a){const h=Object.create(null);for(const f of y){const g=a(f);let w=h[g];w||(w=h[g]=[]),w.push(f)}return h}function I(y,a){const h=[],f=[];for(const g of y)a.has(g)||h.push(g);for(const g of a)y.has(g)||f.push(g);return{removed:h,added:f}}function k(y,a){const h=[],f=[];for(const[g,w]of y)a.has(g)||h.push(w);for(const[g,w]of a)y.has(g)||f.push(w);return{removed:h,added:f}}function C(y,a){const h=new Set;for(const f of a)y.has(f)&&h.add(f);return h}class R{static{n=Symbol.toStringTag}constructor(a,h){this.toKey=h,this._map=new Map,this[n]="SetWithKey";for(const f of a)this.add(f)}get size(){return this._map.size}add(a){const h=this.toKey(a);return this._map.set(h,a),this}delete(a){return this._map.delete(this.toKey(a))}has(a){return this._map.has(this.toKey(a))}*entries(){for(const a of this._map.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this._map.values())yield a}clear(){this._map.clear()}forEach(a,h){this._map.forEach(f=>a.call(h,f,f,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=R}),define(oe[140],ae([0,1,39]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function o(y,a){const h=Math.pow(10,a);return Math.round(y*h)/h}class I{constructor(a,h,f,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.r===h.r&&a.g===h.g&&a.b===h.b&&a.a===h.a}}e.RGBA=I;class k{constructor(a,h,f,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.l=o(Math.max(Math.min(1,f),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.l===h.l&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,w=a.a,d=Math.max(h,f,g),v=Math.min(h,f,g);let E=0,p=0;const m=(v+d)/2,b=d-v;if(b>0){switch(p=Math.min(m<=.5?b/(2*m):b/(2-2*m),1),d){case h:E=(f-g)/b+(f<g?6:0);break;case f:E=(g-h)/b+2;break;case g:E=(h-f)/b+4;break}E*=60,E=Math.round(E)}return new k(E,p,m,w)}static _hue2rgb(a,h,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?a+(h-a)*6*f:f<1/2?h:f<2/3?a+(h-a)*(2/3-f)*6:a}static toRGBA(a){const h=a.h/360,{s:f,l:g,a:w}=a;let d,v,E;if(f===0)d=v=E=g;else{const p=g<.5?g*(1+f):g+f-g*f,m=2*g-p;d=k._hue2rgb(m,p,h+1/3),v=k._hue2rgb(m,p,h),E=k._hue2rgb(m,p,h-1/3)}return new I(Math.round(d*255),Math.round(v*255),Math.round(E*255),w)}}e.HSLA=k;class C{constructor(a,h,f,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.v=o(Math.max(Math.min(1,f),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.v===h.v&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,w=Math.max(h,f,g),d=Math.min(h,f,g),v=w-d,E=w===0?0:v/w;let p;return v===0?p=0:w===h?p=((f-g)/v%6+6)%6:w===f?p=(g-h)/v+2:p=(h-f)/v+4,new C(Math.round(p*60),E,w,a.a)}static toRGBA(a){const{h,s:f,v:g,a:w}=a,d=g*f,v=d*(1-Math.abs(h/60%2-1)),E=g-d;let[p,m,b]=[0,0,0];return h<60?(p=d,m=v):h<120?(p=v,m=d):h<180?(m=d,b=v):h<240?(m=v,b=d):h<300?(p=v,b=d):h<=360&&(p=d,b=v),p=Math.round((p+E)*255),m=Math.round((m+E)*255),b=Math.round((b+E)*255),new I(p,m,b,w)}}e.HSVA=C;class R{static fromHex(a){return R.Format.CSS.parseHex(a)||R.red}static equals(a,h){return!a&&!h?!0:!a||!h?!1:a.equals(h)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:C.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof I)this.rgba=a;else if(a instanceof k)this._hsla=a,this.rgba=k.toRGBA(a);else if(a instanceof C)this._hsva=a,this.rgba=C.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&I.equals(this.rgba,a.rgba)&&k.equals(this.hsla,a.hsla)&&C.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=R._relativeLuminanceForComponent(this.rgba.r),h=R._relativeLuminanceForComponent(this.rgba.g),f=R._relativeLuminanceForComponent(this.rgba.b),g=.2126*a+.7152*h+.0722*f;return o(g,4)}static _relativeLuminanceForComponent(a){const h=a/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f?(h+.05)/(f+.05):(f+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f}isDarkerThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h<f}lighten(a){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new R(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:h,g:f,b:g,a:w}=this.rgba;return new R(new I(h,f,g,w*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new I(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const h=a.rgba,f=this.rgba.a,g=h.a,w=f+g*(1-f);if(w<1e-6)return R.transparent;const d=this.rgba.r*f/w+h.r*g*(1-f)/w,v=this.rgba.g*f/w+h.g*g*(1-f)/w,E=this.rgba.b*f/w+h.b*g*(1-f)/w;return new R(new I(d,v,E,w))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:h,g:f,b:g,a:w}=this.rgba;return new R(new I(a.rgba.r-w*(a.rgba.r-h),a.rgba.g-w*(a.rgba.g-f),a.rgba.b-w*(a.rgba.b-g),1))}flatten(...a){const h=a.reduceRight((f,g)=>R._flatten(g,f));return R._flatten(this,h)}static _flatten(a,h){const f=1-a.rgba.a;return new R(new I(f*h.rgba.r+a.rgba.a*a.rgba.r,f*h.rgba.g+a.rgba.a*a.rgba.g,f*h.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(a,h,f){if(a.isLighterThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),w=h.getRelativeLuminance();return f=f*(w-g)/w,a.lighten(f)}static getDarkerColor(a,h,f){if(a.isDarkerThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),w=h.getRelativeLuminance();return f=f*(g-w)/g,a.darken(f)}static{this.white=new R(new I(255,255,255,1))}static{this.black=new R(new I(0,0,0,1))}static{this.red=new R(new I(255,0,0,1))}static{this.blue=new R(new I(0,0,255,1))}static{this.green=new R(new I(0,255,0,1))}static{this.cyan=new R(new I(0,255,255,1))}static{this.lightgrey=new R(new I(211,211,211,1))}static{this.transparent=new R(new I(0,0,0,0))}}e.Color=R,function(y){let a;(function(h){let f;(function(g){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:y.Format.CSS.formatRGBA(i)}g.formatRGB=w;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}g.formatRGBA=d;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(i)}g.formatHSL=v;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}g.formatHSLA=E;function p(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function m(i){return`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}`}g.formatHex=m;function b(i,c=!1){return c&&i.rgba.a===1?y.Format.CSS.formatHex(i):`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}${p(Math.round(i.rgba.a*255))}`}g.formatHexA=b;function D(i){return i.isOpaque()?y.Format.CSS.formatHex(i):y.Format.CSS.formatRGBA(i)}g.format=D;function t(i){const c=i.length;if(c===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(c===7){const r=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),l=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),u=16*s(i.charCodeAt(5))+s(i.charCodeAt(6));return new y(new I(r,l,u,1))}if(c===9){const r=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),l=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),u=16*s(i.charCodeAt(5))+s(i.charCodeAt(6)),P=16*s(i.charCodeAt(7))+s(i.charCodeAt(8));return new y(new I(r,l,u,P/255))}if(c===4){const r=s(i.charCodeAt(1)),l=s(i.charCodeAt(2)),u=s(i.charCodeAt(3));return new y(new I(16*r+r,16*l+l,16*u+u))}if(c===5){const r=s(i.charCodeAt(1)),l=s(i.charCodeAt(2)),u=s(i.charCodeAt(3)),P=s(i.charCodeAt(4));return new y(new I(16*r+r,16*l+l,16*u+u,(16*P+P)/255))}return null}g.parseHex=t;function s(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(f=h.CSS||(h.CSS={}))})(a=y.Format||(y.Format={}))}(R||(e.Color=R={}))}),define(oe[54],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=o,e.debounce=I,e.throttle=k;function n(C){return(R,y,a)=>{let h=null,f=null;if(typeof a.value=="function"?(h="value",f=a.value):typeof a.get=="function"&&(h="get",f=a.get),!f)throw new Error("not supported");a[h]=C(f,y)}}function o(C,R,y){let a=null,h=null;if(typeof y.value=="function"?(a="value",h=y.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(a="get",h=y.get),!h)throw new Error("not supported");const f=`$memoize$${R}`;y[a]=function(...g){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,g)}),this[f]}}function I(C,R,y){return n((a,h)=>{const f=`$debounce$${h}`,g=`$debounce$result$${h}`;return function(...w){this[g]||(this[g]=y?y():void 0),clearTimeout(this[f]),R&&(this[g]=R(this[g],...w),w=[this[g]]),this[f]=setTimeout(()=>{a.apply(this,w),this[g]=y?y():void 0},C)}})}function k(C,R,y){return n((a,h)=>{const f=`$throttle$timer$${h}`,g=`$throttle$result$${h}`,w=`$throttle$lastRun$${h}`,d=`$throttle$pending$${h}`;return function(...v){if(this[g]||(this[g]=y?y():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...v)),this[d])return;const E=this[w]+C;E<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=y?y():void 0):(this[d]=!0,this[f]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=y?y():void 0},E-Date.now()))}})}}),define(oe[16],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=o,e.isSigPipeError=I,e.onUnexpectedError=k,e.onUnexpectedExternalError=C,e.transformErrorForSerialization=R,e.transformErrorFromSerialization=y,e.isCancellationError=h,e.canceled=g,e.illegalArgument=w,e.illegalState=d,e.getErrorMessage=E;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?D.isErrorNoTelemetry(i)?new D(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(c=>{c(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=n,e.errorHandler=new n;function o(s){e.errorHandler.setUnexpectedErrorHandler(s)}function I(s){if(!s||typeof s!="object")return!1;const i=s;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function k(s){h(s)||e.errorHandler.onUnexpectedError(s)}function C(s){h(s)||e.errorHandler.onUnexpectedExternalError(s)}function R(s){if(s instanceof Error){const{name:i,message:c}=s,r=s.stacktrace||s.stack;return{$isError:!0,name:i,message:c,stack:r,noTelemetry:D.isErrorNoTelemetry(s)}}return s}function y(s){let i;return s.noTelemetry?i=new D:(i=new Error,i.name=s.name),i.message=s.message,i.stack=s.stack,i}const a="Canceled";function h(s){return s instanceof f?!0:s instanceof Error&&s.name===a&&s.message===a}class f extends Error{constructor(){super(a),this.name=this.message}}e.CancellationError=f;function g(){const s=new Error(a);return s.name=s.message,s}function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function d(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=v;function E(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=p;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class D extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof D)return i;const c=new D;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.BugIndicatingError=t}),define(oe[22],ae([0,1,16,138]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=I,e.tail2=k,e.equals=C,e.removeFastWithoutKeepingOrder=R,e.binarySearch=y,e.binarySearch2=a,e.quickSelect=h,e.groupBy=f,e.groupAdjacentBy=g,e.forEachAdjacent=w,e.forEachWithNeighbors=d,e.sortedDiff=v,e.delta=E,e.top=p,e.topAsync=m,e.coalesce=D,e.coalesceInPlace=t,e.move=s,e.isFalsyOrEmpty=i,e.isNonEmptyArray=c,e.distinct=r,e.uniqueFilter=l,e.firstOrDefault=u,e.lastOrDefault=P,e.commonPrefixLength=S,e.range=M,e.index=T,e.insert=L,e.remove=A,e.arrayInsert=_,e.shuffle=B,e.pushToStart=N,e.pushToEnd=z,e.pushMany=se,e.mapArrayOrNot=J,e.asArray=le,e.getRandomElement=K,e.insertInto=ee,e.splice=q,e.compareBy=j,e.tieBreakComparators=ce,e.reverseOrder=re;function I(U,H=0){return U[U.length-(1+H)]}function k(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function C(U,H,Y=(Q,$)=>Q===$){if(U===H)return!0;if(!U||!H||U.length!==H.length)return!1;for(let Q=0,$=U.length;Q<$;Q++)if(!Y(U[Q],H[Q]))return!1;return!0}function R(U,H){const Y=U.length-1;H<Y&&(U[H]=U[Y]),U.pop()}function y(U,H,Y){return a(U.length,Q=>Y(U[Q],H))}function a(U,H){let Y=0,Q=U-1;for(;Y<=Q;){const $=(Y+Q)/2|0,ie=H($);if(ie<0)Y=$+1;else if(ie>0)Q=$-1;else return $}return-(Y+1)}function h(U,H,Y){if(U=U|0,U>=H.length)throw new TypeError("invalid index");const Q=H[Math.floor(H.length*Math.random())],$=[],ie=[],fe=[];for(const me of H){const we=Y(me,Q);we<0?$.push(me):we>0?ie.push(me):fe.push(me)}return U<$.length?h(U,$,Y):U<$.length+fe.length?fe[0]:h(U-($.length+fe.length),ie,Y)}function f(U,H){const Y=[];let Q;for(const $ of U.slice(0).sort(H))!Q||H(Q[0],$)!==0?(Q=[$],Y.push(Q)):Q.push($);return Y}function*g(U,H){let Y,Q;for(const $ of U)Q!==void 0&&H(Q,$)?Y.push($):(Y&&(yield Y),Y=[$]),Q=$;Y&&(yield Y)}function w(U,H){for(let Y=0;Y<=U.length;Y++)H(Y===0?void 0:U[Y-1],Y===U.length?void 0:U[Y])}function d(U,H){for(let Y=0;Y<U.length;Y++)H(Y===0?void 0:U[Y-1],U[Y],Y+1===U.length?void 0:U[Y+1])}function v(U,H,Y){const Q=[];function $(me,we,Ce){if(we===0&&Ce.length===0)return;const Ie=Q[Q.length-1];Ie&&Ie.start+Ie.deleteCount===me?(Ie.deleteCount+=we,Ie.toInsert.push(...Ce)):Q.push({start:me,deleteCount:we,toInsert:Ce})}let ie=0,fe=0;for(;;){if(ie===U.length){$(ie,0,H.slice(fe));break}if(fe===H.length){$(ie,U.length-ie,[]);break}const me=U[ie],we=H[fe],Ce=Y(me,we);Ce===0?(ie+=1,fe+=1):Ce<0?($(ie,1,[]),ie+=1):Ce>0&&($(ie,0,[we]),fe+=1)}return Q}function E(U,H,Y){const Q=v(U,H,Y),$=[],ie=[];for(const fe of Q)$.push(...U.slice(fe.start,fe.start+fe.deleteCount)),ie.push(...fe.toInsert);return{removed:$,added:ie}}function p(U,H,Y){if(Y===0)return[];const Q=U.slice(0,Y).sort(H);return b(U,H,Q,Y,U.length),Q}function m(U,H,Y,Q,$){return Y===0?Promise.resolve([]):new Promise((ie,fe)=>{(async()=>{const me=U.length,we=U.slice(0,Y).sort(H);for(let Ce=Y,Ie=Math.min(Y+Q,me);Ce<me;Ce=Ie,Ie=Math.min(Ie+Q,me)){if(Ce>Y&&await new Promise(De=>setTimeout(De)),$&&$.isCancellationRequested)throw new n.CancellationError;b(U,H,we,Ce,Ie)}return we})().then(ie,fe)})}function b(U,H,Y,Q,$){for(const ie=Y.length;Q<$;Q++){const fe=U[Q];if(H(fe,Y[ie-1])<0){Y.pop();const me=(0,o.findFirstIdxMonotonousOrArrLen)(Y,we=>H(fe,we)<0);Y.splice(me,0,fe)}}}function D(U){return U.filter(H=>!!H)}function t(U){let H=0;for(let Y=0;Y<U.length;Y++)U[Y]&&(U[H]=U[Y],H+=1);U.length=H}function s(U,H,Y){U.splice(Y,0,U.splice(H,1)[0])}function i(U){return!Array.isArray(U)||U.length===0}function c(U){return Array.isArray(U)&&U.length>0}function r(U,H=Y=>Y){const Y=new Set;return U.filter(Q=>{const $=H(Q);return Y.has($)?!1:(Y.add($),!0)})}function l(U){const H=new Set;return Y=>{const Q=U(Y);return H.has(Q)?!1:(H.add(Q),!0)}}function u(U,H){return U.length>0?U[0]:H}function P(U,H){return U.length>0?U[U.length-1]:H}function S(U,H,Y=(Q,$)=>Q===$){let Q=0;for(let $=0,ie=Math.min(U.length,H.length);$<ie&&Y(U[$],H[$]);$++)Q++;return Q}function M(U,H){let Y=typeof H=="number"?U:0;typeof H=="number"?Y=U:(Y=0,H=U);const Q=[];if(Y<=H)for(let $=Y;$<H;$++)Q.push($);else for(let $=Y;$>H;$--)Q.push($);return Q}function T(U,H,Y){return U.reduce((Q,$)=>(Q[H($)]=Y?Y($):$,Q),Object.create(null))}function L(U,H){return U.push(H),()=>A(U,H)}function A(U,H){const Y=U.indexOf(H);if(Y>-1)return U.splice(Y,1),H}function _(U,H,Y){const Q=U.slice(0,H),$=U.slice(H);return Q.concat(Y,$)}function B(U,H){let Y;if(typeof H=="number"){let Q=H;Y=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else Y=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const $=Math.floor(Y()*(Q+1)),ie=U[Q];U[Q]=U[$],U[$]=ie}}function N(U,H){const Y=U.indexOf(H);Y>-1&&(U.splice(Y,1),U.unshift(H))}function z(U,H){const Y=U.indexOf(H);Y>-1&&(U.splice(Y,1),U.push(H))}function se(U,H){for(const Y of H)U.push(Y)}function J(U,H){return Array.isArray(U)?U.map(H):H(U)}function le(U){return Array.isArray(U)?U:[U]}function K(U){return U[Math.floor(Math.random()*U.length)]}function ee(U,H,Y){const Q=O(U,H),$=U.length,ie=Y.length;U.length=$+ie;for(let fe=$-1;fe>=Q;fe--)U[fe+ie]=U[fe];for(let fe=0;fe<ie;fe++)U[fe+Q]=Y[fe]}function q(U,H,Y,Q){const $=O(U,H);let ie=U.splice($,Y);return ie===void 0&&(ie=[]),ee(U,$,Q),ie}function O(U,H){return H<0?Math.max(H+U.length,0):Math.min(H,U.length)}var x;(function(U){function H(ie){return ie<0}U.isLessThan=H;function Y(ie){return ie<=0}U.isLessThanOrEqual=Y;function Q(ie){return ie>0}U.isGreaterThan=Q;function $(ie){return ie===0}U.isNeitherLessOrGreaterThan=$,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function j(U,H){return(Y,Q)=>H(U(Y),U(Q))}function ce(...U){return(H,Y)=>{for(const Q of U){const $=Q(H,Y);if(!x.isNeitherLessOrGreaterThan($))return $}return x.neitherLessOrGreaterThan}}const G=(U,H)=>U-H;e.numberComparator=G;const de=(U,H)=>(0,e.numberComparator)(U?1:0,H?1:0);e.booleanComparator=de;function re(U){return(H,Y)=>-U(H,Y)}class Z{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let Y=this.firstIdx;for(;Y<this.items.length&&H(this.items[Y]);)Y++;const Q=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,Q}takeFromEndWhile(H){let Y=this.lastIdx;for(;Y>=0&&H(this.items[Y]);)Y--;const Q=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,Q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}removeLast(){const H=this.items[this.lastIdx];return this.lastIdx--,H}takeCount(H){const Y=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,Y}}e.ArrayQueue=Z;class W{static{this.empty=new W(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(Y=>(H(Y),!0))}toArray(){const H=[];return this.iterate(Y=>(H.push(Y),!0)),H}filter(H){return new W(Y=>this.iterate(Q=>H(Q)?Y(Q):!0))}map(H){return new W(Y=>this.iterate(Q=>Y(H(Q))))}some(H){let Y=!1;return this.iterate(Q=>(Y=H(Q),!Y)),Y}findFirst(H){let Y;return this.iterate(Q=>H(Q)?(Y=Q,!1):!0),Y}findLast(H){let Y;return this.iterate(Q=>(H(Q)&&(Y=Q),!0)),Y}findLastMaxBy(H){let Y,Q=!0;return this.iterate($=>((Q||x.isGreaterThan(H($,Y)))&&(Q=!1,Y=$),!0)),Y}}e.CallbackIterable=W;class F{constructor(H){this._indexMap=H}static createSortPermutation(H,Y){const Q=Array.from(H.keys()).sort(($,ie)=>Y(H[$],H[ie]));return new F(Q)}apply(H){return H.map((Y,Q)=>H[this._indexMap[Q]])}inverse(){const H=this._indexMap.slice();for(let Y=0;Y<this._indexMap.length;Y++)H[this._indexMap[Y]]=Y;return new F(H)}}e.Permutation=F}),define(oe[141],ae([0,1,16]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=o,e.assertNever=I,e.assert=k,e.softAssert=C,e.assertFn=R,e.checkAdjacentItems=y;function o(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function I(a,h="Unreachable"){throw new Error(h)}function k(a,h="unexpected state"){if(!a)throw new n.BugIndicatingError(`Assertion Failed: ${h}`)}function C(a){a||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function R(a){if(!a()){debugger;a(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function y(a,h){let f=0;for(;f<a.length-1;){const g=a[f],w=a[f+1];if(!h(g,w))return!1;f++}return!0}}),define(oe[90],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=n;function n(o,I){const k=this;let C=!1,R;return function(){if(C)return R;if(C=!0,I)try{R=o.apply(k,arguments)}finally{I()}else R=o.apply(k,arguments);return R}}}),define(oe[78],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(o){function I(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}o.is=I;const k=Object.freeze([]);function C(){return k}o.empty=C;function*R(i){yield i}o.single=R;function y(i){return I(i)?i:R(i)}o.wrap=y;function a(i){return i||k}o.from=a;function*h(i){for(let c=i.length-1;c>=0;c--)yield i[c]}o.reverse=h;function f(i){return!i||i[Symbol.iterator]().next().done===!0}o.isEmpty=f;function g(i){return i[Symbol.iterator]().next().value}o.first=g;function w(i,c){let r=0;for(const l of i)if(c(l,r++))return!0;return!1}o.some=w;function d(i,c){for(const r of i)if(c(r))return r}o.find=d;function*v(i,c){for(const r of i)c(r)&&(yield r)}o.filter=v;function*E(i,c){let r=0;for(const l of i)yield c(l,r++)}o.map=E;function*p(i,c){let r=0;for(const l of i)yield*c(l,r++)}o.flatMap=p;function*m(...i){for(const c of i)yield*c}o.concat=m;function b(i,c,r){let l=r;for(const u of i)l=c(l,u);return l}o.reduce=b;function*D(i,c,r=i.length){for(c<0&&(c+=i.length),r<0?r+=i.length:r>i.length&&(r=i.length);c<r;c++)yield i[c]}o.slice=D;function t(i,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,i];const l=i[Symbol.iterator]();for(let u=0;u<c;u++){const P=l.next();if(P.done)return[r,o.empty()];r.push(P.value)}return[r,{[Symbol.iterator](){return l}}]}o.consume=t;async function s(i){const c=[];for await(const r of i)c.push(r);return Promise.resolve(c)}o.asyncToArray=s})(n||(e.Iterable=n={}))}),define(oe[43],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=C,e.getLocation=f,e.parse=g,e.parseTree=w,e.findNodeAtLocation=d,e.getNodePath=v,e.getNodeValue=E,e.contains=p,e.findNodeAtOffset=m,e.visit=b,e.getNodeType=D;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var o;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(o||(e.SyntaxKind=o={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function C(t,s=!1){let i=0;const c=t.length;let r="",l=0,u=o.Unknown,P=n.None;function S(N){let z=0,se=0;for(;z<N;){const J=t.charCodeAt(i);if(J>=h._0&&J<=h._9)se=se*16+J-h._0;else if(J>=h.A&&J<=h.F)se=se*16+J-h.A+10;else if(J>=h.a&&J<=h.f)se=se*16+J-h.a+10;else break;i++,z++}return z<N&&(se=-1),se}function M(N){i=N,r="",l=0,u=o.Unknown,P=n.None}function T(){const N=i;if(t.charCodeAt(i)===h._0)i++;else for(i++;i<t.length&&a(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===h.dot)if(i++,i<t.length&&a(t.charCodeAt(i)))for(i++;i<t.length&&a(t.charCodeAt(i));)i++;else return P=n.UnexpectedEndOfNumber,t.substring(N,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===h.E||t.charCodeAt(i)===h.e))if(i++,(i<t.length&&t.charCodeAt(i)===h.plus||t.charCodeAt(i)===h.minus)&&i++,i<t.length&&a(t.charCodeAt(i))){for(i++;i<t.length&&a(t.charCodeAt(i));)i++;z=i}else P=n.UnexpectedEndOfNumber;return t.substring(N,z)}function L(){let N="",z=i;for(;;){if(i>=c){N+=t.substring(z,i),P=n.UnexpectedEndOfString;break}const se=t.charCodeAt(i);if(se===h.doubleQuote){N+=t.substring(z,i),i++;break}if(se===h.backslash){if(N+=t.substring(z,i),i++,i>=c){P=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case h.doubleQuote:N+='"';break;case h.backslash:N+="\\";break;case h.slash:N+="/";break;case h.b:N+="\b";break;case h.f:N+="\f";break;case h.n:N+=`
`;break;case h.r:N+="\r";break;case h.t:N+="	";break;case h.u:{const le=S(4);le>=0?N+=String.fromCharCode(le):P=n.InvalidUnicode;break}default:P=n.InvalidEscapeCharacter}z=i;continue}if(se>=0&&se<=31)if(y(se)){N+=t.substring(z,i),P=n.UnexpectedEndOfString;break}else P=n.InvalidCharacter;i++}return N}function A(){if(r="",P=n.None,l=i,i>=c)return l=c,u=o.EOF;let N=t.charCodeAt(i);if(R(N)){do i++,r+=String.fromCharCode(N),N=t.charCodeAt(i);while(R(N));return u=o.Trivia}if(y(N))return i++,r+=String.fromCharCode(N),N===h.carriageReturn&&t.charCodeAt(i)===h.lineFeed&&(i++,r+=`
`),u=o.LineBreakTrivia;switch(N){case h.openBrace:return i++,u=o.OpenBraceToken;case h.closeBrace:return i++,u=o.CloseBraceToken;case h.openBracket:return i++,u=o.OpenBracketToken;case h.closeBracket:return i++,u=o.CloseBracketToken;case h.colon:return i++,u=o.ColonToken;case h.comma:return i++,u=o.CommaToken;case h.doubleQuote:return i++,r=L(),u=o.StringLiteral;case h.slash:{const z=i-1;if(t.charCodeAt(i+1)===h.slash){for(i+=2;i<c&&!y(t.charCodeAt(i));)i++;return r=t.substring(z,i),u=o.LineCommentTrivia}if(t.charCodeAt(i+1)===h.asterisk){i+=2;const se=c-1;let J=!1;for(;i<se;){if(t.charCodeAt(i)===h.asterisk&&t.charCodeAt(i+1)===h.slash){i+=2,J=!0;break}i++}return J||(i++,P=n.UnexpectedEndOfComment),r=t.substring(z,i),u=o.BlockCommentTrivia}return r+=String.fromCharCode(N),i++,u=o.Unknown}case h.minus:if(r+=String.fromCharCode(N),i++,i===c||!a(t.charCodeAt(i)))return u=o.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return r+=T(),u=o.NumericLiteral;default:for(;i<c&&_(N);)i++,N=t.charCodeAt(i);if(l!==i){switch(r=t.substring(l,i),r){case"true":return u=o.TrueKeyword;case"false":return u=o.FalseKeyword;case"null":return u=o.NullKeyword}return u=o.Unknown}return r+=String.fromCharCode(N),i++,u=o.Unknown}}function _(N){if(R(N)||y(N))return!1;switch(N){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function B(){let N;do N=A();while(N>=o.LineCommentTrivia&&N<=o.Trivia);return N}return{setPosition:M,getPosition:()=>i,scan:s?B:A,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>P}}function R(t){return t===h.space||t===h.tab||t===h.verticalTab||t===h.formFeed||t===h.nonBreakingSpace||t===h.ogham||t>=h.enQuad&&t<=h.zeroWidthSpace||t===h.narrowNoBreakSpace||t===h.mathematicalSpace||t===h.ideographicSpace||t===h.byteOrderMark}function y(t){return t===h.lineFeed||t===h.carriageReturn||t===h.lineSeparator||t===h.paragraphSeparator}function a(t){return t>=h._0&&t<=h._9}var h;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(h||(h={}));function f(t,s){const i=[],c=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function P(S,M,T,L){l.value=S,l.offset=M,l.length=T,l.type=L,l.colonOffset=void 0,r=l}try{b(t,{onObjectBegin:(S,M)=>{if(s<=S)throw c;r=void 0,u=s>S,i.push("")},onObjectProperty:(S,M,T)=>{if(s<M||(P(S,M,T,"property"),i[i.length-1]=S,s<=M+T))throw c},onObjectEnd:(S,M)=>{if(s<=S)throw c;r=void 0,i.pop()},onArrayBegin:(S,M)=>{if(s<=S)throw c;r=void 0,i.push(0)},onArrayEnd:(S,M)=>{if(s<=S)throw c;r=void 0,i.pop()},onLiteralValue:(S,M,T)=>{if(s<M||(P(S,M,T,D(S)),s<=M+T))throw c},onSeparator:(S,M,T)=>{if(s<=M)throw c;if(S===":"&&r&&r.type==="property")r.colonOffset=M,u=!1,r=void 0;else if(S===","){const L=i[i.length-1];typeof L=="number"?i[i.length-1]=L+1:(u=!0,i[i.length-1]=""),r=void 0}}})}catch(S){if(S!==c)throw S}return{path:i,previousNode:r,isAtPropertyKey:u,matches:S=>{let M=0;for(let T=0;M<S.length&&T<i.length;T++)if(S[M]===i[T]||S[M]==="*")M++;else if(S[M]!=="**")return!1;return M===S.length}}}function g(t,s=[],i=k.DEFAULT){let c=null,r=[];const l=[];function u(S){Array.isArray(r)?r.push(S):c!==null&&(r[c]=S)}return b(t,{onObjectBegin:()=>{const S={};u(S),l.push(r),r=S,c=null},onObjectProperty:S=>{c=S},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const S=[];u(S),l.push(r),r=S,c=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:u,onError:(S,M,T)=>{s.push({error:S,offset:M,length:T})}},i),r[0]}function w(t,s=[],i=k.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){c.type==="property"&&(c.length=S-c.offset,c=c.parent)}function l(S){return c.children.push(S),S}b(t,{onObjectBegin:S=>{c=l({type:"object",offset:S,length:-1,parent:c,children:[]})},onObjectProperty:(S,M,T)=>{c=l({type:"property",offset:M,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:S,offset:M,length:T,parent:c})},onObjectEnd:(S,M)=>{c.length=S+M-c.offset,c=c.parent,r(S+M)},onArrayBegin:(S,M)=>{c=l({type:"array",offset:S,length:-1,parent:c,children:[]})},onArrayEnd:(S,M)=>{c.length=S+M-c.offset,c=c.parent,r(S+M)},onLiteralValue:(S,M,T)=>{l({type:D(S),offset:M,length:T,parent:c,value:S}),r(M+T)},onSeparator:(S,M,T)=>{c.type==="property"&&(S===":"?c.colonOffset=M:S===","&&r(M))},onError:(S,M,T)=>{s.push({error:S,offset:M,length:T})}},i);const P=c.children[0];return P&&delete P.parent,P}function d(t,s){if(!t)return;let i=t;for(const c of s)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===c){i=l.children[1],r=!0;break}if(!r)return}else{const r=c;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const s=Object.create(null);for(const i of t.children){const c=i.children[1];c&&(s[i.children[0].value]=E(c))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}function m(t,s,i=!1){if(p(t,s,i)){const c=t.children;if(Array.isArray(c))for(let r=0;r<c.length&&c[r].offset<=s;r++){const l=m(c[r],s,i);if(l)return l}return t}}function b(t,s,i=k.DEFAULT){const c=C(t,!1);function r(j){return j?()=>j(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(j){return j?ce=>j(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const u=r(s.onObjectBegin),P=l(s.onObjectProperty),S=r(s.onObjectEnd),M=r(s.onArrayBegin),T=r(s.onArrayEnd),L=l(s.onLiteralValue),A=l(s.onSeparator),_=r(s.onComment),B=l(s.onError),N=i&&i.disallowComments,z=i&&i.allowTrailingComma;function se(){for(;;){const j=c.scan();switch(c.getTokenError()){case n.InvalidUnicode:J(I.InvalidUnicode);break;case n.InvalidEscapeCharacter:J(I.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:J(I.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:N||J(I.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:J(I.UnexpectedEndOfString);break;case n.InvalidCharacter:J(I.InvalidCharacter);break}switch(j){case o.LineCommentTrivia:case o.BlockCommentTrivia:N?J(I.InvalidCommentToken):_();break;case o.Unknown:J(I.InvalidSymbol);break;case o.Trivia:case o.LineBreakTrivia:break;default:return j}}}function J(j,ce=[],G=[]){if(B(j),ce.length+G.length>0){let de=c.getToken();for(;de!==o.EOF;){if(ce.indexOf(de)!==-1){se();break}else if(G.indexOf(de)!==-1)break;de=se()}}}function le(j){const ce=c.getTokenValue();return j?L(ce):P(ce),se(),!0}function K(){switch(c.getToken()){case o.NumericLiteral:{let j=0;try{j=JSON.parse(c.getTokenValue()),typeof j!="number"&&(J(I.InvalidNumberFormat),j=0)}catch{J(I.InvalidNumberFormat)}L(j);break}case o.NullKeyword:L(null);break;case o.TrueKeyword:L(!0);break;case o.FalseKeyword:L(!1);break;default:return!1}return se(),!0}function ee(){return c.getToken()!==o.StringLiteral?(J(I.PropertyNameExpected,[],[o.CloseBraceToken,o.CommaToken]),!1):(le(!1),c.getToken()===o.ColonToken?(A(":"),se(),x()||J(I.ValueExpected,[],[o.CloseBraceToken,o.CommaToken])):J(I.ColonExpected,[],[o.CloseBraceToken,o.CommaToken]),!0)}function q(){u(),se();let j=!1;for(;c.getToken()!==o.CloseBraceToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(j||J(I.ValueExpected,[],[]),A(","),se(),c.getToken()===o.CloseBraceToken&&z)break}else j&&J(I.CommaExpected,[],[]);ee()||J(I.ValueExpected,[],[o.CloseBraceToken,o.CommaToken]),j=!0}return S(),c.getToken()!==o.CloseBraceToken?J(I.CloseBraceExpected,[o.CloseBraceToken],[]):se(),!0}function O(){M(),se();let j=!1;for(;c.getToken()!==o.CloseBracketToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(j||J(I.ValueExpected,[],[]),A(","),se(),c.getToken()===o.CloseBracketToken&&z)break}else j&&J(I.CommaExpected,[],[]);x()||J(I.ValueExpected,[],[o.CloseBracketToken,o.CommaToken]),j=!0}return T(),c.getToken()!==o.CloseBracketToken?J(I.CloseBracketExpected,[o.CloseBracketToken],[]):se(),!0}function x(){switch(c.getToken()){case o.OpenBracketToken:return O();case o.OpenBraceToken:return q();case o.StringLiteral:return le(!0);default:return K()}}return se(),c.getToken()===o.EOF?i.allowEmptyContent?!0:(J(I.ValueExpected,[],[]),!1):x()?(c.getToken()!==o.EOF&&J(I.EndOfFileExpected,[],[]),!0):(J(I.ValueExpected,[],[]),!1)}function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[142],ae([0,1,43]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=o,e.toFormattedString=I,e.getEOL=R,e.isEOL=y;function o(a,h,f){let g,w,d,v,E;if(h){for(v=h.offset,E=v+h.length,d=v;d>0&&!y(a,d-1);)d--;let P=E;for(;P<a.length&&!y(a,P);)P++;w=a.substring(d,P),g=C(w,f)}else w=a,g=0,d=0,v=0,E=a.length;const p=R(f,a);let m=!1,b=0,D;f.insertSpaces?D=k(" ",f.tabSize||4):D="	";const t=(0,n.createScanner)(w,!1);let s=!1;function i(){return p+k(D,g+b)}function c(){let P=t.scan();for(m=!1;P===n.SyntaxKind.Trivia||P===n.SyntaxKind.LineBreakTrivia;)m=m||P===n.SyntaxKind.LineBreakTrivia,P=t.scan();return s=P===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,P}const r=[];function l(P,S,M){!s&&S<E&&M>v&&a.substring(S,M)!==P&&r.push({offset:S,length:M-S,content:P})}let u=c();if(u!==n.SyntaxKind.EOF){const P=t.getTokenOffset()+d,S=k(D,g);l(S,d,P)}for(;u!==n.SyntaxKind.EOF;){let P=t.getTokenOffset()+t.getTokenLength()+d,S=c(),M="";for(;!m&&(S===n.SyntaxKind.LineCommentTrivia||S===n.SyntaxKind.BlockCommentTrivia);){const L=t.getTokenOffset()+d;l(" ",P,L),P=t.getTokenOffset()+t.getTokenLength()+d,M=S===n.SyntaxKind.LineCommentTrivia?i():"",S=c()}if(S===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(b--,M=i());else if(S===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(b--,M=i());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:b++,M=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:M=i();break;case n.SyntaxKind.BlockCommentTrivia:m?M=i():M=" ";break;case n.SyntaxKind.ColonToken:M=" ";break;case n.SyntaxKind.StringLiteral:if(S===n.SyntaxKind.ColonToken){M="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:S===n.SyntaxKind.LineCommentTrivia||S===n.SyntaxKind.BlockCommentTrivia?M=" ":S!==n.SyntaxKind.CommaToken&&S!==n.SyntaxKind.EOF&&(s=!0);break;case n.SyntaxKind.Unknown:s=!0;break}m&&(S===n.SyntaxKind.LineCommentTrivia||S===n.SyntaxKind.BlockCommentTrivia)&&(M=i())}const T=t.getTokenOffset()+d;l(M,P,T),u=S}return r}function I(a,h){const f=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?f.replace(/\r\n|\r|\n/g,h.eol):f}function k(a,h){let f="";for(let g=0;g<h;g++)f+=a;return f}function C(a,h){let f=0,g=0;const w=h.tabSize||4;for(;f<a.length;){const d=a.charAt(f);if(d===" ")g++;else if(d==="	")g+=w;else break;f++}return Math.floor(g/w)}function R(a,h){for(let f=0;f<h.length;f++){const g=h.charAt(f);if(g==="\r")return f+1<h.length&&h.charAt(f+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return a&&a.eol||`
`}function y(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(oe[108],ae([0,1,43,142]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=I,e.setProperty=k,e.withFormatting=C,e.applyEdit=R,e.applyEdits=y;function I(a,h,f){return k(a,h,void 0,f)}function k(a,h,f,g,w){const d=h.slice(),v=[],E=(0,n.parseTree)(a,v);let p,m;for(;d.length>0&&(m=d.pop(),p=(0,n.findNodeAtLocation)(E,d),p===void 0&&f!==void 0);)typeof m=="string"?f={[m]:f}:f=[f];if(p)if(p.type==="object"&&typeof m=="string"&&Array.isArray(p.children)){const b=(0,n.findNodeAtLocation)(p,[m]);if(b!==void 0)if(f===void 0){if(!b.parent)throw new Error("Malformed AST");const D=p.children.indexOf(b.parent);let t,s=b.parent.offset+b.parent.length;if(D>0){const i=p.children[D-1];t=i.offset+i.length}else t=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return C(a,{offset:t,length:s-t,content:""},g)}else return C(a,{offset:b.offset,length:b.length,content:JSON.stringify(f)},g);else{if(f===void 0)return[];const D=`${JSON.stringify(m)}: ${JSON.stringify(f)}`,t=w?w(p.children.map(i=>i.children[0].value)):p.children.length;let s;if(t>0){const i=p.children[t-1];s={offset:i.offset+i.length,length:0,content:","+D}}else p.children.length===0?s={offset:p.offset+1,length:0,content:D}:s={offset:p.offset+1,length:0,content:D+","};return C(a,s,g)}}else if(p.type==="array"&&typeof m=="number"&&Array.isArray(p.children))if(f!==void 0){const b=`${JSON.stringify(f)}`;let D;if(p.children.length===0||m===0)D={offset:p.offset+1,length:0,content:p.children.length===0?b:b+","};else{const t=m===-1||m>p.children.length?p.children.length:m,s=p.children[t-1];D={offset:s.offset+s.length,length:0,content:","+b}}return C(a,D,g)}else{const b=m,D=p.children[b];let t;if(p.children.length===1)t={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===b){const s=p.children[b-1],i=s.offset+s.length,c=p.offset+p.length;t={offset:i,length:c-2-i,content:""}}else t={offset:D.offset,length:p.children[b+1].offset-D.offset,content:""};return C(a,t,g)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${p.type}`);else return f===void 0?[]:C(a,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(f)},g)}function C(a,h,f){let g=R(a,h),w=h.offset,d=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;w>0&&!(0,o.isEOL)(g,w-1);)w--;for(;d<g.length&&!(0,o.isEOL)(g,d);)d++}const v=(0,o.format)(g,{offset:w,length:d-w},f);for(let p=v.length-1;p>=0;p--){const m=v[p];g=R(g,m),w=Math.min(w,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const E=a.length-(g.length-d)-w;return[{offset:w,length:E,content:g.substring(w,d)}]}function R(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function y(a,h){const f=h.slice(0).sort((w,d)=>{const v=w.offset-d.offset;return v===0?w.length-d.length:v});let g=a.length;for(let w=f.length-1;w>=0;w--){const d=f[w];if(d.offset+d.length<=g)a=R(a,d);else throw new Error("Overlapping edit");g=d.offset}return a}}),function(){function V(e,n,o,I){const k=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function C(y){return y.replace(k,function(a,h,f,g,w,d){if(g)return"";if(w){const v=w.length;return w[v-1]===`
`?w[v-2]==="\r"?`\r
`:`
`:""}else return d?a.substring(1):a})}function R(y){const a=C(y);try{return JSON.parse(a)}catch{const f=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(f)}}return{stripComments:C,parse:R}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[66],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class n{constructor(I){this.executor=I,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=n}),define(oe[109],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(k){this.element=k,this.next=n.Undefined,this.prev=n.Undefined}}class o{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let k=this._first;for(;k!==n.Undefined;){const C=k.next;k.prev=n.Undefined,k.next=n.Undefined,k=C}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,C){const R=new n(k);if(this._first===n.Undefined)this._first=R,this._last=R;else if(C){const a=this._last;this._last=R,R.prev=a,a.next=R}else{const a=this._first;this._first=R,R.next=a,a.prev=R}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(R))}}shift(){if(this._first!==n.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==n.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==n.Undefined&&k.next!==n.Undefined){const C=k.prev;C.next=k.next,k.next.prev=C}else k.prev===n.Undefined&&k.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):k.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):k.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==n.Undefined;)yield k.element,k=k.next}}e.LinkedList=o}),define(oe[32],ae([0,1]),function(V,e){"use strict";var n,o,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=k,e.mapToString=C,e.setToString=R,e.mapsStrictEqualIgnoreOrder=D;function k(t,s,i){let c=t.get(s);return c===void 0&&(c=i,t.set(s,c)),c}function C(t){const s=[];return t.forEach((i,c)=>{s.push(`${c} => ${i}`)}),`Map(${t.size}) {${s.join(", ")}}`}function R(t){const s=[];return t.forEach(i=>{s.push(i)}),`Set(${t.size}) {${s.join(", ")}}`}class y{constructor(s,i){this.uri=s,this.value=i}}function a(t){return Array.isArray(t)}class h{static{this.defaultToKey=s=>s.toString()}constructor(s,i){if(this[n]="ResourceMap",s instanceof h)this.map=new Map(s.map),this.toKey=i??h.defaultToKey;else if(a(s)){this.map=new Map,this.toKey=i??h.defaultToKey;for(const[c,r]of s)this.set(c,r)}else this.map=new Map,this.toKey=s??h.defaultToKey}set(s,i){return this.map.set(this.toKey(s),new y(s,i)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,i){typeof i<"u"&&(s=s.bind(i));for(const[c,r]of this.map)s(r.value,r.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=h;class f{constructor(s,i){this[o]="ResourceSet",!s||typeof s=="function"?this._map=new h(s):(this._map=new h(i),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,i){this._map.forEach((c,r)=>s.call(i,r,r,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class w{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,i=g.None){const c=this._map.get(s);if(c)return i!==g.None&&this.touch(c,i),c.value}set(s,i,c=g.None){let r=this._map.get(s);if(r)r.value=i,c!==g.None&&this.touch(r,c);else{switch(r={key:s,value:i,next:void 0,previous:void 0},c){case g.None:this.addItemLast(r);break;case g.AsOld:this.addItemFirst(r);break;case g.AsNew:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(s,r),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this._map.get(s);if(i)return this._map.delete(s),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,i){const c=this._state;let r=this._head;for(;r;){if(i?s.bind(i)(r.value,r.key,this):s(r.value,r.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const s=this,i=this._state;let c=this._head;const r={[Symbol.iterator](){return r},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.key,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return r}values(){const s=this,i=this._state;let c=this._head;const r={[Symbol.iterator](){return r},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.value,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return r}entries(){const s=this,i=this._state;let c=this._head;const r={[Symbol.iterator](){return r},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:[c.key,c.value],done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return r}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._head,c=this.size;for(;i&&c>s;)this._map.delete(i.key),i=i.next,c--;this._head=i,this._size=c,i&&(i.previous=void 0),this._state++}trimNew(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._tail,c=this.size;for(;i&&c>s;)this._map.delete(i.key),i=i.previous,c--;this._tail=i,this._size=c,i&&(i.next=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const i=s.next,c=s.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}s.next=void 0,s.previous=void 0,this._state++}touch(s,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==g.AsOld&&i!==g.AsNew)){if(i===g.AsOld){if(s===this._head)return;const c=s.next,r=s.previous;s===this._tail?(r.next=void 0,this._tail=r):(c.previous=r,r.next=c),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(i===g.AsNew){if(s===this._tail)return;const c=s.next,r=s.previous;s===this._head?(c.previous=void 0,this._head=c):(c.previous=r,r.next=c),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((i,c)=>{s.push([c,i])}),s}fromJSON(s){this.clear();for(const[i,c]of s)this.set(i,c)}}e.LinkedMap=w;class d extends w{constructor(s,i=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,i=g.AsNew){return super.get(s,i)}peek(s){return super.get(s,g.None)}set(s,i){return super.set(s,i,g.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class v extends d{constructor(s,i=1){super(s,i)}trim(s){this.trimOld(s)}set(s,i){return super.set(s,i),this.checkTrim(),this}}e.LRUCache=v;class E extends d{constructor(s,i=1){super(s,i)}trim(s){this.trimNew(s)}set(s,i){return this._limit<=this.size&&!this.has(s)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(s,i),this}}e.MRUCache=E;class p{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let i=this.map.get(s)||0;return i===0?!1:(i--,i===0?this.map.delete(s):this.map.set(s,i),!0)}has(s){return this.map.has(s)}}e.CounterSet=p;class m{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[i,c]of s)this.set(i,c)}clear(){this._m1.clear(),this._m2.clear()}set(s,i){this._m1.set(s,i),this._m2.set(i,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const i=this._m1.get(s);return i===void 0?!1:(this._m1.delete(s),this._m2.delete(i),!0)}forEach(s,i){this._m1.forEach((c,r)=>{s.call(i,c,r,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class b{constructor(){this.map=new Map}add(s,i){let c=this.map.get(s);c||(c=new Set,this.map.set(s,c)),c.add(i)}delete(s,i){const c=this.map.get(s);c&&(c.delete(i),c.size===0&&this.map.delete(s))}forEach(s,i){const c=this.map.get(s);c&&c.forEach(i)}get(s){const i=this.map.get(s);return i||new Set}}e.SetMap=b;function D(t,s){if(t===s)return!0;if(t.size!==s.size)return!1;for(const[i,c]of t)if(!s.has(i)||s.get(i)!==c)return!1;for(const[i]of s)if(!t.has(i))return!1;return!0}}),define(oe[2],ae([0,1,22,139,32,90,78]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=h,e.trackDisposable=f,e.markAsDisposed=g,e.markAsSingleton=v,e.isDisposable=E,e.dispose=p,e.disposeIfDisposable=m,e.combinedDisposable=b,e.toDisposable=D,e.disposeOnReturn=M;const R=!1;let y=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(A){let _=this.livingDisposables.get(A);return _||(_={parent:null,source:null,isSingleton:!1,value:A,idx:a.idx++},this.livingDisposables.set(A,_)),_}trackDisposable(A){const _=this.getDisposableData(A);_.source||(_.source=new Error().stack)}setParent(A,_){const B=this.getDisposableData(A);B.parent=_}markAsDisposed(A){this.livingDisposables.delete(A)}markAsSingleton(A){this.getDisposableData(A).isSingleton=!0}getRootParent(A,_){const B=_.get(A);if(B)return B;const N=A.parent?this.getRootParent(this.getDisposableData(A.parent),_):A;return _.set(A,N),N}getTrackedDisposables(){const A=new Map;return[...this.livingDisposables.entries()].filter(([,B])=>B.source!==null&&!this.getRootParent(B,A).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(A=10,_){let B;if(_)B=_;else{const le=new Map,K=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,le).isSingleton);if(K.length===0)return;const ee=new Set(K.map(q=>q.value));if(B=K.filter(q=>!(q.parent&&ee.has(q.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function N(le){function K(q,O){for(;q.length>0&&O.some(x=>typeof x=="string"?x===q[0]:q[0].match(x));)q.shift()}const ee=le.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const z=new I.SetMap;for(const le of B){const K=N(le);for(let ee=0;ee<=K.length;ee++)z.add(K.slice(0,ee).join(`
`),le)}B.sort((0,n.compareBy)(le=>le.idx,n.numberComparator));let se="",J=0;for(const le of B.slice(0,A)){J++;const K=N(le),ee=[];for(let q=0;q<K.length;q++){let O=K[q];O=`(shared with ${z.get(K.slice(0,q+1).join(`
`)).size}/${B.length} leaks) at ${O}`;const j=z.get(K.slice(0,q).join(`
`)),ce=(0,o.groupBy)([...j].map(G=>N(G)[q]),G=>G);delete ce[K[q]];for(const[G,de]of Object.entries(ce))ee.unshift(`    - stacktraces of ${de.length} other leaks continue with ${G}`);ee.unshift(O)}se+=`


==================== Leaking disposable ${J}/${B.length}: ${le.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return B.length>A&&(se+=`


... and ${B.length-A} more leaking disposables

`),{leaks:B,details:se}}}e.DisposableTracker=a;function h(L){y=L}if(R){const L="__is_disposable_tracked__";h(new class{trackDisposable(A){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[L]||console.log(_)},3e3)}setParent(A,_){if(A&&A!==s.None)try{A[L]=!0}catch{}}markAsDisposed(A){if(A&&A!==s.None)try{A[L]=!0}catch{}}markAsSingleton(A){}})}function f(L){return y?.trackDisposable(L),L}function g(L){y?.markAsDisposed(L)}function w(L,A){y?.setParent(L,A)}function d(L,A){if(y)for(const _ of L)y.setParent(_,A)}function v(L){return y?.markAsSingleton(L),L}function E(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function p(L){if(C.Iterable.is(L)){const A=[];for(const _ of L)if(_)try{_.dispose()}catch(B){A.push(B)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function m(L){for(const A of L)E(A)&&A.dispose();return[]}function b(...L){const A=D(()=>p(L));return d(L,A),A}function D(L){const A=f({dispose:(0,k.createSingleCallFunction)(()=>{g(A),L()})});return A}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,f(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return w(A,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(A),A.dispose()}}deleteAndLeak(A){A&&this._toDispose.has(A)&&(this._toDispose.delete(A),w(A,null))}}e.DisposableStore=t;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,f(this),w(this._store,this)}dispose(){g(this),this._store.dispose()}_register(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(A)}}e.Disposable=s;class i{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(A){this._isDisposed||A===this._value||(this._value?.dispose(),A&&w(A,this),this._value=A)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const A=this._value;return this._value=void 0,A&&w(A,null),A}}e.MutableDisposable=i;class c{constructor(A){this._disposable=new i,this._isDisposed=!1,this._disposable.value=A}get value(){return this._disposable.value}set value(A){this._isDisposed||A===this._disposable.value||(this._disposable.value=A)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=c;class r{constructor(A){this._disposable=A,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(A){let _=A;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,g(this))},this}}e.SafeDisposable=l;class u{constructor(){this.references=new Map}acquire(A,..._){let B=this.references.get(A);B||(B={counter:0,object:this.createReferencedObject(A,..._)},this.references.set(A,B));const{object:N}=B,z=(0,k.createSingleCallFunction)(()=>{--B.counter===0&&(this.destroyReferencedObject(A,B.object),this.references.delete(A))});return B.counter++,{object:N,dispose:z}}}e.ReferenceCollection=u;class P{constructor(A){this.referenceCollection=A}async acquire(A,..._){const B=this.referenceCollection.acquire(A,..._);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(N){throw B.dispose(),N}}}e.AsyncReferenceCollection=P;class S{constructor(A){this.object=A}dispose(){}}e.ImmortalReference=S;function M(L){const A=new t;try{L(A)}finally{A.dispose()}}class T{constructor(){this._store=new Map,this._isDisposed=!1,f(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(A){return this._store.has(A)}get size(){return this._store.size}get(A){return this._store.get(A)}set(A,_,B=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this._store.get(A)?.dispose(),this._store.set(A,_)}deleteAndDispose(A){this._store.get(A)?.dispose(),this._store.delete(A)}deleteAndLeak(A){const _=this._store.get(A);return this._store.delete(A),_}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=T}),define(oe[91],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(o){o[o.Uri=1]="Uri",o[o.Regexp=2]="Regexp",o[o.ScmResource=3]="ScmResource",o[o.ScmResourceGroup=4]="ScmResourceGroup",o[o.ScmProvider=5]="ScmProvider",o[o.CommentController=6]="CommentController",o[o.CommentThread=7]="CommentThread",o[o.CommentThreadInstance=8]="CommentThreadInstance",o[o.CommentThreadReply=9]="CommentThreadReply",o[o.CommentNode=10]="CommentNode",o[o.CommentThreadNode=11]="CommentThreadNode",o[o.TimelineActionContext=12]="TimelineActionContext",o[o.NotebookCellActionContext=13]="NotebookCellActionContext",o[o.NotebookActionContext=14]="NotebookActionContext",o[o.TerminalContext=15]="TerminalContext",o[o.TestItemContext=16]="TestItemContext",o[o.Date=17]="Date",o[o.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(oe[79],ae([0,1,32]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=I,e.normalizeNFD=C;const o=new n.LRUCache(1e4);function I(a){return y(a,"NFC",o)}const k=new n.LRUCache(1e4);function C(a){return y(a,"NFD",k)}const R=/[^\u0000-\u0080]/;function y(a,h,f){if(!a)return a;const g=f.get(a);if(g)return g;let w;return R.test(a)?w=a.normalize(h):w=a,f.set(a,w),w}e.removeAccents=function(){const a=/[\u0300-\u036f]/g;return function(h){return C(h).replace(a,"")}}()}),define(oe[143],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=n,e.rot=o,e.isPointWithinTriangle=R;function n(y,a,h){return Math.min(Math.max(y,a),h)}function o(y,a){return(a+y%a)%a}class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class k{constructor(){this._n=1,this._val=0}update(a){return this._val=this._val+(a-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=k;class C{constructor(a){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(a),this._values.fill(0,0,a)}update(a){const h=this._values[this._index];return this._values[this._index]=a,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=a,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C;function R(y,a,h,f,g,w,d,v){const E=d-h,p=v-f,m=g-h,b=w-f,D=y-h,t=a-f,s=E*E+p*p,i=E*m+p*b,c=E*D+p*t,r=m*m+b*b,l=m*D+b*t,u=1/(s*r-i*i),P=(r*c-i*l)*u,S=(s*l-i*c)*u;return P>=0&&S>=0&&P+S<1}}),function(){function V(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function C(y){k.push(y,Date.now())}function R(){const y=[];for(let a=0;a<k.length;a+=2)y.push({name:k[a],startTime:k[a+1]});return y}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))k.push({name:C.name,startTime:Math.round(I+C.startTime)});return k}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function n(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var o;typeof global=="object"?o=global:typeof self=="object"?o=self:o={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(o)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(o):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),o.perf=n(o))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var o in n)(typeof exports=="object"?exports:V)[o]=n[o]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function n(o){if(e[o])return e[o].exports;var I=e[o]={i:o,l:!1,exports:{}};return V[o].call(I.exports,I,I.exports,n),I.l=!0,I.exports}return n.m=V,n.c=e,n.d=function(o,I,k){n.o(o,I)||Object.defineProperty(o,I,{enumerable:!0,get:k})},n.r=function(o){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(o,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(o,"__esModule",{value:!0})},n.t=function(o,I){if(1&I&&(o=n(o)),8&I||4&I&&typeof o=="object"&&o&&o.__esModule)return o;var k=Object.create(null);if(n.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:o}),2&I&&typeof o!="string")for(var C in o)n.d(k,C,function(R){return o[R]}.bind(null,C));return k},n.n=function(o){var I=o&&o.__esModule?function(){return o.default}:function(){return o};return n.d(I,"a",I),I},n.o=function(o,I){return Object.prototype.hasOwnProperty.call(o,I)},n.p="",n(n.s=0)}([function(V,e,n){(function(o){var I;e=V.exports=de,I=typeof o=="object"&&o.env&&o.env.NODE_DEBUG&&/\bsemver\b/i.test(o.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],a=0,h=a++;y[h]="0|[1-9]\\d*";var f=a++;y[f]="[0-9]+";var g=a++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;y[w]="("+y[h]+")\\.("+y[h]+")\\.("+y[h]+")";var d=a++;y[d]="("+y[f]+")\\.("+y[f]+")\\.("+y[f]+")";var v=a++;y[v]="(?:"+y[h]+"|"+y[g]+")";var E=a++;y[E]="(?:"+y[f]+"|"+y[g]+")";var p=a++;y[p]="(?:-("+y[v]+"(?:\\."+y[v]+")*))";var m=a++;y[m]="(?:-?("+y[E]+"(?:\\."+y[E]+")*))";var b=a++;y[b]="[0-9A-Za-z-]+";var D=a++;y[D]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var t=a++,s="v?"+y[w]+y[p]+"?"+y[D]+"?";y[t]="^"+s+"$";var i="[v=\\s]*"+y[d]+y[m]+"?"+y[D]+"?",c=a++;y[c]="^"+i+"$";var r=a++;y[r]="((?:<|>)?=?)";var l=a++;y[l]=y[f]+"|x|X|\\*";var u=a++;y[u]=y[h]+"|x|X|\\*";var P=a++;y[P]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[p]+")?"+y[D]+"?)?)?";var S=a++;y[S]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[m]+")?"+y[D]+"?)?)?";var M=a++;y[M]="^"+y[r]+"\\s*"+y[P]+"$";var T=a++;y[T]="^"+y[r]+"\\s*"+y[S]+"$";var L=a++;y[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=a++;y[A]="(?:~>?)";var _=a++;y[_]="(\\s*)"+y[A]+"\\s+",R[_]=new RegExp(y[_],"g");var B=a++;y[B]="^"+y[A]+y[P]+"$";var N=a++;y[N]="^"+y[A]+y[S]+"$";var z=a++;y[z]="(?:\\^)";var se=a++;y[se]="(\\s*)"+y[z]+"\\s+",R[se]=new RegExp(y[se],"g");var J=a++;y[J]="^"+y[z]+y[P]+"$";var le=a++;y[le]="^"+y[z]+y[S]+"$";var K=a++;y[K]="^"+y[r]+"\\s*("+i+")$|^$";var ee=a++;y[ee]="^"+y[r]+"\\s*("+s+")$|^$";var q=a++;y[q]="(\\s*)"+y[r]+"\\s*("+i+"|"+y[P]+")",R[q]=new RegExp(y[q],"g");var O=a++;y[O]="^\\s*("+y[P]+")\\s+-\\s+("+y[P]+")\\s*$";var x=a++;y[x]="^\\s*("+y[S]+")\\s+-\\s+("+y[S]+")\\s*$";var j=a++;y[j]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)I(ce,y[ce]),R[ce]||(R[ce]=new RegExp(y[ce]));function G(X,ue){if(X instanceof de)return X;if(typeof X!="string"||X.length>k||!(ue?R[c]:R[t]).test(X))return null;try{return new de(X,ue)}catch{return null}}function de(X,ue){if(X instanceof de){if(X.loose===ue)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof de))return new de(X,ue);I("SemVer",X,ue),this.loose=ue;var he=X.trim().match(ue?R[c]:R[t]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Me=+Se;if(Me>=0&&Me<C)return Me}return Se}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=G,e.valid=function(X,ue){var he=G(X,ue);return he?he.version:null},e.clean=function(X,ue){var he=G(X.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(X){return I("SemVer.compare",this.version,this.loose,X),X instanceof de||(X=new de(X,this.loose)),this.compareMain(X)||this.comparePre(X)},de.prototype.compareMain=function(X){return X instanceof de||(X=new de(X,this.loose)),Z(this.major,X.major)||Z(this.minor,X.minor)||Z(this.patch,X.patch)},de.prototype.comparePre=function(X){if(X instanceof de||(X=new de(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],Se=X.prerelease[ue];if(I("prerelease compare",ue,he,Se),he===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(he===void 0)return-1;if(he!==Se)return Z(he,Se)}while(++ue)},de.prototype.inc=function(X,ue){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ue,he,Se){typeof he=="string"&&(Se=he,he=void 0);try{return new de(X,he).inc(ue,Se).version}catch{return null}},e.diff=function(X,ue){if(H(X,ue))return null;var he=G(X),Se=G(ue);if(he.prerelease.length||Se.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Se[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Se[Me])return Me},e.compareIdentifiers=Z;var re=/^[0-9]+$/;function Z(X,ue){var he=re.test(X),Se=re.test(ue);return he&&Se&&(X=+X,ue=+ue),he&&!Se?-1:Se&&!he?1:X<ue?-1:X>ue?1:0}function W(X,ue,he){return new de(X,he).compare(new de(ue,he))}function F(X,ue,he){return W(X,ue,he)>0}function U(X,ue,he){return W(X,ue,he)<0}function H(X,ue,he){return W(X,ue,he)===0}function Y(X,ue,he){return W(X,ue,he)!==0}function Q(X,ue,he){return W(X,ue,he)>=0}function $(X,ue,he){return W(X,ue,he)<=0}function ie(X,ue,he,Se){var Me;switch(ue){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Me=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Me=X!==he;break;case"":case"=":case"==":Me=H(X,he,Se);break;case"!=":Me=Y(X,he,Se);break;case">":Me=F(X,he,Se);break;case">=":Me=Q(X,he,Se);break;case"<":Me=U(X,he,Se);break;case"<=":Me=$(X,he,Se);break;default:throw new TypeError("Invalid operator: "+ue)}return Me}function fe(X,ue){if(X instanceof fe){if(X.loose===ue)return X;X=X.value}if(!(this instanceof fe))return new fe(X,ue);I("comparator",X,ue),this.loose=ue,this.parse(X),this.semver===me?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(X,ue){return Z(ue,X)},e.major=function(X,ue){return new de(X,ue).major},e.minor=function(X,ue){return new de(X,ue).minor},e.patch=function(X,ue){return new de(X,ue).patch},e.compare=W,e.compareLoose=function(X,ue){return W(X,ue,!0)},e.rcompare=function(X,ue,he){return W(ue,X,he)},e.sort=function(X,ue){return X.sort(function(he,Se){return e.compare(he,Se,ue)})},e.rsort=function(X,ue){return X.sort(function(he,Se){return e.rcompare(he,Se,ue)})},e.gt=F,e.lt=U,e.eq=H,e.neq=Y,e.gte=Q,e.lte=$,e.cmp=ie,e.Comparator=fe;var me={};function we(X,ue){if(X instanceof we)return X.loose===ue?X:new we(X.raw,ue);if(X instanceof fe)return new we(X.value,ue);if(!(this instanceof we))return new we(X,ue);if(this.loose=ue,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ce(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ie(X,ue,he,Se,Me,Ue,We,Le,xe,je,Xe,He,Ke){return((ue=Ce(he)?"":Ce(Se)?">="+he+".0.0":Ce(Me)?">="+he+"."+Se+".0":">="+ue)+" "+(Le=Ce(xe)?"":Ce(je)?"<"+(+xe+1)+".0.0":Ce(Xe)?"<"+xe+"."+(+je+1)+".0":He?"<="+xe+"."+je+"."+Xe+"-"+He:"<="+Le)).trim()}function De(X,ue){for(var he=0;he<X.length;he++)if(!X[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<X.length;he++)if(I(X[he].semver),X[he].semver!==me&&X[he].semver.prerelease.length>0){var Se=X[he].semver;if(Se.major===ue.major&&Se.minor===ue.minor&&Se.patch===ue.patch)return!0}return!1}return!0}function Re(X,ue,he){try{ue=new we(ue,he)}catch{return!1}return ue.test(X)}function pe(X,ue,he,Se){var Me,Ue,We,Le,xe;switch(X=new de(X,Se),ue=new we(ue,Se),he){case">":Me=F,Ue=$,We=U,Le=">",xe=">=";break;case"<":Me=U,Ue=Q,We=F,Le="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(X,ue,Se))return!1;for(var je=0;je<ue.set.length;++je){var Xe=ue.set[je],He=null,Ke=null;if(Xe.forEach(function(Qe){Qe.semver===me&&(Qe=new fe(">=0.0.0")),He=He||Qe,Ke=Ke||Qe,Me(Qe.semver,He.semver,Se)?He=Qe:We(Qe.semver,Ke.semver,Se)&&(Ke=Qe)}),He.operator===Le||He.operator===xe||(!Ke.operator||Ke.operator===Le)&&Ue(X,Ke.semver)||Ke.operator===xe&&We(X,Ke.semver))return!1}return!0}fe.prototype.parse=function(X){var ue=this.loose?R[K]:R[ee],he=X.match(ue);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new de(he[2],this.loose):this.semver=me},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(X){return I("Comparator.test",X,this.loose),this.semver===me||(typeof X=="string"&&(X=new de(X,this.loose)),ie(X,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(X,ue){if(!(X instanceof fe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new we(X.value,ue),Re(this.value,he,ue);if(X.operator==="")return he=new we(this.value,ue),Re(X.semver,he,ue);var Se=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ue=this.semver.version===X.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Le=ie(this.semver,"<",X.semver,ue)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),xe=ie(this.semver,">",X.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Se||Me||Ue&&We||Le||xe},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(X){var ue=this.loose;X=X.trim(),I("range",X,ue);var he=ue?R[x]:R[O];X=X.replace(he,Ie),I("hyphen replace",X),X=X.replace(R[q],"$1$2$3"),I("comparator trim",X,R[q]),X=(X=(X=X.replace(R[_],"$1~")).replace(R[se],"$1^")).split(/\s+/).join(" ");var Se=ue?R[K]:R[ee],Me=X.split(" ").map(function(Ue){return function(We,Le){return I("comp",We),We=function(xe,je){return xe.trim().split(/\s+/).map(function(Xe){return function(He,Ke){I("caret",He,Ke);var Qe=Ke?R[le]:R[J];return He.replace(Qe,function(Ze,Fe,te,ge,ve){var ye;return I("caret",He,Ze,Fe,te,ge,ve),Ce(Fe)?ye="":Ce(te)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ce(ge)?ye=Fe==="0"?">="+Fe+"."+te+".0 <"+Fe+"."+(+te+1)+".0":">="+Fe+"."+te+".0 <"+(+Fe+1)+".0.0":ve?(I("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=Fe==="0"?te==="0"?">="+Fe+"."+te+"."+ge+ve+" <"+Fe+"."+te+"."+(+ge+1):">="+Fe+"."+te+"."+ge+ve+" <"+Fe+"."+(+te+1)+".0":">="+Fe+"."+te+"."+ge+ve+" <"+(+Fe+1)+".0.0"):(I("no pr"),ye=Fe==="0"?te==="0"?">="+Fe+"."+te+"."+ge+" <"+Fe+"."+te+"."+(+ge+1):">="+Fe+"."+te+"."+ge+" <"+Fe+"."+(+te+1)+".0":">="+Fe+"."+te+"."+ge+" <"+(+Fe+1)+".0.0"),I("caret return",ye),ye})}(Xe,je)}).join(" ")}(We,Le),I("caret",We),We=function(xe,je){return xe.trim().split(/\s+/).map(function(Xe){return function(He,Ke){var Qe=Ke?R[N]:R[B];return He.replace(Qe,function(Ze,Fe,te,ge,ve){var ye;return I("tilde",He,Ze,Fe,te,ge,ve),Ce(Fe)?ye="":Ce(te)?ye=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ce(ge)?ye=">="+Fe+"."+te+".0 <"+Fe+"."+(+te+1)+".0":ve?(I("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=">="+Fe+"."+te+"."+ge+ve+" <"+Fe+"."+(+te+1)+".0"):ye=">="+Fe+"."+te+"."+ge+" <"+Fe+"."+(+te+1)+".0",I("tilde return",ye),ye})}(Xe,je)}).join(" ")}(We,Le),I("tildes",We),We=function(xe,je){return I("replaceXRanges",xe,je),xe.split(/\s+/).map(function(Xe){return function(He,Ke){He=He.trim();var Qe=Ke?R[T]:R[M];return He.replace(Qe,function(Ze,Fe,te,ge,ve,ye){I("xRange",He,Ze,Fe,te,ge,ve,ye);var _e=Ce(te),Be=_e||Ce(ge),Ye=Be||Ce(ve);return Fe==="="&&Ye&&(Fe=""),_e?Ze=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&Ye?(Be&&(ge=0),Ye&&(ve=0),Fe===">"?(Fe=">=",Be?(te=+te+1,ge=0,ve=0):Ye&&(ge=+ge+1,ve=0)):Fe==="<="&&(Fe="<",Be?te=+te+1:ge=+ge+1),Ze=Fe+te+"."+ge+"."+ve):Be?Ze=">="+te+".0.0 <"+(+te+1)+".0.0":Ye&&(Ze=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),I("xRange return",Ze),Ze})}(Xe,je)}).join(" ")}(We,Le),I("xrange",We),We=function(xe,je){return I("replaceStars",xe,je),xe.trim().replace(R[j],"")}(We,Le),I("stars",We),We}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ue){return!!Ue.match(Se)})),Me=Me.map(function(Ue){return new fe(Ue,ue)})},we.prototype.intersects=function(X,ue){if(!(X instanceof we))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Se){return X.set.some(function(Me){return Me.every(function(Ue){return Se.intersects(Ue,ue)})})})})},e.toComparators=function(X,ue){return new we(X,ue).set.map(function(he){return he.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},we.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new de(X,this.loose));for(var ue=0;ue<this.set.length;ue++)if(De(this.set[ue],X))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(X,ue,he){var Se=null,Me=null;try{var Ue=new we(ue,he)}catch{return null}return X.forEach(function(We){Ue.test(We)&&(Se&&Me.compare(We)!==-1||(Me=new de(Se=We,he)))}),Se},e.minSatisfying=function(X,ue,he){var Se=null,Me=null;try{var Ue=new we(ue,he)}catch{return null}return X.forEach(function(We){Ue.test(We)&&(Se&&Me.compare(We)!==1||(Me=new de(Se=We,he)))}),Se},e.validRange=function(X,ue){try{return new we(X,ue).range||"*"}catch{return null}},e.ltr=function(X,ue,he){return pe(X,ue,"<",he)},e.gtr=function(X,ue,he){return pe(X,ue,">",he)},e.outside=pe,e.prerelease=function(X,ue){var he=G(X,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ue,he){return X=new we(X,he),ue=new we(ue,he),X.intersects(ue)},e.coerce=function(X){if(X instanceof de)return X;if(typeof X!="string")return null;var ue=X.match(R[L]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,n(1))},function(V,e){var n,o,I=V.exports={};function k(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(E){if(n===setTimeout)return setTimeout(E,0);if((n===k||!n)&&setTimeout)return n=setTimeout,setTimeout(E,0);try{return n(E,0)}catch{try{return n.call(null,E,0)}catch{return n.call(this,E,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:k}catch{n=k}try{o=typeof clearTimeout=="function"?clearTimeout:C}catch{o=C}})();var y,a=[],h=!1,f=-1;function g(){h&&y&&(h=!1,y.length?a=y.concat(a):f=-1,a.length&&w())}function w(){if(!h){var E=R(g);h=!0;for(var p=a.length;p;){for(y=a,a=[];++f<p;)y&&y[f].run();f=-1,p=a.length}y=null,h=!1,function(m){if(o===clearTimeout)return clearTimeout(m);if((o===C||!o)&&clearTimeout)return o=clearTimeout,clearTimeout(m);try{o(m)}catch{try{return o.call(null,m)}catch{return o.call(this,m)}}}(E)}}function d(E,p){this.fun=E,this.array=p}function v(){}I.nextTick=function(E){var p=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)p[m-1]=arguments[m];a.push(new d(E,p)),a.length!==1||h||R(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=v,I.addListener=v,I.once=v,I.off=v,I.removeListener=v,I.removeAllListeners=v,I.emit=v,I.prependListener=v,I.prependOnceListener=v,I.listeners=function(E){return[]},I.binding=function(E){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(E){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(oe[144],ae([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class o{constructor(R,y,a){this.level=R,this.key=y,this.value=a,this.forward=[]}}const I=void 0;class k{constructor(R,y=2**16){this.comparator=R,this[n]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new o(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new o(this._maxLevel,I,I),this._size=0}has(R){return!!k._search(this,R,this.comparator)}get(R){return k._search(this,R,this.comparator)?.value}set(R,y){return k._insert(this,R,y,this.comparator)&&(this._size+=1),this}delete(R){const y=k._delete(this,R,this.comparator);return y&&(this._size-=1),y}forEach(R,y){let a=this._header.forward[0];for(;a;)R.call(y,a.value,a.key,this),a=a.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",y=this._header.forward[0];for(;y;)R+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return R}static _search(R,y,a){let h=R._header;for(let f=R._level-1;f>=0;f--)for(;h.forward[f]&&a(h.forward[f].key,y)<0;)h=h.forward[f];if(h=h.forward[0],h&&a(h.key,y)===0)return h}static _insert(R,y,a,h){const f=[];let g=R._header;for(let w=R._level-1;w>=0;w--){for(;g.forward[w]&&h(g.forward[w].key,y)<0;)g=g.forward[w];f[w]=g}if(g=g.forward[0],g&&h(g.key,y)===0)return g.value=a,!1;{const w=k._randomLevel(R);if(w>R._level){for(let d=R._level;d<w;d++)f[d]=R._header;R._level=w}g=new o(w,y,a);for(let d=0;d<w;d++)g.forward[d]=f[d].forward[d],f[d].forward[d]=g;return!0}}static _randomLevel(R,y=.5){let a=1;for(;Math.random()<y&&a<R._maxLevel;)a+=1;return a}static _delete(R,y,a){const h=[];let f=R._header;for(let g=R._level-1;g>=0;g--){for(;f.forward[g]&&a(f.forward[g].key,y)<0;)f=f.forward[g];h[g]=f}if(f=f.forward[0],!f||a(f.key,y)!==0)return!1;for(let g=0;g<R._level&&h[g].forward[g]===f;g++)h[g].forward[g]=f.forward[g];for(;R._level>0&&R._header.forward[R._level-1]===I;)R._level-=1;return!0}}e.SkipList=k}),define(oe[67],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class o{static create(k){return new o(k)}constructor(k){this._now=n&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=o}),define(oe[4],ae([0,1,16,90,2,109,67]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=w;const R=!1,y=!1,a=!1;var h;(function(N){N.None=()=>I.Disposable.None;function z(Ie){if(a){const{onDidAddListener:De}=Ie,Re=v.create();let pe=0;Ie.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),De?.()}}}function se(Ie,De){return G(Ie,()=>{},0,void 0,!0,void 0,De)}N.defer=se;function J(Ie){return(De,Re=null,pe)=>{let X=!1,ue;return ue=Ie(he=>{if(!X)return ue?ue.dispose():X=!0,De.call(Re,he)},null,pe),X&&ue.dispose(),ue}}N.once=J;function le(Ie,De,Re){return j((pe,X=null,ue)=>Ie(he=>pe.call(X,De(he)),null,ue),Re)}N.map=le;function K(Ie,De,Re){return j((pe,X=null,ue)=>Ie(he=>{De(he),pe.call(X,he)},null,ue),Re)}N.forEach=K;function ee(Ie,De,Re){return j((pe,X=null,ue)=>Ie(he=>De(he)&&pe.call(X,he),null,ue),Re)}N.filter=ee;function q(Ie){return Ie}N.signal=q;function O(...Ie){return(De,Re=null,pe)=>{const X=(0,I.combinedDisposable)(...Ie.map(ue=>ue(he=>De.call(Re,he))));return ce(X,pe)}}N.any=O;function x(Ie,De,Re,pe){let X=Re;return le(Ie,ue=>(X=De(X,ue),X),pe)}N.reduce=x;function j(Ie,De){let Re;const pe={onWillAddFirstListener(){Re=Ie(X.fire,X)},onDidRemoveLastListener(){Re?.dispose()}};De||z(pe);const X=new i(pe);return De?.add(X),X.event}function ce(Ie,De){return De instanceof Array?De.push(Ie):De&&De.add(Ie),Ie}function G(Ie,De,Re=100,pe=!1,X=!1,ue,he){let Se,Me,Ue,We=0,Le;const xe={leakWarningThreshold:ue,onWillAddFirstListener(){Se=Ie(Xe=>{We++,Me=De(Me,Xe),pe&&!Ue&&(je.fire(Me),Me=void 0),Le=()=>{const He=Me;Me=void 0,Ue=void 0,(!pe||We>1)&&je.fire(He),We=0},typeof Re=="number"?(clearTimeout(Ue),Ue=setTimeout(Le,Re)):Ue===void 0&&(Ue=0,queueMicrotask(Le))})},onWillRemoveListener(){X&&We>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Se.dispose()}};he||z(xe);const je=new i(xe);return he?.add(je),je.event}N.debounce=G;function de(Ie,De=0,Re){return N.debounce(Ie,(pe,X)=>pe?(pe.push(X),pe):[X],De,void 0,!0,void 0,Re)}N.accumulate=de;function re(Ie,De=(pe,X)=>pe===X,Re){let pe=!0,X;return ee(Ie,ue=>{const he=pe||!De(ue,X);return pe=!1,X=ue,he},Re)}N.latch=re;function Z(Ie,De,Re){return[N.filter(Ie,De,Re),N.filter(Ie,pe=>!De(pe),Re)]}N.split=Z;function W(Ie,De=!1,Re=[],pe){let X=Re.slice(),ue=Ie(Me=>{X?X.push(Me):Se.fire(Me)});pe&&pe.add(ue);const he=()=>{X?.forEach(Me=>Se.fire(Me)),X=null},Se=new i({onWillAddFirstListener(){ue||(ue=Ie(Me=>Se.fire(Me)),pe&&pe.add(ue))},onDidAddFirstListener(){X&&(De?setTimeout(he):he())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return pe&&pe.add(Se),Se.event}N.buffer=W;function F(Ie,De){return(pe,X,ue)=>{const he=De(new H);return Ie(function(Se){const Me=he.evaluate(Se);Me!==U&&pe.call(X,Me)},void 0,ue)}}N.chain=F;const U=Symbol("HaltChainable");class H{constructor(){this.steps=[]}map(De){return this.steps.push(De),this}forEach(De){return this.steps.push(Re=>(De(Re),Re)),this}filter(De){return this.steps.push(Re=>De(Re)?Re:U),this}reduce(De,Re){let pe=Re;return this.steps.push(X=>(pe=De(pe,X),pe)),this}latch(De=(Re,pe)=>Re===pe){let Re=!0,pe;return this.steps.push(X=>{const ue=Re||!De(X,pe);return Re=!1,pe=X,ue?X:U}),this}evaluate(De){for(const Re of this.steps)if(De=Re(De),De===U)break;return De}}function Y(Ie,De,Re=pe=>pe){const pe=(...Se)=>he.fire(Re(...Se)),X=()=>Ie.on(De,pe),ue=()=>Ie.removeListener(De,pe),he=new i({onWillAddFirstListener:X,onDidRemoveLastListener:ue});return he.event}N.fromNodeEventEmitter=Y;function Q(Ie,De,Re=pe=>pe){const pe=(...Se)=>he.fire(Re(...Se)),X=()=>Ie.addEventListener(De,pe),ue=()=>Ie.removeEventListener(De,pe),he=new i({onWillAddFirstListener:X,onDidRemoveLastListener:ue});return he.event}N.fromDOMEventEmitter=Q;function $(Ie){return new Promise(De=>J(Ie)(De))}N.toPromise=$;function ie(Ie){const De=new i;return Ie.then(Re=>{De.fire(Re)},()=>{De.fire(void 0)}).finally(()=>{De.dispose()}),De.event}N.fromPromise=ie;function fe(Ie,De,Re){return De(Re),Ie(pe=>De(pe))}N.runAndSubscribe=fe;class me{constructor(De,Re){this._observable=De,this._counter=0,this._hasChanged=!1;const pe={onWillAddFirstListener:()=>{De.addObserver(this)},onDidRemoveLastListener:()=>{De.removeObserver(this)}};Re||z(pe),this.emitter=new i(pe),Re&&Re.add(this.emitter)}beginUpdate(De){this._counter++}handlePossibleChange(De){}handleChange(De,Re){this._hasChanged=!0}endUpdate(De){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(Ie,De){return new me(Ie,De).emitter.event}N.fromObservable=we;function Ce(Ie){return(De,Re,pe)=>{let X=0,ue=!1;const he={beginUpdate(){X++},endUpdate(){X--,X===0&&(Ie.reportChanges(),ue&&(ue=!1,De.call(Re)))},handlePossibleChange(){},handleChange(){ue=!0}};Ie.addObserver(he),Ie.reportChanges();const Se={dispose(){Ie.removeObserver(he)}};return pe instanceof I.DisposableStore?pe.add(Se):Array.isArray(pe)&&pe.push(Se),Se}}N.fromObservableLight=Ce})(h||(e.Event=h={}));class f{static{this.all=new Set}static{this._idPool=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${f._idPool++}`,f.all.add(this)}start(z){this._stopWatch=new C.StopWatch,this.listenerCount=z}stop(){if(this._stopWatch){const z=this._stopWatch.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=f;let g=-1;function w(N){const z=g;return g=N,{dispose(){g=z}}}class d{static{this._idPool=1}constructor(z,se,J=(d._idPool++).toString(16).padStart(3,"0")){this._errorHandler=z,this.threshold=se,this.name=J,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(z,se){const J=this.threshold;if(J<=0||se<J)return;this._stacks||(this._stacks=new Map);const le=this._stacks.get(z.value)||0;if(this._stacks.set(z.value,le+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=J*.5;const[K,ee]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${ee}):`;console.warn(q),console.warn(K);const O=new E(q,K);this._errorHandler(O)}return()=>{const K=this._stacks.get(z.value)||0;this._stacks.set(z.value,K-1)}}getMostFrequentStack(){if(!this._stacks)return;let z,se=0;for(const[J,le]of this._stacks)(!z||se<le)&&(z=[J,le],se=le);return z}}class v{static create(){const z=new Error;return new v(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(z,se){super(z),this.name="ListenerLeakError",this.stack=se}}e.ListenerLeakError=E;class p extends Error{constructor(z,se){super(z),this.name="ListenerRefusalError",this.stack=se}}e.ListenerRefusalError=p;let m=0;class b{constructor(z){this.value=z,this.id=m++}}const D=2,t=(N,z)=>{if(N instanceof b)z(N);else for(let se=0;se<N.length;se++){const J=N[se];J&&z(J)}};let s;if(R){const N=[];setInterval(()=>{N.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(N.join(`
`)),N.length=0)},3e3),s=new FinalizationRegistry(z=>{typeof z=="string"&&N.push(z)})}class i{constructor(z){this._size=0,this._options=z,this._leakageMon=g>0||this._options?.leakWarningThreshold?new d(z?.onListenerError??n.onUnexpectedError,this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(y){const z=this._listeners;queueMicrotask(()=>{t(z,se=>se.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(z,se,J)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const O=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(O);const x=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],j=new p(`${O}. HINT: Stack shows most frequent listener (${x[1]}-times)`,x[0]);return(this._options?.onListenerError||n.onUnexpectedError)(j),I.Disposable.None}if(this._disposed)return I.Disposable.None;se&&(z=z.bind(se));const le=new b(z);let K,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(le.stack=v.create(),K=this._leakageMon.check(le.stack,this._size+1)),y&&(le.stack=ee??v.create()),this._listeners?this._listeners instanceof b?(this._deliveryQueue??=new r,this._listeners=[this._listeners,le]):this._listeners.push(le):(this._options?.onWillAddFirstListener?.(this),this._listeners=le,this._options?.onDidAddFirstListener?.(this)),this._size++;const q=(0,I.toDisposable)(()=>{s?.unregister(q),K?.(),this._removeListener(le)});if(J instanceof I.DisposableStore?J.add(q):Array.isArray(J)&&J.push(q),s){const O=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),x=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(O);s.register(q,x?.[2]??O,q)}return q},this._event}_removeListener(z){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const se=this._listeners,J=se.indexOf(z);if(J===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,se[J]=void 0;const le=this._deliveryQueue.current===this;if(this._size*D<=se.length){let K=0;for(let ee=0;ee<se.length;ee++)se[ee]?se[K++]=se[ee]:le&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);se.length=K}}_deliver(z,se){if(!z)return;const J=this._options?.onListenerError||n.onUnexpectedError;if(!J){z.value(se);return}try{z.value(se)}catch(le){J(le)}}_deliverQueue(z){const se=z.current._listeners;for(;z.i<z.end;)this._deliver(se[z.i++],z.value);z.reset()}fire(z){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof b)this._deliver(this._listeners,z);else{const se=this._deliveryQueue;se.enqueue(this,z,this._listeners.length),this._deliverQueue(se)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const c=()=>new r;e.createEventDeliveryQueue=c;class r{constructor(){this.i=-1,this.end=0}enqueue(z,se,J){this.i=0,this.end=J,this.current=z,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends i{async fireAsync(z,se,J){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList),t(this._listeners,le=>this._asyncDeliveryQueue.push([le.value,z]));this._asyncDeliveryQueue.size>0&&!se.isCancellationRequested;){const[le,K]=this._asyncDeliveryQueue.shift(),ee=[],q={...K,token:se,waitUntil:O=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");J&&(O=J(O,le)),ee.push(O)}};try{le(q)}catch(O){(0,n.onUnexpectedError)(O);continue}Object.freeze(ee),await Promise.allSettled(ee).then(O=>{for(const x of O)x.status==="rejected"&&(0,n.onUnexpectedError)(x.reason)})}}}e.AsyncEmitter=l;class u extends i{get isPaused(){return this._isPaused!==0}constructor(z){super(z),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=z?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const z=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(z))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(z){this._size&&(this._isPaused!==0?this._eventQueue.push(z):super.fire(z))}}e.PauseableEmitter=u;class P extends u{constructor(z){super(z),this._delay=z.delay??100}fire(z){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(z)}}e.DebounceEmitter=P;class S extends i{constructor(z){super(z),this._queuedEvents=[],this._mergeFn=z?.merge}fire(z){this.hasListeners()&&(this._queuedEvents.push(z),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(se=>super.fire(se)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=S;class M{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(z){const se={event:z,listener:null};this.events.push(se),this.hasListeners&&this.hook(se);const J=()=>{this.hasListeners&&this.unhook(se);const le=this.events.indexOf(se);this.events.splice(le,1)};return(0,I.toDisposable)((0,o.createSingleCallFunction)(J))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(z=>this.hook(z))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(z=>this.unhook(z))}hook(z){z.listener=z.event(se=>this.emitter.fire(se))}unhook(z){z.listener?.dispose(),z.listener=null}dispose(){this.emitter.dispose();for(const z of this.events)z.listener?.dispose();this.events=[]}}e.EventMultiplexer=M;class T{constructor(z,se,J,le){this._store=new I.DisposableStore;const K=this._store.add(new M),ee=this._store.add(new I.DisposableMap);function q(O){ee.set(O,K.add(le(O)))}for(const O of z)q(O);this._store.add(se(O=>{q(O)})),this._store.add(J(O=>{ee.deleteAndDispose(O)})),this.event=K.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=T;class L{constructor(){this.data=[]}wrapEvent(z,se,J){return(le,K,ee)=>z(q=>{const O=this.data[this.data.length-1];if(!se){O?O.buffers.push(()=>le.call(K,q)):le.call(K,q);return}const x=O;if(!x){le.call(K,se(J,q));return}x.items??=[],x.items.push(q),x.buffers.length===0&&O.buffers.push(()=>{x.reducedResult??=J?x.items.reduce(se,J):x.items.reduce(se),le.call(K,x.reducedResult)})},void 0,ee)}bufferEvents(z){const se={buffers:new Array};this.data.push(se);const J=z();return this.data.pop(),se.buffers.forEach(le=>le()),J}}e.EventBufferer=L;class A{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=I.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(z){this.inputEvent=z,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=z(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A;class _{static const(z){return new B(z)}constructor(z){this._value=z,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(z){z!==this._value&&(this._value=z,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=_;class B{constructor(z){this.value=z,this.onDidChange=h.None}}}),define(oe[23],ae([0,1,4]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const o=Object.freeze(function(y,a){const h=setTimeout(y.bind(a),0);return{dispose(){clearTimeout(h)}}});var I;(function(y){function a(h){return h===y.None||h===y.Cancelled||h instanceof k?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}y.isCancellationToken=a,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})})(I||(e.CancellationToken=I={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?o:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=I.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C;function R(y){const a=new C;return y.add({dispose(){a.cancel()}}),a.token}}),define(oe[145],ae([0,1,23]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=I;class o{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new n.CancellationTokenSource,a=this.task(y.token);return this.result={promise:a,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=o;function I(R){return R}class k{constructor(y,a){this.lastCache=void 0,this.lastArgKey=void 0,typeof y=="function"?(this._fn=y,this._computeKey=I):(this._fn=a,this._computeKey=y.getCacheKey)}get(y){const a=this._computeKey(y);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this._fn(y)),this.lastCache}}e.LRUCachedFunction=k;class C{get cachedValues(){return this._map}constructor(y,a){this._map=new Map,this._map2=new Map,typeof y=="function"?(this._fn=y,this._computeKey=I):(this._fn=a,this._computeKey=y.getCacheKey)}get(y){const a=this._computeKey(y);if(this._map2.has(a))return this._map2.get(a);const h=this._fn(y);return this._map.set(y,h),this._map2.set(a,h),h}}e.CachedFunction=C}),define(oe[68],ae([0,1,16,2]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=I,e.isReadableStream=k,e.isReadableBufferedStream=C,e.newWriteableStream=R,e.consumeReadable=a,e.peekReadable=h,e.consumeStream=f,e.listenStream=g,e.peekStream=w,e.toStream=d,e.emptyStream=v,e.toReadable=E,e.transform=p,e.prefixedReadable=m,e.prefixedStream=b;function I(D){const t=D;return t?typeof t.read=="function":!1}function k(D){const t=D;return t?[t.on,t.pause,t.resume,t.destroy].every(s=>typeof s=="function"):!1}function C(D){const t=D;return t?k(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(D,t){return new y(D,t)}class y{constructor(t,s){this.reducer=t,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(s=>s(t))}emitError(t){this.listeners.error.length===0?(0,n.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(s=>s(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,s){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(t,s){if(this.state.destroyed)return;let i;switch(t){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const c=i.indexOf(s);c>=0&&i.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(D,t){const s=[];let i;for(;(i=D.read())!==null;)s.push(i);return t(s)}function h(D,t,s){const i=[];let c;for(;(c=D.read())!==null&&i.length<s;)i.push(c);return c===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const r=c;return c=void 0,r}return D.read()}}}function f(D,t){return new Promise((s,i)=>{const c=[];g(D,{onData:r=>{t&&c.push(r)},onError:r=>{t?i(r):s(void 0)},onEnd:()=>{s(t?t(c):void 0)}})})}function g(D,t,s){D.on("error",i=>{s?.isCancellationRequested||t.onError(i)}),D.on("end",()=>{s?.isCancellationRequested||t.onEnd()}),D.on("data",i=>{s?.isCancellationRequested||t.onData(i)})}function w(D,t){return new Promise((s,i)=>{const c=new o.DisposableStore,r=[],l=S=>{if(r.push(S),r.length>t)return c.dispose(),D.pause(),s({stream:D,buffer:r,ended:!1})},u=S=>(c.dispose(),i(S)),P=()=>(c.dispose(),s({stream:D,buffer:r,ended:!0}));c.add((0,o.toDisposable)(()=>D.removeListener("error",u))),D.on("error",u),c.add((0,o.toDisposable)(()=>D.removeListener("end",P))),D.on("end",P),c.add((0,o.toDisposable)(()=>D.removeListener("data",l))),D.on("data",l)})}function d(D,t){const s=R(t);return s.end(D),s}function v(){const D=R(()=>{throw new Error("not supported")});return D.end(),D}function E(D){let t=!1;return{read:()=>t?null:(t=!0,D)}}function p(D,t,s){const i=R(s);return g(D,{onData:c=>i.write(t.data(c)),onError:c=>i.error(t.error?t.error(c):c),onEnd:()=>i.end()}),i}function m(D,t,s){let i=!1;return{read:()=>{const c=t.read();return i?c:(i=!0,c!==null?s([D,c]):D)}}}function b(D,t,s){let i=!1;const c=R(s);return g(t,{onData:r=>i?c.write(r):(i=!0,c.write(s([D,r]))),onError:r=>c.error(r),onEnd:()=>{i||(i=!0,c.write(D)),c.end()}}),c}});var Mt=this&&this.__createBinding||(Object.create?function(V,e,n,o){o===void 0&&(o=n);var I=Object.getOwnPropertyDescriptor(e,n);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(V,o,I)}:function(V,e,n,o){o===void 0&&(o=n),V[o]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(V,e){Object.defineProperty(V,"default",{enumerable:!0,value:e})}:function(V,e){V.default=e}),ke=this&&this.__importStar||function(V){if(V&&V.__esModule)return V;var e={};if(V!=null)for(var n in V)n!=="default"&&Object.prototype.hasOwnProperty.call(V,n)&&Mt(e,V,n);return At(e,V),e};define(oe[17],ae([0,1,66,68]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=h,e.writeUInt16LE=f,e.readUInt32BE=g,e.writeUInt32BE=w,e.readUInt32LE=d,e.writeUInt32LE=v,e.readUInt8=E,e.writeUInt8=p,e.readableToBuffer=m,e.bufferToReadable=b,e.streamToBuffer=D,e.bufferedStreamToBuffer=t,e.bufferToStream=s,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=c,e.prefixedBufferReadable=r,e.prefixedBufferStream=l,e.decodeBase64=u,e.encodeBase64=M,o=ke(o);const I=typeof Buffer<"u",k=new n.Lazy(()=>new Uint8Array(256));let C,R;class y{static alloc(L){return I?new y(Buffer.allocUnsafe(L)):new y(new Uint8Array(L))}static wrap(L){return I&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new y(L)}static fromString(L,A){return!(A?.dontUseNodeBuffer||!1)&&I?new y(Buffer.from(L)):(C||(C=new TextEncoder),new y(C.encode(L)))}static fromByteArray(L){const A=y.alloc(L.length);for(let _=0,B=L.length;_<B;_++)A.buffer[_]=L[_];return A}static concat(L,A){if(typeof A>"u"){A=0;for(let N=0,z=L.length;N<z;N++)A+=L[N].byteLength}const _=y.alloc(A);let B=0;for(let N=0,z=L.length;N<z;N++){const se=L[N];_.set(se,B),B+=se.byteLength}return _}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=y.alloc(this.byteLength);return L.set(this),L}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(L,A){return new y(this.buffer.subarray(L,A))}set(L,A){if(L instanceof y)this.buffer.set(L.buffer,A);else if(L instanceof Uint8Array)this.buffer.set(L,A);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),A);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return g(this.buffer,L)}writeUInt32BE(L,A){w(this.buffer,L,A)}readUInt32LE(L){return d(this.buffer,L)}writeUInt32LE(L,A){v(this.buffer,L,A)}readUInt8(L){return E(this.buffer,L)}writeUInt8(L,A){p(this.buffer,L,A)}indexOf(L,A=0){return a(this.buffer,L instanceof y?L.buffer:L,A)}}e.VSBuffer=y;function a(T,L,A=0){const _=L.byteLength,B=T.byteLength;if(_===0)return 0;if(_===1)return T.indexOf(L[0]);if(_>B-A)return-1;const N=k.value;N.fill(L.length);for(let le=0;le<L.length;le++)N[L[le]]=L.length-le-1;let z=A+L.length-1,se=z,J=-1;for(;z<B;)if(T[z]===L[se]){if(se===0){J=z;break}z--,se--}else z+=Math.max(L.length-se,N[T[z]]),se=L.length-1;return J}function h(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}function f(T,L,A){T[A+0]=L&255,L=L>>>8,T[A+1]=L&255}function g(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}function w(T,L,A){T[A+3]=L,L=L>>>8,T[A+2]=L,L=L>>>8,T[A+1]=L,L=L>>>8,T[A]=L}function d(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}function v(T,L,A){T[A+0]=L&255,L=L>>>8,T[A+1]=L&255,L=L>>>8,T[A+2]=L&255,L=L>>>8,T[A+3]=L&255}function E(T,L){return T[L]}function p(T,L,A){T[A]=L}function m(T){return o.consumeReadable(T,L=>y.concat(L))}function b(T){return o.toReadable(T)}function D(T){return o.consumeStream(T,L=>y.concat(L))}async function t(T){return T.ended?y.concat(T.buffer):y.concat([...T.buffer,await D(T.stream)])}function s(T){return o.toStream(T,L=>y.concat(L))}function i(T){return o.transform(T,{data:L=>typeof L=="string"?y.fromString(L):y.wrap(L)},L=>y.concat(L))}function c(T){return o.newWriteableStream(L=>y.concat(L),T)}function r(T,L){return o.prefixedReadable(T,L,A=>y.concat(A))}function l(T,L){return o.prefixedStream(T,L,A=>y.concat(A))}function u(T){let L=0,A=0,_=0;const B=new Uint8Array(Math.floor(T.length/4*3)),N=se=>{switch(A){case 3:B[_++]=L|se,A=0;break;case 2:B[_++]=L|se>>>2,L=se<<6,A=3;break;case 1:B[_++]=L|se>>>4,L=se<<4,A=2;break;default:L=se<<2,A=1}};for(let se=0;se<T.length;se++){const J=T.charCodeAt(se);if(J>=65&&J<=90)N(J-65);else if(J>=97&&J<=122)N(J-97+26);else if(J>=48&&J<=57)N(J-48+52);else if(J===43||J===45)N(62);else if(J===47||J===95)N(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${T[se]}`)}}const z=_;for(;A>0;)N(0);return y.wrap(B).slice(0,z)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:T},L=!0,A=!1){const _=A?S:P;let B="";const N=T.byteLength%3;let z=0;for(;z<T.byteLength-N;z+=3){const se=T[z+0],J=T[z+1],le=T[z+2];B+=_[se>>>2],B+=_[(se<<4|J>>>4)&63],B+=_[(J<<2|le>>>6)&63],B+=_[le&63]}if(N===1){const se=T[z+0];B+=_[se>>>2],B+=_[se<<4&63],L&&(B+="==")}else if(N===2){const se=T[z+0],J=T[z+1];B+=_[se>>>2],B+=_[(se<<4|J>>>4)&63],B+=_[J<<2&63],L&&(B+="=")}return B}}),define(oe[146],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[13],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=n,e.isStringArray=o,e.isObject=I,e.isTypedArray=k,e.isNumber=C,e.isIterable=R,e.isBoolean=y,e.isUndefined=a,e.isDefined=h,e.isUndefinedOrNull=f,e.assertType=g,e.assertIsDefined=w,e.assertAllDefined=d,e.isEmptyObject=E,e.isFunction=p,e.areFunctions=m,e.validateConstraints=b,e.validateConstraint=D;function n(t){return typeof t=="string"}function o(t){return Array.isArray(t)&&t.every(s=>n(s))}function I(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function k(t){const s=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof s}function C(t){return typeof t=="number"&&!isNaN(t)}function R(t){return!!t&&typeof t[Symbol.iterator]=="function"}function y(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function h(t){return!f(t)}function f(t){return a(t)||t===null}function g(t,s){if(!t)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function w(t){if(f(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function d(...t){const s=[];for(let i=0;i<t.length;i++){const c=t[i];if(f(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(c)}return s}const v=Object.prototype.hasOwnProperty;function E(t){if(!I(t))return!1;for(const s in t)if(v.call(t,s))return!1;return!0}function p(t){return typeof t=="function"}function m(...t){return t.length>0&&t.every(p)}function b(t,s){const i=Math.min(t.length,s.length);for(let c=0;c<i;c++)D(t[c],s[c])}function D(t,s){if(n(s)){if(typeof t!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(p(s)){try{if(t instanceof s)return}catch{}if(!f(t)&&t.constructor===s||s.length===1&&s.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[110],ae([0,1,13]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=I,e.getCodiconFontCharacters=k;const o=Object.create(null);function I(C,R){if((0,n.isString)(R)){const y=o[R];if(y===void 0)throw new Error(`${C} references an unknown codicon: ${R}`);R=y}return o[C]=R,{id:C}}function k(){return o}}),define(oe[147],ae([0,1,110]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465),goToSearch:(0,n.register)("go-to-search",60466),percentage:(0,n.register)("percentage",60467),sortPercentage:(0,n.register)("sort-percentage",60467),attach:(0,n.register)("attach",60468)}}),define(oe[80],ae([0,1,110,147]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=I;function I(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},e.Codicon={...o.codiconsLibrary,...e.codiconsDerived}}),define(oe[36],ae([0,1,13]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=o,e.deepFreeze=I,e.cloneAndChange=C,e.mixin=y,e.equals=a,e.safeStringify=h,e.distinct=f,e.getCaseInsensitive=g,e.filter=w,e.getAllPropertyNames=d,e.getAllMethodNames=v,e.createProxyObject=E,e.mapValues=p;function o(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([D,t])=>{b[D]=t&&typeof t=="object"?o(t):t}),b}function I(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const D=b.shift();Object.freeze(D);for(const t in D)if(k.call(D,t)){const s=D[t];typeof s=="object"&&!Object.isFrozen(s)&&!(0,n.isTypedArray)(s)&&b.push(s)}}return m}const k=Object.prototype.hasOwnProperty;function C(m,b){return R(m,b,new Set)}function R(m,b,D){if((0,n.isUndefinedOrNull)(m))return m;const t=b(m);if(typeof t<"u")return t;if(Array.isArray(m)){const s=[];for(const i of m)s.push(R(i,b,D));return s}if((0,n.isObject)(m)){if(D.has(m))throw new Error("Cannot clone recursive data-structure");D.add(m);const s={};for(const i in m)k.call(m,i)&&(s[i]=R(m[i],b,D));return D.delete(m),s}return m}function y(m,b,D=!0){return(0,n.isObject)(m)?((0,n.isObject)(b)&&Object.keys(b).forEach(t=>{t in m?D&&((0,n.isObject)(m[t])&&(0,n.isObject)(b[t])?y(m[t],b[t],D):m[t]=b[t]):m[t]=b[t]}),m):b}function a(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let D,t;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(D=0;D<m.length;D++)if(!a(m[D],b[D]))return!1}else{const s=[];for(t in m)s.push(t);s.sort();const i=[];for(t in b)i.push(t);if(i.sort(),!a(s,i))return!1;for(D=0;D<s.length;D++)if(!a(m[s[D]],b[s[D]]))return!1}return!0}function h(m){const b=new Set;return JSON.stringify(m,(D,t)=>{if((0,n.isObject)(t)||Array.isArray(t)){if(b.has(t))return"[Circular]";b.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function f(m,b){const D=Object.create(null);return!m||!b||Object.keys(b).forEach(s=>{const i=m[s],c=b[s];a(i,c)||(D[s]=c)}),D}function g(m,b){const D=b.toLowerCase(),t=Object.keys(m).find(s=>s.toLowerCase()===D);return t?m[t]:m[b]}function w(m,b){const D=Object.create(null);for(const[t,s]of Object.entries(m))b(t,s)&&(D[t]=s);return D}function d(m){let b=[];for(;Object.prototype!==m;)b=b.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return b}function v(m){const b=[];for(const D of d(m))typeof m[D]=="function"&&b.push(D);return b}function E(m,b){const D=s=>function(){const i=Array.prototype.slice.call(arguments,0);return b(s,i)},t={};for(const s of m)t[s]=D(s);return t}function p(m,b){const D={};for(const[t,s]of Object.entries(m))D[t]=b(s,t);return D}}),define(oe[111],ae([0,1,80]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=I;var o;(function(C){function R(y){return y&&typeof y=="object"&&typeof y.id=="string"}C.isThemeColor=R})(o||(e.ThemeColor=o={}));function I(C){return{id:C}}var k;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function y(m){const b=R.exec(m.id);if(!b)return y(n.Codicon.error);const[,D,t]=b,s=["codicon","codicon-"+D];return t&&s.push("codicon-modifier-"+t.substring(1)),s}C.asClassNameArray=y;function a(m){return y(m).join(" ")}C.asClassName=a;function h(m){return"."+y(m).join(".")}C.asCSSSelector=h;function f(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||o.isThemeColor(m.color))}C.isThemeIcon=f;const g=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function w(m){const b=g.exec(m);if(!b)return;const[,D]=b;return{id:D}}C.fromString=w;function d(m){return{id:m}}C.fromId=d;function v(m,b){let D=m.id;const t=D.lastIndexOf("~");return t!==-1&&(D=D.substring(0,t)),b&&(D=`${D}~${b}`),{id:D}}C.modify=v;function E(m){const b=m.id.lastIndexOf("~");if(b!==-1)return m.id.substring(b+1)}C.getModifier=E;function p(m,b){return m.id===b.id&&m.color?.id===b.color?.id}C.isEqual=p})(k||(e.ThemeIcon=k={}))}),define(oe[148],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=o,e.toUint32=I;var n;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function o(k){return k<0?0:k>n.MAX_UINT_8?n.MAX_UINT_8:k|0}function I(k){return k<0?0:k>n.MAX_UINT_32?n.MAX_UINT_32:k|0}}),define(oe[26],ae([0,1,145,39,66,148]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=C,e.format=y,e.format2=h,e.htmlAttributeEncodeValue=f,e.escape=g,e.escapeRegExpCharacters=w,e.count=d,e.truncate=v,e.truncateMiddle=E,e.trim=p,e.ltrim=m,e.rtrim=b,e.convertSimple2RegExpPattern=D,e.stripWildcards=t,e.createRegExp=s,e.regExpLeadsToEndlessLoop=i,e.splitLines=c,e.splitLinesIncludeSeparators=r,e.firstNonWhitespaceIndex=l,e.getLeadingWhitespace=u,e.lastNonWhitespaceIndex=P,e.replaceAsync=S,e.compare=M,e.compareSubstring=T,e.compareIgnoreCase=L,e.compareSubstringIgnoreCase=A,e.isAsciiDigit=_,e.isLowerAsciiLetter=B,e.isUpperAsciiLetter=N,e.equalsIgnoreCase=z,e.startsWithIgnoreCase=se,e.commonPrefixLength=J,e.commonSuffixLength=le,e.isHighSurrogate=K,e.isLowSurrogate=ee,e.computeCodePoint=q,e.getNextCodePoint=O,e.nextCharLength=G,e.prevCharLength=de,e.getCharContainingOffset=re,e.charCount=Z,e.containsRTL=U,e.isBasicASCII=Y,e.containsUnusualLineTerminators=Q,e.isFullWidthCharacter=$,e.isEmojiImprecise=ie,e.lcut=fe,e.forAnsiStringParts=we,e.removeAnsiEscapeCodes=Ce,e.removeAnsiEscapeCodesFromPrompt=De,e.startsWithUTF8BOM=Re,e.stripUTF8BOM=pe,e.fuzzyContains=X,e.containsUppercaseCharacter=ue,e.uppercaseFirstLetter=he,e.getNLines=Se,e.singleLetterHash=Me,e.getGraphemeBreakType=Ue,e.getLeftDeleteOffset=Xe;function C(te){return!te||typeof te!="string"?!0:te.trim().length===0}const R=/{(\d+)}/g;function y(te,...ge){return ge.length===0?te:te.replace(R,function(ve,ye){const _e=parseInt(ye,10);return isNaN(_e)||_e<0||_e>=ge.length?ve:ge[_e]})}const a=/{([^}]+)}/g;function h(te,ge){return Object.keys(ge).length===0?te:te.replace(a,(ve,ye)=>ge[ye]??ve)}function f(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(te,ge){let ve=0,ye=te.indexOf(ge);for(;ye!==-1;)ve++,ye=te.indexOf(ge,ye+ge.length);return ve}function v(te,ge,ve="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${ve}`}function E(te,ge,ve="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-ve.length/2,_e=Math.floor(ge/2)-ve.length/2;return`${te.substr(0,ye)}${ve}${te.substr(te.length-_e)}`}function p(te,ge=" "){const ve=m(te,ge);return b(ve,ge)}function m(te,ge){if(!te||!ge)return te;const ve=ge.length;if(ve===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+ve;return te.substring(ye)}function b(te,ge){if(!te||!ge)return te;const ve=ge.length,ye=te.length;if(ve===0||ye===0)return te;let _e=ye,Be=-1;for(;Be=te.lastIndexOf(ge,_e-1),!(Be===-1||Be+ve!==_e);){if(Be===0)return"";_e=Be}return te.substring(0,_e)}function D(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(te){return te.replace(/\*/g,"")}function s(te,ge,ve={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=w(te)),ve.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp(te,ye)}function i(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function c(te){return te.split(/\r\n|\r|\n/)}function r(te){const ge=[],ve=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)ge.push(ve[2*ye]+(ve[2*ye+1]??""));return ge}function l(te){for(let ge=0,ve=te.length;ge<ve;ge++){const ye=te.charCodeAt(ge);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ge}return-1}function u(te,ge=0,ve=te.length){for(let ye=ge;ye<ve;ye++){const _e=te.charCodeAt(ye);if(_e!==o.CharCode.Space&&_e!==o.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,ve)}function P(te,ge=te.length-1){for(let ve=ge;ve>=0;ve--){const ye=te.charCodeAt(ve);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ve}return-1}function S(te,ge,ve){const ye=[];let _e=0;for(const Be of te.matchAll(ge)){if(ye.push(te.slice(_e,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");_e=Be.index+Be[0].length,ye.push(ve(Be[0],...Be.slice(1),Be.index,te,Be.groups))}return ye.push(te.slice(_e)),Promise.all(ye).then(Be=>Be.join(""))}function M(te,ge){return te<ge?-1:te>ge?1:0}function T(te,ge,ve=0,ye=te.length,_e=0,Be=ge.length){for(;ve<ye&&_e<Be;ve++,_e++){const at=te.charCodeAt(ve),st=ge.charCodeAt(_e);if(at<st)return-1;if(at>st)return 1}const Ye=ye-ve,lt=Be-_e;return Ye<lt?-1:Ye>lt?1:0}function L(te,ge){return A(te,ge,0,te.length,0,ge.length)}function A(te,ge,ve=0,ye=te.length,_e=0,Be=ge.length){for(;ve<ye&&_e<Be;ve++,_e++){let at=te.charCodeAt(ve),st=ge.charCodeAt(_e);if(at===st)continue;if(at>=128||st>=128)return T(te.toLowerCase(),ge.toLowerCase(),ve,ye,_e,Be);B(at)&&(at-=32),B(st)&&(st-=32);const tt=at-st;if(tt!==0)return tt}const Ye=ye-ve,lt=Be-_e;return Ye<lt?-1:Ye>lt?1:0}function _(te){return te>=o.CharCode.Digit0&&te<=o.CharCode.Digit9}function B(te){return te>=o.CharCode.a&&te<=o.CharCode.z}function N(te){return te>=o.CharCode.A&&te<=o.CharCode.Z}function z(te,ge){return te.length===ge.length&&A(te,ge)===0}function se(te,ge){const ve=ge.length;return ge.length>te.length?!1:A(te,ge,0,ve)===0}function J(te,ge){const ve=Math.min(te.length,ge.length);let ye;for(ye=0;ye<ve;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return ve}function le(te,ge){const ve=Math.min(te.length,ge.length);let ye;const _e=te.length-1,Be=ge.length-1;for(ye=0;ye<ve;ye++)if(te.charCodeAt(_e-ye)!==ge.charCodeAt(Be-ye))return ye;return ve}function K(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function q(te,ge){return(te-55296<<10)+(ge-56320)+65536}function O(te,ge,ve){const ye=te.charCodeAt(ve);if(K(ye)&&ve+1<ge){const _e=te.charCodeAt(ve+1);if(ee(_e))return q(ye,_e)}return ye}function x(te,ge){const ve=te.charCodeAt(ge-1);if(ee(ve)&&ge>1){const ye=te.charCodeAt(ge-2);if(K(ye))return q(ye,ve)}return ve}class j{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=x(this._str,this._offset);return this._offset-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=O(this._str,this._len,this._offset);return this._offset+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class ce{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new j(ge,ve)}nextGraphemeLength(){const ge=xe.getInstance(),ve=this._iterator,ye=ve.offset;let _e=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Be=ve.offset,Ye=ge.getGraphemeBreakType(ve.nextCodePoint());if(We(_e,Ye)){ve.setOffset(Be);break}_e=Ye}return ve.offset-ye}prevGraphemeLength(){const ge=xe.getInstance(),ve=this._iterator,ye=ve.offset;let _e=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Be=ve.offset,Ye=ge.getGraphemeBreakType(ve.prevCodePoint());if(We(Ye,_e)){ve.setOffset(Be);break}_e=Ye}return ye-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ce;function G(te,ge){return new ce(te,ge).nextGraphemeLength()}function de(te,ge){return new ce(te,ge).prevGraphemeLength()}function re(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const ve=ge+G(te,ge);return[ve-de(te,ve),ve]}function Z(te){const ge=new ce(te);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}let W;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(te){return W||(W=F()),W.test(te)}const H=/^[\t\n\r\x20-\x7E]*$/;function Y(te){return H.test(te)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}function $(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function fe(te,ge,ve=""){const ye=te.trimStart();if(ye.length<ge)return ye;const _e=/\b/g;let Be=0;for(;_e.test(ye)&&!(ye.length-_e.lastIndex<ge);)Be=_e.lastIndex,_e.lastIndex+=1;return Be===0?ye:ve+ye.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(te){let ge=0;for(const ve of te.matchAll(me))ge!==ve.index&&(yield{isCode:!1,str:te.substring(ge,ve.index)}),yield{isCode:!0,str:ve[0]},ge=ve.index+ve[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Ce(te){return te&&(te=te.replace(me,"")),te}const Ie=/\\\[.*?\\\]/g;function De(te){return Ce(te).replace(Ie,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(o.CharCode.UTF8_BOM);function Re(te){return!!(te&&te.length>0&&te.charCodeAt(0)===o.CharCode.UTF8_BOM)}function pe(te){return Re(te)?te.substr(1):te}function X(te,ge){if(!te||!ge||te.length<ge.length)return!1;const ve=ge.length,ye=te.toLowerCase();let _e=0,Be=-1;for(;_e<ve;){const Ye=ye.indexOf(ge[_e],Be+1);if(Ye<0)return!1;Be=Ye,_e++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function he(te){return te.charAt(0).toUpperCase()+te.slice(1)}function Se(te,ge=1){if(ge===0)return"";let ve=-1;do ve=te.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?te:(te[ve-1]==="\r"&&ve--,te.substr(0,ve))}function Me(te){const ge=o.CharCode.Z-o.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(o.CharCode.a+te):String.fromCharCode(o.CharCode.A+te-ge)}function Ue(te){return xe.getInstance().getGraphemeBreakType(te)}function We(te,ge){return te===Le.Other?ge!==Le.Extend&&ge!==Le.SpacingMark:te===Le.CR&&ge===Le.LF?!1:te===Le.Control||te===Le.CR||te===Le.LF||ge===Le.Control||ge===Le.CR||ge===Le.LF?!0:!(te===Le.L&&(ge===Le.L||ge===Le.V||ge===Le.LV||ge===Le.LVT)||(te===Le.LV||te===Le.V)&&(ge===Le.V||ge===Le.T)||(te===Le.LVT||te===Le.T)&&ge===Le.T||ge===Le.Extend||ge===Le.ZWJ||ge===Le.SpacingMark||te===Le.Prepend||te===Le.ZWJ&&ge===Le.Extended_Pictographic||te===Le.Regional_Indicator&&ge===Le.Regional_Indicator)}var Le;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class xe{static{this._INSTANCE=null}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}constructor(){this._data=je()}getGraphemeBreakType(ge){if(ge<32)return ge===o.CharCode.LineFeed?Le.LF:ge===o.CharCode.CarriageReturn?Le.CR:Le.Control;if(ge<127)return Le.Other;const ve=this._data,ye=ve.length/3;let _e=1;for(;_e<=ye;)if(ge<ve[3*_e])_e=2*_e;else if(ge>ve[3*_e+1])_e=2*_e+1;else return ve[3*_e+2];return Le.Other}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(te,ge){if(te===0)return 0;const ve=He(te,ge);if(ve!==void 0)return ve;const ye=new j(ge,te);return ye.prevCodePoint(),ye.offset}function He(te,ge){const ve=new j(ge,te);let ye=ve.prevCodePoint();for(;Ke(ye)||ye===Qe.emojiVariantSelector||ye===Qe.enclosingKeyCap;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!ie(ye))return;let _e=ve.offset;return _e>0&&ve.prevCodePoint()===Qe.zwj&&(_e=ve.offset),_e}function Ke(te){return 127995<=te&&te<=127999}var Qe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Ze{static{this.ambiguousCharacterData=new I.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction({getCacheKey:JSON.stringify},ge=>{function ve(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ht,gt]of ut)ct.set(ht,gt);return ct}function _e(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ht,gt]of tt)ut.has(ht)&&ct.set(ht,gt);return ct}const Be=this.ambiguousCharacterData.value;let Ye=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);Ye.length===0&&(Ye=["_default"]);let lt;for(const tt of Ye){const ut=ve(Be[tt]);lt=_e(lt,ut)}const at=ve(Be._common),st=ye(at,lt);return new Ze(st)})}static getInstance(ge){return Ze.cache.get(Array.from(ge))}static{this._locales=new I.Lazy(()=>Object.keys(Ze.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ze._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}containsAmbiguousCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ze;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(ge){return Fe.getData().has(ge)}static containsInvisibleCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&Fe.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe}),define(oe[46],ae([0,1,26]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=o,e.doHash=I,e.numberHash=k,e.stringHash=R,e.toHexString=v,n=ke(n);function o(p){return I(p,0)}function I(p,m){switch(typeof p){case"object":return p===null?k(349,m):Array.isArray(p)?y(p,m):a(p,m);case"string":return R(p,m);case"boolean":return C(p,m);case"number":return k(p,m);case"undefined":return k(937,m);default:return k(617,m)}}function k(p,m){return(m<<5)-m+p|0}function C(p,m){return k(p?433:863,m)}function R(p,m){m=k(149417,m);for(let b=0,D=p.length;b<D;b++)m=k(p.charCodeAt(b),m);return m}function y(p,m){return m=k(104579,m),p.reduce((b,D)=>I(D,b),m)}function a(p,m){return m=k(181387,m),Object.keys(p).sort().reduce((b,D)=>(b=R(D,b),I(p[D],b)),m)}class h{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=I(m,this._value),this._value}}e.Hasher=h;var f;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function g(p,m,b=32){const D=b-m,t=~((1<<D)-1);return(p<<m|(t&p)>>>D)>>>0}function w(p,m=0,b=p.byteLength,D=0){for(let t=0;t<b;t++)p[m+t]=D}function d(p,m,b="0"){for(;p.length<m;)p=b+p;return p}function v(p,m=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(b=>b.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),m/4)}class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(f.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const b=m.length;if(b===0)return;const D=this._buff;let t=this._buffLen,s=this._leftoverHighSurrogate,i,c;for(s!==0?(i=s,c=-1,s=0):(i=m.charCodeAt(0),c=0);;){let r=i;if(n.isHighSurrogate(i))if(c+1<b){const l=m.charCodeAt(c+1);n.isLowSurrogate(l)?(c++,r=n.computeCodePoint(i,l)):r=f.UNICODE_REPLACEMENT}else{s=i;break}else n.isLowSurrogate(i)&&(r=f.UNICODE_REPLACEMENT);if(t=this._push(D,t,r),c++,c<b)i=m.charCodeAt(c);else break}this._buffLen=t,this._leftoverHighSurrogate=s}_push(m,b,D){return D<128?m[b++]=D:D<2048?(m[b++]=192|(D&1984)>>>6,m[b++]=128|(D&63)>>>0):D<65536?(m[b++]=224|(D&61440)>>>12,m[b++]=128|(D&4032)>>>6,m[b++]=128|(D&63)>>>0):(m[b++]=240|(D&1835008)>>>18,m[b++]=128|(D&258048)>>>12,m[b++]=128|(D&4032)>>>6,m[b++]=128|(D&63)>>>0),b>=f.BLOCK_SIZE&&(this._step(),b-=f.BLOCK_SIZE,this._totalLen+=f.BLOCK_SIZE,m[0]=m[f.BLOCK_SIZE+0],m[1]=m[f.BLOCK_SIZE+1],m[2]=m[f.BLOCK_SIZE+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,f.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=E._bigBlock32,b=this._buffDV;for(let P=0;P<64;P+=4)m.setUint32(P,b.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)m.setUint32(P,g(m.getUint32(P-12,!1)^m.getUint32(P-32,!1)^m.getUint32(P-56,!1)^m.getUint32(P-64,!1),1),!1);let D=this._h0,t=this._h1,s=this._h2,i=this._h3,c=this._h4,r,l,u;for(let P=0;P<80;P++)P<20?(r=t&s|~t&i,l=1518500249):P<40?(r=t^s^i,l=1859775393):P<60?(r=t&s|t&i|s&i,l=2400959708):(r=t^s^i,l=3395469782),u=g(D,5)+r+c+l+m.getUint32(P*4,!1)&4294967295,c=i,i=s,s=g(t,30),t=D,D=u;this._h0=this._h0+D&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+c&4294967295}}e.StringSHA1=E}),define(oe[81],ae([0,1,26]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=ke(n);var o;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(o||(o={})),function(I){const k="error",C="warning",R="warn",y="info",a="ignore";function h(g){return g?n.equalsIgnoreCase(k,g)?I.Error:n.equalsIgnoreCase(C,g)||n.equalsIgnoreCase(R,g)?I.Warning:n.equalsIgnoreCase(y,g)?I.Info:I.Ignore:I.Ignore}I.fromValue=h;function f(g){switch(g){case I.Error:return k;case I.Warning:return C;case I.Info:return y;default:return a}}I.toString=f}(o||(o={})),e.default=o}),define(oe[61],ae([0,1,22,39,26]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const v=d.charCodeAt(0),E=this._value.charCodeAt(this._pos);return v-E}value(){return this._value[this._pos]}}e.StringIterator=k;class C{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===o.CharCode.Period)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,I.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class R{constructor(d=!0,v=!0){this._splitOnBackslash=d,this._caseSensitive=v}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let v=d.length-1;v>=0;v--,this._valueLen--){const E=this._value.charCodeAt(v);if(!(E===o.CharCode.Slash||this._splitOnBackslash&&E===o.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const v=this._value.charCodeAt(this._to);if(v===o.CharCode.Slash||this._splitOnBackslash&&v===o.CharCode.Backslash)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,I.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var y;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(y||(y={}));class a{constructor(d,v){this._ignorePathCasing=d,this._ignoreQueryAndFragment=v,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(y.Scheme),this._value.authority&&this._states.push(y.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(y.Path)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(y.Query),this._value.fragment&&this._states.push(y.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===y.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===y.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===y.Scheme)return(0,I.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===y.Authority)return(0,I.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===y.Path)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===y.Query)return(0,I.compare)(d,this._value.query);if(this._states[this._stateIdx]===y.Fragment)return(0,I.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===y.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===y.Authority)return this._value.authority;if(this._states[this._stateIdx]===y.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===y.Query)return this._value.query;if(this._states[this._stateIdx]===y.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(f||(f={}));class g{static forUris(d=()=>!1,v=()=>!1){return new g(new a(d,v))}static forPaths(d=!1){return new g(new R(void 0,!d))}static forStrings(){return new g(new k)}static forConfigKeys(){return new g(new C)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,v){if(v){const E=v.slice(0);(0,n.shuffle)(E);for(const p of E)this.set(p,d)}else{const E=d.slice(0);(0,n.shuffle)(E);for(const p of E)this.set(p[0],p[1])}}set(d,v){const E=this._iter.reset(d);let p;this._root||(this._root=new h,this._root.segment=E.value());const m=[];for(p=this._root;;){const D=E.cmp(p.segment);if(D>0)p.left||(p.left=new h,p.left.segment=E.value()),m.push([f.Left,p]),p=p.left;else if(D<0)p.right||(p.right=new h,p.right.segment=E.value()),m.push([f.Right,p]),p=p.right;else if(E.hasNext())E.next(),p.mid||(p.mid=new h,p.mid.segment=E.value()),m.push([f.Mid,p]),p=p.mid;else break}const b=p.value;p.value=v,p.key=d;for(let D=m.length-1;D>=0;D--){const t=m[D][1];t.updateHeight();const s=t.balanceFactor();if(s<-1||s>1){const i=m[D][0],c=m[D+1][0];if(i===f.Right&&c===f.Right)m[D][1]=t.rotateLeft();else if(i===f.Left&&c===f.Left)m[D][1]=t.rotateRight();else if(i===f.Right&&c===f.Left)t.right=m[D+1][1]=m[D+1][1].rotateRight(),m[D][1]=t.rotateLeft();else if(i===f.Left&&c===f.Right)t.left=m[D+1][1]=m[D+1][1].rotateLeft(),m[D][1]=t.rotateRight();else throw new Error;if(D>0)switch(m[D-1][0]){case f.Left:m[D-1][1].left=m[D][1];break;case f.Right:m[D-1][1].right=m[D][1];break;case f.Mid:m[D-1][1].mid=m[D][1];break}else this._root=m[0][1]}}return b}get(d){return this._getNode(d)?.value}_getNode(d){const v=this._iter.reset(d);let E=this._root;for(;E;){const p=v.cmp(E.segment);if(p>0)E=E.left;else if(p<0)E=E.right;else if(v.hasNext())v.next(),E=E.mid;else break}return E}has(d){const v=this._getNode(d);return!(v?.value===void 0&&v?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,v){const E=this._iter.reset(d),p=[];let m=this._root;for(;m;){const b=E.cmp(m.segment);if(b>0)p.push([f.Left,m]),m=m.left;else if(b<0)p.push([f.Right,m]),m=m.right;else if(E.hasNext())E.next(),p.push([f.Mid,m]),m=m.mid;else break}if(m){if(v?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const b=this._min(m.right);if(b.key){const{key:D,value:t,segment:s}=b;this._delete(b.key,!1),m.key=D,m.value=t,m.segment=s}}else{const b=m.left??m.right;if(p.length>0){const[D,t]=p[p.length-1];switch(D){case f.Left:t.left=b;break;case f.Mid:t.mid=b;break;case f.Right:t.right=b;break}}else this._root=b}for(let b=p.length-1;b>=0;b--){const D=p[b][1];D.updateHeight();const t=D.balanceFactor();if(t>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),p[b][1]=D.rotateLeft()):t<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),p[b][1]=D.rotateRight()),b>0)switch(p[b-1][0]){case f.Left:p[b-1][1].left=p[b][1];break;case f.Right:p[b-1][1].right=p[b][1];break;case f.Mid:p[b-1][1].mid=p[b][1];break}else this._root=p[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const v=this._iter.reset(d);let E=this._root,p;for(;E;){const m=v.cmp(E.segment);if(m>0)E=E.left;else if(m<0)E=E.right;else if(v.hasNext())v.next(),p=E.value||p,E=E.mid;else break}return E&&E.value||p}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,v){const E=this._iter.reset(d);let p=this._root;for(;p;){const m=E.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(E.hasNext())E.next(),p=p.mid;else return p.mid?this._entries(p.mid):v?p.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[v,E]of this)d(E,v)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const v=[];return this._dfsEntries(d,v),v[Symbol.iterator]()}_dfsEntries(d,v){d&&(d.left&&this._dfsEntries(d.left,v),d.value&&v.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,v),d.right&&this._dfsEntries(d.right,v))}_isBalanced(){const d=v=>{if(!v)return!0;const E=v.balanceFactor();return E<-1||E>1?!1:d(v.left)&&d(v.right)};return d(this._root)}}e.TernarySearchTree=g}),define(oe[33],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=o;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(I){return n.test(I)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){I(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,a="";return a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a+="-",a+=C[k[y++]],a+=C[k[y++]],a+="-",a+=C[k[y++]],a+=C[k[y++]],a+="-",a+=C[k[y++]],a+=C[k[y++]],a+="-",a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a+=C[k[y++]],a}}()}),define(oe[149],ae([0,1,92,47,90]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=k,n=ke(n),o=ke(o);async function k(C,R){if(await new Promise((h,f)=>{const g=o.createReadStream(C),w=n.createHash("sha256");g.pipe(w);const d=(0,I.createSingleCallFunction)((v,E)=>{g.removeAllListeners(),w.removeAllListeners(),v?f(v):h(E)});g.once("error",d),g.once("end",d),w.once("error",d),w.once("data",v=>d(void 0,v.toString("hex")))})!==R)throw new Error("Hash mismatch")}}),define(oe[150],ae([0,1,27]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=k;const o=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(C){const R=C.replace(/\-/g,":").toLowerCase();return!o.has(R)}function k(){const C=(0,n.networkInterfaces)();for(const R in C){const y=C[R];if(y){for(const{mac:a}of y)if(I(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[112],ae([0,1,93]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=o,e.findFreePortFaster=k,n=ke(n);function o(R,y,a,h=1){let f=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!f)return f=!0,g(0)},a);I(R,y,h,d=>{if(!f)return f=!0,clearTimeout(w),g(d)})})}function I(R,y,a,h){if(y===0)return h(0);const f=new n.Socket;f.once("connect",()=>(C(f),I(R+a,y-1,a,h))),f.once("data",()=>{}),f.once("error",g=>(C(f),g.code!=="ECONNREFUSED"?I(R+a,y-1,a,h):h(R))),f.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,y,a,h="127.0.0.1"){let f=!1,g,w=1;const d=n.createServer({pauseOnConnect:!0});function v(E,p){f||(f=!0,d.removeAllListeners(),d.close(),g&&clearTimeout(g),p(E))}return new Promise(E=>{g=setTimeout(()=>{v(0,E)},a),d.on("listening",()=>{v(R,E)}),d.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&w<y?(R++,w++,d.listen(R,h)):v(0,E)}),d.on("close",()=>{v(0,E)}),d.listen(R,h)})}function C(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(y){console.error(y)}}}),function(){function V(){function e(){return process.uncHostAllowlist}function n(y){const a=new Set;if(Array.isArray(y))for(const h of y)typeof h=="string"&&a.add(h);return Array.from(a)}function o(){const y=e();return y?Array.from(y):[]}function I(y){if(process.platform!=="win32")return;const a=e();if(a)if(typeof y=="string")a.add(y.toLowerCase());else for(const h of n(y))I(h)}function k(y){if(typeof y!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let h;for(const f of a){if(y.indexOf(f)!==0)continue;const w=y.indexOf("\\",f.length);if(w===-1)continue;const d=y.substring(f.length,w);if(d){h=d;break}}return h}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:o,addUNCHostToAllowlist:I,getUNCHost:k,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[151],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(oe[152],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class n{constructor(I,k){this.sender=I,this.onMessage=k}send(I){try{this.sender.send("vscode:message",I.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=n}),define(oe[153],ae([11,9]),function(V,e){return V.create("vs/base/common/date",e)}),define(oe[154],ae([0,1,153]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=h,e.toLocalISOString=f;const o=60,I=o*60,k=I*24,C=k*7,R=k*30,y=k*365;function a(g,w,d,v){typeof g!="number"&&(g=g.getTime());const E=Math.round((new Date().getTime()-g)/1e3);if(E<-30)return(0,n.localize)(0,null,a(new Date().getTime()+E*1e3,!1));if(!v&&E<30)return(0,n.localize)(1,null);let p;return E<o?(p=E,w?p===1?d?(0,n.localize)(2,null,p):(0,n.localize)(3,null,p):d?(0,n.localize)(4,null,p):(0,n.localize)(5,null,p):p===1?d?(0,n.localize)(6,null,p):(0,n.localize)(7,null,p):d?(0,n.localize)(8,null,p):(0,n.localize)(9,null,p)):E<I?(p=Math.floor(E/o),w?p===1?d?(0,n.localize)(10,null,p):(0,n.localize)(11,null,p):d?(0,n.localize)(12,null,p):(0,n.localize)(13,null,p):p===1?d?(0,n.localize)(14,null,p):(0,n.localize)(15,null,p):d?(0,n.localize)(16,null,p):(0,n.localize)(17,null,p)):E<k?(p=Math.floor(E/I),w?p===1?d?(0,n.localize)(18,null,p):(0,n.localize)(19,null,p):d?(0,n.localize)(20,null,p):(0,n.localize)(21,null,p):p===1?d?(0,n.localize)(22,null,p):(0,n.localize)(23,null,p):d?(0,n.localize)(24,null,p):(0,n.localize)(25,null,p)):E<C?(p=Math.floor(E/k),w?p===1?(0,n.localize)(26,null,p):(0,n.localize)(27,null,p):p===1?(0,n.localize)(28,null,p):(0,n.localize)(29,null,p)):E<R?(p=Math.floor(E/C),w?p===1?d?(0,n.localize)(30,null,p):(0,n.localize)(31,null,p):d?(0,n.localize)(32,null,p):(0,n.localize)(33,null,p):p===1?d?(0,n.localize)(34,null,p):(0,n.localize)(35,null,p):d?(0,n.localize)(36,null,p):(0,n.localize)(37,null,p)):E<y?(p=Math.floor(E/R),w?p===1?d?(0,n.localize)(38,null,p):(0,n.localize)(39,null,p):d?(0,n.localize)(40,null,p):(0,n.localize)(41,null,p):p===1?d?(0,n.localize)(42,null,p):(0,n.localize)(43,null,p):d?(0,n.localize)(44,null,p):(0,n.localize)(45,null,p)):(p=Math.floor(E/y),w?p===1?d?(0,n.localize)(46,null,p):(0,n.localize)(47,null,p):d?(0,n.localize)(48,null,p):(0,n.localize)(49,null,p):p===1?d?(0,n.localize)(50,null,p):(0,n.localize)(51,null,p):d?(0,n.localize)(52,null,p):(0,n.localize)(53,null,p))}function h(g,w){const d=Math.abs(g/1e3);return d<1?w?(0,n.localize)(54,null,g):(0,n.localize)(55,null,g):d<o?w?(0,n.localize)(56,null,Math.round(g)/1e3):(0,n.localize)(57,null,Math.round(g)/1e3):d<I?w?(0,n.localize)(58,null,Math.round(g/(1e3*o))):(0,n.localize)(59,null,Math.round(g/(1e3*o))):d<k?w?(0,n.localize)(60,null,Math.round(g/(1e3*I))):(0,n.localize)(61,null,Math.round(g/(1e3*I))):(0,n.localize)(62,null,Math.round(g/(1e3*k)))}function f(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[155],ae([11,9]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(oe[55],ae([0,1,22,13,155]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=y,e.isErrorWithActions=a,e.createErrorWithActions=h,n=ke(n),o=ke(o),I=ke(I);function k(f,g){return g&&(f.stack||f.stacktrace)?I.localize(0,null,R(f),C(f.stack)||C(f.stacktrace)):R(f)}function C(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?I.localize(1,null,f.message):f.message||I.localize(2,null)}function y(f=null,g=!1){if(!f)return I.localize(3,null);if(Array.isArray(f)){const w=n.coalesce(f),d=y(w[0],g);return w.length>1?I.localize(4,null,d,w.length):d}if(o.isString(f))return f;if(f.detail){const w=f.detail;if(w.error)return k(w.error,g);if(w.exception)return k(w.exception,g)}return f.stack?k(f,g):f.message?f.message:I.localize(5,null)}function a(f){const g=f;return g instanceof Error&&Array.isArray(g.actions)}function h(f,g){let w;return typeof f=="string"?w=new Error(f):w=f,w.actions=g,w}}),define(oe[156],ae([11,9]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(oe[157],ae([0,1,156,43]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=I;function I(k){switch(k){case o.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case o.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case o.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case o.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case o.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case o.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case o.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case o.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case o.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(oe[158],ae([11,9]),function(V,e){return V.create("vs/base/common/platform",e)}),define(oe[3],ae([0,1,158]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=i,e.isLittleEndian=S,e.isBigSurOrNewer=M,n=ke(n),e.LANGUAGE_DEFAULT="en";let o=!1,I=!1,k=!1,C=!1,R=!1,y=!1,a=!1,h=!1,f=!1,g=!1,w,d=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,E,p;const m=globalThis;let b;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?b=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const D=typeof b?.versions?.electron=="string",t=D&&b?.type==="renderer";if(typeof b=="object"){o=b.platform==="win32",I=b.platform==="darwin",k=b.platform==="linux",C=k&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,a=D,f=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const T=b.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),A=L.availableLanguages["*"];w=L.locale,v=L.osLocale,d=A||e.LANGUAGE_DEFAULT,E=L._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!t?(p=navigator.userAgent,o=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,h=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=p.indexOf("Linux")>=0,g=p?.indexOf("Mobi")>=0,y=!0,w=n.getConfiguredDefaultLocale(n.localize(0,null))||e.LANGUAGE_DEFAULT,d=w,v=navigator.language):console.error("Unable to resolve platform.");var s;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(s||(e.Platform=s={}));function i(T){switch(T){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let c=s.Web;I?c=s.Mac:o?c=s.Windows:k&&(c=s.Linux),e.isWindows=o,e.isMacintosh=I,e.isLinux=k,e.isLinuxSnap=C,e.isNative=R,e.isElectron=a,e.isWeb=y,e.isWebWorker=y&&typeof m.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?m.origin:void 0,e.isIOS=h,e.isMobile=g,e.isCI=f,e.platform=c,e.userAgent=p,e.language=d;var r;(function(T){function L(){return e.language}T.value=L;function A(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}T.isDefaultVariant=A;function _(){return e.language==="en"}T.isDefault=_})(r||(e.Language=r={})),e.locale=w,e.platformLocale=v,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof m.postMessage=="function"&&!m.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const T=[];m.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let _=0,B=T.length;_<B;_++){const N=T[_];if(N.id===A.data.vscodeScheduleAsyncWork){T.splice(_,1),N.callback();return}}});let L=0;return A=>{const _=++L;T.push({id:_,callback:A}),m.postMessage({vscodeScheduleAsyncWork:_},"*")}}return T=>setTimeout(T)})();var l;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=I||h?l.Macintosh:o?l.Windows:l.Linux;let u=!0,P=!1;function S(){if(!P){P=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,u=new Uint16Array(T.buffer)[0]===513}return u}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function M(T){return parseFloat(T)>=20}}),define(oe[37],ae([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let o;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const k=I.process;o={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?o={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:o={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=o.cwd,e.env=o.env,e.platform=o.platform,e.arch=o.arch}),define(oe[10],ae([0,1,37]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,n=ke(n);const o=65,I=97,k=90,C=122,R=46,y=47,a=92,h=58,f=63;class g extends Error{constructor(i,c,r){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const u=i.indexOf(".")!==-1?"property":"argument";let P=`The "${i}" ${u} ${l} of type ${c}`;P+=`. Received type ${typeof r}`,super(P),this.code="ERR_INVALID_ARG_TYPE"}}function w(s,i){if(s===null||typeof s!="object")throw new g(i,"Object",s)}function d(s,i){if(typeof s!="string")throw new g(i,"string",s)}const v=n.platform==="win32";function E(s){return s===y||s===a}function p(s){return s===y}function m(s){return s>=o&&s<=k||s>=I&&s<=C}function b(s,i,c,r){let l="",u=0,P=-1,S=0,M=0;for(let T=0;T<=s.length;++T){if(T<s.length)M=s.charCodeAt(T);else{if(r(M))break;M=y}if(r(M)){if(!(P===T-1||S===1))if(S===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==R||l.charCodeAt(l.length-2)!==R){if(l.length>2){const L=l.lastIndexOf(c);L===-1?(l="",u=0):(l=l.slice(0,L),u=l.length-1-l.lastIndexOf(c)),P=T,S=0;continue}else if(l.length!==0){l="",u=0,P=T,S=0;continue}}i&&(l+=l.length>0?`${c}..`:"..",u=2)}else l.length>0?l+=`${c}${s.slice(P+1,T)}`:l=s.slice(P+1,T),u=T-P-1;P=T,S=0}else M===R&&S!==-1?++S:S=-1}return l}function D(s,i){w(i,"pathObject");const c=i.dir||i.root,r=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${r}`:`${c}${s}${r}`:r}e.win32={resolve(...s){let i="",c="",r=!1;for(let l=s.length-1;l>=-1;l--){let u;if(l>=0){if(u=s[l],d(u,"path"),u.length===0)continue}else i.length===0?u=n.cwd():(u=n.env[`=${i}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===a)&&(u=`${i}\\`));const P=u.length;let S=0,M="",T=!1;const L=u.charCodeAt(0);if(P===1)E(L)&&(S=1,T=!0);else if(E(L))if(T=!0,E(u.charCodeAt(1))){let A=2,_=A;for(;A<P&&!E(u.charCodeAt(A));)A++;if(A<P&&A!==_){const B=u.slice(_,A);for(_=A;A<P&&E(u.charCodeAt(A));)A++;if(A<P&&A!==_){for(_=A;A<P&&!E(u.charCodeAt(A));)A++;(A===P||A!==_)&&(M=`\\\\${B}\\${u.slice(_,A)}`,S=A)}}}else S=1;else m(L)&&u.charCodeAt(1)===h&&(M=u.slice(0,2),S=2,P>2&&E(u.charCodeAt(2))&&(T=!0,S=3));if(M.length>0)if(i.length>0){if(M.toLowerCase()!==i.toLowerCase())continue}else i=M;if(r){if(i.length>0)break}else if(c=`${u.slice(S)}\\${c}`,r=T,T&&i.length>0)break}return c=b(c,!r,"\\",E),r?`${i}\\${c}`:`${i}${c}`||"."},normalize(s){d(s,"path");const i=s.length;if(i===0)return".";let c=0,r,l=!1;const u=s.charCodeAt(0);if(i===1)return p(u)?"\\":s;if(E(u))if(l=!0,E(s.charCodeAt(1))){let S=2,M=S;for(;S<i&&!E(s.charCodeAt(S));)S++;if(S<i&&S!==M){const T=s.slice(M,S);for(M=S;S<i&&E(s.charCodeAt(S));)S++;if(S<i&&S!==M){for(M=S;S<i&&!E(s.charCodeAt(S));)S++;if(S===i)return`\\\\${T}\\${s.slice(M)}\\`;S!==M&&(r=`\\\\${T}\\${s.slice(M,S)}`,c=S)}}}else c=1;else m(u)&&s.charCodeAt(1)===h&&(r=s.slice(0,2),c=2,i>2&&E(s.charCodeAt(2))&&(l=!0,c=3));let P=c<i?b(s.slice(c),!l,"\\",E):"";return P.length===0&&!l&&(P="."),P.length>0&&E(s.charCodeAt(i-1))&&(P+="\\"),r===void 0?l?`\\${P}`:P:l?`${r}\\${P}`:`${r}${P}`},isAbsolute(s){d(s,"path");const i=s.length;if(i===0)return!1;const c=s.charCodeAt(0);return E(c)||i>2&&m(c)&&s.charCodeAt(1)===h&&E(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,c;for(let u=0;u<s.length;++u){const P=s[u];d(P,"path"),P.length>0&&(i===void 0?i=c=P:i+=`\\${P}`)}if(i===void 0)return".";let r=!0,l=0;if(typeof c=="string"&&E(c.charCodeAt(0))){++l;const u=c.length;u>1&&E(c.charCodeAt(1))&&(++l,u>2&&(E(c.charCodeAt(2))?++l:r=!1))}if(r){for(;l<i.length&&E(i.charCodeAt(l));)l++;l>=2&&(i=`\\${i.slice(l)}`)}return e.win32.normalize(i)},relative(s,i){if(d(s,"from"),d(i,"to"),s===i)return"";const c=e.win32.resolve(s),r=e.win32.resolve(i);if(c===r||(s=c.toLowerCase(),i=r.toLowerCase(),s===i))return"";let l=0;for(;l<s.length&&s.charCodeAt(l)===a;)l++;let u=s.length;for(;u-1>l&&s.charCodeAt(u-1)===a;)u--;const P=u-l;let S=0;for(;S<i.length&&i.charCodeAt(S)===a;)S++;let M=i.length;for(;M-1>S&&i.charCodeAt(M-1)===a;)M--;const T=M-S,L=P<T?P:T;let A=-1,_=0;for(;_<L;_++){const N=s.charCodeAt(l+_);if(N!==i.charCodeAt(S+_))break;N===a&&(A=_)}if(_!==L){if(A===-1)return r}else{if(T>L){if(i.charCodeAt(S+_)===a)return r.slice(S+_+1);if(_===2)return r.slice(S+_)}P>L&&(s.charCodeAt(l+_)===a?A=_:_===2&&(A=3)),A===-1&&(A=0)}let B="";for(_=l+A+1;_<=u;++_)(_===u||s.charCodeAt(_)===a)&&(B+=B.length===0?"..":"\\..");return S+=A,B.length>0?`${B}${r.slice(S,M)}`:(r.charCodeAt(S)===a&&++S,r.slice(S,M))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const i=e.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===a){if(i.charCodeAt(1)===a){const c=i.charCodeAt(2);if(c!==f&&c!==R)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===h&&i.charCodeAt(2)===a)return`\\\\?\\${i}`;return s},dirname(s){d(s,"path");const i=s.length;if(i===0)return".";let c=-1,r=0;const l=s.charCodeAt(0);if(i===1)return E(l)?s:".";if(E(l)){if(c=r=1,E(s.charCodeAt(1))){let S=2,M=S;for(;S<i&&!E(s.charCodeAt(S));)S++;if(S<i&&S!==M){for(M=S;S<i&&E(s.charCodeAt(S));)S++;if(S<i&&S!==M){for(M=S;S<i&&!E(s.charCodeAt(S));)S++;if(S===i)return s;S!==M&&(c=r=S+1)}}}}else m(l)&&s.charCodeAt(1)===h&&(c=i>2&&E(s.charCodeAt(2))?3:2,r=c);let u=-1,P=!0;for(let S=i-1;S>=r;--S)if(E(s.charCodeAt(S))){if(!P){u=S;break}}else P=!1;if(u===-1){if(c===-1)return".";u=c}return s.slice(0,u)},basename(s,i){i!==void 0&&d(i,"ext"),d(s,"path");let c=0,r=-1,l=!0,u;if(s.length>=2&&m(s.charCodeAt(0))&&s.charCodeAt(1)===h&&(c=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let P=i.length-1,S=-1;for(u=s.length-1;u>=c;--u){const M=s.charCodeAt(u);if(E(M)){if(!l){c=u+1;break}}else S===-1&&(l=!1,S=u+1),P>=0&&(M===i.charCodeAt(P)?--P===-1&&(r=u):(P=-1,r=S))}return c===r?r=S:r===-1&&(r=s.length),s.slice(c,r)}for(u=s.length-1;u>=c;--u)if(E(s.charCodeAt(u))){if(!l){c=u+1;break}}else r===-1&&(l=!1,r=u+1);return r===-1?"":s.slice(c,r)},extname(s){d(s,"path");let i=0,c=-1,r=0,l=-1,u=!0,P=0;s.length>=2&&s.charCodeAt(1)===h&&m(s.charCodeAt(0))&&(i=r=2);for(let S=s.length-1;S>=i;--S){const M=s.charCodeAt(S);if(E(M)){if(!u){r=S+1;break}continue}l===-1&&(u=!1,l=S+1),M===R?c===-1?c=S:P!==1&&(P=1):c!==-1&&(P=-1)}return c===-1||l===-1||P===0||P===1&&c===l-1&&c===r+1?"":s.slice(c,l)},format:D.bind(null,"\\"),parse(s){d(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const c=s.length;let r=0,l=s.charCodeAt(0);if(c===1)return E(l)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(E(l)){if(r=1,E(s.charCodeAt(1))){let A=2,_=A;for(;A<c&&!E(s.charCodeAt(A));)A++;if(A<c&&A!==_){for(_=A;A<c&&E(s.charCodeAt(A));)A++;if(A<c&&A!==_){for(_=A;A<c&&!E(s.charCodeAt(A));)A++;A===c?r=A:A!==_&&(r=A+1)}}}}else if(m(l)&&s.charCodeAt(1)===h){if(c<=2)return i.root=i.dir=s,i;if(r=2,E(s.charCodeAt(2))){if(c===3)return i.root=i.dir=s,i;r=3}}r>0&&(i.root=s.slice(0,r));let u=-1,P=r,S=-1,M=!0,T=s.length-1,L=0;for(;T>=r;--T){if(l=s.charCodeAt(T),E(l)){if(!M){P=T+1;break}continue}S===-1&&(M=!1,S=T+1),l===R?u===-1?u=T:L!==1&&(L=1):u!==-1&&(L=-1)}return S!==-1&&(u===-1||L===0||L===1&&u===S-1&&u===P+1?i.base=i.name=s.slice(P,S):(i.name=s.slice(P,u),i.base=s.slice(P,S),i.ext=s.slice(u,S))),P>0&&P!==r?i.dir=s.slice(0,P-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(v){const s=/\\/g;return()=>{const i=n.cwd().replace(s,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.posix={resolve(...s){let i="",c=!1;for(let r=s.length-1;r>=-1&&!c;r--){const l=r>=0?s[r]:t();d(l,"path"),l.length!==0&&(i=`${l}/${i}`,c=l.charCodeAt(0)===y)}return i=b(i,!c,"/",p),c?`/${i}`:i.length>0?i:"."},normalize(s){if(d(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===y,c=s.charCodeAt(s.length-1)===y;return s=b(s,!i,"/",p),s.length===0?i?"/":c?"./":".":(c&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return d(s,"path"),s.length>0&&s.charCodeAt(0)===y},join(...s){if(s.length===0)return".";let i;for(let c=0;c<s.length;++c){const r=s[c];d(r,"path"),r.length>0&&(i===void 0?i=r:i+=`/${r}`)}return i===void 0?".":e.posix.normalize(i)},relative(s,i){if(d(s,"from"),d(i,"to"),s===i||(s=e.posix.resolve(s),i=e.posix.resolve(i),s===i))return"";const c=1,r=s.length,l=r-c,u=1,P=i.length-u,S=l<P?l:P;let M=-1,T=0;for(;T<S;T++){const A=s.charCodeAt(c+T);if(A!==i.charCodeAt(u+T))break;A===y&&(M=T)}if(T===S)if(P>S){if(i.charCodeAt(u+T)===y)return i.slice(u+T+1);if(T===0)return i.slice(u+T)}else l>S&&(s.charCodeAt(c+T)===y?M=T:T===0&&(M=0));let L="";for(T=c+M+1;T<=r;++T)(T===r||s.charCodeAt(T)===y)&&(L+=L.length===0?"..":"/..");return`${L}${i.slice(u+M)}`},toNamespacedPath(s){return s},dirname(s){if(d(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===y;let c=-1,r=!0;for(let l=s.length-1;l>=1;--l)if(s.charCodeAt(l)===y){if(!r){c=l;break}}else r=!1;return c===-1?i?"/":".":i&&c===1?"//":s.slice(0,c)},basename(s,i){i!==void 0&&d(i,"ext"),d(s,"path");let c=0,r=-1,l=!0,u;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let P=i.length-1,S=-1;for(u=s.length-1;u>=0;--u){const M=s.charCodeAt(u);if(M===y){if(!l){c=u+1;break}}else S===-1&&(l=!1,S=u+1),P>=0&&(M===i.charCodeAt(P)?--P===-1&&(r=u):(P=-1,r=S))}return c===r?r=S:r===-1&&(r=s.length),s.slice(c,r)}for(u=s.length-1;u>=0;--u)if(s.charCodeAt(u)===y){if(!l){c=u+1;break}}else r===-1&&(l=!1,r=u+1);return r===-1?"":s.slice(c,r)},extname(s){d(s,"path");let i=-1,c=0,r=-1,l=!0,u=0;for(let P=s.length-1;P>=0;--P){const S=s.charCodeAt(P);if(S===y){if(!l){c=P+1;break}continue}r===-1&&(l=!1,r=P+1),S===R?i===-1?i=P:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||r===-1||u===0||u===1&&i===r-1&&i===c+1?"":s.slice(i,r)},format:D.bind(null,"/"),parse(s){d(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const c=s.charCodeAt(0)===y;let r;c?(i.root="/",r=1):r=0;let l=-1,u=0,P=-1,S=!0,M=s.length-1,T=0;for(;M>=r;--M){const L=s.charCodeAt(M);if(L===y){if(!S){u=M+1;break}continue}P===-1&&(S=!1,P=M+1),L===R?l===-1?l=M:T!==1&&(T=1):l!==-1&&(T=-1)}if(P!==-1){const L=u===0&&c?1:u;l===-1||T===0||T===1&&l===P-1&&l===u+1?i.base=i.name=s.slice(L,P):(i.name=s.slice(L,l),i.base=s.slice(L,P),i.ext=s.slice(l,P))}return u>0?i.dir=s.slice(0,u-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(oe[31],ae([0,1,39,10,3,26,13]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=y,e.toPosixPath=a,e.getRoot=h,e.isUNC=f,e.isValidBasename=v,e.isEqual=E,e.isEqualOrParent=p,e.isWindowsDriveLetter=m,e.sanitizeFilePath=b,e.removeTrailingPathSeparator=D,e.isRootOrDriveLetter=t,e.hasDriveLetter=s,e.getDriveLetter=i,e.indexOfPath=c,e.parseLineAndColumnAware=r,e.randomPath=P;function R(S){return S===n.CharCode.Slash||S===n.CharCode.Backslash}function y(S){return S.replace(/[\\/]/g,o.posix.sep)}function a(S){return S.indexOf("/")===-1&&(S=y(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function h(S,M=o.posix.sep){if(!S)return"";const T=S.length,L=S.charCodeAt(0);if(R(L)){if(R(S.charCodeAt(1))&&!R(S.charCodeAt(2))){let _=3;const B=_;for(;_<T&&!R(S.charCodeAt(_));_++);if(B!==_&&!R(S.charCodeAt(_+1))){for(_+=1;_<T;_++)if(R(S.charCodeAt(_)))return S.slice(0,_+1).replace(/[\\/]/g,M)}}return M}else if(m(L)&&S.charCodeAt(1)===n.CharCode.Colon)return R(S.charCodeAt(2))?S.slice(0,2)+M:S.slice(0,2);let A=S.indexOf("://");if(A!==-1){for(A+=3;A<T;A++)if(R(S.charCodeAt(A)))return S.slice(0,A+1)}return""}function f(S){if(!I.isWindows||!S||S.length<5)return!1;let M=S.charCodeAt(0);if(M!==n.CharCode.Backslash||(M=S.charCodeAt(1),M!==n.CharCode.Backslash))return!1;let T=2;const L=T;for(;T<S.length&&(M=S.charCodeAt(T),M!==n.CharCode.Backslash);T++);return!(L===T||(M=S.charCodeAt(T+1),isNaN(M)||M===n.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,w=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(S,M=I.isWindows){const T=M?g:w;return!(!S||S.length===0||/^\s+$/.test(S)||(T.lastIndex=0,T.test(S))||M&&d.test(S)||S==="."||S===".."||M&&S[S.length-1]==="."||M&&S.length!==S.trim().length||S.length>255)}function E(S,M,T){const L=S===M;return!T||L?L:!S||!M?!1:(0,k.equalsIgnoreCase)(S,M)}function p(S,M,T,L=o.sep){if(S===M)return!0;if(!S||!M||M.length>S.length)return!1;if(T){if(!(0,k.startsWithIgnoreCase)(S,M))return!1;if(M.length===S.length)return!0;let _=M.length;return M.charAt(M.length-1)===L&&_--,S.charAt(_)===L}return M.charAt(M.length-1)!==L&&(M+=L),S.indexOf(M)===0}function m(S){return S>=n.CharCode.A&&S<=n.CharCode.Z||S>=n.CharCode.a&&S<=n.CharCode.z}function b(S,M){return I.isWindows&&S.endsWith(":")&&(S+=o.sep),(0,o.isAbsolute)(S)||(S=(0,o.join)(M,S)),S=(0,o.normalize)(S),D(S)}function D(S){return I.isWindows?(S=(0,k.rtrim)(S,o.sep),S.endsWith(":")&&(S+=o.sep)):(S=(0,k.rtrim)(S,o.sep),S||(S=o.sep)),S}function t(S){const M=(0,o.normalize)(S);return I.isWindows?S.length>3?!1:s(M)&&(S.length===2||M.charCodeAt(2)===n.CharCode.Backslash):M===o.posix.sep}function s(S,M=I.isWindows){return M?m(S.charCodeAt(0))&&S.charCodeAt(1)===n.CharCode.Colon:!1}function i(S,M=I.isWindows){return s(S,M)?S[0]:void 0}function c(S,M,T){return M.length>S.length?-1:S===M?0:(T&&(S=S.toLowerCase(),M=M.toLowerCase()),S.indexOf(M))}function r(S){const M=S.split(":");let T,L,A;for(const _ of M){const B=Number(_);(0,C.isNumber)(B)?L===void 0?L=B:A===void 0&&(A=B):T=T?[T,_].join(":"):_}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:L!==void 0?L:void 0,column:A!==void 0?A:L!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(S,M,T=8){let L="";for(let _=0;_<T;_++){let B;_===0&&I.isWindows&&!M&&(T===3||T===4)?B=u:B=l,L+=B.charAt(Math.floor(Math.random()*B.length))}let A;return M?A=`${M}-${L}`:A=L,S?(0,o.join)(S,A):A}}),define(oe[82],ae([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=k,e.removeDangerousEnvVariables=C;var o;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(o||(e.Source=o={}));var I;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function k(R,...y){const a=y.reduce((g,w)=>(g[w]=!0,g),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!a[g]).forEach(g=>{for(let w=0;w<h.length;w++)if(g.search(h[w])!==-1){delete R[g];break}})}function C(R){R&&(delete R.DEBUG,n.isMacintosh&&delete R.DYLD_LIBRARY_PATH,n.isLinux&&delete R.LD_PRELOAD)}}),define(oe[7],ae([0,1,39,91,10,3]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=E,e.uriToFsPath=s,I=ke(I);const C=/^\w[\w\d+.-]*$/,R=/^\//,y=/^\/\//;function a(u,P){if(!u.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!C.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!R.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(u,P){return!u&&!P?"file":u}function f(u,P){switch(u){case"https":case"http":case"file":P?P[0]!==w&&(P=w+P):P=w;break}return P}const g="",w="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(P){return P instanceof v?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,S,M,T,L,A=!1){typeof P=="object"?(this.scheme=P.scheme||g,this.authority=P.authority||g,this.path=P.path||g,this.query=P.query||g,this.fragment=P.fragment||g):(this.scheme=h(P,A),this.authority=S||g,this.path=f(this.scheme,M||g),this.query=T||g,this.fragment=L||g,a(this,A))}get fsPath(){return s(this,!1)}with(P){if(!P)return this;let{scheme:S,authority:M,path:T,query:L,fragment:A}=P;return S===void 0?S=this.scheme:S===null&&(S=g),M===void 0?M=this.authority:M===null&&(M=g),T===void 0?T=this.path:T===null&&(T=g),L===void 0?L=this.query:L===null&&(L=g),A===void 0?A=this.fragment:A===null&&(A=g),S===this.scheme&&M===this.authority&&T===this.path&&L===this.query&&A===this.fragment?this:new m(S,M,T,L,A)}static parse(P,S=!1){const M=d.exec(P);return M?new m(M[2]||g,l(M[4]||g),l(M[5]||g),l(M[7]||g),l(M[9]||g),S):new m(g,g,g,g,g)}static file(P){let S=g;if(k.isWindows&&(P=P.replace(/\\/g,w)),P[0]===w&&P[1]===w){const M=P.indexOf(w,2);M===-1?(S=P.substring(2),P=w):(S=P.substring(2,M),P=P.substring(M)||w)}return new m("file",S,P,g,g)}static from(P,S){return new m(P.scheme,P.authority,P.path,P.query,P.fragment,S)}static joinPath(P,...S){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return k.isWindows&&P.scheme==="file"?M=v.file(I.win32.join(s(P,!0),...S)).path:M=I.posix.join(P.path,...S),P.with({path:M})}toString(P=!1){return i(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof v)return P;{const S=new m(P);return S._formatted=P.external??null,S._fsPath=P._sep===p?P.fsPath??null:null,S}}else return P}}e.URI=v;function E(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const p=k.isWindows?1:void 0;class m extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(P=!1){return P?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const P={$mid:o.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=p),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const b={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function D(u,P,S){let M,T=-1;for(let L=0;L<u.length;L++){const A=u.charCodeAt(L);if(A>=n.CharCode.a&&A<=n.CharCode.z||A>=n.CharCode.A&&A<=n.CharCode.Z||A>=n.CharCode.Digit0&&A<=n.CharCode.Digit9||A===n.CharCode.Dash||A===n.CharCode.Period||A===n.CharCode.Underline||A===n.CharCode.Tilde||P&&A===n.CharCode.Slash||S&&A===n.CharCode.OpenSquareBracket||S&&A===n.CharCode.CloseSquareBracket||S&&A===n.CharCode.Colon)T!==-1&&(M+=encodeURIComponent(u.substring(T,L)),T=-1),M!==void 0&&(M+=u.charAt(L));else{M===void 0&&(M=u.substr(0,L));const _=b[A];_!==void 0?(T!==-1&&(M+=encodeURIComponent(u.substring(T,L)),T=-1),M+=_):T===-1&&(T=L)}}return T!==-1&&(M+=encodeURIComponent(u.substring(T))),M!==void 0?M:u}function t(u){let P;for(let S=0;S<u.length;S++){const M=u.charCodeAt(S);M===n.CharCode.Hash||M===n.CharCode.QuestionMark?(P===void 0&&(P=u.substr(0,S)),P+=b[M]):P!==void 0&&(P+=u[S])}return P!==void 0?P:u}function s(u,P){let S;return u.authority&&u.path.length>1&&u.scheme==="file"?S=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?P?S=u.path.substr(1):S=u.path[1].toLowerCase()+u.path.substr(2):S=u.path,k.isWindows&&(S=S.replace(/\//g,"\\")),S}function i(u,P){const S=P?t:D;let M="",{scheme:T,authority:L,path:A,query:_,fragment:B}=u;if(T&&(M+=T,M+=":"),(L||T==="file")&&(M+=w,M+=w),L){let N=L.indexOf("@");if(N!==-1){const z=L.substr(0,N);L=L.substr(N+1),N=z.lastIndexOf(":"),N===-1?M+=S(z,!1,!1):(M+=S(z.substr(0,N),!1,!1),M+=":",M+=S(z.substr(N+1),!1,!0)),M+="@"}L=L.toLowerCase(),N=L.lastIndexOf(":"),N===-1?M+=S(L,!1,!0):(M+=S(L.substr(0,N),!1,!0),M+=L.substr(N))}if(A){if(A.length>=3&&A.charCodeAt(0)===n.CharCode.Slash&&A.charCodeAt(2)===n.CharCode.Colon){const N=A.charCodeAt(1);N>=n.CharCode.A&&N<=n.CharCode.Z&&(A=`/${String.fromCharCode(N+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===n.CharCode.Colon){const N=A.charCodeAt(0);N>=n.CharCode.A&&N<=n.CharCode.Z&&(A=`${String.fromCharCode(N+32)}:${A.substr(2)}`)}M+=S(A,!0,!1)}return _&&(M+="?",M+=S(_,!1,!1)),B&&(M+="#",M+=P?B:D(B,!1,!1)),M}function c(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+c(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(u){return u.match(r)?u.replace(r,P=>c(P)):u}}),define(oe[159],ae([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=o,e.parse=I,e.getFirstFrame=k,e.log=R;function o(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function I(a){const h=[];let f;try{const g=JSON.parse(a.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),f=w.__$stack),h.push(...g)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:f}}function k(a){if(typeof a!="string")return k(I(a).stack);const h=a;if(h){const f=C(h),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(g&&g.length===4)return{uri:n.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function C(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function R(a,h){const{args:f,stack:g}=I(a),w=typeof f[0]=="string"&&f.length===1;let d=C(g);d&&(d=`(${d.trim()})`);let v=[];if(typeof f[0]=="string"?d&&w?v=[`%c[${h}] %c${f[0]} %c${d}`,y("blue"),y(""),y("grey")]:v=[`%c[${h}] %c${f[0]}`,y("blue"),y(""),...f.slice(1)]:v=[`%c[${h}]%`,y("blue"),...f],d&&!w&&v.push(d),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,v)}function y(a){return`color: ${a}`}}),define(oe[83],ae([0,1,17,7,91]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=k,e.parse=C,e.revive=y;function k(a){return JSON.stringify(a,R)}function C(a){let h=JSON.parse(a);return h=y(h),h}function R(a,h){return h instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function y(a,h=0){if(!a||h>200)return a;if(typeof a=="object"){switch(a.$mid){case I.MarshalledId.Uri:return o.URI.revive(a);case I.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case I.MarshalledId.Date:return new Date(a.source)}if(a instanceof n.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let f=0;f<a.length;++f)a[f]=y(a[f],h+1);else for(const f in a)Object.hasOwnProperty.call(a,f)&&(a[f]=y(a[f],h+1))}return a}}),define(oe[12],ae([0,1,16,3,26,7,10]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=y,e.matchesSomeScheme=a,e.getServerRootPath=f,n=ke(n),o=ke(o),C=ke(C);var R;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(R||(e.Schemas=R={}));function y(d,v){return k.URI.isUri(d)?(0,I.equalsIgnoreCase)(d.scheme,v):(0,I.startsWithIgnoreCase)(d,v+":")}function a(d,...v){return v.some(E=>y(d,E))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class h{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v,E){this._serverRootPath=f(v,E)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return C.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(v,E,p){this._hosts[v]=E,this._ports[v]=p}setConnectionToken(v,E){this._connectionTokens[v]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)try{return this._delegate(v)}catch(t){return n.onUnexpectedError(t),v}const E=v.authority;let p=this._hosts[E];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const m=this._ports[E],b=this._connectionTokens[E];let D=`path=${encodeURIComponent(v.path)}`;return typeof b=="string"&&(D+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),k.URI.from({scheme:o.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${p}:${m}`,path:this._remoteResourcesPath,query:D})}}e.RemoteAuthorities=new h;function f(d,v){return C.posix.join(v??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(v){const E=this.toUri(v,V);return this.uriToBrowserUri(E)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(v):v.scheme===R.file&&(o.isNative||o.webWorkerOrigin===`${R.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(v){const E=this.toUri(v,V);return this.uriToFileUri(E)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==g.FALLBACK_AUTHORITY?v.authority:null,query:null,fragment:null}):v}toUri(v,E){return k.URI.isUri(v)?v:k.URI.parse(E.toUrl(v))}}e.FileAccess=new g;var w;(function(d){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(v.get("3"));const E="vscode-coi";function p(b){let D;typeof b=="string"?D=new URL(b).searchParams:b instanceof URL?D=b.searchParams:k.URI.isUri(b)&&(D=new URL(b.toString(!0)).searchParams);const t=D?.get(E);if(t)return v.get(t)}d.getHeadersFromQuery=p;function m(b,D,t){if(!globalThis.crossOriginIsolated)return;const s=D&&t?"3":t?"2":"1";b instanceof URLSearchParams?b.set(E,s):b[E]=s}d.addSearchParam=m})(w||(e.COI=w={}))}),define(oe[19],ae([0,1,39,31,12,10,3,26,7]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=a,e.distinctParents=f,e.toLocalResource=w,o=ke(o),k=ke(k);function a(d){return(0,y.uriToFsPath)(d,!0)}class h{constructor(v){this._ignorePathCasing=v}compare(v,E,p=!1){return v===E?0:(0,R.compare)(this.getComparisonKey(v,p),this.getComparisonKey(E,p))}isEqual(v,E,p=!1){return v===E?!0:!v||!E?!1:this.getComparisonKey(v,p)===this.getComparisonKey(E,p)}getComparisonKey(v,E=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,E,p=!1){if(v.scheme===E.scheme){if(v.scheme===I.Schemas.file)return o.isEqualOrParent(a(v),a(E),this._ignorePathCasing(v))&&v.query===E.query&&(p||v.fragment===E.fragment);if((0,e.isEqualAuthority)(v.authority,E.authority))return o.isEqualOrParent(v.path,E.path,this._ignorePathCasing(v),"/")&&v.query===E.query&&(p||v.fragment===E.fragment)}return!1}joinPath(v,...E){return y.URI.joinPath(v,...E)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let E;return v.scheme===I.Schemas.file?E=y.URI.file(k.dirname(a(v))).path:(E=k.posix.dirname(v.path),v.authority&&E.length&&E.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${v.toString})) resulted in a relative path`),E="/")),v.with({path:E})}normalizePath(v){if(!v.path.length)return v;let E;return v.scheme===I.Schemas.file?E=y.URI.file(k.normalize(a(v))).path:E=k.posix.normalize(v.path),v.with({path:E})}relativePath(v,E){if(v.scheme!==E.scheme||!(0,e.isEqualAuthority)(v.authority,E.authority))return;if(v.scheme===I.Schemas.file){const b=k.relative(a(v),a(E));return C.isWindows?o.toSlashes(b):b}let p=v.path||"/";const m=E.path||"/";if(this._ignorePathCasing(v)){let b=0;for(const D=Math.min(p.length,m.length);b<D&&!(p.charCodeAt(b)!==m.charCodeAt(b)&&p.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);p=m.substr(0,b)+p.substr(b)}return k.posix.relative(p,m)}resolvePath(v,E){if(v.scheme===I.Schemas.file){const p=y.URI.file(k.resolve(a(v),E));return v.with({authority:p.authority,path:p.path})}return E=o.toPosixPath(E),v.with({path:k.posix.resolve(v.path,E)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,E){return v===E||v!==void 0&&E!==void 0&&(0,R.equalsIgnoreCase)(v,E)}hasTrailingPathSeparator(v,E=k.sep){if(v.scheme===I.Schemas.file){const p=a(v);return p.length>o.getRoot(p).length&&p[p.length-1]===E}else{const p=v.path;return p.length>1&&p.charCodeAt(p.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,E=k.sep){return(0,e.hasTrailingPathSeparator)(v,E)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,E=k.sep){let p=!1;if(v.scheme===I.Schemas.file){const m=a(v);p=m!==void 0&&m.length===o.getRoot(m).length&&m[m.length-1]===E}else{E="/";const m=v.path;p=m.length===1&&m.charCodeAt(m.length-1)===n.CharCode.Slash}return!p&&!(0,e.hasTrailingPathSeparator)(v,E)?v.with({path:v.path+"/"}):v}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(d=>d.scheme===I.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new h(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function f(d,v){const E=[];for(let p=0;p<d.length;p++){const m=v(d[p]);d.some((b,D)=>D===p?!1:(0,e.isEqualOrParent)(m,v(b)))||E.push(d[p])}return E}var g;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function v(E){const p=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(D=>{const[t,s]=D.split(":");t&&s&&p.set(t,s)});const b=E.path.substring(0,E.path.indexOf(";"));return b&&p.set(d.META_DATA_MIME,b),p}d.parseMetaData=v})(g||(e.DataUri=g={}));function w(d,v,E){if(v){let p=d.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),d.with({scheme:E,authority:v,path:p})}return d.with({scheme:E})}}),define(oe[8],ae([0,1,23,16,4,2,19,3,146,66]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=h,e.createCancelablePromise=f,e.raceCancellation=g,e.raceCancellationError=w,e.raceCancellablePromises=d,e.raceTimeout=v,e.asPromise=E,e.promiseWithResolvers=p,e.timeout=u,e.disposableTimeout=P,e.sequence=S,e.first=M,e.firstParallel=T,e.retry=O,e.createCancelableAsyncIterable=H;function h(Q){return!!Q&&typeof Q.then=="function"}function f(Q){const $=new n.CancellationTokenSource,ie=Q($.token),fe=new Promise((me,we)=>{const Ce=$.token.onCancellationRequested(()=>{Ce.dispose(),we(new o.CancellationError)});Promise.resolve(ie).then(Ie=>{Ce.dispose(),$.dispose(),me(Ie)},Ie=>{Ce.dispose(),$.dispose(),we(Ie)})});return new class{cancel(){$.cancel(),$.dispose()}then(me,we){return fe.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return fe.finally(me)}}}function g(Q,$,ie){return new Promise((fe,me)=>{const we=$.onCancellationRequested(()=>{we.dispose(),fe(ie)});Q.then(fe,me).finally(()=>we.dispose())})}function w(Q,$){return new Promise((ie,fe)=>{const me=$.onCancellationRequested(()=>{me.dispose(),fe(new o.CancellationError)});Q.then(ie,fe).finally(()=>me.dispose())})}async function d(Q){let $=-1;const ie=Q.map((fe,me)=>fe.then(we=>($=me,we)));try{return await Promise.race(ie)}finally{Q.forEach((fe,me)=>{me!==$&&fe.cancel()})}}function v(Q,$,ie){let fe;const me=setTimeout(()=>{fe?.(void 0),ie?.()},$);return Promise.race([Q.finally(()=>clearTimeout(me)),new Promise(we=>fe=we)])}function E(Q){return new Promise(($,ie)=>{const fe=Q();h(fe)?fe.then($,ie):$(fe)})}function p(){let Q,$;return{promise:new Promise((fe,me)=>{Q=fe,$=me}),resolve:Q,reject:$}}class m{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ie,ie).then(fe)})}return new Promise((ie,fe)=>{this.queuedPromise.then(ie,fe)})}return this.activePromise=$(),new Promise((ie,fe)=>{this.activePromise.then(me=>{this.activePromise=null,ie(me)},me=>{this.activePromise=null,fe(me)})})}dispose(){this.isDisposed=!0}}e.Throttler=m;class b{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=b;class D{constructor(){this.promiseMap=new Map}queue($,ie){const me=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get($)===me&&this.promiseMap.delete($)});return this.promiseMap.set($,me),me}}e.SequencerByKey=D;const t=(Q,$)=>{let ie=!0;const fe=setTimeout(()=>{ie=!1,$()},Q);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(fe),ie=!1}}},s=Q=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,Q())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class i{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,ie=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((me,we)=>{this.doResolve=me,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const me=this.task;return this.task=null,me()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===y.MicrotaskDelay?s(fe):t(ie,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new o.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class c{constructor($){this.delayer=new i($),this.throttler=new m}trigger($,ie){return this.delayer.trigger(()=>this.throttler.queue($),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=c;class r{constructor(){this._isOpen=!1,this._promise=new Promise(($,ie)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class l extends r{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function u(Q,$){return $?new Promise((ie,fe)=>{const me=setTimeout(()=>{we.dispose(),ie()},Q),we=$.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),fe(new o.CancellationError)})}):f(ie=>u(Q,ie))}function P(Q,$=0,ie){const fe=setTimeout(()=>{Q(),ie&&me.dispose()},$),me=(0,k.toDisposable)(()=>{clearTimeout(fe),ie?.deleteAndLeak(me)});return ie?.add(me),me}function S(Q){const $=[];let ie=0;const fe=Q.length;function me(){return ie<fe?Q[ie++]():null}function we(Ce){Ce!=null&&$.push(Ce);const Ie=me();return Ie?Ie.then(we):Promise.resolve($)}return Promise.resolve(null).then(we)}function M(Q,$=fe=>!!fe,ie=null){let fe=0;const me=Q.length,we=()=>{if(fe>=me)return Promise.resolve(ie);const Ce=Q[fe++];return Promise.resolve(Ce()).then(De=>$(De)?Promise.resolve(De):we())};return we()}function T(Q,$=fe=>!!fe,ie=null){if(Q.length===0)return Promise.resolve(ie);let fe=Q.length;const me=()=>{fe=-1;for(const we of Q)we.cancel?.()};return new Promise((we,Ce)=>{for(const Ie of Q)Ie.then(De=>{--fe>=0&&$(De)?(me(),we(De)):fe===0&&we(ie)}).catch(De=>{--fe>=0&&(me(),Ce(De))})})}class L{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ie,fe)=>{this.outstandingPromises.push({factory:$,c:ie,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const ie=$.factory();ie.then($.c,$.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=L;class A extends L{constructor(){super(1)}}e.Queue=A;class _{constructor(){this.sequentializer=new x,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=_;class B{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new G;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,ie=C.extUri){const fe=ie.getComparisonKey($);return this.queues.get(fe)?.size??0}queueFor($,ie,fe=C.extUri){const me=fe.getComparisonKey($);let we=this.queues.get(me);if(!we){we=new A;const Ce=this.drainListenerCount++,Ie=I.Event.once(we.onDrained)(()=>{we?.dispose(),this.queues.delete(me),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ce),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new k.DisposableMap),this.drainListeners.set(Ce,Ie),this.queues.set(me,we)}return we.queue(ie)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=B;class N{constructor($,ie){this._isDisposed=!1,this._token=-1,typeof $=="function"&&typeof ie=="number"&&this.setIfNotSet($,ie)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,ie){if(this._isDisposed)throw new o.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},ie)}setIfNotSet($,ie){if(this._isDisposed)throw new o.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},ie))}}e.TimeoutTimer=N;class z{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,ie,fe=globalThis){if(this.isDisposed)throw new o.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=fe.setInterval(()=>{$()},ie);this.disposable=(0,k.toDisposable)(()=>{fe.clearInterval(me),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=z;class se{constructor($,ie){this.timeoutToken=-1,this.runner=$,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class J{constructor($,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=J;class le extends se{constructor($,ie){super($,ie),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class K extends k.Disposable{constructor($,ie){super(),this.options=$,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of $)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Q,$)=>{(0,R.setTimeout0)(()=>{if(ie)return;const fe=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(Q,$,ie)=>{const fe=Q.requestIdleCallback($,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,Q.cancelIdleCallback(fe))}}},e.runWhenGlobalIdle=Q=>(0,e._runWhenIdle)(globalThis,Q)}();class ee{constructor($,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(fe){this._error=fe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class q extends ee{constructor($){super(globalThis,$)}}e.GlobalIdleValue=q;async function O(Q,$,ie){let fe;for(let me=0;me<ie;me++)try{return await Q()}catch(we){fe=we,await u($)}throw fe}class x{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,ie,fe){return this._running={taskId:$,cancel:()=>fe?.(),promise:ie},ie.then(()=>this.doneRunning($),()=>this.doneRunning($)),ie}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{const{promise:ie,resolve:fe,reject:me}=p();this._queued={run:$,promise:ie,promiseResolve:fe,promiseReject:me}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=x;class j{constructor($,ie=()=>Date.now()){this.interval=$,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=j;var ce;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ce||(ce={}));class G{get isRejected(){return this.outcome?.outcome===ce.Rejected}get isResolved(){return this.outcome?.outcome===ce.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ce.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,ie)=>{this.completeCallback=$,this.errorCallback=ie})}complete($){return new Promise(ie=>{this.completeCallback($),this.outcome={outcome:ce.Resolved,value:$},ie()})}error($){return new Promise(ie=>{this.errorCallback($),this.outcome={outcome:ce.Rejected,value:$},ie()})}cancel(){return this.error(new o.CancellationError)}}e.DeferredPromise=G;var de;(function(Q){async function $(fe){let me;const we=await Promise.all(fe.map(Ce=>Ce.then(Ie=>Ie,Ie=>{me||(me=Ie)})));if(typeof me<"u")throw me;return we}Q.settled=$;function ie(fe){return new Promise(async(me,we)=>{try{await fe(me,we)}catch(Ce){we(Ce)}})}Q.withAsyncBody=ie})(de||(e.Promises=de={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new o.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class Z{constructor($){this._compute=$,this._promise=new a.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Z;var W;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(W||(W={}));class F{static fromArray($){return new F(ie=>{ie.emitMany($)})}static fromPromise($){return new F(async ie=>{ie.emitMany(await $)})}static fromPromises($){return new F(async ie=>{await Promise.all($.map(async fe=>ie.emitOne(await fe)))})}static merge($){return new F(async ie=>{await Promise.all($.map(async fe=>{for await(const me of fe)ie.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor($,ie){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=ie,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const fe={emitOne:me=>this.emitOne(me),emitMany:me=>this.emitMany(me),reject:me=>this.reject(me)};try{await Promise.resolve($(fe)),this.resolve()}catch(me){this.reject(me)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map($,ie){return new F(async fe=>{for await(const me of $)fe.emitOne(ie(me))})}map($){return F.map(this,$)}static filter($,ie){return new F(async fe=>{for await(const me of $)ie(me)&&fe.emitOne(me)})}filter($){return F.filter(this,$)}static coalesce($){return F.filter($,ie=>!!ie)}coalesce(){return F.coalesce(this)}static async toPromise($){const ie=[];for await(const fe of $)ie.push(fe);return ie}toPromise(){return F.toPromise(this)}emitOne($){this._state===W.Initial&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===W.Initial&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject($){this._state===W.Initial&&(this._state=W.DoneError,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=F;class U extends F{constructor($,ie){super(ie),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=U;function H(Q){const $=new n.CancellationTokenSource,ie=Q($.token);return new U($,async fe=>{const me=$.token.onCancellationRequested(()=>{me.dispose(),$.dispose(),fe.reject(new o.CancellationError)});try{for await(const we of ie){if($.token.isCancellationRequested)return;fe.emitOne(we)}me.dispose(),$.dispose()}catch(we){me.dispose(),$.dispose(),fe.reject(we)}})}class Y{constructor($){this._deferred=new G,this._asyncIterable=new F(me=>{if(ie){me.reject(ie);return}return fe&&me.emitMany(fe),this._errorFn=we=>me.reject(we),this._emitFn=we=>me.emitOne(we),this._deferred.p},$);let ie,fe;this._emitFn=me=>{fe||(fe=[]),fe.push(me)},this._errorFn=me=>{ie||(ie=me)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=Y}),define(oe[113],ae([0,1,22,8,39,31,32,10,3,26]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=h,e.splitGlobAware=v,e.match=_,e.parse=B,e.isRelativePattern=N,e.getBasenameTerms=z,e.getPathTerms=se,e.patternsEquals=ee;function h(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const f="[/\\\\]",g="[^/\\\\]",w=/\//g;function d(q,O){switch(q){case 0:return"";case 1:return`${g}*?`;default:return`(?:${f}|${g}+${f}${O?`|${f}${g}+`:""})*?`}}function v(q,O){if(!q)return[];const x=[];let j=!1,ce=!1,G="";for(const de of q){switch(de){case O:if(!j&&!ce){x.push(G),G="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}G+=de}return G&&x.push(G),x}function E(q){if(!q)return"";let O="";const x=v(q,e.GLOB_SPLIT);if(x.every(j=>j===e.GLOBSTAR))O=".*";else{let j=!1;x.forEach((ce,G)=>{if(ce===e.GLOBSTAR){if(j)return;O+=d(2,G===x.length-1)}else{let de=!1,re="",Z=!1,W="";for(const F of ce){if(F!=="}"&&de){re+=F;continue}if(Z&&(F!=="]"||!W)){let U;F==="-"?U=F:(F==="^"||F==="!")&&!W?U="^":F===e.GLOB_SPLIT?U="":U=(0,a.escapeRegExpCharacters)(F),W+=U;continue}switch(F){case"{":de=!0;continue;case"[":Z=!0;continue;case"}":{const H=`(?:${v(re,",").map(Y=>E(Y)).join("|")})`;O+=H,de=!1,re="";break}case"]":{O+="["+W+"]",Z=!1,W="";break}case"?":O+=g;continue;case"*":O+=d(1);continue;default:O+=(0,a.escapeRegExpCharacters)(F)}}G<x.length-1&&(x[G+1]!==e.GLOBSTAR||G+2<x.length)&&(O+=f)}j=ce===e.GLOBSTAR})}return O}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,D=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new C.LRUCache(1e4),c=function(){return!1},r=function(){return null};function l(q,O){if(!q)return r;let x;typeof q!="string"?x=q.pattern:x=q,x=x.trim();const j=`${x}_${!!O.trimForExclusions}`;let ce=i.get(j);if(ce)return u(ce,q);let G;return p.test(x)?ce=S(x.substr(4),x):(G=m.exec(P(x,O)))?ce=M(G[1],x):(O.trimForExclusions?D:b).test(x)?ce=T(x,O):(G=t.exec(P(x,O)))?ce=L(G[1].substr(1),x,!0):(G=s.exec(P(x,O)))?ce=L(G[1],x,!1):ce=A(x),i.set(j,ce),u(ce,q)}function u(q,O){if(typeof O=="string")return q;const x=function(j,ce){return(0,k.isEqualOrParent)(j,O.base,!y.isLinux)?q((0,a.ltrim)(j.substr(O.base.length),R.sep),ce):null};return x.allBasenames=q.allBasenames,x.allPaths=q.allPaths,x.basenames=q.basenames,x.patterns=q.patterns,x}function P(q,O){return O.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function S(q,O){return function(x,j){return typeof x=="string"&&x.endsWith(q)?O:null}}function M(q,O){const x=`/${q}`,j=`\\${q}`,ce=function(de,re){return typeof de!="string"?null:re?re===q?O:null:de===q||de.endsWith(x)||de.endsWith(j)?O:null},G=[q];return ce.basenames=G,ce.patterns=[O],ce.allBasenames=G,ce}function T(q,O){const x=K(q.slice(1,-1).split(",").map(re=>l(re,O)).filter(re=>re!==r),q),j=x.length;if(!j)return r;if(j===1)return x[0];const ce=function(re,Z){for(let W=0,F=x.length;W<F;W++)if(x[W](re,Z))return q;return null},G=x.find(re=>!!re.allBasenames);G&&(ce.allBasenames=G.allBasenames);const de=x.reduce((re,Z)=>Z.allPaths?re.concat(Z.allPaths):re,[]);return de.length&&(ce.allPaths=de),ce}function L(q,O,x){const j=R.sep===R.posix.sep,ce=j?q:q.replace(w,R.sep),G=R.sep+ce,de=R.posix.sep+q;let re;return x?re=function(Z,W){return typeof Z=="string"&&(Z===ce||Z.endsWith(G)||!j&&(Z===q||Z.endsWith(de)))?O:null}:re=function(Z,W){return typeof Z=="string"&&(Z===ce||!j&&Z===q)?O:null},re.allPaths=[(x?"*/":"./")+q],re}function A(q){try{const O=new RegExp(`^${E(q)}$`);return function(x){return O.lastIndex=0,typeof x=="string"&&O.test(x)?q:null}}catch{return r}}function _(q,O,x){return!q||typeof O!="string"?!1:B(q)(O,void 0,x)}function B(q,O={}){if(!q)return c;if(typeof q=="string"||N(q)){const x=l(q,O);if(x===r)return c;const j=function(ce,G){return!!x(ce,G)};return x.allBasenames&&(j.allBasenames=x.allBasenames),x.allPaths&&(j.allPaths=x.allPaths),j}return J(q,O)}function N(q){const O=q;return O?typeof O.base=="string"&&typeof O.pattern=="string":!1}function z(q){return q.allBasenames||[]}function se(q){return q.allPaths||[]}function J(q,O){const x=K(Object.getOwnPropertyNames(q).map(re=>le(re,q[re],O)).filter(re=>re!==r)),j=x.length;if(!j)return r;if(!x.some(re=>!!re.requiresSiblings)){if(j===1)return x[0];const re=function(F,U){let H;for(let Y=0,Q=x.length;Y<Q;Y++){const $=x[Y](F,U);if(typeof $=="string")return $;(0,o.isThenable)($)&&(H||(H=[]),H.push($))}return H?(async()=>{for(const Y of H){const Q=await Y;if(typeof Q=="string")return Q}return null})():null},Z=x.find(F=>!!F.allBasenames);Z&&(re.allBasenames=Z.allBasenames);const W=x.reduce((F,U)=>U.allPaths?F.concat(U.allPaths):F,[]);return W.length&&(re.allPaths=W),re}const ce=function(re,Z,W){let F,U;for(let H=0,Y=x.length;H<Y;H++){const Q=x[H];Q.requiresSiblings&&W&&(Z||(Z=(0,R.basename)(re)),F||(F=Z.substr(0,Z.length-(0,R.extname)(re).length)));const $=Q(re,Z,F,W);if(typeof $=="string")return $;(0,o.isThenable)($)&&(U||(U=[]),U.push($))}return U?(async()=>{for(const H of U){const Y=await H;if(typeof Y=="string")return Y}return null})():null},G=x.find(re=>!!re.allBasenames);G&&(ce.allBasenames=G.allBasenames);const de=x.reduce((re,Z)=>Z.allPaths?re.concat(Z.allPaths):re,[]);return de.length&&(ce.allPaths=de),ce}function le(q,O,x){if(O===!1)return r;const j=l(q,x);if(j===r)return r;if(typeof O=="boolean")return j;if(O){const ce=O.when;if(typeof ce=="string"){const G=(de,re,Z,W)=>{if(!W||!j(de,re))return null;const F=ce.replace("$(basename)",()=>Z),U=W(F);return(0,o.isThenable)(U)?U.then(H=>H?q:null):U?q:null};return G.requiresSiblings=!0,G}}return j}function K(q,O){const x=q.filter(re=>!!re.basenames);if(x.length<2)return q;const j=x.reduce((re,Z)=>{const W=Z.basenames;return W?re.concat(W):re},[]);let ce;if(O){ce=[];for(let re=0,Z=j.length;re<Z;re++)ce.push(O)}else ce=x.reduce((re,Z)=>{const W=Z.patterns;return W?re.concat(W):re},[]);const G=function(re,Z){if(typeof re!="string")return null;if(!Z){let F;for(F=re.length;F>0;F--){const U=re.charCodeAt(F-1);if(U===I.CharCode.Slash||U===I.CharCode.Backslash)break}Z=re.substr(F)}const W=j.indexOf(Z);return W!==-1?ce[W]:null};G.basenames=j,G.patterns=ce,G.allBasenames=j;const de=q.filter(re=>!re.basenames);return de.push(G),de}function ee(q,O){return(0,n.equals)(q,O,(x,j)=>typeof x=="string"&&typeof j=="string"?x===j:typeof x!="string"&&typeof j!="string"?x.base===j.base&&x.pattern===j.pattern:!1)}}),define(oe[48],ae([0,1,22,31,10,3,19,26]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=y,e.normalizeDriveLetter=h,e.tildify=g,e.untildify=w,e.shorten=p,e.template=b,e.mnemonicMenuLabel=D,e.mnemonicButtonLabel=t,e.unmnemonicLabel=s,e.splitRecentLabel=i;function y(r,l){const{os:u,tildify:P,relative:S}=l;if(S){const L=a(r,S,u);if(typeof L=="string")return L}let M=r.fsPath;if(u===k.OperatingSystem.Windows&&!k.isWindows?M=M.replace(/\//g,"\\"):u!==k.OperatingSystem.Windows&&k.isWindows&&(M=M.replace(/\\/g,"/")),u!==k.OperatingSystem.Windows&&P?.userHome){const L=P.userHome.fsPath;let A;r.scheme!==P.userHome.scheme&&r.path[0]===I.posix.sep&&r.path[1]!==I.posix.sep?A=P.userHome.with({path:r.path}).fsPath:A=M,M=g(A,L,u)}return(u===k.OperatingSystem.Windows?I.win32:I.posix).normalize(h(M,u===k.OperatingSystem.Windows))}function a(r,l,u){const P=u===k.OperatingSystem.Windows?I.win32:I.posix,S=u===k.OperatingSystem.Linux?C.extUri:C.extUriIgnorePathCase,M=l.getWorkspace(),T=(0,n.firstOrDefault)(M.folders);if(!T)return;r.scheme!==T.uri.scheme&&r.path[0]===I.posix.sep&&r.path[1]!==I.posix.sep&&(r=T.uri.with({path:r.path}));const L=l.getWorkspaceFolder(r);if(!L)return;let A;if(S.isEqual(L.uri,r)?A="":A=S.relativePath(L.uri,r)??"",A&&(A=P.normalize(A)),M.folders.length>1&&!l.noPrefix){const _=L.name?L.name:S.basenameOrAuthority(L.uri);A=A?`${_} \u2022 ${A}`:_}return A}function h(r,l=k.isWindows){return(0,o.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}let f=Object.create(null);function g(r,l,u=k.OS){if(u===k.OperatingSystem.Windows||!r||!l)return r;let P=f.original===l?f.normalized:void 0;P||(P=l,k.isWindows&&(P=(0,o.toSlashes)(P)),P=`${(0,R.rtrim)(P,I.posix.sep)}${I.posix.sep}`,f={original:l,normalized:P});let S=r;return k.isWindows&&(S=(0,o.toSlashes)(S)),(u===k.OperatingSystem.Linux?S.startsWith(P):(0,R.startsWithIgnoreCase)(S,P))?`~/${S.substr(P.length)}`:r}function w(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}const d="\u2026",v="\\\\",E="~";function p(r,l=I.sep){const u=new Array(r.length);let P=!1;for(let S=0;S<r.length;S++){const M=r[S];if(M===""){u[S]=`.${l}`;continue}if(!M){u[S]=M;continue}P=!0;let T="",L=M;L.indexOf(v)===0?(T=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(l)===0?(T=L.substr(0,L.indexOf(l)+l.length),L=L.substr(L.indexOf(l)+l.length)):L.indexOf(E)===0&&(T=L.substr(0,L.indexOf(E)+E.length),L=L.substr(L.indexOf(E)+E.length));const A=L.split(l);for(let _=1;P&&_<=A.length;_++)for(let B=A.length-_;P&&B>=0;B--){P=!1;let N=A.slice(B,B+_).join(l);for(let z=0;!P&&z<r.length;z++)if(z!==S&&r[z]&&r[z].indexOf(N)>-1){const se=B+_===A.length,J=B>0&&r[z].indexOf(l)>-1?l+N:N,le=r[z].endsWith(J);P=!se||le}if(!P){let z="";(A[0].endsWith(":")||T!=="")&&(B===1&&(B=0,_++,N=A[0]+l+N),B>0&&(z=A[0]+l),z=T+z),B>0&&(z=z+d+l),z=z+N,B+_<A.length&&(z=z+l+d),u[S]=z}}P&&(u[S]=M)}return u}var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function b(r,l=Object.create(null)){const u=[];let P=!1,S="";for(const M of r)if(M==="$"||P&&M==="{")S&&u.push({value:S,type:m.TEXT}),S="",P=!0;else if(M==="}"&&P){const T=l[S];if(typeof T=="string")T.length&&u.push({value:T,type:m.VARIABLE});else if(T){const L=u[u.length-1];(!L||L.type!==m.SEPARATOR)&&u.push({value:T.label,type:m.SEPARATOR})}S="",P=!1}else S+=M;return S&&!P&&u.push({value:S,type:m.TEXT}),u.filter((M,T)=>{if(M.type===m.SEPARATOR){const L=u[T-1],A=u[T+1];return[L,A].every(_=>_&&(_.type===m.VARIABLE||_.type===m.TEXT)&&_.value.length>0)}return!0}).map(M=>M.value).join("")}function D(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function t(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,u=>u==="&"?"&&":"&"):r.replace(/&&/g,"_")}function s(r){return r.replace(/&/g,"&&")}function i(r){if(r.endsWith("]")){const l=r.lastIndexOf(" [",r.length-2);if(l!==-1){const u=c(r.substring(0,l)),P=r.substring(l);return{name:u.name+P,parentPath:u.parentPath}}}return c(r)}function c(r){const l=r.indexOf("/")!==-1?I.posix:I.win32,u=l.basename(r),P=l.dirname(r);return u.length?{name:u,parentPath:P}:{name:P,parentPath:""}}}),define(oe[160],ae([0,1,17,91,7]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=y,e.transformIncomingURIs=h,e.transformAndReviveIncomingURIs=f;function k(g){return g.toJSON()}class C{constructor(w){this._uriTransformer=w}transformIncoming(w){const d=this._uriTransformer.transformIncoming(w);return d===w?w:k(I.URI.from(d))}transformOutgoing(w){const d=this._uriTransformer.transformOutgoing(w);return d===w?w:k(I.URI.from(d))}transformOutgoingURI(w){const d=this._uriTransformer.transformOutgoing(w);return d===w?w:I.URI.from(d)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function R(g,w,d){if(!g||d>200)return null;if(typeof g=="object"){if(g instanceof I.URI)return w.transformOutgoing(g);for(const v in g)if(Object.hasOwnProperty.call(g,v)){const E=R(g[v],w,d+1);E!==null&&(g[v]=E)}}return null}function y(g,w){const d=R(g,w,0);return d===null?g:d}function a(g,w,d,v){if(!g||v>200)return null;if(typeof g=="object"){if(g.$mid===o.MarshalledId.Uri)return d?I.URI.revive(w.transformIncoming(g)):w.transformIncoming(g);if(g instanceof n.VSBuffer)return null;for(const E in g)if(Object.hasOwnProperty.call(g,E)){const p=a(g[E],w,d,v+1);p!==null&&(g[E]=p)}}return null}function h(g,w){const d=a(g,w,!1,0);return d===null?g:d}function f(g,w){const d=a(g,w,!0,0);return d===null?g:d}}),define(oe[94],ae([0,1,27,61,33,150,3]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=y,e.getSqmMachineId=f,e.getdevDeviceId=g,I=ke(I),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(w){return this._virtualMachineOUIs||(this._virtualMachineOUIs=o.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(w)}value(){if(this._value===void 0){let w=0,d=0;const v=(0,n.networkInterfaces)();for(const E in v){const p=v[E];if(p)for(const{mac:m,internal:b}of p)b||(d+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(w+=1))}this._value=d>0?w/d:0}return this._value}};let R;async function y(w){return R||(R=(async()=>await a(w)||I.generateUuid())()),R}async function a(w){try{const d=await new Promise((E,p)=>{V(["crypto"],E,p)}).then(ke),v=(0,k.getMac)();return d.createHash("sha256").update(v,"utf8").digest("hex")}catch(d){w(d);return}}const h="Software\\Microsoft\\SQMClient";async function f(w){if(C.isWindows){const d=await new Promise((v,E)=>{V(["@vscode/windows-registry"],v,E)}).then(ke);try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(v){return w(v),""}}return""}async function g(w){try{return await(await new Promise((E,p)=>{V(["@vscode/deviceid"],E,p)}).then(ke)).getDeviceId()}catch(d){return w(d),""}}}),define(oe[21],ae([0,1,47,27,161,8,31,79,10,3,19,7]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=b,e.whenDeleted=s,e.configureFlushOnWrite=u,e.writeFileSync=S,n=ke(n);var g;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function w(J,le=g.UNLINK,K){if((0,C.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");return le===g.UNLINK?v(J):d(J,K)}async function d(J,le=(0,C.randomPath)((0,o.tmpdir)())){try{try{await n.promises.rename(J,le)}catch(K){return K.code==="ENOENT"?void 0:v(J)}v(le).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function v(J){return n.promises.rm(J,{recursive:!0,force:!0,maxRetries:3})}function E(J){if((0,C.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}async function p(J,le){return D(await(le?m(J):n.promises.readdir(J)))}async function m(J){try{return await n.promises.readdir(J,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const le=[],K=await p(J);for(const ee of K){let q=!1,O=!1,x=!1;try{const j=await e.Promises.lstat((0,y.join)(J,ee));q=j.isFile(),O=j.isDirectory(),x=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}le.push({name:ee,isFile:()=>q,isDirectory:()=>O,isSymbolicLink:()=>x})}return le}function b(J){return D(n.readdirSync(J))}function D(J){return J.map(le=>typeof le=="string"?a.isMacintosh?(0,R.normalizeNFC)(le):le:(le.name=a.isMacintosh?(0,R.normalizeNFC)(le.name):le.name,le))}async function t(J){const le=await p(J),K=[];for(const ee of le)await i.existsDirectory((0,y.join)(J,ee))&&K.push(ee);return K}function s(J,le=1e3){return new Promise(K=>{let ee=!1;const q=setInterval(()=>{ee||(ee=!0,n.access(J,O=>{ee=!1,O&&(clearInterval(q),K(void 0))}))},le)})}var i;(function(J){async function le(q){let O;try{if(O=await e.Promises.lstat(q),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(a.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw x}}J.stat=le;async function K(q){try{const{stat:O,symbolicLink:x}=await J.stat(q);return O.isFile()&&x?.dangling!==!0}catch{}return!1}J.existsFile=K;async function ee(q){try{const{stat:O,symbolicLink:x}=await J.stat(q);return O.isDirectory()&&x?.dangling!==!0}catch{}return!1}J.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const c=new k.ResourceQueue;function r(J,le,K){return c.queueFor(f.URI.file(J),()=>{const ee=M(K);return new Promise((q,O)=>P(J,le,ee,x=>x?O(x):q()))},h.extUriBiasedIgnorePathCase)}let l=!0;function u(J){l=J}function P(J,le,K,ee){if(!l)return n.writeFile(J,le,{mode:K.mode,flag:K.flag},ee);n.open(J,K.flag,K.mode,(q,O)=>{if(q)return ee(q);n.writeFile(O,le,x=>{if(x)return n.close(O,()=>ee(x));n.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),u(!1)),n.close(O,ce=>ee(ce))))})})}function S(J,le,K){const ee=M(K);if(!l)return n.writeFileSync(J,le,{mode:ee.mode,flag:ee.flag});const q=n.openSync(J,ee.flag,ee.mode);try{n.writeFileSync(q,le);try{n.fdatasyncSync(q)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),u(!1)}}finally{n.closeSync(q)}}function M(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function T(J,le,K=6e4){if(J!==le)try{a.isWindows&&typeof K=="number"?await L(J,le,Date.now(),K):await n.promises.rename(J,le)}catch(ee){if(J.toLowerCase()!==le.toLowerCase()&&ee.code==="EXDEV"||J.endsWith("."))await A(J,le,{preserveSymlinks:!1}),await w(J,g.MOVE);else throw ee}}async function L(J,le,K,ee,q=0){try{return await n.promises.rename(J,le)}catch(O){if(O.code!=="EACCES"&&O.code!=="EPERM"&&O.code!=="EBUSY")throw O;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${O}`),O;if(q===0){let x=!1;try{const{stat:j}=await i.stat(le);j.isFile()||(x=!0)}catch{}if(x)throw O}return await(0,k.timeout)(Math.min(100,q*10)),L(J,le,K,ee,q+1)}}async function A(J,le,K){return B(J,le,{root:{source:J,target:le},options:K,handledSourcePaths:new Set})}const _=511;async function B(J,le,K){if(K.handledSourcePaths.has(J))return;K.handledSourcePaths.add(J);const{stat:ee,symbolicLink:q}=await i.stat(J);if(q){if(K.options.preserveSymlinks)try{return await se(J,le,K)}catch{}if(q.dangling)return}return ee.isDirectory()?N(J,le,ee.mode&_,K):z(J,le,ee.mode&_)}async function N(J,le,K,ee){await e.Promises.mkdir(le,{recursive:!0,mode:K});const q=await p(J);for(const O of q)await B((0,y.join)(J,O),(0,y.join)(le,O),ee)}async function z(J,le,K){await e.Promises.copyFile(J,le),await e.Promises.chmod(le,K)}async function se(J,le,K){let ee=await e.Promises.readlink(J);(0,C.isEqualOrParent)(ee,K.root.source,!a.isLinux)&&(ee=(0,y.join)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,le)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(J,le,K,ee,q)=>new Promise((O,x)=>{n.read(J,le,K,ee,q,(j,ce,G)=>j?x(j):O({bytesRead:ce,buffer:G}))})}get readFile(){return n.promises.readFile}get write(){return(J,le,K,ee,q)=>new Promise((O,x)=>{n.write(J,le,K,ee,q,(j,ce,G)=>j?x(j):O({bytesWritten:ce,buffer:G}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,I.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,I.promisify)(n.open)}get close(){return(0,I.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,I.promisify)(n.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return r}get rm(){return w}get rename(){return T}get copy(){return A}}}),define(oe[114],ae([0,1,47,10,3,26,21]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=y,e.realpath=a,e.realpathSync=h,n=ke(n);function R(g){if(I.isLinux)return g;const w=(0,o.dirname)(g);if(g===w)return g;const d=((0,o.basename)(g)||g).toLowerCase();try{const E=(0,C.readdirSync)(w).filter(p=>p.toLowerCase()===d);if(E.length===1){const p=R(w);if(p)return(0,o.join)(p,E[0])}else if(E.length>1){const p=E.indexOf(d);if(p>=0){const m=R(w);if(m)return(0,o.join)(m,E[p])}}}catch{}return null}async function y(g,w){if(I.isLinux)return g;const d=(0,o.dirname)(g);if(g===d)return g;const v=((0,o.basename)(g)||g).toLowerCase();try{if(w?.isCancellationRequested)return null;const p=(await C.Promises.readdir(d)).filter(m=>m.toLowerCase()===v);if(p.length===1){const m=await y(d,w);if(m)return(0,o.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(v);if(m>=0){const b=await y(d,w);if(b)return(0,o.join)(b,p[m])}}}catch{}return null}async function a(g){try{return await C.Promises.realpath(g)}catch{const d=f(g);return await C.Promises.access(d,n.constants.R_OK),d}}function h(g){try{return n.realpathSync(g)}catch{const d=f(g);return n.accessSync(d,n.constants.R_OK),d}}function f(g){return(0,k.rtrim)((0,o.normalize)(g),o.sep)}}),define(oe[115],ae([0,1,27,10,21]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=m,e.getFirstAvailablePowerShellInstallation=b,n=ke(n),o=ke(o),I=ke(I);const k=/^\d+$/,C=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var y;(function(D){D[D.x64=0]="x64",D[D.x86=1]="x86",D[D.ARM=2]="ARM"})(y||(y={}));let a;switch(process.arch){case"ia32":a=y.x86;break;case"arm":case"arm64":a=y.ARM;break;default:a=y.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=y.x86:h=y.x64;class f{constructor(t,s,i){this.exePath=t,this.displayName=s,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:D=!1}={}){return D?a===y.x64?process.env["ProgramFiles(x86)"]||null:h===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:D=!1,findPreview:t=!1}={}){const s=g({useAlternateBitness:D});if(!s)return null;const i=o.join(s,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(i))return null;let c=-1,r=null;for(const P of await I.Promises.readdir(i)){let S=-1;if(t){const T=P.indexOf("-");if(T<0)continue;const L=P.substring(0,T);if(!k.test(L)||P.substring(T+1)!=="preview")continue;S=parseInt(L,10)}else{if(!k.test(P))continue;S=parseInt(P,10)}if(S<=c)continue;const M=o.join(i,P,"pwsh.exe");await I.SymlinkSupport.existsFile(M)&&(r=M,c=S)}if(!r)return null;const l=s.includes("x86")?" (x86)":"",u=t?" Preview":"";return new f(r,`PowerShell${u}${l}`,!0)}async function d({findPreview:D}={}){if(!process.env.LOCALAPPDATA)return null;const t=o.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:s,pwshMsixName:i}=D?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const c of await I.Promises.readdir(t))if(s.test(c)){const r=o.join(t,c,"pwsh.exe");return new f(r,i)}return null}function v(){const D=o.join(n.homedir(),".dotnet","tools","pwsh.exe");return new f(D,".NET Core PowerShell Global Tool")}function E(){const D=o.join(process.env.windir,a===y.x86&&h!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(D,"Windows PowerShell",!0)}async function*p(){let D=await w();D&&(yield D),D=await w({useAlternateBitness:!0}),D&&(yield D),D=await d(),D&&(yield D),D=v(),D&&(yield D),D=await w({findPreview:!0}),D&&(yield D),D=await d({findPreview:!0}),D&&(yield D),D=await w({useAlternateBitness:!0,findPreview:!0}),D&&(yield D),D=E(),D&&(yield D)}async function*m(){for await(const D of p())await D.exists()&&(yield D)}async function b(){for await(const D of m())return D;return null}}),define(oe[95],ae([0,1,10,3,37,82,13,21]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=y,e.createQueuedSender=a,n=ke(n),o=ke(o),I=ke(I),C=ke(C),R=ke(R),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function y(f=I.env){return f.comspec||"cmd.exe"}function a(f){let g=[],w=!1;const d=function(v){if(w){g.push(v);return}(!f.send(v,p=>{if(p&&console.error(p),w=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(b=>d(b))}})||o.isWindows)&&(w=!0)};return{send:d}}var h;(function(f){async function g(w,d,v){if(n.isAbsolute(w))return w;if(d===void 0&&(d=I.cwd()),n.dirname(w)!=="."||(v===void 0&&C.isString(I.env.PATH)&&(v=I.env.PATH.split(n.delimiter)),v===void 0||v.length===0))return n.join(d,w);async function p(m){if(await R.Promises.exists(m)){let b;try{b=await R.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(b=await R.Promises.lstat(m))}return b?!b.isDirectory():!1}return!1}for(const m of v){let b;if(n.isAbsolute(m)?b=n.join(m,w):b=n.join(d,m,w),await p(b))return b;let D=b+".com";if(await p(D)||(D=b+".exe",await p(D)))return D}return n.join(d,w)}f.findExecutable=g})(h||(e.win32=h={}))}),define(oe[116],ae([0,1,49,12]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=I;function I(C){return new Promise((R,y)=>{let a;const h=new Map;function f(w,d,v,E,p){const m=h.get(d);if(w===C||m){const b={name:g(v),cmd:v,pid:w,ppid:d,load:E,mem:p};h.set(w,b),w===C&&(a=b),m&&(m.children||(m.children=[]),m.children.push(b),m.children.length>1&&(m.children=m.children.sort((D,t)=>D.pid-t.pid)))}}function g(w){const d=/--utility-sub-type=network/i,v=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(v.exec(w))return"electron-crash-reporter";if(E.exec(w))return"winpty-agent";if(p.exec(w))return"conpty-agent";let b=m.exec(w);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?d.exec(w)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const D=/[a-zA-Z-]+\.js/g;let t="";do b=D.exec(w),b&&(t+=b+" ");while(b);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,v)=>{V(["@vscode/windows-process-tree"],d,v)}).then(ke).then(d=>{d.getProcessList(C,v=>{if(!v){y(new Error(`Root process ${C} not found`));return}d.getProcessCpuUsage(v,E=>{const p=new Map;E.forEach(m=>{const b=w(m.commandLine||"");p.set(m.pid,{name:g(b),cmd:b,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),a=p.get(C),a?(p.forEach(m=>{const b=p.get(m.ppid);b&&(b.children||(b.children=[]),b.children.push(m))}),p.forEach(m=>{m.children&&(m.children=m.children.sort((b,D)=>b.pid-D.pid))}),R(a)):y(new Error(`Root process ${C} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let w=function(){let d=[a];const v=[];for(;d.length;){const p=d.shift();p&&(v.push(p.pid),p.children&&(d=d.concat(p.children)))}let E=JSON.stringify(o.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+v.join(" "),(0,n.exec)(E,{},(p,m,b)=>{if(p||b)y(p||new Error(b.toString()));else{const D=m.toString().split(`
`);for(let t=0;t<v.length;t++){const s=h.get(v[t]);s.load=parseFloat(D[t])}if(!a){y(new Error(`Root process ${C} not found`));return}R(a)}})};(0,n.exec)("which ps",{},(d,v,E)=>{if(d||E)if(process.platform!=="linux")y(d||new Error(E.toString()));else{const p=JSON.stringify(o.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(p,{},(m,b,D)=>{m||D?y(m||new Error(D.toString())):(k(b,f),w())})}else{const p=v.toString().trim();(0,n.exec)(`${p} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,D,t)=>{b||t&&!t.includes("screen size is bogus")?y(b||new Error(t.toString())):(k(D,f),process.platform==="linux"?w():a?R(a):y(new Error(`Root process ${C} not found`)))})}})}})}function k(C,R){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const h of a){const f=y.exec(h.trim());f&&f.length===6&&R(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(oe[117],ae([0,1,27,3,115,95]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=C,o=ke(o),k=ke(k);async function C(f,g){return f===o.OperatingSystem.Windows?o.isWindows?h():k.getWindowsShell(g):y(f,g)}let R=null;function y(f,g){if(o.isLinux&&f===o.OperatingSystem.Macintosh||o.isMacintosh&&f===o.OperatingSystem.Linux)return"/bin/bash";if(!R){let w;if(o.isWindows)w="/bin/bash";else{if(w=g.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}R=w}return R}let a=null;async function h(){return a||(a=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),a}});var Pe=this&&this.__decorate||function(V,e,n,o){var I=arguments.length,k=I<3?e:o===null?o=Object.getOwnPropertyDescriptor(e,n):o,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(V,e,n,o);else for(var R=V.length-1;R>=0;R--)(C=V[R])&&(k=(I<3?C(k):I>3?C(e,n,k):C(e,n))||k);return I>3&&k&&Object.defineProperty(e,n,k),k};define(oe[44],ae([0,1,22,8,17,23,54,16,4,2,83,26,13]),function(V,e,n,o,I,k,C,R,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=u,e.deserialize=P,e.getDelayedChannel=_,e.getNextTickChannel=B,f=ke(f);var w;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(w||(w={}));function d(q){switch(q){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var v;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(v||(v={}));function E(q){switch(q){case v.Initialize:return"init";case v.PromiseSuccess:return"reply:";case v.PromiseError:case v.PromiseErrorObj:return"replyErr:";case v.EventFire:return"event:"}}var p;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(p||(p={}));function m(q){let O=0;for(let x=0;;x+=7){const j=q.read(1);if(O|=(j.buffer[0]&127)<<x,!(j.buffer[0]&128))return O}}const b=c(0);function D(q,O){if(O===0){q.write(b);return}let x=0;for(let ce=O;ce!==0;ce=ce>>>7)x++;const j=I.VSBuffer.alloc(x);for(let ce=0;O!==0;ce++)j.buffer[ce]=O&127,O=O>>>7,O>0&&(j.buffer[ce]|=128);q.write(j)}class t{constructor(O){this.buffer=O,this.pos=0}read(O){const x=this.buffer.slice(this.pos,this.pos+O);return this.pos+=x.byteLength,x}}e.BufferReader=t;class s{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}e.BufferWriter=s;var i;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(i||(i={}));function c(q){const O=I.VSBuffer.alloc(1);return O.writeUInt8(q,0),O}const r={Undefined:c(i.Undefined),String:c(i.String),Buffer:c(i.Buffer),VSBuffer:c(i.VSBuffer),Array:c(i.Array),Object:c(i.Object),Uint:c(i.Int)},l=typeof Buffer<"u";function u(q,O){if(typeof O>"u")q.write(r.Undefined);else if(typeof O=="string"){const x=I.VSBuffer.fromString(O);q.write(r.String),D(q,x.byteLength),q.write(x)}else if(l&&Buffer.isBuffer(O)){const x=I.VSBuffer.wrap(O);q.write(r.Buffer),D(q,x.byteLength),q.write(x)}else if(O instanceof I.VSBuffer)q.write(r.VSBuffer),D(q,O.byteLength),q.write(O);else if(Array.isArray(O)){q.write(r.Array),D(q,O.length);for(const x of O)u(q,x)}else if(typeof O=="number"&&(O|0)===O)q.write(r.Uint),D(q,O);else{const x=I.VSBuffer.fromString(JSON.stringify(O));q.write(r.Object),D(q,x.byteLength),q.write(x)}}function P(q){switch(q.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return q.read(m(q)).toString();case i.Buffer:return q.read(m(q)).buffer;case i.VSBuffer:return q.read(m(q));case i.Array:{const x=m(q),j=[];for(let ce=0;ce<x;ce++)j.push(P(q));return j}case i.Object:return JSON.parse(q.read(m(q)).toString());case i.Int:return m(q)}}class S{constructor(O,x,j=null,ce=1e3){this.protocol=O,this.ctx=x,this.logger=j,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:v.Initialize})}registerChannel(O,x){this.channels.set(O,x),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case v.Initialize:{const x=this.send([O.type]);this.logger?.logOutgoing(x,0,M.OtherSide,E(O.type));return}case v.PromiseSuccess:case v.PromiseError:case v.EventFire:case v.PromiseErrorObj:{const x=this.send([O.type,O.id],O.data);this.logger?.logOutgoing(x,O.id,M.OtherSide,E(O.type),O.data);return}}}send(O,x=void 0){const j=new s;return u(j,O),u(j,x),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const x=new t(O),j=P(x),ce=P(x),G=j[0];switch(G){case w.Promise:return this.logger?.logIncoming(O.byteLength,j[1],M.OtherSide,`${d(G)}: ${j[2]}.${j[3]}`,ce),this.onPromise({type:G,id:j[1],channelName:j[2],name:j[3],arg:ce});case w.EventListen:return this.logger?.logIncoming(O.byteLength,j[1],M.OtherSide,`${d(G)}: ${j[2]}.${j[3]}`,ce),this.onEventListen({type:G,id:j[1],channelName:j[2],name:j[3],arg:ce});case w.PromiseCancel:return this.logger?.logIncoming(O.byteLength,j[1],M.OtherSide,`${d(G)}`),this.disposeActiveRequest({type:G,id:j[1]});case w.EventDispose:return this.logger?.logIncoming(O.byteLength,j[1],M.OtherSide,`${d(G)}`),this.disposeActiveRequest({type:G,id:j[1]})}}onPromise(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const j=new k.CancellationTokenSource;let ce;try{ce=x.call(this.ctx,O.name,O.arg,j.token)}catch(re){ce=Promise.reject(re)}const G=O.id;ce.then(re=>{this.sendResponse({id:G,data:re,type:v.PromiseSuccess})},re=>{re instanceof Error?this.sendResponse({id:G,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:v.PromiseError}):this.sendResponse({id:G,data:re,type:v.PromiseErrorObj})}).finally(()=>{de.dispose(),this.activeRequests.delete(O.id)});const de=(0,a.toDisposable)(()=>j.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const j=O.id,G=x.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:j,data:de,type:v.EventFire}));this.activeRequests.set(O.id,G)}disposeActiveRequest(O){const x=this.activeRequests.get(O.id);x&&(x.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let x=this.pendingRequests.get(O.channelName);x||(x=[],this.pendingRequests.set(O.channelName,x));const j=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===w.Promise&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:v.PromiseError})},this.timeoutDelay);x.push({request:O,timeoutTimer:j})}flushPendingRequests(O){const x=this.pendingRequests.get(O);if(x){for(const j of x)switch(clearTimeout(j.timeoutTimer),j.request.type){case w.Promise:this.onPromise(j.request);break;case w.EventListen:this.onEventListen(j.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=S;var M;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class T{constructor(O,x=null){this.protocol=O,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=x}getChannel(O){const x=this;return{call(j,ce,G){return x.isDisposed?Promise.reject(new R.CancellationError):x.requestPromise(O,j,ce,G)},listen(j,ce){return x.isDisposed?y.Event.None:x.requestEvent(O,j,ce)}}}requestPromise(O,x,j,ce=k.CancellationToken.None){const G=this.lastRequestId++,de=w.Promise,re={id:G,type:de,channelName:O,name:x,arg:j};if(ce.isCancellationRequested)return Promise.reject(new R.CancellationError);let Z;return new Promise((F,U)=>{if(ce.isCancellationRequested)return U(new R.CancellationError);const H=()=>{const ie=fe=>{switch(fe.type){case v.PromiseSuccess:this.handlers.delete(G),F(fe.data);break;case v.PromiseError:{this.handlers.delete(G);const me=new Error(fe.data.message);me.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,me.name=fe.data.name,U(me);break}case v.PromiseErrorObj:this.handlers.delete(G),U(fe.data);break}};this.handlers.set(G,ie),this.sendRequest(re)};let Y=null;this.state===p.Idle?H():(Y=(0,o.createCancelablePromise)(ie=>this.whenInitialized()),Y.then(()=>{Y=null,H()}));const Q=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:G,type:w.PromiseCancel}),U(new R.CancellationError)},$=ce.onCancellationRequested(Q);Z=(0,a.combinedDisposable)((0,a.toDisposable)(Q),$),this.activeRequests.add(Z)}).finally(()=>{Z.dispose(),this.activeRequests.delete(Z)})}requestEvent(O,x,j){const ce=this.lastRequestId++,G=w.EventListen,de={id:ce,type:G,channelName:O,name:x,arg:j};let re=null;const Z=new y.Emitter({onWillAddFirstListener:()=>{re=(0,o.createCancelablePromise)(F=>this.whenInitialized()),re.then(()=>{re=null,this.activeRequests.add(Z),this.sendRequest(de)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.activeRequests.delete(Z),this.sendRequest({id:ce,type:w.EventDispose}))}}),W=F=>Z.fire(F.data);return this.handlers.set(ce,W),Z.event}sendRequest(O){switch(O.type){case w.Promise:case w.EventListen:{const x=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger?.logOutgoing(x,O.id,M.LocalSide,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case w.PromiseCancel:case w.EventDispose:{const x=this.send([O.type,O.id]);this.logger?.logOutgoing(x,O.id,M.LocalSide,d(O.type));return}}}send(O,x=void 0){const j=new s;return u(j,O),u(j,x),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const x=new t(O),j=P(x),ce=P(x),G=j[0];switch(G){case v.Initialize:return this.logger?.logIncoming(O.byteLength,0,M.LocalSide,E(G)),this.onResponse({type:j[0]});case v.PromiseSuccess:case v.PromiseError:case v.EventFire:case v.PromiseErrorObj:return this.logger?.logIncoming(O.byteLength,j[1],M.LocalSide,E(G),ce),this.onResponse({type:j[0],id:j[1],data:ce})}}onResponse(O){if(O.type===v.Initialize){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(O.id)?.(O)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=T,Pe([C.memoize],T.prototype,"onDidInitializePromise",null);class L{get connections(){const O=[];return this._connections.forEach(x=>O.push(x)),O}constructor(O,x,j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(O(({protocol:ce,onDidClientDisconnect:G})=>{const de=y.Event.once(ce.onMessage);this.disposables.add(de(re=>{const Z=new t(re),W=P(Z),F=new S(ce,W,x,j),U=new T(ce,x);this.channels.forEach((Y,Q)=>F.registerChannel(Q,Y));const H={channelServer:F,channelClient:U,ctx:W};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(G(()=>{F.dispose(),U.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(O,x){const j=this;return{call(ce,G,de){let re;if((0,g.isFunction)(x)){const W=(0,n.getRandomElement)(j.connections.filter(x));re=W?Promise.resolve(W):y.Event.toPromise(y.Event.filter(j.onDidAddConnection,x))}else re=x.routeCall(j,ce,G);const Z=re.then(W=>W.channelClient.getChannel(O));return _(Z).call(ce,G,de)},listen(ce,G){if((0,g.isFunction)(x))return j.getMulticastEvent(O,x,ce,G);const de=x.routeEvent(j,ce,G).then(re=>re.channelClient.getChannel(O));return _(de).listen(ce,G)}}}getMulticastEvent(O,x,j,ce){const G=this;let de;const re=new y.Emitter({onWillAddFirstListener:()=>{de=new a.DisposableStore;const Z=new y.EventMultiplexer,W=new Map,F=H=>{const Q=H.channelClient.getChannel(O).listen(j,ce),$=Z.add(Q);W.set(H,$)},U=H=>{const Y=W.get(H);Y&&(Y.dispose(),W.delete(H))};G.connections.filter(x).forEach(F),y.Event.filter(G.onDidAddConnection,x)(F,void 0,de),G.onDidRemoveConnection(U,void 0,de),Z.event(re.fire,re,de),de.add(Z)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return re.event}registerChannel(O,x){this.channels.set(O,x);for(const j of this._connections)j.channelServer.registerChannel(O,x)}dispose(){this.disposables.dispose();for(const O of this._connections)O.channelClient.dispose(),O.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class A{constructor(O,x,j=null){const ce=new s;u(ce,x),O.send(ce.buffer),this.channelClient=new T(O,j),this.channelServer=new S(O,x,j)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,x){this.channelServer.registerChannel(O,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function _(q){return{call(O,x,j){return q.then(ce=>ce.call(O,x,j))},listen(O,x){const j=new y.Relay;return q.then(ce=>j.input=ce.listen(O,x)),j.event}}}function B(q){let O=!1;return{call(x,j,ce){return O?q.call(x,j,ce):(0,o.timeout)(0).then(()=>O=!0).then(()=>q.call(x,j,ce))},listen(x,j){if(O)return q.listen(x,j);const ce=new y.Relay;return(0,o.timeout)(0).then(()=>O=!0).then(()=>ce.input=q.listen(x,j)),ce.event}}}class N{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const x of O.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await y.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=N;var z;(function(q){function O(G,de,re){const Z=G,W=re&&re.disableMarshalling,F=new Map;for(const U in Z)j(U)&&F.set(U,y.Event.buffer(Z[U],!0,void 0,de));return new class{listen(U,H,Y){const Q=F.get(H);if(Q)return Q;const $=Z[H];if(typeof $=="function"){if(ce(H))return $.call(Z,Y);if(j(H))return F.set(H,y.Event.buffer(Z[H],!0,void 0,de)),F.get(H)}throw new R.ErrorNoTelemetry(`Event not found: ${H}`)}call(U,H,Y){const Q=Z[H];if(typeof Q=="function"){if(!W&&Array.isArray(Y))for(let ie=0;ie<Y.length;ie++)Y[ie]=(0,h.revive)(Y[ie]);let $=Q.apply(Z,Y);return $ instanceof Promise||($=Promise.resolve($)),$}throw new R.ErrorNoTelemetry(`Method not found: ${H}`)}}}q.fromService=O;function x(G,de){const re=de&&de.disableMarshalling;return new Proxy({},{get(Z,W){if(typeof W=="string")return de?.properties?.has(W)?de.properties.get(W):ce(W)?function(F){return G.listen(W,F)}:j(W)?G.listen(W):async function(...F){let U;de&&!(0,g.isUndefinedOrNull)(de.context)?U=[de.context,...F]:U=F;const H=await G.call(W,U);return re?H:(0,h.revive)(H)};throw new R.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}q.toService=x;function j(G){return G[0]==="o"&&G[1]==="n"&&f.isUpperAsciiLetter(G.charCodeAt(2))}function ce(G){return/^onDynamic/.test(G)&&f.isUpperAsciiLetter(G.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const O=q.toString();if(O!=="[object Object]")return O}return q}function le(q){return Array.isArray(q)?q.map(J):J(q)}function K(q,O,x,j,ce,G,de){de=le(de);const re=se[ce],Z=re[j%re.length];let W=[`%c[${q}]%c[${String(O).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test(G)?(W=W.concat(de),W.push(")")):W.push(de),console.log.apply(console,W)}class ee{constructor(O,x){this._outgoingPrefix=O,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,x,j,ce,G){this._totalOutgoing+=O,K(this._outgoingPrefix,this._totalOutgoing,O,x,j,ce,G)}logIncoming(O,x,j,ce,G){this._totalIncoming+=O,K(this._incomingPrefix,this._totalIncoming,O,x,j,ce,G)}}e.IPCLogger=ee}),define(oe[162],ae([0,1,17,4,44]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(y){this.port=y,this.onMessage=o.Event.fromDOMEventEmitter(this.port,"message",a=>a.data?n.VSBuffer.wrap(a.data):n.VSBuffer.alloc(0)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class C extends I.IPCClient{constructor(y,a){const h=new k(y);super(h,a),this.protocol=h}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=C}),define(oe[118],ae([0,1,17,4,2,44]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var R;(function(r){r.enableDiagnostics=!1,r.records=[];const l=new WeakMap;let u=0;function P(M,T){if(!l.has(M)){const L=String(++u);l.set(M,L)}return l.get(M)}function S(M,T,L,A){if(!r.enableDiagnostics)return;const _=P(M,T);if(A instanceof n.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const B=n.VSBuffer.alloc(A.byteLength);B.set(A),r.records.push({timestamp:Date.now(),id:_,label:T,type:L,buff:B})}else r.records.push({timestamp:Date.now(),id:_,label:T,type:L,data:A})}r.traceSocketEvent=S})(R||(e.SocketDiagnostics=R={}));var y;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let a=null;function h(){return a||(a=n.VSBuffer.alloc(0)),a}class f{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(l){this._chunks.push(l),this._totalLength+=l.byteLength}read(l){return this._read(l,!0)}peek(l){return this._read(l,!1)}_read(l,u){if(l===0)return h();if(l>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===l){const T=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=l),T}if(this._chunks[0].byteLength>l){const T=this._chunks[0].slice(0,l);return u&&(this._chunks[0]=this._chunks[0].slice(l),this._totalLength-=l),T}const P=n.VSBuffer.alloc(l);let S=0,M=0;for(;l>0;){const T=this._chunks[M];if(T.byteLength>l){const L=T.slice(0,l);P.set(L,S),S+=l,u&&(this._chunks[M]=T.slice(l),this._totalLength-=l),l-=l}else P.set(T,S),S+=T.byteLength,u?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,l-=T.byteLength}return P}}e.ChunkStream=f;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(g||(g={}));function w(r){switch(r){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class v{constructor(l,u,P,S){this.type=l,this.id=u,this.ack=P,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends I.Disposable{constructor(l){super(),this._onMessage=this._register(new o.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:d.HeaderLength,messageType:g.None,id:0,ack:0},this._socket=l,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent(C.ProtocolHeaderRead,{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const P=this._state.messageType,S=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=d.HeaderLength,this._state.messageType=g.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(C.ProtocolMessageRead,u),this._onMessage.fire(new v(P,S,M,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(l){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=l,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(l){if(this._isDisposed)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.VSBuffer.alloc(d.HeaderLength);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this._socket.traceSocketEvent(C.ProtocolHeaderWrite,{messageType:w(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this._socket.traceSocketEvent(C.ProtocolMessageWrite,l.data),this._writeSoon(u,l.data)}_bufferAdd(l,u){const P=this._totalLength===0;return this._data.push(l,u),this._totalLength+=l.byteLength+u.byteLength,P}_bufferTake(){const l=n.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,l}_writeSoon(l,u){this._bufferAdd(l,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const l=this._bufferTake();this._socket.traceSocketEvent(C.ProtocolWrite,{byteLength:l.byteLength}),this._socket.write(l)}}class m extends I.Disposable{constructor(l){super(),this._onMessage=new o.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new o.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=l,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===g.Regular&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(l){this._socketWriter.write(new v(g.Regular,0,0,l))}}e.Protocol=m;class b extends k.IPCClient{static fromSocket(l,u){return new b(new m(l),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(l,u,P=null){super(l,u,P),this.protocol=l}dispose(){super.dispose();const l=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),l.end()}}e.Client=b;class D{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new o.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(l){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(l):this._emitter.fire(l):this._bufferedMessages.push(l)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=D;class t{constructor(l){this.data=l,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let l=0,u=this._first;for(;u;)u=u.next,l++;return l}peek(){return this._first?this._first.data:null}toArray(){const l=[];let u=0,P=this._first;for(;P;)l[u++]=P.data,P=P.next;return l}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(l){const u=new t(l);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class i{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const l=Date.now();for(let u=0;u<i._HISTORY_LENGTH;u++)this.lastRuns[u]=l-1e3*u;setInterval(()=>{for(let u=i._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const l=Date.now(),u=(1+i._HISTORY_LENGTH)*1e3;let P=0;for(let S=0;S<i._HISTORY_LENGTH;S++)l-this.lastRuns[S]<=u&&P++;return 1-P/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class c{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(l){this._onControlMessage=new D,this.onControlMessage=this._onControlMessage.event,this._onMessage=new D,this.onMessage=this._onMessage.event,this._onDidDispose=new D,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new D,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new D,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l.loadEstimator??i.getInstance(),this._shouldSendKeepAlive=l.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new I.DisposableStore,this._socket=l.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),l.initialChunk&&this._socketReader.acceptChunk(l.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},d.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const l=new v(g.Disconnect,0,0,h());this._socketWriter.write(l),this._socketWriter.flush()}sendPause(){const l=new v(g.Pause,0,0,h());this._socketWriter.write(l)}sendResume(){const l=new v(g.Resume,0,0,h());this._socketWriter.write(l)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(l,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new I.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=l,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.add(this._socket.onClose(P=>this._onSocketClose.fire(P))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const l=new v(g.Ack,0,this._incomingAckId,h());this._socketWriter.write(l);const u=this._outgoingUnackMsg.toArray();for(let P=0,S=u.length;P<S;P++)this._socketWriter.write(u[P]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(l){if(l.ack>this._outgoingAckId){this._outgoingAckId=l.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=l.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(l.type){case g.None:break;case g.Regular:{if(l.id>this._incomingMsgId)if(l.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new v(g.ReplayRequest,0,0,h())))}else this._incomingMsgId=l.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(l.data);break}case g.Control:{this._onControlMessage.fire(l.data);break}case g.Ack:break;case g.Disconnect:{this._onDidDispose.fire();break}case g.ReplayRequest:{const u=this._outgoingUnackMsg.toArray();for(let P=0,S=u.length;P<S;P++)this._socketWriter.write(u[P]);this._recvAckCheck();break}case g.Pause:{this._socketWriter.pause();break}case g.Resume:{this._socketWriter.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(l){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const P=new v(g.Regular,u,this._incomingAckId,l);this._outgoingUnackMsg.push(P),this._isReconnecting||(this._socketWriter.write(P),this._recvAckCheck())}sendControl(l){const u=new v(g.Control,0,0,l);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const l=Date.now()-this._incomingMsgLastTime;if(l>=d.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},d.AcknowledgeTime-l+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const l=this._outgoingUnackMsg.peek(),u=Date.now()-l.writtenTime,P=Date.now()-this._socketReader.lastReadTime,S=Date.now()-this._lastSocketTimeoutTime;if(u>=d.TimeoutTime&&P>=d.TimeoutTime&&S>=d.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:P});return}const M=Math.max(d.TimeoutTime-u,d.TimeoutTime-P,d.TimeoutTime-S,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const l=new v(g.Ack,0,this._incomingAckId,h());this._socketWriter.write(l)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const l=new v(g.KeepAlive,0,this._incomingAckId,h());this._socketWriter.write(l)}}e.PersistentProtocol=c}),define(oe[35],ae([0,1,14,16,12]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,y){const a=(h,...f)=>{this.validateEvent(R,h)&&y(h,...f)};return this.mapListenerToWrapper.set(y,a),n.ipcMain.on(R,a),this}once(R,y){return n.ipcMain.once(R,(a,...h)=>{this.validateEvent(R,a)&&y(a,...h)}),this}handle(R,y){return n.ipcMain.handle(R,(a,...h)=>this.validateEvent(R,a)?y(a,...h):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return n.ipcMain.removeHandler(R),this}removeListener(R,y){const a=this.mapListenerToWrapper.get(y);return a&&(n.ipcMain.removeListener(R,a),this.mapListenerToWrapper.delete(y)),this}validateEvent(R,y){if(!R||!R.startsWith("vscode:"))return(0,o.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const a=y.senderFrame,h=a.url;if(!h||h==="about:blank")return!0;let f="unknown";try{f=new URL(h).host}catch{return(0,o.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${h}'.`),!1}return f!==I.VSCODE_AUTHORITY?((0,o.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${f}'.`),!1):a.parent!==null?((0,o.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${f}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(oe[163],ae([0,1,14,35,151]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=k;function k(){o.validatedIpcMain.on(I.CONTEXT_MENU_CHANNEL,(R,y,a,h,f)=>{const g=C(R,h,a);g.popup({x:f?f.x:void 0,y:f?f.y:void 0,positioningItem:f?f.positioningItem:void 0,callback:()=>{g&&R.sender.send(I.CONTEXT_MENU_CLOSE_CHANNEL,y)}})})}function C(R,y,a){const h=new n.Menu;return a.forEach(f=>{let g;f.type==="separator"?g=new n.MenuItem({type:f.type}):Array.isArray(f.submenu)?g=new n.MenuItem({submenu:C(R,y,f.submenu),label:f.label}):g=new n.MenuItem({label:f.label,type:f.type,accelerator:f.accelerator,checked:f.checked,enabled:f.enabled,visible:f.visible,click:(w,d,v)=>R.sender.send(y,f.id,v)}),h.append(g)}),h}}),define(oe[164],ae([0,1,35,17,4,2,44,152]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function y(h,f){const g=I.Event.fromNodeEventEmitter(n.validatedIpcMain,f,(d,v)=>({event:d,message:v})),w=I.Event.filter(g,({event:d})=>d.sender.id===h);return I.Event.map(w,({message:d})=>d&&o.VSBuffer.wrap(d))}class a extends C.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const f=I.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:hello",({sender:g})=>g);return I.Event.map(f,g=>{const w=g.id;a.Clients.get(w)?.dispose();const v=new I.Emitter;a.Clients.set(w,(0,k.toDisposable)(()=>v.fire()));const E=y(w,"vscode:message"),p=I.Event.any(I.Event.signal(y(w,"vscode:disconnect")),v.event);return{protocol:new R.Protocol(g,E),onDidClientDisconnect:p}})}constructor(){super(a.getOnDidClientConnect())}}e.Server=a}),define(oe[119],ae([0,1,35,4,33,162]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=R;class C extends k.Client{constructor(a,h){super({addEventListener:(f,g)=>a.addListener(f,g),removeEventListener:(f,g)=>a.removeListener(f,g),postMessage:f=>a.postMessage(f),start:()=>a.start(),close:()=>a.close()},h)}}e.Client=C;async function R(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,I.generateUuid)();y.webContents.send("vscode:createMessageChannel",a);const h=o.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:f}=await o.Event.toPromise(o.Event.once(o.Event.filter(h,g=>g.nonce===a)));return f}}),define(oe[165],ae([0,1,49,8,17,23,159,16,4,2,36,95,82,44]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,R=ke(R);class d extends w.ChannelServer{constructor(p){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",m=>I.VSBuffer.wrap(Buffer.from(m,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(p,m){this.modulePath=p,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new o.Delayer(b),this.child=null,this._client=null}getChannel(p){const m=this;return{call(b,D,t){return m.requestPromise(p,b,D,t)},listen(b,D){return m.requestEvent(p,b,D)}}}requestPromise(p,m,b,D=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(D.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(p),s=(0,o.createCancelablePromise)(r=>t.call(m,b,r)),i=D.onCancellationRequested(()=>s.cancel()),c=(0,a.toDisposable)(()=>s.cancel());return this.activeRequests.add(c),s.finally(()=>{i.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(p,m,b){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let D;const t=new y.Emitter({onWillAddFirstListener:()=>{D=this.getCachedChannel(p).listen(m,b)(t.fire,t),this.activeRequests.add(D)},onDidRemoveLastListener:()=>{this.activeRequests.delete(D),D.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,h.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(m.env),this.child=(0,n.fork)(this.modulePath,p,m);const b=new y.Emitter,t=y.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,C.isRemoteConsoleLog)(u)){(0,C.log)(u,`IPC Library: ${this.options.serverName}`);return}b.fire(I.VSBuffer.wrap(Buffer.from(u,"base64")))}),s=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,i=u=>this.child&&this.child.connected&&s.send(u.buffer.toString("base64")),c=b.event,r={send:i,onMessage:c};this._client=new w.ChannelClient(r);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,P)=>{process.removeListener("exit",l),t.dispose(),this.activeRequests.forEach(S=>(0,a.dispose)(S)),this.activeRequests.clear(),u!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+P),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:P})})}return this._client}getCachedChannel(p){let m=this.channels.get(p);return m||(m=this.client.getChannel(p),this.channels.set(p,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(oe[120],ae([0,1,8,4,2,83,13]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=y;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function y(g){const w=g;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends I.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(w,d=Object.create(null)){super(),this.database=w,this.options=d,this._onDidChangeStorage=this._register(new o.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new n.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){this._onDidChangeStorage.pause();try{w.changed?.forEach((d,v)=>this.acceptExternal(v,d)),w.deleted?.forEach(d=>this.acceptExternal(d,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(w,d){if(this.state===a.Closed)return;let v=!1;(0,C.isUndefinedOrNull)(d)?v=this.cache.delete(w):this.cache.get(w)!==d&&(this.cache.set(w,d),v=!0),v&&this._onDidChangeStorage.fire({key:w,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,d){const v=this.cache.get(w);return(0,C.isUndefinedOrNull)(v)?d:v}getBoolean(w,d){const v=this.get(w);return(0,C.isUndefinedOrNull)(v)?d:v==="true"}getNumber(w,d){const v=this.get(w);return(0,C.isUndefinedOrNull)(v)?d:parseInt(v,10)}getObject(w,d){const v=this.get(w);return(0,C.isUndefinedOrNull)(v)?d:(0,k.parse)(v)}async set(w,d,v=!1){if(this.state===a.Closed)return;if((0,C.isUndefinedOrNull)(d))return this.delete(w,v);const E=(0,C.isObject)(d)||Array.isArray(d)?(0,k.stringify)(d):String(d);if(this.cache.get(w)!==E)return this.cache.set(w,E),this.pendingInserts.set(w,E),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire({key:w,external:v}),this.doFlush()}async delete(w,d=!1){if(!(this.state===a.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire({key:w,external:d}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(!(this.state===a.Closed||this.pendingClose))return this.doFlush(w)}async doFlush(w){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=h;class f{constructor(){this.onDidChangeItemsExternal=o.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((d,v)=>this.items.set(v,d)),w.delete?.forEach(d=>this.items.delete(d))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=f}),define(oe[166],ae([0,1,8,4,32,10,21]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class R{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return o.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(h,f=Object.create(null)){this.path=h,this.options=f,this.name=(0,k.basename)(this.path),this.logger=new y(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const h=await this.whenConnected,f=new Map;return(await this.all(h,"SELECT * FROM ItemTable")).forEach(w=>f.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(h){const f=await this.whenConnected;return this.doUpdateItems(f,h)}doUpdateItems(h,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?(0,I.mapToString)(f.insert):"0"}), delete(${f.delete?(0,I.setToString)(f.delete):"0"})`),this.transaction(h,()=>{const g=f.insert,w=f.delete;if(g&&g.size>0){const d=[];d.push([]);let v=0;g.forEach((E,p)=>{let m=d[v];m.length>R.MAX_HOST_PARAMETERS&&(v++,m=[],d.push(m)),m.push(p,E)}),d.forEach(E=>{this.prepare(h,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,p=>p.run(E),()=>{const p=[];let m=0;return g.forEach((b,D)=>{p.push(D),m+=b.length}),`Keys: ${p.join(", ")} Length: ${m}`})})}if(w&&w.size){const d=[];d.push([]);let v=0;w.forEach(E=>{let p=d[v];p.length>R.MAX_HOST_PARAMETERS&&(v++,p=[],d.push(p)),p.push(E)}),d.forEach(E=>{this.prepare(h,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,p=>p.run(E),()=>{const p=[];return w.forEach(m=>{p.push(m)}),`Keys: ${p.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const h=await this.whenConnected;return this.exec(h,"VACUUM")}async close(h){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,h)}doClose(h,f){return new Promise((g,w)=>{h.db.close(d=>(d&&this.handleSQLiteError(h,`[storage ${this.name}] close(): ${d}`),this.path===R.IN_MEMORY_PATH?g():!h.isErroneous&&!h.isInMemory?this.backup().then(g,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),g())):typeof f=="function"?C.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const E=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:f()}).then(()=>E(),p=>(E(),Promise.reject(p)))})).then(g,w):w(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const h=this.toBackupPath(this.path);return C.Promises.copy(this.path,h,{preserveSymlinks:!1})}toBackupPath(h){return`${h}.backup`}async checkIntegrity(h){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${h})`);const f=await this.whenConnected,g=await this.get(f,h?"PRAGMA integrity_check":"PRAGMA quick_check"),w=h?g.integrity_check:g.quick_check;return f.isErroneous?`${w} (last error: ${f.lastError})`:f.isInMemory?`${w} (in-memory!)`:w}async connect(h,f=!0){this.logger.trace(`[storage ${this.name}] open(${h}, retryOnBusy: ${f})`);try{return await this.doConnect(h)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&f)return await(0,n.timeout)(R.BUSY_OPEN_TIMEOUT),this.connect(h,!1);try{await C.Promises.unlink(h);try{await C.Promises.rename(this.toBackupPath(h),h,!1)}catch{}return await this.doConnect(h)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(R.IN_MEMORY_PATH)}}}handleSQLiteError(h,f){h.isErroneous=!0,h.lastError=f,this.logger.error(f)}doConnect(h){return new Promise((f,g)=>{new Promise((w,d)=>{V(["@vscode/sqlite3"],w,d)}).then(ke).then(w=>{const d={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(h,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>g(v)):g(v):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(d),E=>d.db.close(()=>g(E)))),isInMemory:h===R.IN_MEMORY_PATH};d.db.on("error",v=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&d.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},g)})}exec(h,f){return new Promise((g,w)=>{h.db.exec(f,d=>d?(this.handleSQLiteError(h,`[storage ${this.name}] exec(): ${d}`),w(d)):g())})}get(h,f){return new Promise((g,w)=>{h.db.get(f,(d,v)=>d?(this.handleSQLiteError(h,`[storage ${this.name}] get(): ${d}`),w(d)):g(v))})}all(h,f){return new Promise((g,w)=>{h.db.all(f,(d,v)=>d?(this.handleSQLiteError(h,`[storage ${this.name}] all(): ${d}`),w(d)):g(v))})}transaction(h,f){return new Promise((g,w)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),f(),h.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(h,`[storage ${this.name}] transaction(): ${d}`),w(d)):g())})})}prepare(h,f,g,w){const d=h.db.prepare(f),v=E=>{this.handleSQLiteError(h,`[storage ${this.name}] prepare(): ${E} (${f}). Details: ${w()}`)};d.on("error",v),g(d),d.finalize(E=>{E&&v(E),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=R;class y{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[y.VSCODE_TRACE_STORAGE]&&(this.logTrace=h.logTrace),h&&typeof h.logError=="function"&&(this.logError=h.logError)}get isTracing(){return!!this.logTrace}trace(h){this.logTrace?.(h)}error(h){this.logError?.(h)}}}),define(oe[167],ae([11,9]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(oe[168],ae([11,9]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[169],ae([11,9]),function(V,e){return V.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[170],ae([11,9]),function(V,e){return V.create("vs/platform/contextkey/common/scanner",e)}),define(oe[171],ae([11,9]),function(V,e){return V.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[172],ae([11,9]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[173],ae([11,9]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(oe[174],ae([11,9]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(oe[175],ae([11,9]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[176],ae([11,9]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[177],ae([11,9]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[178],ae([11,9]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[179],ae([11,9]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[180],ae([11,9]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(oe[181],ae([11,9]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(oe[182],ae([11,9]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(oe[183],ae([11,9]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[184],ae([11,9]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[185],ae([11,9]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[186],ae([11,9]),function(V,e){return V.create("vs/platform/issue/electron-main/processMainService",e)}),define(oe[187],ae([11,9]),function(V,e){return V.create("vs/platform/log/common/log",e)}),define(oe[188],ae([11,9]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[189],ae([11,9]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[190],ae([11,9]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(oe[191],ae([11,9]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(oe[192],ae([11,9]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[193],ae([11,9]),function(V,e){return V.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[194],ae([11,9]),function(V,e){return V.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[195],ae([11,9]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[196],ae([11,9]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[197],ae([11,9]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[198],ae([11,9]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[199],ae([11,9]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(oe[200],ae([11,9]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[201],ae([11,9]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[202],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=n,e.isWorkspaceBackupInfo=o;function n(I){return I&&I.hasOwnProperty("folderUri")}function o(I){return I&&I.hasOwnProperty("workspace")}}),define(oe[203],ae([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=o,e.deserializeWorkspaceInfos=I,e.deserializeFolderInfos=k;function o(C){return typeof C?.backupFolder=="string"}function I(C){let R=[];try{Array.isArray(C.workspaces)&&(R=C.workspaces.map(y=>({workspace:{id:y.id,configPath:n.URI.parse(y.configURIPath)},remoteAuthority:y.remoteAuthority})))}catch{}return R}function k(C){let R=[];try{Array.isArray(C.folders)&&(R=C.folders.map(y=>({folderUri:n.URI.parse(y.folderUri),remoteAuthority:y.remoteAuthority})))}catch{}return R}}),define(oe[204],ae([0,1,39,16,170]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(k||(e.TokenType=k={}));function C(...h){switch(h.length){case 1:return(0,I.localize)(0,null,h[0]);case 2:return(0,I.localize)(1,null,h[0],h[1]);case 3:return(0,I.localize)(2,null,h[0],h[1],h[2]);default:return}}const R=(0,I.localize)(3,null),y=(0,I.localize)(4,null);class a{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return f.isTripleEq?"===":"==";case k.NotEq:return f.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return f.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return f.lexeme;case k.QuotedStr:return f.lexeme;case k.Error:return f.lexeme;case k.EOF:return"EOF";default:throw(0,o.illegalState)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this._keywords=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this._errors}reset(f){return this._input=f,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case n.CharCode.OpenParen:this._addToken(k.LParen);break;case n.CharCode.CloseParen:this._addToken(k.RParen);break;case n.CharCode.ExclamationMark:if(this._match(n.CharCode.Equals)){const g=this._match(n.CharCode.Equals);this._tokens.push({type:k.NotEq,offset:this._start,isTripleEq:g})}else this._addToken(k.Neg);break;case n.CharCode.SingleQuote:this._quotedString();break;case n.CharCode.Slash:this._regex();break;case n.CharCode.Equals:if(this._match(n.CharCode.Equals)){const g=this._match(n.CharCode.Equals);this._tokens.push({type:k.Eq,offset:this._start,isTripleEq:g})}else this._match(n.CharCode.Tilde)?this._addToken(k.RegexOp):this._error(C("==","=~"));break;case n.CharCode.LessThan:this._addToken(this._match(n.CharCode.Equals)?k.LtEq:k.Lt);break;case n.CharCode.GreaterThan:this._addToken(this._match(n.CharCode.Equals)?k.GtEq:k.Gt);break;case n.CharCode.Ampersand:this._match(n.CharCode.Ampersand)?this._addToken(k.And):this._error(C("&&"));break;case n.CharCode.Pipe:this._match(n.CharCode.Pipe)?this._addToken(k.Or):this._error(C("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(k.EOF),Array.from(this._tokens)}_match(f){return this._isAtEnd()||this._input.charCodeAt(this._current)!==f?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?n.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(f){this._tokens.push({type:f,offset:this._start})}_error(f){const g=this._start,w=this._input.substring(this._start,this._current),d={type:k.Error,offset:this._start,lexeme:w};this._errors.push({offset:g,lexeme:w,additionalInfo:f}),this._tokens.push(d)}_string(){this.stringRe.lastIndex=this._start;const f=this.stringRe.exec(this._input);if(f){this._current=this._start+f[0].length;const g=this._input.substring(this._start,this._current),w=a._keywords.get(g);w?this._addToken(w):this._tokens.push({type:k.Str,lexeme:g,offset:this._start})}}_quotedString(){for(;this._peek()!==n.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:k.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let f=this._current,g=!1,w=!1;for(;;){if(f>=this._input.length){this._current=f,this._error(y);return}const v=this._input.charCodeAt(f);if(g)g=!1;else if(v===n.CharCode.Slash&&!w){f++;break}else v===n.CharCode.OpenSquareBracket?w=!0:v===n.CharCode.Backslash?g=!0:v===n.CharCode.CloseSquareBracket&&(w=!1);f++}for(;f<this._input.length&&a._regexFlags.has(this._input.charCodeAt(f));)f++;this._current=f;const d=this._input.substring(this._start,this._current);this._tokens.push({type:k.RegexStr,lexeme:d,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=a}),define(oe[205],ae([0,1,4,2]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class I{constructor(){this._onCloseEmitter=new n.Emitter,this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(R,y,a){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(R,y,a){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=I;class k extends o.Disposable{constructor(R){super(),this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,y,a){this.channel.call("attach",[R,y,a])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,y){this.channel.call("terminate",[R,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,y){return this.channel.call("openExtensionDevelopmentHostWindow",[R,y])}}e.ExtensionHostDebugChannelClient=k}),define(oe[206],ae([0,1,154,54,12,10,37,19,7]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=h,e.parseDebugParams=f,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,k.dirname)(I.FileAccess.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",w)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(y.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=C.env.VSCODE_PORTABLE;return w?y.URI.file((0,k.join)(w,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.resolve)(w):(0,k.normalize)((0,k.join)(I.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?y.URI.file((0,k.resolve)(w)):y.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.resolve)(w);const d=C.env.VSCODE_EXTENSIONS;if(d)return d;const v=C.env.VSCODE_PORTABLE;return v?(0,k.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(d=>/^[^:/?#]+?:\/\//.test(d)?y.URI.parse(d):y.URI.file((0,k.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?y.URI.parse(w):y.URI.file((0,k.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(w))}get extensionLogLevel(){const w=[];for(const d of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(d);v&&v[1]&&v[2]&&w.push([v[1],v[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=C.env.VSCODE_PORTABLE;return w?y.URI.file((0,k.join)(w,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this._args}constructor(w,d,v){this._args=w,this.paths=d,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,Pe([o.memoize],a.prototype,"appRoot",null),Pe([o.memoize],a.prototype,"userHome",null),Pe([o.memoize],a.prototype,"userDataPath",null),Pe([o.memoize],a.prototype,"appSettingsHome",null),Pe([o.memoize],a.prototype,"tmpDir",null),Pe([o.memoize],a.prototype,"cacheHome",null),Pe([o.memoize],a.prototype,"stateResource",null),Pe([o.memoize],a.prototype,"userRoamingDataHome",null),Pe([o.memoize],a.prototype,"userDataSyncHome",null),Pe([o.memoize],a.prototype,"sync",null),Pe([o.memoize],a.prototype,"machineSettingsResource",null),Pe([o.memoize],a.prototype,"workspaceStorageHome",null),Pe([o.memoize],a.prototype,"localHistoryHome",null),Pe([o.memoize],a.prototype,"keyboardLayoutResource",null),Pe([o.memoize],a.prototype,"argvResource",null),Pe([o.memoize],a.prototype,"isExtensionDevelopment",null),Pe([o.memoize],a.prototype,"untitledWorkspacesHome",null),Pe([o.memoize],a.prototype,"builtinExtensionsPath",null),Pe([o.memoize],a.prototype,"extensionsPath",null),Pe([o.memoize],a.prototype,"extensionDevelopmentLocationURI",null),Pe([o.memoize],a.prototype,"extensionDevelopmentKind",null),Pe([o.memoize],a.prototype,"extensionTestsLocationURI",null),Pe([o.memoize],a.prototype,"debugExtensionHost",null),Pe([o.memoize],a.prototype,"logLevel",null),Pe([o.memoize],a.prototype,"extensionLogLevel",null),Pe([o.memoize],a.prototype,"serviceMachineIdResource",null),Pe([o.memoize],a.prototype,"disableTelemetry",null),Pe([o.memoize],a.prototype,"disableWorkspaceTrust",null),Pe([o.memoize],a.prototype,"useInMemorySecretStorage",null),Pe([o.memoize],a.prototype,"policyFile",null);function h(g,w){return f(g["inspect-extensions"],g["inspect-brk-extensions"],5870,w,g.debugId,g.extensionEnvironment)}function f(g,w,d,v,E,p){const b=Number(w||g)||(v?null:d),D=b?!!w:!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:b,break:D,debugId:E,env:t}}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[121],ae([0,1,319,3,173]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=R,e.formatOptions=a,e.buildHelpMessage=w,e.buildVersionMessage=d,n=et(n);const k={o:(0,I.localize)(0,null),e:(0,I.localize)(1,null),t:(0,I.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,I.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(v,E,p=C){const m=v.find(u=>u.length>0&&u[0]!=="-"),b={},D=["_"],t=[],s={};let i;for(const u in E){const P=E[u];P.type==="subcommand"?u===m&&(i=P):(P.alias&&(b[u]=P.alias),P.type==="string"||P.type==="string[]"?(D.push(u),P.deprecates&&D.push(...P.deprecates)):P.type==="boolean"&&(t.push(u),P.deprecates&&t.push(...P.deprecates)),P.global&&(s[u]=P))}if(i&&m){const u=s;for(const T in i.options)u[T]=i.options[T];const P=v.filter(T=>T!==m),S=p.getSubcommandReporter?p.getSubcommandReporter(m):void 0,M=R(P,u,S);return{[m]:M,_:[]}}const c=(0,n.default)(v,{string:D,boolean:t,alias:b}),r={},l=c;r._=c._.map(u=>String(u)).filter(u=>u.length>0),delete l._;for(const u in E){const P=E[u];if(P.type==="subcommand")continue;P.alias&&delete l[P.alias];let S=l[u];if(P.deprecates)for(const M of P.deprecates)l.hasOwnProperty(M)&&(S||(S=l[M],S&&p.onDeprecatedOption(M,P.deprecationMessage||(0,I.localize)(39,null,u))),delete l[M]);if(typeof S<"u"){if(P.type==="string[]"){if(Array.isArray(S)||(S=[S]),!P.allowEmptyValue){const M=S.filter(T=>T.length>0);M.length!==S.length&&(p.onEmptyValue(u),S=M.length>0?M:void 0)}}else P.type==="string"&&(Array.isArray(S)?(S=S.pop(),p.onMultipleValues(u,S)):!S&&!P.allowEmptyValue&&(p.onEmptyValue(u),S=void 0));r[u]=S,P.deprecationMessage&&p.onDeprecatedOption(u,P.deprecationMessage)}delete l[u]}for(const u in l)p.onUnknownOption(u);return r}function y(v,E){let p="";return E.args&&(Array.isArray(E.args)?p=` <${E.args.join("> <")}>`:p=` <${E.args}>`),E.alias?`-${E.alias} --${v}${p}`:`--${v}${p}`}function a(v,E){const p=[];for(const m in v){const b=v[m],D=y(m,b);p.push([D,b.description])}return h(p,E)}function h(v,E){const m=v.reduce((t,s)=>Math.max(t,s[0].length),12)+2+1;if(E-m<25)return v.reduce((t,s)=>t.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const b=E-m-1,D=[];for(const t of v){const s=t[0],i=g(t[1],b),c=f(m-s.length-2);D.push("  "+s+c+i[0]);for(let r=1;r<i.length;r++)D.push(f(m)+i[r])}return D}function f(v){return" ".repeat(v)}function g(v,E){const p=[];for(;v.length;){const m=v.length<E?v.length:v.lastIndexOf(" ",E),b=v.slice(0,m).trim();v=v.slice(m),p.push(b)}return p}function w(v,E,p,m,b){const D=process.stdout.isTTY&&process.stdout.columns||80,t=b?.noInputFiles!==!0?`[${(0,I.localize)(40,null)}...]`:"",s=[`${v} ${p}`];s.push(""),s.push(`${(0,I.localize)(41,null)}: ${E} [${(0,I.localize)(42,null)}]${t}`),s.push(""),b?.noPipe!==!0&&(o.isWindows?s.push((0,I.localize)(43,null,E)):s.push((0,I.localize)(44,null,E)),s.push(""));const i={},c=[];for(const r in m){const l=m[r];if(l.type==="subcommand")l.description&&c.push({command:r,description:l.description});else if(l.description&&l.cat){let u=i[l.cat];u||(i[l.cat]=u={}),u[r]=l}}for(const r in i){const l=r,u=i[l];u&&(s.push(k[l]),s.push(...a(u,D)),s.push(""))}return c.length&&(s.push((0,I.localize)(45,null)),s.push(...h(c.map(r=>[r.command,r.description]),D)),s.push("")),s.join(`
`)}function d(v,E){return`${v||(0,I.localize)(46,null)}
${E||(0,I.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[69],ae([0,1,320,174,121]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=R,e.parseCLIProcessArgv=y,e.addArg=a,e.isLaunchedFromCli=h,n=et(n);function k(f,g){const w=(b,D)=>{console.warn((0,o.localize)(0,null,b,D))},d=b=>{console.warn((0,o.localize)(1,null,b))},v=(b,D)=>{console.warn((0,o.localize)(2,null,b,D))},E=b=>({onUnknownOption:D=>{I.NATIVE_CLI_COMMANDS.includes(b)||console.warn((0,o.localize)(3,null,D,b))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:v,getSubcommandReporter:I.NATIVE_CLI_COMMANDS.includes(b)?E:void 0}),p={onUnknownOption:b=>{console.warn((0,o.localize)(4,null,b))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:v,getSubcommandReporter:E},m=(0,I.parseArgs)(f,I.OPTIONS,g?p:void 0);return m.goto&&m._.forEach(b=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(b),(0,o.localize)(5,null))),m}function C(f){const g=f.findIndex(w=>!/^-/.test(w));if(g>-1)return[...f.slice(0,g),...f.slice(g+1)]}function R(f){let[,...g]=f;process.env.VSCODE_DEV&&(g=C(g)||[]);const w=!h(process.env);return k(g,w)}function y(f){let[,,...g]=f;return process.env.VSCODE_DEV&&(g=C(g)||[]),k(g,!0)}function a(f,...g){const w=f.indexOf("--");return w===-1?f.push(...g):f.splice(w,0,...g),f}function h(f){return f.VSCODE_CLI==="1"}}),function(){"use strict";function V(e,n,o){function I(C,R){const y=k(C,R),a=[y];return e.isAbsolute(y)||a.unshift(o),e.resolve(...a)}function k(C,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,R);const h=C["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(f,"AppData","Roaming")}break;case"darwin":a=e.join(n.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,R)}return{getUserDataPath:I}}if(typeof define=="function")define(oe[207],ae([122,27,37]),function(e,n,o){return V(e,n,o.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=V(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[96],ae([0,1,27,206,207]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=C,e.parseSharedProcessDebugPort=R;class k extends o.AbstractNativeEnvironmentService{constructor(a,h){super(a,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,I.getUserDataPath)(a,h.nameShort)},h)}}e.NativeEnvironmentService=k;function C(y,a){return(0,o.parseDebugParams)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,a,y.extensionEnvironment)}function R(y,a){return(0,o.parseDebugParams)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,a,y.extensionEnvironment)}}),define(oe[208],ae([0,1,47,27,31]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=k;function k(C){const R=(0,I.randomPath)((0,o.tmpdir)());try{return(0,n.writeFileSync)(R,""),C&&console.log(`Marker file for --wait created: ${R}`),R}catch(y){C&&console.error(`Failed to create marker file for --wait: ${y}`);return}}}),define(oe[209],ae([0,1,13,176]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=I;function I(C,R,y,a){try{k(C,R,y,a)}catch(h){C.error(h?.message??h)}return R}function k(C,R,y,a){const h=(f,g,w)=>{const d=f[g];if((0,n.isString)(d)){const v=d,E=v.length;if(E>1&&v[0]==="%"&&v[E-1]==="%"){const p=v.substr(1,E-2);let m=y[p];m===void 0&&a&&(m=a[p]);const b=typeof m=="string"?m:m?.message,D=a?.[p],t=typeof D=="string"?D:D?.message;if(!b){t||C.warn(`[${R.name}]: ${(0,o.localize)(0,null,p)}`);return}if(w&&(g==="title"||g==="category")&&t&&t!==b){const s={value:b,original:t};f[g]=s}else f[g]=b}}else if((0,n.isObject)(d))for(const v in d)d.hasOwnProperty(v)&&(v==="commands"?h(d,v,!0):h(d,v,w));else if(Array.isArray(d))for(let v=0;v<d.length;v++)h(d,v,w)};for(const f in R)R.hasOwnProperty(f)&&h(R,f)}}),define(oe[210],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(oe[84],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(I,k=[],C=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=n}),define(oe[211],ae([0,1,84]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=k,e.getSingletonServiceDescriptors=C;const o=[];var I;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function k(R,y,a){y instanceof n.SyncDescriptor||(y=new n.SyncDescriptor(y,[],!!a)),o.push([R,y])}function C(){return o}}),define(oe[212],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(k,C){this.key=k,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class o{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const C of this._nodes.values())C.outgoing.size===0&&k.push(C);return k}insertEdge(k,C){const R=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(C);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(k){const C=this._hashFn(k);this._nodes.delete(C);for(const R of this._nodes.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(k){const C=this._hashFn(k);let R=this._nodes.get(C);return R||(R=new n(C,k),this._nodes.set(C,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[C,R]of this._nodes)k.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,C]of this._nodes){const R=new Set([k]),y=this._findCycle(C,R);if(y)return y}}_findCycle(k,C){for(const[R,y]of k.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const a=this._findCycle(y,C);if(a)return a;C.delete(R)}}}e.Graph=o}),define(oe[6],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=k;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=R})(n||(e._util=n={})),e.IInstantiationService=I("instantiationService");function o(C,R,y){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:C,index:y}):(R[n.DI_DEPENDENCIES]=[{id:C,index:y}],R[n.DI_TARGET]=R)}function I(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const R=function(y,a,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");o(R,y,h)};return R.toString=()=>C,n.serviceIds.set(C,R),R}function k(C){return C}}),define(oe[85],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,n.createDecorator)("auxiliaryWindowsMainService")}),define(oe[70],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,n.createDecorator)("backupMainService")}),define(oe[18],ae([0,1,13,7,6]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=k,e.isConfigurationUpdateOverrides=C,e.ConfigurationTargetToString=y,e.isConfigured=a,e.toValuesTree=h,e.addToValueTree=f,e.removeFromValueTree=g,e.getConfigurationValue=d,e.merge=v,e.getLanguageTagSettingPlainKey=E,n=ke(n),e.IConfigurationService=(0,I.createDecorator)("configurationService");function k(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof o.URI)}function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof o.URI)}var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function y(p){switch(p){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function a(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function h(p,m){const b=Object.create(null);for(const D in p)f(b,D,p[D],m);return b}function f(p,m,b,D){const t=m.split("."),s=t.pop();let i=p;for(let c=0;c<t.length;c++){const r=t[c];let l=i[r];switch(typeof l){case"undefined":l=i[r]=Object.create(null);break;case"object":if(l===null){D(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is null`);return}break;default:D(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[s]=b}catch{D(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}else D(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}function g(p,m){const b=m.split(".");w(p,b)}function w(p,m){const b=m.shift();if(m.length===0){delete p[b];return}if(Object.keys(p).indexOf(b)!==-1){const D=p[b];typeof D=="object"&&!Array.isArray(D)&&(w(D,m),Object.keys(D).length===0&&delete p[b])}}function d(p,m,b){function D(i,c){let r=i;for(const l of c){if(typeof r!="object"||r===null)return;r=r[l]}return r}const t=m.split("."),s=D(p,t);return typeof s>"u"?b:s}function v(p,m,b){Object.keys(m).forEach(D=>{D!=="__proto__"&&(D in p?n.isObject(p[D])&&n.isObject(m[D])?v(p[D],m[D],b):b&&(p[D]=m[D]):p[D]=m[D])})}function E(p){return p.replace(/[\[\]]/g,"")}}),define(oe[123],ae([0,1,39,3,26,204,6,169,16]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=h,e.validateWhenClauses=c,e.expressionsAreEqualWithConstantSubstitution=r,e.implies=G;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",o.isMacintosh),a.set("isLinux",o.isLinux),a.set("isWindows",o.isWindows),a.set("isWeb",o.isWeb),a.set("isMacNative",o.isMacintosh&&!o.isWeb),a.set("isEdge",o.isEdge),a.set("isFirefox",o.isFirefox),a.set("isChrome",o.isChrome),a.set("isSafari",o.isSafari);function h(Z,W){if(a.get(Z)!==void 0)throw(0,y.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(Z,W)}const f=Object.prototype.hasOwnProperty;var g;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const w={regexParsingWithErrorRecovery:!0},d=(0,R.localize)(0,null),v=(0,R.localize)(1,null),E=(0,R.localize)(2,null),p=(0,R.localize)(3,null),m=(0,R.localize)(4,null),b=(0,R.localize)(5,null),D=(0,R.localize)(6,null),t=(0,R.localize)(7,null);class s{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=w){this._config=W,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:d,offset:0,lexeme:"",additionalInfo:v});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const F=this._expr();if(!this._isAtEnd()){const U=this._peek(),H=U.type===k.TokenType.Str?b:void 0;throw this._parsingErrors.push({message:m,offset:U.offset,lexeme:k.Scanner.getLexeme(U),additionalInfo:H}),s._parseError}return F}catch(F){if(F!==s._parseError)throw F;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(k.TokenType.Or);){const F=this._and();W.push(F)}return W.length===1?W[0]:i.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(k.TokenType.And);){const F=this._term();W.push(F)}return W.length===1?W[0]:i.and(...W)}_term(){if(this._matchOne(k.TokenType.Neg)){const W=this._peek();switch(W.type){case k.TokenType.True:return this._advance(),u.INSTANCE;case k.TokenType.False:return this._advance(),P.INSTANCE;case k.TokenType.LParen:{this._advance();const F=this._expr();return this._consume(k.TokenType.RParen,p),F?.negate()}case k.TokenType.Str:return this._advance(),_.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case k.TokenType.True:return this._advance(),i.true();case k.TokenType.False:return this._advance(),i.false();case k.TokenType.LParen:{this._advance();const F=this._expr();return this._consume(k.TokenType.RParen,p),F}case k.TokenType.Str:{const F=W.lexeme;if(this._advance(),this._matchOne(k.TokenType.RegexOp)){const H=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),H.type!==k.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",H);const Y=H.lexeme,Q=Y.lastIndexOf("/"),$=Q===Y.length-1?void 0:this._removeFlagsGY(Y.substring(Q+1));let ie;try{ie=new RegExp(Y.substring(1,Q),$)}catch{throw this._errExpectedButGot("REGEX",H)}return le.create(F,ie)}switch(H.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const Y=[H.lexeme];this._advance();let Q=this._peek(),$=0;for(let Ce=0;Ce<H.lexeme.length;Ce++)H.lexeme.charCodeAt(Ce)===n.CharCode.OpenParen?$++:H.lexeme.charCodeAt(Ce)===n.CharCode.CloseParen&&$--;for(;!this._isAtEnd()&&Q.type!==k.TokenType.And&&Q.type!==k.TokenType.Or;){switch(Q.type){case k.TokenType.LParen:$++;break;case k.TokenType.RParen:$--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Ce=0;Ce<Q.lexeme.length;Ce++)Q.lexeme.charCodeAt(Ce)===n.CharCode.OpenParen?$++:H.lexeme.charCodeAt(Ce)===n.CharCode.CloseParen&&$--}if($<0)break;Y.push(k.Scanner.getLexeme(Q)),this._advance(),Q=this._peek()}const ie=Y.join(""),fe=ie.lastIndexOf("/"),me=fe===ie.length-1?void 0:this._removeFlagsGY(ie.substring(fe+1));let we;try{we=new RegExp(ie.substring(1,fe),me)}catch{throw this._errExpectedButGot("REGEX",H)}return i.regex(F,we)}case k.TokenType.QuotedStr:{const Y=H.lexeme;this._advance();let Q=null;if(!(0,I.isFalsyOrWhitespace)(Y)){const $=Y.indexOf("/"),ie=Y.lastIndexOf("/");if($!==ie&&$>=0){const fe=Y.slice($+1,ie),me=Y[ie+1]==="i"?"i":"";try{Q=new RegExp(fe,me)}catch{throw this._errExpectedButGot("REGEX",H)}}}if(Q===null)throw this._errExpectedButGot("REGEX",H);return le.create(F,Q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(k.TokenType.Not)){this._consume(k.TokenType.In,E);const H=this._value();return i.notIn(F,H)}switch(this._peek().type){case k.TokenType.Eq:{this._advance();const H=this._value();if(this._previous().type===k.TokenType.QuotedStr)return i.equals(F,H);switch(H){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,H)}}case k.TokenType.NotEq:{this._advance();const H=this._value();if(this._previous().type===k.TokenType.QuotedStr)return i.notEquals(F,H);switch(H){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,H)}}case k.TokenType.Lt:return this._advance(),se.create(F,this._value());case k.TokenType.LtEq:return this._advance(),J.create(F,this._value());case k.TokenType.Gt:return this._advance(),N.create(F,this._value());case k.TokenType.GtEq:return this._advance(),z.create(F,this._value());case k.TokenType.In:return this._advance(),i.in(F,this._value());default:return i.has(F)}}case k.TokenType.EOF:throw this._parsingErrors.push({message:D,offset:W.offset,lexeme:"",additionalInfo:t}),s._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this._advance(),W.lexeme;case k.TokenType.True:return this._advance(),"true";case k.TokenType.False:return this._advance(),"false";case k.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,F){if(this._check(W))return this._advance();throw this._errExpectedButGot(F,this._peek())}_errExpectedButGot(W,F,U){const H=(0,R.localize)(8,null,W,k.Scanner.getLexeme(F)),Y=F.offset,Q=k.Scanner.getLexeme(F);return this._parsingErrors.push({message:H,offset:Y,lexeme:Q,additionalInfo:U}),s._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===k.TokenType.EOF}}e.Parser=s;class i{static false(){return u.INSTANCE}static true(){return P.INSTANCE}static has(W){return S.create(W)}static equals(W,F){return M.create(W,F)}static notEquals(W,F){return A.create(W,F)}static regex(W,F){return le.create(W,F)}static in(W,F){return T.create(W,F)}static notIn(W,F){return L.create(W,F)}static not(W){return _.create(W)}static and(...W){return q.create(W,null,!0)}static or(...W){return O.create(W,null,!0)}static greater(W,F){return N.create(W,F)}static greaterEquals(W,F){return z.create(W,F)}static smaller(W,F){return se.create(W,F)}static smallerEquals(W,F){return J.create(W,F)}static{this._parser=new s({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=i;function c(Z){const W=new s({regexParsingWithErrorRecovery:!1});return Z.map(F=>(W.parse(F),W.lexingErrors.length>0?W.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,R.localize)(9,null,U.additionalInfo):(0,R.localize)(10,null),offset:U.offset,length:U.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function r(Z,W){const F=Z?Z.substituteConstants():void 0,U=W?W.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}function l(Z,W){return Z.cmp(W)}class u{static{this.INSTANCE=new u}constructor(){this.type=g.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return P.INSTANCE}}e.ContextKeyFalseExpr=u;class P{static{this.INSTANCE=new P}constructor(){this.type=g.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=P;class S{static create(W,F=null){const U=a.get(W);return typeof U=="boolean"?U?P.INSTANCE:u.INSTANCE:new S(W,F)}constructor(W,F){this.key=W,this.negated=F,this.type=g.Defined}cmp(W){return W.type!==this.type?this.type-W.type:j(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=a.get(this.key);return typeof W=="boolean"?W?P.INSTANCE:u.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class M{static create(W,F,U=null){if(typeof F=="boolean")return F?S.create(W,U):_.create(W,U);const H=a.get(W);return typeof H=="boolean"?F===(H?"true":"false")?P.INSTANCE:u.INSTANCE:new M(W,F,U)}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=a.get(this.key);if(typeof W=="boolean"){const F=W?"true":"false";return this.value===F?P.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=M;class T{static create(W,F){return new T(W,F)}constructor(W,F){this.key=W,this.valueKey=F,this.type=g.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const F=W.getValue(this.valueKey),U=W.getValue(this.key);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?f.call(F,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=T;class L{static create(W,F){return new L(W,F)}constructor(W,F){this.key=W,this.valueKey=F,this.type=g.NotIn,this._negated=T.create(W,F)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=L;class A{static create(W,F,U=null){if(typeof F=="boolean")return F?_.create(W,U):S.create(W,U);const H=a.get(W);return typeof H=="boolean"?F===(H?"true":"false")?u.INSTANCE:P.INSTANCE:new A(W,F,U)}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=a.get(this.key);if(typeof W=="boolean"){const F=W?"true":"false";return this.value===F?u.INSTANCE:P.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class _{static create(W,F=null){const U=a.get(W);return typeof U=="boolean"?U?u.INSTANCE:P.INSTANCE:new _(W,F)}constructor(W,F){this.key=W,this.negated=F,this.type=g.Not}cmp(W){return W.type!==this.type?this.type-W.type:j(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=a.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:P.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function B(Z,W){if(typeof Z=="string"){const F=parseFloat(Z);isNaN(F)||(Z=F)}return typeof Z=="string"||typeof Z=="number"?W(Z):u.INSTANCE}class N{static create(W,F,U=null){return B(F,H=>new N(W,H,U))}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class z{static create(W,F,U=null){return B(F,H=>new z(W,H,U))}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=z;class se{static create(W,F,U=null){return B(F,H=>new se(W,H,U))}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=se;class J{static create(W,F,U=null){return B(F,H=>new J(W,H,U))}constructor(W,F,U){this.key=W,this.value=F,this.negated=U,this.type=g.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=J;class le{static create(W,F){return new le(W,F)}constructor(W,F){this.key=W,this.regexp=F,this.type=g.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const F=this.regexp?this.regexp.source:"",U=W.regexp?W.regexp.source:"";return F<U?-1:F>U?1:0}equals(W){if(W.type===this.type){const F=this.regexp?this.regexp.source:"",U=W.regexp?W.regexp.source:"";return this.key===W.key&&F===U}return!1}substituteConstants(){return this}evaluate(W){const F=W.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=K.create(this)),this.negated}}e.ContextKeyRegexExpr=le;class K{static create(W){return new K(W)}constructor(W){this._actual=W,this.type=g.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new K(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=K;function ee(Z){let W=null;for(let F=0,U=Z.length;F<U;F++){const H=Z[F].substituteConstants();if(Z[F]!==H&&W===null){W=[];for(let Y=0;Y<F;Y++)W[Y]=Z[Y]}W!==null&&(W[F]=H)}return W===null?Z:W}class q{static create(W,F,U){return q._normalizeArr(W,F,U)}constructor(W,F){this.expr=W,this.negated=F,this.type=g.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const H=l(this.expr[F],W.expr[F]);if(H!==0)return H}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(W.expr[F]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:q.create(W,this.negated,!1)}evaluate(W){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(W))return!1;return!0}static _normalizeArr(W,F,U){const H=[];let Y=!1;for(const Q of W)if(Q){if(Q.type===g.True){Y=!0;continue}if(Q.type===g.False)return u.INSTANCE;if(Q.type===g.And){H.push(...Q.expr);continue}H.push(Q)}if(H.length===0&&Y)return P.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(l);for(let Q=1;Q<H.length;Q++)H[Q-1].equals(H[Q])&&(H.splice(Q,1),Q--);if(H.length===1)return H[0];for(;H.length>1;){const Q=H[H.length-1];if(Q.type!==g.Or)break;H.pop();const $=H.pop(),ie=H.length===0,fe=O.create(Q.expr.map(me=>q.create([me,$],null,U)),null,ie);fe&&(H.push(fe),H.sort(l))}if(H.length===1)return H[0];if(U){for(let Q=0;Q<H.length;Q++)for(let $=Q+1;$<H.length;$++)if(H[Q].negate().equals(H[$]))return u.INSTANCE;if(H.length===1)return H[0]}return new q(H,F)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const F of this.expr)W.push(...F.keys());return W}map(W){return new q(this.expr.map(F=>F.map(W)),null)}negate(){if(!this.negated){const W=[];for(const F of this.expr)W.push(F.negate());this.negated=O.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=q;class O{static create(W,F,U){return O._normalizeArr(W,F,U)}constructor(W,F){this.expr=W,this.negated=F,this.type=g.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const H=l(this.expr[F],W.expr[F]);if(H!==0)return H}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(W.expr[F]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:O.create(W,this.negated,!1)}evaluate(W){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(W))return!0;return!1}static _normalizeArr(W,F,U){let H=[],Y=!1;if(W){for(let Q=0,$=W.length;Q<$;Q++){const ie=W[Q];if(ie){if(ie.type===g.False){Y=!0;continue}if(ie.type===g.True)return P.INSTANCE;if(ie.type===g.Or){H=H.concat(ie.expr);continue}H.push(ie)}}if(H.length===0&&Y)return u.INSTANCE;H.sort(l)}if(H.length!==0){if(H.length===1)return H[0];for(let Q=1;Q<H.length;Q++)H[Q-1].equals(H[Q])&&(H.splice(Q,1),Q--);if(H.length===1)return H[0];if(U){for(let Q=0;Q<H.length;Q++)for(let $=Q+1;$<H.length;$++)if(H[Q].negate().equals(H[$]))return P.INSTANCE;if(H.length===1)return H[0]}return new O(H,F)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const F of this.expr)W.push(...F.keys());return W}map(W){return new O(this.expr.map(F=>F.map(W)),null)}negate(){if(!this.negated){const W=[];for(const F of this.expr)W.push(F.negate());for(;W.length>1;){const F=W.shift(),U=W.shift(),H=[];for(const Y of re(F))for(const Q of re(U))H.push(q.create([Y,Q],null,!1));W.unshift(O.create(H,null,!1))}this.negated=O.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=O;class x extends S{static{this._info=[]}static all(){return x._info.values()}constructor(W,F,U){super(W,null),this._defaultValue=F,typeof U=="object"?x._info.push({...U,key:W}):U!==!0&&x._info.push({key:W,description:U,type:F!=null?typeof F:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return M.create(this.key,W)}notEqualsTo(W){return A.create(this.key,W)}}e.RawContextKey=x,e.IContextKeyService=(0,C.createDecorator)("contextKeyService");function j(Z,W){return Z<W?-1:Z>W?1:0}function ce(Z,W,F,U){return Z<F?-1:Z>F?1:W<U?-1:W>U?1:0}function G(Z,W){if(Z.type===g.False||W.type===g.True)return!0;if(Z.type===g.Or)return W.type===g.Or?de(Z.expr,W.expr):!1;if(W.type===g.Or){for(const F of W.expr)if(G(Z,F))return!0;return!1}if(Z.type===g.And){if(W.type===g.And)return de(W.expr,Z.expr);for(const F of Z.expr)if(G(F,W))return!0;return!1}return Z.equals(W)}function de(Z,W){let F=0,U=0;for(;F<Z.length&&U<W.length;){const H=Z[F].cmp(W[U]);if(H<0)return!1;H===0&&F++,U++}return F===Z.length}function re(Z){return Z.type===g.Or?Z.expr:[Z]}}),define(oe[97],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=o,e.ID="diagnosticsService",e.IDiagnosticsService=(0,n.createDecorator)(e.ID);function o(k){return!!k.hostName&&!!k.errorMessage}class I{async getPerformanceInfo(C,R){return{}}async getSystemInfo(C,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,R){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=I});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[124],ae([0,1,19,81,171,6,48,3,36]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=w,e.massageMessageBoxOptions=d,o=et(o),e.IDialogService=(0,k.createDecorator)("dialogService");var a;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(a||(a={}));class h{getConfirmationButtons(E){return this.getButtons(E,a.Confirmation)}getPromptButtons(E){return this.getButtons(E,a.Prompt)}getInputButtons(E){return this.getButtons(E,a.Input)}getButtons(E,p){const m=[];switch(p){case a.Confirmation:{const b=E;b.primaryButton?m.push(b.primaryButton):m.push((0,I.localize)(0,null)),b.cancelButton?m.push(b.cancelButton):m.push((0,I.localize)(1,null));break}case a.Prompt:{const b=E;Array.isArray(b.buttons)&&b.buttons.length>0&&m.push(...b.buttons.map(D=>D.label)),b.cancelButton&&(b.cancelButton===!0?m.push((0,I.localize)(2,null)):typeof b.cancelButton=="string"?m.push(b.cancelButton):b.cancelButton.label?m.push(b.cancelButton.label):m.push((0,I.localize)(3,null))),m.length===0&&m.push((0,I.localize)(4,null));break}case a.Input:{const b=E;b.primaryButton?m.push(b.primaryButton):m.push((0,I.localize)(5,null)),b.cancelButton?m.push(b.cancelButton):m.push((0,I.localize)(6,null));break}}return m}getDialogType(E){if(typeof E=="string")return E;if(typeof E=="number")return E===o.default.Info?"info":E===o.default.Error?"error":E===o.default.Warning?"warning":"none"}getPromptResult(E,p,m){const b=[...E.buttons??[]];E.cancelButton&&typeof E.cancelButton!="string"&&typeof E.cancelButton!="boolean"&&b.push(E.cancelButton);let D=b[p]?.run({checkboxChecked:m});return D instanceof Promise||(D=Promise.resolve(D)),{result:D,checkboxChecked:m}}}e.AbstractDialogHandler=h,e.IFileDialogService=(0,k.createDecorator)("fileDialogService");var f;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const g=10;function w(v){const E=[];return E.push(...v.slice(0,g).map(p=>typeof p=="string"?p:(0,n.basename)(p))),v.length>g&&(v.length-g===1?E.push((0,I.localize)(7,null)):E.push((0,I.localize)(8,null,v.length-g))),E.push(""),E.join(`
`)}function d(v,E){const p=(0,y.deepClone)(v);let m=(p.buttons??[]).map(s=>(0,C.mnemonicButtonLabel)(s)),b=(v.buttons||[]).map((s,i)=>i),D=0,t=p.cancelId??m.length-1;if(m.length>1){const s=typeof t=="number"?m[t]:void 0;if(R.isLinux||R.isMacintosh){if(typeof s=="string"&&m.length>1&&t!==1){m.splice(t,1),m.splice(1,0,s);const i=b[t];b.splice(t,1),b.splice(1,0,i),t=1}R.isLinux&&m.length>1&&(m=m.reverse(),b=b.reverse(),D=m.length-1,typeof s=="string"&&(t=D-1))}else if(R.isWindows&&typeof s=="string"&&m.length>1&&t!==m.length-1){m.splice(t,1),m.push(s);const i=b[t];b.splice(t,1),b.push(i),t=m.length-1}}return p.buttons=m,p.defaultId=D,p.cancelId=t,p.noLink=!0,p.title=p.title||E.nameLong,{options:p,buttonIndeces:b}}}),define(oe[98],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=k,e.isGnome=C,e.IEncryptionService=(0,n.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,n.createDecorator)("encryptionMainService");var o;(function(R){R.kwallet="kwallet",R.kwallet5="kwallet5",R.gnomeLibsecret="gnome-libsecret",R.basic="basic"})(o||(e.PasswordStoreCLIOption=o={}));var I;(function(R){R.unknown="unknown",R.basicText="basic_text",R.gnomeAny="gnome_any",R.gnomeLibsecret="gnome_libsecret",R.gnomeKeyring="gnome_keyring",R.kwallet="kwallet",R.kwallet5="kwallet5",R.kwallet6="kwallet6",R.dplib="dpapi",R.keychainAccess="keychain_access"})(I||(e.KnownStorageProvider=I={}));function k(R){return R===I.kwallet||R===I.kwallet5||R===I.kwallet6}function C(R){return R===I.gnomeAny||R===I.gnomeLibsecret||R===I.gnomeKeyring}}),define(oe[38],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[213],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,n.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(oe[214],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,n.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(oe[215],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,n.createDecorator)("externalTerminal")}),define(oe[216],ae([0,1,49,54,12,10,3,82,21,95,179,214]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,n=ke(n),k=ke(k),C=ke(C),y=ke(y),a=ke(a),h=ke(h);const g=h.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends w{static{this.CMD="cmd.exe"}openTerminal(t,s){return this.spawnTerminal(n,t,a.getWindowsShell(),s)}spawnTerminal(t,s,i,c){const r=s.windowsExec||d.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const l=k.basename(r,".exe").toLowerCase();if(l==="cmder")return t.spawn(r,c?[c]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return r.indexOf(" ")>=0&&u.push('""'),u.push(r),l==="wt"&&u.push("-d ."),new Promise((P,S)=>{const M=p(process),T=t.spawn(i,u,{cwd:c,env:M,detached:!0});T.on("error",S),T.on("exit",()=>P())})}async runInTerminal(t,s,i,c,r){const l="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows(),u=await d.getWtExePath();return new Promise((P,S)=>{const M=`"${s} - ${g}"`,T=`"${i.join('" "')}" & pause`,L=Object.assign({},p(process),c);Object.keys(L).filter(z=>L[z]===null).forEach(z=>delete L[z]);const A={cwd:s,env:L,windowsVerbatimArguments:!0};let _,B;k.basename(l,".exe")==="wt"?(_=l,B=["-d",".",d.CMD,"/c",T]):u?(_=u,B=["-d",".",l,"/c",T]):(_=d.CMD,B=["/c","start",M,"/wait",l,"/c",`"${T}"`]),n.spawn(_,B,A).on("error",z=>{S(m(z))}),P(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const t=await a.win32.findExecutable("wt");return await y.Promises.exists(t)?t:void 0}catch{return}}}e.WindowsExternalTerminalService=d,Pe([o.memoize],d,"getWtExePath",null);class v extends w{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(t,s){return this.spawnTerminal(n,t,s)}runInTerminal(t,s,i,c,r){const l=r.osxExec||f.DEFAULT_TERMINAL_OSX;return new Promise((u,P)=>{if(l===f.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const S=l===f.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",t||g,"-w",s];for(const _ of i)T.push("-a"),T.push(_);if(c){const _=Object.assign({},p(process),c);for(const B in _){const N=_[B];N===null?(T.push("-u"),T.push(B)):(T.push("-e"),T.push(`${B}=${N}`))}}let L="";const A=n.spawn(v.OSASCRIPT,T);A.on("error",_=>{P(m(_))}),A.stderr.on("data",_=>{L+=_.toString()}),A.on("exit",_=>{if(_===0)u(void 0);else if(L){const B=L.split(`
`,1);P(new Error(B[0]))}else P(new Error(h.localize(1,null,S,_)))})}else P(new Error(h.localize(2,null,l)))})}spawnTerminal(t,s,i){const c=s.osxExec||f.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{const u=["-a",c];i&&u.push(i);const P=p(process),S=t.spawn("/usr/bin/open",u,{cwd:i,env:P});S.on("error",l),S.on("exit",()=>r())})}}e.MacExternalTerminalService=v;class E extends w{static{this.WAIT_MESSAGE=h.localize(3,null)}openTerminal(t,s){return this.spawnTerminal(n,t,s)}runInTerminal(t,s,i,c,r){const l=r.linuxExec?Promise.resolve(r.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((u,P)=>{const S=[];l.then(M=>{M.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const T=`${b(i)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;S.push(`''${T}''`);const L=Object.assign({},p(process),c);Object.keys(L).filter(N=>L[N]===null).forEach(N=>delete L[N]);const A={cwd:s,env:L};let _="";const B=n.spawn(M,S,A);B.on("error",N=>{P(m(N))}),B.stderr.on("data",N=>{_+=N.toString()}),B.on("exit",N=>{if(N===0)u(void 0);else if(_){const z=_.split(`
`,1);P(new Error(z[0]))}else P(new Error(h.localize(4,null,M,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const t=await y.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(s=>{t?s("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?s("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?s("konsole"):process.env.COLORTERM?s(process.env.COLORTERM):process.env.TERM?s(process.env.TERM):s("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,s,i){const c=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{c.then(u=>{const P=p(process),S=t.spawn(u,[],{cwd:i,env:P});S.on("error",l),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=E;function p(D){const t={...D.env};return(0,R.sanitizeProcessEnvironment)(t),t}function m(D){return"errno"in D&&D.errno==="ENOENT"&&"path"in D&&typeof D.path=="string"?new Error(h.localize(5,null,D.path)):D}function b(D){let t="";for(const s of D)s.indexOf(" ")>=0?t+='"'+s+'"':t+=s,t+=" ";return t}}),define(oe[15],ae([0,1,61,10,26,13,7,181,6,3,12,66]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=g,e.isFileSystemWatcher=E,e.hasReadWriteCapability=m,e.hasFileFolderCopyCapability=b,e.hasFileCloneCapability=D,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=s,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=c,e.hasFileAtomicDeleteCapability=r,e.hasReadonlyCapability=l,e.createFileSystemProviderError=S,e.ensureFileSystemProviderError=M,e.markAsFileSystemProviderError=T,e.toFileSystemProviderErrorCode=L,e.toFileOperationResult=A,e.isParent=se,e.etag=O,e.whenProviderRegistered=x,e.getLargeFileConfirmationLimit=ce,e.IFileService=(0,y.createDecorator)("fileService");function g(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var d;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var v;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(v||(e.FileChangeFilter=v={}));function E(G){const de=G;return!!de&&typeof de.onDidChange=="function"}var p;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function m(G){return!!(G.capabilities&p.FileReadWrite)}function b(G){return!!(G.capabilities&p.FileFolderCopy)}function D(G){return!!(G.capabilities&p.FileClone)}function t(G){return!!(G.capabilities&p.FileOpenReadWriteClose)}function s(G){return!!(G.capabilities&p.FileReadStream)}function i(G){return m(G)?!!(G.capabilities&p.FileAtomicRead):!1}function c(G){return m(G)?!!(G.capabilities&p.FileAtomicWrite):!1}function r(G){return!!(G.capabilities&p.FileAtomicDelete)}function l(G){return!!(G.capabilities&p.Readonly)}var u;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class P extends Error{static create(de,re){const Z=new P(de.toString(),re);return T(Z,re),Z}constructor(de,re){super(de),this.code=re}}e.FileSystemProviderError=P;function S(G,de){return P.create(G,de)}function M(G){return G||S((0,R.localize)(0,null),u.Unknown)}function T(G,de){return G.name=de?`${de} (FileSystemError)`:"FileSystemError",G}function L(G){if(!G)return u.Unknown;if(G instanceof P)return G.code;const de=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!de)return u.Unknown;switch(de[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function A(G){if(G instanceof J)return G.fileOperationResult;switch(L(G)){case u.FileNotFound:return ee.FILE_NOT_FOUND;case u.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case u.NoPermissions:return ee.FILE_PERMISSION_DENIED;case u.FileExists:return ee.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var _;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class B{constructor(de,re,Z){this.resource=de,this.operation=re,this.target=Z}isOperation(de){return this.operation===de}}e.FileOperationEvent=B;var N;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class z{static{this.MIXED_CORRELATION=null}constructor(de,re){this.ignorePathCasing=re,this.correlationId=void 0,this.added=new f.Lazy(()=>{const Z=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawAdded.map(W=>[W,!0])),Z}),this.updated=new f.Lazy(()=>{const Z=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawUpdated.map(W=>[W,!0])),Z}),this.deleted=new f.Lazy(()=>{const Z=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawDeleted.map(W=>[W,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of de){switch(Z.type){case N.ADDED:this.rawAdded.push(Z.resource);break;case N.UPDATED:this.rawUpdated.push(Z.resource);break;case N.DELETED:this.rawDeleted.push(Z.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof Z.cId=="number"?this.correlationId===void 0?this.correlationId=Z.cId:this.correlationId!==Z.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(de,...re){return this.doContains(de,{includeChildren:!1},...re)}affects(de,...re){return this.doContains(de,{includeChildren:!0},...re)}doContains(de,re,...Z){if(!de)return!1;const W=Z.length>0;return!!((!W||Z.includes(N.ADDED))&&(this.added.value.get(de)||re.includeChildren&&this.added.value.findSuperstr(de))||(!W||Z.includes(N.UPDATED))&&(this.updated.value.get(de)||re.includeChildren&&this.updated.value.findSuperstr(de))||(!W||Z.includes(N.DELETED))&&(this.deleted.value.findSubstr(de)||re.includeChildren&&this.deleted.value.findSuperstr(de)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(de){return this.correlationId===de}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function se(G,de,re){return!G||!de||G===de||de.length>G.length?!1:(de.charAt(de.length-1)!==o.sep&&(de+=o.sep),re?(0,I.startsWithIgnoreCase)(G,de):G.indexOf(de)===0)}class J extends Error{constructor(de,re,Z){super(de),this.fileOperationResult=re,this.options=Z}}e.FileOperationError=J;class le extends J{constructor(de,re,Z,W){super(de,re,W),this.fileOperationResult=re,this.size=Z}}e.TooLargeFileOperationError=le;class K extends J{constructor(de,re,Z){super(de,ee.FILE_NOT_MODIFIED_SINCE,Z),this.stat=re}}e.NotModifiedSinceFileOperationError=K;var ee;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var q;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function O(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function x(G,de){if(!de.hasProvider(C.URI.from({scheme:G.scheme})))return new Promise(re=>{const Z=de.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===G.scheme&&W.added&&(Z.dispose(),re())})})}class j{static{this.KB=1024}static{this.MB=j.KB*j.KB}static{this.GB=j.MB*j.KB}static{this.TB=j.GB*j.KB}static formatSize(de){return(0,k.isNumber)(de)||(de=0),de<j.KB?(0,R.localize)(1,null,de.toFixed(0)):de<j.MB?(0,R.localize)(2,null,(de/j.KB).toFixed(2)):de<j.GB?(0,R.localize)(3,null,(de/j.MB).toFixed(2)):de<j.TB?(0,R.localize)(4,null,(de/j.GB).toFixed(2)):(0,R.localize)(5,null,(de/j.TB).toFixed(2))}}e.ByteSize=j;function ce(G){const de=typeof G=="string"||G?.scheme===h.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===h.Schemas.file?1024*j.MB:de?10*j.MB:a.isWeb?50*j.MB:1024*j.MB}}),define(oe[125],ae([0,1,17,16,182,15]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=C;async function C(h,f,g,w,d,v){let E;try{await R(h,f,g,w,d,v)}catch(p){E=p}finally{E&&d.errorTransformer&&(E=d.errorTransformer(E)),typeof E<"u"&&g.error(E),g.end()}}async function R(h,f,g,w,d,v){y(v);const E=await h.open(f,{create:!1});try{y(v);let p=0,m=0,b=d&&typeof d.length=="number"?d.length:void 0,D=n.VSBuffer.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),t=d&&typeof d.position=="number"?d.position:0,s=0;do m=await h.read(E,t,D.buffer,s,D.byteLength-s),t+=m,s+=m,p+=m,typeof b=="number"&&(b-=m),s===D.byteLength&&(await g.write(w(D)),D=n.VSBuffer.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),s=0);while(m>0&&(typeof b!="number"||b>0)&&y(v)&&a(p,d));if(s>0){let i=s;typeof b=="number"&&(i=Math.min(s,b)),g.write(w(D.slice(0,i)))}}catch(p){throw(0,k.ensureFileSystemProviderError)(p)}finally{await h.close(E)}}function y(h){if(h.isCancellationRequested)throw(0,o.canceled)();return!0}function a(h,f){if(typeof f?.limits?.size=="number"&&h>f.limits.size)throw(0,k.createFileSystemProviderError)((0,I.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[62],ae([0,1,113,2,10,3,7,15]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=y,e.isRecursiveWatchRequest=a,e.reviveFileChanges=w,e.coalesceEvents=d,e.normalizeWatcherPattern=v,e.parseWatcherPatterns=E,e.isFiltered=m,e.requestFilterToString=b;function y(D){return typeof D.correlationId=="number"}function a(D){return D.recursive===!0}class h extends o.Disposable{static{this.MAX_RESTARTS=5}constructor(t,s,i,c){super(),this.onFileChanges=t,this.onLogMessage=s,this.verboseLogging=i,this.options=c,this.watcherDisposables=this._register(new o.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new o.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(s=>this.onFileChanges(s))),t.add(this.watcher.onDidLogMessage(s=>this.onLogMessage(s))),t.add(this.watcher.onDidError(s=>this.onError(s.error,s.request)))}onError(t,s){this.canRestart(t,s)?this.restartCounter<h.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${t}`):this.error(t)}canRestart(t,s){return!(!this.options.restartOnError||s||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}trace(t){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=h;class f extends h{constructor(t,s,i){super(t,s,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=f;class g extends h{constructor(t,s,i){super(t,s,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=g;function w(D){return D.map(t=>({type:t.type,resource:C.URI.revive(t.resource),cId:t.cId}))}function d(D){const t=new p;for(const s of D)t.processEvent(s);return t.coalesce()}function v(D,t){return typeof t=="string"&&!t.startsWith(n.GLOBSTAR)&&!(0,I.isAbsolute)(t)?{base:D,pattern:t}:t}function E(D,t){const s=[];for(const i of t)s.push((0,n.parse)(v(D,i)));return s}class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return k.isLinux?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const s=this.mapPathToChange.get(this.toKey(t));let i=!1;if(s){const c=s.type,r=t.type;s.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?i=!0:c===R.FileChangeType.ADDED&&r===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(s)):c===R.FileChangeType.DELETED&&r===R.FileChangeType.ADDED?s.type=R.FileChangeType.UPDATED:c===R.FileChangeType.ADDED&&r===R.FileChangeType.UPDATED||(s.type=r)}else i=!0;i&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],s=[];return Array.from(this.coalesced).filter(i=>i.type!==R.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,c)=>i.resource.fsPath.length-c.resource.fsPath.length).filter(i=>s.some(c=>(0,R.isParent)(i.resource.fsPath,c,!k.isLinux))?!1:(s.push(i.resource.fsPath),!0)).concat(t)}}function m(D,t){if(typeof t=="number")switch(D.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function b(D){if(typeof D=="number"){const t=[];return D&R.FileChangeFilter.ADDED&&t.push("Added"),D&R.FileChangeFilter.DELETED&&t.push("Deleted"),D&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(oe[217],ae([0,1,17,55,16,4,2,68,33,15,62]),function(V,e,n,o,I,k,C,R,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class f extends C.Disposable{constructor(w,d){super(),this.channel=w,this.extraCapabilities=d,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=a.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,d){const{buffer:v}=await this.channel.call("readFile",[w,d]);return v}readFileStream(w,d,v){const E=(0,R.newWriteableStream)(m=>n.VSBuffer.concat(m.map(b=>n.VSBuffer.wrap(b))).buffer),p=new C.DisposableStore;return p.add(this.channel.listen("readFileStream",[w,d])(m=>{if(m instanceof n.VSBuffer)E.write(m.buffer);else{if(m==="end")E.end();else{let b;if(m instanceof Error)b=m;else{const D=m;b=(0,a.createFileSystemProviderError)(D.message??(0,o.toErrorMessage)(D),D.code??a.FileSystemProviderErrorCode.Unknown)}E.error(b),E.end()}p.dispose()}})),p.add(v.onCancellationRequested(()=>{E.error((0,I.canceled)()),E.end(),p.dispose()})),E}writeFile(w,d,v){return this.channel.call("writeFile",[w,n.VSBuffer.wrap(d),v])}open(w,d){return this.channel.call("open",[w,d])}close(w){return this.channel.call("close",[w])}async read(w,d,v,E,p){const[m,b]=await this.channel.call("read",[w,d,p]);return v.set(m.buffer.slice(0,b),E),b}write(w,d,v,E,p){return this.channel.call("write",[w,d,n.VSBuffer.wrap(v),E,p])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,d){return this.channel.call("delete",[w,d])}rename(w,d,v){return this.channel.call("rename",[w,d,v])}copy(w,d,v){return this.channel.call("copy",[w,d,v])}cloneFile(w,d){return this.channel.call("cloneFile",[w,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const d=w;this._onDidChange.fire((0,h.reviveFileChanges)(d))}else{const d=w;this._onDidWatchError.fire(d)}}))}watch(w,d){const v=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,v,w,d]),(0,C.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=f}),define(oe[218],ae([0,1,47,2,62,4,15,7,8]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class a extends o.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new k.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new o.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new y.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new y.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(f=>this.handleDidWatchFail(f)))}handleDidWatchFail(f){this.isCorrelated(f)&&this.suspendWatchRequest(f)}isCorrelated(f){return(0,I.isWatchRequestWithCorrelation)(f)}async watch(f){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new y.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const g of f)this.isCorrelated(g)?this.allCorrelatedWatchRequests.set(g.correlationId,g):this.allNonCorrelatedWatchRequests.add(g);for(const[g]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(g)||(this.suspendedWatchRequests.deleteAndDispose(g),this.suspendedWatchRequestsWithPolling.delete(g));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(f){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(g=>!this.suspendedWatchRequests.has(g.correlationId))]),f?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(f){return typeof f.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(f.correlationId)?"polling":this.suspendedWatchRequests.has(f.correlationId)}async suspendWatchRequest(f){if(this.suspendedWatchRequests.has(f.correlationId))return;const g=new o.DisposableStore;this.suspendedWatchRequests.set(f.correlationId,g),await this.joinWatch.p,!g.isDisposed&&(this.monitorSuspendedWatchRequest(f,g),this.updateWatchers(!0))}resumeWatchRequest(f){this.suspendedWatchRequests.deleteAndDispose(f.correlationId),this.suspendedWatchRequestsWithPolling.delete(f.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(f,g){this.doMonitorWithExistingWatcher(f,g)?(this.trace(`reusing an existing recursive watcher to monitor ${f.path}`),this.suspendedWatchRequestsWithPolling.delete(f.correlationId)):(this.doMonitorWithNodeJS(f,g),this.suspendedWatchRequestsWithPolling.add(f.correlationId))}doMonitorWithExistingWatcher(f,g){const w=this.recursiveWatcher?.subscribe(f.path,(d,v)=>{g.isDisposed||(d?this.monitorSuspendedWatchRequest(f,g):v?.type===C.FileChangeType.ADDED&&this.onMonitoredPathAdded(f))});return w?(g.add(w),!0):!1}doMonitorWithNodeJS(f,g){let w=!1;const d=(v,E)=>{if(g.isDisposed)return;const p=this.isPathNotFound(v),m=this.isPathNotFound(E),b=w;w=p,!p&&(m||b)&&this.onMonitoredPathAdded(f)};this.trace(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.watchFile)(f.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},d)}catch(v){this.warn(`fs.watchFile() failed with error ${v} on path ${f.path} (correlationId: ${f.correlationId})`)}g.add((0,o.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.unwatchFile)(f.path,d)}catch(v){this.warn(`fs.unwatchFile() failed with error ${v} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}onMonitoredPathAdded(f){this.trace(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const g={resource:R.URI.file(f.path),type:C.FileChangeType.ADDED,cId:f.correlationId};this._onDidChangeFile.fire([g]),this.traceEvent(g,f),this.resumeWatchRequest(f)}isPathNotFound(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(f,g){if(this.verboseLogging){const w=` >> normalized ${f.type===C.FileChangeType.ADDED?"[ADDED]":f.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.traceWithCorrelation(w,g)}}traceWithCorrelation(f,g){this.verboseLogging&&this.trace(`${f}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}requestToString(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,I.requestFilterToString)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.verboseLogging=f}}e.BaseWatcher=a}),define(oe[219],ae([0,1,47,8,23,31,2,79,10,3,19,7,114,21,15,62]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=p;class E extends C.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(b,D,t,s,i,c){super(),this.request=b,this.recursiveWatcher=D,this.onDidFilesChange=t,this.onDidWatchFail=s,this.onLogMessage=i,this.verboseLogging=c,this.throttledFileChangesEmitter=this._register(new o.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.onDidFilesChange(r))),this.fileChangesAggregator=this._register(new o.RunOnceWorker(r=>this.handleFileChanges(r),E.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,v.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new I.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const D=await w.Promises.stat(b);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(b,D.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${b})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(b){let D=b.path;try{D=await w.Promises.realpath(b.path),b.path===D&&(D=await(0,g.realcase)(b.path,this.cts.token)??b.path),b.path!==D&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${D})`)}catch{}return D}async doWatch(b,D){const t=new C.DisposableStore;return this.doWatchWithExistingWatcher(b,D,t)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(b,D,t)),t}doWatchWithExistingWatcher(b,D,t){if(D)return!1;const s=f.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(c,r)=>{if(!t.isDisposed)if(c){const l=await this.doWatch(b,D);t.isDisposed?l.dispose():t.add(l)}else r&&(typeof r.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:s,type:r.type,cId:this.request.correlationId},!0)});return i?(t.add(i),!0):!1}async doWatchWithNodeJS(b,D,t){if(a.isMacintosh&&(0,k.isEqualOrParent)(b,"/Volumes/",!0)){this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new I.CancellationTokenSource(this.cts.token);t.add((0,C.toDisposable)(()=>s.dispose(!0)));const i=new C.DisposableStore;t.add(i);try{const c=f.URI.file(this.request.path),r=(0,y.basename)(b),l=(0,n.watch)(b);i.add((0,C.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${b}'`);const u=new Set;if(D)try{for(const S of await w.Promises.readdir(b))u.add(S)}catch(S){this.error(S)}if(s.token.isCancellationRequested)return;const P=new Map;i.add((0,C.toDisposable)(()=>{for(const[,S]of P)S.dispose();P.clear()})),l.on("error",(S,M)=>{s.token.isCancellationRequested||(this.error(`Failed to watch ${b} for changes using fs.watch() (${S}, ${M})`),this.notifyWatchFailed())}),l.on("change",(S,M)=>{if(s.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${S}"] ${M}`);let T="";if(M&&(T=M.toString(),a.isMacintosh&&(T=(0,R.normalizeNFC)(T))),!(!T||S!=="change"&&S!=="rename"))if(D)if(S==="rename"){P.get(T)?.dispose();const L=setTimeout(async()=>{if(P.delete(T),T===r&&!await w.Promises.exists(b)){this.onWatchedPathDeleted(c);return}if(s.token.isCancellationRequested)return;const A=await this.existsChildStrictCase((0,y.join)(b,T));if(s.token.isCancellationRequested)return;let _;A?u.has(T)?_=d.FileChangeType.UPDATED:(_=d.FileChangeType.ADDED,u.add(T)):(u.delete(T),_=d.FileChangeType.DELETED),this.onFileChange({resource:(0,h.joinPath)(c,T),type:_,cId:this.request.correlationId})},E.FILE_DELETE_HANDLER_DELAY);P.set(T,(0,C.toDisposable)(()=>clearTimeout(L)))}else{let L;u.has(T)?L=d.FileChangeType.UPDATED:(L=d.FileChangeType.ADDED,u.add(T)),this.onFileChange({resource:(0,h.joinPath)(c,T),type:L,cId:this.request.correlationId})}else if(S==="rename"||T!==r){const L=setTimeout(async()=>{const A=await w.Promises.exists(b);s.token.isCancellationRequested||(A?(this.onFileChange({resource:c,type:d.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(b,!1))):this.onWatchedPathDeleted(c))},E.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,C.toDisposable)(()=>clearTimeout(L)))}else this.onFileChange({resource:c,type:d.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(c){s.token.isCancellationRequested||this.error(`Failed to watch ${b} for changes using fs.watch() (${c.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(b){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:b,type:d.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(b,D=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${b.type===d.FileChangeType.ADDED?"[ADDED]":b.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${b.resource.fsPath}`),!D&&this.excludes.some(t=>t(b.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${b.resource.fsPath}`):!D&&this.includes&&this.includes.length>0&&!this.includes.some(t=>t(b.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${b.resource.fsPath}`):this.fileChangesAggregator.work(b))}handleFileChanges(b){const D=(0,v.coalesceEvents)(b),t=[];for(const i of D){if((0,v.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.verboseLogging)for(const i of t)this.traceWithCorrelation(` >> normalized ${i.type===d.FileChangeType.ADDED?"[ADDED]":i.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(t)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(b){if(a.isLinux)return w.Promises.exists(b);try{const D=(0,y.basename)(b);return(await w.Promises.readdir((0,y.dirname)(b))).some(s=>s===D)}catch(D){return this.trace(D),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}traceWithCorrelation(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${b}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=E;async function p(m,b,D,t,s=512){const i=await w.Promises.open(m,"r"),c=Buffer.allocUnsafe(s),r=new I.CancellationTokenSource(t);let l,u=!1;const P={path:m,excludes:[],recursive:!1},S=new E(P,void 0,M=>{(async()=>{for(const{type:T}of M)if(T===d.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:L}=await w.Promises.read(i,c,0,s,null);if(!L||r.token.isCancellationRequested)break;b(c.slice(0,L))}}catch(L){l=new Error(L),r.dispose(!0)}finally{u=!1}}})()});return await S.ready,D(),new Promise((M,T)=>{r.token.onCancellationRequested(async()=>{S.dispose();try{await w.Promises.close(i)}catch(L){l=new Error(L)}l?T(l):M()})})}}),define(oe[220],ae([0,1,4,113,218,3,219,31]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends I.BaseWatcher{constructor(h){super(),this.recursiveWatcher=h,this.onDidError=n.Event.None,this.watchers=new Set}async doWatch(h){h=this.removeDuplicateRequests(h);const f=[],g=new Set(Array.from(this.watchers));for(const w of h){const d=this.findWatcher(w);d&&(0,o.patternsEquals)(d.request.excludes,w.excludes)&&(0,o.patternsEquals)(d.request.includes,w.includes)?g.delete(d):f.push(w)}f.length&&this.trace(`Request to start watching: ${f.map(w=>this.requestToString(w)).join(",")}`),g.size&&this.trace(`Request to stop watching: ${Array.from(g).map(w=>this.requestToString(w.request)).join(",")}`);for(const w of g)this.stopWatching(w);for(const w of f)this.startWatching(w)}findWatcher(h){for(const f of this.watchers)if(typeof h.correlationId=="number"||typeof f.request.correlationId=="number"){if(f.request.correlationId===h.correlationId)return f}else if((0,R.isEqual)(f.request.path,h.path,!k.isLinux))return f}startWatching(h){const f=new C.NodeJSFileWatcherLibrary(h,this.recursiveWatcher,w=>this._onDidChangeFile.fire(w),()=>this._onDidWatchFail.fire(h),w=>this._onDidLogMessage.fire(w),this.verboseLogging),g={request:h,instance:f};this.watchers.add(g)}async stop(){await super.stop();for(const h of this.watchers)this.stopWatching(h)}stopWatching(h){this.trace("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}removeDuplicateRequests(h){const f=new Map;for(const g of h){const w=k.isLinux?g.path:g.path.toLowerCase();let d=f.get(g.correlationId);d||(d=new Map,f.set(g.correlationId,d)),d.has(w)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(g)}`),d.set(w,g)}return Array.from(f.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const f of this.watchers)f.instance.setVerboseLogging(h)}trace(h,f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h,f)})}warn(h){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(h)})}toMessage(h,f){return f?`[File Watcher (node.js)] ${h} (${this.requestToString(f.request)})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=y}),define(oe[221],ae([0,1,62,220]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends n.AbstractNonRecursiveWatcherClient{constructor(C,R,y){super(C,R,y),this.init()}createWatcher(C){return C.add(new o.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=I}),define(oe[222],ae([0,1,12,44,165,62]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends k.AbstractUniversalWatcherClient{constructor(y,a,h){super(y,a,h),this.init()}createWatcher(y){const a=y.add(new I.Client(n.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(a.onDidProcessExit(({code:h,signal:f})=>this.onError(`terminated by itself with code ${h}, signal: ${f} (ETERM)`))),o.ProxyChannel.toService((0,o.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(oe[99],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...I){this._entries=new Map;for(const[k,C]of I)this.set(k,C)}set(I,k){const C=this._entries.get(I);return this._entries.set(I,k),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=n}),define(oe[223],ae([0,1,8,16,2,84,212,6,99,109]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class f extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class g{constructor(E=new y.ServiceCollection,p=!1,m,b=h){this._services=E,this._strict=p,this._parent=m,this._enableTracing=b,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=b?m?._globalGraph??new C.Graph(D=>D):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,I.dispose)(this._children),this._children.clear();for(const E of this._servicesToMaybeDispose)(0,I.isDisposable)(E)&&E.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(E,p){this._throwIfDisposed();const m=this,b=new class extends g{dispose(){m._children.delete(b),super.dispose()}}(E,this._strict,this,this._enableTracing);return this._children.add(b),p?.add(b),b}invokeFunction(E,...p){this._throwIfDisposed();const m=d.traceInvocation(this._enableTracing,E);let b=!1;try{return E({get:t=>{if(b)throw(0,o.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(t,m);if(!s)throw new Error(`[invokeFunction] unknown service '${t}'`);return s}},...p)}finally{b=!0,m.stop()}}createInstance(E,...p){this._throwIfDisposed();let m,b;return E instanceof k.SyncDescriptor?(m=d.traceCreation(this._enableTracing,E.ctor),b=this._createInstance(E.ctor,E.staticArguments.concat(p),m)):(m=d.traceCreation(this._enableTracing,E),b=this._createInstance(E,p,m)),m.stop(),b}_createInstance(E,p=[],m){const b=R._util.getServiceDependencies(E).sort((s,i)=>s.index-i.index),D=[];for(const s of b){const i=this._getOrCreateServiceInstance(s.id,m);i||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${s.id}.`,!1),D.push(i)}const t=b.length>0?b[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${E.name} at position ${t+1} conflicts with ${p.length} static arguments`);const s=t-p.length;s>0?p=p.concat(new Array(s)):p=p.slice(0,t)}return Reflect.construct(E,p.concat(D))}_setCreatedServiceInstance(E,p){if(this._services.get(E)instanceof k.SyncDescriptor)this._services.set(E,p);else if(this._parent)this._parent._setCreatedServiceInstance(E,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const p=this._services.get(E);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):p}_getOrCreateServiceInstance(E,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const m=this._getServiceInstanceOrDescriptor(E);return m instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,m,p.branch(E,!0)):(p.branch(E,!1),m)}_safeCreateAndCacheServiceInstance(E,p,m){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,p,m)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,p,m){const b=new C.Graph(s=>s.id.toString());let D=0;const t=[{id:E,desc:p,_trace:m}];for(;t.length;){const s=t.pop();if(b.lookupOrInsertNode(s),D++>1e3)throw new f(b);for(const i of R._util.getServiceDependencies(s.desc.ctor)){const c=this._getServiceInstanceOrDescriptor(i.id);if(c||this._throwIfStrict(`[createInstance] ${E} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(i.id)),c instanceof k.SyncDescriptor){const r={id:i.id,desc:c,_trace:s._trace.branch(i.id,!0)};b.insertEdge(s,r),t.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new f(b);break}for(const{data:i}of s){if(this._getServiceInstanceOrDescriptor(i.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setCreatedServiceInstance(i.id,r)}b.removeNode(i)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,p,m=[],b,D){if(this._services.get(E)instanceof k.SyncDescriptor)return this._createServiceInstance(E,p,m,b,D,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,p,m,b,D);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(E,p,m=[],b,D,t){if(b){const s=new g(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(E);const i=new Map,c=new n.GlobalIdleValue(()=>{const r=s._createInstance(p,m,D);for(const[l,u]of i){const P=r[l];if(typeof P=="function")for(const S of u)S.disposable=P.apply(r,S.listener)}return i.clear(),t.add(r),r});return new Proxy(Object.create(null),{get(r,l){if(!c.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let S=i.get(l);return S||(S=new a.LinkedList,i.set(l,S)),(T,L,A)=>{if(c.isInitialized)return c.value[l](T,L,A);{const _={listener:[T,L,A],disposable:void 0},B=S.push(_);return(0,I.toDisposable)(()=>{B(),_.disposable?.dispose()})}}}if(l in r)return r[l];const u=c.value;let P=u[l];return typeof P!="function"||(P=P.bind(u),r[l]=P),P},set(r,l,u){return c.value[l]=u,!0},getPrototypeOf(r){return p.prototype}})}else{const s=this._createInstance(p,m,D);return t.add(s),s}}_throwIfStrict(E,p){if(p&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=g;var w;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(w||(w={}));class d{static{this.all=new Set}static{this._None=new class extends d{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,p){return E?new d(w.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(E,p){return E?new d(w.Creation,p.name):d._None}static{this._totals=0}constructor(E,p){this.type=E,this.name=p,this._start=Date.now(),this._dep=[]}branch(E,p){const m=new d(w.Branch,E.toString());return this._dep.push([E,p,m]),m}stop(){const E=Date.now()-this._start;d._totals+=E;let p=!1;function m(D,t){const s=[],i=new Array(D+1).join("	");for(const[c,r,l]of t._dep)if(r&&l){p=!0,s.push(`${i}CREATES -> ${c}`);const u=m(D+1,l);u&&s.push(u)}else s.push(`${i}uses -> ${c}`);return s.join(`
`)}const b=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(E>2||p)&&d.all.add(b.join(`
`))}}e.Trace=d}),define(oe[224],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProcessMainService=e.IIssueMainService=e.IssueSource=e.IssueType=void 0;var o;(function(k){k[k.Bug=0]="Bug",k[k.PerformanceIssue=1]="PerformanceIssue",k[k.FeatureRequest=2]="FeatureRequest"})(o||(e.IssueType=o={}));var I;(function(k){k.VSCode="vscode",k.Extension="extension",k.Marketplace="marketplace"})(I||(e.IssueSource=I={})),e.IIssueMainService=(0,n.createDecorator)("issueService"),e.IProcessMainService=(0,n.createDecorator)("processService")}),define(oe[5],ae([0,1,187,55,4,46,2,32,3,19,13,7,123,6]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=v,e.log=p,e.getLogLevel=P,e.LogLevelToString=S,e.LogLevelToLocalizedString=M,e.parseLogLevel=T,n=ke(n),e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function d(){return new Date().toISOString()}function v(L){return(0,h.isNumber)(L)}var E;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function p(L,A,_){switch(A){case E.Trace:L.trace(_);break;case E.Debug:L.debug(_);break;case E.Info:L.info(_);break;case E.Warning:L.warn(_);break;case E.Error:L.error(_);break;case E.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function m(L,A=!1){let _="";for(let B=0;B<L.length;B++){let N=L[B];if(N instanceof Error&&(N=(0,o.toErrorMessage)(N,A)),typeof N=="object")try{N=JSON.stringify(N)}catch{}_+=(B>0?" ":"")+N}return _}class b extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(A){this.level!==A&&(this.level=A,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(A){return this.level!==E.Off&&this.level<=A}}e.AbstractLogger=b;class D extends b{constructor(A){super(),this.logAlways=A}checkLogLevel(A){return this.logAlways||super.checkLogLevel(A)}trace(A,..._){this.checkLogLevel(E.Trace)&&this.log(E.Trace,m([A,..._],!0))}debug(A,..._){this.checkLogLevel(E.Debug)&&this.log(E.Debug,m([A,..._]))}info(A,..._){this.checkLogLevel(E.Info)&&this.log(E.Info,m([A,..._]))}warn(A,..._){this.checkLogLevel(E.Warning)&&this.log(E.Warning,m([A,..._]))}error(A,..._){if(this.checkLogLevel(E.Error))if(A instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=A.stack,this.log(E.Error,m(B))}else this.log(E.Error,m([A,..._]))}flush(){}}e.AbstractMessageLogger=D;class t extends b{constructor(A=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(A),this.useColors=!y.isWindows}trace(A,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,A,..._):console.log(`[main ${d()}]`,A,..._))}debug(A,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,A,..._):console.log(`[main ${d()}]`,A,..._))}info(A,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,A,..._):console.log(`[main ${d()}]`,A,..._))}warn(A,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,A,..._):console.warn(`[main ${d()}]`,A,..._))}error(A,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,A,..._):console.error(`[main ${d()}]`,A,..._))}flush(){}}e.ConsoleMainLogger=t;class s extends b{constructor(A=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(A)}trace(A,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",A,..._):console.log(A,..._))}debug(A,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",A,..._):console.log(A,..._))}info(A,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",A,..._):console.log(A,..._))}warn(A,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",A,..._):console.log(A,..._))}error(A,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",A,..._):console.error(A,..._))}flush(){}}e.ConsoleLogger=s;class i extends b{constructor(A,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=A,this.setLevel(_)}trace(A,..._){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(A),..._])}debug(A,..._){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(A),..._])}info(A,..._){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(A),..._])}warn(A,..._){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(A),..._])}error(A,..._){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(A),..._])}extractMessage(A){return typeof A=="string"?A:(0,o.toErrorMessage)(A,this.checkLogLevel(E.Trace))}flush(){}}e.AdapterLogger=i;class c extends b{constructor(A){super(),this.loggers=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const _ of this.loggers)_.setLevel(A);super.setLevel(A)}trace(A,..._){for(const B of this.loggers)B.trace(A,..._)}debug(A,..._){for(const B of this.loggers)B.debug(A,..._)}info(A,..._){for(const B of this.loggers)B.info(A,..._)}warn(A,..._){for(const B of this.loggers)B.warn(A,..._)}error(A,..._){for(const B of this.loggers)B.error(A,..._)}flush(){for(const A of this.loggers)A.flush()}dispose(){for(const A of this.loggers)A.dispose();super.dispose()}}e.MultiplexLogger=c;class r extends C.Disposable{constructor(A,_,B){if(super(),this.logLevel=A,this.logsHome=_,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new I.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,B)for(const N of B)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(A){return(0,h.isString)(A)?[...this._loggers.values()].find(_=>_.info.id===A):this._loggers.get(A)}getLogger(A){return this.getLoggerEntry(A)?.logger}createLogger(A,_){const B=this.toResource(A),N=(0,h.isString)(A)?A:_?.id??(0,k.hash)(B.toString()).toString(16);let z=this._loggers.get(B)?.logger;const se=_?.logLevel==="always"?E.Trace:_?.logLevel;z||(z=this.doCreateLogger(B,se??this.getLogLevel(B)??this.logLevel,{..._,id:N}));const J={logger:z,info:{resource:B,id:N,logLevel:se,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(J.info),this._loggers.set(B,J),z}toResource(A){return(0,h.isString)(A)?(0,a.joinPath)(this.logsHome,`${A}.log`):A}setLogLevel(A,_){if(f.URI.isUri(A)){const B=A,N=_,z=this._loggers.get(B);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.logLevel?void 0:N,z.logger?.setLevel(N),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([B,N]))}else{this.logLevel=A;for(const[B,N]of this._loggers.entries())this._loggers.get(B)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(A,_){const B=this.getLoggerEntry(A);B&&_!==!B.info.hidden&&(B.info.hidden=!_,this._loggers.set(B.info.resource,B),this._onDidChangeVisibility.fire([B.info.resource,_]))}getLogLevel(A){let _;return A&&(_=this._loggers.get(A)?.info.logLevel),_??this.logLevel}registerLogger(A){const _=this._loggers.get(A.resource);_?_.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this._loggers.set(A.resource,{info:A,logger:void 0}),this._onDidChangeLoggers.fire({added:[A],removed:[]}))}deregisterLogger(A){const _=this._loggers.get(A);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(A),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const A of this._loggers.values())yield A.info}getRegisteredLogger(A){return this._loggers.get(A)?.info}dispose(){this._loggers.forEach(A=>A.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class l{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(A){}getLevel(){return E.Info}trace(A,..._){}debug(A,..._){}info(A,..._){}warn(A,..._){}error(A,..._){}critical(A,..._){}dispose(){}flush(){}}e.NullLogger=l;class u extends l{}e.NullLogService=u;function P(L){if(L.verbose)return E.Trace;if(typeof L.logLevel=="string"){const A=T(L.logLevel.toLowerCase());if(A!==void 0)return A}return e.DEFAULT_LOG_LEVEL}function S(L){switch(L){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function M(L){switch(L){case E.Trace:return{original:"Trace",value:n.localize(0,null)};case E.Debug:return{original:"Debug",value:n.localize(1,null)};case E.Info:return{original:"Info",value:n.localize(2,null)};case E.Warning:return{original:"Warning",value:n.localize(3,null)};case E.Error:return{original:"Error",value:n.localize(4,null)};case E.Off:return{original:"Off",value:n.localize(5,null)}}}function T(L){switch(L){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.CONTEXT_LOG_LEVEL=new g.RawContextKey("logLevel",S(E.Info))});var ne=this&&this.__param||function(V,e){return function(n,o){e(n,o,V)}};define(oe[225],ae([0,1,14,3,98,5]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const C=n.safeStorage;let R=class{constructor(a){this.logService=a,n.app.commandLine.getSwitchValue("password-store")===I.PasswordStoreCLIOption.basic&&C.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(C.encryptString(a));return this.logService.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.logService.error(h),h}}async decrypt(a){let h;try{if(h=JSON.parse(a),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const f=Buffer.from(h.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const g=C.decryptString(f);return this.logService.trace("[EncryptionMainService] Decrypted value."),g}catch(f){throw this.logService.error(f),f}}isEncryptionAvailable(){return Promise.resolve(C.isEncryptionAvailable())}getKeyStorageProvider(){if(o.isWindows)return Promise.resolve(I.KnownStorageProvider.dplib);if(o.isMacintosh)return Promise.resolve(I.KnownStorageProvider.keychainAccess);if(C.getSelectedStorageBackend)try{const a=C.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.logService.error(a)}return Promise.resolve(I.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(o.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(o.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!C.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");C.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=R,e.EncryptionMainService=R=Pe([ne(0,k.ILogService)],R)}),define(oe[226],ae([0,1,22,8,16,4,31,2,10,62,5]),function(V,e,n,o,I,k,C,R,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class f extends R.Disposable{constructor(w,d){super(),this.logService=w,this.options=d,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new o.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new o.ThrottledDelayer(0))}watch(w,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,d):this.watchNonRecursive(w,d)}watchUniversal(w,d){const v={path:this.toWatchPath(w),excludes:d.excludes,includes:d.includes,recursive:d.recursive,filter:d.filter,correlationId:d.correlationId},E=(0,n.insert)(this.universalWatchRequests,v);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,I.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const d of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const d of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(d)&&w.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(w,d){const v={path:this.toWatchPath(w),excludes:d.excludes,includes:d.includes,recursive:!1,filter:d.filter,correlationId:d.correlationId},E=(0,n.insert)(this.nonRecursiveWatchRequests,v);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,I.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logWatcherMessage(w)}logWatcherMessage(w){this.logService[w.type](w.message)}toFilePath(w){return(0,y.normalize)(w.fsPath)}toWatchPath(w){const d=this.toFilePath(w);return(0,C.removeTrailingPathSeparator)(d)}}e.AbstractDiskFileSystemProvider=f}),define(oe[227],ae([0,1,22,8,17,23,4,46,78,2,61,12,71,19,68,180,15,125,5,16]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let t=class extends a.Disposable{static{D=this}constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new C.Emitter),this._onDidUncorrelatedFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new o.ResourceQueue)}registerProvider(i,c){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const r=new a.DisposableStore;return this.provider.set(i,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:c}),r.add(c.onDidChangeFile(l=>{const u=new E.FileChangesEvent(l,!this.isPathCaseSensitive(c));this.internalOnDidFilesChange.fire(u),u.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(u)})),typeof c.onDidWatchError=="function"&&r.add(c.onDidWatchError(l=>this._onDidWatchError.fire(new Error(l)))),r.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:i}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:c}),this.provider.delete(i),(0,a.dispose)(r)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(r){c.push(r)}}),!this.provider.has(i)&&await o.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,c){const r=this.provider.get(i.scheme);return!!(r&&r.capabilities&c)}listCapabilities(){return y.Iterable.map(this.provider,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async withProvider(i){if(!(0,w.isAbsolutePath)(i))throw new E.FileOperationError((0,v.localize)(0,null,this.resourceForError(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const c=this.provider.get(i.scheme);if(!c){const r=new b.ErrorNoTelemetry;throw r.message=(0,v.localize)(1,null,i.toString()),r}return c}async withReadProvider(i){const c=await this.withProvider(i);if((0,E.hasOpenReadWriteCloseCapability)(c)||(0,E.hasReadWriteCapability)(c)||(0,E.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const c=await this.withProvider(i);if((0,E.hasOpenReadWriteCloseCapability)(c)||(0,E.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.doResolveFile(i,c)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,v.localize)(2,null,this.resourceForError(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.ensureFileSystemProviderError)(r)}}async doResolveFile(i,c){const r=await this.withProvider(i),l=this.isPathCaseSensitive(r),u=c?.resolveTo,P=c?.resolveSingleChildDescendants,S=c?.resolveMetadata,M=await r.stat(i);let T;return this.toFileStat(r,i,M,void 0,!!S,(L,A)=>(T||(T=h.TernarySearchTree.forUris(()=>!l),T.set(i,!0),u&&T.fill(!0,u)),T.get(L.resource)||T.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&P?A===1:!1))}async toFileStat(i,c,r,l,u,P){const{providerExtUri:S}=this.getExtUri(i),M={resource:c,name:S.basename(c),isFile:(r.type&E.FileType.File)!==0,isDirectory:(r.type&E.FileType.Directory)!==0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((r.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(M.isDirectory&&P(M,l)){try{const T=await i.readdir(c),L=await o.Promises.settled(T.map(async([A,_])=>{try{const B=S.joinPath(c,A),N=u?await i.stat(B):{type:_};return await this.toFileStat(i,B,N,T.length,u,P)}catch(B){return this.logService.trace(B),null}}));M.children=(0,n.coalesce)(L)}catch(T){this.logService.trace(T),M.children=[]}return M}return M}async resolveAll(i){return o.Promises.settled(i.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.withProvider(i),r=await c.stat(i);return this.toFileStat(c,i,r,void 0,!0,()=>!1)}async exists(i){const c=await this.withProvider(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.doValidateCreateFile(i,c)}catch(r){return r}return!0}async doValidateCreateFile(i,c){if(!c?.overwrite&&await this.exists(i))throw new E.FileOperationError((0,v.localize)(3,null,this.resourceForError(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,c)}async createFile(i,c=I.VSBuffer.fromString(""),r){await this.doValidateCreateFile(i,r);const l=await this.writeFile(i,c);return this._onDidRunOperation.fire(new E.FileOperationEvent(i,E.FileOperation.CREATE,l)),l}async writeFile(i,c,r){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:u}=this.getExtUri(l);let P=r;if((0,E.hasFileAtomicWriteCapability)(l)&&!P?.atomic){const S=l.enforceAtomicWriteFile?.(i);S&&(P={...r,atomic:S})}try{await this.validateWriteFile(l,i,P)||await this.mkdirp(l,u.dirname(i));let M;if((0,E.hasReadWriteCapability)(l)&&!(c instanceof I.VSBuffer))if((0,d.isReadableStream)(c)){const T=await(0,d.peekStream)(c,3);T.ended?M=I.VSBuffer.concat(T.buffer):M=T}else M=(0,d.peekReadable)(c,T=>I.VSBuffer.concat(T),3);else M=c;!(0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l)&&M instanceof I.VSBuffer||(0,E.hasReadWriteCapability)(l)&&(0,E.hasFileAtomicWriteCapability)(l)&&P?.atomic?await this.doWriteUnbuffered(l,i,P,M):await this.doWriteBuffered(l,i,P,M instanceof I.VSBuffer?(0,I.bufferToReadable)(M):M),this._onDidRunOperation.fire(new E.FileOperationEvent(i,E.FileOperation.WRITE))}catch(S){throw new E.FileOperationError((0,v.localize)(4,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(S).toString()),(0,E.toFileOperationResult)(S),P)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,c,r){const l=!!r?.unlock;if(l&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,v.localize)(5,null,this.resourceForError(c)));if(!!r?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,v.localize)(6,null,this.resourceForError(c)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,v.localize)(7,null,this.resourceForError(c)));if(l)throw new Error((0,v.localize)(8,null,this.resourceForError(c)))}let P;try{P=await i.stat(c)}catch{return}if(P.type&E.FileType.Directory)throw new E.FileOperationError((0,v.localize)(9,null,this.resourceForError(c)),E.FileOperationResult.FILE_IS_DIRECTORY,r);if(this.throwIfFileIsReadonly(c,P),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof P.mtime=="number"&&typeof P.size=="number"&&r.mtime<P.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:P.size}))throw new E.FileOperationError((0,v.localize)(10,null),E.FileOperationResult.FILE_MODIFIED_SINCE,r);return P}async readFile(i,c,r){const l=await this.withReadProvider(i);return c?.atomic?this.doReadFileAtomic(l,i,c,r):this.doReadFile(l,i,c,r)}async doReadFileAtomic(i,c,r,l){return new Promise((u,P)=>{this.writeQueue.queueFor(c,async()=>{try{const S=await this.doReadFile(i,c,r,l);u(S)}catch(S){P(S)}},this.getExtUri(i).providerExtUri)})}async doReadFile(i,c,r,l){const u=await this.doReadFileStream(i,c,{...r,preferUnbuffered:!0},l);return{...u,value:await(0,I.streamToBuffer)(u.value)}}async readFileStream(i,c,r){const l=await this.withReadProvider(i);return this.doReadFileStream(l,i,c,r)}async doReadFileStream(i,c,r,l){const u=new k.CancellationTokenSource(l);let P=r;(0,E.hasFileAtomicReadCapability)(i)&&i.enforceAtomicReadFile?.(c)&&(P={...r,atomic:!0});const S=this.validateReadFile(c,P).then(T=>T,T=>{throw u.dispose(!0),T});let M;try{return typeof P?.etag=="string"&&P.etag!==E.ETAG_DISABLED&&await S,P?.atomic&&(0,E.hasFileAtomicReadCapability)(i)||!((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasFileReadStreamCapability)(i))||(0,E.hasReadWriteCapability)(i)&&P?.preferUnbuffered?M=this.readFileUnbuffered(i,c,P):(0,E.hasFileReadStreamCapability)(i)?M=this.readFileStreamed(i,c,u.token,P):M=this.readFileBuffered(i,c,u.token,P),M.on("end",()=>u.dispose()),M.on("error",()=>u.dispose()),{...await S,value:M}}catch(T){throw M&&await(0,d.consumeStream)(M),this.restoreReadError(T,c,P)}}restoreReadError(i,c,r){const l=(0,v.localize)(11,null,this.resourceForError(c),(0,E.ensureFileSystemProviderError)(i).toString());return i instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(l,i.stat,r):i instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(l,i.fileOperationResult,i.size,i.options):new E.FileOperationError(l,(0,E.toFileOperationResult)(i),r)}readFileStreamed(i,c,r,l=Object.create(null)){const u=i.readFileStream(c,l,r);return(0,d.transform)(u,{data:P=>P instanceof I.VSBuffer?P:I.VSBuffer.wrap(P),error:P=>this.restoreReadError(P,c,l)},P=>I.VSBuffer.concat(P))}readFileBuffered(i,c,r,l=Object.create(null)){const u=(0,I.newWriteableBufferStream)();return(0,p.readFileIntoStream)(i,c,u,P=>P,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:P=>this.restoreReadError(P,c,l)},r),u}readFileUnbuffered(i,c,r){const l=(0,d.newWriteableStream)(u=>I.VSBuffer.concat(u));return(async()=>{try{let u;r?.atomic&&(0,E.hasFileAtomicReadCapability)(i)?u=await i.readFile(c,{atomic:!0}):u=await i.readFile(c),typeof r?.position=="number"&&(u=u.slice(r.position)),typeof r?.length=="number"&&(u=u.slice(0,r.length)),this.validateReadFileLimits(c,u.byteLength,r),l.end(I.VSBuffer.wrap(u))}catch(u){l.error(u),l.end()}})(),l}async validateReadFile(i,c){const r=await this.resolve(i,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,v.localize)(12,null,this.resourceForError(i)),E.FileOperationResult.FILE_IS_DIRECTORY,c);if(typeof c?.etag=="string"&&c.etag!==E.ETAG_DISABLED&&c.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,v.localize)(13,null),r,c);return this.validateReadFileLimits(i,r.size,c),r}validateReadFileLimits(i,c,r){if(typeof r?.limits?.size=="number"&&c>r.limits.size)throw new E.TooLargeFileOperationError((0,v.localize)(14,null,this.resourceForError(i)),E.FileOperationResult.FILE_TOO_LARGE,c,r)}async canMove(i,c,r){return this.doCanMoveCopy(i,c,"move",r)}async canCopy(i,c,r){return this.doCanMoveCopy(i,c,"copy",r)}async doCanMoveCopy(i,c,r,l){if(i.toString()!==c.toString())try{const u=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),P=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(u,i,P,c,r,l)}catch(u){return u}return!0}async move(i,c,r){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),P=await this.doMoveCopy(l,i,u,c,"move",!!r),S=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(i,P==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,S)),S}async copy(i,c,r){const l=await this.withReadProvider(i),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),P=await this.doMoveCopy(l,i,u,c,"copy",!!r),S=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(i,P==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,S)),S}async doMoveCopy(i,c,r,l,u,P){if(c.toString()===l.toString())return u;const{exists:S,isSameResourceWithDifferentPathCase:M}=await this.doValidateMoveCopy(i,c,r,l,u,P);if(S&&!M&&P&&await this.del(l,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(l)),u==="copy"){if(i===r&&(0,E.hasFileFolderCopyCapability)(i))await i.copy(c,l,{overwrite:P});else{const T=await this.resolve(c);T.isDirectory?await this.doCopyFolder(i,T,r,l):await this.doCopyFile(i,c,r,l)}return u}else return i===r?(await i.rename(c,l,{overwrite:P}),u):(await this.doMoveCopy(i,c,r,l,"copy",P),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(i,c,r,l){if((0,E.hasOpenReadWriteCloseCapability)(i)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(i,c,r,l);if((0,E.hasOpenReadWriteCloseCapability)(i)&&(0,E.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(i,c,r,l);if((0,E.hasReadWriteCapability)(i)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(i,c,r,l);if((0,E.hasReadWriteCapability)(i)&&(0,E.hasReadWriteCapability)(r))return this.doPipeUnbuffered(i,c,r,l)}async doCopyFolder(i,c,r,l){await r.mkdir(l),Array.isArray(c.children)&&await o.Promises.settled(c.children.map(async u=>{const P=this.getExtUri(r).providerExtUri.joinPath(l,u.name);return u.isDirectory?this.doCopyFolder(i,await this.resolve(u.resource),r,P):this.doCopyFile(i,u.resource,r,P)}))}async doValidateMoveCopy(i,c,r,l,u,P){let S=!1;if(i===r){const{providerExtUri:T,isPathCaseSensitive:L}=this.getExtUri(i);if(L||(S=T.isEqual(c,l)),S&&u==="copy")throw new Error((0,v.localize)(15,null,this.resourceForError(c),this.resourceForError(l)));if(!S&&T.isEqualOrParent(l,c))throw new Error((0,v.localize)(16,null,this.resourceForError(c),this.resourceForError(l)))}const M=await this.exists(l);if(M&&!S){if(!P)throw new E.FileOperationError((0,v.localize)(17,null,this.resourceForError(c),this.resourceForError(l)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===r){const{providerExtUri:T}=this.getExtUri(i);if(T.isEqualOrParent(c,l))throw new Error((0,v.localize)(18,null,this.resourceForError(c),this.resourceForError(l)))}}return{exists:M,isSameResourceWithDifferentPathCase:S}}getExtUri(i){const c=this.isPathCaseSensitive(i);return{providerExtUri:c?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(c,i);const r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(i,E.FileOperation.CREATE,r)),r}async mkdirp(i,c){const r=[],{providerExtUri:l}=this.getExtUri(i);for(;!l.isEqual(c,l.dirname(c));)try{if(!((await i.stat(c)).type&E.FileType.Directory))throw new Error((0,v.localize)(19,null,this.resourceForError(c)));break}catch(u){if((0,E.toFileSystemProviderErrorCode)(u)!==E.FileSystemProviderErrorCode.FileNotFound)throw u;r.push(l.basename(c)),c=l.dirname(c)}for(let u=r.length-1;u>=0;u--){c=l.joinPath(c,r[u]);try{await i.mkdir(c)}catch(P){if((0,E.toFileSystemProviderErrorCode)(P)!==E.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(i,c){try{await this.doValidateDelete(i,c)}catch(r){return r}return!0}async doValidateDelete(i,c){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i),l=!!c?.useTrash;if(l&&!(r.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,v.localize)(20,null,this.resourceForError(i)));const u=c?.atomic;if(u&&!(r.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,v.localize)(21,null,this.resourceForError(i)));if(l&&u)throw new Error((0,v.localize)(22,null,this.resourceForError(i)));let P;try{P=await r.stat(i)}catch{}if(P)this.throwIfFileIsReadonly(i,P);else throw new E.FileOperationError((0,v.localize)(23,null,this.resourceForError(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!c?.recursive){const M=await this.resolve(i);if(M.isDirectory&&Array.isArray(M.children)&&M.children.length>0)throw new Error((0,v.localize)(24,null,this.resourceForError(i)))}return r}async del(i,c){const r=await this.doValidateDelete(i,c);let l=c;if((0,E.hasFileAtomicDeleteCapability)(r)&&!l?.atomic){const M=r.enforceAtomicDelete?.(i);M&&(l={...c,atomic:M})}const u=!!l?.useTrash,P=!!l?.recursive,S=l?.atomic??!1;await r.delete(i,{recursive:P,useTrash:u,atomic:S}),this._onDidRunOperation.fire(new E.FileOperationEvent(i,E.FileOperation.DELETE))}async cloneFile(i,c){const r=await this.withProvider(i),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);if(!(r===l&&this.getExtUri(r).providerExtUri.isEqual(i,c)))return r===l&&(0,E.hasFileCloneCapability)(r)?r.cloneFile(i,c):(await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(c)),r===l&&(0,E.hasFileFolderCopyCapability)(r)?this.writeQueue.queueFor(i,()=>r.copy(i,c,{overwrite:!0}),this.getExtUri(r).providerExtUri):this.writeQueue.queueFor(i,()=>this.doCopyFile(r,i,l,c),this.getExtUri(r).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(i,c){return this.watch(i,{...c,correlationId:D.WATCHER_CORRELATION_IDS++})}watch(i,c={recursive:!1,excludes:[]}){const r=new a.DisposableStore;let l=!1,u=()=>{l=!0};r.add((0,a.toDisposable)(()=>u())),(async()=>{try{const S=await this.doWatch(i,c);l?(0,a.dispose)(S):u=()=>(0,a.dispose)(S)}catch(S){this.logService.error(S)}})();const P=c.correlationId;if(typeof P=="number"){const S=r.add(new C.Emitter);return r.add(this.internalOnDidFilesChange.event(T=>{T.correlates(P)&&S.fire(T)})),{onDidChange:S.event,dispose:()=>r.dispose()}}return r}async doWatch(i,c){const r=await this.withProvider(i),l=(0,R.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(i),c]);let u=this.activeWatchers.get(l);return u||(u={count:0,disposable:r.watch(i,c)},this.activeWatchers.set(l,u)),u.count+=1,(0,a.toDisposable)(()=>{u&&(u.count--,u.count===0&&((0,a.dispose)(u.disposable),this.activeWatchers.delete(l)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,a.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,c,r,l){return this.writeQueue.queueFor(c,async()=>{const u=await i.open(c,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(l)||(0,d.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(i,u,l):await this.doWriteReadableBufferedQueued(i,u,l)}catch(P){throw(0,E.ensureFileSystemProviderError)(P)}finally{await i.close(u)}},this.getExtUri(i).providerExtUri)}async doWriteStreamBufferedQueued(i,c,r){let l=0,u;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const P=I.VSBuffer.concat(r.buffer);await this.doWriteBuffer(i,c,P,P.byteLength,l,0),l+=P.byteLength}if(r.ended)return;u=r.stream}else u=r;return new Promise((P,S)=>{(0,d.listenStream)(u,{onData:async M=>{u.pause();try{await this.doWriteBuffer(i,c,M,M.byteLength,l,0)}catch(T){return S(T)}l+=M.byteLength,setTimeout(()=>u.resume())},onError:M=>S(M),onEnd:()=>P()})})}async doWriteReadableBufferedQueued(i,c,r){let l=0,u;for(;(u=r.read())!==null;)await this.doWriteBuffer(i,c,u,u.byteLength,l,0),l+=u.byteLength}async doWriteBuffer(i,c,r,l,u,P){let S=0;for(;S<l;){const M=await i.write(c,u+S,r.buffer,P+S,l-S);S+=M}}async doWriteUnbuffered(i,c,r,l){return this.writeQueue.queueFor(c,()=>this.doWriteUnbufferedQueued(i,c,r,l),this.getExtUri(i).providerExtUri)}async doWriteUnbufferedQueued(i,c,r,l){let u;l instanceof I.VSBuffer?u=l:(0,d.isReadableStream)(l)?u=await(0,I.streamToBuffer)(l):(0,d.isReadableBufferedStream)(l)?u=await(0,I.bufferedStreamToBuffer)(l):u=(0,I.readableToBuffer)(l),await i.writeFile(c,u.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async doPipeBuffered(i,c,r,l){return this.writeQueue.queueFor(l,()=>this.doPipeBufferedQueued(i,c,r,l),this.getExtUri(r).providerExtUri)}async doPipeBufferedQueued(i,c,r,l){let u,P;try{u=await i.open(c,{create:!1}),P=await r.open(l,{create:!0,unlock:!1});const S=I.VSBuffer.alloc(this.BUFFER_SIZE);let M=0,T=0,L=0;do L=await i.read(u,M,S.buffer,T,S.byteLength-T),await this.doWriteBuffer(r,P,S,L,M,T),M+=L,T+=L,T===S.byteLength&&(T=0);while(L>0)}catch(S){throw(0,E.ensureFileSystemProviderError)(S)}finally{await o.Promises.settled([typeof u=="number"?i.close(u):Promise.resolve(),typeof P=="number"?r.close(P):Promise.resolve()])}}async doPipeUnbuffered(i,c,r,l){return this.writeQueue.queueFor(l,()=>this.doPipeUnbufferedQueued(i,c,r,l),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedQueued(i,c,r,l){return r.writeFile(l,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(i,c,r,l){return this.writeQueue.queueFor(l,()=>this.doPipeUnbufferedToBufferedQueued(i,c,r,l),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedToBufferedQueued(i,c,r,l){const u=await r.open(l,{create:!0,unlock:!1});try{const P=await i.readFile(c);await this.doWriteBuffer(r,u,I.VSBuffer.wrap(P),P.byteLength,0,0)}catch(P){throw(0,E.ensureFileSystemProviderError)(P)}finally{await r.close(u)}}async doPipeBufferedToUnbuffered(i,c,r,l){const u=await(0,I.streamToBuffer)(this.readFileBuffered(i,c,k.CancellationToken.None));await this.doWriteUnbuffered(r,l,void 0,u)}throwIfFileSystemIsReadonly(i,c){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.FileOperationError((0,v.localize)(25,null,this.resourceForError(c)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}throwIfFileIsReadonly(i,c){if((c.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,v.localize)(26,null,this.resourceForError(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(i){return i.scheme===f.Schemas.file?i.fsPath:i.toString(!0)}};e.FileService=t,e.FileService=t=D=Pe([ne(0,m.ILogService)],t)}),define(oe[100],ae([0,1,8,32,17,4,31,2,10,3,19,68,21,184,15,125,226,222,221]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class b extends E.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,s){super(t,s),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new o.ResourceMap(i=>h.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,a.isLinux&&(this._capabilities|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(t){try{const{stat:s,symbolicLink:i}=await g.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:d.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const s=await g.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async c=>{try{let r;c.isSymbolicLink()?r=(await this.stat((0,h.joinPath)(t,c.name))).type:r=this.toType(c),i.push([c.name,r])}catch(r){this.logService.trace(r)}})),i}catch(s){throw this.toFileSystemProviderError(s)}}toType(t,s){let i;return s?.dangling?i=d.FileType.Unknown:t.isFile()?i=d.FileType.File:t.isDirectory()?i=d.FileType.Directory:i=d.FileType.Unknown,s&&(i|=d.FileType.SymbolicLink),i}async createResourceLock(t){const s=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const c=new n.Barrier;return this.resourceLocks.set(t,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,R.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(t)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(t,s){let i;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),i=await this.createResourceLock(t));const c=this.toFilePath(t);return await g.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{i?.dispose()}}traceLock(t){b.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,s,i){const c=(0,f.newWriteableStream)(r=>I.VSBuffer.concat(r.map(l=>I.VSBuffer.wrap(l))).buffer);return(0,v.readFileIntoStream)(this,t,c,r=>r.buffer,{...s,bufferSize:256*1024},i),c}async writeFile(t,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,h.joinPath)((0,h.dirname)(t),`${(0,h.basename)(t)}${i.atomic.postfix}`),s,i):this.doWriteFile(t,s,i)}async canWriteFileAtomic(t){try{const s=this.toFilePath(t),{symbolicLink:i}=await g.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async doWriteFileAtomic(t,s,i,c){const r=new R.DisposableStore;try{r.add(await this.createResourceLock(t)),r.add(await this.createResourceLock(s)),await this.doWriteFile(s,i,c,!0);try{await this.rename(s,t,{overwrite:!0})}catch(l){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{r.dispose()}}async doWriteFile(t,s,i,c){let r;try{const l=this.toFilePath(t);if(!i.create||!i.overwrite){if(await g.Promises.exists(l)){if(!i.overwrite)throw(0,d.createFileSystemProviderError)((0,w.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,d.createFileSystemProviderError)((0,w.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(t,{create:!0,unlock:i.unlock},c),await this.write(r,0,s,0,s.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(t,l)}finally{typeof r=="number"&&await this.close(r)}}static{this.canFlush=!0}static configureFlushOnWrite(t){b.canFlush=t}async open(t,s,i){const c=this.toFilePath(t);let r;(0,d.isFileOpenForWriteOptions)(s)&&!i&&(r=await this.createResourceLock(t));let l;try{if((0,d.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:P}=await g.SymlinkSupport.stat(c);P.mode&128||await g.Promises.chmod(c,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let u;if((0,d.isFileOpenForWriteOptions)(s)){if(a.isWindows)try{await g.Promises.truncate(c,0),u="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}u||(u="w")}else u="r";l=await g.Promises.open(c,u)}catch(u){throw r?.dispose(),(0,d.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(t,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(l,0),(0,d.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(l,t),r){const u=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${c})`),this.mapHandleToLock.set(l,r),u&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${c})`),u.dispose())}return l}async close(t){const s=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&b.canFlush)try{await g.Promises.fdatasync(t)}catch(i){b.configureFlushOnWrite(!1),this.logService.error(i)}return await g.Promises.close(t)}catch(i){throw this.toFileSystemProviderError(i)}finally{s&&(this.mapHandleToLock.get(t)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,i,c,r){const l=this.normalizePos(t,s);let u=null;try{u=(await g.Promises.read(t,i,c,r,l)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(t,l,u)}return u}normalizePos(t,s){return s===this.mapHandleToPos.get(t)?null:s}updatePos(t,s,i){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof s=="number"||(typeof i=="number"?this.mapHandleToPos.set(t,c+i):this.mapHandleToPos.delete(t)))}async write(t,s,i,c,r){return(0,n.retry)(()=>this.doWrite(t,s,i,c,r),100,3)}async doWrite(t,s,i,c,r){const l=this.normalizePos(t,s);let u=null;try{u=(await g.Promises.write(t,i,c,r,l)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),P)}finally{this.updatePos(t,l,u)}return u}async mkdir(t){try{await g.Promises.mkdir(this.toFilePath(t))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(t,s){try{const i=this.toFilePath(t);if(s.recursive){let c;s?.atomic!==!1&&s.atomic.postfix&&(c=(0,y.join)((0,y.dirname)(i),`${(0,y.basename)(i)}${s.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(i)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let r=!1;try{const{stat:l,symbolicLink:u}=await g.SymlinkSupport.stat(i);r=l.isDirectory()&&!u}catch{}if(r)await g.Promises.rmdir(i);else throw c}else throw c}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(t,s,i){const c=this.toFilePath(t),r=this.toFilePath(s);if(c!==r)try{await this.validateMoveCopy(t,s,"move",i.overwrite),await g.Promises.rename(c,r)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(r)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(t,s,i){const c=this.toFilePath(t),r=this.toFilePath(s);if(c!==r)try{await this.validateMoveCopy(t,s,"copy",i.overwrite),await g.Promises.copy(c,r,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(r)),l.toString()))),this.toFileSystemProviderError(l)}}async validateMoveCopy(t,s,i,c){const r=this.toFilePath(t),l=this.toFilePath(s);let u=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,C.isEqual)(r,l,!0)),u){if(i==="copy")throw(0,d.createFileSystemProviderError)((0,w.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const S=await this.statIgnoreError(t);if(!S)throw(0,d.createFileSystemProviderError)((0,w.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const M=await this.statIgnoreError(s);if(M){if(!c)throw(0,d.createFileSystemProviderError)((0,w.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);S.type&d.FileType.File&&M.type&d.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,s){return this.doCloneFile(t,s,!1)}async doCloneFile(t,s,i){const c=this.toFilePath(t),r=this.toFilePath(s),l=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,C.isEqual)(c,r,!l))return;const u=new R.DisposableStore;try{u.add(await this.createResourceLock(t)),u.add(await this.createResourceLock(s)),i&&await g.Promises.mkdir((0,y.dirname)(r),{recursive:!0}),await g.Promises.copyFile(c,r)}catch(P){if(P.code==="ENOENT"&&!i)return this.doCloneFile(t,s,!0);throw this.toFileSystemProviderError(P)}finally{u.dispose()}}createUniversalWatcher(t,s,i){return new p.UniversalWatcherClient(c=>t(c),c=>s(c),i)}createNonRecursiveWatcher(t,s,i){return new m.NodeJSWatcherClient(c=>t(c),c=>s(c),i)}toFileSystemProviderError(t){if(t instanceof d.FileSystemProviderError)return t;let s=t,i;switch(t.code){case"ENOENT":i=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=d.FileSystemProviderErrorCode.Unknown;break;default:i=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(t,s){let i=this.toFileSystemProviderError(s);if(t&&i.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(i=(0,d.createFileSystemProviderError)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return i}}e.DiskFileSystemProvider=b}),define(oe[228],ae([0,1,4,100,2,17,68,23]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class y extends I.Disposable{constructor(f,g){super(),this.provider=f,this.logService=g,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,g,w){const d=this.getUriTransformer(f);switch(g){case"stat":return this.stat(d,w[0]);case"readdir":return this.readdir(d,w[0]);case"open":return this.open(d,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(d,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(d,w[0],w[1],w[2]);case"rename":return this.rename(d,w[0],w[1],w[2]);case"copy":return this.copy(d,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(d,w[0],w[1]);case"mkdir":return this.mkdir(d,w[0]);case"delete":return this.delete(d,w[0],w[1]);case"watch":return this.watch(d,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${g} not found`)}listen(f,g,w){const d=this.getUriTransformer(f);switch(g){case"fileChange":return this.onFileChange(d,w[0]);case"readFileStream":return this.onReadFileStream(d,w[0],w[1])}throw new Error(`Unknown event ${g}`)}stat(f,g){const w=this.transformIncoming(f,g,!0);return this.provider.stat(w)}readdir(f,g){const w=this.transformIncoming(f,g);return this.provider.readdir(w)}async readFile(f,g,w){const d=this.transformIncoming(f,g,!0),v=await this.provider.readFile(d,w);return k.VSBuffer.wrap(v)}onReadFileStream(f,g,w){const d=this.transformIncoming(f,g,!0),v=new R.CancellationTokenSource,E=new n.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),p=this.provider.readFileStream(d,w,v.token);return(0,C.listenStream)(p,{onData:m=>E.fire(k.VSBuffer.wrap(m)),onError:m=>E.fire(m),onEnd:()=>{E.fire("end"),E.dispose(),v.dispose()}}),E.event}writeFile(f,g,w,d){const v=this.transformIncoming(f,g);return this.provider.writeFile(v,w.buffer,d)}open(f,g,w){const d=this.transformIncoming(f,g,!0);return this.provider.open(d,w)}close(f){return this.provider.close(f)}async read(f,g,w){const d=k.VSBuffer.alloc(w),E=await this.provider.read(f,g,d.buffer,0,w);return[d,E]}write(f,g,w,d,v){return this.provider.write(f,g,w.buffer,d,v)}mkdir(f,g){const w=this.transformIncoming(f,g);return this.provider.mkdir(w)}delete(f,g,w){const d=this.transformIncoming(f,g);return this.provider.delete(d,w)}rename(f,g,w,d){const v=this.transformIncoming(f,g),E=this.transformIncoming(f,w);return this.provider.rename(v,E,d)}copy(f,g,w,d){const v=this.transformIncoming(f,g),E=this.transformIncoming(f,w);return this.provider.copy(v,E,d)}cloneFile(f,g,w){const d=this.transformIncoming(f,g),v=this.transformIncoming(f,w);return this.provider.cloneFile(d,v)}onFileChange(f,g){const w=new n.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(g,this.createSessionFileWatcher(f,w))},onDidRemoveLastListener:()=>{(0,I.dispose)(this.sessionToWatcher.get(g)),this.sessionToWatcher.delete(g)}});return w.event}async watch(f,g,w,d,v){const E=this.sessionToWatcher.get(g);if(E){const p=this.transformIncoming(f,d),m=E.watch(w,p,v);this.watchRequests.set(g+w,m)}}async unwatch(f,g){const w=f+g,d=this.watchRequests.get(w);d&&((0,I.dispose)(d),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,f]of this.watchRequests)f.dispose();this.watchRequests.clear();for(const[,f]of this.sessionToWatcher)f.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=y;class a extends I.Disposable{constructor(f,g,w,d){super(),this.uriTransformer=f,this.logService=w,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new o.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(g)}registerListeners(f){const g=this._register(new n.Emitter);this._register(g.event(w=>{f.fire(w.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this._register(this.fileWatcher.onDidChangeFile(w=>g.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>f.fire(w)))}getRecursiveWatcherOptions(f){}getExtraExcludes(f){}watch(f,g,w){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(w.excludes=[...w.excludes,...d]),this.watcherRequests.set(f,this.fileWatcher.watch(g,w)),(0,I.toDisposable)(()=>{(0,I.dispose)(this.watcherRequests.get(f)),this.watcherRequests.delete(f)})}dispose(){for(const[,f]of this.watcherRequests)f.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=a}),define(oe[229],ae([0,1,14,183,3,7,15,10,228,160,55]),function(V,e,n,o,I,k,C,R,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class f extends y.AbstractDiskFileSystemProviderChannel{constructor(d,v,E){super(d,v),this.environmentService=E}getUriTransformer(d){return a.DefaultURITransformer}transformIncoming(d,v){return k.URI.revive(v)}async delete(d,v,E){if(!E.useTrash)return super.delete(d,v,E);const p=this.transformIncoming(d,v),m=(0,R.normalize)(p.fsPath);try{await n.shell.trashItem(m)}catch(b){throw(0,C.createFileSystemProviderError)(I.isWindows?(0,o.localize)(0,null,(0,R.basename)(m),(0,h.toErrorMessage)(b)):(0,o.localize)(1,null,(0,R.basename)(m),(0,h.toErrorMessage)(b)),C.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,v){return new g(d,v,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=f;class g extends y.AbstractSessionFileWatcher{watch(d,v,E){if(E.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(d,v,E)}}}),define(oe[230],ae([0,1,5]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class o extends n.AbstractMessageLogger{constructor(k=n.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(C=>{this._logger?.setLevel(C)}))}set logger(k){this._logger=k;for(const{level:C,message:R}of this.buffer)(0,n.log)(k,C,R);this.buffer=[]}log(k,C){this._logger?(0,n.log)(this._logger,k,C):this.getLevel()<=k&&this.buffer.push({level:k,message:C})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=o}),define(oe[231],ae([0,1,7,4,5,2]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends I.AbstractLoggerService{constructor(f,g,w,d,v){super(g,w,d),this.windowId=f,this.channel=v,this._register(v.listen("onDidChangeLogLevel",f)(E=>{(0,I.isLogLevel)(E)?super.setLogLevel(E):super.setLogLevel(n.URI.revive(E[0]),E[1])})),this._register(v.listen("onDidChangeVisibility",f)(([E,p])=>super.setVisibility(n.URI.revive(E),p))),this._register(v.listen("onDidChangeLoggers",f)(({added:E,removed:p})=>{for(const m of E)super.registerLogger({...m,resource:n.URI.revive(m.resource)});for(const m of p)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new I.AdapterLogger({log:(f,g)=>{this.channel.call("consoleLog",[f,g])}})}registerLogger(f){super.registerLogger(f),this.channel.call("registerLogger",[f,this.windowId])}deregisterLogger(f){super.deregisterLogger(f),this.channel.call("deregisterLogger",[f,this.windowId])}setLogLevel(f,g){super.setLogLevel(f,g),this.channel.call("setLogLevel",[f,g])}setVisibility(f,g){super.setVisibility(f,g),this.channel.call("setVisibility",[this.toResource(f),g])}doCreateLogger(f,g,w){return new R(this.channel,f,g,w,this.windowId)}static setLogLevel(f,g,w){return f.call("setLogLevel",[g,w])}}e.LoggerChannelClient=C;class R extends I.AbstractMessageLogger{constructor(f,g,w,d,v){super(d?.logLevel==="always"),this.channel=f,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.channel.call("createLogger",[g,d,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,g){const w=[[f,g]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(f){this.channel.call("log",[this.file,f])}}class y{constructor(f,g){this.loggerService=f,this.getUriTransformer=g}listen(f,g){const w=this.getUriTransformer(f);switch(g){case"onDidChangeLoggers":return o.Event.map(this.loggerService.onDidChangeLoggers,d=>({added:[...d.added].map(v=>this.transformLogger(v,w)),removed:[...d.removed].map(v=>this.transformLogger(v,w))}));case"onDidChangeVisibility":return o.Event.map(this.loggerService.onDidChangeVisibility,d=>[w.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return o.Event.map(this.loggerService.onDidChangeLogLevel,d=>(0,I.isLogLevel)(d)?d:[w.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${g}`)}async call(f,g,w){const d=this.getUriTransformer(f);switch(g){case"setLogLevel":return(0,I.isLogLevel)(w[0])?this.loggerService.setLogLevel(w[0]):this.loggerService.setLogLevel(n.URI.revive(d.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(v=>this.transformLogger(v,d)))}throw new Error(`Call not found: ${g}`)}transformLogger(f,g){return{...f,resource:g.transformOutgoingURI(f.resource)}}}e.LoggerChannel=y;class a extends k.Disposable{constructor(f,g){super(),g.call("setLogLevel",[f.getLogLevel()]),this._register(f.onDidChangeLogLevel(w=>g.call("setLogLevel",[w]))),g.call("getRegisteredLoggers").then(w=>{for(const d of w)f.registerLogger({...d,resource:n.URI.revive(d.resource)})}),this._register(g.listen("onDidChangeVisibility")(([w,d])=>f.setVisibility(n.URI.revive(w),d))),this._register(g.listen("onDidChangeLoggers")(({added:w,removed:d})=>{for(const v of w)f.registerLogger({...v,resource:n.URI.revive(v.resource)});for(const v of d)f.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=a}),define(oe[232],ae([0,1,2,5]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends n.Disposable{constructor(C,R=[]){super(),this.logger=new o.MultiplexLogger([C,...R]),this._register(C.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(C){this.logger.setLevel(C)}getLevel(){return this.logger.getLevel()}trace(C,...R){this.logger.trace(C,...R)}debug(C,...R){this.logger.debug(C,...R)}info(C,...R){this.logger.info(C,...R)}warn(C,...R){this.logger.warn(C,...R)}error(C,...R){this.logger.error(C,...R)}flush(){this.logger.flush()}}e.LogService=I}),define(oe[233],ae([0,1,32,7,5]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class k{constructor(R){this.loggerService=R,this.loggers=new n.ResourceMap}listen(R,y,a){switch(y){case"onDidChangeLoggers":return a?this.loggerService.getOnDidChangeLoggersEvent(a):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.loggerService.getOnDidChangeLogLevelEvent(a):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.loggerService.getOnDidChangeVisibilityEvent(a):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${y}`)}async call(R,y,a){switch(y){case"createLogger":this.createLogger(o.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.log(o.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1]);case"setLogLevel":return(0,I.isLogLevel)(a[0])?this.loggerService.setLogLevel(a[0]):this.loggerService.setLogLevel(o.URI.revive(a[0]),a[1]);case"setVisibility":return this.loggerService.setVisibility(o.URI.revive(a[0]),a[1]);case"registerLogger":return this.loggerService.registerLogger({...a[0],resource:o.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(o.URI.revive(a[0]))}throw new Error(`Call not found: ${y}`)}createLogger(R,y,a){this.loggers.set(R,this.loggerService.createLogger(R,y,a))}consoleLog(R,y){let a=console.log;switch(R){case I.LogLevel.Error:a=console.error;break;case I.LogLevel.Warning:a=console.warn;break;case I.LogLevel.Info:a=console.info;break}a.call(console,...y)}log(R,y){const a=this.loggers.get(R);if(!a)throw new Error("Create the logger before logging");for(const[h,f]of y)(0,I.log)(a,h,f)}}e.LoggerChannel=k}),define(oe[234],ae([0,1,15,5]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function k(a,h,f,g,w){try{const d=await new Promise((E,p)=>{V(["@vscode/spdlog"],E,p)}).then(ke);d.setFlushOn(I.Trace);const v=await d.createAsyncRotatingLogger(a,h,f,g);return w?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function C(a,h,f){switch(h){case o.LogLevel.Trace:a.trace(f);break;case o.LogLevel.Debug:a.debug(f);break;case o.LogLevel.Info:a.info(f);break;case o.LogLevel.Warning:a.warn(f);break;case o.LogLevel.Error:a.error(f);break;case o.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function R(a,h){switch(h){case o.LogLevel.Trace:a.setLevel(I.Trace);break;case o.LogLevel.Debug:a.setLevel(I.Debug);break;case o.LogLevel.Info:a.setLevel(I.Info);break;case o.LogLevel.Warning:a.setLevel(I.Warning);break;case o.LogLevel.Error:a.setLevel(I.Error);break;case o.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class y extends o.AbstractMessageLogger{constructor(h,f,g,w,d){super(),this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(h,f,g,w),this._register(this.onDidChangeLogLevel(v=>{this._logger&&R(this._logger,v)}))}async _createSpdLogLogger(h,f,g,w){const d=g?6:1,v=30/d*n.ByteSize.MB,E=await k(h,f,v,d,w);if(E){this._logger=E,R(this._logger,this.getLevel());for(const{level:p,message:m}of this.buffer)C(this._logger,p,m);this.buffer=[]}}log(h,f){this._logger?C(this._logger,h,f):this.getLevel()<=h&&this.buffer.push({level:h,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(oe[235],ae([0,1,33,5,234]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class k extends o.AbstractLoggerService{doCreateLogger(R,y,a){return new I.SpdLogLogger((0,n.generateUuid)(),R.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,y)}}e.LoggerService=k}),define(oe[72],ae([0,1,32,4,6,5,235]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,I.refineServiceDecorator)(k.ILoggerService);class R extends C.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new n.ResourceMap}createLogger(a,h,f){f!==void 0&&this.loggerResourcesByWindow.set(this.toResource(a),f);try{return super.createLogger(a,h)}catch(g){throw this.loggerResourcesByWindow.delete(this.toResource(a)),g}}registerLogger(a,h){h!==void 0&&this.loggerResourcesByWindow.set(a.resource,h),super.registerLogger(a)}deregisterLogger(a){this.loggerResourcesByWindow.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const h=[];for(const f of super.getRegisteredLoggers())a===this.loggerResourcesByWindow.get(f.resource)&&h.push(f);return h}getOnDidChangeLogLevelEvent(a){return o.Event.filter(this.onDidChangeLogLevel,h=>(0,k.isLogLevel)(h)||this.isInterestedLoggerResource(h[0],a))}getOnDidChangeVisibilityEvent(a){return o.Event.filter(this.onDidChangeVisibility,([h])=>this.isInterestedLoggerResource(h,a))}getOnDidChangeLoggersEvent(a){return o.Event.filter(o.Event.map(this.onDidChangeLoggers,h=>({added:[...h.added].filter(g=>this.isInterestedLoggerResource(g.resource,a)),removed:[...h.removed].filter(g=>this.isInterestedLoggerResource(g.resource,a))})),h=>h.added.length>0||h.removed.length>0)}deregisterLoggers(a){for(const[h,f]of this.loggerResourcesByWindow)f===a&&this.deregisterLogger(h)}isInterestedLoggerResource(a,h){const f=this.loggerResourcesByWindow.get(a);return f===void 0||f===h}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=R}),define(oe[236],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=n,e.isMenubarMenuItemSeparator=o,e.isMenubarMenuItemRecentAction=I,e.isMenubarMenuItemAction=k;function n(C){return C.submenu!==void 0}function o(C){return C.id==="vscode.menubar.separator"}function I(C){return C.uri!==void 0}function k(C){return!n(C)&&!o(C)&&!I(C)}}),define(oe[40],ae([0,1,4,78,2,6]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class C extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const h=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},h!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),o.Iterable.reduce(this.policies.entries(),(f,[g,w])=>({...f,[g]:w}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return o.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[h,f])=>({...a,[h]:{definition:f,value:this.policies.get(h)}}),{})}}e.AbstractPolicyService=C;class R{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[237],ae([0,1,8,4,78,13,15,5,40]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(f,g){const w=[];for(const d of new Set(I.Iterable.concat(f.keys(),g.keys())))f.get(d)!==g.get(d)&&w.push(d);return w}let h=class extends y.AbstractPolicyService{constructor(g,w,d){super(),this.file=g,this.fileService=w,this.logService=d,this.throttledDelayer=this._register(new n.ThrottledDelayer(500));const v=o.Event.filter(w.onDidFilesChange,E=>E.affects(g));this._register(w.watch(g)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const g=new Map;try{const w=await this.fileService.readFile(this.file),d=JSON.parse(w.value.toString());if(!(0,k.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.policyDefinitions[v]&&g.set(v,d[v])}catch(w){w.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",w)}return g}async refresh(){const g=await this.read(),w=a(this.policies,g);this.policies=g,w.length>0&&this._onDidChange.fire(w)}};e.FilePolicyService=h,e.FilePolicyService=h=Pe([ne(1,C.IFileService),ne(2,R.ILogService)],h)}),define(oe[238],ae([0,1,4,2,40]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(y){this.service=y,this.disposables=new o.DisposableStore}listen(y,a){switch(a){case"onDidChange":return n.Event.map(this.service.onDidChange,h=>h.reduce((f,g)=>({...f,[g]:this.service.getPolicyValue(g)??null}),{}),this.disposables)}throw new Error(`Event not found: ${a}`)}call(y,a,h){switch(a){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(h)}throw new Error(`Call not found: ${a}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=k;class C extends I.AbstractPolicyService{constructor(y,a){super(),this.channel=a;for(const h in y){const{definition:f,value:g}=y[h];this.policyDefinitions[h]=f,g!==void 0&&this.policies.set(h,g)}this.channel.listen("onDidChange")(h=>{for(const f in h){const g=h[f];g===null?this.policies.delete(f):this.policies.set(f,g)}this._onDidChange.fire(Object.keys(h))})}async _updatePolicyDefinitions(y){const a=await this.channel.call("updatePolicyDefinitions",y);for(const h in a)this.policies.set(h,a[h])}}e.PolicyChannelClient=C}),define(oe[239],ae([0,1,40,8,2,5]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let C=class extends n.AbstractPolicyService{constructor(y,a){super(),this.logService=y,this.productName=a,this.throttler=new o.Throttler,this.watcher=this._register(new I.MutableDisposable)}async _updatePolicyDefinitions(y){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(y).length} policy definitions`);const{createWatcher:a}=await new Promise((h,f)=>{V(["@vscode/policy-watcher"],h,f)}).then(ke);await this.throttler.queue(()=>new Promise((h,f)=>{try{this.watcher.value=a(this.productName,y,g=>{this._onDidPolicyChange(g),h()})}catch(g){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),f(g)}}))}_onDidPolicyChange(y){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(y)}`);for(const a in y){const h=y[a];h===void 0?this.policies.delete(a):this.policies.set(a,h)}this._onDidChange.fire(Object.keys(y))}};e.NativePolicyService=C,e.NativePolicyService=C=Pe([ne(0,k.ILogService)],C)}),define(oe[73],ae([0,1,37]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const k=I.context.configuration();if(k)o=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){o=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:C,itemUrl:R,controlUrl:y}=o.extensionsGallery||{};Object.assign(o,{extensionsGallery:{serviceUrl:n.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:n.env.VSCODE_GALLERY_SEARCH_URL||C,itemUrl:n.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:n.env.VSCODE_GALLERY_CONTROL_URL||y}});try{const a=(...f)=>f.reduce((g,w)=>(Object.keys(w).forEach(d=>{Array.isArray(g[d])&&Array.isArray(w[d])?g[d]=w[d]:typeof g[d]=="object"&&typeof w[d]=="object"?g[d]=a(g[d],w[d]):g[d]=w[d]}),g),{}),h=globalThis._VSCODE_USER_PRODUCT_JSON||{};o=a(o,h)}catch{}if(n.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const a=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:a.version,release:a.release})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(oe[28],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[240],ae([0,1,8,5]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let I=class{constructor(C,R,y){this._window=C,this._sessionId=R,this._logService=y}async inspect(C){await this._connect();const R=this._window.webContents.debugger;await R.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,n.timeout)(C);const y=await R.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),y.profile}async _connect(){const C=this._window.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async _disconnect(){const C=this._window.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.WindowProfiler=I,e.WindowProfiler=I=Pe([ne(2,o.ILogService)],I)}),define(oe[74],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,n.createDecorator)("protocolMainService")}),define(oe[45],ae([0,1,141,13]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,n=ke(n),o=ke(o);class I{constructor(){this.data=new Map}add(C,R){n.ok(o.isString(C)),n.ok(o.isObject(R)),n.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,R)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(oe[241],ae([0,1,4,45]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,o=ke(o),e.Extensions={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,a){this.schemasById[I(y)]=a,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new k;o.Registry.add(e.Extensions.JSONContribution,C)}),define(oe[56],ae([0,1,22,4,13,168,18,241,45]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=v,e.keyFromOverrideIdentifiers=E,e.getDefaultValue=p,e.validateProperty=b,e.getScopes=D,I=ke(I),k=ke(k);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var h;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const f=y.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new o.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new o.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,i=!0){this.registerConfigurations([s],i)}registerConfigurations(s,i=!0){const c=new Set;this.doRegisterConfigurations(s,i,c),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(s){const i=new Set;this.doDeregisterConfigurations(s,i),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:s,remove:i}){const c=new Set;this.doDeregisterConfigurations(i,c),this.doRegisterConfigurations(s,!1,c),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}registerDefaultConfigurations(s){const i=new Set;this.doRegisterDefaultConfigurations(s,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doRegisterDefaultConfigurations(s,i){const c=[];for(const{overrides:r,source:l}of s)for(const u in r)if(i.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const P=this.configurationDefaultsOverrides.get(u),S=P?.valuesSources??new Map,M=P?.value||{};for(const A of Object.keys(r[u])){const _=r[u][A];if(I.isObject(_)&&(I.isUndefined(M[A])||I.isObject(M[A]))){if(M[A]={...M[A]??{},..._},l){let N=S.get(A);if(N||(N=new Map,S.set(A,N)),!(N instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const z in _)N.set(z,l)}}else M[A]=_,l&&S.set(A,l)}this.configurationDefaultsOverrides.set(u,{source:l,value:M,valuesSources:S});const T=(0,C.getLanguageTagSettingPlainKey)(u),L={type:"object",default:M,description:k.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:I.isString(l)?void 0:l,defaultValueSource:l};c.push(...v(u)),this.configurationProperties[u]=L,this.defaultLanguageConfigurationOverridesNode.properties[u]=L}else{const P=this.configurationProperties[u],S=this.configurationDefaultsOverrides.get(u);let M=S?.value??P?.defaultDefaultValue,T=r[u],L=l;if(I.isObject(T)&&(P!==void 0&&P.type==="object"||P===void 0&&(I.isUndefined(M)||I.isObject(M)))){if(I.isObject(M)||(M={}),T={...M,...T},L=S?.source??new Map,!(L instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const _ in r[u])l?L.set(_,l):L.delete(_)}this.configurationDefaultsOverrides.set(u,{value:T,source:L}),P&&(this.updatePropertyDefaultValue(u,P),this.updateSchema(u,P))}this.doRegisterOverrideIdentifiers(c)}deregisterDefaultConfigurations(s){const i=new Set;this.doDeregisterDefaultConfigurations(s,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(s,i){for(const{overrides:c,source:r}of s)for(const l in c){const u=I.isString(r)?r:r?.id,P=this.configurationDefaultsOverrides.get(l);if(P){if(e.OVERRIDE_PROPERTY_REGEX.test(l)){for(const M of Object.keys(c[l])){const T=c[l][M];if(I.isObject(T)){const L=P.valuesSources?.get(M);for(const A of Object.keys(T)){const _=L?.get(A);(I.isString(_)?_:_?.id)===u&&(L?.delete(A),delete P.value[M][A])}Object.keys(P.value[M]).length===0&&(delete P.value[M],P.valuesSources?.delete(M))}else{const L=P.valuesSources?.get(M);(I.isString(L)?L:L?.id)===u&&(P.valuesSources?.delete(M),delete P.value[M])}}const S=this.configurationDefaultsOverrides.get(l);S&&Object.keys(S.value).length===0&&(this.configurationDefaultsOverrides.delete(l),delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l])}else{if(P.source instanceof Map){const M=P.source;for(const T in c[l]){const L=M.get(T);(I.isString(L)?L:L?.id)===u&&(M.delete(T),delete P.value[T])}M.size===0&&this.configurationDefaultsOverrides.delete(l)}else{const M=I.isString(P.source)?P.source:P.source?.id;if(u!==M)continue;this.configurationDefaultsOverrides.delete(l)}const S=this.configurationProperties[l];S&&(this.updatePropertyDefaultValue(l,S),this.updateSchema(l,S))}i.add(l)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(s){let i=!1;const c=new Set;s.removedDefaults&&(this.doDeregisterDefaultConfigurations(s.removedDefaults,c),i=!0),s.addedDefaults&&(this.doRegisterDefaultConfigurations(s.addedDefaults,c),i=!0),s.removedConfigurations&&this.doDeregisterConfigurations(s.removedConfigurations,c),s.addedConfigurations&&this.doRegisterConfigurations(s.addedConfigurations,!1,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){this.doRegisterOverrideIdentifiers(s),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(s){for(const i of s)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,i,c){s.forEach(r=>{this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties,void 0,c),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(s,i){const c=r=>{if(r.properties)for(const l in r.properties){i.add(l);const u=this.configurationProperties[l];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,r.properties[l])}r.allOf?.forEach(l=>c(l))};for(const r of s){c(r);const l=this.configurationContributors.indexOf(r);l!==-1&&this.configurationContributors.splice(l,1)}}validateAndRegisterProperties(s,i=!0,c,r,l=h.WINDOW,u){l=I.isUndefinedOrNull(s.scope)?l:s.scope;const P=s.properties;if(P)for(const M in P){const T=P[M];if(i&&b(M,T)){delete P[M];continue}if(T.source=c,T.defaultDefaultValue=P[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=I.isUndefinedOrNull(T.scope)?l:T.scope,T.restricted=I.isUndefinedOrNull(T.restricted)?!!r?.includes(M):T.restricted),P[M].hasOwnProperty("included")&&!P[M].included){this.excludedConfigurationProperties[M]=P[M],delete P[M];continue}else this.configurationProperties[M]=P[M],P[M].policy?.name&&this.policyConfigurations.set(P[M].policy.name,M);!P[M].deprecationMessage&&P[M].markdownDeprecationMessage&&(P[M].deprecationMessage=P[M].markdownDeprecationMessage),u.add(M)}const S=s.allOf;if(S)for(const M of S)this.validateAndRegisterProperties(M,i,c,r,l,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const i=c=>{const r=c.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);c.allOf?.forEach(i)};i(s)}updateSchema(s,i){switch(e.allSettings.properties[s]=i,i.scope){case h.APPLICATION:e.applicationSettings.properties[s]=i;break;case h.MACHINE:e.machineSettings.properties[s]=i;break;case h.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[s]=i;break;case h.WINDOW:e.windowSettings.properties[s]=i;break;case h.RESOURCE:e.resourceSettings.properties[s]=i;break;case h.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[s]=i,this.resourceLanguageSettingsSchema.properties[s]=i;break}}removeFromSchema(s,i){switch(delete e.allSettings.properties[s],i.scope){case h.APPLICATION:delete e.applicationSettings.properties[s];break;case h.MACHINE:delete e.machineSettings.properties[s];break;case h.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[s];break;case h.WINDOW:delete e.windowSettings.properties[s];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const i=`[${s}]`,c={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,c),e.allSettings.properties[i]=c,e.applicationSettings.properties[i]=c,e.machineSettings.properties[i]=c,e.machineOverridableSettings.properties[i]=c,e.windowSettings.properties[i]=c,e.resourceSettings.properties[i]=c}}registerOverridePropertyPatternKey(){const s={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,i){const c=this.configurationDefaultsOverrides.get(s);let r=c?.value,l=c?.source;I.isUndefined(r)&&(r=i.defaultDefaultValue,l=void 0),I.isUndefined(r)&&(r=p(i.type)),i.default=r,i.defaultValueSource=l}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(t){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let i=d.exec(t);for(;i?.length;){const c=i[1].trim();c&&s.push(c),i=d.exec(t)}}return(0,n.distinct)(s)}function E(t){return t.reduce((s,i)=>`${s}[${i}]`,"")}function p(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new g;y.Registry.add(e.Extensions.Configuration,m);function b(t,s){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?k.localize(7,null,t):m.getConfigurationProperties()[t]!==void 0?k.localize(8,null,t):s.policy?.name&&m.getPolicyConfigurations().get(s.policy?.name)!==void 0?k.localize(9,null,t,s.policy?.name,m.getPolicyConfigurations().get(s.policy?.name)):null:k.localize(6,null)}function D(){const t=[],s=m.getConfigurationProperties();for(const i of Object.keys(s))t.push([i,s[i].scope]);return t.push(["launch",h.RESOURCE]),t.push(["task",h.RESOURCE]),t}}),define(oe[126],ae([0,1,22,4,43,2,32,36,13,7,18,56,15,45]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=D,n=ke(n),I=ke(I),R=ke(R),y=ke(y);function d(c){return Object.isFrozen(c)?c:R.deepFreeze(c)}class v{static createEmptyModel(r){return new v({},[],[],void 0,r)}constructor(r,l,u,P,S){this._contents=r,this._keys=l,this._overrides=u,this.raw=P,this.logService=S,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof v)return l;const u=new E("",this.logService);return u.parseRaw(l),u.configurationModel});this._rawConfiguration=r.reduce((l,u)=>u===l?u:l.merge(u),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,h.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const u=this;return{get value(){return d(u.rawConfiguration.getValue(r))},get override(){return l?d(u.rawConfiguration.getOverrideValue(r,l)):void 0},get merged(){return d(l?u.rawConfiguration.override(l).getValue(r):u.rawConfiguration.getValue(r))},get overrides(){const P=[];for(const{contents:S,identifiers:M,keys:T}of u.rawConfiguration.overrides){const L=new v(S,T,[],void 0,u.logService).getValue(r);L!==void 0&&P.push({identifiers:M,value:L})}return P.length?d(P):void 0}}}getOverrideValue(r,l){const u=this.getContentsForOverrideIdentifer(l);return u?r?(0,h.getConfigurationValue)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const u of this.overrides)u.identifiers.includes(r)&&l.push(...u.keys);return n.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return n.distinct(r)}override(r){let l=this.overrideConfigurations.get(r);return l||(l=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,l)),l}merge(...r){const l=R.deepClone(this.contents),u=R.deepClone(this.overrides),P=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const M of r)if(S.push(...M.raw?.length?M.raw:[M]),!M.isEmpty()){this.mergeContents(l,M.contents);for(const T of M.overrides){const[L]=u.filter(A=>n.equals(A.identifiers,T.identifiers));L?(this.mergeContents(L.contents,T.contents),L.keys.push(...T.keys),L.keys=n.distinct(L.keys)):u.push(R.deepClone(T))}for(const T of M.keys)P.indexOf(T)===-1&&P.push(T)}return new v(l,P,u,S.every(M=>M instanceof v)?void 0:S,this.logService)}createOverrideConfigurationModel(r){const l=this.getContentsForOverrideIdentifer(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const P of n.distinct([...Object.keys(this.contents),...Object.keys(l)])){let S=this.contents[P];const M=l[P];M&&(typeof S=="object"&&typeof M=="object"?(S=R.deepClone(S),this.mergeContents(S,M)):S=M),u[P]=S}return new v(u,this.keys,this.overrides,void 0,this.logService)}mergeContents(r,l){for(const u of Object.keys(l)){if(u in r&&y.isObject(r[u])&&y.isObject(l[u])){this.mergeContents(r[u],l[u]);continue}r[u]=R.deepClone(l[u])}}getContentsForOverrideIdentifer(r){let l=null,u=null;const P=S=>{S&&(u?this.mergeContents(u,S):u=R.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===r?l=S.contents:S.identifiers.includes(r)&&P(S.contents);return P(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,l){this.updateValue(r,l,!0)}setValue(r,l){this.updateValue(r,l,!1)}removeValue(r){const l=this.keys.indexOf(r);l!==-1&&(this.keys.splice(l,1),(0,h.removeFromValueTree)(this.contents,r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(u=>n.equals(u.identifiers,(0,f.overrideIdentifiersFromKey)(r))),1))}updateValue(r,l,u){(0,h.addToValueTree)(this.contents,r,l,P=>this.logService.error(P)),u=u||this.keys.indexOf(r)===-1,u&&this.keys.push(r),f.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,f.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,h.toValuesTree)(this.contents[r],P=>this.logService.error(P))})}}e.ConfigurationModel=v;class E{constructor(r,l){this._name=r,this.logService=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||v.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,l){if(!y.isUndefinedOrNull(r)){const u=this.doParseContent(r);this.parseRaw(u,l)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,l){this._raw=r;const{contents:u,keys:P,overrides:S,restricted:M,hasExcludedProperties:T}=this.doParseRaw(r,l);this._configurationModel=new v(u,P,S,T?[r]:void 0,this.logService),this._restrictedConfigurations=M||[]}doParseContent(r){let l={},u=null,P=[];const S=[],M=[];function T(A){Array.isArray(P)?P.push(A):u!==null&&(P[u]=A)}const L={onObjectBegin:()=>{const A={};T(A),S.push(P),P=A,u=null},onObjectProperty:A=>{u=A},onObjectEnd:()=>{P=S.pop()},onArrayBegin:()=>{const A=[];T(A),S.push(P),P=A,u=null},onArrayEnd:()=>{P=S.pop()},onLiteralValue:T,onError:(A,_,B)=>{M.push({error:A,offset:_,length:B})}};if(r)try{I.visit(r,L),l=P[0]||{}}catch(A){this.logService.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return l}doParseRaw(r,l){const u=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),P=this.filter(r,u,!0,l);r=P.raw;const S=(0,h.toValuesTree)(r,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`)),M=Object.keys(r),T=this.toOverrides(r,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:S,keys:M,overrides:T,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}filter(r,l,u,P){let S=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:S};const M={},T=[];for(const L in r)if(f.OVERRIDE_PROPERTY_REGEX.test(L)&&u){const A=this.filter(r[L],l,!1,P);M[L]=A.raw,S=S||A.hasExcludedProperties,T.push(...A.restricted)}else{const A=l[L],_=A?typeof A.scope<"u"?A.scope:f.ConfigurationScope.WINDOW:void 0;A?.restricted&&T.push(L),!P.exclude?.includes(L)&&(P.include?.includes(L)||(_===void 0||P.scopes===void 0||P.scopes.includes(_))&&!(P.skipRestricted&&A?.restricted))?M[L]=r[L]:S=!0}return{raw:M,restricted:T,hasExcludedProperties:S}}toOverrides(r,l){const u=[];for(const P of Object.keys(r))if(f.OVERRIDE_PROPERTY_REGEX.test(P)){const S={};for(const M in r[P])S[M]=r[P][M];u.push({identifiers:(0,f.overrideIdentifiersFromKey)(P),keys:Object.keys(S),contents:(0,h.toValuesTree)(S,l)})}return u}}e.ConfigurationModelParser=E;class p extends k.Disposable{constructor(r,l,u,P,S){super(),this.userSettingsResource=r,this.parseOptions=l,this.fileService=P,this.logService=S,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString(),S),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.any(o.Event.filter(this.fileService.onDidFilesChange,M=>M.contains(this.userSettingsResource)),o.Event.filter(this.fileService.onDidRunOperation,M=>(M.isOperation(g.FileOperation.CREATE)||M.isOperation(g.FileOperation.COPY)||M.isOperation(g.FileOperation.DELETE)||M.isOperation(g.FileOperation.WRITE))&&u.isEqual(M.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return v.createEmptyModel(this.logService)}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(r,l,u,P,S,M,T,L,A,_,B,N,z){this.key=r,this.overrides=l,this._value=u,this.overrideIdentifiers=P,this.defaultConfiguration=S,this.policyConfiguration=M,this.applicationConfiguration=T,this.userConfiguration=L,this.localUserConfiguration=A,this.remoteUserConfiguration=_,this.workspaceConfiguration=B,this.folderConfigurationModel=N,this.memoryConfigurationModel=z}get value(){return d(this._value)}toInspectValue(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class b{constructor(r,l,u,P,S,M,T,L,A,_){this._defaultConfiguration=r,this._policyConfiguration=l,this._applicationConfiguration=u,this._localUserConfiguration=P,this._remoteUserConfiguration=S,this._workspaceConfiguration=M,this._folderConfigurations=T,this._memoryConfiguration=L,this._memoryConfigurationByResource=A,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(r,l,u){return this.getConsolidatedConfigurationModel(r,l,u).getValue(r)}updateValue(r,l,u={}){let P;u.resource?(P=this._memoryConfigurationByResource.get(u.resource),P||(P=v.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(u.resource,P))):P=this._memoryConfiguration,l===void 0?P.removeValue(r):P.setValue(r,l),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,l,u){const P=this.getConsolidatedConfigurationModel(r,l,u),S=this.getFolderConfigurationModelForResource(l.resource,u),M=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,T=new Set;for(const L of P.overrides)for(const A of L.identifiers)P.getOverrideValue(r,A)!==void 0&&T.add(A);return new m(r,l,P.getValue(r),T.size?[...T]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this._workspaceConfiguration:void 0,S||void 0,M)}keys(r){const l=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,l){this._folderConfigurations.set(r,l),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const u=[];if(!l){const{added:P,updated:S,removed:M}=s(this._defaultConfiguration,r);l=[...P,...S,...M]}for(const P of l)for(const S of(0,f.overrideIdentifiersFromKey)(P)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(S),T=r.getKeysForOverrideIdentifier(S),L=[...T.filter(A=>M.indexOf(A)===-1),...M.filter(A=>T.indexOf(A)===-1),...M.filter(A=>!R.equals(this._defaultConfiguration.override(S).getValue(A),r.override(S).getValue(A)))];u.push([S,L])}return this.updateDefaultConfiguration(r),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:u,removed:P}=s(this._policyConfiguration,r),S=[...l,...u,...P];return S.length&&this.updatePolicyConfiguration(r),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:u,removed:P,overrides:S}=s(this.applicationConfiguration,r),M=[...l,...u,...P];return M.length&&this.updateApplicationConfiguration(r),{keys:M,overrides:S}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:u,removed:P,overrides:S}=s(this.localUserConfiguration,r),M=[...l,...u,...P];return M.length&&this.updateLocalUserConfiguration(r),{keys:M,overrides:S}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:u,removed:P,overrides:S}=s(this.remoteUserConfiguration,r),M=[...l,...u,...P];return M.length&&this.updateRemoteUserConfiguration(r),{keys:M,overrides:S}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:u,removed:P,overrides:S}=s(this.workspaceConfiguration,r),M=[...l,...u,...P];return M.length&&this.updateWorkspaceConfiguration(r),{keys:M,overrides:S}}compareAndUpdateFolderConfiguration(r,l){const u=this.folderConfigurations.get(r),{added:P,updated:S,removed:M,overrides:T}=s(u,l),L=[...P,...S,...M];return(L.length||!u)&&this.updateFolderConfiguration(r,l),{keys:L,overrides:T}}compareAndDeleteFolderConfiguration(r){const l=this.folderConfigurations.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:P,removed:S,overrides:M}=s(l,void 0);return{keys:[...u,...P,...S],overrides:M}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,l,u){let P=this.getConsolidatedConfigurationModelForResource(l,u);return l.overrideIdentifier&&(P=P.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(P=P.merge(this._policyConfiguration)),P}getConsolidatedConfigurationModelForResource({resource:r},l){let u=this.getWorkspaceConsolidatedConfiguration();if(l&&r){const P=l.getFolder(r);P&&(u=this.getFolderConsolidatedConfiguration(P.uri)||u);const S=this._memoryConfigurationByResource.get(r);S&&(u=u.merge(S))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let l=this._foldersConsolidatedConfigurations.get(r);if(!l){const u=this.getWorkspaceConsolidatedConfiguration(),P=this._folderConfigurations.get(r);P?(l=u.merge(P),this._foldersConsolidatedConfigurations.set(r,l)):l=u}return l}getFolderConfigurationModelForResource(r,l){if(l&&r){const u=l.getFolder(r);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,l)=>{const{contents:u,overrides:P,keys:S}=this._folderConfigurations.get(l);return r.push([l,{contents:u,overrides:P,keys:S}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(l=>r.add(l)),this.userConfiguration.keys.forEach(l=>r.add(l)),this._workspaceConfiguration.keys.forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(u=>r.add(u))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(P=>l.add(P))),[...l.values()]}static parse(r,l){const u=this.parseConfigurationModel(r.defaults,l),P=this.parseConfigurationModel(r.policy,l),S=this.parseConfigurationModel(r.application,l),M=this.parseConfigurationModel(r.user,l),T=this.parseConfigurationModel(r.workspace,l),L=r.folders.reduce((A,_)=>(A.set(a.URI.revive(_[0]),this.parseConfigurationModel(_[1],l)),A),new C.ResourceMap);return new b(u,P,S,M,v.createEmptyModel(l),T,L,v.createEmptyModel(l),new C.ResourceMap,l)}static parseConfigurationModel(r,l){return new v(r.contents,r.keys,r.overrides,void 0,l)}}e.Configuration=b;function D(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,l=new Map;for(const P of c)P.keys.forEach(S=>r.add(S)),P.overrides.forEach(([S,M])=>{const T=(0,C.getOrSet)(l,S,new Set);M.forEach(L=>T.add(L))});const u=[];return l.forEach((P,S)=>u.push([S,[...P.values()]])),{keys:[...r.values()],overrides:u}}class t{constructor(r,l,u,P,S){this.change=r,this.previous=l,this.currentConfiguraiton=u,this.currentWorkspace=P,this.logService=S,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const M of r.keys)this.affectedKeys.add(M);for(const[,M]of r.overrides)for(const T of M)this.affectedKeys.add(T);this._affectsConfigStr=this._marker;for(const M of this.affectedKeys)this._affectsConfigStr+=M+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(r,l){const u=this._marker+r,P=this._affectsConfigStr.indexOf(u);if(P<0)return!1;const S=P+u.length;if(S>=this._affectsConfigStr.length)return!1;const M=this._affectsConfigStr.charCodeAt(S);if(M!==this._markerCode1&&M!==this._markerCode2)return!1;if(l){const T=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(r,l,this.currentWorkspace);return!R.equals(T,L)}return!0}}e.ConfigurationChangeEvent=t;function s(c,r){const{added:l,removed:u,updated:P}=i(r?.rawConfiguration,c?.rawConfiguration),S=[],M=c?.getAllOverrideIdentifiers()||[],T=r?.getAllOverrideIdentifiers()||[];if(r){const L=T.filter(A=>!M.includes(A));for(const A of L)S.push([A,r.getKeysForOverrideIdentifier(A)])}if(c){const L=M.filter(A=>!T.includes(A));for(const A of L)S.push([A,c.getKeysForOverrideIdentifier(A)])}if(r&&c){for(const L of M)if(T.includes(L)){const A=i({contents:c.getOverrideValue(void 0,L)||{},keys:c.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});S.push([L,[...A.added,...A.removed,...A.updated]])}}return{added:l,removed:u,updated:P,overrides:S}}function i(c,r){const l=c?r?c.keys.filter(S=>r.keys.indexOf(S)===-1):[...c.keys]:[],u=r?c?r.keys.filter(S=>c.keys.indexOf(S)===-1):[...r.keys]:[],P=[];if(c&&r){for(const S of r.keys)if(c.keys.indexOf(S)!==-1){const M=(0,h.getConfigurationValue)(r.contents,S),T=(0,h.getConfigurationValue)(c.contents,S);R.equals(M,T)||P.push(S)}}return{added:l,removed:u,updated:P}}}),define(oe[242],ae([0,1,22,4,2,36,13,126,56,5,40,45]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(E){super(),this.logService=E,this._onDidChangeConfiguration=this._register(new o.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(f.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:p})=>this.onDidUpdateConfiguration(Array.from(E),p))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,p){this.updateConfigurationModel(E,f.Registry.as(y.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);const E=f.Registry.as(y.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,p){const m=this.getConfigurationDefaultOverrides();for(const b of E){const D=m[b],t=p[b];D!==void 0?this._configurationModel.addValue(b,D):t?this._configurationModel.addValue(b,t.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=g;class w{constructor(){this.onDidChangeConfiguration=o.Event.None,this.configurationModel=R.ConfigurationModel.createEmptyModel(new a.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let d=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(E,p,m){super(),this.defaultConfiguration=E,this.policyService=p,this.logService=m,this._onDidChangeConfiguration=this._register(new o.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const p={},m=[],b=f.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(const D of E){const t=b[D];if(!t){m.push(D);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.logService.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}m.push(D),p[t.policy.name]={type:t.type}}}return(0,C.isEmptyObject)(p)||await this.policyService.updatePolicyDefinitions(p),m}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const p=f.Registry.as(y.Extensions.Configuration).getPolicyConfigurations(),m=(0,n.coalesce)(E.map(b=>p.get(b)));this.update(m,!0)}update(E,p){this.logService.trace("PolicyConfiguration#update",E);const m=f.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),b=[],D=this._configurationModel.isEmpty();for(const t of E){const s=m[t]?.policy?.name;if(s){const i=this.policyService.getPolicyValue(s);(D?i!==void 0:!(0,k.equals)(this._configurationModel.getValue(t),i))&&b.push([t,i])}else this._configurationModel.getValue(t)!==void 0&&b.push([t,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const t=this._configurationModel;this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);for(const s of t.keys)this._configurationModel.setValue(s,t.getValue(s));for(const[s,i]of b)i===void 0?this._configurationModel.removeValue(s):this._configurationModel.setValue(s,i);p&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=d,e.PolicyConfiguration=d=Pe([ne(1,h.IPolicyService),ne(2,a.ILogService)],d)}),define(oe[243],ae([0,1,22,8,17,4,43,108,2,32,36,3,19,18,126,56,242,15,40]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends y.Disposable{constructor(s,i,c,r){super(),this.settingsResource=s,this.logService=r,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration(r)),this.policyConfiguration=c instanceof m.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,c,r)),this.userConfiguration=this._register(new d.UserSettings(this.settingsResource,{},g.extUriBiasedIgnorePathCase,i,r)),this.configuration=new d.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),new a.ResourceMap,d.ConfigurationModel.createEmptyModel(r),new a.ResourceMap,r),this.configurationEditing=new D(s,i,this),this.reloadConfigurationScheduler=this._register(new o.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:l,properties:u})=>this.onDidDefaultConfigurationChange(l,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(l=>this.onDidPolicyConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[s,i,c]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new d.Configuration(s,i,d.ConfigurationModel.createEmptyModel(this.logService),c,d.ConfigurationModel.createEmptyModel(this.logService),d.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,d.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(s,i){const c=typeof s=="string"?s:void 0,r=(0,w.isConfigurationOverrides)(s)?s:(0,w.isConfigurationOverrides)(i)?i:{};return this.configuration.getValue(c,r,void 0)}async updateValue(s,i,c,r,l){const u=(0,w.isConfigurationUpdateOverrides)(c)?c:(0,w.isConfigurationOverrides)(c)?{resource:c.resource,overrideIdentifiers:c.overrideIdentifier?[c.overrideIdentifier]:void 0}:void 0,P=u?r:c;if(P!==void 0&&P!==w.ConfigurationTarget.USER_LOCAL&&P!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${s} to target ${P}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.distinct)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const S=this.inspect(s,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(S.policyValue!==void 0)throw new Error(`Unable to write ${s} because it is configured in system policy.`);if((0,h.equals)(i,S.defaultValue)&&(i=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const T=u.overrideIdentifiers.sort(),L=this.configuration.localUserConfiguration.overrides.find(A=>(0,n.equals)([...A.identifiers].sort(),T));L&&(u.overrideIdentifiers=L.identifiers)}const M=u?.overrideIdentifiers?.length?[(0,v.keyFromOverrideIdentifiers)(u.overrideIdentifiers),s]:[s];await this.configurationEditing.write(M,i),await this.reloadConfiguration()}inspect(s,i={}){return this.configuration.inspect(s,i,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const s=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(s)}onDidChangeUserConfiguration(s){const i=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(s);this.trigger(c,i,w.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(s,i){const c=this.configuration.toData(),r=this.configuration.compareAndUpdateDefaultConfiguration(s,i);this.trigger(r,c,w.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(s){const i=this.configuration.toData(),c=this.configuration.compareAndUpdatePolicyConfiguration(s);this.trigger(c,i,w.ConfigurationTarget.DEFAULT)}trigger(s,i,c){const r=new d.ConfigurationChangeEvent(s,{data:i},this.configuration,void 0,this.logService);r.source=c,this._onDidChangeConfiguration.fire(r)}}e.ConfigurationService=b;class D{constructor(s,i,c){this.settingsResource=s,this.fileService=i,this.configurationService=c,this.queue=new o.Queue}write(s,i){return this.queue.queue(()=>this.doWriteConfiguration(s,i))}async doWriteConfiguration(s,i){let c;try{c=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(u){if(u.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND)c="{}";else throw u}const r=[];if((0,C.parse)(c,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const l=this.getEdits(c,s,i);c=(0,R.applyEdits)(c,l),await this.fileService.writeFile(this.settingsResource,I.VSBuffer.fromString(c))}getEdits(s,i,c){const{tabSize:r,insertSpaces:l,eol:u}=this.formattingOptions;if(!i.length){const P=JSON.stringify(c,null,l?" ".repeat(r):"	");return[{content:P,length:P.length,offset:0}]}return(0,R.setProperty)(s,i,c,{tabSize:r,insertSpaces:l,eol:u})}get formattingOptions(){if(!this._formattingOptions){let s=f.OS===f.OperatingSystem.Linux||f.OS===f.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(s=i),this._formattingOptions={eol:s,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(oe[244],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class n{async routeCall(I,k,C){if(k!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${k}`);const R=C[0];if(R?.authority){const y=I.connections.find(a=>a.ctx===R.authority);if(y)return y}throw new Error("Caller not found")}routeEvent(I,k){throw new Error(`Event not found: ${k}`)}}e.NodeRemoteResourceRouter=n}),define(oe[245],ae([0,1,16,6]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=a,e.IRemoteAuthorityResolverService=(0,o.createDecorator)("remoteAuthorityResolverService");var I;(function(h){h[h.WebSocket=0]="WebSocket",h[h.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class k{constructor(f){this.id=f,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=k;class C{constructor(f,g){this.host=f,this.port=g,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=C;var R;(function(h){h.Unknown="Unknown",h.NotAvailable="NotAvailable",h.TemporarilyNotAvailable="TemporarilyNotAvailable",h.NoResolverFound="NoResolverFound",h.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class y extends n.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof y&&f._code===R.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof y&&f._code===R.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof y&&f._code===R.NoResolverFound}static isInvalidAuthority(f){return f instanceof y&&f._code===R.InvalidAuthority}static isHandled(f){return f instanceof y&&f.isHandled}constructor(f,g=R.Unknown,w){super(f),this._message=f,this._code=g,this._detail=w,this.isHandled=g===R.NotAvailable&&w===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function a(h){const f=h.indexOf("+");return f===-1?h:h.substring(0,f)}}),define(oe[246],ae([0,1,8,17,23,16,4,2,12,71,67,33,118,245]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=S,e.connectRemoteAgentExtensionHost=M,e.connectRemoteAgentTunnel=L,a=ke(a);const d=30*1e3;var v;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function E(re){switch(re){case v.Management:return"Management";case v.ExtensionHost:return"ExtensionHost";case v.Tunnel:return"Tunnel"}}function p(re){const Z=new I.CancellationTokenSource;return setTimeout(()=>Z.cancel(),re),Z.token}function m(re,Z){if(re.isCancellationRequested||Z.isCancellationRequested)return I.CancellationToken.Cancelled;const W=new I.CancellationTokenSource;return re.onCancellationRequested(()=>W.cancel()),Z.onCancellationRequested(()=>W.cancel()),W.token}class b{get didTimeout(){return this._state==="timedout"}constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,n.promiseWithResolvers)(),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function D(re,Z){const W=new b(Z);return W.registerDisposable(re.onControlMessage(F=>{const U=JSON.parse(F.toString()),H=O(U);H?W.reject(H):W.resolve(U)})),W.promise}function t(re,Z,W,F,U,H,Y,Q){const $=new b(Q),ie=h.StopWatch.create(!1);return re.info(`Creating a socket (${Y})...`),a.mark(`code/willCreateSocket/${H}`),Z.connect(W,F,U,Y).then(fe=>{$.didTimeout?(a.mark(`code/didCreateSocketError/${H}`),re.info(`Creating a socket (${Y}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(a.mark(`code/didCreateSocketOK/${H}`),re.info(`Creating a socket (${Y}) was successful after ${ie.elapsed()} ms.`),$.resolve(fe))},fe=>{a.mark(`code/didCreateSocketError/${H}`),re.info(`Creating a socket (${Y}) returned an error after ${ie.elapsed()} ms.`),re.error(fe),$.reject(fe)}),$.promise}function s(re,Z){const W=new b(Z);return re.then(F=>{W.didTimeout||W.resolve(F)},F=>{W.didTimeout||W.reject(F)}),W.promise}async function i(re,Z,W,F){const U=G(re,Z);re.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let H;try{H=await t(re.logService,re.remoteSocketFactoryService,re.connectTo,y.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,E(Z),`renderer-${E(Z)}-${re.reconnectionToken}`,F)}catch(fe){throw re.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),re.logService.error(fe),fe}re.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Y,Q;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(H,null),Y=re.reconnectionProtocol,Q=!1):(Y=new g.PersistentProtocol({socket:H}),Q=!0),re.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const $=await s(re.signService.createNewMessage((0,f.generateUuid)()),F),ie={type:"auth",auth:re.connectionToken||"00000000000000000000",data:$.data};Y.sendControl(o.VSBuffer.fromString(JSON.stringify(ie)));try{const fe=await D(Y,m(F,p(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(re.logService.trace(`${U} 4/6. received SignRequest control message.`),!await s(re.signService.validate($,fe.signedData),F)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const we=await s(re.signService.sign(fe.data),F),Ce={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:Z};return W&&(Ce.args=W),re.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(o.VSBuffer.fromString(JSON.stringify(Ce))),{protocol:Y,ownsProtocol:Q}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(re.logService.error(`${U} the handshake timed out. Error:`),re.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${U} received error control message when negotiating connection. Error:`),re.logService.error(fe)),Q&&q(Y),fe}}async function c(re,Z,W,F){const U=Date.now(),H=G(re,Z),{protocol:Y,ownsProtocol:Q}=await i(re,Z,W,F),$=new b(F);return $.registerDisposable(Y.onControlMessage(ie=>{const fe=JSON.parse(ie.toString()),me=O(fe);me?(re.logService.error(`${H} received error control message when negotiating connection. Error:`),re.logService.error(me),Q&&q(Y),$.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${de(U)}!`),$.resolve({protocol:Y,firstMessage:fe}))})),$.promise}async function r(re,Z){const{protocol:W}=await c(re,v.Management,void 0,Z);return{protocol:W}}async function l(re,Z,W){const{protocol:F,firstMessage:U}=await c(re,v.ExtensionHost,Z,W),H=U&&U.debugPort;return{protocol:F,debugPort:H}}async function u(re,Z,W){const F=Date.now(),U=G(re,v.Tunnel),{protocol:H}=await i(re,v.Tunnel,Z,W);return re.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${de(F)}!`),H}async function P(re,Z,W){const{connectTo:F,connectionToken:U}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:F,connectionToken:U,reconnectionToken:Z,reconnectionProtocol:W,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function S(re,Z,W){return T(re,async F=>{const{protocol:U}=await r(F,I.CancellationToken.None);return new K(re,Z,W,F.reconnectionToken,U)})}async function M(re,Z){return T(re,async W=>{const{protocol:F,debugPort:U}=await l(W,Z,I.CancellationToken.None);return new ee(re,Z,W.reconnectionToken,F,U)})}async function T(re,Z){for(let F=1;;F++)try{const U=(0,f.generateUuid)(),H=await P(re,U,null);return await Z(H)}catch(U){if(F<5)re.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(U);else throw re.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(U),le.triggerPermanentFailure(0,0,w.RemoteAuthorityResolverError.isHandled(U)),U}}async function L(re,Z,W){const F=await P(re,(0,f.generateUuid)(),null);return await u(F,{host:Z,port:W},I.CancellationToken.None)}function A(re){return(0,n.createCancelablePromise)(Z=>new Promise((W,F)=>{const U=setTimeout(W,re*1e3);Z.onCancellationRequested(()=>{clearTimeout(U),W()})}))}var _;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(_||(e.PersistentConnectionEventType=_={}));class B{constructor(Z,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=W,this.type=_.ConnectionLost}}e.ConnectionLostEvent=B;class N{constructor(Z,W,F,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=W,this.durationSeconds=F,this.cancellableTimer=U,this.type=_.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class z{constructor(Z,W,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=_.ReconnectionRunning}}e.ReconnectionRunningEvent=z;class se{constructor(Z,W,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=_.ConnectionGain}}e.ConnectionGainEvent=se;class J{constructor(Z,W,F,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=W,this.attempt=F,this.handled=U,this.type=_.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=J;class le extends R.Disposable{static triggerPermanentFailure(Z,W,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=W,this._permanentFailureHandled=F,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||le._permanentFailure}constructor(Z,W,F,U,H){super(),this._connectionType=Z,this._options=W,this.reconnectionToken=F,this.protocol=U,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new C.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new se(this.reconnectionToken,0,0)),this._register(U.onSocketClose(Y=>{const Q=ce(this._connectionType,this.reconnectionToken,!0);Y?Y.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${Q} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${Q} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${Q} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(Y=>{const Q=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),le._instances.push(this),this._register((0,R.toDisposable)(()=>{const Y=le._instances.indexOf(this);Y>=0&&le._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(le._permanentFailureMillisSinceLastIncomingData,le._permanentFailureAttempt,le._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const Z=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const U=F<W.length?W[F]:W[W.length-1];try{if(U>0){const Y=A(U);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Y)),this._options.logService.info(`${Z} waiting for ${U} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${Z} resolving connection...`);const H=await P(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${H.connectTo}...`),await this._reconnect(H,p(d)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(w.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,k.isCancellationError)(H)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof w.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,w.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(Z,W,F){this._reconnectionFailureIsFatal?le.triggerPermanentFailure(Z,W,F):this._gotoPermanentFailure(Z,W,F)}_gotoPermanentFailure(Z,W,F){this._onDidStateChange.fire(new J(this.reconnectionToken,Z,W,F)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=le;class K extends le{constructor(Z,W,F,U,H){super(v.Management,Z,U,H,!0),this.client=this._register(new g.Client(H,{remoteAuthority:W,clientId:F},Z.ipcLogger))}async _reconnect(Z,W){await r(Z,W)}}e.ManagementPersistentConnection=K;class ee extends le{constructor(Z,W,F,U,H){super(v.ExtensionHost,Z,F,U,!1),this._startArguments=W,this.debugPort=H}async _reconnect(Z,W){await l(Z,this._startArguments,W)}}e.ExtensionHostPersistentConnection=ee;function q(re){try{re.acceptDisconnect();const Z=re.getSocket();re.dispose(),Z.dispose()}catch(Z){(0,k.onUnexpectedError)(Z)}}function O(re){if(re&&re.type==="error"){const Z=new Error(`Connection error: ${re.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function x(re,Z){for(;re.length<Z;)re+=" ";return re}function j(re,Z){return`[remote-connection][${x(E(re),13)}][${Z.substr(0,5)}\u2026]`}function ce(re,Z,W){return`${j(re,Z)}[${W?"reconnect":"initial"}]`}function G(re,Z){return`${ce(Z,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function de(re){return`${Date.now()-re} ms`}}),define(oe[75],ae([0,1,12]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=o,e.getRemoteName=I,e.parseAuthorityWithPort=k,e.parseAuthorityWithOptionalPort=C;function o(y){return y.scheme===n.Schemas.vscodeRemote?y.authority:void 0}function I(y){if(!y)return;const a=y.indexOf("+");return a<0?y:y.substr(0,a)}function k(y){const{host:a,port:h}=R(y);if(typeof h>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function C(y,a){let{host:h,port:f}=R(y);return typeof f>"u"&&(f=a),{host:h,port:f}}function R(y){const a=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=y.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const f=y.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:y,port:void 0}}}),define(oe[86],ae([0,1,26,6,75]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=k,e.isApplicationScopedExtension=f,e.isLanguagePackExtension=g,e.isAuthenticationProviderExtension=w,e.isResolverExtension=d,e.parseApiProposals=v,e.parseEnabledApiProposalNames=E,n=ke(n),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(C||(e.ExtensionType=C={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.LINUX_RISCV64="linux-riscv64",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class y{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,b){if(typeof m>"u"||m===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof m=="string"||typeof b=="string"){const D=typeof m=="string"?m:m.value,t=typeof b=="string"?b:b.value;return n.equalsIgnoreCase(D,t)}return m._lower===b._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=y;class a{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const b of m)this.add(b)}add(m){this._set.add(y.toKey(m))}delete(m){return this._set.delete(y.toKey(m))}has(m){return this._set.has(y.toKey(m))}}e.ExtensionIdentifierSet=a;class h{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(y.toKey(m))}get(m){return this._map.get(y.toKey(m))}has(m){return this._map.has(y.toKey(m))}set(m,b){this._map.set(y.toKey(m),b)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=h;function f(p){return g(p)}function g(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function w(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function d(p,m){if(m){const b=`onResolveRemoteAuthority:${(0,I.getRemoteName)(m)}`;return!!p.activationEvents?.includes(b)}return!1}function v(p){return p.map(m=>{const[b,D]=m.split("@");return{proposalName:b,version:D?parseInt(D):void 0}})}function E(p){return p.map(m=>m.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,o.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[127],ae([0,1,3,175,86,6]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=y,e.getTargetPlatform=a,e.isNotWebExtensionInWebTargetPlatform=h,e.isTargetPlatformCompatible=f,e.isIExtensionIdentifier=g,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var C;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function R(t){switch(t){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case I.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function y(t){switch(t){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.LINUX_PPC64LE:return I.TargetPlatform.LINUX_PPC64LE;case I.TargetPlatform.LINUX_RISCV64:return I.TargetPlatform.LINUX_RISCV64;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function a(t,s){switch(t){case n.Platform.Windows:return s==="x64"?I.TargetPlatform.WIN32_X64:s==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case n.Platform.Linux:return s==="x64"?I.TargetPlatform.LINUX_X64:s==="arm64"?I.TargetPlatform.LINUX_ARM64:s==="arm"?I.TargetPlatform.LINUX_ARMHF:s==="ppc64le"?I.TargetPlatform.LINUX_PPC64LE:s==="riscv64"?I.TargetPlatform.LINUX_RISCV64:I.TargetPlatform.UNKNOWN;case"alpine":return s==="x64"?I.TargetPlatform.ALPINE_X64:s==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case n.Platform.Mac:return s==="x64"?I.TargetPlatform.DARWIN_X64:s==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case n.Platform.Web:return I.TargetPlatform.WEB}}function h(t,s){return s===I.TargetPlatform.WEB&&!t.includes(I.TargetPlatform.WEB)}function f(t,s,i){return h(s,i)?!1:t===I.TargetPlatform.UNDEFINED||t===I.TargetPlatform.UNIVERSAL?!0:t===I.TargetPlatform.UNKNOWN?!1:t===i}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var v;(function(t){t.Install="install",t.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var E;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(p||(e.ExtensionGalleryErrorCode=p={}));class m extends Error{constructor(s,i){super(s),this.code=i,this.name=i}}e.ExtensionGalleryError=m;var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));class D extends Error{constructor(s,i){super(s),this.code=i,this.name=i}}e.ExtensionManagementError=D,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,o.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,o.localize2)(1,"Preferences")});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[247],ae([0,1,19,81,178,248,86,210]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=h,e.parseVersion=f,e.normalizeVersion=g,e.isValidVersion=w,e.validateExtensionManifest=d,e.isValidExtensionVersion=v,e.isEngineValid=E,e.areApiProposalsCompatible=p,o=et(o),I=ke(I),k=ke(k);const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function h(D){return D=D.trim(),D==="*"||y.test(D)}function f(D){if(!h(D))return null;if(D=D.trim(),D==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=D.match(y);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function g(D){if(!D)return null;const t=D.majorBase,s=D.majorMustEqual,i=D.minorBase;let c=D.minorMustEqual;const r=D.patchBase;let l=D.patchMustEqual;D.hasCaret&&(t===0||(c=!1),l=!1);let u=0;if(D.preRelease){const P=a.exec(D.preRelease);if(P){const[,S,M,T]=P;u=Date.UTC(Number(S),Number(M)-1,Number(T))}}return{majorBase:t,majorMustEqual:s,minorBase:i,minorMustEqual:c,patchBase:r,patchMustEqual:l,isMinimum:D.hasGreaterEquals,notBefore:u}}function w(D,t,s){let i;typeof D=="string"?i=g(f(D)):i=D;let c;t instanceof Date?c=t.getTime():typeof t=="string"&&(c=new Date(t).getTime());let r;if(typeof s=="string"?r=g(f(s)):r=s,!i||!r)return!1;const l=i.majorBase,u=i.minorBase,P=i.patchBase;let S=r.majorBase,M=r.minorBase,T=r.patchBase;const L=r.notBefore;let A=r.majorMustEqual,_=r.minorMustEqual,B=r.patchMustEqual;return r.isMinimum?l>S?!0:l<S?!1:u>M?!0:u<M||c&&c<L?!1:P>=T:(l===1&&S===0&&(!A||!_||!B)&&(S=1,M=0,T=0,A=!0,_=!1,B=!1),l<S?!1:l>S?!A:u<M?!1:u>M?!_:P<T?!1:P>T?!B:!(c&&c<L))}function d(D,t,s,i,c,r){const l=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return l.push([o.default.Error,I.localize(0,null)]),l;if(typeof i.name!="string")return l.push([o.default.Error,I.localize(1,null,"name")]),l;if(typeof i.version!="string")return l.push([o.default.Error,I.localize(2,null,"version")]),l;if(!i.engines)return l.push([o.default.Error,I.localize(3,null,"engines")]),l;if(typeof i.engines.vscode!="string")return l.push([o.default.Error,I.localize(4,null,"engines.vscode")]),l;if(typeof i.extensionDependencies<"u"&&!b(i.extensionDependencies))return l.push([o.default.Error,I.localize(5,null,"extensionDependencies")]),l;if(typeof i.activationEvents<"u"){if(!b(i.activationEvents))return l.push([o.default.Error,I.localize(6,null,"activationEvents")]),l;if(typeof i.main>"u"&&typeof i.browser>"u")return l.push([o.default.Error,I.localize(7,null,"activationEvents","main","browser")]),l}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&l.push([o.default.Warning,I.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return l.push([o.default.Error,I.localize(9,null,"main")]),l;{const S=(0,n.joinPath)(s,i.main);(0,n.isEqualOrParent)(S,s)||l.push([o.default.Warning,I.localize(10,null,S.path,s.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return l.push([o.default.Error,I.localize(11,null,"browser")]),l;{const S=(0,n.joinPath)(s,i.browser);(0,n.isEqualOrParent)(S,s)||l.push([o.default.Warning,I.localize(12,null,S.path,s.path)])}}if(!k.valid(i.version))return l.push([o.default.Error,I.localize(13,null)]),l;const u=[];if(!v(D,t,i,c,u))for(const S of u)l.push([o.default.Error,S]);if(r&&i.enabledApiProposals?.length){const S=[];if(!p([...i.enabledApiProposals],S))for(const M of S)l.push([o.default.Error,M])}return l}function v(D,t,s,i,c){return i||typeof s.main>"u"&&typeof s.browser>"u"?!0:m(D,t,s.engines.vscode,c)}function E(D,t,s){return D==="*"||m(t,s,D)}function p(D,t){if(D.length===0)return!0;const s=Array.isArray(t)?t:void 0,i=(s?void 0:t)??R.allApiProposals,c=[],r=(0,C.parseApiProposals)(D);for(const{proposalName:l,version:u}of r){const P=i[l];P&&u&&P.version!==u&&c.push(I.localize(14,null,l))}return s?.push(...c),c.length===0}function m(D,t,s,i=[]){const c=g(f(s));if(!c)return i.push(I.localize(15,null,s)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return i.push(I.localize(16,null,s)),!1}else if(!c.majorMustEqual)return i.push(I.localize(17,null,s)),!1;return w(D,t,c)?!0:(i.push(I.localize(18,null,D,s)),!1)}function b(D){if(!Array.isArray(D))return!1;for(let t=0,s=D.length;t<s;t++)if(typeof D[t]!="string")return!1;return!0}}),define(oe[249],ae([0,1,2,6]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,o.createDecorator)("remoteSocketFactoryService");class I{constructor(){this.factories={}}register(C,R){return this.factories[C]??=[],this.factories[C].push(R),(0,n.toDisposable)(()=>{const y=this.factories[C]?.indexOf(R);typeof y=="number"&&y>=0&&this.factories[C]?.splice(y,1)})}getSocketFactory(C){return(this.factories[C.type]||[]).find(y=>y.supports(C))}connect(C,R,y,a){const h=this.getSocketFactory(C);if(!h)throw new Error(`No socket factory found for ${C}`);return h.connect(C,R,y,a)}}e.RemoteSocketFactoryService=I}),define(oe[250],ae([0,1,27,49,21,122]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=R,n=ke(n),o=ke(o),k=ke(k);let C;async function R(w=!1){return(C===void 0||w)&&(C=y()),C}async function y(){const w=a();if(w===void 0)return!1;if(w>=22e3){const d=f();if(d)return new Promise(v=>{o.execFile(d,["--status"],E=>v(!E))})}else{const d=g();if(d)try{if((await I.Promises.stat(d)).isFile())return!0}catch{}}return!1}function a(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(w)return parseInt(w[3])}function h(w){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return k.join(d,v?"Sysnative":"System32",w)}}function f(){return h("wsl.exe")}function g(){return h("lxss\\LxssManager.dll")}}),define(oe[57],ae([0,1,17,16,2,190,56,6,5,45]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=g,e.hasNoContent=w,e.asText=d,e.asTextOrError=v,e.asJson=E,e.updateProxyConfigurationsScope=p,e.IRequestService=(0,R.createDecorator)("requestService");class h{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const s in this.original)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?t[s]="*****":t[s]=this.original[s];this.headers=t}return this.headers}}class f extends I.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,k.localize)(0,null),when:y.CONTEXT_LOG_LEVEL.isEqualTo((0,y.LogLevelToString)(y.LogLevel.Trace)).serialize()})}async logAndRequest(t,s,i){const c=`${t} #${++this.counter}: ${s.url}`;this.logger.trace(`${c} - begin`,s.type,new h(s.headers??{}));try{const r=await i();return this.logger.trace(`${c} - end`,s.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.logger.error(`${c} - error`,s.type,(0,o.getErrorMessage)(r)),r}}}e.AbstractRequestService=f;function g(D){return D.res.statusCode&&D.res.statusCode>=200&&D.res.statusCode<300||D.res.statusCode===1223}function w(D){return D.res.statusCode===204}async function d(D){return w(D)?null:(await(0,n.streamToBuffer)(D.stream)).toString()}async function v(D){if(!g(D))throw new Error("Server returned "+D.res.statusCode);return d(D)}async function E(D){if(!g(D))throw new Error("Server returned "+D.res.statusCode);if(w(D))return null;const s=(await(0,n.streamToBuffer)(D.stream)).toString();try{return JSON.parse(s)}catch(i){throw i.message+=`:
`+s,i}}function p(D){b(D)}let m;function b(D){const t=a.Registry.as(C.Extensions.Configuration),s=m;m={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:D,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null),(0,k.localize)(10,null)],default:"override",description:(0,k.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[m],remove:s?[s]:[]})}b(C.ConfigurationScope.APPLICATION)}),define(oe[251],ae([0,1,17,23]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class I{constructor(R){this.service=R}listen(R,y){throw new Error("Invalid listen")}call(R,y,a,h=o.CancellationToken.None){switch(y){case"request":return this.service.request(a[0],h).then(async({res:f,stream:g})=>{const w=await(0,n.streamToBuffer)(g);return[{statusCode:f.statusCode,headers:f.headers},w]});case"resolveProxy":return this.service.resolveProxy(a[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=I;class k{constructor(R){this.channel=R}async request(R,y){const[a,h]=await this.channel.call("request",[R],y);return{res:a,stream:(0,n.bufferToStream)(h)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=k}),define(oe[252],ae([0,1,253,13]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=k;function I(C,R){return C.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:C.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(C,R,y={}){const a=(0,n.parse)(C),h=y.proxyUrl||I(a,R);if(!h)return null;const f=(0,n.parse)(h);if(!/^https?:$/.test(f.protocol||""))return null;const g={host:f.hostname||"",port:(f.port?+f.port:0)||(f.protocol==="https"?443:80),auth:f.auth,rejectUnauthorized:(0,o.isBoolean)(y.strictSSL)?y.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,d)=>{V(["http-proxy-agent"],w,d)}).then(ke)).HttpProxyAgent(h,g):new(await new Promise((w,d)=>{V(["https-proxy-agent"],w,d)}).then(ke)).HttpsProxyAgent(h,g)}}),define(oe[254],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[101],ae([0,1,49,10,191,23,55,16,3,33,117,69,8,143]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=v;let d;async function v(p,m,b,D){return b["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.isLaunchedFromCli)(D)&&!b["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.isLaunchedFromCli)(D)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=g.Promises.withAsyncBody(async(t,s)=>{const i=new k.CancellationTokenSource;let c=1e4;const r=p.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(c=(0,w.clamp)(r,1,120)*1e3);const l=setTimeout(()=>{i.dispose(!0),s(new Error((0,I.localize)(0,null)))},c);try{t(await E(m,i.token))}catch(u){!(0,R.isCancellationError)(u)&&!i.token.isCancellationRequested?s(new Error((0,I.localize)(1,null,(0,C.toErrorMessage)(u)))):t({})}finally{clearTimeout(l),i.dispose()}})),d)}async function E(p,m){const b=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",b);const D=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",D);const t=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};p.trace("getUnixShellEnvironment#env",i);const c=await(0,h.getSystemShell)(y.OS,i);return p.trace("getUnixShellEnvironment#shell",c),new Promise((r,l)=>{if(m.isCancellationRequested)return l(new R.CancellationError);const u=(0,o.basename)(c);let P,S;const M="";/^pwsh(-preview)?$/.test(u)?(P=`& '${process.execPath}' ${M} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,S=["-Login","-Command"]):u==="nu"?(P=`^'${process.execPath}' ${M} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,S=["-i","-l","-c"]):u==="xonsh"?(P=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,S=["-i","-l","-c"]):(P=`'${process.execPath}' ${M} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u==="tcsh"||u==="csh"?S=["-ic"]:S=["-i","-l","-c"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),P);const T=(0,n.spawn)(c,[...S,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});m.onCancellationRequested(()=>(T.kill(),l(new R.CancellationError))),T.on("error",_=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(_)),l(_)});const L=[];T.stdout.on("data",_=>L.push(_));const A=[];T.stderr.on("data",_=>A.push(_)),T.on("close",(_,B)=>{const N=Buffer.concat(L).toString("utf8");p.trace("getUnixShellEnvironment#raw",N);const z=Buffer.concat(A).toString("utf8");if(z.trim()&&p.trace("getUnixShellEnvironment#stderr",z),_||B)return l(new Error((0,I.localize)(2,null,_,B)));const se=s.exec(N),J=se?se[1]:"{}";try{const le=JSON.parse(J);b?le.ELECTRON_RUN_AS_NODE=b:delete le.ELECTRON_RUN_AS_NODE,D?le.ELECTRON_NO_ATTACH_CONSOLE=D:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",le),r(le)}catch(le){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(le)),l(le)}})})}}),define(oe[255],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class n{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(I){try{const k=await this.getValidator();if(k){const C=String(n._nextId++);return this.validators.set(C,k),{id:C,data:k.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,k){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(k)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(I){try{return await this.signValue(I)}catch{}return I}}e.AbstractSignService=n}),define(oe[102],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,n.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[256],ae([0,1,255]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o extends n.AbstractSignService{getValidator(){return this.vsda().then(k=>new k.validator)}signValue(k){return this.vsda().then(C=>new C.signer().sign(k))}vsda(){return new Promise((k,C)=>V(["vsda"],k,C))}}e.SignService=o}),define(oe[34],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,n.createDecorator)("stateReadService"),e.IStateService=(0,n.createDecorator)("stateService")}),define(oe[128],ae([0,1,8,17,2,13,38,15,5]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends I.Disposable{constructor(d,v,E,p){super(),this.storagePath=d,this.saveStrategy=v,this.logService=E,this.fileService=p,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new n.ThrottledDelayer(this.saveStrategy===a.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(d){d.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(d)}}getItem(d,v){const E=this.storage[d];return(0,k.isUndefinedOrNull)(E)?v:E}setItem(d,v){this.setItems([{key:d,data:v}])}setItems(d){let v=!1;for(const{key:E,data:p}of d)this.storage[E]!==p&&((0,k.isUndefinedOrNull)(p)?(0,k.isUndefined)(this.storage[E])||(this.storage[E]=void 0,v=!0):(this.storage[E]=p,v=!0));v&&this.save()}removeItem(d){(0,k.isUndefined)(this.storage[d])||(this.storage[d]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const d=JSON.stringify(this.storage,null,4);if(d!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,o.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=d}catch(v){this.logService.error(v)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let f=class extends I.Disposable{constructor(d,v,E,p){super(),this.fileStorage=this._register(new h(v.stateResource,d,E,p))}async init(){await this.fileStorage.init()}getItem(d,v){return this.fileStorage.getItem(d,v)}};e.StateReadonlyService=f,e.StateReadonlyService=f=Pe([ne(1,C.IEnvironmentService),ne(2,y.ILogService),ne(3,R.IFileService)],f);class g extends f{setItem(d,v){this.fileStorage.setItem(d,v)}setItems(d){this.fileStorage.setItems(d)}removeItem(d){this.fileStorage.removeItem(d)}close(){return this.fileStorage.close()}}e.StateService=g}),define(oe[129],ae([0,1,3,37,33]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=C,e.verifyMicrosoftInternalDomain=R;function k(y){if(n.platform===n.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function C(y,a,h,f,g,w,d,v,E,p){const m=Object.create(null);m["common.machineId"]=w,m["common.sqmId"]=d,m["common.devDeviceId"]=v,m.sessionID=(0,I.generateUuid)()+Date.now(),m.commitHash=f,m.version=g,m["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,n.PlatformToString)(n.platform),m["common.nodePlatform"]=o.platform,m["common.nodeArch"]=h,m["common.product"]=p||"desktop",E&&(m["common.msftInternal"]=E);let b=0;const D=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),n.isLinuxSnap&&(m["common.snap"]="true");const t=k(a);return t&&(m["common.platformDetail"]=t),m}function R(y){const a=o.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return y.some(f=>h===f)}}),define(oe[25],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var o;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(o||(e.TelemetryLevel=o={}));var I;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(oe[257],ae([0,1,27,8,43,12,10,3,67,7,94,21,116,97,15,28,25]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=m,e.getMachineInfo=D,e.collectLaunchConfigs=t,n=ke(n);const p=new Map;async function m(i,c){const r=`${i}::${c.join(":")}`,l=p.get(r);if(l)return l;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],P=new Map,S=new Map,M=2e4;function T(A,_,B,N){const z=_.substring(A.length+1);return o.Promises.withAsyncBody(async se=>{let J;N.readdirCount++;try{J=await f.Promises.readdir(_,{withFileTypes:!0})}catch{se();return}if(N.count>=M){N.count+=J.length,N.maxReached=!0,se();return}let le=J.length;if(le===0){se();return}let K=J;N.count+J.length>M&&(N.maxReached=!0,le=M-N.count,K=J.slice(0,le)),N.count+=J.length;for(const ee of K)if(ee.isDirectory()){if(B.includes(ee.name)||await T(A,(0,C.join)(_,ee.name),B,N),--le===0){se();return}}else{const q=ee.name.lastIndexOf(".");if(q>=0){const O=ee.name.substring(q+1);O&&P.set(O,(P.get(O)??0)+1)}for(const O of u)O.relativePathPattern?.test(z)!==!1&&O.filePattern.test(ee.name)&&S.set(O.tag,(S.get(O.tag)??0)+1);if(--le===0){se();return}}})}const L=o.Promises.withAsyncBody(async A=>{const _={count:0,maxReached:!1,readdirCount:0},B=new y.StopWatch(!0);await T(i,i,c,_);const N=await t(i);A({configFiles:b(S),fileTypes:b(P),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:N,totalScanTime:B.elapsed(),totalReaddirCount:_.readdirCount})});return p.set(r,L),L}function b(i){return Array.from(i.entries(),([c,r])=>({name:c,count:r})).sort((c,r)=>r.count-c.count)}function D(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},c=n.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}async function t(i){try{const c=new Map,r=(0,C.join)(i,".vscode","launch.json"),l=await f.Promises.readFile(r),u=[],P=(0,I.parse)(l.toString(),u);if(u.length)return console.log(`Unable to parse ${r}`),[];if((0,I.getNodeType)(P)==="object"&&P.configurations)for(const S of P.configurations){const M=S.type;M&&(c.has(M)?c.set(M,c.get(M)+1):c.set(M,1))}return b(c)}catch{return[]}}let s=class{constructor(c,r){this.telemetryService=c,this.productService=r}formatMachineInfo(c){const r=[];return r.push(`OS Version:       ${c.os}`),r.push(`CPUs:             ${c.cpus}`),r.push(`Memory (System):  ${c.memory}`),r.push(`VM:               ${c.vmHint}`),r.join(`
`)}formatEnvironment(c){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const l=n.cpus();return l&&l.length>0&&r.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||r.push(`Load (avg):       ${n.loadavg().map(u=>Math.round(u)).join(", ")}`),r.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${c.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(c,r){return Promise.all([(0,g.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async l=>{let[u,P]=l,S=this.formatProcessList(c,u);return r.forEach(M=>{if((0,w.isRemoteDiagnosticError)(M))S+=`
${M.errorMessage}`,P+=`
${M.errorMessage}`;else if(S+=`

Remote: ${M.hostName}`,M.processes&&(S+=`
${this.formatProcessList(c,M.processes)}`),M.workspaceMetadata){P+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const L=M.workspaceMetadata[T];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),P+=`|    Folder (${T}): ${A}`,P+=this.formatWorkspaceStats(L)}}}),{processInfo:S,workspaceInfo:P}})}async getSystemInfo(c,r){const{memory:l,vmHint:u,os:P,cpus:S}=D(),M={os:P,memory:l,cpus:S,vmHint:u,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:r};return R.isWindows||(M.load=`${n.loadavg().map(T=>Math.round(T)).join(", ")}`),R.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(c,r){const l=[];return(0,g.listProcesses)(c.mainPID).then(async u=>(l.push(""),l.push(this.formatEnvironment(c)),l.push(""),l.push(this.formatProcessList(c,u)),c.windows.some(P=>P.folderURIs&&P.folderURIs.length>0&&!P.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(c))),r.forEach(P=>{if((0,w.isRemoteDiagnosticError)(P))l.push(`
${P.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${P.hostName}`),l.push(this.formatMachineInfo(P.machineInfo)),P.processes&&l.push(this.formatProcessList(c,P.processes)),P.workspaceMetadata)for(const S of Object.keys(P.workspaceMetadata)){const M=P.workspaceMetadata[S];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),l.push(`Folder (${S}): ${T}`),l.push(this.formatWorkspaceStats(M))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(c){const r=[];let u=0;const P=(L,A)=>{const _=` ${L}(${A})`;u+_.length>60?(r.push(S),S="|                 ",u=S.length):u+=_.length,S+=_};let S="|      File types:";const M=10,T=c.fileTypes.length>M?M:c.fileTypes.length;for(let L=0;L<T;L++){const A=c.fileTypes[L];P(A.name,A.count)}if(r.push(S),c.configFiles.length>=0&&(S="|      Conf files:",u=0,c.configFiles.forEach(L=>{P(L.name,L.count)}),r.push(S)),c.launchConfigFiles.length>0){let L="|      Launch Configs:";c.launchConfigFiles.forEach(A=>{const _=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;L+=_}),r.push(L)}return r.join(`
`)}expandGPUFeatures(c){const r=Math.max(...Object.keys(c).map(l=>l.length));return Object.keys(c).map(l=>`${l}:  ${" ".repeat(r-l.length)}  ${c[l]}`).join(`
                  `)}formatWorkspaceMetadata(c){const r=[],l=[];return c.windows.forEach(u=>{u.folderURIs.length===0||u.remoteAuthority||(r.push(`|  Window (${u.title})`),u.folderURIs.forEach(P=>{const S=a.URI.revive(P);if(S.scheme===k.Schemas.file){const M=S.fsPath;l.push(m(M,["node_modules",".git"]).then(T=>{let L=`${T.fileCount} files`;T.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${(0,C.basename)(M)}): ${L}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else r.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(u=>r.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(c,r){const l=new Map;c.windows.forEach(P=>l.set(P.pid,`window [${P.id}] (${P.title})`)),c.pidToNames.forEach(({pid:P,name:S})=>l.set(P,S));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(c.mainPID,l,u,r,0),u.join(`
`)}formatProcessItem(c,r,l,u,P){const S=P===0;let M;S?M=u.pid===c?`${this.productService.applicationName} main`:"remote agent":r.has(u.pid)?M=r.get(u.pid):M=`${"  ".repeat(P)} ${u.name}`;const T=process.platform==="win32"?u.mem:n.totalmem()*(u.mem/100);l.push(`${u.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(u.children)&&u.children.forEach(L=>this.formatProcessItem(c,r,l,L,P+1))}async getWorkspaceFileExtensions(c){const r=new Set;for(const{uri:l}of c.folders){const u=a.URI.revive(l);if(u.scheme!==k.Schemas.file)continue;const P=u.fsPath;try{(await m(P,["node_modules",".git"])).fileTypes.forEach(M=>r.add(M.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(c){for(const{uri:r}of c.folders){const l=a.URI.revive(r);if(l.scheme!==k.Schemas.file)continue;const u=l.fsPath;try{const P=await m(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),P.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:S.name,count:S.count})}),P.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:S.name,count:S.count})}),P.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:S.name,count:S.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:P.totalScanTime,reachedLimit:P.maxFilesReached,fileCount:P.fileCount,readdirCount:P.totalReaddirCount})}catch{}}}};e.DiagnosticsService=s,e.DiagnosticsService=s=Pe([ne(0,E.ITelemetryService),ne(1,v.IProductService)],s)}),define(oe[258],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class n{constructor(k){this.appenders=k}listen(k,C){throw new Error(`Event not found: ${C}`)}call(k,C,{eventName:R,data:y}){return this.appenders.forEach(a=>a.log(R,y)),Promise.resolve(null)}}e.TelemetryAppenderChannel=n;class o{constructor(k){this.channel=k}log(k,C){return this.channel.call("log",{eventName:k,data:C}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=o}),define(oe[58],ae([0,1,36,13,75,129,25]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=h,e.isLoggingOnly=f,e.getTelemetryLevel=g,e.validateTelemetryData=w,e.cleanRemoteAuthority=v,e.isInternalTelemetry=p,e.getPiiPathsFromEnvironment=m,e.cleanData=t;class R{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class y{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class a{async publicLog(i,c,r){}async publicLogError(i,c,r){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry)}function f(s,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}function g(s){const i=s.getValue(C.TELEMETRY_SETTING_ID),c=s.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return C.TelemetryLevel.NONE;switch(i??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function w(s){const i={},c={},r={};E(s,r);for(let l in r){l=l.length>150?l.substr(l.length-149):l;const u=r[l];typeof u=="number"?c[l]=u:typeof u=="boolean"?c[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),i[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(i[l]=u)}return{properties:i,measurements:c}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(s){if(!s)return"none";const i=(0,I.getRemoteName)(s);return d.has(i)?i:"other"}function E(s,i,c=0,r){if(s)for(const l of Object.getOwnPropertyNames(s)){const u=s[l],P=r?r+l:l;Array.isArray(u)?i[P]=(0,n.safeStringify)(u):u instanceof Date?i[P]=u.toISOString():(0,o.isObject)(u)?c<2?E(u,i,c+1,P+"."):i[P]=(0,n.safeStringify)(u):i[P]=u}}function p(s,i){const c=s.msftInternalDomains||[],r=i.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(c)||r}function m(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}function b(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let c=s;const r=[];for(const S of i)for(;;){const M=S.exec(s);if(!M)break;r.push([M.index,S.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(c="";;){const S=u.exec(s);if(!S)break;const M=r.some(([T,L])=>S.index<L&&T<u.lastIndex);!l.test(S[0])&&!M&&(c+=s.substring(P,S.index)+"<REDACTED: user-file-path>",P=u.lastIndex)}return P<s.length&&(c+=s.substr(P)),c}function D(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of i)if(c.regex.test(s))return`<REDACTED: ${c.label}>`;return s}function t(s,i){return(0,n.cloneAndChange)(s,c=>{if(c instanceof R||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let r=c.replaceAll("%20"," ");r=b(r,i);for(const l of i)r=r.replace(l,"");return r=D(r),r}})}}),define(oe[130],ae([0,1,26,127,86,3,7,16,37,58]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=h,e.getIdAndVersion=d,e.getExtensionId=v,e.adoptToGalleryExtensionId=E,e.getGalleryExtensionId=p,e.groupByExtension=m,e.getLocalExtensionTelemetryData=b,e.getGalleryExtensionTelemetryData=D,e.getExtensionDependencies=t,e.computeTargetPlatform=i;function h(c,r){return c.uuid&&r.uuid?c.uuid===r.uuid:c.id===r.id?!0:(0,n.compareIgnoreCase)(c.id,r.id)===0}const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(r){const l=r.manifest?r.manifest.version:r.version,u=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new g(r.identifier,l,u)}static parse(r){const l=f.exec(r);return l&&l[1]&&l[2]?new g({id:l[1]},l[2],l[4]||void 0):null}constructor(r,l,u=I.TargetPlatform.UNDEFINED){this.identifier=r,this.version=l,this.targetPlatform=u,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof g?h(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=g;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(c){const r=w.exec(c);return r&&r[1]?[E(r[1]),r[2]]:[E(c),void 0]}function v(c,r){return`${c}.${r}`}function E(c){return c.toLowerCase()}function p(c,r){return E(v(c??I.UNDEFINED_PUBLISHER,r))}function m(c,r){const l=[],u=P=>{for(const S of l)if(S.some(M=>h(r(M),r(P))))return S;return null};for(const P of c){const S=u(P);S?S.push(P):l.push([P])}return l}function b(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function D(c){return{id:new a.TelemetryTrustedValue(c.identifier.id),name:new a.TelemetryTrustedValue(c.name),version:c.version,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function t(c,r){const l=[],u=r.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const P=u.shift();if(P&&l.every(S=>!h(S.identifier,{id:P}))){const S=c.filter(M=>h(M.identifier,{id:P}));S.length===1&&(l.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function s(c,r){if(!k.isLinux)return!1;let l;try{l=(await c.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await c.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){r.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(P))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(c,r){const l=await s(c,r),u=(0,o.getTargetPlatform)(l?"alpine":k.platform,y.arch);return r.debug("ComputeTargetPlatform:",u),u}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[259],ae([0,1,2,36,3,26,192,18,56,73,28,45,25,58]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,a=et(a);let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(p,m,b){this._configurationService=m,this._productService=b,this._experimentProperties={},this._disposables=new n.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=p.piiPaths||[],this._telemetryLevel=g.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(D),"gi")),D.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(D.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(D=>{(D.affectsConfiguration(g.TELEMETRY_SETTING_ID)||D.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||D.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(p,m){this._experimentProperties[p]=m}_updateTelemetryLevel(){let p=(0,w.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const b=m.usage?g.TelemetryLevel.USAGE:m.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;p=Math.min(p,b)}this._telemetryLevel=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(p,m,b){this._telemetryLevel<m||(b=(0,o.mixin)(b,this._experimentProperties),b=(0,w.cleanData)(b,this._cleanupPatterns),b=(0,o.mixin)(b,this._commonProperties),this._appenders.forEach(D=>D.log(p,b)))}publicLog(p,m){this._log(p,g.TelemetryLevel.USAGE,m)}publicLog2(p,m){this.publicLog(p,m)}publicLogError(p,m){this._sendErrorTelemetry&&this._log(p,g.TelemetryLevel.ERROR,m)}publicLogError2(p,m){this.publicLogError(p,m)}};e.TelemetryService=d,e.TelemetryService=d=Pe([ne(1,R.IConfigurationService),ne(2,h.IProductService)],d);function v(){const E=(0,C.localize)(0,null,a.default.nameLong),p=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=I.isWeb?"":(0,C.localize)(3,null),b=(0,C.localize)(4,null),D=(0,C.localize)(5,null),t=(0,C.localize)(6,null),s=(0,C.localize)(7,null),i=`
|       | ${b} | ${D} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,C.localize)(8,null);return`
${E} ${p} ${m}

&nbsp;

${s}
${i}

&nbsp;

${c}
`}f.Registry.as(y.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:v(),default:g.TelemetryConfiguration.OFF,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),f.Registry.as(y.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[260],ae([0,1,3,94,25]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=k,e.resolveSqmId=C,e.resolvedevDeviceId=R;async function k(y,a){let h=y.getItem(I.machineIdKey);return(typeof h!="string"||n.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,o.getMachineId)(a.error.bind(a))),h}async function C(y,a){let h=y.getItem(I.sqmIdKey);return typeof h!="string"&&(h=await(0,o.getSqmMachineId)(a.error.bind(a))),h}async function R(y,a){let h=y.getItem(I.devDeviceIdKey);return typeof h!="string"&&(h=await(0,o.getdevDeviceId)(a.error.bind(a))),h}}),define(oe[261],ae([0,1,25,260]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=I,e.resolveSqmId=k,e.resolvedevDeviceId=C;async function I(R,y){const a=await(0,o.resolveMachineId)(R,y);return R.setItem(n.machineIdKey,a),a}async function k(R,y){const a=await(0,o.resolveSqmId)(R,y);return R.setItem(n.sqmIdKey,a),a}async function C(R,y){const a=await(0,o.resolvedevDeviceId)(R,y);return R.setItem(n.devDeviceIdKey,a),a}}),define(oe[131],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(o){o[o.Replace=1]="Replace",o[o.Append=2]="Append",o[o.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[262],ae([0,1,3,131]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const I=new Map([[o.EnvironmentVariableMutatorType.Append,"APPEND"],[o.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[o.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(h){this.collections=h,this.map=new Map,this.descriptionMap=new Map,h.forEach((f,g)=>{this.populateDescriptionMap(f,g);const w=f.map.entries();let d=w.next();for(;!d.done;){const v=d.value[1],E=d.value[0];let p=this.map.get(E);if(p||(p=[],this.map.set(E,p)),p.length>0&&p[0].type===o.EnvironmentVariableMutatorType.Replace){d=w.next();continue}const m={extensionIdentifier:g,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};m.scope||delete m.scope,p.unshift(m),d=w.next()}})}async applyToProcessEnvironment(h,f,g){let w;n.isWindows&&(w={},Object.keys(h).forEach(d=>w[d.toLowerCase()]=d));for(const[d,v]of this.getVariableMap(f)){const E=n.isWindows&&w[d.toLowerCase()]||d;for(const p of v){const m=g?await g(p.value):p.value;if(p.options?.applyAtProcessCreation??!0)switch(p.type){case o.EnvironmentVariableMutatorType.Append:h[E]=(h[E]||"")+m;break;case o.EnvironmentVariableMutatorType.Prepend:h[E]=m+(h[E]||"");break;case o.EnvironmentVariableMutatorType.Replace:h[E]=m;break}if(p.options?.applyAtShellIntegration??!1){const b=`VSCODE_ENV_${I.get(p.type)}`;h[b]=(h[b]?h[b]+":":"")+d+"="+this._encodeColons(m)}}}}_encodeColons(h){return h.replaceAll(":","\\x3a")}diff(h,f){const g=new Map,w=new Map,d=new Map;if(h.getVariableMap(f).forEach((v,E)=>{const p=this.getVariableMap(f).get(E),m=R(v,p);m&&g.set(E,m)}),this.getVariableMap(f).forEach((v,E)=>{const p=h.getVariableMap(f).get(E),m=R(v,p);m&&d.set(E,m)}),this.getVariableMap(f).forEach((v,E)=>{const p=h.getVariableMap(f).get(E),m=y(v,p);m&&w.set(E,m)}),!(g.size===0&&w.size===0&&d.size===0))return{added:g,changed:w,removed:d}}getVariableMap(h){const f=new Map;for(const g of this.map.values()){const w=g.filter(d=>C(d,h));w.length>0&&f.set(w[0].variable,w)}return f}getDescriptionMap(h){const f=new Map;for(const g of this.descriptionMap.values()){const w=g.filter(d=>C(d,h,!0));for(const d of w)f.set(d.extensionIdentifier,d.description)}return f}populateDescriptionMap(h,f){if(!h.descriptionMap)return;const g=h.descriptionMap.entries();let w=g.next();for(;!w.done;){const d=w.value[1],v=w.value[0];let E=this.descriptionMap.get(v);E||(E=[],this.descriptionMap.set(v,E));const p={extensionIdentifier:f,scope:d.scope,description:d.description};p.scope||delete p.scope,E.push(p),w=g.next()}}}e.MergedEnvironmentVariableCollection=k;function C(a,h,f=!1){return a.scope?!!(a.scope.workspaceFolder&&h?.workspaceFolder&&a.scope.workspaceFolder.index===h.workspaceFolder.index):f?h===a.scope:!0}function R(a,h){if(!h)return a;const f=new Set;h.forEach(w=>f.add(w.extensionIdentifier));const g=[];return a.forEach(w=>{f.has(w.extensionIdentifier)||g.push(w)}),g.length===0?void 0:g}function y(a,h){if(!h)return;const f=new Map;h.forEach(w=>f.set(w.extensionIdentifier,w));const g=[];return a.forEach(w=>{const d=f.get(w.extensionIdentifier);d&&(w.type!==d.type||w.value!==d.value||w.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&g.push(d)}),g.length===0?void 0:g}}),define(oe[263],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=n,e.serializeEnvironmentDescriptionMap=o,e.deserializeEnvironmentVariableCollection=I,e.deserializeEnvironmentDescriptionMap=k,e.serializeEnvironmentVariableCollections=C,e.deserializeEnvironmentVariableCollections=R;function n(y){return[...y.entries()]}function o(y){return y?[...y.entries()]:[]}function I(y){return new Map(y)}function k(y){return new Map(y??[])}function C(y){return Array.from(y.entries()).map(a=>[a[0],n(a[1].map),o(a[1].descriptionMap)])}function R(y){return new Map(y.map(a=>[a[0],{map:I(a[1]),descriptionMap:k(a[2])}]))}}),define(oe[264],ae([0,1,8,23,4,2,5]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(a,h){super(),this._logService=h,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new I.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=a===void 0?15e3:a,this._register((0,k.toDisposable)(()=>{for(const f of this._pendingRequestDisposables.values())(0,k.dispose)(f)}))}createRequest(a){return new Promise((h,f)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,h),this._onCreateRequest.fire({requestId:g,...a});const w=new o.CancellationTokenSource;(0,n.timeout)(this._timeout,w.token).then(()=>f(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,k.toDisposable)(()=>w.cancel())])})}acceptReply(a,h){const f=this._pendingRequests.get(a);f?(this._pendingRequests.delete(a),(0,k.dispose)(this._pendingRequestDisposables.get(a)||[]),this._pendingRequestDisposables.delete(a),f(h)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.RequestStore=R,e.RequestStore=R=Pe([ne(1,C.ILogService)],R)}),define(oe[76],ae([0,1,6,123,45]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new o.RawContextKey("terminalTabFocusMode",!1,!0);var k;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var C;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var y;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(y||(e.WindowsShellType=y={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var h;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(h||(e.TerminalIpcChannels=h={}));var f;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.IPtyService=(0,n.createDecorator)("ptyService");var g;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var v;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var E;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(E||(e.FlowControlConstants=E={}));var p;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var m;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var b;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(b||(e.TerminalExitReason=b={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class D{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(s){const i=this._sanitizeRemoteAuthority(s.remoteAuthority);if(this._backends.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this._backends.set(i,s)}getTerminalBackend(s){return this._backends.get(this._sanitizeRemoteAuthority(s))}_sanitizeRemoteAuthority(s){return s?.toLowerCase()??""}}I.Registry.add(e.TerminalExtensions.Backend,new D),e.ILocalPtyService=(0,n.createDecorator)("localPtyService"),e.ITerminalLogService=(0,n.createDecorator)("terminalLogService")}),define(oe[265],ae([0,1,80,7,194,111]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=C,e.terminalProfileArgsMatch=a,e.terminalIconsEqual=h,e.isUriComponents=f;function C(g,w){const d=[{name:null,description:(0,I.localize)(0,null)}];return d.push(...g.map(v=>({name:v.profileName,description:R(v)}))),w&&d.push(...w.map(v=>({name:v.title,description:y(v)}))),{values:d.map(v=>v.name),markdownDescriptions:d.map(v=>v.description)}}function R(g){let w=`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?w+=`
- args: "${g.args}"`:w+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(w+=`
- overrideName: ${g.overrideName}`),g.color&&(w+=`
- color: ${g.color}`),g.env&&(w+=`
- env: ${JSON.stringify(g.env)}`),w}function y(g){return`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function a(g,w){if(!g&&!w)return!0;if(typeof g=="string"&&typeof w=="string")return g===w;if(Array.isArray(g)&&Array.isArray(w)){if(g.length!==w.length)return!1;for(let d=0;d<g.length;d++)if(g[d]!==w[d])return!1;return!0}return!1}function h(g,w){if(!g&&!w)return!0;if(!g||!w)return!1;if(k.ThemeIcon.isThemeIcon(g)&&k.ThemeIcon.isThemeIcon(w))return g.id===w.id&&g.color===w.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof w=="object"&&"light"in w&&"dark"in w){const d=g,v=w;if((o.URI.isUri(d.light)||f(d.light))&&(o.URI.isUri(d.dark)||f(d.dark))&&(o.URI.isUri(v.light)||f(v.light))&&(o.URI.isUri(v.dark)||f(v.dark)))return d.light.path===v.light.path&&d.dark.path===v.dark.path}if(o.URI.isUri(g)&&o.URI.isUri(w)||f(g)||f(w)){const d=g,v=w;return d.path===v.path&&d.scheme===v.scheme}return!1}function f(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(oe[266],ae([0,1,80,3,193,56,45,76,265]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=d,e.registerTerminalDefaultProfileConfiguration=E,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,n.getAllCodicons)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.getAllCodicons)(),p=>`$(${p.id})`)};const a={args:{description:(0,I.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,I.localize)(1,null),type:"boolean"},icon:{description:(0,I.localize)(2,null),...e.terminalIconSchema},color:{description:(0,I.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,I.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(5,null),type:["string","array"],items:{type:"string"}},...a}},f={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(6,null),type:["string"],items:{type:"string"}},...a}};function g(p){const m=p===o.Platform.Linux?"linux":p===o.Platform.Mac?"osx":"windows";return(0,I.localize)(7,null,(0,o.PlatformToString)(p),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,I.localize)(8,null),type:"object",properties:{[R.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,I.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,I.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,I.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(o.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,I.localize)(12,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(13,null),type:"string"},id:{description:(0,I.localize)(14,null),type:"string"},title:{description:(0,I.localize)(15,null),type:"string"},...a}},{type:"null"},h]}},[R.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(o.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(16,null),type:"string"},id:{description:(0,I.localize)(17,null),type:"string"},title:{description:(0,I.localize)(18,null),type:"string"},...a}},{type:"null"},h]}},[R.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(o.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(19,null),type:"string"},id:{description:(0,I.localize)(20,null),type:"string"},title:{description:(0,I.localize)(21,null),type:"string"},...a}},{type:"null"},h]}},[R.TerminalSettingId.UseWslProfiles]:{description:(0,I.localize)(22,null),type:"boolean",default:!0},[R.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,I.localize)(23,null),type:"boolean",default:!0},[R.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,I.localize)(24,null),type:"number",default:100},[R.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,I.localize)(25,null),type:"boolean",default:!0},[R.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,I.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.Registry.as(k.Extensions.Configuration).registerConfiguration(w),E()}let v;function E(p,m){const b=C.Registry.as(k.Extensions.Configuration);let D;p&&(D=(0,y.createProfileSchemaEnums)(p?.profiles,m));const t=v;v={id:"terminal",order:100,title:(0,I.localize)(27,null),type:"object",properties:{[R.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,I.localize)(28,null),type:["string","null"],default:null,enum:p?.os===o.OperatingSystem.Linux?D?.values:void 0,markdownEnumDescriptions:p?.os===o.OperatingSystem.Linux?D?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,I.localize)(29,null),type:["string","null"],default:null,enum:p?.os===o.OperatingSystem.Macintosh?D?.values:void 0,markdownEnumDescriptions:p?.os===o.OperatingSystem.Macintosh?D?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,I.localize)(30,null),type:["string","null"],default:null,enum:p?.os===o.OperatingSystem.Windows?D?.values:void 0,markdownEnumDescriptions:p?.os===o.OperatingSystem.Windows?D?.markdownDescriptions:void 0}}},b.updateConfigurations({add:[v],remove:t?[t]:[]})}}),define(oe[267],ae([0,1,27,12,36,10,3,37,26,13,21,131,263,262]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=d,e.findExecutable=v,e.getShellIntegrationInjection=E,n=ke(n),k=ke(k),R=ke(R),h=ke(h);function d(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let P=0;return u&&u.length===4&&(P=parseInt(u[3])),P}async function v(u,P,S,M=R.env,T=h.Promises.exists){if(k.isAbsolute(u))return await T(u)?u:void 0;if(P===void 0&&(P=R.cwd()),k.dirname(u)!=="."){const B=k.join(P,u);return await T(B)?B:void 0}const A=(0,I.getCaseInsensitive)(M,"PATH");if(S===void 0&&(0,a.isString)(A)&&(S=A.split(k.delimiter)),S===void 0||S.length===0){const B=k.join(P,u);return await T(B)?B:void 0}for(const B of S){let N;if(k.isAbsolute(B)?N=k.join(B,u):N=k.join(P,B,u),await T(N))return N;if(C.isWindows){let z=N+".com";if(await T(z)||(z=N+".exe",await T(z)))return z}}const _=k.join(P,u);return await T(_)?_:void 0}function E(u,P,S,M,T){const L=C.isWindows&&(!P.windowsEnableConpty||d()<18309);if(!P.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||L)return;const A=u.args,_=R.platform==="win32"?k.basename(u.executable).toLowerCase():k.basename(u.executable),B=k.dirname(o.FileAccess.asFileUri("").fsPath);let N;const z={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(z.VSCODE_NONCE=P.shellIntegration.nonce),C.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!A||r(A)?N=b.get(m.WindowsPwsh):c(A)&&(N=b.get(m.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,y.format)(N[N.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:z}):void 0;if(_==="bash.exe")return!A||A.length===0?N=b.get(m.Bash):l(A)&&(z.VSCODE_SHELL_LOGIN="1",p(P,z),N=b.get(m.Bash)),N?(N=[...N],N[N.length-1]=(0,y.format)(N[N.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;M.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(_){case"bash":return!A||A.length===0?N=b.get(m.Bash):l(A)&&(z.VSCODE_SHELL_LOGIN="1",p(P,z),N=b.get(m.Bash)),N?(N=[...N],N[N.length-1]=(0,y.format)(N[N.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;case"fish":{const se=S?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=k.join(B,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${se}:${J}`,p(P,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!A||r(A)?N=b.get(m.Pwsh):c(A)&&(N=b.get(m.PwshLogin)),N?(P.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,y.format)(N[N.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;case"zsh":{if(!A||A.length===0?N=b.get(m.Zsh):l(A)?(N=b.get(m.ZshLogin),p(P,z)):(A===b.get(m.Zsh)||A===b.get(m.ZshLogin))&&(N=A),!N)return;N=[...N],N[N.length-1]=(0,y.format)(N[N.length-1],B);let se;try{se=n.userInfo().username}catch{se="unknown"}const J=k.join(n.tmpdir(),`${se}-${T.applicationName}-zsh`);z.ZDOTDIR=J;const le=S?.ZDOTDIR??n.homedir()??"~";z.USER_ZDOTDIR=le;const K=[];return K.push({source:k.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(J,".zshrc")}),K.push({source:k.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(J,".zprofile")}),K.push({source:k.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(J,".zshenv")}),K.push({source:k.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(J,".zlogin")}),{newArgs:N,envMixin:z,filesToCopy:K}}}M.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function p(u,P){if(C.isMacintosh&&u.environmentVariableCollections){const S=(0,g.deserializeEnvironmentVariableCollections)(u.environmentVariableCollections),T=new w.MergedEnvironmentVariableCollection(S).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),L=[];if(T)for(const A of T)A.type===f.EnvironmentVariableMutatorType.Prepend&&L.push(A.value);L.length>0&&(P.VSCODE_PATH_PREFIX=L.join(""))}}var m;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(m||(m={}));const b=new Map;b.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),b.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),b.set(m.Zsh,["-i"]),b.set(m.ZshLogin,["-il"]),b.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const D=["-login","-l"],t=["--login","-l"],s=["-i","--interactive"],i=["-nol","-nologo"];function c(u){return typeof u=="string"?D.includes(u.toLowerCase()):u.length===1&&D.includes(u[0].toLowerCase())||u.length===2&&(D.includes(u[0].toLowerCase())||D.includes(u[1].toLowerCase()))&&(i.includes(u[0].toLowerCase())||i.includes(u[1].toLowerCase()))}function r(u){return typeof u=="string"?i.includes(u.toLowerCase()):u.length===0||u?.length===1&&i.includes(u[0].toLowerCase())}function l(u){return typeof u!="string"&&(u=u.filter(P=>!s.includes(P.toLowerCase()))),u==="string"&&t.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&t.includes(u[0].toLowerCase())}}),define(oe[268],ae([0,1,49,80,10,3,13,21,115,76,267,122]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=v,n=ke(n),R=ke(R);var g;(function(P){P.UnixShellsPath="/etc/shells"})(g||(g={}));let w,d=!0;function v(P,S,M,T,L=process.env,A,_,B,N){return A=A||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},k.isWindows?E(M,A,L,_,T.getValue(a.TerminalSettingId.UseWslProfiles)!==!1,P&&typeof P=="object"?{...P}:T.getValue(a.TerminalSettingId.ProfilesWindows),typeof S=="string"?S:T.getValue(a.TerminalSettingId.DefaultProfileWindows),N,B):r(A,_,M,P&&typeof P=="object"?{...P}:T.getValue(k.isLinux?a.TerminalSettingId.ProfilesLinux:a.TerminalSettingId.ProfilesMacOs),typeof S=="string"?S:T.getValue(k.isLinux?a.TerminalSettingId.DefaultProfileLinux:a.TerminalSettingId.DefaultProfileMacOs),N,B,L)}async function E(P,S,M,T,L,A,_,B,N){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let J=!1;(0,h.getWindowsBuildNumber)()>=16299&&(J=!0),await D(B);const le=new Map;if(P){le.set("PowerShell",{source:a.ProfileSource.Pwsh,icon:o.Codicon.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:o.Codicon.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:a.ProfileSource.GitBash,isAutoDetected:!0}),le.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:o.Codicon.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:o.Codicon.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}l(A,le);const K=await p(le.entries(),_,S,M,T,N);if(P&&L)try{const ee=await i(`${se}\\${J?"wsl":"bash"}.exe`,_);for(const q of ee)(!A||!(q.profileName in A))&&K.push(q)}catch{d&&(T?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return K}async function p(P,S,M,T=process.env,L,A){const _=[];for(const[B,N]of P)_.push(m(B,N,S,M,T,L,A));return(await Promise.all(_)).filter(B=>!!B)}async function m(P,S,M,T,L=process.env,A,_){if(S===null)return;let B,N,z;if("source"in S&&!("path"in S)){const K=w?.get(S.source);if(!K)return;B=K.paths,N=S.args||K.args,S.icon?z=b(S.icon):K.icon&&(z=K.icon)}else B=Array.isArray(S.path)?S.path:[S.path],N=k.isWindows||Array.isArray(S.args)?S.args:void 0,z=b(S.icon);let se;if(_){const K=B.map(q=>typeof q=="string"?q:q.path),ee=await _(K);se=new Array(B.length);for(let q=0;q<B.length;q++)typeof B[q]=="string"?se[q]=ee[q]:se[q]={path:ee[q],isUnsafe:!0}}else se=B.slice();let J;if(S.requiresPath){let K;if((0,C.isString)(S.requiresPath)?K=S.requiresPath:(K=S.requiresPath.path,S.requiresPath.isUnsafe&&(J=K)),!await T.existsFile(K))return}const le=await u(P,M,se,T,L,N,S.env,S.overrideName,S.isAutoDetected,J);if(!le){A?.debug("Terminal profile not validated",P,B);return}return le.isAutoDetected=S.isAutoDetected,le.icon=z,le.color=S.color,le}function b(P){return typeof P=="string"?{id:P}:P}async function D(P){if(w&&!P)return;const[S,M]=await Promise.all([t(),P||s()]);w=new Map,w.set(a.ProfileSource.GitBash,{profileName:"Git Bash",paths:S,args:["--login","-i"]}),w.set(a.ProfileSource.Pwsh,{profileName:"PowerShell",paths:M,icon:o.Codicon.terminalPowershell})}async function t(){const P=new Set,S=await(0,h.findExecutable)("git.exe");if(S){const L=(0,f.dirname)(S);P.add((0,f.resolve)(L,"../.."))}function M(L,A){A&&L.add(A)}M(P,process.env.ProgramW6432),M(P,process.env.ProgramFiles),M(P,process.env["ProgramFiles(X86)"]),M(P,`${process.env.LocalAppData}\\Program`);const T=[];for(const L of P)T.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return T.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),T.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),T}async function s(){const P=[];for await(const S of(0,y.enumeratePowerShellInstallations)())P.push(S.exePath);return P}async function i(P,S){const M=[],T=await new Promise((_,B)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,z)=>{if(N)return B("Problem occurred when getting wsl distros");_(z)})});if(!T)return[];const L=new RegExp(/[\r?\n]/),A=T.split(L).filter(_=>_.trim().length>0&&_!=="");for(const _ of A){if(_===""||_.startsWith("docker-desktop"))continue;const B=`${_} (WSL)`,N={profileName:B,path:P,args:["-d",`${_}`],isDefault:B===S,icon:c(_),isAutoDetected:!1};M.push(N)}return M}function c(P){return P.includes("Ubuntu")?o.Codicon.terminalUbuntu:P.includes("Debian")?o.Codicon.terminalDebian:o.Codicon.terminalLinux}async function r(P,S,M,T,L,A,_,B){const N=new Map;if(M&&await P.existsFile(g.UnixShellsPath)){const z=(await P.readFile(g.UnixShellsPath)).toString(),se=(A||z.split(`
`)).map(le=>{const K=le.indexOf("#");return K===-1?le:le.substring(0,K)}).filter(le=>le.trim().length>0),J=new Map;for(const le of se){let K=(0,I.basename)(le),ee=J.get(K)||0;ee++,ee>1&&(K=`${K} (${ee})`),J.set(K,ee),N.set(K,{path:le,isAutoDetected:!0})}}return l(T,N),await p(N.entries(),L,P,B,S,_)}function l(P,S){if(P)for(const[M,T]of Object.entries(P))T===null||typeof T!="object"||!("path"in T)&&!("source"in T)?S.delete(M):(T.icon=T.icon||S.get(M)?.icon,S.set(M,T))}async function u(P,S,M,T,L,A,_,B,N,z){if(M.length===0)return Promise.resolve(void 0);const se=M.shift();if(se==="")return u(P,S,M,T,L,A,_,B,N);const J=typeof se!="string"&&se.isUnsafe,le=typeof se=="string"?se:se.path,K={profileName:P,path:le,args:A,env:_,overrideName:B,isAutoDetected:N,isDefault:P===S,isUnsafePath:J,requiresUnsafePath:z};if((0,I.basename)(le)===le){const q=L.PATH?L.PATH.split(I.delimiter):void 0,O=await(0,h.findExecutable)(le,void 0,q,void 0,T.existsFile);return O?(K.path=O,K.isFromPath=!0,K):u(P,S,M,T,L,A)}return await T.existsFile((0,I.normalize)(le))?K:u(P,S,M,T,L,A,_,B,N)}}),define(oe[269],ae([0,1,4,2,3,44,18,5,231,101,264,76,266,268,117,67]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let p=class extends o.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(b,D,t,s){super(),this._ptyHostStarter=b,this._configurationService=D,this._logService=t,this._loggerService=s,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new n.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new n.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new n.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new n.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new n.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new n.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new n.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new n.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new n.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new n.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new n.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new n.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,o.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._register(this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables)),this._ptyHostStarter.onRequestConnection&&this._register(n.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost())),this._ptyHostStarter.onWillShutdown&&this._register(this._ptyHostStarter.onWillShutdown(()=>this._wasQuitRequested=!0))}get _ignoreProcessNames(){return this._configurationService.getValue(f.TerminalSettingId.IgnoreProcessNames)}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,a.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(b){return this._logService.error("ptyHost was unable to resolve shell environment",b),{}}}_startPtyHost(){const b=this._ptyHostStarter.start(),D=b.client;this._logService.getLevel()===R.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(D.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(b.onDidProcessExit(i=>{this._onPtyHostExit.fire(i.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const s=k.ProxyChannel.toService(D.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(i=>this._onProcessData.fire(i))),this._register(s.onProcessReady(i=>this._onProcessReady.fire(i))),this._register(s.onProcessExit(i=>this._onProcessExit.fire(i))),this._register(s.onDidChangeProperty(i=>this._onDidChangeProperty.fire(i))),this._register(s.onProcessReplay(i=>this._onProcessReplay.fire(i))),this._register(s.onProcessOrphanQuestion(i=>this._onProcessOrphanQuestion.fire(i))),this._register(s.onDidRequestDetach(i=>this._onDidRequestDetach.fire(i))),this._register(new y.RemoteLoggerChannelClient(this._loggerService,D.getChannel(f.TerminalIpcChannels.Logger))),this.__connection=b,this.__proxy=s,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async i=>{i.affectsConfiguration(f.TerminalSettingId.IgnoreProcessNames)&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[b,s]}async createProcess(b,D,t,s,i,c,r,l,u,P,S){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),T=await this._proxy.createProcess(b,D,t,s,i,c,r,l,u,P,S);return clearTimeout(M),T}updateTitle(b,D,t){return this._proxy.updateTitle(b,D,t)}updateIcon(b,D,t,s){return this._proxy.updateIcon(b,D,t,s)}attachToProcess(b){return this._proxy.attachToProcess(b)}detachFromProcess(b,D){return this._proxy.detachFromProcess(b,D)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(b){return this._proxy.start(b)}shutdown(b,D){return this._proxy.shutdown(b,D)}input(b,D){return this._proxy.input(b,D)}processBinary(b,D){return this._proxy.processBinary(b,D)}resize(b,D,t){return this._proxy.resize(b,D,t)}clearBuffer(b){return this._proxy.clearBuffer(b)}acknowledgeDataEvent(b,D){return this._proxy.acknowledgeDataEvent(b,D)}setUnicodeVersion(b,D){return this._proxy.setUnicodeVersion(b,D)}getInitialCwd(b){return this._proxy.getInitialCwd(b)}getCwd(b){return this._proxy.getCwd(b)}async getLatency(){const b=new v.StopWatch,D=await this._proxy.getLatency();return b.stop(),[{label:"ptyhostservice<->ptyhost",latency:b.elapsed()},...D]}orphanQuestionReply(b){return this._proxy.orphanQuestionReply(b)}installAutoReply(b,D){return this._proxy.installAutoReply(b,D)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(b){return this._proxy.uninstallAutoReply(b)}getDefaultSystemShell(b){return this._optionalProxy?.getDefaultSystemShell(b)??(0,d.getSystemShell)(b??I.OS,process.env)}async getProfiles(b,D,t,s=!1){const i=await this._resolveShellEnv();return(0,w.detectAvailableProfiles)(D,t,s,this._configurationService,i,void 0,this._logService,this._resolveVariables.bind(this,b))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(b,D){return this._proxy.getWslPath(b,D)}getRevivedPtyNewId(b,D){return this._proxy.getRevivedPtyNewId(b,D)}setTerminalLayoutInfo(b){return this._proxy.setTerminalLayoutInfo(b)}async getTerminalLayoutInfo(b){return this._optionalProxy?.getTerminalLayoutInfo(b)}async requestDetachInstance(b,D){return this._proxy.requestDetachInstance(b,D)}async acceptDetachInstanceReply(b,D){return this._proxy.acceptDetachInstanceReply(b,D)}async freePortKillProcess(b){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(b)}async serializeTerminalState(b){return this._proxy.serializeTerminalState(b)}async reviveTerminalProcesses(b,D,t){return this._proxy.reviveTerminalProcesses(b,D,t)}async refreshProperty(b,D){return this._proxy.refreshProperty(b,D)}async updateProperty(b,D,t){return this._proxy.updateProperty(b,D,t)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(b){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),b?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(b,D){return this._resolveVariablesRequestStore.createRequest({workspaceId:b,originalText:D})}async acceptPtyHostResolvedVariables(b,D){this._resolveVariablesRequestStore.acceptReply(b,D)}};e.PtyHostService=p,e.PtyHostService=p=Pe([ne(1,C.IConfigurationService),ne(2,R.ILogService),ne(3,R.ILoggerService)],p)}),define(oe[77],ae([0,1,14,4,2,3,18,6,34]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const a="#FFFFFF",h="#1E1E1E",f="#000000",g="#FFFFFF",w="theme",d="themeBackground",v="windowSplash";var E;(function(m){m.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",m.SYSTEM_COLOR_THEME="window.systemColorTheme"})(E||(E={})),e.IThemeMainService=(0,R.createDecorator)("themeMainService");let p=class extends I.Disposable{constructor(b,D){super(),this.stateService=b,this.configurationService=D,this._onDidChangeColorScheme=this._register(new o.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,k.isLinux||this._register(this.configurationService.onDidChangeConfiguration(t=>{(t.affectsConfiguration(E.SYSTEM_COLOR_THEME)||t.affectsConfiguration(E.DETECT_COLOR_SCHEME))&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(o.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){if(k.isLinux||this.configurationService.getValue(E.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.configurationService.getValue(E.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(k.isWindows){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(k.isMacintosh){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(k.isLinux&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const b=this.getColorScheme();if(b.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return b.dark?f:g;let D=this.stateService.getItem(d,null);if(!D)switch(this.getBaseTheme()){case"vs":D=a;break;case"hc-black":D=f;break;case"hc-light":D=g;break;default:D=h}return k.isMacintosh&&D.toUpperCase()===h&&(D="#171717"),D}getBaseTheme(){switch(this.stateService.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(b,D){this.stateService.setItems([{key:w,data:D.baseTheme},{key:d,data:D.colorInfo.background},{key:v,data:D}]),typeof b=="number"&&this.updateBackgroundColor(b,D),this.updateSystemColorTheme()}updateBackgroundColor(b,D){for(const t of n.BrowserWindow.getAllWindows())if(t.id===b){t.setBackgroundColor(D.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(v)}};e.ThemeMainService=p,e.ThemeMainService=p=Pe([ne(0,y.IStateService),ne(1,C.IConfigurationService)],p)}),define(oe[132],ae([0,1,4,2,3,7,18,6,5]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=f,e.extractLocalHostUriMetaDataForPortMapping=w,e.extractQueryLocalHostUriMetaDataForPortMapping=d,e.isLocalhost=v,e.isAllInterfaces=E,e.isPortPrivileged=p,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var a;(function(D){D.Http="http",D.Https="https"})(a||(e.TunnelProtocol=a={}));var h;(function(D){D.ConstantPrivate="constantPrivate",D.Private="private",D.Public="public"})(h||(e.TunnelPrivacyId=h={}));function f(D){return!!D.forwardPort}var g;(function(D){D[D.Notify=1]="Notify",D[D.OpenBrowser=2]="OpenBrowser",D[D.OpenPreview=3]="OpenPreview",D[D.Silent=4]="Silent",D[D.Ignore=5]="Ignore",D[D.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function w(D){if(D.scheme!=="http"&&D.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(D.authority);if(t)return{address:t[1],port:+t[2]}}function d(D){if(D.scheme!=="http"&&D.scheme!=="https"||!D.query)return;const t=D.query.split("&");for(const s of t){const i=s.split("=")[1];if(/^https?:/.exec(i)){const c=w(k.URI.parse(i));if(c)return c}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(D){return e.LOCALHOST_ADDRESSES.indexOf(D)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(D){return e.ALL_INTERFACES_ADDRESSES.indexOf(D)>=0}function p(D,t,s,i){if(s===I.OperatingSystem.Windows)return!1;if(s===I.OperatingSystem.Macintosh&&E(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(c?.length===4&&parseInt(c[1])>=18)return!1}return D<1024}class m{constructor(t,s,i){this.remoteAddress=t,this.localAddress=s,this._dispose=i,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let b=class extends o.Disposable{constructor(t,s){super(),this.logService=t,this.configurationService=s,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],s=Array.from(this._tunnels.values());for(const i of s){const c=Array.from(i.values());for(const r of c){const l=await r.value;l&&typeof l!="string"&&t.push(l)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:s}of t.values())await s.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,s,i,c,r){this.addTunnelToMap(t,s,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:s,localAddress:i,privacy:c,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,s){(E(t)||v(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const i=this.getTunnelFromMap(t,s);if(i)return++i.refcount,i.value}openTunnel(t,s,i,c,r,l=!1,u,P){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${i} on local port ${r}.`);const S=this._tunnelProvider??t;if(!S)return;if(s||(s="localhost"),c||(c=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(i)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const M=this.retainOrCreateTunnel(S,s,i,c,r,l,u,P);return M?M.then(T=>{if(T){if(typeof T=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(s,i),T}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(s,i);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const L=this.makeTunnel(T);return(T.tunnelRemoteHost!==s||T.tunnelRemotePort!==i)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&T.privacy!==u&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(L),L}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),M)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const s=this._tunnels.get(t.tunnelRemoteHost);if(s){const i=s.get(t.tunnelRemotePort);i&&(i.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async tryDisposeTunnel(t,s,i){if(i.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${s}.`);const c=i.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(s),c}}async closeTunnel(t,s){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${s} `);const i=this._tunnels.get(t);if(i&&i.has(s)){const c=i.get(s);c.refcount=0,await this.tryDisposeTunnel(t,s,c)}}addTunnelToMap(t,s,i){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(s,{refcount:1,value:i})}async removeEmptyOrErrorTunnelFromMap(t,s){const i=this._tunnels.get(t);if(i){const c=i.get(s),r=c?await c.value:void 0;(!r||typeof r=="string")&&i.delete(s),i.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,s){const i=[t];v(t)?(i.push(...e.LOCALHOST_ADDRESSES),i.push(...e.ALL_INTERFACES_ADDRESSES)):E(t)&&i.push(...e.ALL_INTERFACES_ADDRESSES);const c=i.map(r=>this._tunnels.get(r));for(const r of c){const l=r?.get(s);if(l)return l}}canTunnel(t){return!!w(t)}createWithProvider(t,s,i,c,r,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${i} on local port ${c}.`);const P=i;this._factoryInProgress.add(P);const S=c===void 0?i:c,M={elevationRequired:r?this.isPortPrivileged(S):!1},T={remoteAddress:{host:s,port:i},localAddressPort:c,privacy:l,public:l?l!==h.Private:void 0,protocol:u},L=t.forwardPort(T,M);return L?(this.addTunnelToMap(s,i,L),L.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(P)})):this._factoryInProgress.delete(P),L}};e.AbstractTunnelService=b,e.AbstractTunnelService=b=Pe([ne(0,y.ILogService),ne(1,C.IConfigurationService)],b)}),define(oe[50],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var o;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(o||(e.StateType=o={}));var I;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(I||(e.UpdateType=I={}));var k;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(k||(e.DisablementReason=k={})),e.State={Uninitialized:{type:o.Uninitialized},Disabled:C=>({type:o.Disabled,reason:C}),Idle:(C,R)=>({type:o.Idle,updateType:C,error:R}),CheckingForUpdates:C=>({type:o.CheckingForUpdates,explicit:C}),AvailableForDownload:C=>({type:o.AvailableForDownload,update:C}),Downloading:{type:o.Downloading},Downloaded:C=>({type:o.Downloaded,update:C}),Updating:C=>({type:o.Updating,update:C}),Ready:C=>({type:o.Ready,update:C})},e.IUpdateService=(0,n.createDecorator)("updateService")}),define(oe[270],ae([0,1,3,195,56,45]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(I.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,o.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:I.ConfigurationScope.APPLICATION,description:(0,o.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,o.localize)(2,null),(0,o.localize)(3,null),(0,o.localize)(4,null),(0,o.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:I.ConfigurationScope.APPLICATION,description:(0,o.localize)(6,null),deprecationMessage:(0,o.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:I.ConfigurationScope.APPLICATION,title:(0,o.localize)(8,null),description:(0,o.localize)(9,null),included:n.isWindows&&!n.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:I.ConfigurationScope.APPLICATION,description:(0,o.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[271],ae([0,1,4,50]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class I{constructor(R){this.service=R}listen(R,y){switch(y){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${y}`)}call(R,y,a){switch(y){case"checkForUpdates":return this.service.checkForUpdates(a);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(a)}throw new Error(`Call not found: ${y}`)}}e.UpdateChannel=I;class k{get state(){return this._state}set state(R){this._state=R,this._onStateChange.fire(R)}constructor(R){this.channel=R,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event,this._state=o.State.Uninitialized,this.channel.listen("onStateChange")(y=>this.state=y),this.channel.call("_getInitialState").then(y=>this.state=y)}checkForUpdates(R){return this.channel.call("checkForUpdates",R)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(R){return this.channel.call("_applySpecificUpdate",R)}}e.UpdateChannelClient=k}),define(oe[41],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,n.createDecorator)("IUriIdentityService")}),define(oe[272],ae([0,1,41,211,15,19,144,4,2]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(g){this.uri=g,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(g){this._fileService=g,this._dispooables=new y.DisposableStore,this._limit=2**16;const w=new Map,d=v=>{let E=w.get(v.scheme);return E===void 0&&(E=g.hasProvider(v)&&!this._fileService.hasCapability(v,I.FileSystemProviderCapabilities.PathCaseSensitive),w.set(v.scheme,E)),E};this._dispooables.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{w.delete(v.scheme)})),this.extUri=new k.ExtUri(d),this._canonicalUris=new C.SkipList((v,E)=>this.extUri.compare(v,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,k.normalizePath)(g));const w=this._canonicalUris.get(g);return w?w.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new a(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((d,v)=>d[1].time<v[1].time?1:d[1].time>v[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let d=0;d<w;d++)this._canonicalUris.set(g[d][0],g[d][1].touch())}};e.UriIdentityService=h,e.UriIdentityService=h=Pe([ne(0,I.IFileService)],h),(0,o.registerSingleton)(n.IUriIdentityService,h,o.InstantiationType.Delayed)}),define(oe[133],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,n.createDecorator)("urlService")}),define(oe[273],ae([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class o{constructor(R){this.handler=R}listen(R,y){throw new Error(`Event not found: ${y}`)}call(R,y,a){switch(y){case"handleURL":return this.handler.handleURL(n.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${y}`)}}e.URLHandlerChannel=o;class I{constructor(R){this.channel=R}handleURL(R,y){return this.channel.call("handleURL",[R.toJSON(),y])}}e.URLHandlerChannelClient=I;class k{constructor(R,y){this.next=R,this.logService=y}async routeCall(R,y,a,h){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(Array.isArray(a)&&a.length>0){const f=n.URI.revive(a[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const g=/\bwindowId=(\d+)/.exec(f.query);if(g){const w=g[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,f.toString(!0));const d=new RegExp(`window:${w}`),v=R.connections.find(E=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",E.ctx),d.test(E.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(R,y,a,h)}routeEvent(R,y){throw new Error(`Event not found: ${y}`)}}e.URLHandlerRouter=k}),define(oe[274],ae([0,1,8,2,7,28]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends o.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(a,h){const f=[...this.handlers.values()];return(0,n.first)(f.map(g=>()=>g.handleURL(a,h)),void 0,!1).then(g=>g||!1)}registerHandler(a){return this.handlers.add(a),(0,o.toDisposable)(()=>this.handlers.delete(a))}}e.AbstractURLService=C;let R=class extends C{constructor(a){super(),this.productService=a}create(a){let{authority:h,path:f,query:g,fragment:w}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return h&&f&&f.indexOf("/")!==0&&(f=`/${f}`),I.URI.from({scheme:this.productService.urlProtocol,authority:h,path:f,query:g,fragment:w})}};e.NativeURLService=R,e.NativeURLService=R=Pe([ne(0,k.IProductService)],R)}),define(oe[275],ae([0,1,14,8,4,2,3,7]),function(V,e,n,o,I,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class y extends k.Disposable{constructor(h,f,g,w,d,v){if(super(),this.urlService=f,this.logService=v,this.uris=[],this.retryCount=0,h&&(v.trace("ElectronURLListener initialUrisToHandle:",h.map(m=>m.originalUrl)),this.uris=h),C.isWindows){const m=w.isBuilt?[]:[`"${w.appRoot}"`];m.push("--open-url","--"),n.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,m)}const E=I.Event.map(I.Event.fromNodeEventEmitter(n.app,"open-url",(m,b)=>({event:m,url:b})),({event:m,url:b})=>(m.preventDefault(),b));this._register(E(m=>{const b=this.uriFromRawUrl(m);b&&this.urlService.open(b,{originalUrl:m})})),g.getWindows().filter(m=>m.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(I.Event.once(g.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(h){try{return R.URI.parse(h)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const h=[];for(const f of this.uris)await this.urlService.open(f.uri,{originalUrl:f.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),h.push(f));h.length!==0&&(this.uris=h,(0,o.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=y}),define(oe[276],ae([0,1,4,2,15,61,32]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends o.Disposable{constructor(a,h,f,g,w,d){super(),this.fileSystemScheme=a,this.fileSystemProvider=h,this.userDataScheme=f,this.userDataProfilesService=g,this.uriIdentityService=w,this.logService=d,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=k.TernarySearchTree.forUris(()=>!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new C.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(v))),this.updateAtomicReadWritesResources(),this._register(g.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(v=>this.handleFileChanges(v)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,h){return this.fileSystemProvider.open(this.toFileSystemResource(a),h)}close(a){return this.fileSystemProvider.close(a)}read(a,h,f,g,w){return this.fileSystemProvider.read(a,h,f,g,w)}write(a,h,f,g,w){return this.fileSystemProvider.write(a,h,f,g,w)}watch(a,h){this.watchResources.set(a,a);const f=this.fileSystemProvider.watch(this.toFileSystemResource(a),h);return(0,o.toDisposable)(()=>{this.watchResources.delete(a),f.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,h,f){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(h),f)}readFile(a,h){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),h)}readFileStream(a,h,f){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),h,f)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,h,f){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),h,f)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.fileSystemProvider.delete(this.toFileSystemResource(a),h)}copy(a,h,f){if((0,I.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(h),f);throw new Error("copy not supported")}cloneFile(a,h){if((0,I.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(h));throw new Error("clone not supported")}handleFileChanges(a){const h=[];for(const f of a){if(f.resource.scheme!==this.fileSystemScheme)continue;const g=this.toUserDataResource(f.resource);this.watchResources.findSubstr(g)&&h.push({resource:g,type:f.type,cId:f.cId})}h.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(h))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(oe[277],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(oe[278],ae([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,n.createDecorator)("webviewManagerService")}),define(oe[279],ae([0,1,14,2,12,7]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends o.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const y=this.handleWebviewRequest.bind(this);n.protocol.registerFileProtocol(I.Schemas.vscodeWebview,y)}handleWebviewRequest(y,a){try{const h=k.URI.parse(y.url),f=C.validWebviewFilePaths.get(h.path);if(typeof f=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${f}`,w=I.FileAccess.asFileUri(g);return a({path:w.fsPath,headers:{...I.COI.getHeadersFromQuery(y.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.WebviewProtocolProvider=C}),define(oe[51],ae([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=o,e.isWorkspaceToOpen=I,e.isFolderToOpen=k,e.isFileToOpen=C,e.getMenuBarVisibility=R,e.hasCustomTitlebar=f,e.hasNativeTitlebar=g,e.getTitleBarStyle=w,e.useWindowControlsOverlay=d,e.useNativeFullScreen=v,e.zoomLevelToZoomFactor=E,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function o(p){return typeof p.parentId=="number"}function I(p){return!!p.workspaceUri}function k(p){return!!p.folderUri}function C(p){return!!p.fileUri}function R(p){const m=g(p),b=p.getValue("window.menuBarVisibility");return b==="default"||m&&b==="compact"||n.isMacintosh&&n.isNative?"classic":b}var y;(function(p){p.TITLE_BAR_STYLE="window.titleBarStyle",p.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(y||(e.TitleBarSetting=y={}));var a;(function(p){p.NATIVE="native",p.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var h;(function(p){p.AUTO="auto",p.WINDOWED="windowed",p.NEVER="never"})(h||(e.CustomTitleBarVisibility=h={}));function f(p,m){return!0}function g(p,m){return m||(m=w(p)),m===a.NATIVE}function w(p){if(n.isWeb)return a.CUSTOM;const m=p.getValue("window");if(m){if(n.isMacintosh&&m.nativeTabs===!0||n.isMacintosh&&m.nativeFullScreen===!1)return a.NATIVE;const t=m.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return n.isLinux?a.NATIVE:a.CUSTOM}e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function d(p){return!(!n.isWindows||n.isWeb||g(p))}function v(p){const m=p.getValue("window");return!m||typeof m.nativeFullScreen!="boolean"||m.nativeTabs?!0:m.nativeFullScreen!==!1}function E(p=0){return Math.pow(1.2,p)}}),define(oe[52],ae([0,1,14]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var o;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(o||(e.LoadReason=o={}));var I;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(I||(e.UnloadReason=I={}));const k=function(a=R.Normal){return{width:1024,height:768,mode:a}};e.defaultWindowState=k;const C=function(){const f=n.screen.getPrimaryDisplay().workArea,g=Math.max(f.x+f.width/2-800/2,0),w=Math.max(f.y+f.height/2-600/2,0);return{x:g,y:w,width:800,height:600,mode:R.Normal}};e.defaultAuxWindowState=C;var R;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(R||(e.WindowMode=R={}));var y;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(y||(e.WindowError=y={}))}),define(oe[280],ae([0,1,8,4,2]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends I.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:y,getActiveWindowId:a}){super(),this.disposables=this._register(new I.DisposableStore),o.Event.latch(o.Event.any(R,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,n.createCancelablePromise)(()=>a()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(oe[30],ae([0,1,199,10,61,19,7,6,12]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=h,e.toWorkspaceIdentifier=f,e.isWorkspaceIdentifier=g,e.reviveIdentifier=w,e.isWorkspace=v,e.isWorkspaceFolder=E,e.toWorkspaceFolder=b,e.isUntitledWorkspace=D,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=s,e.isSavedWorkspace=i,e.hasWorkspaceFileExtension=c,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function a(r){const l=r;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}function h(r){return typeof r?.id=="string"&&!a(r)&&!g(r)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function f(r,l){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,o.basename)(r)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=r;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function g(r){const l=r;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}function w(r){const l=r;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const u=r;if(u?.configPath)return{id:u.id,configPath:C.URI.revive(u.configPath)};if(r?.id)return{id:r.id}}var d;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function v(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function E(r){const l=r;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class p{constructor(l,u,P,S,M){this._id=l,this._transient=P,this._configuration=S,this._ignorePathCasing=M,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class m{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,k.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(r){return new m({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(r,l){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,l.untitledWorkspacesHome)}function t(r){let l;return C.URI.isUri(r)?l=r:l=r.configuration,l?.scheme===y.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(r){return r.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function i(r,l){return!D(r,l)&&!t(r)}function c(r){return(typeof r=="string"?(0,o.extname)(r):(0,k.extname)(r))===e.WORKSPACE_SUFFIX}}),define(oe[53],ae([0,1,14,8,46,48,2,79,3,21,172,124,6,5,28,30]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,g.createDecorator)("dialogMainService");let E=class{constructor(m,b){this.logService=m,this.productService=b,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new o.Queue}pickFileFolder(m,b){return this.doPick({...m,pickFolders:!0,pickFiles:!0,title:(0,h.localize)(0,null)},b)}pickFolder(m,b){return this.doPick({...m,pickFolders:!0,title:(0,h.localize)(1,null)},b)}pickFile(m,b){return this.doPick({...m,pickFiles:!0,title:(0,h.localize)(2,null)},b)}pickWorkspace(m,b){const D=(0,h.localize)(3,null),t=(0,k.mnemonicButtonLabel)((0,h.localize)(4,null)),s=v.WORKSPACE_FILTER;return this.doPick({...m,pickFiles:!0,title:D,filters:s,buttonLabel:t},b)}async doPick(m,b){const D={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(D.properties=void 0,m.pickFiles&&m.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),y.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(b||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(m){if(m){let b=this.windowDialogQueues.get(m.id);return b||(b=new o.Queue,this.windowDialogQueues.set(m.id,b)),b}else return this.noWindowDialogueQueue}showMessageBox(m,b){return this.getWindowDialogQueue(b).queue(async()=>{const{options:D,buttonIndeces:t}=(0,f.massageMessageBoxOptions)(m,this.productService);let s;return b?s=await n.dialog.showMessageBox(b,D):s=await n.dialog.showMessageBox(D),{response:t[s.response],checkboxChecked:s.checkboxChecked}})}async showSaveDialog(m,b){const D=this.acquireFileDialogLock(m,b);if(!D)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.getWindowDialogQueue(b).queue(async()=>{let t;return b?t=await n.dialog.showSaveDialog(b,m):t=await n.dialog.showSaveDialog(m),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,C.dispose)(D)}}normalizePath(m){return m&&y.isMacintosh&&(m=(0,R.normalizeNFC)(m)),m}normalizePaths(m){return m.map(b=>this.normalizePath(b))}async showOpenDialog(m,b){m.defaultPath&&(await a.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const D=this.acquireFileDialogLock(m,b);if(!D)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(b).queue(async()=>{let t;return b?t=await n.dialog.showOpenDialog(b,m):t=await n.dialog.showOpenDialog(m),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,C.dispose)(D)}}acquireFileDialogLock(m,b){if(!b)return C.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",m);let D=this.windowFileDialogLocks.get(b.id);D||(D=new Set,this.windowFileDialogLocks.set(b.id,D));const t=(0,I.hash)(m);if(!D.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",m),D.add(t),(0,C.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",m),D?.delete(t),D?.size===0&&this.windowFileDialogLocks.delete(b.id)})}};e.DialogMainService=E,e.DialogMainService=E=Pe([ne(0,w.ILogService),ne(1,d.IProductService)],E)}),define(oe[281],ae([0,1,4,2,83,30]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends o.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(y,a){super(),this.logService=y,this.storageMainService=a,this.onDidChangeApplicationStorageEmitter=this._register(new n.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(a.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(y,a){this._register(n.Event.debounce(y.onDidChangeStorage,(h,f)=>(h?h.push(f):h=[f],h),C.STORAGE_CHANGE_DEBOUNCE_TIME)(h=>{h.length&&a.fire(this.serializeStorageChangeEvents(h,y))}))}serializeStorageChangeEvents(y,a){const h=new Map,f=new Set;return y.forEach(g=>{const w=a.get(g.key);typeof w=="string"?h.set(g.key,w):f.add(g.key)}),{changed:Array.from(h.entries()),deleted:Array.from(f.values())}}listen(y,a,h){switch(a){case"onDidChangeStorage":{const f=h.profile?(0,I.revive)(h.profile):void 0;if(!f)return this.onDidChangeApplicationStorageEmitter.event;let g=this.mapProfileToOnDidChangeProfileStorageEmitter.get(f.id);return g||(g=this._register(new n.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(f),g),this.mapProfileToOnDidChangeProfileStorageEmitter.set(f.id,g)),g.event}}throw new Error(`Event not found: ${a}`)}async call(y,a,h){const f=h.profile?(0,I.revive)(h.profile):void 0,g=(0,k.reviveIdentifier)(h.workspace),w=await this.withStorageInitialized(f,g);switch(a){case"getItems":return Array.from(w.items.entries());case"updateItems":{const d=h;if(d.insert)for(const[v,E]of d.insert)w.set(v,E);d.delete?.forEach(v=>w.delete(v));break}case"optimize":return w.optimize();case"isUsed":{const d=h.payload;if(typeof d=="string")return this.storageMainService.isUsed(d)}default:throw new Error(`Call not found: ${a}`)}}async withStorageInitialized(y,a){let h;a?h=this.storageMainService.workspaceStorage(a):y?h=this.storageMainService.profileStorage(y):h=this.storageMainService.applicationStorage;try{await h.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${a?"workspace":y?"profile":"application"} storage due to ${f}`)}return h}}e.StorageDatabaseChannel=C}),define(oe[42],ae([0,1,46,4,2,19,7,196,38,15,6,5,30,32,41,8,33,26,13]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=D,e.reviveProfile=t,e.toUserDataProfile=s;var b;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function D(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&C.URI.isUri(l.location)&&C.URI.isUri(l.globalStorageHome)&&C.URI.isUri(l.settingsResource)&&C.URI.isUri(l.keybindingsResource)&&C.URI.isUri(l.tasksResource)&&C.URI.isUri(l.snippetsHome)&&C.URI.isUri(l.extensionsResource))}e.IUserDataProfilesService=(0,h.createDecorator)("IUserDataProfilesService");function t(r,l){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:C.URI.revive(r.location).with({scheme:l}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:l}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:l}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:l}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:l}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:l}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:l}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:l}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function s(r,l,u,P,S,M){return{id:r,name:l,location:u,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:M&&S?.useDefaultFlags?.globalState?M.globalStorageHome:(0,k.joinPath)(u,"globalStorage"),settingsResource:M&&S?.useDefaultFlags?.settings?M.settingsResource:(0,k.joinPath)(u,"settings.json"),keybindingsResource:M&&S?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,k.joinPath)(u,"keybindings.json"),tasksResource:M&&S?.useDefaultFlags?.tasks?M.tasksResource:(0,k.joinPath)(u,"tasks.json"),snippetsHome:M&&S?.useDefaultFlags?.snippets?M.snippetsHome:(0,k.joinPath)(u,"snippets"),extensionsResource:M&&S?.useDefaultFlags?.extensions?M.extensionsResource:(0,k.joinPath)(u,"extensions.json"),cacheHome:(0,k.joinPath)(P,r),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let i=class extends I.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(l,u,P,S){super(),this.environmentService=l,this.fileService=u,this.uriIdentityService=P,this.logService=S,this.enabled=!0,this._onDidChangeProfiles=this._register(new o.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new o.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new o.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new o.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new w.ResourceMap,workspaces:new w.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,k.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(l){this.enabled!==l&&(this._profilesObject=void 0,this.enabled=l)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const l=this.createDefaultProfile(),u=[l];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,m.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}u.push(s((0,k.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags},l))}}catch(M){this.logService.error(M)}const P=new w.ResourceMap,S=new Map;if(u.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[T,L]of Object.entries(M.workspaces)){const A=C.URI.parse(T),_=u.find(B=>B.id===L);_&&P.set(A,_)}if(M.emptyWindows)for(const[T,L]of Object.entries(M.emptyWindows)){const A=u.find(_=>_.id===L);A&&S.set(T,A)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:u,workspaces:P,emptyWindows:S}}return this._profilesObject}createDefaultProfile(){const l=s("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",P=new RegExp(`${(0,p.escapeRegExpCharacters)(u)}\\s(\\d+)`);let S=0;for(const T of this.profiles){const L=P.exec(T.name),A=L?parseInt(L[1]):0;S=A>S?A:S}const M=`${u} ${S+1}`;return this.createProfile((0,n.hash)((0,E.generateUuid)()).toString(16),M,{transient:!0},l)}async createNamedProfile(l,u,P){return this.createProfile((0,n.hash)((0,E.generateUuid)()).toString(16),l,u,P)}async createProfile(l,u,P,S){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(l,u,P);return S&&await this.setProfileForWorkspace(S,M),M}async doCreateProfile(l,u,P){if(!(0,m.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.profileCreationPromises.get(u);return S||(S=(async()=>{try{if(this.profiles.find(A=>A.name===u||A.id===l))throw new Error(`Profile with ${u} name already exists`);const T=s(l,u,(0,k.joinPath)(this.profilesHome,l),this.profilesCacheHome,P,this.defaultProfile);await this.fileService.createFolder(T.location);const L=[];return this._onWillCreateProfile.fire({profile:T,join(A){L.push(A)}}),await v.Promises.settled(L),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,S)),S}async updateProfile(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(S=>S.id===l.id);if(!P)throw new Error(`Profile '${l.name}' does not exist`);return P=s(P.id,u.name??P.name,P.location,this.profilesCacheHome,{shortName:u.shortName??P.shortName,icon:u.icon===null?void 0:u.icon??P.icon,transient:u.transient??P.isTransient,useDefaultFlags:u.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[P]),P}async removeProfile(l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(S=>S.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const P=[];this._onWillRemoveProfile.fire({profile:u,join(S){P.push(S)}});try{await Promise.allSettled(P)}catch(S){this.logService.error(S)}for(const S of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(S)?.id&&this.profilesObject.emptyWindows.delete(S);for(const S of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(S)?.id&&this.profilesObject.workspaces.delete(S);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(S){(0,a.toFileOperationResult)(S)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(S)}}async setProfileForWorkspace(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(S=>S.id===u.id);if(!P)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(l,P)}unsetWorkspace(l,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(l,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const l=await this.fileService.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(P=>!this.uriIdentityService.extUri.isEqual(P.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const l=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.getWorkspace(l),P=C.URI.isUri(u)?this.profilesObject.workspaces.get(u):this.profilesObject.emptyWindows.get(u);return P||((0,g.isSingleFolderWorkspaceIdentifier)(l)?this.transientProfilesObject.folders.get(l.uri):(0,g.isWorkspaceIdentifier)(l)?this.transientProfilesObject.workspaces.get(l.configPath):this.transientProfilesObject.emptyWindows.get(l.id))}getWorkspace(l){return(0,g.isSingleFolderWorkspaceIdentifier)(l)?l.uri:(0,g.isWorkspaceIdentifier)(l)?l.configPath:l.id}isProfileAssociatedToWorkspace(l){return!!([...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location))||[...this.transientProfilesObject.folders.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,l.location)))}updateProfiles(l,u,P){const S=[...this.profiles,...l],M=[],T=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let L of S){if(L.isDefault||u.some(_=>L.id===_.id))continue;L=P.find(_=>L.id===_.id)??L;const A=T.find(_=>L.id===_.id);if(L.isTransient)this.transientProfilesObject.profiles.push(L);else{if(A){for(const[_,B]of this.transientProfilesObject.emptyWindows.entries())if(L.id===B.id){this.updateWorkspaceAssociation({id:_},L);break}for(const[_,B]of this.transientProfilesObject.workspaces.entries())if(L.id===B.id){this.updateWorkspaceAssociation({id:"",configPath:_},L);break}for(const[_,B]of this.transientProfilesObject.folders.entries())if(L.id===B.id){this.updateWorkspaceAssociation({id:"",uri:_},L);break}}M.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(l,u,P)}triggerProfilesChanges(l,u,P){this._onDidChangeProfiles.fire({added:l,removed:u,updated:P,all:this.profiles})}updateWorkspaceAssociation(l,u,P){if(P=u?.isTransient?!0:P,P)(0,g.isSingleFolderWorkspaceIdentifier)(l)?(this.transientProfilesObject.folders.delete(l.uri),u&&this.transientProfilesObject.folders.set(l.uri,u)):(0,g.isWorkspaceIdentifier)(l)?(this.transientProfilesObject.workspaces.delete(l.configPath),u&&this.transientProfilesObject.workspaces.set(l.configPath,u)):(this.transientProfilesObject.emptyWindows.delete(l.id),u&&this.transientProfilesObject.emptyWindows.set(l.id,u));else{this.updateWorkspaceAssociation(l,void 0,!0);const S=this.getWorkspace(l);C.URI.isUri(S)?(this.profilesObject.workspaces.delete(S),u&&this.profilesObject.workspaces.set(S,u)):(this.profilesObject.emptyWindows.delete(S),u&&this.profilesObject.emptyWindows.set(S,u)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const l={};for(const[P,S]of this.profilesObject.workspaces.entries())l[P.toString()]=S.id;const u={};for(const[P,S]of this.profilesObject.emptyWindows.entries())u[P.toString()]=S.id;this.saveStoredProfileAssociations({workspaces:l,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(l){const u={},P=this.createDefaultProfile();if(l.workspaces)for(const[M,T]of Object.entries(l.workspaces)){const L=C.URI.parse(T);u[M]=this.uriIdentityService.extUri.isEqual(L,P.location)?P.id:this.uriIdentityService.extUri.basename(L)}const S={};if(l.emptyWindows)for(const[M,T]of Object.entries(l.emptyWindows)){const L=C.URI.parse(T);S[M]=this.uriIdentityService.extUri.isEqual(L,P.location)?P.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:u,emptyWindows:S}}getStoredProfiles(){return[]}saveStoredProfiles(l){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(l){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=i,e.UserDataProfilesService=i=Pe([ne(0,y.IEnvironmentService),ne(1,a.IFileService),ne(2,d.IUriIdentityService),ne(3,f.ILogService)],i);class c extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(l){this.storedProfiles=l}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(l){this.storedProfileAssociations=l}}e.InMemoryUserDataProfilesService=c}),define(oe[87],ae([0,1,8,17,2,4,32,7,127,130,15,6,5,42,41,13,16,25]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class b extends Error{constructor(c,r){super(c),this.code=r}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let D=class extends I.Disposable{constructor(c,r,l,u,P,S){super(),this.extensionsLocation=c,this.fileService=r,this.userDataProfilesService=l,this.uriIdentityService=u,this.telemetryService=P,this.logService=S,this._onAddExtensions=this._register(new k.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new k.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new k.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new k.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(c,r){return this.withProfileExtensions(c,void 0,r)}async addExtensionsToProfile(c,r,l){const u=[],P=[];try{return await this.withProfileExtensions(r,S=>{const M=[];if(l)M.push(...S);else for(const T of S)c.some(([L])=>(0,a.areSameExtensions)(L.identifier,T.identifier)&&L.manifest.version!==T.version)?u.push(T):M.push(T);for(const[T,L]of c){const A=M.findIndex(B=>(0,a.areSameExtensions)(B.identifier,T.identifier)&&B.version===T.manifest.version),_={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:L};A===-1?(P.push(_),M.push(_)):M.splice(A,1,_)}return P.length&&this._onAddExtensions.fire({extensions:P,profileLocation:r}),u.length&&this._onRemoveExtensions.fire({extensions:u,profileLocation:r}),M}),P.length&&this._onDidAddExtensions.fire({extensions:P,profileLocation:r}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,profileLocation:r}),P}catch(S){throw P.length&&this._onDidAddExtensions.fire({extensions:P,error:S,profileLocation:r}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,error:S,profileLocation:r}),S}}async updateMetadata(c,r){const l=[];return await this.withProfileExtensions(r,u=>{const P=[];for(const S of u){const M=c.find(([T])=>(0,a.areSameExtensions)(T.identifier,S.identifier)&&T.manifest.version===S.version);M&&(S.metadata={...S.metadata,...M[1]},l.push(S)),P.push(S)}return P}),l}async removeExtensionFromProfile(c,r){const l=[];try{await this.withProfileExtensions(r,u=>{const P=[];for(const S of u)(0,a.areSameExtensions)(S.identifier,c.identifier)?l.push(S):P.push(S);return l.length&&this._onRemoveExtensions.fire({extensions:l,profileLocation:r}),P}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,profileLocation:r})}catch(u){throw l.length&&this._onDidRemoveExtensions.fire({extensions:l,error:u,profileLocation:r}),u}}async withProfileExtensions(c,r,l){return this.getResourceAccessQueue(c).queue(async()=>{let u=[],P;try{const S=await this.fileService.readFile(c);P=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,h.toFileOperationResult)(S)!==h.FileOperationResult.FILE_NOT_FOUND)throw S;if(this.uriIdentityService.extUri.isEqual(c,this.userDataProfilesService.defaultProfile.extensionsResource)&&(P=await this.migrateFromOldDefaultProfileExtensionsLocation()),!P&&l?.bailOutWhenFileNotFound)throw new b((0,E.getErrorMessage)(S),m.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.reportAndThrowInvalidConentError(c);let S=!1;for(const M of P){t(M)||this.reportAndThrowInvalidConentError(c);let T;if((0,v.isString)(M.relativeLocation)&&M.relativeLocation)T=this.resolveExtensionLocation(M.relativeLocation);else if((0,v.isString)(M.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${M.location}`);continue}else{T=R.URI.revive(M.location);const L=this.toRelativePath(T);L&&(S=!0,M.relativeLocation=L)}(0,v.isUndefined)(M.metadata?.hasPreReleaseVersion)&&M.metadata?.preRelease&&(S=!0,M.metadata.hasPreReleaseVersion=!0),u.push({identifier:M.identifier,location:T,version:M.version,metadata:M.metadata})}S&&await this.fileService.writeFile(c,o.VSBuffer.fromString(JSON.stringify(P)))}if(r){u=r(u);const S=u.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(c,o.VSBuffer.fromString(JSON.stringify(S)))}return u})}reportAndThrowInvalidConentError(c){const r=new b(`Invalid extensions content in ${c.toString()}`,m.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}toRelativePath(c){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c),this.extensionsLocation)?this.uriIdentityService.extUri.basename(c):void 0}resolveExtensionLocation(c){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,c)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const c=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),r=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let l;try{l=(await this.fileService.readFile(c)).value.toString()}catch(P){if((0,h.toFileOperationResult)(P)===h.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.logService.info("Migrating extensions from old default profile location",c.toString());let u;try{const P=JSON.parse(l);Array.isArray(P)&&P.every(S=>t(S))?u=P:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.logService.error(P)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,o.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",c.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(P){if((0,h.toFileOperationResult)(P)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",c.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw P}try{await this.fileService.del(c)}catch(P){(0,h.toFileOperationResult)(P)!==h.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(P)}try{await this.fileService.del(r)}catch(P){(0,h.toFileOperationResult)(P)!==h.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(P)}return u})()),this._migrationPromise}getResourceAccessQueue(c){let r=this.resourcesAccessQueueMap.get(c);return r||(r=new n.Queue,this.resourcesAccessQueueMap.set(c,r)),r}};e.AbstractExtensionsProfileScannerService=D,e.AbstractExtensionsProfileScannerService=D=Pe([ne(1,h.IFileService),ne(2,w.IUserDataProfilesService),ne(3,d.IUriIdentityService),ne(4,p.ITelemetryService),ne(5,g.ILogService)],D);function t(i){return(0,v.isObject)(i)&&(0,y.isIExtensionIdentifier)(i.identifier)&&(s(i.location)||(0,v.isString)(i.location)&&i.location)&&((0,v.isUndefined)(i.relativeLocation)||(0,v.isString)(i.relativeLocation))&&i.version&&(0,v.isString)(i.version)}function s(i){return i?(0,v.isString)(i.path)&&(0,v.isString)(i.scheme):!1}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[134],ae([0,1,22,8,36,17,16,43,157,2,12,10,3,19,248,81,13,7,177,38,130,86,247,15,6,5,28,4,83,87,42,41,209]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=se,I=ke(I),f=ke(f),g=ke(g),d=ke(d),v=et(v);var A;(function(le){function K(ee,q){if(ee===q)return!0;const O=Object.keys(ee),x=new Set;for(const j of Object.keys(q))x.add(j);if(O.length!==x.size)return!1;for(const j of O){if(ee[j]!==q[j])return!1;x.delete(j)}return x.size===0}le.equals=K})(A||(e.Translations=A={})),e.IExtensionsScannerService=(0,c.createDecorator)("IExtensionsScannerService");let _=class extends a.Disposable{constructor(K,ee,q,O,x,j,ce,G,de,re,Z,W){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ee,this.extensionsControlLocation=q,this.currentProfile=O,this.userDataProfilesService=x,this.extensionsProfileScannerService=j,this.fileService=ce,this.logService=G,this.environmentService=de,this.productService=re,this.uriIdentityService=Z,this.instantiationService=W,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(t.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(t.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,D.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,ee,q){const[O,x]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ee)]),j=q?await this.scanExtensionsUnderDevelopment(K,[...O,...x]):[];return this.dedupExtensions(O,x,j,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ee=[];ee.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),ee.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[q,O]=await Promise.all(ee);return this.applyScanOptions([...q,...O],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ee=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",ee);const q=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,O=await this.createExtensionScannerInput(ee,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,q,K.productVersion??this.getProductVersion()),x=K.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let j;try{j=await x.scanExtensions(O)}catch(ce){if(ce instanceof S.ExtensionsProfileScanningError&&ce.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),j=await x.scanExtensions(O);else throw ce}return j=await this.applyScanOptions(j,t.ExtensionType.User,K,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(K,ee){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(O=>O.scheme===h.Schemas.file).map(async O=>{const x=await this.createExtensionScannerInput(O,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(x)).map(ce=>(ce.type=ee.find(G=>(0,D.areSameExtensions)(G.identifier,ce.identifier))?.type??ce.type,this.extensionsScanner.validate(ce,x)))}))).flat();return this.applyScanOptions(q,"development",K,!0)}return[]}async scanExistingExtension(K,ee,q){const O=await this.createExtensionScannerInput(K,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),x=await this.extensionsScanner.scanExtension(O);return!x||!q.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(K,ee,q){const O=await this.createExtensionScannerInput(K,!1,ee,!0,q.language,!0,void 0,q.productVersion??this.getProductVersion()),x=await this.extensionsScanner.scanOneOrMultipleExtensions(O);return this.applyScanOptions(x,ee,q,!0)}async scanMultipleExtensions(K,ee,q){const O=[];return await Promise.all(K.map(async x=>{const j=await this.scanOneOrMultipleExtensions(x,ee,q);O.push(...j)})),this.applyScanOptions(O,ee,q,!0)}async scanMetadata(K){const ee=(0,w.joinPath)(K,"package.json"),q=(await this.fileService.readFile(ee)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(K,ee){const q=(0,w.joinPath)(K,"package.json"),O=(await this.fileService.readFile(q)).value.toString(),x=JSON.parse(O);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,x.__metadata={...x.__metadata,...ee},await this.fileService.writeFile((0,w.joinPath)(K,"package.json"),k.VSBuffer.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof S.ExtensionsProfileScanningError&&K.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(ee=>[ee,ee.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(ee){(0,i.toFileOperationResult)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(ee))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,ee,q,O){return q.includeAllVersions||(K=this.dedupExtensions(ee===t.ExtensionType.System?K:void 0,ee===t.ExtensionType.User?K:void 0,ee==="development"?K:void 0,await this.getTargetPlatform(),O)),q.includeInvalid||(K=K.filter(x=>x.isValid)),K.sort((x,j)=>{const ce=f.basename(x.location.fsPath),G=f.basename(j.location.fsPath);return ce<G?-1:ce>G?1:0})}dedupExtensions(K,ee,q,O,x){const j=(G,de,re)=>{if(G.isValid&&!de.isValid)return!1;if(G.isValid===de.isValid){if(x&&d.gt(G.manifest.version,de.manifest.version))return this.logService.debug(`Skipping extension ${de.location.path} with lower version ${de.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(d.eq(G.manifest.version,de.manifest.version)){if(G.type===t.ExtensionType.System)return this.logService.debug(`Skipping extension ${de.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===O)return this.logService.debug(`Skipping extension ${de.location.path} from different target platform ${de.targetPlatform}`),!1}}return re?this.logService.warn(`Overwriting user extension ${G.location.path} with ${de.location.path}.`):this.logService.debug(`Overwriting user extension ${G.location.path} with ${de.location.path}.`),!0},ce=new t.ExtensionIdentifierMap;return K?.forEach(G=>{const de=ce.get(G.identifier.id);(!de||j(de,G,!1))&&ce.set(G.identifier.id,G)}),ee?.forEach(G=>{const de=ce.get(G.identifier.id);if(!de&&K&&G.type===t.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!de||j(de,G,!1))&&ce.set(G.identifier.id,G)}),q?.forEach(G=>{const de=ce.get(G.identifier.id);(!de||j(de,G,!0))&&ce.set(G.identifier.id,G),ce.set(G.identifier.id,G)}),[...ce.values()]}async scanDefaultSystemExtensions(K,ee){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ee,!0,void 0,this.getProductVersion()),x=await(K&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",x.length),x}async scanDevSystemExtensions(K,ee){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const O=ee?await this.getBuiltInExtensionControl():{},x=[],j=p.URI.file(f.normalize(f.join(h.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of q){const de=O[G.name]||"marketplace";switch(de){case"disabled":break;case"marketplace":x.push((0,w.joinPath)(j,G.name));break;default:x.push(p.URI.file(de));break}}const ce=await Promise.all(x.map(async G=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(G,!1,t.ExtensionType.System,!0,K,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ce.length),(0,n.coalesce)(ce)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,ee,q,O,x,j,ce,G){const de=await this.getTranslations(x??g.language),re=await this.getMtime(K),Z=ee&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,W=Z?await this.getMtime(Z):void 0;return new B(K,re,Z,W,ee,ce,q,O,j,G.version,G.date,this.productService.commit,!this.environmentService.isBuilt,x,de)}async getMtime(K){try{const ee=await this.fileService.stat(K);if(typeof ee.mtime=="number")return ee.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=_,e.AbstractExtensionsScannerService=_=Pe([ne(4,M.IUserDataProfilesService),ne(5,S.IExtensionsProfileScannerService),ne(6,i.IFileService),ne(7,r.ILogService),ne(8,b.IEnvironmentService),ne(9,l.IProductService),ne(10,T.IUriIdentityService),ne(11,c.IInstantiationService)],_);class B{constructor(K,ee,q,O,x,j,ce,G,de,re,Z,W,F,U,H){this.location=K,this.mtime=ee,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=O,this.profile=x,this.profileScanOptions=j,this.type=ce,this.excludeObsolete=G,this.validate=de,this.productVersion=re,this.productDate=Z,this.productCommit=W,this.devMode=F,this.language=U,this.translations=H}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ee){return(0,w.isEqual)(K.location,ee.location)&&K.mtime===ee.mtime&&(0,w.isEqual)(K.applicationExtensionslocation,ee.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&K.profile===ee.profile&&I.equals(K.profileScanOptions,ee.profileScanOptions)&&K.type===ee.type&&K.excludeObsolete===ee.excludeObsolete&&K.validate===ee.validate&&K.productVersion===ee.productVersion&&K.productDate===ee.productDate&&K.productCommit===ee.productCommit&&K.devMode===ee.devMode&&K.language===ee.language&&A.equals(K.translations,ee.translations)}}e.ExtensionScannerInput=B;let N=class extends a.Disposable{constructor(K,ee,q,O,x,j){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=ee,this.uriIdentityService=q,this.fileService=O,this.logService=j,this.extensionsEnabledWithApiProposalVersion=x.extensionsEnabledWithApiProposalVersion?.map(ce=>ce.toLowerCase())??[]}async scanExtensions(K){const ee=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let q={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const O=(await this.fileService.readFile(this.obsoleteFile)).value.toString();q=JSON.parse(O)}catch{}return(0,E.isEmptyObject)(q)?ee:ee.filter(O=>!q[D.ExtensionKey.create(O).toString()])}async scanExtensionsFromLocation(K){const ee=await this.fileService.resolve(K.location);if(!ee.children?.length)return[];const q=await Promise.all(ee.children.map(async O=>{if(!O.isDirectory||K.type===t.ExtensionType.User&&(0,w.basename)(O.resource).indexOf(".")===0)return null;const x=new B(O.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(x)}));return(0,n.coalesce)(q).sort((O,x)=>O.location.path<x.location.path?-1:1)}async scanExtensionsFromProfile(K){let ee=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){ee=ee.filter(O=>!O.metadata?.isApplicationScoped);const q=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,O=>!!O.metadata?.isBuiltin||!!O.metadata?.isApplicationScoped,K);ee.push(...q)}return ee}async scanExtensionsFromProfileResource(K,ee,q){const O=await this.extensionsProfileScannerService.scanProfileExtensions(K,q.profileScanOptions);if(!O.length)return[];const x=await Promise.all(O.map(async j=>{if(ee(j)){const ce=new B(j.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ce,j.metadata)}return null}));return(0,n.coalesce)(x)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,w.joinPath)(K.location,"package.json"))){const ee=await this.scanExtension(K);return ee?[ee]:[]}else return await this.scanExtensions(K)}catch(ee){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,C.getErrorMessage)(ee)),[]}}async scanExtension(K,ee){try{let q=await this.scanExtensionManifest(K.location);if(q){q.publisher||(q.publisher=t.UNDEFINED_PUBLISHER),ee=ee??q.__metadata,delete q.__metadata;const O=(0,D.getGalleryExtensionId)(q.publisher,q.name),x=ee?.id?{id:O,uuid:ee.id}:{id:O},j=ee?.isSystem?t.ExtensionType.System:K.type,ce=j===t.ExtensionType.System||!!ee?.isBuiltin;q=await this.translateManifest(K.location,q,B.createNlsConfiguration(K));let G={type:j,identifier:x,manifest:q,location:K.location,isBuiltin:ce,targetPlatform:ee?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return K.validate&&(G=this.validate(G,K)),q.enabledApiProposals&&this.extensionsEnabledWithApiProposalVersion.includes(O.toLowerCase())&&(q.enabledApiProposals=(0,t.parseEnabledApiProposalNames)([...q.enabledApiProposals])),G}}catch(q){K.type!==t.ExtensionType.System&&this.logService.error(q)}return null}validate(K,ee){let q=!0;const O=this.extensionsEnabledWithApiProposalVersion.includes(K.identifier.id.toLowerCase()),x=(0,s.validateExtensionManifest)(ee.productVersion,ee.productDate,ee.location,K.manifest,K.isBuiltin,O);for(const[j,ce]of x)j===v.default.Error&&(q=!1,this.logService.error(this.formatMessage(ee.location,ce)));return K.isValid=q,K.validations=x,K}async scanExtensionManifest(K){const ee=(0,w.joinPath)(K,"package.json");let q;try{q=(await this.fileService.readFile(ee)).value.toString()}catch(x){return(0,i.toFileOperationResult)(x)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(K,(0,m.localize)(0,null,ee.path,x.message))),null}let O;try{O=JSON.parse(q)}catch{const j=[];(0,R.parse)(q,j);for(const ce of j)this.logService.error(this.formatMessage(K,(0,m.localize)(1,null,ee.path,ce.offset,ce.length,(0,y.getParseErrorMessage)(ce.error))));return null}return(0,R.getNodeType)(O)!=="object"?(this.logService.error(this.formatMessage(K,(0,m.localize)(2,null,ee.path))),null):O}async translateManifest(K,ee,q){const O=await this.getLocalizedMessages(K,ee,q);if(O)try{const x=[],j=await this.resolveOriginalMessageBundle(O.default,x);if(x.length>0)return x.forEach(G=>{this.logService.error(this.formatMessage(K,(0,m.localize)(3,null,O.default?.path,(0,y.getParseErrorMessage)(G.error))))}),ee;if((0,R.getNodeType)(O)!=="object")return this.logService.error(this.formatMessage(K,(0,m.localize)(4,null,O.default?.path))),ee;const ce=O.values||Object.create(null);return(0,L.localizeManifest)(this.logService,ee,ce,j)}catch{}return ee}async getLocalizedMessages(K,ee,q){const O=(0,w.joinPath)(K,"package.nls.json"),x=(de,re)=>{re.forEach(Z=>{this.logService.error(this.formatMessage(K,(0,m.localize)(5,null,de?.path,(0,y.getParseErrorMessage)(Z.error))))})},j=de=>{this.logService.error(this.formatMessage(K,(0,m.localize)(6,null,de?.path)))},ce=`${ee.publisher}.${ee.name}`,G=q.translations[ce];if(G)try{const de=p.URI.file(G),re=(await this.fileService.readFile(de)).value.toString(),Z=[],W=(0,R.parse)(re,Z);return Z.length>0?(x(de,Z),{values:void 0,default:O}):(0,R.getNodeType)(W)!=="object"?(j(de),{values:void 0,default:O}):{values:W.contents?W.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.fileService.exists(O))return;let re;try{re=await this.findMessageBundles(K,q)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const Z=(await this.fileService.readFile(re.localized)).value.toString(),W=[],F=(0,R.parse)(Z,W);return W.length>0?(x(re.localized,W),{values:void 0,default:re.original}):(0,R.getNodeType)(F)!=="object"?(j(re.localized),{values:void 0,default:re.original}):{values:F,default:re.original}}catch{return{values:void 0,default:re.original}}}}async resolveOriginalMessageBundle(K,ee){if(K)try{const q=(await this.fileService.readFile(K)).value.toString();return(0,R.parse)(q,ee)}catch{}}findMessageBundles(K,ee){return new Promise((q,O)=>{const x=j=>{const ce=(0,w.joinPath)(K,`package.nls.${j}.json`);this.fileService.exists(ce).then(G=>{G&&q({localized:ce,original:(0,w.joinPath)(K,"package.nls.json")});const de=j.lastIndexOf("-");de===-1?q({localized:(0,w.joinPath)(K,"package.nls.json"),original:null}):(j=j.substring(0,de),x(j))})};if(ee.devMode||ee.pseudo||!ee.language)return q({localized:(0,w.joinPath)(K,"package.nls.json"),original:null});x(ee.language)})}formatMessage(K,ee){return`[${K.path}]: ${ee}`}};N=Pe([ne(1,S.IExtensionsProfileScannerService),ne(2,T.IUriIdentityService),ne(3,i.IFileService),ne(4,l.IProductService),ne(5,r.ILogService)],N);let z=class extends N{constructor(K,ee,q,O,x,j,ce,G){super(ee,O,x,j,ce,G),this.currentProfile=K,this.userDataProfilesService=q,this.cacheValidatorThrottler=this._register(new o.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const ee=this.getCacheFile(K),q=await this.readExtensionCache(ee);if(this.input=K,q&&q.input&&B.equals(q.input,this.input))return this.logService.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(x=>(x.location=p.URI.revive(x.location),x));const O=await super.scanExtensions(K);return await this.writeExtensionCache(ee,{input:K,result:O}),O}async readExtensionCache(K){try{const ee=await this.fileService.readFile(K),q=JSON.parse(ee.value.toString());return{result:q.result,input:(0,P.revive)(q.input)}}catch(ee){this.logService.debug("Error while reading the extension cache file:",K.path,(0,C.getErrorMessage)(ee))}return null}async writeExtensionCache(K,ee){try{await this.fileService.writeFile(K,k.VSBuffer.fromString(JSON.stringify(ee)))}catch(q){this.logService.debug("Error while writing the extension cache file:",K.path,(0,C.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),ee=await this.readExtensionCache(K);if(!ee)return;const q=ee.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(O,q))try{this.logService.info("Invalidating Cache",q,O),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}getCacheFile(K){const ee=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(ee.cacheHome,K.type===t.ExtensionType.System?t.BUILTIN_MANIFEST_CACHE_FILE:t.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===t.ExtensionType.System?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(ee=>this.uriIdentityService.extUri.isEqual(K.location,ee.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=Pe([ne(2,M.IUserDataProfilesService),ne(3,S.IExtensionsProfileScannerService),ne(4,T.IUriIdentityService),ne(5,i.IFileService),ne(6,l.IProductService),ne(7,r.ILogService)],z);function se(le,K){const ee=(0,D.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:ee,identifier:new t.ExtensionIdentifier(ee),isBuiltin:le.type===t.ExtensionType.System,isUserBuiltin:le.type===t.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class J extends _{constructor(K,ee,q,O,x,j,ce,G,de,re,Z,W){super(K,ee,(0,w.joinPath)(q,".vscode-oss-dev","extensions","control.json"),O,x,j,ce,G,de,re,Z,W),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const F=await this.fileService.readFile(p.URI.file(g.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(oe[282],ae([0,1,5,42,41,25,87,15,38,7]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let h=class extends C.AbstractExtensionsProfileScannerService{constructor(g,w,d,v,E,p){super(a.URI.file(g.extensionsPath),w,d,v,E,p)}};e.ExtensionsProfileScannerService=h,e.ExtensionsProfileScannerService=h=Pe([ne(0,y.INativeEnvironmentService),ne(1,R.IFileService),ne(2,o.IUserDataProfilesService),ne(3,I.IUriIdentityService),ne(4,k.ITelemetryService),ne(5,n.ILogService)],h)}),define(oe[283],ae([0,1,7,38,87,134,15,6,5,28,41,42]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends k.NativeExtensionsScannerService{constructor(d,v,E,p,m,b,D,t){super(n.URI.file(m.builtinExtensionsPath),n.URI.file(m.extensionsPath),m.userHome,d.defaultProfile,d,v,E,p,m,b,D,t)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=Pe([ne(0,f.IUserDataProfilesService),ne(1,I.IExtensionsProfileScannerService),ne(2,C.IFileService),ne(3,y.ILogService),ne(4,o.INativeEnvironmentService),ne(5,a.IProductService),ne(6,h.IUriIdentityService),ne(7,R.IInstantiationService)],g)}),define(oe[284],ae([0,1,14,2,12,10,3,61,7,33,35,38,5,42]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends o.Disposable{constructor(E,p,m){super(),this.environmentService=E,this.logService=m,this.validRoots=R.TernarySearchTree.forPaths(!C.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(E.appRoot),this.addValidFileRoot(E.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.with({scheme:I.Schemas.file}).fsPath),this.addValidFileRoot(E.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:E}=n.session;E.protocol.registerFileProtocol(I.Schemas.vscodeFileResource,(p,m)=>this.handleResourceRequest(p,m)),E.protocol.interceptFileProtocol(I.Schemas.file,(p,m)=>this.handleFileRequest(p,m)),this._register((0,o.toDisposable)(()=>{E.protocol.unregisterProtocol(I.Schemas.vscodeFileResource),E.protocol.uninterceptProtocol(I.Schemas.file)}))}addValidFileRoot(E){const p=(0,k.normalize)(E);return this.validRoots.get(p)?o.Disposable.None:(this.validRoots.set(p,!0),(0,o.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(E,p){const m=y.URI.parse(E.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${I.Schemas.file}: protocol (original URL: ${E.url})`),p({error:-3})}handleResourceRequest(E,p){const m=this.requestToNormalizedFilePath(E);let b;return this.environmentService.crossOriginIsolated&&((0,k.basename)(m)==="workbench.html"||(0,k.basename)(m)==="workbench-dev.html"?b=I.COI.CoopAndCoep:b=I.COI.getHeadersFromQuery(E.url)),this.validRoots.findSubstr(m)?p({path:m,headers:b}):this.validExtensions.has((0,k.extname)(m).toLowerCase())?p({path:m}):(this.logService.error(`${I.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${I.Schemas.vscodeFileResource}: protocol (original URL: ${E.url})`),p({error:-3}))}requestToNormalizedFilePath(E){const p=y.URI.parse(E.url),m=I.FileAccess.uriToFileUri(p);return(0,k.normalize)(m.fsPath)}createIPCObjectUrl(){let E;const p=y.URI.from({scheme:"vscode",path:(0,a.generateUuid)()}),m=p.toString(),b=async()=>E;return h.validatedIpcMain.handle(m,b),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:p,update:D=>E=D,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),h.validatedIpcMain.removeHandler(m)}}}};e.ProtocolMainService=d,e.ProtocolMainService=d=Pe([ne(0,f.INativeEnvironmentService),ne(1,w.IUserDataProfilesService),ne(2,g.ILogService)],d)}),define(oe[63],ae([0,1,8,4,2,71,13,120,6,42]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=w,e.isProfileUsingDefaultStorage=v,e.logStorage=p,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,y.createDecorator)("storageService");var h;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var f;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function w(m){const b=m.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}class d extends I.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(b={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new o.PauseableEmitter),this._onDidChangeTarget=this._register(new o.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new o.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(b,D,t){return o.Event.filter(this._onDidChangeValue.event,s=>s.scope===b&&(D===void 0||s.key===D),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,D){const{key:t,external:s}=D;if(t===e.TARGET_KEY){switch(b){case f.APPLICATION:this._applicationKeyTargets=void 0;break;case f.PROFILE:this._profileKeyTargets=void 0;break;case f.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:t,target:this.getKeyTargets(b)[t],external:s})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,D,t){return this.getStorage(D)?.get(b,t)}getBoolean(b,D,t){return this.getStorage(D)?.getBoolean(b,t)}getNumber(b,D,t){return this.getStorage(D)?.getNumber(b,t)}getObject(b,D,t){return this.getStorage(D)?.getObject(b,t)}storeAll(b,D){this.withPausedEmitters(()=>{for(const t of b)this.store(t.key,t.value,t.scope,t.target,D)})}store(b,D,t,s,i=!1){if((0,C.isUndefinedOrNull)(D)){this.remove(b,t,i);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,t,s),this.getStorage(t)?.set(b,D,i)})}remove(b,D,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(b,D,void 0),this.getStorage(D)?.delete(b,t)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,D){const t=[],s=this.getKeyTargets(b);for(const i of Object.keys(s))s[i]===D&&t.push(i);return t}updateKeyTarget(b,D,t,s=!1){const i=this.getKeyTargets(D);typeof t=="number"?i[b]!==t&&(i[b]=t,this.getStorage(D)?.set(e.TARGET_KEY,JSON.stringify(i),s)):typeof i[b]=="number"&&(delete i[b],this.getStorage(D)?.set(e.TARGET_KEY,JSON.stringify(i),s))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(f.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(f.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(f.APPLICATION)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case f.APPLICATION:return this.applicationKeyTargets;case f.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const D=this.getStorage(b);return D?w(D):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=h.NONE){this._onWillSaveState.fire({reason:b});const D=this.getStorage(f.APPLICATION),t=this.getStorage(f.PROFILE),s=this.getStorage(f.WORKSPACE);switch(b){case h.NONE:await n.Promises.settled([D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await n.Promises.settled([D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(f.APPLICATION)?.items??new Map,D=this.getStorage(f.PROFILE)?.items??new Map,t=this.getStorage(f.WORKSPACE)?.items??new Map;return p(b,D,t,this.getLogDetails(f.APPLICATION)??"",this.getLogDetails(f.PROFILE)??"",this.getLogDetails(f.WORKSPACE)??"")}async optimize(b){return await this.flush(),this.getStorage(b)?.optimize()}async switch(b,D){return this.emitWillSaveState(h.NONE),(0,a.isUserDataProfile)(b)?this.switchToProfile(b,D):this.switchToWorkspace(b,D)}canSwitchProfile(b,D){return!(b.id===D.id||v(D)&&v(b))}switchData(b,D,t){this.withPausedEmitters(()=>{const s=new Set;for(const[i,c]of b)s.add(i),D.get(i)!==c&&this.emitDidChangeValue(t,{key:i,external:!0});for(const[i]of D.items)s.has(i)||this.emitDidChangeValue(t,{key:i,external:!0})})}}e.AbstractStorageService=d;function v(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class E extends d{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(f.WORKSPACE,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(f.PROFILE,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(f.APPLICATION,b)))}getStorage(b){switch(b){case f.APPLICATION:return this.applicationStorage;case f.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case f.APPLICATION:return"inMemory (application)";case f.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(b){return!1}}e.InMemoryStorageService=E;async function p(m,b,D,t,s,i){const c=A=>{try{return JSON.parse(A)}catch{return A}},r=new Map,l=new Map;m.forEach((A,_)=>{r.set(_,A),l.set(_,c(A))});const u=new Map,P=new Map;b.forEach((A,_)=>{u.set(_,A),P.set(_,c(A))});const S=new Map,M=new Map;D.forEach((A,_)=>{S.set(_,A),M.set(_,c(A))}),console.group(t!==s?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(r.forEach((A,_)=>{T.push({key:_,value:A})}),console.table(T),console.groupEnd(),console.log(l),t!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const A=[];u.forEach((_,B)=>{A.push({key:B,value:_})}),console.table(A),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${i})`);const L=[];S.forEach((A,_)=>{L.push({key:_,value:A})}),console.table(L),console.groupEnd(),console.log(M)}}),define(oe[285],ae([0,1,17,33,63]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=k;async function k(C,R,y){let a=y&&y.get("storage.serviceMachineId",I.StorageScope.APPLICATION)||null;if(a)return a;try{const f=(await R.readFile(C.serviceMachineIdResource)).value.toString();a=(0,o.isUUID)(f)?f:null}catch{a=null}if(!a){a=(0,o.generateUuid)();try{await R.writeFile(C.serviceMachineIdResource,n.VSBuffer.fromString(a))}catch{}}return y?.store("storage.serviceMachineId",a,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),a}}),define(oe[286],ae([0,1,285,25,58]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=k;async function k(C,R,y,a,h,f,g){const w={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${R.nameShort})`};if((0,I.supportsTelemetry)(R,y)&&(0,I.getTelemetryLevel)(a)===o.TelemetryLevel.USAGE){const d=await(0,n.getServiceMachineId)(y,h,f);w["X-Market-User-Id"]=d,w["VSCode-SessionId"]=g.machineId||d}return w}}),define(oe[287],ae([0,1,22,8,4,2,10,67,7,21,120,166,5,63,25,30,12]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class p extends k.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(c,r){super(),this.logService=c,this.fileService=r,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new I.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new h.Storage(new h.InMemoryStorageDatabase,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new o.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=h.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===h.StorageState.None)try{const c=this._register(await this.doCreate());this._storage.dispose(),this._storage=c,this._register(c.onDidChangeStorage(l=>this._onDidChangeStorage.fire(l))),await this.doInit(c);const r=c.getBoolean(w.IS_NEW_KEY);r===void 0?c.set(w.IS_NEW_KEY,!0):r&&c.set(w.IS_NEW_KEY,!1)}catch(c){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.state=h.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?c=>this.logService.trace(c):void 0,logError:c=>this.logService.error(c)}}doInit(c){return c.init()}get items(){return this._storage.items}get(c,r){return this._storage.get(c,r)}set(c,r){return this._storage.set(c,r)}delete(c){return this._storage.delete(c)}optimize(){return this._storage.optimize()}async close(){const c=new R.StopWatch(!1);await this.doClose(),c.stop(),c.elapsed()>p.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(c),this._onDidCloseStorage.fire()}async logSlowClose(c){if(this.path)try{const r=(0,n.top)(Array.from(this._storage.items.entries()).map(([u,P])=>({key:u,length:P.length})),(u,P)=>P.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),l=(await this.fileService.stat(y.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${l}b, Large Keys: ${r}`)}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=h.StorageState.Closed,await this._storage.close()}}class m extends p{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,C.join)(this.profile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,m.STORAGE_NAME)}constructor(c,r,l,u){super(l,u),this.profile=c,this.options=r}async doCreate(){return new h.Storage(new f.SQLiteStorageDatabase(this.path??f.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class b extends m{constructor(c,r,l,u){super(c,r,l,u)}}e.ProfileStorageMain=b;class D extends m{constructor(c,r,l,u){super(r.defaultProfile,c,l,u)}async doInit(c){await super.doInit(c),this.updateTelemetryState(c)}updateTelemetryState(c){c.get(d.firstSessionDateStorageKey,void 0)===void 0&&c.set(d.firstSessionDateStorageKey,new Date().toUTCString());const l=c.get(d.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();c.set(d.lastSessionDateStorageKey,typeof l>"u"?null:l),c.set(d.currentSessionDateStorageKey,u)}}e.ApplicationStorageMain=D;class t extends p{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,C.join)(this.environmentService.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.workspace.id,t.WORKSPACE_STORAGE_NAME)}constructor(c,r,l,u,P){super(l,P),this.workspace=c,this.options=r,this.environmentService=u}async doCreate(){const{storageFilePath:c,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new h.Storage(new f.SQLiteStorageDatabase(c,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:r?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,C.join)(this.environmentService.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.workspace.id),r=(0,C.join)(c,t.WORKSPACE_STORAGE_NAME);return await a.Promises.exists(c)?{storageFilePath:r,wasCreated:!1}:(await a.Promises.mkdir(c,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(c),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(c){let r;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const l=(0,C.join)(c,t.WORKSPACE_META_NAME);await a.Promises.exists(l)||await a.Promises.writeFile(l,JSON.stringify(r,void 0,2))}catch(l){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=t;class s extends p{get path(){}async doCreate(){return new h.Storage(new h.InMemoryStorageDatabase,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=s}),define(oe[288],ae([0,1,4,2,63]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class k extends o.Disposable{constructor(R,y,a){super(),this.storageMainService=R,this.userDataProfilesService=y,this.logService=a;const h=this._register(new o.MutableDisposable);this._onDidChange=this._register(new n.Emitter({onWillAddFirstListener:()=>h.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>h.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const R=new o.DisposableStore;return R.add(n.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(y,a)=>(y?y.push(a.key):y=[a.key],y),100)(y=>this.onDidChangeApplicationStorage(y))),R.add(n.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(y,a)=>{y||(y=new Map);let h=y.get(a.profile.id);return h||y.set(a.profile.id,h={profile:a.profile,keys:[],storage:a.storage}),h.keys.push(a.key),y},100)(y=>this.onDidChangeProfileStorage(y))),R}onDidChangeApplicationStorage(R){const y=R.includes(I.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],a=[];if(R=R.filter(h=>h!==I.TARGET_KEY),R.length){const h=(0,I.loadKeyTargets)(this.storageMainService.applicationStorage.storage);a.push({profile:this.userDataProfilesService.defaultProfile,changes:R.map(f=>({key:f,scope:I.StorageScope.PROFILE,target:h[f]}))})}this.triggerEvents(y,a)}onDidChangeProfileStorage(R){const y=[],a=new Map;for(const[h,f]of R.entries()){f.keys.includes(I.TARGET_KEY)&&y.push(f.profile);const g=f.keys.filter(w=>w!==I.TARGET_KEY);if(g.length){const w=(0,I.loadKeyTargets)(f.storage.storage);a.set(h,{profile:f.profile,changes:g.map(d=>({key:d,scope:I.StorageScope.PROFILE,target:w[d]}))})}}this.triggerEvents(y,[...a.values()])}triggerEvents(R,y){(R.length||y.length)&&this._onDidChange.fire({valueChanges:y,targetChanges:R})}listen(R,y,a){switch(y){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${y}`)}async call(R,y){throw new Error(`Call not found: ${y}`)}}e.ProfileStorageChangesListenerChannel=k}),define(oe[289],ae([0,1,7,38,15,5,34,41,42,13,128]),function(V,e,n,o,I,k,C,R,y,a,h){"use strict";var f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let w=class extends y.UserDataProfilesService{static{f=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(p,m,b,D,t){super(b,D,m,t),this.stateReadonlyService=p,this.nativeEnvironmentService=b}getStoredProfiles(){return this.stateReadonlyService.getItem(f.PROFILES_KEY,[]).map(m=>({...m,location:(0,a.isString)(m.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,m.location):n.URI.revive(m.location)}))}getStoredProfileAssociations(){const p=this.stateReadonlyService.getItem(f.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(f.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?p:this.migrateStoredProfileAssociations(p)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(n.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=w,e.UserDataProfilesReadonlyService=w=f=Pe([ne(0,C.IStateReadService),ne(1,R.IUriIdentityService),ne(2,o.INativeEnvironmentService),ne(3,I.IFileService),ne(4,k.ILogService)],w);let d=g=class extends w{constructor(p,m,b,D,t){super(p,m,b,D,t),this.stateService=p}saveStoredProfiles(p){p.length?this.stateService.setItem(g.PROFILES_KEY,p.map(m=>({...m,location:this.uriIdentityService.extUri.basename(m.location)}))):this.stateService.removeItem(g.PROFILES_KEY)}getStoredProfiles(){const p=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(p),this.stateService.setItem("userDataProfilesMigration",!0)),p}saveStoredProfileAssociations(p){p.emptyWindows||p.workspaces?this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,p):this.stateService.removeItem(g.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const p="workspaceAndProfileInfo",m=this.stateService.getItem(p,void 0);if(m){this.stateService.removeItem(p);const D=m.reduce((t,{workspace:s,profile:i})=>(t[n.URI.revive(s).toString()]=n.URI.revive(i).toString(),t),{});this.stateService.setItem(g.PROFILE_ASSOCIATIONS_KEY,{workspaces:D})}const b=super.getStoredProfileAssociations();return this.stateService.getItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(b),this.stateService.setItem(g.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),b}};e.UserDataProfilesService=d,e.UserDataProfilesService=d=g=Pe([ne(0,C.IStateService),ne(1,R.IUriIdentityService),ne(2,o.INativeEnvironmentService),ne(3,I.IFileService),ne(4,k.ILogService)],d);let v=class extends d{constructor(p,m,b,D){super(new h.StateService(h.SaveStrategy.IMMEDIATE,m,D,b),p,m,b,D)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=v,e.ServerUserDataProfilesService=v=Pe([ne(0,R.IUriIdentityService),ne(1,o.INativeEnvironmentService),ne(2,I.IFileService),ne(3,k.ILogService)],v)}),define(oe[59],ae([0,1,38,15,6,5,41,42,289,34]),function(V,e,n,o,I,k,C,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,I.refineServiceDecorator)(R.IUserDataProfilesService);let h=class extends y.UserDataProfilesService{constructor(g,w,d,v,E){super(g,w,d,v,E)}getAssociatedEmptyWindows(){const g=[];for(const w of this.profilesObject.emptyWindows.keys())g.push({id:w});return g}};e.UserDataProfilesMainService=h,e.UserDataProfilesMainService=h=Pe([ne(0,a.IStateService),ne(1,C.IUriIdentityService),ne(2,n.INativeEnvironmentService),ne(3,o.IFileService),ne(4,k.ILogService)],h)}),define(oe[135],ae([0,1,19,7,30]),function(V,e,n,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=k,e.findWindowOnWorkspaceOrFolder=C,e.findWindowOnExtensionDevelopmentPath=R;async function k(y,a,h){for(const g of y){const w=g.openedWorkspace;if((0,I.isWorkspaceIdentifier)(w)){const d=await h(w);if(d){if(d.folders.some(v=>n.extUriBiasedIgnorePathCase.isEqualOrParent(a,v.uri)))return g}else if(n.extUriBiasedIgnorePathCase.isEqualOrParent(a,w.configPath))return g}}const f=y.filter(g=>(0,I.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqualOrParent(a,g.openedWorkspace.uri));if(f.length)return f.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function C(y,a){for(const h of y)if((0,I.isWorkspaceIdentifier)(h.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(h.openedWorkspace.configPath,a)||(0,I.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(h.openedWorkspace.uri,a))return h}function R(y,a){const h=f=>a.some(g=>n.extUriBiasedIgnorePathCase.isEqual(o.URI.file(g),o.URI.file(f)));for(const f of y)if(f.config?.extensionDevelopmentPath?.some(g=>h(g)))return f}}),define(oe[103],ae([0,1,31,43,108,48,12,10,3,19,7,6,75,30]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=d,e.isRecentFolder=v,e.isRecentFile=E,e.isStoredWorkspaceFolder=p,e.getStoredWorkspaceFolder=D,e.toWorkspaceFolders=s,e.rewriteWorkspaceFileForNewLocation=i,e.restoreRecentlyOpened=P,e.toStoreData=S,o=ke(o),I=ke(I),e.IWorkspacesService=(0,f.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}function v(M){return M.hasOwnProperty("folderUri")}function E(M){return M.hasOwnProperty("fileUri")}function p(M){return m(M)||b(M)}function m(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function b(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function D(M,T,L,A,_){if(M.scheme!==A.scheme)return{name:L,uri:M.toString(!0)};let B=T?void 0:_.relativePath(A,M);if(B!==void 0)B.length===0?B=".":y.isWindows&&(B=t(B));else if(M.scheme===C.Schemas.file)B=M.fsPath,y.isWindows&&(B=t(B));else if(_.isEqualAuthority(M.authority,A.authority))B=M.path;else return{name:L,uri:M.toString(!0)};return{name:L,path:B}}function t(M){return M=(0,k.normalizeDriveLetter)(M),(0,n.isUNC)(M)||(M=(0,n.toSlashes)(M)),M}function s(M,T,L){const A=[],_=new Set,B=L.dirname(T);for(const N of M){let z;if(m(N))N.path&&(z=L.resolvePath(B,N.path));else if(b(N))try{z=h.URI.parse(N.uri),z.path[0]!==R.posix.sep&&(z=z.with({path:R.posix.sep+z.path}))}catch(se){console.warn(se)}if(z){const se=L.getComparisonKey(z);if(!_.has(se)){_.add(se);const J=N.name||L.basenameOrAuthority(z);A.push(new w.WorkspaceFolder({uri:z,name:J,index:A.length},N))}}}return A}function i(M,T,L,A,_){const B=c(T,M),N=_.dirname(T),z=_.dirname(A),se=[];for(const ee of B.folders){const q=m(ee)?_.resolvePath(N,ee.path):h.URI.parse(ee.uri);let O;L?O=!1:O=!m(ee)||(0,R.isAbsolute)(ee.path),se.push(D(q,O,ee.name,z,_))}const J={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},le=I.setProperty(M,["folders"],se,J);let K=I.applyEdits(M,le);return(0,a.isEqualAuthority)(B.remoteAuthority,(0,g.getRemoteAuthority)(A))&&(K=I.applyEdits(K,I.removeProperty(K,["remoteAuthority"],J))),K}function c(M,T){const L=o.parse(T);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(A=>p(A));else throw new Error(`${M} looks like an invalid workspace file.`);return L}function r(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function l(M){return typeof M.folderUri=="string"}function u(M){return typeof M.fileUri=="string"}function P(M,T){const L={workspaces:[],files:[]};if(M){const A=function(B,N){for(let z=0;z<B.length;z++)try{N(B[z],z)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(B[z])}: ${se.toString()}. Skip entry.`)}},_=M;Array.isArray(_.entries)&&A(_.entries,B=>{const N=B.label,z=B.remoteAuthority;r(B)?L.workspaces.push({label:N,remoteAuthority:z,workspace:{id:B.workspace.id,configPath:h.URI.parse(B.workspace.configPath)}}):l(B)?L.workspaces.push({label:N,remoteAuthority:z,folderUri:h.URI.parse(B.folderUri)}):u(B)&&L.files.push({label:N,remoteAuthority:z,fileUri:h.URI.parse(B.fileUri)})})}return L}function S(M){const T={entries:[]};for(const L of M.workspaces)v(L)?T.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):T.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of M.files)T.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return T}}),define(oe[104],ae([0,1,92,12,3,19]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=C,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=y,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(a){function h(){let f=a.scheme===o.Schemas.file?(0,k.originalFSPath)(a):a.toString();return I.isLinux||(f=f.toLowerCase()),(0,n.createHash)("md5").update(f).digest("hex")}return{id:h(),configPath:a}}function R(a,h){function f(){if(a.scheme!==o.Schemas.file)return(0,n.createHash)("md5").update(a.toString()).digest("hex");if(!h)return;let w;return I.isLinux?w=h.ino:I.isMacintosh?w=h.birthtime.getTime():I.isWindows&&(typeof h.birthtimeMs=="number"?w=Math.floor(h.birthtimeMs):w=h.birthtime.getTime()),(0,n.createHash)("md5").update(a.fsPath).update(w?String(w):"").digest("hex")}const g=f();if(typeof g=="string")return{id:g,uri:a}}function y(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[105],ae([0,1,92,93,27,290,17,16,4,2,10,3,33,44,118]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=r,e.createStaticIPCHandle=l,e.serve=S,e.connect=M;const v=3e4;class E{traceSocketEvent(L,A){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,A)}constructor(L,A=""){this._canWrite=!0,this.debugLabel=A,this.socket=L,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=B=>{if(this.traceSocketEvent(d.SocketDiagnosticsEventType.Error,{code:B?.code,message:B?.message}),B){if(B.code==="EPIPE")return;(0,R.onUnexpectedError)(B)}},this.socket.on("error",this._errorListener);let _;this._closeListener=B=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Close,{hadError:B}),this._canWrite=!1,_&&clearTimeout(_)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,_=setTimeout(()=>L.destroy(),v)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(L){const A=_=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Read,_),L(C.VSBuffer.wrap(_))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(L){const A=_=>{L({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:_,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(L){const A=()=>{L()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(L){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(d.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}}end(){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=E;var p;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var m;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(m||(m={}));class b extends a.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,A){this.socket.traceSocketEvent(L,A)}constructor(L,A,_,B){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:m.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:_?.byteLength||0,recordInflateBytes:B}),this._flowManager=this._register(new D(this,A,_,B,this._onData,(N,z)=>this._write(N,z))),this._register(this._flowManager.onError(N=>{console.error(N),(0,R.onUnexpectedError)(N),this._onClose.fire({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this._incomingData=new d.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let A=0;for(;A<L.byteLength;)this._flowManager.writeMessage(L.slice(A,Math.min(A+p.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),A+=p.MaxWebSocketMessageLength}_write(L,{compressed:A,opcode:_}){if(this._isEnded)return;this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let B=p.MinHeaderByteSize;L.byteLength<126?B+=0:L.byteLength<2**16?B+=2:B+=8;const N=C.VSBuffer.alloc(B),z=A?64:0,se=_&15;if(N.writeUInt8(128|z|se,0),L.byteLength<126)N.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){N.writeUInt8(126,1);let J=1;N.writeUInt8(L.byteLength>>>8&255,++J),N.writeUInt8(L.byteLength>>>0&255,++J)}else{N.writeUInt8(127,1);let J=1;N.writeUInt8(0,++J),N.writeUInt8(0,++J),N.writeUInt8(0,++J),N.writeUInt8(0,++J),N.writeUInt8(L.byteLength>>>24&255,++J),N.writeUInt8(L.byteLength>>>16&255,++J),N.writeUInt8(L.byteLength>>>8&255,++J),N.writeUInt8(L.byteLength>>>0&255,++J)}this.socket.write(C.VSBuffer.concat([N,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===m.PeekHeader){const A=this._incomingData.peek(this._state.readLen),_=A.readUInt8(0),B=(_&128)>>>7,N=(_&64)>>>6,z=_&15,se=A.readUInt8(1),J=(se&128)>>>7,le=se&127;this._state.state=m.ReadHeader,this._state.readLen=p.MinHeaderByteSize+(J?4:0)+(le===126?2:0)+(le===127?8:0),this._state.fin=B,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!B,this._state.mask=0,this._state.opcode=z,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===m.ReadHeader){const A=this._incomingData.read(this._state.readLen),_=A.readUInt8(1),B=(_&128)>>>7;let N=_&127,z=1;N===126?N=A.readUInt8(++z)*2**8+A.readUInt8(++z):N===127&&(N=A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*0+A.readUInt8(++z)*2**24+A.readUInt8(++z)*2**16+A.readUInt8(++z)*2**8+A.readUInt8(++z));let se=0;B&&(se=A.readUInt8(++z)*2**24+A.readUInt8(++z)*2**16+A.readUInt8(++z)*2**8+A.readUInt8(++z)),this._state.state=m.ReadBody,this._state.readLen=N,this._state.mask=se,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===m.ReadBody){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,A),i(A,this._state.mask),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,A),this._state.state=m.PeekHeader,this._state.readLen=p.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=b;class D extends a.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}constructor(L,A,_,B,N,z){super(),this._tracer=L,this._onData=N,this._writeFn=z,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new t(this._tracer,B,_,{windowBits:15})),this._zlibDeflateStream=this._register(new s(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(se=>this._onError.fire(se))),this._register(this._zlibDeflateStream.onError(se=>this._onError.fire(se)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(L,A){this._writeQueue.push({data:L,options:A}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:L,options:A}=this._writeQueue.shift();if(this._zlibDeflateStream&&A.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(_,A)}else this._writeFn(L,{...A,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,A){return new Promise((_,B)=>{L.write(A),L.flush(N=>_(N))})}acceptFrame(L,A,_){this._readQueue.push({data:L,isCompressed:A,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(L,A,_){return new Promise((B,N)=>{L.write(A),_&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(z=>B(z))})}}class t extends a.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}constructor(L,A,_,B){super(),this._tracer=L,this._recordInflateBytes=A,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,k.createInflateRaw)(B),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateData,N),this._pendingInflateData.push(C.VSBuffer.wrap(N))}),_&&(this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialWrite,_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateWrite,L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateFlushFired);const A=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(A)})}}class s extends a.Disposable{constructor(L,A){super(),this._tracer=L,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,k.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateError,{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateData,_),this._pendingDeflateData.push(C.VSBuffer.wrap(_))})}write(L){this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateFlushFired);let A=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),L(A)})}}function i(T,L){if(L===0)return;const A=T.byteLength>>>2;for(let J=0;J<A;J++){const le=T.readUInt32BE(J*4);T.writeUInt32BE(le^L,J*4)}const _=A*4,B=T.byteLength-_,N=L>>>24&255,z=L>>>16&255,se=L>>>8&255;B>=1&&T.writeUInt8(T.readUInt8(_)^N,_),B>=2&&T.writeUInt8(T.readUInt8(_+1)^z,_+1),B>=3&&T.writeUInt8(T.readUInt8(_+2)^se,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[f.Platform.Linux]:107,[f.Platform.Mac]:103};function r(){const T=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const L=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,I.tmpdir)(),A=(0,h.join)(L,`vscode-ipc-${T}.sock`);return u(A),A}function l(T,L,A){const B=(0,n.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${A}-${L}-sock`;const N=A.substr(0,4),z=L.substr(0,6);let se;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?se=(0,h.join)(e.XDG_RUNTIME_DIR,`vscode-${B}-${N}-${z}.sock`):se=(0,h.join)(T,`${N}-${z}.sock`),u(se),se}function u(T){const L=c[f.platform];typeof L=="number"&&T.length>=L&&console.warn(`WARNING: IPC handle "${T}" is longer than ${L} chars, try a shorter --user-data-dir`)}class P extends w.IPCServer{static toClientConnectionEvent(L){const A=y.Event.fromNodeEventEmitter(L,"connection");return y.Event.map(A,_=>({protocol:new d.Protocol(new E(_,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(_,"close"))}))}constructor(L){super(P.toClientConnectionEvent(L)),this.server=L}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=P;function S(T){return new Promise((L,A)=>{const _=(0,o.createServer)();_.on("error",A),_.listen(T,()=>{_.removeListener("error",A),L(new P(_))})})}function M(T,L){return new Promise((A,_)=>{const B=(0,o.createConnection)(T,()=>{B.removeListener("error",_),A(d.Client.fromSocket(new E(B,`ipc-client${L}`),L))});B.once("error",_)})}}),define(oe[24],ae([0,1,54,10,3,105,38,96,6]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(C.IEnvironmentService);class a extends R.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,o.join)(this.userDataPath,"clp")}get backupHome(){return(0,o.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,o.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(I.isLinux){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const g=f.slice(0,-17);if(this._snapEnv[g])continue;process.env[g]&&(this._snapEnv[g]=process.env[g]),process.env[f]?process.env[g]=process.env[f]:delete process.env[g]}}}restoreSnapExportedVariables(){if(I.isLinux)for(const f in this._snapEnv)process.env[f]=this._snapEnv[f],delete this._snapEnv[f]}}e.EnvironmentMainService=a,Pe([n.memoize],a.prototype,"cachedLanguagesPath",null),Pe([n.memoize],a.prototype,"backupHome",null),Pe([n.memoize],a.prototype,"mainIPCHandle",null),Pe([n.memoize],a.prototype,"mainLockfile",null),Pe([n.memoize],a.prototype,"disableUpdates",null),Pe([n.memoize],a.prototype,"crossOriginIsolated",null),Pe([n.memoize],a.prototype,"codeCachePath",null),Pe([n.memoize],a.prototype,"useCodeCache",null)}),define(oe[291],ae([0,1,92,31,12,10,3,19,21,203,18,24,34,15,5,202,30,104]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{static{m=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(t,s,i,c){this.environmentMainService=t,this.configurationService=s,this.logService=i,this.stateService=c,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=R.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,l)=>(0,o.isEqual)(r,l,!C.isLinux)}}async initialize(){const t=this.stateService.getItem(m.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(t.emptyWindows),this.workspaces=await this.validateWorkspaces((0,a.deserializeWorkspaceInfos)(t)),this.folders=await this.validateFolders((0,a.deserializeFolderInfos)(t)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==w.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===w.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||w.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(t,s){this.workspaces.some(c=>t.workspace.id===c.workspace.id)||(this.workspaces.push(t),this.storeWorkspacesMetadata());const i=(0,k.join)(this.backupHome,t.workspace.id);return s?this.moveBackupFolder(i,s).then(()=>i):i}async moveBackupFolder(t,s){if(await y.Promises.exists(t)&&await this.convertToEmptyWindowBackup(t),await y.Promises.exists(s))try{await y.Promises.rename(s,t,!1)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.folders.some(s=>this.backupUriComparer.isEqual(t.folderUri,s.folderUri))||(this.folders.push(t),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,this.getFolderHash(t))}registerEmptyWindowBackup(t){return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,t.backupFolder))||(this.emptyWindows.push(t),this.storeWorkspacesMetadata()),(0,k.join)(this.backupHome,t.backupFolder)}async validateWorkspaces(t){if(!Array.isArray(t))return[];const s=new Set,i=[];for(const c of t){const r=c.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!s.has(r.id)){s.add(r.id);const l=(0,k.join)(this.backupHome,r.id);await this.doHasBackups(l)?r.configPath.scheme!==I.Schemas.file||await y.Promises.exists(r.configPath.fsPath)?i.push(c):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return i}async validateFolders(t){if(!Array.isArray(t))return[];const s=[],i=new Set;for(const c of t){const r=c.folderUri,l=this.backupUriComparer.getComparisonKey(r);if(!i.has(l)){i.add(l);const u=(0,k.join)(this.backupHome,this.getFolderHash(c));await this.doHasBackups(u)?r.scheme!==I.Schemas.file||await y.Promises.exists(r.fsPath)?s.push(c):await this.convertToEmptyWindowBackup(u):await this.deleteStaleBackup(u)}}return s}async validateEmptyWorkspaces(t){if(!Array.isArray(t))return[];const s=[],i=new Set;for(const c of t){const r=c.backupFolder;if(typeof r!="string")return[];if(!i.has(r)){i.add(r);const l=(0,k.join)(this.backupHome,r);await this.doHasBackups(l)?s.push(c):await this.deleteStaleBackup(l)}}return s}async deleteStaleBackup(t){try{await y.Promises.rm(t,y.RimRafMode.MOVE)}catch(s){this.logService.error(`Backup: Could not delete stale backup: ${s.toString()}`)}}prepareNewEmptyWindowBackup(){let t=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,t.id));)t=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:t.id}}async convertToEmptyWindowBackup(t){const s=this.prepareNewEmptyWindowBackup(),i=(0,k.join)(this.backupHome,s.backupFolder);try{await y.Promises.rename(t,i,!1)}catch(c){return this.logService.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.emptyWindows.push(s),!0}async getDirtyWorkspaces(){const t=[];for(const s of this.workspaces)await this.hasBackups(s)&&t.push(s);for(const s of this.folders)await this.hasBackups(s)&&t.push(s);return t}hasBackups(t){let s;return(0,a.isEmptyWindowBackupInfo)(t)?s=(0,k.join)(this.backupHome,t.backupFolder):(0,v.isFolderBackupInfo)(t)?s=(0,k.join)(this.backupHome,this.getFolderHash(t)):s=(0,k.join)(this.backupHome,t.workspace.id),this.doHasBackups(s)}async doHasBackups(t){try{const s=await y.Promises.readdir(t);for(const i of s)try{if((await y.Promises.readdir((0,k.join)(t,i))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const t={workspaces:this.workspaces.map(({workspace:s,remoteAuthority:i})=>{const c={id:s.id,configURIPath:s.configPath.toString()};return i&&(c.remoteAuthority=i),c}),folders:this.folders.map(({folderUri:s,remoteAuthority:i})=>{const c={folderUri:s.toString()};return i&&(c.remoteAuthority=i),c}),emptyWindows:this.emptyWindows.map(({backupFolder:s,remoteAuthority:i})=>{const c={backupFolder:s};return i&&(c.remoteAuthority=i),c})};this.stateService.setItem(m.backupWorkspacesMetadataStorageKey,t)}getFolderHash(t){const s=t.folderUri;let i;return s.scheme===I.Schemas.file?i=C.isLinux?s.fsPath:s.fsPath.toLowerCase():i=s.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.BackupMainService=b,e.BackupMainService=b=m=Pe([ne(0,f.IEnvironmentMainService),ne(1,h.IConfigurationService),ne(2,d.ILogService),ne(3,g.IStateService)],b)}),define(oe[20],ae([0,1,14,35,8,4,2,3,37,13,6,5,34,52,24]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,h.createDecorator)("lifecycleMainService");var E;(function(b){b[b.QUIT=1]="QUIT",b[b.KILL=2]="KILL"})(E||(e.ShutdownReason=E={}));var p;(function(b){b[b.Starting=1]="Starting",b[b.Ready=2]="Ready",b[b.AfterWindowOpen=3]="AfterWindowOpen",b[b.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let m=class extends C.Disposable{static{v=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(D,t,s){super(),this.logService=D,this.stateService=t,this.environmentMainService=s,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=p.Starting,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(p.Ready).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(v.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(v.QUIT_AND_RESTART_KEY)}registerListeners(){const D=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),R.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(E.QUIT))};n.app.addListener("before-quit",D);const t=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!R.isMacintosh)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",s=>{this.trace("Lifecycle#app.on(will-quit) - begin"),s.preventDefault(),this.fireOnWillShutdown(E.QUIT).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),n.app.removeListener("before-quit",D),n.app.removeListener("window-all-closed",t),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}fireOnWillShutdown(D){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const t=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const s=[];return this._onWillShutdown.fire({reason:D,join(i,c){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),s.push(c.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await I.Promises.settled(s)}catch(i){this.logService.error(i)}try{await this.stateService.close()}catch(i){this.logService.error(i)}})(),this.pendingWillShutdownPromise}set phase(D){if(D<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===D)return;this.trace(`lifecycle (main): phase changed (value: ${D})`),this._phase=D;const t=this.phaseWhen.get(this._phase);t&&(t.open(),this.phaseWhen.delete(this._phase))}async when(D){if(D<=this._phase)return;let t=this.phaseWhen.get(D);t||(t=new I.Barrier,this.phaseWhen.set(D,t)),await t.wait()}registerWindow(D){const t=new C.DisposableStore;this.windowCounter++,t.add(D.onWillLoad(i=>this._onWillLoadWindow.fire({window:D,workspace:i.workspace,reason:i.reason})));const s=(0,a.assertIsDefined)(D.win);t.add(k.Event.fromNodeEventEmitter(s,"close")(i=>{const c=D.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.trace(`Lifecycle#window.on('close') - window ID ${D.id}`),i.preventDefault(),this.unload(D,w.UnloadReason.CLOSE).then(r=>{if(r){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(D),D.close()})})),t.add(k.Event.fromNodeEventEmitter(s,"closed")(()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${D.id}`),this.windowCounter--,t.dispose(),this.windowCounter===0&&(!R.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(E.QUIT)}))}registerAuxWindow(D){const t=(0,a.assertIsDefined)(D.win),s=new C.DisposableStore;s.add(k.Event.fromNodeEventEmitter(t,"close")(i=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${D.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),s.add(k.Event.fromNodeEventEmitter(t,"closed")(()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${D.id}`),s.dispose()}))}async reload(D,t){await this.unload(D,w.UnloadReason.RELOAD)||D.reload(t)}unload(D,t){const s=this.mapWindowIdToPendingUnload.get(D.id);if(s)return s;const i=this.doUnload(D,t).finally(()=>{this.mapWindowIdToPendingUnload.delete(D.id)});return this.mapWindowIdToPendingUnload.set(D.id,i),i}async doUnload(D,t){if(!D.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${D.id}`);const s=this._quitRequested?w.UnloadReason.QUIT:t,i=await this.onBeforeUnloadWindowInRenderer(D,s);return i?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${D.id})`),this.handleWindowUnloadVeto(i)):(await this.onWillUnloadWindowInRenderer(D,s),!1)}handleWindowUnloadVeto(D){return D?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(D){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(D),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(D,t){return new Promise(s=>{const i=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${i}`,r=`vscode:cancel${i}`;o.validatedIpcMain.once(c,()=>{s(!1)}),o.validatedIpcMain.once(r,()=>{s(!0)}),D.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:r,reason:t})})}onWillUnloadWindowInRenderer(D,t){return new Promise(s=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;o.validatedIpcMain.once(c,()=>s()),D.send("vscode:onWillUnload",{replyChannel:c,reason:t})})}quit(D){return this.doQuit(D).then(t=>{if(!t&&D)try{if(R.isWindows){const s=(0,y.cwd)();s!==process.cwd()&&process.chdir(s)}}catch(s){this.logService.error(s)}return t})}doQuit(D){return this.trace(`Lifecycle#quit() - begin (willRestart: ${D})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(D&&this.stateService.setItem(v.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(t=>{this.pendingQuitPromiseResolve=t,this.trace("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.pendingQuitPromise)}trace(D){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(D):this.logService.trace(D)}setRelaunchHandler(D){this.relaunchHandler=D}async relaunch(D){this.trace("Lifecycle#relaunch()");const t=process.argv.slice(1);if(D?.addArgs&&t.push(...D.addArgs),D?.removeArgs)for(const c of D.removeArgs){const r=t.indexOf(c);r>=0&&t.splice(r,1)}const s=()=>{this.relaunchHandler?.handleRelaunch(D)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",s),await this.quit(!0)&&n.app.removeListener("quit",s)}async kill(D){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(E.KILL),await Promise.race([(0,I.timeout)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let s;t.webContents&&!t.webContents.isDestroyed()?s=new Promise(i=>t.once("closed",i)):s=Promise.resolve(),t.destroy(),await s}})()]),n.app.exit(D)}};e.LifecycleMainService=m,e.LifecycleMainService=m=v=Pe([ne(0,f.ILogService),ne(1,g.IStateService),ne(2,d.IEnvironmentMainService)],m)}),define(oe[292],ae([0,1,3,4,2,6,20]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,n=ke(n),e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let R=class extends I.Disposable{constructor(h){super(),this._onDidChangeKeyboardLayout=this._register(new o.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,h.when(C.LifecycleMainPhase.AfterWindowOpen).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const h=await new Promise((f,g)=>{V(["native-keymap"],f,g)}).then(ke);this._keyboardLayoutData=y(h),n.isCI||h.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=y(h),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=R,e.KeyboardLayoutMainService=R=Pe([ne(0,C.ILifecycleMainService)],R);function y(a){const h=a.getKeyMap(),f=a.getCurrentKeyboardLayout();return{keyboardMapping:h,keyboardLayoutInfo:f}}}),define(oe[293],ae([0,1,253,8,17,16,13,18,38,101,5,57,252,290]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=E;let d=class extends f.AbstractRequestService{constructor(m,b,D,t){super(t),this.configurationService=m,this.environmentService=b,this.logService=D,this.configure(),this._register(m.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.configure()}))}configure(){const m=this.configurationService.getValue("http");this.proxyUrl=m?.proxy,this.strictSSL=!!m?.proxyStrictSSL,this.authorization=m?.proxyAuthorization}async request(m,b){const{proxyUrl:D,strictSSL:t}=this;let s;try{s=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,k.getErrorMessage)(r)))}const i={...process.env,...s},c=m.agent?m.agent:await(0,g.getProxyAgent)(m.url||"",i,{proxyUrl:D,strictSSL:t});return m.agent=c,m.strictSSL=t,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(m.isChromiumNetwork?"electron":"node",m,()=>E(m,b))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((b,D)=>{V(["@vscode/proxy-agent"],b,D)}).then(ke)).loadSystemCertificates({log:this.logService})}};e.RequestService=d,e.RequestService=d=Pe([ne(0,R.IConfigurationService),ne(1,y.INativeEnvironmentService),ne(2,h.ILogService),ne(3,h.ILoggerService)],d);async function v(p){return((0,n.parse)(p.url).protocol==="https:"?await new Promise((D,t)=>{V(["https"],D,t)}).then(ke):await new Promise((D,t)=>{V(["http"],D,t)}).then(ke)).request}async function E(p,m){return o.Promises.withAsyncBody(async(b,D)=>{const t=(0,n.parse)(p.url),s=p.getRawRequest?p.getRawRequest(p):await v(p),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,C.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(i.auth=p.user+":"+p.password);const c=s(i,r=>{const l=(0,C.isNumber)(p.followRedirects)?p.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&l>0&&r.headers.location)E({...p,url:r.headers.location,followRedirects:l-1},m).then(b,D);else{let u=r;!p.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,w.createGunzip)())),b({res:r,stream:(0,I.streamToBufferReadableStream)(u)})}});c.on("error",D),p.timeout&&c.setTimeout(p.timeout),p.isChromiumNetwork&&c.removeHeader("Content-Length"),p.data&&typeof p.data=="string"&&c.write(p.data),c.end(),m.onCancellationRequested(()=>{c.abort(),D(new k.CancellationError)})})}}),define(oe[294],ae([0,1,14,293]),function(V,e,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function I(C){return n.net.request}class k extends o.RequestService{request(R,y){return super.request({...R||{},getRawRequest:I,isChromiumNetwork:!0},y)}}e.RequestMainService=k}),define(oe[88],ae([0,1,7,4,2,38,15,6,20,5,63,287,42,59,41,12]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,R.createDecorator)("storageMainService");let E=class extends I.Disposable{constructor(b,D,t,s,i,c){super(),this.logService=b,this.environmentService=D,this.userDataProfilesService=t,this.lifecycleMainService=s,this.fileService=i,this.uriIdentityService=c,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new o.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(y.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,D]of this.mapProfileToStorage)b.join("profileStorage",D.close());for(const[,D]of this.mapWorkspaceToStorage)b.join("workspaceStorage",D.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const D=this.mapProfileToStorage.get(b.profile.id);D&&b.join(D.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new f.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(o.Event.once(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),b}profileStorage(b){if((0,h.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let D=this.mapProfileToStorage.get(b.id);if(!D){this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),D=this._register(this.createProfileStorage(b)),this.mapProfileToStorage.set(b.id,D);const t=this._register(D.onDidChangeStorage(s=>this._onDidChangeProfileStorage.fire({...s,storage:D,profile:b})));this._register(o.Event.once(D.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id),t.dispose()}))}return D}createProfileStorage(b){return this.shutdownReason===y.ShutdownReason.KILL?new f.InMemoryStorageMain(this.logService,this.fileService):new f.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let D=this.mapWorkspaceToStorage.get(b.id);return D||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),D=this._register(this.createWorkspaceStorage(b)),this.mapWorkspaceToStorage.set(b.id,D),this._register(o.Event.once(D.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)}))),D}createWorkspaceStorage(b){return this.shutdownReason===y.ShutdownReason.KILL?new f.InMemoryStorageMain(this.logService,this.fileService):new f.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(b){const D=n.URI.file(b);for(const t of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(t.path&&this.uriIdentityService.extUri.isEqualOrParent(n.URI.file(t.path),D))return!0;return!1}};e.StorageMainService=E,e.StorageMainService=E=Pe([ne(0,a.ILogService),ne(1,k.IEnvironmentService),ne(2,w.IUserDataProfilesMainService),ne(3,y.ILifecycleMainService),ne(4,C.IFileService),ne(5,d.IUriIdentityService)],E),e.IApplicationStorageMainService=(0,R.createDecorator)("applicationStorageMainService");let p=class extends h.AbstractStorageService{constructor(b,D){super(),this.userDataProfilesService=b,this.storageMainService=D,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===h.StorageScope.APPLICATION)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===h.StorageScope.APPLICATION)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=p,e.ApplicationStorageMainService=p=Pe([ne(0,g.IUserDataProfilesService),ne(1,e.IStorageMainService)],p)}),define(oe[295],ae([0,1,93,27,112,105,8,2,3,18,5,28,246,249,102,132,17]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,n=ke(n),o=ke(o);async function p(s,i,c,r,l){let u;for(let P=3;P&&(u?.dispose(),u=await new m(s,i,c,r,l).waitForReady(),!(l&&I.BROWSER_RESTRICTED_PORTS[l]||!I.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));P--);return u}class m extends R.Disposable{constructor(i,c,r,l,u){super(),this.defaultTunnelHost=c,this.suggestedLocalPort=u,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=i,this._server=n.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=P=>this._onConnection(P),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){const i=this.suggestedLocalPort??this.tunnelRemotePort,c=(0,v.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,I.findFreePortFaster)(i,2,1e3,c),l=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(i){i.pause();const c=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,g.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),l=r.getSocket(),u=r.readEntireBuffer();r.dispose(),u.byteLength>0&&i.write(u.buffer),i.on("end",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),l.end()}),i.on("close",()=>l.end()),i.on("error",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),l instanceof k.NodeSocket?l.socket.destroy():l.end()}),l instanceof k.NodeSocket?this._mirrorNodeSocket(i,l):this._mirrorGenericSocket(i,l),i.localAddress&&this._socketsDispose.set(i.localAddress,()=>{i.end(),l.end()})}_mirrorGenericSocket(i,c){c.onClose(()=>i.destroy()),c.onEnd(()=>i.end()),c.onData(r=>i.write(r.buffer)),i.on("data",r=>c.write(E.VSBuffer.wrap(r))),i.resume()}_mirrorNodeSocket(i,c){const r=c.socket;r.on("end",()=>i.end()),r.on("close",()=>i.end()),r.on("error",()=>{i.destroy()}),r.pipe(i),i.pipe(r)}}e.NodeRemoteTunnel=m;let b=class extends v.AbstractTunnelService{constructor(i,c,r,l,u){super(c,u),this.remoteSocketFactoryService=i,this.signService=r,this.productService=l}isPortPrivileged(i){return(0,v.isPortPrivileged)(i,this.defaultTunnelHost,y.OS,o.release())}retainOrCreateTunnel(i,c,r,l,u,P,S,M){const T=this.getTunnelFromMap(c,r);if(T)return++T.refcount,T.value;if((0,v.isTunnelProvider)(i))return this.createWithProvider(i,c,r,u,P,S,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${r} on local port ${u}.`);const L={commit:this.productService.commit,quality:this.productService.quality,addressProvider:i,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},A=p(L,l,c,r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,r,A),A}}};e.BaseTunnelService=b,e.BaseTunnelService=b=Pe([ne(0,w.IRemoteSocketFactoryService),ne(1,h.ILogService),ne(2,d.ISignService),ne(3,f.IProductService),ne(4,a.IConfigurationService)],b);let D=class extends b{constructor(i,c,r,l,u){super(i,c,r,l,u)}};e.TunnelService=D,e.TunnelService=D=Pe([ne(0,w.IRemoteSocketFactoryService),ne(1,h.ILogService),ne(2,d.ISignService),ne(3,f.IProductService),ne(4,a.IConfigurationService)],D);let t=class extends R.Disposable{constructor(i,c,r,l,u){super(),this.remoteSocketFactoryService=i,this.logService=c,this.productService=r,this.signService=l,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(i,c,r,l,u,P,S,M,T){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${l} on local port ${P}.`),!this._tunnelServices.has(i)){const L=new D(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(L),this._tunnelServices.set(i,L),L.onTunnelClosed(async()=>{(await L.tunnels).length===0&&(L.dispose(),this._tunnelServices.delete(i))})}return this._tunnelServices.get(i).openTunnel(c,r,l,u,P,S,M,T)}};e.SharedTunnelsService=t,e.SharedTunnelsService=t=Pe([ne(0,w.IRemoteSocketFactoryService),ne(1,h.ILogService),ne(2,f.IProductService),ne(3,d.ISignService),ne(4,a.IConfigurationService)],t)}),define(oe[106],ae([0,1,8,23,4,18,24,20,5,28,57,50]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=g;function g(d,v,E){return`${E.updateUrl}/api/update/${d}/${v}/${E.commit}`}let w=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,E,p,m,b,D){this.lifecycleMainService=v,this.configurationService=E,this.environmentMainService=p,this.requestService=m,this.logService=b,this.productService=D,this._state=f.State.Uninitialized,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,v.when(R.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(f.State.Disabled(f.DisablementReason.NotBuilt));return}if(this.environmentMainService.disableUpdates){this.setState(f.State.Disabled(f.DisablementReason.DisabledByEnvironment)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(f.State.Disabled(f.DisablementReason.MissingConfiguration)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),E=this.getProductQuality(v);if(!E){this.setState(f.State.Disabled(f.DisablementReason.ManuallyDisabled)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.setState(f.State.Disabled(f.DisablementReason.InvalidConfiguration)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const p=new URL(this.url);p.searchParams.set("prss","true"),this.url=p.toString()}if(this.setState(f.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,n.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},o.CancellationToken.None)).res.statusCode===204}catch(E){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(E);return}}async _applySpecificUpdate(v){}getUpdateType(){return f.UpdateType.Archive}doQuitAndInstall(){}};e.AbstractUpdateService=w,e.AbstractUpdateService=w=Pe([ne(0,R.ILifecycleMainService),ne(1,k.IConfigurationService),ne(2,C.IEnvironmentMainService),ne(3,h.IRequestService),ne(4,y.ILogService),ne(5,a.IProductService)],w)}),define(oe[296],ae([0,1,14,54,4,46,2,18,24,20,5,28,57,25,50,106]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0,n=ke(n);let E=class extends v.AbstractUpdateService{get onRawError(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"error",(m,b)=>b)}get onRawUpdateNotAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(m,b,D,t)=>({version:D,productVersion:D,timestamp:t}))}constructor(m,b,D,t,s,i,c){super(m,b,t,s,i,c),this.telemetryService=D,this.disposables=new C.DisposableStore,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!==d.StateType.Ready?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.telemetryService.publicLog2("update:error",{messageHash:String((0,k.hash)(String(m)))}),this.logService.error("UpdateService error:",m);const b=this.state.type===d.StateType.CheckingForUpdates&&this.state.explicit?m:void 0;this.setState(d.State.Idle(d.UpdateType.Archive,b))}buildUpdateFeedUrl(m){let b;this.productService.darwinUniversalAssetId?b=this.productService.darwinUniversalAssetId:b=process.arch==="x64"?"darwin":"darwin-arm64";const D=(0,v.createUpdateURL)(b,m,this.productService);try{n.autoUpdater.setFeedURL({url:D})}catch(t){this.logService.error("Failed to set update feed URL",t);return}return D}doCheckForUpdates(m){this.setState(d.State.CheckingForUpdates(m)),n.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type===d.StateType.CheckingForUpdates&&this.setState(d.State.Downloading)}onUpdateDownloaded(m){this.state.type===d.StateType.Downloading&&(this.setState(d.State.Downloaded(m)),this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(d.State.Ready(m)))}onUpdateNotAvailable(){this.state.type===d.StateType.CheckingForUpdates&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(d.UpdateType.Archive)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=E,Pe([o.memoize],E.prototype,"onRawError",null),Pe([o.memoize],E.prototype,"onRawUpdateNotAvailable",null),Pe([o.memoize],E.prototype,"onRawUpdateAvailable",null),Pe([o.memoize],E.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=E=Pe([ne(0,a.ILifecycleMainService),ne(1,R.IConfigurationService),ne(2,w.ITelemetryService),ne(3,y.IEnvironmentMainService),ne(4,g.IRequestService),ne(5,h.ILogService),ne(6,f.IProductService)],E)}),define(oe[297],ae([0,1,49,47,8,4,10,24,20,5,25,50]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0,C=ke(C);let g=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,E,p){if(this.lifecycleMainService=v,this.logService=p,this._state=f.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(f.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}scheduleCheckForUpdates(v=60*60*1e3){return(0,I.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return f.UpdateType.Snap}doQuitAndInstall(){}async _applySpecificUpdate(v){}};g=Pe([ne(0,y.ILifecycleMainService),ne(1,R.IEnvironmentMainService),ne(2,a.ILogService)],g);let w=class extends g{constructor(v,E,p,m,b,D){super(p,m,b),this.snap=v,this.snapRevision=E,this.telemetryService=D;const t=(0,o.watch)(C.dirname(this.snap)),s=k.Event.fromNodeEventEmitter(t,"change",(l,u)=>u),i=k.Event.filter(s,l=>l==="current"),r=k.Event.debounce(i,(l,u)=>u,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{r.dispose(),t.close()})}doCheckForUpdates(){this.setState(f.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(f.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(f.UpdateType.Snap)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(f.State.Idle(f.UpdateType.Snap,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((p,m)=>(0,o.realpath)(`${C.dirname(this.snap)}/current`,(b,D)=>b?m(b):p(D))),E=C.basename(v);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=w,e.SnapUpdateService=w=Pe([ne(2,y.ILifecycleMainService),ne(3,R.IEnvironmentMainService),ne(4,a.ILogService),ne(5,h.ITelemetryService)],w)}),define(oe[29],ae([0,1,14,3,6,52,51,77,28,18,24,10,140]),function(V,e,n,o,I,k,C,R,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=d,e.getLastFocused=v,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var w;(function(p){p[p.CLI=0]="CLI",p[p.DOCK=1]="DOCK",p[p.MENU=2]="MENU",p[p.DIALOG=3]="DIALOG",p[p.DESKTOP=4]="DESKTOP",p[p.API=5]="API"})(w||(e.OpenContext=w={}));function d(p,m,b){const D=p.get(R.IThemeMainService),t=p.get(y.IProductService),s=p.get(a.IConfigurationService),i=p.get(h.IEnvironmentMainService),c=s.getValue("window"),r={backgroundColor:D.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,title:t.nameLong,show:m.mode!==k.WindowMode.Maximized&&m.mode!==k.WindowMode.Fullscreen,x:m.x,y:m.y,width:m.width,height:m.height,webPreferences:{...b,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(m.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(o.isLinux?r.icon=(0,f.join)(i.appRoot,"resources/linux/code.png"):o.isWindows&&!i.isBuilt&&(r.icon=(0,f.join)(i.appRoot,"resources/win32/code_150x150.png")),o.isMacintosh&&(r.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),o.isMacintosh&&!(0,C.useNativeFullScreen)(s)&&(r.fullscreenable=!1),o.isMacintosh&&c?.nativeTabs===!0&&(r.tabbingIdentifier=t.nameShort),!(0,C.hasNativeTitlebar)(s)&&(r.titleBarStyle="hidden",o.isMacintosh||(r.frame=!1),(0,C.useWindowControlsOverlay)(s))){const P=D.getWindowSplash()?.colorInfo.titleBarBackground??D.getBackgroundColor(),S=g.Color.fromHex(P).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:P,symbolColor:S}}return r}function v(p){let m,b=Number.MIN_VALUE;for(const D of p)D.lastFocusTime>b&&(b=D.lastFocusTime,m=D);return m}var E;(function(p){function m(D,t,s=n.screen.getAllDisplays()){if(D.trace(`window#validateWindowState: validating window state on ${s.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){D.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){D.trace("window#validateWindowState: unexpected negative values");return}if(s.length===1){const r=b(s[0]);if(D.trace("window#validateWindowState: single monitor working area",r),r){let l=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!r||(t.x<r.x&&(t.x=r.x),t.y<r.y&&(t.y=r.y))};l(),t.width>r.width&&(t.width=r.width),t.height>r.height&&(t.height=r.height),t.x>r.x+r.width-128&&(t.x=r.x+r.width-t.width),t.y>r.y+r.height-128&&(t.y=r.y+r.height-t.height),l()}return t}if(t.display&&t.mode===k.WindowMode.Fullscreen){const r=s.find(l=>l.id===t.display);if(r&&typeof r.bounds?.x=="number"&&typeof r.bounds?.y=="number"){D.trace("window#validateWindowState: restoring fullscreen to previous display");const l=(0,k.defaultWindowState)(k.WindowMode.Fullscreen);return l.x=r.bounds.x,l.y=r.bounds.y,l}}let i,c;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),c=b(i),D.trace("window#validateWindowState: multi-monitor working area",c)}catch(r){D.error("window#validateWindowState: error finding display for window state",r)}if(i&&c&&t.x+t.width>c.x&&t.y+t.height>c.y&&t.x<c.x+c.width&&t.y<c.y+c.height)return t;D.trace("window#validateWindowState: state is outside of the multi-monitor working area")}p.validateWindowState=m;function b(D){if(D.workArea.width>0&&D.workArea.height>0)return D.workArea;if(D.bounds.width>0&&D.bounds.height>0)return D.bounds}})(E||(e.WindowStateValidator=E={}))}),define(oe[298],ae([0,1,14,23,4,46,2,33,98,5,63,88,29]),function(V,e,n,o,I,k,C,R,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let d=class extends C.Disposable{constructor(E,p,m,b){super(),this.logService=E,this.windowsMainService=p,this.encryptionMainService=m,this.applicationStorageMainService=b,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=I.Event.fromNodeEventEmitter(n.app,"login",(p,m,b,D,t)=>({event:p,webContents:m,req:b,authInfo:D,callback:t}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:p,req:m,callback:b}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let D;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),D=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{D=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}b(D?.username,D?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(E);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const p=String((0,k.hash)({scheme:E.scheme,host:E.host,port:E.port}));let m,b;try{const i=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+p,h.StorageScope.APPLICATION);if(i){const c=JSON.parse(await this.encryptionMainService.decrypt(i));m=c.username,b=c.password}}catch(i){this.logService.error(i)}if(this.state!==w.StoredCredentialsUsed&&typeof m=="string"&&typeof b=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:m,password:b};const D=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!D){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${D.id} to handle proxy login`);const t={authInfo:E,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??b,replyChannel:`vscode:proxyAuthResponse:${(0,R.generateUuid)()}`};D.sendWhenReady("vscode:openProxyAuthenticationDialog",o.CancellationToken.None,t),this.state=w.LoginDialogShown;const s=await new Promise(i=>{const c=async(r,l,u)=>{if(l===t.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${D.id}`),D.win?.webContents.off("ipc-message",c),u){const P={username:u.username,password:u.password};try{if(u.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(P));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+p,S,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+p,h.StorageScope.APPLICATION)}catch(S){this.logService.error(S)}i({username:P.username,password:P.password})}else i(void 0)};D.win?.webContents.on("ipc-message",c)});return this.sessionCredentials=s,s}};e.ProxyAuthHandler=d,e.ProxyAuthHandler=d=Pe([ne(0,a.ILogService),ne(1,g.IWindowsMainService),ne(2,y.IEncryptionMainService),ne(3,f.IApplicationStorageMainService)],d)}),define(oe[299],ae([0,1,93,205,121,29]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends o.ExtensionHostDebugBroadcastChannel{constructor(y){super(),this.windowsMainService=y}call(y,a,h){return a==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(h[0],h[1]):super.call(y,a,h)}async openExtensionDevelopmentHostWindow(y,a){const h=(0,I.parseArgs)(y,I.OPTIONS);h.debugRenderer=a;const f=h.extensionDevelopmentPath;if(!f)return{success:!1};const[g]=await this.windowsMainService.openExtensionDevelopmentHostWindow(f,{context:k.OpenContext.API,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!a)return{success:!0};const w=g.win;if(!w)return{success:!0};const d=w.webContents.debugger;let v=d.isAttached()?1/0:0;const E=(0,n.createServer)(p=>{v++===0&&d.attach();let m=!1;const b=s=>{m||p.write(JSON.stringify(s)+"\0")},D=(s,i,c,r)=>b({method:i,params:c,sessionId:r});w.on("close",()=>{d.removeListener("message",D),p.end(),m=!0}),d.addListener("message",D);let t=Buffer.alloc(0);p.on("data",s=>{t=Buffer.concat([t,s]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let c;try{const r=t.slice(0,i).toString("utf8");t=t.slice(i+1),c=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(c.method,c.params,c.sessionId).then(r=>b({id:c.id,sessionId:c.sessionId,result:r})).catch(r=>b({id:c.id,sessionId:c.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",s=>{console.error("error on cdp pipe:",s)}),p.on("close",()=>{m=!0,--v===0&&d.detach()})});return await new Promise(p=>E.listen(0,p)),w.on("close",()=>E.close()),{rendererDebugPort:E.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),define(oe[300],ae([0,1,14,22,3,7,21,18,69,6,5,133,29]),function(V,e,n,o,I,k,C,R,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,a.createDecorator)(e.ID);let w=class{constructor(v,E,p,m){this.logService=v,this.windowsMainService=E,this.urlService=p,this.configurationService=m}async start(v,E){this.logService.trace("Received data from other instance: ",v,E),I.isMacintosh&&n.app.focus({steal:!0});const p=this.parseOpenUrl(v);if(p.length){let m=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const b=(0,o.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:g.OpenContext.DESKTOP}));b&&(m=b.ready())}m.then(()=>{for(const{uri:b,originalUrl:D}of p)this.urlService.open(b,{originalUrl:D})})}else return this.startOpenWindow(v,E)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,o.coalesce)(v._urls.map(E=>{try{return{uri:k.URI.parse(E),originalUrl:E}}catch{return null}})):[]}async startOpenWindow(v,E){const p=(0,y.isLaunchedFromCli)(E)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let m=[];const b=v.wait&&v.waitMarkerFilePath?k.URI.file(v.waitMarkerFilePath):void 0,D=v.remote||void 0,t={context:p,cli:v,userEnv:v["preserve-env"]||p===g.OpenContext.CLI?E:void 0,waitMarkerFileURI:b,remoteAuthority:D,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,t);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let s=!1;if(v["new-window"]||t.forceProfile||t.forceTempProfile)s=!0;else if(v["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!I.isMacintosh}if(s)m=await this.windowsMainService.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.windowsMainService.getLastActiveWindow();i?(this.windowsMainService.openExistingWindow(i,t),m=[i]):m=await this.windowsMainService.open({...t,forceEmpty:!0})}}else m=await this.windowsMainService.open({...t,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(b&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,C.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=w,e.LaunchMainService=w=Pe([ne(0,h.ILogService),ne(1,g.IWindowsMainService),ne(2,f.IURLService),ne(3,R.IConfigurationService)],w)}),define(oe[301],ae([0,1,2,20,52,59,30,8,29]),function(V,e,n,o,I,k,C,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let a=class extends n.Disposable{constructor(f,g,w){super(),this.userDataProfilesService=g,this.windowsMainService=w,this._register(f.onWillLoadWindow(d=>{d.reason===I.LoadReason.LOAD&&this.unsetProfileForWorkspace(d.window)})),this._register(f.onBeforeCloseWindow(d=>this.unsetProfileForWorkspace(d))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(f){const g=this.getWorkspace(f),w=this.userDataProfilesService.getProfileForWorkspace(g);w?.isTransient&&(this.userDataProfilesService.unsetWorkspace(g,w.isTransient),w.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(f){return f.openedWorkspace??(0,C.toWorkspaceIdentifier)(f.backupPath,f.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const f=this.userDataProfilesService.getAssociatedEmptyWindows();if(f.length===0)return;const g=this.windowsMainService.getWindows().map(w=>this.getWorkspace(w));for(const w of f)g.some(d=>d.id===w.id)||this.userDataProfilesService.unsetWorkspace(w,!1)}};e.UserDataProfilesHandler=a,e.UserDataProfilesHandler=a=Pe([ne(0,o.ILifecycleMainService),ne(1,k.IUserDataProfilesMainService),ne(2,y.IWindowsMainService)],a)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[64],ae([0,1,14,2,4,5,321,8,12,29,81,25,20,82,36,3,107]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0,h=et(h);function m(t){return typeof t.responseWindowId=="number"}let b=class extends o.Disposable{static{p=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(p.all.values())}constructor(s,i,c){super(),this.logService=s,this.telemetryService=i,this.lifecycleMainService=c,this.id=String(++p.ID_COUNTER),this._onStdout=this._register(new I.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new I.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new I.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new I.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new I.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new I.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.killed=!1}log(s,i){let c;switch(this.configuration?.correlationId?c=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${s}`:c=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${s}`,i){case h.default.Error:this.logService.error(c);break;case h.default.Warning:this.logService.warn(c);break;case h.default.Info:this.logService.trace(c);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",h.default.Error),!1):!0}start(s){const i=this.doStart(s);return i&&s.payload&&this.postMessage(s.payload)&&this.log("payload sent via postMessage()",h.default.Info),i}doStart(s){if(!this.validateCanStart())return!1;this.configuration=s;const i=`${this.configuration.type}-${this.id}`,c=y.FileAccess.asFileUri("bootstrap-fork.js").fsPath,r=this.configuration.args??[],l=this.configuration.execArgv??[],u=this.configuration.allowLoadingUnsignedLibraries,P=this.configuration.forceAllocationsToV8Sandbox,S="pipe",M=this.createEnv(s);return this.log("creating new...",h.default.Info),this.process=n.utilityProcess.fork(c,r,{serviceName:i,env:M,execArgv:l,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:P,stdio:S}),this.registerListeners(this.process,this.configuration,i),!0}createEnv(s){const i=s.env?{...s.env}:{...(0,d.deepClone)(process.env)};i.VSCODE_AMD_ENTRYPOINT=s.entryPoint,typeof s.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(s.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=s.type,v.isWindows&&((0,E.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,E.getUNCHostAllowlist)().join("\\")),(0,w.removeDangerousEnvVariables)(i);for(const c of Object.keys(i))i[c]=String(i[c]);return i}registerListeners(s,i,c){if(s.stdout){const r=new C.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(s.stdout,"data")(l=>this._onStdout.fire(typeof l=="string"?l:r.write(l))))}if(s.stderr){const r=new C.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(s.stderr,"data")(l=>this._onStderr.fire(typeof l=="string"?l:r.write(l))))}this._register(I.Event.fromNodeEventEmitter(s,"message")(r=>this._onMessage.fire(r))),this._register(I.Event.fromNodeEventEmitter(s,"spawn")(()=>{this.processPid=s.pid,typeof s.pid=="number"&&p.all.set(s.pid,{pid:s.pid,name:m(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.log("successfully created",h.default.Info),this._onSpawn.fire(s.pid)})),this._register(I.Event.fromNodeEventEmitter(s,"exit")(r=>{const l=this.isNormalExit(r)?0:r;this.log(`received exit event with code ${l}`,h.default.Info),this._onExit.fire({pid:this.processPid,code:l,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(I.Event.fromNodeEventEmitter(n.app,"child-process-gone",(r,l)=>({event:r,details:l}))(({details:r})=>{r.type==="Utility"&&r.name===c&&!this.isNormalExit(r.exitCode)&&(this.log(`crashed with code ${r.exitCode} and reason '${r.reason}'`,h.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:i.type,reason:r.reason,code:r.exitCode}),this._onCrash.fire({pid:this.processPid,code:r.exitCode,reason:r.reason}),this.onDidExitOrCrashOrKill())}))}once(s,i){const c=this._register(this._onMessage.event(r=>{r===s&&(c.dispose(),i())}))}postMessage(s,i){return this.process?(this.process.postMessage(s,i),!0):!1}connect(s){const{port1:i,port2:c}=new n.MessageChannelMain;return this.postMessage(s,[c]),i}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",h.default.Info);const s=process;return typeof s._debugProcess=="function"?(s._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",h.default.Info),this.process.kill()?(this.log("successfully killed the process",h.default.Info),this.killed=!0,this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",h.default.Warning)}isNormalExit(s){return s===0?!0:this.killed&&s===15}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&p.all.delete(this.processPid),this.process=void 0}async waitForExit(s){this.process&&(this.log("waiting to exit...",h.default.Info),await Promise.race([I.Event.toPromise(this.onExit),(0,R.timeout)(s)]),this.process&&(this.log(`did not exit within ${s}ms, will kill it now...`,h.default.Info),this.kill()))}};e.UtilityProcess=b,e.UtilityProcess=b=p=Pe([ne(0,k.ILogService),ne(1,f.ITelemetryService),ne(2,g.ILifecycleMainService)],b);let D=class extends b{constructor(s,i,c,r){super(s,c,r),this.windowsMainService=i}start(s){const i=this.windowsMainService.getWindowById(s.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",h.default.Error),!0;if(!super.doStart(s))return!1;this.registerWindowListeners(i.win,s);const r=this.connect(s.payload);return i.win.webContents.postMessage(s.responseChannel,s.responseNonce,[r]),!0}registerWindowListeners(s,i){i.windowLifecycleBound&&(this._register(I.Event.filter(this.lifecycleMainService.onWillLoadWindow,c=>c.window.win===s)(()=>this.kill())),this._register(I.Event.fromNodeEventEmitter(s,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=D,e.WindowUtilityProcess=D=Pe([ne(0,k.ILogService),ne(1,a.IWindowsMainService),ne(2,f.ITelemetryService),ne(3,g.ILifecycleMainService)],D)}),define(oe[302],ae([0,1,8,16,4,2,20,5,25,64,29]),function(V,e,n,o,I,k,C,R,y,a,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class extends k.Disposable{static{f=this}static{this._lastId=0}constructor(d,v,E,p){super(),this._logService=d,this._lifecycleMainService=v,this._windowsMainService=E,this._telemetryService=p,this._extHosts=new Map,this._shutdown=!1,this._register(this._lifecycleMainService.onWillShutdown(m=>{this._shutdown=!0,m.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}_getExtHost(d){const v=this._extHosts.get(d);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(d){return this._getExtHost(d).onStdout}onDynamicStderr(d){return this._getExtHost(d).onStderr}onDynamicMessage(d){return this._getExtHost(d).onMessage}onDynamicExit(d){return this._getExtHost(d).onExit}async createExtensionHost(){if(this._shutdown)throw(0,o.canceled)();const d=String(++f._lastId),v=new a.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);this._extHosts.set(d,v);const E=v.onExit(({pid:p,code:m,signal:b})=>{E.dispose(),this._logService.info(`Extension host with pid ${p} exited with code: ${m}, signal: ${b}.`),setTimeout(()=>{v.dispose(),this._extHosts.delete(d)}),setTimeout(()=>{try{process.kill(p,0),this._logService.error(`Extension host with pid ${p} still exists, forcefully killing it...`),process.kill(p)}catch{}},1e3)});return{id:d}}async start(d,v){if(this._shutdown)throw(0,o.canceled)();const E=this._getExtHost(d);return E.start({...v,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:v.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d}),{pid:await I.Event.toPromise(E.onSpawn)}}async enableInspectPort(d){if(this._shutdown)throw(0,o.canceled)();const v=this._extHosts.get(d);return v?v.enableInspectPort():!1}async kill(d){if(this._shutdown)throw(0,o.canceled)();const v=this._extHosts.get(d);v&&v.kill()}async _killAllNow(){for(const[,d]of this._extHosts)d.kill()}async _waitForAllExit(d){const v=[];for(const[,E]of this._extHosts)v.push(E.waitForExit(d));return n.Promises.settled(v).then(()=>{})}};e.ExtensionHostStarter=g,e.ExtensionHostStarter=g=f=Pe([ne(0,R.ILogService),ne(1,C.ILifecycleMainService),ne(2,h.IWindowsMainService),ne(3,y.ITelemetryService)],g)}),define(oe[303],ae([0,1,35,8,2,24,20,5,42,40,72,64,58,96,13,254,4]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let p=class extends I.Disposable{constructor(b,D,t,s,i,c,r,l,u){super(),this.machineId=b,this.sqmId=D,this.devDeviceId=t,this.environmentMainService=s,this.userDataProfilesService=i,this.lifecycleMainService=c,this.logService=r,this.loggerMainService=l,this.policyService=u,this.firstWindowConnectionBarrier=new o.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._onDidCrash=this._register(new E.Emitter),this.onDidCrash=this._onDidCrash.event,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){n.validatedIpcMain.on(v.SharedProcessChannelConnection.request,(b,D)=>this.onWindowConnection(b,D,v.SharedProcessChannelConnection.response)),n.validatedIpcMain.on(v.SharedProcessRawConnection.request,(b,D)=>this.onWindowConnection(b,D,v.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(b,D,t){this.logService.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const s=await this.connect(t);if(b.sender.isDestroyed())return s.close();b.sender.postMessage(t,D,[s])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(v.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const b=new o.DeferredPromise;this.utilityProcess?.once(v.SharedProcessLifecycle.initDone,()=>b.complete()),await b.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const b=new o.DeferredPromise;this.utilityProcess?.once(v.SharedProcessLifecycle.ipcReady,()=>b.complete()),await b.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new f.UtilityProcess(this.logService,g.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(t=>{typeof t.warning=="string"?this.logService.warn(t.warning):typeof t.error=="string"&&this.logService.error(t.error)});const b=(0,w.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let D;b.port&&(D=["--nolazy"],b.break?D.push(`--inspect-brk=${b.port}`):D.push(`--inspect=${b.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:D}),this._register(this.utilityProcess.onCrash(()=>this._onDidCrash.fire()))}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(b){return await this.whenIpcReady,(0,d.assertIsDefined)(this.utilityProcess).connect(b)}};e.SharedProcess=p,e.SharedProcess=p=Pe([ne(3,k.IEnvironmentMainService),ne(4,y.IUserDataProfilesService),ne(5,C.ILifecycleMainService),ne(6,R.ILogService),ne(7,h.ILoggerMainService),ne(8,a.IPolicyService)],p)}),define(oe[304],ae([0,1,24,96,20,5,58,76,64,119,35,2,4,36,18,12]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let E=class extends f.Disposable{constructor(m,b,D,t,s){super(),this._reconnectConstants=m,this._configurationService=b,this._environmentMainService=D,this._lifecycleMainService=t,this._logService=s,this.utilityProcess=void 0,this._onRequestConnection=new g.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new g.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._register(this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire())),h.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(i,c)=>this._onWindowConnection(i,c)),this._register((0,f.toDisposable)(()=>{h.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new y.UtilityProcess(this._logService,C.NullTelemetryService,this._lifecycleMainService);const m=(0,o.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),b=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:b,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const D=this.utilityProcess.connect(),t=new a.Client(D,"ptyHost"),s=new f.DisposableStore;return s.add(t),s.add((0,f.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:t,store:s,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const m={...(0,w.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},b=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostLatency);b&&typeof b=="number"&&(m.VSCODE_LATENCY=String(b));const D=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostStartupDelay);return D&&typeof D=="number"&&(m.VSCODE_STARTUP_DELAY=String(D)),this._environmentMainService.restoreSnapExportedVariables(),m}_onWindowConnection(m,b){this._onRequestConnection.fire();const D=this.utilityProcess.connect();if(m.sender.isDestroyed()){D.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",b,[D])}};e.ElectronPtyHostStarter=E,e.ElectronPtyHostStarter=E=Pe([ne(1,d.IConfigurationService),ne(2,n.IEnvironmentMainService),ne(3,I.ILifecycleMainService),ne(4,k.ILogService)],E)}),define(oe[305],ae([0,1,2,6,5,29,64,25,46,4,8,20]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,o.createDecorator)("utilityProcessWorker");let g=class extends n.Disposable{constructor(v,E,p,m){super(),this.logService=v,this.windowsMainService=E,this.telemetryService=p,this.lifecycleMainService=m,this.workers=new Map}async createWorker(v){const E=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${E})`);const p=this.hash(v);this.workers.has(p)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${E})`),this.disposeWorker(v));const m=new w(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,v);if(!m.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(p,m);const b=new h.DeferredPromise;return a.Event.once(m.onDidTerminate)(D=>{D.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${D.code}, signal: ${D.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${D.code}, signal: ${D.signal}`),this.workers.delete(p),b.complete({reason:D})}),b.p}hash(v){return(0,y.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const E=this.hash(v),p=this.workers.get(E);p&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),p.kill(),p.dispose(),this.workers.delete(E))}};e.UtilityProcessWorkerMainService=g,e.UtilityProcessWorkerMainService=g=Pe([ne(0,I.ILogService),ne(1,k.IWindowsMainService),ne(2,R.ITelemetryService),ne(3,f.ILifecycleMainService)],g);let w=class extends n.Disposable{constructor(v,E,p,m,b){super(),this.logService=v,this.windowsMainService=E,this.telemetryService=p,this.lifecycleMainService=m,this.configuration=b,this._onDidTerminate=this._register(new a.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=this._register(new C.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService)),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(v=>this._onDidTerminate.fire({code:v.code,signal:v.signal}))),this._register(this.utilityProcess.onCrash(v=>this._onDidTerminate.fire({code:v.code,signal:"ECRASH"})))}spawn(){const E=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:E,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};w=Pe([ne(0,I.ILogService),ne(1,k.IWindowsMainService),ne(2,R.ITelemetryService),ne(3,f.ILifecycleMainService)],w)}),define(oe[306],ae([0,1,14,4,2,279,29]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let R=class extends I.Disposable{constructor(a){super(),this.windowsMainService=a,this._onFoundInFrame=this._register(new o.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(a,h){let f;if(typeof a.windowId=="number"){const{windowId:g}=a,w=this.windowsMainService.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);f=w.win.webContents}else{const{webContentsId:g}=a;if(f=n.webContents.fromId(g),!f)throw new Error(`Invalid webContentsId: ${g}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(h)}async findInFrame(a,h,f,g){const d=this.getFrameByName(a,h);if(typeof d.findInFrame=="function"){d.findInFrame(f,{findNext:g.findNext,forward:g.forward});const v=(E,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(a,h,f){const w=this.getFrameByName(a,h);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}getFrameByName(a,h){const f=this.windowsMainService.getWindowById(a.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${a}`);const g=f.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===h);if(!g)throw new Error(`Unknown frame: ${h}`);return g}};e.WebviewMainService=R,e.WebviewMainService=R=Pe([ne(0,C.IWindowsMainService)],R)}),define(oe[307],ae([0,1,14,2,3,19,7,18,20,5,34,29,52,30]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=E,e.getWindowsStateStoreData=m;let v=class extends o.Disposable{static{d=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(t,s,i,c,r){super(),this.windowsMainService=t,this.stateService=s,this.lifecycleMainService=i,this.logService=c,this.configurationService=r,this._state=E(this.stateService.getItem(d.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){n.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this._register(this.lifecycleMainService.onBeforeCloseWindow(t=>this.onBeforeCloseWindow(t))),this._register(this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown())),this._register(this.windowsMainService.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.lastClosedState=void 0)})),this._register(this.windowsMainService.onDidDestroyWindow(t=>this.onBeforeCloseWindow(t)))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const t=new Set,s={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!s.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),r&&(s.lastActiveWindow=this.toWindowState(r),s.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&t.add(s.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);i&&(s.lastPluginDevelopmentHostWindow=this.toWindowState(i),s.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(t.has(s.lastPluginDevelopmentHostWindow.uiState.display)?I.isMacintosh&&!i.win?.isSimpleFullScreen()&&(s.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):t.add(s.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(s.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const l=this.toWindowState(r);return l.uiState.mode===g.WindowMode.Fullscreen&&(t.has(l.uiState.display)?I.isMacintosh&&l.windowId!==s.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(l.uiState.mode=g.WindowMode.Normal):t.add(l.uiState.display)),l}));const c=m(s);this.stateService.setItem(d.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(t){if(this.lifecycleMainService.quitRequested)return;const s=this.toWindowState(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=s:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this._state.openedWindows.forEach(i=>{const c=(0,w.isWorkspaceIdentifier)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,r=(0,w.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&i.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(i.folderUri,t.openedWorkspace.uri);(c||r)&&(i.uiState=s.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=s)}toWindowState(t){return{windowId:t.id,workspace:(0,w.isWorkspaceIdentifier)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const s=this.doGetNewWindowState(t),i=this.configurationService.getValue("window");if(s.mode===g.WindowMode.Fullscreen){let c;s.hasDefaultState?c=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):c=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),c||(s.mode=g.WindowMode.Normal)}return s}doGetNewWindowState(t){const s=this.windowsMainService.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=t.workspace;if((0,w.isWorkspaceIdentifier)(P)){const M=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===P.id).map(T=>T.uiState);if(M.length)return M[0]}if((0,w.isSingleFolderWorkspaceIdentifier)(P)){const M=this.state.openedWindows.filter(T=>T.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(T.folderUri,P.uri)).map(T=>T.uiState);if(M.length)return M[0]}else if(t.backupPath){const M=this.state.openedWindows.filter(T=>T.backupPath===t.backupPath).map(T=>T.uiState);if(M.length)return M[0]}const S=this.lastClosedState||this.state.lastActiveWindow;if(!s&&S)return S.uiState}let i;const c=n.screen.getAllDisplays();if(c.length===1)i=c[0];else{if(I.isMacintosh){const P=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(P)}!i&&s&&(i=n.screen.getDisplayMatching(s.getBounds())),i||(i=n.screen.getPrimaryDisplay()||c[0])}let r=(0,g.defaultWindowState)();r.x=Math.round(i.bounds.x+i.bounds.width/2-r.width/2),r.y=Math.round(i.bounds.y+i.bounds.height/2-r.height/2);const l=this.configurationService.getValue("window");let u=!0;if(l?.newWindowDimensions){if(l.newWindowDimensions==="maximized")r.mode=g.WindowMode.Maximized,u=!1;else if(l.newWindowDimensions==="fullscreen")r.mode=g.WindowMode.Fullscreen,u=!1;else if((l.newWindowDimensions==="inherit"||l.newWindowDimensions==="offset")&&s){const P=s.serializeWindowState();P.mode===g.WindowMode.Fullscreen?r.mode=g.WindowMode.Fullscreen:r={...P,zoomLevel:void 0},u=r.mode!==g.WindowMode.Fullscreen&&l.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(t){if(this.windowsMainService.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const s=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;s.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.WindowsStateHandler=v,e.WindowsStateHandler=v=d=Pe([ne(0,f.IWindowsMainService),ne(1,h.IStateService),ne(2,y.ILifecycleMainService),ne(3,a.ILogService),ne(4,R.IConfigurationService)],v);function E(D){const t={openedWindows:[]},s=D||{openedWindows:[]};return s.lastActiveWindow&&(t.lastActiveWindow=p(s.lastActiveWindow)),s.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=p(s.lastPluginDevelopmentHostWindow)),Array.isArray(s.openedWindows)&&(t.openedWindows=s.openedWindows.map(i=>p(i))),t}function p(D){const t={uiState:D.uiState};return D.backupPath&&(t.backupPath=D.backupPath),D.remoteAuthority&&(t.remoteAuthority=D.remoteAuthority),D.folder&&(t.folderUri=C.URI.parse(D.folder)),D.workspaceIdentifier&&(t.workspace={id:D.workspaceIdentifier.id,configPath:C.URI.parse(D.workspaceIdentifier.configURIPath)}),t}function m(D){return{lastActiveWindow:D.lastActiveWindow&&b(D.lastActiveWindow),lastPluginDevelopmentHostWindow:D.lastPluginDevelopmentHostWindow&&b(D.lastPluginDevelopmentHostWindow),openedWindows:D.openedWindows.map(t=>b(t))}}function b(D){return{workspaceIdentifier:D.workspace&&{id:D.workspace.id,configURIPath:D.workspace.configPath.toString()},folder:D.folderUri&&D.folderUri.toString(),backupPath:D.backupPath,remoteAuthority:D.remoteAuthority,uiState:D.uiState}}}),define(oe[60],ae([0,1,14,4,43,2,12,10,19,21,201,70,53,24,6,5,59,135,30,103,104]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,d.createDecorator)("workspacesManagementMainService");let t=class extends k.Disposable{constructor(i,c,r,l,u){super(),this.environmentMainService=i,this.logService=c,this.userDataProfilesMainService=r,this.backupMainService=l,this.dialogMainService=u,this._onDidDeleteUntitledWorkspace=this._register(new o.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new o.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const i=(await a.Promises.readdir(this.untitledWorkspacesHome.with({scheme:C.Schemas.file}).fsPath)).map(c=>(0,y.joinPath)(this.untitledWorkspacesHome,c,m.UNTITLED_WORKSPACE_NAME));for(const c of i){const r=(0,D.getWorkspaceIdentifier)(c),l=await this.resolveLocalWorkspace(c);l?this.untitledWorkspaces.push({workspace:r,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(i){i.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${i}).`)}}resolveLocalWorkspace(i){return this.doResolveLocalWorkspace(i,c=>a.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(i,c){if(this.isWorkspacePath(i)&&i.scheme===C.Schemas.file)try{const r=c(i.fsPath);return r instanceof Promise?r.then(l=>this.doResolveWorkspace(i,l),l=>{}):this.doResolveWorkspace(i,r)}catch{return}}isWorkspacePath(i){return(0,m.isUntitledWorkspace)(i,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(i)}doResolveWorkspace(i,c){try{const r=this.doParseStoredWorkspace(i,c),l=(0,D.getWorkspaceIdentifier)(i);return{id:l.id,configPath:l.configPath,folders:(0,b.toWorkspaceFolders)(r.folders,l.configPath,y.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.logService.warn(r.toString())}}doParseStoredWorkspace(i,c){const r=(0,I.parse)(c);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(l=>(0,b.isStoredWorkspaceFolder)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(i,c){const{workspace:r,storedWorkspace:l}=this.newUntitledWorkspace(i,c),u=r.configPath.fsPath;return await a.Promises.mkdir((0,R.dirname)(u),{recursive:!0}),await a.Promises.writeFile(u,JSON.stringify(l,null,"	")),this.untitledWorkspaces.push({workspace:r,remoteAuthority:c}),r}newUntitledWorkspace(i=[],c){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,y.joinPath)(this.untitledWorkspacesHome,r),u=(0,y.joinPath)(l,m.UNTITLED_WORKSPACE_NAME),P=[];for(const S of i)P.push((0,b.getStoredWorkspaceFolder)(S.uri,!0,S.name,l,y.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(u),storedWorkspace:{folders:P,remoteAuthority:c}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,m.isUntitledWorkspace)(i.configPath,this.environmentMainService)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.doDeleteUntitledWorkspace(i),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(i),this._onDidDeleteUntitledWorkspace.fire(i))}async doDeleteUntitledWorkspace(i){const c=(0,y.originalFSPath)(i.configPath);try{await a.Promises.rm((0,R.dirname)(c));const r=(0,R.join)(this.environmentMainService.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,i.id);await a.Promises.exists(r)&&await a.Promises.writeFile((0,R.join)(r,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(l=>l.workspace.id!==i.id)}catch(r){this.logService.warn(`Unable to delete untitled workspace ${c} (${r}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(i,c,r){if(!i||!i.win||!i.isReady||!await this.isValidTargetWorkspacePath(i,c,r))return;const u=await this.doEnterWorkspace(i,(0,D.getWorkspaceIdentifier)(r));if(u)return this._onDidEnterWorkspace.fire({window:i,workspace:u.workspace}),u}async isValidTargetWorkspacePath(i,c,r){return r?(0,m.isWorkspaceIdentifier)(i.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,r)?!1:(0,p.findWindowOnWorkspaceOrFolder)(c,r)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,h.localize)(0,null)],message:(0,h.localize)(1,null,(0,y.basename)(r)),detail:(0,h.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(i,c){if(!i.config)return;i.focus();let r;return i.config.extensionDevelopmentPath||(i.config.backupPath?r=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority},i.config.backupPath):r=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority})),(0,m.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=c,i.config.backupPath=r,{workspace:c,backupPath:r}}};e.WorkspacesManagementMainService=t,e.WorkspacesManagementMainService=t=Pe([ne(0,w.IEnvironmentMainService),ne(1,v.ILogService),ne(2,E.IUserDataProfilesMainService),ne(3,f.IBackupMainService),ne(4,g.IDialogMainService)],t)}),define(oe[136],ae([0,1,14,35,23,6,29,30,60,13,5,64]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let g=class{constructor(d,v,E){this.windowsMainService=d,this.workspacesManagementMainService=v,this.logService=E}async getRemoteDiagnostics(d){const v=this.windowsMainService.getWindows();return(await Promise.all(v.map(async p=>{const m=p.remoteAuthority;if(!m)return;const b=`vscode:getDiagnosticInfoResponse${p.id}`,D={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(p):void 0};return new Promise(t=>{p.sendWhenReady("vscode:getDiagnosticInfo",I.CancellationToken.None,{replyChannel:b,args:D}),o.validatedIpcMain.once(b,(s,i)=>{i||t({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),t(i)}),setTimeout(()=>{t({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)})}))).filter(p=>!!p)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const E of n.BrowserWindow.getAllWindows()){const p=this.windowsMainService.getWindowById(E.id);p?d.push(await this.codeWindowToInfo(p)):d.push(this.browserWindowToInfo(E))}const v=[];for(const{pid:E,name:p}of f.UtilityProcess.getAll())v.push({pid:E,name:p});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:v,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const v=await this.getFolderURIs(d),E=(0,a.assertIsDefined)(d.win);return this.browserWindowToInfo(E,v,d.remoteAuthority)}browserWindowToInfo(d,v=[],E){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:v,remoteAuthority:E}}async getFolderURIs(d){const v=[],E=d.openedWorkspace;if((0,R.isSingleFolderWorkspaceIdentifier)(E))v.push(E.uri);else if((0,R.isWorkspaceIdentifier)(E)){const p=await this.workspacesManagementMainService.resolveLocalWorkspace(E.configPath);p&&p.folders.forEach(b=>{v.push(b.uri)})}return v}};e.DiagnosticsMainService=g,e.DiagnosticsMainService=g=Pe([ne(0,C.IWindowsMainService),ne(1,y.IWorkspacesManagementMainService),ne(2,h.ILogService)],g)}),define(oe[65],ae([0,1,49,14,27,161,54,4,2,12,10,3,7,114,94,21,112,189,53,24,6,20,5,28,77,29,30,60,17,250,240,85,16]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,D.createDecorator)("nativeHostMainService");let A=class extends y.Disposable{constructor(B,N,z,se,J,le,K,ee,q){super(),this.windowsMainService=B,this.auxiliaryWindowsMainService=N,this.dialogMainService=z,this.lifecycleMainService=se,this.environmentMainService=J,this.logService=le,this.productService=K,this.themeMainService=ee,this.workspacesManagementMainService=q,this.onDidOpenMainWindow=R.Event.map(this.windowsMainService.onDidOpenWindow,O=>O.id),this.onDidTriggerWindowSystemContextMenu=R.Event.any(R.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:O,x,y:j})=>({windowId:O.id,x,y:j})),R.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:O,x,y:j})=>({windowId:O.id,x,y:j}))),this.onDidMaximizeWindow=R.Event.any(R.Event.map(this.windowsMainService.onDidMaximizeWindow,O=>O.id),R.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,O=>O.id)),this.onDidUnmaximizeWindow=R.Event.any(R.Event.map(this.windowsMainService.onDidUnmaximizeWindow,O=>O.id),R.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,O=>O.id)),this.onDidChangeWindowFullScreen=R.Event.any(R.Event.map(this.windowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen})),R.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,O=>({windowId:O.window.id,fullscreen:O.fullscreen}))),this.onDidBlurMainWindow=R.Event.filter(R.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(O,x)=>x.id),O=>!!this.windowsMainService.getWindowById(O)),this.onDidFocusMainWindow=R.Event.any(R.Event.map(R.Event.filter(R.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),O=>!!O),O=>O.id),R.Event.filter(R.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(O,x)=>x.id),O=>!!this.windowsMainService.getWindowById(O))),this.onDidBlurMainOrAuxiliaryWindow=R.Event.any(this.onDidBlurMainWindow,R.Event.map(R.Event.filter(R.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(O,x)=>this.auxiliaryWindowsMainService.getWindowByWebContents(x.webContents)),O=>!!O),O=>O.id)),this.onDidFocusMainOrAuxiliaryWindow=R.Event.any(this.onDidFocusMainWindow,R.Event.map(R.Event.filter(R.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(O,x)=>this.auxiliaryWindowsMainService.getWindowByWebContents(x.webContents)),O=>!!O),O=>O.id)),this.onDidResumeOS=R.Event.fromNodeEventEmitter(o.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new R.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=R.Event.debounce(R.Event.any(R.Event.filter(R.Event.fromNodeEventEmitter(o.screen,"display-metrics-changed",(O,x,j)=>j),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),R.Event.fromNodeEventEmitter(o.screen,"display-added"),R.Event.fromNodeEventEmitter(o.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(B,N){const z=this.windowsMainService.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,l.toWorkspaceIdentifier)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()})),se=[];return N.includeAuxiliaryWindows&&se.push(...this.auxiliaryWindowsMainService.getWindows().map(J=>({id:J.id,parentId:J.parentId,title:J.win?.getTitle()??"",filename:J.getRepresentedFilename()}))),[...z,...se]}async getWindowCount(B){return this.windowsMainService.getWindowCount()}async getActiveWindowId(B){const N=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(N)return N.id}openWindow(B,N,z){return Array.isArray(N)?this.doOpenWindow(B,N,z):this.doOpenEmptyWindow(B,N)}async doOpenWindow(B,N,z=Object.create(null)){N.length>0&&await this.windowsMainService.open({context:r.OpenContext.API,contextWindowId:B,urisToOpen:N,cli:this.environmentMainService.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async doOpenEmptyWindow(B,N){await this.windowsMainService.openEmptyWindow({context:r.OpenContext.API,contextWindowId:B},N)}async isFullScreen(B,N){return this.windowById(N?.targetWindowId,B)?.isFullScreen??!1}async toggleFullScreen(B,N){this.windowById(N?.targetWindowId,B)?.toggleFullScreen()}async handleTitleDoubleClick(B,N){this.windowById(N?.targetWindowId,B)?.handleTitleDoubleClick()}async getCursorScreenPoint(B){const N=o.screen.getCursorScreenPoint(),z=o.screen.getDisplayNearestPoint(N);return{point:N,display:z.bounds}}async isMaximized(B,N){return this.windowById(N?.targetWindowId,B)?.win?.isMaximized()??!1}async maximizeWindow(B,N){this.windowById(N?.targetWindowId,B)?.win?.maximize()}async unmaximizeWindow(B,N){this.windowById(N?.targetWindowId,B)?.win?.unmaximize()}async minimizeWindow(B,N){this.windowById(N?.targetWindowId,B)?.win?.minimize()}async moveWindowTop(B,N){this.windowById(N?.targetWindowId,B)?.win?.moveTop()}async positionWindow(B,N,z){const se=this.windowById(z?.targetWindowId,B);if(se?.win){if(se.win.isFullScreen()){const J=R.Event.toPromise(R.Event.once(R.Event.fromNodeEventEmitter(se.win,"leave-full-screen")));se.win.setFullScreen(!1),await J}se.win.setBounds(N)}}async updateWindowControls(B,N){this.windowById(N?.targetWindowId,B)?.updateWindowControls(N)}async focusWindow(B,N){this.windowById(N?.targetWindowId,B)?.focus({force:N?.force??!1})}async setMinimumSize(B,N,z){const se=this.codeWindowById(B);if(se?.win){const[J,le]=se.win.getSize(),[K,ee]=se.win.getMinimumSize(),[q,O]=[N??K,z??ee],[x,j]=[Math.max(J,q),Math.max(le,O)];(K!==q||ee!==O)&&se.win.setMinimumSize(q,O),(J!==x||le!==j)&&se.win.setSize(x,j)}}async saveWindowSplash(B,N){this.themeMainService.saveWindowSplash(B,N)}async installShellCommand(B){const{source:N,target:z}=await this.getShellCommandLink();try{const{symbolicLink:se}=await v.SymlinkSupport.stat(N);if(se&&!se.dangling){const J=await(0,w.realpath)(N);if(z===J)return}await v.Promises.unlink(N)}catch(se){if(se.code!=="ENOENT")throw se}try{await v.Promises.symlink(z,N)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:J}=await this.showMessageBox(B,{type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,p.localize)(1,null),(0,p.localize)(2,null)]});if(J===1)throw new L.CancellationError;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${N}'\\" with administrator privileges"`;await(0,k.promisify)(n.exec)(le)}catch{throw new Error((0,p.localize)(3,null,N))}}}async uninstallShellCommand(B){const{source:N}=await this.getShellCommandLink();try{await v.Promises.unlink(N)}catch(z){switch(z.code){case"EACCES":{const{response:se}=await this.showMessageBox(B,{type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,p.localize)(5,null),(0,p.localize)(6,null)]});if(se===1)throw new L.CancellationError;try{const J=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,k.promisify)(n.exec)(J)}catch{throw new Error((0,p.localize)(7,null,N))}break}case"ENOENT":break;default:throw z}}}async getShellCommandLink(){const B=(0,h.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),N=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(B))throw new Error((0,p.localize)(8,null,B));return{source:N,target:B}}async showMessageBox(B,N){const z=this.windowById(N?.targetWindowId,B);return this.dialogMainService.showMessageBox(N,z?.win??void 0)}async showSaveDialog(B,N){const z=this.windowById(N?.targetWindowId,B);return this.dialogMainService.showSaveDialog(N,z?.win??void 0)}async showOpenDialog(B,N){const z=this.windowById(N?.targetWindowId,B);return this.dialogMainService.showOpenDialog(N,z?.win??void 0)}async pickFileFolderAndOpen(B,N){const z=await this.dialogMainService.pickFileFolder(N);z&&await this.doOpenPicked(await Promise.all(z.map(async se=>await v.SymlinkSupport.existsDirectory(se)?{folderUri:g.URI.file(se)}:{fileUri:g.URI.file(se)})),N,B)}async pickFolderAndOpen(B,N){const z=await this.dialogMainService.pickFolder(N);z&&await this.doOpenPicked(z.map(se=>({folderUri:g.URI.file(se)})),N,B)}async pickFileAndOpen(B,N){const z=await this.dialogMainService.pickFile(N);z&&await this.doOpenPicked(z.map(se=>({fileUri:g.URI.file(se)})),N,B)}async pickWorkspaceAndOpen(B,N){const z=await this.dialogMainService.pickWorkspace(N);z&&await this.doOpenPicked(z.map(se=>({workspaceUri:g.URI.file(se)})),N,B)}async doOpenPicked(B,N,z){await this.windowsMainService.open({context:r.OpenContext.DIALOG,contextWindowId:z,cli:this.environmentMainService.args,urisToOpen:B,forceNewWindow:N.forceNewWindow})}async showItemInFolder(B,N){o.shell.showItemInFolder(N)}async setRepresentedFilename(B,N,z){this.windowById(z?.targetWindowId,B)?.setRepresentedFilename(N)}async setDocumentEdited(B,N,z){this.windowById(z?.targetWindowId,B)?.setDocumentEdited(N)}async openExternal(B,N){return this.environmentMainService.unsetSnapExportedVariables(),o.shell.openExternal(N),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(B,N){return o.shell.trashItem(N)}async isAdmin(){let B;return f.isWindows?B=(await new Promise((N,z)=>{V(["native-is-elevated"],N,z)}).then(ke)).default():B=process.getuid?.()===0,B}async writeElevated(B,N,z,se){const J=await new Promise((le,K)=>{V(["@vscode/sudo-prompt"],le,K)}).then(ke);return new Promise((le,K)=>{const ee=[`"${this.cliPath}"`];se?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${N.fsPath}"`,`"${z.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:f.isMacintosh&&this.environmentMainService.isBuilt?(0,h.join)((0,h.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};J.exec(ee.join(" "),q,(O,x,j)=>{x&&this.logService.trace(`[sudo-prompt] received stdout: ${x}`),j&&this.logService.trace(`[sudo-prompt] received stderr: ${j}`),O?K(O):le(void 0)})})}async isRunningUnderARM64Translation(){return f.isLinux||f.isWindows?!1:o.app.runningUnderARM64Translation}get cliPath(){return f.isWindows?this.environmentMainService.isBuilt?(0,h.join)((0,h.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,h.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):f.isLinux?this.environmentMainService.isBuilt?(0,h.join)((0,h.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,h.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,h.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,h.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,I.totalmem)(),freemem:(0,I.freemem)(),loadavg:(0,I.loadavg)()}}async getOSProperties(){return{arch:(0,I.arch)(),platform:(0,I.platform)(),release:(0,I.release)(),type:(0,I.type)(),cpus:(0,I.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return f.isWindows&&(0,S.hasWSLFeatureInstalled)()}async getProcessId(B){return this.windowById(void 0,B)?.win?.webContents.getOSProcessId()}async killProcess(B,N,z){process.kill(N,z)}async readClipboardText(B,N){return o.clipboard.readText(N)}async writeClipboardText(B,N,z){return o.clipboard.writeText(N,z)}async readClipboardFindText(B){return o.clipboard.readFindText()}async writeClipboardFindText(B,N){return o.clipboard.writeFindText(N)}async writeClipboardBuffer(B,N,z,se){return o.clipboard.writeBuffer(N,Buffer.from(z.buffer),se)}async readClipboardBuffer(B,N){return P.VSBuffer.wrap(o.clipboard.readBuffer(N))}async hasClipboard(B,N,z){return o.clipboard.has(N,z)}async newWindowTab(){await this.windowsMainService.open({context:r.OpenContext.API,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){o.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){o.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){o.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){o.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){o.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(B,N){this.codeWindowById(B)?.updateTouchBar(N)}async notifyReady(B){this.codeWindowById(B)?.setReady()}async relaunch(B,N){return this.lifecycleMainService.relaunch(N)}async reload(B,N){const z=this.codeWindowById(B);if(z){if((0,l.isWorkspaceIdentifier)(z.openedWorkspace)){const se=z.openedWorkspace.configPath;if(se.scheme===a.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(z,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(B,N){return this.windowById(N?.targetWindowId,B)?.win?.close()}async quit(B){const N=this.windowsMainService.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&N.win?N.win.close():this.lifecycleMainService.quit()}async exit(B,N){await this.lifecycleMainService.kill(N)}async resolveProxy(B,N){return this.codeWindowById(B)?.win?.webContents?.session?.resolveProxy(N)}async loadCertificates(B){return(await new Promise((z,se)=>{V(["@vscode/proxy-agent"],z,se)}).then(ke)).loadSystemCertificates({log:this.logService})}findFreePort(B,N,z,se,J=1){return(0,E.findFreePort)(N,z,se,J)}async openDevTools(B,N){this.windowById(N?.targetWindowId,B)?.win?.webContents.openDevTools(N?.mode?{mode:N.mode,activate:N.activate}:void 0)}async toggleDevTools(B,N){this.windowById(N?.targetWindowId,B)?.win?.webContents.toggleDevTools()}async profileRenderer(B,N,z){const se=this.codeWindowById(B);if(!se||!se.win)throw new Error;return await new M.WindowProfiler(se.win,N,this.logService).inspect(z)}async windowsGetStringRegKey(B,N,z,se){if(!f.isWindows)return;const J=await new Promise((le,K)=>{V(["@vscode/windows-registry"],le,K)}).then(ke);try{return J.GetStringRegKey(N,z,se)}catch{return}}windowById(B,N){return this.codeWindowById(B)??this.auxiliaryWindowById(B)??this.codeWindowById(N)}codeWindowById(B){if(typeof B=="number")return this.windowsMainService.getWindowById(B)}auxiliaryWindowById(B){if(typeof B!="number")return;const N=o.webContents.fromId(B);if(N)return this.auxiliaryWindowsMainService.getWindowByWebContents(N)}};e.NativeHostMainService=A,Pe([C.memoize],A.prototype,"cliPath",null),e.NativeHostMainService=A=Pe([ne(0,r.IWindowsMainService),ne(1,T.IAuxiliaryWindowsMainService),ne(2,m.IDialogMainService),ne(3,t.ILifecycleMainService),ne(4,b.IEnvironmentMainService),ne(5,s.ILogService),ne(6,i.IProductService),ne(7,c.IThemeMainService),ne(8,u.IWorkspacesManagementMainService)],A)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[308],ae([0,1,14,27,8,23,2,12,3,35,185,53,24,5,65,73,74,51,29]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0,v=et(v);let D=class{static{b=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(s,i,c,r,l,u,P){this.userEnv=s,this.environmentMainService=i,this.logService=c,this.dialogMainService=r,this.nativeHostMainService=l,this.protocolMainService=u,this.windowsMainService=P,this.issueReporterWindow=null,this.issueReporterParentWindow=null}async openReporter(s){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=n.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const i=new C.DisposableStore,c=i.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(r,c,{backgroundColor:s.styles.backgroundColor,title:(0,h.localize)(0,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:v.default}),this.issueReporterWindow.loadURL(R.FileAccess.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(s){this.logService.error(s)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:s}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(1,null),buttons:[(0,h.localize)(2,null),(0,h.localize)(3,null)]},this.issueReporterWindow);s===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:s}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(4,null),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]},this.issueReporterWindow);return s===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const s=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!s)throw new Error("Window not found");return s}async $sendReporterMenu(s,i){const c=this.issueReporterWindowCheck(),r="vscode:triggerReporterMenu",l=new k.CancellationTokenSource;return c.sendWhenReady(r,l.token,{replyChannel:r,extensionId:s,extensionName:i}),await(0,I.raceTimeout)(new Promise(P=>a.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${s}`,(S,M)=>P(M))),5e3,()=>{this.logService.error(`Error: Extension ${s} timed out waiting for menu response`),l.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,c,r){const l=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:c.title,backgroundColor:c.backgroundColor||b.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,p.zoomLevelToZoomFactor)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return l.setMenuBarVisibility(!1),l}getWindowPosition(s,i,c){let r;const l=n.screen.getAllDisplays();if(l.length===1)r=l[0];else{if(y.isMacintosh){const S=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint(S)}!r&&s&&(r=n.screen.getDisplayMatching(s.getBounds())),r||(r=n.screen.getPrimaryDisplay()||l[0])}const u=r.bounds,P={width:i,height:c,x:u.x+u.width/2-i/2,y:u.y+u.height/2-c/2};return u.width>0&&u.height>0&&(P.x<u.x&&(P.x=u.x),P.y<u.y&&(P.y=u.y),P.x>u.x+u.width&&(P.x=u.x),P.y>u.y+u.height&&(P.y=u.y),P.width>u.width&&(P.width=u.width),P.height>u.height&&(P.height=u.height)),P}};e.IssueMainService=D,e.IssueMainService=D=b=Pe([ne(1,g.IEnvironmentMainService),ne(2,w.ILogService),ne(3,f.IDialogMainService),ne(4,d.INativeHostMainService),ne(5,E.IProtocolMainService),ne(6,m.IWindowsMainService)],D)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[309],ae([0,1,14,31,2,12,3,116,35,186,97,136,53,24,5,65,73,28,74,34,64,51]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ProcessMainService=void 0,E=et(E);const i="issue.processExplorerWindowState";let c=class{static{s=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(u,P,S,M,T,L,A,_,B,N){this.userEnv=u,this.environmentMainService=P,this.logService=S,this.diagnosticsService=M,this.diagnosticsMainService=T,this.dialogMainService=L,this.nativeHostMainService=A,this.protocolMainService=_,this.productService=B,this.stateService=N,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.validatedIpcMain.on("vscode:listProcesses",async u=>{const P=[];try{P.push({name:(0,a.localize)(0,null),rootProcess:await(0,R.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(M=>{(0,h.isRemoteDiagnosticError)(M)?P.push({name:M.hostName,rootProcess:M}):M.processes&&P.push({name:M.hostName,rootProcess:M.processes})})}catch(S){this.logService.error(`Listing processes failed: ${S}`)}this.safeSend(u,"vscode:listProcessesResponse",P)}),y.validatedIpcMain.on("vscode:workbenchCommand",(u,P)=>{const{id:S,from:M,args:T}=P;let L;switch(M){case"processExplorer":L=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${M}`)}L?.webContents.send("vscode:runAction",{id:S,from:M,args:T})}),y.validatedIpcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow?.close()}),y.validatedIpcMain.on("vscode:pidToNameRequest",async u=>{const P=await this.diagnosticsMainService.getMainDiagnostics(),S=[];for(const M of P.windows)S.push([M.pid,`window [${M.id}] (${M.title})`]);for(const{pid:M,name:T}of D.UtilityProcess.getAll())S.push([M,T]);this.safeSend(u,"vscode:pidToNameResponse",S)})}async openProcessExplorer(u){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=n.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const P=new I.DisposableStore,S=P.add(this.protocolMainService.createIPCObjectUrl()),M=this.stateService.getItem(i,void 0),T=r(M)?M:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(T,S,{backgroundColor:u.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0},"process-explorer"),S.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:E.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,P.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,P.dispose())});const L=()=>{if(!this.processExplorerWindow)return;const A=this.processExplorerWindow.getSize(),_=this.processExplorerWindow.getPosition();if(!A||!_)return;const B={width:A[0],height:A[1],x:_[0],y:_[1]};this.stateService.setItem(i,B)};this.processExplorerWindow.on("moved",L),this.processExplorerWindow.on("resized",L)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(u){u.isMinimized()&&u.restore(),u.focus()}getWindowPosition(u,P,S){let M;const T=n.screen.getAllDisplays();if(T.length===1)M=T[0];else{if(C.isMacintosh){const _=n.screen.getCursorScreenPoint();M=n.screen.getDisplayNearestPoint(_)}!M&&u&&(M=n.screen.getDisplayMatching(u.getBounds())),M||(M=n.screen.getPrimaryDisplay()||T[0])}const L=M.bounds,A={width:P,height:S,x:L.x+L.width/2-P/2,y:L.y+L.height/2-S/2};return L.width>0&&L.height>0&&(A.x<L.x&&(A.x=L.x),A.y<L.y&&(A.y=L.y),A.x>L.x+L.width&&(A.x=L.x),A.y>L.y+L.height&&(A.y=L.y),A.width>L.width&&(A.width=L.width),A.height>L.height&&(A.height=L.height)),A}async stopTracing(){if(!this.environmentMainService.args.trace)return;const u=await n.contentTracing.stopRecording(`${(0,o.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,a.localize)(2,null),detail:(0,a.localize)(3,null,u),buttons:[(0,a.localize)(4,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,u)}async getSystemStatus(){const[u,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,P)}async $getSystemInfo(){const[u,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(u,P)}async $getPerformanceInfo(){try{const[u,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,P)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}createBrowserWindow(u,P,S,M){const T=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:S.title,backgroundColor:S.backgroundColor||s.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.zoomLevelToZoomFactor)(S.zoomLevel),sandbox:!0},alwaysOnTop:S.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}safeSend(u,P,...S){u.sender.isDestroyed()||u.sender.send(P,...S)}async closeProcessExplorer(){this.processExplorerWindow?.close()}};e.ProcessMainService=c,e.ProcessMainService=c=s=Pe([ne(1,w.IEnvironmentMainService),ne(2,d.ILogService),ne(3,h.IDiagnosticsService),ne(4,f.IDiagnosticsMainService),ne(5,g.IDialogMainService),ne(6,v.INativeHostMainService),ne(7,m.IProtocolMainService),ne(8,p.IProductService),ne(9,b.IStateService)],c);function r(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(oe[310],ae([0,1,23,18,24,20,5,65,28,57,25,50,106]),function(V,e,n,o,I,k,C,R,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends g.AbstractUpdateService{constructor(v,E,p,m,b,D,t,s){super(v,E,m,b,D,s),this.telemetryService=p,this.nativeHostMainService=t}buildUpdateFeedUrl(v){return(0,g.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){this.url&&(this.setState(f.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},n.CancellationToken.None).then(a.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(f.State.Idle(f.UpdateType.Archive))):this.setState(f.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E);const p=v?E.message||E:void 0;this.setState(f.State.Idle(f.UpdateType.Archive,p))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(f.State.Idle(f.UpdateType.Archive))}};e.LinuxUpdateService=w,e.LinuxUpdateService=w=Pe([ne(0,k.ILifecycleMainService),ne(1,o.IConfigurationService),ne(2,h.ITelemetryService),ne(3,I.IEnvironmentMainService),ne(4,a.IRequestService),ne(5,C.ILogService),ne(6,R.INativeHostMainService),ne(7,y.IProductService)],w)}),define(oe[311],ae([0,1,49,47,27,8,23,54,46,10,7,149,21,18,24,15,20,5,65,28,57,25,50,106]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0,o=ke(o),a=ke(a),g=ke(g);async function c(P,S=1e3){for(;!P();)await(0,k.timeout)(S)}let r;function l(){return typeof r>"u"&&(r=o.existsSync(a.join(a.dirname(process.execPath),"unins000.exe"))?s.UpdateType.Setup:s.UpdateType.Archive),r}let u=class extends i.AbstractUpdateService{get cachePath(){const S=a.join((0,I.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return g.Promises.mkdir(S,{recursive:!0}).then(()=>S)}constructor(S,M,T,L,A,_,B,N,z){super(S,M,L,A,_,z),this.telemetryService=T,this.fileService=B,this.nativeHostMainService=N,S.setRelaunchHandler(this)}handleRelaunch(S){return S?.addArgs||S?.removeArgs||this.state.type!==s.StateType.Ready||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(s.State.Disabled(s.DisablementReason.RunningAsAdmin)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(S){let M=`win32-${process.arch}`;return l()===s.UpdateType.Archive?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,i.createUpdateURL)(M,S,this.productService)}doCheckForUpdates(S){this.url&&(this.setState(s.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},C.CancellationToken.None).then(D.asJson).then(M=>{const T=l();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(s.State.Idle(T)),Promise.resolve(null)):T===s.UpdateType.Archive?(this.setState(s.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(s.State.Downloading),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(L=>g.Promises.exists(L).then(A=>{if(A)return Promise.resolve(L);const _=`${L}.tmp`;return this.requestService.request({url:M.url},C.CancellationToken.None).then(B=>this.fileService.writeFile(h.URI.file(_),B.stream)).then(M.sha256hash?()=>(0,f.checksum)(_,M.sha256hash):()=>{}).then(()=>g.Promises.rename(_,L,!1)).then(()=>L)})).then(L=>{this.availableUpdate={packagePath:L},this.setState(s.State.Downloaded(M)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(s.State.Ready(M))})))}).then(void 0,M=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,y.hash)(String(M)))}),this.logService.error(M);const T=S?M.message||M:void 0;this.setState(s.State.Idle(l(),T))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(s.State.Idle(l()))}async getUpdatePackagePath(S){const M=await this.cachePath;return a.join(M,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const M=S?_=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(_):()=>!0,T=await this.cachePath,A=(await g.Promises.readdir(T)).filter(M).map(async _=>{try{await g.Promises.unlink(a.join(T,_))}catch{}});await Promise.all(A)}async doApplyUpdate(){if(this.state.type!==s.StateType.Downloaded||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(s.State.Updating(S));const M=await this.cachePath;this.availableUpdate.updateFilePath=a.join(M,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await g.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,n.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(s.State.Idle(l()))});const L=`${this.productService.win32MutexName}-ready`,A=await new Promise((_,B)=>{V(["@vscode/windows-mutex"],_,B)}).then(ke);c(()=>A.isActive(L)).then(()=>this.setState(s.State.Ready(S)))}doQuitAndInstall(){this.state.type!==s.StateType.Ready||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?o.unlinkSync(this.availableUpdate.updateFilePath):(0,n.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return l()}async _applySpecificUpdate(S){if(this.state.type!==s.StateType.Idle)return;const M=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.setState(s.State.Downloading),this.availableUpdate={packagePath:S},this.setState(s.State.Downloaded(T)),M?this.productService.target==="user"&&this.doApplyUpdate():this.setState(s.State.Ready(T))}};e.Win32UpdateService=u,Pe([R.memoize],u.prototype,"cachePath",null),e.Win32UpdateService=u=Pe([ne(0,E.ILifecycleMainService),ne(1,w.IConfigurationService),ne(2,t.ITelemetryService),ne(3,d.IEnvironmentMainService),ne(4,D.IRequestService),ne(5,p.ILogService),ne(6,v.IFileService),ne(7,m.INativeHostMainService),ne(8,b.IProductService)],u)}),define(oe[137],ae([0,1,14,8,23,55,4,2,12,71,3,7,197,27,70,18,53,24,69,15,20,5,28,74,286,88,25,111,77,51,29,30,60,52,40,34,59,72,22,6]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L,A,_,B,N,z,se,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var le;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(le||(le={}));class K extends R.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(O){this._win=O,this._register(C.Event.fromNodeEventEmitter(O,"maximize")(()=>this._onDidMaximize.fire())),this._register(C.Event.fromNodeEventEmitter(O,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(C.Event.fromNodeEventEmitter(O,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(C.Event.fromNodeEventEmitter(O,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(C.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(C.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const x=!(0,S.hasNativeTitlebar)(this.configurationService);if(h.isMacintosh&&x&&O.setSheetOffset((0,h.isBigSurOrNewer)((0,w.release)())?28:22),x&&(h.isWindows&&(0,S.useWindowControlsOverlay)(this.configurationService)||h.isMacintosh)){const j=this.stateService.getItem(K.windowControlHeightStateStorageKey);j?this.updateWindowControls({height:j}):this.updateWindowControls({height:S.DEFAULT_CUSTOM_TITLEBAR_HEIGHT})}h.isWindows&&x&&O.hookWindowMessage(278,()=>{const[ce,G]=O.getPosition(),de=n.screen.getCursorScreenPoint(),re=de.x-ce,Z=de.y-G;return!(re>30&&Z>=0&&Z<=Math.max(O.getBounds().height*.15,35))||(O.setEnabled(!1),O.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:re,y:Z})),0}),this.environmentMainService.args["open-devtools"]===!0&&O.webContents.openDevTools(),h.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(O,x,j,ce){super(),this.configurationService=O,this.stateService=x,this.environmentMainService=j,this.logService=ce,this._onDidClose=this._register(new C.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new C.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new C.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new C.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new C.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new C.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,S.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}applyState(O,x=n.screen.getAllDisplays().length>0){const j=this.configurationService.getValue("window"),ce=h.isMacintosh&&j?.nativeTabs===!0;(h.isMacintosh||h.isWindows)&&x&&(!ce||n.BrowserWindow.getAllWindows().length===1)&&[O.width,O.height,O.x,O.y].every(G=>typeof G=="number")&&this._win?.setBounds({width:O.width,height:O.height,x:O.x,y:O.y}),(O.mode===A.WindowMode.Maximized||O.mode===A.WindowMode.Fullscreen)&&(this._win?.maximize(),O.mode===A.WindowMode.Fullscreen&&this.setFullScreen(!0,!0),this._win?.show())}setRepresentedFilename(O){h.isMacintosh?this.win?.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return h.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){h.isMacintosh&&this.win?.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return h.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(O){h.isMacintosh&&O?.force&&n.app.focus({steal:!0});const x=this.win;x&&(x.isMinimized()&&x.restore(),x.focus())}handleTitleDoubleClick(){const O=this.win;if(O)if(h.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":O.minimize();break;case"None":break;case"Maximize":default:O.isMaximized()?O.unmaximize():O.maximize()}else O.isMaximized()?O.unmaximize():O.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(O){const x=this.win;if(x){if(O.height&&this.stateService.setItem(ee.windowControlHeightStateStorageKey,O.height),h.isWindows&&this.hasWindowControlOverlay)x.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0});else if(h.isMacintosh&&O.height!==void 0){const j=(O.height-15)/2;j?x.setWindowButtonPosition({x:j,y:j}):x.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(O,x){(0,S.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(O,x):this.setSimpleFullScreen(O)}get isFullScreen(){if(h.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const O=this.win,x=O?.isFullScreen(),j=O?.isSimpleFullScreen();return!!(x||j)}setNativeFullScreen(O,x){const j=this.win;j?.isSimpleFullScreen()&&j?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(O,x)}doSetNativeFullScreen(O,x){if(h.isMacintosh){this.transientIsNativeFullScreen=O;const ce=this.joinNativeFullScreenTransition=new o.DeferredPromise;(async()=>{const G=await Promise.race([ce.p,(0,o.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===ce&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!G&&O&&x&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(O)}setSimpleFullScreen(O){const x=this.win;x?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),x?.setSimpleFullScreen(O),x?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=K;let ee=class extends K{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const O=this.userDataProfilesService.profiles.find(x=>x.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&O?O:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(O,x,j,ce,G,de,re,Z,W,F,U,H,Y,Q,$,ie,fe,me,we,Ce,Ie){super(F,Ce,ce,x),this.loggerMainService=j,this.policyService=G,this.userDataProfilesService=de,this.fileService=re,this.applicationStorageMainService=Z,this.storageMainService=W,this.themeMainService=U,this.workspacesManagementMainService=H,this.backupMainService=Y,this.telemetryService=Q,this.dialogMainService=$,this.lifecycleMainService=ie,this.productService=fe,this.protocolMainService=me,this.windowsMainService=we,this._onWillLoad=this._register(new C.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new C.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new C.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=le.NONE;{const[De,Re]=this.restoreWindowState(O.state);this.windowState=De,this.logService.trace("window#ctor: using window state",De);const pe=Ie.invokeFunction(M.defaultBrowserWindowOptions,this.windowState,{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(pe),(0,a.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win),this.applyState(this.windowState,Re),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=le.READY;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===le.READY}get whenClosedOrLoaded(){return new Promise(O=>{function x(){j.dispose(),ce.dispose(),O()}const j=this.onDidClose(()=>x()),ce=this.onWillLoad(()=>x())})}registerListeners(){this._register(C.Event.fromNodeEventEmitter(this._win,"unresponsive")(()=>this.onWindowError(A.WindowError.UNRESPONSIVE))),this._register(C.Event.fromNodeEventEmitter(this._win.webContents,"render-process-gone",(x,j)=>j)(x=>this.onWindowError(A.WindowError.PROCESS_GONE,{...x}))),this._register(C.Event.fromNodeEventEmitter(this._win.webContents,"did-fail-load",(x,j,ce)=>({exitCode:j,reason:ce}))(({exitCode:x,reason:j})=>this.onWindowError(A.WindowError.LOAD,{reason:j,exitCode:x}))),this._register(C.Event.fromNodeEventEmitter(this._win.webContents,"will-prevent-unload")(x=>x.preventDefault())),this._register(C.Event.fromNodeEventEmitter(this._win.webContents,"did-finish-load")(()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)})),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",I.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",I.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(x=>this.onConfigurationUpdated(x))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(x=>this.onDidDeleteUntitledWorkspace(x)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(x,j)=>{const ce=await this.getMarketplaceHeaders();j({cancel:!1,requestHeaders:Object.assign(x.requestHeaders,ce)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(O,x){switch(O){case A.WindowError.PROCESS_GONE:this.logService.error(`CodeWindow: renderer process gone (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break;case A.WindowError.UNRESPONSIVE:this.logService.error("CodeWindow: detected unresponsive");break;case A.WindowError.LOAD:this.logService.error(`CodeWindow: failed to load (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:O,reason:x?.reason,code:x?.exitCode}),O){case A.WindowError.UNRESPONSIVE:case A.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(O===A.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:j,checkboxChecked:ce}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this._config?.workspace?(0,g.localize)(5,null):void 0},this._win);if(j!==2){const G=j===0;await this.destroyWindow(G,ce)}}else if(O===A.WindowError.PROCESS_GONE){let j;x?j=(0,g.localize)(7,null,x.reason,x.exitCode??"<unknown>"):j=(0,g.localize)(6,null);const{response:ce,checkboxChecked:G}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:j,detail:this._config?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this._config?.workspace?(0,g.localize)(13,null):void 0},this._win),de=ce===0;await this.destroyWindow(de,G)}break}}async destroyWindow(O,x){const j=this._config?.workspace;if(x&&j)try{const ce=this.storageMainService.workspaceStorage(j);await ce.init(),ce.delete("memento/workbench.parts.editor"),await ce.close()}catch(ce){this.logService.error(ce)}this._onDidDestroy.fire();try{if(O&&this._config){let ce,G;(0,T.isSingleFolderWorkspaceIdentifier)(j)?ce={folderUri:j.uri}:(0,T.isWorkspaceIdentifier)(j)?ce={workspaceUri:j.configPath}:G=!0,(0,se.firstOrDefault)(await this.windowsMainService.open({context:M.OpenContext.API,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ce?[ce]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(O){this._config?.workspace?.id===O.id&&(this._config.workspace=void 0)}onConfigurationUpdated(O){if(!O||O.affectsConfiguration("window.menuBarVisibility")){const x=this.getMenuBarVisibility();x!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=x,this.setMenuBarVisibility(x))}if(!O||O.affectsConfiguration("http.proxy")||O.affectsConfiguration("http.noProxy")){let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const j=(this.configurationService.getValue("http.noProxy")||[]).map(ce=>ce.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||j!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=j;const ce=x||"",G=j?`${j},<local>`:"<local>";this.logService.trace(`Setting proxy to '${ce}', bypassing '${G}'`),this._win.webContents.session.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(O){h.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,x=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!x.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),x.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,x),this.readyState===le.NONE?this._config=O:this.pendingLoadConfig=O,this.readyState=le.NAVIGATING,this._win.loadURL(y.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const j=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new o.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:O.workspace,reason:x.isReload?A.LoadReason.RELOAD:j?A.LoadReason.LOAD:A.LoadReason.INITIAL})}updateConfiguration(O,x){const j=(this._config??this.pendingLoadConfig)?.userEnv;if(j){const ce=(0,m.isLaunchedFromCli)(j)&&!(0,m.isLaunchedFromCli)(O.userEnv),G=this.isExtensionDevelopmentHost;(ce||G)&&(O.userEnv={...j,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),x.disableExtensions!==void 0&&(O["disable-extensions"]=x.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),O.partsSplash=this.themeMainService.getWindowSplash(),O.zoomLevel=this.getZoomLevel(),O.isCustomZoomLevel=typeof this.customZoomLevel=="number",O.isCustomZoomLevel&&O.partsSplash&&(O.partsSplash.zoomLevel=O.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),O.perfMarks=(0,a.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const x=Object.assign({},this._config);x.workspace=await this.validateWorkspaceBeforeReload(x),delete x.filesToOpenOrCreate,delete x.filesToDiff,delete x.filesToMerge,delete x.filesToWait,this.isExtensionDevelopmentHost&&O&&(x.verbose=O.verbose,x.debugId=O.debugId,x.extensionEnvironment=O.extensionEnvironment,x["inspect-extensions"]=O["inspect-extensions"],x["inspect-brk-extensions"]=O["inspect-brk-extensions"],x["extensions-dir"]=O["extensions-dir"]),x.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),x.isInitialStartup=!1,x.policiesData=this.policyService.serialize(),x.continueOn=this.environmentMainService.continueOn,x.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},x.logLevel=this.loggerMainService.getLogLevel(),x.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(x,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async validateWorkspaceBeforeReload(O){if((0,T.isWorkspaceIdentifier)(O.workspace)){const x=O.workspace.configPath;if(x.scheme===y.Schemas.file&&!await this.fileService.exists(x))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(O.workspace)){const x=O.workspace.uri;if(x.scheme===y.Schemas.file&&!await this.fileService.exists(x))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let j;try{j=n.screen.getDisplayMatching(this.getBounds())}catch{}const ce=(0,A.defaultWindowState)();return{mode:A.WindowMode.Fullscreen,display:j?j.id:void 0,width:this.windowState.width||ce.width,height:this.windowState.height||ce.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const O=Object.create(null);let x;if(!h.isMacintosh&&this._win.isMaximized()?x=A.WindowMode.Maximized:x=A.WindowMode.Normal,x===A.WindowMode.Maximized?O.mode=A.WindowMode.Maximized:O.mode=A.WindowMode.Normal,x===A.WindowMode.Normal||x===A.WindowMode.Maximized){let j;x===A.WindowMode.Normal?j=this.getBounds():j=this._win.getNormalBounds(),O.x=j.x,O.y=j.y,O.width=j.width,O.height=j.height}return O.zoomLevel=this.customZoomLevel,O}restoreWindowState(O){(0,a.mark)("code/willRestoreCodeWindowState");let x=!1;if(O){this.customZoomLevel=O.zoomLevel;try{const j=n.screen.getAllDisplays();x=j.length>1,O=M.WindowStateValidator.validateWindowState(this.logService,O,j)}catch(j){this.logService.warn(`Unexpected error validating window state: ${j}
${j.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[O||(0,A.defaultWindowState)(),x]}getBounds(){const[O,x]=this._win.getPosition(),[j,ce]=this._win.getSize();return{x:O,y:x,width:j,height:ce}}setFullScreen(O,x){super.setFullScreen(O,x),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",I.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let O=(0,S.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,x=!0){h.isMacintosh||(O==="toggle"&&x&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const x=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!x),this._win.autoHideMenuBar=x;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(O){this.customZoomLevel=O}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(O,x,...j){this.isReady?this.send(O,...j):this.ready().then(()=>{x.isCancellationRequested||this.send(O,...j)})}send(O,...x){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this._win.webContents.send(O,...x)}catch(j){this.logService.warn(`Error sending IPC message to channel '${O}' of window ${this._id}: ${(0,k.toErrorMessage)(j)}`)}}}updateTouchBar(O){h.isMacintosh&&this.touchBarGroups.forEach((x,j)=>{const ce=O[j];x.segments=this.createTouchBarGroupSegments(ce)})}createTouchBar(){if(h.isMacintosh){for(let O=0;O<10;O++){const x=this.createTouchBarGroup();this.touchBarGroups.push(x)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const x=this.createTouchBarGroupSegments(O),j=new n.TouchBar.TouchBarSegmentedControl({segments:x,mode:"buttons",segmentStyle:"automatic",change:ce=>{this.sendWhenReady("vscode:runAction",I.CancellationToken.None,{id:j.segments[ce].id,from:"touchbar"})}});return j}createTouchBarGroupSegments(O=[]){return O.map(j=>{let ce;j.icon&&!u.ThemeIcon.isThemeIcon(j.icon)&&j.icon?.dark?.scheme===y.Schemas.file&&(ce=n.nativeImage.createFromPath(f.URI.revive(j.icon.dark).fsPath),ce.isEmpty()&&(ce=void 0));let G;return typeof j.title=="string"?G=j.title:G=j.title.value,{id:j.id,label:ce?void 0:G,icon:ce}})}matches(O){return this._win?.webContents.id===O.id}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=ee,e.CodeWindow=ee=Pe([ne(1,t.ILogService),ne(2,z.ILoggerMainService),ne(3,p.IEnvironmentMainService),ne(4,_.IPolicyService),ne(5,N.IUserDataProfilesMainService),ne(6,b.IFileService),ne(7,r.IApplicationStorageMainService),ne(8,r.IStorageMainService),ne(9,v.IConfigurationService),ne(10,P.IThemeMainService),ne(11,L.IWorkspacesManagementMainService),ne(12,d.IBackupMainService),ne(13,l.ITelemetryService),ne(14,E.IDialogMainService),ne(15,D.ILifecycleMainService),ne(16,s.IProductService),ne(17,i.IProtocolMainService),ne(18,M.IWindowsMainService),ne(19,B.IStateService),ne(20,J.IInstantiationService)],ee)}),define(oe[312],ae([0,1,14,3,18,24,20,5,34,51,52,137]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let g=class extends f.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(d,v,E,p,m,b){super(p,m,v,E),this.webContents=d,this.lifecycleMainService=b,this.id=this.webContents.id,this.parentId=-1,this.stateApplied=!1,this.tryClaimWindow()}tryClaimWindow(d){this._store.isDisposed||this.webContents.isDestroyed()||(this.doTryClaimWindow(),d&&!this.stateApplied&&(this.stateApplied=!0,this.applyState({x:d.x,y:d.y,width:d.width,height:d.height,mode:d.show===!1?h.WindowMode.Maximized:h.WindowMode.Normal})))}doTryClaimWindow(){if(this._win)return;const d=n.BrowserWindow.fromWebContents(this.webContents);d&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(d),d.setMenu(null),(o.isWindows||o.isLinux)&&(0,a.hasNativeTitlebar)(this.configurationService)&&d.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}matches(d){return this.webContents.id===d.id}};e.AuxiliaryWindow=g,e.AuxiliaryWindow=g=Pe([ne(1,k.IEnvironmentMainService),ne(2,R.ILogService),ne(3,I.IConfigurationService),ne(4,y.IStateService),ne(5,C.ILifecycleMainService)],g)}),define(oe[313],ae([0,1,14,4,2,12,35,312,6,5,52,29]),function(V,e,n,o,I,k,C,R,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let g=class extends I.Disposable{constructor(d,v){super(),this.instantiationService=d,this.logService=v,this._onDidMaximizeWindow=this._register(new o.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new o.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new o.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new o.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){n.app.on("browser-window-created",(d,v)=>{const E=this.getWindowByWebContents(v.webContents);if(E)this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),E.tryClaimWindow();else{const p=new I.DisposableStore;p.add(o.Event.fromNodeEventEmitter(v.webContents,"did-create-window",(m,b)=>({browserWindow:m,details:b}))(({browserWindow:m,details:b})=>{const D=this.getWindowByWebContents(m.webContents);D&&(this.logService.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),D.tryClaimWindow(b.options))})),p.add(o.Event.fromNodeEventEmitter(v,"closed")(()=>p.dispose()))}}),C.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(d,v)=>{const E=this.getWindowByWebContents(d.sender);return E&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),E.parentId=v),d.sender.id})}createWindow(d){return this.instantiationService.invokeFunction(f.defaultBrowserWindowOptions,this.validateWindowState(d),{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}validateWindowState(d){const v={},E=d.features.split(",");for(const m of E){const[b,D]=m.split("=");switch(b){case"width":v.width=parseInt(D,10);break;case"height":v.height=parseInt(D,10);break;case"left":v.x=parseInt(D,10);break;case"top":v.y=parseInt(D,10);break;case"window-maximized":v.mode=h.WindowMode.Maximized;break;case"window-fullscreen":v.mode=h.WindowMode.Fullscreen;break}}const p=f.WindowStateValidator.validateWindowState(this.logService,v)??(0,h.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",p),p}registerWindow(d){const v=new I.DisposableStore,E=this.instantiationService.createInstance(R.AuxiliaryWindow,d);this.windows.set(E.id,E),v.add((0,I.toDisposable)(()=>this.windows.delete(E.id))),v.add(E.onDidMaximize(()=>this._onDidMaximizeWindow.fire(E))),v.add(E.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(E))),v.add(E.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!0}))),v.add(E.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!1}))),v.add(E.onDidTriggerSystemContextMenu(({x:p,y:m})=>this._onDidTriggerSystemContextMenu.fire({window:E,x:p,y:m}))),o.Event.once(E.onDidClose)(()=>v.dispose())}getWindowByWebContents(d){const v=this.windows.get(d.id);return v?.matches(d)?v:void 0}getFocusedWindow(){const d=n.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,f.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=g,e.AuxiliaryWindowsMainService=g=Pe([ne(0,y.IInstantiationService),ne(1,a.ILogService)],g)}),define(oe[89],ae([0,1,14,22,8,4,48,2,12,3,19,7,21,200,6,20,5,63,88,103,30,60,32,53]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let r=class extends R.Disposable{static{c=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(u,P,S,M,T){super(),this.logService=u,this.workspacesManagementMainService=P,this.lifecycleMainService=S,this.applicationStorageMainService=M,this.dialogMainService=T,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new I.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(v.LifecycleMainPhase.Eventually).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){let P=[],S=[];for(const T of u)if((0,b.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&!this.containsWorkspace(P,T.workspace)&&P.push(T);else if((0,b.isRecentFolder)(T))this.containsFolder(P,T.folderUri)||P.push(T);else{const L=this.containsFile(S,T.fileUri),A=T.fileUri.scheme===y.Schemas.file&&c.COMMON_FILES_FILTER.indexOf((0,h.basename)(T.fileUri))>=0;!L&&!A&&(S.push(T),a.isWindows&&T.fileUri.scheme===y.Schemas.file&&n.app.addRecentDocument(T.fileUri.fsPath))}const M=await this.mergeEntriesFromStorage({workspaces:P,files:S});P=M.workspaces,S=M.files,P.length>c.MAX_TOTAL_RECENT_ENTRIES&&(P.length=c.MAX_TOTAL_RECENT_ENTRIES),S.length>c.MAX_TOTAL_RECENT_ENTRIES&&(S.length=c.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:P,files:S}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(u){const P=L=>{const A=this.location(L);for(const _ of u)if(h.extUriBiasedIgnorePathCase.isEqual(_,A))return!1;return!0},S=await this.getRecentlyOpened(),M=S.workspaces.filter(P),T=S.files.filter(P);(M.length!==S.workspaces.length||T.length!==S.files.length)&&(await this.saveRecentlyOpened({files:T,workspaces:M}),this._onDidChangeRecentlyOpened.fire(),a.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(u){if(u?.confirm){const{response:P}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null)],message:(0,w.localize)(2,null),detail:(0,w.localize)(3,null),cancelId:1});if(P!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(u){const P=new s.ResourceMap(T=>h.extUriBiasedIgnorePathCase.getComparisonKey(T));if(u?.workspaces)for(const T of u.workspaces)P.set(this.location(T),T);const S=new s.ResourceMap(T=>h.extUriBiasedIgnorePathCase.getComparisonKey(T));if(u?.files)for(const T of u.files)S.set(this.location(T),T);const M=await this.getRecentlyOpenedFromStorage();for(const T of M.workspaces){const L=P.get(this.location(T));L?L.label=L.label??T.label:P.set(this.location(T),T)}for(const T of M.files){const L=S.get(this.location(T));L?L.label=L.label??T.label:S.set(this.location(T),T)}return{workspaces:[...P.values()],files:[...S.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let u;const P=this.applicationStorageMainService.get(c.RECENTLY_OPENED_STORAGE_KEY,p.StorageScope.APPLICATION);if(typeof P=="string")try{u=JSON.parse(P)}catch(S){this.logService.error("Unexpected error parsing opened paths list",S)}return(0,b.restoreRecentlyOpened)(u,this.logService)}async saveRecentlyOpened(u){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(c.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,b.toStoreData)(u)),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}location(u){return(0,b.isRecentFolder)(u)?u.folderUri:(0,b.isRecentFile)(u)?u.fileUri:u.workspace.configPath}containsWorkspace(u,P){return!!u.find(S=>(0,b.isRecentWorkspace)(S)&&S.workspace.id===P.id)}containsFolder(u,P){return!!u.find(S=>(0,b.isRecentFolder)(S)&&h.extUriBiasedIgnorePathCase.isEqual(S.folderUri,P))}containsFile(u,P){return!!u.find(S=>h.extUriBiasedIgnorePathCase.isEqual(S.fileUri,P))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async handleWindowsJumpList(){a.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!a.isWindows)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(4,null),description:(0,w.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const T of n.app.getJumpListSettings().removedItems){const L=T.args;if(L){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(L);A&&P.push(f.URI.parse(A[2]))}}await this.removeRecentlyOpened(P);let S=!1;const M=(0,o.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,c.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(T=>{const L=(0,b.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:A,description:_}=this.getWindowsJumpListLabel(L,T.label);let B;return f.URI.isUri(L)?B=`--folder-uri "${L.toString()}"`:(S=!0,B=`--file-uri "${L.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:_.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));M.length>0&&u.push({type:"custom",name:S?(0,w.localize)(6,null):(0,w.localize)(7,null),items:M})}u.push({type:"recent"});try{const P=n.app.setJumpList(u);P&&P!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.logService.warn("updateWindowsJumpList#setJumpList",P)}}getWindowsJumpListLabel(u,P){if(P)return{title:(0,C.splitRecentLabel)(P).name,description:P};if(f.URI.isUri(u))return{title:(0,h.basename)(u),description:this.renderJumpListPathDescription(u)};if(this.workspacesManagementMainService.isUntitledWorkspace(u))return{title:(0,w.localize)(8,null),description:""};let S=(0,h.basename)(u.configPath);return S.endsWith(D.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-D.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(9,null,S),description:this.renderJumpListPathDescription(u.configPath)}}renderJumpListPathDescription(u){return u.scheme==="file"?(0,C.normalizeDriveLetter)(u.fsPath):u.toString()}async updateMacOSRecentDocuments(){if(!a.isMacintosh)return;n.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),P=[];let S=0;for(let T=0;T<u.workspaces.length&&S<c.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const L=this.location(u.workspaces[T]);if(L.scheme===y.Schemas.file){const A=(0,h.originalFSPath)(L);await g.Promises.exists(A)&&(P.push(A),S++)}}const M=[];for(let T=0;T<u.files.length&&S<c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const L=this.location(u.files[T]);if(L.scheme===y.Schemas.file){const A=(0,h.originalFSPath)(L);if(c.COMMON_FILES_FILTER.includes((0,h.basename)(L))||P.includes(A))continue;await g.Promises.exists(A)&&(M.push(A),S++)}}M.reverse().forEach(T=>n.app.addRecentDocument(T)),P.reverse().forEach(T=>n.app.addRecentDocument(T))}};e.WorkspacesHistoryMainService=r,e.WorkspacesHistoryMainService=r=c=Pe([ne(0,E.ILogService),ne(1,t.IWorkspacesManagementMainService),ne(2,v.ILifecycleMainService),ne(3,m.IApplicationStorageMainService),ne(4,i.IDialogMainService)],r)}),define(oe[314],ae([0,1,14,8,23,48,3,7,188,85,18,24,20,5,236,65,28,34,25,50,51,29,89,2]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0,y=ke(y);const r="menu";let l=class extends i.Disposable{static{c=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,M,T,L,A,_,B,N,z,se,J,le){super(),this.updateService=S,this.configurationService=M,this.windowsMainService=T,this.environmentMainService=L,this.telemetryService=A,this.workspacesHistoryMainService=_,this.stateService=B,this.lifecycleMainService=N,this.logService=z,this.nativeHostMainService=se,this.productService=J,this.auxiliaryWindowsMainService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new o.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new o.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(C.isMacintosh||(0,D.hasNativeTitlebar)(M))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(c.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,B,N)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,B,N)=>this.windowsMainService.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,B,N)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,B,N)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,B,N)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const M=this.productService.requestFeatureUrl;M&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(M,"openUserVoiceUrl"));const T=this.productService.reportIssueUrl;T&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(T,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(C.language){const _=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${_}lang=${C.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0)),this._register(this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S))),this._register(this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus())),this._register(this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus()))}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!C.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,M){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(c.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){C.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!C.isMacintosh)return;const S=n.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!S||!!this.auxiliaryWindowsMainService.getWindowByWebContents(S.webContents),this.scheduleUpdateMenu()}install(){const S=n.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(C.isMacintosh?new n.Menu:null);return}const M=new n.Menu;let T;if(C.isMacintosh){const A=new n.Menu;T=new n.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),M.append(T)}if(C.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new n.Menu;A.append(new n.MenuItem({label:this.mnemonicLabel(y.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(1,null)),submenu:A});this.setMenuById(A,"File"),M.append(_)}if(this.shouldDrawMenu("Edit")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),M.append(_)}if(this.shouldDrawMenu("Selection")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),M.append(_)}if(this.shouldDrawMenu("View")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(4,null)),submenu:A});this.setMenuById(A,"View"),M.append(_)}if(this.shouldDrawMenu("Go")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),M.append(_)}if(this.shouldDrawMenu("Run")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),M.append(_)}if(this.shouldDrawMenu("Terminal")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),M.append(_)}let L;if(this.shouldDrawMenu("Window")){const A=new n.Menu;L=new n.MenuItem({label:this.mnemonicLabel(y.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(L&&M.append(L),this.shouldDrawMenu("Help")){const A=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(y.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),M.append(_)}M.items&&M.items.length>0?this.doSetApplicationMenu(M):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){if(n.Menu.setApplicationMenu(S),S)for(const M of this.auxiliaryWindowsMainService.getWindows())M.win?.setMenu(null)}setMacApplicationMenu(S){const M=this.createMenuItem(y.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),T=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const le=new n.Menu;this.setMenuById(le,"Preferences"),L=new n.MenuItem({label:this.mnemonicLabel(y.localize(11,null)),submenu:le})}const A=new n.Menu,_=new n.MenuItem({label:y.localize(12,null),role:"services",submenu:A}),B=new n.MenuItem({label:y.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),N=new n.MenuItem({label:y.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new n.MenuItem({label:y.localize(15,null),role:"unhide"}),se=new n.MenuItem(this.likeAction("workbench.action.quit",{label:y.localize(16,null,this.productService.nameLong),click:async(le,K,ee)=>{const q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||q?.win?.isMinimized())&&await this.confirmBeforeQuit(ee)&&this.nativeHostMainService.quit(void 0)}})),J=[M];J.push(...T),L&&J.push(u(),L),J.push(u(),_,u(),B,N,z,u(),se),J.forEach(le=>S.append(le))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const M=this.configurationService.getValue("window.confirmBeforeClose");if(M==="always"||M==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:T}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[y.localize(17,null),y.localize(18,null)],message:y.localize(19,null)});return T===0}return!0}shouldDrawMenu(S){if(!C.isMacintosh&&!(0,D.hasNativeTitlebar)(this.configurationService))return!1;switch(S){case"File":case"Help":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,M){M.forEach(T=>{if((0,d.isMenubarMenuItemSeparator)(T))S.append(u());else if((0,d.isMenubarMenuItemSubmenu)(T)){const L=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(T.label),submenu:L});this.setMenu(L,T.submenu.items),S.append(A)}else(0,d.isMenubarMenuItemRecentAction)(T)?S.append(this.createOpenRecentMenuItem(T)):(0,d.isMenubarMenuItemAction)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),C.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[T.id]?S.append(new n.MenuItem(this.likeAction(T.id,{label:this.mnemonicLabel(T.label),click:this.fallbackMenuHandlers[T.id]}))):S.append(this.createMenuItem(T.label,T.id,!1,T.checked)):S.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)):S.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)))})}setMenuById(S,M){this.menubarMenus&&this.menubarMenus[M]&&this.setMenu(S,this.menubarMenus[M].items)}insertCheckForUpdatesItems(S){const M=this.getUpdateMenuItems();M.length&&(M.forEach(T=>S.append(T)),S.append(u()))}createOpenRecentMenuItem(S){const M=R.URI.revive(S.uri),T=S.id,L=T==="openRecentFile"?{fileUri:M}:T==="openRecentWorkspace"?{workspaceUri:M}:{folderUri:M};return new n.MenuItem(this.likeAction(T,{label:S.label,click:async(A,_,B)=>{const N=this.isOptionClick(B);(await this.windowsMainService.open({context:t.OpenContext.MENU,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([M])}},!1))}isOptionClick(S){return!!(S&&(!C.isMacintosh&&(S.ctrlKey||S.shiftKey)||C.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,M,T){const L={label:this.mnemonicLabel(S),role:T,enabled:!0};return new n.MenuItem(this.withKeybinding(M,L))}setMacWindowMenu(S){const M=new n.MenuItem({label:y.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),T=new n.MenuItem({label:y.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new n.MenuItem({label:y.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(y.localize(23,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(u()),_.push(this.createMenuItem(y.localize(24,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(y.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(y.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(y.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(y.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[M,T,u(),A,..._,u(),L].forEach(B=>S.append(B))}getUpdateMenuItems(){switch(this.updateService.state.type){case b.StateType.Idle:return[new n.MenuItem({label:this.mnemonicLabel(y.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case b.StateType.CheckingForUpdates:return[new n.MenuItem({label:y.localize(30,null),enabled:!1})];case b.StateType.AvailableForDownload:return[new n.MenuItem({label:this.mnemonicLabel(y.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case b.StateType.Downloading:return[new n.MenuItem({label:y.localize(32,null),enabled:!1})];case b.StateType.Downloaded:return C.isMacintosh?[]:[new n.MenuItem({label:this.mnemonicLabel(y.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case b.StateType.Updating:return[new n.MenuItem({label:y.localize(34,null),enabled:!1})];case b.StateType.Ready:return[new n.MenuItem({label:this.mnemonicLabel(y.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,M,T,L){const A=this.mnemonicLabel(S),_=typeof M=="function"?M:(J,le,K)=>{const ee=J?J.userSettingsLabel:null;let q=M;Array.isArray(M)&&(q=this.isOptionClick(K)?M[1]:M[0]),ee&&K.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ee}):this.runActionInRenderer({type:"commandId",commandId:q})},B=typeof T=="boolean"?T:this.windowsMainService.getWindowCount()>0,N=typeof L=="boolean"?L:!1,z={label:A,click:_,enabled:B};N&&(z.type="checkbox",z.checked=N);let se;return typeof M=="string"?se=M:Array.isArray(M)&&(se=M[0]),C.isMacintosh&&(se==="editor.action.clipboardCutAction"?z.role="cut":se==="editor.action.clipboardCopyAction"?z.role="copy":se==="editor.action.clipboardPasteAction"&&(z.role="paste"),se==="undo"?z.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?z.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(z.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.withKeybinding(se,z))}makeContextAwareClickHandler(S,M){return(T,L,A)=>{const _=n.BrowserWindow.getFocusedWindow();if(!_)return M.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return M.inDevTools(_.webContents.devToolsWebContents);S(T,L||_,A)}}runActionInRenderer(S){let M=n.BrowserWindow.getFocusedWindow();if(M){const L=this.auxiliaryWindowsMainService.getWindowByWebContents(M.webContents);L&&(M=this.windowsMainService.getWindowById(L.parentId)?.win??null)}if(!M){const L=this.windowsMainService.getLastActiveWindow();L?.win?.isMinimized()&&(M=L.win)}const T=M?this.windowsMainService.getWindowById(M.id):void 0;if(T){if(this.logService.trace("menubar#runActionInRenderer",S),C.isMacintosh&&!this.environmentMainService.isBuilt&&!T.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return!1;if(S.type==="commandId"){const L={id:S.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",I.CancellationToken.None,L)}else{const L={userSettingsLabel:S.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",I.CancellationToken.None,L)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",S),!1}withKeybinding(S,M){const T=typeof S=="string"?this.keybindings[S]:void 0;if(T?.label){if(T.isNative!==!1)M.accelerator=T.label,M.userSettingsLabel=T.userSettingsLabel;else if(typeof M.label=="string"){const L=M.label.indexOf("[");L>=0?M.label=`${M.label.substr(0,L)} [${T.label}]`:M.label=`${M.label} [${T.label}]`}}else M.accelerator=void 0;return M}likeAction(S,M,T=!M.accelerator){T&&(M=this.withKeybinding(S,M));const L=M.click;return M.click=(A,_,B)=>{this.reportMenuActionTelemetry(S),L?.(A,_,B)},M}openUrl(S,M){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(M)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:r})}mnemonicLabel(S){return(0,k.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=l,e.Menubar=l=c=Pe([ne(0,b.IUpdateService),ne(1,h.IConfigurationService),ne(2,t.IWindowsMainService),ne(3,f.IEnvironmentMainService),ne(4,m.ITelemetryService),ne(5,s.IWorkspacesHistoryMainService),ne(6,p.IStateService),ne(7,g.ILifecycleMainService),ne(8,w.ILogService),ne(9,v.INativeHostMainService),ne(10,E.IProductService),ne(11,a.IAuxiliaryWindowsMainService)],l);function u(){return new n.MenuItem({type:"separator"})}}),define(oe[315],ae([0,1,6,20,5,314,2]),function(V,e,n,o,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,n.createDecorator)("menubarMainService");let R=class extends C.Disposable{constructor(a,h,f){super(),this.instantiationService=a,this.lifecycleMainService=h,this.logService=f,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(o.LifecycleMainPhase.AfterWindowOpen),this._register(this.instantiationService.createInstance(k.Menubar))}async updateMenubar(a,h){this.logService.trace("menubarService#updateMenubar",a),(await this.menubar).updateMenu(h,a)}};e.MenubarMainService=R,e.MenubarMainService=R=Pe([ne(0,n.IInstantiationService),ne(1,o.ILifecycleMainService),ne(2,I.ILogService)],R)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[316],ae([0,1,14,21,107,27,22,23,39,4,31,48,2,12,10,71,3,37,19,13,7,198,70,18,53,24,15,6,20,5,73,74,75,34,51,137,29,135,307,30,104,89,60,52,77,40,59,72,85]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L,A,_,B,N,z,se,J,le,K,ee,q,O,x,j,ce,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0,M=et(M);function de(W){return(0,J.isWorkspaceIdentifier)(W?.workspace)}function re(W){return(0,J.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let Z=class extends g.Disposable{constructor(F,U,H,Y,Q,$,ie,fe,me,we,Ce,Ie,De,Re,pe,X,ue,he,Se,Me,Ue){super(),this.machineId=F,this.sqmId=U,this.devDeviceId=H,this.initialUserEnv=Y,this.logService=Q,this.loggerService=$,this.stateService=ie,this.policyService=fe,this.environmentMainService=me,this.userDataProfilesMainService=we,this.lifecycleMainService=Ce,this.backupMainService=Ie,this.configurationService=De,this.workspacesHistoryMainService=Re,this.workspacesManagementMainService=pe,this.instantiationService=X,this.dialogMainService=ue,this.fileService=he,this.protocolMainService=Se,this.themeMainService=Me,this.auxiliaryWindowsMainService=Ue,this._onDidOpenWindow=this._register(new a.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new a.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new a.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new a.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new a.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new a.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new a.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new a.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new se.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const U=new g.DisposableStore;if(U.add(a.Event.any(F.onDidClose,F.onDidDestroy)(()=>U.dispose())),F.config.extensionDevelopmentPath)for(const H of F.config.extensionDevelopmentPath)U.add(this.protocolMainService.addValidFileRoot(H));F.config.extensionTestsPath&&U.add(this.protocolMainService.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,U){const H=this.environmentMainService.args,Y=U?.remoteAuthority||void 0,Q=!0,$=U?.forceReuseWindow,ie=!$;return this.open({...F,cli:H,forceEmpty:Q,forceNewWindow:ie,forceReuseWindow:$,remoteAuthority:Y,forceTempProfile:U?.forceTempProfile,forceProfile:U?.forceProfile})}openExistingWindow(F,U){F.focus(),this.handleWaitMarkerFile(U,[F])}async open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const U=[],H=[],Y=[],Q=[],$=[];let ie,fe=0;const me=await this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",me);for(const Re of me)re(Re)?F.addMode?U.push(Re):H.push(Re):de(Re)?Y.push(Re):Re.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),ie.filesToOpenOrCreate.push(Re)):Re.backupPath?$.push({backupFolder:(0,d.basename)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):fe++;F.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),F.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&F.waitMarkerFileURI&&(ie.filesToWait={paths:(0,C.coalesce)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),Y.push(...Q),$.push(...this.backupMainService.getEmptyWindowBackups())):$.length=0;const{windows:we,filesOpenedInWindow:Ce}=await this.doOpen(F,Y,H,$,fe,ie,U);if(this.logService.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${H.length}, emptyToRestore: ${$.length}, emptyToOpen: ${fe})`),we.length>1)if(Ce)Ce.focus();else{const Re=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let pe=!0,X=!0;if(Re){const ue=we.filter(he=>this.windowsStateHandler.state.lastActiveWindow&&he.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),pe=!1,X=!1)}if(pe)for(let ue=we.length-1;ue>=0;ue--){const he=we[ue];if(!(he.openedWorkspace&&Q.some(Se=>he.openedWorkspace&&Se.workspace.id===he.openedWorkspace.id)||he.backupPath&&$.some(Se=>he.backupPath&&Se.backupFolder===(0,d.basename)(he.backupPath)))){he.focus(),X=!1;break}}X&&we[we.length-1].focus()}const Ie=ie&&ie.filesToDiff.length>0,De=ie&&ie.filesToMerge.length>0;if(!we.some(Re=>Re.isExtensionDevelopmentHost)&&!Ie&&!De&&!F.noRecentEntry){const Re=[];for(const pe of me)de(pe)&&!pe.transient?Re.push({label:pe.label,workspace:pe.workspace,remoteAuthority:pe.remoteAuthority}):re(pe)?Re.push({label:pe.label,folderUri:pe.workspace.uri,remoteAuthority:pe.remoteAuthority}):pe.fileUri&&Re.push({label:pe.label,fileUri:pe.fileUri,remoteAuthority:pe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Re)}return this.handleWaitMarkerFile(F,we),we}handleWaitMarkerFile(F,U){const H=F.waitMarkerFileURI;F.context===N.OpenContext.CLI&&H&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.fileService.del(H)}catch{}})()}async doOpen(F,U,H,Y,Q,$,ie){const fe=[];let me;function we(ue,he){fe.push(ue),he&&(me=ue,$=void 0)}let{openFolderInNewWindow:Ce,openFilesInNewWindow:Ie}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,he=this.getLastActiveWindowForAuthority(ue);he&&we(this.doAddFoldersToExistingWindow(he,ie.map(Se=>Se.workspace.uri)))}const De=H.length+U.length+Y.length;if($&&De===0){const ue=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],he=this.getWindows().filter(Me=>$&&(0,m.isEqualAuthority)(Me.remoteAuthority,$.remoteAuthority));let Se;ue?.fileUri&&!Ie&&((F.context===N.OpenContext.DESKTOP||F.context===N.OpenContext.CLI||F.context===N.OpenContext.DOCK)&&(Se=await(0,z.findWindowOnFile)(he,ue.fileUri,async Me=>Me.configPath.scheme===w.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Me.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(he))),Se?(0,J.isWorkspaceIdentifier)(Se.openedWorkspace)?U.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?H.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):we(this.doOpenFilesInExistingWindow(F,Se,$),!0):we(await this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const Re=(0,C.distinct)(U,ue=>ue.workspace.id);if(Re.length>0){const ue=(0,C.coalesce)(Re.map(he=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.configPath)));if(ue.length>0){const he=ue[0],Se=(0,m.isEqualAuthority)($?.remoteAuthority,he.remoteAuthority)?$:void 0;we(this.doOpenFilesInExistingWindow(F,he,Se),!!Se),Ce=!0}for(const he of Re){if(ue.some(Ue=>Ue.openedWorkspace&&Ue.openedWorkspace.id===he.workspace.id))continue;const Se=he.remoteAuthority,Me=(0,m.isEqualAuthority)($?.remoteAuthority,Se)?$:void 0;we(await this.doOpenFolderOrWorkspace(F,he,Ce,Me),!!Me),Ce=!0}}const pe=(0,C.distinct)(H,ue=>m.extUriBiasedIgnorePathCase.getComparisonKey(ue.workspace.uri));if(pe.length>0){const ue=(0,C.coalesce)(pe.map(he=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.uri)));if(ue.length>0){const he=ue[0],Se=(0,m.isEqualAuthority)($?.remoteAuthority,he.remoteAuthority)?$:void 0;we(this.doOpenFilesInExistingWindow(F,he,Se),!!Se),Ce=!0}for(const he of pe){if(ue.some(Ue=>(0,J.isSingleFolderWorkspaceIdentifier)(Ue.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(Ue.openedWorkspace.uri,he.workspace.uri)))continue;const Se=he.remoteAuthority,Me=(0,m.isEqualAuthority)($?.remoteAuthority,Se)?$:void 0;we(await this.doOpenFolderOrWorkspace(F,he,Ce,Me),!!Me),Ce=!0}}const X=(0,C.distinct)(Y,ue=>ue.backupFolder);if(X.length>0)for(const ue of X){const he=ue.remoteAuthority,Se=(0,m.isEqualAuthority)($?.remoteAuthority,he)?$:void 0;we(await this.doOpenEmpty(F,!0,he,Se,ue),!!Se),Ce=!0}if(fe.length===0||$){$&&!Q&&Q++;const ue=$?$.remoteAuthority:F.remoteAuthority;for(let he=0;he<Q;he++)we(await this.doOpenEmpty(F,Ce,ue,$),!!$),Ce=!0}return{windows:(0,C.distinct)(fe),filesOpenedInWindow:me}}doOpenFilesInExistingWindow(F,U,H){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:H}),this.focusMainOrChildWindow(U);const Y={filesToOpenOrCreate:H?.filesToOpenOrCreate,filesToDiff:H?.filesToDiff,filesToMerge:H?.filesToMerge,filesToWait:H?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",R.CancellationToken.None,Y),U}focusMainOrChildWindow(F){let U=F;const H=n.BrowserWindow.getFocusedWindow();if(H&&H.id!==F.id){const Y=this.auxiliaryWindowsMainService.getWindowByWebContents(H.webContents);Y&&Y.parentId===F.id&&(U=Y)}U.focus()}doAddFoldersToExistingWindow(F,U){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),F.focus();const H={foldersToAdd:U};return F.sendWhenReady("vscode:addFolders",R.CancellationToken.None,H),F}doOpenEmpty(F,U,H,Y,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:H,filesToOpen:Y,forceNewWindow:U});let $;return!U&&typeof F.contextWindowId=="number"&&($=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:H,forceNewWindow:U,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Y,windowToUse:$,emptyWindowBackupInfo:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}doOpenFolderOrWorkspace(F,U,H,Y,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:Y}),!H&&!Q&&typeof F.contextWindowId=="number"&&(Q=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:U.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:H,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Y,windowToUse:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async getPathsToOpen(F){let U,H=!1,Y=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(U=await this.doExtractPathsFromAPI(F),H=!0):F.forceEmpty?U=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(U=await this.doExtractPathsFromCLI(F.cli),U.length===0&&U.push(Object.create(null)),H=!0):(U=await this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),Y=!0),!F.addMode&&H){const Q=U.filter($=>re($));if(Q.length>1){const $=Q[0].remoteAuthority;if(Q.every(ie=>(0,m.isEqualAuthority)(ie.remoteAuthority,$))){const ie=await this.workspacesManagementMainService.createUntitledWorkspace(Q.map(fe=>({uri:fe.workspace.uri})));U.push({workspace:ie,remoteAuthority:$}),U=U.filter(fe=>!re(fe))}}}if(F.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Q=await this.doGetPathsFromLastSession();U.unshift(...Q.filter($=>de($)||re($)||$.backupPath))}return U}async doExtractPathsFromAPI(F){const U={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},H=await Promise.all((0,C.coalesce)(F.urisToOpen||[]).map(async Y=>{const Q=await this.resolveOpenable(Y,U);if(Q)return Q.label=Y.label,Q;const $=this.resourceFromOpenable(Y);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,t.localize)(0,null)],message:$.scheme===w.Schemas.file?(0,t.localize)(1,null):(0,t.localize)(2,null),detail:$.scheme===w.Schemas.file?(0,t.localize)(3,null,(0,f.getPathLabel)($,{os:E.OS,tildify:this.environmentMainService})):(0,t.localize)(4,null,$.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.coalesce)(H)}async doExtractPathsFromCLI(F){const U=[],H={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},Y=F["folder-uri"];if(Y){const ie=await Promise.all(Y.map(fe=>{const me=this.cliArgToUri(fe);if(me)return this.resolveOpenable({folderUri:me},H)}));U.push(...(0,C.coalesce)(ie))}const Q=F["file-uri"];if(Q){const ie=await Promise.all(Q.map(fe=>{const me=this.cliArgToUri(fe);if(me)return this.resolveOpenable((0,J.hasWorkspaceFileExtension)(fe)?{workspaceUri:me}:{fileUri:me},H)}));U.push(...(0,C.coalesce)(ie))}const $=await Promise.all(F._.map(ie=>H.remoteAuthority?this.doResolveRemotePath(ie,H):this.doResolveFilePath(ie,H)));return U.push(...(0,C.coalesce)($)),U}cliArgToUri(F){try{const U=D.URI.parse(F);if(!U.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.logService.error(`Invalid URI input string: ${F}, ${U.message}`)}}async doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];F!=="one"&&U.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&U.push(this.windowsStateHandler.state.lastActiveWindow);const H=await Promise.all(U.map(async Y=>{if(Y.workspace){const Q=await this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});if(de(Q))return Q}else if(Y.folderUri){const Q=await this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});if(re(Q))return Q}else if(F!=="folders"&&Y.backupPath)return{backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority}}));return(0,C.coalesce)(H)}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async resolveOpenable(F,U=Object.create(null)){const H=this.resourceFromOpenable(F);return H.scheme===w.Schemas.file?((0,_.isFileToOpen)(F)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(H.fsPath,U)):this.doResolveRemoteOpenable(F,U)}doResolveRemoteOpenable(F,U){let H=this.resourceFromOpenable(F);const Y=(0,L.getRemoteAuthority)(H)||U.remoteAuthority;if(H=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(H)),(0,_.isFileToOpen)(F)){if(U.gotoLineMode){const{path:Q,line:$,column:ie}=(0,h.parseLineAndColumnAware)(H.path);return{fileUri:H.with({path:Q}),options:{selection:$?{startLineNumber:$,startColumn:ie||1}:void 0},remoteAuthority:Y}}return{fileUri:H,remoteAuthority:Y}}else if((0,_.isWorkspaceToOpen)(F))return{workspace:(0,le.getWorkspaceIdentifier)(H),remoteAuthority:Y};return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:Y}}resourceFromOpenable(F){return(0,_.isWorkspaceToOpen)(F)?F.workspaceUri:(0,_.isFolderToOpen)(F)?F.folderUri:F.fileUri}async doResolveFilePath(F,U,H){let Y,Q;U.gotoLineMode&&({path:F,line:Y,column:Q}=(0,h.parseLineAndColumnAware)(F)),F=(0,h.sanitizeFilePath)((0,d.normalize)(F),(0,p.cwd)());try{const $=await o.Promises.stat(F);if($.isFile()){if(!U.forceOpenWorkspaceAsFile){const ie=await this.workspacesManagementMainService.resolveLocalWorkspace(D.URI.file(F));if(ie)return ie.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:l.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:D.URI.file(F),type:l.FileType.File,exists:!0,options:{selection:Y?{startLineNumber:Y,startColumn:Q||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(D.URI.file(F),$),type:l.FileType.Directory,exists:!0};if(!E.isWindows&&F==="/dev/null")return{fileUri:D.URI.file(F),type:l.FileType.File,exists:!0}}}catch($){if($.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!H)return this.onUNCHostNotAllowed(F,U);const ie=D.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([ie]),U.ignoreFileNotFound)return{fileUri:ie,type:l.FileType.File,exists:!1}}}async onUNCHostNotAllowed(F,U){const H=D.URI.file(F),{response:Y,checkboxChecked:Q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],message:(0,t.localize)(8,null,H.authority),detail:(0,t.localize)(9,null,(0,f.getPathLabel)(H,{os:E.OS,tildify:this.environmentMainService})),checkboxLabel:(0,t.localize)(10,null,H.authority),cancelId:1});if(Y===0){if((0,I.addUNCHostToAllowlist)(H.authority),Q){const $={channel:"vscode:configureAllowedUNCHost",args:H.authority};this.sendToFocused($.channel,$.args),this.sendToOpeningWindow($.channel,$.args)}return this.doResolveFilePath(F,U,!0)}if(Y===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(F,U)}doResolveRemotePath(F,U){const H=F.charCodeAt(0),Y=U.remoteAuthority;let Q,$;U.gotoLineMode&&({path:F,line:Q,column:$}=(0,h.parseLineAndColumnAware)(F)),H!==y.CharCode.Slash&&((0,h.isWindowsDriveLetter)(H)&&F.charCodeAt(F.charCodeAt(1))===y.CharCode.Colon&&(F=(0,h.toSlashes)(F)),F=`/${F}`);const ie=D.URI.from({scheme:w.Schemas.vscodeRemote,authority:Y,path:F});if(F.charCodeAt(F.length-1)!==y.CharCode.Slash){if((0,J.hasWorkspaceFileExtension)(F))return U.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:Q?{startLineNumber:Q,startColumn:$||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,le.getWorkspaceIdentifier)(ie),remoteAuthority:Y};if(U.gotoLineMode||d.posix.basename(F).indexOf(".")!==-1)return{fileUri:ie,options:{selection:Q?{startLineNumber:Q,startColumn:$||1}:void 0},remoteAuthority:Y}}return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(ie),remoteAuthority:Y}}shouldOpenNewWindow(F){const U=this.configurationService.getValue("window"),H=U?.openFoldersInNewWindow||"default",Y=U?.openFilesInNewWindow||"off";let Q=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(H==="on"||H==="off")&&(Q=H==="on");let $=!1;return F.forceNewWindow||F.forceReuseWindow?$=!!F.forceNewWindow&&!F.forceReuseWindow:(E.isMacintosh?F.context===N.OpenContext.DOCK&&($=!0):F.context!==N.OpenContext.DIALOG&&F.context!==N.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!F.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&($=Y==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(F,U){const H=(0,z.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(H)return this.lifecycleMainService.reload(H,U.cli),H.focus(),[H];let Y=U.cli["folder-uri"]||[],Q=U.cli["file-uri"]||[],$=U.cli._;if(!$.length&&!Y.length&&!Q.length&&!U.cli.extensionTestsPath){const me=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(D.URI.isUri(we)?we.scheme===w.Schemas.file?$=[we.fsPath]:Y=[we.toString()]:we.configPath.scheme===w.Schemas.file?$=[(0,m.originalFSPath)(we.configPath)]:Q=[we.configPath.toString()])}let ie=U.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=D.URI.parse(me),Ce=(0,L.getRemoteAuthority)(we);Ce&&(ie?(0,m.isEqualAuthority)(Ce,ie)||this.logService.error("more than one extension development path authority"):ie=Ce)}$=$.filter(me=>{const we=D.URI.file(me);return(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:(0,m.isEqualAuthority)((0,L.getRemoteAuthority)(we),ie)}),Y=Y.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,m.isEqualAuthority)((0,L.getRemoteAuthority)(we),ie):!1}),Q=Q.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,m.isEqualAuthority)((0,L.getRemoteAuthority)(we),ie):!1}),U.cli._=$,U.cli["folder-uri"]=Y,U.cli["file-uri"]=Q;const fe={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!$.length&&!Y.length&&!Q.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:ie,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(fe)}async openInBrowserWindow(F){const U=this.configurationService.getValue("window"),H=this.getLastActiveWindow(),Q=(U?.newWindowProfile?this.userDataProfilesMainService.profiles.find(fe=>fe.name===U.newWindowProfile):void 0)??H?.profile??this.userDataProfilesMainService.defaultProfile;let $;!F.forceNewWindow&&!F.forceNewTabbedWindow&&($=F.windowToUse||H,$&&$.focus());const ie={...this.environmentMainService.args,...F.cli,machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,d.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:Q},homeDir:this.environmentMainService.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:w.Schemas.file}).fsPath,product:M.default,isInitialStartup:F.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)(),arch:(0,k.arch)()},autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if($){const fe=$.config;!ie.extensionDevelopmentPath&&fe?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=fe.extensionDevelopmentPath,ie.extensionDevelopmentKind=fe.extensionDevelopmentKind,ie["enable-proposed-api"]=fe["enable-proposed-api"],ie.verbose=fe.verbose,ie["inspect-extensions"]=fe["inspect-extensions"],ie["inspect-brk-extensions"]=fe["inspect-brk-extensions"],ie.debugId=fe.debugId,ie.extensionEnvironment=fe.extensionEnvironment,ie["extensions-dir"]=fe["extensions-dir"],ie["disable-extensions"]=fe["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:fe?.loggers.window??ie.loggers.window}}else{const fe=this.windowsStateHandler.getNewWindowState(ie);(0,v.mark)("code/willCreateCodeWindow");const me=$=this.instantiationService.createInstance(B.CodeWindow,{state:fe,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.windows.set(me.id,me),this._onDidOpenWindow.fire(me),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new g.DisposableStore;we.add(me.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(me))),we.add(a.Event.once(me.onDidClose)(()=>this.onWindowClosed(me,we))),we.add(a.Event.once(me.onDidDestroy)(()=>this.onWindowDestroyed(me))),we.add(me.onDidMaximize(()=>this._onDidMaximizeWindow.fire(me))),we.add(me.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(me))),we.add(me.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Ie,y:De})=>this._onDidTriggerSystemContextMenu.fire({window:me,x:Ie,y:De})));const Ce=(0,b.assertIsDefined)(me.win?.webContents);Ce.removeAllListeners("devtools-reload-page"),we.add(a.Event.fromNodeEventEmitter(Ce,"devtools-reload-page")(()=>this.lifecycleMainService.reload(me))),this.lifecycleMainService.registerWindow(me)}return ie.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,q.UnloadReason.LOAD).then(async fe=>{fe||await this.doOpenInBrowserWindow($,ie,F,Q)}):await this.doOpenInBrowserWindow($,ie,F,Q),$}async doOpenInBrowserWindow(F,U,H,Y){if(U.extensionDevelopmentPath||((0,J.isWorkspaceIdentifier)(U.workspace)?U.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(U.workspace)?U.backupPath=this.backupMainService.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:H.emptyWindowBackupInfo?.backupFolder??(0,le.createEmptyWorkspaceIdentifier)().id,remoteAuthority:U.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const Q=U.workspace??(0,J.toWorkspaceIdentifier)(U.backupPath,!1),$=this.resolveProfileForBrowserWindow(H,Q,Y),ie=$ instanceof Promise?await $:$;U.profiles.profile=ie,U.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(Q,ie)}F.load(U)}resolveProfileForBrowserWindow(F,U,H){return F.forceProfile?this.userDataProfilesMainService.profiles.find(Y=>Y.name===F.forceProfile)??this.userDataProfilesMainService.createNamedProfile(F.forceProfile):F.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(U)??H}onWindowClosed(F,U){this.windows.delete(F.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}onWindowDestroyed(F){this.windows.delete(F.id),this._onDidDestroyWindow.fire(F)}getFocusedWindow(){const F=n.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(U=>(0,m.isEqualAuthority)(U.remoteAuthority,F)))}doGetLastActiveWindow(F){return(0,N.getLastFocused)(F)}sendToFocused(F,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,R.CancellationToken.None,...U)}sendToOpeningWindow(F,...U){this._register(a.Event.once(this.onDidSignalReadyWindow)(H=>{H.sendWhenReady(F,R.CancellationToken.None,...U)}))}sendToAll(F,U,H){for(const Y of this.getWindows())H&&H.indexOf(Y.id)>=0||Y.sendWhenReady(F,R.CancellationToken.None,U)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(F){return this.windows.get(F)}getWindowByWebContents(F){const U=n.BrowserWindow.fromWebContents(F);if(!U)return;const H=this.getWindowById(U.id);return H?.matches(F)?H:void 0}};e.WindowsMainService=Z,e.WindowsMainService=Z=Pe([ne(4,S.ILogService),ne(5,ce.ILoggerMainService),ne(6,A.IStateService),ne(7,x.IPolicyService),ne(8,r.IEnvironmentMainService),ne(9,j.IUserDataProfilesMainService),ne(10,P.ILifecycleMainService),ne(11,s.IBackupMainService),ne(12,i.IConfigurationService),ne(13,K.IWorkspacesHistoryMainService),ne(14,ee.IWorkspacesManagementMainService),ne(15,u.IInstantiationService),ne(16,c.IDialogMainService),ne(17,l.IFileService),ne(18,T.IProtocolMainService),ne(19,O.IThemeMainService),ne(20,G.IAuxiliaryWindowsMainService)],Z)}),define(oe[317],ae([0,1,70,29,89,60]),function(V,e,n,o,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(y,a,h,f){this.workspacesManagementMainService=y,this.windowsMainService=a,this.workspacesHistoryMainService=h,this.backupMainService=f,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(y,a){const h=this.windowsMainService.getWindowById(y);if(h)return this.workspacesManagementMainService.enterWorkspace(h,this.windowsMainService.getWindows(),a)}createUntitledWorkspace(y,a,h){return this.workspacesManagementMainService.createUntitledWorkspace(a,h)}deleteUntitledWorkspace(y,a){return this.workspacesManagementMainService.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(y,a){return this.workspacesManagementMainService.getWorkspaceIdentifier(a)}getRecentlyOpened(y){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(y,a){return this.workspacesHistoryMainService.addRecentlyOpened(a)}removeRecentlyOpened(y,a){return this.workspacesHistoryMainService.removeRecentlyOpened(a)}clearRecentlyOpened(y){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=C,e.WorkspacesMainService=C=Pe([ne(0,k.IWorkspacesManagementMainService),ne(1,o.IWindowsMainService),ne(2,I.IWorkspacesHistoryMainService),ne(3,n.IBackupMainService)],C)}),define(oe[318],ae([0,1,14,107,35,27,17,55,16,31,4,322,48,2,12,10,3,13,7,33,163,44,164,119,298,167,70,291,18,299,97,136,53,98,225,24,69,101,213,302,215,216,217,15,229,100,84,6,99,224,308,309,292,300,20,5,315,65,28,75,303,102,34,281,88,129,25,258,259,58,50,271,296,310,297,311,133,273,274,275,278,306,51,29,316,280,30,103,89,317,60,40,238,59,251,57,87,134,283,301,288,8,261,282,233,72,305,277,22,76,304,269,244,66,85,313,79]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L,A,_,B,N,z,se,J,le,K,ee,q,O,x,j,ce,G,de,re,Z,W,F,U,H,Y,Q,$,ie,fe,me,we,Ce,Ie,De,Re,pe,X,ue,he,Se,Me,Ue,We,Le,xe,je,Xe,He,Ke,Qe,Ze,Fe,te,ge,ve,ye,_e,Be,Ye,lt,at,st,tt,ut,ct,ht,gt,Ct,Lt,mt,pt,Tt,Ot,_t,vt,Wt,bt,ft,Ft,Nt,wt,Ut,It,xt,Pt){"use strict";var St;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let yt=class extends w.Disposable{static{St=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[d.Schemas.file]:"security.promptForLocalFileProtocolHandling",[d.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,Te,Oe,Ee,be,qe,Ve,Ge,Ne,$e,ze,Je){super(),this.mainProcessNodeIpcServer=Ae,this.userEnv=Te,this.mainInstantiationService=Oe,this.logService=Ee,this.loggerService=be,this.environmentMainService=qe,this.lifecycleMainService=Ve,this.configurationService=Ge,this.stateService=Ne,this.fileService=$e,this.productService=ze,this.userDataProfilesMainService=Je,this.configureSession(),this.registerListeners()}configureSession(){const Ae=Ne=>Ne?.startsWith(`${d.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ne,$e,ze,Je)=>Ae(Je.requestingUrl)?ze(Te.has($e)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ne,$e,ze,Je)=>Ae(Je.requestingUrl)?Te.has($e):!1);const Oe=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,d.Schemas.vscodeManagedRemoteResource,"devtools"]),Ee=Ne=>{for(let $e=Ne;$e;$e=$e.parent)if($e.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},be=Ne=>Ne.resourceType==="xhr"||Ee(Ne.frame),qe=Ne=>{const $e=Ne.frame;if(!$e||!this.windowsMainService)return!1;const ze=n.BrowserWindow.getAllWindows();for(const Je of ze)if($e.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ve=(Ne,$e)=>{if(Ne.path!=="/index.html")return!0;const ze=$e.frame;if(!ze||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&ze.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ne,$e)=>{const ze=m.URI.parse(Ne.url);return ze.scheme===d.Schemas.vscodeWebview&&!Ve(ze,Ne)?(this.logService.error("Blocked vscode-webview request",Ne.url),$e({cancel:!0})):ze.scheme===d.Schemas.vscodeFileResource&&!qe(Ne)?(this.logService.error("Blocked vscode-file request",Ne.url),$e({cancel:!0})):ze.path.endsWith(".svg")&&!Oe.has(ze.scheme)?$e({cancel:!be(Ne)}):$e({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,$e)=>{const ze=Ne.responseHeaders,Je=ze["content-type"]||ze["Content-Type"];if(Je&&Array.isArray(Je)){const it=m.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Oe.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],$e({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ot=>ot.toLowerCase().includes("image/svg")))return $e({cancel:!be(Ne)})}return $e({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,$e)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ne.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],$e({cancel:!1,responseHeaders:ze})}return $e({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ge.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome")),E.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,o.disableUNCAccessRestrictions)():(0,o.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,y.setUnexpectedErrorHandler)(Oe=>this.onUnexpectedError(Oe)),process.on("uncaughtException",Oe=>{(0,y.isSigPipeError)(Oe)||(0,y.onUnexpectedError)(Oe)}),process.on("unhandledRejection",Oe=>(0,y.onUnexpectedError)(Oe)),h.Event.once(this.lifecycleMainService.onWillShutdown)(()=>this.dispose()),(0,D.registerContextMenuListener)(),n.app.on("accessibility-support-changed",(Oe,Ee)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),n.app.on("activate",async(Oe,Ee)=>{this.logService.trace("app#activate"),Ee||await this.windowsMainService?.openEmptyWindow({context:Fe.OpenContext.DOCK})}),n.app.on("web-contents-created",(Oe,Ee)=>{Ee?.opener?.url.startsWith(`${d.Schemas.vscodeFileResource}://${d.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(Ee)),Ee.on("will-navigate",be=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),be.preventDefault()}),Ee.setWindowOpenHandler(be=>be.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(be)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${be.url}}`),this.nativeHostMainService?.openExternal(void 0,be.url),{action:"deny"}))});let Ae=[],Te;n.app.on("open-file",(Oe,Ee)=>{Ee=(0,Pt.normalizeNFC)(Ee),this.logService.trace("app#open-file: ",Ee),Oe.preventDefault(),Ae.push((0,ve.hasWorkspaceFileExtension)(Ee)?{workspaceUri:m.URI.file(Ee)}:{fileUri:m.URI.file(Ee)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.windowsMainService?.open({context:Fe.OpenContext.DOCK,cli:this.environmentMainService.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:Fe.OpenContext.DESKTOP})}),I.validatedIpcMain.handle("vscode:fetchShellEnv",Oe=>{const Ee=this.windowsMainService?.getWindowByWebContents(Oe.sender);let be,qe;return Ee?.config?(be=Ee.config,qe={...process.env,...Ee.config.userEnv}):(be=this.environmentMainService.args,qe=process.env),this.resolveShellEnvironment(be,qe,!1)}),I.validatedIpcMain.handle("vscode:writeNlsFile",(Oe,Ee,be)=>{const qe=this.validateNlsPath([Ee]);if(!qe||typeof be!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(qe,C.VSBuffer.fromString(be))}),I.validatedIpcMain.handle("vscode:readNlsFile",async(Oe,...Ee)=>{const be=this.validateNlsPath(Ee);if(!be)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(be)).value.toString()}),I.validatedIpcMain.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),I.validatedIpcMain.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),I.validatedIpcMain.on("vscode:reloadWindow",Oe=>Oe.sender.reload()),I.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Oe,Ee)=>{const be=this.windowsMainService?.getWindowByWebContents(Oe.sender);be&&be.notifyZoomLevel(Ee)})}validateNlsPath(Ae){let Te;for(const Oe of Ae)typeof Oe=="string"&&(typeof Te!="string"?Te=Oe:Te=(0,v.join)(Te,Oe));if(!(typeof Te!="string"||!(0,v.isAbsolute)(Te)||!(0,a.isEqualOrParent)(Te,this.environmentMainService.cachedLanguagesPath,!E.isLinux)))return m.URI.file(Te)}onUnexpectedError(Ae){if(Ae){const Te={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.logService.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.logService.error(Ae.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ae=this.productService.win32AppUserModelId;E.isWindows&&Ae&&n.app.setAppUserModelId(Ae);try{E.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.logService.error(ze)}const Te=new s.Server;h.Event.once(this.lifecycleMainService.onWillShutdown)(ze=>{ze.reason===U.ShutdownReason.KILL&&Te.dispose()}),this.logService.trace("Resolving machine identifier...");const[Oe,Ee,be]=await Promise.all([(0,pt.resolveMachineId)(this.stateService,this.logService),(0,pt.resolveSqmId)(this.stateService,this.logService),(0,pt.resolvedevDeviceId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:qe,sharedProcessClient:Ve}=this.setupSharedProcess(Oe,Ee,be),Ge=await this.initServices(Oe,Ee,be,qe);this._register(Ge.createInstance(c.ProxyAuthHandler)),this._register(Ge.createInstance(Ct.UserDataProfilesHandler)),Ge.invokeFunction(ze=>this.initChannels(ze,Te,Ve));const Ne=await Ge.invokeFunction(ze=>this.setupProtocolUrlHandlers(ze,Te));this.setupManagedRemoteResourceUrlHandler(Te),this.lifecycleMainService.phase=U.LifecycleMainPhase.Ready,await Ge.invokeFunction(ze=>this.openFirstWindow(ze,Ne)),this.lifecycleMainService.phase=U.LifecycleMainPhase.AfterWindowOpen,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=U.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ae,Te){const Oe=this.windowsMainService=Ae.get(Fe.IWindowsMainService),Ee=Ae.get(xe.IURLService),be=this.nativeHostMainService=Ae.get(Q.INativeHostMainService),qe=Ae.get(L.IDialogMainService),Ve=this;Ee.registerHandler({async handleURL(it,ot){return Ve.handleProtocolUrl(Oe,qe,Ee,it,ot)}});const Ge=this._register(new ge.ActiveWindowManager({onDidOpenMainWindow:be.onDidOpenMainWindow,onDidFocusMainWindow:be.onDidFocusMainWindow,getActiveWindowId:()=>be.getActiveWindowId(-1)})),Ne=new t.StaticRouter(it=>Ge.getActiveClientId().then(ot=>it===ot)),$e=new je.URLHandlerRouter(Ne,this.logService),ze=Te.getChannel("urlHandler",$e);Ee.registerHandler(new je.URLHandlerChannelClient(ze));const Je=await this.resolveInitialProtocolUrls(Oe,qe);return this._register(new He.ElectronURLListener(Je?.urls,Ee,Oe,this.environmentMainService,this.productService,this.logService)),Je}setupManagedRemoteResourceUrlHandler(Ae){const Te=()=>({statusCode:404,data:"Not found"}),Oe=new Ut.Lazy(()=>Ae.getChannel(wt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new wt.NodeRemoteResourceRouter));n.protocol.registerBufferProtocol(d.Schemas.vscodeManagedRemoteResource,(Ee,be)=>{const qe=m.URI.parse(Ee.url);if(!qe.authority.startsWith("window:"))return be(Te());Oe.value.call(wt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[qe]).then(Ve=>be({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.logService.warn("error dispatching remote resource call",Ve),be({statusCode:500,data:String(Ve)})})})}async resolveInitialProtocolUrls(Ae,Te){const Oe=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Oe.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Oe.length+Ee.length===0)return;const be=[...Oe,...Ee].map(Ge=>{try{return{uri:m.URI.parse(Ge),originalUrl:Ge}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),qe=[],Ve=[];for(const Ge of be){if(!Ge)continue;const Ne=this.getWindowOpenableFromProtocolUrl(Ge.uri);if(Ne)if(await this.shouldBlockOpenable(Ne,Ae,Te)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Ne),qe.push(Ne);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ve.push(Ge)}return{urls:Ve,openables:qe}}async shouldBlockOpenable(Ae,Te,Oe){let Ee,be;if((0,Ze.isWorkspaceToOpen)(Ae)?(Ee=Ae.workspaceUri,be=(0,r.localize)(0,null,Ee.scheme===d.Schemas.file?(0,g.getPathLabel)(Ee,{os:E.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)):(0,Ze.isFolderToOpen)(Ae)?(Ee=Ae.folderUri,be=(0,r.localize)(1,null,Ee.scheme===d.Schemas.file?(0,g.getPathLabel)(Ee,{os:E.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)):(Ee=Ae.fileUri,be=(0,r.localize)(2,null,Ee.scheme===d.Schemas.file?(0,g.getPathLabel)(Ee,{os:E.OS,tildify:this.environmentMainService}):Ee.toString(!0),this.productService.nameShort)),Ee.scheme!==d.Schemas.file&&Ee.scheme!==d.Schemas.vscodeRemote||this.configurationService.getValue(St.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Ee.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ge}=await Oe.showMessageBox({type:"warning",buttons:[(0,r.localize)(3,null),(0,r.localize)(4,null)],message:be,detail:(0,r.localize)(5,null),checkboxLabel:Ee.scheme===d.Schemas.file?(0,r.localize)(6,null):(0,r.localize)(7,null),cancelId:1});if(Ve!==0)return!0;if(Ge){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:Ee.scheme===d.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}getWindowOpenableFromProtocolUrl(Ae){if(Ae.path){if(Ae.authority===d.Schemas.file){const Te=m.URI.file(Ae.fsPath);return(0,ve.hasWorkspaceFileExtension)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Ae.authority===d.Schemas.vscodeRemote){const Te=Ae.path.indexOf(v.posix.sep,1);if(Te!==-1){const Oe=Ae.path.substring(1,Te),Ee=Ae.path.substring(Te);let be=Ae.query;const qe=new URLSearchParams(Ae.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),be=qe.toString());const Ve=m.URI.from({scheme:d.Schemas.vscodeRemote,authority:Oe,path:Ee,query:be,fragment:Ae.fragment});return(0,ve.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ve}:/:[\d]+$/.test(Ee)?{fileUri:Ve}:{folderUri:Ve}}}}}async handleProtocolUrl(Ae,Te,Oe,Ee,be){this.logService.trace("app#handleProtocolUrl():",Ee.toString(!0),be),Ee.scheme===this.productService.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:m.URI.parse(Ee.query).path,query:""}));let qe=!1;const Ve=new URLSearchParams(Ee.query);Ve.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),Ve.delete("windowId"),Ee=Ee.with({query:Ve.toString()}),qe=!0):E.isMacintosh&&Ae.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),qe=!0);const Ge=Ve.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),Ve.delete("continueOn"),Ee=Ee.with({query:Ve.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Ne=this.getWindowOpenableFromProtocolUrl(Ee);return Ne?await this.shouldBlockOpenable(Ne,Ae,Te)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,Ee.toString(!0)),(0,bt.firstOrDefault)(await Ae.open({context:Fe.OpenContext.API,cli:{...this.environmentMainService.args},urisToOpen:[Ne],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0)),await(0,bt.firstOrDefault)(await Ae.open({context:Fe.OpenContext.API,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ie.getRemoteAuthority)(Ee)}))?.ready(),Oe.open(Ee,be)):(this.logService.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),be),!1)}setupSharedProcess(Ae,Te,Oe){const Ee=this._register(this.mainInstantiationService.createInstance(fe.SharedProcess,Ae,Te,Oe));this._register(Ee.onDidCrash(()=>this.windowsMainService?.sendToFocused("vscode:reportSharedProcessCrash")));const be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ve=await Ee.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Ve,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),be))(),sharedProcessClient:be}}async initServices(Ae,Te,Oe,Ee){const be=new G.ServiceCollection;switch(process.platform){case"win32":be.set(he.IUpdateService,new j.SyncDescriptor(Le.Win32UpdateService));break;case"linux":E.isLinuxSnap?be.set(he.IUpdateService,new j.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(he.IUpdateService,new j.SyncDescriptor(Ue.LinuxUpdateService));break;case"darwin":be.set(he.IUpdateService,new j.SyncDescriptor(Me.DarwinUpdateService));break}be.set(Fe.IWindowsMainService,new j.SyncDescriptor(te.WindowsMainService,[Ae,Te,Oe,this.userEnv],!1)),be.set(It.IAuxiliaryWindowsMainService,new j.SyncDescriptor(xt.AuxiliaryWindowsMainService,void 0,!1));const qe=new L.DialogMainService(this.logService,this.productService);be.set(L.IDialogMainService,qe),be.set(F.ILaunchMainService,new j.SyncDescriptor(F.LaunchMainService,void 0,!1)),be.set(T.IDiagnosticsMainService,new j.SyncDescriptor(T.DiagnosticsMainService,void 0,!1)),be.set(M.IDiagnosticsService,t.ProxyChannel.toService((0,t.getDelayedChannel)(Ee.then(ze=>ze.getChannel("diagnostics"))))),be.set(de.IIssueMainService,new j.SyncDescriptor(re.IssueMainService,[this.userEnv])),be.set(de.IProcessMainService,new j.SyncDescriptor(Z.ProcessMainService,[this.userEnv])),be.set(A.IEncryptionMainService,new j.SyncDescriptor(_.EncryptionMainService)),be.set(W.IKeyboardLayoutMainService,new j.SyncDescriptor(W.KeyboardLayoutMainService)),be.set(Q.INativeHostMainService,new j.SyncDescriptor(Q.NativeHostMainService,void 0,!1)),be.set(Ke.IWebviewManagerService,new j.SyncDescriptor(Qe.WebviewMainService)),be.set(Y.IMenubarMainService,new j.SyncDescriptor(Y.MenubarMainService)),be.set(se.IExtensionHostStarter,new j.SyncDescriptor(J.ExtensionHostStarter)),be.set(Ie.IStorageMainService,new j.SyncDescriptor(Ie.StorageMainService)),be.set(Ie.IApplicationStorageMainService,new j.SyncDescriptor(Ie.ApplicationStorageMainService));const Ve=new Ft.ElectronPtyHostStarter({graceTime:ft.LocalReconnectConstants.GraceTime,shortGraceTime:ft.LocalReconnectConstants.ShortGraceTime,scrollback:this.configurationService.getValue(ft.TerminalSettingId.PersistentSessionScrollback)??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ge=new Nt.PtyHostService(Ve,this.configurationService,this.logService,this.loggerService);be.set(ft.ILocalPtyService,Ge),E.isWindows?be.set(le.IExternalTerminalMainService,new j.SyncDescriptor(K.WindowsExternalTerminalService)):E.isMacintosh?be.set(le.IExternalTerminalMainService,new j.SyncDescriptor(K.MacExternalTerminalService)):E.isLinux&&be.set(le.IExternalTerminalMainService,new j.SyncDescriptor(K.LinuxExternalTerminalService));const Ne=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);be.set(l.IBackupMainService,Ne);const $e=new Ye.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ne,qe);if(be.set(Ye.IWorkspacesManagementMainService,$e),be.set(ye.IWorkspacesService,new j.SyncDescriptor(Be.WorkspacesMainService,void 0,!1)),be.set(_e.IWorkspacesHistoryMainService,new j.SyncDescriptor(_e.WorkspacesHistoryMainService,void 0,!1)),be.set(xe.IURLService,new j.SyncDescriptor(Xe.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.productService,this.environmentMainService)){const ze=(0,ue.isInternalTelemetry)(this.productService,this.configurationService),Je=(0,t.getDelayedChannel)(Ee.then(Et=>Et.getChannel("telemetryAppender"))),it=new pe.TelemetryAppenderClient(Je),ot=(0,De.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,Ae,Te,Oe,ze),nt=(0,ue.getPiiPathsFromEnvironment)(this.environmentMainService),dt={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};be.set(Re.ITelemetryService,new j.SyncDescriptor(X.TelemetryService,[dt],!1))}else be.set(Re.ITelemetryService,ue.NullTelemetryService);return be.set(ct.IExtensionsProfileScannerService,new j.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),be.set(ht.IExtensionsScannerService,new j.SyncDescriptor(gt.ExtensionsScannerService,void 0,!0)),be.set(vt.IUtilityProcessWorkerMainService,new j.SyncDescriptor(vt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([Ne.initialize(),$e.initialize()]),this.mainInstantiationService.createChild(be)}initChannels(Ae,Te,Oe){const Ee=this._register(new w.DisposableStore),be=t.ProxyChannel.fromService(Ae.get(F.ILaunchMainService),Ee,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",be);const qe=t.ProxyChannel.fromService(Ae.get(T.IDiagnosticsMainService),Ee,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",qe);const Ve=Ee.add(new at.PolicyChannel(Ae.get(lt.IPolicyService)));Te.registerChannel("policy",Ve),Oe.then(rt=>rt.registerChannel("policy",Ve));const Ge=this.fileService.getProvider(d.Schemas.file);(0,p.assertType)(Ge instanceof x.DiskFileSystemProvider);const Ne=Ee.add(new O.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService));Te.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ne),Oe.then(rt=>rt.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ne));const $e=t.ProxyChannel.fromService(Ae.get(st.IUserDataProfilesMainService),Ee);Te.registerChannel("userDataProfiles",$e),Oe.then(rt=>rt.registerChannel("userDataProfiles",$e));const ze=new tt.RequestChannel(Ae.get(ut.IRequestService));Oe.then(rt=>rt.registerChannel("request",ze));const Je=new Se.UpdateChannel(Ae.get(he.IUpdateService));Te.registerChannel("update",Je);const it=t.ProxyChannel.fromService(Ae.get(de.IIssueMainService),Ee);Te.registerChannel("issue",it);const ot=t.ProxyChannel.fromService(Ae.get(de.IProcessMainService),Ee);Te.registerChannel("process",ot);const nt=t.ProxyChannel.fromService(Ae.get(A.IEncryptionMainService),Ee);Te.registerChannel("encryption",nt);const dt=t.ProxyChannel.fromService(Ae.get(me.ISignService),Ee);Te.registerChannel("sign",dt);const Et=t.ProxyChannel.fromService(Ae.get(W.IKeyboardLayoutMainService),Ee);Te.registerChannel("keyboardLayout",Et),this.nativeHostMainService=Ae.get(Q.INativeHostMainService);const Dt=t.ProxyChannel.fromService(this.nativeHostMainService,Ee);Te.registerChannel("nativeHost",Dt),Oe.then(rt=>rt.registerChannel("nativeHost",Dt));const Bt=t.ProxyChannel.fromService(Ae.get(ye.IWorkspacesService),Ee);Te.registerChannel("workspaces",Bt);const zt=t.ProxyChannel.fromService(Ae.get(Y.IMenubarMainService),Ee);Te.registerChannel("menubar",zt);const qt=t.ProxyChannel.fromService(Ae.get(xe.IURLService),Ee);Te.registerChannel("url",qt);const Ht=t.ProxyChannel.fromService(Ae.get(Ke.IWebviewManagerService),Ee);Te.registerChannel("webview",Ht);const Rt=Ee.add(new Ce.StorageDatabaseChannel(this.logService,Ae.get(Ie.IStorageMainService)));Te.registerChannel("storage",Rt),Oe.then(rt=>rt.registerChannel("storage",Rt));const $t=Ee.add(new Lt.ProfileStorageChangesListenerChannel(Ae.get(Ie.IStorageMainService),Ae.get(st.IUserDataProfilesMainService),this.logService));Oe.then(rt=>rt.registerChannel("profileStorageListener",$t));const Vt=t.ProxyChannel.fromService(Ae.get(ft.ILocalPtyService),Ee);Te.registerChannel(ft.TerminalIpcChannels.LocalPty,Vt);const jt=t.ProxyChannel.fromService(Ae.get(le.IExternalTerminalMainService),Ee);Te.registerChannel("externalTerminal",jt);const kt=new Ot.LoggerChannel(Ae.get(_t.ILoggerMainService));Te.registerChannel("logger",kt),Oe.then(rt=>rt.registerChannel("logger",kt));const Gt=new S.ElectronExtensionHostDebugBroadcastChannel(Ae.get(Fe.IWindowsMainService));Te.registerChannel("extensionhostdebugservice",Gt);const Kt=t.ProxyChannel.fromService(Ae.get(se.IExtensionHostStarter),Ee);Te.registerChannel(se.ipcExtensionHostStarterChannelName,Kt);const Qt=t.ProxyChannel.fromService(Ae.get(vt.IUtilityProcessWorkerMainService),Ee);Te.registerChannel(Wt.ipcUtilityProcessWorkerChannelName,Qt)}async openFirstWindow(Ae,Te){const Oe=this.windowsMainService=Ae.get(Fe.IWindowsMainService);this.auxiliaryWindowsMainService=Ae.get(It.IAuxiliaryWindowsMainService);const Ee=(0,N.isLaunchedFromCli)(process.env)?Fe.OpenContext.CLI:Fe.OpenContext.DESKTOP,be=this.environmentMainService.args;if(Te){if(Te.openables.length>0)return Oe.open({context:Ee,cli:be,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const dt=new URLSearchParams(nt.uri.query);if(dt.get("windowId")==="_blank")return dt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:dt.toString()}),Oe.open({context:Ee,cli:be,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ve=be._.length,Ge=!!be["folder-uri"],Ne=!!be["file-uri"],$e=be["skip-add-to-recently-opened"]===!0,ze=be.wait&&be.waitMarkerFilePath?m.URI.file(be.waitMarkerFilePath):void 0,Je=be.remote||void 0,it=be.profile,ot=be["profile-temp"];if(!Ve&&!Ge&&!Ne){if(be["new-window"]||it||ot)return Oe.open({context:Ee,cli:be,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:Je,forceProfile:it,forceTempProfile:ot});if(qe.length)return Oe.open({context:Fe.OpenContext.DOCK,cli:be,urisToOpen:qe.map(nt=>(nt=(0,Pt.normalizeNFC)(nt),(0,ve.hasWorkspaceFileExtension)(nt)?{workspaceUri:m.URI.file(nt)}:{fileUri:m.URI.file(nt)})),noRecentEntry:$e,waitMarkerFileURI:ze,initialStartup:!0})}return Oe.open({context:Ee,cli:be,forceNewWindow:be["new-window"],diffMode:be.diff,mergeMode:be.merge,noRecentEntry:$e,waitMarkerFileURI:ze,gotoLineMode:be.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:it,forceTempProfile:ot})}afterWindowOpen(){this.installMutex(),n.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Ae,Te)=>{Te({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),E.isMacintosh&&n.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ae=this.productService.win32MutexName;if(E.isWindows&&Ae)try{const Te=await new Promise((Ee,be)=>{V(["@vscode/windows-mutex"],Ee,be)}).then(ke),Oe=new Te.Mutex(Ae);h.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Oe.release())}catch(Te){this.logService.error(Te)}}async resolveShellEnvironment(Ae,Te,Oe){try{return await(0,z.getResolvedShellEnv)(this.configurationService,this.logService,Ae,Te)}catch(Ee){const be=(0,R.toErrorMessage)(Ee);Oe?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",be):this.logService.error(be)}return{}}async updateCrashReporterEnablement(){try{const Te=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Oe=(0,f.parse)(Te),be=(0,ue.getTelemetryLevel)(this.configurationService)>=Re.TelemetryLevel.CRASH;if(Oe["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${be},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.generateUuid)()}"`,"}"],Ve=Te.substring(0,Te.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(Ve))}else{const qe=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${be},`);qe!==Te&&await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(qe))}}catch(Ae){this.logService.error(Ae),this.windowsMainService?.sendToFocused("vscode:showArgvParseWarning")}}};e.CodeApplication=yt,e.CodeApplication=yt=St=Pe([ne(2,ce.IInstantiationService),ne(3,H.ILogService),ne(4,H.ILoggerService),ne(5,B.IEnvironmentMainService),ne(6,U.ILifecycleMainService),ne(7,P.IConfigurationService),ne(8,we.IStateService),ne(9,q.IFileService),ne(10,$.IProductService),ne(11,st.IUserDataProfilesMainService)],yt)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[323],ae([0,1,14,47,7,22,8,55,16,31,4,48,12,10,71,3,37,26,21,44,105,318,9,18,243,257,24,69,208,15,227,100,84,223,99,20,230,5,73,28,74,284,132,295,57,294,102,256,34,58,77,59,40,239,237,2,41,272,72,232,124,128,276,107,270]),function(V,e,n,o,I,k,C,R,y,a,h,f,g,w,d,v,E,p,m,b,D,t,s,i,c,r,l,u,P,S,M,T,L,A,_,B,N,z,se,J,le,K,ee,q,O,x,j,ce,G,de,re,Z,W,F,U,H,Y,Q,$,ie,fe,me,we,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),se=et(se);class Ie{main(){try{this.startup()}catch(pe){console.error(pe.message),n.app.exit(1)}}async startup(){(0,y.setUnexpectedErrorHandler)(Le=>console.error(Le));const[pe,X,ue,he,Se,Me,Ue,We]=this.createServices();try{try{await this.initServices(ue,We,he,Se,Ue)}catch(Le){throw this.handleStartupDataDirError(ue,Ue,Le),Le}await pe.invokeFunction(async Le=>{const xe=Le.get(z.ILogService),je=Le.get(B.ILifecycleMainService),Xe=Le.get(S.IFileService),He=Le.get(z.ILoggerService),Ke=await this.claimInstance(xe,ue,je,pe,Ue,!0);return m.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Qe=>{xe.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),Me.logger=He.createLogger("main",{name:(0,s.localize)(0,null)}),h.Event.once(je.onWillShutdown)(Qe=>{Xe.dispose(),he.dispose(),Qe.join("instanceLockfile",m.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),pe.createInstance(t.CodeApplication,Ke,X).startup()})}catch(Le){pe.invokeFunction(this.quit,Le)}}createServices(){const pe=new _.ServiceCollection,X=new H.DisposableStore;process.once("exit",()=>X.dispose());const ue={_serviceBrand:void 0,...se.default};pe.set(J.IProductService,ue);const he=new l.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(he);pe.set(l.IEnvironmentMainService,he);const Me=new $.LoggerMainService((0,z.getLogLevel)(he),he.logsHome);pe.set($.ILoggerMainService,Me);const Ue=new N.BufferLogger(Me.getLogLevel()),We=X.add(new ie.LogService(Ue,[new z.ConsoleMainLogger(Me.getLogLevel())]));pe.set(z.ILogService,We);const Le=new M.FileService(We);pe.set(S.IFileService,Le);const xe=new T.DiskFileSystemProvider(We);Le.registerProvider(g.Schemas.file,xe);const je=new Q.UriIdentityService(Le);pe.set(Y.IUriIdentityService,je);const Xe=new me.StateService(me.SaveStrategy.DELAYED,he,We,Le);pe.set(G.IStateReadService,Xe),pe.set(G.IStateService,Xe);const He=new Z.UserDataProfilesMainService(Xe,je,he,Le,We);pe.set(Z.IUserDataProfilesMainService,He),Le.registerProvider(g.Schemas.vscodeUserData,new we.FileUserDataProvider(g.Schemas.file,xe,g.Schemas.vscodeUserData,He,je,We));const Ke=v.isWindows&&ue.win32RegValueName?X.add(new F.NativePolicyService(We,ue.win32RegValueName)):he.policyFile?X.add(new U.FilePolicyService(he.policyFile,Le,We)):new W.NullPolicyService;pe.set(W.IPolicyService,Ke);const Qe=new c.ConfigurationService(He.defaultProfile.settingsResource,Le,Ke,We);return pe.set(i.IConfigurationService,Qe),pe.set(B.ILifecycleMainService,new L.SyncDescriptor(B.LifecycleMainService,void 0,!1)),pe.set(O.IRequestService,new L.SyncDescriptor(x.RequestMainService,void 0,!0)),pe.set(re.IThemeMainService,new L.SyncDescriptor(re.ThemeMainService)),pe.set(j.ISignService,new L.SyncDescriptor(ce.SignService,void 0,!1)),pe.set(ee.ITunnelService,new L.SyncDescriptor(q.TunnelService)),pe.set(le.IProtocolMainService,new K.ProtocolMainService(he,He,We)),[new A.InstantiationService(pe,!0),Se,he,Qe,Xe,Ue,ue,He]}patchEnvironment(pe){const X={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const he=process.env[ue];typeof he=="string"&&(X[ue]=he)}),Object.assign(process.env,X),X}async initServices(pe,X,ue,he,Se){await C.Promises.settled([Promise.all([this.allowWindowsUNCPath(pe.extensionsPath),pe.codeCachePath,pe.logsHome.with({scheme:g.Schemas.file}).fsPath,X.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,pe.backupHome].map(Me=>Me?m.Promises.mkdir(Me,{recursive:!0}):void 0)),he.init(),ue.initialize()]),X.init()}allowWindowsUNCPath(pe){if(v.isWindows){const X=(0,Ce.getUNCHost)(pe);X&&(0,Ce.addUNCHostToAllowlist)(X)}return pe}async claimInstance(pe,X,ue,he,Se,Me){let Ue;try{(0,d.mark)("code/willStartMainServer"),Ue=await(0,D.serve)(X.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),h.Event.once(ue.onWillShutdown)(()=>Ue.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.handleStartupDataDirError(X,Se,We),We;let Le;try{Le=await(0,D.connect)(X.mainIPCHandle,"main")}catch(He){if(!Me||v.isWindows||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(1,null,Se.nameShort),(0,s.localize)(2,null),Se),He;try{(0,o.unlinkSync)(X.mainIPCHandle)}catch(Ke){throw pe.warn("Could not delete obsolete instance handle",Ke),Ke}return this.claimInstance(pe,X,ue,he,Se,!1)}if(X.extensionTestsLocationURI&&!X.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw pe.error(He),Le.dispose(),new Error(He)}let xe;!X.args.wait&&!X.args.status&&(xe=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(3,null,Se.nameShort),(0,s.localize)(4,null),Se)},1e4));const je=b.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=b.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(X.args.status)return he.invokeFunction(async()=>{const He=new r.DiagnosticsService(de.NullTelemetryService,Se),Ke=await Xe.getMainDiagnostics(),Qe=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ze=await He.getDiagnostics(Ke,Qe);throw console.log(Ze),new y.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow(je,pe),pe.trace("Sending env to running instance..."),await je.start(X.args,process.env),Le.dispose(),xe&&clearTimeout(xe),new y.ExpectedError("Sent env to running instance. Terminating...")}if(X.args.status)throw console.log((0,s.localize)(5,null,Se.nameShort)),new y.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ue}handleStartupDataDirError(pe,X,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const he=(0,k.coalesce)([pe.userDataPath,pe.extensionsPath,D.XDG_RUNTIME_DIR]).map(Se=>(0,f.getPathLabel)(I.URI.file(Se),{os:v.OS,tildify:pe}));this.showStartupWarningDialog((0,s.localize)(6,null),(0,s.localize)(7,null,(0,R.toErrorMessage)(ue),he.join(`
`)),X)}}showStartupWarningDialog(pe,X,ue){n.dialog.showMessageBoxSync((0,fe.massageMessageBoxOptions)({type:"warning",buttons:[(0,s.localize)(8,null)],message:pe,detail:X},ue).options)}async windowsAllowSetForegroundWindow(pe,X){if(v.isWindows){const ue=await pe.getMainProcessId();X.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((he,Se)=>{V(["windows-foreground-love"],he,Se)}).then(ke)).allowSetForegroundWindow(ue)}catch(he){X.error(he)}}}quit(pe,X){const ue=pe.get(z.ILogService),he=pe.get(B.ILifecycleMainService);let Se=0;X&&(X.isExpected?X.message&&ue.trace(X.message):(Se=1,X.stack?ue.error(X.stack):ue.error(`Startup error: ${X.toString()}`))),he.kill(Se)}resolveArgs(){const pe=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const X=(0,P.createWaitMarkerFileSync)(pe.verbose);X&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",X),pe.waitMarkerFilePath=X)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const X=this.doValidatePaths(pe._,pe.goto);pe._=X}return pe}doValidatePaths(pe,X){const ue=(0,E.cwd)(),he=pe.map(Ue=>{let We=String(Ue),Le;X&&(Le=(0,a.parseLineAndColumnAware)(We),We=Le.path),We&&(We=this.preparePath(ue,We));const xe=(0,a.sanitizeFilePath)(We,ue),je=(0,w.basename)(xe);return je&&!(0,a.isValidBasename)(je)?null:X&&Le?(Le.path=xe,this.toPath(Le)):xe}),Se=v.isWindows||v.isMacintosh,Me=(0,k.distinct)(he,Ue=>Ue&&Se?Ue.toLowerCase():Ue||"");return(0,k.coalesce)(Me)}preparePath(pe,X){return v.isWindows&&(X=(0,p.rtrim)(X,'"')),X=(0,p.trim)((0,p.trim)(X," "),"	"),v.isWindows&&(X=(0,w.resolve)(pe,X),X=(0,p.rtrim)(X,".")),X}toPath(pe){const X=[pe.path];return typeof pe.line=="number"&&X.push(String(pe.line)),typeof pe.column=="number"&&X.push(String(pe.column)),X.join(":")}}new Ie().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/code/electron-main/main.js.map
