/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/browser/event","vs/base/common/path","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(ne){for(var t=[],i=0,n=ne.length;i<n;i++)t[i]=De[ne[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ut,isFrozen:ui,getPrototypeOf:ci,getOwnPropertyDescriptor:hi}=Object;let{freeze:ut,seal:bt,create:di}=Object,{apply:kt,construct:Mt}=typeof Reflect<"u"&&Reflect;kt||(kt=function(t,i,n){return t.apply(i,n)}),ut||(ut=function(t){return t}),bt||(bt=function(t){return t}),Mt||(Mt=function(t,i){return new t(...i)});const fi=pt(Array.prototype.forEach),Vt=pt(Array.prototype.pop),St=pt(Array.prototype.push),Nt=pt(String.prototype.toLowerCase),Pt=pt(String.prototype.toString),gi=pt(String.prototype.match),vt=pt(String.prototype.replace),mi=pt(String.prototype.indexOf),pi=pt(String.prototype.trim),gt=pt(RegExp.prototype.test),At=bi(TypeError);function pt(ne){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),k=1;k<i;k++)n[k-1]=arguments[k];return kt(ne,t,n)}}function bi(ne){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Mt(ne,i)}}function Ge(ne,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Nt,Ut&&Ut(ne,null);let k=t.length;for(;k--;){let R=t[k];if(typeof R=="string"){const N=i(R);N!==R&&(ui(t)||(t[k]=N),R=N)}ne[R]=!0}return ne}function Et(ne){const t=di(null);for(const[i,n]of zt(ne))t[i]=n;return t}function Ft(ne,t){for(;ne!==null;){const n=hi(ne,t);if(n){if(n.get)return pt(n.get);if(typeof n.value=="function")return pt(n.value)}ne=ci(ne)}function i(n){return console.warn("fallback value for",n),null}return i}const Kt=ut(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Bt=ut(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),xt=ut(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),vi=ut(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Wt=ut(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),Di=ut(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),$t=ut(["#text"]),qt=ut(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ht=ut(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Gt=ut(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Rt=ut(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),wi=bt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),Ei=bt(/<%[\w\W]*|[\w\W]*%>/gm),_i=bt(/\${[\w\W]*}/gm),yi=bt(/^data-[\-\w.\u00B7-\uFFFF]/),Si=bt(/^aria-[\-\w]+$/),jt=bt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Ai=bt(/^(?:\w+script|data):/i),Ti=bt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Yt=bt(/^html$/i);var Xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:wi,ERB_EXPR:Ei,TMPLIT_EXPR:_i,DATA_ATTR:yi,ARIA_ATTR:Si,IS_ALLOWED_URI:jt,IS_SCRIPT_OR_DATA:Ai,ATTR_WHITESPACE:Ti,DOCTYPE_NAME:Yt});const Li=()=>typeof window>"u"?null:window,Ii=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const k="data-tt-policy-suffix";i&&i.hasAttribute(k)&&(n=i.getAttribute(k));const R="dompurify"+(n?"#"+n:"");try{return t.createPolicy(R,{createHTML(N){return N},createScriptURL(N){return N}})}catch{return console.warn("TrustedTypes policy "+R+" could not be created."),null}};function Zt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Li();const t=ze=>Zt(ze);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const i=ne.document,n=i.currentScript;let{document:k}=ne;const{DocumentFragment:R,HTMLTemplateElement:N,Node:w,Element:_,NodeFilter:d,NamedNodeMap:b=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:y,DOMParser:p,trustedTypes:m}=ne,e=_.prototype,s=Ft(e,"cloneNode"),o=Ft(e,"nextSibling"),c=Ft(e,"childNodes"),h=Ft(e,"parentNode");if(typeof N=="function"){const ze=k.createElement("template");ze.content&&ze.content.ownerDocument&&(k=ze.content.ownerDocument)}let v,L="";const{implementation:S,createNodeIterator:r,createDocumentFragment:f,getElementsByTagName:E}=k,{importNode:T}=i;let H={};t.isSupported=typeof zt=="function"&&typeof h=="function"&&S&&S.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:W,ERB_EXPR:U,TMPLIT_EXPR:D,DATA_ATTR:x,ARIA_ATTR:z,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:P}=Xt;let{IS_ALLOWED_URI:K}=Xt,Q=null;const X=Ge({},[...Kt,...Bt,...xt,...Wt,...$t]);let G=null;const J=Ge({},[...qt,...Ht,...Gt,...Rt]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),pe=null,Te=null,Fe=!0,re=!0,ee=!1,he=!0,le=!1,Ne=!1,te=!1,be=!1,Se=!1,Oe=!1,Re=!1,We=!0,oe=!1;const q="user-content-";let B=!0,l=!1,a={},g=null;const C=Ge({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const u=Ge({},["audio","video","img","source","image","track"]);let I=null;const A=Ge({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),M="http://www.w3.org/1998/Math/MathML",V="http://www.w3.org/2000/svg",Y="http://www.w3.org/1999/xhtml";let ie=Y,ae=!1,fe=null;const _e=Ge({},[M,V,Y],Pt);let Ee;const Le=["application/xhtml+xml","text/html"],Ie="text/html";let de,Ce=null;const qe=k.createElement("form"),Xe=function(ge){return ge instanceof RegExp||ge instanceof Function},tt=function(ge){if(!(Ce&&Ce===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=Et(ge),Ee=Le.indexOf(ge.PARSER_MEDIA_TYPE)===-1?Ee=Ie:Ee=ge.PARSER_MEDIA_TYPE,de=Ee==="application/xhtml+xml"?Pt:Nt,Q="ALLOWED_TAGS"in ge?Ge({},ge.ALLOWED_TAGS,de):X,G="ALLOWED_ATTR"in ge?Ge({},ge.ALLOWED_ATTR,de):J,fe="ALLOWED_NAMESPACES"in ge?Ge({},ge.ALLOWED_NAMESPACES,Pt):_e,I="ADD_URI_SAFE_ATTR"in ge?Ge(Et(A),ge.ADD_URI_SAFE_ATTR,de):A,F="ADD_DATA_URI_TAGS"in ge?Ge(Et(u),ge.ADD_DATA_URI_TAGS,de):u,g="FORBID_CONTENTS"in ge?Ge({},ge.FORBID_CONTENTS,de):C,pe="FORBID_TAGS"in ge?Ge({},ge.FORBID_TAGS,de):{},Te="FORBID_ATTR"in ge?Ge({},ge.FORBID_ATTR,de):{},a="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Fe=ge.ALLOW_ARIA_ATTR!==!1,re=ge.ALLOW_DATA_ATTR!==!1,ee=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,he=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=ge.SAFE_FOR_TEMPLATES||!1,Ne=ge.WHOLE_DOCUMENT||!1,Se=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Re=ge.RETURN_TRUSTED_TYPE||!1,be=ge.FORCE_BODY||!1,We=ge.SANITIZE_DOM!==!1,oe=ge.SANITIZE_NAMED_PROPS||!1,B=ge.KEEP_CONTENT!==!1,l=ge.IN_PLACE||!1,K=ge.ALLOWED_URI_REGEXP||jt,ie=ge.NAMESPACE||Y,ce=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(re=!1),Oe&&(Se=!0),a&&(Q=Ge({},[...$t]),G=[],a.html===!0&&(Ge(Q,Kt),Ge(G,qt)),a.svg===!0&&(Ge(Q,Bt),Ge(G,Ht),Ge(G,Rt)),a.svgFilters===!0&&(Ge(Q,xt),Ge(G,Ht),Ge(G,Rt)),a.mathMl===!0&&(Ge(Q,Wt),Ge(G,Gt),Ge(G,Rt))),ge.ADD_TAGS&&(Q===X&&(Q=Et(Q)),Ge(Q,ge.ADD_TAGS,de)),ge.ADD_ATTR&&(G===J&&(G=Et(G)),Ge(G,ge.ADD_ATTR,de)),ge.ADD_URI_SAFE_ATTR&&Ge(I,ge.ADD_URI_SAFE_ATTR,de),ge.FORBID_CONTENTS&&(g===C&&(g=Et(g)),Ge(g,ge.FORBID_CONTENTS,de)),B&&(Q["#text"]=!0),Ne&&Ge(Q,["html","head","body"]),Q.table&&(Ge(Q,["tbody"]),delete pe.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw At('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw At('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=ge.TRUSTED_TYPES_POLICY,L=v.createHTML("")}else v===void 0&&(v=Ii(m,n)),v!==null&&typeof L=="string"&&(L=v.createHTML(""));ut&&ut(ge),Ce=ge}},lt=Ge({},["mi","mo","mn","ms","mtext"]),rt=Ge({},["foreignobject","desc","title","annotation-xml"]),je=Ge({},["title","style","font","a","script"]),Ze=Ge({},Bt);Ge(Ze,xt),Ge(Ze,vi);const Z=Ge({},Wt);Ge(Z,Di);const ue=function(ge){let ke=h(ge);(!ke||!ke.tagName)&&(ke={namespaceURI:ie,tagName:"template"});const Be=Nt(ge.tagName),Ye=Nt(ke.tagName);return fe[ge.namespaceURI]?ge.namespaceURI===V?ke.namespaceURI===Y?Be==="svg":ke.namespaceURI===M?Be==="svg"&&(Ye==="annotation-xml"||lt[Ye]):!!Ze[Be]:ge.namespaceURI===M?ke.namespaceURI===Y?Be==="math":ke.namespaceURI===V?Be==="math"&&rt[Ye]:!!Z[Be]:ge.namespaceURI===Y?ke.namespaceURI===V&&!rt[Ye]||ke.namespaceURI===M&&!lt[Ye]?!1:!Z[Be]&&(je[Be]||!Ze[Be]):!!(Ee==="application/xhtml+xml"&&fe[ge.namespaceURI]):!1},ve=function(ge){St(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Ae=function(ge,ke){try{St(t.removed,{attribute:ke.getAttributeNode(ge),from:ke})}catch{St(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ge),ge==="is"&&!G[ge])if(Se||Oe)try{ve(ke)}catch{}else try{ke.setAttribute(ge,"")}catch{}},Pe=function(ge){let ke,Be;if(be)ge="<remove></remove>"+ge;else{const ft=gi(ge,/^[\r\n\t ]+/);Be=ft&&ft[0]}Ee==="application/xhtml+xml"&&ie===Y&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ye=v?v.createHTML(ge):ge;if(ie===Y)try{ke=new p().parseFromString(Ye,Ee)}catch{}if(!ke||!ke.documentElement){ke=S.createDocument(ie,"template",null);try{ke.documentElement.innerHTML=ae?L:Ye}catch{}}const it=ke.body||ke.documentElement;return ge&&Be&&it.insertBefore(k.createTextNode(Be),it.childNodes[0]||null),ie===Y?E.call(ke,Ne?"html":"body")[0]:Ne?ke.documentElement:it},Ve=function(ge){return r.call(ge.ownerDocument||ge,ge,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},Qe=function(ge){return ge instanceof y&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof b)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},ot=function(ge){return typeof w=="object"?ge instanceof w:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},nt=function(ge,ke,Be){H[ge]&&fi(H[ge],Ye=>{Ye.call(t,ke,Be,Ce)})},ct=function(ge){let ke;if(nt("beforeSanitizeElements",ge,null),Qe(ge))return ve(ge),!0;const Be=de(ge.nodeName);if(nt("uponSanitizeElement",ge,{tagName:Be,allowedTags:Q}),ge.hasChildNodes()&&!ot(ge.firstElementChild)&&(!ot(ge.content)||!ot(ge.content.firstElementChild))&&gt(/<[/\w]/g,ge.innerHTML)&&gt(/<[/\w]/g,ge.textContent))return ve(ge),!0;if(!Q[Be]||pe[Be]){if(!pe[Be]&&dt(Be)&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,Be)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Be)))return!1;if(B&&!g[Be]){const Ye=h(ge)||ge.parentNode,it=c(ge)||ge.childNodes;if(it&&Ye){const ft=it.length;for(let Je=ft-1;Je>=0;--Je)Ye.insertBefore(s(it[Je],!0),o(ge))}}return ve(ge),!0}return ge instanceof _&&!ue(ge)||(Be==="noscript"||Be==="noembed"||Be==="noframes")&&gt(/<\/no(script|embed|frames)/i,ge.innerHTML)?(ve(ge),!0):(le&&ge.nodeType===3&&(ke=ge.textContent,ke=vt(ke,W," "),ke=vt(ke,U," "),ke=vt(ke,D," "),ge.textContent!==ke&&(St(t.removed,{element:ge.cloneNode()}),ge.textContent=ke)),nt("afterSanitizeElements",ge,null),!1)},st=function(ge,ke,Be){if(We&&(ke==="id"||ke==="name")&&(Be in k||Be in qe))return!1;if(!(re&&!Te[ke]&&gt(x,ke))){if(!(Fe&&gt(z,ke))){if(!G[ke]||Te[ke]){if(!(dt(ge)&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,ge)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(ge))&&(ce.attributeNameCheck instanceof RegExp&&gt(ce.attributeNameCheck,ke)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(ke))||ke==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,Be)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Be))))return!1}else if(!I[ke]){if(!gt(K,vt(Be,P,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ge!=="script"&&mi(Be,"data:")===0&&F[ge])){if(!(ee&&!gt(O,vt(Be,P,"")))){if(Be)return!1}}}}}}return!0},dt=function(ge){return ge.indexOf("-")>0},ht=function(ge){let ke,Be,Ye,it;nt("beforeSanitizeAttributes",ge,null);const{attributes:ft}=ge;if(!ft)return;const Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:G};for(it=ft.length;it--;){ke=ft[it];const{name:mt,namespaceURI:Tt}=ke;if(Be=mt==="value"?ke.value:pi(ke.value),Ye=de(mt),Je.attrName=Ye,Je.attrValue=Be,Je.keepAttr=!0,Je.forceKeepAttr=void 0,nt("uponSanitizeAttribute",ge,Je),Be=Je.attrValue,Je.forceKeepAttr||(Ae(mt,ge),!Je.keepAttr))continue;if(!he&&gt(/\/>/i,Be)){Ae(mt,ge);continue}le&&(Be=vt(Be,W," "),Be=vt(Be,U," "),Be=vt(Be,D," "));const Ct=de(ge.nodeName);if(st(Ct,Ye,Be)){if(oe&&(Ye==="id"||Ye==="name")&&(Ae(mt,ge),Be=q+Be),v&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!Tt)switch(m.getAttributeType(Ct,Ye)){case"TrustedHTML":{Be=v.createHTML(Be);break}case"TrustedScriptURL":{Be=v.createScriptURL(Be);break}}try{Tt?ge.setAttributeNS(Tt,mt,Be):ge.setAttribute(mt,Be),Vt(t.removed)}catch{}}}nt("afterSanitizeAttributes",ge,null)},Dt=function ze(ge){let ke;const Be=Ve(ge);for(nt("beforeSanitizeShadowDOM",ge,null);ke=Be.nextNode();)nt("uponSanitizeShadowNode",ke,null),!ct(ke)&&(ke.content instanceof R&&ze(ke.content),ht(ke));nt("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(ze){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Be,Ye,it;if(ae=!ze,ae&&(ze="<!-->"),typeof ze!="string"&&!ot(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw At("dirty is not a string, aborting")}else throw At("toString is not a function");if(!t.isSupported)return ze;if(te||tt(ge),t.removed=[],typeof ze=="string"&&(l=!1),l){if(ze.nodeName){const mt=de(ze.nodeName);if(!Q[mt]||pe[mt])throw At("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof w)ke=Pe("<!---->"),Be=ke.ownerDocument.importNode(ze,!0),Be.nodeType===1&&Be.nodeName==="BODY"||Be.nodeName==="HTML"?ke=Be:ke.appendChild(Be);else{if(!Se&&!le&&!Ne&&ze.indexOf("<")===-1)return v&&Re?v.createHTML(ze):ze;if(ke=Pe(ze),!ke)return Se?null:Re?L:""}ke&&be&&ve(ke.firstChild);const ft=Ve(l?ze:ke);for(;Ye=ft.nextNode();)ct(Ye)||(Ye.content instanceof R&&Dt(Ye.content),ht(Ye));if(l)return ze;if(Se){if(Oe)for(it=f.call(ke.ownerDocument);ke.firstChild;)it.appendChild(ke.firstChild);else it=ke;return(G.shadowroot||G.shadowrootmode)&&(it=T.call(i,it,!0)),it}let Je=Ne?ke.outerHTML:ke.innerHTML;return Ne&&Q["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&gt(Yt,ke.ownerDocument.doctype.name)&&(Je="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Je),le&&(Je=vt(Je,W," "),Je=vt(Je,U," "),Je=vt(Je,D," ")),v&&Re?v.createHTML(Je):Je},t.setConfig=function(ze){tt(ze),te=!0},t.clearConfig=function(){Ce=null,te=!1},t.isValidAttribute=function(ze,ge,ke){Ce||tt({});const Be=de(ze),Ye=de(ge);return st(Be,Ye,ke)},t.addHook=function(ze,ge){typeof ge=="function"&&(H[ze]=H[ze]||[],St(H[ze],ge))},t.removeHook=function(ze){if(H[ze])return Vt(H[ze])},t.removeHooks=function(ze){H[ze]&&(H[ze]=[])},t.removeAllHooks=function(){H={}},t}var Ni=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Ni}),define(De[56],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=k;class i{constructor(N){this.domNode=N,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(N){const w=n(N);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(N){const w=n(N);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(N){const w=n(N);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(N){const w=n(N);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(N){const w=n(N);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(N){const w=n(N);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(N){const w=n(N);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setPaddingTop(N){const w=n(N);this._paddingTop!==w&&(this._paddingTop=w,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(N){const w=n(N);this._paddingLeft!==w&&(this._paddingLeft=w,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(N){const w=n(N);this._paddingBottom!==w&&(this._paddingBottom=w,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(N){const w=n(N);this._paddingRight!==w&&(this._paddingRight=w,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(N){this._fontFamily!==N&&(this._fontFamily=N,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(N){this._fontWeight!==N&&(this._fontWeight=N,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(N){const w=n(N);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(N){this._fontStyle!==N&&(this._fontStyle=N,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(N){this._fontFeatureSettings!==N&&(this._fontFeatureSettings=N,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(N){this._fontVariationSettings!==N&&(this._fontVariationSettings=N,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(N){this._textDecoration!==N&&(this._textDecoration=N,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(N){const w=n(N);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(N){const w=n(N);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(N){this._className!==N&&(this._className=N,this.domNode.className=this._className)}toggleClassName(N,w){this.domNode.classList.toggle(N,w),this._className=this.domNode.className}setDisplay(N){this._display!==N&&(this._display=N,this.domNode.style.display=this._display)}setPosition(N){this._position!==N&&(this._position=N,this.domNode.style.position=this._position)}setVisibility(N){this._visibility!==N&&(this._visibility=N,this.domNode.style.visibility=this._visibility)}setColor(N){this._color!==N&&(this._color=N,this.domNode.style.color=this._color)}setBackgroundColor(N){this._backgroundColor!==N&&(this._backgroundColor=N,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(N){this._layerHint!==N&&(this._layerHint=N,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(N){this._boxShadow!==N&&(this._boxShadow=N,this.domNode.style.boxShadow=N)}setContain(N){this._contain!==N&&(this._contain=N,this.domNode.style.contain=this._contain)}setAttribute(N,w){this.domNode.setAttribute(N,w)}removeAttribute(N){this.domNode.removeAttribute(N)}appendChild(N){this.domNode.appendChild(N.domNode)}removeChild(N){this.domNode.removeChild(N.domNode)}}t.FastDomNode=i;function n(R){return typeof R=="number"?`${R}px`:R}function k(R){return new i(R)}}),define(De[86],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=R;const i=new WeakMap;function n(w){if(!w.parent||w.parent===w)return null;try{const _=w.location,d=w.parent.location;if(_.origin!=="null"&&d.origin!=="null"&&_.origin!==d.origin)return null}catch{return null}return w.parent}class k{static getSameOriginWindowChain(_){let d=i.get(_);if(!d){d=[],i.set(_,d);let b=_,y;do y=n(b),y?d.push({window:new WeakRef(b),iframeElement:b.frameElement||null}):d.push({window:new WeakRef(b),iframeElement:null}),b=y;while(b)}return d.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(_,d){if(!d||_===d)return{top:0,left:0};let b=0,y=0;const p=this.getSameOriginWindowChain(_);for(const m of p){const e=m.window.deref();if(b+=e?.scrollY??0,y+=e?.scrollX??0,e===d||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();b+=s.top,y+=s.left}return{top:b,left:y}}}t.IframeUtils=k;async function R(w,_){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:w,salt:_}),y=new TextEncoder().encode(d),p=await crypto.subtle.digest("sha-256",y);return N(p)}function N(w){const d=Array.from(new Uint8Array(w)).map(b=>b.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(De[34],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setBaseLayerHoverDelegate=n,t.getBaseLayerHoverDelegate=k;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(R){i=R}function k(){return i}}),define(De[42],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(N){N[N.Copy=0]="Copy",N[N.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(N){N.Over="drop-target",N.Before="drop-target-before",N.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class k extends Error{constructor(w,_){super(`ListError [${w}] ${_}`)}}t.ListError=k;class R{constructor(){this.cache=new WeakMap}getHeight(w){return this.cache.get(w)??this.estimateHeight(w)}setDynamicHeight(w,_){_>0&&this.cache.set(w,_)}}t.CachedListVirtualDelegate=R}),define(De[87],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class i{constructor(k){this.spliceables=k}splice(k,R,N){this.spliceables.forEach(w=>w.splice(k,R,N))}}t.CombinedSpliceable=i}),define(De[57],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const i=20;class n{constructor(R,N,w,_,d,b){this._scrollbarSize=Math.round(N),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(R),this._visibleSize=_,this._scrollSize=d,this._scrollPosition=b,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new n(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(R){const N=Math.round(R);return this._visibleSize!==N?(this._visibleSize=N,this._refreshComputedValues(),!0):!1}setScrollSize(R){const N=Math.round(R);return this._scrollSize!==N?(this._scrollSize=N,this._refreshComputedValues(),!0):!1}setScrollPosition(R){const N=Math.round(R);return this._scrollPosition!==N?(this._scrollPosition=N,this._refreshComputedValues(),!0):!1}setScrollbarSize(R){this._scrollbarSize=Math.round(R)}setOppositeScrollbarSize(R){this._oppositeScrollbarSize=Math.round(R)}static _computeValues(R,N,w,_,d){const b=Math.max(0,w-R),y=Math.max(0,b-2*N),p=_>0&&_>w;if(!p)return{computedAvailableSize:Math.round(b),computedIsNeeded:p,computedSliderSize:Math.round(y),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(w*y/_))),e=(y-m)/(_-w),s=d*e;return{computedAvailableSize:Math.round(b),computedIsNeeded:p,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const R=n._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=R.computedAvailableSize,this._computedIsNeeded=R.computedIsNeeded,this._computedSliderSize=R.computedSliderSize,this._computedSliderRatio=R.computedSliderRatio,this._computedSliderPosition=R.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(R){if(!this._computedIsNeeded)return 0;const N=R-this._arrowSize-this._computedSliderSize/2;return Math.round(N/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(R){if(!this._computedIsNeeded)return 0;const N=R-this._arrowSize;let w=this._scrollPosition;return N<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(R){if(!this._computedIsNeeded)return 0;const N=this._computedSliderPosition+R;return Math.round(N/this._computedSliderRatio)}}t.ScrollbarState=n}),define(De[35],we([1,0,42]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var k;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(k||(t.ObjectTreeElementCollapseState=k={}));var R;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(R||(t.TreeMouseEventTarget=R={}));var N;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(N||(t.TreeDragOverBubble=N={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:N.Up}},acceptBubbleDown(d=!1){return{accept:!0,bubble:N.Down,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:N.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:N.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:d}}};class w extends Error{constructor(b,y){super(`TreeError [${b}] ${y}`)}}t.TreeError=w;class _{constructor(b){this.fn=b,this._map=new WeakMap}map(b){let y=this._map.get(b);return y||(y=this.fn(b),this._map.set(b,y)),y}}t.WeakMapper=_}),define(De[25],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=i,t.isAuxiliaryWindow=n;function i(k,R){const N=k;typeof N.vscodeWindowId!="number"&&Object.defineProperty(N,"vscodeWindowId",{get:()=>R})}t.mainWindow=window;function n(k){return k===t.mainWindow?!1:typeof k?.vscodeWindowId=="number"}}),define(De[88],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=n,t.findLastMonotonous=k,t.findLastIdxMonotonous=R,t.findFirstMonotonous=N,t.findFirstIdxMonotonousOrArrLen=w,t.findFirstIdxMonotonous=_,t.findFirstMax=b,t.findLastMax=y,t.findFirstMin=p,t.findMaxIdx=m,t.mapFindFirst=e;function i(s,o){const c=n(s,o);if(c!==-1)return s[c]}function n(s,o,c=s.length-1){for(let h=c;h>=0;h--){const v=s[h];if(o(v))return h}return-1}function k(s,o){const c=R(s,o);return c===-1?void 0:s[c]}function R(s,o,c=0,h=s.length){let v=c,L=h;for(;v<L;){const S=Math.floor((v+L)/2);o(s[S])?v=S+1:L=S}return v-1}function N(s,o){const c=w(s,o);return c===s.length?void 0:s[c]}function w(s,o,c=0,h=s.length){let v=c,L=h;for(;v<L;){const S=Math.floor((v+L)/2);o(s[S])?L=S:v=S+1}return v}function _(s,o,c=0,h=s.length){const v=w(s,o,c,h);return v===s.length?-1:v}class d{static{this.assertInvariants=!1}constructor(o){this._array=o,this._findLastMonotonousLastIdx=0}findLastMonotonous(o){if(d.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!o(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=o}const c=R(this._array,o,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}t.MonotonousArray=d;function b(s,o){if(s.length===0)return;let c=s[0];for(let h=1;h<s.length;h++){const v=s[h];o(v,c)>0&&(c=v)}return c}function y(s,o){if(s.length===0)return;let c=s[0];for(let h=1;h<s.length;h++){const v=s[h];o(v,c)>=0&&(c=v)}return c}function p(s,o){return b(s,(c,h)=>-o(c,h))}function m(s,o){if(s.length===0)return-1;let c=0;for(let h=1;h<s.length;h++){const v=s[h];o(v,s[c])>0&&(c=h)}return c}function e(s,o){for(const c of s){const h=o(c);if(h!==void 0)return h}}}),define(De[18],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(De[58],we([1,0]),function(ne,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=n,t.diffSets=k,t.diffMaps=R,t.intersection=N;function n(_,d){const b=Object.create(null);for(const y of _){const p=d(y);let m=b[p];m||(m=b[p]=[]),m.push(y)}return b}function k(_,d){const b=[],y=[];for(const p of _)d.has(p)||b.push(p);for(const p of d)_.has(p)||y.push(p);return{removed:b,added:y}}function R(_,d){const b=[],y=[];for(const[p,m]of _)d.has(p)||b.push(m);for(const[p,m]of d)_.has(p)||y.push(m);return{removed:b,added:y}}function N(_,d){const b=new Set;for(const y of d)_.has(y)&&b.add(y);return b}class w{static{i=Symbol.toStringTag}constructor(d,b){this.toKey=b,this._map=new Map,this[i]="SetWithKey";for(const y of d)this.add(y)}get size(){return this._map.size}add(d){const b=this.toKey(d);return this._map.set(b,d),this}delete(d){return this._map.delete(this.toKey(d))}has(d){return this._map.has(this.toKey(d))}*entries(){for(const d of this._map.values())yield[d,d]}keys(){return this.values()}*values(){for(const d of this._map.values())yield d}clear(){this._map.clear()}forEach(d,b){this._map.forEach(y=>d.call(b,y,y,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=w}),define(De[89],we([1,0,18]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function n(_,d){const b=Math.pow(10,d);return Math.round(_*b)/b}class k{constructor(d,b,y,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,p),0),3)}static equals(d,b){return d.r===b.r&&d.g===b.g&&d.b===b.b&&d.a===b.a}}t.RGBA=k;class R{constructor(d,b,y,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,b),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(d,b){return d.h===b.h&&d.s===b.s&&d.l===b.l&&d.a===b.a}static fromRGBA(d){const b=d.r/255,y=d.g/255,p=d.b/255,m=d.a,e=Math.max(b,y,p),s=Math.min(b,y,p);let o=0,c=0;const h=(s+e)/2,v=e-s;if(v>0){switch(c=Math.min(h<=.5?v/(2*h):v/(2-2*h),1),e){case b:o=(y-p)/v+(y<p?6:0);break;case y:o=(p-b)/v+2;break;case p:o=(b-y)/v+4;break}o*=60,o=Math.round(o)}return new R(o,c,h,m)}static _hue2rgb(d,b,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?d+(b-d)*6*y:y<1/2?b:y<2/3?d+(b-d)*(2/3-y)*6:d}static toRGBA(d){const b=d.h/360,{s:y,l:p,a:m}=d;let e,s,o;if(y===0)e=s=o=p;else{const c=p<.5?p*(1+y):p+y-p*y,h=2*p-c;e=R._hue2rgb(h,c,b+1/3),s=R._hue2rgb(h,c,b),o=R._hue2rgb(h,c,b-1/3)}return new k(Math.round(e*255),Math.round(s*255),Math.round(o*255),m)}}t.HSLA=R;class N{constructor(d,b,y,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,b),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(d,b){return d.h===b.h&&d.s===b.s&&d.v===b.v&&d.a===b.a}static fromRGBA(d){const b=d.r/255,y=d.g/255,p=d.b/255,m=Math.max(b,y,p),e=Math.min(b,y,p),s=m-e,o=m===0?0:s/m;let c;return s===0?c=0:m===b?c=((y-p)/s%6+6)%6:m===y?c=(p-b)/s+2:c=(b-y)/s+4,new N(Math.round(c*60),o,m,d.a)}static toRGBA(d){const{h:b,s:y,v:p,a:m}=d,e=p*y,s=e*(1-Math.abs(b/60%2-1)),o=p-e;let[c,h,v]=[0,0,0];return b<60?(c=e,h=s):b<120?(c=s,h=e):b<180?(h=e,v=s):b<240?(h=s,v=e):b<300?(c=s,v=e):b<=360&&(c=e,v=s),c=Math.round((c+o)*255),h=Math.round((h+o)*255),v=Math.round((v+o)*255),new k(c,h,v,m)}}t.HSVA=N;class w{static fromHex(d){return w.Format.CSS.parseHex(d)||w.red}static equals(d,b){return!d&&!b?!0:!d||!b?!1:d.equals(b)}get hsla(){return this._hsla?this._hsla:R.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:N.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof k)this.rgba=d;else if(d instanceof R)this._hsla=d,this.rgba=R.toRGBA(d);else if(d instanceof N)this._hsva=d,this.rgba=N.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&k.equals(this.rgba,d.rgba)&&R.equals(this.hsla,d.hsla)&&N.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=w._relativeLuminanceForComponent(this.rgba.r),b=w._relativeLuminanceForComponent(this.rgba.g),y=w._relativeLuminanceForComponent(this.rgba.b),p=.2126*d+.7152*b+.0722*y;return n(p,4)}static _relativeLuminanceForComponent(d){const b=d/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(d){const b=this.getRelativeLuminance(),y=d.getRelativeLuminance();return b>y?(b+.05)/(y+.05):(y+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const b=this.getRelativeLuminance(),y=d.getRelativeLuminance();return b>y}isDarkerThan(d){const b=this.getRelativeLuminance(),y=d.getRelativeLuminance();return b<y}lighten(d){return new w(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new w(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:b,g:y,b:p,a:m}=this.rgba;return new w(new k(b,y,p,m*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const b=d.rgba,y=this.rgba.a,p=b.a,m=y+p*(1-y);if(m<1e-6)return w.transparent;const e=this.rgba.r*y/m+b.r*p*(1-y)/m,s=this.rgba.g*y/m+b.g*p*(1-y)/m,o=this.rgba.b*y/m+b.b*p*(1-y)/m;return new w(new k(e,s,o,m))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:b,g:y,b:p,a:m}=this.rgba;return new w(new k(d.rgba.r-m*(d.rgba.r-b),d.rgba.g-m*(d.rgba.g-y),d.rgba.b-m*(d.rgba.b-p),1))}flatten(...d){const b=d.reduceRight((y,p)=>w._flatten(p,y));return w._flatten(this,b)}static _flatten(d,b){const y=1-d.rgba.a;return new w(new k(y*b.rgba.r+d.rgba.a*d.rgba.r,y*b.rgba.g+d.rgba.a*d.rgba.g,y*b.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=w.Format.CSS.format(this)),this._toString}static getLighterColor(d,b,y){if(d.isLighterThan(b))return d;y=y||.5;const p=d.getRelativeLuminance(),m=b.getRelativeLuminance();return y=y*(m-p)/m,d.lighten(y)}static getDarkerColor(d,b,y){if(d.isDarkerThan(b))return d;y=y||.5;const p=d.getRelativeLuminance(),m=b.getRelativeLuminance();return y=y*(p-m)/p,d.darken(y)}static{this.white=new w(new k(255,255,255,1))}static{this.black=new w(new k(0,0,0,1))}static{this.red=new w(new k(255,0,0,1))}static{this.blue=new w(new k(0,0,255,1))}static{this.green=new w(new k(0,255,0,1))}static{this.cyan=new w(new k(0,255,255,1))}static{this.lightgrey=new w(new k(211,211,211,1))}static{this.transparent=new w(new k(0,0,0,0))}}t.Color=w,function(_){let d;(function(b){let y;(function(p){function m(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:_.Format.CSS.formatRGBA(f)}p.formatRGB=m;function e(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}p.formatRGBA=e;function s(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(f)}p.formatHSL=s;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}p.formatHSLA=o;function c(f){const E=f.toString(16);return E.length!==2?"0"+E:E}function h(f){return`#${c(f.rgba.r)}${c(f.rgba.g)}${c(f.rgba.b)}`}p.formatHex=h;function v(f,E=!1){return E&&f.rgba.a===1?_.Format.CSS.formatHex(f):`#${c(f.rgba.r)}${c(f.rgba.g)}${c(f.rgba.b)}${c(Math.round(f.rgba.a*255))}`}p.formatHexA=v;function L(f){return f.isOpaque()?_.Format.CSS.formatHex(f):_.Format.CSS.formatRGBA(f)}p.format=L;function S(f){const E=f.length;if(E===0||f.charCodeAt(0)!==i.CharCode.Hash)return null;if(E===7){const T=16*r(f.charCodeAt(1))+r(f.charCodeAt(2)),H=16*r(f.charCodeAt(3))+r(f.charCodeAt(4)),W=16*r(f.charCodeAt(5))+r(f.charCodeAt(6));return new _(new k(T,H,W,1))}if(E===9){const T=16*r(f.charCodeAt(1))+r(f.charCodeAt(2)),H=16*r(f.charCodeAt(3))+r(f.charCodeAt(4)),W=16*r(f.charCodeAt(5))+r(f.charCodeAt(6)),U=16*r(f.charCodeAt(7))+r(f.charCodeAt(8));return new _(new k(T,H,W,U/255))}if(E===4){const T=r(f.charCodeAt(1)),H=r(f.charCodeAt(2)),W=r(f.charCodeAt(3));return new _(new k(16*T+T,16*H+H,16*W+W))}if(E===5){const T=r(f.charCodeAt(1)),H=r(f.charCodeAt(2)),W=r(f.charCodeAt(3)),U=r(f.charCodeAt(4));return new _(new k(16*T+T,16*H+H,16*W+W,(16*U+U)/255))}return null}p.parseHex=S;function r(f){switch(f){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(y=b.CSS||(b.CSS={}))})(d=_.Format||(_.Format={}))}(w||(t.Color=w={}))}),define(De[36],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=n,t.debounce=k,t.throttle=R;function i(N){return(w,_,d)=>{let b=null,y=null;if(typeof d.value=="function"?(b="value",y=d.value):typeof d.get=="function"&&(b="get",y=d.get),!y)throw new Error("not supported");d[b]=N(y,_)}}function n(N,w,_){let d=null,b=null;if(typeof _.value=="function"?(d="value",b=_.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(d="get",b=_.get),!b)throw new Error("not supported");const y=`$memoize$${w}`;_[d]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[y]}}function k(N,w,_){return i((d,b)=>{const y=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...m){this[p]||(this[p]=_?_():void 0),clearTimeout(this[y]),w&&(this[p]=w(this[p],...m),m=[this[p]]),this[y]=setTimeout(()=>{d.apply(this,m),this[p]=_?_():void 0},N)}})}function R(N,w,_){return i((d,b)=>{const y=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,m=`$throttle$lastRun$${b}`,e=`$throttle$pending$${b}`;return function(...s){if(this[p]||(this[p]=_?_():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),w&&(this[p]=w(this[p],...s)),this[e])return;const o=this[m]+N;o<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[p]]),this[p]=_?_():void 0):(this[e]=!0,this[y]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),d.apply(this,[this[p]]),this[p]=_?_():void 0},o-Date.now()))}})}}),define(De[90],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(k,R,N,w){this.originalStart=k,this.originalLength=R,this.modifiedStart=N,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),define(De[6],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=n,t.isSigPipeError=k,t.onUnexpectedError=R,t.onUnexpectedExternalError=N,t.transformErrorForSerialization=w,t.transformErrorFromSerialization=_,t.isCancellationError=b,t.canceled=p,t.illegalArgument=m,t.illegalState=e,t.getErrorMessage=o;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?L.isErrorNoTelemetry(f)?new L(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(E=>{E(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}t.ErrorHandler=i,t.errorHandler=new i;function n(r){t.errorHandler.setUnexpectedErrorHandler(r)}function k(r){if(!r||typeof r!="object")return!1;const f=r;return f.code==="EPIPE"&&f.syscall?.toUpperCase()==="WRITE"}function R(r){b(r)||t.errorHandler.onUnexpectedError(r)}function N(r){b(r)||t.errorHandler.onUnexpectedExternalError(r)}function w(r){if(r instanceof Error){const{name:f,message:E}=r,T=r.stacktrace||r.stack;return{$isError:!0,name:f,message:E,stack:T,noTelemetry:L.isErrorNoTelemetry(r)}}return r}function _(r){let f;return r.noTelemetry?f=new L:(f=new Error,f.name=r.name),f.message=r.message,f.stack=r.stack,f}const d="Canceled";function b(r){return r instanceof y?!0:r instanceof Error&&r.name===d&&r.message===d}class y extends Error{constructor(){super(d),this.name=this.message}}t.CancellationError=y;function p(){const r=new Error(d);return r.name=r.message,r}function m(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function e(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class s extends TypeError{constructor(f){super(f?`${f} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=s;function o(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class c extends Error{constructor(f){super("NotImplemented"),f&&(this.message=f)}}t.NotImplementedError=c;class h extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}t.NotSupportedError=h;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=v;class L extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof L)return f;const E=new L;return E.message=f.message,E.stack=f.stack,E}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}t.ErrorNoTelemetry=L;class S extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}t.BugIndicatingError=S}),define(De[9],we([1,0,6,88]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=k,t.tail2=R,t.equals=N,t.removeFastWithoutKeepingOrder=w,t.binarySearch=_,t.binarySearch2=d,t.quickSelect=b,t.groupBy=y,t.groupAdjacentBy=p,t.forEachAdjacent=m,t.forEachWithNeighbors=e,t.sortedDiff=s,t.delta=o,t.top=c,t.topAsync=h,t.coalesce=L,t.coalesceInPlace=S,t.move=r,t.isFalsyOrEmpty=f,t.isNonEmptyArray=E,t.distinct=T,t.uniqueFilter=H,t.firstOrDefault=W,t.lastOrDefault=U,t.commonPrefixLength=D,t.range=x,t.index=z,t.insert=O,t.remove=P,t.arrayInsert=K,t.shuffle=Q,t.pushToStart=X,t.pushToEnd=G,t.pushMany=J,t.mapArrayOrNot=ce,t.asArray=pe,t.getRandomElement=Te,t.insertInto=Fe,t.splice=re,t.compareBy=le,t.tieBreakComparators=Ne,t.reverseOrder=Se;function k(oe,q=0){return oe[oe.length-(1+q)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function N(oe,q,B=(l,a)=>l===a){if(oe===q)return!0;if(!oe||!q||oe.length!==q.length)return!1;for(let l=0,a=oe.length;l<a;l++)if(!B(oe[l],q[l]))return!1;return!0}function w(oe,q){const B=oe.length-1;q<B&&(oe[q]=oe[B]),oe.pop()}function _(oe,q,B){return d(oe.length,l=>B(oe[l],q))}function d(oe,q){let B=0,l=oe-1;for(;B<=l;){const a=(B+l)/2|0,g=q(a);if(g<0)B=a+1;else if(g>0)l=a-1;else return a}return-(B+1)}function b(oe,q,B){if(oe=oe|0,oe>=q.length)throw new TypeError("invalid index");const l=q[Math.floor(q.length*Math.random())],a=[],g=[],C=[];for(const F of q){const u=B(F,l);u<0?a.push(F):u>0?g.push(F):C.push(F)}return oe<a.length?b(oe,a,B):oe<a.length+C.length?C[0]:b(oe-(a.length+C.length),g,B)}function y(oe,q){const B=[];let l;for(const a of oe.slice(0).sort(q))!l||q(l[0],a)!==0?(l=[a],B.push(l)):l.push(a);return B}function*p(oe,q){let B,l;for(const a of oe)l!==void 0&&q(l,a)?B.push(a):(B&&(yield B),B=[a]),l=a;B&&(yield B)}function m(oe,q){for(let B=0;B<=oe.length;B++)q(B===0?void 0:oe[B-1],B===oe.length?void 0:oe[B])}function e(oe,q){for(let B=0;B<oe.length;B++)q(B===0?void 0:oe[B-1],oe[B],B+1===oe.length?void 0:oe[B+1])}function s(oe,q,B){const l=[];function a(F,u,I){if(u===0&&I.length===0)return;const A=l[l.length-1];A&&A.start+A.deleteCount===F?(A.deleteCount+=u,A.toInsert.push(...I)):l.push({start:F,deleteCount:u,toInsert:I})}let g=0,C=0;for(;;){if(g===oe.length){a(g,0,q.slice(C));break}if(C===q.length){a(g,oe.length-g,[]);break}const F=oe[g],u=q[C],I=B(F,u);I===0?(g+=1,C+=1):I<0?(a(g,1,[]),g+=1):I>0&&(a(g,0,[u]),C+=1)}return l}function o(oe,q,B){const l=s(oe,q,B),a=[],g=[];for(const C of l)a.push(...oe.slice(C.start,C.start+C.deleteCount)),g.push(...C.toInsert);return{removed:a,added:g}}function c(oe,q,B){if(B===0)return[];const l=oe.slice(0,B).sort(q);return v(oe,q,l,B,oe.length),l}function h(oe,q,B,l,a){return B===0?Promise.resolve([]):new Promise((g,C)=>{(async()=>{const F=oe.length,u=oe.slice(0,B).sort(q);for(let I=B,A=Math.min(B+l,F);I<F;I=A,A=Math.min(A+l,F)){if(I>B&&await new Promise(M=>setTimeout(M)),a&&a.isCancellationRequested)throw new i.CancellationError;v(oe,q,u,I,A)}return u})().then(g,C)})}function v(oe,q,B,l,a){for(const g=B.length;l<a;l++){const C=oe[l];if(q(C,B[g-1])<0){B.pop();const F=(0,n.findFirstIdxMonotonousOrArrLen)(B,u=>q(C,u)<0);B.splice(F,0,C)}}}function L(oe){return oe.filter(q=>!!q)}function S(oe){let q=0;for(let B=0;B<oe.length;B++)oe[B]&&(oe[q]=oe[B],q+=1);oe.length=q}function r(oe,q,B){oe.splice(B,0,oe.splice(q,1)[0])}function f(oe){return!Array.isArray(oe)||oe.length===0}function E(oe){return Array.isArray(oe)&&oe.length>0}function T(oe,q=B=>B){const B=new Set;return oe.filter(l=>{const a=q(l);return B.has(a)?!1:(B.add(a),!0)})}function H(oe){const q=new Set;return B=>{const l=oe(B);return q.has(l)?!1:(q.add(l),!0)}}function W(oe,q){return oe.length>0?oe[0]:q}function U(oe,q){return oe.length>0?oe[oe.length-1]:q}function D(oe,q,B=(l,a)=>l===a){let l=0;for(let a=0,g=Math.min(oe.length,q.length);a<g&&B(oe[a],q[a]);a++)l++;return l}function x(oe,q){let B=typeof q=="number"?oe:0;typeof q=="number"?B=oe:(B=0,q=oe);const l=[];if(B<=q)for(let a=B;a<q;a++)l.push(a);else for(let a=B;a>q;a--)l.push(a);return l}function z(oe,q,B){return oe.reduce((l,a)=>(l[q(a)]=B?B(a):a,l),Object.create(null))}function O(oe,q){return oe.push(q),()=>P(oe,q)}function P(oe,q){const B=oe.indexOf(q);if(B>-1)return oe.splice(B,1),q}function K(oe,q,B){const l=oe.slice(0,q),a=oe.slice(q);return l.concat(B,a)}function Q(oe,q){let B;if(typeof q=="number"){let l=q;B=()=>{const a=Math.sin(l++)*179426549;return a-Math.floor(a)}}else B=Math.random;for(let l=oe.length-1;l>0;l-=1){const a=Math.floor(B()*(l+1)),g=oe[l];oe[l]=oe[a],oe[a]=g}}function X(oe,q){const B=oe.indexOf(q);B>-1&&(oe.splice(B,1),oe.unshift(q))}function G(oe,q){const B=oe.indexOf(q);B>-1&&(oe.splice(B,1),oe.push(q))}function J(oe,q){for(const B of q)oe.push(B)}function ce(oe,q){return Array.isArray(oe)?oe.map(q):q(oe)}function pe(oe){return Array.isArray(oe)?oe:[oe]}function Te(oe){return oe[Math.floor(Math.random()*oe.length)]}function Fe(oe,q,B){const l=ee(oe,q),a=oe.length,g=B.length;oe.length=a+g;for(let C=a-1;C>=l;C--)oe[C+g]=oe[C];for(let C=0;C<g;C++)oe[C+l]=B[C]}function re(oe,q,B,l){const a=ee(oe,q);let g=oe.splice(a,B);return g===void 0&&(g=[]),Fe(oe,a,l),g}function ee(oe,q){return q<0?Math.max(q+oe.length,0):Math.min(q,oe.length)}var he;(function(oe){function q(g){return g<0}oe.isLessThan=q;function B(g){return g<=0}oe.isLessThanOrEqual=B;function l(g){return g>0}oe.isGreaterThan=l;function a(g){return g===0}oe.isNeitherLessOrGreaterThan=a,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function le(oe,q){return(B,l)=>q(oe(B),oe(l))}function Ne(...oe){return(q,B)=>{for(const l of oe){const a=l(q,B);if(!he.isNeitherLessOrGreaterThan(a))return a}return he.neitherLessOrGreaterThan}}const te=(oe,q)=>oe-q;t.numberComparator=te;const be=(oe,q)=>(0,t.numberComparator)(oe?1:0,q?1:0);t.booleanComparator=be;function Se(oe){return(q,B)=>-oe(q,B)}class Oe{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let B=this.firstIdx;for(;B<this.items.length&&q(this.items[B]);)B++;const l=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,l}takeFromEndWhile(q){let B=this.lastIdx;for(;B>=0&&q(this.items[B]);)B--;const l=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,l}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}removeLast(){const q=this.items[this.lastIdx];return this.lastIdx--,q}takeCount(q){const B=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,B}}t.ArrayQueue=Oe;class Re{static{this.empty=new Re(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(B=>(q(B),!0))}toArray(){const q=[];return this.iterate(B=>(q.push(B),!0)),q}filter(q){return new Re(B=>this.iterate(l=>q(l)?B(l):!0))}map(q){return new Re(B=>this.iterate(l=>B(q(l))))}some(q){let B=!1;return this.iterate(l=>(B=q(l),!B)),B}findFirst(q){let B;return this.iterate(l=>q(l)?(B=l,!1):!0),B}findLast(q){let B;return this.iterate(l=>(q(l)&&(B=l),!0)),B}findLastMaxBy(q){let B,l=!0;return this.iterate(a=>((l||he.isGreaterThan(q(a,B)))&&(l=!1,B=a),!0)),B}}t.CallbackIterable=Re;class We{constructor(q){this._indexMap=q}static createSortPermutation(q,B){const l=Array.from(q.keys()).sort((a,g)=>B(q[a],q[g]));return new We(l)}apply(q){return q.map((B,l)=>q[this._indexMap[l]])}inverse(){const q=this._indexMap.slice();for(let B=0;B<this._indexMap.length;B++)q[this._indexMap[B]]=B;return new We(q)}}t.Permutation=We}),define(De[43],we([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.assertNever=k,t.assert=R,t.softAssert=N,t.assertFn=w,t.checkAdjacentItems=_;function n(d,b){if(!d)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function k(d,b="Unreachable"){throw new Error(b)}function R(d,b="unexpected state"){if(!d)throw new i.BugIndicatingError(`Assertion Failed: ${b}`)}function N(d){d||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function w(d){if(!d()){debugger;d(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function _(d,b){let y=0;for(;y<d.length-1;){const p=d[y],m=d[y+1];if(!b(p,m))return!1;y++}return!0}});var Fi=this&&this.__createBinding||(Object.create?function(ne,t,i,n){n===void 0&&(n=i);var k=Object.getOwnPropertyDescriptor(t,i);(!k||("get"in k?!t.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(ne,n,k)}:function(ne,t,i,n){n===void 0&&(n=i),ne[n]=t[i]}),Ri=this&&this.__setModuleDefault||(Object.create?function(ne,t){Object.defineProperty(ne,"default",{enumerable:!0,value:t})}:function(ne,t){ne.default=t}),Ue=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var t={};if(ne!=null)for(var i in ne)i!=="default"&&Object.prototype.hasOwnProperty.call(ne,i)&&Fi(t,ne,i);return Ri(t,ne),t};define(De[31],we([1,0,9]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.strictEquals=void 0,t.itemsEquals=k,t.jsonStringifyEquals=R,t.itemEquals=N,t.equalsIfDefined=w,t.structuralEquals=_,t.getStructuralKey=d,i=Ue(i);const n=(m,e)=>m===e;t.strictEquals=n;function k(m=t.strictEquals){return(e,s)=>i.equals(e,s,m)}function R(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function N(){return(m,e)=>m.equals(e)}function w(m,e,s){if(s!==void 0){const o=m;return o==null||e===void 0||e===null?e===o:s(o,e)}else{const o=m;return(c,h)=>c==null||h===void 0||h===null?h===c:o(c,h)}}function _(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!_(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,o=e,c=Object.keys(s),h=Object.keys(o),v=new Set(h);if(c.length!==h.length)return!1;for(const L of c)if(!v.has(L)||!_(s[L],o[L]))return!1;return!0}return!1}function d(m){return JSON.stringify(p(m))}let b=0;const y=new WeakMap;function p(m){if(Array.isArray(m))return m.map(p);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=p(e[o]);return s}else{let e=y.get(m);return e===void 0&&(e=b++,y.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(De[59],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(n,k){const R=this;let N=!1,w;return function(){if(N)return w;if(N=!0,k)try{w=n.apply(R,arguments)}finally{k()}else w=n.apply(R,arguments);return w}}}),define(De[91],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")}),define(De[37],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}n.is=k;const R=Object.freeze([]);function N(){return R}n.empty=N;function*w(f){yield f}n.single=w;function _(f){return k(f)?f:w(f)}n.wrap=_;function d(f){return f||R}n.from=d;function*b(f){for(let E=f.length-1;E>=0;E--)yield f[E]}n.reverse=b;function y(f){return!f||f[Symbol.iterator]().next().done===!0}n.isEmpty=y;function p(f){return f[Symbol.iterator]().next().value}n.first=p;function m(f,E){let T=0;for(const H of f)if(E(H,T++))return!0;return!1}n.some=m;function e(f,E){for(const T of f)if(E(T))return T}n.find=e;function*s(f,E){for(const T of f)E(T)&&(yield T)}n.filter=s;function*o(f,E){let T=0;for(const H of f)yield E(H,T++)}n.map=o;function*c(f,E){let T=0;for(const H of f)yield*E(H,T++)}n.flatMap=c;function*h(...f){for(const E of f)yield*E}n.concat=h;function v(f,E,T){let H=T;for(const W of f)H=E(H,W);return H}n.reduce=v;function*L(f,E,T=f.length){for(E<0&&(E+=f.length),T<0?T+=f.length:T>f.length&&(T=f.length);E<T;E++)yield f[E]}n.slice=L;function S(f,E=Number.POSITIVE_INFINITY){const T=[];if(E===0)return[T,f];const H=f[Symbol.iterator]();for(let W=0;W<E;W++){const U=H.next();if(U.done)return[T,n.empty()];T.push(U.value)}return[T,{[Symbol.iterator](){return H}}]}n.consume=S;async function r(f){const E=[];for await(const T of f)E.push(T);return Promise.resolve(E)}n.asyncToArray=r})(i||(t.Iterable=i={}))}),define(De[8],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const R=new k,N=new k,w=new k;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const _=[],d=Object.create(null),b=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>b[e]||n.None,toEnum:e=>d[e]||n.None,toString:e=>_[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],o=[],c=[];for(const h of s){const[v,L,S,r,f,E,T,H,W]=h;if(c[L]||(c[L]=!0,_[L]=S,d[S]=L,b[S.toLowerCase()]=L,v&&(t.IMMUTABLE_CODE_TO_KEY_CODE[L]=r,r!==i.Unknown&&r!==i.Enter&&r!==i.Ctrl&&r!==i.Shift&&r!==i.Alt&&r!==i.Meta&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=L))),!o[r]){if(o[r]=!0,!f)throw new Error(`String representation missing for key code ${r} around scan code ${S}`);R.define(r,f),N.define(r,H||f),w.define(r,W||H||f)}E&&(t.EVENT_KEY_CODE_MAP[E]=r),T&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[T]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[i.Enter]=n.Enter})();var y;(function(e){function s(S){return R.keyCodeToStr(S)}e.toString=s;function o(S){return R.strToKeyCode(S)}e.fromString=o;function c(S){return N.keyCodeToStr(S)}e.toUserSettingsUS=c;function h(S){return w.keyCodeToStr(S)}e.toUserSettingsGeneral=h;function v(S){return N.strToKeyCode(S)||w.strToKeyCode(S)}e.fromUserSettings=v;function L(S){if(S>=i.Numpad0&&S<=i.NumpadDivide)return null;switch(S){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return R.keyCodeToStr(S)}e.toElectronAccelerator=L})(y||(t.KeyCodeUtils=y={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p||(t.KeyMod=p={}));function m(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(De[26],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(k){this.executor=k,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),define(De[15],we([1,0,26]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=w,t.getDefaultHoverDelegate=_,t.createInstantHoverDelegate=d;let k=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const R=new i.Lazy(()=>k("mouse",!1)),N=new i.Lazy(()=>k("element",!1));function w(b){k=b}function _(b){return b==="element"?N.value:R.value}function d(){return k("element",!0)}}),define(De[60],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(R){this.element=R,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let R=this._first;for(;R!==i.Undefined;){const N=R.next;R.prev=i.Undefined,R.next=i.Undefined,R=N}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,N){const w=new i(R);if(this._first===i.Undefined)this._first=w,this._last=w;else if(N){const d=this._last;this._last=w,w.prev=d,d.next=w}else{const d=this._first;this._first=w,w.next=d,d.prev=w}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(w))}}shift(){if(this._first!==i.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==i.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==i.Undefined&&R.next!==i.Undefined){const N=R.prev;N.next=R.next,R.next.prev=N}else R.prev===i.Undefined&&R.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):R.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):R.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==i.Undefined;)yield R.element,R=R.next}}t.LinkedList=n}),define(De[44],we([1,0]),function(ne,t){"use strict";var i,n,k;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=R,t.mapToString=N,t.setToString=w,t.mapsStrictEqualIgnoreOrder=L;function R(S,r,f){let E=S.get(r);return E===void 0&&(E=f,S.set(r,E)),E}function N(S){const r=[];return S.forEach((f,E)=>{r.push(`${E} => ${f}`)}),`Map(${S.size}) {${r.join(", ")}}`}function w(S){const r=[];return S.forEach(f=>{r.push(f)}),`Set(${S.size}) {${r.join(", ")}}`}class _{constructor(r,f){this.uri=r,this.value=f}}function d(S){return Array.isArray(S)}class b{static{this.defaultToKey=r=>r.toString()}constructor(r,f){if(this[i]="ResourceMap",r instanceof b)this.map=new Map(r.map),this.toKey=f??b.defaultToKey;else if(d(r)){this.map=new Map,this.toKey=f??b.defaultToKey;for(const[E,T]of r)this.set(E,T)}else this.map=new Map,this.toKey=r??b.defaultToKey}set(r,f){return this.map.set(this.toKey(r),new _(r,f)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,f){typeof f<"u"&&(r=r.bind(f));for(const[E,T]of this.map)r(T.value,T.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=b;class y{constructor(r,f){this[n]="ResourceSet",!r||typeof r=="function"?this._map=new b(r):(this._map=new b(f),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,f){this._map.forEach((E,T)=>r.call(f,T,T,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=y;var p;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(p||(t.Touch=p={}));class m{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,f=p.None){const E=this._map.get(r);if(E)return f!==p.None&&this.touch(E,f),E.value}set(r,f,E=p.None){let T=this._map.get(r);if(T)T.value=f,E!==p.None&&this.touch(T,E);else{switch(T={key:r,value:f,next:void 0,previous:void 0},E){case p.None:this.addItemLast(T);break;case p.AsOld:this.addItemFirst(T);break;case p.AsNew:this.addItemLast(T);break;default:this.addItemLast(T);break}this._map.set(r,T),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const f=this._map.get(r);if(f)return this._map.delete(r),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,f){const E=this._state;let T=this._head;for(;T;){if(f?r.bind(f)(T.value,T.key,this):r(T.value,T.key,this),this._state!==E)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const r=this,f=this._state;let E=this._head;const T={[Symbol.iterator](){return T},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:E.key,done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return T}values(){const r=this,f=this._state;let E=this._head;const T={[Symbol.iterator](){return T},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:E.value,done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return T}entries(){const r=this,f=this._state;let E=this._head;const T={[Symbol.iterator](){return T},next(){if(r._state!==f)throw new Error("LinkedMap got modified during iteration.");if(E){const H={value:[E.key,E.value],done:!1};return E=E.next,H}else return{value:void 0,done:!0}}};return T}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this._head,E=this.size;for(;f&&E>r;)this._map.delete(f.key),f=f.next,E--;this._head=f,this._size=E,f&&(f.previous=void 0),this._state++}trimNew(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this._tail,E=this.size;for(;f&&E>r;)this._map.delete(f.key),f=f.previous,E--;this._tail=f,this._size=E,f&&(f.next=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const f=r.next,E=r.previous;if(!f||!E)throw new Error("Invalid list");f.previous=E,E.next=f}r.next=void 0,r.previous=void 0,this._state++}touch(r,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==p.AsOld&&f!==p.AsNew)){if(f===p.AsOld){if(r===this._head)return;const E=r.next,T=r.previous;r===this._tail?(T.next=void 0,this._tail=T):(E.previous=T,T.next=E),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(f===p.AsNew){if(r===this._tail)return;const E=r.next,T=r.previous;r===this._head?(E.previous=void 0,this._head=E):(E.previous=T,T.next=E),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((f,E)=>{r.push([E,f])}),r}fromJSON(r){this.clear();for(const[f,E]of r)this.set(f,E)}}t.LinkedMap=m;class e extends m{constructor(r,f=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,f=p.AsNew){return super.get(r,f)}peek(r){return super.get(r,p.None)}set(r,f){return super.set(r,f,p.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class s extends e{constructor(r,f=1){super(r,f)}trim(r){this.trimOld(r)}set(r,f){return super.set(r,f),this.checkTrim(),this}}t.LRUCache=s;class o extends e{constructor(r,f=1){super(r,f)}trim(r){this.trimNew(r)}set(r,f){return this._limit<=this.size&&!this.has(r)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(r,f),this}}t.MRUCache=o;class c{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let f=this.map.get(r)||0;return f===0?!1:(f--,f===0?this.map.delete(r):this.map.set(r,f),!0)}has(r){return this.map.has(r)}}t.CounterSet=c;class h{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[f,E]of r)this.set(f,E)}clear(){this._m1.clear(),this._m2.clear()}set(r,f){this._m1.set(r,f),this._m2.set(f,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const f=this._m1.get(r);return f===void 0?!1:(this._m1.delete(r),this._m2.delete(f),!0)}forEach(r,f){this._m1.forEach((E,T)=>{r.call(f,E,T,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=h;class v{constructor(){this.map=new Map}add(r,f){let E=this.map.get(r);E||(E=new Set,this.map.set(r,E)),E.add(f)}delete(r,f){const E=this.map.get(r);E&&(E.delete(f),E.size===0&&this.map.delete(r))}forEach(r,f){const E=this.map.get(r);E&&E.forEach(f)}get(r){const f=this.map.get(r);return f||new Set}}t.SetMap=v;function L(S,r){if(S===r)return!0;if(S.size!==r.size)return!1;for(const[f,E]of S)if(!r.has(f)||r.get(f)!==E)return!1;for(const[f]of r)if(!S.has(f))return!1;return!0}}),define(De[2],we([1,0,9,58,44,59,37]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=b,t.trackDisposable=y,t.markAsDisposed=p,t.markAsSingleton=s,t.isDisposable=o,t.dispose=c,t.disposeIfDisposable=h,t.combinedDisposable=v,t.toDisposable=L,t.disposeOnReturn=x;const w=!1;let _=null;class d{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(P){let K=this.livingDisposables.get(P);return K||(K={parent:null,source:null,isSingleton:!1,value:P,idx:d.idx++},this.livingDisposables.set(P,K)),K}trackDisposable(P){const K=this.getDisposableData(P);K.source||(K.source=new Error().stack)}setParent(P,K){const Q=this.getDisposableData(P);Q.parent=K}markAsDisposed(P){this.livingDisposables.delete(P)}markAsSingleton(P){this.getDisposableData(P).isSingleton=!0}getRootParent(P,K){const Q=K.get(P);if(Q)return Q;const X=P.parent?this.getRootParent(this.getDisposableData(P.parent),K):P;return K.set(P,X),X}getTrackedDisposables(){const P=new Map;return[...this.livingDisposables.entries()].filter(([,Q])=>Q.source!==null&&!this.getRootParent(Q,P).isSingleton).flatMap(([Q])=>Q)}computeLeakingDisposables(P=10,K){let Q;if(K)Q=K;else{const pe=new Map,Te=[...this.livingDisposables.values()].filter(re=>re.source!==null&&!this.getRootParent(re,pe).isSingleton);if(Te.length===0)return;const Fe=new Set(Te.map(re=>re.value));if(Q=Te.filter(re=>!(re.parent&&Fe.has(re.parent))),Q.length===0)throw new Error("There are cyclic diposable chains!")}if(!Q)return;function X(pe){function Te(re,ee){for(;re.length>0&&ee.some(he=>typeof he=="string"?he===re[0]:re[0].match(he));)re.shift()}const Fe=pe.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Te(Fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Fe.reverse()}const G=new k.SetMap;for(const pe of Q){const Te=X(pe);for(let Fe=0;Fe<=Te.length;Fe++)G.add(Te.slice(0,Fe).join(`
`),pe)}Q.sort((0,i.compareBy)(pe=>pe.idx,i.numberComparator));let J="",ce=0;for(const pe of Q.slice(0,P)){ce++;const Te=X(pe),Fe=[];for(let re=0;re<Te.length;re++){let ee=Te[re];ee=`(shared with ${G.get(Te.slice(0,re+1).join(`
`)).size}/${Q.length} leaks) at ${ee}`;const le=G.get(Te.slice(0,re).join(`
`)),Ne=(0,n.groupBy)([...le].map(te=>X(te)[re]),te=>te);delete Ne[Te[re]];for(const[te,be]of Object.entries(Ne))Fe.unshift(`    - stacktraces of ${be.length} other leaks continue with ${te}`);Fe.unshift(ee)}J+=`


==================== Leaking disposable ${ce}/${Q.length}: ${pe.value.constructor.name} ====================
${Fe.join(`
`)}
============================================================

`}return Q.length>P&&(J+=`


... and ${Q.length-P} more leaking disposables

`),{leaks:Q,details:J}}}t.DisposableTracker=d;function b(O){_=O}if(w){const O="__is_disposable_tracked__";b(new class{trackDisposable(P){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[O]||console.log(K)},3e3)}setParent(P,K){if(P&&P!==r.None)try{P[O]=!0}catch{}}markAsDisposed(P){if(P&&P!==r.None)try{P[O]=!0}catch{}}markAsSingleton(P){}})}function y(O){return _?.trackDisposable(O),O}function p(O){_?.markAsDisposed(O)}function m(O,P){_?.setParent(O,P)}function e(O,P){if(_)for(const K of O)_.setParent(K,P)}function s(O){return _?.markAsSingleton(O),O}function o(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function c(O){if(N.Iterable.is(O)){const P=[];for(const K of O)if(K)try{K.dispose()}catch(Q){P.push(Q)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function h(O){for(const P of O)o(P)&&P.dispose();return[]}function v(...O){const P=L(()=>c(O));return e(O,P),P}function L(O){const P=y({dispose:(0,R.createSingleCallFunction)(()=>{p(P),O()})});return P}class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{c(this._toDispose)}finally{this._toDispose.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return m(P,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(P),P.dispose()}}deleteAndLeak(P){P&&this._toDispose.has(P)&&(this._toDispose.delete(P),m(P,null))}}t.DisposableStore=S;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new S,y(this),m(this._store,this)}dispose(){p(this),this._store.dispose()}_register(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(P)}}t.Disposable=r;class f{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(P){this._isDisposed||P===this._value||(this._value?.dispose(),P&&m(P,this),this._value=P)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const P=this._value;return this._value=void 0,P&&m(P,null),P}}t.MutableDisposable=f;class E{constructor(P){this._disposable=new f,this._isDisposed=!1,this._disposable.value=P}get value(){return this._disposable.value}set value(P){this._isDisposed||P===this._disposable.value||(this._disposable.value=P)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=E;class T{constructor(P){this._disposable=P,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=T;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let K=P;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,p(this))},this}}t.SafeDisposable=H;class W{constructor(){this.references=new Map}acquire(P,...K){let Q=this.references.get(P);Q||(Q={counter:0,object:this.createReferencedObject(P,...K)},this.references.set(P,Q));const{object:X}=Q,G=(0,R.createSingleCallFunction)(()=>{--Q.counter===0&&(this.destroyReferencedObject(P,Q.object),this.references.delete(P))});return Q.counter++,{object:X,dispose:G}}}t.ReferenceCollection=W;class U{constructor(P){this.referenceCollection=P}async acquire(P,...K){const Q=this.referenceCollection.acquire(P,...K);try{return{object:await Q.object,dispose:()=>Q.dispose()}}catch(X){throw Q.dispose(),X}}}t.AsyncReferenceCollection=U;class D{constructor(P){this.object=P}dispose(){}}t.ImmortalReference=D;function x(O){const P=new S;try{O(P)}finally{P.dispose()}}class z{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){p(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{c(this._store.values())}finally{this._store.clear()}}has(P){return this._store.has(P)}get size(){return this._store.size}get(P){return this._store.get(P)}set(P,K,Q=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Q||this._store.get(P)?.dispose(),this._store.set(P,K)}deleteAndDispose(P){this._store.get(P)?.dispose(),this._store.delete(P)}deleteAndLeak(P){const K=this._store.get(P);return this._store.delete(P),K}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=z}),function(ne,t){typeof define=="function"&&define.amd?define(De[92],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(q,B){for(var l=0;l<B.length;l++){var a=B[l];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(q,a.key,a)}}function i(q,B,l){return B&&t(q.prototype,B),l&&t(q,l),Object.defineProperty(q,"prototype",{writable:!1}),q}function n(q,B){if(q){if(typeof q=="string")return k(q,B);var l=Object.prototype.toString.call(q).slice(8,-1);if(l==="Object"&&q.constructor&&(l=q.constructor.name),l==="Map"||l==="Set")return Array.from(q);if(l==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(l))return k(q,B)}}function k(q,B){(B==null||B>q.length)&&(B=q.length);for(var l=0,a=new Array(B);l<B;l++)a[l]=q[l];return a}function R(q,B){var l=typeof Symbol<"u"&&q[Symbol.iterator]||q["@@iterator"];if(l)return(l=l.call(q)).next.bind(l);if(Array.isArray(q)||(l=n(q))||B&&q&&typeof q.length=="number"){l&&(q=l);var a=0;return function(){return a>=q.length?{done:!0}:{done:!1,value:q[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=N();function w(q){ne.defaults=q}var _=/[&<>"']/,d=/[&<>"']/g,b=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(B){return p[B]};function e(q,B){if(B){if(_.test(q))return q.replace(d,m)}else if(b.test(q))return q.replace(y,m);return q}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(q){return q.replace(s,function(B,l){return l=l.toLowerCase(),l==="colon"?":":l.charAt(0)==="#"?l.charAt(1)==="x"?String.fromCharCode(parseInt(l.substring(2),16)):String.fromCharCode(+l.substring(1)):""})}var c=/(^|[^\[])\^/g;function h(q,B){q=typeof q=="string"?q:q.source,B=B||"";var l={replace:function(g,C){return C=C.source||C,C=C.replace(c,"$1"),q=q.replace(g,C),l},getRegex:function(){return new RegExp(q,B)}};return l}var v=/[^\w:]/g,L=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(q,B,l){if(q){var a;try{a=decodeURIComponent(o(l)).replace(v,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}B&&!L.test(l)&&(l=H(B,l));try{l=encodeURI(l).replace(/%25/g,"%")}catch{return null}return l}var r={},f=/^[^:]+:\/*[^/]*$/,E=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function H(q,B){r[" "+q]||(f.test(q)?r[" "+q]=q+"/":r[" "+q]=x(q,"/",!0)),q=r[" "+q];var l=q.indexOf(":")===-1;return B.substring(0,2)==="//"?l?B:q.replace(E,"$1")+B:B.charAt(0)==="/"?l?B:q.replace(T,"$1")+B:q+B}var W={exec:function(){}};function U(q){for(var B=1,l,a;B<arguments.length;B++){l=arguments[B];for(a in l)Object.prototype.hasOwnProperty.call(l,a)&&(q[a]=l[a])}return q}function D(q,B){var l=q.replace(/\|/g,function(C,F,u){for(var I=!1,A=F;--A>=0&&u[A]==="\\";)I=!I;return I?"|":" |"}),a=l.split(/ \|/),g=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>B)a.splice(B);else for(;a.length<B;)a.push("");for(;g<a.length;g++)a[g]=a[g].trim().replace(/\\\|/g,"|");return a}function x(q,B,l){var a=q.length;if(a===0)return"";for(var g=0;g<a;){var C=q.charAt(a-g-1);if(C===B&&!l)g++;else if(C!==B&&l)g++;else break}return q.slice(0,a-g)}function z(q,B){if(q.indexOf(B[1])===-1)return-1;for(var l=q.length,a=0,g=0;g<l;g++)if(q[g]==="\\")g++;else if(q[g]===B[0])a++;else if(q[g]===B[1]&&(a--,a<0))return g;return-1}function O(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(q,B){if(B<1)return"";for(var l="";B>1;)B&1&&(l+=q),B>>=1,q+=q;return l+q}function K(q,B,l,a){var g=B.href,C=B.title?e(B.title):null,F=q[1].replace(/\\([\[\]])/g,"$1");if(q[0].charAt(0)!=="!"){a.state.inLink=!0;var u={type:"link",raw:l,href:g,title:C,text:F,tokens:a.inlineTokens(F)};return a.state.inLink=!1,u}return{type:"image",raw:l,href:g,title:C,text:e(F)}}function Q(q,B){var l=q.match(/^(\s+)(?:```)/);if(l===null)return B;var a=l[1];return B.split(`
`).map(function(g){var C=g.match(/^\s+/);if(C===null)return g;var F=C[0];return F.length>=a.length?g.slice(a.length):g}).join(`
`)}var X=function(){function q(l){this.options=l||ne.defaults}var B=q.prototype;return B.space=function(a){var g=this.rules.block.newline.exec(a);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},B.code=function(a){var g=this.rules.block.code.exec(a);if(g){var C=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?C:x(C,`
`)}}},B.fences=function(a){var g=this.rules.block.fences.exec(a);if(g){var C=g[0],F=Q(C,g[3]||"");return{type:"code",raw:C,lang:g[2]?g[2].trim():g[2],text:F}}},B.heading=function(a){var g=this.rules.block.heading.exec(a);if(g){var C=g[2].trim();if(/#$/.test(C)){var F=x(C,"#");(this.options.pedantic||!F||/ $/.test(F))&&(C=F.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:C,tokens:this.lexer.inline(C)}}},B.hr=function(a){var g=this.rules.block.hr.exec(a);if(g)return{type:"hr",raw:g[0]}},B.blockquote=function(a){var g=this.rules.block.blockquote.exec(a);if(g){var C=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},B.list=function(a){var g=this.rules.block.list.exec(a);if(g){var C,F,u,I,A,M,V,Y,ie,ae,fe,_e,Ee=g[1].trim(),Le=Ee.length>1,Ie={type:"list",raw:"",ordered:Le,start:Le?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Le?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Le?Ee:"[*+-]");for(var de=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(_e=!1,!(!(g=de.exec(a))||this.rules.block.hr.test(a)));){if(C=g[0],a=a.substring(C.length),Y=g[2].split(`
`,1)[0],ie=a.split(`
`,1)[0],this.options.pedantic?(I=2,fe=Y.trimLeft()):(I=g[2].search(/[^ ]/),I=I>4?1:I,fe=Y.slice(I),I+=g[1].length),M=!1,!Y&&/^ *$/.test(ie)&&(C+=ie+`
`,a=a.substring(ie.length+1),_e=!0),!_e)for(var Ce=new RegExp("^ {0,"+Math.min(3,I-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),qe=new RegExp("^ {0,"+Math.min(3,I-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,I-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,I-1)+"}#");a&&(ae=a.split(`
`,1)[0],Y=ae,this.options.pedantic&&(Y=Y.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(Y)||tt.test(Y)||Ce.test(Y)||qe.test(a)));){if(Y.search(/[^ ]/)>=I||!Y.trim())fe+=`
`+Y.slice(I);else if(!M)fe+=`
`+Y;else break;!M&&!Y.trim()&&(M=!0),C+=ae+`
`,a=a.substring(ae.length+1)}Ie.loose||(V?Ie.loose=!0:/\n *\n *$/.test(C)&&(V=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(fe),F&&(u=F[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:C,task:!!F,checked:u,loose:!1,text:fe}),Ie.raw+=C}Ie.items[Ie.items.length-1].raw=C.trimRight(),Ie.items[Ie.items.length-1].text=fe.trimRight(),Ie.raw=Ie.raw.trimRight();var lt=Ie.items.length;for(A=0;A<lt;A++){this.lexer.state.top=!1,Ie.items[A].tokens=this.lexer.blockTokens(Ie.items[A].text,[]);var rt=Ie.items[A].tokens.filter(function(Ze){return Ze.type==="space"}),je=rt.every(function(Ze){for(var Z=Ze.raw.split(""),ue=0,ve=R(Z),Ae;!(Ae=ve()).done;){var Pe=Ae.value;if(Pe===`
`&&(ue+=1),ue>1)return!0}return!1});!Ie.loose&&rt.length&&je&&(Ie.loose=!0,Ie.items[A].loose=!0)}return Ie}},B.html=function(a){var g=this.rules.block.html.exec(a);if(g){var C={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);C.type="paragraph",C.text=F,C.tokens=this.lexer.inline(F)}return C}},B.def=function(a){var g=this.rules.block.def.exec(a);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var C=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:g[0],href:g[2],title:g[3]}}},B.table=function(a){var g=this.rules.block.table.exec(a);if(g){var C={type:"table",header:D(g[1]).map(function(V){return{text:V}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=g[0];var F=C.align.length,u,I,A,M;for(u=0;u<F;u++)/^ *-+: *$/.test(C.align[u])?C.align[u]="right":/^ *:-+: *$/.test(C.align[u])?C.align[u]="center":/^ *:-+ *$/.test(C.align[u])?C.align[u]="left":C.align[u]=null;for(F=C.rows.length,u=0;u<F;u++)C.rows[u]=D(C.rows[u],C.header.length).map(function(V){return{text:V}});for(F=C.header.length,I=0;I<F;I++)C.header[I].tokens=this.lexer.inline(C.header[I].text);for(F=C.rows.length,I=0;I<F;I++)for(M=C.rows[I],A=0;A<M.length;A++)M[A].tokens=this.lexer.inline(M[A].text);return C}}},B.lheading=function(a){var g=this.rules.block.lheading.exec(a);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},B.paragraph=function(a){var g=this.rules.block.paragraph.exec(a);if(g){var C=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:C,tokens:this.lexer.inline(C)}}},B.text=function(a){var g=this.rules.block.text.exec(a);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},B.escape=function(a){var g=this.rules.inline.escape.exec(a);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},B.tag=function(a){var g=this.rules.inline.tag.exec(a);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},B.link=function(a){var g=this.rules.inline.link.exec(a);if(g){var C=g[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var F=x(C.slice(0,-1),"\\");if((C.length-F.length)%2===0)return}else{var u=z(g[2],"()");if(u>-1){var I=g[0].indexOf("!")===0?5:4,A=I+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,A).trim(),g[3]=""}}var M=g[2],V="";if(this.options.pedantic){var Y=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(M);Y&&(M=Y[1],V=Y[3])}else V=g[3]?g[3].slice(1,-1):"";return M=M.trim(),/^</.test(M)&&(this.options.pedantic&&!/>$/.test(C)?M=M.slice(1):M=M.slice(1,-1)),K(g,{href:M&&M.replace(this.rules.inline._escapes,"$1"),title:V&&V.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},B.reflink=function(a,g){var C;if((C=this.rules.inline.reflink.exec(a))||(C=this.rules.inline.nolink.exec(a))){var F=(C[2]||C[1]).replace(/\s+/g," ");if(F=g[F.toLowerCase()],!F||!F.href){var u=C[0].charAt(0);return{type:"text",raw:u,text:u}}return K(C,F,C[0],this.lexer)}},B.emStrong=function(a,g,C){C===void 0&&(C="");var F=this.rules.inline.emStrong.lDelim.exec(a);if(F&&!(F[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=F[1]||F[2]||"";if(!u||u&&(C===""||this.rules.inline.punctuation.exec(C))){var I=F[0].length-1,A,M,V=I,Y=0,ie=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,g=g.slice(-1*a.length+I);(F=ie.exec(g))!=null;)if(A=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!A){if(M=A.length,F[3]||F[4]){V+=M;continue}else if((F[5]||F[6])&&I%3&&!((I+M)%3)){Y+=M;continue}if(V-=M,!(V>0)){if(M=Math.min(M,M+V+Y),Math.min(I,M)%2){var ae=a.slice(1,I+F.index+M);return{type:"em",raw:a.slice(0,I+F.index+M+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var fe=a.slice(2,I+F.index+M-1);return{type:"strong",raw:a.slice(0,I+F.index+M+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},B.codespan=function(a){var g=this.rules.inline.code.exec(a);if(g){var C=g[2].replace(/\n/g," "),F=/[^ ]/.test(C),u=/^ /.test(C)&&/ $/.test(C);return F&&u&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:g[0],text:C}}},B.br=function(a){var g=this.rules.inline.br.exec(a);if(g)return{type:"br",raw:g[0]}},B.del=function(a){var g=this.rules.inline.del.exec(a);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},B.autolink=function(a,g){var C=this.rules.inline.autolink.exec(a);if(C){var F,u;return C[2]==="@"?(F=e(this.options.mangle?g(C[1]):C[1]),u="mailto:"+F):(F=e(C[1]),u=F),{type:"link",raw:C[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},B.url=function(a,g){var C;if(C=this.rules.inline.url.exec(a)){var F,u;if(C[2]==="@")F=e(this.options.mangle?g(C[0]):C[0]),u="mailto:"+F;else{var I;do I=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(I!==C[0]);F=e(C[0]),C[1]==="www."?u="http://"+F:u=F}return{type:"link",raw:C[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},B.inlineText=function(a,g){var C=this.rules.inline.text.exec(a);if(C){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:F=e(this.options.smartypants?g(C[0]):C[0]),{type:"text",raw:C[0],text:F}}},q}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:W,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=U({},G),G.gfm=U({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=U({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:W,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:W,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:W,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=h(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=h(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=h(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=h(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=h(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=h(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=h(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=h(J.reflink).replace("label",J._label).replace("ref",G._label).getRegex(),J.nolink=h(J.nolink).replace("ref",G._label).getRegex(),J.reflinkSearch=h(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=U({},J),J.pedantic=U({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=U({},J.normal,{escape:h(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=h(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=U({},J.gfm,{br:h(J.br).replace("{2,}","*").getRegex(),text:h(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function pe(q){var B="",l,a,g=q.length;for(l=0;l<g;l++)a=q.charCodeAt(l),Math.random()>.5&&(a="x"+a.toString(16)),B+="&#"+a+";";return B}var Te=function(){function q(l){this.tokens=[],this.tokens.links=Object.create(null),this.options=l||ne.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:G.normal,inline:J.normal};this.options.pedantic?(a.block=G.pedantic,a.inline=J.pedantic):this.options.gfm&&(a.block=G.gfm,this.options.breaks?a.inline=J.breaks:a.inline=J.gfm),this.tokenizer.rules=a}q.lex=function(a,g){var C=new q(g);return C.lex(a)},q.lexInline=function(a,g){var C=new q(g);return C.inlineTokens(a)};var B=q.prototype;return B.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},B.blockTokens=function(a,g){var C=this;g===void 0&&(g=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(V,Y,ie){return Y+"    ".repeat(ie.length)});for(var F,u,I,A;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(V){return(F=V.call({lexer:C},a,g))?(a=a.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.space(a)){a=a.substring(F.raw.length),F.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(F);continue}if(F=this.tokenizer.code(a)){a=a.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(F=this.tokenizer.fences(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.heading(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.hr(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.blockquote(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.list(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.html(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.def(a)){a=a.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.lheading(a)){a=a.substring(F.raw.length),g.push(F);continue}if(I=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var V=1/0,Y=a.slice(1),ie=void 0;C.options.extensions.startBlock.forEach(function(ae){ie=ae.call({lexer:this},Y),typeof ie=="number"&&ie>=0&&(V=Math.min(V,ie))}),V<1/0&&V>=0&&(I=a.substring(0,V+1))}(),this.state.top&&(F=this.tokenizer.paragraph(I))){u=g[g.length-1],A&&u.type==="paragraph"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F),A=I.length!==a.length,a=a.substring(F.raw.length);continue}if(F=this.tokenizer.text(a)){a=a.substring(F.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(a){var M="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(M);break}else throw new Error(M)}}return this.state.top=!0,g},B.inline=function(a,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:a,tokens:g}),g},B.inlineTokens=function(a,g){var C=this;g===void 0&&(g=[]);var F,u,I,A=a,M,V,Y;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(M=this.tokenizer.rules.inline.reflinkSearch.exec(A))!=null;)ie.includes(M[0].slice(M[0].lastIndexOf("[")+1,-1))&&(A=A.slice(0,M.index)+"["+P("a",M[0].length-2)+"]"+A.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(M=this.tokenizer.rules.inline.blockSkip.exec(A))!=null;)A=A.slice(0,M.index)+"["+P("a",M[0].length-2)+"]"+A.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(M=this.tokenizer.rules.inline.escapedEmSt.exec(A))!=null;)A=A.slice(0,M.index)+"++"+A.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(V||(Y=""),V=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(F=fe.call({lexer:C},a,g))?(a=a.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.escape(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.tag(a)){a=a.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.link(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.emStrong(a,A,Y)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.codespan(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.br(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.del(a)){a=a.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.autolink(a,pe)){a=a.substring(F.raw.length),g.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(a,pe))){a=a.substring(F.raw.length),g.push(F);continue}if(I=a,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,_e=a.slice(1),Ee=void 0;C.options.extensions.startInline.forEach(function(Le){Ee=Le.call({lexer:this},_e),typeof Ee=="number"&&Ee>=0&&(fe=Math.min(fe,Ee))}),fe<1/0&&fe>=0&&(I=a.substring(0,fe+1))}(),F=this.tokenizer.inlineText(I,ce)){a=a.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Y=F.raw.slice(-1)),V=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(a){var ae="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return g},i(q,null,[{key:"rules",get:function(){return{block:G,inline:J}}}]),q}(),Fe=function(){function q(l){this.options=l||ne.defaults}var B=q.prototype;return B.code=function(a,g,C){var F=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(a,F);u!=null&&u!==a&&(C=!0,a=u)}return a=a.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(C?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(C?a:e(a,!0))+`</code></pre>
`},B.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},B.html=function(a){return a},B.heading=function(a,g,C,F){if(this.options.headerIds){var u=this.options.headerPrefix+F.slug(C);return"<h"+g+' id="'+u+'">'+a+"</h"+g+`>
`}return"<h"+g+">"+a+"</h"+g+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(a,g,C){var F=g?"ol":"ul",u=g&&C!==1?' start="'+C+'"':"";return"<"+F+u+`>
`+a+"</"+F+`>
`},B.listitem=function(a){return"<li>"+a+`</li>
`},B.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(a){return"<p>"+a+`</p>
`},B.table=function(a,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+g+`</table>
`},B.tablerow=function(a){return`<tr>
`+a+`</tr>
`},B.tablecell=function(a,g){var C=g.header?"th":"td",F=g.align?"<"+C+' align="'+g.align+'">':"<"+C+">";return F+a+("</"+C+`>
`)},B.strong=function(a){return"<strong>"+a+"</strong>"},B.em=function(a){return"<em>"+a+"</em>"},B.codespan=function(a){return"<code>"+a+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(a){return"<del>"+a+"</del>"},B.link=function(a,g,C){if(a=S(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var F='<a href="'+e(a)+'"';return g&&(F+=' title="'+g+'"'),F+=">"+C+"</a>",F},B.image=function(a,g,C){if(a=S(this.options.sanitize,this.options.baseUrl,a),a===null)return C;var F='<img src="'+a+'" alt="'+C+'"';return g&&(F+=' title="'+g+'"'),F+=this.options.xhtml?"/>":">",F},B.text=function(a){return a},q}(),re=function(){function q(){}var B=q.prototype;return B.strong=function(a){return a},B.em=function(a){return a},B.codespan=function(a){return a},B.del=function(a){return a},B.html=function(a){return a},B.text=function(a){return a},B.link=function(a,g,C){return""+C},B.image=function(a,g,C){return""+C},B.br=function(){return""},q}(),ee=function(){function q(){this.seen={}}var B=q.prototype;return B.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(a,g){var C=a,F=0;if(this.seen.hasOwnProperty(C)){F=this.seen[a];do F++,C=a+"-"+F;while(this.seen.hasOwnProperty(C))}return g||(this.seen[a]=F,this.seen[C]=0),C},B.slug=function(a,g){g===void 0&&(g={});var C=this.serialize(a);return this.getNextSafeSlug(C,g.dryrun)},q}(),he=function(){function q(l){this.options=l||ne.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new ee}q.parse=function(a,g){var C=new q(g);return C.parse(a)},q.parseInline=function(a,g){var C=new q(g);return C.parseInline(a)};var B=q.prototype;return B.parse=function(a,g){g===void 0&&(g=!0);var C="",F,u,I,A,M,V,Y,ie,ae,fe,_e,Ee,Le,Ie,de,Ce,qe,Xe,tt,lt=a.length;for(F=0;F<lt;F++){if(fe=a[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(tt=this.options.extensions.renderers[fe.type].call({parser:this},fe),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){C+=tt||"";continue}switch(fe.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,o(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(ie="",Y="",A=fe.header.length,u=0;u<A;u++)Y+=this.renderer.tablecell(this.parseInline(fe.header[u].tokens),{header:!0,align:fe.align[u]});for(ie+=this.renderer.tablerow(Y),ae="",A=fe.rows.length,u=0;u<A;u++){for(V=fe.rows[u],Y="",M=V.length,I=0;I<M;I++)Y+=this.renderer.tablecell(this.parseInline(V[I].tokens),{header:!1,align:fe.align[I]});ae+=this.renderer.tablerow(Y)}C+=this.renderer.table(ie,ae);continue}case"blockquote":{ae=this.parse(fe.tokens),C+=this.renderer.blockquote(ae);continue}case"list":{for(_e=fe.ordered,Ee=fe.start,Le=fe.loose,A=fe.items.length,ae="",u=0;u<A;u++)de=fe.items[u],Ce=de.checked,qe=de.task,Ie="",de.task&&(Xe=this.renderer.checkbox(Ce),Le?de.tokens.length>0&&de.tokens[0].type==="paragraph"?(de.tokens[0].text=Xe+" "+de.tokens[0].text,de.tokens[0].tokens&&de.tokens[0].tokens.length>0&&de.tokens[0].tokens[0].type==="text"&&(de.tokens[0].tokens[0].text=Xe+" "+de.tokens[0].tokens[0].text)):de.tokens.unshift({type:"text",text:Xe}):Ie+=Xe),Ie+=this.parse(de.tokens,Le),ae+=this.renderer.listitem(Ie,qe,Ce);C+=this.renderer.list(ae,_e,Ee);continue}case"html":{C+=this.renderer.html(fe.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(ae=fe.tokens?this.parseInline(fe.tokens):fe.text;F+1<lt&&a[F+1].type==="text";)fe=a[++F],ae+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);C+=g?this.renderer.paragraph(ae):ae;continue}default:{var rt='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}}return C},B.parseInline=function(a,g){g=g||this.renderer;var C="",F,u,I,A=a.length;for(F=0;F<A;F++){if(u=a[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(I=this.options.extensions.renderers[u.type].call({parser:this},u),I!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){C+=I||"";continue}switch(u.type){case"escape":{C+=g.text(u.text);break}case"html":{C+=g.html(u.text);break}case"link":{C+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{C+=g.image(u.href,u.title,u.text);break}case"strong":{C+=g.strong(this.parseInline(u.tokens,g));break}case"em":{C+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{C+=g.codespan(u.text);break}case"br":{C+=g.br();break}case"del":{C+=g.del(this.parseInline(u.tokens,g));break}case"text":{C+=g.text(u.text);break}default:{var M='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(M);return}else throw new Error(M)}}}return C},q}();function le(q,B,l){if(typeof q>"u"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof B=="function"&&(l=B,B=null),B=U({},le.defaults,B||{}),O(B),l){var a=B.highlight,g;try{g=Te.lex(q,B)}catch(A){return l(A)}var C=function(M){var V;if(!M)try{B.walkTokens&&le.walkTokens(g,B.walkTokens),V=he.parse(g,B)}catch(Y){M=Y}return B.highlight=a,M?l(M):l(null,V)};if(!a||a.length<3||(delete B.highlight,!g.length))return C();var F=0;le.walkTokens(g,function(A){A.type==="code"&&(F++,setTimeout(function(){a(A.text,A.lang,function(M,V){if(M)return C(M);V!=null&&V!==A.text&&(A.text=V,A.escaped=!0),F--,F===0&&C()})},0))}),F===0&&C();return}function u(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}try{var I=Te.lex(q,B);if(B.walkTokens){if(B.async)return Promise.all(le.walkTokens(I,B.walkTokens)).then(function(){return he.parse(I,B)}).catch(u);le.walkTokens(I,B.walkTokens)}return he.parse(I,B)}catch(A){u(A)}}le.options=le.setOptions=function(q){return U(le.defaults,q),w(le.defaults),le},le.getDefaults=N,le.defaults=ne.defaults,le.use=function(){for(var q=arguments.length,B=new Array(q),l=0;l<q;l++)B[l]=arguments[l];var a=U.apply(void 0,[{}].concat(B)),g=le.defaults.extensions||{renderers:{},childTokens:{}},C;B.forEach(function(F){if(F.extensions&&(C=!0,F.extensions.forEach(function(I){if(!I.name)throw new Error("extension name required");if(I.renderer){var A=g.renderers?g.renderers[I.name]:null;A?g.renderers[I.name]=function(){for(var M=arguments.length,V=new Array(M),Y=0;Y<M;Y++)V[Y]=arguments[Y];var ie=I.renderer.apply(this,V);return ie===!1&&(ie=A.apply(this,V)),ie}:g.renderers[I.name]=I.renderer}if(I.tokenizer){if(!I.level||I.level!=="block"&&I.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[I.level]?g[I.level].unshift(I.tokenizer):g[I.level]=[I.tokenizer],I.start&&(I.level==="block"?g.startBlock?g.startBlock.push(I.start):g.startBlock=[I.start]:I.level==="inline"&&(g.startInline?g.startInline.push(I.start):g.startInline=[I.start]))}I.childTokens&&(g.childTokens[I.name]=I.childTokens)})),F.renderer&&function(){var I=le.defaults.renderer||new Fe,A=function(Y){var ie=I[Y];I[Y]=function(){for(var ae=arguments.length,fe=new Array(ae),_e=0;_e<ae;_e++)fe[_e]=arguments[_e];var Ee=F.renderer[Y].apply(I,fe);return Ee===!1&&(Ee=ie.apply(I,fe)),Ee}};for(var M in F.renderer)A(M);a.renderer=I}(),F.tokenizer&&function(){var I=le.defaults.tokenizer||new X,A=function(Y){var ie=I[Y];I[Y]=function(){for(var ae=arguments.length,fe=new Array(ae),_e=0;_e<ae;_e++)fe[_e]=arguments[_e];var Ee=F.tokenizer[Y].apply(I,fe);return Ee===!1&&(Ee=ie.apply(I,fe)),Ee}};for(var M in F.tokenizer)A(M);a.tokenizer=I}(),F.walkTokens){var u=le.defaults.walkTokens;a.walkTokens=function(I){var A=[];return A.push(F.walkTokens.call(this,I)),u&&(A=A.concat(u.call(this,I))),A}}C&&(a.extensions=g),le.setOptions(a)})},le.walkTokens=function(q,B){for(var l=[],a=function(){var u=C.value;switch(l=l.concat(B.call(le,u)),u.type){case"table":{for(var I=R(u.header),A;!(A=I()).done;){var M=A.value;l=l.concat(le.walkTokens(M.tokens,B))}for(var V=R(u.rows),Y;!(Y=V()).done;)for(var ie=Y.value,ae=R(ie),fe;!(fe=ae()).done;){var _e=fe.value;l=l.concat(le.walkTokens(_e.tokens,B))}break}case"list":{l=l.concat(le.walkTokens(u.items,B));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[u.type]?le.defaults.extensions.childTokens[u.type].forEach(function(Ee){l=l.concat(le.walkTokens(u[Ee],B))}):u.tokens&&(l=l.concat(le.walkTokens(u.tokens,B)))}},g=R(q),C;!(C=g()).done;)a();return l},le.parseInline=function(q,B){if(typeof q>"u"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");B=U({},le.defaults,B||{}),O(B);try{var l=Te.lexInline(q,B);return B.walkTokens&&le.walkTokens(l,B.walkTokens),he.parseInline(l,B)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},le.Parser=he,le.parser=he.parse,le.Renderer=Fe,le.TextRenderer=re,le.Lexer=Te,le.lexer=Te.lex,le.Tokenizer=X,le.Slugger=ee,le.parse=le;var Ne=le.options,te=le.setOptions,be=le.use,Se=le.walkTokens,Oe=le.parseInline,Re=le,We=he.parse,oe=Te.lex;ne.Lexer=Te,ne.Parser=he,ne.Renderer=Fe,ne.Slugger=ee,ne.TextRenderer=re,ne.Tokenizer=X,ne.getDefaults=N,ne.lexer=oe,ne.marked=le,ne.options=Ne,ne.parse=Re,ne.parseInline=Oe,ne.parser=We,ne.setOptions=te,ne.use=be,ne.walkTokens=Se,Object.defineProperty(ne,"__esModule",{value:!0})}),define(De[61],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(De[93],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=i;function i(s){const o=R(s);if(o&&o.length>0)return new Uint32Array(o)}let n=0;const k=new Uint32Array(10);function R(s){if(n=0,N(s,y,_.InitialConsonant),n>0||(N(s,p,_.Vowel),n>0)||(N(s,m,_.FinalConsonant),n>0)||(N(s,e,_.CompatibilityJamo),n))return k.subarray(0,n);if(s>=44032&&s<=55203){const o=s-44032,c=o%588,h=Math.floor(o/588),v=Math.floor(c/28),L=c%28-1;if(h<y.length?N(h,y,0):_.InitialConsonant+h-_.CompatibilityJamo<e.length&&N(_.InitialConsonant+h,e,_.CompatibilityJamo),v<p.length?N(v,p,0):_.Vowel+v-_.CompatibilityJamo<e.length&&N(_.Vowel+v-_.CompatibilityJamo,e,_.CompatibilityJamo),L>=0&&(L<m.length?N(L,m,0):_.FinalConsonant+L-_.CompatibilityJamo<e.length&&N(_.FinalConsonant+L-_.CompatibilityJamo,e,_.CompatibilityJamo)),n>0)return k.subarray(0,n)}}function N(s,o,c){s>=c&&s<c+o.length&&w(o[s-c])}function w(s){s!==d.NUL&&(k[n++]=s&255,s>>8&&(k[n++]=s>>8&255),s>>16&&(k[n++]=s>>16&255))}var _;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(_||(_={}));var d;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(d||(d={}));var b;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(b||(b={}));const y=new Uint8Array([d.r,d.R,d.s,d.e,d.E,d.f,d.a,d.q,d.Q,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g]),p=new Uint16Array([d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,b.hk,b.ho,b.hl,d.y,d.n,b.nj,b.np,b.nl,d.b,d.m,b.ml,d.l]),m=new Uint16Array([d.r,d.R,b.rt,d.s,b.sw,b.sg,d.e,d.f,b.fr,b.fa,b.fq,b.ft,b.fx,b.fv,b.fg,d.a,d.q,b.qt,d.t,d.T,d.d,d.w,d.c,d.z,d.x,d.v,d.g]),e=new Uint16Array([d.r,d.R,b.rt,d.s,b.sw,b.sg,d.e,d.E,d.f,b.fr,b.fa,b.fq,b.ft,b.fx,b.fv,b.fg,d.a,d.q,d.Q,b.qt,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g,d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,b.hk,b.ho,b.hl,d.y,d.n,b.nj,b.np,b.nl,d.b,d.m,b.ml,d.l])}),define(De[94],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class i{constructor(k,R=0,N=k.length,w=R-1){this.items=k,this.start=R,this.end=N,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=i}),define(De[95],we([1,0,58,94]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class k{constructor(w=[],_=10){this._initialize(w),this._limit=_,this._onChange()}getHistory(){return this._elements}add(w){this._history.delete(w),this._history.add(w),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(w){return this._history.has(w)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const w=this._elements;this._navigator=new n.ArrayNavigator(w,0,w.length,w.length)}_reduceToLimit(){const w=this._elements;w.length>this._limit&&this._initialize(w.slice(w.length-this._limit))}_currentPosition(){const w=this._navigator.current();return w?this._elements.indexOf(w):-1}_initialize(w){this._history=new Set;for(const _ of w)this._history.add(_)}get _elements(){const w=[];return this._history.forEach(_=>w.push(_)),w}}t.HistoryNavigator=k;class R{get size(){return this._size}constructor(w,_=10,d=b=>b){if(this.capacity=_,this.identityFn=d,w.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:w[0],previous:void 0,next:void 0},this.valueSet=new i.SetWithKey([w[0]],d);for(let b=1;b<w.length;b++)this.add(w[b])}add(w){const _={value:w,previous:this.tail,next:void 0};for(this.tail.next=_,this.tail=_,this.cursor=this.tail,this._size++,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(w){if(this.identityFn(this.tail.value)===this.identityFn(w))return w;const _=this.tail.value;return this.valueSet.delete(_),this.tail.value=w,this.valueSet.has(w)?this._deleteFromList(w):this.valueSet.add(w),_}prepend(w){if(this._size===this.capacity||this.valueSet.has(w))return;const _={value:w,previous:void 0,next:this.head};this.head.previous=_,this.head=_,this._size++,this.valueSet.add(w)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(w){return this.valueSet.has(w)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let w=this.head;for(;w;)yield w.value,w=w.next}_deleteFromList(w){let _=this.head;const d=this.identityFn(w);for(;_!==this.tail;)this.identityFn(_.value)===d&&(_===this.head?(this.head=this.head.next,this.head.previous=void 0):(_.previous.next=_.next,_.next.previous=_.previous),this._size--),_=_.next}}t.HistoryNavigator2=R}),define(De[38],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=i,t.rot=n,t.isPointWithinTriangle=w;function i(_,d,b){return Math.min(Math.max(_,d),b)}function n(_,d){return(d+_%d)%d}class k{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=k;class R{constructor(){this._n=1,this._val=0}update(d){return this._val=this._val+(d-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=R;class N{constructor(d){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(d),this._values.fill(0,0,d)}update(d){const b=this._values[this._index];return this._values[this._index]=d,this._index=(this._index+1)%this._values.length,this._sum-=b,this._sum+=d,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=N;function w(_,d,b,y,p,m,e,s){const o=e-b,c=s-y,h=p-b,v=m-y,L=_-b,S=d-y,r=o*o+c*c,f=o*h+c*v,E=o*L+c*S,T=h*h+v*v,H=h*L+v*S,W=1/(r*T-f*f),U=(T*E-f*H)*W,D=(r*H-f*E)*W;return U>=0&&D>=0&&U+D<1}}),define(De[27],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=R,t.getFunctionName=p;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return R(e,this)}}t.DebugNameData=i;const n=new Map,k=new WeakMap;function R(m,e){const s=k.get(m);if(s)return s;const o=N(m,e);if(o){let c=n.get(o)??0;c++,n.set(o,c);const h=c===1?o:`${o}#${c}`;return k.set(m,h),h}}function N(m,e){const s=k.get(m);if(s)return s;const o=e.owner?b(e.owner)+".":"";let c;const h=e.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(c=h(),c!==void 0)return o+c}else return o+h;const v=e.referenceFn;if(v!==void 0&&(c=p(v),c!==void 0))return o+c;if(e.owner!==void 0){const L=w(e.owner,m);if(L!==void 0)return o+L}}function w(m,e){for(const s in m)if(m[s]===e)return s}const _=new Map,d=new WeakMap;function b(m){const e=d.get(m);if(e)return e;const s=y(m);let o=_.get(s)??0;o++,_.set(s,o);const c=o===1?s:`${s}#${o}`;return d.set(m,c),c}function y(m){const e=m.constructor;return e?e.name:"Object"}function p(m){const e=m.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(De[32],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=n,t.getLogger=k;let i;function n(s){i=s}function k(){return i}class R{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return N([w(m("|  ",this.indentation)),o])}formatInfo(o){return o.hadValue?o.didChange?[w(" "),d(b(o.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),d(b(o.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),d(b(o.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(o,c){console.log(...this.textToConsoleArgs([_("observable value changed"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c)]))}formatChanges(o){if(o.size!==0)return d(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(h,v)=>(this.changedObservablesSets.get(o).add(h),c.apply(o,[h,v]))}handleDerivedRecomputed(o,c){const h=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([_("derived recomputed"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c),this.formatChanges(h),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.textToConsoleArgs([_("observable from event triggered"),d(o.debugName,{color:"BlueViolet"}),...this.formatInfo(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(h,v)=>(this.changedObservablesSets.get(o).add(h),c.apply(o,[h,v]))}handleAutorunTriggered(o){const c=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([_("autorun"),d(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),c.clear(),this.indentation++}handleAutorunFinished(o){this.indentation--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.textToConsoleArgs([_("transaction"),d(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=R;function N(s){const o=new Array,c=[];let h="";function v(S){if("length"in S)for(const r of S)r&&v(r);else"text"in S?(h+=`%c${S.text}`,o.push(S.style),S.data&&c.push(...S.data)):"data"in S&&c.push(...S.data)}v(s);const L=[h,...o];return L.push(...c),L}function w(s){return d(s,{color:"black"})}function _(s){return d(e(`${s}: `,10),{color:"black",bold:!0})}function d(s,o={color:"black"}){function c(v){return Object.entries(v).reduce((L,[S,r])=>`${L}${S}:${r};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:s,style:c(h)}}function b(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?y(s,o):p(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function y(s,o){let c="[ ",h=!0;for(const v of s){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${b(v,o-c.length)}`}return c+=" ]",c}function p(s,o){let c="{ ",h=!0;for(const[v,L]of Object.entries(s)){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${v}: ${b(L,o-c.length)}`}return c+=" }",c}function m(s,o){let c="";for(let h=1;h<=o;h++)c+=s;return c}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(De[45],we([1,0,43,2,27,32]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=N,t.autorunOpts=w,t.autorunHandleChanges=_,t.autorunWithStoreHandleChanges=d,t.autorunWithStore=b,t.autorunDelta=y;function N(e){return new m(new k.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function w(e,s){return new m(new k.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function _(e,s){return new m(new k.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function d(e,s){const o=new n.DisposableStore,c=_({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(h,v)=>{o.clear(),s(h,v,o)});return(0,n.toDisposable)(()=>{c.dispose(),o.dispose()})}function b(e){const s=new n.DisposableStore,o=w({owner:void 0,debugName:void 0,debugReferenceFn:e},c=>{s.clear(),e(c,s)});return(0,n.toDisposable)(()=>{o.dispose(),s.dispose()})}function y(e,s){let o;return w({debugReferenceFn:s},c=>{const h=e.read(c),v=o;o=h,s({lastValue:v,newValue:h})})}var p;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(p||(p={}));class m{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,o,c,h){this._debugNameData=s,this._runFn=o,this.createChangeSummary=c,this._handleChange=h,this.state=p.stale,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,R.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,n.trackDisposable)(this)}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear(),(0,n.markAsDisposed)(this)}_runIfNeeded(){if(this.state===p.upToDate)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=p.upToDate;const o=this.disposed;try{if(!o){(0,R.getLogger)()?.handleAutorunTriggered(this);const c=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,c)}}finally{o||(0,R.getLogger)()?.handleAutorunFinished(this);for(const c of this.dependenciesToBeRemoved)c.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===p.upToDate&&(this.state=p.dependenciesMightHaveChanged),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===p.dependenciesMightHaveChanged){this.state=p.upToDate;for(const s of this.dependencies)if(s.reportChanges(),this.state===p.stale)break}this._runIfNeeded()}while(this.state!==p.upToDate);this.updateCount--,(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(s){this.state===p.upToDate&&this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(this.state=p.dependenciesMightHaveChanged)}handleChange(s,o){this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:o,didChange:h=>h===s},this.changeSummary))&&(this.state=p.stale)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const o=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),o}}t.AutorunObserver=m,function(e){e.Observer=m}(N||(t.autorun=N={}))}),define(De[28],we([1,0,31,27,32]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=N,t._setKeepObserved=_,t._setDerivedOpts=b,t.transaction=m,t.globalTransaction=s,t.asyncTransaction=o,t.subtransaction=c,t.observableValue=v,t.disposableObservableValue=S;let R;function N(f){R=f}let w;function _(f){w=f}let d;function b(f){d=f}class y{get TChange(){return null}reportChanges(){this.get()}read(E){return E?E.readObservable(this):this.get()}map(E,T){const H=T===void 0?void 0:E,W=T===void 0?E:T;return d({owner:H,debugName:()=>{const U=(0,n.getFunctionName)(W);if(U!==void 0)return U;const x=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(W.toString());if(x)return`${this.debugName}.${x[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:W},U=>W(this.read(U),U))}recomputeInitiallyAndOnChange(E,T){return E.add(R(this,T)),this}keepObserved(E){return E.add(w(this)),this}get debugValue(){return this.get()}}t.ConvenientObservable=y;class p extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(E){const T=this.observers.size;this.observers.add(E),T===0&&this.onFirstObserverAdded()}removeObserver(E){this.observers.delete(E)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=p;function m(f,E){const T=new h(f,E);try{f(T)}finally{T.finish()}}let e;function s(f){if(e)f(e);else{const E=new h(f,void 0);e=E;try{f(E)}finally{E.finish(),e=void 0}}}async function o(f,E){const T=new h(f,E);try{await f(T)}finally{T.finish()}}function c(f,E,T){f?E(f):m(E,T)}class h{constructor(E,T){this._fn=E,this._getDebugName=T,this.updatingObservers=[],(0,k.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,n.getFunctionName)(this._fn)}updateObserver(E,T){this.updatingObservers.push({observer:E,observable:T}),E.beginUpdate(T)}finish(){const E=this.updatingObservers;for(let T=0;T<E.length;T++){const{observer:H,observable:W}=E[T];H.endUpdate(W)}this.updatingObservers=null,(0,k.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=h;function v(f,E){let T;return typeof f=="string"?T=new n.DebugNameData(void 0,f,void 0):T=new n.DebugNameData(f,void 0,void 0),new L(T,E,i.strictEquals)}class L extends p{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(E,T,H){super(),this._debugNameData=E,this._equalityComparator=H,this._value=T}get(){return this._value}set(E,T,H){if(H===void 0&&this._equalityComparator(this._value,E))return;let W;T||(T=W=new h(()=>{},()=>`Setting ${this.debugName}`));try{const U=this._value;this._setValue(E),(0,k.getLogger)()?.handleObservableChanged(this,{oldValue:U,newValue:E,change:H,didChange:!0,hadValue:!0});for(const D of this.observers)T.updateObserver(D,this),D.handleChange(this,H)}finally{W&&W.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(E){this._value=E}}t.ObservableValue=L;function S(f,E){let T;return typeof f=="string"?T=new n.DebugNameData(void 0,f,void 0):T=new n.DebugNameData(f,void 0,void 0),new r(T,E,i.strictEquals)}class r extends L{_setValue(E){this._value!==E&&(this._value&&this._value.dispose(),this._value=E)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=r}),define(De[46],we([1,0,43,31,2,28,27,32]),function(ne,t,i,n,k,R,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DerivedWithSetter=t.Derived=void 0,t.derived=_,t.derivedWithSetter=d,t.derivedOpts=b,t.derivedHandleChanges=y,t.derivedWithStore=p,t.derivedDisposable=m;function _(c,h){return h!==void 0?new s(new N.DebugNameData(c,void 0,h),h,void 0,void 0,void 0,n.strictEquals):new s(new N.DebugNameData(void 0,void 0,c),c,void 0,void 0,void 0,n.strictEquals)}function d(c,h,v){return new o(new N.DebugNameData(c,void 0,h),h,void 0,void 0,void 0,n.strictEquals,v)}function b(c,h){return new s(new N.DebugNameData(c.owner,c.debugName,c.debugReferenceFn),h,void 0,void 0,c.onLastObserverRemoved,c.equalsFn??n.strictEquals)}(0,R._setDerivedOpts)(b);function y(c,h){return new s(new N.DebugNameData(c.owner,c.debugName,void 0),h,c.createEmptyChangeSummary,c.handleChange,void 0,c.equalityComparer??n.strictEquals)}function p(c,h){let v,L;h===void 0?(v=c,L=void 0):(L=c,v=h);const S=new k.DisposableStore;return new s(new N.DebugNameData(L,void 0,v),r=>(S.clear(),v(r,S)),void 0,void 0,()=>S.dispose(),n.strictEquals)}function m(c,h){let v,L;h===void 0?(v=c,L=void 0):(L=c,v=h);let S;return new s(new N.DebugNameData(L,void 0,v),r=>{S?S.clear():S=new k.DisposableStore;const f=v(r);return f&&S.add(f),f},void 0,void 0,()=>{S&&(S.dispose(),S=void 0)},n.strictEquals)}var e;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(e||(e={}));class s extends R.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(h,v,L,S,r=void 0,f){super(),this._debugNameData=h,this._computeFn=v,this.createChangeSummary=L,this._handleChange=S,this._handleLastObserverRemoved=r,this._equalityComparator=f,this.state=e.initial,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,w.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=e.initial,this.value=void 0;for(const h of this.dependencies)h.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const h=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),h}else{do{if(this.state===e.dependenciesMightHaveChanged){for(const h of this.dependencies)if(h.reportChanges(),this.state===e.stale)break}this.state===e.dependenciesMightHaveChanged&&(this.state=e.upToDate),this._recomputeIfNeeded()}while(this.state!==e.upToDate);return this.value}}_recomputeIfNeeded(){if(this.state===e.upToDate)return;const h=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=h;const v=this.state!==e.initial,L=this.value;this.state=e.upToDate;const S=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,S)}finally{for(const f of this.dependenciesToBeRemoved)f.removeObserver(this);this.dependenciesToBeRemoved.clear()}const r=v&&!this._equalityComparator(L,this.value);if((0,w.getLogger)()?.handleDerivedRecomputed(this,{oldValue:L,newValue:this.value,change:void 0,didChange:r,hadValue:v}),r)for(const f of this.observers)f.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(h){this.updateCount++;const v=this.updateCount===1;if(this.state===e.upToDate&&(this.state=e.dependenciesMightHaveChanged,!v))for(const L of this.observers)L.handlePossibleChange(this);if(v)for(const L of this.observers)L.beginUpdate(this)}endUpdate(h){if(this.updateCount--,this.updateCount===0){const v=[...this.observers];for(const L of v)L.endUpdate(this)}(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(h){if(this.state===e.upToDate&&this.dependencies.has(h)&&!this.dependenciesToBeRemoved.has(h)){this.state=e.dependenciesMightHaveChanged;for(const v of this.observers)v.handlePossibleChange(this)}}handleChange(h,v){if(this.dependencies.has(h)&&!this.dependenciesToBeRemoved.has(h)){const L=this._handleChange?this._handleChange({changedObservable:h,change:v,didChange:r=>r===h},this.changeSummary):!0,S=this.state===e.upToDate;if(L&&(this.state===e.dependenciesMightHaveChanged||S)&&(this.state=e.stale,S))for(const r of this.observers)r.handlePossibleChange(this)}}readObservable(h){h.addObserver(this);const v=h.get();return this.dependencies.add(h),this.dependenciesToBeRemoved.delete(h),v}addObserver(h){const v=!this.observers.has(h)&&this.updateCount>0;super.addObserver(h),v&&h.beginUpdate(this)}removeObserver(h){const v=this.observers.has(h)&&this.updateCount>0;super.removeObserver(h),v&&h.endUpdate(this)}}t.Derived=s;class o extends s{constructor(h,v,L,S,r=void 0,f,E){super(h,v,L,S,r,f),this.set=E}}t.DerivedWithSetter=o}),define(De[96],we([1,0,28]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LazyObservableValue=void 0;class n extends i.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"LazyObservableValue"}constructor(R,N,w){super(),this._debugNameData=R,this._equalityComparator=w,this._isUpToDate=!0,this._deltas=[],this._updateCounter=0,this._value=N}get(){return this._update(),this._value}_update(){if(!this._isUpToDate)if(this._isUpToDate=!0,this._deltas.length>0){for(const R of this.observers)for(const N of this._deltas)R.handleChange(this,N);this._deltas.length=0}else for(const R of this.observers)R.handleChange(this,void 0)}_beginUpdate(){if(this._updateCounter++,this._updateCounter===1)for(const R of this.observers)R.beginUpdate(this)}_endUpdate(){if(this._updateCounter--,this._updateCounter===0){this._update();const R=[...this.observers];for(const N of R)N.endUpdate(this)}}addObserver(R){const N=!this.observers.has(R)&&this._updateCounter>0;super.addObserver(R),N&&R.beginUpdate(this)}removeObserver(R){const N=this.observers.has(R)&&this._updateCounter>0;super.removeObserver(R),N&&R.endUpdate(this)}set(R,N,w){if(w===void 0&&this._equalityComparator(this._value,R))return;let _;N||(N=_=new i.TransactionImpl(()=>{},()=>`Setting ${this.debugName}`));try{if(this._isUpToDate=!1,this._setValue(R),w!==void 0&&this._deltas.push(w),N.updateObserver({beginUpdate:()=>this._beginUpdate(),endUpdate:()=>this._endUpdate(),handleChange:(d,b)=>{},handlePossibleChange:d=>{}},this),this._updateCounter>1)for(const d of this.observers)d.handlePossibleChange(this)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(R){this._value=R}}t.LazyObservableValue=n}),define(De[97],we([1,0,31,28,27,96]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=N;function N(w,_){return w.lazy?new R.LazyObservableValue(new k.DebugNameData(w.owner,w.debugName,void 0),_,w.equalsFn??i.strictEquals):new n.ObservableValue(new k.DebugNameData(w.owner,w.debugName,void 0),_,w.equalsFn??i.strictEquals)}}),define(De[47],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function k(_,d){if(_.start>=d.end||d.start>=_.end)return{start:0,end:0};const b=Math.max(_.start,d.start),y=Math.min(_.end,d.end);return y-b<=0?{start:0,end:0}:{start:b,end:y}}n.intersect=k;function R(_){return _.end-_.start<=0}n.isEmpty=R;function N(_,d){return!R(k(_,d))}n.intersects=N;function w(_,d){const b=[],y={start:_.start,end:Math.min(d.start,_.end)},p={start:Math.max(d.end,_.start),end:_.end};return R(y)||b.push(y),R(p)||b.push(p),b}n.relativeComplement=w})(i||(t.Range=i={}))}),define(De[98],we([1,0,47]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=n,t.shift=k,t.consolidate=R;function n(_,d){const b=[];for(const y of d){if(_.start>=y.range.end)continue;if(_.end<y.range.start)break;const p=i.Range.intersect(_,y.range);i.Range.isEmpty(p)||b.push({range:p,size:y.size})}return b}function k({start:_,end:d},b){return{start:_+b,end:d+b}}function R(_){const d=[];let b=null;for(const y of _){const p=y.range.start,m=y.range.end,e=y.size;if(b&&e===b.size){b.range.end=m;continue}b={range:{start:p,end:m},size:e},d.push(b)}return d}function N(..._){return R(_.reduce((d,b)=>d.concat(b),[]))}class w{get paddingTop(){return this._paddingTop}set paddingTop(d){this._size=this._size+d-this._paddingTop,this._paddingTop=d}constructor(d){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=d??0,this._size=this._paddingTop}splice(d,b,y=[]){const p=y.length-b,m=n({start:0,end:d},this.groups),e=n({start:d+b,end:Number.POSITIVE_INFINITY},this.groups).map(o=>({range:k(o.range,p),size:o.size})),s=y.map((o,c)=>({range:{start:d+c,end:d+c+1},size:o.size}));this.groups=N(m,s,e),this._size=this._paddingTop+this.groups.reduce((o,c)=>o+c.size*(c.range.end-c.range.start),0)}get count(){const d=this.groups.length;return d?this.groups[d-1].range.end:0}get size(){return this._size}indexAt(d){if(d<0)return-1;if(d<this._paddingTop)return 0;let b=0,y=this._paddingTop;for(const p of this.groups){const m=p.range.end-p.range.start,e=y+m*p.size;if(d<e)return b+Math.floor((d-y)/p.size);b+=m,y=e}return b}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let b=0,y=0;for(const p of this.groups){const m=p.range.end-p.range.start,e=y+m;if(d<e)return this._paddingTop+b+(d-y)*p.size;b+=m*p.size,y=e}return-1}}t.RangeMap=w}),define(De[99],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(R){return new n(R)}constructor(R){this._now=i&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=n}),define(De[3],we([1,0,6,59,2,60,99]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=m;const w=!1,_=!1,d=!1;var b;(function(X){X.None=()=>k.Disposable.None;function G(A){if(d){const{onDidAddListener:M}=A,V=s.create();let Y=0;A.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),M?.()}}}function J(A,M){return te(A,()=>{},0,void 0,!0,void 0,M)}X.defer=J;function ce(A){return(M,V=null,Y)=>{let ie=!1,ae;return ae=A(fe=>{if(!ie)return ae?ae.dispose():ie=!0,M.call(V,fe)},null,Y),ie&&ae.dispose(),ae}}X.once=ce;function pe(A,M,V){return le((Y,ie=null,ae)=>A(fe=>Y.call(ie,M(fe)),null,ae),V)}X.map=pe;function Te(A,M,V){return le((Y,ie=null,ae)=>A(fe=>{M(fe),Y.call(ie,fe)},null,ae),V)}X.forEach=Te;function Fe(A,M,V){return le((Y,ie=null,ae)=>A(fe=>M(fe)&&Y.call(ie,fe),null,ae),V)}X.filter=Fe;function re(A){return A}X.signal=re;function ee(...A){return(M,V=null,Y)=>{const ie=(0,k.combinedDisposable)(...A.map(ae=>ae(fe=>M.call(V,fe))));return Ne(ie,Y)}}X.any=ee;function he(A,M,V,Y){let ie=V;return pe(A,ae=>(ie=M(ie,ae),ie),Y)}X.reduce=he;function le(A,M){let V;const Y={onWillAddFirstListener(){V=A(ie.fire,ie)},onDidRemoveLastListener(){V?.dispose()}};M||G(Y);const ie=new f(Y);return M?.add(ie),ie.event}function Ne(A,M){return M instanceof Array?M.push(A):M&&M.add(A),A}function te(A,M,V=100,Y=!1,ie=!1,ae,fe){let _e,Ee,Le,Ie=0,de;const Ce={leakWarningThreshold:ae,onWillAddFirstListener(){_e=A(Xe=>{Ie++,Ee=M(Ee,Xe),Y&&!Le&&(qe.fire(Ee),Ee=void 0),de=()=>{const tt=Ee;Ee=void 0,Le=void 0,(!Y||Ie>1)&&qe.fire(tt),Ie=0},typeof V=="number"?(clearTimeout(Le),Le=setTimeout(de,V)):Le===void 0&&(Le=0,queueMicrotask(de))})},onWillRemoveListener(){ie&&Ie>0&&de?.()},onDidRemoveLastListener(){de=void 0,_e.dispose()}};fe||G(Ce);const qe=new f(Ce);return fe?.add(qe),qe.event}X.debounce=te;function be(A,M=0,V){return X.debounce(A,(Y,ie)=>Y?(Y.push(ie),Y):[ie],M,void 0,!0,void 0,V)}X.accumulate=be;function Se(A,M=(Y,ie)=>Y===ie,V){let Y=!0,ie;return Fe(A,ae=>{const fe=Y||!M(ae,ie);return Y=!1,ie=ae,fe},V)}X.latch=Se;function Oe(A,M,V){return[X.filter(A,M,V),X.filter(A,Y=>!M(Y),V)]}X.split=Oe;function Re(A,M=!1,V=[],Y){let ie=V.slice(),ae=A(Ee=>{ie?ie.push(Ee):_e.fire(Ee)});Y&&Y.add(ae);const fe=()=>{ie?.forEach(Ee=>_e.fire(Ee)),ie=null},_e=new f({onWillAddFirstListener(){ae||(ae=A(Ee=>_e.fire(Ee)),Y&&Y.add(ae))},onDidAddFirstListener(){ie&&(M?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return Y&&Y.add(_e),_e.event}X.buffer=Re;function We(A,M){return(Y,ie,ae)=>{const fe=M(new q);return A(function(_e){const Ee=fe.evaluate(_e);Ee!==oe&&Y.call(ie,Ee)},void 0,ae)}}X.chain=We;const oe=Symbol("HaltChainable");class q{constructor(){this.steps=[]}map(M){return this.steps.push(M),this}forEach(M){return this.steps.push(V=>(M(V),V)),this}filter(M){return this.steps.push(V=>M(V)?V:oe),this}reduce(M,V){let Y=V;return this.steps.push(ie=>(Y=M(Y,ie),Y)),this}latch(M=(V,Y)=>V===Y){let V=!0,Y;return this.steps.push(ie=>{const ae=V||!M(ie,Y);return V=!1,Y=ie,ae?ie:oe}),this}evaluate(M){for(const V of this.steps)if(M=V(M),M===oe)break;return M}}function B(A,M,V=Y=>Y){const Y=(..._e)=>fe.fire(V(..._e)),ie=()=>A.on(M,Y),ae=()=>A.removeListener(M,Y),fe=new f({onWillAddFirstListener:ie,onDidRemoveLastListener:ae});return fe.event}X.fromNodeEventEmitter=B;function l(A,M,V=Y=>Y){const Y=(..._e)=>fe.fire(V(..._e)),ie=()=>A.addEventListener(M,Y),ae=()=>A.removeEventListener(M,Y),fe=new f({onWillAddFirstListener:ie,onDidRemoveLastListener:ae});return fe.event}X.fromDOMEventEmitter=l;function a(A){return new Promise(M=>ce(A)(M))}X.toPromise=a;function g(A){const M=new f;return A.then(V=>{M.fire(V)},()=>{M.fire(void 0)}).finally(()=>{M.dispose()}),M.event}X.fromPromise=g;function C(A,M,V){return M(V),A(Y=>M(Y))}X.runAndSubscribe=C;class F{constructor(M,V){this._observable=M,this._counter=0,this._hasChanged=!1;const Y={onWillAddFirstListener:()=>{M.addObserver(this)},onDidRemoveLastListener:()=>{M.removeObserver(this)}};V||G(Y),this.emitter=new f(Y),V&&V.add(this.emitter)}beginUpdate(M){this._counter++}handlePossibleChange(M){}handleChange(M,V){this._hasChanged=!0}endUpdate(M){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function u(A,M){return new F(A,M).emitter.event}X.fromObservable=u;function I(A){return(M,V,Y)=>{let ie=0,ae=!1;const fe={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(A.reportChanges(),ae&&(ae=!1,M.call(V)))},handlePossibleChange(){},handleChange(){ae=!0}};A.addObserver(fe),A.reportChanges();const _e={dispose(){A.removeObserver(fe)}};return Y instanceof k.DisposableStore?Y.add(_e):Array.isArray(Y)&&Y.push(_e),_e}}X.fromObservableLight=I})(b||(t.Event=b={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(G){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${G}_${y._idPool++}`,y.all.add(this)}start(G){this._stopWatch=new N.StopWatch,this.listenerCount=G}stop(){if(this._stopWatch){const G=this._stopWatch.elapsed();this.durations.push(G),this.elapsedOverall+=G,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=y;let p=-1;function m(X){const G=p;return p=X,{dispose(){p=G}}}class e{static{this._idPool=1}constructor(G,J,ce=(e._idPool++).toString(16).padStart(3,"0")){this._errorHandler=G,this.threshold=J,this.name=ce,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(G,J){const ce=this.threshold;if(ce<=0||J<ce)return;this._stacks||(this._stacks=new Map);const pe=this._stacks.get(G.value)||0;if(this._stacks.set(G.value,pe+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=ce*.5;const[Te,Fe]=this.getMostFrequentStack(),re=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${Fe}):`;console.warn(re),console.warn(Te);const ee=new o(re,Te);this._errorHandler(ee)}return()=>{const Te=this._stacks.get(G.value)||0;this._stacks.set(G.value,Te-1)}}getMostFrequentStack(){if(!this._stacks)return;let G,J=0;for(const[ce,pe]of this._stacks)(!G||J<pe)&&(G=[ce,pe],J=pe);return G}}class s{static create(){const G=new Error;return new s(G.stack??"")}constructor(G){this.value=G}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(G,J){super(G),this.name="ListenerLeakError",this.stack=J}}t.ListenerLeakError=o;class c extends Error{constructor(G,J){super(G),this.name="ListenerRefusalError",this.stack=J}}t.ListenerRefusalError=c;let h=0;class v{constructor(G){this.value=G,this.id=h++}}const L=2,S=(X,G)=>{if(X instanceof v)G(X);else for(let J=0;J<X.length;J++){const ce=X[J];ce&&G(ce)}};let r;if(w){const X=[];setInterval(()=>{X.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(X.join(`
`)),X.length=0)},3e3),r=new FinalizationRegistry(G=>{typeof G=="string"&&X.push(G)})}class f{constructor(G){this._size=0,this._options=G,this._leakageMon=p>0||this._options?.leakWarningThreshold?new e(G?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(_){const G=this._listeners;queueMicrotask(()=>{S(G,J=>J.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(G,J,ce)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const ee=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(ee);const he=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],le=new c(`${ee}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this._options?.onListenerError||i.onUnexpectedError)(le),k.Disposable.None}if(this._disposed)return k.Disposable.None;J&&(G=G.bind(J));const pe=new v(G);let Te,Fe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(pe.stack=s.create(),Te=this._leakageMon.check(pe.stack,this._size+1)),_&&(pe.stack=Fe??s.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new T,this._listeners=[this._listeners,pe]):this._listeners.push(pe):(this._options?.onWillAddFirstListener?.(this),this._listeners=pe,this._options?.onDidAddFirstListener?.(this)),this._size++;const re=(0,k.toDisposable)(()=>{r?.unregister(re),Te?.(),this._removeListener(pe)});if(ce instanceof k.DisposableStore?ce.add(re):Array.isArray(ce)&&ce.push(re),r){const ee=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ee);r.register(re,he?.[2]??ee,re)}return re},this._event}_removeListener(G){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const J=this._listeners,ce=J.indexOf(G);if(ce===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,J[ce]=void 0;const pe=this._deliveryQueue.current===this;if(this._size*L<=J.length){let Te=0;for(let Fe=0;Fe<J.length;Fe++)J[Fe]?J[Te++]=J[Fe]:pe&&(this._deliveryQueue.end--,Te<this._deliveryQueue.i&&this._deliveryQueue.i--);J.length=Te}}_deliver(G,J){if(!G)return;const ce=this._options?.onListenerError||i.onUnexpectedError;if(!ce){G.value(J);return}try{G.value(J)}catch(pe){ce(pe)}}_deliverQueue(G){const J=G.current._listeners;for(;G.i<G.end;)this._deliver(J[G.i++],G.value);G.reset()}fire(G){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,G);else{const J=this._deliveryQueue;J.enqueue(this,G,this._listeners.length),this._deliverQueue(J)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=f;const E=()=>new T;t.createEventDeliveryQueue=E;class T{constructor(){this.i=-1,this.end=0}enqueue(G,J,ce){this.i=0,this.end=ce,this.current=G,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class H extends f{async fireAsync(G,J,ce){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList),S(this._listeners,pe=>this._asyncDeliveryQueue.push([pe.value,G]));this._asyncDeliveryQueue.size>0&&!J.isCancellationRequested;){const[pe,Te]=this._asyncDeliveryQueue.shift(),Fe=[],re={...Te,token:J,waitUntil:ee=>{if(Object.isFrozen(Fe))throw new Error("waitUntil can NOT be called asynchronous");ce&&(ee=ce(ee,pe)),Fe.push(ee)}};try{pe(re)}catch(ee){(0,i.onUnexpectedError)(ee);continue}Object.freeze(Fe),await Promise.allSettled(Fe).then(ee=>{for(const he of ee)he.status==="rejected"&&(0,i.onUnexpectedError)(he.reason)})}}}t.AsyncEmitter=H;class W extends f{get isPaused(){return this._isPaused!==0}constructor(G){super(G),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=G?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const G=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(G))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(G){this._size&&(this._isPaused!==0?this._eventQueue.push(G):super.fire(G))}}t.PauseableEmitter=W;class U extends W{constructor(G){super(G),this._delay=G.delay??100}fire(G){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(G)}}t.DebounceEmitter=U;class D extends f{constructor(G){super(G),this._queuedEvents=[],this._mergeFn=G?.merge}fire(G){this.hasListeners()&&(this._queuedEvents.push(G),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(J=>super.fire(J)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=D;class x{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(G){const J={event:G,listener:null};this.events.push(J),this.hasListeners&&this.hook(J);const ce=()=>{this.hasListeners&&this.unhook(J);const pe=this.events.indexOf(J);this.events.splice(pe,1)};return(0,k.toDisposable)((0,n.createSingleCallFunction)(ce))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(G=>this.hook(G))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(G=>this.unhook(G))}hook(G){G.listener=G.event(J=>this.emitter.fire(J))}unhook(G){G.listener?.dispose(),G.listener=null}dispose(){this.emitter.dispose();for(const G of this.events)G.listener?.dispose();this.events=[]}}t.EventMultiplexer=x;class z{constructor(G,J,ce,pe){this._store=new k.DisposableStore;const Te=this._store.add(new x),Fe=this._store.add(new k.DisposableMap);function re(ee){Fe.set(ee,Te.add(pe(ee)))}for(const ee of G)re(ee);this._store.add(J(ee=>{re(ee)})),this._store.add(ce(ee=>{Fe.deleteAndDispose(ee)})),this.event=Te.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=z;class O{constructor(){this.data=[]}wrapEvent(G,J,ce){return(pe,Te,Fe)=>G(re=>{const ee=this.data[this.data.length-1];if(!J){ee?ee.buffers.push(()=>pe.call(Te,re)):pe.call(Te,re);return}const he=ee;if(!he){pe.call(Te,J(ce,re));return}he.items??=[],he.items.push(re),he.buffers.length===0&&ee.buffers.push(()=>{he.reducedResult??=ce?he.items.reduce(J,ce):he.items.reduce(J),pe.call(Te,he.reducedResult)})},void 0,Fe)}bufferEvents(G){const J={buffers:new Array};this.data.push(J);const ce=G();return this.data.pop(),J.buffers.forEach(pe=>pe()),ce}}t.EventBufferer=O;class P{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(G){this.inputEvent=G,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=G(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=P;class K{static const(G){return new Q(G)}constructor(G){this._value=G,this._onDidChange=new f,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(G){G!==this._value&&(this._value=G,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=K;class Q{constructor(G){this.value=G,this.onDidChange=b.None}}}),define(De[19],we([1,0,25,3]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=R,t.setZoomLevel=N,t.getZoomLevel=w,t.getZoomFactor=_,t.setZoomFactor=d,t.setFullscreen=b,t.isFullscreen=y,t.isStandalone=e,t.isWCOEnabled=s;class k{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new n.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new n.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new k}getZoomLevel(c){return this.mapWindowIdToZoomLevel.get(this.getWindowId(c))??0}setZoomLevel(c,h){if(this.getZoomLevel(h)===c)return;const v=this.getWindowId(h);this.mapWindowIdToZoomLevel.set(v,c),this._onDidChangeZoomLevel.fire(v)}getZoomFactor(c){return this.mapWindowIdToZoomFactor.get(this.getWindowId(c))??1}setZoomFactor(c,h){this.mapWindowIdToZoomFactor.set(this.getWindowId(h),c)}setFullscreen(c,h){if(this.isFullscreen(h)===c)return;const v=this.getWindowId(h);this.mapWindowIdToFullScreen.set(v,c),this._onDidChangeFullscreen.fire(v)}isFullscreen(c){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(c))}getWindowId(c){return c.vscodeWindowId}}function R(o,c,h){typeof c=="string"&&(c=o.matchMedia(c)),c.addEventListener("change",h)}function N(o,c){k.INSTANCE.setZoomLevel(o,c)}function w(o){return k.INSTANCE.getZoomLevel(o)}t.onDidChangeZoomLevel=k.INSTANCE.onDidChangeZoomLevel;function _(o){return k.INSTANCE.getZoomFactor(o)}function d(o,c){k.INSTANCE.setZoomFactor(o,c)}function b(o,c){k.INSTANCE.setFullscreen(o,c)}function y(o){return k.INSTANCE.isFullscreen(o)}t.onDidChangeFullscreen=k.INSTANCE.onDidChangeFullscreen;const p=navigator.userAgent;t.isFirefox=p.indexOf("Firefox")>=0,t.isWebKit=p.indexOf("AppleWebKit")>=0,t.isChrome=p.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&p.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=p.indexOf("Electron/")>=0,t.isAndroid=p.indexOf("Android")>=0;let m=!1;if(typeof i.mainWindow.matchMedia=="function"){const o=i.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=i.mainWindow.matchMedia("(display-mode: fullscreen)");m=o.matches,R(i.mainWindow,o,({matches:h})=>{m&&c.matches||(m=h)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}}),define(De[29],we([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class n{get event(){return this.emitter.event}constructor(R,N,w){const _=d=>this.emitter.fire(d);this.emitter=new i.Emitter({onWillAddFirstListener:()=>R.addEventListener(N,_,w),onDidRemoveLastListener:()=>R.removeEventListener(N,_,w)})}dispose(){this.emitter.dispose()}}t.DomEmitter=n}),define(De[39],we([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=w;const n=Object.freeze(function(_,d){const b=setTimeout(_.bind(d),0);return{dispose(){clearTimeout(b)}}});var k;(function(_){function d(b){return b===_.None||b===_.Cancelled||b instanceof R?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}_.isCancellationToken=d,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k||(t.CancellationToken=k={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class N{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}t.CancellationTokenSource=N;function w(_){const d=new N;return _.add({dispose(){d.cancel()}}),d.token}}),define(De[100],we([1,0,39]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=k;class n{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new i.CancellationTokenSource,d=this.task(_.token);return this.result={promise:d,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}t.Cache=n;function k(w){return w}class R{constructor(_,d){this.lastCache=void 0,this.lastArgKey=void 0,typeof _=="function"?(this._fn=_,this._computeKey=k):(this._fn=d,this._computeKey=_.getCacheKey)}get(_){const d=this._computeKey(_);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this._fn(_)),this.lastCache}}t.LRUCachedFunction=R;class N{get cachedValues(){return this._map}constructor(_,d){this._map=new Map,this._map2=new Map,typeof _=="function"?(this._fn=_,this._computeKey=k):(this._fn=d,this._computeKey=_.getCacheKey)}get(_){const d=this._computeKey(_);if(this._map2.has(d))return this._map2.get(d);const b=this._fn(_);return this._map.set(_,b),this._map2.set(d,b),b}}t.CachedFunction=N}),define(De[101],we([1,0,45,28,46,39,27,31,6]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=m,t.derivedWithCancellationToken=e;class d{get cachedValue(){return this._value}constructor(o){this._computeValue=o,this._value=(0,n.observableValue)(this,void 0)}getValue(){let o=this._value.get();return o||(o=this._computeValue(),this._value.set(o,void 0)),o}}t.ObservableLazy=d;class b{static fromFn(o){return new b(o())}constructor(o){this._value=(0,n.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=o.then(c=>((0,n.transaction)(h=>{this._value.set(new y(c,void 0),h)}),c),c=>{throw(0,n.transaction)(h=>{this._value.set(new y(void 0,c),h)}),c})}}t.ObservablePromise=b;class y{constructor(o,c){this.data=o,this.error=c}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=y;class p{constructor(o){this._computePromise=o,this._lazyValue=new d(()=>new b(this._computePromise())),this.cachedPromiseResult=(0,k.derived)(this,c=>this._lazyValue.cachedValue.read(c)?.promiseResult.read(c))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=p;function m(s,o,c,h){return o||(o=v=>v!=null),new Promise((v,L)=>{let S=!0,r=!1;const f=s.map(T=>({isFinished:o(T),error:c?c(T):!1,state:T})),E=(0,i.autorun)(T=>{const{isFinished:H,error:W,state:U}=f.read(T);(H||W)&&(S?r=!0:E.dispose(),W?L(W===!0?U:W):v(U))});if(h){const T=h.onCancellationRequested(()=>{E.dispose(),T.dispose(),L(new _.CancellationError)});if(h.isCancellationRequested){E.dispose(),T.dispose(),L(new _.CancellationError);return}}S=!1,r&&E.dispose()})}function e(s,o){let c,h;o===void 0?(c=s,h=void 0):(h=s,c=o);let v;return new k.Derived(new N.DebugNameData(h,void 0,c),L=>(v&&v.dispose(!0),v=new R.CancellationTokenSource,c(L,v.token)),void 0,void 0,()=>v?.dispose(),w.strictEquals)}}),define(De[102],we([1,0,3,2,45,28,27,46,32,6,31]),function(ne,t,i,n,k,R,N,w,_,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEventFromObservable=t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=y,t.observableFromPromise=m,t.observableFromEvent=e,t.observableFromEventOpts=s,t.observableSignalFromEvent=c,t.observableSignal=v,t.debouncedObservable=S,t.debouncedObservable2=r,t.wasEventTriggeredRecently=f,t.keepObserved=E,t.recomputeInitiallyAndOnChange=T,t.derivedObservableWithCache=W,t.derivedObservableWithWritableCache=U,t.mapObservableArrayCached=D,t.observableFromValueWithChangeEvent=O,t.latestChangedValue=P;function y(K){return new p(K)}class p extends R.ConvenientObservable{constructor(Q){super(),this.value=Q}get debugName(){return this.toString()}get(){return this.value}addObserver(Q){}removeObserver(Q){}toString(){return`Const: ${this.value}`}}function m(K){const Q=(0,R.observableValue)("promiseValue",{});return K.then(X=>{Q.set({value:X},void 0)}),Q}function e(...K){let Q,X,G;return K.length===3?[Q,X,G]=K:[X,G]=K,new o(new N.DebugNameData(Q,void 0,G),X,G,()=>o.globalTransaction,b.strictEquals)}function s(K,Q,X){return new o(new N.DebugNameData(K.owner,K.debugName,K.debugReferenceFn??X),Q,X,()=>o.globalTransaction,K.equalsFn??b.strictEquals)}class o extends R.BaseObservable{constructor(Q,X,G,J,ce){super(),this._debugNameData=Q,this.event=X,this._getValue=G,this._getTransaction=J,this._equalityComparator=ce,this.hasValue=!1,this.handleEvent=pe=>{const Te=this._getValue(pe),Fe=this.value,re=!this.hasValue||!this._equalityComparator(Fe,Te);let ee=!1;re&&(this.value=Te,this.hasValue&&(ee=!0,(0,R.subtransaction)(this._getTransaction(),he=>{(0,_.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:Te,change:void 0,didChange:re,hadValue:this.hasValue});for(const le of this.observers)he.updateObserver(le,this),le.handleChange(this,void 0)},()=>{const he=this.getDebugName();return"Event fired"+(he?`: ${he}`:"")})),this.hasValue=!0),ee||(0,_.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:Te,change:void 0,didChange:re,hadValue:this.hasValue})}}getDebugName(){return this._debugNameData.getDebugName(this)}get debugName(){const Q=this.getDebugName();return"From Event"+(Q?`: ${Q}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=o,function(K){K.Observer=o;function Q(X,G){let J=!1;o.globalTransaction===void 0&&(o.globalTransaction=X,J=!0);try{G()}finally{J&&(o.globalTransaction=void 0)}}K.batchEventsGlobally=Q}(e||(t.observableFromEvent=e={}));function c(K,Q){return new h(K,Q)}class h extends R.BaseObservable{constructor(Q,X){super(),this.debugName=Q,this.event=X,this.handleEvent=()=>{(0,R.transaction)(G=>{for(const J of this.observers)G.updateObserver(J,this),J.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function v(K){return typeof K=="string"?new L(K):new L(void 0,K)}class L extends R.BaseObservable{get debugName(){return new N.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(Q,X){super(),this._debugName=Q,this._owner=X}trigger(Q,X){if(!Q){(0,R.transaction)(G=>{this.trigger(G,X)},()=>`Trigger signal ${this.debugName}`);return}for(const G of this.observers)Q.updateObserver(G,this),G.handleChange(this,X)}get(){}}function S(K,Q,X){const G=(0,R.observableValue)("debounced",void 0);let J;return X.add((0,k.autorun)(ce=>{const pe=K.read(ce);J&&clearTimeout(J),J=setTimeout(()=>{(0,R.transaction)(Te=>{G.set(pe,Te)})},Q)})),G}function r(K,Q){let X=!1,G,J;return e(ce=>{const pe=(0,k.autorun)(Te=>{const Fe=K.read(Te);X?(J&&clearTimeout(J),J=setTimeout(()=>{G=Fe,ce()},Q)):(X=!0,G=Fe)});return{dispose(){pe.dispose(),X=!1,G=void 0}}},()=>X?G:K.get())}function f(K,Q,X){const G=(0,R.observableValue)("triggeredRecently",!1);let J;return X.add(K(()=>{G.set(!0,void 0),J&&clearTimeout(J),J=setTimeout(()=>{G.set(!1,void 0)},Q)})),G}function E(K){const Q=new H(!1,void 0);return K.addObserver(Q),(0,n.toDisposable)(()=>{K.removeObserver(Q)})}(0,R._setKeepObserved)(E);function T(K,Q){const X=new H(!0,Q);return K.addObserver(X),Q?Q(K.get()):K.reportChanges(),(0,n.toDisposable)(()=>{K.removeObserver(X)})}(0,R._setRecomputeInitiallyAndOnChange)(T);class H{constructor(Q,X){this._forceRecompute=Q,this._handleValue=X,this._counter=0}beginUpdate(Q){this._counter++}endUpdate(Q){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(Q.get()):Q.reportChanges())}handlePossibleChange(Q){}handleChange(Q,X){}}t.KeepAliveObserver=H;function W(K,Q){let X;return(0,w.derivedOpts)({owner:K,debugReferenceFn:Q},J=>(X=Q(J,X),X))}function U(K,Q){let X;const G=v("derivedObservableWithWritableCache"),J=(0,w.derived)(K,ce=>(G.read(ce),X=Q(ce,X),X));return Object.assign(J,{clearCache:ce=>{X=void 0,G.trigger(ce)},setCache:(ce,pe)=>{X=ce,G.trigger(pe)}})}function D(K,Q,X,G){let J=new x(X,G);return(0,w.derivedOpts)({debugReferenceFn:X,owner:K,onLastObserverRemoved:()=>{J.dispose(),J=new x(X)}},pe=>(J.setItems(Q.read(pe)),J.getItems()))}class x{constructor(Q,X){this._map=Q,this._keySelector=X,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(Q=>Q.store.dispose()),this._cache.clear()}setItems(Q){const X=[],G=new Set(this._cache.keys());for(const J of Q){const ce=this._keySelector?this._keySelector(J):J;let pe=this._cache.get(ce);if(pe)G.delete(ce);else{const Te=new n.DisposableStore;pe={out:this._map(J,Te),store:Te},this._cache.set(ce,pe)}X.push(pe.out)}for(const J of G)this._cache.get(J).store.dispose(),this._cache.delete(J);this._items=X}getItems(){return this._items}}class z{constructor(Q){this.observable=Q}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.ValueWithChangeEventFromObservable=z;function O(K,Q){return Q instanceof z?Q.observable:e(K,Q.onDidChange,()=>Q.value)}function P(K,Q){if(Q.length===0)throw new d.BugIndicatingError;let X=!1,G;const J=e(K,ce=>{const pe=new n.DisposableStore;for(const Te of Q)pe.add((0,k.autorunOpts)({debugName:()=>(0,N.getDebugName)(J,new N.DebugNameData(K,void 0,void 0))+".updateLastChangedValue"},Fe=>{X=!0,G=Te.read(Fe),ce()}));return pe.add({dispose(){X=!1,G=void 0}}),pe},()=>X?G:Q[Q.length-1].get());return J}}),define(De[62],we([1,0,28,46,45,102,101,97,32]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return R.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return R.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return R.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return R.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return R.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return R.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return R.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return R.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return R.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return R.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return R.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return N.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return N.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return N.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return N.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return N.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return N.derivedWithCancellationToken}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return w.observableValueOpts}}),!1&&(0,_.setLogger)(new _.ConsoleObservableLogger)}),define(De[20],we([1,0,3,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var k;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(k||(t.ScrollbarVisibility=k={}));class R{constructor(e,s,o,c,h,v,L){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,o=o|0,c=c|0,h=h|0,v=v|0,L=L|0),this.rawScrollLeft=c,this.rawScrollTop=L,s<0&&(s=0),c+s>o&&(c=o-s),c<0&&(c=0),h<0&&(h=0),L+h>v&&(L=v-h),L<0&&(L=0),this.width=s,this.scrollWidth=o,this.scrollLeft=c,this.height=h,this.scrollHeight=v,this.scrollTop=L}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new R(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new R(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,L=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:h,heightChanged:v,scrollHeightChanged:L,scrollTopChanged:S}}}t.ScrollState=R;class N extends n.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new R(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,s){const o=this._state.withScrollDimensions(e,s);this._setState(o,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const s=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(e,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const o=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===o.scrollLeft&&this._smoothScrolling.to.scrollTop===o.scrollTop)return;let c;s?c=new b(this._smoothScrolling.from,o,this._smoothScrolling.startTime,this._smoothScrolling.duration):c=this._smoothScrolling.combine(this._state,o,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=c}else{const o=this._state.withScrollPosition(e);this._smoothScrolling=b.start(this._state,o,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),s=this._state.withScrollPosition(e);if(this._setState(s,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,s){const o=this._state;o.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(o,s)))}}t.Scrollable=N;class w{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.SmoothScrollingUpdate=w;function _(m,e){const s=e-m;return function(o){return m+s*p(o)}}function d(m,e,s){return function(o){return o<s?m(o/s):e((o-s)/(1-s))}}class b{constructor(e,s,o,c){this.from=e,this.to=s,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,s,o){if(Math.abs(e-s)>2.5*o){let h,v;return e<s?(h=e+.75*o,v=s-.75*o):(h=e-.75*o,v=s+.75*o),d(_(e,h),_(v,s),.33)}return _(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.scrollLeft(s),c=this.scrollTop(s);return new w(o,c,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return b.start(e,s,o)}static start(e,s,o){o=o+10;const c=Date.now()-10;return new b(e,s,c,o)}}t.SmoothScrollingOperation=b;function y(m){return Math.pow(m,3)}function p(m){return 1-y(1-m)}}),define(De[103],we([1,0,6,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=k,t.isReadableStream=R,t.isReadableBufferedStream=N,t.newWriteableStream=w,t.consumeReadable=d,t.peekReadable=b,t.consumeStream=y,t.listenStream=p,t.peekStream=m,t.toStream=e,t.emptyStream=s,t.toReadable=o,t.transform=c,t.prefixedReadable=h,t.prefixedStream=v;function k(L){const S=L;return S?typeof S.read=="function":!1}function R(L){const S=L;return S?[S.on,S.pause,S.resume,S.destroy].every(r=>typeof r=="function"):!1}function N(L){const S=L;return S?R(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}function w(L,S){return new _(L,S)}class _{constructor(S,r){this.reducer=S,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(r=>r(S))}emitError(S){this.listeners.error.length===0?(0,i.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(r=>r(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,r){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(S,r){if(this.state.destroyed)return;let f;switch(S){case"data":f=this.listeners.data;break;case"end":f=this.listeners.end;break;case"error":f=this.listeners.error;break}if(f){const E=f.indexOf(r);E>=0&&f.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(f=>f())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(L,S){const r=[];let f;for(;(f=L.read())!==null;)r.push(f);return S(r)}function b(L,S,r){const f=[];let E;for(;(E=L.read())!==null&&f.length<r;)f.push(E);return E===null&&f.length>0?S(f):{read:()=>{if(f.length>0)return f.shift();if(typeof E<"u"){const T=E;return E=void 0,T}return L.read()}}}function y(L,S){return new Promise((r,f)=>{const E=[];p(L,{onData:T=>{S&&E.push(T)},onError:T=>{S?f(T):r(void 0)},onEnd:()=>{r(S?S(E):void 0)}})})}function p(L,S,r){L.on("error",f=>{r?.isCancellationRequested||S.onError(f)}),L.on("end",()=>{r?.isCancellationRequested||S.onEnd()}),L.on("data",f=>{r?.isCancellationRequested||S.onData(f)})}function m(L,S){return new Promise((r,f)=>{const E=new n.DisposableStore,T=[],H=D=>{if(T.push(D),T.length>S)return E.dispose(),L.pause(),r({stream:L,buffer:T,ended:!1})},W=D=>(E.dispose(),f(D)),U=()=>(E.dispose(),r({stream:L,buffer:T,ended:!0}));E.add((0,n.toDisposable)(()=>L.removeListener("error",W))),L.on("error",W),E.add((0,n.toDisposable)(()=>L.removeListener("end",U))),L.on("end",U),E.add((0,n.toDisposable)(()=>L.removeListener("data",H))),L.on("data",H)})}function e(L,S){const r=w(S);return r.end(L),r}function s(){const L=w(()=>{throw new Error("not supported")});return L.end(),L}function o(L){let S=!1;return{read:()=>S?null:(S=!0,L)}}function c(L,S,r){const f=w(r);return p(L,{onData:E=>f.write(S.data(E)),onError:E=>f.error(S.error?S.error(E):E),onEnd:()=>f.end()}),f}function h(L,S,r){let f=!1;return{read:()=>{const E=S.read();return f?E:(f=!0,E!==null?r([L,E]):L)}}}function v(L,S,r){let f=!1;const E=w(r);return p(S,{onData:T=>f?E.write(T):(f=!0,E.write(r([L,T]))),onError:T=>E.error(T),onEnd:()=>{f||(f=!0,E.write(L)),E.end()}}),E}}),define(De[48],we([1,0,26,103]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=d,t.readUInt16LE=b,t.writeUInt16LE=y,t.readUInt32BE=p,t.writeUInt32BE=m,t.readUInt32LE=e,t.writeUInt32LE=s,t.readUInt8=o,t.writeUInt8=c,t.readableToBuffer=h,t.bufferToReadable=v,t.streamToBuffer=L,t.bufferedStreamToBuffer=S,t.bufferToStream=r,t.streamToBufferReadableStream=f,t.newWriteableBufferStream=E,t.prefixedBufferReadable=T,t.prefixedBufferStream=H,t.decodeBase64=W,t.encodeBase64=x,n=Ue(n);const k=typeof Buffer<"u",R=new i.Lazy(()=>new Uint8Array(256));let N,w;class _{static alloc(O){return k?new _(Buffer.allocUnsafe(O)):new _(new Uint8Array(O))}static wrap(O){return k&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new _(O)}static fromString(O,P){return!(P?.dontUseNodeBuffer||!1)&&k?new _(Buffer.from(O)):(N||(N=new TextEncoder),new _(N.encode(O)))}static fromByteArray(O){const P=_.alloc(O.length);for(let K=0,Q=O.length;K<Q;K++)P.buffer[K]=O[K];return P}static concat(O,P){if(typeof P>"u"){P=0;for(let X=0,G=O.length;X<G;X++)P+=O[X].byteLength}const K=_.alloc(P);let Q=0;for(let X=0,G=O.length;X<G;X++){const J=O[X];K.set(J,Q),Q+=J.byteLength}return K}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=_.alloc(this.byteLength);return O.set(this),O}toString(){return k?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(O,P){return new _(this.buffer.subarray(O,P))}set(O,P){if(O instanceof _)this.buffer.set(O.buffer,P);else if(O instanceof Uint8Array)this.buffer.set(O,P);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),P);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return p(this.buffer,O)}writeUInt32BE(O,P){m(this.buffer,O,P)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,P){s(this.buffer,O,P)}readUInt8(O){return o(this.buffer,O)}writeUInt8(O,P){c(this.buffer,O,P)}indexOf(O,P=0){return d(this.buffer,O instanceof _?O.buffer:O,P)}}t.VSBuffer=_;function d(z,O,P=0){const K=O.byteLength,Q=z.byteLength;if(K===0)return 0;if(K===1)return z.indexOf(O[0]);if(K>Q-P)return-1;const X=R.value;X.fill(O.length);for(let pe=0;pe<O.length;pe++)X[O[pe]]=O.length-pe-1;let G=P+O.length-1,J=G,ce=-1;for(;G<Q;)if(z[G]===O[J]){if(J===0){ce=G;break}G--,J--}else G+=Math.max(O.length-J,X[z[G]]),J=O.length-1;return ce}function b(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0}function y(z,O,P){z[P+0]=O&255,O=O>>>8,z[P+1]=O&255}function p(z,O){return z[O]*2**24+z[O+1]*2**16+z[O+2]*2**8+z[O+3]}function m(z,O,P){z[P+3]=O,O=O>>>8,z[P+2]=O,O=O>>>8,z[P+1]=O,O=O>>>8,z[P]=O}function e(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0|z[O+2]<<16>>>0|z[O+3]<<24>>>0}function s(z,O,P){z[P+0]=O&255,O=O>>>8,z[P+1]=O&255,O=O>>>8,z[P+2]=O&255,O=O>>>8,z[P+3]=O&255}function o(z,O){return z[O]}function c(z,O,P){z[P]=O}function h(z){return n.consumeReadable(z,O=>_.concat(O))}function v(z){return n.toReadable(z)}function L(z){return n.consumeStream(z,O=>_.concat(O))}async function S(z){return z.ended?_.concat(z.buffer):_.concat([...z.buffer,await L(z.stream)])}function r(z){return n.toStream(z,O=>_.concat(O))}function f(z){return n.transform(z,{data:O=>typeof O=="string"?_.fromString(O):_.wrap(O)},O=>_.concat(O))}function E(z){return n.newWriteableStream(O=>_.concat(O),z)}function T(z,O){return n.prefixedReadable(z,O,P=>_.concat(P))}function H(z,O){return n.prefixedStream(z,O,P=>_.concat(P))}function W(z){let O=0,P=0,K=0;const Q=new Uint8Array(Math.floor(z.length/4*3)),X=J=>{switch(P){case 3:Q[K++]=O|J,P=0;break;case 2:Q[K++]=O|J>>>2,O=J<<6,P=3;break;case 1:Q[K++]=O|J>>>4,O=J<<4,P=2;break;default:O=J<<2,P=1}};for(let J=0;J<z.length;J++){const ce=z.charCodeAt(J);if(ce>=65&&ce<=90)X(ce-65);else if(ce>=97&&ce<=122)X(ce-97+26);else if(ce>=48&&ce<=57)X(ce-48+52);else if(ce===43||ce===45)X(62);else if(ce===47||ce===95)X(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${z[J]}`)}}const G=K;for(;P>0;)X(0);return _.wrap(Q).slice(0,G)}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:z},O=!0,P=!1){const K=P?D:U;let Q="";const X=z.byteLength%3;let G=0;for(;G<z.byteLength-X;G+=3){const J=z[G+0],ce=z[G+1],pe=z[G+2];Q+=K[J>>>2],Q+=K[(J<<4|ce>>>4)&63],Q+=K[(ce<<2|pe>>>6)&63],Q+=K[pe&63]}if(X===1){const J=z[G+0];Q+=K[J>>>2],Q+=K[J<<4&63],O&&(Q+="==")}else if(X===2){const J=z[G+0],ce=z[G+1];Q+=K[J>>>2],Q+=K[(J<<4|ce>>>4)&63],Q+=K[ce<<2&63],O&&(Q+="=")}return Q}}),define(De[63],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[10],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=n,t.isObject=k,t.isTypedArray=R,t.isNumber=N,t.isIterable=w,t.isBoolean=_,t.isUndefined=d,t.isDefined=b,t.isUndefinedOrNull=y,t.assertType=p,t.assertIsDefined=m,t.assertAllDefined=e,t.isEmptyObject=o,t.isFunction=c,t.areFunctions=h,t.validateConstraints=v,t.validateConstraint=L;function i(S){return typeof S=="string"}function n(S){return Array.isArray(S)&&S.every(r=>i(r))}function k(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}function R(S){const r=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof r}function N(S){return typeof S=="number"&&!isNaN(S)}function w(S){return!!S&&typeof S[Symbol.iterator]=="function"}function _(S){return S===!0||S===!1}function d(S){return typeof S>"u"}function b(S){return!y(S)}function y(S){return d(S)||S===null}function p(S,r){if(!S)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(S){if(y(S))throw new Error("Assertion Failed: argument is undefined or null");return S}function e(...S){const r=[];for(let f=0;f<S.length;f++){const E=S[f];if(y(E))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);r.push(E)}return r}const s=Object.prototype.hasOwnProperty;function o(S){if(!k(S))return!1;for(const r in S)if(s.call(S,r))return!1;return!0}function c(S){return typeof S=="function"}function h(...S){return S.length>0&&S.every(c)}function v(S,r){const f=Math.min(S.length,r.length);for(let E=0;E<f;E++)L(S[E],r[E])}function L(S,r){if(i(r)){if(typeof S!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(c(r)){try{if(S instanceof r)return}catch{}if(!y(S)&&S.constructor===r||r.length===1&&r.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(De[49],we([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=k,t.getCodiconFontCharacters=R;const n=Object.create(null);function k(N,w){if((0,i.isString)(w)){const _=n[w];if(_===void 0)throw new Error(`${N} references an unknown codicon: ${w}`);w=_}return n[N]=w,{id:N}}function R(){return n}}),define(De[104],we([1,0,49]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(De[21],we([1,0,49,104]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=k;function k(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...n.codiconsLibrary,...t.codiconsDerived}}),define(De[64],we([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=n,t.deepFreeze=k,t.cloneAndChange=N,t.mixin=_,t.equals=d,t.safeStringify=b,t.distinct=y,t.getCaseInsensitive=p,t.filter=m,t.getAllPropertyNames=e,t.getAllMethodNames=s,t.createProxyObject=o,t.mapValues=c;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([L,S])=>{v[L]=S&&typeof S=="object"?n(S):S}),v}function k(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const L=v.shift();Object.freeze(L);for(const S in L)if(R.call(L,S)){const r=L[S];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.isTypedArray)(r)&&v.push(r)}}return h}const R=Object.prototype.hasOwnProperty;function N(h,v){return w(h,v,new Set)}function w(h,v,L){if((0,i.isUndefinedOrNull)(h))return h;const S=v(h);if(typeof S<"u")return S;if(Array.isArray(h)){const r=[];for(const f of h)r.push(w(f,v,L));return r}if((0,i.isObject)(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const r={};for(const f in h)R.call(h,f)&&(r[f]=w(h[f],v,L));return L.delete(h),r}return h}function _(h,v,L=!0){return(0,i.isObject)(h)?((0,i.isObject)(v)&&Object.keys(v).forEach(S=>{S in h?L&&((0,i.isObject)(h[S])&&(0,i.isObject)(v[S])?_(h[S],v[S],L):h[S]=v[S]):h[S]=v[S]}),h):v}function d(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let L,S;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(L=0;L<h.length;L++)if(!d(h[L],v[L]))return!1}else{const r=[];for(S in h)r.push(S);r.sort();const f=[];for(S in v)f.push(S);if(f.sort(),!d(r,f))return!1;for(L=0;L<r.length;L++)if(!d(h[r[L]],v[r[L]]))return!1}return!0}function b(h){const v=new Set;return JSON.stringify(h,(L,S)=>{if((0,i.isObject)(S)||Array.isArray(S)){if(v.has(S))return"[Circular]";v.add(S)}return typeof S=="bigint"?`[BigInt ${S.toString()}]`:S})}function y(h,v){const L=Object.create(null);return!h||!v||Object.keys(v).forEach(r=>{const f=h[r],E=v[r];d(f,E)||(L[r]=E)}),L}function p(h,v){const L=v.toLowerCase(),S=Object.keys(h).find(r=>r.toLowerCase()===L);return S?h[S]:h[v]}function m(h,v){const L=Object.create(null);for(const[S,r]of Object.entries(h))v(S,r)&&(L[S]=r);return L}function e(h){let v=[];for(;Object.prototype!==h;)v=v.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return v}function s(h){const v=[];for(const L of e(h))typeof h[L]=="function"&&v.push(L);return v}function o(h,v){const L=r=>function(){const f=Array.prototype.slice.call(arguments,0);return v(r,f)},S={};for(const r of h)S[r]=L(r);return S}function c(h,v){const L={};for(const[S,r]of Object.entries(h))L[S]=v(r,S);return L}}),define(De[22],we([1,0,21]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=k;var n;(function(N){function w(_){return _&&typeof _=="object"&&typeof _.id=="string"}N.isThemeColor=w})(n||(t.ThemeColor=n={}));function k(N){return{id:N}}var R;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function _(h){const v=w.exec(h.id);if(!v)return _(i.Codicon.error);const[,L,S]=v,r=["codicon","codicon-"+L];return S&&r.push("codicon-modifier-"+S.substring(1)),r}N.asClassNameArray=_;function d(h){return _(h).join(" ")}N.asClassName=d;function b(h){return"."+_(h).join(".")}N.asCSSSelector=b;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||n.isThemeColor(h.color))}N.isThemeIcon=y;const p=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function m(h){const v=p.exec(h);if(!v)return;const[,L]=v;return{id:L}}N.fromString=m;function e(h){return{id:h}}N.fromId=e;function s(h,v){let L=h.id;const S=L.lastIndexOf("~");return S!==-1&&(L=L.substring(0,S)),v&&(L=`${L}~${v}`),{id:L}}N.modify=s;function o(h){const v=h.id.lastIndexOf("~");if(v!==-1)return h.id.substring(v+1)}N.getModifier=o;function c(h,v){return h.id===v.id&&h.color?.id===v.color?.id}N.isEqual=c})(R||(t.ThemeIcon=R={}))}),define(De[65],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=n,t.toUint32=k;var i;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(R){return R<0?0:R>i.MAX_UINT_8?i.MAX_UINT_8:R|0}function k(R){return R<0?0:R>i.MAX_UINT_32?i.MAX_UINT_32:R|0}}),define(De[11],we([1,0,100,18,26,65]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=N,t.format=_,t.format2=b,t.htmlAttributeEncodeValue=y,t.escape=p,t.escapeRegExpCharacters=m,t.count=e,t.truncate=s,t.truncateMiddle=o,t.trim=c,t.ltrim=h,t.rtrim=v,t.convertSimple2RegExpPattern=L,t.stripWildcards=S,t.createRegExp=r,t.regExpLeadsToEndlessLoop=f,t.splitLines=E,t.splitLinesIncludeSeparators=T,t.firstNonWhitespaceIndex=H,t.getLeadingWhitespace=W,t.lastNonWhitespaceIndex=U,t.replaceAsync=D,t.compare=x,t.compareSubstring=z,t.compareIgnoreCase=O,t.compareSubstringIgnoreCase=P,t.isAsciiDigit=K,t.isLowerAsciiLetter=Q,t.isUpperAsciiLetter=X,t.equalsIgnoreCase=G,t.startsWithIgnoreCase=J,t.commonPrefixLength=ce,t.commonSuffixLength=pe,t.isHighSurrogate=Te,t.isLowSurrogate=Fe,t.computeCodePoint=re,t.getNextCodePoint=ee,t.nextCharLength=te,t.prevCharLength=be,t.getCharContainingOffset=Se,t.charCount=Oe,t.containsRTL=oe,t.isBasicASCII=B,t.containsUnusualLineTerminators=l,t.isFullWidthCharacter=a,t.isEmojiImprecise=g,t.lcut=C,t.forAnsiStringParts=u,t.removeAnsiEscapeCodes=I,t.removeAnsiEscapeCodesFromPrompt=M,t.startsWithUTF8BOM=V,t.stripUTF8BOM=Y,t.fuzzyContains=ie,t.containsUppercaseCharacter=ae,t.uppercaseFirstLetter=fe,t.getNLines=_e,t.singleLetterHash=Ee,t.getGraphemeBreakType=Le,t.getLeftDeleteOffset=Xe;function N(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const w=/{(\d+)}/g;function _(Z,...ue){return ue.length===0?Z:Z.replace(w,function(ve,Ae){const Pe=parseInt(Ae,10);return isNaN(Pe)||Pe<0||Pe>=ue.length?ve:ue[Pe]})}const d=/{([^}]+)}/g;function b(Z,ue){return Object.keys(ue).length===0?Z:Z.replace(d,(ve,Ae)=>ue[Ae]??ve)}function y(Z){return Z.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function p(Z){return Z.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(Z,ue){let ve=0,Ae=Z.indexOf(ue);for(;Ae!==-1;)ve++,Ae=Z.indexOf(ue,Ae+ue.length);return ve}function s(Z,ue,ve="\u2026"){return Z.length<=ue?Z:`${Z.substr(0,ue)}${ve}`}function o(Z,ue,ve="\u2026"){if(Z.length<=ue)return Z;const Ae=Math.ceil(ue/2)-ve.length/2,Pe=Math.floor(ue/2)-ve.length/2;return`${Z.substr(0,Ae)}${ve}${Z.substr(Z.length-Pe)}`}function c(Z,ue=" "){const ve=h(Z,ue);return v(ve,ue)}function h(Z,ue){if(!Z||!ue)return Z;const ve=ue.length;if(ve===0||Z.length===0)return Z;let Ae=0;for(;Z.indexOf(ue,Ae)===Ae;)Ae=Ae+ve;return Z.substring(Ae)}function v(Z,ue){if(!Z||!ue)return Z;const ve=ue.length,Ae=Z.length;if(ve===0||Ae===0)return Z;let Pe=Ae,Ve=-1;for(;Ve=Z.lastIndexOf(ue,Pe-1),!(Ve===-1||Ve+ve!==Pe);){if(Ve===0)return"";Pe=Ve}return Z.substring(0,Pe)}function L(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function S(Z){return Z.replace(/\*/g,"")}function r(Z,ue,ve={}){if(!Z)throw new Error("Cannot create regex from empty string");ue||(Z=m(Z)),ve.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let Ae="";return ve.global&&(Ae+="g"),ve.matchCase||(Ae+="i"),ve.multiline&&(Ae+="m"),ve.unicode&&(Ae+="u"),new RegExp(Z,Ae)}function f(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function E(Z){return Z.split(/\r\n|\r|\n/)}function T(Z){const ue=[],ve=Z.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil(ve.length/2);Ae++)ue.push(ve[2*Ae]+(ve[2*Ae+1]??""));return ue}function H(Z){for(let ue=0,ve=Z.length;ue<ve;ue++){const Ae=Z.charCodeAt(ue);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return ue}return-1}function W(Z,ue=0,ve=Z.length){for(let Ae=ue;Ae<ve;Ae++){const Pe=Z.charCodeAt(Ae);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return Z.substring(ue,Ae)}return Z.substring(ue,ve)}function U(Z,ue=Z.length-1){for(let ve=ue;ve>=0;ve--){const Ae=Z.charCodeAt(ve);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return ve}return-1}function D(Z,ue,ve){const Ae=[];let Pe=0;for(const Ve of Z.matchAll(ue)){if(Ae.push(Z.slice(Pe,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Pe=Ve.index+Ve[0].length,Ae.push(ve(Ve[0],...Ve.slice(1),Ve.index,Z,Ve.groups))}return Ae.push(Z.slice(Pe)),Promise.all(Ae).then(Ve=>Ve.join(""))}function x(Z,ue){return Z<ue?-1:Z>ue?1:0}function z(Z,ue,ve=0,Ae=Z.length,Pe=0,Ve=ue.length){for(;ve<Ae&&Pe<Ve;ve++,Pe++){const nt=Z.charCodeAt(ve),ct=ue.charCodeAt(Pe);if(nt<ct)return-1;if(nt>ct)return 1}const Qe=Ae-ve,ot=Ve-Pe;return Qe<ot?-1:Qe>ot?1:0}function O(Z,ue){return P(Z,ue,0,Z.length,0,ue.length)}function P(Z,ue,ve=0,Ae=Z.length,Pe=0,Ve=ue.length){for(;ve<Ae&&Pe<Ve;ve++,Pe++){let nt=Z.charCodeAt(ve),ct=ue.charCodeAt(Pe);if(nt===ct)continue;if(nt>=128||ct>=128)return z(Z.toLowerCase(),ue.toLowerCase(),ve,Ae,Pe,Ve);Q(nt)&&(nt-=32),Q(ct)&&(ct-=32);const st=nt-ct;if(st!==0)return st}const Qe=Ae-ve,ot=Ve-Pe;return Qe<ot?-1:Qe>ot?1:0}function K(Z){return Z>=n.CharCode.Digit0&&Z<=n.CharCode.Digit9}function Q(Z){return Z>=n.CharCode.a&&Z<=n.CharCode.z}function X(Z){return Z>=n.CharCode.A&&Z<=n.CharCode.Z}function G(Z,ue){return Z.length===ue.length&&P(Z,ue)===0}function J(Z,ue){const ve=ue.length;return ue.length>Z.length?!1:P(Z,ue,0,ve)===0}function ce(Z,ue){const ve=Math.min(Z.length,ue.length);let Ae;for(Ae=0;Ae<ve;Ae++)if(Z.charCodeAt(Ae)!==ue.charCodeAt(Ae))return Ae;return ve}function pe(Z,ue){const ve=Math.min(Z.length,ue.length);let Ae;const Pe=Z.length-1,Ve=ue.length-1;for(Ae=0;Ae<ve;Ae++)if(Z.charCodeAt(Pe-Ae)!==ue.charCodeAt(Ve-Ae))return Ae;return ve}function Te(Z){return 55296<=Z&&Z<=56319}function Fe(Z){return 56320<=Z&&Z<=57343}function re(Z,ue){return(Z-55296<<10)+(ue-56320)+65536}function ee(Z,ue,ve){const Ae=Z.charCodeAt(ve);if(Te(Ae)&&ve+1<ue){const Pe=Z.charCodeAt(ve+1);if(Fe(Pe))return re(Ae,Pe)}return Ae}function he(Z,ue){const ve=Z.charCodeAt(ue-1);if(Fe(ve)&&ue>1){const Ae=Z.charCodeAt(ue-2);if(Te(Ae))return re(Ae,ve)}return ve}class le{get offset(){return this._offset}constructor(ue,ve=0){this._str=ue,this._len=ue.length,this._offset=ve}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=he(this._str,this._offset);return this._offset-=ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}nextCodePoint(){const ue=ee(this._str,this._len,this._offset);return this._offset+=ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}eol(){return this._offset>=this._len}}t.CodePointIterator=le;class Ne{get offset(){return this._iterator.offset}constructor(ue,ve=0){this._iterator=new le(ue,ve)}nextGraphemeLength(){const ue=Ce.getInstance(),ve=this._iterator,Ae=ve.offset;let Pe=ue.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Ve=ve.offset,Qe=ue.getGraphemeBreakType(ve.nextCodePoint());if(Ie(Pe,Qe)){ve.setOffset(Ve);break}Pe=Qe}return ve.offset-Ae}prevGraphemeLength(){const ue=Ce.getInstance(),ve=this._iterator,Ae=ve.offset;let Pe=ue.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Ve=ve.offset,Qe=ue.getGraphemeBreakType(ve.prevCodePoint());if(Ie(Qe,Pe)){ve.setOffset(Ve);break}Pe=Qe}return Ae-ve.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Ne;function te(Z,ue){return new Ne(Z,ue).nextGraphemeLength()}function be(Z,ue){return new Ne(Z,ue).prevGraphemeLength()}function Se(Z,ue){ue>0&&Fe(Z.charCodeAt(ue))&&ue--;const ve=ue+te(Z,ue);return[ve-be(Z,ve),ve]}function Oe(Z){const ue=new Ne(Z);let ve=0;for(;!ue.eol();)ve++,ue.nextGraphemeLength();return ve}let Re;function We(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Z){return Re||(Re=We()),Re.test(Z)}const q=/^[\t\n\r\x20-\x7E]*$/;function B(Z){return q.test(Z)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function l(Z){return t.UNUSUAL_LINE_TERMINATORS.test(Z)}function a(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function g(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function C(Z,ue,ve=""){const Ae=Z.trimStart();if(Ae.length<ue)return Ae;const Pe=/\b/g;let Ve=0;for(;Pe.test(Ae)&&!(Ae.length-Pe.lastIndex<ue);)Ve=Pe.lastIndex,Pe.lastIndex+=1;return Ve===0?Ae:ve+Ae.substring(Ve).trimStart()}const F=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(Z){let ue=0;for(const ve of Z.matchAll(F))ue!==ve.index&&(yield{isCode:!1,str:Z.substring(ue,ve.index)}),yield{isCode:!0,str:ve[0]},ue=ve.index+ve[0].length;ue!==Z.length&&(yield{isCode:!1,str:Z.substring(ue)})}function I(Z){return Z&&(Z=Z.replace(F,"")),Z}const A=/\\\[.*?\\\]/g;function M(Z){return I(Z).replace(A,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function V(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===n.CharCode.UTF8_BOM)}function Y(Z){return V(Z)?Z.substr(1):Z}function ie(Z,ue){if(!Z||!ue||Z.length<ue.length)return!1;const ve=ue.length,Ae=Z.toLowerCase();let Pe=0,Ve=-1;for(;Pe<ve;){const Qe=Ae.indexOf(ue[Pe],Ve+1);if(Qe<0)return!1;Ve=Qe,Pe++}return!0}function ae(Z,ue=!1){return Z?(ue&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function fe(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function _e(Z,ue=1){if(ue===0)return"";let ve=-1;do ve=Z.indexOf(`
`,ve+1),ue--;while(ue>0&&ve>=0);return ve===-1?Z:(Z[ve-1]==="\r"&&ve--,Z.substr(0,ve))}function Ee(Z){const ue=n.CharCode.Z-n.CharCode.A+1;return Z=Z%(2*ue),Z<ue?String.fromCharCode(n.CharCode.a+Z):String.fromCharCode(n.CharCode.A+Z-ue)}function Le(Z){return Ce.getInstance().getGraphemeBreakType(Z)}function Ie(Z,ue){return Z===de.Other?ue!==de.Extend&&ue!==de.SpacingMark:Z===de.CR&&ue===de.LF?!1:Z===de.Control||Z===de.CR||Z===de.LF||ue===de.Control||ue===de.CR||ue===de.LF?!0:!(Z===de.L&&(ue===de.L||ue===de.V||ue===de.LV||ue===de.LVT)||(Z===de.LV||Z===de.V)&&(ue===de.V||ue===de.T)||(Z===de.LVT||Z===de.T)&&ue===de.T||ue===de.Extend||ue===de.ZWJ||ue===de.SpacingMark||Z===de.Prepend||Z===de.ZWJ&&ue===de.Extended_Pictographic||Z===de.Regional_Indicator&&ue===de.Regional_Indicator)}var de;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(de||(t.GraphemeBreakType=de={}));class Ce{static{this._INSTANCE=null}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(ue){if(ue<32)return ue===n.CharCode.LineFeed?de.LF:ue===n.CharCode.CarriageReturn?de.CR:de.Control;if(ue<127)return de.Other;const ve=this._data,Ae=ve.length/3;let Pe=1;for(;Pe<=Ae;)if(ue<ve[3*Pe])Pe=2*Pe;else if(ue>ve[3*Pe+1])Pe=2*Pe+1;else return ve[3*Pe+2];return de.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Z,ue){if(Z===0)return 0;const ve=tt(Z,ue);if(ve!==void 0)return ve;const Ae=new le(ue,Z);return Ae.prevCodePoint(),Ae.offset}function tt(Z,ue){const ve=new le(ue,Z);let Ae=ve.prevCodePoint();for(;lt(Ae)||Ae===rt.emojiVariantSelector||Ae===rt.enclosingKeyCap;){if(ve.offset===0)return;Ae=ve.prevCodePoint()}if(!g(Ae))return;let Pe=ve.offset;return Pe>0&&ve.prevCodePoint()===rt.zwj&&(Pe=ve.offset),Pe}function lt(Z){return 127995<=Z&&Z<=127999}var rt;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),t.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},ue=>{function ve(st){const dt=new Map;for(let ht=0;ht<st.length;ht+=2)dt.set(st[ht],st[ht+1]);return dt}function Ae(st,dt){const ht=new Map(st);for(const[Dt,ze]of dt)ht.set(Dt,ze);return ht}function Pe(st,dt){if(!st)return dt;const ht=new Map;for(const[Dt,ze]of st)dt.has(Dt)&&ht.set(Dt,ze);return ht}const Ve=this.ambiguousCharacterData.value;let Qe=ue.filter(st=>!st.startsWith("_")&&st in Ve);Qe.length===0&&(Qe=["_default"]);let ot;for(const st of Qe){const dt=ve(Ve[st]);ot=Pe(ot,dt)}const nt=ve(Ve._common),ct=Ae(nt,ot);return new je(ct)})}static getInstance(ue){return je.cache.get(Array.from(ue))}static{this._locales=new k.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return je._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}containsAmbiguousCharacter(ue){for(let ve=0;ve<ue.length;ve++){const Ae=ue.codePointAt(ve);if(typeof Ae=="number"&&this.isAmbiguous(Ae))return!0}return!1}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je;class Ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ze.getRawData())),this._data}static isInvisibleCharacter(ue){return Ze.getData().has(ue)}static containsInvisibleCharacter(ue){for(let ve=0;ve<ue.length;ve++){const Ae=ue.codePointAt(ve);if(typeof Ae=="number"&&Ze.isInvisibleCharacter(Ae))return!0}return!1}static get codePoints(){return Ze.getData()}}t.InvisibleCharacters=Ze}),define(De[50],we([1,0,18,44,93,11]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=N,t.matchesContiguousSubString=_,t.matchesSubString=d,t.isUpper=p,t.matchesCamelCase=U,t.matchesWords=D,t.matchesFuzzy=Q,t.matchesFuzzy2=X,t.anyScore=G,t.createMatches=J,t.isPatternInWord=We,t.fuzzyScore=l,t.fuzzyScoreGracefulAggressive=C,t.fuzzyScoreGraceful=F,R=Ue(R);function N(...A){return function(M,V){for(let Y=0,ie=A.length;Y<ie;Y++){const ae=A[Y](M,V);if(ae)return ae}return null}}t.matchesStrictPrefix=w.bind(void 0,!1),t.matchesPrefix=w.bind(void 0,!0);function w(A,M,V){if(!V||V.length<M.length)return null;let Y;return A?Y=R.startsWithIgnoreCase(V,M):Y=V.indexOf(M)===0,Y?M.length>0?[{start:0,end:M.length}]:[]:null}function _(A,M){const V=M.toLowerCase().indexOf(A.toLowerCase());return V===-1?null:[{start:V,end:V+A.length}]}function d(A,M){return b(A.toLowerCase(),M.toLowerCase(),0,0)}function b(A,M,V,Y){if(V===A.length)return[];if(Y===M.length)return null;if(A[V]===M[Y]){let ie=null;return(ie=b(A,M,V+1,Y+1))?S({start:Y,end:Y+1},ie):null}return b(A,M,V,Y+1)}function y(A){return i.CharCode.a<=A&&A<=i.CharCode.z}function p(A){return i.CharCode.A<=A&&A<=i.CharCode.Z}function m(A){return i.CharCode.Digit0<=A&&A<=i.CharCode.Digit9}function e(A){return A===i.CharCode.Space||A===i.CharCode.Tab||A===i.CharCode.LineFeed||A===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>s.add(A.charCodeAt(0)));function o(A){return e(A)||s.has(A)}function c(A,M){return A===M||o(A)&&o(M)}const h=new Map;function v(A){if(h.has(A))return h.get(A);let M;const V=(0,k.getKoreanAltChars)(A);return V&&(M=V),h.set(A,M),M}function L(A){return y(A)||p(A)||m(A)}function S(A,M){return M.length===0?M=[A]:A.end===M[0].start?M[0].start=A.start:M.unshift(A),M}function r(A,M){for(let V=M;V<A.length;V++){const Y=A.charCodeAt(V);if(p(Y)||m(Y)||V>0&&!L(A.charCodeAt(V-1)))return V}return A.length}function f(A,M,V,Y){if(V===A.length)return[];if(Y===M.length)return null;if(A[V]!==M[Y].toLowerCase())return null;{let ie=null,ae=Y+1;for(ie=f(A,M,V+1,Y+1);!ie&&(ae=r(M,ae))<M.length;)ie=f(A,M,V+1,ae),ae++;return ie===null?null:S({start:Y,end:Y+1},ie)}}function E(A){let M=0,V=0,Y=0,ie=0,ae=0;for(let Ie=0;Ie<A.length;Ie++)ae=A.charCodeAt(Ie),p(ae)&&M++,y(ae)&&V++,L(ae)&&Y++,m(ae)&&ie++;const fe=M/A.length,_e=V/A.length,Ee=Y/A.length,Le=ie/A.length;return{upperPercent:fe,lowerPercent:_e,alphaPercent:Ee,numericPercent:Le}}function T(A){const{upperPercent:M,lowerPercent:V}=A;return V===0&&M>.6}function H(A){const{upperPercent:M,lowerPercent:V,alphaPercent:Y,numericPercent:ie}=A;return V>.2&&M<.8&&Y>.6&&ie<.2}function W(A){let M=0,V=0,Y=0,ie=0;for(let ae=0;ae<A.length;ae++)Y=A.charCodeAt(ae),p(Y)&&M++,y(Y)&&V++,e(Y)&&ie++;return(M===0||V===0)&&ie===0?A.length<=30:M<=5}function U(A,M){if(!M||(M=M.trim(),M.length===0)||!W(A))return null;M.length>60&&(M=M.substring(0,60));const V=E(M);if(!H(V)){if(!T(V))return null;M=M.toLowerCase()}let Y=null,ie=0;for(A=A.toLowerCase();ie<M.length&&(Y=f(A,M,0,ie))===null;)ie=r(M,ie+1);return Y}function D(A,M,V=!1){if(!M||M.length===0)return null;let Y=null,ie=0;for(A=A.toLowerCase(),M=M.toLowerCase();ie<M.length&&(Y=x(A,M,0,ie,V),Y===null);)ie=z(M,ie+1);return Y}function x(A,M,V,Y,ie){let ae=0;if(V===A.length)return[];if(Y===M.length)return null;if(!c(A.charCodeAt(V),M.charCodeAt(Y))){const Ee=v(A.charCodeAt(V));if(!Ee)return null;for(let Le=0;Le<Ee.length;Le++)if(!c(Ee[Le],M.charCodeAt(Y+Le)))return null;ae+=Ee.length-1}let fe=null,_e=Y+ae+1;if(fe=x(A,M,V+1,_e,ie),!ie)for(;!fe&&(_e=z(M,_e))<M.length;)fe=x(A,M,V+1,_e,ie),_e++;if(!fe)return null;if(A.charCodeAt(V)!==M.charCodeAt(Y)){const Ee=v(A.charCodeAt(V));if(!Ee)return fe;for(let Le=0;Le<Ee.length;Le++)if(Ee[Le]!==M.charCodeAt(Y+Le))return fe}return S({start:Y,end:Y+ae+1},fe)}function z(A,M){for(let V=M;V<A.length;V++)if(o(A.charCodeAt(V))||V>0&&o(A.charCodeAt(V-1)))return V;return A.length}const O=N(t.matchesPrefix,U,_),P=N(t.matchesPrefix,U,d),K=new n.LRUCache(1e4);function Q(A,M,V=!1){if(typeof A!="string"||typeof M!="string")return null;let Y=K.get(A);Y||(Y=new RegExp(R.convertSimple2RegExpPattern(A),"i"),K.set(A,Y));const ie=Y.exec(M);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:V?P(A,M):O(A,M)}function X(A,M){const V=l(A,A.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?J(V):null}function G(A,M,V,Y,ie,ae){const fe=Math.min(13,A.length);for(;V<fe;V++){const _e=l(A,M,V,Y,ie,ae,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_e)return _e}return[0,ae]}function J(A){if(typeof A>"u")return[];const M=[],V=A[1];for(let Y=A.length-1;Y>1;Y--){const ie=A[Y]+V,ae=M[M.length-1];ae&&ae.end===ie?ae.end=ie+1:M.push({start:ie,end:ie+1})}return M}const ce=128;function pe(){const A=[],M=[];for(let V=0;V<=ce;V++)M[V]=0;for(let V=0;V<=ce;V++)A.push(M.slice(0));return A}function Te(A){const M=[];for(let V=0;V<=A;V++)M[V]=0;return M}const Fe=Te(2*ce),re=Te(2*ce),ee=pe(),he=pe(),le=pe(),Ne=!1;function te(A,M,V,Y,ie){function ae(_e,Ee,Le=" "){for(;_e.length<Ee;)_e=Le+_e;return _e}let fe=` |   |${Y.split("").map(_e=>ae(_e,3)).join("|")}
`;for(let _e=0;_e<=V;_e++)_e===0?fe+=" |":fe+=`${M[_e-1]}|`,fe+=A[_e].slice(0,ie+1).map(Ee=>ae(Ee.toString(),3)).join("|")+`
`;return fe}function be(A,M,V,Y){A=A.substr(M),V=V.substr(Y),console.log(te(he,A,A.length,V,V.length)),console.log(te(le,A,A.length,V,V.length)),console.log(te(ee,A,A.length,V,V.length))}function Se(A,M){if(M<0||M>=A.length)return!1;const V=A.codePointAt(M);switch(V){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(V)}}function Oe(A,M){if(M<0||M>=A.length)return!1;switch(A.charCodeAt(M)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Re(A,M,V){return M[A]!==V[A]}function We(A,M,V,Y,ie,ae,fe=!1){for(;M<V&&ie<ae;)A[M]===Y[ie]&&(fe&&(Fe[M]=ie),M+=1),ie+=1;return M===V}var oe;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var q;(function(A){A.Default=[-100,0];function M(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}A.isDefault=M})(q||(t.FuzzyScore=q={}));class B{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(M,V){this.firstMatchCanBeWeak=M,this.boostFullMatch=V}}t.FuzzyScoreOptions=B;function l(A,M,V,Y,ie,ae,fe=B.default){const _e=A.length>ce?ce:A.length,Ee=Y.length>ce?ce:Y.length;if(V>=_e||ae>=Ee||_e-V>Ee-ae||!We(M,V,_e,ie,ae,Ee,!0))return;a(_e,Ee,V,ae,M,ie);let Le=1,Ie=1,de=V,Ce=ae;const qe=[!1];for(Le=1,de=V;de<_e;Le++,de++){const je=Fe[de],Ze=re[de],Z=de+1<_e?re[de+1]:Ee;for(Ie=je-ae+1,Ce=je;Ce<Z;Ie++,Ce++){let ue=Number.MIN_SAFE_INTEGER,ve=!1;Ce<=Ze&&(ue=g(A,M,de,V,Y,ie,Ce,Ee,ae,ee[Le-1][Ie-1]===0,qe));let Ae=0;ue!==Number.MAX_SAFE_INTEGER&&(ve=!0,Ae=ue+he[Le-1][Ie-1]);const Pe=Ce>je,Ve=Pe?he[Le][Ie-1]+(ee[Le][Ie-1]>0?-5:0):0,Qe=Ce>je+1&&ee[Le][Ie-1]>0,ot=Qe?he[Le][Ie-2]+(ee[Le][Ie-2]>0?-5:0):0;if(Qe&&(!Pe||ot>=Ve)&&(!ve||ot>=Ae))he[Le][Ie]=ot,le[Le][Ie]=oe.LeftLeft,ee[Le][Ie]=0;else if(Pe&&(!ve||Ve>=Ae))he[Le][Ie]=Ve,le[Le][Ie]=oe.Left,ee[Le][Ie]=0;else if(ve)he[Le][Ie]=Ae,le[Le][Ie]=oe.Diag,ee[Le][Ie]=ee[Le-1][Ie-1]+1;else throw new Error("not possible")}}if(Ne&&be(A,V,Y,ae),!qe[0]&&!fe.firstMatchCanBeWeak)return;Le--,Ie--;const Xe=[he[Le][Ie],ae];let tt=0,lt=0;for(;Le>=1;){let je=Ie;do{const Ze=le[Le][je];if(Ze===oe.LeftLeft)je=je-2;else if(Ze===oe.Left)je=je-1;else break}while(je>=1);tt>1&&M[V+Le-1]===ie[ae+Ie-1]&&!Re(je+ae-1,Y,ie)&&tt+1>ee[Le][je]&&(je=Ie),je===Ie?tt++:tt=1,lt||(lt=je),Le--,Ie=je-1,Xe.push(Ie)}Ee-ae===_e&&fe.boostFullMatch&&(Xe[0]+=2);const rt=lt-_e;return Xe[0]-=rt,Xe}function a(A,M,V,Y,ie,ae){let fe=A-1,_e=M-1;for(;fe>=V&&_e>=Y;)ie[fe]===ae[_e]&&(re[fe]=_e,fe--),_e--}function g(A,M,V,Y,ie,ae,fe,_e,Ee,Le,Ie){if(M[V]!==ae[fe])return Number.MIN_SAFE_INTEGER;let de=1,Ce=!1;return fe===V-Y?de=A[V]===ie[fe]?7:5:Re(fe,ie,ae)&&(fe===0||!Re(fe-1,ie,ae))?(de=A[V]===ie[fe]?7:5,Ce=!0):Se(ae,fe)&&(fe===0||!Se(ae,fe-1))?de=5:(Se(ae,fe-1)||Oe(ae,fe-1))&&(de=5,Ce=!0),de>1&&V===Y&&(Ie[0]=!0),Ce||(Ce=Re(fe,ie,ae)||Se(ae,fe-1)||Oe(ae,fe-1)),V===Y?fe>Ee&&(de-=Ce?3:5):Le?de+=Ce?2:0:de+=Ce?0:1,fe+1===_e&&(de-=Ce?3:5),de}function C(A,M,V,Y,ie,ae,fe){return u(A,M,V,Y,ie,ae,!0,fe)}function F(A,M,V,Y,ie,ae,fe){return u(A,M,V,Y,ie,ae,!1,fe)}function u(A,M,V,Y,ie,ae,fe,_e){let Ee=l(A,M,V,Y,ie,ae,_e);if(Ee&&!fe)return Ee;if(A.length>=3){const Le=Math.min(7,A.length-1);for(let Ie=V+1;Ie<Le;Ie++){const de=I(A,Ie);if(de){const Ce=l(de,de.toLowerCase(),V,Y,ie,ae,_e);Ce&&(Ce[0]-=3,(!Ee||Ce[0]>Ee[0])&&(Ee=Ce))}}}return Ee}function I(A,M){if(M+1>=A.length)return;const V=A[M],Y=A[M+1];if(V!==Y)return A.slice(0,M)+Y+V+A.slice(M+2)}}),define(De[66],we([1,0,11]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=n,t.doHash=k,t.numberHash=R,t.stringHash=w,t.toHexString=s,i=Ue(i);function n(c){return k(c,0)}function k(c,h){switch(typeof c){case"object":return c===null?R(349,h):Array.isArray(c)?_(c,h):d(c,h);case"string":return w(c,h);case"boolean":return N(c,h);case"number":return R(c,h);case"undefined":return R(937,h);default:return R(617,h)}}function R(c,h){return(h<<5)-h+c|0}function N(c,h){return R(c?433:863,h)}function w(c,h){h=R(149417,h);for(let v=0,L=c.length;v<L;v++)h=R(c.charCodeAt(v),h);return h}function _(c,h){return h=R(104579,h),c.reduce((v,L)=>k(L,v),h)}function d(c,h){return h=R(181387,h),Object.keys(c).sort().reduce((v,L)=>(v=w(L,v),k(c[L],v)),h)}class b{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=k(h,this._value),this._value}}t.Hasher=b;var y;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(c,h,v=32){const L=v-h,S=~((1<<L)-1);return(c<<h|(S&c)>>>L)>>>0}function m(c,h=0,v=c.byteLength,L=0){for(let S=0;S<v;S++)c[h+S]=L}function e(c,h,v="0"){for(;c.length<h;)c=v+c;return c}function s(c,h=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),h/4)}class o{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(y.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const v=h.length;if(v===0)return;const L=this._buff;let S=this._buffLen,r=this._leftoverHighSurrogate,f,E;for(r!==0?(f=r,E=-1,r=0):(f=h.charCodeAt(0),E=0);;){let T=f;if(i.isHighSurrogate(f))if(E+1<v){const H=h.charCodeAt(E+1);i.isLowSurrogate(H)?(E++,T=i.computeCodePoint(f,H)):T=y.UNICODE_REPLACEMENT}else{r=f;break}else i.isLowSurrogate(f)&&(T=y.UNICODE_REPLACEMENT);if(S=this._push(L,S,T),E++,E<v)f=h.charCodeAt(E);else break}this._buffLen=S,this._leftoverHighSurrogate=r}_push(h,v,L){return L<128?h[v++]=L:L<2048?(h[v++]=192|(L&1984)>>>6,h[v++]=128|(L&63)>>>0):L<65536?(h[v++]=224|(L&61440)>>>12,h[v++]=128|(L&4032)>>>6,h[v++]=128|(L&63)>>>0):(h[v++]=240|(L&1835008)>>>18,h[v++]=128|(L&258048)>>>12,h[v++]=128|(L&4032)>>>6,h[v++]=128|(L&63)>>>0),v>=y.BLOCK_SIZE&&(this._step(),v-=y.BLOCK_SIZE,this._totalLen+=y.BLOCK_SIZE,h[0]=h[y.BLOCK_SIZE+0],h[1]=h[y.BLOCK_SIZE+1],h[2]=h[y.BLOCK_SIZE+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,y.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=o._bigBlock32,v=this._buffDV;for(let U=0;U<64;U+=4)h.setUint32(U,v.getUint32(U,!1),!1);for(let U=64;U<320;U+=4)h.setUint32(U,p(h.getUint32(U-12,!1)^h.getUint32(U-32,!1)^h.getUint32(U-56,!1)^h.getUint32(U-64,!1),1),!1);let L=this._h0,S=this._h1,r=this._h2,f=this._h3,E=this._h4,T,H,W;for(let U=0;U<80;U++)U<20?(T=S&r|~S&f,H=1518500249):U<40?(T=S^r^f,H=1859775393):U<60?(T=S&r|S&f|r&f,H=2400959708):(T=S^r^f,H=3395469782),W=p(L,5)+T+E+H+h.getUint32(U*4,!1)&4294967295,E=f,f=r,r=p(S,30),S=L,L=W;this._h0=this._h0+L&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+E&4294967295}}t.StringSHA1=o}),define(De[105],we([1,0,90,66,65]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=N;class R{constructor(m){this.source=m}getElements(){const m=this.source,e=new Int32Array(m.length);for(let s=0,o=m.length;s<o;s++)e[s]=m.charCodeAt(s);return e}}t.StringDiffSequence=R;function N(p,m,e){return new y(new R(p),new R(m)).ComputeDiff(e).changes}class w{static Assert(m,e){if(!m)throw new Error(e)}}class _{static Copy(m,e,s,o,c){for(let h=0;h<c;h++)s[o+h]=m[e+h]}static Copy2(m,e,s,o,c){for(let h=0;h<c;h++)s[o+h]=m[e+h]}}var d;(function(p){p[p.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class b{constructor(){this.m_changes=[],this.m_originalStart=k.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=k.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=k.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=k.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class y{constructor(m,e,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=m,this._modifiedSequence=e;const[o,c,h]=y._getElements(m),[v,L,S]=y._getElements(e);this._hasStrings=h&&S,this._originalStringElements=o,this._originalElementsOrHash=c,this._modifiedStringElements=v,this._modifiedElementsOrHash=L,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const e=m.getElements();if(y._isStringArray(e)){const s=new Int32Array(e.length);for(let o=0,c=e.length;o<c;o++)s[o]=(0,n.stringHash)(e[o],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(m,e){if(!this.ElementsAreEqual(m,e))return!1;const s=y._getStrictElement(this._originalSequence,m),o=y._getStrictElement(this._modifiedSequence,e);return s===o}static _getStrictElement(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}OriginalElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(m,e){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[e]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,e,s,o,c){const h=[!1];let v=this.ComputeDiffRecursive(m,e,s,o,h);return c&&(v=this.PrettifyChanges(v)),{quitEarly:h[0],changes:v}}ComputeDiffRecursive(m,e,s,o,c){for(c[0]=!1;m<=e&&s<=o&&this.ElementsAreEqual(m,s);)m++,s++;for(;e>=m&&o>=s&&this.ElementsAreEqual(e,o);)e--,o--;if(m>e||s>o){let f;return s<=o?(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),f=[new i.DiffChange(m,0,s,o-s+1)]):m<=e?(w.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new i.DiffChange(m,e-m+1,s,0)]):(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),w.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const h=[0],v=[0],L=this.ComputeRecursionPoint(m,e,s,o,h,v,c),S=h[0],r=v[0];if(L!==null)return L;if(!c[0]){const f=this.ComputeDiffRecursive(m,S,s,r,c);let E=[];return c[0]?E=[new i.DiffChange(S+1,e-(S+1)+1,r+1,o-(r+1)+1)]:E=this.ComputeDiffRecursive(S+1,e,r+1,o,c),this.ConcatenateChanges(f,E)}return[new i.DiffChange(m,e-m+1,s,o-s+1)]}WALKTRACE(m,e,s,o,c,h,v,L,S,r,f,E,T,H,W,U,D,x){let z=null,O=null,P=new b,K=e,Q=s,X=T[0]-U[0]-o,G=k.Constants.MIN_SAFE_SMALL_INTEGER,J=this.m_forwardHistory.length-1;do{const ce=X+m;ce===K||ce<Q&&S[ce-1]<S[ce+1]?(f=S[ce+1],H=f-X-o,f<G&&P.MarkNextChange(),G=f,P.AddModifiedElement(f+1,H),X=ce+1-m):(f=S[ce-1]+1,H=f-X-o,f<G&&P.MarkNextChange(),G=f-1,P.AddOriginalElement(f,H+1),X=ce-1-m),J>=0&&(S=this.m_forwardHistory[J],m=S[0],K=1,Q=S.length-1)}while(--J>=-1);if(z=P.getReverseChanges(),x[0]){let ce=T[0]+1,pe=U[0]+1;if(z!==null&&z.length>0){const Te=z[z.length-1];ce=Math.max(ce,Te.getOriginalEnd()),pe=Math.max(pe,Te.getModifiedEnd())}O=[new i.DiffChange(ce,E-ce+1,pe,W-pe+1)]}else{P=new b,K=h,Q=v,X=T[0]-U[0]-L,G=k.Constants.MAX_SAFE_SMALL_INTEGER,J=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ce=X+c;ce===K||ce<Q&&r[ce-1]>=r[ce+1]?(f=r[ce+1]-1,H=f-X-L,f>G&&P.MarkNextChange(),G=f+1,P.AddOriginalElement(f+1,H+1),X=ce+1-c):(f=r[ce-1],H=f-X-L,f>G&&P.MarkNextChange(),G=f,P.AddModifiedElement(f+1,H+1),X=ce-1-c),J>=0&&(r=this.m_reverseHistory[J],c=r[0],K=1,Q=r.length-1)}while(--J>=-1);O=P.getChanges()}return this.ConcatenateChanges(z,O)}ComputeRecursionPoint(m,e,s,o,c,h,v){let L=0,S=0,r=0,f=0,E=0,T=0;m--,s--,c[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const H=e-m+(o-s),W=H+1,U=new Int32Array(W),D=new Int32Array(W),x=o-s,z=e-m,O=m-s,P=e-o,Q=(z-x)%2===0;U[x]=m,D[z]=e,v[0]=!1;for(let X=1;X<=H/2+1;X++){let G=0,J=0;r=this.ClipDiagonalBound(x-X,X,x,W),f=this.ClipDiagonalBound(x+X,X,x,W);for(let pe=r;pe<=f;pe+=2){pe===r||pe<f&&U[pe-1]<U[pe+1]?L=U[pe+1]:L=U[pe-1]+1,S=L-(pe-x)-O;const Te=L;for(;L<e&&S<o&&this.ElementsAreEqual(L+1,S+1);)L++,S++;if(U[pe]=L,L+S>G+J&&(G=L,J=S),!Q&&Math.abs(pe-z)<=X-1&&L>=D[pe])return c[0]=L,h[0]=S,Te<=D[pe]&&d.MaxDifferencesHistory>0&&X<=d.MaxDifferencesHistory+1?this.WALKTRACE(x,r,f,O,z,E,T,P,U,D,L,e,c,S,o,h,Q,v):null}const ce=(G-m+(J-s)-X)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(G,ce))return v[0]=!0,c[0]=G,h[0]=J,ce>0&&d.MaxDifferencesHistory>0&&X<=d.MaxDifferencesHistory+1?this.WALKTRACE(x,r,f,O,z,E,T,P,U,D,L,e,c,S,o,h,Q,v):(m++,s++,[new i.DiffChange(m,e-m+1,s,o-s+1)]);E=this.ClipDiagonalBound(z-X,X,z,W),T=this.ClipDiagonalBound(z+X,X,z,W);for(let pe=E;pe<=T;pe+=2){pe===E||pe<T&&D[pe-1]>=D[pe+1]?L=D[pe+1]-1:L=D[pe-1],S=L-(pe-z)-P;const Te=L;for(;L>m&&S>s&&this.ElementsAreEqual(L,S);)L--,S--;if(D[pe]=L,Q&&Math.abs(pe-x)<=X&&L<=U[pe])return c[0]=L,h[0]=S,Te>=U[pe]&&d.MaxDifferencesHistory>0&&X<=d.MaxDifferencesHistory+1?this.WALKTRACE(x,r,f,O,z,E,T,P,U,D,L,e,c,S,o,h,Q,v):null}if(X<=d.MaxDifferencesHistory){let pe=new Int32Array(f-r+2);pe[0]=x-r+1,_.Copy2(U,r,pe,1,f-r+1),this.m_forwardHistory.push(pe),pe=new Int32Array(T-E+2),pe[0]=z-E+1,_.Copy2(D,E,pe,1,T-E+1),this.m_reverseHistory.push(pe)}}return this.WALKTRACE(x,r,f,O,z,E,T,P,U,D,L,e,c,S,o,h,Q,v)}PrettifyChanges(m){for(let e=0;e<m.length;e++){const s=m[e],o=e<m.length-1?m[e+1].originalStart:this._originalElementsOrHash.length,c=e<m.length-1?m[e+1].modifiedStart:this._modifiedElementsOrHash.length,h=s.originalLength>0,v=s.modifiedLength>0;for(;s.originalStart+s.originalLength<o&&s.modifiedStart+s.modifiedLength<c&&(!h||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!v||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const S=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!S)break;s.originalStart++,s.modifiedStart++}const L=[null];if(e<m.length-1&&this.ChangesOverlap(m[e],m[e+1],L)){m[e]=L[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let o=0,c=0;if(e>0){const f=m[e-1];o=f.originalStart+f.originalLength,c=f.modifiedStart+f.modifiedLength}const h=s.originalLength>0,v=s.modifiedLength>0;let L=0,S=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let f=1;;f++){const E=s.originalStart-f,T=s.modifiedStart-f;if(E<o||T<c||h&&!this.OriginalElementsAreEqual(E,E+s.originalLength)||v&&!this.ModifiedElementsAreEqual(T,T+s.modifiedLength))break;const W=(E===o&&T===c?5:0)+this._boundaryScore(E,s.originalLength,T,s.modifiedLength);W>S&&(S=W,L=f)}s.originalStart-=L,s.modifiedStart-=L;const r=[null];if(e>0&&this.ChangesOverlap(m[e-1],m[e],r)){m[e-1]=r[0],m.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,s=m.length;e<s;e++){const o=m[e-1],c=m[e],h=c.originalStart-o.originalStart-o.originalLength,v=o.originalStart,L=c.originalStart+c.originalLength,S=L-v,r=o.modifiedStart,f=c.modifiedStart+c.modifiedLength,E=f-r;if(h<5&&S<20&&E<20){const T=this._findBetterContiguousSequence(v,S,r,E,h);if(T){const[H,W]=T;(H!==o.originalStart+o.originalLength||W!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=H-o.originalStart,o.modifiedLength=W-o.modifiedStart,c.originalStart=H+h,c.modifiedStart=W+h,c.originalLength=L-c.originalStart,c.modifiedLength=f-c.modifiedStart)}}}return m}_findBetterContiguousSequence(m,e,s,o,c){if(e<c||o<c)return null;const h=m+e-c+1,v=s+o-c+1;let L=0,S=0,r=0;for(let f=m;f<h;f++)for(let E=s;E<v;E++){const T=this._contiguousSequenceScore(f,E,c);T>0&&T>L&&(L=T,S=f,r=E)}return L>0?[S,r]:null}_contiguousSequenceScore(m,e,s){let o=0;for(let c=0;c<s;c++){if(!this.ElementsAreEqual(m+c,e+c))return 0;o+=this._originalStringElements[m+c].length}return o}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,e){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,e){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(m,e,s,o){const c=this._OriginalRegionIsBoundary(m,e)?1:0,h=this._ModifiedRegionIsBoundary(s,o)?1:0;return c+h}ConcatenateChanges(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.ChangesOverlap(m[m.length-1],e[0],s)){const o=new Array(m.length+e.length-1);return _.Copy(m,0,o,0,m.length-1),o[m.length-1]=s[0],_.Copy(e,1,o,m.length,e.length-1),o}else{const o=new Array(m.length+e.length);return _.Copy(m,0,o,0,m.length),_.Copy(e,0,o,m.length,e.length),o}}ChangesOverlap(m,e,s){if(w.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),w.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const o=m.originalStart;let c=m.originalLength;const h=m.modifiedStart;let v=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(c=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.DiffChange(o,c,h,v),!0}else return s[0]=null,!1}ClipDiagonalBound(m,e,s,o){if(m>=0&&m<o)return m;const c=s,h=o-s-1,v=e%2===0;if(m<0){const L=c%2===0;return v===L?0:1}else{const L=h%2===0;return v===L?o-1:o-2}}}t.LcsDiff=y}),define(De[67],we([1,0,50,11,22]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=_,t.markdownEscapeEscapedIcons=b,t.stripIcons=p,t.getCodiconAriaLabel=m,t.parseLabelWithIcons=s,t.matchesFuzzyIconAware=o;const R="$(",N=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${N.source}`,"g");function _(c){return c.replace(w,(h,v)=>v?h:`\\${h}`)}const d=new RegExp(`\\\\${N.source}`,"g");function b(c){return c.replace(d,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function p(c){return c.indexOf(R)===-1?c:c.replace(y,(h,v,L,S)=>L?h:v||S||"")}function m(c){return c?c.replace(/\$\((.*?)\)/g,(h,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){e.lastIndex=0;let h="";const v=[];let L=0;for(;;){const S=e.lastIndex,r=e.exec(c),f=c.substring(S,r?.index);if(f.length>0){h+=f;for(let E=0;E<f.length;E++)v.push(L)}if(!r)break;L+=r[0].length}return{text:h,iconOffsets:v}}function o(c,h,v=!1){const{text:L,iconOffsets:S}=h;if(!S||S.length===0)return(0,i.matchesFuzzy)(c,L,v);const r=(0,n.ltrim)(L," "),f=L.length-r.length,E=(0,i.matchesFuzzy)(c,r,v);if(E)for(const T of E){const H=S[T.start+f]+f;T.start+=H,T.end+=H}return E}}),define(De[106],we([1,0,9,18,11]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}t.StringIterator=R;class N{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===n.CharCode.Period)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,k.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=N;class w{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===n.CharCode.Slash||this._splitOnBackslash&&o===n.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===n.CharCode.Slash||this._splitOnBackslash&&s===n.CharCode.Backslash)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,k.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=w;var _;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(_||(_={}));class d{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(_.Scheme),this._value.authority&&this._states.push(_.Authority),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(_.Path)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(_.Query),this._value.fragment&&this._states.push(_.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===_.Scheme)return(0,k.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===_.Authority)return(0,k.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===_.Path)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===_.Query)return(0,k.compare)(e,this._value.query);if(this._states[this._stateIdx]===_.Fragment)return(0,k.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===_.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===_.Authority)return this._value.authority;if(this._states[this._stateIdx]===_.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===_.Query)return this._value.query;if(this._states[this._stateIdx]===_.Fragment)return this._value.fragment;throw new Error}}t.UriIterator=d;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(y||(y={}));class p{static forUris(e=()=>!1,s=()=>!1){return new p(new d(e,s))}static forPaths(e=!1){return new p(new w(void 0,!e))}static forStrings(){return new p(new R)}static forConfigKeys(){return new p(new N)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const o=s.slice(0);(0,i.shuffle)(o);for(const c of o)this.set(c,e)}else{const o=e.slice(0);(0,i.shuffle)(o);for(const c of o)this.set(c[0],c[1])}}set(e,s){const o=this._iter.reset(e);let c;this._root||(this._root=new b,this._root.segment=o.value());const h=[];for(c=this._root;;){const L=o.cmp(c.segment);if(L>0)c.left||(c.left=new b,c.left.segment=o.value()),h.push([y.Left,c]),c=c.left;else if(L<0)c.right||(c.right=new b,c.right.segment=o.value()),h.push([y.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new b,c.mid.segment=o.value()),h.push([y.Mid,c]),c=c.mid;else break}const v=c.value;c.value=s,c.key=e;for(let L=h.length-1;L>=0;L--){const S=h[L][1];S.updateHeight();const r=S.balanceFactor();if(r<-1||r>1){const f=h[L][0],E=h[L+1][0];if(f===y.Right&&E===y.Right)h[L][1]=S.rotateLeft();else if(f===y.Left&&E===y.Left)h[L][1]=S.rotateRight();else if(f===y.Right&&E===y.Left)S.right=h[L+1][1]=h[L+1][1].rotateRight(),h[L][1]=S.rotateLeft();else if(f===y.Left&&E===y.Right)S.left=h[L+1][1]=h[L+1][1].rotateLeft(),h[L][1]=S.rotateRight();else throw new Error;if(L>0)switch(h[L-1][0]){case y.Left:h[L-1][1].left=h[L][1];break;case y.Right:h[L-1][1].right=h[L][1];break;case y.Mid:h[L-1][1].mid=h[L][1];break}else this._root=h[0][1]}}return v}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const o=this._iter.reset(e),c=[];let h=this._root;for(;h;){const v=o.cmp(h.segment);if(v>0)c.push([y.Left,h]),h=h.left;else if(v<0)c.push([y.Right,h]),h=h.right;else if(o.hasNext())o.next(),c.push([y.Mid,h]),h=h.mid;else break}if(h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right);if(v.key){const{key:L,value:S,segment:r}=v;this._delete(v.key,!1),h.key=L,h.value=S,h.segment=r}}else{const v=h.left??h.right;if(c.length>0){const[L,S]=c[c.length-1];switch(L){case y.Left:S.left=v;break;case y.Mid:S.mid=v;break;case y.Right:S.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const L=c[v][1];L.updateHeight();const S=L.balanceFactor();if(S>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),c[v][1]=L.rotateLeft()):S<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),c[v][1]=L.rotateRight()),v>0)switch(c[v-1][0]){case y.Left:c[v-1][1].left=c[v][1];break;case y.Right:c[v-1][1].right=c[v][1];break;case y.Mid:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let o=this._root,c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(e){return this._findSuperstrOrElement(e,!1)}_findSuperstrOrElement(e,s){const o=this._iter.reset(e);let c=this._root;for(;c;){const h=o.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):s?c.value:void 0}}hasElementOrSubtree(e){return this._findSuperstrOrElement(e,!0)!==void 0}forEach(e){for(const[s,o]of this)e(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){e&&(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}t.TernarySearchTree=p}),define(De[107],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(De[108],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class i{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=i}),define(De[40],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.webUtils=t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const i=globalThis.vscode;t.ipcRenderer=i.ipcRenderer,t.ipcMessagePort=i.ipcMessagePort,t.webFrame=i.webFrame,t.process=i.process,t.context=i.context,t.webUtils=i.webUtils}),define(De[109],we([1,0,107,40]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=R;let k=0;function R(w,_,d){const b=[],y=k++,p=`vscode:onContextMenu${y}`,m=(e,s,o)=>{b[s].click?.(o)};n.ipcRenderer.once(p,m),n.ipcRenderer.once(i.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===y&&(n.ipcRenderer.removeListener(p,m),d?.())}),n.ipcRenderer.send(i.CONTEXT_MENU_CHANNEL,y,w.map(e=>N(e,b)),p,_)}function N(w,_){const d={id:_.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return _.push(w),Array.isArray(w.submenu)&&(d.submenu=w.submenu.map(b=>N(b,_))),d}}),define(De[68],we([7]),{}),define(De[110],we([7]),{}),define(De[111],we([7]),{}),define(De[112],we([7]),{}),define(De[113],we([1,0,111,112]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(De[114],we([7]),{}),define(De[115],we([7]),{}),define(De[116],we([7]),{}),define(De[117],we([7]),{}),define(De[118],we([7]),{}),define(De[119],we([7]),{}),define(De[120],we([7]),{}),define(De[121],we([7]),{}),define(De[122],we([7]),{}),define(De[123],we([7]),{}),define(De[124],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(De[125],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(De[126],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(De[127],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(De[128],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(De[129],we([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(De[130],we([14,13]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(De[51],we([1,0,3,2,130]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=b,k=Ue(k);class R extends n.Disposable{constructor(p,m="",e="",s=!0,o){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=p,this._label=m,this._cssClass=e,this._enabled=s,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(p){this._setLabel(p)}_setLabel(p){this._label!==p&&(this._label=p,this._onDidChange.fire({label:p}))}get tooltip(){return this._tooltip||""}set tooltip(p){this._setTooltip(p)}_setTooltip(p){this._tooltip!==p&&(this._tooltip=p,this._onDidChange.fire({tooltip:p}))}get class(){return this._cssClass}set class(p){this._setClass(p)}_setClass(p){this._cssClass!==p&&(this._cssClass=p,this._onDidChange.fire({class:p}))}get enabled(){return this._enabled}set enabled(p){this._setEnabled(p)}_setEnabled(p){this._enabled!==p&&(this._enabled=p,this._onDidChange.fire({enabled:p}))}get checked(){return this._checked}set checked(p){this._setChecked(p)}_setChecked(p){this._checked!==p&&(this._checked=p,this._onDidChange.fire({checked:p}))}async run(p,m){this._actionCallback&&await this._actionCallback(p)}}t.Action=R;class N extends n.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(p,m){if(!p.enabled)return;this._onWillRun.fire({action:p});let e;try{await this.runAction(p,m)}catch(s){e=s}this._onDidRun.fire({action:p,error:e})}async runAction(p,m){await p.run(m)}}t.ActionRunner=N;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let m=[];for(const e of p)e.length&&(m.length?m=[...m,new w,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=w;class _{get actions(){return this._actions}constructor(p,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=m,this.class=s,this._actions=e}async run(){}}t.SubmenuAction=_;class d extends R{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,k.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d;function b(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...p)=>y.run(...p)}}}),define(De[131],we([14,13]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(De[5],we([1,0,131]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=f,t.isLittleEndian=D,t.isBigSurOrNewer=x,i=Ue(i),t.LANGUAGE_DEFAULT="en";let n=!1,k=!1,R=!1,N=!1,w=!1,_=!1,d=!1,b=!1,y=!1,p=!1,m,e=t.LANGUAGE_DEFAULT,s=t.LANGUAGE_DEFAULT,o,c;const h=globalThis;let v;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?v=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const L=typeof v?.versions?.electron=="string",S=L&&v?.type==="renderer";if(typeof v=="object"){n=v.platform==="win32",k=v.platform==="darwin",R=v.platform==="linux",N=R&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,d=L,y=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const z=v.env.VSCODE_NLS_CONFIG;if(z)try{const O=JSON.parse(z),P=O.availableLanguages["*"];m=O.locale,s=O.osLocale,e=P||t.LANGUAGE_DEFAULT,o=O._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!S?(c=navigator.userAgent,n=c.indexOf("Windows")>=0,k=c.indexOf("Macintosh")>=0,b=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,_=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.LANGUAGE_DEFAULT,e=m,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(r||(t.Platform=r={}));function f(z){switch(z){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let E=r.Web;k?E=r.Mac:n?E=r.Windows:R&&(E=r.Linux),t.isWindows=n,t.isMacintosh=k,t.isLinux=R,t.isLinuxSnap=N,t.isNative=w,t.isElectron=d,t.isWeb=_,t.isWebWorker=_&&typeof h.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?h.origin:void 0,t.isIOS=b,t.isMobile=p,t.isCI=y,t.platform=E,t.userAgent=c,t.language=e;var T;(function(z){function O(){return t.language}z.value=O;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}z.isDefaultVariant=P;function K(){return t.language==="en"}z.isDefault=K})(T||(t.Language=T={})),t.locale=m,t.platformLocale=s,t.translationsConfigFile=o,t.setTimeout0IsFaster=typeof h.postMessage=="function"&&!h.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const z=[];h.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let K=0,Q=z.length;K<Q;K++){const X=z[K];if(X.id===P.data.vscodeScheduleAsyncWork){z.splice(K,1),X.callback();return}}});let O=0;return P=>{const K=++O;z.push({id:K,callback:P}),h.postMessage({vscodeScheduleAsyncWork:K},"*")}}return z=>setTimeout(z)})();var H;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(H||(t.OperatingSystem=H={})),t.OS=k||b?H.Macintosh:n?H.Windows:H.Linux;let W=!0,U=!1;function D(){if(!U){U=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,W=new Uint16Array(z.buffer)[0]===513}return W}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function x(z){return parseFloat(z)>=20}}),define(De[69],we([1,0,19,25,5]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0,i=Ue(i),k=Ue(k);var R;(function(N){N[N.Always=0]="Always",N[N.FullScreen=1]="FullScreen",N[N.None=2]="None"})(R||(t.KeyboardSupport=R={})),t.BrowserFeatures={clipboard:{writeText:k.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:k.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:k.isNative||i.isStandalone()?R.Always:navigator.keyboard||i.isSafari?R.FullScreen:R.None,touch:"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0,pointerEvents:n.mainWindow.PointerEvent&&("ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0)}}),define(De[23],we([1,0,19,86,5]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0,i=Ue(i),k=Ue(k);class R{constructor(d,b){this.timestamp=Date.now(),this.browserEvent=b,this.leftButton=b.button===0,this.middleButton=b.button===1,this.rightButton=b.button===2,this.buttons=b.buttons,this.target=b.target,this.detail=b.detail||1,b.type==="dblclick"&&(this.detail=2),this.ctrlKey=b.ctrlKey,this.shiftKey=b.shiftKey,this.altKey=b.altKey,this.metaKey=b.metaKey,typeof b.pageX=="number"?(this.posx=b.pageX,this.posy=b.pageY):(this.posx=b.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=b.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const y=n.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(d,b.view);this.posx-=y.left,this.posy-=y.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=R;class N extends R{constructor(d,b){super(d,b),this.dataTransfer=b.dataTransfer}}t.DragMouseEvent=N;class w{constructor(d,b=0,y=0){this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=y,this.deltaX=b;let p=!1;if(i.isChrome){const m=navigator.userAgent.match(/Chrome\/(\d+)/);p=(m?parseInt(m[1]):123)<=122}if(d){const m=d,e=d,s=d.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")p?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(d.type==="wheel"){const o=d;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!k.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof m.wheelDeltaX<"u")i.isSafari&&k.isWindows?this.deltaX=-(m.wheelDeltaX/120):p?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const o=d;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!k.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(p?this.deltaY=d.wheelDelta/(120*s):this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(De[132],we([1,0,6,8,5]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=N,t.createSimpleKeybinding=w;var R;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(R||(R={}));function N(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,o=(m&4294901760)>>>16;return o!==0?new b([w(s,e),w(o,e)]):new b([w(s,e)])}else{const s=[];for(let o=0;o<m.length;o++)s.push(w(m[o],e));return new b(s)}}function w(m,e){const s=!!(m&R.CtrlCmd),o=!!(m&R.WinCtrl),c=e===k.OperatingSystem.Macintosh?o:s,h=!!(m&R.Shift),v=!!(m&R.Alt),L=e===k.OperatingSystem.Macintosh?s:o,S=m&R.KeyCode;return new _(c,h,v,L,S)}class _{constructor(e,s,o,c,h){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.keyCode=h}equals(e){return e instanceof _&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`K${e}${s}${o}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.KeyCodeChord=_;class d{constructor(e,s,o,c,h){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.scanCode=h}equals(e){return e instanceof d&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`S${e}${s}${o}${c}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.ScanCodeChord=d;class b{constructor(e){if(e.length===0)throw(0,i.illegalArgument)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,o=this.chords.length;s<o;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.Keybinding=b;class y{constructor(e,s,o,c,h,v){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=c,this.keyLabel=h,this.keyAriaLabel=v}}t.ResolvedChord=y;class p{}t.ResolvedKeybinding=p}),define(De[16],we([1,0,19,8,132,5]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=y,t.printStandardKeyboardEvent=p,i=Ue(i),R=Ue(R);function N(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.isFirefox)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(R.isLinux)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(R.isMacintosh)return n.KeyCode.Meta;break}else if(i.isWebKit){if(R.isMacintosh&&s===93)return n.KeyCode.Meta;if(!R.isMacintosh&&s===92)return n.KeyCode.Meta}return n.EVENT_KEY_CODE_MAP[s]||n.KeyCode.Unknown}const w=R.isMacintosh?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,_=n.KeyMod.Alt,d=n.KeyMod.Shift,b=R.isMacintosh?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function y(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function p(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=N(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=w),this.altKey&&(o|=_),this.shiftKey&&(o|=d),this.metaKey&&(o|=b),o|=s,o}_computeKeyCodeChord(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new k.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=m}),define(De[133],we([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let n;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const R=k.process;n={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.arch=n.arch}),define(De[30],we([1,0,133]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0,i=Ue(i);const n=65,k=97,R=90,N=122,w=46,_=47,d=92,b=58,y=63;class p extends Error{constructor(f,E,T){let H;typeof E=="string"&&E.indexOf("not ")===0?(H="must not be",E=E.replace(/^not /,"")):H="must be";const W=f.indexOf(".")!==-1?"property":"argument";let U=`The "${f}" ${W} ${H} of type ${E}`;U+=`. Received type ${typeof T}`,super(U),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,f){if(r===null||typeof r!="object")throw new p(f,"Object",r)}function e(r,f){if(typeof r!="string")throw new p(f,"string",r)}const s=i.platform==="win32";function o(r){return r===_||r===d}function c(r){return r===_}function h(r){return r>=n&&r<=R||r>=k&&r<=N}function v(r,f,E,T){let H="",W=0,U=-1,D=0,x=0;for(let z=0;z<=r.length;++z){if(z<r.length)x=r.charCodeAt(z);else{if(T(x))break;x=_}if(T(x)){if(!(U===z-1||D===1))if(D===2){if(H.length<2||W!==2||H.charCodeAt(H.length-1)!==w||H.charCodeAt(H.length-2)!==w){if(H.length>2){const O=H.lastIndexOf(E);O===-1?(H="",W=0):(H=H.slice(0,O),W=H.length-1-H.lastIndexOf(E)),U=z,D=0;continue}else if(H.length!==0){H="",W=0,U=z,D=0;continue}}f&&(H+=H.length>0?`${E}..`:"..",W=2)}else H.length>0?H+=`${E}${r.slice(U+1,z)}`:H=r.slice(U+1,z),W=z-U-1;U=z,D=0}else x===w&&D!==-1?++D:D=-1}return H}function L(r,f){m(f,"pathObject");const E=f.dir||f.root,T=f.base||`${f.name||""}${f.ext||""}`;return E?E===f.root?`${E}${T}`:`${E}${r}${T}`:T}t.win32={resolve(...r){let f="",E="",T=!1;for(let H=r.length-1;H>=-1;H--){let W;if(H>=0){if(W=r[H],e(W,"path"),W.length===0)continue}else f.length===0?W=i.cwd():(W=i.env[`=${f}`]||i.cwd(),(W===void 0||W.slice(0,2).toLowerCase()!==f.toLowerCase()&&W.charCodeAt(2)===d)&&(W=`${f}\\`));const U=W.length;let D=0,x="",z=!1;const O=W.charCodeAt(0);if(U===1)o(O)&&(D=1,z=!0);else if(o(O))if(z=!0,o(W.charCodeAt(1))){let P=2,K=P;for(;P<U&&!o(W.charCodeAt(P));)P++;if(P<U&&P!==K){const Q=W.slice(K,P);for(K=P;P<U&&o(W.charCodeAt(P));)P++;if(P<U&&P!==K){for(K=P;P<U&&!o(W.charCodeAt(P));)P++;(P===U||P!==K)&&(x=`\\\\${Q}\\${W.slice(K,P)}`,D=P)}}}else D=1;else h(O)&&W.charCodeAt(1)===b&&(x=W.slice(0,2),D=2,U>2&&o(W.charCodeAt(2))&&(z=!0,D=3));if(x.length>0)if(f.length>0){if(x.toLowerCase()!==f.toLowerCase())continue}else f=x;if(T){if(f.length>0)break}else if(E=`${W.slice(D)}\\${E}`,T=z,z&&f.length>0)break}return E=v(E,!T,"\\",o),T?`${f}\\${E}`:`${f}${E}`||"."},normalize(r){e(r,"path");const f=r.length;if(f===0)return".";let E=0,T,H=!1;const W=r.charCodeAt(0);if(f===1)return c(W)?"\\":r;if(o(W))if(H=!0,o(r.charCodeAt(1))){let D=2,x=D;for(;D<f&&!o(r.charCodeAt(D));)D++;if(D<f&&D!==x){const z=r.slice(x,D);for(x=D;D<f&&o(r.charCodeAt(D));)D++;if(D<f&&D!==x){for(x=D;D<f&&!o(r.charCodeAt(D));)D++;if(D===f)return`\\\\${z}\\${r.slice(x)}\\`;D!==x&&(T=`\\\\${z}\\${r.slice(x,D)}`,E=D)}}}else E=1;else h(W)&&r.charCodeAt(1)===b&&(T=r.slice(0,2),E=2,f>2&&o(r.charCodeAt(2))&&(H=!0,E=3));let U=E<f?v(r.slice(E),!H,"\\",o):"";return U.length===0&&!H&&(U="."),U.length>0&&o(r.charCodeAt(f-1))&&(U+="\\"),T===void 0?H?`\\${U}`:U:H?`${T}\\${U}`:`${T}${U}`},isAbsolute(r){e(r,"path");const f=r.length;if(f===0)return!1;const E=r.charCodeAt(0);return o(E)||f>2&&h(E)&&r.charCodeAt(1)===b&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let f,E;for(let W=0;W<r.length;++W){const U=r[W];e(U,"path"),U.length>0&&(f===void 0?f=E=U:f+=`\\${U}`)}if(f===void 0)return".";let T=!0,H=0;if(typeof E=="string"&&o(E.charCodeAt(0))){++H;const W=E.length;W>1&&o(E.charCodeAt(1))&&(++H,W>2&&(o(E.charCodeAt(2))?++H:T=!1))}if(T){for(;H<f.length&&o(f.charCodeAt(H));)H++;H>=2&&(f=`\\${f.slice(H)}`)}return t.win32.normalize(f)},relative(r,f){if(e(r,"from"),e(f,"to"),r===f)return"";const E=t.win32.resolve(r),T=t.win32.resolve(f);if(E===T||(r=E.toLowerCase(),f=T.toLowerCase(),r===f))return"";let H=0;for(;H<r.length&&r.charCodeAt(H)===d;)H++;let W=r.length;for(;W-1>H&&r.charCodeAt(W-1)===d;)W--;const U=W-H;let D=0;for(;D<f.length&&f.charCodeAt(D)===d;)D++;let x=f.length;for(;x-1>D&&f.charCodeAt(x-1)===d;)x--;const z=x-D,O=U<z?U:z;let P=-1,K=0;for(;K<O;K++){const X=r.charCodeAt(H+K);if(X!==f.charCodeAt(D+K))break;X===d&&(P=K)}if(K!==O){if(P===-1)return T}else{if(z>O){if(f.charCodeAt(D+K)===d)return T.slice(D+K+1);if(K===2)return T.slice(D+K)}U>O&&(r.charCodeAt(H+K)===d?P=K:K===2&&(P=3)),P===-1&&(P=0)}let Q="";for(K=H+P+1;K<=W;++K)(K===W||r.charCodeAt(K)===d)&&(Q+=Q.length===0?"..":"\\..");return D+=P,Q.length>0?`${Q}${T.slice(D,x)}`:(T.charCodeAt(D)===d&&++D,T.slice(D,x))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const f=t.win32.resolve(r);if(f.length<=2)return r;if(f.charCodeAt(0)===d){if(f.charCodeAt(1)===d){const E=f.charCodeAt(2);if(E!==y&&E!==w)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(h(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===d)return`\\\\?\\${f}`;return r},dirname(r){e(r,"path");const f=r.length;if(f===0)return".";let E=-1,T=0;const H=r.charCodeAt(0);if(f===1)return o(H)?r:".";if(o(H)){if(E=T=1,o(r.charCodeAt(1))){let D=2,x=D;for(;D<f&&!o(r.charCodeAt(D));)D++;if(D<f&&D!==x){for(x=D;D<f&&o(r.charCodeAt(D));)D++;if(D<f&&D!==x){for(x=D;D<f&&!o(r.charCodeAt(D));)D++;if(D===f)return r;D!==x&&(E=T=D+1)}}}}else h(H)&&r.charCodeAt(1)===b&&(E=f>2&&o(r.charCodeAt(2))?3:2,T=E);let W=-1,U=!0;for(let D=f-1;D>=T;--D)if(o(r.charCodeAt(D))){if(!U){W=D;break}}else U=!1;if(W===-1){if(E===-1)return".";W=E}return r.slice(0,W)},basename(r,f){f!==void 0&&e(f,"ext"),e(r,"path");let E=0,T=-1,H=!0,W;if(r.length>=2&&h(r.charCodeAt(0))&&r.charCodeAt(1)===b&&(E=2),f!==void 0&&f.length>0&&f.length<=r.length){if(f===r)return"";let U=f.length-1,D=-1;for(W=r.length-1;W>=E;--W){const x=r.charCodeAt(W);if(o(x)){if(!H){E=W+1;break}}else D===-1&&(H=!1,D=W+1),U>=0&&(x===f.charCodeAt(U)?--U===-1&&(T=W):(U=-1,T=D))}return E===T?T=D:T===-1&&(T=r.length),r.slice(E,T)}for(W=r.length-1;W>=E;--W)if(o(r.charCodeAt(W))){if(!H){E=W+1;break}}else T===-1&&(H=!1,T=W+1);return T===-1?"":r.slice(E,T)},extname(r){e(r,"path");let f=0,E=-1,T=0,H=-1,W=!0,U=0;r.length>=2&&r.charCodeAt(1)===b&&h(r.charCodeAt(0))&&(f=T=2);for(let D=r.length-1;D>=f;--D){const x=r.charCodeAt(D);if(o(x)){if(!W){T=D+1;break}continue}H===-1&&(W=!1,H=D+1),x===w?E===-1?E=D:U!==1&&(U=1):E!==-1&&(U=-1)}return E===-1||H===-1||U===0||U===1&&E===H-1&&E===T+1?"":r.slice(E,H)},format:L.bind(null,"\\"),parse(r){e(r,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return f;const E=r.length;let T=0,H=r.charCodeAt(0);if(E===1)return o(H)?(f.root=f.dir=r,f):(f.base=f.name=r,f);if(o(H)){if(T=1,o(r.charCodeAt(1))){let P=2,K=P;for(;P<E&&!o(r.charCodeAt(P));)P++;if(P<E&&P!==K){for(K=P;P<E&&o(r.charCodeAt(P));)P++;if(P<E&&P!==K){for(K=P;P<E&&!o(r.charCodeAt(P));)P++;P===E?T=P:P!==K&&(T=P+1)}}}}else if(h(H)&&r.charCodeAt(1)===b){if(E<=2)return f.root=f.dir=r,f;if(T=2,o(r.charCodeAt(2))){if(E===3)return f.root=f.dir=r,f;T=3}}T>0&&(f.root=r.slice(0,T));let W=-1,U=T,D=-1,x=!0,z=r.length-1,O=0;for(;z>=T;--z){if(H=r.charCodeAt(z),o(H)){if(!x){U=z+1;break}continue}D===-1&&(x=!1,D=z+1),H===w?W===-1?W=z:O!==1&&(O=1):W!==-1&&(O=-1)}return D!==-1&&(W===-1||O===0||O===1&&W===D-1&&W===U+1?f.base=f.name=r.slice(U,D):(f.name=r.slice(U,W),f.base=r.slice(U,D),f.ext=r.slice(W,D))),U>0&&U!==T?f.dir=r.slice(0,U-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(s){const r=/\\/g;return()=>{const f=i.cwd().replace(r,"/");return f.slice(f.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...r){let f="",E=!1;for(let T=r.length-1;T>=-1&&!E;T--){const H=T>=0?r[T]:S();e(H,"path"),H.length!==0&&(f=`${H}/${f}`,E=H.charCodeAt(0)===_)}return f=v(f,!E,"/",c),E?`/${f}`:f.length>0?f:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const f=r.charCodeAt(0)===_,E=r.charCodeAt(r.length-1)===_;return r=v(r,!f,"/",c),r.length===0?f?"/":E?"./":".":(E&&(r+="/"),f?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===_},join(...r){if(r.length===0)return".";let f;for(let E=0;E<r.length;++E){const T=r[E];e(T,"path"),T.length>0&&(f===void 0?f=T:f+=`/${T}`)}return f===void 0?".":t.posix.normalize(f)},relative(r,f){if(e(r,"from"),e(f,"to"),r===f||(r=t.posix.resolve(r),f=t.posix.resolve(f),r===f))return"";const E=1,T=r.length,H=T-E,W=1,U=f.length-W,D=H<U?H:U;let x=-1,z=0;for(;z<D;z++){const P=r.charCodeAt(E+z);if(P!==f.charCodeAt(W+z))break;P===_&&(x=z)}if(z===D)if(U>D){if(f.charCodeAt(W+z)===_)return f.slice(W+z+1);if(z===0)return f.slice(W+z)}else H>D&&(r.charCodeAt(E+z)===_?x=z:z===0&&(x=0));let O="";for(z=E+x+1;z<=T;++z)(z===T||r.charCodeAt(z)===_)&&(O+=O.length===0?"..":"/..");return`${O}${f.slice(W+x)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const f=r.charCodeAt(0)===_;let E=-1,T=!0;for(let H=r.length-1;H>=1;--H)if(r.charCodeAt(H)===_){if(!T){E=H;break}}else T=!1;return E===-1?f?"/":".":f&&E===1?"//":r.slice(0,E)},basename(r,f){f!==void 0&&e(f,"ext"),e(r,"path");let E=0,T=-1,H=!0,W;if(f!==void 0&&f.length>0&&f.length<=r.length){if(f===r)return"";let U=f.length-1,D=-1;for(W=r.length-1;W>=0;--W){const x=r.charCodeAt(W);if(x===_){if(!H){E=W+1;break}}else D===-1&&(H=!1,D=W+1),U>=0&&(x===f.charCodeAt(U)?--U===-1&&(T=W):(U=-1,T=D))}return E===T?T=D:T===-1&&(T=r.length),r.slice(E,T)}for(W=r.length-1;W>=0;--W)if(r.charCodeAt(W)===_){if(!H){E=W+1;break}}else T===-1&&(H=!1,T=W+1);return T===-1?"":r.slice(E,T)},extname(r){e(r,"path");let f=-1,E=0,T=-1,H=!0,W=0;for(let U=r.length-1;U>=0;--U){const D=r.charCodeAt(U);if(D===_){if(!H){E=U+1;break}continue}T===-1&&(H=!1,T=U+1),D===w?f===-1?f=U:W!==1&&(W=1):f!==-1&&(W=-1)}return f===-1||T===-1||W===0||W===1&&f===T-1&&f===E+1?"":r.slice(f,T)},format:L.bind(null,"/"),parse(r){e(r,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return f;const E=r.charCodeAt(0)===_;let T;E?(f.root="/",T=1):T=0;let H=-1,W=0,U=-1,D=!0,x=r.length-1,z=0;for(;x>=T;--x){const O=r.charCodeAt(x);if(O===_){if(!D){W=x+1;break}continue}U===-1&&(D=!1,U=x+1),O===w?H===-1?H=x:z!==1&&(z=1):H!==-1&&(z=-1)}if(U!==-1){const O=W===0&&E?1:W;H===-1||z===0||z===1&&H===U-1&&H===W+1?f.base=f.name=r.slice(O,U):(f.name=r.slice(O,H),f.base=r.slice(O,U),f.ext=r.slice(H,U))}return W>0?f.dir=r.slice(0,W-1):E&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(De[134],we([1,0,18,30,5,11,10]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=w,t.toSlashes=_,t.toPosixPath=d,t.getRoot=b,t.isUNC=y,t.isValidBasename=s,t.isEqual=o,t.isEqualOrParent=c,t.isWindowsDriveLetter=h,t.sanitizeFilePath=v,t.removeTrailingPathSeparator=L,t.isRootOrDriveLetter=S,t.hasDriveLetter=r,t.getDriveLetter=f,t.indexOfPath=E,t.parseLineAndColumnAware=T,t.randomPath=U;function w(D){return D===i.CharCode.Slash||D===i.CharCode.Backslash}function _(D){return D.replace(/[\\/]/g,n.posix.sep)}function d(D){return D.indexOf("/")===-1&&(D=_(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function b(D,x=n.posix.sep){if(!D)return"";const z=D.length,O=D.charCodeAt(0);if(w(O)){if(w(D.charCodeAt(1))&&!w(D.charCodeAt(2))){let K=3;const Q=K;for(;K<z&&!w(D.charCodeAt(K));K++);if(Q!==K&&!w(D.charCodeAt(K+1))){for(K+=1;K<z;K++)if(w(D.charCodeAt(K)))return D.slice(0,K+1).replace(/[\\/]/g,x)}}return x}else if(h(O)&&D.charCodeAt(1)===i.CharCode.Colon)return w(D.charCodeAt(2))?D.slice(0,2)+x:D.slice(0,2);let P=D.indexOf("://");if(P!==-1){for(P+=3;P<z;P++)if(w(D.charCodeAt(P)))return D.slice(0,P+1)}return""}function y(D){if(!k.isWindows||!D||D.length<5)return!1;let x=D.charCodeAt(0);if(x!==i.CharCode.Backslash||(x=D.charCodeAt(1),x!==i.CharCode.Backslash))return!1;let z=2;const O=z;for(;z<D.length&&(x=D.charCodeAt(z),x!==i.CharCode.Backslash);z++);return!(O===z||(x=D.charCodeAt(z+1),isNaN(x)||x===i.CharCode.Backslash))}const p=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(D,x=k.isWindows){const z=x?p:m;return!(!D||D.length===0||/^\s+$/.test(D)||(z.lastIndex=0,z.test(D))||x&&e.test(D)||D==="."||D===".."||x&&D[D.length-1]==="."||x&&D.length!==D.trim().length||D.length>255)}function o(D,x,z){const O=D===x;return!z||O?O:!D||!x?!1:(0,R.equalsIgnoreCase)(D,x)}function c(D,x,z,O=n.sep){if(D===x)return!0;if(!D||!x||x.length>D.length)return!1;if(z){if(!(0,R.startsWithIgnoreCase)(D,x))return!1;if(x.length===D.length)return!0;let K=x.length;return x.charAt(x.length-1)===O&&K--,D.charAt(K)===O}return x.charAt(x.length-1)!==O&&(x+=O),D.indexOf(x)===0}function h(D){return D>=i.CharCode.A&&D<=i.CharCode.Z||D>=i.CharCode.a&&D<=i.CharCode.z}function v(D,x){return k.isWindows&&D.endsWith(":")&&(D+=n.sep),(0,n.isAbsolute)(D)||(D=(0,n.join)(x,D)),D=(0,n.normalize)(D),L(D)}function L(D){return k.isWindows?(D=(0,R.rtrim)(D,n.sep),D.endsWith(":")&&(D+=n.sep)):(D=(0,R.rtrim)(D,n.sep),D||(D=n.sep)),D}function S(D){const x=(0,n.normalize)(D);return k.isWindows?D.length>3?!1:r(x)&&(D.length===2||x.charCodeAt(2)===i.CharCode.Backslash):x===n.posix.sep}function r(D,x=k.isWindows){return x?h(D.charCodeAt(0))&&D.charCodeAt(1)===i.CharCode.Colon:!1}function f(D,x=k.isWindows){return r(D,x)?D[0]:void 0}function E(D,x,z){return x.length>D.length?-1:D===x?0:(z&&(D=D.toLowerCase(),x=x.toLowerCase()),D.indexOf(x))}function T(D){const x=D.split(":");let z,O,P;for(const K of x){const Q=Number(K);(0,N.isNumber)(Q)?O===void 0?O=Q:P===void 0&&(P=Q):z=z?[z,K].join(":"):K}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:O!==void 0?O:void 0,column:P!==void 0?P:O!==void 0?1:void 0}}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",W="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(D,x,z=8){let O="";for(let K=0;K<z;K++){let Q;K===0&&k.isWindows&&!x&&(z===3||z===4)?Q=W:Q=H,O+=Q.charAt(Math.floor(Math.random()*Q.length))}let P;return x?P=`${x}-${O}`:P=O,D?(0,n.join)(D,P):P}}),define(De[135],we([1,0,30]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=R,t.getMediaMime=N,t.getExtensionForMimeType=w,t.normalizeMimeType=d,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(b){const y=(0,i.extname)(b),p=n[y.toLowerCase()];return p!==void 0?p:N(b)}function N(b){const y=(0,i.extname)(b);return k[y.toLowerCase()]}function w(b){for(const y in k)if(k[y]===b)return y}const _=/^(.+)\/(.+?)(;.+)?$/;function d(b,y){const p=_.exec(b);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:y?void 0:b}}),define(De[17],we([1,0,18,61,30,5]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=o,t.uriToFsPath=r,k=Ue(k);const N=/^\w[\w\d+.-]*$/,w=/^\//,_=/^\/\//;function d(W,U){if(!W.scheme&&U)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${W.authority}", path: "${W.path}", query: "${W.query}", fragment: "${W.fragment}"}`);if(W.scheme&&!N.test(W.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(W.path){if(W.authority){if(!w.test(W.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(W.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(W,U){return!W&&!U?"file":W}function y(W,U){switch(W){case"https":case"http":case"file":U?U[0]!==m&&(U=m+U):U=m;break}return U}const p="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(U){return U instanceof s?!0:U?typeof U.authority=="string"&&typeof U.fragment=="string"&&typeof U.path=="string"&&typeof U.query=="string"&&typeof U.scheme=="string"&&typeof U.fsPath=="string"&&typeof U.with=="function"&&typeof U.toString=="function":!1}constructor(U,D,x,z,O,P=!1){typeof U=="object"?(this.scheme=U.scheme||p,this.authority=U.authority||p,this.path=U.path||p,this.query=U.query||p,this.fragment=U.fragment||p):(this.scheme=b(U,P),this.authority=D||p,this.path=y(this.scheme,x||p),this.query=z||p,this.fragment=O||p,d(this,P))}get fsPath(){return r(this,!1)}with(U){if(!U)return this;let{scheme:D,authority:x,path:z,query:O,fragment:P}=U;return D===void 0?D=this.scheme:D===null&&(D=p),x===void 0?x=this.authority:x===null&&(x=p),z===void 0?z=this.path:z===null&&(z=p),O===void 0?O=this.query:O===null&&(O=p),P===void 0?P=this.fragment:P===null&&(P=p),D===this.scheme&&x===this.authority&&z===this.path&&O===this.query&&P===this.fragment?this:new h(D,x,z,O,P)}static parse(U,D=!1){const x=e.exec(U);return x?new h(x[2]||p,H(x[4]||p),H(x[5]||p),H(x[7]||p),H(x[9]||p),D):new h(p,p,p,p,p)}static file(U){let D=p;if(R.isWindows&&(U=U.replace(/\\/g,m)),U[0]===m&&U[1]===m){const x=U.indexOf(m,2);x===-1?(D=U.substring(2),U=m):(D=U.substring(2,x),U=U.substring(x)||m)}return new h("file",D,U,p,p)}static from(U,D){return new h(U.scheme,U.authority,U.path,U.query,U.fragment,D)}static joinPath(U,...D){if(!U.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let x;return R.isWindows&&U.scheme==="file"?x=s.file(k.win32.join(r(U,!0),...D)).path:x=k.posix.join(U.path,...D),U.with({path:x})}toString(U=!1){return f(this,U)}toJSON(){return this}static revive(U){if(U){if(U instanceof s)return U;{const D=new h(U);return D._formatted=U.external??null,D._fsPath=U._sep===c?U.fsPath??null:null,D}}else return U}}t.URI=s;function o(W){return!W||typeof W!="object"?!1:typeof W.scheme=="string"&&(typeof W.authority=="string"||typeof W.authority>"u")&&(typeof W.path=="string"||typeof W.path>"u")&&(typeof W.query=="string"||typeof W.query>"u")&&(typeof W.fragment=="string"||typeof W.fragment>"u")}const c=R.isWindows?1:void 0;class h extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(U=!1){return U?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const U={$mid:n.MarshalledId.Uri};return this._fsPath&&(U.fsPath=this._fsPath,U._sep=c),this._formatted&&(U.external=this._formatted),this.path&&(U.path=this.path),this.scheme&&(U.scheme=this.scheme),this.authority&&(U.authority=this.authority),this.query&&(U.query=this.query),this.fragment&&(U.fragment=this.fragment),U}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function L(W,U,D){let x,z=-1;for(let O=0;O<W.length;O++){const P=W.charCodeAt(O);if(P>=i.CharCode.a&&P<=i.CharCode.z||P>=i.CharCode.A&&P<=i.CharCode.Z||P>=i.CharCode.Digit0&&P<=i.CharCode.Digit9||P===i.CharCode.Dash||P===i.CharCode.Period||P===i.CharCode.Underline||P===i.CharCode.Tilde||U&&P===i.CharCode.Slash||D&&P===i.CharCode.OpenSquareBracket||D&&P===i.CharCode.CloseSquareBracket||D&&P===i.CharCode.Colon)z!==-1&&(x+=encodeURIComponent(W.substring(z,O)),z=-1),x!==void 0&&(x+=W.charAt(O));else{x===void 0&&(x=W.substr(0,O));const K=v[P];K!==void 0?(z!==-1&&(x+=encodeURIComponent(W.substring(z,O)),z=-1),x+=K):z===-1&&(z=O)}}return z!==-1&&(x+=encodeURIComponent(W.substring(z))),x!==void 0?x:W}function S(W){let U;for(let D=0;D<W.length;D++){const x=W.charCodeAt(D);x===i.CharCode.Hash||x===i.CharCode.QuestionMark?(U===void 0&&(U=W.substr(0,D)),U+=v[x]):U!==void 0&&(U+=W[D])}return U!==void 0?U:W}function r(W,U){let D;return W.authority&&W.path.length>1&&W.scheme==="file"?D=`//${W.authority}${W.path}`:W.path.charCodeAt(0)===i.CharCode.Slash&&(W.path.charCodeAt(1)>=i.CharCode.A&&W.path.charCodeAt(1)<=i.CharCode.Z||W.path.charCodeAt(1)>=i.CharCode.a&&W.path.charCodeAt(1)<=i.CharCode.z)&&W.path.charCodeAt(2)===i.CharCode.Colon?U?D=W.path.substr(1):D=W.path[1].toLowerCase()+W.path.substr(2):D=W.path,R.isWindows&&(D=D.replace(/\//g,"\\")),D}function f(W,U){const D=U?S:L;let x="",{scheme:z,authority:O,path:P,query:K,fragment:Q}=W;if(z&&(x+=z,x+=":"),(O||z==="file")&&(x+=m,x+=m),O){let X=O.indexOf("@");if(X!==-1){const G=O.substr(0,X);O=O.substr(X+1),X=G.lastIndexOf(":"),X===-1?x+=D(G,!1,!1):(x+=D(G.substr(0,X),!1,!1),x+=":",x+=D(G.substr(X+1),!1,!0)),x+="@"}O=O.toLowerCase(),X=O.lastIndexOf(":"),X===-1?x+=D(O,!1,!0):(x+=D(O.substr(0,X),!1,!0),x+=O.substr(X))}if(P){if(P.length>=3&&P.charCodeAt(0)===i.CharCode.Slash&&P.charCodeAt(2)===i.CharCode.Colon){const X=P.charCodeAt(1);X>=i.CharCode.A&&X<=i.CharCode.Z&&(P=`/${String.fromCharCode(X+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===i.CharCode.Colon){const X=P.charCodeAt(0);X>=i.CharCode.A&&X<=i.CharCode.Z&&(P=`${String.fromCharCode(X+32)}:${P.substr(2)}`)}x+=D(P,!0,!1)}return K&&(x+="?",x+=D(K,!1,!1)),Q&&(x+="#",x+=U?Q:L(Q,!1,!1)),x}function E(W){try{return decodeURIComponent(W)}catch{return W.length>3?W.substr(0,3)+E(W.substr(3)):W}}const T=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(W){return W.match(T)?W.replace(T,U=>E(U)):W}}),define(De[70],we([1,0,48,17,61]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=R,t.parse=N,t.revive=_;function R(d){return JSON.stringify(d,w)}function N(d){let b=JSON.parse(d);return b=_(b),b}function w(d,b){return b instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:b.source,flags:b.flags}:b}function _(d,b=0){if(!d||b>200)return d;if(typeof d=="object"){switch(d.$mid){case k.MarshalledId.Uri:return n.URI.revive(d);case k.MarshalledId.Regexp:return new RegExp(d.source,d.flags);case k.MarshalledId.Date:return new Date(d.source)}if(d instanceof i.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let y=0;y<d.length;++y)d[y]=_(d[y],b+1);else for(const y in d)Object.hasOwnProperty.call(d,y)&&(d[y]=_(d[y],b+1))}return d}}),define(De[41],we([1,0,6,5,11,17,30]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=_,t.matchesSomeScheme=d,t.getServerRootPath=y,i=Ue(i),n=Ue(n),N=Ue(N);var w;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(w||(t.Schemas=w={}));function _(e,s){return R.URI.isUri(e)?(0,k.equalsIgnoreCase)(e.scheme,s):(0,k.startsWithIgnoreCase)(e,s+":")}function d(e,...s){return s.some(o=>_(e,o))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s,o){this._serverRootPath=y(s,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return N.posix.join(this._serverRootPath,w.vscodeRemoteResource)}set(s,o,c){this._hosts[s]=o,this._ports[s]=c}setConnectionToken(s,o){this._connectionTokens[s]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(S){return i.onUnexpectedError(S),s}const o=s.authority;let c=this._hosts[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const h=this._ports[o],v=this._connectionTokens[o];let L=`path=${encodeURIComponent(s.path)}`;return typeof v=="string"&&(L+=`&${t.connectionTokenQueryName}=${encodeURIComponent(v)}`),R.URI.from({scheme:n.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${c}:${h}`,path:this._remoteResourcesPath,query:L})}}t.RemoteAuthorities=new b;function y(e,s){return N.posix.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class p{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(s){const o=this.toUri(s,ne);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===w.vscodeRemote?t.RemoteAuthorities.rewrite(s):s.scheme===w.file&&(n.isNative||n.webWorkerOrigin===`${w.vscodeFileResource}://${p.FALLBACK_AUTHORITY}`)?s.with({scheme:w.vscodeFileResource,authority:s.authority||p.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const o=this.toUri(s,ne);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===w.vscodeFileResource?s.with({scheme:w.file,authority:s.authority!==p.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,o){return R.URI.isUri(s)?s:R.URI.parse(o.toUrl(s))}}t.FileAccess=new p;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function c(v){let L;typeof v=="string"?L=new URL(v).searchParams:v instanceof URL?L=v.searchParams:R.URI.isUri(v)&&(L=new URL(v.toString(!0)).searchParams);const S=L?.get(o);if(S)return s.get(S)}e.getHeadersFromQuery=c;function h(v,L,S){if(!globalThis.crossOriginIsolated)return;const r=L&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(o,r):v[o]=r}e.addSearchParam=h})(m||(t.COI=m={}))}),define(De[52],we([1,0,18,134,41,30,5,11,17]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=d,t.distinctParents=y,t.toLocalResource=m,n=Ue(n),R=Ue(R);function d(e){return(0,_.uriToFsPath)(e,!0)}class b{constructor(s){this._ignorePathCasing=s}compare(s,o,c=!1){return s===o?0:(0,w.compare)(this.getComparisonKey(s,c),this.getComparisonKey(o,c))}isEqual(s,o,c=!1){return s===o?!0:!s||!o?!1:this.getComparisonKey(s,c)===this.getComparisonKey(o,c)}getComparisonKey(s,o=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,o,c=!1){if(s.scheme===o.scheme){if(s.scheme===k.Schemas.file)return n.isEqualOrParent(d(s),d(o),this._ignorePathCasing(s))&&s.query===o.query&&(c||s.fragment===o.fragment);if((0,t.isEqualAuthority)(s.authority,o.authority))return n.isEqualOrParent(s.path,o.path,this._ignorePathCasing(s),"/")&&s.query===o.query&&(c||s.fragment===o.fragment)}return!1}joinPath(s,...o){return _.URI.joinPath(s,...o)}basenameOrAuthority(s){return(0,t.basename)(s)||s.authority}basename(s){return R.posix.basename(s.path)}extname(s){return R.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let o;return s.scheme===k.Schemas.file?o=_.URI.file(R.dirname(d(s))).path:(o=R.posix.dirname(s.path),s.authority&&o.length&&o.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),o="/")),s.with({path:o})}normalizePath(s){if(!s.path.length)return s;let o;return s.scheme===k.Schemas.file?o=_.URI.file(R.normalize(d(s))).path:o=R.posix.normalize(s.path),s.with({path:o})}relativePath(s,o){if(s.scheme!==o.scheme||!(0,t.isEqualAuthority)(s.authority,o.authority))return;if(s.scheme===k.Schemas.file){const v=R.relative(d(s),d(o));return N.isWindows?n.toSlashes(v):v}let c=s.path||"/";const h=o.path||"/";if(this._ignorePathCasing(s)){let v=0;for(const L=Math.min(c.length,h.length);v<L&&!(c.charCodeAt(v)!==h.charCodeAt(v)&&c.charAt(v).toLowerCase()!==h.charAt(v).toLowerCase());v++);c=h.substr(0,v)+c.substr(v)}return R.posix.relative(c,h)}resolvePath(s,o){if(s.scheme===k.Schemas.file){const c=_.URI.file(R.resolve(d(s),o));return s.with({authority:c.authority,path:c.path})}return o=n.toPosixPath(o),s.with({path:R.posix.resolve(s.path,o)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,o){return s===o||s!==void 0&&o!==void 0&&(0,w.equalsIgnoreCase)(s,o)}hasTrailingPathSeparator(s,o=R.sep){if(s.scheme===k.Schemas.file){const c=d(s);return c.length>n.getRoot(c).length&&c[c.length-1]===o}else{const c=s.path;return c.length>1&&c.charCodeAt(c.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,o=R.sep){return(0,t.hasTrailingPathSeparator)(s,o)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,o=R.sep){let c=!1;if(s.scheme===k.Schemas.file){const h=d(s);c=h!==void 0&&h.length===n.getRoot(h).length&&h[h.length-1]===o}else{o="/";const h=s.path;c=h.length===1&&h.charCodeAt(h.length-1)===i.CharCode.Slash}return!c&&!(0,t.hasTrailingPathSeparator)(s,o)?s.with({path:s.path+"/"}):s}}t.ExtUri=b,t.extUri=new b(()=>!1),t.extUriBiasedIgnorePathCase=new b(e=>e.scheme===k.Schemas.file?!N.isLinux:!0),t.extUriIgnorePathCase=new b(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function y(e,s){const o=[];for(let c=0;c<e.length;c++){const h=s(e[c]);e.some((v,L)=>L===c?!1:(0,t.isEqualOrParent)(h,s(v)))||o.push(e[c])}return o}var p;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(L=>{const[S,r]=L.split(":");S&&r&&c.set(S,r)});const v=o.path.substring(0,o.path.indexOf(";"));return v&&c.set(e.META_DATA_MIME,v),c}e.parseMetaData=s})(p||(t.DataUri=p={}));function m(e,s,o){if(s){let c=e.path;return c&&c[0]!==R.posix.sep&&(c=R.posix.sep+c),e.with({scheme:o,authority:s,path:c})}return e.with({scheme:o})}}),define(De[12],we([1,0,39,6,3,2,52,5,63,26]),function(ne,t,i,n,k,R,N,w,_,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=b,t.createCancelablePromise=y,t.raceCancellation=p,t.raceCancellationError=m,t.raceCancellablePromises=e,t.raceTimeout=s,t.asPromise=o,t.promiseWithResolvers=c,t.timeout=W,t.disposableTimeout=U,t.sequence=D,t.first=x,t.firstParallel=z,t.retry=ee,t.createCancelableAsyncIterable=q;function b(l){return!!l&&typeof l.then=="function"}function y(l){const a=new i.CancellationTokenSource,g=l(a.token),C=new Promise((F,u)=>{const I=a.token.onCancellationRequested(()=>{I.dispose(),u(new n.CancellationError)});Promise.resolve(g).then(A=>{I.dispose(),a.dispose(),F(A)},A=>{I.dispose(),a.dispose(),u(A)})});return new class{cancel(){a.cancel(),a.dispose()}then(F,u){return C.then(F,u)}catch(F){return this.then(void 0,F)}finally(F){return C.finally(F)}}}function p(l,a,g){return new Promise((C,F)=>{const u=a.onCancellationRequested(()=>{u.dispose(),C(g)});l.then(C,F).finally(()=>u.dispose())})}function m(l,a){return new Promise((g,C)=>{const F=a.onCancellationRequested(()=>{F.dispose(),C(new n.CancellationError)});l.then(g,C).finally(()=>F.dispose())})}async function e(l){let a=-1;const g=l.map((C,F)=>C.then(u=>(a=F,u)));try{return await Promise.race(g)}finally{l.forEach((C,F)=>{F!==a&&C.cancel()})}}function s(l,a,g){let C;const F=setTimeout(()=>{C?.(void 0),g?.()},a);return Promise.race([l.finally(()=>clearTimeout(F)),new Promise(u=>C=u)])}function o(l){return new Promise((a,g)=>{const C=l();b(C)?C.then(a,g):a(C)})}function c(){let l,a;return{promise:new Promise((C,F)=>{l=C,a=F}),resolve:l,reject:a}}class h{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const g=()=>{if(this.queuedPromise=null,this.isDisposed)return;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(g,g).then(C)})}return new Promise((g,C)=>{this.queuedPromise.then(g,C)})}return this.activePromise=a(),new Promise((g,C)=>{this.activePromise.then(F=>{this.activePromise=null,g(F)},F=>{this.activePromise=null,C(F)})})}dispose(){this.isDisposed=!0}}t.Throttler=h;class v{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}t.Sequencer=v;class L{constructor(){this.promiseMap=new Map}queue(a,g){const F=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.promiseMap.get(a)===F&&this.promiseMap.delete(a)});return this.promiseMap.set(a,F),F}}t.SequencerByKey=L;const S=(l,a)=>{let g=!0;const C=setTimeout(()=>{g=!1,a()},l);return{isTriggered:()=>g,dispose:()=>{clearTimeout(C),g=!1}}},r=l=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,l())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class f{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,g=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,u)=>{this.doResolve=F,this.doReject=u}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=g===_.MicrotaskDelay?r(C):S(g,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=f;class E{constructor(a){this.delayer=new f(a),this.throttler=new h}trigger(a,g){return this.delayer.trigger(()=>this.throttler.queue(a),g)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=E;class T{constructor(){this._isOpen=!1,this._promise=new Promise((a,g)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=T;class H extends T{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=H;function W(l,a){return a?new Promise((g,C)=>{const F=setTimeout(()=>{u.dispose(),g()},l),u=a.onCancellationRequested(()=>{clearTimeout(F),u.dispose(),C(new n.CancellationError)})}):y(g=>W(l,g))}function U(l,a=0,g){const C=setTimeout(()=>{l(),g&&F.dispose()},a),F=(0,R.toDisposable)(()=>{clearTimeout(C),g?.deleteAndLeak(F)});return g?.add(F),F}function D(l){const a=[];let g=0;const C=l.length;function F(){return g<C?l[g++]():null}function u(I){I!=null&&a.push(I);const A=F();return A?A.then(u):Promise.resolve(a)}return Promise.resolve(null).then(u)}function x(l,a=C=>!!C,g=null){let C=0;const F=l.length,u=()=>{if(C>=F)return Promise.resolve(g);const I=l[C++];return Promise.resolve(I()).then(M=>a(M)?Promise.resolve(M):u())};return u()}function z(l,a=C=>!!C,g=null){if(l.length===0)return Promise.resolve(g);let C=l.length;const F=()=>{C=-1;for(const u of l)u.cancel?.()};return new Promise((u,I)=>{for(const A of l)A.then(M=>{--C>=0&&a(M)?(F(),u(M)):C===0&&u(g)}).catch(M=>{--C>=0&&(F(),I(M))})})}class O{constructor(a){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((g,C)=>{this.outstandingPromises.push({factory:a,c:g,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const g=a.factory();g.then(a.c,a.e),g.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=O;class P extends O{constructor(){super(1)}}t.Queue=P;class K{constructor(){this.sequentializer=new he,this.tasks=0}queue(a){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,a())):this.sequentializer.run(this.tasks++,a())}}t.LimitedQueue=K;class Q{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const a=new te;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueSize(a,g=N.extUri){const C=g.getComparisonKey(a);return this.queues.get(C)?.size??0}queueFor(a,g,C=N.extUri){const F=C.getComparisonKey(a);let u=this.queues.get(F);if(!u){u=new P;const I=this.drainListenerCount++,A=k.Event.once(u.onDrained)(()=>{u?.dispose(),this.queues.delete(F),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(I),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(I,A),this.queues.set(F,u)}return u.queue(g)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=Q;class X{constructor(a,g){this._isDisposed=!1,this._token=-1,typeof a=="function"&&typeof g=="number"&&this.setIfNotSet(a,g)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},g)}setIfNotSet(a,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},g))}}t.TimeoutTimer=X;class G{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(a,g,C=globalThis){if(this.isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const F=C.setInterval(()=>{a()},g);this.disposable=(0,R.toDisposable)(()=>{C.clearInterval(F),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}t.IntervalTimer=G;class J{constructor(a,g){this.timeoutToken=-1,this.runner=a,this.timeout=g,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=J;class ce{constructor(a,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=g,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ce;class pe extends J{constructor(a,g){super(a,g),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=pe;class Te extends R.Disposable{constructor(a,g){super(),this.options=a,this.handler=g,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const g of a)this.pendingWork.push(g);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=Te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(l,a)=>{(0,w.setTimeout0)(()=>{if(g)return;const C=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t._runWhenIdle=(l,a,g)=>{const C=l.requestIdleCallback(a,typeof g=="number"?{timeout:g}:void 0);let F=!1;return{dispose(){F||(F=!0,l.cancelIdleCallback(C))}}},t.runWhenGlobalIdle=l=>(0,t._runWhenIdle)(globalThis,l)}();class Fe{constructor(a,g){this._didRun=!1,this._executor=()=>{try{this._value=g()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(a,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Fe;class re extends Fe{constructor(a){super(globalThis,a)}}t.GlobalIdleValue=re;async function ee(l,a,g){let C;for(let F=0;F<g;F++)try{return await l()}catch(u){C=u,await W(a)}throw C}class he{isRunning(a){return typeof a=="number"?this._running?.taskId===a:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(a,g,C){return this._running={taskId:a,cancel:()=>C?.(),promise:g},g.then(()=>this.doneRunning(a),()=>this.doneRunning(a)),g}doneRunning(a){this._running&&a===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const a=this._queued;this._queued=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this._queued)this._queued.run=a;else{const{promise:g,resolve:C,reject:F}=c();this._queued={run:a,promise:g,promiseResolve:C,promiseReject:F}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=he;class le{constructor(a,g=()=>Date.now()){this.interval=a,this.nowFn=g,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}t.IntervalCounter=le;var Ne;(function(l){l[l.Resolved=0]="Resolved",l[l.Rejected=1]="Rejected"})(Ne||(Ne={}));class te{get isRejected(){return this.outcome?.outcome===Ne.Rejected}get isResolved(){return this.outcome?.outcome===Ne.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Ne.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((a,g)=>{this.completeCallback=a,this.errorCallback=g})}complete(a){return new Promise(g=>{this.completeCallback(a),this.outcome={outcome:Ne.Resolved,value:a},g()})}error(a){return new Promise(g=>{this.errorCallback(a),this.outcome={outcome:Ne.Rejected,value:a},g()})}cancel(){return this.error(new n.CancellationError)}}t.DeferredPromise=te;var be;(function(l){async function a(C){let F;const u=await Promise.all(C.map(I=>I.then(A=>A,A=>{F||(F=A)})));if(typeof F<"u")throw F;return u}l.settled=a;function g(C){return new Promise(async(F,u)=>{try{await C(F,u)}catch(I){u(I)}})}l.withAsyncBody=g})(be||(t.Promises=be={}));class Se{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(a){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=a.then(g=>(this._value=g,this._isResolved=!0,g),g=>{throw this._error=g,this._isResolved=!0,g})}requireValue(){if(!this._isResolved)throw new n.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=Se;class Oe{constructor(a){this._compute=a,this._promise=new d.Lazy(()=>new Se(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=Oe;var Re;(function(l){l[l.Initial=0]="Initial",l[l.DoneOK=1]="DoneOK",l[l.DoneError=2]="DoneError"})(Re||(Re={}));class We{static fromArray(a){return new We(g=>{g.emitMany(a)})}static fromPromise(a){return new We(async g=>{g.emitMany(await a)})}static fromPromises(a){return new We(async g=>{await Promise.all(a.map(async C=>g.emitOne(await C)))})}static merge(a){return new We(async g=>{await Promise.all(a.map(async C=>{for await(const F of C)g.emitOne(F)}))})}static{this.EMPTY=We.fromArray([])}constructor(a,g){this._state=Re.Initial,this._results=[],this._error=null,this._onReturn=g,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const C={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(a(C)),this.resolve()}catch(F){this.reject(F)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===Re.DoneError)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===Re.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(a,g){return new We(async C=>{for await(const F of a)C.emitOne(g(F))})}map(a){return We.map(this,a)}static filter(a,g){return new We(async C=>{for await(const F of a)g(F)&&C.emitOne(F)})}filter(a){return We.filter(this,a)}static coalesce(a){return We.filter(a,g=>!!g)}coalesce(){return We.coalesce(this)}static async toPromise(a){const g=[];for await(const C of a)g.push(C);return g}toPromise(){return We.toPromise(this)}emitOne(a){this._state===Re.Initial&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===Re.Initial&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===Re.Initial&&(this._state=Re.DoneOK,this._onStateChanged.fire())}reject(a){this._state===Re.Initial&&(this._state=Re.DoneError,this._error=a,this._onStateChanged.fire())}}t.AsyncIterableObject=We;class oe extends We{constructor(a,g){super(g),this._source=a}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=oe;function q(l){const a=new i.CancellationTokenSource,g=l(a.token);return new oe(a,async C=>{const F=a.token.onCancellationRequested(()=>{F.dispose(),a.dispose(),C.reject(new n.CancellationError)});try{for await(const u of g){if(a.token.isCancellationRequested)return;C.emitOne(u)}F.dispose(),a.dispose()}catch(u){F.dispose(),a.dispose(),C.reject(u)}})}class B{constructor(a){this._deferred=new te,this._asyncIterable=new We(F=>{if(g){F.reject(g);return}return C&&F.emitMany(C),this._errorFn=u=>F.reject(u),this._emitFn=u=>F.emitOne(u),this._deferred.p},a);let g,C;this._emitFn=F=>{C||(C=[]),C.push(F)},this._errorFn=F=>{g||(g=F)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(a){this._errorFn(a),this._deferred.complete()}emitOne(a){this._emitFn(a)}}t.AsyncIterableSource=B}),define(De[4],we([1,0,19,69,16,23,12,6,3,136,8,2,41,5,17,66,25,38]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o,c){"use strict";var h;Object.defineProperty(t,"__esModule",{value:!0}),t.SafeTriangle=t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=v,t.addDisposableListener=S,t.addDisposableGenericMouseDownListener=W,t.addDisposableGenericMouseMoveListener=U,t.addDisposableGenericMouseUpListener=D,t.runWhenWindowIdle=x,t.disposableWindowInterval=O,t.measure=Q,t.modify=X,t.addDisposableThrottledListener=pe,t.getComputedStyle=Te,t.getClientArea=Fe,t.getTopLeftOffset=he,t.size=le,t.position=Ne,t.getDomNodePagePosition=te,t.getDomNodeZoomLevel=be,t.getTotalWidth=Se,t.getContentWidth=Oe,t.getTotalScrollWidth=Re,t.getContentHeight=We,t.getTotalHeight=oe,t.getLargestChildWidth=B,t.isAncestor=l,t.setParentFlowTo=g,t.isAncestorUsingFlowTo=F,t.findParentWithClass=u,t.hasParentWithClass=I,t.isShadowRoot=A,t.isInShadowDOM=M,t.getShadowRoot=V,t.getActiveElement=Y,t.isActiveElement=ie,t.isAncestorOfActiveElement=ae,t.isActiveDocument=fe,t.getActiveDocument=_e,t.getActiveWindow=Ee,t.isGlobalStylesheet=Ie,t.createStyleSheet2=de,t.createStyleSheet=qe,t.cloneGlobalStylesheets=Xe,t.createMetaElement=lt,t.createLinkElement=rt,t.createCSSRule=ve,t.removeCSSRulesContainingSelector=Ae,t.isHTMLElement=Ve,t.isHTMLAnchorElement=Qe,t.isHTMLSpanElement=ot,t.isHTMLTextAreaElement=nt,t.isHTMLInputElement=ct,t.isHTMLButtonElement=st,t.isHTMLDivElement=dt,t.isMouseEvent=ht,t.isKeyboardEvent=Dt,t.isPointerEvent=ze,t.isDragEvent=ge,t.isEventLike=ke,t.saveParentsScrollTop=Be,t.restoreParentsScrollTop=Ye,t.trackFocus=ft,t.after=Je,t.append=mt,t.prepend=Tt,t.reset=Ct,t.$=ei,t.join=Oi,t.setVisibility=ki,t.show=ti,t.hide=ii,t.removeTabIndexAndUpdateFocus=Pi,t.finalHandler=Bi,t.domContentLoaded=xi,t.computeScreenAwareSize=Wi,t.windowOpenNoOpener=Hi,t.windowOpenPopup=zi,t.windowOpenWithSuccess=Ui,t.animate=Vi,t.asCSSUrl=Ki,t.asCSSPropertyValue=$i,t.asCssValueWithDefault=ri,t.triggerDownload=qi,t.triggerUpload=Gi,t.detectFullscreen=ji,t.hookDomPurifyHrefAndSrcSanitizer=oi,t.safeInnerHtml=Zi,t.multibyteAwareBtoa=Ji,t.getCookieValue=en,t.h=nn,t.svgElem=sn,t.copyAttributes=li,t.trackAttributes=on,i=Ue(i),_=Ue(_),d=Ue(d),m=Ue(m),h=function(){const $=new Map;(0,o.ensureCodeWindow)(o.mainWindow,1);const j={window:o.mainWindow,disposables:new y.DisposableStore};$.set(o.mainWindow.vscodeWindowId,j);const se=new _.Emitter,me=new _.Emitter,ye=new _.Emitter;function xe(Me,$e){return(typeof Me=="number"?$.get(Me):void 0)??($e?j:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:ye.event,onDidUnregisterWindow:me.event,registerWindow(Me){if($.has(Me.vscodeWindowId))return y.Disposable.None;const $e=new y.DisposableStore,Ke={window:Me,disposables:$e.add(new y.DisposableStore)};return $.set(Me.vscodeWindowId,Ke),$e.add((0,y.toDisposable)(()=>{$.delete(Me.vscodeWindowId),me.fire(Me)})),$e.add(S(Me,t.EventType.BEFORE_UNLOAD,()=>{ye.fire(Me)})),se.fire(Ke),$e},getWindows(){return $.values()},getWindowsCount(){return $.size},getWindowId(Me){return Me.vscodeWindowId},hasWindow(Me){return $.has(Me)},getWindowById:xe,getWindow(Me){const $e=Me;if($e?.ownerDocument?.defaultView)return $e.ownerDocument.defaultView.window;const Ke=Me;return Ke?.view?Ke.view.window:o.mainWindow},getDocument(Me){const $e=Me;return(0,t.getWindow)($e).document}}}(),t.registerWindow=h.registerWindow,t.getWindow=h.getWindow,t.getDocument=h.getDocument,t.getWindows=h.getWindows,t.getWindowsCount=h.getWindowsCount,t.getWindowId=h.getWindowId,t.getWindowById=h.getWindowById,t.hasWindow=h.hasWindow,t.onDidRegisterWindow=h.onDidRegisterWindow,t.onWillUnregisterWindow=h.onWillUnregisterWindow,t.onDidUnregisterWindow=h.onDidUnregisterWindow;function v($){for(;$.firstChild;)$.firstChild.remove()}class L{constructor(j,se,me,ye){this._node=j,this._type=se,this._handler=me,this._options=ye||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function S($,j,se,me){return new L($,j,se,me)}function r($,j){return function(se){return j(new R.StandardMouseEvent($,se))}}function f($){return function(j){return $(new k.StandardKeyboardEvent(j))}}const E=function(j,se,me,ye){let xe=me;return se==="click"||se==="mousedown"||se==="contextmenu"?xe=r((0,t.getWindow)(j),me):(se==="keydown"||se==="keypress"||se==="keyup")&&(xe=f(me)),S(j,se,xe,ye)};t.addStandardDisposableListener=E;const T=function(j,se,me){const ye=r((0,t.getWindow)(j),se);return W(j,ye,me)};t.addStandardDisposableGenericMouseDownListener=T;const H=function(j,se,me){const ye=r((0,t.getWindow)(j),se);return D(j,ye,me)};t.addStandardDisposableGenericMouseUpListener=H;function W($,j,se){return S($,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,j,se)}function U($,j,se){return S($,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,j,se)}function D($,j,se){return S($,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,j,se)}function x($,j,se){return(0,N._runWhenIdle)($,j,se)}class z extends N.AbstractIdleValue{constructor(j,se){super(j,se)}}t.WindowIdleValue=z;function O($,j,se,me){let ye=0;const xe=$.setInterval(()=>{ye++,(typeof me=="number"&&ye>=me||j()===!0)&&Me.dispose()},se),Me=(0,y.toDisposable)(()=>{$.clearInterval(xe)});return Me}class P extends N.IntervalTimer{constructor(j){super(),this.defaultTarget=j&&(0,t.getWindow)(j)}cancelAndSet(j,se,me){return super.cancelAndSet(j,se,me??this.defaultTarget)}}t.WindowIntervalTimer=P;class K{constructor(j,se=0){this._runner=j,this.priority=se,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(j){(0,w.onUnexpectedError)(j)}}static sort(j,se){return se.priority-j.priority}}(function(){const $=new Map,j=new Map,se=new Map,me=new Map,ye=xe=>{se.set(xe,!1);const Me=$.get(xe)??[];for(j.set(xe,Me),$.set(xe,[]),me.set(xe,!0);Me.length>0;)Me.sort(K.sort),Me.shift().execute();me.set(xe,!1)};t.scheduleAtNextAnimationFrame=(xe,Me,$e=0)=>{const Ke=(0,t.getWindowId)(xe),He=new K(Me,$e);let at=$.get(Ke);return at||(at=[],$.set(Ke,at)),at.push(He),se.get(Ke)||(se.set(Ke,!0),xe.requestAnimationFrame(()=>ye(Ke))),He},t.runAtThisOrScheduleAtNextAnimationFrame=(xe,Me,$e)=>{const Ke=(0,t.getWindowId)(xe);if(me.get(Ke)){const He=new K(Me,$e);let at=j.get(Ke);return at||(at=[],j.set(Ke,at)),at.push(He),He}else return(0,t.scheduleAtNextAnimationFrame)(xe,Me,$e)}})();function Q($,j){return(0,t.scheduleAtNextAnimationFrame)($,j,1e4)}function X($,j){return(0,t.scheduleAtNextAnimationFrame)($,j,-1e4)}const G=8,J=function($,j){return j};class ce extends y.Disposable{constructor(j,se,me,ye=J,xe=G){super();let Me=null,$e=0;const Ke=this._register(new N.TimeoutTimer),He=()=>{$e=new Date().getTime(),me(Me),Me=null};this._register(S(j,se,at=>{Me=ye(Me,at);const yt=new Date().getTime()-$e;yt>=xe?(Ke.cancel(),He()):Ke.setIfNotSet(He,xe-yt)}))}}function pe($,j,se,me,ye){return new ce($,j,se,me,ye)}function Te($){return(0,t.getWindow)($).getComputedStyle($,null)}function Fe($,j){const se=(0,t.getWindow)($),me=se.document;if($!==me.body)return new ee($.clientWidth,$.clientHeight);if(m.isIOS&&se?.visualViewport)return new ee(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ee(se.innerWidth,se.innerHeight);if(me.body&&me.body.clientWidth&&me.body.clientHeight)return new ee(me.body.clientWidth,me.body.clientHeight);if(me.documentElement&&me.documentElement.clientWidth&&me.documentElement.clientHeight)return new ee(me.documentElement.clientWidth,me.documentElement.clientHeight);if(j)return Fe(j);throw new Error("Unable to figure out browser width and height")}class re{static convertToPixels(j,se){return parseFloat(se)||0}static getDimension(j,se,me){const ye=Te(j),xe=ye?ye.getPropertyValue(se):"0";return re.convertToPixels(j,xe)}static getBorderLeftWidth(j){return re.getDimension(j,"border-left-width","borderLeftWidth")}static getBorderRightWidth(j){return re.getDimension(j,"border-right-width","borderRightWidth")}static getBorderTopWidth(j){return re.getDimension(j,"border-top-width","borderTopWidth")}static getBorderBottomWidth(j){return re.getDimension(j,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(j){return re.getDimension(j,"padding-left","paddingLeft")}static getPaddingRight(j){return re.getDimension(j,"padding-right","paddingRight")}static getPaddingTop(j){return re.getDimension(j,"padding-top","paddingTop")}static getPaddingBottom(j){return re.getDimension(j,"padding-bottom","paddingBottom")}static getMarginLeft(j){return re.getDimension(j,"margin-left","marginLeft")}static getMarginTop(j){return re.getDimension(j,"margin-top","marginTop")}static getMarginRight(j){return re.getDimension(j,"margin-right","marginRight")}static getMarginBottom(j){return re.getDimension(j,"margin-bottom","marginBottom")}}class ee{static{this.None=new ee(0,0)}constructor(j,se){this.width=j,this.height=se}with(j=this.width,se=this.height){return j!==this.width||se!==this.height?new ee(j,se):this}static is(j){return typeof j=="object"&&typeof j.height=="number"&&typeof j.width=="number"}static lift(j){return j instanceof ee?j:new ee(j.width,j.height)}static equals(j,se){return j===se?!0:!j||!se?!1:j.width===se.width&&j.height===se.height}}t.Dimension=ee;function he($){let j=$.offsetParent,se=$.offsetTop,me=$.offsetLeft;for(;($=$.parentNode)!==null&&$!==$.ownerDocument.body&&$!==$.ownerDocument.documentElement;){se-=$.scrollTop;const ye=A($)?null:Te($);ye&&(me-=ye.direction!=="rtl"?$.scrollLeft:-$.scrollLeft),$===j&&(me+=re.getBorderLeftWidth($),se+=re.getBorderTopWidth($),se+=$.offsetTop,me+=$.offsetLeft,j=$.offsetParent)}return{left:me,top:se}}function le($,j,se){typeof j=="number"&&($.style.width=`${j}px`),typeof se=="number"&&($.style.height=`${se}px`)}function Ne($,j,se,me,ye,xe="absolute"){typeof j=="number"&&($.style.top=`${j}px`),typeof se=="number"&&($.style.right=`${se}px`),typeof me=="number"&&($.style.bottom=`${me}px`),typeof ye=="number"&&($.style.left=`${ye}px`),$.style.position=xe}function te($){const j=$.getBoundingClientRect(),se=(0,t.getWindow)($);return{left:j.left+se.scrollX,top:j.top+se.scrollY,width:j.width,height:j.height}}function be($){let j=$,se=1;do{const me=Te(j).zoom;me!=null&&me!=="1"&&(se*=me),j=j.parentElement}while(j!==null&&j!==j.ownerDocument.documentElement);return se}function Se($){const j=re.getMarginLeft($)+re.getMarginRight($);return $.offsetWidth+j}function Oe($){const j=re.getBorderLeftWidth($)+re.getBorderRightWidth($),se=re.getPaddingLeft($)+re.getPaddingRight($);return $.offsetWidth-j-se}function Re($){const j=re.getMarginLeft($)+re.getMarginRight($);return $.scrollWidth+j}function We($){const j=re.getBorderTopWidth($)+re.getBorderBottomWidth($),se=re.getPaddingTop($)+re.getPaddingBottom($);return $.offsetHeight-j-se}function oe($){const j=re.getMarginTop($)+re.getMarginBottom($);return $.offsetHeight+j}function q($,j){if($===null)return 0;const se=he($),me=he(j);return se.left-me.left}function B($,j){const se=j.map(ye=>Math.max(Re(ye),Se(ye))+q(ye,$)||0);return Math.max(...se)}function l($,j){return!!j?.contains($)}const a="parentFlowToElementId";function g($,j){$.dataset[a]=j.id}function C($){const j=$.dataset[a];return typeof j=="string"?$.ownerDocument.getElementById(j):null}function F($,j){let se=$;for(;se;){if(se===j)return!0;if(Ve(se)){const me=C(se);if(me){se=me;continue}}se=se.parentNode}return!1}function u($,j,se){for(;$&&$.nodeType===$.ELEMENT_NODE;){if($.classList.contains(j))return $;if(se){if(typeof se=="string"){if($.classList.contains(se))return null}else if($===se)return null}$=$.parentNode}return null}function I($,j,se){return!!u($,j,se)}function A($){return $&&!!$.host&&!!$.mode}function M($){return!!V($)}function V($){for(;$.parentNode;){if($===$.ownerDocument?.body)return null;$=$.parentNode}return A($)?$:null}function Y(){let $=_e().activeElement;for(;$?.shadowRoot;)$=$.shadowRoot.activeElement;return $}function ie($){return Y()===$}function ae($){return l(Y(),$)}function fe($){return $.ownerDocument===_e()}function _e(){return(0,t.getWindowsCount)()<=1?o.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:j})=>j.document).find(j=>j.hasFocus())??o.mainWindow.document}function Ee(){return _e().defaultView?.window??o.mainWindow}const Le=new Map;function Ie($){return Le.has($)}function de(){return new Ce}class Ce{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(j){j!==this._currentCssStyle&&(this._currentCssStyle=j,this._styleSheet?this._styleSheet.innerText=j:this._styleSheet=qe(o.mainWindow.document.head,se=>se.innerText=j))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function qe($=o.mainWindow.document.head,j,se){const me=document.createElement("style");if(me.type="text/css",me.media="screen",j?.(me),$.appendChild(me),se&&se.add((0,y.toDisposable)(()=>me.remove())),$===o.mainWindow.document.head){const ye=new Set;Le.set(me,ye);for(const{window:xe,disposables:Me}of(0,t.getWindows)()){if(xe===o.mainWindow)continue;const $e=Me.add(tt(me,ye,xe));se?.add($e)}}return me}function Xe($){const j=new y.DisposableStore;for(const[se,me]of Le)j.add(tt(se,me,$));return j}function tt($,j,se){const me=new y.DisposableStore,ye=$.cloneNode(!0);se.document.head.appendChild(ye),me.add((0,y.toDisposable)(()=>ye.remove()));for(const xe of ue($))ye.sheet?.insertRule(xe.cssText,ye.sheet?.cssRules.length);return me.add(t.sharedMutationObserver.observe($,me,{childList:!0})(()=>{ye.textContent=$.textContent})),j.add(ye),me.add((0,y.toDisposable)(()=>j.delete(ye))),me}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe($,j,se){let me=this.mutationObservers.get($);me||(me=new Map,this.mutationObservers.set($,me));const ye=(0,s.hash)(se);let xe=me.get(ye);if(xe)xe.users+=1;else{const Me=new _.Emitter,$e=new MutationObserver(He=>Me.fire(He));$e.observe($,se);const Ke=xe={users:1,observer:$e,onDidMutate:Me.event};j.add((0,y.toDisposable)(()=>{Ke.users-=1,Ke.users===0&&(Me.dispose(),$e.disconnect(),me?.delete(ye),me?.size===0&&this.mutationObservers.delete($))})),me.set(ye,xe)}return xe.onDidMutate}};function lt($=o.mainWindow.document.head){return je("meta",$)}function rt($=o.mainWindow.document.head){return je("link",$)}function je($,j=o.mainWindow.document.head){const se=document.createElement($);return j.appendChild(se),se}let Ze=null;function Z(){return Ze||(Ze=qe()),Ze}function ue($){return $?.sheet?.rules?$.sheet.rules:$?.sheet?.cssRules?$.sheet.cssRules:[]}function ve($,j,se=Z()){if(!(!se||!j)){se.sheet?.insertRule(`${$} {${j}}`,0);for(const me of Le.get(se)??[])ve($,j,me)}}function Ae($,j=Z()){if(!j)return;const se=ue(j),me=[];for(let ye=0;ye<se.length;ye++){const xe=se[ye];Pe(xe)&&xe.selectorText.indexOf($)!==-1&&me.push(ye)}for(let ye=me.length-1;ye>=0;ye--)j.sheet?.deleteRule(me[ye]);for(const ye of Le.get(j)??[])Ae($,ye)}function Pe($){return typeof $.selectorText=="string"}function Ve($){return $ instanceof HTMLElement||$ instanceof(0,t.getWindow)($).HTMLElement}function Qe($){return $ instanceof HTMLAnchorElement||$ instanceof(0,t.getWindow)($).HTMLAnchorElement}function ot($){return $ instanceof HTMLSpanElement||$ instanceof(0,t.getWindow)($).HTMLSpanElement}function nt($){return $ instanceof HTMLTextAreaElement||$ instanceof(0,t.getWindow)($).HTMLTextAreaElement}function ct($){return $ instanceof HTMLInputElement||$ instanceof(0,t.getWindow)($).HTMLInputElement}function st($){return $ instanceof HTMLButtonElement||$ instanceof(0,t.getWindow)($).HTMLButtonElement}function dt($){return $ instanceof HTMLDivElement||$ instanceof(0,t.getWindow)($).HTMLDivElement}function ht($){return $ instanceof MouseEvent||$ instanceof(0,t.getWindow)($).MouseEvent}function Dt($){return $ instanceof KeyboardEvent||$ instanceof(0,t.getWindow)($).KeyboardEvent}function ze($){return $ instanceof PointerEvent||$ instanceof(0,t.getWindow)($).PointerEvent}function ge($){return $ instanceof DragEvent||$ instanceof(0,t.getWindow)($).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"};function ke($){const j=$;return!!(j&&typeof j.preventDefault=="function"&&typeof j.stopPropagation=="function")}t.EventHelper={stop:($,j)=>($.preventDefault(),j&&$.stopPropagation(),$)};function Be($){const j=[];for(let se=0;$&&$.nodeType===$.ELEMENT_NODE;se++)j[se]=$.scrollTop,$=$.parentNode;return j}function Ye($,j){for(let se=0;$&&$.nodeType===$.ELEMENT_NODE;se++)$.scrollTop!==j[se]&&($.scrollTop=j[se]),$=$.parentNode}class it extends y.Disposable{static hasFocusWithin(j){if(Ve(j)){const se=V(j),me=se?se.activeElement:j.ownerDocument.activeElement;return l(me,j)}else{const se=j;return l(se.document.activeElement,se.document)}}constructor(j){super(),this._onDidFocus=this._register(new _.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new _.Emitter),this.onDidBlur=this._onDidBlur.event;let se=it.hasFocusWithin(j),me=!1;const ye=()=>{me=!1,se||(se=!0,this._onDidFocus.fire())},xe=()=>{se&&(me=!0,(Ve(j)?(0,t.getWindow)(j):j).setTimeout(()=>{me&&(me=!1,se=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{it.hasFocusWithin(j)!==se&&(se?xe():ye())},this._register(S(j,t.EventType.FOCUS,ye,!0)),this._register(S(j,t.EventType.BLUR,xe,!0)),Ve(j)&&(this._register(S(j,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(S(j,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function ft($){return new it($)}function Je($,j){return $.after(j),j}function mt($,...j){if($.append(...j),j.length===1&&typeof j[0]!="string")return j[0]}function Tt($,j){return $.insertBefore(j,$.firstChild),j}function Ct($,...j){$.innerText="",mt($,...j)}const Qt=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Lt;(function($){$.HTML="http://www.w3.org/1999/xhtml",$.SVG="http://www.w3.org/2000/svg"})(Lt||(t.Namespace=Lt={}));function Jt($,j,se,...me){const ye=Qt.exec(j);if(!ye)throw new Error("Bad use of emmet");const xe=ye[1]||"div";let Me;return $!==Lt.HTML?Me=document.createElementNS($,xe):Me=document.createElement(xe),ye[3]&&(Me.id=ye[3]),ye[4]&&(Me.className=ye[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([$e,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test($e)?Me[$e]=Ke:$e==="selected"?Ke&&Me.setAttribute($e,"true"):Me.setAttribute($e,Ke))}),Me.append(...me),Me}function ei($,j,...se){return Jt(Lt.HTML,$,j,...se)}ei.SVG=function($,j,...se){return Jt(Lt.SVG,$,j,...se)};function Oi($,j){const se=[];return $.forEach((me,ye)=>{ye>0&&(j instanceof Node?se.push(j.cloneNode()):se.push(document.createTextNode(j))),se.push(me)}),se}function ki($,...j){$?ti(...j):ii(...j)}function ti(...$){for(const j of $)j.style.display="",j.removeAttribute("aria-hidden")}function ii(...$){for(const j of $)j.style.display="none",j.setAttribute("aria-hidden","true")}function Mi($,j){for(;$&&$.nodeType===$.ELEMENT_NODE;){if(Ve($)&&$.hasAttribute(j))return $;$=$.parentNode}return null}function Pi($){!$||!$.hasAttribute("tabIndex")||($.ownerDocument.activeElement===$&&Mi($.parentElement,"tabIndex")?.focus(),$.removeAttribute("tabindex"))}function Bi($){return j=>{j.preventDefault(),j.stopPropagation(),$(j)}}function xi($){return new Promise(j=>{if($.document.readyState==="complete"||$.document&&$.document.body!==null)j(void 0);else{const me=()=>{$.window.removeEventListener("DOMContentLoaded",me,!1),j()};$.window.addEventListener("DOMContentLoaded",me,!1)}})}function Wi($,j){const se=$.devicePixelRatio*j;return Math.max(1,Math.floor(se))/$.devicePixelRatio}function Hi($){o.mainWindow.open($,"_blank","noopener")}const ni=780,si=640;function zi($){const j=Math.floor(o.mainWindow.screenLeft+o.mainWindow.innerWidth/2-ni/2),se=Math.floor(o.mainWindow.screenTop+o.mainWindow.innerHeight/2-si/2);o.mainWindow.open($,"_blank",`width=${ni},height=${si},top=${se},left=${j}`)}function Ui($,j=!0){const se=o.mainWindow.open();return se?(j&&(se.opener=null),se.location.href=$,!0):!1}function Vi($,j){const se=()=>{j(),me=(0,t.scheduleAtNextAnimationFrame)($,se)};let me=(0,t.scheduleAtNextAnimationFrame)($,se);return(0,y.toDisposable)(()=>me.dispose())}p.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(o.mainWindow.location.href)?"https":"http");function Ki($){return $?`url('${p.FileAccess.uriToBrowserUri($).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function $i($){return`'${$.replace(/'/g,"%27")}'`}function ri($,j){if($!==void 0){const se=$.match(/^\s*var\((.+)\)$/);if(se){const me=se[1].split(",",2);return me.length===2&&(j=ri(me[1].trim(),j)),`var(${me[0]}, ${j})`}return $}return j}function qi($,j){let se;if(e.URI.isUri($))se=$.toString(!0);else{const xe=new Blob([$]);se=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(se))}const me=Ee(),ye=document.createElement("a");me.document.body.appendChild(ye),ye.download=j,ye.href=se,ye.click(),setTimeout(()=>ye.remove())}function Gi(){return new Promise($=>{const j=Ee(),se=document.createElement("input");j.document.body.appendChild(se),se.type="file",se.multiple=!0,_.Event.once(_.Event.fromDOMEventEmitter(se,"input"))(()=>{$(se.files??void 0)}),se.click(),setTimeout(()=>se.remove())})}var It;(function($){$[$.DOCUMENT=1]="DOCUMENT",$[$.BROWSER=2]="BROWSER"})(It||(t.DetectedFullscreenMode=It={}));function ji($){return $.document.fullscreenElement||$.document.webkitFullscreenElement||$.document.webkitIsFullScreen?{mode:It.DOCUMENT,guess:!1}:$.innerHeight===$.screen.height?{mode:It.BROWSER,guess:!1}:(m.isMacintosh||m.isLinux)&&$.outerHeight===$.screen.height&&$.outerWidth===$.screen.width?{mode:It.BROWSER,guess:!0}:null}function oi($,j=!1){const se=document.createElement("a");return d.addHook("afterSanitizeAttributes",me=>{for(const ye of["href","src"])if(me.hasAttribute(ye)){const xe=me.getAttribute(ye);if(ye==="href"&&xe.startsWith("#"))continue;if(se.href=xe,!$.includes(se.protocol.replace(/:$/,""))){if(j&&ye==="src"&&se.href.startsWith("data:"))continue;me.removeAttribute(ye)}}}),(0,y.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}const Yi=[p.Schemas.http,p.Schemas.https,p.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Xi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Zi($,j){const se=oi(Yi);try{const me=d.sanitize(j,Xi);$.innerHTML=me}finally{se.dispose()}}function Qi($){const j=new Uint16Array($.length);for(let ye=0;ye<j.length;ye++)j[ye]=$.charCodeAt(ye);let se="";const me=new Uint8Array(j.buffer);for(let ye=0;ye<me.length;ye++)se+=String.fromCharCode(me[ye]);return se}function Ji($){return btoa(Qi($))}class _t extends _.Emitter{constructor(){super(),this._subscriptions=new y.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(_.Event.runAndSubscribe(t.onDidRegisterWindow,({window:j,disposables:se})=>this.registerListeners(j,se),{window:o.mainWindow,disposables:this._subscriptions}))}registerListeners(j,se){se.add(S(j,"keydown",me=>{if(me.defaultPrevented)return;const ye=new k.StandardKeyboardEvent(me);if(!(ye.keyCode===b.KeyCode.Alt&&me.repeat)){if(me.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(me.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(me.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(me.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ye.keyCode!==b.KeyCode.Alt)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=me.altKey,this._keyStatus.ctrlKey=me.ctrlKey,this._keyStatus.metaKey=me.metaKey,this._keyStatus.shiftKey=me.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=me,this.fire(this._keyStatus))}},!0)),se.add(S(j,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!me.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!me.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!me.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=me.altKey,this._keyStatus.ctrlKey=me.ctrlKey,this._keyStatus.metaKey=me.metaKey,this._keyStatus.shiftKey=me.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=me,this.fire(this._keyStatus)))},!0)),se.add(S(j.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(S(j.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(S(j.document.body,"mousemove",me=>{me.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),se.add(S(j,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return _t.instance||(_t.instance=new _t),_t.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=_t;function en($){const j=document.cookie.match("(^|[^;]+)\\s*"+$+"\\s*=\\s*([^;]+)");return j?j.pop():void 0}class tn extends y.Disposable{constructor(j,se){super(),this.element=j,this.callbacks=se,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(S(this.element,t.EventType.DRAG_START,j=>{this.callbacks.onDragStart?.(j)})),this.callbacks.onDrag&&this._register(S(this.element,t.EventType.DRAG,j=>{this.callbacks.onDrag?.(j)})),this._register(S(this.element,t.EventType.DRAG_ENTER,j=>{this.counter++,this.dragStartTime=j.timeStamp,this.callbacks.onDragEnter?.(j)})),this._register(S(this.element,t.EventType.DRAG_OVER,j=>{j.preventDefault(),this.callbacks.onDragOver?.(j,j.timeStamp-this.dragStartTime)})),this._register(S(this.element,t.EventType.DRAG_LEAVE,j=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(j))})),this._register(S(this.element,t.EventType.DRAG_END,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(j)})),this._register(S(this.element,t.EventType.DROP,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(j)}))}}t.DragAndDropObserver=tn;const ai=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function nn($,...j){let se,me;Array.isArray(j[0])?(se={},me=j[0]):(se=j[0]||{},me=j[1]);const ye=ai.exec($);if(!ye||!ye.groups)throw new Error("Bad use of h");const xe=ye.groups.tag||"div",Me=document.createElement(xe);ye.groups.id&&(Me.id=ye.groups.id);const $e=[];if(ye.groups.class)for(const He of ye.groups.class.split("."))He!==""&&$e.push(He);if(se.className!==void 0)for(const He of se.className.split("."))He!==""&&$e.push(He);$e.length>0&&(Me.className=$e.join(" "));const Ke={};if(ye.groups.name&&(Ke[ye.groups.name]=Me),me)for(const He of me)Ve(He)?Me.appendChild(He):typeof He=="string"?Me.append(He):"root"in He&&(Object.assign(Ke,He),Me.appendChild(He.root));for(const[He,at]of Object.entries(se))if(He!=="className")if(He==="style")for(const[yt,wt]of Object.entries(at))Me.style.setProperty(Ot(yt),typeof wt=="number"?wt+"px":""+wt);else He==="tabIndex"?Me.tabIndex=at:Me.setAttribute(Ot(He),at.toString());return Ke.root=Me,Ke}function sn($,...j){let se,me;Array.isArray(j[0])?(se={},me=j[0]):(se=j[0]||{},me=j[1]);const ye=ai.exec($);if(!ye||!ye.groups)throw new Error("Bad use of h");const xe=ye.groups.tag||"div",Me=document.createElementNS("http://www.w3.org/2000/svg",xe);ye.groups.id&&(Me.id=ye.groups.id);const $e=[];if(ye.groups.class)for(const He of ye.groups.class.split("."))He!==""&&$e.push(He);if(se.className!==void 0)for(const He of se.className.split("."))He!==""&&$e.push(He);$e.length>0&&(Me.className=$e.join(" "));const Ke={};if(ye.groups.name&&(Ke[ye.groups.name]=Me),me)for(const He of me)Ve(He)?Me.appendChild(He):typeof He=="string"?Me.append(He):"root"in He&&(Object.assign(Ke,He),Me.appendChild(He.root));for(const[He,at]of Object.entries(se))if(He!=="className")if(He==="style")for(const[yt,wt]of Object.entries(at))Me.style.setProperty(Ot(yt),typeof wt=="number"?wt+"px":""+wt);else He==="tabIndex"?Me.tabIndex=at:Me.setAttribute(Ot(He),at.toString());return Ke.root=Me,Ke}function Ot($){return $.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function li($,j,se){for(const{name:me,value:ye}of $.attributes)(!se||se.includes(me))&&j.setAttribute(me,ye)}function rn($,j,se){const me=$.getAttribute(se);me?j.setAttribute(se,me):j.removeAttribute(se)}function on($,j,se){li($,j,se);const me=new y.DisposableStore;return me.add(t.sharedMutationObserver.observe($,me,{attributes:!0,attributeFilter:se})(ye=>{for(const xe of ye)xe.type==="attributes"&&xe.attributeName&&rn($,j,xe.attributeName)})),me}class an{constructor(j,se,me){this.originX=j,this.originY=se,this.triangles=[];const{top:ye,left:xe,right:Me,bottom:$e}=me.getBoundingClientRect(),Ke=this.triangles;let He=0;Ke[He++]=xe,Ke[He++]=ye,Ke[He++]=Me,Ke[He++]=ye,Ke[He++]=xe,Ke[He++]=ye,Ke[He++]=xe,Ke[He++]=$e,Ke[He++]=Me,Ke[He++]=ye,Ke[He++]=Me,Ke[He++]=$e,Ke[He++]=xe,Ke[He++]=$e,Ke[He++]=Me,Ke[He++]=$e}contains(j,se){const{triangles:me,originX:ye,originY:xe}=this;for(let Me=0;Me<4;Me++)if((0,c.isPointWithinTriangle)(j,se,ye,xe,me[2*Me],me[2*Me+1],me[2*Me+2],me[2*Me+3]))return!0;return!1}}t.SafeTriangle=an}),define(De[71],we([1,0,4,2,135]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=N;class R extends n.Disposable{constructor(_,d){super(),this._register((0,i.addDisposableListener)(_,"dragover",b=>{b.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{d(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(b=>{this._register((0,i.addDisposableListener)(_,b,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=R,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:k.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function N(w,_,d,b,y){const p=document.createElement("div");p.className=d,p.textContent=_,y&&(p.style.color=y),b&&(p.style.background=b),w.dataTransfer&&((0,i.getWindow)(w).document.body.appendChild(p),w.dataTransfer.setDragImage(p,-10,-10),setTimeout(()=>p.remove(),0))}}),define(De[72],we([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=n,t.renderFormattedText=k,t.createElement=R,i=Ue(i);function n(p,m={}){const e=R(m);return e.textContent=p,e}function k(p,m={}){const e=R(m);return _(e,d(p,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function R(p){const m=p.inline?"span":"div",e=document.createElement(m);return p.className&&(e.className=p.className),e}class N{constructor(m){this.source=m,this.index=0}eos(){return this.index>=this.source.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(p){p[p.Invalid=0]="Invalid",p[p.Root=1]="Root",p[p.Text=2]="Text",p[p.Bold=3]="Bold",p[p.Italics=4]="Italics",p[p.Action=5]="Action",p[p.ActionClose=6]="ActionClose",p[p.Code=7]="Code",p[p.NewLine=8]="NewLine"})(w||(w={}));function _(p,m,e,s){let o;if(m.type===w.Text)o=document.createTextNode(m.content||"");else if(m.type===w.Bold)o=document.createElement("b");else if(m.type===w.Italics)o=document.createElement("i");else if(m.type===w.Code&&s)o=document.createElement("code");else if(m.type===w.Action&&e){const c=document.createElement("a");e.disposables.add(i.addStandardDisposableListener(c,"click",h=>{e.callback(String(m.index),h)})),o=c}else m.type===w.NewLine?o=document.createElement("br"):m.type===w.Root&&(o=p);o&&p!==o&&p.appendChild(o),o&&Array.isArray(m.children)&&m.children.forEach(c=>{_(o,c,e,s)})}function d(p,m){const e={type:w.Root,children:[]};let s=0,o=e;const c=[],h=new N(p);for(;!h.eos();){let v=h.next();const L=v==="\\"&&y(h.peek(),m)!==w.Invalid;if(L&&(v=h.next()),!L&&b(v,m)&&v===h.peek()){h.advance(),o.type===w.Text&&(o=c.pop());const S=y(v,m);if(o.type===S||o.type===w.Action&&S===w.ActionClose)o=c.pop();else{const r={type:S,children:[]};S===w.Action&&(r.index=s,s++),o.children.push(r),c.push(o),o=r}}else if(v===`
`)o.type===w.Text&&(o=c.pop()),o.children.push({type:w.NewLine});else if(o.type!==w.Text){const S={type:w.Text,content:v};o.children.push(S),c.push(o),o=S}else o.content+=v}return o.type===w.Text&&(o=c.pop()),c.length,e}function b(p,m){return y(p,m)!==w.Invalid}function y(p,m){switch(p){case"*":return w.Bold;case"_":return w.Italics;case"[":return w.Action;case"]":return w.ActionClose;case"`":return m?w.Code:w.Invalid;default:return w.Invalid}}}),define(De[73],we([1,0,4,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0,i=Ue(i);class k{constructor(){this._hooks=new n.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(N,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const _=this._onStopCallback;this._onStopCallback=null,N&&_&&_(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(N,w,_,d,b){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=d,this._onStopCallback=b;let y=N;try{N.setPointerCapture(w),this._hooks.add((0,n.toDisposable)(()=>{try{N.releasePointerCapture(w)}catch{}}))}catch{y=i.getWindow(N)}this._hooks.add(i.addDisposableListener(y,i.EventType.POINTER_MOVE,p=>{if(p.buttons!==_){this.stopMonitoring(!0);return}p.preventDefault(),this._pointerMoveCallback(p)})),this._hooks.add(i.addDisposableListener(y,i.EventType.POINTER_UP,p=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=k});var et=this&&this.__decorate||function(ne,t,i,n){var k=arguments.length,R=k<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,t,i,n);else for(var w=ne.length-1;w>=0;w--)(N=ne[w])&&(R=(k<3?N(R):k>3?N(t,i,R):N(t,i))||R);return k>3&&R&&Object.defineProperty(t,i,R),R};define(De[33],we([1,0,4,25,9,36,3,2,60]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0,i=Ue(i),k=Ue(k);var d;(function(y){y.Tap="-monaco-gesturetap",y.Change="-monaco-gesturechange",y.Start="-monaco-gesturestart",y.End="-monaco-gesturesend",y.Contextmenu="-monaco-gesturecontextmenu"})(d||(t.EventType=d={}));class b extends w.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new _.LinkedList,this.ignoreTargets=new _.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(N.Event.runAndSubscribe(i.onDidRegisterWindow,({window:p,disposables:m})=>{m.add(i.addDisposableListener(p.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),m.add(i.addDisposableListener(p.document,"touchend",e=>this.onTouchEnd(p,e))),m.add(i.addDisposableListener(p.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:n.mainWindow,disposables:this._store}))}static addTarget(p){if(!b.isTouchDevice())return w.Disposable.None;b.INSTANCE||(b.INSTANCE=(0,w.markAsSingleton)(new b));const m=b.INSTANCE.targets.push(p);return(0,w.toDisposable)(m)}static ignoreTarget(p){if(!b.isTouchDevice())return w.Disposable.None;b.INSTANCE||(b.INSTANCE=(0,w.markAsSingleton)(new b));const m=b.INSTANCE.ignoreTargets.push(p);return(0,w.toDisposable)(m)}static isTouchDevice(){return"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(p){const m=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,s=p.targetTouches.length;e<s;e++){const o=p.targetTouches.item(e);this.activeTouches[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:m,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[m],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const c=this.newGestureEvent(d.Start,o.target);c.pageX=o.pageX,c.pageY=o.pageY,this.dispatchEvent(c)}this.dispatched&&(p.preventDefault(),p.stopPropagation(),this.dispatched=!1)}onTouchEnd(p,m){const e=Date.now(),s=Object.keys(this.activeTouches).length;for(let o=0,c=m.changedTouches.length;o<c;o++){const h=m.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(h.identifier))){console.warn("move of an UNKNOWN touch",h);continue}const v=this.activeTouches[h.identifier],L=Date.now()-v.initialTimeStamp;if(L<b.HOLD_DELAY&&Math.abs(v.initialPageX-k.tail(v.rollingPageX))<30&&Math.abs(v.initialPageY-k.tail(v.rollingPageY))<30){const S=this.newGestureEvent(d.Tap,v.initialTarget);S.pageX=k.tail(v.rollingPageX),S.pageY=k.tail(v.rollingPageY),this.dispatchEvent(S)}else if(L>=b.HOLD_DELAY&&Math.abs(v.initialPageX-k.tail(v.rollingPageX))<30&&Math.abs(v.initialPageY-k.tail(v.rollingPageY))<30){const S=this.newGestureEvent(d.Contextmenu,v.initialTarget);S.pageX=k.tail(v.rollingPageX),S.pageY=k.tail(v.rollingPageY),this.dispatchEvent(S)}else if(s===1){const S=k.tail(v.rollingPageX),r=k.tail(v.rollingPageY),f=k.tail(v.rollingTimestamps)-v.rollingTimestamps[0],E=S-v.rollingPageX[0],T=r-v.rollingPageY[0],H=[...this.targets].filter(W=>v.initialTarget instanceof Node&&W.contains(v.initialTarget));this.inertia(p,H,e,Math.abs(E)/f,E>0?1:-1,S,Math.abs(T)/f,T>0?1:-1,r)}this.dispatchEvent(this.newGestureEvent(d.End,v.initialTarget)),delete this.activeTouches[h.identifier]}this.dispatched&&(m.preventDefault(),m.stopPropagation(),this.dispatched=!1)}newGestureEvent(p,m){const e=document.createEvent("CustomEvent");return e.initEvent(p,!1,!0),e.initialTarget=m,e.tapCount=0,e}dispatchEvent(p){if(p.type===d.Tap){const m=new Date().getTime();let e=0;m-this._lastSetTapCountTime>b.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=m,p.tapCount=e}else(p.type===d.Change||p.type===d.Contextmenu)&&(this._lastSetTapCountTime=0);if(p.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(p.initialTarget))return;const m=[];for(const e of this.targets)if(e.contains(p.initialTarget)){let s=0,o=p.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent(p),this.dispatched=!0}}inertia(p,m,e,s,o,c,h,v,L){this.handle=i.scheduleAtNextAnimationFrame(p,()=>{const S=Date.now(),r=S-e;let f=0,E=0,T=!0;s+=b.SCROLL_FRICTION*r,h+=b.SCROLL_FRICTION*r,s>0&&(T=!1,f=o*s*r),h>0&&(T=!1,E=v*h*r);const H=this.newGestureEvent(d.Change);H.translationX=f,H.translationY=E,m.forEach(W=>W.dispatchEvent(H)),T||this.inertia(p,m,S,s,o,c+f,h,v,L+E)})}onTouchMove(p){const m=Date.now();for(let e=0,s=p.changedTouches.length;e<s;e++){const o=p.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const c=this.activeTouches[o.identifier],h=this.newGestureEvent(d.Change,c.initialTarget);h.translationX=o.pageX-k.tail(c.rollingPageX),h.translationY=o.pageY-k.tail(c.rollingPageY),h.pageX=o.pageX,h.pageY=o.pageY,this.dispatchEvent(h),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(o.pageX),c.rollingPageY.push(o.pageY),c.rollingTimestamps.push(m)}this.dispatched&&(p.preventDefault(),p.stopPropagation(),this.dispatched=!1)}}t.Gesture=b,et([R.memoize],b,"isTouchDevice",null)}),define(De[74],we([1,0,4,110]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=d,t.alert=b,t.status=y,i=Ue(i);const n=2e4;let k,R,N,w,_;function d(m){k=document.createElement("div"),k.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),k.appendChild(o),o};R=e(),N=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),k.appendChild(o),o};w=s(),_=s(),m.appendChild(k)}function b(m){k&&(R.textContent!==m?(i.clearNode(N),p(R,m)):(i.clearNode(R),p(N,m)))}function y(m){k&&(w.textContent!==m?(i.clearNode(_),p(w,m)):(i.clearNode(w),p(_,m)))}function p(m,e){i.clearNode(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(De[75],we([1,0,69,4,2,5,47,114]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ContextView=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.isAnchor=_,t.layout=e,n=Ue(n),R=Ue(R);var w;(function(c){c[c.ABSOLUTE=1]="ABSOLUTE",c[c.FIXED=2]="FIXED",c[c.FIXED_SHADOW=3]="FIXED_SHADOW"})(w||(t.ContextViewDOMPosition=w={}));function _(c){const h=c;return!!h&&typeof h.x=="number"&&typeof h.y=="number"}var d;(function(c){c[c.LEFT=0]="LEFT",c[c.RIGHT=1]="RIGHT"})(d||(t.AnchorAlignment=d={}));var b;(function(c){c[c.BELOW=0]="BELOW",c[c.ABOVE=1]="ABOVE"})(b||(t.AnchorPosition=b={}));var y;(function(c){c[c.VERTICAL=0]="VERTICAL",c[c.HORIZONTAL=1]="HORIZONTAL"})(y||(t.AnchorAxisAlignment=y={}));var p;(function(c){c[c.Before=0]="Before",c[c.After=1]="After"})(p||(t.LayoutAnchorPosition=p={}));var m;(function(c){c[c.AVOID=0]="AVOID",c[c.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(c,h,v){const L=v.mode===m.ALIGN?v.offset:v.offset+v.size,S=v.mode===m.ALIGN?v.offset+v.size:v.offset;return v.position===p.Before?h<=c-L?L:h<=S?S-h:Math.max(c-h,0):h<=S?S-h:h<=c-L?L:0}class s extends k.Disposable{static{this.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"]}static{this.BUBBLE_DOWN_EVENTS=["click"]}constructor(h,v){super(),this.container=null,this.useFixedPosition=!1,this.useShadowDOM=!1,this.delegate=null,this.toDisposeOnClean=k.Disposable.None,this.toDisposeOnSetContainer=k.Disposable.None,this.shadowRoot=null,this.shadowRootHostElement=null,this.view=n.$(".context-view"),n.hide(this.view),this.setContainer(h,v),this._register((0,k.toDisposable)(()=>this.setContainer(null,w.ABSOLUTE)))}setContainer(h,v){this.useFixedPosition=v!==w.ABSOLUTE;const L=this.useShadowDOM;if(this.useShadowDOM=v===w.FIXED_SHADOW,!(h===this.container&&L===this.useShadowDOM)&&(this.container&&(this.toDisposeOnSetContainer.dispose(),this.view.remove(),this.shadowRoot&&(this.shadowRoot=null,this.shadowRootHostElement?.remove(),this.shadowRootHostElement=null),this.container=null),h)){if(this.container=h,this.useShadowDOM){this.shadowRootHostElement=n.$(".shadow-root-host"),this.container.appendChild(this.shadowRootHostElement),this.shadowRoot=this.shadowRootHostElement.attachShadow({mode:"open"});const r=document.createElement("style");r.textContent=o,this.shadowRoot.appendChild(r),this.shadowRoot.appendChild(this.view),this.shadowRoot.appendChild(n.$("slot"))}else this.container.appendChild(this.view);const S=new k.DisposableStore;s.BUBBLE_UP_EVENTS.forEach(r=>{S.add(n.addStandardDisposableListener(this.container,r,f=>{this.onDOMEvent(f,!1)}))}),s.BUBBLE_DOWN_EVENTS.forEach(r=>{S.add(n.addStandardDisposableListener(this.container,r,f=>{this.onDOMEvent(f,!0)},!0))}),this.toDisposeOnSetContainer=S}}show(h){this.isVisible()&&this.hide(),n.clearNode(this.view),this.view.className="context-view monaco-component",this.view.style.top="0px",this.view.style.left="0px",this.view.style.zIndex=`${2575+(h.layer??0)}`,this.view.style.position=this.useFixedPosition?"fixed":"absolute",n.show(this.view),this.toDisposeOnClean=h.render(this.view)||k.Disposable.None,this.delegate=h,this.doLayout(),this.delegate.focus?.()}getViewElement(){return this.view}layout(){if(this.isVisible()){if(this.delegate.canRelayout===!1&&!(R.isIOS&&i.BrowserFeatures.pointerEvents)){this.hide();return}this.delegate?.layout?.(),this.doLayout()}}doLayout(){if(!this.isVisible())return;const h=this.delegate.getAnchor();let v;if(n.isHTMLElement(h)){const D=n.getDomNodePagePosition(h),x=n.getDomNodeZoomLevel(h);v={top:D.top*x,left:D.left*x,width:D.width*x,height:D.height*x}}else _(h)?v={top:h.y,left:h.x,width:h.width||1,height:h.height||2}:v={top:h.posy,left:h.posx,width:2,height:2};const L=n.getTotalWidth(this.view),S=n.getTotalHeight(this.view),r=this.delegate.anchorPosition||b.BELOW,f=this.delegate.anchorAlignment||d.LEFT,E=this.delegate.anchorAxisAlignment||y.VERTICAL;let T,H;const W=n.getActiveWindow();if(E===y.VERTICAL){const D={offset:v.top-W.pageYOffset,size:v.height,position:r===b.BELOW?p.Before:p.After},x={offset:v.left,size:v.width,position:f===d.LEFT?p.Before:p.After,mode:m.ALIGN};T=e(W.innerHeight,S,D)+W.pageYOffset,N.Range.intersects({start:T,end:T+S},{start:D.offset,end:D.offset+D.size})&&(x.mode=m.AVOID),H=e(W.innerWidth,L,x)}else{const D={offset:v.left,size:v.width,position:f===d.LEFT?p.Before:p.After},x={offset:v.top,size:v.height,position:r===b.BELOW?p.Before:p.After,mode:m.ALIGN};H=e(W.innerWidth,L,D),N.Range.intersects({start:H,end:H+L},{start:D.offset,end:D.offset+D.size})&&(x.mode=m.AVOID),T=e(W.innerHeight,S,x)+W.pageYOffset}this.view.classList.remove("top","bottom","left","right"),this.view.classList.add(r===b.BELOW?"bottom":"top"),this.view.classList.add(f===d.LEFT?"left":"right"),this.view.classList.toggle("fixed",this.useFixedPosition);const U=n.getDomNodePagePosition(this.container);this.view.style.top=`${T-(this.useFixedPosition?n.getDomNodePagePosition(this.view).top:U.top)}px`,this.view.style.left=`${H-(this.useFixedPosition?n.getDomNodePagePosition(this.view).left:U.left)}px`,this.view.style.width="initial"}hide(h){const v=this.delegate;this.delegate=null,v?.onHide&&v.onHide(h),this.toDisposeOnClean.dispose(),n.hide(this.view)}isVisible(){return!!this.delegate}onDOMEvent(h,v){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(h,n.getWindow(h).document.activeElement):v&&!n.isAncestor(h.target,this.container)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.ContextView=s;const o=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(De[137],we([1,0,4,22]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=R,t.renderIcon=N,i=Ue(i);const k=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function R(w){const _=new Array;let d,b=0,y=0;for(;(d=k.exec(w))!==null;){y=d.index||0,b<y&&_.push(w.substring(b,y)),b=(d.index||0)+d[0].length;const[,p,m]=d;_.push(p?`$(${m})`:N({id:m}))}return b<w.length&&_.push(w.substring(b)),_}function N(w){const _=i.$("span");return _.classList.add(...n.ThemeIcon.asClassNameArray(w)),_}}),define(De[138],we([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;class n{constructor(R){this.renderers=R,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(R){let N=this.getTemplateCache(R).pop(),w=!1;if(N)w=this.transactionNodesPendingRemoval.has(N.domNode),w&&this.transactionNodesPendingRemoval.delete(N.domNode);else{const _=(0,i.$)(".monaco-list-row"),b=this.getRenderer(R).renderTemplate(_);N={domNode:_,templateId:R,templateData:b}}return{row:N,isReusingConnectedDomNode:w}}release(R){R&&this.releaseRow(R)}transact(R){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{R()}finally{for(const N of this.transactionNodesPendingRemoval)this.doRemoveNode(N);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(R){const{domNode:N,templateId:w}=R;N&&(this.inTransaction?this.transactionNodesPendingRemoval.add(N):this.doRemoveNode(N)),this.getTemplateCache(w).push(R)}doRemoveNode(R){R.classList.remove("scrolling"),R.remove()}getTemplateCache(R){let N=this.cache.get(R);return N||(N=[],this.cache.set(R,N)),N}dispose(){this.cache.forEach((R,N)=>{for(const w of R)this.getRenderer(N).disposeTemplate(w.templateData),w.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(R){const N=this.renderers.get(R);if(!N)throw new Error(`No renderer found for ${R}`);return N}}t.RowCache=n}),define(De[139],we([1,0,12,2,20]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class R extends n.Disposable{constructor(w,_,d){super(),this._visibility=w,this._visibleClassName=_,this._invisibleClassName=d,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new i.TimeoutTimer)}setVisibility(w){this._visibility!==w&&(this._visibility=w,this._updateShouldBeVisible())}setShouldBeVisible(w){this._rawShouldBeVisible=w,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===k.ScrollbarVisibility.Hidden?!1:this._visibility===k.ScrollbarVisibility.Visible?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const w=this._applyVisibilitySetting();this._shouldBeVisible!==w&&(this._shouldBeVisible=w,this.ensureVisibility())}setIsNeeded(w){this._isNeeded!==w&&(this._isNeeded=w,this.ensureVisibility())}setDomNode(w){this._domNode=w,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(w){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(w?" fade":"")))}}t.ScrollbarVisibilityController=R}),define(De[140],we([1,0,4,33,9,3,8,2,5]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0,i=Ue(i),k=Ue(k);class d extends w.Disposable{constructor(y,p,m,e){super(),this.selected=0,this.selectBoxOptions=e||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new R.Emitter),this.styles=m,this.registerListeners(),this.setOptions(y,p)}registerListeners(){this._register(n.Gesture.addTarget(this.selectElement)),[n.EventType.Tap].forEach(y=>{this._register(i.addDisposableListener(this.selectElement,y,p=>{this.selectElement.focus()}))}),this._register(i.addStandardDisposableListener(this.selectElement,"click",y=>{i.EventHelper.stop(y,!0)})),this._register(i.addStandardDisposableListener(this.selectElement,"change",y=>{this.selectElement.title=y.target.value,this._onDidSelect.fire({index:y.target.selectedIndex,selected:y.target.value})})),this._register(i.addStandardDisposableListener(this.selectElement,"keydown",y=>{let p=!1;_.isMacintosh?(y.keyCode===N.KeyCode.DownArrow||y.keyCode===N.KeyCode.UpArrow||y.keyCode===N.KeyCode.Space)&&(p=!0):(y.keyCode===N.KeyCode.DownArrow&&y.altKey||y.keyCode===N.KeyCode.Space||y.keyCode===N.KeyCode.Enter)&&(p=!0),p&&y.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(y,p){(!this.options||!k.equals(this.options,y))&&(this.options=y,this.selectElement.options.length=0,this.options.forEach((m,e)=>{this.selectElement.add(this.createOption(m.text,e,m.isDisabled))})),p!==void 0&&this.select(p)}select(y){this.options.length===0?this.selected=0:y>=0&&y<this.options.length?this.selected=y:y>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(y){this.selectBoxOptions.ariaLabel=y,this.selectElement.setAttribute("aria-label",y)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setEnabled(y){this.selectElement.disabled=!y}setFocusable(y){this.selectElement.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(y){this.styles=y,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(y,p,m){const e=document.createElement("option");return e.value=y,e.text=y,e.disabled=!!m,e}}t.SelectBoxNative=d}),define(De[76],we([1,0,35,9,12,63,105,3,37]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=d,t.getVisibleState=b;function d(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function b(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function y(m){return typeof m.collapsible=="boolean"}class p{constructor(e,s,o,c={}){this.user=e,this.list=s,this.rootRef=[],this.eventBufferer=new w.EventBufferer,this._onDidChangeCollapseState=new w.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new w.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new w.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new k.Delayer(R.MicrotaskDelay),this.collapseByDefault=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.allowNonCollapsibleParents=c.allowNonCollapsibleParents??!1,this.filter=c.filter,this.autoExpandSingleChildren=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.root={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,o=_.Iterable.empty(),c={}){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");c.diffIdentityProvider?this.spliceSmart(c.diffIdentityProvider,e,s,o,c):this.spliceSimple(e,s,o,c)}spliceSmart(e,s,o,c=_.Iterable.empty(),h,v=h.diffDepth??0){const{parentNode:L}=this.getParentNodeWithListIndex(s);if(!L.lastDiffIds)return this.spliceSimple(s,o,c,h);const S=[...c],r=s[s.length-1],f=new N.LcsDiff({getElements:()=>L.lastDiffIds},{getElements:()=>[...L.children.slice(0,r),...S,...L.children.slice(r+o)].map(U=>e.getId(U.element).toString())}).ComputeDiff(!1);if(f.quitEarly)return L.lastDiffIds=void 0,this.spliceSimple(s,o,S,h);const E=s.slice(0,-1),T=(U,D,x)=>{if(v>0)for(let z=0;z<x;z++)U--,D--,this.spliceSmart(e,[...E,U,0],Number.MAX_SAFE_INTEGER,S[D].children,h,v-1)};let H=Math.min(L.children.length,r+o),W=S.length;for(const U of f.changes.sort((D,x)=>x.originalStart-D.originalStart))T(H,W,H-(U.originalStart+U.originalLength)),H=U.originalStart,W=U.modifiedStart-r,this.spliceSimple([...E,H],U.originalLength,_.Iterable.slice(S,W,W+U.modifiedLength),h);T(H,W,H)}spliceSimple(e,s,o=_.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:h,diffIdentityProvider:v}){const{parentNode:L,listIndex:S,revealed:r,visible:f}=this.getParentNodeWithListIndex(e),E=[],T=_.Iterable.map(o,K=>this.createTreeNode(K,L,L.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r,E,c)),H=e[e.length-1];let W=0;for(let K=H;K>=0&&K<L.children.length;K--){const Q=L.children[K];if(Q.visible){W=Q.visibleChildIndex;break}}const U=[];let D=0,x=0;for(const K of T)U.push(K),x+=K.renderNodeCount,K.visible&&(K.visibleChildIndex=W+D++);const z=(0,n.splice)(L.children,H,s,U);v?L.lastDiffIds?(0,n.splice)(L.lastDiffIds,H,s,U.map(K=>v.getId(K.element).toString())):L.lastDiffIds=L.children.map(K=>v.getId(K.element).toString()):L.lastDiffIds=void 0;let O=0;for(const K of z)K.visible&&O++;if(O!==0)for(let K=H+U.length;K<L.children.length;K++){const Q=L.children[K];Q.visible&&(Q.visibleChildIndex-=O)}if(L.visibleChildrenCount+=D-O,r&&f){const K=z.reduce((Q,X)=>Q+(X.visible?X.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(L,x-K),this.list.splice(S,K,E)}if(z.length>0&&h){const K=Q=>{h(Q),Q.children.forEach(K)};z.forEach(K)}this._onDidSplice.fire({insertedNodes:U,deletedNodes:z});let P=L;for(;P;){if(P.visibility===i.TreeVisibility.Recurse){this.refilterDelayer.trigger(()=>this.refilter());break}P=P.parent}}rerender(e){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:o,revealed:c}=this.getTreeNodeWithListIndex(e);s.visible&&c&&this.list.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{listIndex:o}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(o,s)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:c}=this.getTreeNodeWithListIndex(e);return o&&c?s:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,s){const o=this.getTreeNode(e);typeof s>"u"&&(s=!o.collapsible);const c={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,c))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,s,o){const c=this.getTreeNode(e);typeof s>"u"&&(s=!c.collapsed);const h={collapsed:s,recursive:o||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,h))}_setCollapseState(e,s){const{node:o,listIndex:c,revealed:h}=this.getTreeNodeWithListIndex(e),v=this._setListNodeCollapseState(o,c,h,s);if(o!==this.root&&this.autoExpandSingleChildren&&v&&!y(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let L=-1;for(let S=0;S<o.children.length;S++)if(o.children[S].visible)if(L>-1){L=-1;break}else L=S;L>-1&&this._setCollapseState([...e,L],s)}return v}_setListNodeCollapseState(e,s,o,c){const h=this._setNodeCollapseState(e,c,!1);if(!o||!e.visible||!h)return h;const v=e.renderNodeCount,L=this.updateNodeAfterCollapseChange(e),S=v-(s===-1?0:1);return this.list.splice(s+1,S,L.slice(1)),h}_setNodeCollapseState(e,s,o){let c;if(e===this.root?c=!1:(y(s)?(c=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(c=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):c=!1,c&&this._onDidChangeCollapseState.fire({node:e,deep:o})),!y(s)&&s.recursive)for(const h of e.children)c=this._setNodeCollapseState(h,s,!0)||c;return c}expandTo(e){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,s),this.refilterDelayer.cancel()}createTreeNode(e,s,o,c,h,v){const L={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},S=this._filterNode(L,o);L.visibility=S,c&&h.push(L);const r=e.children||_.Iterable.empty(),f=c&&S!==i.TreeVisibility.Hidden&&!L.collapsed;let E=0,T=1;for(const H of r){const W=this.createTreeNode(H,L,S,f,h,v);L.children.push(W),T+=W.renderNodeCount,W.visible&&(W.visibleChildIndex=E++)}return this.allowNonCollapsibleParents||(L.collapsible=L.collapsible||L.children.length>0),L.visibleChildrenCount=E,L.visible=S===i.TreeVisibility.Recurse?E>0:S===i.TreeVisibility.Visible,L.visible?L.collapsed||(L.renderNodeCount=T):(L.renderNodeCount=0,c&&h.pop()),v?.(L),L}updateNodeAfterCollapseChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterCollapseChange(e,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterCollapseChange(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(o,s);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterFilterChange(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterFilterChange(e,s,o,c=!0){let h;if(e!==this.root){if(h=this._filterNode(e,s),h===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;c&&o.push(e)}const v=o.length;e.renderNodeCount=e===this.root?0:1;let L=!1;if(!e.collapsed||h!==i.TreeVisibility.Hidden){let S=0;for(const r of e.children)L=this._updateNodeAfterFilterChange(r,h,o,c&&!e.collapsed)||L,r.visible&&(r.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=h===i.TreeVisibility.Recurse?L:h===i.TreeVisibility.Visible,e.visibility=h),e.visible?e.collapsed||(e.renderNodeCount+=o.length-v):(e.renderNodeCount=0,c&&o.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,s){const o=this.filter?this.filter.filter(e.element,s):i.TreeVisibility.Visible;return typeof o=="boolean"?(e.filterData=void 0,o?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):d(o)?(e.filterData=o.data,b(o.visibility)):(e.filterData=void 0,b(o))}hasTreeNode(e,s=this.root){if(!e||e.length===0)return!0;const[o,...c]=e;return o<0||o>s.children.length?!1:this.hasTreeNode(c,s.children[o])}getTreeNode(e,s=this.root){if(!e||e.length===0)return s;const[o,...c]=e;if(o<0||o>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");return this.getTreeNode(c,s.children[o])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:c,visible:h}=this.getParentNodeWithListIndex(e),v=e[e.length-1];if(v<0||v>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");const L=s.children[v];return{node:L,listIndex:o,revealed:c,visible:h&&L.visible}}getParentNodeWithListIndex(e,s=this.root,o=0,c=!0,h=!0){const[v,...L]=e;if(v<0||v>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");for(let S=0;S<v;S++)o+=s.children[S].renderNodeCount;return c=c&&!s.collapsed,h=h&&s.visible,L.length===0?{parentNode:s,listIndex:o,revealed:c,visible:h}:this.getParentNodeWithListIndex(L,s.children[v],o+1,c,h)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.tail2)(e)[0]}getFirstElementChild(e){const s=this.getTreeNode(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.getTreeNode(e);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=p}),define(De[141],we([1,0,76,35,37]),function(ne,t,i,n,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class R{get size(){return this.nodes.size}constructor(w,_,d={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new i.IndexTreeModel(w,_,null,d),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,d.sorter&&(this.sorter={compare(b,y){return d.sorter.compare(b.element,y.element)}}),this.identityProvider=d.identityProvider}setChildren(w,_=k.Iterable.empty(),d={}){const b=this.getElementLocation(w);this._setChildren(b,this.preserveCollapseState(_),d)}_setChildren(w,_=k.Iterable.empty(),d){const b=new Set,y=new Set,p=e=>{if(e.element===null)return;const s=e;if(b.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();y.add(o),this.nodesByIdentity.set(o,s)}d.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(b.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();y.has(o)||this.nodesByIdentity.delete(o)}d.onDidDeleteNode?.(s)};this.model.splice([...w,0],Number.MAX_VALUE,_,{...d,onDidCreateNode:p,onDidDeleteNode:m})}preserveCollapseState(w=k.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),k.Iterable.map(w,_=>{let d=this.nodes.get(_.element);if(!d&&this.identityProvider){const p=this.identityProvider.getId(_.element).toString();d=this.nodesByIdentity.get(p)}if(!d){let p;return typeof _.collapsed>"u"?p=void 0:_.collapsed===n.ObjectTreeElementCollapseState.Collapsed||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?p=!0:_.collapsed===n.ObjectTreeElementCollapseState.Expanded||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?p=!1:p=!!_.collapsed,{..._,children:this.preserveCollapseState(_.children),collapsed:p}}const b=typeof _.collapsible=="boolean"?_.collapsible:d.collapsible;let y;return typeof _.collapsed>"u"||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||_.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?y=d.collapsed:_.collapsed===n.ObjectTreeElementCollapseState.Collapsed?y=!0:_.collapsed===n.ObjectTreeElementCollapseState.Expanded?y=!1:y=!!_.collapsed,{..._,collapsible:b,collapsed:y,children:this.preserveCollapseState(_.children)}})}rerender(w){const _=this.getElementLocation(w);this.model.rerender(_)}updateElementHeight(w,_){const d=this.getElementLocation(w);this.model.updateElementHeight(d,_)}resort(w=null,_=!0){if(!this.sorter)return;const d=this.getElementLocation(w),b=this.model.getNode(d);this._setChildren(d,this.resortChildren(b,_),{})}resortChildren(w,_,d=!0){let b=[...w.children];return(_||d)&&(b=b.sort(this.sorter.compare.bind(this.sorter))),k.Iterable.map(b,y=>({element:y.element,collapsible:y.collapsible,collapsed:y.collapsed,children:this.resortChildren(y,_,!1)}))}getFirstElementChild(w=null){const _=this.getElementLocation(w);return this.model.getFirstElementChild(_)}getLastElementAncestor(w=null){const _=this.getElementLocation(w);return this.model.getLastElementAncestor(_)}has(w){return this.nodes.has(w)}getListIndex(w){const _=this.getElementLocation(w);return this.model.getListIndex(_)}getListRenderCount(w){const _=this.getElementLocation(w);return this.model.getListRenderCount(_)}isCollapsible(w){const _=this.getElementLocation(w);return this.model.isCollapsible(_)}setCollapsible(w,_){const d=this.getElementLocation(w);return this.model.setCollapsible(d,_)}isCollapsed(w){const _=this.getElementLocation(w);return this.model.isCollapsed(_)}setCollapsed(w,_,d){const b=this.getElementLocation(w);return this.model.setCollapsed(b,_,d)}expandTo(w){const _=this.getElementLocation(w);this.model.expandTo(_)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);return _}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new n.TreeError(this.user,"Invalid getParentNodeLocation call");const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);const d=this.model.getNodeLocation(_),b=this.model.getParentNodeLocation(d);return this.model.getNode(b).element}getElementLocation(w){if(w===null)return[];const _=this.nodes.get(w);if(!_)throw new n.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(_)}}t.ObjectTreeModel=R}),define(De[24],we([1,0,4,16,23,33,2]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0,i=Ue(i);class w extends N.Disposable{onclick(d,b){this._register(i.addDisposableListener(d,i.EventType.CLICK,y=>b(new k.StandardMouseEvent(i.getWindow(d),y))))}onmousedown(d,b){this._register(i.addDisposableListener(d,i.EventType.MOUSE_DOWN,y=>b(new k.StandardMouseEvent(i.getWindow(d),y))))}onmouseover(d,b){this._register(i.addDisposableListener(d,i.EventType.MOUSE_OVER,y=>b(new k.StandardMouseEvent(i.getWindow(d),y))))}onmouseleave(d,b){this._register(i.addDisposableListener(d,i.EventType.MOUSE_LEAVE,y=>b(new k.StandardMouseEvent(i.getWindow(d),y))))}onkeydown(d,b){this._register(i.addDisposableListener(d,i.EventType.KEY_DOWN,y=>b(new n.StandardKeyboardEvent(y))))}onkeyup(d,b){this._register(i.addDisposableListener(d,i.EventType.KEY_UP,y=>b(new n.StandardKeyboardEvent(y))))}oninput(d,b){this._register(i.addDisposableListener(d,i.EventType.INPUT,b))}onblur(d,b){this._register(i.addDisposableListener(d,i.EventType.BLUR,b))}onfocus(d,b){this._register(i.addDisposableListener(d,i.EventType.FOCUS,b))}onchange(d,b){this._register(i.addDisposableListener(d,i.EventType.CHANGE,b))}ignoreGesture(d){return R.Gesture.ignoreTarget(d)}}t.Widget=w}),define(De[53],we([1,0,73,24,12,22,4]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,N=Ue(N),t.ARROW_IMG_SIZE=11;class w extends n.Widget{constructor(d){super(),this._onActivate=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...R.ThemeIcon.asClassNameArray(d.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._register(N.addStandardDisposableListener(this.bgDomNode,N.EventType.POINTER_DOWN,b=>this._arrowPointerDown(b))),this._register(N.addStandardDisposableListener(this.domNode,N.EventType.POINTER_DOWN,b=>this._arrowPointerDown(b))),this._pointerdownRepeatTimer=this._register(new N.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new k.TimeoutTimer)}_arrowPointerDown(d){if(!d.target||!(d.target instanceof Element))return;const b=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,N.getWindow(d))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(b,200),this._pointerMoveMonitor.startMonitoring(d.target,d.pointerId,d.buttons,y=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),d.preventDefault()}}t.ScrollbarArrow=w}),define(De[77],we([1,0,4,56,73,53,139,24,5]),function(ne,t,i,n,k,R,N,w,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0,i=Ue(i),_=Ue(_);const d=140;class b extends w.Widget{constructor(p){super(),this._lazyRender=p.lazyRender,this._host=p.host,this._scrollable=p.scrollable,this._scrollByPage=p.scrollByPage,this._scrollbarState=p.scrollbarState,this._visibilityController=this._register(new N.ScrollbarVisibilityController(p.visibility,"visible scrollbar "+p.extraScrollbarClassName,"invisible scrollbar "+p.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new k.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,n.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(i.addDisposableListener(this.domNode.domNode,i.EventType.POINTER_DOWN,m=>this._domNodePointerDown(m)))}_createArrow(p){const m=this._register(new R.ScrollbarArrow(p));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}_createSlider(p,m,e,s){this.slider=(0,n.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(p),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(i.addDisposableListener(this.slider.domNode,i.EventType.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))})),this.onclick(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}_onElementSize(p){return this._scrollbarState.setVisibleSize(p)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(p){return this._scrollbarState.setScrollSize(p)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(p){return this._scrollbarState.setScrollPosition(p)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(p){p.target===this.domNode.domNode&&this._onPointerDown(p)}delegatePointerDown(p){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this._scrollbarState.getSliderPosition(),s=m+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),o=this._sliderPointerPosition(p);e<=o&&o<=s?p.button===0&&(p.preventDefault(),this._sliderPointerDown(p)):this._onPointerDown(p)}_onPointerDown(p){let m,e;if(p.target===this.domNode.domNode&&typeof p.offsetX=="number"&&typeof p.offsetY=="number")m=p.offsetX,e=p.offsetY;else{const o=i.getDomNodePagePosition(this.domNode.domNode);m=p.pageX-o.left,e=p.pageY-o.top}const s=this._pointerDownRelativePosition(m,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),p.button===0&&(p.preventDefault(),this._sliderPointerDown(p))}_sliderPointerDown(p){if(!p.target||!(p.target instanceof Element))return;const m=this._sliderPointerPosition(p),e=this._sliderOrthogonalPointerPosition(p),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(p.target,p.pointerId,p.buttons,o=>{const c=this._sliderOrthogonalPointerPosition(o),h=Math.abs(c-e);if(_.isWindows&&h>d){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const L=this._sliderPointerPosition(o)-m;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(L))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(p){const m={};this.writeScrollPosition(m,p),this._scrollable.setScrollPositionNow(m)}updateScrollbarSize(p){this._updateScrollbarSize(p),this._scrollbarState.setScrollbarSize(p),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=b}),define(De[142],we([1,0,23,77,53,57,21,20]),function(ne,t,i,n,k,R,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class _ extends n.AbstractScrollbar{constructor(b,y,p){const m=b.getScrollDimensions(),e=b.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:p,scrollbarState:new R.ScrollbarState(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===w.ScrollbarVisibility.Hidden?0:y.horizontalScrollbarSize,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const s=(y.arrowSize-k.ARROW_IMG_SIZE)/2,o=(y.horizontalScrollbarSize-k.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonLeft,top:o,left:s,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:s,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}_updateSlider(b,y){this.slider.setWidth(b),this.slider.setLeft(y)}_renderDomNode(b,y){this.domNode.setWidth(b),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this._shouldRender=this._onElementScrollSize(b.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(b.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(b.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(b,y){return b}_sliderPointerPosition(b){return b.pageX}_sliderOrthogonalPointerPosition(b){return b.pageY}_updateScrollbarSize(b){this.slider.setHeight(b)}writeScrollPosition(b,y){b.scrollLeft=y}updateOptions(b){this.updateScrollbarSize(b.horizontal===w.ScrollbarVisibility.Hidden?0:b.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(b.vertical===w.ScrollbarVisibility.Hidden?0:b.verticalScrollbarSize),this._visibilityController.setVisibility(b.horizontal),this._scrollByPage=b.scrollByPage}}t.HorizontalScrollbar=_}),define(De[143],we([1,0,23,77,53,57,21,20]),function(ne,t,i,n,k,R,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class _ extends n.AbstractScrollbar{constructor(b,y,p){const m=b.getScrollDimensions(),e=b.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:p,scrollbarState:new R.ScrollbarState(y.verticalHasArrows?y.arrowSize:0,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const s=(y.arrowSize-k.ARROW_IMG_SIZE)/2,o=(y.verticalScrollbarSize-k.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonUp,top:s,left:o,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:N.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:s,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}_updateSlider(b,y){this.slider.setHeight(b),this.slider.setTop(y)}_renderDomNode(b,y){this.domNode.setWidth(y),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this._shouldRender=this._onElementScrollSize(b.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(b.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(b.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(b,y){return y}_sliderPointerPosition(b){return b.pageY}_sliderOrthogonalPointerPosition(b){return b.pageX}_updateScrollbarSize(b){this.slider.setWidth(b)}writeScrollPosition(b,y){b.scrollTop=y}updateOptions(b){this.updateScrollbarSize(b.vertical===w.ScrollbarVisibility.Hidden?0:b.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(b.vertical),this._scrollByPage=b.scrollByPage}}t.VerticalScrollbar=_}),define(De[78],we([1,0,19,4,56,23,142,143,24,12,3,2,5,20,118]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0,n=Ue(n),p=Ue(p);const e=500,s=50,o=!0;class c{constructor(T,H,W){this.timestamp=T,this.deltaX=H,this.deltaY=W,this.score=0}}class h{static{this.INSTANCE=new h}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let T=1,H=0,W=1,U=this._rear;do{const D=U===this._front?T:Math.pow(2,-W);if(T-=D,H+=this._memory[U].score*D,U===this._front)break;U=(this._capacity+U-1)%this._capacity,W++}while(!0);return H<=.5}acceptStandardWheelEvent(T){if(i.isChrome){const H=n.getWindow(T.browserEvent),W=(0,i.getZoomFactor)(H);this.accept(Date.now(),T.deltaX*W,T.deltaY*W)}else this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,H,W){let U=null;const D=new c(T,H,W);this._front===-1&&this._rear===-1?(this._memory[0]=D,this._front=0,this._rear=0):(U=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=D),D.score=this._computeScore(D,U)}_computeScore(T,H){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let W=.5;if((!this._isAlmostInt(T.deltaX)||!this._isAlmostInt(T.deltaY))&&(W+=.25),H){const U=Math.abs(T.deltaX),D=Math.abs(T.deltaY),x=Math.abs(H.deltaX),z=Math.abs(H.deltaY),O=Math.max(Math.min(U,x),1),P=Math.max(Math.min(D,z),1),K=Math.max(U,x),Q=Math.max(D,z);K%O===0&&Q%P===0&&(W-=.5)}return Math.min(Math.max(W,0),1)}_isAlmostInt(T){return Math.abs(Math.round(T)-T)<.01}}t.MouseWheelClassifier=h;class v extends _.Widget{get options(){return this._options}constructor(T,H,W){super(),this._onScroll=this._register(new b.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new b.Emitter),this.onWillScroll=this._onWillScroll.event,T.style.overflow="hidden",this._options=f(H),this._scrollable=W,this._register(this._scrollable.onScroll(D=>{this._onWillScroll.fire(D),this._onDidScroll(D),this._onScroll.fire(D)}));const U={onMouseWheel:D=>this._onMouseWheel(D),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,U)),this._horizontalScrollbar=this._register(new N.HorizontalScrollbar(this._scrollable,this._options,U)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(T),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,k.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,k.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,k.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,D=>this._onMouseOver(D)),this.onmouseleave(this._listenOnDomNode,D=>this._onMouseLeave(D)),this._hideTimeout=this._register(new d.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,y.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this._verticalScrollbar.delegatePointerDown(T)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(T){this._scrollable.setScrollDimensions(T,!1)}updateClassName(T){this._options.className=T,p.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this._options.handleMouseWheel=T.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this._options.horizontal=T.horizontal),typeof T.vertical<"u"&&(this._options.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this._options.scrollByPage=T.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(T){this._revealOnScroll=T}delegateScrollFromMouseWheelEvent(T){this._onMouseWheel(new R.StandardWheelEvent(T))}_setListeningToMouseWheel(T){if(this._mouseWheelToDispose.length>0!==T&&(this._mouseWheelToDispose=(0,y.dispose)(this._mouseWheelToDispose),T)){const W=U=>{this._onMouseWheel(new R.StandardWheelEvent(U))};this._mouseWheelToDispose.push(n.addDisposableListener(this._listenOnDomNode,n.EventType.MOUSE_WHEEL,W,{passive:!1}))}}_onMouseWheel(T){if(T.browserEvent?.defaultPrevented)return;const H=h.INSTANCE;o&&H.acceptStandardWheelEvent(T);let W=!1;if(T.deltaY||T.deltaX){let D=T.deltaY*this._options.mouseWheelScrollSensitivity,x=T.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&x+D===0?x=D=0:Math.abs(D)>=Math.abs(x)?x=0:D=0),this._options.flipAxes&&([D,x]=[x,D]);const z=!p.isMacintosh&&T.browserEvent&&T.browserEvent.shiftKey;(this._options.scrollYToX||z)&&!x&&(x=D,D=0),T.browserEvent&&T.browserEvent.altKey&&(x=x*this._options.fastScrollSensitivity,D=D*this._options.fastScrollSensitivity);const O=this._scrollable.getFutureScrollPosition();let P={};if(D){const K=s*D,Q=O.scrollTop-(K<0?Math.floor(K):Math.ceil(K));this._verticalScrollbar.writeScrollPosition(P,Q)}if(x){const K=s*x,Q=O.scrollLeft-(K<0?Math.floor(K):Math.ceil(K));this._horizontalScrollbar.writeScrollPosition(P,Q)}P=this._scrollable.validateScrollPosition(P),(O.scrollLeft!==P.scrollLeft||O.scrollTop!==P.scrollTop)&&(o&&this._options.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(P):this._scrollable.setScrollPositionNow(P),W=!0)}let U=W;!U&&this._options.alwaysConsumeMouseWheel&&(U=!0),!U&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(U=!0),U&&(T.preventDefault(),T.stopPropagation())}_onDidScroll(T){this._shouldRender=this._horizontalScrollbar.onDidScroll(T)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(T)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const T=this._scrollable.getCurrentScrollPosition(),H=T.scrollTop>0,W=T.scrollLeft>0,U=W?" left":"",D=H?" top":"",x=W||H?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${U}`),this._topShadowDomNode.setClassName(`shadow${D}`),this._topLeftShadowDomNode.setClassName(`shadow${x}${D}${U}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(T){this._mouseIsOver=!1,this._hide()}_onMouseOver(T){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=v;class L extends v{constructor(T,H){H=H||{},H.mouseWheelSmoothScroll=!1;const W=new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:U=>n.scheduleAtNextAnimationFrame(n.getWindow(T),U)});super(T,H,W),this._register(W)}setScrollPosition(T){this._scrollable.setScrollPositionNow(T)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=L;class S extends v{constructor(T,H,W){super(T,H,W)}setScrollPosition(T){T.reuseAnimation?this._scrollable.setScrollPositionSmooth(T,T.reuseAnimation):this._scrollable.setScrollPositionNow(T)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class r extends v{constructor(T,H){H=H||{},H.mouseWheelSmoothScroll=!1;const W=new m.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:U=>n.scheduleAtNextAnimationFrame(n.getWindow(T),U)});super(T,H,W),this._register(W),this._element=T,this._register(this.onScroll(U=>{U.scrollTopChanged&&(this._element.scrollTop=U.scrollTop),U.scrollLeftChanged&&(this._element.scrollLeft=U.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this._scrollable.setScrollPositionNow(T)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=r;function f(E){const T={lazyRender:typeof E.lazyRender<"u"?E.lazyRender:!1,className:typeof E.className<"u"?E.className:"",useShadows:typeof E.useShadows<"u"?E.useShadows:!0,handleMouseWheel:typeof E.handleMouseWheel<"u"?E.handleMouseWheel:!0,flipAxes:typeof E.flipAxes<"u"?E.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof E.consumeMouseWheelIfScrollbarIsNeeded<"u"?E.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof E.alwaysConsumeMouseWheel<"u"?E.alwaysConsumeMouseWheel:!1,scrollYToX:typeof E.scrollYToX<"u"?E.scrollYToX:!1,mouseWheelScrollSensitivity:typeof E.mouseWheelScrollSensitivity<"u"?E.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof E.fastScrollSensitivity<"u"?E.fastScrollSensitivity:5,scrollPredominantAxis:typeof E.scrollPredominantAxis<"u"?E.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof E.mouseWheelSmoothScroll<"u"?E.mouseWheelSmoothScroll:!0,arrowSize:typeof E.arrowSize<"u"?E.arrowSize:11,listenOnDomNode:typeof E.listenOnDomNode<"u"?E.listenOnDomNode:null,horizontal:typeof E.horizontal<"u"?E.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof E.horizontalScrollbarSize<"u"?E.horizontalScrollbarSize:10,horizontalSliderSize:typeof E.horizontalSliderSize<"u"?E.horizontalSliderSize:0,horizontalHasArrows:typeof E.horizontalHasArrows<"u"?E.horizontalHasArrows:!1,vertical:typeof E.vertical<"u"?E.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof E.verticalScrollbarSize<"u"?E.verticalScrollbarSize:10,verticalHasArrows:typeof E.verticalHasArrows<"u"?E.verticalHasArrows:!1,verticalSliderSize:typeof E.verticalSliderSize<"u"?E.verticalSliderSize:0,scrollByPage:typeof E.scrollByPage<"u"?E.scrollByPage:!1};return T.horizontalSliderSize=typeof E.horizontalSliderSize<"u"?E.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof E.verticalSliderSize<"u"?E.verticalSliderSize:T.verticalScrollbarSize,p.isMacintosh&&(T.className+=" mac"),T}}),define(De[79],we([1,0,71,4,29,33,78,9,12,36,3,2,47,20,42,98,138,6,38]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const v={CurrentDragAndDropData:void 0};var L;(function(U){U[U.TOP=0]="TOP",U[U.CENTER_TOP=1]="CENTER_TOP",U[U.CENTER_BOTTOM=2]="CENTER_BOTTOM",U[U.BOTTOM=3]="BOTTOM"})(L||(t.ListViewTargetSector=L={}));const S={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(U){return[U]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this._context}set context(D){this._context=D}constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=r;class f{constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=f;class E{constructor(){this.types=[],this.files=[]}update(D){if(D.types&&this.types.splice(0,this.types.length,...D.types),D.files){this.files.splice(0,this.files.length);for(let x=0;x<D.files.length;x++){const z=D.files.item(x);z&&(z.size||z.type)&&this.files.push(z)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=E;function T(U,D){return Array.isArray(U)&&Array.isArray(D)?(0,w.equals)(U,D):U===D}class H{constructor(D){D?.getSetSize?this.getSetSize=D.getSetSize.bind(D):this.getSetSize=(x,z,O)=>O,D?.getPosInSet?this.getPosInSet=D.getPosInSet.bind(D):this.getPosInSet=(x,z)=>z+1,D?.getRole?this.getRole=D.getRole.bind(D):this.getRole=x=>"listitem",D?.isChecked?this.isChecked=D.isChecked.bind(D):this.isChecked=x=>{}}}class W{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(D){if(D!==this._horizontalScrolling){if(D&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=D,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const x of this.items)this.measureItemWidth(x);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,n.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(D,x,z,O=S){if(this.virtualDelegate=x,this.domId=`list_id_${++W.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new _.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=y.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=y.Disposable.None,this.onDragLeaveTimeout=y.Disposable.None,this.disposables=new y.DisposableStore,this._onDidChangeContentHeight=new b.Emitter,this._onDidChangeContentWidth=new b.Emitter,this.onDidChangeContentHeight=b.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=b.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,O.horizontalScrolling&&O.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(O.paddingTop??0);for(const K of z)this.renderers.set(K.templateId,K);this.cache=this.disposables.add(new o.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof O.mouseSupport=="boolean"?O.mouseSupport:!0),this._horizontalScrolling=O.horizontalScrolling??S.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof O.paddingBottom>"u"?0:O.paddingBottom,this.accessibilityProvider=new H(O.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(O.transformOptimization??S.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(R.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:O.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:K=>(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),K)})),this.scrollableElement=this.disposables.add(new N.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:O.alwaysConsumeMouseWheel??S.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:O.verticalScrollMode??S.verticalScrollMode,useShadows:O.useShadows??S.useShadows,mouseWheelScrollSensitivity:O.mouseWheelScrollSensitivity,fastScrollSensitivity:O.fastScrollSensitivity,scrollByPage:O.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),D.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,n.addDisposableListener)(this.rowsContainer,R.EventType.Change,K=>this.onTouchChange(K))),this.disposables.add((0,n.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",K=>K.target.scrollTop=0)),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragover",K=>this.onDragOver(this.toDragEvent(K)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"drop",K=>this.onDrop(this.toDragEvent(K)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragleave",K=>this.onDragLeave(this.toDragEvent(K)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragend",K=>this.onDragEnd(K))),this.setRowLineHeight=O.setRowLineHeight??S.setRowLineHeight,this.setRowHeight=O.setRowHeight??S.setRowHeight,this.supportDynamicHeights=O.supportDynamicHeights??S.supportDynamicHeights,this.dnd=O.dnd??this.disposables.add(S.dnd),this.layout(O.initialSize?.height,O.initialSize?.width)}updateOptions(D){D.paddingBottom!==void 0&&(this.paddingBottom=D.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),D.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(D.smoothScrolling?125:0),D.horizontalScrolling!==void 0&&(this.horizontalScrolling=D.horizontalScrolling);let x;if(D.scrollByPage!==void 0&&(x={...x??{},scrollByPage:D.scrollByPage}),D.mouseWheelScrollSensitivity!==void 0&&(x={...x??{},mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity}),D.fastScrollSensitivity!==void 0&&(x={...x??{},fastScrollSensitivity:D.fastScrollSensitivity}),x&&this.scrollableElement.updateOptions(x),D.paddingTop!==void 0&&D.paddingTop!==this.rangeMap.paddingTop){const z=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),O=D.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=D.paddingTop,this.render(z,Math.max(0,this.lastRenderTop+O),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(D){this.scrollableElement.delegateScrollFromMouseWheelEvent(D)}delegateVerticalScrollbarPointerDown(D){this.scrollableElement.delegateVerticalScrollbarPointerDown(D)}updateElementHeight(D,x,z){if(D<0||D>=this.items.length)return;const O=this.items[D].size;if(typeof x>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[D].lastDynamicHeightWidth=void 0,x=O+this.probeDynamicHeight(D)}if(O===x)return;const P=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let K=0;D<P.start||z!==null&&z>D&&z<P.end?K=x-O:K=0,this.rangeMap.splice(D,1,[{size:x}]),this.items[D].size=x,this.render(P,Math.max(0,this.lastRenderTop+K),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(D){return new s.RangeMap(D)}splice(D,x,z=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(D,x,z)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(D,x,z=[]){const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),P={start:D,end:D+x},K=p.Range.intersect(O,P),Q=new Map;for(let be=K.end-1;be>=K.start;be--){const Se=this.items[be];if(Se.dragStartDisposable.dispose(),Se.checkedDisposable.dispose(),Se.row){let Oe=Q.get(Se.templateId);Oe||(Oe=[],Q.set(Se.templateId,Oe));const Re=this.renderers.get(Se.templateId);Re&&Re.disposeElement&&Re.disposeElement(Se.element,be,Se.row.templateData,Se.size),Oe.unshift(Se.row)}Se.row=null,Se.stale=!0}const X={start:D+x,end:this.items.length},G=p.Range.intersect(X,O),J=p.Range.relativeComplement(X,O),ce=z.map(be=>({id:String(this.itemId++),element:be,templateId:this.virtualDelegate.getTemplateId(be),size:this.virtualDelegate.getHeight(be),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(be),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:y.Disposable.None,checkedDisposable:y.Disposable.None,stale:!1}));let pe;D===0&&x>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,ce),pe=this.items,this.items=ce):(this.rangeMap.splice(D,x,ce),pe=this.items.splice(D,x,...ce));const Te=z.length-x,Fe=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),re=(0,s.shift)(G,Te),ee=p.Range.intersect(Fe,re);for(let be=ee.start;be<ee.end;be++)this.updateItemInDOM(this.items[be],be);const he=p.Range.relativeComplement(re,Fe);for(const be of he)for(let Se=be.start;Se<be.end;Se++)this.removeItemFromDOM(Se);const le=J.map(be=>(0,s.shift)(be,Te)),te=[{start:D,end:D+z.length},...le].map(be=>p.Range.intersect(Fe,be)).reverse();for(const be of te)for(let Se=be.end-1;Se>=be.start;Se--){const Oe=this.items[Se],We=Q.get(Oe.templateId)?.pop();this.insertItemInDOM(Se,We)}for(const be of Q.values())for(const Se of be)this.cache.release(Se);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),pe.map(be=>be.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let D=0;for(const x of this.items)typeof x.width<"u"&&(D=Math.max(D,x.width));this.scrollWidth=D,this.scrollableElement.setScrollDimensions({scrollWidth:D===0?0:D+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(D){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const x=this.items[D];this.measureItemWidth(x),typeof x.width<"u"&&x.width>this.scrollWidth&&(this.scrollWidth=x.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const D of this.items)D.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const D=this.firstVisibleIndex,x=this.rangeMap.positionAt(D),z=this.rangeMap.positionAt(D+1);return z!==-1&&(z-x)/2+x<this.scrollTop?D+1:D}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(D){return this.items[D].element}indexOf(D){return this.items.findIndex(x=>x.element===D)}domElement(D){const x=this.items[D].row;return x&&x.domNode}elementHeight(D){return this.items[D].size}elementTop(D){return this.rangeMap.positionAt(D)}indexAt(D){return this.rangeMap.indexAt(D)}indexAfter(D){return this.rangeMap.indexAfter(D)}layout(D,x){const z={height:typeof D=="number"?D:(0,n.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,z.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(z),typeof x<"u"&&(this.renderWidth=x,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof x=="number"?x:(0,n.getContentWidth)(this.domNode)})}render(D,x,z,O,P,K=!1){const Q=this.getRenderRange(x,z),X=p.Range.relativeComplement(Q,D).reverse(),G=p.Range.relativeComplement(D,Q);if(K){const J=p.Range.intersect(D,Q);for(let ce=J.start;ce<J.end;ce++)this.updateItemInDOM(this.items[ce],ce)}this.cache.transact(()=>{for(const J of G)for(let ce=J.start;ce<J.end;ce++)this.removeItemFromDOM(ce);for(const J of X)for(let ce=J.end-1;ce>=J.start;ce--)this.insertItemInDOM(ce)}),O!==void 0&&(this.rowsContainer.style.left=`-${O}px`),this.rowsContainer.style.top=`-${x}px`,this.horizontalScrolling&&P!==void 0&&(this.rowsContainer.style.width=`${Math.max(P,this.renderWidth)}px`),this.lastRenderTop=x,this.lastRenderHeight=z}insertItemInDOM(D,x){const z=this.items[D];if(!z.row)if(x)z.row=x,z.stale=!0;else{const X=this.cache.alloc(z.templateId);z.row=X.row,z.stale||=X.isReusingConnectedDomNode}const O=this.accessibilityProvider.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",O);const P=this.accessibilityProvider.isChecked(z.element);if(typeof P=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const X=G=>z.row.domNode.setAttribute("aria-checked",String(!!G));X(P.value),z.checkedDisposable=P.onDidChange(()=>X(P.value))}if(z.stale||!z.row.domNode.parentElement){const X=this.items.at(D+1)?.row?.domNode??null;(z.row.domNode.parentElement!==this.rowsContainer||z.row.domNode.nextElementSibling!==X)&&this.rowsContainer.insertBefore(z.row.domNode,X),z.stale=!1}this.updateItemInDOM(z,D);const K=this.renderers.get(z.templateId);if(!K)throw new Error(`No renderer found for template id ${z.templateId}`);K?.renderElement(z.element,D,z.row.templateData,z.size);const Q=this.dnd.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!Q,Q&&(z.dragStartDisposable=(0,n.addDisposableListener)(z.row.domNode,"dragstart",X=>this.onDragStart(z.element,Q,X))),this.horizontalScrolling&&(this.measureItemWidth(z),this.eventuallyUpdateScrollWidth())}measureItemWidth(D){if(!D.row||!D.row.domNode)return;D.row.domNode.style.width="fit-content",D.width=(0,n.getContentWidth)(D.row.domNode);const x=(0,n.getWindow)(D.row.domNode).getComputedStyle(D.row.domNode);x.paddingLeft&&(D.width+=parseFloat(x.paddingLeft)),x.paddingRight&&(D.width+=parseFloat(x.paddingRight)),D.row.domNode.style.width=""}updateItemInDOM(D,x){D.row.domNode.style.top=`${this.elementTop(x)}px`,this.setRowHeight&&(D.row.domNode.style.height=`${D.size}px`),this.setRowLineHeight&&(D.row.domNode.style.lineHeight=`${D.size}px`),D.row.domNode.setAttribute("data-index",`${x}`),D.row.domNode.setAttribute("data-last-element",x===this.length-1?"true":"false"),D.row.domNode.setAttribute("data-parity",x%2===0?"even":"odd"),D.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(D.element,x,this.length))),D.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(D.element,x))),D.row.domNode.setAttribute("id",this.getElementDomId(x)),D.row.domNode.classList.toggle("drop-target",D.dropTarget)}removeItemFromDOM(D){const x=this.items[D];if(x.dragStartDisposable.dispose(),x.checkedDisposable.dispose(),x.row){const z=this.renderers.get(x.templateId);z&&z.disposeElement&&z.disposeElement(x.element,D,x.row.templateData,x.size),this.cache.release(x.row),x.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(D,x){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:D,reuseAnimation:x})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(D){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:D})}get scrollTop(){return this.getScrollTop()}set scrollTop(D){this.setScrollTop(D)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"click")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseDblClick(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"dblclick")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseMiddleClick(){return b.Event.filter(b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"auxclick")).event,D=>this.toMouseEvent(D),this.disposables),D=>D.browserEvent.button===1,this.disposables)}get onMouseUp(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"mouseup")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseDown(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"mousedown")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseOver(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"mouseover")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseMove(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"mousemove")).event,D=>this.toMouseEvent(D),this.disposables)}get onMouseOut(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"mouseout")).event,D=>this.toMouseEvent(D),this.disposables)}get onContextMenu(){return b.Event.any(b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"contextmenu")).event,D=>this.toMouseEvent(D),this.disposables),b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,R.EventType.Contextmenu)).event,D=>this.toGestureEvent(D),this.disposables))}get onTouchStart(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.domNode,"touchstart")).event,D=>this.toTouchEvent(D),this.disposables)}get onTap(){return b.Event.map(this.disposables.add(new k.DomEmitter(this.rowsContainer,R.EventType.Tap)).event,D=>this.toGestureEvent(D),this.disposables)}toMouseEvent(D){const x=this.getItemIndexFromEventTarget(D.target||null),z=typeof x>"u"?void 0:this.items[x],O=z&&z.element;return{browserEvent:D,index:x,element:O}}toTouchEvent(D){const x=this.getItemIndexFromEventTarget(D.target||null),z=typeof x>"u"?void 0:this.items[x],O=z&&z.element;return{browserEvent:D,index:x,element:O}}toGestureEvent(D){const x=this.getItemIndexFromEventTarget(D.initialTarget||null),z=typeof x>"u"?void 0:this.items[x],O=z&&z.element;return{browserEvent:D,index:x,element:O}}toDragEvent(D){const x=this.getItemIndexFromEventTarget(D.target||null),z=typeof x>"u"?void 0:this.items[x],O=z&&z.element,P=this.getTargetSector(D,x);return{browserEvent:D,index:x,element:O,sector:P}}onScroll(D){try{const x=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(x,D.scrollTop,D.height,D.scrollLeft,D.scrollWidth),this.supportDynamicHeights&&this._rerender(D.scrollTop,D.height,D.inSmoothScrolling)}catch(x){throw console.error("Got bad scroll event:",D),x}}onTouchChange(D){D.preventDefault(),D.stopPropagation(),this.scrollTop-=D.translationY}onDragStart(D,x,z){if(!z.dataTransfer)return;const O=this.dnd.getDragElements(D);if(z.dataTransfer.effectAllowed="copyMove",z.dataTransfer.setData(i.DataTransfers.TEXT,x),z.dataTransfer.setDragImage){let P;this.dnd.getDragLabel&&(P=this.dnd.getDragLabel(O,z)),typeof P>"u"&&(P=String(O.length));const K=(0,n.$)(".monaco-drag-image");K.textContent=P,(G=>{for(;G&&!G.classList.contains("monaco-workbench");)G=G.parentElement;return G||this.domNode.ownerDocument})(this.domNode).appendChild(K),z.dataTransfer.setDragImage(K,-10,-10),setTimeout(()=>K.remove(),0)}this.domNode.classList.add("dragging"),this.currentDragData=new r(O),v.CurrentDragAndDropData=new f(O),this.dnd.onDragStart?.(this.currentDragData,z)}onDragOver(D){if(D.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),v.CurrentDragAndDropData&&v.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(D.browserEvent),!D.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(v.CurrentDragAndDropData)this.currentDragData=v.CurrentDragAndDropData;else{if(!D.browserEvent.dataTransfer.types)return!1;this.currentDragData=new E}const x=this.dnd.onDragOver(this.currentDragData,D.element,D.index,D.sector,D.browserEvent);if(this.canDrop=typeof x=="boolean"?x:x.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;D.browserEvent.dataTransfer.dropEffect=typeof x!="boolean"&&x.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let z;typeof x!="boolean"&&x.feedback?z=x.feedback:typeof D.index>"u"?z=[-1]:z=[D.index],z=(0,w.distinct)(z).filter(P=>P>=-1&&P<this.length).sort((P,K)=>P-K),z=z[0]===-1?[-1]:z;let O=typeof x!="boolean"&&x.effect&&x.effect.position?x.effect.position:e.ListDragOverEffectPosition.Over;if(T(this.currentDragFeedback,z)&&this.currentDragFeedbackPosition===O)return!0;if(this.currentDragFeedback=z,this.currentDragFeedbackPosition=O,this.currentDragFeedbackDisposable.dispose(),z[0]===-1)this.domNode.classList.add(O),this.rowsContainer.classList.add(O),this.currentDragFeedbackDisposable=(0,y.toDisposable)(()=>{this.domNode.classList.remove(O),this.rowsContainer.classList.remove(O)});else{if(z.length>1&&O!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");O===e.ListDragOverEffectPosition.After&&z[0]<this.length-1&&(z[0]+=1,O=e.ListDragOverEffectPosition.Before);for(const P of z){const K=this.items[P];K.dropTarget=!0,K.row?.domNode.classList.add(O)}this.currentDragFeedbackDisposable=(0,y.toDisposable)(()=>{for(const P of z){const K=this.items[P];K.dropTarget=!1,K.row?.domNode.classList.remove(O)}})}return!0}onDragLeave(D){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,_.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,D.element,D.index,D.browserEvent)}onDrop(D){if(!this.canDrop)return;const x=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,!(!x||!D.browserEvent.dataTransfer)&&(D.browserEvent.preventDefault(),x.update(D.browserEvent.dataTransfer),this.dnd.drop(x,D.element,D.index,D.sector,D.browserEvent))}onDragEnd(D){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(D)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=y.Disposable.None}setupDragAndDropScrollTopAnimation(D){if(!this.dragOverAnimationDisposable){const x=(0,n.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,n.animate)((0,n.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,x))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,_.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=D.pageY}animateDragAndDropScrollTop(D){if(this.dragOverMouseY===void 0)return;const x=this.dragOverMouseY-D,z=this.renderHeight-35;x<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(x-35))):x>z&&(this.scrollTop+=Math.min(14,Math.floor(.3*(x-z))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(D,x){if(x===void 0)return;const z=D.offsetY/this.items[x].size,O=Math.floor(z/.25);return(0,h.clamp)(O,0,3)}getItemIndexFromEventTarget(D){const x=this.scrollableElement.getDomNode();let z=D;for(;(0,n.isHTMLElement)(z)&&z!==this.rowsContainer&&x.contains(z);){const O=z.getAttribute("data-index");if(O){const P=Number(O);if(!isNaN(P))return P}z=z.parentElement}}getRenderRange(D,x){return{start:this.rangeMap.indexAt(D),end:this.rangeMap.indexAfter(D+x-1)}}_rerender(D,x,z){const O=this.getRenderRange(D,x);let P,K;D===this.elementTop(O.start)?(P=O.start,K=0):O.end-O.start>1&&(P=O.start+1,K=this.elementTop(P)-D);let Q=0;for(;;){const X=this.getRenderRange(D,x);let G=!1;for(let J=X.start;J<X.end;J++){const ce=this.probeDynamicHeight(J);ce!==0&&this.rangeMap.splice(J,1,[this.items[J]]),Q+=ce,G=G||ce!==0}if(!G){Q!==0&&this.eventuallyUpdateScrollDimensions();const J=p.Range.relativeComplement(O,X);for(const pe of J)for(let Te=pe.start;Te<pe.end;Te++)this.items[Te].row&&this.removeItemFromDOM(Te);const ce=p.Range.relativeComplement(X,O).reverse();for(const pe of ce)for(let Te=pe.end-1;Te>=pe.start;Te--)this.insertItemInDOM(Te);for(let pe=X.start;pe<X.end;pe++)this.items[pe].row&&this.updateItemInDOM(this.items[pe],pe);if(typeof P=="number"){const pe=this.scrollable.getFutureScrollPosition().scrollTop-D,Te=this.elementTop(P)-K+pe;this.setScrollTop(Te,z)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(D){const x=this.items[D];if(this.virtualDelegate.getDynamicHeight){const K=this.virtualDelegate.getDynamicHeight(x.element);if(K!==null){const Q=x.size;return x.size=K,x.lastDynamicHeightWidth=this.renderWidth,K-Q}}if(!x.hasDynamicHeight||x.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(x.element))return 0;const z=x.size;if(x.row)return x.row.domNode.style.height="",x.size=x.row.domNode.offsetHeight,x.size===0&&!(0,n.isAncestor)(x.row.domNode,(0,n.getWindow)(x.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),x.lastDynamicHeightWidth=this.renderWidth,x.size-z;const{row:O}=this.cache.alloc(x.templateId);O.domNode.style.height="",this.rowsContainer.appendChild(O.domNode);const P=this.renderers.get(x.templateId);if(!P)throw new c.BugIndicatingError("Missing renderer for templateId: "+x.templateId);return P.renderElement(x.element,D,O.templateData,void 0),x.size=O.domNode.offsetHeight,P.disposeElement?.(x.element,D,O.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(x.element,x.size),x.lastDynamicHeightWidth=this.renderWidth,O.domNode.remove(),this.cache.release(O),x.size-z}getElementDomId(D){return`${this.domId}_${D}`}dispose(){for(const D of this.items)if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const x=this.renderers.get(D.row.templateId);x&&(x.disposeElement?.(D.element,-1,D.row.templateData,void 0),x.disposeTemplate(D.row.templateData))}this.items=[],this.domNode?.remove(),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=W,et([d.memoize],W.prototype,"onMouseClick",null),et([d.memoize],W.prototype,"onMouseDblClick",null),et([d.memoize],W.prototype,"onMouseMiddleClick",null),et([d.memoize],W.prototype,"onMouseUp",null),et([d.memoize],W.prototype,"onMouseDown",null),et([d.memoize],W.prototype,"onMouseOver",null),et([d.memoize],W.prototype,"onMouseMove",null),et([d.memoize],W.prototype,"onMouseOut",null),et([d.memoize],W.prototype,"onContextMenu",null),et([d.memoize],W.prototype,"onTouchStart",null),et([d.memoize],W.prototype,"onTap",null)}),define(De[54],we([1,0,4,29,16,33,74,87,9,12,89,36,3,50,8,2,38,5,10,42,79,23,62,117]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o,c,h,v,L,S,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=W,t.isMonacoEditor=D,t.isMonacoCustomToggle=x,t.isActionItem=z,t.isMonacoTwistie=O,t.isStickyScrollElement=P,t.isStickyScrollContainer=K,t.isButton=Q,t.isSelectionSingleChangeEvent=Te,t.isSelectionRangeChangeEvent=Fe,c=Ue(c);class f{constructor(l){this.trait=l,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(l){return l}renderElement(l,a,g){const C=this.renderedElements.findIndex(F=>F.templateData===g);if(C>=0){const F=this.renderedElements[C];this.trait.unrender(g),F.index=a}else{const F={index:a,templateData:g};this.renderedElements.push(F)}this.trait.renderIndex(a,g)}splice(l,a,g){const C=[];for(const F of this.renderedElements)F.index<l?C.push(F):F.index>=l+a&&C.push({index:F.index+g-a,templateData:F.templateData});this.renderedElements=C}renderIndexes(l){for(const{index:a,templateData:g}of this.renderedElements)l.indexOf(a)>-1&&this.trait.renderIndex(a,g)}disposeTemplate(l){const a=this.renderedElements.findIndex(g=>g.templateData===l);a<0||this.renderedElements.splice(a,1)}}class E{get name(){return this._trait}get renderer(){return new f(this)}constructor(l){this._trait=l,this.indexes=[],this.sortedIndexes=[],this._onChange=new p.Emitter,this.onChange=this._onChange.event}splice(l,a,g){const C=g.length-a,F=l+a,u=[];let I=0;for(;I<this.sortedIndexes.length&&this.sortedIndexes[I]<l;)u.push(this.sortedIndexes[I++]);for(let A=0;A<g.length;A++)g[A]&&u.push(A+l);for(;I<this.sortedIndexes.length&&this.sortedIndexes[I]>=F;)u.push(this.sortedIndexes[I++]+C);this.renderer.splice(l,a,g.length),this._set(u,u)}renderIndex(l,a){a.classList.toggle(this._trait,this.contains(l))}unrender(l){l.classList.remove(this._trait)}set(l,a){return this._set(l,[...l].sort(Oe),a)}_set(l,a,g){const C=this.indexes,F=this.sortedIndexes;this.indexes=l,this.sortedIndexes=a;const u=be(F,l);return this.renderer.renderIndexes(u),this._onChange.fire({indexes:l,browserEvent:g}),C}get(){return this.indexes}contains(l){return(0,_.binarySearch)(this.sortedIndexes,l,Oe)>=0}dispose(){(0,s.dispose)(this._onChange)}}et([y.memoize],E.prototype,"renderer",null);class T extends E{constructor(l){super("selected"),this.setAriaSelected=l}renderIndex(l,a){super.renderIndex(l,a),this.setAriaSelected&&(this.contains(l)?a.setAttribute("aria-selected","true"):a.setAttribute("aria-selected","false"))}}class H{constructor(l,a,g){this.trait=l,this.view=a,this.identityProvider=g}splice(l,a,g){if(!this.identityProvider)return this.trait.splice(l,a,new Array(g.length).fill(!1));const C=this.trait.get().map(I=>this.identityProvider.getId(this.view.element(I)).toString());if(C.length===0)return this.trait.splice(l,a,new Array(g.length).fill(!1));const F=new Set(C),u=g.map(I=>F.has(this.identityProvider.getId(I).toString()));this.trait.splice(l,a,u)}}function W(B){return B.tagName==="INPUT"||B.tagName==="TEXTAREA"}function U(B,l){return B.classList.contains(l)?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:U(B.parentElement,l)}function D(B){return U(B,"monaco-editor")}function x(B){return U(B,"monaco-custom-toggle")}function z(B){return U(B,"action-item")}function O(B){return U(B,"monaco-tl-twistie")}function P(B){return U(B,"monaco-tree-sticky-row")}function K(B){return B.classList.contains("monaco-tree-sticky-container")}function Q(B){return B.tagName==="A"&&B.classList.contains("monaco-button")||B.tagName==="DIV"&&B.classList.contains("monaco-button-dropdown")?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:Q(B.parentElement)}class X{get onKeyDown(){return p.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,l=>l.filter(a=>!W(a.target)).map(a=>new k.StandardKeyboardEvent(a)))}constructor(l,a,g){this.list=l,this.view=a,this.disposables=new s.DisposableStore,this.multipleSelectionDisposables=new s.DisposableStore,this.multipleSelectionSupport=g.multipleSelectionSupport,this.disposables.add(this.onKeyDown(C=>{switch(C.keyCode){case e.KeyCode.Enter:return this.onEnter(C);case e.KeyCode.UpArrow:return this.onUpArrow(C);case e.KeyCode.DownArrow:return this.onDownArrow(C);case e.KeyCode.PageUp:return this.onPageUpArrow(C);case e.KeyCode.PageDown:return this.onPageDownArrow(C);case e.KeyCode.Escape:return this.onEscape(C);case e.KeyCode.KeyA:this.multipleSelectionSupport&&(c.isMacintosh?C.metaKey:C.ctrlKey)&&this.onCtrlA(C)}}))}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=l.multipleSelectionSupport)}onEnter(l){l.preventDefault(),l.stopPropagation(),this.list.setSelection(this.list.getFocus(),l.browserEvent)}onUpArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusPrevious(1,!1,l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onDownArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusNext(1,!1,l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onPageUpArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusPreviousPage(l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onPageDownArrow(l){l.preventDefault(),l.stopPropagation(),this.list.focusNextPage(l.browserEvent);const a=this.list.getFocus()[0];this.list.setAnchor(a),this.list.reveal(a),this.view.domNode.focus()}onCtrlA(l){l.preventDefault(),l.stopPropagation(),this.list.setSelection((0,_.range)(this.list.length),l.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(l){this.list.getSelection().length&&(l.preventDefault(),l.stopPropagation(),this.list.setSelection([],l.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}et([y.memoize],X.prototype,"onKeyDown",null);var G;(function(B){B[B.Automatic=0]="Automatic",B[B.Trigger=1]="Trigger"})(G||(t.TypeNavigationMode=G={}));var J;(function(B){B[B.Idle=0]="Idle",B[B.Typing=1]="Typing"})(J||(J={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(B){return B.ctrlKey||B.metaKey||B.altKey?!1:B.keyCode>=e.KeyCode.KeyA&&B.keyCode<=e.KeyCode.KeyZ||B.keyCode>=e.KeyCode.Digit0&&B.keyCode<=e.KeyCode.Digit9||B.keyCode>=e.KeyCode.Numpad0&&B.keyCode<=e.KeyCode.Numpad9||B.keyCode>=e.KeyCode.Semicolon&&B.keyCode<=e.KeyCode.Quote}};class ce{constructor(l,a,g,C,F){this.list=l,this.view=a,this.keyboardNavigationLabelProvider=g,this.keyboardNavigationEventFilter=C,this.delegate=F,this.enabled=!1,this.state=J.Idle,this.mode=G.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new s.DisposableStore,this.disposables=new s.DisposableStore,this.updateOptions(l.options)}updateOptions(l){l.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=l.typeNavigationMode??G.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let l=!1;const a=p.Event.chain(this.enabledDisposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,F=>F.filter(u=>!W(u.target)).filter(()=>this.mode===G.Automatic||this.triggered).map(u=>new k.StandardKeyboardEvent(u)).filter(u=>l||this.keyboardNavigationEventFilter(u)).filter(u=>this.delegate.mightProducePrintableCharacter(u)).forEach(u=>i.EventHelper.stop(u,!0)).map(u=>u.browserEvent.key)),g=p.Event.debounce(a,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);p.Event.reduce(p.Event.any(a,g),(F,u)=>u===null?null:(F||"")+u,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),g(this.onClear,this,this.enabledDisposables),a(()=>l=!0,void 0,this.enabledDisposables),g(()=>l=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const l=this.list.getFocus();if(l.length>0&&l[0]===this.previouslyFocused){const a=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(l[0]));typeof a=="string"?(0,N.alert)(a):a&&(0,N.alert)(a.get())}this.previouslyFocused=-1}onInput(l){if(!l){this.state=J.Idle,this.triggered=!1;return}const a=this.list.getFocus(),g=a.length>0?a[0]:0,C=this.state===J.Idle?1:0;this.state=J.Typing;for(let F=0;F<this.list.length;F++){const u=(g+F+C)%this.list.length,I=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(u)),A=I&&I.toString();if(this.list.options.typeNavigationEnabled){if(typeof A<"u"){if((0,m.matchesPrefix)(l,A)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}const M=(0,m.matchesFuzzy2)(l,A);if(M&&M[0].end-M[0].start>1&&M.length===1){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}else if(typeof A>"u"||(0,m.matchesPrefix)(l,A)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class pe{constructor(l,a){this.list=l,this.view=a,this.disposables=new s.DisposableStore;const g=p.Event.chain(this.disposables.add(new n.DomEmitter(a.domNode,"keydown")).event,F=>F.filter(u=>!W(u.target)).map(u=>new k.StandardKeyboardEvent(u)));p.Event.chain(g,F=>F.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.onTab,this,this.disposables)}onTab(l){if(l.target!==this.view.domNode)return;const a=this.list.getFocus();if(a.length===0)return;const g=this.view.domElement(a[0]);if(!g)return;const C=g.querySelector("[tabIndex]");if(!C||!(0,i.isHTMLElement)(C)||C.tabIndex===-1)return;const F=(0,i.getWindow)(C).getComputedStyle(C);F.visibility==="hidden"||F.display==="none"||(l.preventDefault(),l.stopPropagation(),C.focus())}dispose(){this.disposables.dispose()}}function Te(B){return c.isMacintosh?B.browserEvent.metaKey:B.browserEvent.ctrlKey}function Fe(B){return B.browserEvent.shiftKey}function re(B){return(0,i.isMouseEvent)(B)&&B.button===2}const ee={isSelectionSingleChangeEvent:Te,isSelectionRangeChangeEvent:Fe};class he{constructor(l){this.list=l,this.disposables=new s.DisposableStore,this._onPointer=new p.Emitter,this.onPointer=this._onPointer.event,l.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ee),this.mouseSupport=typeof l.options.mouseSupport>"u"||!!l.options.mouseSupport,this.mouseSupport&&(l.onMouseDown(this.onMouseDown,this,this.disposables),l.onContextMenu(this.onContextMenu,this,this.disposables),l.onMouseDblClick(this.onDoubleClick,this,this.disposables),l.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(R.Gesture.addTarget(l.getHTMLElement()))),p.Event.any(l.onMouseClick,l.onMouseMiddleClick,l.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,l.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ee))}isSelectionSingleChangeEvent(l){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(l):!1}isSelectionRangeChangeEvent(l){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(l):!1}isSelectionChangeEvent(l){return this.isSelectionSingleChangeEvent(l)||this.isSelectionRangeChangeEvent(l)}onMouseDown(l){D(l.browserEvent.target)||(0,i.getActiveElement)()!==l.browserEvent.target&&this.list.domFocus()}onContextMenu(l){if(W(l.browserEvent.target)||D(l.browserEvent.target))return;const a=typeof l.index>"u"?[]:[l.index];this.list.setFocus(a,l.browserEvent)}onViewPointer(l){if(!this.mouseSupport||W(l.browserEvent.target)||D(l.browserEvent.target)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const a=l.index;if(typeof a>"u"){this.list.setFocus([],l.browserEvent),this.list.setSelection([],l.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(l))return this.changeSelection(l);this.list.setFocus([a],l.browserEvent),this.list.setAnchor(a),re(l.browserEvent)||this.list.setSelection([a],l.browserEvent),this._onPointer.fire(l)}onDoubleClick(l){if(W(l.browserEvent.target)||D(l.browserEvent.target)||this.isSelectionChangeEvent(l)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const a=this.list.getFocus();this.list.setSelection(a,l.browserEvent)}changeSelection(l){const a=l.index;let g=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(l)){typeof g>"u"&&(g=this.list.getFocus()[0]??a,this.list.setAnchor(g));const C=Math.min(g,a),F=Math.max(g,a),u=(0,_.range)(C,F+1),I=this.list.getSelection(),A=te(be(I,[g]),g);if(A.length===0)return;const M=be(u,Se(I,A));this.list.setSelection(M,l.browserEvent),this.list.setFocus([a],l.browserEvent)}else if(this.isSelectionSingleChangeEvent(l)){const C=this.list.getSelection(),F=C.filter(u=>u!==a);this.list.setFocus([a]),this.list.setAnchor(a),C.length===F.length?this.list.setSelection([...F,a],l.browserEvent):this.list.setSelection(F,l.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=he;class le{constructor(l,a){this.styleElement=l,this.selectorSuffix=a}style(l){const a=this.selectorSuffix&&`.${this.selectorSuffix}`,g=[];l.listBackground&&g.push(`.monaco-list${a} .monaco-list-rows { background: ${l.listBackground}; }`),l.listFocusBackground&&(g.push(`.monaco-list${a}:focus .monaco-list-row.focused { background-color: ${l.listFocusBackground}; }`),g.push(`.monaco-list${a}:focus .monaco-list-row.focused:hover { background-color: ${l.listFocusBackground}; }`)),l.listFocusForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.focused { color: ${l.listFocusForeground}; }`),l.listActiveSelectionBackground&&(g.push(`.monaco-list${a}:focus .monaco-list-row.selected { background-color: ${l.listActiveSelectionBackground}; }`),g.push(`.monaco-list${a}:focus .monaco-list-row.selected:hover { background-color: ${l.listActiveSelectionBackground}; }`)),l.listActiveSelectionForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.selected { color: ${l.listActiveSelectionForeground}; }`),l.listActiveSelectionIconForeground&&g.push(`.monaco-list${a}:focus .monaco-list-row.selected .codicon { color: ${l.listActiveSelectionIconForeground}; }`),l.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.selected.focused { background-color: ${l.listFocusAndSelectionBackground}; }
			`),l.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.selected.focused { color: ${l.listFocusAndSelectionForeground}; }
			`),l.listInactiveFocusForeground&&(g.push(`.monaco-list${a} .monaco-list-row.focused { color:  ${l.listInactiveFocusForeground}; }`),g.push(`.monaco-list${a} .monaco-list-row.focused:hover { color:  ${l.listInactiveFocusForeground}; }`)),l.listInactiveSelectionIconForeground&&g.push(`.monaco-list${a} .monaco-list-row.focused .codicon { color:  ${l.listInactiveSelectionIconForeground}; }`),l.listInactiveFocusBackground&&(g.push(`.monaco-list${a} .monaco-list-row.focused { background-color:  ${l.listInactiveFocusBackground}; }`),g.push(`.monaco-list${a} .monaco-list-row.focused:hover { background-color:  ${l.listInactiveFocusBackground}; }`)),l.listInactiveSelectionBackground&&(g.push(`.monaco-list${a} .monaco-list-row.selected { background-color:  ${l.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${a} .monaco-list-row.selected:hover { background-color:  ${l.listInactiveSelectionBackground}; }`)),l.listInactiveSelectionForeground&&g.push(`.monaco-list${a} .monaco-list-row.selected { color: ${l.listInactiveSelectionForeground}; }`),l.listHoverBackground&&g.push(`.monaco-list${a}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${l.listHoverBackground}; }`),l.listHoverForeground&&g.push(`.monaco-list${a}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${l.listHoverForeground}; }`);const C=(0,i.asCssValueWithDefault)(l.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(l.listSelectionOutline,l.listFocusOutline??""));C&&g.push(`.monaco-list${a}:focus .monaco-list-row.focused.selected { outline: 1px solid ${C}; outline-offset: -1px;}`),l.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${a}:focus .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${a}.last-focused .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.asCssValueWithDefault)(l.listSelectionOutline,l.listInactiveFocusOutline??"");F&&g.push(`.monaco-list${a} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),l.listSelectionOutline&&g.push(`.monaco-list${a} .monaco-list-row.selected { outline: 1px dotted ${l.listSelectionOutline}; outline-offset: -1px; }`),l.listInactiveFocusOutline&&g.push(`.monaco-list${a} .monaco-list-row.focused { outline: 1px dotted ${l.listInactiveFocusOutline}; outline-offset: -1px; }`),l.listHoverOutline&&g.push(`.monaco-list${a} .monaco-list-row:hover { outline: 1px dashed ${l.listHoverOutline}; outline-offset: -1px; }`),l.listDropOverBackground&&g.push(`
				.monaco-list${a}.drop-target,
				.monaco-list${a} .monaco-list-rows.drop-target,
				.monaco-list${a} .monaco-list-row.drop-target { background-color: ${l.listDropOverBackground} !important; color: inherit !important; }
			`),l.listDropBetweenBackground&&(g.push(`
			.monaco-list${a} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${a} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${a} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${a} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`)),l.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${l.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),l.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${l.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=g.join(`
`)}}t.DefaultStyleController=le,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:b.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:b.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:b.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Ne={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(B,l){const a=B.indexOf(l);if(a===-1)return[];const g=[];let C=a-1;for(;C>=0&&B[C]===l-(a-C);)g.push(B[C--]);for(g.reverse(),C=a;C<B.length&&B[C]===l+(C-a);)g.push(B[C++]);return g}function be(B,l){const a=[];let g=0,C=0;for(;g<B.length||C<l.length;)if(g>=B.length)a.push(l[C++]);else if(C>=l.length)a.push(B[g++]);else if(B[g]===l[C]){a.push(B[g]),g++,C++;continue}else B[g]<l[C]?a.push(B[g++]):a.push(l[C++]);return a}function Se(B,l){const a=[];let g=0,C=0;for(;g<B.length||C<l.length;)if(g>=B.length)a.push(l[C++]);else if(C>=l.length)a.push(B[g++]);else if(B[g]===l[C]){g++,C++;continue}else B[g]<l[C]?a.push(B[g++]):C++;return a}const Oe=(B,l)=>B-l;class Re{constructor(l,a){this._templateId=l,this.renderers=a}get templateId(){return this._templateId}renderTemplate(l){return this.renderers.map(a=>a.renderTemplate(l))}renderElement(l,a,g,C){let F=0;for(const u of this.renderers)u.renderElement(l,a,g[F++],C)}disposeElement(l,a,g,C){let F=0;for(const u of this.renderers)u.disposeElement?.(l,a,g[F],C),F+=1}disposeTemplate(l){let a=0;for(const g of this.renderers)g.disposeTemplate(l[a++])}}class We{constructor(l){this.accessibilityProvider=l,this.templateId="a18n"}renderTemplate(l){return{container:l,disposables:new s.DisposableStore}}renderElement(l,a,g){const C=this.accessibilityProvider.getAriaLabel(l),F=C&&typeof C!="string"?C:(0,r.constObservable)(C);g.disposables.add((0,r.autorun)(I=>{this.setAriaLabel(I.readObservable(F),g.container)}));const u=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(l);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}setAriaLabel(l,a){l?a.setAttribute("aria-label",l):a.removeAttribute("aria-label")}disposeElement(l,a,g,C){g.disposables.clear()}disposeTemplate(l){l.disposables.dispose()}}class oe{constructor(l,a){this.list=l,this.dnd=a}getDragElements(l){const a=this.list.getSelectedElements();return a.indexOf(l)>-1?a:[l]}getDragURI(l){return this.dnd.getDragURI(l)}getDragLabel(l,a){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(l,a)}onDragStart(l,a){this.dnd.onDragStart?.(l,a)}onDragOver(l,a,g,C,F){return this.dnd.onDragOver(l,a,g,C,F)}onDragLeave(l,a,g,C){this.dnd.onDragLeave?.(l,a,g,C)}onDragEnd(l){this.dnd.onDragEnd?.(l)}drop(l,a,g,C,F){this.dnd.drop(l,a,g,C,F)}dispose(){this.dnd.dispose()}}class q{get onDidChangeFocus(){return p.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),l=>this.toListEvent(l),this.disposables)}get onDidChangeSelection(){return p.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),l=>this.toListEvent(l),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let l=!1;const a=p.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,F=>F.map(u=>new k.StandardKeyboardEvent(u)).filter(u=>l=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).filter(()=>!1)),g=p.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event,F=>F.forEach(()=>l=!1).map(u=>new k.StandardKeyboardEvent(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).map(({browserEvent:u})=>{const I=this.getFocus(),A=I.length?I[0]:void 0,M=typeof A<"u"?this.view.element(A):void 0,V=typeof A<"u"?this.view.domElement(A):this.view.domNode;return{index:A,element:M,anchor:V,browserEvent:u}})),C=p.Event.chain(this.view.onContextMenu,F=>F.filter(u=>!l).map(({element:u,index:I,browserEvent:A})=>({element:u,index:I,anchor:new S.StandardMouseEvent((0,i.getWindow)(this.view.domNode),A),browserEvent:A})));return p.Event.any(a,g,C)}get onKeyDown(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return p.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return p.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(l,a,g,C,F=Ne){this.user=l,this._options=F,this.focus=new E("focused"),this.anchor=new E("anchor"),this.eventBufferer=new p.EventBufferer,this._ariaLabel="",this.disposables=new s.DisposableStore,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event;const u=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new T(u!=="listbox");const I=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=F.accessibilityProvider,this.accessibilityProvider&&(I.push(new We(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),C=C.map(M=>new Re(M.templateId,[...I,M]));const A={...F,dnd:F.dnd&&new oe(this,F.dnd)};if(this.view=this.createListView(a,g,C,A),this.view.domNode.setAttribute("role",u),F.styleController)this.styleController=F.styleController(this.view.domId);else{const M=(0,i.createStyleSheet)(this.view.domNode);this.styleController=new le(M,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new H(this.focus,this.view,F.identityProvider),new H(this.selection,this.view,F.identityProvider),new H(this.anchor,this.view,F.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new pe(this,this.view)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.keyboardController=new X(this,this.view,F),this.disposables.add(this.keyboardController)),F.keyboardNavigationLabelProvider){const M=F.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new ce(this,this.view,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),M),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(F),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(l,a,g,C){return new L.ListView(l,a,g,C)}createMouseController(l){return new he(this)}updateOptions(l={}){this._options={...this._options,...l},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(l),this.keyboardController?.updateOptions(l),this.view.updateOptions(l)}get options(){return this._options}splice(l,a,g=[]){if(l<0||l>this.view.length)throw new v.ListError(this.user,`Invalid start index: ${l}`);if(a<0)throw new v.ListError(this.user,`Invalid delete count: ${a}`);a===0&&g.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(l,a,g))}updateWidth(l){this.view.updateWidth(l)}updateElementHeight(l,a){this.view.updateElementHeight(l,a,null)}rerender(){this.view.rerender()}element(l){return this.view.element(l)}indexOf(l){return this.view.indexOf(l)}indexAt(l){return this.view.indexAt(l)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(l){this.view.setScrollTop(l)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(l){this.view.setScrollLeft(l)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(l){this._ariaLabel=l,this.view.domNode.setAttribute("aria-label",l)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(l,a){this.view.layout(l,a)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(l,a){for(const g of l)if(g<0||g>=this.length)throw new v.ListError(this.user,`Invalid index ${g}`);this.selection.set(l,a)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(l=>this.view.element(l))}setAnchor(l){if(typeof l>"u"){this.anchor.set([]);return}if(l<0||l>=this.length)throw new v.ListError(this.user,`Invalid index ${l}`);this.anchor.set([l])}getAnchor(){return(0,_.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const l=this.getAnchor();return typeof l>"u"?void 0:this.element(l)}setFocus(l,a){for(const g of l)if(g<0||g>=this.length)throw new v.ListError(this.user,`Invalid index ${g}`);this.focus.set(l,a)}focusNext(l=1,a=!1,g,C){if(this.length===0)return;const F=this.focus.get(),u=this.findNextIndex(F.length>0?F[0]+l:0,a,C);u>-1&&this.setFocus([u],g)}focusPrevious(l=1,a=!1,g,C){if(this.length===0)return;const F=this.focus.get(),u=this.findPreviousIndex(F.length>0?F[0]-l:0,a,C);u>-1&&this.setFocus([u],g)}async focusNextPage(l,a){let g=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);g=g===0?0:g-1;const C=this.getFocus()[0];if(C!==g&&(C===void 0||g>C)){const F=this.findPreviousIndex(g,!1,a);F>-1&&C!==F?this.setFocus([F],l):this.setFocus([g],l)}else{const F=this.view.getScrollTop();let u=F+this.view.renderHeight;g>C&&(u-=this.view.elementHeight(g)),this.view.setScrollTop(u),this.view.getScrollTop()!==F&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(l,a))}}async focusPreviousPage(l,a,g=()=>0){let C;const F=g(),u=this.view.getScrollTop()+F;u===0?C=this.view.indexAt(u):C=this.view.indexAfter(u-1);const I=this.getFocus()[0];if(I!==C&&(I===void 0||I>=C)){const A=this.findNextIndex(C,!1,a);A>-1&&I!==A?this.setFocus([A],l):this.setFocus([C],l)}else{const A=u;this.view.setScrollTop(u-this.view.renderHeight-F),this.view.getScrollTop()+g()!==A&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(l,a,g))}}focusLast(l,a){if(this.length===0)return;const g=this.findPreviousIndex(this.length-1,!1,a);g>-1&&this.setFocus([g],l)}focusFirst(l,a){this.focusNth(0,l,a)}focusNth(l,a,g){if(this.length===0)return;const C=this.findNextIndex(l,!1,g);C>-1&&this.setFocus([C],a)}findNextIndex(l,a=!1,g){for(let C=0;C<this.length;C++){if(l>=this.length&&!a)return-1;if(l=l%this.length,!g||g(this.element(l)))return l;l++}return-1}findPreviousIndex(l,a=!1,g){for(let C=0;C<this.length;C++){if(l<0&&!a)return-1;if(l=(this.length+l%this.length)%this.length,!g||g(this.element(l)))return l;l--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(l=>this.view.element(l))}reveal(l,a,g=0){if(l<0||l>=this.length)throw new v.ListError(this.user,`Invalid index ${l}`);const C=this.view.getScrollTop(),F=this.view.elementTop(l),u=this.view.elementHeight(l);if((0,h.isNumber)(a)){const I=u-this.view.renderHeight+g;this.view.setScrollTop(I*(0,o.clamp)(a,0,1)+F-g)}else{const I=F+u,A=C+this.view.renderHeight;F<C+g&&I>=A||(F<C+g||I>=A&&u>=this.view.renderHeight?this.view.setScrollTop(F-g):I>=A&&this.view.setScrollTop(I-this.view.renderHeight))}}getRelativeTop(l,a=0){if(l<0||l>=this.length)throw new v.ListError(this.user,`Invalid index ${l}`);const g=this.view.getScrollTop(),C=this.view.elementTop(l),F=this.view.elementHeight(l);if(C<g+a||C+F>g+this.view.renderHeight)return null;const u=F-this.view.renderHeight+a;return Math.abs((g+a-C)/u)}isDOMFocused(){return(0,i.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(l){return this.view.getElementDomId(l)}getElementTop(l){return this.view.elementTop(l)}style(l){this.styleController.style(l)}toListEvent({indexes:l,browserEvent:a}){return{indexes:l,elements:l.map(g=>this.view.element(g)),browserEvent:a}}_onFocusChange(){const l=this.focus.get();this.view.domNode.classList.toggle("element-focused",l.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const l=this.focus.get();if(l.length>0){let a;this.accessibilityProvider?.getActiveDescendantId&&(a=this.accessibilityProvider.getActiveDescendantId(this.view.element(l[0]))),this.view.domNode.setAttribute("aria-activedescendant",a||this.view.getElementDomId(l[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const l=this.selection.get();this.view.domNode.classList.toggle("selection-none",l.length===0),this.view.domNode.classList.toggle("selection-single",l.length===1),this.view.domNode.classList.toggle("selection-multiple",l.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=q,et([y.memoize],q.prototype,"onDidChangeFocus",null),et([y.memoize],q.prototype,"onDidChangeSelection",null),et([y.memoize],q.prototype,"onContextMenu",null),et([y.memoize],q.prototype,"onKeyDown",null),et([y.memoize],q.prototype,"onKeyUp",null),et([y.memoize],q.prototype,"onKeyPress",null),et([y.memoize],q.prototype,"onDidFocus",null),et([y.memoize],q.prototype,"onDidBlur",null)}),define(De[144],we([1,0,6,67,52,11,17]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=d,t.isMarkdownString=b,t.markdownStringEqual=y,t.escapeMarkdownSyntaxTokens=p,t.appendEscapedMarkdownCodeBlockFence=m,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=s,t.parseHrefAndDimensions=o;var w;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class _{constructor(h="",v=!1){if(this.value=h,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(h,v=w.Paragraph){return this.value+=p(this.supportThemeIcons?(0,n.escapeIcons)(h):h).replace(/([ \t]+)/g,(L,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===w.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+=`
${m(v,h)}
`,this}appendLink(h,v,L){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(h),")"),L&&(this.value+=` "${this._escape(this._escape(L,'"'),")")}"`),this.value+=")",this}_escape(h,v){const L=new RegExp((0,R.escapeRegExpCharacters)(v),"g");return h.replace(L,(S,r)=>h.charAt(r-1)!=="\\"?`\\${S}`:S)}}t.MarkdownString=_;function d(c){return b(c)?!c.value:Array.isArray(c)?c.every(d):!0}function b(c){return c instanceof _?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,k.isEqual)(N.URI.from(c.baseUri),N.URI.from(h.baseUri)))}function p(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(c,h){const v=c.match(/^`+/gm)?.reduce((S,r)=>S.length>r.length?S:r).length??0,L=v>=3?v+1:3;return[`${"`".repeat(L)}${h}`,c,`${"`".repeat(L)}`].join(`
`)}function e(c){return c.replace(/"/g,"&quot;")}function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const h=[],v=c.split("|").map(S=>S.trim());c=v[0];const L=v[1];if(L){const S=/height=(\d+)/.exec(L),r=/width=(\d+)/.exec(L),f=S?S[1]:"",E=r?r[1]:"",T=isFinite(parseInt(E)),H=isFinite(parseInt(f));T&&h.push(`width="${E}"`),H&&h.push(`height="${f}"`)}return{href:c,dimensions:h}}}),define(De[145],we([1,0,4,136,29,72,16,23,137,6,3,144,67,91,8,26,2,92,70,41,64,52,11,17]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o,c,h,v,L,S,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=T,t.renderStringAsPlaintext=z,t.renderMarkdownAsPlaintext=O,t.fillInIncompleteTokens=re,i=Ue(i),n=Ue(n);const E=Object.freeze({image:(l,a,g)=>{let C=[],F=[];return l&&({href:l,dimensions:C}=(0,y.parseHrefAndDimensions)(l),F.push(`src="${(0,y.escapeDoubleQuotes)(l)}"`)),g&&F.push(`alt="${(0,y.escapeDoubleQuotes)(g)}"`),a&&F.push(`title="${(0,y.escapeDoubleQuotes)(a)}"`),C.length&&(F=F.concat(C)),"<img "+F.join(" ")+">"},paragraph:l=>`<p>${l}</p>`,link:(l,a,g)=>typeof l!="string"?"":(l===g&&(g=(0,y.removeMarkdownEscapes)(g)),a=typeof a=="string"?(0,y.escapeDoubleQuotes)((0,y.removeMarkdownEscapes)(a)):"",l=(0,y.removeMarkdownEscapes)(l),l=l.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${l}" title="${a||l}" draggable="false">${g}</a>`)});function T(l,a={},g={}){const C=new o.DisposableStore;let F=!1;const u=(0,R.createElement)(a),I=function(Ee){let Le;try{Le=(0,h.parse)(decodeURIComponent(Ee))}catch{}return Le?(Le=(0,L.cloneAndChange)(Le,Ie=>{if(l.uris&&l.uris[Ie])return f.URI.revive(l.uris[Ie])}),encodeURIComponent(JSON.stringify(Le))):Ee},A=function(Ee,Le){const Ie=l.uris&&l.uris[Ee];let de=f.URI.revive(Ie);return Le?Ee.startsWith(v.Schemas.data+":")?Ee:(de||(de=f.URI.parse(Ee)),v.FileAccess.uriToBrowserUri(de).toString(!0)):!de||f.URI.parse(Ee).toString()===de.toString()?Ee:(de.query&&(de=de.with({query:I(de.query)})),de.toString())},M=new c.marked.Renderer;M.image=E.image,M.link=E.link,M.paragraph=E.paragraph;const V=[],Y=[];if(a.codeBlockRendererSync?M.code=(Ee,Le)=>{const Ie=m.defaultGenerator.nextId(),de=a.codeBlockRendererSync(H(Le),Ee);return Y.push([Ie,de]),`<div class="code" data-code="${Ie}">${(0,r.escape)(Ee)}</div>`}:a.codeBlockRenderer&&(M.code=(Ee,Le)=>{const Ie=m.defaultGenerator.nextId(),de=a.codeBlockRenderer(H(Le),Ee);return V.push(de.then(Ce=>[Ie,Ce])),`<div class="code" data-code="${Ie}">${(0,r.escape)(Ee)}</div>`}),a.actionHandler){const Ee=function(de){let Ce=de.target;if(!(Ce.tagName!=="A"&&(Ce=Ce.parentElement,!Ce||Ce.tagName!=="A")))try{let qe=Ce.dataset.href;qe&&(l.baseUri&&(qe=W(f.URI.from(l.baseUri),qe)),a.actionHandler.callback(qe,de))}catch(qe){(0,d.onUnexpectedError)(qe)}finally{de.preventDefault()}},Le=a.actionHandler.disposables.add(new k.DomEmitter(u,"click")),Ie=a.actionHandler.disposables.add(new k.DomEmitter(u,"auxclick"));a.actionHandler.disposables.add(b.Event.any(Le.event,Ie.event)(de=>{const Ce=new w.StandardMouseEvent(i.getWindow(u),de);!Ce.leftButton&&!Ce.middleButton||Ee(Ce)})),a.actionHandler.disposables.add(i.addDisposableListener(u,"keydown",de=>{const Ce=new N.StandardKeyboardEvent(de);!Ce.equals(e.KeyCode.Space)&&!Ce.equals(e.KeyCode.Enter)||Ee(Ce)}))}l.supportHtml||(g.sanitizer=Ee=>a.sanitizerOptions?.replaceWithPlaintext?(0,r.escape)(Ee):(l.isTrusted?Ee.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?Ee:"",g.sanitize=!0,g.silent=!0),g.renderer=M;let ie=l.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),l.supportThemeIcons&&(ie=(0,p.markdownEscapeEscapedIcons)(ie));let ae;if(a.fillInIncompleteTokens){const Ee={...c.marked.defaults,...g},Le=c.marked.lexer(ie,Ee),Ie=re(Le);ae=c.marked.parser(Ie,Ee)}else ae=c.marked.parse(ie,g);l.supportThemeIcons&&(ae=(0,_.renderLabelWithIcons)(ae).map(Le=>typeof Le=="string"?Le:Le.outerHTML).join(""));const _e=new DOMParser().parseFromString(D({isTrusted:l.isTrusted,...a.sanitizerOptions},ae),"text/html");if(_e.body.querySelectorAll("img, audio, video, source").forEach(Ee=>{const Le=Ee.getAttribute("src");if(Le){let Ie=Le;try{l.baseUri&&(Ie=W(f.URI.from(l.baseUri),Ie))}catch{}if(Ee.setAttribute("src",A(Ie,!0)),a.remoteImageIsAllowed){const de=f.URI.parse(Ie);de.scheme!==v.Schemas.file&&de.scheme!==v.Schemas.data&&!a.remoteImageIsAllowed(de)&&Ee.replaceWith(i.$("",void 0,Ee.outerHTML))}}}),_e.body.querySelectorAll("a").forEach(Ee=>{const Le=Ee.getAttribute("href");if(Ee.setAttribute("href",""),!Le||/^data:|javascript:/i.test(Le)||/^command:/i.test(Le)&&!l.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Le))Ee.replaceWith(...Ee.childNodes);else{let Ie=A(Le,!1);l.baseUri&&(Ie=W(f.URI.from(l.baseUri),Le)),Ee.dataset.href=Ie}}),u.innerHTML=D({isTrusted:l.isTrusted,...a.sanitizerOptions},_e.body.innerHTML),V.length>0)Promise.all(V).then(Ee=>{if(F)return;const Le=new Map(Ee),Ie=u.querySelectorAll("div[data-code]");for(const de of Ie){const Ce=Le.get(de.dataset.code??"");Ce&&i.reset(de,Ce)}a.asyncRenderCallback?.()});else if(Y.length>0){const Ee=new Map(Y),Le=u.querySelectorAll("div[data-code]");for(const Ie of Le){const de=Ee.get(Ie.dataset.code??"");de&&i.reset(Ie,de)}}if(a.asyncRenderCallback)for(const Ee of u.getElementsByTagName("img")){const Le=C.add(i.addDisposableListener(Ee,"load",()=>{Le.dispose(),a.asyncRenderCallback()}))}return{element:u,dispose:()=>{F=!0,C.dispose()}}}function H(l){if(!l)return"";const a=l.split(/[\s+|:|,|\{|\?]/,1);return a.length?a[0]:l}function W(l,a){return/^\w[\w\d+.-]*:/.test(a)?a:l.path.endsWith("/")?(0,S.resolvePath)(l,a).toString():(0,S.resolvePath)((0,S.dirname)(l),a).toString()}const U=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function D(l,a){const{config:g,allowedSchemes:C}=x(l),F=new o.DisposableStore;F.add(B("uponSanitizeAttribute",(u,I)=>{if(I.attrName==="style"||I.attrName==="class"){if(u.tagName==="SPAN"){if(I.attrName==="style"){I.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(I.attrValue);return}else if(I.attrName==="class"){I.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(I.attrValue);return}}I.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(I.attrName==="type"&&I.attrValue==="checkbox"||I.attrName==="disabled"||I.attrName==="checked"){I.keepAttr=!0;return}I.keepAttr=!1}})),F.add(B("uponSanitizeElement",(u,I)=>{if(I.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):l.replaceWithPlaintext||u.remove()),l.replaceWithPlaintext&&!I.allowedTags[I.tagName]&&I.tagName!=="body"&&u.parentElement){let A,M;if(I.tagName==="#comment")A=`<!--${u.textContent}-->`;else{const ae=U.includes(I.tagName),fe=u.attributes.length?" "+Array.from(u.attributes).map(_e=>`${_e.name}="${_e.value}"`).join(" "):"";A=`<${I.tagName}${fe}>`,ae||(M=`</${I.tagName}>`)}const V=document.createDocumentFragment(),Y=u.parentElement.ownerDocument.createTextNode(A);V.appendChild(Y);const ie=M?u.parentElement.ownerDocument.createTextNode(M):void 0;for(;u.firstChild;)V.appendChild(u.firstChild);ie&&V.appendChild(ie),u.parentElement.replaceChild(V,u)}})),F.add(i.hookDomPurifyHrefAndSrcSanitizer(C));try{return n.sanitize(a,{...g,RETURN_TRUSTED_TYPE:!0})}finally{F.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function x(l){const a=[v.Schemas.http,v.Schemas.https,v.Schemas.mailto,v.Schemas.data,v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemote,v.Schemas.vscodeRemoteResource];return l.isTrusted&&a.push(v.Schemas.command),{config:{ALLOWED_TAGS:l.allowedTags??[...i.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:a}}function z(l){return typeof l=="string"?l:O(l)}function O(l,a){let g=l.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const C=c.marked.parse(g,{renderer:a?X.value:Q.value}).replace(/&(#\d+|[a-zA-Z]+);/g,F=>P.get(F)??F);return D({isTrusted:!1},C).toString()}const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function K(){const l=new c.marked.Renderer;return l.code=a=>a,l.blockquote=a=>a,l.html=a=>"",l.heading=(a,g,C)=>a+`
`,l.hr=()=>"",l.list=(a,g)=>a,l.listitem=a=>a+`
`,l.paragraph=a=>a+`
`,l.table=(a,g)=>a+g+`
`,l.tablerow=a=>a,l.tablecell=(a,g)=>a+" ",l.strong=a=>a,l.em=a=>a,l.codespan=a=>a,l.br=()=>`
`,l.del=a=>a,l.image=(a,g,C)=>"",l.text=a=>a,l.link=(a,g,C)=>C,l}const Q=new s.Lazy(l=>K()),X=new s.Lazy(()=>{const l=K();return l.code=a=>`
\`\`\`
${a}
\`\`\`
`,l});function G(l){let a="";return l.forEach(g=>{a+=g.raw}),a}function J(l){if(l.tokens)for(let a=l.tokens.length-1;a>=0;a--){const g=l.tokens[a];if(g.type==="text"){const C=g.raw.split(`
`),F=C[C.length-1];if(F.includes("`"))return le(l);if(F.includes("**"))return Re(l);if(F.match(/\*\w/))return Ne(l);if(F.match(/(^|\s)__\w/))return We(l);if(F.match(/(^|\s)_\w/))return te(l);if(ce(F)||pe(F)&&l.tokens.slice(0,a).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=l.tokens.slice(a+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||F.match(/^[^"]* +"[^"]*$/)?Se(l):be(l)}else if(F.match(/(^|\s)\[\w*/))return Oe(l)}}}function ce(l){return!!l.match(/(^|\s)\[.*\]\(\w*/)}function pe(l){return!!l.match(/^[^\[]*\]\([^\)]*$/)}function Te(l){const a=l.items[l.items.length-1],g=a.tokens?a.tokens[a.tokens.length-1]:void 0;let C;if(g?.type==="text"&&!("inRawBlock"in a)&&(C=J(g)),!C||C.type!=="paragraph")return;const F=G(l.items.slice(0,-1)),u=a.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!u)return;const I=u+G(a.tokens.slice(0,-1))+C.raw,A=c.marked.lexer(F+I)[0];if(A.type==="list")return A}const Fe=3;function re(l){for(let a=0;a<Fe;a++){const g=ee(l);if(g)l=g;else break}return l}function ee(l){let a,g;for(a=0;a<l.length;a++){const C=l[a];let F;if(C.type==="paragraph"&&(F=C.raw.match(/(\n|^)(````*)/))){const u=F[2];g=he(l.slice(a),u);break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){g=q(l.slice(a));break}if(a===l.length-1&&C.type==="list"){const u=Te(C);if(u){g=[u];break}}if(a===l.length-1&&C.type==="paragraph"){const u=J(C);if(u){g=[u];break}}}if(g){const C=[...l.slice(0,a),...g];return C.links=l.links,C}return null}function he(l,a){const g=G(l);return c.marked.lexer(g+`
${a}`)}function le(l){return oe(l,"`")}function Ne(l){return oe(l,"*")}function te(l){return oe(l,"_")}function be(l){return oe(l,")")}function Se(l){return oe(l,'")')}function Oe(l){return oe(l,"](https://microsoft.com)")}function Re(l){return oe(l,"**")}function We(l){return oe(l,"__")}function oe(l,a){const g=G(Array.isArray(l)?l:[l]);return c.marked.lexer(g+a)[0]}function q(l){const a=G(l),g=a.split(`
`);let C,F=!1;for(let u=0;u<g.length;u++){const I=g[u].trim();if(typeof C>"u"&&I.match(/^\s*\|/)){const A=I.match(/(\|[^\|]+)(?=\||$)/g);A&&(C=A.length)}else if(typeof C=="number")if(I.match(/^\s*\|/)){if(u!==g.length-1)return;F=!0}else return}if(typeof C=="number"&&C>0){const u=F?g.slice(0,-1).join(`
`):a,I=!!u.match(/\|\s*$/),A=u+(I?"":"|")+`
|${" --- |".repeat(C)}`;return c.marked.lexer(A)}}function B(l,a){return n.addHook(l,a),(0,o.toDisposable)(()=>n.removeHook(l))}}),define(De[146],we([1,0,4,29,16,145,75,34,15,54,9,3,8,2,5,20,128,120]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0,i=Ue(i),b=Ue(b);const c=i.$,h="selectOption.entry.template";class v{get templateId(){return h}renderTemplate(r){const f=Object.create(null);return f.root=r,f.text=i.append(r,c(".option-text")),f.detail=i.append(r,c(".option-detail")),f.decoratorRight=i.append(r,c(".option-decorator-right")),f}renderElement(r,f,E){const T=E,H=r.text,W=r.detail,U=r.decoratorRight,D=r.isDisabled;T.text.textContent=H,T.detail.textContent=W||"",T.decoratorRight.innerText=U||"",D?T.root.classList.add("option-disabled"):T.root.classList.remove("option-disabled")}disposeTemplate(r){}}class L extends m.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(r,f,E,T,H){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=T,this.selectBoxOptions=H||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=L.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new y.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(E),this.selected=f||0,r&&this.setOptions(r,f),this.initStyleSheet()}setTitle(r){!this._hover&&r?this._hover=this._register((0,w.getBaseLayerHoverDelegate)().setupManagedHover((0,_.getDefaultHoverDelegate)("mouse"),this.selectElement,r)):this._hover&&this._hover.update(r)}getHeight(){return 22}getTemplateId(){return h}constructSelectDropDown(r){this.contextViewProvider=r,this.selectDropDownContainer=i.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=i.append(this.selectDropDownContainer,c(".select-box-details-pane"));const f=i.append(this.selectDropDownContainer,c(".select-box-dropdown-container-width-control")),E=i.append(f,c(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",i.append(E,this.widthControlElement),this._dropDownPosition=N.AnchorPosition.BELOW,this.styleElement=i.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.DRAG_START,T=>{i.EventHelper.stop(T,!0)}))}registerListeners(){this._register(i.addStandardDisposableListener(this.selectElement,"change",f=>{this.selected=f.target.selectedIndex,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(i.addDisposableListener(this.selectElement,i.EventType.CLICK,f=>{i.EventHelper.stop(f),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.MOUSE_DOWN,f=>{i.EventHelper.stop(f)}));let r;this._register(i.addDisposableListener(this.selectElement,"touchstart",f=>{r=this._isVisible})),this._register(i.addDisposableListener(this.selectElement,"touchend",f=>{i.EventHelper.stop(f),r?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.KEY_DOWN,f=>{const E=new k.StandardKeyboardEvent(f);let T=!1;e.isMacintosh?(E.keyCode===p.KeyCode.DownArrow||E.keyCode===p.KeyCode.UpArrow||E.keyCode===p.KeyCode.Space||E.keyCode===p.KeyCode.Enter)&&(T=!0):(E.keyCode===p.KeyCode.DownArrow&&E.altKey||E.keyCode===p.KeyCode.UpArrow&&E.altKey||E.keyCode===p.KeyCode.Space||E.keyCode===p.KeyCode.Enter)&&(T=!0),T&&(this.showSelectDropDown(),i.EventHelper.stop(f,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(r,f){b.equals(this.options,r)||(this.options=r,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((E,T)=>{this.selectElement.add(this.createOption(E.text,T,E.isDisabled)),typeof E.description=="string"&&(this._hasDetails=!0)})),f!==void 0&&(this.select(f),this._currentSelection=this.selected)}setEnabled(r){this.selectElement.disabled=!r}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(r){r>=0&&r<this.options.length?this.selected=r:r>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(r){this.selectBoxOptions.ariaLabel=r,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(r){this.selectElement.tabIndex=r?0:-1}render(r){this.container=r,r.classList.add("select-container"),r.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const r=[];this.styles.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=r.join(`
`)}styleSelectElement(){const r=this.styles.selectBackground??"",f=this.styles.selectForeground??"",E=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=r,this.selectElement.style.color=f,this.selectElement.style.borderColor=E}styleList(){const r=this.styles.selectBackground??"",f=i.asCssValueWithDefault(this.styles.selectListBackground,r);this.selectDropDownListContainer.style.backgroundColor=f,this.selectionDetailsPane.style.backgroundColor=f;const E=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=E,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(r,f,E){const T=document.createElement("option");return T.value=r,T.text=r,T.disabled=!!E,T}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:r=>this.renderSelectDropDown(r,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:r=>this.renderSelectDropDown(r),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(r){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),r&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(r,f){return r.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(f),{dispose:()=>{this.selectDropDownContainer.remove()}}}measureMaxDetailsHeight(){let r=0;return this.options.forEach((f,E)=>{this.updateDetail(E),this.selectionDetailsPane.offsetHeight>r&&(r=this.selectionDetailsPane.offsetHeight)}),r}layoutSelectDropDown(r){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const f=i.getWindow(this.selectElement),E=i.getDomNodePagePosition(this.selectElement),T=i.getWindow(this.selectElement).getComputedStyle(this.selectElement),H=parseFloat(T.getPropertyValue("--dropdown-padding-top"))+parseFloat(T.getPropertyValue("--dropdown-padding-bottom")),W=f.innerHeight-E.top-E.height-(this.selectBoxOptions.minBottomMargin||0),U=E.top-L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,D=this.selectElement.offsetWidth,x=this.setWidthControlElement(this.widthControlElement),z=Math.max(x,Math.round(D)).toString()+"px";this.selectDropDownContainer.style.width=z,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let O=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const P=this._hasDetails?this._cachedMaxDetailsHeight:0,K=O+H+P,Q=Math.floor((W-H-P)/this.getHeight()),X=Math.floor((U-H-P)/this.getHeight());if(r)return E.top+E.height>f.innerHeight-22||E.top<L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||Q<1&&X<1?!1:(Q<L.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&X>Q&&this.options.length>Q?(this._dropDownPosition=N.AnchorPosition.ABOVE,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=N.AnchorPosition.BELOW,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(E.top+E.height>f.innerHeight-22||E.top<L.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===N.AnchorPosition.BELOW&&Q<1||this._dropDownPosition===N.AnchorPosition.ABOVE&&X<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===N.AnchorPosition.BELOW){if(this._isVisible&&Q+X<1)return this.hideSelectDropDown(!0),!1;K>W&&(O=Q*this.getHeight())}else K>U&&(O=X*this.getHeight());return this.selectList.layout(O),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=O+H+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=O+H+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=z,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(r){let f=0;if(r){let E=0,T=0;this.options.forEach((H,W)=>{const U=H.detail?H.detail.length:0,D=H.decoratorRight?H.decoratorRight.length:0,x=H.text.length+U+D;x>T&&(E=W,T=x)}),r.textContent=this.options[E].text+(this.options[E].decoratorRight?this.options[E].decoratorRight+" ":""),f=i.getTotalWidth(r)}return f}createSelectList(r){if(this.selectList)return;this.selectDropDownListContainer=i.append(r,c(".select-box-dropdown-list-container")),this.listRenderer=new v,this.selectList=new d.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:T=>{let H=T.text;return T.detail&&(H+=`. ${T.detail}`),T.decoratorRight&&(H+=`. ${T.decoratorRight}`),T.description&&(H+=`. ${T.description}`),H},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>e.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const f=this._register(new n.DomEmitter(this.selectDropDownListContainer,"keydown")),E=y.Event.chain(f.event,T=>T.filter(()=>this.selectList.length>0).map(H=>new k.StandardKeyboardEvent(H)));this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.Enter))(this.onEnter,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.Tab))(this.onEnter,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.Escape))(this.onEscape,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.UpArrow))(this.onUpArrow,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.DownArrow))(this.onDownArrow,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.PageDown))(this.onPageDown,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.PageUp))(this.onPageUp,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.Home))(this.onHome,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode===p.KeyCode.End))(this.onEnd,this)),this._register(y.Event.chain(E,T=>T.filter(H=>H.keyCode>=p.KeyCode.Digit0&&H.keyCode<=p.KeyCode.KeyZ||H.keyCode>=p.KeyCode.Semicolon&&H.keyCode<=p.KeyCode.NumpadDivide))(this.onCharacter,this)),this._register(i.addDisposableListener(this.selectList.getHTMLElement(),i.EventType.POINTER_UP,T=>this.onPointerUp(T))),this._register(this.selectList.onMouseOver(T=>typeof T.index<"u"&&this.selectList.setFocus([T.index]))),this._register(this.selectList.onDidChangeFocus(T=>this.onListFocus(T))),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.FOCUS_OUT,T=>{!this._isVisible||i.isAncestor(T.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(r){if(!this.selectList.length)return;i.EventHelper.stop(r);const f=r.target;if(!f||f.classList.contains("slider"))return;const E=f.closest(".monaco-list-row");if(!E)return;const T=Number(E.getAttribute("data-index")),H=E.classList.contains("option-disabled");T>=0&&T<this.options.length&&!H&&(this.selected=T,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(r,f){const E=H=>{for(let W=0;W<H.childNodes.length;W++){const U=H.childNodes.item(W);(U.tagName&&U.tagName.toLowerCase())==="img"?U.remove():E(U)}},T=(0,R.renderMarkdown)({value:r,supportThemeIcons:!0},{actionHandler:f});return T.element.classList.add("select-box-description-markdown"),E(T.element),T.element}onListFocus(r){!this._isVisible||!this._hasDetails||this.updateDetail(r.indexes[0])}updateDetail(r){this.selectionDetailsPane.innerText="";const f=this.options[r],E=f?.description??"",T=f?.descriptionIsMarkdown??!1;if(E){if(T){const H=f.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(E,H))}else this.selectionDetailsPane.innerText=E;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(r){i.EventHelper.stop(r),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(r){i.EventHelper.stop(r),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(r){if(this.selected<this.options.length-1){i.EventHelper.stop(r,!0);const f=this.options[this.selected+1].isDisabled;if(f&&this.options.length>this.selected+2)this.selected+=2;else{if(f)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(r){this.selected>0&&(i.EventHelper.stop(r,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(r){i.EventHelper.stop(r),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(r){i.EventHelper.stop(r),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(r){i.EventHelper.stop(r),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(r){i.EventHelper.stop(r),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(r){const f=p.KeyCodeUtils.toString(r.keyCode);let E=-1;for(let T=0;T<this.options.length-1;T++)if(E=(T+this.selected+1)%this.options.length,this.options[E].text.charAt(0).toUpperCase()===f&&!this.options[E].isDisabled){this.select(E),this.selectList.setFocus([E]),this.selectList.reveal(this.selectList.getFocus()[0]),i.EventHelper.stop(r);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=L}),define(De[147],we([1,0,54,146,140,24,5,119]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...i.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends R.Widget{constructor(d,b,y,p,m){super(),N.isMacintosh&&!m?.useCustomDrawn?this.selectBoxDelegate=new k.SelectBoxNative(d,b,p,m):this.selectBoxDelegate=new n.SelectBoxList(d,b,y,p,m),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(d,b){this.selectBoxDelegate.setOptions(d,b)}select(d){this.selectBoxDelegate.select(d)}setAriaLabel(d){this.selectBoxDelegate.setAriaLabel(d)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(d){this.selectBoxDelegate.setFocusable(d)}setEnabled(d){this.selectBoxDelegate.setEnabled(d)}render(d){this.selectBoxDelegate.render(d)}}t.SelectBox=w}),define(De[80],we([1,0,19,71,4,33,15,147,51,2,5,10,124,34,68]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0,b=Ue(b),y=Ue(y),p=Ue(p);class e extends d.Disposable{get action(){return this._action}constructor(h,v,L={}){super(),this.options=L,this._context=h||this,this._action=v,v instanceof _.Action&&this._register(v.onDidChange(S=>{this.element&&this.handleActionChangeEvent(S)}))}handleActionChangeEvent(h){h.enabled!==void 0&&this.updateEnabled(),h.checked!==void 0&&this.updateChecked(),h.class!==void 0&&this.updateClass(),h.label!==void 0&&(this.updateLabel(),this.updateTooltip()),h.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new _.ActionRunner)),this._actionRunner}set actionRunner(h){this._actionRunner=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const v=this.element=h;this._register(R.Gesture.addTarget(h));const L=this.options&&this.options.draggable;L&&(h.draggable=!0,i.isFirefox&&this._register((0,k.addDisposableListener)(h,k.EventType.DRAG_START,S=>S.dataTransfer?.setData(n.DataTransfers.TEXT,this._action.label)))),this._register((0,k.addDisposableListener)(v,R.EventType.Tap,S=>this.onClick(S,!0))),this._register((0,k.addDisposableListener)(v,k.EventType.MOUSE_DOWN,S=>{L||k.EventHelper.stop(S,!0),this._action.enabled&&S.button===0&&v.classList.add("active")})),b.isMacintosh&&this._register((0,k.addDisposableListener)(v,k.EventType.CONTEXT_MENU,S=>{S.button===0&&S.ctrlKey===!0&&this.onClick(S)})),this._register((0,k.addDisposableListener)(v,k.EventType.CLICK,S=>{k.EventHelper.stop(S,!0),this.options&&this.options.isMenu||this.onClick(S)})),this._register((0,k.addDisposableListener)(v,k.EventType.DBLCLICK,S=>{k.EventHelper.stop(S,!0)})),[k.EventType.MOUSE_UP,k.EventType.MOUSE_OUT].forEach(S=>{this._register((0,k.addDisposableListener)(v,S,r=>{k.EventHelper.stop(r),v.classList.remove("active")}))})}onClick(h,v=!1){k.EventHelper.stop(h,!0);const L=y.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?h:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,L)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const h=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=h;else if(!this.customHover&&h!==""){const v=this.options.hoverDelegate??(0,N.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,m.getBaseLayerHoverDelegate)().setupManagedHover(v,this.element,h))}else this.customHover&&this.customHover.update(h)}updateAriaLabel(){if(this.element){const h=this.getTooltip()??"";this.element.setAttribute("aria-label",h)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class s extends e{constructor(h,v,L){super(h,v,L),this.options=L,this.options.icon=L.icon!==void 0?L.icon:!1,this.options.label=L.label!==void 0?L.label:!0,this.cssClass=""}render(h){super.render(h),y.assertType(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.getDefaultAriaRole()),this.label=v,this.element.appendChild(v),this.options.label&&this.options.keybinding){const L=document.createElement("span");L.classList.add("keybinding"),L.textContent=this.options.keybinding,this.element.appendChild(L)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===_.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(h){this.label&&(this.label.tabIndex=h?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(h=this.action.label,this.options.keybinding&&(h=p.localize(0,null,h,this.options.keybinding))),h??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const h=this.getTooltip()??"";this.label.setAttribute("aria-label",h)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.removeAttribute("aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=s;class o extends e{constructor(h,v,L,S,r,f,E){super(h,v),this.selectBox=new w.SelectBox(L,S,r,f,E),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(h,v){this.selectBox.setOptions(h,v)}select(h){this.selectBox.select(h)}registerListeners(){this._register(this.selectBox.onDidSelect(h=>this.runAction(h.selected,h.index)))}runAction(h,v){this.actionRunner.run(this._action,this.getActionContext(h,v))}getActionContext(h,v){return h}setFocusable(h){this.selectBox.setFocusable(h)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(h){this.selectBox.render(h)}}t.SelectActionViewItem=o}),define(De[81],we([1,0,4,16,80,15,51,3,8,2,10,68]),function(ne,t,i,n,k,R,N,w,_,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=m,i=Ue(i),b=Ue(b);var y;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(y||(t.ActionsOrientation=y={}));class p extends d.Disposable{constructor(s,o={}){super(),this._actionRunnerDisposables=this._register(new d.DisposableStore),this.viewItemDisposables=this._register(new d.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new w.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this.options=o,this._context=o.context??null,this._orientation=this.options.orientation??y.HORIZONTAL,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[_.KeyCode.Enter,_.KeyCode.Space]},this._hoverDelegate=o.hoverDelegate??this._register((0,R.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new N.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(v=>this._onDidRun.fire(v))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(v=>this._onWillRun.fire(v))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let c,h;switch(this._orientation){case y.HORIZONTAL:c=[_.KeyCode.LeftArrow],h=[_.KeyCode.RightArrow];break;case y.VERTICAL:c=[_.KeyCode.UpArrow],h=[_.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_DOWN,v=>{const L=new n.StandardKeyboardEvent(v);let S=!0;const r=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;c&&(L.equals(c[0])||L.equals(c[1]))?S=this.focusPrevious():h&&(L.equals(h[0])||L.equals(h[1]))?S=this.focusNext():L.equals(_.KeyCode.Escape)&&this.cancelHasListener?this._onDidCancel.fire():L.equals(_.KeyCode.Home)?S=this.focusFirst():L.equals(_.KeyCode.End)?S=this.focusLast():L.equals(_.KeyCode.Tab)&&r instanceof k.BaseActionViewItem&&r.trapsArrowNavigation?S=this.focusNext():this.isTriggerKeyEvent(L)?this._triggerKeys.keyDown?this.doTrigger(L):this.triggerKeyDown=!0:S=!1,S&&(L.preventDefault(),L.stopPropagation())})),this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_UP,v=>{const L=new n.StandardKeyboardEvent(v);this.isTriggerKeyEvent(L)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(L)),L.preventDefault(),L.stopPropagation()):(L.equals(_.KeyCode.Tab)||L.equals(_.KeyMod.Shift|_.KeyCode.Tab)||L.equals(_.KeyCode.UpArrow)||L.equals(_.KeyCode.DownArrow)||L.equals(_.KeyCode.LeftArrow)||L.equals(_.KeyCode.RightArrow))&&this.updateFocusedItem()})),this.focusTracker=this._register(i.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(i.getActiveElement()===this.domNode||!i.isAncestor(i.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const o=this.viewItems.find(c=>c instanceof k.BaseActionViewItem&&c.isEnabled());o instanceof k.BaseActionViewItem&&o.setFocusable(!0)}else this.viewItems.forEach(o=>{o instanceof k.BaseActionViewItem&&o.setFocusable(!1)})}isTriggerKeyEvent(s){let o=!1;return this._triggerKeys.keys.forEach(c=>{o=o||s.equals(c)}),o}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const o=this.actionsList.children[s];if(i.isAncestor(i.getActiveElement(),o)){this.focusedItem=s,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(o=>o.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){this._actionRunner=s,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(o=>this._onDidRun.fire(o))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(o=>this._onWillRun.fire(o))),this.viewItems.forEach(o=>o.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(o=>o.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.isHTMLElement(s)){for(;s.parentElement!==this.actionsList;){if(!s.parentElement)return;s=s.parentElement}for(let o=0;o<this.actionsList.childNodes.length;o++)if(this.actionsList.childNodes[o]===s)return this.viewItems[o].action}}push(s,o={}){const c=Array.isArray(s)?s:[s];let h=b.isNumber(o.index)?o.index:null;c.forEach(v=>{const L=document.createElement("li");L.className="action-item",L.setAttribute("role","presentation");let S;const r={hoverDelegate:this._hoverDelegate,...o};this.options.actionViewItemProvider&&(S=this.options.actionViewItemProvider(v,r)),S||(S=new k.ActionViewItem(this.context,v,r)),this.options.allowContextMenu||this.viewItemDisposables.set(S,i.addDisposableListener(L,i.EventType.CONTEXT_MENU,f=>{i.EventHelper.stop(f,!0)})),S.actionRunner=this._actionRunner,S.setActionContext(this.context),S.render(L),this.focusable&&S instanceof k.BaseActionViewItem&&this.viewItems.length===0&&S.setFocusable(!0),h===null||h<0||h>=this.actionsList.children.length?(this.actionsList.appendChild(L),this.viewItems.push(S)):(this.actionsList.insertBefore(L,this.actionsList.children[h]),this.viewItems.splice(h,0,S),h++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const o=this.actionsList.children.item(s);if(o)return o.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const o=this.actionsList.children.item(s);if(o)return o.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.childNodes[s].remove(),this.viewItemDisposables.deleteAndDispose(this.viewItems[s]),(0,d.dispose)(this.viewItems.splice(s,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,d.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),i.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let o=!1,c;if(s===void 0?o=!0:typeof s=="number"?c=s:typeof s=="boolean"&&(o=s),o&&typeof this.focusedItem>"u"){const h=this.viewItems.findIndex(v=>v.isEnabled());this.focusedItem=h===-1?void 0:h,this.updateFocus(void 0,void 0,!0)}else c!==void 0&&(this.focusedItem=c),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const o=this.focusedItem;let c;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=o,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,c=this.viewItems[this.focusedItem]}while(this.focusedItem!==o&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===N.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const o=this.focusedItem;let c;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=o,!1;this.focusedItem=this.viewItems.length-1}c=this.viewItems[this.focusedItem]}while(this.focusedItem!==o&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===N.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,o,c=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:o}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const h=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(h){let v=!0;b.isFunction(h.focus)||(v=!1),this.options.focusOnlyEnabledItems&&b.isFunction(h.isEnabled)&&!h.isEnabled()&&(v=!1),h.action.id===N.Separator.ID&&(v=!1),v?(c||this.previouslyFocusedItem!==this.focusedItem)&&(h.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:o}),this.previouslyFocusedItem=void 0),v&&h.showHover?.()}}doTrigger(s){if(typeof this.focusedItem>"u")return;const o=this.viewItems[this.focusedItem];if(o instanceof k.BaseActionViewItem){const c=o._context===null||o._context===void 0?s:o._context;this.run(o._action,c)}}async run(s,o){await this._actionRunner.run(s,o)}dispose(){this._context=void 0,this.viewItems=(0,d.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=p;function m(e){if(!e.length)return e;let s=-1;for(let c=0;c<e.length;c++)if(e[c].id!==N.Separator.ID){s=c;break}if(s===-1)return[];e=e.slice(s);for(let c=e.length-1;c>=0&&e[c].id===N.Separator.ID;c--)e.splice(c,1);let o=!1;for(let c=e.length-1;c>=0;c--){const h=e[c].id===N.Separator.ID;h&&!o?e.splice(c,1):h?h&&(o=!1):o=!0}return e}}),define(De[82],we([1,0,4,29,72,81,74,75,34,15,78,24,3,95,64,20,127,116]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0,i=Ue(i),N=Ue(N),o=Ue(o);const c=i.$;var h;(function(S){S[S.INFO=1]="INFO",S[S.WARNING=2]="WARNING",S[S.ERROR=3]="ERROR"})(h||(t.MessageType=h={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class v extends y.Widget{constructor(r,f,E){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new p.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=f,this.options=E,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=i.append(r,c(".monaco-inputbox.idle"));const T=this.options.flexibleHeight?"textarea":"input",H=i.append(this.element,c(".ibwrapper"));if(this.input=i.append(H,c(T+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=i.append(H,c("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new b.ScrollableElement(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),i.append(r,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(D=>this.input.scrollTop=D.scrollTop));const W=this._register(new n.DomEmitter(r.ownerDocument,"selectionchange")),U=p.Event.filter(W.event,()=>r.ownerDocument.getSelection()?.anchorNode===H);this._register(U(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new R.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(r){this.placeholder=r,this.input.setAttribute("placeholder",r)}setTooltip(r){this.tooltip=r,this.hover?this.hover.update(r):this.hover=this._register((0,_.getBaseLayerHoverDelegate)().setupManagedHover((0,d.getDefaultHoverDelegate)("mouse"),this.input,r))}setAriaLabel(r){this.ariaLabel=r,r?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(r){this.input.value!==r&&(this.input.value=r,this.onValueChange())}get step(){return this.input.step}set step(r){this.input.step=r}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:i.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return i.isActiveElement(this.input)}select(r=null){this.input.select(),r&&(this.input.setSelectionRange(r.start,r.end),r.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const r=this.input.selectionStart;if(r===null)return null;const f=this.input.selectionEnd??r;return{start:r,end:f}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(r){r?this.enable():this.disable()}get width(){return i.getTotalWidth(this.input)}set width(r){if(this.options.flexibleHeight&&this.options.flexibleWidth){let f=0;if(this.mirror){const E=parseFloat(this.mirror.style.paddingLeft||"")||0,T=parseFloat(this.mirror.style.paddingRight||"")||0;f=E+T}this.input.style.width=r-f+"px"}else this.input.style.width=r+"px";this.mirror&&(this.mirror.style.width=r+"px")}set paddingRight(r){this.input.style.width=`calc(100% - ${r}px)`,this.mirror&&(this.mirror.style.paddingRight=r+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const r=this.cachedContentHeight,f=this.cachedHeight,E=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:r,height:f}),this.scrollableElement.setScrollPosition({scrollTop:E})}showMessage(r,f){if(this.state==="open"&&(0,e.equals)(this.message,r))return;this.message=r,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(r.type));const E=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${i.asCssValueWithDefault(E.border,"transparent")}`,this.message.content&&(this.hasFocus()||f)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let r=null;return this.validation&&(r=this.validation(this.value),r?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(r)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),r?.type}stylesForType(r){const f=this.options.inputBoxStyles;switch(r){case h.INFO:return{border:f.inputValidationInfoBorder,background:f.inputValidationInfoBackground,foreground:f.inputValidationInfoForeground};case h.WARNING:return{border:f.inputValidationWarningBorder,background:f.inputValidationWarningBackground,foreground:f.inputValidationWarningForeground};default:return{border:f.inputValidationErrorBorder,background:f.inputValidationErrorBackground,foreground:f.inputValidationErrorForeground}}}classForType(r){switch(r){case h.INFO:return"info";case h.WARNING:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let r;const f=()=>r.style.width=i.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:w.AnchorAlignment.RIGHT,render:T=>{if(!this.message)return null;r=i.append(T,c(".monaco-inputbox-container")),f();const H={inline:!0,className:"monaco-inputbox-message"},W=this.message.formatContent?(0,k.renderFormattedText)(this.message.content,H):(0,k.renderText)(this.message.content,H);W.classList.add(this.classForType(this.message.type));const U=this.stylesForType(this.message.type);return W.style.backgroundColor=U.background??"",W.style.color=U.foreground??"",W.style.border=U.border?`1px solid ${U.border}`:"",i.append(r,W),null},onHide:()=>{this.state="closed"},layout:f});let E;this.message.type===h.ERROR?E=o.localize(0,null,this.message.content):this.message.type===h.WARNING?E=o.localize(1,null,this.message.content):E=o.localize(2,null,this.message.content),N.alert(E),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const r=this.value,E=r.charCodeAt(r.length-1)===10?" ":"";(r+E).replace(/\u000c/g,"")?this.mirror.textContent=r+E:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const r=this.options.inputBoxStyles,f=r.inputBackground??"",E=r.inputForeground??"",T=r.inputBorder??"";this.element.style.backgroundColor=f,this.element.style.color=E,this.input.style.backgroundColor="inherit",this.input.style.color=E,this.element.style.border=`1px solid ${i.asCssValueWithDefault(T,"transparent")}`}layout(){if(!this.mirror)return;const r=this.cachedContentHeight;this.cachedContentHeight=i.getTotalHeight(this.mirror),r!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(r){const f=this.inputElement,E=f.selectionStart,T=f.selectionEnd,H=f.value;E!==null&&T!==null&&(this.value=H.substr(0,E)+r+H.substr(T),f.setSelectionRange(E+1,E+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=v;class L extends v{constructor(r,f,E){const T=o.localize(3,null,"\u21C5"),H=o.localize(4,null,"\u21C5");super(r,f,E),this._onDidFocus=this._register(new p.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new p.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new m.HistoryNavigator(E.history,100);const W=()=>{if(E.showHistoryHint&&E.showHistoryHint()&&!this.placeholder.endsWith(T)&&!this.placeholder.endsWith(H)&&this.history.getHistory().length){const U=this.placeholder.endsWith(")")?T:H,D=this.placeholder+U;E.showPlaceholderOnFocus&&!i.isActiveElement(this.input)?this.placeholder=D:this.setPlaceHolder(D)}};this.observer=new MutationObserver((U,D)=>{U.forEach(x=>{x.target.textContent||W()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>W()),this.onblur(this.input,()=>{const U=D=>{if(this.placeholder.endsWith(D)){const x=this.placeholder.slice(0,this.placeholder.length-D.length);return E.showPlaceholderOnFocus?this.placeholder=x:this.setPlaceHolder(x),!0}else return!1};U(H)||U(T)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(r){this.value&&(r||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(r){const f=this.getHistory();this.clearHistory(),r.forEach(E=>{this.history.add(E)}),f.forEach(E=>{this.history.add(E)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let r=this.getNextValue();r&&(r=r===this.value?this.getNextValue():r),this.value=r??"",N.status(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let r=this.getPreviousValue();r&&(r=r===this.value?this.getPreviousValue():r),r&&(this.value=r,N.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(r){super.setPlaceHolder(r),this.setTooltip(r)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let r=this.history.current();return r||(r=this.history.last(),this.history.next()),r}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=L}),define(De[83],we([1,0,80,24,21,22,3,8,4,15,34,121]),function(ne,t,i,n,k,R,N,w,_,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends i.BaseActionViewItem{constructor(o,c,h){super(o,c,h),this.toggle=this._register(new p({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(o){this.element=o,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.ToggleActionViewItem=y;class p extends n.Widget{constructor(o){super(),this._onChange=this._register(new N.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new N.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=o,this._checked=this._opts.isChecked;const c=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,c.push(...R.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&c.push(...this._opts.actionClassName.split(" ")),this._checked&&c.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,b.getBaseLayerHoverDelegate)().setupManagedHover(o.hoverDelegate??(0,d.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...c),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,h=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),h.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,h=>{if(h.keyCode===w.KeyCode.Space||h.keyCode===w.KeyCode.Enter){this.checked=!this._checked,this._onChange.fire(!0),h.preventDefault(),h.stopPropagation();return}this._onKeyDown.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(o){this._checked=o,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(o){this._icon&&this.domNode.classList.remove(...R.ThemeIcon.asClassNameArray(this._icon)),this._icon=o,this._icon&&this.domNode.classList.add(...R.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this._hover.update(o),this.domNode.setAttribute("aria-label",o)}set visible(o){this.domNode.style.display=o?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.Toggle=p;class m extends n.Widget{static{this.CLASS_NAME="monaco-checkbox"}constructor(o,c,h){super(),this.title=o,this.isChecked=c,this._onChange=this._register(new N.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new p({title:this.title,isChecked:this.isChecked,icon:k.Codicon.check,actionClassName:m.CLASS_NAME,...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=h,this.applyStyles(),this._register(this.checkbox.onChange(v=>{this.applyStyles(),this._onChange.fire(v)}))}get checked(){return this.checkbox.checked}set checked(o){this.checkbox.checked=o,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,_.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=m;class e extends i.BaseActionViewItem{constructor(o,c,h){super(o,c,h),this.toggle=this._register(new m(this._action.label,!!this._action.checked,h.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(o){if(this.element=o,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const c=this.element.appendChild((0,_.$)("span.checkbox-label",void 0,this._action.label));this._register((0,_.addDisposableListener)(c,_.EventType.CLICK,h=>{this.toggle.checked=!this.toggle.checked,h.stopPropagation(),h.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.CheckboxActionViewItem=e}),define(De[148],we([1,0,15,83,21,126]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0,R=Ue(R);const N=R.localize(0,null),w=R.localize(1,null),_=R.localize(2,null);class d extends n.Toggle{constructor(m){super({icon:k.Codicon.caseSensitive,title:N+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class b extends n.Toggle{constructor(m){super({icon:k.Codicon.wholeWord,title:w+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.WholeWordsToggle=b;class y extends n.Toggle{constructor(m){super({icon:k.Codicon.regex,title:_+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.RegexToggle=y}),define(De[149],we([1,0,4,148,82,24,3,8,125,2,15,115]),function(ne,t,i,n,k,R,N,w,_,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0,i=Ue(i),_=Ue(_);const y=_.localize(0,null);class p extends R.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,o){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new d.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new N.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new N.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new N.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new N.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new N.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new N.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new N.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=o.placeholder||"",this.validation=o.validation,this.label=o.label||y,this.showCommonFindToggles=!!o.showCommonFindToggles;const c=o.appendCaseSensitiveLabel||"",h=o.appendWholeWordsLabel||"",v=o.appendRegexLabel||"",L=o.history||[],S=!!o.flexibleHeight,r=!!o.flexibleWidth,f=o.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new k.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:L,showHistoryHint:o.showHistoryHint,flexibleHeight:S,flexibleWidth:r,flexibleMaxHeight:f,inputBoxStyles:o.inputBoxStyles}));const E=this._register((0,b.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new n.RegexToggle({appendTitle:v,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.regex.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(H=>{this._onRegexKeyDown.fire(H)})),this.wholeWords=this._register(new n.WholeWordsToggle({appendTitle:h,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.wholeWords.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new n.CaseSensitiveToggle({appendTitle:c,isChecked:!1,hoverDelegate:E,...o.toggleStyles})),this._register(this.caseSensitive.onChange(H=>{this._onDidOptionChange.fire(H),!H&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(H=>{this._onCaseSensitiveKeyDown.fire(H)}));const T=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,H=>{if(H.equals(w.KeyCode.LeftArrow)||H.equals(w.KeyCode.RightArrow)||H.equals(w.KeyCode.Escape)){const W=T.indexOf(this.domNode.ownerDocument.activeElement);if(W>=0){let U=-1;H.equals(w.KeyCode.RightArrow)?U=(W+1)%T.length:H.equals(w.KeyCode.LeftArrow)&&(W===0?U=T.length-1:U=W-1),H.equals(w.KeyCode.Escape)?(T[W].blur(),this.inputBox.focus()):U>=0&&T[U].focus(),i.EventHelper.stop(H,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(o?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),e?.appendChild(this.domNode),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionstart",T=>{this.imeSessionInProgress=!0})),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionend",T=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,T=>this._onKeyDown.fire(T)),this.onkeyup(this.inputBox.inputElement,T=>this._onKeyUp.fire(T)),this.oninput(this.inputBox.inputElement,T=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,T=>this._onMouseDown.fire(T))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.updateInputBoxPadding(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const e of this.additionalToggles)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const e of this.additionalToggles)e.disable()}setFocusInputOnOptionClick(e){this.fixFocusOnOptionClickEnabled=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new d.DisposableStore;for(const s of e??[])this.additionalTogglesDisposables.value.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.value.add(s.onChange(o=>{this._onDidOptionChange.fire(o),!o&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((s,o)=>s+o.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(e){this.caseSensitive&&(this.caseSensitive.checked=e)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(e){this.wholeWords&&(this.wholeWords.checked=e)}getRegex(){return this.regex?.checked??!1}setRegex(e){this.regex&&(this.regex.checked=e,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=p}),define(De[150],we([1,0,4,29,16,81,149,82,79,54,83,76,35,51,9,12,21,22,44,3,50,8,2,38,10,129,15,62,122]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o,c,h,v,L,S,r,f,E,T,H,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class U extends _.ElementsDragAndDropData{set context(u){this.data.context=u}get context(){return this.data.context}constructor(u){super(u.elements.map(I=>I.element)),this.data=u}}function D(F){return F instanceof _.ElementsDragAndDropData?new U(F):F}class x{constructor(u,I){this.modelProvider=u,this.dnd=I,this.autoExpandDisposable=r.Disposable.None,this.disposables=new r.DisposableStore}getDragURI(u){return this.dnd.getDragURI(u.element)}getDragLabel(u,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(u.map(A=>A.element),I)}onDragStart(u,I){this.dnd.onDragStart?.(D(u),I)}onDragOver(u,I,A,M,V,Y=!0){const ie=this.dnd.onDragOver(D(u),I&&I.element,A,M,V),ae=this.autoExpandNode!==I;if(ae&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=I),typeof I>"u")return ie;if(ae&&typeof ie!="boolean"&&ie.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Ie=this.modelProvider(),de=Ie.getNodeLocation(I);Ie.isCollapsed(de)&&Ie.setCollapsed(de,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!Y){const Ie=typeof ie=="boolean"?ie:ie.accept,de=typeof ie=="boolean"?void 0:ie.effect;return{accept:Ie,effect:de,feedback:[A]}}return ie}if(ie.bubble===p.TreeDragOverBubble.Up){const Ie=this.modelProvider(),de=Ie.getNodeLocation(I),Ce=Ie.getParentNodeLocation(de),qe=Ie.getNode(Ce),Xe=Ce&&Ie.getListIndex(Ce);return this.onDragOver(u,qe,Xe,M,V,!1)}const fe=this.modelProvider(),_e=fe.getNodeLocation(I),Ee=fe.getListIndex(_e),Le=fe.getListRenderCount(_e);return{...ie,feedback:(0,e.range)(Ee,Ee+Le)}}drop(u,I,A,M,V){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(D(u),I&&I.element,A,M,V)}onDragEnd(u){this.dnd.onDragEnd?.(u)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function z(F,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(I){return u.identityProvider.getId(I.element)}},dnd:u.dnd&&new x(F,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(I){return u.multipleSelectionController.isSelectionSingleChangeEvent({...I,element:I.element})},isSelectionRangeChangeEvent(I){return u.multipleSelectionController.isSelectionRangeChangeEvent({...I,element:I.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(I){const A=F(),M=A.getNodeLocation(I),V=A.getParentNodeLocation(M);return A.getNode(V).visibleChildrenCount},getPosInSet(I){return I.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?I=>u.accessibilityProvider.isChecked(I.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?I=>u.accessibilityProvider.getRole(I.element):()=>"treeitem",getAriaLabel(I){return u.accessibilityProvider.getAriaLabel(I.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?I=>u.accessibilityProvider.getAriaLevel(I.element):I=>I.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(I=>u.accessibilityProvider.getActiveDescendantId(I.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(I){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(I.element)}}}}class O{constructor(u){this.delegate=u}getHeight(u){return this.delegate.getHeight(u.element)}getTemplateId(u){return this.delegate.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(u.element)}setDynamicHeight(u,I){this.delegate.setDynamicHeight?.(u.element,I)}}t.ComposedTreeDelegate=O;class P{static lift(u){return u instanceof P?u:new P(u)}static empty(u=0){return new P({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const I of u.expanded)this.expanded[I]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=P;var K;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(K||(t.RenderIndentGuides=K={}));class Q{get elements(){return this._elements}constructor(u,I=[]){this._elements=I,this.disposables=new r.DisposableStore,this.onDidChange=v.Event.forEach(u,A=>this._elements=A,this.disposables)}dispose(){this.disposables.dispose()}}class X{static{this.DefaultIndent=8}constructor(u,I,A,M,V,Y={}){this.renderer=u,this.modelProvider=I,this.activeNodes=M,this.renderedIndentGuides=V,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=X.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=r.Disposable.None,this.disposables=new r.DisposableStore,this.templateId=u.templateId,this.updateOptions(Y),v.Event.map(A,ie=>ie.node)(this.onDidChangeNodeTwistieState,this,this.disposables),u.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(u={}){if(typeof u.indent<"u"){const I=(0,f.clamp)(u.indent,0,40);if(I!==this.indent){this.indent=I;for(const[A,M]of this.renderedNodes)this.renderTreeElement(A,M)}}if(typeof u.renderIndentGuides<"u"){const I=u.renderIndentGuides!==K.None;if(I!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=I;for(const[A,M]of this.renderedNodes)this._renderIndentGuides(A,M);if(this.indentGuidesDisposable.dispose(),I){const A=new r.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,A),this.indentGuidesDisposable=A,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const I=(0,i.append)(u,(0,i.$)(".monaco-tl-row")),A=(0,i.append)(I,(0,i.$)(".monaco-tl-indent")),M=(0,i.append)(I,(0,i.$)(".monaco-tl-twistie")),V=(0,i.append)(I,(0,i.$)(".monaco-tl-contents")),Y=this.renderer.renderTemplate(V);return{container:u,indent:A,twistie:M,indentGuidesDisposable:r.Disposable.None,templateData:Y}}renderElement(u,I,A,M){this.renderedNodes.set(u,A),this.renderedElements.set(u.element,u),this.renderTreeElement(u,A),this.renderer.renderElement(u,I,A.templateData,M)}disposeElement(u,I,A,M){A.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(u,I,A.templateData,M),typeof M=="number"&&(this.renderedNodes.delete(u),this.renderedElements.delete(u.element))}disposeTemplate(u){this.renderer.disposeTemplate(u.templateData)}onDidChangeTwistieState(u){const I=this.renderedElements.get(u);I&&this.onDidChangeNodeTwistieState(I)}onDidChangeNodeTwistieState(u){const I=this.renderedNodes.get(u);I&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(u,I))}renderTreeElement(u,I){const A=X.DefaultIndent+(u.depth-1)*this.indent;I.twistie.style.paddingLeft=`${A}px`,I.indent.style.width=`${A+this.indent-16}px`,u.collapsible?I.container.setAttribute("aria-expanded",String(!u.collapsed)):I.container.removeAttribute("aria-expanded"),I.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded));let M=!1;this.renderer.renderTwistie&&(M=this.renderer.renderTwistie(u.element,I.twistie)),u.collapsible&&(!this.hideTwistiesOfChildlessElements||u.visibleChildrenCount>0)?(M||I.twistie.classList.add(...c.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded)),I.twistie.classList.add("collapsible"),I.twistie.classList.toggle("collapsed",u.collapsed)):I.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(u,I)}_renderIndentGuides(u,I){if((0,i.clearNode)(I.indent),I.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const A=new r.DisposableStore,M=this.modelProvider();for(;;){const V=M.getNodeLocation(u),Y=M.getParentNodeLocation(V);if(!Y)break;const ie=M.getNode(Y),ae=(0,i.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(ie)&&ae.classList.add("active"),I.indent.childElementCount===0?I.indent.appendChild(ae):I.indent.insertBefore(ae,I.indent.firstElementChild),this.renderedIndentGuides.add(ie,ae),A.add((0,r.toDisposable)(()=>this.renderedIndentGuides.delete(ie,ae))),u=ie}I.indentGuidesDisposable=A}_onDidChangeActiveNodes(u){if(!this.shouldRenderIndentGuides)return;const I=new Set,A=this.modelProvider();u.forEach(M=>{const V=A.getNodeLocation(M);try{const Y=A.getParentNodeLocation(V);M.collapsible&&M.children.length>0&&!M.collapsed?I.add(M):Y&&I.add(A.getNode(Y))}catch{}}),this.activeIndentNodes.forEach(M=>{I.has(M)||this.renderedIndentGuides.forEach(M,V=>V.classList.remove("active"))}),I.forEach(M=>{this.activeIndentNodes.has(M)||this.renderedIndentGuides.forEach(M,V=>V.classList.add("active"))}),this.activeIndentNodes=I}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,r.dispose)(this.disposables)}}t.TreeRenderer=X;class G{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(u){this._pattern=u,this._lowercasePattern=u.toLowerCase()}constructor(u,I,A){this.tree=u,this.keyboardNavigationLabelProvider=I,this._filter=A,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new r.DisposableStore,u.onWillRefilter(this.reset,this,this.disposables)}filter(u,I){let A=p.TreeVisibility.Visible;if(this._filter){const Y=this._filter.filter(u,I);if(typeof Y=="boolean"?A=Y?p.TreeVisibility.Visible:p.TreeVisibility.Hidden:(0,y.isFilterResult)(Y)?A=(0,y.getVisibleState)(Y.visibility):A=Y,A===p.TreeVisibility.Hidden)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:L.FuzzyScore.Default,visibility:A};const M=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(u),V=Array.isArray(M)?M:[M];for(const Y of V){const ie=Y&&Y.toString();if(typeof ie>"u")return{data:L.FuzzyScore.Default,visibility:A};let ae;if(this.tree.findMatchType===Fe.Contiguous){const fe=ie.toLowerCase().indexOf(this._lowercasePattern);if(fe>-1){ae=[Number.MAX_SAFE_INTEGER,0];for(let _e=this._lowercasePattern.length;_e>0;_e--)ae.push(fe+_e-1)}}else ae=(0,L.fuzzyScore)(this._pattern,this._lowercasePattern,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ae)return this._matchCount++,V.length===1?{data:ae,visibility:A}:{data:{label:ie,score:ae},visibility:A}}return this.tree.findMode===Te.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(u):p.TreeVisibility.Recurse:{data:L.FuzzyScore.Default,visibility:A}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,r.dispose)(this.disposables)}}class J extends b.Toggle{constructor(u){super({icon:o.Codicon.listFilter,title:(0,T.localize)(0,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.ModeToggle=J;class ce extends b.Toggle{constructor(u){super({icon:o.Codicon.searchFuzzy,title:(0,T.localize)(1,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.FuzzyToggle=ce;const pe={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:b.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Te;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Te||(t.TreeFindMode=Te={}));var Fe;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class re extends r.Disposable{set mode(u){this.modeToggle.checked=u===Te.Filter,this.findInput.inputBox.setPlaceHolder(u===Te.Filter?(0,T.localize)(2,null):(0,T.localize)(3,null))}set matchType(u){this.matchTypeToggle.checked=u===Fe.Fuzzy}get value(){return this.findInput.inputBox.value}set value(u){this.findInput.inputBox.value=u}constructor(u,I,A,M,V,Y){super(),this.tree=I,this.elements=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new v.Emitter,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.elements.root),this._register((0,r.toDisposable)(()=>this.elements.root.remove()));const ie=Y?.styles??pe;ie.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const ae=this._register((0,H.createInstantHoverDelegate)());this.modeToggle=this._register(new J({...ie.toggleStyles,isChecked:M===Te.Filter,hoverDelegate:ae})),this.matchTypeToggle=this._register(new ce({...ie.toggleStyles,isChecked:V===Fe.Fuzzy,hoverDelegate:ae})),this.onDidChangeMode=v.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?Te.Filter:Te.Highlight,this._store),this.onDidChangeMatchType=v.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Fe.Fuzzy:Fe.Contiguous,this._store),this.findInput=this._register(new N.FindInput(this.elements.findInput,A,{label:(0,T.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:Y?.history})),this.actionbar=this._register(new R.ActionBar(this.elements.actionbar)),this.mode=M;const fe=this._register(new n.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),_e=v.Event.chain(fe.event,de=>de.map(Ce=>new k.StandardKeyboardEvent(Ce)));this._register(_e(de=>{if(de.equals(S.KeyCode.Enter)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(de.equals(S.KeyCode.DownArrow)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(de.equals(S.KeyCode.UpArrow)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const Ee=this._register(new m.Action("close",(0,T.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(Ee,{icon:!0,label:!1});const Le=this._register(new n.DomEmitter(this.elements.grab,"mousedown"));this._register(Le.event(de=>{const Ce=new r.DisposableStore,qe=Ce.add(new n.DomEmitter((0,i.getWindow)(de),"mousemove")),Xe=Ce.add(new n.DomEmitter((0,i.getWindow)(de),"mouseup")),tt=this.right,lt=de.pageX,rt=this.top,je=de.pageY;this.elements.grab.classList.add("grabbing");const Ze=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Z=ue=>{const ve=ue.pageX-lt;this.right=tt-ve;const Ae=ue.pageY-je;this.top=rt+Ae,this.layout()};Ce.add(qe.event(Z)),Ce.add(Xe.event(ue=>{Z(ue),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Ze,Ce.dispose()}))}));const Ie=v.Event.chain(this._register(new n.DomEmitter(this.elements.grab,"keydown")).event,de=>de.map(Ce=>new k.StandardKeyboardEvent(Ce)));this._register(Ie(de=>{let Ce,qe;if(de.keyCode===S.KeyCode.LeftArrow?Ce=Number.POSITIVE_INFINITY:de.keyCode===S.KeyCode.RightArrow?Ce=0:de.keyCode===S.KeyCode.Space&&(Ce=this.right===0?Number.POSITIVE_INFINITY:0),de.keyCode===S.KeyCode.UpArrow?qe=0:de.keyCode===S.KeyCode.DownArrow&&(qe=Number.POSITIVE_INFINITY),Ce!==void 0&&(de.preventDefault(),de.stopPropagation(),this.right=Ce,this.layout()),qe!==void 0){de.preventDefault(),de.stopPropagation(),this.top=qe;const Xe=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(u=this.width){this.width=u,this.right=(0,f.clamp)(this.right,0,Math.max(0,u-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(u){this.findInput.showMessage(u)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class ee{get pattern(){return this._pattern}get mode(){return this._mode}set mode(u){u!==this._mode&&(this._mode=u,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(u))}get matchType(){return this._matchType}set matchType(u){u!==this._matchType&&(this._matchType=u,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(u))}constructor(u,I,A,M,V,Y={}){this.tree=u,this.view=A,this.filter=M,this.contextViewProvider=V,this.options=Y,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new v.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new v.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new v.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new v.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new r.DisposableStore,this.disposables=new r.DisposableStore,this._mode=u.options.defaultFindMode??Te.Highlight,this._matchType=u.options.defaultFindMatchType??Fe.Fuzzy,I.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new re(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(u=>this.mode=u,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(u=>this.matchType=u,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(u){this._pattern=u,this._onDidChangePattern.fire(u),this.filter.pattern=u,this.tree.refilter(),u&&this.tree.focusNext(0,!0,void 0,A=>!L.FuzzyScore.isDefault(A.filterData));const I=this.tree.getFocus();if(I.length>0){const A=I[0];this.tree.getRelativeTop(A)===null&&this.tree.reveal(A,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const u=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&u?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:w.MessageType.WARNING,content:(0,T.localize)(6,null)}):this.widget?.showMessage({type:w.MessageType.WARNING}):this.widget?.clearMessage()}shouldAllowFocus(u){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!L.FuzzyScore.isDefault(u.filterData)}layout(u){this.width=u,this.widget?.layout(u)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function he(F,u){return F.position===u.position&&le(F,u)}function le(F,u){return F.node.element===u.node.element&&F.startIndex===u.startIndex&&F.height===u.height&&F.endIndex===u.endIndex}class Ne{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.equals)(this.stickyNodes,u.stickyNodes,he)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const I=this.stickyNodes[this.count-2];return I.position+I.height!==u.position}animationStateChanged(u){if(!(0,e.equals)(this.stickyNodes,u.stickyNodes,le)||this.count===0)return!1;const I=this.stickyNodes[this.count-1],A=u.stickyNodes[u.count-1];return I.position!==A.position}}class te{constrainStickyScrollNodes(u,I,A){for(let M=0;M<u.length;M++){const V=u[M];if(V.position+V.height>A||M>=I)return u.slice(0,M)}return u}}class be extends r.Disposable{constructor(u,I,A,M,V,Y={}){super(),this.tree=u,this.model=I,this.view=A,this.treeDelegate=V,this.maxWidgetViewRatio=.4;const ie=this.validateStickySettings(Y);this.stickyScrollMaxItemCount=ie.stickyScrollMaxItemCount,this.stickyScrollDelegate=Y.stickyScrollDelegate??new te,this._widget=this._register(new Se(A.getScrollableElement(),A,u,M,V,Y.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(A.onDidScroll(()=>this.update())),this._register(A.onDidChangeContentHeight(()=>this.update())),this._register(u.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(u){return this._widget.getNode(u)}getNodeAtHeight(u){let I;if(u===0?I=this.view.firstVisibleIndex:I=this.view.indexAt(u+this.view.scrollTop),!(I<0||I>=this.view.length))return this.view.element(I)}update(){const u=this.getNodeAtHeight(0);if(!u||this.tree.scrollTop===0){this._widget.setState(void 0);return}const I=this.findStickyState(u);this._widget.setState(I)}findStickyState(u){const I=[];let A=u,M=0,V=this.getNextStickyNode(A,void 0,M);for(;V&&(I.push(V),M+=V.height,!(I.length<=this.stickyScrollMaxItemCount&&(A=this.getNextVisibleNode(V),!A)));)V=this.getNextStickyNode(A,V.node,M);const Y=this.constrainStickyNodes(I);return Y.length?new Ne(Y):void 0}getNextVisibleNode(u){return this.getNodeAtHeight(u.position+u.height)}getNextStickyNode(u,I,A){const M=this.getAncestorUnderPrevious(u,I);if(M&&!(M===u&&(!this.nodeIsUncollapsedParent(u)||this.nodeTopAlignsWithStickyNodesBottom(u,A))))return this.createStickyScrollNode(M,A)}nodeTopAlignsWithStickyNodesBottom(u,I){const A=this.getNodeIndex(u),M=this.view.getElementTop(A),V=I;return this.view.scrollTop===M-V}createStickyScrollNode(u,I){const A=this.treeDelegate.getHeight(u),{startIndex:M,endIndex:V}=this.getNodeRange(u),Y=this.calculateStickyNodePosition(V,I,A);return{node:u,position:Y,height:A,startIndex:M,endIndex:V}}getAncestorUnderPrevious(u,I=void 0){let A=u,M=this.getParentNode(A);for(;M;){if(M===I)return A;A=M,M=this.getParentNode(A)}if(I===void 0)return A}calculateStickyNodePosition(u,I,A){let M=this.view.getRelativeTop(u);if(M===null&&this.view.firstVisibleIndex===u&&u+1<this.view.length){const fe=this.treeDelegate.getHeight(this.view.element(u)),_e=this.view.getRelativeTop(u+1);M=_e?_e-fe/this.view.renderHeight:null}if(M===null)return I;const V=this.view.element(u),Y=this.treeDelegate.getHeight(V),ae=M*this.view.renderHeight+Y;return I+A>ae&&I<=ae?ae-A:I}constrainStickyNodes(u){if(u.length===0)return[];const I=this.view.renderHeight*this.maxWidgetViewRatio,A=u[u.length-1];if(u.length<=this.stickyScrollMaxItemCount&&A.position+A.height<=I)return u;const M=this.stickyScrollDelegate.constrainStickyScrollNodes(u,this.stickyScrollMaxItemCount,I);if(!M.length)return[];const V=M[M.length-1];if(M.length>this.stickyScrollMaxItemCount||V.position+V.height>I)throw new Error("stickyScrollDelegate violates constraints");return M}getParentNode(u){const I=this.model.getNodeLocation(u),A=this.model.getParentNodeLocation(I);return A?this.model.getNode(A):void 0}nodeIsUncollapsedParent(u){const I=this.model.getNodeLocation(u);return this.model.getListRenderCount(I)>1}getNodeIndex(u){const I=this.model.getNodeLocation(u);return this.model.getListIndex(I)}getNodeRange(u){const I=this.model.getNodeLocation(u),A=this.model.getListIndex(I);if(A<0)throw new Error("Node not found in tree");const M=this.model.getListRenderCount(I),V=A+M-1;return{startIndex:A,endIndex:V}}nodePositionTopBelowWidget(u){const I=[];let A=this.getParentNode(u);for(;A;)I.push(A),A=this.getParentNode(A);let M=0;for(let V=0;V<I.length&&V<this.stickyScrollMaxItemCount;V++)M+=this.treeDelegate.getHeight(I[V]);return M}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const I=this.validateStickySettings(u);this.stickyScrollMaxItemCount!==I.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=I.stickyScrollMaxItemCount,this.update())}validateStickySettings(u){let I=7;return typeof u.stickyScrollMaxItemCount=="number"&&(I=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:I}}}class Se{constructor(u,I,A,M,V,Y){this.view=I,this.tree=A,this.treeRenderers=M,this.treeDelegate=V,this.accessibilityProvider=Y,this._previousElements=[],this._previousStateDisposables=new r.DisposableStore,this._rootDomNode=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this._rootDomNode);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(ie),this.stickyScrollFocus=new Oe(this._rootDomNode,I),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const u=this._previousState.stickyNodes[this._previousState.count-1];return u.position+u.height}get count(){return this._previousState?.count??0}getNode(u){return this._previousState?.stickyNodes.find(I=>I.node===u)}setState(u){const I=!!this._previousState&&this._previousState.count>0,A=!!u&&u.count>0;if(!I&&!A||I&&A&&this._previousState.equal(u))return;if(I!==A&&this.setVisible(A),!A){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const M=u.stickyNodes[u.count-1];if(this._previousState&&u.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${M.position}px`;else{this._previousStateDisposables.clear();const V=Array(u.count);for(let Y=u.count-1;Y>=0;Y--){const ie=u.stickyNodes[Y],{element:ae,disposable:fe}=this.createElement(ie,Y,u.count);V[Y]=ae,this._rootDomNode.appendChild(ae),this._previousStateDisposables.add(fe)}this.stickyScrollFocus.updateElements(V,u),this._previousElements=V}this._previousState=u,this._rootDomNode.style.height=`${M.position+M.height}px`}createElement(u,I,A){const M=u.startIndex,V=document.createElement("div");V.style.top=`${u.position}px`,this.tree.options.setRowHeight!==!1&&(V.style.height=`${u.height}px`),this.tree.options.setRowLineHeight!==!1&&(V.style.lineHeight=`${u.height}px`),V.classList.add("monaco-tree-sticky-row"),V.classList.add("monaco-list-row"),V.setAttribute("data-index",`${M}`),V.setAttribute("data-parity",M%2===0?"even":"odd"),V.setAttribute("id",this.view.getElementID(M));const Y=this.setAccessibilityAttributes(V,u.node.element,I,A),ie=this.treeDelegate.getTemplateId(u.node),ae=this.treeRenderers.find(Le=>Le.templateId===ie);if(!ae)throw new Error(`No renderer found for template id ${ie}`);let fe=u.node;fe===this.tree.getNode(this.tree.getNodeLocation(u.node))&&(fe=new Proxy(u.node,{}));const _e=ae.renderTemplate(V);ae.renderElement(fe,u.startIndex,_e,u.height);const Ee=(0,r.toDisposable)(()=>{Y.dispose(),ae.disposeElement(fe,u.startIndex,_e,u.height),ae.disposeTemplate(_e),V.remove()});return{element:V,disposable:Ee}}setAccessibilityAttributes(u,I,A,M){if(!this.accessibilityProvider)return r.Disposable.None;this.accessibilityProvider.getSetSize&&u.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(I,A,M))),this.accessibilityProvider.getPosInSet&&u.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(I,A))),this.accessibilityProvider.getRole&&u.setAttribute("role",this.accessibilityProvider.getRole(I)??"treeitem");const V=this.accessibilityProvider.getAriaLabel(I),Y=V&&typeof V!="string"?V:(0,W.constObservable)(V),ie=(0,W.autorun)(fe=>{const _e=fe.readObservable(Y);_e?u.setAttribute("aria-label",_e):u.removeAttribute("aria-label")});typeof V=="string"||V&&u.setAttribute("aria-label",V.get());const ae=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(I);return typeof ae=="number"&&u.setAttribute("aria-level",`${ae}`),u.setAttribute("aria-selected",String(!1)),ie}setVisible(u){this._rootDomNode.classList.toggle("empty",!u),u||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class Oe extends r.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(u){u!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(u),this._domHasFocus=u)}constructor(u,I){super(),this.container=u,this.view=I,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new v.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new v.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this.container.addEventListener("focus",()=>this.onFocus()),this.container.addEventListener("blur",()=>this.onBlur()),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(A=>this.onKeyDown(A))),this._register(this.view.onMouseDown(A=>this.onMouseDown(A))),this._register(this.view.onContextMenu(A=>this.handleContextMenu(A)))}handleContextMenu(u){const I=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(I)&&!(0,d.isStickyScrollElement)(I)){this.focusedLast()&&this.view.domFocus();return}if(!(0,i.isKeyboardEvent)(u.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.state.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(Y);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const M=this.state.stickyNodes[this.focusedIndex].node.element,V=this.elements[this.focusedIndex];this._onContextMenu.fire({element:M,anchor:V,browserEvent:u.browserEvent,isStickyScroll:!0})}onKeyDown(u){if(this.domHasFocus&&this.state){if(u.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const I=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([I]),this.scrollNodeUnderWidget(I,this.state)}else this.setFocusedElement(this.focusedIndex+1);u.preventDefault(),u.stopPropagation()}}}onMouseDown(u){const I=u.browserEvent.target;!(0,d.isStickyScrollContainer)(I)&&!(0,d.isStickyScrollElement)(I)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,I){if(I&&I.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(I&&I.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const A=this.focusedIndex;if(this.removeFocus(),this.elements=u,this.state=I,I){const M=(0,f.clamp)(A,0,I.count-1);this.setFocus(M)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=I?0:-1}setFocusedElement(u){const I=this.state;if(!I)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(u),!(u<I.count-1)&&I.lastNodePartiallyVisible()){const A=I.stickyNodes[u];this.scrollNodeUnderWidget(A.endIndex+1,I)}}scrollNodeUnderWidget(u,I){const A=I.stickyNodes[I.count-1],M=I.count>1?I.stickyNodes[I.count-2]:void 0,V=this.view.getElementTop(u),Y=M?M.position+M.height+A.height:A.height;this.view.scrollTop=V-Y}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.state&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&u>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const I=this.focusedIndex;I>=0&&this.toggleElementFocus(this.elements[I],!1),u>=0&&this.toggleElementFocus(this.elements[u],!0),this.focusedIndex=u}toggleElementFocus(u,I){this.toggleElementActiveFocus(u,I&&this.domHasFocus),this.toggleElementPassiveFocus(u,I)}toggleCurrentElementActiveFocus(u){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],u)}toggleElementActiveFocus(u,I){u.classList.toggle("focused",I)}toggleElementPassiveFocus(u,I){u.classList.toggle("passive-focused",I)}toggleStickyScrollFocused(u){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function Re(F){let u=p.TreeMouseEventTarget.Unknown;return(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=p.TreeMouseEventTarget.Twistie:(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=p.TreeMouseEventTarget.Element:(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=p.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:u}}function We(F){const u=(0,d.isStickyScrollContainer)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:u}}function oe(F,u){u(F),F.children.forEach(I=>oe(I,u))}class q{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(u,I){this.getFirstViewElementWithTrait=u,this.identityProvider=I,this.nodes=[],this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event}set(u,I){!I?.__forceEvent&&(0,e.equals)(this.nodes,u)||this._set(u,!1,I)}_set(u,I,A){if(this.nodes=[...u],this.elements=void 0,this._nodeSet=void 0,!I){const M=this;this._onDidChange.fire({get elements(){return M.get()},browserEvent:A})}}get(){return this.elements||(this.elements=this.nodes.map(u=>u.element)),[...this.elements]}getNodes(){return this.nodes}has(u){return this.nodeSet.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:I}){if(!this.identityProvider){const ae=this.createNodeSet(),fe=_e=>ae.delete(_e);I.forEach(_e=>oe(_e,fe)),this.set([...ae.values()]);return}const A=new Set,M=ae=>A.add(this.identityProvider.getId(ae.element).toString());I.forEach(ae=>oe(ae,M));const V=new Map,Y=ae=>V.set(this.identityProvider.getId(ae.element).toString(),ae);u.forEach(ae=>oe(ae,Y));const ie=[];for(const ae of this.nodes){const fe=this.identityProvider.getId(ae.element).toString();if(!A.has(fe))ie.push(ae);else{const Ee=V.get(fe);Ee&&Ee.visible&&ie.push(Ee)}}if(this.nodes.length>0&&ie.length===0){const ae=this.getFirstViewElementWithTrait();ae&&ie.push(ae)}this._set(ie,!0)}createNodeSet(){const u=new Set;for(const I of this.nodes)u.add(I);return u}}class B extends d.MouseController{constructor(u,I,A){super(u),this.tree=I,this.stickyScrollProvider=A}onViewPointer(u){if((0,d.isButton)(u.browserEvent.target)||(0,d.isInputElement)(u.browserEvent.target)||(0,d.isMonacoEditor)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const I=u.element;if(!I)return super.onViewPointer(u);if(this.isSelectionRangeChangeEvent(u)||this.isSelectionSingleChangeEvent(u))return super.onViewPointer(u);const A=u.browserEvent.target,M=A.classList.contains("monaco-tl-twistie")||A.classList.contains("monaco-icon-label")&&A.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,V=(0,d.isStickyScrollElement)(u.browserEvent.target);let Y=!1;if(V?Y=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?Y=this.tree.expandOnlyOnTwistieClick(I.element):Y=!!this.tree.expandOnlyOnTwistieClick,V)this.handleStickyScrollMouseEvent(u,I);else{if(Y&&!M&&u.browserEvent.detail!==2)return super.onViewPointer(u);if(!this.tree.expandOnDoubleClick&&u.browserEvent.detail===2)return super.onViewPointer(u)}if(I.collapsible&&(!V||M)){const ie=this.tree.getNodeLocation(I),ae=u.browserEvent.altKey;if(this.tree.setFocus([ie]),this.tree.toggleCollapsed(ie,ae),M){u.browserEvent.isHandledByList=!0;return}}V||super.onViewPointer(u)}handleStickyScrollMouseEvent(u,I){if((0,d.isMonacoCustomToggle)(u.browserEvent.target)||(0,d.isActionItem)(u.browserEvent.target))return;const A=this.stickyScrollProvider();if(!A)throw new Error("Sticky scroll controller not found");const M=this.list.indexOf(I),V=this.list.getElementTop(M),Y=A.nodePositionTopBelowWidget(I);this.tree.scrollTop=V-Y,this.list.domFocus(),this.list.setFocus([M]),this.list.setSelection([M])}onDoubleClick(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||u.browserEvent.isHandledByList||super.onDoubleClick(u)}onMouseDown(u){const I=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(I)&&!(0,d.isStickyScrollElement)(I)){super.onMouseDown(u);return}}onContextMenu(u){const I=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(I)&&!(0,d.isStickyScrollElement)(I)){super.onContextMenu(u);return}}}class l extends d.List{constructor(u,I,A,M,V,Y,ie,ae){super(u,I,A,M,ae),this.focusTrait=V,this.selectionTrait=Y,this.anchorTrait=ie}createMouseController(u){return new B(this,u.tree,u.stickyScrollProvider)}splice(u,I,A=[]){if(super.splice(u,I,A),A.length===0)return;const M=[],V=[];let Y;A.forEach((ie,ae)=>{this.focusTrait.has(ie)&&M.push(u+ae),this.selectionTrait.has(ie)&&V.push(u+ae),this.anchorTrait.has(ie)&&(Y=u+ae)}),M.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...M])),V.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...V])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(u,I,A=!1){super.setFocus(u,I),A||this.focusTrait.set(u.map(M=>this.element(M)),I)}setSelection(u,I,A=!1){super.setSelection(u,I),A||this.selectionTrait.set(u.map(M=>this.element(M)),I)}setAnchor(u,I=!1){super.setAnchor(u),I||(typeof u>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(u)]))}}var a;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(a||(t.AbstractTreePart=a={}));class g{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return v.Event.map(this.view.onMouseClick,Re)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.view.onMouseDblClick,Re),u=>u.target!==p.TreeMouseEventTarget.Filter)}get onMouseOver(){return v.Event.map(this.view.onMouseOver,Re)}get onMouseOut(){return v.Event.map(this.view.onMouseOut,Re)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.view.onContextMenu,We),u=>!u.isStickyScroll),this.stickyScrollController?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.view.onTap,Re)}get onPointer(){return v.Event.map(this.view.onPointer,Re)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??Te.Highlight}set findMode(u){this.findController&&(this.findController.mode=u)}get findMatchType(){return this.findController?.matchType??Fe.Fuzzy}set findMatchType(u){this.findController&&(this.findController.matchType=u)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(u,I,A,M,V={}){this._user=u,this._options=V,this.eventBufferer=new v.EventBufferer,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.disposables=new r.DisposableStore,this._onWillRefilter=new v.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new v.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new O(A);const Y=new v.Relay,ie=new v.Relay,ae=this.disposables.add(new Q(ie.event)),fe=new h.SetMap;this.renderers=M.map(de=>new X(de,()=>this.model,Y.event,ae,fe,V));for(const de of this.renderers)this.disposables.add(de);let _e;V.keyboardNavigationLabelProvider&&(_e=new G(this,V.keyboardNavigationLabelProvider,V.filter),V={...V,filter:_e},this.disposables.add(_e)),this.focus=new q(()=>this.view.getFocusedElements()[0],V.identityProvider),this.selection=new q(()=>this.view.getSelectedElements()[0],V.identityProvider),this.anchor=new q(()=>this.view.getAnchorElement(),V.identityProvider),this.view=new l(u,I,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...z(()=>this.model,V),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(u,this.view,V),Y.input=this.model.onDidChangeCollapseState;const Ee=v.Event.forEach(this.model.onDidSplice,de=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(de),this.selection.onDidModelSplice(de)})},this.disposables);Ee(()=>null,null,this.disposables);const Le=this.disposables.add(new v.Emitter),Ie=this.disposables.add(new s.Delayer(0));if(this.disposables.add(v.Event.any(Ee,this.focus.onDidChange,this.selection.onDidChange)(()=>{Ie.trigger(()=>{const de=new Set;for(const Ce of this.focus.getNodes())de.add(Ce);for(const Ce of this.selection.getNodes())de.add(Ce);Le.fire([...de.values()])})})),ie.input=Le.event,V.keyboardSupport!==!1){const de=v.Event.chain(this.view.onKeyDown,Ce=>Ce.filter(qe=>!(0,d.isInputElement)(qe.target)).map(qe=>new k.StandardKeyboardEvent(qe)));v.Event.chain(de,Ce=>Ce.filter(qe=>qe.keyCode===S.KeyCode.LeftArrow))(this.onLeftArrow,this,this.disposables),v.Event.chain(de,Ce=>Ce.filter(qe=>qe.keyCode===S.KeyCode.RightArrow))(this.onRightArrow,this,this.disposables),v.Event.chain(de,Ce=>Ce.filter(qe=>qe.keyCode===S.KeyCode.Space))(this.onSpace,this,this.disposables)}if((V.findWidgetEnabled??!0)&&V.keyboardNavigationLabelProvider&&V.contextViewProvider){const de=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new ee(this,this.model,this.view,_e,V.contextViewProvider,de),this.focusNavigationFilter=Ce=>this.findController.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;V.enableStickyScroll&&(this.stickyScrollController=new be(this,this.model,this.view,this.renderers,this.treeDelegate,V),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,i.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===K.Always)}updateOptions(u={}){this._options={...this._options,...u};for(const I of this.renderers)I.updateOptions(u);this.view.updateOptions(this._options),this.findController?.updateOptions(u),this.updateStickyScroll(u),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===K.Always)}get options(){return this._options}updateStickyScroll(u){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new be(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(u)}updateWidth(u){const I=this.model.getListIndex(u);I!==-1&&this.view.updateWidth(I)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(u){this.view.scrollTop=u}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(u){this.view.scrollLeft=u}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let u=this.view.firstVisibleIndex;return this.stickyScrollController&&(u+=this.stickyScrollController.count),u<0||u>=this.view.length?void 0:this.view.element(u).element}get lastVisibleElement(){const u=this.view.lastVisibleIndex;return this.view.element(u).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(u){this.view.ariaLabel=u}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,i.isActiveElement)(this.getHTMLElement())}layout(u,I){this.view.layout(u,I),(0,E.isNumber)(I)&&this.findController?.layout(I)}style(u){const I=`.${this.view.domId}`,A=[];u.treeIndentGuidesStroke&&(A.push(`.monaco-list${I}:hover .monaco-tl-indent > .indent-guide, .monaco-list${I}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),A.push(`.monaco-list${I} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const M=u.treeStickyScrollBackground??u.listBackground;M&&(A.push(`.monaco-list${I} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${M}; }`),A.push(`.monaco-list${I} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${M}; }`)),u.treeStickyScrollBorder&&A.push(`.monaco-list${I} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&A.push(`.monaco-list${I} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(A.push(`.monaco-list${I}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),A.push(`.monaco-list${I}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const V=(0,i.asCssValueWithDefault)(u.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(u.listSelectionOutline,u.listFocusOutline??""));V&&(A.push(`.monaco-list${I}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${V}; outline-offset: -1px;}`),A.push(`.monaco-list${I}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(A.push(`.monaco-list${I}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),A.push(`.monaco-list${I}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),A.push(`.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=A.join(`
`),this.view.style(u)}getParentElement(u){const I=this.model.getParentNodeLocation(u);return this.model.getNode(I).element}getFirstElementChild(u){return this.model.getFirstElementChild(u)}getNode(u){return this.model.getNode(u)}getNodeLocation(u){return this.model.getNodeLocation(u)}collapse(u,I=!1){return this.model.setCollapsed(u,!0,I)}expand(u,I=!1){return this.model.setCollapsed(u,!1,I)}toggleCollapsed(u,I=!1){return this.model.setCollapsed(u,void 0,I)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(u){return this.model.isCollapsible(u)}setCollapsible(u,I){return this.model.setCollapsible(u,I)}isCollapsed(u){return this.model.isCollapsed(u)}expandTo(u){this.model.expandTo(u)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(u){if(typeof u>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const I=this.model.getNode(u);this.anchor.set([I]);const A=this.model.getListIndex(u);A>-1&&this.view.setAnchor(A,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(u,I){this.eventBufferer.bufferEvents(()=>{const A=u.map(V=>this.model.getNode(V));this.selection.set(A,I);const M=u.map(V=>this.model.getListIndex(V)).filter(V=>V>-1);this.view.setSelection(M,I,!0)})}getSelection(){return this.selection.get()}setFocus(u,I){this.eventBufferer.bufferEvents(()=>{const A=u.map(V=>this.model.getNode(V));this.focus.set(A,I);const M=u.map(V=>this.model.getListIndex(V)).filter(V=>V>-1);this.view.setFocus(M,I,!0)})}focusNext(u=1,I=!1,A,M=(0,i.isKeyboardEvent)(A)&&A.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(u,I,A,M)}focusPrevious(u=1,I=!1,A,M=(0,i.isKeyboardEvent)(A)&&A.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(u,I,A,M)}focusNextPage(u,I=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(u,I)}focusPreviousPage(u,I=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(u,I,()=>this.stickyScrollController?.height??0)}focusLast(u,I=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(u,I)}focusFirst(u,I=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(u,I)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const u=this.stickyScrollController?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?a.StickyScroll:a.Tree}reveal(u,I){this.model.expandTo(u);const A=this.model.getListIndex(u);if(A!==-1)if(!this.stickyScrollController)this.view.reveal(A,I);else{const M=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(u));this.view.reveal(A,I,M)}}getRelativeTop(u){const I=this.model.getListIndex(u);if(I===-1)return null;const A=this.stickyScrollController?.getNode(this.getNode(u));return this.view.getRelativeTop(I,A?.position??this.stickyScrollController?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new p.TreeError(this._user,"Can't get tree view state without an identity provider");const I=Y=>u.getId(Y).toString(),A=P.empty(this.scrollTop);for(const Y of this.getFocus())A.focus.add(I(Y));for(const Y of this.getSelection())A.selection.add(I(Y));const M=this.model.getNode(),V=[M];for(;V.length>0;){const Y=V.shift();Y!==M&&Y.collapsible&&(A.expanded[I(Y.element)]=Y.collapsed?0:1),V.push(...Y.children)}return A}onLeftArrow(u){u.preventDefault(),u.stopPropagation();const I=this.view.getFocusedElements();if(I.length===0)return;const A=I[0],M=this.model.getNodeLocation(A);if(!this.model.setCollapsed(M,!0)){const Y=this.model.getParentNodeLocation(M);if(!Y)return;const ie=this.model.getListIndex(Y);this.view.reveal(ie),this.view.setFocus([ie])}}onRightArrow(u){u.preventDefault(),u.stopPropagation();const I=this.view.getFocusedElements();if(I.length===0)return;const A=I[0],M=this.model.getNodeLocation(A);if(!this.model.setCollapsed(M,!1)){if(!A.children.some(ae=>ae.visible))return;const[Y]=this.view.getFocus(),ie=Y+1;this.view.reveal(ie),this.view.setFocus([ie])}}onSpace(u){u.preventDefault(),u.stopPropagation();const I=this.view.getFocusedElements();if(I.length===0)return;const A=I[0],M=this.model.getNodeLocation(A),V=u.browserEvent.altKey;this.model.setCollapsed(M,void 0,V)}navigate(u){return new C(this.view,this.model,u)}dispose(){(0,r.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=g;class C{constructor(u,I,A){this.view=u,this.model=I,A?this.index=this.model.getListIndex(A):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(De[151],we([1,0,150,141,35,37]),function(ne,t,i,n,k,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class N extends i.AbstractTree{constructor(_,d,b,y,p,m={}){super(_,d,b,y,m),this.user=_,this.dataSource=p,this.nodesByIdentity=new Map,this.identityProvider=m.identityProvider}getInput(){return this.input}setInput(_,d){if(d&&!this.identityProvider)throw new k.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=_,!_){this.nodesByIdentity.clear(),this.model.setChildren(null,R.Iterable.empty());return}if(!d){this._refresh(_);return}const b=[],y=[],p=e=>{const s=this.identityProvider.getId(e).toString();return!d.expanded[s]},m=e=>{const s=this.identityProvider.getId(e.element).toString();d.focus.has(s)&&b.push(e.element),d.selection.has(s)&&y.push(e.element)};this._refresh(_,p,m),this.setFocus(b),this.setSelection(y),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(_=this.input){if(typeof this.input>"u")throw new k.TreeError(this.user,"Tree input not set");let d;this.identityProvider&&(d=b=>{const y=this.identityProvider.getId(b).toString(),p=this.nodesByIdentity.get(y);if(p)return p.collapsed}),this._refresh(_,d)}resort(_=this.input,d=!0){this.model.resort(_===this.input?null:_,d)}refresh(_){if(_===void 0){this.view.rerender();return}this.model.rerender(_)}_refresh(_,d,b){let y;if(this.identityProvider){const p=new Set,m=b;b=e=>{const s=this.identityProvider.getId(e.element).toString();p.add(s),this.nodesByIdentity.set(s,e),m?.(e)},y=e=>{const s=this.identityProvider.getId(e.element).toString();p.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(_===this.input?null:_,this.iterate(_,d).elements,{onDidCreateNode:b,onDidDeleteNode:y})}iterate(_,d){const b=[...this.dataSource.getChildren(_)];return{elements:R.Iterable.map(b,p=>{const{elements:m,size:e}=this.iterate(p,d),s=this.dataSource.hasChildren?this.dataSource.hasChildren(p):void 0,o=e===0?void 0:d&&d(p);return{element:p,children:m,collapsible:s,collapsed:o}}),size:b.length}}createModel(_,d,b){return new n.ObjectTreeModel(_,d,b)}}t.DataTree=N}),define(De[84],we([1,0,9,12,48,39,36,6,3,2,70,11,10]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=W,t.deserialize=U,t.getDelayedChannel=K,t.getNextTickChannel=Q,y=Ue(y);var m;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(m||(m={}));function e(re){switch(re){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function o(re){switch(re){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var c;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(c||(c={}));function h(re){let ee=0;for(let he=0;;he+=7){const le=re.read(1);if(ee|=(le.buffer[0]&127)<<he,!(le.buffer[0]&128))return ee}}const v=E(0);function L(re,ee){if(ee===0){re.write(v);return}let he=0;for(let Ne=ee;Ne!==0;Ne=Ne>>>7)he++;const le=k.VSBuffer.alloc(he);for(let Ne=0;ee!==0;Ne++)le.buffer[Ne]=ee&127,ee=ee>>>7,ee>0&&(le.buffer[Ne]|=128);re.write(le)}class S{constructor(ee){this.buffer=ee,this.pos=0}read(ee){const he=this.buffer.slice(this.pos,this.pos+ee);return this.pos+=he.byteLength,he}}t.BufferReader=S;class r{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(ee){this.buffers.push(ee)}}t.BufferWriter=r;var f;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(f||(f={}));function E(re){const ee=k.VSBuffer.alloc(1);return ee.writeUInt8(re,0),ee}const T={Undefined:E(f.Undefined),String:E(f.String),Buffer:E(f.Buffer),VSBuffer:E(f.VSBuffer),Array:E(f.Array),Object:E(f.Object),Uint:E(f.Int)},H=typeof Buffer<"u";function W(re,ee){if(typeof ee>"u")re.write(T.Undefined);else if(typeof ee=="string"){const he=k.VSBuffer.fromString(ee);re.write(T.String),L(re,he.byteLength),re.write(he)}else if(H&&Buffer.isBuffer(ee)){const he=k.VSBuffer.wrap(ee);re.write(T.Buffer),L(re,he.byteLength),re.write(he)}else if(ee instanceof k.VSBuffer)re.write(T.VSBuffer),L(re,ee.byteLength),re.write(ee);else if(Array.isArray(ee)){re.write(T.Array),L(re,ee.length);for(const he of ee)W(re,he)}else if(typeof ee=="number"&&(ee|0)===ee)re.write(T.Uint),L(re,ee);else{const he=k.VSBuffer.fromString(JSON.stringify(ee));re.write(T.Object),L(re,he.byteLength),re.write(he)}}function U(re){switch(re.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return re.read(h(re)).toString();case f.Buffer:return re.read(h(re)).buffer;case f.VSBuffer:return re.read(h(re));case f.Array:{const he=h(re),le=[];for(let Ne=0;Ne<he;Ne++)le.push(U(re));return le}case f.Object:return JSON.parse(re.read(h(re)).toString());case f.Int:return h(re)}}class D{constructor(ee,he,le=null,Ne=1e3){this.protocol=ee,this.ctx=he,this.logger=le,this.timeoutDelay=Ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:s.Initialize})}registerChannel(ee,he){this.channels.set(ee,he),setTimeout(()=>this.flushPendingRequests(ee),0)}sendResponse(ee){switch(ee.type){case s.Initialize:{const he=this.send([ee.type]);this.logger?.logOutgoing(he,0,x.OtherSide,o(ee.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const he=this.send([ee.type,ee.id],ee.data);this.logger?.logOutgoing(he,ee.id,x.OtherSide,o(ee.type),ee.data);return}}}send(ee,he=void 0){const le=new r;return W(le,ee),W(le,he),this.sendBuffer(le.buffer)}sendBuffer(ee){try{return this.protocol.send(ee),ee.byteLength}catch{return 0}}onRawMessage(ee){const he=new S(ee),le=U(he),Ne=U(he),te=le[0];switch(te){case m.Promise:return this.logger?.logIncoming(ee.byteLength,le[1],x.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,Ne),this.onPromise({type:te,id:le[1],channelName:le[2],name:le[3],arg:Ne});case m.EventListen:return this.logger?.logIncoming(ee.byteLength,le[1],x.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,Ne),this.onEventListen({type:te,id:le[1],channelName:le[2],name:le[3],arg:Ne});case m.PromiseCancel:return this.logger?.logIncoming(ee.byteLength,le[1],x.OtherSide,`${e(te)}`),this.disposeActiveRequest({type:te,id:le[1]});case m.EventDispose:return this.logger?.logIncoming(ee.byteLength,le[1],x.OtherSide,`${e(te)}`),this.disposeActiveRequest({type:te,id:le[1]})}}onPromise(ee){const he=this.channels.get(ee.channelName);if(!he){this.collectPendingRequest(ee);return}const le=new R.CancellationTokenSource;let Ne;try{Ne=he.call(this.ctx,ee.name,ee.arg,le.token)}catch(Se){Ne=Promise.reject(Se)}const te=ee.id;Ne.then(Se=>{this.sendResponse({id:te,data:Se,type:s.PromiseSuccess})},Se=>{Se instanceof Error?this.sendResponse({id:te,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split(`
`):void 0},type:s.PromiseError}):this.sendResponse({id:te,data:Se,type:s.PromiseErrorObj})}).finally(()=>{be.dispose(),this.activeRequests.delete(ee.id)});const be=(0,d.toDisposable)(()=>le.cancel());this.activeRequests.set(ee.id,be)}onEventListen(ee){const he=this.channels.get(ee.channelName);if(!he){this.collectPendingRequest(ee);return}const le=ee.id,te=he.listen(this.ctx,ee.name,ee.arg)(be=>this.sendResponse({id:le,data:be,type:s.EventFire}));this.activeRequests.set(ee.id,te)}disposeActiveRequest(ee){const he=this.activeRequests.get(ee.id);he&&(he.dispose(),this.activeRequests.delete(ee.id))}collectPendingRequest(ee){let he=this.pendingRequests.get(ee.channelName);he||(he=[],this.pendingRequests.set(ee.channelName,he));const le=setTimeout(()=>{console.error(`Unknown channel: ${ee.channelName}`),ee.type===m.Promise&&this.sendResponse({id:ee.id,data:{name:"Unknown channel",message:`Channel name '${ee.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:s.PromiseError})},this.timeoutDelay);he.push({request:ee,timeoutTimer:le})}flushPendingRequests(ee){const he=this.pendingRequests.get(ee);if(he){for(const le of he)switch(clearTimeout(le.timeoutTimer),le.request.type){case m.Promise:this.onPromise(le.request);break;case m.EventListen:this.onEventListen(le.request);break}this.pendingRequests.delete(ee)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=D;var x;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class z{constructor(ee,he=null){this.protocol=ee,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(le=>this.onBuffer(le)),this.logger=he}getChannel(ee){const he=this;return{call(le,Ne,te){return he.isDisposed?Promise.reject(new w.CancellationError):he.requestPromise(ee,le,Ne,te)},listen(le,Ne){return he.isDisposed?_.Event.None:he.requestEvent(ee,le,Ne)}}}requestPromise(ee,he,le,Ne=R.CancellationToken.None){const te=this.lastRequestId++,be=m.Promise,Se={id:te,type:be,channelName:ee,name:he,arg:le};if(Ne.isCancellationRequested)return Promise.reject(new w.CancellationError);let Oe;return new Promise((We,oe)=>{if(Ne.isCancellationRequested)return oe(new w.CancellationError);const q=()=>{const g=C=>{switch(C.type){case s.PromiseSuccess:this.handlers.delete(te),We(C.data);break;case s.PromiseError:{this.handlers.delete(te);const F=new Error(C.data.message);F.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,F.name=C.data.name,oe(F);break}case s.PromiseErrorObj:this.handlers.delete(te),oe(C.data);break}};this.handlers.set(te,g),this.sendRequest(Se)};let B=null;this.state===c.Idle?q():(B=(0,n.createCancelablePromise)(g=>this.whenInitialized()),B.then(()=>{B=null,q()}));const l=()=>{B?(B.cancel(),B=null):this.sendRequest({id:te,type:m.PromiseCancel}),oe(new w.CancellationError)},a=Ne.onCancellationRequested(l);Oe=(0,d.combinedDisposable)((0,d.toDisposable)(l),a),this.activeRequests.add(Oe)}).finally(()=>{Oe.dispose(),this.activeRequests.delete(Oe)})}requestEvent(ee,he,le){const Ne=this.lastRequestId++,te=m.EventListen,be={id:Ne,type:te,channelName:ee,name:he,arg:le};let Se=null;const Oe=new _.Emitter({onWillAddFirstListener:()=>{Se=(0,n.createCancelablePromise)(We=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(Oe),this.sendRequest(be)})},onDidRemoveLastListener:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(Oe),this.sendRequest({id:Ne,type:m.EventDispose}))}}),Re=We=>Oe.fire(We.data);return this.handlers.set(Ne,Re),Oe.event}sendRequest(ee){switch(ee.type){case m.Promise:case m.EventListen:{const he=this.send([ee.type,ee.id,ee.channelName,ee.name],ee.arg);this.logger?.logOutgoing(he,ee.id,x.LocalSide,`${e(ee.type)}: ${ee.channelName}.${ee.name}`,ee.arg);return}case m.PromiseCancel:case m.EventDispose:{const he=this.send([ee.type,ee.id]);this.logger?.logOutgoing(he,ee.id,x.LocalSide,e(ee.type));return}}}send(ee,he=void 0){const le=new r;return W(le,ee),W(le,he),this.sendBuffer(le.buffer)}sendBuffer(ee){try{return this.protocol.send(ee),ee.byteLength}catch{return 0}}onBuffer(ee){const he=new S(ee),le=U(he),Ne=U(he),te=le[0];switch(te){case s.Initialize:return this.logger?.logIncoming(ee.byteLength,0,x.LocalSide,o(te)),this.onResponse({type:le[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.logger?.logIncoming(ee.byteLength,le[1],x.LocalSide,o(te),Ne),this.onResponse({type:le[0],id:le[1],data:Ne})}}onResponse(ee){if(ee.type===s.Initialize){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(ee.id)?.(ee)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=z,et([N.memoize],z.prototype,"onDidInitializePromise",null);class O{get connections(){const ee=[];return this._connections.forEach(he=>ee.push(he)),ee}constructor(ee,he,le){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new d.DisposableStore,this.disposables.add(ee(({protocol:Ne,onDidClientDisconnect:te})=>{const be=_.Event.once(Ne.onMessage);this.disposables.add(be(Se=>{const Oe=new S(Se),Re=U(Oe),We=new D(Ne,Re,he,le),oe=new z(Ne,he);this.channels.forEach((B,l)=>We.registerChannel(l,B));const q={channelServer:We,channelClient:oe,ctx:Re};this._connections.add(q),this._onDidAddConnection.fire(q),this.disposables.add(te(()=>{We.dispose(),oe.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)}))}))}))}getChannel(ee,he){const le=this;return{call(Ne,te,be){let Se;if((0,p.isFunction)(he)){const Re=(0,i.getRandomElement)(le.connections.filter(he));Se=Re?Promise.resolve(Re):_.Event.toPromise(_.Event.filter(le.onDidAddConnection,he))}else Se=he.routeCall(le,Ne,te);const Oe=Se.then(Re=>Re.channelClient.getChannel(ee));return K(Oe).call(Ne,te,be)},listen(Ne,te){if((0,p.isFunction)(he))return le.getMulticastEvent(ee,he,Ne,te);const be=he.routeEvent(le,Ne,te).then(Se=>Se.channelClient.getChannel(ee));return K(be).listen(Ne,te)}}}getMulticastEvent(ee,he,le,Ne){const te=this;let be;const Se=new _.Emitter({onWillAddFirstListener:()=>{be=new d.DisposableStore;const Oe=new _.EventMultiplexer,Re=new Map,We=q=>{const l=q.channelClient.getChannel(ee).listen(le,Ne),a=Oe.add(l);Re.set(q,a)},oe=q=>{const B=Re.get(q);B&&(B.dispose(),Re.delete(q))};te.connections.filter(he).forEach(We),_.Event.filter(te.onDidAddConnection,he)(We,void 0,be),te.onDidRemoveConnection(oe,void 0,be),Oe.event(Se.fire,Se,be),be.add(Oe)},onDidRemoveLastListener:()=>{be?.dispose(),be=void 0}});return Se.event}registerChannel(ee,he){this.channels.set(ee,he);for(const le of this._connections)le.channelServer.registerChannel(ee,he)}dispose(){this.disposables.dispose();for(const ee of this._connections)ee.channelClient.dispose(),ee.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class P{constructor(ee,he,le=null){const Ne=new r;W(Ne,he),ee.send(Ne.buffer),this.channelClient=new z(ee,le),this.channelServer=new D(ee,he,le)}getChannel(ee){return this.channelClient.getChannel(ee)}registerChannel(ee,he){this.channelServer.registerChannel(ee,he)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=P;function K(re){return{call(ee,he,le){return re.then(Ne=>Ne.call(ee,he,le))},listen(ee,he){const le=new _.Relay;return re.then(Ne=>le.input=Ne.listen(ee,he)),le.event}}}function Q(re){let ee=!1;return{call(he,le,Ne){return ee?re.call(he,le,Ne):(0,n.timeout)(0).then(()=>ee=!0).then(()=>re.call(he,le,Ne))},listen(he,le){if(ee)return re.listen(he,le);const Ne=new _.Relay;return(0,n.timeout)(0).then(()=>ee=!0).then(()=>Ne.input=re.listen(he,le)),Ne.event}}}class X{constructor(ee){this.fn=ee}routeCall(ee){return this.route(ee)}routeEvent(ee){return this.route(ee)}async route(ee){for(const he of ee.connections)if(await Promise.resolve(this.fn(he.ctx)))return Promise.resolve(he);return await _.Event.toPromise(ee.onDidAddConnection),await this.route(ee)}}t.StaticRouter=X;var G;(function(re){function ee(te,be,Se){const Oe=te,Re=Se&&Se.disableMarshalling,We=new Map;for(const oe in Oe)le(oe)&&We.set(oe,_.Event.buffer(Oe[oe],!0,void 0,be));return new class{listen(oe,q,B){const l=We.get(q);if(l)return l;const a=Oe[q];if(typeof a=="function"){if(Ne(q))return a.call(Oe,B);if(le(q))return We.set(q,_.Event.buffer(Oe[q],!0,void 0,be)),We.get(q)}throw new w.ErrorNoTelemetry(`Event not found: ${q}`)}call(oe,q,B){const l=Oe[q];if(typeof l=="function"){if(!Re&&Array.isArray(B))for(let g=0;g<B.length;g++)B[g]=(0,b.revive)(B[g]);let a=l.apply(Oe,B);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new w.ErrorNoTelemetry(`Method not found: ${q}`)}}}re.fromService=ee;function he(te,be){const Se=be&&be.disableMarshalling;return new Proxy({},{get(Oe,Re){if(typeof Re=="string")return be?.properties?.has(Re)?be.properties.get(Re):Ne(Re)?function(We){return te.listen(Re,We)}:le(Re)?te.listen(Re):async function(...We){let oe;be&&!(0,p.isUndefinedOrNull)(be.context)?oe=[be.context,...We]:oe=We;const q=await te.call(Re,oe);return Se?q:(0,b.revive)(q)};throw new w.ErrorNoTelemetry(`Property not found: ${String(Re)}`)}})}re.toService=he;function le(te){return te[0]==="o"&&te[1]==="n"&&y.isUpperAsciiLetter(te.charCodeAt(2))}function Ne(te){return/^onDynamic/.test(te)&&y.isUpperAsciiLetter(te.charCodeAt(9))}})(G||(t.ProxyChannel=G={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const ee=re.toString();if(ee!=="[object Object]")return ee}return re}function pe(re){return Array.isArray(re)?re.map(ce):ce(re)}function Te(re,ee,he,le,Ne,te,be){be=pe(be);const Se=J[Ne],Oe=Se[le%Se.length];let Re=[`%c[${re}]%c[${String(ee).padStart(7," ")}]%c[len: ${String(he).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(te)?(Re=Re.concat(be),Re.push(")")):Re.push(be),console.log.apply(console,Re)}class Fe{constructor(ee,he){this._outgoingPrefix=ee,this._incomingPrefix=he,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ee,he,le,Ne,te){this._totalOutgoing+=ee,Te(this._outgoingPrefix,this._totalOutgoing,ee,he,le,Ne,te)}logIncoming(ee,he,le,Ne,te){this._totalIncoming+=ee,Te(this._incomingPrefix,this._totalIncoming,ee,he,le,Ne,te)}}t.IPCLogger=Fe}),define(De[152],we([1,0,48,3,84,108,40]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends k.IPCClient{static createProtocol(){const d=n.Event.fromNodeEventEmitter(N.ipcRenderer,"vscode:message",(b,y)=>i.VSBuffer.wrap(y));return N.ipcRenderer.send("vscode:hello"),new R.Protocol(N.ipcRenderer,d)}constructor(d){const b=w.createProtocol();super(b,d),this.protocol=b}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=w}),define(De[153],we([14,13]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(De[154],we([14,13]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(De[55],we([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=k,t.refineServiceDecorator=R;var i;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function w(_){return _[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=w})(i||(t._util=i={})),t.IInstantiationService=k("instantiationService");function n(N,w,_){w[i.DI_TARGET]===w?w[i.DI_DEPENDENCIES].push({id:N,index:_}):(w[i.DI_DEPENDENCIES]=[{id:N,index:_}],w[i.DI_TARGET]=w)}function k(N){if(i.serviceIds.has(N))return i.serviceIds.get(N);const w=function(_,d,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(w,_,b)};return w.toString=()=>N,i.serviceIds.set(N,w),w}function R(N){return N}}),define(De[155],we([1,0,55]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=n,t.ID="diagnosticsService",t.IDiagnosticsService=(0,i.createDecorator)(t.ID);function n(R){return!!R.hostName&&!!R.errorMessage}class k{async getPerformanceInfo(N,w){return{}}async getSystemInfo(N,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,w){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}t.NullDiagnosticsService=k}),define(De[156],we([1,0,106,30,11,10,17,153,55,5,41,26]),function(ne,t,i,n,k,R,N,w,_,d,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=p,t.isFileSystemWatcher=o,t.hasReadWriteCapability=h,t.hasFileFolderCopyCapability=v,t.hasFileCloneCapability=L,t.hasOpenReadWriteCloseCapability=S,t.hasFileReadStreamCapability=r,t.hasFileAtomicReadCapability=f,t.hasFileAtomicWriteCapability=E,t.hasFileAtomicDeleteCapability=T,t.hasReadonlyCapability=H,t.createFileSystemProviderError=D,t.ensureFileSystemProviderError=x,t.markAsFileSystemProviderError=z,t.toFileSystemProviderErrorCode=O,t.toFileOperationResult=P,t.isParent=J,t.etag=ee,t.whenProviderRegistered=he,t.getLargeFileConfirmationLimit=Ne,t.IFileService=(0,_.createDecorator)("fileService");function p(te){return te.create===!0}var m;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(te){const be=te;return!!be&&typeof be.onDidChange=="function"}var c;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(c||(t.FileSystemProviderCapabilities=c={}));function h(te){return!!(te.capabilities&c.FileReadWrite)}function v(te){return!!(te.capabilities&c.FileFolderCopy)}function L(te){return!!(te.capabilities&c.FileClone)}function S(te){return!!(te.capabilities&c.FileOpenReadWriteClose)}function r(te){return!!(te.capabilities&c.FileReadStream)}function f(te){return h(te)?!!(te.capabilities&c.FileAtomicRead):!1}function E(te){return h(te)?!!(te.capabilities&c.FileAtomicWrite):!1}function T(te){return!!(te.capabilities&c.FileAtomicDelete)}function H(te){return!!(te.capabilities&c.Readonly)}var W;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(W||(t.FileSystemProviderErrorCode=W={}));class U extends Error{static create(be,Se){const Oe=new U(be.toString(),Se);return z(Oe,Se),Oe}constructor(be,Se){super(be),this.code=Se}}t.FileSystemProviderError=U;function D(te,be){return U.create(te,be)}function x(te){return te||D((0,w.localize)(0,null),W.Unknown)}function z(te,be){return te.name=be?`${be} (FileSystemError)`:"FileSystemError",te}function O(te){if(!te)return W.Unknown;if(te instanceof U)return te.code;const be=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!be)return W.Unknown;switch(be[1]){case W.FileExists:return W.FileExists;case W.FileIsADirectory:return W.FileIsADirectory;case W.FileNotADirectory:return W.FileNotADirectory;case W.FileNotFound:return W.FileNotFound;case W.FileTooLarge:return W.FileTooLarge;case W.FileWriteLocked:return W.FileWriteLocked;case W.NoPermissions:return W.NoPermissions;case W.Unavailable:return W.Unavailable}return W.Unknown}function P(te){if(te instanceof ce)return te.fileOperationResult;switch(O(te)){case W.FileNotFound:return Fe.FILE_NOT_FOUND;case W.FileIsADirectory:return Fe.FILE_IS_DIRECTORY;case W.FileNotADirectory:return Fe.FILE_NOT_DIRECTORY;case W.FileWriteLocked:return Fe.FILE_WRITE_LOCKED;case W.NoPermissions:return Fe.FILE_PERMISSION_DENIED;case W.FileExists:return Fe.FILE_MOVE_CONFLICT;case W.FileTooLarge:return Fe.FILE_TOO_LARGE;default:return Fe.FILE_OTHER_ERROR}}var K;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(K||(t.FileOperation=K={}));class Q{constructor(be,Se,Oe){this.resource=be,this.operation=Se,this.target=Oe}isOperation(be){return this.operation===be}}t.FileOperationEvent=Q;var X;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class G{static{this.MIXED_CORRELATION=null}constructor(be,Se){this.ignorePathCasing=Se,this.correlationId=void 0,this.added=new y.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawAdded.map(Re=>[Re,!0])),Oe}),this.updated=new y.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawUpdated.map(Re=>[Re,!0])),Oe}),this.deleted=new y.Lazy(()=>{const Oe=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Oe.fill(this.rawDeleted.map(Re=>[Re,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of be){switch(Oe.type){case X.ADDED:this.rawAdded.push(Oe.resource);break;case X.UPDATED:this.rawUpdated.push(Oe.resource);break;case X.DELETED:this.rawDeleted.push(Oe.resource);break}this.correlationId!==G.MIXED_CORRELATION&&(typeof Oe.cId=="number"?this.correlationId===void 0?this.correlationId=Oe.cId:this.correlationId!==Oe.cId&&(this.correlationId=G.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=G.MIXED_CORRELATION))}}contains(be,...Se){return this.doContains(be,{includeChildren:!1},...Se)}affects(be,...Se){return this.doContains(be,{includeChildren:!0},...Se)}doContains(be,Se,...Oe){if(!be)return!1;const Re=Oe.length>0;return!!((!Re||Oe.includes(X.ADDED))&&(this.added.value.get(be)||Se.includeChildren&&this.added.value.findSuperstr(be))||(!Re||Oe.includes(X.UPDATED))&&(this.updated.value.get(be)||Se.includeChildren&&this.updated.value.findSuperstr(be))||(!Re||Oe.includes(X.DELETED))&&(this.deleted.value.findSubstr(be)||Se.includeChildren&&this.deleted.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.correlationId===be}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=G;function J(te,be,Se){return!te||!be||te===be||be.length>te.length?!1:(be.charAt(be.length-1)!==n.sep&&(be+=n.sep),Se?(0,k.startsWithIgnoreCase)(te,be):te.indexOf(be)===0)}class ce extends Error{constructor(be,Se,Oe){super(be),this.fileOperationResult=Se,this.options=Oe}}t.FileOperationError=ce;class pe extends ce{constructor(be,Se,Oe,Re){super(be,Se,Re),this.fileOperationResult=Se,this.size=Oe}}t.TooLargeFileOperationError=pe;class Te extends ce{constructor(be,Se,Oe){super(be,Fe.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=Se}}t.NotModifiedSinceFileOperationError=Te;var Fe;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var re;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(t.FileKind=re={})),t.ETAG_DISABLED="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function he(te,be){if(!be.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(Se=>{const Oe=be.onDidChangeFileSystemProviderRegistrations(Re=>{Re.scheme===te.scheme&&Re.added&&(Oe.dispose(),Se())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(be){return(0,R.isNumber)(be)||(be=0),be<le.KB?(0,w.localize)(1,null,be.toFixed(0)):be<le.MB?(0,w.localize)(2,null,(be/le.KB).toFixed(2)):be<le.GB?(0,w.localize)(3,null,(be/le.MB).toFixed(2)):be<le.TB?(0,w.localize)(4,null,(be/le.GB).toFixed(2)):(0,w.localize)(5,null,(be/le.TB).toFixed(2))}}t.ByteSize=le;function Ne(te){const be=typeof te=="string"||te?.scheme===b.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===b.Schemas.file?1024*le.MB:be?10*le.MB:d.isWeb?50*le.MB:1024*le.MB}}),define(De[157],we([1,0,55]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,i.createDecorator)("mainProcessService");class n{constructor(R,N){this.server=R,this.router=N}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,N){this.server.registerChannel(R,N)}}t.MainProcessService=n}),define(De[158],we([1,0,2,152]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class k extends i.Disposable{constructor(N){super(),this.mainProcessConnection=this._register(new n.Client(`window:${N}`))}getChannel(N){return this.mainProcessConnection.getChannel(N)}registerChannel(N,w){this.mainProcessConnection.registerChannel(N,w)}}t.ElectronIPCMainProcessService=k});var Ci=this&&this.__param||function(ne,t){return function(i,n){t(i,n,ne)}};define(De[159],we([1,0,84,157]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let k=class{constructor(N,w){return this.windowId=N,i.ProxyChannel.toService(w.getChannel("nativeHost"),{context:N,properties:(()=>{const _=new Map;return _.set("windowId",N),_})()})}};t.NativeHostService=k,t.NativeHostService=k=et([Ci(1,n.IMainProcessService)],k)}),define(De[85],we([1,0,43,10]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0,i=Ue(i),n=Ue(n);class k{constructor(){this.data=new Map}add(N,w){i.ok(n.isString(N)),i.ok(n.isObject(w)),i.ok(!this.data.has(N),"There is already an extension with this id"),this.data.set(N,w)}knows(N){return this.data.has(N)}as(N){return this.data.get(N)||null}}t.Registry=new k}),define(De[160],we([1,0,3,85]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,n=Ue(n),t.Extensions={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,d){this.schemasById[k(_)]=d,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const N=new R;n.Registry.add(t.Extensions.JSONContribution,N)}),define(De[161],we([1,0,12,21,49,22,3,10,17,154,160,85]),function(ne,t,i,n,k,R,N,w,_,d,b,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=o,t.getIconRegistry=c,y=Ue(y),t.Extensions={IconContribution:"base.contributions.icons"};var p;(function(S){function r(f,E){let T=f.defaults;for(;R.ThemeIcon.isThemeIcon(T);){const H=s.getIcon(T.id);if(!H)return;T=H.defaults}return T}S.getDefinition=r})(p||(t.IconContribution=p={}));var m;(function(S){function r(E){return{weight:E.weight,style:E.style,src:E.src.map(T=>({format:T.format,location:T.location.toString()}))}}S.toJSONObject=r;function f(E){const T=H=>(0,w.isString)(H)?H:void 0;if(E&&Array.isArray(E.src)&&E.src.every(H=>(0,w.isString)(H.format)&&(0,w.isString)(H.location)))return{weight:T(E.weight),style:T(E.style),src:E.src.map(H=>({format:H.format,location:_.URI.parse(H.location)}))}}S.fromJSONObject=f})(m||(t.IconFontDefinition=m={}));class e{constructor(){this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,d.localize)(0,null)},fontCharacter:{type:"string",description:(0,d.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(r,f,E,T){const H=this.iconsById[r];if(H){if(E&&!H.description){H.description=E,this.iconSchema.properties[r].markdownDescription=`${E} $(${r})`;const D=this.iconReferenceSchema.enum.indexOf(r);D!==-1&&(this.iconReferenceSchema.enumDescriptions[D]=E),this._onDidChange.fire()}return H}const W={id:r,description:E,defaults:f,deprecationMessage:T};this.iconsById[r]=W;const U={$ref:"#/definitions/icons"};return T&&(U.deprecationMessage=T),E&&(U.markdownDescription=`${E}: $(${r})`),this.iconSchema.properties[r]=U,this.iconReferenceSchema.enum.push(r),this.iconReferenceSchema.enumDescriptions.push(E||""),this._onDidChange.fire(),{id:r}}deregisterIcon(r){delete this.iconsById[r],delete this.iconSchema.properties[r];const f=this.iconReferenceSchema.enum.indexOf(r);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(r=>this.iconsById[r])}getIcon(r){return this.iconsById[r]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(r,f){const E=this.iconFontsById[r];return E||(this.iconFontsById[r]=f,this._onDidChange.fire(),f)}deregisterIconFont(r){delete this.iconFontsById[r]}getIconFont(r){return this.iconFontsById[r]}toString(){const r=(H,W)=>H.id.localeCompare(W.id),f=H=>{for(;R.ThemeIcon.isThemeIcon(H.defaults);)H=this.iconsById[H.defaults.id];return`codicon codicon-${H?H.id:""}`},E=[];E.push("| preview     | identifier                        | default codicon ID                | description"),E.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.iconsById).map(H=>this.iconsById[H]);for(const H of T.filter(W=>!!W.description).sort(r))E.push(`|<i class="${f(H)}"></i>|${H.id}|${R.ThemeIcon.isThemeIcon(H.defaults)?H.defaults.id:H.id}|${H.description||""}|`);E.push("| preview     | identifier                        "),E.push("| ----------- | --------------------------------- |");for(const H of T.filter(W=>!R.ThemeIcon.isThemeIcon(W.defaults)).sort(r))E.push(`|<i class="${f(H)}"></i>|${H.id}|`);return E.join(`
`)}}const s=new e;y.Registry.add(t.Extensions.IconContribution,s);function o(S,r,f,E){return s.registerIcon(S,r,f,E)}function c(){return s}function h(){const S=(0,k.getCodiconFontCharacters)();for(const r in S){const f="\\"+S[r].toString(16);s.registerIcon(r,{fontCharacter:f})}}h(),t.iconsSchemaId="vscode://schemas/icons";const v=y.Registry.as(b.Extensions.JSONContribution);v.registerSchema(t.iconsSchemaId,s.getIconSchema());const L=new i.RunOnceScheduler(()=>v.notifySchemaChanged(t.iconsSchemaId),200);s.onDidChange(()=>{L.isScheduled()||L.schedule()}),t.widgetClose=o("widget-close",n.Codicon.close,(0,d.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",n.Codicon.arrowUp,(0,d.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",n.Codicon.arrowDown,(0,d.localize)(4,null)),t.syncing=R.ThemeIcon.modify(n.Codicon.sync,"spin"),t.spinningLoading=R.ThemeIcon.modify(n.Codicon.loading,"spin")}),define(De[162],we([1,0,4,3,2,22,161]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=w;function w(d){const b=new k.DisposableStore,y=b.add(new n.Emitter),p=(0,N.getIconRegistry)();return b.add(p.onDidChange(()=>y.fire())),d&&b.add(d.onDidProductIconThemeChange(()=>y.fire())),{dispose:()=>b.dispose(),onDidChange:y.event,getCSS(){const m=d?d.getProductIconTheme():new _,e={},s=[],o=[];for(const c of p.getIcons()){const h=m.getIcon(c);if(!h)continue;const v=h.font,L=`--vscode-icon-${c.id}-font-family`,S=`--vscode-icon-${c.id}-content`;v?(e[v.id]=v.definition,o.push(`${L}: ${(0,i.asCSSPropertyValue)(v.id)};`,`${S}: '${h.fontCharacter}';`),s.push(`.codicon-${c.id}:before { content: '${h.fontCharacter}'; font-family: ${(0,i.asCSSPropertyValue)(v.id)}; }`)):(o.push(`${S}: '${h.fontCharacter}'; ${L}: 'codicon';`),s.push(`.codicon-${c.id}:before { content: '${h.fontCharacter}'; }`))}for(const c in e){const h=e[c],v=h.weight?`font-weight: ${h.weight};`:"",L=h.style?`font-style: ${h.style};`:"",S=h.src.map(r=>`${(0,i.asCSSUrl)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${S}; font-family: ${(0,i.asCSSPropertyValue)(c)};${v}${L} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class _{getIcon(b){const y=(0,N.getIconRegistry)();let p=b.defaults;for(;R.ThemeIcon.isThemeIcon(p);){const m=y.getIcon(p.id);if(!m)return;p=m.defaults}return p}}t.UnthemedProductIconTheme=_}),define(De[163],we([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=n,t.isWorkspaceToOpen=k,t.isFolderToOpen=R,t.isFileToOpen=N,t.getMenuBarVisibility=w,t.hasCustomTitlebar=y,t.hasNativeTitlebar=p,t.getTitleBarStyle=m,t.useWindowControlsOverlay=e,t.useNativeFullScreen=s,t.zoomLevelToZoomFactor=o,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(c){return typeof c.parentId=="number"}function k(c){return!!c.workspaceUri}function R(c){return!!c.folderUri}function N(c){return!!c.fileUri}function w(c){const h=p(c),v=c.getValue("window.menuBarVisibility");return v==="default"||h&&v==="compact"||i.isMacintosh&&i.isNative?"classic":v}var _;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(_||(t.TitleBarSetting=_={}));var d;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(d||(t.TitlebarStyle=d={}));var b;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(b||(t.CustomTitleBarVisibility=b={}));function y(c,h){return!0}function p(c,h){return h||(h=m(c)),h===d.NATIVE}function m(c){if(i.isWeb)return d.CUSTOM;const h=c.getValue("window");if(h){if(i.isMacintosh&&h.nativeTabs===!0||i.isMacintosh&&h.nativeFullScreen===!1)return d.NATIVE;const S=h.titleBarStyle;if(S===d.NATIVE||S===d.CUSTOM)return S}return i.isLinux?d.NATIVE:d.CUSTOM}t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function e(c){return!(!i.isWindows||i.isWeb||p(c))}function s(c){const h=c.getValue("window");return!h||typeof h.nativeFullScreen!="boolean"||h.nativeTabs?!0:h.nativeFullScreen!==!1}function o(c=0){return Math.pow(1.2,c)}}),define(De[164],we([1,0,19,4,25,40,163]),function(ne,t,i,n,k,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=_,t.zoomIn=b,t.zoomOut=y;var w;(function(p){p[p.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",p[p.ALL_WINDOWS=2]="ALL_WINDOWS"})(w||(t.ApplyZoomTarget=w={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function _(p,m){p=Math.min(Math.max(p,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];m===w.ACTIVE_WINDOW?e.push((0,n.getActiveWindow)()):m===w.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)d(s)?.webFrame?.setZoomLevel(p),(0,i.setZoomFactor)((0,N.zoomLevelToZoomFactor)(p),s),(0,i.setZoomLevel)(p,s)}function d(p){if(p===k.mainWindow)return{ipcRenderer:R.ipcRenderer,webFrame:R.webFrame};{const m=p;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function b(p){_((0,i.getZoomLevel)(typeof p=="number"?(0,n.getActiveWindow)():p)+1,p)}function y(p){_((0,i.getZoomLevel)(typeof p=="number"?(0,n.getActiveWindow)():p)-1,p)}}),define(De[165],we([1,0,13,4,151,12,109,40,155,156,158,159,162,164,16,8,25,123,113]),function(ne,t,i,n,k,R,N,w,_,d,b,y,p,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=x;const c=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class v{getHeight(O){return 22}getTemplateId(O){return W(O)?"process":T(O)?"machine":(0,_.isRemoteDiagnosticError)(O)?"error":H(O)?"header":""}}class L{hasChildren(O){return(0,_.isRemoteDiagnosticError)(O)?!1:W(O)?!!O.children?.length:!0}getChildren(O){return W(O)?O.children?O.children:[]:(0,_.isRemoteDiagnosticError)(O)?[]:H(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:T(O)?[O.rootProcess]:[O.processes]}}class S{constructor(){this.templateId="header"}renderTemplate(O){const P=(0,n.append)(O,(0,n.$)(".row")),K=(0,n.append)(P,(0,n.$)(".nameLabel")),Q=(0,n.append)(P,(0,n.$)(".cpu")),X=(0,n.append)(P,(0,n.$)(".memory")),G=(0,n.append)(P,(0,n.$)(".pid"));return{name:K,CPU:Q,memory:X,PID:G}}renderElement(O,P,K,Q){K.name.textContent=(0,i.localize)(0,null),K.CPU.textContent=(0,i.localize)(1,null),K.PID.textContent=(0,i.localize)(2,null),K.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(O){}}class r{constructor(){this.templateId="machine"}renderTemplate(O){const P=Object.create(null),K=(0,n.append)(O,(0,n.$)(".row"));return P.name=(0,n.append)(K,(0,n.$)(".nameLabel")),P}renderElement(O,P,K,Q){K.name.textContent=O.element.name}disposeTemplate(O){}}class f{constructor(){this.templateId="error"}renderTemplate(O){const P=Object.create(null),K=(0,n.append)(O,(0,n.$)(".row"));return P.name=(0,n.append)(K,(0,n.$)(".nameLabel")),P}renderElement(O,P,K,Q){K.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class E{constructor(O,P,K){this.platform=O,this.totalMem=P,this.mapPidToName=K,this.templateId="process"}renderTemplate(O){const P=(0,n.append)(O,(0,n.$)(".row")),K=(0,n.append)(P,(0,n.$)(".nameLabel")),Q=(0,n.append)(P,(0,n.$)(".cpu")),X=(0,n.append)(P,(0,n.$)(".memory")),G=(0,n.append)(P,(0,n.$)(".pid"));return{name:K,CPU:Q,PID:G,memory:X}}renderElement(O,P,K,Q){const{element:X}=O,G=X.pid.toFixed(0);let J=X.name;this.mapPidToName.has(X.pid)&&(J=this.mapPidToName.get(X.pid)),K.name.textContent=J,K.name.title=X.cmd,K.CPU.textContent=X.load.toFixed(0),K.PID.textContent=G,K.PID.parentElement.id=`pid-${G}`;const ce=this.platform==="win32"?X.mem:this.totalMem*(X.mem/100);K.memory.textContent=(ce/d.ByteSize.MB).toFixed(0)}disposeTemplate(O){}}function T(z){return!!z.name&&!!z.rootProcess}function H(z){return!!z.processRoots}function W(z){return!!z.pid}class U{constructor(O,P){this.data=P,this.mapPidToName=new Map;const K=new b.ElectronIPCMainProcessService(O);this.nativeHostService=new y.NativeHostService(O,K),this.applyStyles(P.styles),this.setEventHandlers(P),w.ipcRenderer.on("vscode:pidToNameResponse",(Q,X)=>{this.mapPidToName.clear();for(const[G,J]of X)this.mapPidToName.set(G,J)}),w.ipcRenderer.on("vscode:listProcessesResponse",async(Q,X)=>{X.forEach((G,J)=>{W(G.rootProcess)&&(G.rootProcess.name=J===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:X}}),this.tree.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth)):await this.createProcessTree(X),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:pidToNameRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(O){o.mainWindow.document.onkeydown=P=>{const K=O.platform==="darwin"?P.metaKey:P.ctrlKey;K&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),K&&P.keyCode===187&&(0,m.zoomIn)(o.mainWindow),K&&P.keyCode===189&&(0,m.zoomOut)(o.mainWindow)}}async createProcessTree(O){const P=o.mainWindow.document.getElementById("process-list");if(!P)return;const{totalmem:K}=await this.nativeHostService.getOSStatistics(),Q=[new E(this.data.platform,K,this.mapPidToName),new S,new r,new f];this.tree=new k.DataTree("processExplorer",P,new v,Q,new L,{identityProvider:{getId:X=>W(X)?X.pid.toString():(0,_.isRemoteDiagnosticError)(X)?X.hostName:H(X)?"processes":T(X)?X.name:"header"}}),this.tree.setInput({processes:{processRoots:O}}),this.tree.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth),this.tree.onKeyDown(X=>{const G=new e.StandardKeyboardEvent(X);if(G.keyCode===s.KeyCode.KeyE&&G.altKey){const J=this.getSelectedPids();Promise.all(J.map(ce=>this.nativeHostService.killProcess(ce,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(X=>{W(X.element)&&this.showContextMenu(X.element,!0)}),P.style.height=`${o.mainWindow.innerHeight}px`,o.mainWindow.addEventListener("resize",()=>{P.style.height=`${o.mainWindow.innerHeight}px`,this.tree?.layout(o.mainWindow.innerHeight,o.mainWindow.innerWidth)})}isDebuggable(O){const P=c.exec(O);return P&&P.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}attachTo(O){const P={type:"node",request:"attach",name:`process ${O.pid}`};let K=c.exec(O.cmd);K?P.port=Number(K.groups.port):P.processId=String(O.pid),K=h.exec(O.cmd),K&&(P.port=Number(K.groups.port)),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}applyStyles(O){const P=(0,n.createStyleSheet)(),K=[];O.listFocusBackground&&(K.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&K.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(K.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&K.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&K.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&K.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&K.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=K.join(`
`),O.color&&(o.mainWindow.document.body.style.color=O.color)}showContextMenu(O,P){const K=[],Q=Number(O.pid);P&&(K.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.nativeHostService.killProcess(Q,"SIGTERM")}}),K.push({label:(0,i.localize)(5,null),click:()=>{this.nativeHostService.killProcess(Q,"SIGKILL")}}),K.push({type:"separator"})),K.push({label:(0,i.localize)(6,null),click:()=>{const X=this.getSelectedPids();X?.includes(Q)||(X.length=0,X.push(Q));const G=X?.map(J=>o.mainWindow.document.getElementById(`pid-${J}`)).filter(J=>!!J);if(G){const J=G.map(ce=>ce.innerText).filter(ce=>!!ce);this.nativeHostService.writeClipboardText(J.join(`
`))}}}),K.push({label:(0,i.localize)(7,null),click:()=>{const X=o.mainWindow.document.getElementById("process-list");X&&this.nativeHostService.writeClipboardText(X.innerText)}}),O&&P&&this.isDebuggable(O.cmd)&&(K.push({type:"separator"}),K.push({label:(0,i.localize)(8,null),click:()=>{this.attachTo(O)}})),(0,N.popup)(K)}requestProcessList(O){setTimeout(()=>{const P=Date.now(),K=O+P-this.lastRequestTime;this.lastRequestTime=P,K>1e3?(w.ipcRenderer.send("vscode:pidToNameRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(K)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function D(){const z=(0,n.createStyleSheet)();z.id="codiconStyles";const O=(0,p.getIconsStyleSheet)(void 0);function P(){z.textContent=O.getCSS()}const K=new R.RunOnceScheduler(P,0);O.onDidChange(()=>K.schedule()),K.schedule()}function x(z){const O=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";o.mainWindow.document.body.classList.add(O),D(),(0,m.applyZoom)(z.data.zoomLevel,o.mainWindow),new U(z.windowId,z.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
