/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ae=function(q){for(var t=[],P=0,b=q.length;P<b;P++)t[P]=oe[q[P]];return t};define(oe[74],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoaderStats=t.LoaderEventType=t.isESM=void 0,t.isESM=!1;var P;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(P||(t.LoaderEventType=P={}));class b{static get(){const D=new Map,k=new Map,C=new Map,p=new Map;function c(g,T){g.has(T.detail)||g.set(T.detail,-T.timestamp)}function l(g,T){const y=g.get(T.detail);y&&(y>=0||g.set(T.detail,y+T.timestamp))}let d=[];typeof q=="function"&&typeof q.getStats=="function"&&(d=q.getStats().slice(0).sort((g,T)=>g.timestamp-T.timestamp));for(const g of d)switch(g.type){case P.BeginLoadingScript:c(D,g);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:l(D,g);break;case P.BeginInvokeFactory:c(k,g);break;case P.EndInvokeFactory:l(k,g);break;case P.NodeBeginNativeRequire:c(C,g);break;case P.NodeEndNativeRequire:l(C,g);break;case P.NodeBeginEvaluatingScript:c(p,g);break;case P.NodeEndEvaluatingScript:l(p,g);break}let u=0;C.forEach(g=>u+=g);function S(g){const T=[];return g.forEach((y,f)=>T.push([f,y])),T}return{amdLoad:S(D),amdInvoke:S(k),nodeRequire:S(C),nodeEval:S(p),nodeRequireTotal:u}}static toMarkdownTable(D,k){let C="";const p=[];return D.forEach((c,l)=>{p[l]=c.length}),k.forEach(c=>{c.forEach((l,d)=>{typeof l>"u"&&(l=c[d]="-");const u=l.toString().length;p[d]=Math.max(u,p[d])})}),D.forEach((c,l)=>{C+=`| ${c+" ".repeat(p[l]-c.toString().length)} `}),C+=`|
`,D.forEach((c,l)=>{C+=`| ${"-".repeat(p[l])} `}),C+=`|
`,k.forEach(c=>{c.forEach((l,d)=>{typeof l<"u"&&(C+=`| ${l+" ".repeat(p[d]-l.toString().length)} `)}),C+=`|
`}),C}}t.LoaderStats=b}),define(oe[55],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=b,t.debounce=v,t.throttle=D;function P(k){return(C,p,c)=>{let l=null,d=null;if(typeof c.value=="function"?(l="value",d=c.value):typeof c.get=="function"&&(l="get",d=c.get),!d)throw new Error("not supported");c[l]=k(d,p)}}function b(k,C,p){let c=null,l=null;if(typeof p.value=="function"?(c="value",l=p.value,l.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",l=p.get),!l)throw new Error("not supported");const d=`$memoize$${C}`;p[c]=function(...u){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:l.apply(this,u)}),this[d]}}function v(k,C,p){return P((c,l)=>{const d=`$debounce$${l}`,u=`$debounce$result$${l}`;return function(...S){this[u]||(this[u]=p?p():void 0),clearTimeout(this[d]),C&&(this[u]=C(this[u],...S),S=[this[u]]),this[d]=setTimeout(()=>{c.apply(this,S),this[u]=p?p():void 0},k)}})}function D(k,C,p){return P((c,l)=>{const d=`$throttle$timer$${l}`,u=`$throttle$result$${l}`,S=`$throttle$lastRun$${l}`,g=`$throttle$pending$${l}`;return function(...T){if(this[u]||(this[u]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),C&&(this[u]=C(this[u],...T)),this[g])return;const y=this[S]+k;y<=Date.now()?(this[S]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0):(this[g]=!0,this[d]=setTimeout(()=>{this[g]=!1,this[S]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0},y-Date.now()))}})}}),define(oe[75],ae([0,1,9]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=b,t.assertNever=v,t.assert=D,t.softAssert=k,t.assertFn=C,t.checkAdjacentItems=p;function b(c,l){if(!c)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function v(c,l="Unreachable"){throw new Error(l)}function D(c,l="unexpected state"){if(!c)throw new P.BugIndicatingError(`Assertion Failed: ${l}`)}function k(c){c||(0,P.onUnexpectedError)(new P.BugIndicatingError("Soft Assertion Failed"))}function C(c){if(!c()){debugger;c(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}function p(c,l){let d=0;for(;d<c.length-1;){const u=c[d],S=c[d+1];if(!l(u,S))return!1;d++}return!0}}),define(oe[34],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.createScanner=k,t.getLocation=d,t.parse=u,t.parseTree=S,t.findNodeAtLocation=g,t.getNodePath=T,t.getNodeValue=y,t.contains=f,t.findNodeAtOffset=m,t.visit=R,t.getNodeType=E;var P;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(P||(t.ScanError=P={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b||(t.SyntaxKind=b={}));var v;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(v||(t.ParseErrorCode=v={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D||(t.ParseOptions=D={}));function k(e,a=!1){let i=0;const s=e.length;let r="",n=0,o=b.Unknown,h=P.None;function w(Y){let ne=0,ce=0;for(;ne<Y;){const ue=e.charCodeAt(i);if(ue>=l._0&&ue<=l._9)ce=ce*16+ue-l._0;else if(ue>=l.A&&ue<=l.F)ce=ce*16+ue-l.A+10;else if(ue>=l.a&&ue<=l.f)ce=ce*16+ue-l.a+10;else break;i++,ne++}return ne<Y&&(ce=-1),ce}function O(Y){i=Y,r="",n=0,o=b.Unknown,h=P.None}function x(){const Y=i;if(e.charCodeAt(i)===l._0)i++;else for(i++;i<e.length&&c(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===l.dot)if(i++,i<e.length&&c(e.charCodeAt(i)))for(i++;i<e.length&&c(e.charCodeAt(i));)i++;else return h=P.UnexpectedEndOfNumber,e.substring(Y,i);let ne=i;if(i<e.length&&(e.charCodeAt(i)===l.E||e.charCodeAt(i)===l.e))if(i++,(i<e.length&&e.charCodeAt(i)===l.plus||e.charCodeAt(i)===l.minus)&&i++,i<e.length&&c(e.charCodeAt(i))){for(i++;i<e.length&&c(e.charCodeAt(i));)i++;ne=i}else h=P.UnexpectedEndOfNumber;return e.substring(Y,ne)}function L(){let Y="",ne=i;for(;;){if(i>=s){Y+=e.substring(ne,i),h=P.UnexpectedEndOfString;break}const ce=e.charCodeAt(i);if(ce===l.doubleQuote){Y+=e.substring(ne,i),i++;break}if(ce===l.backslash){if(Y+=e.substring(ne,i),i++,i>=s){h=P.UnexpectedEndOfString;break}switch(e.charCodeAt(i++)){case l.doubleQuote:Y+='"';break;case l.backslash:Y+="\\";break;case l.slash:Y+="/";break;case l.b:Y+="\b";break;case l.f:Y+="\f";break;case l.n:Y+=`
`;break;case l.r:Y+="\r";break;case l.t:Y+="	";break;case l.u:{const he=w(4);he>=0?Y+=String.fromCharCode(he):h=P.InvalidUnicode;break}default:h=P.InvalidEscapeCharacter}ne=i;continue}if(ce>=0&&ce<=31)if(p(ce)){Y+=e.substring(ne,i),h=P.UnexpectedEndOfString;break}else h=P.InvalidCharacter;i++}return Y}function A(){if(r="",h=P.None,n=i,i>=s)return n=s,o=b.EOF;let Y=e.charCodeAt(i);if(C(Y)){do i++,r+=String.fromCharCode(Y),Y=e.charCodeAt(i);while(C(Y));return o=b.Trivia}if(p(Y))return i++,r+=String.fromCharCode(Y),Y===l.carriageReturn&&e.charCodeAt(i)===l.lineFeed&&(i++,r+=`
`),o=b.LineBreakTrivia;switch(Y){case l.openBrace:return i++,o=b.OpenBraceToken;case l.closeBrace:return i++,o=b.CloseBraceToken;case l.openBracket:return i++,o=b.OpenBracketToken;case l.closeBracket:return i++,o=b.CloseBracketToken;case l.colon:return i++,o=b.ColonToken;case l.comma:return i++,o=b.CommaToken;case l.doubleQuote:return i++,r=L(),o=b.StringLiteral;case l.slash:{const ne=i-1;if(e.charCodeAt(i+1)===l.slash){for(i+=2;i<s&&!p(e.charCodeAt(i));)i++;return r=e.substring(ne,i),o=b.LineCommentTrivia}if(e.charCodeAt(i+1)===l.asterisk){i+=2;const ce=s-1;let ue=!1;for(;i<ce;){if(e.charCodeAt(i)===l.asterisk&&e.charCodeAt(i+1)===l.slash){i+=2,ue=!0;break}i++}return ue||(i++,h=P.UnexpectedEndOfComment),r=e.substring(ne,i),o=b.BlockCommentTrivia}return r+=String.fromCharCode(Y),i++,o=b.Unknown}case l.minus:if(r+=String.fromCharCode(Y),i++,i===s||!c(e.charCodeAt(i)))return o=b.Unknown;case l._0:case l._1:case l._2:case l._3:case l._4:case l._5:case l._6:case l._7:case l._8:case l._9:return r+=x(),o=b.NumericLiteral;default:for(;i<s&&_(Y);)i++,Y=e.charCodeAt(i);if(n!==i){switch(r=e.substring(n,i),r){case"true":return o=b.TrueKeyword;case"false":return o=b.FalseKeyword;case"null":return o=b.NullKeyword}return o=b.Unknown}return r+=String.fromCharCode(Y),i++,o=b.Unknown}}function _(Y){if(C(Y)||p(Y))return!1;switch(Y){case l.closeBrace:case l.closeBracket:case l.openBrace:case l.openBracket:case l.doubleQuote:case l.colon:case l.comma:case l.slash:return!1}return!0}function X(){let Y;do Y=A();while(Y>=b.LineCommentTrivia&&Y<=b.Trivia);return Y}return{setPosition:O,getPosition:()=>i,scan:a?X:A,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>n,getTokenLength:()=>i-n,getTokenError:()=>h}}function C(e){return e===l.space||e===l.tab||e===l.verticalTab||e===l.formFeed||e===l.nonBreakingSpace||e===l.ogham||e>=l.enQuad&&e<=l.zeroWidthSpace||e===l.narrowNoBreakSpace||e===l.mathematicalSpace||e===l.ideographicSpace||e===l.byteOrderMark}function p(e){return e===l.lineFeed||e===l.carriageReturn||e===l.lineSeparator||e===l.paragraphSeparator}function c(e){return e>=l._0&&e<=l._9}var l;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(l||(l={}));function d(e,a){const i=[],s=new Object;let r;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(w,O,x,L){n.value=w,n.offset=O,n.length=x,n.type=L,n.colonOffset=void 0,r=n}try{R(e,{onObjectBegin:(w,O)=>{if(a<=w)throw s;r=void 0,o=a>w,i.push("")},onObjectProperty:(w,O,x)=>{if(a<O||(h(w,O,x,"property"),i[i.length-1]=w,a<=O+x))throw s},onObjectEnd:(w,O)=>{if(a<=w)throw s;r=void 0,i.pop()},onArrayBegin:(w,O)=>{if(a<=w)throw s;r=void 0,i.push(0)},onArrayEnd:(w,O)=>{if(a<=w)throw s;r=void 0,i.pop()},onLiteralValue:(w,O,x)=>{if(a<O||(h(w,O,x,E(w)),a<=O+x))throw s},onSeparator:(w,O,x)=>{if(a<=O)throw s;if(w===":"&&r&&r.type==="property")r.colonOffset=O,o=!1,r=void 0;else if(w===","){const L=i[i.length-1];typeof L=="number"?i[i.length-1]=L+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(w){if(w!==s)throw w}return{path:i,previousNode:r,isAtPropertyKey:o,matches:w=>{let O=0;for(let x=0;O<w.length&&x<i.length;x++)if(w[O]===i[x]||w[O]==="*")O++;else if(w[O]!=="**")return!1;return O===w.length}}}function u(e,a=[],i=D.DEFAULT){let s=null,r=[];const n=[];function o(w){Array.isArray(r)?r.push(w):s!==null&&(r[s]=w)}return R(e,{onObjectBegin:()=>{const w={};o(w),n.push(r),r=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const w=[];o(w),n.push(r),r=w,s=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:o,onError:(w,O,x)=>{a.push({error:w,offset:O,length:x})}},i),r[0]}function S(e,a=[],i=D.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function n(w){return s.children.push(w),w}R(e,{onObjectBegin:w=>{s=n({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,O,x)=>{s=n({type:"property",offset:O,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:O,length:x,parent:s})},onObjectEnd:(w,O)=>{s.length=w+O-s.offset,s=s.parent,r(w+O)},onArrayBegin:(w,O)=>{s=n({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,O)=>{s.length=w+O-s.offset,s=s.parent,r(w+O)},onLiteralValue:(w,O,x)=>{n({type:E(w),offset:O,length:x,parent:s,value:w}),r(O+x)},onSeparator:(w,O,x)=>{s.type==="property"&&(w===":"?s.colonOffset=O:w===","&&r(O))},onError:(w,O,x)=>{a.push({error:w,offset:O,length:x})}},i);const h=s.children[0];return h&&delete h.parent,h}function g(e,a){if(!e)return;let i=e;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===s){i=n.children[1],r=!0;break}if(!r)return}else{const r=s;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}function T(e){if(!e.parent||!e.parent.children)return[];const a=T(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;a.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&a.push(i)}return a}function y(e){switch(e.type){case"array":return e.children.map(y);case"object":{const a=Object.create(null);for(const i of e.children){const s=i.children[1];s&&(a[i.children[0].value]=y(s))}return a}case"null":case"string":case"number":case"boolean":return e.value;default:return}}function f(e,a,i=!1){return a>=e.offset&&a<e.offset+e.length||i&&a===e.offset+e.length}function m(e,a,i=!1){if(f(e,a,i)){const s=e.children;if(Array.isArray(s))for(let r=0;r<s.length&&s[r].offset<=a;r++){const n=m(s[r],a,i);if(n)return n}return e}}function R(e,a,i=D.DEFAULT){const s=k(e,!1);function r(Q){return Q?()=>Q(s.getTokenOffset(),s.getTokenLength()):()=>!0}function n(Q){return Q?te=>Q(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=r(a.onObjectBegin),h=n(a.onObjectProperty),w=r(a.onObjectEnd),O=r(a.onArrayBegin),x=r(a.onArrayEnd),L=n(a.onLiteralValue),A=n(a.onSeparator),_=r(a.onComment),X=n(a.onError),Y=i&&i.disallowComments,ne=i&&i.allowTrailingComma;function ce(){for(;;){const Q=s.scan();switch(s.getTokenError()){case P.InvalidUnicode:ue(v.InvalidUnicode);break;case P.InvalidEscapeCharacter:ue(v.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:ue(v.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:Y||ue(v.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:ue(v.UnexpectedEndOfString);break;case P.InvalidCharacter:ue(v.InvalidCharacter);break}switch(Q){case b.LineCommentTrivia:case b.BlockCommentTrivia:Y?ue(v.InvalidCommentToken):_();break;case b.Unknown:ue(v.InvalidSymbol);break;case b.Trivia:case b.LineBreakTrivia:break;default:return Q}}}function ue(Q,te=[],F=[]){if(X(Q),te.length+F.length>0){let V=s.getToken();for(;V!==b.EOF;){if(te.indexOf(V)!==-1){ce();break}else if(F.indexOf(V)!==-1)break;V=ce()}}}function he(Q){const te=s.getTokenValue();return Q?L(te):h(te),ce(),!0}function B(){switch(s.getToken()){case b.NumericLiteral:{let Q=0;try{Q=JSON.parse(s.getTokenValue()),typeof Q!="number"&&(ue(v.InvalidNumberFormat),Q=0)}catch{ue(v.InvalidNumberFormat)}L(Q);break}case b.NullKeyword:L(null);break;case b.TrueKeyword:L(!0);break;case b.FalseKeyword:L(!1);break;default:return!1}return ce(),!0}function Z(){return s.getToken()!==b.StringLiteral?(ue(v.PropertyNameExpected,[],[b.CloseBraceToken,b.CommaToken]),!1):(he(!1),s.getToken()===b.ColonToken?(A(":"),ce(),G()||ue(v.ValueExpected,[],[b.CloseBraceToken,b.CommaToken])):ue(v.ColonExpected,[],[b.CloseBraceToken,b.CommaToken]),!0)}function z(){o(),ce();let Q=!1;for(;s.getToken()!==b.CloseBraceToken&&s.getToken()!==b.EOF;){if(s.getToken()===b.CommaToken){if(Q||ue(v.ValueExpected,[],[]),A(","),ce(),s.getToken()===b.CloseBraceToken&&ne)break}else Q&&ue(v.CommaExpected,[],[]);Z()||ue(v.ValueExpected,[],[b.CloseBraceToken,b.CommaToken]),Q=!0}return w(),s.getToken()!==b.CloseBraceToken?ue(v.CloseBraceExpected,[b.CloseBraceToken],[]):ce(),!0}function W(){O(),ce();let Q=!1;for(;s.getToken()!==b.CloseBracketToken&&s.getToken()!==b.EOF;){if(s.getToken()===b.CommaToken){if(Q||ue(v.ValueExpected,[],[]),A(","),ce(),s.getToken()===b.CloseBracketToken&&ne)break}else Q&&ue(v.CommaExpected,[],[]);G()||ue(v.ValueExpected,[],[b.CloseBracketToken,b.CommaToken]),Q=!0}return x(),s.getToken()!==b.CloseBracketToken?ue(v.CloseBracketExpected,[b.CloseBracketToken],[]):ce(),!0}function G(){switch(s.getToken()){case b.OpenBracketToken:return W();case b.OpenBraceToken:return z();case b.StringLiteral:return he(!0);default:return B()}}return ce(),s.getToken()===b.EOF?i.allowEmptyContent?!0:(ue(v.ValueExpected,[],[]),!1):G()?(s.getToken()!==b.EOF&&ue(v.EndOfFileExpected,[],[]),!0):(ue(v.ValueExpected,[],[]),!1)}function E(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[76],ae([0,1,34]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.format=b,t.toFormattedString=v,t.getEOL=C,t.isEOL=p;function b(c,l,d){let u,S,g,T,y;if(l){for(T=l.offset,y=T+l.length,g=T;g>0&&!p(c,g-1);)g--;let h=y;for(;h<c.length&&!p(c,h);)h++;S=c.substring(g,h),u=k(S,d)}else S=c,u=0,g=0,T=0,y=c.length;const f=C(d,c);let m=!1,R=0,E;d.insertSpaces?E=D(" ",d.tabSize||4):E="	";const e=(0,P.createScanner)(S,!1);let a=!1;function i(){return f+D(E,u+R)}function s(){let h=e.scan();for(m=!1;h===P.SyntaxKind.Trivia||h===P.SyntaxKind.LineBreakTrivia;)m=m||h===P.SyntaxKind.LineBreakTrivia,h=e.scan();return a=h===P.SyntaxKind.Unknown||e.getTokenError()!==P.ScanError.None,h}const r=[];function n(h,w,O){!a&&w<y&&O>T&&c.substring(w,O)!==h&&r.push({offset:w,length:O-w,content:h})}let o=s();if(o!==P.SyntaxKind.EOF){const h=e.getTokenOffset()+g,w=D(E,u);n(w,g,h)}for(;o!==P.SyntaxKind.EOF;){let h=e.getTokenOffset()+e.getTokenLength()+g,w=s(),O="";for(;!m&&(w===P.SyntaxKind.LineCommentTrivia||w===P.SyntaxKind.BlockCommentTrivia);){const L=e.getTokenOffset()+g;n(" ",h,L),h=e.getTokenOffset()+e.getTokenLength()+g,O=w===P.SyntaxKind.LineCommentTrivia?i():"",w=s()}if(w===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(R--,O=i());else if(w===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(R--,O=i());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:R++,O=i();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:O=i();break;case P.SyntaxKind.BlockCommentTrivia:m?O=i():O=" ";break;case P.SyntaxKind.ColonToken:O=" ";break;case P.SyntaxKind.StringLiteral:if(w===P.SyntaxKind.ColonToken){O="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:w===P.SyntaxKind.LineCommentTrivia||w===P.SyntaxKind.BlockCommentTrivia?O=" ":w!==P.SyntaxKind.CommaToken&&w!==P.SyntaxKind.EOF&&(a=!0);break;case P.SyntaxKind.Unknown:a=!0;break}m&&(w===P.SyntaxKind.LineCommentTrivia||w===P.SyntaxKind.BlockCommentTrivia)&&(O=i())}const x=e.getTokenOffset()+g;n(O,h,x),o=w}return r}function v(c,l){const d=JSON.stringify(c,void 0,l.insertSpaces?l.tabSize||4:"	");return l.eol!==void 0?d.replace(/\r\n|\r|\n/g,l.eol):d}function D(c,l){let d="";for(let u=0;u<l;u++)d+=c;return d}function k(c,l){let d=0,u=0;const S=l.tabSize||4;for(;d<c.length;){const g=c.charAt(d);if(g===" ")u++;else if(g==="	")u+=S;else break;d++}return Math.floor(u/S)}function C(c,l){for(let d=0;d<l.length;d++){const u=l.charAt(d);if(u==="\r")return d+1<l.length&&l.charAt(d+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return c&&c.eol||`
`}function p(c,l){return`\r
`.indexOf(c.charAt(l))!==-1}}),define(oe[77],ae([0,1,34,76]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeProperty=v,t.setProperty=D,t.withFormatting=k,t.applyEdit=C,t.applyEdits=p;function v(c,l,d){return D(c,l,void 0,d)}function D(c,l,d,u,S){const g=l.slice(),T=[],y=(0,P.parseTree)(c,T);let f,m;for(;g.length>0&&(m=g.pop(),f=(0,P.findNodeAtLocation)(y,g),f===void 0&&d!==void 0);)typeof m=="string"?d={[m]:d}:d=[d];if(f)if(f.type==="object"&&typeof m=="string"&&Array.isArray(f.children)){const R=(0,P.findNodeAtLocation)(f,[m]);if(R!==void 0)if(d===void 0){if(!R.parent)throw new Error("Malformed AST");const E=f.children.indexOf(R.parent);let e,a=R.parent.offset+R.parent.length;if(E>0){const i=f.children[E-1];e=i.offset+i.length}else e=f.offset+1,f.children.length>1&&(a=f.children[1].offset);return k(c,{offset:e,length:a-e,content:""},u)}else return k(c,{offset:R.offset,length:R.length,content:JSON.stringify(d)},u);else{if(d===void 0)return[];const E=`${JSON.stringify(m)}: ${JSON.stringify(d)}`,e=S?S(f.children.map(i=>i.children[0].value)):f.children.length;let a;if(e>0){const i=f.children[e-1];a={offset:i.offset+i.length,length:0,content:","+E}}else f.children.length===0?a={offset:f.offset+1,length:0,content:E}:a={offset:f.offset+1,length:0,content:E+","};return k(c,a,u)}}else if(f.type==="array"&&typeof m=="number"&&Array.isArray(f.children))if(d!==void 0){const R=`${JSON.stringify(d)}`;let E;if(f.children.length===0||m===0)E={offset:f.offset+1,length:0,content:f.children.length===0?R:R+","};else{const e=m===-1||m>f.children.length?f.children.length:m,a=f.children[e-1];E={offset:a.offset+a.length,length:0,content:","+R}}return k(c,E,u)}else{const R=m,E=f.children[R];let e;if(f.children.length===1)e={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===R){const a=f.children[R-1],i=a.offset+a.length,s=f.offset+f.length;e={offset:i,length:s-2-i,content:""}}else e={offset:E.offset,length:f.children[R+1].offset-E.offset,content:""};return k(c,e,u)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${f.type}`);else return d===void 0?[]:k(c,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(d)},u)}function k(c,l,d){let u=C(c,l),S=l.offset,g=l.offset+l.content.length;if(l.length===0||l.content.length===0){for(;S>0&&!(0,b.isEOL)(u,S-1);)S--;for(;g<u.length&&!(0,b.isEOL)(u,g);)g++}const T=(0,b.format)(u,{offset:S,length:g-S},d);for(let f=T.length-1;f>=0;f--){const m=T[f];u=C(u,m),S=Math.min(S,m.offset),g=Math.max(g,m.offset+m.length),g+=m.content.length-m.length}const y=c.length-(u.length-g)-S;return[{offset:S,length:y,content:u.substring(S,g)}]}function C(c,l){return c.substring(0,l.offset)+l.content+c.substring(l.offset+l.length)}function p(c,l){const d=l.slice(0).sort((S,g)=>{const T=S.offset-g.offset;return T===0?S.length-g.length:T});let u=c.length;for(let S=d.length-1;S>=0;S--){const g=d[S];if(g.offset+g.length<=u)c=C(c,g);else throw new Error("Overlapping edit");u=g.offset}return c}}),define(oe[78],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=P,t.rot=b,t.isPointWithinTriangle=C;function P(p,c,l){return Math.min(Math.max(p,c),l)}function b(p,c){return(c+p%c)%c}class v{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=v;class D{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=D;class k{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const l=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=k;function C(p,c,l,d,u,S,g,T){const y=g-l,f=T-d,m=u-l,R=S-d,E=p-l,e=c-d,a=y*y+f*f,i=y*m+f*R,s=y*E+f*e,r=m*m+R*R,n=m*E+R*e,o=1/(a*r-i*i),h=(r*s-i*n)*o,w=(a*n-i*s)*o;return h>=0&&w>=0&&h+w<1}}),function(){function q(v){const D=[];typeof v=="number"&&D.push("code/timeOrigin",v);function k(p){D.push(p,Date.now())}function C(){const p=[];for(let c=0;c<D.length;c+=2)p.push({name:D[c],startTime:D[c+1]});return p}return{mark:k,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(v+k.startTime)});return D}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function P(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=t()),v.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=P(b))}(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var P=t();for(var b in P)(typeof exports=="object"?exports:q)[b]=P[b]}}(typeof self<"u"?self:this,function(){return function(q){var t={};function P(b){if(t[b])return t[b].exports;var v=t[b]={i:b,l:!1,exports:{}};return q[b].call(v.exports,v,v.exports,P),v.l=!0,v.exports}return P.m=q,P.c=t,P.d=function(b,v,D){P.o(b,v)||Object.defineProperty(b,v,{enumerable:!0,get:D})},P.r=function(b){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},P.t=function(b,v){if(1&v&&(b=P(b)),8&v||4&v&&typeof b=="object"&&b&&b.__esModule)return b;var D=Object.create(null);if(P.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:b}),2&v&&typeof b!="string")for(var k in b)P.d(D,k,function(C){return b[C]}.bind(null,k));return D},P.n=function(b){var v=b&&b.__esModule?function(){return b.default}:function(){return b};return P.d(v,"a",v),v},P.o=function(b,v){return Object.prototype.hasOwnProperty.call(b,v)},P.p="",P(P.s=0)}([function(q,t,P){(function(b){var v;t=q.exports=V,v=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var $=Array.prototype.slice.call(arguments,0);$.unshift("SEMVER"),console.log.apply(console,$)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],p=t.src=[],c=0,l=c++;p[l]="0|[1-9]\\d*";var d=c++;p[d]="[0-9]+";var u=c++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=c++;p[S]="("+p[l]+")\\.("+p[l]+")\\.("+p[l]+")";var g=c++;p[g]="("+p[d]+")\\.("+p[d]+")\\.("+p[d]+")";var T=c++;p[T]="(?:"+p[l]+"|"+p[u]+")";var y=c++;p[y]="(?:"+p[d]+"|"+p[u]+")";var f=c++;p[f]="(?:-("+p[T]+"(?:\\."+p[T]+")*))";var m=c++;p[m]="(?:-?("+p[y]+"(?:\\."+p[y]+")*))";var R=c++;p[R]="[0-9A-Za-z-]+";var E=c++;p[E]="(?:\\+("+p[R]+"(?:\\."+p[R]+")*))";var e=c++,a="v?"+p[S]+p[f]+"?"+p[E]+"?";p[e]="^"+a+"$";var i="[v=\\s]*"+p[g]+p[m]+"?"+p[E]+"?",s=c++;p[s]="^"+i+"$";var r=c++;p[r]="((?:<|>)?=?)";var n=c++;p[n]=p[d]+"|x|X|\\*";var o=c++;p[o]=p[l]+"|x|X|\\*";var h=c++;p[h]="[v=\\s]*("+p[o]+")(?:\\.("+p[o]+")(?:\\.("+p[o]+")(?:"+p[f]+")?"+p[E]+"?)?)?";var w=c++;p[w]="[v=\\s]*("+p[n]+")(?:\\.("+p[n]+")(?:\\.("+p[n]+")(?:"+p[m]+")?"+p[E]+"?)?)?";var O=c++;p[O]="^"+p[r]+"\\s*"+p[h]+"$";var x=c++;p[x]="^"+p[r]+"\\s*"+p[w]+"$";var L=c++;p[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=c++;p[A]="(?:~>?)";var _=c++;p[_]="(\\s*)"+p[A]+"\\s+",C[_]=new RegExp(p[_],"g");var X=c++;p[X]="^"+p[A]+p[h]+"$";var Y=c++;p[Y]="^"+p[A]+p[w]+"$";var ne=c++;p[ne]="(?:\\^)";var ce=c++;p[ce]="(\\s*)"+p[ne]+"\\s+",C[ce]=new RegExp(p[ce],"g");var ue=c++;p[ue]="^"+p[ne]+p[h]+"$";var he=c++;p[he]="^"+p[ne]+p[w]+"$";var B=c++;p[B]="^"+p[r]+"\\s*("+i+")$|^$";var Z=c++;p[Z]="^"+p[r]+"\\s*("+a+")$|^$";var z=c++;p[z]="(\\s*)"+p[r]+"\\s*("+i+"|"+p[h]+")",C[z]=new RegExp(p[z],"g");var W=c++;p[W]="^\\s*("+p[h]+")\\s+-\\s+("+p[h]+")\\s*$";var G=c++;p[G]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var Q=c++;p[Q]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)v(te,p[te]),C[te]||(C[te]=new RegExp(p[te]));function F($,ee){if($ instanceof V)return $;if(typeof $!="string"||$.length>D||!(ee?C[s]:C[e]).test($))return null;try{return new V($,ee)}catch{return null}}function V($,ee){if($ instanceof V){if($.loose===ee)return $;$=$.version}else if(typeof $!="string")throw new TypeError("Invalid Version: "+$);if($.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof V))return new V($,ee);v("SemVer",$,ee),this.loose=ee;var ie=$.trim().match(ee?C[s]:C[e]);if(!ie)throw new TypeError("Invalid Version: "+$);if(this.raw=$,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Pe=+ve;if(Pe>=0&&Pe<k)return Pe}return ve}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}t.parse=F,t.valid=function($,ee){var ie=F($,ee);return ie?ie.version:null},t.clean=function($,ee){var ie=F($.trim().replace(/^[=v]+/,""),ee);return ie?ie.version:null},t.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function($){return v("SemVer.compare",this.version,this.loose,$),$ instanceof V||($=new V($,this.loose)),this.compareMain($)||this.comparePre($)},V.prototype.compareMain=function($){return $ instanceof V||($=new V($,this.loose)),j(this.major,$.major)||j(this.minor,$.minor)||j(this.patch,$.patch)},V.prototype.comparePre=function($){if($ instanceof V||($=new V($,this.loose)),this.prerelease.length&&!$.prerelease.length)return-1;if(!this.prerelease.length&&$.prerelease.length)return 1;if(!this.prerelease.length&&!$.prerelease.length)return 0;var ee=0;do{var ie=this.prerelease[ee],ve=$.prerelease[ee];if(v("prerelease compare",ee,ie,ve),ie===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(ie===void 0)return-1;if(ie!==ve)return j(ie,ve)}while(++ee)},V.prototype.inc=function($,ee){switch($){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+$)}return this.format(),this.raw=this.version,this},t.inc=function($,ee,ie,ve){typeof ie=="string"&&(ve=ie,ie=void 0);try{return new V($,ie).inc(ee,ve).version}catch{return null}},t.diff=function($,ee){if(N($,ee))return null;var ie=F($),ve=F(ee);if(ie.prerelease.length||ve.prerelease.length){for(var Pe in ie)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ie[Pe]!==ve[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ie)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ie[Pe]!==ve[Pe])return Pe},t.compareIdentifiers=j;var K=/^[0-9]+$/;function j($,ee){var ie=K.test($),ve=K.test(ee);return ie&&ve&&($=+$,ee=+ee),ie&&!ve?-1:ve&&!ie?1:$<ee?-1:$>ee?1:0}function I($,ee,ie){return new V($,ie).compare(new V(ee,ie))}function M($,ee,ie){return I($,ee,ie)>0}function U($,ee,ie){return I($,ee,ie)<0}function N($,ee,ie){return I($,ee,ie)===0}function H($,ee,ie){return I($,ee,ie)!==0}function J($,ee,ie){return I($,ee,ie)>=0}function re($,ee,ie){return I($,ee,ie)<=0}function le($,ee,ie,ve){var Pe;switch(ee){case"===":typeof $=="object"&&($=$.version),typeof ie=="object"&&(ie=ie.version),Pe=$===ie;break;case"!==":typeof $=="object"&&($=$.version),typeof ie=="object"&&(ie=ie.version),Pe=$!==ie;break;case"":case"=":case"==":Pe=N($,ie,ve);break;case"!=":Pe=H($,ie,ve);break;case">":Pe=M($,ie,ve);break;case">=":Pe=J($,ie,ve);break;case"<":Pe=U($,ie,ve);break;case"<=":Pe=re($,ie,ve);break;default:throw new TypeError("Invalid operator: "+ee)}return Pe}function ge($,ee){if($ instanceof ge){if($.loose===ee)return $;$=$.value}if(!(this instanceof ge))return new ge($,ee);v("comparator",$,ee),this.loose=ee,this.parse($),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}t.rcompareIdentifiers=function($,ee){return j(ee,$)},t.major=function($,ee){return new V($,ee).major},t.minor=function($,ee){return new V($,ee).minor},t.patch=function($,ee){return new V($,ee).patch},t.compare=I,t.compareLoose=function($,ee){return I($,ee,!0)},t.rcompare=function($,ee,ie){return I(ee,$,ie)},t.sort=function($,ee){return $.sort(function(ie,ve){return t.compare(ie,ve,ee)})},t.rsort=function($,ee){return $.sort(function(ie,ve){return t.rcompare(ie,ve,ee)})},t.gt=M,t.lt=U,t.eq=N,t.neq=H,t.gte=J,t.lte=re,t.cmp=le,t.Comparator=ge;var pe={};function me($,ee){if($ instanceof me)return $.loose===ee?$:new me($.raw,ee);if($ instanceof ge)return new me($.value,ee);if(!(this instanceof me))return new me($,ee);if(this.loose=ee,this.raw=$,this.set=$.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$);this.format()}function Se($){return!$||$.toLowerCase()==="x"||$==="*"}function de($,ee,ie,ve,Pe,ke,Re,Ne,Oe,Ae,We,Le,xe){return((ee=Se(ie)?"":Se(ve)?">="+ie+".0.0":Se(Pe)?">="+ie+"."+ve+".0":">="+ee)+" "+(Ne=Se(Oe)?"":Se(Ae)?"<"+(+Oe+1)+".0.0":Se(We)?"<"+Oe+"."+(+Ae+1)+".0":Le?"<="+Oe+"."+Ae+"."+We+"-"+Le:"<="+Ne)).trim()}function fe($,ee){for(var ie=0;ie<$.length;ie++)if(!$[ie].test(ee))return!1;if(ee.prerelease.length){for(ie=0;ie<$.length;ie++)if(v($[ie].semver),$[ie].semver!==pe&&$[ie].semver.prerelease.length>0){var ve=$[ie].semver;if(ve.major===ee.major&&ve.minor===ee.minor&&ve.patch===ee.patch)return!0}return!1}return!0}function ye($,ee,ie){try{ee=new me(ee,ie)}catch{return!1}return ee.test($)}function Ie($,ee,ie,ve){var Pe,ke,Re,Ne,Oe;switch($=new V($,ve),ee=new me(ee,ve),ie){case">":Pe=M,ke=re,Re=U,Ne=">",Oe=">=";break;case"<":Pe=U,ke=J,Re=M,Ne="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye($,ee,ve))return!1;for(var Ae=0;Ae<ee.set.length;++Ae){var We=ee.set[Ae],Le=null,xe=null;if(We.forEach(function(Fe){Fe.semver===pe&&(Fe=new ge(">=0.0.0")),Le=Le||Fe,xe=xe||Fe,Pe(Fe.semver,Le.semver,ve)?Le=Fe:Re(Fe.semver,xe.semver,ve)&&(xe=Fe)}),Le.operator===Ne||Le.operator===Oe||(!xe.operator||xe.operator===Ne)&&ke($,xe.semver)||xe.operator===Oe&&Re($,xe.semver))return!1}return!0}ge.prototype.parse=function($){var ee=this.loose?C[B]:C[Z],ie=$.match(ee);if(!ie)throw new TypeError("Invalid comparator: "+$);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new V(ie[2],this.loose):this.semver=pe},ge.prototype.toString=function(){return this.value},ge.prototype.test=function($){return v("Comparator.test",$,this.loose),this.semver===pe||(typeof $=="string"&&($=new V($,this.loose)),le($,this.operator,this.semver,this.loose))},ge.prototype.intersects=function($,ee){if(!($ instanceof ge))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new me($.value,ee),ye(this.value,ie,ee);if($.operator==="")return ie=new me(this.value,ee),ye($.semver,ie,ee);var ve=!(this.operator!==">="&&this.operator!==">"||$.operator!==">="&&$.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||$.operator!=="<="&&$.operator!=="<"),ke=this.semver.version===$.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||$.operator!==">="&&$.operator!=="<="),Ne=le(this.semver,"<",$.semver,ee)&&(this.operator===">="||this.operator===">")&&($.operator==="<="||$.operator==="<"),Oe=le(this.semver,">",$.semver,ee)&&(this.operator==="<="||this.operator==="<")&&($.operator===">="||$.operator===">");return ve||Pe||ke&&Re||Ne||Oe},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function($){return $.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function($){var ee=this.loose;$=$.trim(),v("range",$,ee);var ie=ee?C[G]:C[W];$=$.replace(ie,de),v("hyphen replace",$),$=$.replace(C[z],"$1$2$3"),v("comparator trim",$,C[z]),$=($=($=$.replace(C[_],"$1~")).replace(C[ce],"$1^")).split(/\s+/).join(" ");var ve=ee?C[B]:C[Z],Pe=$.split(" ").map(function(ke){return function(Re,Ne){return v("comp",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,xe){v("caret",Le,xe);var Fe=xe?C[he]:C[ue];return Le.replace(Fe,function(Ue,be,Ce,De,Te){var Me;return v("caret",Le,Ue,be,Ce,De,Te),Se(be)?Me="":Se(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":Se(De)?Me=be==="0"?">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+".0 <"+(+be+1)+".0.0":Te?(v("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+Te+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+Te+" <"+(+be+1)+".0.0"):(v("no pr"),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+" <"+(+be+1)+".0.0"),v("caret return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),v("caret",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,xe){var Fe=xe?C[Y]:C[X];return Le.replace(Fe,function(Ue,be,Ce,De,Te){var Me;return v("tilde",Le,Ue,be,Ce,De,Te),Se(be)?Me="":Se(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":Se(De)?Me=">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":Te?(v("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0"):Me=">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0",v("tilde return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),v("tildes",Re),Re=function(Oe,Ae){return v("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(We){return function(Le,xe){Le=Le.trim();var Fe=xe?C[x]:C[O];return Le.replace(Fe,function(Ue,be,Ce,De,Te,Me){v("xRange",Le,Ue,be,Ce,De,Te,Me);var je=Se(Ce),_e=je||Se(De),ze=_e||Se(Te);return be==="="&&ze&&(be=""),je?Ue=be===">"||be==="<"?"<0.0.0":"*":be&&ze?(_e&&(De=0),ze&&(Te=0),be===">"?(be=">=",_e?(Ce=+Ce+1,De=0,Te=0):ze&&(De=+De+1,Te=0)):be==="<="&&(be="<",_e?Ce=+Ce+1:De=+De+1),Ue=be+Ce+"."+De+"."+Te):_e?Ue=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ze&&(Ue=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0"),v("xRange return",Ue),Ue})}(We,Ae)}).join(" ")}(Re,Ne),v("xrange",Re),Re=function(Oe,Ae){return v("replaceStars",Oe,Ae),Oe.trim().replace(C[Q],"")}(Re,Ne),v("stars",Re),Re}(ke,ee)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ke){return!!ke.match(ve)})),Pe=Pe.map(function(ke){return new ge(ke,ee)})},me.prototype.intersects=function($,ee){if(!($ instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(ve){return $.set.some(function(Pe){return Pe.every(function(ke){return ve.intersects(ke,ee)})})})})},t.toComparators=function($,ee){return new me($,ee).set.map(function(ie){return ie.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},me.prototype.test=function($){if(!$)return!1;typeof $=="string"&&($=new V($,this.loose));for(var ee=0;ee<this.set.length;ee++)if(fe(this.set[ee],$))return!0;return!1},t.satisfies=ye,t.maxSatisfying=function($,ee,ie){var ve=null,Pe=null;try{var ke=new me(ee,ie)}catch{return null}return $.forEach(function(Re){ke.test(Re)&&(ve&&Pe.compare(Re)!==-1||(Pe=new V(ve=Re,ie)))}),ve},t.minSatisfying=function($,ee,ie){var ve=null,Pe=null;try{var ke=new me(ee,ie)}catch{return null}return $.forEach(function(Re){ke.test(Re)&&(ve&&Pe.compare(Re)!==1||(Pe=new V(ve=Re,ie)))}),ve},t.validRange=function($,ee){try{return new me($,ee).range||"*"}catch{return null}},t.ltr=function($,ee,ie){return Ie($,ee,"<",ie)},t.gtr=function($,ee,ie){return Ie($,ee,">",ie)},t.outside=Ie,t.prerelease=function($,ee){var ie=F($,ee);return ie&&ie.prerelease.length?ie.prerelease:null},t.intersects=function($,ee,ie){return $=new me($,ie),ee=new me(ee,ie),$.intersects(ee)},t.coerce=function($){if($ instanceof V)return $;if(typeof $!="string")return null;var ee=$.match(C[L]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,P(1))},function(q,t){var P,b,v=q.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function C(y){if(P===setTimeout)return setTimeout(y,0);if((P===D||!P)&&setTimeout)return P=setTimeout,setTimeout(y,0);try{return P(y,0)}catch{try{return P.call(null,y,0)}catch{return P.call(this,y,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:D}catch{P=D}try{b=typeof clearTimeout=="function"?clearTimeout:k}catch{b=k}})();var p,c=[],l=!1,d=-1;function u(){l&&p&&(l=!1,p.length?c=p.concat(c):d=-1,c.length&&S())}function S(){if(!l){var y=C(u);l=!0;for(var f=c.length;f;){for(p=c,c=[];++d<f;)p&&p[d].run();d=-1,f=c.length}p=null,l=!1,function(m){if(b===clearTimeout)return clearTimeout(m);if((b===k||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(m);try{b(m)}catch{try{return b.call(null,m)}catch{return b.call(this,m)}}}(y)}}function g(y,f){this.fun=y,this.array=f}function T(){}v.nextTick=function(y){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];c.push(new g(y,f)),c.length!==1||l||C(S)},g.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=T,v.addListener=T,v.once=T,v.off=T,v.removeListener=T,v.removeAllListeners=T,v.emit=T,v.prependListener=T,v.prependOnceListener=T,v.listeners=function(y){return[]},v.binding=function(y){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(y){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(oe[79],ae([0,1]),function(q,t){"use strict";var P;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class b{constructor(C,p,c){this.level=C,this.key=p,this.value=c,this.forward=[]}}const v=void 0;class D{constructor(C,p=2**16){this.comparator=C,this[P]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new b(this._maxLevel,v,v)}get size(){return this._size}clear(){this._header=new b(this._maxLevel,v,v),this._size=0}has(C){return!!D._search(this,C,this.comparator)}get(C){return D._search(this,C,this.comparator)?.value}set(C,p){return D._insert(this,C,p,this.comparator)&&(this._size+=1),this}delete(C){const p=D._delete(this,C,this.comparator);return p&&(this._size-=1),p}forEach(C,p){let c=this._header.forward[0];for(;c;)C.call(p,c.value,c.key,this),c=c.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",p=this._header.forward[0];for(;p;)C+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return C}static _search(C,p,c){let l=C._header;for(let d=C._level-1;d>=0;d--)for(;l.forward[d]&&c(l.forward[d].key,p)<0;)l=l.forward[d];if(l=l.forward[0],l&&c(l.key,p)===0)return l}static _insert(C,p,c,l){const d=[];let u=C._header;for(let S=C._level-1;S>=0;S--){for(;u.forward[S]&&l(u.forward[S].key,p)<0;)u=u.forward[S];d[S]=u}if(u=u.forward[0],u&&l(u.key,p)===0)return u.value=c,!1;{const S=D._randomLevel(C);if(S>C._level){for(let g=C._level;g<S;g++)d[g]=C._header;C._level=S}u=new b(S,p,c);for(let g=0;g<S;g++)u.forward[g]=d[g].forward[g],d[g].forward[g]=u;return!0}}static _randomLevel(C,p=.5){let c=1;for(;Math.random()<p&&c<C._maxLevel;)c+=1;return c}static _delete(C,p,c){const l=[];let d=C._header;for(let u=C._level-1;u>=0;u--){for(;d.forward[u]&&c(d.forward[u].key,p)<0;)d=d.forward[u];l[u]=d}if(d=d.forward[0],!d||c(d.key,p)!==0)return!1;for(let u=0;u<C._level&&l[u].forward[u]===d;u++)l[u].forward[u]=d.forward[u];for(;C._level>0&&C._header.forward[C._level-1]===v;)C._level-=1;return!0}}t.SkipList=D}),define(oe[47],ae([0,1,9,2]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=v,t.isReadableStream=D,t.isReadableBufferedStream=k,t.newWriteableStream=C,t.consumeReadable=c,t.peekReadable=l,t.consumeStream=d,t.listenStream=u,t.peekStream=S,t.toStream=g,t.emptyStream=T,t.toReadable=y,t.transform=f,t.prefixedReadable=m,t.prefixedStream=R;function v(E){const e=E;return e?typeof e.read=="function":!1}function D(E){const e=E;return e?[e.on,e.pause,e.resume,e.destroy].every(a=>typeof a=="function"):!1}function k(E){const e=E;return e?D(e.stream)&&Array.isArray(e.buffer)&&typeof e.ended=="boolean":!1}function C(E,e){return new p(E,e)}class p{constructor(e,a){this.reducer=e,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){if(!this.state.destroyed){if(this.state.flowing)this.emitData(e);else if(this.buffer.data.push(e),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(e){this.state.destroyed||(this.state.flowing?this.emitError(e):this.buffer.error.push(e))}end(e){this.state.destroyed||(typeof e<"u"&&this.write(e),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(e){this.listeners.data.slice(0).forEach(a=>a(e))}emitError(e){this.listeners.error.length===0?(0,P.onUnexpectedError)(e):this.listeners.error.slice(0).forEach(a=>a(e))}emitEnd(){this.listeners.end.slice(0).forEach(e=>e())}on(e,a){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(e,a){if(this.state.destroyed)return;let i;switch(e){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(a);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.emitData(e),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.emitError(e);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,e){const a=[];let i;for(;(i=E.read())!==null;)a.push(i);return e(a)}function l(E,e,a){const i=[];let s;for(;(s=E.read())!==null&&i.length<a;)i.push(s);return s===null&&i.length>0?e(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const r=s;return s=void 0,r}return E.read()}}}function d(E,e){return new Promise((a,i)=>{const s=[];u(E,{onData:r=>{e&&s.push(r)},onError:r=>{e?i(r):a(void 0)},onEnd:()=>{a(e?e(s):void 0)}})})}function u(E,e,a){E.on("error",i=>{a?.isCancellationRequested||e.onError(i)}),E.on("end",()=>{a?.isCancellationRequested||e.onEnd()}),E.on("data",i=>{a?.isCancellationRequested||e.onData(i)})}function S(E,e){return new Promise((a,i)=>{const s=new b.DisposableStore,r=[],n=w=>{if(r.push(w),r.length>e)return s.dispose(),E.pause(),a({stream:E,buffer:r,ended:!1})},o=w=>(s.dispose(),i(w)),h=()=>(s.dispose(),a({stream:E,buffer:r,ended:!0}));s.add((0,b.toDisposable)(()=>E.removeListener("error",o))),E.on("error",o),s.add((0,b.toDisposable)(()=>E.removeListener("end",h))),E.on("end",h),s.add((0,b.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}function g(E,e){const a=C(e);return a.end(E),a}function T(){const E=C(()=>{throw new Error("not supported")});return E.end(),E}function y(E){let e=!1;return{read:()=>e?null:(e=!0,E)}}function f(E,e,a){const i=C(a);return u(E,{onData:s=>i.write(e.data(s)),onError:s=>i.error(e.error?e.error(s):s),onEnd:()=>i.end()}),i}function m(E,e,a){let i=!1;return{read:()=>{const s=e.read();return i?s:(i=!0,s!==null?a([E,s]):E)}}}function R(E,e,a){let i=!1;const s=C(a);return u(e,{onData:r=>i?s.write(r):(i=!0,s.write(a([E,r]))),onError:r=>s.error(r),onEnd:()=>{i||(i=!0,s.write(E)),s.end()}}),s}});var $e=this&&this.__createBinding||(Object.create?function(q,t,P,b){b===void 0&&(b=P);var v=Object.getOwnPropertyDescriptor(t,P);(!v||("get"in v?!t.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return t[P]}}),Object.defineProperty(q,b,v)}:function(q,t,P,b){b===void 0&&(b=P),q[b]=t[P]}),Be=this&&this.__setModuleDefault||(Object.create?function(q,t){Object.defineProperty(q,"default",{enumerable:!0,value:t})}:function(q,t){q.default=t}),we=this&&this.__importStar||function(q){if(q&&q.__esModule)return q;var t={};if(q!=null)for(var P in q)P!=="default"&&Object.prototype.hasOwnProperty.call(q,P)&&$e(t,q,P);return Be(t,q),t};define(oe[14],ae([0,1,171,47]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=c,t.readUInt16LE=l,t.writeUInt16LE=d,t.readUInt32BE=u,t.writeUInt32BE=S,t.readUInt32LE=g,t.writeUInt32LE=T,t.readUInt8=y,t.writeUInt8=f,t.readableToBuffer=m,t.bufferToReadable=R,t.streamToBuffer=E,t.bufferedStreamToBuffer=e,t.bufferToStream=a,t.streamToBufferReadableStream=i,t.newWriteableBufferStream=s,t.prefixedBufferReadable=r,t.prefixedBufferStream=n,t.decodeBase64=o,t.encodeBase64=O,b=we(b);const v=typeof Buffer<"u",D=new P.Lazy(()=>new Uint8Array(256));let k,C;class p{static alloc(L){return v?new p(Buffer.allocUnsafe(L)):new p(new Uint8Array(L))}static wrap(L){return v&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new p(L)}static fromString(L,A){return!(A?.dontUseNodeBuffer||!1)&&v?new p(Buffer.from(L)):(k||(k=new TextEncoder),new p(k.encode(L)))}static fromByteArray(L){const A=p.alloc(L.length);for(let _=0,X=L.length;_<X;_++)A.buffer[_]=L[_];return A}static concat(L,A){if(typeof A>"u"){A=0;for(let Y=0,ne=L.length;Y<ne;Y++)A+=L[Y].byteLength}const _=p.alloc(A);let X=0;for(let Y=0,ne=L.length;Y<ne;Y++){const ce=L[Y];_.set(ce,X),X+=ce.byteLength}return _}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=p.alloc(this.byteLength);return L.set(this),L}toString(){return v?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(L,A){return new p(this.buffer.subarray(L,A))}set(L,A){if(L instanceof p)this.buffer.set(L.buffer,A);else if(L instanceof Uint8Array)this.buffer.set(L,A);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),A);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return u(this.buffer,L)}writeUInt32BE(L,A){S(this.buffer,L,A)}readUInt32LE(L){return g(this.buffer,L)}writeUInt32LE(L,A){T(this.buffer,L,A)}readUInt8(L){return y(this.buffer,L)}writeUInt8(L,A){f(this.buffer,L,A)}indexOf(L,A=0){return c(this.buffer,L instanceof p?L.buffer:L,A)}}t.VSBuffer=p;function c(x,L,A=0){const _=L.byteLength,X=x.byteLength;if(_===0)return 0;if(_===1)return x.indexOf(L[0]);if(_>X-A)return-1;const Y=D.value;Y.fill(L.length);for(let he=0;he<L.length;he++)Y[L[he]]=L.length-he-1;let ne=A+L.length-1,ce=ne,ue=-1;for(;ne<X;)if(x[ne]===L[ce]){if(ce===0){ue=ne;break}ne--,ce--}else ne+=Math.max(L.length-ce,Y[x[ne]]),ce=L.length-1;return ue}function l(x,L){return x[L+0]<<0>>>0|x[L+1]<<8>>>0}function d(x,L,A){x[A+0]=L&255,L=L>>>8,x[A+1]=L&255}function u(x,L){return x[L]*2**24+x[L+1]*2**16+x[L+2]*2**8+x[L+3]}function S(x,L,A){x[A+3]=L,L=L>>>8,x[A+2]=L,L=L>>>8,x[A+1]=L,L=L>>>8,x[A]=L}function g(x,L){return x[L+0]<<0>>>0|x[L+1]<<8>>>0|x[L+2]<<16>>>0|x[L+3]<<24>>>0}function T(x,L,A){x[A+0]=L&255,L=L>>>8,x[A+1]=L&255,L=L>>>8,x[A+2]=L&255,L=L>>>8,x[A+3]=L&255}function y(x,L){return x[L]}function f(x,L,A){x[A]=L}function m(x){return b.consumeReadable(x,L=>p.concat(L))}function R(x){return b.toReadable(x)}function E(x){return b.consumeStream(x,L=>p.concat(L))}async function e(x){return x.ended?p.concat(x.buffer):p.concat([...x.buffer,await E(x.stream)])}function a(x){return b.toStream(x,L=>p.concat(L))}function i(x){return b.transform(x,{data:L=>typeof L=="string"?p.fromString(L):p.wrap(L)},L=>p.concat(L))}function s(x){return b.newWriteableStream(L=>p.concat(L),x)}function r(x,L){return b.prefixedReadable(x,L,A=>p.concat(A))}function n(x,L){return b.prefixedStream(x,L,A=>p.concat(A))}function o(x){let L=0,A=0,_=0;const X=new Uint8Array(Math.floor(x.length/4*3)),Y=ce=>{switch(A){case 3:X[_++]=L|ce,A=0;break;case 2:X[_++]=L|ce>>>2,L=ce<<6,A=3;break;case 1:X[_++]=L|ce>>>4,L=ce<<4,A=2;break;default:L=ce<<2,A=1}};for(let ce=0;ce<x.length;ce++){const ue=x.charCodeAt(ce);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${x[ce]}`)}}const ne=_;for(;A>0;)Y(0);return p.wrap(X).slice(0,ne)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:x},L=!0,A=!1){const _=A?w:h;let X="";const Y=x.byteLength%3;let ne=0;for(;ne<x.byteLength-Y;ne+=3){const ce=x[ne+0],ue=x[ne+1],he=x[ne+2];X+=_[ce>>>2],X+=_[(ce<<4|ue>>>4)&63],X+=_[(ue<<2|he>>>6)&63],X+=_[he&63]}if(Y===1){const ce=x[ne+0];X+=_[ce>>>2],X+=_[ce<<4&63],L&&(X+="==")}else if(Y===2){const ce=x[ne+0],ue=x[ne+1];X+=_[ce>>>2],X+=_[(ce<<4|ue>>>4)&63],X+=_[ue<<2&63],L&&(X+="=")}return X}}),define(oe[28],ae([0,1,3]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=b,t.deepFreeze=v,t.cloneAndChange=k,t.mixin=p,t.equals=c,t.safeStringify=l,t.distinct=d,t.getCaseInsensitive=u,t.filter=S,t.getAllPropertyNames=g,t.getAllMethodNames=T,t.createProxyObject=y,t.mapValues=f;function b(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const R=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([E,e])=>{R[E]=e&&typeof e=="object"?b(e):e}),R}function v(m){if(!m||typeof m!="object")return m;const R=[m];for(;R.length>0;){const E=R.shift();Object.freeze(E);for(const e in E)if(D.call(E,e)){const a=E[e];typeof a=="object"&&!Object.isFrozen(a)&&!(0,P.isTypedArray)(a)&&R.push(a)}}return m}const D=Object.prototype.hasOwnProperty;function k(m,R){return C(m,R,new Set)}function C(m,R,E){if((0,P.isUndefinedOrNull)(m))return m;const e=R(m);if(typeof e<"u")return e;if(Array.isArray(m)){const a=[];for(const i of m)a.push(C(i,R,E));return a}if((0,P.isObject)(m)){if(E.has(m))throw new Error("Cannot clone recursive data-structure");E.add(m);const a={};for(const i in m)D.call(m,i)&&(a[i]=C(m[i],R,E));return E.delete(m),a}return m}function p(m,R,E=!0){return(0,P.isObject)(m)?((0,P.isObject)(R)&&Object.keys(R).forEach(e=>{e in m?E&&((0,P.isObject)(m[e])&&(0,P.isObject)(R[e])?p(m[e],R[e],E):m[e]=R[e]):m[e]=R[e]}),m):R}function c(m,R){if(m===R)return!0;if(m==null||R===null||R===void 0||typeof m!=typeof R||typeof m!="object"||Array.isArray(m)!==Array.isArray(R))return!1;let E,e;if(Array.isArray(m)){if(m.length!==R.length)return!1;for(E=0;E<m.length;E++)if(!c(m[E],R[E]))return!1}else{const a=[];for(e in m)a.push(e);a.sort();const i=[];for(e in R)i.push(e);if(i.sort(),!c(a,i))return!1;for(E=0;E<a.length;E++)if(!c(m[a[E]],R[a[E]]))return!1}return!0}function l(m){const R=new Set;return JSON.stringify(m,(E,e)=>{if((0,P.isObject)(e)||Array.isArray(e)){if(R.has(e))return"[Circular]";R.add(e)}return typeof e=="bigint"?`[BigInt ${e.toString()}]`:e})}function d(m,R){const E=Object.create(null);return!m||!R||Object.keys(R).forEach(a=>{const i=m[a],s=R[a];c(i,s)||(E[a]=s)}),E}function u(m,R){const E=R.toLowerCase(),e=Object.keys(m).find(a=>a.toLowerCase()===E);return e?m[e]:m[R]}function S(m,R){const E=Object.create(null);for(const[e,a]of Object.entries(m))R(e,a)&&(E[e]=a);return E}function g(m){let R=[];for(;Object.prototype!==m;)R=R.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return R}function T(m){const R=[];for(const E of g(m))typeof m[E]=="function"&&R.push(E);return R}function y(m,R){const E=a=>function(){const i=Array.prototype.slice.call(arguments,0);return R(a,i)},e={};for(const a of m)e[a]=E(a);return e}function f(m,R){const E={};for(const[e,a]of Object.entries(m))E[e]=R(a,e);return E}}),define(oe[43],ae([0,1,32]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=b,t.doHash=v,t.numberHash=D,t.stringHash=C,t.toHexString=T,P=we(P);function b(f){return v(f,0)}function v(f,m){switch(typeof f){case"object":return f===null?D(349,m):Array.isArray(f)?p(f,m):c(f,m);case"string":return C(f,m);case"boolean":return k(f,m);case"number":return D(f,m);case"undefined":return D(937,m);default:return D(617,m)}}function D(f,m){return(m<<5)-m+f|0}function k(f,m){return D(f?433:863,m)}function C(f,m){m=D(149417,m);for(let R=0,E=f.length;R<E;R++)m=D(f.charCodeAt(R),m);return m}function p(f,m){return m=D(104579,m),f.reduce((R,E)=>v(E,R),m)}function c(f,m){return m=D(181387,m),Object.keys(f).sort().reduce((R,E)=>(R=C(E,R),v(f[E],R)),m)}class l{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=v(m,this._value),this._value}}t.Hasher=l;var d;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function u(f,m,R=32){const E=R-m,e=~((1<<E)-1);return(f<<m|(e&f)>>>E)>>>0}function S(f,m=0,R=f.byteLength,E=0){for(let e=0;e<R;e++)f[m+e]=E}function g(f,m,R="0"){for(;f.length<m;)f=R+f;return f}function T(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(R=>R.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),m/4)}class y{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(d.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const R=m.length;if(R===0)return;const E=this._buff;let e=this._buffLen,a=this._leftoverHighSurrogate,i,s;for(a!==0?(i=a,s=-1,a=0):(i=m.charCodeAt(0),s=0);;){let r=i;if(P.isHighSurrogate(i))if(s+1<R){const n=m.charCodeAt(s+1);P.isLowSurrogate(n)?(s++,r=P.computeCodePoint(i,n)):r=d.UNICODE_REPLACEMENT}else{a=i;break}else P.isLowSurrogate(i)&&(r=d.UNICODE_REPLACEMENT);if(e=this._push(E,e,r),s++,s<R)i=m.charCodeAt(s);else break}this._buffLen=e,this._leftoverHighSurrogate=a}_push(m,R,E){return E<128?m[R++]=E:E<2048?(m[R++]=192|(E&1984)>>>6,m[R++]=128|(E&63)>>>0):E<65536?(m[R++]=224|(E&61440)>>>12,m[R++]=128|(E&4032)>>>6,m[R++]=128|(E&63)>>>0):(m[R++]=240|(E&1835008)>>>18,m[R++]=128|(E&258048)>>>12,m[R++]=128|(E&4032)>>>6,m[R++]=128|(E&63)>>>0),R>=d.BLOCK_SIZE&&(this._step(),R-=d.BLOCK_SIZE,this._totalLen+=d.BLOCK_SIZE,m[0]=m[d.BLOCK_SIZE+0],m[1]=m[d.BLOCK_SIZE+1],m[2]=m[d.BLOCK_SIZE+2]),R}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,d.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),T(this._h0)+T(this._h1)+T(this._h2)+T(this._h3)+T(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=y._bigBlock32,R=this._buffDV;for(let h=0;h<64;h+=4)m.setUint32(h,R.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)m.setUint32(h,u(m.getUint32(h-12,!1)^m.getUint32(h-32,!1)^m.getUint32(h-56,!1)^m.getUint32(h-64,!1),1),!1);let E=this._h0,e=this._h1,a=this._h2,i=this._h3,s=this._h4,r,n,o;for(let h=0;h<80;h++)h<20?(r=e&a|~e&i,n=1518500249):h<40?(r=e^a^i,n=1859775393):h<60?(r=e&a|e&i|a&i,n=2400959708):(r=e^a^i,n=3395469782),o=u(E,5)+r+s+n+m.getUint32(h*4,!1)&4294967295,s=i,i=a,a=u(e,30),e=E,E=o;this._h0=this._h0+E&4294967295,this._h1=this._h1+e&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}t.StringSHA1=y}),define(oe[56],ae([0,1,32]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),P=we(P);var b;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(b||(b={})),function(v){const D="error",k="warning",C="warn",p="info",c="ignore";function l(u){return u?P.equalsIgnoreCase(D,u)?v.Error:P.equalsIgnoreCase(k,u)||P.equalsIgnoreCase(C,u)?v.Warning:P.equalsIgnoreCase(p,u)?v.Info:v.Ignore:v.Ignore}v.fromValue=l;function d(u){switch(u){case v.Error:return D;case v.Warning:return k;case v.Info:return p;default:return c}}v.toString=d}(b||(b={})),t.default=b}),define(oe[29],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=void 0,t.isUUID=b;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function b(v){return P.test(v)}t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(C){for(let p=0;p<C.length;p++)C[p]=Math.floor(Math.random()*256);return C};const D=new Uint8Array(16),k=[];for(let C=0;C<256;C++)k.push(C.toString(16).padStart(2,"0"));return function(){v(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,c="";return c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c+="-",c+=k[D[p++]],c+=k[D[p++]],c+="-",c+=k[D[p++]],c+=k[D[p++]],c+="-",c+=k[D[p++]],c+=k[D[p++]],c+="-",c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c+=k[D[p++]],c}}()}),define(oe[80],ae([0,1,35]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=D;const b=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(k){const C=k.replace(/\-/g,":").toLowerCase();return!b.has(C)}function D(){const k=(0,P.networkInterfaces)();for(const C in k){const p=k[C];if(p){for(const{mac:c}of p)if(v(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[81],ae([7,4]),function(q,t){return q.create("vs/base/common/date",t)}),define(oe[82],ae([0,1,81]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fromNow=c,t.getDurationString=l,t.toLocalISOString=d;const b=60,v=b*60,D=v*24,k=D*7,C=D*30,p=D*365;function c(u,S,g,T){typeof u!="number"&&(u=u.getTime());const y=Math.round((new Date().getTime()-u)/1e3);if(y<-30)return(0,P.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!T&&y<30)return(0,P.localize)(1,null);let f;return y<b?(f=y,S?f===1?g?(0,P.localize)(2,null,f):(0,P.localize)(3,null,f):g?(0,P.localize)(4,null,f):(0,P.localize)(5,null,f):f===1?g?(0,P.localize)(6,null,f):(0,P.localize)(7,null,f):g?(0,P.localize)(8,null,f):(0,P.localize)(9,null,f)):y<v?(f=Math.floor(y/b),S?f===1?g?(0,P.localize)(10,null,f):(0,P.localize)(11,null,f):g?(0,P.localize)(12,null,f):(0,P.localize)(13,null,f):f===1?g?(0,P.localize)(14,null,f):(0,P.localize)(15,null,f):g?(0,P.localize)(16,null,f):(0,P.localize)(17,null,f)):y<D?(f=Math.floor(y/v),S?f===1?g?(0,P.localize)(18,null,f):(0,P.localize)(19,null,f):g?(0,P.localize)(20,null,f):(0,P.localize)(21,null,f):f===1?g?(0,P.localize)(22,null,f):(0,P.localize)(23,null,f):g?(0,P.localize)(24,null,f):(0,P.localize)(25,null,f)):y<k?(f=Math.floor(y/D),S?f===1?(0,P.localize)(26,null,f):(0,P.localize)(27,null,f):f===1?(0,P.localize)(28,null,f):(0,P.localize)(29,null,f)):y<C?(f=Math.floor(y/k),S?f===1?g?(0,P.localize)(30,null,f):(0,P.localize)(31,null,f):g?(0,P.localize)(32,null,f):(0,P.localize)(33,null,f):f===1?g?(0,P.localize)(34,null,f):(0,P.localize)(35,null,f):g?(0,P.localize)(36,null,f):(0,P.localize)(37,null,f)):y<p?(f=Math.floor(y/C),S?f===1?g?(0,P.localize)(38,null,f):(0,P.localize)(39,null,f):g?(0,P.localize)(40,null,f):(0,P.localize)(41,null,f):f===1?g?(0,P.localize)(42,null,f):(0,P.localize)(43,null,f):g?(0,P.localize)(44,null,f):(0,P.localize)(45,null,f)):(f=Math.floor(y/p),S?f===1?g?(0,P.localize)(46,null,f):(0,P.localize)(47,null,f):g?(0,P.localize)(48,null,f):(0,P.localize)(49,null,f):f===1?g?(0,P.localize)(50,null,f):(0,P.localize)(51,null,f):g?(0,P.localize)(52,null,f):(0,P.localize)(53,null,f))}function l(u,S){const g=Math.abs(u/1e3);return g<1?S?(0,P.localize)(54,null,u):(0,P.localize)(55,null,u):g<b?S?(0,P.localize)(56,null,Math.round(u)/1e3):(0,P.localize)(57,null,Math.round(u)/1e3):g<v?S?(0,P.localize)(58,null,Math.round(u/(1e3*b))):(0,P.localize)(59,null,Math.round(u/(1e3*b))):g<D?S?(0,P.localize)(60,null,Math.round(u/(1e3*v))):(0,P.localize)(61,null,Math.round(u/(1e3*v))):(0,P.localize)(62,null,Math.round(u/(1e3*D)))}function d(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[83],ae([7,4]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(oe[38],ae([0,1,20,3,83]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=p,t.isErrorWithActions=c,t.createErrorWithActions=l,P=we(P),b=we(b),v=we(v);function D(d,u){return u&&(d.stack||d.stacktrace)?v.localize(0,null,C(d),k(d.stack)||k(d.stacktrace)):C(d)}function k(d){return Array.isArray(d)?d.join(`
`):d}function C(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?v.localize(1,null,d.message):d.message||v.localize(2,null)}function p(d=null,u=!1){if(!d)return v.localize(3,null);if(Array.isArray(d)){const S=P.coalesce(d),g=p(S[0],u);return S.length>1?v.localize(4,null,g,S.length):g}if(b.isString(d))return d;if(d.detail){const S=d.detail;if(S.error)return D(S.error,u);if(S.exception)return D(S.exception,u)}return d.stack?D(d,u):d.message?d.message:v.localize(5,null)}function c(d){const u=d;return u instanceof Error&&Array.isArray(u.actions)}function l(d,u){let S;return typeof d=="string"?S=new Error(d):S=d,S.actions=u,S}}),define(oe[84],ae([7,4]),function(q,t){return q.create("vs/base/common/jsonErrorMessages",t)}),define(oe[85],ae([0,1,84,34]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=v;function v(D){switch(D){case b.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case b.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case b.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case b.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case b.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case b.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case b.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case b.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case b.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(oe[57],ae([0,1,13]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.sanitizeProcessEnvironment=D,t.removeDangerousEnvVariables=k;var b;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(b||(t.Source=b={}));var v;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(v||(t.TerminateResponseCode=v={}));function D(C,...p){const c=p.reduce((u,S)=>(u[S]=!0,u),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(u=>!c[u]).forEach(u=>{for(let S=0;S<l.length;S++)if(u.search(l[S])!==-1){delete C[u];break}})}function k(C){C&&(delete C.DEBUG,P.isMacintosh&&delete C.DYLD_LIBRARY_PATH,P.isLinux&&delete C.LD_PRELOAD)}}),define(oe[86],ae([0,1,12]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteConsoleLog=b,t.parse=v,t.getFirstFrame=D,t.log=C;function b(c){const l=c;return l&&typeof l.type=="string"&&typeof l.severity=="string"}function v(c){const l=[];let d;try{const u=JSON.parse(c.arguments),S=u[u.length-1];S&&S.__$stack&&(u.pop(),d=S.__$stack),l.push(...u)}catch{l.push("Unable to log remote console arguments",c.arguments)}return{args:l,stack:d}}function D(c){if(typeof c!="string")return D(v(c).stack);const l=c;if(l){const d=k(l),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(u&&u.length===4)return{uri:P.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function k(c){if(!c)return c;const l=c.indexOf(`
`);return l===-1?c:c.substring(0,l)}function C(c,l){const{args:d,stack:u}=v(c),S=typeof d[0]=="string"&&d.length===1;let g=k(u);g&&(g=`(${g.trim()})`);let T=[];if(typeof d[0]=="string"?g&&S?T=[`%c[${l}] %c${d[0]} %c${g}`,p("blue"),p(""),p("grey")]:T=[`%c[${l}] %c${d[0]}`,p("blue"),p(""),...d.slice(1)]:T=[`%c[${l}]%`,p("blue"),...d],g&&!S&&T.push(g),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,T)}function p(c){return`color: ${c}`}}),define(oe[48],ae([0,1,14,12,172]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=D,t.parse=k,t.revive=p;function D(c){return JSON.stringify(c,C)}function k(c){let l=JSON.parse(c);return l=p(l),l}function C(c,l){return l instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:l.source,flags:l.flags}:l}function p(c,l=0){if(!c||l>200)return c;if(typeof c=="object"){switch(c.$mid){case v.MarshalledId.Uri:return b.URI.revive(c);case v.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case v.MarshalledId.Date:return new Date(c.source)}if(c instanceof P.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let d=0;d<c.length;++d)c[d]=p(c[d],l+1);else for(const d in c)Object.hasOwnProperty.call(c,d)&&(c[d]=p(c[d],l+1))}return c}}),define(oe[87],ae([0,1,74,15,13,12]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.importAMDNodeModule=l,v=we(v);class k{constructor(u,S,g){this.id=u,this.dependencies=S,this.callback=g}}class C{static{this.INSTANCE=new C}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(u,S,g)=>{typeof u!="string"&&(g=S,S=u,u=null),(typeof S!="object"||!Array.isArray(S))&&(g=S,S=null),this._defineCalls.push(new k(u,S,g))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(u):this._isRenderer?this._rendererLoadScript(u):this._nodeJSLoadScript(u));if(!S)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(u){return new Promise((S,g)=>{const T=document.createElement("script");T.setAttribute("async","async"),T.setAttribute("type","text/javascript");const y=()=>{T.removeEventListener("load",f),T.removeEventListener("error",m)},f=R=>{y(),S(this._defineCalls.pop())},m=R=>{y(),g(R)};T.addEventListener("load",f),T.addEventListener("error",m),this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),T.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(T)})}_workerLoadScript(u){return new Promise((S,g)=>{try{this._amdPolicy&&(u=this._amdPolicy.createScriptURL(u)),importScripts(u),S(this._defineCalls.pop())}catch(T){g(T)}})}async _nodeJSLoadScript(u){try{const S=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,T=globalThis._VSCODE_NODE_MODULES.module,y=D.URI.parse(u).fsPath,f=S.readFileSync(y).toString(),m=T.wrap(f.replace(/^#!.*/,""));return new g.Script(m).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const p=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function l(d,u,S){if(P.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[d]&&(d=c[d]);const g=`${d}/${u}`;if(p.has(g))return p.get(g);let T;if(/^\w[\w\d+.-]*:\/\//.test(g))T=g;else{const R=`${S&&!v.isWeb?b.nodeModulesAsarPath:b.nodeModulesPath}/${g}`;T=b.FileAccess.asBrowserUri(R).toString(!0)}const y=C.INSTANCE.load(T);return p.set(g,y),y}else return await new Promise((g,T)=>{q([d],g,T)}).then(we)}}),define(oe[88],ae([0,1,35,49,29,80,13]),function(q,t,P,b,v,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.virtualMachineHint=void 0,t.getMachineId=p,t.getSqmMachineId=d,t.getdevDeviceId=u,v=we(v),t.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,g=0;const T=(0,P.networkInterfaces)();for(const y in T){const f=T[y];if(f)for(const{mac:m,internal:R}of f)R||(g+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(S+=1))}this._value=g>0?S/g:0}return this._value}};let C;async function p(S){return C||(C=(async()=>await c(S)||v.generateUuid())()),C}async function c(S){try{const g=await new Promise((y,f)=>{q(["crypto"],y,f)}).then(we),T=(0,D.getMac)();return g.createHash("sha256").update(T,"utf8").digest("hex")}catch(g){S(g);return}}const l="Software\\Microsoft\\SQMClient";async function d(S){if(k.isWindows){const g=await new Promise((T,y)=>{q(["@vscode/windows-registry"],T,y)}).then(we);try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",l,"MachineId")||""}catch(T){return S(T),""}}return""}async function u(S){try{return await(await new Promise((y,f)=>{q(["@vscode/deviceid"],y,f)}).then(we)).getDeviceId()}catch(g){return S(g),""}}}),define(oe[89],ae([0,1,35,16,26]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.enumeratePowerShellInstallations=m,t.getFirstAvailablePowerShellInstallation=R,P=we(P),b=we(b),v=we(v);const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let l;process.env.PROCESSOR_ARCHITEW6432?l=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?l=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?l=p.x86:l=p.x64;class d{constructor(e,a,i){this.exePath=e,this.displayName=a,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function u({useAlternateBitness:E=!1}={}){return E?c===p.x64?process.env["ProgramFiles(x86)"]||null:l===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:E=!1,findPreview:e=!1}={}){const a=u({useAlternateBitness:E});if(!a)return null;const i=b.join(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(i))return null;let s=-1,r=null;for(const h of await v.Promises.readdir(i)){let w=-1;if(e){const x=h.indexOf("-");if(x<0)continue;const L=h.substring(0,x);if(!D.test(L)||h.substring(x+1)!=="preview")continue;w=parseInt(L,10)}else{if(!D.test(h))continue;w=parseInt(h,10)}if(w<=s)continue;const O=b.join(i,h,"pwsh.exe");await v.SymlinkSupport.existsFile(O)&&(r=O,s=w)}if(!r)return null;const n=a.includes("x86")?" (x86)":"",o=e?" Preview":"";return new d(r,`PowerShell${o}${n}`,!0)}async function g({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const e=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(e))return null;const{pwshMsixDirRegex:a,pwshMsixName:i}=E?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(e))if(a.test(s)){const r=b.join(e,s,"pwsh.exe");return new d(r,i)}return null}function T(){const E=b.join(P.homedir(),".dotnet","tools","pwsh.exe");return new d(E,".NET Core PowerShell Global Tool")}function y(){const E=b.join(process.env.windir,c===p.x86&&l!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(E,"Windows PowerShell",!0)}async function*f(){let E=await S();E&&(yield E),E=await S({useAlternateBitness:!0}),E&&(yield E),E=await g(),E&&(yield E),E=T(),E&&(yield E),E=await S({findPreview:!0}),E&&(yield E),E=await g({findPreview:!0}),E&&(yield E),E=await S({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=y(),E&&(yield E)}async function*m(){for await(const E of f())await E.exists()&&(yield E)}async function R(){for await(const E of m())return E;return null}}),define(oe[58],ae([0,1,16,13,36,57,3,26]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=p,t.createQueuedSender=c,P=we(P),b=we(b),v=we(v),k=we(k),C=we(C),Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function p(d=v.env){return d.comspec||"cmd.exe"}function c(d){let u=[],S=!1;const g=function(T){if(S){u.push(T);return}(!d.send(T,f=>{if(f&&console.error(f),S=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(R=>g(R))}})||b.isWindows)&&(S=!0)};return{send:g}}var l;(function(d){async function u(S,g,T){if(P.isAbsolute(S))return S;if(g===void 0&&(g=v.cwd()),P.dirname(S)!=="."||(T===void 0&&k.isString(v.env.PATH)&&(T=v.env.PATH.split(P.delimiter)),T===void 0||T.length===0))return P.join(g,S);async function f(m){if(await C.Promises.exists(m)){let R;try{R=await C.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(R=await C.Promises.lstat(m))}return R?!R.isDirectory():!1}return!1}for(const m of T){let R;if(P.isAbsolute(m)?R=P.join(m,S):R=P.join(g,m,S),await f(R))return R;let E=R+".com";if(await f(E)||(E=R+".exe",await f(E)))return E}return P.join(g,S)}d.findExecutable=u})(l||(t.win32=l={}))}),define(oe[90],ae([0,1,35,13,89,58]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShell=k,b=we(b),D=we(D);async function k(d,u){return d===b.OperatingSystem.Windows?b.isWindows?l():D.getWindowsShell(u):p(d,u)}let C=null;function p(d,u){if(b.isLinux&&d===b.OperatingSystem.Macintosh||b.isMacintosh&&d===b.OperatingSystem.Linux)return"/bin/bash";if(!C){let S;if(b.isWindows)S="/bin/bash";else{if(S=u.SHELL,!S)try{S=(0,P.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}C=S}return C}let c=null;async function l(){return c||(c=(await(0,v.getFirstAvailablePowerShellInstallation)()).exePath),c}});var Ee=this&&this.__decorate||function(q,t,P,b){var v=arguments.length,D=v<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,P):b,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(q,t,P,b);else for(var C=q.length-1;C>=0;C--)(k=q[C])&&(D=(v<3?k(D):v>3?k(t,P,D):k(t,P))||D);return v>3&&D&&Object.defineProperty(t,P,D),D};define(oe[59],ae([0,1,20,8,14,22,55,9,5,2,48,32,3]),function(q,t,P,b,v,D,k,C,p,c,l,d,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=o,t.deserialize=h,t.getDelayedChannel=_,t.getNextTickChannel=X,d=we(d);var S;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(S||(S={}));function g(z){switch(z){case S.Promise:return"req";case S.PromiseCancel:return"cancel";case S.EventListen:return"subscribe";case S.EventDispose:return"unsubscribe"}}var T;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(T||(T={}));function y(z){switch(z){case T.Initialize:return"init";case T.PromiseSuccess:return"reply:";case T.PromiseError:case T.PromiseErrorObj:return"replyErr:";case T.EventFire:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function m(z){let W=0;for(let G=0;;G+=7){const Q=z.read(1);if(W|=(Q.buffer[0]&127)<<G,!(Q.buffer[0]&128))return W}}const R=s(0);function E(z,W){if(W===0){z.write(R);return}let G=0;for(let te=W;te!==0;te=te>>>7)G++;const Q=v.VSBuffer.alloc(G);for(let te=0;W!==0;te++)Q.buffer[te]=W&127,W=W>>>7,W>0&&(Q.buffer[te]|=128);z.write(Q)}class e{constructor(W){this.buffer=W,this.pos=0}read(W){const G=this.buffer.slice(this.pos,this.pos+W);return this.pos+=G.byteLength,G}}t.BufferReader=e;class a{constructor(){this.buffers=[]}get buffer(){return v.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}t.BufferWriter=a;var i;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(i||(i={}));function s(z){const W=v.VSBuffer.alloc(1);return W.writeUInt8(z,0),W}const r={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},n=typeof Buffer<"u";function o(z,W){if(typeof W>"u")z.write(r.Undefined);else if(typeof W=="string"){const G=v.VSBuffer.fromString(W);z.write(r.String),E(z,G.byteLength),z.write(G)}else if(n&&Buffer.isBuffer(W)){const G=v.VSBuffer.wrap(W);z.write(r.Buffer),E(z,G.byteLength),z.write(G)}else if(W instanceof v.VSBuffer)z.write(r.VSBuffer),E(z,W.byteLength),z.write(W);else if(Array.isArray(W)){z.write(r.Array),E(z,W.length);for(const G of W)o(z,G)}else if(typeof W=="number"&&(W|0)===W)z.write(r.Uint),E(z,W);else{const G=v.VSBuffer.fromString(JSON.stringify(W));z.write(r.Object),E(z,G.byteLength),z.write(G)}}function h(z){switch(z.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return z.read(m(z)).toString();case i.Buffer:return z.read(m(z)).buffer;case i.VSBuffer:return z.read(m(z));case i.Array:{const G=m(z),Q=[];for(let te=0;te<G;te++)Q.push(h(z));return Q}case i.Object:return JSON.parse(z.read(m(z)).toString());case i.Int:return m(z)}}class w{constructor(W,G,Q=null,te=1e3){this.protocol=W,this.ctx=G,this.logger=Q,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:T.Initialize})}registerChannel(W,G){this.channels.set(W,G),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case T.Initialize:{const G=this.send([W.type]);this.logger?.logOutgoing(G,0,O.OtherSide,y(W.type));return}case T.PromiseSuccess:case T.PromiseError:case T.EventFire:case T.PromiseErrorObj:{const G=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(G,W.id,O.OtherSide,y(W.type),W.data);return}}}send(W,G=void 0){const Q=new a;return o(Q,W),o(Q,G),this.sendBuffer(Q.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const G=new e(W),Q=h(G),te=h(G),F=Q[0];switch(F){case S.Promise:return this.logger?.logIncoming(W.byteLength,Q[1],O.OtherSide,`${g(F)}: ${Q[2]}.${Q[3]}`,te),this.onPromise({type:F,id:Q[1],channelName:Q[2],name:Q[3],arg:te});case S.EventListen:return this.logger?.logIncoming(W.byteLength,Q[1],O.OtherSide,`${g(F)}: ${Q[2]}.${Q[3]}`,te),this.onEventListen({type:F,id:Q[1],channelName:Q[2],name:Q[3],arg:te});case S.PromiseCancel:return this.logger?.logIncoming(W.byteLength,Q[1],O.OtherSide,`${g(F)}`),this.disposeActiveRequest({type:F,id:Q[1]});case S.EventDispose:return this.logger?.logIncoming(W.byteLength,Q[1],O.OtherSide,`${g(F)}`),this.disposeActiveRequest({type:F,id:Q[1]})}}onPromise(W){const G=this.channels.get(W.channelName);if(!G){this.collectPendingRequest(W);return}const Q=new D.CancellationTokenSource;let te;try{te=G.call(this.ctx,W.name,W.arg,Q.token)}catch(K){te=Promise.reject(K)}const F=W.id;te.then(K=>{this.sendResponse({id:F,data:K,type:T.PromiseSuccess})},K=>{K instanceof Error?this.sendResponse({id:F,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:T.PromiseError}):this.sendResponse({id:F,data:K,type:T.PromiseErrorObj})}).finally(()=>{V.dispose(),this.activeRequests.delete(W.id)});const V=(0,c.toDisposable)(()=>Q.cancel());this.activeRequests.set(W.id,V)}onEventListen(W){const G=this.channels.get(W.channelName);if(!G){this.collectPendingRequest(W);return}const Q=W.id,F=G.listen(this.ctx,W.name,W.arg)(V=>this.sendResponse({id:Q,data:V,type:T.EventFire}));this.activeRequests.set(W.id,F)}disposeActiveRequest(W){const G=this.activeRequests.get(W.id);G&&(G.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let G=this.pendingRequests.get(W.channelName);G||(G=[],this.pendingRequests.set(W.channelName,G));const Q=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===S.Promise&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:T.PromiseError})},this.timeoutDelay);G.push({request:W,timeoutTimer:Q})}flushPendingRequests(W){const G=this.pendingRequests.get(W);if(G){for(const Q of G)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case S.Promise:this.onPromise(Q.request);break;case S.EventListen:this.onEventListen(Q.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=w;var O;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class x{constructor(W,G=null){this.protocol=W,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=G}getChannel(W){const G=this;return{call(Q,te,F){return G.isDisposed?Promise.reject(new C.CancellationError):G.requestPromise(W,Q,te,F)},listen(Q,te){return G.isDisposed?p.Event.None:G.requestEvent(W,Q,te)}}}requestPromise(W,G,Q,te=D.CancellationToken.None){const F=this.lastRequestId++,V=S.Promise,K={id:F,type:V,channelName:W,name:G,arg:Q};if(te.isCancellationRequested)return Promise.reject(new C.CancellationError);let j;return new Promise((M,U)=>{if(te.isCancellationRequested)return U(new C.CancellationError);const N=()=>{const le=ge=>{switch(ge.type){case T.PromiseSuccess:this.handlers.delete(F),M(ge.data);break;case T.PromiseError:{this.handlers.delete(F);const pe=new Error(ge.data.message);pe.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,pe.name=ge.data.name,U(pe);break}case T.PromiseErrorObj:this.handlers.delete(F),U(ge.data);break}};this.handlers.set(F,le),this.sendRequest(K)};let H=null;this.state===f.Idle?N():(H=(0,b.createCancelablePromise)(le=>this.whenInitialized()),H.then(()=>{H=null,N()}));const J=()=>{H?(H.cancel(),H=null):this.sendRequest({id:F,type:S.PromiseCancel}),U(new C.CancellationError)},re=te.onCancellationRequested(J);j=(0,c.combinedDisposable)((0,c.toDisposable)(J),re),this.activeRequests.add(j)}).finally(()=>{j.dispose(),this.activeRequests.delete(j)})}requestEvent(W,G,Q){const te=this.lastRequestId++,F=S.EventListen,V={id:te,type:F,channelName:W,name:G,arg:Q};let K=null;const j=new p.Emitter({onWillAddFirstListener:()=>{K=(0,b.createCancelablePromise)(M=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(j),this.sendRequest(V)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(j),this.sendRequest({id:te,type:S.EventDispose}))}}),I=M=>j.fire(M.data);return this.handlers.set(te,I),j.event}sendRequest(W){switch(W.type){case S.Promise:case S.EventListen:{const G=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(G,W.id,O.LocalSide,`${g(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case S.PromiseCancel:case S.EventDispose:{const G=this.send([W.type,W.id]);this.logger?.logOutgoing(G,W.id,O.LocalSide,g(W.type));return}}}send(W,G=void 0){const Q=new a;return o(Q,W),o(Q,G),this.sendBuffer(Q.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const G=new e(W),Q=h(G),te=h(G),F=Q[0];switch(F){case T.Initialize:return this.logger?.logIncoming(W.byteLength,0,O.LocalSide,y(F)),this.onResponse({type:Q[0]});case T.PromiseSuccess:case T.PromiseError:case T.EventFire:case T.PromiseErrorObj:return this.logger?.logIncoming(W.byteLength,Q[1],O.LocalSide,y(F),te),this.onResponse({type:Q[0],id:Q[1],data:te})}}onResponse(W){if(W.type===T.Initialize){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=x,Ee([k.memoize],x.prototype,"onDidInitializePromise",null);class L{get connections(){const W=[];return this._connections.forEach(G=>W.push(G)),W}constructor(W,G,Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new c.DisposableStore,this.disposables.add(W(({protocol:te,onDidClientDisconnect:F})=>{const V=p.Event.once(te.onMessage);this.disposables.add(V(K=>{const j=new e(K),I=h(j),M=new w(te,I,G,Q),U=new x(te,G);this.channels.forEach((H,J)=>M.registerChannel(J,H));const N={channelServer:M,channelClient:U,ctx:I};this._connections.add(N),this._onDidAddConnection.fire(N),this.disposables.add(F(()=>{M.dispose(),U.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)}))}))}))}getChannel(W,G){const Q=this;return{call(te,F,V){let K;if((0,u.isFunction)(G)){const I=(0,P.getRandomElement)(Q.connections.filter(G));K=I?Promise.resolve(I):p.Event.toPromise(p.Event.filter(Q.onDidAddConnection,G))}else K=G.routeCall(Q,te,F);const j=K.then(I=>I.channelClient.getChannel(W));return _(j).call(te,F,V)},listen(te,F){if((0,u.isFunction)(G))return Q.getMulticastEvent(W,G,te,F);const V=G.routeEvent(Q,te,F).then(K=>K.channelClient.getChannel(W));return _(V).listen(te,F)}}}getMulticastEvent(W,G,Q,te){const F=this;let V;const K=new p.Emitter({onWillAddFirstListener:()=>{V=new c.DisposableStore;const j=new p.EventMultiplexer,I=new Map,M=N=>{const J=N.channelClient.getChannel(W).listen(Q,te),re=j.add(J);I.set(N,re)},U=N=>{const H=I.get(N);H&&(H.dispose(),I.delete(N))};F.connections.filter(G).forEach(M),p.Event.filter(F.onDidAddConnection,G)(M,void 0,V),F.onDidRemoveConnection(U,void 0,V),j.event(K.fire,K,V),V.add(j)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return K.event}registerChannel(W,G){this.channels.set(W,G);for(const Q of this._connections)Q.channelServer.registerChannel(W,G)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=L;class A{constructor(W,G,Q=null){const te=new a;o(te,G),W.send(te.buffer),this.channelClient=new x(W,Q),this.channelServer=new w(W,G,Q)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,G){this.channelServer.registerChannel(W,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function _(z){return{call(W,G,Q){return z.then(te=>te.call(W,G,Q))},listen(W,G){const Q=new p.Relay;return z.then(te=>Q.input=te.listen(W,G)),Q.event}}}function X(z){let W=!1;return{call(G,Q,te){return W?z.call(G,Q,te):(0,b.timeout)(0).then(()=>W=!0).then(()=>z.call(G,Q,te))},listen(G,Q){if(W)return z.listen(G,Q);const te=new p.Relay;return(0,b.timeout)(0).then(()=>W=!0).then(()=>te.input=z.listen(G,Q)),te.event}}}class Y{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const G of W.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await p.Event.toPromise(W.onDidAddConnection),await this.route(W)}}t.StaticRouter=Y;var ne;(function(z){function W(F,V,K){const j=F,I=K&&K.disableMarshalling,M=new Map;for(const U in j)Q(U)&&M.set(U,p.Event.buffer(j[U],!0,void 0,V));return new class{listen(U,N,H){const J=M.get(N);if(J)return J;const re=j[N];if(typeof re=="function"){if(te(N))return re.call(j,H);if(Q(N))return M.set(N,p.Event.buffer(j[N],!0,void 0,V)),M.get(N)}throw new C.ErrorNoTelemetry(`Event not found: ${N}`)}call(U,N,H){const J=j[N];if(typeof J=="function"){if(!I&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,l.revive)(H[le]);let re=J.apply(j,H);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new C.ErrorNoTelemetry(`Method not found: ${N}`)}}}z.fromService=W;function G(F,V){const K=V&&V.disableMarshalling;return new Proxy({},{get(j,I){if(typeof I=="string")return V?.properties?.has(I)?V.properties.get(I):te(I)?function(M){return F.listen(I,M)}:Q(I)?F.listen(I):async function(...M){let U;V&&!(0,u.isUndefinedOrNull)(V.context)?U=[V.context,...M]:U=M;const N=await F.call(I,U);return K?N:(0,l.revive)(N)};throw new C.ErrorNoTelemetry(`Property not found: ${String(I)}`)}})}z.toService=G;function Q(F){return F[0]==="o"&&F[1]==="n"&&d.isUpperAsciiLetter(F.charCodeAt(2))}function te(F){return/^onDynamic/.test(F)&&d.isUpperAsciiLetter(F.charCodeAt(9))}})(ne||(t.ProxyChannel=ne={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function he(z){return Array.isArray(z)?z.map(ue):ue(z)}function B(z,W,G,Q,te,F,V){V=he(V);const K=ce[te],j=K[Q%K.length];let I=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(F)?(I=I.concat(V),I.push(")")):I.push(V),console.log.apply(console,I)}class Z{constructor(W,G){this._outgoingPrefix=W,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,G,Q,te,F){this._totalOutgoing+=W,B(this._outgoingPrefix,this._totalOutgoing,W,G,Q,te,F)}logIncoming(W,G,Q,te,F){this._totalIncoming+=W,B(this._incomingPrefix,this._totalIncoming,W,G,Q,te,F)}}t.IPCLogger=Z}),define(oe[91],ae([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0,C=we(C);class g extends S.ChannelServer{constructor(f){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",m=>v.VSBuffer.wrap(Buffer.from(m,"base64")))},f),process.once("disconnect",()=>this.dispose())}}t.Server=g;class T{constructor(f,m){this.modulePath=f,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const R=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new b.Delayer(R),this.child=null,this._client=null}getChannel(f){const m=this;return{call(R,E,e){return m.requestPromise(f,R,E,e)},listen(R,E){return m.requestEvent(f,R,E)}}}requestPromise(f,m,R,E=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const e=this.getCachedChannel(f),a=(0,b.createCancelablePromise)(r=>e.call(m,R,r)),i=E.onCancellationRequested(()=>a.cancel()),s=(0,c.toDisposable)(()=>a.cancel());return this.activeRequests.add(s),a.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(f,m,R){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let E;const e=new p.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(f).listen(m,R)(e.fire,e),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return e.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,l.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.removeDangerousEnvVariables)(m.env),this.child=(0,P.fork)(this.modulePath,f,m);const R=new p.Emitter,e=p.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}R.fire(v.VSBuffer.wrap(Buffer.from(o,"base64")))}),a=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&a.send(o.buffer.toString("base64")),s=R.event,r={send:i,onMessage:s};this._client=new S.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,h)=>{process.removeListener("exit",n),e.dispose(),this.activeRequests.forEach(w=>(0,c.dispose)(w)),this.activeRequests.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+h),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:h})})}return this._client}getCachedChannel(f){let m=this.channels.get(f);return m||(m=this.client.getChannel(f),this.channels.set(f,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}t.Client=T}),define(oe[92],ae([0,1,8,5,2,48,3]),function(q,t,P,b,v,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.StorageHint=void 0,t.isStorageItemsChangeEvent=p;var C;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(t.StorageHint=C={}));function p(u){const S=u;return S?.changed instanceof Map||S?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(t.StorageState=c={}));class l extends v.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,g=Object.create(null)){super(),this.database=S,this.options=g,this._onDidChangeStorage=this._register(new b.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=this._register(new P.ThrottledDelayer(l.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((g,T)=>this.acceptExternal(T,g)),S.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,g){if(this.state===c.Closed)return;let T=!1;(0,k.isUndefinedOrNull)(g)?T=this.cache.delete(S):this.cache.get(S)!==g&&(this.cache.set(S,g),T=!0),T&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,g){const T=this.cache.get(S);return(0,k.isUndefinedOrNull)(T)?g:T}getBoolean(S,g){const T=this.get(S);return(0,k.isUndefinedOrNull)(T)?g:T==="true"}getNumber(S,g){const T=this.get(S);return(0,k.isUndefinedOrNull)(T)?g:parseInt(T,10)}getObject(S,g){const T=this.get(S);return(0,k.isUndefinedOrNull)(T)?g:(0,D.parse)(T)}async set(S,g,T=!1){if(this.state===c.Closed)return;if((0,k.isUndefinedOrNull)(g))return this.delete(S,T);const y=(0,k.isObject)(g)||Array.isArray(g)?(0,D.stringify)(g):String(g);if(this.cache.get(S)!==y)return this.cache.set(S,y),this.pendingInserts.set(S,y),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:T}),this.doFlush()}async delete(S,g=!1){if(!(this.state===c.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:g}),this.doFlush()}async optimize(){if(this.state!==c.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!(this.state===c.Closed||this.pendingClose))return this.doFlush(S)}async doFlush(S){return this.options.hint===C.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===C.STORAGE_IN_MEMORY}}t.Storage=l;class d{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((g,T)=>this.items.set(T,g)),S.delete?.forEach(g=>this.items.delete(g))}async optimize(){}async close(){}}t.InMemoryStorageDatabase=d}),define(oe[93],ae([7,4]),function(q,t){return q.create("vs/base/node/zip",t)}),define(oe[50],ae([0,1,94,8,16,3,26,93]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtractError=t.CorruptZipMessage=void 0,t.zip=y,t.extract=f,t.buffer=R,v=we(v),C=we(C),t.CorruptZipMessage="end of central directory record signature not found";const p=new RegExp(t.CorruptZipMessage);class c extends Error{constructor(e,a){let i=a.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=e,this.cause=a}}t.ExtractError=c;function l(E){const e=E.externalFileAttributes>>16||33188;return[448,56,7].map(a=>e&a).reduce((a,i)=>a+i,e&61440)}function d(E){if(E instanceof c)return E;let e;return p.test(E.message)&&(e="CorruptZip"),new c(e,E)}function u(E,e,a,i,s,r){const n=v.dirname(e),o=v.join(i,n);if(!o.startsWith(i))return Promise.reject(new Error(C.localize(0,null,e)));const h=v.join(i,e);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((O,x)=>{if(!r.isCancellationRequested)try{w=(0,P.createWriteStream)(h,{mode:a}),w.once("close",()=>O()),w.once("error",x),E.once("error",x),E.pipe(w)}catch(L){x(L)}}))}function S(E,e,a,i){let s=(0,b.createCancelablePromise)(()=>Promise.resolve()),r=0;const n=i.onCancellationRequested(()=>{s.cancel(),E.close()});return new Promise((o,h)=>{const w=new b.Sequencer,O=x=>{x.isCancellationRequested||(r++,E.readEntry())};E.once("error",h),E.once("close",()=>s.then(()=>{i.isCancellationRequested||E.entryCount===r?o():h(new c("Incomplete",new Error(C.localize(1,null,r,E.entryCount))))},h)),E.readEntry(),E.on("entry",x=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(x.fileName)){O(i);return}const L=x.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(L)){const X=v.join(e,L);s=(0,b.createCancelablePromise)(Y=>k.Promises.mkdir(X,{recursive:!0}).then(()=>O(Y)).then(void 0,h));return}const A=T(E,x),_=l(x);s=(0,b.createCancelablePromise)(X=>w.queue(()=>A.then(Y=>u(Y,L,_,e,a,X).then(()=>O(X)))).then(null,h))})}).finally(()=>n.dispose())}async function g(E,e=!1){const{open:a}=await new Promise((i,s)=>{q(["yauzl"],i,s)}).then(we);return new Promise((i,s)=>{a(E,e?{lazyEntries:!0}:void 0,(r,n)=>{r?s(d(r)):i((0,D.assertIsDefined)(n))})})}function T(E,e){return new Promise((a,i)=>{E.openReadStream(e,(s,r)=>{s?i(d(s)):a((0,D.assertIsDefined)(r))})})}async function y(E,e){const{ZipFile:a}=await new Promise((i,s)=>{q(["yazl"],i,s)}).then(we);return new Promise((i,s)=>{const r=new a;e.forEach(o=>{o.contents?r.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&r.addFile(o.localPath,o.path)}),r.end();const n=(0,P.createWriteStream)(E);r.outputStream.pipe(n),r.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>i(E))})}function f(E,e,a={},i){const s=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=g(E,!0);return a.overwrite&&(r=r.then(n=>k.Promises.rm(e).then(()=>n))),r.then(n=>S(n,e,{sourcePathRegex:s},i))}function m(E,e){return g(E).then(a=>new Promise((i,s)=>{a.on("entry",r=>{r.fileName===e&&T(a,r).then(n=>i(n),n=>s(n))}),a.once("close",()=>s(new Error(C.localize(2,null,e))))}))}function R(E,e){return m(E,e).then(a=>new Promise((i,s)=>{const r=[];a.once("error",s),a.on("data",n=>r.push(n)),a.on("end",()=>i(Buffer.concat(r)))}))}}),define(oe[95],ae([7,4]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(oe[96],ae([7,4]),function(q,t){return q.create("vs/platform/contextkey/common/contextkey",t)}),define(oe[97],ae([7,4]),function(q,t){return q.create("vs/platform/contextkey/common/scanner",t)}),define(oe[98],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(oe[99],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(oe[100],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(oe[101],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(oe[102],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(oe[103],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(oe[104],ae([7,4]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(oe[105],ae([7,4]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(oe[106],ae([7,4]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(oe[107],ae([7,4]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(oe[108],ae([7,4]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(oe[109],ae([7,4]),function(q,t){return q.create("vs/platform/languagePacks/common/languagePacks",t)}),define(oe[110],ae([7,4]),function(q,t){return q.create("vs/platform/log/common/log",t)}),define(oe[111],ae([7,4]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(oe[112],ae([7,4]),function(q,t){return q.create("vs/platform/shell/node/shellEnv",t)}),define(oe[113],ae([7,4]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(oe[114],ae([7,4]),function(q,t){return q.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(oe[115],ae([7,4]),function(q,t){return q.create("vs/platform/workspace/common/workspace",t)}),define(oe[116],ae([0,1,117,9,97]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Scanner=t.TokenType=void 0;var D;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(D||(t.TokenType=D={}));function k(...l){switch(l.length){case 1:return(0,v.localize)(0,null,l[0]);case 2:return(0,v.localize)(1,null,l[0],l[1]);case 3:return(0,v.localize)(2,null,l[0],l[1],l[2]);default:return}}const C=(0,v.localize)(3,null),p=(0,v.localize)(4,null);class c{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return d.isTripleEq?"===":"==";case D.NotEq:return d.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return d.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return d.lexeme;case D.QuotedStr:return d.lexeme;case D.Error:return d.lexeme;case D.EOF:return"EOF";default:throw(0,b.illegalState)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this._keywords=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this._errors}reset(d){return this._input=d,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case P.CharCode.OpenParen:this._addToken(D.LParen);break;case P.CharCode.CloseParen:this._addToken(D.RParen);break;case P.CharCode.ExclamationMark:if(this._match(P.CharCode.Equals)){const u=this._match(P.CharCode.Equals);this._tokens.push({type:D.NotEq,offset:this._start,isTripleEq:u})}else this._addToken(D.Neg);break;case P.CharCode.SingleQuote:this._quotedString();break;case P.CharCode.Slash:this._regex();break;case P.CharCode.Equals:if(this._match(P.CharCode.Equals)){const u=this._match(P.CharCode.Equals);this._tokens.push({type:D.Eq,offset:this._start,isTripleEq:u})}else this._match(P.CharCode.Tilde)?this._addToken(D.RegexOp):this._error(k("==","=~"));break;case P.CharCode.LessThan:this._addToken(this._match(P.CharCode.Equals)?D.LtEq:D.Lt);break;case P.CharCode.GreaterThan:this._addToken(this._match(P.CharCode.Equals)?D.GtEq:D.Gt);break;case P.CharCode.Ampersand:this._match(P.CharCode.Ampersand)?this._addToken(D.And):this._error(k("&&"));break;case P.CharCode.Pipe:this._match(P.CharCode.Pipe)?this._addToken(D.Or):this._error(k("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(D.EOF),Array.from(this._tokens)}_match(d){return this._isAtEnd()||this._input.charCodeAt(this._current)!==d?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?P.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(d){this._tokens.push({type:d,offset:this._start})}_error(d){const u=this._start,S=this._input.substring(this._start,this._current),g={type:D.Error,offset:this._start,lexeme:S};this._errors.push({offset:u,lexeme:S,additionalInfo:d}),this._tokens.push(g)}_string(){this.stringRe.lastIndex=this._start;const d=this.stringRe.exec(this._input);if(d){this._current=this._start+d[0].length;const u=this._input.substring(this._start,this._current),S=c._keywords.get(u);S?this._addToken(S):this._tokens.push({type:D.Str,lexeme:u,offset:this._start})}}_quotedString(){for(;this._peek()!==P.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(C);return}this._advance(),this._tokens.push({type:D.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let d=this._current,u=!1,S=!1;for(;;){if(d>=this._input.length){this._current=d,this._error(p);return}const T=this._input.charCodeAt(d);if(u)u=!1;else if(T===P.CharCode.Slash&&!S){d++;break}else T===P.CharCode.OpenSquareBracket?S=!0:T===P.CharCode.Backslash?u=!0:T===P.CharCode.CloseSquareBracket&&(S=!1);d++}for(;d<this._input.length&&c._regexFlags.has(this._input.charCodeAt(d));)d++;this._current=d;const g=this._input.substring(this._start,this._current);this._tokens.push({type:D.RegexStr,lexeme:g,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}t.Scanner=c}),define(oe[118],ae([0,1,82,55,15,16,36,17,12]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractNativeEnvironmentService=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,t.parseExtensionHostDebugPort=l,t.parseDebugParams=d,t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,D.dirname)(v.FileAccess.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const S=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",S)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(p.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=k.env.VSCODE_PORTABLE;return S?p.URI.file((0,D.join)(S,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,D.resolve)(S):(0,D.normalize)((0,D.join)(v.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?p.URI.file((0,D.resolve)(S)):p.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,D.resolve)(S);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const T=k.env.VSCODE_PORTABLE;return T?(0,D.join)(T,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(g=>/^[^:/?#]+?:\/\//.test(g)?p.URI.parse(g):p.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?p.URI.parse(S):p.URI.file((0,D.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return l(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const g of this.args.log||[]){const T=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);T&&T[1]&&T[2]&&S.push([T[1],T[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=k.env.VSCODE_PORTABLE;return S?p.URI.file((0,D.join)(S,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this._args}constructor(S,g,T){this._args=S,this.paths=g,this.productService=T,this.editSessionId=this.args.editSessionId}}t.AbstractNativeEnvironmentService=c,Ee([b.memoize],c.prototype,"appRoot",null),Ee([b.memoize],c.prototype,"userHome",null),Ee([b.memoize],c.prototype,"userDataPath",null),Ee([b.memoize],c.prototype,"appSettingsHome",null),Ee([b.memoize],c.prototype,"tmpDir",null),Ee([b.memoize],c.prototype,"cacheHome",null),Ee([b.memoize],c.prototype,"stateResource",null),Ee([b.memoize],c.prototype,"userRoamingDataHome",null),Ee([b.memoize],c.prototype,"userDataSyncHome",null),Ee([b.memoize],c.prototype,"sync",null),Ee([b.memoize],c.prototype,"machineSettingsResource",null),Ee([b.memoize],c.prototype,"workspaceStorageHome",null),Ee([b.memoize],c.prototype,"localHistoryHome",null),Ee([b.memoize],c.prototype,"keyboardLayoutResource",null),Ee([b.memoize],c.prototype,"argvResource",null),Ee([b.memoize],c.prototype,"isExtensionDevelopment",null),Ee([b.memoize],c.prototype,"untitledWorkspacesHome",null),Ee([b.memoize],c.prototype,"builtinExtensionsPath",null),Ee([b.memoize],c.prototype,"extensionsPath",null),Ee([b.memoize],c.prototype,"extensionDevelopmentLocationURI",null),Ee([b.memoize],c.prototype,"extensionDevelopmentKind",null),Ee([b.memoize],c.prototype,"extensionTestsLocationURI",null),Ee([b.memoize],c.prototype,"debugExtensionHost",null),Ee([b.memoize],c.prototype,"logLevel",null),Ee([b.memoize],c.prototype,"extensionLogLevel",null),Ee([b.memoize],c.prototype,"serviceMachineIdResource",null),Ee([b.memoize],c.prototype,"disableTelemetry",null),Ee([b.memoize],c.prototype,"disableWorkspaceTrust",null),Ee([b.memoize],c.prototype,"useInMemorySecretStorage",null),Ee([b.memoize],c.prototype,"policyFile",null);function l(u,S){return d(u["inspect-extensions"],u["inspect-brk-extensions"],5870,S,u.debugId,u.extensionEnvironment)}function d(u,S,g,T,y,f){const R=Number(S||u)||(T?null:g),E=R?!!S:!1;let e;if(f)try{e=JSON.parse(f)}catch{}return{port:R,break:E,debugId:y,env:e}}}),function(){"use strict";function q(t,P,b){function v(k,C){const p=D(k,C),c=[p];return t.isAbsolute(p)||c.unshift(b),t.resolve(...c)}function D(k,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return t.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return t.join(c,C);const l=k["user-data-dir"];if(l)return l;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=t.join(d,"AppData","Roaming")}break;case"darwin":c=t.join(P.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||t.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(c,C)}return{getUserDataPath:v}}if(typeof define=="function")define(oe[119],ae([173,35,36]),function(t,P,b){return q(t,P,b.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),P=require("os");module.exports=q(t,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[120],ae([0,1,35,118,119]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0,t.parsePtyHostDebugPort=k,t.parseSharedProcessDebugPort=C;class D extends b.AbstractNativeEnvironmentService{constructor(c,l){super(c,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,v.getUserDataPath)(c,l.nameShort)},l)}}t.NativeEnvironmentService=D;function k(p,c){return(0,b.parseDebugParams)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function C(p,c){return(0,b.parseDebugParams)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(oe[121],ae([0,1,3,101]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=v;function v(k,C,p,c){try{D(k,C,p,c)}catch(l){k.error(l?.message??l)}return C}function D(k,C,p,c){const l=(d,u,S)=>{const g=d[u];if((0,P.isString)(g)){const T=g,y=T.length;if(y>1&&T[0]==="%"&&T[y-1]==="%"){const f=T.substr(1,y-2);let m=p[f];m===void 0&&c&&(m=c[f]);const R=typeof m=="string"?m:m?.message,E=c?.[f],e=typeof E=="string"?E:E?.message;if(!R){e||k.warn(`[${C.name}]: ${(0,b.localize)(0,null,f)}`);return}if(S&&(u==="title"||u==="category")&&e&&e!==R){const a={value:R,original:e};d[u]=a}else d[u]=R}}else if((0,P.isObject)(g))for(const T in g)g.hasOwnProperty(T)&&(T==="commands"?l(g,T,!0):l(g,T,S));else if(Array.isArray(g))for(let T=0;T<g.length;T++)l(g,T,S)};for(const d in C)C.hasOwnProperty(d)&&l(C,d)}}),define(oe[122],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};t.allApiProposals=Object.freeze(P)}),define(oe[51],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class P{constructor(v,D=[],k=!1){this.ctor=v,this.staticArguments=D,this.supportsDelayedInstantiation=k}}t.SyncDescriptor=P}),define(oe[123],ae([0,1,51]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.registerSingleton=D,t.getSingletonServiceDescriptors=k;const b=[];var v;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(v||(t.InstantiationType=v={}));function D(C,p,c){p instanceof P.SyncDescriptor||(p=new P.SyncDescriptor(p,[],!!c)),b.push([C,p])}function k(){return b}}),define(oe[124],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class P{constructor(D,k){this.key=D,this.data=k,this.incoming=new Map,this.outgoing=new Map}}t.Node=P;class b{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(const k of this._nodes.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const C=this.lookupOrInsertNode(D),p=this.lookupOrInsertNode(k);C.outgoing.set(p.key,p),p.incoming.set(C.key,C)}removeNode(D){const k=this._hashFn(D);this._nodes.delete(k);for(const C of this._nodes.values())C.outgoing.delete(k),C.incoming.delete(k)}lookupOrInsertNode(D){const k=this._hashFn(D);let C=this._nodes.get(k);return C||(C=new P(k,D),this._nodes.set(k,C)),C}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){const D=[];for(const[k,C]of this._nodes)D.push(`${k}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,k]of this._nodes){const C=new Set([D]),p=this._findCycle(k,C);if(p)return p}}_findCycle(D,k){for(const[C,p]of D.outgoing){if(k.has(C))return[...k,C].join(" -> ");k.add(C);const c=this._findCycle(p,k);if(c)return c;k.delete(C)}}}t.Graph=b}),define(oe[30],ae([0,1,3,12,11]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.IConfigurationService=void 0,t.isConfigurationOverrides=D,t.isConfigurationUpdateOverrides=k,t.ConfigurationTargetToString=p,t.isConfigured=c,t.toValuesTree=l,t.addToValueTree=d,t.removeFromValueTree=u,t.getConfigurationValue=g,t.merge=T,t.getLanguageTagSettingPlainKey=y,P=we(P),t.IConfigurationService=(0,v.createDecorator)("configurationService");function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof b.URI)}function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof b.URI)}var C;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(C||(t.ConfigurationTarget=C={}));function p(f){switch(f){case C.APPLICATION:return"APPLICATION";case C.USER:return"USER";case C.USER_LOCAL:return"USER_LOCAL";case C.USER_REMOTE:return"USER_REMOTE";case C.WORKSPACE:return"WORKSPACE";case C.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case C.DEFAULT:return"DEFAULT";case C.MEMORY:return"MEMORY"}}function c(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function l(f,m){const R=Object.create(null);for(const E in f)d(R,E,f[E],m);return R}function d(f,m,R,E){const e=m.split("."),a=e.pop();let i=f;for(let s=0;s<e.length;s++){const r=e[s];let n=i[r];switch(typeof n){case"undefined":n=i[r]=Object.create(null);break;case"object":if(n===null){E(`Ignoring ${m} as ${e.slice(0,s+1).join(".")} is null`);return}break;default:E(`Ignoring ${m} as ${e.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[a]=R}catch{E(`Ignoring ${m} as ${e.join(".")} is ${JSON.stringify(i)}`)}else E(`Ignoring ${m} as ${e.join(".")} is ${JSON.stringify(i)}`)}function u(f,m){const R=m.split(".");S(f,R)}function S(f,m){const R=m.shift();if(m.length===0){delete f[R];return}if(Object.keys(f).indexOf(R)!==-1){const E=f[R];typeof E=="object"&&!Array.isArray(E)&&(S(E,m),Object.keys(E).length===0&&delete f[R])}}function g(f,m,R){function E(i,s){let r=i;for(const n of s){if(typeof r!="object"||r===null)return;r=r[n]}return r}const e=m.split("."),a=E(f,e);return typeof a>"u"?R:a}function T(f,m,R){Object.keys(m).forEach(E=>{E!=="__proto__"&&(E in f?P.isObject(f[E])&&P.isObject(m[E])?T(f[E],m[E],R):R&&(f[E]=m[E]):f[E]=m[E])})}function y(f){return f.replace(/[\[\]]/g,"")}}),define(oe[125],ae([0,1,117,13,32,116,11,96,9]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeySmallerEqualsExpr=t.ContextKeySmallerExpr=t.ContextKeyGreaterEqualsExpr=t.ContextKeyGreaterExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.Parser=t.ContextKeyExprType=void 0,t.setConstant=l,t.validateWhenClauses=s,t.expressionsAreEqualWithConstantSubstitution=r,t.implies=F;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",b.isMacintosh),c.set("isLinux",b.isLinux),c.set("isWindows",b.isWindows),c.set("isWeb",b.isWeb),c.set("isMacNative",b.isMacintosh&&!b.isWeb),c.set("isEdge",b.isEdge),c.set("isFirefox",b.isFirefox),c.set("isChrome",b.isChrome),c.set("isSafari",b.isSafari);function l(j,I){if(c.get(j)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(j,I)}const d=Object.prototype.hasOwnProperty;var u;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(u||(t.ContextKeyExprType=u={}));const S={regexParsingWithErrorRecovery:!0},g=(0,C.localize)(0,null),T=(0,C.localize)(1,null),y=(0,C.localize)(2,null),f=(0,C.localize)(3,null),m=(0,C.localize)(4,null),R=(0,C.localize)(5,null),E=(0,C.localize)(6,null),e=(0,C.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(I=S){this._config=I,this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(I){if(I===""){this._parsingErrors.push({message:g,offset:0,lexeme:"",additionalInfo:T});return}this._tokens=this._scanner.reset(I).scan(),this._current=0,this._parsingErrors=[];try{const M=this._expr();if(!this._isAtEnd()){const U=this._peek(),N=U.type===D.TokenType.Str?R:void 0;throw this._parsingErrors.push({message:m,offset:U.offset,lexeme:D.Scanner.getLexeme(U),additionalInfo:N}),a._parseError}return M}catch(M){if(M!==a._parseError)throw M;return}}_expr(){return this._or()}_or(){const I=[this._and()];for(;this._matchOne(D.TokenType.Or);){const M=this._and();I.push(M)}return I.length===1?I[0]:i.or(...I)}_and(){const I=[this._term()];for(;this._matchOne(D.TokenType.And);){const M=this._term();I.push(M)}return I.length===1?I[0]:i.and(...I)}_term(){if(this._matchOne(D.TokenType.Neg)){const I=this._peek();switch(I.type){case D.TokenType.True:return this._advance(),o.INSTANCE;case D.TokenType.False:return this._advance(),h.INSTANCE;case D.TokenType.LParen:{this._advance();const M=this._expr();return this._consume(D.TokenType.RParen,f),M?.negate()}case D.TokenType.Str:return this._advance(),_.create(I.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",I)}}return this._primary()}_primary(){const I=this._peek();switch(I.type){case D.TokenType.True:return this._advance(),i.true();case D.TokenType.False:return this._advance(),i.false();case D.TokenType.LParen:{this._advance();const M=this._expr();return this._consume(D.TokenType.RParen,f),M}case D.TokenType.Str:{const M=I.lexeme;if(this._advance(),this._matchOne(D.TokenType.RegexOp)){const N=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),N.type!==D.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",N);const H=N.lexeme,J=H.lastIndexOf("/"),re=J===H.length-1?void 0:this._removeFlagsGY(H.substring(J+1));let le;try{le=new RegExp(H.substring(1,J),re)}catch{throw this._errExpectedButGot("REGEX",N)}return he.create(M,le)}switch(N.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const H=[N.lexeme];this._advance();let J=this._peek(),re=0;for(let Se=0;Se<N.lexeme.length;Se++)N.lexeme.charCodeAt(Se)===P.CharCode.OpenParen?re++:N.lexeme.charCodeAt(Se)===P.CharCode.CloseParen&&re--;for(;!this._isAtEnd()&&J.type!==D.TokenType.And&&J.type!==D.TokenType.Or;){switch(J.type){case D.TokenType.LParen:re++;break;case D.TokenType.RParen:re--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Se=0;Se<J.lexeme.length;Se++)J.lexeme.charCodeAt(Se)===P.CharCode.OpenParen?re++:N.lexeme.charCodeAt(Se)===P.CharCode.CloseParen&&re--}if(re<0)break;H.push(D.Scanner.getLexeme(J)),this._advance(),J=this._peek()}const le=H.join(""),ge=le.lastIndexOf("/"),pe=ge===le.length-1?void 0:this._removeFlagsGY(le.substring(ge+1));let me;try{me=new RegExp(le.substring(1,ge),pe)}catch{throw this._errExpectedButGot("REGEX",N)}return i.regex(M,me)}case D.TokenType.QuotedStr:{const H=N.lexeme;this._advance();let J=null;if(!(0,v.isFalsyOrWhitespace)(H)){const re=H.indexOf("/"),le=H.lastIndexOf("/");if(re!==le&&re>=0){const ge=H.slice(re+1,le),pe=H[le+1]==="i"?"i":"";try{J=new RegExp(ge,pe)}catch{throw this._errExpectedButGot("REGEX",N)}}}if(J===null)throw this._errExpectedButGot("REGEX",N);return he.create(M,J)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(D.TokenType.Not)){this._consume(D.TokenType.In,y);const N=this._value();return i.notIn(M,N)}switch(this._peek().type){case D.TokenType.Eq:{this._advance();const N=this._value();if(this._previous().type===D.TokenType.QuotedStr)return i.equals(M,N);switch(N){case"true":return i.has(M);case"false":return i.not(M);default:return i.equals(M,N)}}case D.TokenType.NotEq:{this._advance();const N=this._value();if(this._previous().type===D.TokenType.QuotedStr)return i.notEquals(M,N);switch(N){case"true":return i.not(M);case"false":return i.has(M);default:return i.notEquals(M,N)}}case D.TokenType.Lt:return this._advance(),ce.create(M,this._value());case D.TokenType.LtEq:return this._advance(),ue.create(M,this._value());case D.TokenType.Gt:return this._advance(),Y.create(M,this._value());case D.TokenType.GtEq:return this._advance(),ne.create(M,this._value());case D.TokenType.In:return this._advance(),i.in(M,this._value());default:return i.has(M)}}case D.TokenType.EOF:throw this._parsingErrors.push({message:E,offset:I.offset,lexeme:"",additionalInfo:e}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const I=this._peek();switch(I.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this._advance(),I.lexeme;case D.TokenType.True:return this._advance(),"true";case D.TokenType.False:return this._advance(),"false";case D.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(I){return I.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(I){return this._check(I)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(I,M){if(this._check(I))return this._advance();throw this._errExpectedButGot(M,this._peek())}_errExpectedButGot(I,M,U){const N=(0,C.localize)(8,null,I,D.Scanner.getLexeme(M)),H=M.offset,J=D.Scanner.getLexeme(M);return this._parsingErrors.push({message:N,offset:H,lexeme:J,additionalInfo:U}),a._parseError}_check(I){return this._peek().type===I}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===D.TokenType.EOF}}t.Parser=a;class i{static false(){return o.INSTANCE}static true(){return h.INSTANCE}static has(I){return w.create(I)}static equals(I,M){return O.create(I,M)}static notEquals(I,M){return A.create(I,M)}static regex(I,M){return he.create(I,M)}static in(I,M){return x.create(I,M)}static notIn(I,M){return L.create(I,M)}static not(I){return _.create(I)}static and(...I){return z.create(I,null,!0)}static or(...I){return W.create(I,null,!0)}static greater(I,M){return Y.create(I,M)}static greaterEquals(I,M){return ne.create(I,M)}static smaller(I,M){return ce.create(I,M)}static smallerEquals(I,M){return ue.create(I,M)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(I){return I==null?void 0:this._parser.parse(I)}}t.ContextKeyExpr=i;function s(j){const I=new a({regexParsingWithErrorRecovery:!1});return j.map(M=>(I.parse(M),I.lexingErrors.length>0?I.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,C.localize)(9,null,U.additionalInfo):(0,C.localize)(10,null),offset:U.offset,length:U.lexeme.length})):I.parsingErrors.length>0?I.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function r(j,I){const M=j?j.substituteConstants():void 0,U=I?I.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}function n(j,I){return j.cmp(I)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!1}serialize(){return"false"}keys(){return[]}map(I){return this}negate(){return h.INSTANCE}}t.ContextKeyFalseExpr=o;class h{static{this.INSTANCE=new h}constructor(){this.type=u.True}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!0}serialize(){return"true"}keys(){return[]}map(I){return this}negate(){return o.INSTANCE}}t.ContextKeyTrueExpr=h;class w{static create(I,M=null){const U=c.get(I);return typeof U=="boolean"?U?h.INSTANCE:o.INSTANCE:new w(I,M)}constructor(I,M){this.key=I,this.negated=M,this.type=u.Defined}cmp(I){return I.type!==this.type?this.type-I.type:Q(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=c.get(this.key);return typeof I=="boolean"?I?h.INSTANCE:o.INSTANCE:this}evaluate(I){return!!I.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(I){return I.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}t.ContextKeyDefinedExpr=w;class O{static create(I,M,U=null){if(typeof M=="boolean")return M?w.create(I,U):_.create(I,U);const N=c.get(I);return typeof N=="boolean"?M===(N?"true":"false")?h.INSTANCE:o.INSTANCE:new O(I,M,U)}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.Equals}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=c.get(this.key);if(typeof I=="boolean"){const M=I?"true":"false";return this.value===M?h.INSTANCE:o.INSTANCE}return this}evaluate(I){return I.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(I){return I.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}t.ContextKeyEqualsExpr=O;class x{static create(I,M){return new x(I,M)}constructor(I,M){this.key=I,this.valueKey=M,this.type=u.In,this.negated=null}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.valueKey,I.key,I.valueKey)}equals(I){return I.type===this.type?this.key===I.key&&this.valueKey===I.valueKey:!1}substituteConstants(){return this}evaluate(I){const M=I.getValue(this.valueKey),U=I.getValue(this.key);return Array.isArray(M)?M.includes(U):typeof U=="string"&&typeof M=="object"&&M!==null?d.call(M,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(I){return I.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this.key,this.valueKey)),this.negated}}t.ContextKeyInExpr=x;class L{static create(I,M){return new L(I,M)}constructor(I,M){this.key=I,this.valueKey=M,this.type=u.NotIn,this._negated=x.create(I,M)}cmp(I){return I.type!==this.type?this.type-I.type:this._negated.cmp(I._negated)}equals(I){return I.type===this.type?this._negated.equals(I._negated):!1}substituteConstants(){return this}evaluate(I){return!this._negated.evaluate(I)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(I){return I.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}t.ContextKeyNotInExpr=L;class A{static create(I,M,U=null){if(typeof M=="boolean")return M?_.create(I,U):w.create(I,U);const N=c.get(I);return typeof N=="boolean"?M===(N?"true":"false")?o.INSTANCE:h.INSTANCE:new A(I,M,U)}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.NotEquals}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=c.get(this.key);if(typeof I=="boolean"){const M=I?"true":"false";return this.value===M?o.INSTANCE:h.INSTANCE}return this}evaluate(I){return I.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(I){return I.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}t.ContextKeyNotEqualsExpr=A;class _{static create(I,M=null){const U=c.get(I);return typeof U=="boolean"?U?o.INSTANCE:h.INSTANCE:new _(I,M)}constructor(I,M){this.key=I,this.negated=M,this.type=u.Not}cmp(I){return I.type!==this.type?this.type-I.type:Q(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=c.get(this.key);return typeof I=="boolean"?I?o.INSTANCE:h.INSTANCE:this}evaluate(I){return!I.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(I){return I.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}t.ContextKeyNotExpr=_;function X(j,I){if(typeof j=="string"){const M=parseFloat(j);isNaN(M)||(j=M)}return typeof j=="string"||typeof j=="number"?I(j):o.INSTANCE}class Y{static create(I,M,U=null){return X(M,N=>new Y(I,N,U))}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.Greater}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterExpr=Y;class ne{static create(I,M,U=null){return X(M,N=>new ne(I,N,U))}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.GreaterEquals}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}t.ContextKeyGreaterEqualsExpr=ne;class ce{static create(I,M,U=null){return X(M,N=>new ce(I,N,U))}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.Smaller}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerExpr=ce;class ue{static create(I,M,U=null){return X(M,N=>new ue(I,N,U))}constructor(I,M,U){this.key=I,this.value=M,this.negated=U,this.type=u.SmallerEquals}cmp(I){return I.type!==this.type?this.type-I.type:te(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}t.ContextKeySmallerEqualsExpr=ue;class he{static create(I,M){return new he(I,M)}constructor(I,M){this.key=I,this.regexp=M,this.type=u.Regex,this.negated=null}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.key<I.key)return-1;if(this.key>I.key)return 1;const M=this.regexp?this.regexp.source:"",U=I.regexp?I.regexp.source:"";return M<U?-1:M>U?1:0}equals(I){if(I.type===this.type){const M=this.regexp?this.regexp.source:"",U=I.regexp?I.regexp.source:"";return this.key===I.key&&M===U}return!1}substituteConstants(){return this}evaluate(I){const M=I.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const I=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${I}`}keys(){return[this.key]}map(I){return I.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}t.ContextKeyRegexExpr=he;class B{static create(I){return new B(I)}constructor(I){this._actual=I,this.type=u.NotRegex}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}substituteConstants(){return this}evaluate(I){return!this._actual.evaluate(I)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(I){return new B(this._actual.map(I))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=B;function Z(j){let I=null;for(let M=0,U=j.length;M<U;M++){const N=j[M].substituteConstants();if(j[M]!==N&&I===null){I=[];for(let H=0;H<M;H++)I[H]=j[H]}I!==null&&(I[M]=N)}return I===null?j:I}class z{static create(I,M,U){return z._normalizeArr(I,M,U)}constructor(I,M){this.expr=I,this.negated=M,this.type=u.And}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const N=n(this.expr[M],I.expr[M]);if(N!==0)return N}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(I.expr[M]))return!1;return!0}return!1}substituteConstants(){const I=Z(this.expr);return I===this.expr?this:z.create(I,this.negated,!1)}evaluate(I){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(I))return!1;return!0}static _normalizeArr(I,M,U){const N=[];let H=!1;for(const J of I)if(J){if(J.type===u.True){H=!0;continue}if(J.type===u.False)return o.INSTANCE;if(J.type===u.And){N.push(...J.expr);continue}N.push(J)}if(N.length===0&&H)return h.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(n);for(let J=1;J<N.length;J++)N[J-1].equals(N[J])&&(N.splice(J,1),J--);if(N.length===1)return N[0];for(;N.length>1;){const J=N[N.length-1];if(J.type!==u.Or)break;N.pop();const re=N.pop(),le=N.length===0,ge=W.create(J.expr.map(pe=>z.create([pe,re],null,U)),null,le);ge&&(N.push(ge),N.sort(n))}if(N.length===1)return N[0];if(U){for(let J=0;J<N.length;J++)for(let re=J+1;re<N.length;re++)if(N[J].negate().equals(N[re]))return o.INSTANCE;if(N.length===1)return N[0]}return new z(N,M)}}serialize(){return this.expr.map(I=>I.serialize()).join(" && ")}keys(){const I=[];for(const M of this.expr)I.push(...M.keys());return I}map(I){return new z(this.expr.map(M=>M.map(I)),null)}negate(){if(!this.negated){const I=[];for(const M of this.expr)I.push(M.negate());this.negated=W.create(I,this,!0)}return this.negated}}t.ContextKeyAndExpr=z;class W{static create(I,M,U){return W._normalizeArr(I,M,U)}constructor(I,M){this.expr=I,this.negated=M,this.type=u.Or}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const N=n(this.expr[M],I.expr[M]);if(N!==0)return N}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(I.expr[M]))return!1;return!0}return!1}substituteConstants(){const I=Z(this.expr);return I===this.expr?this:W.create(I,this.negated,!1)}evaluate(I){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(I))return!0;return!1}static _normalizeArr(I,M,U){let N=[],H=!1;if(I){for(let J=0,re=I.length;J<re;J++){const le=I[J];if(le){if(le.type===u.False){H=!0;continue}if(le.type===u.True)return h.INSTANCE;if(le.type===u.Or){N=N.concat(le.expr);continue}N.push(le)}}if(N.length===0&&H)return o.INSTANCE;N.sort(n)}if(N.length!==0){if(N.length===1)return N[0];for(let J=1;J<N.length;J++)N[J-1].equals(N[J])&&(N.splice(J,1),J--);if(N.length===1)return N[0];if(U){for(let J=0;J<N.length;J++)for(let re=J+1;re<N.length;re++)if(N[J].negate().equals(N[re]))return h.INSTANCE;if(N.length===1)return N[0]}return new W(N,M)}}serialize(){return this.expr.map(I=>I.serialize()).join(" || ")}keys(){const I=[];for(const M of this.expr)I.push(...M.keys());return I}map(I){return new W(this.expr.map(M=>M.map(I)),null)}negate(){if(!this.negated){const I=[];for(const M of this.expr)I.push(M.negate());for(;I.length>1;){const M=I.shift(),U=I.shift(),N=[];for(const H of K(M))for(const J of K(U))N.push(z.create([H,J],null,!1));I.unshift(W.create(N,null,!1))}this.negated=W.create(I,this,!0)}return this.negated}}t.ContextKeyOrExpr=W;class G extends w{static{this._info=[]}static all(){return G._info.values()}constructor(I,M,U){super(I,null),this._defaultValue=M,typeof U=="object"?G._info.push({...U,key:I}):U!==!0&&G._info.push({key:I,description:U,type:M!=null?typeof M:void 0})}bindTo(I){return I.createKey(this.key,this._defaultValue)}getValue(I){return I.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(I){return O.create(this.key,I)}notEqualsTo(I){return A.create(this.key,I)}}t.RawContextKey=G,t.IContextKeyService=(0,k.createDecorator)("contextKeyService");function Q(j,I){return j<I?-1:j>I?1:0}function te(j,I,M,U){return j<M?-1:j>M?1:I<U?-1:I>U?1:0}function F(j,I){if(j.type===u.False||I.type===u.True)return!0;if(j.type===u.Or)return I.type===u.Or?V(j.expr,I.expr):!1;if(I.type===u.Or){for(const M of I.expr)if(F(j,M))return!0;return!1}if(j.type===u.And){if(I.type===u.And)return V(I.expr,j.expr);for(const M of j.expr)if(F(M,I))return!0;return!1}return j.equals(I)}function V(j,I){let M=0,U=0;for(;M<j.length&&U<I.length;){const N=j[M].cmp(I[U]);if(N<0)return!1;N===0&&M++,U++}return M===j.length}function K(j){return j.type===u.Or?j.expr:[j]}}),define(oe[61],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,P.createDecorator)("downloadService")}),define(oe[18],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,P.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,P.refineServiceDecorator)(t.IEnvironmentService)}),define(oe[62],ae([0,1,14,9,107,10]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=k;async function k(l,d,u,S,g,T){let y;try{await C(l,d,u,S,g,T)}catch(f){y=f}finally{y&&g.errorTransformer&&(y=g.errorTransformer(y)),typeof y<"u"&&u.error(y),u.end()}}async function C(l,d,u,S,g,T){p(T);const y=await l.open(d,{create:!1});try{p(T);let f=0,m=0,R=g&&typeof g.length=="number"?g.length:void 0,E=P.VSBuffer.alloc(Math.min(g.bufferSize,typeof R=="number"?R:g.bufferSize)),e=g&&typeof g.position=="number"?g.position:0,a=0;do m=await l.read(y,e,E.buffer,a,E.byteLength-a),e+=m,a+=m,f+=m,typeof R=="number"&&(R-=m),a===E.byteLength&&(await u.write(S(E)),E=P.VSBuffer.alloc(Math.min(g.bufferSize,typeof R=="number"?R:g.bufferSize)),a=0);while(m>0&&(typeof R!="number"||R>0)&&p(T)&&c(f,g));if(a>0){let i=a;typeof R=="number"&&(i=Math.min(a,R)),u.write(S(E.slice(0,i)))}}catch(f){throw(0,D.ensureFileSystemProviderError)(f)}finally{await l.close(y)}}function p(l){if(l.isCancellationRequested)throw(0,b.canceled)();return!0}function c(l,d){if(typeof d?.limits?.size=="number"&&l>d.limits.size)throw(0,D.createFileSystemProviderError)((0,v.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[126],ae([0,1,94,2,52,5,10,12,8]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BaseWatcher=void 0;class c extends b.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new D.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new b.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new p.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new p.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(d=>this.handleDidWatchFail(d)))}handleDidWatchFail(d){this.isCorrelated(d)&&this.suspendWatchRequest(d)}isCorrelated(d){return(0,v.isWatchRequestWithCorrelation)(d)}async watch(d){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new p.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const u of d)this.isCorrelated(u)?this.allCorrelatedWatchRequests.set(u.correlationId,u):this.allNonCorrelatedWatchRequests.add(u);for(const[u]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(u)||(this.suspendedWatchRequests.deleteAndDispose(u),this.suspendedWatchRequestsWithPolling.delete(u));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(d){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(u=>!this.suspendedWatchRequests.has(u.correlationId))]),d?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(d.correlationId)?"polling":this.suspendedWatchRequests.has(d.correlationId)}async suspendWatchRequest(d){if(this.suspendedWatchRequests.has(d.correlationId))return;const u=new b.DisposableStore;this.suspendedWatchRequests.set(d.correlationId,u),await this.joinWatch.p,!u.isDisposed&&(this.monitorSuspendedWatchRequest(d,u),this.updateWatchers(!0))}resumeWatchRequest(d){this.suspendedWatchRequests.deleteAndDispose(d.correlationId),this.suspendedWatchRequestsWithPolling.delete(d.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(d,u){this.doMonitorWithExistingWatcher(d,u)?(this.trace(`reusing an existing recursive watcher to monitor ${d.path}`),this.suspendedWatchRequestsWithPolling.delete(d.correlationId)):(this.doMonitorWithNodeJS(d,u),this.suspendedWatchRequestsWithPolling.add(d.correlationId))}doMonitorWithExistingWatcher(d,u){const S=this.recursiveWatcher?.subscribe(d.path,(g,T)=>{u.isDisposed||(g?this.monitorSuspendedWatchRequest(d,u):T?.type===k.FileChangeType.ADDED&&this.onMonitoredPathAdded(d))});return S?(u.add(S),!0):!1}doMonitorWithNodeJS(d,u){let S=!1;const g=(T,y)=>{if(u.isDisposed)return;const f=this.isPathNotFound(T),m=this.isPathNotFound(y),R=S;S=f,!f&&(m||R)&&this.onMonitoredPathAdded(d)};this.trace(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,P.watchFile)(d.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},g)}catch(T){this.warn(`fs.watchFile() failed with error ${T} on path ${d.path} (correlationId: ${d.correlationId})`)}u.add((0,b.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,P.unwatchFile)(d.path,g)}catch(T){this.warn(`fs.unwatchFile() failed with error ${T} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}onMonitoredPathAdded(d){this.trace(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const u={resource:C.URI.file(d.path),type:k.FileChangeType.ADDED,cId:d.correlationId};this._onDidChangeFile.fire([u]),this.traceEvent(u,d),this.resumeWatchRequest(d)}isPathNotFound(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(d,u){if(this.verboseLogging){const S=` >> normalized ${d.type===k.FileChangeType.ADDED?"[ADDED]":d.type===k.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.traceWithCorrelation(S,u)}}traceWithCorrelation(d,u){this.verboseLogging&&this.trace(`${d}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}requestToString(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,v.requestFilterToString)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.verboseLogging=d}}t.BaseWatcher=c}),define(oe[127],ae([0,1,5,174,126,13,175,63]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class p extends v.BaseWatcher{constructor(l){super(),this.recursiveWatcher=l,this.onDidError=P.Event.None,this.watchers=new Set}async doWatch(l){l=this.removeDuplicateRequests(l);const d=[],u=new Set(Array.from(this.watchers));for(const S of l){const g=this.findWatcher(S);g&&(0,b.patternsEquals)(g.request.excludes,S.excludes)&&(0,b.patternsEquals)(g.request.includes,S.includes)?u.delete(g):d.push(S)}d.length&&this.trace(`Request to start watching: ${d.map(S=>this.requestToString(S)).join(",")}`),u.size&&this.trace(`Request to stop watching: ${Array.from(u).map(S=>this.requestToString(S.request)).join(",")}`);for(const S of u)this.stopWatching(S);for(const S of d)this.startWatching(S)}findWatcher(l){for(const d of this.watchers)if(typeof l.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===l.correlationId)return d}else if((0,C.isEqual)(d.request.path,l.path,!D.isLinux))return d}startWatching(l){const d=new k.NodeJSFileWatcherLibrary(l,this.recursiveWatcher,S=>this._onDidChangeFile.fire(S),()=>this._onDidWatchFail.fire(l),S=>this._onDidLogMessage.fire(S),this.verboseLogging),u={request:l,instance:d};this.watchers.add(u)}async stop(){await super.stop();for(const l of this.watchers)this.stopWatching(l)}stopWatching(l){this.trace("stopping file watcher",l),this.watchers.delete(l),l.instance.dispose()}removeDuplicateRequests(l){const d=new Map;for(const u of l){const S=D.isLinux?u.path:u.path.toLowerCase();let g=d.get(u.correlationId);g||(g=new Map,d.set(u.correlationId,g)),g.has(S)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(u)}`),g.set(S,u)}return Array.from(d.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(l){super.setVerboseLogging(l);for(const d of this.watchers)d.instance.setVerboseLogging(l)}trace(l,d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l,d)})}warn(l){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(l)})}toMessage(l,d){return d?`[File Watcher (node.js)] ${l} (${this.requestToString(d.request)})`:`[File Watcher (node.js)] ${l}`}}t.NodeJSWatcher=p}),define(oe[128],ae([0,1,52,127]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class v extends P.AbstractNonRecursiveWatcherClient{constructor(k,C,p){super(k,C,p),this.init()}createWatcher(k){return k.add(new b.NodeJSWatcher(void 0))}}t.NodeJSWatcherClient=v}),define(oe[129],ae([0,1,15,59,91,52]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(p,c,l){super(p,c,l),this.init()}createWatcher(p){const c=p.add(new v.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:l,signal:d})=>this.onError(`terminated by itself with code ${l}, signal: ${d} (ETERM)`))),b.ProxyChannel.toService((0,b.getNextTickChannel)(c.getChannel("watcher")))}}t.UniversalWatcherClient=k}),define(oe[64],ae([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class P{constructor(...v){this._entries=new Map;for(const[D,k]of v)this.set(D,k)}set(v,D){const k=this._entries.get(v);return this._entries.set(v,D),k}has(v){return this._entries.has(v)}get(v){return this._entries.get(v)}}t.ServiceCollection=P}),define(oe[130],ae([0,1,8,9,2,51,124,11,64,176]),function(q,t,P,b,v,D,k,C,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class u{constructor(y=new p.ServiceCollection,f=!1,m,R=l){this._services=y,this._strict=f,this._parent=m,this._enableTracing=R,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=R?m?._globalGraph??new k.Graph(E=>E):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,v.dispose)(this._children),this._children.clear();for(const y of this._servicesToMaybeDispose)(0,v.isDisposable)(y)&&y.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(y,f){this._throwIfDisposed();const m=this,R=new class extends u{dispose(){m._children.delete(R),super.dispose()}}(y,this._strict,this,this._enableTracing);return this._children.add(R),f?.add(R),R}invokeFunction(y,...f){this._throwIfDisposed();const m=g.traceInvocation(this._enableTracing,y);let R=!1;try{return y({get:e=>{if(R)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(e,m);if(!a)throw new Error(`[invokeFunction] unknown service '${e}'`);return a}},...f)}finally{R=!0,m.stop()}}createInstance(y,...f){this._throwIfDisposed();let m,R;return y instanceof D.SyncDescriptor?(m=g.traceCreation(this._enableTracing,y.ctor),R=this._createInstance(y.ctor,y.staticArguments.concat(f),m)):(m=g.traceCreation(this._enableTracing,y),R=this._createInstance(y,f,m)),m.stop(),R}_createInstance(y,f=[],m){const R=C._util.getServiceDependencies(y).sort((a,i)=>a.index-i.index),E=[];for(const a of R){const i=this._getOrCreateServiceInstance(a.id,m);i||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${a.id}.`,!1),E.push(i)}const e=R.length>0?R[0].index:f.length;if(f.length!==e){console.trace(`[createInstance] First service dependency of ${y.name} at position ${e+1} conflicts with ${f.length} static arguments`);const a=e-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,e)}return Reflect.construct(y,f.concat(E))}_setCreatedServiceInstance(y,f){if(this._services.get(y)instanceof D.SyncDescriptor)this._services.set(y,f);else if(this._parent)this._parent._setCreatedServiceInstance(y,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const f=this._services.get(y);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):f}_getOrCreateServiceInstance(y,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const m=this._getServiceInstanceOrDescriptor(y);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,m,f.branch(y,!0)):(f.branch(y,!1),m)}_safeCreateAndCacheServiceInstance(y,f,m){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,f,m)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,f,m){const R=new k.Graph(a=>a.id.toString());let E=0;const e=[{id:y,desc:f,_trace:m}];for(;e.length;){const a=e.pop();if(R.lookupOrInsertNode(a),E++>1e3)throw new d(R);for(const i of C._util.getServiceDependencies(a.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(i.id);if(s||this._throwIfStrict(`[createInstance] ${y} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(i.id)),s instanceof D.SyncDescriptor){const r={id:i.id,desc:s,_trace:a._trace.branch(i.id,!0)};R.insertEdge(a,r),e.push(r)}}}for(;;){const a=R.roots();if(a.length===0){if(!R.isEmpty())throw new d(R);break}for(const{data:i}of a){if(this._getServiceInstanceOrDescriptor(i.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setCreatedServiceInstance(i.id,r)}R.removeNode(i)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,f,m=[],R,E){if(this._services.get(y)instanceof D.SyncDescriptor)return this._createServiceInstance(y,f,m,R,E,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,f,m,R,E);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(y,f,m=[],R,E,e){if(R){const a=new u(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(y);const i=new Map,s=new P.GlobalIdleValue(()=>{const r=a._createInstance(f,m,E);for(const[n,o]of i){const h=r[n];if(typeof h=="function")for(const w of o)w.disposable=h.apply(r,w.listener)}return i.clear(),e.add(r),r});return new Proxy(Object.create(null),{get(r,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let w=i.get(n);return w||(w=new c.LinkedList,i.set(n,w)),(x,L,A)=>{if(s.isInitialized)return s.value[n](x,L,A);{const _={listener:[x,L,A],disposable:void 0},X=w.push(_);return(0,v.toDisposable)(()=>{X(),_.disposable?.dispose()})}}}if(n in r)return r[n];const o=s.value;let h=o[n];return typeof h!="function"||(h=h.bind(o),r[n]=h),h},set(r,n,o){return s.value[n]=o,!0},getPrototypeOf(r){return f.prototype}})}else{const a=this._createInstance(f,m,E);return e.add(a),a}}_throwIfStrict(y,f){if(f&&console.warn(y),this._strict)throw new Error(y)}}t.InstantiationService=u;var S;(function(T){T[T.None=0]="None",T[T.Creation=1]="Creation",T[T.Invocation=2]="Invocation",T[T.Branch=3]="Branch"})(S||(S={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,f){return y?new g(S.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(y,f){return y?new g(S.Creation,f.name):g._None}static{this._totals=0}constructor(y,f){this.type=y,this.name=f,this._start=Date.now(),this._dep=[]}branch(y,f){const m=new g(S.Branch,y.toString());return this._dep.push([y,f,m]),m}stop(){const y=Date.now()-this._start;g._totals+=y;let f=!1;function m(E,e){const a=[],i=new Array(E+1).join("	");for(const[s,r,n]of e._dep)if(r&&n){f=!0,a.push(`${i}CREATES -> ${s}`);const o=m(E+1,n);o&&a.push(o)}else a.push(`${i}uses -> ${s}`);return a.join(`
`)}const R=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(y>2||f)&&g.all.add(R.join(`
`))}}t.Trace=g}),define(oe[6],ae([0,1,110,38,5,43,2,31,13,17,3,12,125,11]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_LOG_LEVEL=t.NullLogService=t.NullLogger=t.AbstractLoggerService=t.MultiplexLogger=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.isLogLevel=T,t.log=f,t.getLogLevel=h,t.LogLevelToString=w,t.LogLevelToLocalizedString=O,t.parseLogLevel=x,P=we(P),t.ILogService=(0,S.createDecorator)("logService"),t.ILoggerService=(0,S.createDecorator)("loggerService");function g(){return new Date().toISOString()}function T(L){return(0,l.isNumber)(L)}var y;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(y||(t.LogLevel=y={})),t.DEFAULT_LOG_LEVEL=y.Info;function f(L,A,_){switch(A){case y.Trace:L.trace(_);break;case y.Debug:L.debug(_);break;case y.Info:L.info(_);break;case y.Warning:L.warn(_);break;case y.Error:L.error(_);break;case y.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function m(L,A=!1){let _="";for(let X=0;X<L.length;X++){let Y=L[X];if(Y instanceof Error&&(Y=(0,b.toErrorMessage)(Y,A)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}_+=(X>0?" ":"")+Y}return _}class R extends k.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new v.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(A){this.level!==A&&(this.level=A,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(A){return this.level!==y.Off&&this.level<=A}}t.AbstractLogger=R;class E extends R{constructor(A){super(),this.logAlways=A}checkLogLevel(A){return this.logAlways||super.checkLogLevel(A)}trace(A,..._){this.checkLogLevel(y.Trace)&&this.log(y.Trace,m([A,..._],!0))}debug(A,..._){this.checkLogLevel(y.Debug)&&this.log(y.Debug,m([A,..._]))}info(A,..._){this.checkLogLevel(y.Info)&&this.log(y.Info,m([A,..._]))}warn(A,..._){this.checkLogLevel(y.Warning)&&this.log(y.Warning,m([A,..._]))}error(A,..._){if(this.checkLogLevel(y.Error))if(A instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=A.stack,this.log(y.Error,m(X))}else this.log(y.Error,m([A,..._]))}flush(){}}t.AbstractMessageLogger=E;class e extends R{constructor(A=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(A),this.useColors=!p.isWindows}trace(A,..._){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,..._):console.log(`[main ${g()}]`,A,..._))}debug(A,..._){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,..._):console.log(`[main ${g()}]`,A,..._))}info(A,..._){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,A,..._):console.log(`[main ${g()}]`,A,..._))}warn(A,..._){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,A,..._):console.warn(`[main ${g()}]`,A,..._))}error(A,..._){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,A,..._):console.error(`[main ${g()}]`,A,..._))}flush(){}}t.ConsoleMainLogger=e;class a extends R{constructor(A=t.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(A)}trace(A,..._){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",A,..._):console.log(A,..._))}debug(A,..._){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",A,..._):console.log(A,..._))}info(A,..._){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",A,..._):console.log(A,..._))}warn(A,..._){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",A,..._):console.log(A,..._))}error(A,..._){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",A,..._):console.error(A,..._))}flush(){}}t.ConsoleLogger=a;class i extends R{constructor(A,_=t.DEFAULT_LOG_LEVEL){super(),this.adapter=A,this.setLevel(_)}trace(A,..._){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(A),..._])}debug(A,..._){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(A),..._])}info(A,..._){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(A),..._])}warn(A,..._){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(A),..._])}error(A,..._){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(A),..._])}extractMessage(A){return typeof A=="string"?A:(0,b.toErrorMessage)(A,this.checkLogLevel(y.Trace))}flush(){}}t.AdapterLogger=i;class s extends R{constructor(A){super(),this.loggers=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const _ of this.loggers)_.setLevel(A);super.setLevel(A)}trace(A,..._){for(const X of this.loggers)X.trace(A,..._)}debug(A,..._){for(const X of this.loggers)X.debug(A,..._)}info(A,..._){for(const X of this.loggers)X.info(A,..._)}warn(A,..._){for(const X of this.loggers)X.warn(A,..._)}error(A,..._){for(const X of this.loggers)X.error(A,..._)}flush(){for(const A of this.loggers)A.flush()}dispose(){for(const A of this.loggers)A.dispose();super.dispose()}}t.MultiplexLogger=s;class r extends k.Disposable{constructor(A,_,X){if(super(),this.logLevel=A,this.logsHome=_,this._loggers=new C.ResourceMap,this._onDidChangeLoggers=this._register(new v.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new v.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new v.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,X)for(const Y of X)this._loggers.set(Y.resource,{logger:void 0,info:Y})}getLoggerEntry(A){return(0,l.isString)(A)?[...this._loggers.values()].find(_=>_.info.id===A):this._loggers.get(A)}getLogger(A){return this.getLoggerEntry(A)?.logger}createLogger(A,_){const X=this.toResource(A),Y=(0,l.isString)(A)?A:_?.id??(0,D.hash)(X.toString()).toString(16);let ne=this._loggers.get(X)?.logger;const ce=_?.logLevel==="always"?y.Trace:_?.logLevel;ne||(ne=this.doCreateLogger(X,ce??this.getLogLevel(X)??this.logLevel,{..._,id:Y}));const ue={logger:ne,info:{resource:X,id:Y,logLevel:ce,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ue.info),this._loggers.set(X,ue),ne}toResource(A){return(0,l.isString)(A)?(0,c.joinPath)(this.logsHome,`${A}.log`):A}setLogLevel(A,_){if(d.URI.isUri(A)){const X=A,Y=_,ne=this._loggers.get(X);ne&&Y!==ne.info.logLevel&&(ne.info.logLevel=Y===this.logLevel?void 0:Y,ne.logger?.setLevel(Y),this._loggers.set(ne.info.resource,ne),this._onDidChangeLogLevel.fire([X,Y]))}else{this.logLevel=A;for(const[X,Y]of this._loggers.entries())this._loggers.get(X)?.info.logLevel===void 0&&Y.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(A,_){const X=this.getLoggerEntry(A);X&&_!==!X.info.hidden&&(X.info.hidden=!_,this._loggers.set(X.info.resource,X),this._onDidChangeVisibility.fire([X.info.resource,_]))}getLogLevel(A){let _;return A&&(_=this._loggers.get(A)?.info.logLevel),_??this.logLevel}registerLogger(A){const _=this._loggers.get(A.resource);_?_.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this._loggers.set(A.resource,{info:A,logger:void 0}),this._onDidChangeLoggers.fire({added:[A],removed:[]}))}deregisterLogger(A){const _=this._loggers.get(A);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(A),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const A of this._loggers.values())yield A.info}getRegisteredLogger(A){return this._loggers.get(A)?.info}dispose(){this._loggers.forEach(A=>A.logger?.dispose()),this._loggers.clear(),super.dispose()}}t.AbstractLoggerService=r;class n{constructor(){this.onDidChangeLogLevel=new v.Emitter().event}setLevel(A){}getLevel(){return y.Info}trace(A,..._){}debug(A,..._){}info(A,..._){}warn(A,..._){}error(A,..._){}critical(A,..._){}dispose(){}flush(){}}t.NullLogger=n;class o extends n{}t.NullLogService=o;function h(L){if(L.verbose)return y.Trace;if(typeof L.logLevel=="string"){const A=x(L.logLevel.toLowerCase());if(A!==void 0)return A}return t.DEFAULT_LOG_LEVEL}function w(L){switch(L){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function O(L){switch(L){case y.Trace:return{original:"Trace",value:P.localize(0,null)};case y.Debug:return{original:"Debug",value:P.localize(1,null)};case y.Info:return{original:"Info",value:P.localize(2,null)};case y.Warning:return{original:"Warning",value:P.localize(3,null)};case y.Error:return{original:"Error",value:P.localize(4,null)};case y.Off:return{original:"Off",value:P.localize(5,null)}}}function x(L){switch(L){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}t.CONTEXT_LOG_LEVEL=new u.RawContextKey("logLevel",w(y.Info))}),define(oe[131],ae([0,1,20,8,9,5,63,2,16,52,6]),function(q,t,P,b,v,D,k,C,p,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class d extends C.Disposable{constructor(S,g){super(),this.logService=S,this.options=g,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new b.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}watch(S,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,g):this.watchNonRecursive(S,g)}watchUniversal(S,g){const T={path:this.toWatchPath(S),excludes:g.excludes,includes:g.includes,recursive:g.recursive,filter:g.filter,correlationId:g.correlationId},y=(0,P.insert)(this.universalWatchRequests,T);return this.refreshUniversalWatchers(),(0,C.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,v.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const g of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const g of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(g)&&S.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(S,g){const T={path:this.toWatchPath(S),excludes:g.excludes,includes:g.includes,recursive:!1,filter:g.filter,correlationId:g.correlationId},y=(0,P.insert)(this.nonRecursiveWatchRequests,T);return this.refreshNonRecursiveWatchers(),(0,C.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,v.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logWatcherMessage(S)}logWatcherMessage(S){this.logService[S.type](S.message)}toFilePath(S){return(0,p.normalize)(S.fsPath)}toWatchPath(S){const g=this.toFilePath(S);return(0,k.removeTrailingPathSeparator)(g)}}t.AbstractDiskFileSystemProvider=d});var se=this&&this.__param||function(q,t){return function(P,b){t(P,b,q)}};define(oe[132],ae([0,1,20,8,14,22,5,43,65,2,49,15,133,17,47,106,10,62,6,9]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let e=class extends c.Disposable{static{E=this}constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(i,s){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${i}`);const r=new c.DisposableStore;return this.provider.set(i,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:s}),r.add(s.onDidChangeFile(n=>{const o=new y.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:i}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:s}),this.provider.delete(i),(0,c.dispose)(r)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(r){s.push(r)}}),!this.provider.has(i)&&await b.Promises.settled(s)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,s){const r=this.provider.get(i.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return p.Iterable.map(this.provider,([i,s])=>({scheme:i,capabilities:s.capabilities}))}async withProvider(i){if(!(0,S.isAbsolutePath)(i))throw new y.FileOperationError((0,T.localize)(0,null,this.resourceForError(i)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const s=this.provider.get(i.scheme);if(!s){const r=new R.ErrorNoTelemetry;throw r.message=(0,T.localize)(1,null,i.toString()),r}return s}async withReadProvider(i){const s=await this.withProvider(i);if((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s)||(0,y.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const s=await this.withProvider(i);if((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,s){try{return await this.doResolveFile(i,s)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,T.localize)(2,null,this.resourceForError(i)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(i,s){const r=await this.withProvider(i),n=this.isPathCaseSensitive(r),o=s?.resolveTo,h=s?.resolveSingleChildDescendants,w=s?.resolveMetadata,O=await r.stat(i);let x;return this.toFileStat(r,i,O,void 0,!!w,(L,A)=>(x||(x=l.TernarySearchTree.forUris(()=>!n),x.set(i,!0),o&&x.fill(!0,o)),x.get(L.resource)||x.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&h?A===1:!1))}async toFileStat(i,s,r,n,o,h){const{providerExtUri:w}=this.getExtUri(i),O={resource:s,name:w.basename(s),isFile:(r.type&y.FileType.File)!==0,isDirectory:(r.type&y.FileType.Directory)!==0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&y.FilePermission.Readonly)||!!(i.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((r.permissions??0)&y.FilePermission.Locked),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(O.isDirectory&&h(O,n)){try{const x=await i.readdir(s),L=await b.Promises.settled(x.map(async([A,_])=>{try{const X=w.joinPath(s,A),Y=o?await i.stat(X):{type:_};return await this.toFileStat(i,X,Y,x.length,o,h)}catch(X){return this.logService.trace(X),null}}));O.children=(0,P.coalesce)(L)}catch(x){this.logService.trace(x),O.children=[]}return O}return O}async resolveAll(i){return b.Promises.settled(i.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(i){const s=await this.withProvider(i),r=await s.stat(i);return this.toFileStat(s,i,r,void 0,!0,()=>!1)}async exists(i){const s=await this.withProvider(i);try{return!!await s.stat(i)}catch{return!1}}async canCreateFile(i,s){try{await this.doValidateCreateFile(i,s)}catch(r){return r}return!0}async doValidateCreateFile(i,s){if(!s?.overwrite&&await this.exists(i))throw new y.FileOperationError((0,T.localize)(3,null,this.resourceForError(i)),y.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(i,s=v.VSBuffer.fromString(""),r){await this.doValidateCreateFile(i,r);const n=await this.writeFile(i,s);return this._onDidRunOperation.fire(new y.FileOperationEvent(i,y.FileOperation.CREATE,n)),n}async writeFile(i,s,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:o}=this.getExtUri(n);let h=r;if((0,y.hasFileAtomicWriteCapability)(n)&&!h?.atomic){const w=n.enforceAtomicWriteFile?.(i);w&&(h={...r,atomic:w})}try{await this.validateWriteFile(n,i,h)||await this.mkdirp(n,o.dirname(i));let O;if((0,y.hasReadWriteCapability)(n)&&!(s instanceof v.VSBuffer))if((0,g.isReadableStream)(s)){const x=await(0,g.peekStream)(s,3);x.ended?O=v.VSBuffer.concat(x.buffer):O=x}else O=(0,g.peekReadable)(s,x=>v.VSBuffer.concat(x),3);else O=s;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&O instanceof v.VSBuffer||(0,y.hasReadWriteCapability)(n)&&(0,y.hasFileAtomicWriteCapability)(n)&&h?.atomic?await this.doWriteUnbuffered(n,i,h,O):await this.doWriteBuffered(n,i,h,O instanceof v.VSBuffer?(0,v.bufferToReadable)(O):O),this._onDidRunOperation.fire(new y.FileOperationEvent(i,y.FileOperation.WRITE))}catch(w){throw new y.FileOperationError((0,T.localize)(4,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(w).toString()),(0,y.toFileOperationResult)(w),h)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,s,r){const n=!!r?.unlock;if(n&&!(i.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,T.localize)(5,null,this.resourceForError(s)));if(!!r?.atomic){if(!(i.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,T.localize)(6,null,this.resourceForError(s)));if(!(i.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,T.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,T.localize)(8,null,this.resourceForError(s)))}let h;try{h=await i.stat(s)}catch{return}if(h.type&y.FileType.Directory)throw new y.FileOperationError((0,T.localize)(9,null,this.resourceForError(s)),y.FileOperationResult.FILE_IS_DIRECTORY,r);if(this.throwIfFileIsReadonly(s,h),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof h.mtime=="number"&&typeof h.size=="number"&&r.mtime<h.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:h.size}))throw new y.FileOperationError((0,T.localize)(10,null),y.FileOperationResult.FILE_MODIFIED_SINCE,r);return h}async readFile(i,s,r){const n=await this.withReadProvider(i);return s?.atomic?this.doReadFileAtomic(n,i,s,r):this.doReadFile(n,i,s,r)}async doReadFileAtomic(i,s,r,n){return new Promise((o,h)=>{this.writeQueue.queueFor(s,async()=>{try{const w=await this.doReadFile(i,s,r,n);o(w)}catch(w){h(w)}},this.getExtUri(i).providerExtUri)})}async doReadFile(i,s,r,n){const o=await this.doReadFileStream(i,s,{...r,preferUnbuffered:!0},n);return{...o,value:await(0,v.streamToBuffer)(o.value)}}async readFileStream(i,s,r){const n=await this.withReadProvider(i);return this.doReadFileStream(n,i,s,r)}async doReadFileStream(i,s,r,n){const o=new D.CancellationTokenSource(n);let h=r;(0,y.hasFileAtomicReadCapability)(i)&&i.enforceAtomicReadFile?.(s)&&(h={...r,atomic:!0});const w=this.validateReadFile(s,h).then(x=>x,x=>{throw o.dispose(!0),x});let O;try{return typeof h?.etag=="string"&&h.etag!==y.ETAG_DISABLED&&await w,h?.atomic&&(0,y.hasFileAtomicReadCapability)(i)||!((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasFileReadStreamCapability)(i))||(0,y.hasReadWriteCapability)(i)&&h?.preferUnbuffered?O=this.readFileUnbuffered(i,s,h):(0,y.hasFileReadStreamCapability)(i)?O=this.readFileStreamed(i,s,o.token,h):O=this.readFileBuffered(i,s,o.token,h),O.on("end",()=>o.dispose()),O.on("error",()=>o.dispose()),{...await w,value:O}}catch(x){throw O&&await(0,g.consumeStream)(O),this.restoreReadError(x,s,h)}}restoreReadError(i,s,r){const n=(0,T.localize)(11,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(i).toString());return i instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(n,i.stat,r):i instanceof y.TooLargeFileOperationError?new y.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new y.FileOperationError(n,(0,y.toFileOperationResult)(i),r)}readFileStreamed(i,s,r,n=Object.create(null)){const o=i.readFileStream(s,n,r);return(0,g.transform)(o,{data:h=>h instanceof v.VSBuffer?h:v.VSBuffer.wrap(h),error:h=>this.restoreReadError(h,s,n)},h=>v.VSBuffer.concat(h))}readFileBuffered(i,s,r,n=Object.create(null)){const o=(0,v.newWriteableBufferStream)();return(0,f.readFileIntoStream)(i,s,o,h=>h,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:h=>this.restoreReadError(h,s,n)},r),o}readFileUnbuffered(i,s,r){const n=(0,g.newWriteableStream)(o=>v.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,y.hasFileAtomicReadCapability)(i)?o=await i.readFile(s,{atomic:!0}):o=await i.readFile(s),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.validateReadFileLimits(s,o.byteLength,r),n.end(v.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(i,s){const r=await this.resolve(i,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,T.localize)(12,null,this.resourceForError(i)),y.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==y.ETAG_DISABLED&&s.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,T.localize)(13,null),r,s);return this.validateReadFileLimits(i,r.size,s),r}validateReadFileLimits(i,s,r){if(typeof r?.limits?.size=="number"&&s>r.limits.size)throw new y.TooLargeFileOperationError((0,T.localize)(14,null,this.resourceForError(i)),y.FileOperationResult.FILE_TOO_LARGE,s,r)}async canMove(i,s,r){return this.doCanMoveCopy(i,s,"move",r)}async canCopy(i,s,r){return this.doCanMoveCopy(i,s,"copy",r)}async doCanMoveCopy(i,s,r,n){if(i.toString()!==s.toString())try{const o=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(o,i,h,s,r,n)}catch(o){return o}return!0}async move(i,s,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),h=await this.doMoveCopy(n,i,o,s,"move",!!r),w=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(i,h==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,w)),w}async copy(i,s,r){const n=await this.withReadProvider(i),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),h=await this.doMoveCopy(n,i,o,s,"copy",!!r),w=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(i,h==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,w)),w}async doMoveCopy(i,s,r,n,o,h){if(s.toString()===n.toString())return o;const{exists:w,isSameResourceWithDifferentPathCase:O}=await this.doValidateMoveCopy(i,s,r,n,o,h);if(w&&!O&&h&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),o==="copy"){if(i===r&&(0,y.hasFileFolderCopyCapability)(i))await i.copy(s,n,{overwrite:h});else{const x=await this.resolve(s);x.isDirectory?await this.doCopyFolder(i,x,r,n):await this.doCopyFile(i,s,r,n)}return o}else return i===r?(await i.rename(s,n,{overwrite:h}),o):(await this.doMoveCopy(i,s,r,n,"copy",h),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(i,s,r,n){if((0,y.hasOpenReadWriteCloseCapability)(i)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(i,s,r,n);if((0,y.hasOpenReadWriteCloseCapability)(i)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(i,s,r,n);if((0,y.hasReadWriteCapability)(i)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(i,s,r,n);if((0,y.hasReadWriteCapability)(i)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(i,s,r,n)}async doCopyFolder(i,s,r,n){await r.mkdir(n),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async o=>{const h=this.getExtUri(r).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(i,await this.resolve(o.resource),r,h):this.doCopyFile(i,o.resource,r,h)}))}async doValidateMoveCopy(i,s,r,n,o,h){let w=!1;if(i===r){const{providerExtUri:x,isPathCaseSensitive:L}=this.getExtUri(i);if(L||(w=x.isEqual(s,n)),w&&o==="copy")throw new Error((0,T.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!w&&x.isEqualOrParent(n,s))throw new Error((0,T.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const O=await this.exists(n);if(O&&!w){if(!h)throw new y.FileOperationError((0,T.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(i===r){const{providerExtUri:x}=this.getExtUri(i);if(x.isEqualOrParent(s,n))throw new Error((0,T.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:O,isSameResourceWithDifferentPathCase:w}}getExtUri(i){const s=this.isPathCaseSensitive(i);return{providerExtUri:s?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(i){return!!(i.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(s,i);const r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(i,y.FileOperation.CREATE,r)),r}async mkdirp(i,s){const r=[],{providerExtUri:n}=this.getExtUri(i);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await i.stat(s)).type&y.FileType.Directory))throw new Error((0,T.localize)(19,null,this.resourceForError(s)));break}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(n.basename(s)),s=n.dirname(s)}for(let o=r.length-1;o>=0;o--){s=n.joinPath(s,r[o]);try{await i.mkdir(s)}catch(h){if((0,y.toFileSystemProviderErrorCode)(h)!==y.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(i,s){try{await this.doValidateDelete(i,s)}catch(r){return r}return!0}async doValidateDelete(i,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i),n=!!s?.useTrash;if(n&&!(r.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,T.localize)(20,null,this.resourceForError(i)));const o=s?.atomic;if(o&&!(r.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,T.localize)(21,null,this.resourceForError(i)));if(n&&o)throw new Error((0,T.localize)(22,null,this.resourceForError(i)));let h;try{h=await r.stat(i)}catch{}if(h)this.throwIfFileIsReadonly(i,h);else throw new y.FileOperationError((0,T.localize)(23,null,this.resourceForError(i)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const O=await this.resolve(i);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,T.localize)(24,null,this.resourceForError(i)))}return r}async del(i,s){const r=await this.doValidateDelete(i,s);let n=s;if((0,y.hasFileAtomicDeleteCapability)(r)&&!n?.atomic){const O=r.enforceAtomicDelete?.(i);O&&(n={...s,atomic:O})}const o=!!n?.useTrash,h=!!n?.recursive,w=n?.atomic??!1;await r.delete(i,{recursive:h,useTrash:o,atomic:w}),this._onDidRunOperation.fire(new y.FileOperationEvent(i,y.FileOperation.DELETE))}async cloneFile(i,s){const r=await this.withProvider(i),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(!(r===n&&this.getExtUri(r).providerExtUri.isEqual(i,s)))return r===n&&(0,y.hasFileCloneCapability)(r)?r.cloneFile(i,s):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),r===n&&(0,y.hasFileFolderCopyCapability)(r)?this.writeQueue.queueFor(i,()=>r.copy(i,s,{overwrite:!0}),this.getExtUri(r).providerExtUri):this.writeQueue.queueFor(i,()=>this.doCopyFile(r,i,n,s),this.getExtUri(r).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(i,s){return this.watch(i,{...s,correlationId:E.WATCHER_CORRELATION_IDS++})}watch(i,s={recursive:!1,excludes:[]}){const r=new c.DisposableStore;let n=!1,o=()=>{n=!0};r.add((0,c.toDisposable)(()=>o())),(async()=>{try{const w=await this.doWatch(i,s);n?(0,c.dispose)(w):o=()=>(0,c.dispose)(w)}catch(w){this.logService.error(w)}})();const h=s.correlationId;if(typeof h=="number"){const w=r.add(new k.Emitter);return r.add(this.internalOnDidFilesChange.event(x=>{x.correlates(h)&&w.fire(x)})),{onDidChange:w.event,dispose:()=>r.dispose()}}return r}async doWatch(i,s){const r=await this.withProvider(i),n=(0,C.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(i),s]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:r.watch(i,s)},this.activeWatchers.set(n,o)),o.count+=1,(0,c.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,c.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,c.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,s,r,n){return this.writeQueue.queueFor(s,async()=>{const o=await i.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,g.isReadableStream)(n)||(0,g.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(i,o,n):await this.doWriteReadableBufferedQueued(i,o,n)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await i.close(o)}},this.getExtUri(i).providerExtUri)}async doWriteStreamBufferedQueued(i,s,r){let n=0,o;if((0,g.isReadableBufferedStream)(r)){if(r.buffer.length>0){const h=v.VSBuffer.concat(r.buffer);await this.doWriteBuffer(i,s,h,h.byteLength,n,0),n+=h.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((h,w)=>{(0,g.listenStream)(o,{onData:async O=>{o.pause();try{await this.doWriteBuffer(i,s,O,O.byteLength,n,0)}catch(x){return w(x)}n+=O.byteLength,setTimeout(()=>o.resume())},onError:O=>w(O),onEnd:()=>h()})})}async doWriteReadableBufferedQueued(i,s,r){let n=0,o;for(;(o=r.read())!==null;)await this.doWriteBuffer(i,s,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(i,s,r,n,o,h){let w=0;for(;w<n;){const O=await i.write(s,o+w,r.buffer,h+w,n-w);w+=O}}async doWriteUnbuffered(i,s,r,n){return this.writeQueue.queueFor(s,()=>this.doWriteUnbufferedQueued(i,s,r,n),this.getExtUri(i).providerExtUri)}async doWriteUnbufferedQueued(i,s,r,n){let o;n instanceof v.VSBuffer?o=n:(0,g.isReadableStream)(n)?o=await(0,v.streamToBuffer)(n):(0,g.isReadableBufferedStream)(n)?o=await(0,v.bufferedStreamToBuffer)(n):o=(0,v.readableToBuffer)(n),await i.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async doPipeBuffered(i,s,r,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(i,s,r,n),this.getExtUri(r).providerExtUri)}async doPipeBufferedQueued(i,s,r,n){let o,h;try{o=await i.open(s,{create:!1}),h=await r.open(n,{create:!0,unlock:!1});const w=v.VSBuffer.alloc(this.BUFFER_SIZE);let O=0,x=0,L=0;do L=await i.read(o,O,w.buffer,x,w.byteLength-x),await this.doWriteBuffer(r,h,w,L,O,x),O+=L,x+=L,x===w.byteLength&&(x=0);while(L>0)}catch(w){throw(0,y.ensureFileSystemProviderError)(w)}finally{await b.Promises.settled([typeof o=="number"?i.close(o):Promise.resolve(),typeof h=="number"?r.close(h):Promise.resolve()])}}async doPipeUnbuffered(i,s,r,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(i,s,r,n),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedQueued(i,s,r,n){return r.writeFile(n,await i.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(i,s,r,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(i,s,r,n),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedToBufferedQueued(i,s,r,n){const o=await r.open(n,{create:!0,unlock:!1});try{const h=await i.readFile(s);await this.doWriteBuffer(r,o,v.VSBuffer.wrap(h),h.byteLength,0,0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await r.close(o)}}async doPipeBufferedToUnbuffered(i,s,r,n){const o=await(0,v.streamToBuffer)(this.readFileBuffered(i,s,D.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,o)}throwIfFileSystemIsReadonly(i,s){if(i.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.FileOperationError((0,T.localize)(25,null,this.resourceForError(s)),y.FileOperationResult.FILE_PERMISSION_DENIED);return i}throwIfFileIsReadonly(i,s){if((s.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,T.localize)(26,null,this.resourceForError(i)),y.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(i){return i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}};t.FileService=e,t.FileService=e=E=Ee([se(0,m.ILogService)],e)}),define(oe[134],ae([0,1,8,31,14,5,63,2,16,13,17,47,26,108,10,62,131,129,128]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class R extends y.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(e,a){super(e,a),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new b.ResourceMap(i=>l.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,c.isLinux&&(this._capabilities|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(e){try{const{stat:a,symbolicLink:i}=await u.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(a,i),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:g.FilePermission.Locked}}catch(a){throw this.toFileSystemProviderError(a)}}async statIgnoreError(e){try{return await this.stat(e)}catch{return}}async readdir(e){try{const a=await u.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),i=[];return await Promise.all(a.map(async s=>{try{let r;s.isSymbolicLink()?r=(await this.stat((0,l.joinPath)(e,s.name))).type:r=this.toType(s),i.push([s.name,r])}catch(r){this.logService.trace(r)}})),i}catch(a){throw this.toFileSystemProviderError(a)}}toType(e,a){let i;return a?.dangling?i=g.FileType.Unknown:e.isFile()?i=g.FileType.File:e.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,a&&(i|=g.FileType.SymbolicLink),i}async createResourceLock(e){const a=this.toFilePath(e);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let i;for(;i=this.resourceLocks.get(e);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await i.wait();const s=new P.Barrier;return this.resourceLocks.set(e,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,C.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(e)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(e)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),s.open()})}async readFile(e,a){let i;try{a?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),i=await this.createResourceLock(e));const s=this.toFilePath(e);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{i?.dispose()}}traceLock(e){R.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(e)}readFileStream(e,a,i){const s=(0,d.newWriteableStream)(r=>v.VSBuffer.concat(r.map(n=>v.VSBuffer.wrap(n))).buffer);return(0,T.readFileIntoStream)(this,e,s,r=>r.buffer,{...a,bufferSize:256*1024},i),s}async writeFile(e,a,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.canWriteFileAtomic(e)?this.doWriteFileAtomic(e,(0,l.joinPath)((0,l.dirname)(e),`${(0,l.basename)(e)}${i.atomic.postfix}`),a,i):this.doWriteFile(e,a,i)}async canWriteFileAtomic(e){try{const a=this.toFilePath(e),{symbolicLink:i}=await u.SymlinkSupport.stat(a);if(i)return!1}catch{}return!0}async doWriteFileAtomic(e,a,i,s){const r=new C.DisposableStore;try{r.add(await this.createResourceLock(e)),r.add(await this.createResourceLock(a)),await this.doWriteFile(a,i,s,!0);try{await this.rename(a,e,{overwrite:!0})}catch(n){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{r.dispose()}}async doWriteFile(e,a,i,s){let r;try{const n=this.toFilePath(e);if(!i.create||!i.overwrite){if(await u.Promises.exists(n)){if(!i.overwrite)throw(0,g.createFileSystemProviderError)((0,S.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.createFileSystemProviderError)((0,S.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(e,{create:!0,unlock:i.unlock},s),await this.write(r,0,a,0,a.byteLength)}catch(n){throw await this.toFileSystemProviderWriteError(e,n)}finally{typeof r=="number"&&await this.close(r)}}static{this.canFlush=!0}static configureFlushOnWrite(e){R.canFlush=e}async open(e,a,i){const s=this.toFilePath(e);let r;(0,g.isFileOpenForWriteOptions)(a)&&!i&&(r=await this.createResourceLock(e));let n;try{if((0,g.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:h}=await u.SymlinkSupport.stat(s);h.mode&128||await u.Promises.chmod(s,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let o;if((0,g.isFileOpenForWriteOptions)(a)){if(c.isWindows)try{await u.Promises.truncate(s,0),o="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}o||(o="w")}else o="r";n=await u.Promises.open(s,o)}catch(o){throw r?.dispose(),(0,g.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(e,o):this.toFileSystemProviderError(o)}if(this.mapHandleToPos.set(n,0),(0,g.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(n,e),r){const o=this.mapHandleToLock.get(n);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${s})`),this.mapHandleToLock.set(n,r),o&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${s})`),o.dispose())}return n}async close(e){const a=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&R.canFlush)try{await u.Promises.fdatasync(e)}catch(i){R.configureFlushOnWrite(!1),this.logService.error(i)}return await u.Promises.close(e)}catch(i){throw this.toFileSystemProviderError(i)}finally{a&&(this.mapHandleToLock.get(e)===a&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),a.dispose())}}async read(e,a,i,s,r){const n=this.normalizePos(e,a);let o=null;try{o=(await u.Promises.read(e,i,s,r,n)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(e,n,o)}return o}normalizePos(e,a){return a===this.mapHandleToPos.get(e)?null:a}updatePos(e,a,i){const s=this.mapHandleToPos.get(e);typeof s=="number"&&(typeof a=="number"||(typeof i=="number"?this.mapHandleToPos.set(e,s+i):this.mapHandleToPos.delete(e)))}async write(e,a,i,s,r){return(0,P.retry)(()=>this.doWrite(e,a,i,s,r),100,3)}async doWrite(e,a,i,s,r){const n=this.normalizePos(e,a);let o=null;try{o=(await u.Promises.write(e,i,s,r,n)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),h)}finally{this.updatePos(e,n,o)}return o}async mkdir(e){try{await u.Promises.mkdir(this.toFilePath(e))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(e,a){try{const i=this.toFilePath(e);if(a.recursive){let s;a?.atomic!==!1&&a.atomic.postfix&&(s=(0,p.join)((0,p.dirname)(i),`${(0,p.basename)(i)}${a.atomic.postfix}`)),await u.Promises.rm(i,u.RimRafMode.MOVE,s)}else try{await u.Promises.unlink(i)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let r=!1;try{const{stat:n,symbolicLink:o}=await u.SymlinkSupport.stat(i);r=n.isDirectory()&&!o}catch{}if(r)await u.Promises.rmdir(i);else throw s}else throw s}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(e,a,i){const s=this.toFilePath(e),r=this.toFilePath(a);if(s!==r)try{await this.validateMoveCopy(e,a,"move",i.overwrite),await u.Promises.rename(s,r)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,S.localize)(2,null,(0,p.basename)(s),(0,p.basename)((0,p.dirname)(r)),n.toString()))),this.toFileSystemProviderError(n)}}async copy(e,a,i){const s=this.toFilePath(e),r=this.toFilePath(a);if(s!==r)try{await this.validateMoveCopy(e,a,"copy",i.overwrite),await u.Promises.copy(s,r,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,S.localize)(3,null,(0,p.basename)(s),(0,p.basename)((0,p.dirname)(r)),n.toString()))),this.toFileSystemProviderError(n)}}async validateMoveCopy(e,a,i,s){const r=this.toFilePath(e),n=this.toFilePath(a);let o=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,k.isEqual)(r,n,!0)),o){if(i==="copy")throw(0,g.createFileSystemProviderError)((0,S.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const w=await this.statIgnoreError(e);if(!w)throw(0,g.createFileSystemProviderError)((0,S.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(a);if(O){if(!s)throw(0,g.createFileSystemProviderError)((0,S.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);w.type&g.FileType.File&&O.type&g.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(e,a){return this.doCloneFile(e,a,!1)}async doCloneFile(e,a,i){const s=this.toFilePath(e),r=this.toFilePath(a),n=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.isEqual)(s,r,!n))return;const o=new C.DisposableStore;try{o.add(await this.createResourceLock(e)),o.add(await this.createResourceLock(a)),i&&await u.Promises.mkdir((0,p.dirname)(r),{recursive:!0}),await u.Promises.copyFile(s,r)}catch(h){if(h.code==="ENOENT"&&!i)return this.doCloneFile(e,a,!0);throw this.toFileSystemProviderError(h)}finally{o.dispose()}}createUniversalWatcher(e,a,i){return new f.UniversalWatcherClient(s=>e(s),s=>a(s),i)}createNonRecursiveWatcher(e,a,i){return new m.NodeJSWatcherClient(s=>e(s),s=>a(s),i)}toFileSystemProviderError(e){if(e instanceof g.FileSystemProviderError)return e;let a=e,i;switch(e.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${e.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(a,i)}async toFileSystemProviderWriteError(e,a){let i=this.toFileSystemProviderError(a);if(e&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(e));s.mode&128||(i=(0,g.createFileSystemProviderError)(a,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return i}}t.DiskFileSystemProvider=R}),define(oe[135],ae([0,1,2,6]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogService=void 0;class v extends P.Disposable{constructor(k,C=[]){super(),this.logger=new b.MultiplexLogger([k,...C]),this._register(k.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...C){this.logger.trace(k,...C)}debug(k,...C){this.logger.debug(k,...C)}info(k,...C){this.logger.info(k,...C)}warn(k,...C){this.logger.warn(k,...C)}error(k,...C){this.logger.error(k,...C)}flush(){this.logger.flush()}}t.LogService=v}),define(oe[136],ae([0,1,10,6]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;var v;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(v||(v={}));async function D(c,l,d,u,S){try{const g=await new Promise((y,f)=>{q(["@vscode/spdlog"],y,f)}).then(we);g.setFlushOn(v.Trace);const T=await g.createAsyncRotatingLogger(c,l,d,u);return S?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(g){console.error(g)}return null}function k(c,l,d){switch(l){case b.LogLevel.Trace:c.trace(d);break;case b.LogLevel.Debug:c.debug(d);break;case b.LogLevel.Info:c.info(d);break;case b.LogLevel.Warning:c.warn(d);break;case b.LogLevel.Error:c.error(d);break;case b.LogLevel.Off:break;default:throw new Error(`Invalid log level ${l}`)}}function C(c,l){switch(l){case b.LogLevel.Trace:c.setLevel(v.Trace);break;case b.LogLevel.Debug:c.setLevel(v.Debug);break;case b.LogLevel.Info:c.setLevel(v.Info);break;case b.LogLevel.Warning:c.setLevel(v.Warning);break;case b.LogLevel.Error:c.setLevel(v.Error);break;case b.LogLevel.Off:c.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${l}`)}}class p extends b.AbstractMessageLogger{constructor(l,d,u,S,g){super(),this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(l,d,u,S),this._register(this.onDidChangeLogLevel(T=>{this._logger&&C(this._logger,T)}))}async _createSpdLogLogger(l,d,u,S){const g=u?6:1,T=30/g*P.ByteSize.MB,y=await D(l,d,T,g,S);if(y){this._logger=y,C(this._logger,this.getLevel());for(const{level:f,message:m}of this.buffer)k(this._logger,f,m);this.buffer=[]}}log(l,d){this._logger?k(this._logger,l,d):this.getLevel()<=l&&this.buffer.push({level:l,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=p}),define(oe[137],ae([0,1,29,6,136]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoggerService=void 0;class D extends b.AbstractLoggerService{doCreateLogger(C,p,c){return new v.SpdLogLogger((0,P.generateUuid)(),C.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}t.LoggerService=D}),define(oe[39],ae([0,1,5,65,2,11]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,D.createDecorator)("policy");class k extends v.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const l=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},l!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),b.Iterable.reduce(this.policies.entries(),(d,[u,S])=>({...d,[u]:S}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return b.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[l,d])=>({...c,[l]:{definition:d,value:this.policies.get(l)}}),{})}}t.AbstractPolicyService=k;class C{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=C}),define(oe[138],ae([0,1,8,5,65,3,10,6,39]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function c(d,u){const S=[];for(const g of new Set(v.Iterable.concat(d.keys(),u.keys())))d.get(g)!==u.get(g)&&S.push(g);return S}let l=class extends p.AbstractPolicyService{constructor(u,S,g){super(),this.file=u,this.fileService=S,this.logService=g,this.throttledDelayer=this._register(new P.ThrottledDelayer(500));const T=b.Event.filter(S.onDidFilesChange,y=>y.affects(u));this._register(S.watch(u)),this._register(T(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const u=new Map;try{const S=await this.fileService.readFile(this.file),g=JSON.parse(S.value.toString());if(!(0,D.isObject)(g))throw new Error("Policy file isn't a JSON object");for(const T of Object.keys(g))this.policyDefinitions[T]&&u.set(T,g[T])}catch(S){S.fileOperationResult!==k.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",S)}return u}async refresh(){const u=await this.read(),S=c(this.policies,u);this.policies=u,S.length>0&&this._onDidChange.fire(S)}};t.FilePolicyService=l,t.FilePolicyService=l=Ee([se(1,k.IFileService),se(2,C.ILogService)],l)}),define(oe[139],ae([0,1,39,8,2,6]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;let k=class extends P.AbstractPolicyService{constructor(p,c){super(),this.logService=p,this.productName=c,this.throttler=new b.Throttler,this.watcher=this._register(new v.MutableDisposable)}async _updatePolicyDefinitions(p){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((l,d)=>{q(["@vscode/policy-watcher"],l,d)}).then(we);await this.throttler.queue(()=>new Promise((l,d)=>{try{this.watcher.value=c(this.productName,p,u=>{this._onDidPolicyChange(u),l()})}catch(u){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",u),d(u)}}))}_onDidPolicyChange(p){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const l=p[c];l===void 0?this.policies.delete(c):this.policies.set(c,l)}this._onDidChange.fire(Object.keys(p))}};t.NativePolicyService=k,t.NativePolicyService=k=Ee([se(0,D.ILogService)],k)}),define(oe[33],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,P.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(oe[37],ae([0,1,75,3]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0,P=we(P),b=we(b);class v{constructor(){this.data=new Map}add(k,C){P.ok(b.isString(k)),P.ok(b.isObject(C)),P.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,C)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}t.Registry=new v}),define(oe[140],ae([0,1,5,37]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,b=we(b),t.Extensions={JSONContribution:"base.contributions.json"};function v(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class D{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,c){this.schemasById[v(p)]=c,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new D;b.Registry.add(t.Extensions.JSONContribution,k)}),define(oe[40],ae([0,1,20,5,3,95,30,140,37]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0,t.overrideIdentifiersFromKey=T,t.keyFromOverrideIdentifiers=y,t.getDefaultValue=f,t.validateProperty=R,t.getScopes=E,v=we(v),D=we(D);var c;(function(e){e.Multiline="multilineText",e.Singleline="singlelineText"})(c||(t.EditPresentationTypes=c={})),t.Extensions={Configuration:"base.contributions.configuration"};var l;(function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l||(t.ConfigurationScope=l={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const d=p.Registry.as(C.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,i=!0){this.registerConfigurations([a],i)}registerConfigurations(a,i=!0){const s=new Set;this.doRegisterConfigurations(a,i,s),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(a){const i=new Set;this.doDeregisterConfigurations(a,i),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:a,remove:i}){const s=new Set;this.doDeregisterConfigurations(i,s),this.doRegisterConfigurations(a,!1,s),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(a){const i=new Set;this.doRegisterDefaultConfigurations(a,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doRegisterDefaultConfigurations(a,i){const s=[];for(const{overrides:r,source:n}of a)for(const o in r)if(i.add(o),t.OVERRIDE_PROPERTY_REGEX.test(o)){const h=this.configurationDefaultsOverrides.get(o),w=h?.valuesSources??new Map,O=h?.value||{};for(const A of Object.keys(r[o])){const _=r[o][A];if(v.isObject(_)&&(v.isUndefined(O[A])||v.isObject(O[A]))){if(O[A]={...O[A]??{},..._},n){let Y=w.get(A);if(Y||(Y=new Map,w.set(A,Y)),!(Y instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const ne in _)Y.set(ne,n)}}else O[A]=_,n&&w.set(A,n)}this.configurationDefaultsOverrides.set(o,{source:n,value:O,valuesSources:w});const x=(0,k.getLanguageTagSettingPlainKey)(o),L={type:"object",default:O,description:D.localize(1,null,x),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:O,source:v.isString(n)?void 0:n,defaultValueSource:n};s.push(...T(o)),this.configurationProperties[o]=L,this.defaultLanguageConfigurationOverridesNode.properties[o]=L}else{const h=this.configurationProperties[o],w=this.configurationDefaultsOverrides.get(o);let O=w?.value??h?.defaultDefaultValue,x=r[o],L=n;if(v.isObject(x)&&(h!==void 0&&h.type==="object"||h===void 0&&(v.isUndefined(O)||v.isObject(O)))){if(v.isObject(O)||(O={}),x={...O,...x},L=w?.source??new Map,!(L instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const _ in r[o])n?L.set(_,n):L.delete(_)}this.configurationDefaultsOverrides.set(o,{value:x,source:L}),h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(a){const i=new Set;this.doDeregisterDefaultConfigurations(a,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(a,i){for(const{overrides:s,source:r}of a)for(const n in s){const o=v.isString(r)?r:r?.id,h=this.configurationDefaultsOverrides.get(n);if(h){if(t.OVERRIDE_PROPERTY_REGEX.test(n)){for(const O of Object.keys(s[n])){const x=s[n][O];if(v.isObject(x)){const L=h.valuesSources?.get(O);for(const A of Object.keys(x)){const _=L?.get(A);(v.isString(_)?_:_?.id)===o&&(L?.delete(A),delete h.value[O][A])}Object.keys(h.value[O]).length===0&&(delete h.value[O],h.valuesSources?.delete(O))}else{const L=h.valuesSources?.get(O);(v.isString(L)?L:L?.id)===o&&(h.valuesSources?.delete(O),delete h.value[O])}}const w=this.configurationDefaultsOverrides.get(n);w&&Object.keys(w.value).length===0&&(this.configurationDefaultsOverrides.delete(n),delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n])}else{if(h.source instanceof Map){const O=h.source;for(const x in s[n]){const L=O.get(x);(v.isString(L)?L:L?.id)===o&&(O.delete(x),delete h.value[x])}O.size===0&&this.configurationDefaultsOverrides.delete(n)}else{const O=v.isString(h.source)?h.source:h.source?.id;if(o!==O)continue;this.configurationDefaultsOverrides.delete(n)}const w=this.configurationProperties[n];w&&(this.updatePropertyDefaultValue(n,w),this.updateSchema(n,w))}i.add(n)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(a){let i=!1;const s=new Set;a.removedDefaults&&(this.doDeregisterDefaultConfigurations(a.removedDefaults,s),i=!0),a.addedDefaults&&(this.doRegisterDefaultConfigurations(a.addedDefaults,s),i=!0),a.removedConfigurations&&this.doDeregisterConfigurations(a.removedConfigurations,s),a.addedConfigurations&&this.doRegisterConfigurations(a.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){this.doRegisterOverrideIdentifiers(a),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(a){for(const i of a)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,i,s){a.forEach(r=>{this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties,void 0,s),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(a,i){const s=r=>{if(r.properties)for(const n in r.properties){i.add(n);const o=this.configurationProperties[n];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n])}r.allOf?.forEach(n=>s(n))};for(const r of a){s(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(a,i=!0,s,r,n=l.WINDOW,o){n=v.isUndefinedOrNull(a.scope)?n:a.scope;const h=a.properties;if(h)for(const O in h){const x=h[O];if(i&&R(O,x)){delete h[O];continue}if(x.source=s,x.defaultDefaultValue=h[O].default,this.updatePropertyDefaultValue(O,x),t.OVERRIDE_PROPERTY_REGEX.test(O)?x.scope=void 0:(x.scope=v.isUndefinedOrNull(x.scope)?n:x.scope,x.restricted=v.isUndefinedOrNull(x.restricted)?!!r?.includes(O):x.restricted),h[O].hasOwnProperty("included")&&!h[O].included){this.excludedConfigurationProperties[O]=h[O],delete h[O];continue}else this.configurationProperties[O]=h[O],h[O].policy?.name&&this.policyConfigurations.set(h[O].policy.name,O);!h[O].deprecationMessage&&h[O].markdownDeprecationMessage&&(h[O].deprecationMessage=h[O].markdownDeprecationMessage),o.add(O)}const w=a.allOf;if(w)for(const O of w)this.validateAndRegisterProperties(O,i,s,r,n,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const i=s=>{const r=s.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);s.allOf?.forEach(i)};i(a)}updateSchema(a,i){switch(t.allSettings.properties[a]=i,i.scope){case l.APPLICATION:t.applicationSettings.properties[a]=i;break;case l.MACHINE:t.machineSettings.properties[a]=i;break;case l.MACHINE_OVERRIDABLE:t.machineOverridableSettings.properties[a]=i;break;case l.WINDOW:t.windowSettings.properties[a]=i;break;case l.RESOURCE:t.resourceSettings.properties[a]=i;break;case l.LANGUAGE_OVERRIDABLE:t.resourceSettings.properties[a]=i,this.resourceLanguageSettingsSchema.properties[a]=i;break}}removeFromSchema(a,i){switch(delete t.allSettings.properties[a],i.scope){case l.APPLICATION:delete t.applicationSettings.properties[a];break;case l.MACHINE:delete t.machineSettings.properties[a];break;case l.MACHINE_OVERRIDABLE:delete t.machineOverridableSettings.properties[a];break;case l.WINDOW:delete t.windowSettings.properties[a];break;case l.RESOURCE:case l.LANGUAGE_OVERRIDABLE:delete t.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const i=`[${a}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,s),t.allSettings.properties[i]=s,t.applicationSettings.properties[i]=s,t.machineSettings.properties[i]=s,t.machineOverridableSettings.properties[i]=s,t.windowSettings.properties[i]=s,t.resourceSettings.properties[i]=s}}registerOverridePropertyPatternKey(){const a={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,i){const s=this.configurationDefaultsOverrides.get(a);let r=s?.value,n=s?.source;v.isUndefined(r)&&(r=i.defaultDefaultValue,n=void 0),v.isUndefined(r)&&(r=f(i.type)),i.default=r,i.defaultValueSource=n}}const S="\\[([^\\]]+)\\]",g=new RegExp(S,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function T(e){const a=[];if(t.OVERRIDE_PROPERTY_REGEX.test(e)){let i=g.exec(e);for(;i?.length;){const s=i[1].trim();s&&a.push(s),i=g.exec(e)}}return(0,P.distinct)(a)}function y(e){return e.reduce((a,i)=>`${a}[${i}]`,"")}function f(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;p.Registry.add(t.Extensions.Configuration,m);function R(e,a){return e.trim()?t.OVERRIDE_PROPERTY_REGEX.test(e)?D.localize(7,null,e):m.getConfigurationProperties()[e]!==void 0?D.localize(8,null,e):a.policy?.name&&m.getPolicyConfigurations().get(a.policy?.name)!==void 0?D.localize(9,null,e,a.policy?.name,m.getPolicyConfigurations().get(a.policy?.name)):null:D.localize(6,null)}function E(){const e=[],a=m.getConfigurationProperties();for(const i of Object.keys(a))e.push([i,a[i].scope]);return e.push(["launch",l.RESOURCE]),e.push(["task",l.RESOURCE]),e}}),define(oe[66],ae([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationChangeEvent=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0,t.mergeChanges=E,P=we(P),v=we(v),C=we(C),p=we(p);function g(s){return Object.isFrozen(s)?s:C.deepFreeze(s)}class T{static createEmptyModel(r){return new T({},[],[],void 0,r)}constructor(r,n,o,h,w){this._contents=r,this._keys=n,this._overrides=o,this.raw=h,this.logService=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof T)return n;const o=new y("",this.logService);return o.parseRaw(n),o.configurationModel});this._rawConfiguration=r.reduce((n,o)=>o===n?o:n.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,l.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const o=this;return{get value(){return g(o.rawConfiguration.getValue(r))},get override(){return n?g(o.rawConfiguration.getOverrideValue(r,n)):void 0},get merged(){return g(n?o.rawConfiguration.override(n).getValue(r):o.rawConfiguration.getValue(r))},get overrides(){const h=[];for(const{contents:w,identifiers:O,keys:x}of o.rawConfiguration.overrides){const L=new T(w,x,[],void 0,o.logService).getValue(r);L!==void 0&&h.push({identifiers:O,value:L})}return h.length?g(h):void 0}}}getOverrideValue(r,n){const o=this.getContentsForOverrideIdentifer(n);return o?r?(0,l.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return P.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return P.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=C.deepClone(this.contents),o=C.deepClone(this.overrides),h=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const O of r)if(w.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.mergeContents(n,O.contents);for(const x of O.overrides){const[L]=o.filter(A=>P.equals(A.identifiers,x.identifiers));L?(this.mergeContents(L.contents,x.contents),L.keys.push(...x.keys),L.keys=P.distinct(L.keys)):o.push(C.deepClone(x))}for(const x of O.keys)h.indexOf(x)===-1&&h.push(x)}return new T(n,h,o,w.every(O=>O instanceof T)?void 0:w,this.logService)}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const h of P.distinct([...Object.keys(this.contents),...Object.keys(n)])){let w=this.contents[h];const O=n[h];O&&(typeof w=="object"&&typeof O=="object"?(w=C.deepClone(w),this.mergeContents(w,O)):w=O),o[h]=w}return new T(o,this.keys,this.overrides,void 0,this.logService)}mergeContents(r,n){for(const o of Object.keys(n)){if(o in r&&p.isObject(r[o])&&p.isObject(n[o])){this.mergeContents(r[o],n[o]);continue}r[o]=C.deepClone(n[o])}}getContentsForOverrideIdentifer(r){let n=null,o=null;const h=w=>{w&&(o?this.mergeContents(o,w):o=C.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?n=w.contents:w.identifiers.includes(r)&&h(w.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,n){this.updateValue(r,n,!0)}setValue(r,n){this.updateValue(r,n,!1)}removeValue(r){const n=this.keys.indexOf(r);n!==-1&&(this.keys.splice(n,1),(0,l.removeFromValueTree)(this.contents,r),d.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(o=>P.equals(o.identifiers,(0,d.overrideIdentifiersFromKey)(r))),1))}updateValue(r,n,o){(0,l.addToValueTree)(this.contents,r,n,h=>this.logService.error(h)),o=o||this.keys.indexOf(r)===-1,o&&this.keys.push(r),d.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,d.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,l.toValuesTree)(this.contents[r],h=>this.logService.error(h))})}}t.ConfigurationModel=T;class y{constructor(r,n){this._name=r,this.logService=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||T.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!p.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:o,keys:h,overrides:w,restricted:O,hasExcludedProperties:x}=this.doParseRaw(r,n);this._configurationModel=new T(o,h,w,x?[r]:void 0,this.logService),this._restrictedConfigurations=O||[]}doParseContent(r){let n={},o=null,h=[];const w=[],O=[];function x(A){Array.isArray(h)?h.push(A):o!==null&&(h[o]=A)}const L={onObjectBegin:()=>{const A={};x(A),w.push(h),h=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{h=w.pop()},onArrayBegin:()=>{const A=[];x(A),w.push(h),h=A,o=null},onArrayEnd:()=>{h=w.pop()},onLiteralValue:x,onError:(A,_,X)=>{O.push({error:A,offset:_,length:X})}};if(r)try{v.visit(r,L),n=h[0]||{}}catch(A){this.logService.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(r,n){const o=S.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,o,!0,n);r=h.raw;const w=(0,l.toValuesTree)(r,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`)),O=Object.keys(r),x=this.toOverrides(r,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:w,keys:O,overrides:x,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}filter(r,n,o,h){let w=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const O={},x=[];for(const L in r)if(d.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const A=this.filter(r[L],n,!1,h);O[L]=A.raw,w=w||A.hasExcludedProperties,x.push(...A.restricted)}else{const A=n[L],_=A?typeof A.scope<"u"?A.scope:d.ConfigurationScope.WINDOW:void 0;A?.restricted&&x.push(L),!h.exclude?.includes(L)&&(h.include?.includes(L)||(_===void 0||h.scopes===void 0||h.scopes.includes(_))&&!(h.skipRestricted&&A?.restricted))?O[L]=r[L]:w=!0}return{raw:O,restricted:x,hasExcludedProperties:w}}toOverrides(r,n){const o=[];for(const h of Object.keys(r))if(d.OVERRIDE_PROPERTY_REGEX.test(h)){const w={};for(const O in r[h])w[O]=r[h][O];o.push({identifiers:(0,d.overrideIdentifiersFromKey)(h),keys:Object.keys(w),contents:(0,l.toValuesTree)(w,n)})}return o}}t.ConfigurationModelParser=y;class f extends D.Disposable{constructor(r,n,o,h,w){super(),this.userSettingsResource=r,this.parseOptions=n,this.fileService=h,this.logService=w,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString(),w),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.any(b.Event.filter(this.fileService.onDidFilesChange,O=>O.contains(this.userSettingsResource)),b.Event.filter(this.fileService.onDidRunOperation,O=>(O.isOperation(u.FileOperation.CREATE)||O.isOperation(u.FileOperation.COPY)||O.isOperation(u.FileOperation.DELETE)||O.isOperation(u.FileOperation.WRITE))&&o.isEqual(O.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return T.createEmptyModel(this.logService)}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=f;class m{constructor(r,n,o,h,w,O,x,L,A,_,X,Y,ne){this.key=r,this.overrides=n,this._value=o,this.overrideIdentifiers=h,this.defaultConfiguration=w,this.policyConfiguration=O,this.applicationConfiguration=x,this.userConfiguration=L,this.localUserConfiguration=A,this.remoteUserConfiguration=_,this.workspaceConfiguration=X,this.folderConfigurationModel=Y,this.memoryConfigurationModel=ne}get value(){return g(this._value)}toInspectValue(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class R{constructor(r,n,o,h,w,O,x,L,A,_){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=h,this._remoteUserConfiguration=w,this._workspaceConfiguration=O,this._folderConfigurations=x,this._memoryConfiguration=L,this._memoryConfigurationByResource=A,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,n,o){return this.getConsolidatedConfigurationModel(r,n,o).getValue(r)}updateValue(r,n,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=T.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,n===void 0?h.removeValue(r):h.setValue(r,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,o){const h=this.getConsolidatedConfigurationModel(r,n,o),w=this.getFolderConfigurationModelForResource(n.resource,o),O=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,x=new Set;for(const L of h.overrides)for(const A of L.identifiers)h.getOverrideValue(r,A)!==void 0&&x.add(A);return new m(r,n,h.getValue(r),x.size?[...x]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,w||void 0,O)}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:h,updated:w,removed:O}=a(this._defaultConfiguration,r);n=[...h,...w,...O]}for(const h of n)for(const w of(0,d.overrideIdentifiersFromKey)(h)){const O=this._defaultConfiguration.getKeysForOverrideIdentifier(w),x=r.getKeysForOverrideIdentifier(w),L=[...x.filter(A=>O.indexOf(A)===-1),...O.filter(A=>x.indexOf(A)===-1),...O.filter(A=>!C.equals(this._defaultConfiguration.override(w).getValue(A),r.override(w).getValue(A)))];o.push([w,L])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:o,removed:h}=a(this._policyConfiguration,r),w=[...n,...o,...h];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:o,removed:h,overrides:w}=a(this.applicationConfiguration,r),O=[...n,...o,...h];return O.length&&this.updateApplicationConfiguration(r),{keys:O,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:h,overrides:w}=a(this.localUserConfiguration,r),O=[...n,...o,...h];return O.length&&this.updateLocalUserConfiguration(r),{keys:O,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:h,overrides:w}=a(this.remoteUserConfiguration,r),O=[...n,...o,...h];return O.length&&this.updateRemoteUserConfiguration(r),{keys:O,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:h,overrides:w}=a(this.workspaceConfiguration,r),O=[...n,...o,...h];return O.length&&this.updateWorkspaceConfiguration(r),{keys:O,overrides:w}}compareAndUpdateFolderConfiguration(r,n){const o=this.folderConfigurations.get(r),{added:h,updated:w,removed:O,overrides:x}=a(o,n),L=[...h,...w,...O];return(L.length||!o)&&this.updateFolderConfiguration(r,n),{keys:L,overrides:x}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:h,removed:w,overrides:O}=a(n,void 0);return{keys:[...o,...h,...w],overrides:O}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,o){let h=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(h=h.merge(this._policyConfiguration)),h}getConsolidatedConfigurationModelForResource({resource:r},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const h=n.getFolder(r);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const w=this._memoryConfigurationByResource.get(r);w&&(o=o.merge(w))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(n=o.merge(h),this._foldersConsolidatedConfigurations.set(r,n)):n=o}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:o,overrides:h,keys:w}=this._folderConfigurations.get(n);return r.push([n,{contents:o,overrides:h,keys:w}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(n=>r.add(n)),this.userConfiguration.keys.forEach(n=>r.add(n)),this._workspaceConfiguration.keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(h=>n.add(h))),[...n.values()]}static parse(r,n){const o=this.parseConfigurationModel(r.defaults,n),h=this.parseConfigurationModel(r.policy,n),w=this.parseConfigurationModel(r.application,n),O=this.parseConfigurationModel(r.user,n),x=this.parseConfigurationModel(r.workspace,n),L=r.folders.reduce((A,_)=>(A.set(c.URI.revive(_[0]),this.parseConfigurationModel(_[1],n)),A),new k.ResourceMap);return new R(o,h,w,O,T.createEmptyModel(n),x,L,T.createEmptyModel(n),new k.ResourceMap,n)}static parseConfigurationModel(r,n){return new T(r.contents,r.keys,r.overrides,void 0,n)}}t.Configuration=R;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,n=new Map;for(const h of s)h.keys.forEach(w=>r.add(w)),h.overrides.forEach(([w,O])=>{const x=(0,k.getOrSet)(n,w,new Set);O.forEach(L=>x.add(L))});const o=[];return n.forEach((h,w)=>o.push([w,[...h.values()]])),{keys:[...r.values()],overrides:o}}class e{constructor(r,n,o,h,w){this.change=r,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=h,this.logService=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const O of r.keys)this.affectedKeys.add(O);for(const[,O]of r.overrides)for(const x of O)this.affectedKeys.add(x);this._affectsConfigStr=this._marker;for(const O of this.affectedKeys)this._affectsConfigStr+=O+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(r,n){const o=this._marker+r,h=this._affectsConfigStr.indexOf(o);if(h<0)return!1;const w=h+o.length;if(w>=this._affectsConfigStr.length)return!1;const O=this._affectsConfigStr.charCodeAt(w);if(O!==this._markerCode1&&O!==this._markerCode2)return!1;if(n){const x=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!C.equals(x,L)}return!0}}t.ConfigurationChangeEvent=e;function a(s,r){const{added:n,removed:o,updated:h}=i(r?.rawConfiguration,s?.rawConfiguration),w=[],O=s?.getAllOverrideIdentifiers()||[],x=r?.getAllOverrideIdentifiers()||[];if(r){const L=x.filter(A=>!O.includes(A));for(const A of L)w.push([A,r.getKeysForOverrideIdentifier(A)])}if(s){const L=O.filter(A=>!x.includes(A));for(const A of L)w.push([A,s.getKeysForOverrideIdentifier(A)])}if(r&&s){for(const L of O)if(x.includes(L)){const A=i({contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});w.push([L,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:o,updated:h,overrides:w}}function i(s,r){const n=s?r?s.keys.filter(w=>r.keys.indexOf(w)===-1):[...s.keys]:[],o=r?s?r.keys.filter(w=>s.keys.indexOf(w)===-1):[...r.keys]:[],h=[];if(s&&r){for(const w of r.keys)if(s.keys.indexOf(w)!==-1){const O=(0,l.getConfigurationValue)(r.contents,w),x=(0,l.getConfigurationValue)(s.contents,w);C.equals(O,x)||h.push(w)}}return{added:n,removed:o,updated:h}}}),define(oe[141],ae([0,1,20,5,2,28,3,66,40,6,39,37]),function(q,t,P,b,v,D,k,C,p,c,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfiguration=void 0;class u extends v.Disposable{get configurationModel(){return this._configurationModel}constructor(y){super(),this.logService=y,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(d.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(y),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(y,f){this.updateConfigurationModel(y,d.Registry.as(p.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:y})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService);const y=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(y),y)}updateConfigurationModel(y,f){const m=this.getConfigurationDefaultOverrides();for(const R of y){const E=m[R],e=f[R];E!==void 0?this._configurationModel.addValue(R,E):e?this._configurationModel.addValue(R,e.default):this._configurationModel.removeValue(R)}}}t.DefaultConfiguration=u;class S{constructor(){this.onDidChangeConfiguration=b.Event.None,this.configurationModel=C.ConfigurationModel.createEmptyModel(new c.NullLogService)}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=S;let g=class extends v.Disposable{get configurationModel(){return this._configurationModel}constructor(y,f,m){super(),this.defaultConfiguration=y,this.policyService=f,this.logService=m,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(y=>this.onDidChangePolicies(y))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:y})=>this.update(await this.updatePolicyDefinitions(y),!0))),this._configurationModel}async updatePolicyDefinitions(y){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",y);const f={},m=[],R=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const E of y){const e=R[E];if(!e){m.push(E);continue}if(e.policy){if(e.type!=="string"&&e.type!=="number"){this.logService.warn(`Policy ${e.policy.name} has unsupported type ${e.type}`);continue}m.push(E),f[e.policy.name]={type:e.type}}}return(0,k.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),m}onDidChangePolicies(y){this.logService.trace("PolicyConfiguration#onDidChangePolicies",y);const f=d.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),m=(0,P.coalesce)(y.map(R=>f.get(R)));this.update(m,!0)}update(y,f){this.logService.trace("PolicyConfiguration#update",y);const m=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),R=[],E=this._configurationModel.isEmpty();for(const e of y){const a=m[e]?.policy?.name;if(a){const i=this.policyService.getPolicyValue(a);(E?i!==void 0:!(0,D.equals)(this._configurationModel.getValue(e),i))&&R.push([e,i])}else this._configurationModel.getValue(e)!==void 0&&R.push([e,void 0])}if(R.length){this.logService.trace("PolicyConfiguration#changed",R);const e=this._configurationModel;this._configurationModel=C.ConfigurationModel.createEmptyModel(this.logService);for(const a of e.keys)this._configurationModel.setValue(a,e.getValue(a));for(const[a,i]of R)i===void 0?this._configurationModel.removeValue(a):this._configurationModel.setValue(a,i);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};t.PolicyConfiguration=g,t.PolicyConfiguration=g=Ee([se(1,l.IPolicyService),se(2,c.ILogService)],g)}),define(oe[142],ae([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,141,10,39]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class R extends p.Disposable{constructor(a,i,s,r){super(),this.settingsResource=a,this.logService=r,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new y.DefaultConfiguration(r)),this.policyConfiguration=s instanceof m.NullPolicyService?new y.NullPolicyConfiguration:this._register(new y.PolicyConfiguration(this.defaultConfiguration,s,r)),this.userConfiguration=this._register(new g.UserSettings(this.settingsResource,{},u.extUriBiasedIgnorePathCase,i,r)),this.configuration=new g.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,g.ConfigurationModel.createEmptyModel(r),g.ConfigurationModel.createEmptyModel(r),g.ConfigurationModel.createEmptyModel(r),g.ConfigurationModel.createEmptyModel(r),new c.ResourceMap,g.ConfigurationModel.createEmptyModel(r),new c.ResourceMap,r),this.configurationEditing=new E(a,i,this),this.reloadConfigurationScheduler=this._register(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:o})=>this.onDidDefaultConfigurationChange(n,o))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[a,i,s]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new g.Configuration(a,i,g.ConfigurationModel.createEmptyModel(this.logService),s,g.ConfigurationModel.createEmptyModel(this.logService),g.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,g.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(a,i){const s=typeof a=="string"?a:void 0,r=(0,S.isConfigurationOverrides)(a)?a:(0,S.isConfigurationOverrides)(i)?i:{};return this.configuration.getValue(s,r,void 0)}async updateValue(a,i,s,r,n){const o=(0,S.isConfigurationUpdateOverrides)(s)?s:(0,S.isConfigurationOverrides)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,h=o?r:s;if(h!==void 0&&h!==S.ConfigurationTarget.USER_LOCAL&&h!==S.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${h}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.distinct)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const w=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,l.equals)(i,w.defaultValue)&&(i=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const x=o.overrideIdentifiers.sort(),L=this.configuration.localUserConfiguration.overrides.find(A=>(0,P.equals)([...A.identifiers].sort(),x));L&&(o.overrideIdentifiers=L.identifiers)}const O=o?.overrideIdentifiers?.length?[(0,T.keyFromOverrideIdentifiers)(o.overrideIdentifiers),a]:[a];await this.configurationEditing.write(O,i),await this.reloadConfiguration()}inspect(a,i={}){return this.configuration.inspect(a,i,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const a=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(a)}onDidChangeUserConfiguration(a){const i=this.configuration.toData(),s=this.configuration.compareAndUpdateLocalUserConfiguration(a);this.trigger(s,i,S.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(a,i){const s=this.configuration.toData(),r=this.configuration.compareAndUpdateDefaultConfiguration(a,i);this.trigger(r,s,S.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(a){const i=this.configuration.toData(),s=this.configuration.compareAndUpdatePolicyConfiguration(a);this.trigger(s,i,S.ConfigurationTarget.DEFAULT)}trigger(a,i,s){const r=new g.ConfigurationChangeEvent(a,{data:i},this.configuration,void 0,this.logService);r.source=s,this._onDidChangeConfiguration.fire(r)}}t.ConfigurationService=R;class E{constructor(a,i,s){this.settingsResource=a,this.fileService=i,this.configurationService=s,this.queue=new b.Queue}write(a,i){return this.queue.queue(()=>this.doWriteConfiguration(a,i))}async doWriteConfiguration(a,i){let s;try{s=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw o}const r=[];if((0,k.parse)(s,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(s,a,i);s=(0,C.applyEdits)(s,n),await this.fileService.writeFile(this.settingsResource,v.VSBuffer.fromString(s))}getEdits(a,i,s){const{tabSize:r,insertSpaces:n,eol:o}=this.formattingOptions;if(!i.length){const h=JSON.stringify(s,null,n?" ".repeat(r):"	");return[{content:h,length:h.length,offset:0}]}return(0,C.setProperty)(a,i,s,{tabSize:r,insertSpaces:n,eol:o})}get formattingOptions(){if(!this._formattingOptions){let a=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(a=i),this._formattingOptions={eol:a,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(oe[67],ae([0,1,15]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteAuthority=b,t.getRemoteName=v,t.parseAuthorityWithPort=D,t.parseAuthorityWithOptionalPort=k;function b(p){return p.scheme===P.Schemas.vscodeRemote?p.authority:void 0}function v(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function D(p){const{host:c,port:l}=C(p);if(typeof l>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:l}}function k(p,c){let{host:l,port:d}=C(p);return typeof d>"u"&&(d=c),{host:l,port:d}}function C(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const l=p.match(/^(\[[0-9a-z:]+\])$/);if(l)return{host:l[1],port:void 0};const d=p.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:p,port:void 0}}}),define(oe[23],ae([0,1,32,11,67]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.ExtensionIdentifierMap=t.ExtensionIdentifierSet=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=void 0,t.getWorkspaceSupportTypeMessage=D,t.isApplicationScopedExtension=d,t.isLanguagePackExtension=u,t.isAuthenticationProviderExtension=S,t.isResolverExtension=g,t.parseApiProposals=T,t.parseEnabledApiProposalNames=y,P=we(P),t.USER_MANIFEST_CACHE_FILE="extensions.user.cache",t.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}t.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(k||(t.ExtensionType=k={}));var C;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.LINUX_PPC64LE="linux-ppc64le",f.LINUX_RISCV64="linux-riscv64",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(C||(t.TargetPlatform=C={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,R){if(typeof m>"u"||m===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof m=="string"||typeof R=="string"){const E=typeof m=="string"?m:m.value,e=typeof R=="string"?R:R.value;return P.equalsIgnoreCase(E,e)}return m._lower===R._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.ExtensionIdentifier=p;class c{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const R of m)this.add(R)}add(m){this._set.add(p.toKey(m))}delete(m){return this._set.delete(p.toKey(m))}has(m){return this._set.has(p.toKey(m))}}t.ExtensionIdentifierSet=c;class l{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(p.toKey(m))}get(m){return this._map.get(p.toKey(m))}has(m){return this._map.has(p.toKey(m))}set(m,R){this._map.set(p.toKey(m),R)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}t.ExtensionIdentifierMap=l;function d(f){return u(f)}function u(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function S(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function g(f,m){if(m){const R=`onResolveRemoteAuthority:${(0,v.getRemoteName)(m)}`;return!!f.activationEvents?.includes(R)}return!1}function T(f){return f.map(m=>{const[R,E]=m.split("@");return{proposalName:R,version:E?parseInt(E):void 0}})}function y(f){return f.map(m=>m.split("@")[0])}t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[21],ae([0,1,13,99,23,11]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.ExtensionsLocalizedLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.ExtensionGalleryError=t.ExtensionGalleryErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=t.EXTENSION_INSTALL_DEP_PACK_CONTEXT=t.EXTENSION_INSTALL_SOURCE_CONTEXT=t.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.TargetPlatformToString=C,t.toTargetPlatform=p,t.getTargetPlatform=c,t.isNotWebExtensionInWebTargetPlatform=l,t.isTargetPlatformCompatible=d,t.isIExtensionIdentifier=u,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension",t.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",t.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",t.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(e){e.COMMAND="command",e.SETTINGS_SYNC="settingsSync"})(k||(t.ExtensionInstallSource=k={}));function C(e){switch(e){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case v.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function p(e){switch(e){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.LINUX_PPC64LE:return v.TargetPlatform.LINUX_PPC64LE;case v.TargetPlatform.LINUX_RISCV64:return v.TargetPlatform.LINUX_RISCV64;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function c(e,a){switch(e){case P.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:a==="ppc64le"?v.TargetPlatform.LINUX_PPC64LE:a==="riscv64"?v.TargetPlatform.LINUX_RISCV64:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Web:return v.TargetPlatform.WEB}}function l(e,a){return a===v.TargetPlatform.WEB&&!e.includes(v.TargetPlatform.WEB)}function d(e,a,i){return l(a,i)?!1:e===v.TargetPlatform.UNDEFINED||e===v.TargetPlatform.UNIVERSAL?!0:e===v.TargetPlatform.UNKNOWN?!1:e===i}function u(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}var S;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})(S||(t.SortBy=S={}));var g;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(g||(t.SortOrder=g={}));var T;(function(e){e.Install="install",e.Uninstall="uninstall"})(T||(t.StatisticType=T={}));var y;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(y||(t.InstallOperation=y={})),t.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var f;(function(e){e.Timeout="Timeout",e.Cancelled="Cancelled",e.Failed="Failed",e.DownloadFailedWriting="DownloadFailedWriting"})(f||(t.ExtensionGalleryErrorCode=f={}));class m extends Error{constructor(a,i){super(a),this.code=i,this.name=i}}t.ExtensionGalleryError=m;var R;(function(e){e.Unsupported="Unsupported",e.Deprecated="Deprecated",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatibleApi="IncompatibleApi",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.DownloadSignature="DownloadSignature",e.DownloadFailedWriting="DownloadFailedWriting",e.UpdateExistingMetadata="UpdateExistingMetadata",e.UpdateMetadata="UpdateMetadata",e.Extract="Extract",e.Scanning="Scanning",e.ScanningExtension="ScanningExtension",e.ReadUninstalled="ReadUninstalled",e.UnsetUninstalled="UnsetUninstalled",e.Delete="Delete",e.Rename="Rename",e.IntializeDefaultProfile="IntializeDefaultProfile",e.AddToProfile="AddToProfile",e.InstalledExtensionNotFound="InstalledExtensionNotFound",e.PostInstall="PostInstall",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Signature="Signature",e.NotAllowed="NotAllowed",e.Gallery="Gallery",e.Cancelled="Cancelled",e.Unknown="Unknown",e.Internal="Internal"})(R||(t.ExtensionManagementErrorCode=R={}));class E extends Error{constructor(a,i){super(a),this.code=i,this.name=i}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),t.ExtensionsLocalizedLabel=(0,b.localize2)(0,"Extensions"),t.PreferencesLocalizedLabel=(0,b.localize2)(1,"Preferences")}),define(oe[143],ae([0,1,2,23,10]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends P.Disposable{constructor(C,p,c,l,d){super(),this.userDataProfilesService=C,this.fileService=p,this.uriIdentityService=c,this.logService=d,this._register(l.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(l.onDidUninstallExtension(u=>this.onDidUnInstallExtension(u)))}onDidInstallExtensions(C){for(const p of C)p.local&&this.invalidate(p.profileLocation)}onDidUnInstallExtension(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const p of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(p.extensionsResource,C)&&await this.deleteUserCacheFile(p);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(C){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(C.cacheHome,b.USER_MANIFEST_CACHE_FILE))}catch(p){(0,v.toFileOperationResult)(p)!==v.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(p)}}}t.ExtensionsManifestCache=D});var Ve=this&&this.__importDefault||function(q){return q&&q.__esModule?q:{default:q}};define(oe[44],ae([0,1,17,56,105,45,23,122]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidVersionStr=l,t.parseVersion=d,t.normalizeVersion=u,t.isValidVersion=S,t.validateExtensionManifest=g,t.isValidExtensionVersion=T,t.isEngineValid=y,t.areApiProposalsCompatible=f,b=Ve(b),v=we(v),D=we(D);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function l(E){return E=E.trim(),E==="*"||p.test(E)}function d(E){if(!l(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const e=E.match(p);return e?{hasCaret:e[1]==="^",hasGreaterEquals:e[1]===">=",majorBase:e[2]==="x"?0:parseInt(e[2],10),majorMustEqual:e[2]!=="x",minorBase:e[4]==="x"?0:parseInt(e[4],10),minorMustEqual:e[4]!=="x",patchBase:e[6]==="x"?0:parseInt(e[6],10),patchMustEqual:e[6]!=="x",preRelease:e[8]||null}:null}function u(E){if(!E)return null;const e=E.majorBase,a=E.majorMustEqual,i=E.minorBase;let s=E.minorMustEqual;const r=E.patchBase;let n=E.patchMustEqual;E.hasCaret&&(e===0||(s=!1),n=!1);let o=0;if(E.preRelease){const h=c.exec(E.preRelease);if(h){const[,w,O,x]=h;o=Date.UTC(Number(w),Number(O)-1,Number(x))}}return{majorBase:e,majorMustEqual:a,minorBase:i,minorMustEqual:s,patchBase:r,patchMustEqual:n,isMinimum:E.hasGreaterEquals,notBefore:o}}function S(E,e,a){let i;typeof E=="string"?i=u(d(E)):i=E;let s;e instanceof Date?s=e.getTime():typeof e=="string"&&(s=new Date(e).getTime());let r;if(typeof a=="string"?r=u(d(a)):r=a,!i||!r)return!1;const n=i.majorBase,o=i.minorBase,h=i.patchBase;let w=r.majorBase,O=r.minorBase,x=r.patchBase;const L=r.notBefore;let A=r.majorMustEqual,_=r.minorMustEqual,X=r.patchMustEqual;return r.isMinimum?n>w?!0:n<w?!1:o>O?!0:o<O||s&&s<L?!1:h>=x:(n===1&&w===0&&(!A||!_||!X)&&(w=1,O=0,x=0,A=!0,_=!1,X=!1),n<w?!1:n>w?!A:o<O?!1:o>O?!_:h<x?!1:h>x?!X:!(s&&s<L))}function g(E,e,a,i,s,r){const n=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return n.push([b.default.Error,v.localize(0,null)]),n;if(typeof i.name!="string")return n.push([b.default.Error,v.localize(1,null,"name")]),n;if(typeof i.version!="string")return n.push([b.default.Error,v.localize(2,null,"version")]),n;if(!i.engines)return n.push([b.default.Error,v.localize(3,null,"engines")]),n;if(typeof i.engines.vscode!="string")return n.push([b.default.Error,v.localize(4,null,"engines.vscode")]),n;if(typeof i.extensionDependencies<"u"&&!R(i.extensionDependencies))return n.push([b.default.Error,v.localize(5,null,"extensionDependencies")]),n;if(typeof i.activationEvents<"u"){if(!R(i.activationEvents))return n.push([b.default.Error,v.localize(6,null,"activationEvents")]),n;if(typeof i.main>"u"&&typeof i.browser>"u")return n.push([b.default.Error,v.localize(7,null,"activationEvents","main","browser")]),n}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&n.push([b.default.Warning,v.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return n.push([b.default.Error,v.localize(9,null,"main")]),n;{const w=(0,P.joinPath)(a,i.main);(0,P.isEqualOrParent)(w,a)||n.push([b.default.Warning,v.localize(10,null,w.path,a.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return n.push([b.default.Error,v.localize(11,null,"browser")]),n;{const w=(0,P.joinPath)(a,i.browser);(0,P.isEqualOrParent)(w,a)||n.push([b.default.Warning,v.localize(12,null,w.path,a.path)])}}if(!D.valid(i.version))return n.push([b.default.Error,v.localize(13,null)]),n;const o=[];if(!T(E,e,i,s,o))for(const w of o)n.push([b.default.Error,w]);if(r&&i.enabledApiProposals?.length){const w=[];if(!f([...i.enabledApiProposals],w))for(const O of w)n.push([b.default.Error,O])}return n}function T(E,e,a,i,s){return i||typeof a.main>"u"&&typeof a.browser>"u"?!0:m(E,e,a.engines.vscode,s)}function y(E,e,a){return E==="*"||m(e,a,E)}function f(E,e){if(E.length===0)return!0;const a=Array.isArray(e)?e:void 0,i=(a?void 0:e)??C.allApiProposals,s=[],r=(0,k.parseApiProposals)(E);for(const{proposalName:n,version:o}of r){const h=i[n];h&&o&&h.version!==o&&s.push(v.localize(14,null,n))}return a?.push(...s),s.length===0}function m(E,e,a,i=[]){const s=u(d(a));if(!s)return i.push(v.localize(15,null,a)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return i.push(v.localize(16,null,a)),!1}else if(!s.majorMustEqual)return i.push(v.localize(17,null,a)),!1;return S(E,e,s)?!0:(i.push(v.localize(18,null,E,a)),!1)}function R(E){if(!Array.isArray(E))return!1;for(let e=0,a=E.length;e<a;e++)if(typeof E[e]!="string")return!1;return!0}}),define(oe[68],ae([0,1,22,2,13,109,21,11]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.getLocale=p;function p(l){return l.tags.find(d=>d.startsWith("lp-"))?.split("lp-")[1]}t.ILanguagePackService=(0,C.createDecorator)("languagePackService");let c=class extends b.Disposable{constructor(d){super(),this.extensionGalleryService=d}async getAvailableLanguages(){const d=new P.CancellationTokenSource;setTimeout(()=>d.cancel(),1e3);let u;try{u=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},d.token)}catch{return[]}const g=u.firstPage.filter(T=>T.properties.localizedLanguages?.length&&T.tags.some(y=>y.startsWith("lp-"))).map(T=>{const y=T.properties.localizedLanguages?.[0],f=p(T);return{...this.createQuickPickItem(f,y,T),extensionId:T.identifier.id,galleryExtension:T}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(d,u,S){const g=u??d;let T;if(g!==d&&(T=`(${d})`),d.toLowerCase()===v.language.toLowerCase()&&(T??="",T+=(0,D.localize)(0,null)),S?.installCount){T??="";const y=S.installCount;let f;y>1e6?f=`${Math.floor(y/1e5)/10}M`:y>1e3?f=`${Math.floor(y/1e3)}K`:f=String(y),T+=` $(cloud-download) ${f}`}return{id:d,label:g,description:T}}};t.LanguagePackBaseService=c,t.LanguagePackBaseService=c=Ee([se(0,k.IExtensionGalleryService)],c)}),define(oe[46],ae([0,1,14,9,2,111,40,11,6,37]),function(q,t,P,b,v,D,k,C,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractRequestService=t.IRequestService=void 0,t.isSuccess=u,t.hasNoContent=S,t.asText=g,t.asTextOrError=T,t.asJson=y,t.updateProxyConfigurationsScope=f,t.IRequestService=(0,C.createDecorator)("requestService");class l{constructor(e){this.original=e}toJSON(){if(!this.headers){const e=Object.create(null);for(const a in this.original)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?e[a]="*****":e[a]=this.original[a];this.headers=e}return this.headers}}class d extends v.Disposable{constructor(e){super(),this.counter=0,this.logger=e.createLogger("network",{name:(0,D.localize)(0,null),when:p.CONTEXT_LOG_LEVEL.isEqualTo((0,p.LogLevelToString)(p.LogLevel.Trace)).serialize()})}async logAndRequest(e,a,i){const s=`${e} #${++this.counter}: ${a.url}`;this.logger.trace(`${s} - begin`,a.type,new l(a.headers??{}));try{const r=await i();return this.logger.trace(`${s} - end`,a.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.logger.error(`${s} - error`,a.type,(0,b.getErrorMessage)(r)),r}}}t.AbstractRequestService=d;function u(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function S(E){return E.res.statusCode===204}async function g(E){return S(E)?null:(await(0,P.streamToBuffer)(E.stream)).toString()}async function T(E){if(!u(E))throw new Error("Server returned "+E.res.statusCode);return g(E)}async function y(E){if(!u(E))throw new Error("Server returned "+E.res.statusCode);if(S(E))return null;const a=(await(0,P.streamToBuffer)(E.stream)).toString();try{return JSON.parse(a)}catch(i){throw i.message+=`:
`+a,i}}function f(E){R(E)}let m;function R(E){const e=c.Registry.as(k.Extensions.Configuration),a=m;m={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null),(0,D.localize)(10,null)],default:"override",description:(0,D.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(13,null),restricted:!0}}},e.updateConfigurations({add:[m],remove:a?[a]:[]})}R(k.ConfigurationScope.APPLICATION)}),define(oe[144],ae([0,1,22,15,10,46]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let k=class{constructor(p,c){this.requestService=p,this.fileService=c}async download(p,c,l=P.CancellationToken.None){if(p.scheme===b.Schemas.file||p.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(p,c);return}const d={type:"GET",url:p.toString(!0)},u=await this.requestService.request(d,l);if(u.res.statusCode===200)await this.fileService.writeFile(c,u.stream);else{const S=await(0,D.asTextOrError)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${S}`)}}};t.DownloadService=k,t.DownloadService=k=Ee([se(0,D.IRequestService),se(1,v.IFileService)],k)}),define(oe[145],ae([0,1,146,3]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=D;function v(k,C){return k.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:k.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function D(k,C,p={}){const c=(0,P.parse)(k),l=p.proxyUrl||v(c,C);if(!l)return null;const d=(0,P.parse)(l);if(!/^https?:$/.test(d.protocol||""))return null;const u={host:d.hostname||"",port:(d.port?+d.port:0)||(d.protocol==="https"?443:80),auth:d.auth,rejectUnauthorized:(0,b.isBoolean)(p.strictSSL)?p.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((S,g)=>{q(["http-proxy-agent"],S,g)}).then(we)).HttpProxyAgent(l,u):new(await new Promise((S,g)=>{q(["https-proxy-agent"],S,g)}).then(we)).HttpsProxyAgent(l,u)}}),define(oe[147],ae([0,1,60,16,112,22,38,9,13,29,90,177,8,78]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=T;let g;async function T(f,m,R,E){return R["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.isLaunchedFromCli)(E)&&!R["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.isLaunchedFromCli)(E)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=u.Promises.withAsyncBody(async(e,a)=>{const i=new D.CancellationTokenSource;let s=1e4;const r=f.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(s=(0,S.clamp)(r,1,120)*1e3);const n=setTimeout(()=>{i.dispose(!0),a(new Error((0,v.localize)(0,null)))},s);try{e(await y(m,i.token))}catch(o){!(0,C.isCancellationError)(o)&&!i.token.isCancellationRequested?a(new Error((0,v.localize)(1,null,(0,k.toErrorMessage)(o)))):e({})}finally{clearTimeout(n),i.dispose()}})),g)}async function y(f,m){const R=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",R);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",E);const e=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(e+"({.*})"+e),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",i);const s=await(0,l.getSystemShell)(p.OS,i);return f.trace("getUnixShellEnvironment#shell",s),new Promise((r,n)=>{if(m.isCancellationRequested)return n(new C.CancellationError);const o=(0,b.basename)(s);let h,w;const O="";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${O} -p '''${e}'' + JSON.stringify(process.env) + ''${e}'''`,w=["-Login","-Command"]):o==="nu"?(h=`^'${process.execPath}' ${O} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,w=["-i","-l","-c"]):o==="xonsh"?(h=`import os, json; print("${e}", json.dumps(dict(os.environ)), "${e}")`,w=["-i","-l","-c"]):(h=`'${process.execPath}' ${O} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,o==="tcsh"||o==="csh"?w=["-ic"]:w=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),h);const x=(0,P.spawn)(s,[...w,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});m.onCancellationRequested(()=>(x.kill(),n(new C.CancellationError))),x.on("error",_=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(_)),n(_)});const L=[];x.stdout.on("data",_=>L.push(_));const A=[];x.stderr.on("data",_=>A.push(_)),x.on("close",(_,X)=>{const Y=Buffer.concat(L).toString("utf8");f.trace("getUnixShellEnvironment#raw",Y);const ne=Buffer.concat(A).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),_||X)return n(new Error((0,v.localize)(2,null,_,X)));const ce=a.exec(Y),ue=ce?ce[1]:"{}";try{const he=JSON.parse(ue);R?he.ELECTRON_RUN_AS_NODE=R:delete he.ELECTRON_RUN_AS_NODE,E?he.ELECTRON_NO_ATTACH_CONSOLE=E:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",he),r(he)}catch(he){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(he)),n(he)}})})}}),define(oe[148],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=t.IStateReadService=void 0,t.IStateReadService=(0,P.createDecorator)("stateReadService"),t.IStateService=(0,P.createDecorator)("stateService")}),define(oe[69],ae([0,1,8,14,2,3,18,10,6]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.StateReadonlyService=t.FileStorage=t.SaveStrategy=void 0;var c;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(c||(t.SaveStrategy=c={}));class l extends v.Disposable{constructor(g,T,y,f){super(),this.storagePath=g,this.saveStrategy=T,this.logService=y,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new P.ThrottledDelayer(this.saveStrategy===c.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(g){g.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(g)}}getItem(g,T){const y=this.storage[g];return(0,D.isUndefinedOrNull)(y)?T:y}setItem(g,T){this.setItems([{key:g,data:T}])}setItems(g){let T=!1;for(const{key:y,data:f}of g)this.storage[y]!==f&&((0,D.isUndefinedOrNull)(f)?(0,D.isUndefined)(this.storage[y])||(this.storage[y]=void 0,T=!0):(this.storage[y]=f,T=!0));T&&this.save()}removeItem(g){(0,D.isUndefined)(this.storage[g])||(this.storage[g]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const g=JSON.stringify(this.storage,null,4);if(g!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,b.VSBuffer.fromString(g),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=g}catch(T){this.logService.error(T)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=l;let d=class extends v.Disposable{constructor(g,T,y,f){super(),this.fileStorage=this._register(new l(T.stateResource,g,y,f))}async init(){await this.fileStorage.init()}getItem(g,T){return this.fileStorage.getItem(g,T)}};t.StateReadonlyService=d,t.StateReadonlyService=d=Ee([se(1,k.IEnvironmentService),se(2,p.ILogService),se(3,C.IFileService)],d);class u extends d{setItem(g,T){this.fileStorage.setItem(g,T)}setItems(g){this.fileStorage.setItems(g)}removeItem(g){this.fileStorage.removeItem(g)}close(){return this.fileStorage.close()}}t.StateService=u}),define(oe[70],ae([0,1,13,36,29]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=k,t.verifyMicrosoftInternalDomain=C;function D(p){if(P.platform===P.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function k(p,c,l,d,u,S,g,T,y,f){const m=Object.create(null);m["common.machineId"]=S,m["common.sqmId"]=g,m["common.devDeviceId"]=T,m.sessionID=(0,v.generateUuid)()+Date.now(),m.commitHash=d,m.version=u,m["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,P.PlatformToString)(P.platform),m["common.nodePlatform"]=b.platform,m["common.nodeArch"]=l,m["common.product"]=f||"desktop",y&&(m["common.msftInternal"]=y);let R=0;const E=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),P.isLinuxSnap&&(m["common.snap"]="true");const e=D(c);return e&&(m["common.platformDetail"]=e),m}function C(p){const c=b.env.USERDNSDOMAIN;if(!c)return!1;const l=c.toLowerCase();return p.some(d=>l===d)}}),define(oe[19],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_CRASH_REPORTER_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.devDeviceIdKey=t.sqmIdKey=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,P.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.sqmIdKey="telemetry.sqmId",t.devDeviceIdKey="telemetry.devDeviceId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(b||(t.TelemetryLevel=b={}));var v;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(v||(t.TelemetryConfiguration=v={}))}),define(oe[71],ae([0,1,9,11,6,19]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionSignatureVerificationService=t.ExtensionSignatureVerificationError=t.ExtensionSignatureVerificationCode=t.IExtensionSignatureVerificationService=void 0,t.IExtensionSignatureVerificationService=(0,b.createDecorator)("IExtensionSignatureVerificationService");var k;(function(c){c.Success="Success",c.RequiredArgumentMissing="RequiredArgumentMissing",c.InvalidArgument="InvalidArgument",c.PackageIsUnreadable="PackageIsUnreadable",c.UnhandledException="UnhandledException",c.SignatureManifestIsMissing="SignatureManifestIsMissing",c.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",c.SignatureIsMissing="SignatureIsMissing",c.SignatureIsUnreadable="SignatureIsUnreadable",c.CertificateIsUnreadable="CertificateIsUnreadable",c.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",c.FileAlreadyExists="FileAlreadyExists",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",c.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",c.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",c.SignatureIsInvalid="SignatureIsInvalid",c.SignatureManifestIsInvalid="SignatureManifestIsInvalid",c.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",c.EntryIsMissing="EntryIsMissing",c.EntryIsTampered="EntryIsTampered",c.Untrusted="Untrusted",c.CertificateRevoked="CertificateRevoked",c.SignatureIsNotValid="SignatureIsNotValid",c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(t.ExtensionSignatureVerificationCode=k={}));class C extends Error{constructor(l){super(l),this.code=l}}t.ExtensionSignatureVerificationError=C;let p=class{constructor(l,d){this.logService=l,this.telemetryService=d}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((l,d)=>q(["@vscode/vsce-sign"],async u=>l(u),d))),this.moduleLoadingPromise}async verify(l,d,u,S){let g;const T=l.identifier.id;try{g=await this.vsceSign()}catch(R){return this.logService.error("Could not load vsce-sign module",(0,P.getErrorMessage)(R)),this.logService.info(`Extension signature verification is not done: ${T}`),!1}const y=new Date().getTime();let f;try{this.logService.trace(`Verifying extension signature for ${T}...`),f=await g.verify(d,u,this.logService.getLevel()===v.LogLevel.Trace)}catch(R){f={code:k.UnknownError,didExecute:!1,output:(0,P.getErrorMessage)(R)}}const m=new Date().getTime()-y;if(this.logService.info(`Extension signature verification result for ${T}: ${f.code}. Executed: ${f.didExecute}. Duration: ${m}ms.`),this.logService.trace(`Extension signature verification output for ${T}:
${f.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:T,extensionVersion:l.version,code:f.code,internalCode:f.internalCode,duration:m,didExecute:f.didExecute,clientTargetPlatform:S}),f.code===k.Success)return!0;throw new C(f.code)}};t.ExtensionSignatureVerificationService=p,t.ExtensionSignatureVerificationService=p=Ee([se(0,v.ILogService),se(1,D.ITelemetryService)],p)}),define(oe[41],ae([0,1,28,3,67,70,19]),function(q,t,P,b,v,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullAppender=t.extensionTelemetryLogChannelId=t.telemetryLogId=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=t.TelemetryTrustedValue=void 0,t.supportsTelemetry=l,t.isLoggingOnly=d,t.getTelemetryLevel=u,t.validateTelemetryData=S,t.cleanRemoteAuthority=T,t.isInternalTelemetry=f,t.getPiiPathsFromEnvironment=m,t.cleanData=e;class C{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}t.TelemetryTrustedValue=C;class p{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.NullTelemetryServiceShape=p,t.NullTelemetryService=new p;class c{async publicLog(i,s,r){}async publicLogError(i,s,r){}}t.NullEndpointTelemetryService=c,t.telemetryLogId="telemetry",t.extensionTelemetryLogChannelId="extensionTelemetryLog",t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(a,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!a.enableTelemetry)}function d(a,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function u(a){const i=a.getValue(k.TELEMETRY_SETTING_ID),s=a.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return k.TelemetryLevel.NONE;switch(i??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function S(a){const i={},s={},r={};y(a,r);for(let n in r){n=n.length>150?n.substr(n.length-149):n;const o=r[n];typeof o=="number"?s[n]=o:typeof o=="boolean"?s[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),i[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[n]=o)}return{properties:i,measurements:s}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function T(a){if(!a)return"none";const i=(0,v.getRemoteName)(a);return g.has(i)?i:"other"}function y(a,i,s=0,r){if(a)for(const n of Object.getOwnPropertyNames(a)){const o=a[n],h=r?r+n:n;Array.isArray(o)?i[h]=(0,P.safeStringify)(o):o instanceof Date?i[h]=o.toISOString():(0,b.isObject)(o)?s<2?y(o,i,s+1,h+"."):i[h]=(0,P.safeStringify)(o):i[h]=o}}function f(a,i){const s=a.msftInternalDomains||[],r=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||r}function m(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function R(a,i){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let s=a;const r=[];for(const w of i)for(;;){const O=w.exec(a);if(!O)break;r.push([O.index,w.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(s="";;){const w=o.exec(a);if(!w)break;const O=r.some(([x,L])=>w.index<L&&x<o.lastIndex);!n.test(w[0])&&!O&&(s+=a.substring(h,w.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<a.length&&(s+=a.substr(h)),s}function E(a){if(!a)return a;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of i)if(s.regex.test(a))return`<REDACTED: ${s.label}>`;return a}function e(a,i){return(0,P.cloneAndChange)(a,s=>{if(s instanceof C||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let r=s.replaceAll("%20"," ");r=R(r,i);for(const n of i)r=r.replace(n,"");return r=E(r),r}})}}),define(oe[27],ae([0,1,32,21,23,13,12,9,36,41]),function(q,t,P,b,v,D,k,C,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BetterMergeId=t.ExtensionKey=void 0,t.areSameExtensions=l,t.getIdAndVersion=g,t.getExtensionId=T,t.adoptToGalleryExtensionId=y,t.getGalleryExtensionId=f,t.groupByExtension=m,t.getLocalExtensionTelemetryData=R,t.getGalleryExtensionTelemetryData=E,t.getExtensionDependencies=e,t.computeTargetPlatform=i;function l(s,r){return s.uuid&&r.uuid?s.uuid===r.uuid:s.id===r.id?!0:(0,P.compareIgnoreCase)(s.id,r.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(r){const n=r.manifest?r.manifest.version:r.version,o=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new u(r.identifier,n,o)}static parse(r){const n=d.exec(r);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,o=v.TargetPlatform.UNDEFINED){this.identifier=r,this.version=n,this.targetPlatform=o,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof u?l(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}t.ExtensionKey=u;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const r=S.exec(s);return r&&r[1]?[y(r[1]),r[2]]:[y(s),void 0]}function T(s,r){return`${s}.${r}`}function y(s){return s.toLowerCase()}function f(s,r){return y(T(s??v.UNDEFINED_PUBLISHER,r))}function m(s,r){const n=[],o=h=>{for(const w of n)if(w.some(O=>l(r(O),r(h))))return w;return null};for(const h of s){const w=o(h);w?w.push(h):n.push([h])}return n}function R(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function E(s){return{id:new c.TelemetryTrustedValue(s.identifier.id),name:new c.TelemetryTrustedValue(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}t.BetterMergeId=new v.ExtensionIdentifier("pprice.better-merge");function e(s,r){const n=[],o=r.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&n.every(w=>!l(w.identifier,{id:h}))){const w=s.filter(O=>l(O.identifier,{id:h}));w.length===1&&(n.push(w[0]),o.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function a(s,r){if(!D.isLinux)return!1;let n;try{n=(await s.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){r.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,r){const n=await a(s,r),o=(0,b.getTargetPlatform)(n?"alpine":D.platform,p.arch);return r.debug("ComputeTargetPlatform:",o),o}}),define(oe[149],ae([0,1,22,9,15,17,45,12,100,21,27,23]),function(q,t,P,b,v,D,k,C,p,c,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLI=void 0;const u=T=>(0,p.localize)(0,null,T),S=(0,p.localize)(1,null,"ms-dotnettools.csharp");let g=class{constructor(y,f,m){this.logger=y,this.extensionManagementService=f,this.extensionGalleryService=m}get location(){}async listExtensions(y,f,m){let R=await this.extensionManagementService.getInstalled(d.ExtensionType.User,m);const E=d.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(f&&f!==""){if(E.indexOf(f.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(a=>a.manifest.categories?a.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.logger.info("Possible Categories: "),E.forEach(a=>{this.logger.info(a)});return}this.location&&this.logger.info((0,p.localize)(2,null,this.location)),R=R.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let e;for(const a of R)e!==a.identifier.id&&(e=a.identifier.id,this.logger.info(y?`${e}@${a.manifest.version}`:e))}async installExtensions(y,f,m,R){const E=[];try{y.length&&this.logger.info(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const e=[],a=[],i=(r,n,o)=>{a.push({id:r,version:n!=="prerelease"?n:void 0,installOptions:{...m,isBuiltin:o,installPreReleaseVersion:n==="prerelease"||m.installPreReleaseVersion}})};for(const r of y)if(r instanceof C.URI)e.push({vsix:r,installOptions:m});else{const[n,o]=(0,l.getIdAndVersion)(r);i(n,o,!1)}for(const r of f)if(r instanceof C.URI)e.push({vsix:r,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,o]=(0,l.getIdAndVersion)(r);i(n,o,!0)}const s=await this.extensionManagementService.getInstalled(void 0,m.profileLocation);if(e.length&&await Promise.all(e.map(async({vsix:r,installOptions:n})=>{try{await this.installVSIX(r,n,R,s)}catch(o){this.logger.error(o),E.push(r.toString())}})),a.length){const r=await this.installGalleryExtensions(a,s,R);E.push(...r)}}catch(e){throw this.logger.error((0,p.localize)(5,null,(0,b.getErrorMessage)(e))),e}if(E.length)throw new Error((0,p.localize)(6,null,E.join(", ")))}async updateExtensions(y){const f=await this.extensionManagementService.getInstalled(d.ExtensionType.User,y),m=[];for(const a of f)a.identifier.uuid&&m.push({...a.identifier,preRelease:a.preRelease});this.logger.trace((0,p.localize)(7,null,m.length));const R=await this.extensionGalleryService.getExtensions(m,{compatible:!0},P.CancellationToken.None),E=[];for(const a of R)for(const i of f)(0,l.areSameExtensions)(i.identifier,a.identifier)&&(0,k.gt)(a.version,i.manifest.version)&&E.push({extension:a,options:{operation:c.InstallOperation.Update,installPreReleaseVersion:i.preRelease,profileLocation:y,isApplicationScoped:i.isApplicationScoped}});if(!E.length){this.logger.info((0,p.localize)(8,null));return}this.logger.info((0,p.localize)(9,null,E.map(a=>a.extension.identifier.id).join(", ")));const e=await this.extensionManagementService.installGalleryExtensions(E);for(const a of e)a.error?this.logger.error((0,p.localize)(10,null,a.identifier.id,(0,b.getErrorMessage)(a.error))):this.logger.info((0,p.localize)(11,null,a.identifier.id,a.local?.manifest.version))}async installGalleryExtensions(y,f,m){if(y=y.filter(({id:a,version:i})=>{const s=f.find(r=>(0,l.areSameExtensions)(r.identifier,{id:a}));if(s){if(!m&&(!i||i==="prerelease"&&s.preRelease))return this.logger.info((0,p.localize)(12,null,a,s.manifest.version,a)),!1;if(i&&s.manifest.version===i)return this.logger.info((0,p.localize)(13,null,`${a}@${i}`)),!1}return!0}),!y.length)return[];const R=[],E=[],e=await this.getGalleryExtensions(y);if(await Promise.all(y.map(async({id:a,version:i,installOptions:s})=>{const r=e.get(a.toLowerCase());if(!r){this.logger.error(`${u(i?`${a}@${i}`:a)}
${S}`),R.push(a);return}try{const o=await this.extensionGalleryService.getManifest(r,P.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),R.push(a);return}const n=f.find(o=>(0,l.areSameExtensions)(o.identifier,r.identifier));if(n){if(r.version===n.manifest.version){this.logger.info((0,p.localize)(14,null,i?`${a}@${i}`:a));return}this.logger.info((0,p.localize)(15,null,a,r.version))}s.isBuiltin?this.logger.info(i?(0,p.localize)(16,null,a,i):(0,p.localize)(17,null,a)):this.logger.info(i?(0,p.localize)(18,null,a,i):(0,p.localize)(19,null,a)),E.push({extension:r,options:{...s,installGivenVersion:!!i,isApplicationScoped:s.isApplicationScoped||n?.isApplicationScoped}})})),E.length){const a=await this.extensionManagementService.installGalleryExtensions(E);for(const i of a)i.error?(this.logger.error((0,p.localize)(20,null,i.identifier.id,(0,b.getErrorMessage)(i.error))),R.push(i.identifier.id)):this.logger.info((0,p.localize)(21,null,i.identifier.id,i.local?.manifest.version))}return R}async installVSIX(y,f,m,R){const E=await this.extensionManagementService.getManifest(y);if(!E)throw new Error("Invalid vsix");if(await this.validateVSIX(E,m,f.profileLocation,R))try{await this.extensionManagementService.install(y,f),this.logger.info((0,p.localize)(22,null,(0,D.basename)(y)))}catch(a){if((0,b.isCancellationError)(a))this.logger.info((0,p.localize)(23,null,(0,D.basename)(y)));else throw a}}async getGalleryExtensions(y){const f=new Map,m=y.some(e=>e.installOptions.installPreReleaseVersion),R=await this.extensionManagementService.getTargetPlatform(),E=[];for(const e of y)c.EXTENSION_IDENTIFIER_REGEX.test(e.id)&&E.push({...e,preRelease:m});if(E.length){const e=await this.extensionGalleryService.getExtensions(E,{targetPlatform:R},P.CancellationToken.None);for(const a of e)f.set(a.identifier.id.toLowerCase(),a)}return f}validateExtensionKind(y){return!0}async validateVSIX(y,f,m,R){if(!f){const E={id:(0,l.getGalleryExtensionId)(y.publisher,y.name)},e=R.find(a=>(0,l.areSameExtensions)(E,a.identifier)&&(0,k.gt)(a.manifest.version,y.version));if(e)return this.logger.info((0,p.localize)(24,null,e.identifier.id,e.manifest.version,y.version)),!1}return this.validateExtensionKind(y)}async uninstallExtensions(y,f,m){const R=async e=>{if(e instanceof C.URI){const a=await this.extensionManagementService.getManifest(e);return(0,l.getExtensionId)(a.publisher,a.name)}return e},E=[];for(const e of y){const a=await R(e),s=(await this.extensionManagementService.getInstalled(void 0,m)).filter(r=>(0,l.areSameExtensions)(r.identifier,{id:a}));if(!s.length)throw new Error(`${this.notInstalled(a)}
${S}`);if(s.some(r=>r.type===d.ExtensionType.System)){this.logger.info((0,p.localize)(25,null,a));return}if(!f&&s.some(r=>r.isBuiltin)){this.logger.info((0,p.localize)(26,null,a));return}this.logger.info((0,p.localize)(27,null,a));for(const r of s)await this.extensionManagementService.uninstall(r,{profileLocation:m}),E.push(r);this.location?this.logger.info((0,p.localize)(28,null,a,this.location)):this.logger.info((0,p.localize)(29,null,a))}}async locateExtension(y){const f=await this.extensionManagementService.getInstalled();y.forEach(m=>{f.forEach(R=>{if(R.identifier.id===m&&R.location.scheme===v.Schemas.file){this.logger.info(R.location.fsPath);return}})})}notInstalled(y){return this.location?(0,p.localize)(30,null,y,this.location):(0,p.localize)(31,null,y)}};t.ExtensionManagementCLI=g,t.ExtensionManagementCLI=g=Ee([se(1,c.IExtensionManagementService),se(2,c.IExtensionGalleryService)],g)}),define(oe[150],ae([0,1,5,2,31,27,23,10]),function(q,t,P,b,v,D,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;class p extends b.Disposable{constructor(l,d,u,S,g,T,y){super(),this.extensionManagementService=l,this.extensionsScannerService=d,this.userDataProfilesService=u,this.extensionsProfileScannerService=S,this.uriIdentityService=g,this.fileService=T,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new P.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new b.DisposableMap),this.initialize().then(null,f=>y.error(f))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l){try{l.length&&await Promise.all(l.map(d=>(this.extensionsProfileWatchDisposables.set(d.id,(0,b.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(d.extensionsResource)),this.fileService.watch(d.extensionsResource))),this.populateExtensionsFromProfile(d.extensionsResource))))}catch(d){throw this.logService.error(d),d}}async onAddExtensions(l){for(const d of l.extensions)this.addExtensionWithKey(this.getKey(d.identifier,d.version),l.profileLocation)}async onDidAddExtensions(l){for(const d of l.extensions){const u=this.getKey(d.identifier,d.version);l.error?this.removeExtensionWithKey(u,l.profileLocation):this.addExtensionWithKey(u,l.profileLocation)}}async onRemoveExtensions(l){for(const d of l.extensions)this.removeExtensionWithKey(this.getKey(d.identifier,d.version),l.profileLocation)}async onDidRemoveExtensions(l){const d=[],u=[];for(const S of l.extensions){const g=this.getKey(S.identifier,S.version);l.error?this.addExtensionWithKey(g,l.profileLocation):(this.removeExtensionWithKey(g,l.profileLocation),this.allExtensions.has(g)||(this.logService.debug("Extension is removed from all profiles",S.identifier.id,S.version),u.push(this.extensionManagementService.scanInstalledExtensionAtLocation(S.location).then(T=>{T?d.push(T):this.logService.info("Extension not found at the location",S.location.toString())},T=>this.logService.error(T)))))}try{await Promise.all(u),d.length&&await this.uninstallExtensionsNotInProfiles(d)}catch(S){this.logService.error(S)}}onDidFilesChange(l){for(const d of this.userDataProfilesService.profiles)l.contains(d.extensionsResource,C.FileChangeType.UPDATED,C.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(d.extensionsResource)}async onDidExtensionsProfileChange(l){const d=[],u=[],S=await this.extensionsProfileScannerService.scanProfileExtensions(l),g=new Set,T=new Set;for(const[y,f]of this.allExtensions)f.has(l)&&T.add(y);for(const y of S){const f=this.getKey(y.identifier,y.version);g.add(f),T.has(f)||(d.push(y.identifier),this.addExtensionWithKey(f,l))}for(const y of T)if(!g.has(y)){const f=this.fromKey(y);f&&(u.push(f.identifier),this.removeExtensionWithKey(y,l))}(d.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:d.length?{extensions:d,profileLocation:l}:void 0,removed:u.length?{extensions:u,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const d=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const u of d)this.addExtensionWithKey(this.getKey(u.identifier,u.version),l)}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(u=>!this.allExtensions.has(this.getKey(u.identifier,u.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,d){let u=this.allExtensions.get(l);u||this.allExtensions.set(l,u=new v.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(S))),u.add(d)}removeExtensionWithKey(l,d){const u=this.allExtensions.get(l);u&&u.delete(d),u?.size||this.allExtensions.delete(l)}getKey(l,d){return`${k.ExtensionIdentifier.toKey(l.id)}@${d}`}fromKey(l){const[d,u]=(0,D.getIdAndVersion)(l);return u?{identifier:{id:d},version:u}:void 0}}t.ExtensionsWatcher=p}),define(oe[151],ae([0,1,178,20,8,2,15,16,26,18,21,27,6,68,12]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let T=class extends S.LanguagePackBaseService{constructor(R,E,e,a){super(e),this.extensionManagementService=R,this.logService=a,this.cache=this._register(new y(E,a)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getBuiltInExtensionTranslationsUri(R,E){const a=(await this.cache.getLanguagePacks())[E];if(!a){this.logService.warn(`No language pack found for ${E}`);return}const i=a.translations[R];return i?g.URI.file(i):void 0}async getInstalledLanguages(){const R=await this.cache.getLanguagePacks(),E=Object.keys(R).map(e=>{const a=R[e];return{...this.createQuickPickItem(e,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return E.push(this.createQuickPickItem("en","English")),E.sort((e,a)=>e.label.localeCompare(a.label)),E}async postInstallExtension(R){R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",R.identifier.id),await this.update())}async postUninstallExtension(R){const E=await this.cache.getLanguagePacks();Object.keys(E).some(e=>E[e]&&E[e].extensions.some(a=>(0,d.areSameExtensions)(a.extensionIdentifier,R.identifier)))&&(this.logService.info("Removing language packs from the extension",R.identifier.id),await this.update())}async update(){const[R,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),e=await this.cache.update(E);return!(0,b.equals)(Object.keys(R),Object.keys(e))}};t.NativeLanguagePackService=T,t.NativeLanguagePackService=T=Ee([se(0,l.IExtensionManagementService),se(1,c.INativeEnvironmentService),se(2,l.IExtensionGalleryService),se(3,u.ILogService)],T);let y=class extends D.Disposable{constructor(R,E){super(),this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(R.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new v.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(R){return this.withLanguagePacks(E=>{Object.keys(E).forEach(e=>delete E[e]),this.createLanguagePacksFromExtensions(E,...R)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(R,...E){for(const e of E)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(R,e);Object.keys(R).forEach(e=>this.updateHash(R[e]))}createLanguagePacksFromExtension(R,E){const e=E.identifier,a=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const i of a)if(E.location.scheme===k.Schemas.file&&f(i)){let s=R[i.languageId];s||(s={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},R[i.languageId]=s);const r=s.extensions.filter(n=>(0,d.areSameExtensions)(n.extensionIdentifier,e))[0];r?r.version=E.manifest.version:s.extensions.push({extensionIdentifier:e,version:E.manifest.version});for(const n of i.translations)s.translations[n.id]=(0,C.join)(E.location.fsPath,n.path)}}updateHash(R){if(R){const E=(0,P.createHash)("md5");for(const e of R.extensions)E.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);R.hash=E.digest("hex")}}withLanguagePacks(R=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(E=R(e),e)).then(e=>{for(const i of Object.keys(e))e[i]||delete e[i];this.languagePacks=e,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),p.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>E,e=>this.logService.error(e))})}};y=Ee([se(0,c.INativeEnvironmentService),se(1,u.ILogService)],y);function f(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const R of m.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(oe[152],ae([0,1,87,9,28,41]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",C="https://0.0.0.0/ping";async function p(l,d,u){const S=await(0,P.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,P.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),T=new S.AppInsightsCore,y=new g.PostChannel,f={instrumentationKey:l,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(u){f.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};f.extensionConfig[y.identifier]=m}return T.initialize(f,[]),T.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',d&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),T}class c{constructor(d,u,S,g,T){this._isInternalTelemetry=d,this._eventPrefix=u,this._defaultData=S,this._xhrOverride=T,this.endPointUrl=k,this.endPointHealthUrl=C,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(d){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=p(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(u=>{d(u)},u=>{(0,b.onUnexpectedError)(u),console.error(u)})}}log(d,u){if(!this._aiCoreOrKey)return;u=(0,v.mixin)(u,this._defaultData),u=(0,D.validateTelemetryData)(u);const S=this._eventPrefix+"/"+d;try{this._withAIClient(g=>{g.pluginVersionString=u?.properties.version??"Unknown",g.track({name:S,baseData:{name:S,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(u=>{u.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=c});var Ve=this&&this.__importDefault||function(q){return q&&q.__esModule?q:{default:q}};define(oe[153],ae([0,1,2,28,13,32,113,30,40,154,33,37,19,41]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0,c=Ve(c);let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,m,R){this._configurationService=m,this._productService=R,this._experimentProperties={},this._disposables=new P.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=f.piiPaths||[],this._telemetryLevel=u.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(u.TELEMETRY_SETTING_ID)||E.affectsConfiguration(u.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(u.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,m){this._experimentProperties[f]=m}_updateTelemetryLevel(){let f=(0,S.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const R=m.usage?u.TelemetryLevel.USAGE:m.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;f=Math.min(f,R)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(f,m,R){this._telemetryLevel<m||(R=(0,b.mixin)(R,this._experimentProperties),R=(0,S.cleanData)(R,this._cleanupPatterns),R=(0,b.mixin)(R,this._commonProperties),this._appenders.forEach(E=>E.log(f,R)))}publicLog(f,m){this._log(f,u.TelemetryLevel.USAGE,m)}publicLog2(f,m){this.publicLog(f,m)}publicLogError(f,m){this._sendErrorTelemetry&&this._log(f,u.TelemetryLevel.ERROR,m)}publicLogError2(f,m){this.publicLogError(f,m)}};t.TelemetryService=g,t.TelemetryService=g=Ee([se(1,C.IConfigurationService),se(2,l.IProductService)],g);function T(){const y=(0,k.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=v.isWeb?"":(0,k.localize)(3,null),R=(0,k.localize)(4,null),E=(0,k.localize)(5,null),e=(0,k.localize)(6,null),a=(0,k.localize)(7,null),i=`
|       | ${R} | ${E} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${y} ${f} ${m}

&nbsp;

${a}
${i}

&nbsp;

${s}
`}d.Registry.as(p.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[u.TELEMETRY_SETTING_ID]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:T(),default:u.TelemetryConfiguration.OFF,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.Registry.as(p.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[u.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,k.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,k.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${u.TELEMETRY_SETTING_ID}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[155],ae([0,1,14,22,179,152]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0,v=we(v);async function k(l,d){const u=await d.request(l,b.CancellationToken.None),S=(await(0,P.streamToBuffer)(u.stream)).toString(),g=u.res.statusCode??200;return{headers:u.res.headers,statusCode:g,responseData:S}}async function C(l){const d={method:l.type,headers:l.headers};return new Promise((S,g)=>{const T=v.request(l.url??"",d,y=>{y.on("data",function(f){S({headers:y.headers,statusCode:y.statusCode??200,responseData:f.toString()})}),y.on("error",function(f){g(f)})});T.write(l.data,y=>{y&&g(y)}),T.end()})}async function p(l,d,u){const S=typeof d.data=="string"?d.data:new TextDecoder().decode(d.data),g={type:"POST",headers:{...d.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(d.data).toString()},url:d.urlString,data:S};try{const T=l?await k(g,l):await C(g);u(T.statusCode,T.headers,T.responseData)}catch{u(0,{})}}class c extends D.AbstractOneDataSystemAppender{constructor(d,u,S,g,T){const y={sendPOST:(f,m)=>{p(d,f,m)}};super(u,S,g,T,y)}}t.OneDataSystemAppender=c}),define(oe[156],ae([0,1,16,26]),function(q,t,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=v;async function v(D,k){const C=Object.create(null),p=(l,d)=>{const u=JSON.parse(l);C[d]=u};if(k){const l=[],d=await b.Promises.readdir(k);for(const S of d)try{(await b.Promises.stat((0,P.join)(k,S))).isDirectory()&&l.push(S)}catch{}const u=[];for(const S of l)(await b.Promises.readdir((0,P.join)(k,S))).filter(T=>T==="telemetry.json").length===1&&u.push(S);for(const S of u){const g=(await b.Promises.readFile((0,P.join)(k,S,"telemetry.json"))).toString();p(g,S)}}let c=(await b.Promises.readFile((0,P.join)(D,"telemetry-core.json"))).toString();return p(c,"vscode-core"),c=(await b.Promises.readFile((0,P.join)(D,"telemetry-extensions.json"))).toString(),p(c,"vscode-extensions"),JSON.stringify(C,null,4)}}),define(oe[157],ae([0,1,13,88,19]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMachineId=D,t.resolveSqmId=k,t.resolvedevDeviceId=C;async function D(p,c){let l=p.getItem(v.machineIdKey);return(typeof l!="string"||P.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,b.getMachineId)(c.error.bind(c))),l}async function k(p,c){let l=p.getItem(v.sqmIdKey);return typeof l!="string"&&(l=await(0,b.getSqmMachineId)(c.error.bind(c))),l}async function C(p,c){let l=p.getItem(v.devDeviceIdKey);return typeof l!="string"&&(l=await(0,b.getdevDeviceId)(c.error.bind(c))),l}}),define(oe[24],ae([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(oe[158],ae([0,1,24,123,10,17,79,5,2]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class c{static{this._clock=0}constructor(u){this.uri=u,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let l=class{constructor(u){this._fileService=u,this._dispooables=new p.DisposableStore,this._limit=2**16;const S=new Map,g=T=>{let y=S.get(T.scheme);return y===void 0&&(y=u.hasProvider(T)&&!this._fileService.hasCapability(T,v.FileSystemProviderCapabilities.PathCaseSensitive),S.set(T.scheme,y)),y};this._dispooables.add(C.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(T=>{S.delete(T.scheme)})),this.extUri=new D.ExtUri(g),this._canonicalUris=new k.SkipList((T,y)=>this.extUri.compare(T,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(u){this._fileService.hasProvider(u)&&(u=(0,D.normalizePath)(u));const S=this._canonicalUris.get(u);return S?S.touch().uri.with({fragment:u.fragment}):(this._canonicalUris.set(u,new c(u)),this._checkTrim(),u)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const u=[...this._canonicalUris.entries()].sort((g,T)=>g[1].time<T[1].time?1:g[1].time>T[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let g=0;g<S;g++)this._canonicalUris.set(u[g][0],u[g][1].touch())}};t.UriIdentityService=l,t.UriIdentityService=l=Ee([se(0,v.IFileService)],l),(0,b.registerSingleton)(P.IUriIdentityService,l,b.InstantiationType.Delayed)}),define(oe[159],ae([0,1,5,2,10,49,31]),function(q,t,P,b,v,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileUserDataProvider=void 0;class C extends b.Disposable{constructor(c,l,d,u,S,g){super(),this.fileSystemScheme=c,this.fileSystemProvider=l,this.userDataScheme=d,this.userDataProfilesService=u,this.uriIdentityService=S,this.logService=g,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=D.TernarySearchTree.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new k.ResourceSet(T=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(T))),this.updateAtomicReadWritesResources(),this._register(u.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(T=>this.handleFileChanges(T)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const c of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(c.settingsResource),this.atomicReadWriteResources.add(c.keybindingsResource),this.atomicReadWriteResources.add(c.tasksResource),this.atomicReadWriteResources.add(c.extensionsResource)}open(c,l){return this.fileSystemProvider.open(this.toFileSystemResource(c),l)}close(c){return this.fileSystemProvider.close(c)}read(c,l,d,u,S){return this.fileSystemProvider.read(c,l,d,u,S)}write(c,l,d,u,S){return this.fileSystemProvider.write(c,l,d,u,S)}watch(c,l){this.watchResources.set(c,c);const d=this.fileSystemProvider.watch(this.toFileSystemResource(c),l);return(0,b.toDisposable)(()=>{this.watchResources.delete(c),d.dispose()})}stat(c){return this.fileSystemProvider.stat(this.toFileSystemResource(c))}mkdir(c){return this.fileSystemProvider.mkdir(this.toFileSystemResource(c))}rename(c,l,d){return this.fileSystemProvider.rename(this.toFileSystemResource(c),this.toFileSystemResource(l),d)}readFile(c,l){return this.fileSystemProvider.readFile(this.toFileSystemResource(c),l)}readFileStream(c,l,d){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(c),l,d)}readdir(c){return this.fileSystemProvider.readdir(this.toFileSystemResource(c))}enforceAtomicReadFile(c){return this.atomicReadWriteResources.has(c)}writeFile(c,l,d){return this.fileSystemProvider.writeFile(this.toFileSystemResource(c),l,d)}enforceAtomicWriteFile(c){return this.atomicReadWriteResources.has(c)?{postfix:".vsctmp"}:!1}delete(c,l){return this.fileSystemProvider.delete(this.toFileSystemResource(c),l)}copy(c,l,d){if((0,v.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(c),this.toFileSystemResource(l),d);throw new Error("copy not supported")}cloneFile(c,l){if((0,v.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(c),this.toFileSystemResource(l));throw new Error("clone not supported")}handleFileChanges(c){const l=[];for(const d of c){if(d.resource.scheme!==this.fileSystemScheme)continue;const u=this.toUserDataResource(d.resource);this.watchResources.findSubstr(u)&&l.push({resource:u,type:d.type,cId:d.cId})}l.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(l))}toFileSystemResource(c){return c.with({scheme:this.fileSystemScheme})}toUserDataResource(c){return c.with({scheme:this.userDataScheme})}}t.FileUserDataProvider=C}),define(oe[160],ae([0,1,115,16,49,17,12,11,15]),function(q,t,P,b,v,D,k,C,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.STANDALONE_EDITOR_WORKSPACE_ID=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_SUFFIX=t.WORKSPACE_EXTENSION=t.WorkspaceFolder=t.Workspace=t.WorkbenchState=t.UNKNOWN_EMPTY_WINDOW_WORKSPACE=t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=t.IWorkspaceContextService=void 0,t.isSingleFolderWorkspaceIdentifier=c,t.isEmptyWorkspaceIdentifier=l,t.toWorkspaceIdentifier=d,t.isWorkspaceIdentifier=u,t.reviveIdentifier=S,t.isWorkspace=T,t.isWorkspaceFolder=y,t.toWorkspaceFolder=R,t.isUntitledWorkspace=E,t.isTemporaryWorkspace=e,t.isStandaloneEditorWorkspace=a,t.isSavedWorkspace=i,t.hasWorkspaceFileExtension=s,t.IWorkspaceContextService=(0,C.createDecorator)("contextService");function c(r){const n=r;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}function l(r){return typeof r?.id=="string"&&!c(r)&&!u(r)}t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},t.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function d(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,b.basename)(r)}:n?t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:t.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=r;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(r){const n=r;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}function S(r){const n=r;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}var g;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(g||(t.WorkbenchState=g={}));function T(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function y(r){const n=r;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,h,w,O){this._id=n,this._transient=h,this._configuration=w,this._ignorePathCasing=O,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=f;class m{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=m;function R(r){return new m({uri:r,index:0,name:(0,D.basenameOrAuthority)(r)},{uri:r.toString()})}t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_SUFFIX=`.${t.WORKSPACE_EXTENSION}`,t.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function E(r,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}function e(r){let n;return k.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===p.Schemas.tmp}t.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(r){return r.id===t.STANDALONE_EDITOR_WORKSPACE_ID}function i(r,n){return!E(r,n)&&!e(r)}function s(r){return(typeof r=="string"?(0,b.extname)(r):(0,D.extname)(r))===t.WORKSPACE_SUFFIX}}),define(oe[25],ae([0,1,43,5,2,17,12,114,18,10,11,6,160,31,24,8,29,32,3]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryUserDataProfilesService=t.UserDataProfilesService=t.IUserDataProfilesService=t.ProfileResourceType=void 0,t.isUserDataProfile=E,t.reviveProfile=e,t.toUserDataProfile=a;var R;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(R||(t.ProfileResourceType=R={}));function E(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}t.IUserDataProfilesService=(0,l.createDecorator)("IUserDataProfilesService");function e(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:k.URI.revive(r.location).with({scheme:n}),globalStorageHome:k.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(r.extensionsResource).with({scheme:n}),cacheHome:k.URI.revive(r.cacheHome).with({scheme:n}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function a(r,n,o,h,w,O){return{id:r,name:n,location:o,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:O&&w?.useDefaultFlags?.globalState?O.globalStorageHome:(0,D.joinPath)(o,"globalStorage"),settingsResource:O&&w?.useDefaultFlags?.settings?O.settingsResource:(0,D.joinPath)(o,"settings.json"),keybindingsResource:O&&w?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,D.joinPath)(o,"keybindings.json"),tasksResource:O&&w?.useDefaultFlags?.tasks?O.tasksResource:(0,D.joinPath)(o,"tasks.json"),snippetsHome:O&&w?.useDefaultFlags?.snippets?O.snippetsHome:(0,D.joinPath)(o,"snippets"),extensionsResource:O&&w?.useDefaultFlags?.extensions?O.extensionsResource:(0,D.joinPath)(o,"extensions.json"),cacheHome:(0,D.joinPath)(h,r),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let i=class extends v.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,h,w){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=h,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new b.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new b.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new b.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new b.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new S.ResourceMap,workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,D.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),o=[n];if(this.enabled)try{for(const O of this.getStoredProfiles()){if(!O.name||!(0,m.isString)(O.name)||!O.location){this.logService.warn("Skipping the invalid stored profile",O.location||O.name);continue}o.push(a((0,D.basename)(O.location),O.name,O.location,this.profilesCacheHome,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},n))}}catch(O){this.logService.error(O)}const h=new S.ResourceMap,w=new Map;if(o.length)try{const O=this.getStoredProfileAssociations();if(O.workspaces)for(const[x,L]of Object.entries(O.workspaces)){const A=k.URI.parse(x),_=o.find(X=>X.id===L);_&&h.set(A,_)}if(O.emptyWindows)for(const[x,L]of Object.entries(O.emptyWindows)){const A=o.find(_=>_.id===L);A&&w.set(x,A)}}catch(O){this.logService.error(O)}this._profilesObject={profiles:o,workspaces:h,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const n=a("__default__profile__",(0,C.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",h=new RegExp(`${(0,f.escapeRegExpCharacters)(o)}\\s(\\d+)`);let w=0;for(const x of this.profiles){const L=h.exec(x.name),A=L?parseInt(L[1]):0;w=A>w?A:w}const O=`${o} ${w+1}`;return this.createProfile((0,P.hash)((0,y.generateUuid)()).toString(16),O,{transient:!0},n)}async createNamedProfile(n,o,h){return this.createProfile((0,P.hash)((0,y.generateUuid)()).toString(16),n,o,h)}async createProfile(n,o,h,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const O=await this.doCreateProfile(n,o,h);return w&&await this.setProfileForWorkspace(w,O),O}async doCreateProfile(n,o,h){if(!(0,m.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(o);return w||(w=(async()=>{try{if(this.profiles.find(A=>A.name===o||A.id===n))throw new Error(`Profile with ${o} name already exists`);const x=a(n,o,(0,D.joinPath)(this.profilesHome,n),this.profilesCacheHome,h,this.defaultProfile);await this.fileService.createFolder(x.location);const L=[];return this._onWillCreateProfile.fire({profile:x,join(A){L.push(A)}}),await T.Promises.settled(L),this.updateProfiles([x],[],[]),x}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,w)),w}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(w=>w.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);return h=a(h.id,o.name??h.name,h.location,this.profilesCacheHome,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[h]),h}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(w=>w.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const h=[];this._onWillRemoveProfile.fire({profile:o,join(w){h.push(w)}});try{await Promise.allSettled(h)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(w){(0,c.toFileOperationResult)(w)!==c.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(w=>w.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,h)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.uriIdentityService.extUri.isEqual(h.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n),h=k.URI.isUri(o)?this.profilesObject.workspaces.get(o):this.profilesObject.emptyWindows.get(o);return h||((0,u.isSingleFolderWorkspaceIdentifier)(n)?this.transientProfilesObject.folders.get(n.uri):(0,u.isWorkspaceIdentifier)(n)?this.transientProfilesObject.workspaces.get(n.configPath):this.transientProfilesObject.emptyWindows.get(n.id))}getWorkspace(n){return(0,u.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,u.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.folders.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,h){const w=[...this.profiles,...n],O=[],x=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let L of w){if(L.isDefault||o.some(_=>L.id===_.id))continue;L=h.find(_=>L.id===_.id)??L;const A=x.find(_=>L.id===_.id);if(L.isTransient)this.transientProfilesObject.profiles.push(L);else{if(A){for(const[_,X]of this.transientProfilesObject.emptyWindows.entries())if(L.id===X.id){this.updateWorkspaceAssociation({id:_},L);break}for(const[_,X]of this.transientProfilesObject.workspaces.entries())if(L.id===X.id){this.updateWorkspaceAssociation({id:"",configPath:_},L);break}for(const[_,X]of this.transientProfilesObject.folders.entries())if(L.id===X.id){this.updateWorkspaceAssociation({id:"",uri:_},L);break}}O.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.saveStoredProfiles(O),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,h)}triggerProfilesChanges(n,o,h){this._onDidChangeProfiles.fire({added:n,removed:o,updated:h,all:this.profiles})}updateWorkspaceAssociation(n,o,h){if(h=o?.isTransient?!0:h,h)(0,u.isSingleFolderWorkspaceIdentifier)(n)?(this.transientProfilesObject.folders.delete(n.uri),o&&this.transientProfilesObject.folders.set(n.uri,o)):(0,u.isWorkspaceIdentifier)(n)?(this.transientProfilesObject.workspaces.delete(n.configPath),o&&this.transientProfilesObject.workspaces.set(n.configPath,o)):(this.transientProfilesObject.emptyWindows.delete(n.id),o&&this.transientProfilesObject.emptyWindows.set(n.id,o));else{this.updateWorkspaceAssociation(n,void 0,!0);const w=this.getWorkspace(n);k.URI.isUri(w)?(this.profilesObject.workspaces.delete(w),o&&this.profilesObject.workspaces.set(w,o)):(this.profilesObject.emptyWindows.delete(w),o&&this.profilesObject.emptyWindows.set(w,o)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const n={};for(const[h,w]of this.profilesObject.workspaces.entries())n[h.toString()]=w.id;const o={};for(const[h,w]of this.profilesObject.emptyWindows.entries())o[h.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},h=this.createDefaultProfile();if(n.workspaces)for(const[O,x]of Object.entries(n.workspaces)){const L=k.URI.parse(x);o[O]=this.uriIdentityService.extUri.isEqual(L,h.location)?h.id:this.uriIdentityService.extUri.basename(L)}const w={};if(n.emptyWindows)for(const[O,x]of Object.entries(n.emptyWindows)){const L=k.URI.parse(x);w[O]=this.uriIdentityService.extUri.isEqual(L,h.location)?h.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.UserDataProfilesService=i,t.UserDataProfilesService=i=Ee([se(0,p.IEnvironmentService),se(1,c.IFileService),se(2,g.IUriIdentityService),se(3,d.ILogService)],i);class s extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}t.InMemoryUserDataProfilesService=s}),define(oe[53],ae([0,1,20,8,22,9,5,2,13,3,12,98,21,27,23,44,6,33,19,24,25]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.AbstractExtensionManagementService=void 0,t.toExtensionManagementError=a,d=we(d);let e=class extends C.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,o,h,w,O,x){super(),this.galleryService=n,this.telemetryService=o,this.uriIdentityService=h,this.logService=w,this.productService=O,this.userDataProfilesService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(h=>(0,u.isTargetPlatformCompatible)(h,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const w=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:O})=>(0,S.areSameExtensions)(O,n.identifier));if(w?.local)return w?.local;throw w?.error?w.error:new u.ExtensionManagementError(`Unknown error while installing extension ${n.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(h){throw a(h)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new u.ExtensionManagementError(d.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const o=[],h=[];return await Promise.allSettled(n.map(async({extension:w,options:O})=>{try{const x=await this.checkAndGetCompatibleVersion(w,!!O?.installGivenVersion,!!O?.installPreReleaseVersion,O.productVersion??{version:this.productService.version,date:this.productService.date});h.push({...x,options:O})}catch(x){o.push({identifier:w.identifier,operation:u.InstallOperation.Install,source:w,error:x,profileLocation:O.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),h.length&&o.push(...await this.installExtensions(h)),o}async uninstall(n,o={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,o)}async toggleAppliationScope(n,o){if((0,g.isApplicationScopedExtension)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let h=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(h=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const w of this.userDataProfilesService.profiles){const O=(await this.getInstalled(g.ExtensionType.User,w.extensionsResource)).find(x=>(0,S.areSameExtensions)(x.identifier,n.identifier));O?this._onDidUpdateExtensionMetadata.fire({local:O,profileLocation:w.extensionsResource}):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:w.extensionsResource})}return h}else{const h=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:h.identifier,operation:u.InstallOperation.Install,local:h,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const o=new Map,h=new Map,w=[],O=(L,A)=>`${S.ExtensionKey.create(L).toString()}-${A.toString()}`,x=(L,A,_,X)=>{const Y=this.createInstallExtensionTask(L,A,_),ne=`${(0,S.getGalleryExtensionId)(L.publisher,L.name)}-${_.profileLocation.toString()}`;h.set(ne,{task:Y,root:X}),this._onInstallExtension.fire({identifier:Y.identifier,source:A,profileLocation:_.profileLocation}),this.logService.info("Installing extension:",Y.identifier.id,_),l.URI.isUri(A)||this.installingExtensions.set(O(A,_.profileLocation),{task:Y,waitingTasks:[]})};try{for(const{manifest:L,extension:A,options:_}of n){const X=_.isApplicationScoped||_.isBuiltin||(0,g.isApplicationScopedExtension)(L),Y={..._,installOnlyNewlyAddedFromExtensionPack:_.installOnlyNewlyAddedFromExtensionPack??!l.URI.isUri(A),isApplicationScoped:X,profileLocation:X?this.userDataProfilesService.defaultProfile.extensionsResource:_.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:_.productVersion??{version:this.productService.version,date:this.productService.date}},ne=l.URI.isUri(A)?void 0:this.installingExtensions.get(O(A,Y.profileLocation));ne?(this.logService.info("Extension is already requested to install",ne.task.identifier.id,Y.profileLocation.toString()),w.push(ne.task.waitUntilTaskIsFinished())):x(L,A,Y,void 0)}return await Promise.all([...h.values()].map(async({task:L})=>{if(L.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const A=await this.getAllDepsAndPackExtensions(L.identifier,L.manifest,!!L.options.installOnlyNewlyAddedFromExtensionPack,!!L.options.installPreReleaseVersion,L.options.profileLocation,L.options.productVersion),_=await this.getInstalled(void 0,L.options.profileLocation,L.options.productVersion),X={...L.options,context:{...L.options.context,[u.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:Y,manifest:ne}of(0,P.distinct)(A,({gallery:ce})=>ce.identifier.id)){if(h.has(`${Y.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`))continue;const ce=this.installingExtensions.get(O(Y,X.profileLocation));if(ce){if(this.canWaitForTask(L,ce.task)){const ue=ce.task.identifier;this.logService.info("Waiting for already requested installing extension",ue.id,L.identifier.id,X.profileLocation.toString()),ce.waitingTasks.push(L),w.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,he=>he.some(B=>(0,S.areSameExtensions)(B.identifier,ue)))).then(he=>{if(this.logService.info("Finished waiting for already requested installing extension",ue.id,L.identifier.id,X.profileLocation.toString()),!he.find(Z=>(0,S.areSameExtensions)(Z.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else _.some(({identifier:ue})=>(0,S.areSameExtensions)(ue,Y.identifier))||x(ne,Y,X,L)}}catch(A){if(l.URI.isUri(L.source))(0,P.isNonEmptyArray)(L.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,A.message),(0,P.isNonEmptyArray)(L.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),A}})),await this.joinAllSettled([...h.entries()].map(async([L,{task:A}])=>{const _=new Date().getTime();let X;try{X=await A.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(X,A.source,A.options,v.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(Y){const ne=a(Y);throw l.URI.isUri(A.source)||i(this.telemetryService,A.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(A.source),error:ne,source:A.options.context?.[u.EXTENSION_INSTALL_SOURCE_CONTEXT]}),o.set(L,{error:ne,identifier:A.identifier,operation:A.operation,source:A.source,context:A.options.context,profileLocation:A.options.profileLocation,applicationScoped:A.options.isApplicationScoped}),this.logService.error("Error while installing the extension",A.identifier.id,(0,D.getErrorMessage)(ne),A.options.profileLocation.toString()),ne}if(!l.URI.isUri(A.source)){const Y=A.operation===u.InstallOperation.Update,ne=Y?void 0:(new Date().getTime()-A.source.lastUpdated)/1e3;if(i(this.telemetryService,Y?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(A.source),verificationStatus:A.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:ne,source:A.options.context?.[u.EXTENSION_INSTALL_SOURCE_CONTEXT]}),p.isWeb&&A.operation!==u.InstallOperation.Update)try{await this.galleryService.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,u.StatisticType.Install)}catch{}}o.set(L,{local:X,identifier:A.identifier,operation:A.operation,source:A.source,context:A.options.context,profileLocation:A.options.profileLocation,applicationScoped:X.isApplicationScoped})})),w.length&&await this.joinAllSettled(w),[...o.values()]}catch(L){const A=(Y,ne,ce)=>{const ue=[];Y.manifest.extensionDependencies?.length&&ue.push(...Y.manifest.extensionDependencies),Y.manifest.extensionPack?.length&&ue.push(...Y.manifest.extensionPack);for(const he of ue){if(ce.includes(he.toLowerCase()))continue;ce.push(he.toLowerCase());const B=o.get(`${he.toLowerCase()}-${ne.toString()}`);B?.local&&(ce=A(B.local,ne,ce))}return ce},_=Y=>({identifier:Y.identifier,operation:u.InstallOperation.Install,source:Y.source,context:Y.options.context,profileLocation:Y.options.profileLocation,error:L}),X=[];for(const[Y,{task:ne,root:ce}]of h){const ue=o.get(Y);ue?ue.local&&ce&&!o.get(`${ce.identifier.id.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local&&(X.push(this.createUninstallExtensionTask(ue.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),o.set(Y,_(ne))):(ne.cancel(),o.set(Y,_(ne)))}for(const[Y,{task:ne}]of h){const ce=o.get(Y);if(!ce?.local||ne.options.donotIncludePackAndDependencies)continue;A(ce.local,ne.options.profileLocation,[ce.local.identifier.id.toLowerCase()]).slice(1).some(he=>h.has(`${he.toLowerCase()}-${ne.options.profileLocation.toString()}`)&&!o.get(`${he.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local)&&(X.push(this.createUninstallExtensionTask(ce.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),o.set(Y,_(ne)))}throw X.length&&await Promise.allSettled(X.map(async Y=>{try{await Y.run(),this.logService.info("Rollback: Uninstalled extension",Y.extension.identifier.id)}catch(ne){this.logService.warn("Rollback: Error while uninstalling extension",Y.extension.identifier.id,(0,D.getErrorMessage)(ne))}})),L}finally{for(const{task:L}of h.values())L.source&&!l.URI.isUri(L.source)&&this.installingExtensions.delete(O(L.source,L.options.profileLocation));if(o.size){const L=[...o.values()];for(const A of L)A.local&&this.logService.info("Extension installed successfully:",A.identifier.id,A.profileLocation.toString());this._onDidInstallExtensions.fire(L)}}}canWaitForTask(n,o){for(const[,{task:h,waitingTasks:w}]of this.installingExtensions.entries())if(h===n&&(w.includes(o)||w.some(O=>this.canWaitForTask(O,o)))||h===o&&w[0]&&!this.canWaitForTask(n,w[0]))return!1;return!0}async joinAllSettled(n,o){const h=[],w=[],O=await Promise.allSettled(n);for(const L of O)L.status==="fulfilled"?h.push(L.value):w.push(a(L.reason,o));if(!w.length)return h;if(w.length===1)throw w[0];let x=new u.ExtensionManagementError("",u.ExtensionManagementErrorCode.Unknown);for(const L of w)x=new u.ExtensionManagementError(x.message?`${x.message}, ${L.message}`:L.message,L.code!==u.ExtensionManagementErrorCode.Unknown&&L.code!==u.ExtensionManagementErrorCode.Internal?L.code:x.code);throw x}async getAllDepsAndPackExtensions(n,o,h,w,O,x){if(!this.galleryService.isEnabled())return[];const L=await this.getInstalled(void 0,O,x),A=[],_=[],X=async(Y,ne)=>{A.push(Y);const ce=ne.extensionDependencies||[],ue=[...ce];if(ne.extensionPack){const he=h?L.find(B=>(0,S.areSameExtensions)(B.identifier,Y)):void 0;for(const B of ne.extensionPack)he&&he.manifest.extensionPack&&he.manifest.extensionPack.some(Z=>(0,S.areSameExtensions)({id:Z},{id:B}))||ue.every(Z=>!(0,S.areSameExtensions)({id:Z},{id:B}))&&ue.push(B)}if(ue.length){const he=ue.filter(B=>A.every(Z=>!(0,S.areSameExtensions)(Z,{id:B})));if(he.length){const B=await this.galleryService.getExtensions(he.map(Z=>({id:Z,preRelease:w})),v.CancellationToken.None);for(const Z of B){if(A.find(G=>(0,S.areSameExtensions)(G,Z.identifier)))continue;const z=ce.some(G=>(0,S.areSameExtensions)({id:G},Z.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(Z,!1,w,x)}catch(G){if(z)throw G;this.logService.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,D.getErrorMessage)(G));continue}_.push({gallery:W.extension,manifest:W.manifest}),await X(W.extension.identifier,W.manifest)}}}};return await X(n,o),_}async checkAndGetCompatibleVersion(n,o,h,w){let O;const x=await this.getExtensionsControlManifest();if(x.malicious.some(_=>(0,S.areSameExtensions)(n.identifier,_)))throw new u.ExtensionManagementError(d.localize(1,null,n.identifier.id),u.ExtensionManagementErrorCode.Malicious);const L=x.deprecated[n.identifier.id.toLowerCase()];if(L?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${L.extension.id}' extension instead.`),O=(await this.galleryService.getExtensions([{id:L.extension.id,preRelease:L.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:w},v.CancellationToken.None))[0],!O)throw new u.ExtensionManagementError(d.localize(2,null,n.identifier.id,L.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const _=await this.getTargetPlatform();throw new u.ExtensionManagementError(d.localize(3,null,n.identifier.id,this.productService.nameLong,(0,u.TargetPlatformToString)(_)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.getCompatibleVersion(n,o,h,w),!O){const _=[];throw(0,T.areApiProposalsCompatible)(n.properties.enabledApiProposals??[],_)?!h&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],v.CancellationToken.None))[0]?new u.ExtensionManagementError(d.localize(5,null,n.displayName??n.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.ExtensionManagementError(d.localize(6,null,n.identifier.id,this.productService.nameLong,this.productService.version),u.ExtensionManagementErrorCode.Incompatible):new u.ExtensionManagementError(d.localize(4,null,n.displayName??n.identifier.id,_[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",O.identifier.id);const A=await this.galleryService.getManifest(O,v.CancellationToken.None);if(A===null)throw new u.ExtensionManagementError(`Missing manifest for extension ${O.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(A.version!==O.version)throw new u.ExtensionManagementError(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:A}}async getCompatibleVersion(n,o,h,w){const O=await this.getTargetPlatform();let x=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==h&&(x=(await this.galleryService.getExtensions([{...n.identifier,preRelease:h}],{targetPlatform:O,compatible:!0,productVersion:w},v.CancellationToken.None))[0]||null),!x&&await this.galleryService.isExtensionCompatible(n,h,O,w)&&(x=n),x||(o?x=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:O,compatible:!0,productVersion:w},v.CancellationToken.None))[0]||null:x=await this.galleryService.getCompatibleExtension(n,h,O,w)),x}async uninstallExtension(n,o){const h={...o,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},w=X=>`${X.id.toLowerCase()}${h.versionOnly?`-${n.manifest.version}`:""}${h.profileLocation?`@${h.profileLocation.toString()}`:""}`,O=this.uninstallingExtensions.get(w(n.identifier));if(O)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),O.waitUntilTaskIsFinished();const x=X=>{const Y=this.createUninstallExtensionTask(X,h);return this.uninstallingExtensions.set(w(Y.extension.identifier),Y),h.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,h.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this._onUninstallExtension.fire({identifier:X.identifier,profileLocation:h.profileLocation,applicationScoped:X.isApplicationScoped}),Y},L=(X,Y)=>{Y?h.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,h.profileLocation.toString(),Y.message):this.logService.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,Y.message):h.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,h.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),i(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(X),error:Y}),this._onDidUninstallExtension.fire({identifier:X.identifier,error:Y?.code,profileLocation:h.profileLocation,applicationScoped:X.isApplicationScoped})},A=[],_=[];try{A.push(x(n));const X=await this.getInstalled(g.ExtensionType.User,h.profileLocation);if(h.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const Y=this.getAllPackExtensionsToUninstall(n,X);for(const ne of Y)this.uninstallingExtensions.has(w(ne.identifier))?this.logService.info("Extensions is already requested to uninstall",ne.identifier.id):A.push(x(ne))}h.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(A.map(Y=>Y.extension),X,n),await this.joinAllSettled(A.map(async Y=>{try{if(await Y.run(),await this.joinAllSettled(this.participants.map(ne=>ne.postUninstall(Y.extension,h,v.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,u.StatisticType.Uninstall)}catch{}L(Y.extension)}catch(ne){const ce=a(ne);throw L(Y.extension,ce),ce}finally{_.push(Y)}}))}catch(X){const Y=a(X);for(const ne of A){try{ne.cancel()}catch{}_.includes(ne)||L(ne.extension,Y)}throw Y}finally{for(const X of A)this.uninstallingExtensions.delete(w(X.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}checkForDependents(n,o,h){for(const w of n){const O=this.getDependents(w,o);if(O.length){const x=O.filter(L=>!n.some(A=>(0,S.areSameExtensions)(A.identifier,L.identifier)));if(x.length)throw new Error(this.getDependentsErrorMessage(w,x,h))}}}getDependentsErrorMessage(n,o,h){return h===n?o.length===1?d.localize(7,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(8,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(9,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?d.localize(10,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(11,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(12,null,h.manifest.displayName||h.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(n,o,h=[]){if(h.indexOf(n)!==-1)return[];h.push(n);const w=n.manifest.extensionPack?n.manifest.extensionPack:[];if(w.length){const O=o.filter(L=>!L.isBuiltin&&w.some(A=>(0,S.areSameExtensions)({id:A},L.identifier))),x=[];for(const L of O)x.push(...this.getAllPackExtensionsToUninstall(L,o,h));return[...O,...x]}return[]}getDependents(n,o){return o.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(w=>(0,S.areSameExtensions)({id:w},n.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(n){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.getErrorMessage)(n)),{malicious:[],deprecated:{},search:[]}}}};t.AbstractExtensionManagementService=e,t.AbstractExtensionManagementService=e=Ee([se(0,u.IExtensionGalleryService),se(1,m.ITelemetryService),se(2,R.IUriIdentityService),se(3,y.ILogService),se(4,f.IProductService),se(5,E.IUserDataProfilesService)],e);function a(r,n){if(r instanceof u.ExtensionManagementError)return r;let o;return r instanceof u.ExtensionGalleryError?o=new u.ExtensionManagementError(r.message,r.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):o=new u.ExtensionManagementError(r.message,(0,D.isCancellationError)(r)?u.ExtensionManagementErrorCode.Cancelled:n??u.ExtensionManagementErrorCode.Internal),o.stack=r.stack,o}function i(r,n,{extensionData:o,verificationStatus:h,duration:w,error:O,source:x,durationSinceUpdate:L}){let A,_;(0,c.isDefined)(h)&&(h===!0?h="Verified":(h===!1||(A=u.ExtensionManagementErrorCode.Signature,_=h),h="Unverified")),O&&(A=O.code,O.code===u.ExtensionManagementErrorCode.Signature&&(_=O.message)),r.publicLog(n,{...o,verificationStatus:h,success:!O,duration:w,errorcode:A,errorcodeDetail:_,durationSinceUpdate:L,source:x})}class s{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(n=>new Promise((o,h)=>{const w=n.onCancellationRequested(()=>{w.dispose(),h(new D.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=s}),define(oe[42],ae([0,1,8,14,2,5,31,12,21,27,10,11,6,25,24,3,9,19]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionsProfileScannerService=t.IExtensionsProfileScannerService=t.ExtensionsProfileScanningError=t.ExtensionsProfileScanningErrorCode=void 0;var m;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(t.ExtensionsProfileScanningErrorCode=m={}));class R extends Error{constructor(s,r){super(s),this.code=r}}t.ExtensionsProfileScanningError=R,t.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let E=class extends v.Disposable{constructor(s,r,n,o,h,w){super(),this.extensionsLocation=s,this.fileService=r,this.userDataProfilesService=n,this.uriIdentityService=o,this.telemetryService=h,this.logService=w,this._onAddExtensions=this._register(new D.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new D.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new D.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new D.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(s,r){return this.withProfileExtensions(s,void 0,r)}async addExtensionsToProfile(s,r,n){const o=[],h=[];try{return await this.withProfileExtensions(r,w=>{const O=[];if(n)O.push(...w);else for(const x of w)s.some(([L])=>(0,c.areSameExtensions)(L.identifier,x.identifier)&&L.manifest.version!==x.version)?o.push(x):O.push(x);for(const[x,L]of s){const A=O.findIndex(X=>(0,c.areSameExtensions)(X.identifier,x.identifier)&&X.version===x.manifest.version),_={identifier:x.identifier,version:x.manifest.version,location:x.location,metadata:L};A===-1?(h.push(_),O.push(_)):O.splice(A,1,_)}return h.length&&this._onAddExtensions.fire({extensions:h,profileLocation:r}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:r}),O}),h.length&&this._onDidAddExtensions.fire({extensions:h,profileLocation:r}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:r}),h}catch(w){throw h.length&&this._onDidAddExtensions.fire({extensions:h,error:w,profileLocation:r}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:w,profileLocation:r}),w}}async updateMetadata(s,r){const n=[];return await this.withProfileExtensions(r,o=>{const h=[];for(const w of o){const O=s.find(([x])=>(0,c.areSameExtensions)(x.identifier,w.identifier)&&x.manifest.version===w.version);O&&(w.metadata={...w.metadata,...O[1]},n.push(w)),h.push(w)}return h}),n}async removeExtensionFromProfile(s,r){const n=[];try{await this.withProfileExtensions(r,o=>{const h=[];for(const w of o)(0,c.areSameExtensions)(w.identifier,s.identifier)?n.push(w):h.push(w);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:r}),h}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:r})}catch(o){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:o,profileLocation:r}),o}}async withProfileExtensions(s,r,n){return this.getResourceAccessQueue(s).queue(async()=>{let o=[],h;try{const w=await this.fileService.readFile(s);h=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,l.toFileOperationResult)(w)!==l.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(h=await this.migrateFromOldDefaultProfileExtensionsLocation()),!h&&n?.bailOutWhenFileNotFound)throw new R((0,y.getErrorMessage)(w),m.ERROR_PROFILE_NOT_FOUND)}if(h){Array.isArray(h)||this.reportAndThrowInvalidConentError(s);let w=!1;for(const O of h){e(O)||this.reportAndThrowInvalidConentError(s);let x;if((0,T.isString)(O.relativeLocation)&&O.relativeLocation)x=this.resolveExtensionLocation(O.relativeLocation);else if((0,T.isString)(O.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{x=C.URI.revive(O.location);const L=this.toRelativePath(x);L&&(w=!0,O.relativeLocation=L)}(0,T.isUndefined)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(w=!0,O.metadata.hasPreReleaseVersion=!0),o.push({identifier:O.identifier,location:x,version:O.version,metadata:O.metadata})}w&&await this.fileService.writeFile(s,b.VSBuffer.fromString(JSON.stringify(h)))}if(r){o=r(o);const w=o.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.toRelativePath(O.location),metadata:O.metadata}));await this.fileService.writeFile(s,b.VSBuffer.fromString(JSON.stringify(w)))}return o})}reportAndThrowInvalidConentError(s){const r=new R(`Invalid extensions content in ${s.toString()}`,m.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),r=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(h){if((0,l.toFileOperationResult)(h)===l.FileOperationResult.FILE_NOT_FOUND)return;throw h}this.logService.info("Migrating extensions from old default profile location",s.toString());let o;try{const h=JSON.parse(n);Array.isArray(h)&&h.every(w=>e(w))?o=h:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.logService.error(h)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,b.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(h){if((0,l.toFileOperationResult)(h)===l.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw h}try{await this.fileService.del(s)}catch(h){(0,l.toFileOperationResult)(h)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}try{await this.fileService.del(r)}catch(h){(0,l.toFileOperationResult)(h)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}return o})()),this._migrationPromise}getResourceAccessQueue(s){let r=this.resourcesAccessQueueMap.get(s);return r||(r=new P.Queue,this.resourcesAccessQueueMap.set(s,r)),r}};t.AbstractExtensionsProfileScannerService=E,t.AbstractExtensionsProfileScannerService=E=Ee([se(1,l.IFileService),se(2,S.IUserDataProfilesService),se(3,g.IUriIdentityService),se(4,f.ITelemetryService),se(5,u.ILogService)],E);function e(i){return(0,T.isObject)(i)&&(0,p.isIExtensionIdentifier)(i.identifier)&&(a(i.location)||(0,T.isString)(i.location)&&i.location)&&((0,T.isUndefined)(i.relativeLocation)||(0,T.isString)(i.relativeLocation))&&i.version&&(0,T.isString)(i.version)}function a(i){return i?(0,T.isString)(i.path)&&(0,T.isString)(i.scheme):!1}});var Ve=this&&this.__importDefault||function(q){return q&&q.__esModule?q:{default:q}};define(oe[54],ae([0,1,20,8,28,14,9,34,85,2,15,16,13,17,45,56,3,12,102,18,27,23,44,10,11,6,33,5,48,42,25,24,121]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E,e,a,i,s,r,n,o,h,w,O,x,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.ExtensionScannerInput=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0,t.toExtensionDescription=ce,v=we(v),d=we(d),u=we(u),g=we(g),T=Ve(T);var A;(function(he){function B(Z,z){if(Z===z)return!0;const W=Object.keys(Z),G=new Set;for(const Q of Object.keys(z))G.add(Q);if(W.length!==G.size)return!1;for(const Q of W){if(Z[Q]!==z[Q])return!1;G.delete(Q)}return G.size===0}he.equals=B})(A||(t.Translations=A={})),t.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let _=class extends c.Disposable{constructor(B,Z,z,W,G,Q,te,F,V,K,j,I){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Z,this.extensionsControlLocation=z,this.currentProfile=W,this.userDataProfilesService=G,this.extensionsProfileScannerService=Q,this.fileService=te,this.logService=F,this.environmentService=V,this.productService=K,this.uriIdentityService=j,this.instantiationService=I,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Y,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(e.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(e.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,Z,z){const[W,G]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Z)]),Q=z?await this.scanExtensionsUnderDevelopment(B,[...W,...G]):[];return this.dedupExtensions(W,G,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Z=[];Z.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),Z.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[z,W]=await Promise.all(Z);return this.applyScanOptions([...z,...W],e.ExtensionType.System,B,!1)}async scanUserExtensions(B){const Z=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Z);const z=this.uriIdentityService.extUri.isEqual(B.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Z,!!B.profileLocation,e.ExtensionType.User,!B.includeUninstalled,B.language,!0,z,B.productVersion??this.getProductVersion()),G=B.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Q;try{Q=await G.scanExtensions(W)}catch(te){if(te instanceof w.ExtensionsProfileScanningError&&te.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),Q=await G.scanExtensions(W);else throw te}return Q=await this.applyScanOptions(Q,e.ExtensionType.User,B,!0),this.logService.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(B,Z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===l.Schemas.file).map(async W=>{const G=await this.createExtensionScannerInput(W,!1,e.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(G)).map(te=>(te.type=Z.find(F=>(0,E.areSameExtensions)(F.identifier,te.identifier))?.type??te.type,this.extensionsScanner.validate(te,G)))}))).flat();return this.applyScanOptions(z,"development",B,!0)}return[]}async scanExistingExtension(B,Z,z){const W=await this.createExtensionScannerInput(B,!1,Z,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),G=await this.extensionsScanner.scanExtension(W);return!G||!z.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(B,Z,z){const W=await this.createExtensionScannerInput(B,!1,Z,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),G=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(G,Z,z,!0)}async scanMultipleExtensions(B,Z,z){const W=[];return await Promise.all(B.map(async G=>{const Q=await this.scanOneOrMultipleExtensions(G,Z,z);W.push(...Q)})),this.applyScanOptions(W,Z,z,!0)}async scanMetadata(B){const Z=(0,S.joinPath)(B,"package.json"),z=(await this.fileService.readFile(Z)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(B,Z){const z=(0,S.joinPath)(B,"package.json"),W=(await this.fileService.readFile(z)).value.toString(),G=JSON.parse(W);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,G.__metadata={...G.__metadata,...Z},await this.fileService.writeFile((0,S.joinPath)(B,"package.json"),D.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof w.ExtensionsProfileScanningError&&B.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw B}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(Z=>[Z,Z.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,i.toFileOperationResult)(Z)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(Z))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.logService.error(B)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(B,Z,z,W){return z.includeAllVersions||(B=this.dedupExtensions(Z===e.ExtensionType.System?B:void 0,Z===e.ExtensionType.User?B:void 0,Z==="development"?B:void 0,await this.getTargetPlatform(),W)),z.includeInvalid||(B=B.filter(G=>G.isValid)),B.sort((G,Q)=>{const te=d.basename(G.location.fsPath),F=d.basename(Q.location.fsPath);return te<F?-1:te>F?1:0})}dedupExtensions(B,Z,z,W,G){const Q=(F,V,K)=>{if(F.isValid&&!V.isValid)return!1;if(F.isValid===V.isValid){if(G&&g.gt(F.manifest.version,V.manifest.version))return this.logService.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(g.eq(F.manifest.version,V.manifest.version)){if(F.type===e.ExtensionType.System)return this.logService.debug(`Skipping extension ${V.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===W)return this.logService.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return K?this.logService.warn(`Overwriting user extension ${F.location.path} with ${V.location.path}.`):this.logService.debug(`Overwriting user extension ${F.location.path} with ${V.location.path}.`),!0},te=new e.ExtensionIdentifierMap;return B?.forEach(F=>{const V=te.get(F.identifier.id);(!V||Q(V,F,!1))&&te.set(F.identifier.id,F)}),Z?.forEach(F=>{const V=te.get(F.identifier.id);if(!V&&B&&F.type===e.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!V||Q(V,F,!1))&&te.set(F.identifier.id,F)}),z?.forEach(F=>{const V=te.get(F.identifier.id);(!V||Q(V,F,!0))&&te.set(F.identifier.id,F),te.set(F.identifier.id,F)}),[...te.values()]}async scanDefaultSystemExtensions(B,Z){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,e.ExtensionType.System,!0,Z,!0,void 0,this.getProductVersion()),G=await(B&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",G.length),G}async scanDevSystemExtensions(B,Z){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Z?await this.getBuiltInExtensionControl():{},G=[],Q=f.URI.file(d.normalize(d.join(l.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of z){const V=W[F.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":G.push((0,S.joinPath)(Q,F.name));break;default:G.push(f.URI.file(V));break}}const te=await Promise.all(G.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,!1,e.ExtensionType.System,!0,B,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",te.length),(0,P.coalesce)(te)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,Z,z,W,G,Q,te,F){const V=await this.getTranslations(G??u.language),K=await this.getMtime(B),j=Z&&!this.uriIdentityService.extUri.isEqual(B,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,I=j?await this.getMtime(j):void 0;return new X(B,K,j,I,Z,te,z,W,Q,F.version,F.date,this.productService.commit,!this.environmentService.isBuilt,G,V)}async getMtime(B){try{const Z=await this.fileService.stat(B);if(typeof Z.mtime=="number")return Z.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};t.AbstractExtensionsScannerService=_,t.AbstractExtensionsScannerService=_=Ee([se(4,O.IUserDataProfilesService),se(5,w.IExtensionsProfileScannerService),se(6,i.IFileService),se(7,r.ILogService),se(8,R.IEnvironmentService),se(9,n.IProductService),se(10,x.IUriIdentityService),se(11,s.IInstantiationService)],_);class X{constructor(B,Z,z,W,G,Q,te,F,V,K,j,I,M,U,N){this.location=B,this.mtime=Z,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=W,this.profile=G,this.profileScanOptions=Q,this.type=te,this.excludeObsolete=F,this.validate=V,this.productVersion=K,this.productDate=j,this.productCommit=I,this.devMode=M,this.language=U,this.translations=N}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Z){return(0,S.isEqual)(B.location,Z.location)&&B.mtime===Z.mtime&&(0,S.isEqual)(B.applicationExtensionslocation,Z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&B.profile===Z.profile&&v.equals(B.profileScanOptions,Z.profileScanOptions)&&B.type===Z.type&&B.excludeObsolete===Z.excludeObsolete&&B.validate===Z.validate&&B.productVersion===Z.productVersion&&B.productDate===Z.productDate&&B.productCommit===Z.productCommit&&B.devMode===Z.devMode&&B.language===Z.language&&A.equals(B.translations,Z.translations)}}t.ExtensionScannerInput=X;let Y=class extends c.Disposable{constructor(B,Z,z,W,G,Q){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=Z,this.uriIdentityService=z,this.fileService=W,this.logService=Q,this.extensionsEnabledWithApiProposalVersion=G.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(B){const Z=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let z={};if(B.excludeObsolete&&B.type===e.ExtensionType.User)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(W)}catch{}return(0,y.isEmptyObject)(z)?Z:Z.filter(W=>!z[E.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(B){const Z=await this.fileService.resolve(B.location);if(!Z.children?.length)return[];const z=await Promise.all(Z.children.map(async W=>{if(!W.isDirectory||B.type===e.ExtensionType.User&&(0,S.basename)(W.resource).indexOf(".")===0)return null;const G=new X(W.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(G)}));return(0,P.coalesce)(z).sort((W,G)=>W.location.path<G.location.path?-1:1)}async scanExtensionsFromProfile(B){let Z=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){Z=Z.filter(W=>!W.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,B);Z.push(...z)}return Z}async scanExtensionsFromProfileResource(B,Z,z){const W=await this.extensionsProfileScannerService.scanProfileExtensions(B,z.profileScanOptions);if(!W.length)return[];const G=await Promise.all(W.map(async Q=>{if(Z(Q)){const te=new X(Q.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(te,Q.metadata)}return null}));return(0,P.coalesce)(G)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,S.joinPath)(B.location,"package.json"))){const Z=await this.scanExtension(B);return Z?[Z]:[]}else return await this.scanExtensions(B)}catch(Z){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,k.getErrorMessage)(Z)),[]}}async scanExtension(B,Z){try{let z=await this.scanExtensionManifest(B.location);if(z){z.publisher||(z.publisher=e.UNDEFINED_PUBLISHER),Z=Z??z.__metadata,delete z.__metadata;const W=(0,E.getGalleryExtensionId)(z.publisher,z.name),G=Z?.id?{id:W,uuid:Z.id}:{id:W},Q=Z?.isSystem?e.ExtensionType.System:B.type,te=Q===e.ExtensionType.System||!!Z?.isBuiltin;z=await this.translateManifest(B.location,z,X.createNlsConfiguration(B));let F={type:Q,identifier:G,manifest:z,location:B.location,isBuiltin:te,targetPlatform:Z?.targetPlatform??e.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return B.validate&&(F=this.validate(F,B)),z.enabledApiProposals&&this.extensionsEnabledWithApiProposalVersion.includes(W.toLowerCase())&&(z.enabledApiProposals=(0,e.parseEnabledApiProposalNames)([...z.enabledApiProposals])),F}}catch(z){B.type!==e.ExtensionType.System&&this.logService.error(z)}return null}validate(B,Z){let z=!0;const W=this.extensionsEnabledWithApiProposalVersion.includes(B.identifier.id.toLowerCase()),G=(0,a.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,B.manifest,B.isBuiltin,W);for(const[Q,te]of G)Q===T.default.Error&&(z=!1,this.logService.error(this.formatMessage(Z.location,te)));return B.isValid=z,B.validations=G,B}async scanExtensionManifest(B){const Z=(0,S.joinPath)(B,"package.json");let z;try{z=(await this.fileService.readFile(Z)).value.toString()}catch(G){return(0,i.toFileOperationResult)(G)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(B,(0,m.localize)(0,null,Z.path,G.message))),null}let W;try{W=JSON.parse(z)}catch{const Q=[];(0,C.parse)(z,Q);for(const te of Q)this.logService.error(this.formatMessage(B,(0,m.localize)(1,null,Z.path,te.offset,te.length,(0,p.getParseErrorMessage)(te.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(B,(0,m.localize)(2,null,Z.path))),null):W}async translateManifest(B,Z,z){const W=await this.getLocalizedMessages(B,Z,z);if(W)try{const G=[],Q=await this.resolveOriginalMessageBundle(W.default,G);if(G.length>0)return G.forEach(F=>{this.logService.error(this.formatMessage(B,(0,m.localize)(3,null,W.default?.path,(0,p.getParseErrorMessage)(F.error))))}),Z;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(B,(0,m.localize)(4,null,W.default?.path))),Z;const te=W.values||Object.create(null);return(0,L.localizeManifest)(this.logService,Z,te,Q)}catch{}return Z}async getLocalizedMessages(B,Z,z){const W=(0,S.joinPath)(B,"package.nls.json"),G=(V,K)=>{K.forEach(j=>{this.logService.error(this.formatMessage(B,(0,m.localize)(5,null,V?.path,(0,p.getParseErrorMessage)(j.error))))})},Q=V=>{this.logService.error(this.formatMessage(B,(0,m.localize)(6,null,V?.path)))},te=`${Z.publisher}.${Z.name}`,F=z.translations[te];if(F)try{const V=f.URI.file(F),K=(await this.fileService.readFile(V)).value.toString(),j=[],I=(0,C.parse)(K,j);return j.length>0?(G(V,j),{values:void 0,default:W}):(0,C.getNodeType)(I)!=="object"?(Q(V),{values:void 0,default:W}):{values:I.contents?I.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let K;try{K=await this.findMessageBundles(B,z)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const j=(await this.fileService.readFile(K.localized)).value.toString(),I=[],M=(0,C.parse)(j,I);return I.length>0?(G(K.localized,I),{values:void 0,default:K.original}):(0,C.getNodeType)(M)!=="object"?(Q(K.localized),{values:void 0,default:K.original}):{values:M,default:K.original}}catch{return{values:void 0,default:K.original}}}}async resolveOriginalMessageBundle(B,Z){if(B)try{const z=(await this.fileService.readFile(B)).value.toString();return(0,C.parse)(z,Z)}catch{}}findMessageBundles(B,Z){return new Promise((z,W)=>{const G=Q=>{const te=(0,S.joinPath)(B,`package.nls.${Q}.json`);this.fileService.exists(te).then(F=>{F&&z({localized:te,original:(0,S.joinPath)(B,"package.nls.json")});const V=Q.lastIndexOf("-");V===-1?z({localized:(0,S.joinPath)(B,"package.nls.json"),original:null}):(Q=Q.substring(0,V),G(Q))})};if(Z.devMode||Z.pseudo||!Z.language)return z({localized:(0,S.joinPath)(B,"package.nls.json"),original:null});G(Z.language)})}formatMessage(B,Z){return`[${B.path}]: ${Z}`}};Y=Ee([se(1,w.IExtensionsProfileScannerService),se(2,x.IUriIdentityService),se(3,i.IFileService),se(4,n.IProductService),se(5,r.ILogService)],Y);let ne=class extends Y{constructor(B,Z,z,W,G,Q,te,F){super(Z,W,G,Q,te,F),this.currentProfile=B,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new b.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const Z=this.getCacheFile(B),z=await this.readExtensionCache(Z);if(this.input=B,z&&z.input&&X.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",B.type===e.ExtensionType.System?"system":"user",B.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(G=>(G.location=f.URI.revive(G.location),G));const W=await super.scanExtensions(B);return await this.writeExtensionCache(Z,{input:B,result:W}),W}async readExtensionCache(B){try{const Z=await this.fileService.readFile(B),z=JSON.parse(Z.value.toString());return{result:z.result,input:(0,h.revive)(z.input)}}catch(Z){this.logService.debug("Error while reading the extension cache file:",B.path,(0,k.getErrorMessage)(Z))}return null}async writeExtensionCache(B,Z){try{await this.fileService.writeFile(B,D.VSBuffer.fromString(JSON.stringify(Z)))}catch(z){this.logService.debug("Error while writing the extension cache file:",B.path,(0,k.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const B=this.getCacheFile(this.input),Z=await this.readExtensionCache(B);if(!Z)return;const z=Z.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!v.equals(W,z))try{this.logService.info("Invalidating Cache",z,W),await this.fileService.del(B),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}getCacheFile(B){const Z=this.getProfile(B);return this.uriIdentityService.extUri.joinPath(Z.cacheHome,B.type===e.ExtensionType.System?e.BUILTIN_MANIFEST_CACHE_FILE:e.USER_MANIFEST_CACHE_FILE)}getProfile(B){return B.type===e.ExtensionType.System?this.userDataProfilesService.defaultProfile:B.profile?this.uriIdentityService.extUri.isEqual(B.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Z=>this.uriIdentityService.extUri.isEqual(B.location,Z.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ne=Ee([se(2,O.IUserDataProfilesService),se(3,w.IExtensionsProfileScannerService),se(4,x.IUriIdentityService),se(5,i.IFileService),se(6,n.IProductService),se(7,r.ILogService)],ne);function ce(he,B){const Z=(0,E.getExtensionId)(he.manifest.publisher,he.manifest.name);return{id:Z,identifier:new e.ExtensionIdentifier(Z),isBuiltin:he.type===e.ExtensionType.System,isUserBuiltin:he.type===e.ExtensionType.User&&he.isBuiltin,isUnderDevelopment:B,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,publisherDisplayName:he.publisherDisplayName,...he.manifest}}class ue extends _{constructor(B,Z,z,W,G,Q,te,F,V,K,j,I){super(B,Z,(0,S.joinPath)(z,".vscode-oss-dev","extensions","control.json"),W,G,Q,te,F,V,K,j,I),this.translationsPromise=(async()=>{if(u.translationsConfigFile)try{const M=await this.fileService.readFile(f.URI.file(u.translationsConfigFile));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}t.NativeExtensionsScannerService=ue}),define(oe[161],ae([0,1,60,8,38,5,2,15,16,26,6,25]),function(q,t,P,b,v,D,k,C,p,c,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let u=class extends k.Disposable{constructor(g,T){super(),this.userDataProfilesService=g,this.logService=T,this.processesLimiter=new b.Limiter(5)}async postUninstall(g){const T=this.parseScript(g,"uninstall");T&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(T.script,"uninstall",T.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(y){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(y)}}));try{await c.Promises.rm(this.getExtensionStoragePath(g))}catch(y){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(y)}}parseScript(g,T){const y=`vscode:${T}`;if(g.location.scheme===C.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[y]=="string"){const f=g.manifest.scripts[y].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${y} should be a node script`),null):{script:(0,p.join)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(g,T,y,f,m){return new Promise((R,E)=>{const e=this.start(g,T,y,m);let a;const i=s=>{a&&(clearTimeout(a),a=null),s?E(s):R(void 0)};e.on("error",s=>{i((0,v.toErrorMessage)(s)||"Unknown")}),e.on("exit",(s,r)=>{i(s?`post-${T} process exited with code ${s}`:void 0)}),f&&(a=setTimeout(()=>{a=null,e.kill(),E("timed out")},5e3))})}start(g,T,y,f){const m={silent:!0,execArgv:void 0},R=(0,P.fork)(g,[`--type=extension-post-${T}`,...y],m);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const E=D.Event.fromNodeEventEmitter(R.stdout,"data"),e=D.Event.fromNodeEventEmitter(R.stderr,"data");this._register(E(s=>this.logService.info(f.identifier.id,f.manifest.version,`post-${T}`,s))),this._register(e(s=>this.logService.error(f.identifier.id,f.manifest.version,`post-${T}`,s)));const a=D.Event.any(D.Event.map(E,s=>({data:`%c${s}`,format:[""]}),this._store),D.Event.map(e,s=>({data:`%c${s}`,format:["color: red"]}),this._store));return D.Event.debounce(a,(s,r)=>s?{data:s.data+r.data,format:[...s.format,...r.format]}:{data:r.data,format:r.format},100,void 0,void 0,void 0,this._store)(s=>{console.group(f.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),R}getExtensionStoragePath(g){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};t.ExtensionsLifecycle=u,t.ExtensionsLifecycle=u=Ee([se(0,d.IUserDataProfilesService),se(1,l.ILogService)],u)}),define(oe[72],ae([0,1,50,104,53,21]),function(q,t,P,b,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fromExtractError=k,t.getManifest=C;function k(p){let c=D.ExtensionManagementErrorCode.Extract;return p instanceof P.ExtractError&&(p.type==="CorruptZip"?c=D.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(c=D.ExtensionManagementErrorCode.IncompleteZip)),(0,v.toExtensionManagementError)(p,c)}async function C(p){let c;try{c=await(0,P.buffer)(p,"extension/package.json")}catch(l){throw k(l)}try{return JSON.parse(c.toString("utf8"))}catch{throw new D.ExtensionManagementError((0,b.localize)(0,null),D.ExtensionManagementErrorCode.Invalid)}}}),define(oe[162],ae([0,1,8,9,2,15,17,45,29,26,50,30,18,53,21,27,72,71,10,6,19]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0,C=we(C);let a=class extends v.Disposable{static{e=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(s,r,n,o,h,w,O){super(),this.fileService=r,this.extensionGalleryService=n,this.configurationService=o,this.extensionSignatureVerificationService=h,this.telemetryService=w,this.logService=O,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(s,r,n,o){await this.cleanUpPromise;const h=await this.downloadVSIX(s,r);let w=!1;if(n&&this.shouldVerifySignature(s)){let O;try{O=await this.downloadSignatureArchive(s)}catch(x){try{await this.delete(h)}catch(L){this.logService.error(L)}throw x}try{w=await this.extensionSignatureVerificationService.verify(s,h.fsPath,O.fsPath,o)}catch(x){if(w=x.code,w===f.ExtensionSignatureVerificationCode.PackageIsInvalidZip||w===f.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(h)}catch(L){this.logService.error(L)}throw new g.ExtensionManagementError(l.CorruptZipMessage,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(x){this.logService.error(x)}}}return{location:h,verificationStatus:w}}shouldVerifySignature(s){return s.isSigned||this.logService.info(`Extension is not signed: ${s.identifier.id}`),!1}async downloadVSIX(s,r){try{const n=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(s)),o=await this.doDownload(s,"vsix",async()=>{await this.downloadFile(s,n,h=>this.extensionGalleryService.download(s,h,r));try{await this.validate(n.fsPath,"extension/package.json")}catch(h){try{await this.fileService.del(n)}catch(w){this.logService.warn(`Error while deleting: ${n.path}`,(0,b.getErrorMessage)(w))}throw h}},2);return o>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:s.identifier.id,attempts:o}),n}catch(n){throw(0,S.toExtensionManagementError)(n,g.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(s){try{const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`),n=await this.doDownload(s,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(s,r);try{await this.validate(r.fsPath,".signature.p7s")}catch(o){try{await this.fileService.del(r)}catch(h){this.logService.warn(`Error while deleting: ${r.path}`,(0,b.getErrorMessage)(h))}throw o}},2);return n>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:s.identifier.id,attempts:n}),r}catch(r){throw(0,S.toExtensionManagementError)(r,g.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(s,r,n){if(await this.fileService.exists(r))return;if(r.scheme!==D.Schemas.file){await n(r);return}const o=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);try{await n(o)}catch(h){try{await this.fileService.del(o)}catch{}throw h}try{await c.Promises.rename(o.fsPath,r.fsPath,2*60*1e3)}catch(h){try{await this.fileService.del(o)}catch{}let w=!1;try{w=await this.fileService.exists(r)}catch{}if(w)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,r.path);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(h)}. Deleted the file from downloaded location`,o.path),h}}async doDownload(s,r,n,o){let h=1;for(;;)try{return await n(),h}catch(w){if(h++>o)throw w;this.logService.warn(`Failed downloading ${r}. ${(0,b.getErrorMessage)(w)}. Retry again...`,s.identifier.id)}}async validate(s,r){try{await(0,l.buffer)(s,r)}catch(n){throw(0,y.fromExtractError)(n)}}async delete(s){await this.cleanUpPromise,await this.fileService.del(s)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const r=[],n=[],o=[];for(const O of s.children)if(O.name.endsWith(e.SignatureArchiveExtension))o.push(O.resource);else{const x=T.ExtensionKey.parse(O.name);x&&n.push([x,O])}const h=(0,T.groupByExtension)(n,([O])=>O),w=[];for(const O of h)O.sort((x,L)=>C.rcompare(x[0].version,L[0].version)),r.push(...O.slice(1).map(x=>x[1].resource)),w.push(O[0][1]);w.sort((O,x)=>O.mtime-x.mtime),r.push(...w.slice(0,Math.max(0,w.length-this.cache)).map(O=>O.resource)),r.push(...o),await P.Promises.settled(r.map(O=>(this.logService.trace("Deleting from cache",O.path),this.fileService.del(O))))}}catch(s){this.logService.error(s)}}getName(s){return this.cache?T.ExtensionKey.create(s).toString().toLowerCase():(0,p.generateUuid)()}};t.ExtensionsDownloader=a,t.ExtensionsDownloader=a=e=Ee([se(0,u.INativeEnvironmentService),se(1,m.IFileService),se(2,g.IExtensionGalleryService),se(3,d.IConfigurationService),se(4,f.IExtensionSignatureVerificationService),se(5,E.ITelemetryService),se(6,R.ILogService)],a)}),define(oe[163],ae([0,1,8,14,22,38,9,5,43,2,31,15,16,17,45,3,12,29,26,50,103,61,18,53,21,27,42,54,162,161,72,143,150,23,44,10,11,6,33,19,24,25]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E,e,a,i,s,r,n,o,h,w,O,x,L,A,_,X,Y,ne,ce,ue,he,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,u=we(u),g=we(g),m=we(m),E=we(E),t.INativeServerExtensionManagementService=(0,Y.refineServiceDecorator)(s.IExtensionManagementService);const Z=".vsctmp";let z=class extends i.AbstractExtensionManagementService{constructor(F,V,K,j,I,M,U,N,H,J,re,le){super(F,V,re,K,J,le),this.extensionsScannerService=I,this.extensionsProfileScannerService=M,this.downloadService=U,this.instantiationService=N,this.fileService=H,this.extractingGalleryExtensions=new Map,this.knownDirectories=new l.ResourceSet;const ge=this._register(N.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(W,me=>ge.postUninstall(me))),this.manifestCache=this._register(new x.ExtensionsManifestCache(le,H,re,this,this.logService)),this.extensionsDownloader=this._register(N.createInstance(h.ExtensionsDownloader));const pe=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,le,M,re,H,K));this._register(pe.onDidChangeExtensionsByAnotherSource(me=>this.onDidChangeExtensionsFromAnotherSource(me))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,r.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const V=await this.collectFiles(F),K=await(0,R.zip)((0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,V);return y.URI.file(K)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:V,cleanup:K}=await this.downloadVsix(F),j=u.resolve(V.fsPath);try{return await(0,O.getManifest)(j)}finally{await K()}}getInstalled(F,V=this.userDataProfilesService.defaultProfile.extensionsResource,K={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(F??null,V,K)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.extensionsScanner.scanUserExtensionAtLocation(F)}async install(F,V={}){this.logService.trace("ExtensionManagementService#install",F.toString());const{location:K,cleanup:j}=await this.downloadVsix(F);try{const I=await(0,O.getManifest)(u.resolve(K.fsPath)),M=(0,r.getGalleryExtensionId)(I.publisher,I.name);if(I.engines&&I.engines.vscode&&!(0,_.isEngineValid)(I.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,M,this.productService.version));const N=(await this.installExtensions([{manifest:I,extension:K,options:V}])).find(({identifier:H})=>(0,r.areSameExtensions)(H,{id:M}));if(N?.local)return N.local;throw N?.error?N.error:(0,i.toExtensionManagementError)(new Error(`Unknown error while installing extension ${M}`))}finally{await j()}}async installFromLocation(F,V){this.logService.trace("ExtensionManagementService#installFromLocation",F.toString());const K=await this.extensionsScanner.scanUserExtensionAtLocation(F);if(!K||!K.manifest.name||!K.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.addExtensionsToProfile([[K,{source:"resource"}]],V),this.logService.info("Successfully installed extension",K.identifier.id,V.toString()),K}async installExtensionsFromProfile(F,V,K){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",F,V.toString(),K.toString());const j=(await this.getInstalled(A.ExtensionType.User,V)).filter(I=>F.some(M=>(0,r.areSameExtensions)(M,I.identifier)));if(j.length){const I=await Promise.all(j.map(M=>this.extensionsScanner.scanMetadata(M,V)));await this.addExtensionsToProfile(j.map((M,U)=>[M,I[U]]),K),this.logService.info("Successfully installed extensions",j.map(M=>M.identifier.id),K.toString())}return j}async updateMetadata(F,V,K){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),F=await this.extensionsScanner.updateMetadata(F,V,K),this.manifestCache.invalidate(K),this._onDidUpdateExtensionMetadata.fire({local:F,profileLocation:K}),F}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const V=await this.getTargetPlatform(),[K]=await this.galleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:V,compatible:!0},v.CancellationToken.None);if(!K)throw new Error(E.localize(2,null));await this.extensionsScanner.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(j){throw new Error(E.localize(3,null,(0,D.toErrorMessage)(j)))}return this.installFromGallery(K)}copyExtension(F,V,K,j){return this.extensionsScanner.copyExtension(F,V,K,j)}copyExtensions(F,V){return this.extensionsScanner.copyExtensions(F,V,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...F){return this.extensionsScanner.setUninstalled(...F)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(F){this.logService.error(F)}}async download(F,V,K){const{location:j}=await this.extensionsDownloader.download(F,V,!K);return j}async downloadVsix(F){if(F.scheme===d.Schemas.file)return{location:F,async cleanup(){}};this.logService.trace("Downloading extension from",F.toString());const V=(0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(F,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(j){this.logService.error(j)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(F,V,K){const j=V instanceof y.URI?new r.ExtensionKey({id:(0,r.getGalleryExtensionId)(F.publisher,F.name)},F.version):r.ExtensionKey.create(V);return this.instantiationService.createInstance(G,j,F,V,K,(I,M)=>{if(V instanceof y.URI)return this.extractVSIX(j,V,K,M);let U=this.extractingGalleryExtensions.get(j.toString());return U||(this.extractingGalleryExtensions.set(j.toString(),U=this.downloadAndExtractGalleryExtension(j,V,I,K,M)),U.finally(()=>this.extractingGalleryExtensions.delete(j.toString()))),U},this.extensionsScanner)}createUninstallExtensionTask(F,V){return new Q(F,V.profileLocation,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(F,V,K,j,I){const{verificationStatus:M,location:U}=await this.extensionsDownloader.download(V,K,!j.donotVerifySignature,j.context?.[s.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(I.isCancellationRequested)throw new k.CancellationError;return await(0,O.getManifest)(U.fsPath),{local:await this.extensionsScanner.extractUserExtension(F,U.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:j.isApplicationScoped,isMachineScoped:j.isMachineScoped,isBuiltin:j.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:j.installGivenVersion?!0:!!j.pinned,preRelease:(0,T.isBoolean)(j.preRelease)?j.preRelease:j.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,I),verificationStatus:M}}catch(N){try{await this.extensionsDownloader.delete(U)}catch(H){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,k.getErrorMessage)(H))}throw(0,i.toExtensionManagementError)(N)}}async extractVSIX(F,V,K,j){return{local:await this.extensionsScanner.extractUserExtension(F,u.resolve(V.fsPath),{isApplicationScoped:K.isApplicationScoped,isMachineScoped:K.isMachineScoped,isBuiltin:K.isBuiltin,installedTimestamp:Date.now(),pinned:K.installGivenVersion?!0:!!K.pinned,source:"vsix"},!0,j)}}async collectFiles(F){const V=async j=>{let I=await m.Promises.readdir(j);I=I.map(N=>u.join(j,N));const M=await Promise.all(I.map(N=>m.Promises.stat(N)));let U=Promise.resolve([]);return M.forEach((N,H)=>{const J=I[H];N.isFile()&&(U=U.then(re=>[...re,J])),N.isDirectory()&&(U=U.then(re=>V(J).then(le=>[...re,...le])))}),U};return(await V(F.location.fsPath)).map(j=>({path:`extension/${u.relative(F.location.fsPath,j)}`,localPath:j}))}async onDidChangeExtensionsFromAnotherSource({added:F,removed:V}){if(V){const K=F&&this.uriIdentityService.extUri.isEqual(V.profileLocation,F.profileLocation)?V.extensions.filter(j=>F.extensions.every(I=>!(0,r.areSameExtensions)(I,j))):V.extensions;for(const j of K)this.logService.info("Extensions removed from another source",j.id,V.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:j,profileLocation:V.profileLocation})}if(F){const j=(await this.getInstalled(A.ExtensionType.User,F.profileLocation)).filter(I=>F.extensions.some(M=>(0,r.areSameExtensions)(M,I.identifier)));this._onDidInstallExtensions.fire(j.map(I=>(this.logService.info("Extensions added from another source",I.identifier.id,F.profileLocation.toString()),{identifier:I.identifier,local:I,profileLocation:F.profileLocation,operation:s.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(V=>this.knownDirectories.add(V)));const F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const V of F.children??[])V.isDirectory&&this.knownDirectories.add(V.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(V=>this.onDidFilesChange(V)))}async onDidFilesChange(F){if(!F.affects(this.extensionsScannerService.userExtensionsLocation,X.FileChangeType.ADDED))return;const V=[];for(const K of F.rawAdded){if(this.knownDirectories.has(K)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(K),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(K,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(K).startsWith(".")||!(await this.fileService.stat(K)).isDirectory)continue;const j=await this.extensionsScanner.scanUserExtensionAtLocation(K);j&&j.installedTimestamp===void 0&&(this.knownDirectories.add(K),V.push(j))}V.length&&(await this.addExtensionsToProfile(V.map(K=>[K,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",V.map(K=>K.identifier.id)))}async addExtensionsToProfile(F,V){const K=F.map(j=>j[0]);await this.setInstalled(K),await this.extensionsProfileScannerService.addExtensionsToProfile(F,V),this._onDidInstallExtensions.fire(K.map(j=>({local:j,identifier:j.identifier,operation:s.InstallOperation.None,profileLocation:V})))}async setInstalled(F){const V=await this.extensionsScanner.getUninstalledExtensions();for(const K of F){const j=r.ExtensionKey.create(K);V[j.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",j.id),await this.extensionsScanner.setInstalled(j),this.logService.info("Removed the extension from uninstalled list:",j.id))}}};t.ExtensionManagementService=z,t.ExtensionManagementService=z=Ee([se(0,s.IExtensionGalleryService),se(1,ue.ITelemetryService),se(2,ne.ILogService),se(3,a.INativeEnvironmentService),se(4,o.IExtensionsScannerService),se(5,n.IExtensionsProfileScannerService),se(6,e.IDownloadService),se(7,Y.IInstantiationService),se(8,X.IFileService),se(9,ce.IProductService),se(10,he.IUriIdentityService),se(11,B.IUserDataProfilesService)],z);let W=class extends c.Disposable{constructor(F,V,K,j,I,M,U){super(),this.beforeRemovingExtension=F,this.fileService=V,this.extensionsScannerService=K,this.extensionsProfileScannerService=j,this.uriIdentityService=I,this.telemetryService=M,this.logService=U,this._onExtract=this._register(new C.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new l.ResourceMap,this.scanUserExtensionsPromise=new l.ResourceMap,this.uninstalledResource=(0,S.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(F,V,K){try{const j={includeInvalid:!0,profileLocation:V,productVersion:K};let I=[];if(F===null||F===A.ExtensionType.System){let M=this.scanAllExtensionPromise.get(V);M||(M=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},j,!1).finally(()=>this.scanAllExtensionPromise.delete(V)),this.scanAllExtensionPromise.set(V,M)),I.push(...await M)}else if(F===A.ExtensionType.User){let M=this.scanUserExtensionsPromise.get(V);M||(M=this.extensionsScannerService.scanUserExtensions(j).finally(()=>this.scanUserExtensionsPromise.delete(V)),this.scanUserExtensionsPromise.set(V,M)),I.push(...await M)}return I=F!==null?I.filter(M=>M.type===F):I,await Promise.all(I.map(M=>this.toLocalExtension(M)))}catch(j){throw(0,i.toExtensionManagementError)(j,s.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(V.map(K=>this.toLocalExtension(K)))}catch(V){throw(0,i.toExtensionManagementError)(V,s.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const V=await this.extensionsScannerService.scanExistingExtension(F,A.ExtensionType.User,{includeInvalid:!0});if(V)return await this.toLocalExtension(V)}catch(V){this.logService.error(V)}return null}async extractUserExtension(F,V,K,j,I){const M=F.toString(),U=y.URI.file(u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`)),N=y.URI.file(u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M));let H=await this.fileService.exists(N);if(H&&j){try{await this.deleteExtensionFromLocation(F.id,N,"removeExisting")}catch{throw new s.ExtensionManagementError(E.localize(4,null,N.fsPath,F.id),s.ExtensionManagementErrorCode.Delete)}H=!1}if(H)try{await this.extensionsScannerService.updateMetadata(N,K)}catch(J){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,X.toFileOperationResult)(J)}`}),(0,i.toExtensionManagementError)(J,s.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(I.isCancellationRequested)throw new k.CancellationError;try{this.logService.trace(`Started extracting the extension from ${V} to ${N.fsPath}`),await(0,R.extract)(V,U.fsPath,{sourcePath:"extension",overwrite:!0},I),this.logService.info(`Extracted extension to ${N}:`,F.id)}catch(J){throw(0,O.fromExtractError)(J)}try{await this.extensionsScannerService.updateMetadata(U,K)}catch(J){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,X.toFileOperationResult)(J)}`}),(0,i.toExtensionManagementError)(J,s.ExtensionManagementErrorCode.UpdateMetadata)}if(I.isCancellationRequested)throw new k.CancellationError;try{this.logService.trace(`Started renaming the extension from ${U.fsPath} to ${N.fsPath}`),await this.rename(U.fsPath,N.fsPath),this.logService.info("Renamed to",N.fsPath)}catch(J){if(J.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.fileService.del(U,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(J)}. Deleted from extracted location`,U),J}this._onExtract.fire(N)}catch(J){try{await this.fileService.del(U,{recursive:!0})}catch{}throw J}return this.scanLocalExtension(N,A.ExtensionType.User)}async scanMetadata(F,V){return V?(await this.getScannedExtension(F,V))?.metadata:this.extensionsScannerService.scanMetadata(F.location)}async getScannedExtension(F,V){return(await this.extensionsProfileScannerService.scanProfileExtensions(V)).find(j=>(0,r.areSameExtensions)(j.identifier,F.identifier))}async updateMetadata(F,V,K){try{K?await this.extensionsProfileScannerService.updateMetadata([[F,V]],K):await this.extensionsScannerService.updateMetadata(F.location,V)}catch(j){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.identifier.id,code:`${(0,X.toFileOperationResult)(j)}`}),(0,i.toExtensionManagementError)(j,s.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,K)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(F){throw(0,i.toExtensionManagementError)(F,s.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const V=F.map(K=>r.ExtensionKey.create(K));await this.withUninstalledExtensions(K=>V.forEach(j=>{K[j.toString()]=!0,this.logService.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(F){try{await this.withUninstalledExtensions(V=>delete V[F.toString()])}catch(V){throw(0,i.toExtensionManagementError)(V,s.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,V){if(this.uriIdentityService.extUri.isEqualOrParent(F.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(F.identifier.id,F.location,V)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[r.ExtensionKey.create(F).toString()])}async copyExtension(F,V,K,j){const I=await this.getScannedExtension(F,V),M=await this.getScannedExtension(F,K);if(j={...I?.metadata,...j},M)if(this.uriIdentityService.extUri.isEqual(M.location,F.location))await this.extensionsProfileScannerService.updateMetadata([[F,{...M.metadata,...j}]],K);else{const U=await this.scanLocalExtension(M.location,F.type,K);await this.extensionsProfileScannerService.removeExtensionFromProfile(U,K),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,{...M.metadata,...j}]],K)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[F,j]],K);return this.scanLocalExtension(F.location,F.type,K)}async copyExtensions(F,V,K){const j=await this.scanExtensions(A.ExtensionType.User,F,K),I=await Promise.all(j.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.extensionsProfileScannerService.addExtensionsToProfile(I,V)}async deleteExtensionFromLocation(F,V,K){this.logService.trace(`Deleting ${K} extension from disk`,F,V.fsPath);const j=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(V),`${this.uriIdentityService.extUri.basename(V)}.${(0,p.hash)((0,f.generateUuid)()).toString(16)}${Z}`);await this.rename(V.fsPath,j.fsPath),await this.fileService.del(j,{recursive:!0}),this.logService.info(`Deleted ${K} extension from disk`,F,V.fsPath)}withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(j){if((0,X.toFileOperationResult)(j)!==X.FileOperationResult.FILE_NOT_FOUND)throw j}let K={};if(V)try{K=JSON.parse(V)}catch{}return F&&(F(K),Object.keys(K).length?await this.fileService.writeFile(this.uninstalledResource,b.VSBuffer.fromString(JSON.stringify(K))):await this.fileService.del(this.uninstalledResource)),K})}async rename(F,V){try{await m.Promises.rename(F,V,2*60*1e3)}catch(K){throw(0,i.toExtensionManagementError)(K,s.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,V,K){try{if(K){const I=(await this.extensionsScannerService.scanUserExtensions({profileLocation:K})).find(M=>this.uriIdentityService.extUri.isEqual(M.location,F));if(I)return await this.toLocalExtension(I)}else{const j=await this.extensionsScannerService.scanExistingExtension(F,V,{includeInvalid:!0});if(j)return await this.toLocalExtension(j)}throw new s.ExtensionManagementError(E.localize(5,null,F.path),s.ExtensionManagementErrorCode.ScanningExtension)}catch(j){throw(0,i.toExtensionManagementError)(j,s.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(F){const V=await this.fileService.resolve(F.location);let K,j;return V.children&&(K=V.children.find(({name:I})=>/^readme(\.txt|\.md|)$/i.test(I))?.resource,j=V.children.find(({name:I})=>/^changelog(\.txt|\.md|)$/i.test(I))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:K,changelogUrl:j,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(F));const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),K=new Set;for(const I of V)F[r.ExtensionKey.create(I).toString()]||K.add(I.identifier.id.toLowerCase());try{const I=(0,r.groupByExtension)(V,M=>M.identifier);await P.Promises.settled(I.map(async M=>{const U=M.sort((N,H)=>g.rcompare(N.manifest.version,H.manifest.version))[0];K.has(U.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(U))}))}catch(I){this.logService.error(I)}const j=V.filter(I=>I.metadata&&F[r.ExtensionKey.create(I).toString()]);await Promise.allSettled(j.map(I=>this.removeUninstalledExtension(I)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(V){(0,X.toFileOperationResult)(V)!==X.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(V);return}if(F?.children)try{await Promise.allSettled(F.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(Z))){this.logService.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.fileService.del(V.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(K){(0,X.toFileOperationResult)(K)!==X.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(K)}}}))}catch{}}};t.ExtensionsScanner=W,t.ExtensionsScanner=W=Ee([se(1,X.IFileService),se(2,o.IExtensionsScannerService),se(3,n.IExtensionsProfileScannerService),se(4,he.IUriIdentityService),se(5,ue.ITelemetryService),se(6,ne.ILogService)],W);let G=class extends i.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(F,V,K,j,I,M,U,N,H,J,re,le){super(),this.extensionKey=F,this.manifest=V,this.source=K,this.options=j,this.extractExtensionFn=I,this.extensionsScanner=M,this.uriIdentityService=U,this.galleryService=N,this.userDataProfilesService=H,this.extensionsScannerService=J,this.extensionsProfileScannerService=re,this.logService=le,this._operation=s.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(F){const K=(await this.extensionsScanner.scanExtensions(A.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(U=>(0,r.areSameExtensions)(U.identifier,this.identifier));K&&(this._operation=s.InstallOperation.Update);const j={isApplicationScoped:this.options.isApplicationScoped||K?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||K?.isMachineScoped,isBuiltin:this.options.isBuiltin||K?.isBuiltin,isSystem:K?.type===A.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??K?.pinned,source:this.source instanceof y.URI?"vsix":"gallery"};let I;if(this.source instanceof y.URI){if(K&&this.extensionKey.equals(new r.ExtensionKey(K.identifier,K.manifest.version)))try{await this.extensionsScanner.removeExtension(K,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}const U=await this.unsetIfUninstalled(this.extensionKey);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(j.id=this.source.identifier.uuid,j.publisherId=this.source.publisherId,j.publisherDisplayName=this.source.publisherDisplayName,j.targetPlatform=this.source.properties.targetPlatform,j.updated=!!K,j.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,j.hasPreReleaseVersion=K?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,j.preRelease=(0,T.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||K?.preRelease,K&&K.type!==A.ExtensionType.System&&K.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(K,j,this.options.profileLocation);I=await this.unsetIfUninstalled(this.extensionKey)}if(F.isCancellationRequested)throw(0,i.toExtensionManagementError)(new k.CancellationError);if(!I){const U=await this.extractExtensionFn(this.operation,F);I=U.local,this._verificationStatus=U.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(U){throw(0,i.toExtensionManagementError)(U,s.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,i.toExtensionManagementError)(new k.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[I,j]],this.options.profileLocation,!I.isValid)}catch(U){throw(0,i.toExtensionManagementError)(U,s.ExtensionManagementErrorCode.AddToProfile)}const M=await this.extensionsScanner.scanLocalExtension(I.location,A.ExtensionType.User,this.options.profileLocation);if(!M)throw new s.ExtensionManagementError("Cannot find the installed extension",s.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof y.URI&&this.updateMetadata(I,F),M}async unsetIfUninstalled(F){return(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(j=>r.ExtensionKey.create(j).equals(F))):void 0}async updateMetadata(F,V){try{let[K]=await this.galleryService.getExtensions([{id:F.identifier.id,version:F.manifest.version}],V);if(K||([K]=await this.galleryService.getExtensions([{id:F.identifier.id}],V)),K){const j={id:K.identifier.uuid,publisherDisplayName:K.publisherDisplayName,publisherId:K.publisherId,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||K.properties.isPreReleaseVersion,preRelease:K.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(F,j,this.options.profileLocation)}}catch{}}};G=Ee([se(6,he.IUriIdentityService),se(7,s.IExtensionGalleryService),se(8,B.IUserDataProfilesService),se(9,o.IExtensionsScannerService),se(10,n.IExtensionsProfileScannerService),se(11,ne.ILogService)],G);class Q extends i.AbstractExtensionTask{constructor(F,V,K){super(),this.extension=F,this.profileLocation=V,this.extensionsProfileScannerService=K}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[164],ae([0,1,6,25,24,19,42,10,18,12]),function(q,t,P,b,v,D,k,C,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=void 0;let l=class extends k.AbstractExtensionsProfileScannerService{constructor(u,S,g,T,y,f){super(c.URI.file(u.extensionsPath),S,g,T,y,f)}};t.ExtensionsProfileScannerService=l,t.ExtensionsProfileScannerService=l=Ee([se(0,p.INativeEnvironmentService),se(1,C.IFileService),se(2,b.IUserDataProfilesService),se(3,v.IUriIdentityService),se(4,D.ITelemetryService),se(5,P.ILogService)],l)}),define(oe[165],ae([0,1,12,18,42,54,10,11,6,33,24,25]),function(q,t,P,b,v,D,k,C,p,c,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let u=class extends D.NativeExtensionsScannerService{constructor(g,T,y,f,m,R,E,e){super(P.URI.file(m.builtinExtensionsPath),P.URI.file(m.extensionsPath),m.userHome,g.defaultProfile,g,T,y,f,m,R,E,e)}};t.ExtensionsScannerService=u,t.ExtensionsScannerService=u=Ee([se(0,d.IUserDataProfilesService),se(1,v.IExtensionsProfileScannerService),se(2,k.IFileService),se(3,p.ILogService),se(4,b.INativeEnvironmentService),se(5,c.IProductService),se(6,l.IUriIdentityService),se(7,C.IInstantiationService)],u)}),define(oe[73],ae([0,1,8,5,2,133,3,92,11,25]),function(q,t,P,b,v,D,k,C,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.TARGET_KEY=t.IS_NEW_KEY=void 0,t.loadKeyTargets=S,t.isProfileUsingDefaultStorage=T,t.logStorage=f,t.IS_NEW_KEY="__$__isNewStorageMarker",t.TARGET_KEY="__$__targetStorageMarker",t.IStorageService=(0,p.createDecorator)("storageService");var l;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(l||(t.WillSaveStateReason=l={}));var d;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(d||(t.StorageScope=d={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(t.StorageTarget=u={}));function S(m){const R=m.get(t.TARGET_KEY);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class g extends v.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(R={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=R,this._onDidChangeValue=this._register(new b.PauseableEmitter),this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new v.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(R,E,e){return b.Event.filter(this._onDidChangeValue.event,a=>a.scope===R&&(E===void 0||a.key===E),e)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,v.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(R,E){const{key:e,external:a}=E;if(e===t.TARGET_KEY){switch(R){case d.APPLICATION:this._applicationKeyTargets=void 0;break;case d.PROFILE:this._profileKeyTargets=void 0;break;case d.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:R})}else this._onDidChangeValue.fire({scope:R,key:e,target:this.getKeyTargets(R)[e],external:a})}emitWillSaveState(R){this._onWillSaveState.fire({reason:R})}get(R,E,e){return this.getStorage(E)?.get(R,e)}getBoolean(R,E,e){return this.getStorage(E)?.getBoolean(R,e)}getNumber(R,E,e){return this.getStorage(E)?.getNumber(R,e)}getObject(R,E,e){return this.getStorage(E)?.getObject(R,e)}storeAll(R,E){this.withPausedEmitters(()=>{for(const e of R)this.store(e.key,e.value,e.scope,e.target,E)})}store(R,E,e,a,i=!1){if((0,k.isUndefinedOrNull)(E)){this.remove(R,e,i);return}this.withPausedEmitters(()=>{this.updateKeyTarget(R,e,a),this.getStorage(e)?.set(R,E,i)})}remove(R,E,e=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(R,E,void 0),this.getStorage(E)?.delete(R,e)})}withPausedEmitters(R){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{R()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(R,E){const e=[],a=this.getKeyTargets(R);for(const i of Object.keys(a))a[i]===E&&e.push(i);return e}updateKeyTarget(R,E,e,a=!1){const i=this.getKeyTargets(E);typeof e=="number"?i[R]!==e&&(i[R]=e,this.getStorage(E)?.set(t.TARGET_KEY,JSON.stringify(i),a)):typeof i[R]=="number"&&(delete i[R],this.getStorage(E)?.set(t.TARGET_KEY,JSON.stringify(i),a))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(d.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(d.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(d.APPLICATION)),this._applicationKeyTargets}getKeyTargets(R){switch(R){case d.APPLICATION:return this.applicationKeyTargets;case d.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(R){const E=this.getStorage(R);return E?S(E):Object.create(null)}isNew(R){return this.getBoolean(t.IS_NEW_KEY,R)===!0}async flush(R=l.NONE){this._onWillSaveState.fire({reason:R});const E=this.getStorage(d.APPLICATION),e=this.getStorage(d.PROFILE),a=this.getStorage(d.WORKSPACE);switch(R){case l.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case l.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.getStorage(d.APPLICATION)?.items??new Map,E=this.getStorage(d.PROFILE)?.items??new Map,e=this.getStorage(d.WORKSPACE)?.items??new Map;return f(R,E,e,this.getLogDetails(d.APPLICATION)??"",this.getLogDetails(d.PROFILE)??"",this.getLogDetails(d.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.getStorage(R)?.optimize()}async switch(R,E){return this.emitWillSaveState(l.NONE),(0,c.isUserDataProfile)(R)?this.switchToProfile(R,E):this.switchToWorkspace(R,E)}canSwitchProfile(R,E){return!(R.id===E.id||T(E)&&T(R))}switchData(R,E,e){this.withPausedEmitters(()=>{const a=new Set;for(const[i,s]of R)a.add(i),E.get(i)!==s&&this.emitDidChangeValue(e,{key:i,external:!0});for(const[i]of E.items)a.has(i)||this.emitDidChangeValue(e,{key:i,external:!0})})}}t.AbstractStorageService=g;function T(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class y extends g{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(R=>this.emitDidChangeValue(d.WORKSPACE,R))),this._register(this.profileStorage.onDidChangeStorage(R=>this.emitDidChangeValue(d.PROFILE,R))),this._register(this.applicationStorage.onDidChangeStorage(R=>this.emitDidChangeValue(d.APPLICATION,R)))}getStorage(R){switch(R){case d.APPLICATION:return this.applicationStorage;case d.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(R){switch(R){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(R){return!1}}t.InMemoryStorageService=y;async function f(m,R,E,e,a,i){const s=A=>{try{return JSON.parse(A)}catch{return A}},r=new Map,n=new Map;m.forEach((A,_)=>{r.set(_,A),n.set(_,s(A))});const o=new Map,h=new Map;R.forEach((A,_)=>{o.set(_,A),h.set(_,s(A))});const w=new Map,O=new Map;E.forEach((A,_)=>{w.set(_,A),O.set(_,s(A))}),console.group(e!==a?`Storage: Application (path: ${e})`:`Storage: Application & Profile (path: ${e}, default profile)`);const x=[];if(r.forEach((A,_)=>{x.push({key:_,value:A})}),console.table(x),console.groupEnd(),console.log(n),e!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const A=[];o.forEach((_,X)=>{A.push({key:X,value:_})}),console.table(A),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${i})`);const L=[];w.forEach((A,_)=>{L.push({key:_,value:A})}),console.table(L),console.groupEnd(),console.log(O)}}),define(oe[166],ae([0,1,14,29,73]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=D;async function D(k,C,p){let c=p&&p.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(c)return c;try{const d=(await C.readFile(k.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(d)?d:null}catch{c=null}if(!c){c=(0,b.generateUuid)();try{await C.writeFile(k.serviceMachineIdResource,P.VSBuffer.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),c}}),define(oe[167],ae([0,1,166,19,41]),function(q,t,P,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=D;async function D(k,C,p,c,l,d,u){const S={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${C.nameShort})`};if((0,v.supportsTelemetry)(C,p)&&(0,v.getTelemetryLevel)(c)===b.TelemetryLevel.USAGE){const g=await(0,P.getServiceMachineId)(p,l,d);S["X-Market-User-Id"]=g,S["VSCode-SessionId"]=u.machineId||g}return S}}),define(oe[168],ae([0,1,20,22,9,13,36,3,12,30,18,21,27,23,44,10,6,33,46,167,73,19,180]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E,e,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0,t.sortExtensionVersions=F;const i=D.isWeb?S.TargetPlatform.WEB:(0,d.getTargetPlatform)(D.platform,k.arch),s="X-Market-Search-Activity-Id";var r;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...U){return String(U.reduce((N,H)=>N|H,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},w={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},x={pageNumber:1,pageSize:10,sortBy:d.SortBy.NoneOrRelevance,sortOrder:d.SortOrder.Default,flags:r.None,criteria:[],assetTypes:[]};class L{constructor(N=x){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(N,H=this.state.pageSize){return new L({...this.state,pageNumber:N,pageSize:H})}withFilter(N,...H){const J=[...this.state.criteria,...H.length?H.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new L({...this.state,criteria:J})}withSortBy(N){return new L({...this.state,sortBy:N})}withSortOrder(N){return new L({...this.state,sortOrder:N})}withFlags(...N){return new L({...this.state,flags:N.reduce((H,J)=>H|J,0)})}withAssetTypes(...N){return new L({...this.state,assetTypes:N})}withSource(N){return new L({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:H,pageSize:J,sortBy:re,sortOrder:le,flags:ge,assetTypes:pe}=this.state;return{filters:[{criteria:N,pageNumber:H,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:pe,flags:ge}}get searchText(){const N=this.state.criteria.filter(H=>H.filterType===o.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(U,N){const H=(U||[]).filter(J=>J.statisticName===N)[0];return H?H.value:0}function _(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=ne(U,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function X(U){if(U.properties){const N=U.properties.filter(re=>re.key===h.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>H.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return ne(U,h.Repository)}function Y(U){return{uri:`${U.fallbackAssetUri}/${h.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${h.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ne(U,N){return U.files.filter(J=>J.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ce(U,N){const H=U.properties?U.properties.filter(re=>re.key===N):[],J=H.length>0&&H[0].value;return J?J.split(",").map(re=>(0,u.adoptToGalleryExtensionId)(re)):[]}function ue(U){const N=U.properties?U.properties.filter(H=>H.key===w.Engine):[];return N.length>0&&N[0].value||""}function he(U){const N=U.properties?U.properties.filter(H=>H.key===w.PreRelease):[];return N.length>0&&N[0].value==="true"}function B(U){const N=U.properties?U.properties.filter(J=>J.key===w.EnabledApiProposals):[],H=N.length>0&&N[0].value||"";return H?H.split(","):[]}function Z(U){const N=U.properties?U.properties.filter(J=>J.key===w.LocalizedLanguages):[],H=N.length>0&&N[0].value||"";return H?H.split(","):[]}function z(U){return U.properties?.find(N=>N.key===w.SponsorLink)?.value}function W(U){return U.properties?.find(N=>N.key===w.SupportLink)?.value}function G(U){return U.indexOf("preview")!==-1}function Q(U){return U.targetPlatform?(0,d.toTargetPlatform)(U.targetPlatform):S.TargetPlatform.UNDEFINED}function te(U){const N=(0,P.distinct)(U.versions.map(Q)),H=!!U.tags?.includes(d.WEB_EXTENSION_TAG),J=N.indexOf(S.TargetPlatform.WEB);return H?J===-1&&N.push(S.TargetPlatform.WEB):J!==-1&&N.splice(J,1),N}function F(U,N){for(let H=0;H<U.length;H++){const J=U[H];if(J.version===U[H-1]?.version){let re=H;if(Q(J)===N)for(;re>0&&U[re-1].version===J.version;)re--;re!==H&&(U.splice(H,1),U.splice(re,0,J))}}return U}function V(U,N,H){U.telemetryData={index:N,querySource:H,queryActivityId:U.queryContext?.[s]}}function K(U,N,H,J){const re=U.versions[0],le={manifest:ne(N,h.Manifest),readme:ne(N,h.Details),changelog:ne(N,h.Changelog),license:ne(N,h.License),repository:X(N),download:Y(N),icon:ne(N,h.Icon),signature:ne(N,h.Signature),coreTranslations:_(N)};return{type:"gallery",identifier:{id:(0,u.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(re),description:U.shortDescription??"",installCount:A(U.statistics,"install"),rating:A(U.statistics,"averagerating"),ratingCount:A(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:H,assets:le,properties:{dependencies:ce(N,w.Dependency),extensionPack:ce(N,w.ExtensionPack),engine:ue(N),enabledApiProposals:B(N),localizedLanguages:Z(N),targetPlatform:Q(N),isPreReleaseVersion:he(N)},hasPreReleaseVersion:he(re),hasReleaseVersion:!0,preview:G(U.flags),isSigned:!!le.signature,queryContext:J,supportLink:W(re)}}let j=class{constructor(N,H,J,re,le,ge,pe,me){this.requestService=H,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=ge,this.productService=pe,this.configurationService=me;const Se=pe.extensionsGallery,de=Se?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=de?Se.servicePPEUrl:Se?.serviceUrl,this.extensionsGallerySearchUrl=de?void 0:Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.extensionsEnabledWithApiProposalVersion=pe.extensionsEnabledWithApiProposalVersion?.map(fe=>fe.toLowerCase())??[],this.commonHeadersPromise=(0,R.resolveMarketplaceHeaders)(pe.version,pe,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,H,J){const re=b.CancellationToken.isCancellationToken(H)?{}:H,le=b.CancellationToken.isCancellationToken(H)?H:J,ge=[],pe=[],me=[],Se=[];let de=!0;for(const Ie of N){Ie.uuid?pe.push(Ie.uuid):ge.push(Ie.id);const $=!!(Ie.version||Ie.preRelease);me.push({id:Ie.id,uuid:Ie.uuid,includePreRelease:$}),Ie.version&&Se.push({id:Ie.id,uuid:Ie.uuid,version:Ie.version}),de=de&&!!Ie.hasPreRelease&&!$}if(!pe.length&&!ge.length)return[];let fe=new L().withPage(1,N.length);pe.length&&(fe=fe.withFilter(o.ExtensionId,...pe)),ge.length&&(fe=fe.withFilter(o.ExtensionName,...ge)),(re.queryAllVersions||de)&&(fe=fe.withFlags(fe.flags,r.IncludeVersions)),re.source&&(fe=fe.withSource(re.source));const{extensions:ye}=await this.queryGalleryExtensions(fe,{targetPlatform:re.targetPlatform??i,includePreRelease:me,versions:Se,compatible:!!re.compatible,productVersion:re.productVersion??{version:this.productService.version,date:this.productService.date}},le);return re.source&&ye.forEach((Ie,$)=>V(Ie,$,re.source)),ye}async getCompatibleExtension(N,H,J,re={version:this.productService.version,date:this.productService.date}){if((0,d.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(N,H,J))return N;const le=new L().withFlags(r.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,N.identifier.uuid),{extensions:ge}=await this.queryGalleryExtensions(le,{targetPlatform:J,compatible:!0,includePreRelease:H,productVersion:re},b.CancellationToken.None);return ge[0]||null}async isExtensionCompatible(N,H,J,re={version:this.productService.version,date:this.productService.date}){if(!(0,d.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,J)||!H&&N.properties.isPreReleaseVersion)return!1;let le=N.properties.engine;if(!le){const ge=await this.getManifest(N,b.CancellationToken.None);if(!ge)throw new Error("Manifest was not found");le=ge.engines.vscode}return!(!(0,g.isEngineValid)(le,re.version,re.date)||!this.areApiProposalsCompatible(N.identifier,N.properties.enabledApiProposals))}areApiProposalsCompatible(N,H){return!H||!this.extensionsEnabledWithApiProposalVersion.includes(N.id.toLowerCase())?!0:(0,g.areApiProposalsCompatible)(H)}async isValidVersion(N,H,J,re,le,ge,pe={version:this.productService.version,date:this.productService.date}){if(!(0,d.isTargetPlatformCompatible)(Q(H),le,ge)||J!=="any"&&he(H)!==(J==="prerelease"))return!1;if(re)try{const me=await this.getEngine(N,H);if(!(0,g.isEngineValid)(me,pe.version,pe.date))return!1}catch(me){return this.logService.error(`Error while getting the engine for the version ${H.version}.`,(0,v.getErrorMessage)(me)),!1}return!0}async query(N,H){let J=N.text||"";const re=N.pageSize??50;let le=new L().withPage(1,re);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,ye)=>(le=le.withFilter(o.Category,ye||fe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,ye)=>(le=le.withFilter(o.Tag,ye||fe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(le=le.withFilter(o.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),le=le.withFilter(o.SearchText,J)),le=le.withSortBy(d.SortBy.NoneOrRelevance)):N.ids?le=le.withFilter(o.ExtensionId,...N.ids):N.names?le=le.withFilter(o.ExtensionName,...N.names):le=le.withSortBy(d.SortBy.InstallCount),typeof N.sortBy=="number"&&(le=le.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(le=le.withSortOrder(N.sortOrder)),N.source&&(le=le.withSource(N.source));const ge=async(de,fe)=>{const{extensions:ye,total:Ie}=await this.queryGalleryExtensions(de,{targetPlatform:i,compatible:!1,includePreRelease:!!N.includePreRelease,productVersion:N.productVersion??{version:this.productService.version,date:this.productService.date}},fe);return ye.forEach(($,ee)=>V($,(de.pageNumber-1)*de.pageSize+ee,N.source)),{extensions:ye,total:Ie}},{extensions:pe,total:me}=await ge(le,H),Se=async(de,fe)=>{if(fe.isCancellationRequested)throw new v.CancellationError;const{extensions:ye}=await ge(le.withPage(de+1),fe);return ye};return{firstPage:pe,total:me,pageSize:le.pageSize,getPage:Se}}async queryGalleryExtensions(N,H,J){const re=N.flags;N.flags&r.IncludeLatestVersionOnly&&N.flags&r.IncludeVersions&&(N=N.withFlags(N.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(N.flags&r.IncludeLatestVersionOnly)&&!(N.flags&r.IncludeVersions)&&(N=N.withFlags(N.flags,r.IncludeLatestVersionOnly)),H.versions?.length&&(N=N.withFlags(N.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),N=N.withFlags(N.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:le,total:ge,context:pe}=await this.queryRawGalleryExtensions(N,J);if(!(N.flags&r.IncludeLatestVersionOnly)){const fe=[];for(const ye of le){const Ie=await this.toGalleryExtensionWithCriteria(ye,H,pe);Ie&&fe.push(Ie)}return{extensions:fe,total:ge}}const Se=[],de=new Map;for(let fe=0;fe<le.length;fe++){const ye=le[fe],Ie={id:(0,u.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},$=(0,C.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(ie=>(0,u.areSameExtensions)(ie,Ie))?.includePreRelease;if(H.compatible&&(0,d.isNotWebExtensionInWebTargetPlatform)(te(ye),H.targetPlatform))continue;const ee=await this.toGalleryExtensionWithCriteria(ye,H,pe);!ee||ee.properties.isPreReleaseVersion&&(!$||!ee.hasReleaseVersion)||!ee.properties.isPreReleaseVersion&&ee.properties.targetPlatform!==H.targetPlatform&&ee.hasPreReleaseVersion?de.set(ye.extensionId,fe):Se.push([fe,ee])}if(de.size){const fe=new a.StopWatch,ye=new L().withFlags(re&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,de.size).withFilter(o.ExtensionId,...de.keys()),{extensions:Ie}=await this.queryGalleryExtensions(ye,H,J);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:de.size});for(const $ of Ie){const ee=de.get($.identifier.uuid);Se.push([ee,$])}}return{extensions:Se.sort((fe,ye)=>fe[0]-ye[0]).map(([,fe])=>fe),total:ge}}async toGalleryExtensionWithCriteria(N,H,J){const re={id:(0,u.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},le=H.versions?.find(Se=>(0,u.areSameExtensions)(Se,re))?.version,ge=(0,C.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Se=>(0,u.areSameExtensions)(Se,re))?.includePreRelease,pe=te(N),me=F(N.versions,H.targetPlatform);if(H.compatible&&(0,d.isNotWebExtensionInWebTargetPlatform)(pe,H.targetPlatform))return null;for(let Se=0;Se<me.length;Se++){const de=me[Se];if(!(le&&de.version!==le)){if(await this.isValidVersion(re.id,de,ge?"any":"release",H.compatible,pe,H.targetPlatform,H.productVersion))return H.compatible&&!this.areApiProposalsCompatible(re,B(de))?null:K(N,de,pe,J);if(le&&de.version===le)return null}}return le||H.compatible?null:K(N,N.versions[0],pe)}async queryRawGalleryExtensions(N,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,r.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(r.Unpublished));const J=await this.commonHeadersPromise,re=JSON.stringify(N.raw),le={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},ge=new a.StopWatch;let pe,me,Se=0;try{if(pe=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&N.criteria.some(fe=>fe.filterType===o.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:re,headers:le},H),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Se};const de=await(0,m.asJson)(pe);if(de){const fe=de.results[0],ye=fe.extensions,Ie=fe.resultMetadata&&fe.resultMetadata.filter($=>$.metadataType==="ResultCount")[0];return Se=Ie&&Ie.metadataItems.filter($=>$.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:Se,context:{[s]:pe.res.headers.activityid}}}return{galleryExtensions:[],total:Se}}catch(de){if((0,v.isCancellationError)(de))throw me=d.ExtensionGalleryErrorCode.Cancelled,de;{const fe=(0,v.getErrorMessage)(de);throw me=fe.startsWith("XHR timeout")?d.ExtensionGalleryErrorCode.Timeout:d.ExtensionGalleryErrorCode.Failed,new d.ExtensionGalleryError(fe,me)}}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(re.length),duration:ge.elapsed(),success:!!pe&&(0,m.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:me,count:String(Se)})}}async reportStatistic(N,H,J,re){if(!this.isEnabled())return;const le=D.isWeb?this.api(`/itemName/${N}.${H}/version/${J}/statType/${re===d.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${H}/${J}/stats?statType=${re}`),ge=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:le,headers:me},b.CancellationToken.None)}catch{}}async download(N,H,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,u.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ge=J===d.InstallOperation.Install?"install":J===d.InstallOperation.Update?"update":"",pe=ge?{uri:`${N.assets.download.uri}${p.URI.parse(N.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${N.assets.download.fallbackUri}${p.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:N.assets.download,me=N.queryContext?.[s]?{[s]:N.queryContext[s]}:void 0,Se=await this.getAsset(N.identifier.id,pe,h.VSIX,me?{headers:me}:void 0);try{await this.fileService.writeFile(H,Se.stream)}catch(de){try{await this.fileService.del(H)}catch(fe){this.logService.warn(`Error while deleting the file ${H.toString()}`,(0,v.getErrorMessage)(fe))}throw new d.ExtensionGalleryError((0,v.getErrorMessage)(de),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:new Date().getTime()-le})}async downloadSignatureArchive(N,H){if(!N.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const J=await this.getAsset(N.identifier.id,N.assets.signature,h.Signature);try{await this.fileService.writeFile(H,J.stream)}catch(re){try{await this.fileService.del(H)}catch(le){this.logService.warn(`Error while deleting the file ${H.toString()}`,(0,v.getErrorMessage)(le))}throw new d.ExtensionGalleryError((0,v.getErrorMessage)(re),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(N,H){if(N.assets.readme){const J=await this.getAsset(N.identifier.id,N.assets.readme,h.Details,{},H);return await(0,m.asTextOrError)(J)||""}return""}async getManifest(N,H){if(N.assets.manifest){const J=await this.getAsset(N.identifier.id,N.assets.manifest,h.Manifest,{},H),re=await(0,m.asTextOrError)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,H,J){const re=ne(H,h.Manifest);if(!re)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},ge=await this.getAsset(N,re,h.Manifest,{headers:le});return await(0,m.asJson)(ge)}async getCoreTranslation(N,H){const J=N.assets.coreTranslations.filter(re=>re[0]===H.toUpperCase())[0];if(J){const re=await this.getAsset(N.identifier.id,J[1],J[0]),le=await(0,m.asTextOrError)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,H){if(N.assets.changelog){const J=await this.getAsset(N.identifier.id,N.assets.changelog,h.Changelog,{},H);return await(0,m.asTextOrError)(J)||""}return""}async getAllCompatibleVersions(N,H,J){let re=new L().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);N.uuid?re=re.withFilter(o.ExtensionId,N.uuid):re=re.withFilter(o.ExtensionName,N.id);const{galleryExtensions:le}=await this.queryRawGalleryExtensions(re,b.CancellationToken.None);if(!le.length)return[];const ge=te(le[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(ge,J))return[];const pe=[];await Promise.all(le[0].versions.map(async de=>{try{await this.isValidVersion(N.id,de,H?"any":"release",!0,ge,J)&&this.areApiProposalsCompatible(N,B(de))&&pe.push(de)}catch{}}));const me=[],Se=new Set;for(const de of F(pe,J))Se.has(de.version)||(Se.add(de.version),me.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:he(de)}));return me}async getAsset(N,H,J,re={},le=b.CancellationToken.None){const ge=await this.commonHeadersPromise,pe={type:"GET"},me={...ge,...re.headers||{}};re={...re,...pe,headers:me};const Se=H.uri,de=H.fallbackUri,fe={...re,url:Se};try{const ye=await this.requestService.request(fe,le);if(ye.res.statusCode===200)return ye;const Ie=await(0,m.asTextOrError)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${Ie}`)}catch(ye){if((0,v.isCancellationError)(ye))throw ye;const Ie=(0,v.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:N,assetType:J,message:Ie});const $={...re,url:de};return this.requestService.request($,le)}}async getEngine(N,H){let J=ue(H);if(!J){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:N,version:H.version});const re=await this.getManifestFromRawExtensionVersion(N,H,b.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,m.asJson)(N),J=[],re={},le=[],ge=[];if(H){for(const pe of H.malicious)J.push({id:pe});if(H.migrateToPreRelease)for(const[pe,me]of Object.entries(H.migrateToPreRelease))(!me.engine||(0,g.isEngineValid)(me.engine,this.productService.version,this.productService.date))&&(re[pe.toLowerCase()]={disallowInstall:!0,extension:{id:me.id,displayName:me.displayName,autoMigrate:{storage:!!me.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[pe,me]of Object.entries(H.deprecated))me&&(re[pe.toLowerCase()]=(0,C.isBoolean)(me)?{}:me);if(H.search)for(const pe of H.search)le.push(pe);if(Array.isArray(H.extensionsEnabledWithPreRelease))for(const pe of H.extensionsEnabledWithPreRelease)ge.push(pe.toLowerCase())}return{malicious:J,deprecated:re,search:le,extensionsEnabledWithPreRelease:ge}}};j=Ee([se(1,m.IRequestService),se(2,y.ILogService),se(3,l.IEnvironmentService),se(4,e.ITelemetryService),se(5,T.IFileService),se(6,f.IProductService),se(7,c.IConfigurationService)],j);let I=class extends j{constructor(N,H,J,re,le,ge,pe,me){super(N,H,J,re,le,ge,pe,me)}};t.ExtensionGalleryService=I,t.ExtensionGalleryService=I=Ee([se(0,E.IStorageService),se(1,m.IRequestService),se(2,y.ILogService),se(3,l.IEnvironmentService),se(4,e.ITelemetryService),se(5,T.IFileService),se(6,f.IProductService),se(7,c.IConfigurationService)],I);let M=class extends j{constructor(N,H,J,re,le,ge,pe){super(void 0,N,H,J,re,le,ge,pe)}};t.ExtensionGalleryServiceWithNoStorageService=M,t.ExtensionGalleryServiceWithNoStorageService=M=Ee([se(0,m.IRequestService),se(1,y.ILogService),se(2,l.IEnvironmentService),se(3,e.ITelemetryService),se(4,T.IFileService),se(5,f.IProductService),se(6,c.IConfigurationService)],M)}),define(oe[169],ae([0,1,12,18,10,6,148,24,25,3,69]),function(q,t,P,b,v,D,k,C,p,c,l){"use strict";var d,u;Object.defineProperty(t,"__esModule",{value:!0}),t.ServerUserDataProfilesService=t.UserDataProfilesService=t.UserDataProfilesReadonlyService=void 0;let S=class extends p.UserDataProfilesService{static{d=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(f,m,R,E,e){super(R,E,m,e),this.stateReadonlyService=f,this.nativeEnvironmentService=R}getStoredProfiles(){return this.stateReadonlyService.getItem(d.PROFILES_KEY,[]).map(m=>({...m,location:(0,c.isString)(m.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,m.location):P.URI.revive(m.location)}))}getStoredProfileAssociations(){const f=this.stateReadonlyService.getItem(d.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?f:this.migrateStoredProfileAssociations(f)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(P.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.UserDataProfilesReadonlyService=S,t.UserDataProfilesReadonlyService=S=d=Ee([se(0,k.IStateReadService),se(1,C.IUriIdentityService),se(2,b.INativeEnvironmentService),se(3,v.IFileService),se(4,D.ILogService)],S);let g=u=class extends S{constructor(f,m,R,E,e){super(f,m,R,E,e),this.stateService=f}saveStoredProfiles(f){f.length?this.stateService.setItem(u.PROFILES_KEY,f.map(m=>({...m,location:this.uriIdentityService.extUri.basename(m.location)}))):this.stateService.removeItem(u.PROFILES_KEY)}getStoredProfiles(){const f=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(f),this.stateService.setItem("userDataProfilesMigration",!0)),f}saveStoredProfileAssociations(f){f.emptyWindows||f.workspaces?this.stateService.setItem(u.PROFILE_ASSOCIATIONS_KEY,f):this.stateService.removeItem(u.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",m=this.stateService.getItem(f,void 0);if(m){this.stateService.removeItem(f);const E=m.reduce((e,{workspace:a,profile:i})=>(e[P.URI.revive(a).toString()]=P.URI.revive(i).toString(),e),{});this.stateService.setItem(u.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const R=super.getStoredProfileAssociations();return this.stateService.getItem(u.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(R),this.stateService.setItem(u.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),R}};t.UserDataProfilesService=g,t.UserDataProfilesService=g=u=Ee([se(0,k.IStateService),se(1,C.IUriIdentityService),se(2,b.INativeEnvironmentService),se(3,v.IFileService),se(4,D.ILogService)],g);let T=class extends g{constructor(f,m,R,E){super(new l.StateService(l.SaveStrategy.IMMEDIATE,m,E,R),f,m,R,E)}async init(){return await this.stateService.init(),super.init()}};t.ServerUserDataProfilesService=T,t.ServerUserDataProfilesService=T=Ee([se(0,C.IUriIdentityService),se(1,b.INativeEnvironmentService),se(2,v.IFileService),se(3,D.ILogService)],T)}),define(oe[170],ae([0,1,146,8,14,9,3,30,18,147,6,46,145,181]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0,t.nodeRequest=y;let g=class extends d.AbstractRequestService{constructor(m,R,E,e){super(e),this.configurationService=m,this.environmentService=R,this.logService=E,this.configure(),this._register(m.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.configure()}))}configure(){const m=this.configurationService.getValue("http");this.proxyUrl=m?.proxy,this.strictSSL=!!m?.proxyStrictSSL,this.authorization=m?.proxyAuthorization}async request(m,R){const{proxyUrl:E,strictSSL:e}=this;let a;try{a=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,D.getErrorMessage)(r)))}const i={...process.env,...a},s=m.agent?m.agent:await(0,u.getProxyAgent)(m.url||"",i,{proxyUrl:E,strictSSL:e});return m.agent=s,m.strictSSL=e,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(m.isChromiumNetwork?"electron":"node",m,()=>y(m,R))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((R,E)=>{q(["@vscode/proxy-agent"],R,E)}).then(we)).loadSystemCertificates({log:this.logService})}};t.RequestService=g,t.RequestService=g=Ee([se(0,C.IConfigurationService),se(1,p.INativeEnvironmentService),se(2,l.ILogService),se(3,l.ILoggerService)],g);async function T(f){return((0,P.parse)(f.url).protocol==="https:"?await new Promise((E,e)=>{q(["https"],E,e)}).then(we):await new Promise((E,e)=>{q(["http"],E,e)}).then(we)).request}async function y(f,m){return b.Promises.withAsyncBody(async(R,E)=>{const e=(0,P.parse)(f.url),a=f.getRawRequest?f.getRawRequest(f):await T(f),i={hostname:e.hostname,port:e.port?parseInt(e.port):e.protocol==="https:"?443:80,protocol:e.protocol,path:e.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,k.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(i.auth=f.user+":"+f.password);const s=a(i,r=>{const n=(0,k.isNumber)(f.followRedirects)?f.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)y({...f,url:r.headers.location,followRedirects:n-1},m).then(R,E);else{let o=r;!f.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,S.createGunzip)())),R({res:r,stream:(0,v.streamToBufferReadableStream)(o)})}});s.on("error",E),f.timeout&&s.setTimeout(f.timeout),f.isChromiumNetwork&&s.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&s.write(f.data),s.end(),m.onCancellationRequested(()=>{s.abort(),E(new D.CancellationError)})})}});var Ve=this&&this.__importDefault||function(q){return q&&q.__esModule?q:{default:q}};define(oe[182],ae([0,1,35,8,38,9,2,15,16,13,36,12,26,30,142,61,144,18,120,168,21,71,149,42,54,163,165,10,132,134,51,130,64,68,151,6,138,39,139,154,33,46,170,69,70,19,153,41,155,156,24,158,25,169,157,164,135,137,4,159,183]),function(q,t,P,b,v,D,k,C,p,c,l,d,u,S,g,T,y,f,m,R,E,e,a,i,s,r,n,o,h,w,O,x,L,A,_,X,Y,ne,ce,ue,he,B,Z,z,W,G,Q,te,F,V,K,j,I,M,U,N,H,J,re,le,ge){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=me,ue=Ve(ue);class pe extends k.Disposable{constructor(de){super(),this.argv=de,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[de,fe]=await this.initServices();return de.invokeFunction(async ye=>{const Ie=ye.get(X.ILogService),$=ye.get(o.IFileService),ee=ye.get(f.INativeEnvironmentService),ie=ye.get(I.IUserDataProfilesService);Ie.info("CLI main",this.argv),this.registerErrorHandler(Ie),await this.doRun(ee,$,ie,de),await Promise.all(fe.map(ve=>{(0,b.raceTimeout)(ve.flush(),1e3)}))})}async initServices(){const de=new L.ServiceCollection,fe={_serviceBrand:void 0,...ue.default};de.set(he.IProductService,fe);const ye=new m.NativeEnvironmentService(this.argv,fe);de.set(f.INativeEnvironmentService,ye),await Promise.all([this.allowWindowsUNCPath(ye.appSettingsHome.with({scheme:C.Schemas.file}).fsPath),this.allowWindowsUNCPath(ye.extensionsPath)].map(Ce=>Ce?u.Promises.mkdir(Ce,{recursive:!0}):void 0));const Ie=new J.LoggerService((0,X.getLogLevel)(ye),ye.logsHome);de.set(X.ILoggerService,Ie);const $=this._register(Ie.createLogger("cli",{name:(0,re.localize)(0,null)})),ee=[];Ie.getLogLevel()===X.LogLevel.Trace&&ee.push(new X.ConsoleLogger(Ie.getLogLevel()));const ie=this._register(new H.LogService($,ee));de.set(X.ILogService,ie);const ve=this._register(new h.FileService(ie));de.set(o.IFileService,ve);const Pe=this._register(new w.DiskFileSystemProvider(ie));ve.registerProvider(C.Schemas.file,Pe);const ke=new j.UriIdentityService(ve);de.set(K.IUriIdentityService,ke);const Re=new z.StateReadonlyService(z.SaveStrategy.DELAYED,ye,ie,ve),Ne=new M.UserDataProfilesReadonlyService(Re,ke,ye,ve,ie);de.set(I.IUserDataProfilesService,Ne),ve.registerProvider(C.Schemas.vscodeUserData,new le.FileUserDataProvider(C.Schemas.file,Pe,C.Schemas.vscodeUserData,Ne,ke,ie));const Oe=c.isWindows&&fe.win32RegValueName?this._register(new ce.NativePolicyService(ie,fe.win32RegValueName)):ye.policyFile?this._register(new Y.FilePolicyService(ye.policyFile,ve,ie)):new ne.NullPolicyService;de.set(ne.IPolicyService,Oe);const Ae=this._register(new g.ConfigurationService(Ne.defaultProfile.settingsResource,ve,Oe,ie));de.set(S.IConfigurationService,Ae),await Promise.all([Re.init(),Ae.initialize()]);let We;try{We=await(0,U.resolveMachineId)(Re,ie)}catch(Ce){Ce.code!=="ENOENT"&&ie.error(Ce)}const Le=await(0,U.resolveSqmId)(Re,ie),xe=await(0,U.resolvedevDeviceId)(Re,ie);Ne.init(),de.set(K.IUriIdentityService,new j.UriIdentityService(ve));const Fe=new Z.RequestService(Ae,ye,ie,Ie);de.set(B.IRequestService,Fe),de.set(T.IDownloadService,new O.SyncDescriptor(y.DownloadService,void 0,!0)),de.set(i.IExtensionsProfileScannerService,new O.SyncDescriptor(N.ExtensionsProfileScannerService,void 0,!0)),de.set(s.IExtensionsScannerService,new O.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),de.set(e.IExtensionSignatureVerificationService,new O.SyncDescriptor(e.ExtensionSignatureVerificationService,void 0,!0)),de.set(r.INativeServerExtensionManagementService,new O.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),de.set(E.IExtensionGalleryService,new O.SyncDescriptor(R.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),de.set(A.ILanguagePackService,new O.SyncDescriptor(_.NativeLanguagePackService,void 0,!1));const Ue=[],be=(0,te.isInternalTelemetry)(fe,Ae);if((0,te.supportsTelemetry)(fe,ye)){fe.aiConfig&&fe.aiConfig.ariaKey&&Ue.push(new F.OneDataSystemAppender(Fe,be,"monacoworkbench",null,fe.aiConfig.ariaKey));const Ce={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,W.resolveCommonProperties)((0,P.release)(),(0,P.hostname)(),process.arch,fe.commit,fe.version,We,Le,xe,be),piiPaths:(0,te.getPiiPathsFromEnvironment)(ye)};de.set(G.ITelemetryService,new O.SyncDescriptor(Q.TelemetryService,[Ce],!1))}else de.set(G.ITelemetryService,te.NullTelemetryService);return[new x.InstantiationService(de),Ue]}allowWindowsUNCPath(de){if(c.isWindows){const fe=(0,ge.getUNCHost)(de);fe&&(0,ge.addUNCHostToAllowlist)(fe)}return de}registerErrorHandler(de){(0,D.setUnexpectedErrorHandler)(fe=>{const ye=(0,v.toErrorMessage)(fe,!0);ye&&de.error(`[uncaught exception in CLI]: ${ye}`)}),process.on("uncaughtException",fe=>{(0,D.isSigPipeError)(fe)||(0,D.onUnexpectedError)(fe)}),process.on("unhandledRejection",fe=>(0,D.onUnexpectedError)(fe))}async doRun(de,fe,ye,Ie){let $;if(de.args.profile&&($=ye.profiles.find(ie=>ie.name===de.args.profile),!$))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=($??ye.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return Ie.createInstance(a.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,ee);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ie={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ee};return Ie.createInstance(a.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),ie,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Ie.createInstance(a.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ee);if(this.argv["update-extensions"])return Ie.createInstance(a.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).updateExtensions(ee);if(this.argv["locate-extension"])return Ie.createInstance(a.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,V.buildTelemetryMessage)(de.appRoot,de.extensionsPath))}}asExtensionIdOrVSIX(de){return de.map(fe=>/\.vsix$/i.test(fe)?d.URI.file((0,p.isAbsolute)(fe)?fe:(0,p.join)((0,l.cwd)(),fe)):fe)}}async function me(Se){const de=new pe(Se);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/code/node/cliProcessMain.js.map
