/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/platform/extensions/common/extensions","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(ne){for(var e=[],C=0,c=ne.length;C<c;C++)e[C]=le[ne[C]];return e};define(le[129],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var C;(function(T){T[T.LoaderAvailable=1]="LoaderAvailable",T[T.BeginLoadingScript=10]="BeginLoadingScript",T[T.EndLoadingScriptOK=11]="EndLoadingScriptOK",T[T.EndLoadingScriptError=12]="EndLoadingScriptError",T[T.BeginInvokeFactory=21]="BeginInvokeFactory",T[T.EndInvokeFactory=22]="EndInvokeFactory",T[T.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",T[T.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",T[T.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",T[T.NodeEndNativeRequire=34]="NodeEndNativeRequire",T[T.CachedDataFound=60]="CachedDataFound",T[T.CachedDataMissed=61]="CachedDataMissed",T[T.CachedDataRejected=62]="CachedDataRejected",T[T.CachedDataCreated=63]="CachedDataCreated"})(C||(e.LoaderEventType=C={}));class c{static get(){const D=new Map,O=new Map,L=new Map,_=new Map;function v(l,y){l.has(y.detail)||l.set(y.detail,-y.timestamp)}function P(l,y){const w=l.get(y.detail);w&&(w>=0||l.set(y.detail,w+y.timestamp))}let p=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(p=ne.getStats().slice(0).sort((l,y)=>l.timestamp-y.timestamp));for(const l of p)switch(l.type){case C.BeginLoadingScript:v(D,l);break;case C.EndLoadingScriptOK:case C.EndLoadingScriptError:P(D,l);break;case C.BeginInvokeFactory:v(O,l);break;case C.EndInvokeFactory:P(O,l);break;case C.NodeBeginNativeRequire:v(L,l);break;case C.NodeEndNativeRequire:P(L,l);break;case C.NodeBeginEvaluatingScript:v(_,l);break;case C.NodeEndEvaluatingScript:P(_,l);break}let h=0;L.forEach(l=>h+=l);function m(l){const y=[];return l.forEach((w,f)=>y.push([f,w])),y}return{amdLoad:m(D),amdInvoke:m(O),nodeRequire:m(L),nodeEval:m(_),nodeRequireTotal:h}}static toMarkdownTable(D,O){let L="";const _=[];return D.forEach((v,P)=>{_[P]=v.length}),O.forEach(v=>{v.forEach((P,p)=>{typeof P>"u"&&(P=v[p]="-");const h=P.toString().length;_[p]=Math.max(h,_[p])})}),D.forEach((v,P)=>{L+=`| ${v+" ".repeat(_[P]-v.toString().length)} `}),L+=`|
`,D.forEach((v,P)=>{L+=`| ${"-".repeat(_[P])} `}),L+=`|
`,O.forEach(v=>{v.forEach((P,p)=>{typeof P<"u"&&(L+=`| ${P+" ".repeat(_[p]-P.toString().length)} `)}),L+=`|
`}),L}}e.LoaderStats=c}),define(le[130],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=C,e.findLastIdx=c,e.findLastMonotonous=T,e.findLastIdxMonotonous=D,e.findFirstMonotonous=O,e.findFirstIdxMonotonousOrArrLen=L,e.findFirstIdxMonotonous=_,e.findFirstMax=P,e.findLastMax=p,e.findFirstMin=h,e.findMaxIdx=m,e.mapFindFirst=l;function C(y,w){const f=c(y,w);if(f!==-1)return y[f]}function c(y,w,f=y.length-1){for(let S=f;S>=0;S--){const R=y[S];if(w(R))return S}return-1}function T(y,w){const f=D(y,w);return f===-1?void 0:y[f]}function D(y,w,f=0,S=y.length){let R=f,g=S;for(;R<g;){const s=Math.floor((R+g)/2);w(y[s])?R=s+1:g=s}return R-1}function O(y,w){const f=L(y,w);return f===y.length?void 0:y[f]}function L(y,w,f=0,S=y.length){let R=f,g=S;for(;R<g;){const s=Math.floor((R+g)/2);w(y[s])?g=s:R=s+1}return R}function _(y,w,f=0,S=y.length){const R=L(y,w,f,S);return R===y.length?-1:R}class v{static{this.assertInvariants=!1}constructor(w){this._array=w,this._findLastMonotonousLastIdx=0}findLastMonotonous(w){if(v.assertInvariants){if(this._prevFindLastPredicate){for(const S of this._array)if(this._prevFindLastPredicate(S)&&!w(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=w}const f=D(this._array,w,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=f+1,f===-1?void 0:this._array[f]}}e.MonotonousArray=v;function P(y,w){if(y.length===0)return;let f=y[0];for(let S=1;S<y.length;S++){const R=y[S];w(R,f)>0&&(f=R)}return f}function p(y,w){if(y.length===0)return;let f=y[0];for(let S=1;S<y.length;S++){const R=y[S];w(R,f)>=0&&(f=R)}return f}function h(y,w){return P(y,(f,S)=>-w(f,S))}function m(y,w){if(y.length===0)return-1;let f=0;for(let S=1;S<y.length;S++){const R=y[S];w(R,y[f])>0&&(f=S)}return f}function l(y,w){for(const f of y){const S=w(f);if(S!==void 0)return S}}}),define(le[39],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var C;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(C||(e.CharCode=C={}))}),define(le[131],ue([0,1]),function(ne,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=c,e.diffSets=T,e.diffMaps=D,e.intersection=O;function c(_,v){const P=Object.create(null);for(const p of _){const h=v(p);let m=P[h];m||(m=P[h]=[]),m.push(p)}return P}function T(_,v){const P=[],p=[];for(const h of _)v.has(h)||P.push(h);for(const h of v)_.has(h)||p.push(h);return{removed:P,added:p}}function D(_,v){const P=[],p=[];for(const[h,m]of _)v.has(h)||P.push(m);for(const[h,m]of v)_.has(h)||p.push(m);return{removed:P,added:p}}function O(_,v){const P=new Set;for(const p of v)_.has(p)&&P.add(p);return P}class L{static{C=Symbol.toStringTag}constructor(v,P){this.toKey=P,this._map=new Map,this[C]="SetWithKey";for(const p of v)this.add(p)}get size(){return this._map.size}add(v){const P=this.toKey(v);return this._map.set(P,v),this}delete(v){return this._map.delete(this.toKey(v))}has(v){return this._map.has(this.toKey(v))}*entries(){for(const v of this._map.values())yield[v,v]}keys(){return this.values()}*values(){for(const v of this._map.values())yield v}clear(){this._map.clear()}forEach(v,P){this._map.forEach(p=>v.call(P,p,p,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=L}),define(le[88],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=c,e.debounce=T,e.throttle=D;function C(O){return(L,_,v)=>{let P=null,p=null;if(typeof v.value=="function"?(P="value",p=v.value):typeof v.get=="function"&&(P="get",p=v.get),!p)throw new Error("not supported");v[P]=O(p,_)}}function c(O,L,_){let v=null,P=null;if(typeof _.value=="function"?(v="value",P=_.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(v="get",P=_.get),!P)throw new Error("not supported");const p=`$memoize$${L}`;_[v]=function(...h){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,h)}),this[p]}}function T(O,L,_){return C((v,P)=>{const p=`$debounce$${P}`,h=`$debounce$result$${P}`;return function(...m){this[h]||(this[h]=_?_():void 0),clearTimeout(this[p]),L&&(this[h]=L(this[h],...m),m=[this[h]]),this[p]=setTimeout(()=>{v.apply(this,m),this[h]=_?_():void 0},O)}})}function D(O,L,_){return C((v,P)=>{const p=`$throttle$timer$${P}`,h=`$throttle$result$${P}`,m=`$throttle$lastRun$${P}`,l=`$throttle$pending$${P}`;return function(...y){if(this[h]||(this[h]=_?_():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),L&&(this[h]=L(this[h],...y)),this[l])return;const w=this[m]+O;w<=Date.now()?(this[m]=Date.now(),v.apply(this,[this[h]]),this[h]=_?_():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),v.apply(this,[this[h]]),this[h]=_?_():void 0},w-Date.now()))}})}}),define(le[8],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=c,e.isSigPipeError=T,e.onUnexpectedError=D,e.onUnexpectedExternalError=O,e.transformErrorForSerialization=L,e.transformErrorFromSerialization=_,e.isCancellationError=P,e.canceled=h,e.illegalArgument=m,e.illegalState=l,e.getErrorMessage=w;class C{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?g.isErrorNoTelemetry(t)?new g(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=C,e.errorHandler=new C;function c(r){e.errorHandler.setUnexpectedErrorHandler(r)}function T(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(r){P(r)||e.errorHandler.onUnexpectedError(r)}function O(r){P(r)||e.errorHandler.onUnexpectedExternalError(r)}function L(r){if(r instanceof Error){const{name:t,message:o}=r,i=r.stacktrace||r.stack;return{$isError:!0,name:t,message:o,stack:i,noTelemetry:g.isErrorNoTelemetry(r)}}return r}function _(r){let t;return r.noTelemetry?t=new g:(t=new Error,t.name=r.name),t.message=r.message,t.stack=r.stack,t}const v="Canceled";function P(r){return r instanceof p?!0:r instanceof Error&&r.name===v&&r.message===v}class p extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=p;function h(){const r=new Error(v);return r.name=r.message,r}function m(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function l(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=y;function w(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=f;class S extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=S;class R extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=R;class g extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof g)return t;const o=new g;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.BugIndicatingError=s}),define(le[19],ue([0,1,8,130]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=T,e.tail2=D,e.equals=O,e.removeFastWithoutKeepingOrder=L,e.binarySearch=_,e.binarySearch2=v,e.quickSelect=P,e.groupBy=p,e.groupAdjacentBy=h,e.forEachAdjacent=m,e.forEachWithNeighbors=l,e.sortedDiff=y,e.delta=w,e.top=f,e.topAsync=S,e.coalesce=g,e.coalesceInPlace=s,e.move=r,e.isFalsyOrEmpty=t,e.isNonEmptyArray=o,e.distinct=i,e.uniqueFilter=n,e.firstOrDefault=a,e.lastOrDefault=u,e.commonPrefixLength=d,e.range=b,e.index=A,e.insert=I,e.remove=E,e.arrayInsert=k,e.shuffle=F,e.pushToStart=U,e.pushToEnd=M,e.pushMany=H,e.mapArrayOrNot=B,e.asArray=Z,e.getRandomElement=V,e.insertInto=ie,e.splice=z,e.compareBy=se,e.tieBreakComparators=ce,e.reverseOrder=G;function T($,x=0){return $[$.length-(1+x)]}function D($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}function O($,x,J=(ee,K)=>ee===K){if($===x)return!0;if(!$||!x||$.length!==x.length)return!1;for(let ee=0,K=$.length;ee<K;ee++)if(!J($[ee],x[ee]))return!1;return!0}function L($,x){const J=$.length-1;x<J&&($[x]=$[J]),$.pop()}function _($,x,J){return v($.length,ee=>J($[ee],x))}function v($,x){let J=0,ee=$-1;for(;J<=ee;){const K=(J+ee)/2|0,oe=x(K);if(oe<0)J=K+1;else if(oe>0)ee=K-1;else return K}return-(J+1)}function P($,x,J){if($=$|0,$>=x.length)throw new TypeError("invalid index");const ee=x[Math.floor(x.length*Math.random())],K=[],oe=[],he=[];for(const ge of x){const Se=J(ge,ee);Se<0?K.push(ge):Se>0?oe.push(ge):he.push(ge)}return $<K.length?P($,K,J):$<K.length+he.length?he[0]:P($-(K.length+he.length),oe,J)}function p($,x){const J=[];let ee;for(const K of $.slice(0).sort(x))!ee||x(ee[0],K)!==0?(ee=[K],J.push(ee)):ee.push(K);return J}function*h($,x){let J,ee;for(const K of $)ee!==void 0&&x(ee,K)?J.push(K):(J&&(yield J),J=[K]),ee=K;J&&(yield J)}function m($,x){for(let J=0;J<=$.length;J++)x(J===0?void 0:$[J-1],J===$.length?void 0:$[J])}function l($,x){for(let J=0;J<$.length;J++)x(J===0?void 0:$[J-1],$[J],J+1===$.length?void 0:$[J+1])}function y($,x,J){const ee=[];function K(ge,Se,Pe){if(Se===0&&Pe.length===0)return;const ve=ee[ee.length-1];ve&&ve.start+ve.deleteCount===ge?(ve.deleteCount+=Se,ve.toInsert.push(...Pe)):ee.push({start:ge,deleteCount:Se,toInsert:Pe})}let oe=0,he=0;for(;;){if(oe===$.length){K(oe,0,x.slice(he));break}if(he===x.length){K(oe,$.length-oe,[]);break}const ge=$[oe],Se=x[he],Pe=J(ge,Se);Pe===0?(oe+=1,he+=1):Pe<0?(K(oe,1,[]),oe+=1):Pe>0&&(K(oe,0,[Se]),he+=1)}return ee}function w($,x,J){const ee=y($,x,J),K=[],oe=[];for(const he of ee)K.push(...$.slice(he.start,he.start+he.deleteCount)),oe.push(...he.toInsert);return{removed:K,added:oe}}function f($,x,J){if(J===0)return[];const ee=$.slice(0,J).sort(x);return R($,x,ee,J,$.length),ee}function S($,x,J,ee,K){return J===0?Promise.resolve([]):new Promise((oe,he)=>{(async()=>{const ge=$.length,Se=$.slice(0,J).sort(x);for(let Pe=J,ve=Math.min(J+ee,ge);Pe<ge;Pe=ve,ve=Math.min(ve+ee,ge)){if(Pe>J&&await new Promise(ye=>setTimeout(ye)),K&&K.isCancellationRequested)throw new C.CancellationError;R($,x,Se,Pe,ve)}return Se})().then(oe,he)})}function R($,x,J,ee,K){for(const oe=J.length;ee<K;ee++){const he=$[ee];if(x(he,J[oe-1])<0){J.pop();const ge=(0,c.findFirstIdxMonotonousOrArrLen)(J,Se=>x(he,Se)<0);J.splice(ge,0,he)}}}function g($){return $.filter(x=>!!x)}function s($){let x=0;for(let J=0;J<$.length;J++)$[J]&&($[x]=$[J],x+=1);$.length=x}function r($,x,J){$.splice(J,0,$.splice(x,1)[0])}function t($){return!Array.isArray($)||$.length===0}function o($){return Array.isArray($)&&$.length>0}function i($,x=J=>J){const J=new Set;return $.filter(ee=>{const K=x(ee);return J.has(K)?!1:(J.add(K),!0)})}function n($){const x=new Set;return J=>{const ee=$(J);return x.has(ee)?!1:(x.add(ee),!0)}}function a($,x){return $.length>0?$[0]:x}function u($,x){return $.length>0?$[$.length-1]:x}function d($,x,J=(ee,K)=>ee===K){let ee=0;for(let K=0,oe=Math.min($.length,x.length);K<oe&&J($[K],x[K]);K++)ee++;return ee}function b($,x){let J=typeof x=="number"?$:0;typeof x=="number"?J=$:(J=0,x=$);const ee=[];if(J<=x)for(let K=J;K<x;K++)ee.push(K);else for(let K=J;K>x;K--)ee.push(K);return ee}function A($,x,J){return $.reduce((ee,K)=>(ee[x(K)]=J?J(K):K,ee),Object.create(null))}function I($,x){return $.push(x),()=>E($,x)}function E($,x){const J=$.indexOf(x);if(J>-1)return $.splice(J,1),x}function k($,x,J){const ee=$.slice(0,x),K=$.slice(x);return ee.concat(J,K)}function F($,x){let J;if(typeof x=="number"){let ee=x;J=()=>{const K=Math.sin(ee++)*179426549;return K-Math.floor(K)}}else J=Math.random;for(let ee=$.length-1;ee>0;ee-=1){const K=Math.floor(J()*(ee+1)),oe=$[ee];$[ee]=$[K],$[K]=oe}}function U($,x){const J=$.indexOf(x);J>-1&&($.splice(J,1),$.unshift(x))}function M($,x){const J=$.indexOf(x);J>-1&&($.splice(J,1),$.push(x))}function H($,x){for(const J of x)$.push(J)}function B($,x){return Array.isArray($)?$.map(x):x($)}function Z($){return Array.isArray($)?$:[$]}function V($){return $[Math.floor(Math.random()*$.length)]}function ie($,x,J){const ee=q($,x),K=$.length,oe=J.length;$.length=K+oe;for(let he=K-1;he>=ee;he--)$[he+oe]=$[he];for(let he=0;he<oe;he++)$[he+ee]=J[he]}function z($,x,J,ee){const K=q($,x);let oe=$.splice(K,J);return oe===void 0&&(oe=[]),ie($,K,ee),oe}function q($,x){return x<0?Math.max(x+$.length,0):Math.min(x,$.length)}var te;(function($){function x(oe){return oe<0}$.isLessThan=x;function J(oe){return oe<=0}$.isLessThanOrEqual=J;function ee(oe){return oe>0}$.isGreaterThan=ee;function K(oe){return oe===0}$.isNeitherLessOrGreaterThan=K,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function se($,x){return(J,ee)=>x($(J),$(ee))}function ce(...$){return(x,J)=>{for(const ee of $){const K=ee(x,J);if(!te.isNeitherLessOrGreaterThan(K))return K}return te.neitherLessOrGreaterThan}}const W=($,x)=>$-x;e.numberComparator=W;const Q=($,x)=>(0,e.numberComparator)($?1:0,x?1:0);e.booleanComparator=Q;function G($){return(x,J)=>-$(x,J)}class j{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let J=this.firstIdx;for(;J<this.items.length&&x(this.items[J]);)J++;const ee=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,ee}takeFromEndWhile(x){let J=this.lastIdx;for(;J>=0&&x(this.items[J]);)J--;const ee=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,ee}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}removeLast(){const x=this.items[this.lastIdx];return this.lastIdx--,x}takeCount(x){const J=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,J}}e.ArrayQueue=j;class N{static{this.empty=new N(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(J=>(x(J),!0))}toArray(){const x=[];return this.iterate(J=>(x.push(J),!0)),x}filter(x){return new N(J=>this.iterate(ee=>x(ee)?J(ee):!0))}map(x){return new N(J=>this.iterate(ee=>J(x(ee))))}some(x){let J=!1;return this.iterate(ee=>(J=x(ee),!J)),J}findFirst(x){let J;return this.iterate(ee=>x(ee)?(J=ee,!1):!0),J}findLast(x){let J;return this.iterate(ee=>(x(ee)&&(J=ee),!0)),J}findLastMaxBy(x){let J,ee=!0;return this.iterate(K=>((ee||te.isGreaterThan(x(K,J)))&&(ee=!1,J=K),!0)),J}}e.CallbackIterable=N;class Y{constructor(x){this._indexMap=x}static createSortPermutation(x,J){const ee=Array.from(x.keys()).sort((K,oe)=>J(x[K],x[oe]));return new Y(ee)}apply(x){return x.map((J,ee)=>x[this._indexMap[ee]])}inverse(){const x=this._indexMap.slice();for(let J=0;J<this._indexMap.length;J++)x[this._indexMap[J]]=J;return new Y(x)}}e.Permutation=Y}),define(le[132],ue([0,1,8]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.assertNever=T,e.assert=D,e.softAssert=O,e.assertFn=L,e.checkAdjacentItems=_;function c(v,P){if(!v)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}function T(v,P="Unreachable"){throw new Error(P)}function D(v,P="unexpected state"){if(!v)throw new C.BugIndicatingError(`Assertion Failed: ${P}`)}function O(v){v||(0,C.onUnexpectedError)(new C.BugIndicatingError("Soft Assertion Failed"))}function L(v){if(!v()){debugger;v(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}function _(v,P){let p=0;for(;p<v.length-1;){const h=v[p],m=v[p+1];if(!P(h,m))return!1;p++}return!0}}),define(le[89],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=C;function C(c,T){const D=this;let O=!1,L;return function(){if(O)return L;if(O=!0,T)try{L=c.apply(D,arguments)}finally{T()}else L=c.apply(D,arguments);return L}}}),define(le[64],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(c){function T(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}c.is=T;const D=Object.freeze([]);function O(){return D}c.empty=O;function*L(t){yield t}c.single=L;function _(t){return T(t)?t:L(t)}c.wrap=_;function v(t){return t||D}c.from=v;function*P(t){for(let o=t.length-1;o>=0;o--)yield t[o]}c.reverse=P;function p(t){return!t||t[Symbol.iterator]().next().done===!0}c.isEmpty=p;function h(t){return t[Symbol.iterator]().next().value}c.first=h;function m(t,o){let i=0;for(const n of t)if(o(n,i++))return!0;return!1}c.some=m;function l(t,o){for(const i of t)if(o(i))return i}c.find=l;function*y(t,o){for(const i of t)o(i)&&(yield i)}c.filter=y;function*w(t,o){let i=0;for(const n of t)yield o(n,i++)}c.map=w;function*f(t,o){let i=0;for(const n of t)yield*o(n,i++)}c.flatMap=f;function*S(...t){for(const o of t)yield*o}c.concat=S;function R(t,o,i){let n=i;for(const a of t)n=o(n,a);return n}c.reduce=R;function*g(t,o,i=t.length){for(o<0&&(o+=t.length),i<0?i+=t.length:i>t.length&&(i=t.length);o<i;o++)yield t[o]}c.slice=g;function s(t,o=Number.POSITIVE_INFINITY){const i=[];if(o===0)return[i,t];const n=t[Symbol.iterator]();for(let a=0;a<o;a++){const u=n.next();if(u.done)return[i,c.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return n}}]}c.consume=s;async function r(t){const o=[];for await(const i of t)o.push(i);return Promise.resolve(o)}c.asyncToArray=r})(C||(e.Iterable=C={}))}),define(le[34],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=O,e.getLocation=p,e.parse=h,e.parseTree=m,e.findNodeAtLocation=l,e.getNodePath=y,e.getNodeValue=w,e.contains=f,e.findNodeAtOffset=S,e.visit=R,e.getNodeType=g;var C;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var c;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var T;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var D;(function(s){s.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function O(s,r=!1){let t=0;const o=s.length;let i="",n=0,a=c.Unknown,u=C.None;function d(U){let M=0,H=0;for(;M<U;){const B=s.charCodeAt(t);if(B>=P._0&&B<=P._9)H=H*16+B-P._0;else if(B>=P.A&&B<=P.F)H=H*16+B-P.A+10;else if(B>=P.a&&B<=P.f)H=H*16+B-P.a+10;else break;t++,M++}return M<U&&(H=-1),H}function b(U){t=U,i="",n=0,a=c.Unknown,u=C.None}function A(){const U=t;if(s.charCodeAt(t)===P._0)t++;else for(t++;t<s.length&&v(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===P.dot)if(t++,t<s.length&&v(s.charCodeAt(t)))for(t++;t<s.length&&v(s.charCodeAt(t));)t++;else return u=C.UnexpectedEndOfNumber,s.substring(U,t);let M=t;if(t<s.length&&(s.charCodeAt(t)===P.E||s.charCodeAt(t)===P.e))if(t++,(t<s.length&&s.charCodeAt(t)===P.plus||s.charCodeAt(t)===P.minus)&&t++,t<s.length&&v(s.charCodeAt(t))){for(t++;t<s.length&&v(s.charCodeAt(t));)t++;M=t}else u=C.UnexpectedEndOfNumber;return s.substring(U,M)}function I(){let U="",M=t;for(;;){if(t>=o){U+=s.substring(M,t),u=C.UnexpectedEndOfString;break}const H=s.charCodeAt(t);if(H===P.doubleQuote){U+=s.substring(M,t),t++;break}if(H===P.backslash){if(U+=s.substring(M,t),t++,t>=o){u=C.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case P.doubleQuote:U+='"';break;case P.backslash:U+="\\";break;case P.slash:U+="/";break;case P.b:U+="\b";break;case P.f:U+="\f";break;case P.n:U+=`
`;break;case P.r:U+="\r";break;case P.t:U+="	";break;case P.u:{const Z=d(4);Z>=0?U+=String.fromCharCode(Z):u=C.InvalidUnicode;break}default:u=C.InvalidEscapeCharacter}M=t;continue}if(H>=0&&H<=31)if(_(H)){U+=s.substring(M,t),u=C.UnexpectedEndOfString;break}else u=C.InvalidCharacter;t++}return U}function E(){if(i="",u=C.None,n=t,t>=o)return n=o,a=c.EOF;let U=s.charCodeAt(t);if(L(U)){do t++,i+=String.fromCharCode(U),U=s.charCodeAt(t);while(L(U));return a=c.Trivia}if(_(U))return t++,i+=String.fromCharCode(U),U===P.carriageReturn&&s.charCodeAt(t)===P.lineFeed&&(t++,i+=`
`),a=c.LineBreakTrivia;switch(U){case P.openBrace:return t++,a=c.OpenBraceToken;case P.closeBrace:return t++,a=c.CloseBraceToken;case P.openBracket:return t++,a=c.OpenBracketToken;case P.closeBracket:return t++,a=c.CloseBracketToken;case P.colon:return t++,a=c.ColonToken;case P.comma:return t++,a=c.CommaToken;case P.doubleQuote:return t++,i=I(),a=c.StringLiteral;case P.slash:{const M=t-1;if(s.charCodeAt(t+1)===P.slash){for(t+=2;t<o&&!_(s.charCodeAt(t));)t++;return i=s.substring(M,t),a=c.LineCommentTrivia}if(s.charCodeAt(t+1)===P.asterisk){t+=2;const H=o-1;let B=!1;for(;t<H;){if(s.charCodeAt(t)===P.asterisk&&s.charCodeAt(t+1)===P.slash){t+=2,B=!0;break}t++}return B||(t++,u=C.UnexpectedEndOfComment),i=s.substring(M,t),a=c.BlockCommentTrivia}return i+=String.fromCharCode(U),t++,a=c.Unknown}case P.minus:if(i+=String.fromCharCode(U),t++,t===o||!v(s.charCodeAt(t)))return a=c.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return i+=A(),a=c.NumericLiteral;default:for(;t<o&&k(U);)t++,U=s.charCodeAt(t);if(n!==t){switch(i=s.substring(n,t),i){case"true":return a=c.TrueKeyword;case"false":return a=c.FalseKeyword;case"null":return a=c.NullKeyword}return a=c.Unknown}return i+=String.fromCharCode(U),t++,a=c.Unknown}}function k(U){if(L(U)||_(U))return!1;switch(U){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function F(){let U;do U=E();while(U>=c.LineCommentTrivia&&U<=c.Trivia);return U}return{setPosition:b,getPosition:()=>t,scan:r?F:E,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>n,getTokenLength:()=>t-n,getTokenError:()=>u}}function L(s){return s===P.space||s===P.tab||s===P.verticalTab||s===P.formFeed||s===P.nonBreakingSpace||s===P.ogham||s>=P.enQuad&&s<=P.zeroWidthSpace||s===P.narrowNoBreakSpace||s===P.mathematicalSpace||s===P.ideographicSpace||s===P.byteOrderMark}function _(s){return s===P.lineFeed||s===P.carriageReturn||s===P.lineSeparator||s===P.paragraphSeparator}function v(s){return s>=P._0&&s<=P._9}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function p(s,r){const t=[],o=new Object;let i;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(d,b,A,I){n.value=d,n.offset=b,n.length=A,n.type=I,n.colonOffset=void 0,i=n}try{R(s,{onObjectBegin:(d,b)=>{if(r<=d)throw o;i=void 0,a=r>d,t.push("")},onObjectProperty:(d,b,A)=>{if(r<b||(u(d,b,A,"property"),t[t.length-1]=d,r<=b+A))throw o},onObjectEnd:(d,b)=>{if(r<=d)throw o;i=void 0,t.pop()},onArrayBegin:(d,b)=>{if(r<=d)throw o;i=void 0,t.push(0)},onArrayEnd:(d,b)=>{if(r<=d)throw o;i=void 0,t.pop()},onLiteralValue:(d,b,A)=>{if(r<b||(u(d,b,A,g(d)),r<=b+A))throw o},onSeparator:(d,b,A)=>{if(r<=b)throw o;if(d===":"&&i&&i.type==="property")i.colonOffset=b,a=!1,i=void 0;else if(d===","){const I=t[t.length-1];typeof I=="number"?t[t.length-1]=I+1:(a=!0,t[t.length-1]=""),i=void 0}}})}catch(d){if(d!==o)throw d}return{path:t,previousNode:i,isAtPropertyKey:a,matches:d=>{let b=0;for(let A=0;b<d.length&&A<t.length;A++)if(d[b]===t[A]||d[b]==="*")b++;else if(d[b]!=="**")return!1;return b===d.length}}}function h(s,r=[],t=D.DEFAULT){let o=null,i=[];const n=[];function a(d){Array.isArray(i)?i.push(d):o!==null&&(i[o]=d)}return R(s,{onObjectBegin:()=>{const d={};a(d),n.push(i),i=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{i=n.pop()},onArrayBegin:()=>{const d=[];a(d),n.push(i),i=d,o=null},onArrayEnd:()=>{i=n.pop()},onLiteralValue:a,onError:(d,b,A)=>{r.push({error:d,offset:b,length:A})}},t),i[0]}function m(s,r=[],t=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(d){o.type==="property"&&(o.length=d-o.offset,o=o.parent)}function n(d){return o.children.push(d),d}R(s,{onObjectBegin:d=>{o=n({type:"object",offset:d,length:-1,parent:o,children:[]})},onObjectProperty:(d,b,A)=>{o=n({type:"property",offset:b,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:d,offset:b,length:A,parent:o})},onObjectEnd:(d,b)=>{o.length=d+b-o.offset,o=o.parent,i(d+b)},onArrayBegin:(d,b)=>{o=n({type:"array",offset:d,length:-1,parent:o,children:[]})},onArrayEnd:(d,b)=>{o.length=d+b-o.offset,o=o.parent,i(d+b)},onLiteralValue:(d,b,A)=>{n({type:g(d),offset:b,length:A,parent:o,value:d}),i(b+A)},onSeparator:(d,b,A)=>{o.type==="property"&&(d===":"?o.colonOffset=b:d===","&&i(b))},onError:(d,b,A)=>{r.push({error:d,offset:b,length:A})}},t);const u=o.children[0];return u&&delete u.parent,u}function l(s,r){if(!s)return;let t=s;for(const o of r)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let i=!1;for(const n of t.children)if(Array.isArray(n.children)&&n.children[0].value===o){t=n.children[1],i=!0;break}if(!i)return}else{const i=o;if(t.type!=="array"||i<0||!Array.isArray(t.children)||i>=t.children.length)return;t=t.children[i]}return t}function y(s){if(!s.parent||!s.parent.children)return[];const r=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const r=Object.create(null);for(const t of s.children){const o=t.children[1];o&&(r[t.children[0].value]=w(o))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function f(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}function S(s,r,t=!1){if(f(s,r,t)){const o=s.children;if(Array.isArray(o))for(let i=0;i<o.length&&o[i].offset<=r;i++){const n=S(o[i],r,t);if(n)return n}return s}}function R(s,r,t=D.DEFAULT){const o=O(s,!1);function i(se){return se?()=>se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function n(se){return se?ce=>se(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),u=n(r.onObjectProperty),d=i(r.onObjectEnd),b=i(r.onArrayBegin),A=i(r.onArrayEnd),I=n(r.onLiteralValue),E=n(r.onSeparator),k=i(r.onComment),F=n(r.onError),U=t&&t.disallowComments,M=t&&t.allowTrailingComma;function H(){for(;;){const se=o.scan();switch(o.getTokenError()){case C.InvalidUnicode:B(T.InvalidUnicode);break;case C.InvalidEscapeCharacter:B(T.InvalidEscapeCharacter);break;case C.UnexpectedEndOfNumber:B(T.UnexpectedEndOfNumber);break;case C.UnexpectedEndOfComment:U||B(T.UnexpectedEndOfComment);break;case C.UnexpectedEndOfString:B(T.UnexpectedEndOfString);break;case C.InvalidCharacter:B(T.InvalidCharacter);break}switch(se){case c.LineCommentTrivia:case c.BlockCommentTrivia:U?B(T.InvalidCommentToken):k();break;case c.Unknown:B(T.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return se}}}function B(se,ce=[],W=[]){if(F(se),ce.length+W.length>0){let Q=o.getToken();for(;Q!==c.EOF;){if(ce.indexOf(Q)!==-1){H();break}else if(W.indexOf(Q)!==-1)break;Q=H()}}}function Z(se){const ce=o.getTokenValue();return se?I(ce):u(ce),H(),!0}function V(){switch(o.getToken()){case c.NumericLiteral:{let se=0;try{se=JSON.parse(o.getTokenValue()),typeof se!="number"&&(B(T.InvalidNumberFormat),se=0)}catch{B(T.InvalidNumberFormat)}I(se);break}case c.NullKeyword:I(null);break;case c.TrueKeyword:I(!0);break;case c.FalseKeyword:I(!1);break;default:return!1}return H(),!0}function ie(){return o.getToken()!==c.StringLiteral?(B(T.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(Z(!1),o.getToken()===c.ColonToken?(E(":"),H(),te()||B(T.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):B(T.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function z(){a(),H();let se=!1;for(;o.getToken()!==c.CloseBraceToken&&o.getToken()!==c.EOF;){if(o.getToken()===c.CommaToken){if(se||B(T.ValueExpected,[],[]),E(","),H(),o.getToken()===c.CloseBraceToken&&M)break}else se&&B(T.CommaExpected,[],[]);ie()||B(T.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),se=!0}return d(),o.getToken()!==c.CloseBraceToken?B(T.CloseBraceExpected,[c.CloseBraceToken],[]):H(),!0}function q(){b(),H();let se=!1;for(;o.getToken()!==c.CloseBracketToken&&o.getToken()!==c.EOF;){if(o.getToken()===c.CommaToken){if(se||B(T.ValueExpected,[],[]),E(","),H(),o.getToken()===c.CloseBracketToken&&M)break}else se&&B(T.CommaExpected,[],[]);te()||B(T.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),se=!0}return A(),o.getToken()!==c.CloseBracketToken?B(T.CloseBracketExpected,[c.CloseBracketToken],[]):H(),!0}function te(){switch(o.getToken()){case c.OpenBracketToken:return q();case c.OpenBraceToken:return z();case c.StringLiteral:return Z(!0);default:return V()}}return H(),o.getToken()===c.EOF?t.allowEmptyContent?!0:(B(T.ValueExpected,[],[]),!1):te()?(o.getToken()!==c.EOF&&B(T.EndOfFileExpected,[],[]),!0):(B(T.ValueExpected,[],[]),!1)}function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[45],ue([0,1,34]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=c,e.toFormattedString=T,e.getEOL=L,e.isEOL=_;function c(v,P,p){let h,m,l,y,w;if(P){for(y=P.offset,w=y+P.length,l=y;l>0&&!_(v,l-1);)l--;let u=w;for(;u<v.length&&!_(v,u);)u++;m=v.substring(l,u),h=O(m,p)}else m=v,h=0,l=0,y=0,w=v.length;const f=L(p,v);let S=!1,R=0,g;p.insertSpaces?g=D(" ",p.tabSize||4):g="	";const s=(0,C.createScanner)(m,!1);let r=!1;function t(){return f+D(g,h+R)}function o(){let u=s.scan();for(S=!1;u===C.SyntaxKind.Trivia||u===C.SyntaxKind.LineBreakTrivia;)S=S||u===C.SyntaxKind.LineBreakTrivia,u=s.scan();return r=u===C.SyntaxKind.Unknown||s.getTokenError()!==C.ScanError.None,u}const i=[];function n(u,d,b){!r&&d<w&&b>y&&v.substring(d,b)!==u&&i.push({offset:d,length:b-d,content:u})}let a=o();if(a!==C.SyntaxKind.EOF){const u=s.getTokenOffset()+l,d=D(g,h);n(d,l,u)}for(;a!==C.SyntaxKind.EOF;){let u=s.getTokenOffset()+s.getTokenLength()+l,d=o(),b="";for(;!S&&(d===C.SyntaxKind.LineCommentTrivia||d===C.SyntaxKind.BlockCommentTrivia);){const I=s.getTokenOffset()+l;n(" ",u,I),u=s.getTokenOffset()+s.getTokenLength()+l,b=d===C.SyntaxKind.LineCommentTrivia?t():"",d=o()}if(d===C.SyntaxKind.CloseBraceToken)a!==C.SyntaxKind.OpenBraceToken&&(R--,b=t());else if(d===C.SyntaxKind.CloseBracketToken)a!==C.SyntaxKind.OpenBracketToken&&(R--,b=t());else{switch(a){case C.SyntaxKind.OpenBracketToken:case C.SyntaxKind.OpenBraceToken:R++,b=t();break;case C.SyntaxKind.CommaToken:case C.SyntaxKind.LineCommentTrivia:b=t();break;case C.SyntaxKind.BlockCommentTrivia:S?b=t():b=" ";break;case C.SyntaxKind.ColonToken:b=" ";break;case C.SyntaxKind.StringLiteral:if(d===C.SyntaxKind.ColonToken){b="";break}case C.SyntaxKind.NullKeyword:case C.SyntaxKind.TrueKeyword:case C.SyntaxKind.FalseKeyword:case C.SyntaxKind.NumericLiteral:case C.SyntaxKind.CloseBraceToken:case C.SyntaxKind.CloseBracketToken:d===C.SyntaxKind.LineCommentTrivia||d===C.SyntaxKind.BlockCommentTrivia?b=" ":d!==C.SyntaxKind.CommaToken&&d!==C.SyntaxKind.EOF&&(r=!0);break;case C.SyntaxKind.Unknown:r=!0;break}S&&(d===C.SyntaxKind.LineCommentTrivia||d===C.SyntaxKind.BlockCommentTrivia)&&(b=t())}const A=s.getTokenOffset()+l;n(b,u,A),a=d}return i}function T(v,P){const p=JSON.stringify(v,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?p.replace(/\r\n|\r|\n/g,P.eol):p}function D(v,P){let p="";for(let h=0;h<P;h++)p+=v;return p}function O(v,P){let p=0,h=0;const m=P.tabSize||4;for(;p<v.length;){const l=v.charAt(p);if(l===" ")h++;else if(l==="	")h+=m;else break;p++}return Math.floor(h/m)}function L(v,P){for(let p=0;p<P.length;p++){const h=P.charAt(p);if(h==="\r")return p+1<P.length&&P.charAt(p+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return v&&v.eol||`
`}function _(v,P){return`\r
`.indexOf(v.charAt(P))!==-1}}),define(le[65],ue([0,1,34,45]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=T,e.setProperty=D,e.withFormatting=O,e.applyEdit=L,e.applyEdits=_;function T(v,P,p){return D(v,P,void 0,p)}function D(v,P,p,h,m){const l=P.slice(),y=[],w=(0,C.parseTree)(v,y);let f,S;for(;l.length>0&&(S=l.pop(),f=(0,C.findNodeAtLocation)(w,l),f===void 0&&p!==void 0);)typeof S=="string"?p={[S]:p}:p=[p];if(f)if(f.type==="object"&&typeof S=="string"&&Array.isArray(f.children)){const R=(0,C.findNodeAtLocation)(f,[S]);if(R!==void 0)if(p===void 0){if(!R.parent)throw new Error("Malformed AST");const g=f.children.indexOf(R.parent);let s,r=R.parent.offset+R.parent.length;if(g>0){const t=f.children[g-1];s=t.offset+t.length}else s=f.offset+1,f.children.length>1&&(r=f.children[1].offset);return O(v,{offset:s,length:r-s,content:""},h)}else return O(v,{offset:R.offset,length:R.length,content:JSON.stringify(p)},h);else{if(p===void 0)return[];const g=`${JSON.stringify(S)}: ${JSON.stringify(p)}`,s=m?m(f.children.map(t=>t.children[0].value)):f.children.length;let r;if(s>0){const t=f.children[s-1];r={offset:t.offset+t.length,length:0,content:","+g}}else f.children.length===0?r={offset:f.offset+1,length:0,content:g}:r={offset:f.offset+1,length:0,content:g+","};return O(v,r,h)}}else if(f.type==="array"&&typeof S=="number"&&Array.isArray(f.children))if(p!==void 0){const R=`${JSON.stringify(p)}`;let g;if(f.children.length===0||S===0)g={offset:f.offset+1,length:0,content:f.children.length===0?R:R+","};else{const s=S===-1||S>f.children.length?f.children.length:S,r=f.children[s-1];g={offset:r.offset+r.length,length:0,content:","+R}}return O(v,g,h)}else{const R=S,g=f.children[R];let s;if(f.children.length===1)s={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===R){const r=f.children[R-1],t=r.offset+r.length,o=f.offset+f.length;s={offset:t,length:o-2-t,content:""}}else s={offset:g.offset,length:f.children[R+1].offset-g.offset,content:""};return O(v,s,h)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${f.type}`);else return p===void 0?[]:O(v,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(p)},h)}function O(v,P,p){let h=L(v,P),m=P.offset,l=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;m>0&&!(0,c.isEOL)(h,m-1);)m--;for(;l<h.length&&!(0,c.isEOL)(h,l);)l++}const y=(0,c.format)(h,{offset:m,length:l-m},p);for(let f=y.length-1;f>=0;f--){const S=y[f];h=L(h,S),m=Math.min(m,S.offset),l=Math.max(l,S.offset+S.length),l+=S.content.length-S.length}const w=v.length-(h.length-l)-m;return[{offset:m,length:w,content:h.substring(m,l)}]}function L(v,P){return v.substring(0,P.offset)+P.content+v.substring(P.offset+P.length)}function _(v,P){const p=P.slice(0).sort((m,l)=>{const y=m.offset-l.offset;return y===0?m.length-l.length:y});let h=v.length;for(let m=p.length-1;m>=0;m--){const l=p[m];if(l.offset+l.length<=h)v=L(v,l);else throw new Error("Overlapping edit");h=l.offset}return v}}),define(le[54],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class C{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=C}),define(le[90],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class C{static{this.Undefined=new C(void 0)}constructor(D){this.element=D,this.next=C.Undefined,this.prev=C.Undefined}}class c{constructor(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===C.Undefined}clear(){let D=this._first;for(;D!==C.Undefined;){const O=D.next;D.prev=C.Undefined,D.next=C.Undefined,D=O}this._first=C.Undefined,this._last=C.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,O){const L=new C(D);if(this._first===C.Undefined)this._first=L,this._last=L;else if(O){const v=this._last;this._last=L,L.prev=v,v.next=L}else{const v=this._first;this._first=L,L.next=v,v.prev=L}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(L))}}shift(){if(this._first!==C.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==C.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==C.Undefined&&D.next!==C.Undefined){const O=D.prev;O.next=D.next,D.next.prev=O}else D.prev===C.Undefined&&D.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):D.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):D.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==C.Undefined;)yield D.element,D=D.next}}e.LinkedList=c}),define(le[35],ue([0,1]),function(ne,e){"use strict";var C,c,T;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=D,e.mapToString=O,e.setToString=L,e.mapsStrictEqualIgnoreOrder=g;function D(s,r,t){let o=s.get(r);return o===void 0&&(o=t,s.set(r,o)),o}function O(s){const r=[];return s.forEach((t,o)=>{r.push(`${o} => ${t}`)}),`Map(${s.size}) {${r.join(", ")}}`}function L(s){const r=[];return s.forEach(t=>{r.push(t)}),`Set(${s.size}) {${r.join(", ")}}`}class _{constructor(r,t){this.uri=r,this.value=t}}function v(s){return Array.isArray(s)}class P{static{this.defaultToKey=r=>r.toString()}constructor(r,t){if(this[C]="ResourceMap",r instanceof P)this.map=new Map(r.map),this.toKey=t??P.defaultToKey;else if(v(r)){this.map=new Map,this.toKey=t??P.defaultToKey;for(const[o,i]of r)this.set(o,i)}else this.map=new Map,this.toKey=r??P.defaultToKey}set(r,t){return this.map.set(this.toKey(r),new _(r,t)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,t){typeof t<"u"&&(r=r.bind(t));for(const[o,i]of this.map)r(i.value,i.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=P;class p{constructor(r,t){this[c]="ResourceSet",!r||typeof r=="function"?this._map=new P(r):(this._map=new P(t),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,t){this._map.forEach((o,i)=>r.call(t,i,i,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var h;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class m{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,t=h.None){const o=this._map.get(r);if(o)return t!==h.None&&this.touch(o,t),o.value}set(r,t,o=h.None){let i=this._map.get(r);if(i)i.value=t,o!==h.None&&this.touch(i,o);else{switch(i={key:r,value:t,next:void 0,previous:void 0},o){case h.None:this.addItemLast(i);break;case h.AsOld:this.addItemFirst(i);break;case h.AsNew:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(r,i),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const t=this._map.get(r);if(t)return this._map.delete(r),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,t){const o=this._state;let i=this._head;for(;i;){if(t?r.bind(t)(i.value,i.key,this):r(i.value,i.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const r=this,t=this._state;let o=this._head;const i={[Symbol.iterator](){return i},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.key,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}values(){const r=this,t=this._state;let o=this._head;const i={[Symbol.iterator](){return i},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.value,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}entries(){const r=this,t=this._state;let o=this._head;const i={[Symbol.iterator](){return i},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:[o.key,o.value],done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return i}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this._head,o=this.size;for(;t&&o>r;)this._map.delete(t.key),t=t.next,o--;this._head=t,this._size=o,t&&(t.previous=void 0),this._state++}trimNew(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this._tail,o=this.size;for(;t&&o>r;)this._map.delete(t.key),t=t.previous,o--;this._tail=t,this._size=o,t&&(t.next=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const t=r.next,o=r.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}r.next=void 0,r.previous=void 0,this._state++}touch(r,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==h.AsOld&&t!==h.AsNew)){if(t===h.AsOld){if(r===this._head)return;const o=r.next,i=r.previous;r===this._tail?(i.next=void 0,this._tail=i):(o.previous=i,i.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(t===h.AsNew){if(r===this._tail)return;const o=r.next,i=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=i,i.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((t,o)=>{r.push([o,t])}),r}fromJSON(r){this.clear();for(const[t,o]of r)this.set(t,o)}}e.LinkedMap=m;class l extends m{constructor(r,t=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,t=h.AsNew){return super.get(r,t)}peek(r){return super.get(r,h.None)}set(r,t){return super.set(r,t,h.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class y extends l{constructor(r,t=1){super(r,t)}trim(r){this.trimOld(r)}set(r,t){return super.set(r,t),this.checkTrim(),this}}e.LRUCache=y;class w extends l{constructor(r,t=1){super(r,t)}trim(r){this.trimNew(r)}set(r,t){return this._limit<=this.size&&!this.has(r)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(r,t),this}}e.MRUCache=w;class f{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let t=this.map.get(r)||0;return t===0?!1:(t--,t===0?this.map.delete(r):this.map.set(r,t),!0)}has(r){return this.map.has(r)}}e.CounterSet=f;class S{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[t,o]of r)this.set(t,o)}clear(){this._m1.clear(),this._m2.clear()}set(r,t){this._m1.set(r,t),this._m2.set(t,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const t=this._m1.get(r);return t===void 0?!1:(this._m1.delete(r),this._m2.delete(t),!0)}forEach(r,t){this._m1.forEach((o,i)=>{r.call(t,o,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=S;class R{constructor(){this.map=new Map}add(r,t){let o=this.map.get(r);o||(o=new Set,this.map.set(r,o)),o.add(t)}delete(r,t){const o=this.map.get(r);o&&(o.delete(t),o.size===0&&this.map.delete(r))}forEach(r,t){const o=this.map.get(r);o&&o.forEach(t)}get(r){const t=this.map.get(r);return t||new Set}}e.SetMap=R;function g(s,r){if(s===r)return!0;if(s.size!==r.size)return!1;for(const[t,o]of s)if(!r.has(t)||r.get(t)!==o)return!1;for(const[t]of r)if(!s.has(t))return!1;return!0}}),define(le[2],ue([0,1,19,131,35,89,64]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=P,e.trackDisposable=p,e.markAsDisposed=h,e.markAsSingleton=y,e.isDisposable=w,e.dispose=f,e.disposeIfDisposable=S,e.combinedDisposable=R,e.toDisposable=g,e.disposeOnReturn=b;const L=!1;let _=null;class v{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(E){let k=this.livingDisposables.get(E);return k||(k={parent:null,source:null,isSingleton:!1,value:E,idx:v.idx++},this.livingDisposables.set(E,k)),k}trackDisposable(E){const k=this.getDisposableData(E);k.source||(k.source=new Error().stack)}setParent(E,k){const F=this.getDisposableData(E);F.parent=k}markAsDisposed(E){this.livingDisposables.delete(E)}markAsSingleton(E){this.getDisposableData(E).isSingleton=!0}getRootParent(E,k){const F=k.get(E);if(F)return F;const U=E.parent?this.getRootParent(this.getDisposableData(E.parent),k):E;return k.set(E,U),U}getTrackedDisposables(){const E=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,E).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(E=10,k){let F;if(k)F=k;else{const Z=new Map,V=[...this.livingDisposables.values()].filter(z=>z.source!==null&&!this.getRootParent(z,Z).isSingleton);if(V.length===0)return;const ie=new Set(V.map(z=>z.value));if(F=V.filter(z=>!(z.parent&&ie.has(z.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function U(Z){function V(z,q){for(;z.length>0&&q.some(te=>typeof te=="string"?te===z[0]:z[0].match(te));)z.shift()}const ie=Z.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return V(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new T.SetMap;for(const Z of F){const V=U(Z);for(let ie=0;ie<=V.length;ie++)M.add(V.slice(0,ie).join(`
`),Z)}F.sort((0,C.compareBy)(Z=>Z.idx,C.numberComparator));let H="",B=0;for(const Z of F.slice(0,E)){B++;const V=U(Z),ie=[];for(let z=0;z<V.length;z++){let q=V[z];q=`(shared with ${M.get(V.slice(0,z+1).join(`
`)).size}/${F.length} leaks) at ${q}`;const se=M.get(V.slice(0,z).join(`
`)),ce=(0,c.groupBy)([...se].map(W=>U(W)[z]),W=>W);delete ce[V[z]];for(const[W,Q]of Object.entries(ce))ie.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${W}`);ie.unshift(q)}H+=`


==================== Leaking disposable ${B}/${F.length}: ${Z.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>E&&(H+=`


... and ${F.length-E} more leaking disposables

`),{leaks:F,details:H}}}e.DisposableTracker=v;function P(I){_=I}if(L){const I="__is_disposable_tracked__";P(new class{trackDisposable(E){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[I]||console.log(k)},3e3)}setParent(E,k){if(E&&E!==r.None)try{E[I]=!0}catch{}}markAsDisposed(E){if(E&&E!==r.None)try{E[I]=!0}catch{}}markAsSingleton(E){}})}function p(I){return _?.trackDisposable(I),I}function h(I){_?.markAsDisposed(I)}function m(I,E){_?.setParent(I,E)}function l(I,E){if(_)for(const k of I)_.setParent(k,E)}function y(I){return _?.markAsSingleton(I),I}function w(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function f(I){if(O.Iterable.is(I)){const E=[];for(const k of I)if(k)try{k.dispose()}catch(F){E.push(F)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function S(I){for(const E of I)w(E)&&E.dispose();return[]}function R(...I){const E=g(()=>f(I));return l(I,E),E}function g(I){const E=p({dispose:(0,D.createSingleCallFunction)(()=>{h(E),I()})});return E}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return m(E,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(E),E.dispose()}}deleteAndLeak(E){E&&this._toDispose.has(E)&&(this._toDispose.delete(E),m(E,null))}}e.DisposableStore=s;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,p(this),m(this._store,this)}dispose(){h(this),this._store.dispose()}_register(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(E)}}e.Disposable=r;class t{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(E){this._isDisposed||E===this._value||(this._value?.dispose(),E&&m(E,this),this._value=E)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const E=this._value;return this._value=void 0,E&&m(E,null),E}}e.MutableDisposable=t;class o{constructor(E){this._disposable=new t,this._isDisposed=!1,this._disposable.value=E}get value(){return this._disposable.value}set value(E){this._isDisposed||E===this._disposable.value||(this._disposable.value=E)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=o;class i{constructor(E){this._disposable=E,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(E){let k=E;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,h(this))},this}}e.SafeDisposable=n;class a{constructor(){this.references=new Map}acquire(E,...k){let F=this.references.get(E);F||(F={counter:0,object:this.createReferencedObject(E,...k)},this.references.set(E,F));const{object:U}=F,M=(0,D.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(E,F.object),this.references.delete(E))});return F.counter++,{object:U,dispose:M}}}e.ReferenceCollection=a;class u{constructor(E){this.referenceCollection=E}async acquire(E,...k){const F=this.referenceCollection.acquire(E,...k);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(U){throw F.dispose(),U}}}e.AsyncReferenceCollection=u;class d{constructor(E){this.object=E}dispose(){}}e.ImmortalReference=d;function b(I){const E=new s;try{I(E)}finally{E.dispose()}}class A{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(E){return this._store.has(E)}get size(){return this._store.size}get(E){return this._store.get(E)}set(E,k,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(E)?.dispose(),this._store.set(E,k)}deleteAndDispose(E){this._store.get(E)?.dispose(),this._store.delete(E)}deleteAndLeak(E){const k=this._store.get(E);return this._store.delete(E),k}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=A}),define(le[66],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var C;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(C||(e.MarshalledId=C={}))}),define(le[91],ue([0,1,35]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=T,e.normalizeNFD=O;const c=new C.LRUCache(1e4);function T(v){return _(v,"NFC",c)}const D=new C.LRUCache(1e4);function O(v){return _(v,"NFD",D)}const L=/[^\u0000-\u0080]/;function _(v,P,p){if(!v)return v;const h=p.get(v);if(h)return h;let m;return L.test(v)?m=v.normalize(P):m=v,p.set(v,m),m}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(P){return O(P).replace(v,"")}}()}),function(){function ne(T){const D=[];typeof T=="number"&&D.push("code/timeOrigin",T);function O(_){D.push(_,Date.now())}function L(){const _=[];for(let v=0;v<D.length;v+=2)_.push({name:D[v],startTime:D[v+1]});return _}return{mark:O,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const O of performance.getEntriesByType("mark"))D.push({name:O.name,startTime:Math.round(T+O.startTime)});return D}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function C(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=C(c))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var c in C)(typeof exports=="object"?exports:ne)[c]=C[c]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function C(c){if(e[c])return e[c].exports;var T=e[c]={i:c,l:!1,exports:{}};return ne[c].call(T.exports,T,T.exports,C),T.l=!0,T.exports}return C.m=ne,C.c=e,C.d=function(c,T,D){C.o(c,T)||Object.defineProperty(c,T,{enumerable:!0,get:D})},C.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},C.t=function(c,T){if(1&T&&(c=C(c)),8&T||4&T&&typeof c=="object"&&c&&c.__esModule)return c;var D=Object.create(null);if(C.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:c}),2&T&&typeof c!="string")for(var O in c)C.d(D,O,function(L){return c[L]}.bind(null,O));return D},C.n=function(c){var T=c&&c.__esModule?function(){return c.default}:function(){return c};return C.d(T,"a",T),T},C.o=function(c,T){return Object.prototype.hasOwnProperty.call(c,T)},C.p="",C(C.s=0)}([function(ne,e,C){(function(c){var T;e=ne.exports=Q,T=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],_=e.src=[],v=0,P=v++;_[P]="0|[1-9]\\d*";var p=v++;_[p]="[0-9]+";var h=v++;_[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=v++;_[m]="("+_[P]+")\\.("+_[P]+")\\.("+_[P]+")";var l=v++;_[l]="("+_[p]+")\\.("+_[p]+")\\.("+_[p]+")";var y=v++;_[y]="(?:"+_[P]+"|"+_[h]+")";var w=v++;_[w]="(?:"+_[p]+"|"+_[h]+")";var f=v++;_[f]="(?:-("+_[y]+"(?:\\."+_[y]+")*))";var S=v++;_[S]="(?:-?("+_[w]+"(?:\\."+_[w]+")*))";var R=v++;_[R]="[0-9A-Za-z-]+";var g=v++;_[g]="(?:\\+("+_[R]+"(?:\\."+_[R]+")*))";var s=v++,r="v?"+_[m]+_[f]+"?"+_[g]+"?";_[s]="^"+r+"$";var t="[v=\\s]*"+_[l]+_[S]+"?"+_[g]+"?",o=v++;_[o]="^"+t+"$";var i=v++;_[i]="((?:<|>)?=?)";var n=v++;_[n]=_[p]+"|x|X|\\*";var a=v++;_[a]=_[P]+"|x|X|\\*";var u=v++;_[u]="[v=\\s]*("+_[a]+")(?:\\.("+_[a]+")(?:\\.("+_[a]+")(?:"+_[f]+")?"+_[g]+"?)?)?";var d=v++;_[d]="[v=\\s]*("+_[n]+")(?:\\.("+_[n]+")(?:\\.("+_[n]+")(?:"+_[S]+")?"+_[g]+"?)?)?";var b=v++;_[b]="^"+_[i]+"\\s*"+_[u]+"$";var A=v++;_[A]="^"+_[i]+"\\s*"+_[d]+"$";var I=v++;_[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=v++;_[E]="(?:~>?)";var k=v++;_[k]="(\\s*)"+_[E]+"\\s+",L[k]=new RegExp(_[k],"g");var F=v++;_[F]="^"+_[E]+_[u]+"$";var U=v++;_[U]="^"+_[E]+_[d]+"$";var M=v++;_[M]="(?:\\^)";var H=v++;_[H]="(\\s*)"+_[M]+"\\s+",L[H]=new RegExp(_[H],"g");var B=v++;_[B]="^"+_[M]+_[u]+"$";var Z=v++;_[Z]="^"+_[M]+_[d]+"$";var V=v++;_[V]="^"+_[i]+"\\s*("+t+")$|^$";var ie=v++;_[ie]="^"+_[i]+"\\s*("+r+")$|^$";var z=v++;_[z]="(\\s*)"+_[i]+"\\s*("+t+"|"+_[u]+")",L[z]=new RegExp(_[z],"g");var q=v++;_[q]="^\\s*("+_[u]+")\\s+-\\s+("+_[u]+")\\s*$";var te=v++;_[te]="^\\s*("+_[d]+")\\s+-\\s+("+_[d]+")\\s*$";var se=v++;_[se]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)T(ce,_[ce]),L[ce]||(L[ce]=new RegExp(_[ce]));function W(ae,fe){if(ae instanceof Q)return ae;if(typeof ae!="string"||ae.length>D||!(fe?L[o]:L[s]).test(ae))return null;try{return new Q(ae,fe)}catch{return null}}function Q(ae,fe){if(ae instanceof Q){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof Q))return new Q(ae,fe);T("SemVer",ae,fe),this.loose=fe;var me=ae.trim().match(fe?L[o]:L[s]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Te=+Ce;if(Te>=0&&Te<O)return Te}return Ce}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=W,e.valid=function(ae,fe){var me=W(ae,fe);return me?me.version:null},e.clean=function(ae,fe){var me=W(ae.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(ae){return T("SemVer.compare",this.version,this.loose,ae),ae instanceof Q||(ae=new Q(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Q.prototype.compareMain=function(ae){return ae instanceof Q||(ae=new Q(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},Q.prototype.comparePre=function(ae){if(ae instanceof Q||(ae=new Q(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Ce=ae.prerelease[fe];if(T("prerelease compare",fe,me,Ce),me===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(me===void 0)return-1;if(me!==Ce)return j(me,Ce)}while(++fe)},Q.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,me,Ce){typeof me=="string"&&(Ce=me,me=void 0);try{return new Q(ae,me).inc(fe,Ce).version}catch{return null}},e.diff=function(ae,fe){if(x(ae,fe))return null;var me=W(ae),Ce=W(fe);if(me.prerelease.length||Ce.prerelease.length){for(var Te in me)if((Te==="major"||Te==="minor"||Te==="patch")&&me[Te]!==Ce[Te])return"pre"+Te;return"prerelease"}for(var Te in me)if((Te==="major"||Te==="minor"||Te==="patch")&&me[Te]!==Ce[Te])return Te},e.compareIdentifiers=j;var G=/^[0-9]+$/;function j(ae,fe){var me=G.test(ae),Ce=G.test(fe);return me&&Ce&&(ae=+ae,fe=+fe),me&&!Ce?-1:Ce&&!me?1:ae<fe?-1:ae>fe?1:0}function N(ae,fe,me){return new Q(ae,me).compare(new Q(fe,me))}function Y(ae,fe,me){return N(ae,fe,me)>0}function $(ae,fe,me){return N(ae,fe,me)<0}function x(ae,fe,me){return N(ae,fe,me)===0}function J(ae,fe,me){return N(ae,fe,me)!==0}function ee(ae,fe,me){return N(ae,fe,me)>=0}function K(ae,fe,me){return N(ae,fe,me)<=0}function oe(ae,fe,me,Ce){var Te;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Te=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Te=ae!==me;break;case"":case"=":case"==":Te=x(ae,me,Ce);break;case"!=":Te=J(ae,me,Ce);break;case">":Te=Y(ae,me,Ce);break;case">=":Te=ee(ae,me,Ce);break;case"<":Te=$(ae,me,Ce);break;case"<=":Te=K(ae,me,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Te}function he(ae,fe){if(ae instanceof he){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof he))return new he(ae,fe);T("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(ae,fe){return j(fe,ae)},e.major=function(ae,fe){return new Q(ae,fe).major},e.minor=function(ae,fe){return new Q(ae,fe).minor},e.patch=function(ae,fe){return new Q(ae,fe).patch},e.compare=N,e.compareLoose=function(ae,fe){return N(ae,fe,!0)},e.rcompare=function(ae,fe,me){return N(fe,ae,me)},e.sort=function(ae,fe){return ae.sort(function(me,Ce){return e.compare(me,Ce,fe)})},e.rsort=function(ae,fe){return ae.sort(function(me,Ce){return e.rcompare(me,Ce,fe)})},e.gt=Y,e.lt=$,e.eq=x,e.neq=J,e.gte=ee,e.lte=K,e.cmp=oe,e.Comparator=he;var ge={};function Se(ae,fe){if(ae instanceof Se)return ae.loose===fe?ae:new Se(ae.raw,fe);if(ae instanceof he)return new Se(ae.value,fe);if(!(this instanceof Se))return new Se(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function ve(ae,fe,me,Ce,Te,Fe,Oe,_e,Ne,We,je,Me,$e){return((fe=Pe(me)?"":Pe(Ce)?">="+me+".0.0":Pe(Te)?">="+me+"."+Ce+".0":">="+fe)+" "+(_e=Pe(Ne)?"":Pe(We)?"<"+(+Ne+1)+".0.0":Pe(je)?"<"+Ne+"."+(+We+1)+".0":Me?"<="+Ne+"."+We+"."+je+"-"+Me:"<="+_e)).trim()}function ye(ae,fe){for(var me=0;me<ae.length;me++)if(!ae[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<ae.length;me++)if(T(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Ce=ae[me].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function Ie(ae,fe,me){try{fe=new Se(fe,me)}catch{return!1}return fe.test(ae)}function be(ae,fe,me,Ce){var Te,Fe,Oe,_e,Ne;switch(ae=new Q(ae,Ce),fe=new Se(fe,Ce),me){case">":Te=Y,Fe=K,Oe=$,_e=">",Ne=">=";break;case"<":Te=$,Fe=ee,Oe=Y,_e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(ae,fe,Ce))return!1;for(var We=0;We<fe.set.length;++We){var je=fe.set[We],Me=null,$e=null;if(je.forEach(function(qe){qe.semver===ge&&(qe=new he(">=0.0.0")),Me=Me||qe,$e=$e||qe,Te(qe.semver,Me.semver,Ce)?Me=qe:Oe(qe.semver,$e.semver,Ce)&&($e=qe)}),Me.operator===_e||Me.operator===Ne||(!$e.operator||$e.operator===_e)&&Fe(ae,$e.semver)||$e.operator===Ne&&Oe(ae,$e.semver))return!1}return!0}he.prototype.parse=function(ae){var fe=this.loose?L[V]:L[ie],me=ae.match(fe);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Q(me[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(ae){return T("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new Q(ae,this.loose)),oe(ae,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ae,fe){if(!(ae instanceof he))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new Se(ae.value,fe),Ie(this.value,me,fe);if(ae.operator==="")return me=new Se(this.value,fe),Ie(ae.semver,me,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),_e=oe(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ne=oe(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Te||Fe&&Oe||_e||Ne},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),T("range",ae,fe);var me=fe?L[te]:L[q];ae=ae.replace(me,ve),T("hyphen replace",ae),ae=ae.replace(L[z],"$1$2$3"),T("comparator trim",ae,L[z]),ae=(ae=(ae=ae.replace(L[k],"$1~")).replace(L[H],"$1^")).split(/\s+/).join(" ");var Ce=fe?L[V]:L[ie],Te=ae.split(" ").map(function(Fe){return function(Oe,_e){return T("comp",Oe),Oe=function(Ne,We){return Ne.trim().split(/\s+/).map(function(je){return function(Me,$e){T("caret",Me,$e);var qe=$e?L[Z]:L[B];return Me.replace(qe,function(Be,Ae,re,de,pe){var Ee;return T("caret",Me,Be,Ae,re,de,pe),Pe(Ae)?Ee="":Pe(re)?Ee=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Pe(de)?Ee=Ae==="0"?">="+Ae+"."+re+".0 <"+Ae+"."+(+re+1)+".0":">="+Ae+"."+re+".0 <"+(+Ae+1)+".0.0":pe?(T("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ee=Ae==="0"?re==="0"?">="+Ae+"."+re+"."+de+pe+" <"+Ae+"."+re+"."+(+de+1):">="+Ae+"."+re+"."+de+pe+" <"+Ae+"."+(+re+1)+".0":">="+Ae+"."+re+"."+de+pe+" <"+(+Ae+1)+".0.0"):(T("no pr"),Ee=Ae==="0"?re==="0"?">="+Ae+"."+re+"."+de+" <"+Ae+"."+re+"."+(+de+1):">="+Ae+"."+re+"."+de+" <"+Ae+"."+(+re+1)+".0":">="+Ae+"."+re+"."+de+" <"+(+Ae+1)+".0.0"),T("caret return",Ee),Ee})}(je,We)}).join(" ")}(Oe,_e),T("caret",Oe),Oe=function(Ne,We){return Ne.trim().split(/\s+/).map(function(je){return function(Me,$e){var qe=$e?L[U]:L[F];return Me.replace(qe,function(Be,Ae,re,de,pe){var Ee;return T("tilde",Me,Be,Ae,re,de,pe),Pe(Ae)?Ee="":Pe(re)?Ee=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Pe(de)?Ee=">="+Ae+"."+re+".0 <"+Ae+"."+(+re+1)+".0":pe?(T("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ee=">="+Ae+"."+re+"."+de+pe+" <"+Ae+"."+(+re+1)+".0"):Ee=">="+Ae+"."+re+"."+de+" <"+Ae+"."+(+re+1)+".0",T("tilde return",Ee),Ee})}(je,We)}).join(" ")}(Oe,_e),T("tildes",Oe),Oe=function(Ne,We){return T("replaceXRanges",Ne,We),Ne.split(/\s+/).map(function(je){return function(Me,$e){Me=Me.trim();var qe=$e?L[A]:L[b];return Me.replace(qe,function(Be,Ae,re,de,pe,Ee){T("xRange",Me,Be,Ae,re,de,pe,Ee);var Le=Pe(re),ke=Le||Pe(de),xe=ke||Pe(pe);return Ae==="="&&xe&&(Ae=""),Le?Be=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&xe?(ke&&(de=0),xe&&(pe=0),Ae===">"?(Ae=">=",ke?(re=+re+1,de=0,pe=0):xe&&(de=+de+1,pe=0)):Ae==="<="&&(Ae="<",ke?re=+re+1:de=+de+1),Be=Ae+re+"."+de+"."+pe):ke?Be=">="+re+".0.0 <"+(+re+1)+".0.0":xe&&(Be=">="+re+"."+de+".0 <"+re+"."+(+de+1)+".0"),T("xRange return",Be),Be})}(je,We)}).join(" ")}(Oe,_e),T("xrange",Oe),Oe=function(Ne,We){return T("replaceStars",Ne,We),Ne.trim().replace(L[se],"")}(Oe,_e),T("stars",Oe),Oe}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Fe){return!!Fe.match(Ce)})),Te=Te.map(function(Fe){return new he(Fe,fe)})},Se.prototype.intersects=function(ae,fe){if(!(ae instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ce){return ae.set.some(function(Te){return Te.every(function(Fe){return Ce.intersects(Fe,fe)})})})})},e.toComparators=function(ae,fe){return new Se(ae,fe).set.map(function(me){return me.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Q(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ye(this.set[fe],ae))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(ae,fe,me){var Ce=null,Te=null;try{var Fe=new Se(fe,me)}catch{return null}return ae.forEach(function(Oe){Fe.test(Oe)&&(Ce&&Te.compare(Oe)!==-1||(Te=new Q(Ce=Oe,me)))}),Ce},e.minSatisfying=function(ae,fe,me){var Ce=null,Te=null;try{var Fe=new Se(fe,me)}catch{return null}return ae.forEach(function(Oe){Fe.test(Oe)&&(Ce&&Te.compare(Oe)!==1||(Te=new Q(Ce=Oe,me)))}),Ce},e.validRange=function(ae,fe){try{return new Se(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,me){return be(ae,fe,"<",me)},e.gtr=function(ae,fe,me){return be(ae,fe,">",me)},e.outside=be,e.prerelease=function(ae,fe){var me=W(ae,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,fe,me){return ae=new Se(ae,me),fe=new Se(fe,me),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof Q)return ae;if(typeof ae!="string")return null;var fe=ae.match(L[I]);return fe==null?null:W((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,C(1))},function(ne,e){var C,c,T=ne.exports={};function D(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function L(w){if(C===setTimeout)return setTimeout(w,0);if((C===D||!C)&&setTimeout)return C=setTimeout,setTimeout(w,0);try{return C(w,0)}catch{try{return C.call(null,w,0)}catch{return C.call(this,w,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:D}catch{C=D}try{c=typeof clearTimeout=="function"?clearTimeout:O}catch{c=O}})();var _,v=[],P=!1,p=-1;function h(){P&&_&&(P=!1,_.length?v=_.concat(v):p=-1,v.length&&m())}function m(){if(!P){var w=L(h);P=!0;for(var f=v.length;f;){for(_=v,v=[];++p<f;)_&&_[p].run();p=-1,f=v.length}_=null,P=!1,function(S){if(c===clearTimeout)return clearTimeout(S);if((c===O||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(S);try{c(S)}catch{try{return c.call(null,S)}catch{return c.call(this,S)}}}(w)}}function l(w,f){this.fun=w,this.array=f}function y(){}T.nextTick=function(w){var f=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)f[S-1]=arguments[S];v.push(new l(w,f)),v.length!==1||P||L(m)},l.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=y,T.addListener=y,T.once=y,T.off=y,T.removeListener=y,T.removeAllListeners=y,T.emit=y,T.prependListener=y,T.prependOnceListener=y,T.listeners=function(w){return[]},T.binding=function(w){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(w){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(le[133],ue([0,1]),function(ne,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class c{constructor(L,_,v){this.level=L,this.key=_,this.value=v,this.forward=[]}}const T=void 0;class D{constructor(L,_=2**16){this.comparator=L,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new c(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new c(this._maxLevel,T,T),this._size=0}has(L){return!!D._search(this,L,this.comparator)}get(L){return D._search(this,L,this.comparator)?.value}set(L,_){return D._insert(this,L,_,this.comparator)&&(this._size+=1),this}delete(L){const _=D._delete(this,L,this.comparator);return _&&(this._size-=1),_}forEach(L,_){let v=this._header.forward[0];for(;v;)L.call(_,v.value,v.key,this),v=v.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let L=this._header.forward[0];for(;L;)yield[L.key,L.value],L=L.forward[0]}*keys(){let L=this._header.forward[0];for(;L;)yield L.key,L=L.forward[0]}*values(){let L=this._header.forward[0];for(;L;)yield L.value,L=L.forward[0]}toString(){let L="[SkipList]:",_=this._header.forward[0];for(;_;)L+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return L}static _search(L,_,v){let P=L._header;for(let p=L._level-1;p>=0;p--)for(;P.forward[p]&&v(P.forward[p].key,_)<0;)P=P.forward[p];if(P=P.forward[0],P&&v(P.key,_)===0)return P}static _insert(L,_,v,P){const p=[];let h=L._header;for(let m=L._level-1;m>=0;m--){for(;h.forward[m]&&P(h.forward[m].key,_)<0;)h=h.forward[m];p[m]=h}if(h=h.forward[0],h&&P(h.key,_)===0)return h.value=v,!1;{const m=D._randomLevel(L);if(m>L._level){for(let l=L._level;l<m;l++)p[l]=L._header;L._level=m}h=new c(m,_,v);for(let l=0;l<m;l++)h.forward[l]=p[l].forward[l],p[l].forward[l]=h;return!0}}static _randomLevel(L,_=.5){let v=1;for(;Math.random()<_&&v<L._maxLevel;)v+=1;return v}static _delete(L,_,v){const P=[];let p=L._header;for(let h=L._level-1;h>=0;h--){for(;p.forward[h]&&v(p.forward[h].key,_)<0;)p=p.forward[h];P[h]=p}if(p=p.forward[0],!p||v(p.key,_)!==0)return!1;for(let h=0;h<L._level&&P[h].forward[h]===p;h++)P[h].forward[h]=p.forward[h];for(;L._level>0&&L._header.forward[L._level-1]===T;)L._level-=1;return!0}}e.SkipList=D}),define(le[55],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(D){return new c(D)}constructor(D){this._now=C&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=c}),define(le[3],ue([0,1,8,89,2,90,55]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=m;const L=!1,_=!1,v=!1;var P;(function(U){U.None=()=>T.Disposable.None;function M(ve){if(v){const{onDidAddListener:ye}=ve,Ie=y.create();let be=0;ve.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),ye?.()}}}function H(ve,ye){return W(ve,()=>{},0,void 0,!0,void 0,ye)}U.defer=H;function B(ve){return(ye,Ie=null,be)=>{let ae=!1,fe;return fe=ve(me=>{if(!ae)return fe?fe.dispose():ae=!0,ye.call(Ie,me)},null,be),ae&&fe.dispose(),fe}}U.once=B;function Z(ve,ye,Ie){return se((be,ae=null,fe)=>ve(me=>be.call(ae,ye(me)),null,fe),Ie)}U.map=Z;function V(ve,ye,Ie){return se((be,ae=null,fe)=>ve(me=>{ye(me),be.call(ae,me)},null,fe),Ie)}U.forEach=V;function ie(ve,ye,Ie){return se((be,ae=null,fe)=>ve(me=>ye(me)&&be.call(ae,me),null,fe),Ie)}U.filter=ie;function z(ve){return ve}U.signal=z;function q(...ve){return(ye,Ie=null,be)=>{const ae=(0,T.combinedDisposable)(...ve.map(fe=>fe(me=>ye.call(Ie,me))));return ce(ae,be)}}U.any=q;function te(ve,ye,Ie,be){let ae=Ie;return Z(ve,fe=>(ae=ye(ae,fe),ae),be)}U.reduce=te;function se(ve,ye){let Ie;const be={onWillAddFirstListener(){Ie=ve(ae.fire,ae)},onDidRemoveLastListener(){Ie?.dispose()}};ye||M(be);const ae=new t(be);return ye?.add(ae),ae.event}function ce(ve,ye){return ye instanceof Array?ye.push(ve):ye&&ye.add(ve),ve}function W(ve,ye,Ie=100,be=!1,ae=!1,fe,me){let Ce,Te,Fe,Oe=0,_e;const Ne={leakWarningThreshold:fe,onWillAddFirstListener(){Ce=ve(je=>{Oe++,Te=ye(Te,je),be&&!Fe&&(We.fire(Te),Te=void 0),_e=()=>{const Me=Te;Te=void 0,Fe=void 0,(!be||Oe>1)&&We.fire(Me),Oe=0},typeof Ie=="number"?(clearTimeout(Fe),Fe=setTimeout(_e,Ie)):Fe===void 0&&(Fe=0,queueMicrotask(_e))})},onWillRemoveListener(){ae&&Oe>0&&_e?.()},onDidRemoveLastListener(){_e=void 0,Ce.dispose()}};me||M(Ne);const We=new t(Ne);return me?.add(We),We.event}U.debounce=W;function Q(ve,ye=0,Ie){return U.debounce(ve,(be,ae)=>be?(be.push(ae),be):[ae],ye,void 0,!0,void 0,Ie)}U.accumulate=Q;function G(ve,ye=(be,ae)=>be===ae,Ie){let be=!0,ae;return ie(ve,fe=>{const me=be||!ye(fe,ae);return be=!1,ae=fe,me},Ie)}U.latch=G;function j(ve,ye,Ie){return[U.filter(ve,ye,Ie),U.filter(ve,be=>!ye(be),Ie)]}U.split=j;function N(ve,ye=!1,Ie=[],be){let ae=Ie.slice(),fe=ve(Te=>{ae?ae.push(Te):Ce.fire(Te)});be&&be.add(fe);const me=()=>{ae?.forEach(Te=>Ce.fire(Te)),ae=null},Ce=new t({onWillAddFirstListener(){fe||(fe=ve(Te=>Ce.fire(Te)),be&&be.add(fe))},onDidAddFirstListener(){ae&&(ye?setTimeout(me):me())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return be&&be.add(Ce),Ce.event}U.buffer=N;function Y(ve,ye){return(be,ae,fe)=>{const me=ye(new x);return ve(function(Ce){const Te=me.evaluate(Ce);Te!==$&&be.call(ae,Te)},void 0,fe)}}U.chain=Y;const $=Symbol("HaltChainable");class x{constructor(){this.steps=[]}map(ye){return this.steps.push(ye),this}forEach(ye){return this.steps.push(Ie=>(ye(Ie),Ie)),this}filter(ye){return this.steps.push(Ie=>ye(Ie)?Ie:$),this}reduce(ye,Ie){let be=Ie;return this.steps.push(ae=>(be=ye(be,ae),be)),this}latch(ye=(Ie,be)=>Ie===be){let Ie=!0,be;return this.steps.push(ae=>{const fe=Ie||!ye(ae,be);return Ie=!1,be=ae,fe?ae:$}),this}evaluate(ye){for(const Ie of this.steps)if(ye=Ie(ye),ye===$)break;return ye}}function J(ve,ye,Ie=be=>be){const be=(...Ce)=>me.fire(Ie(...Ce)),ae=()=>ve.on(ye,be),fe=()=>ve.removeListener(ye,be),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return me.event}U.fromNodeEventEmitter=J;function ee(ve,ye,Ie=be=>be){const be=(...Ce)=>me.fire(Ie(...Ce)),ae=()=>ve.addEventListener(ye,be),fe=()=>ve.removeEventListener(ye,be),me=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return me.event}U.fromDOMEventEmitter=ee;function K(ve){return new Promise(ye=>B(ve)(ye))}U.toPromise=K;function oe(ve){const ye=new t;return ve.then(Ie=>{ye.fire(Ie)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}U.fromPromise=oe;function he(ve,ye,Ie){return ye(Ie),ve(be=>ye(be))}U.runAndSubscribe=he;class ge{constructor(ye,Ie){this._observable=ye,this._counter=0,this._hasChanged=!1;const be={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Ie||M(be),this.emitter=new t(be),Ie&&Ie.add(this.emitter)}beginUpdate(ye){this._counter++}handlePossibleChange(ye){}handleChange(ye,Ie){this._hasChanged=!0}endUpdate(ye){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Se(ve,ye){return new ge(ve,ye).emitter.event}U.fromObservable=Se;function Pe(ve){return(ye,Ie,be)=>{let ae=0,fe=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(ve.reportChanges(),fe&&(fe=!1,ye.call(Ie)))},handlePossibleChange(){},handleChange(){fe=!0}};ve.addObserver(me),ve.reportChanges();const Ce={dispose(){ve.removeObserver(me)}};return be instanceof T.DisposableStore?be.add(Ce):Array.isArray(be)&&be.push(Ce),Ce}}U.fromObservableLight=Pe})(P||(e.Event=P={}));class p{static{this.all=new Set}static{this._idPool=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${p._idPool++}`,p.all.add(this)}start(M){this._stopWatch=new O.StopWatch,this.listenerCount=M}stop(){if(this._stopWatch){const M=this._stopWatch.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=p;let h=-1;function m(U){const M=h;return h=U,{dispose(){h=M}}}class l{static{this._idPool=1}constructor(M,H,B=(l._idPool++).toString(16).padStart(3,"0")){this._errorHandler=M,this.threshold=H,this.name=B,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(M,H){const B=this.threshold;if(B<=0||H<B)return;this._stacks||(this._stacks=new Map);const Z=this._stacks.get(M.value)||0;if(this._stacks.set(M.value,Z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=B*.5;const[V,ie]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${ie}):`;console.warn(z),console.warn(V);const q=new w(z,V);this._errorHandler(q)}return()=>{const V=this._stacks.get(M.value)||0;this._stacks.set(M.value,V-1)}}getMostFrequentStack(){if(!this._stacks)return;let M,H=0;for(const[B,Z]of this._stacks)(!M||H<Z)&&(M=[B,Z],H=Z);return M}}class y{static create(){const M=new Error;return new y(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w extends Error{constructor(M,H){super(M),this.name="ListenerLeakError",this.stack=H}}e.ListenerLeakError=w;class f extends Error{constructor(M,H){super(M),this.name="ListenerRefusalError",this.stack=H}}e.ListenerRefusalError=f;let S=0;class R{constructor(M){this.value=M,this.id=S++}}const g=2,s=(U,M)=>{if(U instanceof R)M(U);else for(let H=0;H<U.length;H++){const B=U[H];B&&M(B)}};let r;if(L){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),r=new FinalizationRegistry(M=>{typeof M=="string"&&U.push(M)})}class t{constructor(M){this._size=0,this._options=M,this._leakageMon=h>0||this._options?.leakWarningThreshold?new l(M?.onListenerError??C.onUnexpectedError,this._options?.leakWarningThreshold??h):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(_){const M=this._listeners;queueMicrotask(()=>{s(M,H=>H.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(M,H,B)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const q=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(q);const te=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],se=new f(`${q}. HINT: Stack shows most frequent listener (${te[1]}-times)`,te[0]);return(this._options?.onListenerError||C.onUnexpectedError)(se),T.Disposable.None}if(this._disposed)return T.Disposable.None;H&&(M=M.bind(H));const Z=new R(M);let V,ie;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Z.stack=y.create(),V=this._leakageMon.check(Z.stack,this._size+1)),_&&(Z.stack=ie??y.create()),this._listeners?this._listeners instanceof R?(this._deliveryQueue??=new i,this._listeners=[this._listeners,Z]):this._listeners.push(Z):(this._options?.onWillAddFirstListener?.(this),this._listeners=Z,this._options?.onDidAddFirstListener?.(this)),this._size++;const z=(0,T.toDisposable)(()=>{r?.unregister(z),V?.(),this._removeListener(Z)});if(B instanceof T.DisposableStore?B.add(z):Array.isArray(B)&&B.push(z),r){const q=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),te=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(q);r.register(z,te?.[2]??q,z)}return z},this._event}_removeListener(M){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const H=this._listeners,B=H.indexOf(M);if(B===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,H[B]=void 0;const Z=this._deliveryQueue.current===this;if(this._size*g<=H.length){let V=0;for(let ie=0;ie<H.length;ie++)H[ie]?H[V++]=H[ie]:Z&&(this._deliveryQueue.end--,V<this._deliveryQueue.i&&this._deliveryQueue.i--);H.length=V}}_deliver(M,H){if(!M)return;const B=this._options?.onListenerError||C.onUnexpectedError;if(!B){M.value(H);return}try{M.value(H)}catch(Z){B(Z)}}_deliverQueue(M){const H=M.current._listeners;for(;M.i<M.end;)this._deliver(H[M.i++],M.value);M.reset()}fire(M){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof R)this._deliver(this._listeners,M);else{const H=this._deliveryQueue;H.enqueue(this,M,this._listeners.length),this._deliverQueue(H)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=t;const o=()=>new i;e.createEventDeliveryQueue=o;class i{constructor(){this.i=-1,this.end=0}enqueue(M,H,B){this.i=0,this.end=B,this.current=M,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends t{async fireAsync(M,H,B){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList),s(this._listeners,Z=>this._asyncDeliveryQueue.push([Z.value,M]));this._asyncDeliveryQueue.size>0&&!H.isCancellationRequested;){const[Z,V]=this._asyncDeliveryQueue.shift(),ie=[],z={...V,token:H,waitUntil:q=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");B&&(q=B(q,Z)),ie.push(q)}};try{Z(z)}catch(q){(0,C.onUnexpectedError)(q);continue}Object.freeze(ie),await Promise.allSettled(ie).then(q=>{for(const te of q)te.status==="rejected"&&(0,C.onUnexpectedError)(te.reason)})}}}e.AsyncEmitter=n;class a extends t{get isPaused(){return this._isPaused!==0}constructor(M){super(M),this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=M?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const M=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(M))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(M){this._size&&(this._isPaused!==0?this._eventQueue.push(M):super.fire(M))}}e.PauseableEmitter=a;class u extends a{constructor(M){super(M),this._delay=M.delay??100}fire(M){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(M)}}e.DebounceEmitter=u;class d extends t{constructor(M){super(M),this._queuedEvents=[],this._mergeFn=M?.merge}fire(M){this.hasListeners()&&(this._queuedEvents.push(M),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(H=>super.fire(H)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new t({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(M){const H={event:M,listener:null};this.events.push(H),this.hasListeners&&this.hook(H);const B=()=>{this.hasListeners&&this.unhook(H);const Z=this.events.indexOf(H);this.events.splice(Z,1)};return(0,T.toDisposable)((0,c.createSingleCallFunction)(B))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(M=>this.hook(M))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(M=>this.unhook(M))}hook(M){M.listener=M.event(H=>this.emitter.fire(H))}unhook(M){M.listener?.dispose(),M.listener=null}dispose(){this.emitter.dispose();for(const M of this.events)M.listener?.dispose();this.events=[]}}e.EventMultiplexer=b;class A{constructor(M,H,B,Z){this._store=new T.DisposableStore;const V=this._store.add(new b),ie=this._store.add(new T.DisposableMap);function z(q){ie.set(q,V.add(Z(q)))}for(const q of M)z(q);this._store.add(H(q=>{z(q)})),this._store.add(B(q=>{ie.deleteAndDispose(q)})),this.event=V.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=A;class I{constructor(){this.data=[]}wrapEvent(M,H,B){return(Z,V,ie)=>M(z=>{const q=this.data[this.data.length-1];if(!H){q?q.buffers.push(()=>Z.call(V,z)):Z.call(V,z);return}const te=q;if(!te){Z.call(V,H(B,z));return}te.items??=[],te.items.push(z),te.buffers.length===0&&q.buffers.push(()=>{te.reducedResult??=B?te.items.reduce(H,B):te.items.reduce(H),Z.call(V,te.reducedResult)})},void 0,ie)}bufferEvents(M){const H={buffers:new Array};this.data.push(H);const B=M();return this.data.pop(),H.buffers.forEach(Z=>Z()),B}}e.EventBufferer=I;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new t({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(M){this.inputEvent=M,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=M(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E;class k{static const(M){return new F(M)}constructor(M){this._value=M,this._onDidChange=new t,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(M){M!==this._value&&(this._value=M,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=k;class F{constructor(M){this.value=M,this.onDidChange=P.None}}}),define(le[26],ue([0,1,3]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=L;const c=Object.freeze(function(_,v){const P=setTimeout(_.bind(v),0);return{dispose(){clearTimeout(P)}}});var T;(function(_){function v(P){return P===_.None||P===_.Cancelled||P instanceof D?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}_.isCancellationToken=v,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(T||(e.CancellationToken=T={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?c:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=T.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=O;function L(_){const v=new O;return _.add({dispose(){v.cancel()}}),v.token}}),define(le[134],ue([0,1,26]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=T;class c{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new C.CancellationTokenSource,v=this.task(_.token);return this.result={promise:v,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}e.Cache=c;function T(L){return L}class D{constructor(_,v){this.lastCache=void 0,this.lastArgKey=void 0,typeof _=="function"?(this._fn=_,this._computeKey=T):(this._fn=v,this._computeKey=_.getCacheKey)}get(_){const v=this._computeKey(_);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this._fn(_)),this.lastCache}}e.LRUCachedFunction=D;class O{get cachedValues(){return this._map}constructor(_,v){this._map=new Map,this._map2=new Map,typeof _=="function"?(this._fn=_,this._computeKey=T):(this._fn=v,this._computeKey=_.getCacheKey)}get(_){const v=this._computeKey(_);if(this._map2.has(v))return this._map2.get(v);const P=this._fn(_);return this._map.set(_,P),this._map2.set(v,P),P}}e.CachedFunction=O}),define(le[51],ue([0,1,8,2]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=T,e.isReadableStream=D,e.isReadableBufferedStream=O,e.newWriteableStream=L,e.consumeReadable=v,e.peekReadable=P,e.consumeStream=p,e.listenStream=h,e.peekStream=m,e.toStream=l,e.emptyStream=y,e.toReadable=w,e.transform=f,e.prefixedReadable=S,e.prefixedStream=R;function T(g){const s=g;return s?typeof s.read=="function":!1}function D(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}function O(g){const s=g;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function L(g,s){return new _(g,s)}class _{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const o=t.indexOf(r);o>=0&&t.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(g,s){const r=[];let t;for(;(t=g.read())!==null;)r.push(t);return s(r)}function P(g,s,r){const t=[];let o;for(;(o=g.read())!==null&&t.length<r;)t.push(o);return o===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return g.read()}}}function p(g,s){return new Promise((r,t)=>{const o=[];h(g,{onData:i=>{s&&o.push(i)},onError:i=>{s?t(i):r(void 0)},onEnd:()=>{r(s?s(o):void 0)}})})}function h(g,s,r){g.on("error",t=>{r?.isCancellationRequested||s.onError(t)}),g.on("end",()=>{r?.isCancellationRequested||s.onEnd()}),g.on("data",t=>{r?.isCancellationRequested||s.onData(t)})}function m(g,s){return new Promise((r,t)=>{const o=new c.DisposableStore,i=[],n=d=>{if(i.push(d),i.length>s)return o.dispose(),g.pause(),r({stream:g,buffer:i,ended:!1})},a=d=>(o.dispose(),t(d)),u=()=>(o.dispose(),r({stream:g,buffer:i,ended:!0}));o.add((0,c.toDisposable)(()=>g.removeListener("error",a))),g.on("error",a),o.add((0,c.toDisposable)(()=>g.removeListener("end",u))),g.on("end",u),o.add((0,c.toDisposable)(()=>g.removeListener("data",n))),g.on("data",n)})}function l(g,s){const r=L(s);return r.end(g),r}function y(){const g=L(()=>{throw new Error("not supported")});return g.end(),g}function w(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}function f(g,s,r){const t=L(r);return h(g,{onData:o=>t.write(s.data(o)),onError:o=>t.error(s.error?s.error(o):o),onEnd:()=>t.end()}),t}function S(g,s,r){let t=!1;return{read:()=>{const o=s.read();return t?o:(t=!0,o!==null?r([g,o]):g)}}}function R(g,s,r){let t=!1;const o=L(r);return h(s,{onData:i=>t?o.write(i):(t=!0,o.write(r([g,i]))),onError:i=>o.error(i),onEnd:()=>{t||(t=!0,o.write(g)),o.end()}}),o}});var Tt=this&&this.__createBinding||(Object.create?function(ne,e,C,c){c===void 0&&(c=C);var T=Object.getOwnPropertyDescriptor(e,C);(!T||("get"in T?!e.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return e[C]}}),Object.defineProperty(ne,c,T)}:function(ne,e,C,c){c===void 0&&(c=C),ne[c]=e[C]}),Lt=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),De=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var C in ne)C!=="default"&&Object.prototype.hasOwnProperty.call(ne,C)&&Tt(e,ne,C);return Lt(e,ne),e};define(le[15],ue([0,1,54,51]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=v,e.readUInt16LE=P,e.writeUInt16LE=p,e.readUInt32BE=h,e.writeUInt32BE=m,e.readUInt32LE=l,e.writeUInt32LE=y,e.readUInt8=w,e.writeUInt8=f,e.readableToBuffer=S,e.bufferToReadable=R,e.streamToBuffer=g,e.bufferedStreamToBuffer=s,e.bufferToStream=r,e.streamToBufferReadableStream=t,e.newWriteableBufferStream=o,e.prefixedBufferReadable=i,e.prefixedBufferStream=n,e.decodeBase64=a,e.encodeBase64=b,c=De(c);const T=typeof Buffer<"u",D=new C.Lazy(()=>new Uint8Array(256));let O,L;class _{static alloc(I){return T?new _(Buffer.allocUnsafe(I)):new _(new Uint8Array(I))}static wrap(I){return T&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new _(I)}static fromString(I,E){return!(E?.dontUseNodeBuffer||!1)&&T?new _(Buffer.from(I)):(O||(O=new TextEncoder),new _(O.encode(I)))}static fromByteArray(I){const E=_.alloc(I.length);for(let k=0,F=I.length;k<F;k++)E.buffer[k]=I[k];return E}static concat(I,E){if(typeof E>"u"){E=0;for(let U=0,M=I.length;U<M;U++)E+=I[U].byteLength}const k=_.alloc(E);let F=0;for(let U=0,M=I.length;U<M;U++){const H=I[U];k.set(H,F),F+=H.byteLength}return k}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=_.alloc(this.byteLength);return I.set(this),I}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(I,E){return new _(this.buffer.subarray(I,E))}set(I,E){if(I instanceof _)this.buffer.set(I.buffer,E);else if(I instanceof Uint8Array)this.buffer.set(I,E);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),E);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return h(this.buffer,I)}writeUInt32BE(I,E){m(this.buffer,I,E)}readUInt32LE(I){return l(this.buffer,I)}writeUInt32LE(I,E){y(this.buffer,I,E)}readUInt8(I){return w(this.buffer,I)}writeUInt8(I,E){f(this.buffer,I,E)}indexOf(I,E=0){return v(this.buffer,I instanceof _?I.buffer:I,E)}}e.VSBuffer=_;function v(A,I,E=0){const k=I.byteLength,F=A.byteLength;if(k===0)return 0;if(k===1)return A.indexOf(I[0]);if(k>F-E)return-1;const U=D.value;U.fill(I.length);for(let Z=0;Z<I.length;Z++)U[I[Z]]=I.length-Z-1;let M=E+I.length-1,H=M,B=-1;for(;M<F;)if(A[M]===I[H]){if(H===0){B=M;break}M--,H--}else M+=Math.max(I.length-H,U[A[M]]),H=I.length-1;return B}function P(A,I){return A[I+0]<<0>>>0|A[I+1]<<8>>>0}function p(A,I,E){A[E+0]=I&255,I=I>>>8,A[E+1]=I&255}function h(A,I){return A[I]*2**24+A[I+1]*2**16+A[I+2]*2**8+A[I+3]}function m(A,I,E){A[E+3]=I,I=I>>>8,A[E+2]=I,I=I>>>8,A[E+1]=I,I=I>>>8,A[E]=I}function l(A,I){return A[I+0]<<0>>>0|A[I+1]<<8>>>0|A[I+2]<<16>>>0|A[I+3]<<24>>>0}function y(A,I,E){A[E+0]=I&255,I=I>>>8,A[E+1]=I&255,I=I>>>8,A[E+2]=I&255,I=I>>>8,A[E+3]=I&255}function w(A,I){return A[I]}function f(A,I,E){A[E]=I}function S(A){return c.consumeReadable(A,I=>_.concat(I))}function R(A){return c.toReadable(A)}function g(A){return c.consumeStream(A,I=>_.concat(I))}async function s(A){return A.ended?_.concat(A.buffer):_.concat([...A.buffer,await g(A.stream)])}function r(A){return c.toStream(A,I=>_.concat(I))}function t(A){return c.transform(A,{data:I=>typeof I=="string"?_.fromString(I):_.wrap(I)},I=>_.concat(I))}function o(A){return c.newWriteableStream(I=>_.concat(I),A)}function i(A,I){return c.prefixedReadable(A,I,E=>_.concat(E))}function n(A,I){return c.prefixedStream(A,I,E=>_.concat(E))}function a(A){let I=0,E=0,k=0;const F=new Uint8Array(Math.floor(A.length/4*3)),U=H=>{switch(E){case 3:F[k++]=I|H,E=0;break;case 2:F[k++]=I|H>>>2,I=H<<6,E=3;break;case 1:F[k++]=I|H>>>4,I=H<<4,E=2;break;default:I=H<<2,E=1}};for(let H=0;H<A.length;H++){const B=A.charCodeAt(H);if(B>=65&&B<=90)U(B-65);else if(B>=97&&B<=122)U(B-97+26);else if(B>=48&&B<=57)U(B-48+52);else if(B===43||B===45)U(62);else if(B===47||B===95)U(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${A[H]}`)}}const M=k;for(;E>0;)U(0);return _.wrap(F).slice(0,M)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:A},I=!0,E=!1){const k=E?d:u;let F="";const U=A.byteLength%3;let M=0;for(;M<A.byteLength-U;M+=3){const H=A[M+0],B=A[M+1],Z=A[M+2];F+=k[H>>>2],F+=k[(H<<4|B>>>4)&63],F+=k[(B<<2|Z>>>6)&63],F+=k[Z&63]}if(U===1){const H=A[M+0];F+=k[H>>>2],F+=k[H<<4&63],I&&(F+="==")}else if(U===2){const H=A[M+0],B=A[M+1];F+=k[H>>>2],F+=k[(H<<4|B>>>4)&63],F+=k[B<<2&63],I&&(F+="=")}return F}}),define(le[135],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[13],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=C,e.isStringArray=c,e.isObject=T,e.isTypedArray=D,e.isNumber=O,e.isIterable=L,e.isBoolean=_,e.isUndefined=v,e.isDefined=P,e.isUndefinedOrNull=p,e.assertType=h,e.assertIsDefined=m,e.assertAllDefined=l,e.isEmptyObject=w,e.isFunction=f,e.areFunctions=S,e.validateConstraints=R,e.validateConstraint=g;function C(s){return typeof s=="string"}function c(s){return Array.isArray(s)&&s.every(r=>C(r))}function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function D(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}function O(s){return typeof s=="number"&&!isNaN(s)}function L(s){return!!s&&typeof s[Symbol.iterator]=="function"}function _(s){return s===!0||s===!1}function v(s){return typeof s>"u"}function P(s){return!p(s)}function p(s){return v(s)||s===null}function h(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(s){if(p(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l(...s){const r=[];for(let t=0;t<s.length;t++){const o=s[t];if(p(o))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);r.push(o)}return r}const y=Object.prototype.hasOwnProperty;function w(s){if(!T(s))return!1;for(const r in s)if(y.call(s,r))return!1;return!0}function f(s){return typeof s=="function"}function S(...s){return s.length>0&&s.every(f)}function R(s,r){const t=Math.min(s.length,r.length);for(let o=0;o<t;o++)g(s[o],r[o])}function g(s,r){if(C(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(s instanceof r)return}catch{}if(!p(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],ue([0,1,13]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=c,e.deepFreeze=T,e.cloneAndChange=O,e.mixin=_,e.equals=v,e.safeStringify=P,e.distinct=p,e.getCaseInsensitive=h,e.filter=m,e.getAllPropertyNames=l,e.getAllMethodNames=y,e.createProxyObject=w,e.mapValues=f;function c(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const R=Array.isArray(S)?[]:{};return Object.entries(S).forEach(([g,s])=>{R[g]=s&&typeof s=="object"?c(s):s}),R}function T(S){if(!S||typeof S!="object")return S;const R=[S];for(;R.length>0;){const g=R.shift();Object.freeze(g);for(const s in g)if(D.call(g,s)){const r=g[s];typeof r=="object"&&!Object.isFrozen(r)&&!(0,C.isTypedArray)(r)&&R.push(r)}}return S}const D=Object.prototype.hasOwnProperty;function O(S,R){return L(S,R,new Set)}function L(S,R,g){if((0,C.isUndefinedOrNull)(S))return S;const s=R(S);if(typeof s<"u")return s;if(Array.isArray(S)){const r=[];for(const t of S)r.push(L(t,R,g));return r}if((0,C.isObject)(S)){if(g.has(S))throw new Error("Cannot clone recursive data-structure");g.add(S);const r={};for(const t in S)D.call(S,t)&&(r[t]=L(S[t],R,g));return g.delete(S),r}return S}function _(S,R,g=!0){return(0,C.isObject)(S)?((0,C.isObject)(R)&&Object.keys(R).forEach(s=>{s in S?g&&((0,C.isObject)(S[s])&&(0,C.isObject)(R[s])?_(S[s],R[s],g):S[s]=R[s]):S[s]=R[s]}),S):R}function v(S,R){if(S===R)return!0;if(S==null||R===null||R===void 0||typeof S!=typeof R||typeof S!="object"||Array.isArray(S)!==Array.isArray(R))return!1;let g,s;if(Array.isArray(S)){if(S.length!==R.length)return!1;for(g=0;g<S.length;g++)if(!v(S[g],R[g]))return!1}else{const r=[];for(s in S)r.push(s);r.sort();const t=[];for(s in R)t.push(s);if(t.sort(),!v(r,t))return!1;for(g=0;g<r.length;g++)if(!v(S[r[g]],R[r[g]]))return!1}return!0}function P(S){const R=new Set;return JSON.stringify(S,(g,s)=>{if((0,C.isObject)(s)||Array.isArray(s)){if(R.has(s))return"[Circular]";R.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function p(S,R){const g=Object.create(null);return!S||!R||Object.keys(R).forEach(r=>{const t=S[r],o=R[r];v(t,o)||(g[r]=o)}),g}function h(S,R){const g=R.toLowerCase(),s=Object.keys(S).find(r=>r.toLowerCase()===g);return s?S[s]:S[R]}function m(S,R){const g=Object.create(null);for(const[s,r]of Object.entries(S))R(s,r)&&(g[s]=r);return g}function l(S){let R=[];for(;Object.prototype!==S;)R=R.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return R}function y(S){const R=[];for(const g of l(S))typeof S[g]=="function"&&R.push(g);return R}function w(S,R){const g=r=>function(){const t=Array.prototype.slice.call(arguments,0);return R(r,t)},s={};for(const r of S)s[r]=g(r);return s}function f(S,R){const g={};for(const[s,r]of Object.entries(S))g[s]=R(r,s);return g}}),define(le[136],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=c,e.toUint32=T;var C;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function c(D){return D<0?0:D>C.MAX_UINT_8?C.MAX_UINT_8:D|0}function T(D){return D<0?0:D>C.MAX_UINT_32?C.MAX_UINT_32:D|0}}),define(le[27],ue([0,1,134,39,54,136]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=O,e.format=_,e.format2=P,e.htmlAttributeEncodeValue=p,e.escape=h,e.escapeRegExpCharacters=m,e.count=l,e.truncate=y,e.truncateMiddle=w,e.trim=f,e.ltrim=S,e.rtrim=R,e.convertSimple2RegExpPattern=g,e.stripWildcards=s,e.createRegExp=r,e.regExpLeadsToEndlessLoop=t,e.splitLines=o,e.splitLinesIncludeSeparators=i,e.firstNonWhitespaceIndex=n,e.getLeadingWhitespace=a,e.lastNonWhitespaceIndex=u,e.replaceAsync=d,e.compare=b,e.compareSubstring=A,e.compareIgnoreCase=I,e.compareSubstringIgnoreCase=E,e.isAsciiDigit=k,e.isLowerAsciiLetter=F,e.isUpperAsciiLetter=U,e.equalsIgnoreCase=M,e.startsWithIgnoreCase=H,e.commonPrefixLength=B,e.commonSuffixLength=Z,e.isHighSurrogate=V,e.isLowSurrogate=ie,e.computeCodePoint=z,e.getNextCodePoint=q,e.nextCharLength=W,e.prevCharLength=Q,e.getCharContainingOffset=G,e.charCount=j,e.containsRTL=$,e.isBasicASCII=J,e.containsUnusualLineTerminators=ee,e.isFullWidthCharacter=K,e.isEmojiImprecise=oe,e.lcut=he,e.forAnsiStringParts=Se,e.removeAnsiEscapeCodes=Pe,e.removeAnsiEscapeCodesFromPrompt=ye,e.startsWithUTF8BOM=Ie,e.stripUTF8BOM=be,e.fuzzyContains=ae,e.containsUppercaseCharacter=fe,e.uppercaseFirstLetter=me,e.getNLines=Ce,e.singleLetterHash=Te,e.getGraphemeBreakType=Fe,e.getLeftDeleteOffset=je;function O(re){return!re||typeof re!="string"?!0:re.trim().length===0}const L=/{(\d+)}/g;function _(re,...de){return de.length===0?re:re.replace(L,function(pe,Ee){const Le=parseInt(Ee,10);return isNaN(Le)||Le<0||Le>=de.length?pe:de[Le]})}const v=/{([^}]+)}/g;function P(re,de){return Object.keys(de).length===0?re:re.replace(v,(pe,Ee)=>de[Ee]??pe)}function p(re){return re.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function h(re){return re.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function m(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(re,de){let pe=0,Ee=re.indexOf(de);for(;Ee!==-1;)pe++,Ee=re.indexOf(de,Ee+de.length);return pe}function y(re,de,pe="\u2026"){return re.length<=de?re:`${re.substr(0,de)}${pe}`}function w(re,de,pe="\u2026"){if(re.length<=de)return re;const Ee=Math.ceil(de/2)-pe.length/2,Le=Math.floor(de/2)-pe.length/2;return`${re.substr(0,Ee)}${pe}${re.substr(re.length-Le)}`}function f(re,de=" "){const pe=S(re,de);return R(pe,de)}function S(re,de){if(!re||!de)return re;const pe=de.length;if(pe===0||re.length===0)return re;let Ee=0;for(;re.indexOf(de,Ee)===Ee;)Ee=Ee+pe;return re.substring(Ee)}function R(re,de){if(!re||!de)return re;const pe=de.length,Ee=re.length;if(pe===0||Ee===0)return re;let Le=Ee,ke=-1;for(;ke=re.lastIndexOf(de,Le-1),!(ke===-1||ke+pe!==Le);){if(ke===0)return"";Le=ke}return re.substring(0,Le)}function g(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(re){return re.replace(/\*/g,"")}function r(re,de,pe={}){if(!re)throw new Error("Cannot create regex from empty string");de||(re=m(re)),pe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(re,Ee)}function t(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function o(re){return re.split(/\r\n|\r|\n/)}function i(re){const de=[],pe=re.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(pe.length/2);Ee++)de.push(pe[2*Ee]+(pe[2*Ee+1]??""));return de}function n(re){for(let de=0,pe=re.length;de<pe;de++){const Ee=re.charCodeAt(de);if(Ee!==c.CharCode.Space&&Ee!==c.CharCode.Tab)return de}return-1}function a(re,de=0,pe=re.length){for(let Ee=de;Ee<pe;Ee++){const Le=re.charCodeAt(Ee);if(Le!==c.CharCode.Space&&Le!==c.CharCode.Tab)return re.substring(de,Ee)}return re.substring(de,pe)}function u(re,de=re.length-1){for(let pe=de;pe>=0;pe--){const Ee=re.charCodeAt(pe);if(Ee!==c.CharCode.Space&&Ee!==c.CharCode.Tab)return pe}return-1}function d(re,de,pe){const Ee=[];let Le=0;for(const ke of re.matchAll(de)){if(Ee.push(re.slice(Le,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");Le=ke.index+ke[0].length,Ee.push(pe(ke[0],...ke.slice(1),ke.index,re,ke.groups))}return Ee.push(re.slice(Le)),Promise.all(Ee).then(ke=>ke.join(""))}function b(re,de){return re<de?-1:re>de?1:0}function A(re,de,pe=0,Ee=re.length,Le=0,ke=de.length){for(;pe<Ee&&Le<ke;pe++,Le++){const Ge=re.charCodeAt(pe),Ye=de.charCodeAt(Le);if(Ge<Ye)return-1;if(Ge>Ye)return 1}const xe=Ee-pe,Je=ke-Le;return xe<Je?-1:xe>Je?1:0}function I(re,de){return E(re,de,0,re.length,0,de.length)}function E(re,de,pe=0,Ee=re.length,Le=0,ke=de.length){for(;pe<Ee&&Le<ke;pe++,Le++){let Ge=re.charCodeAt(pe),Ye=de.charCodeAt(Le);if(Ge===Ye)continue;if(Ge>=128||Ye>=128)return A(re.toLowerCase(),de.toLowerCase(),pe,Ee,Le,ke);F(Ge)&&(Ge-=32),F(Ye)&&(Ye-=32);const ze=Ge-Ye;if(ze!==0)return ze}const xe=Ee-pe,Je=ke-Le;return xe<Je?-1:xe>Je?1:0}function k(re){return re>=c.CharCode.Digit0&&re<=c.CharCode.Digit9}function F(re){return re>=c.CharCode.a&&re<=c.CharCode.z}function U(re){return re>=c.CharCode.A&&re<=c.CharCode.Z}function M(re,de){return re.length===de.length&&E(re,de)===0}function H(re,de){const pe=de.length;return de.length>re.length?!1:E(re,de,0,pe)===0}function B(re,de){const pe=Math.min(re.length,de.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(re.charCodeAt(Ee)!==de.charCodeAt(Ee))return Ee;return pe}function Z(re,de){const pe=Math.min(re.length,de.length);let Ee;const Le=re.length-1,ke=de.length-1;for(Ee=0;Ee<pe;Ee++)if(re.charCodeAt(Le-Ee)!==de.charCodeAt(ke-Ee))return Ee;return pe}function V(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function z(re,de){return(re-55296<<10)+(de-56320)+65536}function q(re,de,pe){const Ee=re.charCodeAt(pe);if(V(Ee)&&pe+1<de){const Le=re.charCodeAt(pe+1);if(ie(Le))return z(Ee,Le)}return Ee}function te(re,de){const pe=re.charCodeAt(de-1);if(ie(pe)&&de>1){const Ee=re.charCodeAt(de-2);if(V(Ee))return z(Ee,pe)}return pe}class se{get offset(){return this._offset}constructor(de,pe=0){this._str=de,this._len=de.length,this._offset=pe}setOffset(de){this._offset=de}prevCodePoint(){const de=te(this._str,this._offset);return this._offset-=de>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}nextCodePoint(){const de=q(this._str,this._len,this._offset);return this._offset+=de>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=se;class ce{get offset(){return this._iterator.offset}constructor(de,pe=0){this._iterator=new se(de,pe)}nextGraphemeLength(){const de=Ne.getInstance(),pe=this._iterator,Ee=pe.offset;let Le=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ke=pe.offset,xe=de.getGraphemeBreakType(pe.nextCodePoint());if(Oe(Le,xe)){pe.setOffset(ke);break}Le=xe}return pe.offset-Ee}prevGraphemeLength(){const de=Ne.getInstance(),pe=this._iterator,Ee=pe.offset;let Le=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ke=pe.offset,xe=de.getGraphemeBreakType(pe.prevCodePoint());if(Oe(xe,Le)){pe.setOffset(ke);break}Le=xe}return Ee-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ce;function W(re,de){return new ce(re,de).nextGraphemeLength()}function Q(re,de){return new ce(re,de).prevGraphemeLength()}function G(re,de){de>0&&ie(re.charCodeAt(de))&&de--;const pe=de+W(re,de);return[pe-Q(re,pe),pe]}function j(re){const de=new ce(re);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let N;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(re){return N||(N=Y()),N.test(re)}const x=/^[\t\n\r\x20-\x7E]*$/;function J(re){return x.test(re)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}function K(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function oe(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function he(re,de,pe=""){const Ee=re.trimStart();if(Ee.length<de)return Ee;const Le=/\b/g;let ke=0;for(;Le.test(Ee)&&!(Ee.length-Le.lastIndex<de);)ke=Le.lastIndex,Le.lastIndex+=1;return ke===0?Ee:pe+Ee.substring(ke).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Se(re){let de=0;for(const pe of re.matchAll(ge))de!==pe.index&&(yield{isCode:!1,str:re.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==re.length&&(yield{isCode:!1,str:re.substring(de)})}function Pe(re){return re&&(re=re.replace(ge,"")),re}const ve=/\\\[.*?\\\]/g;function ye(re){return Pe(re).replace(ve,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(c.CharCode.UTF8_BOM);function Ie(re){return!!(re&&re.length>0&&re.charCodeAt(0)===c.CharCode.UTF8_BOM)}function be(re){return Ie(re)?re.substr(1):re}function ae(re,de){if(!re||!de||re.length<de.length)return!1;const pe=de.length,Ee=re.toLowerCase();let Le=0,ke=-1;for(;Le<pe;){const xe=Ee.indexOf(de[Le],ke+1);if(xe<0)return!1;ke=xe,Le++}return!0}function fe(re,de=!1){return re?(de&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Ce(re,de=1){if(de===0)return"";let pe=-1;do pe=re.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?re:(re[pe-1]==="\r"&&pe--,re.substr(0,pe))}function Te(re){const de=c.CharCode.Z-c.CharCode.A+1;return re=re%(2*de),re<de?String.fromCharCode(c.CharCode.a+re):String.fromCharCode(c.CharCode.A+re-de)}function Fe(re){return Ne.getInstance().getGraphemeBreakType(re)}function Oe(re,de){return re===_e.Other?de!==_e.Extend&&de!==_e.SpacingMark:re===_e.CR&&de===_e.LF?!1:re===_e.Control||re===_e.CR||re===_e.LF||de===_e.Control||de===_e.CR||de===_e.LF?!0:!(re===_e.L&&(de===_e.L||de===_e.V||de===_e.LV||de===_e.LVT)||(re===_e.LV||re===_e.V)&&(de===_e.V||de===_e.T)||(re===_e.LVT||re===_e.T)&&de===_e.T||de===_e.Extend||de===_e.ZWJ||de===_e.SpacingMark||re===_e.Prepend||re===_e.ZWJ&&de===_e.Extended_Pictographic||re===_e.Regional_Indicator&&de===_e.Regional_Indicator)}var _e;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(_e||(e.GraphemeBreakType=_e={}));class Ne{static{this._INSTANCE=null}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}constructor(){this._data=We()}getGraphemeBreakType(de){if(de<32)return de===c.CharCode.LineFeed?_e.LF:de===c.CharCode.CarriageReturn?_e.CR:_e.Control;if(de<127)return _e.Other;const pe=this._data,Ee=pe.length/3;let Le=1;for(;Le<=Ee;)if(de<pe[3*Le])Le=2*Le;else if(de>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return _e.Other}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(re,de){if(re===0)return 0;const pe=Me(re,de);if(pe!==void 0)return pe;const Ee=new se(de,re);return Ee.prevCodePoint(),Ee.offset}function Me(re,de){const pe=new se(de,re);let Ee=pe.prevCodePoint();for(;$e(Ee)||Ee===qe.emojiVariantSelector||Ee===qe.enclosingKeyCap;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!oe(Ee))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===qe.zwj&&(Le=pe.offset),Le}function $e(re){return 127995<=re&&re<=127999}var qe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class Be{static{this.ambiguousCharacterData=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new C.LRUCachedFunction({getCacheKey:JSON.stringify},de=>{function pe(ze){const Ze=new Map;for(let Xe=0;Xe<ze.length;Xe+=2)Ze.set(ze[Xe],ze[Xe+1]);return Ze}function Ee(ze,Ze){const Xe=new Map(ze);for(const[nt,at]of Ze)Xe.set(nt,at);return Xe}function Le(ze,Ze){if(!ze)return Ze;const Xe=new Map;for(const[nt,at]of ze)Ze.has(nt)&&Xe.set(nt,at);return Xe}const ke=this.ambiguousCharacterData.value;let xe=de.filter(ze=>!ze.startsWith("_")&&ze in ke);xe.length===0&&(xe=["_default"]);let Je;for(const ze of xe){const Ze=pe(ke[ze]);Je=Le(Je,Ze)}const Ge=pe(ke._common),Ye=Ee(Ge,Je);return new Be(Ye)})}static getInstance(de){return Be.cache.get(Array.from(de))}static{this._locales=new T.Lazy(()=>Object.keys(Be.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Be._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}containsAmbiguousCharacter(de){for(let pe=0;pe<de.length;pe++){const Ee=de.codePointAt(pe);if(typeof Ee=="number"&&this.isAmbiguous(Ee))return!0}return!1}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be;class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(de){return Ae.getData().has(de)}static containsInvisibleCharacter(de){for(let pe=0;pe<de.length;pe++){const Ee=de.codePointAt(pe);if(typeof Ee=="number"&&Ae.isInvisibleCharacter(Ee))return!0}return!1}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae}),define(le[56],ue([0,1,27]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=c,e.doHash=T,e.numberHash=D,e.stringHash=L,e.toHexString=y,C=De(C);function c(f){return T(f,0)}function T(f,S){switch(typeof f){case"object":return f===null?D(349,S):Array.isArray(f)?_(f,S):v(f,S);case"string":return L(f,S);case"boolean":return O(f,S);case"number":return D(f,S);case"undefined":return D(937,S);default:return D(617,S)}}function D(f,S){return(S<<5)-S+f|0}function O(f,S){return D(f?433:863,S)}function L(f,S){S=D(149417,S);for(let R=0,g=f.length;R<g;R++)S=D(f.charCodeAt(R),S);return S}function _(f,S){return S=D(104579,S),f.reduce((R,g)=>T(g,R),S)}function v(f,S){return S=D(181387,S),Object.keys(f).sort().reduce((R,g)=>(R=L(g,R),T(f[g],R)),S)}class P{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=T(S,this._value),this._value}}e.Hasher=P;var p;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function h(f,S,R=32){const g=R-S,s=~((1<<g)-1);return(f<<S|(s&f)>>>g)>>>0}function m(f,S=0,R=f.byteLength,g=0){for(let s=0;s<R;s++)f[S+s]=g}function l(f,S,R="0"){for(;f.length<S;)f=R+f;return f}function y(f,S=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(R=>R.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),S/4)}class w{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(p.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const R=S.length;if(R===0)return;const g=this._buff;let s=this._buffLen,r=this._leftoverHighSurrogate,t,o;for(r!==0?(t=r,o=-1,r=0):(t=S.charCodeAt(0),o=0);;){let i=t;if(C.isHighSurrogate(t))if(o+1<R){const n=S.charCodeAt(o+1);C.isLowSurrogate(n)?(o++,i=C.computeCodePoint(t,n)):i=p.UNICODE_REPLACEMENT}else{r=t;break}else C.isLowSurrogate(t)&&(i=p.UNICODE_REPLACEMENT);if(s=this._push(g,s,i),o++,o<R)t=S.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=r}_push(S,R,g){return g<128?S[R++]=g:g<2048?(S[R++]=192|(g&1984)>>>6,S[R++]=128|(g&63)>>>0):g<65536?(S[R++]=224|(g&61440)>>>12,S[R++]=128|(g&4032)>>>6,S[R++]=128|(g&63)>>>0):(S[R++]=240|(g&1835008)>>>18,S[R++]=128|(g&258048)>>>12,S[R++]=128|(g&4032)>>>6,S[R++]=128|(g&63)>>>0),R>=p.BLOCK_SIZE&&(this._step(),R-=p.BLOCK_SIZE,this._totalLen+=p.BLOCK_SIZE,S[0]=S[p.BLOCK_SIZE+0],S[1]=S[p.BLOCK_SIZE+1],S[2]=S[p.BLOCK_SIZE+2]),R}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,p.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,R=this._buffDV;for(let u=0;u<64;u+=4)S.setUint32(u,R.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)S.setUint32(u,h(S.getUint32(u-12,!1)^S.getUint32(u-32,!1)^S.getUint32(u-56,!1)^S.getUint32(u-64,!1),1),!1);let g=this._h0,s=this._h1,r=this._h2,t=this._h3,o=this._h4,i,n,a;for(let u=0;u<80;u++)u<20?(i=s&r|~s&t,n=1518500249):u<40?(i=s^r^t,n=1859775393):u<60?(i=s&r|s&t|r&t,n=2400959708):(i=s^r^t,n=3395469782),a=h(g,5)+i+o+n+S.getUint32(u*4,!1)&4294967295,o=t,t=r,r=h(s,30),s=g,g=a;this._h0=this._h0+g&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+t&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=w}),define(le[92],ue([0,1,27]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C=De(C);var c;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(c||(c={})),function(T){const D="error",O="warning",L="warn",_="info",v="ignore";function P(h){return h?C.equalsIgnoreCase(D,h)?T.Error:C.equalsIgnoreCase(O,h)||C.equalsIgnoreCase(L,h)?T.Warning:C.equalsIgnoreCase(_,h)?T.Info:T.Ignore:T.Ignore}T.fromValue=P;function p(h){switch(h){case T.Error:return D;case T.Warning:return O;case T.Info:return _;default:return v}}T.toString=p}(c||(c={})),e.default=c}),define(le[52],ue([0,1,19,39,27]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const y=l.charCodeAt(0),w=this._value.charCodeAt(this._pos);return y-w}value(){return this._value[this._pos]}}e.StringIterator=D;class O{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===c.CharCode.Period)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,T.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class L{constructor(l=!0,y=!0){this._splitOnBackslash=l,this._caseSensitive=y}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let y=l.length-1;y>=0;y--,this._valueLen--){const w=this._value.charCodeAt(y);if(!(w===c.CharCode.Slash||this._splitOnBackslash&&w===c.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const y=this._value.charCodeAt(this._to);if(y===c.CharCode.Slash||this._splitOnBackslash&&y===c.CharCode.Backslash)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,T.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var _;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(_||(_={}));class v{constructor(l,y){this._ignorePathCasing=l,this._ignoreQueryAndFragment=y,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(_.Scheme),this._value.authority&&this._states.push(_.Authority),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(_.Path)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(_.Query),this._value.fragment&&this._states.push(_.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===_.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===_.Scheme)return(0,T.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===_.Authority)return(0,T.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===_.Path)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===_.Query)return(0,T.compare)(l,this._value.query);if(this._states[this._stateIdx]===_.Fragment)return(0,T.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===_.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===_.Authority)return this._value.authority;if(this._states[this._stateIdx]===_.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===_.Query)return this._value.query;if(this._states[this._stateIdx]===_.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=v;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(p||(p={}));class h{static forUris(l=()=>!1,y=()=>!1){return new h(new v(l,y))}static forPaths(l=!1){return new h(new L(void 0,!l))}static forStrings(){return new h(new D)}static forConfigKeys(){return new h(new O)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,y){if(y){const w=y.slice(0);(0,C.shuffle)(w);for(const f of w)this.set(f,l)}else{const w=l.slice(0);(0,C.shuffle)(w);for(const f of w)this.set(f[0],f[1])}}set(l,y){const w=this._iter.reset(l);let f;this._root||(this._root=new P,this._root.segment=w.value());const S=[];for(f=this._root;;){const g=w.cmp(f.segment);if(g>0)f.left||(f.left=new P,f.left.segment=w.value()),S.push([p.Left,f]),f=f.left;else if(g<0)f.right||(f.right=new P,f.right.segment=w.value()),S.push([p.Right,f]),f=f.right;else if(w.hasNext())w.next(),f.mid||(f.mid=new P,f.mid.segment=w.value()),S.push([p.Mid,f]),f=f.mid;else break}const R=f.value;f.value=y,f.key=l;for(let g=S.length-1;g>=0;g--){const s=S[g][1];s.updateHeight();const r=s.balanceFactor();if(r<-1||r>1){const t=S[g][0],o=S[g+1][0];if(t===p.Right&&o===p.Right)S[g][1]=s.rotateLeft();else if(t===p.Left&&o===p.Left)S[g][1]=s.rotateRight();else if(t===p.Right&&o===p.Left)s.right=S[g+1][1]=S[g+1][1].rotateRight(),S[g][1]=s.rotateLeft();else if(t===p.Left&&o===p.Right)s.left=S[g+1][1]=S[g+1][1].rotateLeft(),S[g][1]=s.rotateRight();else throw new Error;if(g>0)switch(S[g-1][0]){case p.Left:S[g-1][1].left=S[g][1];break;case p.Right:S[g-1][1].right=S[g][1];break;case p.Mid:S[g-1][1].mid=S[g][1];break}else this._root=S[0][1]}}return R}get(l){return this._getNode(l)?.value}_getNode(l){const y=this._iter.reset(l);let w=this._root;for(;w;){const f=y.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(l){const y=this._getNode(l);return!(y?.value===void 0&&y?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,y){const w=this._iter.reset(l),f=[];let S=this._root;for(;S;){const R=w.cmp(S.segment);if(R>0)f.push([p.Left,S]),S=S.left;else if(R<0)f.push([p.Right,S]),S=S.right;else if(w.hasNext())w.next(),f.push([p.Mid,S]),S=S.mid;else break}if(S){if(y?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const R=this._min(S.right);if(R.key){const{key:g,value:s,segment:r}=R;this._delete(R.key,!1),S.key=g,S.value=s,S.segment=r}}else{const R=S.left??S.right;if(f.length>0){const[g,s]=f[f.length-1];switch(g){case p.Left:s.left=R;break;case p.Mid:s.mid=R;break;case p.Right:s.right=R;break}}else this._root=R}for(let R=f.length-1;R>=0;R--){const g=f[R][1];g.updateHeight();const s=g.balanceFactor();if(s>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),f[R][1]=g.rotateLeft()):s<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),f[R][1]=g.rotateRight()),R>0)switch(f[R-1][0]){case p.Left:f[R-1][1].left=f[R][1];break;case p.Right:f[R-1][1].right=f[R][1];break;case p.Mid:f[R-1][1].mid=f[R][1];break}else this._root=f[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const y=this._iter.reset(l);let w=this._root,f;for(;w;){const S=y.cmp(w.segment);if(S>0)w=w.left;else if(S<0)w=w.right;else if(y.hasNext())y.next(),f=w.value||f,w=w.mid;else break}return w&&w.value||f}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,y){const w=this._iter.reset(l);let f=this._root;for(;f;){const S=w.cmp(f.segment);if(S>0)f=f.left;else if(S<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else return f.mid?this._entries(f.mid):y?f.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[y,w]of this)l(w,y)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const y=[];return this._dfsEntries(l,y),y[Symbol.iterator]()}_dfsEntries(l,y){l&&(l.left&&this._dfsEntries(l.left,y),l.value&&y.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,y),l.right&&this._dfsEntries(l.right,y))}_isBalanced(){const l=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:l(y.left)&&l(y.right)};return l(this._root)}}e.TernarySearchTree=h}),define(le[32],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=c;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(T){return C.test(T)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(L){for(let _=0;_<L.length;_++)L[_]=Math.floor(Math.random()*256);return L};const D=new Uint8Array(16),O=[];for(let L=0;L<256;L++)O.push(L.toString(16).padStart(2,"0"));return function(){T(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,v="";return v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v+="-",v+=O[D[_++]],v+=O[D[_++]],v+="-",v+=O[D[_++]],v+=O[D[_++]],v+="-",v+=O[D[_++]],v+=O[D[_++]],v+="-",v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v+=O[D[_++]],v}}()}),define(le[137],ue([0,1,38]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=D;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(O){const L=O.replace(/\-/g,":").toLowerCase();return!c.has(L)}function D(){const O=(0,C.networkInterfaces)();for(const L in O){const _=O[L];if(_){for(const{mac:v}of _)if(T(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],ue([0,1,277,15]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class T extends C.Transform{constructor(O){if(super(),typeof O=="number")this.splitter=O,this.spitterLen=1;else{const L=Buffer.isBuffer(O)?O:Buffer.from(O);this.splitter=L.length===1?L[0]:L,this.spitterLen=L.length}}_transform(O,L,_){this.buffer?this.buffer=Buffer.concat([this.buffer,O]):this.buffer=O;let v=0;for(;v<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,v):(0,c.binaryIndexOf)(this.buffer,this.splitter,v);if(P===-1)break;this.push(this.buffer.slice(v,P+this.spitterLen)),v=P+this.spitterLen}this.buffer=v===this.buffer.length?void 0:this.buffer.slice(v),_()}_flush(O){this.buffer&&this.push(this.buffer),O()}}e.StreamSplitter=T}),define(le[139],ue([0,1,67]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=c,e.findFreePortFaster=D,C=De(C);function c(L,_,v,P=1){let p=!1;return new Promise(h=>{const m=setTimeout(()=>{if(!p)return p=!0,h(0)},v);T(L,_,P,l=>{if(!p)return p=!0,clearTimeout(m),h(l)})})}function T(L,_,v,P){if(_===0)return P(0);const p=new C.Socket;p.once("connect",()=>(O(p),T(L+v,_-1,v,P))),p.once("data",()=>{}),p.once("error",h=>(O(p),h.code!=="ECONNREFUSED"?T(L+v,_-1,v,P):P(L))),p.connect(L,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(L,_,v,P="127.0.0.1"){let p=!1,h,m=1;const l=C.createServer({pauseOnConnect:!0});function y(w,f){p||(p=!0,l.removeAllListeners(),l.close(),h&&clearTimeout(h),f(w))}return new Promise(w=>{h=setTimeout(()=>{y(0,w)},v),l.on("listening",()=>{y(L,w)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&m<_?(L++,m++,l.listen(L,P)):y(0,w)}),l.on("close",()=>{y(0,w)}),l.listen(L,P)})}function O(L){try{L.removeAllListeners("connect"),L.removeAllListeners("error"),L.end(),L.destroy(),L.unref()}catch(_){console.error(_)}}}),define(le[140],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=C;function C(c){return!!c.parentPort}}),define(le[141],ue([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[68],ue([0,1,141]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=v,e.getDurationString=P,e.toLocalISOString=p;const c=60,T=c*60,D=T*24,O=D*7,L=D*30,_=D*365;function v(h,m,l,y){typeof h!="number"&&(h=h.getTime());const w=Math.round((new Date().getTime()-h)/1e3);if(w<-30)return(0,C.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,C.localize)(1,null);let f;return w<c?(f=w,m?f===1?l?(0,C.localize)(2,null,f):(0,C.localize)(3,null,f):l?(0,C.localize)(4,null,f):(0,C.localize)(5,null,f):f===1?l?(0,C.localize)(6,null,f):(0,C.localize)(7,null,f):l?(0,C.localize)(8,null,f):(0,C.localize)(9,null,f)):w<T?(f=Math.floor(w/c),m?f===1?l?(0,C.localize)(10,null,f):(0,C.localize)(11,null,f):l?(0,C.localize)(12,null,f):(0,C.localize)(13,null,f):f===1?l?(0,C.localize)(14,null,f):(0,C.localize)(15,null,f):l?(0,C.localize)(16,null,f):(0,C.localize)(17,null,f)):w<D?(f=Math.floor(w/T),m?f===1?l?(0,C.localize)(18,null,f):(0,C.localize)(19,null,f):l?(0,C.localize)(20,null,f):(0,C.localize)(21,null,f):f===1?l?(0,C.localize)(22,null,f):(0,C.localize)(23,null,f):l?(0,C.localize)(24,null,f):(0,C.localize)(25,null,f)):w<O?(f=Math.floor(w/D),m?f===1?(0,C.localize)(26,null,f):(0,C.localize)(27,null,f):f===1?(0,C.localize)(28,null,f):(0,C.localize)(29,null,f)):w<L?(f=Math.floor(w/O),m?f===1?l?(0,C.localize)(30,null,f):(0,C.localize)(31,null,f):l?(0,C.localize)(32,null,f):(0,C.localize)(33,null,f):f===1?l?(0,C.localize)(34,null,f):(0,C.localize)(35,null,f):l?(0,C.localize)(36,null,f):(0,C.localize)(37,null,f)):w<_?(f=Math.floor(w/L),m?f===1?l?(0,C.localize)(38,null,f):(0,C.localize)(39,null,f):l?(0,C.localize)(40,null,f):(0,C.localize)(41,null,f):f===1?l?(0,C.localize)(42,null,f):(0,C.localize)(43,null,f):l?(0,C.localize)(44,null,f):(0,C.localize)(45,null,f)):(f=Math.floor(w/_),m?f===1?l?(0,C.localize)(46,null,f):(0,C.localize)(47,null,f):l?(0,C.localize)(48,null,f):(0,C.localize)(49,null,f):f===1?l?(0,C.localize)(50,null,f):(0,C.localize)(51,null,f):l?(0,C.localize)(52,null,f):(0,C.localize)(53,null,f))}function P(h,m){const l=Math.abs(h/1e3);return l<1?m?(0,C.localize)(54,null,h):(0,C.localize)(55,null,h):l<c?m?(0,C.localize)(56,null,Math.round(h)/1e3):(0,C.localize)(57,null,Math.round(h)/1e3):l<T?m?(0,C.localize)(58,null,Math.round(h/(1e3*c))):(0,C.localize)(59,null,Math.round(h/(1e3*c))):l<D?m?(0,C.localize)(60,null,Math.round(h/(1e3*T))):(0,C.localize)(61,null,Math.round(h/(1e3*T))):(0,C.localize)(62,null,Math.round(h/(1e3*D)))}function p(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],ue([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[41],ue([0,1,19,13,142]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=_,e.isErrorWithActions=v,e.createErrorWithActions=P,C=De(C),c=De(c),T=De(T);function D(p,h){return h&&(p.stack||p.stacktrace)?T.localize(0,null,L(p),O(p.stack)||O(p.stacktrace)):L(p)}function O(p){return Array.isArray(p)?p.join(`
`):p}function L(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?T.localize(1,null,p.message):p.message||T.localize(2,null)}function _(p=null,h=!1){if(!p)return T.localize(3,null);if(Array.isArray(p)){const m=C.coalesce(p),l=_(m[0],h);return m.length>1?T.localize(4,null,l,m.length):l}if(c.isString(p))return p;if(p.detail){const m=p.detail;if(m.error)return D(m.error,h);if(m.exception)return D(m.exception,h)}return p.stack?D(p,h):p.message?p.message:T.localize(5,null)}function v(p){const h=p;return h instanceof Error&&Array.isArray(h.actions)}function P(p,h){let m;return typeof p=="string"?m=new Error(p):m=p,m.actions=h,m}}),define(le[143],ue([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],ue([0,1,143,34]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=T;function T(D){switch(D){case c.ParseErrorCode.InvalidSymbol:return(0,C.localize)(0,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,C.localize)(1,null);case c.ParseErrorCode.PropertyNameExpected:return(0,C.localize)(2,null);case c.ParseErrorCode.ValueExpected:return(0,C.localize)(3,null);case c.ParseErrorCode.ColonExpected:return(0,C.localize)(4,null);case c.ParseErrorCode.CommaExpected:return(0,C.localize)(5,null);case c.ParseErrorCode.CloseBraceExpected:return(0,C.localize)(6,null);case c.ParseErrorCode.CloseBracketExpected:return(0,C.localize)(7,null);case c.ParseErrorCode.EndOfFileExpected:return(0,C.localize)(8,null);default:return""}}}),define(le[145],ue([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,145]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=t,e.isLittleEndian=d,e.isBigSurOrNewer=b,C=De(C),e.LANGUAGE_DEFAULT="en";let c=!1,T=!1,D=!1,O=!1,L=!1,_=!1,v=!1,P=!1,p=!1,h=!1,m,l=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,w,f;const S=globalThis;let R;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?R=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(R=process);const g=typeof R?.versions?.electron=="string",s=g&&R?.type==="renderer";if(typeof R=="object"){c=R.platform==="win32",T=R.platform==="darwin",D=R.platform==="linux",O=D&&!!R.env.SNAP&&!!R.env.SNAP_REVISION,v=g,p=!!R.env.CI||!!R.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT;const A=R.env.VSCODE_NLS_CONFIG;if(A)try{const I=JSON.parse(A),E=I.availableLanguages["*"];m=I.locale,y=I.osLocale,l=E||e.LANGUAGE_DEFAULT,w=I._translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!s?(f=navigator.userAgent,c=f.indexOf("Windows")>=0,T=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=f.indexOf("Linux")>=0,h=f?.indexOf("Mobi")>=0,_=!0,m=C.getConfiguredDefaultLocale(C.localize(0,null))||e.LANGUAGE_DEFAULT,l=m,y=navigator.language):console.error("Unable to resolve platform.");var r;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(r||(e.Platform=r={}));function t(A){switch(A){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let o=r.Web;T?o=r.Mac:c?o=r.Windows:D&&(o=r.Linux),e.isWindows=c,e.isMacintosh=T,e.isLinux=D,e.isLinuxSnap=O,e.isNative=L,e.isElectron=v,e.isWeb=_,e.isWebWorker=_&&typeof S.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?S.origin:void 0,e.isIOS=P,e.isMobile=h,e.isCI=p,e.platform=o,e.userAgent=f,e.language=l;var i;(function(A){function I(){return e.language}A.value=I;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}A.isDefaultVariant=E;function k(){return e.language==="en"}A.isDefault=k})(i||(e.Language=i={})),e.locale=m,e.platformLocale=y,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof S.postMessage=="function"&&!S.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const A=[];S.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let k=0,F=A.length;k<F;k++){const U=A[k];if(U.id===E.data.vscodeScheduleAsyncWork){A.splice(k,1),U.callback();return}}});let I=0;return E=>{const k=++I;A.push({id:k,callback:E}),S.postMessage({vscodeScheduleAsyncWork:k},"*")}}return A=>setTimeout(A)})();var n;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=T||P?n.Macintosh:c?n.Windows:n.Linux;let a=!0,u=!1;function d(){if(!u){u=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,a=new Uint16Array(A.buffer)[0]===513}return a}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function b(A){return parseFloat(A)>=20}}),define(le[37],ue([0,1,5]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let c;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const D=T.process;c={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.platform=c.platform,e.arch=c.arch}),define(le[146],ue([0,1,37]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=O;var c;(function(L){L.UNKNOWN="UNKNOWN",L.CINNAMON="CINNAMON",L.DEEPIN="DEEPIN",L.GNOME="GNOME",L.KDE3="KDE3",L.KDE4="KDE4",L.KDE5="KDE5",L.KDE6="KDE6",L.PANTHEON="PANTHEON",L.UNITY="UNITY",L.XFCE="XFCE",L.UKUI="UKUI",L.LXQT="LXQT"})(c||(c={}));const T="XDG_CURRENT_DESKTOP",D="KDE_SESSION_VERSION";function O(){const L=C.env[T];if(L){const v=L.split(":").map(P=>P.trim()).filter(P=>P.length>0);for(const P of v)switch(P){case"Unity":{const p=C.env.DESKTOP_SESSION;return p&&p.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const p=C.env[D];return p==="5"?c.KDE5:p==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const _=C.env.DESKTOP_SESSION;if(_)switch(_){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return D in C.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in C.env?c.GNOME:"KDE_FULL_SESSION"in C.env?D in C.env?c.KDE4:c.KDE3:c.UNKNOWN}}),define(le[14],ue([0,1,37]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,C=De(C);const c=65,T=97,D=90,O=122,L=46,_=47,v=92,P=58,p=63;class h extends Error{constructor(t,o,i){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const a=t.indexOf(".")!==-1?"property":"argument";let u=`The "${t}" ${a} ${n} of type ${o}`;u+=`. Received type ${typeof i}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,t){if(r===null||typeof r!="object")throw new h(t,"Object",r)}function l(r,t){if(typeof r!="string")throw new h(t,"string",r)}const y=C.platform==="win32";function w(r){return r===_||r===v}function f(r){return r===_}function S(r){return r>=c&&r<=D||r>=T&&r<=O}function R(r,t,o,i){let n="",a=0,u=-1,d=0,b=0;for(let A=0;A<=r.length;++A){if(A<r.length)b=r.charCodeAt(A);else{if(i(b))break;b=_}if(i(b)){if(!(u===A-1||d===1))if(d===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==L||n.charCodeAt(n.length-2)!==L){if(n.length>2){const I=n.lastIndexOf(o);I===-1?(n="",a=0):(n=n.slice(0,I),a=n.length-1-n.lastIndexOf(o)),u=A,d=0;continue}else if(n.length!==0){n="",a=0,u=A,d=0;continue}}t&&(n+=n.length>0?`${o}..`:"..",a=2)}else n.length>0?n+=`${o}${r.slice(u+1,A)}`:n=r.slice(u+1,A),a=A-u-1;u=A,d=0}else b===L&&d!==-1?++d:d=-1}return n}function g(r,t){m(t,"pathObject");const o=t.dir||t.root,i=t.base||`${t.name||""}${t.ext||""}`;return o?o===t.root?`${o}${i}`:`${o}${r}${i}`:i}e.win32={resolve(...r){let t="",o="",i=!1;for(let n=r.length-1;n>=-1;n--){let a;if(n>=0){if(a=r[n],l(a,"path"),a.length===0)continue}else t.length===0?a=C.cwd():(a=C.env[`=${t}`]||C.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==t.toLowerCase()&&a.charCodeAt(2)===v)&&(a=`${t}\\`));const u=a.length;let d=0,b="",A=!1;const I=a.charCodeAt(0);if(u===1)w(I)&&(d=1,A=!0);else if(w(I))if(A=!0,w(a.charCodeAt(1))){let E=2,k=E;for(;E<u&&!w(a.charCodeAt(E));)E++;if(E<u&&E!==k){const F=a.slice(k,E);for(k=E;E<u&&w(a.charCodeAt(E));)E++;if(E<u&&E!==k){for(k=E;E<u&&!w(a.charCodeAt(E));)E++;(E===u||E!==k)&&(b=`\\\\${F}\\${a.slice(k,E)}`,d=E)}}}else d=1;else S(I)&&a.charCodeAt(1)===P&&(b=a.slice(0,2),d=2,u>2&&w(a.charCodeAt(2))&&(A=!0,d=3));if(b.length>0)if(t.length>0){if(b.toLowerCase()!==t.toLowerCase())continue}else t=b;if(i){if(t.length>0)break}else if(o=`${a.slice(d)}\\${o}`,i=A,A&&t.length>0)break}return o=R(o,!i,"\\",w),i?`${t}\\${o}`:`${t}${o}`||"."},normalize(r){l(r,"path");const t=r.length;if(t===0)return".";let o=0,i,n=!1;const a=r.charCodeAt(0);if(t===1)return f(a)?"\\":r;if(w(a))if(n=!0,w(r.charCodeAt(1))){let d=2,b=d;for(;d<t&&!w(r.charCodeAt(d));)d++;if(d<t&&d!==b){const A=r.slice(b,d);for(b=d;d<t&&w(r.charCodeAt(d));)d++;if(d<t&&d!==b){for(b=d;d<t&&!w(r.charCodeAt(d));)d++;if(d===t)return`\\\\${A}\\${r.slice(b)}\\`;d!==b&&(i=`\\\\${A}\\${r.slice(b,d)}`,o=d)}}}else o=1;else S(a)&&r.charCodeAt(1)===P&&(i=r.slice(0,2),o=2,t>2&&w(r.charCodeAt(2))&&(n=!0,o=3));let u=o<t?R(r.slice(o),!n,"\\",w):"";return u.length===0&&!n&&(u="."),u.length>0&&w(r.charCodeAt(t-1))&&(u+="\\"),i===void 0?n?`\\${u}`:u:n?`${i}\\${u}`:`${i}${u}`},isAbsolute(r){l(r,"path");const t=r.length;if(t===0)return!1;const o=r.charCodeAt(0);return w(o)||t>2&&S(o)&&r.charCodeAt(1)===P&&w(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let t,o;for(let a=0;a<r.length;++a){const u=r[a];l(u,"path"),u.length>0&&(t===void 0?t=o=u:t+=`\\${u}`)}if(t===void 0)return".";let i=!0,n=0;if(typeof o=="string"&&w(o.charCodeAt(0))){++n;const a=o.length;a>1&&w(o.charCodeAt(1))&&(++n,a>2&&(w(o.charCodeAt(2))?++n:i=!1))}if(i){for(;n<t.length&&w(t.charCodeAt(n));)n++;n>=2&&(t=`\\${t.slice(n)}`)}return e.win32.normalize(t)},relative(r,t){if(l(r,"from"),l(t,"to"),r===t)return"";const o=e.win32.resolve(r),i=e.win32.resolve(t);if(o===i||(r=o.toLowerCase(),t=i.toLowerCase(),r===t))return"";let n=0;for(;n<r.length&&r.charCodeAt(n)===v;)n++;let a=r.length;for(;a-1>n&&r.charCodeAt(a-1)===v;)a--;const u=a-n;let d=0;for(;d<t.length&&t.charCodeAt(d)===v;)d++;let b=t.length;for(;b-1>d&&t.charCodeAt(b-1)===v;)b--;const A=b-d,I=u<A?u:A;let E=-1,k=0;for(;k<I;k++){const U=r.charCodeAt(n+k);if(U!==t.charCodeAt(d+k))break;U===v&&(E=k)}if(k!==I){if(E===-1)return i}else{if(A>I){if(t.charCodeAt(d+k)===v)return i.slice(d+k+1);if(k===2)return i.slice(d+k)}u>I&&(r.charCodeAt(n+k)===v?E=k:k===2&&(E=3)),E===-1&&(E=0)}let F="";for(k=n+E+1;k<=a;++k)(k===a||r.charCodeAt(k)===v)&&(F+=F.length===0?"..":"\\..");return d+=E,F.length>0?`${F}${i.slice(d,b)}`:(i.charCodeAt(d)===v&&++d,i.slice(d,b))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const t=e.win32.resolve(r);if(t.length<=2)return r;if(t.charCodeAt(0)===v){if(t.charCodeAt(1)===v){const o=t.charCodeAt(2);if(o!==p&&o!==L)return`\\\\?\\UNC\\${t.slice(2)}`}}else if(S(t.charCodeAt(0))&&t.charCodeAt(1)===P&&t.charCodeAt(2)===v)return`\\\\?\\${t}`;return r},dirname(r){l(r,"path");const t=r.length;if(t===0)return".";let o=-1,i=0;const n=r.charCodeAt(0);if(t===1)return w(n)?r:".";if(w(n)){if(o=i=1,w(r.charCodeAt(1))){let d=2,b=d;for(;d<t&&!w(r.charCodeAt(d));)d++;if(d<t&&d!==b){for(b=d;d<t&&w(r.charCodeAt(d));)d++;if(d<t&&d!==b){for(b=d;d<t&&!w(r.charCodeAt(d));)d++;if(d===t)return r;d!==b&&(o=i=d+1)}}}}else S(n)&&r.charCodeAt(1)===P&&(o=t>2&&w(r.charCodeAt(2))?3:2,i=o);let a=-1,u=!0;for(let d=t-1;d>=i;--d)if(w(r.charCodeAt(d))){if(!u){a=d;break}}else u=!1;if(a===-1){if(o===-1)return".";a=o}return r.slice(0,a)},basename(r,t){t!==void 0&&l(t,"ext"),l(r,"path");let o=0,i=-1,n=!0,a;if(r.length>=2&&S(r.charCodeAt(0))&&r.charCodeAt(1)===P&&(o=2),t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let u=t.length-1,d=-1;for(a=r.length-1;a>=o;--a){const b=r.charCodeAt(a);if(w(b)){if(!n){o=a+1;break}}else d===-1&&(n=!1,d=a+1),u>=0&&(b===t.charCodeAt(u)?--u===-1&&(i=a):(u=-1,i=d))}return o===i?i=d:i===-1&&(i=r.length),r.slice(o,i)}for(a=r.length-1;a>=o;--a)if(w(r.charCodeAt(a))){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":r.slice(o,i)},extname(r){l(r,"path");let t=0,o=-1,i=0,n=-1,a=!0,u=0;r.length>=2&&r.charCodeAt(1)===P&&S(r.charCodeAt(0))&&(t=i=2);for(let d=r.length-1;d>=t;--d){const b=r.charCodeAt(d);if(w(b)){if(!a){i=d+1;break}continue}n===-1&&(a=!1,n=d+1),b===L?o===-1?o=d:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||n===-1||u===0||u===1&&o===n-1&&o===i+1?"":r.slice(o,n)},format:g.bind(null,"\\"),parse(r){l(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const o=r.length;let i=0,n=r.charCodeAt(0);if(o===1)return w(n)?(t.root=t.dir=r,t):(t.base=t.name=r,t);if(w(n)){if(i=1,w(r.charCodeAt(1))){let E=2,k=E;for(;E<o&&!w(r.charCodeAt(E));)E++;if(E<o&&E!==k){for(k=E;E<o&&w(r.charCodeAt(E));)E++;if(E<o&&E!==k){for(k=E;E<o&&!w(r.charCodeAt(E));)E++;E===o?i=E:E!==k&&(i=E+1)}}}}else if(S(n)&&r.charCodeAt(1)===P){if(o<=2)return t.root=t.dir=r,t;if(i=2,w(r.charCodeAt(2))){if(o===3)return t.root=t.dir=r,t;i=3}}i>0&&(t.root=r.slice(0,i));let a=-1,u=i,d=-1,b=!0,A=r.length-1,I=0;for(;A>=i;--A){if(n=r.charCodeAt(A),w(n)){if(!b){u=A+1;break}continue}d===-1&&(b=!1,d=A+1),n===L?a===-1?a=A:I!==1&&(I=1):a!==-1&&(I=-1)}return d!==-1&&(a===-1||I===0||I===1&&a===d-1&&a===u+1?t.base=t.name=r.slice(u,d):(t.name=r.slice(u,a),t.base=r.slice(u,d),t.ext=r.slice(a,d))),u>0&&u!==i?t.dir=r.slice(0,u-1):t.dir=t.root,t},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(y){const r=/\\/g;return()=>{const t=C.cwd().replace(r,"/");return t.slice(t.indexOf("/"))}}return()=>C.cwd()})();e.posix={resolve(...r){let t="",o=!1;for(let i=r.length-1;i>=-1&&!o;i--){const n=i>=0?r[i]:s();l(n,"path"),n.length!==0&&(t=`${n}/${t}`,o=n.charCodeAt(0)===_)}return t=R(t,!o,"/",f),o?`/${t}`:t.length>0?t:"."},normalize(r){if(l(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===_,o=r.charCodeAt(r.length-1)===_;return r=R(r,!t,"/",f),r.length===0?t?"/":o?"./":".":(o&&(r+="/"),t?`/${r}`:r)},isAbsolute(r){return l(r,"path"),r.length>0&&r.charCodeAt(0)===_},join(...r){if(r.length===0)return".";let t;for(let o=0;o<r.length;++o){const i=r[o];l(i,"path"),i.length>0&&(t===void 0?t=i:t+=`/${i}`)}return t===void 0?".":e.posix.normalize(t)},relative(r,t){if(l(r,"from"),l(t,"to"),r===t||(r=e.posix.resolve(r),t=e.posix.resolve(t),r===t))return"";const o=1,i=r.length,n=i-o,a=1,u=t.length-a,d=n<u?n:u;let b=-1,A=0;for(;A<d;A++){const E=r.charCodeAt(o+A);if(E!==t.charCodeAt(a+A))break;E===_&&(b=A)}if(A===d)if(u>d){if(t.charCodeAt(a+A)===_)return t.slice(a+A+1);if(A===0)return t.slice(a+A)}else n>d&&(r.charCodeAt(o+A)===_?b=A:A===0&&(b=0));let I="";for(A=o+b+1;A<=i;++A)(A===i||r.charCodeAt(A)===_)&&(I+=I.length===0?"..":"/..");return`${I}${t.slice(a+b)}`},toNamespacedPath(r){return r},dirname(r){if(l(r,"path"),r.length===0)return".";const t=r.charCodeAt(0)===_;let o=-1,i=!0;for(let n=r.length-1;n>=1;--n)if(r.charCodeAt(n)===_){if(!i){o=n;break}}else i=!1;return o===-1?t?"/":".":t&&o===1?"//":r.slice(0,o)},basename(r,t){t!==void 0&&l(t,"ext"),l(r,"path");let o=0,i=-1,n=!0,a;if(t!==void 0&&t.length>0&&t.length<=r.length){if(t===r)return"";let u=t.length-1,d=-1;for(a=r.length-1;a>=0;--a){const b=r.charCodeAt(a);if(b===_){if(!n){o=a+1;break}}else d===-1&&(n=!1,d=a+1),u>=0&&(b===t.charCodeAt(u)?--u===-1&&(i=a):(u=-1,i=d))}return o===i?i=d:i===-1&&(i=r.length),r.slice(o,i)}for(a=r.length-1;a>=0;--a)if(r.charCodeAt(a)===_){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":r.slice(o,i)},extname(r){l(r,"path");let t=-1,o=0,i=-1,n=!0,a=0;for(let u=r.length-1;u>=0;--u){const d=r.charCodeAt(u);if(d===_){if(!n){o=u+1;break}continue}i===-1&&(n=!1,i=u+1),d===L?t===-1?t=u:a!==1&&(a=1):t!==-1&&(a=-1)}return t===-1||i===-1||a===0||a===1&&t===i-1&&t===o+1?"":r.slice(t,i)},format:g.bind(null,"/"),parse(r){l(r,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return t;const o=r.charCodeAt(0)===_;let i;o?(t.root="/",i=1):i=0;let n=-1,a=0,u=-1,d=!0,b=r.length-1,A=0;for(;b>=i;--b){const I=r.charCodeAt(b);if(I===_){if(!d){a=b+1;break}continue}u===-1&&(d=!1,u=b+1),I===L?n===-1?n=b:A!==1&&(A=1):n!==-1&&(A=-1)}if(u!==-1){const I=a===0&&o?1:a;n===-1||A===0||A===1&&n===u-1&&n===a+1?t.base=t.name=r.slice(I,u):(t.name=r.slice(I,n),t.base=r.slice(I,u),t.ext=r.slice(n,u))}return a>0?t.dir=r.slice(0,a-1):o&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(le[42],ue([0,1,39,14,5,27,13]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=L,e.toSlashes=_,e.toPosixPath=v,e.getRoot=P,e.isUNC=p,e.isValidBasename=y,e.isEqual=w,e.isEqualOrParent=f,e.isWindowsDriveLetter=S,e.sanitizeFilePath=R,e.removeTrailingPathSeparator=g,e.isRootOrDriveLetter=s,e.hasDriveLetter=r,e.getDriveLetter=t,e.indexOfPath=o,e.parseLineAndColumnAware=i,e.randomPath=u;function L(d){return d===C.CharCode.Slash||d===C.CharCode.Backslash}function _(d){return d.replace(/[\\/]/g,c.posix.sep)}function v(d){return d.indexOf("/")===-1&&(d=_(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}function P(d,b=c.posix.sep){if(!d)return"";const A=d.length,I=d.charCodeAt(0);if(L(I)){if(L(d.charCodeAt(1))&&!L(d.charCodeAt(2))){let k=3;const F=k;for(;k<A&&!L(d.charCodeAt(k));k++);if(F!==k&&!L(d.charCodeAt(k+1))){for(k+=1;k<A;k++)if(L(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,b)}}return b}else if(S(I)&&d.charCodeAt(1)===C.CharCode.Colon)return L(d.charCodeAt(2))?d.slice(0,2)+b:d.slice(0,2);let E=d.indexOf("://");if(E!==-1){for(E+=3;E<A;E++)if(L(d.charCodeAt(E)))return d.slice(0,E+1)}return""}function p(d){if(!T.isWindows||!d||d.length<5)return!1;let b=d.charCodeAt(0);if(b!==C.CharCode.Backslash||(b=d.charCodeAt(1),b!==C.CharCode.Backslash))return!1;let A=2;const I=A;for(;A<d.length&&(b=d.charCodeAt(A),b!==C.CharCode.Backslash);A++);return!(I===A||(b=d.charCodeAt(A+1),isNaN(b)||b===C.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,m=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(d,b=T.isWindows){const A=b?h:m;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||b&&l.test(d)||d==="."||d===".."||b&&d[d.length-1]==="."||b&&d.length!==d.trim().length||d.length>255)}function w(d,b,A){const I=d===b;return!A||I?I:!d||!b?!1:(0,D.equalsIgnoreCase)(d,b)}function f(d,b,A,I=c.sep){if(d===b)return!0;if(!d||!b||b.length>d.length)return!1;if(A){if(!(0,D.startsWithIgnoreCase)(d,b))return!1;if(b.length===d.length)return!0;let k=b.length;return b.charAt(b.length-1)===I&&k--,d.charAt(k)===I}return b.charAt(b.length-1)!==I&&(b+=I),d.indexOf(b)===0}function S(d){return d>=C.CharCode.A&&d<=C.CharCode.Z||d>=C.CharCode.a&&d<=C.CharCode.z}function R(d,b){return T.isWindows&&d.endsWith(":")&&(d+=c.sep),(0,c.isAbsolute)(d)||(d=(0,c.join)(b,d)),d=(0,c.normalize)(d),g(d)}function g(d){return T.isWindows?(d=(0,D.rtrim)(d,c.sep),d.endsWith(":")&&(d+=c.sep)):(d=(0,D.rtrim)(d,c.sep),d||(d=c.sep)),d}function s(d){const b=(0,c.normalize)(d);return T.isWindows?d.length>3?!1:r(b)&&(d.length===2||b.charCodeAt(2)===C.CharCode.Backslash):b===c.posix.sep}function r(d,b=T.isWindows){return b?S(d.charCodeAt(0))&&d.charCodeAt(1)===C.CharCode.Colon:!1}function t(d,b=T.isWindows){return r(d,b)?d[0]:void 0}function o(d,b,A){return b.length>d.length?-1:d===b?0:(A&&(d=d.toLowerCase(),b=b.toLowerCase()),d.indexOf(b))}function i(d){const b=d.split(":");let A,I,E;for(const k of b){const F=Number(k);(0,O.isNumber)(F)?I===void 0?I=F:E===void 0&&(E=F):A=A?[A,k].join(":"):k}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(d,b,A=8){let I="";for(let k=0;k<A;k++){let F;k===0&&T.isWindows&&!b&&(A===3||A===4)?F=a:F=n,I+=F.charAt(Math.floor(Math.random()*F.length))}let E;return b?E=`${b}-${I}`:E=I,d?(0,c.join)(d,E):E}}),define(le[147],ue([0,1,14]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=D,e.getMediaMime=O,e.getExtensionForMimeType=L,e.normalizeMimeType=v,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(P){const p=(0,C.extname)(P),h=c[p.toLowerCase()];return h!==void 0?h:O(P)}function O(P){const p=(0,C.extname)(P);return T[p.toLowerCase()]}function L(P){for(const p in T)if(T[p]===P)return p}const _=/^(.+)\/(.+?)(;.+)?$/;function v(P,p){const h=_.exec(P);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:p?void 0:P}}),define(le[93],ue([0,1,5]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=D,e.removeDangerousEnvVariables=O;var c;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(c||(e.Source=c={}));var T;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function D(L,..._){const v=_.reduce((h,m)=>(h[m]=!0,h),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(h=>!v[h]).forEach(h=>{for(let m=0;m<P.length;m++)if(h.search(P[m])!==-1){delete L[h];break}})}function O(L){L&&(delete L.DEBUG,C.isMacintosh&&delete L.DYLD_LIBRARY_PATH,C.isLinux&&delete L.LD_PRELOAD)}}),define(le[9],ue([0,1,39,66,14,5]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=w,e.uriToFsPath=r,T=De(T);const O=/^\w[\w\d+.-]*$/,L=/^\//,_=/^\/\//;function v(a,u){if(!a.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!O.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!L.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(a,u){return!a&&!u?"file":a}function p(a,u){switch(a){case"https":case"http":case"file":u?u[0]!==m&&(u=m+u):u=m;break}return u}const h="",m="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(u){return u instanceof y?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,d,b,A,I,E=!1){typeof u=="object"?(this.scheme=u.scheme||h,this.authority=u.authority||h,this.path=u.path||h,this.query=u.query||h,this.fragment=u.fragment||h):(this.scheme=P(u,E),this.authority=d||h,this.path=p(this.scheme,b||h),this.query=A||h,this.fragment=I||h,v(this,E))}get fsPath(){return r(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:b,path:A,query:I,fragment:E}=u;return d===void 0?d=this.scheme:d===null&&(d=h),b===void 0?b=this.authority:b===null&&(b=h),A===void 0?A=this.path:A===null&&(A=h),I===void 0?I=this.query:I===null&&(I=h),E===void 0?E=this.fragment:E===null&&(E=h),d===this.scheme&&b===this.authority&&A===this.path&&I===this.query&&E===this.fragment?this:new S(d,b,A,I,E)}static parse(u,d=!1){const b=l.exec(u);return b?new S(b[2]||h,n(b[4]||h),n(b[5]||h),n(b[7]||h),n(b[9]||h),d):new S(h,h,h,h,h)}static file(u){let d=h;if(D.isWindows&&(u=u.replace(/\\/g,m)),u[0]===m&&u[1]===m){const b=u.indexOf(m,2);b===-1?(d=u.substring(2),u=m):(d=u.substring(2,b),u=u.substring(b)||m)}return new S("file",d,u,h,h)}static from(u,d){return new S(u.scheme,u.authority,u.path,u.query,u.fragment,d)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.isWindows&&u.scheme==="file"?b=y.file(T.win32.join(r(u,!0),...d)).path:b=T.posix.join(u.path,...d),u.with({path:b})}toString(u=!1){return t(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof y)return u;{const d=new S(u);return d._formatted=u.external??null,d._fsPath=u._sep===f?u.fsPath??null:null,d}}else return u}}e.URI=y;function w(a){return!a||typeof a!="object"?!1:typeof a.scheme=="string"&&(typeof a.authority=="string"||typeof a.authority>"u")&&(typeof a.path=="string"||typeof a.path>"u")&&(typeof a.query=="string"||typeof a.query>"u")&&(typeof a.fragment=="string"||typeof a.fragment>"u")}const f=D.isWindows?1:void 0;class S extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(u=!1){return u?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const u={$mid:c.MarshalledId.Uri};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=f),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const R={[C.CharCode.Colon]:"%3A",[C.CharCode.Slash]:"%2F",[C.CharCode.QuestionMark]:"%3F",[C.CharCode.Hash]:"%23",[C.CharCode.OpenSquareBracket]:"%5B",[C.CharCode.CloseSquareBracket]:"%5D",[C.CharCode.AtSign]:"%40",[C.CharCode.ExclamationMark]:"%21",[C.CharCode.DollarSign]:"%24",[C.CharCode.Ampersand]:"%26",[C.CharCode.SingleQuote]:"%27",[C.CharCode.OpenParen]:"%28",[C.CharCode.CloseParen]:"%29",[C.CharCode.Asterisk]:"%2A",[C.CharCode.Plus]:"%2B",[C.CharCode.Comma]:"%2C",[C.CharCode.Semicolon]:"%3B",[C.CharCode.Equals]:"%3D",[C.CharCode.Space]:"%20"};function g(a,u,d){let b,A=-1;for(let I=0;I<a.length;I++){const E=a.charCodeAt(I);if(E>=C.CharCode.a&&E<=C.CharCode.z||E>=C.CharCode.A&&E<=C.CharCode.Z||E>=C.CharCode.Digit0&&E<=C.CharCode.Digit9||E===C.CharCode.Dash||E===C.CharCode.Period||E===C.CharCode.Underline||E===C.CharCode.Tilde||u&&E===C.CharCode.Slash||d&&E===C.CharCode.OpenSquareBracket||d&&E===C.CharCode.CloseSquareBracket||d&&E===C.CharCode.Colon)A!==-1&&(b+=encodeURIComponent(a.substring(A,I)),A=-1),b!==void 0&&(b+=a.charAt(I));else{b===void 0&&(b=a.substr(0,I));const k=R[E];k!==void 0?(A!==-1&&(b+=encodeURIComponent(a.substring(A,I)),A=-1),b+=k):A===-1&&(A=I)}}return A!==-1&&(b+=encodeURIComponent(a.substring(A))),b!==void 0?b:a}function s(a){let u;for(let d=0;d<a.length;d++){const b=a.charCodeAt(d);b===C.CharCode.Hash||b===C.CharCode.QuestionMark?(u===void 0&&(u=a.substr(0,d)),u+=R[b]):u!==void 0&&(u+=a[d])}return u!==void 0?u:a}function r(a,u){let d;return a.authority&&a.path.length>1&&a.scheme==="file"?d=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===C.CharCode.Slash&&(a.path.charCodeAt(1)>=C.CharCode.A&&a.path.charCodeAt(1)<=C.CharCode.Z||a.path.charCodeAt(1)>=C.CharCode.a&&a.path.charCodeAt(1)<=C.CharCode.z)&&a.path.charCodeAt(2)===C.CharCode.Colon?u?d=a.path.substr(1):d=a.path[1].toLowerCase()+a.path.substr(2):d=a.path,D.isWindows&&(d=d.replace(/\//g,"\\")),d}function t(a,u){const d=u?s:g;let b="",{scheme:A,authority:I,path:E,query:k,fragment:F}=a;if(A&&(b+=A,b+=":"),(I||A==="file")&&(b+=m,b+=m),I){let U=I.indexOf("@");if(U!==-1){const M=I.substr(0,U);I=I.substr(U+1),U=M.lastIndexOf(":"),U===-1?b+=d(M,!1,!1):(b+=d(M.substr(0,U),!1,!1),b+=":",b+=d(M.substr(U+1),!1,!0)),b+="@"}I=I.toLowerCase(),U=I.lastIndexOf(":"),U===-1?b+=d(I,!1,!0):(b+=d(I.substr(0,U),!1,!0),b+=I.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===C.CharCode.Slash&&E.charCodeAt(2)===C.CharCode.Colon){const U=E.charCodeAt(1);U>=C.CharCode.A&&U<=C.CharCode.Z&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===C.CharCode.Colon){const U=E.charCodeAt(0);U>=C.CharCode.A&&U<=C.CharCode.Z&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}b+=d(E,!0,!1)}return k&&(b+="?",b+=d(k,!1,!1)),F&&(b+="#",b+=u?F:g(F,!1,!1)),b}function o(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+o(a.substr(3)):a}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(a){return a.match(i)?a.replace(i,u=>o(u)):a}}),define(le[148],ue([0,1,9]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=c,e.parse=T,e.getFirstFrame=D,e.log=L;function c(v){const P=v;return P&&typeof P.type=="string"&&typeof P.severity=="string"}function T(v){const P=[];let p;try{const h=JSON.parse(v.arguments),m=h[h.length-1];m&&m.__$stack&&(h.pop(),p=m.__$stack),P.push(...h)}catch{P.push("Unable to log remote console arguments",v.arguments)}return{args:P,stack:p}}function D(v){if(typeof v!="string")return D(T(v).stack);const P=v;if(P){const p=O(P),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function O(v){if(!v)return v;const P=v.indexOf(`
`);return P===-1?v:v.substring(0,P)}function L(v,P){const{args:p,stack:h}=T(v),m=typeof p[0]=="string"&&p.length===1;let l=O(h);l&&(l=`(${l.trim()})`);let y=[];if(typeof p[0]=="string"?l&&m?y=[`%c[${P}] %c${p[0]} %c${l}`,_("blue"),_(""),_("grey")]:y=[`%c[${P}] %c${p[0]}`,_("blue"),_(""),...p.slice(1)]:y=[`%c[${P}]%`,_("blue"),...p],l&&!m&&y.push(l),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,y)}function _(v){return`color: ${v}`}}),define(le[69],ue([0,1,15,9,66]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=D,e.parse=O,e.revive=_;function D(v){return JSON.stringify(v,L)}function O(v){let P=JSON.parse(v);return P=_(P),P}function L(v,P){return P instanceof RegExp?{$mid:T.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function _(v,P=0){if(!v||P>200)return v;if(typeof v=="object"){switch(v.$mid){case T.MarshalledId.Uri:return c.URI.revive(v);case T.MarshalledId.Regexp:return new RegExp(v.source,v.flags);case T.MarshalledId.Date:return new Date(v.source)}if(v instanceof C.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let p=0;p<v.length;++p)v[p]=_(v[p],P+1);else for(const p in v)Object.hasOwnProperty.call(v,p)&&(v[p]=_(v[p],P+1))}return v}}),define(le[23],ue([0,1,8,5,27,9,14]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=_,e.matchesSomeScheme=v,e.getServerRootPath=p,C=De(C),c=De(c),O=De(O);var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(L||(e.Schemas=L={}));function _(l,y){return D.URI.isUri(l)?(0,T.equalsIgnoreCase)(l.scheme,y):(0,T.startsWithIgnoreCase)(l,y+":")}function v(l,...y){return y.some(w=>_(l,w))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}setServerRootPath(y,w){this._serverRootPath=p(y,w)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return O.posix.join(this._serverRootPath,L.vscodeRemoteResource)}set(y,w,f){this._hosts[y]=w,this._ports[y]=f}setConnectionToken(y,w){this._connectionTokens[y]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)try{return this._delegate(y)}catch(s){return C.onUnexpectedError(s),y}const w=y.authority;let f=this._hosts[w];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const S=this._ports[w],R=this._connectionTokens[w];let g=`path=${encodeURIComponent(y.path)}`;return typeof R=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(R)}`),D.URI.from({scheme:c.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${f}:${S}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new P;function p(l,y){return O.posix.join(y??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class h{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(y){const w=this.toUri(y,ne);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===L.file&&(c.isNative||c.webWorkerOrigin===`${L.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?y.with({scheme:L.vscodeFileResource,authority:y.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(y){const w=this.toUri(y,ne);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===L.vscodeFileResource?y.with({scheme:L.file,authority:y.authority!==h.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(y,w){return D.URI.isUri(y)?y:D.URI.parse(w.toUrl(y))}}e.FileAccess=new h;var m;(function(l){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function f(R){let g;typeof R=="string"?g=new URL(R).searchParams:R instanceof URL?g=R.searchParams:D.URI.isUri(R)&&(g=new URL(R.toString(!0)).searchParams);const s=g?.get(w);if(s)return y.get(s)}l.getHeadersFromQuery=f;function S(R,g,s){if(!globalThis.crossOriginIsolated)return;const r=g&&s?"3":s?"2":"1";R instanceof URLSearchParams?R.set(w,r):R[w]=r}l.addSearchParam=S})(m||(e.COI=m={}))}),define(le[149],ue([0,1,129,23,5,9]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=P,T=De(T);class O{constructor(h,m,l){this.id=h,this.dependencies=m,this.callback=l}}class L{static{this.INSTANCE=new L}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(h,m,l)=>{typeof h!="string"&&(l=m,m=h,h=null),(typeof m!="object"||!Array.isArray(m))&&(l=m,m=null),this._defineCalls.push(new O(h,m,l))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this._initialize();const m=await(this._isWebWorker?this._workerLoadScript(h):this._isRenderer?this._rendererLoadScript(h):this._nodeJSLoadScript(h));if(!m)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}_rendererLoadScript(h){return new Promise((m,l)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const w=()=>{y.removeEventListener("load",f),y.removeEventListener("error",S)},f=R=>{w(),m(this._defineCalls.pop())},S=R=>{w(),l(R)};y.addEventListener("load",f),y.addEventListener("error",S),this._amdPolicy&&(h=this._amdPolicy.createScriptURL(h)),y.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(h){return new Promise((m,l)=>{try{this._amdPolicy&&(h=this._amdPolicy.createScriptURL(h)),importScripts(h),m(this._defineCalls.pop())}catch(y){l(y)}})}async _nodeJSLoadScript(h){try{const m=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,w=D.URI.parse(h).fsPath,f=m.readFileSync(w).toString(),S=y.wrap(f.replace(/^#!.*/,""));return new l.Script(S).runInThisContext().apply(),this._defineCalls.pop()}catch(m){throw m}}}const _=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function P(p,h,m){if(C.isESM){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[p]&&(p=v[p]);const l=`${p}/${h}`;if(_.has(l))return _.get(l);let y;if(/^\w[\w\d+.-]*:\/\//.test(l))y=l;else{const R=`${m&&!T.isWeb?c.nodeModulesAsarPath:c.nodeModulesPath}/${l}`;y=c.FileAccess.asBrowserUri(R).toString(!0)}const w=L.INSTANCE.load(y);return _.set(l,w),w}else return await new Promise((l,y)=>{ne([p],l,y)}).then(De)}}),define(le[21],ue([0,1,39,42,23,14,5,27,9]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=v,e.distinctParents=p,e.toLocalResource=m,c=De(c),D=De(D);function v(l){return(0,_.uriToFsPath)(l,!0)}class P{constructor(y){this._ignorePathCasing=y}compare(y,w,f=!1){return y===w?0:(0,L.compare)(this.getComparisonKey(y,f),this.getComparisonKey(w,f))}isEqual(y,w,f=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,f)===this.getComparisonKey(w,f)}getComparisonKey(y,w=!1){return y.with({path:this._ignorePathCasing(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this._ignorePathCasing(y)}isEqualOrParent(y,w,f=!1){if(y.scheme===w.scheme){if(y.scheme===T.Schemas.file)return c.isEqualOrParent(v(y),v(w),this._ignorePathCasing(y))&&y.query===w.query&&(f||y.fragment===w.fragment);if((0,e.isEqualAuthority)(y.authority,w.authority))return c.isEqualOrParent(y.path,w.path,this._ignorePathCasing(y),"/")&&y.query===w.query&&(f||y.fragment===w.fragment)}return!1}joinPath(y,...w){return _.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return D.posix.basename(y.path)}extname(y){return D.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===T.Schemas.file?w=_.URI.file(D.dirname(v(y))).path:(w=D.posix.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==C.CharCode.Slash&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===T.Schemas.file?w=_.URI.file(D.normalize(v(y))).path:w=D.posix.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.isEqualAuthority)(y.authority,w.authority))return;if(y.scheme===T.Schemas.file){const R=D.relative(v(y),v(w));return O.isWindows?c.toSlashes(R):R}let f=y.path||"/";const S=w.path||"/";if(this._ignorePathCasing(y)){let R=0;for(const g=Math.min(f.length,S.length);R<g&&!(f.charCodeAt(R)!==S.charCodeAt(R)&&f.charAt(R).toLowerCase()!==S.charAt(R).toLowerCase());R++);f=S.substr(0,R)+f.substr(R)}return D.posix.relative(f,S)}resolvePath(y,w){if(y.scheme===T.Schemas.file){const f=_.URI.file(D.resolve(v(y),w));return y.with({authority:f.authority,path:f.path})}return w=c.toPosixPath(w),y.with({path:D.posix.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,L.equalsIgnoreCase)(y,w)}hasTrailingPathSeparator(y,w=D.sep){if(y.scheme===T.Schemas.file){const f=v(y);return f.length>c.getRoot(f).length&&f[f.length-1]===w}else{const f=y.path;return f.length>1&&f.charCodeAt(f.length-1)===C.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=D.sep){return(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=D.sep){let f=!1;if(y.scheme===T.Schemas.file){const S=v(y);f=S!==void 0&&S.length===c.getRoot(S).length&&S[S.length-1]===w}else{w="/";const S=y.path;f=S.length===1&&S.charCodeAt(S.length-1)===C.CharCode.Slash}return!f&&!(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path+"/"}):y}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(l=>l.scheme===T.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new P(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(l,y){const w=[];for(let f=0;f<l.length;f++){const S=y(l[f]);l.some((R,g)=>g===f?!1:(0,e.isEqualOrParent)(S,y(R)))||w.push(l[f])}return w}var h;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function y(w){const f=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,r]=g.split(":");s&&r&&f.set(s,r)});const R=w.path.substring(0,w.path.indexOf(";"));return R&&f.set(l.META_DATA_MIME,R),f}l.parseMetaData=y})(h||(e.DataUri=h={}));function m(l,y,w){if(y){let f=l.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),l.with({scheme:w,authority:y,path:f})}return l.with({scheme:w})}}),define(le[6],ue([0,1,26,8,3,2,21,5,135,54]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=P,e.createCancelablePromise=p,e.raceCancellation=h,e.raceCancellationError=m,e.raceCancellablePromises=l,e.raceTimeout=y,e.asPromise=w,e.promiseWithResolvers=f,e.timeout=a,e.disposableTimeout=u,e.sequence=d,e.first=b,e.firstParallel=A,e.retry=q,e.createCancelableAsyncIterable=x;function P(ee){return!!ee&&typeof ee.then=="function"}function p(ee){const K=new C.CancellationTokenSource,oe=ee(K.token),he=new Promise((ge,Se)=>{const Pe=K.token.onCancellationRequested(()=>{Pe.dispose(),Se(new c.CancellationError)});Promise.resolve(oe).then(ve=>{Pe.dispose(),K.dispose(),ge(ve)},ve=>{Pe.dispose(),K.dispose(),Se(ve)})});return new class{cancel(){K.cancel(),K.dispose()}then(ge,Se){return he.then(ge,Se)}catch(ge){return this.then(void 0,ge)}finally(ge){return he.finally(ge)}}}function h(ee,K,oe){return new Promise((he,ge)=>{const Se=K.onCancellationRequested(()=>{Se.dispose(),he(oe)});ee.then(he,ge).finally(()=>Se.dispose())})}function m(ee,K){return new Promise((oe,he)=>{const ge=K.onCancellationRequested(()=>{ge.dispose(),he(new c.CancellationError)});ee.then(oe,he).finally(()=>ge.dispose())})}async function l(ee){let K=-1;const oe=ee.map((he,ge)=>he.then(Se=>(K=ge,Se)));try{return await Promise.race(oe)}finally{ee.forEach((he,ge)=>{ge!==K&&he.cancel()})}}function y(ee,K,oe){let he;const ge=setTimeout(()=>{he?.(void 0),oe?.()},K);return Promise.race([ee.finally(()=>clearTimeout(ge)),new Promise(Se=>he=Se)])}function w(ee){return new Promise((K,oe)=>{const he=ee();P(he)?he.then(K,oe):K(he)})}function f(){let ee,K;return{promise:new Promise((he,ge)=>{ee=he,K=ge}),resolve:ee,reject:K}}class S{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const oe=()=>{if(this.queuedPromise=null,this.isDisposed)return;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(oe,oe).then(he)})}return new Promise((oe,he)=>{this.queuedPromise.then(oe,he)})}return this.activePromise=K(),new Promise((oe,he)=>{this.activePromise.then(ge=>{this.activePromise=null,oe(ge)},ge=>{this.activePromise=null,he(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=S;class R{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=R;class g{constructor(){this.promiseMap=new Map}queue(K,oe){const ge=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(K)===ge&&this.promiseMap.delete(K)});return this.promiseMap.set(K,ge),ge}}e.SequencerByKey=g;const s=(ee,K)=>{let oe=!0;const he=setTimeout(()=>{oe=!1,K()},ee);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(he),oe=!1}}},r=ee=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ee())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class t{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,oe=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Se)=>{this.doResolve=ge,this.doReject=Se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===_.MicrotaskDelay?r(he):s(oe,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new c.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class o{constructor(K){this.delayer=new t(K),this.throttler=new S}trigger(K,oe){return this.delayer.trigger(()=>this.throttler.queue(K),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class i{constructor(){this._isOpen=!1,this._promise=new Promise((K,oe)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class n extends i{constructor(K){super(),this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function a(ee,K){return K?new Promise((oe,he)=>{const ge=setTimeout(()=>{Se.dispose(),oe()},ee),Se=K.onCancellationRequested(()=>{clearTimeout(ge),Se.dispose(),he(new c.CancellationError)})}):p(oe=>a(ee,oe))}function u(ee,K=0,oe){const he=setTimeout(()=>{ee(),oe&&ge.dispose()},K),ge=(0,D.toDisposable)(()=>{clearTimeout(he),oe?.deleteAndLeak(ge)});return oe?.add(ge),ge}function d(ee){const K=[];let oe=0;const he=ee.length;function ge(){return oe<he?ee[oe++]():null}function Se(Pe){Pe!=null&&K.push(Pe);const ve=ge();return ve?ve.then(Se):Promise.resolve(K)}return Promise.resolve(null).then(Se)}function b(ee,K=he=>!!he,oe=null){let he=0;const ge=ee.length,Se=()=>{if(he>=ge)return Promise.resolve(oe);const Pe=ee[he++];return Promise.resolve(Pe()).then(ye=>K(ye)?Promise.resolve(ye):Se())};return Se()}function A(ee,K=he=>!!he,oe=null){if(ee.length===0)return Promise.resolve(oe);let he=ee.length;const ge=()=>{he=-1;for(const Se of ee)Se.cancel?.()};return new Promise((Se,Pe)=>{for(const ve of ee)ve.then(ye=>{--he>=0&&K(ye)?(ge(),Se(ye)):he===0&&Se(oe)}).catch(ye=>{--he>=0&&(ge(),Pe(ye))})})}class I{constructor(K){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((oe,he)=>{this.outstandingPromises.push({factory:K,c:oe,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const oe=K.factory();oe.then(K.c,K.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=I;class E extends I{constructor(){super(1)}}e.Queue=E;class k{constructor(){this.sequentializer=new te,this.tasks=0}queue(K){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,K())):this.sequentializer.run(this.tasks++,K())}}e.LimitedQueue=k;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const K=new W;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueSize(K,oe=O.extUri){const he=oe.getComparisonKey(K);return this.queues.get(he)?.size??0}queueFor(K,oe,he=O.extUri){const ge=he.getComparisonKey(K);let Se=this.queues.get(ge);if(!Se){Se=new E;const Pe=this.drainListenerCount++,ve=T.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Pe),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new D.DisposableMap),this.drainListeners.set(Pe,ve),this.queues.set(ge,Se)}return Se.queue(oe)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class U{constructor(K,oe){this._isDisposed=!1,this._token=-1,typeof K=="function"&&typeof oe=="number"&&this.setIfNotSet(K,oe)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,oe){if(this._isDisposed)throw new c.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},oe)}setIfNotSet(K,oe){if(this._isDisposed)throw new c.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},oe))}}e.TimeoutTimer=U;class M{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(K,oe,he=globalThis){if(this.isDisposed)throw new c.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=he.setInterval(()=>{K()},oe);this.disposable=(0,D.toDisposable)(()=>{he.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=M;class H{constructor(K,oe){this.timeoutToken=-1,this.runner=K,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class B{constructor(K,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=B;class Z extends H{constructor(K,oe){super(K,oe),this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner?.(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Z;class V extends D.Disposable{constructor(K,oe){super(),this.options=K,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const oe of K)this.pendingWork.push(oe);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ee,K)=>{(0,L.setTimeout0)(()=>{if(oe)return;const he=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e._runWhenIdle=(ee,K,oe)=>{const he=ee.requestIdleCallback(K,typeof oe=="number"?{timeout:oe}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ee.cancelIdleCallback(he))}}},e.runWhenGlobalIdle=ee=>(0,e._runWhenIdle)(globalThis,ee)}();class ie{constructor(K,oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(K,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ie;class z extends ie{constructor(K){super(globalThis,K)}}e.GlobalIdleValue=z;async function q(ee,K,oe){let he;for(let ge=0;ge<oe;ge++)try{return await ee()}catch(Se){he=Se,await a(K)}throw he}class te{isRunning(K){return typeof K=="number"?this._running?.taskId===K:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(K,oe,he){return this._running={taskId:K,cancel:()=>he?.(),promise:oe},oe.then(()=>this.doneRunning(K),()=>this.doneRunning(K)),oe}doneRunning(K){this._running&&K===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const K=this._queued;this._queued=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this._queued)this._queued.run=K;else{const{promise:oe,resolve:he,reject:ge}=f();this._queued={run:K,promise:oe,promiseResolve:he,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class se{constructor(K,oe=()=>Date.now()){this.interval=K,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=se;var ce;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(ce||(ce={}));class W{get isRejected(){return this.outcome?.outcome===ce.Rejected}get isResolved(){return this.outcome?.outcome===ce.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ce.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((K,oe)=>{this.completeCallback=K,this.errorCallback=oe})}complete(K){return new Promise(oe=>{this.completeCallback(K),this.outcome={outcome:ce.Resolved,value:K},oe()})}error(K){return new Promise(oe=>{this.errorCallback(K),this.outcome={outcome:ce.Rejected,value:K},oe()})}cancel(){return this.error(new c.CancellationError)}}e.DeferredPromise=W;var Q;(function(ee){async function K(he){let ge;const Se=await Promise.all(he.map(Pe=>Pe.then(ve=>ve,ve=>{ge||(ge=ve)})));if(typeof ge<"u")throw ge;return Se}ee.settled=K;function oe(he){return new Promise(async(ge,Se)=>{try{await he(ge,Se)}catch(Pe){Se(Pe)}})}ee.withAsyncBody=oe})(Q||(e.Promises=Q={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(K){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=K.then(oe=>(this._value=oe,this._isResolved=!0,oe),oe=>{throw this._error=oe,this._isResolved=!0,oe})}requireValue(){if(!this._isResolved)throw new c.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class j{constructor(K){this._compute=K,this._promise=new v.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=j;var N;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(N||(N={}));class Y{static fromArray(K){return new Y(oe=>{oe.emitMany(K)})}static fromPromise(K){return new Y(async oe=>{oe.emitMany(await K)})}static fromPromises(K){return new Y(async oe=>{await Promise.all(K.map(async he=>oe.emitOne(await he)))})}static merge(K){return new Y(async oe=>{await Promise.all(K.map(async he=>{for await(const ge of he)oe.emitOne(ge)}))})}static{this.EMPTY=Y.fromArray([])}constructor(K,oe){this._state=N.Initial,this._results=[],this._error=null,this._onReturn=oe,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const he={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(K(he)),this.resolve()}catch(ge){this.reject(ge)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===N.DoneError)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===N.DoneOK)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(K,oe){return new Y(async he=>{for await(const ge of K)he.emitOne(oe(ge))})}map(K){return Y.map(this,K)}static filter(K,oe){return new Y(async he=>{for await(const ge of K)oe(ge)&&he.emitOne(ge)})}filter(K){return Y.filter(this,K)}static coalesce(K){return Y.filter(K,oe=>!!oe)}coalesce(){return Y.coalesce(this)}static async toPromise(K){const oe=[];for await(const he of K)oe.push(he);return oe}toPromise(){return Y.toPromise(this)}emitOne(K){this._state===N.Initial&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===N.Initial&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===N.Initial&&(this._state=N.DoneOK,this._onStateChanged.fire())}reject(K){this._state===N.Initial&&(this._state=N.DoneError,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=Y;class $ extends Y{constructor(K,oe){super(oe),this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=$;function x(ee){const K=new C.CancellationTokenSource,oe=ee(K.token);return new $(K,async he=>{const ge=K.token.onCancellationRequested(()=>{ge.dispose(),K.dispose(),he.reject(new c.CancellationError)});try{for await(const Se of oe){if(K.token.isCancellationRequested)return;he.emitOne(Se)}ge.dispose(),K.dispose()}catch(Se){ge.dispose(),K.dispose(),he.reject(Se)}})}class J{constructor(K){this._deferred=new W,this._asyncIterable=new Y(ge=>{if(oe){ge.reject(oe);return}return he&&ge.emitMany(he),this._errorFn=Se=>ge.reject(Se),this._emitFn=Se=>ge.emitOne(Se),this._deferred.p},K);let oe,he;this._emitFn=ge=>{he||(he=[]),he.push(ge)},this._errorFn=ge=>{oe||(oe=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(K){this._errorFn(K),this._deferred.complete()}emitOne(K){this._emitFn(K)}}e.AsyncIterableSource=J}),define(le[94],ue([0,1,19,6,39,42,35,14,5,27]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=P,e.splitGlobAware=y,e.match=k,e.parse=F,e.isRelativePattern=U,e.getBasenameTerms=M,e.getPathTerms=H,e.patternsEquals=ie;function P(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",h="[^/\\\\]",m=/\//g;function l(z,q){switch(z){case 0:return"";case 1:return`${h}*?`;default:return`(?:${p}|${h}+${p}${q?`|${p}${h}+`:""})*?`}}function y(z,q){if(!z)return[];const te=[];let se=!1,ce=!1,W="";for(const Q of z){switch(Q){case q:if(!se&&!ce){te.push(W),W="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}W+=Q}return W&&te.push(W),te}function w(z){if(!z)return"";let q="";const te=y(z,e.GLOB_SPLIT);if(te.every(se=>se===e.GLOBSTAR))q=".*";else{let se=!1;te.forEach((ce,W)=>{if(ce===e.GLOBSTAR){if(se)return;q+=l(2,W===te.length-1)}else{let Q=!1,G="",j=!1,N="";for(const Y of ce){if(Y!=="}"&&Q){G+=Y;continue}if(j&&(Y!=="]"||!N)){let $;Y==="-"?$=Y:(Y==="^"||Y==="!")&&!N?$="^":Y===e.GLOB_SPLIT?$="":$=(0,v.escapeRegExpCharacters)(Y),N+=$;continue}switch(Y){case"{":Q=!0;continue;case"[":j=!0;continue;case"}":{const x=`(?:${y(G,",").map(J=>w(J)).join("|")})`;q+=x,Q=!1,G="";break}case"]":{q+="["+N+"]",j=!1,N="";break}case"?":q+=h;continue;case"*":q+=l(1);continue;default:q+=(0,v.escapeRegExpCharacters)(Y)}}W<te.length-1&&(te[W+1]!==e.GLOBSTAR||W+2<te.length)&&(q+=p)}se=ce===e.GLOBSTAR})}return q}const f=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),o=function(){return!1},i=function(){return null};function n(z,q){if(!z)return i;let te;typeof z!="string"?te=z.pattern:te=z,te=te.trim();const se=`${te}_${!!q.trimForExclusions}`;let ce=t.get(se);if(ce)return a(ce,z);let W;return f.test(te)?ce=d(te.substr(4),te):(W=S.exec(u(te,q)))?ce=b(W[1],te):(q.trimForExclusions?g:R).test(te)?ce=A(te,q):(W=s.exec(u(te,q)))?ce=I(W[1].substr(1),te,!0):(W=r.exec(u(te,q)))?ce=I(W[1],te,!1):ce=E(te),t.set(se,ce),a(ce,z)}function a(z,q){if(typeof q=="string")return z;const te=function(se,ce){return(0,D.isEqualOrParent)(se,q.base,!_.isLinux)?z((0,v.ltrim)(se.substr(q.base.length),L.sep),ce):null};return te.allBasenames=z.allBasenames,te.allPaths=z.allPaths,te.basenames=z.basenames,te.patterns=z.patterns,te}function u(z,q){return q.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function d(z,q){return function(te,se){return typeof te=="string"&&te.endsWith(z)?q:null}}function b(z,q){const te=`/${z}`,se=`\\${z}`,ce=function(Q,G){return typeof Q!="string"?null:G?G===z?q:null:Q===z||Q.endsWith(te)||Q.endsWith(se)?q:null},W=[z];return ce.basenames=W,ce.patterns=[q],ce.allBasenames=W,ce}function A(z,q){const te=V(z.slice(1,-1).split(",").map(G=>n(G,q)).filter(G=>G!==i),z),se=te.length;if(!se)return i;if(se===1)return te[0];const ce=function(G,j){for(let N=0,Y=te.length;N<Y;N++)if(te[N](G,j))return z;return null},W=te.find(G=>!!G.allBasenames);W&&(ce.allBasenames=W.allBasenames);const Q=te.reduce((G,j)=>j.allPaths?G.concat(j.allPaths):G,[]);return Q.length&&(ce.allPaths=Q),ce}function I(z,q,te){const se=L.sep===L.posix.sep,ce=se?z:z.replace(m,L.sep),W=L.sep+ce,Q=L.posix.sep+z;let G;return te?G=function(j,N){return typeof j=="string"&&(j===ce||j.endsWith(W)||!se&&(j===z||j.endsWith(Q)))?q:null}:G=function(j,N){return typeof j=="string"&&(j===ce||!se&&j===z)?q:null},G.allPaths=[(te?"*/":"./")+z],G}function E(z){try{const q=new RegExp(`^${w(z)}$`);return function(te){return q.lastIndex=0,typeof te=="string"&&q.test(te)?z:null}}catch{return i}}function k(z,q,te){return!z||typeof q!="string"?!1:F(z)(q,void 0,te)}function F(z,q={}){if(!z)return o;if(typeof z=="string"||U(z)){const te=n(z,q);if(te===i)return o;const se=function(ce,W){return!!te(ce,W)};return te.allBasenames&&(se.allBasenames=te.allBasenames),te.allPaths&&(se.allPaths=te.allPaths),se}return B(z,q)}function U(z){const q=z;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function M(z){return z.allBasenames||[]}function H(z){return z.allPaths||[]}function B(z,q){const te=V(Object.getOwnPropertyNames(z).map(G=>Z(G,z[G],q)).filter(G=>G!==i)),se=te.length;if(!se)return i;if(!te.some(G=>!!G.requiresSiblings)){if(se===1)return te[0];const G=function(Y,$){let x;for(let J=0,ee=te.length;J<ee;J++){const K=te[J](Y,$);if(typeof K=="string")return K;(0,c.isThenable)(K)&&(x||(x=[]),x.push(K))}return x?(async()=>{for(const J of x){const ee=await J;if(typeof ee=="string")return ee}return null})():null},j=te.find(Y=>!!Y.allBasenames);j&&(G.allBasenames=j.allBasenames);const N=te.reduce((Y,$)=>$.allPaths?Y.concat($.allPaths):Y,[]);return N.length&&(G.allPaths=N),G}const ce=function(G,j,N){let Y,$;for(let x=0,J=te.length;x<J;x++){const ee=te[x];ee.requiresSiblings&&N&&(j||(j=(0,L.basename)(G)),Y||(Y=j.substr(0,j.length-(0,L.extname)(G).length)));const K=ee(G,j,Y,N);if(typeof K=="string")return K;(0,c.isThenable)(K)&&($||($=[]),$.push(K))}return $?(async()=>{for(const x of $){const J=await x;if(typeof J=="string")return J}return null})():null},W=te.find(G=>!!G.allBasenames);W&&(ce.allBasenames=W.allBasenames);const Q=te.reduce((G,j)=>j.allPaths?G.concat(j.allPaths):G,[]);return Q.length&&(ce.allPaths=Q),ce}function Z(z,q,te){if(q===!1)return i;const se=n(z,te);if(se===i)return i;if(typeof q=="boolean")return se;if(q){const ce=q.when;if(typeof ce=="string"){const W=(Q,G,j,N)=>{if(!N||!se(Q,G))return null;const Y=ce.replace("$(basename)",()=>j),$=N(Y);return(0,c.isThenable)($)?$.then(x=>x?z:null):$?z:null};return W.requiresSiblings=!0,W}}return se}function V(z,q){const te=z.filter(G=>!!G.basenames);if(te.length<2)return z;const se=te.reduce((G,j)=>{const N=j.basenames;return N?G.concat(N):G},[]);let ce;if(q){ce=[];for(let G=0,j=se.length;G<j;G++)ce.push(q)}else ce=te.reduce((G,j)=>{const N=j.patterns;return N?G.concat(N):G},[]);const W=function(G,j){if(typeof G!="string")return null;if(!j){let Y;for(Y=G.length;Y>0;Y--){const $=G.charCodeAt(Y-1);if($===T.CharCode.Slash||$===T.CharCode.Backslash)break}j=G.substr(Y)}const N=se.indexOf(j);return N!==-1?ce[N]:null};W.basenames=se,W.patterns=ce,W.allBasenames=se;const Q=z.filter(G=>!G.basenames);return Q.push(W),Q}function ie(z,q){return(0,C.equals)(z,q,(te,se)=>typeof te=="string"&&typeof se=="string"?te===se:typeof te!="string"&&typeof se!="string"?te.base===se.base&&te.pattern===se.pattern:!1)}}),define(le[95],ue([0,1,15,66,9]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=_,e.transformIncomingURIs=P,e.transformAndReviveIncomingURIs=p;function D(h){return h.toJSON()}class O{constructor(m){this._uriTransformer=m}transformIncoming(m){const l=this._uriTransformer.transformIncoming(m);return l===m?m:D(T.URI.from(l))}transformOutgoing(m){const l=this._uriTransformer.transformOutgoing(m);return l===m?m:D(T.URI.from(l))}transformOutgoingURI(m){const l=this._uriTransformer.transformOutgoing(m);return l===m?m:T.URI.from(l)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function L(h,m,l){if(!h||l>200)return null;if(typeof h=="object"){if(h instanceof T.URI)return m.transformOutgoing(h);for(const y in h)if(Object.hasOwnProperty.call(h,y)){const w=L(h[y],m,l+1);w!==null&&(h[y]=w)}}return null}function _(h,m){const l=L(h,m,0);return l===null?h:l}function v(h,m,l,y){if(!h||y>200)return null;if(typeof h=="object"){if(h.$mid===c.MarshalledId.Uri)return l?T.URI.revive(m.transformIncoming(h)):m.transformIncoming(h);if(h instanceof C.VSBuffer)return null;for(const w in h)if(Object.hasOwnProperty.call(h,w)){const f=v(h[w],m,l,y+1);f!==null&&(h[w]=f)}}return null}function P(h,m){const l=v(h,m,!1,0);return l===null?h:l}function p(h,m){const l=v(h,m,!0,0);return l===null?h:l}}),define(le[150],ue([0,1,38,52,32,137,5]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=_,e.getSqmMachineId=p,e.getdevDeviceId=h,T=De(T),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=c.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,l=0;const y=(0,C.networkInterfaces)();for(const w in y){const f=y[w];if(f)for(const{mac:S,internal:R}of f)R||(l+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(m+=1))}this._value=l>0?m/l:0}return this._value}};let L;async function _(m){return L||(L=(async()=>await v(m)||T.generateUuid())()),L}async function v(m){try{const l=await new Promise((w,f)=>{ne(["crypto"],w,f)}).then(De),y=(0,D.getMac)();return l.createHash("sha256").update(y,"utf8").digest("hex")}catch(l){m(l);return}}const P="Software\\Microsoft\\SQMClient";async function p(m){if(O.isWindows){const l=await new Promise((y,w)=>{ne(["@vscode/windows-registry"],y,w)}).then(De);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(y){return m(y),""}}return""}async function h(m){try{return await(await new Promise((w,f)=>{ne(["@vscode/deviceid"],w,f)}).then(De)).getDeviceId()}catch(l){return m(l),""}}}),define(le[151],ue([0,1,46,152,14,37]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=P,e.getCodeDisplayProtocol=p;const O="XDG_SESSION_TYPE",L="WAYLAND_DISPLAY",_="XDG_RUNTIME_DIR";var v;(function(h){h.Wayland="wayland",h.XWayland="xwayland",h.X11="x11",h.Unknown="unknown"})(v||(v={}));async function P(h){const m=D.env[O];if(m)return m===v.Wayland||m===v.X11?m:v.Unknown;if(D.env[L]){const y=D.env[_];if(y){const w=(0,T.join)(y,"wayland-0");try{return await(0,c.access)(w,C.constants.R_OK),v.Wayland}catch(f){return h(f),v.Unknown}}else return v.Unknown}else return v.X11}function p(h,m){if(m)switch(m){case"auto":return h;case"x11":return h===v.Wayland?v.XWayland:v.X11;case"wayland":return v.Wayland;default:return v.Unknown}else return h===v.Wayland?v.XWayland:v.X11}}),define(le[153],ue([0,1,46,152,278,5]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=O,D=De(D);async function O(L){if(D.isMacintosh||D.isWindows)return;let _;for(const v of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{_=await(0,c.open)(v,C.constants.R_OK);break}catch{}if(!_){L("Unable to retrieve release information from known identifier paths.");return}try{const v=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),P={id:"unknown"};for await(const p of(0,T.createInterface)({input:_.createReadStream(),crlfDelay:1/0})){if(!p.includes("="))continue;const h=p.split("=")[0].toUpperCase().trim();if(v.has(h)){const m=p.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?P.id=m:h==="ID_LIKE"?P.id_like=m:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(P.version_id=m)}}return P}catch(v){L(v)}}}),define(le[31],ue([0,1,46,38,279,6,42,91,14,5,21,9]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=R,e.whenDeleted=r,e.configureFlushOnWrite=a,e.writeFileSync=d,C=De(C);var h;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function m(B,Z=h.UNLINK,V){if((0,O.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return Z===h.UNLINK?y(B):l(B,V)}async function l(B,Z=(0,O.randomPath)((0,c.tmpdir)())){try{try{await C.promises.rename(B,Z)}catch(V){return V.code==="ENOENT"?void 0:y(B)}y(Z).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(B){return C.promises.rm(B,{recursive:!0,force:!0,maxRetries:3})}function w(B){if((0,O.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}async function f(B,Z){return g(await(Z?S(B):C.promises.readdir(B)))}async function S(B){try{return await C.promises.readdir(B,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const Z=[],V=await f(B);for(const ie of V){let z=!1,q=!1,te=!1;try{const se=await e.Promises.lstat((0,_.join)(B,ie));z=se.isFile(),q=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}Z.push({name:ie,isFile:()=>z,isDirectory:()=>q,isSymbolicLink:()=>te})}return Z}function R(B){return g(C.readdirSync(B))}function g(B){return B.map(Z=>typeof Z=="string"?v.isMacintosh?(0,L.normalizeNFC)(Z):Z:(Z.name=v.isMacintosh?(0,L.normalizeNFC)(Z.name):Z.name,Z))}async function s(B){const Z=await f(B),V=[];for(const ie of Z)await t.existsDirectory((0,_.join)(B,ie))&&V.push(ie);return V}function r(B,Z=1e3){return new Promise(V=>{let ie=!1;const z=setInterval(()=>{ie||(ie=!0,C.access(B,q=>{ie=!1,q&&(clearInterval(z),V(void 0))}))},Z)})}var t;(function(B){async function Z(z){let q;try{if(q=await e.Promises.lstat(z),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(v.isWindows&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw se}throw te}}B.stat=Z;async function V(z){try{const{stat:q,symbolicLink:te}=await B.stat(z);return q.isFile()&&te?.dangling!==!0}catch{}return!1}B.existsFile=V;async function ie(z){try{const{stat:q,symbolicLink:te}=await B.stat(z);return q.isDirectory()&&te?.dangling!==!0}catch{}return!1}B.existsDirectory=ie})(t||(e.SymlinkSupport=t={}));const o=new D.ResourceQueue;function i(B,Z,V){return o.queueFor(p.URI.file(B),()=>{const ie=b(V);return new Promise((z,q)=>u(B,Z,ie,te=>te?q(te):z()))},P.extUriBiasedIgnorePathCase)}let n=!0;function a(B){n=B}function u(B,Z,V,ie){if(!n)return C.writeFile(B,Z,{mode:V.mode,flag:V.flag},ie);C.open(B,V.flag,V.mode,(z,q)=>{if(z)return ie(z);C.writeFile(q,Z,te=>{if(te)return C.close(q,()=>ie(te));C.fdatasync(q,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),a(!1)),C.close(q,ce=>ie(ce))))})})}function d(B,Z,V){const ie=b(V);if(!n)return C.writeFileSync(B,Z,{mode:ie.mode,flag:ie.flag});const z=C.openSync(B,ie.flag,ie.mode);try{C.writeFileSync(z,Z);try{C.fdatasyncSync(z)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),a(!1)}}finally{C.closeSync(z)}}function b(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function A(B,Z,V=6e4){if(B!==Z)try{v.isWindows&&typeof V=="number"?await I(B,Z,Date.now(),V):await C.promises.rename(B,Z)}catch(ie){if(B.toLowerCase()!==Z.toLowerCase()&&ie.code==="EXDEV"||B.endsWith("."))await E(B,Z,{preserveSymlinks:!1}),await m(B,h.MOVE);else throw ie}}async function I(B,Z,V,ie,z=0){try{return await C.promises.rename(B,Z)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-V>=ie)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${q}`),q;if(z===0){let te=!1;try{const{stat:se}=await t.stat(Z);se.isFile()||(te=!0)}catch{}if(te)throw q}return await(0,D.timeout)(Math.min(100,z*10)),I(B,Z,V,ie,z+1)}}async function E(B,Z,V){return F(B,Z,{root:{source:B,target:Z},options:V,handledSourcePaths:new Set})}const k=511;async function F(B,Z,V){if(V.handledSourcePaths.has(B))return;V.handledSourcePaths.add(B);const{stat:ie,symbolicLink:z}=await t.stat(B);if(z){if(V.options.preserveSymlinks)try{return await H(B,Z,V)}catch{}if(z.dangling)return}return ie.isDirectory()?U(B,Z,ie.mode&k,V):M(B,Z,ie.mode&k)}async function U(B,Z,V,ie){await e.Promises.mkdir(Z,{recursive:!0,mode:V});const z=await f(B);for(const q of z)await F((0,_.join)(B,q),(0,_.join)(Z,q),ie)}async function M(B,Z,V){await e.Promises.copyFile(B,Z),await e.Promises.chmod(Z,V)}async function H(B,Z,V){let ie=await e.Promises.readlink(B);(0,O.isEqualOrParent)(ie,V.root.source,!v.isLinux)&&(ie=(0,_.join)(V.root.target,ie.substr(V.root.source.length+1))),await e.Promises.symlink(ie,Z)}e.Promises=new class{get access(){return C.promises.access}get stat(){return C.promises.stat}get lstat(){return C.promises.lstat}get utimes(){return C.promises.utimes}get read(){return(B,Z,V,ie,z)=>new Promise((q,te)=>{C.read(B,Z,V,ie,z,(se,ce,W)=>se?te(se):q({bytesRead:ce,buffer:W}))})}get readFile(){return C.promises.readFile}get write(){return(B,Z,V,ie,z)=>new Promise((q,te)=>{C.write(B,Z,V,ie,z,(se,ce,W)=>se?te(se):q({bytesWritten:ce,buffer:W}))})}get appendFile(){return C.promises.appendFile}get fdatasync(){return(0,T.promisify)(C.fdatasync)}get truncate(){return C.promises.truncate}get copyFile(){return C.promises.copyFile}get open(){return(0,T.promisify)(C.open)}get close(){return(0,T.promisify)(C.close)}get symlink(){return C.promises.symlink}get readlink(){return C.promises.readlink}get chmod(){return C.promises.chmod}get mkdir(){return C.promises.mkdir}get unlink(){return C.promises.unlink}get rmdir(){return C.promises.rmdir}get realpath(){return(0,T.promisify)(C.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return s}get writeFile(){return i}get rm(){return m}get rename(){return A}get copy(){return E}}}),define(le[154],ue([0,1,46,14,5,27,31]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=L,e.realcase=_,e.realpath=v,e.realpathSync=P,C=De(C);function L(h){if(T.isLinux)return h;const m=(0,c.dirname)(h);if(h===m)return h;const l=((0,c.basename)(h)||h).toLowerCase();try{const w=(0,O.readdirSync)(m).filter(f=>f.toLowerCase()===l);if(w.length===1){const f=L(m);if(f)return(0,c.join)(f,w[0])}else if(w.length>1){const f=w.indexOf(l);if(f>=0){const S=L(m);if(S)return(0,c.join)(S,w[f])}}}catch{}return null}async function _(h,m){if(T.isLinux)return h;const l=(0,c.dirname)(h);if(h===l)return h;const y=((0,c.basename)(h)||h).toLowerCase();try{if(m?.isCancellationRequested)return null;const f=(await O.Promises.readdir(l)).filter(S=>S.toLowerCase()===y);if(f.length===1){const S=await _(l,m);if(S)return(0,c.join)(S,f[0])}else if(f.length>1){const S=f.indexOf(y);if(S>=0){const R=await _(l,m);if(R)return(0,c.join)(R,f[S])}}}catch{}return null}async function v(h){try{return await O.Promises.realpath(h)}catch{const l=p(h);return await O.Promises.access(l,C.constants.R_OK),l}}function P(h){try{return C.realpathSync(h)}catch{const l=p(h);return C.accessSync(l,C.constants.R_OK),l}}function p(h){return(0,D.rtrim)((0,c.normalize)(h),c.sep)}}),define(le[155],ue([0,1,14,5,37,93,13,31]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=_,e.createQueuedSender=v,C=De(C),c=De(c),T=De(T),O=De(O),L=De(L),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function _(p=T.env){return p.comspec||"cmd.exe"}function v(p){let h=[],m=!1;const l=function(y){if(m){h.push(y);return}(!p.send(y,f=>{if(f&&console.error(f),m=!1,h.length>0){const S=h.slice(0);h=[],S.forEach(R=>l(R))}})||c.isWindows)&&(m=!0)};return{send:l}}var P;(function(p){async function h(m,l,y){if(C.isAbsolute(m))return m;if(l===void 0&&(l=T.cwd()),C.dirname(m)!=="."||(y===void 0&&O.isString(T.env.PATH)&&(y=T.env.PATH.split(C.delimiter)),y===void 0||y.length===0))return C.join(l,m);async function f(S){if(await L.Promises.exists(S)){let R;try{R=await L.Promises.stat(S)}catch(g){g.message.startsWith("EACCES")&&(R=await L.Promises.lstat(S))}return R?!R.isDirectory():!1}return!1}for(const S of y){let R;if(C.isAbsolute(S)?R=C.join(S,m):R=C.join(l,S,m),await f(R))return R;let g=R+".com";if(await f(g)||(g=R+".exe",await f(g)))return g}return C.join(l,m)}p.findExecutable=h})(P||(e.win32=P={}))}),define(le[156],ue([0,1,70,23]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=T;function T(O){return new Promise((L,_)=>{let v;const P=new Map;function p(m,l,y,w,f){const S=P.get(l);if(m===O||S){const R={name:h(y),cmd:y,pid:m,ppid:l,load:w,mem:f};P.set(m,R),m===O&&(v=R),S&&(S.children||(S.children=[]),S.children.push(R),S.children.length>1&&(S.children=S.children.sort((g,s)=>g.pid-s.pid)))}}function h(m){const l=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,S=/--type=([a-zA-Z-]+)/;if(y.exec(m))return"electron-crash-reporter";if(w.exec(m))return"winpty-agent";if(f.exec(m))return"conpty-agent";let R=S.exec(m);if(R&&R.length===2)return R[1]==="renderer"?"window":R[1]==="utility"?l.exec(m)?"utility-network-service":"utility-process":R[1]==="extensionHost"?"extension-host":R[1];const g=/[a-zA-Z-]+\.js/g;let s="";do R=g.exec(m),R&&(s+=R+" ");while(R);return s&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${s})`:m}if(process.platform==="win32"){const m=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,y)=>{ne(["@vscode/windows-process-tree"],l,y)}).then(De).then(l=>{l.getProcessList(O,y=>{if(!y){_(new Error(`Root process ${O} not found`));return}l.getProcessCpuUsage(y,w=>{const f=new Map;w.forEach(S=>{const R=m(S.commandLine||"");f.set(S.pid,{name:h(R),cmd:R,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),v=f.get(O),v?(f.forEach(S=>{const R=f.get(S.ppid);R&&(R.children||(R.children=[]),R.children.push(S))}),f.forEach(S=>{S.children&&(S.children=S.children.sort((R,g)=>R.pid-g.pid))}),L(v)):_(new Error(`Root process ${O} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let m=function(){let l=[v];const y=[];for(;l.length;){const f=l.shift();f&&(y.push(f.pid),f.children&&(l=l.concat(f.children)))}let w=JSON.stringify(c.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,C.exec)(w,{},(f,S,R)=>{if(f||R)_(f||new Error(R.toString()));else{const g=S.toString().split(`
`);for(let s=0;s<y.length;s++){const r=P.get(y[s]);r.load=parseFloat(g[s])}if(!v){_(new Error(`Root process ${O} not found`));return}L(v)}})};(0,C.exec)("which ps",{},(l,y,w)=>{if(l||w)if(process.platform!=="linux")_(l||new Error(w.toString()));else{const f=JSON.stringify(c.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,C.exec)(f,{},(S,R,g)=>{S||g?_(S||new Error(g.toString())):(D(R,p),m())})}else{const f=y.toString().trim();(0,C.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(R,g,s)=>{R||s&&!s.includes("screen size is bogus")?_(R||new Error(s.toString())):(D(g,p),process.platform==="linux"?m():v?L(v):_(new Error(`Root process ${O} not found`)))})}})}})}function D(O,L){const _=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=O.toString().split(`
`);for(const P of v){const p=_.exec(P.trim());p&&p.length===6&&L(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var we=this&&this.__decorate||function(ne,e,C,c){var T=arguments.length,D=T<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,C):c,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(ne,e,C,c);else for(var L=ne.length-1;L>=0;L--)(O=ne[L])&&(D=(T<3?O(D):T>3?O(e,C,D):O(e,C))||D);return T>3&&D&&Object.defineProperty(e,C,D),D};define(le[43],ue([0,1,19,6,15,26,88,8,3,2,69,27,13]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=a,e.deserialize=u,e.getDelayedChannel=k,e.getNextTickChannel=F,p=De(p);var m;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(m||(m={}));function l(z){switch(z){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var y;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(y||(y={}));function w(z){switch(z){case y.Initialize:return"init";case y.PromiseSuccess:return"reply:";case y.PromiseError:case y.PromiseErrorObj:return"replyErr:";case y.EventFire:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function S(z){let q=0;for(let te=0;;te+=7){const se=z.read(1);if(q|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return q}}const R=o(0);function g(z,q){if(q===0){z.write(R);return}let te=0;for(let ce=q;ce!==0;ce=ce>>>7)te++;const se=T.VSBuffer.alloc(te);for(let ce=0;q!==0;ce++)se.buffer[ce]=q&127,q=q>>>7,q>0&&(se.buffer[ce]|=128);z.write(se)}class s{constructor(q){this.buffer=q,this.pos=0}read(q){const te=this.buffer.slice(this.pos,this.pos+q);return this.pos+=te.byteLength,te}}e.BufferReader=s;class r{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=r;var t;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(t||(t={}));function o(z){const q=T.VSBuffer.alloc(1);return q.writeUInt8(z,0),q}const i={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},n=typeof Buffer<"u";function a(z,q){if(typeof q>"u")z.write(i.Undefined);else if(typeof q=="string"){const te=T.VSBuffer.fromString(q);z.write(i.String),g(z,te.byteLength),z.write(te)}else if(n&&Buffer.isBuffer(q)){const te=T.VSBuffer.wrap(q);z.write(i.Buffer),g(z,te.byteLength),z.write(te)}else if(q instanceof T.VSBuffer)z.write(i.VSBuffer),g(z,q.byteLength),z.write(q);else if(Array.isArray(q)){z.write(i.Array),g(z,q.length);for(const te of q)a(z,te)}else if(typeof q=="number"&&(q|0)===q)z.write(i.Uint),g(z,q);else{const te=T.VSBuffer.fromString(JSON.stringify(q));z.write(i.Object),g(z,te.byteLength),z.write(te)}}function u(z){switch(z.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return z.read(S(z)).toString();case t.Buffer:return z.read(S(z)).buffer;case t.VSBuffer:return z.read(S(z));case t.Array:{const te=S(z),se=[];for(let ce=0;ce<te;ce++)se.push(u(z));return se}case t.Object:return JSON.parse(z.read(S(z)).toString());case t.Int:return S(z)}}class d{constructor(q,te,se=null,ce=1e3){this.protocol=q,this.ctx=te,this.logger=se,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:y.Initialize})}registerChannel(q,te){this.channels.set(q,te),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case y.Initialize:{const te=this.send([q.type]);this.logger?.logOutgoing(te,0,b.OtherSide,w(q.type));return}case y.PromiseSuccess:case y.PromiseError:case y.EventFire:case y.PromiseErrorObj:{const te=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(te,q.id,b.OtherSide,w(q.type),q.data);return}}}send(q,te=void 0){const se=new r;return a(se,q),a(se,te),this.sendBuffer(se.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const te=new s(q),se=u(te),ce=u(te),W=se[0];switch(W){case m.Promise:return this.logger?.logIncoming(q.byteLength,se[1],b.OtherSide,`${l(W)}: ${se[2]}.${se[3]}`,ce),this.onPromise({type:W,id:se[1],channelName:se[2],name:se[3],arg:ce});case m.EventListen:return this.logger?.logIncoming(q.byteLength,se[1],b.OtherSide,`${l(W)}: ${se[2]}.${se[3]}`,ce),this.onEventListen({type:W,id:se[1],channelName:se[2],name:se[3],arg:ce});case m.PromiseCancel:return this.logger?.logIncoming(q.byteLength,se[1],b.OtherSide,`${l(W)}`),this.disposeActiveRequest({type:W,id:se[1]});case m.EventDispose:return this.logger?.logIncoming(q.byteLength,se[1],b.OtherSide,`${l(W)}`),this.disposeActiveRequest({type:W,id:se[1]})}}onPromise(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const se=new D.CancellationTokenSource;let ce;try{ce=te.call(this.ctx,q.name,q.arg,se.token)}catch(G){ce=Promise.reject(G)}const W=q.id;ce.then(G=>{this.sendResponse({id:W,data:G,type:y.PromiseSuccess})},G=>{G instanceof Error?this.sendResponse({id:W,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split(`
`):void 0},type:y.PromiseError}):this.sendResponse({id:W,data:G,type:y.PromiseErrorObj})}).finally(()=>{Q.dispose(),this.activeRequests.delete(q.id)});const Q=(0,v.toDisposable)(()=>se.cancel());this.activeRequests.set(q.id,Q)}onEventListen(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const se=q.id,W=te.listen(this.ctx,q.name,q.arg)(Q=>this.sendResponse({id:se,data:Q,type:y.EventFire}));this.activeRequests.set(q.id,W)}disposeActiveRequest(q){const te=this.activeRequests.get(q.id);te&&(te.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let te=this.pendingRequests.get(q.channelName);te||(te=[],this.pendingRequests.set(q.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===m.Promise&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:y.PromiseError})},this.timeoutDelay);te.push({request:q,timeoutTimer:se})}flushPendingRequests(q){const te=this.pendingRequests.get(q);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case m.Promise:this.onPromise(se.request);break;case m.EventListen:this.onEventListen(se.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class A{constructor(q,te=null){this.protocol=q,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=te}getChannel(q){const te=this;return{call(se,ce,W){return te.isDisposed?Promise.reject(new L.CancellationError):te.requestPromise(q,se,ce,W)},listen(se,ce){return te.isDisposed?_.Event.None:te.requestEvent(q,se,ce)}}}requestPromise(q,te,se,ce=D.CancellationToken.None){const W=this.lastRequestId++,Q=m.Promise,G={id:W,type:Q,channelName:q,name:te,arg:se};if(ce.isCancellationRequested)return Promise.reject(new L.CancellationError);let j;return new Promise((Y,$)=>{if(ce.isCancellationRequested)return $(new L.CancellationError);const x=()=>{const oe=he=>{switch(he.type){case y.PromiseSuccess:this.handlers.delete(W),Y(he.data);break;case y.PromiseError:{this.handlers.delete(W);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,$(ge);break}case y.PromiseErrorObj:this.handlers.delete(W),$(he.data);break}};this.handlers.set(W,oe),this.sendRequest(G)};let J=null;this.state===f.Idle?x():(J=(0,c.createCancelablePromise)(oe=>this.whenInitialized()),J.then(()=>{J=null,x()}));const ee=()=>{J?(J.cancel(),J=null):this.sendRequest({id:W,type:m.PromiseCancel}),$(new L.CancellationError)},K=ce.onCancellationRequested(ee);j=(0,v.combinedDisposable)((0,v.toDisposable)(ee),K),this.activeRequests.add(j)}).finally(()=>{j.dispose(),this.activeRequests.delete(j)})}requestEvent(q,te,se){const ce=this.lastRequestId++,W=m.EventListen,Q={id:ce,type:W,channelName:q,name:te,arg:se};let G=null;const j=new _.Emitter({onWillAddFirstListener:()=>{G=(0,c.createCancelablePromise)(Y=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(j),this.sendRequest(Q)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(j),this.sendRequest({id:ce,type:m.EventDispose}))}}),N=Y=>j.fire(Y.data);return this.handlers.set(ce,N),j.event}sendRequest(q){switch(q.type){case m.Promise:case m.EventListen:{const te=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(te,q.id,b.LocalSide,`${l(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case m.PromiseCancel:case m.EventDispose:{const te=this.send([q.type,q.id]);this.logger?.logOutgoing(te,q.id,b.LocalSide,l(q.type));return}}}send(q,te=void 0){const se=new r;return a(se,q),a(se,te),this.sendBuffer(se.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const te=new s(q),se=u(te),ce=u(te),W=se[0];switch(W){case y.Initialize:return this.logger?.logIncoming(q.byteLength,0,b.LocalSide,w(W)),this.onResponse({type:se[0]});case y.PromiseSuccess:case y.PromiseError:case y.EventFire:case y.PromiseErrorObj:return this.logger?.logIncoming(q.byteLength,se[1],b.LocalSide,w(W),ce),this.onResponse({type:se[0],id:se[1],data:ce})}}onResponse(q){if(q.type===y.Initialize){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=A,we([O.memoize],A.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this._connections.forEach(te=>q.push(te)),q}constructor(q,te,se){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new v.DisposableStore,this.disposables.add(q(({protocol:ce,onDidClientDisconnect:W})=>{const Q=_.Event.once(ce.onMessage);this.disposables.add(Q(G=>{const j=new s(G),N=u(j),Y=new d(ce,N,te,se),$=new A(ce,te);this.channels.forEach((J,ee)=>Y.registerChannel(ee,J));const x={channelServer:Y,channelClient:$,ctx:N};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(W(()=>{Y.dispose(),$.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(q,te){const se=this;return{call(ce,W,Q){let G;if((0,h.isFunction)(te)){const N=(0,C.getRandomElement)(se.connections.filter(te));G=N?Promise.resolve(N):_.Event.toPromise(_.Event.filter(se.onDidAddConnection,te))}else G=te.routeCall(se,ce,W);const j=G.then(N=>N.channelClient.getChannel(q));return k(j).call(ce,W,Q)},listen(ce,W){if((0,h.isFunction)(te))return se.getMulticastEvent(q,te,ce,W);const Q=te.routeEvent(se,ce,W).then(G=>G.channelClient.getChannel(q));return k(Q).listen(ce,W)}}}getMulticastEvent(q,te,se,ce){const W=this;let Q;const G=new _.Emitter({onWillAddFirstListener:()=>{Q=new v.DisposableStore;const j=new _.EventMultiplexer,N=new Map,Y=x=>{const ee=x.channelClient.getChannel(q).listen(se,ce),K=j.add(ee);N.set(x,K)},$=x=>{const J=N.get(x);J&&(J.dispose(),N.delete(x))};W.connections.filter(te).forEach(Y),_.Event.filter(W.onDidAddConnection,te)(Y,void 0,Q),W.onDidRemoveConnection($,void 0,Q),j.event(G.fire,G,Q),Q.add(j)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return G.event}registerChannel(q,te){this.channels.set(q,te);for(const se of this._connections)se.channelServer.registerChannel(q,te)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class E{constructor(q,te,se=null){const ce=new r;a(ce,te),q.send(ce.buffer),this.channelClient=new A(q,se),this.channelServer=new d(q,te,se)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,te){this.channelServer.registerChannel(q,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=E;function k(z){return{call(q,te,se){return z.then(ce=>ce.call(q,te,se))},listen(q,te){const se=new _.Relay;return z.then(ce=>se.input=ce.listen(q,te)),se.event}}}function F(z){let q=!1;return{call(te,se,ce){return q?z.call(te,se,ce):(0,c.timeout)(0).then(()=>q=!0).then(()=>z.call(te,se,ce))},listen(te,se){if(q)return z.listen(te,se);const ce=new _.Relay;return(0,c.timeout)(0).then(()=>q=!0).then(()=>ce.input=z.listen(te,se)),ce.event}}}class U{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const te of q.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await _.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=U;var M;(function(z){function q(W,Q,G){const j=W,N=G&&G.disableMarshalling,Y=new Map;for(const $ in j)se($)&&Y.set($,_.Event.buffer(j[$],!0,void 0,Q));return new class{listen($,x,J){const ee=Y.get(x);if(ee)return ee;const K=j[x];if(typeof K=="function"){if(ce(x))return K.call(j,J);if(se(x))return Y.set(x,_.Event.buffer(j[x],!0,void 0,Q)),Y.get(x)}throw new L.ErrorNoTelemetry(`Event not found: ${x}`)}call($,x,J){const ee=j[x];if(typeof ee=="function"){if(!N&&Array.isArray(J))for(let oe=0;oe<J.length;oe++)J[oe]=(0,P.revive)(J[oe]);let K=ee.apply(j,J);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new L.ErrorNoTelemetry(`Method not found: ${x}`)}}}z.fromService=q;function te(W,Q){const G=Q&&Q.disableMarshalling;return new Proxy({},{get(j,N){if(typeof N=="string")return Q?.properties?.has(N)?Q.properties.get(N):ce(N)?function(Y){return W.listen(N,Y)}:se(N)?W.listen(N):async function(...Y){let $;Q&&!(0,h.isUndefinedOrNull)(Q.context)?$=[Q.context,...Y]:$=Y;const x=await W.call(N,$);return G?x:(0,P.revive)(x)};throw new L.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}z.toService=te;function se(W){return W[0]==="o"&&W[1]==="n"&&p.isUpperAsciiLetter(W.charCodeAt(2))}function ce(W){return/^onDynamic/.test(W)&&p.isUpperAsciiLetter(W.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const q=z.toString();if(q!=="[object Object]")return q}return z}function Z(z){return Array.isArray(z)?z.map(B):B(z)}function V(z,q,te,se,ce,W,Q){Q=Z(Q);const G=H[ce],j=G[se%G.length];let N=[`%c[${z}]%c[${String(q).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(W)?(N=N.concat(Q),N.push(")")):N.push(Q),console.log.apply(console,N)}class ie{constructor(q,te){this._outgoingPrefix=q,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,te,se,ce,W){this._totalOutgoing+=q,V(this._outgoingPrefix,this._totalOutgoing,q,te,se,ce,W)}logIncoming(q,te,se,ce,W){this._totalIncoming+=q,V(this._incomingPrefix,this._totalIncoming,q,te,se,ce,W)}}e.IPCLogger=ie}),define(le[71],ue([0,1,15,3,2,43]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var L;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function u(b,A){if(!n.has(b)){const I=String(++a);n.set(b,I)}return n.get(b)}function d(b,A,I,E){if(!i.enableDiagnostics)return;const k=u(b,A);if(E instanceof C.VSBuffer||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const F=C.VSBuffer.alloc(E.byteLength);F.set(E),i.records.push({timestamp:Date.now(),id:k,label:A,type:I,buff:F})}else i.records.push({timestamp:Date.now(),id:k,label:A,type:I,data:E})}i.traceSocketEvent=d})(L||(e.SocketDiagnostics=L={}));var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_||(e.SocketCloseEventType=_={}));let v=null;function P(){return v||(v=C.VSBuffer.alloc(0)),v}class p{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return P();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const A=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),A}if(this._chunks[0].byteLength>n){const A=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),A}const u=C.VSBuffer.alloc(n);let d=0,b=0;for(;n>0;){const A=this._chunks[b];if(A.byteLength>n){const I=A.slice(0,n);u.set(I,d),d+=n,a&&(this._chunks[b]=A.slice(n),this._totalLength-=n),n-=n}else u.set(A,d),d+=A.byteLength,a?(this._chunks.shift(),this._totalLength-=A.byteLength):b++,n-=A.byteLength}return u}}e.ChunkStream=p;var h;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(h||(h={}));function m(i){switch(i){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var l;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class y{constructor(n,a,u,d){this.type=n,this.id=a,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends T.Disposable{constructor(n){super(),this._onMessage=this._register(new c.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:l.HeaderLength,messageType:h.None,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new p,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent(O.ProtocolHeaderRead,{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,d=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=l.HeaderLength,this._state.messageType=h.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(O.ProtocolMessageRead,a),this._onMessage.fire(new y(u,d,b,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=C.VSBuffer.alloc(l.HeaderLength);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:m(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent(O.ProtocolMessageWrite,n.data),this._writeSoon(a,n.data)}_bufferAdd(n,a){const u=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,u}_bufferTake(){const n=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent(O.ProtocolWrite,{byteLength:n.byteLength}),this._socket.write(n)}}class S extends T.Disposable{constructor(n){super(),this._onMessage=new c.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new c.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===h.Regular&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new y(h.Regular,0,0,n))}}e.Protocol=S;class R extends D.IPCClient{static fromSocket(n,a){return new R(new S(n),a)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,a,u=null){super(n,a,u),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=R;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new c.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class s{constructor(n){this.data=n,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let n=0,a=this._first;for(;a;)a=a.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let a=0,u=this._first;for(;u;)n[a++]=u.data,u=u.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new s(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<t._HISTORY_LENGTH;d++)n-this.lastRuns[d]<=a&&u++;return 1-u/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??t.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},l.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new y(h.Disconnect,0,0,P());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new y(h.Pause,0,0,P());this._socketWriter.write(n)}sendResume(){const n=new y(h.Resume,0,0,P());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new f(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new y(h.Ack,0,this._incomingAckId,P());this._socketWriter.write(n);const a=this._outgoingUnackMsg.toArray();for(let u=0,d=a.length;u<d;u++)this._socketWriter.write(a[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case h.None:break;case h.Regular:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new y(h.ReplayRequest,0,0,P())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case h.Control:{this._onControlMessage.fire(n.data);break}case h.Ack:break;case h.Disconnect:{this._onDidDispose.fire();break}case h.ReplayRequest:{const a=this._outgoingUnackMsg.toArray();for(let u=0,d=a.length;u<d;u++)this._socketWriter.write(a[u]);this._recvAckCheck();break}case h.Pause:{this._socketWriter.pause();break}case h.Resume:{this._socketWriter.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(h.Regular,a,this._incomingAckId,n);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(n){const a=new y(h.Control,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=l.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},l.AcknowledgeTime-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime,u=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(a>=l.TimeoutTime&&u>=l.TimeoutTime&&d>=l.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:u});return}const b=Math.max(l.TimeoutTime-a,l.TimeoutTime-u,l.TimeoutTime-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},b)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new y(h.Ack,0,this._incomingAckId,P());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new y(h.KeepAlive,0,this._incomingAckId,P());this._socketWriter.write(n)}}e.PersistentProtocol=o}),define(le[96],ue([0,1,70,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,L=De(L);class l extends m.ChannelServer{constructor(f){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:_.Event.fromNodeEventEmitter(process,"message",S=>T.VSBuffer.wrap(Buffer.from(S,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=l;class y{constructor(f,S){this.modulePath=f,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new _.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const R=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new c.Delayer(R),this.child=null,this._client=null}getChannel(f){const S=this;return{call(R,g,s){return S.requestPromise(f,R,g,s)},listen(R,g){return S.requestEvent(f,R,g)}}}requestPromise(f,S,R,g=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),r=(0,c.createCancelablePromise)(i=>s.call(S,R,i)),t=g.onCancellationRequested(()=>r.cancel()),o=(0,v.toDisposable)(()=>r.cancel());return this.activeRequests.add(o),r.finally(()=>{t.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(f,S,R){if(!this.disposeDelayer)return _.Event.None;this.disposeDelayer.cancel();let g;const s=new _.Emitter({onWillAddFirstListener:()=>{g=this.getCachedChannel(f).listen(S,R)(s.fire,s),this.activeRequests.add(g)},onDidRemoveLastListener:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,h.removeDangerousEnvVariables)(S.env),this.child=(0,C.fork)(this.modulePath,f,S);const R=new _.Emitter,s=_.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,O.isRemoteConsoleLog)(a)){(0,O.log)(a,`IPC Library: ${this.options.serverName}`);return}R.fire(T.VSBuffer.wrap(Buffer.from(a,"base64")))}),r=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),o=R.event,i={send:t,onMessage:o};this._client=new m.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,u)=>{process.removeListener("exit",n),s.dispose(),this.activeRequests.forEach(d=>(0,v.dispose)(d)),this.activeRequests.clear(),a!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:u})})}return this._client}getCachedChannel(f){let S=this.channels.get(f);return S||(S=this.client.getChannel(f),this.channels.set(f,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(le[157],ue([0,1,140,15,43,3,13,19]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=P;class _{constructor(h){this.port=h,this.onMessage=D.Event.fromNodeEventEmitter(this.port,"message",m=>m.data?c.VSBuffer.wrap(m.data):c.VSBuffer.alloc(0)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}class v extends T.IPCServer{static getOnDidClientConnect(h){(0,O.assertType)((0,C.isUtilityProcess)(process),"Electron Utility Process");const m=new D.Emitter;return process.parentPort.on("message",l=>{if(h?.handledClientConnection(l))return;const y=(0,L.firstOrDefault)(l.ports);y&&m.fire(y)}),D.Event.map(m.event,l=>({protocol:new _(l),onDidClientDisconnect:D.Event.fromNodeEventEmitter(l,"close")}))}constructor(h){super(v.getOnDidClientConnect(h))}}e.Server=v;function P(p,h,m){const l=y=>{y.data===h&&(p.removeListener("message",l),m())};p.on("message",l)}}),define(le[72],ue([0,1,6,3,2,69,13]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=_;var L;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L||(e.StorageHint=L={}));function _(h){const m=h;return m?.changed instanceof Map||m?.deleted instanceof Set}var v;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(v||(e.StorageState=v={}));class P extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(m,l=Object.create(null)){super(),this.database=m,this.options=l,this._onDidChangeStorage=this._register(new c.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=this._register(new C.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){this._onDidChangeStorage.pause();try{m.changed?.forEach((l,y)=>this.acceptExternal(y,l)),m.deleted?.forEach(l=>this.acceptExternal(l,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(m,l){if(this.state===v.Closed)return;let y=!1;(0,O.isUndefinedOrNull)(l)?y=this.cache.delete(m):this.cache.get(m)!==l&&(this.cache.set(m,l),y=!0),y&&this._onDidChangeStorage.fire({key:m,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,l){const y=this.cache.get(m);return(0,O.isUndefinedOrNull)(y)?l:y}getBoolean(m,l){const y=this.get(m);return(0,O.isUndefinedOrNull)(y)?l:y==="true"}getNumber(m,l){const y=this.get(m);return(0,O.isUndefinedOrNull)(y)?l:parseInt(y,10)}getObject(m,l){const y=this.get(m);return(0,O.isUndefinedOrNull)(y)?l:(0,D.parse)(y)}async set(m,l,y=!1){if(this.state===v.Closed)return;if((0,O.isUndefinedOrNull)(l))return this.delete(m,y);const w=(0,O.isObject)(l)||Array.isArray(l)?(0,D.stringify)(l):String(l);if(this.cache.get(m)!==w)return this.cache.set(m,w),this.pendingInserts.set(m,w),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire({key:m,external:y}),this.doFlush()}async delete(m,l=!1){if(!(this.state===v.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire({key:m,external:l}),this.doFlush()}async optimize(){if(this.state!==v.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!(this.state===v.Closed||this.pendingClose))return this.doFlush(m)}async doFlush(m){return this.options.hint===L.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===L.STORAGE_IN_MEMORY}}e.Storage=P;class p{constructor(){this.onDidChangeItemsExternal=c.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((l,y)=>this.items.set(y,l)),m.delete?.forEach(l=>this.items.delete(l))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=p}),define(le[158],ue([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[73],ue([0,1,46,6,14,13,31,158]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=w,e.extract=f,e.buffer=R,T=De(T),L=De(L),e.CorruptZipMessage="end of central directory record signature not found";const _=new RegExp(e.CorruptZipMessage);class v extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=s,this.cause=r}}e.ExtractError=v;function P(g){const s=g.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function p(g){if(g instanceof v)return g;let s;return _.test(g.message)&&(s="CorruptZip"),new v(s,g)}function h(g,s,r,t,o,i){const n=T.dirname(s),a=T.join(t,n);if(!a.startsWith(t))return Promise.reject(new Error(L.localize(0,null,s)));const u=T.join(t,s);let d;return i.onCancellationRequested(()=>{d?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((b,A)=>{if(!i.isCancellationRequested)try{d=(0,C.createWriteStream)(u,{mode:r}),d.once("close",()=>b()),d.once("error",A),g.once("error",A),g.pipe(d)}catch(I){A(I)}}))}function m(g,s,r,t){let o=(0,c.createCancelablePromise)(()=>Promise.resolve()),i=0;const n=t.onCancellationRequested(()=>{o.cancel(),g.close()});return new Promise((a,u)=>{const d=new c.Sequencer,b=A=>{A.isCancellationRequested||(i++,g.readEntry())};g.once("error",u),g.once("close",()=>o.then(()=>{t.isCancellationRequested||g.entryCount===i?a():u(new v("Incomplete",new Error(L.localize(1,null,i,g.entryCount))))},u)),g.readEntry(),g.on("entry",A=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){b(t);return}const I=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(I)){const F=T.join(s,I);o=(0,c.createCancelablePromise)(U=>O.Promises.mkdir(F,{recursive:!0}).then(()=>b(U)).then(void 0,u));return}const E=y(g,A),k=P(A);o=(0,c.createCancelablePromise)(F=>d.queue(()=>E.then(U=>h(U,I,k,s,r,F).then(()=>b(F)))).then(null,u))})}).finally(()=>n.dispose())}async function l(g,s=!1){const{open:r}=await new Promise((t,o)=>{ne(["yauzl"],t,o)}).then(De);return new Promise((t,o)=>{r(g,s?{lazyEntries:!0}:void 0,(i,n)=>{i?o(p(i)):t((0,D.assertIsDefined)(n))})})}function y(g,s){return new Promise((r,t)=>{g.openReadStream(s,(o,i)=>{o?t(p(o)):r((0,D.assertIsDefined)(i))})})}async function w(g,s){const{ZipFile:r}=await new Promise((t,o)=>{ne(["yazl"],t,o)}).then(De);return new Promise((t,o)=>{const i=new r;s.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const n=(0,C.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",o),n.once("error",o),n.once("finish",()=>t(g))})}function f(g,s,r={},t){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let i=l(g,!0);return r.overwrite&&(i=i.then(n=>O.Promises.rm(s).then(()=>n))),i.then(n=>m(n,s,{sourcePathRegex:o},t))}function S(g,s){return l(g).then(r=>new Promise((t,o)=>{r.on("entry",i=>{i.fileName===s&&y(r,i).then(n=>t(n),n=>o(n))}),r.once("close",()=>o(new Error(L.localize(2,null,s))))}))}function R(g,s){return S(g,s).then(r=>new Promise((t,o)=>{const i=[];r.once("error",o),r.on("data",n=>i.push(n)),r.on("end",()=>t(Buffer.concat(i)))}))}}),define(le[159],ue([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],ue([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],ue([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],ue([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],ue([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],ue([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],ue([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],ue([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],ue([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],ue([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],ue([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],ue([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],ue([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],ue([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],ue([0,1,39,8,161]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(D||(e.TokenType=D={}));function O(...P){switch(P.length){case 1:return(0,T.localize)(0,null,P[0]);case 2:return(0,T.localize)(1,null,P[0],P[1]);case 3:return(0,T.localize)(2,null,P[0],P[1],P[2]);default:return}}const L=(0,T.localize)(3,null),_=(0,T.localize)(4,null);class v{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return p.isTripleEq?"===":"==";case D.NotEq:return p.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return p.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return p.lexeme;case D.QuotedStr:return p.lexeme;case D.Error:return p.lexeme;case D.EOF:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this._keywords=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this._errors}reset(p){return this._input=p,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case C.CharCode.OpenParen:this._addToken(D.LParen);break;case C.CharCode.CloseParen:this._addToken(D.RParen);break;case C.CharCode.ExclamationMark:if(this._match(C.CharCode.Equals)){const h=this._match(C.CharCode.Equals);this._tokens.push({type:D.NotEq,offset:this._start,isTripleEq:h})}else this._addToken(D.Neg);break;case C.CharCode.SingleQuote:this._quotedString();break;case C.CharCode.Slash:this._regex();break;case C.CharCode.Equals:if(this._match(C.CharCode.Equals)){const h=this._match(C.CharCode.Equals);this._tokens.push({type:D.Eq,offset:this._start,isTripleEq:h})}else this._match(C.CharCode.Tilde)?this._addToken(D.RegexOp):this._error(O("==","=~"));break;case C.CharCode.LessThan:this._addToken(this._match(C.CharCode.Equals)?D.LtEq:D.Lt);break;case C.CharCode.GreaterThan:this._addToken(this._match(C.CharCode.Equals)?D.GtEq:D.Gt);break;case C.CharCode.Ampersand:this._match(C.CharCode.Ampersand)?this._addToken(D.And):this._error(O("&&"));break;case C.CharCode.Pipe:this._match(C.CharCode.Pipe)?this._addToken(D.Or):this._error(O("||"));break;case C.CharCode.Space:case C.CharCode.CarriageReturn:case C.CharCode.Tab:case C.CharCode.LineFeed:case C.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(D.EOF),Array.from(this._tokens)}_match(p){return this._isAtEnd()||this._input.charCodeAt(this._current)!==p?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?C.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(p){this._tokens.push({type:p,offset:this._start})}_error(p){const h=this._start,m=this._input.substring(this._start,this._current),l={type:D.Error,offset:this._start,lexeme:m};this._errors.push({offset:h,lexeme:m,additionalInfo:p}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const p=this.stringRe.exec(this._input);if(p){this._current=this._start+p[0].length;const h=this._input.substring(this._start,this._current),m=v._keywords.get(h);m?this._addToken(m):this._tokens.push({type:D.Str,lexeme:h,offset:this._start})}}_quotedString(){for(;this._peek()!==C.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(L);return}this._advance(),this._tokens.push({type:D.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let p=this._current,h=!1,m=!1;for(;;){if(p>=this._input.length){this._current=p,this._error(_);return}const y=this._input.charCodeAt(p);if(h)h=!1;else if(y===C.CharCode.Slash&&!m){p++;break}else y===C.CharCode.OpenSquareBracket?m=!0:y===C.CharCode.Backslash?h=!0:y===C.CharCode.CloseSquareBracket&&(m=!1);p++}for(;p<this._input.length&&v._regexFlags.has(this._input.charCodeAt(p));)p++;this._current=p;const l=this._input.substring(this._start,this._current);this._tokens.push({type:D.RegexStr,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=v}),define(le[191],ue([0,1,68,88,23,14,37,21,9]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=P,e.parseDebugParams=p,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class v{get appRoot(){return(0,D.dirname)(T.FileAccess.asFileUri("").fsPath)}get userHome(){return _.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return _.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return _.URI.file(this.paths.tmpDir)}get cacheHome(){return _.URI.file(this.userDataPath)}get stateResource(){return(0,L.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,L.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return _.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(_.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,L.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,L.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=O.env.VSCODE_PORTABLE;return m?_.URI.file((0,D.join)(m,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return _.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(T.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?_.URI.file((0,D.resolve)(m)):_.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const l=O.env.VSCODE_EXTENSIONS;if(l)return l;const y=O.env.VSCODE_PORTABLE;return y?(0,D.join)(y,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(l=>/^[^:/?#]+?:\/\//.test(l)?_.URI.parse(l):_.URI.file((0,D.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?_.URI.parse(m):_.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const l of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);y&&y[1]&&y[2]&&m.push([y[1],y[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,L.joinPath)(_.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=O.env.VSCODE_PORTABLE;return m?_.URI.file((0,D.join)(m,"policy.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,l,y){this._args=m,this.paths=l,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=v,we([c.memoize],v.prototype,"appRoot",null),we([c.memoize],v.prototype,"userHome",null),we([c.memoize],v.prototype,"userDataPath",null),we([c.memoize],v.prototype,"appSettingsHome",null),we([c.memoize],v.prototype,"tmpDir",null),we([c.memoize],v.prototype,"cacheHome",null),we([c.memoize],v.prototype,"stateResource",null),we([c.memoize],v.prototype,"userRoamingDataHome",null),we([c.memoize],v.prototype,"userDataSyncHome",null),we([c.memoize],v.prototype,"sync",null),we([c.memoize],v.prototype,"machineSettingsResource",null),we([c.memoize],v.prototype,"workspaceStorageHome",null),we([c.memoize],v.prototype,"localHistoryHome",null),we([c.memoize],v.prototype,"keyboardLayoutResource",null),we([c.memoize],v.prototype,"argvResource",null),we([c.memoize],v.prototype,"isExtensionDevelopment",null),we([c.memoize],v.prototype,"untitledWorkspacesHome",null),we([c.memoize],v.prototype,"builtinExtensionsPath",null),we([c.memoize],v.prototype,"extensionsPath",null),we([c.memoize],v.prototype,"extensionDevelopmentLocationURI",null),we([c.memoize],v.prototype,"extensionDevelopmentKind",null),we([c.memoize],v.prototype,"extensionTestsLocationURI",null),we([c.memoize],v.prototype,"debugExtensionHost",null),we([c.memoize],v.prototype,"logLevel",null),we([c.memoize],v.prototype,"extensionLogLevel",null),we([c.memoize],v.prototype,"serviceMachineIdResource",null),we([c.memoize],v.prototype,"disableTelemetry",null),we([c.memoize],v.prototype,"disableWorkspaceTrust",null),we([c.memoize],v.prototype,"useInMemorySecretStorage",null),we([c.memoize],v.prototype,"policyFile",null);function P(h,m){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,m,h.debugId,h.extensionEnvironment)}function p(h,m,l,y,w,f){const R=Number(m||h)||(y?null:l),g=R?!!m:!1;let s;if(f)try{s=JSON.parse(f)}catch{}return{port:R,break:g,debugId:w,env:s}}}),function(){"use strict";function ne(e,C,c){function T(O,L){const _=D(O,L),v=[_];return e.isAbsolute(_)||v.unshift(c),e.resolve(...v)}function D(O,L){process.env.VSCODE_DEV&&(L="code-oss-dev");const _=process.env.VSCODE_PORTABLE;if(_)return e.join(_,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,L);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(p,"AppData","Roaming")}break;case"darwin":v=e.join(C.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,L)}return{getUserDataPath:T}}if(typeof define=="function")define(le[192],ue([280,38,37]),function(e,C,c){return ne(e,C,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=ne(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],ue([0,1,38,191,192]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=O,e.parseSharedProcessDebugPort=L;class D extends c.AbstractNativeEnvironmentService{constructor(v,P){super(v,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,T.getUserDataPath)(v,P.nameShort)},P)}}e.NativeEnvironmentService=D;function O(_,v){return(0,c.parseDebugParams)(_["inspect-ptyhost"],_["inspect-brk-ptyhost"],5877,v,_.extensionEnvironment)}function L(_,v){return(0,c.parseDebugParams)(_["inspect-sharedprocess"],_["inspect-brk-sharedprocess"],5879,v,_.extensionEnvironment)}}),define(le[194],ue([0,1,13,164]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=T;function T(O,L,_,v){try{D(O,L,_,v)}catch(P){O.error(P?.message??P)}return L}function D(O,L,_,v){const P=(p,h,m)=>{const l=p[h];if((0,C.isString)(l)){const y=l,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const f=y.substr(1,w-2);let S=_[f];S===void 0&&v&&(S=v[f]);const R=typeof S=="string"?S:S?.message,g=v?.[f],s=typeof g=="string"?g:g?.message;if(!R){s||O.warn(`[${L.name}]: ${(0,c.localize)(0,null,f)}`);return}if(m&&(h==="title"||h==="category")&&s&&s!==R){const r={value:R,original:s};p[h]=r}else p[h]=R}}else if((0,C.isObject)(l))for(const y in l)l.hasOwnProperty(y)&&(y==="commands"?P(l,y,!0):P(l,y,m));else if(Array.isArray(l))for(let y=0;y<l.length;y++)P(l,y,m)};for(const p in L)L.hasOwnProperty(p)&&P(L,p)}}),define(le[195],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class C{constructor(D){this.channel=D}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(D){return this.channel.call("promptImportantExtensionsInstallNotification",[D])}promptWorkspaceRecommendations(D){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=C;class c{constructor(D){this.service=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,L){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=c}),define(le[196],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const C={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(C)}),define(le[74],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(T,D=[],O=!1){this.ctor=T,this.staticArguments=D,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=C}),define(le[197],ue([0,1,74]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=D,e.getSingletonServiceDescriptors=O;const c=[];var T;(function(L){L[L.Eager=0]="Eager",L[L.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function D(L,_,v){_ instanceof C.SyncDescriptor||(_=new C.SyncDescriptor(_,[],!!v)),c.push([L,_])}function O(){return c}}),define(le[198],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(D,O){this.key=D,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class c{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(const O of this._nodes.values())O.outgoing.size===0&&D.push(O);return D}insertEdge(D,O){const L=this.lookupOrInsertNode(D),_=this.lookupOrInsertNode(O);L.outgoing.set(_.key,_),_.incoming.set(L.key,L)}removeNode(D){const O=this._hashFn(D);this._nodes.delete(O);for(const L of this._nodes.values())L.outgoing.delete(O),L.incoming.delete(O)}lookupOrInsertNode(D){const O=this._hashFn(D);let L=this._nodes.get(O);return L||(L=new C(O,D),this._nodes.set(O,L)),L}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){const D=[];for(const[O,L]of this._nodes)D.push(`${O}
	(-> incoming)[${[...L.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...L.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,O]of this._nodes){const L=new Set([D]),_=this._findCycle(O,L);if(_)return _}}_findCycle(D,O){for(const[L,_]of D.outgoing){if(O.has(L))return[...O,L].join(" -> ");O.add(L);const v=this._findCycle(_,O);if(v)return v;O.delete(L)}}}e.Graph=c}),define(le[4],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=T,e.refineServiceDecorator=D;var C;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function L(_){return _[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=L})(C||(e._util=C={})),e.IInstantiationService=T("instantiationService");function c(O,L,_){L[C.DI_TARGET]===L?L[C.DI_DEPENDENCIES].push({id:O,index:_}):(L[C.DI_DEPENDENCIES]=[{id:O,index:_}],L[C.DI_TARGET]=L)}function T(O){if(C.serviceIds.has(O))return C.serviceIds.get(O);const L=function(_,v,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(L,_,P)};return L.toString=()=>O,C.serviceIds.set(O,L),L}function D(O){return O}}),define(le[199],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,C.createDecorator)("checksumService")}),define(le[22],ue([0,1,13,9,4]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=D,e.isConfigurationUpdateOverrides=O,e.ConfigurationTargetToString=_,e.isConfigured=v,e.toValuesTree=P,e.addToValueTree=p,e.removeFromValueTree=h,e.getConfigurationValue=l,e.merge=y,e.getLanguageTagSettingPlainKey=w,C=De(C),e.IConfigurationService=(0,T.createDecorator)("configurationService");function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof c.URI)}function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof c.URI)}var L;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(L||(e.ConfigurationTarget=L={}));function _(f){switch(f){case L.APPLICATION:return"APPLICATION";case L.USER:return"USER";case L.USER_LOCAL:return"USER_LOCAL";case L.USER_REMOTE:return"USER_REMOTE";case L.WORKSPACE:return"WORKSPACE";case L.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case L.DEFAULT:return"DEFAULT";case L.MEMORY:return"MEMORY"}}function v(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function P(f,S){const R=Object.create(null);for(const g in f)p(R,g,f[g],S);return R}function p(f,S,R,g){const s=S.split("."),r=s.pop();let t=f;for(let o=0;o<s.length;o++){const i=s[o];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":if(n===null){g(`Ignoring ${S} as ${s.slice(0,o+1).join(".")} is null`);return}break;default:g(`Ignoring ${S} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[r]=R}catch{g(`Ignoring ${S} as ${s.join(".")} is ${JSON.stringify(t)}`)}else g(`Ignoring ${S} as ${s.join(".")} is ${JSON.stringify(t)}`)}function h(f,S){const R=S.split(".");m(f,R)}function m(f,S){const R=S.shift();if(S.length===0){delete f[R];return}if(Object.keys(f).indexOf(R)!==-1){const g=f[R];typeof g=="object"&&!Array.isArray(g)&&(m(g,S),Object.keys(g).length===0&&delete f[R])}}function l(f,S,R){function g(t,o){let i=t;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const s=S.split("."),r=g(f,s);return typeof r>"u"?R:r}function y(f,S,R){Object.keys(S).forEach(g=>{g!=="__proto__"&&(g in f?C.isObject(f[g])&&C.isObject(S[g])?y(f[g],S[g],R):R&&(f[g]=S[g]):f[g]=S[g])})}function w(f){return f.replace(/[\[\]]/g,"")}}),define(le[97],ue([0,1,39,5,27,190,4,160,8]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=P,e.validateWhenClauses=o,e.expressionsAreEqualWithConstantSubstitution=i,e.implies=W;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",c.isMacintosh),v.set("isLinux",c.isLinux),v.set("isWindows",c.isWindows),v.set("isWeb",c.isWeb),v.set("isMacNative",c.isMacintosh&&!c.isWeb),v.set("isEdge",c.isEdge),v.set("isFirefox",c.isFirefox),v.set("isChrome",c.isChrome),v.set("isSafari",c.isSafari);function P(j,N){if(v.get(j)!==void 0)throw(0,_.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(j,N)}const p=Object.prototype.hasOwnProperty;var h;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const m={regexParsingWithErrorRecovery:!0},l=(0,L.localize)(0,null),y=(0,L.localize)(1,null),w=(0,L.localize)(2,null),f=(0,L.localize)(3,null),S=(0,L.localize)(4,null),R=(0,L.localize)(5,null),g=(0,L.localize)(6,null),s=(0,L.localize)(7,null);class r{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(N=m){this._config=N,this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(N){if(N===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:y});return}this._tokens=this._scanner.reset(N).scan(),this._current=0,this._parsingErrors=[];try{const Y=this._expr();if(!this._isAtEnd()){const $=this._peek(),x=$.type===D.TokenType.Str?R:void 0;throw this._parsingErrors.push({message:S,offset:$.offset,lexeme:D.Scanner.getLexeme($),additionalInfo:x}),r._parseError}return Y}catch(Y){if(Y!==r._parseError)throw Y;return}}_expr(){return this._or()}_or(){const N=[this._and()];for(;this._matchOne(D.TokenType.Or);){const Y=this._and();N.push(Y)}return N.length===1?N[0]:t.or(...N)}_and(){const N=[this._term()];for(;this._matchOne(D.TokenType.And);){const Y=this._term();N.push(Y)}return N.length===1?N[0]:t.and(...N)}_term(){if(this._matchOne(D.TokenType.Neg)){const N=this._peek();switch(N.type){case D.TokenType.True:return this._advance(),a.INSTANCE;case D.TokenType.False:return this._advance(),u.INSTANCE;case D.TokenType.LParen:{this._advance();const Y=this._expr();return this._consume(D.TokenType.RParen,f),Y?.negate()}case D.TokenType.Str:return this._advance(),k.create(N.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",N)}}return this._primary()}_primary(){const N=this._peek();switch(N.type){case D.TokenType.True:return this._advance(),t.true();case D.TokenType.False:return this._advance(),t.false();case D.TokenType.LParen:{this._advance();const Y=this._expr();return this._consume(D.TokenType.RParen,f),Y}case D.TokenType.Str:{const Y=N.lexeme;if(this._advance(),this._matchOne(D.TokenType.RegexOp)){const x=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),x.type!==D.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",x);const J=x.lexeme,ee=J.lastIndexOf("/"),K=ee===J.length-1?void 0:this._removeFlagsGY(J.substring(ee+1));let oe;try{oe=new RegExp(J.substring(1,ee),K)}catch{throw this._errExpectedButGot("REGEX",x)}return Z.create(Y,oe)}switch(x.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const J=[x.lexeme];this._advance();let ee=this._peek(),K=0;for(let Pe=0;Pe<x.lexeme.length;Pe++)x.lexeme.charCodeAt(Pe)===C.CharCode.OpenParen?K++:x.lexeme.charCodeAt(Pe)===C.CharCode.CloseParen&&K--;for(;!this._isAtEnd()&&ee.type!==D.TokenType.And&&ee.type!==D.TokenType.Or;){switch(ee.type){case D.TokenType.LParen:K++;break;case D.TokenType.RParen:K--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Pe=0;Pe<ee.lexeme.length;Pe++)ee.lexeme.charCodeAt(Pe)===C.CharCode.OpenParen?K++:x.lexeme.charCodeAt(Pe)===C.CharCode.CloseParen&&K--}if(K<0)break;J.push(D.Scanner.getLexeme(ee)),this._advance(),ee=this._peek()}const oe=J.join(""),he=oe.lastIndexOf("/"),ge=he===oe.length-1?void 0:this._removeFlagsGY(oe.substring(he+1));let Se;try{Se=new RegExp(oe.substring(1,he),ge)}catch{throw this._errExpectedButGot("REGEX",x)}return t.regex(Y,Se)}case D.TokenType.QuotedStr:{const J=x.lexeme;this._advance();let ee=null;if(!(0,T.isFalsyOrWhitespace)(J)){const K=J.indexOf("/"),oe=J.lastIndexOf("/");if(K!==oe&&K>=0){const he=J.slice(K+1,oe),ge=J[oe+1]==="i"?"i":"";try{ee=new RegExp(he,ge)}catch{throw this._errExpectedButGot("REGEX",x)}}}if(ee===null)throw this._errExpectedButGot("REGEX",x);return Z.create(Y,ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(D.TokenType.Not)){this._consume(D.TokenType.In,w);const x=this._value();return t.notIn(Y,x)}switch(this._peek().type){case D.TokenType.Eq:{this._advance();const x=this._value();if(this._previous().type===D.TokenType.QuotedStr)return t.equals(Y,x);switch(x){case"true":return t.has(Y);case"false":return t.not(Y);default:return t.equals(Y,x)}}case D.TokenType.NotEq:{this._advance();const x=this._value();if(this._previous().type===D.TokenType.QuotedStr)return t.notEquals(Y,x);switch(x){case"true":return t.not(Y);case"false":return t.has(Y);default:return t.notEquals(Y,x)}}case D.TokenType.Lt:return this._advance(),H.create(Y,this._value());case D.TokenType.LtEq:return this._advance(),B.create(Y,this._value());case D.TokenType.Gt:return this._advance(),U.create(Y,this._value());case D.TokenType.GtEq:return this._advance(),M.create(Y,this._value());case D.TokenType.In:return this._advance(),t.in(Y,this._value());default:return t.has(Y)}}case D.TokenType.EOF:throw this._parsingErrors.push({message:g,offset:N.offset,lexeme:"",additionalInfo:s}),r._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const N=this._peek();switch(N.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this._advance(),N.lexeme;case D.TokenType.True:return this._advance(),"true";case D.TokenType.False:return this._advance(),"false";case D.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(N){return N.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(N){return this._check(N)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(N,Y){if(this._check(N))return this._advance();throw this._errExpectedButGot(Y,this._peek())}_errExpectedButGot(N,Y,$){const x=(0,L.localize)(8,null,N,D.Scanner.getLexeme(Y)),J=Y.offset,ee=D.Scanner.getLexeme(Y);return this._parsingErrors.push({message:x,offset:J,lexeme:ee,additionalInfo:$}),r._parseError}_check(N){return this._peek().type===N}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===D.TokenType.EOF}}e.Parser=r;class t{static false(){return a.INSTANCE}static true(){return u.INSTANCE}static has(N){return d.create(N)}static equals(N,Y){return b.create(N,Y)}static notEquals(N,Y){return E.create(N,Y)}static regex(N,Y){return Z.create(N,Y)}static in(N,Y){return A.create(N,Y)}static notIn(N,Y){return I.create(N,Y)}static not(N){return k.create(N)}static and(...N){return z.create(N,null,!0)}static or(...N){return q.create(N,null,!0)}static greater(N,Y){return U.create(N,Y)}static greaterEquals(N,Y){return M.create(N,Y)}static smaller(N,Y){return H.create(N,Y)}static smallerEquals(N,Y){return B.create(N,Y)}static{this._parser=new r({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this._parser.parse(N)}}e.ContextKeyExpr=t;function o(j){const N=new r({regexParsingWithErrorRecovery:!1});return j.map(Y=>(N.parse(Y),N.lexingErrors.length>0?N.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,L.localize)(9,null,$.additionalInfo):(0,L.localize)(10,null),offset:$.offset,length:$.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}function i(j,N){const Y=j?j.substituteConstants():void 0,$=N?N.substituteConstants():void 0;return!Y&&!$?!0:!Y||!$?!1:Y.equals($)}function n(j,N){return j.cmp(N)}class a{static{this.INSTANCE=new a}constructor(){this.type=h.False}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=a;class u{static{this.INSTANCE=new u}constructor(){this.type=h.True}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=u;class d{static create(N,Y=null){const $=v.get(N);return typeof $=="boolean"?$?u.INSTANCE:a.INSTANCE:new d(N,Y)}constructor(N,Y){this.key=N,this.negated=Y,this.type=h.Defined}cmp(N){return N.type!==this.type?this.type-N.type:se(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=v.get(this.key);return typeof N=="boolean"?N?u.INSTANCE:a.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class b{static create(N,Y,$=null){if(typeof Y=="boolean")return Y?d.create(N,$):k.create(N,$);const x=v.get(N);return typeof x=="boolean"?Y===(x?"true":"false")?u.INSTANCE:a.INSTANCE:new b(N,Y,$)}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.Equals}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=v.get(this.key);if(typeof N=="boolean"){const Y=N?"true":"false";return this.value===Y?u.INSTANCE:a.INSTANCE}return this}evaluate(N){return N.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(N){return N.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class A{static create(N,Y){return new A(N,Y)}constructor(N,Y){this.key=N,this.valueKey=Y,this.type=h.In,this.negated=null}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.valueKey,N.key,N.valueKey)}equals(N){return N.type===this.type?this.key===N.key&&this.valueKey===N.valueKey:!1}substituteConstants(){return this}evaluate(N){const Y=N.getValue(this.valueKey),$=N.getValue(this.key);return Array.isArray(Y)?Y.includes($):typeof $=="string"&&typeof Y=="object"&&Y!==null?p.call(Y,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(N){return N.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=A;class I{static create(N,Y){return new I(N,Y)}constructor(N,Y){this.key=N,this.valueKey=Y,this.type=h.NotIn,this._negated=A.create(N,Y)}cmp(N){return N.type!==this.type?this.type-N.type:this._negated.cmp(N._negated)}equals(N){return N.type===this.type?this._negated.equals(N._negated):!1}substituteConstants(){return this}evaluate(N){return!this._negated.evaluate(N)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(N){return N.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=I;class E{static create(N,Y,$=null){if(typeof Y=="boolean")return Y?k.create(N,$):d.create(N,$);const x=v.get(N);return typeof x=="boolean"?Y===(x?"true":"false")?a.INSTANCE:u.INSTANCE:new E(N,Y,$)}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.NotEquals}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=v.get(this.key);if(typeof N=="boolean"){const Y=N?"true":"false";return this.value===Y?a.INSTANCE:u.INSTANCE}return this}evaluate(N){return N.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(N){return N.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class k{static create(N,Y=null){const $=v.get(N);return typeof $=="boolean"?$?a.INSTANCE:u.INSTANCE:new k(N,Y)}constructor(N,Y){this.key=N,this.negated=Y,this.type=h.Not}cmp(N){return N.type!==this.type?this.type-N.type:se(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=v.get(this.key);return typeof N=="boolean"?N?a.INSTANCE:u.INSTANCE:this}evaluate(N){return!N.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(N){return N.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function F(j,N){if(typeof j=="string"){const Y=parseFloat(j);isNaN(Y)||(j=Y)}return typeof j=="string"||typeof j=="number"?N(j):a.INSTANCE}class U{static create(N,Y,$=null){return F(Y,x=>new U(N,x,$))}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.Greater}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class M{static create(N,Y,$=null){return F(Y,x=>new M(N,x,$))}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.GreaterEquals}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class H{static create(N,Y,$=null){return F(Y,x=>new H(N,x,$))}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.Smaller}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=H;class B{static create(N,Y,$=null){return F(Y,x=>new B(N,x,$))}constructor(N,Y,$){this.key=N,this.value=Y,this.negated=$,this.type=h.SmallerEquals}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class Z{static create(N,Y){return new Z(N,Y)}constructor(N,Y){this.key=N,this.regexp=Y,this.type=h.Regex,this.negated=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.key<N.key)return-1;if(this.key>N.key)return 1;const Y=this.regexp?this.regexp.source:"",$=N.regexp?N.regexp.source:"";return Y<$?-1:Y>$?1:0}equals(N){if(N.type===this.type){const Y=this.regexp?this.regexp.source:"",$=N.regexp?N.regexp.source:"";return this.key===N.key&&Y===$}return!1}substituteConstants(){return this}evaluate(N){const Y=N.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const N=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${N}`}keys(){return[this.key]}map(N){return N.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=V.create(this)),this.negated}}e.ContextKeyRegexExpr=Z;class V{static create(N){return new V(N)}constructor(N){this._actual=N,this.type=h.NotRegex}cmp(N){return N.type!==this.type?this.type-N.type:this._actual.cmp(N._actual)}equals(N){return N.type===this.type?this._actual.equals(N._actual):!1}substituteConstants(){return this}evaluate(N){return!this._actual.evaluate(N)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(N){return new V(this._actual.map(N))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=V;function ie(j){let N=null;for(let Y=0,$=j.length;Y<$;Y++){const x=j[Y].substituteConstants();if(j[Y]!==x&&N===null){N=[];for(let J=0;J<Y;J++)N[J]=j[J]}N!==null&&(N[Y]=x)}return N===null?j:N}class z{static create(N,Y,$){return z._normalizeArr(N,Y,$)}constructor(N,Y){this.expr=N,this.negated=Y,this.type=h.And}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let Y=0,$=this.expr.length;Y<$;Y++){const x=n(this.expr[Y],N.expr[Y]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let Y=0,$=this.expr.length;Y<$;Y++)if(!this.expr[Y].equals(N.expr[Y]))return!1;return!0}return!1}substituteConstants(){const N=ie(this.expr);return N===this.expr?this:z.create(N,this.negated,!1)}evaluate(N){for(let Y=0,$=this.expr.length;Y<$;Y++)if(!this.expr[Y].evaluate(N))return!1;return!0}static _normalizeArr(N,Y,$){const x=[];let J=!1;for(const ee of N)if(ee){if(ee.type===h.True){J=!0;continue}if(ee.type===h.False)return a.INSTANCE;if(ee.type===h.And){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&J)return u.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(n);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==h.Or)break;x.pop();const K=x.pop(),oe=x.length===0,he=q.create(ee.expr.map(ge=>z.create([ge,K],null,$)),null,oe);he&&(x.push(he),x.sort(n))}if(x.length===1)return x[0];if($){for(let ee=0;ee<x.length;ee++)for(let K=ee+1;K<x.length;K++)if(x[ee].negate().equals(x[K]))return a.INSTANCE;if(x.length===1)return x[0]}return new z(x,Y)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const Y of this.expr)N.push(...Y.keys());return N}map(N){return new z(this.expr.map(Y=>Y.map(N)),null)}negate(){if(!this.negated){const N=[];for(const Y of this.expr)N.push(Y.negate());this.negated=q.create(N,this,!0)}return this.negated}}e.ContextKeyAndExpr=z;class q{static create(N,Y,$){return q._normalizeArr(N,Y,$)}constructor(N,Y){this.expr=N,this.negated=Y,this.type=h.Or}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let Y=0,$=this.expr.length;Y<$;Y++){const x=n(this.expr[Y],N.expr[Y]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let Y=0,$=this.expr.length;Y<$;Y++)if(!this.expr[Y].equals(N.expr[Y]))return!1;return!0}return!1}substituteConstants(){const N=ie(this.expr);return N===this.expr?this:q.create(N,this.negated,!1)}evaluate(N){for(let Y=0,$=this.expr.length;Y<$;Y++)if(this.expr[Y].evaluate(N))return!0;return!1}static _normalizeArr(N,Y,$){let x=[],J=!1;if(N){for(let ee=0,K=N.length;ee<K;ee++){const oe=N[ee];if(oe){if(oe.type===h.False){J=!0;continue}if(oe.type===h.True)return u.INSTANCE;if(oe.type===h.Or){x=x.concat(oe.expr);continue}x.push(oe)}}if(x.length===0&&J)return a.INSTANCE;x.sort(n)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if($){for(let ee=0;ee<x.length;ee++)for(let K=ee+1;K<x.length;K++)if(x[ee].negate().equals(x[K]))return u.INSTANCE;if(x.length===1)return x[0]}return new q(x,Y)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const Y of this.expr)N.push(...Y.keys());return N}map(N){return new q(this.expr.map(Y=>Y.map(N)),null)}negate(){if(!this.negated){const N=[];for(const Y of this.expr)N.push(Y.negate());for(;N.length>1;){const Y=N.shift(),$=N.shift(),x=[];for(const J of G(Y))for(const ee of G($))x.push(z.create([J,ee],null,!1));N.unshift(q.create(x,null,!1))}this.negated=q.create(N,this,!0)}return this.negated}}e.ContextKeyOrExpr=q;class te extends d{static{this._info=[]}static all(){return te._info.values()}constructor(N,Y,$){super(N,null),this._defaultValue=Y,typeof $=="object"?te._info.push({...$,key:N}):$!==!0&&te._info.push({key:N,description:$,type:Y!=null?typeof Y:void 0})}bindTo(N){return N.createKey(this.key,this._defaultValue)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return b.create(this.key,N)}notEqualsTo(N){return E.create(this.key,N)}}e.RawContextKey=te,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function se(j,N){return j<N?-1:j>N?1:0}function ce(j,N,Y,$){return j<Y?-1:j>Y?1:N<$?-1:N>$?1:0}function W(j,N){if(j.type===h.False||N.type===h.True)return!0;if(j.type===h.Or)return N.type===h.Or?Q(j.expr,N.expr):!1;if(N.type===h.Or){for(const Y of N.expr)if(W(j,Y))return!0;return!1}if(j.type===h.And){if(N.type===h.And)return Q(N.expr,j.expr);for(const Y of j.expr)if(W(Y,N))return!0;return!1}return j.equals(N)}function Q(j,N){let Y=0,$=0;for(;Y<j.length&&$<N.length;){const x=j[Y].cmp(N[$]);if(x<0)return!1;x===0&&Y++,$++}return Y===j.length}function G(j){return j.type===h.Or?j.expr:[j]}}),define(le[98],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=c,e.ID="diagnosticsService",e.IDiagnosticsService=(0,C.createDecorator)(e.ID);function c(D){return!!D.hostName&&!!D.errorMessage}class T{async getPerformanceInfo(O,L){return{}}async getSystemInfo(O,L){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,L){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=T}),define(le[99],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,C.createDecorator)("downloadService")}),define(le[16],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(le[75],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=T;var c;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function T(O){switch(O){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var D;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(D||(e.RecommendationsNotificationResult=D={})),e.IExtensionRecommendationNotificationService=(0,C.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[7],ue([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=h,e.isFileSystemWatcher=w,e.hasReadWriteCapability=S,e.hasFileFolderCopyCapability=R,e.hasFileCloneCapability=g,e.hasOpenReadWriteCloseCapability=s,e.hasFileReadStreamCapability=r,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=o,e.hasFileAtomicDeleteCapability=i,e.hasReadonlyCapability=n,e.createFileSystemProviderError=d,e.ensureFileSystemProviderError=b,e.markAsFileSystemProviderError=A,e.toFileSystemProviderErrorCode=I,e.toFileOperationResult=E,e.isParent=H,e.etag=q,e.whenProviderRegistered=te,e.getLargeFileConfirmationLimit=ce,e.IFileService=(0,_.createDecorator)("fileService");function h(W){return W.create===!0}var m;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var l;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var y;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function w(W){const Q=W;return!!Q&&typeof Q.onDidChange=="function"}var f;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function S(W){return!!(W.capabilities&f.FileReadWrite)}function R(W){return!!(W.capabilities&f.FileFolderCopy)}function g(W){return!!(W.capabilities&f.FileClone)}function s(W){return!!(W.capabilities&f.FileOpenReadWriteClose)}function r(W){return!!(W.capabilities&f.FileReadStream)}function t(W){return S(W)?!!(W.capabilities&f.FileAtomicRead):!1}function o(W){return S(W)?!!(W.capabilities&f.FileAtomicWrite):!1}function i(W){return!!(W.capabilities&f.FileAtomicDelete)}function n(W){return!!(W.capabilities&f.Readonly)}var a;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class u extends Error{static create(Q,G){const j=new u(Q.toString(),G);return A(j,G),j}constructor(Q,G){super(Q),this.code=G}}e.FileSystemProviderError=u;function d(W,Q){return u.create(W,Q)}function b(W){return W||d((0,L.localize)(0,null),a.Unknown)}function A(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}function I(W){if(!W)return a.Unknown;if(W instanceof u)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return a.Unknown;switch(Q[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}function E(W){if(W instanceof B)return W.fileOperationResult;switch(I(W)){case a.FileNotFound:return ie.FILE_NOT_FOUND;case a.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case a.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case a.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case a.NoPermissions:return ie.FILE_PERMISSION_DENIED;case a.FileExists:return ie.FILE_MOVE_CONFLICT;case a.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var k;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class F{constructor(Q,G,j){this.resource=Q,this.operation=G,this.target=j}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=F;var U;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class M{static{this.MIXED_CORRELATION=null}constructor(Q,G){this.ignorePathCasing=G,this.correlationId=void 0,this.added=new p.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawAdded.map(N=>[N,!0])),j}),this.updated=new p.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawUpdated.map(N=>[N,!0])),j}),this.deleted=new p.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawDeleted.map(N=>[N,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of Q){switch(j.type){case U.ADDED:this.rawAdded.push(j.resource);break;case U.UPDATED:this.rawUpdated.push(j.resource);break;case U.DELETED:this.rawDeleted.push(j.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof j.cId=="number"?this.correlationId===void 0?this.correlationId=j.cId:this.correlationId!==j.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(Q,...G){return this.doContains(Q,{includeChildren:!1},...G)}affects(Q,...G){return this.doContains(Q,{includeChildren:!0},...G)}doContains(Q,G,...j){if(!Q)return!1;const N=j.length>0;return!!((!N||j.includes(U.ADDED))&&(this.added.value.get(Q)||G.includeChildren&&this.added.value.findSuperstr(Q))||(!N||j.includes(U.UPDATED))&&(this.updated.value.get(Q)||G.includeChildren&&this.updated.value.findSuperstr(Q))||(!N||j.includes(U.DELETED))&&(this.deleted.value.findSubstr(Q)||G.includeChildren&&this.deleted.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.correlationId===Q}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function H(W,Q,G){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==c.sep&&(Q+=c.sep),G?(0,T.startsWithIgnoreCase)(W,Q):W.indexOf(Q)===0)}class B extends Error{constructor(Q,G,j){super(Q),this.fileOperationResult=G,this.options=j}}e.FileOperationError=B;class Z extends B{constructor(Q,G,j,N){super(Q,G,N),this.fileOperationResult=G,this.size=j}}e.TooLargeFileOperationError=Z;class V extends B{constructor(Q,G,j){super(Q,ie.FILE_NOT_MODIFIED_SINCE,j),this.stat=G}}e.NotModifiedSinceFileOperationError=V;var ie;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var z;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.ETAG_DISABLED="";function q(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function te(W,Q){if(!Q.hasProvider(O.URI.from({scheme:W.scheme})))return new Promise(G=>{const j=Q.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===W.scheme&&N.added&&(j.dispose(),G())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(Q){return(0,D.isNumber)(Q)||(Q=0),Q<se.KB?(0,L.localize)(1,null,Q.toFixed(0)):Q<se.MB?(0,L.localize)(2,null,(Q/se.KB).toFixed(2)):Q<se.GB?(0,L.localize)(3,null,(Q/se.MB).toFixed(2)):Q<se.TB?(0,L.localize)(4,null,(Q/se.GB).toFixed(2)):(0,L.localize)(5,null,(Q/se.TB).toFixed(2))}}e.ByteSize=se;function ce(W){const Q=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*se.MB:Q?10*se.MB:v.isWeb?50*se.MB:1024*se.MB}});var X=this&&this.__param||function(ne,e){return function(C,c){e(C,c,ne)}};define(le[200],ue([0,1,76,51,7]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let D=class{constructor(L){this.fileService=L}async checksum(L){const _=(await this.fileService.readFileStream(L)).value;return new Promise((v,P)=>{const p=(0,C.createHash)("sha256");(0,c.listenStream)(_,{onData:h=>p.update(h.buffer),onError:h=>P(h),onEnd:()=>v(p.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=D,e.ChecksumService=D=we([X(0,T.IFileService)],D)}),define(le[100],ue([0,1,15,8,171,7]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=O;async function O(P,p,h,m,l,y){let w;try{await L(P,p,h,m,l,y)}catch(f){w=f}finally{w&&l.errorTransformer&&(w=l.errorTransformer(w)),typeof w<"u"&&h.error(w),h.end()}}async function L(P,p,h,m,l,y){_(y);const w=await P.open(p,{create:!1});try{_(y);let f=0,S=0,R=l&&typeof l.length=="number"?l.length:void 0,g=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof R=="number"?R:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,r=0;do S=await P.read(w,s,g.buffer,r,g.byteLength-r),s+=S,r+=S,f+=S,typeof R=="number"&&(R-=S),r===g.byteLength&&(await h.write(m(g)),g=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof R=="number"?R:l.bufferSize)),r=0);while(S>0&&(typeof R!="number"||R>0)&&_(y)&&v(f,l));if(r>0){let t=r;typeof R=="number"&&(t=Math.min(r,R)),h.write(m(g.slice(0,t)))}}catch(f){throw(0,D.ensureFileSystemProviderError)(f)}finally{await P.close(w)}}function _(P){if(P.isCancellationRequested)throw(0,c.canceled)();return!0}function v(P,p){if(typeof p?.limits?.size=="number"&&P>p.limits.size)throw(0,D.createFileSystemProviderError)((0,T.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],ue([0,1,94,2,14,5,9,7]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=_,e.isRecursiveWatchRequest=v,e.reviveFileChanges=m,e.coalesceEvents=l,e.normalizeWatcherPattern=y,e.parseWatcherPatterns=w,e.isFiltered=S,e.requestFilterToString=R;function _(g){return typeof g.correlationId=="number"}function v(g){return g.recursive===!0}class P extends c.Disposable{static{this.MAX_RESTARTS=5}constructor(s,r,t,o){super(),this.onFileChanges=s,this.onLogMessage=r,this.verboseLogging=t,this.options=o,this.watcherDisposables=this._register(new c.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const s=new c.DisposableStore;this.watcherDisposables.value=s,this.watcher=this.createWatcher(s),this.watcher.setVerboseLogging(this.verboseLogging),s.add(this.watcher.onDidChangeFile(r=>this.onFileChanges(r))),s.add(this.watcher.onDidLogMessage(r=>this.onLogMessage(r))),s.add(this.watcher.onDidError(r=>this.onError(r.error,r.request)))}onError(s,r){this.canRestart(s,r)?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${s}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${s}`):this.error(s)}canRestart(s,r){return!(!this.options.restartOnError||r||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}restart(s){this.restartCounter++,this.init(),this.watch(s)}async watch(s){this.requests=s,await this.watcher?.watch(s)}async setVerboseLogging(s){this.verboseLogging=s,await this.watcher?.setVerboseLogging(s)}error(s){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${s}`})}trace(s){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${s}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P;class p extends P{constructor(s,r,t){super(s,r,t,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class h extends P{constructor(s,r,t){super(s,r,t,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=h;function m(g){return g.map(s=>({type:s.type,resource:O.URI.revive(s.resource),cId:s.cId}))}function l(g){const s=new f;for(const r of g)s.processEvent(r);return s.coalesce()}function y(g,s){return typeof s=="string"&&!s.startsWith(C.GLOBSTAR)&&!(0,T.isAbsolute)(s)?{base:g,pattern:s}:s}function w(g,s){const r=[];for(const t of s)r.push((0,C.parse)(y(g,t)));return r}class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(s){return D.isLinux?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const r=this.mapPathToChange.get(this.toKey(s));let t=!1;if(r){const o=r.type,i=s.type;r.resource.fsPath!==s.resource.fsPath&&(s.type===L.FileChangeType.DELETED||s.type===L.FileChangeType.ADDED)?t=!0:o===L.FileChangeType.ADDED&&i===L.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(s)),this.coalesced.delete(r)):o===L.FileChangeType.DELETED&&i===L.FileChangeType.ADDED?r.type=L.FileChangeType.UPDATED:o===L.FileChangeType.ADDED&&i===L.FileChangeType.UPDATED||(r.type=i)}else t=!0;t&&(this.coalesced.add(s),this.mapPathToChange.set(this.toKey(s),s))}coalesce(){const s=[],r=[];return Array.from(this.coalesced).filter(t=>t.type!==L.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>r.some(o=>(0,L.isParent)(t.resource.fsPath,o,!D.isLinux))?!1:(r.push(t.resource.fsPath),!0)).concat(s)}}function S(g,s){if(typeof s=="number")switch(g.type){case L.FileChangeType.ADDED:return(s&L.FileChangeFilter.ADDED)===0;case L.FileChangeType.DELETED:return(s&L.FileChangeFilter.DELETED)===0;case L.FileChangeType.UPDATED:return(s&L.FileChangeFilter.UPDATED)===0}return!1}function R(g){if(typeof g=="number"){const s=[];return g&L.FileChangeFilter.ADDED&&s.push("Added"),g&L.FileChangeFilter.DELETED&&s.push("Deleted"),g&L.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(le[201],ue([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class p extends O.Disposable{constructor(m,l){super(),this.channel=m,this.extraCapabilities=l,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,_.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=v.FileSystemProviderCapabilities.FileReadWrite|v.FileSystemProviderCapabilities.FileOpenReadWriteClose|v.FileSystemProviderCapabilities.FileReadStream|v.FileSystemProviderCapabilities.FileFolderCopy|v.FileSystemProviderCapabilities.FileWriteUnlock|v.FileSystemProviderCapabilities.FileAtomicRead|v.FileSystemProviderCapabilities.FileAtomicWrite|v.FileSystemProviderCapabilities.FileAtomicDelete|v.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=v.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=v.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,l){const{buffer:y}=await this.channel.call("readFile",[m,l]);return y}readFileStream(m,l,y){const w=(0,L.newWriteableStream)(S=>C.VSBuffer.concat(S.map(R=>C.VSBuffer.wrap(R))).buffer),f=new O.DisposableStore;return f.add(this.channel.listen("readFileStream",[m,l])(S=>{if(S instanceof C.VSBuffer)w.write(S.buffer);else{if(S==="end")w.end();else{let R;if(S instanceof Error)R=S;else{const g=S;R=(0,v.createFileSystemProviderError)(g.message??(0,c.toErrorMessage)(g),g.code??v.FileSystemProviderErrorCode.Unknown)}w.error(R),w.end()}f.dispose()}})),f.add(y.onCancellationRequested(()=>{w.error((0,T.canceled)()),w.end(),f.dispose()})),w}writeFile(m,l,y){return this.channel.call("writeFile",[m,C.VSBuffer.wrap(l),y])}open(m,l){return this.channel.call("open",[m,l])}close(m){return this.channel.call("close",[m])}async read(m,l,y,w,f){const[S,R]=await this.channel.call("read",[m,l,f]);return y.set(S.buffer.slice(0,R),w),R}write(m,l,y,w,f){return this.channel.call("write",[m,l,C.VSBuffer.wrap(y),w,f])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,l){return this.channel.call("delete",[m,l])}rename(m,l,y){return this.channel.call("rename",[m,l,y])}copy(m,l,y){return this.channel.call("copy",[m,l,y])}cloneFile(m,l){return this.channel.call("cloneFile",[m,l])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const l=m;this._onDidChange.fire((0,P.reviveFileChanges)(l))}else{const l=m;this._onDidWatchError.fire(l)}}))}watch(m,l){const y=(0,_.generateUuid)();return this.channel.call("watch",[this.sessionId,y,m,l]),(0,O.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=p}),define(le[202],ue([0,1,46,2,47,3,7,9,6]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class v extends c.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new D.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new c.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new _.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new _.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(p=>this.handleDidWatchFail(p)))}handleDidWatchFail(p){this.isCorrelated(p)&&this.suspendWatchRequest(p)}isCorrelated(p){return(0,T.isWatchRequestWithCorrelation)(p)}async watch(p){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new _.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const h of p)this.isCorrelated(h)?this.allCorrelatedWatchRequests.set(h.correlationId,h):this.allNonCorrelatedWatchRequests.add(h);for(const[h]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(h)||(this.suspendedWatchRequests.deleteAndDispose(h),this.suspendedWatchRequestsWithPolling.delete(h));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(p){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(h=>!this.suspendedWatchRequests.has(h.correlationId))]),p?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(p){return typeof p.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(p.correlationId)?"polling":this.suspendedWatchRequests.has(p.correlationId)}async suspendWatchRequest(p){if(this.suspendedWatchRequests.has(p.correlationId))return;const h=new c.DisposableStore;this.suspendedWatchRequests.set(p.correlationId,h),await this.joinWatch.p,!h.isDisposed&&(this.monitorSuspendedWatchRequest(p,h),this.updateWatchers(!0))}resumeWatchRequest(p){this.suspendedWatchRequests.deleteAndDispose(p.correlationId),this.suspendedWatchRequestsWithPolling.delete(p.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(p,h){this.doMonitorWithExistingWatcher(p,h)?(this.trace(`reusing an existing recursive watcher to monitor ${p.path}`),this.suspendedWatchRequestsWithPolling.delete(p.correlationId)):(this.doMonitorWithNodeJS(p,h),this.suspendedWatchRequestsWithPolling.add(p.correlationId))}doMonitorWithExistingWatcher(p,h){const m=this.recursiveWatcher?.subscribe(p.path,(l,y)=>{h.isDisposed||(l?this.monitorSuspendedWatchRequest(p,h):y?.type===O.FileChangeType.ADDED&&this.onMonitoredPathAdded(p))});return m?(h.add(m),!0):!1}doMonitorWithNodeJS(p,h){let m=!1;const l=(y,w)=>{if(h.isDisposed)return;const f=this.isPathNotFound(y),S=this.isPathNotFound(w),R=m;m=f,!f&&(S||R)&&this.onMonitoredPathAdded(p)};this.trace(`starting fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,C.watchFile)(p.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},l)}catch(y){this.warn(`fs.watchFile() failed with error ${y} on path ${p.path} (correlationId: ${p.correlationId})`)}h.add((0,c.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,C.unwatchFile)(p.path,l)}catch(y){this.warn(`fs.unwatchFile() failed with error ${y} on path ${p.path} (correlationId: ${p.correlationId})`)}}))}onMonitoredPathAdded(p){this.trace(`detected ${p.path} exists again, resuming watcher (correlationId: ${p.correlationId})`);const h={resource:L.URI.file(p.path),type:O.FileChangeType.ADDED,cId:p.correlationId};this._onDidChangeFile.fire([h]),this.traceEvent(h,p),this.resumeWatchRequest(p)}isPathNotFound(p){return p.ctimeMs===0&&p.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(p,h){if(this.verboseLogging){const m=` >> normalized ${p.type===O.FileChangeType.ADDED?"[ADDED]":p.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`;this.traceWithCorrelation(m,h)}}traceWithCorrelation(p,h){this.verboseLogging&&this.trace(`${p}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}requestToString(p){return`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, filter: ${(0,T.requestFilterToString)(p.filter)}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`}async setVerboseLogging(p){this.verboseLogging=p}}e.BaseWatcher=v}),define(le[203],ue([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=f;class w extends O.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(R,g,s,r,t,o){super(),this.request=R,this.recursiveWatcher=g,this.onDidFilesChange=s,this.onDidWatchFail=r,this.onLogMessage=t,this.verboseLogging=o,this.throttledFileChangesEmitter=this._register(new c.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new c.RunOnceWorker(i=>this.handleFileChanges(i),w.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,y.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const R=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await m.Promises.stat(R);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(R,g.isDirectory()))}catch(R){R.code!=="ENOENT"?this.error(R):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${R})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(R){let g=R.path;try{g=await m.Promises.realpath(R.path),R.path===g&&(g=await(0,h.realcase)(R.path,this.cts.token)??R.path),R.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${R.path}, real: ${g})`)}catch{}return g}async doWatch(R,g){const s=new O.DisposableStore;return this.doWatchWithExistingWatcher(R,g,s)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(R,g,s)),s}doWatchWithExistingWatcher(R,g,s){if(g)return!1;const r=p.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(o,i)=>{if(!s.isDisposed)if(o){const n=await this.doWatch(R,g);s.isDisposed?n.dispose():s.add(n)}else i&&(typeof i.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:r,type:i.type,cId:this.request.correlationId},!0)});return t?(s.add(t),!0):!1}async doWatchWithNodeJS(R,g,s){if(v.isMacintosh&&(0,D.isEqualOrParent)(R,"/Volumes/",!0)){this.error(`Refusing to watch ${R} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new T.CancellationTokenSource(this.cts.token);s.add((0,O.toDisposable)(()=>r.dispose(!0)));const t=new O.DisposableStore;s.add(t);try{const o=p.URI.file(this.request.path),i=(0,_.basename)(R),n=(0,C.watch)(R);t.add((0,O.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${R}'`);const a=new Set;if(g)try{for(const d of await m.Promises.readdir(R))a.add(d)}catch(d){this.error(d)}if(r.token.isCancellationRequested)return;const u=new Map;t.add((0,O.toDisposable)(()=>{for(const[,d]of u)d.dispose();u.clear()})),n.on("error",(d,b)=>{r.token.isCancellationRequested||(this.error(`Failed to watch ${R} for changes using fs.watch() (${d}, ${b})`),this.notifyWatchFailed())}),n.on("change",(d,b)=>{if(r.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${d}"] ${b}`);let A="";if(b&&(A=b.toString(),v.isMacintosh&&(A=(0,L.normalizeNFC)(A))),!(!A||d!=="change"&&d!=="rename"))if(g)if(d==="rename"){u.get(A)?.dispose();const I=setTimeout(async()=>{if(u.delete(A),A===i&&!await m.Promises.exists(R)){this.onWatchedPathDeleted(o);return}if(r.token.isCancellationRequested)return;const E=await this.existsChildStrictCase((0,_.join)(R,A));if(r.token.isCancellationRequested)return;let k;E?a.has(A)?k=l.FileChangeType.UPDATED:(k=l.FileChangeType.ADDED,a.add(A)):(a.delete(A),k=l.FileChangeType.DELETED),this.onFileChange({resource:(0,P.joinPath)(o,A),type:k,cId:this.request.correlationId})},w.FILE_DELETE_HANDLER_DELAY);u.set(A,(0,O.toDisposable)(()=>clearTimeout(I)))}else{let I;a.has(A)?I=l.FileChangeType.UPDATED:(I=l.FileChangeType.ADDED,a.add(A)),this.onFileChange({resource:(0,P.joinPath)(o,A),type:I,cId:this.request.correlationId})}else if(d==="rename"||A!==i){const I=setTimeout(async()=>{const E=await m.Promises.exists(R);r.token.isCancellationRequested||(E?(this.onFileChange({resource:o,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0),t.add(await this.doWatch(R,!1))):this.onWatchedPathDeleted(o))},w.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,O.toDisposable)(()=>clearTimeout(I)))}else this.onFileChange({resource:o,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(o){r.token.isCancellationRequested||this.error(`Failed to watch ${R} for changes using fs.watch() (${o.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(R){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:R,type:l.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(R,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${R.type===l.FileChangeType.ADDED?"[ADDED]":R.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${R.resource.fsPath}`),!g&&this.excludes.some(s=>s(R.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${R.resource.fsPath}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(s=>s(R.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${R.resource.fsPath}`):this.fileChangesAggregator.work(R))}handleFileChanges(R){const g=(0,y.coalesceEvents)(R),s=[];for(const t of g){if((0,y.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.verboseLogging)for(const t of s)this.traceWithCorrelation(` >> normalized ${t.type===l.FileChangeType.ADDED?"[ADDED]":t.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(s)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(R){if(v.isLinux)return m.Promises.exists(R);try{const g=(0,_.basename)(R);return(await m.Promises.readdir((0,_.dirname)(R))).some(r=>r===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(R){this.verboseLogging=R}error(R){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${R}`})}warn(R){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${R}`})}trace(R){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${R}`})}traceWithCorrelation(R){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${R}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w;async function f(S,R,g,s,r=512){const t=await m.Promises.open(S,"r"),o=Buffer.allocUnsafe(r),i=new T.CancellationTokenSource(s);let n,a=!1;const u={path:S,excludes:[],recursive:!1},d=new w(u,void 0,b=>{(async()=>{for(const{type:A}of b)if(A===l.FileChangeType.UPDATED){if(a)return;a=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(t,o,0,r,null);if(!I||i.token.isCancellationRequested)break;R(o.slice(0,I))}}catch(I){n=new Error(I),i.dispose(!0)}finally{a=!1}}})()});return await d.ready,g(),new Promise((b,A)=>{i.token.onCancellationRequested(async()=>{d.dispose();try{await m.Promises.close(t)}catch(I){n=new Error(I)}n?A(n):b()})})}}),define(le[204],ue([0,1,3,94,202,5,203,42]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class _ extends T.BaseWatcher{constructor(P){super(),this.recursiveWatcher=P,this.onDidError=C.Event.None,this.watchers=new Set}async doWatch(P){P=this.removeDuplicateRequests(P);const p=[],h=new Set(Array.from(this.watchers));for(const m of P){const l=this.findWatcher(m);l&&(0,c.patternsEquals)(l.request.excludes,m.excludes)&&(0,c.patternsEquals)(l.request.includes,m.includes)?h.delete(l):p.push(m)}p.length&&this.trace(`Request to start watching: ${p.map(m=>this.requestToString(m)).join(",")}`),h.size&&this.trace(`Request to stop watching: ${Array.from(h).map(m=>this.requestToString(m.request)).join(",")}`);for(const m of h)this.stopWatching(m);for(const m of p)this.startWatching(m)}findWatcher(P){for(const p of this.watchers)if(typeof P.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===P.correlationId)return p}else if((0,L.isEqual)(p.request.path,P.path,!D.isLinux))return p}startWatching(P){const p=new O.NodeJSFileWatcherLibrary(P,this.recursiveWatcher,m=>this._onDidChangeFile.fire(m),()=>this._onDidWatchFail.fire(P),m=>this._onDidLogMessage.fire(m),this.verboseLogging),h={request:P,instance:p};this.watchers.add(h)}async stop(){await super.stop();for(const P of this.watchers)this.stopWatching(P)}stopWatching(P){this.trace("stopping file watcher",P),this.watchers.delete(P),P.instance.dispose()}removeDuplicateRequests(P){const p=new Map;for(const h of P){const m=D.isLinux?h.path:h.path.toLowerCase();let l=p.get(h.correlationId);l||(l=new Map,p.set(h.correlationId,l)),l.has(m)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(h)}`),l.set(m,h)}return Array.from(p.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(P){super.setVerboseLogging(P);for(const p of this.watchers)p.instance.setVerboseLogging(P)}trace(P,p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P,p)})}warn(P){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(P)})}toMessage(P,p){return p?`[File Watcher (node.js)] ${P} (${this.requestToString(p.request)})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=_}),define(le[205],ue([0,1,47,204]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends C.AbstractNonRecursiveWatcherClient{constructor(O,L,_){super(O,L,_),this.init()}createWatcher(O){return O.add(new c.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=T}),define(le[206],ue([0,1,23,43,96,47]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends D.AbstractUniversalWatcherClient{constructor(_,v,P){super(_,v,P),this.init()}createWatcher(_){const v=_.add(new T.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return _.add(v.onDidProcessExit(({code:P,signal:p})=>this.onError(`terminated by itself with code ${P}, signal: ${p} (ETERM)`))),c.ProxyChannel.toService((0,c.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(le[77],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...T){this._entries=new Map;for(const[D,O]of T)this.set(D,O)}set(T,D){const O=this._entries.get(T);return this._entries.set(T,D),O}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=C}),define(le[207],ue([0,1,6,8,2,74,198,4,77,90]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class p extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class h{constructor(w=new _.ServiceCollection,f=!1,S,R=P){this._services=w,this._strict=f,this._parent=S,this._enableTracing=R,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(L.IInstantiationService,this),this._globalGraph=R?S?._globalGraph??new O.Graph(g=>g):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,T.dispose)(this._children),this._children.clear();for(const w of this._servicesToMaybeDispose)(0,T.isDisposable)(w)&&w.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(w,f){this._throwIfDisposed();const S=this,R=new class extends h{dispose(){S._children.delete(R),super.dispose()}}(w,this._strict,this,this._enableTracing);return this._children.add(R),f?.add(R),R}invokeFunction(w,...f){this._throwIfDisposed();const S=l.traceInvocation(this._enableTracing,w);let R=!1;try{return w({get:s=>{if(R)throw(0,c.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(s,S);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...f)}finally{R=!0,S.stop()}}createInstance(w,...f){this._throwIfDisposed();let S,R;return w instanceof D.SyncDescriptor?(S=l.traceCreation(this._enableTracing,w.ctor),R=this._createInstance(w.ctor,w.staticArguments.concat(f),S)):(S=l.traceCreation(this._enableTracing,w),R=this._createInstance(w,f,S)),S.stop(),R}_createInstance(w,f=[],S){const R=L._util.getServiceDependencies(w).sort((r,t)=>r.index-t.index),g=[];for(const r of R){const t=this._getOrCreateServiceInstance(r.id,S);t||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${r.id}.`,!1),g.push(t)}const s=R.length>0?R[0].index:f.length;if(f.length!==s){console.trace(`[createInstance] First service dependency of ${w.name} at position ${s+1} conflicts with ${f.length} static arguments`);const r=s-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,s)}return Reflect.construct(w,f.concat(g))}_setCreatedServiceInstance(w,f){if(this._services.get(w)instanceof D.SyncDescriptor)this._services.set(w,f);else if(this._parent)this._parent._setCreatedServiceInstance(w,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const f=this._services.get(w);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):f}_getOrCreateServiceInstance(w,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const S=this._getServiceInstanceOrDescriptor(w);return S instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,S,f.branch(w,!0)):(f.branch(w,!1),S)}_safeCreateAndCacheServiceInstance(w,f,S){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,f,S)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,f,S){const R=new O.Graph(r=>r.id.toString());let g=0;const s=[{id:w,desc:f,_trace:S}];for(;s.length;){const r=s.pop();if(R.lookupOrInsertNode(r),g++>1e3)throw new p(R);for(const t of L._util.getServiceDependencies(r.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(t.id);if(o||this._throwIfStrict(`[createInstance] ${w} depends on ${t.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(t.id)),o instanceof D.SyncDescriptor){const i={id:t.id,desc:o,_trace:r._trace.branch(t.id,!0)};R.insertEdge(r,i),s.push(i)}}}for(;;){const r=R.roots();if(r.length===0){if(!R.isEmpty())throw new p(R);break}for(const{data:t}of r){if(this._getServiceInstanceOrDescriptor(t.id)instanceof D.SyncDescriptor){const i=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setCreatedServiceInstance(t.id,i)}R.removeNode(t)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,f,S=[],R,g){if(this._services.get(w)instanceof D.SyncDescriptor)return this._createServiceInstance(w,f,S,R,g,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,f,S,R,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(w,f,S=[],R,g,s){if(R){const r=new h(void 0,this._strict,this,this._enableTracing);r._globalGraphImplicitDependency=String(w);const t=new Map,o=new C.GlobalIdleValue(()=>{const i=r._createInstance(f,S,g);for(const[n,a]of t){const u=i[n];if(typeof u=="function")for(const d of a)d.disposable=u.apply(i,d.listener)}return t.clear(),s.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let d=t.get(n);return d||(d=new v.LinkedList,t.set(n,d)),(A,I,E)=>{if(o.isInitialized)return o.value[n](A,I,E);{const k={listener:[A,I,E],disposable:void 0},F=d.push(k);return(0,T.toDisposable)(()=>{F(),k.disposable?.dispose()})}}}if(n in i)return i[n];const a=o.value;let u=a[n];return typeof u!="function"||(u=u.bind(a),i[n]=u),u},set(i,n,a){return o.value[n]=a,!0},getPrototypeOf(i){return f.prototype}})}else{const r=this._createInstance(f,S,g);return s.add(r),r}}_throwIfStrict(w,f){if(f&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=h;var m;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(m||(m={}));class l{static{this.all=new Set}static{this._None=new class extends l{constructor(){super(m.None,null)}stop(){}branch(){return this}}}static traceInvocation(w,f){return w?new l(m.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l._None}static traceCreation(w,f){return w?new l(m.Creation,f.name):l._None}static{this._totals=0}constructor(w,f){this.type=w,this.name=f,this._start=Date.now(),this._dep=[]}branch(w,f){const S=new l(m.Branch,w.toString());return this._dep.push([w,f,S]),S}stop(){const w=Date.now()-this._start;l._totals+=w;let f=!1;function S(g,s){const r=[],t=new Array(g+1).join("	");for(const[o,i,n]of s._dep)if(i&&n){f=!0,r.push(`${t}CREATES -> ${o}`);const a=S(g+1,n);a&&r.push(a)}else r.push(`${t}uses -> ${o}`);return r.join(`
`)}const R=[`${this.type===m.Creation?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(w>2||f)&&l.all.add(R.join(`
`))}}e.Trace=l}),define(le[57],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,C.createDecorator)("mainProcessService");class c{constructor(D,O){this.server=D,this.router=O}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,O){this.server.registerChannel(D,O)}}e.MainProcessService=c}),define(le[10],ue([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=y,e.log=f,e.getLogLevel=u,e.LogLevelToString=d,e.LogLevelToLocalizedString=b,e.parseLogLevel=A,C=De(C),e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function l(){return new Date().toISOString()}function y(I){return(0,P.isNumber)(I)}var w;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function f(I,E,k){switch(E){case w.Trace:I.trace(k);break;case w.Debug:I.debug(k);break;case w.Info:I.info(k);break;case w.Warning:I.warn(k);break;case w.Error:I.error(k);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function S(I,E=!1){let k="";for(let F=0;F<I.length;F++){let U=I[F];if(U instanceof Error&&(U=(0,c.toErrorMessage)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}k+=(F>0?" ":"")+U}return k}class R extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==w.Off&&this.level<=E}}e.AbstractLogger=R;class g extends R{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...k){this.checkLogLevel(w.Trace)&&this.log(w.Trace,S([E,...k],!0))}debug(E,...k){this.checkLogLevel(w.Debug)&&this.log(w.Debug,S([E,...k]))}info(E,...k){this.checkLogLevel(w.Info)&&this.log(w.Info,S([E,...k]))}warn(E,...k){this.checkLogLevel(w.Warning)&&this.log(w.Warning,S([E,...k]))}error(E,...k){if(this.checkLogLevel(w.Error))if(E instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=E.stack,this.log(w.Error,S(F))}else this.log(w.Error,S([E,...k]))}flush(){}}e.AbstractMessageLogger=g;class s extends R{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!_.isWindows}trace(E,...k){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...k):console.log(`[main ${l()}]`,E,...k))}debug(E,...k){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...k):console.log(`[main ${l()}]`,E,...k))}info(E,...k){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...k):console.log(`[main ${l()}]`,E,...k))}warn(E,...k){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...k):console.warn(`[main ${l()}]`,E,...k))}error(E,...k){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...k):console.error(`[main ${l()}]`,E,...k))}flush(){}}e.ConsoleMainLogger=s;class r extends R{constructor(E=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(E)}trace(E,...k){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...k):console.log(E,...k))}debug(E,...k){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...k):console.log(E,...k))}info(E,...k){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...k):console.log(E,...k))}warn(E,...k){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...k):console.log(E,...k))}error(E,...k){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...k):console.error(E,...k))}flush(){}}e.ConsoleLogger=r;class t extends R{constructor(E,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(k)}trace(E,...k){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(E),...k])}debug(E,...k){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(E),...k])}info(E,...k){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(E),...k])}warn(E,...k){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(E),...k])}error(E,...k){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(E),...k])}extractMessage(E){return typeof E=="string"?E:(0,c.toErrorMessage)(E,this.checkLogLevel(w.Trace))}flush(){}}e.AdapterLogger=t;class o extends R{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const k of this.loggers)k.setLevel(E);super.setLevel(E)}trace(E,...k){for(const F of this.loggers)F.trace(E,...k)}debug(E,...k){for(const F of this.loggers)F.debug(E,...k)}info(E,...k){for(const F of this.loggers)F.info(E,...k)}warn(E,...k){for(const F of this.loggers)F.warn(E,...k)}error(E,...k){for(const F of this.loggers)F.error(E,...k)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose();super.dispose()}}e.MultiplexLogger=o;class i extends O.Disposable{constructor(E,k,F){if(super(),this.logLevel=E,this.logsHome=k,this._loggers=new L.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,F)for(const U of F)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(E){return(0,P.isString)(E)?[...this._loggers.values()].find(k=>k.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,k){const F=this.toResource(E),U=(0,P.isString)(E)?E:k?.id??(0,D.hash)(F.toString()).toString(16);let M=this._loggers.get(F)?.logger;const H=k?.logLevel==="always"?w.Trace:k?.logLevel;M||(M=this.doCreateLogger(F,H??this.getLogLevel(F)??this.logLevel,{...k,id:U}));const B={logger:M,info:{resource:F,id:U,logLevel:H,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(B.info),this._loggers.set(F,B),M}toResource(E){return(0,P.isString)(E)?(0,v.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,k){if(p.URI.isUri(E)){const F=E,U=k,M=this._loggers.get(F);M&&U!==M.info.logLevel&&(M.info.logLevel=U===this.logLevel?void 0:U,M.logger?.setLevel(U),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([F,U]))}else{this.logLevel=E;for(const[F,U]of this._loggers.entries())this._loggers.get(F)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,k){const F=this.getLoggerEntry(E);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this._loggers.set(F.info.resource,F),this._onDidChangeVisibility.fire([F.info.resource,k]))}getLogLevel(E){let k;return E&&(k=this._loggers.get(E)?.info.logLevel),k??this.logLevel}registerLogger(E){const k=this._loggers.get(E.resource);k?k.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const k=this._loggers.get(E);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(E){}getLevel(){return w.Info}trace(E,...k){}debug(E,...k){}info(E,...k){}warn(E,...k){}error(E,...k){}critical(E,...k){}dispose(){}flush(){}}e.NullLogger=n;class a extends n{}e.NullLogService=a;function u(I){if(I.verbose)return w.Trace;if(typeof I.logLevel=="string"){const E=A(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}function d(I){switch(I){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function b(I){switch(I){case w.Trace:return{original:"Trace",value:C.localize(0,null)};case w.Debug:return{original:"Debug",value:C.localize(1,null)};case w.Info:return{original:"Info",value:C.localize(2,null)};case w.Warning:return{original:"Warning",value:C.localize(3,null)};case w.Error:return{original:"Error",value:C.localize(4,null)};case w.Off:return{original:"Off",value:C.localize(5,null)}}}function A(I){switch(I){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.CONTEXT_LOG_LEVEL=new h.RawContextKey("logLevel",d(w.Info))}),define(le[208],ue([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let p=class extends T.Disposable{constructor(m,l){super(),this.environmentService=m,this.logService=l,this._register(new C.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const m=(0,L.basename)(this.environmentService.logsHome),l=(0,L.dirname)(this.environmentService.logsHome.with({scheme:D.Schemas.file})).fsPath,f=(await _.Promises.readdir(l)).filter(R=>/^\d{8}T\d{6}$/.test(R)).sort().filter(R=>R!==m),S=f.slice(0,Math.max(0,f.length-9));S.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${S.join(", ")}'`),await Promise.all(S.map(R=>_.Promises.rm((0,O.join)(l,R)))))}catch(m){(0,c.onUnexpectedError)(m)}}};e.LogsDataCleaner=p,e.LogsDataCleaner=p=we([X(0,v.IEnvironmentService),X(1,P.ILogService)],p)}),define(le[209],ue([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends L.Disposable{constructor(m,l){super(),this.logService=m,this.options=l,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new c.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new c.ThrottledDelayer(0))}watch(m,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,l):this.watchNonRecursive(m,l)}watchUniversal(m,l){const y={path:this.toWatchPath(m),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},w=(0,C.insert)(this.universalWatchRequests,y);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,T.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,v.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const l of this.universalWatchRequests)(0,v.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const l of this.universalWatchRequests)(0,v.isRecursiveWatchRequest)(l)&&m.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(m,l){const y={path:this.toWatchPath(m),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},w=(0,C.insert)(this.nonRecursiveWatchRequests,y);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,T.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,v.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logWatcherMessage(m)}logWatcherMessage(m){this.logService[m.type](m.message)}toFilePath(m){return(0,_.normalize)(m.fsPath)}toWatchPath(m){const l=this.toFilePath(m);return(0,O.removeTrailingPathSeparator)(l)}}e.AbstractDiskFileSystemProvider=p}),define(le[210],ue([0,1,19,6,15,26,3,56,64,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let s=class extends v.Disposable{static{g=this}constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new O.Emitter),this._onDidUncorrelatedFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new c.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${t}`);const i=new v.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),i.add(o.onDidChangeFile(n=>{const a=new w.FileChangesEvent(n,!this.isPathCaseSensitive(o));this.internalOnDidFilesChange.fire(a),a.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(a)})),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,v.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){o.push(i)}}),!this.provider.has(t)&&await c.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return _.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,m.isAbsolutePath)(t))throw new w.FileOperationError((0,y.localize)(0,null,this.resourceForError(t)),w.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const i=new R.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,t.toString()),i}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o)||(0,w.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(i){throw(0,w.toFileSystemProviderErrorCode)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,y.localize)(2,null,this.resourceForError(t)),w.FileOperationResult.FILE_NOT_FOUND):(0,w.ensureFileSystemProviderError)(i)}}async doResolveFile(t,o){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),a=o?.resolveTo,u=o?.resolveSingleChildDescendants,d=o?.resolveMetadata,b=await i.stat(t);let A;return this.toFileStat(i,t,b,void 0,!!d,(I,E)=>(A||(A=P.TernarySearchTree.forUris(()=>!n),A.set(t,!0),a&&A.fill(!0,a)),A.get(I.resource)||A.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&u?E===1:!1))}async toFileStat(t,o,i,n,a,u){const{providerExtUri:d}=this.getExtUri(t),b={resource:o,name:d.basename(o),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(t.capabilities&w.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(b.isDirectory&&u(b,n)){try{const A=await t.readdir(o),I=await c.Promises.settled(A.map(async([E,k])=>{try{const F=d.joinPath(o,E),U=a?await t.stat(F):{type:k};return await this.toFileStat(t,F,U,A.length,a,u)}catch(F){return this.logService.trace(F),null}}));b.children=(0,C.coalesce)(I)}catch(A){this.logService.trace(A),b.children=[]}return b}return b}async resolveAll(t){return c.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),i=await o.stat(t);return this.toFileStat(o,t,i,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(i){return i}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new w.FileOperationError((0,y.localize)(3,null,this.resourceForError(t)),w.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=T.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,o);return this._onDidRunOperation.fire(new w.FileOperationEvent(t,w.FileOperation.CREATE,n)),n}async writeFile(t,o,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:a}=this.getExtUri(n);let u=i;if((0,w.hasFileAtomicWriteCapability)(n)&&!u?.atomic){const d=n.enforceAtomicWriteFile?.(t);d&&(u={...i,atomic:d})}try{await this.validateWriteFile(n,t,u)||await this.mkdirp(n,a.dirname(t));let b;if((0,w.hasReadWriteCapability)(n)&&!(o instanceof T.VSBuffer))if((0,l.isReadableStream)(o)){const A=await(0,l.peekStream)(o,3);A.ended?b=T.VSBuffer.concat(A.buffer):b=A}else b=(0,l.peekReadable)(o,A=>T.VSBuffer.concat(A),3);else b=o;!(0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)&&b instanceof T.VSBuffer||(0,w.hasReadWriteCapability)(n)&&(0,w.hasFileAtomicWriteCapability)(n)&&u?.atomic?await this.doWriteUnbuffered(n,t,u,b):await this.doWriteBuffered(n,t,u,b instanceof T.VSBuffer?(0,T.bufferToReadable)(b):b),this._onDidRunOperation.fire(new w.FileOperationEvent(t,w.FileOperation.WRITE))}catch(d){throw new w.FileOperationError((0,y.localize)(4,null,this.resourceForError(t),(0,w.ensureFileSystemProviderError)(d).toString()),(0,w.toFileOperationResult)(d),u)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,i){const n=!!i?.unlock;if(n&&!(t.capabilities&w.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,y.localize)(5,null,this.resourceForError(o)));if(!!i?.atomic){if(!(t.capabilities&w.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,y.localize)(6,null,this.resourceForError(o)));if(!(t.capabilities&w.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,y.localize)(7,null,this.resourceForError(o)));if(n)throw new Error((0,y.localize)(8,null,this.resourceForError(o)))}let u;try{u=await t.stat(o)}catch{return}if(u.type&w.FileType.Directory)throw new w.FileOperationError((0,y.localize)(9,null,this.resourceForError(o)),w.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.throwIfFileIsReadonly(o,u),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.ETAG_DISABLED&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==(0,w.etag)({mtime:i.mtime,size:u.size}))throw new w.FileOperationError((0,y.localize)(10,null),w.FileOperationResult.FILE_MODIFIED_SINCE,i);return u}async readFile(t,o,i){const n=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(n,t,o,i):this.doReadFile(n,t,o,i)}async doReadFileAtomic(t,o,i,n){return new Promise((a,u)=>{this.writeQueue.queueFor(o,async()=>{try{const d=await this.doReadFile(t,o,i,n);a(d)}catch(d){u(d)}},this.getExtUri(t).providerExtUri)})}async doReadFile(t,o,i,n){const a=await this.doReadFileStream(t,o,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,T.streamToBuffer)(a.value)}}async readFileStream(t,o,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,o,i)}async doReadFileStream(t,o,i,n){const a=new D.CancellationTokenSource(n);let u=i;(0,w.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(o)&&(u={...i,atomic:!0});const d=this.validateReadFile(o,u).then(A=>A,A=>{throw a.dispose(!0),A});let b;try{return typeof u?.etag=="string"&&u.etag!==w.ETAG_DISABLED&&await d,u?.atomic&&(0,w.hasFileAtomicReadCapability)(t)||!((0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasFileReadStreamCapability)(t))||(0,w.hasReadWriteCapability)(t)&&u?.preferUnbuffered?b=this.readFileUnbuffered(t,o,u):(0,w.hasFileReadStreamCapability)(t)?b=this.readFileStreamed(t,o,a.token,u):b=this.readFileBuffered(t,o,a.token,u),b.on("end",()=>a.dispose()),b.on("error",()=>a.dispose()),{...await d,value:b}}catch(A){throw b&&await(0,l.consumeStream)(b),this.restoreReadError(A,o,u)}}restoreReadError(t,o,i){const n=(0,y.localize)(11,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(t).toString());return t instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof w.TooLargeFileOperationError?new w.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new w.FileOperationError(n,(0,w.toFileOperationResult)(t),i)}readFileStreamed(t,o,i,n=Object.create(null)){const a=t.readFileStream(o,n,i);return(0,l.transform)(a,{data:u=>u instanceof T.VSBuffer?u:T.VSBuffer.wrap(u),error:u=>this.restoreReadError(u,o,n)},u=>T.VSBuffer.concat(u))}readFileBuffered(t,o,i,n=Object.create(null)){const a=(0,T.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,o,a,u=>u,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:u=>this.restoreReadError(u,o,n)},i),a}readFileUnbuffered(t,o,i){const n=(0,l.newWriteableStream)(a=>T.VSBuffer.concat(a));return(async()=>{try{let a;i?.atomic&&(0,w.hasFileAtomicReadCapability)(t)?a=await t.readFile(o,{atomic:!0}):a=await t.readFile(o),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.validateReadFileLimits(o,a.byteLength,i),n.end(T.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async validateReadFile(t,o){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new w.FileOperationError((0,y.localize)(12,null,this.resourceForError(t)),w.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&o.etag===i.etag)throw new w.NotModifiedSinceFileOperationError((0,y.localize)(13,null),i,o);return this.validateReadFileLimits(t,i.size,o),i}validateReadFileLimits(t,o,i){if(typeof i?.limits?.size=="number"&&o>i.limits.size)throw new w.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(t)),w.FileOperationResult.FILE_TOO_LARGE,o,i)}async canMove(t,o,i){return this.doCanMoveCopy(t,o,"move",i)}async canCopy(t,o,i){return this.doCanMoveCopy(t,o,"copy",i)}async doCanMoveCopy(t,o,i,n){if(t.toString()!==o.toString())try{const a=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(a,t,u,o,i,n)}catch(a){return a}return!0}async move(t,o,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),u=await this.doMoveCopy(n,t,a,o,"move",!!i),d=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(t,u==="move"?w.FileOperation.MOVE:w.FileOperation.COPY,d)),d}async copy(t,o,i){const n=await this.withReadProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),u=await this.doMoveCopy(n,t,a,o,"copy",!!i),d=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(t,u==="copy"?w.FileOperation.COPY:w.FileOperation.MOVE,d)),d}async doMoveCopy(t,o,i,n,a,u){if(o.toString()===n.toString())return a;const{exists:d,isSameResourceWithDifferentPathCase:b}=await this.doValidateMoveCopy(t,o,i,n,a,u);if(d&&!b&&u&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),a==="copy"){if(t===i&&(0,w.hasFileFolderCopyCapability)(t))await t.copy(o,n,{overwrite:u});else{const A=await this.resolve(o);A.isDirectory?await this.doCopyFolder(t,A,i,n):await this.doCopyFile(t,o,i,n)}return a}else return t===i?(await t.rename(o,n,{overwrite:u}),a):(await this.doMoveCopy(t,o,i,n,"copy",u),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,i,n){if((0,w.hasOpenReadWriteCloseCapability)(t)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,o,i,n);if((0,w.hasOpenReadWriteCloseCapability)(t)&&(0,w.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,o,i,n);if((0,w.hasReadWriteCapability)(t)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,o,i,n);if((0,w.hasReadWriteCapability)(t)&&(0,w.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,o,i,n)}async doCopyFolder(t,o,i,n){await i.mkdir(n),Array.isArray(o.children)&&await c.Promises.settled(o.children.map(async a=>{const u=this.getExtUri(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.doCopyFolder(t,await this.resolve(a.resource),i,u):this.doCopyFile(t,a.resource,i,u)}))}async doValidateMoveCopy(t,o,i,n,a,u){let d=!1;if(t===i){const{providerExtUri:A,isPathCaseSensitive:I}=this.getExtUri(t);if(I||(d=A.isEqual(o,n)),d&&a==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(o),this.resourceForError(n)));if(!d&&A.isEqualOrParent(n,o))throw new Error((0,y.localize)(16,null,this.resourceForError(o),this.resourceForError(n)))}const b=await this.exists(n);if(b&&!d){if(!u)throw new w.FileOperationError((0,y.localize)(17,null,this.resourceForError(o),this.resourceForError(n)),w.FileOperationResult.FILE_MOVE_CONFLICT);if(t===i){const{providerExtUri:A}=this.getExtUri(t);if(A.isEqualOrParent(o,n))throw new Error((0,y.localize)(18,null,this.resourceForError(o),this.resourceForError(n)))}}return{exists:b,isSameResourceWithDifferentPathCase:d}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(t,w.FileOperation.CREATE,i)),i}async mkdirp(t,o){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await t.stat(o)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(o)));break}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(o)),o=n.dirname(o)}for(let a=i.length-1;a>=0;a--){o=n.joinPath(o,i[a]);try{await t.mkdir(o)}catch(u){if((0,w.toFileSystemProviderErrorCode)(u)!==w.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(i){return i}return!0}async doValidateDelete(t,o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),n=!!o?.useTrash;if(n&&!(i.capabilities&w.FileSystemProviderCapabilities.Trash))throw new Error((0,y.localize)(20,null,this.resourceForError(t)));const a=o?.atomic;if(a&&!(i.capabilities&w.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,y.localize)(21,null,this.resourceForError(t)));if(n&&a)throw new Error((0,y.localize)(22,null,this.resourceForError(t)));let u;try{u=await i.stat(t)}catch{}if(u)this.throwIfFileIsReadonly(t,u);else throw new w.FileOperationError((0,y.localize)(23,null,this.resourceForError(t)),w.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const b=await this.resolve(t);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(t)))}return i}async del(t,o){const i=await this.doValidateDelete(t,o);let n=o;if((0,w.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const b=i.enforceAtomicDelete?.(t);b&&(n={...o,atomic:b})}const a=!!n?.useTrash,u=!!n?.recursive,d=n?.atomic??!1;await i.delete(t,{recursive:u,useTrash:a,atomic:d}),this._onDidRunOperation.fire(new w.FileOperationEvent(t,w.FileOperation.DELETE))}async cloneFile(t,o){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(!(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,o)))return i===n&&(0,w.hasFileCloneCapability)(i)?i.cloneFile(t,o):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),i===n&&(0,w.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(t,()=>i.copy(t,o,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(t,()=>this.doCopyFile(i,t,n,o),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:g.WATCHER_CORRELATION_IDS++})}watch(t,o={recursive:!1,excludes:[]}){const i=new v.DisposableStore;let n=!1,a=()=>{n=!0};i.add((0,v.toDisposable)(()=>a())),(async()=>{try{const d=await this.doWatch(t,o);n?(0,v.dispose)(d):a=()=>(0,v.dispose)(d)}catch(d){this.logService.error(d)}})();const u=o.correlationId;if(typeof u=="number"){const d=i.add(new O.Emitter);return i.add(this.internalOnDidFilesChange.event(A=>{A.correlates(u)&&d.fire(A)})),{onDidChange:d.event,dispose:()=>i.dispose()}}return i}async doWatch(t,o){const i=await this.withProvider(t),n=(0,L.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),o]);let a=this.activeWatchers.get(n);return a||(a={count:0,disposable:i.watch(t,o)},this.activeWatchers.set(n,a)),a.count+=1,(0,v.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,v.dispose)(a.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,v.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,o,i,n){return this.writeQueue.queueFor(o,async()=>{const a=await t.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,l.isReadableStream)(n)||(0,l.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,a,n):await this.doWriteReadableBufferedQueued(t,a,n)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await t.close(a)}},this.getExtUri(t).providerExtUri)}async doWriteStreamBufferedQueued(t,o,i){let n=0,a;if((0,l.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=T.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,o,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((u,d)=>{(0,l.listenStream)(a,{onData:async b=>{a.pause();try{await this.doWriteBuffer(t,o,b,b.byteLength,n,0)}catch(A){return d(A)}n+=b.byteLength,setTimeout(()=>a.resume())},onError:b=>d(b),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(t,o,i){let n=0,a;for(;(a=i.read())!==null;)await this.doWriteBuffer(t,o,a,a.byteLength,n,0),n+=a.byteLength}async doWriteBuffer(t,o,i,n,a,u){let d=0;for(;d<n;){const b=await t.write(o,a+d,i.buffer,u+d,n-d);d+=b}}async doWriteUnbuffered(t,o,i,n){return this.writeQueue.queueFor(o,()=>this.doWriteUnbufferedQueued(t,o,i,n),this.getExtUri(t).providerExtUri)}async doWriteUnbufferedQueued(t,o,i,n){let a;n instanceof T.VSBuffer?a=n:(0,l.isReadableStream)(n)?a=await(0,T.streamToBuffer)(n):(0,l.isReadableBufferedStream)(n)?a=await(0,T.bufferedStreamToBuffer)(n):a=(0,T.readableToBuffer)(n),await t.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(t,o,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(t,o,i,n),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(t,o,i,n){let a,u;try{a=await t.open(o,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const d=T.VSBuffer.alloc(this.BUFFER_SIZE);let b=0,A=0,I=0;do I=await t.read(a,b,d.buffer,A,d.byteLength-A),await this.doWriteBuffer(i,u,d,I,b,A),b+=I,A+=I,A===d.byteLength&&(A=0);while(I>0)}catch(d){throw(0,w.ensureFileSystemProviderError)(d)}finally{await c.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async doPipeUnbuffered(t,o,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(t,o,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(t,o,i,n){return i.writeFile(n,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(t,o,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(t,o,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const u=await t.readFile(o);await this.doWriteBuffer(i,a,T.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await i.close(a)}}async doPipeBufferedToUnbuffered(t,o,i,n){const a=await(0,T.streamToBuffer)(this.readFileBuffered(t,o,D.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,a)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&w.FileSystemProviderCapabilities.Readonly)throw new w.FileOperationError((0,y.localize)(25,null,this.resourceForError(o)),w.FileOperationResult.FILE_PERMISSION_DENIED);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,y.localize)(26,null,this.resourceForError(t)),w.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=s,e.FileService=s=g=we([X(0,S.ILogService)],s)}),define(le[211],ue([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,209,206,205]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class R extends w.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,r){super(s,r),this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new c.ResourceMap(t=>P.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,v.isLinux&&(this._capabilities|=l.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(s){try{const{stat:r,symbolicLink:t}=await h.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:l.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const r=await h.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async o=>{try{let i;o.isSymbolicLink()?i=(await this.stat((0,P.joinPath)(s,o.name))).type:i=this.toType(o),t.push([o.name,i])}catch(i){this.logService.trace(i)}})),t}catch(r){throw this.toFileSystemProviderError(r)}}toType(s,r){let t;return r?.dangling?t=l.FileType.Unknown:s.isFile()?t=l.FileType.File:s.isDirectory()?t=l.FileType.Directory:t=l.FileType.Unknown,r&&(t|=l.FileType.SymbolicLink),t}async createResourceLock(s){const r=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let t;for(;t=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await t.wait();const o=new C.Barrier;return this.resourceLocks.set(s,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,L.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(s)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),o.open()})}async readFile(s,r){let t;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),t=await this.createResourceLock(s));const o=this.toFilePath(s);return await h.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{t?.dispose()}}traceLock(s){R.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,r,t){const o=(0,p.newWriteableStream)(i=>T.VSBuffer.concat(i.map(n=>T.VSBuffer.wrap(n))).buffer);return(0,y.readFileIntoStream)(this,s,o,i=>i.buffer,{...r,bufferSize:256*1024},t),o}async writeFile(s,r,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,P.joinPath)((0,P.dirname)(s),`${(0,P.basename)(s)}${t.atomic.postfix}`),r,t):this.doWriteFile(s,r,t)}async canWriteFileAtomic(s){try{const r=this.toFilePath(s),{symbolicLink:t}=await h.SymlinkSupport.stat(r);if(t)return!1}catch{}return!0}async doWriteFileAtomic(s,r,t,o){const i=new L.DisposableStore;try{i.add(await this.createResourceLock(s)),i.add(await this.createResourceLock(r)),await this.doWriteFile(r,t,o,!0);try{await this.rename(r,s,{overwrite:!0})}catch(n){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async doWriteFile(s,r,t,o){let i;try{const n=this.toFilePath(s);if(!t.create||!t.overwrite){if(await h.Promises.exists(n)){if(!t.overwrite)throw(0,l.createFileSystemProviderError)((0,m.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,l.createFileSystemProviderError)((0,m.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:t.unlock},o),await this.write(i,0,r,0,r.byteLength)}catch(n){throw await this.toFileSystemProviderWriteError(s,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.canFlush=!0}static configureFlushOnWrite(s){R.canFlush=s}async open(s,r,t){const o=this.toFilePath(s);let i;(0,l.isFileOpenForWriteOptions)(r)&&!t&&(i=await this.createResourceLock(s));let n;try{if((0,l.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:u}=await h.SymlinkSupport.stat(o);u.mode&128||await h.Promises.chmod(o,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}let a;if((0,l.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await h.Promises.truncate(o,0),a="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}a||(a="w")}else a="r";n=await h.Promises.open(o,a)}catch(a){throw i?.dispose(),(0,l.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(s,a):this.toFileSystemProviderError(a)}if(this.mapHandleToPos.set(n,0),(0,l.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(n,s),i){const a=this.mapHandleToLock.get(n);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${o})`),this.mapHandleToLock.set(n,i),a&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${o})`),a.dispose())}return n}async close(s){const r=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&R.canFlush)try{await h.Promises.fdatasync(s)}catch(t){R.configureFlushOnWrite(!1),this.logService.error(t)}return await h.Promises.close(s)}catch(t){throw this.toFileSystemProviderError(t)}finally{r&&(this.mapHandleToLock.get(s)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),r.dispose())}}async read(s,r,t,o,i){const n=this.normalizePos(s,r);let a=null;try{a=(await h.Promises.read(s,t,o,i,n)).bytesRead}catch(u){throw this.toFileSystemProviderError(u)}finally{this.updatePos(s,n,a)}return a}normalizePos(s,r){return r===this.mapHandleToPos.get(s)?null:r}updatePos(s,r,t){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof r=="number"||(typeof t=="number"?this.mapHandleToPos.set(s,o+t):this.mapHandleToPos.delete(s)))}async write(s,r,t,o,i){return(0,C.retry)(()=>this.doWrite(s,r,t,o,i),100,3)}async doWrite(s,r,t,o,i){const n=this.normalizePos(s,r);let a=null;try{a=(await h.Promises.write(s,t,o,i,n)).bytesWritten}catch(u){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),u)}finally{this.updatePos(s,n,a)}return a}async mkdir(s){try{await h.Promises.mkdir(this.toFilePath(s))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(s,r){try{const t=this.toFilePath(s);if(r.recursive){let o;r?.atomic!==!1&&r.atomic.postfix&&(o=(0,_.join)((0,_.dirname)(t),`${(0,_.basename)(t)}${r.atomic.postfix}`)),await h.Promises.rm(t,h.RimRafMode.MOVE,o)}else try{await h.Promises.unlink(t)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:a}=await h.SymlinkSupport.stat(t);i=n.isDirectory()&&!a}catch{}if(i)await h.Promises.rmdir(t);else throw o}else throw o}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(s,r,t){const o=this.toFilePath(s),i=this.toFilePath(r);if(o!==i)try{await this.validateMoveCopy(s,r,"move",t.overwrite),await h.Promises.rename(o,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,m.localize)(2,null,(0,_.basename)(o),(0,_.basename)((0,_.dirname)(i)),n.toString()))),this.toFileSystemProviderError(n)}}async copy(s,r,t){const o=this.toFilePath(s),i=this.toFilePath(r);if(o!==i)try{await this.validateMoveCopy(s,r,"copy",t.overwrite),await h.Promises.copy(o,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,m.localize)(3,null,(0,_.basename)(o),(0,_.basename)((0,_.dirname)(i)),n.toString()))),this.toFileSystemProviderError(n)}}async validateMoveCopy(s,r,t,o){const i=this.toFilePath(s),n=this.toFilePath(r);let a=!1;if(!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive)||(a=(0,O.isEqual)(i,n,!0)),a){if(t==="copy")throw(0,l.createFileSystemProviderError)((0,m.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const d=await this.statIgnoreError(s);if(!d)throw(0,l.createFileSystemProviderError)((0,m.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const b=await this.statIgnoreError(r);if(b){if(!o)throw(0,l.createFileSystemProviderError)((0,m.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);d.type&l.FileType.File&&b.type&l.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,r){return this.doCloneFile(s,r,!1)}async doCloneFile(s,r,t){const o=this.toFilePath(s),i=this.toFilePath(r),n=!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.isEqual)(o,i,!n))return;const a=new L.DisposableStore;try{a.add(await this.createResourceLock(s)),a.add(await this.createResourceLock(r)),t&&await h.Promises.mkdir((0,_.dirname)(i),{recursive:!0}),await h.Promises.copyFile(o,i)}catch(u){if(u.code==="ENOENT"&&!t)return this.doCloneFile(s,r,!0);throw this.toFileSystemProviderError(u)}finally{a.dispose()}}createUniversalWatcher(s,r,t){return new f.UniversalWatcherClient(o=>s(o),o=>r(o),t)}createNonRecursiveWatcher(s,r,t){return new S.NodeJSWatcherClient(o=>s(o),o=>r(o),t)}toFileSystemProviderError(s){if(s instanceof l.FileSystemProviderError)return s;let r=s,t;switch(s.code){case"ENOENT":t=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=l.FileSystemProviderErrorCode.Unknown;break;default:t=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(r,t)}async toFileSystemProviderWriteError(s,r){let t=this.toFileSystemProviderError(r);if(s&&t.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await h.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(t=(0,l.createFileSystemProviderError)(r,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return t}}e.DiskFileSystemProvider=R}),define(le[102],ue([0,1,3,2,4,10]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("sharedProcessLifecycleService");let O=class extends c.Disposable{constructor(_){super(),this.logService=_,this._onWillShutdown=this._register(new C.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=O,e.SharedProcessLifecycleService=O=we([X(0,D.ILogService)],O)}),define(le[212],ue([0,1,9,3,10,2]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class O extends T.AbstractLoggerService{constructor(p,h,m,l,y){super(h,m,l),this.windowId=p,this.channel=y,this._register(y.listen("onDidChangeLogLevel",p)(w=>{(0,T.isLogLevel)(w)?super.setLogLevel(w):super.setLogLevel(C.URI.revive(w[0]),w[1])})),this._register(y.listen("onDidChangeVisibility",p)(([w,f])=>super.setVisibility(C.URI.revive(w),f))),this._register(y.listen("onDidChangeLoggers",p)(({added:w,removed:f})=>{for(const S of w)super.registerLogger({...S,resource:C.URI.revive(S.resource)});for(const S of f)super.deregisterLogger(S.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(p,h)=>{this.channel.call("consoleLog",[p,h])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,h){super.setLogLevel(p,h),this.channel.call("setLogLevel",[p,h])}setVisibility(p,h){super.setVisibility(p,h),this.channel.call("setVisibility",[this.toResource(p),h])}doCreateLogger(p,h,m){return new L(this.channel,p,h,m,this.windowId)}static setLogLevel(p,h,m){return p.call("setLogLevel",[h,m])}}e.LoggerChannelClient=O;class L extends T.AbstractMessageLogger{constructor(p,h,m,l,y){super(l?.logLevel==="always"),this.channel=p,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.channel.call("createLogger",[h,l,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,h){const m=[[p,h]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(p){this.channel.call("log",[this.file,p])}}class _{constructor(p,h){this.loggerService=p,this.getUriTransformer=h}listen(p,h){const m=this.getUriTransformer(p);switch(h){case"onDidChangeLoggers":return c.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(y=>this.transformLogger(y,m)),removed:[...l.removed].map(y=>this.transformLogger(y,m))}));case"onDidChangeVisibility":return c.Event.map(this.loggerService.onDidChangeVisibility,l=>[m.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,T.isLogLevel)(l)?l:[m.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${h}`)}async call(p,h,m){const l=this.getUriTransformer(p);switch(h){case"setLogLevel":return(0,T.isLogLevel)(m[0])?this.loggerService.setLogLevel(m[0]):this.loggerService.setLogLevel(C.URI.revive(l.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,l)))}throw new Error(`Call not found: ${h}`)}transformLogger(p,h){return{...p,resource:h.transformOutgoingURI(p.resource)}}}e.LoggerChannel=_;class v extends D.Disposable{constructor(p,h){super(),h.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(m=>h.call("setLogLevel",[m]))),h.call("getRegisteredLoggers").then(m=>{for(const l of m)p.registerLogger({...l,resource:C.URI.revive(l.resource)})}),this._register(h.listen("onDidChangeVisibility")(([m,l])=>p.setVisibility(C.URI.revive(m),l))),this._register(h.listen("onDidChangeLoggers")(({added:m,removed:l})=>{for(const y of m)p.registerLogger({...y,resource:C.URI.revive(y.resource)});for(const y of l)p.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=v}),define(le[213],ue([0,1,2,10]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends C.Disposable{constructor(O,L=[]){super(),this.logger=new c.MultiplexLogger([O,...L]),this._register(O.onDidChangeLogLevel(_=>this.setLevel(_)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(O){this.logger.setLevel(O)}getLevel(){return this.logger.getLevel()}trace(O,...L){this.logger.trace(O,...L)}debug(O,...L){this.logger.debug(O,...L)}info(O,...L){this.logger.info(O,...L)}warn(O,...L){this.logger.warn(O,...L)}error(O,...L){this.logger.error(O,...L)}flush(){this.logger.flush()}}e.LogService=T}),define(le[58],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,C.createDecorator)("nativeHostService")}),define(le[214],ue([0,1,43,57]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let T=class{constructor(O,L){return this.windowId=O,C.ProxyChannel.toService(L.getChannel("nativeHost"),{context:O,properties:(()=>{const _=new Map;return _.set("windowId",O),_})()})}};e.NativeHostService=T,e.NativeHostService=T=we([X(1,c.IMainProcessService)],T)}),define(le[59],ue([0,1,3,64,2,4]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class O extends T.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(v){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...v,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(v),c.Iterable.reduce(this.policies.entries(),(p,[h,m])=>({...p,[h]:m}),{})}getPolicyValue(v){return this.policies.get(v)}serialize(){return c.Iterable.reduce(Object.entries(this.policyDefinitions),(v,[P,p])=>({...v,[P]:{definition:p,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=O;class L{constructor(){this.onDidChange=C.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=L}),define(le[215],ue([0,1,3,2,59]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class D{constructor(_){this.service=_,this.disposables=new c.DisposableStore}listen(_,v){switch(v){case"onDidChange":return C.Event.map(this.service.onDidChange,P=>P.reduce((p,h)=>({...p,[h]:this.service.getPolicyValue(h)??null}),{}),this.disposables)}throw new Error(`Event not found: ${v}`)}call(_,v,P){switch(v){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${v}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=D;class O extends T.AbstractPolicyService{constructor(_,v){super(),this.channel=v;for(const P in _){const{definition:p,value:h}=_[P];this.policyDefinitions[P]=p,h!==void 0&&this.policies.set(P,h)}this.channel.listen("onDidChange")(P=>{for(const p in P){const h=P[p];h===null?this.policies.delete(p):this.policies.set(p,h)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(_){const v=await this.channel.call("updatePolicyDefinitions",_);for(const P in v)this.policies.set(P,v[P])}}e.PolicyChannelClient=O}),define(le[103],ue([0,1,37]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.context<"u"){const D=T.context.configuration();if(D)c=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){c=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:D,searchUrl:O,itemUrl:L,controlUrl:_}=c.extensionsGallery||{};Object.assign(c,{extensionsGallery:{serviceUrl:C.env.VSCODE_GALLERY_SERVICE_URL||D,searchUrl:C.env.VSCODE_GALLERY_SEARCH_URL||O,itemUrl:C.env.VSCODE_GALLERY_ITEM_URL||L,controlUrl:C.env.VSCODE_GALLERY_CONTROL_URL||_}});try{const v=(...p)=>p.reduce((h,m)=>(Object.keys(m).forEach(l=>{Array.isArray(h[l])&&Array.isArray(m[l])?h[l]=m[l]:typeof h[l]=="object"&&typeof m[l]=="object"?h[l]=v(h[l],m[l]):h[l]=m[l]}),h),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};c=v(c,P)}catch{}if(C.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const v=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:v.version,release:v.release})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(le[24],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[216],ue([0,1,6,8,2,14,31,10,24]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=class extends T.Disposable{constructor(p,h,m){super(),this.productService=h,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,p&&this._register(new C.RunOnceScheduler(()=>{this.cleanUpCodeCaches(p)},3e4)).schedule()}async cleanUpCodeCaches(p){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),m=(0,D.dirname)(p),l=(0,D.basename)(p),y=await O.Promises.readdir(m);await Promise.all(y.map(async w=>{if(w===l)return;const f=(0,D.join)(m,w),S=await O.Promises.stat(f);if(S.isDirectory()&&h-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(f)}))}catch(h){(0,c.onUnexpectedError)(h)}}};e.CodeCacheCleaner=v,e.CodeCacheCleaner=v=we([X(1,_.IProductService),X(2,L.ILogService)],v)}),define(le[217],ue([0,1,6,8,2,14,31,16,10,24]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends T.Disposable{constructor(h,m,l){super(),this.environmentService=h,this.logService=m,this.productService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new C.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),m=JSON.parse(await O.Promises.readFile((0,D.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const S of Object.keys(m)){const R=m[S];h[`${R.hash}.${S}`]=!0}const l=(0,D.join)(this.environmentService.userDataPath,"clp");if(!await O.Promises.exists(l))return;const w=await O.Promises.readdir(l);for(const S of w){if(h[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await O.Promises.rm((0,D.join)(l,S))}const f=Date.now();for(const S of Object.keys(h)){const R=(0,D.join)(l,S),g=await O.Promises.readdir(R);for(const s of g){if(s==="tcf.json")continue;const r=(0,D.join)(R,s),t=await O.Promises.stat(r);t.isDirectory()&&f-t.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,D.join)(S,s)}`),await O.Promises.rm(r))}}}catch(h){(0,c.onUnexpectedError)(h)}}};e.LanguagePackCachedDataCleaner=P,e.LanguagePackCachedDataCleaner=P=we([X(0,L.INativeEnvironmentService),X(1,_.ILogService),X(2,v.IProductService)],P)}),define(le[218],ue([0,1,14,4]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,c.createDecorator)("IV8InspectProfilingService");var T;(function(D){function O(_){return!!(_.samples&&_.timeDeltas)}D.isValidProfile=O;function L(_,v="noAbsolutePaths"){for(const P of _.nodes)P.callFrame&&P.callFrame.url&&((0,C.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,C.join)(v,(0,C.basename)(P.callFrame.url)));return _}D.rewriteAbsolutePaths=L})(T||(e.Utils=T={}))}),define(le[219],ue([0,1,32]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class c{constructor(){this._sessions=new Map}async startProfiling(D){const L=await(await new Promise((v,P)=>{ne(["v8-inspect-profiler"],v,P)}).then(De)).startProfiling({host:D.host,port:D.port,checkForPaused:!0}),_=(0,C.generateUuid)();return this._sessions.set(_,L),_}async stopProfiling(D){const O=this._sessions.get(D);if(!O)throw new Error(`UNKNOWN session '${D}'`);const L=await O.stop();return this._sessions.delete(D),L.profile}}e.InspectProfilingService=c}),define(le[44],ue([0,1,132,13]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,C=De(C),c=De(c);class T{constructor(){this.data=new Map}add(O,L){C.ok(c.isString(O)),C.ok(c.isObject(L)),C.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,L)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new T}),define(le[104],ue([0,1,3,44]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,c=De(c),e.Extensions={JSONContribution:"base.contributions.json"};function T(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class D{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,v){this.schemasById[T(_)]=v,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new D;c.Registry.add(e.Extensions.JSONContribution,O)}),define(le[48],ue([0,1,19,3,13,159,22,104,44]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=y,e.keyFromOverrideIdentifiers=w,e.getDefaultValue=f,e.validateProperty=R,e.getScopes=g,T=De(T),D=De(D);var v;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=_.Registry.as(L.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new c.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new c.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const o=new Set;this.doRegisterConfigurations(r,t,o),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(r){const t=new Set;this.doDeregisterConfigurations(r,t),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:r,remove:t}){const o=new Set;this.doDeregisterConfigurations(t,o),this.doRegisterConfigurations(r,!1,o),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}registerDefaultConfigurations(r){const t=new Set;this.doRegisterDefaultConfigurations(r,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,t){const o=[];for(const{overrides:i,source:n}of r)for(const a in i)if(t.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const u=this.configurationDefaultsOverrides.get(a),d=u?.valuesSources??new Map,b=u?.value||{};for(const E of Object.keys(i[a])){const k=i[a][E];if(T.isObject(k)&&(T.isUndefined(b[E])||T.isObject(b[E]))){if(b[E]={...b[E]??{},...k},n){let U=d.get(E);if(U||(U=new Map,d.set(E,U)),!(U instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const M in k)U.set(M,n)}}else b[E]=k,n&&d.set(E,n)}this.configurationDefaultsOverrides.set(a,{source:n,value:b,valuesSources:d});const A=(0,O.getLanguageTagSettingPlainKey)(a),I={type:"object",default:b,description:D.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:T.isString(n)?void 0:n,defaultValueSource:n};o.push(...y(a)),this.configurationProperties[a]=I,this.defaultLanguageConfigurationOverridesNode.properties[a]=I}else{const u=this.configurationProperties[a],d=this.configurationDefaultsOverrides.get(a);let b=d?.value??u?.defaultDefaultValue,A=i[a],I=n;if(T.isObject(A)&&(u!==void 0&&u.type==="object"||u===void 0&&(T.isUndefined(b)||T.isObject(b)))){if(T.isObject(b)||(b={}),A={...b,...A},I=d?.source??new Map,!(I instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const k in i[a])n?I.set(k,n):I.delete(k)}this.configurationDefaultsOverrides.set(a,{value:A,source:I}),u&&(this.updatePropertyDefaultValue(a,u),this.updateSchema(a,u))}this.doRegisterOverrideIdentifiers(o)}deregisterDefaultConfigurations(r){const t=new Set;this.doDeregisterDefaultConfigurations(r,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,t){for(const{overrides:o,source:i}of r)for(const n in o){const a=T.isString(i)?i:i?.id,u=this.configurationDefaultsOverrides.get(n);if(u){if(e.OVERRIDE_PROPERTY_REGEX.test(n)){for(const b of Object.keys(o[n])){const A=o[n][b];if(T.isObject(A)){const I=u.valuesSources?.get(b);for(const E of Object.keys(A)){const k=I?.get(E);(T.isString(k)?k:k?.id)===a&&(I?.delete(E),delete u.value[b][E])}Object.keys(u.value[b]).length===0&&(delete u.value[b],u.valuesSources?.delete(b))}else{const I=u.valuesSources?.get(b);(T.isString(I)?I:I?.id)===a&&(u.valuesSources?.delete(b),delete u.value[b])}}const d=this.configurationDefaultsOverrides.get(n);d&&Object.keys(d.value).length===0&&(this.configurationDefaultsOverrides.delete(n),delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n])}else{if(u.source instanceof Map){const b=u.source;for(const A in o[n]){const I=b.get(A);(T.isString(I)?I:I?.id)===a&&(b.delete(A),delete u.value[A])}b.size===0&&this.configurationDefaultsOverrides.delete(n)}else{const b=T.isString(u.source)?u.source:u.source?.id;if(a!==b)continue;this.configurationDefaultsOverrides.delete(n)}const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}t.add(n)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let t=!1;const o=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,o),t=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,o),t=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,o),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const t of r)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,t,o){r.forEach(i=>{this.validateAndRegisterProperties(i,t,i.extensionInfo,i.restrictedProperties,void 0,o),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(r,t){const o=i=>{if(i.properties)for(const n in i.properties){t.add(n);const a=this.configurationProperties[n];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>o(n))};for(const i of r){o(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(r,t=!0,o,i,n=P.WINDOW,a){n=T.isUndefinedOrNull(r.scope)?n:r.scope;const u=r.properties;if(u)for(const b in u){const A=u[b];if(t&&R(b,A)){delete u[b];continue}if(A.source=o,A.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,A),e.OVERRIDE_PROPERTY_REGEX.test(b)?A.scope=void 0:(A.scope=T.isUndefinedOrNull(A.scope)?n:A.scope,A.restricted=T.isUndefinedOrNull(A.restricted)?!!i?.includes(b):A.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b],u[b].policy?.name&&this.policyConfigurations.set(u[b].policy.name,b);!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),a.add(b)}const d=r.allOf;if(d)for(const b of d)this.validateAndRegisterProperties(b,t,o,i,n,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const t=o=>{const i=o.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);o.allOf?.forEach(t)};t(r)}updateSchema(r,t){switch(e.allSettings.properties[r]=t,t.scope){case P.APPLICATION:e.applicationSettings.properties[r]=t;break;case P.MACHINE:e.machineSettings.properties[r]=t;break;case P.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[r]=t;break;case P.WINDOW:e.windowSettings.properties[r]=t;break;case P.RESOURCE:e.resourceSettings.properties[r]=t;break;case P.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[r]=t,this.resourceLanguageSettingsSchema.properties[r]=t;break}}removeFromSchema(r,t){switch(delete e.allSettings.properties[r],t.scope){case P.APPLICATION:delete e.applicationSettings.properties[r];break;case P.MACHINE:delete e.machineSettings.properties[r];break;case P.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[r];break;case P.WINDOW:delete e.windowSettings.properties[r];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const t=`[${r}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,o),e.allSettings.properties[t]=o,e.applicationSettings.properties[t]=o,e.machineSettings.properties[t]=o,e.machineOverridableSettings.properties[t]=o,e.windowSettings.properties[t]=o,e.resourceSettings.properties[t]=o}}registerOverridePropertyPatternKey(){const r={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,t){const o=this.configurationDefaultsOverrides.get(r);let i=o?.value,n=o?.source;T.isUndefined(i)&&(i=t.defaultDefaultValue,n=void 0),T.isUndefined(i)&&(i=f(t.type)),t.default=i,t.defaultValueSource=n}}const m="\\[([^\\]]+)\\]",l=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(s){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let t=l.exec(s);for(;t?.length;){const o=t[1].trim();o&&r.push(o),t=l.exec(s)}}return(0,C.distinct)(r)}function w(s){return s.reduce((r,t)=>`${r}[${t}]`,"")}function f(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const S=new h;_.Registry.add(e.Extensions.Configuration,S);function R(s,r){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):S.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):r.policy?.name&&S.getPolicyConfigurations().get(r.policy?.name)!==void 0?D.localize(9,null,s,r.policy?.name,S.getPolicyConfigurations().get(r.policy?.name)):null:D.localize(6,null)}function g(){const s=[],r=S.getConfigurationProperties();for(const t of Object.keys(r))s.push([t,r[t].scope]);return s.push(["launch",P.RESOURCE]),s.push(["task",P.RESOURCE]),s}}),define(le[78],ue([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=g,C=De(C),T=De(T),L=De(L),_=De(_);function l(o){return Object.isFrozen(o)?o:L.deepFreeze(o)}class y{static createEmptyModel(i){return new y({},[],[],void 0,i)}constructor(i,n,a,u,d){this._contents=i,this._keys=n,this._overrides=a,this.raw=u,this.logService=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof y)return n;const a=new w("",this.logService);return a.parseRaw(n),a.configurationModel});this._rawConfiguration=i.reduce((n,a)=>a===n?a:n.merge(a),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const a=this;return{get value(){return l(a.rawConfiguration.getValue(i))},get override(){return n?l(a.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return l(n?a.rawConfiguration.override(n).getValue(i):a.rawConfiguration.getValue(i))},get overrides(){const u=[];for(const{contents:d,identifiers:b,keys:A}of a.rawConfiguration.overrides){const I=new y(d,A,[],void 0,a.logService).getValue(i);I!==void 0&&u.push({identifiers:b,value:I})}return u.length?l(u):void 0}}}getOverrideValue(i,n){const a=this.getContentsForOverrideIdentifer(n);return a?i?(0,P.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const a of this.overrides)a.identifiers.includes(i)&&n.push(...a.keys);return C.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return C.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=L.deepClone(this.contents),a=L.deepClone(this.overrides),u=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const b of i)if(d.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.mergeContents(n,b.contents);for(const A of b.overrides){const[I]=a.filter(E=>C.equals(E.identifiers,A.identifiers));I?(this.mergeContents(I.contents,A.contents),I.keys.push(...A.keys),I.keys=C.distinct(I.keys)):a.push(L.deepClone(A))}for(const A of b.keys)u.indexOf(A)===-1&&u.push(A)}return new y(n,u,a,d.every(b=>b instanceof y)?void 0:d,this.logService)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const u of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let d=this.contents[u];const b=n[u];b&&(typeof d=="object"&&typeof b=="object"?(d=L.deepClone(d),this.mergeContents(d,b)):d=b),a[u]=d}return new y(a,this.keys,this.overrides,void 0,this.logService)}mergeContents(i,n){for(const a of Object.keys(n)){if(a in i&&_.isObject(i[a])&&_.isObject(n[a])){this.mergeContents(i[a],n[a]);continue}i[a]=L.deepClone(n[a])}}getContentsForOverrideIdentifer(i){let n=null,a=null;const u=d=>{d&&(a?this.mergeContents(a,d):a=L.deepClone(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===i?n=d.contents:d.identifiers.includes(i)&&u(d.contents);return u(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(a=>C.equals(a.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,a){(0,P.addToValueTree)(this.contents,i,n,u=>this.logService.error(u)),a=a||this.keys.indexOf(i)===-1,a&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],u=>this.logService.error(u))})}}e.ConfigurationModel=y;class w{constructor(i,n){this._name=i,this.logService=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||y.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!_.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:a,keys:u,overrides:d,restricted:b,hasExcludedProperties:A}=this.doParseRaw(i,n);this._configurationModel=new y(a,u,d,A?[i]:void 0,this.logService),this._restrictedConfigurations=b||[]}doParseContent(i){let n={},a=null,u=[];const d=[],b=[];function A(E){Array.isArray(u)?u.push(E):a!==null&&(u[a]=E)}const I={onObjectBegin:()=>{const E={};A(E),d.push(u),u=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const E=[];A(E),d.push(u),u=E,a=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:A,onError:(E,k,F)=>{b.push({error:E,offset:k,length:F})}};if(i)try{T.visit(i,I),n=u[0]||{}}catch(E){this.logService.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return n}doParseRaw(i,n){const a=m.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),u=this.filter(i,a,!0,n);i=u.raw;const d=(0,P.toValuesTree)(i,I=>this.logService.error(`Conflict in settings file ${this._name}: ${I}`)),b=Object.keys(i),A=this.toOverrides(i,I=>this.logService.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:d,keys:b,overrides:A,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(i,n,a,u){let d=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:d};const b={},A=[];for(const I in i)if(p.OVERRIDE_PROPERTY_REGEX.test(I)&&a){const E=this.filter(i[I],n,!1,u);b[I]=E.raw,d=d||E.hasExcludedProperties,A.push(...E.restricted)}else{const E=n[I],k=E?typeof E.scope<"u"?E.scope:p.ConfigurationScope.WINDOW:void 0;E?.restricted&&A.push(I),!u.exclude?.includes(I)&&(u.include?.includes(I)||(k===void 0||u.scopes===void 0||u.scopes.includes(k))&&!(u.skipRestricted&&E?.restricted))?b[I]=i[I]:d=!0}return{raw:b,restricted:A,hasExcludedProperties:d}}toOverrides(i,n){const a=[];for(const u of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const b in i[u])d[b]=i[u][b];a.push({identifiers:(0,p.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,P.toValuesTree)(d,n)})}return a}}e.ConfigurationModelParser=w;class f extends D.Disposable{constructor(i,n,a,u,d){super(),this.userSettingsResource=i,this.parseOptions=n,this.fileService=u,this.logService=d,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString(),d),this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.any(c.Event.filter(this.fileService.onDidFilesChange,b=>b.contains(this.userSettingsResource)),c.Event.filter(this.fileService.onDidRunOperation,b=>(b.isOperation(h.FileOperation.CREATE)||b.isOperation(h.FileOperation.COPY)||b.isOperation(h.FileOperation.DELETE)||b.isOperation(h.FileOperation.WRITE))&&a.isEqual(b.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return y.createEmptyModel(this.logService)}}reparse(i){return i&&(this.parseOptions=i),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class S{constructor(i,n,a,u,d,b,A,I,E,k,F,U,M){this.key=i,this.overrides=n,this._value=a,this.overrideIdentifiers=u,this.defaultConfiguration=d,this.policyConfiguration=b,this.applicationConfiguration=A,this.userConfiguration=I,this.localUserConfiguration=E,this.remoteUserConfiguration=k,this.workspaceConfiguration=F,this.folderConfigurationModel=U,this.memoryConfigurationModel=M}get value(){return l(this._value)}toInspectValue(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class R{constructor(i,n,a,u,d,b,A,I,E,k){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=a,this._localUserConfiguration=u,this._remoteUserConfiguration=d,this._workspaceConfiguration=b,this._folderConfigurations=A,this._memoryConfiguration=I,this._memoryConfigurationByResource=E,this.logService=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(i,n,a){return this.getConsolidatedConfigurationModel(i,n,a).getValue(i)}updateValue(i,n,a={}){let u;a.resource?(u=this._memoryConfigurationByResource.get(a.resource),u||(u=y.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(a.resource,u))):u=this._memoryConfiguration,n===void 0?u.removeValue(i):u.setValue(i,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,a){const u=this.getConsolidatedConfigurationModel(i,n,a),d=this.getFolderConfigurationModelForResource(n.resource,a),b=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,A=new Set;for(const I of u.overrides)for(const E of I.identifiers)u.getOverrideValue(i,E)!==void 0&&A.add(E);return new S(i,n,u.getValue(i),A.size?[...A]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this._workspaceConfiguration:void 0,d||void 0,b)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const a=[];if(!n){const{added:u,updated:d,removed:b}=r(this._defaultConfiguration,i);n=[...u,...d,...b]}for(const u of n)for(const d of(0,p.overrideIdentifiersFromKey)(u)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(d),A=i.getKeysForOverrideIdentifier(d),I=[...A.filter(E=>b.indexOf(E)===-1),...b.filter(E=>A.indexOf(E)===-1),...b.filter(E=>!L.equals(this._defaultConfiguration.override(d).getValue(E),i.override(d).getValue(E)))];a.push([d,I])}return this.updateDefaultConfiguration(i),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:a,removed:u}=r(this._policyConfiguration,i),d=[...n,...a,...u];return d.length&&this.updatePolicyConfiguration(i),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:a,removed:u,overrides:d}=r(this.applicationConfiguration,i),b=[...n,...a,...u];return b.length&&this.updateApplicationConfiguration(i),{keys:b,overrides:d}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:a,removed:u,overrides:d}=r(this.localUserConfiguration,i),b=[...n,...a,...u];return b.length&&this.updateLocalUserConfiguration(i),{keys:b,overrides:d}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:a,removed:u,overrides:d}=r(this.remoteUserConfiguration,i),b=[...n,...a,...u];return b.length&&this.updateRemoteUserConfiguration(i),{keys:b,overrides:d}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:a,removed:u,overrides:d}=r(this.workspaceConfiguration,i),b=[...n,...a,...u];return b.length&&this.updateWorkspaceConfiguration(i),{keys:b,overrides:d}}compareAndUpdateFolderConfiguration(i,n){const a=this.folderConfigurations.get(i),{added:u,updated:d,removed:b,overrides:A}=r(a,n),I=[...u,...d,...b];return(I.length||!a)&&this.updateFolderConfiguration(i,n),{keys:I,overrides:A}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:u,removed:d,overrides:b}=r(n,void 0);return{keys:[...a,...u,...d],overrides:b}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,a){let u=this.getConsolidatedConfigurationModelForResource(n,a);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:i},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const u=n.getFolder(i);u&&(a=this.getFolderConsolidatedConfiguration(u.uri)||a);const d=this._memoryConfigurationByResource.get(i);d&&(a=a.merge(d))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(i);u?(n=a.merge(u),this._foldersConsolidatedConfigurations.set(i,n)):n=a}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const a=n.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:a,overrides:u,keys:d}=this._folderConfigurations.get(n);return i.push([n,{contents:a,overrides:u,keys:d}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(a=>i.add(a))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(u=>n.add(u))),[...n.values()]}static parse(i,n){const a=this.parseConfigurationModel(i.defaults,n),u=this.parseConfigurationModel(i.policy,n),d=this.parseConfigurationModel(i.application,n),b=this.parseConfigurationModel(i.user,n),A=this.parseConfigurationModel(i.workspace,n),I=i.folders.reduce((E,k)=>(E.set(v.URI.revive(k[0]),this.parseConfigurationModel(k[1],n)),E),new O.ResourceMap);return new R(a,u,d,b,y.createEmptyModel(n),A,I,y.createEmptyModel(n),new O.ResourceMap,n)}static parseConfigurationModel(i,n){return new y(i.contents,i.keys,i.overrides,void 0,n)}}e.Configuration=R;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,n=new Map;for(const u of o)u.keys.forEach(d=>i.add(d)),u.overrides.forEach(([d,b])=>{const A=(0,O.getOrSet)(n,d,new Set);b.forEach(I=>A.add(I))});const a=[];return n.forEach((u,d)=>a.push([d,[...u.values()]])),{keys:[...i.values()],overrides:a}}class s{constructor(i,n,a,u,d){this.change=i,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=u,this.logService=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const b of i.keys)this.affectedKeys.add(b);for(const[,b]of i.overrides)for(const A of b)this.affectedKeys.add(A);this._affectsConfigStr=this._marker;for(const b of this.affectedKeys)this._affectsConfigStr+=b+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(i,n){const a=this._marker+i,u=this._affectsConfigStr.indexOf(a);if(u<0)return!1;const d=u+a.length;if(d>=this._affectsConfigStr.length)return!1;const b=this._affectsConfigStr.charCodeAt(d);if(b!==this._markerCode1&&b!==this._markerCode2)return!1;if(n){const A=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,I=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!L.equals(A,I)}return!0}}e.ConfigurationChangeEvent=s;function r(o,i){const{added:n,removed:a,updated:u}=t(i?.rawConfiguration,o?.rawConfiguration),d=[],b=o?.getAllOverrideIdentifiers()||[],A=i?.getAllOverrideIdentifiers()||[];if(i){const I=A.filter(E=>!b.includes(E));for(const E of I)d.push([E,i.getKeysForOverrideIdentifier(E)])}if(o){const I=b.filter(E=>!A.includes(E));for(const E of I)d.push([E,o.getKeysForOverrideIdentifier(E)])}if(i&&o){for(const I of b)if(A.includes(I)){const E=t({contents:o.getOverrideValue(void 0,I)||{},keys:o.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});d.push([I,[...E.added,...E.removed,...E.updated]])}}return{added:n,removed:a,updated:u,overrides:d}}function t(o,i){const n=o?i?o.keys.filter(d=>i.keys.indexOf(d)===-1):[...o.keys]:[],a=i?o?i.keys.filter(d=>o.keys.indexOf(d)===-1):[...i.keys]:[],u=[];if(o&&i){for(const d of i.keys)if(o.keys.indexOf(d)!==-1){const b=(0,P.getConfigurationValue)(i.contents,d),A=(0,P.getConfigurationValue)(o.contents,d);L.equals(b,A)||u.push(d)}}return{added:n,removed:a,updated:u}}}),define(le[220],ue([0,1,19,3,2,30,13,78,48,10,59,44]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class h extends T.Disposable{get configurationModel(){return this._configurationModel}constructor(w){super(),this.logService=w,this._onDidChangeConfiguration=this._register(new c.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(p.Registry.as(_.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:f})=>this.onDidUpdateConfiguration(Array.from(w),f))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(w,f){this.updateConfigurationModel(w,p.Registry.as(_.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService);const w=p.Registry.as(_.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(w),w)}updateConfigurationModel(w,f){const S=this.getConfigurationDefaultOverrides();for(const R of w){const g=S[R],s=f[R];g!==void 0?this._configurationModel.addValue(R,g):s?this._configurationModel.addValue(R,s.default):this._configurationModel.removeValue(R)}}}e.DefaultConfiguration=h;class m{constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=L.ConfigurationModel.createEmptyModel(new v.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let l=class extends T.Disposable{get configurationModel(){return this._configurationModel}constructor(w,f,S){super(),this.defaultConfiguration=w,this.policyService=f,this.logService=S,this._onDidChangeConfiguration=this._register(new c.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.updatePolicyDefinitions(w),!0))),this._configurationModel}async updatePolicyDefinitions(w){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",w);const f={},S=[],R=p.Registry.as(_.Extensions.Configuration).getConfigurationProperties();for(const g of w){const s=R[g];if(!s){S.push(g);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}S.push(g),f[s.policy.name]={type:s.type}}}return(0,O.isEmptyObject)(f)||await this.policyService.updatePolicyDefinitions(f),S}onDidChangePolicies(w){this.logService.trace("PolicyConfiguration#onDidChangePolicies",w);const f=p.Registry.as(_.Extensions.Configuration).getPolicyConfigurations(),S=(0,C.coalesce)(w.map(R=>f.get(R)));this.update(S,!0)}update(w,f){this.logService.trace("PolicyConfiguration#update",w);const S=p.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),R=[],g=this._configurationModel.isEmpty();for(const s of w){const r=S[s]?.policy?.name;if(r){const t=this.policyService.getPolicyValue(r);(g?t!==void 0:!(0,D.equals)(this._configurationModel.getValue(s),t))&&R.push([s,t])}else this._configurationModel.getValue(s)!==void 0&&R.push([s,void 0])}if(R.length){this.logService.trace("PolicyConfiguration#changed",R);const s=this._configurationModel;this._configurationModel=L.ConfigurationModel.createEmptyModel(this.logService);for(const r of s.keys)this._configurationModel.setValue(r,s.getValue(r));for(const[r,t]of R)t===void 0?this._configurationModel.removeValue(r):this._configurationModel.setValue(r,t);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=l,e.PolicyConfiguration=l=we([X(1,P.IPolicyService),X(2,v.ILogService)],l)}),define(le[221],ue([0,1,19,6,15,3,34,65,2,35,30,5,21,22,78,48,220,7,59]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends _.Disposable{constructor(r,t,o,i){super(),this.settingsResource=r,this.logService=i,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration(i)),this.policyConfiguration=o instanceof S.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,o,i)),this.userConfiguration=this._register(new l.UserSettings(this.settingsResource,{},h.extUriBiasedIgnorePathCase,t,i)),this.configuration=new l.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,l.ConfigurationModel.createEmptyModel(i),l.ConfigurationModel.createEmptyModel(i),l.ConfigurationModel.createEmptyModel(i),l.ConfigurationModel.createEmptyModel(i),new v.ResourceMap,l.ConfigurationModel.createEmptyModel(i),new v.ResourceMap,i),this.configurationEditing=new g(r,t,this),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:a})=>this.onDidDefaultConfigurationChange(n,a))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[r,t,o]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new l.Configuration(r,t,l.ConfigurationModel.createEmptyModel(this.logService),o,l.ConfigurationModel.createEmptyModel(this.logService),l.ConfigurationModel.createEmptyModel(this.logService),new v.ResourceMap,l.ConfigurationModel.createEmptyModel(this.logService),new v.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(r,t){const o=typeof r=="string"?r:void 0,i=(0,m.isConfigurationOverrides)(r)?r:(0,m.isConfigurationOverrides)(t)?t:{};return this.configuration.getValue(o,i,void 0)}async updateValue(r,t,o,i,n){const a=(0,m.isConfigurationUpdateOverrides)(o)?o:(0,m.isConfigurationOverrides)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,u=a?i:o;if(u!==void 0&&u!==m.ConfigurationTarget.USER_LOCAL&&u!==m.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${u}.`);a?.overrideIdentifiers&&(a.overrideIdentifiers=(0,C.distinct)(a.overrideIdentifiers),a.overrideIdentifiers=a.overrideIdentifiers.length?a.overrideIdentifiers:void 0);const d=this.inspect(r,{resource:a?.resource,overrideIdentifier:a?.overrideIdentifiers?a.overrideIdentifiers[0]:void 0});if(d.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,P.equals)(t,d.defaultValue)&&(t=void 0),a?.overrideIdentifiers?.length&&a.overrideIdentifiers.length>1){const A=a.overrideIdentifiers.sort(),I=this.configuration.localUserConfiguration.overrides.find(E=>(0,C.equals)([...E.identifiers].sort(),A));I&&(a.overrideIdentifiers=I.identifiers)}const b=a?.overrideIdentifiers?.length?[(0,y.keyFromOverrideIdentifiers)(a.overrideIdentifiers),r]:[r];await this.configurationEditing.write(b,t),await this.reloadConfiguration()}inspect(r,t={}){return this.configuration.inspect(r,t,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const r=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(r)}onDidChangeUserConfiguration(r){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(r);this.trigger(o,t,m.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(r,t){const o=this.configuration.toData(),i=this.configuration.compareAndUpdateDefaultConfiguration(r,t);this.trigger(i,o,m.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(r){const t=this.configuration.toData(),o=this.configuration.compareAndUpdatePolicyConfiguration(r);this.trigger(o,t,m.ConfigurationTarget.DEFAULT)}trigger(r,t,o){const i=new l.ConfigurationChangeEvent(r,{data:t},this.configuration,void 0,this.logService);i.source=o,this._onDidChangeConfiguration.fire(i)}}e.ConfigurationService=R;class g{constructor(r,t,o){this.settingsResource=r,this.fileService=t,this.configurationService=o,this.queue=new c.Queue}write(r,t){return this.queue.queue(()=>this.doWriteConfiguration(r,t))}async doWriteConfiguration(r,t){let o;try{o=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(a){if(a.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw a}const i=[];if((0,O.parse)(o,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(o,r,t);o=(0,L.applyEdits)(o,n),await this.fileService.writeFile(this.settingsResource,T.VSBuffer.fromString(o))}getEdits(r,t,o){const{tabSize:i,insertSpaces:n,eol:a}=this.formattingOptions;if(!t.length){const u=JSON.stringify(o,null,n?" ".repeat(i):"	");return[{content:u,length:u.length,offset:0}]}return(0,L.setProperty)(r,t,o,{tabSize:i,insertSpaces:n,eol:a})}get formattingOptions(){if(!this._formattingOptions){let r=p.OS===p.OperatingSystem.Linux||p.OS===p.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(r=t),this._formattingOptions={eol:r,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[222],ue([0,1,15,3,2,71]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=L;const O=(v,P,p)=>{const h=new Uint8Array(16);for(let y=0;y<16;y++)h[y]=Math.round(Math.random()*256);const m=(0,C.encodeBase64)(C.VSBuffer.wrap(h));return[`GET ws://localhost${v}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=O,e.socketRawEndHeaderSequence=C.VSBuffer.fromString(`\r
\r
`);async function L(v,P,p,h,m){v.write(C.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,p,h)));const l=new T.DisposableStore;try{return await new Promise((y,w)=>{let f;l.add(v.onData(S=>{f?f=C.VSBuffer.concat([f,S],f.byteLength+S.byteLength):f=S;const R=f.indexOf(e.socketRawEndHeaderSequence);if(R===-1)return;y(v),v.pauseData();const g=f.slice(R+e.socketRawEndHeaderSequence.byteLength);g.byteLength&&m.onData.fire(g)})),l.add(v.onClose(S=>w(S??new Error("socket closed")))),l.add(v.onEnd(()=>w(new Error("socket ended"))))})}catch(y){throw v.dispose(),y}finally{l.dispose()}}class _ extends T.Disposable{constructor(P,p){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new c.PauseableEmitter),this.onData=(...h)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...h)),this.didDisposeEmitter=this._register(new c.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(p.onData),this._register(p.onData.event(h=>this.pausableDataEmitter.fire(h))),this.onClose=this._register(p.onClose).event,this.onEnd=this._register(p.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,p){D.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,p)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=_}),define(le[105],ue([0,1,8,4]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=v,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var T;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class D{constructor(p){this.id=p,this.type=T.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=D;class O{constructor(p,h){this.host=p,this.port=h,this.type=T.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=O;var L;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(L||(e.RemoteAuthorityResolverErrorCode=L={}));class _ extends C.ErrorNoTelemetry{static isNotAvailable(p){return p instanceof _&&p._code===L.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof _&&p._code===L.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof _&&p._code===L.NoResolverFound}static isInvalidAuthority(p){return p instanceof _&&p._code===L.InvalidAuthority}static isHandled(p){return p instanceof _&&p.isHandled}constructor(p,h=L.Unknown,m){super(p),this._message=p,this._code=h,this._detail=m,this.isHandled=h===L.NotAvailable&&m===!0,Object.setPrototypeOf(this,_.prototype)}}e.RemoteAuthorityResolverError=_;function v(P){const p=P.indexOf("+");return p===-1?P:P.substring(0,p)}}),define(le[223],ue([0,1,6,15,26,8,3,2,23,101,55,32,71,105]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=d,e.connectRemoteAgentExtensionHost=b,e.connectRemoteAgentTunnel=I,v=De(v);const l=30*1e3;var y;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(G){switch(G){case y.Management:return"Management";case y.ExtensionHost:return"ExtensionHost";case y.Tunnel:return"Tunnel"}}function f(G){const j=new T.CancellationTokenSource;return setTimeout(()=>j.cancel(),G),j.token}function S(G,j){if(G.isCancellationRequested||j.isCancellationRequested)return T.CancellationToken.Cancelled;const N=new T.CancellationTokenSource;return G.onCancellationRequested(()=>N.cancel()),j.onCancellationRequested(()=>N.cancel()),N.token}class R{get didTimeout(){return this._state==="timedout"}constructor(j){this._state="pending",this._disposables=new L.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,C.promiseWithResolvers)(),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function g(G,j){const N=new R(j);return N.registerDisposable(G.onControlMessage(Y=>{const $=JSON.parse(Y.toString()),x=q($);x?N.reject(x):N.resolve($)})),N.promise}function s(G,j,N,Y,$,x,J,ee){const K=new R(ee),oe=P.StopWatch.create(!1);return G.info(`Creating a socket (${J})...`),v.mark(`code/willCreateSocket/${x}`),j.connect(N,Y,$,J).then(he=>{K.didTimeout?(v.mark(`code/didCreateSocketError/${x}`),G.info(`Creating a socket (${J}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(v.mark(`code/didCreateSocketOK/${x}`),G.info(`Creating a socket (${J}) was successful after ${oe.elapsed()} ms.`),K.resolve(he))},he=>{v.mark(`code/didCreateSocketError/${x}`),G.info(`Creating a socket (${J}) returned an error after ${oe.elapsed()} ms.`),G.error(he),K.reject(he)}),K.promise}function r(G,j){const N=new R(j);return G.then(Y=>{N.didTimeout||N.resolve(Y)},Y=>{N.didTimeout||N.reject(Y)}),N.promise}async function t(G,j,N,Y){const $=W(G,j);G.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let x;try{x=await s(G.logService,G.remoteSocketFactoryService,G.connectTo,_.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,w(j),`renderer-${w(j)}-${G.reconnectionToken}`,Y)}catch(he){throw G.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),G.logService.error(he),he}G.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let J,ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(x,null),J=G.reconnectionProtocol,ee=!1):(J=new h.PersistentProtocol({socket:x}),ee=!0),G.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const K=await r(G.signService.createNewMessage((0,p.generateUuid)()),Y),oe={type:"auth",auth:G.connectionToken||"00000000000000000000",data:K.data};J.sendControl(c.VSBuffer.fromString(JSON.stringify(oe)));try{const he=await g(J,S(Y,f(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(G.logService.trace(`${$} 4/6. received SignRequest control message.`),!await r(G.signService.validate(K,he.signedData),Y)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const Se=await r(G.signService.sign(he.data),Y),Pe={type:"connectionType",commit:G.commit,signedData:Se,desiredConnectionType:j};return N&&(Pe.args=N),G.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(c.VSBuffer.fromString(JSON.stringify(Pe))),{protocol:J,ownsProtocol:ee}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(G.logService.error(`${$} the handshake timed out. Error:`),G.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${$} received error control message when negotiating connection. Error:`),G.logService.error(he)),ee&&z(J),he}}async function o(G,j,N,Y){const $=Date.now(),x=W(G,j),{protocol:J,ownsProtocol:ee}=await t(G,j,N,Y),K=new R(Y);return K.registerDisposable(J.onControlMessage(oe=>{const he=JSON.parse(oe.toString()),ge=q(he);ge?(G.logService.error(`${x} received error control message when negotiating connection. Error:`),G.logService.error(ge),ee&&z(J),K.reject(ge)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${Q($)}!`),K.resolve({protocol:J,firstMessage:he}))})),K.promise}async function i(G,j){const{protocol:N}=await o(G,y.Management,void 0,j);return{protocol:N}}async function n(G,j,N){const{protocol:Y,firstMessage:$}=await o(G,y.ExtensionHost,j,N),x=$&&$.debugPort;return{protocol:Y,debugPort:x}}async function a(G,j,N){const Y=Date.now(),$=W(G,y.Tunnel),{protocol:x}=await t(G,y.Tunnel,j,N);return G.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Q(Y)}!`),x}async function u(G,j,N){const{connectTo:Y,connectionToken:$}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:Y,connectionToken:$,reconnectionToken:j,reconnectionProtocol:N,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function d(G,j,N){return A(G,async Y=>{const{protocol:$}=await i(Y,T.CancellationToken.None);return new V(G,j,N,Y.reconnectionToken,$)})}async function b(G,j){return A(G,async N=>{const{protocol:Y,debugPort:$}=await n(N,j,T.CancellationToken.None);return new ie(G,j,N.reconnectionToken,Y,$)})}async function A(G,j){for(let Y=1;;Y++)try{const $=(0,p.generateUuid)(),x=await u(G,$,null);return await j(x)}catch($){if(Y<5)G.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),G.logService.error($);else throw G.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error($),Z.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled($)),$}}async function I(G,j,N){const Y=await u(G,(0,p.generateUuid)(),null);return await a(Y,{host:j,port:N},T.CancellationToken.None)}function E(G){return(0,C.createCancelablePromise)(j=>new Promise((N,Y)=>{const $=setTimeout(N,G*1e3);j.onCancellationRequested(()=>{clearTimeout($),N()})}))}var k;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(k||(e.PersistentConnectionEventType=k={}));class F{constructor(j,N){this.reconnectionToken=j,this.millisSinceLastIncomingData=N,this.type=k.ConnectionLost}}e.ConnectionLostEvent=F;class U{constructor(j,N,Y,$){this.reconnectionToken=j,this.millisSinceLastIncomingData=N,this.durationSeconds=Y,this.cancellableTimer=$,this.type=k.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class M{constructor(j,N,Y){this.reconnectionToken=j,this.millisSinceLastIncomingData=N,this.attempt=Y,this.type=k.ReconnectionRunning}}e.ReconnectionRunningEvent=M;class H{constructor(j,N,Y){this.reconnectionToken=j,this.millisSinceLastIncomingData=N,this.attempt=Y,this.type=k.ConnectionGain}}e.ConnectionGainEvent=H;class B{constructor(j,N,Y,$){this.reconnectionToken=j,this.millisSinceLastIncomingData=N,this.attempt=Y,this.handled=$,this.type=k.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=B;class Z extends L.Disposable{static triggerPermanentFailure(j,N,Y){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=N,this._permanentFailureHandled=Y,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||Z._permanentFailure}constructor(j,N,Y,$,x){super(),this._connectionType=j,this._options=N,this.reconnectionToken=Y,this.protocol=$,this._reconnectionFailureIsFatal=x,this._onDidStateChange=this._register(new O.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new H(this.reconnectionToken,0,0)),this._register($.onSocketClose(J=>{const ee=ce(this._connectionType,this.reconnectionToken,!0);J?J.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${ee} received socket close event (hadError: ${J.hadError}).`),J.error&&this._options.logService.error(J.error)):(this._options.logService.info(`${ee} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this._options.logService.error(J.event)):this._options.logService.info(`${ee} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(J=>{const ee=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),Z._instances.push(this),this._register((0,L.toDisposable)(()=>{const J=Z._instances.indexOf(this);J>=0&&Z._instances.splice(J,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Z._permanentFailureMillisSinceLastIncomingData,Z._permanentFailureAttempt,Z._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const j=ce(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const $=Y<N.length?N[Y]:N[N.length-1];try{if($>0){const J=E($);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,J)),this._options.logService.info(`${j} waiting for ${$} seconds before reconnecting...`);try{await J}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this._options.logService.info(`${j} resolving connection...`);const x=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${x.connectTo}...`),await this._reconnect(x,f(l)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,D.isCancellationError)(x)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof m.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,m.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(j,N,Y){this._reconnectionFailureIsFatal?Z.triggerPermanentFailure(j,N,Y):this._gotoPermanentFailure(j,N,Y)}_gotoPermanentFailure(j,N,Y){this._onDidStateChange.fire(new B(this.reconnectionToken,j,N,Y)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Z;class V extends Z{constructor(j,N,Y,$,x){super(y.Management,j,$,x,!0),this.client=this._register(new h.Client(x,{remoteAuthority:N,clientId:Y},j.ipcLogger))}async _reconnect(j,N){await i(j,N)}}e.ManagementPersistentConnection=V;class ie extends Z{constructor(j,N,Y,$,x){super(y.ExtensionHost,j,Y,$,!1),this._startArguments=N,this.debugPort=x}async _reconnect(j,N){await n(j,this._startArguments,N)}}e.ExtensionHostPersistentConnection=ie;function z(G){try{G.acceptDisconnect();const j=G.getSocket();G.dispose(),j.dispose()}catch(j){(0,D.onUnexpectedError)(j)}}function q(G){if(G&&G.type==="error"){const j=new Error(`Connection error: ${G.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function te(G,j){for(;G.length<j;)G+=" ";return G}function se(G,j){return`[remote-connection][${te(w(G),13)}][${j.substr(0,5)}\u2026]`}function ce(G,j,N){return`${se(G,j)}[${N?"reconnect":"initial"}]`}function W(G,j){return`${ce(j,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function Q(G){return`${Date.now()-G} ms`}}),define(le[106],ue([0,1,23]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=c,e.getRemoteName=T,e.parseAuthorityWithPort=D,e.parseAuthorityWithOptionalPort=O;function c(_){return _.scheme===C.Schemas.vscodeRemote?_.authority:void 0}function T(_){if(!_)return;const v=_.indexOf("+");return v<0?_:_.substr(0,v)}function D(_){const{host:v,port:P}=L(_);if(typeof P>"u")throw new Error(`Invalid remote authority: ${_}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:v,port:P}}function O(_,v){let{host:P,port:p}=L(_);return typeof p>"u"&&(p=v),{host:P,port:p}}function L(_){const v=_.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const P=_.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const p=_.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:_,port:void 0}}}),define(le[36],ue([0,1,27,4,106]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=D,e.isApplicationScopedExtension=p,e.isLanguagePackExtension=h,e.isAuthenticationProviderExtension=m,e.isResolverExtension=l,e.parseApiProposals=y,e.parseEnabledApiProposalNames=w,C=De(C),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(O||(e.ExtensionType=O={}));var L;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.LINUX_PPC64LE="linux-ppc64le",f.LINUX_RISCV64="linux-riscv64",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(L||(e.TargetPlatform=L={}));class _{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,R){if(typeof S>"u"||S===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof S=="string"||typeof R=="string"){const g=typeof S=="string"?S:S.value,s=typeof R=="string"?R:R.value;return C.equalsIgnoreCase(g,s)}return S._lower===R._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=_;class v{get size(){return this._set.size}constructor(S){if(this._set=new Set,S)for(const R of S)this.add(R)}add(S){this._set.add(_.toKey(S))}delete(S){return this._set.delete(_.toKey(S))}has(S){return this._set.has(_.toKey(S))}}e.ExtensionIdentifierSet=v;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(S){this._map.delete(_.toKey(S))}get(S){return this._map.get(_.toKey(S))}has(S){return this._map.has(_.toKey(S))}set(S,R){this._map.set(_.toKey(S),R)}values(){return this._map.values()}forEach(S){this._map.forEach(S)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function p(f){return h(f)}function h(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function l(f,S){if(S){const R=`onResolveRemoteAuthority:${(0,T.getRemoteName)(S)}`;return!!f.activationEvents?.includes(R)}return!1}function y(f){return f.map(S=>{const[R,g]=S.split("@");return{proposalName:R,version:g?parseInt(g):void 0}})}function w(f){return f.map(S=>S.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,c.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[28],ue([0,1,5,163,36,4]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=L,e.toTargetPlatform=_,e.getTargetPlatform=v,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=p,e.isIExtensionIdentifier=h,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var O;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function L(s){switch(s){case T.TargetPlatform.WIN32_X64:return"Windows 64 bit";case T.TargetPlatform.WIN32_ARM64:return"Windows ARM";case T.TargetPlatform.LINUX_X64:return"Linux 64 bit";case T.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case T.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case T.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case T.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case T.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case T.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case T.TargetPlatform.DARWIN_X64:return"Mac";case T.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case T.TargetPlatform.WEB:return"Web";case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;case T.TargetPlatform.UNKNOWN:return T.TargetPlatform.UNKNOWN;case T.TargetPlatform.UNDEFINED:return T.TargetPlatform.UNDEFINED}}function _(s){switch(s){case T.TargetPlatform.WIN32_X64:return T.TargetPlatform.WIN32_X64;case T.TargetPlatform.WIN32_ARM64:return T.TargetPlatform.WIN32_ARM64;case T.TargetPlatform.LINUX_X64:return T.TargetPlatform.LINUX_X64;case T.TargetPlatform.LINUX_ARM64:return T.TargetPlatform.LINUX_ARM64;case T.TargetPlatform.LINUX_ARMHF:return T.TargetPlatform.LINUX_ARMHF;case T.TargetPlatform.LINUX_PPC64LE:return T.TargetPlatform.LINUX_PPC64LE;case T.TargetPlatform.LINUX_RISCV64:return T.TargetPlatform.LINUX_RISCV64;case T.TargetPlatform.ALPINE_X64:return T.TargetPlatform.ALPINE_X64;case T.TargetPlatform.ALPINE_ARM64:return T.TargetPlatform.ALPINE_ARM64;case T.TargetPlatform.DARWIN_X64:return T.TargetPlatform.DARWIN_X64;case T.TargetPlatform.DARWIN_ARM64:return T.TargetPlatform.DARWIN_ARM64;case T.TargetPlatform.WEB:return T.TargetPlatform.WEB;case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;default:return T.TargetPlatform.UNKNOWN}}function v(s,r){switch(s){case C.Platform.Windows:return r==="x64"?T.TargetPlatform.WIN32_X64:r==="arm64"?T.TargetPlatform.WIN32_ARM64:T.TargetPlatform.UNKNOWN;case C.Platform.Linux:return r==="x64"?T.TargetPlatform.LINUX_X64:r==="arm64"?T.TargetPlatform.LINUX_ARM64:r==="arm"?T.TargetPlatform.LINUX_ARMHF:r==="ppc64le"?T.TargetPlatform.LINUX_PPC64LE:r==="riscv64"?T.TargetPlatform.LINUX_RISCV64:T.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?T.TargetPlatform.ALPINE_X64:r==="arm64"?T.TargetPlatform.ALPINE_ARM64:T.TargetPlatform.UNKNOWN;case C.Platform.Mac:return r==="x64"?T.TargetPlatform.DARWIN_X64:r==="arm64"?T.TargetPlatform.DARWIN_ARM64:T.TargetPlatform.UNKNOWN;case C.Platform.Web:return T.TargetPlatform.WEB}}function P(s,r){return r===T.TargetPlatform.WEB&&!s.includes(T.TargetPlatform.WEB)}function p(s,r,t){return P(r,t)?!1:s===T.TargetPlatform.UNDEFINED||s===T.TargetPlatform.UNIVERSAL?!0:s===T.TargetPlatform.UNKNOWN?!1:s===t}function h(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var m;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var l;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var y;(function(s){s.Install="install",s.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var f;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class S extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.ExtensionGalleryError=S;var R;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateExistingMetadata="UpdateExistingMetadata",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class g extends Error{constructor(r,t){super(r),this.code=t,this.name=t}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,c.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,c.localize2)(1,"Preferences")}),define(le[224],ue([0,1,3,2,30,9,95,28]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function _(w,f){return w?D.URI.revive(f?f.transformIncoming(w):w):void 0}function v(w,f){return f?f.transformOutgoingURI(w):w}function P(w,f){f=f||O.DefaultURITransformer;const S=w.manifest;return{...(0,O.transformAndReviveIncomingURIs)({...w,manifest:void 0},f),manifest:S}}function p(w,f){return w?.profileLocation?(0,O.transformAndReviveIncomingURIs)(w,f??O.DefaultURITransformer):w}function h(w,f){return f?(0,T.cloneAndChange)(w,S=>S instanceof D.URI?f.transformOutgoingURI(S):void 0):w}class m{constructor(f,S){this.service=f,this.getUriTransformer=S,this.onInstallExtension=C.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=C.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=C.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=C.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=C.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,S){const R=this.getUriTransformer(f);switch(S){case"onInstallExtension":return C.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?v(g.profileLocation,R):g.profileLocation}));case"onDidInstallExtensions":return C.Event.map(this.onDidInstallExtensions,g=>g.map(s=>({...s,local:s.local?h(s.local,R):s.local,profileLocation:s.profileLocation?v(s.profileLocation,R):s.profileLocation})));case"onUninstallExtension":return C.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?v(g.profileLocation,R):g.profileLocation}));case"onDidUninstallExtension":return C.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?v(g.profileLocation,R):g.profileLocation}));case"onDidUpdateExtensionMetadata":return C.Event.map(this.onDidUpdateExtensionMetadata,g=>({local:h(g.local,R),profileLocation:v(g.profileLocation,R)}))}throw new Error("Invalid listen")}async call(f,S,R){const g=this.getUriTransformer(f);switch(S){case"zip":{const s=P(R[0],g),r=await this.service.zip(s);return v(r,g)}case"unzip":return this.service.unzip(_(R[0],g));case"install":return this.service.install(_(R[0],g),p(R[1],g));case"installFromLocation":return this.service.installFromLocation(_(R[0],g),_(R[1],g));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(R[0],_(R[1],g),_(R[2],g));case"getManifest":return this.service.getManifest(_(R[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(R[0]);case"installFromGallery":return this.service.installFromGallery(R[0],p(R[1],g));case"installGalleryExtensions":{const s=R[0];return this.service.installGalleryExtensions(s.map(({extension:r,options:t})=>({extension:r,options:p(t,g)??{}})))}case"uninstall":return this.service.uninstall(P(R[0],g),p(R[1],g));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(R[0],g));case"getInstalled":return(await this.service.getInstalled(R[0],_(R[1],g),R[2])).map(r=>h(r,g));case"toggleAppliationScope":{const s=await this.service.toggleAppliationScope(P(R[0],g),_(R[1],g));return h(s,g)}case"copyExtensions":return this.service.copyExtensions(_(R[0],g),_(R[1],g));case"updateMetadata":{const s=await this.service.updateMetadata(P(R[0],g),R[1],_(R[2],g));return h(s,g)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(R[0],R[1],R[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class l extends c.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(f){super(),this.channel=f,this._onInstallExtension=this._register(new C.Emitter),this._onDidInstallExtensions=this._register(new C.Emitter),this._onUninstallExtension=this._register(new C.Emitter),this._onDidUninstallExtension=this._register(new C.Emitter),this._onDidUpdateExtensionMetadata=this._register(new C.Emitter),this._register(this.channel.listen("onInstallExtension")(S=>this.fireEvent(this._onInstallExtension,{...S,source:this.isUriComponents(S.source)?D.URI.revive(S.source):S.source,profileLocation:D.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this.fireEvent(this._onDidInstallExtensions,S.map(R=>({...R,local:R.local?P(R.local,null):R.local,source:this.isUriComponents(R.source)?D.URI.revive(R.source):R.source,profileLocation:D.URI.revive(R.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this.fireEvent(this._onUninstallExtension,{...S,profileLocation:D.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this.fireEvent(this._onDidUninstallExtension,{...S,profileLocation:D.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(S=>this.fireEvent(this._onDidUpdateExtensionMetadata,{profileLocation:D.URI.revive(S.profileLocation),local:P(S.local,null)})))}fireEvent(f,S){f.fire(S)}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const S=await this.getTargetPlatform();return f.allTargetPlatforms.some(R=>(0,L.isTargetPlatformCompatible)(R,f.allTargetPlatforms,S))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(S=>D.URI.revive(S)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,S){return Promise.resolve(this.channel.call("install",[f,S])).then(R=>P(R,null))}installFromLocation(f,S){return Promise.resolve(this.channel.call("installFromLocation",[f,S])).then(R=>P(R,null))}async installExtensionsFromProfile(f,S,R){return(await this.channel.call("installExtensionsFromProfile",[f,S,R])).map(s=>P(s,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,S){return Promise.resolve(this.channel.call("installFromGallery",[f,S])).then(R=>P(R,null))}async installGalleryExtensions(f){return(await this.channel.call("installGalleryExtensions",[f])).map(R=>({...R,local:R.local?P(R.local,null):R.local,source:this.isUriComponents(R.source)?D.URI.revive(R.source):R.source,profileLocation:D.URI.revive(R.profileLocation)}))}uninstall(f,S){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[f,S]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f])).then(S=>P(S,null))}getInstalled(f=null,S,R){return Promise.resolve(this.channel.call("getInstalled",[f,S,R])).then(g=>g.map(s=>P(s,null)))}updateMetadata(f,S,R){return Promise.resolve(this.channel.call("updateMetadata",[f,S,R])).then(g=>P(g,null))}toggleAppliationScope(f,S){return this.channel.call("toggleAppliationScope",[f,S]).then(R=>P(R,null))}copyExtensions(f,S){return this.channel.call("copyExtensions",[f,S])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(f,S,R){const g=await this.channel.call("download",[f,S,R]);return D.URI.revive(g)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=l;class y{constructor(f){this.service=f}listen(f,S){throw new Error("Invalid listen")}call(f,S,R){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(D.URI.revive(R[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(le[225],ue([0,1,2,36,7]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends C.Disposable{constructor(L,_,v,P,p){super(),this.userDataProfilesService=L,this.fileService=_,this.uriIdentityService=v,this.logService=p,this._register(P.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(P.onDidUninstallExtension(h=>this.onDidUnInstallExtension(h)))}onDidInstallExtensions(L){for(const _ of L)_.local&&this.invalidate(_.profileLocation)}onDidUnInstallExtension(L){L.error||this.invalidate(L.profileLocation)}async invalidate(L){if(L)for(const _ of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(_.extensionsResource,L)&&await this.deleteUserCacheFile(_);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(L){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(L.cacheHome,c.USER_MANIFEST_CACHE_FILE))}catch(_){(0,T.toFileOperationResult)(_)!==T.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(_)}}}e.ExtensionsManifestCache=D});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[60],ue([0,1,21,92,168,61,36,196]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=P,e.parseVersion=p,e.normalizeVersion=h,e.isValidVersion=m,e.validateExtensionManifest=l,e.isValidExtensionVersion=y,e.isEngineValid=w,e.areApiProposalsCompatible=f,c=it(c),T=De(T),D=De(D);const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function P(g){return g=g.trim(),g==="*"||_.test(g)}function p(g){if(!P(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=g.match(_);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function h(g){if(!g)return null;const s=g.majorBase,r=g.majorMustEqual,t=g.minorBase;let o=g.minorMustEqual;const i=g.patchBase;let n=g.patchMustEqual;g.hasCaret&&(s===0||(o=!1),n=!1);let a=0;if(g.preRelease){const u=v.exec(g.preRelease);if(u){const[,d,b,A]=u;a=Date.UTC(Number(d),Number(b)-1,Number(A))}}return{majorBase:s,majorMustEqual:r,minorBase:t,minorMustEqual:o,patchBase:i,patchMustEqual:n,isMinimum:g.hasGreaterEquals,notBefore:a}}function m(g,s,r){let t;typeof g=="string"?t=h(p(g)):t=g;let o;s instanceof Date?o=s.getTime():typeof s=="string"&&(o=new Date(s).getTime());let i;if(typeof r=="string"?i=h(p(r)):i=r,!t||!i)return!1;const n=t.majorBase,a=t.minorBase,u=t.patchBase;let d=i.majorBase,b=i.minorBase,A=i.patchBase;const I=i.notBefore;let E=i.majorMustEqual,k=i.minorMustEqual,F=i.patchMustEqual;return i.isMinimum?n>d?!0:n<d?!1:a>b?!0:a<b||o&&o<I?!1:u>=A:(n===1&&d===0&&(!E||!k||!F)&&(d=1,b=0,A=0,E=!0,k=!1,F=!1),n<d?!1:n>d?!E:a<b?!1:a>b?!k:u<A?!1:u>A?!F:!(o&&o<I))}function l(g,s,r,t,o,i){const n=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return n.push([c.default.Error,T.localize(0,null)]),n;if(typeof t.name!="string")return n.push([c.default.Error,T.localize(1,null,"name")]),n;if(typeof t.version!="string")return n.push([c.default.Error,T.localize(2,null,"version")]),n;if(!t.engines)return n.push([c.default.Error,T.localize(3,null,"engines")]),n;if(typeof t.engines.vscode!="string")return n.push([c.default.Error,T.localize(4,null,"engines.vscode")]),n;if(typeof t.extensionDependencies<"u"&&!R(t.extensionDependencies))return n.push([c.default.Error,T.localize(5,null,"extensionDependencies")]),n;if(typeof t.activationEvents<"u"){if(!R(t.activationEvents))return n.push([c.default.Error,T.localize(6,null,"activationEvents")]),n;if(typeof t.main>"u"&&typeof t.browser>"u")return n.push([c.default.Error,T.localize(7,null,"activationEvents","main","browser")]),n}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&n.push([c.default.Warning,T.localize(8,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return n.push([c.default.Error,T.localize(9,null,"main")]),n;{const d=(0,C.joinPath)(r,t.main);(0,C.isEqualOrParent)(d,r)||n.push([c.default.Warning,T.localize(10,null,d.path,r.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return n.push([c.default.Error,T.localize(11,null,"browser")]),n;{const d=(0,C.joinPath)(r,t.browser);(0,C.isEqualOrParent)(d,r)||n.push([c.default.Warning,T.localize(12,null,d.path,r.path)])}}if(!D.valid(t.version))return n.push([c.default.Error,T.localize(13,null)]),n;const a=[];if(!y(g,s,t,o,a))for(const d of a)n.push([c.default.Error,d]);if(i&&t.enabledApiProposals?.length){const d=[];if(!f([...t.enabledApiProposals],d))for(const b of d)n.push([c.default.Error,b])}return n}function y(g,s,r,t,o){return t||typeof r.main>"u"&&typeof r.browser>"u"?!0:S(g,s,r.engines.vscode,o)}function w(g,s,r){return g==="*"||S(s,r,g)}function f(g,s){if(g.length===0)return!0;const r=Array.isArray(s)?s:void 0,t=(r?void 0:s)??L.allApiProposals,o=[],i=(0,O.parseApiProposals)(g);for(const{proposalName:n,version:a}of i){const u=t[n];u&&a&&u.version!==a&&o.push(T.localize(14,null,n))}return r?.push(...o),o.length===0}function S(g,s,r,t=[]){const o=h(p(r));if(!o)return t.push(T.localize(15,null,r)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(T.localize(16,null,r)),!1}else if(!o.majorMustEqual)return t.push(T.localize(17,null,r)),!1;return m(g,s,o)?!0:(t.push(T.localize(18,null,g,r)),!1)}function R(g){if(!Array.isArray(g))return!1;for(let s=0,r=g.length;s<r;s++)if(typeof g[s]!="string")return!1;return!0}}),define(le[79],ue([0,1,26,2,5,173,28,4]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=_;function _(P){return P.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,L.createDecorator)("languagePackService");let v=class extends c.Disposable{constructor(p){super(),this.extensionGalleryService=p}async getAvailableLanguages(){const p=new C.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let h;try{h=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const l=h.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(w=>w.startsWith("lp-"))).map(y=>{const w=y.properties.localizedLanguages?.[0],f=_(y);return{...this.createQuickPickItem(f,w,y),extensionId:y.identifier.id,galleryExtension:y}});return l.push(this.createQuickPickItem("en","English")),l}createQuickPickItem(p,h,m){const l=h??p;let y;if(l!==p&&(y=`(${p})`),p.toLowerCase()===T.language.toLowerCase()&&(y??="",y+=(0,D.localize)(0,null)),m?.installCount){y??="";const w=m.installCount;let f;w>1e6?f=`${Math.floor(w/1e5)/10}M`:w>1e3?f=`${Math.floor(w/1e3)}K`:f=String(w),y+=` $(cloud-download) ${f}`}return{id:p,label:l,description:y}}};e.LanguagePackBaseService=v,e.LanguagePackBaseService=v=we([X(0,O.IExtensionGalleryService)],v)}),define(le[226],ue([0,1,2,79]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends C.Disposable{constructor(O){super(),this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=T,e.LocalizationsUpdater=T=we([X(0,c.ILanguagePackService)],T)}),define(le[107],ue([0,1,2,4]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,c.createDecorator)("remoteSocketFactoryService");class T{constructor(){this.factories={}}register(O,L){return this.factories[O]??=[],this.factories[O].push(L),(0,C.toDisposable)(()=>{const _=this.factories[O]?.indexOf(L);typeof _=="number"&&_>=0&&this.factories[O]?.splice(_,1)})}getSocketFactory(O){return(this.factories[O.type]||[]).find(_=>_.supports(O))}connect(O,L,_,v){const P=this.getSocketFactory(O);if(!P)throw new Error(`No socket factory found for ${O}`);return P.connect(O,L,_,v)}}e.RemoteSocketFactoryService=T}),define(le[227],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,C.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[108],ue([0,1,4,175]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,C.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var T;(function(D){D.disconnected=O=>({type:"disconnected",onTokenFailed:O}),D.connected=(O,L)=>({type:"connected",info:O,serviceInstallFailed:L}),D.connecting=O=>({type:"connecting",progress:O}),D.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,c.localize)(0,null)}),define(le[62],ue([0,1,15,8,2,177,48,4,10,44]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=h,e.hasNoContent=m,e.asText=l,e.asTextOrError=y,e.asJson=w,e.updateProxyConfigurationsScope=f,e.IRequestService=(0,L.createDecorator)("requestService");class P{constructor(s){this.original=s}toJSON(){if(!this.headers){const s=Object.create(null);for(const r in this.original)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?s[r]="*****":s[r]=this.original[r];this.headers=s}return this.headers}}class p extends T.Disposable{constructor(s){super(),this.counter=0,this.logger=s.createLogger("network",{name:(0,D.localize)(0,null),when:_.CONTEXT_LOG_LEVEL.isEqualTo((0,_.LogLevelToString)(_.LogLevel.Trace)).serialize()})}async logAndRequest(s,r,t){const o=`${s} #${++this.counter}: ${r.url}`;this.logger.trace(`${o} - begin`,r.type,new P(r.headers??{}));try{const i=await t();return this.logger.trace(`${o} - end`,r.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${o} - error`,r.type,(0,c.getErrorMessage)(i)),i}}}e.AbstractRequestService=p;function h(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function m(g){return g.res.statusCode===204}async function l(g){return m(g)?null:(await(0,C.streamToBuffer)(g.stream)).toString()}async function y(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);return l(g)}async function w(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);if(m(g))return null;const r=(await(0,C.streamToBuffer)(g.stream)).toString();try{return JSON.parse(r)}catch(t){throw t.message+=`:
`+r,t}}function f(g){R(g)}let S;function R(g){const s=v.Registry.as(O.Extensions.Configuration),r=S;S={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null),(0,D.localize)(10,null)],default:"override",description:(0,D.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(13,null),restricted:!0}}},s.updateConfigurations({add:[S],remove:r?[r]:[]})}R(O.ConfigurationScope.APPLICATION)}),define(le[228],ue([0,1,26,23,7,62]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(_,v){this.requestService=_,this.fileService=v}async download(_,v,P=C.CancellationToken.None){if(_.scheme===c.Schemas.file||_.scheme===c.Schemas.vscodeRemote){await this.fileService.copy(_,v);return}const p={type:"GET",url:_.toString(!0)},h=await this.requestService.request(p,P);if(h.res.statusCode===200)await this.fileService.writeFile(v,h.stream);else{const m=await(0,D.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${m}`)}}};e.DownloadService=O,e.DownloadService=O=we([X(0,D.IRequestService),X(1,T.IFileService)],O)}),define(le[229],ue([0,1,15,26]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class T{constructor(L){this.service=L}listen(L,_){throw new Error("Invalid listen")}call(L,_,v,P=c.CancellationToken.None){switch(_){case"request":return this.service.request(v[0],P).then(async({res:p,stream:h})=>{const m=await(0,C.streamToBuffer)(h);return[{statusCode:p.statusCode,headers:p.headers},m]});case"resolveProxy":return this.service.resolveProxy(v[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=T;class D{constructor(L){this.channel=L}async request(L,_){const[v,P]=await this.channel.call("request",[L],_);return{res:v,stream:(0,C.bufferToStream)(P)}}async resolveProxy(L){return this.channel.call("resolveProxy",[L])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=D}),define(le[230],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[231],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class C{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(T){try{const D=await this.getValidator();if(D){const O=String(C._nextId++);return this.validators.set(O,D),{id:O,data:D.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,D){if(!T.id)return!0;const O=this.validators.get(T.id);if(!O)return!1;this.validators.delete(T.id);try{return O.validate(D)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(T){try{return await this.signValue(T)}catch{}return T}}e.AbstractSignService=C}),define(le[109],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,C.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[232],ue([0,1,231]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c extends C.AbstractSignService{getValidator(){return this.vsda().then(D=>new D.validator)}signValue(D){return this.vsda().then(O=>new O.signer().sign(D))}vsda(){return new Promise((D,O)=>ne(["vsda"],D,O))}}e.SignService=c}),define(le[80],ue([0,1,3,2]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends c.Disposable{constructor(p,h,m){super(),this.channel=p,this.profile=h,this.workspace=m}async getItems(){const p={profile:this.profile,workspace:this.workspace},h=await this.channel.call("getItems",p);return new Map(h)}updateItems(p){const h={profile:this.profile,workspace:this.workspace};return p.insert&&(h.insert=Array.from(p.insert.entries())),p.delete&&(h.delete=Array.from(p.delete.values())),this.channel.call("updateItems",h)}optimize(){const p={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",p)}}class D extends T{constructor(p,h){super(p,h,void 0),this._onDidChangeItemsExternal=this._register(new C.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(p=>this.onDidChangeStorage(p)))}onDidChangeStorage(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this._onDidChangeItemsExternal.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class O extends D{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class L extends D{constructor(p,h){super(p,h)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=L;class _ extends T{constructor(p,h){super(p,void 0,h),this.onDidChangeItemsExternal=C.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=_;class v{constructor(p){this.channel=p}isUsed(p){const h={payload:p,profile:void 0,workspace:void 0};return this.channel.call("isUsed",h)}}e.StorageClient=v}),define(le[110],ue([0,1,5,37,32]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=O,e.verifyMicrosoftInternalDomain=L;function D(_){if(C.platform===C.Platform.Linux&&/^penguin(\.|$)/i.test(_))return"chromebook"}function O(_,v,P,p,h,m,l,y,w,f){const S=Object.create(null);S["common.machineId"]=m,S["common.sqmId"]=l,S["common.devDeviceId"]=y,S.sessionID=(0,T.generateUuid)()+Date.now(),S.commitHash=p,S.version=h,S["common.platformVersion"]=(_||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,C.PlatformToString)(C.platform),S["common.nodePlatform"]=c.platform,S["common.nodeArch"]=P,S["common.product"]=f||"desktop",w&&(S["common.msftInternal"]=w);let R=0;const g=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),C.isLinuxSnap&&(S["common.snap"]="true");const s=D(v);return s&&(S["common.platformDetail"]=s),S}function L(_){const v=c.env.USERDNSDOMAIN;if(!v)return!1;const P=v.toLowerCase();return _.some(p=>P===p)}}),define(le[18],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var c;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var T;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(le[233],ue([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=S,e.getMachineInfo=g,e.collectLaunchConfigs=s,C=De(C);const f=new Map;async function S(t,o){const i=`${t}::${o.join(":")}`,n=f.get(i);if(n)return n;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,d=new Map,b=2e4;function A(E,k,F,U){const M=k.substring(E.length+1);return c.Promises.withAsyncBody(async H=>{let B;U.readdirCount++;try{B=await p.Promises.readdir(k,{withFileTypes:!0})}catch{H();return}if(U.count>=b){U.count+=B.length,U.maxReached=!0,H();return}let Z=B.length;if(Z===0){H();return}let V=B;U.count+B.length>b&&(U.maxReached=!0,Z=b-U.count,V=B.slice(0,Z)),U.count+=B.length;for(const ie of V)if(ie.isDirectory()){if(F.includes(ie.name)||await A(E,(0,O.join)(k,ie.name),F,U),--Z===0){H();return}}else{const z=ie.name.lastIndexOf(".");if(z>=0){const q=ie.name.substring(z+1);q&&u.set(q,(u.get(q)??0)+1)}for(const q of a)q.relativePathPattern?.test(M)!==!1&&q.filePattern.test(ie.name)&&d.set(q.tag,(d.get(q.tag)??0)+1);if(--Z===0){H();return}}})}const I=c.Promises.withAsyncBody(async E=>{const k={count:0,maxReached:!1,readdirCount:0},F=new _.StopWatch(!0);await A(t,t,o,k);const U=await s(t);E({configFiles:R(d),fileTypes:R(u),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:U,totalScanTime:F.elapsed(),totalReaddirCount:k.readdirCount})});return f.set(i,I),I}function R(t){return Array.from(t.entries(),([o,i])=>({name:o,count:i})).sort((o,i)=>i.count-o.count)}function g(){const t={os:`${C.type()} ${C.arch()} ${C.release()}`,memory:`${(C.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},o=C.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function s(t){try{const o=new Map,i=(0,O.join)(t,".vscode","launch.json"),n=await p.Promises.readFile(i),a=[],u=(0,T.parse)(n.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const b=d.type;b&&(o.has(b)?o.set(b,o.get(b)+1):o.set(b,1))}return R(o)}catch{return[]}}let r=class{constructor(o,i){this.telemetryService=o,this.productService=i}formatMachineInfo(o){const i=[];return i.push(`OS Version:       ${o.os}`),i.push(`CPUs:             ${o.cpus}`),i.push(`Memory (System):  ${o.memory}`),i.push(`VM:               ${o.vmHint}`),i.join(`
`)}formatEnvironment(o){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${C.type()} ${C.arch()} ${C.release()}`);const n=C.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(C.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||i.push(`Load (avg):       ${C.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${o.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(o,i){return Promise.all([(0,h.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async n=>{let[a,u]=n,d=this.formatProcessList(o,a);return i.forEach(b=>{if((0,m.isRemoteDiagnosticError)(b))d+=`
${b.errorMessage}`,u+=`
${b.errorMessage}`;else if(d+=`

Remote: ${b.hostName}`,b.processes&&(d+=`
${this.formatProcessList(o,b.processes)}`),b.workspaceMetadata){u+=`
|  Remote: ${b.hostName}`;for(const A of Object.keys(b.workspaceMetadata)){const I=b.workspaceMetadata[A];let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),u+=`|    Folder (${A}): ${E}`,u+=this.formatWorkspaceStats(I)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(o,i){const{memory:n,vmHint:a,os:u,cpus:d}=g(),b={os:u,memory:n,cpus:d,vmHint:a,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:i};return L.isWindows||(b.load=`${C.loadavg().map(A=>Math.round(A)).join(", ")}`),L.isLinux&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(o,i){const n=[];return(0,h.listProcesses)(o.mainPID).then(async a=>(n.push(""),n.push(this.formatEnvironment(o)),n.push(""),n.push(this.formatProcessList(o,a)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(o))),i.forEach(u=>{if((0,m.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(o,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const b=u.workspaceMetadata[d];let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),n.push(`Folder (${d}): ${A}`),n.push(this.formatWorkspaceStats(b))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(o){const i=[];let a=0;const u=(I,E)=>{const k=` ${I}(${E})`;a+k.length>60?(i.push(d),d="|                 ",a=d.length):a+=k.length,d+=k};let d="|      File types:";const b=10,A=o.fileTypes.length>b?b:o.fileTypes.length;for(let I=0;I<A;I++){const E=o.fileTypes[I];u(E.name,E.count)}if(i.push(d),o.configFiles.length>=0&&(d="|      Conf files:",a=0,o.configFiles.forEach(I=>{u(I.name,I.count)}),i.push(d)),o.launchConfigFiles.length>0){let I="|      Launch Configs:";o.launchConfigFiles.forEach(E=>{const k=E.count>1?` ${E.name}(${E.count})`:` ${E.name}`;I+=k}),i.push(I)}return i.join(`
`)}expandGPUFeatures(o){const i=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${o[n]}`).join(`
                  `)}formatWorkspaceMetadata(o){const i=[],n=[];return o.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const d=v.URI.revive(u);if(d.scheme===D.Schemas.file){const b=d.fsPath;n.push(S(b,["node_modules",".git"]).then(A=>{let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,O.basename)(b)}): ${I}`),i.push(this.formatWorkspaceStats(A))}).catch(A=>{i.push(`|      Error: Unable to collect workspace stats for folder ${b} (${A.toString()})`)}))}else i.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(o,i){const n=new Map;o.windows.forEach(u=>n.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:d})=>n.set(u,d));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(o.mainPID,n,a,i,0),a.join(`
`)}formatProcessItem(o,i,n,a,u){const d=u===0;let b;d?b=a.pid===o?`${this.productService.applicationName} main`:"remote agent":i.has(a.pid)?b=i.get(a.pid):b=`${"  ".repeat(u)} ${a.name}`;const A=process.platform==="win32"?a.mem:C.totalmem()*(a.mem/100);n.push(`${a.load.toFixed(0).padStart(5," ")}	${(A/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(a.children)&&a.children.forEach(I=>this.formatProcessItem(o,i,n,I,u+1))}async getWorkspaceFileExtensions(o){const i=new Set;for(const{uri:n}of o.folders){const a=v.URI.revive(n);if(a.scheme!==D.Schemas.file)continue;const u=a.fsPath;try{(await S(u,["node_modules",".git"])).fileTypes.forEach(b=>i.add(b.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(o){for(const{uri:i}of o.folders){const n=v.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const a=n.fsPath;try{const u=await S(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:d.name,count:d.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.DiagnosticsService=r,e.DiagnosticsService=r=we([X(0,w.ITelemetryService),X(1,y.IProductService)],r)}),define(le[111],ue([0,1,8,4,10,18]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,c.createDecorator)("IExtensionSignatureVerificationService");var O;(function(v){v.Success="Success",v.RequiredArgumentMissing="RequiredArgumentMissing",v.InvalidArgument="InvalidArgument",v.PackageIsUnreadable="PackageIsUnreadable",v.UnhandledException="UnhandledException",v.SignatureManifestIsMissing="SignatureManifestIsMissing",v.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",v.SignatureIsMissing="SignatureIsMissing",v.SignatureIsUnreadable="SignatureIsUnreadable",v.CertificateIsUnreadable="CertificateIsUnreadable",v.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",v.FileAlreadyExists="FileAlreadyExists",v.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",v.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",v.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",v.SignatureIsInvalid="SignatureIsInvalid",v.SignatureManifestIsInvalid="SignatureManifestIsInvalid",v.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",v.EntryIsMissing="EntryIsMissing",v.EntryIsTampered="EntryIsTampered",v.Untrusted="Untrusted",v.CertificateRevoked="CertificateRevoked",v.SignatureIsNotValid="SignatureIsNotValid",v.UnknownError="UnknownError",v.PackageIsInvalidZip="PackageIsInvalidZip",v.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class L extends Error{constructor(P){super(P),this.code=P}}e.ExtensionSignatureVerificationError=L;let _=class{constructor(P,p){this.logService=P,this.telemetryService=p}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((P,p)=>ne(["@vscode/vsce-sign"],async h=>P(h),p))),this.moduleLoadingPromise}async verify(P,p,h,m){let l;const y=P.identifier.id;try{l=await this.vsceSign()}catch(R){return this.logService.error("Could not load vsce-sign module",(0,C.getErrorMessage)(R)),this.logService.info(`Extension signature verification is not done: ${y}`),!1}const w=new Date().getTime();let f;try{this.logService.trace(`Verifying extension signature for ${y}...`),f=await l.verify(p,h,this.logService.getLevel()===T.LogLevel.Trace)}catch(R){f={code:O.UnknownError,didExecute:!1,output:(0,C.getErrorMessage)(R)}}const S=new Date().getTime()-w;if(this.logService.info(`Extension signature verification result for ${y}: ${f.code}. Executed: ${f.didExecute}. Duration: ${S}ms.`),this.logService.trace(`Extension signature verification output for ${y}:
${f.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:y,extensionVersion:P.version,code:f.code,internalCode:f.internalCode,duration:S,didExecute:f.didExecute,clientTargetPlatform:m}),f.code===O.Success)return!0;throw new L(f.code)}};e.ExtensionSignatureVerificationService=_,e.ExtensionSignatureVerificationService=_=we([X(0,T.ILogService),X(1,D.ITelemetryService)],_)}),define(le[112],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class C{constructor(D){this.appenders=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,{eventName:L,data:_}){return this.appenders.forEach(v=>v.log(L,_)),Promise.resolve(null)}}e.TelemetryAppenderChannel=C;class c{constructor(D){this.channel=D}log(D,O){return this.channel.call("log",{eventName:D,data:O}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=c}),define(le[49],ue([0,1,30,13,106,110,18]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=P,e.isLoggingOnly=p,e.getTelemetryLevel=h,e.validateTelemetryData=m,e.cleanRemoteAuthority=y,e.isInternalTelemetry=f,e.getPiiPathsFromEnvironment=S,e.cleanData=s;class L{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=L;class _{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=_,e.NullTelemetryService=new _;class v{async publicLog(t,o,i){}async publicLogError(t,o,i){}}e.NullEndpointTelemetryService=v,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!r.enableTelemetry)}function p(r,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function h(r){const t=r.getValue(O.TELEMETRY_SETTING_ID),o=r.getValue(O.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(r.getValue(O.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return O.TelemetryLevel.NONE;switch(t??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function m(r){const t={},o={},i={};w(r,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const a=i[n];typeof a=="number"?o[n]=a:typeof a=="boolean"?o[n]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${a.length}`),t[n]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(t[n]=a)}return{properties:t,measurements:o}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(r){if(!r)return"none";const t=(0,T.getRemoteName)(r);return l.has(t)?t:"other"}function w(r,t,o=0,i){if(r)for(const n of Object.getOwnPropertyNames(r)){const a=r[n],u=i?i+n:n;Array.isArray(a)?t[u]=(0,C.safeStringify)(a):a instanceof Date?t[u]=a.toISOString():(0,c.isObject)(a)?o<2?w(a,t,o+1,u+"."):t[u]=(0,C.safeStringify)(a):t[u]=a}}function f(r,t){const o=r.msftInternalDomains||[],i=t.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||i}function S(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function R(r,t){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const i=[];for(const d of t)for(;;){const b=d.exec(r);if(!b)break;i.push([b.index,d.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(o="";;){const d=a.exec(r);if(!d)break;const b=i.some(([A,I])=>d.index<I&&A<a.lastIndex);!n.test(d[0])&&!b&&(o+=r.substring(u,d.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<r.length&&(o+=r.substr(u)),o}function g(r){if(!r)return r;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(r))return`<REDACTED: ${o.label}>`;return r}function s(r,t){return(0,C.cloneAndChange)(r,o=>{if(o instanceof L||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let i=o.replaceAll("%20"," ");i=R(i,t);for(const n of t)i=i.replace(n,"");return i=g(i),i}})}}),define(le[33],ue([0,1,27,28,36,5,9,8,37,49]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=P,e.getIdAndVersion=l,e.getExtensionId=y,e.adoptToGalleryExtensionId=w,e.getGalleryExtensionId=f,e.groupByExtension=S,e.getLocalExtensionTelemetryData=R,e.getGalleryExtensionTelemetryData=g,e.getExtensionDependencies=s,e.computeTargetPlatform=t;function P(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,C.compareIgnoreCase)(o.id,i.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,n,a)}static parse(i){const n=p.exec(i);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a=T.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==T.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=h;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(o){const i=m.exec(o);return i&&i[1]?[w(i[1]),i[2]]:[w(o),void 0]}function y(o,i){return`${o}.${i}`}function w(o){return o.toLowerCase()}function f(o,i){return w(y(o??T.UNDEFINED_PUBLISHER,i))}function S(o,i){const n=[],a=u=>{for(const d of n)if(d.some(b=>P(i(b),i(u))))return d;return null};for(const u of o){const d=a(u);d?d.push(u):n.push([u])}return n}function R(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function g(o){return{id:new v.TelemetryTrustedValue(o.identifier.id),name:new v.TelemetryTrustedValue(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function s(o,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const u=a.shift();if(u&&n.every(d=>!P(d.identifier,{id:u}))){const d=o.filter(b=>P(b.identifier,{id:u}));d.length===1&&(n.push(d[0]),a.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function r(o,i){if(!D.isLinux)return!1;let n;try{n=(await o.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,i){const n=await r(o,i),a=(0,c.getTargetPlatform)(n?"alpine":D.platform,_.arch);return i.debug("ComputeTargetPlatform:",a),a}}),define(le[234],ue([0,1,26,28,33,36]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=O;async function O(L,_,v,P,p){try{const h=await L.getExtensionsControlManifest();if(!h.deprecated)return;const m=await L.getInstalled(D.ExtensionType.User);for(const[l,y]of Object.entries(h.deprecated)){if(!y?.extension)continue;const{id:w,autoMigrate:f,preRelease:S}=y.extension;if(!f)continue;const R=m.find(s=>(0,T.areSameExtensions)(s.identifier,{id:l}));if(!R)continue;const g=(await _.getExtensions([{id:w,preRelease:S}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},C.CancellationToken.None))[0];if(!g){p.info(`Skipping migrating '${R.identifier.id}' extension because, the comaptible target '${w}' extension is not found`);continue}try{p.info(`Migrating '${R.identifier.id}' extension to '${w}' extension...`);const s=!P.getDisabledExtensions().some(t=>(0,T.areSameExtensions)(t,R.identifier));await L.uninstall(R),p.info(`Uninstalled the unsupported extension '${R.identifier.id}'`);let r=m.find(t=>(0,T.areSameExtensions)(t.identifier,{id:w}));(!r||!r.isPreReleaseVersion&&s)&&(r=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:R.isMachineScoped,operation:c.InstallOperation.Migrate}),p.info(`Installed the pre-release extension '${r.identifier.id}'`),s||(await P.disableExtension(r.identifier),p.info(`Disabled the pre-release extension '${r.identifier.id}' because the unsupported extension '${R.identifier.id}' is disabled`)),f.storage&&(v.addToMigrationList((0,T.getExtensionId)(R.manifest.publisher,R.manifest.name),(0,T.getExtensionId)(r.manifest.publisher,r.manifest.name)),p.info("Added pre-release extension to the storage migration list"))),p.info(`Migrated '${R.identifier.id}' extension to '${w}' extension.`)}catch(s){p.error(s)}}}catch(h){p.error(h)}}}),define(le[235],ue([0,1,3,2,35,33,36,7]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class _ extends c.Disposable{constructor(P,p,h,m,l,y,w){super(),this.extensionManagementService=P,this.extensionsScannerService=p,this.userDataProfilesService=h,this.extensionsProfileScannerService=m,this.uriIdentityService=l,this.fileService=y,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new c.DisposableMap),this.initialize().then(null,f=>w.error(f))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(P=>this.onDidChangeProfiles(P.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(P=>this.onAddExtensions(P))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(P=>this.onDidAddExtensions(P))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(P=>this.onRemoveExtensions(P))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(P=>this.onDidRemoveExtensions(P))),this._register(this.fileService.onDidFilesChange(P=>this.onDidFilesChange(P)))}async onDidChangeProfiles(P){try{P.length&&await Promise.all(P.map(p=>(this.extensionsProfileWatchDisposables.set(p.id,(0,c.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(p.extensionsResource)),this.fileService.watch(p.extensionsResource))),this.populateExtensionsFromProfile(p.extensionsResource))))}catch(p){throw this.logService.error(p),p}}async onAddExtensions(P){for(const p of P.extensions)this.addExtensionWithKey(this.getKey(p.identifier,p.version),P.profileLocation)}async onDidAddExtensions(P){for(const p of P.extensions){const h=this.getKey(p.identifier,p.version);P.error?this.removeExtensionWithKey(h,P.profileLocation):this.addExtensionWithKey(h,P.profileLocation)}}async onRemoveExtensions(P){for(const p of P.extensions)this.removeExtensionWithKey(this.getKey(p.identifier,p.version),P.profileLocation)}async onDidRemoveExtensions(P){const p=[],h=[];for(const m of P.extensions){const l=this.getKey(m.identifier,m.version);P.error?this.addExtensionWithKey(l,P.profileLocation):(this.removeExtensionWithKey(l,P.profileLocation),this.allExtensions.has(l)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),h.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(y=>{y?p.push(y):this.logService.info("Extension not found at the location",m.location.toString())},y=>this.logService.error(y)))))}try{await Promise.all(h),p.length&&await this.uninstallExtensionsNotInProfiles(p)}catch(m){this.logService.error(m)}}onDidFilesChange(P){for(const p of this.userDataProfilesService.profiles)P.contains(p.extensionsResource,L.FileChangeType.UPDATED,L.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(p.extensionsResource)}async onDidExtensionsProfileChange(P){const p=[],h=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(P),l=new Set,y=new Set;for(const[w,f]of this.allExtensions)f.has(P)&&y.add(w);for(const w of m){const f=this.getKey(w.identifier,w.version);l.add(f),y.has(f)||(p.push(w.identifier),this.addExtensionWithKey(f,P))}for(const w of y)if(!l.has(w)){const f=this.fromKey(w);f&&(h.push(f.identifier),this.removeExtensionWithKey(w,P))}(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p.length?{extensions:p,profileLocation:P}:void 0,removed:h.length?{extensions:h,profileLocation:P}:void 0})}async populateExtensionsFromProfile(P){const p=await this.extensionsProfileScannerService.scanProfileExtensions(P);for(const h of p)this.addExtensionWithKey(this.getKey(h.identifier,h.version),P)}async uninstallExtensionsNotInProfiles(P){P||(P=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(h=>!this.allExtensions.has(this.getKey(h.identifier,h.manifest.version)))),P.length&&await this.extensionManagementService.markAsUninstalled(...P)}addExtensionWithKey(P,p){let h=this.allExtensions.get(P);h||this.allExtensions.set(P,h=new T.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),h.add(p)}removeExtensionWithKey(P,p){const h=this.allExtensions.get(P);h&&h.delete(p),h?.size||this.allExtensions.delete(P)}getKey(P,p){return`${O.ExtensionIdentifier.toKey(P.id)}@${p}`}fromKey(P){const[p,h]=(0,D.getIdAndVersion)(P);return h?{identifier:{id:p},version:h}:void 0}}e.ExtensionsWatcher=_}),define(le[236],ue([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends m.LanguagePackBaseService{constructor(R,g,s,r){super(s),this.extensionManagementService=R,this.logService=r,this.cache=this._register(new w(g,r)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(R,g){const r=(await this.cache.getLanguagePacks())[g];if(!r){this.logService.warn(`No language pack found for ${g}`);return}const t=r.translations[R];return t?l.URI.file(t):void 0}async getInstalledLanguages(){const R=await this.cache.getLanguagePacks(),g=Object.keys(R).map(s=>{const r=R[s];return{...this.createQuickPickItem(s,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return g.push(this.createQuickPickItem("en","English")),g.sort((s,r)=>s.label.localeCompare(r.label)),g}async postInstallExtension(R){R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",R.identifier.id),await this.update())}async postUninstallExtension(R){const g=await this.cache.getLanguagePacks();Object.keys(g).some(s=>g[s]&&g[s].extensions.some(r=>(0,p.areSameExtensions)(r.extensionIdentifier,R.identifier)))&&(this.logService.info("Removing language packs from the extension",R.identifier.id),await this.update())}async update(){const[R,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(g);return!(0,c.equals)(Object.keys(R),Object.keys(s))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=we([X(0,P.IExtensionManagementService),X(1,v.INativeEnvironmentService),X(2,P.IExtensionGalleryService),X(3,h.ILogService)],y);let w=class extends D.Disposable{constructor(R,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(R.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(R){return this.withLanguagePacks(g=>{Object.keys(g).forEach(s=>delete g[s]),this.createLanguagePacksFromExtensions(g,...R)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(R,...g){for(const s of g)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(R,s);Object.keys(R).forEach(s=>this.updateHash(R[s]))}createLanguagePacksFromExtension(R,g){const s=g.identifier,r=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of r)if(g.location.scheme===O.Schemas.file&&f(t)){let o=R[t.languageId];o||(o={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},R[t.languageId]=o);const i=o.extensions.filter(n=>(0,p.areSameExtensions)(n.extensionIdentifier,s))[0];i?i.version=g.manifest.version:o.extensions.push({extensionIdentifier:s,version:g.manifest.version});for(const n of t.translations)o.translations[n.id]=(0,L.join)(g.location.fsPath,n.path)}}updateHash(R){if(R){const g=(0,C.createHash)("md5");for(const s of R.extensions)g.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);R.hash=g.digest("hex")}}withLanguagePacks(R=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return _.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch{return{}}}).then(s=>(g=R(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.languagePacks=s,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),_.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>g,s=>this.logService.error(s))})}};w=we([X(0,v.INativeEnvironmentService),X(1,h.ILogService)],w);function f(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const R of S.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(le[237],ue([0,1,149,8,30,49]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const O="https://0.0.0.0/OneCollector/1.0",L="https://0.0.0.0/ping";async function _(P,p,h){const m=await(0,C.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,C.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new m.AppInsightsCore,w=new l.PostChannel,f={instrumentationKey:P,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(h){f.extensionConfig={};const S={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[w.identifier]=S}return y.initialize(f,[]),y.addTelemetryInitializer(S=>{S.ext=S.ext??{},S.ext.web=S.ext.web??{},S.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',p&&(S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),y}class v{constructor(p,h,m,l,y){this._isInternalTelemetry=p,this._eventPrefix=h,this._defaultData=m,this._xhrOverride=y,this.endPointUrl=O,this.endPointHealthUrl=L,this._defaultData||(this._defaultData={}),typeof l=="function"?this._aiCoreOrKey=l():this._aiCoreOrKey=l,this._asyncAiCore=null}_withAIClient(p){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){p(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=_(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(h=>{p(h)},h=>{(0,c.onUnexpectedError)(h),console.error(h)})}}log(p,h){if(!this._aiCoreOrKey)return;h=(0,T.mixin)(h,this._defaultData),h=(0,D.validateTelemetryData)(h);const m=this._eventPrefix+"/"+p;try{this._withAIClient(l=>{l.pluginVersionString=h?.properties.version??"Unknown",l.track({name:m,baseData:{name:m,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(p=>{this._withAIClient(h=>{h.unload(!0,()=>{this._aiCoreOrKey=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(le[113],ue([0,1,2,178,16,10,24,49]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let _=class extends C.Disposable{constructor(P,p,h,m,l=""){super(),this.prefix=l;const y=p.getLogger(L.telemetryLogId);if(y)this.logger=this._register(y);else{const f=(0,L.isLoggingOnly)(m,h)?" (Not Sent)":"",S=()=>(0,L.supportsTelemetry)(m,h)&&P.getLevel()===D.LogLevel.Trace;this.logger=this._register(p.createLogger(L.telemetryLogId,{name:(0,c.localize)(0,null,f),hidden:!S()})),this._register(P.onDidChangeLogLevel(()=>p.setVisibility(L.telemetryLogId,S()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,p){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,L.validateTelemetryData)(p))}};e.TelemetryLogAppender=_,e.TelemetryLogAppender=_=we([X(0,D.ILogService),X(1,D.ILoggerService),X(2,T.IEnvironmentService),X(3,O.IProductService)],_)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[114],ue([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,v=it(v);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,S,R){this._configurationService=S,this._productService=R,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=f.piiPaths||[],this._telemetryLevel=h.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(g),"gi")),g.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(g.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(g=>{(g.affectsConfiguration(h.TELEMETRY_SETTING_ID)||g.affectsConfiguration(h.TELEMETRY_OLD_SETTING_ID)||g.affectsConfiguration(h.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(f,S){this._experimentProperties[f]=S}_updateTelemetryLevel(){let f=(0,m.getTelemetryLevel)(this._configurationService);const S=this._productService.enabledTelemetryLevels;if(S){this._sendErrorTelemetry=this.sendErrorTelemetry?S.error:!1;const R=S.usage?h.TelemetryLevel.USAGE:S.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,R)}this._telemetryLevel=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(f,S,R){this._telemetryLevel<S||(R=(0,c.mixin)(R,this._experimentProperties),R=(0,m.cleanData)(R,this._cleanupPatterns),R=(0,c.mixin)(R,this._commonProperties),this._appenders.forEach(g=>g.log(f,R)))}publicLog(f,S){this._log(f,h.TelemetryLevel.USAGE,S)}publicLog2(f,S){this.publicLog(f,S)}publicLogError(f,S){this._sendErrorTelemetry&&this._log(f,h.TelemetryLevel.ERROR,S)}publicLogError2(f,S){this.publicLogError(f,S)}};e.TelemetryService=l,e.TelemetryService=l=we([X(1,L.IConfigurationService),X(2,P.IProductService)],l);function y(){const w=(0,O.localize)(0,null,v.default.nameLong),f=v.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=T.isWeb?"":(0,O.localize)(3,null),R=(0,O.localize)(4,null),g=(0,O.localize)(5,null),s=(0,O.localize)(6,null),r=(0,O.localize)(7,null),t=`
|       | ${R} | ${g} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,O.localize)(8,null);return`
${w} ${f} ${S}

&nbsp;

${r}
${t}

&nbsp;

${o}
`}p.Registry.as(_.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:h.TelemetryConfiguration.OFF,restricted:!0,scope:_.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(_.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,O.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,O.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:_.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[238],ue([0,1,15,26,281,237]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,T=De(T);async function O(P,p){const h=await p.request(P,c.CancellationToken.None),m=(await(0,C.streamToBuffer)(h.stream)).toString(),l=h.res.statusCode??200;return{headers:h.res.headers,statusCode:l,responseData:m}}async function L(P){const p={method:P.type,headers:P.headers};return new Promise((m,l)=>{const y=T.request(P.url??"",p,w=>{w.on("data",function(f){m({headers:w.headers,statusCode:w.statusCode??200,responseData:f.toString()})}),w.on("error",function(f){l(f)})});y.write(P.data,w=>{w&&l(w)}),y.end()})}async function _(P,p,h){const m=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),l={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:m};try{const y=P?await O(l,P):await L(l);h(y.statusCode,y.headers,y.responseData)}catch{h(0,{})}}class v extends D.AbstractOneDataSystemAppender{constructor(p,h,m,l,y){const w={sendPOST:(f,S)=>{_(p,f,S)}};super(h,m,l,y,w)}}e.OneDataSystemAppender=v}),define(le[239],ue([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(l,y,w,f,S,R){this.configurationService=l,this.telemetryService=y,this.logService=w,this.loggerService=f,this.environmentService=S,this.productService=R,this.customTelemetryServices=new Map}getCustomTelemetryService(l){if(!this.customTelemetryServices.has(l.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.telemetryService.machineId,y["common.vscodesessionid"]=this.telemetryService.sessionId;const w=[l.id,JSON.stringify(y),l.aiKey],S=new c.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new v.TelemetryAppenderClient(S),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${l.id}] `)];this.customTelemetryServices.set(l.id,new p.TelemetryService({appenders:R,sendErrorTelemetry:l.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(l.id)}publicLog(l,y,w){this.getCustomTelemetryService(l).publicLog(y,w)}publicLogError(l,y,w){this.getCustomTelemetryService(l).publicLogError(y,w)}};e.CustomEndpointTelemetryService=h,e.CustomEndpointTelemetryService=h=we([X(0,T.IConfigurationService),X(1,_.ITelemetryService),X(2,O.ILogService),X(3,O.ILoggerService),X(4,D.IEnvironmentService),X(5,L.IProductService)],h)}),define(le[81],ue([0,1,3,2,5,9,22,4,10]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=p,e.extractLocalHostUriMetaDataForPortMapping=m,e.extractQueryLocalHostUriMetaDataForPortMapping=l,e.isLocalhost=y,e.isAllInterfaces=w,e.isPortPrivileged=f,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var v;(function(g){g.Http="http",g.Https="https"})(v||(e.TunnelProtocol=v={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P||(e.TunnelPrivacyId=P={}));function p(g){return!!g.forwardPort}var h;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function m(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(s)return{address:s[1],port:+s[2]}}function l(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const s=g.query.split("&");for(const r of s){const t=r.split("=")[1];if(/^https?:/.exec(t)){const o=m(D.URI.parse(t));if(o)return o}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}function f(g,s,r,t){if(r===T.OperatingSystem.Windows)return!1;if(r===T.OperatingSystem.Macintosh&&w(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return g<1024}class S{constructor(s,r,t){this.remoteAddress=s,this.localAddress=r,this._dispose=t,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=S;let R=class extends c.Disposable{constructor(s,r){super(),this.logService=s,this.configurationService=r,this._onTunnelOpened=new C.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new C.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new C.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions,this._canChangeProtocol=s.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],r=Array.from(this._tunnels.values());for(const t of r){const o=Array.from(t.values());for(const i of o){const n=await i.value;n&&typeof n!="string"&&s.push(n)}}return s}async dispose(){super.dispose();for(const s of this._tunnels.values()){for(const{value:r}of s.values())await r.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,r,t,o,i){this.addTunnelToMap(s,r,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:r,localAddress:t,privacy:o,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,r){(w(s)||y(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(s,r);if(t)return++t.refcount,t.value}openTunnel(s,r,t,o,i,n=!1,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${t} on local port ${i}.`);const d=this._tunnelProvider??s;if(!d)return;if(r||(r="localhost"),o||(o=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.retainOrCreateTunnel(d,r,t,o,i,n,a,u);return b?b.then(A=>{if(A){if(typeof A=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(r,t),A}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(r,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.makeTunnel(A);return(A.tunnelRemoteHost!==r||A.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&A.privacy!==a&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(I),I}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const r=this._tunnels.get(s.tunnelRemoteHost);if(r){const t=r.get(s.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async tryDisposeTunnel(s,r,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${r}.`);const o=t.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this._onTunnelClosed.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(r),o}}async closeTunnel(s,r){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${r} `);const t=this._tunnels.get(s);if(t&&t.has(r)){const o=t.get(r);o.refcount=0,await this.tryDisposeTunnel(s,r,o)}}addTunnelToMap(s,r,t){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(r,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(s,r){const t=this._tunnels.get(s);if(t){const o=t.get(r),i=o?await o.value:void 0;(!i||typeof i=="string")&&t.delete(r),t.size===0&&this._tunnels.delete(s)}}getTunnelFromMap(s,r){const t=[s];y(s)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):w(s)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const o=t.map(i=>this._tunnels.get(i));for(const i of o){const n=i?.get(r);if(n)return n}}canTunnel(s){return!!m(s)}createWithProvider(s,r,t,o,i,n,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${t} on local port ${o}.`);const u=t;this._factoryInProgress.add(u);const d=o===void 0?t:o,b={elevationRequired:i?this.isPortPrivileged(d):!1},A={remoteAddress:{host:r,port:t},localAddressPort:o,privacy:n,public:n?n!==P.Private:void 0,protocol:a},I=s.forwardPort(A,b);return I?(this.addTunnelToMap(r,t,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),I}};e.AbstractTunnelService=R,e.AbstractTunnelService=R=we([X(0,_.ILogService),X(1,O.IConfigurationService)],R)}),define(le[240],ue([0,1,10,81,2,8,6]),function(ne,e,C,c,T,D,O){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class _ extends T.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new O.DeferredPromise),this._addressPromise.p)}setAddress(p){this._address=p,this._addressPromise&&(this._addressPromise.complete(p),this._addressPromise=null)}setTunnel(p){this._register(p)}}let v=class extends T.Disposable{static{L=this}static{this._lastId=0}constructor(p,h){super(),this._tunnelService=p,this._logService=h,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++L._lastId)}}async startTunnel(p,h,m,l,y,w,f){const S=new _,R=await Promise.resolve(this._tunnelService.openTunnel(p,S,m,l,y,w,f));if(!R||typeof R=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${l} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(h))throw this._disposedTunnels.delete(h),S.dispose(),await R.dispose(),(0,D.canceled)();return S.setTunnel(R),this._tunnels.set(h,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${R.localAddress} (local) to ${m}:${l} (remote).`),{tunnelLocalPort:R.tunnelLocalPort,localAddress:R.localAddress}}async setAddress(p,h){const m=this._tunnels.get(p);m&&m.setAddress(h)}async destroyTunnel(p){const h=this._tunnels.get(p);if(h){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this._tunnels.delete(p),await h.dispose();return}this._disposedTunnels.add(p)}};e.SharedProcessTunnelService=v,e.SharedProcessTunnelService=v=L=we([X(0,c.ISharedTunnelsService),X(1,C.ILogService)],v)}),define(le[29],ue([0,1,4]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(le[241],ue([0,1,29,197,7,21,133,3,2]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{static{this._clock=0}constructor(h){this.uri=h,this.time=v._clock++}touch(){return this.time=v._clock++,this}}let P=class{constructor(h){this._fileService=h,this._dispooables=new _.DisposableStore,this._limit=2**16;const m=new Map,l=y=>{let w=m.get(y.scheme);return w===void 0&&(w=h.hasProvider(y)&&!this._fileService.hasCapability(y,T.FileSystemProviderCapabilities.PathCaseSensitive),m.set(y.scheme,w)),w};this._dispooables.add(L.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(y=>{m.delete(y.scheme)})),this.extUri=new D.ExtUri(l),this._canonicalUris=new O.SkipList((y,w)=>this.extUri.compare(y,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,D.normalizePath)(h));const m=this._canonicalUris.get(h);return m?m.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new v(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((l,y)=>l[1].time<y[1].time?1:l[1].time>y[1].time?-1:0);v._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let l=0;l<m;l++)this._canonicalUris.set(h[l][0],h[l][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=we([X(0,T.IFileService)],P),(0,c.registerSingleton)(C.IUriIdentityService,P,c.InstantiationType.Delayed)}),define(le[242],ue([0,1,3,2,7,52,35]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class L extends c.Disposable{constructor(v,P,p,h,m,l){super(),this.fileSystemScheme=v,this.fileSystemProvider=P,this.userDataScheme=p,this.userDataProfilesService=h,this.uriIdentityService=m,this.logService=l,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=D.TernarySearchTree.forUris(()=>!(this.capabilities&T.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new O.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(h.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const v of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(v.settingsResource),this.atomicReadWriteResources.add(v.keybindingsResource),this.atomicReadWriteResources.add(v.tasksResource),this.atomicReadWriteResources.add(v.extensionsResource)}open(v,P){return this.fileSystemProvider.open(this.toFileSystemResource(v),P)}close(v){return this.fileSystemProvider.close(v)}read(v,P,p,h,m){return this.fileSystemProvider.read(v,P,p,h,m)}write(v,P,p,h,m){return this.fileSystemProvider.write(v,P,p,h,m)}watch(v,P){this.watchResources.set(v,v);const p=this.fileSystemProvider.watch(this.toFileSystemResource(v),P);return(0,c.toDisposable)(()=>{this.watchResources.delete(v),p.dispose()})}stat(v){return this.fileSystemProvider.stat(this.toFileSystemResource(v))}mkdir(v){return this.fileSystemProvider.mkdir(this.toFileSystemResource(v))}rename(v,P,p){return this.fileSystemProvider.rename(this.toFileSystemResource(v),this.toFileSystemResource(P),p)}readFile(v,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(v),P)}readFileStream(v,P,p){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(v),P,p)}readdir(v){return this.fileSystemProvider.readdir(this.toFileSystemResource(v))}enforceAtomicReadFile(v){return this.atomicReadWriteResources.has(v)}writeFile(v,P,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(v),P,p)}enforceAtomicWriteFile(v){return this.atomicReadWriteResources.has(v)?{postfix:".vsctmp"}:!1}delete(v,P){return this.fileSystemProvider.delete(this.toFileSystemResource(v),P)}copy(v,P,p){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(v),this.toFileSystemResource(P),p);throw new Error("copy not supported")}cloneFile(v,P){if((0,T.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(v),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(v){const P=[];for(const p of v){if(p.resource.scheme!==this.fileSystemScheme)continue;const h=this.toUserDataResource(p.resource);this.watchResources.findSubstr(h)&&P.push({resource:h,type:p.type,cId:p.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(v){return v.with({scheme:this.fileSystemScheme})}toUserDataResource(v){return v.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=L}),define(le[82],ue([0,1,65]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.getLineStartOffset=T,e.getLineEndOffset=D;function c(O,L,_,v){const P=(0,C.setProperty)(O,L,_,v)[0];return P&&(O=O.substring(0,P.offset)+P.content+O.substring(P.offset+P.length)),O}function T(O,L,_){let v=_;for(;v>=0;){if(O.charAt(v)===L.charAt(L.length-1)&&L.length===1)return v+1;if(v--,L.length===2&&v>=0&&O.charAt(v)===L.charAt(0))return v+2}return 0}function D(O,L,_){let v=_;for(;v>=0;)if(O.charAt(v)===L.charAt(L.length-1)&&L.length===1||(v++,L.length===2&&v>=0&&O.charAt(v)===L.charAt(1)))return v;return O.length-1}}),define(le[243],ue([0,1,30,61,13]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=D,c=De(c);function D(m,l,y,w,f,S){const R=[],g=[],s=[];if(!l){const M=m.filter(({identifier:H})=>f.every(B=>B.toLowerCase()!==H.id.toLowerCase()));return{local:{added:R,removed:g,updated:s},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}m=m.map(p),l=l.map(p),y=y?y.map(p):null;const r=new Map,t=M=>{M.uuid&&r.set(M.id.toLowerCase(),M.uuid)};m.forEach(({identifier:M})=>t(M)),l.forEach(({identifier:M})=>t(M)),y?.forEach(({identifier:M})=>t(M)),w?.forEach(({identifier:M})=>t(M)),S?.forEach(M=>t(M));const o=M=>{const H=M.identifier.uuid||r.get(M.identifier.id.toLowerCase());return H?`uuid:${H}`:`id:${M.identifier.id.toLowerCase()}`},i=(M,H)=>(M.set(o(H),H),M),n=m.reduce(i,new Map),a=l.reduce(i,new Map),u=l.reduce((M,H)=>i(M,(0,C.deepClone)(H)),new Map),d=y?y.reduce(i,new Map):null,b=w.reduce(i,new Map),A=f.reduce((M,H)=>{const B=r.get(H.toLowerCase());return M.add(B?`uuid:${B}`:`id:${H.toLowerCase()}`)},new Set),I=S?S.reduce((M,{id:H,uuid:B})=>(B=B??r.get(H.toLowerCase()),M.add(B?`uuid:${B}`:`id:${H.toLowerCase()}`)),new Set):null,E=O(n,a,A,!1);if(E.added.size>0||E.removed.size>0||E.updated.size>0){const M=O(d,n,A,!1),H=O(d,a,A,!0),B=(Z,V,ie,z)=>{let q,te,se;return V.installed?(q=z.pinned,se=z.preRelease,q&&(te=z.version)):(q=ie.pinned,se=ie.preRelease,q&&(te=ie.version)),q===void 0&&(q=V.pinned,q&&(te=V.version)),se===void 0&&(se=V.preRelease),{...z,installed:V.installed||ie.installed,pinned:q,preRelease:se,version:te??(ie.version&&(!V.installed||c.gt(ie.version,V.version))?ie.version:V.version),state:_(V,ie,d?.get(Z))}};for(const Z of H.removed.values()){const V=n.get(Z);if(!V)continue;const ie=(0,T.assertIsDefined)(d?.get(Z)),z=I&&!I.has(Z)&&ie.installed;V.installed&&z?g.push(V.identifier):u.set(Z,V)}for(const Z of H.added.values()){const V=(0,T.assertIsDefined)(a.get(Z)),ie=n.get(Z);if(ie){if(E.updated.has(Z)){const z=B(Z,ie,V,V);L(ie,V,!1,!1)||s.push(h(z,Z)),u.set(Z,z)}}else V.installed&&R.push(h(V,Z))}for(const Z of H.updated.values()){const V=(0,T.assertIsDefined)(a.get(Z)),ie=(0,T.assertIsDefined)(d?.get(Z)),z=n.get(Z);if(z)if(I&&!I.has(Z)&&ie.installed&&z.installed&&!V.installed)g.push(z.identifier);else{const te=B(Z,z,V,V);s.push(h(te,Z)),u.set(Z,te)}else V.installed&&R.push(h(V,Z))}for(const Z of M.added.values())H.added.has(Z)||u.set(Z,(0,T.assertIsDefined)(n.get(Z)));for(const Z of M.updated.values()){if(H.removed.has(Z)||H.updated.has(Z))continue;const V=(0,T.assertIsDefined)(n.get(Z)),ie=(0,T.assertIsDefined)(a.get(Z));u.set(Z,B(Z,V,ie,V))}for(const Z of M.removed.values())H.updated.has(Z)||H.removed.has(Z)||b.has(Z)||(0,T.assertIsDefined)(a.get(Z)).installed&&I&&(I.has(Z)||!(0,T.assertIsDefined)(d?.get(Z)).installed||u.delete(Z))}const k=[],F=O(a,u,new Set,!0),U=F.added.size>0||F.updated.size>0||F.removed.size>0;return U&&u.forEach((M,H)=>k.push(h(M,H))),{local:{added:R,removed:g,updated:s},remote:U?{added:[...F.added].map(M=>u.get(M)),updated:[...F.updated].map(M=>u.get(M)),removed:[...F.removed].map(M=>a.get(M)),all:k}:null}}function O(m,l,y,w){const f=m?[...m.keys()].filter(r=>!y.has(r)):[],S=[...l.keys()].filter(r=>!y.has(r)),R=S.filter(r=>!f.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),g=f.filter(r=>!S.includes(r)).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of f){if(g.has(r))continue;const t=m.get(r),o=l.get(r);(!o||!L(t,o,w,!0))&&s.add(r)}return{added:R,removed:g,updated:s}}function L(m,l,y,w){return!(m.disabled!==l.disabled||!!m.isApplicationScoped!=!!l.isApplicationScoped||w&&m.installed!==l.installed||m.installed&&l.installed&&(m.preRelease!==l.preRelease||m.pinned!==l.pinned||l.pinned&&m.version!==l.version)||!P(m.state,l.state)||y&&m.version!==l.version)}function _(m,l,y){const w=m.state,f=l.state,S=y?.state;if(!l.version||w&&c.gt(m.version,l.version))return w;if(f&&c.gt(l.version,m.version)||!w)return f;if(!f)return w;const R=(0,C.deepClone)(w),g=S?v(S,f):{added:Object.keys(f).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set},s=S?v(S,w):{added:Object.keys(w).reduce((r,t)=>(r.add(t),r),new Set),removed:new Set,updated:new Set};for(const r of[...g.added.values(),...g.updated.values()])R[r]=f[r];for(const r of g.removed.values())s.updated.has(r)||delete R[r];return R}function v(m,l){const y=Object.keys(m),w=Object.keys(l),f=w.filter(g=>!y.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),S=y.filter(g=>!w.includes(g)).reduce((g,s)=>(g.add(s),g),new Set),R=new Set;for(const g of y){if(S.has(g))continue;const s=m[g],r=l[g];(0,C.equals)(s,r)||R.add(g)}return{added:f,removed:S,updated:R}}function P(m={},l={}){const{added:y,removed:w,updated:f}=v(m,l);return y.size===0&&w.size===0&&f.size===0}function p(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function h(m,l){const y={...m,identifier:{id:m.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!m.preRelease,pinned:!!m.pinned};return m.disabled||delete y.disabled,m.installed||delete y.installed,m.state||delete y.state,m.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[115],ue([0,1,19,22,4]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let D=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,_){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return v=v.filter(P=>P!==L&&P!==`-${L}`),_&&v.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(L,_){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return v=v.filter(P=>P!==L&&P!==`-${L}`),_&&v.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(L){const _=L.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),P=[],p=[];if(Array.isArray(v))for(const h of v)h.startsWith("-")?p.push(h.substring(1)):P.push(h);return(0,C.distinct)([..._,...P].filter(h=>!p.includes(h)))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(_=>_.toLowerCase())}};e.IgnoredExtensionsManagementService=D,e.IgnoredExtensionsManagementService=D=we([X(0,c.IConfigurationService)],D)}),define(le[244],ue([0,1,19,34,30,97,82]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=_,T=De(T),O=De(O);function L(g){return(0,c.parse)(g)||[]}async function _(g,s,r,t,o){const i=L(g),n=L(s),a=r?L(r):null,u=[...i,...n,...a||[]].map(B=>B.key),d=await o.resolveUserBindings(u),b=P(i,n,a,d);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const A=h(i),I=h(n),E=a?h(a):null,k=l(A,I,d),F=E?l(E,A,d):{added:[...A.keys()].reduce((B,Z)=>(B.add(Z),B),new Set),removed:new Set,updated:new Set},U=E?l(E,I,d):{added:[...I.keys()].reduce((B,Z)=>(B.add(Z),B),new Set),removed:new Set,updated:new Set},M=v(k,F,U);let H=g;for(const B of M.removed.values())M.conflicts.has(B)||(H=S(H,B,t));for(const B of M.added.values()){if(M.conflicts.has(B))continue;const Z=I.get(B);if(Z.some(V=>V.command!==`-${B}`&&b.conflicts.has(d[V.key]))){M.conflicts.add(B);continue}H=f(H,Z,t)}for(const B of M.updated.values()){if(M.conflicts.has(B))continue;const Z=I.get(B);if(Z.some(V=>V.command!==`-${B}`&&b.conflicts.has(d[V.key]))){M.conflicts.add(B);continue}H=R(H,B,Z,t)}return{mergeContent:H,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function v(g,s,r){const t=new Set,o=new Set,i=new Set,n=new Set;for(const a of s.removed.values())r.updated.has(a)&&n.add(a);for(const a of r.removed.values())n.has(a)||(s.updated.has(a)?n.add(a):o.add(a));for(const a of s.added.values())n.has(a)||r.added.has(a)&&g.updated.has(a)&&n.add(a);for(const a of r.added.values())n.has(a)||(s.added.has(a)?g.updated.has(a)&&n.add(a):t.add(a));for(const a of s.updated.values())n.has(a)||r.updated.has(a)&&g.updated.has(a)&&n.add(a);for(const a of r.updated.values())n.has(a)||(s.updated.has(a)?g.updated.has(a)&&n.add(a):i.add(a));return{added:t,removed:o,updated:i,conflicts:n}}function P(g,s,r,t){const o=new Set,i=p(g,t),n=p(s,t),a=r?p(r,t):null,u=m(i,n);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:o,removed:o,updated:o,conflicts:o};const d=a?m(a,i):{added:[...i.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:o,removed:o,updated:o,conflicts:o};const b=a?m(a,n):{added:[...n.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:o,removed:o,updated:o,conflicts:o};const{added:A,removed:I,updated:E,conflicts:k}=v(u,d,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:I,updated:E,conflicts:k}}function p(g,s){const r=new Map;for(const t of g){const o=s[t.key];let i=r.get(o);i||(i=[],r.set(o,i)),i.push(t)}return r}function h(g){const s=new Map;for(const r of g){const t=r.command[0]==="-"?r.command.substring(1):r.command;let o=s.get(t);o||(o=[],s.set(t,o)),o.push(r)}return s}function m(g,s){const r=[...g.keys()],t=[...s.keys()],o=t.filter(a=>!r.includes(a)).reduce((a,u)=>(a.add(u),a),new Set),i=r.filter(a=>!t.includes(a)).reduce((a,u)=>(a.add(u),a),new Set),n=new Set;for(const a of r){if(i.has(a))continue;const u=g.get(a).map(b=>({...b,key:a})),d=s.get(a).map(b=>({...b,key:a}));(0,C.equals)(u,d,(b,A)=>w(b,A))||n.add(a)}return{added:o,removed:i,updated:n}}function l(g,s,r){const t=[...g.keys()],o=[...s.keys()],i=o.filter(u=>!t.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),n=t.filter(u=>!o.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),a=new Set;for(const u of t){if(n.has(u))continue;const d=g.get(u).map(A=>({...A,key:r[A.key]})),b=s.get(u).map(A=>({...A,key:r[A.key]}));y(d,b)||a.add(u)}return{added:i,removed:n,updated:a}}function y(g,s){return!(!(0,C.equals)(g.filter(({command:r})=>r[0]!=="-"),s.filter(({command:r})=>r[0]!=="-"),(r,t)=>w(r,t))||!(0,C.equals)(g.filter(({command:r})=>r[0]==="-"),s.filter(({command:r})=>r[0]==="-"),(r,t)=>w(r,t)))}function w(g,s){if(g.command!==s.command||g.key!==s.key)return!1;const r=D.ContextKeyExpr.deserialize(g.when),t=D.ContextKeyExpr.deserialize(s.when);return!(r&&!t||!r&&t||r&&t&&!r.equals(t)||!T.equals(g.args,s.args))}function f(g,s,r){for(const t of s)g=O.edit(g,[-1],t,r);return g}function S(g,s,r){const t=L(g);for(let o=t.length-1;o>=0;o--)(t[o].command===s||t[o].command===`-${s}`)&&(g=O.edit(g,[o],void 0,r));return g}function R(g,s,r,t){const o=L(g),i=o.findIndex(n=>n.command===s||n.command===`-${s}`);for(let n=o.length-1;n>=0;n--)(o[n].command===s||o[n].command===`-${s}`)&&(g=O.edit(g,[n],void 0,t));for(let n=r.length-1;n>=0;n--)g=O.edit(g,[i],r[n],t);return g}}),define(le[245],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=C,e.areSame=T;function C(D,O,L){const _={},v={},P=new Set;if(!O)return{local:{added:_,updated:v,removed:[...P.values()]},remote:{added:D,updated:{},removed:[]},conflicts:[]};const p=c(D,O);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:_,updated:v,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=c(L,D),m=c(L,O),l={},y={},w=new Set,f=new Set;for(const S of h.removed.values())m.updated.has(S)?_[S]=O[S]:w.add(S);for(const S of m.removed.values())f.has(S)||(h.updated.has(S)?f.add(S):P.add(S));for(const S of h.updated.values())f.has(S)||(m.updated.has(S)?p.updated.has(S)&&f.add(S):y[S]=D[S]);for(const S of m.updated.values())f.has(S)||(h.updated.has(S)?p.updated.has(S)&&f.add(S):D[S]!==void 0&&(v[S]=O[S]));for(const S of h.added.values())f.has(S)||(m.added.has(S)?p.updated.has(S)&&f.add(S):l[S]=D[S]);for(const S of m.added.values())f.has(S)||(h.added.has(S)?p.updated.has(S)&&f.add(S):_[S]=O[S]);return{local:{added:_,removed:[...P.values()],updated:v},remote:{added:l,removed:[...w.values()],updated:y},conflicts:[...f.values()]}}function c(D,O){const L=D?Object.keys(D):[],_=O?Object.keys(O):[],v=_.filter(h=>!L.includes(h)).reduce((h,m)=>(h.add(m),h),new Set),P=L.filter(h=>!_.includes(h)).reduce((h,m)=>(h.add(m),h),new Set),p=new Set;for(const h of L){if(P.has(h))continue;const m=D[h],l=O[h];m!==l&&p.add(h)}return{added:v,removed:P,updated:p}}function T(D,O){const{added:L,removed:_,updated:v}=c(D,O);return L.size===0&&_.size===0&&v.size===0}}),define(le[246],ue([0,1,30]),function(ne,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=c;function c(D,O,L,_){const v={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!O){const h=D.filter(({id:m})=>!_.includes(m));return h.length?P.added=h:P=null,{local:v,remote:P}}const p=T(D,O,_);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const h=T(L,D,_),m=T(L,O,_);for(const l of m.removed){const y=D.find(w=>w.id===l);y&&v.removed.push(y)}for(const l of m.added){const y=O.find(w=>w.id===l);h.added.includes(l)?p.updated.includes(l)&&v.updated.push(y):v.added.push(y)}for(const l of m.updated)v.updated.push(O.find(y=>y.id===l));for(const l of h.added)m.added.includes(l)||P.added.push(D.find(y=>y.id===l));for(const l of h.updated)m.removed.includes(l)||m.updated.includes(l)||P.updated.push(D.find(y=>y.id===l));for(const l of h.removed){const y=O.find(w=>w.id===l);y&&P.removed.push(y)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:v,remote:P}}function T(D,O,L){D=D?D.filter(({id:m})=>!L.includes(m)):[],O=O.filter(({id:m})=>!L.includes(m));const _=D.map(({id:m})=>m),v=O.map(({id:m})=>m),P=v.filter(m=>!_.includes(m)),p=_.filter(m=>!v.includes(m)),h=[];for(const{id:m,name:l,shortName:y,icon:w,useDefaultFlags:f}of D){if(p.includes(m))continue;const S=O.find(R=>R.id===m);(!S||S.name!==l||S.shortName!==y||S.icon!==w||!(0,C.equals)(S.useDefaultFlags,f))&&h.push(m)}return{added:P,removed:p,updated:h}}}),define(le[25],ue([0,1,19,13,185,48,28,4,104,44]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=P,e.getDefaultIgnoredSettings=p,e.registerConfiguration=h,e.isAuthenticationProvider=m,e.getPathSegments=y,e.getLastSyncResourceUri=w,e.createSyncHeaders=f,e.getEnablementKey=i;function P(){const n=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n).filter(a=>!!n[a].disallowSyncIgnore)}function p(){const n=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(n).filter(b=>!!n[b].ignoreSync),u=Object.keys(n).filter(b=>n[b].scope===D.ConfigurationScope.MACHINE||n[b].scope===D.ConfigurationScope.MACHINE_OVERRIDABLE),d=P();return(0,C.distinct)([...a,...u,...d])}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function h(){const n="vscode://schemas/ignoredSettings",a=v.Registry.as(D.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:D.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:D.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:D.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=v.Registry.as(_.Extensions.JSONContribution),d=()=>{const b=P(),A=p(),I=Object.keys(D.allSettings.properties).filter(F=>!A.includes(F)),E=A.filter(F=>!b.includes(F)),k={items:{type:"string",enum:[...I,...E.map(F=>`-${F}`)]}};u.registerSchema(n,k)};return a.onDidUpdateConfiguration(()=>d())}function m(n){return n&&(0,c.isObject)(n)&&(0,c.isString)(n.id)&&Array.isArray(n.scopes)}var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(l||(e.SyncResource=l={})),e.ALL_SYNC_RESOURCES=[l.Settings,l.Keybindings,l.Snippets,l.Tasks,l.Extensions,l.GlobalState,l.Profiles];function y(n,...a){return n?[n,...a]:a}function w(n,a,u,d){return d.joinPath(u.userDataSyncHome,...y(n,a,`lastSync${a}.json`))}e.IUserDataSyncStoreManagementService=(0,L.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,L.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,L.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function f(n){const a={};return a[e.HEADER_EXECUTION_ID]=n,a}var S;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(S||(e.UserDataSyncErrorCode=S={}));class R extends Error{constructor(a,u,d,b){super(a),this.code=u,this.resource=d,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=R;class g extends R{constructor(a,u,d,b,A){super(a,d,void 0,A),this.url=u,this.serverCode=b}}e.UserDataSyncStoreError=g;class s extends R{constructor(a,u){super(a,u)}}e.UserDataAutoSyncError=s,function(n){function a(u){if(u instanceof n)return u;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(d&&d[1]){const b=d[2]==="unknown"?void 0:d[2],A=d[3]==="unknown"?void 0:d[3];return new n(u.message,d[1],b,A)}return new n(u.message,S.Unknown)}n.toUserDataSyncError=a}(R||(e.UserDataSyncError=R={}));var r;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(r||(e.SyncStatus=r={}));var t;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(t||(e.Change=t={}));var o;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(o||(e.MergeState=o={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.IUserDataSyncEnablementService=(0,L.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,L.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,L.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,L.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,L.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,L.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[247],ue([0,1,30,25]),function(ne,e,C,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=T,C=De(C);function T(O,L,_,v,P){if(!L)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const p=D(O,L);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const h=_?D(_,L):{added:Object.keys(L).reduce((S,R)=>(S.add(R),S),new Set),removed:new Set,updated:new Set},m=_?D(_,O):{added:Object.keys(O).reduce((S,R)=>(S.add(R),S),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},y=C.deepClone(L),w=!_;for(const S of m.added.values())S!==c.SYNC_SERVICE_URL_TYPE&&w&&h.added.has(S)||(y[S]=O[S]);for(const S of m.updated.values())y[S]=O[S];for(const S of m.removed.values())v.unregistered.includes(S)||delete y[S];for(const S of h.added.values()){const R=L[S];if(v.machine.includes(S)){P.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(_&&m.added.has(S))continue;const g=O[S];g&&g.value===R.value||S===c.SYNC_SERVICE_URL_TYPE&&w&&m.added.has(S)||(g?l.updated[S]=R:l.added[S]=R)}for(const S of h.updated.values()){const R=L[S];if(v.machine.includes(S)){P.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(S)||m.removed.has(S))continue;const g=O[S];g&&g.value===R.value||(l.updated[S]=R)}for(const S of h.removed.values()){if(v.machine.includes(S)){P.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}m.updated.has(S)||m.removed.has(S)||l.removed.push(S)}const f=D(L,y);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:y}}}function D(O,L){const _=Object.keys(O),v=Object.keys(L),P=v.filter(m=>!_.includes(m)).reduce((m,l)=>(m.add(l),m),new Set),p=_.filter(m=>!v.includes(m)).reduce((m,l)=>(m.add(l),m),new Set),h=new Set;for(const m of _){if(p.has(m))continue;const l=O[m],y=L[m];C.equals(l,y)||h.add(m)}return{added:P,removed:p,updated:h}}}),define(le[248],ue([0,1,19,34,65,45,30,82,25]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=v,e.removeComments=h,e.updateIgnoredSettings=m,e.merge=l,e.isEmpty=w,e.addSetting=S,O=De(O),L=De(L);function v(u,d,b){let A=[];b?A=p(b):A=P(d);const I=[],E=[...(0,_.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const k of A)k.startsWith("-")?E.push(k.substring(1)):I.push(k);return(0,C.distinct)([...u,...I].filter(k=>!E.includes(k)))}function P(u){let d=u.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=u.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:u.getValue("settingsSync.ignoredSettings")||[]}function p(u){const d=(0,c.parse)(u);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function h(u,d){const b=(0,c.parse)(u)||{};let A="{}";for(const I of Object.keys(b)){const E=(0,T.setProperty)(A,[I],b[I],d);A=(0,T.applyEdits)(A,E)}return A}function m(u,d,b,A){if(b.length){const I=a(d),E=(0,c.parse)(d)||{},k=(0,c.parse)(u);if(!k)return u;const F=[];for(const U of b){const M=E[U],H=k[U];M===void 0?u=L.edit(u,[U],void 0,A):H!==void 0?u=L.edit(u,[U],M,A):F.push(r(U,I))}F.sort((U,M)=>U.startOffset-M.startOffset),F.forEach(U=>u=S(U.setting.key,d,u,A))}return u}function l(u,d,b,A,I,E){const k=m(u,d,A,E),F=b!==k,U=b!==d;if(!F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:k,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:m(d,u,A,E),remoteContent:null,hasConflicts:!1};if(b===null&&w(u)){const N=y(u,d,A)?null:m(d,u,A,E);return{conflictsSettings:[],localContent:N,remoteContent:null,hasConflicts:!1}}let M=u,H=d;const B=(0,c.parse)(u),Z=(0,c.parse)(d),V=b?(0,c.parse)(b):null,ie=A.reduce((N,Y)=>(N.add(Y),N),new Set),z=f(B,Z,ie),q=f(V,B,ie),te=f(V,Z,ie),se=new Map,ce=new Set,W=N=>{ce.add(N);const Y=I.filter(({key:$})=>$===N)[0];Y?(M=L.edit(M,[N],Y.value,E),H=L.edit(H,[N],Y.value,E)):se.set(N,{key:N,localValue:B[N],remoteValue:Z[N]})};for(const N of q.removed.values())te.updated.has(N)?W(N):H=L.edit(H,[N],void 0,E);for(const N of te.removed.values())ce.has(N)||(q.updated.has(N)?W(N):M=L.edit(M,[N],void 0,E));for(const N of q.updated.values())ce.has(N)||(te.updated.has(N)?z.updated.has(N)&&W(N):H=L.edit(H,[N],B[N],E));for(const N of te.updated.values())ce.has(N)||(q.updated.has(N)?z.updated.has(N)&&W(N):M=L.edit(M,[N],Z[N],E));for(const N of q.added.values())ce.has(N)||(te.added.has(N)?z.updated.has(N)&&W(N):H=S(N,M,H,E));for(const N of te.added.values())ce.has(N)||(q.added.has(N)?z.updated.has(N)&&W(N):M=S(N,H,M,E));const Q=se.size>0||!y(M,H,A),G=Q||!y(M,u,[]),j=Q||!y(H,d,[]);return{localContent:G?M:null,remoteContent:j?H:null,conflictsSettings:[...se.values()],hasConflicts:Q}}function y(u,d,b){if(u===d)return!0;const A=(0,c.parse)(u),I=(0,c.parse)(d),E=b.reduce((U,M)=>(U.add(M),U),new Set),k=a(u).filter(U=>!(U.setting&&E.has(U.setting.key))),F=a(d).filter(U=>!(U.setting&&E.has(U.setting.key)));if(k.length!==F.length)return!1;for(let U=0;U<k.length;U++){const M=k[U],H=F[U];if(M.setting&&H.setting){if(M.setting.key!==H.setting.key||!O.equals(A[M.setting.key],I[M.setting.key]))return!1}else if(!M.setting&&!H.setting){if(M.value!==H.value)return!1}else return!1}return!0}function w(u){return u?a(u).length===0:!0}function f(u,d,b){const A=u?Object.keys(u).filter(U=>!b.has(U)):[],I=Object.keys(d).filter(U=>!b.has(U)),E=I.filter(U=>!A.includes(U)).reduce((U,M)=>(U.add(M),U),new Set),k=A.filter(U=>!I.includes(U)).reduce((U,M)=>(U.add(M),U),new Set),F=new Set;if(u)for(const U of A){if(k.has(U))continue;const M=u[U],H=d[U];O.equals(M,H)||F.add(U)}return{added:E,removed:k,updated:F}}function S(u,d,b,A){const I=(0,c.parse)(d),E=a(d),k=a(b),F=R(u,E,k);return g(b,u,I[u],F,k,A)}function R(u,d,b){const A=d.findIndex(E=>E.setting?.key===u),I=d[A-1];if(I){if(I.setting){const k=r(I.setting.key,b);if(k)return{index:b.indexOf(k),insertAfter:!0}}else{const k=t(A,d);if(k){const F=r(k.setting.key,b);if(F){const U=o(b.indexOf(F),b),M=i(d,k,d[A]);if(U){const H=i(b,F,U),B=n(M,H);return B?{index:b.indexOf(B),insertAfter:!0}:{index:b.indexOf(U),insertAfter:!1}}else{const H=i(b,F,b[b.length-1]),B=n(M,H);return B?{index:b.indexOf(B),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const E=d[A+1];if(E)if(E.setting){const k=r(E.setting.key,b);if(k)return{index:b.indexOf(k),insertAfter:!1}}else{const k=o(A,d);if(k){const F=r(k.setting.key,b);if(F){const U=t(b.indexOf(F),b),M=i(d,d[A],k);if(U){const H=i(b,U,F),B=n(M.reverse(),H.reverse());return B?{index:b.indexOf(B),insertAfter:!1}:{index:b.indexOf(U),insertAfter:!0}}else{const H=i(b,b[0],F),B=n(M.reverse(),H.reverse());return B?{index:b.indexOf(B),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function g(u,d,b,A,I,E){let k;return A.index===-1?k=(0,T.setProperty)(u,[d],b,E):k=s(u,d,b,A,I,E).map(F=>(0,T.withFormatting)(u,F,E)[0]),(0,T.applyEdits)(u,k)}function s(u,d,b,A,I,E){const k=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,F=(0,D.getEOL)(E,u),U=I[A.index];if(A.insertAfter){const M=[];if(U.setting)M.push({offset:U.endOffset,length:0,content:","+k});else{const H=o(A.index,I),B=t(A.index,I),Z=B?.setting?.commaOffset;B&&Z===void 0&&M.push({offset:B.endOffset,length:0,content:","});const V=Z!==void 0&&Z>U.endOffset;M.push({offset:V?Z+1:U.endOffset,length:0,content:H?F+k+",":F+k})}return M}else{if(U.setting)return[{offset:U.startOffset,length:0,content:k+","}];const M=(I[A.index-1]&&!I[A.index-1].setting?F:"")+k+(o(A.index,I)?",":"")+F;return[{offset:U.startOffset,length:0,content:M}]}}function r(u,d){return d.filter(b=>b.setting?.key===u)[0]}function t(u,d){for(let b=u-1;b>=0;b--)if(d[b].setting)return d[b]}function o(u,d){for(let b=u+1;b<d.length;b++)if(d[b].setting)return d[b]}function i(u,d,b){const A=u.indexOf(d),I=u.indexOf(b);return u.filter((E,k)=>A<k&&k<I)}function n(u,d){if(u.length&&d.length){let b=0;for(;b<d.length&&b<u.length;b++)if(u[b].value!==d[b].value)return d[b-1];return d[b-1]}}function a(u){const d=[];let b=-1,A,I;const E={onObjectBegin:k=>{b++},onObjectProperty:(k,F,U)=>{b===0&&(A=F,I=k)},onObjectEnd:(k,F)=>{b--,b===0&&d.push({startOffset:A,endOffset:k+F,value:u.substring(A,k+F),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(k,F)=>{b++},onArrayEnd:(k,F)=>{b--,b===0&&d.push({startOffset:A,endOffset:k+F,value:u.substring(A,k+F),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(k,F,U)=>{b===0&&d.push({startOffset:A,endOffset:F+U,value:u.substring(A,F+U),setting:{key:I,commaOffset:void 0}})},onSeparator:(k,F,U)=>{if(b===0&&k===","){let M=d.length-1;for(;M>=0&&!d[M].setting;M--);const H=d[M];H&&d.splice(M,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:F}})}},onComment:(k,F)=>{b===0&&d.push({startOffset:k,endOffset:k+F,value:u.substring(k,k+F)})}};return(0,c.visit)(u,E),d}}),define(le[83],ue([0,1,3,2,4,25]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let O=class extends c.Disposable{get account(){return this._account}constructor(_,v){super(),this.userDataSyncStoreService=_,this.logService=v,this._onDidChangeAccount=this._register(new C.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(_.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P===D.UserDataSyncErrorCode.Forbidden?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(_.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(_){(_&&this._account?_.token!==this._account.token||_.authenticationProviderId!==this._account.authenticationProviderId:_!==this._account)&&(this._account=_,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(_))}};e.UserDataSyncAccountService=O,e.UserDataSyncAccountService=O=we([X(0,D.IUserDataSyncStoreService),X(1,D.IUserDataSyncLogService)],O)}),define(le[249],ue([0,1,21,186,16,10,25]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends D.AbstractLogger{constructor(v,P){super(),this.logger=this._register(v.createLogger((0,C.joinPath)(P.logsHome,`${O.USER_DATA_SYNC_LOG_ID}.log`),{id:O.USER_DATA_SYNC_LOG_ID,name:(0,c.localize)(0,null)}))}trace(v,...P){this.logger.trace(v,...P)}debug(v,...P){this.logger.debug(v,...P)}info(v,...P){this.logger.info(v,...P)}warn(v,...P){this.logger.warn(v,...P)}error(v,...P){this.logger.error(v,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=L,e.UserDataSyncLogService=L=we([X(0,D.ILoggerService),X(1,T.IEnvironmentService)],L)}),define(le[250],ue([0,1,6,3,2]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends T.Disposable{constructor({onDidOpenMainWindow:L,onDidFocusMainWindow:_,getActiveWindowId:v}){super(),this.disposables=this._register(new T.DisposableStore),c.Event.latch(c.Event.any(L,_))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,C.createCancelablePromise)(()=>v()),(async()=>{try{const p=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:p}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(le[116],ue([0,1,189,14,52,21,9,4,23]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=v,e.isEmptyWorkspaceIdentifier=P,e.toWorkspaceIdentifier=p,e.isWorkspaceIdentifier=h,e.reviveIdentifier=m,e.isWorkspace=y,e.isWorkspaceFolder=w,e.toWorkspaceFolder=R,e.isUntitledWorkspace=g,e.isTemporaryWorkspace=s,e.isStandaloneEditorWorkspace=r,e.isSavedWorkspace=t,e.hasWorkspaceFileExtension=o,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");function v(i){const n=i;return typeof n?.id=="string"&&O.URI.isUri(n.uri)}function P(i){return typeof i?.id=="string"&&!v(i)&&!h(i)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,c.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}function h(i){const n=i;return typeof n?.id=="string"&&O.URI.isUri(n.configPath)}function m(i){const n=i;if(n?.uri)return{id:n.id,uri:O.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:O.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}var l;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function w(i){const n=i;return!!(n&&typeof n=="object"&&O.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,a,u,d,b){this._id=n,this._transient=u,this._configuration=d,this._ignorePathCasing=b,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class S{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function R(i){return new S({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}function s(i){let n;return O.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===_.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function t(i,n){return!g(i,n)&&!s(i)}function o(i){return(typeof i=="string"?(0,c.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}}),define(le[20],ue([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=g,e.reviveProfile=s,e.toUserDataProfile=r;var R;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&O.URI.isUri(n.location)&&O.URI.isUri(n.globalStorageHome)&&O.URI.isUri(n.settingsResource)&&O.URI.isUri(n.keybindingsResource)&&O.URI.isUri(n.tasksResource)&&O.URI.isUri(n.snippetsHome)&&O.URI.isUri(n.extensionsResource))}e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function s(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:n}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function r(i,n,a,u,d,b){return{id:i,name:n,location:a,isDefault:!1,shortName:d?.shortName,icon:d?.icon,globalStorageHome:b&&d?.useDefaultFlags?.globalState?b.globalStorageHome:(0,D.joinPath)(a,"globalStorage"),settingsResource:b&&d?.useDefaultFlags?.settings?b.settingsResource:(0,D.joinPath)(a,"settings.json"),keybindingsResource:b&&d?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,D.joinPath)(a,"keybindings.json"),tasksResource:b&&d?.useDefaultFlags?.tasks?b.tasksResource:(0,D.joinPath)(a,"tasks.json"),snippetsHome:b&&d?.useDefaultFlags?.snippets?b.snippetsHome:(0,D.joinPath)(a,"snippets"),extensionsResource:b&&d?.useDefaultFlags?.extensions?b.extensionsResource:(0,D.joinPath)(a,"extensions.json"),cacheHome:(0,D.joinPath)(u,i),useDefaultFlags:d?.useDefaultFlags,isTransient:d?.transient}}let t=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,a,u,d){super(),this.environmentService=n,this.fileService=a,this.uriIdentityService=u,this.logService=d,this.enabled=!0,this._onDidChangeProfiles=this._register(new c.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new c.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new c.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new c.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new m.ResourceMap,workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,D.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),a=[n];if(this.enabled)try{for(const b of this.getStoredProfiles()){if(!b.name||!(0,S.isString)(b.name)||!b.location){this.logService.warn("Skipping the invalid stored profile",b.location||b.name);continue}a.push(r((0,D.basename)(b.location),b.name,b.location,this.profilesCacheHome,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},n))}}catch(b){this.logService.error(b)}const u=new m.ResourceMap,d=new Map;if(a.length)try{const b=this.getStoredProfileAssociations();if(b.workspaces)for(const[A,I]of Object.entries(b.workspaces)){const E=O.URI.parse(A),k=a.find(F=>F.id===I);k&&u.set(E,k)}if(b.emptyWindows)for(const[A,I]of Object.entries(b.emptyWindows)){const E=a.find(k=>k.id===I);E&&d.set(A,E)}}catch(b){this.logService.error(b)}this._profilesObject={profiles:a,workspaces:u,emptyWindows:d}}return this._profilesObject}createDefaultProfile(){const n=r("__default__profile__",(0,L.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",u=new RegExp(`${(0,f.escapeRegExpCharacters)(a)}\\s(\\d+)`);let d=0;for(const A of this.profiles){const I=u.exec(A.name),E=I?parseInt(I[1]):0;d=E>d?E:d}const b=`${a} ${d+1}`;return this.createProfile((0,C.hash)((0,w.generateUuid)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,a,u){return this.createProfile((0,C.hash)((0,w.generateUuid)()).toString(16),n,a,u)}async createProfile(n,a,u,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const b=await this.doCreateProfile(n,a,u);return d&&await this.setProfileForWorkspace(d,b),b}async doCreateProfile(n,a,u){if(!(0,S.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let d=this.profileCreationPromises.get(a);return d||(d=(async()=>{try{if(this.profiles.find(E=>E.name===a||E.id===n))throw new Error(`Profile with ${a} name already exists`);const A=r(n,a,(0,D.joinPath)(this.profilesHome,n),this.profilesCacheHome,u,this.defaultProfile);await this.fileService.createFolder(A.location);const I=[];return this._onWillCreateProfile.fire({profile:A,join(E){I.push(E)}}),await y.Promises.settled(I),this.updateProfiles([A],[],[]),A}finally{this.profileCreationPromises.delete(a)}})(),this.profileCreationPromises.set(a,d)),d}async updateProfile(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(d=>d.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=r(u.id,a.name??u.name,u.location,this.profilesCacheHome,{shortName:a.shortName??u.shortName,icon:a.icon===null?void 0:a.icon??u.icon,transient:a.transient??u.isTransient,useDefaultFlags:a.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[u]),u}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(d=>d.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:a,join(d){u.push(d)}});try{await Promise.allSettled(u)}catch(d){this.logService.error(d)}for(const d of[...this.profilesObject.emptyWindows.keys()])a.id===this.profilesObject.emptyWindows.get(d)?.id&&this.profilesObject.emptyWindows.delete(d);for(const d of[...this.profilesObject.workspaces.keys()])a.id===this.profilesObject.workspaces.get(d)?.id&&this.profilesObject.workspaces.delete(d);this.updateStoredProfileAssociations(),this.updateProfiles([],[a],[]);try{await this.fileService.del(a.cacheHome,{recursive:!0})}catch(d){(0,v.toFileOperationResult)(d)!==v.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(d)}}async setProfileForWorkspace(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(d=>d.id===a.id);if(!u)throw new Error(`Profile '${a.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,a)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,a.resource))).map(a=>this.fileService.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(a=>!this.isProfileAssociatedToWorkspace(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.getWorkspace(n),u=O.URI.isUri(a)?this.profilesObject.workspaces.get(a):this.profilesObject.emptyWindows.get(a);return u||((0,h.isSingleFolderWorkspaceIdentifier)(n)?this.transientProfilesObject.folders.get(n.uri):(0,h.isWorkspaceIdentifier)(n)?this.transientProfilesObject.workspaces.get(n.configPath):this.transientProfilesObject.emptyWindows.get(n.id))}getWorkspace(n){return(0,h.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,h.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.profilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.profilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.transientProfilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.transientProfilesObject.folders.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location)))}updateProfiles(n,a,u){const d=[...this.profiles,...n],b=[],A=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let I of d){if(I.isDefault||a.some(k=>I.id===k.id))continue;I=u.find(k=>I.id===k.id)??I;const E=A.find(k=>I.id===k.id);if(I.isTransient)this.transientProfilesObject.profiles.push(I);else{if(E){for(const[k,F]of this.transientProfilesObject.emptyWindows.entries())if(I.id===F.id){this.updateWorkspaceAssociation({id:k},I);break}for(const[k,F]of this.transientProfilesObject.workspaces.entries())if(I.id===F.id){this.updateWorkspaceAssociation({id:"",configPath:k},I);break}for(const[k,F]of this.transientProfilesObject.folders.entries())if(I.id===F.id){this.updateWorkspaceAssociation({id:"",uri:k},I);break}}b.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags})}}this.saveStoredProfiles(b),this._profilesObject=void 0,this.triggerProfilesChanges(n,a,u)}triggerProfilesChanges(n,a,u){this._onDidChangeProfiles.fire({added:n,removed:a,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,a,u){if(u=a?.isTransient?!0:u,u)(0,h.isSingleFolderWorkspaceIdentifier)(n)?(this.transientProfilesObject.folders.delete(n.uri),a&&this.transientProfilesObject.folders.set(n.uri,a)):(0,h.isWorkspaceIdentifier)(n)?(this.transientProfilesObject.workspaces.delete(n.configPath),a&&this.transientProfilesObject.workspaces.set(n.configPath,a)):(this.transientProfilesObject.emptyWindows.delete(n.id),a&&this.transientProfilesObject.emptyWindows.set(n.id,a));else{this.updateWorkspaceAssociation(n,void 0,!0);const d=this.getWorkspace(n);O.URI.isUri(d)?(this.profilesObject.workspaces.delete(d),a&&this.profilesObject.workspaces.set(d,a)):(this.profilesObject.emptyWindows.delete(d),a&&this.profilesObject.emptyWindows.set(d,a)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const n={};for(const[u,d]of this.profilesObject.workspaces.entries())n[u.toString()]=d.id;const a={};for(const[u,d]of this.profilesObject.emptyWindows.entries())a[u.toString()]=d.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:a}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const a={},u=this.createDefaultProfile();if(n.workspaces)for(const[b,A]of Object.entries(n.workspaces)){const I=O.URI.parse(A);a[b]=this.uriIdentityService.extUri.isEqual(I,u.location)?u.id:this.uriIdentityService.extUri.basename(I)}const d={};if(n.emptyWindows)for(const[b,A]of Object.entries(n.emptyWindows)){const I=O.URI.parse(A);d[b]=this.uriIdentityService.extUri.isEqual(I,u.location)?u.id:this.uriIdentityService.extUri.basename(I)}return{workspaces:a,emptyWindows:d}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=t,e.UserDataProfilesService=t=we([X(0,_.IEnvironmentService),X(1,v.IFileService),X(2,l.IUriIdentityService),X(3,p.ILogService)],t);class o extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=o}),define(le[251],ue([0,1,6,2,20]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let D=class extends c.Disposable{constructor(L){super(),this._register(new C.RunOnceScheduler(()=>{L.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=D,e.UserDataProfilesCleaner=D=we([X(0,T.IUserDataProfilesService)],D)}),define(le[84],ue([0,1,19,6,26,8,3,2,5,13,9,162,28,33,36,60,10,24,18,29,20]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=r,p=De(p);let s=class extends L.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,a,u,d,b,A){super(),this.galleryService=n,this.telemetryService=a,this.uriIdentityService=u,this.logService=d,this.productService=b,this.userDataProfilesService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this._onDidUpdateExtensionMetadata=this._register(new O.Emitter),this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(({task:I})=>I.cancel()),this.uninstallingExtensions.forEach(I=>I.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const a=await this.getTargetPlatform();return n.allTargetPlatforms.some(u=>(0,h.isTargetPlatformCompatible)(u,n.allTargetPlatforms,a))}async installFromGallery(n,a={}){try{const d=(await this.installGalleryExtensions([{extension:n,options:a}])).find(({identifier:b})=>(0,m.areSameExtensions)(b,n.identifier));if(d?.local)return d?.local;throw d?.error?d.error:new h.ExtensionManagementError(`Unknown error while installing extension ${n.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(u){throw r(u)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(p.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const a=[],u=[];return await Promise.allSettled(n.map(async({extension:d,options:b})=>{try{const A=await this.checkAndGetCompatibleVersion(d,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.productService.version,date:this.productService.date});u.push({...A,options:b})}catch(A){a.push({identifier:d.identifier,operation:h.InstallOperation.Install,source:d,error:A,profileLocation:b.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),u.length&&a.push(...await this.installExtensions(u)),a}async uninstall(n,a={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,a)}async toggleAppliationScope(n,a){if((0,l.isApplicationScopedExtension)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let u=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(a,this.userDataProfilesService.defaultProfile.extensionsResource)||(u=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,a));for(const d of this.userDataProfilesService.profiles){const b=(await this.getInstalled(l.ExtensionType.User,d.extensionsResource)).find(A=>(0,m.areSameExtensions)(A.identifier,n.identifier));b?this._onDidUpdateExtensionMetadata.fire({local:b,profileLocation:d.extensionsResource}):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:d.extensionsResource})}return u}else{const u=this.uriIdentityService.extUri.isEqual(a,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,a,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:u.identifier,operation:h.InstallOperation.Install,local:u,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const a=new Map,u=new Map,d=[],b=(I,E)=>`${m.ExtensionKey.create(I).toString()}-${E.toString()}`,A=(I,E,k,F)=>{const U=this.createInstallExtensionTask(I,E,k),M=`${(0,m.getGalleryExtensionId)(I.publisher,I.name)}-${k.profileLocation.toString()}`;u.set(M,{task:U,root:F}),this._onInstallExtension.fire({identifier:U.identifier,source:E,profileLocation:k.profileLocation}),this.logService.info("Installing extension:",U.identifier.id,k),P.URI.isUri(E)||this.installingExtensions.set(b(E,k.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:I,extension:E,options:k}of n){const F=k.isApplicationScoped||k.isBuiltin||(0,l.isApplicationScopedExtension)(I),U={...k,installOnlyNewlyAddedFromExtensionPack:k.installOnlyNewlyAddedFromExtensionPack??!P.URI.isUri(E),isApplicationScoped:F,profileLocation:F?this.userDataProfilesService.defaultProfile.extensionsResource:k.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:k.productVersion??{version:this.productService.version,date:this.productService.date}},M=P.URI.isUri(E)?void 0:this.installingExtensions.get(b(E,U.profileLocation));M?(this.logService.info("Extension is already requested to install",M.task.identifier.id,U.profileLocation.toString()),d.push(M.task.waitUntilTaskIsFinished())):A(I,E,U,void 0)}return await Promise.all([...u.values()].map(async({task:I})=>{if(I.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",I.identifier.id);else try{const E=await this.getAllDepsAndPackExtensions(I.identifier,I.manifest,!!I.options.installOnlyNewlyAddedFromExtensionPack,!!I.options.installPreReleaseVersion,I.options.profileLocation,I.options.productVersion),k=await this.getInstalled(void 0,I.options.profileLocation,I.options.productVersion),F={...I.options,context:{...I.options.context,[h.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:U,manifest:M}of(0,C.distinct)(E,({gallery:H})=>H.identifier.id)){if(u.has(`${U.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const H=this.installingExtensions.get(b(U,F.profileLocation));if(H){if(this.canWaitForTask(I,H.task)){const B=H.task.identifier;this.logService.info("Waiting for already requested installing extension",B.id,I.identifier.id,F.profileLocation.toString()),H.waitingTasks.push(I),d.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,Z=>Z.some(V=>(0,m.areSameExtensions)(V.identifier,B)))).then(Z=>{if(this.logService.info("Finished waiting for already requested installing extension",B.id,I.identifier.id,F.profileLocation.toString()),!Z.find(ie=>(0,m.areSameExtensions)(ie.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else k.some(({identifier:B})=>(0,m.areSameExtensions)(B,U.identifier))||A(M,U,F,I)}}catch(E){if(P.URI.isUri(I.source))(0,C.isNonEmptyArray)(I.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",I.identifier.id,E.message),(0,C.isNonEmptyArray)(I.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",I.identifier.id,E.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",I.identifier.id),E}})),await this.joinAllSettled([...u.entries()].map(async([I,{task:E}])=>{const k=new Date().getTime();let F;try{F=await E.run(),await this.joinAllSettled(this.participants.map(U=>U.postInstall(F,E.source,E.options,T.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(U){const M=r(U);throw P.URI.isUri(E.source)||t(this.telemetryService,E.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(E.source),error:M,source:E.options.context?.[h.EXTENSION_INSTALL_SOURCE_CONTEXT]}),a.set(I,{error:M,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.logService.error("Error while installing the extension",E.identifier.id,(0,D.getErrorMessage)(M),E.options.profileLocation.toString()),M}if(!P.URI.isUri(E.source)){const U=E.operation===h.InstallOperation.Update,M=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(t(this.telemetryService,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-k,durationSinceUpdate:M,source:E.options.context?.[h.EXTENSION_INSTALL_SOURCE_CONTEXT]}),_.isWeb&&E.operation!==h.InstallOperation.Update)try{await this.galleryService.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,h.StatisticType.Install)}catch{}}a.set(I,{local:F,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:F.isApplicationScoped})})),d.length&&await this.joinAllSettled(d),[...a.values()]}catch(I){const E=(U,M,H)=>{const B=[];U.manifest.extensionDependencies?.length&&B.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&B.push(...U.manifest.extensionPack);for(const Z of B){if(H.includes(Z.toLowerCase()))continue;H.push(Z.toLowerCase());const V=a.get(`${Z.toLowerCase()}-${M.toString()}`);V?.local&&(H=E(V.local,M,H))}return H},k=U=>({identifier:U.identifier,operation:h.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:I}),F=[];for(const[U,{task:M,root:H}]of u){const B=a.get(U);B?B.local&&H&&!a.get(`${H.identifier.id.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local&&(F.push(this.createUninstallExtensionTask(B.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),a.set(U,k(M))):(M.cancel(),a.set(U,k(M)))}for(const[U,{task:M}]of u){const H=a.get(U);if(!H?.local||M.options.donotIncludePackAndDependencies)continue;E(H.local,M.options.profileLocation,[H.local.identifier.id.toLowerCase()]).slice(1).some(Z=>u.has(`${Z.toLowerCase()}-${M.options.profileLocation.toString()}`)&&!a.get(`${Z.toLowerCase()}-${M.options.profileLocation.toString()}`)?.local)&&(F.push(this.createUninstallExtensionTask(H.local,{versionOnly:!0,profileLocation:M.options.profileLocation})),a.set(U,k(M)))}throw F.length&&await Promise.allSettled(F.map(async U=>{try{await U.run(),this.logService.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(M){this.logService.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,D.getErrorMessage)(M))}})),I}finally{for(const{task:I}of u.values())I.source&&!P.URI.isUri(I.source)&&this.installingExtensions.delete(b(I.source,I.options.profileLocation));if(a.size){const I=[...a.values()];for(const E of I)E.local&&this.logService.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this._onDidInstallExtensions.fire(I)}}}canWaitForTask(n,a){for(const[,{task:u,waitingTasks:d}]of this.installingExtensions.entries())if(u===n&&(d.includes(a)||d.some(b=>this.canWaitForTask(b,a)))||u===a&&d[0]&&!this.canWaitForTask(n,d[0]))return!1;return!0}async joinAllSettled(n,a){const u=[],d=[],b=await Promise.allSettled(n);for(const I of b)I.status==="fulfilled"?u.push(I.value):d.push(r(I.reason,a));if(!d.length)return u;if(d.length===1)throw d[0];let A=new h.ExtensionManagementError("",h.ExtensionManagementErrorCode.Unknown);for(const I of d)A=new h.ExtensionManagementError(A.message?`${A.message}, ${I.message}`:I.message,I.code!==h.ExtensionManagementErrorCode.Unknown&&I.code!==h.ExtensionManagementErrorCode.Internal?I.code:A.code);throw A}async getAllDepsAndPackExtensions(n,a,u,d,b,A){if(!this.galleryService.isEnabled())return[];const I=await this.getInstalled(void 0,b,A),E=[],k=[],F=async(U,M)=>{E.push(U);const H=M.extensionDependencies||[],B=[...H];if(M.extensionPack){const Z=u?I.find(V=>(0,m.areSameExtensions)(V.identifier,U)):void 0;for(const V of M.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(ie=>(0,m.areSameExtensions)({id:ie},{id:V}))||B.every(ie=>!(0,m.areSameExtensions)({id:ie},{id:V}))&&B.push(V)}if(B.length){const Z=B.filter(V=>E.every(ie=>!(0,m.areSameExtensions)(ie,{id:V})));if(Z.length){const V=await this.galleryService.getExtensions(Z.map(ie=>({id:ie,preRelease:d})),T.CancellationToken.None);for(const ie of V){if(E.find(te=>(0,m.areSameExtensions)(te,ie.identifier)))continue;const z=H.some(te=>(0,m.areSameExtensions)({id:te},ie.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(ie,!1,d,A)}catch(te){if(z)throw te;this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id,(0,D.getErrorMessage)(te));continue}k.push({gallery:q.extension,manifest:q.manifest}),await F(q.extension.identifier,q.manifest)}}}};return await F(n,a),k}async checkAndGetCompatibleVersion(n,a,u,d){let b;const A=await this.getExtensionsControlManifest();if(A.malicious.some(k=>(0,m.areSameExtensions)(n.identifier,k)))throw new h.ExtensionManagementError(p.localize(1,null,n.identifier.id),h.ExtensionManagementErrorCode.Malicious);const I=A.deprecated[n.identifier.id.toLowerCase()];if(I?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${I.extension.id}' extension instead.`),b=(await this.galleryService.getExtensions([{id:I.extension.id,preRelease:I.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:d},T.CancellationToken.None))[0],!b)throw new h.ExtensionManagementError(p.localize(2,null,n.identifier.id,I.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const k=await this.getTargetPlatform();throw new h.ExtensionManagementError(p.localize(3,null,n.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(k)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.getCompatibleVersion(n,a,u,d),!b){const k=[];throw(0,y.areApiProposalsCompatible)(n.properties.enabledApiProposals??[],k)?!u&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],T.CancellationToken.None))[0]?new h.ExtensionManagementError(p.localize(5,null,n.displayName??n.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(p.localize(6,null,n.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible):new h.ExtensionManagementError(p.localize(4,null,n.displayName??n.identifier.id,k[0]),h.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",b.identifier.id);const E=await this.galleryService.getManifest(b,T.CancellationToken.None);if(E===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${b.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(E.version!==b.version)throw new h.ExtensionManagementError(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:E}}async getCompatibleVersion(n,a,u,d){const b=await this.getTargetPlatform();let A=null;return!a&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==u&&(A=(await this.galleryService.getExtensions([{...n.identifier,preRelease:u}],{targetPlatform:b,compatible:!0,productVersion:d},T.CancellationToken.None))[0]||null),!A&&await this.galleryService.isExtensionCompatible(n,u,b,d)&&(A=n),A||(a?A=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:b,compatible:!0,productVersion:d},T.CancellationToken.None))[0]||null:A=await this.galleryService.getCompatibleExtension(n,u,b,d)),A}async uninstallExtension(n,a){const u={...a,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},d=F=>`${F.id.toLowerCase()}${u.versionOnly?`-${n.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,b=this.uninstallingExtensions.get(d(n.identifier));if(b)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),b.waitUntilTaskIsFinished();const A=F=>{const U=this.createUninstallExtensionTask(F,u);return this.uninstallingExtensions.set(d(U.extension.identifier),U),u.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,u.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:u.profileLocation,applicationScoped:F.isApplicationScoped}),U},I=(F,U)=>{U?u.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,u.profileLocation.toString(),U.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,U.message):u.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,u.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(F),error:U}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:U?.code,profileLocation:u.profileLocation,applicationScoped:F.isApplicationScoped})},E=[],k=[];try{E.push(A(n));const F=await this.getInstalled(l.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const U=this.getAllPackExtensionsToUninstall(n,F);for(const M of U)this.uninstallingExtensions.has(d(M.identifier))?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):E.push(A(M))}u.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(E.map(U=>U.extension),F,n),await this.joinAllSettled(E.map(async U=>{try{if(await U.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(U.extension,u,T.CancellationToken.None))),U.extension.identifier.uuid)try{await this.galleryService.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,h.StatisticType.Uninstall)}catch{}I(U.extension)}catch(M){const H=r(M);throw I(U.extension,H),H}finally{k.push(U)}}))}catch(F){const U=r(F);for(const M of E){try{M.cancel()}catch{}k.includes(M)||I(M.extension,U)}throw U}finally{for(const F of E)this.uninstallingExtensions.delete(d(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(n,a,u){for(const d of n){const b=this.getDependents(d,a);if(b.length){const A=b.filter(I=>!n.some(E=>(0,m.areSameExtensions)(E.identifier,I.identifier)));if(A.length)throw new Error(this.getDependentsErrorMessage(d,A,u))}}}getDependentsErrorMessage(n,a,u){return u===n?a.length===1?p.localize(7,null,u.manifest.displayName||u.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?p.localize(8,null,u.manifest.displayName||u.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):p.localize(9,null,u.manifest.displayName||u.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?p.localize(10,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?p.localize(11,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):p.localize(12,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(n,a,u=[]){if(u.indexOf(n)!==-1)return[];u.push(n);const d=n.manifest.extensionPack?n.manifest.extensionPack:[];if(d.length){const b=a.filter(I=>!I.isBuiltin&&d.some(E=>(0,m.areSameExtensions)({id:E},I.identifier))),A=[];for(const I of b)A.push(...this.getAllPackExtensionsToUninstall(I,a,u));return[...b,...A]}return[]}getDependents(n,a){return a.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(d=>(0,m.areSameExtensions)({id:d},n.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(n){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.getErrorMessage)(n)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=s,e.AbstractExtensionManagementService=s=we([X(0,h.IExtensionGalleryService),X(1,S.ITelemetryService),X(2,R.IUriIdentityService),X(3,w.ILogService),X(4,f.IProductService),X(5,g.IUserDataProfilesService)],s);function r(i,n){if(i instanceof h.ExtensionManagementError)return i;let a;return i instanceof h.ExtensionGalleryError?a=new h.ExtensionManagementError(i.message,i.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):a=new h.ExtensionManagementError(i.message,(0,D.isCancellationError)(i)?h.ExtensionManagementErrorCode.Cancelled:n??h.ExtensionManagementErrorCode.Internal),a.stack=i.stack,a}function t(i,n,{extensionData:a,verificationStatus:u,duration:d,error:b,source:A,durationSinceUpdate:I}){let E,k;(0,v.isDefined)(u)&&(u===!0?u="Verified":(u===!1||(E=h.ExtensionManagementErrorCode.Signature,k=u),u="Unverified")),b&&(E=b.code,b.code===h.ExtensionManagementErrorCode.Signature&&(k=b.message)),i.publicLog(n,{...a,verificationStatus:u,success:!b,duration:d,errorcode:E,errorcodeDetail:k,durationSinceUpdate:I,source:A})}class o{constructor(){this.barrier=new c.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,c.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,c.createCancelablePromise)(n=>new Promise((a,u)=>{const d=n.onCancellationRequested(()=>{d.dispose(),u(new D.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(le[53],ue([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var S;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(S||(e.ExtensionsProfileScanningErrorCode=S={}));class R extends Error{constructor(o,i){super(o),this.code=i}}e.ExtensionsProfileScanningError=R,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let g=class extends T.Disposable{constructor(o,i,n,a,u,d){super(),this.extensionsLocation=o,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=a,this.telemetryService=u,this.logService=d,this._onAddExtensions=this._register(new D.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new D.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new D.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new D.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new O.ResourceMap}scanProfileExtensions(o,i){return this.withProfileExtensions(o,void 0,i)}async addExtensionsToProfile(o,i,n){const a=[],u=[];try{return await this.withProfileExtensions(i,d=>{const b=[];if(n)b.push(...d);else for(const A of d)o.some(([I])=>(0,v.areSameExtensions)(I.identifier,A.identifier)&&I.manifest.version!==A.version)?a.push(A):b.push(A);for(const[A,I]of o){const E=b.findIndex(F=>(0,v.areSameExtensions)(F.identifier,A.identifier)&&F.version===A.manifest.version),k={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:I};E===-1?(u.push(k),b.push(k)):b.splice(E,1,k)}return u.length&&this._onAddExtensions.fire({extensions:u,profileLocation:i}),a.length&&this._onRemoveExtensions.fire({extensions:a,profileLocation:i}),b}),u.length&&this._onDidAddExtensions.fire({extensions:u,profileLocation:i}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,profileLocation:i}),u}catch(d){throw u.length&&this._onDidAddExtensions.fire({extensions:u,error:d,profileLocation:i}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,error:d,profileLocation:i}),d}}async updateMetadata(o,i){const n=[];return await this.withProfileExtensions(i,a=>{const u=[];for(const d of a){const b=o.find(([A])=>(0,v.areSameExtensions)(A.identifier,d.identifier)&&A.manifest.version===d.version);b&&(d.metadata={...d.metadata,...b[1]},n.push(d)),u.push(d)}return u}),n}async removeExtensionFromProfile(o,i){const n=[];try{await this.withProfileExtensions(i,a=>{const u=[];for(const d of a)(0,v.areSameExtensions)(d.identifier,o.identifier)?n.push(d):u.push(d);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),u}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:a,profileLocation:i}),a}}async withProfileExtensions(o,i,n){return this.getResourceAccessQueue(o).queue(async()=>{let a=[],u;try{const d=await this.fileService.readFile(o);u=JSON.parse(d.value.toString().trim()||"[]")}catch(d){if((0,P.toFileOperationResult)(d)!==P.FileOperationResult.FILE_NOT_FOUND)throw d;if(this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)&&(u=await this.migrateFromOldDefaultProfileExtensionsLocation()),!u&&n?.bailOutWhenFileNotFound)throw new R((0,w.getErrorMessage)(d),S.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.reportAndThrowInvalidConentError(o);let d=!1;for(const b of u){s(b)||this.reportAndThrowInvalidConentError(o);let A;if((0,y.isString)(b.relativeLocation)&&b.relativeLocation)A=this.resolveExtensionLocation(b.relativeLocation);else if((0,y.isString)(b.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${b.location}`);continue}else{A=L.URI.revive(b.location);const I=this.toRelativePath(A);I&&(d=!0,b.relativeLocation=I)}(0,y.isUndefined)(b.metadata?.hasPreReleaseVersion)&&b.metadata?.preRelease&&(d=!0,b.metadata.hasPreReleaseVersion=!0),a.push({identifier:b.identifier,location:A,version:b.version,metadata:b.metadata})}d&&await this.fileService.writeFile(o,c.VSBuffer.fromString(JSON.stringify(u)))}if(i){a=i(a);const d=a.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.toRelativePath(b.location),metadata:b.metadata}));await this.fileService.writeFile(o,c.VSBuffer.fromString(JSON.stringify(d)))}return a})}reportAndThrowInvalidConentError(o){const i=new R(`Invalid extensions content in ${o.toString()}`,S.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(o){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(o),this.extensionsLocation)?this.uriIdentityService.extUri.basename(o):void 0}resolveExtensionLocation(o){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,o)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const o=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(o)).value.toString()}catch(u){if((0,P.toFileOperationResult)(u)===P.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.logService.info("Migrating extensions from old default profile location",o.toString());let a;try{const u=JSON.parse(n);Array.isArray(u)&&u.every(d=>s(d))?a=u:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.logService.error(u)}if(a)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,c.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(u){if((0,P.toFileOperationResult)(u)===P.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw u}try{await this.fileService.del(o)}catch(u){(0,P.toFileOperationResult)(u)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(u)}try{await this.fileService.del(i)}catch(u){(0,P.toFileOperationResult)(u)!==P.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(u)}return a})()),this._migrationPromise}getResourceAccessQueue(o){let i=this.resourcesAccessQueueMap.get(o);return i||(i=new C.Queue,this.resourcesAccessQueueMap.set(o,i)),i}};e.AbstractExtensionsProfileScannerService=g,e.AbstractExtensionsProfileScannerService=g=we([X(1,P.IFileService),X(2,m.IUserDataProfilesService),X(3,l.IUriIdentityService),X(4,f.ITelemetryService),X(5,h.ILogService)],g);function s(t){return(0,y.isObject)(t)&&(0,_.isIExtensionIdentifier)(t.identifier)&&(r(t.location)||(0,y.isString)(t.location)&&t.location)&&((0,y.isUndefined)(t.relativeLocation)||(0,y.isString)(t.relativeLocation))&&t.version&&(0,y.isString)(t.version)}function r(t){return t?(0,y.isString)(t.path)&&(0,y.isString)(t.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[85],ue([0,1,19,6,30,15,8,34,144,2,23,14,5,21,61,92,13,9,165,16,33,36,60,7,4,10,24,3,69,53,20,29,194]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t,o,i,n,a,u,d,b,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=H,T=De(T),p=De(p),h=De(h),l=De(l),y=it(y);var E;(function(Z){function V(ie,z){if(ie===z)return!0;const q=Object.keys(ie),te=new Set;for(const se of Object.keys(z))te.add(se);if(q.length!==te.size)return!1;for(const se of q){if(ie[se]!==z[se])return!1;te.delete(se)}return te.size===0}Z.equals=V})(E||(e.Translations=E={})),e.IExtensionsScannerService=(0,o.createDecorator)("IExtensionsScannerService");let k=class extends v.Disposable{constructor(V,ie,z,q,te,se,ce,W,Q,G,j,N){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=ie,this.extensionsControlLocation=z,this.currentProfile=q,this.userDataProfilesService=te,this.extensionsProfileScannerService=se,this.fileService=ce,this.logService=W,this.environmentService=Q,this.productService=G,this.uriIdentityService=j,this.instantiationService=N,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(U,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(s.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(s.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,ie,z){const[q,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(ie)]),se=z?await this.scanExtensionsUnderDevelopment(V,[...q,...te]):[];return this.dedupExtensions(q,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const ie=[];ie.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),ie.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[z,q]=await Promise.all(ie);return this.applyScanOptions([...z,...q],s.ExtensionType.System,V,!1)}async scanUserExtensions(V){const ie=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",ie);const z=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(ie,!!V.profileLocation,s.ExtensionType.User,!V.includeUninstalled,V.language,!0,z,V.productVersion??this.getProductVersion()),te=V.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let se;try{se=await te.scanExtensions(q)}catch(ce){if(ce instanceof d.ExtensionsProfileScanningError&&ce.code===d.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),se=await te.scanExtensions(q);else throw ce}return se=await this.applyScanOptions(se,s.ExtensionType.User,V,!0),this.logService.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(V,ie){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===P.Schemas.file).map(async q=>{const te=await this.createExtensionScannerInput(q,!1,s.ExtensionType.User,!0,V.language,!1,void 0,V.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(ce=>(ce.type=ie.find(W=>(0,g.areSameExtensions)(W.identifier,ce.identifier))?.type??ce.type,this.extensionsScanner.validate(ce,te)))}))).flat();return this.applyScanOptions(z,"development",V,!0)}return[]}async scanExistingExtension(V,ie,z){const q=await this.createExtensionScannerInput(V,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),te=await this.extensionsScanner.scanExtension(q);return!te||!z.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,ie,z){const q=await this.createExtensionScannerInput(V,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),te=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(te,ie,z,!0)}async scanMultipleExtensions(V,ie,z){const q=[];return await Promise.all(V.map(async te=>{const se=await this.scanOneOrMultipleExtensions(te,ie,z);q.push(...se)})),this.applyScanOptions(q,ie,z,!0)}async scanMetadata(V){const ie=(0,m.joinPath)(V,"package.json"),z=(await this.fileService.readFile(ie)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(V,ie){const z=(0,m.joinPath)(V,"package.json"),q=(await this.fileService.readFile(z)).value.toString(),te=JSON.parse(q);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,te.__metadata={...te.__metadata,...ie},await this.fileService.writeFile((0,m.joinPath)(V,"package.json"),D.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof d.ExtensionsProfileScanningError&&V.code===d.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(ie=>[ie,ie.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(ie){(0,t.toFileOperationResult)(ie)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(ie))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,ie,z,q){return z.includeAllVersions||(V=this.dedupExtensions(ie===s.ExtensionType.System?V:void 0,ie===s.ExtensionType.User?V:void 0,ie==="development"?V:void 0,await this.getTargetPlatform(),q)),z.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,se)=>{const ce=p.basename(te.location.fsPath),W=p.basename(se.location.fsPath);return ce<W?-1:ce>W?1:0})}dedupExtensions(V,ie,z,q,te){const se=(W,Q,G)=>{if(W.isValid&&!Q.isValid)return!1;if(W.isValid===Q.isValid){if(te&&l.gt(W.manifest.version,Q.manifest.version))return this.logService.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(l.eq(W.manifest.version,Q.manifest.version)){if(W.type===s.ExtensionType.System)return this.logService.debug(`Skipping extension ${Q.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===q)return this.logService.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return G?this.logService.warn(`Overwriting user extension ${W.location.path} with ${Q.location.path}.`):this.logService.debug(`Overwriting user extension ${W.location.path} with ${Q.location.path}.`),!0},ce=new s.ExtensionIdentifierMap;return V?.forEach(W=>{const Q=ce.get(W.identifier.id);(!Q||se(Q,W,!1))&&ce.set(W.identifier.id,W)}),ie?.forEach(W=>{const Q=ce.get(W.identifier.id);if(!Q&&V&&W.type===s.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!Q||se(Q,W,!1))&&ce.set(W.identifier.id,W)}),z?.forEach(W=>{const Q=ce.get(W.identifier.id);(!Q||se(Q,W,!0))&&ce.set(W.identifier.id,W),ce.set(W.identifier.id,W)}),[...ce.values()]}async scanDefaultSystemExtensions(V,ie){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,ie,!0,void 0,this.getProductVersion()),te=await(V&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(V,ie){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=ie?await this.getBuiltInExtensionControl():{},te=[],se=f.URI.file(p.normalize(p.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const W of z){const Q=q[W.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":te.push((0,m.joinPath)(se,W.name));break;default:te.push(f.URI.file(Q));break}}const ce=await Promise.all(te.map(async W=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(W,!1,s.ExtensionType.System,!0,V,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ce.length),(0,C.coalesce)(ce)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,ie,z,q,te,se,ce,W){const Q=await this.getTranslations(te??h.language),G=await this.getMtime(V),j=ie&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=j?await this.getMtime(j):void 0;return new F(V,G,j,N,ie,ce,z,q,se,W.version,W.date,this.productService.commit,!this.environmentService.isBuilt,te,Q)}async getMtime(V){try{const ie=await this.fileService.stat(V);if(typeof ie.mtime=="number")return ie.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=k,e.AbstractExtensionsScannerService=k=we([X(4,b.IUserDataProfilesService),X(5,d.IExtensionsProfileScannerService),X(6,t.IFileService),X(7,i.ILogService),X(8,R.IEnvironmentService),X(9,n.IProductService),X(10,A.IUriIdentityService),X(11,o.IInstantiationService)],k);class F{constructor(V,ie,z,q,te,se,ce,W,Q,G,j,N,Y,$,x){this.location=V,this.mtime=ie,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=q,this.profile=te,this.profileScanOptions=se,this.type=ce,this.excludeObsolete=W,this.validate=Q,this.productVersion=G,this.productDate=j,this.productCommit=N,this.devMode=Y,this.language=$,this.translations=x}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,ie){return(0,m.isEqual)(V.location,ie.location)&&V.mtime===ie.mtime&&(0,m.isEqual)(V.applicationExtensionslocation,ie.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&V.profile===ie.profile&&T.equals(V.profileScanOptions,ie.profileScanOptions)&&V.type===ie.type&&V.excludeObsolete===ie.excludeObsolete&&V.validate===ie.validate&&V.productVersion===ie.productVersion&&V.productDate===ie.productDate&&V.productCommit===ie.productCommit&&V.devMode===ie.devMode&&V.language===ie.language&&E.equals(V.translations,ie.translations)}}e.ExtensionScannerInput=F;let U=class extends v.Disposable{constructor(V,ie,z,q,te,se){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=ie,this.uriIdentityService=z,this.fileService=q,this.logService=se,this.extensionsEnabledWithApiProposalVersion=te.extensionsEnabledWithApiProposalVersion?.map(ce=>ce.toLowerCase())??[]}async scanExtensions(V){const ie=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let z={};if(V.excludeObsolete&&V.type===s.ExtensionType.User)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(q)}catch{}return(0,w.isEmptyObject)(z)?ie:ie.filter(q=>!z[g.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(V){const ie=await this.fileService.resolve(V.location);if(!ie.children?.length)return[];const z=await Promise.all(ie.children.map(async q=>{if(!q.isDirectory||V.type===s.ExtensionType.User&&(0,m.basename)(q.resource).indexOf(".")===0)return null;const te=new F(q.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,C.coalesce)(z).sort((q,te)=>q.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(V){let ie=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){ie=ie.filter(q=>!q.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,V);ie.push(...z)}return ie}async scanExtensionsFromProfileResource(V,ie,z){const q=await this.extensionsProfileScannerService.scanProfileExtensions(V,z.profileScanOptions);if(!q.length)return[];const te=await Promise.all(q.map(async se=>{if(ie(se)){const ce=new F(se.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ce,se.metadata)}return null}));return(0,C.coalesce)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,m.joinPath)(V.location,"package.json"))){const ie=await this.scanExtension(V);return ie?[ie]:[]}else return await this.scanExtensions(V)}catch(ie){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,O.getErrorMessage)(ie)),[]}}async scanExtension(V,ie){try{let z=await this.scanExtensionManifest(V.location);if(z){z.publisher||(z.publisher=s.UNDEFINED_PUBLISHER),ie=ie??z.__metadata,delete z.__metadata;const q=(0,g.getGalleryExtensionId)(z.publisher,z.name),te=ie?.id?{id:q,uuid:ie.id}:{id:q},se=ie?.isSystem?s.ExtensionType.System:V.type,ce=se===s.ExtensionType.System||!!ie?.isBuiltin;z=await this.translateManifest(V.location,z,F.createNlsConfiguration(V));let W={type:se,identifier:te,manifest:z,location:V.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return V.validate&&(W=this.validate(W,V)),z.enabledApiProposals&&this.extensionsEnabledWithApiProposalVersion.includes(q.toLowerCase())&&(z.enabledApiProposals=(0,s.parseEnabledApiProposalNames)([...z.enabledApiProposals])),W}}catch(z){V.type!==s.ExtensionType.System&&this.logService.error(z)}return null}validate(V,ie){let z=!0;const q=this.extensionsEnabledWithApiProposalVersion.includes(V.identifier.id.toLowerCase()),te=(0,r.validateExtensionManifest)(ie.productVersion,ie.productDate,ie.location,V.manifest,V.isBuiltin,q);for(const[se,ce]of te)se===y.default.Error&&(z=!1,this.logService.error(this.formatMessage(ie.location,ce)));return V.isValid=z,V.validations=te,V}async scanExtensionManifest(V){const ie=(0,m.joinPath)(V,"package.json");let z;try{z=(await this.fileService.readFile(ie)).value.toString()}catch(te){return(0,t.toFileOperationResult)(te)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(V,(0,S.localize)(0,null,ie.path,te.message))),null}let q;try{q=JSON.parse(z)}catch{const se=[];(0,L.parse)(z,se);for(const ce of se)this.logService.error(this.formatMessage(V,(0,S.localize)(1,null,ie.path,ce.offset,ce.length,(0,_.getParseErrorMessage)(ce.error))));return null}return(0,L.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(V,(0,S.localize)(2,null,ie.path))),null):q}async translateManifest(V,ie,z){const q=await this.getLocalizedMessages(V,ie,z);if(q)try{const te=[],se=await this.resolveOriginalMessageBundle(q.default,te);if(te.length>0)return te.forEach(W=>{this.logService.error(this.formatMessage(V,(0,S.localize)(3,null,q.default?.path,(0,_.getParseErrorMessage)(W.error))))}),ie;if((0,L.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(V,(0,S.localize)(4,null,q.default?.path))),ie;const ce=q.values||Object.create(null);return(0,I.localizeManifest)(this.logService,ie,ce,se)}catch{}return ie}async getLocalizedMessages(V,ie,z){const q=(0,m.joinPath)(V,"package.nls.json"),te=(Q,G)=>{G.forEach(j=>{this.logService.error(this.formatMessage(V,(0,S.localize)(5,null,Q?.path,(0,_.getParseErrorMessage)(j.error))))})},se=Q=>{this.logService.error(this.formatMessage(V,(0,S.localize)(6,null,Q?.path)))},ce=`${ie.publisher}.${ie.name}`,W=z.translations[ce];if(W)try{const Q=f.URI.file(W),G=(await this.fileService.readFile(Q)).value.toString(),j=[],N=(0,L.parse)(G,j);return j.length>0?(te(Q,j),{values:void 0,default:q}):(0,L.getNodeType)(N)!=="object"?(se(Q),{values:void 0,default:q}):{values:N.contents?N.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let G;try{G=await this.findMessageBundles(V,z)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const j=(await this.fileService.readFile(G.localized)).value.toString(),N=[],Y=(0,L.parse)(j,N);return N.length>0?(te(G.localized,N),{values:void 0,default:G.original}):(0,L.getNodeType)(Y)!=="object"?(se(G.localized),{values:void 0,default:G.original}):{values:Y,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(V,ie){if(V)try{const z=(await this.fileService.readFile(V)).value.toString();return(0,L.parse)(z,ie)}catch{}}findMessageBundles(V,ie){return new Promise((z,q)=>{const te=se=>{const ce=(0,m.joinPath)(V,`package.nls.${se}.json`);this.fileService.exists(ce).then(W=>{W&&z({localized:ce,original:(0,m.joinPath)(V,"package.nls.json")});const Q=se.lastIndexOf("-");Q===-1?z({localized:(0,m.joinPath)(V,"package.nls.json"),original:null}):(se=se.substring(0,Q),te(se))})};if(ie.devMode||ie.pseudo||!ie.language)return z({localized:(0,m.joinPath)(V,"package.nls.json"),original:null});te(ie.language)})}formatMessage(V,ie){return`[${V.path}]: ${ie}`}};U=we([X(1,d.IExtensionsProfileScannerService),X(2,A.IUriIdentityService),X(3,t.IFileService),X(4,n.IProductService),X(5,i.ILogService)],U);let M=class extends U{constructor(V,ie,z,q,te,se,ce,W){super(ie,q,te,se,ce,W),this.currentProfile=V,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new c.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const ie=this.getCacheFile(V),z=await this.readExtensionCache(ie);if(this.input=V,z&&z.input&&F.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",V.type===s.ExtensionType.System?"system":"user",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(te=>(te.location=f.URI.revive(te.location),te));const q=await super.scanExtensions(V);return await this.writeExtensionCache(ie,{input:V,result:q}),q}async readExtensionCache(V){try{const ie=await this.fileService.readFile(V),z=JSON.parse(ie.value.toString());return{result:z.result,input:(0,u.revive)(z.input)}}catch(ie){this.logService.debug("Error while reading the extension cache file:",V.path,(0,O.getErrorMessage)(ie))}return null}async writeExtensionCache(V,ie){try{await this.fileService.writeFile(V,D.VSBuffer.fromString(JSON.stringify(ie)))}catch(z){this.logService.debug("Error while writing the extension cache file:",V.path,(0,O.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const V=this.getCacheFile(this.input),ie=await this.readExtensionCache(V);if(!ie)return;const z=ie.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(q,z))try{this.logService.info("Invalidating Cache",z,q),await this.fileService.del(V),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}getCacheFile(V){const ie=this.getProfile(V);return this.uriIdentityService.extUri.joinPath(ie.cacheHome,V.type===s.ExtensionType.System?s.BUILTIN_MANIFEST_CACHE_FILE:s.USER_MANIFEST_CACHE_FILE)}getProfile(V){return V.type===s.ExtensionType.System?this.userDataProfilesService.defaultProfile:V.profile?this.uriIdentityService.extUri.isEqual(V.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(ie=>this.uriIdentityService.extUri.isEqual(V.location,ie.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};M=we([X(2,b.IUserDataProfilesService),X(3,d.IExtensionsProfileScannerService),X(4,A.IUriIdentityService),X(5,t.IFileService),X(6,n.IProductService),X(7,i.ILogService)],M);function H(Z,V){const ie=(0,g.getExtensionId)(Z.manifest.publisher,Z.manifest.name);return{id:ie,identifier:new s.ExtensionIdentifier(ie),isBuiltin:Z.type===s.ExtensionType.System,isUserBuiltin:Z.type===s.ExtensionType.User&&Z.isBuiltin,isUnderDevelopment:V,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,publisherDisplayName:Z.publisherDisplayName,...Z.manifest}}class B extends k{constructor(V,ie,z,q,te,se,ce,W,Q,G,j,N){super(V,ie,(0,m.joinPath)(z,".vscode-oss-dev","extensions","control.json"),q,te,se,ce,W,Q,G,j,N),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const Y=await this.fileService.readFile(f.URI.file(h.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=B}),define(le[252],ue([0,1,70,6,41,3,2,23,14,31,10,20]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends O.Disposable{constructor(l,y){super(),this.userDataProfilesService=l,this.logService=y,this.processesLimiter=new c.Limiter(5)}async postUninstall(l){const y=this.parseScript(l,"uninstall");y&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,l),this.logService.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(w){this.logService.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.logService.error(w)}}));try{await v.Promises.rm(this.getExtensionStoragePath(l))}catch(w){this.logService.error("Error while removing extension storage path",l.identifier.id),this.logService.error(w)}}parseScript(l,y){const w=`vscode:${y}`;if(l.location.scheme===L.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[w]=="string"){const f=l.manifest.scripts[w].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${w} should be a node script`),null):{script:(0,_.join)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(l,y,w,f,S){return new Promise((R,g)=>{const s=this.start(l,y,w,S);let r;const t=o=>{r&&(clearTimeout(r),r=null),o?g(o):R(void 0)};s.on("error",o=>{t((0,T.toErrorMessage)(o)||"Unknown")}),s.on("exit",(o,i)=>{t(o?`post-${y} process exited with code ${o}`:void 0)}),f&&(r=setTimeout(()=>{r=null,s.kill(),g("timed out")},5e3))})}start(l,y,w,f){const S={silent:!0,execArgv:void 0},R=(0,C.fork)(l,[`--type=extension-post-${y}`,...w],S);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const g=D.Event.fromNodeEventEmitter(R.stdout,"data"),s=D.Event.fromNodeEventEmitter(R.stderr,"data");this._register(g(o=>this.logService.info(f.identifier.id,f.manifest.version,`post-${y}`,o))),this._register(s(o=>this.logService.error(f.identifier.id,f.manifest.version,`post-${y}`,o)));const r=D.Event.any(D.Event.map(g,o=>({data:`%c${o}`,format:[""]}),this._store),D.Event.map(s,o=>({data:`%c${o}`,format:["color: red"]}),this._store));return D.Event.debounce(r,(o,i)=>o?{data:o.data+i.data,format:[...o.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this._store)(o=>{console.group(f.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),R}getExtensionStoragePath(l){return(0,_.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=h,e.ExtensionsLifecycle=h=we([X(0,p.IUserDataProfilesService),X(1,P.ILogService)],h)}),define(le[117],ue([0,1,73,167,84,28]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=O,e.getManifest=L;function O(_){let v=D.ExtensionManagementErrorCode.Extract;return _ instanceof C.ExtractError&&(_.type==="CorruptZip"?v=D.ExtensionManagementErrorCode.CorruptZip:_.type==="Incomplete"&&(v=D.ExtensionManagementErrorCode.IncompleteZip)),(0,T.toExtensionManagementError)(_,v)}async function L(_){let v;try{v=await(0,C.buffer)(_,"extension/package.json")}catch(P){throw O(P)}try{return JSON.parse(v.toString("utf8"))}catch{throw new D.ExtensionManagementError((0,c.localize)(0,null),D.ExtensionManagementErrorCode.Invalid)}}}),define(le[253],ue([0,1,6,8,2,23,21,61,32,31,73,22,16,84,28,33,117,111,7,10,18]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,L=De(L);let r=class extends T.Disposable{static{s=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(o,i,n,a,u,d,b){super(),this.fileService=i,this.extensionGalleryService=n,this.configurationService=a,this.extensionSignatureVerificationService=u,this.telemetryService=d,this.logService=b,this.extensionsDownloadDir=o.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(o,i,n,a){await this.cleanUpPromise;const u=await this.downloadVSIX(o,i);let d=!1;if(n&&this.shouldVerifySignature(o)){let b;try{b=await this.downloadSignatureArchive(o)}catch(A){try{await this.delete(u)}catch(I){this.logService.error(I)}throw A}try{d=await this.extensionSignatureVerificationService.verify(o,u.fsPath,b.fsPath,a)}catch(A){if(d=A.code,d===f.ExtensionSignatureVerificationCode.PackageIsInvalidZip||d===f.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(I){this.logService.error(I)}throw new l.ExtensionManagementError(P.CorruptZipMessage,l.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(b)}catch(A){this.logService.error(A)}}}return{location:u,verificationStatus:d}}shouldVerifySignature(o){return o.isSigned||this.logService.info(`Extension is not signed: ${o.identifier.id}`),!1}async downloadVSIX(o,i){try{const n=(0,O.joinPath)(this.extensionsDownloadDir,this.getName(o)),a=await this.doDownload(o,"vsix",async()=>{await this.downloadFile(o,n,u=>this.extensionGalleryService.download(o,u,i));try{await this.validate(n.fsPath,"extension/package.json")}catch(u){try{await this.fileService.del(n)}catch(d){this.logService.warn(`Error while deleting: ${n.path}`,(0,c.getErrorMessage)(d))}throw u}},2);return a>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:o.identifier.id,attempts:a}),n}catch(n){throw(0,m.toExtensionManagementError)(n,l.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(o){try{const i=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,_.generateUuid)()}`),n=await this.doDownload(o,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(o,i);try{await this.validate(i.fsPath,".signature.p7s")}catch(a){try{await this.fileService.del(i)}catch(u){this.logService.warn(`Error while deleting: ${i.path}`,(0,c.getErrorMessage)(u))}throw a}},2);return n>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:o.identifier.id,attempts:n}),i}catch(i){throw(0,m.toExtensionManagementError)(i,l.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(o,i,n){if(await this.fileService.exists(i))return;if(i.scheme!==D.Schemas.file){await n(i);return}const a=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,_.generateUuid)()}`);try{await n(a)}catch(u){try{await this.fileService.del(a)}catch{}throw u}try{await v.Promises.rename(a.fsPath,i.fsPath,2*60*1e3)}catch(u){try{await this.fileService.del(a)}catch{}let d=!1;try{d=await this.fileService.exists(i)}catch{}if(d)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",o.identifier.id,i.path);else throw this.logService.info(`Rename failed because of ${(0,c.getErrorMessage)(u)}. Deleted the file from downloaded location`,a.path),u}}async doDownload(o,i,n,a){let u=1;for(;;)try{return await n(),u}catch(d){if(u++>a)throw d;this.logService.warn(`Failed downloading ${i}. ${(0,c.getErrorMessage)(d)}. Retry again...`,o.identifier.id)}}async validate(o,i){try{await(0,P.buffer)(o,i)}catch(n){throw(0,w.fromExtractError)(n)}}async delete(o){await this.cleanUpPromise,await this.fileService.del(o)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const o=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(o.children){const i=[],n=[],a=[];for(const b of o.children)if(b.name.endsWith(s.SignatureArchiveExtension))a.push(b.resource);else{const A=y.ExtensionKey.parse(b.name);A&&n.push([A,b])}const u=(0,y.groupByExtension)(n,([b])=>b),d=[];for(const b of u)b.sort((A,I)=>L.rcompare(A[0].version,I[0].version)),i.push(...b.slice(1).map(A=>A[1].resource)),d.push(b[0][1]);d.sort((b,A)=>b.mtime-A.mtime),i.push(...d.slice(0,Math.max(0,d.length-this.cache)).map(b=>b.resource)),i.push(...a),await C.Promises.settled(i.map(b=>(this.logService.trace("Deleting from cache",b.path),this.fileService.del(b))))}}catch(o){this.logService.error(o)}}getName(o){return this.cache?y.ExtensionKey.create(o).toString().toLowerCase():(0,_.generateUuid)()}};e.ExtensionsDownloader=r,e.ExtensionsDownloader=r=s=we([X(0,h.INativeEnvironmentService),X(1,S.IFileService),X(2,l.IExtensionGalleryService),X(3,p.IConfigurationService),X(4,f.IExtensionSignatureVerificationService),X(5,g.ITelemetryService),X(6,R.ILogService)],r)}),define(le[118],ue([0,1,6,15,26,41,8,3,56,2,35,23,14,21,61,13,9,32,31,73,166,99,16,84,28,33,53,85,253,252,117,225,235,36,60,7,4,10,24,18,29,20]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t,o,i,n,a,u,d,b,A,I,E,k,F,U,M,H,B,Z,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,h=De(h),l=De(l),S=De(S),g=De(g),e.INativeServerExtensionManagementService=(0,U.refineServiceDecorator)(o.IExtensionManagementService);const ie=".vsctmp";let z=class extends t.AbstractExtensionManagementService{constructor(W,Q,G,j,N,Y,$,x,J,ee,K,oe){super(W,Q,K,G,ee,oe),this.extensionsScannerService=N,this.extensionsProfileScannerService=Y,this.downloadService=$,this.instantiationService=x,this.fileService=J,this.extractingGalleryExtensions=new Map,this.knownDirectories=new P.ResourceSet;const he=this._register(x.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(q,Se=>he.postUninstall(Se))),this.manifestCache=this._register(new A.ExtensionsManifestCache(oe,J,K,this,this.logService)),this.extensionsDownloader=this._register(x.createInstance(u.ExtensionsDownloader));const ge=this._register(new I.ExtensionsWatcher(this,this.extensionsScannerService,oe,Y,K,J,G));this._register(ge.onDidChangeExtensionsByAnotherSource(Se=>this.onDidChangeExtensionsFromAnotherSource(Se))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const Q=await this.collectFiles(W),G=await(0,R.zip)((0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,Q);return w.URI.file(G)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:Q,cleanup:G}=await this.downloadVsix(W),j=h.resolve(Q.fsPath);try{return await(0,b.getManifest)(j)}finally{await G()}}getInstalled(W,Q=this.userDataProfilesService.defaultProfile.extensionsResource,G={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(W??null,Q,G)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.extensionsScanner.scanUserExtensionAtLocation(W)}async install(W,Q={}){this.logService.trace("ExtensionManagementService#install",W.toString());const{location:G,cleanup:j}=await this.downloadVsix(W);try{const N=await(0,b.getManifest)(h.resolve(G.fsPath)),Y=(0,i.getGalleryExtensionId)(N.publisher,N.name);if(N.engines&&N.engines.vscode&&!(0,k.isEngineValid)(N.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,Y,this.productService.version));const x=(await this.installExtensions([{manifest:N,extension:G,options:Q}])).find(({identifier:J})=>(0,i.areSameExtensions)(J,{id:Y}));if(x?.local)return x.local;throw x?.error?x.error:(0,t.toExtensionManagementError)(new Error(`Unknown error while installing extension ${Y}`))}finally{await j()}}async installFromLocation(W,Q){this.logService.trace("ExtensionManagementService#installFromLocation",W.toString());const G=await this.extensionsScanner.scanUserExtensionAtLocation(W);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.addExtensionsToProfile([[G,{source:"resource"}]],Q),this.logService.info("Successfully installed extension",G.identifier.id,Q.toString()),G}async installExtensionsFromProfile(W,Q,G){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",W,Q.toString(),G.toString());const j=(await this.getInstalled(E.ExtensionType.User,Q)).filter(N=>W.some(Y=>(0,i.areSameExtensions)(Y,N.identifier)));if(j.length){const N=await Promise.all(j.map(Y=>this.extensionsScanner.scanMetadata(Y,Q)));await this.addExtensionsToProfile(j.map((Y,$)=>[Y,N[$]]),G),this.logService.info("Successfully installed extensions",j.map(Y=>Y.identifier.id),G.toString())}return j}async updateMetadata(W,Q,G){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),Q.isPreReleaseVersion&&(Q.preRelease=!0,Q.hasPreReleaseVersion=!0),Q.isMachineScoped===!1&&(Q.isMachineScoped=void 0),Q.isBuiltin===!1&&(Q.isBuiltin=void 0),Q.pinned===!1&&(Q.pinned=void 0),W=await this.extensionsScanner.updateMetadata(W,Q,G),this.manifestCache.invalidate(G),this._onDidUpdateExtensionMetadata.fire({local:W,profileLocation:G}),W}async reinstallFromGallery(W){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const Q=await this.getTargetPlatform(),[G]=await this.galleryService.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:Q,compatible:!0},T.CancellationToken.None);if(!G)throw new Error(g.localize(2,null));await this.extensionsScanner.setUninstalled(W);try{await this.extensionsScanner.removeUninstalledExtension(W)}catch(j){throw new Error(g.localize(3,null,(0,D.toErrorMessage)(j)))}return this.installFromGallery(G)}copyExtension(W,Q,G,j){return this.extensionsScanner.copyExtension(W,Q,G,j)}copyExtensions(W,Q){return this.extensionsScanner.copyExtensions(W,Q,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...W){return this.extensionsScanner.setUninstalled(...W)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(W){this.logService.error(W)}}async download(W,Q,G){const{location:j}=await this.extensionsDownloader.download(W,Q,!G);return j}async downloadVsix(W){if(W.scheme===p.Schemas.file)return{location:W,async cleanup(){}};this.logService.trace("Downloading extension from",W.toString());const Q=(0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,f.generateUuid)());return await this.downloadService.download(W,Q),this.logService.info("Downloaded extension to",Q.toString()),{location:Q,cleanup:async()=>{try{await this.fileService.del(Q)}catch(j){this.logService.error(j)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(W,Q,G){const j=Q instanceof w.URI?new i.ExtensionKey({id:(0,i.getGalleryExtensionId)(W.publisher,W.name)},W.version):i.ExtensionKey.create(Q);return this.instantiationService.createInstance(te,j,W,Q,G,(N,Y)=>{if(Q instanceof w.URI)return this.extractVSIX(j,Q,G,Y);let $=this.extractingGalleryExtensions.get(j.toString());return $||(this.extractingGalleryExtensions.set(j.toString(),$=this.downloadAndExtractGalleryExtension(j,Q,N,G,Y)),$.finally(()=>this.extractingGalleryExtensions.delete(j.toString()))),$},this.extensionsScanner)}createUninstallExtensionTask(W,Q){return new se(W,Q.profileLocation,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(W,Q,G,j,N){const{verificationStatus:Y,location:$}=await this.extensionsDownloader.download(Q,G,!j.donotVerifySignature,j.context?.[o.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(N.isCancellationRequested)throw new O.CancellationError;return await(0,b.getManifest)($.fsPath),{local:await this.extensionsScanner.extractUserExtension(W,$.fsPath,{id:Q.identifier.uuid,publisherId:Q.publisherId,publisherDisplayName:Q.publisherDisplayName,targetPlatform:Q.properties.targetPlatform,isApplicationScoped:j.isApplicationScoped,isMachineScoped:j.isMachineScoped,isBuiltin:j.isBuiltin,isPreReleaseVersion:Q.properties.isPreReleaseVersion,hasPreReleaseVersion:Q.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:j.installGivenVersion?!0:!!j.pinned,preRelease:(0,y.isBoolean)(j.preRelease)?j.preRelease:j.installPreReleaseVersion||Q.properties.isPreReleaseVersion,source:"gallery"},!1,N),verificationStatus:Y}}catch(x){try{await this.extensionsDownloader.delete($)}catch(J){this.logService.warn("Error while deleting the downloaded file",$.toString(),(0,O.getErrorMessage)(J))}throw(0,t.toExtensionManagementError)(x)}}async extractVSIX(W,Q,G,j){return{local:await this.extensionsScanner.extractUserExtension(W,h.resolve(Q.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},!0,j)}}async collectFiles(W){const Q=async j=>{let N=await S.Promises.readdir(j);N=N.map(x=>h.join(j,x));const Y=await Promise.all(N.map(x=>S.Promises.stat(x)));let $=Promise.resolve([]);return Y.forEach((x,J)=>{const ee=N[J];x.isFile()&&($=$.then(K=>[...K,ee])),x.isDirectory()&&($=$.then(K=>Q(ee).then(oe=>[...K,...oe])))}),$};return(await Q(W.location.fsPath)).map(j=>({path:`extension/${h.relative(W.location.fsPath,j)}`,localPath:j}))}async onDidChangeExtensionsFromAnotherSource({added:W,removed:Q}){if(Q){const G=W&&this.uriIdentityService.extUri.isEqual(Q.profileLocation,W.profileLocation)?Q.extensions.filter(j=>W.extensions.every(N=>!(0,i.areSameExtensions)(N,j))):Q.extensions;for(const j of G)this.logService.info("Extensions removed from another source",j.id,Q.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:j,profileLocation:Q.profileLocation})}if(W){const j=(await this.getInstalled(E.ExtensionType.User,W.profileLocation)).filter(N=>W.extensions.some(Y=>(0,i.areSameExtensions)(Y,N.identifier)));this._onDidInstallExtensions.fire(j.map(N=>(this.logService.info("Extensions added from another source",N.identifier.id,W.profileLocation.toString()),{identifier:N.identifier,local:N,profileLocation:W.profileLocation,operation:o.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(Q=>this.knownDirectories.add(Q)));const W=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const Q of W.children??[])Q.isDirectory&&this.knownDirectories.add(Q.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(Q=>this.onDidFilesChange(Q)))}async onDidFilesChange(W){if(!W.affects(this.extensionsScannerService.userExtensionsLocation,F.FileChangeType.ADDED))return;const Q=[];for(const G of W.rawAdded){if(this.knownDirectories.has(G)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(G),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(G,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(G).startsWith(".")||!(await this.fileService.stat(G)).isDirectory)continue;const j=await this.extensionsScanner.scanUserExtensionAtLocation(G);j&&j.installedTimestamp===void 0&&(this.knownDirectories.add(G),Q.push(j))}Q.length&&(await this.addExtensionsToProfile(Q.map(G=>[G,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",Q.map(G=>G.identifier.id)))}async addExtensionsToProfile(W,Q){const G=W.map(j=>j[0]);await this.setInstalled(G),await this.extensionsProfileScannerService.addExtensionsToProfile(W,Q),this._onDidInstallExtensions.fire(G.map(j=>({local:j,identifier:j.identifier,operation:o.InstallOperation.None,profileLocation:Q})))}async setInstalled(W){const Q=await this.extensionsScanner.getUninstalledExtensions();for(const G of W){const j=i.ExtensionKey.create(G);Q[j.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",j.id),await this.extensionsScanner.setInstalled(j),this.logService.info("Removed the extension from uninstalled list:",j.id))}}};e.ExtensionManagementService=z,e.ExtensionManagementService=z=we([X(0,o.IExtensionGalleryService),X(1,B.ITelemetryService),X(2,M.ILogService),X(3,r.INativeEnvironmentService),X(4,a.IExtensionsScannerService),X(5,n.IExtensionsProfileScannerService),X(6,s.IDownloadService),X(7,U.IInstantiationService),X(8,F.IFileService),X(9,H.IProductService),X(10,Z.IUriIdentityService),X(11,V.IUserDataProfilesService)],z);let q=class extends v.Disposable{constructor(W,Q,G,j,N,Y,$){super(),this.beforeRemovingExtension=W,this.fileService=Q,this.extensionsScannerService=G,this.extensionsProfileScannerService=j,this.uriIdentityService=N,this.telemetryService=Y,this.logService=$,this._onExtract=this._register(new L.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new P.ResourceMap,this.scanUserExtensionsPromise=new P.ResourceMap,this.uninstalledResource=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(W,Q,G){try{const j={includeInvalid:!0,profileLocation:Q,productVersion:G};let N=[];if(W===null||W===E.ExtensionType.System){let Y=this.scanAllExtensionPromise.get(Q);Y||(Y=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},j,!1).finally(()=>this.scanAllExtensionPromise.delete(Q)),this.scanAllExtensionPromise.set(Q,Y)),N.push(...await Y)}else if(W===E.ExtensionType.User){let Y=this.scanUserExtensionsPromise.get(Q);Y||(Y=this.extensionsScannerService.scanUserExtensions(j).finally(()=>this.scanUserExtensionsPromise.delete(Q)),this.scanUserExtensionsPromise.set(Q,Y)),N.push(...await Y)}return N=W!==null?N.filter(Y=>Y.type===W):N,await Promise.all(N.map(Y=>this.toLocalExtension(Y)))}catch(j){throw(0,t.toExtensionManagementError)(j,o.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(W){try{const Q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return await Promise.all(Q.map(G=>this.toLocalExtension(G)))}catch(Q){throw(0,t.toExtensionManagementError)(Q,o.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(W){try{const Q=await this.extensionsScannerService.scanExistingExtension(W,E.ExtensionType.User,{includeInvalid:!0});if(Q)return await this.toLocalExtension(Q)}catch(Q){this.logService.error(Q)}return null}async extractUserExtension(W,Q,G,j,N){const Y=W.toString(),$=w.URI.file(h.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`)),x=w.URI.file(h.join(this.extensionsScannerService.userExtensionsLocation.fsPath,Y));let J=await this.fileService.exists(x);if(J&&j){try{await this.deleteExtensionFromLocation(W.id,x,"removeExisting")}catch{throw new o.ExtensionManagementError(g.localize(4,null,x.fsPath,W.id),o.ExtensionManagementErrorCode.Delete)}J=!1}if(J)try{await this.extensionsScannerService.updateMetadata(x,G)}catch(ee){throw this.telemetryService.publicLog2("extension:extract",{extensionId:W.id,code:`${(0,F.toFileOperationResult)(ee)}`}),(0,t.toExtensionManagementError)(ee,o.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(N.isCancellationRequested)throw new O.CancellationError;try{this.logService.trace(`Started extracting the extension from ${Q} to ${x.fsPath}`),await(0,R.extract)(Q,$.fsPath,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${x}:`,W.id)}catch(ee){throw(0,b.fromExtractError)(ee)}try{await this.extensionsScannerService.updateMetadata($,G)}catch(ee){throw this.telemetryService.publicLog2("extension:extract",{extensionId:W.id,code:`${(0,F.toFileOperationResult)(ee)}`}),(0,t.toExtensionManagementError)(ee,o.ExtensionManagementErrorCode.UpdateMetadata)}if(N.isCancellationRequested)throw new O.CancellationError;try{this.logService.trace(`Started renaming the extension from ${$.fsPath} to ${x.fsPath}`),await this.rename($.fsPath,x.fsPath),this.logService.info("Renamed to",x.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);try{await this.fileService.del($,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(ee)}. Deleted from extracted location`,$),ee}this._onExtract.fire(x)}catch(ee){try{await this.fileService.del($,{recursive:!0})}catch{}throw ee}return this.scanLocalExtension(x,E.ExtensionType.User)}async scanMetadata(W,Q){return Q?(await this.getScannedExtension(W,Q))?.metadata:this.extensionsScannerService.scanMetadata(W.location)}async getScannedExtension(W,Q){return(await this.extensionsProfileScannerService.scanProfileExtensions(Q)).find(j=>(0,i.areSameExtensions)(j.identifier,W.identifier))}async updateMetadata(W,Q,G){try{G?await this.extensionsProfileScannerService.updateMetadata([[W,Q]],G):await this.extensionsScannerService.updateMetadata(W.location,Q)}catch(j){throw this.telemetryService.publicLog2("extension:extract",{extensionId:W.identifier.id,code:`${(0,F.toFileOperationResult)(j)}`}),(0,t.toExtensionManagementError)(j,o.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(W.location,W.type,G)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(W){throw(0,t.toExtensionManagementError)(W,o.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...W){const Q=W.map(G=>i.ExtensionKey.create(G));await this.withUninstalledExtensions(G=>Q.forEach(j=>{G[j.toString()]=!0,this.logService.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(W){try{await this.withUninstalledExtensions(Q=>delete Q[W.toString()])}catch(Q){throw(0,t.toExtensionManagementError)(Q,o.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(W,Q){if(this.uriIdentityService.extUri.isEqualOrParent(W.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(W.identifier.id,W.location,Q)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.withUninstalledExtensions(Q=>delete Q[i.ExtensionKey.create(W).toString()])}async copyExtension(W,Q,G,j){const N=await this.getScannedExtension(W,Q),Y=await this.getScannedExtension(W,G);if(j={...N?.metadata,...j},Y)if(this.uriIdentityService.extUri.isEqual(Y.location,W.location))await this.extensionsProfileScannerService.updateMetadata([[W,{...Y.metadata,...j}]],G);else{const $=await this.scanLocalExtension(Y.location,W.type,G);await this.extensionsProfileScannerService.removeExtensionFromProfile($,G),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,{...Y.metadata,...j}]],G)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[W,j]],G);return this.scanLocalExtension(W.location,W.type,G)}async copyExtensions(W,Q,G){const j=await this.scanExtensions(E.ExtensionType.User,W,G),N=await Promise.all(j.filter(Y=>!Y.isApplicationScoped).map(async Y=>[Y,await this.scanMetadata(Y,W)]));await this.extensionsProfileScannerService.addExtensionsToProfile(N,Q)}async deleteExtensionFromLocation(W,Q,G){this.logService.trace(`Deleting ${G} extension from disk`,W,Q.fsPath);const j=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(Q),`${this.uriIdentityService.extUri.basename(Q)}.${(0,_.hash)((0,f.generateUuid)()).toString(16)}${ie}`);await this.rename(Q.fsPath,j.fsPath),await this.fileService.del(j,{recursive:!0}),this.logService.info(`Deleted ${G} extension from disk`,W,Q.fsPath)}withUninstalledExtensions(W){return this.uninstalledFileLimiter.queue(async()=>{let Q;try{Q=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(j){if((0,F.toFileOperationResult)(j)!==F.FileOperationResult.FILE_NOT_FOUND)throw j}let G={};if(Q)try{G=JSON.parse(Q)}catch{}return W&&(W(G),Object.keys(G).length?await this.fileService.writeFile(this.uninstalledResource,c.VSBuffer.fromString(JSON.stringify(G))):await this.fileService.del(this.uninstalledResource)),G})}async rename(W,Q){try{await S.Promises.rename(W,Q,2*60*1e3)}catch(G){throw(0,t.toExtensionManagementError)(G,o.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,Q,G){try{if(G){const N=(await this.extensionsScannerService.scanUserExtensions({profileLocation:G})).find(Y=>this.uriIdentityService.extUri.isEqual(Y.location,W));if(N)return await this.toLocalExtension(N)}else{const j=await this.extensionsScannerService.scanExistingExtension(W,Q,{includeInvalid:!0});if(j)return await this.toLocalExtension(j)}throw new o.ExtensionManagementError(g.localize(5,null,W.path),o.ExtensionManagementErrorCode.ScanningExtension)}catch(j){throw(0,t.toExtensionManagementError)(j,o.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(W){const Q=await this.fileService.resolve(W.location);let G,j;return Q.children&&(G=Q.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,j=Q.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:G,changelogUrl:j,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(W));const Q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const N of Q)W[i.ExtensionKey.create(N).toString()]||G.add(N.identifier.id.toLowerCase());try{const N=(0,i.groupByExtension)(Q,Y=>Y.identifier);await C.Promises.settled(N.map(async Y=>{const $=Y.sort((x,J)=>l.rcompare(x.manifest.version,J.manifest.version))[0];G.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension($))}))}catch(N){this.logService.error(N)}const j=Q.filter(N=>N.metadata&&W[i.ExtensionKey.create(N).toString()]);await Promise.allSettled(j.map(N=>this.removeUninstalledExtension(N)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(Q){(0,F.toFileOperationResult)(Q)!==F.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(Q);return}if(W?.children)try{await Promise.allSettled(W.children.map(async Q=>{if(!(!Q.isDirectory||!Q.name.endsWith(ie))){this.logService.trace("Deleting the temporarily deleted folder",Q.resource.toString());try{await this.fileService.del(Q.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",Q.resource.toString())}catch(G){(0,F.toFileOperationResult)(G)!==F.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(G)}}}))}catch{}}};e.ExtensionsScanner=q,e.ExtensionsScanner=q=we([X(1,F.IFileService),X(2,a.IExtensionsScannerService),X(3,n.IExtensionsProfileScannerService),X(4,Z.IUriIdentityService),X(5,B.ITelemetryService),X(6,M.ILogService)],q);let te=class extends t.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(W,Q,G,j,N,Y,$,x,J,ee,K,oe){super(),this.extensionKey=W,this.manifest=Q,this.source=G,this.options=j,this.extractExtensionFn=N,this.extensionsScanner=Y,this.uriIdentityService=$,this.galleryService=x,this.userDataProfilesService=J,this.extensionsScannerService=ee,this.extensionsProfileScannerService=K,this.logService=oe,this._operation=o.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(W){const G=(await this.extensionsScanner.scanExtensions(E.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find($=>(0,i.areSameExtensions)($.identifier,this.identifier));G&&(this._operation=o.InstallOperation.Update);const j={isApplicationScoped:this.options.isApplicationScoped||G?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||G?.isMachineScoped,isBuiltin:this.options.isBuiltin||G?.isBuiltin,isSystem:G?.type===E.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??G?.pinned,source:this.source instanceof w.URI?"vsix":"gallery"};let N;if(this.source instanceof w.URI){if(G&&this.extensionKey.equals(new i.ExtensionKey(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}const $=await this.unsetIfUninstalled(this.extensionKey);if($)try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(j.id=this.source.identifier.uuid,j.publisherId=this.source.publisherId,j.publisherDisplayName=this.source.publisherDisplayName,j.targetPlatform=this.source.properties.targetPlatform,j.updated=!!G,j.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,j.hasPreReleaseVersion=G?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,j.preRelease=(0,y.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||G?.preRelease,G&&G.type!==E.ExtensionType.System&&G.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(G,j,this.options.profileLocation);N=await this.unsetIfUninstalled(this.extensionKey)}if(W.isCancellationRequested)throw(0,t.toExtensionManagementError)(new O.CancellationError);if(!N){const $=await this.extractExtensionFn(this.operation,W);N=$.local,this._verificationStatus=$.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch($){throw(0,t.toExtensionManagementError)($,o.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(W.isCancellationRequested)throw(0,t.toExtensionManagementError)(new O.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[N,j]],this.options.profileLocation,!N.isValid)}catch($){throw(0,t.toExtensionManagementError)($,o.ExtensionManagementErrorCode.AddToProfile)}const Y=await this.extensionsScanner.scanLocalExtension(N.location,E.ExtensionType.User,this.options.profileLocation);if(!Y)throw new o.ExtensionManagementError("Cannot find the installed extension",o.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof w.URI&&this.updateMetadata(N,W),Y}async unsetIfUninstalled(W){return(await this.extensionsScanner.getUninstalledExtensions())[W.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",W.id),await this.extensionsScanner.setInstalled(W),this.logService.info("Removed the extension from uninstalled list:",W.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(j=>i.ExtensionKey.create(j).equals(W))):void 0}async updateMetadata(W,Q){try{let[G]=await this.galleryService.getExtensions([{id:W.identifier.id,version:W.manifest.version}],Q);if(G||([G]=await this.galleryService.getExtensions([{id:W.identifier.id}],Q)),G){const j={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(W,j,this.options.profileLocation)}}catch{}}};te=we([X(6,Z.IUriIdentityService),X(7,o.IExtensionGalleryService),X(8,V.IUserDataProfilesService),X(9,a.IExtensionsScannerService),X(10,n.IExtensionsProfileScannerService),X(11,M.ILogService)],te);class se extends t.AbstractExtensionTask{constructor(W,Q,G){super(),this.extension=W,this.profileLocation=Q,this.extensionsProfileScannerService=G}async doRun(W){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[254],ue([0,1,10,20,29,18,53,7,16,9]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends O.AbstractExtensionsProfileScannerService{constructor(h,m,l,y,w,f){super(v.URI.file(h.extensionsPath),m,l,y,w,f)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=we([X(0,_.INativeEnvironmentService),X(1,L.IFileService),X(2,c.IUserDataProfilesService),X(3,T.IUriIdentityService),X(4,D.ITelemetryService),X(5,C.ILogService)],P)}),define(le[255],ue([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends D.NativeExtensionsScannerService{constructor(l,y,w,f,S,R,g,s){super(C.URI.file(S.builtinExtensionsPath),C.URI.file(S.extensionsPath),S.userHome,l.defaultProfile,l,y,w,f,S,R,g,s)}};e.ExtensionsScannerService=h,e.ExtensionsScannerService=h=we([X(0,p.IUserDataProfilesService),X(1,T.IExtensionsProfileScannerService),X(2,O.IFileService),X(3,_.ILogService),X(4,c.INativeEnvironmentService),X(5,v.IProductService),X(6,P.IUriIdentityService),X(7,L.IInstantiationService)],h)}),define(le[17],ue([0,1,6,3,2,101,13,72,4,20]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=m,e.isProfileUsingDefaultStorage=y,e.logStorage=f,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,_.createDecorator)("storageService");var P;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var p;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var h;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function m(S){const R=S.get(e.TARGET_KEY);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class l extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(R={flushInterval:l.DEFAULT_FLUSH_INTERVAL}){super(),this.options=R,this._onDidChangeValue=this._register(new c.PauseableEmitter),this._onDidChangeTarget=this._register(new c.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new c.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(R,g,s){return c.Event.filter(this._onDidChangeValue.event,r=>r.scope===R&&(g===void 0||r.key===g),s)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(R,g){const{key:s,external:r}=g;if(s===e.TARGET_KEY){switch(R){case p.APPLICATION:this._applicationKeyTargets=void 0;break;case p.PROFILE:this._profileKeyTargets=void 0;break;case p.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:R})}else this._onDidChangeValue.fire({scope:R,key:s,target:this.getKeyTargets(R)[s],external:r})}emitWillSaveState(R){this._onWillSaveState.fire({reason:R})}get(R,g,s){return this.getStorage(g)?.get(R,s)}getBoolean(R,g,s){return this.getStorage(g)?.getBoolean(R,s)}getNumber(R,g,s){return this.getStorage(g)?.getNumber(R,s)}getObject(R,g,s){return this.getStorage(g)?.getObject(R,s)}storeAll(R,g){this.withPausedEmitters(()=>{for(const s of R)this.store(s.key,s.value,s.scope,s.target,g)})}store(R,g,s,r,t=!1){if((0,O.isUndefinedOrNull)(g)){this.remove(R,s,t);return}this.withPausedEmitters(()=>{this.updateKeyTarget(R,s,r),this.getStorage(s)?.set(R,g,t)})}remove(R,g,s=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(R,g,void 0),this.getStorage(g)?.delete(R,s)})}withPausedEmitters(R){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{R()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(R,g){const s=[],r=this.getKeyTargets(R);for(const t of Object.keys(r))r[t]===g&&s.push(t);return s}updateKeyTarget(R,g,s,r=!1){const t=this.getKeyTargets(g);typeof s=="number"?t[R]!==s&&(t[R]=s,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(t),r)):typeof t[R]=="number"&&(delete t[R],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(t),r))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(p.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(p.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(p.APPLICATION)),this._applicationKeyTargets}getKeyTargets(R){switch(R){case p.APPLICATION:return this.applicationKeyTargets;case p.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(R){const g=this.getStorage(R);return g?m(g):Object.create(null)}isNew(R){return this.getBoolean(e.IS_NEW_KEY,R)===!0}async flush(R=P.NONE){this._onWillSaveState.fire({reason:R});const g=this.getStorage(p.APPLICATION),s=this.getStorage(p.PROFILE),r=this.getStorage(p.WORKSPACE);switch(R){case P.NONE:await C.Promises.settled([g?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await C.Promises.settled([g?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.getStorage(p.APPLICATION)?.items??new Map,g=this.getStorage(p.PROFILE)?.items??new Map,s=this.getStorage(p.WORKSPACE)?.items??new Map;return f(R,g,s,this.getLogDetails(p.APPLICATION)??"",this.getLogDetails(p.PROFILE)??"",this.getLogDetails(p.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.getStorage(R)?.optimize()}async switch(R,g){return this.emitWillSaveState(P.NONE),(0,v.isUserDataProfile)(R)?this.switchToProfile(R,g):this.switchToWorkspace(R,g)}canSwitchProfile(R,g){return!(R.id===g.id||y(g)&&y(R))}switchData(R,g,s){this.withPausedEmitters(()=>{const r=new Set;for(const[t,o]of R)r.add(t),g.get(t)!==o&&this.emitDidChangeValue(s,{key:t,external:!0});for(const[t]of g.items)r.has(t)||this.emitDidChangeValue(s,{key:t,external:!0})})}}e.AbstractStorageService=l;function y(S){return S.isDefault||!!S.useDefaultFlags?.globalState}class w extends l{constructor(){super(),this.applicationStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(R=>this.emitDidChangeValue(p.WORKSPACE,R))),this._register(this.profileStorage.onDidChangeStorage(R=>this.emitDidChangeValue(p.PROFILE,R))),this._register(this.applicationStorage.onDidChangeStorage(R=>this.emitDidChangeValue(p.APPLICATION,R)))}getStorage(R){switch(R){case p.APPLICATION:return this.applicationStorage;case p.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(R){switch(R){case p.APPLICATION:return"inMemory (application)";case p.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(R){return!1}}e.InMemoryStorageService=w;async function f(S,R,g,s,r,t){const o=E=>{try{return JSON.parse(E)}catch{return E}},i=new Map,n=new Map;S.forEach((E,k)=>{i.set(k,E),n.set(k,o(E))});const a=new Map,u=new Map;R.forEach((E,k)=>{a.set(k,E),u.set(k,o(E))});const d=new Map,b=new Map;g.forEach((E,k)=>{d.set(k,E),b.set(k,o(E))}),console.group(s!==r?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const A=[];if(i.forEach((E,k)=>{A.push({key:k,value:E})}),console.table(A),console.groupEnd(),console.log(n),s!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const E=[];a.forEach((k,F)=>{E.push({key:F,value:k})}),console.table(E),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${t})`);const I=[];d.forEach((E,k)=>{I.push({key:k,value:E})}),console.table(I),console.groupEnd(),console.log(b)}}),define(le[119],ue([0,1,3,2,13,28,33,17]),function(ne,e,C,c,T,D,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let _=class extends c.Disposable{constructor(p,h){super(),this._onDidChangeEnablement=new C.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(p)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"}))),this._register(h.onDidInstallExtensions(m=>m.forEach(({local:l,operation:y})=>{l&&y===D.InstallOperation.Migrate&&this._removeFromDisabledExtensions(l.identifier)})))}async enableExtension(p,h){return this._removeFromDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:h}),!0):!1}async disableExtension(p,h){return this._addToDisabledExtensions(p)?(this._onDidChangeEnablement.fire({extensions:[p],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(D.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(p){const h=this.getDisabledExtensions();return h.every(m=>!(0,O.areSameExtensions)(m,p))?(h.push(p),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(p){const h=this.getDisabledExtensions();for(let m=0;m<h.length;m++){const l=h[m];if((0,O.areSameExtensions)(l,p))return h.splice(m,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(p){this._setExtensions(D.DISABLED_EXTENSIONS_STORAGE_PATH,p)}_getExtensions(p){return this.storageManger.get(p,L.StorageScope.PROFILE)}_setExtensions(p,h){this.storageManger.set(p,h,L.StorageScope.PROFILE)}};e.GlobalExtensionEnablementService=_,e.GlobalExtensionEnablementService=_=we([X(0,L.IStorageService),X(1,D.IExtensionManagementService)],_);class v extends c.Disposable{constructor(p){super(),this.storageService=p,this.storage=Object.create(null),this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this._register(p.onDidChangeValue(L.StorageScope.PROFILE,void 0,this._register(new c.DisposableStore))(h=>this.onDidStorageChange(h)))}get(p,h){let m;return h===L.StorageScope.PROFILE?((0,T.isUndefinedOrNull)(this.storage[p])&&(this.storage[p]=this._get(p,h)),m=this.storage[p]):m=this._get(p,h),JSON.parse(m)}set(p,h,m){const l=JSON.stringify(h.map(({id:w,uuid:f})=>({id:w,uuid:f})));this._get(p,m)!==l&&(m===L.StorageScope.PROFILE&&(h.length?this.storage[p]=l:delete this.storage[p]),this._set(p,h.length?l:void 0,m))}onDidStorageChange(p){if(!(0,T.isUndefinedOrNull)(this.storage[p.key])&&this._get(p.key,p.scope)!==this.storage[p.key]){const m=this.get(p.key,p.scope);delete this.storage[p.key];const l=this.get(p.key,p.scope),y=m.filter(f=>!l.some(S=>(0,O.areSameExtensions)(f,S))),w=l.filter(f=>!m.some(S=>(0,O.areSameExtensions)(S,f)));(y.length||w.length)&&this._onDidChange.fire([...y,...w])}}_get(p,h){return this.storageService.get(p,h,"[]")}_set(p,h,m){h?this.storageService.store(p,h,m,L.StorageTarget.MACHINE):this.storageService.remove(p,m)}}e.StorageManager=v}),define(le[86],ue([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,C.createDecorator)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class extends T.Disposable{static{p=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(y){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const w=h.exec(y);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(y,w){const f=await y.getInstalled(),S=[];for(const[R,g]of p.readAllExtensionsWithKeysForSync(w)){const s=f.find(r=>(0,O.areSameExtensions)(r.identifier,{id:R}))?.manifest.version;for(const r of g)s!==r&&S.push(p.toKey({id:R,version:r}))}for(const R of S)w.remove(R,D.StorageScope.PROFILE)}static readAllExtensionsWithKeysForSync(y){const w=new Map,f=y.keys(D.StorageScope.PROFILE,D.StorageTarget.MACHINE);for(const S of f){const R=p.fromKey(S);if(R){let g=w.get(R.id.toLowerCase());g||w.set(R.id.toLowerCase(),g=[]),g.push(R.version)}}return w}constructor(y,w,f){super(),this.storageService=y,this.productService=w,this.logService=f,this._onDidChangeExtensionStorageToSync=this._register(new c.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=p.readAllExtensionsWithKeysForSync(y),this._register(this.storageService.onDidChangeValue(D.StorageScope.PROFILE,void 0,this._register(new T.DisposableStore))(S=>this.onDidChangeStorageValue(S)))}onDidChangeStorageValue(y){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const w=p.fromKey(y.key);if(w){if(this.storageService.get(y.key,D.StorageScope.PROFILE)===void 0)this.extensionsWithKeysForSync.delete(w.id.toLowerCase());else{let f=this.extensionsWithKeysForSync.get(w.id.toLowerCase());f||this.extensionsWithKeysForSync.set(w.id.toLowerCase(),f=[]),f.push(w.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(y){if((0,P.isString)(y))return y;const w=y.manifest?y.manifest.publisher:y.publisher,f=y.manifest?y.manifest.name:y.name;return(0,O.getExtensionId)(w,f)}getExtensionState(y,w){const f=this.getExtensionId(y),S=this.getExtensionStateRaw(y,w);if(S)try{return JSON.parse(S)}catch(R){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${w}): ${R}`)}}getExtensionStateRaw(y,w){const f=this.getExtensionId(y),S=this.storageService.get(f,w?D.StorageScope.PROFILE:D.StorageScope.WORKSPACE);return S&&S?.length>p.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${w}): ${S.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),S}setExtensionState(y,w,f){const S=this.getExtensionId(y);w===void 0?this.storageService.remove(S,f?D.StorageScope.PROFILE:D.StorageScope.WORKSPACE):this.storageService.store(S,JSON.stringify(w),f?D.StorageScope.PROFILE:D.StorageScope.WORKSPACE,D.StorageTarget.MACHINE)}setKeysForSync(y,w){this.storageService.store(p.toKey(y),JSON.stringify(w),D.StorageScope.PROFILE,D.StorageTarget.MACHINE)}getKeysForSync(y){const w=this.productService.extensionSyncedKeys?.[y.id.toLowerCase()],f=this.storageService.get(p.toKey(y),D.StorageScope.PROFILE),S=f?JSON.parse(f):void 0;return S&&w?(0,_.distinct)([...S,...w]):S||w}addToMigrationList(y,w){if(y!==w){const f=this.migrationList.filter(S=>!S.includes(y)&&!S.includes(w));f.push([y,w]),this.migrationList=f}}getSourceExtensionToMigrate(y){const w=this.migrationList.find(([,f])=>y===f);return w?w[0]:void 0}get migrationList(){const y=this.storageService.get("extensionStorage.migrationList",D.StorageScope.APPLICATION,"[]");try{const w=JSON.parse(y);if(Array.isArray(w))return w}catch{}return[]}set migrationList(y){y.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(y),D.StorageScope.APPLICATION,D.StorageTarget.MACHINE):this.storageService.remove("extensionStorage.migrationList",D.StorageScope.APPLICATION)}};e.ExtensionStorageService=m,e.ExtensionStorageService=m=p=we([X(0,D.IStorageService),X(1,L.IProductService),X(2,v.ILogService)],m)}),define(le[256],ue([0,1,2,28,86,234,118,10,17]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let v=class extends C.Disposable{constructor(p,h,m,l,y,w){super(),p.cleanUp(),(0,D.migrateUnsupportedExtensions)(p,h,m,l,w),T.ExtensionStorageService.removeOutdatedExtensionVersions(p,y)}};e.ExtensionsContributions=v,e.ExtensionsContributions=v=we([X(0,O.INativeServerExtensionManagementService),X(1,c.IExtensionGalleryService),X(2,T.IExtensionStorageService),X(3,c.IGlobalExtensionEnablementService),X(4,_.IStorageService),X(5,L.ILogService)],v)}),define(le[257],ue([0,1,19,2,21,9,7,24,6,3,14,5,37,33,75,36,17]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let f=class extends c.Disposable{constructor(r,t){super(),this.fileService=r,this.productService=t,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,o])=>this.allConfigBasedTips.set(o.configPath,o))}getConfigBasedTips(r){return this.getValidConfigBasedTips(r)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(r){const t=[];for(const[o,i]of this.allConfigBasedTips)if(!(i.configScheme&&i.configScheme!==r.scheme))try{const n=(await this.fileService.readFile((0,T.joinPath)(r,o))).value.toString();for(const[a,u]of Object.entries(i.recommendations))(!u.contentPattern||new RegExp(u.contentPattern,"mig").test(n))&&t.push({extensionId:a,extensionName:u.name,configName:i.configName,important:!!u.important,isExtensionPack:!!u.isExtensionPack,whenNotInstalled:u.whenNotInstalled})}catch{}return t}};e.ExtensionTipsService=f,e.ExtensionTipsService=f=we([X(0,O.IFileService),X(1,L.IProductService)],f);const S="extensionTips/promptedExecutableTips",R="extensionTips/lastPromptedMediumImpExeTime";class g extends f{constructor(r,t,o,i,n,a,u,d){super(u,d),this.userHome=r,this.windowEvents=t,this.telemetryService=o,this.extensionManagementService=i,this.storageService=n,this.extensionRecommendationNotificationService=a,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,d.exeBasedExtensionTips&&Object.entries(d.exeBasedExtensionTips).forEach(([b,A])=>{const I=[],E=[],k=[];Object.entries(A.recommendations).forEach(([F,U])=>{U.important?A.important?I.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):E.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):k.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),I.length&&this.highImportanceExecutableTips.set(b,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:I}),E.length&&this.mediumImportanceExecutableTips.set(b,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:E}),k.length&&this.allOtherExecutableTips.set(b,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:k})}),(0,_.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),t=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...t]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),t=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),o=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,o),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(t,o)}groupImportantTipsByExe(r,t){const o=new Map;r.forEach(d=>o.set(d.extensionId.toLowerCase(),d));const{installed:i,uninstalled:n}=this.groupByInstalled([...o.keys()],t);for(const d of i){const b=o.get(d);b&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:d,exeName:b.exeName})}for(const d of n){const b=o.get(d);b&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:d,exeName:b.exeName})}const a=this.getPromptedExecutableTips(),u=new Map;for(const d of n){const b=o.get(d);if(b&&(!a[b.exeName]||!a[b.exeName].includes(b.extensionId))){let A=u.get(b.exeName);A||(A=[],u.set(b.exeName,A)),A.push(b)}}return u}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[r,t]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(t).then(o=>{switch(o){case l.RecommendationsNotificationResult.Accepted:this.addToRecommendedExecutables(t[0].exeName,t);break;case l.RecommendationsNotificationResult.Ignored:this.highImportanceTipsByExe.delete(r);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const i=v.Event.once(v.Event.latch(v.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptHighImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const i=this._register(new c.MutableDisposable);i.value=(0,_.disposableTimeout)(()=>{i.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const r=this.getLastPromptedMediumExeTime(),t=Date.now()-r,o=7*24*60*60*1e3;if(t<o){const a=this._register(new c.MutableDisposable);a.value=(0,_.disposableTimeout)(()=>{a.dispose(),this.promptMediumImportanceExeBasedTip()},o-t);return}const[i,n]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(n).then(a=>{switch(a){case l.RecommendationsNotificationResult.Accepted:{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(i),this.addToRecommendedExecutables(n[0].exeName,n);const u=this._register(new c.MutableDisposable);u.value=(0,_.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},o);break}case l.RecommendationsNotificationResult.Ignored:this.mediumImportanceTipsByExe.delete(i),this.promptMediumImportanceExeBasedTip();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const u=v.Event.once(v.Event.latch(v.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(u(()=>this.promptMediumImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const u=this._register(new c.MutableDisposable);u.value=(0,_.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(r){const t=await this.extensionManagementService.getInstalled(y.ExtensionType.User),o=r.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>t.every(a=>!(0,m.areSameExtensions)(a.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:o,source:l.RecommendationSource.EXE,name:r[0].exeFriendlyName,searchValue:`@exe:"${r[0].exeName}"`})}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(R,w.StorageScope.APPLICATION);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(R,r,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(S,w.StorageScope.APPLICATION,"{}"))}addToRecommendedExecutables(r,t){const o=this.getPromptedExecutableTips();o[r]=t.map(({extensionId:i})=>i.toLowerCase()),this.storageService.store(S,JSON.stringify(o),w.StorageScope.APPLICATION,w.StorageTarget.USER)}groupByInstalled(r,t){const o=[],i=[],n=t.reduce((a,u)=>(a.add(u.identifier.id.toLowerCase()),a),new Set);return r.forEach(a=>{n.has(a.toLowerCase())?o.push(a):i.push(a)}),{installed:o,uninstalled:i}}async getValidExecutableBasedExtensionTips(r){const t=[],o=new Map;for(const i of r.keys()){const n=r.get(i);if(!n||!(0,C.isNonEmptyArray)(n.recommendations))continue;const a=[];p.isWindows?n.windowsPath&&a.push(n.windowsPath.replace("%USERPROFILE%",()=>h.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>h.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>h.env.ProgramFiles).replace("%APPDATA%",()=>h.env.APPDATA).replace("%WINDIR%",()=>h.env.WINDIR)):(a.push((0,P.join)("/usr/local/bin",i)),a.push((0,P.join)("/usr/bin",i)),a.push((0,P.join)(this.userHome.fsPath,i)));for(const u of a){let d=o.get(u);if(d===void 0&&(d=await this.fileService.exists(D.URI.file(u)),o.set(u,d)),d)for(const{extensionId:b,extensionName:A,isExtensionPack:I,whenNotInstalled:E}of n.recommendations)t.push({extensionId:b,extensionName:A,isExtensionPack:I,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:E})}}return t}}e.AbstractNativeExtensionTipsService=g}),define(le[258],ue([0,1,28,7,24,16,75,58,17,18,257]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=class extends P.AbstractNativeExtensionTipsService{constructor(m,l,y,w,f,S,R,g){super(m.userHome,f,l,y,w,S,R,g)}};e.ExtensionTipsService=p,e.ExtensionTipsService=p=we([X(0,D.INativeEnvironmentService),X(1,v.ITelemetryService),X(2,C.IExtensionManagementService),X(3,_.IStorageService),X(4,L.INativeHostService),X(5,O.IExtensionRecommendationNotificationService),X(6,c.IFileService),X(7,T.IProductService)],p)}),define(le[50],ue([0,1,15,32,17]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=D;async function D(O,L,_){let v=_&&_.get("storage.serviceMachineId",T.StorageScope.APPLICATION)||null;if(v)return v;try{const p=(await L.readFile(O.serviceMachineIdResource)).value.toString();v=(0,c.isUUID)(p)?p:null}catch{v=null}if(!v){v=(0,c.generateUuid)();try{await L.writeFile(O.serviceMachineIdResource,C.VSBuffer.fromString(v))}catch{}}return _?.store("storage.serviceMachineId",v,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE),v}}),define(le[259],ue([0,1,50,18,49]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=D;async function D(O,L,_,v,P,p,h){const m={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${L.nameShort})`};if((0,T.supportsTelemetry)(L,_)&&(0,T.getTelemetryLevel)(v)===c.TelemetryLevel.USAGE){const l=await(0,C.getServiceMachineId)(_,P,p);m["X-Market-User-Id"]=l,m["VSCode-SessionId"]=h.machineId||l}return m}}),define(le[260],ue([0,1,19,26,8,5,37,13,9,22,16,28,33,36,60,7,10,24,62,259,17,18,55]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=W;const t=D.isWeb?m.TargetPlatform.WEB:(0,p.getTargetPlatform)(D.platform,O.arch),o="X-Market-Search-Activity-Id";var i;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...$){return String($.reduce((x,J)=>x|J,0))}var a;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},A={pageNumber:1,pageSize:10,sortBy:p.SortBy.NoneOrRelevance,sortOrder:p.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(x=A){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,J=this.state.pageSize){return new I({...this.state,pageNumber:x,pageSize:J})}withFilter(x,...J){const ee=[...this.state.criteria,...J.length?J.map(K=>({filterType:x,value:K})):[{filterType:x}]];return new I({...this.state,criteria:ee})}withSortBy(x){return new I({...this.state,sortBy:x})}withSortOrder(x){return new I({...this.state,sortOrder:x})}withFlags(...x){return new I({...this.state,flags:x.reduce((J,ee)=>J|ee,0)})}withAssetTypes(...x){return new I({...this.state,assetTypes:x})}withSource(x){return new I({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:J,pageSize:ee,sortBy:K,sortOrder:oe,flags:he,assetTypes:ge}=this.state;return{filters:[{criteria:x,pageNumber:J,pageSize:ee,sortBy:K,sortOrder:oe}],assetTypes:ge,flags:he}}get searchText(){const x=this.state.criteria.filter(J=>J.filterType===a.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function E($,x){const J=($||[]).filter(ee=>ee.statisticName===x)[0];return J?J.value:0}function k($){const x="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ee=>ee.assetType.indexOf(x)===0).reduce((ee,K)=>{const oe=M($,K.assetType);return oe&&ee.push([K.assetType.substring(x.length),oe]),ee},[])}function F($){if($.properties){const x=$.properties.filter(K=>K.key===u.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=x.filter(K=>J.test(K.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return M($,u.Repository)}function U($){return{uri:`${$.fallbackAssetUri}/${u.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${u.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function M($,x){return $.files.filter(ee=>ee.assetType===x)[0]?{uri:`${$.assetUri}/${x}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${x}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function H($,x){const J=$.properties?$.properties.filter(K=>K.key===x):[],ee=J.length>0&&J[0].value;return ee?ee.split(",").map(K=>(0,h.adoptToGalleryExtensionId)(K)):[]}function B($){const x=$.properties?$.properties.filter(J=>J.key===d.Engine):[];return x.length>0&&x[0].value||""}function Z($){const x=$.properties?$.properties.filter(J=>J.key===d.PreRelease):[];return x.length>0&&x[0].value==="true"}function V($){const x=$.properties?$.properties.filter(ee=>ee.key===d.EnabledApiProposals):[],J=x.length>0&&x[0].value||"";return J?J.split(","):[]}function ie($){const x=$.properties?$.properties.filter(ee=>ee.key===d.LocalizedLanguages):[],J=x.length>0&&x[0].value||"";return J?J.split(","):[]}function z($){return $.properties?.find(x=>x.key===d.SponsorLink)?.value}function q($){return $.properties?.find(x=>x.key===d.SupportLink)?.value}function te($){return $.indexOf("preview")!==-1}function se($){return $.targetPlatform?(0,p.toTargetPlatform)($.targetPlatform):m.TargetPlatform.UNDEFINED}function ce($){const x=(0,C.distinct)($.versions.map(se)),J=!!$.tags?.includes(p.WEB_EXTENSION_TAG),ee=x.indexOf(m.TargetPlatform.WEB);return J?ee===-1&&x.push(m.TargetPlatform.WEB):ee!==-1&&x.splice(ee,1),x}function W($,x){for(let J=0;J<$.length;J++){const ee=$[J];if(ee.version===$[J-1]?.version){let K=J;if(se(ee)===x)for(;K>0&&$[K-1].version===ee.version;)K--;K!==J&&($.splice(J,1),$.splice(K,0,ee))}}return $}function Q($,x,J){$.telemetryData={index:x,querySource:J,queryActivityId:$.queryContext?.[o]}}function G($,x,J,ee){const K=$.versions[0],oe={manifest:M(x,u.Manifest),readme:M(x,u.Details),changelog:M(x,u.Changelog),license:M(x,u.License),repository:F(x),download:U(x),icon:M(x,u.Icon),signature:M(x,u.Signature),coreTranslations:k(x)};return{type:"gallery",identifier:{id:(0,h.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:x.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(K),description:$.shortDescription??"",installCount:E($.statistics,"install"),rating:E($.statistics,"averagerating"),ratingCount:E($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:J,assets:oe,properties:{dependencies:H(x,d.Dependency),extensionPack:H(x,d.ExtensionPack),engine:B(x),enabledApiProposals:V(x),localizedLanguages:ie(x),targetPlatform:se(x),isPreReleaseVersion:Z(x)},hasPreReleaseVersion:Z(K),hasReleaseVersion:!0,preview:te($.flags),isSigned:!!oe.signature,queryContext:ee,supportLink:q(K)}}let j=class{constructor(x,J,ee,K,oe,he,ge,Se){this.requestService=J,this.logService=ee,this.environmentService=K,this.telemetryService=oe,this.fileService=he,this.productService=ge,this.configurationService=Se;const Pe=ge.extensionsGallery,ve=Pe?.servicePPEUrl&&Se.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ve?Pe.servicePPEUrl:Pe?.serviceUrl,this.extensionsGallerySearchUrl=ve?void 0:Pe?.searchUrl,this.extensionsControlUrl=Pe?.controlUrl,this.extensionsEnabledWithApiProposalVersion=ge.extensionsEnabledWithApiProposalVersion?.map(ye=>ye.toLowerCase())??[],this.commonHeadersPromise=(0,R.resolveMarketplaceHeaders)(ge.version,ge,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,J,ee){const K=c.CancellationToken.isCancellationToken(J)?{}:J,oe=c.CancellationToken.isCancellationToken(J)?J:ee,he=[],ge=[],Se=[],Pe=[];let ve=!0;for(const be of x){be.uuid?ge.push(be.uuid):he.push(be.id);const ae=!!(be.version||be.preRelease);Se.push({id:be.id,uuid:be.uuid,includePreRelease:ae}),be.version&&Pe.push({id:be.id,uuid:be.uuid,version:be.version}),ve=ve&&!!be.hasPreRelease&&!ae}if(!ge.length&&!he.length)return[];let ye=new I().withPage(1,x.length);ge.length&&(ye=ye.withFilter(a.ExtensionId,...ge)),he.length&&(ye=ye.withFilter(a.ExtensionName,...he)),(K.queryAllVersions||ve)&&(ye=ye.withFlags(ye.flags,i.IncludeVersions)),K.source&&(ye=ye.withSource(K.source));const{extensions:Ie}=await this.queryGalleryExtensions(ye,{targetPlatform:K.targetPlatform??t,includePreRelease:Se,versions:Pe,compatible:!!K.compatible,productVersion:K.productVersion??{version:this.productService.version,date:this.productService.date}},oe);return K.source&&Ie.forEach((be,ae)=>Q(be,ae,K.source)),Ie}async getCompatibleExtension(x,J,ee,K={version:this.productService.version,date:this.productService.date}){if((0,p.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(x,J,ee))return x;const oe=new I().withFlags(i.IncludeVersions).withPage(1,1).withFilter(a.ExtensionId,x.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(oe,{targetPlatform:ee,compatible:!0,includePreRelease:J,productVersion:K},c.CancellationToken.None);return he[0]||null}async isExtensionCompatible(x,J,ee,K={version:this.productService.version,date:this.productService.date}){if(!(0,p.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,ee)||!J&&x.properties.isPreReleaseVersion)return!1;let oe=x.properties.engine;if(!oe){const he=await this.getManifest(x,c.CancellationToken.None);if(!he)throw new Error("Manifest was not found");oe=he.engines.vscode}return!(!(0,l.isEngineValid)(oe,K.version,K.date)||!this.areApiProposalsCompatible(x.identifier,x.properties.enabledApiProposals))}areApiProposalsCompatible(x,J){return!J||!this.extensionsEnabledWithApiProposalVersion.includes(x.id.toLowerCase())?!0:(0,l.areApiProposalsCompatible)(J)}async isValidVersion(x,J,ee,K,oe,he,ge={version:this.productService.version,date:this.productService.date}){if(!(0,p.isTargetPlatformCompatible)(se(J),oe,he)||ee!=="any"&&Z(J)!==(ee==="prerelease"))return!1;if(K)try{const Se=await this.getEngine(x,J);if(!(0,l.isEngineValid)(Se,ge.version,ge.date))return!1}catch(Se){return this.logService.error(`Error while getting the engine for the version ${J.version}.`,(0,T.getErrorMessage)(Se)),!1}return!0}async query(x,J){let ee=x.text||"";const K=x.pageSize??50;let oe=new I().withPage(1,K);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,ye,Ie)=>(oe=oe.withFilter(a.Category,Ie||ye),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,ye,Ie)=>(oe=oe.withFilter(a.Tag,Ie||ye),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(a.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),oe=oe.withFilter(a.SearchText,ee)),oe=oe.withSortBy(p.SortBy.NoneOrRelevance)):x.ids?oe=oe.withFilter(a.ExtensionId,...x.ids):x.names?oe=oe.withFilter(a.ExtensionName,...x.names):oe=oe.withSortBy(p.SortBy.InstallCount),typeof x.sortBy=="number"&&(oe=oe.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(oe=oe.withSortOrder(x.sortOrder)),x.source&&(oe=oe.withSource(x.source));const he=async(ve,ye)=>{const{extensions:Ie,total:be}=await this.queryGalleryExtensions(ve,{targetPlatform:t,compatible:!1,includePreRelease:!!x.includePreRelease,productVersion:x.productVersion??{version:this.productService.version,date:this.productService.date}},ye);return Ie.forEach((ae,fe)=>Q(ae,(ve.pageNumber-1)*ve.pageSize+fe,x.source)),{extensions:Ie,total:be}},{extensions:ge,total:Se}=await he(oe,J),Pe=async(ve,ye)=>{if(ye.isCancellationRequested)throw new T.CancellationError;const{extensions:Ie}=await he(oe.withPage(ve+1),ye);return Ie};return{firstPage:ge,total:Se,pageSize:oe.pageSize,getPage:Pe}}async queryGalleryExtensions(x,J,ee){const K=x.flags;x.flags&i.IncludeLatestVersionOnly&&x.flags&i.IncludeVersions&&(x=x.withFlags(x.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(x.flags&i.IncludeLatestVersionOnly)&&!(x.flags&i.IncludeVersions)&&(x=x.withFlags(x.flags,i.IncludeLatestVersionOnly)),J.versions?.length&&(x=x.withFlags(x.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),x=x.withFlags(x.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:he,context:ge}=await this.queryRawGalleryExtensions(x,ee);if(!(x.flags&i.IncludeLatestVersionOnly)){const ye=[];for(const Ie of oe){const be=await this.toGalleryExtensionWithCriteria(Ie,J,ge);be&&ye.push(be)}return{extensions:ye,total:he}}const Pe=[],ve=new Map;for(let ye=0;ye<oe.length;ye++){const Ie=oe[ye],be={id:(0,h.getGalleryExtensionId)(Ie.publisher.publisherName,Ie.extensionName),uuid:Ie.extensionId},ae=(0,L.isBoolean)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(me=>(0,h.areSameExtensions)(me,be))?.includePreRelease;if(J.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ce(Ie),J.targetPlatform))continue;const fe=await this.toGalleryExtensionWithCriteria(Ie,J,ge);!fe||fe.properties.isPreReleaseVersion&&(!ae||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==J.targetPlatform&&fe.hasPreReleaseVersion?ve.set(Ie.extensionId,ye):Pe.push([ye,fe])}if(ve.size){const ye=new r.StopWatch,Ie=new I().withFlags(K&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(a.ExtensionId,...ve.keys()),{extensions:be}=await this.queryGalleryExtensions(Ie,J,ee);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:ye.elapsed(),count:ve.size});for(const ae of be){const fe=ve.get(ae.identifier.uuid);Pe.push([fe,ae])}}return{extensions:Pe.sort((ye,Ie)=>ye[0]-Ie[0]).map(([,ye])=>ye),total:he}}async toGalleryExtensionWithCriteria(x,J,ee){const K={id:(0,h.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},oe=J.versions?.find(Pe=>(0,h.areSameExtensions)(Pe,K))?.version,he=(0,L.isBoolean)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(Pe=>(0,h.areSameExtensions)(Pe,K))?.includePreRelease,ge=ce(x),Se=W(x.versions,J.targetPlatform);if(J.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ge,J.targetPlatform))return null;for(let Pe=0;Pe<Se.length;Pe++){const ve=Se[Pe];if(!(oe&&ve.version!==oe)){if(await this.isValidVersion(K.id,ve,he?"any":"release",J.compatible,ge,J.targetPlatform,J.productVersion))return J.compatible&&!this.areApiProposalsCompatible(K,V(ve))?null:G(x,ve,ge,ee);if(oe&&ve.version===oe)return null}}return oe||J.compatible?null:G(x,x.versions[0],ge)}async queryRawGalleryExtensions(x,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,i.ExcludeNonValidated).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExcludeWithFlags,n(i.Unpublished));const ee=await this.commonHeadersPromise,K=JSON.stringify(x.raw),oe={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},he=new r.StopWatch;let ge,Se,Pe=0;try{if(ge=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(ye=>ye.filterType===a.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:K,headers:oe},J),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Pe};const ve=await(0,S.asJson)(ge);if(ve){const ye=ve.results[0],Ie=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Pe=be&&be.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:Pe,context:{[o]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Pe}}catch(ve){if((0,T.isCancellationError)(ve))throw Se=p.ExtensionGalleryErrorCode.Cancelled,ve;{const ye=(0,T.getErrorMessage)(ve);throw Se=ye.startsWith("XHR timeout")?p.ExtensionGalleryErrorCode.Timeout:p.ExtensionGalleryErrorCode.Failed,new p.ExtensionGalleryError(ye,Se)}}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(K.length),duration:he.elapsed(),success:!!ge&&(0,S.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:Se,count:String(Pe)})}}async reportStatistic(x,J,ee,K){if(!this.isEnabled())return;const oe=D.isWeb?this.api(`/itemName/${x}.${J}/version/${ee}/statType/${K===p.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${J}/${ee}/stats?statType=${K}`),he=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Se={...await this.commonHeadersPromise,Accept:he};try{await this.requestService.request({type:"POST",url:oe,headers:Se},c.CancellationToken.None)}catch{}}async download(x,J,ee){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const K=(0,h.getGalleryExtensionTelemetryData)(x),oe=new Date().getTime(),he=ee===p.InstallOperation.Install?"install":ee===p.InstallOperation.Update?"update":"",ge=he?{uri:`${x.assets.download.uri}${_.URI.parse(x.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${x.assets.download.fallbackUri}${_.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:x.assets.download,Se=x.queryContext?.[o]?{[o]:x.queryContext[o]}:void 0,Pe=await this.getAsset(x.identifier.id,ge,u.VSIX,Se?{headers:Se}:void 0);try{await this.fileService.writeFile(J,Pe.stream)}catch(ve){try{await this.fileService.del(J)}catch(ye){this.logService.warn(`Error while deleting the file ${J.toString()}`,(0,T.getErrorMessage)(ye))}throw new p.ExtensionGalleryError((0,T.getErrorMessage)(ve),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:new Date().getTime()-oe})}async downloadSignatureArchive(x,J){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const ee=await this.getAsset(x.identifier.id,x.assets.signature,u.Signature);try{await this.fileService.writeFile(J,ee.stream)}catch(K){try{await this.fileService.del(J)}catch(oe){this.logService.warn(`Error while deleting the file ${J.toString()}`,(0,T.getErrorMessage)(oe))}throw new p.ExtensionGalleryError((0,T.getErrorMessage)(K),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(x,J){if(x.assets.readme){const ee=await this.getAsset(x.identifier.id,x.assets.readme,u.Details,{},J);return await(0,S.asTextOrError)(ee)||""}return""}async getManifest(x,J){if(x.assets.manifest){const ee=await this.getAsset(x.identifier.id,x.assets.manifest,u.Manifest,{},J),K=await(0,S.asTextOrError)(ee);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(x,J,ee){const K=M(J,u.Manifest);if(!K)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},he=await this.getAsset(x,K,u.Manifest,{headers:oe});return await(0,S.asJson)(he)}async getCoreTranslation(x,J){const ee=x.assets.coreTranslations.filter(K=>K[0]===J.toUpperCase())[0];if(ee){const K=await this.getAsset(x.identifier.id,ee[1],ee[0]),oe=await(0,S.asTextOrError)(K);return oe?JSON.parse(oe):null}return null}async getChangelog(x,J){if(x.assets.changelog){const ee=await this.getAsset(x.identifier.id,x.assets.changelog,u.Changelog,{},J);return await(0,S.asTextOrError)(ee)||""}return""}async getAllCompatibleVersions(x,J,ee){let K=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);x.uuid?K=K.withFilter(a.ExtensionId,x.uuid):K=K.withFilter(a.ExtensionName,x.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(K,c.CancellationToken.None);if(!oe.length)return[];const he=ce(oe[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(he,ee))return[];const ge=[];await Promise.all(oe[0].versions.map(async ve=>{try{await this.isValidVersion(x.id,ve,J?"any":"release",!0,he,ee)&&this.areApiProposalsCompatible(x,V(ve))&&ge.push(ve)}catch{}}));const Se=[],Pe=new Set;for(const ve of W(ge,ee))Pe.has(ve.version)||(Pe.add(ve.version),Se.push({version:ve.version,date:ve.lastUpdated,isPreReleaseVersion:Z(ve)}));return Se}async getAsset(x,J,ee,K={},oe=c.CancellationToken.None){const he=await this.commonHeadersPromise,ge={type:"GET"},Se={...he,...K.headers||{}};K={...K,...ge,headers:Se};const Pe=J.uri,ve=J.fallbackUri,ye={...K,url:Pe};try{const Ie=await this.requestService.request(ye,oe);if(Ie.res.statusCode===200)return Ie;const be=await(0,S.asTextOrError)(Ie);throw new Error(`Expected 200, got back ${Ie.res.statusCode} instead.

${be}`)}catch(Ie){if((0,T.isCancellationError)(Ie))throw Ie;const be=(0,T.getErrorMessage)(Ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:x,assetType:ee,message:be});const ae={...K,url:ve};return this.requestService.request(ae,oe)}}async getEngine(x,J){let ee=B(J);if(!ee){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:x,version:J.version});const K=await this.getManifestFromRawExtensionVersion(x,J,c.CancellationToken.None);if(!K)throw new Error("Manifest was not found");ee=K.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},c.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,S.asJson)(x),ee=[],K={},oe=[],he=[];if(J){for(const ge of J.malicious)ee.push({id:ge});if(J.migrateToPreRelease)for(const[ge,Se]of Object.entries(J.migrateToPreRelease))(!Se.engine||(0,l.isEngineValid)(Se.engine,this.productService.version,this.productService.date))&&(K[ge.toLowerCase()]={disallowInstall:!0,extension:{id:Se.id,displayName:Se.displayName,autoMigrate:{storage:!!Se.migrateStorage},preRelease:!0}});if(J.deprecated)for(const[ge,Se]of Object.entries(J.deprecated))Se&&(K[ge.toLowerCase()]=(0,L.isBoolean)(Se)?{}:Se);if(J.search)for(const ge of J.search)oe.push(ge);if(Array.isArray(J.extensionsEnabledWithPreRelease))for(const ge of J.extensionsEnabledWithPreRelease)he.push(ge.toLowerCase())}return{malicious:ee,deprecated:K,search:oe,extensionsEnabledWithPreRelease:he}}};j=we([X(1,S.IRequestService),X(2,w.ILogService),X(3,P.IEnvironmentService),X(4,s.ITelemetryService),X(5,y.IFileService),X(6,f.IProductService),X(7,v.IConfigurationService)],j);let N=class extends j{constructor(x,J,ee,K,oe,he,ge,Se){super(x,J,ee,K,oe,he,ge,Se)}};e.ExtensionGalleryService=N,e.ExtensionGalleryService=N=we([X(0,g.IStorageService),X(1,S.IRequestService),X(2,w.ILogService),X(3,P.IEnvironmentService),X(4,s.ITelemetryService),X(5,y.IFileService),X(6,f.IProductService),X(7,v.IConfigurationService)],N);let Y=class extends j{constructor(x,J,ee,K,oe,he,ge){super(void 0,x,J,ee,K,oe,he,ge)}};e.ExtensionGalleryServiceWithNoStorageService=Y,e.ExtensionGalleryServiceWithNoStorageService=Y=we([X(0,S.IRequestService),X(1,w.ILogService),X(2,P.IEnvironmentService),X(3,s.ITelemetryService),X(4,y.IFileService),X(5,f.IProductService),X(6,v.IConfigurationService)],Y)}),define(le[261],ue([0,1,108,3,18,16,2,10,14,70,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const s=[C.CONFIGURATION_KEY_HOST_NAME,C.CONFIGURATION_KEY_PREVENT_SLEEP],r="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends O.Disposable{constructor(u,d,b,A,I,E,k){super(),this.telemetryService=u,this.productService=d,this.environmentService=b,this.configurationService=E,this.storageService=k,this._onDidTokenFailedEmitter=new c.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new c.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new c.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=C.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(F,U)=>{U?this._logger.error(F):this._logger.info(F)},this._logger=this._register(A.createLogger((0,g.joinPath)(b.logsHome,`${C.LOG_ID}.log`),{id:C.LOG_ID,name:C.LOGGER_NAME})),this._startTunnelProcessDelayer=new h.Delayer(100),this._register(this._logger.onDidChangeLogLevel(F=>this._logger.info("Log level changed to "+(0,L.LogLevelToString)(F)))),this._register(I.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(E.onDidChangeConfiguration(F=>{s.some(U=>F.affectsConfiguration(U))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=C.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(u){this._tunnelStatus=u,this._onDidChangeTunnelStatusEmitter.fire(u)}setMode(u){n(this._mode,u)||(this._mode=u,this._storeMode(u),this._onDidChangeModeEmitter.fire(this._mode),u.active?(this._logger.info(`Session updated: ${u.session.accountLabel} (${u.session.providerId}) (service=${u.asService})`),u.session.token&&this._logger.info(`Session token updated: ${u.session.accountLabel} (${u.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(u){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(u);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(d){this._logger.error(d)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let u;p.isMacintosh?u=this.environmentService.appRoot:u=(0,_.dirname)((0,_.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,_.join)(u,"bin",`${this.productService.tunnelApplicationName}${p.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(u){if(n(this._mode,u)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(u);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(d){this._logger.error(d)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const u=this._mode.asService;this.setMode(C.INACTIVE_TUNNEL_MODE);try{u&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(d){this._logger.error(d)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(u){this._logger.error(u)}this.setTunnelStatus(C.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let u="",d=!1;const b=(U,M)=>{M?this._logger.error(U):u+=U,!this.environmentService.isBuilt&&U.startsWith("   Compiling")&&this.setTunnelStatus(C.TunnelStates.connecting((0,y.localize)(0,null)))},A=this.runCodeTunnelCommand("status",["status"],b);this._tunnelProcess=A;try{if(await A,this._tunnelProcess!==A)return;let U;try{U=JSON.parse(u.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(u.trim())}`),this.setTunnelStatus(C.TunnelStates.disconnected());return}if(d=U.service_installed,this._logger.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this._mode.active){this.setTunnelStatus(C.TunnelStates.disconnected());return}}catch(U){this._logger.error(U),this.setTunnelStatus(C.TunnelStates.disconnected());return}finally{this._tunnelProcess===A&&(this._tunnelProcess=void 0)}const I=this._mode.active?this._mode.session:void 0;if(I&&I.token){const U=I.token;this.setTunnelStatus(C.TunnelStates.connecting((0,y.localize)(1,null,I.accountLabel,I.providerId)));const M=(B,Z)=>{B=B.replaceAll(U,"*".repeat(4)),b(B,Z)},H=this.runCodeTunnelCommand("login",["user","login","--provider",I.providerId,"--log",(0,L.LogLevelToString)(this._logger.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:U});this._tunnelProcess=H;try{if(await H,this._tunnelProcess!==H)return}catch(B){this._logger.error(B),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(I),this.setTunnelStatus(C.TunnelStates.disconnected(I));return}}const E=this._getTunnelName();E?this.setTunnelStatus(C.TunnelStates.connecting((0,y.localize)(2,null,E))):this.setTunnelStatus(C.TunnelStates.connecting((0,y.localize)(3,null)));const k=["--accept-server-license-terms","--log",(0,L.LogLevelToString)(this._logger.getLevel())];E?k.push("--name",E):k.push("--random-name");let F=!1;return this._mode.active&&this._mode.asService&&!d&&(F=await this.installTunnelService(k)===!1),this.serverOrAttachTunnel(I,k,F)}async installTunnelService(u){let d;try{d=await this.runCodeTunnelCommand("serviceInstall",["service","install",...u])}catch(b){this._logger.error(b),d=1}if(d!==0){const b=(0,y.localize)(4,null);return this._logger.warn(b),this.setTunnelStatus(C.TunnelStates.connecting(b)),!1}return!0}async serverOrAttachTunnel(u,d,b){d.push("--parent-process-id",String(process.pid)),this._preventSleep()&&d.push("--no-sleep");let A=!1;const I=this.runCodeTunnelCommand("tunnel",d,(E,k)=>{k?this._logger.error(E):this._logger.info(E),E.includes("Connected to an existing tunnel process")&&(A=!0);const F=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const U={link:F[1],domain:F[2],tunnelName:F[4],isAttached:A};this.setTunnelStatus(C.TunnelStates.connected(U,b))}else E.match(/error refreshing token/)&&(I.cancel(),this._onDidTokenFailedEmitter.fire(u),this.setTunnelStatus(C.TunnelStates.disconnected(u)))});this._tunnelProcess=I,I.finally(()=>{I===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=C.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(C.TunnelStates.disconnected()))})}runCodeTunnelCommand(u,d,b=this.defaultOnOutput,A){return(0,h.createCancelablePromise)(I=>new Promise((E,k)=>{I.isCancellationRequested&&E(-1);let F;const U=["ignore","pipe","pipe"];if(I.onCancellationRequested(()=>{F&&(this._logger.info(`${u} terminating(${F.pid})`),F.kill())}),!this.environmentService.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${u} Spawning: cargo run -- tunnel ${d.join(" ")}
`,!1),F=(0,v.spawn)("cargo",["run","--","tunnel",...d],{cwd:(0,_.join)(this.environmentService.appRoot,"cli"),stdio:U,env:{...process.env,RUST_BACKTRACE:"1",...A}});else{b(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();b(`${u} Spawning: ${M} tunnel ${d.join(" ")}
`,!1),F=(0,v.spawn)(M,["tunnel",...d],{cwd:(0,w.homedir)(),stdio:U,env:{...process.env,...A}})}F.stdout.pipe(new R.StreamSplitter(`
`)).on("data",M=>{if(F){const H=M.toString();b(H,!1)}}),F.stderr.pipe(new R.StreamSplitter(`
`)).on("data",M=>{if(F){const H=M.toString();b(H,!0)}}),F.on("exit",M=>{F&&(b(`${u} exit(${F.pid}): + ${M} `,!1),F=void 0,E(M||0))}),F.on("error",M=>{F&&(b(`${u} error(${F.pid}): + ${M} `,!0),F=void 0,k())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(C.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let u=this.configurationService.getValue(C.CONFIGURATION_KEY_HOST_NAME)||(0,w.hostname)();return u=u.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),u||void 0}_restoreMode(){try{const u=this.storageService.get(r,f.StorageScope.APPLICATION),d=this.storageService.getBoolean(t,f.StorageScope.APPLICATION,!1);if(u){const b=JSON.parse(u);if(b&&(0,S.isString)(b.accountLabel)&&(0,S.isString)(b.sessionId)&&(0,S.isString)(b.providerId))return{active:!0,session:b,asService:d};this._logger.error("Problems restoring session from storage, invalid format",b)}}catch(u){this._logger.error("Problems restoring session from storage",u)}return C.INACTIVE_TUNNEL_MODE}_storeMode(u){if(u.active){const d={providerId:u.session.providerId,sessionId:u.session.sessionId,accountLabel:u.session.accountLabel};this.storageService.store(r,JSON.stringify(d),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.storageService.store(t,u.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.storageService.remove(r,f.StorageScope.APPLICATION),this.storageService.remove(t,f.StorageScope.APPLICATION)}};e.RemoteTunnelService=o,e.RemoteTunnelService=o=we([X(0,T.ITelemetryService),X(1,P.IProductService),X(2,D.INativeEnvironmentService),X(3,L.ILoggerService),X(4,m.ISharedProcessLifecycleService),X(5,l.IConfigurationService),X(6,f.IStorageService)],o);function i(a,u){return a&&u?a.sessionId===u.sessionId&&a.providerId===u.providerId&&a.token===u.token:a===u}const n=(a,u)=>a.active!==u.active?!1:a.active&&u.active?a.asService===u.asService&&i(a.session,u.session):!0}),define(le[262],ue([0,1,6,2,23,21,72,17,80,20]),function(ne,e,C,c,T,D,O,L,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends L.AbstractStorageService{constructor(h,m,l,y){super(),this.initialWorkspace=h,this.initialProfiles=m,this.remoteService=l,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new c.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new c.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const h=this._register(new _.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),m=this._register(new O.Storage(h));return this._register(m.onDidChangeStorage(l=>this.emitDidChangeValue(L.StorageScope.APPLICATION,l))),m}createProfileStorage(h){this.profileStorageDisposables.clear(),this.profileStorageProfile=h;let m;if((0,L.isProfileUsingDefaultStorage)(h))m=this.applicationStorage;else{const l=this.profileStorageDisposables.add(new _.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),h));m=this.profileStorageDisposables.add(new O.Storage(l))}return this.profileStorageDisposables.add(m.onDidChangeStorage(l=>this.emitDidChangeValue(L.StorageScope.PROFILE,l))),m}createWorkspaceStorage(h){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=h?.id;let m;if(h){const l=this.workspaceStorageDisposables.add(new _.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),h));m=this.workspaceStorageDisposables.add(new O.Storage(l)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(y=>this.emitDidChangeValue(L.StorageScope.WORKSPACE,y)))}return m}async doInitialize(){await C.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(h){switch(h){case L.StorageScope.APPLICATION:return this.applicationStorage;case L.StorageScope.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case L.StorageScope.APPLICATION:return this.applicationStorageProfile.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;case L.StorageScope.PROFILE:return this.profileStorageProfile?.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:T.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await C.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(h){if(!this.canSwitchProfile(this.profileStorageProfile,h))return;const m=this.profileStorage,l=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(h),await this.profileStorage.init(),this.switchData(l,this.profileStorage,L.StorageScope.PROFILE)}async switchToWorkspace(h,m){const l=this.workspaceStorage,y=l?.items??new Map;await l?.close(),this.workspaceStorage=this.createWorkspaceStorage(h),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,L.StorageScope.WORKSPACE)}hasScope(h){return(0,v.isUserDataProfile)(h)?this.profileStorageProfile.id===h.id:this.workspaceStorageId===h.id}}e.RemoteStorageService=P}),define(le[263],ue([0,1,3,2,20,95]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class O{constructor(v,P){this.service=v,this.getUriTransformer=P}listen(v,P){const p=this.getUriTransformer(v);switch(P){case"onDidChangeProfiles":return C.Event.map(this.service.onDidChangeProfiles,h=>({all:h.all.map(m=>(0,D.transformOutgoingURIs)({...m},p)),added:h.added.map(m=>(0,D.transformOutgoingURIs)({...m},p)),removed:h.removed.map(m=>(0,D.transformOutgoingURIs)({...m},p)),updated:h.updated.map(m=>(0,D.transformOutgoingURIs)({...m},p))}))}throw new Error(`Invalid listen ${P}`)}async call(v,P,p){const h=this.getUriTransformer(v);switch(P){case"createProfile":{const m=await this.service.createProfile(p[0],p[1],p[2]);return(0,D.transformOutgoingURIs)({...m},h)}case"updateProfile":{let m=(0,T.reviveProfile)((0,D.transformIncomingURIs)(p[0],h),this.service.profilesHome.scheme);return m=await this.service.updateProfile(m,p[1]),(0,D.transformOutgoingURIs)({...m},h)}case"removeProfile":{const m=(0,T.reviveProfile)((0,D.transformIncomingURIs)(p[0],h),this.service.profilesHome.scheme);return this.service.removeProfile(m)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=O;class L extends c.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(v,P,p){super(),this.profilesHome=P,this.channel=p,this._profiles=[],this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=v.map(h=>(0,T.reviveProfile)(h,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(h=>{const m=h.added.map(w=>(0,T.reviveProfile)(w,this.profilesHome.scheme)),l=h.removed.map(w=>(0,T.reviveProfile)(w,this.profilesHome.scheme)),y=h.updated.map(w=>(0,T.reviveProfile)(w,this.profilesHome.scheme));this._profiles=h.all.map(w=>(0,T.reviveProfile)(w,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:m,removed:l,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(v){this.enabled=v}isEnabled(){return this.enabled}async createNamedProfile(v,P,p){const h=await this.channel.call("createNamedProfile",[v,P,p]);return(0,T.reviveProfile)(h,this.profilesHome.scheme)}async createProfile(v,P,p,h){const m=await this.channel.call("createProfile",[v,P,p,h]);return(0,T.reviveProfile)(m,this.profilesHome.scheme)}async createTransientProfile(v){const P=await this.channel.call("createTransientProfile",[v]);return(0,T.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(v,P){await this.channel.call("setProfileForWorkspace",[v,P])}removeProfile(v){return this.channel.call("removeProfile",[v])}async updateProfile(v,P){const p=await this.channel.call("updateProfile",[v,P]);return(0,T.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=L}),define(le[63],ue([0,1,2,72,4,17,3,80,20]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,T.createDecorator)("IUserDataProfileStorageService");let v=class extends C.Disposable{constructor(m,l){super(),this.storageService=l,m&&(this.storageServicesMap=this._register(new C.DisposableMap))}async readStorageData(m){return this.withProfileScopedStorageService(m,async l=>this.getItems(l))}async updateStorageData(m,l,y){return this.withProfileScopedStorageService(m,async w=>this.writeItems(w,l,y))}async withProfileScopedStorageService(m,l){if(this.storageService.hasScope(m))return l(this.storageService);let y=this.storageServicesMap?.get(m.id);if(!y){y=new p(this.createStorageDatabase(m)),this.storageServicesMap?.set(m.id,y);try{await y.initialize()}catch(w){throw this.storageServicesMap?.has(m.id)?this.storageServicesMap.deleteAndDispose(m.id):y.dispose(),w}}try{const w=await l(y);return await y.flush(),w}finally{this.storageServicesMap?.has(m.id)||y.dispose()}}getItems(m){const l=new Map,y=w=>{for(const f of m.keys(D.StorageScope.PROFILE,w))l.set(f,{value:m.get(f,D.StorageScope.PROFILE),target:w})};return y(D.StorageTarget.USER),y(D.StorageTarget.MACHINE),l}writeItems(m,l,y){m.storeAll(Array.from(l.entries()).map(([w,f])=>({key:w,value:f,scope:D.StorageScope.PROFILE,target:y})),!0)}};e.AbstractUserDataProfileStorageService=v,e.AbstractUserDataProfileStorageService=v=we([X(1,D.IStorageService)],v);class P extends v{constructor(m,l,y,w,f){super(m,w),this.remoteService=l;const S=l.getChannel("profileStorageListener"),R=this._register(new C.MutableDisposable);this._onDidChange=this._register(new O.Emitter({onWillAddFirstListener:()=>{R.value=S.listen("onDidChange")(g=>{f.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(s=>(0,_.reviveProfile)(s,y.profilesHome.scheme)),valueChanges:g.valueChanges.map(s=>({...s,profile:(0,_.reviveProfile)(s.profile,y.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>R.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(m){const l=this.remoteService.getChannel("storage");return(0,D.isProfileUsingDefaultStorage)(m)?new L.ApplicationStorageDatabaseClient(l):new L.ProfileStorageDatabaseClient(l,m)}}e.RemoteUserDataProfileStorageService=P;class p extends D.AbstractStorageService{constructor(m){super({flushInterval:100}),this.profileStorageDatabase=m}async doInitialize(){const m=await this.profileStorageDatabase,l=new c.Storage(m);return this._register(l.onDidChangeStorage(y=>{this.emitDidChangeValue(D.StorageScope.PROFILE,y)})),this._register((0,C.toDisposable)(()=>{l.close(),l.dispose(),(0,C.isDisposable)(m)&&m.dispose()})),this.profileStorage=l,this.profileStorage.init()}getStorage(m){return m===D.StorageScope.PROFILE?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[264],ue([0,1,17,10,20,57,63]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessUserDataProfileStorageService=void 0;let L=class extends O.RemoteUserDataProfileStorageService{constructor(v,P,p,h){super(!0,v,P,p,h)}};e.SharedProcessUserDataProfileStorageService=L,e.SharedProcessUserDataProfileStorageService=L=we([X(0,D.IMainProcessService),X(1,T.IUserDataProfilesService),X(2,C.IStorageService),X(3,c.ILogService)],L)}),define(le[40],ue([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=r,e.isSyncData=t,e.getSyncResourceLogLabel=o;function r(d){return!!(d&&d.ref!==void 0&&typeof d.ref=="string"&&d.ref!==""&&d.syncData!==void 0&&(d.syncData===null||t(d.syncData)))}function t(d){return!!(d&&d.version!==void 0&&typeof d.version=="number"&&d.content!==void 0&&typeof d.content=="string"&&(Object.keys(d).length===2||Object.keys(d).length===3&&d.machineId!==void 0&&typeof d.machineId=="string"))}function o(d,b){return`${(0,v.uppercaseFirstLetter)(d)}${b.isDefault?"":` (${b.name})`}`}let i=class extends _.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(b,A,I,E,k,F,U,M,H,B,Z,V){super(),this.syncResource=b,this.collection=A,this.fileService=I,this.environmentService=E,this.storageService=k,this.userDataSyncStoreService=F,this.userDataSyncLocalStoreService=U,this.userDataSyncEnablementService=M,this.telemetryService=H,this.logService=B,this.configurationService=Z,this.syncPreviewPromise=null,this._status=g.SyncStatus.Idle,this._onDidChangStatus=this._register(new O.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new O.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new c.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new O.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=o(b.syncResource,b.profile),this.extUri=V.extUri,this.syncFolder=this.extUri.joinPath(E.userDataSyncHome,...(0,g.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,g.PREVIEW_DIR_NAME),this.lastSyncResource=(0,g.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,E,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(E,I,k)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status===g.SyncStatus.HasConflicts){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const b=await this.syncPreviewPromise;this.syncPreviewPromise=null;const A=await this.performSync(b.remoteUserData,b.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(A)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.hasRemoteChanged(b):!0)&&this._onDidChangeLocal.fire()}}setStatus(b){this._status!==b&&(this._status=b,this._onDidChangStatus.fire(b))}async sync(b,A={}){await this._sync(b,!0,this.getUserDataSyncConfiguration(),A)}async preview(b,A,I={}){return this._sync(b,!1,A,I)}async apply(b,A={}){try{this.syncHeaders={...A};const I=await this.doApply(b);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(b,A,I,E){try{if(this.syncHeaders={...E},this.status===g.SyncStatus.HasConflicts)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status===g.SyncStatus.Syncing)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus(g.SyncStatus.Syncing);let k=g.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(b,F);return k=await this.performSync(U,F,A,I),k===g.SyncStatus.HasConflicts?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):k===g.SyncStatus.Idle&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(k)}}finally{this.syncHeaders={}}}async replace(b){const A=this.parseSyncData(b);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus(g.SyncStatus.Syncing);const I=await this.getLastSyncUserData(),E=await this.getLatestRemoteUserData(null,I),k=await this.isRemoteDataFromCurrentMachine(E),F=await this.generateSyncPreview({ref:E.ref,syncData:A},I,k,this.getUserDataSyncConfiguration(),D.CancellationToken.None),U=[];for(const M of F){const H=await this.getAcceptResult(M,M.remoteResource,void 0,D.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,D.CancellationToken.None);U.push([M,{...H,remoteChange:B!==g.Change.None?B:g.Change.Modified}])}await this.applyResult(E,I,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus(g.SyncStatus.Idle)}return!0}async isRemoteDataFromCurrentMachine(b){const A=await this.currentMachineIdPromise;return!!b.syncData?.machineId&&b.syncData.machineId===A}async getLatestRemoteUserData(b,A){if(A){const I=b?b[this.resource]:void 0;if(A.ref===I||I===void 0&&A.syncData===null)return A}return this.getRemoteUserData(A)}async performSync(b,A,I,E){if(b.syncData&&b.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new g.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,b.syncData.version),g.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(b,A,I,E)}catch(k){if(k instanceof g.UserDataSyncError)switch(k.code){case g.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(b,A,I,E);case g.UserDataSyncErrorCode.Conflict:case g.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),A=await this.getLastSyncUserData(),this.performSync(b,A,I,E)}throw k}}async doSync(b,A,I,E){try{const k=await this.isRemoteDataFromCurrentMachine(b),F=!k&&A===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,U=I&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,c.createCancelablePromise)(H=>this.doGenerateSyncResourcePreview(b,A,k,U,E,H)));let M=await this.syncPreviewPromise;if(I&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const H of M.resourcePreviews)M=await this.accept(H.remoteResource)||M}return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:H})=>H===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:I?await this.doApply(!1):g.SyncStatus.Syncing}catch(k){throw this.syncPreviewPromise=null,k}}async merge(b){return await this.updateSyncResourcePreview(b,async A=>{const I=await this.getMergeResult(A,D.CancellationToken.None);await this.fileService.writeFile(A.previewResource,T.VSBuffer.fromString(I?.content||""));const E=I&&!I.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,D.CancellationToken.None):void 0;return A.acceptResult=E,A.mergeState=I.hasConflicts?g.MergeState.Conflict:E?g.MergeState.Accepted:g.MergeState.Preview,A.localChange=E?E.localChange:I.localChange,A.remoteChange=E?E.remoteChange:I.remoteChange,A}),this.syncPreviewPromise}async accept(b,A){return await this.updateSyncResourcePreview(b,async I=>{const E=await this.getAcceptResult(I,b,A,D.CancellationToken.None);return I.acceptResult=E,I.mergeState=g.MergeState.Accepted,I.localChange=E.localChange,I.remoteChange=E.remoteChange,I}),this.syncPreviewPromise}async discard(b){return await this.updateSyncResourcePreview(b,async A=>{const I=await this.getMergeResult(A,D.CancellationToken.None);return await this.fileService.writeFile(A.previewResource,T.VSBuffer.fromString(I.content||"")),A.acceptResult=void 0,A.mergeState=g.MergeState.Preview,A.localChange=I.localChange,A.remoteChange=I.remoteChange,A}),this.syncPreviewPromise}async updateSyncResourcePreview(b,A){if(!this.syncPreviewPromise)return;let I=await this.syncPreviewPromise;const E=I.resourcePreviews.findIndex(({localResource:k,remoteResource:F,previewResource:U})=>this.extUri.isEqual(k,b)||this.extUri.isEqual(F,b)||this.extUri.isEqual(U,b));E!==-1&&(this.syncPreviewPromise=(0,c.createCancelablePromise)(async k=>{const F=[...I.resourcePreviews];return F[E]=await A(F[E]),{...I,resourcePreviews:F}}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:k})=>k===g.MergeState.Conflict)?this.setStatus(g.SyncStatus.HasConflicts):this.setStatus(g.SyncStatus.Syncing))}async doApply(b){if(!this.syncPreviewPromise)return g.SyncStatus.Idle;const A=await this.syncPreviewPromise;return A.resourcePreviews.some(({mergeState:I})=>I===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:A.resourcePreviews.some(({mergeState:I})=>I!==g.MergeState.Accepted)?g.SyncStatus.Syncing:(await this.applyResult(A.remoteUserData,A.lastSyncUserData,A.resourcePreviews.map(I=>[I,I.acceptResult]),b),this.syncPreviewPromise=null,await this.clearPreviewFolder(),g.SyncStatus.Idle)}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(b){const A=b.filter(({mergeState:I})=>I===g.MergeState.Conflict);(0,C.equals)(this._conflicts,A,(I,E)=>this.extUri.isEqual(I.previewResource,E.previewResource))||(this._conflicts=A,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async resolvePreviewContent(b){const A=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(A)for(const I of A.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,b))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,b))return I.remoteContent;if(this.extUri.isEqual(I.localResource,b))return I.localContent;if(this.extUri.isEqual(I.baseResource,b))return I.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,f.StorageScope.APPLICATION);try{await this.fileService.del(this.lastSyncResource)}catch(b){(0,l.toFileOperationResult)(b)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(b)}}async doGenerateSyncResourcePreview(b,A,I,E,k,F){const U=await this.generateSyncPreview(b,A,I,k,F),M=[];for(const H of U){const B=H.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(H.localChange===g.Change.None&&H.remoteChange===g.Change.None)M.push({...H,acceptedResource:B,acceptResult:{content:null,localChange:g.Change.None,remoteChange:g.Change.None},mergeState:g.MergeState.Accepted});else{const Z=E?await this.getMergeResult(H,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(H.previewResource,T.VSBuffer.fromString(Z?.content||""));const V=Z&&!Z.hasConflicts?await this.getAcceptResult(H,H.previewResource,void 0,F):void 0;M.push({...H,acceptResult:V,mergeState:Z?.hasConflicts?g.MergeState.Conflict:V?g.MergeState.Accepted:g.MergeState.Preview,localChange:V?V.localChange:Z?Z.localChange:H.localChange,remoteChange:V?V.remoteChange:Z?Z.remoteChange:H.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:A,resourcePreviews:M,isLastSyncFromCurrentMachine:I}}async getLastSyncUserData(){let b=this.getStoredLastSyncUserDataStateContent();if(b||(b=await this.migrateLastSyncUserData()),!b)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const A=JSON.parse(b),I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!A.version&&!!I&&A.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${A.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;let E,k=1;for(;E===void 0&&k++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===A.ref?E=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.FileOperationError&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof g.UserDataSyncError)throw F;this.logService.error(F,k)}}if(E===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,A.ref,this.collection,this.syncHeaders);E=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:E})}catch(F){if(F instanceof g.UserDataSyncError&&F.code===g.UserDataSyncErrorCode.NotFound)this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return E===void 0?null:{...A,syncData:E}}async updateLastSyncUserData(b,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),E={ref:b.ref,version:I,...A};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(E),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData(b)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,f.StorageScope.APPLICATION)}async readLastSyncStoredRemoteUserData(){const b=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const A=b?JSON.parse(b):void 0;if(r(A))return A}catch(A){this.logService.error(A)}}async writeLastSyncStoredRemoteUserData(b){await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(b)))}async migrateLastSyncUserData(){try{const b=await this.fileService.readFile(this.lastSyncResource),A=JSON.parse(b.value.toString());await this.fileService.del(this.lastSyncResource),A.ref&&A.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...A,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:A.content===null?null:JSON.parse(A.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,A)}catch(b){b instanceof l.FileOperationError&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(b)}return this.storageService.get(this.lastSyncUserDataStateKey,f.StorageScope.APPLICATION)}async getRemoteUserData(b){const{ref:A,content:I}=await this.getUserData(b);let E=null;return I!==null&&(E=this.parseSyncData(I)),{ref:A,syncData:E}}parseSyncData(b){try{const A=JSON.parse(b);if(t(A))return A}catch(A){this.logService.error(A)}throw new g.UserDataSyncError((0,p.localize)(1,null),g.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(b){const A=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,A,this.collection,this.syncHeaders)}async updateRemoteUserData(b,A){const I=await this.currentMachineIdPromise,E={version:this.version,machineId:I,content:b};try{return A=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(E),A,this.collection,this.syncHeaders),{ref:A,syncData:E}}catch(k){throw k instanceof g.UserDataSyncError&&k.code===g.UserDataSyncErrorCode.TooLarge&&(k=new g.UserDataSyncError(k.message,k.code,this.resource)),k}}async backupLocal(b){const A={version:this.version,content:b};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(A),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==g.SyncStatus.Idle&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus(g.SyncStatus.Idle),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i,e.AbstractSynchroniser=i=we([X(2,l.IFileService),X(3,m.IEnvironmentService),X(4,f.IStorageService),X(5,g.IUserDataSyncStoreService),X(6,g.IUserDataSyncLocalStoreService),X(7,g.IUserDataSyncEnablementService),X(8,S.ITelemetryService),X(9,g.IUserDataSyncLogService),X(10,h.IConfigurationService),X(11,R.IUriIdentityService)],i);let n=class extends i{constructor(b,A,I,E,k,F,U,M,H,B,Z,V,ie){super(A,I,E,k,F,U,M,H,B,Z,V,ie),this.file=b,this._register(this.fileService.watch(this.extUri.dirname(b))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(b,A,I){try{A?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(b),I?void 0:A):await this.fileService.createFile(this.file,T.VSBuffer.fromString(b),{overwrite:I})}catch(E){throw E instanceof l.FileOperationError&&E.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||E instanceof l.FileOperationError&&E.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new g.UserDataSyncError(E.message,g.UserDataSyncErrorCode.LocalPreconditionFailed):E}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(b){if(!(b instanceof l.FileOperationError&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw b}}onFileChanges(b){b.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=n,e.AbstractFileSynchroniser=n=we([X(3,l.IFileService),X(4,m.IEnvironmentService),X(5,f.IStorageService),X(6,g.IUserDataSyncStoreService),X(7,g.IUserDataSyncLocalStoreService),X(8,g.IUserDataSyncEnablementService),X(9,S.ITelemetryService),X(10,g.IUserDataSyncLogService),X(11,h.IConfigurationService),X(12,R.IUriIdentityService)],n);let a=class extends n{constructor(b,A,I,E,k,F,U,M,H,B,Z,V,ie,z){super(b,A,I,E,k,F,U,M,H,B,Z,ie,z),this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(b,A){const I=[],E=(0,L.parse)(b,I,{allowEmptyContent:!0,allowTrailingComma:!0});return I.length>0||!(0,P.isUndefined)(E)&&A!==Array.isArray(E)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=a,e.AbstractJsonFileSynchroniser=a=we([X(3,l.IFileService),X(4,m.IEnvironmentService),X(5,f.IStorageService),X(6,g.IUserDataSyncStoreService),X(7,g.IUserDataSyncLocalStoreService),X(8,g.IUserDataSyncEnablementService),X(9,S.ITelemetryService),X(10,g.IUserDataSyncLogService),X(11,g.IUserDataSyncUtilService),X(12,h.IConfigurationService),X(13,R.IUriIdentityService)],a);let u=class{constructor(b,A,I,E,k,F,U){this.resource=b,this.userDataProfilesService=A,this.environmentService=I,this.logService=E,this.fileService=k,this.storageService=F,this.extUri=U.extUri,this.lastSyncResource=(0,g.getLastSyncResourceUri)(void 0,this.resource,I,this.extUri)}async initialize({ref:b,content:A}){if(!A){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(A);if(I)try{await this.doInitialize({ref:b,syncData:I})}catch(E){this.logService.error(E)}}parseSyncData(b){try{const A=JSON.parse(b);if(t(A))return A}catch(A){this.logService.error(A)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(b,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const I={ref:b.ref,version:void 0,...A};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(I),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(b)))}};e.AbstractInitializer=u,e.AbstractInitializer=u=we([X(1,s.IUserDataProfilesService),X(2,m.IEnvironmentService),X(3,y.ILogService),X(4,l.IFileService),X(5,f.IStorageService),X(6,R.IUriIdentityService)],u)}),define(le[120],ue([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,36,7,4,77,10,17,18,29,20,40,243,115,25,63]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t,o,i,n,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=b,e.stringify=A;async function d(F,U){const M=JSON.parse(F.content);if(F.version===1||F.version===2){const H=(await U.getInstalled(y.ExtensionType.System)).filter(B=>B.isBuiltin);for(const B of M)F.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),F.version===2&&H.every(Z=>!(0,m.areSameExtensions)(Z.identifier,B.identifier))&&(B.installed=!0)}return M}function b(F){return JSON.parse(F.content)}function A(F,U){return F.sort((M,H)=>!M.identifier.uuid&&H.identifier.uuid?-1:M.identifier.uuid&&!H.identifier.uuid?1:(0,_.compare)(M.identifier.id,H.identifier.id)),U?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}let I=class extends o.AbstractSynchroniser{constructor(U,M,H,B,Z,V,ie,z,q,te,se,ce,W,Q,G,j,N){super({syncResource:a.SyncResource.Extensions,profile:U},M,B,H,Z,V,ie,ce,W,te,se,G),this.extensionManagementService=z,this.ignoredExtensionsManagementService=q,this.instantiationService=N,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(E),this._register(D.Event.any(D.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:$})=>!!$)),D.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),D.Event.filter(j.onDidChange,Y=>Y.valueChanges.some(({profile:$,changes:x})=>this.syncResource.profile.id===$.id&&x.some(J=>J.key===h.DISABLED_EXTENSIONS_STORAGE_PATH))),Q.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(U,M){const H=U.syncData?await d(U.syncData,this.extensionManagementService):null,B=M?.skippedExtensions??[],Z=M?.builtinExtensions??null,V=M?.syncData?await d(M.syncData,this.extensionManagementService):null,{localExtensions:ie,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);H?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:te}=(0,i.merge)(ie,H,V,B,z,Z),se={local:q,remote:te,content:this.getPreviewContent(ie,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?a.Change.Modified:a.Change.None,remoteChange:te!==null?a.Change.Modified:a.Change.None},ce=this.stringify(ie,!1);return[{skippedExtensions:B,builtinExtensions:Z,baseResource:this.baseResource,baseContent:V?this.stringify(V,!1):ce,localResource:this.localResource,localContent:ce,localExtensions:ie,remoteResource:this.remoteResource,remoteExtensions:H,remoteContent:H?this.stringify(H,!1):null,previewResource:this.previewResource,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(U){const M=U.syncData?await d(U.syncData,this.extensionManagementService):null,{localExtensions:H,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,i.merge)(H,M,M,U.skippedExtensions||[],B,U.builtinExtensions||[]);return Z!==null}getPreviewContent(U,M,H,B){const Z=[...M,...H],V=new Set,ie=z=>{V.add(z.id.toLowerCase()),z.uuid&&V.add(z.uuid)};Z.forEach(({identifier:z})=>ie(z)),B.forEach(ie);for(const z of U)V.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&V.has(z.identifier.uuid)||Z.push(z);return this.stringify(Z,!1)}async getMergeResult(U,M){return{...U.previewResult,hasConflicts:!1}}async getAcceptResult(U,M,H,B){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(U);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(U);if(this.extUri.isEqual(M,this.previewResource))return U.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(U){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),B=(0,i.merge)(U.localExtensions,null,null,U.skippedExtensions,H,U.builtinExtensions),{local:Z,remote:V}=B;return{content:U.localContent,local:Z,remote:V,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?a.Change.Modified:a.Change.None,remoteChange:V!==null?a.Change.Modified:a.Change.None}}async acceptRemote(U){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),B=U.remoteContent?JSON.parse(U.remoteContent):null;if(B!==null){const Z=(0,i.merge)(U.localExtensions,B,U.localExtensions,[],H,U.builtinExtensions),{local:V,remote:ie}=Z;return{content:U.remoteContent,local:V,remote:ie,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?a.Change.Modified:a.Change.None,remoteChange:ie!==null?a.Change.Modified:a.Change.None}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:a.Change.None,remoteChange:a.Change.None}}async applyResult(U,M,H,B){let{skippedExtensions:Z,builtinExtensions:V,localExtensions:ie}=H[0][0];const{local:z,remote:q,localChange:te,remoteChange:se}=H[0][1];if(te===a.Change.None&&se===a.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),te!==a.Change.None&&(await this.backupLocal(JSON.stringify(ie)),Z=await this.localExtensionsProvider.updateLocalExtensions(z.added,z.removed,z.updated,Z,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ce=JSON.stringify(q.all);U=await this.updateRemoteUserData(ce,B?null:U.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(W=>W.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(W=>W.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(W=>W.identifier.id))}.`:""}`)}M?.ref!==U.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),V=this.computeBuiltinExtensions(ie,V),await this.updateLastSyncUserData(U,{skippedExtensions:Z,builtinExtensions:V}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(ce=>ce.identifier.id))}.`:""}`))}computeBuiltinExtensions(U,M){const H=new Set,B=[];for(const Z of U)H.add(Z.identifier.id.toLowerCase()),Z.installed||B.push(Z.identifier);if(M)for(const Z of M)H.has(Z.id.toLowerCase())||B.push(Z);return B}async resolveContent(U){if(this.extUri.isEqual(this.remoteResource,U)||this.extUri.isEqual(this.baseResource,U)||this.extUri.isEqual(this.localResource,U)||this.extUri.isEqual(this.acceptedResource,U)){const M=await this.resolvePreviewContent(U);return M&&this.stringify(JSON.parse(M),!0)}return null}stringify(U,M){return A(U,M)}async hasLocalData(){try{const{localExtensions:U}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(U.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=I,e.ExtensionsSynchroniser=I=we([X(2,P.IEnvironmentService),X(3,w.IFileService),X(4,g.IStorageService),X(5,a.IUserDataSyncStoreService),X(6,a.IUserDataSyncLocalStoreService),X(7,h.IExtensionManagementService),X(8,n.IIgnoredExtensionsManagementService),X(9,a.IUserDataSyncLogService),X(10,v.IConfigurationService),X(11,a.IUserDataSyncEnablementService),X(12,s.ITelemetryService),X(13,l.IExtensionStorageService),X(14,r.IUriIdentityService),X(15,u.IUserDataProfileStorageService),X(16,f.IInstantiationService)],I);let E=class{constructor(U,M,H,B,Z,V){this.extensionManagementService=U,this.userDataProfileStorageService=M,this.extensionGalleryService=H,this.ignoredExtensionsManagementService=B,this.instantiationService=Z,this.logService=V}async getLocalExtensions(U){const M=await this.extensionManagementService.getInstalled(void 0,U.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);return{localExtensions:await this.withProfileScopedServices(U,async(Z,V)=>{const ie=Z.getDisabledExtensions();return M.map(z=>{const{identifier:q,isBuiltin:te,manifest:se,preRelease:ce,pinned:W,isApplicationScoped:Q}=z,G={identifier:q,preRelease:ce,version:se.version,pinned:!!W};Q&&!(0,y.isApplicationScopedExtension)(se)&&(G.isApplicationScoped=Q),ie.some(j=>(0,m.areSameExtensions)(j,q))&&(G.disabled=!0),te||(G.installed=!0);try{const j=V.getKeysForSync({id:q.id,version:se.version});if(j){const N=V.getExtensionState(z,!0)||{};G.state=Object.keys(N).reduce((Y,$)=>(j.includes($)&&(Y[$]=N[$]),Y),{})}}catch(j){this.logService.info(`${(0,o.getSyncResourceLogLabel)(a.SyncResource.Extensions,U)}: Error while parsing extension state`,(0,T.getErrorMessage)(j))}return G})}),ignoredExtensions:H}}async updateLocalExtensions(U,M,H,B,Z){const V=(0,o.getSyncResourceLogLabel)(a.SyncResource.Extensions,Z),ie=[],z=new Map,q=[],te=[],se=await this.extensionManagementService.getInstalled(void 0,Z.extensionsResource);if((U.length||H.length)&&await this.withProfileScopedServices(Z,async(Q,G)=>{await C.Promises.settled([...U,...H].map(async j=>{const N=se.find(x=>(0,m.areSameExtensions)(x.identifier,j.identifier));if(N&&N.isBuiltin){j.state&&N.manifest.version===j.version&&this.updateExtensionState(j.state,N,N.manifest.version,G),Q.getDisabledExtensions().some(J=>(0,m.areSameExtensions)(J,j.identifier))!==!!j.disabled&&(j.disabled?(this.logService.trace(`${V}: Disabling extension...`,j.identifier.id),await Q.disableExtension(j.identifier),this.logService.info(`${V}: Disabled extension`,j.identifier.id)):(this.logService.trace(`${V}: Enabling extension...`,j.identifier.id),await Q.enableExtension(j.identifier),this.logService.info(`${V}: Enabled extension`,j.identifier.id))),q.push(j.identifier);return}const Y=j.pinned?j.version:void 0,$=(await this.extensionGalleryService.getExtensions([{...j.identifier,version:Y,preRelease:Y?void 0:j.preRelease}],c.CancellationToken.None))[0];if(j.state&&(N?N.manifest.version===j.version:$)&&this.updateExtensionState(j.state,N||$,N?.manifest.version,G),$)try{Q.getDisabledExtensions().some(J=>(0,m.areSameExtensions)(J,j.identifier))!==!!j.disabled&&(j.disabled?(this.logService.trace(`${V}: Disabling extension...`,j.identifier.id,$.version),await Q.disableExtension($.identifier),this.logService.info(`${V}: Disabled extension`,j.identifier.id,$.version)):(this.logService.trace(`${V}: Enabling extension...`,j.identifier.id,$.version),await Q.enableExtension($.identifier),this.logService.info(`${V}: Enabled extension`,j.identifier.id,$.version))),(!N||N.preRelease!==j.preRelease||N.pinned!==j.pinned||Y&&N.manifest.version!==Y)&&(await this.extensionManagementService.canInstall($)?(ie.push({extension:$,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,pinned:j.pinned,installPreReleaseVersion:j.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[h.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[h.EXTENSION_INSTALL_SOURCE_CONTEXT]:h.ExtensionInstallSource.SETTINGS_SYNC}}}),z.set($.identifier.id.toLowerCase(),j)):(this.logService.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),te.push(j)))}catch(x){te.push(j),this.logService.error(x),this.logService.info(`${V}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else te.push(j),this.logService.info(`${V}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),M.length){const Q=se.filter(({identifier:G,isBuiltin:j})=>!j&&M.some(N=>(0,m.areSameExtensions)(G,N)));await C.Promises.settled(Q.map(async G=>{this.logService.trace(`${V}: Uninstalling local extension...`,G.identifier.id),await this.extensionManagementService.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.logService.info(`${V}: Uninstalled local extension.`,G.identifier.id),q.push(G.identifier)}))}const ce=await this.extensionManagementService.installGalleryExtensions(ie);for(const{identifier:Q,local:G,error:j,source:N}of ce){const Y=N;if(G)this.logService.info(`${V}: Installed extension.`,Q.id,Y.version),q.push(Q);else{const $=z.get(Q.id.toLowerCase());$&&(te.push($),this.logService.info(`${V}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)),j instanceof h.ExtensionManagementError&&[h.ExtensionManagementErrorCode.Incompatible,h.ExtensionManagementErrorCode.IncompatibleApi,h.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,Y.displayName||Y.identifier.id):j&&this.logService.error(j)}}const W=[];for(const Q of B)q.some(G=>(0,m.areSameExtensions)(G,Q.identifier))||W.push(Q);for(const Q of te)W.some(G=>(0,m.areSameExtensions)(G.identifier,Q.identifier))||W.push(Q);return W}updateExtensionState(U,M,H,B){const Z=B.getExtensionState(M,!0)||{},V=H?B.getKeysForSync({id:M.identifier.id,version:H}):void 0;V?V.forEach(ie=>{Z[ie]=U[ie]}):Object.keys(U).forEach(ie=>Z[ie]=U[ie]),B.setExtensionState(M,Z,!0)}async withProfileScopedServices(U,M){return this.userDataProfileStorageService.withProfileScopedStorageService(U,async H=>{const B=new L.DisposableStore,Z=B.add(this.instantiationService.createChild(new S.ServiceCollection([g.IStorageService,H]))),V=B.add(Z.createInstance(p.GlobalExtensionEnablementService)),ie=B.add(Z.createInstance(l.ExtensionStorageService));try{return await M(V,ie)}finally{B.dispose()}})}};e.LocalExtensionsProvider=E,e.LocalExtensionsProvider=E=we([X(0,h.IExtensionManagementService),X(1,u.IUserDataProfileStorageService),X(2,h.IExtensionGalleryService),X(3,n.IIgnoredExtensionsManagementService),X(4,f.IInstantiationService),X(5,a.IUserDataSyncLogService)],E);let k=class extends o.AbstractInitializer{constructor(U,M,H,B,Z,V,ie,z){super(a.SyncResource.Extensions,B,Z,V,H,ie,z),this.extensionManagementService=U,this.ignoredExtensionsManagementService=M}async parseExtensions(U){return U.syncData?await d(U.syncData,this.extensionManagementService):null}generatePreview(U,M){const H=[],B=[],Z=[];for(const V of U){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(V.identifier.id))continue;const ie=M.find(z=>(0,m.areSameExtensions)(z.identifier,V.identifier));ie?(H.push(ie),V.disabled&&Z.push(V.identifier)):V.installed&&(B.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&Z.push(V.identifier))}return{installedExtensions:H,newExtensions:B,disabledExtensions:Z,remoteExtensions:U}}};e.AbstractExtensionsInitializer=k,e.AbstractExtensionsInitializer=k=we([X(0,h.IExtensionManagementService),X(1,n.IIgnoredExtensionsManagementService),X(2,w.IFileService),X(3,t.IUserDataProfilesService),X(4,P.IEnvironmentService),X(5,R.ILogService),X(6,g.IStorageService),X(7,r.IUriIdentityService)],k)}),define(le[121],ue([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,247,25,20,63,4]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=n;const o="globalState.argv.",i=["locale"];function n(I,E){const k=I.storage?Object.keys(I.storage).sort():[],F={};return k.forEach(U=>F[U]=I.storage[U]),I.storage=F,E?(0,O.toFormattedString)(I,{}):JSON.stringify(I)}const a=1;let u=class extends f.AbstractSynchroniser{constructor(E,k,F,U,M,H,B,Z,V,ie,z,q,te,se){super({syncResource:g.SyncResource.GlobalState,profile:E},k,U,Z,q,M,H,V,ie,B,z,te),this.userDataProfileStorageService=F,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=se.createInstance(d),this._register(U.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(U.onDidFilesChange,ce=>ce.contains(this.environmentService.argvResource)),T.Event.filter(F.onDidChange,ce=>!!(ce.targetChanges.some(W=>this.syncResource.profile.id===W.id)||ce.valueChanges.some(({profile:W,changes:Q})=>this.syncResource.profile.id===W.id&&Q.some(G=>G.target===l.StorageTarget.USER)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(E,k,F){const U=E.syncData?JSON.parse(E.syncData.content):null;k=k===null&&F?E:k;const M=k&&k.syncData?JSON.parse(k.syncData.content):null,H=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=await this.getStorageKeys(M),{local:Z,remote:V}=(0,R.merge)(H.storage,U?U.storage:null,M?M.storage:null,B,this.logService),ie={content:null,local:Z,remote:V,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:V.all!==null?g.Change.Modified:g.Change.None},z=n(H,!1);return[{baseResource:this.baseResource,baseContent:M?n(M,!1):z,localResource:this.localResource,localContent:z,localUserData:H,remoteResource:this.remoteResource,remoteContent:U?n(U,!1):null,previewResource:this.previewResource,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async hasRemoteChanged(E){const k=E.syncData?JSON.parse(E.syncData.content):null;if(k===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),U=await this.getStorageKeys(k),{remote:M}=(0,R.merge)(F.storage,k.storage,k.storage,U,this.logService);return M.all!==null}async getMergeResult(E,k){return{...E.previewResult,hasConflicts:!1}}async getAcceptResult(E,k,F,U){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(E);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(E);if(this.extUri.isEqual(k,this.previewResource))return E.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:g.Change.None,remoteChange:g.Change.Modified}}async acceptRemote(E){if(E.remoteContent!==null){const k=JSON.parse(E.remoteContent),{local:F,remote:U}=(0,R.merge)(E.localUserData.storage,k.storage,null,E.storageKeys,this.logService);return{content:E.remoteContent,local:F,remote:U,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:U!==null?g.Change.Modified:g.Change.None}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:g.Change.None,remoteChange:g.Change.None}}async applyResult(E,k,F,U){const{localUserData:M}=F[0][0],{local:H,remote:B,localChange:Z,remoteChange:V}=F[0][1];if(Z===g.Change.None&&V===g.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Z!==g.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.localGlobalStateProvider.writeLocalGlobalState(H,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==g.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const ie=JSON.stringify({storage:B.all});E=await this.updateRemoteUserData(ie,U?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${B.added.length?` Added: ${B.added}.`:""}${B.updated.length?` Updated: ${B.updated}.`:""}${B.removed.length?` Removed: ${B.removed}.`:""}`)}k?.ref!==E.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(E),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(E){if(this.extUri.isEqual(this.remoteResource,E)||this.extUri.isEqual(this.baseResource,E)||this.extUri.isEqual(this.localResource,E)||this.extUri.isEqual(this.acceptedResource,E)){const k=await this.resolvePreviewContent(E);return k&&n(JSON.parse(k),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${o}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(E){const k=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],U=[];for(const[B,Z]of k)Z.target===l.StorageTarget.USER?F.push(B):Z.target===l.StorageTarget.MACHINE&&U.push(B);const M=[...F,...U],H=E?.storage?Object.keys(E.storage).filter(B=>!B.startsWith(o)&&!M.includes(B)&&k.get(B)!==void 0):[];if(!L.isWeb){const B=[...g.ALL_SYNC_RESOURCES.map(Z=>(0,g.getEnablementKey)(Z)),g.SYNC_SERVICE_URL_TYPE];H.push(...B),U.push(...B)}return{user:F,machine:U,unregistered:H}}};e.GlobalStateSynchroniser=u,e.GlobalStateSynchroniser=u=we([X(2,r.IUserDataProfileStorageService),X(3,p.IFileService),X(4,g.IUserDataSyncStoreService),X(5,g.IUserDataSyncLocalStoreService),X(6,g.IUserDataSyncLogService),X(7,P.IEnvironmentService),X(8,g.IUserDataSyncEnablementService),X(9,y.ITelemetryService),X(10,v.IConfigurationService),X(11,l.IStorageService),X(12,w.IUriIdentityService),X(13,t.IInstantiationService)],u);let d=class{constructor(E,k,F,U){this.fileService=E,this.environmentService=k,this.userDataProfileStorageService=F,this.logService=U}async getLocalGlobalState(E){const k={};if(E.isDefault){const U=await this.getLocalArgvContent(),M=(0,D.parse)(U);for(const H of i)M[H]!==void 0&&(k[`${o}${H}`]={version:1,value:M[H]})}const F=await this.userDataProfileStorageService.readStorageData(E);for(const[U,M]of F)M.value&&M.target===l.StorageTarget.USER&&(k[U]={version:1,value:M.value});return{storage:k}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const E=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),E.value.toString()}catch(E){this.logService.debug((0,c.getErrorMessage)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:k,updated:F},U){const M=(0,f.getSyncResourceLogLabel)(g.SyncResource.GlobalState,U),H={},B=new Map,Z=await this.userDataProfileStorageService.readStorageData(U),V=(ie,z)=>{for(const q of ie){if(q.startsWith(o)){H[q.substring(o.length)]=z?z[q].value:void 0;continue}if(z){const te=z[q];te.value!==Z.get(q)?.value&&B.set(q,te.value)}else Z.get(q)!==void 0&&B.set(q,void 0)}};if(V(Object.keys(E),E),V(Object.keys(F),F),V(k),Object.keys(H).length){this.logService.trace(`${M}: Updating locale...`);const ie=await this.getLocalArgvContent();let z=ie;for(const q of Object.keys(H))z=(0,S.edit)(z,[q],H[q],{});ie!==z&&(this.logService.trace(`${M}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,C.VSBuffer.fromString(z)),this.logService.info(`${M}: Updated locale.`)),this.logService.info(`${M}: Updated locale`)}B.size&&(this.logService.trace(`${M}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(U,B,l.StorageTarget.USER),this.logService.info(`${M}: Updated global state`,[...B.keys()]))}};e.LocalGlobalStateProvider=d,e.LocalGlobalStateProvider=d=we([X(0,p.IFileService),X(1,P.IEnvironmentService),X(2,r.IUserDataProfileStorageService),X(3,g.IUserDataSyncLogService)],d);let b=class extends f.AbstractInitializer{constructor(E,k,F,U,M,H){super(g.SyncResource.GlobalState,F,U,M,k,E,H)}async doInitialize(E){const k=E.syncData?JSON.parse(E.syncData.content):null;if(!k){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},U={};for(const M of Object.keys(k.storage))M.startsWith(o)?F[M.substring(o.length)]=k.storage[M].value:this.storageService.get(M,l.StorageScope.PROFILE)===void 0&&(U[M]=k.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const H of Object.keys(F))M=(0,S.edit)(M,[H],F[H],{});await this.fileService.writeFile(this.environmentService.argvResource,C.VSBuffer.fromString(M))}if(Object.keys(U).length){const M=[];for(const H of Object.keys(U))M.push({key:H,value:U[H],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.storageService.storeAll(M,!0)}}};e.GlobalStateInitializer=b,e.GlobalStateInitializer=b=we([X(0,l.IStorageService),X(1,p.IFileService),X(2,s.IUserDataProfilesService),X(3,P.IEnvironmentService),X(4,g.IUserDataSyncLogService),X(5,w.IUriIdentityService)],b);let A=class{constructor(E,k,F,U,M){this.userDataSyncStoreClient=E,this.storageService=k,this.environmentService=F,this.fileService=U,this.logService=M}getSyncStoreType(E){return this.parseGlobalState(E)?.storage[g.SYNC_SERVICE_URL_TYPE]?.value}async sync(E){const k=(0,g.createSyncHeaders)((0,_.generateUuid)());try{return await this.doSync(E,k)}catch(F){if(F instanceof g.UserDataSyncError)switch(F.code){case g.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(E,k)}throw F}}async doSync(E,k){const F=await this.userDataSyncStoreClient.readResource(g.SyncResource.GlobalState,null,void 0,k),U=this.parseGlobalState(F)||{storage:{}};U.storage[g.SYNC_SERVICE_URL_TYPE]={value:E,version:a};const M=await(0,m.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),H={version:a,machineId:M,content:n(U,!1)};await this.userDataSyncStoreClient.writeResource(g.SyncResource.GlobalState,JSON.stringify(H),F.ref,void 0,k)}parseGlobalState({content:E}){if(!E)return null;const k=JSON.parse(E);if((0,f.isSyncData)(k))return k?JSON.parse(k.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=A,e.UserDataSyncStoreTypeSynchronizer=A=we([X(1,l.IStorageService),X(2,P.IEnvironmentService),X(3,p.IFileService),X(4,h.ILogService)],A)}),define(le[122],ue([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,244,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=R;function R(r,t,o){try{const i=JSON.parse(r);if(!t)return(0,L.isUndefined)(i.all)?null:i.all;switch(O.OS){case O.OperatingSystem.Macintosh:return(0,L.isUndefined)(i.mac)?null:i.mac;case O.OperatingSystem.Linux:return(0,L.isUndefined)(i.linux)?null:i.linux;case O.OperatingSystem.Windows:return(0,L.isUndefined)(i.windows)?null:i.windows}}catch(i){return o.error(i),null}}let g=class extends w.AbstractJsonFileSynchroniser{constructor(t,o,i,n,a,u,d,b,A,I,E,k,F){super(t.keybindingsResource,{syncResource:S.SyncResource.Keybindings,profile:t},o,b,A,I,i,n,d,k,a,E,u,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(u.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(t,o,i,n){const a=t.syncData?R(t.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;o=o===null&&i?t:o;const u=o?this.getKeybindingsContentFromLastSyncUserData(o):null,d=await this.getLocalFileContent(),b=await this.getFormattingOptions();let A=null,I=!1,E=!1,k=!1;if(a){let M=d?d.value.toString():"[]";if(M=M||"[]",this.hasErrors(M,!0))throw new S.UserDataSyncError((0,_.localize)(0,null),S.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==M||u!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const H=await(0,f.merge)(M,a,u,b,this.userDataSyncUtilService);H.hasChanges&&(A=H.mergeContent,k=H.hasConflicts,I=k||H.mergeContent!==M,E=k||H.mergeContent!==a)}}else d&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=d.value.toString(),E=!0);const F={content:k?u:A,localChange:I?d?S.Change.Modified:S.Change.Added:S.Change.None,remoteChange:E?S.Change.Modified:S.Change.None,hasConflicts:k},U=d?d.value.toString():null;return[{fileContent:d,baseResource:this.baseResource,baseContent:u,localResource:this.localResource,localContent:U,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const o=this.getKeybindingsContentFromLastSyncUserData(t);if(o===null)return!0;const i=await this.getLocalFileContent(),n=i?i.value.toString():"",a=await this.getFormattingOptions(),u=await(0,f.merge)(n||"[]",o,o,a,this.userDataSyncUtilService);return u.hasConflicts||u.mergeContent!==o}async getMergeResult(t,o){return t.previewResult}async getAcceptResult(t,o,i,n){if(this.extUri.isEqual(o,this.localResource))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:S.Change.None,remoteChange:S.Change.Modified};if(this.extUri.isEqual(o,this.remoteResource))return{content:t.remoteContent,localChange:S.Change.Modified,remoteChange:S.Change.None};if(this.extUri.isEqual(o,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i,localChange:S.Change.Modified,remoteChange:S.Change.Modified};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(t,o,i,n){const{fileContent:a}=i[0][0];let{content:u,localChange:d,remoteChange:b}=i[0][1];if(d===S.Change.None&&b===S.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u,!0)))throw new S.UserDataSyncError((0,_.localize)(1,null),S.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(d!==S.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(u||"[]",a,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),b!==S.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(u||"[]",t.syncData?.content);t=await this.updateRemoteUserData(A,n?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(t,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const o=(0,D.parse)(t.value.toString());if((0,C.isNonEmptyArray)(o))return!0}}catch(t){if(t.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.baseResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)?this.resolvePreviewContent(t):null}getKeybindingsContentFromLastSyncUserData(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.syncKeybindingsPerPlatform()?null:R(t.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(t,o){let i={};try{i=JSON.parse(o||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=t,O.OS){case O.OperatingSystem.Macintosh:i.mac=t;break;case O.OperatingSystem.Linux:i.linux=t;break;case O.OperatingSystem.Windows:i.windows=t;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=g,e.KeybindingsSynchroniser=g=we([X(2,S.IUserDataSyncStoreService),X(3,S.IUserDataSyncLocalStoreService),X(4,S.IUserDataSyncLogService),X(5,v.IConfigurationService),X(6,S.IUserDataSyncEnablementService),X(7,p.IFileService),X(8,P.IEnvironmentService),X(9,h.IStorageService),X(10,S.IUserDataSyncUtilService),X(11,m.ITelemetryService),X(12,l.IUriIdentityService)],g);let s=class extends w.AbstractInitializer{constructor(t,o,i,n,a,u){super(S.SyncResource.Keybindings,o,i,n,t,a,u)}async doInitialize(t){const o=t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null;if(!o){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,c.VSBuffer.fromString(o)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),o=(0,D.parse)(t.value.toString());return!(0,C.isNonEmptyArray)(o)}catch(t){return t.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}getKeybindingsContentFromSyncContent(t){try{return R(t,!0,this.logService)}catch(o){return this.logService.error(o),null}}};e.KeybindingsInitializer=s,e.KeybindingsInitializer=s=we([X(0,p.IFileService),X(1,y.IUserDataProfilesService),X(2,P.IEnvironmentService),X(3,S.IUserDataSyncLogService),X(4,h.IStorageService),X(5,l.IUriIdentityService)],s)}),define(le[123],ue([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,248,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=S;function f(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function S(s){const r=JSON.parse(s);return f(r)?r:{settings:s}}let R=class extends l.AbstractJsonFileSynchroniser{constructor(r,t,o,i,n,a,u,d,b,A,I,E,k,F){super(r.settingsResource,{syncResource:w.SyncResource.Settings,profile:r},t,o,i,n,a,u,I,E,d,b,A,F),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(r,t),i=this.getSettingsSyncContent(o),n=new O.ConfigurationModelParser(w.USER_DATA_SYNC_CONFIGURATION_SCOPE,this.logService);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(w.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,o){const i=await this.getLocalFileContent(),n=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);t=t===null&&o?r:t;const u=t?this.getSettingsSyncContent(t):null,d=await this.getIgnoredSettings();let b=null,A=!1,I=!1,E=!1;if(a){let M=i?i.value.toString().trim():"{}";M=M||"{}",this.validateContent(M),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,y.merge)(M,a.settings,u?u.settings:null,d,[],n);b=H.localContent||H.remoteContent,A=H.localContent!==null,I=H.remoteContent!==null,E=H.hasConflicts}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),b=i.value.toString().trim()||"{}",this.validateContent(b),I=!0);const k=i?i.value.toString():null,F=u?.settings??null,U={content:E?F:b,localChange:A?w.Change.Modified:w.Change.None,remoteChange:I?w.Change.Modified:w.Change.None,hasConflicts:E};return[{fileContent:i,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:k,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getSettingsSyncContent(r);if(t===null)return!0;const o=await this.getLocalFileContent(),i=o?o.value.toString().trim():"",n=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(i||"{}",t.settings,t.settings,n,[],a).remoteContent!==null}async getMergeResult(r,t){const o=await this.getFormattingOptions(),i=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,y.updateIgnoredSettings)(r.previewResult.content,"{}",i,o):null}}async getAcceptResult(r,t,o,i){const n=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,y.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,n):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,y.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,n):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.extUri.isEqual(t,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o!==null?(0,y.updateIgnoredSettings)(o,r.fileContent?r.fileContent.value.toString():"{}",a,n):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,o,i){const{fileContent:n}=o[0][0];let{content:a,localChange:u,remoteChange:d}=o[0][1];if(u===w.Change.None&&d===w.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),u!==w.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),n&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(n.value.toString()))),await this.updateLocalFileContent(a,n,i),await this.configurationService.reloadConfiguration(D.ConfigurationTarget.USER_LOCAL),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==w.Change.None){const b=await this.getFormattingOptions(),A=this.getSettingsSyncContent(r),I=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,A?A.settings:"{}",I,b),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),i?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r)return!(0,y.isEmpty)(r.value.toString())}catch(r){if(r.fileOperationResult!==v.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r)?this.resolvePreviewContent(r):null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const o=await this.getFormattingOptions(),i=await this.getIgnoredSettings();t=(0,y.updateIgnoredSettings)(t,"{}",i,o)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return S(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=this._register(c.Event.any(c.Event.filter(this.extensionManagementService.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),c.Event.filter(this.extensionManagementService.onDidUninstallExtension,i=>!i.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0}))}const t=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(t,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new w.UserDataSyncError((0,T.localize)(0,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.SettingsSynchroniser=R,e.SettingsSynchroniser=R=we([X(2,v.IFileService),X(3,L.IEnvironmentService),X(4,P.IStorageService),X(5,w.IUserDataSyncStoreService),X(6,w.IUserDataSyncLocalStoreService),X(7,w.IUserDataSyncLogService),X(8,w.IUserDataSyncUtilService),X(9,D.IConfigurationService),X(10,w.IUserDataSyncEnablementService),X(11,p.ITelemetryService),X(12,_.IExtensionManagementService),X(13,h.IUriIdentityService)],R);let g=class extends l.AbstractInitializer{constructor(r,t,o,i,n,a){super(w.SyncResource.Settings,t,o,i,r,n,a)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,C.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===v.FileOperationResult.FILE_NOT_FOUND}}parseSettingsSyncContent(r){try{return S(r)}catch(t){this.logService.error(t)}return null}};e.SettingsInitializer=g,e.SettingsInitializer=g=we([X(0,v.IFileService),X(1,m.IUserDataProfilesService),X(2,L.IEnvironmentService),X(3,w.IUserDataSyncLogService),X(4,P.IStorageService),X(5,h.IUriIdentityService)],g)}),define(le[124],ue([0,1,15,3,30,22,16,7,17,18,29,20,40,245,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=y;function y(S){return JSON.parse(S.content)}let w=class extends h.AbstractSynchroniser{constructor(R,g,s,r,t,o,i,n,a,u,d,b){super({syncResource:l.SyncResource.Snippets,profile:R},g,r,s,t,o,i,u,d,n,a,b),this.version=1,this.snippetsFolder=R.snippetsHome,this._register(this.fileService.watch(s.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(c.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(R,g,s){const r=await this.getSnippetsFileContents(),t=this.toSnippetsContents(r),o=R.syncData?this.parseSnippets(R.syncData):null;g=g===null&&s?R:g;const i=g&&g.syncData?this.parseSnippets(g.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,m.merge)(t,o,i);return this.getResourcePreviews(n,r,o||{},i||{})}async hasRemoteChanged(R){const g=R.syncData?this.parseSnippets(R.syncData):null;if(g===null)return!0;const s=await this.getSnippetsFileContents(),r=this.toSnippetsContents(s),t=(0,m.merge)(r,g,g);return Object.keys(t.remote.added).length>0||Object.keys(t.remote.updated).length>0||t.remote.removed.length>0||t.conflicts.length>0}async getMergeResult(R,g){return R.previewResult}async getAcceptResult(R,g,s,r){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:R.fileContent?R.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:R.fileContent?R.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:R.remoteContent,localChange:R.remoteContent!==null?R.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder))return s===void 0?{content:R.previewResult.content,localChange:R.previewResult.localChange,remoteChange:R.previewResult.remoteChange}:{content:s,localChange:s===null?R.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:s===null?R.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(R,g,s,r){const t=s.map(([o,i])=>({...o,acceptResult:i}));t.every(({localChange:o,remoteChange:i})=>o===l.Change.None&&i===l.Change.None)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),t.some(({localChange:o})=>o!==l.Change.None)&&(await this.updateLocalBackup(t),await this.updateLocalSnippets(t,r)),t.some(({remoteChange:o})=>o!==l.Change.None)&&(R=await this.updateRemoteSnippets(t,R,r)),g?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of t)try{await this.fileService.del(o)}catch{}}getResourcePreviews(R,g,s,r){const t=new Map;for(const o of Object.keys(R.local.added)){const i={content:R.local.added[o],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(R.local.updated)){const i={content:R.local.updated[o],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of R.local.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(R.remote.added)){const i={content:R.remote.added[o],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(R.remote.updated)){const i={content:R.remote.updated[o],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of R.remote.removed){const i={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of R.conflicts){const i={content:r[o]??null,hasConflicts:!0,localChange:g[o]?l.Change.Modified:l.Change.Added,remoteChange:s[o]?l.Change.Modified:l.Change.Added},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g))if(!t.has(o)){const i={content:g[o]?g[o].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=g[o]?g[o].value.toString():null;t.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:r[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:s[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...t.values()]}async resolveContent(R){return this.extUri.isEqualOrParent(R,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(R,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(R,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(R,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(R):null}async hasLocalData(){try{const R=await this.getSnippetsFileContents();if(Object.keys(R).length)return!0}catch{}return!1}async updateLocalBackup(R){const g={};for(const s of R)s.fileContent&&(g[this.extUri.basename(s.localResource)]=s.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(g)))}async updateLocalSnippets(R,g){for(const{fileContent:s,acceptResult:r,localResource:t,remoteResource:o,localChange:i}of R)if(i!==l.Change.None){const n=o?this.extUri.basename(o):this.extUri.basename(t),a=this.extUri.joinPath(this.snippetsFolder,n);i===l.Change.Deleted?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):i===l.Change.Added?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,C.VSBuffer.fromString(r.content),{overwrite:g}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,C.VSBuffer.fromString(r.content),g?void 0:s),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(R,g,s){const r=g.syncData?this.parseSnippets(g.syncData):{},t=(0,T.deepClone)(r);for(const{acceptResult:o,localResource:i,remoteResource:n,remoteChange:a}of R)if(a!==l.Change.None){const u=i?this.extUri.basename(i):this.extUri.basename(n);a===l.Change.Deleted?delete t[u]:t[u]=o.content}return(0,m.areSame)(r,t)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),g=await this.updateRemoteUserData(JSON.stringify(t),s?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),g}parseSnippets(R){return y(R)}toSnippetsContents(R){const g={};for(const s of Object.keys(R))g[s]=R[s].value.toString();return g}async getSnippetsFileContents(){const R={};let g;try{g=await this.fileService.resolve(this.snippetsFolder)}catch(s){if(s instanceof L.FileOperationError&&s.fileOperationResult===L.FileOperationResult.FILE_NOT_FOUND)return R;throw s}for(const s of g.children||[]){const r=s.resource,t=this.extUri.extname(r);if(t===".json"||t===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,r),i=await this.fileService.readFile(r);R[o]=i}}return R}};e.SnippetsSynchroniser=w,e.SnippetsSynchroniser=w=we([X(2,O.IEnvironmentService),X(3,L.IFileService),X(4,_.IStorageService),X(5,l.IUserDataSyncStoreService),X(6,l.IUserDataSyncLocalStoreService),X(7,l.IUserDataSyncLogService),X(8,D.IConfigurationService),X(9,l.IUserDataSyncEnablementService),X(10,v.ITelemetryService),X(11,P.IUriIdentityService)],w);let f=class extends h.AbstractInitializer{constructor(R,g,s,r,t,o){super(l.SyncResource.Snippets,g,s,r,R,t,o)}async doInitialize(R){const g=R.syncData?JSON.parse(R.syncData.content):null;if(!g){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const r of Object.keys(g)){const t=g[r];if(t){const o=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,r);await this.fileService.createFile(o,C.VSBuffer.fromString(t)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(R)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(R){return R.fileOperationResult===L.FileOperationResult.FILE_NOT_FOUND}}};e.SnippetsInitializer=f,e.SnippetsInitializer=f=we([X(0,L.IFileService),X(1,p.IUserDataProfilesService),X(2,O.IEnvironmentService),X(3,l.IUserDataSyncLogService),X(4,_.IStorageService),X(5,P.IUriIdentityService)],f)}),define(le[125],ue([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=h;function h(w,f){try{return JSON.parse(w).tasks??null}catch(S){return f.error(S),null}}let m=class extends P.AbstractFileSynchroniser{constructor(f,S,R,g,s,r,t,o,i,n,a,u){super(f.tasksResource,{syncResource:p.SyncResource.Tasks,profile:f},S,o,i,n,R,g,t,a,s,r,u),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(f,S,R,g){const s=f.syncData?h(f.syncData.content,this.logService):null;S=S===null&&R?f:S;const r=S?.syncData?h(S.syncData.content,this.logService):null,t=await this.getLocalFileContent();let o=null,i=!1,n=!1,a=!1;if(f.syncData){const b=t?t.value.toString():null;if(!r||r!==b||r!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=y(b,s,r);o=A.content,a=A.hasConflicts,i=A.hasLocalChanged,n=A.hasRemoteChanged}}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),o=t.value.toString(),n=!0);const u={content:a?r:o,localChange:i?t?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:n?p.Change.Modified:p.Change.None,hasConflicts:a},d=t?t.value.toString():null;return[{fileContent:t,baseResource:this.baseResource,baseContent:r,localResource:this.localResource,localContent:d,localChange:u.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:u.remoteChange,previewResource:this.previewResource,previewResult:u,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const S=f?.syncData?h(f.syncData.content,this.logService):null;if(S===null)return!0;const R=await this.getLocalFileContent(),g=R?R.value.toString():null,s=y(g,S,S);return s.hasLocalChanged||s.hasRemoteChanged}async getMergeResult(f,S){return f.previewResult}async getAcceptResult(f,S,R,g){if(this.extUri.isEqual(S,this.localResource))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.extUri.isEqual(S,this.remoteResource))return{content:f.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.extUri.isEqual(S,this.previewResource))return R===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:R,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(f,S,R,g){const{fileContent:s}=R[0][0],{content:r,localChange:t,remoteChange:o}=R[0][1];if(t===p.Change.None&&o===p.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),t!==p.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),s&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(s.value.toString()))),r?await this.updateLocalFileContent(r,s,g):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),o!==p.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(r));f=await this.updateRemoteUserData(i,g?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}S?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(f){return this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.baseResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)?this.resolvePreviewContent(f):null}toTasksSyncContent(f){return f?{tasks:f}:{}}};e.TasksSynchroniser=m,e.TasksSynchroniser=m=we([X(2,p.IUserDataSyncStoreService),X(3,p.IUserDataSyncLocalStoreService),X(4,p.IUserDataSyncLogService),X(5,c.IConfigurationService),X(6,p.IUserDataSyncEnablementService),X(7,D.IFileService),X(8,T.IEnvironmentService),X(9,O.IStorageService),X(10,L.ITelemetryService),X(11,_.IUriIdentityService)],m);let l=class extends P.AbstractInitializer{constructor(f,S,R,g,s,r){super(p.SyncResource.Tasks,S,R,g,f,s,r),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(f){const S=f.syncData?h(f.syncData.content,this.logService):null;if(!S){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,C.VSBuffer.fromString(S)),await this.updateLastSyncUserData(f)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=l,e.TasksInitializer=l=we([X(0,D.IFileService),X(1,v.IUserDataProfilesService),X(2,T.IEnvironmentService),X(3,p.IUserDataSyncLogService),X(4,O.IStorageService),X(5,_.IUriIdentityService)],l);function y(w,f,S){if(w===null&&f===null&&S===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const R=S!==w,g=S!==f;return!R&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:R&&!g?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!R?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],ue([0,1,45,22,16,7,17,18,29,20,40,246,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=l,e.parseUserDataProfilesManifest=y;let m=class extends P.AbstractSynchroniser{constructor(f,S,R,g,s,r,t,o,i,n,a,u,d){super({syncResource:h.SyncResource.Profiles,profile:f},S,g,s,r,t,o,a,u,i,n,d),this.userDataProfilesService=R,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?y(f.syncData):null}async getRemoteSyncedProfiles(f){const S=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(f,S);return R?.syncData?y(R.syncData):null}async generateSyncPreview(f,S,R){if(!this.userDataProfilesService.isEnabled())throw new h.UserDataSyncError("Cannot sync profiles because they are disabled",h.UserDataSyncErrorCode.LocalError);const g=f.syncData?y(f.syncData):null,s=S?.syncData?y(S.syncData):null,r=this.getLocalUserDataProfiles(),{local:t,remote:o}=(0,p.merge)(r,g,s,[]),i={local:t,remote:o,content:s?this.stringifyRemoteProfiles(s):null,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:o!==null?h.Change.Modified:h.Change.None},n=l(r,!1);return[{baseResource:this.baseResource,baseContent:s?this.stringifyRemoteProfiles(s):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:g?this.stringifyRemoteProfiles(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const S=f?.syncData?y(f.syncData):null,R=this.getLocalUserDataProfiles(),{remote:g}=(0,p.merge)(R,S,S,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async getMergeResult(f,S){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,S,R,g){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(S,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(f){const S=this.getLocalUserDataProfiles(),R=(0,p.merge)(S,null,null,[]),{local:g,remote:s}=R;return{content:f.localContent,local:g,remote:s,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:s!==null?h.Change.Modified:h.Change.None}}async acceptRemote(f){const S=f.remoteContent?JSON.parse(f.remoteContent):null,R=[],g=[];for(const s of this.getLocalUserDataProfiles()){const r=S?.find(t=>t.id===s.id);r&&(R.push({id:s.id,name:s.name,collection:r.collection}),g.push(s))}if(S!==null){const s=(0,p.merge)(g,S,R,[]),{local:r,remote:t}=s;return{content:f.remoteContent,local:r,remote:t,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:t!==null?h.Change.Modified:h.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:h.Change.None,remoteChange:h.Change.None}}async applyResult(f,S,R,g){const{local:s,remote:r,localChange:t,remoteChange:o}=R[0][1];t===h.Change.None&&o===h.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=R[0][0].remoteProfiles||[];if(i.length+(r?.added.length??0)-(r?.removed.length??0)>20)throw new h.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.",h.UserDataSyncErrorCode.LocalTooManyProfiles);if(t!==h.Change.None&&(await this.backupLocal(l(this.getLocalUserDataProfiles(),!1)),await Promise.all(s.removed.map(async n=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${n.name}' profile...`),await this.userDataProfilesService.removeProfile(n),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${n.name}'.`)})),await Promise.all(s.added.map(async n=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${n.name}' profile...`),await this.userDataProfilesService.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${n.name}'.`)})),await Promise.all(s.updated.map(async n=>{const a=this.userDataProfilesService.profiles.find(u=>u.id===n.id);a?(this.logService.trace(`${this.syncResourceLogLabel}: Updating '${n.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${n.name}'.`)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${n.id}' to update.`)}))),o!==h.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const n=[],a=i.length+(r?.added.length??0)<=20;if(a)for(const u of r?.added||[]){const d=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push(d),i.push({id:u.id,name:u.name,collection:d,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const u of r?.removed||[])i.splice(i.findIndex(({id:d})=>u.id===d),1);for(const u of r?.updated||[]){const d=i.find(({id:b})=>u.id===b);d&&i.splice(i.indexOf(d),1,{...d,id:u.id,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,g?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${a&&r?.added.length?` Added: ${JSON.stringify(r.added.map(u=>u.name))}.`:""}${r?.updated.length?` Updated: ${JSON.stringify(r.updated.map(u=>u.name))}.`:""}${r?.removed.length?` Removed: ${JSON.stringify(r.removed.map(u=>u.name))}.`:""}`)}catch(u){if(n.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const d of n)await this.userDataSyncStoreService.deleteCollection(d,this.syncHeaders)}throw u}for(const u of r?.removed||[])await this.userDataSyncStoreService.deleteCollection(u.collection,this.syncHeaders)}S?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,S){return this.updateRemoteUserData(this.stringifyRemoteProfiles(f),S)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(f){if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.baseResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)){const S=await this.resolvePreviewContent(f);return S&&(0,C.toFormattedString)(JSON.parse(S),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(f=>!f.isDefault&&!f.isTransient)}stringifyRemoteProfiles(f){return JSON.stringify([...f].sort((S,R)=>S.name.localeCompare(R.name)))}};e.UserDataProfilesManifestSynchroniser=m,e.UserDataProfilesManifestSynchroniser=m=we([X(2,v.IUserDataProfilesService),X(3,D.IFileService),X(4,T.IEnvironmentService),X(5,O.IStorageService),X(6,h.IUserDataSyncStoreService),X(7,h.IUserDataSyncLocalStoreService),X(8,h.IUserDataSyncLogService),X(9,c.IConfigurationService),X(10,h.IUserDataSyncEnablementService),X(11,L.ITelemetryService),X(12,_.IUriIdentityService)],m);function l(w,f){const S=[...w].sort((R,g)=>R.name.localeCompare(g.name)).map(R=>({id:R.id,name:R.name}));return f?(0,C.toFormattedString)(S,{}):JSON.stringify(S)}function y(w){return JSON.parse(w.content)}}),define(le[265],ue([0,1,3,2,5,16,17,18,25]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const v="sync.enable";let P=class extends c.Disposable{constructor(h,m,l,y){super(),this.storageService=h,this.telemetryService=m,this.environmentService=l,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new C.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new C.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(h.onDidChangeValue(O.StorageScope.APPLICATION,void 0,this._register(new c.DisposableStore))(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,O.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(v,{enabled:h}),this.storageService.store(v,h,O.StorageScope.APPLICATION,O.StorageTarget.MACHINE))}isResourceEnabled(h){return this.storageService.getBoolean((0,_.getEnablementKey)(h),O.StorageScope.APPLICATION,!0)}setResourceEnablement(h,m){if(this.isResourceEnabled(h)!==m){const l=(0,_.getEnablementKey)(h);this.storeResourceEnablement(l,m)}}getResourceSyncStateVersion(h){}storeResourceEnablement(h,m){this.storageService.store(h,m,O.StorageScope.APPLICATION,T.isWeb?O.StorageTarget.USER:O.StorageTarget.MACHINE)}onDidStorageChange(h){if(v===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const m=_.ALL_SYNC_RESOURCES.filter(l=>(0,_.getEnablementKey)(l)===h.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=we([X(0,O.IStorageService),X(1,L.ITelemetryService),X(2,D.IEnvironmentService),X(3,_.IUserDataSyncStoreManagementService)],P)}),define(le[266],ue([0,1,6,15,68,2,21,22,16,7,20,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let h=class extends D.Disposable{constructor(l,y,w,f,S){super(),this.environmentService=l,this.fileService=y,this.configurationService=w,this.logService=f,this.userDataProfilesService=S,this.cleanUp()}async cleanUp(){for(const y of this.userDataProfilesService.profiles)for(const w of p.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(w,y.isDefault?void 0:y.id))}catch(f){this.logService.error(f)}let l;try{l=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(y){(0,v.toFileOperationResult)(y)!==v.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(y);return}if(l.children){for(const y of l.children)if(y.isDirectory&&!this.userDataProfilesService.profiles.some(w=>w.id===y.name))try{this.logService.info("Deleting non existing profile from backup",y.resource.path),await this.fileService.del(y.resource,{recursive:!0})}catch(w){this.logService.error(w)}}}async getAllResourceRefs(l,y,w){const f=this.getResourceBackupHome(l,y,w);try{const S=await this.fileService.resolve(f);if(S.children)return S.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)}))}catch(S){if((0,v.toFileOperationResult)(S)!==v.FileOperationResult.FILE_NOT_FOUND)throw S}return[]}async resolveResourceContent(l,y,w,f){const S=this.getResourceBackupHome(l,w,f),R=(0,O.joinPath)(S,y);try{return(await this.fileService.readFile(R)).value.toString()}catch(g){return this.logService.error(g),null}}async writeResource(l,y,w,f,S){const R=this.getResourceBackupHome(l,f,S),g=(0,O.joinPath)(R,`${(0,T.toLocalISOString)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,c.VSBuffer.fromString(y))}catch(s){this.logService.error(s)}}getResourceBackupHome(l,y,w=this.environmentService.userDataSyncHome){return(0,O.joinPath)(w,...y?[y,l]:[l])}async cleanUpBackup(l){try{try{if(!await this.fileService.exists(l))return}catch{return}const y=await this.fileService.resolve(l);if(y.children){const w=y.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),f=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=w.filter(g=>Date.now()-this.getCreationTime(g)>f);const R=w.length-S.length;R<10&&(S=S.slice(10-R)),await C.Promises.settled(S.map(async g=>{this.logService.info("Deleting from backup",g.resource.path),await this.fileService.del(g.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=h,e.UserDataSyncLocalStoreService=h=we([X(0,_.IEnvironmentService),X(1,v.IFileService),X(2,L.IConfigurationService),X(3,p.IUserDataSyncLogService),X(4,P.IUserDataProfilesService)],h)}),define(le[87],ue([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=s,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const y="sync.currentMachineName",w="Safari",f="Chrome",S="Edge",R="Firefox",g="Android";function s(o){switch(o){case w:case f:case S:case R:case g:case(0,T.PlatformToString)(T.Platform.Web):return!0}return!1}function r(){return T.isSafari?w:T.isChrome?f:T.isEdge?S:T.isFirefox?R:T.isAndroid?g:(0,T.PlatformToString)(T.isWeb?T.Platform.Web:T.platform)}let t=class extends c.Disposable{static{l=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(i,n,a,u,d,b){super(),this.storageService=a,this.userDataSyncStoreService=u,this.logService=d,this.productService=b,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,p.getServiceMachineId)(i,n,a)}async getMachines(i){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(u=>({...u,isCurrent:u.id===n}))}async addCurrentMachine(i){const n=await this.currentMachineIdPromise,a=await this.readMachinesData(i);a.machines.some(({id:u})=>u===n)||(a.machines.push({id:n,name:this.computeCurrentMachineName(a.machines),platform:r()}),await this.writeMachinesData(a))}async removeCurrentMachine(i){const n=await this.currentMachineIdPromise,a=await this.readMachinesData(i),u=a.machines.filter(({id:d})=>d!==n);u.length!==a.machines.length&&(a.machines=u,await this.writeMachinesData(a))}async renameMachine(i,n,a){const u=await this.readMachinesData(a),d=u.machines.find(({id:b})=>b===i);if(d){d.name=n,await this.writeMachinesData(u);const b=await this.currentMachineIdPromise;i===b&&this.storageService.store(y,n,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.readMachinesData();for(const[a,u]of i){const d=n.machines.find(b=>b.id===a);d&&(d.disabled=u?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(i){const n=this.storageService.get(y,h.StorageScope.APPLICATION);if(n)return n;const a=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${r()} (${this.productService.nameShort})`,u=new RegExp(`${(0,D.escapeRegExpCharacters)(a)}\\s#(\\d+)`);let d=0;for(const b of i){const A=u.exec(b.name),I=A?parseInt(A[1]):0;d=I>d?I:d}return`${a} #${d+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const n=this.parse(this.userData);if(n.version!==l.VERSION)throw new Error((0,O.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(i){const n=JSON.stringify(i),a=await this.userDataSyncStoreService.writeResource(l.RESOURCE,n,this.userData?.ref||null);this.userData={ref:a,content:n},this._onDidChange.fire()}async readUserData(i){if(this.userData){const n=i&&i.latest?i.latest[l.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(l.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.logService.error(n)}return{version:l.VERSION,machines:[]}}};e.UserDataSyncMachinesService=t,e.UserDataSyncMachinesService=t=l=we([X(0,L.IEnvironmentService),X(1,_.IFileService),X(2,h.IStorageService),X(3,m.IUserDataSyncStoreService),X(4,m.IUserDataSyncLogService),X(5,P.IProductService)],t)}),define(le[267],ue([0,1,6,68,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",R="sync.sessionId",g="sync.storeUrl",s="sync.productQuality";let r=class extends L.Disposable{get syncUrl(){const i=this.storageService.get(g,m.StorageScope.APPLICATION);return i?P.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(g,i.toString(),m.StorageScope.APPLICATION,m.StorageTarget.MACHINE):this.storageService.remove(g,m.StorageScope.APPLICATION)}get productQuality(){return this.storageService.get(s,m.StorageScope.APPLICATION)}set productQuality(i){i?this.storageService.store(s,i,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE):this.storageService.remove(s,m.StorageScope.APPLICATION)}constructor(i,n,a,u,d,b,A,I,E,k){super(),this.userDataSyncStoreManagementService=n,this.userDataSyncStoreService=a,this.userDataSyncEnablementService=u,this.userDataSyncService=d,this.logService=b,this.userDataSyncAccountService=A,this.telemetryService=I,this.userDataSyncMachinesService=E,this.storageService=k,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new C.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=n.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(n.onDidChangeUserDataSyncStore(()=>{(0,v.isEqual)(this.syncUrl,n.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=n.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(a.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(d.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(O.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:n}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new t(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(a=>this.onDidFinishSync(a))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(n&&this.logService.info(n),this.autoSync.clear()):n&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(n))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,n,a){try{this.userDataSyncAccountService.account&&!a&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(R,m.StorageScope.APPLICATION),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(this.logService.error(u),n)this.updateEnablement(!1);else throw u}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const n=y.UserDataSyncError.toUserDataSyncError(i);n instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:n.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),n.code===y.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):n.code===y.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===y.UserDataSyncErrorCode.LocalTooManyRequests?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):n.code===y.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===y.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===y.UserDataSyncErrorCode.UpgradeRequired||n.code===y.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===y.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===y.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===y.UserDataSyncErrorCode.ServiceChanged||n.code===y.UserDataSyncErrorCode.DefaultServiceChanged?_.isWeb&&n.code===y.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(n),this.successiveFailures++),this._onError.fire(n)}async disableMachineEventually(){this.storageService.store(S,!0,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),await(0,C.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,m.StorageScope.APPLICATION,!1)}stopDisableMachineEventually(){this.storageService.remove(S,m.StorageScope.APPLICATION)}async triggerSync(i,n,a){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(n&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const u=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:u}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",a)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=r,e.UserDataAutoSyncService=r=we([X(0,h.IProductService),X(1,y.IUserDataSyncStoreManagementService),X(2,y.IUserDataSyncStoreService),X(3,y.IUserDataSyncEnablementService),X(4,y.IUserDataSyncService),X(5,y.IUserDataSyncLogService),X(6,w.IUserDataSyncAccountService),X(7,l.ITelemetryService),X(8,f.IUserDataSyncMachinesService),X(9,m.IStorageService)],r);class t extends L.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(i,n,a,u,d,b,A,I,E){super(),this.lastSyncUrl=i,this.interval=n,this.userDataSyncStoreManagementService=a,this.userDataSyncStoreService=u,this.userDataSyncService=d,this.userDataSyncMachinesService=b,this.logService=A,this.telemetryService=I,this.storageService=E,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new O.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new O.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(t.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,C.disposableTimeout)(()=>{this.sync(t.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(i,n){const a=(0,C.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,D.isCancellationError)(d))return}return this.doSync(i,n,u)});return this.syncPromise=a,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,v.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),n=this.userDataSyncStoreManagementService.userDataSyncStore;return!!n&&!!i&&(!(0,v.isEqual)(n.defaultUrl,i.defaultUrl)||!(0,v.isEqual)(n.insidersUrl,i.insidersUrl)||!(0,v.isEqual)(n.stableUrl,i.stableUrl))}async doSync(i,n,a){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let u;try{await this.createAndRunSyncTask(n,a)}catch(d){if(this.logService.error(d),u=d,y.UserDataSyncError.toUserDataSyncError(d).code===y.UserDataSyncErrorCode.MethodNotFound)try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(n,a),u=void 0}catch(b){this.logService.error(b),u=b}}this._onDidFinishSync.fire(u)}async createAndRunSyncTask(i,n){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),n.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,p.localize)(0,null),y.UserDataSyncErrorCode.DefaultServiceChanged):new y.UserDataAutoSyncError((0,p.localize)(1,null),y.UserDataSyncErrorCode.ServiceChanged):new y.UserDataAutoSyncError((0,p.localize)(2,null),y.UserDataSyncErrorCode.TurnedOff);const a=this.storageService.get(R,m.StorageScope.APPLICATION);if(a&&this.manifest&&a!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,p.localize)(3,null),y.UserDataSyncErrorCode.DefaultServiceChanged):new y.UserDataAutoSyncError((0,p.localize)(4,null),y.UserDataSyncErrorCode.ServiceChanged):new y.UserDataAutoSyncError((0,p.localize)(5,null),y.UserDataSyncErrorCode.SessionExpired);const u=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(n.isCancellationRequested)return;const d=u.find(A=>A.isCurrent);if(d?.disabled)throw new y.UserDataAutoSyncError((0,p.localize)(6,null),y.UserDataSyncErrorCode.TurnedOff);const b=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(A){throw new y.UserDataAutoSyncError((0,T.toErrorMessage)(A),A instanceof y.UserDataSyncError?A.code:y.UserDataSyncErrorCode.Unknown)}this.manifest&&this.manifest.session!==a&&this.storageService.store(R,this.manifest.session,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),!n.isCancellationRequested&&(d||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}}),define(le[268],ue([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let o=class{static{t=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(n,a,u,d,b,A,I,E,k,F){this.userDataSyncStoreService=n,this.userDataSyncLocalStoreService=a,this.logService=u,this.environmentService=b,this.storageService=A,this.fileService=I,this.userDataProfilesService=E,this.configurationService=k,this.instantiationService=F,this.extUri=d.extUri}async getRemoteSyncedProfiles(){const n=await this.userDataSyncStoreService.readResource(v.SyncResource.Profiles,null,void 0);if(n.content){const a=this.parseSyncData(n.content,v.SyncResource.Profiles);return(0,g.parseUserDataProfilesManifest)(a)}return[]}async getLocalSyncedProfiles(n){const a=await this.userDataSyncLocalStoreService.getAllResourceRefs(v.SyncResource.Profiles,void 0,n);if(a.length){const u=await this.userDataSyncLocalStoreService.resolveResourceContent(v.SyncResource.Profiles,a[0].ref,void 0,n);if(u){const d=this.parseSyncData(u,v.SyncResource.Profiles);return(0,g.parseUserDataProfilesManifest)(d)}}return[]}async getLocalSyncedMachines(n){const a=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,n);if(a.length){const u=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",a[0].ref,void 0,n);if(u)return JSON.parse(u).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,a){return(await this.userDataSyncStoreService.getAllResourceRefs(n,a?.collection)).map(({created:d,ref:b})=>({created:d,uri:this.toUri({remote:!0,syncResource:n,profile:a?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:a?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(n,a,u){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(n,a?.collection,u)).map(({created:b,ref:A})=>({created:b,uri:this.toUri({remote:!1,syncResource:n,profile:a?.id??this.userDataProfilesService.defaultProfile.id,collection:a?.collection,ref:A,node:void 0,location:u})}))}resolveUserDataSyncResource({uri:n}){const a=this.resolveUri(n),u=a?this.userDataProfilesService.profiles.find(d=>d.id===a.profile):void 0;return a&&u?{profile:u,syncResource:a?.syncResource}:void 0}async getAssociatedResources({uri:n}){const a=this.resolveUri(n);if(!a)return[];const u=this.userDataProfilesService.profiles.find(d=>d.id===a.profile);switch(a.syncResource){case v.SyncResource.Settings:return this.getSettingsAssociatedResources(n,u);case v.SyncResource.Keybindings:return this.getKeybindingsAssociatedResources(n,u);case v.SyncResource.Tasks:return this.getTasksAssociatedResources(n,u);case v.SyncResource.Snippets:return this.getSnippetsAssociatedResources(n,u);case v.SyncResource.GlobalState:return this.getGlobalStateAssociatedResources(n,u);case v.SyncResource.Extensions:return this.getExtensionsAssociatedResources(n,u);case v.SyncResource.Profiles:return this.getProfilesAssociatedResources(n,u);case v.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const a=this.resolveUri(n);if(a){if(a.remote){if(a.ref){const{content:u}=await this.getUserData(a.syncResource,a.ref,a.collection);if(u)return this.parseSyncData(u,a.syncResource)?.machineId}return}if(a.location){if(a.ref){const u=await this.userDataSyncLocalStoreService.resolveResourceContent(a.syncResource,a.ref,a.collection,a.location);if(u)return this.parseSyncData(u,a.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(n){const a=this.resolveUri(n);if(!a||a.node===t.NOT_EXISTING_RESOURCE)return null;if(a.ref){const u=await this.getContentFromStore(a.remote,a.syncResource,a.collection,a.ref,a.location);return a.node&&u?this.resolveNodeContent(a.syncResource,u,a.node):u}return!a.remote&&!a.node?this.resolveLatestContent(a.syncResource,a.profile):null}async getContentFromStore(n,a,u,d,b){if(n){const{content:A}=await this.getUserData(a,d,u);return A}return this.userDataSyncLocalStoreService.resolveResourceContent(a,d,u,b)}resolveNodeContent(n,a,u){const d=this.parseSyncData(a,n);switch(n){case v.SyncResource.Settings:return this.resolveSettingsNodeContent(d,u);case v.SyncResource.Keybindings:return this.resolveKeybindingsNodeContent(d,u);case v.SyncResource.Tasks:return this.resolveTasksNodeContent(d,u);case v.SyncResource.Snippets:return this.resolveSnippetsNodeContent(d,u);case v.SyncResource.GlobalState:return this.resolveGlobalStateNodeContent(d,u);case v.SyncResource.Extensions:return this.resolveExtensionsNodeContent(d,u);case v.SyncResource.Profiles:return this.resolveProfileNodeContent(d,u);case v.SyncResource.WorkspaceState:return null}}async resolveLatestContent(n,a){const u=this.userDataProfilesService.profiles.find(d=>d.id===a);if(!u)return null;switch(n){case v.SyncResource.GlobalState:return this.resolveLatestGlobalStateContent(u);case v.SyncResource.Extensions:return this.resolveLatestExtensionsContent(u);case v.SyncResource.Profiles:return this.resolveLatestProfilesContent(u);case v.SyncResource.Settings:return null;case v.SyncResource.Keybindings:return null;case v.SyncResource.Tasks:return null;case v.SyncResource.Snippets:return null;case v.SyncResource.WorkspaceState:return null}}getSettingsAssociatedResources(n,a){const u=this.extUri.joinPath(n,"settings.json"),d=a?a.settingsResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:u,comparableResource:d}]}resolveSettingsNodeContent(n,a){switch(a){case"settings.json":return(0,m.parseSettingsSyncContent)(n.content).settings}return null}getKeybindingsAssociatedResources(n,a){const u=this.extUri.joinPath(n,"keybindings.json"),d=a?a.keybindingsResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:u,comparableResource:d}]}resolveKeybindingsNodeContent(n,a){switch(a){case"keybindings.json":return(0,l.getKeybindingsContentFromSyncContent)(n.content,!!this.configurationService.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(n,a){const u=this.extUri.joinPath(n,"tasks.json"),d=a?a.tasksResource:this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:u,comparableResource:d}]}resolveTasksNodeContent(n,a){switch(a){case"tasks.json":return(0,w.getTasksContentFromSyncContent)(n.content,this.logService)}return null}async getSnippetsAssociatedResources(n,a){const u=await this.resolveContent(n);if(u){const d=this.parseSyncData(u,v.SyncResource.Snippets);if(d){const b=(0,h.parseSnippets)(d),A=[];for(const I of Object.keys(b)){const E=this.extUri.joinPath(n,I),k=a?this.extUri.joinPath(a.snippetsHome,I):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);A.push({resource:E,comparableResource:k})}return A}}return[]}resolveSnippetsNodeContent(n,a){return(0,h.parseSnippets)(n)[a]||null}getExtensionsAssociatedResources(n,a){const u=this.extUri.joinPath(n,"extensions.json"),d=a?this.toUri({remote:!1,syncResource:v.SyncResource.Extensions,profile:a.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:u,comparableResource:d}]}resolveExtensionsNodeContent(n,a){switch(a){case"extensions.json":return(0,f.stringify)((0,f.parseExtensions)(n),!0)}return null}async resolveLatestExtensionsContent(n){const{localExtensions:a}=await this.instantiationService.createInstance(f.LocalExtensionsProvider).getLocalExtensions(n);return(0,f.stringify)(a,!0)}getGlobalStateAssociatedResources(n,a){const u=this.extUri.joinPath(n,"globalState.json"),d=a?this.toUri({remote:!1,syncResource:v.SyncResource.GlobalState,profile:a.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,t.NOT_EXISTING_RESOURCE);return[{resource:u,comparableResource:d}]}resolveGlobalStateNodeContent(n,a){switch(a){case"globalState.json":return(0,S.stringify)(JSON.parse(n.content),!0)}return null}async resolveLatestGlobalStateContent(n){const a=await this.instantiationService.createInstance(S.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,S.stringify)(a,!0)}getProfilesAssociatedResources(n,a){const u=this.extUri.joinPath(n,"profiles.json"),d=this.toUri({remote:!1,syncResource:v.SyncResource.Profiles,profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:u,comparableResource:d}]}resolveProfileNodeContent(n,a){switch(a){case"profiles.json":return(0,s.toFormattedString)(JSON.parse(n.content),{})}return null}async resolveLatestProfilesContent(n){return(0,g.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(a=>!a.isDefault&&!a.isTransient),!0)}toUri(n){const a=n.remote?t.REMOTE_BACKUP_AUTHORITY:t.LOCAL_BACKUP_AUTHORITY,u=[];return n.location&&(u.push(`scheme:${n.location.scheme}`),u.push(`authority:${n.location.authority}`),u.push((0,r.trim)(n.location.path,"/"))),u.push(`syncResource:${n.syncResource}`),u.push(`profile:${n.profile}`),n.collection&&u.push(`collection:${n.collection}`),n.ref&&u.push(`ref:${n.ref}`),n.node&&u.push(n.node),this.extUri.joinPath(C.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:a,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...u)}resolveUri(n){if(n.scheme!==v.USER_DATA_SYNC_SCHEME)return;const a=[];for(;n.path!=="/";)a.unshift(this.extUri.basename(n)),n=this.extUri.dirname(n);if(a.length<2)return;const u=n.authority===t.REMOTE_BACKUP_AUTHORITY;let d,b;const A=[];let I,E,k,F,U;for(;a.length;){const M=a.shift();M.startsWith("scheme:")?d=M.substring(7):M.startsWith("authority:")?b=M.substring(10):M.startsWith("syncResource:")?I=M.substring(13):M.startsWith("profile:")?E=M.substring(8):M.startsWith("collection:")?k=M.substring(11):M.startsWith("ref:")?F=M.substring(4):I?U=M:A.push(M)}return{remote:u,syncResource:I,profile:E,collection:k,ref:F,node:U,location:d&&b!==void 0?this.extUri.joinPath(C.URI.from({scheme:d,authority:b,query:n.query,fragment:n.fragment,path:"/"}),...A):void 0}}parseSyncData(n,a){try{const u=JSON.parse(n);if((0,p.isSyncData)(u))return u}catch(u){this.logService.error(u)}throw new v.UserDataSyncError((0,c.localize)(0,null),v.UserDataSyncErrorCode.IncompatibleRemoteContent,a)}async getUserData(n,a,u){const d=await this.userDataSyncStoreService.resolveResourceContent(n,a,u);return{ref:a,content:d}}};e.UserDataSyncResourceProviderService=o,e.UserDataSyncResourceProviderService=o=t=we([X(0,v.IUserDataSyncStoreService),X(1,v.IUserDataSyncLocalStoreService),X(2,v.IUserDataSyncLogService),X(3,_.IUriIdentityService),X(4,T.IEnvironmentService),X(5,L.IStorageService),X(6,D.IFileService),X(7,P.IUserDataProfilesService),X(8,y.IConfigurationService),X(9,R.IInstantiationService)],o)}),define(le[269],ue([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let a=class extends L.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(I,E,k,F,U,M,H,B,Z,V,ie){super(),this.fileService=I,this.userDataSyncStoreService=E,this.userDataSyncStoreManagementService=k,this.instantiationService=F,this.logService=U,this.telemetryService=M,this.storageService=H,this.userDataSyncEnablementService=B,this.userDataProfilesService=Z,this.userDataSyncResourceProviderService=V,this.userDataSyncLocalStoreService=ie,this._status=i.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new O.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new O.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new O.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new O.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new O.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new O.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new O.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=k.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this._lastSyncTime=this.storageService.getNumber(n,y.StorageScope.APPLICATION,void 0),this._register((0,L.toDisposable)(()=>this.clearActiveProfileSynchronizers())),this._register(new c.RunOnceScheduler(()=>this.cleanUpStaleStorageData(),5*1e3)).schedule()}async createSyncTask(I,E){this.checkEnablement(),this.logService.info("Sync started.");const k=new Date().getTime(),F=(0,P.generateUuid)();try{const B=(0,i.createSyncHeaders)(F);E&&(B["Cache-Control"]="no-cache"),I=await this.userDataSyncStoreService.manifest(I,B)}catch(B){const Z=i.UserDataSyncError.toUserDataSyncError(B);throw b(Z,F,this.userDataSyncStoreManagementService,this.telemetryService),Z}const U=!1,M=this;let H;return{manifest:I,async run(){if(U)throw new Error("Can run a task only once");H=(0,c.createCancelablePromise)(B=>M.sync(I,!1,F,B)),await H.finally(()=>H=void 0),M.logService.info(`Sync done. Took ${new Date().getTime()-k}ms`),M.updateLastSyncTime()},stop(){return H?.cancel(),M.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.logService.info("Sync started.");const I=new Date().getTime(),E=(0,P.generateUuid)(),k=(0,i.createSyncHeaders)(E);let F;try{F=await this.userDataSyncStoreService.manifest(null,k)}catch(H){const B=i.UserDataSyncError.toUserDataSyncError(H);throw b(B,E,this.userDataSyncStoreManagementService,this.telemetryService),B}await this.resetLocal();const U=this,M=new T.CancellationTokenSource;return{id:E,async merge(){return U.sync(F,!0,E,M.token)},async apply(){try{try{await U.applyManualSync(F,E,M.token)}catch(H){if(i.UserDataSyncError.toUserDataSyncError(H).code===i.UserDataSyncErrorCode.MethodNotFound)U.logService.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.logService.info("Applying manual sync again..."),await U.applyManualSync(F,E,M.token);else throw H}}catch(H){throw U.logService.error(H),H}U.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),U.updateLastSyncTime()},async stop(){M.cancel(),await U.stop(),await U.resetLocal()}}}async sync(I,E,k,F){this._syncErrors=[];try{this.status!==i.SyncStatus.HasConflicts&&this.setStatus(i.SyncStatus.Syncing);const U=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(U,I,E,k,F));const M=U.enabled.find(H=>H.resource===i.SyncResource.Profiles);if(M){const H=await M.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(H,I,E,k,F)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.setStatus(i.SyncStatus.Idle),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(I,E,k,F,U){for(const M of I){if(U.isCancellationRequested)return;const H=this.userDataProfilesService.profiles.find(Z=>Z.id===M.id);if(!H){this.logService.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",M.name);const B=this.getOrCreateActiveProfileSynchronizer(H,M);this._syncErrors.push(...await this.syncProfile(B,E,k,F,U))}for(const[M,H]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(B=>B.id===H[0].profile.id)||(await H[0].resetLocal(),H[1].dispose(),this.activeProfileSynchronizers.delete(M))}async applyManualSync(I,E,k){const F=this.getActiveProfileSynchronizers();for(const Z of F){if(k.isCancellationRequested)return;await Z.apply(E,k)}const U=F.find(Z=>Z.profile.isDefault);if(!U)return;const M=U.enabled.find(Z=>Z.resource===i.SyncResource.Profiles);if(!M)return;const B=(await M.getRemoteSyncedProfiles(I?.latest??null)||[]).filter(Z=>F.every(V=>V.profile.id!==Z.id));B.length&&await this.syncRemoteProfiles(B,I,!1,E,k)}async syncProfile(I,E,k,F,U){return(await I.sync(E,k,F,U)).map(([H,B])=>({profile:I.profile,syncResource:H,error:B}))}async stop(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(I=>I.stop()))}async resolveContent(I){const E=await this.userDataSyncResourceProviderService.resolveContent(I);if(E)return E;for(const k of this.getActiveProfileSynchronizers())for(const F of k.enabled){const U=await F.resolveContent(I);if(U)return U}return null}async replace(I){this.checkEnablement();const E=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(I);if(!E)return;const k=await this.resolveContent(I.uri);k&&await this.performAction(E.profile,async F=>{if(E.syncResource===F.resource)return await F.replace(k),!0})}async accept(I,E,k,F){this.checkEnablement(),await this.performAction(I.profile,async U=>{if(I.syncResource===U.resource)return await U.accept(E,k),F&&await U.apply((0,v.isBoolean)(F)?!1:F.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async E=>{if(E.resource!==i.SyncResource.GlobalState&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(I){this.logService.error(I)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(n,y.StorageScope.APPLICATION);for(const[I]of this.activeProfileSynchronizers.values())try{await I.resetLocal()}catch(E){this.logService.error(E)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpStaleStorageData(){const I=this.storageService.keys(y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),E=[];for(const F of I){if(!F.endsWith(".lastSyncUserData"))continue;const U=F.split(".");U.length===3&&E.push([F,U[0]])}if(!E.length)return;const k=new L.DisposableStore;try{let F=this.activeProfileSynchronizers.get(this.userDataProfilesService.defaultProfile.id)?.[0];F||(F=k.add(this.instantiationService.createInstance(u,this.userDataProfilesService.defaultProfile,void 0)));const U=F.enabled.find(B=>B.resource===i.SyncResource.Profiles);if(!U)return;const H=(await U.getLastSyncedProfiles())?.map(B=>B.collection)??[];for(const[B,Z]of E)H.includes(Z)||(this.logService.info(`Removing last sync state for stale profile: ${Z}`),this.storageService.remove(B,y.StorageScope.APPLICATION))}finally{k.dispose()}}async cleanUpRemoteData(){const I=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),E=I.map(M=>M.collection),k=await this.userDataSyncStoreService.getAllCollections(),F=k.filter(M=>!E.includes(M));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(M=>this.userDataSyncStoreService.deleteCollection(M))),this.logService.info("Deleted redundant collections on server"));const U=I.filter(M=>k.includes(M.collection));if(U.length!==I.length){const M=this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(U,null),this.logService.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(I){this.checkEnablement();const E=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(I,E)}async extractActivityData(I,E){const k=(await this.fileService.readFile(I)).value.toString(),F=JSON.parse(k);if(F.resources)for(const U in F.resources)for(const M of F.resources[U])await this.userDataSyncLocalStoreService.writeResource(U,M.content,new Date(M.created*1e3),void 0,E);if(F.collections)for(const U in F.collections)for(const M in F.collections[U].resources)for(const H of F.collections[U].resources?.[M]??[])await this.userDataSyncLocalStoreService.writeResource(M,H.content,new Date(H.created*1e3),U,E)}async performAction(I,E){const k=new L.DisposableStore;try{const F=this.activeProfileSynchronizers.get(I.id);if(F){const Z=await this.performActionWithProfileSynchronizer(F[0],E,k);return(0,v.isUndefined)(Z)?null:Z}if(I.isDefault){const Z=k.add(this.instantiationService.createInstance(u,I,void 0)),V=await this.performActionWithProfileSynchronizer(Z,E,k);return(0,v.isUndefined)(V)?null:V}if(this.userDataProfilesService.isEnabled())return null;const U=k.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,I,void 0)),M=await this.userDataSyncStoreService.manifest(null),B=(await U.getRemoteSyncedProfiles(M?.latest??null)||[]).find(Z=>Z.id===I.id);if(B){const Z=k.add(this.instantiationService.createInstance(u,I,B.collection)),V=await this.performActionWithProfileSynchronizer(Z,E,k);return(0,v.isUndefined)(V)?null:V}return null}finally{k.dispose()}}async performActionWithProfileSynchronizer(I,E,k){const F=[...I.enabled,...I.disabled.reduce((U,M)=>(M!==i.SyncResource.WorkspaceState&&U.push(k.add(I.createSynchronizer(M))),U),[])];for(const U of F){const M=await E(U);if(!(0,v.isUndefined)(M))return M}}setStatus(I){const E=this._status;this._status!==I&&(this._status=I,this._onDidChangeStatus.fire(I),E===i.SyncStatus.HasConflicts&&this.updateLastSyncTime())}updateConflicts(){const I=this.getActiveProfileSynchronizers().map(E=>E.conflicts).flat();(0,C.equals)(this._conflicts,I,(E,k)=>E.profile.id===k.profile.id&&E.syncResource===k.syncResource&&(0,C.equals)(E.conflicts,k.conflicts,(F,U)=>(0,_.isEqual)(F.previewResource,U.previewResource)))||(this._conflicts=I,this._onDidChangeConflicts.fire(I))}updateLastSyncTime(){this.status===i.SyncStatus.Idle&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(I,E){let k=this.activeProfileSynchronizers.get(I.id);if(k&&k[0].collection!==E?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),k[1].dispose(),k=void 0,this.activeProfileSynchronizers.delete(I.id)),!k){const F=new L.DisposableStore,U=F.add(this.instantiationService.createInstance(u,I,E?.collection));F.add(U.onDidChangeStatus(M=>this.setStatus(M))),F.add(U.onDidChangeConflicts(M=>this.updateConflicts())),F.add(U.onDidChangeLocal(M=>this._onDidChangeLocal.fire(M))),this.activeProfileSynchronizers.set(I.id,k=[U,F])}return k[0]}getActiveProfileSynchronizers(){const I=[];for(const[E]of this.activeProfileSynchronizers.values())I.push(E);return I}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,I])=>I.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=a,e.UserDataSyncService=a=we([X(0,m.IFileService),X(1,i.IUserDataSyncStoreService),X(2,i.IUserDataSyncStoreManagementService),X(3,l.IInstantiationService),X(4,i.IUserDataSyncLogService),X(5,w.ITelemetryService),X(6,y.IStorageService),X(7,i.IUserDataSyncEnablementService),X(8,f.IUserDataProfilesService),X(9,i.IUserDataSyncResourceProviderService),X(10,i.IUserDataSyncLocalStoreService)],a);let u=class extends L.Disposable{get enabled(){return this._enabled.sort((I,E)=>I[1]-E[1]).map(([I])=>I)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(I=>!this.userDataSyncEnablementService.isResourceEnabled(I))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(I,E,k,F,U,M,H,B,Z,V){super(),this.profile=I,this.collection=E,this.userDataSyncEnablementService=k,this.instantiationService=F,this.extensionGalleryService=U,this.userDataSyncStoreManagementService=M,this.telemetryService=H,this.logService=B,this.userDataProfilesService=Z,this.configurationService=V,this._enabled=[],this._status=i.SyncStatus.Idle,this._onDidChangeStatus=this._register(new O.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new O.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new O.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(k.onDidChangeResourceEnablement(([ie,z])=>this.onDidChangeResourceEnablement(ie,z))),this._register((0,L.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.ALL_SYNC_RESOURCES)k.isResourceEnabled(ie)&&this.registerSynchronizer(ie)}onDidChangeResourceEnablement(I,E){E?this.registerSynchronizer(I):this.deRegisterSynchronizer(I)}registerSynchronizer(I){if(this._enabled.some(([U])=>U.resource===I))return;if(I===i.SyncResource.Extensions&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(I===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||I===i.SyncResource.WorkspaceState)return;if(I!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[I]){this.logService.debug(`Skipping syncing ${I} in ${this.profile.name} because it is already synced by default profile`);return}const E=new L.DisposableStore,k=E.add(this.createSynchronizer(I));E.add(k.onDidChangeStatus(()=>this.updateStatus())),E.add(k.onDidChangeConflicts(()=>this.updateConflicts())),E.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(I)));const F=this.getOrder(I);this._enabled.push([k,F,E])}deRegisterSynchronizer(I){const E=this._enabled.findIndex(([k])=>k.resource===I);if(E!==-1){const[[k,,F]]=this._enabled.splice(E,1);F.dispose(),this.updateStatus(),Promise.allSettled([k.stop(),k.resetLocal()]).then(null,U=>this.logService.error(U))}}createSynchronizer(I){switch(I){case i.SyncResource.Settings:return this.instantiationService.createInstance(s.SettingsSynchroniser,this.profile,this.collection);case i.SyncResource.Keybindings:return this.instantiationService.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case i.SyncResource.Snippets:return this.instantiationService.createInstance(r.SnippetsSynchroniser,this.profile,this.collection);case i.SyncResource.Tasks:return this.instantiationService.createInstance(t.TasksSynchroniser,this.profile,this.collection);case i.SyncResource.GlobalState:return this.instantiationService.createInstance(R.GlobalStateSynchroniser,this.profile,this.collection);case i.SyncResource.Extensions:return this.instantiationService.createInstance(S.ExtensionsSynchroniser,this.profile,this.collection);case i.SyncResource.Profiles:return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(I,E,k,F){if(F.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const M=[],H=(0,i.createSyncHeaders)(k),B=(this.collection?I?.collections?.[this.collection]?.latest:I?.latest)??null,Z=E?await this.getUserDataSyncConfiguration(B):{};for(const V of U){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(V.resource))return[];try{if(E){const ie=await V.preview(B,Z,H);if(ie)for(const z of ie.resourcePreviews)(z.localChange!==i.Change.None||z.remoteChange!==i.Change.None)&&z.mergeState===i.MergeState.Preview&&await V.merge(z.previewResource)}else await V.sync(B,H)}catch(ie){const z=i.UserDataSyncError.toUserDataSyncError(ie);if(b(z,k,this.userDataSyncStoreManagementService,this.telemetryService),d(ie))throw z;this.logService.error(ie),this.logService.error(`${V.resource}: ${(0,D.toErrorMessage)(ie)}`),M.push([V.resource,z])}}return M}finally{this.updateStatus()}}async apply(I,E){const k=(0,i.createSyncHeaders)(I);for(const F of this.enabled){if(E.isCancellationRequested)return;try{await F.apply(!1,k)}catch(U){const M=i.UserDataSyncError.toUserDataSyncError(U);if(b(M,I,this.userDataSyncStoreManagementService,this.telemetryService),d(U))throw M;this.logService.error(U),this.logService.error(`${F.resource}: ${(0,D.toErrorMessage)(U)}`)}}}async stop(){for(const I of this.enabled)try{I.status!==i.SyncStatus.Idle&&await I.stop()}catch(E){this.logService.error(E)}}async resetLocal(){for(const I of this.enabled)try{await I.resetLocal()}catch(E){this.logService.error(`${I.resource}: ${(0,D.toErrorMessage)(E)}`),this.logService.error(E)}}async getUserDataSyncConfiguration(I){if(!this.profile.isDefault)return{};const E=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),k=this.enabled.find(F=>F instanceof s.SettingsSynchroniser);if(k){const F=await k.getRemoteUserDataSyncConfiguration(I);return{...E,...F}}return E}setStatus(I){this._status!==I&&(this._status=I,this._onDidChangeStatus.fire(I))}updateStatus(){return this.updateConflicts(),this.enabled.some(I=>I.status===i.SyncStatus.HasConflicts)?this.setStatus(i.SyncStatus.HasConflicts):this.enabled.some(I=>I.status===i.SyncStatus.Syncing)?this.setStatus(i.SyncStatus.Syncing):this.setStatus(i.SyncStatus.Idle)}updateConflicts(){const I=this.enabled.filter(E=>E.status===i.SyncStatus.HasConflicts).filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,C.equals)(this._conflicts,I,(E,k)=>E.syncResource===k.syncResource&&(0,C.equals)(E.conflicts,k.conflicts,(F,U)=>(0,_.isEqual)(F.previewResource,U.previewResource)))||(this._conflicts=I,this._onDidChangeConflicts.fire(I))}getOrder(I){switch(I){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};u=we([X(2,i.IUserDataSyncEnablementService),X(3,l.IInstantiationService),X(4,h.IExtensionGalleryService),X(5,i.IUserDataSyncStoreManagementService),X(6,w.ITelemetryService),X(7,i.IUserDataSyncLogService),X(8,f.IUserDataProfilesService),X(9,p.IConfigurationService)],u);function d(A){if(A instanceof i.UserDataSyncError)switch(A.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function b(A,I,E,k){k.publicLog2("sync/error",{code:A.code,serverCode:A instanceof i.UserDataSyncStoreError?String(A.serverCode):void 0,url:A instanceof i.UserDataSyncStoreError?A.url:void 0,resource:A.resource,executionId:I,service:E.userDataSyncStore.url.toString()})}}),define(le[270],ue([0,1,3,2,9,20,25]),function(ne,e,C,c,T,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function L(h,m){return{...h,profile:(0,D.reviveProfile)(h.profile,m.profilesHome.scheme)}}function _(h){return{created:h.created,uri:T.URI.revive(h.uri)}}class v{constructor(m,l,y){this.service=m,this.userDataProfilesService=l,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new C.Emitter}listen(m,l){switch(l){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(m,l,y){try{return await this._call(m,l,y)}catch(w){throw this.logService.error(w),w}}async _call(m,l,y){switch(l){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(T.URI.revive(y[0]));case"accept":return this.service.accept(L(y[0],this.userDataProfilesService),T.URI.revive(y[1]),y[2],y[3]);case"replace":return this.service.replace(_(y[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(T.URI.revive(y[0]));case"extractActivityData":return this.service.extractActivityData(T.URI.revive(y[0]),T.URI.revive(y[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(l.startsWith("manualSync/")){const w=l.substring(11),f=y[0],S=this.getManualSyncTask(f);switch(y=y.slice(1),w){case"merge":return S.merge();case"apply":return S.apply().then(()=>this.manualSyncTasks.delete(this.createKey(S.id)));case"stop":return S.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(S.id)))}}throw new Error("Invalid call")}getManualSyncTask(m){const l=this.manualSyncTasks.get(this.createKey(m));if(!l)throw new Error(`Manual sync taks not found: ${m}`);return l}async createManualSyncTask(){const m=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(m.id),m),m.id}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncServiceChannel=v;let P=class extends c.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(m,l){super(),this.userDataProfilesService=l,this._status=O.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new C.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new C.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new C.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new C.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,w,f){return m.call(y,w,f).then(null,S=>{throw O.UserDataSyncError.toUserDataSyncError(S)})},listen(y,w){return m.listen(y,w)}},this.channel.call("_getInitialData").then(([y,w,f])=>{this.updateStatus(y),this.updateConflicts(w),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(w=>({...w,error:O.UserDataSyncError.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const m=await this.channel.call("createManualSyncTask"),l=this;return new p(m,{async call(w,f,S){return l.channel.call(`manualSync/${w}`,[m,...Array.isArray(f)?f:[f]],S)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,l,y,w){return this.channel.call("accept",[m,l,y,w])}resolveContent(m){return this.channel.call("resolveContent",[m])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(m){return this.channel.call("replace",[m])}saveRemoteActivityData(m){return this.channel.call("getRemoteActivityData",[m])}extractActivityData(m,l){return this.channel.call("extractActivityData",[m,l])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(l=>({syncResource:l.syncResource,profile:(0,D.reviveProfile)(l.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:l.conflicts.map(y=>({...y,baseResource:T.URI.revive(y.baseResource),localResource:T.URI.revive(y.localResource),remoteResource:T.URI.revive(y.remoteResource),previewResource:T.URI.revive(y.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}};e.UserDataSyncServiceChannelClient=P,e.UserDataSyncServiceChannelClient=P=we([X(1,D.IUserDataProfilesService)],P);class p extends c.Disposable{constructor(m,l){super(),this.id=m,this.channel=l}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(le[127],ue([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,62,50,17,25]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="configurationSync.store",r="sync.previous.store",t="sync.donot-make-requests-until",o="sync.user-session-id",i="sync.machine-session-id",n=100,a=1e3*60*5;let u=class extends O.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(g.SYNC_SERVICE_URL_TYPE,R.StorageScope.APPLICATION)}set userDataSyncStoreType(k){this.storageService.store(g.SYNC_SERVICE_URL_TYPE,k,R.StorageScope.APPLICATION,_.isWeb?R.StorageTarget.USER:R.StorageTarget.MACHINE)}constructor(k,F,U){super(),this.productService=k,this.configurationService=F,this.storageService=U,this._onDidChangeUserDataSyncStore=this._register(new D.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const M=this._register(new O.DisposableStore);this._register(D.Event.filter(U.onDidChangeValue(R.StorageScope.APPLICATION,g.SYNC_SERVICE_URL_TYPE,M),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,M)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[s]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(k){if(k&&(k=_.isWeb&&k.web?{...k,...k.web}:k,(0,P.isString)(k.url)&&(0,P.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(F=>Array.isArray(k.authenticationProviders[F].scopes)))){const F=k,U=!!F.canSwitch,M=F.url===F.insidersUrl?"insiders":"stable",H=(U?this.userDataSyncStoreType:void 0)||M,B=H==="insiders"?F.insidersUrl:H==="stable"?F.stableUrl:F.url;return{url:p.URI.parse(B),type:H,defaultType:M,defaultUrl:p.URI.parse(F.url),stableUrl:p.URI.parse(F.stableUrl),insidersUrl:p.URI.parse(F.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(F.authenticationProviders).reduce((Z,V)=>(Z.push({id:V,scopes:F.authenticationProviders[V].scopes}),Z),[])}}}};e.AbstractUserDataSyncStoreManagementService=u,e.AbstractUserDataSyncStoreManagementService=u=we([X(0,w.IProductService),X(1,m.IConfigurationService),X(2,R.IStorageService)],u);let d=class extends u{constructor(k,F,U){super(k,F,U);const M=this.storageService.get(r,R.StorageScope.APPLICATION);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const H=this.productService[s];H?this.storageService.store(r,JSON.stringify(H),R.StorageScope.APPLICATION,R.StorageTarget.MACHINE):this.storageService.remove(r,R.StorageScope.APPLICATION)}async switch(k){k!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=k,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=d,e.UserDataSyncStoreManagementService=d=we([X(0,w.IProductService),X(1,m.IConfigurationService),X(2,R.IStorageService)],d);let b=class extends O.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(k,F,U,M,H,B,Z){super(),this.requestService=U,this.logService=M,this.storageService=Z,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new D.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(k),this.commonHeadersPromise=(0,S.getServiceMachineId)(H,B,Z).then(V=>{const ie={"X-Client-Name":`${F.applicationName}${_.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.session=new I(n,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,O.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(k,F){this.authToken={token:k,type:F}}updateUserDataSyncStoreUrl(k){this.userDataSyncStoreUrl=k?(0,v.joinPath)(k,"v1"):void 0}initDonotMakeRequestsUntil(){const k=this.storageService.getNumber(t,R.StorageScope.APPLICATION);k&&Date.now()<k&&this.setDonotMakeRequestsUntil(new Date(k))}setDonotMakeRequestsUntil(k){this._donotMakeRequestsUntil?.getTime()!==k?.getTime()&&(this._donotMakeRequestsUntil=k,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),R.StorageScope.APPLICATION,R.StorageTarget.MACHINE),this.resetDonotMakeRequestsUntilPromise=(0,C.createCancelablePromise)(F=>(0,C.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(t,R.StorageScope.APPLICATION),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();k={...k},k["Content-Type"]="application/json";const U=await this.request(F,{type:"GET",headers:k},[],c.CancellationToken.None);return(await(0,f.asJson)(U))?.map(({id:M})=>M)||[]}async createCollection(k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();k={...k},k["Content-Type"]=L.Mimes.text;const U=await this.request(F,{type:"POST",headers:k},[],c.CancellationToken.None),M=await(0,f.asTextOrError)(U);if(!M)throw new g.UserDataSyncStoreError("Server did not return the collection id",F,g.UserDataSyncErrorCode.NoCollection,U.res.statusCode,U.res.headers[g.HEADER_OPERATION_ID]);return M}async deleteCollection(k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=k?(0,v.joinPath)(this.userDataSyncStoreUrl,"collection",k).toString():(0,v.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(U,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async getAllResourceRefs(k,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=this.getResourceUrl(this.userDataSyncStoreUrl,F,k),M={},H=await this.request(U.toString(),{type:"GET",headers:M},[],c.CancellationToken.None);return(await(0,f.asJson)(H)||[]).map(({url:Z,created:V})=>({ref:(0,v.relativePath)(U,U.with({path:Z})),created:V*1e3}))}async resolveResourceContent(k,F,U,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,U,k),F).toString();M={...M},M["Cache-Control"]="no-cache";const B=await this.request(H,{type:"GET",headers:M},[],c.CancellationToken.None);return await(0,f.asTextOrError)(B)}async deleteResource(k,F,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=F!==null?(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,U,k),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,U,k).toString(),H={};await this.request(M,{type:"DELETE",headers:H},[],c.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,v.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":L.Mimes.text};await this.request(k,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async readResource(k,F,U,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,v.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,U,k),"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const B=await this.request(H,{type:"GET",headers:M},[304],c.CancellationToken.None);let Z=null;if(B.res.statusCode===304&&(Z=F),Z===null){const V=B.res.headers.etag;if(!V)throw new g.UserDataSyncStoreError("Server did not return the ref",H,g.UserDataSyncErrorCode.NoRef,B.res.statusCode,B.res.headers[g.HEADER_OPERATION_ID]);const ie=await(0,f.asTextOrError)(B);if(!ie&&B.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",H,g.UserDataSyncErrorCode.EmptyResponse,B.res.statusCode,B.res.headers[g.HEADER_OPERATION_ID]);Z={ref:V,content:ie}}return Z}async writeResource(k,F,U,M,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=this.getResourceUrl(this.userDataSyncStoreUrl,M,k).toString();H={...H},H["Content-Type"]=L.Mimes.text,U&&(H["If-Match"]=U);const Z=await this.request(B,{type:"POST",data:F,headers:H},[],c.CancellationToken.None),V=Z.res.headers.etag;if(!V)throw new g.UserDataSyncStoreError("Server did not return the ref",B,g.UserDataSyncErrorCode.NoRef,Z.res.statusCode,Z.res.headers[g.HEADER_OPERATION_ID]);return V}async manifest(k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,v.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",k&&(F["If-None-Match"]=k.ref);const M=await this.request(U,{type:"GET",headers:F},[304],c.CancellationToken.None);let H=null;if(M.res.statusCode===304&&(H=k),!H){const Z=M.res.headers.etag;if(!Z)throw new g.UserDataSyncStoreError("Server did not return the ref",U,g.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[g.HEADER_OPERATION_ID]);const V=await(0,f.asTextOrError)(M);if(!V&&M.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",U,g.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[g.HEADER_OPERATION_ID]);V&&(H={...JSON.parse(V),ref:Z})}const B=this.storageService.get(o,R.StorageScope.APPLICATION);return B&&H&&B!==H.session&&this.clearSession(),H===null&&B&&this.clearSession(),H&&this.storageService.store(o,H.session,R.StorageScope.APPLICATION,R.StorageTarget.MACHINE),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,v.joinPath)(this.userDataSyncStoreUrl,"download").toString(),F={},U=await this.request(k,{type:"GET",headers:F},[],c.CancellationToken.None);if(!(0,f.isSuccess)(U))throw new g.UserDataSyncStoreError("Server returned "+U.res.statusCode,k,g.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[g.HEADER_OPERATION_ID]);if((0,f.hasNoContent)(U))throw new g.UserDataSyncStoreError("Empty response",k,g.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[g.HEADER_OPERATION_ID]);return U.stream}getResourceUrl(k,F,U){return F?(0,v.joinPath)(k,"collection",F,"resource",U):(0,v.joinPath)(k,"resource",U)}clearSession(){this.storageService.remove(o,R.StorageScope.APPLICATION),this.storageService.remove(i,R.StorageScope.APPLICATION)}async request(k,F,U,M){if(!this.authToken)throw new g.UserDataSyncStoreError("No Auth Token Available",k,g.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of too many requests (429).`,k,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;F.headers={...F.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:k,type:F.type,headers:{...F.headers,authorization:void 0}});let B;try{B=await this.session.request(k,F,M)}catch(q){if(!(q instanceof g.UserDataSyncStoreError)){let te=g.UserDataSyncErrorCode.RequestFailed;const se=(0,T.getErrorMessage)(q).toLowerCase();se.includes("xhr timeout")?te=g.UserDataSyncErrorCode.RequestTimeout:se.includes("protocol")&&se.includes("not supported")?te=g.UserDataSyncErrorCode.RequestProtocolNotSupported:se.includes("request path contains unescaped characters")?te=g.UserDataSyncErrorCode.RequestPathNotEscaped:se.includes("headers must be an object")?te=g.UserDataSyncErrorCode.RequestHeadersNotObject:(0,T.isCancellationError)(q)&&(te=g.UserDataSyncErrorCode.RequestCanceled),q=new g.UserDataSyncStoreError(`Connection refused for the request '${k}'.`,k,te,void 0,void 0)}throw this.logService.info("Request failed",k),q}const Z=B.res.headers[g.HEADER_OPERATION_ID],V={url:k,status:B.res.statusCode,"execution-id":F.headers[g.HEADER_EXECUTION_ID],"operation-id":Z},ie=(0,f.isSuccess)(B)||B.res.statusCode&&U.includes(B.res.statusCode);let z="";if(ie?this.logService.trace("Request succeeded",V):(z=await(0,f.asText)(B)||"",this.logService.info("Request failed",V,z)),B.res.statusCode===401||B.res.statusCode===403){if(this.authToken=void 0,B.res.statusCode===401)throw this._onTokenFailed.fire(g.UserDataSyncErrorCode.Unauthorized),new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of Unauthorized (401).`,k,g.UserDataSyncErrorCode.Unauthorized,B.res.statusCode,Z);if(B.res.statusCode===403)throw this._onTokenFailed.fire(g.UserDataSyncErrorCode.Forbidden),new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because the access is forbidden (403).`,k,g.UserDataSyncErrorCode.Forbidden,B.res.statusCode,Z)}if(this._onTokenSucceed.fire(),B.res.statusCode===404)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because the requested resource is not found (404).`,k,g.UserDataSyncErrorCode.NotFound,B.res.statusCode,Z);if(B.res.statusCode===405)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because the requested endpoint is not found (405). ${z}`,k,g.UserDataSyncErrorCode.MethodNotFound,B.res.statusCode,Z);if(B.res.statusCode===409)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,k,g.UserDataSyncErrorCode.Conflict,B.res.statusCode,Z);if(B.res.statusCode===410)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because the requested resource is not longer available (410).`,k,g.UserDataSyncErrorCode.Gone,B.res.statusCode,Z);if(B.res.statusCode===412)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,k,g.UserDataSyncErrorCode.PreconditionFailed,B.res.statusCode,Z);if(B.res.statusCode===413)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of too large payload (413).`,k,g.UserDataSyncErrorCode.TooLarge,B.res.statusCode,Z);if(B.res.statusCode===426)throw new g.UserDataSyncStoreError(`${F.type} request '${k}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,k,g.UserDataSyncErrorCode.UpgradeRequired,B.res.statusCode,Z);if(B.res.statusCode===429){const q=B.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of too many requests (429).`,k,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,B.res.statusCode,Z)):new g.UserDataSyncStoreError(`${F.type} request '${k}' failed because of too many requests (429).`,k,g.UserDataSyncErrorCode.TooManyRequests,B.res.statusCode,Z)}if(!ie)throw new g.UserDataSyncStoreError("Server returned "+B.res.statusCode,k,g.UserDataSyncErrorCode.Unknown,B.res.statusCode,Z);return B}addSessionHeaders(k){let F=this.storageService.get(i,R.StorageScope.APPLICATION);F===void 0&&(F=(0,h.generateUuid)(),this.storageService.store(i,F,R.StorageScope.APPLICATION,R.StorageTarget.MACHINE)),k["X-Machine-Session-Id"]=F;const U=this.storageService.get(o,R.StorageScope.APPLICATION);U!==void 0&&(k["X-User-Session-Id"]=U)}};e.UserDataSyncStoreClient=b,e.UserDataSyncStoreClient=b=we([X(1,w.IProductService),X(2,f.IRequestService),X(3,g.IUserDataSyncLogService),X(4,l.IEnvironmentService),X(5,y.IFileService),X(6,R.IStorageService)],b);let A=class extends b{constructor(k,F,U,M,H,B,Z){super(k.userDataSyncStore?.url,F,U,M,H,B,Z),this._register(k.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(k.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=A,e.UserDataSyncStoreService=A=we([X(0,g.IUserDataSyncStoreManagementService),X(1,w.IProductService),X(2,f.IRequestService),X(3,g.IUserDataSyncLogService),X(4,l.IEnvironmentService),X(5,y.IFileService),X(6,R.IStorageService)],A);class I{constructor(k,F,U,M){this.limit=k,this.interval=F,this.requestService=U,this.logService=M,this.requests=[],this.startTime=void 0}request(k,F,U){if(this.isExpired()&&this.reset(),F.url=k,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new g.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,k,g.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(k),this.requestService.request(F,U)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(le[271],ue([0,1,3,2,9,22,24,17,127]),function(ne,e,C,c,T,D,O,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class v{constructor(l){this.service=l}listen(l,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${y}`)}call(l,y,w){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(w)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=v;class P extends c.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(l){super(),this.channel=l,this._onDidChangeAccount=this._register(new C.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(y=>{this._account=y,this._register(this.channel.listen("onDidChangeAccount")(w=>{this._account=w,this._onDidChangeAccount.fire(w)}))})}updateAccount(l){return this.channel.call("updateAccount",l)}}e.UserDataSyncAccountServiceChannelClient=P;class p{constructor(l){this.service=l}listen(l,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${y}`)}call(l,y,w){switch(y){case"switch":return this.service.switch(w[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=p;let h=class extends _.AbstractUserDataSyncStoreManagementService{constructor(l,y,w,f){super(y,w,f),this.channel=l,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(l){return this.channel.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(l)}revive(l){return{url:T.URI.revive(l.url),type:l.type,defaultUrl:T.URI.revive(l.defaultUrl),insidersUrl:T.URI.revive(l.insidersUrl),stableUrl:T.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=h,e.UserDataSyncStoreManagementServiceChannelClient=h=we([X(1,O.IProductService),X(2,D.IConfigurationService),X(3,L.IStorageService)],h)}),define(le[272],ue([0,1,3,58,24,17,18,267,25,83,87]),function(ne,e,C,c,T,D,O,L,_,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let p=class extends L.UserDataAutoSyncService{constructor(m,l,y,w,f,S,R,g,s,r,t){super(m,l,y,w,f,R,g,s,r,t),this._register(C.Event.debounce(C.Event.any(C.Event.map(S.onDidFocusMainWindow,()=>"windowFocus"),C.Event.map(S.onDidOpenMainWindow,()=>"windowOpen")),(o,i)=>o?[...o,i]:[i],1e3)(o=>this.triggerSync(o,!0,!1)))}};e.UserDataAutoSyncService=p,e.UserDataAutoSyncService=p=we([X(0,T.IProductService),X(1,_.IUserDataSyncStoreManagementService),X(2,_.IUserDataSyncStoreService),X(3,_.IUserDataSyncEnablementService),X(4,_.IUserDataSyncService),X(5,c.INativeHostService),X(6,_.IUserDataSyncLogService),X(7,v.IUserDataSyncAccountService),X(8,O.ITelemetryService),X(9,P.IUserDataSyncMachinesService),X(10,D.IStorageService)],p)}),define(le[273],ue([0,1,76,23,5,21]),function(ne,e,C,c,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=O,e.getSingleFolderWorkspaceIdentifier=L,e.createEmptyWorkspaceIdentifier=_,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(v){function P(){let p=v.scheme===c.Schemas.file?(0,D.originalFSPath)(v):v.toString();return T.isLinux||(p=p.toLowerCase()),(0,C.createHash)("md5").update(p).digest("hex")}return{id:P(),configPath:v}}function L(v,P){function p(){if(v.scheme!==c.Schemas.file)return(0,C.createHash)("md5").update(v.toString()).digest("hex");if(!P)return;let m;return T.isLinux?m=P.ino:T.isMacintosh?m=P.birthtime.getTime():T.isWindows&&(typeof P.birthtimeMs=="number"?m=Math.floor(P.birthtimeMs):m=P.birthtime.getTime()),(0,C.createHash)("md5").update(v.fsPath).update(m?String(m):"").digest("hex")}const h=p();if(typeof h=="string")return{id:h,uri:v}}function _(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[274],ue([0,1,6,8,2,14,31,16,10,80,116,273,58,57,23]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let y=class extends T.Disposable{constructor(f,S,R,g){super(),this.environmentService=f,this.logService=S,this.nativeHostService=R,this.mainProcessService=g,this._register(new C.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.environmentService.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,S=await O.Promises.readdir(f),R=new v.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(S.map(async g=>{const s=(0,D.join)(f,g);g.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||g===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(o=>o.workspace?.id===g)||await R.isUsed(s)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await O.Promises.rm(s))}))}catch(f){(0,c.onUnexpectedError)(f)}}};e.UnusedWorkspaceStorageDataCleaner=y,e.UnusedWorkspaceStorageDataCleaner=y=we([X(0,L.INativeEnvironmentService),X(1,_.ILogService),X(2,h.INativeHostService),X(3,m.IMainProcessService)],y)}),define(le[128],ue([0,1,76,67,38,282,15,8,3,2,14,5,32,43,71]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=i,e.createStaticIPCHandle=n,e.serve=d,e.connect=b;const y=3e4;class w{traceSocketEvent(I,E){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,E)}constructor(I,E=""){this._canWrite=!0,this.debugLabel=E,this.socket=I,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,L.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener);let k;this._closeListener=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this._canWrite=!1,k&&clearTimeout(k)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,k=setTimeout(()=>I.destroy(),y)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(I){const E=k=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,k),I(O.VSBuffer.wrap(k))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(I){const E=k=>{I({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:k,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(I){const E=()=>{I()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(I){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,I),this.socket.write(I.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,L.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,L.onUnexpectedError)(E)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((I,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),I();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),I()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=w;var f;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var S;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(S||(S={}));class R extends v.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,E){this.socket.traceSocketEvent(I,E)}constructor(I,E,k,F){super(),this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:S.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:k?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new g(this,E,k,F,this._onData,(U,M)=>this._write(U,M))),this._register(this._flowManager.onError(U=>{console.error(U),(0,L.onUnexpectedError)(U),this._onClose.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this._incomingData=new l.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(async U=>{this._flowManager.isProcessingReadQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(U)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let E=0;for(;E<I.byteLength;)this._flowManager.writeMessage(I.slice(E,Math.min(E+f.MaxWebSocketMessageLength,I.byteLength)),{compressed:!0,opcode:2}),E+=f.MaxWebSocketMessageLength}_write(I,{compressed:E,opcode:k}){if(this._isEnded)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,I);let F=f.MinHeaderByteSize;I.byteLength<126?F+=0:I.byteLength<2**16?F+=2:F+=8;const U=O.VSBuffer.alloc(F),M=E?64:0,H=k&15;if(U.writeUInt8(128|M|H,0),I.byteLength<126)U.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){U.writeUInt8(126,1);let B=1;U.writeUInt8(I.byteLength>>>8&255,++B),U.writeUInt8(I.byteLength>>>0&255,++B)}else{U.writeUInt8(127,1);let B=1;U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(I.byteLength>>>24&255,++B),U.writeUInt8(I.byteLength>>>16&255,++B),U.writeUInt8(I.byteLength>>>8&255,++B),U.writeUInt8(I.byteLength>>>0&255,++B)}this.socket.write(O.VSBuffer.concat([U,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===S.PeekHeader){const E=this._incomingData.peek(this._state.readLen),k=E.readUInt8(0),F=(k&128)>>>7,U=(k&64)>>>6,M=k&15,H=E.readUInt8(1),B=(H&128)>>>7,Z=H&127;this._state.state=S.ReadHeader,this._state.readLen=f.MinHeaderByteSize+(B?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!U),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===S.ReadHeader){const E=this._incomingData.read(this._state.readLen),k=E.readUInt8(1),F=(k&128)>>>7;let U=k&127,M=1;U===126?U=E.readUInt8(++M)*2**8+E.readUInt8(++M):U===127&&(U=E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*2**24+E.readUInt8(++M)*2**16+E.readUInt8(++M)*2**8+E.readUInt8(++M));let H=0;F&&(H=E.readUInt8(++M)*2**24+E.readUInt8(++M)*2**16+E.readUInt8(++M)*2**8+E.readUInt8(++M)),this._state.state=S.ReadBody,this._state.readLen=U,this._state.mask=H,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===S.ReadBody){const E=this._incomingData.read(this._state.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,E),t(E,this._state.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,E),this._state.state=S.PeekHeader,this._state.readLen=f.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(E,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await _.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=R;class g extends v.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:O.VSBuffer.alloc(0)}constructor(I,E,k,F,U,M){super(),this._tracer=I,this._onData=U,this._writeFn=M,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new _.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new _.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,E?(this._zlibInflateStream=this._register(new s(this._tracer,F,k,{windowBits:15})),this._zlibDeflateStream=this._register(new r(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(I,E){this._writeQueue.push({data:I,options:E}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:I,options:E}=this._writeQueue.shift();if(this._zlibDeflateStream&&E.compressed){const k=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(k,E)}else this._writeFn(I,{...E,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,E){return new Promise((k,F)=>{I.write(E),I.flush(U=>k(U))})}acceptFrame(I,E,k){this._readQueue.push({data:I,isCompressed:E,isLastFrameOfMessage:k}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const E=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(E)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(I,E,k){return new Promise((F,U)=>{I.write(E),k&&I.write(O.VSBuffer.fromByteArray([0,0,255,255])),I.flush(M=>F(M))})}}class s extends v.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?O.VSBuffer.concat(this._recordedInflateBytes):O.VSBuffer.alloc(0)}constructor(I,E,k,F){super(),this._tracer=I,this._recordInflateBytes=E,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,D.createInflateRaw)(F),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this._pendingInflateData.push(O.VSBuffer.wrap(U))}),k&&(this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,k.buffer),this._zlibInflate.write(k.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const E=O.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(E)})}}class r extends v.Disposable{constructor(I,E){super(),this._tracer=I,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,D.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",k=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibDeflate.on("data",k=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,k),this._pendingDeflateData.push(O.VSBuffer.wrap(k))})}write(I){this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let E=O.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.byteLength-4),I(E)})}}function t(A,I){if(I===0)return;const E=A.byteLength>>>2;for(let B=0;B<E;B++){const Z=A.readUInt32BE(B*4);A.writeUInt32BE(Z^I,B*4)}const k=E*4,F=A.byteLength-k,U=I>>>24&255,M=I>>>16&255,H=I>>>8&255;F>=1&&A.writeUInt8(A.readUInt8(k)^U,k),F>=2&&A.writeUInt8(A.readUInt8(k+1)^M,k+1),F>=3&&A.writeUInt8(A.readUInt8(k+2)^H,k+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[p.Platform.Linux]:107,[p.Platform.Mac]:103};function i(){const A=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const I=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,T.tmpdir)(),E=(0,P.join)(I,`vscode-ipc-${A}.sock`);return a(E),E}function n(A,I,E){const F=(0,C.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${E}-${I}-sock`;const U=E.substr(0,4),M=I.substr(0,6);let H;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${U}-${M}.sock`):H=(0,P.join)(A,`${U}-${M}.sock`),a(H),H}function a(A){const I=o[p.platform];typeof I=="number"&&A.length>=I&&console.warn(`WARNING: IPC handle "${A}" is longer than ${I} chars, try a shorter --user-data-dir`)}class u extends m.IPCServer{static toClientConnectionEvent(I){const E=_.Event.fromNodeEventEmitter(I,"connection");return _.Event.map(E,k=>({protocol:new l.Protocol(new w(k,"ipc-server-connection")),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(k,"close"))}))}constructor(I){super(u.toClientConnectionEvent(I)),this.server=I}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function d(A){return new Promise((I,E)=>{const k=(0,c.createServer)();k.on("error",E),k.listen(A,()=>{k.removeListener("error",E),I(new u(k))})})}function b(A,I){return new Promise((E,k)=>{const F=(0,c.createConnection)(A,()=>{F.removeListener("error",k),E(l.Client.fromSocket(new w(F,`ipc-client${I}`),I))});F.once("error",k)})}}),define(le[275],ue([0,1,67,128,222]),function(ne,e,C,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,C=De(C),e.nodeSocketFactory=new class{supports(D){return!0}connect({host:D,port:O},L,_,v){return new Promise((P,p)=>{const h=C.createConnection({host:D,port:O},()=>{h.removeListener("error",p),h.write((0,T.makeRawSocketHeaders)(L,_,v));const m=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(h.off("data",m),P(new c.NodeSocket(h,v)))};h.on("data",m)});h.setNoDelay(!0),h.once("error",p)})}}}),define(le[276],ue([0,1,67,38,139,128,6,2,5,22,10,24,223,107,109,81,15]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,C=De(C),c=De(c);async function f(r,t,o,i,n){let a;for(let u=3;u&&(a?.dispose(),a=await new S(r,t,o,i,n).waitForReady(),!(n&&T.BROWSER_RESTRICTED_PORTS[n]||!T.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));u--);return a}class S extends L.Disposable{constructor(t,o,i,n,a){super(),this.defaultTunnelHost=o,this.suggestedLocalPort=a,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=t,this._server=C.createServer(),this._barrier=new O.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=u=>this._onConnection(u),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){const t=this.suggestedLocalPort??this.tunnelRemotePort,o=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,T.findFreePortFaster)(t,2,1e3,o),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(t){t.pause();const o=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,h.connectRemoteAgentTunnel)(this._options,o,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&t.write(a.buffer),t.on("end",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),n.end()}),t.on("close",()=>n.end()),t.on("error",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),n instanceof D.NodeSocket?n.socket.destroy():n.end()}),n instanceof D.NodeSocket?this._mirrorNodeSocket(t,n):this._mirrorGenericSocket(t,n),t.localAddress&&this._socketsDispose.set(t.localAddress,()=>{t.end(),n.end()})}_mirrorGenericSocket(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(i=>t.write(i.buffer)),t.on("data",i=>o.write(w.VSBuffer.wrap(i))),t.resume()}_mirrorNodeSocket(t,o){const i=o.socket;i.on("end",()=>t.end()),i.on("close",()=>t.end()),i.on("error",()=>{t.destroy()}),i.pipe(t),t.pipe(i)}}e.NodeRemoteTunnel=S;let R=class extends y.AbstractTunnelService{constructor(t,o,i,n,a){super(o,a),this.remoteSocketFactoryService=t,this.signService=i,this.productService=n}isPortPrivileged(t){return(0,y.isPortPrivileged)(t,this.defaultTunnelHost,_.OS,c.release())}retainOrCreateTunnel(t,o,i,n,a,u,d,b){const A=this.getTunnelFromMap(o,i);if(A)return++A.refcount,A.value;if((0,y.isTunnelProvider)(t))return this.createWithProvider(t,o,i,a,u,d,b);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${i} on local port ${a}.`);const I={commit:this.productService.commit,quality:this.productService.quality,addressProvider:t,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},E=f(I,n,o,i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,i,E),E}}};e.BaseTunnelService=R,e.BaseTunnelService=R=we([X(0,m.IRemoteSocketFactoryService),X(1,P.ILogService),X(2,l.ISignService),X(3,p.IProductService),X(4,v.IConfigurationService)],R);let g=class extends R{constructor(t,o,i,n,a){super(t,o,i,n,a)}};e.TunnelService=g,e.TunnelService=g=we([X(0,m.IRemoteSocketFactoryService),X(1,P.ILogService),X(2,l.ISignService),X(3,p.IProductService),X(4,v.IConfigurationService)],g);let s=class extends L.Disposable{constructor(t,o,i,n,a){super(),this.remoteSocketFactoryService=t,this.logService=o,this.productService=i,this.signService=n,this.configurationService=a,this._tunnelServices=new Map}async openTunnel(t,o,i,n,a,u,d,b,A){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${u}.`),!this._tunnelServices.has(t)){const I=new g(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(I),this._tunnelServices.set(t,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this._tunnelServices.delete(t))})}return this._tunnelServices.get(t).openTunnel(o,i,n,a,u,d,b,A)}};e.SharedTunnelsService=s,e.SharedTunnelsService=s=we([X(0,m.IRemoteSocketFactoryService),X(1,P.ILogService),X(2,p.IProductService),X(3,l.ISignService),X(4,v.IConfigurationService)],s)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[283],ue([0,1,38,41,8,2,23,9,19,3,43,157,216,217,226,208,274,199,200,22,221,98,233,99,228,16,119,260,28,111,224,118,75,7,210,211,74,4,207,77,79,236,10,212,103,24,62,17,110,18,112,113,114,49,239,86,115,25,83,266,271,249,87,265,269,270,127,63,264,250,109,232,81,276,227,240,29,241,5,242,201,219,218,85,255,20,53,215,59,263,238,251,108,268,256,11,213,102,261,254,229,195,58,214,272,258,57,262,107,105,275,193,230,153,146,151]),function(ne,e,C,c,T,D,O,L,_,v,P,p,h,m,l,y,w,f,S,R,g,s,r,t,o,i,n,a,u,d,b,A,I,E,k,F,U,M,H,B,Z,V,ie,z,q,te,se,ce,W,Q,G,j,N,Y,$,x,J,ee,K,oe,he,ge,Se,Pe,ve,ye,Ie,be,ae,fe,me,Ce,Te,Fe,Oe,_e,Ne,We,je,Me,$e,qe,Be,Ae,re,de,pe,Ee,Le,ke,xe,Je,Ge,Ye,ze,Ze,Xe,nt,at,_t,At,kt,Ot,Ut,Nt,Ft,Et,Mt,wt,xt,Wt,$t,ut,qt,Bt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=bt,q=it(q);class zt extends D.Disposable{constructor(Re){super(),this.configuration=Re,this.server=this._register(new p.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new v.Emitter),this.registerListeners()}registerListeners(){let Re=!1;const Ue=()=>{Re||(Re=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,p.once)(process.parentPort,ut.SharedProcessLifecycle.exit,Ue)}async init(){const Re=await this.initServices();(0,ee.registerConfiguration)(),Re.invokeFunction(Ue=>{const He=Ue.get(ie.ILogService),Ve=Ue.get(Q.ITelemetryService),et=Ue.get(de.IUserDataProfilesService);He.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(He),this.reportProfilesInfo(Ve,et),this._register(et.onDidChangeProfiles(()=>this.reportProfilesInfo(Ve,et))),this.reportClientOSInfo(Ve,He)}),this._register((0,D.combinedDisposable)(Re.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),Re.createInstance(m.LanguagePackCachedDataCleaner),Re.createInstance(w.UnusedWorkspaceStorageDataCleaner),Re.createInstance(y.LogsDataCleaner),Re.createInstance(l.LocalizationsUpdater),Re.createInstance(ze.ExtensionsContributions),Re.createInstance(Je.UserDataProfilesCleaner)))}async initServices(){const Re=new B.ServiceCollection,Ue={_serviceBrand:void 0,...q.default};Re.set(te.IProductService,Ue);const He=new P.StaticRouter(Qe=>Qe==="main"),Ve=new Et.MainProcessService(this.server,He);Re.set(Et.IMainProcessService,Ve);const et=this.configuration.policiesData?new Ee.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new Le.NullPolicyService;Re.set(Le.IPolicyService,et);const Ke=new $t.NativeEnvironmentService(this.configuration.args,Ue);Re.set(i.INativeEnvironmentService,Ke);const ot=new z.LoggerChannelClient(void 0,this.configuration.logLevel,Ke.logsHome,this.configuration.loggers.map(Qe=>({...Qe,resource:L.URI.revive(Qe.resource)})),Ve.getChannel("logger"));Re.set(ie.ILoggerService,ot);const dt=this._register(ot.createLogger("sharedprocess",{name:(0,Ze.localize)(0,null)})),pt=this._register(new ie.ConsoleLogger(dt.getLevel())),tt=this._register(new Xe.LogService(dt,[pt]));Re.set(ie.ILogService,tt),this.lifecycleService=this._register(new nt.SharedProcessLifecycleService(tt)),Re.set(nt.ISharedProcessLifecycleService,this.lifecycleService);const st=this._register(new k.FileService(tt));Re.set(E.IFileService,st);const St=this._register(new F.DiskFileSystemProvider(tt));st.registerProvider(O.Schemas.file,St);const ft=new We.UriIdentityService(st);Re.set(Ne.IUriIdentityService,ft);const rt=this._register(new ke.UserDataProfilesService(this.configuration.profiles.all,L.URI.revive(this.configuration.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Re.set(de.IUserDataProfilesService,rt);const vt=this._register(new Me.FileUserDataProvider(O.Schemas.file,this._register(new $e.DiskFileSystemProviderClient(Ve.getChannel($e.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:je.isLinux})),O.Schemas.vscodeUserData,rt,ft,tt));st.registerProvider(O.Schemas.vscodeUserData,vt);const ct=this._register(new g.ConfigurationService(rt.defaultProfile.settingsResource,st,et,tt));Re.set(R.IConfigurationService,ct);const yt=new Mt.RemoteStorageService(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ve,Ke);Re.set(ce.IStorageService,yt),this._register((0,D.toDisposable)(()=>yt.flush())),await Promise.all([ct.initialize(),yt.initialize()]);const Pt=new At.RequestChannelClient(Ve.getChannel("request"));Re.set(se.IRequestService,Pt),Re.set(f.IChecksumService,new U.SyncDescriptor(S.ChecksumService,void 0,!1)),Re.set(Be.IV8InspectProfilingService,new U.SyncDescriptor(qe.InspectProfilingService,void 0,!1));const Rt=new Ut.NativeHostService(-1,Ve);Re.set(Ot.INativeHostService,Rt),Re.set(t.IDownloadService,new U.SyncDescriptor(o.DownloadService,void 0,!0));const Vt=this._register(new fe.ActiveWindowManager(Rt)),Ht=new P.StaticRouter(Qe=>Vt.getActiveClientId().then(mt=>Qe===mt));Re.set(I.IExtensionRecommendationNotificationService,new kt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ht)));let gt;const lt=[],Ct=(0,Y.isInternalTelemetry)(Ue,ct);if((0,Y.supportsTelemetry)(Ue,Ke)){const Qe=new j.TelemetryLogAppender(tt,ot,Ke,Ue);if(lt.push(Qe),!(0,Y.isLoggingOnly)(Ue,Ke)&&Ue.aiConfig?.ariaKey){const mt=new xe.OneDataSystemAppender(Pt,Ct,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,D.toDisposable)(()=>mt.flush())),lt.push(mt)}gt=new N.TelemetryService({appenders:lt,commonProperties:(0,W.resolveCommonProperties)((0,C.release)(),(0,C.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,this.configuration.sqmId,this.configuration.devDeviceId,Ct),sendErrorTelemetry:!0,piiPaths:(0,Y.getPiiPathsFromEnvironment)(Ke)},ct,Ue)}else{gt=Y.NullTelemetryService;const Qe=Y.NullAppender;lt.push(Qe)}this.server.registerChannel("telemetryAppender",new G.TelemetryAppenderChannel(lt)),Re.set(Q.ITelemetryService,gt);const Gt=new $.CustomEndpointTelemetryService(ct,gt,tt,ot,Ke,Ue);Re.set(Q.ICustomEndpointTelemetryService,Gt),Re.set(pe.IExtensionsProfileScannerService,new U.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Re.set(Ae.IExtensionsScannerService,new U.SyncDescriptor(re.ExtensionsScannerService,void 0,!0)),Re.set(d.IExtensionSignatureVerificationService,new U.SyncDescriptor(d.ExtensionSignatureVerificationService,void 0,!0)),Re.set(A.INativeServerExtensionManagementService,new U.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),Re.set(u.IExtensionGalleryService,new U.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),Re.set(u.IExtensionTipsService,new U.SyncDescriptor(Ft.ExtensionTipsService,void 0,!1)),Re.set(Z.ILanguagePackService,new U.SyncDescriptor(V.NativeLanguagePackService,void 0,!1)),Re.set(s.IDiagnosticsService,new U.SyncDescriptor(r.DiagnosticsService,void 0,!1)),Re.set(K.IUserDataSyncAccountService,new U.SyncDescriptor(K.UserDataSyncAccountService,void 0,!0)),Re.set(ee.IUserDataSyncLogService,new U.SyncDescriptor(ge.UserDataSyncLogService,void 0,!0)),Re.set(ee.IUserDataSyncUtilService,P.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Re.set(u.IGlobalExtensionEnablementService,new U.SyncDescriptor(n.GlobalExtensionEnablementService,void 0,!1)),Re.set(J.IIgnoredExtensionsManagementService,new U.SyncDescriptor(J.IgnoredExtensionsManagementService,void 0,!0)),Re.set(x.IExtensionStorageService,new U.SyncDescriptor(x.ExtensionStorageService)),Re.set(ee.IUserDataSyncStoreManagementService,new U.SyncDescriptor(Ie.UserDataSyncStoreManagementService,void 0,!0)),Re.set(ee.IUserDataSyncStoreService,new U.SyncDescriptor(Ie.UserDataSyncStoreService,void 0,!0)),Re.set(Se.IUserDataSyncMachinesService,new U.SyncDescriptor(Se.UserDataSyncMachinesService,void 0,!0)),Re.set(ee.IUserDataSyncLocalStoreService,new U.SyncDescriptor(oe.UserDataSyncLocalStoreService,void 0,!1)),Re.set(ee.IUserDataSyncEnablementService,new U.SyncDescriptor(Pe.UserDataSyncEnablementService,void 0,!0)),Re.set(ee.IUserDataSyncService,new U.SyncDescriptor(ve.UserDataSyncService,void 0,!1)),Re.set(be.IUserDataProfileStorageService,new U.SyncDescriptor(ae.SharedProcessUserDataProfileStorageService,void 0,!0)),Re.set(ee.IUserDataSyncResourceProviderService,new U.SyncDescriptor(Ye.UserDataSyncResourceProviderService,void 0,!0)),Re.set(me.ISignService,new U.SyncDescriptor(Ce.SignService,void 0,!1));const Dt=new wt.RemoteSocketFactoryService;return Re.set(wt.IRemoteSocketFactoryService,Dt),Dt.register(xt.RemoteConnectionType.WebSocket,Wt.nodeSocketFactory),Re.set(Te.ISharedTunnelsService,new U.SyncDescriptor(Fe.SharedTunnelsService)),Re.set(Oe.ISharedProcessTunnelService,new U.SyncDescriptor(_e.SharedProcessTunnelService)),Re.set(Ge.IRemoteTunnelService,new U.SyncDescriptor(at.RemoteTunnelService)),new H.InstantiationService(Re)}initChannels(Re){const Ue=new b.ExtensionManagementChannel(Re.get(u.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const He=P.ProxyChannel.fromService(Re.get(Z.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",He);const Ve=P.ProxyChannel.fromService(Re.get(s.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",Ve);const et=new b.ExtensionTipsChannel(Re.get(u.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Ke=P.ProxyChannel.fromService(Re.get(f.IChecksumService),this._store);this.server.registerChannel("checksum",Ke);const ot=P.ProxyChannel.fromService(Re.get(Be.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",ot);const dt=P.ProxyChannel.fromService(Re.get(Se.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",dt);const pt=P.ProxyChannel.fromService(Re.get(Q.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",pt);const tt=new he.UserDataSyncAccountServiceChannel(Re.get(K.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",tt);const st=new he.UserDataSyncStoreManagementServiceChannel(Re.get(ee.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",st);const St=new ye.UserDataSyncServiceChannel(Re.get(ee.IUserDataSyncService),Re.get(de.IUserDataProfilesService),Re.get(ie.ILogService));this.server.registerChannel("userDataSync",St);const ft=this._register(Re.get(M.IInstantiationService).createInstance(Nt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(ft,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Re.get(ee.IUserDataSyncResourceProviderService),this._store));const rt=P.ProxyChannel.fromService(Re.get(Oe.ISharedProcessTunnelService),this._store);this.server.registerChannel(Oe.ipcSharedProcessTunnelChannelName,rt);const vt=P.ProxyChannel.fromService(Re.get(Ge.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",vt)}registerErrorHandler(Re){process.on("uncaughtException",Ue=>(0,T.onUnexpectedError)(Ue)),process.on("unhandledRejection",Ue=>(0,T.onUnexpectedError)(Ue)),(0,T.setUnexpectedErrorHandler)(Ue=>{const He=(0,c.toErrorMessage)(Ue,!0);He&&Re.error(`[uncaught exception in sharedProcess]: ${He}`)})}reportProfilesInfo(Re,Ue){Re.publicLog2("profilesInfo",{count:Ue.profiles.length})}async reportClientOSInfo(Re,Ue){if(je.isLinux){const[He,Ve]=await Promise.all([(0,qt.getOSReleaseInfo)(Ue.error.bind(Ue)),(0,It.getDisplayProtocol)(Ue.error.bind(Ue))]),et=(0,Bt.getDesktopEnvironment)(),Ke=(0,It.getCodeDisplayProtocol)(Ve,this.configuration.args["ozone-platform"]);He&&Re.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:et,displayProtocol:Ve,codeDisplayProtocol:Ke})}}handledClientConnection(Re){if(Re.data!==ut.SharedProcessRawConnection.response)return!1;const Ue=(0,_.firstOrDefault)(Re.ports);return Ue?(this.onDidWindowConnectRaw.fire(Ue),!0):!1}}async function bt(ht){try{const Re=new zt(ht);process.parentPort.postMessage(ut.SharedProcessLifecycle.ipcReady),await Re.init(),process.parentPort.postMessage(ut.SharedProcessLifecycle.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const jt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ht=>{clearTimeout(jt),bt(ht.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
