/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/nls","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","vs/base/common/marshallingIds","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],a=0,t=ie.length;a<t;a++)e[a]=he[ie[a]];return e};define(he[43],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=a,e.findLastIdx=t,e.findLastMonotonous=L,e.findLastIdxMonotonous=y,e.findFirstMonotonous=W,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=v,e.findFirstMax=w,e.findLastMax=_,e.findFirstMin=f,e.findMaxIdx=c,e.mapFindFirst=l;function a(h,m){const u=t(h,m);if(u!==-1)return h[u]}function t(h,m,u=h.length-1){for(let r=u;r>=0;r--){const p=h[r];if(m(p))return r}return-1}function L(h,m){const u=y(h,m);return u===-1?void 0:h[u]}function y(h,m,u=0,r=h.length){let p=u,b=r;for(;p<b;){const s=Math.floor((p+b)/2);m(h[s])?p=s+1:b=s}return p-1}function W(h,m){const u=P(h,m);return u===h.length?void 0:h[u]}function P(h,m,u=0,r=h.length){let p=u,b=r;for(;p<b;){const s=Math.floor((p+b)/2);m(h[s])?b=s:p=s+1}return p}function v(h,m,u=0,r=h.length){const p=P(h,m,u,r);return p===h.length?-1:p}class o{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(o.assertInvariants){if(this._prevFindLastPredicate){for(const r of this._array)if(this._prevFindLastPredicate(r)&&!m(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const u=y(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=o;function w(h,m){if(h.length===0)return;let u=h[0];for(let r=1;r<h.length;r++){const p=h[r];m(p,u)>0&&(u=p)}return u}function _(h,m){if(h.length===0)return;let u=h[0];for(let r=1;r<h.length;r++){const p=h[r];m(p,u)>=0&&(u=p)}return u}function f(h,m){return w(h,(u,r)=>-m(u,r))}function c(h,m){if(h.length===0)return-1;let u=0;for(let r=1;r<h.length;r++){const p=h[r];m(p,h[u])>0&&(u=r)}return u}function l(h,m){for(const u of h){const r=m(u);if(r!==void 0)return r}}}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define(he[44],fe([0,1]),function(ie,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=L,e.diffMaps=y,e.intersection=W;function t(v,o){const w=Object.create(null);for(const _ of v){const f=o(_);let c=w[f];c||(c=w[f]=[]),c.push(_)}return w}function L(v,o){const w=[],_=[];for(const f of v)o.has(f)||w.push(f);for(const f of o)v.has(f)||_.push(f);return{removed:w,added:_}}function y(v,o){const w=[],_=[];for(const[f,c]of v)o.has(f)||w.push(c);for(const[f,c]of o)v.has(f)||_.push(c);return{removed:w,added:_}}function W(v,o){const w=new Set;for(const _ of o)v.has(_)&&w.add(_);return w}class P{static{a=Symbol.toStringTag}constructor(o,w){this.toKey=w,this._map=new Map,this[a]="SetWithKey";for(const _ of o)this.add(_)}get size(){return this._map.size}add(o){const w=this.toKey(o);return this._map.set(w,o),this}delete(o){return this._map.delete(this.toKey(o))}has(o){return this._map.has(this.toKey(o))}*entries(){for(const o of this._map.values())yield[o,o]}keys(){return this.values()}*values(){for(const o of this._map.values())yield o}clear(){this._map.clear()}forEach(o,w){this._map.forEach(_=>o.call(w,_,_,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=P}),define(he[15],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=t,e.debounce=L,e.throttle=y;function a(W){return(P,v,o)=>{let w=null,_=null;if(typeof o.value=="function"?(w="value",_=o.value):typeof o.get=="function"&&(w="get",_=o.get),!_)throw new Error("not supported");o[w]=W(_,v)}}function t(W,P,v){let o=null,w=null;if(typeof v.value=="function"?(o="value",w=v.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(o="get",w=v.get),!w)throw new Error("not supported");const _=`$memoize$${P}`;v[o]=function(...f){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,f)}),this[_]}}function L(W,P,v){return a((o,w)=>{const _=`$debounce$${w}`,f=`$debounce$result$${w}`;return function(...c){this[f]||(this[f]=v?v():void 0),clearTimeout(this[_]),P&&(this[f]=P(this[f],...c),c=[this[f]]),this[_]=setTimeout(()=>{o.apply(this,c),this[f]=v?v():void 0},W)}})}function y(W,P,v){return a((o,w)=>{const _=`$throttle$timer$${w}`,f=`$throttle$result$${w}`,c=`$throttle$lastRun$${w}`,l=`$throttle$pending$${w}`;return function(...h){if(this[f]||(this[f]=v?v():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...h)),this[l])return;const m=this[c]+W;m<=Date.now()?(this[c]=Date.now(),o.apply(this,[this[f]]),this[f]=v?v():void 0):(this[l]=!0,this[_]=setTimeout(()=>{this[l]=!1,this[c]=Date.now(),o.apply(this,[this[f]]),this[f]=v?v():void 0},m-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=L,e.onUnexpectedError=y,e.onUnexpectedExternalError=W,e.transformErrorForSerialization=P,e.transformErrorFromSerialization=v,e.isCancellationError=w,e.canceled=f,e.illegalArgument=c,e.illegalState=l,e.getErrorMessage=m;class a{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?b.isErrorNoTelemetry(n)?new b(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(S=>{S(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=a,e.errorHandler=new a;function t(i){e.errorHandler.setUnexpectedErrorHandler(i)}function L(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function y(i){w(i)||e.errorHandler.onUnexpectedError(i)}function W(i){w(i)||e.errorHandler.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:n,message:S}=i,A=i.stacktrace||i.stack;return{$isError:!0,name:n,message:S,stack:A,noTelemetry:b.isErrorNoTelemetry(i)}}return i}function v(i){let n;return i.noTelemetry?n=new b:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const o="Canceled";function w(i){return i instanceof _?!0:i instanceof Error&&i.name===o&&i.message===o}class _ extends Error{constructor(){super(o),this.name=this.message}}e.CancellationError=_;function f(){const i=new Error(o);return i.name=i.message,i}function c(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function l(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class h extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=h;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class u extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=u;class r extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=r;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof b)return n;const S=new b;return S.message=n.message,S.stack=n.stack,S}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class s extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.BugIndicatingError=s}),define(he[18],fe([0,1,7,43]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=L,e.tail2=y,e.equals=W,e.removeFastWithoutKeepingOrder=P,e.binarySearch=v,e.binarySearch2=o,e.quickSelect=w,e.groupBy=_,e.groupAdjacentBy=f,e.forEachAdjacent=c,e.forEachWithNeighbors=l,e.sortedDiff=h,e.delta=m,e.top=u,e.topAsync=r,e.coalesce=b,e.coalesceInPlace=s,e.move=i,e.isFalsyOrEmpty=n,e.isNonEmptyArray=S,e.distinct=A,e.uniqueFilter=O,e.firstOrDefault=E,e.lastOrDefault=D,e.commonPrefixLength=I,e.range=x,e.index=z,e.insert=k,e.remove=g,e.arrayInsert=M,e.shuffle=R,e.pushToStart=C,e.pushToEnd=B,e.pushMany=Z,e.mapArrayOrNot=G,e.asArray=J,e.getRandomElement=se,e.insertInto=le,e.splice=V,e.compareBy=ee,e.tieBreakComparators=ue,e.reverseOrder=ge;function L(U,N=0){return U[U.length-(1+N)]}function y(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function W(U,N,K=(j,T)=>j===T){if(U===N)return!0;if(!U||!N||U.length!==N.length)return!1;for(let j=0,T=U.length;j<T;j++)if(!K(U[j],N[j]))return!1;return!0}function P(U,N){const K=U.length-1;N<K&&(U[N]=U[K]),U.pop()}function v(U,N,K){return o(U.length,j=>K(U[j],N))}function o(U,N){let K=0,j=U-1;for(;K<=j;){const T=(K+j)/2|0,X=N(T);if(X<0)K=T+1;else if(X>0)j=T-1;else return T}return-(K+1)}function w(U,N,K){if(U=U|0,U>=N.length)throw new TypeError("invalid index");const j=N[Math.floor(N.length*Math.random())],T=[],X=[],ne=[];for(const oe of N){const pe=K(oe,j);pe<0?T.push(oe):pe>0?X.push(oe):ne.push(oe)}return U<T.length?w(U,T,K):U<T.length+ne.length?ne[0]:w(U-(T.length+ne.length),X,K)}function _(U,N){const K=[];let j;for(const T of U.slice(0).sort(N))!j||N(j[0],T)!==0?(j=[T],K.push(j)):j.push(T);return K}function*f(U,N){let K,j;for(const T of U)j!==void 0&&N(j,T)?K.push(T):(K&&(yield K),K=[T]),j=T;K&&(yield K)}function c(U,N){for(let K=0;K<=U.length;K++)N(K===0?void 0:U[K-1],K===U.length?void 0:U[K])}function l(U,N){for(let K=0;K<U.length;K++)N(K===0?void 0:U[K-1],U[K],K+1===U.length?void 0:U[K+1])}function h(U,N,K){const j=[];function T(oe,pe,we){if(pe===0&&we.length===0)return;const me=j[j.length-1];me&&me.start+me.deleteCount===oe?(me.deleteCount+=pe,me.toInsert.push(...we)):j.push({start:oe,deleteCount:pe,toInsert:we})}let X=0,ne=0;for(;;){if(X===U.length){T(X,0,N.slice(ne));break}if(ne===N.length){T(X,U.length-X,[]);break}const oe=U[X],pe=N[ne],we=K(oe,pe);we===0?(X+=1,ne+=1):we<0?(T(X,1,[]),X+=1):we>0&&(T(X,0,[pe]),ne+=1)}return j}function m(U,N,K){const j=h(U,N,K),T=[],X=[];for(const ne of j)T.push(...U.slice(ne.start,ne.start+ne.deleteCount)),X.push(...ne.toInsert);return{removed:T,added:X}}function u(U,N,K){if(K===0)return[];const j=U.slice(0,K).sort(N);return p(U,N,j,K,U.length),j}function r(U,N,K,j,T){return K===0?Promise.resolve([]):new Promise((X,ne)=>{(async()=>{const oe=U.length,pe=U.slice(0,K).sort(N);for(let we=K,me=Math.min(K+j,oe);we<oe;we=me,me=Math.min(me+j,oe)){if(we>K&&await new Promise(de=>setTimeout(de)),T&&T.isCancellationRequested)throw new a.CancellationError;p(U,N,pe,we,me)}return pe})().then(X,ne)})}function p(U,N,K,j,T){for(const X=K.length;j<T;j++){const ne=U[j];if(N(ne,K[X-1])<0){K.pop();const oe=(0,t.findFirstIdxMonotonousOrArrLen)(K,pe=>N(ne,pe)<0);K.splice(oe,0,ne)}}}function b(U){return U.filter(N=>!!N)}function s(U){let N=0;for(let K=0;K<U.length;K++)U[K]&&(U[N]=U[K],N+=1);U.length=N}function i(U,N,K){U.splice(K,0,U.splice(N,1)[0])}function n(U){return!Array.isArray(U)||U.length===0}function S(U){return Array.isArray(U)&&U.length>0}function A(U,N=K=>K){const K=new Set;return U.filter(j=>{const T=N(j);return K.has(T)?!1:(K.add(T),!0)})}function O(U){const N=new Set;return K=>{const j=U(K);return N.has(j)?!1:(N.add(j),!0)}}function E(U,N){return U.length>0?U[0]:N}function D(U,N){return U.length>0?U[U.length-1]:N}function I(U,N,K=(j,T)=>j===T){let j=0;for(let T=0,X=Math.min(U.length,N.length);T<X&&K(U[T],N[T]);T++)j++;return j}function x(U,N){let K=typeof N=="number"?U:0;typeof N=="number"?K=U:(K=0,N=U);const j=[];if(K<=N)for(let T=K;T<N;T++)j.push(T);else for(let T=K;T>N;T--)j.push(T);return j}function z(U,N,K){return U.reduce((j,T)=>(j[N(T)]=K?K(T):T,j),Object.create(null))}function k(U,N){return U.push(N),()=>g(U,N)}function g(U,N){const K=U.indexOf(N);if(K>-1)return U.splice(K,1),N}function M(U,N,K){const j=U.slice(0,N),T=U.slice(N);return j.concat(K,T)}function R(U,N){let K;if(typeof N=="number"){let j=N;K=()=>{const T=Math.sin(j++)*179426549;return T-Math.floor(T)}}else K=Math.random;for(let j=U.length-1;j>0;j-=1){const T=Math.floor(K()*(j+1)),X=U[j];U[j]=U[T],U[T]=X}}function C(U,N){const K=U.indexOf(N);K>-1&&(U.splice(K,1),U.unshift(N))}function B(U,N){const K=U.indexOf(N);K>-1&&(U.splice(K,1),U.push(N))}function Z(U,N){for(const K of N)U.push(K)}function G(U,N){return Array.isArray(U)?U.map(N):N(U)}function J(U){return Array.isArray(U)?U:[U]}function se(U){return U[Math.floor(Math.random()*U.length)]}function le(U,N,K){const j=F(U,N),T=U.length,X=K.length;U.length=T+X;for(let ne=T-1;ne>=j;ne--)U[ne+X]=U[ne];for(let ne=0;ne<X;ne++)U[ne+j]=K[ne]}function V(U,N,K,j){const T=F(U,N);let X=U.splice(T,K);return X===void 0&&(X=[]),le(U,T,j),X}function F(U,N){return N<0?Math.max(N+U.length,0):Math.min(N,U.length)}var Y;(function(U){function N(X){return X<0}U.isLessThan=N;function K(X){return X<=0}U.isLessThanOrEqual=K;function j(X){return X>0}U.isGreaterThan=j;function T(X){return X===0}U.isNeitherLessOrGreaterThan=T,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function ee(U,N){return(K,j)=>N(U(K),U(j))}function ue(...U){return(N,K)=>{for(const j of U){const T=j(N,K);if(!Y.isNeitherLessOrGreaterThan(T))return T}return Y.neitherLessOrGreaterThan}}const $=(U,N)=>U-N;e.numberComparator=$;const ae=(U,N)=>(0,e.numberComparator)(U?1:0,N?1:0);e.booleanComparator=ae;function ge(U){return(N,K)=>-U(N,K)}class te{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let K=this.firstIdx;for(;K<this.items.length&&N(this.items[K]);)K++;const j=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,j}takeFromEndWhile(N){let K=this.lastIdx;for(;K>=0&&N(this.items[K]);)K--;const j=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,j}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}removeLast(){const N=this.items[this.lastIdx];return this.lastIdx--,N}takeCount(N){const K=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,K}}e.ArrayQueue=te;class d{static{this.empty=new d(N=>{})}constructor(N){this.iterate=N}forEach(N){this.iterate(K=>(N(K),!0))}toArray(){const N=[];return this.iterate(K=>(N.push(K),!0)),N}filter(N){return new d(K=>this.iterate(j=>N(j)?K(j):!0))}map(N){return new d(K=>this.iterate(j=>K(N(j))))}some(N){let K=!1;return this.iterate(j=>(K=N(j),!K)),K}findFirst(N){let K;return this.iterate(j=>N(j)?(K=j,!1):!0),K}findLast(N){let K;return this.iterate(j=>(N(j)&&(K=j),!0)),K}findLastMaxBy(N){let K,j=!0;return this.iterate(T=>((j||Y.isGreaterThan(N(T,K)))&&(j=!1,K=T),!0)),K}}e.CallbackIterable=d;class H{constructor(N){this._indexMap=N}static createSortPermutation(N,K){const j=Array.from(N.keys()).sort((T,X)=>K(N[T],N[X]));return new H(j)}apply(N){return N.map((K,j)=>N[this._indexMap[j]])}inverse(){const N=this._indexMap.slice();for(let K=0;K<this._indexMap.length;K++)N[this._indexMap[K]]=K;return new H(N)}}e.Permutation=H}),define(he[45],fe([0,1,7]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.assertNever=L,e.assert=y,e.softAssert=W,e.assertFn=P,e.checkAdjacentItems=v;function t(o,w){if(!o)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function L(o,w="Unreachable"){throw new Error(w)}function y(o,w="unexpected state"){if(!o)throw new a.BugIndicatingError(`Assertion Failed: ${w}`)}function W(o){o||(0,a.onUnexpectedError)(new a.BugIndicatingError("Soft Assertion Failed"))}function P(o){if(!o()){debugger;o(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}function v(o,w){let _=0;for(;_<o.length-1;){const f=o[_],c=o[_+1];if(!w(f,c))return!1;_++}return!0}}),define(he[32],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=a;function a(t,L){const y=this;let W=!1,P;return function(){if(W)return P;if(W=!0,L)try{P=t.apply(y,arguments)}finally{L()}else P=t.apply(y,arguments);return P}}}),define(he[46],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function L(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=L;const y=Object.freeze([]);function W(){return y}t.empty=W;function*P(n){yield n}t.single=P;function v(n){return L(n)?n:P(n)}t.wrap=v;function o(n){return n||y}t.from=o;function*w(n){for(let S=n.length-1;S>=0;S--)yield n[S]}t.reverse=w;function _(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=_;function f(n){return n[Symbol.iterator]().next().value}t.first=f;function c(n,S){let A=0;for(const O of n)if(S(O,A++))return!0;return!1}t.some=c;function l(n,S){for(const A of n)if(S(A))return A}t.find=l;function*h(n,S){for(const A of n)S(A)&&(yield A)}t.filter=h;function*m(n,S){let A=0;for(const O of n)yield S(O,A++)}t.map=m;function*u(n,S){let A=0;for(const O of n)yield*S(O,A++)}t.flatMap=u;function*r(...n){for(const S of n)yield*S}t.concat=r;function p(n,S,A){let O=A;for(const E of n)O=S(O,E);return O}t.reduce=p;function*b(n,S,A=n.length){for(S<0&&(S+=n.length),A<0?A+=n.length:A>n.length&&(A=n.length);S<A;S++)yield n[S]}t.slice=b;function s(n,S=Number.POSITIVE_INFINITY){const A=[];if(S===0)return[A,n];const O=n[Symbol.iterator]();for(let E=0;E<S;E++){const D=O.next();if(D.done)return[A,t.empty()];A.push(D.value)}return[A,{[Symbol.iterator](){return O}}]}t.consume=s;async function i(n){const S=[];for await(const A of n)S.push(A);return Promise.resolve(S)}t.asyncToArray=i})(a||(e.Iterable=a={}))}),define(he[25],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(L){this.executor=L,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=a}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{static{this.Undefined=new a(void 0)}constructor(y){this.element=y,this.next=a.Undefined,this.prev=a.Undefined}}class t{constructor(){this._first=a.Undefined,this._last=a.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===a.Undefined}clear(){let y=this._first;for(;y!==a.Undefined;){const W=y.next;y.prev=a.Undefined,y.next=a.Undefined,y=W}this._first=a.Undefined,this._last=a.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,W){const P=new a(y);if(this._first===a.Undefined)this._first=P,this._last=P;else if(W){const o=this._last;this._last=P,P.prev=o,o.next=P}else{const o=this._first;this._first=P,P.next=o,o.prev=P}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(P))}}shift(){if(this._first!==a.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==a.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==a.Undefined&&y.next!==a.Undefined){const W=y.prev;W.next=y.next,y.next.prev=W}else y.prev===a.Undefined&&y.next===a.Undefined?(this._first=a.Undefined,this._last=a.Undefined):y.next===a.Undefined?(this._last=this._last.prev,this._last.next=a.Undefined):y.prev===a.Undefined&&(this._first=this._first.next,this._first.prev=a.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==a.Undefined;)yield y.element,y=y.next}}e.LinkedList=t}),define(he[28],fe([0,1]),function(ie,e){"use strict";var a,t,L;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=y,e.mapToString=W,e.setToString=P,e.mapsStrictEqualIgnoreOrder=b;function y(s,i,n){let S=s.get(i);return S===void 0&&(S=n,s.set(i,S)),S}function W(s){const i=[];return s.forEach((n,S)=>{i.push(`${S} => ${n}`)}),`Map(${s.size}) {${i.join(", ")}}`}function P(s){const i=[];return s.forEach(n=>{i.push(n)}),`Set(${s.size}) {${i.join(", ")}}`}class v{constructor(i,n){this.uri=i,this.value=n}}function o(s){return Array.isArray(s)}class w{static{this.defaultToKey=i=>i.toString()}constructor(i,n){if(this[a]="ResourceMap",i instanceof w)this.map=new Map(i.map),this.toKey=n??w.defaultToKey;else if(o(i)){this.map=new Map,this.toKey=n??w.defaultToKey;for(const[S,A]of i)this.set(S,A)}else this.map=new Map,this.toKey=i??w.defaultToKey}set(i,n){return this.map.set(this.toKey(i),new v(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[S,A]of this.map)i(A.value,A.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=w;class _{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this._map=new w(i):(this._map=new w(n),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,n){this._map.forEach((S,A)=>i.call(n,A,A,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=_;var f;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class c{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=f.None){const S=this._map.get(i);if(S)return n!==f.None&&this.touch(S,n),S.value}set(i,n,S=f.None){let A=this._map.get(i);if(A)A.value=n,S!==f.None&&this.touch(A,S);else{switch(A={key:i,value:n,next:void 0,previous:void 0},S){case f.None:this.addItemLast(A);break;case f.AsOld:this.addItemFirst(A);break;case f.AsNew:this.addItemLast(A);break;default:this.addItemLast(A);break}this._map.set(i,A),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const S=this._state;let A=this._head;for(;A;){if(n?i.bind(n)(A.value,A.key,this):i(A.value,A.key,this),this._state!==S)throw new Error("LinkedMap got modified during iteration.");A=A.next}}keys(){const i=this,n=this._state;let S=this._head;const A={[Symbol.iterator](){return A},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(S){const O={value:S.key,done:!1};return S=S.next,O}else return{value:void 0,done:!0}}};return A}values(){const i=this,n=this._state;let S=this._head;const A={[Symbol.iterator](){return A},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(S){const O={value:S.value,done:!1};return S=S.next,O}else return{value:void 0,done:!0}}};return A}entries(){const i=this,n=this._state;let S=this._head;const A={[Symbol.iterator](){return A},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(S){const O={value:[S.key,S.value],done:!1};return S=S.next,O}else return{value:void 0,done:!0}}};return A}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,S=this.size;for(;n&&S>i;)this._map.delete(n.key),n=n.next,S--;this._head=n,this._size=S,n&&(n.previous=void 0),this._state++}trimNew(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._tail,S=this.size;for(;n&&S>i;)this._map.delete(n.key),n=n.previous,S--;this._tail=n,this._size=S,n&&(n.next=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,S=i.previous;if(!n||!S)throw new Error("Invalid list");n.previous=S,S.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==f.AsOld&&n!==f.AsNew)){if(n===f.AsOld){if(i===this._head)return;const S=i.next,A=i.previous;i===this._tail?(A.next=void 0,this._tail=A):(S.previous=A,A.next=S),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===f.AsNew){if(i===this._tail)return;const S=i.next,A=i.previous;i===this._head?(S.previous=void 0,this._head=S):(S.previous=A,A.next=S),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,S)=>{i.push([S,n])}),i}fromJSON(i){this.clear();for(const[n,S]of i)this.set(n,S)}}e.LinkedMap=c;class l extends c{constructor(i,n=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=f.AsNew){return super.get(i,n)}peek(i){return super.get(i,f.None)}set(i,n){return super.set(i,n,f.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class h extends l{constructor(i,n=1){super(i,n)}trim(i){this.trimOld(i)}set(i,n){return super.set(i,n),this.checkTrim(),this}}e.LRUCache=h;class m extends l{constructor(i,n=1){super(i,n)}trim(i){this.trimNew(i)}set(i,n){return this._limit<=this.size&&!this.has(i)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(i,n),this}}e.MRUCache=m;class u{constructor(){this.map=new Map}add(i){return this.map.set(i,(this.map.get(i)||0)+1),this}delete(i){let n=this.map.get(i)||0;return n===0?!1:(n--,n===0?this.map.delete(i):this.map.set(i,n),!0)}has(i){return this.map.has(i)}}e.CounterSet=u;class r{constructor(i){if(this._m1=new Map,this._m2=new Map,i)for(const[n,S]of i)this.set(n,S)}clear(){this._m1.clear(),this._m2.clear()}set(i,n){this._m1.set(i,n),this._m2.set(n,i)}get(i){return this._m1.get(i)}getKey(i){return this._m2.get(i)}delete(i){const n=this._m1.get(i);return n===void 0?!1:(this._m1.delete(i),this._m2.delete(n),!0)}forEach(i,n){this._m1.forEach((S,A)=>{i.call(n,S,A,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=r;class p{constructor(){this.map=new Map}add(i,n){let S=this.map.get(i);S||(S=new Set,this.map.set(i,S)),S.add(n)}delete(i,n){const S=this.map.get(i);S&&(S.delete(n),S.size===0&&this.map.delete(i))}forEach(i,n){const S=this.map.get(i);S&&S.forEach(n)}get(i){const n=this.map.get(i);return n||new Set}}e.SetMap=p;function b(s,i){if(s===i)return!0;if(s.size!==i.size)return!1;for(const[n,S]of s)if(!i.has(n)||i.get(n)!==S)return!1;for(const[n]of i)if(!s.has(n))return!1;return!0}}),define(he[2],fe([0,1,18,44,28,32,46]),function(ie,e,a,t,L,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=w,e.trackDisposable=_,e.markAsDisposed=f,e.markAsSingleton=h,e.isDisposable=m,e.dispose=u,e.disposeIfDisposable=r,e.combinedDisposable=p,e.toDisposable=b,e.disposeOnReturn=x;const P=!1;let v=null;class o{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(g){let M=this.livingDisposables.get(g);return M||(M={parent:null,source:null,isSingleton:!1,value:g,idx:o.idx++},this.livingDisposables.set(g,M)),M}trackDisposable(g){const M=this.getDisposableData(g);M.source||(M.source=new Error().stack)}setParent(g,M){const R=this.getDisposableData(g);R.parent=M}markAsDisposed(g){this.livingDisposables.delete(g)}markAsSingleton(g){this.getDisposableData(g).isSingleton=!0}getRootParent(g,M){const R=M.get(g);if(R)return R;const C=g.parent?this.getRootParent(this.getDisposableData(g.parent),M):g;return M.set(g,C),C}getTrackedDisposables(){const g=new Map;return[...this.livingDisposables.entries()].filter(([,R])=>R.source!==null&&!this.getRootParent(R,g).isSingleton).flatMap(([R])=>R)}computeLeakingDisposables(g=10,M){let R;if(M)R=M;else{const J=new Map,se=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,J).isSingleton);if(se.length===0)return;const le=new Set(se.map(V=>V.value));if(R=se.filter(V=>!(V.parent&&le.has(V.parent))),R.length===0)throw new Error("There are cyclic diposable chains!")}if(!R)return;function C(J){function se(V,F){for(;V.length>0&&F.some(Y=>typeof Y=="string"?Y===V[0]:V[0].match(Y));)V.shift()}const le=J.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return se(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const B=new L.SetMap;for(const J of R){const se=C(J);for(let le=0;le<=se.length;le++)B.add(se.slice(0,le).join(`
`),J)}R.sort((0,a.compareBy)(J=>J.idx,a.numberComparator));let Z="",G=0;for(const J of R.slice(0,g)){G++;const se=C(J),le=[];for(let V=0;V<se.length;V++){let F=se[V];F=`(shared with ${B.get(se.slice(0,V+1).join(`
`)).size}/${R.length} leaks) at ${F}`;const ee=B.get(se.slice(0,V).join(`
`)),ue=(0,t.groupBy)([...ee].map($=>C($)[V]),$=>$);delete ue[se[V]];for(const[$,ae]of Object.entries(ue))le.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${$}`);le.unshift(F)}Z+=`


==================== Leaking disposable ${G}/${R.length}: ${J.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return R.length>g&&(Z+=`


... and ${R.length-g} more leaking disposables

`),{leaks:R,details:Z}}}e.DisposableTracker=o;function w(k){v=k}if(P){const k="__is_disposable_tracked__";w(new class{trackDisposable(g){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[k]||console.log(M)},3e3)}setParent(g,M){if(g&&g!==i.None)try{g[k]=!0}catch{}}markAsDisposed(g){if(g&&g!==i.None)try{g[k]=!0}catch{}}markAsSingleton(g){}})}function _(k){return v?.trackDisposable(k),k}function f(k){v?.markAsDisposed(k)}function c(k,g){v?.setParent(k,g)}function l(k,g){if(v)for(const M of k)v.setParent(M,g)}function h(k){return v?.markAsSingleton(k),k}function m(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function u(k){if(W.Iterable.is(k)){const g=[];for(const M of k)if(M)try{M.dispose()}catch(R){g.push(R)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function r(k){for(const g of k)m(g)&&g.dispose();return[]}function p(...k){const g=b(()=>u(k));return l(k,g),g}function b(k){const g=_({dispose:(0,y.createSingleCallFunction)(()=>{f(g),k()})});return g}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return c(g,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(g),g.dispose()}}deleteAndLeak(g){g&&this._toDispose.has(g)&&(this._toDispose.delete(g),c(g,null))}}e.DisposableStore=s;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,_(this),c(this._store,this)}dispose(){f(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=i;class n{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){this._isDisposed||g===this._value||(this._value?.dispose(),g&&c(g,this),this._value=g)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const g=this._value;return this._value=void 0,g&&c(g,null),g}}e.MutableDisposable=n;class S{constructor(g){this._disposable=new n,this._isDisposed=!1,this._disposable.value=g}get value(){return this._disposable.value}set value(g){this._isDisposed||g===this._disposable.value||(this._disposable.value=g)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=S;class A{constructor(g){this._disposable=g,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=A;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(g){let M=g;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,f(this))},this}}e.SafeDisposable=O;class E{constructor(){this.references=new Map}acquire(g,...M){let R=this.references.get(g);R||(R={counter:0,object:this.createReferencedObject(g,...M)},this.references.set(g,R));const{object:C}=R,B=(0,y.createSingleCallFunction)(()=>{--R.counter===0&&(this.destroyReferencedObject(g,R.object),this.references.delete(g))});return R.counter++,{object:C,dispose:B}}}e.ReferenceCollection=E;class D{constructor(g){this.referenceCollection=g}async acquire(g,...M){const R=this.referenceCollection.acquire(g,...M);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(C){throw R.dispose(),C}}}e.AsyncReferenceCollection=D;class I{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=I;function x(k){const g=new s;try{k(g)}finally{g.dispose()}}class z{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){f(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(g){return this._store.has(g)}get size(){return this._store.size}get(g){return this._store.get(g)}set(g,M,R=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this._store.get(g)?.dispose(),this._store.set(g,M)}deleteAndDispose(g){this._store.get(g)?.dispose(),this._store.delete(g)}deleteAndLeak(g){const M=this._store.get(g);return this._store.delete(g),M}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=z}),define(he[29],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define(he[48],fe([0,1,28]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=L,e.normalizeNFD=W;const t=new a.LRUCache(1e4);function L(o){return v(o,"NFC",t)}const y=new a.LRUCache(1e4);function W(o){return v(o,"NFD",y)}const P=/[^\u0000-\u0080]/;function v(o,w,_){if(!o)return o;const f=_.get(o);if(f)return f;let c;return P.test(o)?c=o.normalize(w):c=o,_.set(o,c),c}e.removeAccents=function(){const o=/[\u0300-\u036f]/g;return function(w){return W(w).replace(o,"")}}()}),function(){function ie(L){const y=[];typeof L=="number"&&y.push("code/timeOrigin",L);function W(v){y.push(v,Date.now())}function P(){const v=[];for(let o=0;o<y.length;o+=2)v.push({name:y[o],startTime:y[o+1]});return v}return{mark:W,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const W of performance.getEntriesByType("mark"))y.push({name:W.name,startTime:Math.round(L+W.startTime)});return y}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(he[49],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(y){return new t(y)}constructor(y){this._now=a&&y===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(he[4],fe([0,1,7,32,2,47,49]),function(ie,e,a,t,L,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=c;const P=!1,v=!1,o=!1;var w;(function(C){C.None=()=>L.Disposable.None;function B(me){if(o){const{onDidAddListener:de}=me,Ee=h.create();let ye=0;me.onDidAddListener=()=>{++ye===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),de?.()}}}function Z(me,de){return $(me,()=>{},0,void 0,!0,void 0,de)}C.defer=Z;function G(me){return(de,Ee=null,ye)=>{let be=!1,Le;return Le=me(Ie=>{if(!be)return Le?Le.dispose():be=!0,de.call(Ee,Ie)},null,ye),be&&Le.dispose(),Le}}C.once=G;function J(me,de,Ee){return ee((ye,be=null,Le)=>me(Ie=>ye.call(be,de(Ie)),null,Le),Ee)}C.map=J;function se(me,de,Ee){return ee((ye,be=null,Le)=>me(Ie=>{de(Ie),ye.call(be,Ie)},null,Le),Ee)}C.forEach=se;function le(me,de,Ee){return ee((ye,be=null,Le)=>me(Ie=>de(Ie)&&ye.call(be,Ie),null,Le),Ee)}C.filter=le;function V(me){return me}C.signal=V;function F(...me){return(de,Ee=null,ye)=>{const be=(0,L.combinedDisposable)(...me.map(Le=>Le(Ie=>de.call(Ee,Ie))));return ue(be,ye)}}C.any=F;function Y(me,de,Ee,ye){let be=Ee;return J(me,Le=>(be=de(be,Le),be),ye)}C.reduce=Y;function ee(me,de){let Ee;const ye={onWillAddFirstListener(){Ee=me(be.fire,be)},onDidRemoveLastListener(){Ee?.dispose()}};de||B(ye);const be=new n(ye);return de?.add(be),be.event}function ue(me,de){return de instanceof Array?de.push(me):de&&de.add(me),me}function $(me,de,Ee=100,ye=!1,be=!1,Le,Ie){let Ce,Ae,Be,We=0,Se;const Te={leakWarningThreshold:Le,onWillAddFirstListener(){Ce=me(Ve=>{We++,Ae=de(Ae,Ve),ye&&!Be&&(qe.fire(Ae),Ae=void 0),Se=()=>{const Ke=Ae;Ae=void 0,Be=void 0,(!ye||We>1)&&qe.fire(Ke),We=0},typeof Ee=="number"?(clearTimeout(Be),Be=setTimeout(Se,Ee)):Be===void 0&&(Be=0,queueMicrotask(Se))})},onWillRemoveListener(){be&&We>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,Ce.dispose()}};Ie||B(Te);const qe=new n(Te);return Ie?.add(qe),qe.event}C.debounce=$;function ae(me,de=0,Ee){return C.debounce(me,(ye,be)=>ye?(ye.push(be),ye):[be],de,void 0,!0,void 0,Ee)}C.accumulate=ae;function ge(me,de=(ye,be)=>ye===be,Ee){let ye=!0,be;return le(me,Le=>{const Ie=ye||!de(Le,be);return ye=!1,be=Le,Ie},Ee)}C.latch=ge;function te(me,de,Ee){return[C.filter(me,de,Ee),C.filter(me,ye=>!de(ye),Ee)]}C.split=te;function d(me,de=!1,Ee=[],ye){let be=Ee.slice(),Le=me(Ae=>{be?be.push(Ae):Ce.fire(Ae)});ye&&ye.add(Le);const Ie=()=>{be?.forEach(Ae=>Ce.fire(Ae)),be=null},Ce=new n({onWillAddFirstListener(){Le||(Le=me(Ae=>Ce.fire(Ae)),ye&&ye.add(Le))},onDidAddFirstListener(){be&&(de?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Le&&Le.dispose(),Le=null}});return ye&&ye.add(Ce),Ce.event}C.buffer=d;function H(me,de){return(ye,be,Le)=>{const Ie=de(new N);return me(function(Ce){const Ae=Ie.evaluate(Ce);Ae!==U&&ye.call(be,Ae)},void 0,Le)}}C.chain=H;const U=Symbol("HaltChainable");class N{constructor(){this.steps=[]}map(de){return this.steps.push(de),this}forEach(de){return this.steps.push(Ee=>(de(Ee),Ee)),this}filter(de){return this.steps.push(Ee=>de(Ee)?Ee:U),this}reduce(de,Ee){let ye=Ee;return this.steps.push(be=>(ye=de(ye,be),ye)),this}latch(de=(Ee,ye)=>Ee===ye){let Ee=!0,ye;return this.steps.push(be=>{const Le=Ee||!de(be,ye);return Ee=!1,ye=be,Le?be:U}),this}evaluate(de){for(const Ee of this.steps)if(de=Ee(de),de===U)break;return de}}function K(me,de,Ee=ye=>ye){const ye=(...Ce)=>Ie.fire(Ee(...Ce)),be=()=>me.on(de,ye),Le=()=>me.removeListener(de,ye),Ie=new n({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ie.event}C.fromNodeEventEmitter=K;function j(me,de,Ee=ye=>ye){const ye=(...Ce)=>Ie.fire(Ee(...Ce)),be=()=>me.addEventListener(de,ye),Le=()=>me.removeEventListener(de,ye),Ie=new n({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ie.event}C.fromDOMEventEmitter=j;function T(me){return new Promise(de=>G(me)(de))}C.toPromise=T;function X(me){const de=new n;return me.then(Ee=>{de.fire(Ee)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}C.fromPromise=X;function ne(me,de,Ee){return de(Ee),me(ye=>de(ye))}C.runAndSubscribe=ne;class oe{constructor(de,Ee){this._observable=de,this._counter=0,this._hasChanged=!1;const ye={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Ee||B(ye),this.emitter=new n(ye),Ee&&Ee.add(this.emitter)}beginUpdate(de){this._counter++}handlePossibleChange(de){}handleChange(de,Ee){this._hasChanged=!0}endUpdate(de){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function pe(me,de){return new oe(me,de).emitter.event}C.fromObservable=pe;function we(me){return(de,Ee,ye)=>{let be=0,Le=!1;const Ie={beginUpdate(){be++},endUpdate(){be--,be===0&&(me.reportChanges(),Le&&(Le=!1,de.call(Ee)))},handlePossibleChange(){},handleChange(){Le=!0}};me.addObserver(Ie),me.reportChanges();const Ce={dispose(){me.removeObserver(Ie)}};return ye instanceof L.DisposableStore?ye.add(Ce):Array.isArray(ye)&&ye.push(Ce),Ce}}C.fromObservableLight=we})(w||(e.Event=w={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${_._idPool++}`,_.all.add(this)}start(B){this._stopWatch=new W.StopWatch,this.listenerCount=B}stop(){if(this._stopWatch){const B=this._stopWatch.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=_;let f=-1;function c(C){const B=f;return f=C,{dispose(){f=B}}}class l{static{this._idPool=1}constructor(B,Z,G=(l._idPool++).toString(16).padStart(3,"0")){this._errorHandler=B,this.threshold=Z,this.name=G,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(B,Z){const G=this.threshold;if(G<=0||Z<G)return;this._stacks||(this._stacks=new Map);const J=this._stacks.get(B.value)||0;if(this._stacks.set(B.value,J+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=G*.5;const[se,le]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${Z} listeners already. MOST frequent listener (${le}):`;console.warn(V),console.warn(se);const F=new m(V,se);this._errorHandler(F)}return()=>{const se=this._stacks.get(B.value)||0;this._stacks.set(B.value,se-1)}}getMostFrequentStack(){if(!this._stacks)return;let B,Z=0;for(const[G,J]of this._stacks)(!B||Z<J)&&(B=[G,J],Z=J);return B}}class h{static create(){const B=new Error;return new h(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(B,Z){super(B),this.name="ListenerLeakError",this.stack=Z}}e.ListenerLeakError=m;class u extends Error{constructor(B,Z){super(B),this.name="ListenerRefusalError",this.stack=Z}}e.ListenerRefusalError=u;let r=0;class p{constructor(B){this.value=B,this.id=r++}}const b=2,s=(C,B)=>{if(C instanceof p)B(C);else for(let Z=0;Z<C.length;Z++){const G=C[Z];G&&B(G)}};let i;if(P){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),i=new FinalizationRegistry(B=>{typeof B=="string"&&C.push(B)})}class n{constructor(B){this._size=0,this._options=B,this._leakageMon=f>0||this._options?.leakWarningThreshold?new l(B?.onListenerError??a.onUnexpectedError,this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const B=this._listeners;queueMicrotask(()=>{s(B,Z=>Z.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(B,Z,G)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const F=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(F);const Y=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new u(`${F}. HINT: Stack shows most frequent listener (${Y[1]}-times)`,Y[0]);return(this._options?.onListenerError||a.onUnexpectedError)(ee),L.Disposable.None}if(this._disposed)return L.Disposable.None;Z&&(B=B.bind(Z));const J=new p(B);let se,le;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(J.stack=h.create(),se=this._leakageMon.check(J.stack,this._size+1)),v&&(J.stack=le??h.create()),this._listeners?this._listeners instanceof p?(this._deliveryQueue??=new A,this._listeners=[this._listeners,J]):this._listeners.push(J):(this._options?.onWillAddFirstListener?.(this),this._listeners=J,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,L.toDisposable)(()=>{i?.unregister(V),se?.(),this._removeListener(J)});if(G instanceof L.DisposableStore?G.add(V):Array.isArray(G)&&G.push(V),i){const F=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Y=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(F);i.register(V,Y?.[2]??F,V)}return V},this._event}_removeListener(B){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const Z=this._listeners,G=Z.indexOf(B);if(G===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,Z[G]=void 0;const J=this._deliveryQueue.current===this;if(this._size*b<=Z.length){let se=0;for(let le=0;le<Z.length;le++)Z[le]?Z[se++]=Z[le]:J&&(this._deliveryQueue.end--,se<this._deliveryQueue.i&&this._deliveryQueue.i--);Z.length=se}}_deliver(B,Z){if(!B)return;const G=this._options?.onListenerError||a.onUnexpectedError;if(!G){B.value(Z);return}try{B.value(Z)}catch(J){G(J)}}_deliverQueue(B){const Z=B.current._listeners;for(;B.i<B.end;)this._deliver(Z[B.i++],B.value);B.reset()}fire(B){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof p)this._deliver(this._listeners,B);else{const Z=this._deliveryQueue;Z.enqueue(this,B,this._listeners.length),this._deliverQueue(Z)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const S=()=>new A;e.createEventDeliveryQueue=S;class A{constructor(){this.i=-1,this.end=0}enqueue(B,Z,G){this.i=0,this.end=G,this.current=B,this.value=Z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class O extends n{async fireAsync(B,Z,G){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList),s(this._listeners,J=>this._asyncDeliveryQueue.push([J.value,B]));this._asyncDeliveryQueue.size>0&&!Z.isCancellationRequested;){const[J,se]=this._asyncDeliveryQueue.shift(),le=[],V={...se,token:Z,waitUntil:F=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");G&&(F=G(F,J)),le.push(F)}};try{J(V)}catch(F){(0,a.onUnexpectedError)(F);continue}Object.freeze(le),await Promise.allSettled(le).then(F=>{for(const Y of F)Y.status==="rejected"&&(0,a.onUnexpectedError)(Y.reason)})}}}e.AsyncEmitter=O;class E extends n{get isPaused(){return this._isPaused!==0}constructor(B){super(B),this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=B?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const B=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(B))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(B){this._size&&(this._isPaused!==0?this._eventQueue.push(B):super.fire(B))}}e.PauseableEmitter=E;class D extends E{constructor(B){super(B),this._delay=B.delay??100}fire(B){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(B)}}e.DebounceEmitter=D;class I extends n{constructor(B){super(B),this._queuedEvents=[],this._mergeFn=B?.merge}fire(B){this.hasListeners()&&(this._queuedEvents.push(B),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(Z=>super.fire(Z)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=I;class x{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(B){const Z={event:B,listener:null};this.events.push(Z),this.hasListeners&&this.hook(Z);const G=()=>{this.hasListeners&&this.unhook(Z);const J=this.events.indexOf(Z);this.events.splice(J,1)};return(0,L.toDisposable)((0,t.createSingleCallFunction)(G))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(B=>this.hook(B))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(B=>this.unhook(B))}hook(B){B.listener=B.event(Z=>this.emitter.fire(Z))}unhook(B){B.listener?.dispose(),B.listener=null}dispose(){this.emitter.dispose();for(const B of this.events)B.listener?.dispose();this.events=[]}}e.EventMultiplexer=x;class z{constructor(B,Z,G,J){this._store=new L.DisposableStore;const se=this._store.add(new x),le=this._store.add(new L.DisposableMap);function V(F){le.set(F,se.add(J(F)))}for(const F of B)V(F);this._store.add(Z(F=>{V(F)})),this._store.add(G(F=>{le.deleteAndDispose(F)})),this.event=se.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=z;class k{constructor(){this.data=[]}wrapEvent(B,Z,G){return(J,se,le)=>B(V=>{const F=this.data[this.data.length-1];if(!Z){F?F.buffers.push(()=>J.call(se,V)):J.call(se,V);return}const Y=F;if(!Y){J.call(se,Z(G,V));return}Y.items??=[],Y.items.push(V),Y.buffers.length===0&&F.buffers.push(()=>{Y.reducedResult??=G?Y.items.reduce(Z,G):Y.items.reduce(Z),J.call(se,Y.reducedResult)})},void 0,le)}bufferEvents(B){const Z={buffers:new Array};this.data.push(Z);const G=B();return this.data.pop(),Z.buffers.forEach(J=>J()),G}}e.EventBufferer=k;class g{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=L.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(B){this.inputEvent=B,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=B(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g;class M{static const(B){return new R(B)}constructor(B){this._value=B,this._onDidChange=new n,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(B){B!==this._value&&(this._value=B,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=M;class R{constructor(B){this.value=B,this.onDidChange=w.None}}}),define(he[19],fe([0,1,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=P;const t=Object.freeze(function(v,o){const w=setTimeout(v.bind(o),0);return{dispose(){clearTimeout(w)}}});var L;(function(v){function o(w){return w===v.None||w===v.Cancelled||w instanceof y?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}v.isCancellationToken=o,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L||(e.CancellationToken=L={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new a.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class W{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=L.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=W;function P(v){const o=new W;return v.add({dispose(){o.cancel()}}),o.token}}),define(he[50],fe([0,1,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=L;class t{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new a.CancellationTokenSource,o=this.task(v.token);return this.result={promise:o,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=t;function L(P){return P}class y{constructor(v,o){this.lastCache=void 0,this.lastArgKey=void 0,typeof v=="function"?(this._fn=v,this._computeKey=L):(this._fn=o,this._computeKey=v.getCacheKey)}get(v){const o=this._computeKey(v);return this.lastArgKey!==o&&(this.lastArgKey=o,this.lastCache=this._fn(v)),this.lastCache}}e.LRUCachedFunction=y;class W{get cachedValues(){return this._map}constructor(v,o){this._map=new Map,this._map2=new Map,typeof v=="function"?(this._fn=v,this._computeKey=L):(this._fn=o,this._computeKey=v.getCacheKey)}get(v){const o=this._computeKey(v);if(this._map2.has(o))return this._map2.get(o);const w=this._fn(v);return this._map.set(v,w),this._map2.set(o,w),w}}e.CachedFunction=W}),define(he[51],fe([0,1,7,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=L,e.isReadableStream=y,e.isReadableBufferedStream=W,e.newWriteableStream=P,e.consumeReadable=o,e.peekReadable=w,e.consumeStream=_,e.listenStream=f,e.peekStream=c,e.toStream=l,e.emptyStream=h,e.toReadable=m,e.transform=u,e.prefixedReadable=r,e.prefixedStream=p;function L(b){const s=b;return s?typeof s.read=="function":!1}function y(b){const s=b;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}function W(b){const s=b;return s?y(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function P(b,s){return new v(b,s)}class v{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,a.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const S=n.indexOf(i);S>=0&&n.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function o(b,s){const i=[];let n;for(;(n=b.read())!==null;)i.push(n);return s(i)}function w(b,s,i){const n=[];let S;for(;(S=b.read())!==null&&n.length<i;)n.push(S);return S===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof S<"u"){const A=S;return S=void 0,A}return b.read()}}}function _(b,s){return new Promise((i,n)=>{const S=[];f(b,{onData:A=>{s&&S.push(A)},onError:A=>{s?n(A):i(void 0)},onEnd:()=>{i(s?s(S):void 0)}})})}function f(b,s,i){b.on("error",n=>{i?.isCancellationRequested||s.onError(n)}),b.on("end",()=>{i?.isCancellationRequested||s.onEnd()}),b.on("data",n=>{i?.isCancellationRequested||s.onData(n)})}function c(b,s){return new Promise((i,n)=>{const S=new t.DisposableStore,A=[],O=I=>{if(A.push(I),A.length>s)return S.dispose(),b.pause(),i({stream:b,buffer:A,ended:!1})},E=I=>(S.dispose(),n(I)),D=()=>(S.dispose(),i({stream:b,buffer:A,ended:!0}));S.add((0,t.toDisposable)(()=>b.removeListener("error",E))),b.on("error",E),S.add((0,t.toDisposable)(()=>b.removeListener("end",D))),b.on("end",D),S.add((0,t.toDisposable)(()=>b.removeListener("data",O))),b.on("data",O)})}function l(b,s){const i=P(s);return i.end(b),i}function h(){const b=P(()=>{throw new Error("not supported")});return b.end(),b}function m(b){let s=!1;return{read:()=>s?null:(s=!0,b)}}function u(b,s,i){const n=P(i);return f(b,{onData:S=>n.write(s.data(S)),onError:S=>n.error(s.error?s.error(S):S),onEnd:()=>n.end()}),n}function r(b,s,i){let n=!1;return{read:()=>{const S=s.read();return n?S:(n=!0,S!==null?i([b,S]):b)}}}function p(b,s,i){let n=!1;const S=P(i);return f(s,{onData:A=>n?S.write(A):(n=!0,S.write(i([b,A]))),onError:A=>S.error(A),onEnd:()=>{n||(n=!0,S.write(b)),S.end()}}),S}});var Qe=this&&this.__createBinding||(Object.create?function(ie,e,a,t){t===void 0&&(t=a);var L=Object.getOwnPropertyDescriptor(e,a);(!L||("get"in L?!e.__esModule:L.writable||L.configurable))&&(L={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(ie,t,L)}:function(ie,e,a,t){t===void 0&&(t=a),ie[t]=e[a]}),Ye=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),De=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var a in ie)a!=="default"&&Object.prototype.hasOwnProperty.call(ie,a)&&Qe(e,ie,a);return Ye(e,ie),e};define(he[20],fe([0,1,25,51]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=o,e.readUInt16LE=w,e.writeUInt16LE=_,e.readUInt32BE=f,e.writeUInt32BE=c,e.readUInt32LE=l,e.writeUInt32LE=h,e.readUInt8=m,e.writeUInt8=u,e.readableToBuffer=r,e.bufferToReadable=p,e.streamToBuffer=b,e.bufferedStreamToBuffer=s,e.bufferToStream=i,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=S,e.prefixedBufferReadable=A,e.prefixedBufferStream=O,e.decodeBase64=E,e.encodeBase64=x,t=De(t);const L=typeof Buffer<"u",y=new a.Lazy(()=>new Uint8Array(256));let W,P;class v{static alloc(k){return L?new v(Buffer.allocUnsafe(k)):new v(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new v(k)}static fromString(k,g){return!(g?.dontUseNodeBuffer||!1)&&L?new v(Buffer.from(k)):(W||(W=new TextEncoder),new v(W.encode(k)))}static fromByteArray(k){const g=v.alloc(k.length);for(let M=0,R=k.length;M<R;M++)g.buffer[M]=k[M];return g}static concat(k,g){if(typeof g>"u"){g=0;for(let C=0,B=k.length;C<B;C++)g+=k[C].byteLength}const M=v.alloc(g);let R=0;for(let C=0,B=k.length;C<B;C++){const Z=k[C];M.set(Z,R),R+=Z.byteLength}return M}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=v.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(k,g){return new v(this.buffer.subarray(k,g))}set(k,g){if(k instanceof v)this.buffer.set(k.buffer,g);else if(k instanceof Uint8Array)this.buffer.set(k,g);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),g);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return f(this.buffer,k)}writeUInt32BE(k,g){c(this.buffer,k,g)}readUInt32LE(k){return l(this.buffer,k)}writeUInt32LE(k,g){h(this.buffer,k,g)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,g){u(this.buffer,k,g)}indexOf(k,g=0){return o(this.buffer,k instanceof v?k.buffer:k,g)}}e.VSBuffer=v;function o(z,k,g=0){const M=k.byteLength,R=z.byteLength;if(M===0)return 0;if(M===1)return z.indexOf(k[0]);if(M>R-g)return-1;const C=y.value;C.fill(k.length);for(let J=0;J<k.length;J++)C[k[J]]=k.length-J-1;let B=g+k.length-1,Z=B,G=-1;for(;B<R;)if(z[B]===k[Z]){if(Z===0){G=B;break}B--,Z--}else B+=Math.max(k.length-Z,C[z[B]]),Z=k.length-1;return G}function w(z,k){return z[k+0]<<0>>>0|z[k+1]<<8>>>0}function _(z,k,g){z[g+0]=k&255,k=k>>>8,z[g+1]=k&255}function f(z,k){return z[k]*2**24+z[k+1]*2**16+z[k+2]*2**8+z[k+3]}function c(z,k,g){z[g+3]=k,k=k>>>8,z[g+2]=k,k=k>>>8,z[g+1]=k,k=k>>>8,z[g]=k}function l(z,k){return z[k+0]<<0>>>0|z[k+1]<<8>>>0|z[k+2]<<16>>>0|z[k+3]<<24>>>0}function h(z,k,g){z[g+0]=k&255,k=k>>>8,z[g+1]=k&255,k=k>>>8,z[g+2]=k&255,k=k>>>8,z[g+3]=k&255}function m(z,k){return z[k]}function u(z,k,g){z[g]=k}function r(z){return t.consumeReadable(z,k=>v.concat(k))}function p(z){return t.toReadable(z)}function b(z){return t.consumeStream(z,k=>v.concat(k))}async function s(z){return z.ended?v.concat(z.buffer):v.concat([...z.buffer,await b(z.stream)])}function i(z){return t.toStream(z,k=>v.concat(k))}function n(z){return t.transform(z,{data:k=>typeof k=="string"?v.fromString(k):v.wrap(k)},k=>v.concat(k))}function S(z){return t.newWriteableStream(k=>v.concat(k),z)}function A(z,k){return t.prefixedReadable(z,k,g=>v.concat(g))}function O(z,k){return t.prefixedStream(z,k,g=>v.concat(g))}function E(z){let k=0,g=0,M=0;const R=new Uint8Array(Math.floor(z.length/4*3)),C=Z=>{switch(g){case 3:R[M++]=k|Z,g=0;break;case 2:R[M++]=k|Z>>>2,k=Z<<6,g=3;break;case 1:R[M++]=k|Z>>>4,k=Z<<4,g=2;break;default:k=Z<<2,g=1}};for(let Z=0;Z<z.length;Z++){const G=z.charCodeAt(Z);if(G>=65&&G<=90)C(G-65);else if(G>=97&&G<=122)C(G-97+26);else if(G>=48&&G<=57)C(G-48+52);else if(G===43||G===45)C(62);else if(G===47||G===95)C(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${z[Z]}`)}}const B=M;for(;g>0;)C(0);return v.wrap(R).slice(0,B)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:z},k=!0,g=!1){const M=g?I:D;let R="";const C=z.byteLength%3;let B=0;for(;B<z.byteLength-C;B+=3){const Z=z[B+0],G=z[B+1],J=z[B+2];R+=M[Z>>>2],R+=M[(Z<<4|G>>>4)&63],R+=M[(G<<2|J>>>6)&63],R+=M[J&63]}if(C===1){const Z=z[B+0];R+=M[Z>>>2],R+=M[Z<<4&63],k&&(R+="==")}else if(C===2){const Z=z[B+0],G=z[B+1];R+=M[Z>>>2],R+=M[(Z<<4|G>>>4)&63],R+=M[G<<2&63],k&&(R+="=")}return R}}),define(he[52],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[9],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=a,e.isStringArray=t,e.isObject=L,e.isTypedArray=y,e.isNumber=W,e.isIterable=P,e.isBoolean=v,e.isUndefined=o,e.isDefined=w,e.isUndefinedOrNull=_,e.assertType=f,e.assertIsDefined=c,e.assertAllDefined=l,e.isEmptyObject=m,e.isFunction=u,e.areFunctions=r,e.validateConstraints=p,e.validateConstraint=b;function a(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(i=>a(i))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function y(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}function W(s){return typeof s=="number"&&!isNaN(s)}function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}function v(s){return s===!0||s===!1}function o(s){return typeof s>"u"}function w(s){return!_(s)}function _(s){return o(s)||s===null}function f(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function c(s){if(_(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l(...s){const i=[];for(let n=0;n<s.length;n++){const S=s[n];if(_(S))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(S)}return i}const h=Object.prototype.hasOwnProperty;function m(s){if(!L(s))return!1;for(const i in s)if(h.call(s,i))return!1;return!0}function u(s){return typeof s=="function"}function r(...s){return s.length>0&&s.every(u)}function p(s,i){const n=Math.min(s.length,i.length);for(let S=0;S<n;S++)b(s[S],i[S])}function b(s,i){if(a(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(s instanceof i)return}catch{}if(!_(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[33],fe([0,1,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=t,e.deepFreeze=L,e.cloneAndChange=W,e.mixin=v,e.equals=o,e.safeStringify=w,e.distinct=_,e.getCaseInsensitive=f,e.filter=c,e.getAllPropertyNames=l,e.getAllMethodNames=h,e.createProxyObject=m,e.mapValues=u;function t(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const p=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([b,s])=>{p[b]=s&&typeof s=="object"?t(s):s}),p}function L(r){if(!r||typeof r!="object")return r;const p=[r];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const s in b)if(y.call(b,s)){const i=b[s];typeof i=="object"&&!Object.isFrozen(i)&&!(0,a.isTypedArray)(i)&&p.push(i)}}return r}const y=Object.prototype.hasOwnProperty;function W(r,p){return P(r,p,new Set)}function P(r,p,b){if((0,a.isUndefinedOrNull)(r))return r;const s=p(r);if(typeof s<"u")return s;if(Array.isArray(r)){const i=[];for(const n of r)i.push(P(n,p,b));return i}if((0,a.isObject)(r)){if(b.has(r))throw new Error("Cannot clone recursive data-structure");b.add(r);const i={};for(const n in r)y.call(r,n)&&(i[n]=P(r[n],p,b));return b.delete(r),i}return r}function v(r,p,b=!0){return(0,a.isObject)(r)?((0,a.isObject)(p)&&Object.keys(p).forEach(s=>{s in r?b&&((0,a.isObject)(r[s])&&(0,a.isObject)(p[s])?v(r[s],p[s],b):r[s]=p[s]):r[s]=p[s]}),r):p}function o(r,p){if(r===p)return!0;if(r==null||p===null||p===void 0||typeof r!=typeof p||typeof r!="object"||Array.isArray(r)!==Array.isArray(p))return!1;let b,s;if(Array.isArray(r)){if(r.length!==p.length)return!1;for(b=0;b<r.length;b++)if(!o(r[b],p[b]))return!1}else{const i=[];for(s in r)i.push(s);i.sort();const n=[];for(s in p)n.push(s);if(n.sort(),!o(i,n))return!1;for(b=0;b<i.length;b++)if(!o(r[i[b]],p[i[b]]))return!1}return!0}function w(r){const p=new Set;return JSON.stringify(r,(b,s)=>{if((0,a.isObject)(s)||Array.isArray(s)){if(p.has(s))return"[Circular]";p.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function _(r,p){const b=Object.create(null);return!r||!p||Object.keys(p).forEach(i=>{const n=r[i],S=p[i];o(n,S)||(b[i]=S)}),b}function f(r,p){const b=p.toLowerCase(),s=Object.keys(r).find(i=>i.toLowerCase()===b);return s?r[s]:r[p]}function c(r,p){const b=Object.create(null);for(const[s,i]of Object.entries(r))p(s,i)&&(b[s]=i);return b}function l(r){let p=[];for(;Object.prototype!==r;)p=p.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return p}function h(r){const p=[];for(const b of l(r))typeof r[b]=="function"&&p.push(b);return p}function m(r,p){const b=i=>function(){const n=Array.prototype.slice.call(arguments,0);return p(i,n)},s={};for(const i of r)s[i]=b(i);return s}function u(r,p){const b={};for(const[s,i]of Object.entries(r))b[s]=p(i,s);return b}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=L;var a;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t(y){return y<0?0:y>a.MAX_UINT_8?a.MAX_UINT_8:y|0}function L(y){return y<0?0:y>a.MAX_UINT_32?a.MAX_UINT_32:y|0}}),define(he[10],fe([0,1,50,14,25,53]),function(ie,e,a,t,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=W,e.format=v,e.format2=w,e.htmlAttributeEncodeValue=_,e.escape=f,e.escapeRegExpCharacters=c,e.count=l,e.truncate=h,e.truncateMiddle=m,e.trim=u,e.ltrim=r,e.rtrim=p,e.convertSimple2RegExpPattern=b,e.stripWildcards=s,e.createRegExp=i,e.regExpLeadsToEndlessLoop=n,e.splitLines=S,e.splitLinesIncludeSeparators=A,e.firstNonWhitespaceIndex=O,e.getLeadingWhitespace=E,e.lastNonWhitespaceIndex=D,e.replaceAsync=I,e.compare=x,e.compareSubstring=z,e.compareIgnoreCase=k,e.compareSubstringIgnoreCase=g,e.isAsciiDigit=M,e.isLowerAsciiLetter=R,e.isUpperAsciiLetter=C,e.equalsIgnoreCase=B,e.startsWithIgnoreCase=Z,e.commonPrefixLength=G,e.commonSuffixLength=J,e.isHighSurrogate=se,e.isLowSurrogate=le,e.computeCodePoint=V,e.getNextCodePoint=F,e.nextCharLength=$,e.prevCharLength=ae,e.getCharContainingOffset=ge,e.charCount=te,e.containsRTL=U,e.isBasicASCII=K,e.containsUnusualLineTerminators=j,e.isFullWidthCharacter=T,e.isEmojiImprecise=X,e.lcut=ne,e.forAnsiStringParts=pe,e.removeAnsiEscapeCodes=we,e.removeAnsiEscapeCodesFromPrompt=de,e.startsWithUTF8BOM=Ee,e.stripUTF8BOM=ye,e.fuzzyContains=be,e.containsUppercaseCharacter=Le,e.uppercaseFirstLetter=Ie,e.getNLines=Ce,e.singleLetterHash=Ae,e.getGraphemeBreakType=Be,e.getLeftDeleteOffset=Ve;function W(q){return!q||typeof q!="string"?!0:q.trim().length===0}const P=/{(\d+)}/g;function v(q,...Q){return Q.length===0?q:q.replace(P,function(re,ce){const ve=parseInt(ce,10);return isNaN(ve)||ve<0||ve>=Q.length?re:Q[ve]})}const o=/{([^}]+)}/g;function w(q,Q){return Object.keys(Q).length===0?q:q.replace(o,(re,ce)=>Q[ce]??re)}function _(q){return q.replace(/[<>"'&]/g,Q=>{switch(Q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Q})}function f(q){return q.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}function c(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(q,Q){let re=0,ce=q.indexOf(Q);for(;ce!==-1;)re++,ce=q.indexOf(Q,ce+Q.length);return re}function h(q,Q,re="\u2026"){return q.length<=Q?q:`${q.substr(0,Q)}${re}`}function m(q,Q,re="\u2026"){if(q.length<=Q)return q;const ce=Math.ceil(Q/2)-re.length/2,ve=Math.floor(Q/2)-re.length/2;return`${q.substr(0,ce)}${re}${q.substr(q.length-ve)}`}function u(q,Q=" "){const re=r(q,Q);return p(re,Q)}function r(q,Q){if(!q||!Q)return q;const re=Q.length;if(re===0||q.length===0)return q;let ce=0;for(;q.indexOf(Q,ce)===ce;)ce=ce+re;return q.substring(ce)}function p(q,Q){if(!q||!Q)return q;const re=Q.length,ce=q.length;if(re===0||ce===0)return q;let ve=ce,Pe=-1;for(;Pe=q.lastIndexOf(Q,ve-1),!(Pe===-1||Pe+re!==ve);){if(Pe===0)return"";ve=Pe}return q.substring(0,ve)}function b(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(q){return q.replace(/\*/g,"")}function i(q,Q,re={}){if(!q)throw new Error("Cannot create regex from empty string");Q||(q=c(q)),re.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return re.global&&(ce+="g"),re.matchCase||(ce+="i"),re.multiline&&(ce+="m"),re.unicode&&(ce+="u"),new RegExp(q,ce)}function n(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}function S(q){return q.split(/\r\n|\r|\n/)}function A(q){const Q=[],re=q.split(/(\r\n|\r|\n)/);for(let ce=0;ce<Math.ceil(re.length/2);ce++)Q.push(re[2*ce]+(re[2*ce+1]??""));return Q}function O(q){for(let Q=0,re=q.length;Q<re;Q++){const ce=q.charCodeAt(Q);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return Q}return-1}function E(q,Q=0,re=q.length){for(let ce=Q;ce<re;ce++){const ve=q.charCodeAt(ce);if(ve!==t.CharCode.Space&&ve!==t.CharCode.Tab)return q.substring(Q,ce)}return q.substring(Q,re)}function D(q,Q=q.length-1){for(let re=Q;re>=0;re--){const ce=q.charCodeAt(re);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return re}return-1}function I(q,Q,re){const ce=[];let ve=0;for(const Pe of q.matchAll(Q)){if(ce.push(q.slice(ve,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ve=Pe.index+Pe[0].length,ce.push(re(Pe[0],...Pe.slice(1),Pe.index,q,Pe.groups))}return ce.push(q.slice(ve)),Promise.all(ce).then(Pe=>Pe.join(""))}function x(q,Q){return q<Q?-1:q>Q?1:0}function z(q,Q,re=0,ce=q.length,ve=0,Pe=Q.length){for(;re<ce&&ve<Pe;re++,ve++){const Oe=q.charCodeAt(re),Me=Q.charCodeAt(ve);if(Oe<Me)return-1;if(Oe>Me)return 1}const Re=ce-re,Ne=Pe-ve;return Re<Ne?-1:Re>Ne?1:0}function k(q,Q){return g(q,Q,0,q.length,0,Q.length)}function g(q,Q,re=0,ce=q.length,ve=0,Pe=Q.length){for(;re<ce&&ve<Pe;re++,ve++){let Oe=q.charCodeAt(re),Me=Q.charCodeAt(ve);if(Oe===Me)continue;if(Oe>=128||Me>=128)return z(q.toLowerCase(),Q.toLowerCase(),re,ce,ve,Pe);R(Oe)&&(Oe-=32),R(Me)&&(Me-=32);const ke=Oe-Me;if(ke!==0)return ke}const Re=ce-re,Ne=Pe-ve;return Re<Ne?-1:Re>Ne?1:0}function M(q){return q>=t.CharCode.Digit0&&q<=t.CharCode.Digit9}function R(q){return q>=t.CharCode.a&&q<=t.CharCode.z}function C(q){return q>=t.CharCode.A&&q<=t.CharCode.Z}function B(q,Q){return q.length===Q.length&&g(q,Q)===0}function Z(q,Q){const re=Q.length;return Q.length>q.length?!1:g(q,Q,0,re)===0}function G(q,Q){const re=Math.min(q.length,Q.length);let ce;for(ce=0;ce<re;ce++)if(q.charCodeAt(ce)!==Q.charCodeAt(ce))return ce;return re}function J(q,Q){const re=Math.min(q.length,Q.length);let ce;const ve=q.length-1,Pe=Q.length-1;for(ce=0;ce<re;ce++)if(q.charCodeAt(ve-ce)!==Q.charCodeAt(Pe-ce))return ce;return re}function se(q){return 55296<=q&&q<=56319}function le(q){return 56320<=q&&q<=57343}function V(q,Q){return(q-55296<<10)+(Q-56320)+65536}function F(q,Q,re){const ce=q.charCodeAt(re);if(se(ce)&&re+1<Q){const ve=q.charCodeAt(re+1);if(le(ve))return V(ce,ve)}return ce}function Y(q,Q){const re=q.charCodeAt(Q-1);if(le(re)&&Q>1){const ce=q.charCodeAt(Q-2);if(se(ce))return V(ce,re)}return re}class ee{get offset(){return this._offset}constructor(Q,re=0){this._str=Q,this._len=Q.length,this._offset=re}setOffset(Q){this._offset=Q}prevCodePoint(){const Q=Y(this._str,this._offset);return this._offset-=Q>=y.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Q}nextCodePoint(){const Q=F(this._str,this._len,this._offset);return this._offset+=Q>=y.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Q}eol(){return this._offset>=this._len}}e.CodePointIterator=ee;class ue{get offset(){return this._iterator.offset}constructor(Q,re=0){this._iterator=new ee(Q,re)}nextGraphemeLength(){const Q=Te.getInstance(),re=this._iterator,ce=re.offset;let ve=Q.getGraphemeBreakType(re.nextCodePoint());for(;!re.eol();){const Pe=re.offset,Re=Q.getGraphemeBreakType(re.nextCodePoint());if(We(ve,Re)){re.setOffset(Pe);break}ve=Re}return re.offset-ce}prevGraphemeLength(){const Q=Te.getInstance(),re=this._iterator,ce=re.offset;let ve=Q.getGraphemeBreakType(re.prevCodePoint());for(;re.offset>0;){const Pe=re.offset,Re=Q.getGraphemeBreakType(re.prevCodePoint());if(We(Re,ve)){re.setOffset(Pe);break}ve=Re}return ce-re.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ue;function $(q,Q){return new ue(q,Q).nextGraphemeLength()}function ae(q,Q){return new ue(q,Q).prevGraphemeLength()}function ge(q,Q){Q>0&&le(q.charCodeAt(Q))&&Q--;const re=Q+$(q,Q);return[re-ae(q,re),re]}function te(q){const Q=new ue(q);let re=0;for(;!Q.eol();)re++,Q.nextGraphemeLength();return re}let d;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(q){return d||(d=H()),d.test(q)}const N=/^[\t\n\r\x20-\x7E]*$/;function K(q){return N.test(q)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}function T(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}function X(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}function ne(q,Q,re=""){const ce=q.trimStart();if(ce.length<Q)return ce;const ve=/\b/g;let Pe=0;for(;ve.test(ce)&&!(ce.length-ve.lastIndex<Q);)Pe=ve.lastIndex,ve.lastIndex+=1;return Pe===0?ce:re+ce.substring(Pe).trimStart()}const oe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(q){let Q=0;for(const re of q.matchAll(oe))Q!==re.index&&(yield{isCode:!1,str:q.substring(Q,re.index)}),yield{isCode:!0,str:re[0]},Q=re.index+re[0].length;Q!==q.length&&(yield{isCode:!1,str:q.substring(Q)})}function we(q){return q&&(q=q.replace(oe,"")),q}const me=/\\\[.*?\\\]/g;function de(q){return we(q).replace(me,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function Ee(q){return!!(q&&q.length>0&&q.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ye(q){return Ee(q)?q.substr(1):q}function be(q,Q){if(!q||!Q||q.length<Q.length)return!1;const re=Q.length,ce=q.toLowerCase();let ve=0,Pe=-1;for(;ve<re;){const Re=ce.indexOf(Q[ve],Pe+1);if(Re<0)return!1;Pe=Re,ve++}return!0}function Le(q,Q=!1){return q?(Q&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}function Ie(q){return q.charAt(0).toUpperCase()+q.slice(1)}function Ce(q,Q=1){if(Q===0)return"";let re=-1;do re=q.indexOf(`
`,re+1),Q--;while(Q>0&&re>=0);return re===-1?q:(q[re-1]==="\r"&&re--,q.substr(0,re))}function Ae(q){const Q=t.CharCode.Z-t.CharCode.A+1;return q=q%(2*Q),q<Q?String.fromCharCode(t.CharCode.a+q):String.fromCharCode(t.CharCode.A+q-Q)}function Be(q){return Te.getInstance().getGraphemeBreakType(q)}function We(q,Q){return q===Se.Other?Q!==Se.Extend&&Q!==Se.SpacingMark:q===Se.CR&&Q===Se.LF?!1:q===Se.Control||q===Se.CR||q===Se.LF||Q===Se.Control||Q===Se.CR||Q===Se.LF?!0:!(q===Se.L&&(Q===Se.L||Q===Se.V||Q===Se.LV||Q===Se.LVT)||(q===Se.LV||q===Se.V)&&(Q===Se.V||Q===Se.T)||(q===Se.LVT||q===Se.T)&&Q===Se.T||Q===Se.Extend||Q===Se.ZWJ||Q===Se.SpacingMark||q===Se.Prepend||q===Se.ZWJ&&Q===Se.Extended_Pictographic||q===Se.Regional_Indicator&&Q===Se.Regional_Indicator)}var Se;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Te{static{this._INSTANCE=null}static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(Q){if(Q<32)return Q===t.CharCode.LineFeed?Se.LF:Q===t.CharCode.CarriageReturn?Se.CR:Se.Control;if(Q<127)return Se.Other;const re=this._data,ce=re.length/3;let ve=1;for(;ve<=ce;)if(Q<re[3*ve])ve=2*ve;else if(Q>re[3*ve+1])ve=2*ve+1;else return re[3*ve+2];return Se.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(q,Q){if(q===0)return 0;const re=Ke(q,Q);if(re!==void 0)return re;const ce=new ee(Q,q);return ce.prevCodePoint(),ce.offset}function Ke(q,Q){const re=new ee(Q,q);let ce=re.prevCodePoint();for(;Ze(ce)||ce===je.emojiVariantSelector||ce===je.enclosingKeyCap;){if(re.offset===0)return;ce=re.prevCodePoint()}if(!X(ce))return;let ve=re.offset;return ve>0&&re.prevCodePoint()===je.zwj&&(ve=re.offset),ve}function Ze(q){return 127995<=q&&q<=127999}var je;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class $e{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new a.LRUCachedFunction({getCacheKey:JSON.stringify},Q=>{function re(ke){const Fe=new Map;for(let Ue=0;Ue<ke.length;Ue+=2)Fe.set(ke[Ue],ke[Ue+1]);return Fe}function ce(ke,Fe){const Ue=new Map(ke);for(const[He,Xe]of Fe)Ue.set(He,Xe);return Ue}function ve(ke,Fe){if(!ke)return Fe;const Ue=new Map;for(const[He,Xe]of ke)Fe.has(He)&&Ue.set(He,Xe);return Ue}const Pe=this.ambiguousCharacterData.value;let Re=Q.filter(ke=>!ke.startsWith("_")&&ke in Pe);Re.length===0&&(Re=["_default"]);let Ne;for(const ke of Re){const Fe=re(Pe[ke]);Ne=ve(Ne,Fe)}const Oe=re(Pe._common),Me=ce(Oe,Ne);return new $e(Me)})}static getInstance(Q){return $e.cache.get(Array.from(Q))}static{this._locales=new L.Lazy(()=>Object.keys($e.ambiguousCharacterData.value).filter(Q=>!Q.startsWith("_")))}static getLocales(){return $e._locales.value}constructor(Q){this.confusableDictionary=Q}isAmbiguous(Q){return this.confusableDictionary.has(Q)}containsAmbiguousCharacter(Q){for(let re=0;re<Q.length;re++){const ce=Q.codePointAt(re);if(typeof ce=="number"&&this.isAmbiguous(ce))return!0}return!1}getPrimaryConfusable(Q){return this.confusableDictionary.get(Q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e;class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(Q){return xe.getData().has(Q)}static containsInvisibleCharacter(Q){for(let re=0;re<Q.length;re++){const ce=Q.codePointAt(re);if(typeof ce=="number"&&xe.isInvisibleCharacter(ce))return!0}return!1}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe}),define(he[54],fe([0,1,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=t,e.doHash=L,e.numberHash=y,e.stringHash=P,e.toHexString=h,a=De(a);function t(u){return L(u,0)}function L(u,r){switch(typeof u){case"object":return u===null?y(349,r):Array.isArray(u)?v(u,r):o(u,r);case"string":return P(u,r);case"boolean":return W(u,r);case"number":return y(u,r);case"undefined":return y(937,r);default:return y(617,r)}}function y(u,r){return(r<<5)-r+u|0}function W(u,r){return y(u?433:863,r)}function P(u,r){r=y(149417,r);for(let p=0,b=u.length;p<b;p++)r=y(u.charCodeAt(p),r);return r}function v(u,r){return r=y(104579,r),u.reduce((p,b)=>L(b,p),r)}function o(u,r){return r=y(181387,r),Object.keys(u).sort().reduce((p,b)=>(p=P(b,p),L(u[b],p)),r)}class w{constructor(){this._value=0}get value(){return this._value}hash(r){return this._value=L(r,this._value),this._value}}e.Hasher=w;var _;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function f(u,r,p=32){const b=p-r,s=~((1<<b)-1);return(u<<r|(s&u)>>>b)>>>0}function c(u,r=0,p=u.byteLength,b=0){for(let s=0;s<p;s++)u[r+s]=b}function l(u,r,p="0"){for(;u.length<r;)u=p+u;return u}function h(u,r=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(p=>p.toString(16).padStart(2,"0")).join(""):l((u>>>0).toString(16),r/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(r){const p=r.length;if(p===0)return;const b=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,S;for(i!==0?(n=i,S=-1,i=0):(n=r.charCodeAt(0),S=0);;){let A=n;if(a.isHighSurrogate(n))if(S+1<p){const O=r.charCodeAt(S+1);a.isLowSurrogate(O)?(S++,A=a.computeCodePoint(n,O)):A=_.UNICODE_REPLACEMENT}else{i=n;break}else a.isLowSurrogate(n)&&(A=_.UNICODE_REPLACEMENT);if(s=this._push(b,s,A),S++,S<p)n=r.charCodeAt(S);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(r,p,b){return b<128?r[p++]=b:b<2048?(r[p++]=192|(b&1984)>>>6,r[p++]=128|(b&63)>>>0):b<65536?(r[p++]=224|(b&61440)>>>12,r[p++]=128|(b&4032)>>>6,r[p++]=128|(b&63)>>>0):(r[p++]=240|(b&1835008)>>>18,r[p++]=128|(b&258048)>>>12,r[p++]=128|(b&4032)>>>6,r[p++]=128|(b&63)>>>0),p>=_.BLOCK_SIZE&&(this._step(),p-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,r[0]=r[_.BLOCK_SIZE+0],r[1]=r[_.BLOCK_SIZE+1],r[2]=r[_.BLOCK_SIZE+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const r=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(r/4294967296),!1),this._buffDV.setUint32(60,r%4294967296,!1),this._step()}_step(){const r=m._bigBlock32,p=this._buffDV;for(let D=0;D<64;D+=4)r.setUint32(D,p.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)r.setUint32(D,f(r.getUint32(D-12,!1)^r.getUint32(D-32,!1)^r.getUint32(D-56,!1)^r.getUint32(D-64,!1),1),!1);let b=this._h0,s=this._h1,i=this._h2,n=this._h3,S=this._h4,A,O,E;for(let D=0;D<80;D++)D<20?(A=s&i|~s&n,O=1518500249):D<40?(A=s^i^n,O=1859775393):D<60?(A=s&i|s&n|i&n,O=2400959708):(A=s^i^n,O=3395469782),E=f(b,5)+A+S+O+r.getUint32(D*4,!1)&4294967295,S=n,n=i,i=f(s,30),s=b,b=E;this._h0=this._h0+b&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+S&4294967295}}e.StringSHA1=m}),define(he[55],fe([0,1,18,14,10]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const h=l.charCodeAt(0),m=this._value.charCodeAt(this._pos);return h-m}value(){return this._value[this._pos]}}e.StringIterator=y;class W{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,L.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=W;class P{constructor(l=!0,h=!0){this._splitOnBackslash=l,this._caseSensitive=h}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let h=l.length-1;h>=0;h--,this._valueLen--){const m=this._value.charCodeAt(h);if(!(m===t.CharCode.Slash||this._splitOnBackslash&&m===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===t.CharCode.Slash||this._splitOnBackslash&&h===t.CharCode.Backslash)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,L.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var v;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(v||(v={}));class o{constructor(l,h){this._ignorePathCasing=l,this._ignoreQueryAndFragment=h,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===v.Scheme)return(0,L.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,L.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===v.Query)return(0,L.compare)(l,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,L.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=o;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(_||(_={}));class f{static forUris(l=()=>!1,h=()=>!1){return new f(new o(l,h))}static forPaths(l=!1){return new f(new P(void 0,!l))}static forStrings(){return new f(new y)}static forConfigKeys(){return new f(new W)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,h){if(h){const m=h.slice(0);(0,a.shuffle)(m);for(const u of m)this.set(u,l)}else{const m=l.slice(0);(0,a.shuffle)(m);for(const u of m)this.set(u[0],u[1])}}set(l,h){const m=this._iter.reset(l);let u;this._root||(this._root=new w,this._root.segment=m.value());const r=[];for(u=this._root;;){const b=m.cmp(u.segment);if(b>0)u.left||(u.left=new w,u.left.segment=m.value()),r.push([_.Left,u]),u=u.left;else if(b<0)u.right||(u.right=new w,u.right.segment=m.value()),r.push([_.Right,u]),u=u.right;else if(m.hasNext())m.next(),u.mid||(u.mid=new w,u.mid.segment=m.value()),r.push([_.Mid,u]),u=u.mid;else break}const p=u.value;u.value=h,u.key=l;for(let b=r.length-1;b>=0;b--){const s=r[b][1];s.updateHeight();const i=s.balanceFactor();if(i<-1||i>1){const n=r[b][0],S=r[b+1][0];if(n===_.Right&&S===_.Right)r[b][1]=s.rotateLeft();else if(n===_.Left&&S===_.Left)r[b][1]=s.rotateRight();else if(n===_.Right&&S===_.Left)s.right=r[b+1][1]=r[b+1][1].rotateRight(),r[b][1]=s.rotateLeft();else if(n===_.Left&&S===_.Right)s.left=r[b+1][1]=r[b+1][1].rotateLeft(),r[b][1]=s.rotateRight();else throw new Error;if(b>0)switch(r[b-1][0]){case _.Left:r[b-1][1].left=r[b][1];break;case _.Right:r[b-1][1].right=r[b][1];break;case _.Mid:r[b-1][1].mid=r[b][1];break}else this._root=r[0][1]}}return p}get(l){return this._getNode(l)?.value}_getNode(l){const h=this._iter.reset(l);let m=this._root;for(;m;){const u=h.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(h.hasNext())h.next(),m=m.mid;else break}return m}has(l){const h=this._getNode(l);return!(h?.value===void 0&&h?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,h){const m=this._iter.reset(l),u=[];let r=this._root;for(;r;){const p=m.cmp(r.segment);if(p>0)u.push([_.Left,r]),r=r.left;else if(p<0)u.push([_.Right,r]),r=r.right;else if(m.hasNext())m.next(),u.push([_.Mid,r]),r=r.mid;else break}if(r){if(h?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const p=this._min(r.right);if(p.key){const{key:b,value:s,segment:i}=p;this._delete(p.key,!1),r.key=b,r.value=s,r.segment=i}}else{const p=r.left??r.right;if(u.length>0){const[b,s]=u[u.length-1];switch(b){case _.Left:s.left=p;break;case _.Mid:s.mid=p;break;case _.Right:s.right=p;break}}else this._root=p}for(let p=u.length-1;p>=0;p--){const b=u[p][1];b.updateHeight();const s=b.balanceFactor();if(s>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),u[p][1]=b.rotateLeft()):s<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),u[p][1]=b.rotateRight()),p>0)switch(u[p-1][0]){case _.Left:u[p-1][1].left=u[p][1];break;case _.Right:u[p-1][1].right=u[p][1];break;case _.Mid:u[p-1][1].mid=u[p][1];break}else this._root=u[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const h=this._iter.reset(l);let m=this._root,u;for(;m;){const r=h.cmp(m.segment);if(r>0)m=m.left;else if(r<0)m=m.right;else if(h.hasNext())h.next(),u=m.value||u,m=m.mid;else break}return m&&m.value||u}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,h){const m=this._iter.reset(l);let u=this._root;for(;u;){const r=m.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if(m.hasNext())m.next(),u=u.mid;else return u.mid?this._entries(u.mid):h?u.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[h,m]of this)l(m,h)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const h=[];return this._dfsEntries(l,h),h[Symbol.iterator]()}_dfsEntries(l,h){l&&(l.left&&this._dfsEntries(l.left,h),l.value&&h.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,h),l.right&&this._dfsEntries(l.right,h))}_isBalanced(){const l=h=>{if(!h)return!0;const m=h.balanceFactor();return m<-1||m>1?!1:l(h.left)&&l(h.right)};return l(this._root)}}e.TernarySearchTree=f}),define(he[56],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=t;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(L){return a.test(L)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(P){for(let v=0;v<P.length;v++)P[v]=Math.floor(Math.random()*256);return P};const y=new Uint8Array(16),W=[];for(let P=0;P<256;P++)W.push(P.toString(16).padStart(2,"0"));return function(){L(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let v=0,o="";return o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o+="-",o+=W[y[v++]],o+=W[y[v++]],o+="-",o+=W[y[v++]],o+=W[y[v++]],o+="-",o+=W[y[v++]],o+=W[y[v++]],o+="-",o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o+=W[y[v++]],o}}()}),define(he[34],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=a;function a(t){return!!t.parentPort}}),define(he[57],fe([13,11]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(he[58],fe([0,1,57]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=o,e.getDurationString=w,e.toLocalISOString=_;const t=60,L=t*60,y=L*24,W=y*7,P=y*30,v=y*365;function o(f,c,l,h){typeof f!="number"&&(f=f.getTime());const m=Math.round((new Date().getTime()-f)/1e3);if(m<-30)return(0,a.localize)(0,null,o(new Date().getTime()+m*1e3,!1));if(!h&&m<30)return(0,a.localize)(1,null);let u;return m<t?(u=m,c?u===1?l?(0,a.localize)(2,null,u):(0,a.localize)(3,null,u):l?(0,a.localize)(4,null,u):(0,a.localize)(5,null,u):u===1?l?(0,a.localize)(6,null,u):(0,a.localize)(7,null,u):l?(0,a.localize)(8,null,u):(0,a.localize)(9,null,u)):m<L?(u=Math.floor(m/t),c?u===1?l?(0,a.localize)(10,null,u):(0,a.localize)(11,null,u):l?(0,a.localize)(12,null,u):(0,a.localize)(13,null,u):u===1?l?(0,a.localize)(14,null,u):(0,a.localize)(15,null,u):l?(0,a.localize)(16,null,u):(0,a.localize)(17,null,u)):m<y?(u=Math.floor(m/L),c?u===1?l?(0,a.localize)(18,null,u):(0,a.localize)(19,null,u):l?(0,a.localize)(20,null,u):(0,a.localize)(21,null,u):u===1?l?(0,a.localize)(22,null,u):(0,a.localize)(23,null,u):l?(0,a.localize)(24,null,u):(0,a.localize)(25,null,u)):m<W?(u=Math.floor(m/y),c?u===1?(0,a.localize)(26,null,u):(0,a.localize)(27,null,u):u===1?(0,a.localize)(28,null,u):(0,a.localize)(29,null,u)):m<P?(u=Math.floor(m/W),c?u===1?l?(0,a.localize)(30,null,u):(0,a.localize)(31,null,u):l?(0,a.localize)(32,null,u):(0,a.localize)(33,null,u):u===1?l?(0,a.localize)(34,null,u):(0,a.localize)(35,null,u):l?(0,a.localize)(36,null,u):(0,a.localize)(37,null,u)):m<v?(u=Math.floor(m/P),c?u===1?l?(0,a.localize)(38,null,u):(0,a.localize)(39,null,u):l?(0,a.localize)(40,null,u):(0,a.localize)(41,null,u):u===1?l?(0,a.localize)(42,null,u):(0,a.localize)(43,null,u):l?(0,a.localize)(44,null,u):(0,a.localize)(45,null,u)):(u=Math.floor(m/v),c?u===1?l?(0,a.localize)(46,null,u):(0,a.localize)(47,null,u):l?(0,a.localize)(48,null,u):(0,a.localize)(49,null,u):u===1?l?(0,a.localize)(50,null,u):(0,a.localize)(51,null,u):l?(0,a.localize)(52,null,u):(0,a.localize)(53,null,u))}function w(f,c){const l=Math.abs(f/1e3);return l<1?c?(0,a.localize)(54,null,f):(0,a.localize)(55,null,f):l<t?c?(0,a.localize)(56,null,Math.round(f)/1e3):(0,a.localize)(57,null,Math.round(f)/1e3):l<L?c?(0,a.localize)(58,null,Math.round(f/(1e3*t))):(0,a.localize)(59,null,Math.round(f/(1e3*t))):l<y?c?(0,a.localize)(60,null,Math.round(f/(1e3*L))):(0,a.localize)(61,null,Math.round(f/(1e3*L))):(0,a.localize)(62,null,Math.round(f/(1e3*y)))}function _(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[59],fe([13,11]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(he[60],fe([0,1,18,9,59]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=o,e.createErrorWithActions=w,a=De(a),t=De(t),L=De(L);function y(_,f){return f&&(_.stack||_.stacktrace)?L.localize(0,null,P(_),W(_.stack)||W(_.stacktrace)):P(_)}function W(_){return Array.isArray(_)?_.join(`
`):_}function P(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?L.localize(1,null,_.message):_.message||L.localize(2,null)}function v(_=null,f=!1){if(!_)return L.localize(3,null);if(Array.isArray(_)){const c=a.coalesce(_),l=v(c[0],f);return c.length>1?L.localize(4,null,l,c.length):l}if(t.isString(_))return _;if(_.detail){const c=_.detail;if(c.error)return y(c.error,f);if(c.exception)return y(c.exception,f)}return _.stack?y(_,f):_.message?_.message:L.localize(5,null)}function o(_){const f=_;return f instanceof Error&&Array.isArray(f.actions)}function w(_,f){let c;return typeof _=="string"?c=new Error(_):c=_,c.actions=f,c}}),define(he[61],fe([13,11]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(he[3],fe([0,1,61]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=I,e.isBigSurOrNewer=x,a=De(a),e.LANGUAGE_DEFAULT="en";let t=!1,L=!1,y=!1,W=!1,P=!1,v=!1,o=!1,w=!1,_=!1,f=!1,c,l=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT,m,u;const r=globalThis;let p;typeof r.vscode<"u"&&typeof r.vscode.process<"u"?p=r.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const b=typeof p?.versions?.electron=="string",s=b&&p?.type==="renderer";if(typeof p=="object"){t=p.platform==="win32",L=p.platform==="darwin",y=p.platform==="linux",W=y&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,o=b,_=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT;const z=p.env.VSCODE_NLS_CONFIG;if(z)try{const k=JSON.parse(z),g=k.availableLanguages["*"];c=k.locale,h=k.osLocale,l=g||e.LANGUAGE_DEFAULT,m=k._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!s?(u=navigator.userAgent,t=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,w=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=u.indexOf("Linux")>=0,f=u?.indexOf("Mobi")>=0,v=!0,c=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,l=c,h=navigator.language):console.error("Unable to resolve platform.");var i;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(i||(e.Platform=i={}));function n(z){switch(z){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let S=i.Web;L?S=i.Mac:t?S=i.Windows:y&&(S=i.Linux),e.isWindows=t,e.isMacintosh=L,e.isLinux=y,e.isLinuxSnap=W,e.isNative=P,e.isElectron=o,e.isWeb=v,e.isWebWorker=v&&typeof r.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?r.origin:void 0,e.isIOS=w,e.isMobile=f,e.isCI=_,e.platform=S,e.userAgent=u,e.language=l;var A;(function(z){function k(){return e.language}z.value=k;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}z.isDefaultVariant=g;function M(){return e.language==="en"}z.isDefault=M})(A||(e.Language=A={})),e.locale=c,e.platformLocale=h,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof r.postMessage=="function"&&!r.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const z=[];r.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let M=0,R=z.length;M<R;M++){const C=z[M];if(C.id===g.data.vscodeScheduleAsyncWork){z.splice(M,1),C.callback();return}}});let k=0;return g=>{const M=++k;z.push({id:M,callback:g}),r.postMessage({vscodeScheduleAsyncWork:M},"*")}}return z=>setTimeout(z)})();var O;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(O||(e.OperatingSystem=O={})),e.OS=L||w?O.Macintosh:t?O.Windows:O.Linux;let E=!0,D=!1;function I(){if(!D){D=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,E=new Uint16Array(z.buffer)[0]===513}return E}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function x(z){return parseFloat(z)>=20}}),define(he[16],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const y=L.process;t={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(he[5],fe([0,1,16]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,a=De(a);const t=65,L=97,y=90,W=122,P=46,v=47,o=92,w=58,_=63;class f extends Error{constructor(n,S,A){let O;typeof S=="string"&&S.indexOf("not ")===0?(O="must not be",S=S.replace(/^not /,"")):O="must be";const E=n.indexOf(".")!==-1?"property":"argument";let D=`The "${n}" ${E} ${O} of type ${S}`;D+=`. Received type ${typeof A}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,n){if(i===null||typeof i!="object")throw new f(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new f(n,"string",i)}const h=a.platform==="win32";function m(i){return i===v||i===o}function u(i){return i===v}function r(i){return i>=t&&i<=y||i>=L&&i<=W}function p(i,n,S,A){let O="",E=0,D=-1,I=0,x=0;for(let z=0;z<=i.length;++z){if(z<i.length)x=i.charCodeAt(z);else{if(A(x))break;x=v}if(A(x)){if(!(D===z-1||I===1))if(I===2){if(O.length<2||E!==2||O.charCodeAt(O.length-1)!==P||O.charCodeAt(O.length-2)!==P){if(O.length>2){const k=O.lastIndexOf(S);k===-1?(O="",E=0):(O=O.slice(0,k),E=O.length-1-O.lastIndexOf(S)),D=z,I=0;continue}else if(O.length!==0){O="",E=0,D=z,I=0;continue}}n&&(O+=O.length>0?`${S}..`:"..",E=2)}else O.length>0?O+=`${S}${i.slice(D+1,z)}`:O=i.slice(D+1,z),E=z-D-1;D=z,I=0}else x===P&&I!==-1?++I:I=-1}return O}function b(i,n){c(n,"pathObject");const S=n.dir||n.root,A=n.base||`${n.name||""}${n.ext||""}`;return S?S===n.root?`${S}${A}`:`${S}${i}${A}`:A}e.win32={resolve(...i){let n="",S="",A=!1;for(let O=i.length-1;O>=-1;O--){let E;if(O>=0){if(E=i[O],l(E,"path"),E.length===0)continue}else n.length===0?E=a.cwd():(E=a.env[`=${n}`]||a.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==n.toLowerCase()&&E.charCodeAt(2)===o)&&(E=`${n}\\`));const D=E.length;let I=0,x="",z=!1;const k=E.charCodeAt(0);if(D===1)m(k)&&(I=1,z=!0);else if(m(k))if(z=!0,m(E.charCodeAt(1))){let g=2,M=g;for(;g<D&&!m(E.charCodeAt(g));)g++;if(g<D&&g!==M){const R=E.slice(M,g);for(M=g;g<D&&m(E.charCodeAt(g));)g++;if(g<D&&g!==M){for(M=g;g<D&&!m(E.charCodeAt(g));)g++;(g===D||g!==M)&&(x=`\\\\${R}\\${E.slice(M,g)}`,I=g)}}}else I=1;else r(k)&&E.charCodeAt(1)===w&&(x=E.slice(0,2),I=2,D>2&&m(E.charCodeAt(2))&&(z=!0,I=3));if(x.length>0)if(n.length>0){if(x.toLowerCase()!==n.toLowerCase())continue}else n=x;if(A){if(n.length>0)break}else if(S=`${E.slice(I)}\\${S}`,A=z,z&&n.length>0)break}return S=p(S,!A,"\\",m),A?`${n}\\${S}`:`${n}${S}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let S=0,A,O=!1;const E=i.charCodeAt(0);if(n===1)return u(E)?"\\":i;if(m(E))if(O=!0,m(i.charCodeAt(1))){let I=2,x=I;for(;I<n&&!m(i.charCodeAt(I));)I++;if(I<n&&I!==x){const z=i.slice(x,I);for(x=I;I<n&&m(i.charCodeAt(I));)I++;if(I<n&&I!==x){for(x=I;I<n&&!m(i.charCodeAt(I));)I++;if(I===n)return`\\\\${z}\\${i.slice(x)}\\`;I!==x&&(A=`\\\\${z}\\${i.slice(x,I)}`,S=I)}}}else S=1;else r(E)&&i.charCodeAt(1)===w&&(A=i.slice(0,2),S=2,n>2&&m(i.charCodeAt(2))&&(O=!0,S=3));let D=S<n?p(i.slice(S),!O,"\\",m):"";return D.length===0&&!O&&(D="."),D.length>0&&m(i.charCodeAt(n-1))&&(D+="\\"),A===void 0?O?`\\${D}`:D:O?`${A}\\${D}`:`${A}${D}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const S=i.charCodeAt(0);return m(S)||n>2&&r(S)&&i.charCodeAt(1)===w&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,S;for(let E=0;E<i.length;++E){const D=i[E];l(D,"path"),D.length>0&&(n===void 0?n=S=D:n+=`\\${D}`)}if(n===void 0)return".";let A=!0,O=0;if(typeof S=="string"&&m(S.charCodeAt(0))){++O;const E=S.length;E>1&&m(S.charCodeAt(1))&&(++O,E>2&&(m(S.charCodeAt(2))?++O:A=!1))}if(A){for(;O<n.length&&m(n.charCodeAt(O));)O++;O>=2&&(n=`\\${n.slice(O)}`)}return e.win32.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const S=e.win32.resolve(i),A=e.win32.resolve(n);if(S===A||(i=S.toLowerCase(),n=A.toLowerCase(),i===n))return"";let O=0;for(;O<i.length&&i.charCodeAt(O)===o;)O++;let E=i.length;for(;E-1>O&&i.charCodeAt(E-1)===o;)E--;const D=E-O;let I=0;for(;I<n.length&&n.charCodeAt(I)===o;)I++;let x=n.length;for(;x-1>I&&n.charCodeAt(x-1)===o;)x--;const z=x-I,k=D<z?D:z;let g=-1,M=0;for(;M<k;M++){const C=i.charCodeAt(O+M);if(C!==n.charCodeAt(I+M))break;C===o&&(g=M)}if(M!==k){if(g===-1)return A}else{if(z>k){if(n.charCodeAt(I+M)===o)return A.slice(I+M+1);if(M===2)return A.slice(I+M)}D>k&&(i.charCodeAt(O+M)===o?g=M:M===2&&(g=3)),g===-1&&(g=0)}let R="";for(M=O+g+1;M<=E;++M)(M===E||i.charCodeAt(M)===o)&&(R+=R.length===0?"..":"\\..");return I+=g,R.length>0?`${R}${A.slice(I,x)}`:(A.charCodeAt(I)===o&&++I,A.slice(I,x))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.win32.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===o){if(n.charCodeAt(1)===o){const S=n.charCodeAt(2);if(S!==_&&S!==P)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(r(n.charCodeAt(0))&&n.charCodeAt(1)===w&&n.charCodeAt(2)===o)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let S=-1,A=0;const O=i.charCodeAt(0);if(n===1)return m(O)?i:".";if(m(O)){if(S=A=1,m(i.charCodeAt(1))){let I=2,x=I;for(;I<n&&!m(i.charCodeAt(I));)I++;if(I<n&&I!==x){for(x=I;I<n&&m(i.charCodeAt(I));)I++;if(I<n&&I!==x){for(x=I;I<n&&!m(i.charCodeAt(I));)I++;if(I===n)return i;I!==x&&(S=A=I+1)}}}}else r(O)&&i.charCodeAt(1)===w&&(S=n>2&&m(i.charCodeAt(2))?3:2,A=S);let E=-1,D=!0;for(let I=n-1;I>=A;--I)if(m(i.charCodeAt(I))){if(!D){E=I;break}}else D=!1;if(E===-1){if(S===-1)return".";E=S}return i.slice(0,E)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let S=0,A=-1,O=!0,E;if(i.length>=2&&r(i.charCodeAt(0))&&i.charCodeAt(1)===w&&(S=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let D=n.length-1,I=-1;for(E=i.length-1;E>=S;--E){const x=i.charCodeAt(E);if(m(x)){if(!O){S=E+1;break}}else I===-1&&(O=!1,I=E+1),D>=0&&(x===n.charCodeAt(D)?--D===-1&&(A=E):(D=-1,A=I))}return S===A?A=I:A===-1&&(A=i.length),i.slice(S,A)}for(E=i.length-1;E>=S;--E)if(m(i.charCodeAt(E))){if(!O){S=E+1;break}}else A===-1&&(O=!1,A=E+1);return A===-1?"":i.slice(S,A)},extname(i){l(i,"path");let n=0,S=-1,A=0,O=-1,E=!0,D=0;i.length>=2&&i.charCodeAt(1)===w&&r(i.charCodeAt(0))&&(n=A=2);for(let I=i.length-1;I>=n;--I){const x=i.charCodeAt(I);if(m(x)){if(!E){A=I+1;break}continue}O===-1&&(E=!1,O=I+1),x===P?S===-1?S=I:D!==1&&(D=1):S!==-1&&(D=-1)}return S===-1||O===-1||D===0||D===1&&S===O-1&&S===A+1?"":i.slice(S,O)},format:b.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const S=i.length;let A=0,O=i.charCodeAt(0);if(S===1)return m(O)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(m(O)){if(A=1,m(i.charCodeAt(1))){let g=2,M=g;for(;g<S&&!m(i.charCodeAt(g));)g++;if(g<S&&g!==M){for(M=g;g<S&&m(i.charCodeAt(g));)g++;if(g<S&&g!==M){for(M=g;g<S&&!m(i.charCodeAt(g));)g++;g===S?A=g:g!==M&&(A=g+1)}}}}else if(r(O)&&i.charCodeAt(1)===w){if(S<=2)return n.root=n.dir=i,n;if(A=2,m(i.charCodeAt(2))){if(S===3)return n.root=n.dir=i,n;A=3}}A>0&&(n.root=i.slice(0,A));let E=-1,D=A,I=-1,x=!0,z=i.length-1,k=0;for(;z>=A;--z){if(O=i.charCodeAt(z),m(O)){if(!x){D=z+1;break}continue}I===-1&&(x=!1,I=z+1),O===P?E===-1?E=z:k!==1&&(k=1):E!==-1&&(k=-1)}return I!==-1&&(E===-1||k===0||k===1&&E===I-1&&E===D+1?n.base=n.name=i.slice(D,I):(n.name=i.slice(D,E),n.base=i.slice(D,I),n.ext=i.slice(E,I))),D>0&&D!==A?n.dir=i.slice(0,D-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(h){const i=/\\/g;return()=>{const n=a.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let n="",S=!1;for(let A=i.length-1;A>=-1&&!S;A--){const O=A>=0?i[A]:s();l(O,"path"),O.length!==0&&(n=`${O}/${n}`,S=O.charCodeAt(0)===v)}return n=p(n,!S,"/",u),S?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===v,S=i.charCodeAt(i.length-1)===v;return i=p(i,!n,"/",u),i.length===0?n?"/":S?"./":".":(S&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===v},join(...i){if(i.length===0)return".";let n;for(let S=0;S<i.length;++S){const A=i[S];l(A,"path"),A.length>0&&(n===void 0?n=A:n+=`/${A}`)}return n===void 0?".":e.posix.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.posix.resolve(i),n=e.posix.resolve(n),i===n))return"";const S=1,A=i.length,O=A-S,E=1,D=n.length-E,I=O<D?O:D;let x=-1,z=0;for(;z<I;z++){const g=i.charCodeAt(S+z);if(g!==n.charCodeAt(E+z))break;g===v&&(x=z)}if(z===I)if(D>I){if(n.charCodeAt(E+z)===v)return n.slice(E+z+1);if(z===0)return n.slice(E+z)}else O>I&&(i.charCodeAt(S+z)===v?x=z:z===0&&(x=0));let k="";for(z=S+x+1;z<=A;++z)(z===A||i.charCodeAt(z)===v)&&(k+=k.length===0?"..":"/..");return`${k}${n.slice(E+x)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===v;let S=-1,A=!0;for(let O=i.length-1;O>=1;--O)if(i.charCodeAt(O)===v){if(!A){S=O;break}}else A=!1;return S===-1?n?"/":".":n&&S===1?"//":i.slice(0,S)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let S=0,A=-1,O=!0,E;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let D=n.length-1,I=-1;for(E=i.length-1;E>=0;--E){const x=i.charCodeAt(E);if(x===v){if(!O){S=E+1;break}}else I===-1&&(O=!1,I=E+1),D>=0&&(x===n.charCodeAt(D)?--D===-1&&(A=E):(D=-1,A=I))}return S===A?A=I:A===-1&&(A=i.length),i.slice(S,A)}for(E=i.length-1;E>=0;--E)if(i.charCodeAt(E)===v){if(!O){S=E+1;break}}else A===-1&&(O=!1,A=E+1);return A===-1?"":i.slice(S,A)},extname(i){l(i,"path");let n=-1,S=0,A=-1,O=!0,E=0;for(let D=i.length-1;D>=0;--D){const I=i.charCodeAt(D);if(I===v){if(!O){S=D+1;break}continue}A===-1&&(O=!1,A=D+1),I===P?n===-1?n=D:E!==1&&(E=1):n!==-1&&(E=-1)}return n===-1||A===-1||E===0||E===1&&n===A-1&&n===S+1?"":i.slice(n,A)},format:b.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const S=i.charCodeAt(0)===v;let A;S?(n.root="/",A=1):A=0;let O=-1,E=0,D=-1,I=!0,x=i.length-1,z=0;for(;x>=A;--x){const k=i.charCodeAt(x);if(k===v){if(!I){E=x+1;break}continue}D===-1&&(I=!1,D=x+1),k===P?O===-1?O=x:z!==1&&(z=1):O!==-1&&(z=-1)}if(D!==-1){const k=E===0&&S?1:E;O===-1||z===0||z===1&&O===D-1&&O===E+1?n.base=n.name=i.slice(k,D):(n.name=i.slice(k,O),n.base=i.slice(k,D),n.ext=i.slice(O,D))}return E>0?n.dir=i.slice(0,E-1):S&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(he[35],fe([0,1,14,5,3,10,9]),function(ie,e,a,t,L,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=P,e.toSlashes=v,e.toPosixPath=o,e.getRoot=w,e.isUNC=_,e.isValidBasename=h,e.isEqual=m,e.isEqualOrParent=u,e.isWindowsDriveLetter=r,e.sanitizeFilePath=p,e.removeTrailingPathSeparator=b,e.isRootOrDriveLetter=s,e.hasDriveLetter=i,e.getDriveLetter=n,e.indexOfPath=S,e.parseLineAndColumnAware=A,e.randomPath=D;function P(I){return I===a.CharCode.Slash||I===a.CharCode.Backslash}function v(I){return I.replace(/[\\/]/g,t.posix.sep)}function o(I){return I.indexOf("/")===-1&&(I=v(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function w(I,x=t.posix.sep){if(!I)return"";const z=I.length,k=I.charCodeAt(0);if(P(k)){if(P(I.charCodeAt(1))&&!P(I.charCodeAt(2))){let M=3;const R=M;for(;M<z&&!P(I.charCodeAt(M));M++);if(R!==M&&!P(I.charCodeAt(M+1))){for(M+=1;M<z;M++)if(P(I.charCodeAt(M)))return I.slice(0,M+1).replace(/[\\/]/g,x)}}return x}else if(r(k)&&I.charCodeAt(1)===a.CharCode.Colon)return P(I.charCodeAt(2))?I.slice(0,2)+x:I.slice(0,2);let g=I.indexOf("://");if(g!==-1){for(g+=3;g<z;g++)if(P(I.charCodeAt(g)))return I.slice(0,g+1)}return""}function _(I){if(!L.isWindows||!I||I.length<5)return!1;let x=I.charCodeAt(0);if(x!==a.CharCode.Backslash||(x=I.charCodeAt(1),x!==a.CharCode.Backslash))return!1;let z=2;const k=z;for(;z<I.length&&(x=I.charCodeAt(z),x!==a.CharCode.Backslash);z++);return!(k===z||(x=I.charCodeAt(z+1),isNaN(x)||x===a.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,c=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(I,x=L.isWindows){const z=x?f:c;return!(!I||I.length===0||/^\s+$/.test(I)||(z.lastIndex=0,z.test(I))||x&&l.test(I)||I==="."||I===".."||x&&I[I.length-1]==="."||x&&I.length!==I.trim().length||I.length>255)}function m(I,x,z){const k=I===x;return!z||k?k:!I||!x?!1:(0,y.equalsIgnoreCase)(I,x)}function u(I,x,z,k=t.sep){if(I===x)return!0;if(!I||!x||x.length>I.length)return!1;if(z){if(!(0,y.startsWithIgnoreCase)(I,x))return!1;if(x.length===I.length)return!0;let M=x.length;return x.charAt(x.length-1)===k&&M--,I.charAt(M)===k}return x.charAt(x.length-1)!==k&&(x+=k),I.indexOf(x)===0}function r(I){return I>=a.CharCode.A&&I<=a.CharCode.Z||I>=a.CharCode.a&&I<=a.CharCode.z}function p(I,x){return L.isWindows&&I.endsWith(":")&&(I+=t.sep),(0,t.isAbsolute)(I)||(I=(0,t.join)(x,I)),I=(0,t.normalize)(I),b(I)}function b(I){return L.isWindows?(I=(0,y.rtrim)(I,t.sep),I.endsWith(":")&&(I+=t.sep)):(I=(0,y.rtrim)(I,t.sep),I||(I=t.sep)),I}function s(I){const x=(0,t.normalize)(I);return L.isWindows?I.length>3?!1:i(x)&&(I.length===2||x.charCodeAt(2)===a.CharCode.Backslash):x===t.posix.sep}function i(I,x=L.isWindows){return x?r(I.charCodeAt(0))&&I.charCodeAt(1)===a.CharCode.Colon:!1}function n(I,x=L.isWindows){return i(I,x)?I[0]:void 0}function S(I,x,z){return x.length>I.length?-1:I===x?0:(z&&(I=I.toLowerCase(),x=x.toLowerCase()),I.indexOf(x))}function A(I){const x=I.split(":");let z,k,g;for(const M of x){const R=Number(M);(0,W.isNumber)(R)?k===void 0?k=R:g===void 0&&(g=R):z=z?[z,M].join(":"):M}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:k!==void 0?k:void 0,column:g!==void 0?g:k!==void 0?1:void 0}}const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(I,x,z=8){let k="";for(let M=0;M<z;M++){let R;M===0&&L.isWindows&&!x&&(z===3||z===4)?R=E:R=O,k+=R.charAt(Math.floor(Math.random()*R.length))}let g;return x?g=`${x}-${k}`:g=k,I?(0,t.join)(I,g):g}}),define(he[36],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=y,e.removeDangerousEnvVariables=W;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t||(e.Source=t={}));var L;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function y(P,...v){const o=v.reduce((f,c)=>(f[c]=!0,f),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(f=>!o[f]).forEach(f=>{for(let c=0;c<w.length;c++)if(f.search(w[c])!==-1){delete P[f];break}})}function W(P){P&&(delete P.DEBUG,a.isMacintosh&&delete P.DYLD_LIBRARY_PATH,a.isLinux&&delete P.LD_PRELOAD)}}),define(he[6],fe([0,1,14,29,5,3]),function(ie,e,a,t,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=i,L=De(L);const W=/^\w[\w\d+.-]*$/,P=/^\//,v=/^\/\//;function o(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!W.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!P.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(E,D){return!E&&!D?"file":E}function _(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==c&&(D=c+D):D=c;break}return D}const f="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(D){return D instanceof h?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,I,x,z,k,g=!1){typeof D=="object"?(this.scheme=D.scheme||f,this.authority=D.authority||f,this.path=D.path||f,this.query=D.query||f,this.fragment=D.fragment||f):(this.scheme=w(D,g),this.authority=I||f,this.path=_(this.scheme,x||f),this.query=z||f,this.fragment=k||f,o(this,g))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:I,authority:x,path:z,query:k,fragment:g}=D;return I===void 0?I=this.scheme:I===null&&(I=f),x===void 0?x=this.authority:x===null&&(x=f),z===void 0?z=this.path:z===null&&(z=f),k===void 0?k=this.query:k===null&&(k=f),g===void 0?g=this.fragment:g===null&&(g=f),I===this.scheme&&x===this.authority&&z===this.path&&k===this.query&&g===this.fragment?this:new r(I,x,z,k,g)}static parse(D,I=!1){const x=l.exec(D);return x?new r(x[2]||f,O(x[4]||f),O(x[5]||f),O(x[7]||f),O(x[9]||f),I):new r(f,f,f,f,f)}static file(D){let I=f;if(y.isWindows&&(D=D.replace(/\\/g,c)),D[0]===c&&D[1]===c){const x=D.indexOf(c,2);x===-1?(I=D.substring(2),D=c):(I=D.substring(2,x),D=D.substring(x)||c)}return new r("file",I,D,f,f)}static from(D,I){return new r(D.scheme,D.authority,D.path,D.query,D.fragment,I)}static joinPath(D,...I){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let x;return y.isWindows&&D.scheme==="file"?x=h.file(L.win32.join(i(D,!0),...I)).path:x=L.posix.join(D.path,...I),D.with({path:x})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof h)return D;{const I=new r(D);return I._formatted=D.external??null,I._fsPath=D._sep===u?D.fsPath??null:null,I}}else return D}}e.URI=h;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const u=y.isWindows?1:void 0;class r extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:t.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=u),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const p={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function b(E,D,I){let x,z=-1;for(let k=0;k<E.length;k++){const g=E.charCodeAt(k);if(g>=a.CharCode.a&&g<=a.CharCode.z||g>=a.CharCode.A&&g<=a.CharCode.Z||g>=a.CharCode.Digit0&&g<=a.CharCode.Digit9||g===a.CharCode.Dash||g===a.CharCode.Period||g===a.CharCode.Underline||g===a.CharCode.Tilde||D&&g===a.CharCode.Slash||I&&g===a.CharCode.OpenSquareBracket||I&&g===a.CharCode.CloseSquareBracket||I&&g===a.CharCode.Colon)z!==-1&&(x+=encodeURIComponent(E.substring(z,k)),z=-1),x!==void 0&&(x+=E.charAt(k));else{x===void 0&&(x=E.substr(0,k));const M=p[g];M!==void 0?(z!==-1&&(x+=encodeURIComponent(E.substring(z,k)),z=-1),x+=M):z===-1&&(z=k)}}return z!==-1&&(x+=encodeURIComponent(E.substring(z))),x!==void 0?x:E}function s(E){let D;for(let I=0;I<E.length;I++){const x=E.charCodeAt(I);x===a.CharCode.Hash||x===a.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,I)),D+=p[x]):D!==void 0&&(D+=E[I])}return D!==void 0?D:E}function i(E,D){let I;return E.authority&&E.path.length>1&&E.scheme==="file"?I=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===a.CharCode.Slash&&(E.path.charCodeAt(1)>=a.CharCode.A&&E.path.charCodeAt(1)<=a.CharCode.Z||E.path.charCodeAt(1)>=a.CharCode.a&&E.path.charCodeAt(1)<=a.CharCode.z)&&E.path.charCodeAt(2)===a.CharCode.Colon?D?I=E.path.substr(1):I=E.path[1].toLowerCase()+E.path.substr(2):I=E.path,y.isWindows&&(I=I.replace(/\//g,"\\")),I}function n(E,D){const I=D?s:b;let x="",{scheme:z,authority:k,path:g,query:M,fragment:R}=E;if(z&&(x+=z,x+=":"),(k||z==="file")&&(x+=c,x+=c),k){let C=k.indexOf("@");if(C!==-1){const B=k.substr(0,C);k=k.substr(C+1),C=B.lastIndexOf(":"),C===-1?x+=I(B,!1,!1):(x+=I(B.substr(0,C),!1,!1),x+=":",x+=I(B.substr(C+1),!1,!0)),x+="@"}k=k.toLowerCase(),C=k.lastIndexOf(":"),C===-1?x+=I(k,!1,!0):(x+=I(k.substr(0,C),!1,!0),x+=k.substr(C))}if(g){if(g.length>=3&&g.charCodeAt(0)===a.CharCode.Slash&&g.charCodeAt(2)===a.CharCode.Colon){const C=g.charCodeAt(1);C>=a.CharCode.A&&C<=a.CharCode.Z&&(g=`/${String.fromCharCode(C+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===a.CharCode.Colon){const C=g.charCodeAt(0);C>=a.CharCode.A&&C<=a.CharCode.Z&&(g=`${String.fromCharCode(C+32)}:${g.substr(2)}`)}x+=I(g,!0,!1)}return M&&(x+="?",x+=I(M,!1,!1)),R&&(x+="#",x+=D?R:b(R,!1,!1)),x}function S(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+S(E.substr(3)):E}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(E){return E.match(A)?E.replace(A,D=>S(D)):E}}),define(he[62],fe([0,1,6]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=t,e.parse=L,e.getFirstFrame=y,e.log=P;function t(o){const w=o;return w&&typeof w.type=="string"&&typeof w.severity=="string"}function L(o){const w=[];let _;try{const f=JSON.parse(o.arguments),c=f[f.length-1];c&&c.__$stack&&(f.pop(),_=c.__$stack),w.push(...f)}catch{w.push("Unable to log remote console arguments",o.arguments)}return{args:w,stack:_}}function y(o){if(typeof o!="string")return y(L(o).stack);const w=o;if(w){const _=W(w),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(f&&f.length===4)return{uri:a.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function W(o){if(!o)return o;const w=o.indexOf(`
`);return w===-1?o:o.substring(0,w)}function P(o,w){const{args:_,stack:f}=L(o),c=typeof _[0]=="string"&&_.length===1;let l=W(f);l&&(l=`(${l.trim()})`);let h=[];if(typeof _[0]=="string"?l&&c?h=[`%c[${w}] %c${_[0]} %c${l}`,v("blue"),v(""),v("grey")]:h=[`%c[${w}] %c${_[0]}`,v("blue"),v(""),..._.slice(1)]:h=[`%c[${w}]%`,v("blue"),..._],l&&!c&&h.push(l),typeof console[o.severity]!="function")throw new Error("Unknown console method");console[o.severity].apply(console,h)}function v(o){return`color: ${o}`}}),define(he[63],fe([0,1,20,6,29]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=y,e.parse=W,e.revive=v;function y(o){return JSON.stringify(o,P)}function W(o){let w=JSON.parse(o);return w=v(w),w}function P(o,w){return w instanceof RegExp?{$mid:L.MarshalledId.Regexp,source:w.source,flags:w.flags}:w}function v(o,w=0){if(!o||w>200)return o;if(typeof o=="object"){switch(o.$mid){case L.MarshalledId.Uri:return t.URI.revive(o);case L.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case L.MarshalledId.Date:return new Date(o.source)}if(o instanceof a.VSBuffer||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let _=0;_<o.length;++_)o[_]=v(o[_],w+1);else for(const _ in o)Object.hasOwnProperty.call(o,_)&&(o[_]=v(o[_],w+1))}return o}}),define(he[21],fe([0,1,7,3,10,6,5]),function(ie,e,a,t,L,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=o,e.getServerRootPath=_,a=De(a),t=De(t),W=De(W);var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(P||(e.Schemas=P={}));function v(l,h){return y.URI.isUri(l)?(0,L.equalsIgnoreCase)(l.scheme,h):(0,L.startsWithIgnoreCase)(l,h+":")}function o(l,...h){return h.some(m=>v(l,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h,m){this._serverRootPath=_(h,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return W.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(h,m,u){this._hosts[h]=m,this._ports[h]=u}setConnectionToken(h,m){this._connectionTokens[h]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(s){return a.onUnexpectedError(s),h}const m=h.authority;let u=this._hosts[m];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const r=this._ports[m],p=this._connectionTokens[m];let b=`path=${encodeURIComponent(h.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),y.URI.from({scheme:t.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${u}:${r}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new w;function _(l,h){return W.posix.join(h??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class f{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const m=this.toUri(h,ie);return this.uriToBrowserUri(m)}uriToBrowserUri(h){return h.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===P.file&&(t.isNative||t.webWorkerOrigin===`${P.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?h.with({scheme:P.vscodeFileResource,authority:h.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const m=this.toUri(h,ie);return this.uriToFileUri(m)}uriToFileUri(h){return h.scheme===P.vscodeFileResource?h.with({scheme:P.file,authority:h.authority!==f.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,m){return y.URI.isUri(h)?h:y.URI.parse(m.toUrl(h))}}e.FileAccess=new f;var c;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const m="vscode-coi";function u(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:y.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const s=b?.get(m);if(s)return h.get(s)}l.getHeadersFromQuery=u;function r(p,b,s){if(!globalThis.crossOriginIsolated)return;const i=b&&s?"3":s?"2":"1";p instanceof URLSearchParams?p.set(m,i):p[m]=i}l.addSearchParam=r})(c||(e.COI=c={}))}),define(he[26],fe([0,1,14,35,21,5,3,10,6]),function(ie,e,a,t,L,y,W,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=o,e.distinctParents=_,e.toLocalResource=c,t=De(t),y=De(y);function o(l){return(0,v.uriToFsPath)(l,!0)}class w{constructor(h){this._ignorePathCasing=h}compare(h,m,u=!1){return h===m?0:(0,P.compare)(this.getComparisonKey(h,u),this.getComparisonKey(m,u))}isEqual(h,m,u=!1){return h===m?!0:!h||!m?!1:this.getComparisonKey(h,u)===this.getComparisonKey(m,u)}getComparisonKey(h,m=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,m,u=!1){if(h.scheme===m.scheme){if(h.scheme===L.Schemas.file)return t.isEqualOrParent(o(h),o(m),this._ignorePathCasing(h))&&h.query===m.query&&(u||h.fragment===m.fragment);if((0,e.isEqualAuthority)(h.authority,m.authority))return t.isEqualOrParent(h.path,m.path,this._ignorePathCasing(h),"/")&&h.query===m.query&&(u||h.fragment===m.fragment)}return!1}joinPath(h,...m){return v.URI.joinPath(h,...m)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let m;return h.scheme===L.Schemas.file?m=v.URI.file(y.dirname(o(h))).path:(m=y.posix.dirname(h.path),h.authority&&m.length&&m.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),m="/")),h.with({path:m})}normalizePath(h){if(!h.path.length)return h;let m;return h.scheme===L.Schemas.file?m=v.URI.file(y.normalize(o(h))).path:m=y.posix.normalize(h.path),h.with({path:m})}relativePath(h,m){if(h.scheme!==m.scheme||!(0,e.isEqualAuthority)(h.authority,m.authority))return;if(h.scheme===L.Schemas.file){const p=y.relative(o(h),o(m));return W.isWindows?t.toSlashes(p):p}let u=h.path||"/";const r=m.path||"/";if(this._ignorePathCasing(h)){let p=0;for(const b=Math.min(u.length,r.length);p<b&&!(u.charCodeAt(p)!==r.charCodeAt(p)&&u.charAt(p).toLowerCase()!==r.charAt(p).toLowerCase());p++);u=r.substr(0,p)+u.substr(p)}return y.posix.relative(u,r)}resolvePath(h,m){if(h.scheme===L.Schemas.file){const u=v.URI.file(y.resolve(o(h),m));return h.with({authority:u.authority,path:u.path})}return m=t.toPosixPath(m),h.with({path:y.posix.resolve(h.path,m)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,m){return h===m||h!==void 0&&m!==void 0&&(0,P.equalsIgnoreCase)(h,m)}hasTrailingPathSeparator(h,m=y.sep){if(h.scheme===L.Schemas.file){const u=o(h);return u.length>t.getRoot(u).length&&u[u.length-1]===m}else{const u=h.path;return u.length>1&&u.charCodeAt(u.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,m=y.sep){return(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,m=y.sep){let u=!1;if(h.scheme===L.Schemas.file){const r=o(h);u=r!==void 0&&r.length===t.getRoot(r).length&&r[r.length-1]===m}else{m="/";const r=h.path;u=r.length===1&&r.charCodeAt(r.length-1)===a.CharCode.Slash}return!u&&!(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(l=>l.scheme===L.Schemas.file?!W.isLinux:!0),e.extUriIgnorePathCase=new w(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function _(l,h){const m=[];for(let u=0;u<l.length;u++){const r=h(l[u]);l.some((p,b)=>b===u?!1:(0,e.isEqualOrParent)(r,h(p)))||m.push(l[u])}return m}var f;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function h(m){const u=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[s,i]=b.split(":");s&&i&&u.set(s,i)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&u.set(l.META_DATA_MIME,p),u}l.parseMetaData=h})(f||(e.DataUri=f={}));function c(l,h,m){if(h){let u=l.path;return u&&u[0]!==y.posix.sep&&(u=y.posix.sep+u),l.with({scheme:m,authority:h,path:u})}return l.with({scheme:m})}}),define(he[12],fe([0,1,19,7,4,2,26,3,52,25]),function(ie,e,a,t,L,y,W,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=w,e.createCancelablePromise=_,e.raceCancellation=f,e.raceCancellationError=c,e.raceCancellablePromises=l,e.raceTimeout=h,e.asPromise=m,e.promiseWithResolvers=u,e.timeout=E,e.disposableTimeout=D,e.sequence=I,e.first=x,e.firstParallel=z,e.retry=F,e.createCancelableAsyncIterable=N;function w(j){return!!j&&typeof j.then=="function"}function _(j){const T=new a.CancellationTokenSource,X=j(T.token),ne=new Promise((oe,pe)=>{const we=T.token.onCancellationRequested(()=>{we.dispose(),pe(new t.CancellationError)});Promise.resolve(X).then(me=>{we.dispose(),T.dispose(),oe(me)},me=>{we.dispose(),T.dispose(),pe(me)})});return new class{cancel(){T.cancel(),T.dispose()}then(oe,pe){return ne.then(oe,pe)}catch(oe){return this.then(void 0,oe)}finally(oe){return ne.finally(oe)}}}function f(j,T,X){return new Promise((ne,oe)=>{const pe=T.onCancellationRequested(()=>{pe.dispose(),ne(X)});j.then(ne,oe).finally(()=>pe.dispose())})}function c(j,T){return new Promise((X,ne)=>{const oe=T.onCancellationRequested(()=>{oe.dispose(),ne(new t.CancellationError)});j.then(X,ne).finally(()=>oe.dispose())})}async function l(j){let T=-1;const X=j.map((ne,oe)=>ne.then(pe=>(T=oe,pe)));try{return await Promise.race(X)}finally{j.forEach((ne,oe)=>{oe!==T&&ne.cancel()})}}function h(j,T,X){let ne;const oe=setTimeout(()=>{ne?.(void 0),X?.()},T);return Promise.race([j.finally(()=>clearTimeout(oe)),new Promise(pe=>ne=pe)])}function m(j){return new Promise((T,X)=>{const ne=j();w(ne)?ne.then(T,X):T(ne)})}function u(){let j,T;return{promise:new Promise((ne,oe)=>{j=ne,T=oe}),resolve:j,reject:T}}class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const X=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ne=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ne};this.queuedPromise=new Promise(ne=>{this.activePromise.then(X,X).then(ne)})}return new Promise((X,ne)=>{this.queuedPromise.then(X,ne)})}return this.activePromise=T(),new Promise((X,ne)=>{this.activePromise.then(oe=>{this.activePromise=null,X(oe)},oe=>{this.activePromise=null,ne(oe)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class p{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=p;class b{constructor(){this.promiseMap=new Map}queue(T,X){const oe=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get(T)===oe&&this.promiseMap.delete(T)});return this.promiseMap.set(T,oe),oe}}e.SequencerByKey=b;const s=(j,T)=>{let X=!0;const ne=setTimeout(()=>{X=!1,T()},j);return{isTriggered:()=>X,dispose:()=>{clearTimeout(ne),X=!1}}},i=j=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,j())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class n{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,X=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((oe,pe)=>{this.doResolve=oe,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const oe=this.task;return this.task=null,oe()}}));const ne=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=X===v.MicrotaskDelay?i(ne):s(X,ne),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class S{constructor(T){this.delayer=new n(T),this.throttler=new r}trigger(T,X){return this.delayer.trigger(()=>this.throttler.queue(T),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=S;class A{constructor(){this._isOpen=!1,this._promise=new Promise((T,X)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=A;class O extends A{constructor(T){super(),this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=O;function E(j,T){return T?new Promise((X,ne)=>{const oe=setTimeout(()=>{pe.dispose(),X()},j),pe=T.onCancellationRequested(()=>{clearTimeout(oe),pe.dispose(),ne(new t.CancellationError)})}):_(X=>E(j,X))}function D(j,T=0,X){const ne=setTimeout(()=>{j(),X&&oe.dispose()},T),oe=(0,y.toDisposable)(()=>{clearTimeout(ne),X?.deleteAndLeak(oe)});return X?.add(oe),oe}function I(j){const T=[];let X=0;const ne=j.length;function oe(){return X<ne?j[X++]():null}function pe(we){we!=null&&T.push(we);const me=oe();return me?me.then(pe):Promise.resolve(T)}return Promise.resolve(null).then(pe)}function x(j,T=ne=>!!ne,X=null){let ne=0;const oe=j.length,pe=()=>{if(ne>=oe)return Promise.resolve(X);const we=j[ne++];return Promise.resolve(we()).then(de=>T(de)?Promise.resolve(de):pe())};return pe()}function z(j,T=ne=>!!ne,X=null){if(j.length===0)return Promise.resolve(X);let ne=j.length;const oe=()=>{ne=-1;for(const pe of j)pe.cancel?.()};return new Promise((pe,we)=>{for(const me of j)me.then(de=>{--ne>=0&&T(de)?(oe(),pe(de)):ne===0&&pe(X)}).catch(de=>{--ne>=0&&(oe(),we(de))})})}class k{constructor(T){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(T){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((X,ne)=>{this.outstandingPromises.push({factory:T,c:X,e:ne}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const X=T.factory();X.then(T.c,T.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=k;class g extends k{constructor(){super(1)}}e.Queue=g;class M{constructor(){this.sequentializer=new Y,this.tasks=0}queue(T){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,T())):this.sequentializer.run(this.tasks++,T())}}e.LimitedQueue=M;class R{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const T=new $;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueSize(T,X=W.extUri){const ne=X.getComparisonKey(T);return this.queues.get(ne)?.size??0}queueFor(T,X,ne=W.extUri){const oe=ne.getComparisonKey(T);let pe=this.queues.get(oe);if(!pe){pe=new g;const we=this.drainListenerCount++,me=L.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(oe),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(we),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new y.DisposableMap),this.drainListeners.set(we,me),this.queues.set(oe,pe)}return pe.queue(X)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=R;class C{constructor(T,X){this._isDisposed=!1,this._token=-1,typeof T=="function"&&typeof X=="number"&&this.setIfNotSet(T,X)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,X){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},X)}setIfNotSet(T,X){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},X))}}e.TimeoutTimer=C;class B{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(T,X,ne=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const oe=ne.setInterval(()=>{T()},X);this.disposable=(0,y.toDisposable)(()=>{ne.clearInterval(oe),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=B;class Z{constructor(T,X){this.timeoutToken=-1,this.runner=T,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Z;class G{constructor(T,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=X,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class J extends Z{constructor(T,X){super(T,X),this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner?.(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class se extends y.Disposable{constructor(T,X){super(),this.options=T,this.handler=X,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const X of T)this.pendingWork.push(X);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Z(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(j,T)=>{(0,P.setTimeout0)(()=>{if(X)return;const ne=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ne-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e._runWhenIdle=(j,T,X)=>{const ne=j.requestIdleCallback(T,typeof X=="number"?{timeout:X}:void 0);let oe=!1;return{dispose(){oe||(oe=!0,j.cancelIdleCallback(ne))}}},e.runWhenGlobalIdle=j=>(0,e._runWhenIdle)(globalThis,j)}();class le{constructor(T,X){this._didRun=!1,this._executor=()=>{try{this._value=X()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(T,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=le;class V extends le{constructor(T){super(globalThis,T)}}e.GlobalIdleValue=V;async function F(j,T,X){let ne;for(let oe=0;oe<X;oe++)try{return await j()}catch(pe){ne=pe,await E(T)}throw ne}class Y{isRunning(T){return typeof T=="number"?this._running?.taskId===T:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(T,X,ne){return this._running={taskId:T,cancel:()=>ne?.(),promise:X},X.then(()=>this.doneRunning(T),()=>this.doneRunning(T)),X}doneRunning(T){this._running&&T===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const T=this._queued;this._queued=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this._queued)this._queued.run=T;else{const{promise:X,resolve:ne,reject:oe}=u();this._queued={run:T,promise:X,promiseResolve:ne,promiseReject:oe}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class ee{constructor(T,X=()=>Date.now()){this.interval=T,this.nowFn=X,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var ue;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ue||(ue={}));class ${get isRejected(){return this.outcome?.outcome===ue.Rejected}get isResolved(){return this.outcome?.outcome===ue.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ue.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((T,X)=>{this.completeCallback=T,this.errorCallback=X})}complete(T){return new Promise(X=>{this.completeCallback(T),this.outcome={outcome:ue.Resolved,value:T},X()})}error(T){return new Promise(X=>{this.errorCallback(T),this.outcome={outcome:ue.Rejected,value:T},X()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=$;var ae;(function(j){async function T(ne){let oe;const pe=await Promise.all(ne.map(we=>we.then(me=>me,me=>{oe||(oe=me)})));if(typeof oe<"u")throw oe;return pe}j.settled=T;function X(ne){return new Promise(async(oe,pe)=>{try{await ne(oe,pe)}catch(we){pe(we)}})}j.withAsyncBody=X})(ae||(e.Promises=ae={}));class ge{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(T){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=T.then(X=>(this._value=X,this._isResolved=!0,X),X=>{throw this._error=X,this._isResolved=!0,X})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ge;class te{constructor(T){this._compute=T,this._promise=new o.Lazy(()=>new ge(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=te;var d;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(d||(d={}));class H{static fromArray(T){return new H(X=>{X.emitMany(T)})}static fromPromise(T){return new H(async X=>{X.emitMany(await T)})}static fromPromises(T){return new H(async X=>{await Promise.all(T.map(async ne=>X.emitOne(await ne)))})}static merge(T){return new H(async X=>{await Promise.all(T.map(async ne=>{for await(const oe of ne)X.emitOne(oe)}))})}static{this.EMPTY=H.fromArray([])}constructor(T,X){this._state=d.Initial,this._results=[],this._error=null,this._onReturn=X,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const ne={emitOne:oe=>this.emitOne(oe),emitMany:oe=>this.emitMany(oe),reject:oe=>this.reject(oe)};try{await Promise.resolve(T(ne)),this.resolve()}catch(oe){this.reject(oe)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===d.DoneError)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===d.DoneOK)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(T,X){return new H(async ne=>{for await(const oe of T)ne.emitOne(X(oe))})}map(T){return H.map(this,T)}static filter(T,X){return new H(async ne=>{for await(const oe of T)X(oe)&&ne.emitOne(oe)})}filter(T){return H.filter(this,T)}static coalesce(T){return H.filter(T,X=>!!X)}coalesce(){return H.coalesce(this)}static async toPromise(T){const X=[];for await(const ne of T)X.push(ne);return X}toPromise(){return H.toPromise(this)}emitOne(T){this._state===d.Initial&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===d.Initial&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===d.Initial&&(this._state=d.DoneOK,this._onStateChanged.fire())}reject(T){this._state===d.Initial&&(this._state=d.DoneError,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=H;class U extends H{constructor(T,X){super(X),this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=U;function N(j){const T=new a.CancellationTokenSource,X=j(T.token);return new U(T,async ne=>{const oe=T.token.onCancellationRequested(()=>{oe.dispose(),T.dispose(),ne.reject(new t.CancellationError)});try{for await(const pe of X){if(T.token.isCancellationRequested)return;ne.emitOne(pe)}oe.dispose(),T.dispose()}catch(pe){oe.dispose(),T.dispose(),ne.reject(pe)}})}class K{constructor(T){this._deferred=new $,this._asyncIterable=new H(oe=>{if(X){oe.reject(X);return}return ne&&oe.emitMany(ne),this._errorFn=pe=>oe.reject(pe),this._emitFn=pe=>oe.emitOne(pe),this._deferred.p},T);let X,ne;this._emitFn=oe=>{ne||(ne=[]),ne.push(oe)},this._errorFn=oe=>{X||(X=oe)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(T){this._errorFn(T),this._deferred.complete()}emitOne(T){this._emitFn(T)}}e.AsyncIterableSource=K}),define(he[64],fe([0,1,20,29,6]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=w,e.transformAndReviveIncomingURIs=_;function y(f){return f.toJSON()}class W{constructor(c){this._uriTransformer=c}transformIncoming(c){const l=this._uriTransformer.transformIncoming(c);return l===c?c:y(L.URI.from(l))}transformOutgoing(c){const l=this._uriTransformer.transformOutgoing(c);return l===c?c:y(L.URI.from(l))}transformOutgoingURI(c){const l=this._uriTransformer.transformOutgoing(c);return l===c?c:L.URI.from(l)}transformOutgoingScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}}e.URITransformer=W,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function P(f,c,l){if(!f||l>200)return null;if(typeof f=="object"){if(f instanceof L.URI)return c.transformOutgoing(f);for(const h in f)if(Object.hasOwnProperty.call(f,h)){const m=P(f[h],c,l+1);m!==null&&(f[h]=m)}}return null}function v(f,c){const l=P(f,c,0);return l===null?f:l}function o(f,c,l,h){if(!f||h>200)return null;if(typeof f=="object"){if(f.$mid===t.MarshalledId.Uri)return l?L.URI.revive(c.transformIncoming(f)):c.transformIncoming(f);if(f instanceof a.VSBuffer)return null;for(const m in f)if(Object.hasOwnProperty.call(f,m)){const u=o(f[m],c,l,h+1);u!==null&&(f[m]=u)}}return null}function w(f,c){const l=o(f,c,!1,0);return l===null?f:l}function _(f,c){const l=o(f,c,!0,0);return l===null?f:l}}),define(he[27],fe([0,1,110,22,111,12,35,48,5,3,26,6]),function(ie,e,a,t,L,y,W,P,v,o,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=p,e.whenDeleted=i,e.configureFlushOnWrite=E,e.writeFileSync=I,a=De(a);var f;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function c(G,J=f.UNLINK,se){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return J===f.UNLINK?h(G):l(G,se)}async function l(G,J=(0,W.randomPath)((0,t.tmpdir)())){try{try{await a.promises.rename(G,J)}catch(se){return se.code==="ENOENT"?void 0:h(G)}h(J).catch(se=>{})}catch(se){if(se.code!=="ENOENT")throw se}}async function h(G){return a.promises.rm(G,{recursive:!0,force:!0,maxRetries:3})}function m(G){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function u(G,J){return b(await(J?r(G):a.promises.readdir(G)))}async function r(G){try{return await a.promises.readdir(G,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const J=[],se=await u(G);for(const le of se){let V=!1,F=!1,Y=!1;try{const ee=await e.Promises.lstat((0,v.join)(G,le));V=ee.isFile(),F=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}J.push({name:le,isFile:()=>V,isDirectory:()=>F,isSymbolicLink:()=>Y})}return J}function p(G){return b(a.readdirSync(G))}function b(G){return G.map(J=>typeof J=="string"?o.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=o.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function s(G){const J=await u(G),se=[];for(const le of J)await n.existsDirectory((0,v.join)(G,le))&&se.push(le);return se}function i(G,J=1e3){return new Promise(se=>{let le=!1;const V=setInterval(()=>{le||(le=!0,a.access(G,F=>{le=!1,F&&(clearInterval(V),se(void 0))}))},J)})}var n;(function(G){async function J(V){let F;try{if(F=await e.Promises.lstat(V),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(o.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw ee}throw Y}}G.stat=J;async function se(V){try{const{stat:F,symbolicLink:Y}=await G.stat(V);return F.isFile()&&Y?.dangling!==!0}catch{}return!1}G.existsFile=se;async function le(V){try{const{stat:F,symbolicLink:Y}=await G.stat(V);return F.isDirectory()&&Y?.dangling!==!0}catch{}return!1}G.existsDirectory=le})(n||(e.SymlinkSupport=n={}));const S=new y.ResourceQueue;function A(G,J,se){return S.queueFor(_.URI.file(G),()=>{const le=x(se);return new Promise((V,F)=>D(G,J,le,Y=>Y?F(Y):V()))},w.extUriBiasedIgnorePathCase)}let O=!0;function E(G){O=G}function D(G,J,se,le){if(!O)return a.writeFile(G,J,{mode:se.mode,flag:se.flag},le);a.open(G,se.flag,se.mode,(V,F)=>{if(V)return le(V);a.writeFile(F,J,Y=>{if(Y)return a.close(F,()=>le(Y));a.fdatasync(F,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),E(!1)),a.close(F,ue=>le(ue))))})})}function I(G,J,se){const le=x(se);if(!O)return a.writeFileSync(G,J,{mode:le.mode,flag:le.flag});const V=a.openSync(G,le.flag,le.mode);try{a.writeFileSync(V,J);try{a.fdatasyncSync(V)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),E(!1)}}finally{a.closeSync(V)}}function x(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function z(G,J,se=6e4){if(G!==J)try{o.isWindows&&typeof se=="number"?await k(G,J,Date.now(),se):await a.promises.rename(G,J)}catch(le){if(G.toLowerCase()!==J.toLowerCase()&&le.code==="EXDEV"||G.endsWith("."))await g(G,J,{preserveSymlinks:!1}),await c(G,f.MOVE);else throw le}}async function k(G,J,se,le,V=0){try{return await a.promises.rename(G,J)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-se>=le)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${F}`),F;if(V===0){let Y=!1;try{const{stat:ee}=await n.stat(J);ee.isFile()||(Y=!0)}catch{}if(Y)throw F}return await(0,y.timeout)(Math.min(100,V*10)),k(G,J,se,le,V+1)}}async function g(G,J,se){return R(G,J,{root:{source:G,target:J},options:se,handledSourcePaths:new Set})}const M=511;async function R(G,J,se){if(se.handledSourcePaths.has(G))return;se.handledSourcePaths.add(G);const{stat:le,symbolicLink:V}=await n.stat(G);if(V){if(se.options.preserveSymlinks)try{return await Z(G,J,se)}catch{}if(V.dangling)return}return le.isDirectory()?C(G,J,le.mode&M,se):B(G,J,le.mode&M)}async function C(G,J,se,le){await e.Promises.mkdir(J,{recursive:!0,mode:se});const V=await u(G);for(const F of V)await R((0,v.join)(G,F),(0,v.join)(J,F),le)}async function B(G,J,se){await e.Promises.copyFile(G,J),await e.Promises.chmod(J,se)}async function Z(G,J,se){let le=await e.Promises.readlink(G);(0,W.isEqualOrParent)(le,se.root.source,!o.isLinux)&&(le=(0,v.join)(se.root.target,le.substr(se.root.source.length+1))),await e.Promises.symlink(le,J)}e.Promises=new class{get access(){return a.promises.access}get stat(){return a.promises.stat}get lstat(){return a.promises.lstat}get utimes(){return a.promises.utimes}get read(){return(G,J,se,le,V)=>new Promise((F,Y)=>{a.read(G,J,se,le,V,(ee,ue,$)=>ee?Y(ee):F({bytesRead:ue,buffer:$}))})}get readFile(){return a.promises.readFile}get write(){return(G,J,se,le,V)=>new Promise((F,Y)=>{a.write(G,J,se,le,V,(ee,ue,$)=>ee?Y(ee):F({bytesWritten:ue,buffer:$}))})}get appendFile(){return a.promises.appendFile}get fdatasync(){return(0,L.promisify)(a.fdatasync)}get truncate(){return a.promises.truncate}get copyFile(){return a.promises.copyFile}get open(){return(0,L.promisify)(a.open)}get close(){return(0,L.promisify)(a.close)}get symlink(){return a.promises.symlink}get readlink(){return a.promises.readlink}get chmod(){return a.promises.chmod}get mkdir(){return a.promises.mkdir}get unlink(){return a.promises.unlink}get rmdir(){return a.promises.rmdir}get realpath(){return(0,L.promisify)(a.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return s}get writeFile(){return A}get rm(){return c}get rename(){return z}get copy(){return g}}}),define(he[65],fe([0,1,22,5,27]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=r,e.getFirstAvailablePowerShellInstallation=p,a=De(a),t=De(t),L=De(L);const y=/^\d+$/,W=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var v;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(v||(v={}));let o;switch(process.arch){case"ia32":o=v.x86;break;case"arm":case"arm64":o=v.ARM;break;default:o=v.x64;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=v.x86:w=v.x64;class _{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:b=!1}={}){return b?o===v.x64?process.env["ProgramFiles(x86)"]||null:w===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function c({useAlternateBitness:b=!1,findPreview:s=!1}={}){const i=f({useAlternateBitness:b});if(!i)return null;const n=t.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(n))return null;let S=-1,A=null;for(const D of await L.Promises.readdir(n)){let I=-1;if(s){const z=D.indexOf("-");if(z<0)continue;const k=D.substring(0,z);if(!y.test(k)||D.substring(z+1)!=="preview")continue;I=parseInt(k,10)}else{if(!y.test(D))continue;I=parseInt(D,10)}if(I<=S)continue;const x=t.join(n,D,"pwsh.exe");await L.SymlinkSupport.existsFile(x)&&(A=x,S=I)}if(!A)return null;const O=i.includes("x86")?" (x86)":"",E=s?" Preview":"";return new _(A,`PowerShell${E}${O}`,!0)}async function l({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const s=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=b?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:W,pwshMsixName:"PowerShell (Store)"};for(const S of await L.Promises.readdir(s))if(i.test(S)){const A=t.join(s,S,"pwsh.exe");return new _(A,n)}return null}function h(){const b=t.join(a.homedir(),".dotnet","tools","pwsh.exe");return new _(b,".NET Core PowerShell Global Tool")}function m(){const b=t.join(process.env.windir,o===v.x86&&w!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new _(b,"Windows PowerShell",!0)}async function*u(){let b=await c();b&&(yield b),b=await c({useAlternateBitness:!0}),b&&(yield b),b=await l(),b&&(yield b),b=h(),b&&(yield b),b=await c({findPreview:!0}),b&&(yield b),b=await l({findPreview:!0}),b&&(yield b),b=await c({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=m(),b&&(yield b)}async function*r(){for await(const b of u())await b.exists()&&(yield b)}async function p(){for await(const b of r())return b;return null}}),define(he[37],fe([0,1,5,3,16,36,9,27]),function(ie,e,a,t,L,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=v,e.createQueuedSender=o,a=De(a),t=De(t),L=De(L),W=De(W),P=De(P),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function v(_=L.env){return _.comspec||"cmd.exe"}function o(_){let f=[],c=!1;const l=function(h){if(c){f.push(h);return}(!_.send(h,u=>{if(u&&console.error(u),c=!1,f.length>0){const r=f.slice(0);f=[],r.forEach(p=>l(p))}})||t.isWindows)&&(c=!0)};return{send:l}}var w;(function(_){async function f(c,l,h){if(a.isAbsolute(c))return c;if(l===void 0&&(l=L.cwd()),a.dirname(c)!=="."||(h===void 0&&W.isString(L.env.PATH)&&(h=L.env.PATH.split(a.delimiter)),h===void 0||h.length===0))return a.join(l,c);async function u(r){if(await P.Promises.exists(r)){let p;try{p=await P.Promises.stat(r)}catch(b){b.message.startsWith("EACCES")&&(p=await P.Promises.lstat(r))}return p?!p.isDirectory():!1}return!1}for(const r of h){let p;if(a.isAbsolute(r)?p=a.join(r,c):p=a.join(l,r,c),await u(p))return p;let b=p+".com";if(await u(b)||(b=p+".exe",await u(b)))return b}return a.join(l,c)}_.findExecutable=f})(w||(e.win32=w={}))}),define(he[66],fe([0,1,30,21]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=L;function L(W){return new Promise((P,v)=>{let o;const w=new Map;function _(c,l,h,m,u){const r=w.get(l);if(c===W||r){const p={name:f(h),cmd:h,pid:c,ppid:l,load:m,mem:u};w.set(c,p),c===W&&(o=p),r&&(r.children||(r.children=[]),r.children.push(p),r.children.length>1&&(r.children=r.children.sort((b,s)=>b.pid-s.pid)))}}function f(c){const l=/--utility-sub-type=network/i,h=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,r=/--type=([a-zA-Z-]+)/;if(h.exec(c))return"electron-crash-reporter";if(m.exec(c))return"winpty-agent";if(u.exec(c))return"conpty-agent";let p=r.exec(c);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?l.exec(c)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const b=/[a-zA-Z-]+\.js/g;let s="";do p=b.exec(c),p&&(s+=p+" ");while(p);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:c}if(process.platform==="win32"){const c=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,h)=>{ie(["@vscode/windows-process-tree"],l,h)}).then(De).then(l=>{l.getProcessList(W,h=>{if(!h){v(new Error(`Root process ${W} not found`));return}l.getProcessCpuUsage(h,m=>{const u=new Map;m.forEach(r=>{const p=c(r.commandLine||"");u.set(r.pid,{name:f(p),cmd:p,pid:r.pid,ppid:r.ppid,load:r.cpu||0,mem:r.memory||0})}),o=u.get(W),o?(u.forEach(r=>{const p=u.get(r.ppid);p&&(p.children||(p.children=[]),p.children.push(r))}),u.forEach(r=>{r.children&&(r.children=r.children.sort((p,b)=>p.pid-b.pid))}),P(o)):v(new Error(`Root process ${W} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let c=function(){let l=[o];const h=[];for(;l.length;){const u=l.shift();u&&(h.push(u.pid),u.children&&(l=l.concat(u.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+h.join(" "),(0,a.exec)(m,{},(u,r,p)=>{if(u||p)v(u||new Error(p.toString()));else{const b=r.toString().split(`
`);for(let s=0;s<h.length;s++){const i=w.get(h[s]);i.load=parseFloat(b[s])}if(!o){v(new Error(`Root process ${W} not found`));return}P(o)}})};(0,a.exec)("which ps",{},(l,h,m)=>{if(l||m)if(process.platform!=="linux")v(l||new Error(m.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,a.exec)(u,{},(r,p,b)=>{r||b?v(r||new Error(b.toString())):(y(p,_),c())})}else{const u=h.toString().trim();(0,a.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,b,s)=>{p||s&&!s.includes("screen size is bogus")?v(p||new Error(s.toString())):(y(b,_),process.platform==="linux"?c():o?P(o):v(new Error(`Root process ${W} not found`)))})}})}})}function y(W,P){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,o=W.toString().split(`
`);for(const w of o){const _=v.exec(w.trim());_&&_.length===6&&P(parseInt(_[1]),parseInt(_[2]),_[5],parseFloat(_[3]),parseFloat(_[4]))}}}),define(he[67],fe([0,1,22,3,65,37]),function(ie,e,a,t,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=W,t=De(t),y=De(y);async function W(_,f){return _===t.OperatingSystem.Windows?t.isWindows?w():y.getWindowsShell(f):v(_,f)}let P=null;function v(_,f){if(t.isLinux&&_===t.OperatingSystem.Macintosh||t.isMacintosh&&_===t.OperatingSystem.Linux)return"/bin/bash";if(!P){let c;if(t.isWindows)c="/bin/bash";else{if(c=f.SHELL,!c)try{c=(0,a.userInfo)().shell}catch{}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}P=c}return P}let o=null;async function w(){return o||(o=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),o}});var _e=this&&this.__decorate||function(ie,e,a,t){var L=arguments.length,y=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,W;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(ie,e,a,t);else for(var P=ie.length-1;P>=0;P--)(W=ie[P])&&(y=(L<3?W(y):L>3?W(e,a,y):W(e,a))||y);return L>3&&y&&Object.defineProperty(e,a,y),y};define(he[31],fe([0,1,18,12,20,19,15,7,4,2,63,10,9]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=E,e.deserialize=D,e.getDelayedChannel=M,e.getNextTickChannel=R,_=De(_);var c;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(c||(c={}));function l(V){switch(V){case c.Promise:return"req";case c.PromiseCancel:return"cancel";case c.EventListen:return"subscribe";case c.EventDispose:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h||(h={}));function m(V){switch(V){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function r(V){let F=0;for(let Y=0;;Y+=7){const ee=V.read(1);if(F|=(ee.buffer[0]&127)<<Y,!(ee.buffer[0]&128))return F}}const p=S(0);function b(V,F){if(F===0){V.write(p);return}let Y=0;for(let ue=F;ue!==0;ue=ue>>>7)Y++;const ee=L.VSBuffer.alloc(Y);for(let ue=0;F!==0;ue++)ee.buffer[ue]=F&127,F=F>>>7,F>0&&(ee.buffer[ue]|=128);V.write(ee)}class s{constructor(F){this.buffer=F,this.pos=0}read(F){const Y=this.buffer.slice(this.pos,this.pos+F);return this.pos+=Y.byteLength,Y}}e.BufferReader=s;class i{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}e.BufferWriter=i;var n;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(n||(n={}));function S(V){const F=L.VSBuffer.alloc(1);return F.writeUInt8(V,0),F}const A={Undefined:S(n.Undefined),String:S(n.String),Buffer:S(n.Buffer),VSBuffer:S(n.VSBuffer),Array:S(n.Array),Object:S(n.Object),Uint:S(n.Int)},O=typeof Buffer<"u";function E(V,F){if(typeof F>"u")V.write(A.Undefined);else if(typeof F=="string"){const Y=L.VSBuffer.fromString(F);V.write(A.String),b(V,Y.byteLength),V.write(Y)}else if(O&&Buffer.isBuffer(F)){const Y=L.VSBuffer.wrap(F);V.write(A.Buffer),b(V,Y.byteLength),V.write(Y)}else if(F instanceof L.VSBuffer)V.write(A.VSBuffer),b(V,F.byteLength),V.write(F);else if(Array.isArray(F)){V.write(A.Array),b(V,F.length);for(const Y of F)E(V,Y)}else if(typeof F=="number"&&(F|0)===F)V.write(A.Uint),b(V,F);else{const Y=L.VSBuffer.fromString(JSON.stringify(F));V.write(A.Object),b(V,Y.byteLength),V.write(Y)}}function D(V){switch(V.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return V.read(r(V)).toString();case n.Buffer:return V.read(r(V)).buffer;case n.VSBuffer:return V.read(r(V));case n.Array:{const Y=r(V),ee=[];for(let ue=0;ue<Y;ue++)ee.push(D(V));return ee}case n.Object:return JSON.parse(V.read(r(V)).toString());case n.Int:return r(V)}}class I{constructor(F,Y,ee=null,ue=1e3){this.protocol=F,this.ctx=Y,this.logger=ee,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:h.Initialize})}registerChannel(F,Y){this.channels.set(F,Y),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case h.Initialize:{const Y=this.send([F.type]);this.logger?.logOutgoing(Y,0,x.OtherSide,m(F.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const Y=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(Y,F.id,x.OtherSide,m(F.type),F.data);return}}}send(F,Y=void 0){const ee=new i;return E(ee,F),E(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const Y=new s(F),ee=D(Y),ue=D(Y),$=ee[0];switch($){case c.Promise:return this.logger?.logIncoming(F.byteLength,ee[1],x.OtherSide,`${l($)}: ${ee[2]}.${ee[3]}`,ue),this.onPromise({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case c.EventListen:return this.logger?.logIncoming(F.byteLength,ee[1],x.OtherSide,`${l($)}: ${ee[2]}.${ee[3]}`,ue),this.onEventListen({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case c.PromiseCancel:return this.logger?.logIncoming(F.byteLength,ee[1],x.OtherSide,`${l($)}`),this.disposeActiveRequest({type:$,id:ee[1]});case c.EventDispose:return this.logger?.logIncoming(F.byteLength,ee[1],x.OtherSide,`${l($)}`),this.disposeActiveRequest({type:$,id:ee[1]})}}onPromise(F){const Y=this.channels.get(F.channelName);if(!Y){this.collectPendingRequest(F);return}const ee=new y.CancellationTokenSource;let ue;try{ue=Y.call(this.ctx,F.name,F.arg,ee.token)}catch(ge){ue=Promise.reject(ge)}const $=F.id;ue.then(ge=>{this.sendResponse({id:$,data:ge,type:h.PromiseSuccess})},ge=>{ge instanceof Error?this.sendResponse({id:$,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:h.PromiseError}):this.sendResponse({id:$,data:ge,type:h.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.activeRequests.delete(F.id)});const ae=(0,o.toDisposable)(()=>ee.cancel());this.activeRequests.set(F.id,ae)}onEventListen(F){const Y=this.channels.get(F.channelName);if(!Y){this.collectPendingRequest(F);return}const ee=F.id,$=Y.listen(this.ctx,F.name,F.arg)(ae=>this.sendResponse({id:ee,data:ae,type:h.EventFire}));this.activeRequests.set(F.id,$)}disposeActiveRequest(F){const Y=this.activeRequests.get(F.id);Y&&(Y.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let Y=this.pendingRequests.get(F.channelName);Y||(Y=[],this.pendingRequests.set(F.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===c.Promise&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:h.PromiseError})},this.timeoutDelay);Y.push({request:F,timeoutTimer:ee})}flushPendingRequests(F){const Y=this.pendingRequests.get(F);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case c.Promise:this.onPromise(ee.request);break;case c.EventListen:this.onEventListen(ee.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,o.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=I;var x;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(x||(e.RequestInitiator=x={}));class z{constructor(F,Y=null){this.protocol=F,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=Y}getChannel(F){const Y=this;return{call(ee,ue,$){return Y.isDisposed?Promise.reject(new P.CancellationError):Y.requestPromise(F,ee,ue,$)},listen(ee,ue){return Y.isDisposed?v.Event.None:Y.requestEvent(F,ee,ue)}}}requestPromise(F,Y,ee,ue=y.CancellationToken.None){const $=this.lastRequestId++,ae=c.Promise,ge={id:$,type:ae,channelName:F,name:Y,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new P.CancellationError);let te;return new Promise((H,U)=>{if(ue.isCancellationRequested)return U(new P.CancellationError);const N=()=>{const X=ne=>{switch(ne.type){case h.PromiseSuccess:this.handlers.delete($),H(ne.data);break;case h.PromiseError:{this.handlers.delete($);const oe=new Error(ne.data.message);oe.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,oe.name=ne.data.name,U(oe);break}case h.PromiseErrorObj:this.handlers.delete($),U(ne.data);break}};this.handlers.set($,X),this.sendRequest(ge)};let K=null;this.state===u.Idle?N():(K=(0,t.createCancelablePromise)(X=>this.whenInitialized()),K.then(()=>{K=null,N()}));const j=()=>{K?(K.cancel(),K=null):this.sendRequest({id:$,type:c.PromiseCancel}),U(new P.CancellationError)},T=ue.onCancellationRequested(j);te=(0,o.combinedDisposable)((0,o.toDisposable)(j),T),this.activeRequests.add(te)}).finally(()=>{te.dispose(),this.activeRequests.delete(te)})}requestEvent(F,Y,ee){const ue=this.lastRequestId++,$=c.EventListen,ae={id:ue,type:$,channelName:F,name:Y,arg:ee};let ge=null;const te=new v.Emitter({onWillAddFirstListener:()=>{ge=(0,t.createCancelablePromise)(H=>this.whenInitialized()),ge.then(()=>{ge=null,this.activeRequests.add(te),this.sendRequest(ae)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.activeRequests.delete(te),this.sendRequest({id:ue,type:c.EventDispose}))}}),d=H=>te.fire(H.data);return this.handlers.set(ue,d),te.event}sendRequest(F){switch(F.type){case c.Promise:case c.EventListen:{const Y=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(Y,F.id,x.LocalSide,`${l(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case c.PromiseCancel:case c.EventDispose:{const Y=this.send([F.type,F.id]);this.logger?.logOutgoing(Y,F.id,x.LocalSide,l(F.type));return}}}send(F,Y=void 0){const ee=new i;return E(ee,F),E(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const Y=new s(F),ee=D(Y),ue=D(Y),$=ee[0];switch($){case h.Initialize:return this.logger?.logIncoming(F.byteLength,0,x.LocalSide,m($)),this.onResponse({type:ee[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.logger?.logIncoming(F.byteLength,ee[1],x.LocalSide,m($),ue),this.onResponse({type:ee[0],id:ee[1],data:ue})}}onResponse(F){if(F.type===h.Initialize){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,o.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=z,_e([W.memoize],z.prototype,"onDidInitializePromise",null);class k{get connections(){const F=[];return this._connections.forEach(Y=>F.push(Y)),F}constructor(F,Y,ee){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new o.DisposableStore,this.disposables.add(F(({protocol:ue,onDidClientDisconnect:$})=>{const ae=v.Event.once(ue.onMessage);this.disposables.add(ae(ge=>{const te=new s(ge),d=D(te),H=new I(ue,d,Y,ee),U=new z(ue,Y);this.channels.forEach((K,j)=>H.registerChannel(j,K));const N={channelServer:H,channelClient:U,ctx:d};this._connections.add(N),this._onDidAddConnection.fire(N),this.disposables.add($(()=>{H.dispose(),U.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)}))}))}))}getChannel(F,Y){const ee=this;return{call(ue,$,ae){let ge;if((0,f.isFunction)(Y)){const d=(0,a.getRandomElement)(ee.connections.filter(Y));ge=d?Promise.resolve(d):v.Event.toPromise(v.Event.filter(ee.onDidAddConnection,Y))}else ge=Y.routeCall(ee,ue,$);const te=ge.then(d=>d.channelClient.getChannel(F));return M(te).call(ue,$,ae)},listen(ue,$){if((0,f.isFunction)(Y))return ee.getMulticastEvent(F,Y,ue,$);const ae=Y.routeEvent(ee,ue,$).then(ge=>ge.channelClient.getChannel(F));return M(ae).listen(ue,$)}}}getMulticastEvent(F,Y,ee,ue){const $=this;let ae;const ge=new v.Emitter({onWillAddFirstListener:()=>{ae=new o.DisposableStore;const te=new v.EventMultiplexer,d=new Map,H=N=>{const j=N.channelClient.getChannel(F).listen(ee,ue),T=te.add(j);d.set(N,T)},U=N=>{const K=d.get(N);K&&(K.dispose(),d.delete(N))};$.connections.filter(Y).forEach(H),v.Event.filter($.onDidAddConnection,Y)(H,void 0,ae),$.onDidRemoveConnection(U,void 0,ae),te.event(ge.fire,ge,ae),ae.add(te)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return ge.event}registerChannel(F,Y){this.channels.set(F,Y);for(const ee of this._connections)ee.channelServer.registerChannel(F,Y)}dispose(){this.disposables.dispose();for(const F of this._connections)F.channelClient.dispose(),F.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class g{constructor(F,Y,ee=null){const ue=new i;E(ue,Y),F.send(ue.buffer),this.channelClient=new z(F,ee),this.channelServer=new I(F,Y,ee)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,Y){this.channelServer.registerChannel(F,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=g;function M(V){return{call(F,Y,ee){return V.then(ue=>ue.call(F,Y,ee))},listen(F,Y){const ee=new v.Relay;return V.then(ue=>ee.input=ue.listen(F,Y)),ee.event}}}function R(V){let F=!1;return{call(Y,ee,ue){return F?V.call(Y,ee,ue):(0,t.timeout)(0).then(()=>F=!0).then(()=>V.call(Y,ee,ue))},listen(Y,ee){if(F)return V.listen(Y,ee);const ue=new v.Relay;return(0,t.timeout)(0).then(()=>F=!0).then(()=>ue.input=V.listen(Y,ee)),ue.event}}}class C{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const Y of F.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await v.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=C;var B;(function(V){function F($,ae,ge){const te=$,d=ge&&ge.disableMarshalling,H=new Map;for(const U in te)ee(U)&&H.set(U,v.Event.buffer(te[U],!0,void 0,ae));return new class{listen(U,N,K){const j=H.get(N);if(j)return j;const T=te[N];if(typeof T=="function"){if(ue(N))return T.call(te,K);if(ee(N))return H.set(N,v.Event.buffer(te[N],!0,void 0,ae)),H.get(N)}throw new P.ErrorNoTelemetry(`Event not found: ${N}`)}call(U,N,K){const j=te[N];if(typeof j=="function"){if(!d&&Array.isArray(K))for(let X=0;X<K.length;X++)K[X]=(0,w.revive)(K[X]);let T=j.apply(te,K);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new P.ErrorNoTelemetry(`Method not found: ${N}`)}}}V.fromService=F;function Y($,ae){const ge=ae&&ae.disableMarshalling;return new Proxy({},{get(te,d){if(typeof d=="string")return ae?.properties?.has(d)?ae.properties.get(d):ue(d)?function(H){return $.listen(d,H)}:ee(d)?$.listen(d):async function(...H){let U;ae&&!(0,f.isUndefinedOrNull)(ae.context)?U=[ae.context,...H]:U=H;const N=await $.call(d,U);return ge?N:(0,w.revive)(N)};throw new P.ErrorNoTelemetry(`Property not found: ${String(d)}`)}})}V.toService=Y;function ee($){return $[0]==="o"&&$[1]==="n"&&_.isUpperAsciiLetter($.charCodeAt(2))}function ue($){return/^onDynamic/.test($)&&_.isUpperAsciiLetter($.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const F=V.toString();if(F!=="[object Object]")return F}return V}function J(V){return Array.isArray(V)?V.map(G):G(V)}function se(V,F,Y,ee,ue,$,ae){ae=J(ae);const ge=Z[ue],te=ge[ee%ge.length];let d=[`%c[${V}]%c[${String(F).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test($)?(d=d.concat(ae),d.push(")")):d.push(ae),console.log.apply(console,d)}class le{constructor(F,Y){this._outgoingPrefix=F,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,Y,ee,ue,$){this._totalOutgoing+=F,se(this._outgoingPrefix,this._totalOutgoing,F,Y,ee,ue,$)}logIncoming(F,Y,ee,ue,$){this._totalIncoming+=F,se(this._incomingPrefix,this._totalIncoming,F,Y,ee,ue,$)}}e.IPCLogger=le}),define(he[68],fe([0,1,30,12,20,19,62,7,4,2,33,37,36,31]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,P=De(P);class l extends c.ChannelServer{constructor(u){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",r=>L.VSBuffer.wrap(Buffer.from(r,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=l;class h{constructor(u,r){this.modulePath=u,this.options=r,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=r&&r.timeout?r.timeout:6e4;this.disposeDelayer=new t.Delayer(p),this.child=null,this._client=null}getChannel(u){const r=this;return{call(p,b,s){return r.requestPromise(u,p,b,s)},listen(p,b){return r.requestEvent(u,p,b)}}}requestPromise(u,r,p,b=y.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(u),i=(0,t.createCancelablePromise)(A=>s.call(r,p,A)),n=b.onCancellationRequested(()=>i.cancel()),S=(0,o.toDisposable)(()=>i.cancel());return this.activeRequests.add(S),i.finally(()=>{n.dispose(),this.activeRequests.delete(S),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(u,r,p){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let b;const s=new v.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(u).listen(r,p)(s.fire,s),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],r=Object.create(null);r.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(r.env={...r.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(r.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,f.removeDangerousEnvVariables)(r.env),this.child=(0,a.fork)(this.modulePath,u,r);const p=new v.Emitter,s=v.Event.fromNodeEventEmitter(this.child,"message",E=>E)(E=>{if((0,W.isRemoteConsoleLog)(E)){(0,W.log)(E,`IPC Library: ${this.options.serverName}`);return}p.fire(L.VSBuffer.wrap(Buffer.from(E,"base64")))}),i=this.options.useQueue?(0,_.createQueuedSender)(this.child):this.child,n=E=>this.child&&this.child.connected&&i.send(E.buffer.toString("base64")),S=p.event,A={send:n,onMessage:S};this._client=new c.ChannelClient(A);const O=()=>this.disposeClient();process.once("exit",O),this.child.on("error",E=>console.warn('IPC "'+this.options.serverName+'" errored with '+E)),this.child.on("exit",(E,D)=>{process.removeListener("exit",O),s.dispose(),this.activeRequests.forEach(I=>(0,o.dispose)(I)),this.activeRequests.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+E+" and signal "+D),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:E,signal:D})})}return this._client}getCachedChannel(u){let r=this.channels.get(u);return r||(r=this.client.getChannel(u),this.channels.set(u,r)),r}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(he[69],fe([0,1,34,20,31,4,9,18]),function(ie,e,a,t,L,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=w;class v{constructor(f){this.port=f,this.onMessage=y.Event.fromNodeEventEmitter(this.port,"message",c=>c.data?t.VSBuffer.wrap(c.data):t.VSBuffer.alloc(0)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}class o extends L.IPCServer{static getOnDidClientConnect(f){(0,W.assertType)((0,a.isUtilityProcess)(process),"Electron Utility Process");const c=new y.Emitter;return process.parentPort.on("message",l=>{if(f?.handledClientConnection(l))return;const h=(0,P.firstOrDefault)(l.ports);h&&c.fire(h)}),y.Event.map(c.event,l=>({protocol:new v(l),onDidClientDisconnect:y.Event.fromNodeEventEmitter(l,"close")}))}constructor(f){super(o.getOnDidClientConnect(f))}}e.Server=o;function w(_,f,c){const l=h=>{h.data===f&&(_.removeListener("message",l),c())};_.on("message",l)}}),define(he[70],fe([13,11]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(he[71],fe([13,11]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(he[72],fe([13,11]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(he[73],fe([13,11]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(he[74],fe([13,11]),function(ie,e){return ie.create("vs/platform/log/common/log",e)}),define(he[75],fe([13,11]),function(ie,e){return ie.create("vs/platform/terminal/node/ptyService",e)}),define(he[76],fe([13,11]),function(ie,e){return ie.create("vs/platform/terminal/node/terminalProcess",e)}),define(he[77],fe([0,1,14,7,71]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var y;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(y||(e.TokenType=y={}));function W(...w){switch(w.length){case 1:return(0,L.localize)(0,null,w[0]);case 2:return(0,L.localize)(1,null,w[0],w[1]);case 3:return(0,L.localize)(2,null,w[0],w[1],w[2]);default:return}}const P=(0,L.localize)(3,null),v=(0,L.localize)(4,null);class o{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(_){switch(_.type){case y.LParen:return"(";case y.RParen:return")";case y.Neg:return"!";case y.Eq:return _.isTripleEq?"===":"==";case y.NotEq:return _.isTripleEq?"!==":"!=";case y.Lt:return"<";case y.LtEq:return"<=";case y.Gt:return">=";case y.GtEq:return">=";case y.RegexOp:return"=~";case y.RegexStr:return _.lexeme;case y.True:return"true";case y.False:return"false";case y.In:return"in";case y.Not:return"not";case y.And:return"&&";case y.Or:return"||";case y.Str:return _.lexeme;case y.QuotedStr:return _.lexeme;case y.Error:return _.lexeme;case y.EOF:return"EOF";default:throw(0,t.illegalState)(`unhandled token type: ${JSON.stringify(_)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(_=>_.charCodeAt(0)))}static{this._keywords=new Map([["not",y.Not],["in",y.In],["false",y.False],["true",y.True]])}get errors(){return this._errors}reset(_){return this._input=_,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case a.CharCode.OpenParen:this._addToken(y.LParen);break;case a.CharCode.CloseParen:this._addToken(y.RParen);break;case a.CharCode.ExclamationMark:if(this._match(a.CharCode.Equals)){const f=this._match(a.CharCode.Equals);this._tokens.push({type:y.NotEq,offset:this._start,isTripleEq:f})}else this._addToken(y.Neg);break;case a.CharCode.SingleQuote:this._quotedString();break;case a.CharCode.Slash:this._regex();break;case a.CharCode.Equals:if(this._match(a.CharCode.Equals)){const f=this._match(a.CharCode.Equals);this._tokens.push({type:y.Eq,offset:this._start,isTripleEq:f})}else this._match(a.CharCode.Tilde)?this._addToken(y.RegexOp):this._error(W("==","=~"));break;case a.CharCode.LessThan:this._addToken(this._match(a.CharCode.Equals)?y.LtEq:y.Lt);break;case a.CharCode.GreaterThan:this._addToken(this._match(a.CharCode.Equals)?y.GtEq:y.Gt);break;case a.CharCode.Ampersand:this._match(a.CharCode.Ampersand)?this._addToken(y.And):this._error(W("&&"));break;case a.CharCode.Pipe:this._match(a.CharCode.Pipe)?this._addToken(y.Or):this._error(W("||"));break;case a.CharCode.Space:case a.CharCode.CarriageReturn:case a.CharCode.Tab:case a.CharCode.LineFeed:case a.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(y.EOF),Array.from(this._tokens)}_match(_){return this._isAtEnd()||this._input.charCodeAt(this._current)!==_?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?a.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(_){this._tokens.push({type:_,offset:this._start})}_error(_){const f=this._start,c=this._input.substring(this._start,this._current),l={type:y.Error,offset:this._start,lexeme:c};this._errors.push({offset:f,lexeme:c,additionalInfo:_}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const _=this.stringRe.exec(this._input);if(_){this._current=this._start+_[0].length;const f=this._input.substring(this._start,this._current),c=o._keywords.get(f);c?this._addToken(c):this._tokens.push({type:y.Str,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==a.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(P);return}this._advance(),this._tokens.push({type:y.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let _=this._current,f=!1,c=!1;for(;;){if(_>=this._input.length){this._current=_,this._error(v);return}const h=this._input.charCodeAt(_);if(f)f=!1;else if(h===a.CharCode.Slash&&!c){_++;break}else h===a.CharCode.OpenSquareBracket?c=!0:h===a.CharCode.Backslash?f=!0:h===a.CharCode.CloseSquareBracket&&(c=!1);_++}for(;_<this._input.length&&o._regexFlags.has(this._input.charCodeAt(_));)_++;this._current=_;const l=this._input.substring(this._start,this._current);this._tokens.push({type:y.RegexStr,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=o}),define(he[78],fe([0,1,58,15,21,5,16,26,6]),function(ie,e,a,t,L,y,W,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=w,e.parseDebugParams=_,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class o{get appRoot(){return(0,y.dirname)(L.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,y.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,a.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,y.join)(this.userDataPath,"logs",c)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(v.URI.file((0,y.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=W.env.VSCODE_PORTABLE;return c?v.URI.file((0,y.join)(c,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,y.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,y.resolve)(c):(0,y.normalize)((0,y.join)(L.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?v.URI.file((0,y.resolve)(c)):v.URI.file((0,y.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,y.resolve)(c);const l=W.env.VSCODE_EXTENSIONS;if(l)return l;const h=W.env.VSCODE_PORTABLE;return h?(0,y.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(l=>/^[^:/?#]+?:\/\//.test(l)?v.URI.parse(l):v.URI.file((0,y.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?v.URI.parse(c):v.URI.file((0,y.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!W.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(c))}get extensionLogLevel(){const c=[];for(const l of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);h&&h[1]&&h[2]&&c.push([h[1],h[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=W.env.VSCODE_PORTABLE;return c?v.URI.file((0,y.join)(c,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this._args}constructor(c,l,h){this._args=c,this.paths=l,this.productService=h,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=o,_e([t.memoize],o.prototype,"appRoot",null),_e([t.memoize],o.prototype,"userHome",null),_e([t.memoize],o.prototype,"userDataPath",null),_e([t.memoize],o.prototype,"appSettingsHome",null),_e([t.memoize],o.prototype,"tmpDir",null),_e([t.memoize],o.prototype,"cacheHome",null),_e([t.memoize],o.prototype,"stateResource",null),_e([t.memoize],o.prototype,"userRoamingDataHome",null),_e([t.memoize],o.prototype,"userDataSyncHome",null),_e([t.memoize],o.prototype,"sync",null),_e([t.memoize],o.prototype,"machineSettingsResource",null),_e([t.memoize],o.prototype,"workspaceStorageHome",null),_e([t.memoize],o.prototype,"localHistoryHome",null),_e([t.memoize],o.prototype,"keyboardLayoutResource",null),_e([t.memoize],o.prototype,"argvResource",null),_e([t.memoize],o.prototype,"isExtensionDevelopment",null),_e([t.memoize],o.prototype,"untitledWorkspacesHome",null),_e([t.memoize],o.prototype,"builtinExtensionsPath",null),_e([t.memoize],o.prototype,"extensionsPath",null),_e([t.memoize],o.prototype,"extensionDevelopmentLocationURI",null),_e([t.memoize],o.prototype,"extensionDevelopmentKind",null),_e([t.memoize],o.prototype,"extensionTestsLocationURI",null),_e([t.memoize],o.prototype,"debugExtensionHost",null),_e([t.memoize],o.prototype,"logLevel",null),_e([t.memoize],o.prototype,"extensionLogLevel",null),_e([t.memoize],o.prototype,"serviceMachineIdResource",null),_e([t.memoize],o.prototype,"disableTelemetry",null),_e([t.memoize],o.prototype,"disableWorkspaceTrust",null),_e([t.memoize],o.prototype,"useInMemorySecretStorage",null),_e([t.memoize],o.prototype,"policyFile",null);function w(f,c){return _(f["inspect-extensions"],f["inspect-brk-extensions"],5870,c,f.debugId,f.extensionEnvironment)}function _(f,c,l,h,m,u){const p=Number(c||f)||(h?null:l),b=p?!!c:!1;let s;if(u)try{s=JSON.parse(u)}catch{}return{port:p,break:b,debugId:m,env:s}}});var Ge=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[79],fe([0,1,112,3,72]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=o,e.buildHelpMessage=c,e.buildVersionMessage=l,a=Ge(a);const y={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,L.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,L.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,L.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,L.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,L.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,L.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,L.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,L.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,L.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,L.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const W={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,m,u=W){const r=h.find(E=>E.length>0&&E[0]!=="-"),p={},b=["_"],s=[],i={};let n;for(const E in m){const D=m[E];D.type==="subcommand"?E===r&&(n=D):(D.alias&&(p[E]=D.alias),D.type==="string"||D.type==="string[]"?(b.push(E),D.deprecates&&b.push(...D.deprecates)):D.type==="boolean"&&(s.push(E),D.deprecates&&s.push(...D.deprecates)),D.global&&(i[E]=D))}if(n&&r){const E=i;for(const z in n.options)E[z]=n.options[z];const D=h.filter(z=>z!==r),I=u.getSubcommandReporter?u.getSubcommandReporter(r):void 0,x=P(D,E,I);return{[r]:x,_:[]}}const S=(0,a.default)(h,{string:b,boolean:s,alias:p}),A={},O=S;A._=S._.map(E=>String(E)).filter(E=>E.length>0),delete O._;for(const E in m){const D=m[E];if(D.type==="subcommand")continue;D.alias&&delete O[D.alias];let I=O[E];if(D.deprecates)for(const x of D.deprecates)O.hasOwnProperty(x)&&(I||(I=O[x],I&&u.onDeprecatedOption(x,D.deprecationMessage||(0,L.localize)(39,null,E))),delete O[x]);if(typeof I<"u"){if(D.type==="string[]"){if(Array.isArray(I)||(I=[I]),!D.allowEmptyValue){const x=I.filter(z=>z.length>0);x.length!==I.length&&(u.onEmptyValue(E),I=x.length>0?x:void 0)}}else D.type==="string"&&(Array.isArray(I)?(I=I.pop(),u.onMultipleValues(E,I)):!I&&!D.allowEmptyValue&&(u.onEmptyValue(E),I=void 0));A[E]=I,D.deprecationMessage&&u.onDeprecatedOption(E,D.deprecationMessage)}delete O[E]}for(const E in O)u.onUnknownOption(E);return A}function v(h,m){let u="";return m.args&&(Array.isArray(m.args)?u=` <${m.args.join("> <")}>`:u=` <${m.args}>`),m.alias?`-${m.alias} --${h}${u}`:`--${h}${u}`}function o(h,m){const u=[];for(const r in h){const p=h[r],b=v(r,p);u.push([b,p.description])}return w(u,m)}function w(h,m){const r=h.reduce((s,i)=>Math.max(s,i[0].length),12)+2+1;if(m-r<25)return h.reduce((s,i)=>s.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const p=m-r-1,b=[];for(const s of h){const i=s[0],n=f(s[1],p),S=_(r-i.length-2);b.push("  "+i+S+n[0]);for(let A=1;A<n.length;A++)b.push(_(r)+n[A])}return b}function _(h){return" ".repeat(h)}function f(h,m){const u=[];for(;h.length;){const r=h.length<m?h.length:h.lastIndexOf(" ",m),p=h.slice(0,r).trim();h=h.slice(r),u.push(p)}return u}function c(h,m,u,r,p){const b=process.stdout.isTTY&&process.stdout.columns||80,s=p?.noInputFiles!==!0?`[${(0,L.localize)(40,null)}...]`:"",i=[`${h} ${u}`];i.push(""),i.push(`${(0,L.localize)(41,null)}: ${m} [${(0,L.localize)(42,null)}]${s}`),i.push(""),p?.noPipe!==!0&&(t.isWindows?i.push((0,L.localize)(43,null,m)):i.push((0,L.localize)(44,null,m)),i.push(""));const n={},S=[];for(const A in r){const O=r[A];if(O.type==="subcommand")O.description&&S.push({command:A,description:O.description});else if(O.description&&O.cat){let E=n[O.cat];E||(n[O.cat]=E={}),E[A]=O}}for(const A in n){const O=A,E=n[O];E&&(i.push(y[O]),i.push(...o(E,b)),i.push(""))}return S.length&&(i.push((0,L.localize)(45,null)),i.push(...w(S.map(A=>[A.command,A.description]),b)),i.push("")),i.join(`
`)}function l(h,m){return`${h||(0,L.localize)(46,null)}
${m||(0,L.localize)(47,null)}
${process.arch}`}}),function(){"use strict";function ie(e,a,t){function L(W,P){const v=y(W,P),o=[v];return e.isAbsolute(v)||o.unshift(t),e.resolve(...o)}function y(W,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let o=process.env.VSCODE_APPDATA;if(o)return e.join(o,P);const w=W["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(o=process.env.APPDATA,!o){const _=process.env.USERPROFILE;if(typeof _!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");o=e.join(_,"AppData","Roaming")}break;case"darwin":o=e.join(a.homedir(),"Library","Application Support");break;case"linux":o=process.env.XDG_CONFIG_HOME||e.join(a.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(o,P)}return{getUserDataPath:L}}if(typeof define=="function")define(he[80],fe([81,22,16]),function(e,a,t){return ie(e,a,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),a=require("os");module.exports=ie(e,a,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[82],fe([0,1,22,78,80]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=W,e.parseSharedProcessDebugPort=P;class y extends t.AbstractNativeEnvironmentService{constructor(o,w){super(o,{homeDir:(0,a.homedir)(),tmpDir:(0,a.tmpdir)(),userDataDir:(0,L.getUserDataPath)(o,w.nameShort)},w)}}e.NativeEnvironmentService=y;function W(v,o){return(0,t.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,o,v.extensionEnvironment)}function P(v,o){return(0,t.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,o,v.extensionEnvironment)}}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=L,e.refineServiceDecorator=y;var a;(function(W){W.serviceIds=new Map,W.DI_TARGET="$di$target",W.DI_DEPENDENCIES="$di$dependencies";function P(v){return v[W.DI_DEPENDENCIES]||[]}W.getServiceDependencies=P})(a||(e._util=a={})),e.IInstantiationService=L("instantiationService");function t(W,P,v){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:W,index:v}):(P[a.DI_DEPENDENCIES]=[{id:W,index:v}],P[a.DI_TARGET]=P)}function L(W){if(a.serviceIds.has(W))return a.serviceIds.get(W);const P=function(v,o,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,v,w)};return P.toString=()=>W,a.serviceIds.set(W,P),P}function y(W){return W}}),define(he[38],fe([0,1,14,3,10,77,23,70,7]),function(ie,e,a,t,L,y,W,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=w,e.validateWhenClauses=S,e.expressionsAreEqualWithConstantSubstitution=A,e.implies=$;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",t.isMacintosh),o.set("isLinux",t.isLinux),o.set("isWindows",t.isWindows),o.set("isWeb",t.isWeb),o.set("isMacNative",t.isMacintosh&&!t.isWeb),o.set("isEdge",t.isEdge),o.set("isFirefox",t.isFirefox),o.set("isChrome",t.isChrome),o.set("isSafari",t.isSafari);function w(te,d){if(o.get(te)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(te,d)}const _=Object.prototype.hasOwnProperty;var f;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const c={regexParsingWithErrorRecovery:!0},l=(0,P.localize)(0,null),h=(0,P.localize)(1,null),m=(0,P.localize)(2,null),u=(0,P.localize)(3,null),r=(0,P.localize)(4,null),p=(0,P.localize)(5,null),b=(0,P.localize)(6,null),s=(0,P.localize)(7,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(d=c){this._config=d,this._scanner=new y.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(d){if(d===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:h});return}this._tokens=this._scanner.reset(d).scan(),this._current=0,this._parsingErrors=[];try{const H=this._expr();if(!this._isAtEnd()){const U=this._peek(),N=U.type===y.TokenType.Str?p:void 0;throw this._parsingErrors.push({message:r,offset:U.offset,lexeme:y.Scanner.getLexeme(U),additionalInfo:N}),i._parseError}return H}catch(H){if(H!==i._parseError)throw H;return}}_expr(){return this._or()}_or(){const d=[this._and()];for(;this._matchOne(y.TokenType.Or);){const H=this._and();d.push(H)}return d.length===1?d[0]:n.or(...d)}_and(){const d=[this._term()];for(;this._matchOne(y.TokenType.And);){const H=this._term();d.push(H)}return d.length===1?d[0]:n.and(...d)}_term(){if(this._matchOne(y.TokenType.Neg)){const d=this._peek();switch(d.type){case y.TokenType.True:return this._advance(),E.INSTANCE;case y.TokenType.False:return this._advance(),D.INSTANCE;case y.TokenType.LParen:{this._advance();const H=this._expr();return this._consume(y.TokenType.RParen,u),H?.negate()}case y.TokenType.Str:return this._advance(),M.create(d.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",d)}}return this._primary()}_primary(){const d=this._peek();switch(d.type){case y.TokenType.True:return this._advance(),n.true();case y.TokenType.False:return this._advance(),n.false();case y.TokenType.LParen:{this._advance();const H=this._expr();return this._consume(y.TokenType.RParen,u),H}case y.TokenType.Str:{const H=d.lexeme;if(this._advance(),this._matchOne(y.TokenType.RegexOp)){const N=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),N.type!==y.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",N);const K=N.lexeme,j=K.lastIndexOf("/"),T=j===K.length-1?void 0:this._removeFlagsGY(K.substring(j+1));let X;try{X=new RegExp(K.substring(1,j),T)}catch{throw this._errExpectedButGot("REGEX",N)}return J.create(H,X)}switch(N.type){case y.TokenType.RegexStr:case y.TokenType.Error:{const K=[N.lexeme];this._advance();let j=this._peek(),T=0;for(let we=0;we<N.lexeme.length;we++)N.lexeme.charCodeAt(we)===a.CharCode.OpenParen?T++:N.lexeme.charCodeAt(we)===a.CharCode.CloseParen&&T--;for(;!this._isAtEnd()&&j.type!==y.TokenType.And&&j.type!==y.TokenType.Or;){switch(j.type){case y.TokenType.LParen:T++;break;case y.TokenType.RParen:T--;break;case y.TokenType.RegexStr:case y.TokenType.QuotedStr:for(let we=0;we<j.lexeme.length;we++)j.lexeme.charCodeAt(we)===a.CharCode.OpenParen?T++:N.lexeme.charCodeAt(we)===a.CharCode.CloseParen&&T--}if(T<0)break;K.push(y.Scanner.getLexeme(j)),this._advance(),j=this._peek()}const X=K.join(""),ne=X.lastIndexOf("/"),oe=ne===X.length-1?void 0:this._removeFlagsGY(X.substring(ne+1));let pe;try{pe=new RegExp(X.substring(1,ne),oe)}catch{throw this._errExpectedButGot("REGEX",N)}return n.regex(H,pe)}case y.TokenType.QuotedStr:{const K=N.lexeme;this._advance();let j=null;if(!(0,L.isFalsyOrWhitespace)(K)){const T=K.indexOf("/"),X=K.lastIndexOf("/");if(T!==X&&T>=0){const ne=K.slice(T+1,X),oe=K[X+1]==="i"?"i":"";try{j=new RegExp(ne,oe)}catch{throw this._errExpectedButGot("REGEX",N)}}}if(j===null)throw this._errExpectedButGot("REGEX",N);return J.create(H,j)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(y.TokenType.Not)){this._consume(y.TokenType.In,m);const N=this._value();return n.notIn(H,N)}switch(this._peek().type){case y.TokenType.Eq:{this._advance();const N=this._value();if(this._previous().type===y.TokenType.QuotedStr)return n.equals(H,N);switch(N){case"true":return n.has(H);case"false":return n.not(H);default:return n.equals(H,N)}}case y.TokenType.NotEq:{this._advance();const N=this._value();if(this._previous().type===y.TokenType.QuotedStr)return n.notEquals(H,N);switch(N){case"true":return n.not(H);case"false":return n.has(H);default:return n.notEquals(H,N)}}case y.TokenType.Lt:return this._advance(),Z.create(H,this._value());case y.TokenType.LtEq:return this._advance(),G.create(H,this._value());case y.TokenType.Gt:return this._advance(),C.create(H,this._value());case y.TokenType.GtEq:return this._advance(),B.create(H,this._value());case y.TokenType.In:return this._advance(),n.in(H,this._value());default:return n.has(H)}}case y.TokenType.EOF:throw this._parsingErrors.push({message:b,offset:d.offset,lexeme:"",additionalInfo:s}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const d=this._peek();switch(d.type){case y.TokenType.Str:case y.TokenType.QuotedStr:return this._advance(),d.lexeme;case y.TokenType.True:return this._advance(),"true";case y.TokenType.False:return this._advance(),"false";case y.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(d){return d.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(d){return this._check(d)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(d,H){if(this._check(d))return this._advance();throw this._errExpectedButGot(H,this._peek())}_errExpectedButGot(d,H,U){const N=(0,P.localize)(8,null,d,y.Scanner.getLexeme(H)),K=H.offset,j=y.Scanner.getLexeme(H);return this._parsingErrors.push({message:N,offset:K,lexeme:j,additionalInfo:U}),i._parseError}_check(d){return this._peek().type===d}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===y.TokenType.EOF}}e.Parser=i;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(d){return I.create(d)}static equals(d,H){return x.create(d,H)}static notEquals(d,H){return g.create(d,H)}static regex(d,H){return J.create(d,H)}static in(d,H){return z.create(d,H)}static notIn(d,H){return k.create(d,H)}static not(d){return M.create(d)}static and(...d){return V.create(d,null,!0)}static or(...d){return F.create(d,null,!0)}static greater(d,H){return C.create(d,H)}static greaterEquals(d,H){return B.create(d,H)}static smaller(d,H){return Z.create(d,H)}static smallerEquals(d,H){return G.create(d,H)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this._parser.parse(d)}}e.ContextKeyExpr=n;function S(te){const d=new i({regexParsingWithErrorRecovery:!1});return te.map(H=>(d.parse(H),d.lexingErrors.length>0?d.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,P.localize)(9,null,U.additionalInfo):(0,P.localize)(10,null),offset:U.offset,length:U.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function A(te,d){const H=te?te.substituteConstants():void 0,U=d?d.substituteConstants():void 0;return!H&&!U?!0:!H||!U?!1:H.equals(U)}function O(te,d){return te.cmp(d)}class E{static{this.INSTANCE=new E}constructor(){this.type=f.False}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=E;class D{static{this.INSTANCE=new D}constructor(){this.type=f.True}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=D;class I{static create(d,H=null){const U=o.get(d);return typeof U=="boolean"?U?D.INSTANCE:E.INSTANCE:new I(d,H)}constructor(d,H){this.key=d,this.negated=H,this.type=f.Defined}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=o.get(this.key);return typeof d=="boolean"?d?D.INSTANCE:E.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class x{static create(d,H,U=null){if(typeof H=="boolean")return H?I.create(d,U):M.create(d,U);const N=o.get(d);return typeof N=="boolean"?H===(N?"true":"false")?D.INSTANCE:E.INSTANCE:new x(d,H,U)}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.Equals}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=o.get(this.key);if(typeof d=="boolean"){const H=d?"true":"false";return this.value===H?D.INSTANCE:E.INSTANCE}return this}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=x;class z{static create(d,H){return new z(d,H)}constructor(d,H){this.key=d,this.valueKey=H,this.type=f.In,this.negated=null}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}substituteConstants(){return this}evaluate(d){const H=d.getValue(this.valueKey),U=d.getValue(this.key);return Array.isArray(H)?H.includes(U):typeof U=="string"&&typeof H=="object"&&H!==null?_.call(H,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=z;class k{static create(d,H){return new k(d,H)}constructor(d,H){this.key=d,this.valueKey=H,this.type=f.NotIn,this._negated=z.create(d,H)}cmp(d){return d.type!==this.type?this.type-d.type:this._negated.cmp(d._negated)}equals(d){return d.type===this.type?this._negated.equals(d._negated):!1}substituteConstants(){return this}evaluate(d){return!this._negated.evaluate(d)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(d){return d.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=k;class g{static create(d,H,U=null){if(typeof H=="boolean")return H?M.create(d,U):I.create(d,U);const N=o.get(d);return typeof N=="boolean"?H===(N?"true":"false")?E.INSTANCE:D.INSTANCE:new g(d,H,U)}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.NotEquals}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=o.get(this.key);if(typeof d=="boolean"){const H=d?"true":"false";return this.value===H?E.INSTANCE:D.INSTANCE}return this}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class M{static create(d,H=null){const U=o.get(d);return typeof U=="boolean"?U?E.INSTANCE:D.INSTANCE:new M(d,H)}constructor(d,H){this.key=d,this.negated=H,this.type=f.Not}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=o.get(this.key);return typeof d=="boolean"?d?E.INSTANCE:D.INSTANCE:this}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function R(te,d){if(typeof te=="string"){const H=parseFloat(te);isNaN(H)||(te=H)}return typeof te=="string"||typeof te=="number"?d(te):E.INSTANCE}class C{static create(d,H,U=null){return R(H,N=>new C(d,N,U))}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.Greater}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=G.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=C;class B{static create(d,H,U=null){return R(H,N=>new B(d,N,U))}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.GreaterEquals}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=B;class Z{static create(d,H,U=null){return R(H,N=>new Z(d,N,U))}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.Smaller}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Z;class G{static create(d,H,U=null){return R(H,N=>new G(d,N,U))}constructor(d,H,U){this.key=d,this.value=H,this.negated=U,this.type=f.SmallerEquals}cmp(d){return d.type!==this.type?this.type-d.type:ue(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=G;class J{static create(d,H){return new J(d,H)}constructor(d,H){this.key=d,this.regexp=H,this.type=f.Regex,this.negated=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const H=this.regexp?this.regexp.source:"",U=d.regexp?d.regexp.source:"";return H<U?-1:H>U?1:0}equals(d){if(d.type===this.type){const H=this.regexp?this.regexp.source:"",U=d.regexp?d.regexp.source:"";return this.key===d.key&&H===U}return!1}substituteConstants(){return this}evaluate(d){const H=d.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=J;class se{static create(d){return new se(d)}constructor(d){this._actual=d,this.type=f.NotRegex}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}substituteConstants(){return this}evaluate(d){return!this._actual.evaluate(d)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(d){return new se(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function le(te){let d=null;for(let H=0,U=te.length;H<U;H++){const N=te[H].substituteConstants();if(te[H]!==N&&d===null){d=[];for(let K=0;K<H;K++)d[K]=te[K]}d!==null&&(d[H]=N)}return d===null?te:d}class V{static create(d,H,U){return V._normalizeArr(d,H,U)}constructor(d,H){this.expr=d,this.negated=H,this.type=f.And}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let H=0,U=this.expr.length;H<U;H++){const N=O(this.expr[H],d.expr[H]);if(N!==0)return N}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let H=0,U=this.expr.length;H<U;H++)if(!this.expr[H].equals(d.expr[H]))return!1;return!0}return!1}substituteConstants(){const d=le(this.expr);return d===this.expr?this:V.create(d,this.negated,!1)}evaluate(d){for(let H=0,U=this.expr.length;H<U;H++)if(!this.expr[H].evaluate(d))return!1;return!0}static _normalizeArr(d,H,U){const N=[];let K=!1;for(const j of d)if(j){if(j.type===f.True){K=!0;continue}if(j.type===f.False)return E.INSTANCE;if(j.type===f.And){N.push(...j.expr);continue}N.push(j)}if(N.length===0&&K)return D.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(O);for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];for(;N.length>1;){const j=N[N.length-1];if(j.type!==f.Or)break;N.pop();const T=N.pop(),X=N.length===0,ne=F.create(j.expr.map(oe=>V.create([oe,T],null,U)),null,X);ne&&(N.push(ne),N.sort(O))}if(N.length===1)return N[0];if(U){for(let j=0;j<N.length;j++)for(let T=j+1;T<N.length;T++)if(N[j].negate().equals(N[T]))return E.INSTANCE;if(N.length===1)return N[0]}return new V(N,H)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const H of this.expr)d.push(...H.keys());return d}map(d){return new V(this.expr.map(H=>H.map(d)),null)}negate(){if(!this.negated){const d=[];for(const H of this.expr)d.push(H.negate());this.negated=F.create(d,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class F{static create(d,H,U){return F._normalizeArr(d,H,U)}constructor(d,H){this.expr=d,this.negated=H,this.type=f.Or}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let H=0,U=this.expr.length;H<U;H++){const N=O(this.expr[H],d.expr[H]);if(N!==0)return N}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let H=0,U=this.expr.length;H<U;H++)if(!this.expr[H].equals(d.expr[H]))return!1;return!0}return!1}substituteConstants(){const d=le(this.expr);return d===this.expr?this:F.create(d,this.negated,!1)}evaluate(d){for(let H=0,U=this.expr.length;H<U;H++)if(this.expr[H].evaluate(d))return!0;return!1}static _normalizeArr(d,H,U){let N=[],K=!1;if(d){for(let j=0,T=d.length;j<T;j++){const X=d[j];if(X){if(X.type===f.False){K=!0;continue}if(X.type===f.True)return D.INSTANCE;if(X.type===f.Or){N=N.concat(X.expr);continue}N.push(X)}}if(N.length===0&&K)return E.INSTANCE;N.sort(O)}if(N.length!==0){if(N.length===1)return N[0];for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];if(U){for(let j=0;j<N.length;j++)for(let T=j+1;T<N.length;T++)if(N[j].negate().equals(N[T]))return D.INSTANCE;if(N.length===1)return N[0]}return new F(N,H)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const H of this.expr)d.push(...H.keys());return d}map(d){return new F(this.expr.map(H=>H.map(d)),null)}negate(){if(!this.negated){const d=[];for(const H of this.expr)d.push(H.negate());for(;d.length>1;){const H=d.shift(),U=d.shift(),N=[];for(const K of ge(H))for(const j of ge(U))N.push(V.create([K,j],null,!1));d.unshift(F.create(N,null,!1))}this.negated=F.create(d,this,!0)}return this.negated}}e.ContextKeyOrExpr=F;class Y extends I{static{this._info=[]}static all(){return Y._info.values()}constructor(d,H,U){super(d,null),this._defaultValue=H,typeof U=="object"?Y._info.push({...U,key:d}):U!==!0&&Y._info.push({key:d,description:U,type:H!=null?typeof H:void 0})}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return x.create(this.key,d)}notEqualsTo(d){return g.create(this.key,d)}}e.RawContextKey=Y,e.IContextKeyService=(0,W.createDecorator)("contextKeyService");function ee(te,d){return te<d?-1:te>d?1:0}function ue(te,d,H,U){return te<H?-1:te>H?1:d<U?-1:d>U?1:0}function $(te,d){if(te.type===f.False||d.type===f.True)return!0;if(te.type===f.Or)return d.type===f.Or?ae(te.expr,d.expr):!1;if(d.type===f.Or){for(const H of d.expr)if($(te,H))return!0;return!1}if(te.type===f.And){if(d.type===f.And)return ae(d.expr,te.expr);for(const H of te.expr)if($(H,d))return!0;return!1}return te.equals(d)}function ae(te,d){let H=0,U=0;for(;H<te.length&&U<d.length;){const N=te[H].cmp(d[U]);if(N<0)return!1;N===0&&H++,U++}return H===te.length}function ge(te){return te.type===f.Or?te.expr:[te]}}),define(he[83],fe([0,1,55,5,10,9,6,73,23,3,21,25]),function(ie,e,a,t,L,y,W,P,v,o,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=f,e.isFileSystemWatcher=m,e.hasReadWriteCapability=r,e.hasFileFolderCopyCapability=p,e.hasFileCloneCapability=b,e.hasOpenReadWriteCloseCapability=s,e.hasFileReadStreamCapability=i,e.hasFileAtomicReadCapability=n,e.hasFileAtomicWriteCapability=S,e.hasFileAtomicDeleteCapability=A,e.hasReadonlyCapability=O,e.createFileSystemProviderError=I,e.ensureFileSystemProviderError=x,e.markAsFileSystemProviderError=z,e.toFileSystemProviderErrorCode=k,e.toFileOperationResult=g,e.isParent=Z,e.etag=F,e.whenProviderRegistered=Y,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,v.createDecorator)("fileService");function f($){return $.create===!0}var c;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var l;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var h;(function($){$[$.UPDATED=2]="UPDATED",$[$.ADDED=4]="ADDED",$[$.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function m($){const ae=$;return!!ae&&typeof ae.onDidChange=="function"}var u;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function r($){return!!($.capabilities&u.FileReadWrite)}function p($){return!!($.capabilities&u.FileFolderCopy)}function b($){return!!($.capabilities&u.FileClone)}function s($){return!!($.capabilities&u.FileOpenReadWriteClose)}function i($){return!!($.capabilities&u.FileReadStream)}function n($){return r($)?!!($.capabilities&u.FileAtomicRead):!1}function S($){return r($)?!!($.capabilities&u.FileAtomicWrite):!1}function A($){return!!($.capabilities&u.FileAtomicDelete)}function O($){return!!($.capabilities&u.Readonly)}var E;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ae,ge){const te=new D(ae.toString(),ge);return z(te,ge),te}constructor(ae,ge){super(ae),this.code=ge}}e.FileSystemProviderError=D;function I($,ae){return D.create($,ae)}function x($){return $||I((0,P.localize)(0,null),E.Unknown)}function z($,ae){return $.name=ae?`${ae} (FileSystemError)`:"FileSystemError",$}function k($){if(!$)return E.Unknown;if($ instanceof D)return $.code;const ae=/^(.+) \(FileSystemError\)$/.exec($.name);if(!ae)return E.Unknown;switch(ae[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function g($){if($ instanceof G)return $.fileOperationResult;switch(k($)){case E.FileNotFound:return le.FILE_NOT_FOUND;case E.FileIsADirectory:return le.FILE_IS_DIRECTORY;case E.FileNotADirectory:return le.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return le.FILE_WRITE_LOCKED;case E.NoPermissions:return le.FILE_PERMISSION_DENIED;case E.FileExists:return le.FILE_MOVE_CONFLICT;case E.FileTooLarge:return le.FILE_TOO_LARGE;default:return le.FILE_OTHER_ERROR}}var M;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class R{constructor(ae,ge,te){this.resource=ae,this.operation=ge,this.target=te}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=R;var C;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class B{static{this.MIXED_CORRELATION=null}constructor(ae,ge){this.ignorePathCasing=ge,this.correlationId=void 0,this.added=new _.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawAdded.map(d=>[d,!0])),te}),this.updated=new _.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawUpdated.map(d=>[d,!0])),te}),this.deleted=new _.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawDeleted.map(d=>[d,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ae){switch(te.type){case C.ADDED:this.rawAdded.push(te.resource);break;case C.UPDATED:this.rawUpdated.push(te.resource);break;case C.DELETED:this.rawDeleted.push(te.resource);break}this.correlationId!==B.MIXED_CORRELATION&&(typeof te.cId=="number"?this.correlationId===void 0?this.correlationId=te.cId:this.correlationId!==te.cId&&(this.correlationId=B.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=B.MIXED_CORRELATION))}}contains(ae,...ge){return this.doContains(ae,{includeChildren:!1},...ge)}affects(ae,...ge){return this.doContains(ae,{includeChildren:!0},...ge)}doContains(ae,ge,...te){if(!ae)return!1;const d=te.length>0;return!!((!d||te.includes(C.ADDED))&&(this.added.value.get(ae)||ge.includeChildren&&this.added.value.findSuperstr(ae))||(!d||te.includes(C.UPDATED))&&(this.updated.value.get(ae)||ge.includeChildren&&this.updated.value.findSuperstr(ae))||(!d||te.includes(C.DELETED))&&(this.deleted.value.findSubstr(ae)||ge.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=B;function Z($,ae,ge){return!$||!ae||$===ae||ae.length>$.length?!1:(ae.charAt(ae.length-1)!==t.sep&&(ae+=t.sep),ge?(0,L.startsWithIgnoreCase)($,ae):$.indexOf(ae)===0)}class G extends Error{constructor(ae,ge,te){super(ae),this.fileOperationResult=ge,this.options=te}}e.FileOperationError=G;class J extends G{constructor(ae,ge,te,d){super(ae,ge,d),this.fileOperationResult=ge,this.size=te}}e.TooLargeFileOperationError=J;class se extends G{constructor(ae,ge,te){super(ae,le.FILE_NOT_MODIFIED_SINCE,te),this.stat=ge}}e.NotModifiedSinceFileOperationError=se;var le;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function F($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}async function Y($,ae){if(!ae.hasProvider(W.URI.from({scheme:$.scheme})))return new Promise(ge=>{const te=ae.onDidChangeFileSystemProviderRegistrations(d=>{d.scheme===$.scheme&&d.added&&(te.dispose(),ge())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ae){return(0,y.isNumber)(ae)||(ae=0),ae<ee.KB?(0,P.localize)(1,null,ae.toFixed(0)):ae<ee.MB?(0,P.localize)(2,null,(ae/ee.KB).toFixed(2)):ae<ee.GB?(0,P.localize)(3,null,(ae/ee.MB).toFixed(2)):ae<ee.TB?(0,P.localize)(4,null,(ae/ee.GB).toFixed(2)):(0,P.localize)(5,null,(ae/ee.TB).toFixed(2))}}e.ByteSize=ee;function ue($){const ae=typeof $=="string"||$?.scheme===w.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===w.Schemas.file?1024*ee.MB:ae?10*ee.MB:o.isWeb?50*ee.MB:1024*ee.MB}}),define(he[8],fe([0,1,74,60,4,54,2,28,3,26,9,6,38,23]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=h,e.log=u,e.getLogLevel=D,e.LogLevelToString=I,e.LogLevelToLocalizedString=x,e.parseLogLevel=z,a=De(a),e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function l(){return new Date().toISOString()}function h(k){return(0,w.isNumber)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function u(k,g,M){switch(g){case m.Trace:k.trace(M);break;case m.Debug:k.debug(M);break;case m.Info:k.info(M);break;case m.Warning:k.warn(M);break;case m.Error:k.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function r(k,g=!1){let M="";for(let R=0;R<k.length;R++){let C=k[R];if(C instanceof Error&&(C=(0,t.toErrorMessage)(C,g)),typeof C=="object")try{C=JSON.stringify(C)}catch{}M+=(R>0?" ":"")+C}return M}class p extends W.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(g){this.level!==g&&(this.level=g,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(g){return this.level!==m.Off&&this.level<=g}}e.AbstractLogger=p;class b extends p{constructor(g){super(),this.logAlways=g}checkLogLevel(g){return this.logAlways||super.checkLogLevel(g)}trace(g,...M){this.checkLogLevel(m.Trace)&&this.log(m.Trace,r([g,...M],!0))}debug(g,...M){this.checkLogLevel(m.Debug)&&this.log(m.Debug,r([g,...M]))}info(g,...M){this.checkLogLevel(m.Info)&&this.log(m.Info,r([g,...M]))}warn(g,...M){this.checkLogLevel(m.Warning)&&this.log(m.Warning,r([g,...M]))}error(g,...M){if(this.checkLogLevel(m.Error))if(g instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=g.stack,this.log(m.Error,r(R))}else this.log(m.Error,r([g,...M]))}flush(){}}e.AbstractMessageLogger=b;class s extends p{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.useColors=!v.isWindows}trace(g,...M){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,g,...M):console.log(`[main ${l()}]`,g,...M))}debug(g,...M){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,g,...M):console.log(`[main ${l()}]`,g,...M))}info(g,...M){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,g,...M):console.log(`[main ${l()}]`,g,...M))}warn(g,...M){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,g,...M):console.warn(`[main ${l()}]`,g,...M))}error(g,...M){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,g,...M):console.error(`[main ${l()}]`,g,...M))}flush(){}}e.ConsoleMainLogger=s;class i extends p{constructor(g=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(g)}trace(g,...M){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",g,...M):console.log(g,...M))}debug(g,...M){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",g,...M):console.log(g,...M))}info(g,...M){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",g,...M):console.log(g,...M))}warn(g,...M){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",g,...M):console.log(g,...M))}error(g,...M){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",g,...M):console.error(g,...M))}flush(){}}e.ConsoleLogger=i;class n extends p{constructor(g,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=g,this.setLevel(M)}trace(g,...M){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(g),...M])}debug(g,...M){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(g),...M])}info(g,...M){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(g),...M])}warn(g,...M){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(g),...M])}error(g,...M){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(g),...M])}extractMessage(g){return typeof g=="string"?g:(0,t.toErrorMessage)(g,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=n;class S extends p{constructor(g){super(),this.loggers=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const M of this.loggers)M.setLevel(g);super.setLevel(g)}trace(g,...M){for(const R of this.loggers)R.trace(g,...M)}debug(g,...M){for(const R of this.loggers)R.debug(g,...M)}info(g,...M){for(const R of this.loggers)R.info(g,...M)}warn(g,...M){for(const R of this.loggers)R.warn(g,...M)}error(g,...M){for(const R of this.loggers)R.error(g,...M)}flush(){for(const g of this.loggers)g.flush()}dispose(){for(const g of this.loggers)g.dispose();super.dispose()}}e.MultiplexLogger=S;class A extends W.Disposable{constructor(g,M,R){if(super(),this.logLevel=g,this.logsHome=M,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,R)for(const C of R)this._loggers.set(C.resource,{logger:void 0,info:C})}getLoggerEntry(g){return(0,w.isString)(g)?[...this._loggers.values()].find(M=>M.info.id===g):this._loggers.get(g)}getLogger(g){return this.getLoggerEntry(g)?.logger}createLogger(g,M){const R=this.toResource(g),C=(0,w.isString)(g)?g:M?.id??(0,y.hash)(R.toString()).toString(16);let B=this._loggers.get(R)?.logger;const Z=M?.logLevel==="always"?m.Trace:M?.logLevel;B||(B=this.doCreateLogger(R,Z??this.getLogLevel(R)??this.logLevel,{...M,id:C}));const G={logger:B,info:{resource:R,id:C,logLevel:Z,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(G.info),this._loggers.set(R,G),B}toResource(g){return(0,w.isString)(g)?(0,o.joinPath)(this.logsHome,`${g}.log`):g}setLogLevel(g,M){if(_.URI.isUri(g)){const R=g,C=M,B=this._loggers.get(R);B&&C!==B.info.logLevel&&(B.info.logLevel=C===this.logLevel?void 0:C,B.logger?.setLevel(C),this._loggers.set(B.info.resource,B),this._onDidChangeLogLevel.fire([R,C]))}else{this.logLevel=g;for(const[R,C]of this._loggers.entries())this._loggers.get(R)?.info.logLevel===void 0&&C.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(g,M){const R=this.getLoggerEntry(g);R&&M!==!R.info.hidden&&(R.info.hidden=!M,this._loggers.set(R.info.resource,R),this._onDidChangeVisibility.fire([R.info.resource,M]))}getLogLevel(g){let M;return g&&(M=this._loggers.get(g)?.info.logLevel),M??this.logLevel}registerLogger(g){const M=this._loggers.get(g.resource);M?M.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this._loggers.set(g.resource,{info:g,logger:void 0}),this._onDidChangeLoggers.fire({added:[g],removed:[]}))}deregisterLogger(g){const M=this._loggers.get(g);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(g),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const g of this._loggers.values())yield g.info}getRegisteredLogger(g){return this._loggers.get(g)?.info}dispose(){this._loggers.forEach(g=>g.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=A;class O{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(g){}getLevel(){return m.Info}trace(g,...M){}debug(g,...M){}info(g,...M){}warn(g,...M){}error(g,...M){}critical(g,...M){}dispose(){}flush(){}}e.NullLogger=O;class E extends O{}e.NullLogService=E;function D(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const g=z(k.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}function I(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function x(k){switch(k){case m.Trace:return{original:"Trace",value:a.localize(0,null)};case m.Debug:return{original:"Debug",value:a.localize(1,null)};case m.Info:return{original:"Info",value:a.localize(2,null)};case m.Warning:return{original:"Warning",value:a.localize(3,null)};case m.Error:return{original:"Error",value:a.localize(4,null)};case m.Off:return{original:"Off",value:a.localize(5,null)}}}function z(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",I(m.Info))}),define(he[84],fe([0,1,6,4,8,2]),function(ie,e,a,t,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class W extends L.AbstractLoggerService{constructor(_,f,c,l,h){super(f,c,l),this.windowId=_,this.channel=h,this._register(h.listen("onDidChangeLogLevel",_)(m=>{(0,L.isLogLevel)(m)?super.setLogLevel(m):super.setLogLevel(a.URI.revive(m[0]),m[1])})),this._register(h.listen("onDidChangeVisibility",_)(([m,u])=>super.setVisibility(a.URI.revive(m),u))),this._register(h.listen("onDidChangeLoggers",_)(({added:m,removed:u})=>{for(const r of m)super.registerLogger({...r,resource:a.URI.revive(r.resource)});for(const r of u)super.deregisterLogger(r.resource)}))}createConsoleMainLogger(){return new L.AdapterLogger({log:(_,f)=>{this.channel.call("consoleLog",[_,f])}})}registerLogger(_){super.registerLogger(_),this.channel.call("registerLogger",[_,this.windowId])}deregisterLogger(_){super.deregisterLogger(_),this.channel.call("deregisterLogger",[_,this.windowId])}setLogLevel(_,f){super.setLogLevel(_,f),this.channel.call("setLogLevel",[_,f])}setVisibility(_,f){super.setVisibility(_,f),this.channel.call("setVisibility",[this.toResource(_),f])}doCreateLogger(_,f,c){return new P(this.channel,_,f,c,this.windowId)}static setLogLevel(_,f,c){return _.call("setLogLevel",[f,c])}}e.LoggerChannelClient=W;class P extends L.AbstractMessageLogger{constructor(_,f,c,l,h){super(l?.logLevel==="always"),this.channel=_,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[f,l,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,f){const c=[[_,f]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(_){this.channel.call("log",[this.file,_])}}class v{constructor(_,f){this.loggerService=_,this.getUriTransformer=f}listen(_,f){const c=this.getUriTransformer(_);switch(f){case"onDidChangeLoggers":return t.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(h=>this.transformLogger(h,c)),removed:[...l.removed].map(h=>this.transformLogger(h,c))}));case"onDidChangeVisibility":return t.Event.map(this.loggerService.onDidChangeVisibility,l=>[c.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return t.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,L.isLogLevel)(l)?l:[c.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${f}`)}async call(_,f,c){const l=this.getUriTransformer(_);switch(f){case"setLogLevel":return(0,L.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(a.URI.revive(l.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(h=>this.transformLogger(h,l)))}throw new Error(`Call not found: ${f}`)}transformLogger(_,f){return{..._,resource:f.transformOutgoingURI(_.resource)}}}e.LoggerChannel=v;class o extends y.Disposable{constructor(_,f){super(),f.call("setLogLevel",[_.getLogLevel()]),this._register(_.onDidChangeLogLevel(c=>f.call("setLogLevel",[c]))),f.call("getRegisteredLoggers").then(c=>{for(const l of c)_.registerLogger({...l,resource:a.URI.revive(l.resource)})}),this._register(f.listen("onDidChangeVisibility")(([c,l])=>_.setVisibility(a.URI.revive(c),l))),this._register(f.listen("onDidChangeLoggers")(({added:c,removed:l})=>{for(const h of c)_.registerLogger({...h,resource:a.URI.revive(h.resource)});for(const h of l)_.deregisterLogger(h.resource)}))}}e.RemoteLoggerChannelClient=o}),define(he[85],fe([0,1,2,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends a.Disposable{constructor(W,P=[]){super(),this.logger=new t.MultiplexLogger([W,...P]),this._register(W.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(W){this.logger.setLevel(W)}getLevel(){return this.logger.getLevel()}trace(W,...P){this.logger.trace(W,...P)}debug(W,...P){this.logger.debug(W,...P)}info(W,...P){this.logger.info(W,...P)}warn(W,...P){this.logger.warn(W,...P)}error(W,...P){this.logger.error(W,...P)}flush(){this.logger.flush()}}e.LogService=L}),define(he[86],fe([0,1,83,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(L||(L={}));async function y(o,w,_,f,c){try{const l=await new Promise((m,u)=>{ie(["@vscode/spdlog"],m,u)}).then(De);l.setFlushOn(L.Trace);const h=await l.createAsyncRotatingLogger(o,w,_,f);return c?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(l){console.error(l)}return null}function W(o,w,_){switch(w){case t.LogLevel.Trace:o.trace(_);break;case t.LogLevel.Debug:o.debug(_);break;case t.LogLevel.Info:o.info(_);break;case t.LogLevel.Warning:o.warn(_);break;case t.LogLevel.Error:o.error(_);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(o,w){switch(w){case t.LogLevel.Trace:o.setLevel(L.Trace);break;case t.LogLevel.Debug:o.setLevel(L.Debug);break;case t.LogLevel.Info:o.setLevel(L.Info);break;case t.LogLevel.Warning:o.setLevel(L.Warning);break;case t.LogLevel.Error:o.setLevel(L.Error);break;case t.LogLevel.Off:o.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class v extends t.AbstractMessageLogger{constructor(w,_,f,c,l){super(),this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(w,_,f,c),this._register(this.onDidChangeLogLevel(h=>{this._logger&&P(this._logger,h)}))}async _createSpdLogLogger(w,_,f,c){const l=f?6:1,h=30/l*a.ByteSize.MB,m=await y(w,_,h,l,c);if(m){this._logger=m,P(this._logger,this.getLevel());for(const{level:u,message:r}of this.buffer)W(this._logger,u,r);this.buffer=[]}}log(w,_){this._logger?W(this._logger,w,_):this.getLevel()<=w&&this.buffer.push({level:w,message:_})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=v}),define(he[87],fe([0,1,56,8,86]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class y extends t.AbstractLoggerService{doCreateLogger(P,v,o){return new L.SpdLogLogger((0,a.generateUuid)(),P.fsPath,!o?.donotRotate,!!o?.donotUseFormatters,v)}}e.LoggerService=y}),define(he[88],fe([0,1,16]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const y=L.context.configuration();if(y)t=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){t=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:y,searchUrl:W,itemUrl:P,controlUrl:v}=t.extensionsGallery||{};Object.assign(t,{extensionsGallery:{serviceUrl:a.env.VSCODE_GALLERY_SERVICE_URL||y,searchUrl:a.env.VSCODE_GALLERY_SEARCH_URL||W,itemUrl:a.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:a.env.VSCODE_GALLERY_CONTROL_URL||v}});try{const o=(..._)=>_.reduce((f,c)=>(Object.keys(c).forEach(l=>{Array.isArray(f[l])&&Array.isArray(c[l])?f[l]=c[l]:typeof f[l]=="object"&&typeof c[l]=="object"?f[l]=o(f[l],c[l]):f[l]=c[l]}),f),{}),w=globalThis._VSCODE_USER_PRODUCT_JSON||{};t=o(t,w)}catch{}if(a.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const o=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:o.version,release:o.release})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[89],fe([0,1,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(he[90],fe([0,1,45,9]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,a=De(a),t=De(t);class L{constructor(){this.data=new Map}add(W,P){a.ok(t.isString(W)),a.ok(t.isObject(P)),a.ok(!this.data.has(W),"There is already an extension with this id"),this.data.set(W,P)}knows(W){return this.data.has(W)}as(W){return this.data.get(W)||null}}e.Registry=new L}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var a;(function(L){L[L.CwdDetection=0]="CwdDetection",L[L.NaiveCwdDetection=1]="NaiveCwdDetection",L[L.CommandDetection=2]="CommandDetection",L[L.PartialCommandDetection=3]="PartialCommandDetection",L[L.BufferMarkDetection=4]="BufferMarkDetection"})(a||(e.TerminalCapability=a={}));var t;(function(L){L.Windows="windows",L.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[91],fe([0,1,4,2,24]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class y extends t.Disposable{constructor(P){super(),this._terminal=P,this.type=L.TerminalCapability.BufferMarkDetection,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new a.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const P of this._idToMarkerMap.values())yield P;for(const P of this._anonymousMarkers.values())yield P}addMark(P){const v=P?.marker||this._terminal.registerMarker(),o=P?.id;v&&(o?(this._idToMarkerMap.set(o,v),v.onDispose(()=>this._idToMarkerMap.delete(o))):(this._anonymousMarkers.set(v.id,v),v.onDispose(()=>this._anonymousMarkers.delete(v.id))),this._onMarkAdded.fire({marker:v,id:o,hidden:P?.hidden,hoverMessage:P?.hoverMessage}))}getMark(P){return this._idToMarkerMap.get(P)}}e.BufferMarkCapability=y});var ze=this&&this.__param||function(ie,e){return function(a,t){e(a,t,ie)}};define(he[92],fe([0,1,4,2,8,15]),function(ie,e,a,t,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PromptInputModel=void 0;var W;(function(v){v[v.Unknown=0]="Unknown",v[v.Input=1]="Input",v[v.Execute=2]="Execute"})(W||(W={}));let P=class extends t.Disposable{get value(){return this._value}get cursorIndex(){return this._cursorIndex}get ghostTextIndex(){return this._ghostTextIndex}constructor(o,w,_,f){super(),this._xterm=o,this._logService=f,this._state=W.Unknown,this._commandStartX=0,this._lastUserInput="",this._value="",this._cursorIndex=0,this._ghostTextIndex=-1,this._onDidStartInput=this._register(new a.Emitter),this.onDidStartInput=this._onDidStartInput.event,this._onDidChangeInput=this._register(new a.Emitter),this.onDidChangeInput=this._onDidChangeInput.event,this._onDidFinishInput=this._register(new a.Emitter),this.onDidFinishInput=this._onDidFinishInput.event,this._onDidInterrupt=this._register(new a.Emitter),this.onDidInterrupt=this._onDidInterrupt.event,this._register(a.Event.any(this._xterm.onCursorMove,this._xterm.onData,this._xterm.onWriteParsed)(()=>this._sync())),this._register(this._xterm.onData(c=>this._handleUserInput(c))),this._register(w(c=>this._handleCommandStart(c))),this._register(_(()=>this._handleCommandExecuted())),this._register(this.onDidStartInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidStartInput"))),this._register(this.onDidChangeInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidChangeInput"))),this._register(this.onDidFinishInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidFinishInput"))),this._register(this.onDidInterrupt(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidInterrupt")))}_logCombinedStringIfTrace(o){this._logService.getLevel()===L.LogLevel.Trace&&this._logService.trace(o,this.getCombinedString())}setContinuationPrompt(o){this._continuationPrompt=o,this._sync()}setLastPromptLine(o){this._lastPromptLine=o,this._sync()}setConfidentCommandLine(o){this._value!==o&&(this._value=o,this._cursorIndex=-1,this._ghostTextIndex=-1,this._onDidChangeInput.fire(this._createStateObject()))}getCombinedString(){const o=this._value.replaceAll(`
`,"\u23CE");if(this._cursorIndex===-1)return o;let w=`${o.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(w+=`${o.substring(this.cursorIndex,this.ghostTextIndex)}[`,w+=`${o.substring(this.ghostTextIndex)}]`):w+=o.substring(this.cursorIndex),w}serialize(){return{modelState:this._createStateObject(),commandStartX:this._commandStartX,lastPromptLine:this._lastPromptLine,continuationPrompt:this._continuationPrompt,lastUserInput:this._lastUserInput}}deserialize(o){this._value=o.modelState.value,this._cursorIndex=o.modelState.cursorIndex,this._ghostTextIndex=o.modelState.ghostTextIndex,this._commandStartX=o.commandStartX,this._lastPromptLine=o.lastPromptLine,this._continuationPrompt=o.continuationPrompt,this._lastUserInput=o.lastUserInput}_handleCommandStart(o){this._state!==W.Input&&(this._state=W.Input,this._commandStartMarker=o.marker,this._commandStartX=this._xterm.buffer.active.cursorX,this._value="",this._cursorIndex=0,this._onDidStartInput.fire(this._createStateObject()),this._onDidChangeInput.fire(this._createStateObject()),this._lastPromptLine&&this._commandStartX!==this._lastPromptLine.length&&this._xterm.buffer.active.getLine(this._commandStartMarker.line)?.translateToString(!0).startsWith(this._lastPromptLine)&&(this._commandStartX=this._lastPromptLine.length,this._sync()))}_handleCommandExecuted(){if(this._state===W.Execute)return;this._cursorIndex=-1,this._ghostTextIndex!==-1&&(this._value=this._value.substring(0,this._ghostTextIndex),this._ghostTextIndex=-1);const o=this._createStateObject();this._lastUserInput===""&&(this._lastUserInput="",this._onDidInterrupt.fire(o)),this._state=W.Execute,this._onDidFinishInput.fire(o),this._onDidChangeInput.fire(o)}_sync(){try{this._doSync()}catch(o){this._logService.error("Error while syncing prompt input model",o)}}_doSync(){if(this._state!==W.Input)return;const o=this._commandStartMarker?.line;if(o===void 0)return;const w=this._xterm.buffer.active;let _=w.getLine(o);const f=_?.translateToString(!0,this._commandStartX);if(!_||f===void 0){this._logService.trace("PromptInputModel#_sync: no line");return}const c=w.baseY+w.cursorY;let l=f,h=-1,m;c===o?m=this._getRelativeCursorIndex(this._commandStartX,w,_):m=f.trimEnd().length,c===o&&w.cursorX>1&&(h=this._scanForGhostText(w,_,m));for(let u=o+1;u<=c;u++){_=w.getLine(u);const r=_?.translateToString(!0);if(r&&_)if(_.isWrapped){l+=r;const p=this._getRelativeCursorIndex(0,w,_);c===u?m+=p:m+=r.length}else if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r)){const p=this._trimContinuationPrompt(r);if(l+=`
${p}`,c===u){const b=this._getContinuationPromptCellWidth(_,r),s=this._getRelativeCursorIndex(b,w,_);m+=s+1}else m+=p.length+1}else break}for(let u=c+1;u<w.baseY+this._xterm.rows;u++){_=w.getLine(u);const r=_?.translateToString(!0);if(r&&_)if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r))l+=`
${this._trimContinuationPrompt(r)}`;else break;else break}this._logService.getLevel()===L.LogLevel.Trace&&this._logService.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let u=this._value.length-this._value.trimEnd().length;this._lastUserInput==="\x7F"&&(this._lastUserInput="",m===this._cursorIndex-1&&(this._value.trimEnd().length>l.trimEnd().length&&l.trimEnd().length<=m?u=Math.max(this._value.length-1-l.trimEnd().length,0):u=Math.max(u-1,0))),this._lastUserInput==="\x1B[3~"&&(this._lastUserInput="",m===this._cursorIndex&&(u=Math.max(u-1,0)));const r=l.split(`
`),p=r.length>1,b=l.trimEnd();if(!p){b.length<l.length&&(this._lastUserInput===" "&&(this._lastUserInput="",m>b.length&&m>this._cursorIndex&&u++),u=Math.max(m-b.length,u,0));const s=m===0?"":l[m-1];u>0&&m===this._cursorIndex+1&&this._lastUserInput!==""&&s!==" "&&(u=this._value.length-this._cursorIndex)}if(p){r[r.length-1]=r.at(-1)?.trimEnd()??"";const s=(r.length-1)*(this._continuationPrompt?.length??0);u=Math.max(0,m-l.length-s)}l=r.map(s=>s.trimEnd()).join(`
`)+" ".repeat(u)}(this._value!==l||this._cursorIndex!==m||this._ghostTextIndex!==h)&&(this._value=l,this._cursorIndex=m,this._ghostTextIndex=h,this._onDidChangeInput.fire(this._createStateObject()))}_handleUserInput(o){this._lastUserInput=o}_scanForGhostText(o,w,_){let f=-1,c=!1,l=o.cursorX;for(;l>0;){const h=w.getCell(--l);if(!h)break;if(h.getChars().trim().length>0){c=!this._isCellStyledLikeGhostText(h);break}}if(c){let h=0,m=o.cursorX;for(;m<w.length;){const u=w.getCell(m++);if(!u||u.getCode()===0)break;if(this._isCellStyledLikeGhostText(u)){f=_+h;break}h+=u.getChars().length}}return f}_trimContinuationPrompt(o){return this._lineContainsContinuationPrompt(o)&&(o=o.substring(this._continuationPrompt.length)),o}_lineContainsContinuationPrompt(o){return!!(this._continuationPrompt&&o.startsWith(this._continuationPrompt))}_getContinuationPromptCellWidth(o,w){if(!this._continuationPrompt||!w.startsWith(this._continuationPrompt))return 0;let _="",f=0;for(;_!==this._continuationPrompt;)_+=o.getCell(f++).getChars();return f}_getRelativeCursorIndex(o,w,_){return _?.translateToString(!0,o,w.cursorX).length??0}_isCellStyledLikeGhostText(o){return!!(o.isItalic()||o.isDim())}_createStateObject(){return Object.freeze({value:this._value,cursorIndex:this._cursorIndex,ghostTextIndex:this._ghostTextIndex})}};e.PromptInputModel=P,_e([(0,y.throttle)(0)],P.prototype,"_sync",null),e.PromptInputModel=P=_e([ze(3,L.ILogService)],P)}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class a{get command(){return this._properties.command}get commandLineConfidence(){return this._properties.commandLineConfidence}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(w){this._properties.endMarker=w}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(w,_){this._xterm=w,this._properties=_}static deserialize(w,_,f){const c=w.buffer.normal,l=_.startLine!==void 0?w.registerMarker(_.startLine-(c.baseY+c.cursorY)):void 0;if(!l)return;const h=_.promptStartLine!==void 0?w.registerMarker(_.promptStartLine-(c.baseY+c.cursorY)):void 0,m=_.endLine!==void 0?w.registerMarker(_.endLine-(c.baseY+c.cursorY)):void 0,u=_.executedLine!==void 0?w.registerMarker(_.executedLine-(c.baseY+c.cursorY)):void 0;return new a(w,{command:f?"":_.command,commandLineConfidence:_.commandLineConfidence??"low",isTrusted:_.isTrusted,promptStartMarker:h,marker:l,startX:_.startX,endMarker:m,executedMarker:u,executedX:_.executedX,timestamp:_.timestamp,duration:_.duration,cwd:_.cwd,commandStartLineContent:_.commandStartLineContent,exitCode:_.exitCode,markProperties:_.markProperties,aliases:void 0,wasReplayed:!0})}serialize(w){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:w?"":this.command,commandLineConfidence:w?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return L(this._xterm.buffer.active,this._xterm.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const w=this.executedMarker.line,_=this.endMarker.line;if(w===_)return;let f="",c;for(let l=w;l<_;l++)c=this._xterm.buffer.active.getLine(l),c&&(f+=c.translateToString(!c.isWrapped)+(c.isWrapped?"":`
`));return f===""?void 0:f}getOutputMatch(w){if(!this.executedMarker||!this.endMarker)return;const _=this.endMarker.line;if(_===-1)return;const f=this._xterm.buffer.active,c=Math.max(this.executedMarker.line,0),l=w.lineMatcher,h=typeof l=="string"?1:w.length||W(l),m=[];let u;if(w.anchor==="bottom")for(let r=_-(w.offset||0);r>=c;r--){let p=r;const b=r;for(;p>=c&&f.getLine(p)?.isWrapped;)p--;if(r=p,m.unshift(y(f,p,b,this._xterm.cols)),u||(u=m[0].match(l)),m.length>=h)break}else for(let r=c+(w.offset||0);r<_;r++){const p=r;let b=r;for(;b+1<_&&f.getLine(b+1)?.isWrapped;)b++;if(r=b,m.push(y(f,p,b,this._xterm.cols)),u||(u=m[m.length-1].match(l)),m.length>=h)break}return u?{regexMatch:u,outputLines:m}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return v(this)}}e.TerminalCommand=a;class t{constructor(w){this._xterm=w}serialize(w){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:w,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(w,_,f,c){if(_===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||f)return new a(this._xterm,{command:f?"":this.command||"",commandLineConfidence:f?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:w,exitCode:_,commandStartLineContent:this.commandStartLineContent,markProperties:c})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}extractCommandLine(){return L(this._xterm.buffer.active,this._xterm.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return v(this)}}e.PartialTerminalCommand=t;function L(o,w,_,f,c,l){if(!_||!c||f===void 0||l===void 0)return"";let h="";for(let m=_.line;m<=c.line;m++){const u=o.getLine(m);u&&(h+=u.translateToString(!0,m===_.line?f:0,m===c.line?l:w))}return h}function y(o,w,_,f){const c=Math.max(2048/f*2);_=Math.min(_,w+c);let l="";for(let h=w;h<=_;h++){const m=o.getLine(h);m&&(l+=m.translateToString(!0,0,f))}return l}function W(o){if(!o.multiline)return 1;const w=o.source;let _=1,f=w.indexOf("\\n");for(;f!==-1;)_++,f=w.indexOf("\\n",f+1);return _}function P(o,w){const _="hasOutput"in o?o.marker:o.commandStartMarker;if(!_||!o.promptStartMarker)return 1;let f=1,c=o.promptStartMarker.line;for(;c<_.line&&(w.getLine(c)?.translateToString(!0)??"").length===0;)c++;return f=_.line-c+1,f}function v(o){const w="hasOutput"in o?o.marker:o.commandStartMarker,_="hasOutput"in o?o.executedMarker:o.commandExecutedMarker;if(!w||!_)return 1;let c=Math.max(_.line,w.line)-w.line+1;return("hasOutput"in o?o.executedX:o.commandExecutedX)===0&&c--,c}}),define(he[94],fe([0,1,12,15,4,2,8,24,93,92]),function(ie,e,a,t,L,y,W,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandDetectionCapability=void 0,e.getLinesForCommand=l;let w=class extends y.Disposable{get promptInputModel(){return this._promptInputModel}get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get promptTerminator(){return this._promptTerminator}constructor(r,p){super(),this._terminal=r,this._logService=p,this.type=P.TerminalCapability.CommandDetection,this._commands=[],this._currentCommand=new v.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new L.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new L.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new L.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new L.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new L.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new L.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event,this._promptInputModel=this._register(new o.PromptInputModel(this._terminal,this.onCommandStarted,this.onCommandExecuted,this._logService)),this._register(this.onCommandExecuted(s=>{if(s.commandLineConfidence!=="high"){const i=s;s.command=i.extractCommandLine(),s.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&s.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(s.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&s.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(s.commandLineConfidence="medium")}}));const b=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return b._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return b._onCommandStarted}get onCommandExecutedEmitter(){return b._onCommandExecuted}get dimensions(){return b._dimensions}get isCommandStorageDisabled(){return b.__isCommandStorageDisabled}get commandMarkers(){return b._commandMarkers}set commandMarkers(s){b._commandMarkers=s}get clearCommandsInViewport(){return b._clearCommandsInViewport.bind(b)}commitCommandFinished(){b._commitCommandFinished?.flush(),b._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new y.MandatoryMutableDisposable(new _(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(s=>this._handleResize(s))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(r){this._ptyHeuristics.value.preHandleResize?.(r),this._dimensions.cols=r.cols,this._dimensions.rows=r.rows}_handleCursorMove(){this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:P.CommandInvalidationReason.Windows}))}_clearCommandsInViewport(){let r=0;for(let p=this._commands.length-1;p>=0;p--){const b=this._commands[p].marker?.line;if(b&&b<this._terminal.buffer.active.baseY)break;r++}r>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-r,r))}setContinuationPrompt(r){this._promptInputModel.setContinuationPrompt(r)}setPromptTerminator(r,p){this._logService.debug("CommandDetectionCapability#setPromptTerminator",r),this._promptTerminator=r,this._promptInputModel.setLastPromptLine(p)}setCwd(r){this._cwd=r}setIsWindowsPty(r){if(r&&!(this._ptyHeuristics.value instanceof c)){const p=this;this._ptyHeuristics.value=new c(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return p._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return p._onCommandStarted}get onCommandExecutedEmitter(){return p._onCommandExecuted}get dimensions(){return p._dimensions}get isCommandStorageDisabled(){return p.__isCommandStorageDisabled}get commandMarkers(){return p._commandMarkers}set commandMarkers(b){p._commandMarkers=b}get clearCommandsInViewport(){return p._clearCommandsInViewport.bind(p)}commitCommandFinished(){p._commitCommandFinished?.flush(),p._commitCommandFinished=void 0}},this._logService)}else!r&&!(this._ptyHeuristics.value instanceof _)&&(this._ptyHeuristics.value=new _(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(r){if(this._currentCommand.promptStartMarker&&r>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>r)){for(let p=this.commands.length-1;p>=0;p--)if((this.commands[p].promptStartMarker??this.commands[p].marker).line<=r)return this.commands[p]}}getCwdForLine(r){if(this._currentCommand.promptStartMarker&&r>=this._currentCommand.promptStartMarker?.line)return this._cwd;const p=this.getCommandForLine(r);if(p&&"cwd"in p)return p.cwd}handlePromptStart(r){const p=this.commands.at(-1);p?.endMarker&&p?.executedMarker&&p.endMarker.line===p.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${p.endMarker.line} -> ${p.executedMarker.line+1}`),p.endMarker=m(this._terminal,p.executedMarker,1)),this._currentCommand.promptStartMarker=r?.marker||(p?.endMarker?m(this._terminal,p.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(r){if(this._handleCommandStartOptions=r,this._currentCommand.cwd=this._cwd,this._currentCommand.commandStartMarker=r?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(r)}handleGenericCommand(r){r?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(r),this.handleCommandStart(r),this.handleCommandExecuted(r),this.handleCommandFinished(void 0,r)}handleCommandExecuted(r){this._ptyHeuristics.value.handleCommandExecuted(r),this._currentCommand.markExecutedTime()}handleCommandFinished(r,p){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,p?.marker?.line,this._currentCommand.command,this._currentCommand),r===void 0){const s=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&s?.command===this._currentCommand.command&&(r=s.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=p?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const b=this._currentCommand.promoteToFullCommand(this._cwd,r,this._handleCommandStartOptions?.ignoreCommandLine??!1,p?.markProperties);b&&(this._commands.push(b),this._commitCommandFinished=new a.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(b),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",b),this._onCommandFinished.fire(b))},50),this._commitCommandFinished.schedule()),this._currentCommand=new v.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(r,p){this._logService.debug("CommandDetectionCapability#setCommandLine",r,p),this._currentCommand.command=r,this._currentCommand.commandLineConfidence="high",this._currentCommand.isTrusted=p,p&&this._promptInputModel.setConfidentCommandLine(r)}serialize(){const r=this.commands.map(b=>b.serialize(this.__isCommandStorageDisabled)),p=this._currentCommand.serialize(this._cwd);return p&&r.push(p),{isWindowsPty:this._ptyHeuristics.value instanceof c,commands:r,promptInputModel:this._promptInputModel.serialize()}}deserialize(r){r.isWindowsPty&&this.setIsWindowsPty(r.isWindowsPty);const p=this._terminal.buffer.normal;for(const b of r.commands){if(!b.endLine){const i=b.startLine!==void 0?this._terminal.registerMarker(b.startLine-(p.baseY+p.cursorY)):void 0;if(!i)continue;this._currentCommand.commandStartMarker=b.startLine!==void 0?this._terminal.registerMarker(b.startLine-(p.baseY+p.cursorY)):void 0,this._currentCommand.commandStartX=b.startX,this._currentCommand.promptStartMarker=b.promptStartLine!==void 0?this._terminal.registerMarker(b.promptStartLine-(p.baseY+p.cursorY)):void 0,this._cwd=b.cwd,this._onCommandStarted.fire({marker:i});continue}const s=v.TerminalCommand.deserialize(this._terminal,b,this.__isCommandStorageDisabled);s&&(this._commands.push(s),this._logService.debug("CommandDetectionCapability#onCommandFinished",s),this._onCommandFinished.fire(s))}r.promptInputModel&&this._promptInputModel.deserialize(r.promptInputModel)}};e.CommandDetectionCapability=w,_e([(0,t.debounce)(500)],w.prototype,"_handleCursorMove",null),e.CommandDetectionCapability=w=_e([ze(1,W.ILogService)],w);class _ extends y.Disposable{constructor(r,p,b,s){super(),this._terminal=r,this._capability=p,this._hooks=b,this._logService=s,this._register(r.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&b.clearCommandsInViewport(),!1)))}handleCommandStart(r){this._hooks.commitCommandFinished();const p=this._capability.currentCommand;p.commandStartX=this._terminal.buffer.active.cursorX,p.commandStartMarker=r?.marker||this._terminal.registerMarker(0),p.commandExecutedMarker?.dispose(),p.commandExecutedMarker=void 0,p.commandExecutedX=void 0;for(const b of this._hooks.commandMarkers)b.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:r?.marker||p.commandStartMarker,markProperties:r?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",p.commandStartX,p.commandStartMarker?.line)}handleCommandExecuted(r){const p=this._capability.currentCommand;if(p.commandExecutedMarker=r?.marker||this._terminal.registerMarker(0),p.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",p.commandExecutedX,p.commandExecutedMarker?.line),!p.commandStartMarker||!p.commandExecutedMarker||p.commandStartX===void 0)return;p.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(p.commandStartMarker.line)?.translateToString(!0,p.commandStartX,p.commandRightPromptStartX).trim();let b=p.commandStartMarker.line+1;const s=p.commandExecutedMarker.line;for(;b<s;b++){const i=this._terminal.buffer.active.getLine(b);if(i){const n=p.continuations?.find(A=>A.marker.line===b);n&&(p.command+=`
`);const S=n?.end??0;p.command+=i.translateToString(!0,S)}}b===s&&(p.command+=this._terminal.buffer.active.getLine(s)?.translateToString(!0,void 0,p.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire(p)}}var f;(function(u){u[u.MaxCheckLineCount=10]="MaxCheckLineCount",u[u.Interval=20]="Interval",u[u.MaximumPollCount=10]="MaximumPollCount"})(f||(f={}));let c=class extends y.Disposable{constructor(r,p,b,s){super(),this._terminal=r,this._capability=p,this._hooks=b,this._logService=s,this._onCursorMoveListener=this._register(new y.MutableDisposable),this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(r.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this._hooks.clearCommandsInViewport(),!1))),this._register(this._capability.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:P.CommandInvalidationReason.Windows}))}))}preHandleResize(r){const p=this._terminal.buffer.active.baseY,b=r.rows-this._hooks.dimensions.rows;b>0&&this._waitForCursorMove().then(()=>{const s=Math.min(b,p);for(let i=this._capability.commands.length-1;i>=0;i--){const n=this._capability.commands[i];if(!n.marker||n.marker.line<p||n.commandStartLineContent===void 0)break;const S=this._terminal.buffer.active.getLine(n.marker.line);if(!S||S.translateToString(!0)===n.commandStartLineContent)continue;const A=n.marker.line-s;this._terminal.buffer.active.getLine(A)?.translateToString(!0)===n.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:s})}})}handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const r=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?m(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new a.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(r),f.Interval),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(r){if(this._store.isDisposed)return;const p=this._terminal.buffer.active;let b=this._tryAdjustCommandStartMarkerScannedLineCount;for(;b<f.MaxCheckLineCount&&r.line+b<p.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const s=this._getWindowsPrompt(r.line+b);if(s){const i=typeof s=="string"?s:s.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof s=="object"&&s.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=m(this._terminal,this._capability.currentCommand.commandStartMarker);const n=this._capability.commands.at(-1);n&&this._capability.currentCommand.commandStartMarker.line!==n.endMarker?.line&&(n.endMarker?.dispose(),n.endMarker=m(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=i.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${r.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}b++}b<f.MaxCheckLineCount?(this._tryAdjustCommandStartMarkerScannedLineCount=b,++this._tryAdjustCommandStartMarkerPollCount<f.MaximumPollCount?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=f.MaximumPollCount,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const r=this._terminal.registerMarker(0);r&&this._hooks.commandMarkers.push(r)}})),this._capability.currentCommand.commandStartMarker){const r=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);r&&(this._capability.currentCommand.commandStartLineContent=r.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(r){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const r=this._capability.currentCommand,p=r.command,b=r.commandStartMarker?.line,s=r.commandExecutedMarker?.line;if(!p||p.length===0||b===void 0||b===-1||s===void 0||s===-1)return;let i=0,n=!1;for(let S=b;S<=s;S++){const A=this._terminal.buffer.active.getLine(S);if(!A)break;const O=A.translateToString(!0);for(let E=0;E<O.length;E++){for(;p.length<i&&p[i]===" ";)i++;if(O[E]===p[i]&&i++,i===p.length){const D=E>=this._terminal.cols-1;r.commandExecutedMarker=this._terminal.registerMarker(S-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(D?1:0)),r.commandExecutedX=D?0:E+1,n=!0;break}}if(n)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((r,p)=>r.line-p.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const r=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);r&&(this._capability.currentCommand.commandStartLineContent=r.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand)}}_cursorOnNextLine(){const r=this._capability.commands.at(-1);if(!r)return!0;const p=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,b=(r.endMarker?r.endMarker.line:r.marker?.line)??-1;return p>b}_waitForCursorMove(){const r=this._terminal.buffer.active.cursorX,p=this._terminal.buffer.active.cursorY;let b=0;return new Promise((s,i)=>{const n=setInterval(()=>{if(r!==this._terminal.buffer.active.cursorX||p!==this._terminal.buffer.active.cursorY){s(),clearInterval(n);return}b+=10,b>1e3&&(clearInterval(n),s())},10)})}_getWindowsPrompt(r=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const p=this._terminal.buffer.active.getLine(r);if(!p)return;const b=p.translateToString(!0);if(!b)return;const s=b.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(s){const O=this._adjustPrompt(s,b,">");if(O)return{prompt:O,likelySingleLine:!0}}const i=b.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const O=this._adjustPrompt(i,b,"\u276F");if(O)return O}const n=b.match(/^(?<prompt>\$)/)?.groups?.prompt;if(n){const O=this._adjustPrompt(n,b,"$");if(O)return O}const S=b.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(S)return{prompt:S,likelySingleLine:!0};if(this._capability.promptTerminator&&b.trim().endsWith(this._capability.promptTerminator)){const O=this._adjustPrompt(b,b,this._capability.promptTerminator);if(O)return O}const A=b.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return A?.groups?.prompt?{prompt:A.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(r,p,b){if(r)return p===r&&r.endsWith(b)&&(r+=" "),r}};c=_e([ze(3,W.ILogService)],c);function l(u,r,p,b){if(!b)return;const s=r.executedMarker,i=r.endMarker;if(!s||!i)return;const n=s.line,S=i.line,A=b.length,O=[];if(b.anchor==="bottom")for(let E=S-(b.offset||0);E>=n;E--){let D=E;const I=E;for(;D>=n&&u.getLine(D)?.isWrapped;)D--;E=D,O.unshift(h(u,D,I,p)),O.length>A&&O.pop()}else for(let E=n+(b.offset||0);E<S;E++){const D=E;let I=E;for(;I+1<S&&u.getLine(I+1)?.isWrapped;)I++;E=I,O.push(h(u,D,I,p)),O.length===A&&O.shift()}return O}function h(u,r,p,b){const s=Math.max(2048/b*2);p=Math.min(p,r+s);let i="";for(let n=r;n<=p;n++){const S=u.getLine(n);S&&(i+=S.translateToString(!0,0,b))}return i}function m(u,r,p=0){return u.registerMarker(r.line-(u.buffer.active.baseY+u.buffer.active.cursorY)+p)}}),define(he[95],fe([0,1,4,2,24]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class y extends t.Disposable{constructor(){super(...arguments),this.type=L.TerminalCapability.CwdDetection,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new a.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(P){const v=this._cwd!==P;this._cwd=P;const o=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,o+1),v&&this._onDidChangeCwd.fire(P)}}e.CwdDetectionCapability=y}),define(he[96],fe([0,1,4,2,24]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var y;(function(P){P[P.MinimumPromptLength=2]="MinimumPromptLength"})(y||(y={}));class W extends t.DisposableStore{get commands(){return this._commands}constructor(v){super(),this._terminal=v,this.type=L.TerminalCapability.PartialCommandDetection,this._commands=[],this._onCommandFinished=this.add(new a.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(o=>this._onData(o))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},o=>(o.length>=1&&(o[0]===2||o[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(v){v==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=y.MinimumPromptLength){const v=this._terminal.registerMarker(0);v&&(this._commands.push(v),this._onCommandFinished.fire(v))}}_clearCommandsInViewport(){let v=0;for(let o=this._commands.length-1;o>=0&&!(this._commands[o].line<this._terminal.buffer.active.baseY);o--)v++;this._commands.splice(this._commands.length-v,v)}}e.PartialCommandDetectionCapability=W}),define(he[97],fe([0,1,4,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class L extends t.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new a.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new a.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new a.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new a.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(P,v){this._map.set(P,v),this._onDidAddCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:v})}get(P){return this._map.get(P)}remove(P){const v=this._map.get(P);v&&(this._map.delete(P),this._onDidRemoveCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:v}))}has(P){return this._map.has(P)}}e.TerminalCapabilityStore=L;class y extends t.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new a.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new a.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new a.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new a.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const P of this._stores)for(const v of P.items)yield v}has(P){for(const v of this._stores)for(const o of v.items)if(o===P)return!0;return!1}get(P){for(const v of this._stores){const o=v.get(P);if(o)return o}}add(P){this._stores.push(P);for(const v of P.items)this._onDidAddCapabilityType.fire(v),this._onDidAddCapability.fire({id:v,capability:P.get(v)});this._register(P.onDidAddCapabilityType(v=>this._onDidAddCapabilityType.fire(v))),this._register(P.onDidAddCapability(v=>this._onDidAddCapability.fire(v))),this._register(P.onDidRemoveCapabilityType(v=>this._onDidRemoveCapabilityType.fire(v))),this._register(P.onDidRemoveCapability(v=>this._onDidRemoveCapability.fire(v)))}}e.TerminalCapabilityStoreMultiplexer=y}),define(he[39],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var a;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(a||(e.EnvironmentVariableMutatorType=a={}))}),define(he[98],fe([0,1,3,39]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const L=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class y{constructor(w){this.collections=w,this.map=new Map,this.descriptionMap=new Map,w.forEach((_,f)=>{this.populateDescriptionMap(_,f);const c=_.map.entries();let l=c.next();for(;!l.done;){const h=l.value[1],m=l.value[0];let u=this.map.get(m);if(u||(u=[],this.map.set(m,u)),u.length>0&&u[0].type===t.EnvironmentVariableMutatorType.Replace){l=c.next();continue}const r={extensionIdentifier:f,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};r.scope||delete r.scope,u.unshift(r),l=c.next()}})}async applyToProcessEnvironment(w,_,f){let c;a.isWindows&&(c={},Object.keys(w).forEach(l=>c[l.toLowerCase()]=l));for(const[l,h]of this.getVariableMap(_)){const m=a.isWindows&&c[l.toLowerCase()]||l;for(const u of h){const r=f?await f(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case t.EnvironmentVariableMutatorType.Append:w[m]=(w[m]||"")+r;break;case t.EnvironmentVariableMutatorType.Prepend:w[m]=r+(w[m]||"");break;case t.EnvironmentVariableMutatorType.Replace:w[m]=r;break}if(u.options?.applyAtShellIntegration??!1){const p=`VSCODE_ENV_${L.get(u.type)}`;w[p]=(w[p]?w[p]+":":"")+l+"="+this._encodeColons(r)}}}}_encodeColons(w){return w.replaceAll(":","\\x3a")}diff(w,_){const f=new Map,c=new Map,l=new Map;if(w.getVariableMap(_).forEach((h,m)=>{const u=this.getVariableMap(_).get(m),r=P(h,u);r&&f.set(m,r)}),this.getVariableMap(_).forEach((h,m)=>{const u=w.getVariableMap(_).get(m),r=P(h,u);r&&l.set(m,r)}),this.getVariableMap(_).forEach((h,m)=>{const u=w.getVariableMap(_).get(m),r=v(h,u);r&&c.set(m,r)}),!(f.size===0&&c.size===0&&l.size===0))return{added:f,changed:c,removed:l}}getVariableMap(w){const _=new Map;for(const f of this.map.values()){const c=f.filter(l=>W(l,w));c.length>0&&_.set(c[0].variable,c)}return _}getDescriptionMap(w){const _=new Map;for(const f of this.descriptionMap.values()){const c=f.filter(l=>W(l,w,!0));for(const l of c)_.set(l.extensionIdentifier,l.description)}return _}populateDescriptionMap(w,_){if(!w.descriptionMap)return;const f=w.descriptionMap.entries();let c=f.next();for(;!c.done;){const l=c.value[1],h=c.value[0];let m=this.descriptionMap.get(h);m||(m=[],this.descriptionMap.set(h,m));const u={extensionIdentifier:_,scope:l.scope,description:l.description};u.scope||delete u.scope,m.push(u),c=f.next()}}}e.MergedEnvironmentVariableCollection=y;function W(o,w,_=!1){return o.scope?!!(o.scope.workspaceFolder&&w?.workspaceFolder&&o.scope.workspaceFolder.index===w.workspaceFolder.index):_?w===o.scope:!0}function P(o,w){if(!w)return o;const _=new Set;w.forEach(c=>_.add(c.extensionIdentifier));const f=[];return o.forEach(c=>{_.has(c.extensionIdentifier)||f.push(c)}),f.length===0?void 0:f}function v(o,w){if(!w)return;const _=new Map;w.forEach(c=>_.set(c.extensionIdentifier,c));const f=[];return o.forEach(c=>{const l=_.get(c.extensionIdentifier);l&&(c.type!==l.type||c.value!==l.value||c.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&f.push(l)}),f.length===0?void 0:f}}),define(he[99],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=a,e.serializeEnvironmentDescriptionMap=t,e.deserializeEnvironmentVariableCollection=L,e.deserializeEnvironmentDescriptionMap=y,e.serializeEnvironmentVariableCollections=W,e.deserializeEnvironmentVariableCollections=P;function a(v){return[...v.entries()]}function t(v){return v?[...v.entries()]:[]}function L(v){return new Map(v)}function y(v){return new Map(v??[])}function W(v){return Array.from(v.entries()).map(o=>[o[0],a(o[1].map),t(o[1].descriptionMap)])}function P(v){return new Map(v.map(o=>[o[0],{map:L(o[1]),descriptionMap:y(o[2])}]))}}),define(he[100],fe([0,1,12,19,4,2,8]),function(ie,e,a,t,L,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends y.Disposable{constructor(o,w){super(),this._logService=w,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=o===void 0?15e3:o,this._register((0,y.toDisposable)(()=>{for(const _ of this._pendingRequestDisposables.values())(0,y.dispose)(_)}))}createRequest(o){return new Promise((w,_)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,w),this._onCreateRequest.fire({requestId:f,...o});const c=new t.CancellationTokenSource;(0,a.timeout)(this._timeout,c.token).then(()=>_(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,y.toDisposable)(()=>c.cancel())])})}acceptReply(o,w){const _=this._pendingRequests.get(o);_?(this._pendingRequests.delete(o),(0,y.dispose)(this._pendingRequestDisposables.get(o)||[]),this._pendingRequestDisposables.delete(o),_(w)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${o}`)}};e.RequestStore=P,e.RequestStore=P=_e([ze(1,W.ILogService)],P)}),define(he[17],fe([0,1,23,38,90]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new t.RawContextKey("terminalTabFocusMode",!1,!0);var y;(function(s){s.AutomationProfile="terminal.integrated.automationProfile.",s.DefaultProfile="terminal.integrated.defaultProfile.",s.Profiles="terminal.integrated.profiles."})(y||(e.TerminalSettingPrefix=y={}));var W;(function(s){s.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",s.AutomationProfileLinux="terminal.integrated.automationProfile.linux",s.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",s.AutomationProfileWindows="terminal.integrated.automationProfile.windows",s.ProfilesWindows="terminal.integrated.profiles.windows",s.ProfilesMacOs="terminal.integrated.profiles.osx",s.ProfilesLinux="terminal.integrated.profiles.linux",s.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",s.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",s.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",s.UseWslProfiles="terminal.integrated.useWslProfiles",s.TabsDefaultColor="terminal.integrated.tabs.defaultColor",s.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",s.TabsEnabled="terminal.integrated.tabs.enabled",s.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",s.TabsHideCondition="terminal.integrated.tabs.hideCondition",s.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",s.TabsShowActions="terminal.integrated.tabs.showActions",s.TabsLocation="terminal.integrated.tabs.location",s.TabsFocusMode="terminal.integrated.tabs.focusMode",s.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",s.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",s.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",s.CopyOnSelection="terminal.integrated.copyOnSelection",s.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",s.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",s.FontFamily="terminal.integrated.fontFamily",s.FontSize="terminal.integrated.fontSize",s.LetterSpacing="terminal.integrated.letterSpacing",s.LineHeight="terminal.integrated.lineHeight",s.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",s.TabStopWidth="terminal.integrated.tabStopWidth",s.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",s.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",s.BellDuration="terminal.integrated.bellDuration",s.FontWeight="terminal.integrated.fontWeight",s.FontWeightBold="terminal.integrated.fontWeightBold",s.CursorBlinking="terminal.integrated.cursorBlinking",s.CursorStyle="terminal.integrated.cursorStyle",s.CursorStyleInactive="terminal.integrated.cursorStyleInactive",s.CursorWidth="terminal.integrated.cursorWidth",s.Scrollback="terminal.integrated.scrollback",s.DetectLocale="terminal.integrated.detectLocale",s.DefaultLocation="terminal.integrated.defaultLocation",s.GpuAcceleration="terminal.integrated.gpuAcceleration",s.TerminalTitleSeparator="terminal.integrated.tabs.separator",s.TerminalTitle="terminal.integrated.tabs.title",s.TerminalDescription="terminal.integrated.tabs.description",s.RightClickBehavior="terminal.integrated.rightClickBehavior",s.MiddleClickBehavior="terminal.integrated.middleClickBehavior",s.Cwd="terminal.integrated.cwd",s.ConfirmOnExit="terminal.integrated.confirmOnExit",s.ConfirmOnKill="terminal.integrated.confirmOnKill",s.EnableBell="terminal.integrated.enableBell",s.EnableVisualBell="terminal.integrated.enableVisualBell",s.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",s.AllowChords="terminal.integrated.allowChords",s.AllowMnemonics="terminal.integrated.allowMnemonics",s.TabFocusMode="terminal.integrated.tabFocusMode",s.EnvMacOs="terminal.integrated.env.osx",s.EnvLinux="terminal.integrated.env.linux",s.EnvWindows="terminal.integrated.env.windows",s.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",s.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",s.ShowExitAlert="terminal.integrated.showExitAlert",s.SplitCwd="terminal.integrated.splitCwd",s.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",s.WordSeparators="terminal.integrated.wordSeparators",s.EnableFileLinks="terminal.integrated.enableFileLinks",s.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",s.UnicodeVersion="terminal.integrated.unicodeVersion",s.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",s.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",s.HideOnStartup="terminal.integrated.hideOnStartup",s.CustomGlyphs="terminal.integrated.customGlyphs",s.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",s.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",s.InheritEnv="terminal.integrated.inheritEnv",s.ShowLinkHover="terminal.integrated.showLinkHover",s.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",s.AutoReplies="terminal.integrated.autoReplies",s.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",s.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",s.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",s.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",s.EnableImages="terminal.integrated.enableImages",s.SmoothScrolling="terminal.integrated.smoothScrolling",s.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",s.FocusAfterRun="terminal.integrated.focusAfterRun",s.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",s.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",s.DevMode="terminal.integrated.developer.devMode"})(W||(e.TerminalSettingId=W={}));var P;(function(s){s.PowerShell="pwsh",s.Bash="bash",s.Fish="fish",s.Sh="sh",s.Csh="csh",s.Ksh="ksh",s.Zsh="zsh",s.Python="python"})(P||(e.PosixShellType=P={}));var v;(function(s){s.CommandPrompt="cmd",s.PowerShell="pwsh",s.Wsl="wsl",s.GitBash="gitbash",s.Python="python"})(v||(e.WindowsShellType=v={}));var o;(function(s){s[s.Api=0]="Api",s[s.Process=1]="Process",s[s.Sequence=2]="Sequence",s[s.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var w;(function(s){s.LocalPty="localPty",s.PtyHost="ptyHost",s.PtyHostWindow="ptyHostWindow",s.Logger="logger",s.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var _;(function(s){s.Cwd="cwd",s.InitialCwd="initialCwd",s.FixedDimensions="fixedDimensions",s.Title="title",s.ShellType="shellType",s.HasChildProcesses="hasChildProcesses",s.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",s.OverrideDimensions="overrideDimensions",s.FailedShellIntegrationActivation="failedShellIntegrationActivation",s.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(_||(e.ProcessPropertyType=_={})),e.IPtyService=(0,a.createDecorator)("ptyService");var f;(function(s){s[s.BeatInterval=5e3]="BeatInterval",s[s.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",s[s.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",s[s.SecondWaitMultiplier=1]="SecondWaitMultiplier",s[s.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f||(e.HeartbeatConstants=f={}));var c;(function(s){s[s.Panel=1]="Panel",s[s.Editor=2]="Editor"})(c||(e.TerminalLocation=c={}));var l;(function(s){s.TerminalView="view",s.Editor="editor"})(l||(e.TerminalLocationString=l={}));var h;(function(s){s[s.GraceTime=6e4]="GraceTime",s[s.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var m;(function(s){s[s.HighWatermarkChars=1e5]="HighWatermarkChars",s[s.LowWatermarkChars=5e3]="LowWatermarkChars",s[s.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var u;(function(s){s.GitBash="Git Bash",s.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var r;(function(s){s[s.Off=0]="Off",s[s.FinalTerm=1]="FinalTerm",s[s.VSCode=2]="VSCode"})(r||(e.ShellIntegrationStatus=r={}));var p;(function(s){s[s.Unknown=0]="Unknown",s[s.Shutdown=1]="Shutdown",s[s.Process=2]="Process",s[s.User=3]="User",s[s.Extension=4]="Extension"})(p||(e.TerminalExitReason=p={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class b{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const n=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this._backends.set(n,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}L.Registry.add(e.TerminalExtensions.Backend,new b),e.ILocalPtyService=(0,a.createDecorator)("localPtyService"),e.ITerminalLogService=(0,a.createDecorator)("terminalLogService")}),define(he[101],fe([0,1,12,2,3]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class y extends t.Disposable{constructor(P,v,o,w){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(P.onProcessData(_=>{if(this._paused||this._throttled)return;const f=typeof _=="string"?_:_.data;for(let c=0;c<f.length;c++)f[c]===v[this._pointer]?this._pointer++:this._reset(),this._pointer===v.length&&(w.debug(`Auto reply match: "${v}", response: "${o}"`),P.input(o),this._throttled=!0,(0,a.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){L.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=y}),define(he[102],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(L){this._callback=L,this._terminalBufferMap=new Map}dispose(){for(const L of this._terminalBufferMap.values())L.dispose()}startBuffering(L,y,W=5){const P=y(v=>{const o=typeof v=="string"?v:v.data;let w=this._terminalBufferMap.get(L);if(w){w.data.push(o);return}const _=setTimeout(()=>this.flushBuffer(L),W);w={data:[o],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(L),P.dispose()}},this._terminalBufferMap.set(L,w)});return P}stopBuffering(L){this._terminalBufferMap.get(L)?.dispose()}flushBuffer(L){const y=this._terminalBufferMap.get(L);y&&(this._terminalBufferMap.delete(L),this._callback(L,y.data.join("")))}}e.TerminalDataBufferer=a}),define(he[40],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=t,e.collapseTildePath=L,e.sanitizeCwd=y,e.shouldUseEnvironmentVariableCollection=W;function t(P){let v=P;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace(o,""),`'${v}'`}function L(P,v,o){if(!P)return"";if(!v)return P;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const w=P.replace(/\\/g,"/").toLowerCase(),_=v.replace(/\\/g,"/").toLowerCase();return w.includes(_)?`~${o}${P.slice(v.length+1)}`:P}function y(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),a.OS===a.OperatingSystem.Windows&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function W(P){return!P.strictEnv}}),define(he[103],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=t;var a;(function(L){L[L.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(a||(a={}));function t(L){const y=[];let W=0;for(let P=0;P<L.length-1;P++)(P-W+1>=a.WriteMaxChunkSize||L[P+1]==="\x1B")&&(y.push(L.substring(W,P+1)),W=P+1,P++);return W!==L.length&&y.push(L.substring(W)),y}}),define(he[104],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=a;function a(t,L={}){let y="";return L.excludeLeadingNewLine||(y+=`\r
`),y+="\x1B[0m\x1B[7m * ",L.loudFormatting?y+="\x1B[0;104m":y+="\x1B[0m",y+=` ${t} \x1B[0m
\r`,y}}),define(he[105],fe([0,1,17,2,97,94,95,24,96,4,91,6,40,10]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ShellIntegrationAddon=e.ShellIntegrationOscPs=void 0,e.deserializeMessage=p,e.parseKeyValueAssignment=b,e.parseMarkSequence=s;var l;(function(i){i[i.FinalTerm=133]="FinalTerm",i[i.VSCode=633]="VSCode",i[i.ITerm=1337]="ITerm",i[i.SetCwd=7]="SetCwd",i[i.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(l||(e.ShellIntegrationOscPs=l={}));var h;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D"})(h||(h={}));var m;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D",i.CommandLine="E",i.ContinuationStart="F",i.ContinuationEnd="G",i.RightPromptStart="H",i.RightPromptEnd="I",i.Property="P",i.SetMark="SetMark"})(m||(m={}));var u;(function(i){i.SetMark="SetMark",i.CurrentDir="CurrentDir"})(u||(u={}));class r extends t.Disposable{get status(){return this._status}constructor(n,S,A,O){super(),this._nonce=n,this._disableTelemetry=S,this._telemetryService=A,this._logService=O,this.capabilities=this._register(new L.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=a.ShellIntegrationStatus.Off,this._onDidChangeStatus=new o.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,t.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,t.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(n){this._terminal=n,this.capabilities.add(P.TerminalCapability.PartialCommandDetection,this._register(new v.PartialCommandDetectionCapability(this._terminal))),this._register(n.parser.registerOscHandler(l.VSCode,S=>this._handleVSCodeSequence(S))),this._register(n.parser.registerOscHandler(l.ITerm,S=>this._doHandleITermSequence(S))),this._commonProtocolDisposables.push(n.parser.registerOscHandler(l.FinalTerm,S=>this._handleFinalTermSequence(S))),this._register(n.parser.registerOscHandler(l.SetCwd,S=>this._doHandleSetCwd(S))),this._register(n.parser.registerOscHandler(l.SetWindowsFriendlyCwd,S=>this._doHandleSetWindowsFriendlyCwd(S))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(n,S){this._createOrGetBufferMarkDetection(n).getMark(S)}_handleFinalTermSequence(n){const S=this._doHandleFinalTermSequence(n);return this._status===a.ShellIntegrationStatus.Off&&(this._status=a.ShellIntegrationStatus.FinalTerm,this._onDidChangeStatus.fire(this._status)),S}_doHandleFinalTermSequence(n){if(!this._terminal)return!1;const[S,...A]=n.split(";");switch(S){case h.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case h.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case h.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case h.CommandFinished:{const O=A.length===1?parseInt(A[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(O),!0}}return!1}_handleVSCodeSequence(n){const S=this._doHandleVSCodeSequence(n);return!this._hasUpdatedTelemetry&&S&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==a.ShellIntegrationStatus.VSCode&&(this._status=a.ShellIntegrationStatus.VSCode,this._onDidChangeStatus.fire(this._status)),S}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(P.TerminalCapability.CommandDetection)&&!this.capabilities.get(P.TerminalCapability.CwdDetection)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(n){if(!this._terminal)return!1;const S=n.indexOf(";"),A=S===-1?n:n.substring(0,S),O=S===-1?[]:n.substring(S+1).split(";");switch(A){case m.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case m.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case m.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case m.CommandFinished:{const E=O[0],D=E!==void 0?parseInt(E):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(D),!0}case m.CommandLine:{const E=O[0],D=O[1];let I;return E!==void 0?I=p(E):I="",this._createOrGetCommandDetection(this._terminal).setCommandLine(I,D===this._nonce),!0}case m.ContinuationStart:return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case m.ContinuationEnd:return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case m.RightPromptStart:return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case m.RightPromptEnd:return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case m.Property:{const E=O[0],D=E!==void 0?p(E):"",{key:I,value:x}=b(D);if(x===void 0)return!0;switch(I){case"ContinuationPrompt":return this._updateContinuationPrompt((0,c.removeAnsiEscapeCodesFromPrompt)(x)),!0;case"Cwd":return this._updateCwd(x),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(x==="True"),!0;case"Prompt":{const z=x.replace(/\x1b\[[0-9;]*m/g,"");return this._updatePromptTerminator(z),!0}case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case m.SetMark:return this._createOrGetBufferMarkDetection(this._terminal).addMark(s(O)),!0}return!1}_updateContinuationPrompt(n){this._terminal&&this._createOrGetCommandDetection(this._terminal).setContinuationPrompt(n)}_updatePromptTerminator(n){if(!this._terminal)return;const S=n.substring(n.lastIndexOf(`
`)+1),A=S.substring(S.lastIndexOf(" "));A&&this._createOrGetCommandDetection(this._terminal).setPromptTerminator(A,S)}_updateCwd(n){n=(0,f.sanitizeCwd)(n),this._createOrGetCwdDetection().updateCwd(n),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setCwd(n)}_doHandleITermSequence(n){if(!this._terminal)return!1;const[S]=n.split(";");switch(S){case u.SetMark:this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:A,value:O}=b(S);if(O===void 0)return!0;switch(A){case u.CurrentDir:return this._updateCwd(O),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(n){if(!this._terminal)return!1;const[S,...A]=n.split(";");switch(S){case"9":return A.length&&this._updateCwd(A[0]),!0}return!1}_doHandleSetCwd(n){if(!this._terminal)return!1;const[S]=n.split(";");if(S.match(/^file:\/\/.*\//)){const A=_.URI.parse(S);if(A.path&&A.path.length>0)return this._updateCwd(A.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(P.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(n){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(n)}_createOrGetCwdDetection(){let n=this.capabilities.get(P.TerminalCapability.CwdDetection);return n||(n=this._register(new W.CwdDetectionCapability),this.capabilities.add(P.TerminalCapability.CwdDetection,n)),n}_createOrGetCommandDetection(n){let S=this.capabilities.get(P.TerminalCapability.CommandDetection);return S||(S=this._register(new y.CommandDetectionCapability(n,this._logService)),this.capabilities.add(P.TerminalCapability.CommandDetection,S)),S}_createOrGetBufferMarkDetection(n){let S=this.capabilities.get(P.TerminalCapability.BufferMarkDetection);return S||(S=this._register(new w.BufferMarkCapability(n)),this.capabilities.add(P.TerminalCapability.BufferMarkDetection,S)),S}}e.ShellIntegrationAddon=r;function p(i){return i.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(n,S,A)=>A?String.fromCharCode(parseInt(A,16)):S)}function b(i){const n=i.indexOf("=");return n===-1?{key:i,value:void 0}:{key:i.substring(0,n),value:i.substring(1+n)}}function s(i){let n,S=!1;for(const A of i)A!==void 0&&(A==="Hidden"&&(S=!0),A.startsWith("Id=")&&(n=A.substring(3)));return{id:n,hidden:S}}}),define(he[41],fe([0,1,5,15,4,2,66,8]),function(ie,e,a,t,L,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var v;(function(w){w[w.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",w[w.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(v||(v={})),e.ignoreProcessNames=[];let o=class extends y.Disposable{set hasChildProcesses(_){this._hasChildProcesses!==_&&(this._hasChildProcesses=_,this._logService.debug("ChildProcessMonitor: Has child processes changed",_),this._onDidChangeHasChildProcesses.fire(_))}get hasChildProcesses(){return this._hasChildProcesses}constructor(_,f){super(),this._pid=_,this._logService=f,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new L.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const _=await(0,W.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(_)}catch(_){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",_)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(_){if(!_.children)return!1;if(_.children.length===1){const f=_.children[0];let c;if(f.cmd.startsWith('"'))c=f.cmd.substring(1,f.cmd.indexOf('"',1));else{const l=f.cmd.indexOf(" ");l===-1?c=f.cmd:c=f.cmd.substring(0,l)}return e.ignoreProcessNames.indexOf((0,a.parse)(c).name)===-1}return _.children.length>0}};e.ChildProcessMonitor=o,_e([(0,t.debounce)(v.ActiveDebounceDuration)],o.prototype,"_refreshActive",null),_e([(0,t.throttle)(v.InactiveThrottleDuration)],o.prototype,"_refreshInactive",null),e.ChildProcessMonitor=o=_e([ze(1,P.ILogService)],o)}),define(he[106],fe([0,1,4,2,17]),function(ie,e,a,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class y extends t.Disposable{constructor(){super(),this._onBeat=this._register(new a.Emitter),this.onBeat=this._onBeat.event;const P=setInterval(()=>{this._onBeat.fire()},L.HeartbeatConstants.BeatInterval);this._register((0,t.toDisposable)(()=>clearInterval(P)))}}e.HeartbeatService=y}),define(he[42],fe([0,1,22,21,33,5,3,16,10,9,27,39,99,98]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=l,e.findExecutable=h,e.getShellIntegrationInjection=m,a=De(a),y=De(y),P=De(P),w=De(w);function l(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(a.release());let D=0;return E&&E.length===4&&(D=parseInt(E[3])),D}async function h(E,D,I,x=P.env,z=w.Promises.exists){if(y.isAbsolute(E))return await z(E)?E:void 0;if(D===void 0&&(D=P.cwd()),y.dirname(E)!=="."){const R=y.join(D,E);return await z(R)?R:void 0}const g=(0,L.getCaseInsensitive)(x,"PATH");if(I===void 0&&(0,o.isString)(g)&&(I=g.split(y.delimiter)),I===void 0||I.length===0){const R=y.join(D,E);return await z(R)?R:void 0}for(const R of I){let C;if(y.isAbsolute(R)?C=y.join(R,E):C=y.join(D,R,E),await z(C))return C;if(W.isWindows){let B=C+".com";if(await z(B)||(B=C+".exe",await z(B)))return B}}const M=y.join(D,E);return await z(M)?M:void 0}function m(E,D,I,x,z){const k=W.isWindows&&(!D.windowsEnableConpty||l()<18309);if(!D.shellIntegration.enabled||!E.executable||E.isFeatureTerminal&&!E.forceShellIntegration||E.ignoreShellIntegration||k)return;const g=E.args,M=P.platform==="win32"?y.basename(E.executable).toLowerCase():y.basename(E.executable),R=y.dirname(t.FileAccess.asFileUri("").fsPath);let C;const B={VSCODE_INJECTION:"1"};if(D.shellIntegration.nonce&&(B.VSCODE_NONCE=D.shellIntegration.nonce),W.isWindows){if(M==="pwsh.exe"||M==="powershell.exe")return!g||A(g)?C=p.get(r.WindowsPwsh):S(g)&&(C=p.get(r.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,v.format)(C[C.length-1],R,""),B.VSCODE_STABLE=z.quality==="stable"?"1":"0",D.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:B}):void 0;if(M==="bash.exe")return!g||g.length===0?C=p.get(r.Bash):O(g)&&(B.VSCODE_SHELL_LOGIN="1",u(D,B),C=p.get(r.Bash)),C?(C=[...C],C[C.length-1]=(0,v.format)(C[C.length-1],R),B.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;x.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args);return}switch(M){case"bash":return!g||g.length===0?C=p.get(r.Bash):O(g)&&(B.VSCODE_SHELL_LOGIN="1",u(D,B),C=p.get(r.Bash)),C?(C=[...C],C[C.length-1]=(0,v.format)(C[C.length-1],R),B.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"fish":{const Z=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=y.join(R,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${Z}:${G}`,u(D,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!g||A(g)?C=p.get(r.Pwsh):S(g)&&(C=p.get(r.PwshLogin)),C?(D.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,v.format)(C[C.length-1],R,""),B.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"zsh":{if(!g||g.length===0?C=p.get(r.Zsh):O(g)?(C=p.get(r.ZshLogin),u(D,B)):(g===p.get(r.Zsh)||g===p.get(r.ZshLogin))&&(C=g),!C)return;C=[...C],C[C.length-1]=(0,v.format)(C[C.length-1],R);let Z;try{Z=a.userInfo().username}catch{Z="unknown"}const G=y.join(a.tmpdir(),`${Z}-${z.applicationName}-zsh`);B.ZDOTDIR=G;const J=I?.ZDOTDIR??a.homedir()??"~";B.USER_ZDOTDIR=J;const se=[];return se.push({source:y.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:y.join(G,".zshrc")}),se.push({source:y.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:y.join(G,".zprofile")}),se.push({source:y.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:y.join(G,".zshenv")}),se.push({source:y.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:y.join(G,".zlogin")}),{newArgs:C,envMixin:B,filesToCopy:se}}}x.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args)}function u(E,D){if(W.isMacintosh&&E.environmentVariableCollections){const I=(0,f.deserializeEnvironmentVariableCollections)(E.environmentVariableCollections),z=new c.MergedEnvironmentVariableCollection(I).getVariableMap({workspaceFolder:E.workspaceFolder}).get("PATH"),k=[];if(z)for(const g of z)g.type===_.EnvironmentVariableMutatorType.Prepend&&k.push(g.value);k.length>0&&(D.VSCODE_PATH_PREFIX=k.join(""))}}var r;(function(E){E.WindowsPwsh="windows-pwsh",E.WindowsPwshLogin="windows-pwsh-login",E.Pwsh="pwsh",E.PwshLogin="pwsh-login",E.Zsh="zsh",E.ZshLogin="zsh-login",E.Bash="bash"})(r||(r={}));const p=new Map;p.set(r.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(r.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(r.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(r.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(r.Zsh,["-i"]),p.set(r.ZshLogin,["-il"]),p.set(r.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],s=["--login","-l"],i=["-i","--interactive"],n=["-nol","-nologo"];function S(E){return typeof E=="string"?b.includes(E.toLowerCase()):E.length===1&&b.includes(E[0].toLowerCase())||E.length===2&&(b.includes(E[0].toLowerCase())||b.includes(E[1].toLowerCase()))&&(n.includes(E[0].toLowerCase())||n.includes(E[1].toLowerCase()))}function A(E){return typeof E=="string"?n.includes(E.toLowerCase()):E.length===0||E?.length===1&&n.includes(E[0].toLowerCase())}function O(E){return typeof E!="string"&&(E=E.filter(D=>!i.includes(D.toLowerCase()))),E==="string"&&s.includes(E.toLowerCase())||typeof E!="string"&&E.length===1&&s.includes(E[0].toLowerCase())}}),define(he[107],fe([0,1,12,15,4,2,3,17]),function(ie,e,a,t,L,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const v=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let o;class w extends y.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(f){if(super(),this._rootProcessId=f,this._shellTitle="",this._onShellNameChanged=new L.Emitter,this._onShellTypeChanged=new L.Emitter,!W.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${W.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){W.isWindows&&(await(0,a.timeout)(300),this.getShellName().then(f=>{const c=this.getShellType(f);c!==this._shellType&&(this._onShellTypeChanged.fire(c),this._onShellNameChanged.fire(f),this._shellType=c,this._shellTitle=f)}))}traverseTree(f){if(!f)return"";if(v.indexOf(f.name)===-1||!f.children||f.children.length===0)return f.name;let c=0;for(;c<f.children.length;c++){const l=f.children[c];if(!l.children||l.children.length===0||l.children[0].name!=="conhost.exe")break}return c>=f.children.length?f.name:this.traverseTree(f.children[c])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(o||(o=await new Promise((f,c)=>{ie(["@vscode/windows-process-tree"],f,c)}).then(De)),this._currentRequest=new Promise(f=>{o.getProcessTree(this._rootProcessId,c=>{const l=this.traverseTree(c);this._currentRequest=void 0,f(l)})}),this._currentRequest)}getShellType(f){switch(f.toLowerCase()){case"cmd.exe":return P.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return P.WindowsShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return P.WindowsShellType.GitBash;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return P.WindowsShellType.Wsl;default:return f.match(/python(\d(\.\d{0,2})?)?\.exe/)?P.WindowsShellType.Python:void 0}}}e.WindowsShellHelper=w,_e([(0,t.debounce)(500)],w.prototype,"checkShell",null)}),define(he[108],fe([0,1,30,12,4,2,5,3,6,27,76,8,89,17,41,42,107,113,103]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c,l,h,m,u,r){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0,W=De(W);var b;(function(A){A[A.DataFlushTimeout=250]="DataFlushTimeout",A[A.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(b||(b={}));var s;(function(A){A[A.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",A[A.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",A[A.WriteInterval=5]="WriteInterval"})(s||(s={}));const i=new Map([["bash",c.PosixShellType.Bash],["csh",c.PosixShellType.Csh],["fish",c.PosixShellType.Fish],["ksh",c.PosixShellType.Ksh],["sh",c.PosixShellType.Sh],["pwsh",c.PosixShellType.PowerShell],["python",c.PosixShellType.Python],["zsh",c.PosixShellType.Zsh]]);let n=class extends y.Disposable{static{p=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return P.isWindows?this._windowsShellHelper?.shellType:i.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(O,E,D,I,x,z,k,g,M){super(),this.shellLaunchConfig=O,this._executableEnv=z,this._options=k,this._logService=g,this._productService=M,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event;let R;P.isWindows?R=W.basename(this.shellLaunchConfig.executable||""):R="xterm-256color",this._initialCwd=E,this._properties[c.ProcessPropertyType.InitialCwd]=this._initialCwd,this._properties[c.ProcessPropertyType.Cwd]=this._initialCwd;const C=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,h.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:R,cwd:E,env:x,cols:D,rows:I,useConpty:C,conptyInheritCursor:C&&!!O.initialText},P.isWindows&&(C&&D===0&&I===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new S,this._register(this._delayedResizer.onTrigger(B=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,B.cols&&B.rows&&this.resize(B.cols,B.rows)}))),this.onProcessReady(B=>{this._windowsShellHelper=this._register(new m.WindowsShellHelper(B.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(Z=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:Z}))),this._register(this._windowsShellHelper.onShellNameChanged(Z=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Title,value:Z})))})),this._register((0,y.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const E=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(I=>I!==void 0);if(E)return E;let D;if(this._options.shellIntegration.enabled)if(D=(0,h.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),D){if(this._onDidChangeProperty.fire({type:c.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),D.envMixin)for(const[I,x]of Object.entries(D.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[I]=x;if(D.filesToCopy)for(const I of D.filesToCopy){await o.Promises.mkdir(W.dirname(I.dest),{recursive:!0});try{await o.Promises.copyFile(I.source,I.dest)}catch{}}}else this._onDidChangeProperty.fire({type:c.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,D),D?.newArgs?{injectedArgs:D.newArgs}:void 0}catch(I){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",I),{message:`A native exception occurred during launch (${I.message})`}}}async _validateCwd(){try{if(!(await o.Promises.stat(this._initialCwd)).isDirectory())return{message:(0,w.localize)(0,null,this._initialCwd.toString())}}catch(O){if(O?.code==="ENOENT")return{message:(0,w.localize)(1,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:c.ProcessPropertyType.InitialCwd,value:this._initialCwd})}async _validateExecutable(){const O=this.shellLaunchConfig;if(!O.executable)throw new Error("IShellLaunchConfig.executable not set");const E=O.cwd instanceof v.URI?O.cwd.path:O.cwd,D=O.env&&O.env.PATH?O.env.PATH.split(W.delimiter):void 0,I=await(0,h.findExecutable)(O.executable,E,D,this._executableEnv);if(!I)return{message:(0,w.localize)(2,null,O.executable)};try{const x=await o.Promises.stat(I);if(!x.isFile()&&!x.isSymbolicLink())return{message:(0,w.localize)(3,null,O.executable)};O.executable=I}catch(x){if(x?.code!=="EACCES")throw x}}async setupPtyProcess(O,E,D){const I=D?.newArgs||O.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",O.executable,I,E);const x=(0,u.spawn)(O.executable,I,E);this._ptyProcess=x,this._childProcessMonitor=this._register(new l.ChildProcessMonitor(x.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(z=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.HasChildProcesses,value:z})),this._processStartupComplete=new Promise(z=>{this.onProcessReady(()=>z())}),x.onData(z=>{this._unacknowledgedCharCount+=z.length,!this._isPtyPaused&&this._unacknowledgedCharCount>c.FlowControlConstants.HighWatermarkChars&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${c.FlowControlConstants.HighWatermarkChars})`),this._isPtyPaused=!0,x.pause()),this._logService.trace("node-pty.IPty#onData",z),this._onProcessData.fire(z),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),x.onExit(z=>{this._exitCode=z.exitCode,this._queueProcessExit()}),this._sendProcessId(x.pid),this._setupTitlePolling(x)}_setupTitlePolling(O){setTimeout(()=>this._sendProcessTitle(O)),P.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==O.process&&this._sendProcessTitle(O)},200))}_queueProcessExit(){this._logService.getLevel()===_.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},b.DataFlushTimeout)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!P.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-p._lastKillOrStart<s.KillSpawnThrottleInterval;)this._logService.trace("Throttling kill/spawn call"),await(0,t.timeout)(s.KillSpawnThrottleInterval-(Date.now()-p._lastKillOrStart)+s.KillSpawnSpacingDuration);p._lastKillOrStart=Date.now()}}_sendProcessId(O){this._onProcessReady.fire({pid:O,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(O){if(this._store.isDisposed)return;this._currentTitle=O.process,this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Title,value:this._currentTitle});const E=this.currentTitle.replace(/ \(figterm\)$/g,"");E.toLowerCase().startsWith("python")?this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:c.PosixShellType.Python}):this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:i.get(E)})}shutdown(O){this._logService.getLevel()===_.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),O&&!P.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},b.MaximumShutdownTime))}input(O,E=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,r.chunkInput)(O).map(D=>({isBinary:E,data:D}))),this._startWrite())}async processBinary(O){this.input(O,!0)}async refreshProperty(O){switch(O){case c.ProcessPropertyType.Cwd:{const E=await this.getCwd();return E!==this._properties.cwd&&(this._properties.cwd=E,this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Cwd,value:this._properties.cwd})),E}case c.ProcessPropertyType.InitialCwd:{const E=await this.getInitialCwd();return E!==this._properties.initialCwd&&(this._properties.initialCwd=E,this._onDidChangeProperty.fire({type:c.ProcessPropertyType.InitialCwd,value:this._properties.initialCwd})),E}case c.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(O,E){O===c.ProcessPropertyType.FixedDimensions&&(this._properties.fixedDimensions=E)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},s.WriteInterval)}}_doWrite(){const O=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",O.data),O.isBinary?this._ptyProcess.write(Buffer.from(O.data,"binary")):this._ptyProcess.write(O.data),this._childProcessMonitor?.handleInput()}resize(O,E){if(!this._store.isDisposed&&!(typeof O!="number"||typeof E!="number"||isNaN(O)||isNaN(E))&&this._ptyProcess){if(O=Math.max(O,1),E=Math.max(E,1),this._delayedResizer){this._delayedResizer.cols=O,this._delayedResizer.rows=E;return}this._logService.trace("node-pty.IPty#resize",O,E);try{this._ptyProcess.resize(O,E)}catch(D){if(this._logService.trace("node-pty.IPty#resize exception "+D.message),this._exitCode!==void 0&&D.message!=="ioctl(2) failed, EBADF"&&D.message!=="Cannot resize a pty that has already exited")throw D}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(O){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-O,0),this._logService.trace(`Flow control: Ack ${O} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<c.FlowControlConstants.LowWatermarkChars&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${c.FlowControlConstants.LowWatermarkChars})`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(O){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(P.isMacintosh)return new Promise(O=>{if(!this._ptyProcess){O(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,a.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(E,D,I)=>{!E&&D!==""?O(D.substring(D.indexOf("/"),D.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",E,D,I),O(this._initialCwd))})});if(P.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await o.Promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return P.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,h.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=n,e.TerminalProcess=n=p=_e([ze(7,_.ILogService),ze(8,f.IProductService)],n);class S extends y.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new L.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,y.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(he[109],fe([0,1,30,12,4,2,3,67,8,100,17,102,40,114,42,108,75,41,101,7,105,104,81,15,115]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c,l,h,m,u,r,p,b,s,i,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=void 0,e.traceRpc=A,S=De(S);function A(M,R,C){if(typeof C.value!="function")throw new Error("not supported");const B="value",Z=C.value;C[B]=async function(...G){this.traceRpcArgs.logService.getLevel()===v.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Z.name}(${G.map(se=>JSON.stringify(se)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.timeout)(this.traceRpcArgs.simulatedLatency);let J;try{J=await Z.apply(this,G)}catch(se){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Z.name}`,se),se}return this.traceRpcArgs.logService.getLevel()===v.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Z.name}`,J),J}}let O,E;class D extends y.Disposable{_traceEvent(R,C){return C(B=>{this._logService.getLevel()===v.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${R}.fire(${JSON.stringify(B)})`)}),C}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(R,C,B,Z){super(),this._logService=R,this._productService=C,this._reconnectConstants=B,this._simulatedLatency=Z,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new L.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,y.toDisposable)(()=>{for(const G of this._ptys.values())G.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new o.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(R){u.ignoreProcessNames.length=0,u.ignoreProcessNames.push(...R)}async requestDetachInstance(R,C){return this._detachInstanceRequestStore.createRequest({workspaceId:R,instanceId:C})}async acceptDetachInstanceReply(R,C){let B;const Z=this._ptys.get(C);Z&&(B=await this._buildProcessDetails(C,Z)),this._detachInstanceRequestStore.acceptReply(R,B)}async freePortKillProcess(R){const B=(await new Promise((Z,G)=>{(0,a.exec)(W.isWindows?`netstat -ano | findstr "${R}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${R}`,{},(J,se)=>{if(J)return G("Problem occurred when listing active processes");Z(se)})})).split(/\r?\n/).filter(Z=>!!Z.trim());if(B.length>=1){const Z=/\s+(\d+)(?:\s+|$)/,G=B[0].match(Z)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${R} were not found`);return{port:R,processId:G}}throw new Error(`Could not kill process with port ${R}`)}async serializeTerminalState(R){const C=[];for(const[Z,G]of this._ptys.entries())G.hasWrittenData&&R.indexOf(Z)!==-1&&C.push(t.Promises.withAsyncBody(async J=>{J({id:Z,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this._buildProcessDetails(Z,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const B={version:1,state:await Promise.all(C)};return JSON.stringify(B)}async reviveTerminalProcesses(R,C,B){const Z=[];for(const G of C)Z.push(this._reviveTerminalProcess(R,G));await Promise.all(Z)}async _reviveTerminalProcess(R,C){const B=(0,m.localize)(0,null),Z=await this.createProcess({...C.shellLaunchConfig,cwd:C.processDetails.cwd,color:C.processDetails.color,icon:C.processDetails.icon,name:C.processDetails.titleSource===w.TitleEventSource.Api?C.processDetails.title:void 0,initialText:C.replayEvent.events[0].data+(0,s.formatMessageForTerminal)(B,{loudFormatting:!0})},C.processDetails.cwd,C.replayEvent.events[0].cols,C.replayEvent.events[0].rows,C.unicodeVersion,C.processLaunchConfig.env,C.processLaunchConfig.executableEnv,C.processLaunchConfig.options,!0,C.processDetails.workspaceId,C.processDetails.workspaceName,!0,C.replayEvent.events[0].data),G=this._getRevivingProcessId(R,C.id);this._revivedPtyIdMap.set(G,{newId:Z,state:C}),this._logService.info(`Revived process, old id ${G} -> new id ${Z}`)}async shutdownAll(){this.dispose()}async createProcess(R,C,B,Z,G,J,se,le,V,F,Y,ee,ue){if(R.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const $=++this._lastPtyId,ae=new h.TerminalProcess(R,C,B,Z,J,se,le,this._logService,this._productService),ge={env:J,executableEnv:se,options:le},te=new x($,ae,F,Y,V,B,Z,ge,G,this._reconnectConstants,this._logService,ee&&typeof R.initialText=="string"?R.initialText:void 0,ue,R.icon,R.color,R.name,R.fixedDimensions);return ae.onProcessExit(d=>{te.dispose(),this._ptys.delete($),this._onProcessExit.fire({id:$,event:d})}),te.onProcessData(d=>this._onProcessData.fire({id:$,event:d})),te.onProcessReplay(d=>this._onProcessReplay.fire({id:$,event:d})),te.onProcessReady(d=>this._onProcessReady.fire({id:$,event:d})),te.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:$})),te.onDidChangeProperty(d=>this._onDidChangeProperty.fire({id:$,property:d})),te.onPersistentProcessReady(()=>{for(const d of this._autoReplies.entries())te.installAutoReply(d[0],d[1])}),this._ptys.set($,te),$}async attachToProcess(R){try{await this._throwIfNoPty(R).attach(),this._logService.info(`Persistent process reconnection "${R}"`)}catch(C){throw this._logService.warn(`Persistent process reconnection "${R}" failed`,C.message),C}}async updateTitle(R,C,B){this._throwIfNoPty(R).setTitle(C,B)}async updateIcon(R,C,B,Z){this._throwIfNoPty(R).setIcon(C,B,Z)}async clearBuffer(R){this._throwIfNoPty(R).clearBuffer()}async refreshProperty(R,C){return this._throwIfNoPty(R).refreshProperty(C)}async updateProperty(R,C,B){return this._throwIfNoPty(R).updateProperty(C,B)}async detachFromProcess(R,C){return this._throwIfNoPty(R).detach(C)}async reduceConnectionGraceTime(){for(const R of this._ptys.values())R.reduceGraceTime()}async listProcesses(){const R=Array.from(this._ptys.entries()).filter(([Z,G])=>G.shouldPersistTerminal);this._logService.info(`Listing ${R.length} persistent terminals, ${this._ptys.size} total terminals`);const C=R.map(async([Z,G])=>this._buildProcessDetails(Z,G));return(await Promise.all(C)).filter(Z=>Z.isOrphan)}async getPerformanceMarks(){return S.getMarks()}async start(R){const C=this._ptys.get(R);return C?C.start():{message:`Could not find pty with id "${R}"`}}async shutdown(R,C){return this._ptys.get(R)?.shutdown(C)}async input(R,C){return this._throwIfNoPty(R).input(C)}async processBinary(R,C){return this._throwIfNoPty(R).writeBinary(C)}async resize(R,C,B){return this._throwIfNoPty(R).resize(C,B)}async getInitialCwd(R){return this._throwIfNoPty(R).getInitialCwd()}async getCwd(R){return this._throwIfNoPty(R).getCwd()}async acknowledgeDataEvent(R,C){return this._throwIfNoPty(R).acknowledgeDataEvent(C)}async setUnicodeVersion(R,C){return this._throwIfNoPty(R).setUnicodeVersion(C)}async getLatency(){return[]}async orphanQuestionReply(R){return this._throwIfNoPty(R).orphanQuestionReply()}async installAutoReply(R,C){this._autoReplies.set(R,C);for(const B of this._ptys.values())B.installAutoReply(R,C)}async uninstallAllAutoReplies(){for(const R of this._autoReplies.keys())for(const C of this._ptys.values())C.uninstallAutoReply(R)}async uninstallAutoReply(R){for(const C of this._ptys.values())C.uninstallAutoReply(R)}async getDefaultSystemShell(R=W.OS){return(0,P.getSystemShell)(R,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(R,C){if(C==="win-to-unix"){if(!W.isWindows)return R;if((0,l.getWindowsBuildNumber)()<17063)return R.replace(/\\/g,"/");const B=this._getWSLExecutablePath();return B?new Promise(Z=>{(0,a.execFile)(B,["-e","wslpath",R],{},(J,se,le)=>{Z(J?R:(0,f.escapeNonWindowsPath)(se.trim()))}).stdin.end()}):R}if(C==="unix-to-win"&&W.isWindows){if((0,l.getWindowsBuildNumber)()<17063)return R;const B=this._getWSLExecutablePath();return B?new Promise(Z=>{(0,a.execFile)(B,["-e","wslpath","-w",R],{},(J,se,le)=>{Z(J?R:se.trim())}).stdin.end()}):R}return R}_getWSLExecutablePath(){const R=(0,l.getWindowsBuildNumber)()>=16299,C=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),B=process.env.SystemRoot;if(B)return(0,i.join)(B,C?"Sysnative":"System32",R?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(R,C){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(R,C))?.newId}catch(B){this._logService.warn(`Couldn't find terminal ID ${R}-${C}`,B.message)}}async setTerminalLayoutInfo(R){this._workspaceLayoutInfos.set(R.workspaceId,R)}async getTerminalLayoutInfo(R){S.mark("code/willGetTerminalLayoutInfo");const C=this._workspaceLayoutInfos.get(R.workspaceId);if(C){const B=new Set,G=(await Promise.all(C.tabs.map(async J=>this._expandTerminalTab(R.workspaceId,J,B)))).filter(J=>J.terminals.length>0);return S.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}S.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(R,C,B){const G=(await Promise.all(C.terminals.map(J=>this._expandTerminalInstance(R,J,B)))).filter(J=>J.terminal!==null);return{isActive:C.isActive,activePersistentProcessId:C.activePersistentProcessId,terminals:G}}async _expandTerminalInstance(R,C,B){try{const Z=this._getRevivingProcessId(R,C.terminal),G=this._revivedPtyIdMap.get(Z)?.newId;this._logService.info(`Expanding terminal instance, old id ${Z} -> new id ${G}`),this._revivedPtyIdMap.delete(Z);const J=G??C.terminal;if(B.has(J))throw new Error(`Terminal ${J} has already been expanded`);B.add(J);const se=this._throwIfNoPty(J);return{terminal:{...se&&await this._buildProcessDetails(C.terminal,se,G!==void 0),id:J},relativeSize:C.relativeSize}}catch(Z){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",Z.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",C),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:C.relativeSize}}}_getRevivingProcessId(R,C){return`${R}-${C}`}async _buildProcessDetails(R,C,B=!1){S.mark(`code/willBuildProcessDetails/${R}`);const[Z,G]=await Promise.all([C.getCwd(),B?!0:C.isOrphaned()]),J={id:R,title:C.title,titleSource:C.titleSource,pid:C.pid,workspaceId:C.workspaceId,workspaceName:C.workspaceName,cwd:Z,isOrphan:G,icon:C.icon,color:C.color,fixedDimensions:C.fixedDimensions,environmentVariableCollections:C.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:C.shellLaunchConfig.reconnectionProperties,waitOnExit:C.shellLaunchConfig.waitOnExit,hideFromUser:C.shellLaunchConfig.hideFromUser,isFeatureTerminal:C.shellLaunchConfig.isFeatureTerminal,type:C.shellLaunchConfig.type,hasChildProcesses:C.hasChildProcesses,shellIntegrationNonce:C.processLaunchOptions.options.shellIntegration.nonce};return S.mark(`code/didBuildProcessDetails/${R}`),J}_throwIfNoPty(R){const C=this._ptys.get(R);if(!C)throw new p.ErrorNoTelemetry("Could not find pty on pty host");return C}}e.PtyService=D,_e([n.memoize],D.prototype,"traceRpcArgs",null),_e([A],D.prototype,"refreshIgnoreProcessNames",null),_e([A],D.prototype,"requestDetachInstance",null),_e([A],D.prototype,"acceptDetachInstanceReply",null),_e([A],D.prototype,"freePortKillProcess",null),_e([A],D.prototype,"serializeTerminalState",null),_e([A],D.prototype,"reviveTerminalProcesses",null),_e([A],D.prototype,"shutdownAll",null),_e([A],D.prototype,"createProcess",null),_e([A],D.prototype,"attachToProcess",null),_e([A],D.prototype,"updateTitle",null),_e([A],D.prototype,"updateIcon",null),_e([A],D.prototype,"clearBuffer",null),_e([A],D.prototype,"refreshProperty",null),_e([A],D.prototype,"updateProperty",null),_e([A],D.prototype,"detachFromProcess",null),_e([A],D.prototype,"reduceConnectionGraceTime",null),_e([A],D.prototype,"listProcesses",null),_e([A],D.prototype,"getPerformanceMarks",null),_e([A],D.prototype,"start",null),_e([A],D.prototype,"shutdown",null),_e([A],D.prototype,"input",null),_e([A],D.prototype,"processBinary",null),_e([A],D.prototype,"resize",null),_e([A],D.prototype,"getInitialCwd",null),_e([A],D.prototype,"getCwd",null),_e([A],D.prototype,"acknowledgeDataEvent",null),_e([A],D.prototype,"setUnicodeVersion",null),_e([A],D.prototype,"getLatency",null),_e([A],D.prototype,"orphanQuestionReply",null),_e([A],D.prototype,"installAutoReply",null),_e([A],D.prototype,"uninstallAllAutoReplies",null),_e([A],D.prototype,"uninstallAutoReply",null),_e([A],D.prototype,"getDefaultSystemShell",null),_e([A],D.prototype,"getEnvironment",null),_e([A],D.prototype,"getWslPath",null),_e([A],D.prototype,"getRevivedPtyNewId",null),_e([A],D.prototype,"setTerminalLayoutInfo",null),_e([A],D.prototype,"getTerminalLayoutInfo",null);var I;(function(M){M.None="None",M.ReplayOnly="ReplayOnly",M.Session="Session"})(I||(I={}));class x extends y.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!==I.None}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(R,C){C===w.TitleEventSource.Api&&(this._interactionState.setValue(I.Session,"setTitle"),this._serializer.freeRawReviveBuffer()),this._title=R,this._titleSource=C}setIcon(R,C,B){(!this._icon||"id"in C&&"id"in this._icon&&C.id!==this._icon.id||!this.color||B!==this._color)&&(this._serializer.freeRawReviveBuffer(),R&&this._interactionState.setValue(I.Session,"setIcon")),this._icon=C,this._color=B}_setFixedDimensions(R){this._fixedDimensions=R}constructor(R,C,B,Z,G,J,se,le,V,F,Y,ee,ue,$,ae,ge,te){super(),this._persistentProcessId=R,this._terminalProcess=C,this.workspaceId=B,this.workspaceName=Z,this.shouldPersistTerminal=G,this.processLaunchOptions=le,this.unicodeVersion=V,this._logService=Y,this._icon=$,this._color=ae,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new t.Queue,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new L.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=w.TitleEventSource.Process,this._interactionState=new z(`Persistent process "${this._persistentProcessId}" interaction state`,I.None,this._logService),this._wasRevived=ee!==void 0,this._serializer=new k(J,se,F.scrollback,V,ee,le.options.shellIntegration.nonce,G?ue:void 0,this._logService),ge&&this.setTitle(ge,w.TitleEventSource.Api),this._fixedDimensions=te,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${g(F.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},F.graceTime)),this._disconnectRunner2=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${g(F.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},F.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(d=>{this._pid=d.pid,this._cwd=d.cwd,this._onProcessReady.fire(d)})),this._register(this._terminalProcess.onDidChangeProperty(d=>{this._onDidChangeProperty.fire(d)})),this._bufferer=new _.TerminalDataBufferer((d,H)=>this._onProcessData.fire(H)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(d=>this._serializer.handleData(d))),this._register((0,y.toDisposable)(()=>{for(const d of this._autoReplies.values())d.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(R){this.shouldPersistTerminal&&(this._interactionState.value!==I.None||R)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!==I.Session)}async refreshProperty(R){return this._terminalProcess.refreshProperty(R)}async updateProperty(R,C){if(R===w.ProcessPropertyType.FixedDimensions)return this._setFixedDimensions(C)}async start(){if(!this._isStarted){const R=await this._terminalProcess.start();return R&&"message"in R||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),R}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:w.ProcessPropertyType.Title,value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:w.ProcessPropertyType.ShellType,value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(R){return this._terminalProcess.shutdown(R)}input(R){if(this._interactionState.setValue(I.Session,"input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const C of this._autoReplies.values())C.handleInput();return this._terminalProcess.input(R)}}writeBinary(R){return this._terminalProcess.processBinary(R)}resize(R,C){if(!this._inReplay){this._serializer.handleResize(R,C),this._bufferer.flushBuffer(this._persistentProcessId);for(const B of this._autoReplies.values())B.handleResize();return this._terminalProcess.resize(R,C)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(R){this.unicodeVersion=R,this._serializer.setUnicodeVersion?.(R)}acknowledgeDataEvent(R){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(R)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value===I.None&&this._interactionState.setValue(I.ReplayOnly,"triggerReplay");const R=await this._serializer.generateReplayEvent();let C=0;for(const B of R.events)C+=B.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${C} chars and ${R.events.length} size events`),this._onProcessReplay.fire(R),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(R,C){this._autoReplies.get(R)?.dispose(),this._autoReplies.set(R,new r.TerminalAutoResponder(this._terminalProcess,R,C,this._logService))}uninstallAutoReply(R){this._autoReplies.get(R)?.dispose(),this._autoReplies.delete(R)}sendCommandResult(R,C,B){this._pendingCommands.get(R)&&this._pendingCommands.delete(R)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const R=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,R.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new t.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class z{get value(){return this._value}setValue(R,C){this._value!==R&&(this._value=R,this._log(C))}constructor(R,C,B){this._name=R,this._value=C,this._logService=B,this._log("initialized")}_log(R){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${R}`)}}class k{constructor(R,C,B,Z,G,J,se,le){this._rawReviveBuffer=se,this._xterm=new c.Terminal({cols:R,rows:C,scrollback:B,allowProposedApi:!0}),G&&this._xterm.writeln(G),this.setUnicodeVersion(Z),this._shellIntegrationAddon=new b.ShellIntegrationAddon(J,!0,void 0,le),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(R){this._xterm.write(R)}handleResize(R,C){this._xterm.resize(R,C)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(R,C){const B=new(await this._getSerializeConstructor());this._xterm.loadAddon(B);const Z={scrollback:this._xterm.options.scrollback};R&&(Z.excludeAltBuffer=!0,Z.excludeModes=!0);let G;return C&&this._rawReviveBuffer?G=this._rawReviveBuffer:G=B.serialize(Z),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:G}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(R){this._xterm.unicode.activeVersion!==R&&(R==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=R)}async _getUnicode11Constructor(){return E||(E=(await new Promise((R,C)=>{ie(["@xterm/addon-unicode11"],R,C)}).then(De)).Unicode11Addon),E}async _getSerializeConstructor(){return O||(O=(await new Promise((R,C)=>{ie(["@xterm/addon-serialize"],R,C)}).then(De)).SerializeAddon),O}}function g(M){let R=0,C=0,B=0;M>=1e3&&(B=Math.floor(M/1e3),M-=B*1e3),B>=60&&(C=Math.floor(B/60),B-=C*60),C>=60&&(R=Math.floor(C/60),C-=R*60);const Z=R?`${R}h`:"",G=C?`${C}m`:"",J=B?`${B}s`:"",se=M?`${M}ms`:"";return`${Z}${G}${J}${se}`}});var Ge=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[116],fe([0,1,64,31,68,69,11,79,82,8,84,85,87,88,17,106,109,34,12,2]),function(ie,e,a,t,L,y,W,P,v,o,w,_,f,c,l,h,m,u,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),c=Ge(c),b();async function b(){const s=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),n={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,s&&await(0,r.timeout)(s);const S=(0,u.isUtilityProcess)(process);let A;S?A=new y.Server:A=new L.Server(l.TerminalIpcChannels.PtyHost);const O={_serviceBrand:void 0,...c.default},E=new v.NativeEnvironmentService((0,P.parseArgs)(process.argv,P.OPTIONS),O),D=new f.LoggerService((0,o.getLogLevel)(E),E.logsHome);A.registerChannel(l.TerminalIpcChannels.Logger,new w.LoggerChannel(D,()=>a.DefaultURITransformer));const I=D.createLogger("ptyhost",{name:(0,W.localize)(0,null)}),x=new _.LogService(I);s&&x.warn(`Pty Host startup is delayed ${s}ms`),i&&x.warn(`Pty host is simulating ${i}ms latency`);const z=new p.DisposableStore,k=new h.HeartbeatService;A.registerChannel(l.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(k,z));const g=new m.PtyService(x,O,n,i),M=t.ProxyChannel.fromService(g,z);A.registerChannel(l.TerminalIpcChannels.PtyHost,M),S&&A.registerChannel(l.TerminalIpcChannels.PtyHostWindow,M),process.once("exit",()=>{x.trace("Pty host exiting"),x.dispose(),k.dispose(),g.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/platform/terminal/node/ptyHostMain.js.map
