/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(le){for(var e=[],s=0,d=le.length;s<d;s++)e[s]=_e[le[s]];return e};define(_e[174],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var s;(function(T){T[T.LoaderAvailable=1]="LoaderAvailable",T[T.BeginLoadingScript=10]="BeginLoadingScript",T[T.EndLoadingScriptOK=11]="EndLoadingScriptOK",T[T.EndLoadingScriptError=12]="EndLoadingScriptError",T[T.BeginInvokeFactory=21]="BeginInvokeFactory",T[T.EndInvokeFactory=22]="EndInvokeFactory",T[T.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",T[T.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",T[T.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",T[T.NodeEndNativeRequire=34]="NodeEndNativeRequire",T[T.CachedDataFound=60]="CachedDataFound",T[T.CachedDataMissed=61]="CachedDataMissed",T[T.CachedDataRejected=62]="CachedDataRejected",T[T.CachedDataCreated=63]="CachedDataCreated"})(s||(e.LoaderEventType=s={}));class d{static get(){const R=new Map,L=new Map,A=new Map,p=new Map;function a(b,l){b.has(l.detail)||b.set(l.detail,-l.timestamp)}function I(b,l){const m=b.get(l.detail);m&&(m>=0||b.set(l.detail,m+l.timestamp))}let _=[];typeof le=="function"&&typeof le.getStats=="function"&&(_=le.getStats().slice(0).sort((b,l)=>b.timestamp-l.timestamp));for(const b of _)switch(b.type){case s.BeginLoadingScript:a(R,b);break;case s.EndLoadingScriptOK:case s.EndLoadingScriptError:I(R,b);break;case s.BeginInvokeFactory:a(L,b);break;case s.EndInvokeFactory:I(L,b);break;case s.NodeBeginNativeRequire:a(A,b);break;case s.NodeEndNativeRequire:I(A,b);break;case s.NodeBeginEvaluatingScript:a(p,b);break;case s.NodeEndEvaluatingScript:I(p,b);break}let c=0;A.forEach(b=>c+=b);function C(b){const l=[];return b.forEach((m,h)=>l.push([h,m])),l}return{amdLoad:C(R),amdInvoke:C(L),nodeRequire:C(A),nodeEval:C(p),nodeRequireTotal:c}}static toMarkdownTable(R,L){let A="";const p=[];return R.forEach((a,I)=>{p[I]=a.length}),L.forEach(a=>{a.forEach((I,_)=>{typeof I>"u"&&(I=a[_]="-");const c=I.toString().length;p[_]=Math.max(c,p[_])})}),R.forEach((a,I)=>{A+=`| ${a+" ".repeat(p[I]-a.toString().length)} `}),A+=`|
`,R.forEach((a,I)=>{A+=`| ${"-".repeat(p[I])} `}),A+=`|
`,L.forEach(a=>{a.forEach((I,_)=>{typeof I<"u"&&(A+=`| ${I+" ".repeat(p[_]-I.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=d}),define(_e[132],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=s,e.findLastIdx=d,e.findLastMonotonous=T,e.findLastIdxMonotonous=R,e.findFirstMonotonous=L,e.findFirstIdxMonotonousOrArrLen=A,e.findFirstIdxMonotonous=p,e.findFirstMax=I,e.findLastMax=_,e.findFirstMin=c,e.findMaxIdx=C,e.mapFindFirst=b;function s(l,m){const h=d(l,m);if(h!==-1)return l[h]}function d(l,m,h=l.length-1){for(let g=h;g>=0;g--){const n=l[g];if(m(n))return g}return-1}function T(l,m){const h=R(l,m);return h===-1?void 0:l[h]}function R(l,m,h=0,g=l.length){let n=h,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(l[t])?n=t+1:o=t}return n-1}function L(l,m){const h=A(l,m);return h===l.length?void 0:l[h]}function A(l,m,h=0,g=l.length){let n=h,o=g;for(;n<o;){const t=Math.floor((n+o)/2);m(l[t])?o=t:n=t+1}return n}function p(l,m,h=0,g=l.length){const n=A(l,m,h,g);return n===l.length?-1:n}class a{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const g of this._array)if(this._prevFindLastPredicate(g)&&!m(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const h=R(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}e.MonotonousArray=a;function I(l,m){if(l.length===0)return;let h=l[0];for(let g=1;g<l.length;g++){const n=l[g];m(n,h)>0&&(h=n)}return h}function _(l,m){if(l.length===0)return;let h=l[0];for(let g=1;g<l.length;g++){const n=l[g];m(n,h)>=0&&(h=n)}return h}function c(l,m){return I(l,(h,g)=>-m(h,g))}function C(l,m){if(l.length===0)return-1;let h=0;for(let g=1;g<l.length;g++){const n=l[g];m(n,l[h])>0&&(h=g)}return h}function b(l,m){for(const h of l){const g=m(h);if(g!==void 0)return g}}}),define(_e[27],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var s;(function(d){d[d.Null=0]="Null",d[d.Backspace=8]="Backspace",d[d.Tab=9]="Tab",d[d.LineFeed=10]="LineFeed",d[d.CarriageReturn=13]="CarriageReturn",d[d.Space=32]="Space",d[d.ExclamationMark=33]="ExclamationMark",d[d.DoubleQuote=34]="DoubleQuote",d[d.Hash=35]="Hash",d[d.DollarSign=36]="DollarSign",d[d.PercentSign=37]="PercentSign",d[d.Ampersand=38]="Ampersand",d[d.SingleQuote=39]="SingleQuote",d[d.OpenParen=40]="OpenParen",d[d.CloseParen=41]="CloseParen",d[d.Asterisk=42]="Asterisk",d[d.Plus=43]="Plus",d[d.Comma=44]="Comma",d[d.Dash=45]="Dash",d[d.Period=46]="Period",d[d.Slash=47]="Slash",d[d.Digit0=48]="Digit0",d[d.Digit1=49]="Digit1",d[d.Digit2=50]="Digit2",d[d.Digit3=51]="Digit3",d[d.Digit4=52]="Digit4",d[d.Digit5=53]="Digit5",d[d.Digit6=54]="Digit6",d[d.Digit7=55]="Digit7",d[d.Digit8=56]="Digit8",d[d.Digit9=57]="Digit9",d[d.Colon=58]="Colon",d[d.Semicolon=59]="Semicolon",d[d.LessThan=60]="LessThan",d[d.Equals=61]="Equals",d[d.GreaterThan=62]="GreaterThan",d[d.QuestionMark=63]="QuestionMark",d[d.AtSign=64]="AtSign",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.OpenSquareBracket=91]="OpenSquareBracket",d[d.Backslash=92]="Backslash",d[d.CloseSquareBracket=93]="CloseSquareBracket",d[d.Caret=94]="Caret",d[d.Underline=95]="Underline",d[d.BackTick=96]="BackTick",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z",d[d.OpenCurlyBrace=123]="OpenCurlyBrace",d[d.Pipe=124]="Pipe",d[d.CloseCurlyBrace=125]="CloseCurlyBrace",d[d.Tilde=126]="Tilde",d[d.NoBreakSpace=160]="NoBreakSpace",d[d.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",d[d.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",d[d.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",d[d.U_Combining_Tilde=771]="U_Combining_Tilde",d[d.U_Combining_Macron=772]="U_Combining_Macron",d[d.U_Combining_Overline=773]="U_Combining_Overline",d[d.U_Combining_Breve=774]="U_Combining_Breve",d[d.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",d[d.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",d[d.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",d[d.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",d[d.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",d[d.U_Combining_Caron=780]="U_Combining_Caron",d[d.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",d[d.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",d[d.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",d[d.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",d[d.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",d[d.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",d[d.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",d[d.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",d[d.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",d[d.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",d[d.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",d[d.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",d[d.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",d[d.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",d[d.U_Combining_Horn=795]="U_Combining_Horn",d[d.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",d[d.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",d[d.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",d[d.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",d[d.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",d[d.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",d[d.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",d[d.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",d[d.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",d[d.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",d[d.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",d[d.U_Combining_Cedilla=807]="U_Combining_Cedilla",d[d.U_Combining_Ogonek=808]="U_Combining_Ogonek",d[d.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",d[d.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",d[d.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",d[d.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",d[d.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",d[d.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",d[d.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",d[d.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",d[d.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",d[d.U_Combining_Low_Line=818]="U_Combining_Low_Line",d[d.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",d[d.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",d[d.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",d[d.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",d[d.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",d[d.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",d[d.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",d[d.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",d[d.U_Combining_Square_Below=827]="U_Combining_Square_Below",d[d.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",d[d.U_Combining_X_Above=829]="U_Combining_X_Above",d[d.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",d[d.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",d[d.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",d[d.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",d[d.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",d[d.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",d[d.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",d[d.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",d[d.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",d[d.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",d[d.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",d[d.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",d[d.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",d[d.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",d[d.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",d[d.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",d[d.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",d[d.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",d[d.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",d[d.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",d[d.U_Combining_Fermata=850]="U_Combining_Fermata",d[d.U_Combining_X_Below=851]="U_Combining_X_Below",d[d.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",d[d.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",d[d.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",d[d.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",d[d.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",d[d.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",d[d.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",d[d.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",d[d.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",d[d.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",d[d.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",d[d.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",d[d.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",d[d.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",d[d.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",d[d.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",d[d.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",d[d.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",d[d.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",d[d.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",d[d.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",d[d.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",d[d.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",d[d.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",d[d.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",d[d.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",d[d.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",d[d.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",d[d.LINE_SEPARATOR=8232]="LINE_SEPARATOR",d[d.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",d[d.NEXT_LINE=133]="NEXT_LINE",d[d.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",d[d.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",d[d.U_DIAERESIS=168]="U_DIAERESIS",d[d.U_MACRON=175]="U_MACRON",d[d.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",d[d.U_CEDILLA=184]="U_CEDILLA",d[d.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",d[d.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",d[d.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",d[d.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",d[d.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",d[d.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",d[d.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",d[d.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",d[d.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",d[d.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",d[d.U_BREVE=728]="U_BREVE",d[d.U_DOT_ABOVE=729]="U_DOT_ABOVE",d[d.U_RING_ABOVE=730]="U_RING_ABOVE",d[d.U_OGONEK=731]="U_OGONEK",d[d.U_SMALL_TILDE=732]="U_SMALL_TILDE",d[d.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",d[d.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",d[d.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",d[d.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",d[d.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",d[d.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",d[d.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",d[d.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",d[d.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",d[d.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",d[d.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",d[d.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",d[d.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",d[d.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",d[d.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",d[d.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",d[d.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",d[d.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",d[d.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",d[d.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",d[d.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",d[d.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",d[d.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",d[d.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",d[d.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",d[d.U_GREEK_TONOS=900]="U_GREEK_TONOS",d[d.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",d[d.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",d[d.U_GREEK_PSILI=8127]="U_GREEK_PSILI",d[d.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",d[d.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",d[d.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",d[d.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",d[d.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",d[d.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",d[d.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",d[d.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",d[d.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",d[d.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",d[d.U_GREEK_VARIA=8175]="U_GREEK_VARIA",d[d.U_GREEK_OXIA=8189]="U_GREEK_OXIA",d[d.U_GREEK_DASIA=8190]="U_GREEK_DASIA",d[d.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",d[d.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",d[d.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",d[d.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",d[d.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",d[d.U_OVERLINE=8254]="U_OVERLINE",d[d.UTF8_BOM=65279]="UTF8_BOM",d[d.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",d[d.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(s||(e.CharCode=s={}))}),define(_e[79],ye([1,0]),function(le,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=d,e.diffSets=T,e.diffMaps=R,e.intersection=L;function d(p,a){const I=Object.create(null);for(const _ of p){const c=a(_);let C=I[c];C||(C=I[c]=[]),C.push(_)}return I}function T(p,a){const I=[],_=[];for(const c of p)a.has(c)||I.push(c);for(const c of a)p.has(c)||_.push(c);return{removed:I,added:_}}function R(p,a){const I=[],_=[];for(const[c,C]of p)a.has(c)||I.push(C);for(const[c,C]of a)p.has(c)||_.push(C);return{removed:I,added:_}}function L(p,a){const I=new Set;for(const _ of a)p.has(_)&&I.add(_);return I}class A{static{s=Symbol.toStringTag}constructor(a,I){this.toKey=I,this._map=new Map,this[s]="SetWithKey";for(const _ of a)this.add(_)}get size(){return this._map.size}add(a){const I=this.toKey(a);return this._map.set(I,a),this}delete(a){return this._map.delete(this.toKey(a))}has(a){return this._map.has(this.toKey(a))}*entries(){for(const a of this._map.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this._map.values())yield a}clear(){this._map.clear()}forEach(a,I){this._map.forEach(_=>a.call(I,_,_,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=A}),define(_e[59],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=d,e.debounce=T,e.throttle=R;function s(L){return(A,p,a)=>{let I=null,_=null;if(typeof a.value=="function"?(I="value",_=a.value):typeof a.get=="function"&&(I="get",_=a.get),!_)throw new Error("not supported");a[I]=L(_,p)}}function d(L,A,p){let a=null,I=null;if(typeof p.value=="function"?(a="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",I=p.get),!I)throw new Error("not supported");const _=`$memoize$${A}`;p[a]=function(...c){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,c)}),this[_]}}function T(L,A,p){return s((a,I)=>{const _=`$debounce$${I}`,c=`$debounce$result$${I}`;return function(...C){this[c]||(this[c]=p?p():void 0),clearTimeout(this[_]),A&&(this[c]=A(this[c],...C),C=[this[c]]),this[_]=setTimeout(()=>{a.apply(this,C),this[c]=p?p():void 0},L)}})}function R(L,A,p){return s((a,I)=>{const _=`$throttle$timer$${I}`,c=`$throttle$result$${I}`,C=`$throttle$lastRun$${I}`,b=`$throttle$pending$${I}`;return function(...l){if(this[c]||(this[c]=p?p():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...l)),this[b])return;const m=this[C]+L;m<=Date.now()?(this[C]=Date.now(),a.apply(this,[this[c]]),this[c]=p?p():void 0):(this[b]=!0,this[_]=setTimeout(()=>{this[b]=!1,this[C]=Date.now(),a.apply(this,[this[c]]),this[c]=p?p():void 0},m-Date.now()))}})}}),define(_e[14],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=d,e.isSigPipeError=T,e.onUnexpectedError=R,e.onUnexpectedExternalError=L,e.transformErrorForSerialization=A,e.transformErrorFromSerialization=p,e.isCancellationError=I,e.canceled=c,e.illegalArgument=C,e.illegalState=b,e.getErrorMessage=m;class s{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?o.isErrorNoTelemetry(r)?new o(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(f=>{f(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=s,e.errorHandler=new s;function d(i){e.errorHandler.setUnexpectedErrorHandler(i)}function T(i){if(!i||typeof i!="object")return!1;const r=i;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function R(i){I(i)||e.errorHandler.onUnexpectedError(i)}function L(i){I(i)||e.errorHandler.onUnexpectedExternalError(i)}function A(i){if(i instanceof Error){const{name:r,message:f}=i,u=i.stacktrace||i.stack;return{$isError:!0,name:r,message:f,stack:u,noTelemetry:o.isErrorNoTelemetry(i)}}return i}function p(i){let r;return i.noTelemetry?r=new o:(r=new Error,r.name=i.name),r.message=i.message,r.stack=i.stack,r}const a="Canceled";function I(i){return i instanceof _?!0:i instanceof Error&&i.name===a&&i.message===a}class _ extends Error{constructor(){super(a),this.name=this.message}}e.CancellationError=_;function c(){const i=new Error(a);return i.name=i.message,i}function C(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function b(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class l extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=l;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=n;class o extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof o)return r;const f=new o;return f.message=r.message,f.stack=r.stack,f}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=o;class t extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.BugIndicatingError=t}),define(_e[19],ye([1,0,14,132]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=T,e.tail2=R,e.equals=L,e.removeFastWithoutKeepingOrder=A,e.binarySearch=p,e.binarySearch2=a,e.quickSelect=I,e.groupBy=_,e.groupAdjacentBy=c,e.forEachAdjacent=C,e.forEachWithNeighbors=b,e.sortedDiff=l,e.delta=m,e.top=h,e.topAsync=g,e.coalesce=o,e.coalesceInPlace=t,e.move=i,e.isFalsyOrEmpty=r,e.isNonEmptyArray=f,e.distinct=u,e.uniqueFilter=v,e.firstOrDefault=y,e.lastOrDefault=D,e.commonPrefixLength=w,e.range=P,e.index=k,e.insert=E,e.remove=S,e.arrayInsert=M,e.shuffle=N,e.pushToStart=O,e.pushToEnd=x,e.pushMany=U,e.mapArrayOrNot=F,e.asArray=H,e.getRandomElement=j,e.insertInto=re,e.splice=B,e.compareBy=ee,e.tieBreakComparators=he,e.reverseOrder=pe;function T(ae,te=0){return ae[ae.length-(1+te)]}function R(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,te,ce=(ue,Y)=>ue===Y){if(ae===te)return!0;if(!ae||!te||ae.length!==te.length)return!1;for(let ue=0,Y=ae.length;ue<Y;ue++)if(!ce(ae[ue],te[ue]))return!1;return!0}function A(ae,te){const ce=ae.length-1;te<ce&&(ae[te]=ae[ce]),ae.pop()}function p(ae,te,ce){return a(ae.length,ue=>ce(ae[ue],te))}function a(ae,te){let ce=0,ue=ae-1;for(;ce<=ue;){const Y=(ce+ue)/2|0,oe=te(Y);if(oe<0)ce=Y+1;else if(oe>0)ue=Y-1;else return Y}return-(ce+1)}function I(ae,te,ce){if(ae=ae|0,ae>=te.length)throw new TypeError("invalid index");const ue=te[Math.floor(te.length*Math.random())],Y=[],oe=[],ve=[];for(const be of te){const Fe=ce(be,ue);Fe<0?Y.push(be):Fe>0?oe.push(be):ve.push(be)}return ae<Y.length?I(ae,Y,ce):ae<Y.length+ve.length?ve[0]:I(ae-(Y.length+ve.length),oe,ce)}function _(ae,te){const ce=[];let ue;for(const Y of ae.slice(0).sort(te))!ue||te(ue[0],Y)!==0?(ue=[Y],ce.push(ue)):ue.push(Y);return ce}function*c(ae,te){let ce,ue;for(const Y of ae)ue!==void 0&&te(ue,Y)?ce.push(Y):(ce&&(yield ce),ce=[Y]),ue=Y;ce&&(yield ce)}function C(ae,te){for(let ce=0;ce<=ae.length;ce++)te(ce===0?void 0:ae[ce-1],ce===ae.length?void 0:ae[ce])}function b(ae,te){for(let ce=0;ce<ae.length;ce++)te(ce===0?void 0:ae[ce-1],ae[ce],ce+1===ae.length?void 0:ae[ce+1])}function l(ae,te,ce){const ue=[];function Y(be,Fe,We){if(Fe===0&&We.length===0)return;const Ce=ue[ue.length-1];Ce&&Ce.start+Ce.deleteCount===be?(Ce.deleteCount+=Fe,Ce.toInsert.push(...We)):ue.push({start:be,deleteCount:Fe,toInsert:We})}let oe=0,ve=0;for(;;){if(oe===ae.length){Y(oe,0,te.slice(ve));break}if(ve===te.length){Y(oe,ae.length-oe,[]);break}const be=ae[oe],Fe=te[ve],We=ce(be,Fe);We===0?(oe+=1,ve+=1):We<0?(Y(oe,1,[]),oe+=1):We>0&&(Y(oe,0,[Fe]),ve+=1)}return ue}function m(ae,te,ce){const ue=l(ae,te,ce),Y=[],oe=[];for(const ve of ue)Y.push(...ae.slice(ve.start,ve.start+ve.deleteCount)),oe.push(...ve.toInsert);return{removed:Y,added:oe}}function h(ae,te,ce){if(ce===0)return[];const ue=ae.slice(0,ce).sort(te);return n(ae,te,ue,ce,ae.length),ue}function g(ae,te,ce,ue,Y){return ce===0?Promise.resolve([]):new Promise((oe,ve)=>{(async()=>{const be=ae.length,Fe=ae.slice(0,ce).sort(te);for(let We=ce,Ce=Math.min(ce+ue,be);We<be;We=Ce,Ce=Math.min(Ce+ue,be)){if(We>ce&&await new Promise(Ie=>setTimeout(Ie)),Y&&Y.isCancellationRequested)throw new s.CancellationError;n(ae,te,Fe,We,Ce)}return Fe})().then(oe,ve)})}function n(ae,te,ce,ue,Y){for(const oe=ce.length;ue<Y;ue++){const ve=ae[ue];if(te(ve,ce[oe-1])<0){ce.pop();const be=(0,d.findFirstIdxMonotonousOrArrLen)(ce,Fe=>te(ve,Fe)<0);ce.splice(be,0,ve)}}}function o(ae){return ae.filter(te=>!!te)}function t(ae){let te=0;for(let ce=0;ce<ae.length;ce++)ae[ce]&&(ae[te]=ae[ce],te+=1);ae.length=te}function i(ae,te,ce){ae.splice(ce,0,ae.splice(te,1)[0])}function r(ae){return!Array.isArray(ae)||ae.length===0}function f(ae){return Array.isArray(ae)&&ae.length>0}function u(ae,te=ce=>ce){const ce=new Set;return ae.filter(ue=>{const Y=te(ue);return ce.has(Y)?!1:(ce.add(Y),!0)})}function v(ae){const te=new Set;return ce=>{const ue=ae(ce);return te.has(ue)?!1:(te.add(ue),!0)}}function y(ae,te){return ae.length>0?ae[0]:te}function D(ae,te){return ae.length>0?ae[ae.length-1]:te}function w(ae,te,ce=(ue,Y)=>ue===Y){let ue=0;for(let Y=0,oe=Math.min(ae.length,te.length);Y<oe&&ce(ae[Y],te[Y]);Y++)ue++;return ue}function P(ae,te){let ce=typeof te=="number"?ae:0;typeof te=="number"?ce=ae:(ce=0,te=ae);const ue=[];if(ce<=te)for(let Y=ce;Y<te;Y++)ue.push(Y);else for(let Y=ce;Y>te;Y--)ue.push(Y);return ue}function k(ae,te,ce){return ae.reduce((ue,Y)=>(ue[te(Y)]=ce?ce(Y):Y,ue),Object.create(null))}function E(ae,te){return ae.push(te),()=>S(ae,te)}function S(ae,te){const ce=ae.indexOf(te);if(ce>-1)return ae.splice(ce,1),te}function M(ae,te,ce){const ue=ae.slice(0,te),Y=ae.slice(te);return ue.concat(ce,Y)}function N(ae,te){let ce;if(typeof te=="number"){let ue=te;ce=()=>{const Y=Math.sin(ue++)*179426549;return Y-Math.floor(Y)}}else ce=Math.random;for(let ue=ae.length-1;ue>0;ue-=1){const Y=Math.floor(ce()*(ue+1)),oe=ae[ue];ae[ue]=ae[Y],ae[Y]=oe}}function O(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.unshift(te))}function x(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.push(te))}function U(ae,te){for(const ce of te)ae.push(ce)}function F(ae,te){return Array.isArray(ae)?ae.map(te):te(ae)}function H(ae){return Array.isArray(ae)?ae:[ae]}function j(ae){return ae[Math.floor(Math.random()*ae.length)]}function re(ae,te,ce){const ue=V(ae,te),Y=ae.length,oe=ce.length;ae.length=Y+oe;for(let ve=Y-1;ve>=ue;ve--)ae[ve+oe]=ae[ve];for(let ve=0;ve<oe;ve++)ae[ve+ue]=ce[ve]}function B(ae,te,ce,ue){const Y=V(ae,te);let oe=ae.splice(Y,ce);return oe===void 0&&(oe=[]),re(ae,Y,ue),oe}function V(ae,te){return te<0?Math.max(te+ae.length,0):Math.min(te,ae.length)}var X;(function(ae){function te(oe){return oe<0}ae.isLessThan=te;function ce(oe){return oe<=0}ae.isLessThanOrEqual=ce;function ue(oe){return oe>0}ae.isGreaterThan=ue;function Y(oe){return oe===0}ae.isNeitherLessOrGreaterThan=Y,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(X||(e.CompareResult=X={}));function ee(ae,te){return(ce,ue)=>te(ae(ce),ae(ue))}function he(...ae){return(te,ce)=>{for(const ue of ae){const Y=ue(te,ce);if(!X.isNeitherLessOrGreaterThan(Y))return Y}return X.neitherLessOrGreaterThan}}const ne=(ae,te)=>ae-te;e.numberComparator=ne;const De=(ae,te)=>(0,e.numberComparator)(ae?1:0,te?1:0);e.booleanComparator=De;function pe(ae){return(te,ce)=>-ae(te,ce)}class G{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ce=this.firstIdx;for(;ce<this.items.length&&te(this.items[ce]);)ce++;const ue=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,ue}takeFromEndWhile(te){let ce=this.lastIdx;for(;ce>=0&&te(this.items[ce]);)ce--;const ue=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ce=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ce}}e.ArrayQueue=G;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(ce=>(te(ce),!0))}toArray(){const te=[];return this.iterate(ce=>(te.push(ce),!0)),te}filter(te){return new W(ce=>this.iterate(ue=>te(ue)?ce(ue):!0))}map(te){return new W(ce=>this.iterate(ue=>ce(te(ue))))}some(te){let ce=!1;return this.iterate(ue=>(ce=te(ue),!ce)),ce}findFirst(te){let ce;return this.iterate(ue=>te(ue)?(ce=ue,!1):!0),ce}findLast(te){let ce;return this.iterate(ue=>(te(ue)&&(ce=ue),!0)),ce}findLastMaxBy(te){let ce,ue=!0;return this.iterate(Y=>((ue||X.isGreaterThan(te(Y,ce)))&&(ue=!1,ce=Y),!0)),ce}}e.CallbackIterable=W;class se{constructor(te){this._indexMap=te}static createSortPermutation(te,ce){const ue=Array.from(te.keys()).sort((Y,oe)=>ce(te[Y],te[oe]));return new se(ue)}apply(te){return te.map((ce,ue)=>te[this._indexMap[ue]])}inverse(){const te=this._indexMap.slice();for(let ce=0;ce<this._indexMap.length;ce++)te[this._indexMap[ce]]=ce;return new se(te)}}e.Permutation=se}),define(_e[66],ye([1,0,14]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=d,e.assertNever=T,e.assert=R,e.softAssert=L,e.assertFn=A,e.checkAdjacentItems=p;function d(a,I){if(!a)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function T(a,I="Unreachable"){throw new Error(I)}function R(a,I="unexpected state"){if(!a)throw new s.BugIndicatingError(`Assertion Failed: ${I}`)}function L(a){a||(0,s.onUnexpectedError)(new s.BugIndicatingError("Soft Assertion Failed"))}function A(a){if(!a()){debugger;a(),(0,s.onUnexpectedError)(new s.BugIndicatingError("Assertion Failed"))}}function p(a,I){let _=0;for(;_<a.length-1;){const c=a[_],C=a[_+1];if(!I(c,C))return!1;_++}return!0}});var Wn=this&&this.__createBinding||(Object.create?function(le,e,s,d){d===void 0&&(d=s);var T=Object.getOwnPropertyDescriptor(e,s);(!T||("get"in T?!e.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return e[s]}}),Object.defineProperty(le,d,T)}:function(le,e,s,d){d===void 0&&(d=s),le[d]=e[s]}),zn=this&&this.__setModuleDefault||(Object.create?function(le,e){Object.defineProperty(le,"default",{enumerable:!0,value:e})}:function(le,e){le.default=e}),ze=this&&this.__importStar||function(le){if(le&&le.__esModule)return le;var e={};if(le!=null)for(var s in le)s!=="default"&&Object.prototype.hasOwnProperty.call(le,s)&&Wn(e,le,s);return zn(e,le),e};define(_e[175],ye([1,0,19]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=T,e.jsonStringifyEquals=R,e.itemEquals=L,e.equalsIfDefined=A,e.structuralEquals=p,e.getStructuralKey=a,s=ze(s);const d=(C,b)=>C===b;e.strictEquals=d;function T(C=e.strictEquals){return(b,l)=>s.equals(b,l,C)}function R(){return(C,b)=>JSON.stringify(C)===JSON.stringify(b)}function L(){return(C,b)=>C.equals(b)}function A(C,b,l){if(l!==void 0){const m=C;return m==null||b===void 0||b===null?b===m:l(m,b)}else{const m=C;return(h,g)=>h==null||g===void 0||g===null?g===h:m(h,g)}}function p(C,b){if(C===b)return!0;if(Array.isArray(C)&&Array.isArray(b)){if(C.length!==b.length)return!1;for(let l=0;l<C.length;l++)if(!p(C[l],b[l]))return!1;return!0}if(C&&typeof C=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(C)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const l=C,m=b,h=Object.keys(l),g=Object.keys(m),n=new Set(g);if(h.length!==g.length)return!1;for(const o of h)if(!n.has(o)||!p(l[o],m[o]))return!1;return!0}return!1}function a(C){return JSON.stringify(c(C))}let I=0;const _=new WeakMap;function c(C){if(Array.isArray(C))return C.map(c);if(C&&typeof C=="object")if(Object.getPrototypeOf(C)===Object.prototype){const b=C,l=Object.create(null);for(const m of Object.keys(b).sort())l[m]=c(b[m]);return l}else{let b=_.get(C);return b===void 0&&(b=I++,_.set(C,b)),b+"----2b76a038c20c4bcc"}return C}}),define(_e[80],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=s;function s(d,T){const R=this;let L=!1,A;return function(){if(L)return A;if(L=!0,T)try{A=d.apply(R,arguments)}finally{T()}else A=d.apply(R,arguments);return A}}}),define(_e[133],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(_e[40],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(d){function T(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}d.is=T;const R=Object.freeze([]);function L(){return R}d.empty=L;function*A(r){yield r}d.single=A;function p(r){return T(r)?r:A(r)}d.wrap=p;function a(r){return r||R}d.from=a;function*I(r){for(let f=r.length-1;f>=0;f--)yield r[f]}d.reverse=I;function _(r){return!r||r[Symbol.iterator]().next().done===!0}d.isEmpty=_;function c(r){return r[Symbol.iterator]().next().value}d.first=c;function C(r,f){let u=0;for(const v of r)if(f(v,u++))return!0;return!1}d.some=C;function b(r,f){for(const u of r)if(f(u))return u}d.find=b;function*l(r,f){for(const u of r)f(u)&&(yield u)}d.filter=l;function*m(r,f){let u=0;for(const v of r)yield f(v,u++)}d.map=m;function*h(r,f){let u=0;for(const v of r)yield*f(v,u++)}d.flatMap=h;function*g(...r){for(const f of r)yield*f}d.concat=g;function n(r,f,u){let v=u;for(const y of r)v=f(v,y);return v}d.reduce=n;function*o(r,f,u=r.length){for(f<0&&(f+=r.length),u<0?u+=r.length:u>r.length&&(u=r.length);f<u;f++)yield r[f]}d.slice=o;function t(r,f=Number.POSITIVE_INFINITY){const u=[];if(f===0)return[u,r];const v=r[Symbol.iterator]();for(let y=0;y<f;y++){const D=v.next();if(D.done)return[u,d.empty()];u.push(D.value)}return[u,{[Symbol.iterator](){return v}}]}d.consume=t;async function i(r){const f=[];for await(const u of r)f.push(u);return Promise.resolve(f)}d.asyncToArray=i})(s||(e.Iterable=s={}))}),define(_e[176],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=L,e.getLocation=_,e.parse=c,e.parseTree=C,e.findNodeAtLocation=b,e.getNodePath=l,e.getNodeValue=m,e.contains=h,e.findNodeAtOffset=g,e.visit=n,e.getNodeType=o;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var d;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(d||(e.SyntaxKind=d={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,i=!1){let r=0;const f=t.length;let u="",v=0,y=d.Unknown,D=s.None;function w(O){let x=0,U=0;for(;x<O;){const F=t.charCodeAt(r);if(F>=I._0&&F<=I._9)U=U*16+F-I._0;else if(F>=I.A&&F<=I.F)U=U*16+F-I.A+10;else if(F>=I.a&&F<=I.f)U=U*16+F-I.a+10;else break;r++,x++}return x<O&&(U=-1),U}function P(O){r=O,u="",v=0,y=d.Unknown,D=s.None}function k(){const O=r;if(t.charCodeAt(r)===I._0)r++;else for(r++;r<t.length&&a(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===I.dot)if(r++,r<t.length&&a(t.charCodeAt(r)))for(r++;r<t.length&&a(t.charCodeAt(r));)r++;else return D=s.UnexpectedEndOfNumber,t.substring(O,r);let x=r;if(r<t.length&&(t.charCodeAt(r)===I.E||t.charCodeAt(r)===I.e))if(r++,(r<t.length&&t.charCodeAt(r)===I.plus||t.charCodeAt(r)===I.minus)&&r++,r<t.length&&a(t.charCodeAt(r))){for(r++;r<t.length&&a(t.charCodeAt(r));)r++;x=r}else D=s.UnexpectedEndOfNumber;return t.substring(O,x)}function E(){let O="",x=r;for(;;){if(r>=f){O+=t.substring(x,r),D=s.UnexpectedEndOfString;break}const U=t.charCodeAt(r);if(U===I.doubleQuote){O+=t.substring(x,r),r++;break}if(U===I.backslash){if(O+=t.substring(x,r),r++,r>=f){D=s.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case I.doubleQuote:O+='"';break;case I.backslash:O+="\\";break;case I.slash:O+="/";break;case I.b:O+="\b";break;case I.f:O+="\f";break;case I.n:O+=`
`;break;case I.r:O+="\r";break;case I.t:O+="	";break;case I.u:{const H=w(4);H>=0?O+=String.fromCharCode(H):D=s.InvalidUnicode;break}default:D=s.InvalidEscapeCharacter}x=r;continue}if(U>=0&&U<=31)if(p(U)){O+=t.substring(x,r),D=s.UnexpectedEndOfString;break}else D=s.InvalidCharacter;r++}return O}function S(){if(u="",D=s.None,v=r,r>=f)return v=f,y=d.EOF;let O=t.charCodeAt(r);if(A(O)){do r++,u+=String.fromCharCode(O),O=t.charCodeAt(r);while(A(O));return y=d.Trivia}if(p(O))return r++,u+=String.fromCharCode(O),O===I.carriageReturn&&t.charCodeAt(r)===I.lineFeed&&(r++,u+=`
`),y=d.LineBreakTrivia;switch(O){case I.openBrace:return r++,y=d.OpenBraceToken;case I.closeBrace:return r++,y=d.CloseBraceToken;case I.openBracket:return r++,y=d.OpenBracketToken;case I.closeBracket:return r++,y=d.CloseBracketToken;case I.colon:return r++,y=d.ColonToken;case I.comma:return r++,y=d.CommaToken;case I.doubleQuote:return r++,u=E(),y=d.StringLiteral;case I.slash:{const x=r-1;if(t.charCodeAt(r+1)===I.slash){for(r+=2;r<f&&!p(t.charCodeAt(r));)r++;return u=t.substring(x,r),y=d.LineCommentTrivia}if(t.charCodeAt(r+1)===I.asterisk){r+=2;const U=f-1;let F=!1;for(;r<U;){if(t.charCodeAt(r)===I.asterisk&&t.charCodeAt(r+1)===I.slash){r+=2,F=!0;break}r++}return F||(r++,D=s.UnexpectedEndOfComment),u=t.substring(x,r),y=d.BlockCommentTrivia}return u+=String.fromCharCode(O),r++,y=d.Unknown}case I.minus:if(u+=String.fromCharCode(O),r++,r===f||!a(t.charCodeAt(r)))return y=d.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return u+=k(),y=d.NumericLiteral;default:for(;r<f&&M(O);)r++,O=t.charCodeAt(r);if(v!==r){switch(u=t.substring(v,r),u){case"true":return y=d.TrueKeyword;case"false":return y=d.FalseKeyword;case"null":return y=d.NullKeyword}return y=d.Unknown}return u+=String.fromCharCode(O),r++,y=d.Unknown}}function M(O){if(A(O)||p(O))return!1;switch(O){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let O;do O=S();while(O>=d.LineCommentTrivia&&O<=d.Trivia);return O}return{setPosition:P,getPosition:()=>r,scan:i?N:S,getToken:()=>y,getTokenValue:()=>u,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>D}}function A(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function a(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function _(t,i){const r=[],f=new Object;let u;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function D(w,P,k,E){v.value=w,v.offset=P,v.length=k,v.type=E,v.colonOffset=void 0,u=v}try{n(t,{onObjectBegin:(w,P)=>{if(i<=w)throw f;u=void 0,y=i>w,r.push("")},onObjectProperty:(w,P,k)=>{if(i<P||(D(w,P,k,"property"),r[r.length-1]=w,i<=P+k))throw f},onObjectEnd:(w,P)=>{if(i<=w)throw f;u=void 0,r.pop()},onArrayBegin:(w,P)=>{if(i<=w)throw f;u=void 0,r.push(0)},onArrayEnd:(w,P)=>{if(i<=w)throw f;u=void 0,r.pop()},onLiteralValue:(w,P,k)=>{if(i<P||(D(w,P,k,o(w)),i<=P+k))throw f},onSeparator:(w,P,k)=>{if(i<=P)throw f;if(w===":"&&u&&u.type==="property")u.colonOffset=P,y=!1,u=void 0;else if(w===","){const E=r[r.length-1];typeof E=="number"?r[r.length-1]=E+1:(y=!0,r[r.length-1]=""),u=void 0}}})}catch(w){if(w!==f)throw w}return{path:r,previousNode:u,isAtPropertyKey:y,matches:w=>{let P=0;for(let k=0;P<w.length&&k<r.length;k++)if(w[P]===r[k]||w[P]==="*")P++;else if(w[P]!=="**")return!1;return P===w.length}}}function c(t,i=[],r=R.DEFAULT){let f=null,u=[];const v=[];function y(w){Array.isArray(u)?u.push(w):f!==null&&(u[f]=w)}return n(t,{onObjectBegin:()=>{const w={};y(w),v.push(u),u=w,f=null},onObjectProperty:w=>{f=w},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const w=[];y(w),v.push(u),u=w,f=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:y,onError:(w,P,k)=>{i.push({error:w,offset:P,length:k})}},r),u[0]}function C(t,i=[],r=R.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(w){f.type==="property"&&(f.length=w-f.offset,f=f.parent)}function v(w){return f.children.push(w),w}n(t,{onObjectBegin:w=>{f=v({type:"object",offset:w,length:-1,parent:f,children:[]})},onObjectProperty:(w,P,k)=>{f=v({type:"property",offset:P,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:w,offset:P,length:k,parent:f})},onObjectEnd:(w,P)=>{f.length=w+P-f.offset,f=f.parent,u(w+P)},onArrayBegin:(w,P)=>{f=v({type:"array",offset:w,length:-1,parent:f,children:[]})},onArrayEnd:(w,P)=>{f.length=w+P-f.offset,f=f.parent,u(w+P)},onLiteralValue:(w,P,k)=>{v({type:o(w),offset:P,length:k,parent:f,value:w}),u(P+k)},onSeparator:(w,P,k)=>{f.type==="property"&&(w===":"?f.colonOffset=P:w===","&&u(P))},onError:(w,P,k)=>{i.push({error:w,offset:P,length:k})}},r);const D=f.children[0];return D&&delete D.parent,D}function b(t,i){if(!t)return;let r=t;for(const f of i)if(typeof f=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===f){r=v.children[1],u=!0;break}if(!u)return}else{const u=f;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}function l(t){if(!t.parent||!t.parent.children)return[];const i=l(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;i.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&i.push(r)}return i}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const i=Object.create(null);for(const r of t.children){const f=r.children[1];f&&(i[r.children[0].value]=m(f))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function h(t,i,r=!1){return i>=t.offset&&i<t.offset+t.length||r&&i===t.offset+t.length}function g(t,i,r=!1){if(h(t,i,r)){const f=t.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=i;u++){const v=g(f[u],i,r);if(v)return v}return t}}function n(t,i,r=R.DEFAULT){const f=L(t,!1);function u(ee){return ee?()=>ee(f.getTokenOffset(),f.getTokenLength()):()=>!0}function v(ee){return ee?he=>ee(he,f.getTokenOffset(),f.getTokenLength()):()=>!0}const y=u(i.onObjectBegin),D=v(i.onObjectProperty),w=u(i.onObjectEnd),P=u(i.onArrayBegin),k=u(i.onArrayEnd),E=v(i.onLiteralValue),S=v(i.onSeparator),M=u(i.onComment),N=v(i.onError),O=r&&r.disallowComments,x=r&&r.allowTrailingComma;function U(){for(;;){const ee=f.scan();switch(f.getTokenError()){case s.InvalidUnicode:F(T.InvalidUnicode);break;case s.InvalidEscapeCharacter:F(T.InvalidEscapeCharacter);break;case s.UnexpectedEndOfNumber:F(T.UnexpectedEndOfNumber);break;case s.UnexpectedEndOfComment:O||F(T.UnexpectedEndOfComment);break;case s.UnexpectedEndOfString:F(T.UnexpectedEndOfString);break;case s.InvalidCharacter:F(T.InvalidCharacter);break}switch(ee){case d.LineCommentTrivia:case d.BlockCommentTrivia:O?F(T.InvalidCommentToken):M();break;case d.Unknown:F(T.InvalidSymbol);break;case d.Trivia:case d.LineBreakTrivia:break;default:return ee}}}function F(ee,he=[],ne=[]){if(N(ee),he.length+ne.length>0){let De=f.getToken();for(;De!==d.EOF;){if(he.indexOf(De)!==-1){U();break}else if(ne.indexOf(De)!==-1)break;De=U()}}}function H(ee){const he=f.getTokenValue();return ee?E(he):D(he),U(),!0}function j(){switch(f.getToken()){case d.NumericLiteral:{let ee=0;try{ee=JSON.parse(f.getTokenValue()),typeof ee!="number"&&(F(T.InvalidNumberFormat),ee=0)}catch{F(T.InvalidNumberFormat)}E(ee);break}case d.NullKeyword:E(null);break;case d.TrueKeyword:E(!0);break;case d.FalseKeyword:E(!1);break;default:return!1}return U(),!0}function re(){return f.getToken()!==d.StringLiteral?(F(T.PropertyNameExpected,[],[d.CloseBraceToken,d.CommaToken]),!1):(H(!1),f.getToken()===d.ColonToken?(S(":"),U(),X()||F(T.ValueExpected,[],[d.CloseBraceToken,d.CommaToken])):F(T.ColonExpected,[],[d.CloseBraceToken,d.CommaToken]),!0)}function B(){y(),U();let ee=!1;for(;f.getToken()!==d.CloseBraceToken&&f.getToken()!==d.EOF;){if(f.getToken()===d.CommaToken){if(ee||F(T.ValueExpected,[],[]),S(","),U(),f.getToken()===d.CloseBraceToken&&x)break}else ee&&F(T.CommaExpected,[],[]);re()||F(T.ValueExpected,[],[d.CloseBraceToken,d.CommaToken]),ee=!0}return w(),f.getToken()!==d.CloseBraceToken?F(T.CloseBraceExpected,[d.CloseBraceToken],[]):U(),!0}function V(){P(),U();let ee=!1;for(;f.getToken()!==d.CloseBracketToken&&f.getToken()!==d.EOF;){if(f.getToken()===d.CommaToken){if(ee||F(T.ValueExpected,[],[]),S(","),U(),f.getToken()===d.CloseBracketToken&&x)break}else ee&&F(T.CommaExpected,[],[]);X()||F(T.ValueExpected,[],[d.CloseBracketToken,d.CommaToken]),ee=!0}return k(),f.getToken()!==d.CloseBracketToken?F(T.CloseBracketExpected,[d.CloseBracketToken],[]):U(),!0}function X(){switch(f.getToken()){case d.OpenBracketToken:return V();case d.OpenBraceToken:return B();case d.StringLiteral:return H(!0);default:return j()}}return U(),f.getToken()===d.EOF?r.allowEmptyContent?!0:(F(T.ValueExpected,[],[]),!1):X()?(f.getToken()!==d.EOF&&F(T.EndOfFileExpected,[],[]),!0):(F(T.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(_e[49],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class s{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=s}),define(_e[81],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class s{static{this.Undefined=new s(void 0)}constructor(R){this.element=R,this.next=s.Undefined,this.prev=s.Undefined}}class d{constructor(){this._first=s.Undefined,this._last=s.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===s.Undefined}clear(){let R=this._first;for(;R!==s.Undefined;){const L=R.next;R.prev=s.Undefined,R.next=s.Undefined,R=L}this._first=s.Undefined,this._last=s.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,L){const A=new s(R);if(this._first===s.Undefined)this._first=A,this._last=A;else if(L){const a=this._last;this._last=A,A.prev=a,a.next=A}else{const a=this._first;this._first=A,A.next=a,a.prev=A}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(A))}}shift(){if(this._first!==s.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==s.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==s.Undefined&&R.next!==s.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===s.Undefined&&R.next===s.Undefined?(this._first=s.Undefined,this._last=s.Undefined):R.next===s.Undefined?(this._last=this._last.prev,this._last.next=s.Undefined):R.prev===s.Undefined&&(this._first=this._first.next,this._first.prev=s.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==s.Undefined;)yield R.element,R=R.next}}e.LinkedList=d}),define(_e[29],ye([1,0]),function(le,e){"use strict";var s,d,T;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=R,e.mapToString=L,e.setToString=A,e.mapsStrictEqualIgnoreOrder=o;function R(t,i,r){let f=t.get(i);return f===void 0&&(f=r,t.set(i,f)),f}function L(t){const i=[];return t.forEach((r,f)=>{i.push(`${f} => ${r}`)}),`Map(${t.size}) {${i.join(", ")}}`}function A(t){const i=[];return t.forEach(r=>{i.push(r)}),`Set(${t.size}) {${i.join(", ")}}`}class p{constructor(i,r){this.uri=i,this.value=r}}function a(t){return Array.isArray(t)}class I{static{this.defaultToKey=i=>i.toString()}constructor(i,r){if(this[s]="ResourceMap",i instanceof I)this.map=new Map(i.map),this.toKey=r??I.defaultToKey;else if(a(i)){this.map=new Map,this.toKey=r??I.defaultToKey;for(const[f,u]of i)this.set(f,u)}else this.map=new Map,this.toKey=i??I.defaultToKey}set(i,r){return this.map.set(this.toKey(i),new p(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[f,u]of this.map)i(u.value,u.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=I;class _{constructor(i,r){this[d]="ResourceSet",!i||typeof i=="function"?this._map=new I(i):(this._map=new I(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((f,u)=>i.call(r,u,u,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=_;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c||(e.Touch=c={}));class C{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=c.None){const f=this._map.get(i);if(f)return r!==c.None&&this.touch(f,r),f.value}set(i,r,f=c.None){let u=this._map.get(i);if(u)u.value=r,f!==c.None&&this.touch(u,f);else{switch(u={key:i,value:r,next:void 0,previous:void 0},f){case c.None:this.addItemLast(u);break;case c.AsOld:this.addItemFirst(u);break;case c.AsNew:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const f=this._state;let u=this._head;for(;u;){if(r?i.bind(r)(u.value,u.key,this):i(u.value,u.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,r=this._state;let f=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return u}values(){const i=this,r=this._state;let f=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return u}entries(){const i=this,r=this._state;let f=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,f=this.size;for(;r&&f>i;)this._map.delete(r.key),r=r.next,f--;this._head=r,this._size=f,r&&(r.previous=void 0),this._state++}trimNew(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._tail,f=this.size;for(;r&&f>i;)this._map.delete(r.key),r=r.previous,f--;this._tail=r,this._size=f,r&&(r.next=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,f=i.previous;if(!r||!f)throw new Error("Invalid list");r.previous=f,f.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==c.AsOld&&r!==c.AsNew)){if(r===c.AsOld){if(i===this._head)return;const f=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(f.previous=u,u.next=f),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===c.AsNew){if(i===this._tail)return;const f=i.next,u=i.previous;i===this._head?(f.previous=void 0,this._head=f):(f.previous=u,u.next=f),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,f)=>{i.push([f,r])}),i}fromJSON(i){this.clear();for(const[r,f]of i)this.set(r,f)}}e.LinkedMap=C;class b extends C{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=c.AsNew){return super.get(i,r)}peek(i){return super.get(i,c.None)}set(i,r){return super.set(i,r,c.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class l extends b{constructor(i,r=1){super(i,r)}trim(i){this.trimOld(i)}set(i,r){return super.set(i,r),this.checkTrim(),this}}e.LRUCache=l;class m extends b{constructor(i,r=1){super(i,r)}trim(i){this.trimNew(i)}set(i,r){return this._limit<=this.size&&!this.has(i)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(i,r),this}}e.MRUCache=m;class h{constructor(){this.map=new Map}add(i){return this.map.set(i,(this.map.get(i)||0)+1),this}delete(i){let r=this.map.get(i)||0;return r===0?!1:(r--,r===0?this.map.delete(i):this.map.set(i,r),!0)}has(i){return this.map.has(i)}}e.CounterSet=h;class g{constructor(i){if(this._m1=new Map,this._m2=new Map,i)for(const[r,f]of i)this.set(r,f)}clear(){this._m1.clear(),this._m2.clear()}set(i,r){this._m1.set(i,r),this._m2.set(r,i)}get(i){return this._m1.get(i)}getKey(i){return this._m2.get(i)}delete(i){const r=this._m1.get(i);return r===void 0?!1:(this._m1.delete(i),this._m2.delete(r),!0)}forEach(i,r){this._m1.forEach((f,u)=>{i.call(r,f,u,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=g;class n{constructor(){this.map=new Map}add(i,r){let f=this.map.get(i);f||(f=new Set,this.map.set(i,f)),f.add(r)}delete(i,r){const f=this.map.get(i);f&&(f.delete(r),f.size===0&&this.map.delete(i))}forEach(i,r){const f=this.map.get(i);f&&f.forEach(r)}get(i){const r=this.map.get(i);return r||new Set}}e.SetMap=n;function o(t,i){if(t===i)return!0;if(t.size!==i.size)return!1;for(const[r,f]of t)if(!i.has(r)||i.get(r)!==f)return!1;for(const[r]of i)if(!t.has(r))return!1;return!0}}),define(_e[3],ye([1,0,19,79,29,80,40]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=I,e.trackDisposable=_,e.markAsDisposed=c,e.markAsSingleton=l,e.isDisposable=m,e.dispose=h,e.disposeIfDisposable=g,e.combinedDisposable=n,e.toDisposable=o,e.disposeOnReturn=P;const A=!1;let p=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(S){let M=this.livingDisposables.get(S);return M||(M={parent:null,source:null,isSingleton:!1,value:S,idx:a.idx++},this.livingDisposables.set(S,M)),M}trackDisposable(S){const M=this.getDisposableData(S);M.source||(M.source=new Error().stack)}setParent(S,M){const N=this.getDisposableData(S);N.parent=M}markAsDisposed(S){this.livingDisposables.delete(S)}markAsSingleton(S){this.getDisposableData(S).isSingleton=!0}getRootParent(S,M){const N=M.get(S);if(N)return N;const O=S.parent?this.getRootParent(this.getDisposableData(S.parent),M):S;return M.set(S,O),O}getTrackedDisposables(){const S=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,S).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(S=10,M){let N;if(M)N=M;else{const H=new Map,j=[...this.livingDisposables.values()].filter(B=>B.source!==null&&!this.getRootParent(B,H).isSingleton);if(j.length===0)return;const re=new Set(j.map(B=>B.value));if(N=j.filter(B=>!(B.parent&&re.has(B.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(H){function j(B,V){for(;B.length>0&&V.some(X=>typeof X=="string"?X===B[0]:B[0].match(X));)B.shift()}const re=H.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return j(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const x=new T.SetMap;for(const H of N){const j=O(H);for(let re=0;re<=j.length;re++)x.add(j.slice(0,re).join(`
`),H)}N.sort((0,s.compareBy)(H=>H.idx,s.numberComparator));let U="",F=0;for(const H of N.slice(0,S)){F++;const j=O(H),re=[];for(let B=0;B<j.length;B++){let V=j[B];V=`(shared with ${x.get(j.slice(0,B+1).join(`
`)).size}/${N.length} leaks) at ${V}`;const ee=x.get(j.slice(0,B).join(`
`)),he=(0,d.groupBy)([...ee].map(ne=>O(ne)[B]),ne=>ne);delete he[j[B]];for(const[ne,De]of Object.entries(he))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(V)}U+=`


==================== Leaking disposable ${F}/${N.length}: ${H.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return N.length>S&&(U+=`


... and ${N.length-S} more leaking disposables

`),{leaks:N,details:U}}}e.DisposableTracker=a;function I(E){p=E}if(A){const E="__is_disposable_tracked__";I(new class{trackDisposable(S){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[E]||console.log(M)},3e3)}setParent(S,M){if(S&&S!==i.None)try{S[E]=!0}catch{}}markAsDisposed(S){if(S&&S!==i.None)try{S[E]=!0}catch{}}markAsSingleton(S){}})}function _(E){return p?.trackDisposable(E),E}function c(E){p?.markAsDisposed(E)}function C(E,S){p?.setParent(E,S)}function b(E,S){if(p)for(const M of E)p.setParent(M,S)}function l(E){return p?.markAsSingleton(E),E}function m(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function h(E){if(L.Iterable.is(E)){const S=[];for(const M of E)if(M)try{M.dispose()}catch(N){S.push(N)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function g(E){for(const S of E)m(S)&&S.dispose();return[]}function n(...E){const S=o(()=>h(E));return b(E,S),S}function o(E){const S=_({dispose:(0,R.createSingleCallFunction)(()=>{c(S),E()})});return S}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return C(S,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(S),S.dispose()}}deleteAndLeak(S){S&&this._toDispose.has(S)&&(this._toDispose.delete(S),C(S,null))}}e.DisposableStore=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,_(this),C(this._store,this)}dispose(){c(this),this._store.dispose()}_register(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(S)}}e.Disposable=i;class r{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(S){this._isDisposed||S===this._value||(this._value?.dispose(),S&&C(S,this),this._value=S)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const S=this._value;return this._value=void 0,S&&C(S,null),S}}e.MutableDisposable=r;class f{constructor(S){this._disposable=new r,this._isDisposed=!1,this._disposable.value=S}get value(){return this._disposable.value}set value(S){this._isDisposed||S===this._disposable.value||(this._disposable.value=S)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=f;class u{constructor(S){this._disposable=S,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(S){let M=S;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,c(this))},this}}e.SafeDisposable=v;class y{constructor(){this.references=new Map}acquire(S,...M){let N=this.references.get(S);N||(N={counter:0,object:this.createReferencedObject(S,...M)},this.references.set(S,N));const{object:O}=N,x=(0,R.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(S,N.object),this.references.delete(S))});return N.counter++,{object:O,dispose:x}}}e.ReferenceCollection=y;class D{constructor(S){this.referenceCollection=S}async acquire(S,...M){const N=this.referenceCollection.acquire(S,...M);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.AsyncReferenceCollection=D;class w{constructor(S){this.object=S}dispose(){}}e.ImmortalReference=w;function P(E){const S=new t;try{E(S)}finally{S.dispose()}}class k{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(S){return this._store.has(S)}get size(){return this._store.size}get(S){return this._store.get(S)}set(S,M,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(S)?.dispose(),this._store.set(S,M)}deleteAndDispose(S){this._store.get(S)?.dispose(),this._store.delete(S)}deleteAndLeak(S){const M=this._store.get(S);return this._store.delete(S),M}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=k}),function(le,e){typeof define=="function"&&define.amd?define(_e[177],ye([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(te,ce){for(var ue=0;ue<ce.length;ue++){var Y=ce[ue];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(te,Y.key,Y)}}function s(te,ce,ue){return ce&&e(te.prototype,ce),ue&&e(te,ue),Object.defineProperty(te,"prototype",{writable:!1}),te}function d(te,ce){if(te){if(typeof te=="string")return T(te,ce);var ue=Object.prototype.toString.call(te).slice(8,-1);if(ue==="Object"&&te.constructor&&(ue=te.constructor.name),ue==="Map"||ue==="Set")return Array.from(te);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return T(te,ce)}}function T(te,ce){(ce==null||ce>te.length)&&(ce=te.length);for(var ue=0,Y=new Array(ce);ue<ce;ue++)Y[ue]=te[ue];return Y}function R(te,ce){var ue=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(ue)return(ue=ue.call(te)).next.bind(ue);if(Array.isArray(te)||(ue=d(te))||ce&&te&&typeof te.length=="number"){ue&&(te=ue);var Y=0;return function(){return Y>=te.length?{done:!0}:{done:!1,value:te[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=L();function A(te){le.defaults=te}var p=/[&<>"']/,a=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ce){return c[ce]};function b(te,ce){if(ce){if(p.test(te))return te.replace(a,C)}else if(I.test(te))return te.replace(_,C);return te}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(l,function(ce,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(te,ce){te=typeof te=="string"?te:te.source,ce=ce||"";var ue={replace:function(oe,ve){return ve=ve.source||ve,ve=ve.replace(h,"$1"),te=te.replace(oe,ve),ue},getRegex:function(){return new RegExp(te,ce)}};return ue}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ce,ue){if(te){var Y;try{Y=decodeURIComponent(m(ue)).replace(n,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}ce&&!o.test(ue)&&(ue=v(ce,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},r=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(te,ce){i[" "+te]||(r.test(te)?i[" "+te]=te+"/":i[" "+te]=P(te,"/",!0)),te=i[" "+te];var ue=te.indexOf(":")===-1;return ce.substring(0,2)==="//"?ue?ce:te.replace(f,"$1")+ce:ce.charAt(0)==="/"?ue?ce:te.replace(u,"$1")+ce:te+ce}var y={exec:function(){}};function D(te){for(var ce=1,ue,Y;ce<arguments.length;ce++){ue=arguments[ce];for(Y in ue)Object.prototype.hasOwnProperty.call(ue,Y)&&(te[Y]=ue[Y])}return te}function w(te,ce){var ue=te.replace(/\|/g,function(ve,be,Fe){for(var We=!1,Ce=be;--Ce>=0&&Fe[Ce]==="\\";)We=!We;return We?"|":" |"}),Y=ue.split(/ \|/),oe=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>ce)Y.splice(ce);else for(;Y.length<ce;)Y.push("");for(;oe<Y.length;oe++)Y[oe]=Y[oe].trim().replace(/\\\|/g,"|");return Y}function P(te,ce,ue){var Y=te.length;if(Y===0)return"";for(var oe=0;oe<Y;){var ve=te.charAt(Y-oe-1);if(ve===ce&&!ue)oe++;else if(ve!==ce&&ue)oe++;else break}return te.slice(0,Y-oe)}function k(te,ce){if(te.indexOf(ce[1])===-1)return-1;for(var ue=te.length,Y=0,oe=0;oe<ue;oe++)if(te[oe]==="\\")oe++;else if(te[oe]===ce[0])Y++;else if(te[oe]===ce[1]&&(Y--,Y<0))return oe;return-1}function E(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function S(te,ce){if(ce<1)return"";for(var ue="";ce>1;)ce&1&&(ue+=te),ce>>=1,te+=te;return ue+te}function M(te,ce,ue,Y){var oe=ce.href,ve=ce.title?b(ce.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Y.state.inLink=!0;var Fe={type:"link",raw:ue,href:oe,title:ve,text:be,tokens:Y.inlineTokens(be)};return Y.state.inLink=!1,Fe}return{type:"image",raw:ue,href:oe,title:ve,text:b(be)}}function N(te,ce){var ue=te.match(/^(\s+)(?:```)/);if(ue===null)return ce;var Y=ue[1];return ce.split(`
`).map(function(oe){var ve=oe.match(/^\s+/);if(ve===null)return oe;var be=ve[0];return be.length>=Y.length?oe.slice(Y.length):oe}).join(`
`)}var O=function(){function te(ue){this.options=ue||le.defaults}var ce=te.prototype;return ce.space=function(Y){var oe=this.rules.block.newline.exec(Y);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ce.code=function(Y){var oe=this.rules.block.code.exec(Y);if(oe){var ve=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:P(ve,`
`)}}},ce.fences=function(Y){var oe=this.rules.block.fences.exec(Y);if(oe){var ve=oe[0],be=N(ve,oe[3]||"");return{type:"code",raw:ve,lang:oe[2]?oe[2].trim():oe[2],text:be}}},ce.heading=function(Y){var oe=this.rules.block.heading.exec(Y);if(oe){var ve=oe[2].trim();if(/#$/.test(ve)){var be=P(ve,"#");(this.options.pedantic||!be||/ $/.test(be))&&(ve=be.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:ve,tokens:this.lexer.inline(ve)}}},ce.hr=function(Y){var oe=this.rules.block.hr.exec(Y);if(oe)return{type:"hr",raw:oe[0]}},ce.blockquote=function(Y){var oe=this.rules.block.blockquote.exec(Y);if(oe){var ve=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(ve,[]),text:ve}}},ce.list=function(Y){var oe=this.rules.block.list.exec(Y);if(oe){var ve,be,Fe,We,Ce,Ie,Re,z,$,Q,Z,fe,Ee=oe[1].trim(),Ne=Ee.length>1,Ve={type:"list",raw:"",ordered:Ne,start:Ne?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Ne?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Ne?Ee:"[*+-]");for(var je=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(fe=!1,!(!(oe=je.exec(Y))||this.rules.block.hr.test(Y)));){if(ve=oe[0],Y=Y.substring(ve.length),z=oe[2].split(`
`,1)[0],$=Y.split(`
`,1)[0],this.options.pedantic?(We=2,Z=z.trimLeft()):(We=oe[2].search(/[^ ]/),We=We>4?1:We,Z=z.slice(We),We+=oe[1].length),Ie=!1,!z&&/^ *$/.test($)&&(ve+=$+`
`,Y=Y.substring($.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,We-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,We-1)+"}#");Y&&(Q=Y.split(`
`,1)[0],z=Q,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(z)||nt.test(z)||tt.test(z)||rt.test(Y)));){if(z.search(/[^ ]/)>=We||!z.trim())Z+=`
`+z.slice(We);else if(!Ie)Z+=`
`+z;else break;!Ie&&!z.trim()&&(Ie=!0),ve+=Q+`
`,Y=Y.substring(Q.length+1)}Ve.loose||(Re?Ve.loose=!0:/\n *\n *$/.test(ve)&&(Re=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Z),be&&(Fe=be[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ve,task:!!be,checked:Fe,loose:!1,text:Z}),Ve.raw+=ve}Ve.items[Ve.items.length-1].raw=ve.trimRight(),Ve.items[Ve.items.length-1].text=Z.trimRight(),Ve.raw=Ve.raw.trimRight();var at=Ve.items.length;for(Ce=0;Ce<at;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var mt=Ve.items[Ce].tokens.filter(function(lt){return lt.type==="space"}),dt=mt.every(function(lt){for(var Te=lt.raw.split(""),Ue=0,qe=R(Te),Oe;!(Oe=qe()).done;){var xe=Oe.value;if(xe===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Ve.loose&&mt.length&&dt&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},ce.html=function(Y){var oe=this.rules.block.html.exec(Y);if(oe){var ve={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]);ve.type="paragraph",ve.text=be,ve.tokens=this.lexer.inline(be)}return ve}},ce.def=function(Y){var oe=this.rules.block.def.exec(Y);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var ve=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ve,raw:oe[0],href:oe[2],title:oe[3]}}},ce.table=function(Y){var oe=this.rules.block.table.exec(Y);if(oe){var ve={type:"table",header:w(oe[1]).map(function(Re){return{text:Re}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=oe[0];var be=ve.align.length,Fe,We,Ce,Ie;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(ve.align[Fe])?ve.align[Fe]="right":/^ *:-+: *$/.test(ve.align[Fe])?ve.align[Fe]="center":/^ *:-+ *$/.test(ve.align[Fe])?ve.align[Fe]="left":ve.align[Fe]=null;for(be=ve.rows.length,Fe=0;Fe<be;Fe++)ve.rows[Fe]=w(ve.rows[Fe],ve.header.length).map(function(Re){return{text:Re}});for(be=ve.header.length,We=0;We<be;We++)ve.header[We].tokens=this.lexer.inline(ve.header[We].text);for(be=ve.rows.length,We=0;We<be;We++)for(Ie=ve.rows[We],Ce=0;Ce<Ie.length;Ce++)Ie[Ce].tokens=this.lexer.inline(Ie[Ce].text);return ve}}},ce.lheading=function(Y){var oe=this.rules.block.lheading.exec(Y);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ce.paragraph=function(Y){var oe=this.rules.block.paragraph.exec(Y);if(oe){var ve=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:ve,tokens:this.lexer.inline(ve)}}},ce.text=function(Y){var oe=this.rules.block.text.exec(Y);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ce.escape=function(Y){var oe=this.rules.inline.escape.exec(Y);if(oe)return{type:"escape",raw:oe[0],text:b(oe[1])}},ce.tag=function(Y){var oe=this.rules.inline.tag.exec(Y);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]):oe[0]}},ce.link=function(Y){var oe=this.rules.inline.link.exec(Y);if(oe){var ve=oe[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var be=P(ve.slice(0,-1),"\\");if((ve.length-be.length)%2===0)return}else{var Fe=k(oe[2],"()");if(Fe>-1){var We=oe[0].indexOf("!")===0?5:4,Ce=We+oe[1].length+Fe;oe[2]=oe[2].substring(0,Fe),oe[0]=oe[0].substring(0,Ce).trim(),oe[3]=""}}var Ie=oe[2],Re="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);z&&(Ie=z[1],Re=z[3])}else Re=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(ve)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),M(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ce.reflink=function(Y,oe){var ve;if((ve=this.rules.inline.reflink.exec(Y))||(ve=this.rules.inline.nolink.exec(Y))){var be=(ve[2]||ve[1]).replace(/\s+/g," ");if(be=oe[be.toLowerCase()],!be||!be.href){var Fe=ve[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return M(ve,be,ve[0],this.lexer)}},ce.emStrong=function(Y,oe,ve){ve===void 0&&(ve="");var be=this.rules.inline.emStrong.lDelim.exec(Y);if(be&&!(be[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(ve===""||this.rules.inline.punctuation.exec(ve))){var We=be[0].length-1,Ce,Ie,Re=We,z=0,$=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($.lastIndex=0,oe=oe.slice(-1*Y.length+We);(be=$.exec(oe))!=null;)if(Ce=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Ce){if(Ie=Ce.length,be[3]||be[4]){Re+=Ie;continue}else if((be[5]||be[6])&&We%3&&!((We+Ie)%3)){z+=Ie;continue}if(Re-=Ie,!(Re>0)){if(Ie=Math.min(Ie,Ie+Re+z),Math.min(We,Ie)%2){var Q=Y.slice(1,We+be.index+Ie);return{type:"em",raw:Y.slice(0,We+be.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var Z=Y.slice(2,We+be.index+Ie-1);return{type:"strong",raw:Y.slice(0,We+be.index+Ie+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ce.codespan=function(Y){var oe=this.rules.inline.code.exec(Y);if(oe){var ve=oe[2].replace(/\n/g," "),be=/[^ ]/.test(ve),Fe=/^ /.test(ve)&&/ $/.test(ve);return be&&Fe&&(ve=ve.substring(1,ve.length-1)),ve=b(ve,!0),{type:"codespan",raw:oe[0],text:ve}}},ce.br=function(Y){var oe=this.rules.inline.br.exec(Y);if(oe)return{type:"br",raw:oe[0]}},ce.del=function(Y){var oe=this.rules.inline.del.exec(Y);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ce.autolink=function(Y,oe){var ve=this.rules.inline.autolink.exec(Y);if(ve){var be,Fe;return ve[2]==="@"?(be=b(this.options.mangle?oe(ve[1]):ve[1]),Fe="mailto:"+be):(be=b(ve[1]),Fe=be),{type:"link",raw:ve[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(Y,oe){var ve;if(ve=this.rules.inline.url.exec(Y)){var be,Fe;if(ve[2]==="@")be=b(this.options.mangle?oe(ve[0]):ve[0]),Fe="mailto:"+be;else{var We;do We=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(We!==ve[0]);be=b(ve[0]),ve[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:ve[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(Y,oe){var ve=this.rules.inline.text.exec(Y);if(ve){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):b(ve[0]):ve[0]:be=b(this.options.smartypants?oe(ve[0]):ve[0]),{type:"text",raw:ve[0],text:be}}},te}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=g(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=g(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=g(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=g(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=g(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=D({},x),x.gfm=D({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=g(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=D({},x.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:g(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=g(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=g(x._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=g(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=g(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=g(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=g(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=g(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=g(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=g(U.reflink).replace("label",U._label).replace("ref",x._label).getRegex(),U.nolink=g(U.nolink).replace("ref",x._label).getRegex(),U.reflinkSearch=g(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=D({},U),U.pedantic=D({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=D({},U.normal,{escape:g(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=g(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=D({},U.gfm,{br:g(U.br).replace("{2,}","*").getRegex(),text:g(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(te){var ce="",ue,Y,oe=te.length;for(ue=0;ue<oe;ue++)Y=te.charCodeAt(ue),Math.random()>.5&&(Y="x"+Y.toString(16)),ce+="&#"+Y+";";return ce}var j=function(){function te(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||le.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:x.normal,inline:U.normal};this.options.pedantic?(Y.block=x.pedantic,Y.inline=U.pedantic):this.options.gfm&&(Y.block=x.gfm,this.options.breaks?Y.inline=U.breaks:Y.inline=U.gfm),this.tokenizer.rules=Y}te.lex=function(Y,oe){var ve=new te(oe);return ve.lex(Y)},te.lexInline=function(Y,oe){var ve=new te(oe);return ve.inlineTokens(Y)};var ce=te.prototype;return ce.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ce.blockTokens=function(Y,oe){var ve=this;oe===void 0&&(oe=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Re,z,$){return z+"    ".repeat($.length)});for(var be,Fe,We,Ce;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(be=Re.call({lexer:ve},Y,oe))?(Y=Y.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.space(Y)){Y=Y.substring(be.raw.length),be.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(be);continue}if(be=this.tokenizer.code(Y)){Y=Y.substring(be.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(be);continue}if(be=this.tokenizer.fences(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.heading(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.hr(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.blockquote(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.list(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.html(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.def(Y)){Y=Y.substring(be.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.lheading(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(We=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,z=Y.slice(1),$=void 0;ve.options.extensions.startBlock.forEach(function(Q){$=Q.call({lexer:this},z),typeof $=="number"&&$>=0&&(Re=Math.min(Re,$))}),Re<1/0&&Re>=0&&(We=Y.substring(0,Re+1))}(),this.state.top&&(be=this.tokenizer.paragraph(We))){Fe=oe[oe.length-1],Ce&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(be),Ce=We.length!==Y.length,Y=Y.substring(be.raw.length);continue}if(be=this.tokenizer.text(Y)){Y=Y.substring(be.raw.length),Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(be);continue}if(Y){var Ie="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},ce.inline=function(Y,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Y,tokens:oe}),oe},ce.inlineTokens=function(Y,oe){var ve=this;oe===void 0&&(oe=[]);var be,Fe,We,Ce=Y,Ie,Re,z;if(this.tokens.links){var $=Object.keys(this.tokens.links);if($.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)$.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ie.index)+"["+S("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"["+S("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Re||(z=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(be=Z.call({lexer:ve},Y,oe))?(Y=Y.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.escape(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.tag(Y)){Y=Y.substring(be.raw.length),Fe=oe[oe.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.link(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(be.raw.length),Fe=oe[oe.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.emStrong(Y,Ce,z)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.codespan(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.br(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.del(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.autolink(Y,H)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Y,H))){Y=Y.substring(be.raw.length),oe.push(be);continue}if(We=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,fe=Y.slice(1),Ee=void 0;ve.options.extensions.startInline.forEach(function(Ne){Ee=Ne.call({lexer:this},fe),typeof Ee=="number"&&Ee>=0&&(Z=Math.min(Z,Ee))}),Z<1/0&&Z>=0&&(We=Y.substring(0,Z+1))}(),be=this.tokenizer.inlineText(We,F)){Y=Y.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(z=be.raw.slice(-1)),Re=!0,Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):oe.push(be);continue}if(Y){var Q="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return oe},s(te,null,[{key:"rules",get:function(){return{block:x,inline:U}}}]),te}(),re=function(){function te(ue){this.options=ue||le.defaults}var ce=te.prototype;return ce.code=function(Y,oe,ve){var be=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Y,be);Fe!=null&&Fe!==Y&&(ve=!0,Y=Fe)}return Y=Y.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+b(be,!0)+'">'+(ve?Y:b(Y,!0))+`</code></pre>
`:"<pre><code>"+(ve?Y:b(Y,!0))+`</code></pre>
`},ce.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},ce.html=function(Y){return Y},ce.heading=function(Y,oe,ve,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(ve);return"<h"+oe+' id="'+Fe+'">'+Y+"</h"+oe+`>
`}return"<h"+oe+">"+Y+"</h"+oe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Y,oe,ve){var be=oe?"ol":"ul",Fe=oe&&ve!==1?' start="'+ve+'"':"";return"<"+be+Fe+`>
`+Y+"</"+be+`>
`},ce.listitem=function(Y){return"<li>"+Y+`</li>
`},ce.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Y){return"<p>"+Y+`</p>
`},ce.table=function(Y,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+oe+`</table>
`},ce.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},ce.tablecell=function(Y,oe){var ve=oe.header?"th":"td",be=oe.align?"<"+ve+' align="'+oe.align+'">':"<"+ve+">";return be+Y+("</"+ve+`>
`)},ce.strong=function(Y){return"<strong>"+Y+"</strong>"},ce.em=function(Y){return"<em>"+Y+"</em>"},ce.codespan=function(Y){return"<code>"+Y+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Y){return"<del>"+Y+"</del>"},ce.link=function(Y,oe,ve){if(Y=t(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ve;var be='<a href="'+b(Y)+'"';return oe&&(be+=' title="'+oe+'"'),be+=">"+ve+"</a>",be},ce.image=function(Y,oe,ve){if(Y=t(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ve;var be='<img src="'+Y+'" alt="'+ve+'"';return oe&&(be+=' title="'+oe+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(Y){return Y},te}(),B=function(){function te(){}var ce=te.prototype;return ce.strong=function(Y){return Y},ce.em=function(Y){return Y},ce.codespan=function(Y){return Y},ce.del=function(Y){return Y},ce.html=function(Y){return Y},ce.text=function(Y){return Y},ce.link=function(Y,oe,ve){return""+ve},ce.image=function(Y,oe,ve){return""+ve},ce.br=function(){return""},te}(),V=function(){function te(){this.seen={}}var ce=te.prototype;return ce.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Y,oe){var ve=Y,be=0;if(this.seen.hasOwnProperty(ve)){be=this.seen[Y];do be++,ve=Y+"-"+be;while(this.seen.hasOwnProperty(ve))}return oe||(this.seen[Y]=be,this.seen[ve]=0),ve},ce.slug=function(Y,oe){oe===void 0&&(oe={});var ve=this.serialize(Y);return this.getNextSafeSlug(ve,oe.dryrun)},te}(),X=function(){function te(ue){this.options=ue||le.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new V}te.parse=function(Y,oe){var ve=new te(oe);return ve.parse(Y)},te.parseInline=function(Y,oe){var ve=new te(oe);return ve.parseInline(Y)};var ce=te.prototype;return ce.parse=function(Y,oe){oe===void 0&&(oe=!0);var ve="",be,Fe,We,Ce,Ie,Re,z,$,Q,Z,fe,Ee,Ne,Ve,je,tt,rt,ot,nt,at=Y.length;for(be=0;be<at;be++){if(Z=Y[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(nt=this.options.extensions.renderers[Z.type].call({parser:this},Z),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){ve+=nt||"";continue}switch(Z.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,m(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for($="",z="",Ce=Z.header.length,Fe=0;Fe<Ce;Fe++)z+=this.renderer.tablecell(this.parseInline(Z.header[Fe].tokens),{header:!0,align:Z.align[Fe]});for($+=this.renderer.tablerow(z),Q="",Ce=Z.rows.length,Fe=0;Fe<Ce;Fe++){for(Re=Z.rows[Fe],z="",Ie=Re.length,We=0;We<Ie;We++)z+=this.renderer.tablecell(this.parseInline(Re[We].tokens),{header:!1,align:Z.align[We]});Q+=this.renderer.tablerow(z)}ve+=this.renderer.table($,Q);continue}case"blockquote":{Q=this.parse(Z.tokens),ve+=this.renderer.blockquote(Q);continue}case"list":{for(fe=Z.ordered,Ee=Z.start,Ne=Z.loose,Ce=Z.items.length,Q="",Fe=0;Fe<Ce;Fe++)je=Z.items[Fe],tt=je.checked,rt=je.task,Ve="",je.task&&(ot=this.renderer.checkbox(tt),Ne?je.tokens.length>0&&je.tokens[0].type==="paragraph"?(je.tokens[0].text=ot+" "+je.tokens[0].text,je.tokens[0].tokens&&je.tokens[0].tokens.length>0&&je.tokens[0].tokens[0].type==="text"&&(je.tokens[0].tokens[0].text=ot+" "+je.tokens[0].tokens[0].text)):je.tokens.unshift({type:"text",text:ot}):Ve+=ot),Ve+=this.parse(je.tokens,Ne),Q+=this.renderer.listitem(Ve,rt,tt);ve+=this.renderer.list(Q,fe,Ee);continue}case"html":{ve+=this.renderer.html(Z.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(Q=Z.tokens?this.parseInline(Z.tokens):Z.text;be+1<at&&Y[be+1].type==="text";)Z=Y[++be],Q+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);ve+=oe?this.renderer.paragraph(Q):Q;continue}default:{var mt='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return ve},ce.parseInline=function(Y,oe){oe=oe||this.renderer;var ve="",be,Fe,We,Ce=Y.length;for(be=0;be<Ce;be++){if(Fe=Y[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(We=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){ve+=We||"";continue}switch(Fe.type){case"escape":{ve+=oe.text(Fe.text);break}case"html":{ve+=oe.html(Fe.text);break}case"link":{ve+=oe.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,oe));break}case"image":{ve+=oe.image(Fe.href,Fe.title,Fe.text);break}case"strong":{ve+=oe.strong(this.parseInline(Fe.tokens,oe));break}case"em":{ve+=oe.em(this.parseInline(Fe.tokens,oe));break}case"codespan":{ve+=oe.codespan(Fe.text);break}case"br":{ve+=oe.br();break}case"del":{ve+=oe.del(this.parseInline(Fe.tokens,oe));break}case"text":{ve+=oe.text(Fe.text);break}default:{var Ie='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return ve},te}();function ee(te,ce,ue){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ce=="function"&&(ue=ce,ce=null),ce=D({},ee.defaults,ce||{}),E(ce),ue){var Y=ce.highlight,oe;try{oe=j.lex(te,ce)}catch(Ce){return ue(Ce)}var ve=function(Ie){var Re;if(!Ie)try{ce.walkTokens&&ee.walkTokens(oe,ce.walkTokens),Re=X.parse(oe,ce)}catch(z){Ie=z}return ce.highlight=Y,Ie?ue(Ie):ue(null,Re)};if(!Y||Y.length<3||(delete ce.highlight,!oe.length))return ve();var be=0;ee.walkTokens(oe,function(Ce){Ce.type==="code"&&(be++,setTimeout(function(){Y(Ce.text,Ce.lang,function(Ie,Re){if(Ie)return ve(Ie);Re!=null&&Re!==Ce.text&&(Ce.text=Re,Ce.escaped=!0),be--,be===0&&ve()})},0))}),be===0&&ve();return}function Fe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Ce.message+"",!0)+"</pre>";throw Ce}try{var We=j.lex(te,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ee.walkTokens(We,ce.walkTokens)).then(function(){return X.parse(We,ce)}).catch(Fe);ee.walkTokens(We,ce.walkTokens)}return X.parse(We,ce)}catch(Ce){Fe(Ce)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),A(ee.defaults),ee},ee.getDefaults=L,ee.defaults=le.defaults,ee.use=function(){for(var te=arguments.length,ce=new Array(te),ue=0;ue<te;ue++)ce[ue]=arguments[ue];var Y=D.apply(void 0,[{}].concat(ce)),oe=ee.defaults.extensions||{renderers:{},childTokens:{}},ve;ce.forEach(function(be){if(be.extensions&&(ve=!0,be.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Ce=oe.renderers?oe.renderers[We.name]:null;Ce?oe.renderers[We.name]=function(){for(var Ie=arguments.length,Re=new Array(Ie),z=0;z<Ie;z++)Re[z]=arguments[z];var $=We.renderer.apply(this,Re);return $===!1&&($=Ce.apply(this,Re)),$}:oe.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[We.level]?oe[We.level].unshift(We.tokenizer):oe[We.level]=[We.tokenizer],We.start&&(We.level==="block"?oe.startBlock?oe.startBlock.push(We.start):oe.startBlock=[We.start]:We.level==="inline"&&(oe.startInline?oe.startInline.push(We.start):oe.startInline=[We.start]))}We.childTokens&&(oe.childTokens[We.name]=We.childTokens)})),be.renderer&&function(){var We=ee.defaults.renderer||new re,Ce=function(z){var $=We[z];We[z]=function(){for(var Q=arguments.length,Z=new Array(Q),fe=0;fe<Q;fe++)Z[fe]=arguments[fe];var Ee=be.renderer[z].apply(We,Z);return Ee===!1&&(Ee=$.apply(We,Z)),Ee}};for(var Ie in be.renderer)Ce(Ie);Y.renderer=We}(),be.tokenizer&&function(){var We=ee.defaults.tokenizer||new O,Ce=function(z){var $=We[z];We[z]=function(){for(var Q=arguments.length,Z=new Array(Q),fe=0;fe<Q;fe++)Z[fe]=arguments[fe];var Ee=be.tokenizer[z].apply(We,Z);return Ee===!1&&(Ee=$.apply(We,Z)),Ee}};for(var Ie in be.tokenizer)Ce(Ie);Y.tokenizer=We}(),be.walkTokens){var Fe=ee.defaults.walkTokens;Y.walkTokens=function(We){var Ce=[];return Ce.push(be.walkTokens.call(this,We)),Fe&&(Ce=Ce.concat(Fe.call(this,We))),Ce}}ve&&(Y.extensions=oe),ee.setOptions(Y)})},ee.walkTokens=function(te,ce){for(var ue=[],Y=function(){var Fe=ve.value;switch(ue=ue.concat(ce.call(ee,Fe)),Fe.type){case"table":{for(var We=R(Fe.header),Ce;!(Ce=We()).done;){var Ie=Ce.value;ue=ue.concat(ee.walkTokens(Ie.tokens,ce))}for(var Re=R(Fe.rows),z;!(z=Re()).done;)for(var $=z.value,Q=R($),Z;!(Z=Q()).done;){var fe=Z.value;ue=ue.concat(ee.walkTokens(fe.tokens,ce))}break}case"list":{ue=ue.concat(ee.walkTokens(Fe.items,ce));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(Ee){ue=ue.concat(ee.walkTokens(Fe[Ee],ce))}):Fe.tokens&&(ue=ue.concat(ee.walkTokens(Fe.tokens,ce)))}},oe=R(te),ve;!(ve=oe()).done;)Y();return ue},ee.parseInline=function(te,ce){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ce=D({},ee.defaults,ce||{}),E(ce);try{var ue=j.lexInline(te,ce);return ce.walkTokens&&ee.walkTokens(ue,ce.walkTokens),X.parseInline(ue,ce)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Y.message+"",!0)+"</pre>";throw Y}},ee.Parser=X,ee.parser=X.parse,ee.Renderer=re,ee.TextRenderer=B,ee.Lexer=j,ee.lexer=j.lex,ee.Tokenizer=O,ee.Slugger=V,ee.parse=ee;var he=ee.options,ne=ee.setOptions,De=ee.use,pe=ee.walkTokens,G=ee.parseInline,W=ee,se=X.parse,ae=j.lex;le.Lexer=j,le.Parser=X,le.Renderer=re,le.Slugger=V,le.TextRenderer=B,le.Tokenizer=O,le.getDefaults=L,le.lexer=ae,le.marked=ee,le.options=he,le.parse=W,le.parseInline=G,le.parser=se,le.setOptions=ne,le.use=De,le.walkTokens=pe,Object.defineProperty(le,"__esModule",{value:!0})}),define(_e[41],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var s;(function(d){d[d.Uri=1]="Uri",d[d.Regexp=2]="Regexp",d[d.ScmResource=3]="ScmResource",d[d.ScmResourceGroup=4]="ScmResourceGroup",d[d.ScmProvider=5]="ScmProvider",d[d.CommentController=6]="CommentController",d[d.CommentThread=7]="CommentThread",d[d.CommentThreadInstance=8]="CommentThreadInstance",d[d.CommentThreadReply=9]="CommentThreadReply",d[d.CommentNode=10]="CommentNode",d[d.CommentThreadNode=11]="CommentThreadNode",d[d.TimelineActionContext=12]="TimelineActionContext",d[d.NotebookCellActionContext=13]="NotebookCellActionContext",d[d.NotebookActionContext=14]="NotebookActionContext",d[d.TerminalContext=15]="TerminalContext",d[d.TestItemContext=16]="TestItemContext",d[d.Date=17]="Date",d[d.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(s||(e.MarshalledId=s={}))}),define(_e[178],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=s;function s(l){const m=R(l);if(m&&m.length>0)return new Uint32Array(m)}let d=0;const T=new Uint32Array(10);function R(l){if(d=0,L(l,_,p.InitialConsonant),d>0||(L(l,c,p.Vowel),d>0)||(L(l,C,p.FinalConsonant),d>0)||(L(l,b,p.CompatibilityJamo),d))return T.subarray(0,d);if(l>=44032&&l<=55203){const m=l-44032,h=m%588,g=Math.floor(m/588),n=Math.floor(h/28),o=h%28-1;if(g<_.length?L(g,_,0):p.InitialConsonant+g-p.CompatibilityJamo<b.length&&L(p.InitialConsonant+g,b,p.CompatibilityJamo),n<c.length?L(n,c,0):p.Vowel+n-p.CompatibilityJamo<b.length&&L(p.Vowel+n-p.CompatibilityJamo,b,p.CompatibilityJamo),o>=0&&(o<C.length?L(o,C,0):p.FinalConsonant+o-p.CompatibilityJamo<b.length&&L(p.FinalConsonant+o-p.CompatibilityJamo,b,p.CompatibilityJamo)),d>0)return T.subarray(0,d)}}function L(l,m,h){l>=h&&l<h+m.length&&A(m[l-h])}function A(l){l!==a.NUL&&(T[d++]=l&255,l>>8&&(T[d++]=l>>8&255),l>>16&&(T[d++]=l>>16&255))}var p;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var a;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(a||(a={}));var I;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(I||(I={}));const _=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),c=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,I.hk,I.ho,I.hl,a.y,a.n,I.nj,I.np,I.nl,a.b,a.m,I.ml,a.l]),C=new Uint16Array([a.r,a.R,I.rt,a.s,I.sw,I.sg,a.e,a.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,a.a,a.q,I.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),b=new Uint16Array([a.r,a.R,I.rt,a.s,I.sw,I.sg,a.e,a.E,a.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,a.a,a.q,a.Q,I.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,I.hk,I.ho,I.hl,a.y,a.n,I.nj,I.np,I.nl,a.b,a.m,I.ml,a.l])}),define(_e[82],ye([1,0,29]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=T,e.normalizeNFD=L;const d=new s.LRUCache(1e4);function T(a){return p(a,"NFC",d)}const R=new s.LRUCache(1e4);function L(a){return p(a,"NFD",R)}const A=/[^\u0000-\u0080]/;function p(a,I,_){if(!a)return a;const c=_.get(a);if(c)return c;let C;return A.test(a)?C=a.normalize(I):C=a,_.set(a,C),C}e.removeAccents=function(){const a=/[\u0300-\u036f]/g;return function(I){return L(I).replace(a,"")}}()}),define(_e[134],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=s,e.rot=d,e.isPointWithinTriangle=A;function s(p,a,I){return Math.min(Math.max(p,a),I)}function d(p,a){return(a+p%a)%a}class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class R{constructor(){this._n=1,this._val=0}update(a){return this._val=this._val+(a-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class L{constructor(a){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(a),this._values.fill(0,0,a)}update(a){const I=this._values[this._index];return this._values[this._index]=a,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=a,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L;function A(p,a,I,_,c,C,b,l){const m=b-I,h=l-_,g=c-I,n=C-_,o=p-I,t=a-_,i=m*m+h*h,r=m*g+h*n,f=m*o+h*t,u=g*g+n*n,v=g*o+n*t,y=1/(i*u-r*r),D=(u*f-r*v)*y,w=(i*v-r*f)*y;return D>=0&&w>=0&&D+w<1}}),define(_e[179],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=R,e.getFunctionName=c;class s{constructor(b,l,m){this.owner=b,this.debugNameSource=l,this.referenceFn=m}getDebugName(b){return R(b,this)}}e.DebugNameData=s;const d=new Map,T=new WeakMap;function R(C,b){const l=T.get(C);if(l)return l;const m=L(C,b);if(m){let h=d.get(m)??0;h++,d.set(m,h);const g=h===1?m:`${m}#${h}`;return T.set(C,g),g}}function L(C,b){const l=T.get(C);if(l)return l;const m=b.owner?I(b.owner)+".":"";let h;const g=b.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(h=g(),h!==void 0)return m+h}else return m+g;const n=b.referenceFn;if(n!==void 0&&(h=c(n),h!==void 0))return m+h;if(b.owner!==void 0){const o=A(b.owner,C);if(o!==void 0)return m+o}}function A(C,b){for(const l in C)if(C[l]===b)return l}const p=new Map,a=new WeakMap;function I(C){const b=a.get(C);if(b)return b;const l=_(C);let m=p.get(l)??0;m++,p.set(l,m);const h=m===1?l:`${l}#${m}`;return a.set(C,h),h}function _(C){const b=C.constructor;return b?b.name:"Object"}function c(C){const b=C.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(m?m[1]:void 0)?.trim()}}),define(_e[180],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=d,e.getLogger=T;let s;function d(l){s=l}function T(){return s}class R{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(m){return L([A(C("|  ",this.indentation)),m])}formatInfo(m){return m.hadValue?m.didChange?[A(" "),a(I(m.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),a(I(m.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),a(I(m.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(m,h){console.log(...this.textToConsoleArgs([p("observable value changed"),a(m.debugName,{color:"BlueViolet"}),...this.formatInfo(h)]))}formatChanges(m){if(m.size!==0)return a(" (changed deps: "+[...m].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const h=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(g,n)=>(this.changedObservablesSets.get(m).add(g),h.apply(m,[g,n]))}handleDerivedRecomputed(m,h){const g=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([p("derived recomputed"),a(m.debugName,{color:"BlueViolet"}),...this.formatInfo(h),this.formatChanges(g),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(m,h){console.log(...this.textToConsoleArgs([p("observable from event triggered"),a(m.debugName,{color:"BlueViolet"}),...this.formatInfo(h),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const h=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(g,n)=>(this.changedObservablesSets.get(m).add(g),h.apply(m,[g,n]))}handleAutorunTriggered(m){const h=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([p("autorun"),a(m.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),h.clear(),this.indentation++}handleAutorunFinished(m){this.indentation--}handleBeginTransaction(m){let h=m.getDebugName();h===void 0&&(h=""),console.log(...this.textToConsoleArgs([p("transaction"),a(h,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=R;function L(l){const m=new Array,h=[];let g="";function n(t){if("length"in t)for(const i of t)i&&n(i);else"text"in t?(g+=`%c${t.text}`,m.push(t.style),t.data&&h.push(...t.data)):"data"in t&&h.push(...t.data)}n(l);const o=[g,...m];return o.push(...h),o}function A(l){return a(l,{color:"black"})}function p(l){return a(b(`${l}: `,10),{color:"black",bold:!0})}function a(l,m={color:"black"}){function h(n){return Object.entries(n).reduce((o,[t,i])=>`${o}${t}:${i};`,"")}const g={color:m.color};return m.strikeThrough&&(g["text-decoration"]="line-through"),m.bold&&(g["font-weight"]="bold"),{text:l,style:h(g)}}function I(l,m){switch(typeof l){case"number":return""+l;case"string":return l.length+2<=m?`"${l}"`:`"${l.substr(0,m-7)}"+...`;case"boolean":return l?"true":"false";case"undefined":return"undefined";case"object":return l===null?"null":Array.isArray(l)?_(l,m):c(l,m);case"symbol":return l.toString();case"function":return`[[Function${l.name?" "+l.name:""}]]`;default:return""+l}}function _(l,m){let h="[ ",g=!0;for(const n of l){if(g||(h+=", "),h.length-5>m){h+="...";break}g=!1,h+=`${I(n,m-h.length)}`}return h+=" ]",h}function c(l,m){let h="{ ",g=!0;for(const[n,o]of Object.entries(l)){if(g||(h+=", "),h.length-5>m){h+="...";break}g=!1,h+=`${n}: ${I(o,m-h.length)}`}return h+=" }",h}function C(l,m){let h="";for(let g=1;g<=m;g++)h+=l;return h}function b(l,m){for(;l.length<m;)l+=" ";return l}}),define(_e[181],ye([1,0,175,179,180]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=L,e._setKeepObserved=p,e._setDerivedOpts=I,e.transaction=C,e.globalTransaction=l,e.asyncTransaction=m,e.subtransaction=h,e.observableValue=n,e.disposableObservableValue=t;let R;function L(r){R=r}let A;function p(r){A=r}let a;function I(r){a=r}class _{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,u){const v=u===void 0?void 0:f,y=u===void 0?f:u;return a({owner:v,debugName:()=>{const D=(0,d.getFunctionName)(y);if(D!==void 0)return D;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(P)return`${this.debugName}.${P[2]}`;if(!v)return`${this.debugName} (mapped)`},debugReferenceFn:y},D=>y(this.read(D),D))}recomputeInitiallyAndOnChange(f,u){return f.add(R(this,u)),this}keepObserved(f){return f.add(A(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=_;class c extends _{constructor(){super(...arguments),this.observers=new Set}addObserver(f){const u=this.observers.size;this.observers.add(f),u===0&&this.onFirstObserverAdded()}removeObserver(f){this.observers.delete(f)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=c;function C(r,f){const u=new g(r,f);try{r(u)}finally{u.finish()}}let b;function l(r){if(b)r(b);else{const f=new g(r,void 0);b=f;try{r(f)}finally{f.finish(),b=void 0}}}async function m(r,f){const u=new g(r,f);try{await r(u)}finally{u.finish()}}function h(r,f,u){r?f(r):C(f,u)}class g{constructor(f,u){this._fn=f,this._getDebugName=u,this.updatingObservers=[],(0,T.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,d.getFunctionName)(this._fn)}updateObserver(f,u){this.updatingObservers.push({observer:f,observable:u}),f.beginUpdate(u)}finish(){const f=this.updatingObservers;for(let u=0;u<f.length;u++){const{observer:v,observable:y}=f[u];v.endUpdate(y)}this.updatingObservers=null,(0,T.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=g;function n(r,f){let u;return typeof r=="string"?u=new d.DebugNameData(void 0,r,void 0):u=new d.DebugNameData(r,void 0,void 0),new o(u,f,s.strictEquals)}class o extends c{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(f,u,v){super(),this._debugNameData=f,this._equalityComparator=v,this._value=u}get(){return this._value}set(f,u,v){if(v===void 0&&this._equalityComparator(this._value,f))return;let y;u||(u=y=new g(()=>{},()=>`Setting ${this.debugName}`));try{const D=this._value;this._setValue(f),(0,T.getLogger)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:v,didChange:!0,hadValue:!0});for(const w of this.observers)u.updateObserver(w,this),w.handleChange(this,v)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(f){this._value=f}}e.ObservableValue=o;function t(r,f){let u;return typeof r=="string"?u=new d.DebugNameData(void 0,r,void 0):u=new d.DebugNameData(r,void 0,void 0),new i(u,f,s.strictEquals)}class i extends o{_setValue(f){this._value!==f&&(this._value&&this._value.dispose(),this._value=f)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=i}),function(){function le(T){const R=[];typeof T=="number"&&R.push("code/timeOrigin",T);function L(p){R.push(p,Date.now())}function A(){const p=[];for(let a=0;a<R.length;a+=2)p.push({name:R[a],startTime:R[a+1]});return p}return{mark:L,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(T+L.startTime)});return R}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function s(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var d;typeof global=="object"?d=global:typeof self=="object"?d=self:d={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(d)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(d):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),d.perf=s(d))}(),define(_e[182],ye([1,0,40]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const d=Symbol("unset");class T{constructor(){this.root=new L,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||s.Iterable.empty()}insert(p,a,I){this.opNode(p,_=>_._value=a,I)}mutate(p,a){this.opNode(p,I=>I._value=a(I._value===d?void 0:I._value))}mutatePath(p,a){this.opNode(p,()=>{},I=>a(I))}delete(p){const a=this.getPathToKey(p);if(!a)return;let I=a.length-1;const _=a[I].node._value;if(_!==d){for(this._size--,a[I].node._value=d;I>0;I--){const{node:c,part:C}=a[I];if(c.children?.size||c._value!==d)break;a[I-1].node.children.delete(C)}return _}}*deleteRecursive(p){const a=this.getPathToKey(p);if(!a)return;const I=a[a.length-1].node;for(let _=a.length-1;_>0;_--){const c=a[_-1];if(c.node.children.delete(a[_].part),c.node.children.size>0||c.node._value!==d)break}for(const _ of R(I))_._value!==d&&(this._size--,yield _._value)}find(p){let a=this.root;for(const I of p){const _=a.children?.get(I);if(!_)return;a=_}return a._value===d?void 0:a._value}hasKeyOrParent(p){let a=this.root;for(const I of p){const _=a.children?.get(I);if(!_)return!1;if(_._value!==d)return!0;a=_}return!1}hasKeyOrChildren(p){let a=this.root;for(const I of p){const _=a.children?.get(I);if(!_)return!1;a=_}return!0}hasKey(p){let a=this.root;for(const I of p){const _=a.children?.get(I);if(!_)return!1;a=_}return a._value!==d}getPathToKey(p){const a=[{part:"",node:this.root}];let I=0;for(const _ of p){const c=a[I].node.children?.get(_);if(!c)return;a.push({part:_,node:c}),I++}return a}opNode(p,a,I){let _=this.root;for(const b of p){if(_.children)if(_.children.has(b))_=_.children.get(b);else{const l=new L;_.children.set(b,l),_=l}else{const l=new L;_.children=new Map([[b,l]]),_=l}I?.(_)}const c=_._value===d?0:1;a(_);const C=_._value===d?0:1;this._size+=C-c}*values(){for(const{_value:p}of R(this.root))p!==d&&(yield p)}}e.WellDefinedPrefixTree=T;function*R(A){const p=[A];for(;p.length>0;){const a=p.pop();if(yield a,a.children)for(const I of a.children.values())p.push(I)}}class L{constructor(){this._value=d}get value(){return this._value===d?void 0:this._value}set value(p){this._value=p===void 0?d:p}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var d in s)(typeof exports=="object"?exports:le)[d]=s[d]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function s(d){if(e[d])return e[d].exports;var T=e[d]={i:d,l:!1,exports:{}};return le[d].call(T.exports,T,T.exports,s),T.l=!0,T.exports}return s.m=le,s.c=e,s.d=function(d,T,R){s.o(d,T)||Object.defineProperty(d,T,{enumerable:!0,get:R})},s.r=function(d){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(d,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(d,"__esModule",{value:!0})},s.t=function(d,T){if(1&T&&(d=s(d)),8&T||4&T&&typeof d=="object"&&d&&d.__esModule)return d;var R=Object.create(null);if(s.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:d}),2&T&&typeof d!="string")for(var L in d)s.d(R,L,function(A){return d[A]}.bind(null,L));return R},s.n=function(d){var T=d&&d.__esModule?function(){return d.default}:function(){return d};return s.d(T,"a",T),T},s.o=function(d,T){return Object.prototype.hasOwnProperty.call(d,T)},s.p="",s(s.s=0)}([function(le,e,s){(function(d){var T;e=le.exports=De,T=typeof d=="object"&&d.env&&d.env.NODE_DEBUG&&/\bsemver\b/i.test(d.env.NODE_DEBUG)?function(){var $=Array.prototype.slice.call(arguments,0);$.unshift("SEMVER"),console.log.apply(console,$)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],p=e.src=[],a=0,I=a++;p[I]="0|[1-9]\\d*";var _=a++;p[_]="[0-9]+";var c=a++;p[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=a++;p[C]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var b=a++;p[b]="("+p[_]+")\\.("+p[_]+")\\.("+p[_]+")";var l=a++;p[l]="(?:"+p[I]+"|"+p[c]+")";var m=a++;p[m]="(?:"+p[_]+"|"+p[c]+")";var h=a++;p[h]="(?:-("+p[l]+"(?:\\."+p[l]+")*))";var g=a++;p[g]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var n=a++;p[n]="[0-9A-Za-z-]+";var o=a++;p[o]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var t=a++,i="v?"+p[C]+p[h]+"?"+p[o]+"?";p[t]="^"+i+"$";var r="[v=\\s]*"+p[b]+p[g]+"?"+p[o]+"?",f=a++;p[f]="^"+r+"$";var u=a++;p[u]="((?:<|>)?=?)";var v=a++;p[v]=p[_]+"|x|X|\\*";var y=a++;p[y]=p[I]+"|x|X|\\*";var D=a++;p[D]="[v=\\s]*("+p[y]+")(?:\\.("+p[y]+")(?:\\.("+p[y]+")(?:"+p[h]+")?"+p[o]+"?)?)?";var w=a++;p[w]="[v=\\s]*("+p[v]+")(?:\\.("+p[v]+")(?:\\.("+p[v]+")(?:"+p[g]+")?"+p[o]+"?)?)?";var P=a++;p[P]="^"+p[u]+"\\s*"+p[D]+"$";var k=a++;p[k]="^"+p[u]+"\\s*"+p[w]+"$";var E=a++;p[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=a++;p[S]="(?:~>?)";var M=a++;p[M]="(\\s*)"+p[S]+"\\s+",A[M]=new RegExp(p[M],"g");var N=a++;p[N]="^"+p[S]+p[D]+"$";var O=a++;p[O]="^"+p[S]+p[w]+"$";var x=a++;p[x]="(?:\\^)";var U=a++;p[U]="(\\s*)"+p[x]+"\\s+",A[U]=new RegExp(p[U],"g");var F=a++;p[F]="^"+p[x]+p[D]+"$";var H=a++;p[H]="^"+p[x]+p[w]+"$";var j=a++;p[j]="^"+p[u]+"\\s*("+r+")$|^$";var re=a++;p[re]="^"+p[u]+"\\s*("+i+")$|^$";var B=a++;p[B]="(\\s*)"+p[u]+"\\s*("+r+"|"+p[D]+")",A[B]=new RegExp(p[B],"g");var V=a++;p[V]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var X=a++;p[X]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var ee=a++;p[ee]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)T(he,p[he]),A[he]||(A[he]=new RegExp(p[he]));function ne($,Q){if($ instanceof De)return $;if(typeof $!="string"||$.length>R||!(Q?A[f]:A[t]).test($))return null;try{return new De($,Q)}catch{return null}}function De($,Q){if($ instanceof De){if($.loose===Q)return $;$=$.version}else if(typeof $!="string")throw new TypeError("Invalid Version: "+$);if($.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof De))return new De($,Q);T("SemVer",$,Q),this.loose=Q;var Z=$.trim().match(Q?A[f]:A[t]);if(!Z)throw new TypeError("Invalid Version: "+$);if(this.raw=$,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var Ee=+fe;if(Ee>=0&&Ee<L)return Ee}return fe}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=ne,e.valid=function($,Q){var Z=ne($,Q);return Z?Z.version:null},e.clean=function($,Q){var Z=ne($.trim().replace(/^[=v]+/,""),Q);return Z?Z.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function($){return T("SemVer.compare",this.version,this.loose,$),$ instanceof De||($=new De($,this.loose)),this.compareMain($)||this.comparePre($)},De.prototype.compareMain=function($){return $ instanceof De||($=new De($,this.loose)),G(this.major,$.major)||G(this.minor,$.minor)||G(this.patch,$.patch)},De.prototype.comparePre=function($){if($ instanceof De||($=new De($,this.loose)),this.prerelease.length&&!$.prerelease.length)return-1;if(!this.prerelease.length&&$.prerelease.length)return 1;if(!this.prerelease.length&&!$.prerelease.length)return 0;var Q=0;do{var Z=this.prerelease[Q],fe=$.prerelease[Q];if(T("prerelease compare",Q,Z,fe),Z===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(Z===void 0)return-1;if(Z!==fe)return G(Z,fe)}while(++Q)},De.prototype.inc=function($,Q){switch($){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+$)}return this.format(),this.raw=this.version,this},e.inc=function($,Q,Z,fe){typeof Z=="string"&&(fe=Z,Z=void 0);try{return new De($,Z).inc(Q,fe).version}catch{return null}},e.diff=function($,Q){if(te($,Q))return null;var Z=ne($),fe=ne(Q);if(Z.prerelease.length||fe.prerelease.length){for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==fe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==fe[Ee])return Ee},e.compareIdentifiers=G;var pe=/^[0-9]+$/;function G($,Q){var Z=pe.test($),fe=pe.test(Q);return Z&&fe&&($=+$,Q=+Q),Z&&!fe?-1:fe&&!Z?1:$<Q?-1:$>Q?1:0}function W($,Q,Z){return new De($,Z).compare(new De(Q,Z))}function se($,Q,Z){return W($,Q,Z)>0}function ae($,Q,Z){return W($,Q,Z)<0}function te($,Q,Z){return W($,Q,Z)===0}function ce($,Q,Z){return W($,Q,Z)!==0}function ue($,Q,Z){return W($,Q,Z)>=0}function Y($,Q,Z){return W($,Q,Z)<=0}function oe($,Q,Z,fe){var Ee;switch(Q){case"===":typeof $=="object"&&($=$.version),typeof Z=="object"&&(Z=Z.version),Ee=$===Z;break;case"!==":typeof $=="object"&&($=$.version),typeof Z=="object"&&(Z=Z.version),Ee=$!==Z;break;case"":case"=":case"==":Ee=te($,Z,fe);break;case"!=":Ee=ce($,Z,fe);break;case">":Ee=se($,Z,fe);break;case">=":Ee=ue($,Z,fe);break;case"<":Ee=ae($,Z,fe);break;case"<=":Ee=Y($,Z,fe);break;default:throw new TypeError("Invalid operator: "+Q)}return Ee}function ve($,Q){if($ instanceof ve){if($.loose===Q)return $;$=$.value}if(!(this instanceof ve))return new ve($,Q);T("comparator",$,Q),this.loose=Q,this.parse($),this.semver===be?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function($,Q){return G(Q,$)},e.major=function($,Q){return new De($,Q).major},e.minor=function($,Q){return new De($,Q).minor},e.patch=function($,Q){return new De($,Q).patch},e.compare=W,e.compareLoose=function($,Q){return W($,Q,!0)},e.rcompare=function($,Q,Z){return W(Q,$,Z)},e.sort=function($,Q){return $.sort(function(Z,fe){return e.compare(Z,fe,Q)})},e.rsort=function($,Q){return $.sort(function(Z,fe){return e.rcompare(Z,fe,Q)})},e.gt=se,e.lt=ae,e.eq=te,e.neq=ce,e.gte=ue,e.lte=Y,e.cmp=oe,e.Comparator=ve;var be={};function Fe($,Q){if($ instanceof Fe)return $.loose===Q?$:new Fe($.raw,Q);if($ instanceof ve)return new Fe($.value,Q);if(!(this instanceof Fe))return new Fe($,Q);if(this.loose=Q,this.raw=$,this.set=$.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$);this.format()}function We($){return!$||$.toLowerCase()==="x"||$==="*"}function Ce($,Q,Z,fe,Ee,Ne,Ve,je,tt,rt,ot,nt,at){return((Q=We(Z)?"":We(fe)?">="+Z+".0.0":We(Ee)?">="+Z+"."+fe+".0":">="+Q)+" "+(je=We(tt)?"":We(rt)?"<"+(+tt+1)+".0.0":We(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+je)).trim()}function Ie($,Q){for(var Z=0;Z<$.length;Z++)if(!$[Z].test(Q))return!1;if(Q.prerelease.length){for(Z=0;Z<$.length;Z++)if(T($[Z].semver),$[Z].semver!==be&&$[Z].semver.prerelease.length>0){var fe=$[Z].semver;if(fe.major===Q.major&&fe.minor===Q.minor&&fe.patch===Q.patch)return!0}return!1}return!0}function Re($,Q,Z){try{Q=new Fe(Q,Z)}catch{return!1}return Q.test($)}function z($,Q,Z,fe){var Ee,Ne,Ve,je,tt;switch($=new De($,fe),Q=new Fe(Q,fe),Z){case">":Ee=se,Ne=Y,Ve=ae,je=">",tt=">=";break;case"<":Ee=ae,Ne=ue,Ve=se,je="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re($,Q,fe))return!1;for(var rt=0;rt<Q.set.length;++rt){var ot=Q.set[rt],nt=null,at=null;if(ot.forEach(function(mt){mt.semver===be&&(mt=new ve(">=0.0.0")),nt=nt||mt,at=at||mt,Ee(mt.semver,nt.semver,fe)?nt=mt:Ve(mt.semver,at.semver,fe)&&(at=mt)}),nt.operator===je||nt.operator===tt||(!at.operator||at.operator===je)&&Ne($,at.semver)||at.operator===tt&&Ve($,at.semver))return!1}return!0}ve.prototype.parse=function($){var Q=this.loose?A[j]:A[re],Z=$.match(Q);if(!Z)throw new TypeError("Invalid comparator: "+$);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new De(Z[2],this.loose):this.semver=be},ve.prototype.toString=function(){return this.value},ve.prototype.test=function($){return T("Comparator.test",$,this.loose),this.semver===be||(typeof $=="string"&&($=new De($,this.loose)),oe($,this.operator,this.semver,this.loose))},ve.prototype.intersects=function($,Q){if(!($ instanceof ve))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Fe($.value,Q),Re(this.value,Z,Q);if($.operator==="")return Z=new Fe(this.value,Q),Re($.semver,Z,Q);var fe=!(this.operator!==">="&&this.operator!==">"||$.operator!==">="&&$.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||$.operator!=="<="&&$.operator!=="<"),Ne=this.semver.version===$.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||$.operator!==">="&&$.operator!=="<="),je=oe(this.semver,"<",$.semver,Q)&&(this.operator===">="||this.operator===">")&&($.operator==="<="||$.operator==="<"),tt=oe(this.semver,">",$.semver,Q)&&(this.operator==="<="||this.operator==="<")&&($.operator===">="||$.operator===">");return fe||Ee||Ne&&Ve||je||tt},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function($){return $.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function($){var Q=this.loose;$=$.trim(),T("range",$,Q);var Z=Q?A[X]:A[V];$=$.replace(Z,Ce),T("hyphen replace",$),$=$.replace(A[B],"$1$2$3"),T("comparator trim",$,A[B]),$=($=($=$.replace(A[M],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var fe=Q?A[j]:A[re],Ee=$.split(" ").map(function(Ne){return function(Ve,je){return T("comp",Ve),Ve=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){T("caret",nt,at);var mt=at?A[H]:A[F];return nt.replace(mt,function(dt,lt,Te,Ue,qe){var Oe;return T("caret",nt,dt,lt,Te,Ue,qe),We(lt)?Oe="":We(Te)?Oe=">="+lt+".0.0 <"+(+lt+1)+".0.0":We(Ue)?Oe=lt==="0"?">="+lt+"."+Te+".0 <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+".0 <"+(+lt+1)+".0.0":qe?(T("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Oe=lt==="0"?Te==="0"?">="+lt+"."+Te+"."+Ue+qe+" <"+lt+"."+Te+"."+(+Ue+1):">="+lt+"."+Te+"."+Ue+qe+" <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+"."+Ue+qe+" <"+(+lt+1)+".0.0"):(T("no pr"),Oe=lt==="0"?Te==="0"?">="+lt+"."+Te+"."+Ue+" <"+lt+"."+Te+"."+(+Ue+1):">="+lt+"."+Te+"."+Ue+" <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+"."+Ue+" <"+(+lt+1)+".0.0"),T("caret return",Oe),Oe})}(ot,rt)}).join(" ")}(Ve,je),T("caret",Ve),Ve=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){var mt=at?A[O]:A[N];return nt.replace(mt,function(dt,lt,Te,Ue,qe){var Oe;return T("tilde",nt,dt,lt,Te,Ue,qe),We(lt)?Oe="":We(Te)?Oe=">="+lt+".0.0 <"+(+lt+1)+".0.0":We(Ue)?Oe=">="+lt+"."+Te+".0 <"+lt+"."+(+Te+1)+".0":qe?(T("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Oe=">="+lt+"."+Te+"."+Ue+qe+" <"+lt+"."+(+Te+1)+".0"):Oe=">="+lt+"."+Te+"."+Ue+" <"+lt+"."+(+Te+1)+".0",T("tilde return",Oe),Oe})}(ot,rt)}).join(" ")}(Ve,je),T("tildes",Ve),Ve=function(tt,rt){return T("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,at){nt=nt.trim();var mt=at?A[k]:A[P];return nt.replace(mt,function(dt,lt,Te,Ue,qe,Oe){T("xRange",nt,dt,lt,Te,Ue,qe,Oe);var xe=We(Te),de=xe||We(Ue),J=de||We(qe);return lt==="="&&J&&(lt=""),xe?dt=lt===">"||lt==="<"?"<0.0.0":"*":lt&&J?(de&&(Ue=0),J&&(qe=0),lt===">"?(lt=">=",de?(Te=+Te+1,Ue=0,qe=0):J&&(Ue=+Ue+1,qe=0)):lt==="<="&&(lt="<",de?Te=+Te+1:Ue=+Ue+1),dt=lt+Te+"."+Ue+"."+qe):de?dt=">="+Te+".0.0 <"+(+Te+1)+".0.0":J&&(dt=">="+Te+"."+Ue+".0 <"+Te+"."+(+Ue+1)+".0"),T("xRange return",dt),dt})}(ot,rt)}).join(" ")}(Ve,je),T("xrange",Ve),Ve=function(tt,rt){return T("replaceStars",tt,rt),tt.trim().replace(A[ee],"")}(Ve,je),T("stars",Ve),Ve}(Ne,Q)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ne){return!!Ne.match(fe)})),Ee=Ee.map(function(Ne){return new ve(Ne,Q)})},Fe.prototype.intersects=function($,Q){if(!($ instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(fe){return $.set.some(function(Ee){return Ee.every(function(Ne){return fe.intersects(Ne,Q)})})})})},e.toComparators=function($,Q){return new Fe($,Q).set.map(function(Z){return Z.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function($){if(!$)return!1;typeof $=="string"&&($=new De($,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ie(this.set[Q],$))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function($,Q,Z){var fe=null,Ee=null;try{var Ne=new Fe(Q,Z)}catch{return null}return $.forEach(function(Ve){Ne.test(Ve)&&(fe&&Ee.compare(Ve)!==-1||(Ee=new De(fe=Ve,Z)))}),fe},e.minSatisfying=function($,Q,Z){var fe=null,Ee=null;try{var Ne=new Fe(Q,Z)}catch{return null}return $.forEach(function(Ve){Ne.test(Ve)&&(fe&&Ee.compare(Ve)!==1||(Ee=new De(fe=Ve,Z)))}),fe},e.validRange=function($,Q){try{return new Fe($,Q).range||"*"}catch{return null}},e.ltr=function($,Q,Z){return z($,Q,"<",Z)},e.gtr=function($,Q,Z){return z($,Q,">",Z)},e.outside=z,e.prerelease=function($,Q){var Z=ne($,Q);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function($,Q,Z){return $=new Fe($,Z),Q=new Fe(Q,Z),$.intersects(Q)},e.coerce=function($){if($ instanceof De)return $;if(typeof $!="string")return null;var Q=$.match(A[E]);return Q==null?null:ne((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,s(1))},function(le,e){var s,d,T=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function A(m){if(s===setTimeout)return setTimeout(m,0);if((s===R||!s)&&setTimeout)return s=setTimeout,setTimeout(m,0);try{return s(m,0)}catch{try{return s.call(null,m,0)}catch{return s.call(this,m,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:R}catch{s=R}try{d=typeof clearTimeout=="function"?clearTimeout:L}catch{d=L}})();var p,a=[],I=!1,_=-1;function c(){I&&p&&(I=!1,p.length?a=p.concat(a):_=-1,a.length&&C())}function C(){if(!I){var m=A(c);I=!0;for(var h=a.length;h;){for(p=a,a=[];++_<h;)p&&p[_].run();_=-1,h=a.length}p=null,I=!1,function(g){if(d===clearTimeout)return clearTimeout(g);if((d===L||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(g);try{d(g)}catch{try{return d.call(null,g)}catch{return d.call(this,g)}}}(m)}}function b(m,h){this.fun=m,this.array=h}function l(){}T.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];a.push(new b(m,h)),a.length!==1||I||A(C)},b.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=l,T.addListener=l,T.once=l,T.off=l,T.removeListener=l,T.removeAllListeners=l,T.emit=l,T.prependListener=l,T.prependOnceListener=l,T.listeners=function(m){return[]},T.binding=function(m){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(m){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(_e[43],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class d{static create(R){return new d(R)}constructor(R){this._now=s&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=d}),define(_e[4],ye([1,0,14,80,3,81,43]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=C;const A=!1,p=!1,a=!1;var I;(function(O){O.None=()=>T.Disposable.None;function x(Ce){if(a){const{onDidAddListener:Ie}=Ce,Re=l.create();let z=0;Ce.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Ie?.()}}}function U(Ce,Ie){return ne(Ce,()=>{},0,void 0,!0,void 0,Ie)}O.defer=U;function F(Ce){return(Ie,Re=null,z)=>{let $=!1,Q;return Q=Ce(Z=>{if(!$)return Q?Q.dispose():$=!0,Ie.call(Re,Z)},null,z),$&&Q.dispose(),Q}}O.once=F;function H(Ce,Ie,Re){return ee((z,$=null,Q)=>Ce(Z=>z.call($,Ie(Z)),null,Q),Re)}O.map=H;function j(Ce,Ie,Re){return ee((z,$=null,Q)=>Ce(Z=>{Ie(Z),z.call($,Z)},null,Q),Re)}O.forEach=j;function re(Ce,Ie,Re){return ee((z,$=null,Q)=>Ce(Z=>Ie(Z)&&z.call($,Z),null,Q),Re)}O.filter=re;function B(Ce){return Ce}O.signal=B;function V(...Ce){return(Ie,Re=null,z)=>{const $=(0,T.combinedDisposable)(...Ce.map(Q=>Q(Z=>Ie.call(Re,Z))));return he($,z)}}O.any=V;function X(Ce,Ie,Re,z){let $=Re;return H(Ce,Q=>($=Ie($,Q),$),z)}O.reduce=X;function ee(Ce,Ie){let Re;const z={onWillAddFirstListener(){Re=Ce($.fire,$)},onDidRemoveLastListener(){Re?.dispose()}};Ie||x(z);const $=new r(z);return Ie?.add($),$.event}function he(Ce,Ie){return Ie instanceof Array?Ie.push(Ce):Ie&&Ie.add(Ce),Ce}function ne(Ce,Ie,Re=100,z=!1,$=!1,Q,Z){let fe,Ee,Ne,Ve=0,je;const tt={leakWarningThreshold:Q,onWillAddFirstListener(){fe=Ce(ot=>{Ve++,Ee=Ie(Ee,ot),z&&!Ne&&(rt.fire(Ee),Ee=void 0),je=()=>{const nt=Ee;Ee=void 0,Ne=void 0,(!z||Ve>1)&&rt.fire(nt),Ve=0},typeof Re=="number"?(clearTimeout(Ne),Ne=setTimeout(je,Re)):Ne===void 0&&(Ne=0,queueMicrotask(je))})},onWillRemoveListener(){$&&Ve>0&&je?.()},onDidRemoveLastListener(){je=void 0,fe.dispose()}};Z||x(tt);const rt=new r(tt);return Z?.add(rt),rt.event}O.debounce=ne;function De(Ce,Ie=0,Re){return O.debounce(Ce,(z,$)=>z?(z.push($),z):[$],Ie,void 0,!0,void 0,Re)}O.accumulate=De;function pe(Ce,Ie=(z,$)=>z===$,Re){let z=!0,$;return re(Ce,Q=>{const Z=z||!Ie(Q,$);return z=!1,$=Q,Z},Re)}O.latch=pe;function G(Ce,Ie,Re){return[O.filter(Ce,Ie,Re),O.filter(Ce,z=>!Ie(z),Re)]}O.split=G;function W(Ce,Ie=!1,Re=[],z){let $=Re.slice(),Q=Ce(Ee=>{$?$.push(Ee):fe.fire(Ee)});z&&z.add(Q);const Z=()=>{$?.forEach(Ee=>fe.fire(Ee)),$=null},fe=new r({onWillAddFirstListener(){Q||(Q=Ce(Ee=>fe.fire(Ee)),z&&z.add(Q))},onDidAddFirstListener(){$&&(Ie?setTimeout(Z):Z())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return z&&z.add(fe),fe.event}O.buffer=W;function se(Ce,Ie){return(z,$,Q)=>{const Z=Ie(new te);return Ce(function(fe){const Ee=Z.evaluate(fe);Ee!==ae&&z.call($,Ee)},void 0,Q)}}O.chain=se;const ae=Symbol("HaltChainable");class te{constructor(){this.steps=[]}map(Ie){return this.steps.push(Ie),this}forEach(Ie){return this.steps.push(Re=>(Ie(Re),Re)),this}filter(Ie){return this.steps.push(Re=>Ie(Re)?Re:ae),this}reduce(Ie,Re){let z=Re;return this.steps.push($=>(z=Ie(z,$),z)),this}latch(Ie=(Re,z)=>Re===z){let Re=!0,z;return this.steps.push($=>{const Q=Re||!Ie($,z);return Re=!1,z=$,Q?$:ae}),this}evaluate(Ie){for(const Re of this.steps)if(Ie=Re(Ie),Ie===ae)break;return Ie}}function ce(Ce,Ie,Re=z=>z){const z=(...fe)=>Z.fire(Re(...fe)),$=()=>Ce.on(Ie,z),Q=()=>Ce.removeListener(Ie,z),Z=new r({onWillAddFirstListener:$,onDidRemoveLastListener:Q});return Z.event}O.fromNodeEventEmitter=ce;function ue(Ce,Ie,Re=z=>z){const z=(...fe)=>Z.fire(Re(...fe)),$=()=>Ce.addEventListener(Ie,z),Q=()=>Ce.removeEventListener(Ie,z),Z=new r({onWillAddFirstListener:$,onDidRemoveLastListener:Q});return Z.event}O.fromDOMEventEmitter=ue;function Y(Ce){return new Promise(Ie=>F(Ce)(Ie))}O.toPromise=Y;function oe(Ce){const Ie=new r;return Ce.then(Re=>{Ie.fire(Re)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}O.fromPromise=oe;function ve(Ce,Ie,Re){return Ie(Re),Ce(z=>Ie(z))}O.runAndSubscribe=ve;class be{constructor(Ie,Re){this._observable=Ie,this._counter=0,this._hasChanged=!1;const z={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Re||x(z),this.emitter=new r(z),Re&&Re.add(this.emitter)}beginUpdate(Ie){this._counter++}handlePossibleChange(Ie){}handleChange(Ie,Re){this._hasChanged=!0}endUpdate(Ie){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Fe(Ce,Ie){return new be(Ce,Ie).emitter.event}O.fromObservable=Fe;function We(Ce){return(Ie,Re,z)=>{let $=0,Q=!1;const Z={beginUpdate(){$++},endUpdate(){$--,$===0&&(Ce.reportChanges(),Q&&(Q=!1,Ie.call(Re)))},handlePossibleChange(){},handleChange(){Q=!0}};Ce.addObserver(Z),Ce.reportChanges();const fe={dispose(){Ce.removeObserver(Z)}};return z instanceof T.DisposableStore?z.add(fe):Array.isArray(z)&&z.push(fe),fe}}O.fromObservableLight=We})(I||(e.Event=I={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${_._idPool++}`,_.all.add(this)}start(x){this._stopWatch=new L.StopWatch,this.listenerCount=x}stop(){if(this._stopWatch){const x=this._stopWatch.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=_;let c=-1;function C(O){const x=c;return c=O,{dispose(){c=x}}}class b{static{this._idPool=1}constructor(x,U,F=(b._idPool++).toString(16).padStart(3,"0")){this._errorHandler=x,this.threshold=U,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(x,U){const F=this.threshold;if(F<=0||U<F)return;this._stacks||(this._stacks=new Map);const H=this._stacks.get(x.value)||0;if(this._stacks.set(x.value,H+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=F*.5;const[j,re]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${U} listeners already. MOST frequent listener (${re}):`;console.warn(B),console.warn(j);const V=new m(B,j);this._errorHandler(V)}return()=>{const j=this._stacks.get(x.value)||0;this._stacks.set(x.value,j-1)}}getMostFrequentStack(){if(!this._stacks)return;let x,U=0;for(const[F,H]of this._stacks)(!x||U<H)&&(x=[F,H],U=H);return x}}class l{static create(){const x=new Error;return new l(x.stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(x,U){super(x),this.name="ListenerLeakError",this.stack=U}}e.ListenerLeakError=m;class h extends Error{constructor(x,U){super(x),this.name="ListenerRefusalError",this.stack=U}}e.ListenerRefusalError=h;let g=0;class n{constructor(x){this.value=x,this.id=g++}}const o=2,t=(O,x)=>{if(O instanceof n)x(O);else for(let U=0;U<O.length;U++){const F=O[U];F&&x(F)}};let i;if(A){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),i=new FinalizationRegistry(x=>{typeof x=="string"&&O.push(x)})}class r{constructor(x){this._size=0,this._options=x,this._leakageMon=c>0||this._options?.leakWarningThreshold?new b(x?.onListenerError??s.onUnexpectedError,this._options?.leakWarningThreshold??c):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(p){const x=this._listeners;queueMicrotask(()=>{t(x,U=>U.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(x,U,F)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const V=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(V);const X=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new h(`${V}. HINT: Stack shows most frequent listener (${X[1]}-times)`,X[0]);return(this._options?.onListenerError||s.onUnexpectedError)(ee),T.Disposable.None}if(this._disposed)return T.Disposable.None;U&&(x=x.bind(U));const H=new n(x);let j,re;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(H.stack=l.create(),j=this._leakageMon.check(H.stack,this._size+1)),p&&(H.stack=re??l.create()),this._listeners?this._listeners instanceof n?(this._deliveryQueue??=new u,this._listeners=[this._listeners,H]):this._listeners.push(H):(this._options?.onWillAddFirstListener?.(this),this._listeners=H,this._options?.onDidAddFirstListener?.(this)),this._size++;const B=(0,T.toDisposable)(()=>{i?.unregister(B),j?.(),this._removeListener(H)});if(F instanceof T.DisposableStore?F.add(B):Array.isArray(F)&&F.push(B),i){const V=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),X=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(V);i.register(B,X?.[2]??V,B)}return B},this._event}_removeListener(x){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const U=this._listeners,F=U.indexOf(x);if(F===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,U[F]=void 0;const H=this._deliveryQueue.current===this;if(this._size*o<=U.length){let j=0;for(let re=0;re<U.length;re++)U[re]?U[j++]=U[re]:H&&(this._deliveryQueue.end--,j<this._deliveryQueue.i&&this._deliveryQueue.i--);U.length=j}}_deliver(x,U){if(!x)return;const F=this._options?.onListenerError||s.onUnexpectedError;if(!F){x.value(U);return}try{x.value(U)}catch(H){F(H)}}_deliverQueue(x){const U=x.current._listeners;for(;x.i<x.end;)this._deliver(U[x.i++],x.value);x.reset()}fire(x){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof n)this._deliver(this._listeners,x);else{const U=this._deliveryQueue;U.enqueue(this,x,this._listeners.length),this._deliverQueue(U)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=r;const f=()=>new u;e.createEventDeliveryQueue=f;class u{constructor(){this.i=-1,this.end=0}enqueue(x,U,F){this.i=0,this.end=F,this.current=x,this.value=U}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class v extends r{async fireAsync(x,U,F){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList),t(this._listeners,H=>this._asyncDeliveryQueue.push([H.value,x]));this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[H,j]=this._asyncDeliveryQueue.shift(),re=[],B={...j,token:U,waitUntil:V=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");F&&(V=F(V,H)),re.push(V)}};try{H(B)}catch(V){(0,s.onUnexpectedError)(V);continue}Object.freeze(re),await Promise.allSettled(re).then(V=>{for(const X of V)X.status==="rejected"&&(0,s.onUnexpectedError)(X.reason)})}}}e.AsyncEmitter=v;class y extends r{get isPaused(){return this._isPaused!==0}constructor(x){super(x),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=x?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const x=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(x))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(x){this._size&&(this._isPaused!==0?this._eventQueue.push(x):super.fire(x))}}e.PauseableEmitter=y;class D extends y{constructor(x){super(x),this._delay=x.delay??100}fire(x){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(x)}}e.DebounceEmitter=D;class w extends r{constructor(x){super(x),this._queuedEvents=[],this._mergeFn=x?.merge}fire(x){this.hasListeners()&&(this._queuedEvents.push(x),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(U=>super.fire(U)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=w;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(x){const U={event:x,listener:null};this.events.push(U),this.hasListeners&&this.hook(U);const F=()=>{this.hasListeners&&this.unhook(U);const H=this.events.indexOf(U);this.events.splice(H,1)};return(0,T.toDisposable)((0,d.createSingleCallFunction)(F))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(x=>this.hook(x))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(x=>this.unhook(x))}hook(x){x.listener=x.event(U=>this.emitter.fire(U))}unhook(x){x.listener?.dispose(),x.listener=null}dispose(){this.emitter.dispose();for(const x of this.events)x.listener?.dispose();this.events=[]}}e.EventMultiplexer=P;class k{constructor(x,U,F,H){this._store=new T.DisposableStore;const j=this._store.add(new P),re=this._store.add(new T.DisposableMap);function B(V){re.set(V,j.add(H(V)))}for(const V of x)B(V);this._store.add(U(V=>{B(V)})),this._store.add(F(V=>{re.deleteAndDispose(V)})),this.event=j.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=k;class E{constructor(){this.data=[]}wrapEvent(x,U,F){return(H,j,re)=>x(B=>{const V=this.data[this.data.length-1];if(!U){V?V.buffers.push(()=>H.call(j,B)):H.call(j,B);return}const X=V;if(!X){H.call(j,U(F,B));return}X.items??=[],X.items.push(B),X.buffers.length===0&&V.buffers.push(()=>{X.reducedResult??=F?X.items.reduce(U,F):X.items.reduce(U),H.call(j,X.reducedResult)})},void 0,re)}bufferEvents(x){const U={buffers:new Array};this.data.push(U);const F=x();return this.data.pop(),U.buffers.forEach(H=>H()),F}}e.EventBufferer=E;class S{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=T.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(x){this.inputEvent=x,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=x(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S;class M{static const(x){return new N(x)}constructor(x){this._value=x,this._onDidChange=new r,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(x){x!==this._value&&(this._value=x,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=M;class N{constructor(x){this.value=x,this.onDidChange=I.None}}}),define(_e[21],ye([1,0,4]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=A;const d=Object.freeze(function(p,a){const I=setTimeout(p.bind(a),0);return{dispose(){clearTimeout(I)}}});var T;(function(p){function a(I){return I===p.None||I===p.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}p.isCancellationToken=a,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:d})})(T||(e.CancellationToken=T={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?d:(this._emitter||(this._emitter=new s.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=T.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=L;function A(p){const a=new L;return p.add({dispose(){a.cancel()}}),a.token}}),define(_e[183],ye([1,0,21]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=T;class d{constructor(p){this.task=p,this.result=null}get(){if(this.result)return this.result;const p=new s.CancellationTokenSource,a=this.task(p.token);return this.result={promise:a,dispose:()=>{this.result=null,p.cancel(),p.dispose()}},this.result}}e.Cache=d;function T(A){return A}class R{constructor(p,a){this.lastCache=void 0,this.lastArgKey=void 0,typeof p=="function"?(this._fn=p,this._computeKey=T):(this._fn=a,this._computeKey=p.getCacheKey)}get(p){const a=this._computeKey(p);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this._fn(p)),this.lastCache}}e.LRUCachedFunction=R;class L{get cachedValues(){return this._map}constructor(p,a){this._map=new Map,this._map2=new Map,typeof p=="function"?(this._fn=p,this._computeKey=T):(this._fn=a,this._computeKey=p.getCacheKey)}get(p){const a=this._computeKey(p);if(this._map2.has(a))return this._map2.get(a);const I=this._fn(p);return this._map.set(p,I),this._map2.set(a,I),I}}e.CachedFunction=L}),define(_e[184],ye([1,0,4,3]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var T;(function(C){C[C.Auto=1]="Auto",C[C.Hidden=2]="Hidden",C[C.Visible=3]="Visible"})(T||(e.ScrollbarVisibility=T={}));class R{constructor(b,l,m,h,g,n,o){this._forceIntegerValues=b,this._scrollStateBrand=void 0,this._forceIntegerValues&&(l=l|0,m=m|0,h=h|0,g=g|0,n=n|0,o=o|0),this.rawScrollLeft=h,this.rawScrollTop=o,l<0&&(l=0),h+l>m&&(h=m-l),h<0&&(h=0),g<0&&(g=0),o+g>n&&(o=n-g),o<0&&(o=0),this.width=l,this.scrollWidth=m,this.scrollLeft=h,this.height=g,this.scrollHeight=n,this.scrollTop=o}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,l){return new R(this._forceIntegerValues,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,l?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,l?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new R(this._forceIntegerValues,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,l){const m=this.width!==b.width,h=this.scrollWidth!==b.scrollWidth,g=this.scrollLeft!==b.scrollLeft,n=this.height!==b.height,o=this.scrollHeight!==b.scrollHeight,t=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:l,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:h,scrollLeftChanged:g,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:t}}}e.ScrollState=R;class L extends d.Disposable{constructor(b){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new s.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=b.smoothScrollDuration,this._scheduleAtNextAnimationFrame=b.scheduleAtNextAnimationFrame,this._state=new R(b.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(b){this._smoothScrollDuration=b}validateScrollPosition(b){return this._state.withScrollPosition(b)}getScrollDimensions(){return this._state}setScrollDimensions(b,l){const m=this._state.withScrollDimensions(b,l);this._setState(m,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(b){const l=this._state.withScrollPosition(b);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(l,!1)}setScrollPositionSmooth(b,l){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(b);if(this._smoothScrolling){b={scrollLeft:typeof b.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this._smoothScrolling.to.scrollTop:b.scrollTop};const m=this._state.withScrollPosition(b);if(this._smoothScrolling.to.scrollLeft===m.scrollLeft&&this._smoothScrolling.to.scrollTop===m.scrollTop)return;let h;l?h=new I(this._smoothScrolling.from,m,this._smoothScrolling.startTime,this._smoothScrolling.duration):h=this._smoothScrolling.combine(this._state,m,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=h}else{const m=this._state.withScrollPosition(b);this._smoothScrolling=I.start(this._state,m,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const b=this._smoothScrolling.tick(),l=this._state.withScrollPosition(b);if(this._setState(l,!0),!!this._smoothScrolling){if(b.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(b,l){const m=this._state;m.equals(b)||(this._state=b,this._onScroll.fire(this._state.createScrollEvent(m,l)))}}e.Scrollable=L;class A{constructor(b,l,m){this.scrollLeft=b,this.scrollTop=l,this.isDone=m}}e.SmoothScrollingUpdate=A;function p(C,b){const l=b-C;return function(m){return C+l*c(m)}}function a(C,b,l){return function(m){return m<l?C(m/l):b((m-l)/(1-l))}}class I{constructor(b,l,m,h){this.from=b,this.to=l,this.duration=h,this.startTime=m,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(b,l,m){if(Math.abs(b-l)>2.5*m){let g,n;return b<l?(g=b+.75*m,n=l-.75*m):(g=b-.75*m,n=l+.75*m),a(p(b,g),p(n,l),.33)}return p(b,l)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(b){const l=(b-this.startTime)/this.duration;if(l<1){const m=this.scrollLeft(l),h=this.scrollTop(l);return new A(m,h,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,l,m){return I.start(b,l,m)}static start(b,l,m){m=m+10;const h=Date.now()-10;return new I(b,l,h,m)}}e.SmoothScrollingOperation=I;function _(C){return Math.pow(C,3)}function c(C){return 1-_(1-C)}}),define(_e[104],ye([1,0,14,3]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=T,e.isReadableStream=R,e.isReadableBufferedStream=L,e.newWriteableStream=A,e.consumeReadable=a,e.peekReadable=I,e.consumeStream=_,e.listenStream=c,e.peekStream=C,e.toStream=b,e.emptyStream=l,e.toReadable=m,e.transform=h,e.prefixedReadable=g,e.prefixedStream=n;function T(o){const t=o;return t?typeof t.read=="function":!1}function R(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}function L(o){const t=o;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(o,t){return new p(o,t)}class p{constructor(t,i){this.reducer=t,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(i=>i(t))}emitError(t){this.listeners.error.length===0?(0,s.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(i=>i(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,i){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(t,i){if(this.state.destroyed)return;let r;switch(t){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const f=r.indexOf(i);f>=0&&r.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(o,t){const i=[];let r;for(;(r=o.read())!==null;)i.push(r);return t(i)}function I(o,t,i){const r=[];let f;for(;(f=o.read())!==null&&r.length<i;)r.push(f);return f===null&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return o.read()}}}function _(o,t){return new Promise((i,r)=>{const f=[];c(o,{onData:u=>{t&&f.push(u)},onError:u=>{t?r(u):i(void 0)},onEnd:()=>{i(t?t(f):void 0)}})})}function c(o,t,i){o.on("error",r=>{i?.isCancellationRequested||t.onError(r)}),o.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),o.on("data",r=>{i?.isCancellationRequested||t.onData(r)})}function C(o,t){return new Promise((i,r)=>{const f=new d.DisposableStore,u=[],v=w=>{if(u.push(w),u.length>t)return f.dispose(),o.pause(),i({stream:o,buffer:u,ended:!1})},y=w=>(f.dispose(),r(w)),D=()=>(f.dispose(),i({stream:o,buffer:u,ended:!0}));f.add((0,d.toDisposable)(()=>o.removeListener("error",y))),o.on("error",y),f.add((0,d.toDisposable)(()=>o.removeListener("end",D))),o.on("end",D),f.add((0,d.toDisposable)(()=>o.removeListener("data",v))),o.on("data",v)})}function b(o,t){const i=A(t);return i.end(o),i}function l(){const o=A(()=>{throw new Error("not supported")});return o.end(),o}function m(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function h(o,t,i){const r=A(i);return c(o,{onData:f=>r.write(t.data(f)),onError:f=>r.error(t.error?t.error(f):f),onEnd:()=>r.end()}),r}function g(o,t,i){let r=!1;return{read:()=>{const f=t.read();return r?f:(r=!0,f!==null?i([o,f]):o)}}}function n(o,t,i){let r=!1;const f=A(i);return c(t,{onData:u=>r?f.write(u):(r=!0,f.write(i([o,u]))),onError:u=>f.error(u),onEnd:()=>{r||(r=!0,f.write(o)),f.end()}}),f}}),define(_e[22],ye([1,0,49,104]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=I,e.writeUInt16LE=_,e.readUInt32BE=c,e.writeUInt32BE=C,e.readUInt32LE=b,e.writeUInt32LE=l,e.readUInt8=m,e.writeUInt8=h,e.readableToBuffer=g,e.bufferToReadable=n,e.streamToBuffer=o,e.bufferedStreamToBuffer=t,e.bufferToStream=i,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=f,e.prefixedBufferReadable=u,e.prefixedBufferStream=v,e.decodeBase64=y,e.encodeBase64=P,d=ze(d);const T=typeof Buffer<"u",R=new s.Lazy(()=>new Uint8Array(256));let L,A;class p{static alloc(E){return T?new p(Buffer.allocUnsafe(E)):new p(new Uint8Array(E))}static wrap(E){return T&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new p(E)}static fromString(E,S){return!(S?.dontUseNodeBuffer||!1)&&T?new p(Buffer.from(E)):(L||(L=new TextEncoder),new p(L.encode(E)))}static fromByteArray(E){const S=p.alloc(E.length);for(let M=0,N=E.length;M<N;M++)S.buffer[M]=E[M];return S}static concat(E,S){if(typeof S>"u"){S=0;for(let O=0,x=E.length;O<x;O++)S+=E[O].byteLength}const M=p.alloc(S);let N=0;for(let O=0,x=E.length;O<x;O++){const U=E[O];M.set(U,N),N+=U.byteLength}return M}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=p.alloc(this.byteLength);return E.set(this),E}toString(){return T?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(E,S){return new p(this.buffer.subarray(E,S))}set(E,S){if(E instanceof p)this.buffer.set(E.buffer,S);else if(E instanceof Uint8Array)this.buffer.set(E,S);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),S);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return c(this.buffer,E)}writeUInt32BE(E,S){C(this.buffer,E,S)}readUInt32LE(E){return b(this.buffer,E)}writeUInt32LE(E,S){l(this.buffer,E,S)}readUInt8(E){return m(this.buffer,E)}writeUInt8(E,S){h(this.buffer,E,S)}indexOf(E,S=0){return a(this.buffer,E instanceof p?E.buffer:E,S)}}e.VSBuffer=p;function a(k,E,S=0){const M=E.byteLength,N=k.byteLength;if(M===0)return 0;if(M===1)return k.indexOf(E[0]);if(M>N-S)return-1;const O=R.value;O.fill(E.length);for(let H=0;H<E.length;H++)O[E[H]]=E.length-H-1;let x=S+E.length-1,U=x,F=-1;for(;x<N;)if(k[x]===E[U]){if(U===0){F=x;break}x--,U--}else x+=Math.max(E.length-U,O[k[x]]),U=E.length-1;return F}function I(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0}function _(k,E,S){k[S+0]=E&255,E=E>>>8,k[S+1]=E&255}function c(k,E){return k[E]*2**24+k[E+1]*2**16+k[E+2]*2**8+k[E+3]}function C(k,E,S){k[S+3]=E,E=E>>>8,k[S+2]=E,E=E>>>8,k[S+1]=E,E=E>>>8,k[S]=E}function b(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0|k[E+2]<<16>>>0|k[E+3]<<24>>>0}function l(k,E,S){k[S+0]=E&255,E=E>>>8,k[S+1]=E&255,E=E>>>8,k[S+2]=E&255,E=E>>>8,k[S+3]=E&255}function m(k,E){return k[E]}function h(k,E,S){k[S]=E}function g(k){return d.consumeReadable(k,E=>p.concat(E))}function n(k){return d.toReadable(k)}function o(k){return d.consumeStream(k,E=>p.concat(E))}async function t(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await o(k.stream)])}function i(k){return d.toStream(k,E=>p.concat(E))}function r(k){return d.transform(k,{data:E=>typeof E=="string"?p.fromString(E):p.wrap(E)},E=>p.concat(E))}function f(k){return d.newWriteableStream(E=>p.concat(E),k)}function u(k,E){return d.prefixedReadable(k,E,S=>p.concat(S))}function v(k,E){return d.prefixedStream(k,E,S=>p.concat(S))}function y(k){let E=0,S=0,M=0;const N=new Uint8Array(Math.floor(k.length/4*3)),O=U=>{switch(S){case 3:N[M++]=E|U,S=0;break;case 2:N[M++]=E|U>>>2,E=U<<6,S=3;break;case 1:N[M++]=E|U>>>4,E=U<<4,S=2;break;default:E=U<<2,S=1}};for(let U=0;U<k.length;U++){const F=k.charCodeAt(U);if(F>=65&&F<=90)O(F-65);else if(F>=97&&F<=122)O(F-97+26);else if(F>=48&&F<=57)O(F-48+52);else if(F===43||F===45)O(62);else if(F===47||F===95)O(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${k[U]}`)}}const x=M;for(;S>0;)O(0);return p.wrap(N).slice(0,x)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:k},E=!0,S=!1){const M=S?w:D;let N="";const O=k.byteLength%3;let x=0;for(;x<k.byteLength-O;x+=3){const U=k[x+0],F=k[x+1],H=k[x+2];N+=M[U>>>2],N+=M[(U<<4|F>>>4)&63],N+=M[(F<<2|H>>>6)&63],N+=M[H&63]}if(O===1){const U=k[x+0];N+=M[U>>>2],N+=M[U<<4&63],E&&(N+="==")}else if(O===2){const U=k[x+0],F=k[x+1];N+=M[U>>>2],N+=M[(U<<4|F>>>4)&63],N+=M[F<<2&63],E&&(N+="=")}return N}}),define(_e[185],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(_e[18],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=s,e.isStringArray=d,e.isObject=T,e.isTypedArray=R,e.isNumber=L,e.isIterable=A,e.isBoolean=p,e.isUndefined=a,e.isDefined=I,e.isUndefinedOrNull=_,e.assertType=c,e.assertIsDefined=C,e.assertAllDefined=b,e.isEmptyObject=m,e.isFunction=h,e.areFunctions=g,e.validateConstraints=n,e.validateConstraint=o;function s(t){return typeof t=="string"}function d(t){return Array.isArray(t)&&t.every(i=>s(i))}function T(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}function L(t){return typeof t=="number"&&!isNaN(t)}function A(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function I(t){return!_(t)}function _(t){return a(t)||t===null}function c(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function C(t){if(_(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function b(...t){const i=[];for(let r=0;r<t.length;r++){const f=t[r];if(_(f))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(f)}return i}const l=Object.prototype.hasOwnProperty;function m(t){if(!T(t))return!1;for(const i in t)if(l.call(t,i))return!1;return!0}function h(t){return typeof t=="function"}function g(...t){return t.length>0&&t.every(h)}function n(t,i){const r=Math.min(t.length,i.length);for(let f=0;f<r;f++)o(t[f],i[f])}function o(t,i){if(s(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(t instanceof i)return}catch{}if(!_(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(_e[105],ye([1,0,18]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=T,e.getCodiconFontCharacters=R;const d=Object.create(null);function T(L,A){if((0,s.isString)(A)){const p=d[A];if(p===void 0)throw new Error(`${L} references an unknown codicon: ${A}`);A=p}return d[L]=A,{id:L}}function R(){return d}}),define(_e[186],ye([1,0,105]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,s.register)("add",6e4),plus:(0,s.register)("plus",6e4),gistNew:(0,s.register)("gist-new",6e4),repoCreate:(0,s.register)("repo-create",6e4),lightbulb:(0,s.register)("lightbulb",60001),lightBulb:(0,s.register)("light-bulb",60001),repo:(0,s.register)("repo",60002),repoDelete:(0,s.register)("repo-delete",60002),gistFork:(0,s.register)("gist-fork",60003),repoForked:(0,s.register)("repo-forked",60003),gitPullRequest:(0,s.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.register)("git-pull-request-abandoned",60004),recordKeys:(0,s.register)("record-keys",60005),keyboard:(0,s.register)("keyboard",60005),tag:(0,s.register)("tag",60006),gitPullRequestLabel:(0,s.register)("git-pull-request-label",60006),tagAdd:(0,s.register)("tag-add",60006),tagRemove:(0,s.register)("tag-remove",60006),person:(0,s.register)("person",60007),personFollow:(0,s.register)("person-follow",60007),personOutline:(0,s.register)("person-outline",60007),personFilled:(0,s.register)("person-filled",60007),gitBranch:(0,s.register)("git-branch",60008),gitBranchCreate:(0,s.register)("git-branch-create",60008),gitBranchDelete:(0,s.register)("git-branch-delete",60008),sourceControl:(0,s.register)("source-control",60008),mirror:(0,s.register)("mirror",60009),mirrorPublic:(0,s.register)("mirror-public",60009),star:(0,s.register)("star",60010),starAdd:(0,s.register)("star-add",60010),starDelete:(0,s.register)("star-delete",60010),starEmpty:(0,s.register)("star-empty",60010),comment:(0,s.register)("comment",60011),commentAdd:(0,s.register)("comment-add",60011),alert:(0,s.register)("alert",60012),warning:(0,s.register)("warning",60012),search:(0,s.register)("search",60013),searchSave:(0,s.register)("search-save",60013),logOut:(0,s.register)("log-out",60014),signOut:(0,s.register)("sign-out",60014),logIn:(0,s.register)("log-in",60015),signIn:(0,s.register)("sign-in",60015),eye:(0,s.register)("eye",60016),eyeUnwatch:(0,s.register)("eye-unwatch",60016),eyeWatch:(0,s.register)("eye-watch",60016),circleFilled:(0,s.register)("circle-filled",60017),primitiveDot:(0,s.register)("primitive-dot",60017),closeDirty:(0,s.register)("close-dirty",60017),debugBreakpoint:(0,s.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.register)("debug-breakpoint-disabled",60017),debugHint:(0,s.register)("debug-hint",60017),terminalDecorationSuccess:(0,s.register)("terminal-decoration-success",60017),primitiveSquare:(0,s.register)("primitive-square",60018),edit:(0,s.register)("edit",60019),pencil:(0,s.register)("pencil",60019),info:(0,s.register)("info",60020),issueOpened:(0,s.register)("issue-opened",60020),gistPrivate:(0,s.register)("gist-private",60021),gitForkPrivate:(0,s.register)("git-fork-private",60021),lock:(0,s.register)("lock",60021),mirrorPrivate:(0,s.register)("mirror-private",60021),close:(0,s.register)("close",60022),removeClose:(0,s.register)("remove-close",60022),x:(0,s.register)("x",60022),repoSync:(0,s.register)("repo-sync",60023),sync:(0,s.register)("sync",60023),clone:(0,s.register)("clone",60024),desktopDownload:(0,s.register)("desktop-download",60024),beaker:(0,s.register)("beaker",60025),microscope:(0,s.register)("microscope",60025),vm:(0,s.register)("vm",60026),deviceDesktop:(0,s.register)("device-desktop",60026),file:(0,s.register)("file",60027),fileText:(0,s.register)("file-text",60027),more:(0,s.register)("more",60028),ellipsis:(0,s.register)("ellipsis",60028),kebabHorizontal:(0,s.register)("kebab-horizontal",60028),mailReply:(0,s.register)("mail-reply",60029),reply:(0,s.register)("reply",60029),organization:(0,s.register)("organization",60030),organizationFilled:(0,s.register)("organization-filled",60030),organizationOutline:(0,s.register)("organization-outline",60030),newFile:(0,s.register)("new-file",60031),fileAdd:(0,s.register)("file-add",60031),newFolder:(0,s.register)("new-folder",60032),fileDirectoryCreate:(0,s.register)("file-directory-create",60032),trash:(0,s.register)("trash",60033),trashcan:(0,s.register)("trashcan",60033),history:(0,s.register)("history",60034),clock:(0,s.register)("clock",60034),folder:(0,s.register)("folder",60035),fileDirectory:(0,s.register)("file-directory",60035),symbolFolder:(0,s.register)("symbol-folder",60035),logoGithub:(0,s.register)("logo-github",60036),markGithub:(0,s.register)("mark-github",60036),github:(0,s.register)("github",60036),terminal:(0,s.register)("terminal",60037),console:(0,s.register)("console",60037),repl:(0,s.register)("repl",60037),zap:(0,s.register)("zap",60038),symbolEvent:(0,s.register)("symbol-event",60038),error:(0,s.register)("error",60039),stop:(0,s.register)("stop",60039),variable:(0,s.register)("variable",60040),symbolVariable:(0,s.register)("symbol-variable",60040),array:(0,s.register)("array",60042),symbolArray:(0,s.register)("symbol-array",60042),symbolModule:(0,s.register)("symbol-module",60043),symbolPackage:(0,s.register)("symbol-package",60043),symbolNamespace:(0,s.register)("symbol-namespace",60043),symbolObject:(0,s.register)("symbol-object",60043),symbolMethod:(0,s.register)("symbol-method",60044),symbolFunction:(0,s.register)("symbol-function",60044),symbolConstructor:(0,s.register)("symbol-constructor",60044),symbolBoolean:(0,s.register)("symbol-boolean",60047),symbolNull:(0,s.register)("symbol-null",60047),symbolNumeric:(0,s.register)("symbol-numeric",60048),symbolNumber:(0,s.register)("symbol-number",60048),symbolStructure:(0,s.register)("symbol-structure",60049),symbolStruct:(0,s.register)("symbol-struct",60049),symbolParameter:(0,s.register)("symbol-parameter",60050),symbolTypeParameter:(0,s.register)("symbol-type-parameter",60050),symbolKey:(0,s.register)("symbol-key",60051),symbolText:(0,s.register)("symbol-text",60051),symbolReference:(0,s.register)("symbol-reference",60052),goToFile:(0,s.register)("go-to-file",60052),symbolEnum:(0,s.register)("symbol-enum",60053),symbolValue:(0,s.register)("symbol-value",60053),symbolRuler:(0,s.register)("symbol-ruler",60054),symbolUnit:(0,s.register)("symbol-unit",60054),activateBreakpoints:(0,s.register)("activate-breakpoints",60055),archive:(0,s.register)("archive",60056),arrowBoth:(0,s.register)("arrow-both",60057),arrowDown:(0,s.register)("arrow-down",60058),arrowLeft:(0,s.register)("arrow-left",60059),arrowRight:(0,s.register)("arrow-right",60060),arrowSmallDown:(0,s.register)("arrow-small-down",60061),arrowSmallLeft:(0,s.register)("arrow-small-left",60062),arrowSmallRight:(0,s.register)("arrow-small-right",60063),arrowSmallUp:(0,s.register)("arrow-small-up",60064),arrowUp:(0,s.register)("arrow-up",60065),bell:(0,s.register)("bell",60066),bold:(0,s.register)("bold",60067),book:(0,s.register)("book",60068),bookmark:(0,s.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.register)("briefcase",60076),broadcast:(0,s.register)("broadcast",60077),browser:(0,s.register)("browser",60078),bug:(0,s.register)("bug",60079),calendar:(0,s.register)("calendar",60080),caseSensitive:(0,s.register)("case-sensitive",60081),check:(0,s.register)("check",60082),checklist:(0,s.register)("checklist",60083),chevronDown:(0,s.register)("chevron-down",60084),chevronLeft:(0,s.register)("chevron-left",60085),chevronRight:(0,s.register)("chevron-right",60086),chevronUp:(0,s.register)("chevron-up",60087),chromeClose:(0,s.register)("chrome-close",60088),chromeMaximize:(0,s.register)("chrome-maximize",60089),chromeMinimize:(0,s.register)("chrome-minimize",60090),chromeRestore:(0,s.register)("chrome-restore",60091),circleOutline:(0,s.register)("circle-outline",60092),circle:(0,s.register)("circle",60092),debugBreakpointUnverified:(0,s.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.register)("terminal-decoration-incomplete",60092),circleSlash:(0,s.register)("circle-slash",60093),circuitBoard:(0,s.register)("circuit-board",60094),clearAll:(0,s.register)("clear-all",60095),clippy:(0,s.register)("clippy",60096),closeAll:(0,s.register)("close-all",60097),cloudDownload:(0,s.register)("cloud-download",60098),cloudUpload:(0,s.register)("cloud-upload",60099),code:(0,s.register)("code",60100),collapseAll:(0,s.register)("collapse-all",60101),colorMode:(0,s.register)("color-mode",60102),commentDiscussion:(0,s.register)("comment-discussion",60103),creditCard:(0,s.register)("credit-card",60105),dash:(0,s.register)("dash",60108),dashboard:(0,s.register)("dashboard",60109),database:(0,s.register)("database",60110),debugContinue:(0,s.register)("debug-continue",60111),debugDisconnect:(0,s.register)("debug-disconnect",60112),debugPause:(0,s.register)("debug-pause",60113),debugRestart:(0,s.register)("debug-restart",60114),debugStart:(0,s.register)("debug-start",60115),debugStepInto:(0,s.register)("debug-step-into",60116),debugStepOut:(0,s.register)("debug-step-out",60117),debugStepOver:(0,s.register)("debug-step-over",60118),debugStop:(0,s.register)("debug-stop",60119),debug:(0,s.register)("debug",60120),deviceCameraVideo:(0,s.register)("device-camera-video",60121),deviceCamera:(0,s.register)("device-camera",60122),deviceMobile:(0,s.register)("device-mobile",60123),diffAdded:(0,s.register)("diff-added",60124),diffIgnored:(0,s.register)("diff-ignored",60125),diffModified:(0,s.register)("diff-modified",60126),diffRemoved:(0,s.register)("diff-removed",60127),diffRenamed:(0,s.register)("diff-renamed",60128),diff:(0,s.register)("diff",60129),diffSidebyside:(0,s.register)("diff-sidebyside",60129),discard:(0,s.register)("discard",60130),editorLayout:(0,s.register)("editor-layout",60131),emptyWindow:(0,s.register)("empty-window",60132),exclude:(0,s.register)("exclude",60133),extensions:(0,s.register)("extensions",60134),eyeClosed:(0,s.register)("eye-closed",60135),fileBinary:(0,s.register)("file-binary",60136),fileCode:(0,s.register)("file-code",60137),fileMedia:(0,s.register)("file-media",60138),filePdf:(0,s.register)("file-pdf",60139),fileSubmodule:(0,s.register)("file-submodule",60140),fileSymlinkDirectory:(0,s.register)("file-symlink-directory",60141),fileSymlinkFile:(0,s.register)("file-symlink-file",60142),fileZip:(0,s.register)("file-zip",60143),files:(0,s.register)("files",60144),filter:(0,s.register)("filter",60145),flame:(0,s.register)("flame",60146),foldDown:(0,s.register)("fold-down",60147),foldUp:(0,s.register)("fold-up",60148),fold:(0,s.register)("fold",60149),folderActive:(0,s.register)("folder-active",60150),folderOpened:(0,s.register)("folder-opened",60151),gear:(0,s.register)("gear",60152),gift:(0,s.register)("gift",60153),gistSecret:(0,s.register)("gist-secret",60154),gist:(0,s.register)("gist",60155),gitCommit:(0,s.register)("git-commit",60156),gitCompare:(0,s.register)("git-compare",60157),compareChanges:(0,s.register)("compare-changes",60157),gitMerge:(0,s.register)("git-merge",60158),githubAction:(0,s.register)("github-action",60159),githubAlt:(0,s.register)("github-alt",60160),globe:(0,s.register)("globe",60161),grabber:(0,s.register)("grabber",60162),graph:(0,s.register)("graph",60163),gripper:(0,s.register)("gripper",60164),heart:(0,s.register)("heart",60165),home:(0,s.register)("home",60166),horizontalRule:(0,s.register)("horizontal-rule",60167),hubot:(0,s.register)("hubot",60168),inbox:(0,s.register)("inbox",60169),issueReopened:(0,s.register)("issue-reopened",60171),issues:(0,s.register)("issues",60172),italic:(0,s.register)("italic",60173),jersey:(0,s.register)("jersey",60174),json:(0,s.register)("json",60175),kebabVertical:(0,s.register)("kebab-vertical",60176),key:(0,s.register)("key",60177),law:(0,s.register)("law",60178),lightbulbAutofix:(0,s.register)("lightbulb-autofix",60179),linkExternal:(0,s.register)("link-external",60180),link:(0,s.register)("link",60181),listOrdered:(0,s.register)("list-ordered",60182),listUnordered:(0,s.register)("list-unordered",60183),liveShare:(0,s.register)("live-share",60184),loading:(0,s.register)("loading",60185),location:(0,s.register)("location",60186),mailRead:(0,s.register)("mail-read",60187),mail:(0,s.register)("mail",60188),markdown:(0,s.register)("markdown",60189),megaphone:(0,s.register)("megaphone",60190),mention:(0,s.register)("mention",60191),milestone:(0,s.register)("milestone",60192),gitPullRequestMilestone:(0,s.register)("git-pull-request-milestone",60192),mortarBoard:(0,s.register)("mortar-board",60193),move:(0,s.register)("move",60194),multipleWindows:(0,s.register)("multiple-windows",60195),mute:(0,s.register)("mute",60196),noNewline:(0,s.register)("no-newline",60197),note:(0,s.register)("note",60198),octoface:(0,s.register)("octoface",60199),openPreview:(0,s.register)("open-preview",60200),package:(0,s.register)("package",60201),paintcan:(0,s.register)("paintcan",60202),pin:(0,s.register)("pin",60203),play:(0,s.register)("play",60204),run:(0,s.register)("run",60204),plug:(0,s.register)("plug",60205),preserveCase:(0,s.register)("preserve-case",60206),preview:(0,s.register)("preview",60207),project:(0,s.register)("project",60208),pulse:(0,s.register)("pulse",60209),question:(0,s.register)("question",60210),quote:(0,s.register)("quote",60211),radioTower:(0,s.register)("radio-tower",60212),reactions:(0,s.register)("reactions",60213),references:(0,s.register)("references",60214),refresh:(0,s.register)("refresh",60215),regex:(0,s.register)("regex",60216),remoteExplorer:(0,s.register)("remote-explorer",60217),remote:(0,s.register)("remote",60218),remove:(0,s.register)("remove",60219),replaceAll:(0,s.register)("replace-all",60220),replace:(0,s.register)("replace",60221),repoClone:(0,s.register)("repo-clone",60222),repoForcePush:(0,s.register)("repo-force-push",60223),repoPull:(0,s.register)("repo-pull",60224),repoPush:(0,s.register)("repo-push",60225),report:(0,s.register)("report",60226),requestChanges:(0,s.register)("request-changes",60227),rocket:(0,s.register)("rocket",60228),rootFolderOpened:(0,s.register)("root-folder-opened",60229),rootFolder:(0,s.register)("root-folder",60230),rss:(0,s.register)("rss",60231),ruby:(0,s.register)("ruby",60232),saveAll:(0,s.register)("save-all",60233),saveAs:(0,s.register)("save-as",60234),save:(0,s.register)("save",60235),screenFull:(0,s.register)("screen-full",60236),screenNormal:(0,s.register)("screen-normal",60237),searchStop:(0,s.register)("search-stop",60238),server:(0,s.register)("server",60240),settingsGear:(0,s.register)("settings-gear",60241),settings:(0,s.register)("settings",60242),shield:(0,s.register)("shield",60243),smiley:(0,s.register)("smiley",60244),sortPrecedence:(0,s.register)("sort-precedence",60245),splitHorizontal:(0,s.register)("split-horizontal",60246),splitVertical:(0,s.register)("split-vertical",60247),squirrel:(0,s.register)("squirrel",60248),starFull:(0,s.register)("star-full",60249),starHalf:(0,s.register)("star-half",60250),symbolClass:(0,s.register)("symbol-class",60251),symbolColor:(0,s.register)("symbol-color",60252),symbolConstant:(0,s.register)("symbol-constant",60253),symbolEnumMember:(0,s.register)("symbol-enum-member",60254),symbolField:(0,s.register)("symbol-field",60255),symbolFile:(0,s.register)("symbol-file",60256),symbolInterface:(0,s.register)("symbol-interface",60257),symbolKeyword:(0,s.register)("symbol-keyword",60258),symbolMisc:(0,s.register)("symbol-misc",60259),symbolOperator:(0,s.register)("symbol-operator",60260),symbolProperty:(0,s.register)("symbol-property",60261),wrench:(0,s.register)("wrench",60261),wrenchSubaction:(0,s.register)("wrench-subaction",60261),symbolSnippet:(0,s.register)("symbol-snippet",60262),tasklist:(0,s.register)("tasklist",60263),telescope:(0,s.register)("telescope",60264),textSize:(0,s.register)("text-size",60265),threeBars:(0,s.register)("three-bars",60266),thumbsdown:(0,s.register)("thumbsdown",60267),thumbsup:(0,s.register)("thumbsup",60268),tools:(0,s.register)("tools",60269),triangleDown:(0,s.register)("triangle-down",60270),triangleLeft:(0,s.register)("triangle-left",60271),triangleRight:(0,s.register)("triangle-right",60272),triangleUp:(0,s.register)("triangle-up",60273),twitter:(0,s.register)("twitter",60274),unfold:(0,s.register)("unfold",60275),unlock:(0,s.register)("unlock",60276),unmute:(0,s.register)("unmute",60277),unverified:(0,s.register)("unverified",60278),verified:(0,s.register)("verified",60279),versions:(0,s.register)("versions",60280),vmActive:(0,s.register)("vm-active",60281),vmOutline:(0,s.register)("vm-outline",60282),vmRunning:(0,s.register)("vm-running",60283),watch:(0,s.register)("watch",60284),whitespace:(0,s.register)("whitespace",60285),wholeWord:(0,s.register)("whole-word",60286),window:(0,s.register)("window",60287),wordWrap:(0,s.register)("word-wrap",60288),zoomIn:(0,s.register)("zoom-in",60289),zoomOut:(0,s.register)("zoom-out",60290),listFilter:(0,s.register)("list-filter",60291),listFlat:(0,s.register)("list-flat",60292),listSelection:(0,s.register)("list-selection",60293),selection:(0,s.register)("selection",60293),listTree:(0,s.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.register)("debug-stackframe-active",60297),circleSmallFilled:(0,s.register)("circle-small-filled",60298),debugStackframeDot:(0,s.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.register)("terminal-decoration-mark",60298),debugStackframe:(0,s.register)("debug-stackframe",60299),debugStackframeFocused:(0,s.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.register)("debug-breakpoint-unsupported",60300),symbolString:(0,s.register)("symbol-string",60301),debugReverseContinue:(0,s.register)("debug-reverse-continue",60302),debugStepBack:(0,s.register)("debug-step-back",60303),debugRestartFrame:(0,s.register)("debug-restart-frame",60304),debugAlt:(0,s.register)("debug-alt",60305),callIncoming:(0,s.register)("call-incoming",60306),callOutgoing:(0,s.register)("call-outgoing",60307),menu:(0,s.register)("menu",60308),expandAll:(0,s.register)("expand-all",60309),feedback:(0,s.register)("feedback",60310),gitPullRequestReviewer:(0,s.register)("git-pull-request-reviewer",60310),groupByRefType:(0,s.register)("group-by-ref-type",60311),ungroupByRefType:(0,s.register)("ungroup-by-ref-type",60312),account:(0,s.register)("account",60313),gitPullRequestAssignee:(0,s.register)("git-pull-request-assignee",60313),bellDot:(0,s.register)("bell-dot",60314),debugConsole:(0,s.register)("debug-console",60315),library:(0,s.register)("library",60316),output:(0,s.register)("output",60317),runAll:(0,s.register)("run-all",60318),syncIgnored:(0,s.register)("sync-ignored",60319),pinned:(0,s.register)("pinned",60320),githubInverted:(0,s.register)("github-inverted",60321),serverProcess:(0,s.register)("server-process",60322),serverEnvironment:(0,s.register)("server-environment",60323),pass:(0,s.register)("pass",60324),issueClosed:(0,s.register)("issue-closed",60324),stopCircle:(0,s.register)("stop-circle",60325),playCircle:(0,s.register)("play-circle",60326),record:(0,s.register)("record",60327),debugAltSmall:(0,s.register)("debug-alt-small",60328),vmConnect:(0,s.register)("vm-connect",60329),cloud:(0,s.register)("cloud",60330),merge:(0,s.register)("merge",60331),export:(0,s.register)("export",60332),graphLeft:(0,s.register)("graph-left",60333),magnet:(0,s.register)("magnet",60334),notebook:(0,s.register)("notebook",60335),redo:(0,s.register)("redo",60336),checkAll:(0,s.register)("check-all",60337),pinnedDirty:(0,s.register)("pinned-dirty",60338),passFilled:(0,s.register)("pass-filled",60339),circleLargeFilled:(0,s.register)("circle-large-filled",60340),circleLarge:(0,s.register)("circle-large",60341),circleLargeOutline:(0,s.register)("circle-large-outline",60341),combine:(0,s.register)("combine",60342),gather:(0,s.register)("gather",60342),table:(0,s.register)("table",60343),variableGroup:(0,s.register)("variable-group",60344),typeHierarchy:(0,s.register)("type-hierarchy",60345),typeHierarchySub:(0,s.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.register)("git-pull-request-create",60348),runAbove:(0,s.register)("run-above",60349),runBelow:(0,s.register)("run-below",60350),notebookTemplate:(0,s.register)("notebook-template",60351),debugRerun:(0,s.register)("debug-rerun",60352),workspaceTrusted:(0,s.register)("workspace-trusted",60353),workspaceUntrusted:(0,s.register)("workspace-untrusted",60354),workspaceUnknown:(0,s.register)("workspace-unknown",60355),terminalCmd:(0,s.register)("terminal-cmd",60356),terminalDebian:(0,s.register)("terminal-debian",60357),terminalLinux:(0,s.register)("terminal-linux",60358),terminalPowershell:(0,s.register)("terminal-powershell",60359),terminalTmux:(0,s.register)("terminal-tmux",60360),terminalUbuntu:(0,s.register)("terminal-ubuntu",60361),terminalBash:(0,s.register)("terminal-bash",60362),arrowSwap:(0,s.register)("arrow-swap",60363),copy:(0,s.register)("copy",60364),personAdd:(0,s.register)("person-add",60365),filterFilled:(0,s.register)("filter-filled",60366),wand:(0,s.register)("wand",60367),debugLineByLine:(0,s.register)("debug-line-by-line",60368),inspect:(0,s.register)("inspect",60369),layers:(0,s.register)("layers",60370),layersDot:(0,s.register)("layers-dot",60371),layersActive:(0,s.register)("layers-active",60372),compass:(0,s.register)("compass",60373),compassDot:(0,s.register)("compass-dot",60374),compassActive:(0,s.register)("compass-active",60375),azure:(0,s.register)("azure",60376),issueDraft:(0,s.register)("issue-draft",60377),gitPullRequestClosed:(0,s.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.register)("git-pull-request-draft",60379),debugAll:(0,s.register)("debug-all",60380),debugCoverage:(0,s.register)("debug-coverage",60381),runErrors:(0,s.register)("run-errors",60382),folderLibrary:(0,s.register)("folder-library",60383),debugContinueSmall:(0,s.register)("debug-continue-small",60384),beakerStop:(0,s.register)("beaker-stop",60385),graphLine:(0,s.register)("graph-line",60386),graphScatter:(0,s.register)("graph-scatter",60387),pieChart:(0,s.register)("pie-chart",60388),bracket:(0,s.register)("bracket",60175),bracketDot:(0,s.register)("bracket-dot",60389),bracketError:(0,s.register)("bracket-error",60390),lockSmall:(0,s.register)("lock-small",60391),azureDevops:(0,s.register)("azure-devops",60392),verifiedFilled:(0,s.register)("verified-filled",60393),newline:(0,s.register)("newline",60394),layout:(0,s.register)("layout",60395),layoutActivitybarLeft:(0,s.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.register)("layout-panel-left",60398),layoutPanelCenter:(0,s.register)("layout-panel-center",60399),layoutPanelJustify:(0,s.register)("layout-panel-justify",60400),layoutPanelRight:(0,s.register)("layout-panel-right",60401),layoutPanel:(0,s.register)("layout-panel",60402),layoutSidebarLeft:(0,s.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.register)("layout-sidebar-right",60404),layoutStatusbar:(0,s.register)("layout-statusbar",60405),layoutMenubar:(0,s.register)("layout-menubar",60406),layoutCentered:(0,s.register)("layout-centered",60407),target:(0,s.register)("target",60408),indent:(0,s.register)("indent",60409),recordSmall:(0,s.register)("record-small",60410),errorSmall:(0,s.register)("error-small",60411),terminalDecorationError:(0,s.register)("terminal-decoration-error",60411),arrowCircleDown:(0,s.register)("arrow-circle-down",60412),arrowCircleLeft:(0,s.register)("arrow-circle-left",60413),arrowCircleRight:(0,s.register)("arrow-circle-right",60414),arrowCircleUp:(0,s.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.register)("layout-sidebar-left-off",60418),blank:(0,s.register)("blank",60419),heartFilled:(0,s.register)("heart-filled",60420),map:(0,s.register)("map",60421),mapHorizontal:(0,s.register)("map-horizontal",60421),foldHorizontal:(0,s.register)("fold-horizontal",60421),mapFilled:(0,s.register)("map-filled",60422),mapHorizontalFilled:(0,s.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.register)("fold-horizontal-filled",60422),circleSmall:(0,s.register)("circle-small",60423),bellSlash:(0,s.register)("bell-slash",60424),bellSlashDot:(0,s.register)("bell-slash-dot",60425),commentUnresolved:(0,s.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.register)("search-fuzzy",60429),commentDraft:(0,s.register)("comment-draft",60430),send:(0,s.register)("send",60431),sparkle:(0,s.register)("sparkle",60432),insert:(0,s.register)("insert",60433),mic:(0,s.register)("mic",60434),thumbsdownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsupFilled:(0,s.register)("thumbsup-filled",60436),coffee:(0,s.register)("coffee",60437),snake:(0,s.register)("snake",60438),game:(0,s.register)("game",60439),vr:(0,s.register)("vr",60440),chip:(0,s.register)("chip",60441),piano:(0,s.register)("piano",60442),music:(0,s.register)("music",60443),micFilled:(0,s.register)("mic-filled",60444),repoFetch:(0,s.register)("repo-fetch",60445),copilot:(0,s.register)("copilot",60446),lightbulbSparkle:(0,s.register)("lightbulb-sparkle",60447),robot:(0,s.register)("robot",60448),sparkleFilled:(0,s.register)("sparkle-filled",60449),diffSingle:(0,s.register)("diff-single",60450),diffMultiple:(0,s.register)("diff-multiple",60451),surroundWith:(0,s.register)("surround-with",60452),share:(0,s.register)("share",60453),gitStash:(0,s.register)("git-stash",60454),gitStashApply:(0,s.register)("git-stash-apply",60455),gitStashPop:(0,s.register)("git-stash-pop",60456),vscode:(0,s.register)("vscode",60457),vscodeInsiders:(0,s.register)("vscode-insiders",60458),codeOss:(0,s.register)("code-oss",60459),runCoverage:(0,s.register)("run-coverage",60460),runAllCoverage:(0,s.register)("run-all-coverage",60461),coverage:(0,s.register)("coverage",60462),githubProject:(0,s.register)("github-project",60463),mapVertical:(0,s.register)("map-vertical",60464),foldVertical:(0,s.register)("fold-vertical",60464),mapVerticalFilled:(0,s.register)("map-vertical-filled",60465),foldVerticalFilled:(0,s.register)("fold-vertical-filled",60465),goToSearch:(0,s.register)("go-to-search",60466),percentage:(0,s.register)("percentage",60467),sortPercentage:(0,s.register)("sort-percentage",60467),attach:(0,s.register)("attach",60468)}}),define(_e[83],ye([1,0,105,186]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=T;function T(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,s.register)("dialog-error","error"),dialogWarning:(0,s.register)("dialog-warning","warning"),dialogInfo:(0,s.register)("dialog-info","info"),dialogClose:(0,s.register)("dialog-close","close"),treeItemExpanded:(0,s.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.register)("tree-filter-clear","close"),treeItemLoading:(0,s.register)("tree-item-loading","loading"),menuSelection:(0,s.register)("menu-selection","check"),menuSubmenu:(0,s.register)("menu-submenu","chevron-right"),menuBarMore:(0,s.register)("menubar-more","more"),scrollbarButtonLeft:(0,s.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.register)("toolbar-more","more"),quickInputBack:(0,s.register)("quick-input-back","arrow-left"),dropDownButton:(0,s.register)("drop-down-button",60084),symbolCustomColor:(0,s.register)("symbol-customcolor",60252),exportIcon:(0,s.register)("export",60332),workspaceUnspecified:(0,s.register)("workspace-unspecified",60355),newLine:(0,s.register)("newline",60394),thumbsDownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.register)("thumbsup-filled",60436),gitFetch:(0,s.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.register)("debug-breakpoint-pending",60377)},e.Codicon={...d.codiconsLibrary,...e.codiconsDerived}}),define(_e[25],ye([1,0,18]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=d,e.deepFreeze=T,e.cloneAndChange=L,e.mixin=p,e.equals=a,e.safeStringify=I,e.distinct=_,e.getCaseInsensitive=c,e.filter=C,e.getAllPropertyNames=b,e.getAllMethodNames=l,e.createProxyObject=m,e.mapValues=h;function d(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([o,t])=>{n[o]=t&&typeof t=="object"?d(t):t}),n}function T(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const t in o)if(R.call(o,t)){const i=o[t];typeof i=="object"&&!Object.isFrozen(i)&&!(0,s.isTypedArray)(i)&&n.push(i)}}return g}const R=Object.prototype.hasOwnProperty;function L(g,n){return A(g,n,new Set)}function A(g,n,o){if((0,s.isUndefinedOrNull)(g))return g;const t=n(g);if(typeof t<"u")return t;if(Array.isArray(g)){const i=[];for(const r of g)i.push(A(r,n,o));return i}if((0,s.isObject)(g)){if(o.has(g))throw new Error("Cannot clone recursive data-structure");o.add(g);const i={};for(const r in g)R.call(g,r)&&(i[r]=A(g[r],n,o));return o.delete(g),i}return g}function p(g,n,o=!0){return(0,s.isObject)(g)?((0,s.isObject)(n)&&Object.keys(n).forEach(t=>{t in g?o&&((0,s.isObject)(g[t])&&(0,s.isObject)(n[t])?p(g[t],n[t],o):g[t]=n[t]):g[t]=n[t]}),g):n}function a(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let o,t;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(o=0;o<g.length;o++)if(!a(g[o],n[o]))return!1}else{const i=[];for(t in g)i.push(t);i.sort();const r=[];for(t in n)r.push(t);if(r.sort(),!a(i,r))return!1;for(o=0;o<i.length;o++)if(!a(g[i[o]],n[i[o]]))return!1}return!0}function I(g){const n=new Set;return JSON.stringify(g,(o,t)=>{if((0,s.isObject)(t)||Array.isArray(t)){if(n.has(t))return"[Circular]";n.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function _(g,n){const o=Object.create(null);return!g||!n||Object.keys(n).forEach(i=>{const r=g[i],f=n[i];a(r,f)||(o[i]=f)}),o}function c(g,n){const o=n.toLowerCase(),t=Object.keys(g).find(i=>i.toLowerCase()===o);return t?g[t]:g[n]}function C(g,n){const o=Object.create(null);for(const[t,i]of Object.entries(g))n(t,i)&&(o[t]=i);return o}function b(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}function l(g){const n=[];for(const o of b(g))typeof g[o]=="function"&&n.push(o);return n}function m(g,n){const o=i=>function(){const r=Array.prototype.slice.call(arguments,0);return n(i,r)},t={};for(const i of g)t[i]=o(i);return t}function h(g,n){const o={};for(const[t,i]of Object.entries(g))o[t]=n(i,t);return o}}),define(_e[50],ye([1,0,83]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=T;var d;(function(L){function A(p){return p&&typeof p=="object"&&typeof p.id=="string"}L.isThemeColor=A})(d||(e.ThemeColor=d={}));function T(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function p(g){const n=A.exec(g.id);if(!n)return p(s.Codicon.error);const[,o,t]=n,i=["codicon","codicon-"+o];return t&&i.push("codicon-modifier-"+t.substring(1)),i}L.asClassNameArray=p;function a(g){return p(g).join(" ")}L.asClassName=a;function I(g){return"."+p(g).join(".")}L.asCSSSelector=I;function _(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||d.isThemeColor(g.color))}L.isThemeIcon=_;const c=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function C(g){const n=c.exec(g);if(!n)return;const[,o]=n;return{id:o}}L.fromString=C;function b(g){return{id:g}}L.fromId=b;function l(g,n){let o=g.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),n&&(o=`${o}~${n}`),{id:o}}L.modify=l;function m(g){const n=g.id.lastIndexOf("~");if(n!==-1)return g.id.substring(n+1)}L.getModifier=m;function h(g,n){return g.id===n.id&&g.color?.id===n.color?.id}L.isEqual=h})(R||(e.ThemeIcon=R={}))}),define(_e[84],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=d,e.toUint32=T;var s;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(s||(e.Constants=s={}));function d(R){return R<0?0:R>s.MAX_UINT_8?s.MAX_UINT_8:R|0}function T(R){return R<0?0:R>s.MAX_UINT_32?s.MAX_UINT_32:R|0}}),define(_e[13],ye([1,0,183,27,49,84]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=p,e.format2=I,e.htmlAttributeEncodeValue=_,e.escape=c,e.escapeRegExpCharacters=C,e.count=b,e.truncate=l,e.truncateMiddle=m,e.trim=h,e.ltrim=g,e.rtrim=n,e.convertSimple2RegExpPattern=o,e.stripWildcards=t,e.createRegExp=i,e.regExpLeadsToEndlessLoop=r,e.splitLines=f,e.splitLinesIncludeSeparators=u,e.firstNonWhitespaceIndex=v,e.getLeadingWhitespace=y,e.lastNonWhitespaceIndex=D,e.replaceAsync=w,e.compare=P,e.compareSubstring=k,e.compareIgnoreCase=E,e.compareSubstringIgnoreCase=S,e.isAsciiDigit=M,e.isLowerAsciiLetter=N,e.isUpperAsciiLetter=O,e.equalsIgnoreCase=x,e.startsWithIgnoreCase=U,e.commonPrefixLength=F,e.commonSuffixLength=H,e.isHighSurrogate=j,e.isLowSurrogate=re,e.computeCodePoint=B,e.getNextCodePoint=V,e.nextCharLength=ne,e.prevCharLength=De,e.getCharContainingOffset=pe,e.charCount=G,e.containsRTL=ae,e.isBasicASCII=ce,e.containsUnusualLineTerminators=ue,e.isFullWidthCharacter=Y,e.isEmojiImprecise=oe,e.lcut=ve,e.forAnsiStringParts=Fe,e.removeAnsiEscapeCodes=We,e.removeAnsiEscapeCodesFromPrompt=Ie,e.startsWithUTF8BOM=Re,e.stripUTF8BOM=z,e.fuzzyContains=$,e.containsUppercaseCharacter=Q,e.uppercaseFirstLetter=Z,e.getNLines=fe,e.singleLetterHash=Ee,e.getGraphemeBreakType=Ne,e.getLeftDeleteOffset=ot;function L(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}const A=/{(\d+)}/g;function p(Te,...Ue){return Ue.length===0?Te:Te.replace(A,function(qe,Oe){const xe=parseInt(Oe,10);return isNaN(xe)||xe<0||xe>=Ue.length?qe:Ue[xe]})}const a=/{([^}]+)}/g;function I(Te,Ue){return Object.keys(Ue).length===0?Te:Te.replace(a,(qe,Oe)=>Ue[Oe]??qe)}function _(Te){return Te.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}function c(Te){return Te.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}function C(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Te,Ue){let qe=0,Oe=Te.indexOf(Ue);for(;Oe!==-1;)qe++,Oe=Te.indexOf(Ue,Oe+Ue.length);return qe}function l(Te,Ue,qe="\u2026"){return Te.length<=Ue?Te:`${Te.substr(0,Ue)}${qe}`}function m(Te,Ue,qe="\u2026"){if(Te.length<=Ue)return Te;const Oe=Math.ceil(Ue/2)-qe.length/2,xe=Math.floor(Ue/2)-qe.length/2;return`${Te.substr(0,Oe)}${qe}${Te.substr(Te.length-xe)}`}function h(Te,Ue=" "){const qe=g(Te,Ue);return n(qe,Ue)}function g(Te,Ue){if(!Te||!Ue)return Te;const qe=Ue.length;if(qe===0||Te.length===0)return Te;let Oe=0;for(;Te.indexOf(Ue,Oe)===Oe;)Oe=Oe+qe;return Te.substring(Oe)}function n(Te,Ue){if(!Te||!Ue)return Te;const qe=Ue.length,Oe=Te.length;if(qe===0||Oe===0)return Te;let xe=Oe,de=-1;for(;de=Te.lastIndexOf(Ue,xe-1),!(de===-1||de+qe!==xe);){if(de===0)return"";xe=de}return Te.substring(0,xe)}function o(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Te){return Te.replace(/\*/g,"")}function i(Te,Ue,qe={}){if(!Te)throw new Error("Cannot create regex from empty string");Ue||(Te=C(Te)),qe.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Oe="";return qe.global&&(Oe+="g"),qe.matchCase||(Oe+="i"),qe.multiline&&(Oe+="m"),qe.unicode&&(Oe+="u"),new RegExp(Te,Oe)}function r(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}function f(Te){return Te.split(/\r\n|\r|\n/)}function u(Te){const Ue=[],qe=Te.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(qe.length/2);Oe++)Ue.push(qe[2*Oe]+(qe[2*Oe+1]??""));return Ue}function v(Te){for(let Ue=0,qe=Te.length;Ue<qe;Ue++){const Oe=Te.charCodeAt(Ue);if(Oe!==d.CharCode.Space&&Oe!==d.CharCode.Tab)return Ue}return-1}function y(Te,Ue=0,qe=Te.length){for(let Oe=Ue;Oe<qe;Oe++){const xe=Te.charCodeAt(Oe);if(xe!==d.CharCode.Space&&xe!==d.CharCode.Tab)return Te.substring(Ue,Oe)}return Te.substring(Ue,qe)}function D(Te,Ue=Te.length-1){for(let qe=Ue;qe>=0;qe--){const Oe=Te.charCodeAt(qe);if(Oe!==d.CharCode.Space&&Oe!==d.CharCode.Tab)return qe}return-1}function w(Te,Ue,qe){const Oe=[];let xe=0;for(const de of Te.matchAll(Ue)){if(Oe.push(Te.slice(xe,de.index)),de.index===void 0)throw new Error("match.index should be defined");xe=de.index+de[0].length,Oe.push(qe(de[0],...de.slice(1),de.index,Te,de.groups))}return Oe.push(Te.slice(xe)),Promise.all(Oe).then(de=>de.join(""))}function P(Te,Ue){return Te<Ue?-1:Te>Ue?1:0}function k(Te,Ue,qe=0,Oe=Te.length,xe=0,de=Ue.length){for(;qe<Oe&&xe<de;qe++,xe++){const Qe=Te.charCodeAt(qe),et=Ue.charCodeAt(xe);if(Qe<et)return-1;if(Qe>et)return 1}const J=Oe-qe,Pe=de-xe;return J<Pe?-1:J>Pe?1:0}function E(Te,Ue){return S(Te,Ue,0,Te.length,0,Ue.length)}function S(Te,Ue,qe=0,Oe=Te.length,xe=0,de=Ue.length){for(;qe<Oe&&xe<de;qe++,xe++){let Qe=Te.charCodeAt(qe),et=Ue.charCodeAt(xe);if(Qe===et)continue;if(Qe>=128||et>=128)return k(Te.toLowerCase(),Ue.toLowerCase(),qe,Oe,xe,de);N(Qe)&&(Qe-=32),N(et)&&(et-=32);const ut=Qe-et;if(ut!==0)return ut}const J=Oe-qe,Pe=de-xe;return J<Pe?-1:J>Pe?1:0}function M(Te){return Te>=d.CharCode.Digit0&&Te<=d.CharCode.Digit9}function N(Te){return Te>=d.CharCode.a&&Te<=d.CharCode.z}function O(Te){return Te>=d.CharCode.A&&Te<=d.CharCode.Z}function x(Te,Ue){return Te.length===Ue.length&&S(Te,Ue)===0}function U(Te,Ue){const qe=Ue.length;return Ue.length>Te.length?!1:S(Te,Ue,0,qe)===0}function F(Te,Ue){const qe=Math.min(Te.length,Ue.length);let Oe;for(Oe=0;Oe<qe;Oe++)if(Te.charCodeAt(Oe)!==Ue.charCodeAt(Oe))return Oe;return qe}function H(Te,Ue){const qe=Math.min(Te.length,Ue.length);let Oe;const xe=Te.length-1,de=Ue.length-1;for(Oe=0;Oe<qe;Oe++)if(Te.charCodeAt(xe-Oe)!==Ue.charCodeAt(de-Oe))return Oe;return qe}function j(Te){return 55296<=Te&&Te<=56319}function re(Te){return 56320<=Te&&Te<=57343}function B(Te,Ue){return(Te-55296<<10)+(Ue-56320)+65536}function V(Te,Ue,qe){const Oe=Te.charCodeAt(qe);if(j(Oe)&&qe+1<Ue){const xe=Te.charCodeAt(qe+1);if(re(xe))return B(Oe,xe)}return Oe}function X(Te,Ue){const qe=Te.charCodeAt(Ue-1);if(re(qe)&&Ue>1){const Oe=Te.charCodeAt(Ue-2);if(j(Oe))return B(Oe,qe)}return qe}class ee{get offset(){return this._offset}constructor(Ue,qe=0){this._str=Ue,this._len=Ue.length,this._offset=qe}setOffset(Ue){this._offset=Ue}prevCodePoint(){const Ue=X(this._str,this._offset);return this._offset-=Ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}nextCodePoint(){const Ue=V(this._str,this._len,this._offset);return this._offset+=Ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}eol(){return this._offset>=this._len}}e.CodePointIterator=ee;class he{get offset(){return this._iterator.offset}constructor(Ue,qe=0){this._iterator=new ee(Ue,qe)}nextGraphemeLength(){const Ue=tt.getInstance(),qe=this._iterator,Oe=qe.offset;let xe=Ue.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const de=qe.offset,J=Ue.getGraphemeBreakType(qe.nextCodePoint());if(Ve(xe,J)){qe.setOffset(de);break}xe=J}return qe.offset-Oe}prevGraphemeLength(){const Ue=tt.getInstance(),qe=this._iterator,Oe=qe.offset;let xe=Ue.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const de=qe.offset,J=Ue.getGraphemeBreakType(qe.prevCodePoint());if(Ve(J,xe)){qe.setOffset(de);break}xe=J}return Oe-qe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=he;function ne(Te,Ue){return new he(Te,Ue).nextGraphemeLength()}function De(Te,Ue){return new he(Te,Ue).prevGraphemeLength()}function pe(Te,Ue){Ue>0&&re(Te.charCodeAt(Ue))&&Ue--;const qe=Ue+ne(Te,Ue);return[qe-De(Te,qe),qe]}function G(Te){const Ue=new he(Te);let qe=0;for(;!Ue.eol();)qe++,Ue.nextGraphemeLength();return qe}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Te){return W||(W=se()),W.test(Te)}const te=/^[\t\n\r\x20-\x7E]*$/;function ce(Te){return te.test(Te)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}function Y(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}function oe(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}function ve(Te,Ue,qe=""){const Oe=Te.trimStart();if(Oe.length<Ue)return Oe;const xe=/\b/g;let de=0;for(;xe.test(Oe)&&!(Oe.length-xe.lastIndex<Ue);)de=xe.lastIndex,xe.lastIndex+=1;return de===0?Oe:qe+Oe.substring(de).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Te){let Ue=0;for(const qe of Te.matchAll(be))Ue!==qe.index&&(yield{isCode:!1,str:Te.substring(Ue,qe.index)}),yield{isCode:!0,str:qe[0]},Ue=qe.index+qe[0].length;Ue!==Te.length&&(yield{isCode:!1,str:Te.substring(Ue)})}function We(Te){return Te&&(Te=Te.replace(be,"")),Te}const Ce=/\\\[.*?\\\]/g;function Ie(Te){return We(Te).replace(Ce,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(d.CharCode.UTF8_BOM);function Re(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===d.CharCode.UTF8_BOM)}function z(Te){return Re(Te)?Te.substr(1):Te}function $(Te,Ue){if(!Te||!Ue||Te.length<Ue.length)return!1;const qe=Ue.length,Oe=Te.toLowerCase();let xe=0,de=-1;for(;xe<qe;){const J=Oe.indexOf(Ue[xe],de+1);if(J<0)return!1;de=J,xe++}return!0}function Q(Te,Ue=!1){return Te?(Ue&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}function Z(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}function fe(Te,Ue=1){if(Ue===0)return"";let qe=-1;do qe=Te.indexOf(`
`,qe+1),Ue--;while(Ue>0&&qe>=0);return qe===-1?Te:(Te[qe-1]==="\r"&&qe--,Te.substr(0,qe))}function Ee(Te){const Ue=d.CharCode.Z-d.CharCode.A+1;return Te=Te%(2*Ue),Te<Ue?String.fromCharCode(d.CharCode.a+Te):String.fromCharCode(d.CharCode.A+Te-Ue)}function Ne(Te){return tt.getInstance().getGraphemeBreakType(Te)}function Ve(Te,Ue){return Te===je.Other?Ue!==je.Extend&&Ue!==je.SpacingMark:Te===je.CR&&Ue===je.LF?!1:Te===je.Control||Te===je.CR||Te===je.LF||Ue===je.Control||Ue===je.CR||Ue===je.LF?!0:!(Te===je.L&&(Ue===je.L||Ue===je.V||Ue===je.LV||Ue===je.LVT)||(Te===je.LV||Te===je.V)&&(Ue===je.V||Ue===je.T)||(Te===je.LVT||Te===je.T)&&Ue===je.T||Ue===je.Extend||Ue===je.ZWJ||Ue===je.SpacingMark||Te===je.Prepend||Te===je.ZWJ&&Ue===je.Extended_Pictographic||Te===je.Regional_Indicator&&Ue===je.Regional_Indicator)}var je;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class tt{static{this._INSTANCE=null}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}constructor(){this._data=rt()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===d.CharCode.LineFeed?je.LF:Ue===d.CharCode.CarriageReturn?je.CR:je.Control;if(Ue<127)return je.Other;const qe=this._data,Oe=qe.length/3;let xe=1;for(;xe<=Oe;)if(Ue<qe[3*xe])xe=2*xe;else if(Ue>qe[3*xe+1])xe=2*xe+1;else return qe[3*xe+2];return je.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Te,Ue){if(Te===0)return 0;const qe=nt(Te,Ue);if(qe!==void 0)return qe;const Oe=new ee(Ue,Te);return Oe.prevCodePoint(),Oe.offset}function nt(Te,Ue){const qe=new ee(Ue,Te);let Oe=qe.prevCodePoint();for(;at(Oe)||Oe===mt.emojiVariantSelector||Oe===mt.enclosingKeyCap;){if(qe.offset===0)return;Oe=qe.prevCodePoint()}if(!oe(Oe))return;let xe=qe.offset;return xe>0&&qe.prevCodePoint()===mt.zwj&&(xe=qe.offset),xe}function at(Te){return 127995<=Te&&Te<=127999}var mt;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.noBreakWhitespace="\xA0";class dt{static{this.ambiguousCharacterData=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new s.LRUCachedFunction({getCacheKey:JSON.stringify},Ue=>{function qe(ut){const gt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)gt.set(ut[Dt],ut[Dt+1]);return gt}function Oe(ut,gt){const Dt=new Map(ut);for(const[Ot,zt]of gt)Dt.set(Ot,zt);return Dt}function xe(ut,gt){if(!ut)return gt;const Dt=new Map;for(const[Ot,zt]of ut)gt.has(Ot)&&Dt.set(Ot,zt);return Dt}const de=this.ambiguousCharacterData.value;let J=Ue.filter(ut=>!ut.startsWith("_")&&ut in de);J.length===0&&(J=["_default"]);let Pe;for(const ut of J){const gt=qe(de[ut]);Pe=xe(Pe,gt)}const Qe=qe(de._common),et=Oe(Qe,Pe);return new dt(et)})}static getInstance(Ue){return dt.cache.get(Array.from(Ue))}static{this._locales=new T.Lazy(()=>Object.keys(dt.ambiguousCharacterData.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return dt._locales.value}constructor(Ue){this.confusableDictionary=Ue}isAmbiguous(Ue){return this.confusableDictionary.has(Ue)}containsAmbiguousCharacter(Ue){for(let qe=0;qe<Ue.length;qe++){const Oe=Ue.codePointAt(qe);if(typeof Oe=="number"&&this.isAmbiguous(Oe))return!0}return!1}getPrimaryConfusable(Ue){return this.confusableDictionary.get(Ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=dt;class lt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(lt.getRawData())),this._data}static isInvisibleCharacter(Ue){return lt.getData().has(Ue)}static containsInvisibleCharacter(Ue){for(let qe=0;qe<Ue.length;qe++){const Oe=Ue.codePointAt(qe);if(typeof Oe=="number"&&lt.isInvisibleCharacter(Oe))return!0}return!1}static get codePoints(){return lt.getData()}}e.InvisibleCharacters=lt}),define(_e[135],ye([1,0,27,29,178,13]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=L,e.matchesContiguousSubString=p,e.matchesSubString=a,e.isUpper=c,e.matchesCamelCase=D,e.matchesWords=w,e.matchesFuzzy=N,e.matchesFuzzy2=O,e.anyScore=x,e.createMatches=U,e.isPatternInWord=se,e.fuzzyScore=ue,e.fuzzyScoreGracefulAggressive=ve,e.fuzzyScoreGraceful=be,R=ze(R);function L(...Ce){return function(Ie,Re){for(let z=0,$=Ce.length;z<$;z++){const Q=Ce[z](Ie,Re);if(Q)return Q}return null}}e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(Ce,Ie,Re){if(!Re||Re.length<Ie.length)return null;let z;return Ce?z=R.startsWithIgnoreCase(Re,Ie):z=Re.indexOf(Ie)===0,z?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function p(Ce,Ie){const Re=Ie.toLowerCase().indexOf(Ce.toLowerCase());return Re===-1?null:[{start:Re,end:Re+Ce.length}]}function a(Ce,Ie){return I(Ce.toLowerCase(),Ie.toLowerCase(),0,0)}function I(Ce,Ie,Re,z){if(Re===Ce.length)return[];if(z===Ie.length)return null;if(Ce[Re]===Ie[z]){let $=null;return($=I(Ce,Ie,Re+1,z+1))?t({start:z,end:z+1},$):null}return I(Ce,Ie,Re,z+1)}function _(Ce){return s.CharCode.a<=Ce&&Ce<=s.CharCode.z}function c(Ce){return s.CharCode.A<=Ce&&Ce<=s.CharCode.Z}function C(Ce){return s.CharCode.Digit0<=Ce&&Ce<=s.CharCode.Digit9}function b(Ce){return Ce===s.CharCode.Space||Ce===s.CharCode.Tab||Ce===s.CharCode.LineFeed||Ce===s.CharCode.CarriageReturn}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ce=>l.add(Ce.charCodeAt(0)));function m(Ce){return b(Ce)||l.has(Ce)}function h(Ce,Ie){return Ce===Ie||m(Ce)&&m(Ie)}const g=new Map;function n(Ce){if(g.has(Ce))return g.get(Ce);let Ie;const Re=(0,T.getKoreanAltChars)(Ce);return Re&&(Ie=Re),g.set(Ce,Ie),Ie}function o(Ce){return _(Ce)||c(Ce)||C(Ce)}function t(Ce,Ie){return Ie.length===0?Ie=[Ce]:Ce.end===Ie[0].start?Ie[0].start=Ce.start:Ie.unshift(Ce),Ie}function i(Ce,Ie){for(let Re=Ie;Re<Ce.length;Re++){const z=Ce.charCodeAt(Re);if(c(z)||C(z)||Re>0&&!o(Ce.charCodeAt(Re-1)))return Re}return Ce.length}function r(Ce,Ie,Re,z){if(Re===Ce.length)return[];if(z===Ie.length)return null;if(Ce[Re]!==Ie[z].toLowerCase())return null;{let $=null,Q=z+1;for($=r(Ce,Ie,Re+1,z+1);!$&&(Q=i(Ie,Q))<Ie.length;)$=r(Ce,Ie,Re+1,Q),Q++;return $===null?null:t({start:z,end:z+1},$)}}function f(Ce){let Ie=0,Re=0,z=0,$=0,Q=0;for(let Ve=0;Ve<Ce.length;Ve++)Q=Ce.charCodeAt(Ve),c(Q)&&Ie++,_(Q)&&Re++,o(Q)&&z++,C(Q)&&$++;const Z=Ie/Ce.length,fe=Re/Ce.length,Ee=z/Ce.length,Ne=$/Ce.length;return{upperPercent:Z,lowerPercent:fe,alphaPercent:Ee,numericPercent:Ne}}function u(Ce){const{upperPercent:Ie,lowerPercent:Re}=Ce;return Re===0&&Ie>.6}function v(Ce){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:z,numericPercent:$}=Ce;return Re>.2&&Ie<.8&&z>.6&&$<.2}function y(Ce){let Ie=0,Re=0,z=0,$=0;for(let Q=0;Q<Ce.length;Q++)z=Ce.charCodeAt(Q),c(z)&&Ie++,_(z)&&Re++,b(z)&&$++;return(Ie===0||Re===0)&&$===0?Ce.length<=30:Ie<=5}function D(Ce,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!y(Ce))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Re=f(Ie);if(!v(Re)){if(!u(Re))return null;Ie=Ie.toLowerCase()}let z=null,$=0;for(Ce=Ce.toLowerCase();$<Ie.length&&(z=r(Ce,Ie,0,$))===null;)$=i(Ie,$+1);return z}function w(Ce,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let z=null,$=0;for(Ce=Ce.toLowerCase(),Ie=Ie.toLowerCase();$<Ie.length&&(z=P(Ce,Ie,0,$,Re),z===null);)$=k(Ie,$+1);return z}function P(Ce,Ie,Re,z,$){let Q=0;if(Re===Ce.length)return[];if(z===Ie.length)return null;if(!h(Ce.charCodeAt(Re),Ie.charCodeAt(z))){const Ee=n(Ce.charCodeAt(Re));if(!Ee)return null;for(let Ne=0;Ne<Ee.length;Ne++)if(!h(Ee[Ne],Ie.charCodeAt(z+Ne)))return null;Q+=Ee.length-1}let Z=null,fe=z+Q+1;if(Z=P(Ce,Ie,Re+1,fe,$),!$)for(;!Z&&(fe=k(Ie,fe))<Ie.length;)Z=P(Ce,Ie,Re+1,fe,$),fe++;if(!Z)return null;if(Ce.charCodeAt(Re)!==Ie.charCodeAt(z)){const Ee=n(Ce.charCodeAt(Re));if(!Ee)return Z;for(let Ne=0;Ne<Ee.length;Ne++)if(Ee[Ne]!==Ie.charCodeAt(z+Ne))return Z}return t({start:z,end:z+Q+1},Z)}function k(Ce,Ie){for(let Re=Ie;Re<Ce.length;Re++)if(m(Ce.charCodeAt(Re))||Re>0&&m(Ce.charCodeAt(Re-1)))return Re;return Ce.length}const E=L(e.matchesPrefix,D,p),S=L(e.matchesPrefix,D,a),M=new d.LRUCache(1e4);function N(Ce,Ie,Re=!1){if(typeof Ce!="string"||typeof Ie!="string")return null;let z=M.get(Ce);z||(z=new RegExp(R.convertSimple2RegExpPattern(Ce),"i"),M.set(Ce,z));const $=z.exec(Ie);return $?[{start:$.index,end:$.index+$[0].length}]:Re?S(Ce,Ie):E(Ce,Ie)}function O(Ce,Ie){const Re=ue(Ce,Ce.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?U(Re):null}function x(Ce,Ie,Re,z,$,Q){const Z=Math.min(13,Ce.length);for(;Re<Z;Re++){const fe=ue(Ce,Ie,Re,z,$,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Q]}function U(Ce){if(typeof Ce>"u")return[];const Ie=[],Re=Ce[1];for(let z=Ce.length-1;z>1;z--){const $=Ce[z]+Re,Q=Ie[Ie.length-1];Q&&Q.end===$?Q.end=$+1:Ie.push({start:$,end:$+1})}return Ie}const F=128;function H(){const Ce=[],Ie=[];for(let Re=0;Re<=F;Re++)Ie[Re]=0;for(let Re=0;Re<=F;Re++)Ce.push(Ie.slice(0));return Ce}function j(Ce){const Ie=[];for(let Re=0;Re<=Ce;Re++)Ie[Re]=0;return Ie}const re=j(2*F),B=j(2*F),V=H(),X=H(),ee=H(),he=!1;function ne(Ce,Ie,Re,z,$){function Q(fe,Ee,Ne=" "){for(;fe.length<Ee;)fe=Ne+fe;return fe}let Z=` |   |${z.split("").map(fe=>Q(fe,3)).join("|")}
`;for(let fe=0;fe<=Re;fe++)fe===0?Z+=" |":Z+=`${Ie[fe-1]}|`,Z+=Ce[fe].slice(0,$+1).map(Ee=>Q(Ee.toString(),3)).join("|")+`
`;return Z}function De(Ce,Ie,Re,z){Ce=Ce.substr(Ie),Re=Re.substr(z),console.log(ne(X,Ce,Ce.length,Re,Re.length)),console.log(ne(ee,Ce,Ce.length,Re,Re.length)),console.log(ne(V,Ce,Ce.length,Re,Re.length))}function pe(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;const Re=Ce.codePointAt(Ie);switch(Re){case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.Slash:case s.CharCode.Backslash:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:case s.CharCode.DollarSign:case s.CharCode.LessThan:case s.CharCode.GreaterThan:case s.CharCode.OpenParen:case s.CharCode.CloseParen:case s.CharCode.OpenSquareBracket:case s.CharCode.CloseSquareBracket:case s.CharCode.OpenCurlyBrace:case s.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Re)}}function G(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;switch(Ce.charCodeAt(Ie)){case s.CharCode.Space:case s.CharCode.Tab:return!0;default:return!1}}function W(Ce,Ie,Re){return Ie[Ce]!==Re[Ce]}function se(Ce,Ie,Re,z,$,Q,Z=!1){for(;Ie<Re&&$<Q;)Ce[Ie]===z[$]&&(Z&&(re[Ie]=$),Ie+=1),$+=1;return Ie===Re}var ae;(function(Ce){Ce[Ce.Diag=1]="Diag",Ce[Ce.Left=2]="Left",Ce[Ce.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var te;(function(Ce){Ce.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}Ce.isDefault=Ie})(te||(e.FuzzyScore=te={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Re){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Re}}e.FuzzyScoreOptions=ce;function ue(Ce,Ie,Re,z,$,Q,Z=ce.default){const fe=Ce.length>F?F:Ce.length,Ee=z.length>F?F:z.length;if(Re>=fe||Q>=Ee||fe-Re>Ee-Q||!se(Ie,Re,fe,$,Q,Ee,!0))return;Y(fe,Ee,Re,Q,Ie,$);let Ne=1,Ve=1,je=Re,tt=Q;const rt=[!1];for(Ne=1,je=Re;je<fe;Ne++,je++){const dt=re[je],lt=B[je],Te=je+1<fe?B[je+1]:Ee;for(Ve=dt-Q+1,tt=dt;tt<Te;Ve++,tt++){let Ue=Number.MIN_SAFE_INTEGER,qe=!1;tt<=lt&&(Ue=oe(Ce,Ie,je,Re,z,$,tt,Ee,Q,V[Ne-1][Ve-1]===0,rt));let Oe=0;Ue!==Number.MAX_SAFE_INTEGER&&(qe=!0,Oe=Ue+X[Ne-1][Ve-1]);const xe=tt>dt,de=xe?X[Ne][Ve-1]+(V[Ne][Ve-1]>0?-5:0):0,J=tt>dt+1&&V[Ne][Ve-1]>0,Pe=J?X[Ne][Ve-2]+(V[Ne][Ve-2]>0?-5:0):0;if(J&&(!xe||Pe>=de)&&(!qe||Pe>=Oe))X[Ne][Ve]=Pe,ee[Ne][Ve]=ae.LeftLeft,V[Ne][Ve]=0;else if(xe&&(!qe||de>=Oe))X[Ne][Ve]=de,ee[Ne][Ve]=ae.Left,V[Ne][Ve]=0;else if(qe)X[Ne][Ve]=Oe,ee[Ne][Ve]=ae.Diag,V[Ne][Ve]=V[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(he&&De(Ce,Re,z,Q),!rt[0]&&!Z.firstMatchCanBeWeak)return;Ne--,Ve--;const ot=[X[Ne][Ve],Q];let nt=0,at=0;for(;Ne>=1;){let dt=Ve;do{const lt=ee[Ne][dt];if(lt===ae.LeftLeft)dt=dt-2;else if(lt===ae.Left)dt=dt-1;else break}while(dt>=1);nt>1&&Ie[Re+Ne-1]===$[Q+Ve-1]&&!W(dt+Q-1,z,$)&&nt+1>V[Ne][dt]&&(dt=Ve),dt===Ve?nt++:nt=1,at||(at=dt),Ne--,Ve=dt-1,ot.push(Ve)}Ee-Q===fe&&Z.boostFullMatch&&(ot[0]+=2);const mt=at-fe;return ot[0]-=mt,ot}function Y(Ce,Ie,Re,z,$,Q){let Z=Ce-1,fe=Ie-1;for(;Z>=Re&&fe>=z;)$[Z]===Q[fe]&&(B[Z]=fe,Z--),fe--}function oe(Ce,Ie,Re,z,$,Q,Z,fe,Ee,Ne,Ve){if(Ie[Re]!==Q[Z])return Number.MIN_SAFE_INTEGER;let je=1,tt=!1;return Z===Re-z?je=Ce[Re]===$[Z]?7:5:W(Z,$,Q)&&(Z===0||!W(Z-1,$,Q))?(je=Ce[Re]===$[Z]?7:5,tt=!0):pe(Q,Z)&&(Z===0||!pe(Q,Z-1))?je=5:(pe(Q,Z-1)||G(Q,Z-1))&&(je=5,tt=!0),je>1&&Re===z&&(Ve[0]=!0),tt||(tt=W(Z,$,Q)||pe(Q,Z-1)||G(Q,Z-1)),Re===z?Z>Ee&&(je-=tt?3:5):Ne?je+=tt?2:0:je+=tt?0:1,Z+1===fe&&(je-=tt?3:5),je}function ve(Ce,Ie,Re,z,$,Q,Z){return Fe(Ce,Ie,Re,z,$,Q,!0,Z)}function be(Ce,Ie,Re,z,$,Q,Z){return Fe(Ce,Ie,Re,z,$,Q,!1,Z)}function Fe(Ce,Ie,Re,z,$,Q,Z,fe){let Ee=ue(Ce,Ie,Re,z,$,Q,fe);if(Ee&&!Z)return Ee;if(Ce.length>=3){const Ne=Math.min(7,Ce.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const je=We(Ce,Ve);if(je){const tt=ue(je,je.toLowerCase(),Re,z,$,Q,fe);tt&&(tt[0]-=3,(!Ee||tt[0]>Ee[0])&&(Ee=tt))}}}return Ee}function We(Ce,Ie){if(Ie+1>=Ce.length)return;const Re=Ce[Ie],z=Ce[Ie+1];if(Re!==z)return Ce.slice(0,Ie)+z+Re+Ce.slice(Ie+2)}}),define(_e[60],ye([1,0,13]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=d,e.doHash=T,e.numberHash=R,e.stringHash=A,e.toHexString=l,s=ze(s);function d(h){return T(h,0)}function T(h,g){switch(typeof h){case"object":return h===null?R(349,g):Array.isArray(h)?p(h,g):a(h,g);case"string":return A(h,g);case"boolean":return L(h,g);case"number":return R(h,g);case"undefined":return R(937,g);default:return R(617,g)}}function R(h,g){return(g<<5)-g+h|0}function L(h,g){return R(h?433:863,g)}function A(h,g){g=R(149417,g);for(let n=0,o=h.length;n<o;n++)g=R(h.charCodeAt(n),g);return g}function p(h,g){return g=R(104579,g),h.reduce((n,o)=>T(o,n),g)}function a(h,g){return g=R(181387,g),Object.keys(h).sort().reduce((n,o)=>(n=A(o,n),T(h[o],n)),g)}class I{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=T(g,this._value),this._value}}e.Hasher=I;var _;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function c(h,g,n=32){const o=n-g,t=~((1<<o)-1);return(h<<g|(t&h)>>>o)>>>0}function C(h,g=0,n=h.byteLength,o=0){for(let t=0;t<n;t++)h[g+t]=o}function b(h,g,n="0"){for(;h.length<g;)h=n+h;return h}function l(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(n=>n.toString(16).padStart(2,"0")).join(""):b((h>>>0).toString(16),g/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const n=g.length;if(n===0)return;const o=this._buff;let t=this._buffLen,i=this._leftoverHighSurrogate,r,f;for(i!==0?(r=i,f=-1,i=0):(r=g.charCodeAt(0),f=0);;){let u=r;if(s.isHighSurrogate(r))if(f+1<n){const v=g.charCodeAt(f+1);s.isLowSurrogate(v)?(f++,u=s.computeCodePoint(r,v)):u=_.UNICODE_REPLACEMENT}else{i=r;break}else s.isLowSurrogate(r)&&(u=_.UNICODE_REPLACEMENT);if(t=this._push(o,t,u),f++,f<n)r=g.charCodeAt(f);else break}this._buffLen=t,this._leftoverHighSurrogate=i}_push(g,n,o){return o<128?g[n++]=o:o<2048?(g[n++]=192|(o&1984)>>>6,g[n++]=128|(o&63)>>>0):o<65536?(g[n++]=224|(o&61440)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0):(g[n++]=240|(o&1835008)>>>18,g[n++]=128|(o&258048)>>>12,g[n++]=128|(o&4032)>>>6,g[n++]=128|(o&63)>>>0),n>=_.BLOCK_SIZE&&(this._step(),n-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,g[0]=g[_.BLOCK_SIZE+0],g[1]=g[_.BLOCK_SIZE+1],g[2]=g[_.BLOCK_SIZE+2]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=m._bigBlock32,n=this._buffDV;for(let D=0;D<64;D+=4)g.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)g.setUint32(D,c(g.getUint32(D-12,!1)^g.getUint32(D-32,!1)^g.getUint32(D-56,!1)^g.getUint32(D-64,!1),1),!1);let o=this._h0,t=this._h1,i=this._h2,r=this._h3,f=this._h4,u,v,y;for(let D=0;D<80;D++)D<20?(u=t&i|~t&r,v=1518500249):D<40?(u=t^i^r,v=1859775393):D<60?(u=t&i|t&r|i&r,v=2400959708):(u=t^i^r,v=3395469782),y=c(o,5)+u+f+v+g.getUint32(D*4,!1)&4294967295,f=r,r=i,i=c(t,30),t=o,o=y;this._h0=this._h0+o&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+f&4294967295}}e.StringSHA1=m}),define(_e[136],ye([1,0,135,13,50]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=p,e.markdownEscapeEscapedIcons=I,e.stripIcons=c,e.getCodiconAriaLabel=C,e.parseLabelWithIcons=l,e.matchesFuzzyIconAware=m;const R="$(",L=new RegExp(`\\$\\(${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${L.source}`,"g");function p(h){return h.replace(A,(g,n)=>n?g:`\\${g}`)}const a=new RegExp(`\\\\${L.source}`,"g");function I(h){return h.replace(a,g=>`\\${g}`)}const _=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function c(h){return h.indexOf(R)===-1?h:h.replace(_,(g,n,o,t)=>o?g:n||t||"")}function C(h){return h?h.replace(/\$\((.*?)\)/g,(g,n)=>` ${n} `).trim():""}const b=new RegExp(`\\$\\(${T.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(h){b.lastIndex=0;let g="";const n=[];let o=0;for(;;){const t=b.lastIndex,i=b.exec(h),r=h.substring(t,i?.index);if(r.length>0){g+=r;for(let f=0;f<r.length;f++)n.push(o)}if(!i)break;o+=i[0].length}return{text:g,iconOffsets:n}}function m(h,g,n=!1){const{text:o,iconOffsets:t}=g;if(!t||t.length===0)return(0,s.matchesFuzzy)(h,o,n);const i=(0,d.ltrim)(o," "),r=o.length-i.length,f=(0,s.matchesFuzzy)(h,i,n);if(f)for(const u of f){const v=t[u.start+r]+r;u.start+=v,u.end+=v}return f}}),define(_e[44],ye([1,0,13]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=ze(s);var d;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(d||(d={})),function(T){const R="error",L="warning",A="warn",p="info",a="ignore";function I(c){return c?s.equalsIgnoreCase(R,c)?T.Error:s.equalsIgnoreCase(L,c)||s.equalsIgnoreCase(A,c)?T.Warning:s.equalsIgnoreCase(p,c)?T.Info:T.Ignore:T.Ignore}T.fromValue=I;function _(c){switch(c){case T.Error:return R;case T.Warning:return L;case T.Info:return p;default:return a}}T.toString=_}(d||(d={})),e.default=d}),define(_e[85],ye([1,0,19,27,13]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(b){return this._value=b,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(b){const l=b.charCodeAt(0),m=this._value.charCodeAt(this._pos);return l-m}value(){return this._value[this._pos]}}e.StringIterator=R;class L{constructor(b=!0){this._caseSensitive=b}reset(b){return this._value=b,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let b=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===d.CharCode.Period)if(b)this._from++;else break;else b=!1;return this}cmp(b){return this._caseSensitive?(0,T.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class A{constructor(b=!0,l=!0){this._splitOnBackslash=b,this._caseSensitive=l}reset(b){this._from=0,this._to=0,this._value=b,this._valueLen=b.length;for(let l=b.length-1;l>=0;l--,this._valueLen--){const m=this._value.charCodeAt(l);if(!(m===d.CharCode.Slash||this._splitOnBackslash&&m===d.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let b=!0;for(;this._to<this._valueLen;this._to++){const l=this._value.charCodeAt(this._to);if(l===d.CharCode.Slash||this._splitOnBackslash&&l===d.CharCode.Backslash)if(b)this._from++;else break;else b=!1}return this}cmp(b){return this._caseSensitive?(0,T.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var p;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(b,l){this._ignorePathCasing=b,this._ignoreQueryAndFragment=l,this._states=[],this._stateIdx=0}reset(b){return this._value=b,this._states=[],this._value.scheme&&this._states.push(p.Scheme),this._value.authority&&this._states.push(p.Authority),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(b)),this._pathIterator.reset(b.path),this._pathIterator.value()&&this._states.push(p.Path)),this._ignoreQueryAndFragment(b)||(this._value.query&&this._states.push(p.Query),this._value.fragment&&this._states.push(p.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===p.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===p.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(b){if(this._states[this._stateIdx]===p.Scheme)return(0,T.compareIgnoreCase)(b,this._value.scheme);if(this._states[this._stateIdx]===p.Authority)return(0,T.compareIgnoreCase)(b,this._value.authority);if(this._states[this._stateIdx]===p.Path)return this._pathIterator.cmp(b);if(this._states[this._stateIdx]===p.Query)return(0,T.compare)(b,this._value.query);if(this._states[this._stateIdx]===p.Fragment)return(0,T.compare)(b,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===p.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===p.Authority)return this._value.authority;if(this._states[this._stateIdx]===p.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===p.Query)return this._value.query;if(this._states[this._stateIdx]===p.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=a;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(_||(_={}));class c{static forUris(b=()=>!1,l=()=>!1){return new c(new a(b,l))}static forPaths(b=!1){return new c(new A(void 0,!b))}static forStrings(){return new c(new R)}static forConfigKeys(){return new c(new L)}constructor(b){this._iter=b}clear(){this._root=void 0}fill(b,l){if(l){const m=l.slice(0);(0,s.shuffle)(m);for(const h of m)this.set(h,b)}else{const m=b.slice(0);(0,s.shuffle)(m);for(const h of m)this.set(h[0],h[1])}}set(b,l){const m=this._iter.reset(b);let h;this._root||(this._root=new I,this._root.segment=m.value());const g=[];for(h=this._root;;){const o=m.cmp(h.segment);if(o>0)h.left||(h.left=new I,h.left.segment=m.value()),g.push([_.Left,h]),h=h.left;else if(o<0)h.right||(h.right=new I,h.right.segment=m.value()),g.push([_.Right,h]),h=h.right;else if(m.hasNext())m.next(),h.mid||(h.mid=new I,h.mid.segment=m.value()),g.push([_.Mid,h]),h=h.mid;else break}const n=h.value;h.value=l,h.key=b;for(let o=g.length-1;o>=0;o--){const t=g[o][1];t.updateHeight();const i=t.balanceFactor();if(i<-1||i>1){const r=g[o][0],f=g[o+1][0];if(r===_.Right&&f===_.Right)g[o][1]=t.rotateLeft();else if(r===_.Left&&f===_.Left)g[o][1]=t.rotateRight();else if(r===_.Right&&f===_.Left)t.right=g[o+1][1]=g[o+1][1].rotateRight(),g[o][1]=t.rotateLeft();else if(r===_.Left&&f===_.Right)t.left=g[o+1][1]=g[o+1][1].rotateLeft(),g[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(g[o-1][0]){case _.Left:g[o-1][1].left=g[o][1];break;case _.Right:g[o-1][1].right=g[o][1];break;case _.Mid:g[o-1][1].mid=g[o][1];break}else this._root=g[0][1]}}return n}get(b){return this._getNode(b)?.value}_getNode(b){const l=this._iter.reset(b);let m=this._root;for(;m;){const h=l.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else break}return m}has(b){const l=this._getNode(b);return!(l?.value===void 0&&l?.mid===void 0)}delete(b){return this._delete(b,!1)}deleteSuperstr(b){return this._delete(b,!0)}_delete(b,l){const m=this._iter.reset(b),h=[];let g=this._root;for(;g;){const n=m.cmp(g.segment);if(n>0)h.push([_.Left,g]),g=g.left;else if(n<0)h.push([_.Right,g]),g=g.right;else if(m.hasNext())m.next(),h.push([_.Mid,g]),g=g.mid;else break}if(g){if(l?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this._min(g.right);if(n.key){const{key:o,value:t,segment:i}=n;this._delete(n.key,!1),g.key=o,g.value=t,g.segment=i}}else{const n=g.left??g.right;if(h.length>0){const[o,t]=h[h.length-1];switch(o){case _.Left:t.left=n;break;case _.Mid:t.mid=n;break;case _.Right:t.right=n;break}}else this._root=n}for(let n=h.length-1;n>=0;n--){const o=h[n][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),h[n][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),h[n][1]=o.rotateRight()),n>0)switch(h[n-1][0]){case _.Left:h[n-1][1].left=h[n][1];break;case _.Right:h[n-1][1].right=h[n][1];break;case _.Mid:h[n-1][1].mid=h[n][1];break}else this._root=h[0][1]}}}_min(b){for(;b.left;)b=b.left;return b}findSubstr(b){const l=this._iter.reset(b);let m=this._root,h;for(;m;){const g=l.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(l.hasNext())l.next(),h=m.value||h,m=m.mid;else break}return m&&m.value||h}findSuperstr(b){return this._findSuperstrOrElement(b,!1)}_findSuperstrOrElement(b,l){const m=this._iter.reset(b);let h=this._root;for(;h;){const g=m.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else return h.mid?this._entries(h.mid):l?h.value:void 0}}hasElementOrSubtree(b){return this._findSuperstrOrElement(b,!0)!==void 0}forEach(b){for(const[l,m]of this)b(m,l)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(b){const l=[];return this._dfsEntries(b,l),l[Symbol.iterator]()}_dfsEntries(b,l){b&&(b.left&&this._dfsEntries(b.left,l),b.value&&l.push([b.key,b.value]),b.mid&&this._dfsEntries(b.mid,l),b.right&&this._dfsEntries(b.right,l))}_isBalanced(){const b=l=>{if(!l)return!0;const m=l.balanceFactor();return m<-1||m>1?!1:b(l.left)&&b(l.right)};return b(this._root)}}e.TernarySearchTree=c}),define(_e[32],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=d;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function d(T){return s.test(T)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let p=0;p<A.length;p++)A[p]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),L=[];for(let A=0;A<256;A++)L.push(A.toString(16).padStart(2,"0"));return function(){T(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,a="";return a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a+="-",a+=L[R[p++]],a+=L[R[p++]],a+="-",a+=L[R[p++]],a+=L[R[p++]],a+="-",a+=L[R[p++]],a+=L[R[p++]],a+="-",a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a+=L[R[p++]],a}}()}),define(_e[187],ye([1,0,19,40,32]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=R,e.createFileDataTransferItem=L,e.matchesMimeType=a;function R(_){return{asString:async()=>_,asFile:()=>{},value:typeof _=="string"?_:void 0}}function L(_,c,C){const b={id:(0,T.generateUuid)(),name:_,uri:c,data:C};return{asString:async()=>"",asFile:()=>b,value:void 0}}class A{constructor(){this._entries=new Map}get size(){let c=0;for(const C of this._entries)c++;return c}has(c){return this._entries.has(this.toKey(c))}matches(c){const C=[...this._entries.keys()];return d.Iterable.some(this,([b,l])=>l.asFile())&&C.push("files"),I(p(c),C)}get(c){return this._entries.get(this.toKey(c))?.[0]}append(c,C){const b=this._entries.get(c);b?b.push(C):this._entries.set(this.toKey(c),[C])}replace(c,C){this._entries.set(this.toKey(c),[C])}delete(c){this._entries.delete(this.toKey(c))}*[Symbol.iterator](){for(const[c,C]of this._entries)for(const b of C)yield[c,b]}toKey(c){return p(c)}}e.VSDataTransfer=A;function p(_){return _.toLowerCase()}function a(_,c){return I(p(_),c.map(p))}function I(_,c){if(_==="*/*")return c.length>0;if(c.includes(_))return!0;const C=_.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[b,l,m]=C;return m==="*"?c.some(h=>h.startsWith(l+"/")):!1}e.UriList=Object.freeze({create:_=>(0,s.distinct)(_.map(c=>c.toString())).join(`\r
`),split:_=>_.split(`\r
`),parse:_=>e.UriList.split(_).filter(c=>!c.startsWith("#"))})}),define(_e[188],ye([1,0,67]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=d,e.findFreePortFaster=R,s=ze(s);function d(A,p,a,I=1){let _=!1;return new Promise(c=>{const C=setTimeout(()=>{if(!_)return _=!0,c(0)},a);T(A,p,I,b=>{if(!_)return _=!0,clearTimeout(C),c(b)})})}function T(A,p,a,I){if(p===0)return I(0);const _=new s.Socket;_.once("connect",()=>(L(_),T(A+a,p-1,a,I))),_.once("data",()=>{}),_.once("error",c=>(L(_),c.code!=="ECONNREFUSED"?T(A+a,p-1,a,I):I(A))),_.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(A,p,a,I="127.0.0.1"){let _=!1,c,C=1;const b=s.createServer({pauseOnConnect:!0});function l(m,h){_||(_=!0,b.removeAllListeners(),b.close(),c&&clearTimeout(c),h(m))}return new Promise(m=>{c=setTimeout(()=>{l(0,m)},a),b.on("listening",()=>{l(A,m)}),b.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&C<p?(A++,C++,b.listen(A,I)):l(0,m)}),b.on("close",()=>{l(0,m)}),b.listen(A,I)})}function L(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(p){console.error(p)}}}),define(_e[137],ye([1,0,84]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class d{constructor(A){const p=(0,s.toUint8)(A);this._defaultValue=p,this._asciiMap=d._createAsciiMap(p),this._map=new Map}static _createAsciiMap(A){const p=new Uint8Array(256);return p.fill(A),p}set(A,p){const a=(0,s.toUint8)(p);A>=0&&A<256?this._asciiMap[A]=a:this._map.set(A,a)}get(A){return A>=0&&A<256?this._asciiMap[A]:this._map.get(A)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=d;var T;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(T||(T={}));class R{constructor(){this._actual=new d(T.False)}add(A){this._actual.set(A,T.True)}has(A){return this._actual.get(A)===T.True}clear(){return this._actual.clear()}}e.CharacterSet=R}),define(_e[189],ye([1,0,27]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=T;var d;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function T(R){let L=0,A=0,p=0,a=d.Unknown;for(let I=0,_=R.length;I<_;I++){const c=R.charCodeAt(I);c===s.CharCode.CarriageReturn?(L===0&&(A=I),L++,I+1<_&&R.charCodeAt(I+1)===s.CharCode.LineFeed?(a|=d.CRLF,I++):a|=d.Invalid,p=I+1):c===s.CharCode.LineFeed&&(a|=d.LF,L===0&&(A=I),L++,p=I+1)}return L===0&&(A=R.length),[L,A,R.length-p,a]}}),define(_e[54],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class s{constructor(T,R){this.lineNumber=T,this.column=R}with(T=this.lineNumber,R=this.column){return T===this.lineNumber&&R===this.column?this:new s(T,R)}delta(T=0,R=0){return this.with(this.lineNumber+T,this.column+R)}equals(T){return s.equals(this,T)}static equals(T,R){return!T&&!R?!0:!!T&&!!R&&T.lineNumber===R.lineNumber&&T.column===R.column}isBefore(T){return s.isBefore(this,T)}static isBefore(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<R.column}isBeforeOrEqual(T){return s.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<=R.column}static compare(T,R){const L=T.lineNumber|0,A=R.lineNumber|0;if(L===A){const p=T.column|0,a=R.column|0;return p-a}return L-A}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new s(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=s}),define(_e[31],ye([1,0,54]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class d{constructor(R,L,A,p){R>A||R===A&&L>p?(this.startLineNumber=A,this.startColumn=p,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=A,this.endColumn=p)}isEmpty(){return d.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return d.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return d.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return d.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return d.plusRange(this,R)}static plusRange(R,L){let A,p,a,I;return L.startLineNumber<R.startLineNumber?(A=L.startLineNumber,p=L.startColumn):L.startLineNumber===R.startLineNumber?(A=L.startLineNumber,p=Math.min(L.startColumn,R.startColumn)):(A=R.startLineNumber,p=R.startColumn),L.endLineNumber>R.endLineNumber?(a=L.endLineNumber,I=L.endColumn):L.endLineNumber===R.endLineNumber?(a=L.endLineNumber,I=Math.max(L.endColumn,R.endColumn)):(a=R.endLineNumber,I=R.endColumn),new d(A,p,a,I)}intersectRanges(R){return d.intersectRanges(this,R)}static intersectRanges(R,L){let A=R.startLineNumber,p=R.startColumn,a=R.endLineNumber,I=R.endColumn;const _=L.startLineNumber,c=L.startColumn,C=L.endLineNumber,b=L.endColumn;return A<_?(A=_,p=c):A===_&&(p=Math.max(p,c)),a>C?(a=C,I=b):a===C&&(I=Math.min(I,b)),A>a||A===a&&p>I?null:new d(A,p,a,I)}equalsRange(R){return d.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return d.getEndPosition(this)}static getEndPosition(R){return new s.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return d.getStartPosition(this)}static getStartPosition(R){return new s.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new d(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new d(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return d.collapseToStart(this)}static collapseToStart(R){return new d(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return d.collapseToEnd(this)}static collapseToEnd(R){return new d(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new d(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new d(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new d(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const a=R.startLineNumber|0,I=L.startLineNumber|0;if(a===I){const _=R.startColumn|0,c=L.startColumn|0;if(_===c){const C=R.endLineNumber|0,b=L.endLineNumber|0;if(C===b){const l=R.endColumn|0,m=L.endColumn|0;return l-m}return C-b}return _-c}return a-I}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=d}),define(_e[190],ye([1,0,31]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class d{static insert(R,L){return{range:new s.Range(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.EditOperation=d}),define(_e[191],ye([1,0,54,31]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(T||(e.SelectionDirection=T={}));class R extends d.Range{constructor(A,p,a,I){super(A,p,a,I),this.selectionStartLineNumber=A,this.selectionStartColumn=p,this.positionLineNumber=a,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,p){return A.selectionStartLineNumber===p.selectionStartLineNumber&&A.selectionStartColumn===p.selectionStartColumn&&A.positionLineNumber===p.positionLineNumber&&A.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?T.LTR:T.RTL}setEndPosition(A,p){return this.getDirection()===T.LTR?new R(this.startLineNumber,this.startColumn,A,p):new R(A,p,this.startLineNumber,this.startColumn)}getPosition(){return new s.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new s.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,p){return this.getDirection()===T.LTR?new R(A,p,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,p)}static fromPositions(A,p=A){return new R(A.lineNumber,A.column,p.lineNumber,p.column)}static fromRange(A,p){return p===T.LTR?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,p){if(A&&!p||!A&&p)return!1;if(!A&&!p)return!0;if(A.length!==p.length)return!1;for(let a=0,I=A.length;a<I;a++)if(!this.selectionsEqual(A[a],p[a]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,p,a,I,_){return _===T.LTR?new R(A,p,a,I):new R(a,I,A,p)}}e.Selection=R}),define(_e[192],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(_e[193],ye([1,0,27,29,137]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=p;var R;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends T.CharacterClassifier{constructor(I,_){super(R.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=_,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let c=0,C=I.length;c<C;c++)this.set(I.charCodeAt(c),R.WordSeparator);this.set(s.CharCode.Space,R.Whitespace),this.set(s.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,_){let c=null;for(const C of this._getIntlSegmenterWordsOnLine(I)){if(C.index>_)break;c=C}return c}findNextIntlWordAtOrAfterOffset(I,_){for(const c of this._getIntlSegmenterWordsOnLine(I))if(!(c.index<_))return c;return null}_getIntlSegmenterWordsOnLine(I){return this._segmenter?this._cachedLine===I?this._cachedSegments:(this._cachedLine=I,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(I)),this._cachedSegments):[]}_filterWordSegments(I){const _=[];for(const c of I)this._isWordLike(c)&&_.push(c);return _}_isWordLike(I){return!!I.isWordLike}}e.WordCharacterClassifier=L;const A=new d.LRUCache(10);function p(a,I){const _=`${a}/${I.join(",")}`;let c=A.get(_);return c||(c=new L(a,I),A.set(_,c)),c}}),define(_e[138],ye([1,0,40,3,81]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=L,e.setDefaultGetWordAtTextConfig=p,e.getWordAtText=a,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(_=""){let c="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)_.indexOf(C)>=0||(c+="\\"+C);return c+="\\s]+)",new RegExp(c,"g")}e.DEFAULT_WORD_REGEXP=R();function L(_){let c=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)c=_;else{let C="g";_.ignoreCase&&(C+="i"),_.multiline&&(C+="m"),_.unicode&&(C+="u"),c=new RegExp(_.source,C)}return c.lastIndex=0,c}const A=new T.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(_){const c=A.unshift(_);return(0,d.toDisposable)(c)}function a(_,c,C,b,l){if(c=L(c),l||(l=s.Iterable.first(A)),C.length>l.maxLen){let o=_-l.maxLen/2;return o<0?o=0:b+=o,C=C.substring(o,_+l.maxLen/2),a(_,c,C,b,l)}const m=Date.now(),h=_-1-b;let g=-1,n=null;for(let o=1;!(Date.now()-m>=l.timeBudget);o++){const t=h-l.windowSize*o;c.lastIndex=Math.max(0,t);const i=I(c,C,h,g);if(!i&&n||(n=i,t<=0))break;g=t}if(n){const o={word:n[0],startColumn:b+1+n.index,endColumn:b+1+n.index+n[0].length};return c.lastIndex=0,o}return null}function I(_,c,C,b){let l;for(;l=_.exec(c);){const m=l.index||0;if(m<=C&&_.lastIndex>=C)return l;if(b>0&&m>b)return null}return null}}),define(_e[106],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var s;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(s||(e.LanguageId=s={}));var d;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(d||(e.FontStyle=d={}));var T;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(T||(e.ColorId=T={}));var R;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class A{static getLanguageId(a){return(a&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(a){return(a&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(a){return(a&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(a){return(a&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(a){return(a&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(a){return(a&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(a){let _="mtk"+this.getForeground(a);const c=this.getFontStyle(a);return c&d.Italic&&(_+=" mtki"),c&d.Bold&&(_+=" mtkb"),c&d.Underline&&(_+=" mtku"),c&d.Strikethrough&&(_+=" mtks"),_}static getInlineStyleFromMetadata(a,I){const _=this.getForeground(a),c=this.getFontStyle(a);let C=`color: ${I[_]};`;c&d.Italic&&(C+="font-style: italic;"),c&d.Bold&&(C+="font-weight: bold;");let b="";return c&d.Underline&&(b+=" underline"),c&d.Strikethrough&&(b+=" line-through"),b&&(C+=`text-decoration:${b};`),C}static getPresentationFromMetadata(a){const I=this.getForeground(a),_=this.getFontStyle(a);return{foreground:I,italic:!!(_&d.Italic),bold:!!(_&d.Bold),underline:!!(_&d.Underline),strikethrough:!!(_&d.Strikethrough)}}}e.TokenMetadata=A}),define(_e[194],ye([1,0,27,106]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var T;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(T||(e.IndentAction=T={}));class R{constructor(a){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=a.open,this.close=a.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(a.notIn))for(let I=0,_=a.notIn.length;I<_;I++)switch(a.notIn[I]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(a){switch(a){case d.StandardTokenType.Other:return!0;case d.StandardTokenType.Comment:return this._inComment;case d.StandardTokenType.String:return this._inString;case d.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(a,I){if(a.getTokenCount()===0)return!0;const _=a.findTokenIndexAtOffset(I-2),c=a.getStandardTokenType(_);return this.isOK(c)}_findNeutralCharacterInRange(a,I){for(let _=a;_<=I;_++){const c=String.fromCharCode(_);if(!this.open.includes(c)&&!this.close.includes(c))return c}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.Digit0,s.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.a,s.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(s.CharCode.A,s.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=R;class L{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of a)A(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),A(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),A(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),A(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&A(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=L;function A(p,a,I){p.has(a)?p.get(a).push(I):p.set(a,[I])}}),define(_e[195],ye([1,0,27,137]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=C;var T;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class R{constructor(l,m,h){const g=new Uint8Array(l*m);for(let n=0,o=l*m;n<o;n++)g[n]=h;this._data=g,this.rows=l,this.cols=m}get(l,m){return this._data[l*this.cols+m]}set(l,m,h){this._data[l*this.cols+m]=h}}class L{constructor(l){let m=0,h=T.Invalid;for(let n=0,o=l.length;n<o;n++){const[t,i,r]=l[n];i>m&&(m=i),t>h&&(h=t),r>h&&(h=r)}m++,h++;const g=new R(h,m,T.Invalid);for(let n=0,o=l.length;n<o;n++){const[t,i,r]=l[n];g.set(t,i,r)}this._states=g,this._maxCharCode=m}nextState(l,m){return m<0||m>=this._maxCharCode?T.Invalid:this._states.get(l,m)}}e.StateMachine=L;let A=null;function p(){return A===null&&(A=new L([[T.Start,s.CharCode.h,T.H],[T.Start,s.CharCode.H,T.H],[T.Start,s.CharCode.f,T.F],[T.Start,s.CharCode.F,T.F],[T.H,s.CharCode.t,T.HT],[T.H,s.CharCode.T,T.HT],[T.HT,s.CharCode.t,T.HTT],[T.HT,s.CharCode.T,T.HTT],[T.HTT,s.CharCode.p,T.HTTP],[T.HTT,s.CharCode.P,T.HTTP],[T.HTTP,s.CharCode.s,T.BeforeColon],[T.HTTP,s.CharCode.S,T.BeforeColon],[T.HTTP,s.CharCode.Colon,T.AfterColon],[T.F,s.CharCode.i,T.FI],[T.F,s.CharCode.I,T.FI],[T.FI,s.CharCode.l,T.FIL],[T.FI,s.CharCode.L,T.FIL],[T.FIL,s.CharCode.e,T.BeforeColon],[T.FIL,s.CharCode.E,T.BeforeColon],[T.BeforeColon,s.CharCode.Colon,T.AfterColon],[T.AfterColon,s.CharCode.Slash,T.AlmostThere],[T.AlmostThere,s.CharCode.Slash,T.End]])),A}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let I=null;function _(){if(I===null){I=new d.CharacterClassifier(a.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<b.length;m++)I.set(b.charCodeAt(m),a.ForceTermination);const l=".,;:";for(let m=0;m<l.length;m++)I.set(l.charCodeAt(m),a.CannotEndIn)}return I}class c{static _createLink(l,m,h,g,n){let o=n-1;do{const t=m.charCodeAt(o);if(l.get(t)!==a.CannotEndIn)break;o--}while(o>g);if(g>0){const t=m.charCodeAt(g-1),i=m.charCodeAt(o);(t===s.CharCode.OpenParen&&i===s.CharCode.CloseParen||t===s.CharCode.OpenSquareBracket&&i===s.CharCode.CloseSquareBracket||t===s.CharCode.OpenCurlyBrace&&i===s.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:h,startColumn:g+1,endLineNumber:h,endColumn:o+2},url:m.substring(g,o+1)}}static computeLinks(l,m=p()){const h=_(),g=[];for(let n=1,o=l.getLineCount();n<=o;n++){const t=l.getLineContent(n),i=t.length;let r=0,f=0,u=0,v=T.Start,y=!1,D=!1,w=!1,P=!1;for(;r<i;){let k=!1;const E=t.charCodeAt(r);if(v===T.Accept){let S;switch(E){case s.CharCode.OpenParen:y=!0,S=a.None;break;case s.CharCode.CloseParen:S=y?a.None:a.ForceTermination;break;case s.CharCode.OpenSquareBracket:w=!0,D=!0,S=a.None;break;case s.CharCode.CloseSquareBracket:w=!1,S=D?a.None:a.ForceTermination;break;case s.CharCode.OpenCurlyBrace:P=!0,S=a.None;break;case s.CharCode.CloseCurlyBrace:S=P?a.None:a.ForceTermination;break;case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.BackTick:u===E?S=a.ForceTermination:u===s.CharCode.SingleQuote||u===s.CharCode.DoubleQuote||u===s.CharCode.BackTick?S=a.None:S=a.ForceTermination;break;case s.CharCode.Asterisk:S=u===s.CharCode.Asterisk?a.ForceTermination:a.None;break;case s.CharCode.Pipe:S=u===s.CharCode.Pipe?a.ForceTermination:a.None;break;case s.CharCode.Space:S=w?a.None:a.ForceTermination;break;default:S=h.get(E)}S===a.ForceTermination&&(g.push(c._createLink(h,t,n,f,r)),k=!0)}else if(v===T.End){let S;E===s.CharCode.OpenSquareBracket?(D=!0,S=a.None):S=h.get(E),S===a.ForceTermination?k=!0:v=T.Accept}else v=m.nextState(v,E),v===T.Invalid&&(k=!0);k&&(v=T.Start,y=!1,D=!1,P=!1,f=r+1,u=E),r++}v===T.Accept&&g.push(c._createLink(h,t,n,f,i))}return g}}e.LinkComputer=c;function C(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:c.computeLinks(b)}}),define(_e[55],ye([1,0,25]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=b,e.shouldSynchronizeModel=o;var d;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(d||(e.OverviewRulerLane=d={}));var T;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(T||(e.GlyphMarginLane=T={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var A;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var p;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var a;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(a||(e.DefaultEndOfLine=a={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,i.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this._indentSizeIsTabSize===i._indentSizeIsTabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,s.equals)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class c{constructor(i,r){this._findMatchBrand=void 0,this.range=i,this.matches=r}}e.FindMatch=c;var C;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function b(t){return t&&typeof t.read=="function"}var l;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(l||(e.PositionAffinity=l={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class h{constructor(i,r,f,u,v,y){this.identifier=i,this.range=r,this.text=f,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=v,this._isTracked=y}}e.ValidAnnotatedEditOperation=h;class g{constructor(i,r,f){this.regex=i,this.wordSeparators=r,this.simpleSearch=f}}e.SearchData=g;class n{constructor(i,r,f){this.reverseEdits=i,this.changes=r,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=n;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(_e[196],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=T,e.righttest=R,e.leftRotate=a,e.rightRotate=I,e.rbDelete=_,e.fixInsert=c,e.updateTreeMetadata=C,e.recomputeTreeMetadata=b;class s{constructor(m,h){this.piece=m,this.color=h,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return T(this.right);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.left!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}prev(){if(this.left!==e.SENTINEL)return R(this.left);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.right!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=s;var d;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(d||(e.NodeColor=d={})),e.SENTINEL=new s(null,d.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=d.Black;function T(l){for(;l.left!==e.SENTINEL;)l=l.left;return l}function R(l){for(;l.right!==e.SENTINEL;)l=l.right;return l}function L(l){return l===e.SENTINEL?0:l.size_left+l.piece.length+L(l.right)}function A(l){return l===e.SENTINEL?0:l.lf_left+l.piece.lineFeedCnt+A(l.right)}function p(){e.SENTINEL.parent=e.SENTINEL}function a(l,m){const h=m.right;h.size_left+=m.size_left+(m.piece?m.piece.length:0),h.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=h.left,h.left!==e.SENTINEL&&(h.left.parent=m),h.parent=m.parent,m.parent===e.SENTINEL?l.root=h:m.parent.left===m?m.parent.left=h:m.parent.right=h,h.left=m,m.parent=h}function I(l,m){const h=m.left;m.left=h.right,h.right!==e.SENTINEL&&(h.right.parent=m),h.parent=m.parent,m.size_left-=h.size_left+(h.piece?h.piece.length:0),m.lf_left-=h.lf_left+(h.piece?h.piece.lineFeedCnt:0),m.parent===e.SENTINEL?l.root=h:m===m.parent.right?m.parent.right=h:m.parent.left=h,h.right=m,m.parent=h}function _(l,m){let h,g;if(m.left===e.SENTINEL?(g=m,h=g.right):m.right===e.SENTINEL?(g=m,h=g.left):(g=T(m.right),h=g.right),g===l.root){l.root=h,h.color=d.Black,m.detach(),p(),l.root.parent=e.SENTINEL;return}const n=g.color===d.Red;if(g===g.parent.left?g.parent.left=h:g.parent.right=h,g===m?(h.parent=g.parent,b(l,h)):(g.parent===m?h.parent=g:h.parent=g.parent,b(l,h),g.left=m.left,g.right=m.right,g.parent=m.parent,g.color=m.color,m===l.root?l.root=g:m===m.parent.left?m.parent.left=g:m.parent.right=g,g.left!==e.SENTINEL&&(g.left.parent=g),g.right!==e.SENTINEL&&(g.right.parent=g),g.size_left=m.size_left,g.lf_left=m.lf_left,b(l,g)),m.detach(),h.parent.left===h){const t=L(h),i=A(h);if(t!==h.parent.size_left||i!==h.parent.lf_left){const r=t-h.parent.size_left,f=i-h.parent.lf_left;h.parent.size_left=t,h.parent.lf_left=i,C(l,h.parent,r,f)}}if(b(l,h.parent),n){p();return}let o;for(;h!==l.root&&h.color===d.Black;)h===h.parent.left?(o=h.parent.right,o.color===d.Red&&(o.color=d.Black,h.parent.color=d.Red,a(l,h.parent),o=h.parent.right),o.left.color===d.Black&&o.right.color===d.Black?(o.color=d.Red,h=h.parent):(o.right.color===d.Black&&(o.left.color=d.Black,o.color=d.Red,I(l,o),o=h.parent.right),o.color=h.parent.color,h.parent.color=d.Black,o.right.color=d.Black,a(l,h.parent),h=l.root)):(o=h.parent.left,o.color===d.Red&&(o.color=d.Black,h.parent.color=d.Red,I(l,h.parent),o=h.parent.left),o.left.color===d.Black&&o.right.color===d.Black?(o.color=d.Red,h=h.parent):(o.left.color===d.Black&&(o.right.color=d.Black,o.color=d.Red,a(l,o),o=h.parent.left),o.color=h.parent.color,h.parent.color=d.Black,o.left.color=d.Black,I(l,h.parent),h=l.root));h.color=d.Black,p()}function c(l,m){for(b(l,m);m!==l.root&&m.parent.color===d.Red;)if(m.parent===m.parent.parent.left){const h=m.parent.parent.right;h.color===d.Red?(m.parent.color=d.Black,h.color=d.Black,m.parent.parent.color=d.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,a(l,m)),m.parent.color=d.Black,m.parent.parent.color=d.Red,I(l,m.parent.parent))}else{const h=m.parent.parent.left;h.color===d.Red?(m.parent.color=d.Black,h.color=d.Black,m.parent.parent.color=d.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(l,m)),m.parent.color=d.Black,m.parent.parent.color=d.Red,a(l,m.parent.parent))}l.root.color=d.Black}function C(l,m,h,g){for(;m!==l.root&&m!==e.SENTINEL;)m.parent.left===m&&(m.parent.size_left+=h,m.parent.lf_left+=g),m=m.parent}function b(l,m){let h=0,g=0;if(m!==l.root){for(;m!==l.root&&m===m.parent.right;)m=m.parent;if(m!==l.root)for(m=m.parent,h=L(m.left)-m.size_left,g=A(m.left)-m.lf_left,m.size_left+=h,m.lf_left+=g;m!==l.root&&(h!==0||g!==0);)m.parent.left===m&&(m.parent.size_left+=h,m.parent.lf_left+=g),m=m.parent}}}),define(_e[197],ye([1,0,19,84]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class T{constructor(p){this.values=p,this.prefixSum=new Uint32Array(p.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(p,a){p=(0,d.toUint32)(p);const I=this.values,_=this.prefixSum,c=a.length;return c===0?!1:(this.values=new Uint32Array(I.length+c),this.values.set(I.subarray(0,p),0),this.values.set(I.subarray(p),p+c),this.values.set(a,p),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(p,a){return p=(0,d.toUint32)(p),a=(0,d.toUint32)(a),this.values[p]===a?!1:(this.values[p]=a,p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),!0)}removeValues(p,a){p=(0,d.toUint32)(p),a=(0,d.toUint32)(a);const I=this.values,_=this.prefixSum;if(p>=I.length)return!1;const c=I.length-p;return a>=c&&(a=c),a===0?!1:(this.values=new Uint32Array(I.length-a),this.values.set(I.subarray(0,p),0),this.values.set(I.subarray(p+a),p),this.prefixSum=new Uint32Array(this.values.length),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(p){return p<0?0:(p=(0,d.toUint32)(p),this._getPrefixSum(p))}_getPrefixSum(p){if(p<=this.prefixSumValidIndex[0])return this.prefixSum[p];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),p>=this.values.length&&(p=this.values.length-1);for(let I=a;I<=p;I++)this.prefixSum[I]=this.prefixSum[I-1]+this.values[I];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],p),this.prefixSum[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let a=0,I=this.values.length-1,_=0,c=0,C=0;for(;a<=I;)if(_=a+(I-a)/2|0,c=this.prefixSum[_],C=c-this.values[_],p<C)I=_-1;else if(p>=c)a=_+1;else break;return new L(_,p-C)}}e.PrefixSumComputer=T;class R{constructor(p){this._values=p,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(p){return this._ensureValid(),p===0?0:this._prefixSum[p-1]}getIndexOf(p){this._ensureValid();const a=this._indexBySum[p],I=a>0?this._prefixSum[a-1]:0;return new L(a,p-I)}removeValues(p,a){this._values.splice(p,a),this._invalidate(p)}insertValues(p,a){this._values=(0,s.arrayInsert)(this._values,p,a),this._invalidate(p)}_invalidate(p){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,p-1)}_ensureValid(){if(!this._isValid){for(let p=this._validEndIndex+1,a=this._values.length;p<a;p++){const I=this._values[p],_=p>0?this._prefixSum[p-1]:0;this._prefixSum[p]=_+I;for(let c=0;c<I;c++)this._indexBySum[_+c]=p}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(p,a){this._values[p]!==a&&(this._values[p]=a,this._invalidate(p))}}e.ConstantTimePrefixSumComputer=R;class L{constructor(p,a){this.index=p,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=a}}e.PrefixSumIndexOfResult=L}),define(_e[198],ye([1,0,13,54,197]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,p,a,I){this._uri=A,this._lines=p,this._eol=a,this._versionId=I,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(A){A.eol&&A.eol!==this._eol&&(this._eol=A.eol,this._lineStarts=null);const p=A.changes;for(const a of p)this._acceptDeleteRange(a.range),this._acceptInsertText(new d.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=A.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const A=this._eol.length,p=this._lines.length,a=new Uint32Array(p);for(let I=0;I<p;I++)a[I]=this._lines[I].length+A;this._lineStarts=new T.PrefixSumComputer(a)}}_setLineText(A,p){this._lines[A]=p,this._lineStarts&&this._lineStarts.setValue(A,this._lines[A].length+this._eol.length)}_acceptDeleteRange(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.startLineNumber-1].substring(A.endColumn-1));return}this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.endLineNumber-1].substring(A.endColumn-1)),this._lines.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}_acceptInsertText(A,p){if(p.length===0)return;const a=(0,s.splitLines)(p);if(a.length===1){this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+a[0]+this._lines[A.lineNumber-1].substring(A.column-1));return}a[a.length-1]+=this._lines[A.lineNumber-1].substring(A.column-1),this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+a[0]);const I=new Uint32Array(a.length-1);for(let _=1;_<a.length;_++)this._lines.splice(A.lineNumber+_-1,0,a[_]),I[_-1]=a[_].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(A.lineNumber,I)}}e.MirrorTextModel=R}),define(_e[107],ye([1,0,27,13,193,54,31,55]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=I,e.createFindMatch=_,e.isValidMatch=m,d=ze(d);const p=999;class a{constructor(n,o,t,i){this.searchString=n,this.isRegex=o,this.matchCase=t,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!n;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new A.SearchData(o,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.SearchParams=a;function I(g){if(!g||g.length===0)return!1;for(let n=0,o=g.length;n<o;n++){const t=g.charCodeAt(n);if(t===s.CharCode.LineFeed)return!0;if(t===s.CharCode.Backslash){if(n++,n>=o)break;const i=g.charCodeAt(n);if(i===s.CharCode.n||i===s.CharCode.r||i===s.CharCode.W)return!0}}return!1}function _(g,n,o){if(!o)return new A.FindMatch(g,null);const t=[];for(let i=0,r=n.length;i<r;i++)t[i]=n[i];return new A.FindMatch(g,t)}class c{constructor(n){const o=[];let t=0;for(let i=0,r=n.length;i<r;i++)n.charCodeAt(i)===s.CharCode.LineFeed&&(o[t++]=i);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(n){const o=this._lineFeedsOffsets;let t=0,i=o.length-1;if(i===-1||n<=o[0])return 0;for(;t<i;){const r=t+((i-t)/2>>0);o[r]>=n?i=r-1:o[r+1]>=n?(t=r,i=r):t=r+1}return t+1}}class C{static findMatches(n,o,t,i,r){const f=o.parseSearchRequest();return f?f.regex.multiline?this._doFindMatchesMultiline(n,t,new h(f.wordSeparators,f.regex),i,r):this._doFindMatchesLineByLine(n,t,f,i,r):[]}static _getMultilineMatchRange(n,o,t,i,r,f){let u,v=0;i?(v=i.findLineFeedCountBeforeOffset(r),u=o+r+v):u=o+r;let y;if(i){const k=i.findLineFeedCountBeforeOffset(r+f.length)-v;y=u+f.length+k}else y=u+f.length;const D=n.getPositionAt(u),w=n.getPositionAt(y);return new L.Range(D.lineNumber,D.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(n,o,t,i,r){const f=n.getOffsetAt(o.getStartPosition()),u=n.getValueInRange(o,A.EndOfLinePreference.LF),v=n.getEOL()===`\r
`?new c(u):null,y=[];let D=0,w;for(t.reset(0);w=t.next(u);)if(y[D++]=_(this._getMultilineMatchRange(n,f,u,v,w.index,w[0]),w,i),D>=r)return y;return y}static _doFindMatchesLineByLine(n,o,t,i,r){const f=[];let u=0;if(o.startLineNumber===o.endLineNumber){const y=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return u=this._findMatchesInLine(t,y,o.startLineNumber,o.startColumn-1,u,f,i,r),f}const v=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);u=this._findMatchesInLine(t,v,o.startLineNumber,o.startColumn-1,u,f,i,r);for(let y=o.startLineNumber+1;y<o.endLineNumber&&u<r;y++)u=this._findMatchesInLine(t,n.getLineContent(y),y,0,u,f,i,r);if(u<r){const y=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);u=this._findMatchesInLine(t,y,o.endLineNumber,0,u,f,i,r)}return f}static _findMatchesInLine(n,o,t,i,r,f,u,v){const y=n.wordSeparators;if(!u&&n.simpleSearch){const P=n.simpleSearch,k=P.length,E=o.length;let S=-k;for(;(S=o.indexOf(P,S+k))!==-1;)if((!y||m(y,o,E,S,k))&&(f[r++]=new A.FindMatch(new L.Range(t,S+1+i,t,S+1+k+i),null),r>=v))return r;return r}const D=new h(n.wordSeparators,n.regex);let w;D.reset(0);do if(w=D.next(o),w&&(f[r++]=_(new L.Range(t,w.index+1+i,t,w.index+1+w[0].length+i),w,u),r>=v))return r;while(w);return r}static findNextMatch(n,o,t,i){const r=o.parseSearchRequest();if(!r)return null;const f=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(n,t,f,i):this._doFindNextMatchLineByLine(n,t,f,i)}static _doFindNextMatchMultiline(n,o,t,i){const r=new R.Position(o.lineNumber,1),f=n.getOffsetAt(r),u=n.getLineCount(),v=n.getValueInRange(new L.Range(r.lineNumber,r.column,u,n.getLineMaxColumn(u)),A.EndOfLinePreference.LF),y=n.getEOL()===`\r
`?new c(v):null;t.reset(o.column-1);const D=t.next(v);return D?_(this._getMultilineMatchRange(n,f,v,y,D.index,D[0]),D,i):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(n,new R.Position(1,1),t,i):null}static _doFindNextMatchLineByLine(n,o,t,i){const r=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f),v=this._findFirstMatchInLine(t,u,f,o.column,i);if(v)return v;for(let y=1;y<=r;y++){const D=(f+y-1)%r,w=n.getLineContent(D+1),P=this._findFirstMatchInLine(t,w,D+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(n,o,t,i,r){n.reset(i-1);const f=n.next(o);return f?_(new L.Range(t,f.index+1,t,f.index+1+f[0].length),f,r):null}static findPreviousMatch(n,o,t,i){const r=o.parseSearchRequest();if(!r)return null;const f=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(n,t,f,i):this._doFindPreviousMatchLineByLine(n,t,f,i)}static _doFindPreviousMatchMultiline(n,o,t,i){const r=this._doFindMatchesMultiline(n,new L.Range(1,1,o.lineNumber,o.column),t,i,10*p);if(r.length>0)return r[r.length-1];const f=n.getLineCount();return o.lineNumber!==f||o.column!==n.getLineMaxColumn(f)?this._doFindPreviousMatchMultiline(n,new R.Position(f,n.getLineMaxColumn(f)),t,i):null}static _doFindPreviousMatchLineByLine(n,o,t,i){const r=n.getLineCount(),f=o.lineNumber,u=n.getLineContent(f).substring(0,o.column-1),v=this._findLastMatchInLine(t,u,f,i);if(v)return v;for(let y=1;y<=r;y++){const D=(r+f-y-1)%r,w=n.getLineContent(D+1),P=this._findLastMatchInLine(t,w,D+1,i);if(P)return P}return null}static _findLastMatchInLine(n,o,t,i){let r=null,f;for(n.reset(0);f=n.next(o);)r=_(new L.Range(t,f.index+1,t,f.index+1+f[0].length),f,i);return r}}e.TextModelSearch=C;function b(g,n,o,t,i){if(t===0)return!0;const r=n.charCodeAt(t-1);if(g.get(r)!==T.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t);if(g.get(f)!==T.WordCharacterClass.Regular)return!0}return!1}function l(g,n,o,t,i){if(t+i===o)return!0;const r=n.charCodeAt(t+i);if(g.get(r)!==T.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(i>0){const f=n.charCodeAt(t+i-1);if(g.get(f)!==T.WordCharacterClass.Regular)return!0}return!1}function m(g,n,o,t,i){return b(g,n,o,t,i)&&l(g,n,o,t,i)}class h{constructor(n,o){this._wordSeparators=n,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(n){this._searchRegex.lastIndex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(n){const o=n.length;let t;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(t=this._searchRegex.exec(n),!t))return null;const i=t.index,r=t[0].length;if(i===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){d.getNextCodePoint(n,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=r,!this._wordSeparators||m(this._wordSeparators,n,o,i,r))return t}while(t);return null}}e.Searcher=h}),define(_e[139],ye([1,0,27,54,31,55,196,107]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=_,e.createLineStarts=c;const p=65535;function a(g){let n;return g[g.length-1]<65536?n=new Uint16Array(g.length):n=new Uint32Array(g.length),n.set(g,0),n}class I{constructor(n,o,t,i,r){this.lineStarts=n,this.cr=o,this.lf=t,this.crlf=i,this.isBasicASCII=r}}function _(g,n=!0){const o=[0];let t=1;for(let i=0,r=g.length;i<r;i++){const f=g.charCodeAt(i);f===s.CharCode.CarriageReturn?i+1<r&&g.charCodeAt(i+1)===s.CharCode.LineFeed?(o[t++]=i+2,i++):o[t++]=i+1:f===s.CharCode.LineFeed&&(o[t++]=i+1)}return n?a(o):o}function c(g,n){g.length=0,g[0]=0;let o=1,t=0,i=0,r=0,f=!0;for(let v=0,y=n.length;v<y;v++){const D=n.charCodeAt(v);D===s.CharCode.CarriageReturn?v+1<y&&n.charCodeAt(v+1)===s.CharCode.LineFeed?(r++,g[o++]=v+2,v++):(t++,g[o++]=v+1):D===s.CharCode.LineFeed?(i++,g[o++]=v+1):f&&D!==s.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const u=new I(a(g),t,i,r,f);return g.length=0,u}class C{constructor(n,o,t,i,r){this.bufferIndex=n,this.start=o,this.end=t,this.lineFeedCnt=i,this.length=r}}e.Piece=C;class b{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.StringBuffer=b;class l{constructor(n,o){this._pieces=[],this._tree=n,this._BOM=o,this._index=0,n.root!==L.SENTINEL&&n.iterate(n.root,t=>(t!==L.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class m{constructor(n){this._limit=n,this._cache=[]}get(n){for(let o=this._cache.length-1;o>=0;o--){const t=this._cache[o];if(t.nodeStartOffset<=n&&t.nodeStartOffset+t.node.piece.length>=n)return t}return null}get2(n){for(let o=this._cache.length-1;o>=0;o--){const t=this._cache[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<n&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=n)return t}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let o=!1;const t=this._cache;for(let i=0;i<t.length;i++){const r=t[i];if(r.node.parent===null||r.nodeStartOffset>=n){t[i]=null,o=!0;continue}}if(o){const i=[];for(const r of t)r!==null&&i.push(r);this._cache=i}}}class h{constructor(n,o,t){this.create(n,o,t)}create(n,o,t){this._buffers=[new b("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=L.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=o,this._EOLLength=o.length,this._EOLNormalized=t;let i=null;for(let r=0,f=n.length;r<f;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=_(n[r].buffer));const u=new C(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this._buffers.push(n[r]),i=this.rbInsertRight(i,u)}this._searchCache=new m(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const o=p,t=o-Math.floor(o/3),i=t*2;let r="",f=0;const u=[];if(this.iterate(this.root,v=>{const y=this.getNodeContent(v),D=y.length;if(f<=t||f+D<i)return r+=y,f+=D,!0;const w=r.replace(/\r\n|\r|\n/g,n);return u.push(new b(w,_(w))),r=y,f=D,!0}),f>0){const v=r.replace(/\r\n|\r|\n/g,n);u.push(new b(v,_(v)))}this.create(u,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new l(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,i=>{if(i===L.SENTINEL)return!0;const r=this.getNodeContent(i),f=r.length,u=n.nodeAt(o),v=n.nodeAt(o+f),y=n.getValueInRange2(u,v);return o+=f,r===y})}getOffsetAt(n,o){let t=0,i=this.root;for(;i!==L.SENTINEL;)if(i.left!==L.SENTINEL&&i.lf_left+1>=n)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=n){t+=i.size_left;const r=this.getAccumulatedValue(i,n-i.lf_left-2);return t+=r+o-1}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;return t}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,t=0;const i=n;for(;o!==L.SENTINEL;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const r=this.getIndexOf(o,n-o.size_left);if(t+=o.lf_left+r.index,r.index===0){const f=this.getOffsetAt(t+1,1),u=i-f;return new d.Position(t+1,u+1)}return new d.Position(t+1,r.remainder+1)}else if(n-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===L.SENTINEL){const r=this.getOffsetAt(t+1,1),f=i-n-r;return new d.Position(t+1,f+1)}else o=o.right;return new d.Position(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const t=this.nodeAt2(n.startLineNumber,n.startColumn),i=this.nodeAt2(n.endLineNumber,n.endColumn),r=this.getValueInRange2(t,i);return o?o!==this._EOL||!this._EOLNormalized?r.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this._EOLNormalized?r:r.replace(/\r\n|\r|\n/g,o):r}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,v=this._buffers[u.piece.bufferIndex].buffer,y=this.offsetInBuffer(u.piece.bufferIndex,u.piece.start);return v.substring(y+n.remainder,y+o.remainder)}let t=n.node;const i=this._buffers[t.piece.bufferIndex].buffer,r=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let f=i.substring(r+n.remainder,r+t.piece.length);for(t=t.next();t!==L.SENTINEL;){const u=this._buffers[t.piece.bufferIndex].buffer,v=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===o.node){f+=u.substring(v,v+o.remainder);break}else f+=u.substr(v,t.piece.length);t=t.next()}return f}getLinesContent(){const n=[];let o=0,t="",i=!1;return this.iterate(this.root,r=>{if(r===L.SENTINEL)return!0;const f=r.piece;let u=f.length;if(u===0)return!0;const v=this._buffers[f.bufferIndex].buffer,y=this._buffers[f.bufferIndex].lineStarts,D=f.start.line,w=f.end.line;let P=y[D]+f.start.column;if(i&&(v.charCodeAt(P)===s.CharCode.LineFeed&&(P++,u--),n[o++]=t,t="",i=!1,u===0))return!0;if(D===w)return!this._EOLNormalized&&v.charCodeAt(P+u-1)===s.CharCode.CarriageReturn?(i=!0,t+=v.substr(P,u-1)):t+=v.substr(P,u),!0;t+=this._EOLNormalized?v.substring(P,Math.max(P,y[D+1]-this._EOLLength)):v.substring(P,y[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;for(let k=D+1;k<w;k++)t=this._EOLNormalized?v.substring(y[k],y[k+1]-this._EOLLength):v.substring(y[k],y[k+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;return!this._EOLNormalized&&v.charCodeAt(y[w]+f.end.column-1)===s.CharCode.CarriageReturn?(i=!0,f.end.column===0?o--:t=v.substr(y[w],f.end.column-1)):t=v.substr(y[w],f.end.column),!0}),i&&(n[o++]=t,t=""),n[o++]=t,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const t=this._buffers[o.piece.bufferIndex],i=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(i)}else{const o=this._buffers[n.node.piece.bufferIndex],i=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(i)}}getLineCharCode(n,o){const t=this.nodeAt2(n,o+1);return this._getCharCode(t)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const o=this.nodeAt(n);return this._getCharCode(o)}getNearestChunk(n){const o=this.nodeAt(n);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===L.SENTINEL)return"";const i=this._buffers[t.piece.bufferIndex],r=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return i.buffer.substring(r,r+t.piece.length)}else{const t=this._buffers[o.node.piece.bufferIndex],i=this.offsetInBuffer(o.node.piece.bufferIndex,o.node.piece.start),r=i+o.remainder,f=i+o.node.piece.length;return t.buffer.substring(r,f)}}findMatchesInNode(n,o,t,i,r,f,u,v,y,D,w){const P=this._buffers[n.piece.bufferIndex],k=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),E=this.offsetInBuffer(n.piece.bufferIndex,r),S=this.offsetInBuffer(n.piece.bufferIndex,f);let M;const N={line:0,column:0};let O,x;o._wordSeparators?(O=P.buffer.substring(E,S),x=U=>U+E,o.reset(0)):(O=P.buffer,x=U=>U,o.reset(E));do if(M=o.next(O),M){if(x(M.index)>=S)return D;this.positionInBuffer(n,x(M.index)-k,N);const U=this.getLineFeedCnt(n.piece.bufferIndex,r,N),F=N.line===r.line?N.column-r.column+i:N.column+1,H=F+M[0].length;if(w[D++]=(0,A.createFindMatch)(new T.Range(t+U,F,t+U,H),M,v),x(M.index)+M[0].length>=S||D>=y)return D}while(M);return D}findMatchesLineByLine(n,o,t,i){const r=[];let f=0;const u=new A.Searcher(o.wordSeparators,o.regex);let v=this.nodeAt2(n.startLineNumber,n.startColumn);if(v===null)return[];const y=this.nodeAt2(n.endLineNumber,n.endColumn);if(y===null)return[];let D=this.positionInBuffer(v.node,v.remainder);const w=this.positionInBuffer(y.node,y.remainder);if(v.node===y.node)return this.findMatchesInNode(v.node,u,n.startLineNumber,n.startColumn,D,w,o,t,i,f,r),r;let P=n.startLineNumber,k=v.node;for(;k!==y.node;){const S=this.getLineFeedCnt(k.piece.bufferIndex,D,k.piece.end);if(S>=1){const N=this._buffers[k.piece.bufferIndex].lineStarts,O=this.offsetInBuffer(k.piece.bufferIndex,k.piece.start),x=N[D.line+S],U=P===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(k,u,P,U,D,this.positionInBuffer(k,x-O),o,t,i,f,r),f>=i)return r;P+=S}const M=P===n.startLineNumber?n.startColumn-1:0;if(P===n.endLineNumber){const N=this.getLineContent(P).substring(M,n.endColumn-1);return f=this._findMatchesInLine(o,u,N,n.endLineNumber,M,f,r,t,i),r}if(f=this._findMatchesInLine(o,u,this.getLineContent(P).substr(M),P,M,f,r,t,i),f>=i)return r;P++,v=this.nodeAt2(P,1),k=v.node,D=this.positionInBuffer(v.node,v.remainder)}if(P===n.endLineNumber){const S=P===n.startLineNumber?n.startColumn-1:0,M=this.getLineContent(P).substring(S,n.endColumn-1);return f=this._findMatchesInLine(o,u,M,n.endLineNumber,S,f,r,t,i),r}const E=P===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(y.node,u,P,E,D,w,o,t,i,f,r),r}_findMatchesInLine(n,o,t,i,r,f,u,v,y){const D=n.wordSeparators;if(!v&&n.simpleSearch){const P=n.simpleSearch,k=P.length,E=t.length;let S=-k;for(;(S=t.indexOf(P,S+k))!==-1;)if((!D||(0,A.isValidMatch)(D,t,E,S,k))&&(u[f++]=new R.FindMatch(new T.Range(i,S+1+r,i,S+1+k+r),null),f>=y))return f;return f}let w;o.reset(0);do if(w=o.next(t),w&&(u[f++]=(0,A.createFindMatch)(new T.Range(i,w.index+1+r,i,w.index+1+w[0].length+r),w,v),f>=y))return f;while(w);return f}insert(n,o,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==L.SENTINEL){const{node:i,remainder:r,nodeStartOffset:f}=this.nodeAt(n),u=i.piece,v=u.bufferIndex,y=this.positionInBuffer(i,r);if(i.piece.bufferIndex===0&&u.end.line===this._lastChangeBufferPos.line&&u.end.column===this._lastChangeBufferPos.column&&f+u.length===n&&o.length<p){this.appendToNode(i,o),this.computeBufferMetadata();return}if(f===n)this.insertContentToNodeLeft(o,i),this._searchCache.validate(n);else if(f+i.piece.length>n){const D=[];let w=new C(u.bufferIndex,y,u.end,this.getLineFeedCnt(u.bufferIndex,y,u.end),this.offsetInBuffer(v,u.end)-this.offsetInBuffer(v,y));if(this.shouldCheckCRLF()&&this.endWithCR(o)&&this.nodeCharCodeAt(i,r)===10){const S={line:w.start.line+1,column:0};w=new C(w.bufferIndex,S,w.end,this.getLineFeedCnt(w.bufferIndex,S,w.end),w.length-1),o+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(o))if(this.nodeCharCodeAt(i,r-1)===13){const S=this.positionInBuffer(i,r-1);this.deleteNodeTail(i,S),o="\r"+o,i.piece.length===0&&D.push(i)}else this.deleteNodeTail(i,y);else this.deleteNodeTail(i,y);const P=this.createNewPieces(o);w.length>0&&this.rbInsertRight(i,w);let k=i;for(let E=0;E<P.length;E++)k=this.rbInsertRight(k,P[E]);this.deleteNodes(D)}else this.insertContentToNodeRight(o,i)}else{const i=this.createNewPieces(o);let r=this.rbInsertLeft(null,i[0]);for(let f=1;f<i.length;f++)r=this.rbInsertRight(r,i[f])}this.computeBufferMetadata()}delete(n,o){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",o<=0||this.root===L.SENTINEL)return;const t=this.nodeAt(n),i=this.nodeAt(n+o),r=t.node,f=i.node;if(r===f){const P=this.positionInBuffer(r,t.remainder),k=this.positionInBuffer(r,i.remainder);if(t.nodeStartOffset===n){if(o===r.piece.length){const E=r.next();(0,L.rbDelete)(this,r),this.validateCRLFWithPrevNode(E),this.computeBufferMetadata();return}this.deleteNodeHead(r,k),this._searchCache.validate(n),this.validateCRLFWithPrevNode(r),this.computeBufferMetadata();return}if(t.nodeStartOffset+r.piece.length===n+o){this.deleteNodeTail(r,P),this.validateCRLFWithNextNode(r),this.computeBufferMetadata();return}this.shrinkNode(r,P,k),this.computeBufferMetadata();return}const u=[],v=this.positionInBuffer(r,t.remainder);this.deleteNodeTail(r,v),this._searchCache.validate(n),r.piece.length===0&&u.push(r);const y=this.positionInBuffer(f,i.remainder);this.deleteNodeHead(f,y),f.piece.length===0&&u.push(f);const D=r.next();for(let P=D;P!==L.SENTINEL&&P!==f;P=P.next())u.push(P);const w=r.piece.length===0?r.prev():r;this.deleteNodes(u),this.validateCRLFWithNextNode(w),this.computeBufferMetadata()}insertContentToNodeLeft(n,o){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(o)){const f=o.piece,u={line:f.start.line+1,column:0},v=new C(f.bufferIndex,u,f.end,this.getLineFeedCnt(f.bufferIndex,u,f.end),f.length-1);o.piece=v,n+=`
`,(0,L.updateTreeMetadata)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const i=this.createNewPieces(n);let r=this.rbInsertLeft(o,i[i.length-1]);for(let f=i.length-2;f>=0;f--)r=this.rbInsertLeft(r,i[f]);this.validateCRLFWithPrevNode(r),this.deleteNodes(t)}insertContentToNodeRight(n,o){this.adjustCarriageReturnFromNext(n,o)&&(n+=`
`);const t=this.createNewPieces(n),i=this.rbInsertRight(o,t[0]);let r=i;for(let f=1;f<t.length;f++)r=this.rbInsertRight(r,t[f]);this.validateCRLFWithPrevNode(i)}positionInBuffer(n,o,t){const i=n.piece,r=n.piece.bufferIndex,f=this._buffers[r].lineStarts,v=f[i.start.line]+i.start.column+o;let y=i.start.line,D=i.end.line,w=0,P=0,k=0;for(;y<=D&&(w=y+(D-y)/2|0,k=f[w],w!==D);)if(P=f[w+1],v<k)D=w-1;else if(v>=P)y=w+1;else break;return t?(t.line=w,t.column=v-k,null):{line:w,column:v-k}}getLineFeedCnt(n,o,t){if(t.column===0)return t.line-o.line;const i=this._buffers[n].lineStarts;if(t.line===i.length-1)return t.line-o.line;const r=i[t.line+1],f=i[t.line]+t.column;if(r>f+1)return t.line-o.line;const u=f-1;return this._buffers[n].buffer.charCodeAt(u)===13?t.line-o.line+1:t.line-o.line}offsetInBuffer(n,o){return this._buffers[n].lineStarts[o.line]+o.column}deleteNodes(n){for(let o=0;o<n.length;o++)(0,L.rbDelete)(this,n[o])}createNewPieces(n){if(n.length>p){const D=[];for(;n.length>p;){const P=n.charCodeAt(p-1);let k;P===s.CharCode.CarriageReturn||P>=55296&&P<=56319?(k=n.substring(0,p-1),n=n.substring(p-1)):(k=n.substring(0,p),n=n.substring(p));const E=_(k);D.push(new C(this._buffers.length,{line:0,column:0},{line:E.length-1,column:k.length-E[E.length-1]},E.length-1,k.length)),this._buffers.push(new b(k,E))}const w=_(n);return D.push(new C(this._buffers.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this._buffers.push(new b(n,w)),D}let o=this._buffers[0].buffer.length;const t=_(n,!1);let i=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===o&&o!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},i=this._lastChangeBufferPos;for(let D=0;D<t.length;D++)t[D]+=o+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<t.length;D++)t[D]+=o;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=n}const r=this._buffers[0].buffer.length,f=this._buffers[0].lineStarts.length-1,u=r-this._buffers[0].lineStarts[f],v={line:f,column:u},y=new C(0,i,v,this.getLineFeedCnt(0,i,v),r-o);return this._lastChangeBufferPos=v,[y]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,o=0){let t=this.root,i="";const r=this._searchCache.get2(n);if(r){t=r.node;const f=this.getAccumulatedValue(t,n-r.nodeStartLineNumber-1),u=this._buffers[t.piece.bufferIndex].buffer,v=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(r.nodeStartLineNumber+t.piece.lineFeedCnt===n)i=u.substring(v+f,v+t.piece.length);else{const y=this.getAccumulatedValue(t,n-r.nodeStartLineNumber);return u.substring(v+f,v+y-o)}}else{let f=0;const u=n;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const v=this.getAccumulatedValue(t,n-t.lf_left-2),y=this.getAccumulatedValue(t,n-t.lf_left-1),D=this._buffers[t.piece.bufferIndex].buffer,w=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return f+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:f,nodeStartLineNumber:u-(n-1-t.lf_left)}),D.substring(w+v,w+y-o)}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const v=this.getAccumulatedValue(t,n-t.lf_left-2),y=this._buffers[t.piece.bufferIndex].buffer,D=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);i=y.substring(D+v,D+t.piece.length);break}else n-=t.lf_left+t.piece.lineFeedCnt,f+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.SENTINEL;){const f=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const u=this.getAccumulatedValue(t,0),v=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return i+=f.substring(v,v+u-o),i}else{const u=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);i+=f.substr(u,t.piece.length)}t=t.next()}return i}computeBufferMetadata(){let n=this.root,o=1,t=0;for(;n!==L.SENTINEL;)o+=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;this._lineCnt=o,this._length=t,this._searchCache.validate(this._length)}getIndexOf(n,o){const t=n.piece,i=this.positionInBuffer(n,o),r=i.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===o){const f=this.getLineFeedCnt(n.piece.bufferIndex,t.start,i);if(f!==r)return{index:f,remainder:0}}return{index:r,remainder:i.column}}getAccumulatedValue(n,o){if(o<0)return 0;const t=n.piece,i=this._buffers[t.bufferIndex].lineStarts,r=t.start.line+o+1;return r>t.end.line?i[t.end.line]+t.end.column-i[t.start.line]-t.start.column:i[r]-i[t.start.line]-t.start.column}deleteNodeTail(n,o){const t=n.piece,i=t.lineFeedCnt,r=this.offsetInBuffer(t.bufferIndex,t.end),f=o,u=this.offsetInBuffer(t.bufferIndex,f),v=this.getLineFeedCnt(t.bufferIndex,t.start,f),y=v-i,D=u-r,w=t.length+D;n.piece=new C(t.bufferIndex,t.start,f,v,w),(0,L.updateTreeMetadata)(this,n,D,y)}deleteNodeHead(n,o){const t=n.piece,i=t.lineFeedCnt,r=this.offsetInBuffer(t.bufferIndex,t.start),f=o,u=this.getLineFeedCnt(t.bufferIndex,f,t.end),v=this.offsetInBuffer(t.bufferIndex,f),y=u-i,D=r-v,w=t.length+D;n.piece=new C(t.bufferIndex,f,t.end,u,w),(0,L.updateTreeMetadata)(this,n,D,y)}shrinkNode(n,o,t){const i=n.piece,r=i.start,f=i.end,u=i.length,v=i.lineFeedCnt,y=o,D=this.getLineFeedCnt(i.bufferIndex,i.start,y),w=this.offsetInBuffer(i.bufferIndex,o)-this.offsetInBuffer(i.bufferIndex,r);n.piece=new C(i.bufferIndex,i.start,y,D,w),(0,L.updateTreeMetadata)(this,n,w-u,D-v);const P=new C(i.bufferIndex,t,f,this.getLineFeedCnt(i.bufferIndex,t,f),this.offsetInBuffer(i.bufferIndex,f)-this.offsetInBuffer(i.bufferIndex,t)),k=this.rbInsertRight(n,P);this.validateCRLFWithPrevNode(k)}appendToNode(n,o){this.adjustCarriageReturnFromNext(o,n)&&(o+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(o)&&this.endWithCR(n),i=this._buffers[0].buffer.length;this._buffers[0].buffer+=o;const r=_(o,!1);for(let k=0;k<r.length;k++)r[k]+=i;if(t){const k=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:i-k}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1));const f=this._buffers[0].lineStarts.length-1,u=this._buffers[0].buffer.length-this._buffers[0].lineStarts[f],v={line:f,column:u},y=n.piece.length+o.length,D=n.piece.lineFeedCnt,w=this.getLineFeedCnt(0,n.piece.start,v),P=w-D;n.piece=new C(n.piece.bufferIndex,n.piece.start,v,w,y),this._lastChangeBufferPos=v,(0,L.updateTreeMetadata)(this,n,o.length,P)}nodeAt(n){let o=this.root;const t=this._searchCache.get(n);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:n-t.nodeStartOffset};let i=0;for(;o!==L.SENTINEL;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){i+=o.size_left;const r={node:o,remainder:n-o.size_left,nodeStartOffset:i};return this._searchCache.set(r),r}else n-=o.size_left+o.piece.length,i+=o.size_left+o.piece.length,o=o.right;return null}nodeAt2(n,o){let t=this.root,i=0;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const r=this.getAccumulatedValue(t,n-t.lf_left-2),f=this.getAccumulatedValue(t,n-t.lf_left-1);return i+=t.size_left,{node:t,remainder:Math.min(r+o-1,f),nodeStartOffset:i}}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const r=this.getAccumulatedValue(t,n-t.lf_left-2);if(r+o-1<=t.piece.length)return{node:t,remainder:r+o-1,nodeStartOffset:i};o-=t.piece.length-r;break}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.SENTINEL;){if(t.piece.lineFeedCnt>0){const r=this.getAccumulatedValue(t,0),f=this.offsetOfNode(t);return{node:t,remainder:Math.min(o-1,r),nodeStartOffset:f}}else if(t.piece.length>=o-1){const r=this.offsetOfNode(t);return{node:t,remainder:o-1,nodeStartOffset:r}}else o-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(n,o){if(n.piece.lineFeedCnt<1)return-1;const t=this._buffers[n.piece.bufferIndex],i=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+o;return t.buffer.charCodeAt(i)}offsetOfNode(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.SENTINEL||n.piece.lineFeedCnt===0)return!1;const o=n.piece,t=this._buffers[o.bufferIndex].lineStarts,i=o.start.line,r=t[i]+o.start.column;return i===t.length-1||t[i+1]>r+1?!1:this._buffers[o.bufferIndex].buffer.charCodeAt(r)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const o=n.prev();this.endWithCR(o)&&this.fixCRLF(o,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const o=n.next();this.startWithLF(o)&&this.fixCRLF(n,o)}}fixCRLF(n,o){const t=[],i=this._buffers[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:i[n.piece.end.line]-i[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new C(n.piece.bufferIndex,n.piece.start,r,u,f),(0,L.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&t.push(n);const v={line:o.piece.start.line+1,column:0},y=o.piece.length-1,D=this.getLineFeedCnt(o.piece.bufferIndex,v,o.piece.end);o.piece=new C(o.piece.bufferIndex,v,o.piece.end,D,y),(0,L.updateTreeMetadata)(this,o,-1,-1),o.piece.length===0&&t.push(o);const w=this.createNewPieces(`\r
`);this.rbInsertRight(n,w[0]);for(let P=0;P<t.length;P++)(0,L.rbDelete)(this,t[P])}adjustCarriageReturnFromNext(n,o){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const t=o.next();if(this.startWithLF(t)){if(n+=`
`,t.piece.length===1)(0,L.rbDelete)(this,t);else{const i=t.piece,r={line:i.start.line+1,column:0},f=i.length-1,u=this.getLineFeedCnt(i.bufferIndex,r,i.end);t.piece=new C(i.bufferIndex,r,i.end,u,f),(0,L.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.SENTINEL)return o(L.SENTINEL);const t=this.iterate(n.left,o);return t&&o(n)&&this.iterate(n.right,o)}getNodeContent(n){if(n===L.SENTINEL)return"";const o=this._buffers[n.piece.bufferIndex],t=n.piece,i=this.offsetInBuffer(t.bufferIndex,t.start),r=this.offsetInBuffer(t.bufferIndex,t.end);return o.buffer.substring(i,r)}getPieceContent(n){const o=this._buffers[n.bufferIndex],t=this.offsetInBuffer(n.bufferIndex,n.start),i=this.offsetInBuffer(n.bufferIndex,n.end);return o.buffer.substring(t,i)}rbInsertRight(n,o){const t=new L.TreeNode(o,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(n.right===L.SENTINEL)n.right=t,t.parent=n;else{const r=(0,L.leftest)(n.right);r.left=t,t.parent=r}return(0,L.fixInsert)(this,t),t}rbInsertLeft(n,o){const t=new L.TreeNode(o,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(n.left===L.SENTINEL)n.left=t,t.parent=n;else{const i=(0,L.righttest)(n.left);i.right=t,t.parent=i}return(0,L.fixInsert)(this,t),t}getContentOfSubTree(n){let o="";return this.iterate(n,t=>(o+=this.getNodeContent(t),!0)),o}}e.PieceTreeBase=h}),define(_e[199],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class s{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const L=this._dragOperations.get(R);return this._dragOperations.delete(R),L}}addDragOperationTransfer(R,L){this._dragOperations.set(R,L)}}e.TreeViewsDnDService=s;class d{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=d}),define(_e[200],ye([1,0,4,3,106]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class R{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(p){this._onDidChange.fire({changedLanguages:p,changedColorMap:!1})}register(p,a){return this._tokenizationSupports.set(p,a),this.handleChange([p]),(0,d.toDisposable)(()=>{this._tokenizationSupports.get(p)===a&&(this._tokenizationSupports.delete(p),this.handleChange([p]))})}get(p){return this._tokenizationSupports.get(p)||null}registerFactory(p,a){this._factories.get(p)?.dispose();const I=new L(this,p,a);return this._factories.set(p,I),(0,d.toDisposable)(()=>{const _=this._factories.get(p);!_||_!==I||(this._factories.delete(p),_.dispose())})}async getOrCreate(p){const a=this.get(p);if(a)return a;const I=this._factories.get(p);return!I||I.isResolved?null:(await I.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const I=this._factories.get(p);return!!(!I||I.isResolved)}setColorMap(p){this._colorMap=p,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>T.ColorId.DefaultBackground?this._colorMap[T.ColorId.DefaultBackground]:null}}e.TokenizationRegistry=R;class L extends d.Disposable{get isResolved(){return this._isResolved}constructor(p,a,I){super(),this._registry=p,this._languageId=a,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const p=await this._factory.tokenizationSupport;this._isResolved=!0,p&&!this._isDisposed&&this._register(this._registry.register(this._languageId,p))}}}),define(_e[201],ye([7,8]),function(le,e){return le.create("vs/base/common/actions",e)}),define(_e[202],ye([1,0,4,3,201]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=I,T=ze(T);class R extends d.Disposable{constructor(c,C="",b="",l=!0,m){super(),this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=C,this._cssClass=b,this._enabled=l,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,C){this._actionCallback&&await this._actionCallback(c)}}e.Action=R;class L extends d.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new s.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new s.Emitter),this.onDidRun=this._onDidRun.event}async run(c,C){if(!c.enabled)return;this._onWillRun.fire({action:c});let b;try{await this.runAction(c,C)}catch(l){b=l}this._onDidRun.fire({action:c,error:b})}async runAction(c,C){await c.run(C)}}e.ActionRunner=L;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let C=[];for(const b of c)b.length&&(C.length?C=[...C,new A,...b]:C=b);return C}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=A;class p{get actions(){return this._actions}constructor(c,C,b,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=C,this.class=l,this._actions=b}async run(){}}e.SubmenuAction=p;class a extends R{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=a;function I(_){return{id:_.id,label:_.label,tooltip:_.tooltip??_.label,class:_.class,enabled:_.enabled??!0,checked:_.checked,run:async(...c)=>_.run(...c)}}}),define(_e[203],ye([7,8]),function(le,e){return le.create("vs/base/common/date",e)}),define(_e[204],ye([1,0,203]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=I,e.toLocalISOString=_;const d=60,T=d*60,R=T*24,L=R*7,A=R*30,p=R*365;function a(c,C,b,l){typeof c!="number"&&(c=c.getTime());const m=Math.round((new Date().getTime()-c)/1e3);if(m<-30)return(0,s.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!l&&m<30)return(0,s.localize)(1,null);let h;return m<d?(h=m,C?h===1?b?(0,s.localize)(2,null,h):(0,s.localize)(3,null,h):b?(0,s.localize)(4,null,h):(0,s.localize)(5,null,h):h===1?b?(0,s.localize)(6,null,h):(0,s.localize)(7,null,h):b?(0,s.localize)(8,null,h):(0,s.localize)(9,null,h)):m<T?(h=Math.floor(m/d),C?h===1?b?(0,s.localize)(10,null,h):(0,s.localize)(11,null,h):b?(0,s.localize)(12,null,h):(0,s.localize)(13,null,h):h===1?b?(0,s.localize)(14,null,h):(0,s.localize)(15,null,h):b?(0,s.localize)(16,null,h):(0,s.localize)(17,null,h)):m<R?(h=Math.floor(m/T),C?h===1?b?(0,s.localize)(18,null,h):(0,s.localize)(19,null,h):b?(0,s.localize)(20,null,h):(0,s.localize)(21,null,h):h===1?b?(0,s.localize)(22,null,h):(0,s.localize)(23,null,h):b?(0,s.localize)(24,null,h):(0,s.localize)(25,null,h)):m<L?(h=Math.floor(m/R),C?h===1?(0,s.localize)(26,null,h):(0,s.localize)(27,null,h):h===1?(0,s.localize)(28,null,h):(0,s.localize)(29,null,h)):m<A?(h=Math.floor(m/L),C?h===1?b?(0,s.localize)(30,null,h):(0,s.localize)(31,null,h):b?(0,s.localize)(32,null,h):(0,s.localize)(33,null,h):h===1?b?(0,s.localize)(34,null,h):(0,s.localize)(35,null,h):b?(0,s.localize)(36,null,h):(0,s.localize)(37,null,h)):m<p?(h=Math.floor(m/A),C?h===1?b?(0,s.localize)(38,null,h):(0,s.localize)(39,null,h):b?(0,s.localize)(40,null,h):(0,s.localize)(41,null,h):h===1?b?(0,s.localize)(42,null,h):(0,s.localize)(43,null,h):b?(0,s.localize)(44,null,h):(0,s.localize)(45,null,h)):(h=Math.floor(m/p),C?h===1?b?(0,s.localize)(46,null,h):(0,s.localize)(47,null,h):b?(0,s.localize)(48,null,h):(0,s.localize)(49,null,h):h===1?b?(0,s.localize)(50,null,h):(0,s.localize)(51,null,h):b?(0,s.localize)(52,null,h):(0,s.localize)(53,null,h))}function I(c,C){const b=Math.abs(c/1e3);return b<1?C?(0,s.localize)(54,null,c):(0,s.localize)(55,null,c):b<d?C?(0,s.localize)(56,null,Math.round(c)/1e3):(0,s.localize)(57,null,Math.round(c)/1e3):b<T?C?(0,s.localize)(58,null,Math.round(c/(1e3*d))):(0,s.localize)(59,null,Math.round(c/(1e3*d))):b<R?C?(0,s.localize)(60,null,Math.round(c/(1e3*T))):(0,s.localize)(61,null,Math.round(c/(1e3*T))):(0,s.localize)(62,null,Math.round(c/(1e3*R)))}function _(c){return c.getFullYear()+"-"+String(c.getMonth()+1).padStart(2,"0")+"-"+String(c.getDate()).padStart(2,"0")+"T"+String(c.getHours()).padStart(2,"0")+":"+String(c.getMinutes()).padStart(2,"0")+":"+String(c.getSeconds()).padStart(2,"0")+"."+(c.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(_e[205],ye([7,8]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(_e[51],ye([1,0,19,18,205]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=p,e.isErrorWithActions=a,e.createErrorWithActions=I,s=ze(s),d=ze(d),T=ze(T);function R(_,c){return c&&(_.stack||_.stacktrace)?T.localize(0,null,A(_),L(_.stack)||L(_.stacktrace)):A(_)}function L(_){return Array.isArray(_)?_.join(`
`):_}function A(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?T.localize(1,null,_.message):_.message||T.localize(2,null)}function p(_=null,c=!1){if(!_)return T.localize(3,null);if(Array.isArray(_)){const C=s.coalesce(_),b=p(C[0],c);return C.length>1?T.localize(4,null,b,C.length):b}if(d.isString(_))return _;if(_.detail){const C=_.detail;if(C.error)return R(C.error,c);if(C.exception)return R(C.exception,c)}return _.stack?R(_,c):_.message?_.message:T.localize(5,null)}function a(_){const c=_;return c instanceof Error&&Array.isArray(c.actions)}function I(_,c){let C;return typeof _=="string"?C=new Error(_):C=_,C.actions=c,C}}),define(_e[206],ye([7,8]),function(le,e){return le.create("vs/base/common/platform",e)}),define(_e[11],ye([1,0,206]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=r,e.isLittleEndian=w,e.isBigSurOrNewer=P,s=ze(s),e.LANGUAGE_DEFAULT="en";let d=!1,T=!1,R=!1,L=!1,A=!1,p=!1,a=!1,I=!1,_=!1,c=!1,C,b=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,m,h;const g=globalThis;let n;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?n=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",t=o&&n?.type==="renderer";if(typeof n=="object"){d=n.platform==="win32",T=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,a=o,_=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT;const k=n.env.VSCODE_NLS_CONFIG;if(k)try{const E=JSON.parse(k),S=E.availableLanguages["*"];C=E.locale,l=E.osLocale,b=S||e.LANGUAGE_DEFAULT,m=E._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!t?(h=navigator.userAgent,d=h.indexOf("Windows")>=0,T=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,c=h?.indexOf("Mobi")>=0,p=!0,C=s.getConfiguredDefaultLocale(s.localize(0,null))||e.LANGUAGE_DEFAULT,b=C,l=navigator.language):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(e.Platform=i={}));function r(k){switch(k){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let f=i.Web;T?f=i.Mac:d?f=i.Windows:R&&(f=i.Linux),e.isWindows=d,e.isMacintosh=T,e.isLinux=R,e.isLinuxSnap=L,e.isNative=A,e.isElectron=a,e.isWeb=p,e.isWebWorker=p&&typeof g.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?g.origin:void 0,e.isIOS=I,e.isMobile=c,e.isCI=_,e.platform=f,e.userAgent=h,e.language=b;var u;(function(k){function E(){return e.language}k.value=E;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}k.isDefaultVariant=S;function M(){return e.language==="en"}k.isDefault=M})(u||(e.Language=u={})),e.locale=C,e.platformLocale=l,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof g.postMessage=="function"&&!g.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const k=[];g.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let M=0,N=k.length;M<N;M++){const O=k[M];if(O.id===S.data.vscodeScheduleAsyncWork){k.splice(M,1),O.callback();return}}});let E=0;return S=>{const M=++E;k.push({id:M,callback:S}),g.postMessage({vscodeScheduleAsyncWork:M},"*")}}return k=>setTimeout(k)})();var v;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(v||(e.OperatingSystem=v={})),e.OS=T||I?v.Macintosh:d?v.Windows:v.Linux;let y=!0,D=!1;function w(){if(!D){D=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,y=new Uint16Array(k.buffer)[0]===513}return y}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function P(k){return parseFloat(k)>=20}}),define(_e[56],ye([1,0,11]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let d;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const R=T.process;d={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?d={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:d={get platform(){return s.isWindows?"win32":s.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=d.cwd,e.env=d.env,e.platform=d.platform,e.arch=d.arch}),define(_e[17],ye([1,0,56]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,s=ze(s);const d=65,T=97,R=90,L=122,A=46,p=47,a=92,I=58,_=63;class c extends Error{constructor(r,f,u){let v;typeof f=="string"&&f.indexOf("not ")===0?(v="must not be",f=f.replace(/^not /,"")):v="must be";const y=r.indexOf(".")!==-1?"property":"argument";let D=`The "${r}" ${y} ${v} of type ${f}`;D+=`. Received type ${typeof u}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,r){if(i===null||typeof i!="object")throw new c(r,"Object",i)}function b(i,r){if(typeof i!="string")throw new c(r,"string",i)}const l=s.platform==="win32";function m(i){return i===p||i===a}function h(i){return i===p}function g(i){return i>=d&&i<=R||i>=T&&i<=L}function n(i,r,f,u){let v="",y=0,D=-1,w=0,P=0;for(let k=0;k<=i.length;++k){if(k<i.length)P=i.charCodeAt(k);else{if(u(P))break;P=p}if(u(P)){if(!(D===k-1||w===1))if(w===2){if(v.length<2||y!==2||v.charCodeAt(v.length-1)!==A||v.charCodeAt(v.length-2)!==A){if(v.length>2){const E=v.lastIndexOf(f);E===-1?(v="",y=0):(v=v.slice(0,E),y=v.length-1-v.lastIndexOf(f)),D=k,w=0;continue}else if(v.length!==0){v="",y=0,D=k,w=0;continue}}r&&(v+=v.length>0?`${f}..`:"..",y=2)}else v.length>0?v+=`${f}${i.slice(D+1,k)}`:v=i.slice(D+1,k),y=k-D-1;D=k,w=0}else P===A&&w!==-1?++w:w=-1}return v}function o(i,r){C(r,"pathObject");const f=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return f?f===r.root?`${f}${u}`:`${f}${i}${u}`:u}e.win32={resolve(...i){let r="",f="",u=!1;for(let v=i.length-1;v>=-1;v--){let y;if(v>=0){if(y=i[v],b(y,"path"),y.length===0)continue}else r.length===0?y=s.cwd():(y=s.env[`=${r}`]||s.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==r.toLowerCase()&&y.charCodeAt(2)===a)&&(y=`${r}\\`));const D=y.length;let w=0,P="",k=!1;const E=y.charCodeAt(0);if(D===1)m(E)&&(w=1,k=!0);else if(m(E))if(k=!0,m(y.charCodeAt(1))){let S=2,M=S;for(;S<D&&!m(y.charCodeAt(S));)S++;if(S<D&&S!==M){const N=y.slice(M,S);for(M=S;S<D&&m(y.charCodeAt(S));)S++;if(S<D&&S!==M){for(M=S;S<D&&!m(y.charCodeAt(S));)S++;(S===D||S!==M)&&(P=`\\\\${N}\\${y.slice(M,S)}`,w=S)}}}else w=1;else g(E)&&y.charCodeAt(1)===I&&(P=y.slice(0,2),w=2,D>2&&m(y.charCodeAt(2))&&(k=!0,w=3));if(P.length>0)if(r.length>0){if(P.toLowerCase()!==r.toLowerCase())continue}else r=P;if(u){if(r.length>0)break}else if(f=`${y.slice(w)}\\${f}`,u=k,k&&r.length>0)break}return f=n(f,!u,"\\",m),u?`${r}\\${f}`:`${r}${f}`||"."},normalize(i){b(i,"path");const r=i.length;if(r===0)return".";let f=0,u,v=!1;const y=i.charCodeAt(0);if(r===1)return h(y)?"\\":i;if(m(y))if(v=!0,m(i.charCodeAt(1))){let w=2,P=w;for(;w<r&&!m(i.charCodeAt(w));)w++;if(w<r&&w!==P){const k=i.slice(P,w);for(P=w;w<r&&m(i.charCodeAt(w));)w++;if(w<r&&w!==P){for(P=w;w<r&&!m(i.charCodeAt(w));)w++;if(w===r)return`\\\\${k}\\${i.slice(P)}\\`;w!==P&&(u=`\\\\${k}\\${i.slice(P,w)}`,f=w)}}}else f=1;else g(y)&&i.charCodeAt(1)===I&&(u=i.slice(0,2),f=2,r>2&&m(i.charCodeAt(2))&&(v=!0,f=3));let D=f<r?n(i.slice(f),!v,"\\",m):"";return D.length===0&&!v&&(D="."),D.length>0&&m(i.charCodeAt(r-1))&&(D+="\\"),u===void 0?v?`\\${D}`:D:v?`${u}\\${D}`:`${u}${D}`},isAbsolute(i){b(i,"path");const r=i.length;if(r===0)return!1;const f=i.charCodeAt(0);return m(f)||r>2&&g(f)&&i.charCodeAt(1)===I&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,f;for(let y=0;y<i.length;++y){const D=i[y];b(D,"path"),D.length>0&&(r===void 0?r=f=D:r+=`\\${D}`)}if(r===void 0)return".";let u=!0,v=0;if(typeof f=="string"&&m(f.charCodeAt(0))){++v;const y=f.length;y>1&&m(f.charCodeAt(1))&&(++v,y>2&&(m(f.charCodeAt(2))?++v:u=!1))}if(u){for(;v<r.length&&m(r.charCodeAt(v));)v++;v>=2&&(r=`\\${r.slice(v)}`)}return e.win32.normalize(r)},relative(i,r){if(b(i,"from"),b(r,"to"),i===r)return"";const f=e.win32.resolve(i),u=e.win32.resolve(r);if(f===u||(i=f.toLowerCase(),r=u.toLowerCase(),i===r))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===a;)v++;let y=i.length;for(;y-1>v&&i.charCodeAt(y-1)===a;)y--;const D=y-v;let w=0;for(;w<r.length&&r.charCodeAt(w)===a;)w++;let P=r.length;for(;P-1>w&&r.charCodeAt(P-1)===a;)P--;const k=P-w,E=D<k?D:k;let S=-1,M=0;for(;M<E;M++){const O=i.charCodeAt(v+M);if(O!==r.charCodeAt(w+M))break;O===a&&(S=M)}if(M!==E){if(S===-1)return u}else{if(k>E){if(r.charCodeAt(w+M)===a)return u.slice(w+M+1);if(M===2)return u.slice(w+M)}D>E&&(i.charCodeAt(v+M)===a?S=M:M===2&&(S=3)),S===-1&&(S=0)}let N="";for(M=v+S+1;M<=y;++M)(M===y||i.charCodeAt(M)===a)&&(N+=N.length===0?"..":"\\..");return w+=S,N.length>0?`${N}${u.slice(w,P)}`:(u.charCodeAt(w)===a&&++w,u.slice(w,P))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===a){if(r.charCodeAt(1)===a){const f=r.charCodeAt(2);if(f!==_&&f!==A)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===I&&r.charCodeAt(2)===a)return`\\\\?\\${r}`;return i},dirname(i){b(i,"path");const r=i.length;if(r===0)return".";let f=-1,u=0;const v=i.charCodeAt(0);if(r===1)return m(v)?i:".";if(m(v)){if(f=u=1,m(i.charCodeAt(1))){let w=2,P=w;for(;w<r&&!m(i.charCodeAt(w));)w++;if(w<r&&w!==P){for(P=w;w<r&&m(i.charCodeAt(w));)w++;if(w<r&&w!==P){for(P=w;w<r&&!m(i.charCodeAt(w));)w++;if(w===r)return i;w!==P&&(f=u=w+1)}}}}else g(v)&&i.charCodeAt(1)===I&&(f=r>2&&m(i.charCodeAt(2))?3:2,u=f);let y=-1,D=!0;for(let w=r-1;w>=u;--w)if(m(i.charCodeAt(w))){if(!D){y=w;break}}else D=!1;if(y===-1){if(f===-1)return".";y=f}return i.slice(0,y)},basename(i,r){r!==void 0&&b(r,"ext"),b(i,"path");let f=0,u=-1,v=!0,y;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(f=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let D=r.length-1,w=-1;for(y=i.length-1;y>=f;--y){const P=i.charCodeAt(y);if(m(P)){if(!v){f=y+1;break}}else w===-1&&(v=!1,w=y+1),D>=0&&(P===r.charCodeAt(D)?--D===-1&&(u=y):(D=-1,u=w))}return f===u?u=w:u===-1&&(u=i.length),i.slice(f,u)}for(y=i.length-1;y>=f;--y)if(m(i.charCodeAt(y))){if(!v){f=y+1;break}}else u===-1&&(v=!1,u=y+1);return u===-1?"":i.slice(f,u)},extname(i){b(i,"path");let r=0,f=-1,u=0,v=-1,y=!0,D=0;i.length>=2&&i.charCodeAt(1)===I&&g(i.charCodeAt(0))&&(r=u=2);for(let w=i.length-1;w>=r;--w){const P=i.charCodeAt(w);if(m(P)){if(!y){u=w+1;break}continue}v===-1&&(y=!1,v=w+1),P===A?f===-1?f=w:D!==1&&(D=1):f!==-1&&(D=-1)}return f===-1||v===-1||D===0||D===1&&f===v-1&&f===u+1?"":i.slice(f,v)},format:o.bind(null,"\\"),parse(i){b(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const f=i.length;let u=0,v=i.charCodeAt(0);if(f===1)return m(v)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(m(v)){if(u=1,m(i.charCodeAt(1))){let S=2,M=S;for(;S<f&&!m(i.charCodeAt(S));)S++;if(S<f&&S!==M){for(M=S;S<f&&m(i.charCodeAt(S));)S++;if(S<f&&S!==M){for(M=S;S<f&&!m(i.charCodeAt(S));)S++;S===f?u=S:S!==M&&(u=S+1)}}}}else if(g(v)&&i.charCodeAt(1)===I){if(f<=2)return r.root=r.dir=i,r;if(u=2,m(i.charCodeAt(2))){if(f===3)return r.root=r.dir=i,r;u=3}}u>0&&(r.root=i.slice(0,u));let y=-1,D=u,w=-1,P=!0,k=i.length-1,E=0;for(;k>=u;--k){if(v=i.charCodeAt(k),m(v)){if(!P){D=k+1;break}continue}w===-1&&(P=!1,w=k+1),v===A?y===-1?y=k:E!==1&&(E=1):y!==-1&&(E=-1)}return w!==-1&&(y===-1||E===0||E===1&&y===w-1&&y===D+1?r.base=r.name=i.slice(D,w):(r.name=i.slice(D,y),r.base=i.slice(D,w),r.ext=i.slice(y,w))),D>0&&D!==u?r.dir=i.slice(0,D-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(l){const i=/\\/g;return()=>{const r=s.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>s.cwd()})();e.posix={resolve(...i){let r="",f=!1;for(let u=i.length-1;u>=-1&&!f;u--){const v=u>=0?i[u]:t();b(v,"path"),v.length!==0&&(r=`${v}/${r}`,f=v.charCodeAt(0)===p)}return r=n(r,!f,"/",h),f?`/${r}`:r.length>0?r:"."},normalize(i){if(b(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===p,f=i.charCodeAt(i.length-1)===p;return i=n(i,!r,"/",h),i.length===0?r?"/":f?"./":".":(f&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return b(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let r;for(let f=0;f<i.length;++f){const u=i[f];b(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(b(i,"from"),b(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const f=1,u=i.length,v=u-f,y=1,D=r.length-y,w=v<D?v:D;let P=-1,k=0;for(;k<w;k++){const S=i.charCodeAt(f+k);if(S!==r.charCodeAt(y+k))break;S===p&&(P=k)}if(k===w)if(D>w){if(r.charCodeAt(y+k)===p)return r.slice(y+k+1);if(k===0)return r.slice(y+k)}else v>w&&(i.charCodeAt(f+k)===p?P=k:k===0&&(P=0));let E="";for(k=f+P+1;k<=u;++k)(k===u||i.charCodeAt(k)===p)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(y+P)}`},toNamespacedPath(i){return i},dirname(i){if(b(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===p;let f=-1,u=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===p){if(!u){f=v;break}}else u=!1;return f===-1?r?"/":".":r&&f===1?"//":i.slice(0,f)},basename(i,r){r!==void 0&&b(r,"ext"),b(i,"path");let f=0,u=-1,v=!0,y;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let D=r.length-1,w=-1;for(y=i.length-1;y>=0;--y){const P=i.charCodeAt(y);if(P===p){if(!v){f=y+1;break}}else w===-1&&(v=!1,w=y+1),D>=0&&(P===r.charCodeAt(D)?--D===-1&&(u=y):(D=-1,u=w))}return f===u?u=w:u===-1&&(u=i.length),i.slice(f,u)}for(y=i.length-1;y>=0;--y)if(i.charCodeAt(y)===p){if(!v){f=y+1;break}}else u===-1&&(v=!1,u=y+1);return u===-1?"":i.slice(f,u)},extname(i){b(i,"path");let r=-1,f=0,u=-1,v=!0,y=0;for(let D=i.length-1;D>=0;--D){const w=i.charCodeAt(D);if(w===p){if(!v){f=D+1;break}continue}u===-1&&(v=!1,u=D+1),w===A?r===-1?r=D:y!==1&&(y=1):r!==-1&&(y=-1)}return r===-1||u===-1||y===0||y===1&&r===u-1&&r===f+1?"":i.slice(r,u)},format:o.bind(null,"/"),parse(i){b(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const f=i.charCodeAt(0)===p;let u;f?(r.root="/",u=1):u=0;let v=-1,y=0,D=-1,w=!0,P=i.length-1,k=0;for(;P>=u;--P){const E=i.charCodeAt(P);if(E===p){if(!w){y=P+1;break}continue}D===-1&&(w=!1,D=P+1),E===A?v===-1?v=P:k!==1&&(k=1):v!==-1&&(k=-1)}if(D!==-1){const E=y===0&&f?1:y;v===-1||k===0||k===1&&v===D-1&&v===y+1?r.base=r.name=i.slice(E,D):(r.name=i.slice(E,v),r.base=i.slice(E,D),r.ext=i.slice(v,D))}return y>0?r.dir=i.slice(0,y-1):f&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l?e.win32.normalize:e.posix.normalize,e.isAbsolute=l?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l?e.win32.join:e.posix.join,e.resolve=l?e.win32.resolve:e.posix.resolve,e.relative=l?e.win32.relative:e.posix.relative,e.dirname=l?e.win32.dirname:e.posix.dirname,e.basename=l?e.win32.basename:e.posix.basename,e.extname=l?e.win32.extname:e.posix.extname,e.format=l?e.win32.format:e.posix.format,e.parse=l?e.win32.parse:e.posix.parse,e.toNamespacedPath=l?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l?e.win32.sep:e.posix.sep,e.delimiter=l?e.win32.delimiter:e.posix.delimiter}),define(_e[140],ye([1,0,49,17]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=A,e.compareFileNamesDefault=p,e.compareFileNamesUpper=a,e.compareFileNamesLower=I,e.compareFileNamesUnicode=_,e.compareFileExtensions=c,e.compareFileExtensionsDefault=C,e.compareFileExtensionsUpper=b,e.compareFileExtensionsLower=l,e.compareFileExtensionsUnicode=m,e.comparePaths=v,e.compareAnything=y,e.compareByPrefix=D;const T=new s.Lazy(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),R=new s.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new s.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(w,P,k=!1){const E=w||"",S=P||"",M=T.value.collator.compare(E,S);return T.value.collatorIsNumeric&&M===0&&E!==S?E<S?-1:1:M}function p(w,P){const k=R.value.collator;return w=w||"",P=P||"",o(k,w,P)}function a(w,P){const k=R.value.collator;return w=w||"",P=P||"",f(w,P)||o(k,w,P)}function I(w,P){const k=R.value.collator;return w=w||"",P=P||"",r(w,P)||o(k,w,P)}function _(w,P){return w=w||"",P=P||"",w===P?0:w<P?-1:1}function c(w,P){const[k,E]=g(w),[S,M]=g(P);let N=T.value.collator.compare(E,M);if(N===0){if(T.value.collatorIsNumeric&&E!==M)return E<M?-1:1;if(N=T.value.collator.compare(k,S),T.value.collatorIsNumeric&&N===0&&k!==S)return k<S?-1:1}return N}function C(w,P){w=w||"",P=P||"";const k=n(w),E=n(P),S=R.value.collator,M=L.value.collator;return o(M,k,E)||o(S,w,P)}function b(w,P){w=w||"",P=P||"";const k=n(w),E=n(P),S=R.value.collator,M=L.value.collator;return o(M,k,E)||f(w,P)||o(S,w,P)}function l(w,P){w=w||"",P=P||"";const k=n(w),E=n(P),S=R.value.collator,M=L.value.collator;return o(M,k,E)||r(w,P)||o(S,w,P)}function m(w,P){w=w||"",P=P||"";const k=n(w).toLowerCase(),E=n(P).toLowerCase();return k!==E?k<E?-1:1:w!==P?w<P?-1:1:0}const h=/^(.*?)(\.([^.]*))?$/;function g(w,P=!1){const k=w?h.exec(w):[];let E=[k&&k[1]||"",k&&k[3]||""];return P&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(w){const P=w?h.exec(w):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function o(w,P,k){const E=w.compare(P,k);return E!==0?E:P.length!==k.length?P.length<k.length?-1:1:0}function t(w){const P=w.charAt(0);return P.toLocaleUpperCase()!==P}function i(w){const P=w.charAt(0);return P.toLocaleLowerCase()!==P}function r(w,P){return t(w)&&i(P)?-1:i(w)&&t(P)?1:0}function f(w,P){return i(w)&&t(P)?-1:t(w)&&i(P)?1:0}function u(w,P,k=!1){return k||(w=w&&w.toLowerCase(),P=P&&P.toLowerCase()),w===P?0:w<P?-1:1}function v(w,P,k=!1){const E=w.split(d.sep),S=P.split(d.sep),M=E.length-1,N=S.length-1;let O,x;for(let U=0;;U++){if(O=M===U,x=N===U,O&&x)return A(E[U],S[U],k);if(O)return-1;if(x)return 1;const F=u(E[U],S[U],k);if(F!==0)return F}}function y(w,P,k){const E=w.toLowerCase(),S=P.toLowerCase(),M=D(w,P,k);if(M)return M;const N=E.endsWith(k),O=S.endsWith(k);if(N!==O)return N?-1:1;const x=A(E,S);return x!==0?x:E.localeCompare(S)}function D(w,P,k){const E=w.toLowerCase(),S=P.toLowerCase(),M=E.startsWith(k),N=S.startsWith(k);if(M!==N)return M?-1:1;if(M&&N){if(E.length<S.length)return-1;if(E.length>S.length)return 1}return 0}}),define(_e[33],ye([1,0,27,17,11,13,18]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=A,e.toSlashes=p,e.toPosixPath=a,e.getRoot=I,e.isUNC=_,e.isValidBasename=l,e.isEqual=m,e.isEqualOrParent=h,e.isWindowsDriveLetter=g,e.sanitizeFilePath=n,e.removeTrailingPathSeparator=o,e.isRootOrDriveLetter=t,e.hasDriveLetter=i,e.getDriveLetter=r,e.indexOfPath=f,e.parseLineAndColumnAware=u,e.randomPath=D;function A(w){return w===s.CharCode.Slash||w===s.CharCode.Backslash}function p(w){return w.replace(/[\\/]/g,d.posix.sep)}function a(w){return w.indexOf("/")===-1&&(w=p(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function I(w,P=d.posix.sep){if(!w)return"";const k=w.length,E=w.charCodeAt(0);if(A(E)){if(A(w.charCodeAt(1))&&!A(w.charCodeAt(2))){let M=3;const N=M;for(;M<k&&!A(w.charCodeAt(M));M++);if(N!==M&&!A(w.charCodeAt(M+1))){for(M+=1;M<k;M++)if(A(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(g(E)&&w.charCodeAt(1)===s.CharCode.Colon)return A(w.charCodeAt(2))?w.slice(0,2)+P:w.slice(0,2);let S=w.indexOf("://");if(S!==-1){for(S+=3;S<k;S++)if(A(w.charCodeAt(S)))return w.slice(0,S+1)}return""}function _(w){if(!T.isWindows||!w||w.length<5)return!1;let P=w.charCodeAt(0);if(P!==s.CharCode.Backslash||(P=w.charCodeAt(1),P!==s.CharCode.Backslash))return!1;let k=2;const E=k;for(;k<w.length&&(P=w.charCodeAt(k),P!==s.CharCode.Backslash);k++);return!(E===k||(P=w.charCodeAt(k+1),isNaN(P)||P===s.CharCode.Backslash))}const c=/[\\/:\*\?"<>\|]/g,C=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(w,P=T.isWindows){const k=P?c:C;return!(!w||w.length===0||/^\s+$/.test(w)||(k.lastIndex=0,k.test(w))||P&&b.test(w)||w==="."||w===".."||P&&w[w.length-1]==="."||P&&w.length!==w.trim().length||w.length>255)}function m(w,P,k){const E=w===P;return!k||E?E:!w||!P?!1:(0,R.equalsIgnoreCase)(w,P)}function h(w,P,k,E=d.sep){if(w===P)return!0;if(!w||!P||P.length>w.length)return!1;if(k){if(!(0,R.startsWithIgnoreCase)(w,P))return!1;if(P.length===w.length)return!0;let M=P.length;return P.charAt(P.length-1)===E&&M--,w.charAt(M)===E}return P.charAt(P.length-1)!==E&&(P+=E),w.indexOf(P)===0}function g(w){return w>=s.CharCode.A&&w<=s.CharCode.Z||w>=s.CharCode.a&&w<=s.CharCode.z}function n(w,P){return T.isWindows&&w.endsWith(":")&&(w+=d.sep),(0,d.isAbsolute)(w)||(w=(0,d.join)(P,w)),w=(0,d.normalize)(w),o(w)}function o(w){return T.isWindows?(w=(0,R.rtrim)(w,d.sep),w.endsWith(":")&&(w+=d.sep)):(w=(0,R.rtrim)(w,d.sep),w||(w=d.sep)),w}function t(w){const P=(0,d.normalize)(w);return T.isWindows?w.length>3?!1:i(P)&&(w.length===2||P.charCodeAt(2)===s.CharCode.Backslash):P===d.posix.sep}function i(w,P=T.isWindows){return P?g(w.charCodeAt(0))&&w.charCodeAt(1)===s.CharCode.Colon:!1}function r(w,P=T.isWindows){return i(w,P)?w[0]:void 0}function f(w,P,k){return P.length>w.length?-1:w===P?0:(k&&(w=w.toLowerCase(),P=P.toLowerCase()),w.indexOf(P))}function u(w){const P=w.split(":");let k,E,S;for(const M of P){const N=Number(M);(0,L.isNumber)(N)?E===void 0?E=N:S===void 0&&(S=N):k=k?[k,M].join(":"):M}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:E!==void 0?E:void 0,column:S!==void 0?S:E!==void 0?1:void 0}}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,P,k=8){let E="";for(let M=0;M<k;M++){let N;M===0&&T.isWindows&&!P&&(k===3||k===4)?N=y:N=v,E+=N.charAt(Math.floor(Math.random()*N.length))}let S;return P?S=`${P}-${E}`:S=E,w?(0,d.join)(w,S):S}}),define(_e[141],ye([1,0,27,140,135,60,17,11,13]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=_,e.scoreFuzzy2=h,e.scoreItemFuzzy=u,e.compareItemsByFuzzyScore=E,e.prepareQuery=U,e.pieceToQuery=H;const a=0,I=[a,[]];function _(j,re,B,V){if(!j||!re)return I;const X=j.length,ee=re.length;if(X<ee)return I;const he=j.toLowerCase();return c(re,B,ee,j,he,X,V)}function c(j,re,B,V,X,ee,he){const ne=[],De=[];for(let se=0;se<B;se++){const ae=se*ee,te=ae-ee,ce=se>0,ue=j[se],Y=re[se];for(let oe=0;oe<ee;oe++){const ve=oe>0,be=ae+oe,Fe=be-1,We=te+oe-1,Ce=ve?ne[Fe]:0,Ie=ce&&ve?ne[We]:0,Re=ce&&ve?De[We]:0;let z;!Ie&&ce?z=0:z=C(ue,Y,V,X,oe,Re),z&&Ie+z>=Ce&&(he||ce||X.startsWith(re,oe))?(De[be]=Re+1,ne[be]=Ie+z):(De[be]=a,ne[be]=Ce)}}const pe=[];let G=B-1,W=ee-1;for(;G>=0&&W>=0;){const se=G*ee+W;De[se]===a||(pe.push(W),G--),W--}return[ne[B*ee-1],pe.reverse()]}function C(j,re,B,V,X,ee){let he=0;if(!b(re,V[X]))return he;if(he+=1,ee>0&&(he+=ee*5),j===B[X]&&(he+=1),X===0)he+=8;else{const ne=l(B.charCodeAt(X-1));ne?he+=ne:(0,T.isUpper)(B.charCodeAt(X))&&ee===0&&(he+=2)}return he}function b(j,re){return j===re?!0:j==="/"||j==="\\"?re==="/"||re==="\\":!1}function l(j){switch(j){case s.CharCode.Slash:case s.CharCode.Backslash:return 5;case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function h(j,re,B=0,V=0){const X=re;return X.values&&X.values.length>1?g(j,X.values,B,V):n(j,re,B,V)}function g(j,re,B,V){let X=0;const ee=[];for(const he of re){const[ne,De]=n(j,he,B,V);if(typeof ne!="number")return m;X+=ne,ee.push(...De)}return[X,P(ee)]}function n(j,re,B,V){const X=(0,T.fuzzyScore)(re.original,re.originalLowercase,B,j,j.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,T.createMatches)(X)]:m}const o=Object.freeze({score:0}),t=1<<18,i=1<<17,r=65536;function f(j,re,B,V){const X=V.values?V.values:[V];return(0,R.hash)({[V.normalized]:{values:X.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:j,description:re,allowNonContiguousMatches:B}})}function u(j,re,B,V,X){if(!j||!re.normalized)return o;const ee=V.getItemLabel(j);if(!ee)return o;const he=V.getItemDescription(j),ne=f(ee,he,B,re),De=X[ne];if(De)return De;const pe=v(ee,he,V.getItemPath(j),re,B);return X[ne]=pe,pe}function v(j,re,B,V,X){const ee=!B||!V.containsPathSeparator;return B&&(A.isLinux?V.pathNormalized===B:(0,p.equalsIgnoreCase)(V.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:j.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:V.values&&V.values.length>1?y(j,re,B,V.values,ee,X):D(j,re,B,V,ee,X)}function y(j,re,B,V,X,ee){let he=0;const ne=[],De=[];for(const pe of V){const{score:G,labelMatch:W,descriptionMatch:se}=D(j,re,B,pe,X,ee);if(G===a)return o;he+=G,W&&ne.push(...W),se&&De.push(...se)}return{score:he,labelMatch:P(ne),descriptionMatch:P(De)}}function D(j,re,B,V,X,ee){if(X||!re){const[he,ne]=_(j,V.normalized,V.normalizedLowercase,ee&&!V.expectContiguousMatch);if(he){const De=(0,T.matchesPrefix)(V.normalized,j);let pe;if(De){pe=i;const G=Math.round(V.normalized.length/j.length*100);pe+=G}else pe=r;return{score:pe+he,labelMatch:De||w(ne)}}}if(re){let he=re;B&&(he=`${re}${L.sep}`);const ne=he.length,De=`${he}${j}`,[pe,G]=_(De,V.normalized,V.normalizedLowercase,ee&&!V.expectContiguousMatch);if(pe){const W=w(G),se=[],ae=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),ae.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):ae.push(te)}),{score:pe,labelMatch:se,descriptionMatch:ae}}}return o}function w(j){const re=[];if(!j)return re;let B;for(const V of j)B&&B.end===V?B.end+=1:(B={start:V,end:V+1},re.push(B));return re}function P(j){const re=j.sort((X,ee)=>X.start-ee.start),B=[];let V;for(const X of re)!V||!k(V,X)?(V=X,B.push(X)):(V.start=Math.min(V.start,X.start),V.end=Math.max(V.end,X.end));return B}function k(j,re){return!(j.end<re.start||re.end<j.start)}function E(j,re,B,V,X,ee){const he=u(j,B,V,X,ee),ne=u(re,B,V,X,ee),De=he.score,pe=ne.score;if((De===t||pe===t)&&De!==pe)return De===t?-1:1;if(De>r||pe>r){if(De!==pe)return De>pe?-1:1;if(De<i&&pe<i){const ue=M(he.labelMatch,ne.labelMatch);if(ue!==0)return ue}const te=X.getItemLabel(j)||"",ce=X.getItemLabel(re)||"";if(te.length!==ce.length)return te.length-ce.length}if(De!==pe)return De>pe?-1:1;const G=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(G&&!W)return-1;if(W&&!G)return 1;const se=S(j,he,X),ae=S(re,ne,X);return se&&ae&&se!==ae?ae>se?-1:1:N(j,re,B,X)}function S(j,re,B){let V=-1,X=-1;if(re.descriptionMatch&&re.descriptionMatch.length?V=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(V=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(X=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=B.getItemDescription(j);ee&&(X+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(X=re.descriptionMatch[re.descriptionMatch.length-1].end);return X-V}function M(j,re){if(!j&&!re||(!j||!j.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!j||!j.length)return 1;const B=j[0].start,X=j[j.length-1].end-B,ee=re[0].start,ne=re[re.length-1].end-ee;return X===ne?0:ne<X?1:-1}function N(j,re,B,V){const X=V.getItemLabel(j)||"",ee=V.getItemLabel(re)||"",he=V.getItemDescription(j),ne=V.getItemDescription(re),De=X.length+(he?he.length:0),pe=ee.length+(ne?ne.length:0);if(De!==pe)return De-pe;const G=V.getItemPath(j),W=V.getItemPath(re);return G&&W&&G.length!==W.length?G.length-W.length:X!==ee?(0,d.compareAnything)(X,ee,B.normalized):he&&ne&&he!==ne?(0,d.compareAnything)(he,ne,B.normalized):G&&W&&G!==W?(0,d.compareAnything)(G,W,B.normalized):0}function O(j){return j.startsWith('"')&&j.endsWith('"')}const x=" ";function U(j){typeof j!="string"&&(j="");const re=j.toLowerCase(),{pathNormalized:B,normalized:V,normalizedLowercase:X}=F(j),ee=B.indexOf(L.sep)>=0,he=O(j);let ne;const De=j.split(x);if(De.length>1)for(const pe of De){const G=O(pe),{pathNormalized:W,normalized:se,normalizedLowercase:ae}=F(pe);se&&(ne||(ne=[]),ne.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:ae,expectContiguousMatch:G}))}return{original:j,originalLowercase:re,pathNormalized:B,normalized:V,normalizedLowercase:X,values:ne,containsPathSeparator:ee,expectContiguousMatch:he}}function F(j){let re;A.isWindows?re=j.replace(/\//g,L.sep):re=j.replace(/\\/g,L.sep);const B=(0,p.stripWildcards)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:B,normalizedLowercase:B.toLowerCase()}}function H(j){return Array.isArray(j)?U(j.map(re=>re.original).join(x)):U(j.original)}}),define(_e[108],ye([1,0,17]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=R,e.getMediaMime=L,e.getExtensionForMimeType=A,e.normalizeMimeType=a,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const d={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const _=(0,s.extname)(I),c=d[_.toLowerCase()];return c!==void 0?c:L(I)}function L(I){const _=(0,s.extname)(I);return T[_.toLowerCase()]}function A(I){for(const _ in T)if(T[_]===I)return _}const p=/^(.+)\/(.+?)(;.+)?$/;function a(I,_){const c=p.exec(I);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:_?void 0:I}}),define(_e[109],ye([1,0,11]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=R,e.removeDangerousEnvVariables=L;var d;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(d||(e.Source=d={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function R(A,...p){const a=p.reduce((c,C)=>(c[C]=!0,c),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(c=>!a[c]).forEach(c=>{for(let C=0;C<I.length;C++)if(c.search(I[C])!==-1){delete A[c];break}})}function L(A){A&&(delete A.DEBUG,s.isMacintosh&&delete A.DYLD_LIBRARY_PATH,s.isLinux&&delete A.LD_PRELOAD)}}),define(_e[2],ye([1,0,27,41,17,11]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=i,T=ze(T);const L=/^\w[\w\d+.-]*$/,A=/^\//,p=/^\/\//;function a(y,D){if(!y.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!L.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!A.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,D){return!y&&!D?"file":y}function _(y,D){switch(y){case"https":case"http":case"file":D?D[0]!==C&&(D=C+D):D=C;break}return D}const c="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(D){return D instanceof l?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,w,P,k,E,S=!1){typeof D=="object"?(this.scheme=D.scheme||c,this.authority=D.authority||c,this.path=D.path||c,this.query=D.query||c,this.fragment=D.fragment||c):(this.scheme=I(D,S),this.authority=w||c,this.path=_(this.scheme,P||c),this.query=k||c,this.fragment=E||c,a(this,S))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:w,authority:P,path:k,query:E,fragment:S}=D;return w===void 0?w=this.scheme:w===null&&(w=c),P===void 0?P=this.authority:P===null&&(P=c),k===void 0?k=this.path:k===null&&(k=c),E===void 0?E=this.query:E===null&&(E=c),S===void 0?S=this.fragment:S===null&&(S=c),w===this.scheme&&P===this.authority&&k===this.path&&E===this.query&&S===this.fragment?this:new g(w,P,k,E,S)}static parse(D,w=!1){const P=b.exec(D);return P?new g(P[2]||c,v(P[4]||c),v(P[5]||c),v(P[7]||c),v(P[9]||c),w):new g(c,c,c,c,c)}static file(D){let w=c;if(R.isWindows&&(D=D.replace(/\\/g,C)),D[0]===C&&D[1]===C){const P=D.indexOf(C,2);P===-1?(w=D.substring(2),D=C):(w=D.substring(2,P),D=D.substring(P)||C)}return new g("file",w,D,c,c)}static from(D,w){return new g(D.scheme,D.authority,D.path,D.query,D.fragment,w)}static joinPath(D,...w){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return R.isWindows&&D.scheme==="file"?P=l.file(T.win32.join(i(D,!0),...w)).path:P=T.posix.join(D.path,...w),D.with({path:P})}toString(D=!1){return r(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof l)return D;{const w=new g(D);return w._formatted=D.external??null,w._fsPath=D._sep===h?D.fsPath??null:null,w}}else return D}}e.URI=l;function m(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const h=R.isWindows?1:void 0;class g extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const D={$mid:d.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=h),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[s.CharCode.Colon]:"%3A",[s.CharCode.Slash]:"%2F",[s.CharCode.QuestionMark]:"%3F",[s.CharCode.Hash]:"%23",[s.CharCode.OpenSquareBracket]:"%5B",[s.CharCode.CloseSquareBracket]:"%5D",[s.CharCode.AtSign]:"%40",[s.CharCode.ExclamationMark]:"%21",[s.CharCode.DollarSign]:"%24",[s.CharCode.Ampersand]:"%26",[s.CharCode.SingleQuote]:"%27",[s.CharCode.OpenParen]:"%28",[s.CharCode.CloseParen]:"%29",[s.CharCode.Asterisk]:"%2A",[s.CharCode.Plus]:"%2B",[s.CharCode.Comma]:"%2C",[s.CharCode.Semicolon]:"%3B",[s.CharCode.Equals]:"%3D",[s.CharCode.Space]:"%20"};function o(y,D,w){let P,k=-1;for(let E=0;E<y.length;E++){const S=y.charCodeAt(E);if(S>=s.CharCode.a&&S<=s.CharCode.z||S>=s.CharCode.A&&S<=s.CharCode.Z||S>=s.CharCode.Digit0&&S<=s.CharCode.Digit9||S===s.CharCode.Dash||S===s.CharCode.Period||S===s.CharCode.Underline||S===s.CharCode.Tilde||D&&S===s.CharCode.Slash||w&&S===s.CharCode.OpenSquareBracket||w&&S===s.CharCode.CloseSquareBracket||w&&S===s.CharCode.Colon)k!==-1&&(P+=encodeURIComponent(y.substring(k,E)),k=-1),P!==void 0&&(P+=y.charAt(E));else{P===void 0&&(P=y.substr(0,E));const M=n[S];M!==void 0?(k!==-1&&(P+=encodeURIComponent(y.substring(k,E)),k=-1),P+=M):k===-1&&(k=E)}}return k!==-1&&(P+=encodeURIComponent(y.substring(k))),P!==void 0?P:y}function t(y){let D;for(let w=0;w<y.length;w++){const P=y.charCodeAt(w);P===s.CharCode.Hash||P===s.CharCode.QuestionMark?(D===void 0&&(D=y.substr(0,w)),D+=n[P]):D!==void 0&&(D+=y[w])}return D!==void 0?D:y}function i(y,D){let w;return y.authority&&y.path.length>1&&y.scheme==="file"?w=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===s.CharCode.Slash&&(y.path.charCodeAt(1)>=s.CharCode.A&&y.path.charCodeAt(1)<=s.CharCode.Z||y.path.charCodeAt(1)>=s.CharCode.a&&y.path.charCodeAt(1)<=s.CharCode.z)&&y.path.charCodeAt(2)===s.CharCode.Colon?D?w=y.path.substr(1):w=y.path[1].toLowerCase()+y.path.substr(2):w=y.path,R.isWindows&&(w=w.replace(/\//g,"\\")),w}function r(y,D){const w=D?t:o;let P="",{scheme:k,authority:E,path:S,query:M,fragment:N}=y;if(k&&(P+=k,P+=":"),(E||k==="file")&&(P+=C,P+=C),E){let O=E.indexOf("@");if(O!==-1){const x=E.substr(0,O);E=E.substr(O+1),O=x.lastIndexOf(":"),O===-1?P+=w(x,!1,!1):(P+=w(x.substr(0,O),!1,!1),P+=":",P+=w(x.substr(O+1),!1,!0)),P+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?P+=w(E,!1,!0):(P+=w(E.substr(0,O),!1,!0),P+=E.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===s.CharCode.Slash&&S.charCodeAt(2)===s.CharCode.Colon){const O=S.charCodeAt(1);O>=s.CharCode.A&&O<=s.CharCode.Z&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===s.CharCode.Colon){const O=S.charCodeAt(0);O>=s.CharCode.A&&O<=s.CharCode.Z&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}P+=w(S,!0,!1)}return M&&(P+="?",P+=w(M,!1,!1)),N&&(P+="#",P+=D?N:o(N,!1,!1)),P}function f(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+f(y.substr(3)):y}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(y){return y.match(u)?y.replace(u,D=>f(D)):y}}),define(_e[207],ye([1,0,2]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=d,e.parse=T,e.getFirstFrame=R,e.log=A;function d(a){const I=a;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function T(a){const I=[];let _;try{const c=JSON.parse(a.arguments),C=c[c.length-1];C&&C.__$stack&&(c.pop(),_=C.__$stack),I.push(...c)}catch{I.push("Unable to log remote console arguments",a.arguments)}return{args:I,stack:_}}function R(a){if(typeof a!="string")return R(T(a).stack);const I=a;if(I){const _=L(I),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(c&&c.length===4)return{uri:s.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}function L(a){if(!a)return a;const I=a.indexOf(`
`);return I===-1?a:a.substring(0,I)}function A(a,I){const{args:_,stack:c}=T(a),C=typeof _[0]=="string"&&_.length===1;let b=L(c);b&&(b=`(${b.trim()})`);let l=[];if(typeof _[0]=="string"?b&&C?l=[`%c[${I}] %c${_[0]} %c${b}`,p("blue"),p(""),p("grey")]:l=[`%c[${I}] %c${_[0]}`,p("blue"),p(""),..._.slice(1)]:l=[`%c[${I}]%`,p("blue"),..._],b&&!C&&l.push(b),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,l)}function p(a){return`color: ${a}`}}),define(_e[57],ye([1,0,22,2,41]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=R,e.parse=L,e.revive=p;function R(a){return JSON.stringify(a,A)}function L(a){let I=JSON.parse(a);return I=p(I),I}function A(a,I){return I instanceof RegExp?{$mid:T.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(a,I=0){if(!a||I>200)return a;if(typeof a=="object"){switch(a.$mid){case T.MarshalledId.Uri:return d.URI.revive(a);case T.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case T.MarshalledId.Date:return new Date(a.source)}if(a instanceof s.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let _=0;_<a.length;++_)a[_]=p(a[_],I+1);else for(const _ in a)Object.hasOwnProperty.call(a,_)&&(a[_]=p(a[_],I+1))}return a}}),define(_e[15],ye([1,0,14,11,13,2,17]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=p,e.matchesSomeScheme=a,e.getServerRootPath=_,s=ze(s),d=ze(d),L=ze(L);var A;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(A||(e.Schemas=A={}));function p(b,l){return R.URI.isUri(b)?(0,T.equalsIgnoreCase)(b.scheme,l):(0,T.startsWithIgnoreCase)(b,l+":")}function a(b,...l){return l.some(m=>p(b,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l,m){this._serverRootPath=_(l,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return L.posix.join(this._serverRootPath,A.vscodeRemoteResource)}set(l,m,h){this._hosts[l]=m,this._ports[l]=h}setConnectionToken(l,m){this._connectionTokens[l]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)try{return this._delegate(l)}catch(t){return s.onUnexpectedError(t),l}const m=l.authority;let h=this._hosts[m];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this._ports[m],n=this._connectionTokens[m];let o=`path=${encodeURIComponent(l.path)}`;return typeof n=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),R.URI.from({scheme:d.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${h}:${g}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new I;function _(b,l){return L.posix.join(l??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class c{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(l){const m=this.toUri(l,le);return this.uriToBrowserUri(m)}uriToBrowserUri(l){return l.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(l):l.scheme===A.file&&(d.isNative||d.webWorkerOrigin===`${A.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?l.with({scheme:A.vscodeFileResource,authority:l.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):l}asFileUri(l){const m=this.toUri(l,le);return this.uriToFileUri(m)}uriToFileUri(l){return l.scheme===A.vscodeFileResource?l.with({scheme:A.file,authority:l.authority!==c.FALLBACK_AUTHORITY?l.authority:null,query:null,fragment:null}):l}toUri(l,m){return R.URI.isUri(l)?l:R.URI.parse(m.toUrl(l))}}e.FileAccess=new c;var C;(function(b){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(l.get("3"));const m="vscode-coi";function h(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const t=o?.get(m);if(t)return l.get(t)}b.getHeadersFromQuery=h;function g(n,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";n instanceof URLSearchParams?n.set(m,i):n[m]=i}b.addSearchParam=g})(C||(e.COI=C={}))}),define(_e[208],ye([1,0,174,15,11,2]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=I,T=ze(T);class L{constructor(c,C,b){this.id=c,this.dependencies=C,this.callback=b}}class A{static{this.INSTANCE=new A}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(c,C,b)=>{typeof c!="string"&&(b=C,C=c,c=null),(typeof C!="object"||!Array.isArray(C))&&(b=C,C=null),this._defineCalls.push(new L(c,C,b))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(c){if(c.startsWith(window.location.origin)||c.startsWith("vscode-file://vscode-app"))return c;throw new Error(`[trusted_script_src] Invalid script url: ${c}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(c){return c}})))}async load(c){this._initialize();const C=await(this._isWebWorker?this._workerLoadScript(c):this._isRenderer?this._rendererLoadScript(c):this._nodeJSLoadScript(c));if(!C)throw new Error(`Did not receive a define call from script ${c}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${c}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}_rendererLoadScript(c){return new Promise((C,b)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const m=()=>{l.removeEventListener("load",h),l.removeEventListener("error",g)},h=n=>{m(),C(this._defineCalls.pop())},g=n=>{m(),b(n)};l.addEventListener("load",h),l.addEventListener("error",g),this._amdPolicy&&(c=this._amdPolicy.createScriptURL(c)),l.setAttribute("src",c),window.document.getElementsByTagName("head")[0].appendChild(l)})}_workerLoadScript(c){return new Promise((C,b)=>{try{this._amdPolicy&&(c=this._amdPolicy.createScriptURL(c)),importScripts(c),C(this._defineCalls.pop())}catch(l){b(l)}})}async _nodeJSLoadScript(c){try{const C=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,m=R.URI.parse(c).fsPath,h=C.readFileSync(m).toString(),g=l.wrap(h.replace(/^#!.*/,""));return new b.Script(g).runInThisContext().apply(),this._defineCalls.pop()}catch(C){throw C}}}const p=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function I(_,c,C){if(s.isESM){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[_]&&(_=a[_]);const b=`${_}/${c}`;if(p.has(b))return p.get(b);let l;if(/^\w[\w\d+.-]*:\/\//.test(b))l=b;else{const n=`${C&&!T.isWeb?d.nodeModulesAsarPath:d.nodeModulesPath}/${b}`;l=d.FileAccess.asBrowserUri(n).toString(!0)}const m=A.INSTANCE.load(l);return p.set(b,m),m}else return await new Promise((b,l)=>{le([_],b,l)}).then(ze)}}),define(_e[23],ye([1,0,27,33,15,17,11,13,2]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=a,e.distinctParents=_,e.toLocalResource=C,d=ze(d),R=ze(R);function a(b){return(0,p.uriToFsPath)(b,!0)}class I{constructor(l){this._ignorePathCasing=l}compare(l,m,h=!1){return l===m?0:(0,A.compare)(this.getComparisonKey(l,h),this.getComparisonKey(m,h))}isEqual(l,m,h=!1){return l===m?!0:!l||!m?!1:this.getComparisonKey(l,h)===this.getComparisonKey(m,h)}getComparisonKey(l,m=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,m,h=!1){if(l.scheme===m.scheme){if(l.scheme===T.Schemas.file)return d.isEqualOrParent(a(l),a(m),this._ignorePathCasing(l))&&l.query===m.query&&(h||l.fragment===m.fragment);if((0,e.isEqualAuthority)(l.authority,m.authority))return d.isEqualOrParent(l.path,m.path,this._ignorePathCasing(l),"/")&&l.query===m.query&&(h||l.fragment===m.fragment)}return!1}joinPath(l,...m){return p.URI.joinPath(l,...m)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let m;return l.scheme===T.Schemas.file?m=p.URI.file(R.dirname(a(l))).path:(m=R.posix.dirname(l.path),l.authority&&m.length&&m.charCodeAt(0)!==s.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),m="/")),l.with({path:m})}normalizePath(l){if(!l.path.length)return l;let m;return l.scheme===T.Schemas.file?m=p.URI.file(R.normalize(a(l))).path:m=R.posix.normalize(l.path),l.with({path:m})}relativePath(l,m){if(l.scheme!==m.scheme||!(0,e.isEqualAuthority)(l.authority,m.authority))return;if(l.scheme===T.Schemas.file){const n=R.relative(a(l),a(m));return L.isWindows?d.toSlashes(n):n}let h=l.path||"/";const g=m.path||"/";if(this._ignorePathCasing(l)){let n=0;for(const o=Math.min(h.length,g.length);n<o&&!(h.charCodeAt(n)!==g.charCodeAt(n)&&h.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);h=g.substr(0,n)+h.substr(n)}return R.posix.relative(h,g)}resolvePath(l,m){if(l.scheme===T.Schemas.file){const h=p.URI.file(R.resolve(a(l),m));return l.with({authority:h.authority,path:h.path})}return m=d.toPosixPath(m),l.with({path:R.posix.resolve(l.path,m)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,m){return l===m||l!==void 0&&m!==void 0&&(0,A.equalsIgnoreCase)(l,m)}hasTrailingPathSeparator(l,m=R.sep){if(l.scheme===T.Schemas.file){const h=a(l);return h.length>d.getRoot(h).length&&h[h.length-1]===m}else{const h=l.path;return h.length>1&&h.charCodeAt(h.length-1)===s.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,m=R.sep){return(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,m=R.sep){let h=!1;if(l.scheme===T.Schemas.file){const g=a(l);h=g!==void 0&&g.length===d.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=l.path;h=g.length===1&&g.charCodeAt(g.length-1)===s.CharCode.Slash}return!h&&!(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path+"/"}):l}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(b=>b.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function _(b,l){const m=[];for(let h=0;h<b.length;h++){const g=l(b[h]);b.some((n,o)=>o===h?!1:(0,e.isEqualOrParent)(g,l(n)))||m.push(b[h])}return m}var c;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function l(m){const h=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,i]=o.split(":");t&&i&&h.set(t,i)});const n=m.path.substring(0,m.path.indexOf(";"));return n&&h.set(b.META_DATA_MIME,n),h}b.parseMetaData=l})(c||(e.DataUri=c={}));function C(b,l,m){if(l){let h=b.path;return h&&h[0]!==R.posix.sep&&(h=R.posix.sep+h),b.with({scheme:m,authority:l,path:h})}return b.with({scheme:m})}}),define(_e[9],ye([1,0,21,14,4,3,23,11,185,49]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=I,e.createCancelablePromise=_,e.raceCancellation=c,e.raceCancellationError=C,e.raceCancellablePromises=b,e.raceTimeout=l,e.asPromise=m,e.promiseWithResolvers=h,e.timeout=y,e.disposableTimeout=D,e.sequence=w,e.first=P,e.firstParallel=k,e.retry=V,e.createCancelableAsyncIterable=te;function I(ue){return!!ue&&typeof ue.then=="function"}function _(ue){const Y=new s.CancellationTokenSource,oe=ue(Y.token),ve=new Promise((be,Fe)=>{const We=Y.token.onCancellationRequested(()=>{We.dispose(),Fe(new d.CancellationError)});Promise.resolve(oe).then(Ce=>{We.dispose(),Y.dispose(),be(Ce)},Ce=>{We.dispose(),Y.dispose(),Fe(Ce)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(be,Fe){return ve.then(be,Fe)}catch(be){return this.then(void 0,be)}finally(be){return ve.finally(be)}}}function c(ue,Y,oe){return new Promise((ve,be)=>{const Fe=Y.onCancellationRequested(()=>{Fe.dispose(),ve(oe)});ue.then(ve,be).finally(()=>Fe.dispose())})}function C(ue,Y){return new Promise((oe,ve)=>{const be=Y.onCancellationRequested(()=>{be.dispose(),ve(new d.CancellationError)});ue.then(oe,ve).finally(()=>be.dispose())})}async function b(ue){let Y=-1;const oe=ue.map((ve,be)=>ve.then(Fe=>(Y=be,Fe)));try{return await Promise.race(oe)}finally{ue.forEach((ve,be)=>{be!==Y&&ve.cancel()})}}function l(ue,Y,oe){let ve;const be=setTimeout(()=>{ve?.(void 0),oe?.()},Y);return Promise.race([ue.finally(()=>clearTimeout(be)),new Promise(Fe=>ve=Fe)])}function m(ue){return new Promise((Y,oe)=>{const ve=ue();I(ve)?ve.then(Y,oe):Y(ve)})}function h(){let ue,Y;return{promise:new Promise((ve,be)=>{ue=ve,Y=be}),resolve:ue,reject:Y}}class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const oe=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ve=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ve};this.queuedPromise=new Promise(ve=>{this.activePromise.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.queuedPromise.then(oe,ve)})}return this.activePromise=Y(),new Promise((oe,ve)=>{this.activePromise.then(be=>{this.activePromise=null,oe(be)},be=>{this.activePromise=null,ve(be)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class n{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=n;class o{constructor(){this.promiseMap=new Map}queue(Y,oe){const be=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(Y)===be&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,be),be}}e.SequencerByKey=o;const t=(ue,Y)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,Y()},ue);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},i=ue=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,ue())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class r{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,oe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Fe)=>{this.doResolve=be,this.doReject=Fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const ve=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===p.MicrotaskDelay?i(ve):t(oe,ve),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new d.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class f{constructor(Y){this.delayer=new r(Y),this.throttler=new g}trigger(Y,oe){return this.delayer.trigger(()=>this.throttler.queue(Y),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=f;class u{constructor(){this._isOpen=!1,this._promise=new Promise((Y,oe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class v extends u{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function y(ue,Y){return Y?new Promise((oe,ve)=>{const be=setTimeout(()=>{Fe.dispose(),oe()},ue),Fe=Y.onCancellationRequested(()=>{clearTimeout(be),Fe.dispose(),ve(new d.CancellationError)})}):_(oe=>y(ue,oe))}function D(ue,Y=0,oe){const ve=setTimeout(()=>{ue(),oe&&be.dispose()},Y),be=(0,R.toDisposable)(()=>{clearTimeout(ve),oe?.deleteAndLeak(be)});return oe?.add(be),be}function w(ue){const Y=[];let oe=0;const ve=ue.length;function be(){return oe<ve?ue[oe++]():null}function Fe(We){We!=null&&Y.push(We);const Ce=be();return Ce?Ce.then(Fe):Promise.resolve(Y)}return Promise.resolve(null).then(Fe)}function P(ue,Y=ve=>!!ve,oe=null){let ve=0;const be=ue.length,Fe=()=>{if(ve>=be)return Promise.resolve(oe);const We=ue[ve++];return Promise.resolve(We()).then(Ie=>Y(Ie)?Promise.resolve(Ie):Fe())};return Fe()}function k(ue,Y=ve=>!!ve,oe=null){if(ue.length===0)return Promise.resolve(oe);let ve=ue.length;const be=()=>{ve=-1;for(const Fe of ue)Fe.cancel?.()};return new Promise((Fe,We)=>{for(const Ce of ue)Ce.then(Ie=>{--ve>=0&&Y(Ie)?(be(),Fe(Ie)):ve===0&&Fe(oe)}).catch(Ie=>{--ve>=0&&(be(),We(Ie))})})}class E{constructor(Y){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((oe,ve)=>{this.outstandingPromises.push({factory:Y,c:oe,e:ve}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const oe=Y.factory();oe.then(Y.c,Y.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=E;class S extends E{constructor(){super(1)}}e.Queue=S;class M{constructor(){this.sequentializer=new X,this.tasks=0}queue(Y){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,Y())):this.sequentializer.run(this.tasks++,Y())}}e.LimitedQueue=M;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const Y=new ne;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueSize(Y,oe=L.extUri){const ve=oe.getComparisonKey(Y);return this.queues.get(ve)?.size??0}queueFor(Y,oe,ve=L.extUri){const be=ve.getComparisonKey(Y);let Fe=this.queues.get(be);if(!Fe){Fe=new S;const We=this.drainListenerCount++,Ce=T.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(be),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(We),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(We,Ce),this.queues.set(be,Fe)}return Fe.queue(oe)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class O{constructor(Y,oe){this._isDisposed=!1,this._token=-1,typeof Y=="function"&&typeof oe=="number"&&this.setIfNotSet(Y,oe)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,oe){if(this._isDisposed)throw new d.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},oe)}setIfNotSet(Y,oe){if(this._isDisposed)throw new d.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},oe))}}e.TimeoutTimer=O;class x{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(Y,oe,ve=globalThis){if(this.isDisposed)throw new d.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=ve.setInterval(()=>{Y()},oe);this.disposable=(0,R.toDisposable)(()=>{ve.clearInterval(be),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=x;class U{constructor(Y,oe){this.timeoutToken=-1,this.runner=Y,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class F{constructor(Y,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class H extends U{constructor(Y,oe){super(Y,oe),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class j extends R.Disposable{constructor(Y,oe){super(),this.options=Y,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const oe of Y)this.pendingWork.push(oe);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ue,Y)=>{(0,A.setTimeout0)(()=>{if(oe)return;const ve=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e._runWhenIdle=(ue,Y,oe)=>{const ve=ue.requestIdleCallback(Y,typeof oe=="number"?{timeout:oe}:void 0);let be=!1;return{dispose(){be||(be=!0,ue.cancelIdleCallback(ve))}}},e.runWhenGlobalIdle=ue=>(0,e._runWhenIdle)(globalThis,ue)}();class re{constructor(Y,oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(Y,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=re;class B extends re{constructor(Y){super(globalThis,Y)}}e.GlobalIdleValue=B;async function V(ue,Y,oe){let ve;for(let be=0;be<oe;be++)try{return await ue()}catch(Fe){ve=Fe,await y(Y)}throw ve}class X{isRunning(Y){return typeof Y=="number"?this._running?.taskId===Y:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(Y,oe,ve){return this._running={taskId:Y,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.doneRunning(Y),()=>this.doneRunning(Y)),oe}doneRunning(Y){this._running&&Y===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const Y=this._queued;this._queued=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this._queued)this._queued.run=Y;else{const{promise:oe,resolve:ve,reject:be}=h();this._queued={run:Y,promise:oe,promiseResolve:ve,promiseReject:be}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=X;class ee{constructor(Y,oe=()=>Date.now()){this.interval=Y,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var he;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(he||(he={}));class ne{get isRejected(){return this.outcome?.outcome===he.Rejected}get isResolved(){return this.outcome?.outcome===he.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===he.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((Y,oe)=>{this.completeCallback=Y,this.errorCallback=oe})}complete(Y){return new Promise(oe=>{this.completeCallback(Y),this.outcome={outcome:he.Resolved,value:Y},oe()})}error(Y){return new Promise(oe=>{this.errorCallback(Y),this.outcome={outcome:he.Rejected,value:Y},oe()})}cancel(){return this.error(new d.CancellationError)}}e.DeferredPromise=ne;var De;(function(ue){async function Y(ve){let be;const Fe=await Promise.all(ve.map(We=>We.then(Ce=>Ce,Ce=>{be||(be=Ce)})));if(typeof be<"u")throw be;return Fe}ue.settled=Y;function oe(ve){return new Promise(async(be,Fe)=>{try{await ve(be,Fe)}catch(We){Fe(We)}})}ue.withAsyncBody=oe})(De||(e.Promises=De={}));class pe{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(Y){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=Y.then(oe=>(this._value=oe,this._isResolved=!0,oe),oe=>{throw this._error=oe,this._isResolved=!0,oe})}requireValue(){if(!this._isResolved)throw new d.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=pe;class G{constructor(Y){this._compute=Y,this._promise=new a.Lazy(()=>new pe(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=G;var W;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(Y){return new se(oe=>{oe.emitMany(Y)})}static fromPromise(Y){return new se(async oe=>{oe.emitMany(await Y)})}static fromPromises(Y){return new se(async oe=>{await Promise.all(Y.map(async ve=>oe.emitOne(await ve)))})}static merge(Y){return new se(async oe=>{await Promise.all(Y.map(async ve=>{for await(const be of ve)oe.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(Y,oe){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=oe,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const ve={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(ve)),this.resolve()}catch(be){this.reject(be)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(Y,oe){return new se(async ve=>{for await(const be of Y)ve.emitOne(oe(be))})}map(Y){return se.map(this,Y)}static filter(Y,oe){return new se(async ve=>{for await(const be of Y)oe(be)&&ve.emitOne(be)})}filter(Y){return se.filter(this,Y)}static coalesce(Y){return se.filter(Y,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Y){const oe=[];for await(const ve of Y)oe.push(ve);return oe}toPromise(){return se.toPromise(this)}emitOne(Y){this._state===W.Initial&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===W.Initial&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject(Y){this._state===W.Initial&&(this._state=W.DoneError,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=se;class ae extends se{constructor(Y,oe){super(oe),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function te(ue){const Y=new s.CancellationTokenSource,oe=ue(Y.token);return new ae(Y,async ve=>{const be=Y.token.onCancellationRequested(()=>{be.dispose(),Y.dispose(),ve.reject(new d.CancellationError)});try{for await(const Fe of oe){if(Y.token.isCancellationRequested)return;ve.emitOne(Fe)}be.dispose(),Y.dispose()}catch(Fe){be.dispose(),Y.dispose(),ve.reject(Fe)}})}class ce{constructor(Y){this._deferred=new ne,this._asyncIterable=new se(be=>{if(oe){be.reject(oe);return}return ve&&be.emitMany(ve),this._errorFn=Fe=>be.reject(Fe),this._emitFn=Fe=>be.emitOne(Fe),this._deferred.p},Y);let oe,ve;this._emitFn=be=>{ve||(ve=[]),ve.push(be)},this._errorFn=be=>{oe||(oe=be)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(Y){this._errorFn(Y),this._deferred.complete()}emitOne(Y){this._emitFn(Y)}}e.AsyncIterableSource=ce}),define(_e[39],ye([1,0,19,9,27,33,29,17,11,13]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=I,e.splitGlobAware=l,e.match=M,e.parse=N,e.isRelativePattern=O,e.getBasenameTerms=x,e.getPathTerms=U,e.patternsEquals=re;function I(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const _="[/\\\\]",c="[^/\\\\]",C=/\//g;function b(B,V){switch(B){case 0:return"";case 1:return`${c}*?`;default:return`(?:${_}|${c}+${_}${V?`|${_}${c}+`:""})*?`}}function l(B,V){if(!B)return[];const X=[];let ee=!1,he=!1,ne="";for(const De of B){switch(De){case V:if(!ee&&!he){X.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":he=!0;break;case"]":he=!1;break}ne+=De}return ne&&X.push(ne),X}function m(B){if(!B)return"";let V="";const X=l(B,e.GLOB_SPLIT);if(X.every(ee=>ee===e.GLOBSTAR))V=".*";else{let ee=!1;X.forEach((he,ne)=>{if(he===e.GLOBSTAR){if(ee)return;V+=b(2,ne===X.length-1)}else{let De=!1,pe="",G=!1,W="";for(const se of he){if(se!=="}"&&De){pe+=se;continue}if(G&&(se!=="]"||!W)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!W?ae="^":se===e.GLOB_SPLIT?ae="":ae=(0,a.escapeRegExpCharacters)(se),W+=ae;continue}switch(se){case"{":De=!0;continue;case"[":G=!0;continue;case"}":{const te=`(?:${l(pe,",").map(ce=>m(ce)).join("|")})`;V+=te,De=!1,pe="";break}case"]":{V+="["+W+"]",G=!1,W="";break}case"?":V+=c;continue;case"*":V+=b(1);continue;default:V+=(0,a.escapeRegExpCharacters)(se)}}ne<X.length-1&&(X[ne+1]!==e.GLOBSTAR||ne+2<X.length)&&(V+=_)}ee=he===e.GLOBSTAR})}return V}const h=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),f=function(){return!1},u=function(){return null};function v(B,V){if(!B)return u;let X;typeof B!="string"?X=B.pattern:X=B,X=X.trim();const ee=`${X}_${!!V.trimForExclusions}`;let he=r.get(ee);if(he)return y(he,B);let ne;return h.test(X)?he=w(X.substr(4),X):(ne=g.exec(D(X,V)))?he=P(ne[1],X):(V.trimForExclusions?o:n).test(X)?he=k(X,V):(ne=t.exec(D(X,V)))?he=E(ne[1].substr(1),X,!0):(ne=i.exec(D(X,V)))?he=E(ne[1],X,!1):he=S(X),r.set(ee,he),y(he,B)}function y(B,V){if(typeof V=="string")return B;const X=function(ee,he){return(0,R.isEqualOrParent)(ee,V.base,!p.isLinux)?B((0,a.ltrim)(ee.substr(V.base.length),A.sep),he):null};return X.allBasenames=B.allBasenames,X.allPaths=B.allPaths,X.basenames=B.basenames,X.patterns=B.patterns,X}function D(B,V){return V.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function w(B,V){return function(X,ee){return typeof X=="string"&&X.endsWith(B)?V:null}}function P(B,V){const X=`/${B}`,ee=`\\${B}`,he=function(De,pe){return typeof De!="string"?null:pe?pe===B?V:null:De===B||De.endsWith(X)||De.endsWith(ee)?V:null},ne=[B];return he.basenames=ne,he.patterns=[V],he.allBasenames=ne,he}function k(B,V){const X=j(B.slice(1,-1).split(",").map(pe=>v(pe,V)).filter(pe=>pe!==u),B),ee=X.length;if(!ee)return u;if(ee===1)return X[0];const he=function(pe,G){for(let W=0,se=X.length;W<se;W++)if(X[W](pe,G))return B;return null},ne=X.find(pe=>!!pe.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=X.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return De.length&&(he.allPaths=De),he}function E(B,V,X){const ee=A.sep===A.posix.sep,he=ee?B:B.replace(C,A.sep),ne=A.sep+he,De=A.posix.sep+B;let pe;return X?pe=function(G,W){return typeof G=="string"&&(G===he||G.endsWith(ne)||!ee&&(G===B||G.endsWith(De)))?V:null}:pe=function(G,W){return typeof G=="string"&&(G===he||!ee&&G===B)?V:null},pe.allPaths=[(X?"*/":"./")+B],pe}function S(B){try{const V=new RegExp(`^${m(B)}$`);return function(X){return V.lastIndex=0,typeof X=="string"&&V.test(X)?B:null}}catch{return u}}function M(B,V,X){return!B||typeof V!="string"?!1:N(B)(V,void 0,X)}function N(B,V={}){if(!B)return f;if(typeof B=="string"||O(B)){const X=v(B,V);if(X===u)return f;const ee=function(he,ne){return!!X(he,ne)};return X.allBasenames&&(ee.allBasenames=X.allBasenames),X.allPaths&&(ee.allPaths=X.allPaths),ee}return F(B,V)}function O(B){const V=B;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function x(B){return B.allBasenames||[]}function U(B){return B.allPaths||[]}function F(B,V){const X=j(Object.getOwnPropertyNames(B).map(pe=>H(pe,B[pe],V)).filter(pe=>pe!==u)),ee=X.length;if(!ee)return u;if(!X.some(pe=>!!pe.requiresSiblings)){if(ee===1)return X[0];const pe=function(se,ae){let te;for(let ce=0,ue=X.length;ce<ue;ce++){const Y=X[ce](se,ae);if(typeof Y=="string")return Y;(0,d.isThenable)(Y)&&(te||(te=[]),te.push(Y))}return te?(async()=>{for(const ce of te){const ue=await ce;if(typeof ue=="string")return ue}return null})():null},G=X.find(se=>!!se.allBasenames);G&&(pe.allBasenames=G.allBasenames);const W=X.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return W.length&&(pe.allPaths=W),pe}const he=function(pe,G,W){let se,ae;for(let te=0,ce=X.length;te<ce;te++){const ue=X[te];ue.requiresSiblings&&W&&(G||(G=(0,A.basename)(pe)),se||(se=G.substr(0,G.length-(0,A.extname)(pe).length)));const Y=ue(pe,G,se,W);if(typeof Y=="string")return Y;(0,d.isThenable)(Y)&&(ae||(ae=[]),ae.push(Y))}return ae?(async()=>{for(const te of ae){const ce=await te;if(typeof ce=="string")return ce}return null})():null},ne=X.find(pe=>!!pe.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=X.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return De.length&&(he.allPaths=De),he}function H(B,V,X){if(V===!1)return u;const ee=v(B,X);if(ee===u)return u;if(typeof V=="boolean")return ee;if(V){const he=V.when;if(typeof he=="string"){const ne=(De,pe,G,W)=>{if(!W||!ee(De,pe))return null;const se=he.replace("$(basename)",()=>G),ae=W(se);return(0,d.isThenable)(ae)?ae.then(te=>te?B:null):ae?B:null};return ne.requiresSiblings=!0,ne}}return ee}function j(B,V){const X=B.filter(pe=>!!pe.basenames);if(X.length<2)return B;const ee=X.reduce((pe,G)=>{const W=G.basenames;return W?pe.concat(W):pe},[]);let he;if(V){he=[];for(let pe=0,G=ee.length;pe<G;pe++)he.push(V)}else he=X.reduce((pe,G)=>{const W=G.patterns;return W?pe.concat(W):pe},[]);const ne=function(pe,G){if(typeof pe!="string")return null;if(!G){let se;for(se=pe.length;se>0;se--){const ae=pe.charCodeAt(se-1);if(ae===T.CharCode.Slash||ae===T.CharCode.Backslash)break}G=pe.substr(se)}const W=ee.indexOf(G);return W!==-1?he[W]:null};ne.basenames=ee,ne.patterns=he,ne.allBasenames=ee;const De=B.filter(pe=>!pe.basenames);return De.push(ne),De}function re(B,V){return(0,s.equals)(B,V,(X,ee)=>typeof X=="string"&&typeof ee=="string"?X===ee:typeof X!="string"&&typeof ee!="string"?X.base===ee.base&&X.pattern===ee.pattern:!1)}}),define(_e[86],ye([1,0,14,136,23,13,2]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=a,e.isMarkdownString=I,e.markdownStringEqual=_,e.escapeMarkdownSyntaxTokens=c,e.appendEscapedMarkdownCodeBlockFence=C,e.escapeDoubleQuotes=b,e.removeMarkdownEscapes=l,e.parseHrefAndDimensions=m;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class p{constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=A.Paragraph){return this.value+=c(this.supportThemeIcons?(0,d.escapeIcons)(g):g).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===A.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+=`
${C(n,g)}
`,this}appendLink(g,n,o){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(g),")"),o&&(this.value+=` "${this._escape(this._escape(o,'"'),")")}"`),this.value+=")",this}_escape(g,n){const o=new RegExp((0,R.escapeRegExpCharacters)(n),"g");return g.replace(o,(t,i)=>g.charAt(i-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=p;function a(h){return I(h)?!h.value:Array.isArray(h)?h.every(a):!0}function I(h){return h instanceof p?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function _(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,T.isEqual)(L.URI.from(h.baseUri),L.URI.from(g.baseUri)))}function c(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(h,g){const n=h.match(/^`+/gm)?.reduce((t,i)=>t.length>i.length?t:i).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${g}`,h,`${"`".repeat(o)}`].join(`
`)}function b(h){return h.replace(/"/g,"&quot;")}function l(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(h){const g=[],n=h.split("|").map(t=>t.trim());h=n[0];const o=n[1];if(o){const t=/height=(\d+)/.exec(o),i=/width=(\d+)/.exec(o),r=t?t[1]:"",f=i?i[1]:"",u=isFinite(parseInt(f)),v=isFinite(parseInt(r));u&&g.push(`width="${f}"`),v&&g.push(`height="${r}"`)}return{href:h,dimensions:g}}}),define(_e[110],ye([1,0,19,33,17,11,23,13]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=p,e.normalizeDriveLetter=I,e.tildify=c,e.untildify=C,e.shorten=h,e.template=n,e.mnemonicMenuLabel=o,e.mnemonicButtonLabel=t,e.unmnemonicLabel=i,e.splitRecentLabel=r;function p(u,v){const{os:y,tildify:D,relative:w}=v;if(w){const E=a(u,w,y);if(typeof E=="string")return E}let P=u.fsPath;if(y===R.OperatingSystem.Windows&&!R.isWindows?P=P.replace(/\//g,"\\"):y!==R.OperatingSystem.Windows&&R.isWindows&&(P=P.replace(/\\/g,"/")),y!==R.OperatingSystem.Windows&&D?.userHome){const E=D.userHome.fsPath;let S;u.scheme!==D.userHome.scheme&&u.path[0]===T.posix.sep&&u.path[1]!==T.posix.sep?S=D.userHome.with({path:u.path}).fsPath:S=P,P=c(S,E,y)}return(y===R.OperatingSystem.Windows?T.win32:T.posix).normalize(I(P,y===R.OperatingSystem.Windows))}function a(u,v,y){const D=y===R.OperatingSystem.Windows?T.win32:T.posix,w=y===R.OperatingSystem.Linux?L.extUri:L.extUriIgnorePathCase,P=v.getWorkspace(),k=(0,s.firstOrDefault)(P.folders);if(!k)return;u.scheme!==k.uri.scheme&&u.path[0]===T.posix.sep&&u.path[1]!==T.posix.sep&&(u=k.uri.with({path:u.path}));const E=v.getWorkspaceFolder(u);if(!E)return;let S;if(w.isEqual(E.uri,u)?S="":S=w.relativePath(E.uri,u)??"",S&&(S=D.normalize(S)),P.folders.length>1&&!v.noPrefix){const M=E.name?E.name:w.basenameOrAuthority(E.uri);S=S?`${M} \u2022 ${S}`:M}return S}function I(u,v=R.isWindows){return(0,d.hasDriveLetter)(u,v)?u.charAt(0).toUpperCase()+u.slice(1):u}let _=Object.create(null);function c(u,v,y=R.OS){if(y===R.OperatingSystem.Windows||!u||!v)return u;let D=_.original===v?_.normalized:void 0;D||(D=v,R.isWindows&&(D=(0,d.toSlashes)(D)),D=`${(0,A.rtrim)(D,T.posix.sep)}${T.posix.sep}`,_={original:v,normalized:D});let w=u;return R.isWindows&&(w=(0,d.toSlashes)(w)),(y===R.OperatingSystem.Linux?w.startsWith(D):(0,A.startsWithIgnoreCase)(w,D))?`~/${w.substr(D.length)}`:u}function C(u,v){return u.replace(/^~($|\/|\\)/,`${v}$1`)}const b="\u2026",l="\\\\",m="~";function h(u,v=T.sep){const y=new Array(u.length);let D=!1;for(let w=0;w<u.length;w++){const P=u[w];if(P===""){y[w]=`.${v}`;continue}if(!P){y[w]=P;continue}D=!0;let k="",E=P;E.indexOf(l)===0?(k=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(v)===0?(k=E.substr(0,E.indexOf(v)+v.length),E=E.substr(E.indexOf(v)+v.length)):E.indexOf(m)===0&&(k=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length));const S=E.split(v);for(let M=1;D&&M<=S.length;M++)for(let N=S.length-M;D&&N>=0;N--){D=!1;let O=S.slice(N,N+M).join(v);for(let x=0;!D&&x<u.length;x++)if(x!==w&&u[x]&&u[x].indexOf(O)>-1){const U=N+M===S.length,F=N>0&&u[x].indexOf(v)>-1?v+O:O,H=u[x].endsWith(F);D=!U||H}if(!D){let x="";(S[0].endsWith(":")||k!=="")&&(N===1&&(N=0,M++,O=S[0]+v+O),N>0&&(x=S[0]+v),x=k+x),N>0&&(x=x+b+v),x=x+O,N+M<S.length&&(x=x+v+b),y[w]=x}}D&&(y[w]=P)}return y}var g;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function n(u,v=Object.create(null)){const y=[];let D=!1,w="";for(const P of u)if(P==="$"||D&&P==="{")w&&y.push({value:w,type:g.TEXT}),w="",D=!0;else if(P==="}"&&D){const k=v[w];if(typeof k=="string")k.length&&y.push({value:k,type:g.VARIABLE});else if(k){const E=y[y.length-1];(!E||E.type!==g.SEPARATOR)&&y.push({value:k.label,type:g.SEPARATOR})}w="",D=!1}else w+=P;return w&&!D&&y.push({value:w,type:g.TEXT}),y.filter((P,k)=>{if(P.type===g.SEPARATOR){const E=y[k-1],S=y[k+1];return[E,S].every(M=>M&&(M.type===g.VARIABLE||M.type===g.TEXT)&&M.value.length>0)}return!0}).map(P=>P.value).join("")}function o(u,v){return R.isMacintosh||v?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):u.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function t(u,v){return R.isMacintosh||v?u.replace(/\(&&\w\)|&&/g,""):R.isWindows?u.replace(/&&|&/g,y=>y==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function r(u){if(u.endsWith("]")){const v=u.lastIndexOf(" [",u.length-2);if(v!==-1){const y=f(u.substring(0,v)),D=u.substring(v);return{name:y.name+D,parentPath:y.parentPath}}}return f(u)}function f(u){const v=u.indexOf("/")!==-1?T.posix:T.win32,y=v.basename(u),D=v.dirname(u);return y.length?{name:y,parentPath:D}:{name:D,parentPath:""}}}),define(_e[142],ye([1,0,22,41,2]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=p,e.transformIncomingURIs=I,e.transformAndReviveIncomingURIs=_;function R(c){return c.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const b=this._uriTransformer.transformIncoming(C);return b===C?C:R(T.URI.from(b))}transformOutgoing(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:R(T.URI.from(b))}transformOutgoingURI(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:T.URI.from(b)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function A(c,C,b){if(!c||b>200)return null;if(typeof c=="object"){if(c instanceof T.URI)return C.transformOutgoing(c);for(const l in c)if(Object.hasOwnProperty.call(c,l)){const m=A(c[l],C,b+1);m!==null&&(c[l]=m)}}return null}function p(c,C){const b=A(c,C,0);return b===null?c:b}function a(c,C,b,l){if(!c||l>200)return null;if(typeof c=="object"){if(c.$mid===d.MarshalledId.Uri)return b?T.URI.revive(C.transformIncoming(c)):C.transformIncoming(c);if(c instanceof s.VSBuffer)return null;for(const m in c)if(Object.hasOwnProperty.call(c,m)){const h=a(c[m],C,b,l+1);h!==null&&(c[m]=h)}}return null}function I(c,C){const b=a(c,C,!1,0);return b===null?c:b}function _(c,C){const b=a(c,C,!0,0);return b===null?c:b}}),define(_e[34],ye([1,0,61,68,411,9,33,82,17,11,23,2]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=i,e.configureFlushOnWrite=y,e.writeFileSync=w,s=ze(s);var c;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(c||(e.RimRafMode=c={}));async function C(F,H=c.UNLINK,j){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return H===c.UNLINK?l(F):b(F,j)}async function b(F,H=(0,L.randomPath)((0,d.tmpdir)())){try{try{await s.promises.rename(F,H)}catch(j){return j.code==="ENOENT"?void 0:l(F)}l(H).catch(j=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function l(F){return s.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,L.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function h(F,H){return o(await(H?g(F):s.promises.readdir(F)))}async function g(F){try{return await s.promises.readdir(F,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const H=[],j=await h(F);for(const re of j){let B=!1,V=!1,X=!1;try{const ee=await e.Promises.lstat((0,p.join)(F,re));B=ee.isFile(),V=ee.isDirectory(),X=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}H.push({name:re,isFile:()=>B,isDirectory:()=>V,isSymbolicLink:()=>X})}return H}function n(F){return o(s.readdirSync(F))}function o(F){return F.map(H=>typeof H=="string"?a.isMacintosh?(0,A.normalizeNFC)(H):H:(H.name=a.isMacintosh?(0,A.normalizeNFC)(H.name):H.name,H))}async function t(F){const H=await h(F),j=[];for(const re of H)await r.existsDirectory((0,p.join)(F,re))&&j.push(re);return j}function i(F,H=1e3){return new Promise(j=>{let re=!1;const B=setInterval(()=>{re||(re=!0,s.access(F,V=>{re=!1,V&&(clearInterval(B),j(void 0))}))},H)})}var r;(function(F){async function H(B){let V;try{if(V=await e.Promises.lstat(B),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(a.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw X}}F.stat=H;async function j(B){try{const{stat:V,symbolicLink:X}=await F.stat(B);return V.isFile()&&X?.dangling!==!0}catch{}return!1}F.existsFile=j;async function re(B){try{const{stat:V,symbolicLink:X}=await F.stat(B);return V.isDirectory()&&X?.dangling!==!0}catch{}return!1}F.existsDirectory=re})(r||(e.SymlinkSupport=r={}));const f=new R.ResourceQueue;function u(F,H,j){return f.queueFor(_.URI.file(F),()=>{const re=P(j);return new Promise((B,V)=>D(F,H,re,X=>X?V(X):B()))},I.extUriBiasedIgnorePathCase)}let v=!0;function y(F){v=F}function D(F,H,j,re){if(!v)return s.writeFile(F,H,{mode:j.mode,flag:j.flag},re);s.open(F,j.flag,j.mode,(B,V)=>{if(B)return re(B);s.writeFile(V,H,X=>{if(X)return s.close(V,()=>re(X));s.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),y(!1)),s.close(V,he=>re(he))))})})}function w(F,H,j){const re=P(j);if(!v)return s.writeFileSync(F,H,{mode:re.mode,flag:re.flag});const B=s.openSync(F,re.flag,re.mode);try{s.writeFileSync(B,H);try{s.fdatasyncSync(B)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),y(!1)}}finally{s.closeSync(B)}}function P(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,H,j=6e4){if(F!==H)try{a.isWindows&&typeof j=="number"?await E(F,H,Date.now(),j):await s.promises.rename(F,H)}catch(re){if(F.toLowerCase()!==H.toLowerCase()&&re.code==="EXDEV"||F.endsWith("."))await S(F,H,{preserveSymlinks:!1}),await C(F,c.MOVE);else throw re}}async function E(F,H,j,re,B=0){try{return await s.promises.rename(F,H)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-j>=re)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${V}`),V;if(B===0){let X=!1;try{const{stat:ee}=await r.stat(H);ee.isFile()||(X=!0)}catch{}if(X)throw V}return await(0,R.timeout)(Math.min(100,B*10)),E(F,H,j,re,B+1)}}async function S(F,H,j){return N(F,H,{root:{source:F,target:H},options:j,handledSourcePaths:new Set})}const M=511;async function N(F,H,j){if(j.handledSourcePaths.has(F))return;j.handledSourcePaths.add(F);const{stat:re,symbolicLink:B}=await r.stat(F);if(B){if(j.options.preserveSymlinks)try{return await U(F,H,j)}catch{}if(B.dangling)return}return re.isDirectory()?O(F,H,re.mode&M,j):x(F,H,re.mode&M)}async function O(F,H,j,re){await e.Promises.mkdir(H,{recursive:!0,mode:j});const B=await h(F);for(const V of B)await N((0,p.join)(F,V),(0,p.join)(H,V),re)}async function x(F,H,j){await e.Promises.copyFile(F,H),await e.Promises.chmod(H,j)}async function U(F,H,j){let re=await e.Promises.readlink(F);(0,L.isEqualOrParent)(re,j.root.source,!a.isLinux)&&(re=(0,p.join)(j.root.target,re.substr(j.root.source.length+1))),await e.Promises.symlink(re,H)}e.Promises=new class{get access(){return s.promises.access}get stat(){return s.promises.stat}get lstat(){return s.promises.lstat}get utimes(){return s.promises.utimes}get read(){return(F,H,j,re,B)=>new Promise((V,X)=>{s.read(F,H,j,re,B,(ee,he,ne)=>ee?X(ee):V({bytesRead:he,buffer:ne}))})}get readFile(){return s.promises.readFile}get write(){return(F,H,j,re,B)=>new Promise((V,X)=>{s.write(F,H,j,re,B,(ee,he,ne)=>ee?X(ee):V({bytesWritten:he,buffer:ne}))})}get appendFile(){return s.promises.appendFile}get fdatasync(){return(0,T.promisify)(s.fdatasync)}get truncate(){return s.promises.truncate}get copyFile(){return s.promises.copyFile}get open(){return(0,T.promisify)(s.open)}get close(){return(0,T.promisify)(s.close)}get symlink(){return s.promises.symlink}get readlink(){return s.promises.readlink}get chmod(){return s.promises.chmod}get mkdir(){return s.promises.mkdir}get unlink(){return s.promises.unlink}get rmdir(){return s.promises.rmdir}get realpath(){return(0,T.promisify)(s.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return C}get rename(){return k}get copy(){return S}}}),define(_e[111],ye([1,0,61,17,11,13,34]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=A,e.realcase=p,e.realpath=a,e.realpathSync=I,s=ze(s);function A(c){if(T.isLinux)return c;const C=(0,d.dirname)(c);if(c===C)return c;const b=((0,d.basename)(c)||c).toLowerCase();try{const m=(0,L.readdirSync)(C).filter(h=>h.toLowerCase()===b);if(m.length===1){const h=A(C);if(h)return(0,d.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(b);if(h>=0){const g=A(C);if(g)return(0,d.join)(g,m[h])}}}catch{}return null}async function p(c,C){if(T.isLinux)return c;const b=(0,d.dirname)(c);if(c===b)return c;const l=((0,d.basename)(c)||c).toLowerCase();try{if(C?.isCancellationRequested)return null;const h=(await L.Promises.readdir(b)).filter(g=>g.toLowerCase()===l);if(h.length===1){const g=await p(b,C);if(g)return(0,d.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(l);if(g>=0){const n=await p(b,C);if(n)return(0,d.join)(n,h[g])}}}catch{}return null}async function a(c){try{return await L.Promises.realpath(c)}catch{const b=_(c);return await L.Promises.access(b,s.constants.R_OK),b}}function I(c){try{return s.realpathSync(c)}catch{const b=_(c);return s.accessSync(b,s.constants.R_OK),b}}function _(c){return(0,R.rtrim)((0,d.normalize)(c),d.sep)}}),define(_e[112],ye([1,0,17,11,56,109,18,34]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=p,e.createQueuedSender=a,s=ze(s),d=ze(d),T=ze(T),L=ze(L),A=ze(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(_=T.env){return _.comspec||"cmd.exe"}function a(_){let c=[],C=!1;const b=function(l){if(C){c.push(l);return}(!_.send(l,h=>{if(h&&console.error(h),C=!1,c.length>0){const g=c.slice(0);c=[],g.forEach(n=>b(n))}})||d.isWindows)&&(C=!0)};return{send:b}}var I;(function(_){async function c(C,b,l){if(s.isAbsolute(C))return C;if(b===void 0&&(b=T.cwd()),s.dirname(C)!=="."||(l===void 0&&L.isString(T.env.PATH)&&(l=T.env.PATH.split(s.delimiter)),l===void 0||l.length===0))return s.join(b,C);async function h(g){if(await A.Promises.exists(g)){let n;try{n=await A.Promises.stat(g)}catch(o){o.message.startsWith("EACCES")&&(n=await A.Promises.lstat(g))}return n?!n.isDirectory():!1}return!1}for(const g of l){let n;if(s.isAbsolute(g)?n=s.join(g,C):n=s.join(b,g,C),await h(n))return n;let o=n+".com";if(await h(o)||(o=n+".exe",await h(o)))return o}return s.join(b,C)}_.findExecutable=c})(I||(e.win32=I={}))});var Xe=this&&this.__decorate||function(le,e,s,d){var T=arguments.length,R=T<3?e:d===null?d=Object.getOwnPropertyDescriptor(e,s):d,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,s,d);else for(var A=le.length-1;A>=0;A--)(L=le[A])&&(R=(T<3?L(R):T>3?L(e,s,R):L(e,s))||R);return T>3&&R&&Object.defineProperty(e,s,R),R};define(_e[87],ye([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=y,e.deserialize=D,e.getDelayedChannel=M,e.getNextTickChannel=N,_=ze(_);var C;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(C||(C={}));function b(B){switch(B){case C.Promise:return"req";case C.PromiseCancel:return"cancel";case C.EventListen:return"subscribe";case C.EventDispose:return"unsubscribe"}}var l;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(l||(l={}));function m(B){switch(B){case l.Initialize:return"init";case l.PromiseSuccess:return"reply:";case l.PromiseError:case l.PromiseErrorObj:return"replyErr:";case l.EventFire:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function g(B){let V=0;for(let X=0;;X+=7){const ee=B.read(1);if(V|=(ee.buffer[0]&127)<<X,!(ee.buffer[0]&128))return V}}const n=f(0);function o(B,V){if(V===0){B.write(n);return}let X=0;for(let he=V;he!==0;he=he>>>7)X++;const ee=T.VSBuffer.alloc(X);for(let he=0;V!==0;he++)ee.buffer[he]=V&127,V=V>>>7,V>0&&(ee.buffer[he]|=128);B.write(ee)}class t{constructor(V){this.buffer=V,this.pos=0}read(V){const X=this.buffer.slice(this.pos,this.pos+V);return this.pos+=X.byteLength,X}}e.BufferReader=t;class i{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}e.BufferWriter=i;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function f(B){const V=T.VSBuffer.alloc(1);return V.writeUInt8(B,0),V}const u={Undefined:f(r.Undefined),String:f(r.String),Buffer:f(r.Buffer),VSBuffer:f(r.VSBuffer),Array:f(r.Array),Object:f(r.Object),Uint:f(r.Int)},v=typeof Buffer<"u";function y(B,V){if(typeof V>"u")B.write(u.Undefined);else if(typeof V=="string"){const X=T.VSBuffer.fromString(V);B.write(u.String),o(B,X.byteLength),B.write(X)}else if(v&&Buffer.isBuffer(V)){const X=T.VSBuffer.wrap(V);B.write(u.Buffer),o(B,X.byteLength),B.write(X)}else if(V instanceof T.VSBuffer)B.write(u.VSBuffer),o(B,V.byteLength),B.write(V);else if(Array.isArray(V)){B.write(u.Array),o(B,V.length);for(const X of V)y(B,X)}else if(typeof V=="number"&&(V|0)===V)B.write(u.Uint),o(B,V);else{const X=T.VSBuffer.fromString(JSON.stringify(V));B.write(u.Object),o(B,X.byteLength),B.write(X)}}function D(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(g(B)).toString();case r.Buffer:return B.read(g(B)).buffer;case r.VSBuffer:return B.read(g(B));case r.Array:{const X=g(B),ee=[];for(let he=0;he<X;he++)ee.push(D(B));return ee}case r.Object:return JSON.parse(B.read(g(B)).toString());case r.Int:return g(B)}}class w{constructor(V,X,ee=null,he=1e3){this.protocol=V,this.ctx=X,this.logger=ee,this.timeoutDelay=he,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:l.Initialize})}registerChannel(V,X){this.channels.set(V,X),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case l.Initialize:{const X=this.send([V.type]);this.logger?.logOutgoing(X,0,P.OtherSide,m(V.type));return}case l.PromiseSuccess:case l.PromiseError:case l.EventFire:case l.PromiseErrorObj:{const X=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(X,V.id,P.OtherSide,m(V.type),V.data);return}}}send(V,X=void 0){const ee=new i;return y(ee,V),y(ee,X),this.sendBuffer(ee.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const X=new t(V),ee=D(X),he=D(X),ne=ee[0];switch(ne){case C.Promise:return this.logger?.logIncoming(V.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,he),this.onPromise({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case C.EventListen:return this.logger?.logIncoming(V.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,he),this.onEventListen({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case C.PromiseCancel:return this.logger?.logIncoming(V.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.disposeActiveRequest({type:ne,id:ee[1]});case C.EventDispose:return this.logger?.logIncoming(V.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.disposeActiveRequest({type:ne,id:ee[1]})}}onPromise(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const ee=new R.CancellationTokenSource;let he;try{he=X.call(this.ctx,V.name,V.arg,ee.token)}catch(pe){he=Promise.reject(pe)}const ne=V.id;he.then(pe=>{this.sendResponse({id:ne,data:pe,type:l.PromiseSuccess})},pe=>{pe instanceof Error?this.sendResponse({id:ne,data:{message:pe.message,name:pe.name,stack:pe.stack?pe.stack.split(`
`):void 0},type:l.PromiseError}):this.sendResponse({id:ne,data:pe,type:l.PromiseErrorObj})}).finally(()=>{De.dispose(),this.activeRequests.delete(V.id)});const De=(0,a.toDisposable)(()=>ee.cancel());this.activeRequests.set(V.id,De)}onEventListen(V){const X=this.channels.get(V.channelName);if(!X){this.collectPendingRequest(V);return}const ee=V.id,ne=X.listen(this.ctx,V.name,V.arg)(De=>this.sendResponse({id:ee,data:De,type:l.EventFire}));this.activeRequests.set(V.id,ne)}disposeActiveRequest(V){const X=this.activeRequests.get(V.id);X&&(X.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let X=this.pendingRequests.get(V.channelName);X||(X=[],this.pendingRequests.set(V.channelName,X));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===C.Promise&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:l.PromiseError})},this.timeoutDelay);X.push({request:V,timeoutTimer:ee})}flushPendingRequests(V){const X=this.pendingRequests.get(V);if(X){for(const ee of X)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case C.Promise:this.onPromise(ee.request);break;case C.EventListen:this.onEventListen(ee.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var P;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class k{constructor(V,X=null){this.protocol=V,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=X}getChannel(V){const X=this;return{call(ee,he,ne){return X.isDisposed?Promise.reject(new A.CancellationError):X.requestPromise(V,ee,he,ne)},listen(ee,he){return X.isDisposed?p.Event.None:X.requestEvent(V,ee,he)}}}requestPromise(V,X,ee,he=R.CancellationToken.None){const ne=this.lastRequestId++,De=C.Promise,pe={id:ne,type:De,channelName:V,name:X,arg:ee};if(he.isCancellationRequested)return Promise.reject(new A.CancellationError);let G;return new Promise((se,ae)=>{if(he.isCancellationRequested)return ae(new A.CancellationError);const te=()=>{const oe=ve=>{switch(ve.type){case l.PromiseSuccess:this.handlers.delete(ne),se(ve.data);break;case l.PromiseError:{this.handlers.delete(ne);const be=new Error(ve.data.message);be.stack=Array.isArray(ve.data.stack)?ve.data.stack.join(`
`):ve.data.stack,be.name=ve.data.name,ae(be);break}case l.PromiseErrorObj:this.handlers.delete(ne),ae(ve.data);break}};this.handlers.set(ne,oe),this.sendRequest(pe)};let ce=null;this.state===h.Idle?te():(ce=(0,d.createCancelablePromise)(oe=>this.whenInitialized()),ce.then(()=>{ce=null,te()}));const ue=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ne,type:C.PromiseCancel}),ae(new A.CancellationError)},Y=he.onCancellationRequested(ue);G=(0,a.combinedDisposable)((0,a.toDisposable)(ue),Y),this.activeRequests.add(G)}).finally(()=>{G.dispose(),this.activeRequests.delete(G)})}requestEvent(V,X,ee){const he=this.lastRequestId++,ne=C.EventListen,De={id:he,type:ne,channelName:V,name:X,arg:ee};let pe=null;const G=new p.Emitter({onWillAddFirstListener:()=>{pe=(0,d.createCancelablePromise)(se=>this.whenInitialized()),pe.then(()=>{pe=null,this.activeRequests.add(G),this.sendRequest(De)})},onDidRemoveLastListener:()=>{pe?(pe.cancel(),pe=null):(this.activeRequests.delete(G),this.sendRequest({id:he,type:C.EventDispose}))}}),W=se=>G.fire(se.data);return this.handlers.set(he,W),G.event}sendRequest(V){switch(V.type){case C.Promise:case C.EventListen:{const X=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(X,V.id,P.LocalSide,`${b(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case C.PromiseCancel:case C.EventDispose:{const X=this.send([V.type,V.id]);this.logger?.logOutgoing(X,V.id,P.LocalSide,b(V.type));return}}}send(V,X=void 0){const ee=new i;return y(ee,V),y(ee,X),this.sendBuffer(ee.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const X=new t(V),ee=D(X),he=D(X),ne=ee[0];switch(ne){case l.Initialize:return this.logger?.logIncoming(V.byteLength,0,P.LocalSide,m(ne)),this.onResponse({type:ee[0]});case l.PromiseSuccess:case l.PromiseError:case l.EventFire:case l.PromiseErrorObj:return this.logger?.logIncoming(V.byteLength,ee[1],P.LocalSide,m(ne),he),this.onResponse({type:ee[0],id:ee[1],data:he})}}onResponse(V){if(V.type===l.Initialize){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=k,Xe([L.memoize],k.prototype,"onDidInitializePromise",null);class E{get connections(){const V=[];return this._connections.forEach(X=>V.push(X)),V}constructor(V,X,ee){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(V(({protocol:he,onDidClientDisconnect:ne})=>{const De=p.Event.once(he.onMessage);this.disposables.add(De(pe=>{const G=new t(pe),W=D(G),se=new w(he,W,X,ee),ae=new k(he,X);this.channels.forEach((ce,ue)=>se.registerChannel(ue,ce));const te={channelServer:se,channelClient:ae,ctx:W};this._connections.add(te),this._onDidAddConnection.fire(te),this.disposables.add(ne(()=>{se.dispose(),ae.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)}))}))}))}getChannel(V,X){const ee=this;return{call(he,ne,De){let pe;if((0,c.isFunction)(X)){const W=(0,s.getRandomElement)(ee.connections.filter(X));pe=W?Promise.resolve(W):p.Event.toPromise(p.Event.filter(ee.onDidAddConnection,X))}else pe=X.routeCall(ee,he,ne);const G=pe.then(W=>W.channelClient.getChannel(V));return M(G).call(he,ne,De)},listen(he,ne){if((0,c.isFunction)(X))return ee.getMulticastEvent(V,X,he,ne);const De=X.routeEvent(ee,he,ne).then(pe=>pe.channelClient.getChannel(V));return M(De).listen(he,ne)}}}getMulticastEvent(V,X,ee,he){const ne=this;let De;const pe=new p.Emitter({onWillAddFirstListener:()=>{De=new a.DisposableStore;const G=new p.EventMultiplexer,W=new Map,se=te=>{const ue=te.channelClient.getChannel(V).listen(ee,he),Y=G.add(ue);W.set(te,Y)},ae=te=>{const ce=W.get(te);ce&&(ce.dispose(),W.delete(te))};ne.connections.filter(X).forEach(se),p.Event.filter(ne.onDidAddConnection,X)(se,void 0,De),ne.onDidRemoveConnection(ae,void 0,De),G.event(pe.fire,pe,De),De.add(G)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return pe.event}registerChannel(V,X){this.channels.set(V,X);for(const ee of this._connections)ee.channelServer.registerChannel(V,X)}dispose(){this.disposables.dispose();for(const V of this._connections)V.channelClient.dispose(),V.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class S{constructor(V,X,ee=null){const he=new i;y(he,X),V.send(he.buffer),this.channelClient=new k(V,ee),this.channelServer=new w(V,X,ee)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,X){this.channelServer.registerChannel(V,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=S;function M(B){return{call(V,X,ee){return B.then(he=>he.call(V,X,ee))},listen(V,X){const ee=new p.Relay;return B.then(he=>ee.input=he.listen(V,X)),ee.event}}}function N(B){let V=!1;return{call(X,ee,he){return V?B.call(X,ee,he):(0,d.timeout)(0).then(()=>V=!0).then(()=>B.call(X,ee,he))},listen(X,ee){if(V)return B.listen(X,ee);const he=new p.Relay;return(0,d.timeout)(0).then(()=>V=!0).then(()=>he.input=B.listen(X,ee)),he.event}}}class O{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const X of V.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await p.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=O;var x;(function(B){function V(ne,De,pe){const G=ne,W=pe&&pe.disableMarshalling,se=new Map;for(const ae in G)ee(ae)&&se.set(ae,p.Event.buffer(G[ae],!0,void 0,De));return new class{listen(ae,te,ce){const ue=se.get(te);if(ue)return ue;const Y=G[te];if(typeof Y=="function"){if(he(te))return Y.call(G,ce);if(ee(te))return se.set(te,p.Event.buffer(G[te],!0,void 0,De)),se.get(te)}throw new A.ErrorNoTelemetry(`Event not found: ${te}`)}call(ae,te,ce){const ue=G[te];if(typeof ue=="function"){if(!W&&Array.isArray(ce))for(let oe=0;oe<ce.length;oe++)ce[oe]=(0,I.revive)(ce[oe]);let Y=ue.apply(G,ce);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new A.ErrorNoTelemetry(`Method not found: ${te}`)}}}B.fromService=V;function X(ne,De){const pe=De&&De.disableMarshalling;return new Proxy({},{get(G,W){if(typeof W=="string")return De?.properties?.has(W)?De.properties.get(W):he(W)?function(se){return ne.listen(W,se)}:ee(W)?ne.listen(W):async function(...se){let ae;De&&!(0,c.isUndefinedOrNull)(De.context)?ae=[De.context,...se]:ae=se;const te=await ne.call(W,ae);return pe?te:(0,I.revive)(te)};throw new A.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}B.toService=X;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&_.isUpperAsciiLetter(ne.charCodeAt(2))}function he(ne){return/^onDynamic/.test(ne)&&_.isUpperAsciiLetter(ne.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const V=B.toString();if(V!=="[object Object]")return V}return B}function H(B){return Array.isArray(B)?B.map(F):F(B)}function j(B,V,X,ee,he,ne,De){De=H(De);const pe=U[he],G=pe[ee%pe.length];let W=[`%c[${B}]%c[${String(V).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(ne)?(W=W.concat(De),W.push(")")):W.push(De),console.log.apply(console,W)}class re{constructor(V,X){this._outgoingPrefix=V,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,X,ee,he,ne){this._totalOutgoing+=V,j(this._outgoingPrefix,this._totalOutgoing,V,X,ee,he,ne)}logIncoming(V,X,ee,he,ne){this._totalIncoming+=V,j(this._incomingPrefix,this._totalIncoming,V,X,ee,he,ne)}}e.IPCLogger=re}),define(_e[69],ye([1,0,22,4,3,87]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var A;(function(u){u.enableDiagnostics=!1,u.records=[];const v=new WeakMap;let y=0;function D(P,k){if(!v.has(P)){const E=String(++y);v.set(P,E)}return v.get(P)}function w(P,k,E,S){if(!u.enableDiagnostics)return;const M=D(P,k);if(S instanceof s.VSBuffer||S instanceof Uint8Array||S instanceof ArrayBuffer||ArrayBuffer.isView(S)){const N=s.VSBuffer.alloc(S.byteLength);N.set(S),u.records.push({timestamp:Date.now(),id:M,label:k,type:E,buff:N})}else u.records.push({timestamp:Date.now(),id:M,label:k,type:E,data:S})}u.traceSocketEvent=w})(A||(e.SocketDiagnostics=A={}));var p;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let a=null;function I(){return a||(a=s.VSBuffer.alloc(0)),a}class _{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(v){this._chunks.push(v),this._totalLength+=v.byteLength}read(v){return this._read(v,!0)}peek(v){return this._read(v,!1)}_read(v,y){if(v===0)return I();if(v>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===v){const k=this._chunks[0];return y&&(this._chunks.shift(),this._totalLength-=v),k}if(this._chunks[0].byteLength>v){const k=this._chunks[0].slice(0,v);return y&&(this._chunks[0]=this._chunks[0].slice(v),this._totalLength-=v),k}const D=s.VSBuffer.alloc(v);let w=0,P=0;for(;v>0;){const k=this._chunks[P];if(k.byteLength>v){const E=k.slice(0,v);D.set(E,w),w+=v,y&&(this._chunks[P]=k.slice(v),this._totalLength-=v),v-=v}else D.set(k,w),w+=k.byteLength,y?(this._chunks.shift(),this._totalLength-=k.byteLength):P++,v-=k.byteLength}return D}}e.ChunkStream=_;var c;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(c||(c={}));function C(u){switch(u){case c.None:return"None";case c.Regular:return"Regular";case c.Control:return"Control";case c.Ack:return"Ack";case c.Disconnect:return"Disconnect";case c.ReplayRequest:return"ReplayRequest";case c.Pause:return"PauseWriting";case c.Resume:return"ResumeWriting";case c.KeepAlive:return"KeepAlive"}}var b;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class l{constructor(v,y,D,w){this.type=v,this.id=y,this.ack=D,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends T.Disposable{constructor(v){super(),this._onMessage=this._register(new d.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:b.HeaderLength,messageType:c.None,id:0,ack:0},this._socket=v,this._isDisposed=!1,this._incomingData=new _,this._register(this._socket.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(v){if(!(!v||v.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;){const y=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=y.readUInt32BE(9),this._state.messageType=y.readUInt8(0),this._state.id=y.readUInt32BE(1),this._state.ack=y.readUInt32BE(5),this._socket.traceSocketEvent(L.ProtocolHeaderRead,{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const D=this._state.messageType,w=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=b.HeaderLength,this._state.messageType=c.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(L.ProtocolMessageRead,y),this._onMessage.fire(new l(D,w,P,y)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(v){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=v,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(v){if(this._isDisposed)return;v.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=s.VSBuffer.alloc(b.HeaderLength);y.writeUInt8(v.type,0),y.writeUInt32BE(v.id,1),y.writeUInt32BE(v.ack,5),y.writeUInt32BE(v.data.byteLength,9),this._socket.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:C(v.type),id:v.id,ack:v.ack,messageSize:v.data.byteLength}),this._socket.traceSocketEvent(L.ProtocolMessageWrite,v.data),this._writeSoon(y,v.data)}_bufferAdd(v,y){const D=this._totalLength===0;return this._data.push(v,y),this._totalLength+=v.byteLength+y.byteLength,D}_bufferTake(){const v=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,v}_writeSoon(v,y){this._bufferAdd(v,y)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const v=this._bufferTake();this._socket.traceSocketEvent(L.ProtocolWrite,{byteLength:v.byteLength}),this._socket.write(v)}}class g extends T.Disposable{constructor(v){super(),this._onMessage=new d.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new d.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=v,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(y=>{y.type===c.Regular&&this._onMessage.fire(y.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(v){this._socketWriter.write(new l(c.Regular,0,0,v))}}e.Protocol=g;class n extends R.IPCClient{static fromSocket(v,y){return new n(new g(v),y)}get onDidDispose(){return this.protocol.onDidDispose}constructor(v,y,D=null){super(v,y,D),this.protocol=v}dispose(){super.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end()}}e.Client=n;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new d.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(v){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(v):this._emitter.fire(v):this._bufferedMessages.push(v)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class t{constructor(v){this.data=v,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let v=0,y=this._first;for(;y;)y=y.next,v++;return v}peek(){return this._first?this._first.data:null}toArray(){const v=[];let y=0,D=this._first;for(;D;)v[y++]=D.data,D=D.next;return v}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(v){const y=new t(v);if(!this._first){this._first=y,this._last=y;return}this._last.next=y,this._last=y}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const v=Date.now();for(let y=0;y<r._HISTORY_LENGTH;y++)this.lastRuns[y]=v-1e3*y;setInterval(()=>{for(let y=r._HISTORY_LENGTH;y>=1;y--)this.lastRuns[y]=this.lastRuns[y-1];this.lastRuns[0]=Date.now()},1e3)}load(){const v=Date.now(),y=(1+r._HISTORY_LENGTH)*1e3;let D=0;for(let w=0;w<r._HISTORY_LENGTH;w++)v-this.lastRuns[w]<=y&&D++;return 1-D/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class f{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(v){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=v.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=v.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new T.DisposableStore,this._socket=v.socket,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.add(this._socket.onClose(y=>this._onSocketClose.fire(y))),v.initialChunk&&this._socketReader.acceptChunk(v.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},b.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const v=new l(c.Disconnect,0,0,I());this._socketWriter.write(v),this._socketWriter.flush()}sendPause(){const v=new l(c.Pause,0,0,I());this._socketWriter.write(v)}sendResume(){const v=new l(c.Resume,0,0,I());this._socketWriter.write(v)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(v,y){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new T.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=v,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketReader.acceptChunk(y)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const v=new l(c.Ack,0,this._incomingAckId,I());this._socketWriter.write(v);const y=this._outgoingUnackMsg.toArray();for(let D=0,w=y.length;D<w;D++)this._socketWriter.write(y[D]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(v){if(v.ack>this._outgoingAckId){this._outgoingAckId=v.ack;do{const y=this._outgoingUnackMsg.peek();if(y&&y.id<=v.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(v.type){case c.None:break;case c.Regular:{if(v.id>this._incomingMsgId)if(v.id!==this._incomingMsgId+1){const y=Date.now();y-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=y,this._socketWriter.write(new l(c.ReplayRequest,0,0,I())))}else this._incomingMsgId=v.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(v.data);break}case c.Control:{this._onControlMessage.fire(v.data);break}case c.Ack:break;case c.Disconnect:{this._onDidDispose.fire();break}case c.ReplayRequest:{const y=this._outgoingUnackMsg.toArray();for(let D=0,w=y.length;D<w;D++)this._socketWriter.write(y[D]);this._recvAckCheck();break}case c.Pause:{this._socketWriter.pause();break}case c.Resume:{this._socketWriter.resume();break}case c.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(v){const y=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const D=new l(c.Regular,y,this._incomingAckId,v);this._outgoingUnackMsg.push(D),this._isReconnecting||(this._socketWriter.write(D),this._recvAckCheck())}sendControl(v){const y=new l(c.Control,0,0,v);this._socketWriter.write(y)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const v=Date.now()-this._incomingMsgLastTime;if(v>=b.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},b.AcknowledgeTime-v+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const v=this._outgoingUnackMsg.peek(),y=Date.now()-v.writtenTime,D=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(y>=b.TimeoutTime&&D>=b.TimeoutTime&&w>=b.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:D});return}const P=Math.max(b.TimeoutTime-y,b.TimeoutTime-D,b.TimeoutTime-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const v=new l(c.Ack,0,this._incomingAckId,I());this._socketWriter.write(v)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const v=new l(c.KeepAlive,0,this._incomingAckId,I());this._socketWriter.write(v)}}e.PersistentProtocol=f}),define(_e[209],ye([1,0,58,9,22,21,207,14,4,3,25,112,109,87]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,A=ze(A);class b extends C.ChannelServer{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>T.VSBuffer.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=b;class l{constructor(h,g){this.modulePath=h,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new d.Delayer(n),this.child=null,this._client=null}getChannel(h){const g=this;return{call(n,o,t){return g.requestPromise(h,n,o,t)},listen(n,o){return g.requestEvent(h,n,o)}}}requestPromise(h,g,n,o=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(A.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(h),i=(0,d.createCancelablePromise)(u=>t.call(g,n,u)),r=o.onCancellationRequested(()=>i.cancel()),f=(0,a.toDisposable)(()=>i.cancel());return this.activeRequests.add(f),i.finally(()=>{r.dispose(),this.activeRequests.delete(f),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(h,g,n){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let o;const t=new p.Emitter({onWillAddFirstListener:()=>{o=this.getCachedChannel(h).listen(g,n)(t.fire,t),this.activeRequests.add(o)},onDidRemoveLastListener:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,c.removeDangerousEnvVariables)(g.env),this.child=(0,s.fork)(this.modulePath,h,g);const n=new p.Emitter,t=p.Event.fromNodeEventEmitter(this.child,"message",y=>y)(y=>{if((0,L.isRemoteConsoleLog)(y)){(0,L.log)(y,`IPC Library: ${this.options.serverName}`);return}n.fire(T.VSBuffer.wrap(Buffer.from(y,"base64")))}),i=this.options.useQueue?(0,_.createQueuedSender)(this.child):this.child,r=y=>this.child&&this.child.connected&&i.send(y.buffer.toString("base64")),f=n.event,u={send:r,onMessage:f};this._client=new C.ChannelClient(u);const v=()=>this.disposeClient();process.once("exit",v),this.child.on("error",y=>console.warn('IPC "'+this.options.serverName+'" errored with '+y)),this.child.on("exit",(y,D)=>{process.removeListener("exit",v),t.dispose(),this.activeRequests.forEach(w=>(0,a.dispose)(w)),this.activeRequests.clear(),y!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+y+" and signal "+D),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:y,signal:D})})}return this._client}getCachedChannel(h){let g=this.channels.get(h);return g||(g=this.client.getChannel(h),this.channels.set(h,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=l}),define(_e[210],ye([1,0,9,4,3,57,18]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=p;var A;(function(c){c[c.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",c[c.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function p(c){const C=c;return C?.changed instanceof Map||C?.deleted instanceof Set}var a;(function(c){c[c.None=0]="None",c[c.Initialized=1]="Initialized",c[c.Closed=2]="Closed"})(a||(e.StorageState=a={}));class I extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(C,b=Object.create(null)){super(),this.database=C,this.options=b,this._onDidChangeStorage=this._register(new d.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new s.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){this._onDidChangeStorage.pause();try{C.changed?.forEach((b,l)=>this.acceptExternal(l,b)),C.deleted?.forEach(b=>this.acceptExternal(b,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(C,b){if(this.state===a.Closed)return;let l=!1;(0,L.isUndefinedOrNull)(b)?l=this.cache.delete(C):this.cache.get(C)!==b&&(this.cache.set(C,b),l=!0),l&&this._onDidChangeStorage.fire({key:C,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,b){const l=this.cache.get(C);return(0,L.isUndefinedOrNull)(l)?b:l}getBoolean(C,b){const l=this.get(C);return(0,L.isUndefinedOrNull)(l)?b:l==="true"}getNumber(C,b){const l=this.get(C);return(0,L.isUndefinedOrNull)(l)?b:parseInt(l,10)}getObject(C,b){const l=this.get(C);return(0,L.isUndefinedOrNull)(l)?b:(0,R.parse)(l)}async set(C,b,l=!1){if(this.state===a.Closed)return;if((0,L.isUndefinedOrNull)(b))return this.delete(C,l);const m=(0,L.isObject)(b)||Array.isArray(b)?(0,R.stringify)(b):String(b);if(this.cache.get(C)!==m)return this.cache.set(C,m),this.pendingInserts.set(C,m),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire({key:C,external:l}),this.doFlush()}async delete(C,b=!1){if(!(this.state===a.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire({key:C,external:b}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!(this.state===a.Closed||this.pendingClose))return this.doFlush(C)}async doFlush(C){return this.options.hint===A.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}isInMemory(){return this.options.hint===A.STORAGE_IN_MEMORY}}e.Storage=I;class _{constructor(){this.onDidChangeItemsExternal=d.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((b,l)=>this.items.set(l,b)),C.delete?.forEach(b=>this.items.delete(b))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=_}),define(_e[211],ye([1,0,13,11,22]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=I,e.decodeUTF16LE=_,s=ze(s),d=ze(d),T=ze(T);let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let A;function p(){return A||(A=new TextDecoder("UTF-16BE")),A}let a;function I(){return a||(a=d.isLittleEndian()?L():p()),a}function _(b,l,m){const h=new Uint16Array(b.buffer,l,m);return m>0&&(h[0]===65279||h[0]===65534)?c(b,l,m):L().decode(h)}function c(b,l,m){const h=[];let g=0;for(let n=0;n<m;n++){const o=T.readUInt16LE(b,l);l+=2,h[g++]=String.fromCharCode(o)}return h.join("")}class C{constructor(l){this._capacity=l|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const l=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return I().decode(l)}_flushBuffer(){const l=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[l]:this._completedStrings[this._completedStrings.length]=l}appendCharCode(l){const m=this._capacity-this._bufferLength;m<=1&&(m===0||s.isHighSurrogate(l))&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendASCIICharCode(l){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendString(l){const m=l.length;if(this._bufferLength+m>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=l;return}for(let h=0;h<m;h++)this._buffer[this._bufferLength++]=l.charCodeAt(h)}}e.StringBuilder=C}),define(_e[212],ye([1,0,22,211]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=L,s=ze(s);function T(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,I,_,c){this.oldPosition=a,this.oldText=I,this.newPosition=_,this.newText=c}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${T(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${T(this.oldText)}")`:`(replace@${this.oldPosition} "${T(this.oldText)}" with "${T(this.newText)}")`}static _writeStringSize(a){return 4+2*a.length}static _writeString(a,I,_){const c=I.length;s.writeUInt32BE(a,c,_),_+=4;for(let C=0;C<c;C++)s.writeUInt16LE(a,I.charCodeAt(C),_),_+=2;return _}static _readString(a,I){const _=s.readUInt32BE(a,I);return I+=4,(0,d.decodeUTF16LE)(a,I,_)}writeSize(){return 8+R._writeStringSize(this.oldText)+R._writeStringSize(this.newText)}write(a,I){return s.writeUInt32BE(a,this.oldPosition,I),I+=4,s.writeUInt32BE(a,this.newPosition,I),I+=4,I=R._writeString(a,this.oldText,I),I=R._writeString(a,this.newText,I),I}static read(a,I,_){const c=s.readUInt32BE(a,I);I+=4;const C=s.readUInt32BE(a,I);I+=4;const b=R._readString(a,I);I+=R._writeStringSize(b);const l=R._readString(a,I);return I+=R._writeStringSize(l),_.push(new R(c,b,C,l)),I}}e.TextChange=R;function L(p,a){return p===null||p.length===0?a:new A(p,a).compress()}class A{constructor(a,I){this._prevEdits=a,this._currEdits=I,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let a=0,I=0,_=this._getPrev(a),c=this._getCurr(I);for(;a<this._prevLen||I<this._currLen;){if(_===null){this._acceptCurr(c),c=this._getCurr(++I);continue}if(c===null){this._acceptPrev(_),_=this._getPrev(++a);continue}if(c.oldEnd<=_.newPosition){this._acceptCurr(c),c=this._getCurr(++I);continue}if(_.newEnd<=c.oldPosition){this._acceptPrev(_),_=this._getPrev(++a);continue}if(c.oldPosition<_.newPosition){const[h,g]=A._splitCurr(c,_.newPosition-c.oldPosition);this._acceptCurr(h),c=g;continue}if(_.newPosition<c.oldPosition){const[h,g]=A._splitPrev(_,c.oldPosition-_.newPosition);this._acceptPrev(h),_=g;continue}let l,m;if(c.oldEnd===_.newEnd)l=_,m=c,_=this._getPrev(++a),c=this._getCurr(++I);else if(c.oldEnd<_.newEnd){const[h,g]=A._splitPrev(_,c.oldLength);l=h,m=c,_=g,c=this._getCurr(++I)}else{const[h,g]=A._splitCurr(c,_.newLength);l=_,m=h,_=this._getPrev(++a),c=g}this._result[this._resultLen++]=new R(l.oldPosition,l.oldText,m.newPosition,m.newText),this._prevDeltaOffset+=l.newLength-l.oldLength,this._currDeltaOffset+=m.newLength-m.oldLength}const C=A._merge(this._result);return A._removeNoOps(C)}_acceptCurr(a){this._result[this._resultLen++]=A._rebaseCurr(this._prevDeltaOffset,a),this._currDeltaOffset+=a.newLength-a.oldLength}_getCurr(a){return a<this._currLen?this._currEdits[a]:null}_acceptPrev(a){this._result[this._resultLen++]=A._rebasePrev(this._currDeltaOffset,a),this._prevDeltaOffset+=a.newLength-a.oldLength}_getPrev(a){return a<this._prevLen?this._prevEdits[a]:null}static _rebaseCurr(a,I){return new R(I.oldPosition-a,I.oldText,I.newPosition,I.newText)}static _rebasePrev(a,I){return new R(I.oldPosition,I.oldText,I.newPosition+a,I.newText)}static _splitPrev(a,I){const _=a.newText.substr(0,I),c=a.newText.substr(I);return[new R(a.oldPosition,a.oldText,a.newPosition,_),new R(a.oldEnd,"",a.newPosition+I,c)]}static _splitCurr(a,I){const _=a.oldText.substr(0,I),c=a.oldText.substr(I);return[new R(a.oldPosition,_,a.newPosition,a.newText),new R(a.oldPosition+I,c,a.newEnd,"")]}static _merge(a){if(a.length===0)return a;const I=[];let _=0,c=a[0];for(let C=1;C<a.length;C++){const b=a[C];c.oldEnd===b.oldPosition?c=new R(c.oldPosition,c.oldText+b.oldText,c.newPosition,c.newText+b.newText):(I[_++]=c,c=b)}return I[_++]=c,I}static _removeNoOps(a){if(a.length===0)return a;const I=[];let _=0;for(let c=0;c<a.length;c++){const C=a[c];C.oldText!==C.newText&&(I[_++]=C)}return I}}}),define(_e[213],ye([1,0,39,17]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=T,e.targetsNotebooks=R;function T(L,A,p,a,I,_){if(Array.isArray(L)){let c=0;for(const C of L){const b=T(C,A,p,a,I,_);if(b===10)return b;b>c&&(c=b)}return c}else{if(typeof L=="string")return a?L==="*"?5:L===p?10:0:0;if(L){const{language:c,pattern:C,scheme:b,hasAccessToAllModels:l,notebookType:m}=L;if(!a&&!l)return 0;m&&I&&(A=I);let h=0;if(b)if(b===A.scheme)h=10;else if(b==="*")h=5;else return 0;if(c)if(c===p)h=10;else if(c==="*")h=Math.max(h,5);else return 0;if(m)if(m===_)h=10;else if(m==="*"&&_!==void 0)h=Math.max(h,5);else return 0;if(C){let g;if(typeof C=="string"?g=C:g={...C,base:(0,d.normalize)(C.base)},g===A.fsPath||(0,s.match)(g,A.fsPath))h=10;else return 0}return h}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(_e[214],ye([1,0,4,13,31,55,139,189,212,3]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,d=ze(d);class I extends a.Disposable{constructor(c,C,b,l,m,h,g){super(),this._onDidChangeContent=this._register(new s.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=C,this._mightContainNonBasicASCII=!h,this._mightContainRTL=l,this._mightContainUnusualLineTerminators=m,this._pieceTree=new L.PieceTreeBase(c,b,g)}equals(c){return!(c instanceof I)||this._BOM!==c._BOM||this.getEOL()!==c.getEOL()?!1:this._pieceTree.equal(c._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(c){return this._pieceTree.createSnapshot(c?this._BOM:"")}getOffsetAt(c,C){return this._pieceTree.getOffsetAt(c,C)}getPositionAt(c){return this._pieceTree.getPositionAt(c)}getRangeAt(c,C){const b=c+C,l=this.getPositionAt(c),m=this.getPositionAt(b);return new T.Range(l.lineNumber,l.column,m.lineNumber,m.column)}getValueInRange(c,C=R.EndOfLinePreference.TextDefined){if(c.isEmpty())return"";const b=this._getEndOfLine(C);return this._pieceTree.getValueInRange(c,b)}getValueLengthInRange(c,C=R.EndOfLinePreference.TextDefined){if(c.isEmpty())return 0;if(c.startLineNumber===c.endLineNumber)return c.endColumn-c.startColumn;const b=this.getOffsetAt(c.startLineNumber,c.startColumn),l=this.getOffsetAt(c.endLineNumber,c.endColumn);let m=0;const h=this._getEndOfLine(C),g=this.getEOL();if(h.length!==g.length){const n=h.length-g.length,o=c.endLineNumber-c.startLineNumber;m=n*o}return l-b+m}getCharacterCountInRange(c,C=R.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let b=0;const l=c.startLineNumber,m=c.endLineNumber;for(let h=l;h<=m;h++){const g=this.getLineContent(h),n=h===l?c.startColumn-1:0,o=h===m?c.endColumn-1:g.length;for(let t=n;t<o;t++)d.isHighSurrogate(g.charCodeAt(t))?(b=b+1,t=t+1):b=b+1}return b+=this._getEndOfLine(C).length*(m-l),b}return this.getValueLengthInRange(c,C)}getNearestChunk(c){return this._pieceTree.getNearestChunk(c)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(c){return this._pieceTree.getLineContent(c)}getLineCharCode(c,C){return this._pieceTree.getLineCharCode(c,C)}getCharCode(c){return this._pieceTree.getCharCode(c)}getLineLength(c){return this._pieceTree.getLineLength(c)}getLineMinColumn(c){return 1}getLineMaxColumn(c){return this.getLineLength(c)+1}getLineFirstNonWhitespaceColumn(c){const C=d.firstNonWhitespaceIndex(this.getLineContent(c));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(c){const C=d.lastNonWhitespaceIndex(this.getLineContent(c));return C===-1?0:C+2}_getEndOfLine(c){switch(c){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(c){this._pieceTree.setEOL(c)}applyEdits(c,C,b){let l=this._mightContainRTL,m=this._mightContainUnusualLineTerminators,h=this._mightContainNonBasicASCII,g=!0,n=[];for(let v=0;v<c.length;v++){const y=c[v];g&&y._isTracked&&(g=!1);const D=y.range;if(y.text){let S=!0;h||(S=!d.isBasicASCII(y.text),h=S),!l&&S&&(l=d.containsRTL(y.text)),!m&&S&&(m=d.containsUnusualLineTerminators(y.text))}let w="",P=0,k=0,E=0;if(y.text){let S;[P,k,E,S]=(0,A.countEOL)(y.text);const M=this.getEOL(),N=M===`\r
`?A.StringEOL.CRLF:A.StringEOL.LF;S===A.StringEOL.Unknown||S===N?w=y.text:w=y.text.replace(/\r\n|\r|\n/g,M)}n[v]={sortIndex:v,identifier:y.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:w,eolCount:P,firstLineLength:k,lastLineLength:E,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(I._sortOpsAscending);let o=!1;for(let v=0,y=n.length-1;v<y;v++){const D=n[v].range.getEndPosition(),w=n[v+1].range.getStartPosition();if(w.isBeforeOrEqual(D)){if(w.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}g&&(n=this._reduceOperations(n));const t=b||C?I._getInverseEditRanges(n):[],i=[];if(C)for(let v=0;v<n.length;v++){const y=n[v],D=t[v];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let w=D.startLineNumber;w<=D.endLineNumber;w++){let P="";w===D.startLineNumber&&(P=this.getLineContent(y.range.startLineNumber),d.firstNonWhitespaceIndex(P)!==-1)||i.push({lineNumber:w,oldContent:P})}}let r=null;if(b){let v=0;r=[];for(let y=0;y<n.length;y++){const D=n[y],w=t[y],P=this.getValueInRange(D.range),k=D.rangeOffset+v;v+=D.text.length-P.length,r[y]={sortIndex:D.sortIndex,identifier:D.identifier,range:w,text:P,textChange:new p.TextChange(D.rangeOffset,P,k,D.text)}}o||r.sort((y,D)=>y.sortIndex-D.sortIndex)}this._mightContainRTL=l,this._mightContainUnusualLineTerminators=m,this._mightContainNonBasicASCII=h;const f=this._doApplyEdits(n);let u=null;if(C&&i.length>0){i.sort((v,y)=>y.lineNumber-v.lineNumber),u=[];for(let v=0,y=i.length;v<y;v++){const D=i[v].lineNumber;if(v>0&&i[v-1].lineNumber===D)continue;const w=i[v].oldContent,P=this.getLineContent(D);P.length===0||P===w||d.firstNonWhitespaceIndex(P)!==-1||u.push(D)}}return this._onDidChangeContent.fire(),new R.ApplyEditsResult(r,f,u)}_reduceOperations(c){return c.length<1e3?c:[this._toSingleEditOperation(c)]}_toSingleEditOperation(c){let C=!1;const b=c[0].range,l=c[c.length-1].range,m=new T.Range(b.startLineNumber,b.startColumn,l.endLineNumber,l.endColumn);let h=b.startLineNumber,g=b.startColumn;const n=[];for(let f=0,u=c.length;f<u;f++){const v=c[f],y=v.range;C=C||v.forceMoveMarkers,n.push(this.getValueInRange(new T.Range(h,g,y.startLineNumber,y.startColumn))),v.text.length>0&&n.push(v.text),h=y.endLineNumber,g=y.endColumn}const o=n.join(""),[t,i,r]=(0,A.countEOL)(o);return{sortIndex:0,identifier:c[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:i,lastLineLength:r,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}_doApplyEdits(c){c.sort(I._sortOpsDescending);const C=[];for(let b=0;b<c.length;b++){const l=c[b],m=l.range.startLineNumber,h=l.range.startColumn,g=l.range.endLineNumber,n=l.range.endColumn;if(m===g&&h===n&&l.text.length===0)continue;l.text?(this._pieceTree.delete(l.rangeOffset,l.rangeLength),this._pieceTree.insert(l.rangeOffset,l.text,!0)):this._pieceTree.delete(l.rangeOffset,l.rangeLength);const o=new T.Range(m,h,g,n);C.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return C}findMatchesLineByLine(c,C,b,l){return this._pieceTree.findMatchesLineByLine(c,C,b,l)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(c,C){const b=c.startLineNumber,l=c.startColumn,[m,h,g]=(0,A.countEOL)(C);let n;if(C.length>0){const o=m+1;o===1?n=new T.Range(b,l,b,l+h):n=new T.Range(b,l,b+o-1,g+1)}else n=new T.Range(b,l,b,l);return n}static _getInverseEditRanges(c){const C=[];let b=0,l=0,m=null;for(let h=0,g=c.length;h<g;h++){const n=c[h];let o,t;m?m.range.endLineNumber===n.range.startLineNumber?(o=b,t=l+(n.range.startColumn-m.range.endColumn)):(o=b+(n.range.startLineNumber-m.range.endLineNumber),t=n.range.startColumn):(o=n.range.startLineNumber,t=n.range.startColumn);let i;if(n.text.length>0){const r=n.eolCount+1;r===1?i=new T.Range(o,t,o,t+n.firstLineLength):i=new T.Range(o,t,o+r-1,n.lastLineLength+1)}else i=new T.Range(o,t,o,t);b=i.endLineNumber,l=i.endColumn,C.push(i),m=n}return C}static _sortOpsAscending(c,C){const b=T.Range.compareRangesUsingEnds(c.range,C.range);return b===0?c.sortIndex-C.sortIndex:b}static _sortOpsDescending(c,C){const b=T.Range.compareRangesUsingEnds(c.range,C.range);return b===0?C.sortIndex-c.sortIndex:-b}}e.PieceTreeTextBuffer=I}),define(_e[215],ye([1,0,27,13,55,139,214]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,d=ze(d);class A{constructor(I,_,c,C,b,l,m,h,g){this._chunks=I,this._bom=_,this._cr=c,this._lf=C,this._crlf=b,this._containsRTL=l,this._containsUnusualLineTerminators=m,this._isBasicASCII=h,this._normalizeEOL=g}_getEOL(I){const _=this._cr+this._lf+this._crlf,c=this._cr+this._crlf;return _===0?I===T.DefaultEndOfLine.LF?`
`:`\r
`:c>_/2?`\r
`:`
`}create(I){const _=this._getEOL(I),c=this._chunks;if(this._normalizeEOL&&(_===`\r
`&&(this._cr>0||this._lf>0)||_===`
`&&(this._cr>0||this._crlf>0)))for(let b=0,l=c.length;b<l;b++){const m=c[b].buffer.replace(/\r\n|\r|\n/g,_),h=(0,R.createLineStartsFast)(m);c[b]=new R.StringBuffer(m,h)}const C=new L.PieceTreeTextBuffer(c,this._bom,_,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:C,disposable:C}}getFirstLineText(I){return this._chunks[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(I){if(I.length===0)return;this.chunks.length===0&&d.startsWithUTF8BOM(I)&&(this.BOM=d.UTF8_BOM_CHARACTER,I=I.substr(1));const _=I.charCodeAt(I.length-1);_===s.CharCode.CarriageReturn||_>=55296&&_<=56319?(this._acceptChunk1(I.substr(0,I.length-1),!1),this._hasPreviousChar=!0,this._previousChar=_):(this._acceptChunk1(I,!1),this._hasPreviousChar=!1,this._previousChar=_)}_acceptChunk1(I,_){!_&&I.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+I):this._acceptChunk2(I))}_acceptChunk2(I){const _=(0,R.createLineStarts)(this._tmpLineStarts,I);this.chunks.push(new R.StringBuffer(I,_.lineStarts)),this.cr+=_.cr,this.lf+=_.lf,this.crlf+=_.crlf,_.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=d.containsRTL(I)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=d.containsUnusualLineTerminators(I)))}finish(I=!0){return this._finish(),new A(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,I)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const I=this.chunks[this.chunks.length-1];I.buffer+=String.fromCharCode(this._previousChar);const _=(0,R.createLineStartsFast)(I.buffer);I.lineStarts=_,this._previousChar===s.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=p}),define(_e[143],ye([1,0,22,11]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=p,e.decodeSemanticTokensDto=I,d=ze(d);var T;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(T||(T={}));function R(_){for(let c=0,C=_.length;c<C;c+=4){const b=_[c+0],l=_[c+1],m=_[c+2],h=_[c+3];_[c+0]=h,_[c+1]=m,_[c+2]=l,_[c+3]=b}}function L(_){const c=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return d.isLittleEndian()||R(c),s.VSBuffer.wrap(c)}function A(_){const c=_.buffer;if(d.isLittleEndian()||R(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const C=new Uint8Array(c.byteLength);return C.set(c),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function p(_){const c=new Uint32Array(a(_));let C=0;if(c[C++]=_.id,_.type==="full")c[C++]=T.Full,c[C++]=_.data.length,c.set(_.data,C),C+=_.data.length;else{c[C++]=T.Delta,c[C++]=_.deltas.length;for(const b of _.deltas)c[C++]=b.start,c[C++]=b.deleteCount,b.data?(c[C++]=b.data.length,c.set(b.data,C),C+=b.data.length):c[C++]=0}return L(c)}function a(_){let c=0;if(c+=2,_.type==="full")c+=1+_.data.length;else{c+=1,c+=3*_.deltas.length;for(const C of _.deltas)C.data&&(c+=C.data.length)}return c}function I(_){const c=A(_);let C=0;const b=c[C++];if(c[C++]===T.Full){const g=c[C++],n=c.subarray(C,C+g);return C+=g,{id:b,type:"full",data:n}}const m=c[C++],h=[];for(let g=0;g<m;g++){const n=c[C++],o=c[C++],t=c[C++];let i;t>0&&(i=c.subarray(C,C+t),C+=t),h[g]={start:n,deleteCount:o,data:i}}return{id:b,type:"delta",deltas:h}}}),define(_e[216],ye([7,8]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(_e[217],ye([7,8]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(_e[88],ye([1,0,83,2,190,31,200,217]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=f,e.getAriaLabelForSymbol=v;class p{constructor(V,X,ee){this.offset=V,this.type=X,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class a{constructor(V,X){this.tokens=V,this.endState=X,this._tokenizationResultBrand=void 0}}e.TokenizationResult=a;class I{constructor(V,X){this.tokens=V,this.endState=X,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=I;var _;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(_||(e.HoverVerbosityAction=_={}));var c;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(c||(e.CompletionItemKind=c={}));var C;(function(B){const V=new Map;V.set(c.Method,s.Codicon.symbolMethod),V.set(c.Function,s.Codicon.symbolFunction),V.set(c.Constructor,s.Codicon.symbolConstructor),V.set(c.Field,s.Codicon.symbolField),V.set(c.Variable,s.Codicon.symbolVariable),V.set(c.Class,s.Codicon.symbolClass),V.set(c.Struct,s.Codicon.symbolStruct),V.set(c.Interface,s.Codicon.symbolInterface),V.set(c.Module,s.Codicon.symbolModule),V.set(c.Property,s.Codicon.symbolProperty),V.set(c.Event,s.Codicon.symbolEvent),V.set(c.Operator,s.Codicon.symbolOperator),V.set(c.Unit,s.Codicon.symbolUnit),V.set(c.Value,s.Codicon.symbolValue),V.set(c.Enum,s.Codicon.symbolEnum),V.set(c.Constant,s.Codicon.symbolConstant),V.set(c.Enum,s.Codicon.symbolEnum),V.set(c.EnumMember,s.Codicon.symbolEnumMember),V.set(c.Keyword,s.Codicon.symbolKeyword),V.set(c.Snippet,s.Codicon.symbolSnippet),V.set(c.Text,s.Codicon.symbolText),V.set(c.Color,s.Codicon.symbolColor),V.set(c.File,s.Codicon.symbolFile),V.set(c.Reference,s.Codicon.symbolReference),V.set(c.Customcolor,s.Codicon.symbolCustomColor),V.set(c.Folder,s.Codicon.symbolFolder),V.set(c.TypeParameter,s.Codicon.symbolTypeParameter),V.set(c.User,s.Codicon.account),V.set(c.Issue,s.Codicon.issues);function X(ne){let De=V.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=s.Codicon.symbolProperty),De}B.toIcon=X;const ee=new Map;ee.set("method",c.Method),ee.set("function",c.Function),ee.set("constructor",c.Constructor),ee.set("field",c.Field),ee.set("variable",c.Variable),ee.set("class",c.Class),ee.set("struct",c.Struct),ee.set("interface",c.Interface),ee.set("module",c.Module),ee.set("property",c.Property),ee.set("event",c.Event),ee.set("operator",c.Operator),ee.set("unit",c.Unit),ee.set("value",c.Value),ee.set("constant",c.Constant),ee.set("enum",c.Enum),ee.set("enum-member",c.EnumMember),ee.set("enumMember",c.EnumMember),ee.set("keyword",c.Keyword),ee.set("snippet",c.Snippet),ee.set("text",c.Text),ee.set("color",c.Color),ee.set("file",c.File),ee.set("reference",c.Reference),ee.set("customcolor",c.Customcolor),ee.set("folder",c.Folder),ee.set("type-parameter",c.TypeParameter),ee.set("typeParameter",c.TypeParameter),ee.set("account",c.User),ee.set("issue",c.Issue);function he(ne,De){let pe=ee.get(ne);return typeof pe>"u"&&!De&&(pe=c.Property),pe}B.fromString=he})(C||(e.CompletionItemKinds=C={}));var b;(function(B){B[B.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var l;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(l||(e.CompletionItemInsertTextRule=l={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var h;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var g;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class n{constructor(V,X,ee,he){this.range=V,this.text=X,this.completionKind=ee,this.isSnippetText=he}equals(V){return R.Range.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}e.SelectedSuggestionInfo=n;var o;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var i;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var r;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function f(B){return B&&d.URI.isUri(B.uri)&&R.Range.isIRange(B.range)&&(R.Range.isIRange(B.originSelectionRange)||R.Range.isIRange(B.targetSelectionRange))}var u;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(u||(e.SymbolKind=u={})),e.symbolKindNames={[u.Array]:(0,A.localize)(0,null),[u.Boolean]:(0,A.localize)(1,null),[u.Class]:(0,A.localize)(2,null),[u.Constant]:(0,A.localize)(3,null),[u.Constructor]:(0,A.localize)(4,null),[u.Enum]:(0,A.localize)(5,null),[u.EnumMember]:(0,A.localize)(6,null),[u.Event]:(0,A.localize)(7,null),[u.Field]:(0,A.localize)(8,null),[u.File]:(0,A.localize)(9,null),[u.Function]:(0,A.localize)(10,null),[u.Interface]:(0,A.localize)(11,null),[u.Key]:(0,A.localize)(12,null),[u.Method]:(0,A.localize)(13,null),[u.Module]:(0,A.localize)(14,null),[u.Namespace]:(0,A.localize)(15,null),[u.Null]:(0,A.localize)(16,null),[u.Number]:(0,A.localize)(17,null),[u.Object]:(0,A.localize)(18,null),[u.Operator]:(0,A.localize)(19,null),[u.Package]:(0,A.localize)(20,null),[u.Property]:(0,A.localize)(21,null),[u.String]:(0,A.localize)(22,null),[u.Struct]:(0,A.localize)(23,null),[u.TypeParameter]:(0,A.localize)(24,null),[u.Variable]:(0,A.localize)(25,null)};function v(B,V){return(0,A.localize)(26,null,B,e.symbolKindNames[V])}var y;(function(B){B[B.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var D;(function(B){const V=new Map;V.set(u.File,s.Codicon.symbolFile),V.set(u.Module,s.Codicon.symbolModule),V.set(u.Namespace,s.Codicon.symbolNamespace),V.set(u.Package,s.Codicon.symbolPackage),V.set(u.Class,s.Codicon.symbolClass),V.set(u.Method,s.Codicon.symbolMethod),V.set(u.Property,s.Codicon.symbolProperty),V.set(u.Field,s.Codicon.symbolField),V.set(u.Constructor,s.Codicon.symbolConstructor),V.set(u.Enum,s.Codicon.symbolEnum),V.set(u.Interface,s.Codicon.symbolInterface),V.set(u.Function,s.Codicon.symbolFunction),V.set(u.Variable,s.Codicon.symbolVariable),V.set(u.Constant,s.Codicon.symbolConstant),V.set(u.String,s.Codicon.symbolString),V.set(u.Number,s.Codicon.symbolNumber),V.set(u.Boolean,s.Codicon.symbolBoolean),V.set(u.Array,s.Codicon.symbolArray),V.set(u.Object,s.Codicon.symbolObject),V.set(u.Key,s.Codicon.symbolKey),V.set(u.Null,s.Codicon.symbolNull),V.set(u.EnumMember,s.Codicon.symbolEnumMember),V.set(u.Struct,s.Codicon.symbolStruct),V.set(u.Event,s.Codicon.symbolEvent),V.set(u.Operator,s.Codicon.symbolOperator),V.set(u.TypeParameter,s.Codicon.symbolTypeParameter);function X(ee){let he=V.get(ee);return he||(console.info("No codicon found for SymbolKind "+ee),he=s.Codicon.symbolProperty),he}B.toIcon=X})(D||(e.SymbolKinds=D={}));class w{static asEditOperation(V){return T.EditOperation.replace(R.Range.lift(V.range),V.text)}}e.TextEdit=w;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(V){switch(V){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(V)}constructor(V){this.value=V}}e.FoldingRangeKind=P;var k;(function(B){B[B.AIGenerated=1]="AIGenerated"})(k||(e.NewSymbolNameTag=k={}));var E;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(E||(e.NewSymbolNameTriggerKind=E={}));var S;(function(B){function V(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}B.is=V})(S||(e.Command=S={}));var M;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(M||(e.CommentThreadCollapsibleState=M={}));var N;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var x;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(x||(e.CommentMode=x={}));var U;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(U||(e.CommentState=U={}));var F;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class H{constructor(V){this.createSupport=V,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=H,e.TokenizationRegistry=new L.TokenizationRegistry;var j;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}));var re;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(_e[218],ye([7,8]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[219],ye([7,8]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(_e[220],ye([7,8]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(_e[221],ye([7,8]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(_e[222],ye([7,8]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(_e[223],ye([7,8]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[224],ye([7,8]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(_e[225],ye([7,8]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(_e[226],ye([7,8]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(_e[227],ye([7,8]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(_e[228],ye([7,8]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(_e[229],ye([7,8]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(_e[230],ye([7,8]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(_e[231],ye([7,8]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(_e[232],ye([7,8]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(_e[233],ye([7,8]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(_e[234],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[235],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[236],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(_e[237],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(_e[238],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(_e[239],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(_e[240],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[241],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(_e[242],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[243],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[244],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(_e[245],ye([7,8]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[246],ye([7,8]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(_e[247],ye([7,8]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(_e[248],ye([7,8]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(_e[249],ye([7,8]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(_e[250],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(_e[251],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(_e[252],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[253],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(_e[254],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(_e[255],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(_e[256],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(_e[257],ye([7,8]),function(le,e){return le.create("vs/workbench/contrib/testing/common/constants",e)}),define(_e[258],ye([7,8]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[259],ye([7,8]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(_e[260],ye([7,8]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(_e[261],ye([7,8]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(_e[262],ye([7,8]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(_e[263],ye([1,0,27,14,220]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...I){switch(I.length){case 1:return(0,T.localize)(0,null,I[0]);case 2:return(0,T.localize)(1,null,I[0],I[1]);case 3:return(0,T.localize)(2,null,I[0],I[1],I[2]);default:return}}const A=(0,T.localize)(3,null),p=(0,T.localize)(4,null);class a{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(_){switch(_.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return _.isTripleEq?"===":"==";case R.NotEq:return _.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return _.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return _.lexeme;case R.QuotedStr:return _.lexeme;case R.Error:return _.lexeme;case R.EOF:return"EOF";default:throw(0,d.illegalState)(`unhandled token type: ${JSON.stringify(_)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(_=>_.charCodeAt(0)))}static{this._keywords=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this._errors}reset(_){return this._input=_,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case s.CharCode.OpenParen:this._addToken(R.LParen);break;case s.CharCode.CloseParen:this._addToken(R.RParen);break;case s.CharCode.ExclamationMark:if(this._match(s.CharCode.Equals)){const c=this._match(s.CharCode.Equals);this._tokens.push({type:R.NotEq,offset:this._start,isTripleEq:c})}else this._addToken(R.Neg);break;case s.CharCode.SingleQuote:this._quotedString();break;case s.CharCode.Slash:this._regex();break;case s.CharCode.Equals:if(this._match(s.CharCode.Equals)){const c=this._match(s.CharCode.Equals);this._tokens.push({type:R.Eq,offset:this._start,isTripleEq:c})}else this._match(s.CharCode.Tilde)?this._addToken(R.RegexOp):this._error(L("==","=~"));break;case s.CharCode.LessThan:this._addToken(this._match(s.CharCode.Equals)?R.LtEq:R.Lt);break;case s.CharCode.GreaterThan:this._addToken(this._match(s.CharCode.Equals)?R.GtEq:R.Gt);break;case s.CharCode.Ampersand:this._match(s.CharCode.Ampersand)?this._addToken(R.And):this._error(L("&&"));break;case s.CharCode.Pipe:this._match(s.CharCode.Pipe)?this._addToken(R.Or):this._error(L("||"));break;case s.CharCode.Space:case s.CharCode.CarriageReturn:case s.CharCode.Tab:case s.CharCode.LineFeed:case s.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(R.EOF),Array.from(this._tokens)}_match(_){return this._isAtEnd()||this._input.charCodeAt(this._current)!==_?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?s.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(_){this._tokens.push({type:_,offset:this._start})}_error(_){const c=this._start,C=this._input.substring(this._start,this._current),b={type:R.Error,offset:this._start,lexeme:C};this._errors.push({offset:c,lexeme:C,additionalInfo:_}),this._tokens.push(b)}_string(){this.stringRe.lastIndex=this._start;const _=this.stringRe.exec(this._input);if(_){this._current=this._start+_[0].length;const c=this._input.substring(this._start,this._current),C=a._keywords.get(c);C?this._addToken(C):this._tokens.push({type:R.Str,lexeme:c,offset:this._start})}}_quotedString(){for(;this._peek()!==s.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:R.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let _=this._current,c=!1,C=!1;for(;;){if(_>=this._input.length){this._current=_,this._error(p);return}const l=this._input.charCodeAt(_);if(c)c=!1;else if(l===s.CharCode.Slash&&!C){_++;break}else l===s.CharCode.OpenSquareBracket?C=!0:l===s.CharCode.Backslash?c=!0:l===s.CharCode.CloseSquareBracket&&(C=!1);_++}for(;_<this._input.length&&a._regexFlags.has(this._input.charCodeAt(_));)_++;this._current=_;const b=this._input.substring(this._start,this._current);this._tokens.push({type:R.RegexStr,lexeme:b,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=a}),define(_e[144],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const s={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(s)}),define(_e[113],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(T,R=[],L=!1){this.ctor=T,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=s}),define(_e[89],ye([1,0,113]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=R,e.getSingletonServiceDescriptors=L;const d=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function R(A,p,a){p instanceof s.SyncDescriptor||(p=new s.SyncDescriptor(p,[],!!a)),d.push([A,p])}function L(){return d}}),define(_e[264],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=s;class d{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const A=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(L);A.outgoing.set(p.key,p),p.incoming.set(A.key,A)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(const A of this._nodes.values())A.outgoing.delete(L),A.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let A=this._nodes.get(L);return A||(A=new s(L,R),this._nodes.set(L,A)),A}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[L,A]of this._nodes)R.push(`${L}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this._nodes){const A=new Set([R]),p=this._findCycle(L,A);if(p)return p}}_findCycle(R,L){for(const[A,p]of R.outgoing){if(L.has(A))return[...L,A].join(" -> ");L.add(A);const a=this._findCycle(p,L);if(a)return a;L.delete(A)}}}e.Graph=d}),define(_e[5],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=T,e.refineServiceDecorator=R;var s;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function A(p){return p[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=A})(s||(e._util=s={})),e.IInstantiationService=T("instantiationService");function d(L,A,p){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:L,index:p}):(A[s.DI_DEPENDENCIES]=[{id:L,index:p}],A[s.DI_TARGET]=A)}function T(L){if(s.serviceIds.has(L))return s.serviceIds.get(L);const A=function(p,a,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");d(A,p,I)};return A.toString=()=>L,s.serviceIds.set(L,A),A}function R(L){return L}}),define(_e[45],ye([1,0,18,2,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=R,e.isConfigurationUpdateOverrides=L,e.ConfigurationTargetToString=p,e.isConfigured=a,e.toValuesTree=I,e.addToValueTree=_,e.removeFromValueTree=c,e.getConfigurationValue=b,e.merge=l,e.getLanguageTagSettingPlainKey=m,s=ze(s),e.IConfigurationService=(0,T.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof d.URI)}function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof d.URI)}var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function p(h){switch(h){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function a(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function I(h,g){const n=Object.create(null);for(const o in h)_(n,o,h[o],g);return n}function _(h,g,n,o){const t=g.split("."),i=t.pop();let r=h;for(let f=0;f<t.length;f++){const u=t[f];let v=r[u];switch(typeof v){case"undefined":v=r[u]=Object.create(null);break;case"object":if(v===null){o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is null`);return}break;default:o(`Ignoring ${g} as ${t.slice(0,f+1).join(".")} is ${JSON.stringify(v)}`);return}r=v}if(typeof r=="object"&&r!==null)try{r[i]=n}catch{o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(r)}`)}function c(h,g){const n=g.split(".");C(h,n)}function C(h,g){const n=g.shift();if(g.length===0){delete h[n];return}if(Object.keys(h).indexOf(n)!==-1){const o=h[n];typeof o=="object"&&!Array.isArray(o)&&(C(o,g),Object.keys(o).length===0&&delete h[n])}}function b(h,g,n){function o(r,f){let u=r;for(const v of f){if(typeof u!="object"||u===null)return;u=u[v]}return u}const t=g.split("."),i=o(h,t);return typeof i>"u"?n:i}function l(h,g,n){Object.keys(g).forEach(o=>{o!=="__proto__"&&(o in h?s.isObject(h[o])&&s.isObject(g[o])?l(h[o],g[o],n):n&&(h[o]=g[o]):h[o]=g[o])})}function m(h){return h.replace(/[\[\]]/g,"")}}),define(_e[36],ye([1,0,27,11,13,263,5,219,14]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=I,e.validateWhenClauses=f,e.expressionsAreEqualWithConstantSubstitution=u,e.implies=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",d.isMacintosh),a.set("isLinux",d.isLinux),a.set("isWindows",d.isWindows),a.set("isWeb",d.isWeb),a.set("isMacNative",d.isMacintosh&&!d.isWeb),a.set("isEdge",d.isEdge),a.set("isFirefox",d.isFirefox),a.set("isChrome",d.isChrome),a.set("isSafari",d.isSafari);function I(G,W){if(a.get(G)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(G,W)}const _=Object.prototype.hasOwnProperty;var c;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const C={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),l=(0,A.localize)(1,null),m=(0,A.localize)(2,null),h=(0,A.localize)(3,null),g=(0,A.localize)(4,null),n=(0,A.localize)(5,null),o=(0,A.localize)(6,null),t=(0,A.localize)(7,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=C){this._config=W,this._scanner=new R.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:b,offset:0,lexeme:"",additionalInfo:l});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const se=this._expr();if(!this._isAtEnd()){const ae=this._peek(),te=ae.type===R.TokenType.Str?n:void 0;throw this._parsingErrors.push({message:g,offset:ae.offset,lexeme:R.Scanner.getLexeme(ae),additionalInfo:te}),i._parseError}return se}catch(se){if(se!==i._parseError)throw se;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(R.TokenType.Or);){const se=this._and();W.push(se)}return W.length===1?W[0]:r.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(R.TokenType.And);){const se=this._term();W.push(se)}return W.length===1?W[0]:r.and(...W)}_term(){if(this._matchOne(R.TokenType.Neg)){const W=this._peek();switch(W.type){case R.TokenType.True:return this._advance(),y.INSTANCE;case R.TokenType.False:return this._advance(),D.INSTANCE;case R.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(R.TokenType.RParen,h),se?.negate()}case R.TokenType.Str:return this._advance(),M.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case R.TokenType.True:return this._advance(),r.true();case R.TokenType.False:return this._advance(),r.false();case R.TokenType.LParen:{this._advance();const se=this._expr();return this._consume(R.TokenType.RParen,h),se}case R.TokenType.Str:{const se=W.lexeme;if(this._advance(),this._matchOne(R.TokenType.RegexOp)){const te=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),te.type!==R.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",te);const ce=te.lexeme,ue=ce.lastIndexOf("/"),Y=ue===ce.length-1?void 0:this._removeFlagsGY(ce.substring(ue+1));let oe;try{oe=new RegExp(ce.substring(1,ue),Y)}catch{throw this._errExpectedButGot("REGEX",te)}return H.create(se,oe)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ce=[te.lexeme];this._advance();let ue=this._peek(),Y=0;for(let We=0;We<te.lexeme.length;We++)te.lexeme.charCodeAt(We)===s.CharCode.OpenParen?Y++:te.lexeme.charCodeAt(We)===s.CharCode.CloseParen&&Y--;for(;!this._isAtEnd()&&ue.type!==R.TokenType.And&&ue.type!==R.TokenType.Or;){switch(ue.type){case R.TokenType.LParen:Y++;break;case R.TokenType.RParen:Y--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let We=0;We<ue.lexeme.length;We++)ue.lexeme.charCodeAt(We)===s.CharCode.OpenParen?Y++:te.lexeme.charCodeAt(We)===s.CharCode.CloseParen&&Y--}if(Y<0)break;ce.push(R.Scanner.getLexeme(ue)),this._advance(),ue=this._peek()}const oe=ce.join(""),ve=oe.lastIndexOf("/"),be=ve===oe.length-1?void 0:this._removeFlagsGY(oe.substring(ve+1));let Fe;try{Fe=new RegExp(oe.substring(1,ve),be)}catch{throw this._errExpectedButGot("REGEX",te)}return r.regex(se,Fe)}case R.TokenType.QuotedStr:{const ce=te.lexeme;this._advance();let ue=null;if(!(0,T.isFalsyOrWhitespace)(ce)){const Y=ce.indexOf("/"),oe=ce.lastIndexOf("/");if(Y!==oe&&Y>=0){const ve=ce.slice(Y+1,oe),be=ce[oe+1]==="i"?"i":"";try{ue=new RegExp(ve,be)}catch{throw this._errExpectedButGot("REGEX",te)}}}if(ue===null)throw this._errExpectedButGot("REGEX",te);return H.create(se,ue)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(R.TokenType.Not)){this._consume(R.TokenType.In,m);const te=this._value();return r.notIn(se,te)}switch(this._peek().type){case R.TokenType.Eq:{this._advance();const te=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.equals(se,te);switch(te){case"true":return r.has(se);case"false":return r.not(se);default:return r.equals(se,te)}}case R.TokenType.NotEq:{this._advance();const te=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.notEquals(se,te);switch(te){case"true":return r.not(se);case"false":return r.has(se);default:return r.notEquals(se,te)}}case R.TokenType.Lt:return this._advance(),U.create(se,this._value());case R.TokenType.LtEq:return this._advance(),F.create(se,this._value());case R.TokenType.Gt:return this._advance(),O.create(se,this._value());case R.TokenType.GtEq:return this._advance(),x.create(se,this._value());case R.TokenType.In:return this._advance(),r.in(se,this._value());default:return r.has(se)}}case R.TokenType.EOF:throw this._parsingErrors.push({message:o,offset:W.offset,lexeme:"",additionalInfo:t}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this._advance(),W.lexeme;case R.TokenType.True:return this._advance(),"true";case R.TokenType.False:return this._advance(),"false";case R.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,se){if(this._check(W))return this._advance();throw this._errExpectedButGot(se,this._peek())}_errExpectedButGot(W,se,ae){const te=(0,A.localize)(8,null,W,R.Scanner.getLexeme(se)),ce=se.offset,ue=R.Scanner.getLexeme(se);return this._parsingErrors.push({message:te,offset:ce,lexeme:ue,additionalInfo:ae}),i._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===R.TokenType.EOF}}e.Parser=i;class r{static false(){return y.INSTANCE}static true(){return D.INSTANCE}static has(W){return w.create(W)}static equals(W,se){return P.create(W,se)}static notEquals(W,se){return S.create(W,se)}static regex(W,se){return H.create(W,se)}static in(W,se){return k.create(W,se)}static notIn(W,se){return E.create(W,se)}static not(W){return M.create(W)}static and(...W){return B.create(W,null,!0)}static or(...W){return V.create(W,null,!0)}static greater(W,se){return O.create(W,se)}static greaterEquals(W,se){return x.create(W,se)}static smaller(W,se){return U.create(W,se)}static smallerEquals(W,se){return F.create(W,se)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=r;function f(G){const W=new i({regexParsingWithErrorRecovery:!1});return G.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,A.localize)(9,null,ae.additionalInfo):(0,A.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function u(G,W){const se=G?G.substituteConstants():void 0,ae=W?W.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function v(G,W){return G.cmp(W)}class y{static{this.INSTANCE=new y}constructor(){this.type=c.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=y;class D{static{this.INSTANCE=new D}constructor(){this.type=c.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=D;class w{static create(W,se=null){const ae=a.get(W);return typeof ae=="boolean"?ae?D.INSTANCE:y.INSTANCE:new w(W,se)}constructor(W,se){this.key=W,this.negated=se,this.type=c.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=a.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:y.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class P{static create(W,se,ae=null){if(typeof se=="boolean")return se?w.create(W,ae):M.create(W,ae);const te=a.get(W);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:y.INSTANCE:new P(W,se,ae)}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.Equals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=a.get(this.key);if(typeof W=="boolean"){const se=W?"true":"false";return this.value===se?D.INSTANCE:y.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=P;class k{static create(W,se){return new k(W,se)}constructor(W,se){this.key=W,this.valueKey=se,this.type=c.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.valueKey),ae=W.getValue(this.key);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?_.call(se,ae):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class E{static create(W,se){return new E(W,se)}constructor(W,se){this.key=W,this.valueKey=se,this.type=c.NotIn,this._negated=k.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class S{static create(W,se,ae=null){if(typeof se=="boolean")return se?M.create(W,ae):w.create(W,ae);const te=a.get(W);return typeof te=="boolean"?se===(te?"true":"false")?y.INSTANCE:D.INSTANCE:new S(W,se,ae)}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=a.get(this.key);if(typeof W=="boolean"){const se=W?"true":"false";return this.value===se?y.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class M{static create(W,se=null){const ae=a.get(W);return typeof ae=="boolean"?ae?y.INSTANCE:D.INSTANCE:new M(W,se)}constructor(W,se){this.key=W,this.negated=se,this.type=c.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=a.get(this.key);return typeof W=="boolean"?W?y.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function N(G,W){if(typeof G=="string"){const se=parseFloat(G);isNaN(se)||(G=se)}return typeof G=="string"||typeof G=="number"?W(G):y.INSTANCE}class O{static create(W,se,ae=null){return N(se,te=>new O(W,te,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.Greater}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=O;class x{static create(W,se,ae=null){return N(se,te=>new x(W,te,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class U{static create(W,se,ae=null){return N(se,te=>new U(W,te,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class F{static create(W,se,ae=null){return N(se,te=>new F(W,te,ae))}constructor(W,se,ae){this.key=W,this.value=se,this.negated=ae,this.type=c.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class H{static create(W,se){return new H(W,se)}constructor(W,se){this.key=W,this.regexp=se,this.type=c.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const se=this.regexp?this.regexp.source:"",ae=W.regexp?W.regexp.source:"";return se<ae?-1:se>ae?1:0}equals(W){if(W.type===this.type){const se=this.regexp?this.regexp.source:"",ae=W.regexp?W.regexp.source:"";return this.key===W.key&&se===ae}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.key);return this.regexp?this.regexp.test(se):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=j.create(this)),this.negated}}e.ContextKeyRegexExpr=H;class j{static create(W){return new j(W)}constructor(W){this._actual=W,this.type=c.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new j(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=j;function re(G){let W=null;for(let se=0,ae=G.length;se<ae;se++){const te=G[se].substituteConstants();if(G[se]!==te&&W===null){W=[];for(let ce=0;ce<se;ce++)W[ce]=G[ce]}W!==null&&(W[se]=te)}return W===null?G:W}class B{static create(W,se,ae){return B._normalizeArr(W,se,ae)}constructor(W,se){this.expr=W,this.negated=se,this.type=c.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=v(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:B.create(W,this.negated,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static _normalizeArr(W,se,ae){const te=[];let ce=!1;for(const ue of W)if(ue){if(ue.type===c.True){ce=!0;continue}if(ue.type===c.False)return y.INSTANCE;if(ue.type===c.And){te.push(...ue.expr);continue}te.push(ue)}if(te.length===0&&ce)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(v);for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];for(;te.length>1;){const ue=te[te.length-1];if(ue.type!==c.Or)break;te.pop();const Y=te.pop(),oe=te.length===0,ve=V.create(ue.expr.map(be=>B.create([be,Y],null,ae)),null,oe);ve&&(te.push(ve),te.sort(v))}if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let Y=ue+1;Y<te.length;Y++)if(te[ue].negate().equals(te[Y]))return y.INSTANCE;if(te.length===1)return te[0]}return new B(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new B(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.negated){const W=[];for(const se of this.expr)W.push(se.negate());this.negated=V.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=B;class V{static create(W,se,ae){return V._normalizeArr(W,se,ae)}constructor(W,se){this.expr=W,this.negated=se,this.type=c.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=v(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:V.create(W,this.negated,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(W))return!0;return!1}static _normalizeArr(W,se,ae){let te=[],ce=!1;if(W){for(let ue=0,Y=W.length;ue<Y;ue++){const oe=W[ue];if(oe){if(oe.type===c.False){ce=!0;continue}if(oe.type===c.True)return D.INSTANCE;if(oe.type===c.Or){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&ce)return y.INSTANCE;te.sort(v)}if(te.length!==0){if(te.length===1)return te[0];for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];if(ae){for(let ue=0;ue<te.length;ue++)for(let Y=ue+1;Y<te.length;Y++)if(te[ue].negate().equals(te[Y]))return D.INSTANCE;if(te.length===1)return te[0]}return new V(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new V(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.negated){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),ae=W.shift(),te=[];for(const ce of pe(se))for(const ue of pe(ae))te.push(B.create([ce,ue],null,!1));W.unshift(V.create(te,null,!1))}this.negated=V.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class X extends w{static{this._info=[]}static all(){return X._info.values()}constructor(W,se,ae){super(W,null),this._defaultValue=se,typeof ae=="object"?X._info.push({...ae,key:W}):ae!==!0&&X._info.push({key:W,description:ae,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return S.create(this.key,W)}}e.RawContextKey=X,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function ee(G,W){return G<W?-1:G>W?1:0}function he(G,W,se,ae){return G<se?-1:G>se?1:W<ae?-1:W>ae?1:0}function ne(G,W){if(G.type===c.False||W.type===c.True)return!0;if(G.type===c.Or)return W.type===c.Or?De(G.expr,W.expr):!1;if(W.type===c.Or){for(const se of W.expr)if(ne(G,se))return!0;return!1}if(G.type===c.And){if(W.type===c.And)return De(W.expr,G.expr);for(const se of G.expr)if(ne(se,W))return!0;return!1}return G.equals(W)}function De(G,W){let se=0,ae=0;for(;se<G.length&&ae<W.length;){const te=G[se].cmp(W[ae]);if(te<0)return!1;te===0&&se++,ae++}return se===G.length}function pe(G){return G.type===c.Or?G.expr:[G]}}),define(_e[265],ye([1,0,36,5]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=R,e.IAccessibilityService=(0,d.createDecorator)("accessibilityService");var T;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(T||(e.AccessibilitySupport=T={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new s.RawContextKey("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(_e[114],ye([1,0,19,25,11,184,84,192,138,216,265]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=t,e.clampedFloat=r,e.stringSet=v,e.cursorStyleToString=N,e.filterValidationDecorations=Ie,s=ze(s),d=ze(d),T=ze(T),a=ze(a);var _;(function(de){de[de.None=0]="None",de[de.Keep=1]="Keep",de[de.Brackets=2]="Brackets",de[de.Advanced=3]="Advanced",de[de.Full=4]="Full"})(_||(e.EditorAutoIndentStrategy=_={})),e.MINIMAP_GUTTER_WIDTH=8;class c{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=c;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class b{constructor(J,Pe,Qe,et){this.id=J,this.name=Pe,this.defaultValue=Qe,this.schema=et}applyUpdate(J,Pe){return m(J,Pe)}compute(J,Pe,Qe){return Qe}}class l{constructor(J,Pe){this.newValue=J,this.didChange=Pe}}e.ApplyUpdateResult=l;function m(de,J){if(typeof de!="object"||typeof J!="object"||!de||!J)return new l(J,de!==J);if(Array.isArray(de)||Array.isArray(J)){const Qe=Array.isArray(de)&&Array.isArray(J)&&s.equals(de,J);return new l(J,!Qe)}let Pe=!1;for(const Qe in J)if(J.hasOwnProperty(Qe)){const et=m(de[Qe],J[Qe]);et.didChange&&(de[Qe]=et.newValue,Pe=!0)}return new l(de,Pe)}class h{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Pe){return m(J,Pe)}validate(J){return this.defaultValue}}class g{constructor(J,Pe,Qe,et){this.id=J,this.name=Pe,this.defaultValue=Qe,this.schema=et}applyUpdate(J,Pe){return m(J,Pe)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Pe,Qe){return Qe}}function n(de,J){return typeof de>"u"?J:de==="false"?!1:!!de}class o extends g{constructor(J,Pe,Qe,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Qe),super(J,Pe,Qe,et)}validate(J){return n(J,this.defaultValue)}}function t(de,J,Pe,Qe){if(typeof de>"u")return J;let et=parseInt(de,10);return isNaN(et)?J:(et=Math.max(Pe,et),et=Math.min(Qe,et),et|0)}class i extends g{static clampedInt(J,Pe,Qe,et){return t(J,Pe,Qe,et)}constructor(J,Pe,Qe,et,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Qe,gt.minimum=et,gt.maximum=ut),super(J,Pe,Qe,gt),this.minimum=et,this.maximum=ut}validate(J){return i.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function r(de,J,Pe,Qe){if(typeof de>"u")return J;const et=f.float(de,J);return f.clamp(et,Pe,Qe)}class f extends g{static clamp(J,Pe,Qe){return J<Pe?Pe:J>Qe?Qe:J}static float(J,Pe){if(typeof J=="number")return J;if(typeof J>"u")return Pe;const Qe=parseFloat(J);return isNaN(Qe)?Pe:Qe}constructor(J,Pe,Qe,et,ut){typeof ut<"u"&&(ut.type="number",ut.default=Qe),super(J,Pe,Qe,ut),this.validationFn=et}validate(J){return this.validationFn(f.float(J,this.defaultValue))}}class u extends g{static string(J,Pe){return typeof J!="string"?Pe:J}constructor(J,Pe,Qe,et=void 0){typeof et<"u"&&(et.type="string",et.default=Qe),super(J,Pe,Qe,et)}validate(J){return u.string(J,this.defaultValue)}}function v(de,J,Pe,Qe){return typeof de!="string"?J:Qe&&de in Qe?Qe[de]:Pe.indexOf(de)===-1?J:de}class y extends g{constructor(J,Pe,Qe,et,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Qe),super(J,Pe,Qe,ut),this._allowedValues=et}validate(J){return v(J,this.defaultValue,this._allowedValues)}}class D extends b{constructor(J,Pe,Qe,et,ut,gt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=et),super(J,Pe,Qe,Dt),this._allowedValues=ut,this._convert=gt}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function w(de){switch(de){case"none":return _.None;case"keep":return _.Keep;case"brackets":return _.Brackets;case"advanced":return _.Advanced;case"full":return _.Full}}class P extends b{constructor(){super(xe.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(J){switch(J){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(J,Pe,Qe){return Qe===I.AccessibilitySupport.Unknown?J.accessibilitySupport:Qe}}class k extends b{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(xe.comments,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:a.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{insertSpace:n(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(de){de[de.Hidden=0]="Hidden",de[de.Blink=1]="Blink",de[de.Smooth=2]="Smooth",de[de.Phase=3]="Phase",de[de.Expand=4]="Expand",de[de.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function S(de){switch(de){case"blink":return E.Blink;case"smooth":return E.Smooth;case"phase":return E.Phase;case"expand":return E.Expand;case"solid":return E.Solid}}var M;(function(de){de[de.Line=1]="Line",de[de.Block=2]="Block",de[de.Underline=3]="Underline",de[de.LineThin=4]="LineThin",de[de.BlockOutline=5]="BlockOutline",de[de.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(de){switch(de){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function O(de){switch(de){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class x extends h{constructor(){super(xe.editorClassName)}compute(J,Pe,Qe){const et=["monaco-editor"];return Pe.get(xe.extraEditorClassName)&&et.push(Pe.get(xe.extraEditorClassName)),J.extraEditorClassName&&et.push(J.extraEditorClassName),Pe.get(xe.mouseStyle)==="default"?et.push("mouse-default"):Pe.get(xe.mouseStyle)==="copy"&&et.push("mouse-copy"),Pe.get(xe.showUnused)&&et.push("showUnused"),Pe.get(xe.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class U extends o{constructor(){super(xe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(J,Pe,Qe){return Qe&&J.emptySelectionClipboard}}class F extends b{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(xe.find,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:a.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:a.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{cursorMoveOnType:n(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":v(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":v(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Pe.loop,this.defaultValue.loop)}}}class H extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(xe.fontLigatures,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"||J.length===0?H.OFF:J==="true"?H.ON:J:J?H.ON:H.OFF}}e.EditorFontLigatures=H;class j extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(xe.fontVariations,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?j.OFF:J==="true"?j.TRANSLATE:J:J?j.TRANSLATE:j.OFF}compute(J,Pe,Qe){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class re extends h{constructor(){super(xe.fontInfo)}compute(J,Pe,Qe){return J.fontInfo}}class B extends g{constructor(){super(xe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(J){const Pe=f.float(J,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Pe,6,100)}compute(J,Pe,Qe){return J.fontInfo.fontSize}}class V extends b{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(xe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(i.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}class X extends b{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(xe.gotoLocation,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Qe,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Qe,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Qe,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Qe,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Qe,description:a.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{multiple:v(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??v(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??v(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??v(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??v(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??v(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends b{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(xe.hover,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:J.above,description:a.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:n(Pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Pe.above,this.defaultValue.above)}}}var he;(function(de){de[de.None=0]="None",de[de.Text=1]="Text",de[de.Blocks=2]="Blocks"})(he||(e.RenderMinimap=he={}));class ne extends h{constructor(){super(xe.layoutInfo)}compute(J,Pe,Qe){return ne.computeLayout(Pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const Pe=J.height/J.lineHeight,Qe=Math.floor(J.paddingTop/J.lineHeight);let et=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(et=Math.max(et,Pe-1));const ut=(Qe+J.viewLineCount+et)/(J.pixelRatio*J.height),gt=Math.floor(J.viewLineCount/ut);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Qe,extraLinesBeyondLastLine:et,desiredRatio:ut,minimapLineCount:gt}}static _computeMinimapLayout(J,Pe){const Qe=J.outerWidth,et=J.outerHeight,ut=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:he.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const gt=Pe.stableMinimapLayoutInput,Dt=gt&&J.outerHeight===gt.outerHeight&&J.lineHeight===gt.lineHeight&&J.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&J.pixelRatio===gt.pixelRatio&&J.scrollBeyondLastLine===gt.scrollBeyondLastLine&&J.paddingTop===gt.paddingTop&&J.paddingBottom===gt.paddingBottom&&J.minimap.enabled===gt.minimap.enabled&&J.minimap.side===gt.minimap.side&&J.minimap.size===gt.minimap.size&&J.minimap.showSlider===gt.minimap.showSlider&&J.minimap.renderCharacters===gt.minimap.renderCharacters&&J.minimap.maxColumn===gt.minimap.maxColumn&&J.minimap.scale===gt.minimap.scale&&J.verticalScrollbarWidth===gt.verticalScrollbarWidth&&J.isViewportWrapping===gt.isViewportWrapping,Ot=J.lineHeight,zt=J.typicalHalfwidthCharacterWidth,ui=J.scrollBeyondLastLine,ti=J.minimap.renderCharacters;let Ze=ut>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const jt=J.minimap.maxColumn,Kt=J.minimap.size,vt=J.minimap.side,Tt=J.verticalScrollbarWidth,ii=J.viewLineCount,Yt=J.remainingWidth,$t=J.isViewportWrapping,St=ti?2:3;let Nt=Math.floor(ut*et);const di=Nt/ut;let Ht=!1,Je=!1,Jt=St*Ze,ni=Ze/ut,hi=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Vt,extraLinesBeyondLastLine:Gt,desiredRatio:oi,minimapLineCount:kt}=ne.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:ui,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:et,lineHeight:Ot,pixelRatio:ut});if(ii/kt>1)Ht=!0,Je=!0,Ze=1,Jt=1,ni=Ze/ut;else{let bt=!1,ei=Ze+1;if(Kt==="fit"){const It=Math.ceil((Vt+ii+Gt)*Jt);$t&&Dt&&Yt<=Pe.stableFitRemainingWidth?(bt=!0,ei=Pe.stableFitMaxMinimapScale):bt=It>Nt}if(Kt==="fill"||bt){Ht=!0;const It=Ze;Jt=Math.min(Ot*ut,Math.max(1,Math.floor(1/oi))),$t&&Dt&&Yt<=Pe.stableFitRemainingWidth&&(ei=Pe.stableFitMaxMinimapScale),Ze=Math.min(ei,Math.max(1,Math.floor(Jt/St))),Ze>It&&(hi=Math.min(2,Ze/It)),ni=Ze/ut/hi,Nt=Math.ceil(Math.max(si,Vt+ii+Gt)*Jt),$t?(Pe.stableMinimapLayoutInput=J,Pe.stableFitRemainingWidth=Yt,Pe.stableFitMaxMinimapScale=Ze):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Ct=Math.floor(jt*ni),Ft=Math.min(Ct,Math.max(0,Math.floor((Yt-Tt-2)*ni/(zt+ni)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ut*Ft);const Ut=At/ut;At=Math.floor(At*hi);const ri=ti?he.Text:he.Blocks,Zt=vt==="left"?0:Qe-Ft-Tt;return{renderMinimap:ri,minimapLeft:Zt,minimapWidth:Ft,minimapHeightIsEditorHeight:Ht,minimapIsSampling:Je,minimapScale:Ze,minimapLineHeight:Jt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:di}}static computeLayout(J,Pe){const Qe=Pe.outerWidth|0,et=Pe.outerHeight|0,ut=Pe.lineHeight|0,gt=Pe.lineNumbersDigitCount|0,Dt=Pe.typicalHalfwidthCharacterWidth,Ot=Pe.maxDigitWidth,zt=Pe.pixelRatio,ui=Pe.viewLineCount,ti=J.get(xe.wordWrapOverride2),Ze=ti==="inherit"?J.get(xe.wordWrapOverride1):ti,jt=Ze==="inherit"?J.get(xe.wordWrap):Ze,Kt=J.get(xe.wordWrapColumn),vt=Pe.isDominatedByLongLines,Tt=J.get(xe.glyphMargin),ii=J.get(xe.lineNumbers).renderType!==We.Off,Yt=J.get(xe.lineNumbersMinChars),$t=J.get(xe.scrollBeyondLastLine),St=J.get(xe.padding),Nt=J.get(xe.minimap),di=J.get(xe.scrollbar),Ht=di.verticalScrollbarSize,Je=di.verticalHasArrows,Jt=di.arrowSize,ni=di.horizontalScrollbarSize,hi=J.get(xe.folding),Ct=J.get(xe.showFoldingControls)!=="never";let Ft=J.get(xe.lineDecorationsWidth);hi&&Ct&&(Ft+=16);let At=0;if(ii){const qt=Math.max(gt,Yt);At=Math.round(qt*Ot)}let Ut=0;Tt&&(Ut=ut*Pe.glyphMarginDecorationLaneCount);let ri=0,Zt=ri+Ut,si=Zt+At,Vt=si+Ft;const Gt=Qe-Ut-At-Ft;let oi=!1,kt=!1,yt=-1;Ze==="inherit"&&vt?(oi=!0,kt=!0):jt==="on"||jt==="bounded"?kt=!0:jt==="wordWrapColumn"&&(yt=Kt);const bt=ne._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:zt,scrollBeyondLastLine:$t,paddingTop:St.top,paddingBottom:St.bottom,minimap:Nt,verticalScrollbarWidth:Ht,viewLineCount:ui,remainingWidth:Gt,isViewportWrapping:kt},Pe.memory||new C);bt.renderMinimap!==he.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,Zt+=bt.minimapWidth,si+=bt.minimapWidth,Vt+=bt.minimapWidth);const ei=Gt-bt.minimapWidth,It=Math.max(1,Math.floor((ei-Ht-2)/Dt)),fi=Je?Jt:0;return kt&&(yt=Math.max(1,It),jt==="bounded"&&(yt=Math.min(yt,Kt))),{width:Qe,height:et,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:At,decorationsLeft:si,decorationsWidth:Ft,contentLeft:Vt,contentWidth:ei,minimap:bt,viewportColumn:It,isWordWrapMinified:oi,isViewportWrapping:kt,wrappingColumn:yt,verticalScrollbarWidth:Ht,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Ht,height:et-2*fi,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends b{constructor(){super(xe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(J){return v(J,"simple",["simple","advanced"])}compute(J,Pe,Qe){return Pe.get(xe.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Qe}}var pe;(function(de){de.Off="off",de.OnCode="onCode",de.On="on"})(pe||(e.ShowLightbulbIconMode=pe={}));class G extends b{constructor(){const J={enabled:pe.On};super(xe.lightbulb,"lightbulb",J,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[pe.Off,pe.OnCode,pe.On],default:J.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:v(J.enabled,this.defaultValue.enabled,[pe.Off,pe.OnCode,pe.On])}}}class W extends b{constructor(){const J={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(xe.stickyScroll,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:a.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(xe.inlayHints,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:a.localize(65,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:v(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:n(Pe.padding,this.defaultValue.padding)}}}class ae extends b{constructor(){super(xe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):i.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Pe,Qe){return Qe<0?i.clampedInt(-Qe*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Qe}}class te extends f{constructor(){super(xe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>f.clamp(J,0,150),{markdownDescription:a.localize(66,null)})}compute(J,Pe,Qe){return J.fontInfo.lineHeight}}class ce extends b{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(xe.minimap,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:J.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:J.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:J.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:J.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:J.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),autohide:n(Pe.autohide,this.defaultValue.autohide),size:v(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Pe.side,this.defaultValue.side,["right","left"]),showSlider:v(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Pe.scale,1,1,3),maxColumn:i.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Pe.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(de){return de==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends b{constructor(){super(xe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{top:i.clampedInt(Pe.top,0,0,1e3),bottom:i.clampedInt(Pe.bottom,0,0,1e3)}}}class oe extends b{constructor(){const J={enabled:!0,cycle:!0};super(xe.parameterHints,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:a.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),cycle:n(Pe.cycle,this.defaultValue.cycle)}}}class ve extends h{constructor(){super(xe.pixelRatio)}compute(J,Pe,Qe){return J.pixelRatio}}class be extends b{constructor(){super(xe.placeholder,"placeholder",void 0)}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J:this.defaultValue}}class Fe extends b{constructor(){const J={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(xe.quickSuggestions,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:J.strings,description:a.localize(89,null)},comments:{anyOf:Pe,default:J.comments,description:a.localize(90,null)},other:{anyOf:Pe,default:J.other,description:a.localize(91,null)}},default:J,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const zt=J?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!J||typeof J!="object")return this.defaultValue;const{other:Pe,comments:Qe,strings:et}=J,ut=["on","inline","off"];let gt,Dt,Ot;return typeof Pe=="boolean"?gt=Pe?"on":"off":gt=v(Pe,this.defaultValue.other,ut),typeof Qe=="boolean"?Dt=Qe?"on":"off":Dt=v(Qe,this.defaultValue.comments,ut),typeof et=="boolean"?Ot=et?"on":"off":Ot=v(et,this.defaultValue.strings,ut),{other:gt,comments:Dt,strings:Ot}}}var We;(function(de){de[de.Off=0]="Off",de[de.On=1]="On",de[de.Relative=2]="Relative",de[de.Interval=3]="Interval",de[de.Custom=4]="Custom"})(We||(e.RenderLineNumbersType=We={}));class Ce extends b{constructor(){super(xe.lineNumbers,"lineNumbers",{renderType:We.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(J){let Pe=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Pe=We.Custom,Qe=J):J==="interval"?Pe=We.Interval:J==="relative"?Pe=We.Relative:J==="on"?Pe=We.On:Pe=We.Off),{renderType:Pe,renderFn:Qe}}}function Ie(de){const J=de.get(xe.renderValidationDecorations);return J==="editable"?de.get(xe.readOnly):J!=="on"}class Re extends b{constructor(){const J=[],Pe={type:"number",description:a.localize(98,null)};super(xe.rulers,"rulers",J,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:J,description:a.localize(100,null)})}validate(J){if(Array.isArray(J)){const Pe=[];for(const Qe of J)if(typeof Qe=="number")Pe.push({column:i.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Pe.push({column:i.clampedInt(et.column,0,0,1e4),color:et.color})}return Pe.sort((Qe,et)=>Qe.column-et.column),Pe}return this.defaultValue}}class z extends b{constructor(){super(xe.readOnlyMessage,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function $(de,J){if(typeof de!="string")return J;switch(de){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class Q extends b{constructor(){const J={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(xe.scrollbar,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J,Qe=i.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=i.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(Pe.vertical,this.defaultValue.vertical),horizontal:$(Pe.horizontal,this.defaultValue.horizontal),useShadows:n(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:i.clampedInt(Pe.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:i.clampedInt(Pe.verticalSliderSize,et,0,1e3),scrollByPage:n(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends b{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(xe.unicodeHighlighting,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:a.localize(119,null)}})}applyUpdate(J,Pe){let Qe=!1;Pe.allowedCharacters&&J&&(d.equals(J.allowedCharacters,Pe.allowedCharacters)||(J={...J,allowedCharacters:Pe.allowedCharacters},Qe=!0)),Pe.allowedLocales&&J&&(d.equals(J.allowedLocales,Pe.allowedLocales)||(J={...J,allowedLocales:Pe.allowedLocales},Qe=!0));const et=super.applyUpdate(J,Pe);return Qe?new l(et.newValue,!0):et}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{nonBasicASCII:je(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:je(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:je(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,Pe){if(typeof J!="object"||!J)return Pe;const Qe={};for(const[et,ut]of Object.entries(J))ut===!0&&(Qe[et]=!0);return Qe}}class fe extends b{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(xe.inlineSuggest,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:J.fontFamily,description:a.localize(126,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),mode:v(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class Ee extends b{constructor(){const J={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(xe.inlineEdit,"experimentalInlineEdit",J,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:J.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:J.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:J.backgroundColoring,description:a.localize(133,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showToolbar:v(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends b{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(xe.bracketPairColorization,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ve extends b{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(xe.guides,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:J.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:J.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:J.highlightActiveIndentation,description:a.localize(149,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{bracketPairs:je(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:je(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:je(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function je(de,J,Pe){const Qe=Pe.indexOf(de);return Qe===-1?J:Pe[Qe]}class tt extends b{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(xe.suggest,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:J.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:J.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{insertMode:v(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(Pe.preview,this.defaultValue.preview),previewMode:v(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Pe.showMethods,this.defaultValue.showMethods),showFunctions:n(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Pe.showFields,this.defaultValue.showFields),showVariables:n(Pe.showVariables,this.defaultValue.showVariables),showClasses:n(Pe.showClasses,this.defaultValue.showClasses),showStructs:n(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Pe.showModules,this.defaultValue.showModules),showProperties:n(Pe.showProperties,this.defaultValue.showProperties),showEvents:n(Pe.showEvents,this.defaultValue.showEvents),showOperators:n(Pe.showOperators,this.defaultValue.showOperators),showUnits:n(Pe.showUnits,this.defaultValue.showUnits),showValues:n(Pe.showValues,this.defaultValue.showValues),showConstants:n(Pe.showConstants,this.defaultValue.showConstants),showEnums:n(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Pe.showKeywords,this.defaultValue.showKeywords),showWords:n(Pe.showWords,this.defaultValue.showWords),showColors:n(Pe.showColors,this.defaultValue.showColors),showFiles:n(Pe.showFiles,this.defaultValue.showFiles),showReferences:n(Pe.showReferences,this.defaultValue.showReferences),showFolders:n(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(Pe.showUsers,this.defaultValue.showUsers),showIssues:n(Pe.showIssues,this.defaultValue.showIssues)}}}class rt extends b{constructor(){super(xe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(J.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends b{constructor(){const J=[];super(xe.wordSegmenterLocales,"wordSegmenterLocales",J,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(J){if(typeof J=="string"&&(J=[J]),Array.isArray(J)){const Pe=[];for(const Qe of J)if(typeof Qe=="string")try{Intl.Segmenter.supportedLocalesOf(Qe).length>0&&Pe.push(Qe)}catch{}return Pe}return this.defaultValue}}var nt;(function(de){de[de.None=0]="None",de[de.Same=1]="Same",de[de.Indent=2]="Indent",de[de.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class at extends b{constructor(){super(xe.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(J){switch(J){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(J,Pe,Qe){return Pe.get(xe.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Qe}}class mt extends h{constructor(){super(xe.wrappingInfo)}compute(J,Pe,Qe){const et=Pe.get(xe.layoutInfo);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class dt extends b{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(xe.dropIntoEditor,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showDropSelector:v(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends b{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(xe.pasteAs,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:n(Pe.enabled,this.defaultValue.enabled),showPasteSelector:v(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Te="Consolas, 'Courier New', monospace",Ue="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ue:T.isLinux?qe:Te,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(de){return e.editorOptionsRegistry[de.id]=de,de}var xe;(function(de){de[de.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",de[de.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",de[de.accessibilitySupport=2]="accessibilitySupport",de[de.accessibilityPageSize=3]="accessibilityPageSize",de[de.ariaLabel=4]="ariaLabel",de[de.ariaRequired=5]="ariaRequired",de[de.autoClosingBrackets=6]="autoClosingBrackets",de[de.autoClosingComments=7]="autoClosingComments",de[de.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",de[de.autoClosingDelete=9]="autoClosingDelete",de[de.autoClosingOvertype=10]="autoClosingOvertype",de[de.autoClosingQuotes=11]="autoClosingQuotes",de[de.autoIndent=12]="autoIndent",de[de.automaticLayout=13]="automaticLayout",de[de.autoSurround=14]="autoSurround",de[de.bracketPairColorization=15]="bracketPairColorization",de[de.guides=16]="guides",de[de.codeLens=17]="codeLens",de[de.codeLensFontFamily=18]="codeLensFontFamily",de[de.codeLensFontSize=19]="codeLensFontSize",de[de.colorDecorators=20]="colorDecorators",de[de.colorDecoratorsLimit=21]="colorDecoratorsLimit",de[de.columnSelection=22]="columnSelection",de[de.comments=23]="comments",de[de.contextmenu=24]="contextmenu",de[de.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",de[de.cursorBlinking=26]="cursorBlinking",de[de.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",de[de.cursorStyle=28]="cursorStyle",de[de.cursorSurroundingLines=29]="cursorSurroundingLines",de[de.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",de[de.cursorWidth=31]="cursorWidth",de[de.disableLayerHinting=32]="disableLayerHinting",de[de.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",de[de.domReadOnly=34]="domReadOnly",de[de.dragAndDrop=35]="dragAndDrop",de[de.dropIntoEditor=36]="dropIntoEditor",de[de.emptySelectionClipboard=37]="emptySelectionClipboard",de[de.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",de[de.extraEditorClassName=39]="extraEditorClassName",de[de.fastScrollSensitivity=40]="fastScrollSensitivity",de[de.find=41]="find",de[de.fixedOverflowWidgets=42]="fixedOverflowWidgets",de[de.folding=43]="folding",de[de.foldingStrategy=44]="foldingStrategy",de[de.foldingHighlight=45]="foldingHighlight",de[de.foldingImportsByDefault=46]="foldingImportsByDefault",de[de.foldingMaximumRegions=47]="foldingMaximumRegions",de[de.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",de[de.fontFamily=49]="fontFamily",de[de.fontInfo=50]="fontInfo",de[de.fontLigatures=51]="fontLigatures",de[de.fontSize=52]="fontSize",de[de.fontWeight=53]="fontWeight",de[de.fontVariations=54]="fontVariations",de[de.formatOnPaste=55]="formatOnPaste",de[de.formatOnType=56]="formatOnType",de[de.glyphMargin=57]="glyphMargin",de[de.gotoLocation=58]="gotoLocation",de[de.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",de[de.hover=60]="hover",de[de.inDiffEditor=61]="inDiffEditor",de[de.inlineSuggest=62]="inlineSuggest",de[de.inlineEdit=63]="inlineEdit",de[de.letterSpacing=64]="letterSpacing",de[de.lightbulb=65]="lightbulb",de[de.lineDecorationsWidth=66]="lineDecorationsWidth",de[de.lineHeight=67]="lineHeight",de[de.lineNumbers=68]="lineNumbers",de[de.lineNumbersMinChars=69]="lineNumbersMinChars",de[de.linkedEditing=70]="linkedEditing",de[de.links=71]="links",de[de.matchBrackets=72]="matchBrackets",de[de.minimap=73]="minimap",de[de.mouseStyle=74]="mouseStyle",de[de.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",de[de.mouseWheelZoom=76]="mouseWheelZoom",de[de.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",de[de.multiCursorModifier=78]="multiCursorModifier",de[de.multiCursorPaste=79]="multiCursorPaste",de[de.multiCursorLimit=80]="multiCursorLimit",de[de.occurrencesHighlight=81]="occurrencesHighlight",de[de.overviewRulerBorder=82]="overviewRulerBorder",de[de.overviewRulerLanes=83]="overviewRulerLanes",de[de.padding=84]="padding",de[de.pasteAs=85]="pasteAs",de[de.parameterHints=86]="parameterHints",de[de.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",de[de.placeholder=88]="placeholder",de[de.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",de[de.quickSuggestions=90]="quickSuggestions",de[de.quickSuggestionsDelay=91]="quickSuggestionsDelay",de[de.readOnly=92]="readOnly",de[de.readOnlyMessage=93]="readOnlyMessage",de[de.renameOnType=94]="renameOnType",de[de.renderControlCharacters=95]="renderControlCharacters",de[de.renderFinalNewline=96]="renderFinalNewline",de[de.renderLineHighlight=97]="renderLineHighlight",de[de.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",de[de.renderValidationDecorations=99]="renderValidationDecorations",de[de.renderWhitespace=100]="renderWhitespace",de[de.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",de[de.roundedSelection=102]="roundedSelection",de[de.rulers=103]="rulers",de[de.scrollbar=104]="scrollbar",de[de.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",de[de.scrollBeyondLastLine=106]="scrollBeyondLastLine",de[de.scrollPredominantAxis=107]="scrollPredominantAxis",de[de.selectionClipboard=108]="selectionClipboard",de[de.selectionHighlight=109]="selectionHighlight",de[de.selectOnLineNumbers=110]="selectOnLineNumbers",de[de.showFoldingControls=111]="showFoldingControls",de[de.showUnused=112]="showUnused",de[de.snippetSuggestions=113]="snippetSuggestions",de[de.smartSelect=114]="smartSelect",de[de.smoothScrolling=115]="smoothScrolling",de[de.stickyScroll=116]="stickyScroll",de[de.stickyTabStops=117]="stickyTabStops",de[de.stopRenderingLineAfter=118]="stopRenderingLineAfter",de[de.suggest=119]="suggest",de[de.suggestFontSize=120]="suggestFontSize",de[de.suggestLineHeight=121]="suggestLineHeight",de[de.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",de[de.suggestSelection=123]="suggestSelection",de[de.tabCompletion=124]="tabCompletion",de[de.tabIndex=125]="tabIndex",de[de.unicodeHighlighting=126]="unicodeHighlighting",de[de.unusualLineTerminators=127]="unusualLineTerminators",de[de.useShadowDOM=128]="useShadowDOM",de[de.useTabStops=129]="useTabStops",de[de.wordBreak=130]="wordBreak",de[de.wordSegmenterLocales=131]="wordSegmenterLocales",de[de.wordSeparators=132]="wordSeparators",de[de.wordWrap=133]="wordWrap",de[de.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",de[de.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",de[de.wordWrapColumn=136]="wordWrapColumn",de[de.wordWrapOverride1=137]="wordWrapOverride1",de[de.wordWrapOverride2=138]="wordWrapOverride2",de[de.wrappingIndent=139]="wrappingIndent",de[de.wrappingStrategy=140]="wrappingStrategy",de[de.showDeprecated=141]="showDeprecated",de[de.inlayHints=142]="inlayHints",de[de.editorClassName=143]="editorClassName",de[de.pixelRatio=144]="pixelRatio",de[de.tabFocusMode=145]="tabFocusMode",de[de.layoutInfo=146]="layoutInfo",de[de.wrappingInfo=147]="wrappingInfo",de[de.defaultColorDecorators=148]="defaultColorDecorators",de[de.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",de[de.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new o(xe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:Oe(new y(xe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:Oe(new P),accessibilityPageSize:Oe(new i(xe.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:Oe(new u(xe.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:Oe(new o(xe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new o(xe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new y(xe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:Oe(new y(xe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:Oe(new y(xe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:Oe(new y(xe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:Oe(new y(xe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:Oe(new D(xe.autoIndent,"autoIndent",_.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:Oe(new o(xe.automaticLayout,"automaticLayout",!1)),autoSurround:Oe(new y(xe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:Oe(new Ne),bracketPairGuides:Oe(new Ve),stickyTabStops:Oe(new o(xe.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:Oe(new o(xe.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:Oe(new u(xe.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:Oe(new i(xe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:Oe(new o(xe.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:Oe(new y(xe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:Oe(new i(xe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:Oe(new o(xe.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:Oe(new k),contextmenu:Oe(new o(xe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new o(xe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:Oe(new D(xe.cursorBlinking,"cursorBlinking",E.Blink,"blink",["blink","smooth","phase","expand","solid"],S,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:Oe(new y(xe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:Oe(new D(xe.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:a.localize(261,null)})),cursorSurroundingLines:Oe(new i(xe.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:Oe(new y(xe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:Oe(new i(xe.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:Oe(new o(xe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new o(xe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new o(xe.domReadOnly,"domReadOnly",!1)),dragAndDrop:Oe(new o(xe.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:Oe(new U),dropIntoEditor:Oe(new dt),stickyScroll:Oe(new W),experimentalWhitespaceRendering:Oe(new y(xe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:Oe(new u(xe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Oe(new f(xe.fastScrollSensitivity,"fastScrollSensitivity",5,de=>de<=0?5:de,{markdownDescription:a.localize(272,null)})),find:Oe(new F),fixedOverflowWidgets:Oe(new o(xe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Oe(new o(xe.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:Oe(new y(xe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:Oe(new o(xe.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:Oe(new o(xe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:Oe(new i(xe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:Oe(new o(xe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:Oe(new u(xe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:Oe(new re),fontLigatures2:Oe(new H),fontSize:Oe(new B),fontWeight:Oe(new V),fontVariations:Oe(new j),formatOnPaste:Oe(new o(xe.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:Oe(new o(xe.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:Oe(new o(xe.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:Oe(new X),hideCursorInOverviewRuler:Oe(new o(xe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:Oe(new ee),inDiffEditor:Oe(new o(xe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Oe(new f(xe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,de=>f.clamp(de,-5,20),{description:a.localize(286,null)})),lightbulb:Oe(new G),lineDecorationsWidth:Oe(new ae),lineHeight:Oe(new te),lineNumbers:Oe(new Ce),lineNumbersMinChars:Oe(new i(xe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new o(xe.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:Oe(new o(xe.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:Oe(new y(xe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:Oe(new ce),mouseStyle:Oe(new y(xe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new f(xe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,de=>de===0?1:de,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:Oe(new o(xe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:T.isMacintosh?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:Oe(new o(xe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:Oe(new D(xe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:Oe(new y(xe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:Oe(new i(xe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:Oe(new y(xe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:Oe(new o(xe.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:Oe(new i(xe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Oe(new Y),pasteAs:Oe(new lt),parameterHints:Oe(new oe),peekWidgetDefaultFocus:Oe(new y(xe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:Oe(new be),definitionLinkOpensInPeek:Oe(new o(xe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:Oe(new Fe),quickSuggestionsDelay:Oe(new i(xe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:Oe(new o(xe.readOnly,"readOnly",!1)),readOnlyMessage:Oe(new z),renameOnType:Oe(new o(xe.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:Oe(new o(xe.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:Oe(new y(xe.renderFinalNewline,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:Oe(new y(xe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Oe(new o(xe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:Oe(new y(xe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new y(xe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:Oe(new i(xe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new o(xe.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:Oe(new Re),scrollbar:Oe(new Q),scrollBeyondLastColumn:Oe(new i(xe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:Oe(new o(xe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:Oe(new o(xe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:Oe(new o(xe.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:T.isLinux})),selectionHighlight:Oe(new o(xe.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:Oe(new o(xe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new y(xe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:Oe(new o(xe.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:Oe(new o(xe.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:Oe(new se),snippetSuggestions:Oe(new y(xe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:Oe(new rt),smoothScrolling:Oe(new o(xe.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:Oe(new i(xe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Oe(new tt),inlineSuggest:Oe(new fe),inlineEdit:Oe(new Ee),inlineCompletionsAccessibilityVerbose:Oe(new o(xe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:Oe(new i(xe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new i(xe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new o(xe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:Oe(new y(xe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:Oe(new y(xe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:Oe(new i(xe.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Oe(new Z),unusualLineTerminators:Oe(new y(xe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:Oe(new o(xe.useShadowDOM,"useShadowDOM",!0)),useTabStops:Oe(new o(xe.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:Oe(new y(xe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:Oe(new ot),wordSeparators:Oe(new u(xe.wordSeparators,"wordSeparators",p.USUAL_WORD_SEPARATORS,{description:a.localize(360,null)})),wordWrap:Oe(new y(xe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:Oe(new u(xe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new u(xe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new i(xe.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:Oe(new y(xe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new y(xe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new x),defaultColorDecorators:Oe(new o(xe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:Oe(new ve),tabFocusMode:Oe(new o(xe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:Oe(new ne),wrappingInfo:Oe(new mt),wrappingIndent:Oe(new at),wrappingStrategy:Oe(new De)}});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[266],ye([1,0,23,44,221,5,110,11,25]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=C,e.massageMessageBoxOptions=b,d=xt(d),e.IDialogService=(0,R.createDecorator)("dialogService");var a;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(a||(a={}));class I{getConfirmationButtons(m){return this.getButtons(m,a.Confirmation)}getPromptButtons(m){return this.getButtons(m,a.Prompt)}getInputButtons(m){return this.getButtons(m,a.Input)}getButtons(m,h){const g=[];switch(h){case a.Confirmation:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,T.localize)(0,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,T.localize)(1,null));break}case a.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&g.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?g.push((0,T.localize)(2,null)):typeof n.cancelButton=="string"?g.push(n.cancelButton):n.cancelButton.label?g.push(n.cancelButton.label):g.push((0,T.localize)(3,null))),g.length===0&&g.push((0,T.localize)(4,null));break}case a.Input:{const n=m;n.primaryButton?g.push(n.primaryButton):g.push((0,T.localize)(5,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,T.localize)(6,null));break}}return g}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===d.default.Info?"info":m===d.default.Error?"error":m===d.default.Warning?"warning":"none"}getPromptResult(m,h,g){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let o=n[h]?.run({checkboxChecked:g});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:g}}}e.AbstractDialogHandler=I,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var _;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(_||(e.ConfirmResult=_={}));const c=10;function C(l){const m=[];return m.push(...l.slice(0,c).map(h=>typeof h=="string"?h:(0,s.basename)(h))),l.length>c&&(l.length-c===1?m.push((0,T.localize)(7,null)):m.push((0,T.localize)(8,null,l.length-c))),m.push(""),m.join(`
`)}function b(l,m){const h=(0,p.deepClone)(l);let g=(h.buttons??[]).map(i=>(0,L.mnemonicButtonLabel)(i)),n=(l.buttons||[]).map((i,r)=>r),o=0,t=h.cancelId??g.length-1;if(g.length>1){const i=typeof t=="number"?g[t]:void 0;if(A.isLinux||A.isMacintosh){if(typeof i=="string"&&g.length>1&&t!==1){g.splice(t,1),g.splice(1,0,i);const r=n[t];n.splice(t,1),n.splice(1,0,r),t=1}A.isLinux&&g.length>1&&(g=g.reverse(),n=n.reverse(),o=g.length-1,typeof i=="string"&&(t=o-1))}else if(A.isWindows&&typeof i=="string"&&g.length>1&&t!==g.length-1){g.splice(t,1),g.push(i);const r=n[t];n.splice(t,1),n.push(r),t=g.length-1}}return h.buttons=g,h.defaultId=o,h.cancelId=t,h.noLink=!0,h.title=h.title||m.nameLong,{options:h,buttonIndeces:n}}}),define(_e[145],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[267],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,s.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(_e[268],ye([1,0,58,59,15,17,11,109,34,112,224,267]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,s=ze(s),R=ze(R),L=ze(L),p=ze(p),a=ze(a),I=ze(I);const c=I.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends C{static{this.CMD="cmd.exe"}openTerminal(t,i){return this.spawnTerminal(s,t,a.getWindowsShell(),i)}spawnTerminal(t,i,r,f){const u=i.windowsExec||b.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const v=R.basename(u,".exe").toLowerCase();if(v==="cmder")return t.spawn(u,f?[f]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return u.indexOf(" ")>=0&&y.push('""'),y.push(u),v==="wt"&&y.push("-d ."),new Promise((D,w)=>{const P=h(process),k=t.spawn(r,y,{cwd:f,env:P,detached:!0});k.on("error",w),k.on("exit",()=>D())})}async runInTerminal(t,i,r,f,u){const v="windowsExec"in u&&u.windowsExec?u.windowsExec:b.getDefaultTerminalWindows(),y=await b.getWtExePath();return new Promise((D,w)=>{const P=`"${i} - ${c}"`,k=`"${r.join('" "')}" & pause`,E=Object.assign({},h(process),f);Object.keys(E).filter(x=>E[x]===null).forEach(x=>delete E[x]);const S={cwd:i,env:E,windowsVerbatimArguments:!0};let M,N;R.basename(v,".exe")==="wt"?(M=v,N=["-d",".",b.CMD,"/c",k]):y?(M=y,N=["-d",".",v,"/c",k]):(M=b.CMD,N=["/c","start",P,"/wait",v,"/c",`"${k}"`]),s.spawn(M,N,S).on("error",x=>{w(g(x))}),D(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const t=await a.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.WindowsExternalTerminalService=b,Xe([d.memoize],b,"getWtExePath",null);class l extends C{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(t,i){return this.spawnTerminal(s,t,i)}runInTerminal(t,i,r,f,u){const v=u.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((y,D)=>{if(v===_.DEFAULT_TERMINAL_OSX||v==="iTerm.app"){const w=v===_.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[T.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",t||c,"-w",i];for(const M of r)k.push("-a"),k.push(M);if(f){const M=Object.assign({},h(process),f);for(const N in M){const O=M[N];O===null?(k.push("-u"),k.push(N)):(k.push("-e"),k.push(`${N}=${O}`))}}let E="";const S=s.spawn(l.OSASCRIPT,k);S.on("error",M=>{D(g(M))}),S.stderr.on("data",M=>{E+=M.toString()}),S.on("exit",M=>{if(M===0)y(void 0);else if(E){const N=E.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(1,null,w,M)))})}else D(new Error(I.localize(2,null,v)))})}spawnTerminal(t,i,r){const f=i.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((u,v)=>{const y=["-a",f];r&&y.push(r);const D=h(process),w=t.spawn("/usr/bin/open",y,{cwd:r,env:D});w.on("error",v),w.on("exit",()=>u())})}}e.MacExternalTerminalService=l;class m extends C{static{this.WAIT_MESSAGE=I.localize(3,null)}openTerminal(t,i){return this.spawnTerminal(s,t,i)}runInTerminal(t,i,r,f,u){const v=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((y,D)=>{const w=[];v.then(P=>{P.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const k=`${n(r)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;w.push(`''${k}''`);const E=Object.assign({},h(process),f);Object.keys(E).filter(O=>E[O]===null).forEach(O=>delete E[O]);const S={cwd:i,env:E};let M="";const N=s.spawn(P,w,S);N.on("error",O=>{D(g(O))}),N.stderr.on("data",O=>{M+=O.toString()}),N.on("exit",O=>{if(O===0)y(void 0);else if(M){const x=M.split(`
`,1);D(new Error(x[0]))}else D(new Error(I.localize(4,null,P,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(i=>{t?i("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?i("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?i("konsole"):process.env.COLORTERM?i(process.env.COLORTERM):process.env.TERM?i(process.env.TERM):i("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,i,r){const f=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,v)=>{f.then(y=>{const D=h(process),w=t.spawn(y,[],{cwd:r,env:D});w.on("error",v),w.on("exit",()=>u())})})}}e.LinuxExternalTerminalService=m;function h(o){const t={...o.env};return(0,A.sanitizeProcessEnvironment)(t),t}function g(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let t="";for(const i of o)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(_e[28],ye([1,0,85,17,13,18,2,225,5,11,15,49]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=c,e.isFileSystemWatcher=m,e.hasReadWriteCapability=g,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=o,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=i,e.hasFileAtomicReadCapability=r,e.hasFileAtomicWriteCapability=f,e.hasFileAtomicDeleteCapability=u,e.hasReadonlyCapability=v,e.createFileSystemProviderError=w,e.ensureFileSystemProviderError=P,e.markAsFileSystemProviderError=k,e.toFileSystemProviderErrorCode=E,e.toFileOperationResult=S,e.isParent=U,e.etag=V,e.whenProviderRegistered=X,e.getLargeFileConfirmationLimit=he,e.IFileService=(0,p.createDecorator)("fileService");function c(ne){return ne.create===!0}var C;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var l;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(l||(e.FileChangeFilter=l={}));function m(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var h;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function g(ne){return!!(ne.capabilities&h.FileReadWrite)}function n(ne){return!!(ne.capabilities&h.FileFolderCopy)}function o(ne){return!!(ne.capabilities&h.FileClone)}function t(ne){return!!(ne.capabilities&h.FileOpenReadWriteClose)}function i(ne){return!!(ne.capabilities&h.FileReadStream)}function r(ne){return g(ne)?!!(ne.capabilities&h.FileAtomicRead):!1}function f(ne){return g(ne)?!!(ne.capabilities&h.FileAtomicWrite):!1}function u(ne){return!!(ne.capabilities&h.FileAtomicDelete)}function v(ne){return!!(ne.capabilities&h.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class D extends Error{static create(De,pe){const G=new D(De.toString(),pe);return k(G,pe),G}constructor(De,pe){super(De),this.code=pe}}e.FileSystemProviderError=D;function w(ne,De){return D.create(ne,De)}function P(ne){return ne||w((0,A.localize)(0,null),y.Unknown)}function k(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function E(ne){if(!ne)return y.Unknown;if(ne instanceof D)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return y.Unknown;switch(De[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function S(ne){if(ne instanceof F)return ne.fileOperationResult;switch(E(ne)){case y.FileNotFound:return re.FILE_NOT_FOUND;case y.FileIsADirectory:return re.FILE_IS_DIRECTORY;case y.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return re.FILE_WRITE_LOCKED;case y.NoPermissions:return re.FILE_PERMISSION_DENIED;case y.FileExists:return re.FILE_MOVE_CONFLICT;case y.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var M;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(De,pe,G){this.resource=De,this.operation=pe,this.target=G}isOperation(De){return this.operation===De}}e.FileOperationEvent=N;var O;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class x{static{this.MIXED_CORRELATION=null}constructor(De,pe){this.ignorePathCasing=pe,this.correlationId=void 0,this.added=new _.Lazy(()=>{const G=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawAdded.map(W=>[W,!0])),G}),this.updated=new _.Lazy(()=>{const G=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawUpdated.map(W=>[W,!0])),G}),this.deleted=new _.Lazy(()=>{const G=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawDeleted.map(W=>[W,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of De){switch(G.type){case O.ADDED:this.rawAdded.push(G.resource);break;case O.UPDATED:this.rawUpdated.push(G.resource);break;case O.DELETED:this.rawDeleted.push(G.resource);break}this.correlationId!==x.MIXED_CORRELATION&&(typeof G.cId=="number"?this.correlationId===void 0?this.correlationId=G.cId:this.correlationId!==G.cId&&(this.correlationId=x.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=x.MIXED_CORRELATION))}}contains(De,...pe){return this.doContains(De,{includeChildren:!1},...pe)}affects(De,...pe){return this.doContains(De,{includeChildren:!0},...pe)}doContains(De,pe,...G){if(!De)return!1;const W=G.length>0;return!!((!W||G.includes(O.ADDED))&&(this.added.value.get(De)||pe.includeChildren&&this.added.value.findSuperstr(De))||(!W||G.includes(O.UPDATED))&&(this.updated.value.get(De)||pe.includeChildren&&this.updated.value.findSuperstr(De))||(!W||G.includes(O.DELETED))&&(this.deleted.value.findSubstr(De)||pe.includeChildren&&this.deleted.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.correlationId===De}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=x;function U(ne,De,pe){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==d.sep&&(De+=d.sep),pe?(0,T.startsWithIgnoreCase)(ne,De):ne.indexOf(De)===0)}class F extends Error{constructor(De,pe,G){super(De),this.fileOperationResult=pe,this.options=G}}e.FileOperationError=F;class H extends F{constructor(De,pe,G,W){super(De,pe,W),this.fileOperationResult=pe,this.size=G}}e.TooLargeFileOperationError=H;class j extends F{constructor(De,pe,G){super(De,re.FILE_NOT_MODIFIED_SINCE,G),this.stat=pe}}e.NotModifiedSinceFileOperationError=j;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var B;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.ETAG_DISABLED="";function V(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function X(ne,De){if(!De.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise(pe=>{const G=De.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(G.dispose(),pe())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,R.isNumber)(De)||(De=0),De<ee.KB?(0,A.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,A.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,A.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,A.localize)(4,null,(De/ee.GB).toFixed(2)):(0,A.localize)(5,null,(De/ee.TB).toFixed(2))}}e.ByteSize=ee;function he(ne){const De=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*ee.MB:De?10*ee.MB:a.isWeb?50*ee.MB:1024*ee.MB}}),define(_e[269],ye([1,0,22,14,226,28]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=L;async function L(I,_,c,C,b,l){let m;try{await A(I,_,c,C,b,l)}catch(h){m=h}finally{m&&b.errorTransformer&&(m=b.errorTransformer(m)),typeof m<"u"&&c.error(m),c.end()}}async function A(I,_,c,C,b,l){p(l);const m=await I.open(_,{create:!1});try{p(l);let h=0,g=0,n=b&&typeof b.length=="number"?b.length:void 0,o=s.VSBuffer.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),t=b&&typeof b.position=="number"?b.position:0,i=0;do g=await I.read(m,t,o.buffer,i,o.byteLength-i),t+=g,i+=g,h+=g,typeof n=="number"&&(n-=g),i===o.byteLength&&(await c.write(C(o)),o=s.VSBuffer.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),i=0);while(g>0&&(typeof n!="number"||n>0)&&p(l)&&a(h,b));if(i>0){let r=i;typeof n=="number"&&(r=Math.min(i,n)),c.write(C(o.slice(0,r)))}}catch(h){throw(0,R.ensureFileSystemProviderError)(h)}finally{await I.close(m)}}function p(I){if(I.isCancellationRequested)throw(0,d.canceled)();return!0}function a(I,_){if(typeof _?.limits?.size=="number"&&I>_.limits.size)throw(0,R.createFileSystemProviderError)((0,T.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(_e[70],ye([1,0,39,3,17,11,2,28]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=p,e.isRecursiveWatchRequest=a,e.reviveFileChanges=C,e.coalesceEvents=b,e.normalizeWatcherPattern=l,e.parseWatcherPatterns=m,e.isFiltered=g,e.requestFilterToString=n;function p(o){return typeof o.correlationId=="number"}function a(o){return o.recursive===!0}class I extends d.Disposable{static{this.MAX_RESTARTS=5}constructor(t,i,r,f){super(),this.onFileChanges=t,this.onLogMessage=i,this.verboseLogging=r,this.options=f,this.watcherDisposables=this._register(new d.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new d.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(i=>this.onFileChanges(i))),t.add(this.watcher.onDidLogMessage(i=>this.onLogMessage(i))),t.add(this.watcher.onDidError(i=>this.onError(i.error,i.request)))}onError(t,i){this.canRestart(t,i)?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${t}`):this.error(t)}canRestart(t,i){return!(!this.options.restartOnError||i||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}trace(t){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I;class _ extends I{constructor(t,i,r){super(t,i,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=_;class c extends I{constructor(t,i,r){super(t,i,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=c;function C(o){return o.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function b(o){const t=new h;for(const i of o)t.processEvent(i);return t.coalesce()}function l(o,t){return typeof t=="string"&&!t.startsWith(s.GLOBSTAR)&&!(0,T.isAbsolute)(t)?{base:o,pattern:t}:t}function m(o,t){const i=[];for(const r of t)i.push((0,s.parse)(l(o,r)));return i}class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return R.isLinux?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const i=this.mapPathToChange.get(this.toKey(t));let r=!1;if(i){const f=i.type,u=t.type;i.resource.fsPath!==t.resource.fsPath&&(t.type===A.FileChangeType.DELETED||t.type===A.FileChangeType.ADDED)?r=!0:f===A.FileChangeType.ADDED&&u===A.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(i)):f===A.FileChangeType.DELETED&&u===A.FileChangeType.ADDED?i.type=A.FileChangeType.UPDATED:f===A.FileChangeType.ADDED&&u===A.FileChangeType.UPDATED||(i.type=u)}else r=!0;r&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],i=[];return Array.from(this.coalesced).filter(r=>r.type!==A.FileChangeType.DELETED?(t.push(r),!1):!0).sort((r,f)=>r.resource.fsPath.length-f.resource.fsPath.length).filter(r=>i.some(f=>(0,A.isParent)(r.resource.fsPath,f,!R.isLinux))?!1:(i.push(r.resource.fsPath),!0)).concat(t)}}function g(o,t){if(typeof t=="number")switch(o.type){case A.FileChangeType.ADDED:return(t&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(t&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(t&A.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const t=[];return o&A.FileChangeFilter.ADDED&&t.push("Added"),o&A.FileChangeFilter.DELETED&&t.push("Deleted"),o&A.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(_e[270],ye([1,0,61,3,70,4,28,2,9]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class a extends d.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new R.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new d.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new p.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new p.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(_=>this.handleDidWatchFail(_)))}handleDidWatchFail(_){this.isCorrelated(_)&&this.suspendWatchRequest(_)}isCorrelated(_){return(0,T.isWatchRequestWithCorrelation)(_)}async watch(_){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new p.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const c of _)this.isCorrelated(c)?this.allCorrelatedWatchRequests.set(c.correlationId,c):this.allNonCorrelatedWatchRequests.add(c);for(const[c]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(c)||(this.suspendedWatchRequests.deleteAndDispose(c),this.suspendedWatchRequestsWithPolling.delete(c));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(_){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(c=>!this.suspendedWatchRequests.has(c.correlationId))]),_?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(_){return typeof _.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(_.correlationId)?"polling":this.suspendedWatchRequests.has(_.correlationId)}async suspendWatchRequest(_){if(this.suspendedWatchRequests.has(_.correlationId))return;const c=new d.DisposableStore;this.suspendedWatchRequests.set(_.correlationId,c),await this.joinWatch.p,!c.isDisposed&&(this.monitorSuspendedWatchRequest(_,c),this.updateWatchers(!0))}resumeWatchRequest(_){this.suspendedWatchRequests.deleteAndDispose(_.correlationId),this.suspendedWatchRequestsWithPolling.delete(_.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(_,c){this.doMonitorWithExistingWatcher(_,c)?(this.trace(`reusing an existing recursive watcher to monitor ${_.path}`),this.suspendedWatchRequestsWithPolling.delete(_.correlationId)):(this.doMonitorWithNodeJS(_,c),this.suspendedWatchRequestsWithPolling.add(_.correlationId))}doMonitorWithExistingWatcher(_,c){const C=this.recursiveWatcher?.subscribe(_.path,(b,l)=>{c.isDisposed||(b?this.monitorSuspendedWatchRequest(_,c):l?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(_))});return C?(c.add(C),!0):!1}doMonitorWithNodeJS(_,c){let C=!1;const b=(l,m)=>{if(c.isDisposed)return;const h=this.isPathNotFound(l),g=this.isPathNotFound(m),n=C;C=h,!h&&(g||n)&&this.onMonitoredPathAdded(_)};this.trace(`starting fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,s.watchFile)(_.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},b)}catch(l){this.warn(`fs.watchFile() failed with error ${l} on path ${_.path} (correlationId: ${_.correlationId})`)}c.add((0,d.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,s.unwatchFile)(_.path,b)}catch(l){this.warn(`fs.unwatchFile() failed with error ${l} on path ${_.path} (correlationId: ${_.correlationId})`)}}))}onMonitoredPathAdded(_){this.trace(`detected ${_.path} exists again, resuming watcher (correlationId: ${_.correlationId})`);const c={resource:A.URI.file(_.path),type:L.FileChangeType.ADDED,cId:_.correlationId};this._onDidChangeFile.fire([c]),this.traceEvent(c,_),this.resumeWatchRequest(_)}isPathNotFound(_){return _.ctimeMs===0&&_.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(_,c){if(this.verboseLogging){const C=` >> normalized ${_.type===L.FileChangeType.ADDED?"[ADDED]":_.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`;this.traceWithCorrelation(C,c)}}traceWithCorrelation(_,c){this.verboseLogging&&this.trace(`${_}${typeof c.correlationId=="number"?` <${c.correlationId}> `:""}`)}requestToString(_){return`${_.path} (excludes: ${_.excludes.length>0?_.excludes:"<none>"}, includes: ${_.includes&&_.includes.length>0?JSON.stringify(_.includes):"<all>"}, filter: ${(0,T.requestFilterToString)(_.filter)}, correlationId: ${typeof _.correlationId=="number"?_.correlationId:"<none>"})`}async setVerboseLogging(_){this.verboseLogging=_}}e.BaseWatcher=a}),define(_e[271],ye([1,0,61,9,21,33,3,82,17,11,23,2,111,34,28,70]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=h;class m extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(n,o,t,i,r,f){super(),this.request=n,this.recursiveWatcher=o,this.onDidFilesChange=t,this.onDidWatchFail=i,this.onLogMessage=r,this.verboseLogging=f,this.throttledFileChangesEmitter=this._register(new d.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u))),this.fileChangesAggregator=this._register(new d.RunOnceWorker(u=>this.handleFileChanges(u),m.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,l.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,l.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,l.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const n=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const o=await C.Promises.stat(n);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.error(n):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${n})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(n){let o=n.path;try{o=await C.Promises.realpath(n.path),n.path===o&&(o=await(0,c.realcase)(n.path,this.cts.token)??n.path),n.path!==o&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async doWatch(n,o){const t=new L.DisposableStore;return this.doWatchWithExistingWatcher(n,o,t)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(n,o,t)),t}doWatchWithExistingWatcher(n,o,t){if(o)return!1;const i=_.URI.file(this.request.path),r=this.recursiveWatcher?.subscribe(this.request.path,async(f,u)=>{if(!t.isDisposed)if(f){const v=await this.doWatch(n,o);t.isDisposed?v.dispose():t.add(v)}else u&&(typeof u.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:i,type:u.type,cId:this.request.correlationId},!0)});return r?(t.add(r),!0):!1}async doWatchWithNodeJS(n,o,t){if(a.isMacintosh&&(0,R.isEqualOrParent)(n,"/Volumes/",!0)){this.error(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new T.CancellationTokenSource(this.cts.token);t.add((0,L.toDisposable)(()=>i.dispose(!0)));const r=new L.DisposableStore;t.add(r);try{const f=_.URI.file(this.request.path),u=(0,p.basename)(n),v=(0,s.watch)(n);r.add((0,L.toDisposable)(()=>{v.removeAllListeners(),v.close()})),this.trace(`Started watching: '${n}'`);const y=new Set;if(o)try{for(const w of await C.Promises.readdir(n))y.add(w)}catch(w){this.error(w)}if(i.token.isCancellationRequested)return;const D=new Map;r.add((0,L.toDisposable)(()=>{for(const[,w]of D)w.dispose();D.clear()})),v.on("error",(w,P)=>{i.token.isCancellationRequested||(this.error(`Failed to watch ${n} for changes using fs.watch() (${w}, ${P})`),this.notifyWatchFailed())}),v.on("change",(w,P)=>{if(i.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${w}"] ${P}`);let k="";if(P&&(k=P.toString(),a.isMacintosh&&(k=(0,A.normalizeNFC)(k))),!(!k||w!=="change"&&w!=="rename"))if(o)if(w==="rename"){D.get(k)?.dispose();const E=setTimeout(async()=>{if(D.delete(k),k===u&&!await C.Promises.exists(n)){this.onWatchedPathDeleted(f);return}if(i.token.isCancellationRequested)return;const S=await this.existsChildStrictCase((0,p.join)(n,k));if(i.token.isCancellationRequested)return;let M;S?y.has(k)?M=b.FileChangeType.UPDATED:(M=b.FileChangeType.ADDED,y.add(k)):(y.delete(k),M=b.FileChangeType.DELETED),this.onFileChange({resource:(0,I.joinPath)(f,k),type:M,cId:this.request.correlationId})},m.FILE_DELETE_HANDLER_DELAY);D.set(k,(0,L.toDisposable)(()=>clearTimeout(E)))}else{let E;y.has(k)?E=b.FileChangeType.UPDATED:(E=b.FileChangeType.ADDED,y.add(k)),this.onFileChange({resource:(0,I.joinPath)(f,k),type:E,cId:this.request.correlationId})}else if(w==="rename"||k!==u){const E=setTimeout(async()=>{const S=await C.Promises.exists(n);i.token.isCancellationRequested||(S?(this.onFileChange({resource:f,type:b.FileChangeType.UPDATED,cId:this.request.correlationId},!0),r.add(await this.doWatch(n,!1))):this.onWatchedPathDeleted(f))},m.FILE_DELETE_HANDLER_DELAY);r.clear(),r.add((0,L.toDisposable)(()=>clearTimeout(E)))}else this.onFileChange({resource:f,type:b.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(f){i.token.isCancellationRequested||this.error(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(n){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:n,type:b.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(n,o=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.excludes.some(t=>t(n.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.includes&&this.includes.length>0&&!this.includes.some(t=>t(n.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${n.resource.fsPath}`):this.fileChangesAggregator.work(n))}handleFileChanges(n){const o=(0,l.coalesceEvents)(n),t=[];for(const r of o){if((0,l.isFiltered)(r,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${r.resource.fsPath}`);continue}t.push(r)}if(t.length===0)return;if(this.verboseLogging)for(const r of t)this.traceWithCorrelation(` >> normalized ${r.type===b.FileChangeType.ADDED?"[ADDED]":r.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.throttledFileChangesEmitter.work(t)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(n){if(a.isLinux)return C.Promises.exists(n);try{const o=(0,p.basename)(n);return(await C.Promises.readdir((0,p.dirname)(n))).some(i=>i===o)}catch(o){return this.trace(o),!1}}setVerboseLogging(n){this.verboseLogging=n}error(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}warn(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}trace(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}traceWithCorrelation(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${n}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m;async function h(g,n,o,t,i=512){const r=await C.Promises.open(g,"r"),f=Buffer.allocUnsafe(i),u=new T.CancellationTokenSource(t);let v,y=!1;const D={path:g,excludes:[],recursive:!1},w=new m(D,void 0,P=>{(async()=>{for(const{type:k}of P)if(k===b.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:E}=await C.Promises.read(r,f,0,i,null);if(!E||u.token.isCancellationRequested)break;n(f.slice(0,E))}}catch(E){v=new Error(E),u.dispose(!0)}finally{y=!1}}})()});return await w.ready,o(),new Promise((P,k)=>{u.token.onCancellationRequested(async()=>{w.dispose();try{await C.Promises.close(r)}catch(E){v=new Error(E)}v?k(v):P()})})}}),define(_e[272],ye([1,0,4,39,270,11,271,33]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class p extends T.BaseWatcher{constructor(I){super(),this.recursiveWatcher=I,this.onDidError=s.Event.None,this.watchers=new Set}async doWatch(I){I=this.removeDuplicateRequests(I);const _=[],c=new Set(Array.from(this.watchers));for(const C of I){const b=this.findWatcher(C);b&&(0,d.patternsEquals)(b.request.excludes,C.excludes)&&(0,d.patternsEquals)(b.request.includes,C.includes)?c.delete(b):_.push(C)}_.length&&this.trace(`Request to start watching: ${_.map(C=>this.requestToString(C)).join(",")}`),c.size&&this.trace(`Request to stop watching: ${Array.from(c).map(C=>this.requestToString(C.request)).join(",")}`);for(const C of c)this.stopWatching(C);for(const C of _)this.startWatching(C)}findWatcher(I){for(const _ of this.watchers)if(typeof I.correlationId=="number"||typeof _.request.correlationId=="number"){if(_.request.correlationId===I.correlationId)return _}else if((0,A.isEqual)(_.request.path,I.path,!R.isLinux))return _}startWatching(I){const _=new L.NodeJSFileWatcherLibrary(I,this.recursiveWatcher,C=>this._onDidChangeFile.fire(C),()=>this._onDidWatchFail.fire(I),C=>this._onDidLogMessage.fire(C),this.verboseLogging),c={request:I,instance:_};this.watchers.add(c)}async stop(){await super.stop();for(const I of this.watchers)this.stopWatching(I)}stopWatching(I){this.trace("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}removeDuplicateRequests(I){const _=new Map;for(const c of I){const C=R.isLinux?c.path:c.path.toLowerCase();let b=_.get(c.correlationId);b||(b=new Map,_.set(c.correlationId,b)),b.has(C)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(c)}`),b.set(C,c)}return Array.from(_.values()).map(c=>Array.from(c.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const _ of this.watchers)_.instance.setVerboseLogging(I)}trace(I,_){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I,_)})}warn(I){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(I)})}toMessage(I,_){return _?`[File Watcher (node.js)] ${I} (${this.requestToString(_.request)})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=p}),define(_e[273],ye([1,0,70,272]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends s.AbstractNonRecursiveWatcherClient{constructor(L,A,p){super(L,A,p),this.init()}createWatcher(L){return L.add(new d.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=T}),define(_e[274],ye([1,0,15,87,209,70]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends R.AbstractUniversalWatcherClient{constructor(p,a,I){super(p,a,I),this.init()}createWatcher(p){const a=p.add(new T.Client(s.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(a.onDidProcessExit(({code:I,signal:_})=>this.onError(`terminated by itself with code ${I}, signal: ${_} (ETERM)`))),d.ProxyChannel.toService((0,d.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(_e[115],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...T){this._entries=new Map;for(const[R,L]of T)this.set(R,L)}set(T,R){const L=this._entries.get(T);return this._entries.set(T,R),L}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=s}),define(_e[275],ye([1,0,9,14,3,113,264,5,115,81]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class _ extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class c{constructor(m=new p.ServiceCollection,h=!1,g,n=I){this._services=m,this._strict=h,this._parent=g,this._enableTracing=n,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=n?g?._globalGraph??new L.Graph(o=>o):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,T.dispose)(this._children),this._children.clear();for(const m of this._servicesToMaybeDispose)(0,T.isDisposable)(m)&&m.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(m,h){this._throwIfDisposed();const g=this,n=new class extends c{dispose(){g._children.delete(n),super.dispose()}}(m,this._strict,this,this._enableTracing);return this._children.add(n),h?.add(n),n}invokeFunction(m,...h){this._throwIfDisposed();const g=b.traceInvocation(this._enableTracing,m);let n=!1;try{return m({get:t=>{if(n)throw(0,d.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(t,g);if(!i)throw new Error(`[invokeFunction] unknown service '${t}'`);return i}},...h)}finally{n=!0,g.stop()}}createInstance(m,...h){this._throwIfDisposed();let g,n;return m instanceof R.SyncDescriptor?(g=b.traceCreation(this._enableTracing,m.ctor),n=this._createInstance(m.ctor,m.staticArguments.concat(h),g)):(g=b.traceCreation(this._enableTracing,m),n=this._createInstance(m,h,g)),g.stop(),n}_createInstance(m,h=[],g){const n=A._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),o=[];for(const i of n){const r=this._getOrCreateServiceInstance(i.id,g);r||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),o.push(r)}const t=n.length>0?n[0].index:h.length;if(h.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${h.length} static arguments`);const i=t-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,t)}return Reflect.construct(m,h.concat(o))}_setCreatedServiceInstance(m,h){if(this._services.get(m)instanceof R.SyncDescriptor)this._services.set(m,h);else if(this._parent)this._parent._setCreatedServiceInstance(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const h=this._services.get(m);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):h}_getOrCreateServiceInstance(m,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const g=this._getServiceInstanceOrDescriptor(m);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,g,h.branch(m,!0)):(h.branch(m,!1),g)}_safeCreateAndCacheServiceInstance(m,h,g){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,h,g)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,h,g){const n=new L.Graph(i=>i.id.toString());let o=0;const t=[{id:m,desc:h,_trace:g}];for(;t.length;){const i=t.pop();if(n.lookupOrInsertNode(i),o++>1e3)throw new _(n);for(const r of A._util.getServiceDependencies(i.desc.ctor)){const f=this._getServiceInstanceOrDescriptor(r.id);if(f||this._throwIfStrict(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),f instanceof R.SyncDescriptor){const u={id:r.id,desc:f,_trace:i._trace.branch(r.id,!0)};n.insertEdge(i,u),t.push(u)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new _(n);break}for(const{data:r}of i){if(this._getServiceInstanceOrDescriptor(r.id)instanceof R.SyncDescriptor){const u=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setCreatedServiceInstance(r.id,u)}n.removeNode(r)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,h,g=[],n,o){if(this._services.get(m)instanceof R.SyncDescriptor)return this._createServiceInstance(m,h,g,n,o,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,h,g,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(m,h,g=[],n,o,t){if(n){const i=new c(void 0,this._strict,this,this._enableTracing);i._globalGraphImplicitDependency=String(m);const r=new Map,f=new s.GlobalIdleValue(()=>{const u=i._createInstance(h,g,o);for(const[v,y]of r){const D=u[v];if(typeof D=="function")for(const w of y)w.disposable=D.apply(u,w.listener)}return r.clear(),t.add(u),u});return new Proxy(Object.create(null),{get(u,v){if(!f.isInitialized&&typeof v=="string"&&(v.startsWith("onDid")||v.startsWith("onWill"))){let w=r.get(v);return w||(w=new a.LinkedList,r.set(v,w)),(k,E,S)=>{if(f.isInitialized)return f.value[v](k,E,S);{const M={listener:[k,E,S],disposable:void 0},N=w.push(M);return(0,T.toDisposable)(()=>{N(),M.disposable?.dispose()})}}}if(v in u)return u[v];const y=f.value;let D=y[v];return typeof D!="function"||(D=D.bind(y),u[v]=D),D},set(u,v,y){return f.value[v]=y,!0},getPrototypeOf(u){return h.prototype}})}else{const i=this._createInstance(h,g,o);return t.add(i),i}}_throwIfStrict(m,h){if(h&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=c;var C;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(C||(C={}));class b{static{this.all=new Set}static{this._None=new class extends b{constructor(){super(C.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,h){return m?new b(C.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b._None}static traceCreation(m,h){return m?new b(C.Creation,h.name):b._None}static{this._totals=0}constructor(m,h){this.type=m,this.name=h,this._start=Date.now(),this._dep=[]}branch(m,h){const g=new b(C.Branch,m.toString());return this._dep.push([m,h,g]),g}stop(){const m=Date.now()-this._start;b._totals+=m;let h=!1;function g(o,t){const i=[],r=new Array(o+1).join("	");for(const[f,u,v]of t._dep)if(u&&v){h=!0,i.push(`${r}CREATES -> ${f}`);const y=g(o+1,v);y&&i.push(y)}else i.push(`${r}uses -> ${f}`);return i.join(`
`)}const n=[`${this.type===C.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(m>2||h)&&b.all.add(n.join(`
`))}}e.Trace=b}),define(_e[12],ye([1,0,228,51,4,60,3,29,11,23,18,2,36,5]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=l,e.log=h,e.getLogLevel=D,e.LogLevelToString=w,e.LogLevelToLocalizedString=P,e.parseLogLevel=k,s=ze(s),e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function b(){return new Date().toISOString()}function l(E){return(0,I.isNumber)(E)}var m;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function h(E,S,M){switch(S){case m.Trace:E.trace(M);break;case m.Debug:E.debug(M);break;case m.Info:E.info(M);break;case m.Warning:E.warn(M);break;case m.Error:E.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function g(E,S=!1){let M="";for(let N=0;N<E.length;N++){let O=E[N];if(O instanceof Error&&(O=(0,d.toErrorMessage)(O,S)),typeof O=="object")try{O=JSON.stringify(O)}catch{}M+=(N>0?" ":"")+O}return M}class n extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==m.Off&&this.level<=S}}e.AbstractLogger=n;class o extends n{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...M){this.checkLogLevel(m.Trace)&&this.log(m.Trace,g([S,...M],!0))}debug(S,...M){this.checkLogLevel(m.Debug)&&this.log(m.Debug,g([S,...M]))}info(S,...M){this.checkLogLevel(m.Info)&&this.log(m.Info,g([S,...M]))}warn(S,...M){this.checkLogLevel(m.Warning)&&this.log(m.Warning,g([S,...M]))}error(S,...M){if(this.checkLogLevel(m.Error))if(S instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=S.stack,this.log(m.Error,g(N))}else this.log(m.Error,g([S,...M]))}flush(){}}e.AbstractMessageLogger=o;class t extends n{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!p.isWindows}trace(S,...M){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...M):console.log(`[main ${b()}]`,S,...M))}debug(S,...M){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...M):console.log(`[main ${b()}]`,S,...M))}info(S,...M){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...M):console.log(`[main ${b()}]`,S,...M))}warn(S,...M){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,S,...M):console.warn(`[main ${b()}]`,S,...M))}error(S,...M){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,S,...M):console.error(`[main ${b()}]`,S,...M))}flush(){}}e.ConsoleMainLogger=t;class i extends n{constructor(S=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(S)}trace(S,...M){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...M):console.log(S,...M))}debug(S,...M){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...M):console.log(S,...M))}info(S,...M){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...M):console.log(S,...M))}warn(S,...M){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...M):console.log(S,...M))}error(S,...M){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...M):console.error(S,...M))}flush(){}}e.ConsoleLogger=i;class r extends n{constructor(S,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(M)}trace(S,...M){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(S),...M])}debug(S,...M){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(S),...M])}info(S,...M){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(S),...M])}warn(S,...M){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(S),...M])}error(S,...M){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(S),...M])}extractMessage(S){return typeof S=="string"?S:(0,d.toErrorMessage)(S,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=r;class f extends n{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const M of this.loggers)M.setLevel(S);super.setLevel(S)}trace(S,...M){for(const N of this.loggers)N.trace(S,...M)}debug(S,...M){for(const N of this.loggers)N.debug(S,...M)}info(S,...M){for(const N of this.loggers)N.info(S,...M)}warn(S,...M){for(const N of this.loggers)N.warn(S,...M)}error(S,...M){for(const N of this.loggers)N.error(S,...M)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose();super.dispose()}}e.MultiplexLogger=f;class u extends L.Disposable{constructor(S,M,N){if(super(),this.logLevel=S,this.logsHome=M,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const O of N)this._loggers.set(O.resource,{logger:void 0,info:O})}getLoggerEntry(S){return(0,I.isString)(S)?[...this._loggers.values()].find(M=>M.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,M){const N=this.toResource(S),O=(0,I.isString)(S)?S:M?.id??(0,R.hash)(N.toString()).toString(16);let x=this._loggers.get(N)?.logger;const U=M?.logLevel==="always"?m.Trace:M?.logLevel;x||(x=this.doCreateLogger(N,U??this.getLogLevel(N)??this.logLevel,{...M,id:O}));const F={logger:x,info:{resource:N,id:O,logLevel:U,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(F.info),this._loggers.set(N,F),x}toResource(S){return(0,I.isString)(S)?(0,a.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,M){if(_.URI.isUri(S)){const N=S,O=M,x=this._loggers.get(N);x&&O!==x.info.logLevel&&(x.info.logLevel=O===this.logLevel?void 0:O,x.logger?.setLevel(O),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([N,O]))}else{this.logLevel=S;for(const[N,O]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,M){const N=this.getLoggerEntry(S);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,M]))}getLogLevel(S){let M;return S&&(M=this._loggers.get(S)?.info.logLevel),M??this.logLevel}registerLogger(S){const M=this._loggers.get(S.resource);M?M.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const M=this._loggers.get(S);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=u;class v{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(S){}getLevel(){return m.Info}trace(S,...M){}debug(S,...M){}info(S,...M){}warn(S,...M){}error(S,...M){}critical(S,...M){}dispose(){}flush(){}}e.NullLogger=v;class y extends v{}e.NullLogService=y;function D(E){if(E.verbose)return m.Trace;if(typeof E.logLevel=="string"){const S=k(E.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}function w(E){switch(E){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function P(E){switch(E){case m.Trace:return{original:"Trace",value:s.localize(0,null)};case m.Debug:return{original:"Debug",value:s.localize(1,null)};case m.Info:return{original:"Info",value:s.localize(2,null)};case m.Warning:return{original:"Warning",value:s.localize(3,null)};case m.Error:return{original:"Error",value:s.localize(4,null)};case m.Off:return{original:"Off",value:s.localize(5,null)}}}function k(E){switch(E){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new c.RawContextKey("logLevel",w(m.Info))}),define(_e[276],ye([1,0,19,9,14,4,33,3,17,70,12]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class _ extends A.Disposable{constructor(C,b){super(),this.logService=C,this.options=b,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new d.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}watch(C,b){return b.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,b):this.watchNonRecursive(C,b)}watchUniversal(C,b){const l={path:this.toWatchPath(C),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},m=(0,s.insert)(this.universalWatchRequests,l);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,T.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(b=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const b of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const b of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(b)&&C.includes(b.path)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(C,b){const l={path:this.toWatchPath(C),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},m=(0,s.insert)(this.nonRecursiveWatchRequests,l);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,T.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logWatcherMessage(C)}logWatcherMessage(C){this.logService[C.type](C.message)}toFilePath(C){return(0,p.normalize)(C.fsPath)}toWatchPath(C){const b=this.toFilePath(C);return(0,L.removeTrailingPathSeparator)(b)}}e.AbstractDiskFileSystemProvider=_}),define(_e[277],ye([1,0,9,29,22,4,33,3,17,11,23,104,34,227,28,269,276,274,273]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends m.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new d.ResourceMap(r=>I.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,a.isLinux&&(this._capabilities|=b.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:r}=await c.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:b.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await c.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async f=>{try{let u;f.isSymbolicLink()?u=(await this.stat((0,I.joinPath)(t,f.name))).type:u=this.toType(f),r.push([f.name,u])}catch(u){this.logService.trace(u)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let r;return i?.dangling?r=b.FileType.Unknown:t.isFile()?r=b.FileType.File:t.isDirectory()?r=b.FileType.Directory:r=b.FileType.Unknown,i&&(r|=b.FileType.SymbolicLink),r}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const f=new s.Barrier;return this.resourceLocks.set(t,f),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,A.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===f&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),f.open()})}async readFile(t,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const f=this.toFilePath(t);return await c.Promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}finally{r?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,r){const f=(0,_.newWriteableStream)(u=>T.VSBuffer.concat(u.map(v=>T.VSBuffer.wrap(v))).buffer);return(0,l.readFileIntoStream)(this,t,f,u=>u.buffer,{...i,bufferSize:256*1024},r),f}async writeFile(t,i,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,I.joinPath)((0,I.dirname)(t),`${(0,I.basename)(t)}${r.atomic.postfix}`),i,r):this.doWriteFile(t,i,r)}async canWriteFileAtomic(t){try{const i=this.toFilePath(t),{symbolicLink:r}=await c.SymlinkSupport.stat(i);if(r)return!1}catch{}return!0}async doWriteFileAtomic(t,i,r,f){const u=new A.DisposableStore;try{u.add(await this.createResourceLock(t)),u.add(await this.createResourceLock(i)),await this.doWriteFile(i,r,f,!0);try{await this.rename(i,t,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{u.dispose()}}async doWriteFile(t,i,r,f){let u;try{const v=this.toFilePath(t);if(!r.create||!r.overwrite){if(await c.Promises.exists(v)){if(!r.overwrite)throw(0,b.createFileSystemProviderError)((0,C.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,b.createFileSystemProviderError)((0,C.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:r.unlock},f),await this.write(u,0,i,0,i.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(t,v)}finally{typeof u=="number"&&await this.close(u)}}static{this.canFlush=!0}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i,r){const f=this.toFilePath(t);let u;(0,b.isFileOpenForWriteOptions)(i)&&!r&&(u=await this.createResourceLock(t));let v;try{if((0,b.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:D}=await c.SymlinkSupport.stat(f);D.mode&128||await c.Promises.chmod(f,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}let y;if((0,b.isFileOpenForWriteOptions)(i)){if(a.isWindows)try{await c.Promises.truncate(f,0),y="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}y||(y="w")}else y="r";v=await c.Promises.open(f,y)}catch(y){throw u?.dispose(),(0,b.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(v,0),(0,b.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(v,t),u){const y=this.mapHandleToLock.get(v);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${f})`),this.mapHandleToLock.set(v,u),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${f})`),y.dispose())}return v}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await c.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await c.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,r,f,u){const v=this.normalizePos(t,i);let y=null;try{y=(await c.Promises.read(t,r,f,u,v)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(t,v,y)}return y}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,r){const f=this.mapHandleToPos.get(t);typeof f=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,f+r):this.mapHandleToPos.delete(t)))}async write(t,i,r,f,u){return(0,s.retry)(()=>this.doWrite(t,i,r,f,u),100,3)}async doWrite(t,i,r,f,u){const v=this.normalizePos(t,i);let y=null;try{y=(await c.Promises.write(t,r,f,u,v)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),D)}finally{this.updatePos(t,v,y)}return y}async mkdir(t){try{await c.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const r=this.toFilePath(t);if(i.recursive){let f;i?.atomic!==!1&&i.atomic.postfix&&(f=(0,p.join)((0,p.dirname)(r),`${(0,p.basename)(r)}${i.atomic.postfix}`)),await c.Promises.rm(r,c.RimRafMode.MOVE,f)}else try{await c.Promises.unlink(r)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let u=!1;try{const{stat:v,symbolicLink:y}=await c.SymlinkSupport.stat(r);u=v.isDirectory()&&!y}catch{}if(u)await c.Promises.rmdir(r);else throw f}else throw f}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,i,r){const f=this.toFilePath(t),u=this.toFilePath(i);if(f!==u)try{await this.validateMoveCopy(t,i,"move",r.overwrite),await c.Promises.rename(f,u)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,C.localize)(2,null,(0,p.basename)(f),(0,p.basename)((0,p.dirname)(u)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(t,i,r){const f=this.toFilePath(t),u=this.toFilePath(i);if(f!==u)try{await this.validateMoveCopy(t,i,"copy",r.overwrite),await c.Promises.copy(f,u,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,C.localize)(3,null,(0,p.basename)(f),(0,p.basename)((0,p.dirname)(u)),v.toString()))),this.toFileSystemProviderError(v)}}async validateMoveCopy(t,i,r,f){const u=this.toFilePath(t),v=this.toFilePath(i);let y=!1;if(!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,L.isEqual)(u,v,!0)),y){if(r==="copy")throw(0,b.createFileSystemProviderError)((0,C.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const w=await this.statIgnoreError(t);if(!w)throw(0,b.createFileSystemProviderError)((0,C.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(i);if(P){if(!f)throw(0,b.createFileSystemProviderError)((0,C.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);w.type&b.FileType.File&&P.type&b.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,r){const f=this.toFilePath(t),u=this.toFilePath(i),v=!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.isEqual)(f,u,!v))return;const y=new A.DisposableStore;try{y.add(await this.createResourceLock(t)),y.add(await this.createResourceLock(i)),r&&await c.Promises.mkdir((0,p.dirname)(u),{recursive:!0}),await c.Promises.copyFile(f,u)}catch(D){if(D.code==="ENOENT"&&!r)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(D)}finally{y.dispose()}}createUniversalWatcher(t,i,r){return new h.UniversalWatcherClient(f=>t(f),f=>i(f),r)}createNonRecursiveWatcher(t,i,r){return new g.NodeJSWatcherClient(f=>t(f),f=>i(f),r)}toFileSystemProviderError(t){if(t instanceof b.FileSystemProviderError)return t;let i=t,r;switch(t.code){case"ENOENT":r=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=b.FileSystemProviderErrorCode.Unknown;break;default:r=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(t,i){let r=this.toFileSystemProviderError(i);if(t&&r.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await c.SymlinkSupport.stat(this.toFilePath(t));f.mode&128||(r=(0,b.createFileSystemProviderError)(i,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return r}}e.DiskFileSystemProvider=n}),define(_e[278],ye([1,0,3,12]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends s.Disposable{constructor(L,A=[]){super(),this.logger=new d.MultiplexLogger([L,...A]),this._register(L.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...A){this.logger.trace(L,...A)}debug(L,...A){this.logger.debug(L,...A)}info(L,...A){this.logger.info(L,...A)}warn(L,...A){this.logger.warn(L,...A)}error(L,...A){this.logger.error(L,...A)}flush(){this.logger.flush()}}e.LogService=T}),define(_e[279],ye([1,0,28,12]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var T;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(T||(T={}));async function R(a,I,_,c,C){try{const b=await new Promise((m,h)=>{le(["@vscode/spdlog"],m,h)}).then(ze);b.setFlushOn(T.Trace);const l=await b.createAsyncRotatingLogger(a,I,_,c);return C?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(b){console.error(b)}return null}function L(a,I,_){switch(I){case d.LogLevel.Trace:a.trace(_);break;case d.LogLevel.Debug:a.debug(_);break;case d.LogLevel.Info:a.info(_);break;case d.LogLevel.Warning:a.warn(_);break;case d.LogLevel.Error:a.error(_);break;case d.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function A(a,I){switch(I){case d.LogLevel.Trace:a.setLevel(T.Trace);break;case d.LogLevel.Debug:a.setLevel(T.Debug);break;case d.LogLevel.Info:a.setLevel(T.Info);break;case d.LogLevel.Warning:a.setLevel(T.Warning);break;case d.LogLevel.Error:a.setLevel(T.Error);break;case d.LogLevel.Off:a.setLevel(T.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends d.AbstractMessageLogger{constructor(I,_,c,C,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(I,_,c,C),this._register(this.onDidChangeLogLevel(l=>{this._logger&&A(this._logger,l)}))}async _createSpdLogLogger(I,_,c,C){const b=c?6:1,l=30/b*s.ByteSize.MB,m=await R(I,_,l,b,C);if(m){this._logger=m,A(this._logger,this.getLevel());for(const{level:h,message:g}of this.buffer)L(this._logger,h,g);this.buffer=[]}}log(I,_){this._logger?L(this._logger,I,_):this.getLevel()<=I&&this.buffer.push({level:I,message:_})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[146],ye([1,0,44,229,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,s=xt(s);var R;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(p){function a(b,l){return l-b}p.compare=a;const I=Object.create(null);I[p.Error]=(0,d.localize)(0,null),I[p.Warning]=(0,d.localize)(1,null),I[p.Info]=(0,d.localize)(2,null);function _(b){return I[b]||""}p.toString=_;function c(b){switch(b){case s.default.Error:return p.Error;case s.default.Warning:return p.Warning;case s.default.Info:return p.Info;case s.default.Ignore:return p.Hint}}p.fromSeverity=c;function C(b){switch(b){case p.Error:return s.default.Error;case p.Warning:return s.default.Warning;case p.Info:return s.default.Info;case p.Hint:return s.default.Ignore}}p.toSeverity=C}(L||(e.MarkerSeverity=L={}));var A;(function(p){const a="";function I(c){return _(c,!0)}p.makeKey=I;function _(c,C){const b=[a];return c.source?b.push(c.source.replace("\xA6","\\\xA6")):b.push(a),c.code?typeof c.code=="string"?b.push(c.code.replace("\xA6","\\\xA6")):b.push(c.code.value.replace("\xA6","\\\xA6")):b.push(a),c.severity!==void 0&&c.severity!==null?b.push(L.toString(c.severity)):b.push(a),c.message&&C?b.push(c.message.replace("\xA6","\\\xA6")):b.push(a),c.startLineNumber!==void 0&&c.startLineNumber!==null?b.push(c.startLineNumber.toString()):b.push(a),c.startColumn!==void 0&&c.startColumn!==null?b.push(c.startColumn.toString()):b.push(a),c.endLineNumber!==void 0&&c.endLineNumber!==null?b.push(c.endLineNumber.toString()):b.push(a),c.endColumn!==void 0&&c.endColumn!==null?b.push(c.endColumn.toString()):b.push(a),b.push(a),b.join("\xA6")}p.makeKeyOptionalMessage=_})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,T.createDecorator)("markerService")});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[280],ye([1,0,4,44,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=A,d=xt(d),e.Severity=d.default,e.INotificationService=(0,T.createDecorator)("notificationService");var R;(function(_){_[_.DEFAULT=0]="DEFAULT",_[_.SILENT=1]="SILENT",_[_.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(_){_[_.WORKSPACE=0]="WORKSPACE",_[_.PROFILE=1]="PROFILE",_[_.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function A(_){if(_){const c=_;return typeof c.id=="string"&&typeof c.label=="string"}return!1}var p;(function(_){_[_.OFF=0]="OFF",_[_.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class a{constructor(){this.progress=new I,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(c){}updateMessage(c){}updateActions(c){}close(){}}e.NoOpNotification=a;class I{infinite(){}done(){}total(c){}worked(c){}}e.NoOpProgress=I}),define(_e[281],ye([1,0,56]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.context<"u"){const R=T.context.configuration();if(R)d=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:R,searchUrl:L,itemUrl:A,controlUrl:p}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:s.env.VSCODE_GALLERY_SERVICE_URL||R,searchUrl:s.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:s.env.VSCODE_GALLERY_ITEM_URL||A,controlUrl:s.env.VSCODE_GALLERY_CONTROL_URL||p}});try{const a=(..._)=>_.reduce((c,C)=>(Object.keys(C).forEach(b=>{Array.isArray(c[b])&&Array.isArray(C[b])?c[b]=C[b]:typeof c[b]=="object"&&typeof C[b]=="object"?c[b]=a(c[b],C[b]):c[b]=C[b]}),c),{}),I=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=a(d,I)}catch{}if(s.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const a=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:a.version,release:a.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(_e[116],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,s.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(le,e){return function(s,d){e(s,d,le)}};define(_e[90],ye([1,0,9,21,3,5]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var L;(function(_){_[_.Explorer=1]="Explorer",_[_.Scm=3]="Scm",_[_.Extensions=5]="Extensions",_[_.Window=10]="Window",_[_.Notification=15]="Notification",_[_.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(c){this.callback=c}report(c){this._value=c,this.callback(this._value)}}e.Progress=A;class p{get value(){return this._value}constructor(c){this.callback=c}report(c){this._asyncQueue?this._asyncQueue.push(c):this._asyncQueue=[c],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const c=this._asyncQueue.shift();this._value=c,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const c=this._drainListener;this._drainListener=void 0,c?.()}}drain(){return this._processingAsyncQueue?new Promise(c=>{const C=this._drainListener;this._drainListener=()=>{C?.(),c()}}):Promise.resolve()}}e.AsyncProgress=p;let a=class extends T.Disposable{constructor(c,C){super(),this.deferred=new s.DeferredPromise,C.withProgress(c,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(c){this.reporter?this.reporter.report(c):this.lastStep=c}};e.UnmanagedProgress=a,e.UnmanagedProgress=a=Xe([He(1,e.IProgressService)],a);class I extends T.Disposable{constructor(c){super(),this.progressIndicator=c,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(c){this.stop();const C=++this.currentOperationId,b=new d.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{C===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},c),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:C,token:b.token,stop:()=>this.doStop(C),isCurrent:()=>this.currentOperationId===C}}stop(){this.doStop(this.currentOperationId)}doStop(c){this.currentOperationId===c&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(_e[37],ye([1,0,66,18]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,s=ze(s),d=ze(d);class T{constructor(){this.data=new Map}add(L,A){s.ok(d.isString(L)),s.ok(d.isObject(A)),s.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,A)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new T}),define(_e[117],ye([1,0,4,37]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,d=ze(d),e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,a){this.schemasById[T(p)]=a,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;d.Registry.add(e.Extensions.JSONContribution,L)}),define(_e[71],ye([1,0,19,4,18,218,45,117,37]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=l,e.keyFromOverrideIdentifiers=m,e.getDefaultValue=h,e.validateProperty=n,e.getScopes=o,T=ze(T),R=ze(R);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=p.Registry.as(A.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const f=new Set;this.doRegisterConfigurations(i,r,f),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}deregisterConfigurations(i){const r=new Set;this.doDeregisterConfigurations(i,r),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:i,remove:r}){const f=new Set;this.doDeregisterConfigurations(r,f),this.doRegisterConfigurations(i,!1,f),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}registerDefaultConfigurations(i){const r=new Set;this.doRegisterDefaultConfigurations(i,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,r){const f=[];for(const{overrides:u,source:v}of i)for(const y in u)if(r.add(y),e.OVERRIDE_PROPERTY_REGEX.test(y)){const D=this.configurationDefaultsOverrides.get(y),w=D?.valuesSources??new Map,P=D?.value||{};for(const S of Object.keys(u[y])){const M=u[y][S];if(T.isObject(M)&&(T.isUndefined(P[S])||T.isObject(P[S]))){if(P[S]={...P[S]??{},...M},v){let O=w.get(S);if(O||(O=new Map,w.set(S,O)),!(O instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const x in M)O.set(x,v)}}else P[S]=M,v&&w.set(S,v)}this.configurationDefaultsOverrides.set(y,{source:v,value:P,valuesSources:w});const k=(0,L.getLanguageTagSettingPlainKey)(y),E={type:"object",default:P,description:R.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:T.isString(v)?void 0:v,defaultValueSource:v};f.push(...l(y)),this.configurationProperties[y]=E,this.defaultLanguageConfigurationOverridesNode.properties[y]=E}else{const D=this.configurationProperties[y],w=this.configurationDefaultsOverrides.get(y);let P=w?.value??D?.defaultDefaultValue,k=u[y],E=v;if(T.isObject(k)&&(D!==void 0&&D.type==="object"||D===void 0&&(T.isUndefined(P)||T.isObject(P)))){if(T.isObject(P)||(P={}),k={...P,...k},E=w?.source??new Map,!(E instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const M in u[y])v?E.set(M,v):E.delete(M)}this.configurationDefaultsOverrides.set(y,{value:k,source:E}),D&&(this.updatePropertyDefaultValue(y,D),this.updateSchema(y,D))}this.doRegisterOverrideIdentifiers(f)}deregisterDefaultConfigurations(i){const r=new Set;this.doDeregisterDefaultConfigurations(i,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,r){for(const{overrides:f,source:u}of i)for(const v in f){const y=T.isString(u)?u:u?.id,D=this.configurationDefaultsOverrides.get(v);if(D){if(e.OVERRIDE_PROPERTY_REGEX.test(v)){for(const P of Object.keys(f[v])){const k=f[v][P];if(T.isObject(k)){const E=D.valuesSources?.get(P);for(const S of Object.keys(k)){const M=E?.get(S);(T.isString(M)?M:M?.id)===y&&(E?.delete(S),delete D.value[P][S])}Object.keys(D.value[P]).length===0&&(delete D.value[P],D.valuesSources?.delete(P))}else{const E=D.valuesSources?.get(P);(T.isString(E)?E:E?.id)===y&&(D.valuesSources?.delete(P),delete D.value[P])}}const w=this.configurationDefaultsOverrides.get(v);w&&Object.keys(w.value).length===0&&(this.configurationDefaultsOverrides.delete(v),delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v])}else{if(D.source instanceof Map){const P=D.source;for(const k in f[v]){const E=P.get(k);(T.isString(E)?E:E?.id)===y&&(P.delete(k),delete D.value[k])}P.size===0&&this.configurationDefaultsOverrides.delete(v)}else{const P=T.isString(D.source)?D.source:D.source?.id;if(y!==P)continue;this.configurationDefaultsOverrides.delete(v)}const w=this.configurationProperties[v];w&&(this.updatePropertyDefaultValue(v,w),this.updateSchema(v,w))}r.add(v)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let r=!1;const f=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,f),r=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,f),r=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,f),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const r of i)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,r,f){i.forEach(u=>{this.validateAndRegisterProperties(u,r,u.extensionInfo,u.restrictedProperties,void 0,f),this.configurationContributors.push(u),this.registerJSONConfiguration(u)})}doDeregisterConfigurations(i,r){const f=u=>{if(u.properties)for(const v in u.properties){r.add(v);const y=this.configurationProperties[v];y?.policy?.name&&this.policyConfigurations.delete(y.policy.name),delete this.configurationProperties[v],this.removeFromSchema(v,u.properties[v])}u.allOf?.forEach(v=>f(v))};for(const u of i){f(u);const v=this.configurationContributors.indexOf(u);v!==-1&&this.configurationContributors.splice(v,1)}}validateAndRegisterProperties(i,r=!0,f,u,v=I.WINDOW,y){v=T.isUndefinedOrNull(i.scope)?v:i.scope;const D=i.properties;if(D)for(const P in D){const k=D[P];if(r&&n(P,k)){delete D[P];continue}if(k.source=f,k.defaultDefaultValue=D[P].default,this.updatePropertyDefaultValue(P,k),e.OVERRIDE_PROPERTY_REGEX.test(P)?k.scope=void 0:(k.scope=T.isUndefinedOrNull(k.scope)?v:k.scope,k.restricted=T.isUndefinedOrNull(k.restricted)?!!u?.includes(P):k.restricted),D[P].hasOwnProperty("included")&&!D[P].included){this.excludedConfigurationProperties[P]=D[P],delete D[P];continue}else this.configurationProperties[P]=D[P],D[P].policy?.name&&this.policyConfigurations.set(D[P].policy.name,P);!D[P].deprecationMessage&&D[P].markdownDeprecationMessage&&(D[P].deprecationMessage=D[P].markdownDeprecationMessage),y.add(P)}const w=i.allOf;if(w)for(const P of w)this.validateAndRegisterProperties(P,r,f,u,v,y)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const r=f=>{const u=f.properties;if(u)for(const y in u)this.updateSchema(y,u[y]);f.allOf?.forEach(r)};r(i)}updateSchema(i,r){switch(e.allSettings.properties[i]=r,r.scope){case I.APPLICATION:e.applicationSettings.properties[i]=r;break;case I.MACHINE:e.machineSettings.properties[i]=r;break;case I.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[i]=r;break;case I.WINDOW:e.windowSettings.properties[i]=r;break;case I.RESOURCE:e.resourceSettings.properties[i]=r;break;case I.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[i]=r,this.resourceLanguageSettingsSchema.properties[i]=r;break}}removeFromSchema(i,r){switch(delete e.allSettings.properties[i],r.scope){case I.APPLICATION:delete e.applicationSettings.properties[i];break;case I.MACHINE:delete e.machineSettings.properties[i];break;case I.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[i];break;case I.WINDOW:delete e.windowSettings.properties[i];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const r=`[${i}]`,f={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,f),e.allSettings.properties[r]=f,e.applicationSettings.properties[r]=f,e.machineSettings.properties[r]=f,e.machineOverridableSettings.properties[r]=f,e.windowSettings.properties[r]=f,e.resourceSettings.properties[r]=f}}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,r){const f=this.configurationDefaultsOverrides.get(i);let u=f?.value,v=f?.source;T.isUndefined(u)&&(u=r.defaultDefaultValue,v=void 0),T.isUndefined(u)&&(u=h(r.type)),r.default=u,r.defaultValueSource=v}}const C="\\[([^\\]]+)\\]",b=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(t){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let r=b.exec(t);for(;r?.length;){const f=r[1].trim();f&&i.push(f),r=b.exec(t)}}return(0,s.distinct)(i)}function m(t){return t.reduce((i,r)=>`${i}[${r}]`,"")}function h(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new c;p.Registry.add(e.Extensions.Configuration,g);function n(t,i){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?R.localize(7,null,t):g.getConfigurationProperties()[t]!==void 0?R.localize(8,null,t):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,t,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}function o(){const t=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))t.push([r,i[r].scope]);return t.push(["launch",I.RESOURCE]),t.push(["task",I.RESOURCE]),t}}),define(_e[282],ye([1,0,19,4,176,3,29,25,18,2,45,71,28,37]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=o,s=ze(s),T=ze(T),A=ze(A),p=ze(p);function b(f){return Object.isFrozen(f)?f:A.deepFreeze(f)}class l{static createEmptyModel(u){return new l({},[],[],void 0,u)}constructor(u,v,y,D,w){this._contents=u,this._keys=v,this._overrides=y,this.raw=D,this.logService=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(v=>{if(v instanceof l)return v;const y=new m("",this.logService);return y.parseRaw(v),y.configurationModel});this._rawConfiguration=u.reduce((v,y)=>y===v?y:v.merge(y),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(u){return u?(0,I.getConfigurationValue)(this.contents,u):this.contents}inspect(u,v){const y=this;return{get value(){return b(y.rawConfiguration.getValue(u))},get override(){return v?b(y.rawConfiguration.getOverrideValue(u,v)):void 0},get merged(){return b(v?y.rawConfiguration.override(v).getValue(u):y.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:w,identifiers:P,keys:k}of y.rawConfiguration.overrides){const E=new l(w,k,[],void 0,y.logService).getValue(u);E!==void 0&&D.push({identifiers:P,value:E})}return D.length?b(D):void 0}}}getOverrideValue(u,v){const y=this.getContentsForOverrideIdentifer(v);return y?u?(0,I.getConfigurationValue)(y,u):y:void 0}getKeysForOverrideIdentifier(u){const v=[];for(const y of this.overrides)y.identifiers.includes(u)&&v.push(...y.keys);return s.distinct(v)}getAllOverrideIdentifiers(){const u=[];for(const v of this.overrides)u.push(...v.identifiers);return s.distinct(u)}override(u){let v=this.overrideConfigurations.get(u);return v||(v=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,v)),v}merge(...u){const v=A.deepClone(this.contents),y=A.deepClone(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const P of u)if(w.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.mergeContents(v,P.contents);for(const k of P.overrides){const[E]=y.filter(S=>s.equals(S.identifiers,k.identifiers));E?(this.mergeContents(E.contents,k.contents),E.keys.push(...k.keys),E.keys=s.distinct(E.keys)):y.push(A.deepClone(k))}for(const k of P.keys)D.indexOf(k)===-1&&D.push(k)}return new l(v,D,y,w.every(P=>P instanceof l)?void 0:w,this.logService)}createOverrideConfigurationModel(u){const v=this.getContentsForOverrideIdentifer(u);if(!v||typeof v!="object"||!Object.keys(v).length)return this;const y={};for(const D of s.distinct([...Object.keys(this.contents),...Object.keys(v)])){let w=this.contents[D];const P=v[D];P&&(typeof w=="object"&&typeof P=="object"?(w=A.deepClone(w),this.mergeContents(w,P)):w=P),y[D]=w}return new l(y,this.keys,this.overrides,void 0,this.logService)}mergeContents(u,v){for(const y of Object.keys(v)){if(y in u&&p.isObject(u[y])&&p.isObject(v[y])){this.mergeContents(u[y],v[y]);continue}u[y]=A.deepClone(v[y])}}getContentsForOverrideIdentifer(u){let v=null,y=null;const D=w=>{w&&(y?this.mergeContents(y,w):y=A.deepClone(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===u?v=w.contents:w.identifiers.includes(u)&&D(w.contents);return D(v),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,v){this.updateValue(u,v,!0)}setValue(u,v){this.updateValue(u,v,!1)}removeValue(u){const v=this.keys.indexOf(u);v!==-1&&(this.keys.splice(v,1),(0,I.removeFromValueTree)(this.contents,u),_.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.splice(this.overrides.findIndex(y=>s.equals(y.identifiers,(0,_.overrideIdentifiersFromKey)(u))),1))}updateValue(u,v,y){(0,I.addToValueTree)(this.contents,u,v,D=>this.logService.error(D)),y=y||this.keys.indexOf(u)===-1,y&&this.keys.push(u),_.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.push({identifiers:(0,_.overrideIdentifiersFromKey)(u),keys:Object.keys(this.contents[u]),contents:(0,I.toValuesTree)(this.contents[u],D=>this.logService.error(D))})}}e.ConfigurationModel=l;class m{constructor(u,v){this._name=u,this.logService=v,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||l.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,v){if(!p.isUndefinedOrNull(u)){const y=this.doParseContent(u);this.parseRaw(y,v)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,v){this._raw=u;const{contents:y,keys:D,overrides:w,restricted:P,hasExcludedProperties:k}=this.doParseRaw(u,v);this._configurationModel=new l(y,D,w,k?[u]:void 0,this.logService),this._restrictedConfigurations=P||[]}doParseContent(u){let v={},y=null,D=[];const w=[],P=[];function k(S){Array.isArray(D)?D.push(S):y!==null&&(D[y]=S)}const E={onObjectBegin:()=>{const S={};k(S),w.push(D),D=S,y=null},onObjectProperty:S=>{y=S},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const S=[];k(S),w.push(D),D=S,y=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:k,onError:(S,M,N)=>{P.push({error:S,offset:M,length:N})}};if(u)try{T.visit(u,E),v=D[0]||{}}catch(S){this.logService.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return v}doParseRaw(u,v){const y=C.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),D=this.filter(u,y,!0,v);u=D.raw;const w=(0,I.toValuesTree)(u,E=>this.logService.error(`Conflict in settings file ${this._name}: ${E}`)),P=Object.keys(u),k=this.toOverrides(u,E=>this.logService.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:w,keys:P,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(u,v,y,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:w};const P={},k=[];for(const E in u)if(_.OVERRIDE_PROPERTY_REGEX.test(E)&&y){const S=this.filter(u[E],v,!1,D);P[E]=S.raw,w=w||S.hasExcludedProperties,k.push(...S.restricted)}else{const S=v[E],M=S?typeof S.scope<"u"?S.scope:_.ConfigurationScope.WINDOW:void 0;S?.restricted&&k.push(E),!D.exclude?.includes(E)&&(D.include?.includes(E)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&S?.restricted))?P[E]=u[E]:w=!0}return{raw:P,restricted:k,hasExcludedProperties:w}}toOverrides(u,v){const y=[];for(const D of Object.keys(u))if(_.OVERRIDE_PROPERTY_REGEX.test(D)){const w={};for(const P in u[D])w[P]=u[D][P];y.push({identifiers:(0,_.overrideIdentifiersFromKey)(D),keys:Object.keys(w),contents:(0,I.toValuesTree)(w,v)})}return y}}e.ConfigurationModelParser=m;class h extends R.Disposable{constructor(u,v,y,D,w){super(),this.userSettingsResource=u,this.parseOptions=v,this.fileService=D,this.logService=w,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),w),this._register(this.fileService.watch(y.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.any(d.Event.filter(this.fileService.onDidFilesChange,P=>P.contains(this.userSettingsResource)),d.Event.filter(this.fileService.onDidRunOperation,P=>(P.isOperation(c.FileOperation.CREATE)||P.isOperation(c.FileOperation.COPY)||P.isOperation(c.FileOperation.DELETE)||P.isOperation(c.FileOperation.WRITE))&&y.isEqual(P.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return l.createEmptyModel(this.logService)}}reparse(u){return u&&(this.parseOptions=u),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class g{constructor(u,v,y,D,w,P,k,E,S,M,N,O,x){this.key=u,this.overrides=v,this._value=y,this.overrideIdentifiers=D,this.defaultConfiguration=w,this.policyConfiguration=P,this.applicationConfiguration=k,this.userConfiguration=E,this.localUserConfiguration=S,this.remoteUserConfiguration=M,this.workspaceConfiguration=N,this.folderConfigurationModel=O,this.memoryConfigurationModel=x}get value(){return b(this._value)}toInspectValue(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class n{constructor(u,v,y,D,w,P,k,E,S,M){this._defaultConfiguration=u,this._policyConfiguration=v,this._applicationConfiguration=y,this._localUserConfiguration=D,this._remoteUserConfiguration=w,this._workspaceConfiguration=P,this._folderConfigurations=k,this._memoryConfiguration=E,this._memoryConfigurationByResource=S,this.logService=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(u,v,y){return this.getConsolidatedConfigurationModel(u,v,y).getValue(u)}updateValue(u,v,y={}){let D;y.resource?(D=this._memoryConfigurationByResource.get(y.resource),D||(D=l.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(y.resource,D))):D=this._memoryConfiguration,v===void 0?D.removeValue(u):D.setValue(u,v),y.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,v,y){const D=this.getConsolidatedConfigurationModel(u,v,y),w=this.getFolderConfigurationModelForResource(v.resource,y),P=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const E of D.overrides)for(const S of E.identifiers)D.getOverrideValue(u,S)!==void 0&&k.add(S);return new g(u,v,D.getValue(u),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this._workspaceConfiguration:void 0,w||void 0,P)}keys(u){const v=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:v?v.keys.slice(0):[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,v){this._folderConfigurations.set(u,v),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,v){const y=[];if(!v){const{added:D,updated:w,removed:P}=i(this._defaultConfiguration,u);v=[...D,...w,...P]}for(const D of v)for(const w of(0,_.overrideIdentifiersFromKey)(D)){const P=this._defaultConfiguration.getKeysForOverrideIdentifier(w),k=u.getKeysForOverrideIdentifier(w),E=[...k.filter(S=>P.indexOf(S)===-1),...P.filter(S=>k.indexOf(S)===-1),...P.filter(S=>!A.equals(this._defaultConfiguration.override(w).getValue(S),u.override(w).getValue(S)))];y.push([w,E])}return this.updateDefaultConfiguration(u),{keys:v,overrides:y}}compareAndUpdatePolicyConfiguration(u){const{added:v,updated:y,removed:D}=i(this._policyConfiguration,u),w=[...v,...y,...D];return w.length&&this.updatePolicyConfiguration(u),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:v,updated:y,removed:D,overrides:w}=i(this.applicationConfiguration,u),P=[...v,...y,...D];return P.length&&this.updateApplicationConfiguration(u),{keys:P,overrides:w}}compareAndUpdateLocalUserConfiguration(u){const{added:v,updated:y,removed:D,overrides:w}=i(this.localUserConfiguration,u),P=[...v,...y,...D];return P.length&&this.updateLocalUserConfiguration(u),{keys:P,overrides:w}}compareAndUpdateRemoteUserConfiguration(u){const{added:v,updated:y,removed:D,overrides:w}=i(this.remoteUserConfiguration,u),P=[...v,...y,...D];return P.length&&this.updateRemoteUserConfiguration(u),{keys:P,overrides:w}}compareAndUpdateWorkspaceConfiguration(u){const{added:v,updated:y,removed:D,overrides:w}=i(this.workspaceConfiguration,u),P=[...v,...y,...D];return P.length&&this.updateWorkspaceConfiguration(u),{keys:P,overrides:w}}compareAndUpdateFolderConfiguration(u,v){const y=this.folderConfigurations.get(u),{added:D,updated:w,removed:P,overrides:k}=i(y,v),E=[...D,...w,...P];return(E.length||!y)&&this.updateFolderConfiguration(u,v),{keys:E,overrides:k}}compareAndDeleteFolderConfiguration(u){const v=this.folderConfigurations.get(u);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:y,updated:D,removed:w,overrides:P}=i(v,void 0);return{keys:[...y,...D,...w],overrides:P}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,v,y){let D=this.getConsolidatedConfigurationModelForResource(v,y);return v.overrideIdentifier&&(D=D.override(v.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:u},v){let y=this.getWorkspaceConsolidatedConfiguration();if(v&&u){const D=v.getFolder(u);D&&(y=this.getFolderConsolidatedConfiguration(D.uri)||y);const w=this._memoryConfigurationByResource.get(u);w&&(y=y.merge(w))}return y}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let v=this._foldersConsolidatedConfigurations.get(u);if(!v){const y=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(u);D?(v=y.merge(D),this._foldersConsolidatedConfigurations.set(u,v)):v=y}return v}getFolderConfigurationModelForResource(u,v){if(v&&u){const y=v.getFolder(u);if(y)return this._folderConfigurations.get(y.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,v)=>{const{contents:y,overrides:D,keys:w}=this._folderConfigurations.get(v);return u.push([v,{contents:y,overrides:D,keys:w}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.keys.forEach(v=>u.add(v)),this.userConfiguration.keys.forEach(v=>u.add(v)),this._workspaceConfiguration.keys.forEach(v=>u.add(v)),this._folderConfigurations.forEach(v=>v.keys.forEach(y=>u.add(y))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(v=>u.add(v)),this.userConfiguration.getAllOverrideIdentifiers().forEach(v=>u.add(v)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(v=>u.add(v)),this._folderConfigurations.forEach(v=>v.getAllOverrideIdentifiers().forEach(y=>u.add(y))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(y=>v.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(y=>v.add(y)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(y=>v.add(y)),this._folderConfigurations.forEach(y=>y.getKeysForOverrideIdentifier(u).forEach(D=>v.add(D))),[...v.values()]}static parse(u,v){const y=this.parseConfigurationModel(u.defaults,v),D=this.parseConfigurationModel(u.policy,v),w=this.parseConfigurationModel(u.application,v),P=this.parseConfigurationModel(u.user,v),k=this.parseConfigurationModel(u.workspace,v),E=u.folders.reduce((S,M)=>(S.set(a.URI.revive(M[0]),this.parseConfigurationModel(M[1],v)),S),new L.ResourceMap);return new n(y,D,w,P,l.createEmptyModel(v),k,E,l.createEmptyModel(v),new L.ResourceMap,v)}static parseConfigurationModel(u,v){return new l(u.contents,u.keys,u.overrides,void 0,v)}}e.Configuration=n;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,v=new Map;for(const D of f)D.keys.forEach(w=>u.add(w)),D.overrides.forEach(([w,P])=>{const k=(0,L.getOrSet)(v,w,new Set);P.forEach(E=>k.add(E))});const y=[];return v.forEach((D,w)=>y.push([w,[...D.values()]])),{keys:[...u.values()],overrides:y}}class t{constructor(u,v,y,D,w){this.change=u,this.previous=v,this.currentConfiguraiton=y,this.currentWorkspace=D,this.logService=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const P of u.keys)this.affectedKeys.add(P);for(const[,P]of u.overrides)for(const k of P)this.affectedKeys.add(k);this._affectsConfigStr=this._marker;for(const P of this.affectedKeys)this._affectsConfigStr+=P+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(u,v){const y=this._marker+u,D=this._affectsConfigStr.indexOf(y);if(D<0)return!1;const w=D+y.length;if(w>=this._affectsConfigStr.length)return!1;const P=this._affectsConfigStr.charCodeAt(w);if(P!==this._markerCode1&&P!==this._markerCode2)return!1;if(v){const k=this.previousConfiguration?this.previousConfiguration.getValue(u,v,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(u,v,this.currentWorkspace);return!A.equals(k,E)}return!0}}e.ConfigurationChangeEvent=t;function i(f,u){const{added:v,removed:y,updated:D}=r(u?.rawConfiguration,f?.rawConfiguration),w=[],P=f?.getAllOverrideIdentifiers()||[],k=u?.getAllOverrideIdentifiers()||[];if(u){const E=k.filter(S=>!P.includes(S));for(const S of E)w.push([S,u.getKeysForOverrideIdentifier(S)])}if(f){const E=P.filter(S=>!k.includes(S));for(const S of E)w.push([S,f.getKeysForOverrideIdentifier(S)])}if(u&&f){for(const E of P)if(k.includes(E)){const S=r({contents:f.getOverrideValue(void 0,E)||{},keys:f.getKeysForOverrideIdentifier(E)},{contents:u.getOverrideValue(void 0,E)||{},keys:u.getKeysForOverrideIdentifier(E)});w.push([E,[...S.added,...S.removed,...S.updated]])}}return{added:v,removed:y,updated:D,overrides:w}}function r(f,u){const v=f?u?f.keys.filter(w=>u.keys.indexOf(w)===-1):[...f.keys]:[],y=u?f?u.keys.filter(w=>f.keys.indexOf(w)===-1):[...u.keys]:[],D=[];if(f&&u){for(const w of u.keys)if(f.keys.indexOf(w)!==-1){const P=(0,I.getConfigurationValue)(u.contents,w),k=(0,I.getConfigurationValue)(f.contents,w);A.equals(P,k)||D.push(w)}}return{added:v,removed:y,updated:D}}}),define(_e[283],ye([1,0,22,4,3,69]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=A;const L=(a,I,_)=>{const c=new Uint8Array(16);for(let l=0;l<16;l++)c[l]=Math.round(Math.random()*256);const C=(0,s.encodeBase64)(s.VSBuffer.wrap(c));return[`GET ws://localhost${a}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=s.VSBuffer.fromString(`\r
\r
`);async function A(a,I,_,c,C){a.write(s.VSBuffer.fromString((0,e.makeRawSocketHeaders)(I,_,c)));const b=new T.DisposableStore;try{return await new Promise((l,m)=>{let h;b.add(a.onData(g=>{h?h=s.VSBuffer.concat([h,g],h.byteLength+g.byteLength):h=g;const n=h.indexOf(e.socketRawEndHeaderSequence);if(n===-1)return;l(a),a.pauseData();const o=h.slice(n+e.socketRawEndHeaderSequence.byteLength);o.byteLength&&C.onData.fire(o)})),b.add(a.onClose(g=>m(g??new Error("socket closed")))),b.add(a.onEnd(()=>m(new Error("socket ended"))))})}catch(l){throw a.dispose(),l}finally{b.dispose()}}class p extends T.Disposable{constructor(I,_){super(),this.debugLabel=I,this.pausableDataEmitter=this._register(new d.PauseableEmitter),this.onData=(...c)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...c)),this.didDisposeEmitter=this._register(new d.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(_.onData),this._register(_.onData.event(c=>this.pausableDataEmitter.fire(c))),this.onClose=this._register(_.onClose).event,this.onEnd=this._register(_.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(I,_){R.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,I,_)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=p}),define(_e[72],ye([1,0,14,5]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=a,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var T;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class R{constructor(_){this.id=_,this.type=T.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=R;class L{constructor(_,c){this.host=_,this.port=c,this.type=T.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var A;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class p extends s.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof p&&_._code===A.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof p&&_._code===A.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof p&&_._code===A.NoResolverFound}static isInvalidAuthority(_){return _ instanceof p&&_._code===A.InvalidAuthority}static isHandled(_){return _ instanceof p&&_.isHandled}constructor(_,c=A.Unknown,C){super(_),this._message=_,this._code=c,this._detail=C,this.isHandled=c===A.NotAvailable&&C===!0,Object.setPrototypeOf(this,p.prototype)}}e.RemoteAuthorityResolverError=p;function a(I){const _=I.indexOf("+");return _===-1?I:I.substring(0,_)}}),define(_e[284],ye([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=w,e.connectRemoteAgentExtensionHost=P,e.connectRemoteAgentTunnel=E,a=ze(a);const b=30*1e3;var l;(function(pe){pe[pe.Management=1]="Management",pe[pe.ExtensionHost=2]="ExtensionHost",pe[pe.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function m(pe){switch(pe){case l.Management:return"Management";case l.ExtensionHost:return"ExtensionHost";case l.Tunnel:return"Tunnel"}}function h(pe){const G=new T.CancellationTokenSource;return setTimeout(()=>G.cancel(),pe),G.token}function g(pe,G){if(pe.isCancellationRequested||G.isCancellationRequested)return T.CancellationToken.Cancelled;const W=new T.CancellationTokenSource;return pe.onCancellationRequested(()=>W.cancel()),G.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this._state==="timedout"}constructor(G){this._state="pending",this._disposables=new A.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,s.promiseWithResolvers)(),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function o(pe,G){const W=new n(G);return W.registerDisposable(pe.onControlMessage(se=>{const ae=JSON.parse(se.toString()),te=V(ae);te?W.reject(te):W.resolve(ae)})),W.promise}function t(pe,G,W,se,ae,te,ce,ue){const Y=new n(ue),oe=I.StopWatch.create(!1);return pe.info(`Creating a socket (${ce})...`),a.mark(`code/willCreateSocket/${te}`),G.connect(W,se,ae,ce).then(ve=>{Y.didTimeout?(a.mark(`code/didCreateSocketError/${te}`),pe.info(`Creating a socket (${ce}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),ve?.dispose()):(a.mark(`code/didCreateSocketOK/${te}`),pe.info(`Creating a socket (${ce}) was successful after ${oe.elapsed()} ms.`),Y.resolve(ve))},ve=>{a.mark(`code/didCreateSocketError/${te}`),pe.info(`Creating a socket (${ce}) returned an error after ${oe.elapsed()} ms.`),pe.error(ve),Y.reject(ve)}),Y.promise}function i(pe,G){const W=new n(G);return pe.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function r(pe,G,W,se){const ae=ne(pe,G);pe.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let te;try{te=await t(pe.logService,pe.remoteSocketFactoryService,pe.connectTo,p.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${pe.reconnectionToken}&reconnection=${pe.reconnectionProtocol?"true":"false"}`,m(G),`renderer-${m(G)}-${pe.reconnectionToken}`,se)}catch(ve){throw pe.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),pe.logService.error(ve),ve}pe.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let ce,ue;pe.reconnectionProtocol?(pe.reconnectionProtocol.beginAcceptReconnection(te,null),ce=pe.reconnectionProtocol,ue=!1):(ce=new c.PersistentProtocol({socket:te}),ue=!0),pe.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const Y=await i(pe.signService.createNewMessage((0,_.generateUuid)()),se),oe={type:"auth",auth:pe.connectionToken||"00000000000000000000",data:Y.data};ce.sendControl(d.VSBuffer.fromString(JSON.stringify(oe)));try{const ve=await o(ce,g(se,h(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(pe.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await i(pe.signService.validate(Y,ve.signedData),se)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Fe=await i(pe.signService.sign(ve.data),se),We={type:"connectionType",commit:pe.commit,signedData:Fe,desiredConnectionType:G};return W&&(We.args=W),pe.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(d.VSBuffer.fromString(JSON.stringify(We))),{protocol:ce,ownsProtocol:ue}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(pe.logService.error(`${ae} the handshake timed out. Error:`),pe.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(pe.logService.error(`${ae} received error control message when negotiating connection. Error:`),pe.logService.error(ve)),ue&&B(ce),ve}}async function f(pe,G,W,se){const ae=Date.now(),te=ne(pe,G),{protocol:ce,ownsProtocol:ue}=await r(pe,G,W,se),Y=new n(se);return Y.registerDisposable(ce.onControlMessage(oe=>{const ve=JSON.parse(oe.toString()),be=V(ve);be?(pe.logService.error(`${te} received error control message when negotiating connection. Error:`),pe.logService.error(be),ue&&B(ce),Y.reject(be)):(pe.reconnectionProtocol?.endAcceptReconnection(),pe.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(ae)}!`),Y.resolve({protocol:ce,firstMessage:ve}))})),Y.promise}async function u(pe,G){const{protocol:W}=await f(pe,l.Management,void 0,G);return{protocol:W}}async function v(pe,G,W){const{protocol:se,firstMessage:ae}=await f(pe,l.ExtensionHost,G,W),te=ae&&ae.debugPort;return{protocol:se,debugPort:te}}async function y(pe,G,W){const se=Date.now(),ae=ne(pe,l.Tunnel),{protocol:te}=await r(pe,l.Tunnel,G,W);return pe.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function D(pe,G,W){const{connectTo:se,connectionToken:ae}=await pe.addressProvider.getAddress();return{commit:pe.commit,quality:pe.quality,connectTo:se,connectionToken:ae,reconnectionToken:G,reconnectionProtocol:W,remoteSocketFactoryService:pe.remoteSocketFactoryService,signService:pe.signService,logService:pe.logService}}async function w(pe,G,W){return k(pe,async se=>{const{protocol:ae}=await u(se,T.CancellationToken.None);return new j(pe,G,W,se.reconnectionToken,ae)})}async function P(pe,G){return k(pe,async W=>{const{protocol:se,debugPort:ae}=await v(W,G,T.CancellationToken.None);return new re(pe,G,W.reconnectionToken,se,ae)})}async function k(pe,G){for(let se=1;;se++)try{const ae=(0,_.generateUuid)(),te=await D(pe,ae,null);return await G(te)}catch(ae){if(se<5)pe.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),pe.logService.error(ae);else throw pe.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),pe.logService.error(ae),H.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(ae)),ae}}async function E(pe,G,W){const se=await D(pe,(0,_.generateUuid)(),null);return await y(se,{host:G,port:W},T.CancellationToken.None)}function S(pe){return(0,s.createCancelablePromise)(G=>new Promise((W,se)=>{const ae=setTimeout(W,pe*1e3);G.onCancellationRequested(()=>{clearTimeout(ae),W()})}))}var M;(function(pe){pe[pe.ConnectionLost=0]="ConnectionLost",pe[pe.ReconnectionWait=1]="ReconnectionWait",pe[pe.ReconnectionRunning=2]="ReconnectionRunning",pe[pe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",pe[pe.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class N{constructor(G,W){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.type=M.ConnectionLost}}e.ConnectionLostEvent=N;class O{constructor(G,W,se,ae){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.cancellableTimer=ae,this.type=M.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class x{constructor(G,W,se){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=M.ReconnectionRunning}}e.ReconnectionRunningEvent=x;class U{constructor(G,W,se){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=M.ConnectionGain}}e.ConnectionGainEvent=U;class F{constructor(G,W,se,ae){this.reconnectionToken=G,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=ae,this.type=M.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=F;class H extends A.Disposable{static triggerPermanentFailure(G,W,se){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=W,this._permanentFailureHandled=se,this._instances.forEach(ae=>ae._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||H._permanentFailure}constructor(G,W,se,ae,te){super(),this._connectionType=G,this._options=W,this.reconnectionToken=se,this.protocol=ae,this._reconnectionFailureIsFatal=te,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(ae.onSocketClose(ce=>{const ue=he(this._connectionType,this.reconnectionToken,!0);ce?ce.type===c.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${ue} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this._options.logService.error(ce.error)):(this._options.logService.info(`${ue} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this._options.logService.error(ce.event)):this._options.logService.info(`${ue} received socket close event.`),this._beginReconnecting()})),this._register(ae.onSocketTimeout(ce=>{const ue=he(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),H._instances.push(this),this._register((0,A.toDisposable)(()=>{const ce=H._instances.indexOf(this);ce>=0&&H._instances.splice(ce,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(H._permanentFailureMillisSinceLastIncomingData,H._permanentFailureAttempt,H._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const G=he(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<W.length?W[se]:W[W.length-1];try{if(ae>0){const ce=S(ae);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,ce)),this._options.logService.info(`${G} waiting for ${ae} seconds before reconnecting...`);try{await ce}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this._options.logService.info(`${G} resolving connection...`);const te=await D(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${te.connectTo}...`),await this._reconnect(te,h(b)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(te)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if((0,R.isCancellationError)(te)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if(te instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,C.RemoteAuthorityResolverError.isHandled(te));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(G,W,se){this._reconnectionFailureIsFatal?H.triggerPermanentFailure(G,W,se):this._gotoPermanentFailure(G,W,se)}_gotoPermanentFailure(G,W,se){this._onDidStateChange.fire(new F(this.reconnectionToken,G,W,se)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=H;class j extends H{constructor(G,W,se,ae,te){super(l.Management,G,ae,te,!0),this.client=this._register(new c.Client(te,{remoteAuthority:W,clientId:se},G.ipcLogger))}async _reconnect(G,W){await u(G,W)}}e.ManagementPersistentConnection=j;class re extends H{constructor(G,W,se,ae,te){super(l.ExtensionHost,G,se,ae,!1),this._startArguments=W,this.debugPort=te}async _reconnect(G,W){await v(G,this._startArguments,W)}}e.ExtensionHostPersistentConnection=re;function B(pe){try{pe.acceptDisconnect();const G=pe.getSocket();pe.dispose(),G.dispose()}catch(G){(0,R.onUnexpectedError)(G)}}function V(pe){if(pe&&pe.type==="error"){const G=new Error(`Connection error: ${pe.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function X(pe,G){for(;pe.length<G;)pe+=" ";return pe}function ee(pe,G){return`[remote-connection][${X(m(pe),13)}][${G.substr(0,5)}\u2026]`}function he(pe,G,W){return`${ee(pe,G)}[${W?"reconnect":"initial"}]`}function ne(pe,G){return`${he(G,pe.reconnectionToken,!!pe.reconnectionProtocol)}[${pe.connectTo}]`}function De(pe){return`${Date.now()-pe} ms`}}),define(_e[91],ye([1,0,15]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=d,e.getRemoteName=T,e.parseAuthorityWithPort=R,e.parseAuthorityWithOptionalPort=L;function d(p){return p.scheme===s.Schemas.vscodeRemote?p.authority:void 0}function T(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function R(p){const{host:a,port:I}=A(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:I}}function L(p,a){let{host:I,port:_}=A(p);return typeof _>"u"&&(_=a),{host:I,port:_}}function A(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const _=p.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:p,port:void 0}}}),define(_e[24],ye([1,0,13,5,91]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=R,e.isApplicationScopedExtension=_,e.isLanguagePackExtension=c,e.isAuthenticationProviderExtension=C,e.isResolverExtension=b,e.parseApiProposals=l,e.parseEnabledApiProposalNames=m,s=ze(s),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var A;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.LINUX_PPC64LE="linux-ppc64le",h.LINUX_RISCV64="linux-riscv64",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class p{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,n){if(typeof g>"u"||g===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof g=="string"||typeof n=="string"){const o=typeof g=="string"?g:g.value,t=typeof n=="string"?n:n.value;return s.equalsIgnoreCase(o,t)}return g._lower===n._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=p;class a{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const n of g)this.add(n)}add(g){this._set.add(p.toKey(g))}delete(g){return this._set.delete(p.toKey(g))}has(g){return this._set.has(p.toKey(g))}}e.ExtensionIdentifierSet=a;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(p.toKey(g))}get(g){return this._map.get(p.toKey(g))}has(g){return this._map.has(p.toKey(g))}set(g,n){this._map.set(p.toKey(g),n)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function _(h){return c(h)}function c(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function C(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function b(h,g){if(g){const n=`onResolveRemoteAuthority:${(0,T.getRemoteName)(g)}`;return!!h.activationEvents?.includes(n)}return!1}function l(h){return h.map(g=>{const[n,o]=g.split("@");return{proposalName:n,version:o?parseInt(o):void 0}})}function m(h){return h.map(g=>g.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,d.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[147],ye([1,0,11,222,24,5]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=A,e.toTargetPlatform=p,e.getTargetPlatform=a,e.isNotWebExtensionInWebTargetPlatform=I,e.isTargetPlatformCompatible=_,e.isIExtensionIdentifier=c,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function A(t){switch(t){case T.TargetPlatform.WIN32_X64:return"Windows 64 bit";case T.TargetPlatform.WIN32_ARM64:return"Windows ARM";case T.TargetPlatform.LINUX_X64:return"Linux 64 bit";case T.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case T.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case T.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case T.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case T.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case T.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case T.TargetPlatform.DARWIN_X64:return"Mac";case T.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case T.TargetPlatform.WEB:return"Web";case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;case T.TargetPlatform.UNKNOWN:return T.TargetPlatform.UNKNOWN;case T.TargetPlatform.UNDEFINED:return T.TargetPlatform.UNDEFINED}}function p(t){switch(t){case T.TargetPlatform.WIN32_X64:return T.TargetPlatform.WIN32_X64;case T.TargetPlatform.WIN32_ARM64:return T.TargetPlatform.WIN32_ARM64;case T.TargetPlatform.LINUX_X64:return T.TargetPlatform.LINUX_X64;case T.TargetPlatform.LINUX_ARM64:return T.TargetPlatform.LINUX_ARM64;case T.TargetPlatform.LINUX_ARMHF:return T.TargetPlatform.LINUX_ARMHF;case T.TargetPlatform.LINUX_PPC64LE:return T.TargetPlatform.LINUX_PPC64LE;case T.TargetPlatform.LINUX_RISCV64:return T.TargetPlatform.LINUX_RISCV64;case T.TargetPlatform.ALPINE_X64:return T.TargetPlatform.ALPINE_X64;case T.TargetPlatform.ALPINE_ARM64:return T.TargetPlatform.ALPINE_ARM64;case T.TargetPlatform.DARWIN_X64:return T.TargetPlatform.DARWIN_X64;case T.TargetPlatform.DARWIN_ARM64:return T.TargetPlatform.DARWIN_ARM64;case T.TargetPlatform.WEB:return T.TargetPlatform.WEB;case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;default:return T.TargetPlatform.UNKNOWN}}function a(t,i){switch(t){case s.Platform.Windows:return i==="x64"?T.TargetPlatform.WIN32_X64:i==="arm64"?T.TargetPlatform.WIN32_ARM64:T.TargetPlatform.UNKNOWN;case s.Platform.Linux:return i==="x64"?T.TargetPlatform.LINUX_X64:i==="arm64"?T.TargetPlatform.LINUX_ARM64:i==="arm"?T.TargetPlatform.LINUX_ARMHF:i==="ppc64le"?T.TargetPlatform.LINUX_PPC64LE:i==="riscv64"?T.TargetPlatform.LINUX_RISCV64:T.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?T.TargetPlatform.ALPINE_X64:i==="arm64"?T.TargetPlatform.ALPINE_ARM64:T.TargetPlatform.UNKNOWN;case s.Platform.Mac:return i==="x64"?T.TargetPlatform.DARWIN_X64:i==="arm64"?T.TargetPlatform.DARWIN_ARM64:T.TargetPlatform.UNKNOWN;case s.Platform.Web:return T.TargetPlatform.WEB}}function I(t,i){return i===T.TargetPlatform.WEB&&!t.includes(T.TargetPlatform.WEB)}function _(t,i,r){return I(i,r)?!1:t===T.TargetPlatform.UNDEFINED||t===T.TargetPlatform.UNIVERSAL?!0:t===T.TargetPlatform.UNKNOWN?!1:t===r}function c(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var C;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var b;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var h;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(h||(e.ExtensionGalleryErrorCode=h={}));class g extends Error{constructor(i,r){super(i),this.code=r,this.name=r}}e.ExtensionGalleryError=g;var n;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(i,r){super(i),this.code=r,this.name=r}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,d.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,d.localize2)(1,"Preferences")}),define(_e[148],ye([1,0,14,24]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this._generators=new Map,this._cache=new WeakMap}register(L,A){this._generators.set(L,A)}readActivationEvents(L){return this._cache.has(L)||this._cache.set(L,this._readActivationEvents(L)),this._cache.get(L)}createActivationEventsMap(L){const A=Object.create(null);for(const p of L){const a=this.readActivationEvents(p);a.length>0&&(A[d.ExtensionIdentifier.toKey(p.identifier)]=a)}return A}_readActivationEvents(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const A=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let p=0;p<A.length;p++)A[p]==="onUri"&&(A[p]=`onUri:${d.ExtensionIdentifier.toKey(L.identifier)}`);if(!L.contributes)return A;for(const p in L.contributes){const a=this._generators.get(p);if(!a)continue;const I=L.contributes[p],_=Array.isArray(I)?I:[I];try{a(_,A)}catch(c){(0,s.onUnexpectedError)(c)}}return A}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[285],ye([1,0,23,44,223,412,24,144]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=I,e.parseVersion=_,e.normalizeVersion=c,e.isValidVersion=C,e.validateExtensionManifest=b,e.isValidExtensionVersion=l,e.isEngineValid=m,e.areApiProposalsCompatible=h,d=xt(d),T=ze(T),R=ze(R);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function I(o){return o=o.trim(),o==="*"||p.test(o)}function _(o){if(!I(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function c(o){if(!o)return null;const t=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let f=o.minorMustEqual;const u=o.patchBase;let v=o.patchMustEqual;o.hasCaret&&(t===0||(f=!1),v=!1);let y=0;if(o.preRelease){const D=a.exec(o.preRelease);if(D){const[,w,P,k]=D;y=Date.UTC(Number(w),Number(P)-1,Number(k))}}return{majorBase:t,majorMustEqual:i,minorBase:r,minorMustEqual:f,patchBase:u,patchMustEqual:v,isMinimum:o.hasGreaterEquals,notBefore:y}}function C(o,t,i){let r;typeof o=="string"?r=c(_(o)):r=o;let f;t instanceof Date?f=t.getTime():typeof t=="string"&&(f=new Date(t).getTime());let u;if(typeof i=="string"?u=c(_(i)):u=i,!r||!u)return!1;const v=r.majorBase,y=r.minorBase,D=r.patchBase;let w=u.majorBase,P=u.minorBase,k=u.patchBase;const E=u.notBefore;let S=u.majorMustEqual,M=u.minorMustEqual,N=u.patchMustEqual;return u.isMinimum?v>w?!0:v<w?!1:y>P?!0:y<P||f&&f<E?!1:D>=k:(v===1&&w===0&&(!S||!M||!N)&&(w=1,P=0,k=0,S=!0,M=!1,N=!1),v<w?!1:v>w?!S:y<P?!1:y>P?!M:D<k?!1:D>k?!N:!(f&&f<E))}function b(o,t,i,r,f,u){const v=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return v.push([d.default.Error,T.localize(0,null)]),v;if(typeof r.name!="string")return v.push([d.default.Error,T.localize(1,null,"name")]),v;if(typeof r.version!="string")return v.push([d.default.Error,T.localize(2,null,"version")]),v;if(!r.engines)return v.push([d.default.Error,T.localize(3,null,"engines")]),v;if(typeof r.engines.vscode!="string")return v.push([d.default.Error,T.localize(4,null,"engines.vscode")]),v;if(typeof r.extensionDependencies<"u"&&!n(r.extensionDependencies))return v.push([d.default.Error,T.localize(5,null,"extensionDependencies")]),v;if(typeof r.activationEvents<"u"){if(!n(r.activationEvents))return v.push([d.default.Error,T.localize(6,null,"activationEvents")]),v;if(typeof r.main>"u"&&typeof r.browser>"u")return v.push([d.default.Error,T.localize(7,null,"activationEvents","main","browser")]),v}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&v.push([d.default.Warning,T.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return v.push([d.default.Error,T.localize(9,null,"main")]),v;{const w=(0,s.joinPath)(i,r.main);(0,s.isEqualOrParent)(w,i)||v.push([d.default.Warning,T.localize(10,null,w.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return v.push([d.default.Error,T.localize(11,null,"browser")]),v;{const w=(0,s.joinPath)(i,r.browser);(0,s.isEqualOrParent)(w,i)||v.push([d.default.Warning,T.localize(12,null,w.path,i.path)])}}if(!R.valid(r.version))return v.push([d.default.Error,T.localize(13,null)]),v;const y=[];if(!l(o,t,r,f,y))for(const w of y)v.push([d.default.Error,w]);if(u&&r.enabledApiProposals?.length){const w=[];if(!h([...r.enabledApiProposals],w))for(const P of w)v.push([d.default.Error,P])}return v}function l(o,t,i,r,f){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:g(o,t,i.engines.vscode,f)}function m(o,t,i){return o==="*"||g(t,i,o)}function h(o,t){if(o.length===0)return!0;const i=Array.isArray(t)?t:void 0,r=(i?void 0:t)??A.allApiProposals,f=[],u=(0,L.parseApiProposals)(o);for(const{proposalName:v,version:y}of u){const D=r[v];D&&y&&D.version!==y&&f.push(T.localize(14,null,v))}return i?.push(...f),f.length===0}function g(o,t,i,r=[]){const f=c(_(i));if(!f)return r.push(T.localize(15,null,i)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return r.push(T.localize(16,null,i)),!1}else if(!f.majorMustEqual)return r.push(T.localize(17,null,i)),!1;return C(o,t,f)?!0:(r.push(T.localize(18,null,o,i)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let t=0,i=o.length;t<i;t++)if(typeof o[t]!="string")return!1;return!0}}),define(_e[286],ye([1,0,3,5]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,d.createDecorator)("remoteSocketFactoryService");class T{constructor(){this.factories={}}register(L,A){return this.factories[L]??=[],this.factories[L].push(A),(0,s.toDisposable)(()=>{const p=this.factories[L]?.indexOf(A);typeof p=="number"&&p>=0&&this.factories[L]?.splice(p,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(p=>p.supports(L))}connect(L,A,p,a){const I=this.getSocketFactory(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,A,p,a)}}e.RemoteSocketFactoryService=T}),define(_e[287],ye([1,0,22,14,3,230,71,5,12,37]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=c,e.hasNoContent=C,e.asText=b,e.asTextOrError=l,e.asJson=m,e.updateProxyConfigurationsScope=h,e.IRequestService=(0,A.createDecorator)("requestService");class I{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?t[i]="*****":t[i]=this.original[i];this.headers=t}return this.headers}}class _ extends T.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,R.localize)(0,null),when:p.CONTEXT_LOG_LEVEL.isEqualTo((0,p.LogLevelToString)(p.LogLevel.Trace)).serialize()})}async logAndRequest(t,i,r){const f=`${t} #${++this.counter}: ${i.url}`;this.logger.trace(`${f} - begin`,i.type,new I(i.headers??{}));try{const u=await r();return this.logger.trace(`${f} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.logger.error(`${f} - error`,i.type,(0,d.getErrorMessage)(u)),u}}}e.AbstractRequestService=_;function c(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function C(o){return o.res.statusCode===204}async function b(o){return C(o)?null:(await(0,s.streamToBuffer)(o.stream)).toString()}async function l(o){if(!c(o))throw new Error("Server returned "+o.res.statusCode);return b(o)}async function m(o){if(!c(o))throw new Error("Server returned "+o.res.statusCode);if(C(o))return null;const i=(await(0,s.streamToBuffer)(o.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function h(o){n(o)}let g;function n(o){const t=a.Registry.as(L.Extensions.Configuration),i=g;g={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null),(0,R.localize)(10,null)],default:"override",description:(0,R.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[g],remove:i?[i]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(_e[288],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class s{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(T){try{const R=await this.getValidator();if(R){const L=String(s._nextId++);return this.validators.set(L,R),{id:L,data:R.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,R){if(!T.id)return!0;const L=this.validators.get(T.id);if(!L)return!1;this.validators.delete(T.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(T){try{return await this.signValue(T)}catch{}return T}}e.AbstractSignService=s}),define(_e[118],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,s.createDecorator)(e.SIGN_SERVICE_ID)}),define(_e[149],ye([1,0,288]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d extends s.AbstractSignService{getValidator(){return this.vsda().then(R=>new R.validator)}signValue(R){return this.vsda().then(L=>new L.signer().sign(R))}vsda(){return new Promise((R,L)=>le(["vsda"],R,L))}}e.SignService=d}),define(_e[289],ye([1,0,11,56,32]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=L,e.verifyMicrosoftInternalDomain=A;function R(p){if(s.platform===s.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function L(p,a,I,_,c,C,b,l,m,h){const g=Object.create(null);g["common.machineId"]=C,g["common.sqmId"]=b,g["common.devDeviceId"]=l,g.sessionID=(0,T.generateUuid)()+Date.now(),g.commitHash=_,g.version=c,g["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,s.PlatformToString)(s.platform),g["common.nodePlatform"]=d.platform,g["common.nodeArch"]=I,g["common.product"]=h||"desktop",m&&(g["common.msftInternal"]=m);let n=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),s.isLinuxSnap&&(g["common.snap"]="true");const t=R(a);return t&&(g["common.platformDetail"]=t),g}function A(p){const a=d.env.USERDNSDOMAIN;if(!a)return!1;const I=a.toLowerCase();return p.some(_=>I===_)}}),define(_e[150],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,s.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,s.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var d;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(d||(e.TelemetryLevel=d={}));var T;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(_e[92],ye([1,0,25,18,91,289,150]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=I,e.isLoggingOnly=_,e.getTelemetryLevel=c,e.validateTelemetryData=C,e.cleanRemoteAuthority=l,e.isInternalTelemetry=h,e.getPiiPathsFromEnvironment=g,e.cleanData=t;class A{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=A;class p{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class a{async publicLog(r,f,u){}async publicLogError(r,f,u){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function _(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function c(i){const r=i.getValue(L.TELEMETRY_SETTING_ID),f=i.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return L.TelemetryLevel.NONE;switch(r??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function C(i){const r={},f={},u={};m(i,u);for(let v in u){v=v.length>150?v.substr(v.length-149):v;const y=u[v];typeof y=="number"?f[v]=y:typeof y=="boolean"?f[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),r[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(r[v]=y)}return{properties:r,measurements:f}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(i){if(!i)return"none";const r=(0,T.getRemoteName)(i);return b.has(r)?r:"other"}function m(i,r,f=0,u){if(i)for(const v of Object.getOwnPropertyNames(i)){const y=i[v],D=u?u+v:v;Array.isArray(y)?r[D]=(0,s.safeStringify)(y):y instanceof Date?r[D]=y.toISOString():(0,d.isObject)(y)?f<2?m(y,r,f+1,D+"."):r[D]=(0,s.safeStringify)(y):r[D]=y}}function h(i,r){const f=i.msftInternalDomains||[],u=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(f)||u}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let f=i;const u=[];for(const w of r)for(;;){const P=w.exec(i);if(!P)break;u.push([P.index,w.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const w=y.exec(i);if(!w)break;const P=u.some(([k,E])=>w.index<E&&k<y.lastIndex);!v.test(w[0])&&!P&&(f+=i.substring(D,w.index)+"<REDACTED: user-file-path>",D=y.lastIndex)}return D<i.length&&(f+=i.substr(D)),f}function o(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of r)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return i}function t(i,r){return(0,s.cloneAndChange)(i,f=>{if(f instanceof A||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=n(u,r);for(const v of r)u=u.replace(v,"");return u=o(u),u}})}}),define(_e[290],ye([1,0,13,147,24,11,2,14,56,92]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=I,e.getIdAndVersion=b,e.getExtensionId=l,e.adoptToGalleryExtensionId=m,e.getGalleryExtensionId=h,e.groupByExtension=g,e.getLocalExtensionTelemetryData=n,e.getGalleryExtensionTelemetryData=o,e.getExtensionDependencies=t,e.computeTargetPlatform=r;function I(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,s.compareIgnoreCase)(f.id,u.id)===0}const _=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(u){const v=u.manifest?u.manifest.version:u.version,y=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new c(u.identifier,v,y)}static parse(u){const v=_.exec(u);return v&&v[1]&&v[2]?new c({id:v[1]},v[2],v[4]||void 0):null}constructor(u,v,y=T.TargetPlatform.UNDEFINED){this.identifier=u,this.version=v,this.targetPlatform=y,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==T.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof c?I(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=c;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(f){const u=C.exec(f);return u&&u[1]?[m(u[1]),u[2]]:[m(f),void 0]}function l(f,u){return`${f}.${u}`}function m(f){return f.toLowerCase()}function h(f,u){return m(l(f??T.UNDEFINED_PUBLISHER,u))}function g(f,u){const v=[],y=D=>{for(const w of v)if(w.some(P=>I(u(P),u(D))))return w;return null};for(const D of f){const w=y(D);w?w.push(D):v.push([D])}return v}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function o(f){return{id:new a.TelemetryTrustedValue(f.identifier.id),name:new a.TelemetryTrustedValue(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function t(f,u){const v=[],y=u.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const D=y.shift();if(D&&v.every(w=>!I(w.identifier,{id:D}))){const w=f.filter(P=>I(P.identifier,{id:D}));w.length===1&&(v.push(w[0]),y.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}async function i(f,u){if(!R.isLinux)return!1;let v;try{v=(await f.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await f.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(D))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(f,u){const v=await i(f,u),y=(0,d.getTargetPlatform)(v?"alpine":R.platform,p.arch);return u.debug("ComputeTargetPlatform:",y),y}}),define(_e[291],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=s,e.serializeEnvironmentDescriptionMap=d,e.deserializeEnvironmentVariableCollection=T,e.deserializeEnvironmentDescriptionMap=R,e.serializeEnvironmentVariableCollections=L,e.deserializeEnvironmentVariableCollections=A;function s(p){return[...p.entries()]}function d(p){return p?[...p.entries()]:[]}function T(p){return new Map(p)}function R(p){return new Map(p??[])}function L(p){return Array.from(p.entries()).map(a=>[a[0],s(a[1].map),d(a[1].descriptionMap)])}function A(p){return new Map(p.map(a=>[a[0],{map:T(a[1]),descriptionMap:R(a[2])}]))}}),define(_e[292],ye([1,0,5,36,37]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new d.RawContextKey("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var A;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(A||(e.PosixShellType=A={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var _;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(_||(e.ProcessPropertyType=_={})),e.IPtyService=(0,s.createDecorator)("ptyService");var c;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(c||(e.HeartbeatConstants=c={}));var C;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(C||(e.TerminalLocation=C={}));var b;(function(t){t.TerminalView="view",t.Editor="editor"})(b||(e.TerminalLocationString=b={}));var l;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(l||(e.LocalReconnectConstants=l={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var h;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var g;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var n;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const r=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this._backends.set(r,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}T.Registry.add(e.TerminalExtensions.Backend,new o),e.ILocalPtyService=(0,s.createDecorator)("localPtyService"),e.ITerminalLogService=(0,s.createDecorator)("terminalLogService")}),define(_e[293],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,R,L=5){const A=R(p=>{const a=typeof p=="string"?p:p.data;let I=this._terminalBufferMap.get(T);if(I){I.data.push(a);return}const _=setTimeout(()=>this.flushBuffer(T),L);I={data:[a],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(T),A.dispose()}},this._terminalBufferMap.set(T,I)});return A}stopBuffering(T){this._terminalBufferMap.get(T)?.dispose()}flushBuffer(T){const R=this._terminalBufferMap.get(T);R&&(this._terminalBufferMap.delete(T),this._callback(T,R.data.join("")))}}e.TerminalDataBufferer=s}),define(_e[294],ye([1,0,9,83,105,50,4,18,2,231,117,37]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=m,e.getIconRegistry=h,_=ze(_),e.Extensions={IconContribution:"base.contributions.icons"};var c;(function(t){function i(r,f){let u=r.defaults;for(;R.ThemeIcon.isThemeIcon(u);){const v=l.getIcon(u.id);if(!v)return;u=v.defaults}return u}t.getDefinition=i})(c||(e.IconContribution=c={}));var C;(function(t){function i(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}t.toJSONObject=i;function r(f){const u=v=>(0,A.isString)(v)?v:void 0;if(f&&Array.isArray(f.src)&&f.src.every(v=>(0,A.isString)(v.format)&&(0,A.isString)(v.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map(v=>({format:v.format,location:p.URI.parse(v.location)}))}}t.fromJSONObject=r})(C||(e.IconFontDefinition=C={}));class b{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(i,r,f,u){const v=this.iconsById[i];if(v){if(f&&!v.description){v.description=f,this.iconSchema.properties[i].markdownDescription=`${f} $(${i})`;const w=this.iconReferenceSchema.enum.indexOf(i);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=f),this._onDidChange.fire()}return v}const y={id:i,description:f,defaults:r,deprecationMessage:u};this.iconsById[i]=y;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),f&&(D.markdownDescription=`${f}: $(${i})`),this.iconSchema.properties[i]=D,this.iconReferenceSchema.enum.push(i),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:i}}deregisterIcon(i){delete this.iconsById[i],delete this.iconSchema.properties[i];const r=this.iconReferenceSchema.enum.indexOf(i);r!==-1&&(this.iconReferenceSchema.enum.splice(r,1),this.iconReferenceSchema.enumDescriptions.splice(r,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(i=>this.iconsById[i])}getIcon(i){return this.iconsById[i]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(i,r){const f=this.iconFontsById[i];return f||(this.iconFontsById[i]=r,this._onDidChange.fire(),r)}deregisterIconFont(i){delete this.iconFontsById[i]}getIconFont(i){return this.iconFontsById[i]}toString(){const i=(v,y)=>v.id.localeCompare(y.id),r=v=>{for(;R.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of u.filter(y=>!!y.description).sort(i))f.push(`|<i class="${r(v)}"></i>|${v.id}|${R.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const v of u.filter(y=>!R.ThemeIcon.isThemeIcon(y.defaults)).sort(i))f.push(`|<i class="${r(v)}"></i>|${v.id}|`);return f.join(`
`)}}const l=new b;_.Registry.add(e.Extensions.IconContribution,l);function m(t,i,r,f){return l.registerIcon(t,i,r,f)}function h(){return l}function g(){const t=(0,T.getCodiconFontCharacters)();for(const i in t){const r="\\"+t[i].toString(16);l.registerIcon(i,{fontCharacter:r})}}g(),e.iconsSchemaId="vscode://schemas/icons";const n=_.Registry.as(I.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,l.getIconSchema());const o=new s.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);l.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=m("widget-close",d.Codicon.close,(0,a.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",d.Codicon.arrowUp,(0,a.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",d.Codicon.arrowDown,(0,a.localize)(4,null)),e.syncing=R.ThemeIcon.modify(d.Codicon.sync,"spin"),e.spinningLoading=R.ThemeIcon.modify(d.Codicon.loading,"spin")}),define(_e[93],ye([1,0,4,3,11,2,45,5,12]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=_,e.extractLocalHostUriMetaDataForPortMapping=C,e.extractQueryLocalHostUriMetaDataForPortMapping=b,e.isLocalhost=l,e.isAllInterfaces=m,e.isPortPrivileged=h,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var a;(function(o){o.Http="http",o.Https="https"})(a||(e.TunnelProtocol=a={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function _(o){return!!o.forwardPort}var c;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function C(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function b(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const i of t){const r=i.split("=")[1];if(/^https?:/.exec(r)){const f=C(R.URI.parse(r));if(f)return f}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}function h(o,t,i,r){if(i===T.OperatingSystem.Windows)return!1;if(i===T.OperatingSystem.Macintosh&&m(t)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(f?.length===4&&parseInt(f[1])>=18)return!1}return o<1024}class g{constructor(t,i,r){this.remoteAddress=t,this.localAddress=i,this._dispose=r,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let n=class extends d.Disposable{constructor(t,i){super(),this.logService=t,this.configurationService=i,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],i=Array.from(this._tunnels.values());for(const r of i){const f=Array.from(r.values());for(const u of f){const v=await u.value;v&&typeof v!="string"&&t.push(v)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:i}of t.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,i,r,f,u){this.addTunnelToMap(t,i,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:i,localAddress:r,privacy:f,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,i){(m(t)||l(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const r=this.getTunnelFromMap(t,i);if(r)return++r.refcount,r.value}openTunnel(t,i,r,f,u,v=!1,y,D){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${u}.`);const w=this._tunnelProvider??t;if(!w)return;if(i||(i="localhost"),f||(f=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(r)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.retainOrCreateTunnel(w,i,r,f,u,v,y,D);return P?P.then(k=>{if(k){if(typeof k=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(i,r),k}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(i,r);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.makeTunnel(k);return(k.tunnelRemoteHost!==i||k.tunnelRemotePort!==r)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&k.privacy!==y&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(E),E}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const i=this._tunnels.get(t.tunnelRemoteHost);if(i){const r=i.get(t.tunnelRemotePort);r&&(r.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async tryDisposeTunnel(t,i,r){if(r.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${i}.`);const f=r.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(i),f}}async closeTunnel(t,i){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${i} `);const r=this._tunnels.get(t);if(r&&r.has(i)){const f=r.get(i);f.refcount=0,await this.tryDisposeTunnel(t,i,f)}}addTunnelToMap(t,i,r){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(i,{refcount:1,value:r})}async removeEmptyOrErrorTunnelFromMap(t,i){const r=this._tunnels.get(t);if(r){const f=r.get(i),u=f?await f.value:void 0;(!u||typeof u=="string")&&r.delete(i),r.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,i){const r=[t];l(t)?(r.push(...e.LOCALHOST_ADDRESSES),r.push(...e.ALL_INTERFACES_ADDRESSES)):m(t)&&r.push(...e.ALL_INTERFACES_ADDRESSES);const f=r.map(u=>this._tunnels.get(u));for(const u of f){const v=u?.get(i);if(v)return v}}canTunnel(t){return!!C(t)}createWithProvider(t,i,r,f,u,v,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${f}.`);const D=r;this._factoryInProgress.add(D);const w=f===void 0?r:f,P={elevationRequired:u?this.isPortPrivileged(w):!1},k={remoteAddress:{host:i,port:r},localAddressPort:f,privacy:v,public:v?v!==I.Private:void 0,protocol:y},E=t.forwardPort(k,P);return E?(this.addTunnelToMap(i,r,E),E.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(D)})):this._factoryInProgress.delete(D),E}};e.AbstractTunnelService=n,e.AbstractTunnelService=n=Xe([He(0,p.ILogService),He(1,L.IConfigurationService)],n)}),define(_e[295],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,s.createDecorator)("IUriIdentityService")}),define(_e[296],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,s.createDecorator)("editSessionIdentityService");var d;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(d||(e.EditSessionIdentityMatch=d={}))}),define(_e[297],ye([1,0,15]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=d,e.getVirtualWorkspaceLocation=T,e.getVirtualWorkspaceScheme=R,e.getVirtualWorkspaceAuthority=L,e.isVirtualWorkspace=A;function d(p){return p.scheme!==s.Schemas.file&&p.scheme!==s.Schemas.vscodeRemote}function T(p){if(p.folders.length)return p.folders.every(a=>d(a.uri))?p.folders[0].uri:void 0;if(p.configuration&&d(p.configuration))return p.configuration}function R(p){return T(p)?.scheme}function L(p){return T(p)?.authority}function A(p){return T(p)!==void 0}}),define(_e[46],ye([1,0,233,17,85,23,2,5,15]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=I,e.toWorkspaceIdentifier=_,e.isWorkspaceIdentifier=c,e.reviveIdentifier=C,e.isWorkspace=l,e.isWorkspaceFolder=m,e.toWorkspaceFolder=n,e.isUntitledWorkspace=o,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=i,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=f,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function a(u){const v=u;return typeof v?.id=="string"&&L.URI.isUri(v.uri)}function I(u){return typeof u?.id=="string"&&!a(u)&&!c(u)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function _(u,v){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,d.basename)(u)}:v?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const y=u;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function c(u){const v=u;return typeof v?.id=="string"&&L.URI.isUri(v.configPath)}function C(u){const v=u;if(v?.uri)return{id:v.id,uri:L.URI.revive(v.uri)};const y=u;if(y?.configPath)return{id:y.id,configPath:L.URI.revive(y.configPath)};if(u?.id)return{id:u.id}}var b;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function l(u){const v=u;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}function m(u){const v=u;return!!(v&&typeof v=="object"&&L.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}class h{constructor(v,y,D,w,P){this._id=v,this._transient=D,this._configuration=w,this._ignorePathCasing=P,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=y}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(v,y){this.raw=y,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,R.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function n(u){return new g({uri:u,index:0,name:(0,R.basenameOrAuthority)(u)},{uri:u.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function o(u,v){return R.extUriBiasedIgnorePathCase.isEqualOrParent(u,v.untitledWorkspacesHome)}function t(u){let v;return L.URI.isUri(u)?v=u:v=u.configuration,v?.scheme===p.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(u,v){return!o(u,v)&&!t(u)}function f(u){return(typeof u=="string"?(0,d.extname)(u):(0,R.extname)(u))===e.WORKSPACE_SUFFIX}}),define(_e[151],ye([1,0,60,4,3,23,2,232,145,28,5,12,46,29,295,9,32,13,18]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=o,e.reviveProfile=t,e.toUserDataProfile=i;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const v=u;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&typeof v.isDefault=="boolean"&&typeof v.name=="string"&&L.URI.isUri(v.location)&&L.URI.isUri(v.globalStorageHome)&&L.URI.isUri(v.settingsResource)&&L.URI.isUri(v.keybindingsResource)&&L.URI.isUri(v.tasksResource)&&L.URI.isUri(v.snippetsHome)&&L.URI.isUri(v.extensionsResource))}e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function t(u,v){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:L.URI.revive(u.location).with({scheme:v}),globalStorageHome:L.URI.revive(u.globalStorageHome).with({scheme:v}),settingsResource:L.URI.revive(u.settingsResource).with({scheme:v}),keybindingsResource:L.URI.revive(u.keybindingsResource).with({scheme:v}),tasksResource:L.URI.revive(u.tasksResource).with({scheme:v}),snippetsHome:L.URI.revive(u.snippetsHome).with({scheme:v}),extensionsResource:L.URI.revive(u.extensionsResource).with({scheme:v}),cacheHome:L.URI.revive(u.cacheHome).with({scheme:v}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,v,y,D,w,P){return{id:u,name:v,location:y,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:P&&w?.useDefaultFlags?.globalState?P.globalStorageHome:(0,R.joinPath)(y,"globalStorage"),settingsResource:P&&w?.useDefaultFlags?.settings?P.settingsResource:(0,R.joinPath)(y,"settings.json"),keybindingsResource:P&&w?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,R.joinPath)(y,"keybindings.json"),tasksResource:P&&w?.useDefaultFlags?.tasks?P.tasksResource:(0,R.joinPath)(y,"tasks.json"),snippetsHome:P&&w?.useDefaultFlags?.snippets?P.snippetsHome:(0,R.joinPath)(y,"snippets"),extensionsResource:P&&w?.useDefaultFlags?.extensions?P.extensionsResource:(0,R.joinPath)(y,"extensions.json"),cacheHome:(0,R.joinPath)(D,u),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let r=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(v,y,D,w){super(),this.environmentService=v,this.fileService=y,this.uriIdentityService=D,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new d.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new d.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new d.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new d.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new C.ResourceMap,workspaces:new C.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(v){this.enabled!==v&&(this._profilesObject=void 0,this.enabled=v)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const v=this.createDefaultProfile(),y=[v];if(this.enabled)try{for(const P of this.getStoredProfiles()){if(!P.name||!(0,g.isString)(P.name)||!P.location){this.logService.warn("Skipping the invalid stored profile",P.location||P.name);continue}y.push(i((0,R.basename)(P.location),P.name,P.location,this.profilesCacheHome,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},v))}}catch(P){this.logService.error(P)}const D=new C.ResourceMap,w=new Map;if(y.length)try{const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[k,E]of Object.entries(P.workspaces)){const S=L.URI.parse(k),M=y.find(N=>N.id===E);M&&D.set(S,M)}if(P.emptyWindows)for(const[k,E]of Object.entries(P.emptyWindows)){const S=y.find(M=>M.id===E);S&&w.set(k,S)}}catch(P){this.logService.error(P)}this._profilesObject={profiles:y,workspaces:D,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const v=i("__default__profile__",(0,A.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...v,extensionsResource:this.getDefaultProfileExtensionsLocation()??v.extensionsResource,isDefault:!0}}async createTransientProfile(v){const y="Temp",D=new RegExp(`${(0,h.escapeRegExpCharacters)(y)}\\s(\\d+)`);let w=0;for(const k of this.profiles){const E=D.exec(k.name),S=E?parseInt(E[1]):0;w=S>w?S:w}const P=`${y} ${w+1}`;return this.createProfile((0,s.hash)((0,m.generateUuid)()).toString(16),P,{transient:!0},v)}async createNamedProfile(v,y,D){return this.createProfile((0,s.hash)((0,m.generateUuid)()).toString(16),v,y,D)}async createProfile(v,y,D,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=await this.doCreateProfile(v,y,D);return w&&await this.setProfileForWorkspace(w,P),P}async doCreateProfile(v,y,D){if(!(0,g.isString)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(y);return w||(w=(async()=>{try{if(this.profiles.find(S=>S.name===y||S.id===v))throw new Error(`Profile with ${y} name already exists`);const k=i(v,y,(0,R.joinPath)(this.profilesHome,v),this.profilesCacheHome,D,this.defaultProfile);await this.fileService.createFolder(k.location);const E=[];return this._onWillCreateProfile.fire({profile:k,join(S){E.push(S)}}),await l.Promises.settled(E),this.updateProfiles([k],[],[]),k}finally{this.profileCreationPromises.delete(y)}})(),this.profileCreationPromises.set(y,w)),w}async updateProfile(v,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===v.id);if(!D)throw new Error(`Profile '${v.name}' does not exist`);return D=i(D.id,y.name??D.name,D.location,this.profilesCacheHome,{shortName:y.shortName??D.shortName,icon:y.icon===null?void 0:y.icon??D.icon,transient:y.transient??D.isTransient,useDefaultFlags:y.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[D]),D}async removeProfile(v){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(v.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(w=>w.id===v.id);if(!y)throw new Error(`Profile '${v.name}' does not exist`);const D=[];this._onWillRemoveProfile.fire({profile:y,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])y.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])y.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[y],[]);try{await this.fileService.del(y.cacheHome,{recursive:!0})}catch(w){(0,a.toFileOperationResult)(w)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(w)}}async setProfileForWorkspace(v,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===y.id);if(!D)throw new Error(`Profile '${y.name}' does not exist`);this.updateWorkspaceAssociation(v,D)}unsetWorkspace(v,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(v,void 0,y)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const v=await this.fileService.resolve(this.profilesHome);await Promise.all((v.children||[]).filter(y=>y.isDirectory&&this.profiles.every(D=>!this.uriIdentityService.extUri.isEqual(D.location,y.resource))).map(y=>this.fileService.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const v=this.transientProfilesObject.profiles.filter(y=>!this.isProfileAssociatedToWorkspace(y));await Promise.allSettled(v.map(y=>this.removeProfile(y)))}getProfileForWorkspace(v){const y=this.getWorkspace(v),D=L.URI.isUri(y)?this.profilesObject.workspaces.get(y):this.profilesObject.emptyWindows.get(y);return D||((0,c.isSingleFolderWorkspaceIdentifier)(v)?this.transientProfilesObject.folders.get(v.uri):(0,c.isWorkspaceIdentifier)(v)?this.transientProfilesObject.workspaces.get(v.configPath):this.transientProfilesObject.emptyWindows.get(v.id))}getWorkspace(v){return(0,c.isSingleFolderWorkspaceIdentifier)(v)?v.uri:(0,c.isWorkspaceIdentifier)(v)?v.configPath:v.id}isProfileAssociatedToWorkspace(v){return!!([...this.profilesObject.emptyWindows.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,v.location))||[...this.profilesObject.workspaces.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,v.location))||[...this.transientProfilesObject.emptyWindows.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,v.location))||[...this.transientProfilesObject.workspaces.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,v.location))||[...this.transientProfilesObject.folders.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,v.location)))}updateProfiles(v,y,D){const w=[...this.profiles,...v],P=[],k=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let E of w){if(E.isDefault||y.some(M=>E.id===M.id))continue;E=D.find(M=>E.id===M.id)??E;const S=k.find(M=>E.id===M.id);if(E.isTransient)this.transientProfilesObject.profiles.push(E);else{if(S){for(const[M,N]of this.transientProfilesObject.emptyWindows.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:M},E);break}for(const[M,N]of this.transientProfilesObject.workspaces.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:"",configPath:M},E);break}for(const[M,N]of this.transientProfilesObject.folders.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:"",uri:M},E);break}}P.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(v,y,D)}triggerProfilesChanges(v,y,D){this._onDidChangeProfiles.fire({added:v,removed:y,updated:D,all:this.profiles})}updateWorkspaceAssociation(v,y,D){if(D=y?.isTransient?!0:D,D)(0,c.isSingleFolderWorkspaceIdentifier)(v)?(this.transientProfilesObject.folders.delete(v.uri),y&&this.transientProfilesObject.folders.set(v.uri,y)):(0,c.isWorkspaceIdentifier)(v)?(this.transientProfilesObject.workspaces.delete(v.configPath),y&&this.transientProfilesObject.workspaces.set(v.configPath,y)):(this.transientProfilesObject.emptyWindows.delete(v.id),y&&this.transientProfilesObject.emptyWindows.set(v.id,y));else{this.updateWorkspaceAssociation(v,void 0,!0);const w=this.getWorkspace(v);L.URI.isUri(w)?(this.profilesObject.workspaces.delete(w),y&&this.profilesObject.workspaces.set(w,y)):(this.profilesObject.emptyWindows.delete(w),y&&this.profilesObject.emptyWindows.set(w,y)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const v={};for(const[D,w]of this.profilesObject.workspaces.entries())v[D.toString()]=w.id;const y={};for(const[D,w]of this.profilesObject.emptyWindows.entries())y[D.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:v,emptyWindows:y}),this._profilesObject=void 0}migrateStoredProfileAssociations(v){const y={},D=this.createDefaultProfile();if(v.workspaces)for(const[P,k]of Object.entries(v.workspaces)){const E=L.URI.parse(k);y[P]=this.uriIdentityService.extUri.isEqual(E,D.location)?D.id:this.uriIdentityService.extUri.basename(E)}const w={};if(v.emptyWindows)for(const[P,k]of Object.entries(v.emptyWindows)){const E=L.URI.parse(k);w[P]=this.uriIdentityService.extUri.isEqual(E,D.location)?D.id:this.uriIdentityService.extUri.basename(E)}return{workspaces:y,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(v){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(v){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Xe([He(0,p.IEnvironmentService),He(1,a.IFileService),He(2,b.IUriIdentityService),He(3,_.ILogService)],r);class f extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(v){this.storedProfiles=v}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(v){this.storedProfileAssociations=v}}e.InMemoryUserDataProfilesService=f}),define(_e[152],ye([1,0,9,4,3,62,18,210,5,151]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=C,e.isProfileUsingDefaultStorage=l,e.logStorage=h,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var _;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(_||(e.StorageScope=_={}));var c;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(c||(e.StorageTarget=c={}));function C(g){const n=g.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class b extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new d.PauseableEmitter),this._onDidChangeTarget=this._register(new d.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new d.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new s.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,o,t){return d.Event.filter(this._onDidChangeValue.event,i=>i.scope===n&&(o===void 0||i.key===o),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,s.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,o){const{key:t,external:i}=o;if(t===e.TARGET_KEY){switch(n){case _.APPLICATION:this._applicationKeyTargets=void 0;break;case _.PROFILE:this._profileKeyTargets=void 0;break;case _.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:t,target:this.getKeyTargets(n)[t],external:i})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,o,t){return this.getStorage(o)?.get(n,t)}getBoolean(n,o,t){return this.getStorage(o)?.getBoolean(n,t)}getNumber(n,o,t){return this.getStorage(o)?.getNumber(n,t)}getObject(n,o,t){return this.getStorage(o)?.getObject(n,t)}storeAll(n,o){this.withPausedEmitters(()=>{for(const t of n)this.store(t.key,t.value,t.scope,t.target,o)})}store(n,o,t,i,r=!1){if((0,L.isUndefinedOrNull)(o)){this.remove(n,t,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,t,i),this.getStorage(t)?.set(n,o,r)})}remove(n,o,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,o,void 0),this.getStorage(o)?.delete(n,t)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,o){const t=[],i=this.getKeyTargets(n);for(const r of Object.keys(i))i[r]===o&&t.push(r);return t}updateKeyTarget(n,o,t,i=!1){const r=this.getKeyTargets(o);typeof t=="number"?r[n]!==t&&(r[n]=t,this.getStorage(o)?.set(e.TARGET_KEY,JSON.stringify(r),i)):typeof r[n]=="number"&&(delete r[n],this.getStorage(o)?.set(e.TARGET_KEY,JSON.stringify(r),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(_.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(_.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(_.APPLICATION)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case _.APPLICATION:return this.applicationKeyTargets;case _.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const o=this.getStorage(n);return o?C(o):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=I.NONE){this._onWillSaveState.fire({reason:n});const o=this.getStorage(_.APPLICATION),t=this.getStorage(_.PROFILE),i=this.getStorage(_.WORKSPACE);switch(n){case I.NONE:await s.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await s.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(_.APPLICATION)?.items??new Map,o=this.getStorage(_.PROFILE)?.items??new Map,t=this.getStorage(_.WORKSPACE)?.items??new Map;return h(n,o,t,this.getLogDetails(_.APPLICATION)??"",this.getLogDetails(_.PROFILE)??"",this.getLogDetails(_.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,o){return this.emitWillSaveState(I.NONE),(0,a.isUserDataProfile)(n)?this.switchToProfile(n,o):this.switchToWorkspace(n,o)}canSwitchProfile(n,o){return!(n.id===o.id||l(o)&&l(n))}switchData(n,o,t){this.withPausedEmitters(()=>{const i=new Set;for(const[r,f]of n)i.add(r),o.get(r)!==f&&this.emitDidChangeValue(t,{key:r,external:!0});for(const[r]of o.items)i.has(r)||this.emitDidChangeValue(t,{key:r,external:!0})})}}e.AbstractStorageService=b;function l(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class m extends b{constructor(){super(),this.applicationStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(_.WORKSPACE,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(_.PROFILE,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(_.APPLICATION,n)))}getStorage(n){switch(n){case _.APPLICATION:return this.applicationStorage;case _.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case _.APPLICATION:return"inMemory (application)";case _.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=m;async function h(g,n,o,t,i,r){const f=S=>{try{return JSON.parse(S)}catch{return S}},u=new Map,v=new Map;g.forEach((S,M)=>{u.set(M,S),v.set(M,f(S))});const y=new Map,D=new Map;n.forEach((S,M)=>{y.set(M,S),D.set(M,f(S))});const w=new Map,P=new Map;o.forEach((S,M)=>{w.set(M,S),P.set(M,f(S))}),console.group(t!==i?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const k=[];if(u.forEach((S,M)=>{k.push({key:M,value:S})}),console.table(k),console.groupEnd(),console.log(v),t!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const S=[];y.forEach((M,N)=>{S.push({key:N,value:M})}),console.table(S),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${r})`);const E=[];w.forEach((S,M)=>{E.push({key:M,value:S})}),console.table(E),console.groupEnd(),console.log(P)}}),define(_e[119],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{static{this.enableDebugLogging=!1}constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const R=this._idPool++;return this._data.set(R,T),this.logDebugInfo(),R}get(T,R){return this._data.has(T)?this._data.get(T)[R]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){s.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s}),define(_e[63],ye([1,0,15,23,28,5]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new d.ExtUri(p=>{const a=this._providerInfo.get(p.scheme);return!(a===void 0||a&T.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,a){a===null?this._providerInfo.delete(p.scheme):this._providerInfo.set(p.scheme,a)}isFreeScheme(p){return!this._providerInfo.has(p)&&!this._systemSchemes.has(p)}getCapabilities(p){return this._providerInfo.get(p)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(_e[30],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(_e[298],ye([1,0,238,12,278,30]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends T.LogService{constructor(p,a,I){const _=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",c=I.remote.isRemote?(0,s.localize)(0,null):p?(0,s.localize)(1,null):(0,s.localize)(2,null);super(a.createLogger(_,{name:c}))}};e.ExtHostLogService=L,e.ExtHostLogService=L=Xe([He(1,d.ILoggerService),He(2,R.IExtHostInitDataService)],L)}),define(_e[299],ye([1,0,9]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class d{constructor(L,A,p){this._deferredPromises=new Map,this._id=L,this._shared=A,this._storage=p,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(a=>(this._value=a,this)),this._storageListener=this._storage.onDidChangeStorage(a=>{a.shared===this._shared&&a.key===this._id&&(this._value=a.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const a=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const I of a.values())I.complete()}catch(I){for(const _ of a.values())_.error(I)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this._init}get(L,A){let p=this._value[L];return typeof p>"u"&&(p=A),p}update(L,A){this._value[L]=A;const p=this._deferredPromises.get(L);if(p!==void 0)return p.p;const a=new s.DeferredPromise;return this._deferredPromises.set(L,a),this._scheduler.isScheduled()||this._scheduler.schedule(),a.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=d;class T extends d{setKeysForSync(L){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},L)}constructor(L,A){super(L.identifier.value,!0,A),this._extension=L}}e.ExtensionGlobalMemento=T}),define(_e[300],ye([1,0,4,2]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(L){this._notebooksAndEditors=L,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new s.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(L,A,p,a){const _=this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L)).acceptModelChanged(A.value,p,a);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(L,A){this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L)).acceptDirty(A)}$acceptModelSaved(L){const A=this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(_e[20],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class d{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=d}),define(_e[301],ye([1,0,24,4,3]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{#e;constructor(A,p){this.disposables=new T.DisposableStore,this._id=s.ExtensionIdentifier.toKey(A.identifier),this.#e=p,this.onDidChange=d.Event.map(d.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this._id),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(A){return this.#e.get(this._id,A)}store(A,p){return this.#e.store(this._id,A,p)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=R}),define(_e[73],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class d{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.URITransformerService=d}),define(_e[302],ye([1,0,303,413,414,67,2,12,415]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=I,s=ze(s),d=ze(d),T=ze(T),R=ze(R);const a=!1;function I(n,o,t,i,r,f){const u=f.environment.useHostProxy,v=typeof u=="boolean"?u:!f.remote.isRemote,y={resolveProxy:P=>n.resolveProxy(P),lookupProxyAuthorization:m.bind(void 0,i,r,o,{},f.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>o.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>c(o),addCertificatesV2:()=>C(o),log:i,getLogLevel:()=>{const P=i.getLevel();switch(P){case A.LogLevel.Trace:return p.LogLevel.Trace;case A.LogLevel.Debug:return p.LogLevel.Debug;case A.LogLevel.Info:return p.LogLevel.Info;case A.LogLevel.Warning:return p.LogLevel.Warning;case A.LogLevel.Error:return p.LogLevel.Error;case A.LogLevel.Off:return p.LogLevel.Off;default:return k(P)}function k(E){return i.error("Unknown log level",E),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:v,loadAdditionalCertificates:async()=>{const P=[];if(f.remote.isRemote&&P.push((0,p.loadSystemCertificates)({log:i})),v){i.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=n.loadCertificates();k.then(E=>i.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),P.push(k)}return f.environment.extensionTestsLocationURI&&d.globalAgent.testCertificates?.length&&(i.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),P.push(Promise.resolve(d.globalAgent.testCertificates))),(await Promise.all(P)).flat()},env:process.env},D=(0,p.createProxyResolver)(y),w=_(y,D);return l(t,w)}function _(n,o){function t(i,r){return Object.assign(i.default||i,r)}return{http:t(s,(0,p.createHttpPatch)(n,s,o)),https:t(d,(0,p.createHttpPatch)(n,d,o)),net:t(R,(0,p.createNetPatch)(n,R)),tls:t(T,(0,p.createTlsPatch)(n,T))}}function c(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}function C(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",a)&&!!o.get("systemCertificates")}const b=new Map;function l(n,o){return n.getExtensionPathIndex().then(t=>{const i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(u,v,y){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const D=t.findSubstr(L.URI.file(v.filename));let w=b.get(D);if(w||b.set(D,w={}),!w[u]){const P=o[u];w[u]={...P}}return w[u]}})}async function m(n,o,t,i,r,f,u,v){const y=i[f];u&&(i[f]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${f}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${y}`);const D=u||y,w=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(g(o,w,r),w.some(P=>/^(Negotiate|Kerberos)( |$)/i.test(P))&&!v.kerberosRequested)try{v.kerberosRequested=!0;const P=await new Promise((N,O)=>{le(["kerberos"],N,O)}).then(ze),k=new URL(f),E=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${f}`,`spn:${E}`),"Negotiate "+await(await P.initializeClient(E)).step("")}catch(P){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",P)}}let h=!1;function g(n,o,t){h||!o.length||(h=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(i=>i.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(_e[304],ye([1,0,142]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=T;function d(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function T(R){return new s.URITransformer(d(R))}});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[153],ye([1,0,248,18,2,3,5,37,28,15,51,202,44]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=l,e.isEditorPaneWithScrolling=m,e.findViewStateForEditor=h,e.isResourceEditorInput=g,e.isResourceDiffEditorInput=n,e.isResourceMultiDiffEditorInput=o,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=i,e.isResourceMergeEditorInput=r,e.isEditorInput=w,e.isSideBySideEditorInput=k,e.isDiffEditorInput=E,e.createTooLargeFileError=S,e.isEditorInputWithOptions=M,e.isEditorInputWithOptionsAndGroup=N,e.isEditorIdentifier=O,e.isEditorCommandsContext=x,e.preventEditorClose=B,e.pathsToEditors=ee,e.isTextEditorViewState=ne,e.isEditorOpenError=De,e.createEditorOpenError=pe,c=xt(c),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var b;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function l(G){const W=G;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function m(G){const W=G;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function h(G,W,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===W&&G.matches(ae.input))return ae.getViewState()}function g(G){if(w(G))return!1;const W=G;return T.URI.isUri(W?.resource)}function n(G){if(w(G))return!1;const W=G;return W?.original!==void 0&&W.modified!==void 0}function o(G){if(w(G))return!1;const W=G;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(G){if(w(G)||n(G))return!1;const W=G;return W?.primary!==void 0&&W.secondary!==void 0}function i(G){if(w(G))return!1;const W=G;return W?W.resource===void 0||W.resource.scheme===a.Schemas.untitled||W.forceUntitled===!0:!1}function r(G){if(w(G))return!1;const W=G;return T.URI.isUri(W?.base?.resource)&&T.URI.isUri(W?.input1?.resource)&&T.URI.isUri(W?.input2?.resource)&&T.URI.isUri(W?.result?.resource)}var f;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class v{constructor(){this.mapIdToSaveSource=new Map}registerSource(W,se){let ae=this.mapIdToSaveSource.get(W);return ae||(ae={source:W,label:se},this.mapIdToSaveSource.set(W,ae)),ae.source}getSourceLabel(W){return this.mapIdToSaveSource.get(W)?.label??W}}e.SaveSourceRegistry=new v;var y;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors",G[G.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class D extends R.Disposable{}e.AbstractEditorInput=D;function w(G){return G instanceof D}function P(G){const W=G;return T.URI.isUri(W?.preferredResource)}function k(G){const W=G;return w(W?.primary)&&w(W?.secondary)}function E(G){const W=G;return w(W?.modified)&&w(W?.original)}function S(G,W,se,ae,te){return pe(ae,[(0,_.toAction)({id:"workbench.action.openLargeFile",label:(0,s.localize)(2,null),run:()=>{const ce={...se,limits:{size:Number.MAX_VALUE}};G.openEditor(W,ce)}}),(0,_.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}function M(G){return w(G?.editor)}function N(G){const W=G;return M(G)&&W?.group!==void 0}function O(G){const W=G;return typeof W?.groupId=="number"&&w(W.editor)}function x(G){return typeof G?.groupId=="number"}var U;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var F;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LABEL=2]="GROUP_LABEL",G[G.GROUP_LOCKED=3]="GROUP_LOCKED",G[G.EDITORS_SELECTION=4]="EDITORS_SELECTION",G[G.EDITOR_OPEN=5]="EDITOR_OPEN",G[G.EDITOR_CLOSE=6]="EDITOR_CLOSE",G[G.EDITOR_MOVE=7]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=9]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=11]="EDITOR_PIN",G[G.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",G[G.EDITOR_STICKY=13]="EDITOR_STICKY",G[G.EDITOR_DIRTY=14]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var H;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(H||(e.SideBySideEditor=H={}));class j{getOriginalUri(W,se){if(!W)return;if(r(W))return e.EditorResourceAccessor.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.getSideEditors(W);if(te&&ce){if(se?.supportSideBySide===H.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===H.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===H.PRIMARY?te:ce}}if(n(W)||o(W)||t(W)||r(W))return;const ae=P(W)?W.preferredResource:W.resource;return!ae||!se||!se.filterByScheme?ae:this.filterUri(ae,se.filterByScheme)}getSideEditors(W){return k(W)||t(W)?{primary:W.primary,secondary:W.secondary}:E(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(r(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.getSideEditors(W);if(te&&ce){if(se?.supportSideBySide===H.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===H.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===H.PRIMARY?te:ce}}if(n(W)||o(W)||t(W)||r(W))return;const ae=W.resource;return!ae||!se||!se.filterByScheme?ae:this.filterUri(ae,se.filterByScheme)}filterUri(W,se){if(Array.isArray(se)){if(se.some(ae=>W.scheme===ae))return W}else if(se===W.scheme)return W}}var re;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.KEYBOARD=1]="KEYBOARD",G[G.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function B(G,W,se,ae){if(!G.isSticky(W))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.EditorResourceAccessor=new j;var V;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class X{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(W){const se=this.instantiationService=W.get(L.IInstantiationService);for(const[ae,te]of this.editorSerializerConstructors)this.createEditorSerializer(ae,te,se);this.editorSerializerConstructors.clear()}createEditorSerializer(W,se,ae){const te=ae.createInstance(se);this.editorSerializerInstances.set(W,te)}registerFileEditorFactory(W){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=W}getFileEditorFactory(){return(0,d.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(W,se){if(this.editorSerializerConstructors.has(W)||this.editorSerializerInstances.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.instantiationService?this.createEditorSerializer(W,se,this.instantiationService):this.editorSerializerConstructors.set(W,se),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(W),this.editorSerializerInstances.delete(W)})}getEditorSerializer(W){return this.editorSerializerInstances.get(typeof W=="string"?W:W.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new X);async function ee(G,W,se){return!G||!G.length?[]:await Promise.all(G.map(async ae=>{const te=T.URI.revive(ae.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let ue=ae.exists,Y=ae.type;if(typeof ue!="boolean"||typeof Y!="number")try{Y=(await W.stat(te)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ue=!0}catch(ve){se.error(ve),ue=!1}if(!ue&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(Y===p.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return ue?{resource:te,options:oe}:{resource:te,options:oe,forceUntitled:!0}}))}var he;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ne(G){const W=G;if(!W)return!1;const se=W;if(se.modified)return ne(se.modified);const ae=W;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function De(G){return(0,I.isErrorWithActions)(G)}function pe(G,W,se){const ae=(0,I.createErrorWithActions)(G,W);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(_e[305],ye([1,0,4,249,5,3,29,37,25,83,294]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=C,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,d.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",a.Codicon.window,(0,d.localize)(1,null));var _;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(_||(e.Extensions=_={}));var c;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(c||(e.ViewContainerLocation=c={})),e.ViewContainerLocations=[c.Sidebar,c.Panel,c.AuxiliaryBar];function C(i){switch(i){case c.Sidebar:return"sidebar";case c.Panel:return"panel";case c.AuxiliaryBar:return"auxiliarybar"}}class b extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new s.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new s.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(r,f,u){const v=this.get(r.id);if(v)return v;const y=r;return y.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,L.getOrSet)(this.viewContainers,f,[]).push(y),u?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:f}),y}deregisterViewContainer(r){for(const f of this.viewContainers.keys()){const u=this.viewContainers.get(f),v=u?.indexOf(r);if(v!==-1){u?.splice(v,1),u.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:r,viewContainerLocation:f});return}}}get(r){return this.all.filter(f=>f.id===r)[0]}getViewContainers(r){return[...this.viewContainers.get(r)||[]]}getViewContainerLocation(r){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===r)}}A.Registry.add(_.ViewContainersRegistry,new b);var l;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(l||(e.ViewContentGroups=l={}));function m(i,r){const f=i.group??l.More,u=r.group??l.More;return f!==u?f.localeCompare(u):(i.order??5)-(r.order??5)}class h extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new s.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new s.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new s.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new s.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new L.SetMap}registerViews(r,f){this.registerViews2([{views:r,viewContainer:f}])}registerViews2(r){r.forEach(({views:f,viewContainer:u})=>this.addViews(f,u)),this._onViewsRegistered.fire(r)}deregisterViews(r,f){const u=this.removeViews(r,f);u.length&&this._onViewsDeregistered.fire({views:u,viewContainer:f})}moveViews(r,f){for(const u of this._views.keys())if(u!==f){const v=this.removeViews(r,u);v.length&&(this.addViews(v,f),this._onDidChangeContainer.fire({views:v,from:u,to:f}))}}getViews(r){return this._views.get(r)||[]}getView(r){for(const f of this._viewContainers){const u=(this._views.get(f)||[]).filter(v=>v.id===r)[0];if(u)return u}return null}getViewContainer(r){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(v=>v.id===r)[0])return f;return null}registerViewWelcomeContent(r,f){return this._viewWelcomeContents.add(r,f),this._onDidChangeViewWelcomeContent.fire(r),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(r,f),this._onDidChangeViewWelcomeContent.fire(r)})}registerViewWelcomeContent2(r,f){const u=new Map;for(const[v,y]of f)this._viewWelcomeContents.add(r,y),u.set(v,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(r,y),this._onDidChangeViewWelcomeContent.fire(r)}));return this._onDidChangeViewWelcomeContent.fire(r),u}getViewWelcomeContent(r){const f=[];return this._viewWelcomeContents.forEach(r,u=>f.push(u)),f.sort(m)}addViews(r,f){let u=this._views.get(f);u||(u=[],this._views.set(f,u),this._viewContainers.push(f));for(const v of r){if(this.getView(v.id)!==null)throw new Error((0,d.localize)(2,null,v.id));u.push(v)}}removeViews(r,f){const u=this._views.get(f);if(!u)return[];const v=[],y=[];for(const D of u)r.includes(D)?v.push(D):y.push(D);return v.length&&(y.length?this._views.set(f,y):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),v}}A.Registry.add(_.ViewsRegistry,new h),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var g;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(g||(e.ViewVisibilityState=g={}));var n;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(r,f){this.resolved=!1,this._hasResolve=!1,(0,p.mixin)(this,r),this._hasResolve=!!f,this.resolve=async u=>{if(f&&!this.resolved){const v=await f(u);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}u.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o;class t extends Error{constructor(r){super((0,d.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(_e[306],ye([1,0,250,36]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new d.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new d.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new d.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new d.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new d.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4,null)}),e.CONTEXT_RESPONSE=new d.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,s.localize)(5,null)}),e.CONTEXT_REQUEST=new d.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,s.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new d.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new d.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new d.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new d.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,s.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new d.RawContextKey("inChat",!1,{type:"boolean",description:(0,s.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new d.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new d.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new d.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new d.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new d.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,s.localize)(13,null)})}),define(_e[307],ye([1,0,132,9,21,4,40,3,57,181,13,36,24,5,12,116,287,152,306]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=f,e.reviveSerializedAgent=u;var o;(function(v){v.Panel="panel",v.Terminal="terminal",v.Notebook="notebook",v.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(v){function y(D){switch(D){case"panel":return v.Panel;case"terminal":return v.Terminal;case"notebook":return v.Notebook;case"editor":return v.Editor}return v.Panel}v.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.IChatAgentService=(0,C.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(y){this.contextKeyService=y,this._agents=new Map,this._onDidChangeAgents=new R.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=g.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(y,D){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const P=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(S=>!S.when||P.contextKeyService.contextMatchesRules(_.ContextKeyExpr.deserialize(S.when)))}};const E={data:D};return this._agents.set(y,E),(0,A.toDisposable)(()=>{this._agents.delete(y),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(y,D){const w=this._agents.get(y);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return w.data.isDefault&&this._hasDefaultAgent.set(!0),w.impl=D,this._onDidChangeAgents.fire(new i(w.data,D)),(0,A.toDisposable)(()=>{w.impl=void 0,this._onDidChangeAgents.fire(void 0),w.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(y,D){y.isDynamic=!0;const w={data:y,impl:D};return this._agents.set(y.id,w),this._onDidChangeAgents.fire(new i(y,D)),(0,A.toDisposable)(()=>{this._agents.delete(y.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(y,D){return this._agentCompletionProviders.set(y,D),{dispose:()=>{this._agentCompletionProviders.delete(y)}}}async getAgentCompletionItems(y,D,w){return await this._agentCompletionProviders.get(y)?.(D,w)??[]}updateAgent(y,D){const w=this._agents.get(y);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);w.data.metadata={...w.data.metadata,...D},this._onDidChangeAgents.fire(new i(w.data,w.impl))}getDefaultAgent(y){return(0,s.findLast)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(y))}getSecondaryAgent(){return L.Iterable.find(this._agents.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this._agentIsEnabled(y))return this._agents.get(y)?.data}_agentIsEnabled(y){const D=this._agents.get(y);return!D?.data.when||this.contextKeyService.contextMatchesRules(_.ContextKeyExpr.deserialize(D.data.when))}getAgentByFullyQualifiedId(y){const D=L.Iterable.find(this._agents.values(),w=>f(w.data)===y)?.data;if(!(D&&!this._agentIsEnabled(D.id)))return D}getAgents(){return Array.from(this._agents.values()).map(y=>y.data).filter(y=>this._agentIsEnabled(y.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(y=>!!y.impl).filter(y=>this._agentIsEnabled(y.data.id)).map(y=>new i(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(D=>D.name===y)}agentHasDupeName(y){const D=this.getAgent(y);return D?this.getAgentsByName(D.name).filter(w=>w.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(y,D,w,P,k){const E=this._agents.get(y);if(!E?.impl)throw new Error(`No activated agent with id "${y}"`);return await E.impl.invoke(D,w,P,k)}async getFollowups(y,D,w,P,k){const E=this._agents.get(y);if(!E?.impl)throw new Error(`No activated agent with id "${y}"`);return E.impl?.provideFollowups?E.impl.provideFollowups(D,w,P,k):[]}};e.ChatAgentService=t,e.ChatAgentService=t=Xe([He(0,_.IContextKeyService)],t);class i{constructor(y,D){this.data=y,this.impl=D}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(y,D,w,P){return this.impl.invoke(y,D,w,P)}async provideFollowups(y,D,w,P){return this.impl.provideFollowups?this.impl.provideFollowups(y,D,w,P):[]}provideWelcomeMessage(y,D){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(y,D)}provideSampleQuestions(y,D){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(y,D)}}e.MergedChatAgent=i,e.IChatAgentNameService=(0,C.createDecorator)("chatAgentNameService");let r=class{static{n=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(y,D,w,P){if(this.requestService=D,this.logService=w,this.storageService=P,this.registry=(0,a.observableValue)(this,Object.create(null)),this.disposed=!1,!y.chatParticipantRegistry)return;this.url=y.chatParticipantRegistry;const k=P.get(n.StorageKey,h.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(k??"{}"),void 0)}catch{P.remove(n.StorageKey,h.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(y=>this.logService.warn("Failed to fetch chat participant registry",y)).then(()=>(0,d.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const y=await this.requestService.request({type:"GET",url:this.url},T.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.asJson)(y);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const w=D.restrictedChatParticipants;this.registry.set(w,void 0),this.storageService.store(n.StorageKey,JSON.stringify(w),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}getAgentNameRestriction(y){const D=this.checkAgentNameRestriction(y.name,y).get(),w=!y.fullName||this.checkAgentNameRestriction(y.fullName.replace(/\s/g,""),y).get();return D&&w}checkAgentNameRestriction(y,D){return this.registry.map(P=>P[y.toLowerCase()]).map(P=>P?P.some(k=>(0,I.equalsIgnoreCase)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=r,e.ChatAgentNameService=r=n=Xe([He(0,l.IProductService),He(1,m.IRequestService),He(2,b.ILogService),He(3,h.IStorageService)],r);function f(v){return`${v.extensionId.value}.${v.id}`}function u(v){const y="name"in v?v:{...v,name:v.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new c.ExtensionIdentifier("")),(0,p.revive)(y)}}),define(_e[308],ye([1,0,2,31,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.isIDocumentContext=R,e.isIUsedContext=L;function R(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof s.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(d.Range.isIRange)}function L(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(R)}var A;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(A||(e.ChatAgentVoteDirection=A={}));var p;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.IChatService=(0,T.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(_e[154],ye([1,0,4,9,252]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,p,a,I){const _={command:A};if(p&&Object.keys(p).length>0&&(_.arguments=p),this.internalSend("request",_),typeof I=="number"){const c=setTimeout(()=>{clearTimeout(c);const C=this.pendingRequests.get(_.seq);if(C){this.pendingRequests.delete(_.seq);const b={type:"response",seq:0,request_seq:_.seq,success:!1,command:A,message:(0,T.localize)(0,null,I,A)};C(b)}},I)}return a&&this.pendingRequests.set(_.seq,a),_.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,p){return A.type!=="event"||p.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,d.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const p=A,a=this.pendingRequests.get(p.request_seq);a&&(this.pendingRequests.delete(p.request_seq),a(p));break}}}}internalSend(A,p){p.type=A,p.seq=this.sequence++,this.sendMessage(p)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((p,a)=>A.set(a,p)),await(0,d.timeout)(500),A.forEach((p,a)=>{p({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(a)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(_e[120],ye([1,0,2,253,36,5]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=p,e.isFrameDeemphasized=I,d=ze(d),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:d.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:d.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:d.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:d.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:d.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:d.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:d.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:d.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:d.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:d.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:d.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:d.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:d.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:d.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:d.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:d.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:d.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:d.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:d.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:d.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:d.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:d.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new T.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:d.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new T.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:d.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:d.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:d.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:d.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:d.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new T.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:d.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:d.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:d.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:d.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:d.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:d.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:d.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:d.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:d.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:d.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:d.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new T.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:d.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:d.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:d.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:d.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:d.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:d.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:d.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:d.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:d.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new T.RawContextKey("variableValue",!1,{type:"string",description:d.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new T.RawContextKey("variableType",!1,{type:"string",description:d.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new T.RawContextKey("variableInterfaces",!1,{type:"array",description:d.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new T.RawContextKey("variableName",!1,{type:"string",description:d.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new T.RawContextKey("variableLanguage",!1,{type:"string",description:d.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new T.RawContextKey("variableExtensionId",!1,{type:"string",description:d.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:d.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:d.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:d.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:d.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:d.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:d.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:d.localize(60,null)});const L=n=>d.localize(61,null,n);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:d.localize(62,null)};var A;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(A||(e.State=A={}));function p(n){switch(n){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var a;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var _;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(_||(e.DataBreakpointSetType=_={}));var c;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(c||(e.DebugConfigurationProviderTriggerKind=c={}));var C;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.IDebugService=(0,R.createDecorator)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var l;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(l||(e.DebugVisualizationType=l={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var h;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(h||(e.IDebugVisualizationTreeItem=h={}));var g;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:s.URI.revive(o.iconPath.light),dark:s.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(g||(e.IDebugVisualization=g={}))}),define(_e[309],ye([1,0,13,2,17,25,15,31,21,19]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=_,e.filterExceptionsFromTelemetry=c,e.isSessionAttach=C,e.getExtensionHostDebugSession=b,e.isDebuggerMainContribution=l,e.getExactExpressionStartAndEnd=m,e.getEvaluatableExpressionAtPosition=h,e.isUri=n,e.convertToDAPaths=i,e.convertToVSCPaths=r,e.getVisibleAndSorted=u,e.saveAllBeforeDebugStart=y;const I=/{([^}]+)}/g;function _(w,P,k){return w.replace(I,function(E,S){return P&&S.length>0&&S[0]!=="_"?E:k&&k.hasOwnProperty(S)?k[S]:E})}function c(w){const P={};for(const k of Object.keys(w))k.startsWith("!")||(P[k]=w[k]);return P}function C(w){return w.configuration.request==="attach"&&!b(w)&&(!w.parentSession||C(w.parentSession))}function b(w){let P=w.configuration.type;if(P)return P==="vslsShare"&&(P=w.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(P,"extensionhost")||(0,s.equalsIgnoreCase)(P,"pwa-extensionhost")?w:w.parentSession?b(w.parentSession):void 0}function l(w){return w.type&&(w.label||w.program||w.runtime)}function m(w,P,k){let E,S=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(w);){const O=N.index+1,x=O+N[0].length;if(O<=P&&x>=k){E=N[0],S=O;break}}if(E){const O=/\w+/g;let x=null;for(;(x=O.exec(E))&&!(x.index+1+S+x[0].length>=k););x&&(E=E.substring(0,O.lastIndex))}return E?{start:S,end:S+E.length-1}:{start:0,end:0}}async function h(w,P,k,E){if(w.evaluatableExpressionProvider.has(P)){const S=w.evaluatableExpressionProvider.ordered(P),M=(0,a.coalesce)(await Promise.all(S.map(async N=>{try{return await N.provideEvaluatableExpression(P,k,E??p.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const O=M[0].range;return N||(N=P.getLineContent(k.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const S=P.getLineContent(k.lineNumber),{start:M,end:N}=m(S,k.column,k.column),O=S.substring(M-1,N);return{matchingExpression:O,range:new A.Range(k.lineNumber,M,k.lineNumber,M+O.length)}}return null}const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(w){return!!(w&&w.match(g))}function o(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(n(w.path))return d.URI.parse(w.path);if((0,T.isAbsolute)(w.path))return d.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const P=d.URI.revive(w.path);if(P)return P.scheme===L.Schemas.file?P.fsPath:P.toString()}return w.path}function i(w,P){const k=P?o:t,E=(0,R.deepClone)(w);return f(E,(S,M)=>{S&&M&&(M.path=k(M))}),E}function r(w,P){const k=P?o:t,E=(0,R.deepClone)(w);return f(E,(S,M)=>{!S&&M&&(M.path=k(M))}),E}function f(w,P){switch(w.type){case"event":{const k=w;switch(k.event){case"output":P(!1,k.body.source);break;case"loadedSource":P(!1,k.body.source);break;case"breakpoint":P(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=w;switch(k.command){case"setBreakpoints":P(!0,k.arguments.source);break;case"breakpointLocations":P(!0,k.arguments.source);break;case"source":P(!0,k.arguments.source);break;case"gotoTargets":P(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(E=>P(!1,E));break;default:break}break}case"response":{const k=w;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(E=>P(!1,E.source));break;case"loadedSources":k.body.sources.forEach(E=>P(!1,E));break;case"scopes":k.body.scopes.forEach(E=>P(!1,E.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(E=>P(!1,E.source));break;case"setBreakpoints":k.body.breakpoints.forEach(E=>P(!1,E.source));break;case"disassemble":k.body?.instructions.forEach(S=>P(!1,S.location));break;default:break}break}}}function u(w){return w.filter(P=>!P.presentation?.hidden).sort((P,k)=>P.presentation?k.presentation?P.presentation.group?k.presentation.group?P.presentation.group!==k.presentation.group?P.presentation.group.localeCompare(k.presentation.group):v(P.presentation.order,k.presentation.order):-1:k.presentation.group?1:v(P.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function v(w,P){return typeof w!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:w-P}async function y(w,P){const k=w.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(k!=="none"&&(await P.saveAll(),k==="allEditorsInActiveGroup")){const E=P.activeEditorPane;E&&E.input.resource?.scheme===L.Schemas.untitled&&await P.save({editor:E.input,groupId:E.group.id})}await w.reloadConfiguration()}const D=(w,P)=>!w||!P?w===P:w.name===P.name&&w.path===P.path&&w.sourceReference===P.sourceReference;e.sourcesEqual=D}),define(_e[310],ye([1,0,58,67,25,17,11,13,34,254,154]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0,s=ze(s),d=ze(d),T=ze(T),R=ze(R),L=ze(L),A=ze(A),a=ze(a);class _ extends I.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(h,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,h.on("data",n=>this.handleData(n))}sendMessage(h){if(this.outputStream){const g=JSON.stringify(h);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${_.TWO_CRLF}${g}`,"utf8")}}handleData(h){for(this.rawData=Buffer.concat([this.rawData,h]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+g))}continue}}else{const g=this.rawData.indexOf(_.TWO_CRLF);if(g!==-1){const o=this.rawData.toString("utf8",0,g).split(_.HEADER_LINESEPARATOR);for(const t of o){const i=t.split(_.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(g+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_;class c extends _{startSession(){return new Promise((h,g)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),h(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",o=>{n?this._onError.fire(o):g(o)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=c;class C extends c{constructor(h){super(),this.adapterServer=h}createConnection(h){return d.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",h)}}e.SocketDebugAdapter=C;class b extends c{constructor(h){super(),this.adapterServer=h}createConnection(h){return d.createConnection(this.adapterServer.path,h)}}e.NamedPipeDebugAdapter=b;class l extends _{constructor(h,g){super(),this.adapterExecutable=h,this.debugType=g}async startSession(){const h=this.adapterExecutable.command,g=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(h)if(R.isAbsolute(h)){if(!await p.Promises.exists(h))throw new Error(a.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(a.localize(1,null,this.debugType));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=T.mixin(T.deepClone(process.env),n.env)),h==="node")if(Array.isArray(g)&&g.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(i.cwd=n.cwd);const r=s.fork(g[0],g.slice(1),i);if(!r.pid)throw new Error(a.localize(2,null,g[0]));this.serverProcess=r}else throw new Error(a.localize(3,null));else{const t={env:o};n.cwd&&(t.cwd=n.cwd),this.serverProcess=s.spawn(h,g,t)}this.serverProcess.on("error",t=>{this._onError.fire(t)}),this.serverProcess.on("exit",(t,i)=>{this._onExit.fire(t)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stdin.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(o){this._onError.fire(o)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),L.isWindows?new Promise((h,g)=>{const n=s.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(o,t,i){if(o)return g(o)});n.on("exit",h),n.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(h,g){if(!h)return;const n=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?n.runtime=R.join(g,h.runtime):n.runtime=h.runtime),h.runtimeArgs&&(n.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?n.program=h.program:n.program=R.join(g,h.program)),h.args&&(n.args=h.args);const o=h;return o.win&&(n.win=l.extract(o.win,g)),o.winx86&&(n.winx86=l.extract(o.winx86,g)),o.windows&&(n.windows=l.extract(o.windows,g)),o.osx&&(n.osx=l.extract(o.osx,g)),o.linux&&(n.linux=l.extract(o.linux,g)),n}static platformAdapterExecutable(h,g){let n=Object.create(null);g=g.toLowerCase();for(const u of h)if(u.contributes){const v=u.contributes.debuggers;v&&v.length>0&&v.filter(y=>typeof y.type=="string"&&A.equalsIgnoreCase(y.type,g)).forEach(y=>{const D=l.extract(y,u.extensionLocation.fsPath);n=T.mixin(n,D,u.isBuiltin)})}let o;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.isWindows?o=n.win||n.windows:L.isMacintosh?o=n.osx:L.isLinux&&(o=n.linux),o=o||n;const t=o.program||n.program,i=o.args||n.args,r=o.runtime||n.runtime,f=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(f||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=l}),define(_e[311],ye([1,0,58,33,11]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=L,e.prepareCommand=p,s=ze(s),T=ze(T);function R(a,I){return new Promise((_,c)=>{let C="";const b=s.spawn(a,I);b.pid&&b.stdout.on("data",l=>{C+=l.toString()}),b.on("error",l=>{c(l)}),b.on("close",l=>{_(C)})})}async function L(a){if(a)if(T.isWindows){const I=await new Promise((_,c)=>{le(["@vscode/windows-process-tree"],_,c)}).then(ze);return new Promise(_=>{I.getProcessTree(a,c=>{_(!!c&&c.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(a)]).then(I=>{const _=I.trim();return!(_.length===0||_.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var A;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(A||(A={}));function p(a,I,_,c,C){a=a.trim().toLowerCase();let b;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?b=A.powershell:a.indexOf("cmd.exe")>=0?b=A.cmd:a.indexOf("bash")>=0?b=A.bash:T.isWindows?b=A.cmd:b=A.bash;let l,m=" ";switch(b){case A.powershell:if(l=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),c){const h=(0,d.getDriveLetter)(c);h&&(m+=`${h}:; `),m+=`cd ${l(c)}; `}if(C)for(const h in C){const g=C[h];g===null?m+=`Remove-Item env:${h}; `:m+=`\${env:${h}}='${g}'; `}if(I.length>0){const h=I.shift(),g=_?h:l(h);m+=g[0]==="'"?`& ${g} `:`${g} `;for(const n of I)m+=n==="<"||n===">"||_?n:l(n),m+=" "}break;case A.cmd:if(l=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>h.includes(g))||h.length===0?`"${h}"`:h),c){const h=(0,d.getDriveLetter)(c);h&&(m+=`${h}: && `),m+=`cd ${l(c)} && `}if(C){m+='cmd /C "';for(const h in C){let g=C[h];g===null?m+=`set "${h}=" && `:(g=g.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${h}=${g}" && `)}}for(const h of I)m+=h==="<"||h===">"||_?h:l(h),m+=" ";C&&(m+='"');break;case A.bash:{l=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g);const h=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(c&&(m+=`cd ${l(c)} ; `),C){m+="/usr/bin/env";for(const g in C){const n=C[g];n===null?m+=` -u ${h(g)}`:m+=` ${h(`${g}=${n}`)}`}m+=" "}for(const g of I)m+=g==="<"||g===">"||_?g:l(g),m+=" ";break}}return m}}),define(_e[312],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var d;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(d||(e.CellExecutionUpdateType=d={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(_e[313],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var d;(function(T){T[T.Disconnected=1]="Disconnected",T[T.Connected=2]="Connected",T[T.Initializing=3]="Initializing"})(d||(e.ProxyKernelState=d={})),e.INotebookKernelService=(0,s.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,s.createDecorator)("INotebookKernelHistoryService")}),define(_e[314],ye([1,0,3,31,55,215,107]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class A extends s.Disposable{constructor(a,I,_){super(),this._source=a,this._inputTextBuffer=I,this._outputs=_,this._outputTextBuffers=void 0}_getFullModelRange(a){const I=a.getLineCount();return new d.Range(1,1,I,this._getLineMaxColumn(a,I))}_getLineMaxColumn(a,I){if(I<1||I>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(I)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const a=new R.PieceTreeTextBufferBuilder;a.acceptChunk(this._source);const I=a.finish(!0),{textBuffer:_,disposable:c}=I.create(T.DefaultEndOfLine.LF);this._inputTextBuffer=_,this._register(c)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(a=>{const I=new R.PieceTreeTextBufferBuilder;I.acceptChunk(a);const _=I.finish(!0),{textBuffer:c,disposable:C}=_.create(T.DefaultEndOfLine.LF);return this._register(C),c})),this._outputTextBuffers}findInInputs(a){const _=new L.SearchParams(a,!1,!1,null).parseSearchRequest();if(!_)return[];const c=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(c,_,!0,5e3)}findInOutputs(a){const _=new L.SearchParams(a,!1,!1,null).parseSearchRequest();return _?this.outputTextBuffers.map(c=>{const C=c.findMatchesLineByLine(this._getFullModelRange(c),_,!0,5e3);if(C.length!==0)return{textBuffer:c,matches:C}}).filter(c=>!!c):[]}}e.CellSearchModel=A}),define(_e[74],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(R){R.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var d;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(d||(e.TestPosition=d={}));class T{static fromExtHostTestItem(L,A,p=L.parent){if(L._isRoot)return new T([A]);const a=[L.id];for(let I=p;I&&I.id!==A;I=I.parent)a.push(I.id);return a.push(A),new T(a.reverse())}static isRoot(L){return!L.includes(s.Delimiter)}static root(L){const A=L.indexOf(s.Delimiter);return A===-1?L:L.slice(0,A)}static fromString(L){return new T(L.split(s.Delimiter))}static join(L,A){return new T([...L.path,A])}static joinToString(L,A){return L.toString()+s.Delimiter+A}static parentId(L){const A=L.lastIndexOf(s.Delimiter);return A===-1?void 0:L.slice(0,A)}static localId(L){const A=L.lastIndexOf(s.Delimiter);return A===-1?L:L.slice(A+s.Delimiter.length)}static isChild(L,A){return A.startsWith(L)&&A[L.length]===s.Delimiter}static compare(L,A){return L===A?d.IsSame:T.isChild(L,A)?d.IsChild:T.isChild(A,L)?d.IsParent:d.Disconnected}static getLengthOfCommonPrefix(L,A){if(L===0)return 0;let p=0;for(;p<L-1;){for(let a=1;a<L;a++){const I=A(a-1),_=A(a);if(I.path[p]!==_.path[p])return p}p++}return p}constructor(L,A=L.length){if(this.path=L,this.viewEnd=A,L.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new T(this.path,1)}get parentId(){return this.viewEnd>1?new T(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let L=1;L<=this.viewEnd;L++)yield new T(this.path,L)}*idsToRoot(){for(let L=this.viewEnd;L>0;L--)yield new T(this.path,L)}compare(L){if(typeof L=="string")return T.compare(this.toString(),L);for(let A=0;A<L.viewEnd&&A<this.viewEnd;A++)if(L.path[A]!==this.path[A])return d.Disconnected;return L.viewEnd>this.viewEnd?d.IsChild:L.viewEnd<this.viewEnd?d.IsParent:d.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let L=1;L<this.viewEnd;L++)this.stringifed+=s.Delimiter,this.stringifed+=this.path[L]}return this.stringifed}}e.TestId=T}),define(_e[75],ye([1,0,2,54,31,74]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var L;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.testResultStateToContextValues={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var A;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var p;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.testRunProfileBitsetList=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const a=U=>"runId"in U;e.isStartControllerTests=a;var I;(function(U){U.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),U.deserialize=(F,H)=>({range:T.Range.lift(H.range),uri:F.asCanonicalUri(s.URI.revive(H.uri))})})(I||(e.IRichLocation=I={}));var _;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(_||(e.TestMessageType=_={}));var c;(function(U){U.serialize=F=>({message:F.message,type:_.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),U.deserialize=(F,H)=>({message:H.message,type:_.Error,expected:H.expected,actual:H.actual,contextValue:H.contextValue,location:H.location&&I.deserialize(F,H.location)})})(c||(e.ITestErrorMessage=c={}));const C=(U,F)=>`${F?"s":"e"}${U}`;e.getMarkId=C;var b;(function(U){U.serialize=F=>({message:F.message,type:_.Output,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),U.deserialize=(F,H)=>({message:H.message,type:_.Output,offset:H.offset,length:H.length,location:H.location&&I.deserialize(F,H.location)})})(b||(e.ITestOutputMessage=b={}));var l;(function(U){U.serialize=F=>F.type===_.Error?c.serialize(F):b.serialize(F),U.deserialize=(F,H)=>H.type===_.Error?c.deserialize(F,H):b.deserialize(F,H)})(l||(e.ITestMessage=l={}));var m;(function(U){U.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),U.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(l.serialize)}),U.deserialize=(F,H)=>({state:H.state,duration:H.duration,messages:H.messages.map(j=>l.deserialize(F,j))})})(m||(e.ITestTaskState=m={}));const h="\0",g=(U,F)=>U+h+F;e.namespaceTestTag=g;const n=U=>{const F=U.indexOf(h);return{ctrlId:U.slice(0,F),tagId:U.slice(F+1)}};e.denamespaceTestTag=n;var o;(function(U){U.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),U.deserialize=(F,H)=>({extId:H.extId,label:H.label,tags:H.tags,busy:H.busy,children:void 0,uri:H.uri?F.asCanonicalUri(s.URI.revive(H.uri)):void 0,range:H.range?T.Range.lift(H.range):null,description:H.description,error:H.error,sortText:H.sortText})})(o||(e.ITestItem=o={}));var t;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var i;(function(U){U.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),U.deserialize=(F,H)=>({controllerId:R.TestId.root(H.item.extId),expand:H.expand,item:o.deserialize(F,H.item)})})(i||(e.InternalTestItem=i={}));var r;(function(U){U.serialize=F=>{let H;return F.item&&(H={},F.item.label!==void 0&&(H.label=F.item.label),F.item.tags!==void 0&&(H.tags=F.item.tags),F.item.busy!==void 0&&(H.busy=F.item.busy),F.item.uri!==void 0&&(H.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(H.range=F.item.range?.toJSON()),F.item.description!==void 0&&(H.description=F.item.description),F.item.error!==void 0&&(H.error=F.item.error),F.item.sortText!==void 0&&(H.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:H}},U.deserialize=F=>{let H;return F.item&&(H={},F.item.label!==void 0&&(H.label=F.item.label),F.item.tags!==void 0&&(H.tags=F.item.tags),F.item.busy!==void 0&&(H.busy=F.item.busy),F.item.range!==void 0&&(H.range=F.item.range?T.Range.lift(F.item.range):null),F.item.description!==void 0&&(H.description=F.item.description),F.item.error!==void 0&&(H.error=F.item.error),F.item.sortText!==void 0&&(H.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:H}}})(r||(e.ITestItemUpdate=r={}));const f=(U,F)=>{F.expand!==void 0&&(U.expand=F.expand),F.item!==void 0&&(U.item=U.item?Object.assign(U.item,F.item):F.item)};e.applyTestItemUpdate=f;var u;(function(U){U.serializeWithoutMessages=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serializeWithoutMessages)}),U.serialize=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serialize)}),U.deserialize=(F,H)=>({...i.deserialize(F,H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(j=>m.deserialize(F,j)),retired:!0})})(u||(e.TestResultItem=u={}));var v;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(F,H)=>{F.covered+=H.covered,F.total+=H.total}})(v||(e.ICoverageCount=v={}));var y;(function(U){U.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),U.deserialize=(F,H)=>({id:H.id,statement:H.statement,branch:H.branch,declaration:H.declaration,testIds:H.testIds,uri:F.asCanonicalUri(s.URI.revive(H.uri))}),U.empty=(F,H)=>({id:F,uri:H,statement:v.empty()})})(y||(e.IFileCoverage=y={}));function D(U){return{...U,location:U.location?.toJSON()}}function w(U){return U.location=U.location?d.Position.isIPosition(U.location)?d.Position.lift(U.location):T.Range.lift(U.location):void 0,U}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var P;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})(P||(e.DetailType=P={}));var k;(function(U){U.serialize=F=>F.type===P.Declaration?S.serialize(F):M.serialize(F),U.deserialize=F=>F.type===P.Declaration?S.deserialize(F):M.deserialize(F)})(k||(e.CoverageDetails=k={}));var E;(function(U){U.serialize=D,U.deserialize=w})(E||(e.IBranchCoverage=E={}));var S;(function(U){U.serialize=D,U.deserialize=w})(S||(e.IDeclarationCoverage=S={}));var M;(function(U){U.serialize=F=>({...D(F),branches:F.branches?.map(E.serialize)}),U.deserialize=F=>({...w(F),branches:F.branches?.map(E.deserialize)})})(M||(e.IStatementCoverage=M={}));var N;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var O;(function(U){U.deserialize=(F,H)=>H.op===N.Add?{op:H.op,item:i.deserialize(F,H.item)}:H.op===N.Update?{op:H.op,item:r.deserialize(H.item)}:H.op===N.DocumentSynced?{op:H.op,uri:F.asCanonicalUri(s.URI.revive(H.uri)),docv:H.docv}:H,U.serialize=F=>F.op===N.Add?{op:F.op,item:i.serialize(F.item)}:F.op===N.Update?{op:F.op,item:r.serialize(F.item)}:F})(O||(e.TestsDiffOp=O={}));class x{constructor(F){this.uriIdentity=F,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(F){const H=this.createChangeCollector();for(const j of F)switch(j.op){case N.Add:this.add(i.deserialize(this.uriIdentity,j.item),H);break;case N.Update:this.update(r.deserialize(j.item),H);break;case N.Remove:this.remove(j.itemId,H);break;case N.Retire:this.retireTest(j.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(j.amount);break;case N.AddTag:this._tags.set(j.tag.id,j.tag);break;case N.RemoveTag:this._tags.delete(j.id);break}H.complete?.()}add(F,H){const j=R.TestId.parentId(F.item.extId)?.toString();let re;if(!j)re=this.createItem(F),this.roots.add(re),this.items.set(F.item.extId,re);else if(this.items.has(j)){const B=this.items.get(j);B.children.add(F.item.extId),re=this.createItem(F,B),this.items.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return H.add?.(re),F.expand===t.BusyExpanding&&this.busyControllerCount++,re}update(F,H){const j=this.items.get(F.extId);if(j)return F.expand!==void 0&&(j.expand===t.BusyExpanding&&this.busyControllerCount--,F.expand===t.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,F),H.update?.(j),j}remove(F,H){const j=this.items.get(F);if(!j)return;const re=R.TestId.parentId(j.item.extId)?.toString();re?this.items.get(re).children.delete(j.item.extId):this.roots.delete(j);const B=[[F]];for(;B.length;)for(const V of B.pop()){const X=this.items.get(V);X&&(B.push(X.children),this.items.delete(V),H.remove?.(X,X!==j),X.expand===t.BusyExpanding&&this.busyControllerCount--)}}retireTest(F){}updatePendingRoots(F){this.pendingRootCount+=F}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=x}),define(_e[315],ye([1,0,136,257,75]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(_){_.ViewletId="workbench.view.extension.test",_.ExplorerViewId="workbench.view.testing",_.OutputPeekContributionId="editor.contrib.testingOutputPeek",_.DecorationsContributionId="editor.contrib.testingDecorations",_.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",_.CoverageViewId="workbench.view.testCoverage",_.ResultsPanelId="workbench.panel.testResults",_.ResultsViewId="workbench.panel.testResults.view",_.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(_){_.List="list",_.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var A;(function(_){_.ByLocation="location",_.ByStatus="status",_.ByDuration="duration"})(A||(e.TestExplorerViewSorting=A={}));const p={[T.TestResultState.Errored]:(0,d.localize)(0,null),[T.TestResultState.Failed]:(0,d.localize)(1,null),[T.TestResultState.Passed]:(0,d.localize)(2,null),[T.TestResultState.Queued]:(0,d.localize)(3,null),[T.TestResultState.Running]:(0,d.localize)(4,null),[T.TestResultState.Skipped]:(0,d.localize)(5,null),[T.TestResultState.Unset]:(0,d.localize)(6,null)},a=(_,c)=>(0,d.localize)(7,null,(0,s.stripIcons)(_),p[c]);e.labelForTestInState=a,e.testConfigurationGroupNames={[T.TestRunProfileBitset.Debug]:(0,d.localize)(8,null),[T.TestRunProfileBitset.Run]:(0,d.localize)(9,null),[T.TestRunProfileBitset.Coverage]:(0,d.localize)(10,null)};var I;(function(_){_.CancelTestRefreshAction="testing.cancelTestRefresh",_.CancelTestRunAction="testing.cancelRun",_.ClearTestResultsAction="testing.clearTestResults",_.CollapseAllAction="testing.collapseAll",_.ConfigureTestProfilesAction="testing.configureProfile",_.ContinousRunUsingForTest="testing.continuousRunUsingForTest",_.CoverageAtCursor="testing.coverageAtCursor",_.CoverageByUri="testing.coverage.uri",_.CoverageClear="testing.coverage.close",_.CoverageCurrentFile="testing.coverageCurrentFile",_.CoverageFilterToTest="testing.coverageFilterToTest",_.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",_.CoverageLastRun="testing.coverageLastRun",_.CoverageSelectedAction="testing.coverageSelected",_.CoverageToggleToolbar="testing.coverageToggleToolbar",_.CoverageViewChangeSorting="testing.coverageViewChangeSorting",_.DebugAction="testing.debug",_.DebugAllAction="testing.debugAll",_.DebugAtCursor="testing.debugAtCursor",_.DebugByUri="testing.debug.uri",_.DebugCurrentFile="testing.debugCurrentFile",_.DebugFailedTests="testing.debugFailTests",_.DebugLastRun="testing.debugLastRun",_.DebugSelectedAction="testing.debugSelected",_.FilterAction="workbench.actions.treeView.testExplorer.filter",_.GetExplorerSelection="_testing.getExplorerSelection",_.GetSelectedProfiles="testing.getSelectedProfiles",_.GoToTest="testing.editFocusedTest",_.HideTestAction="testing.hideTest",_.OpenCoverage="testing.openCoverage",_.OpenOutputPeek="testing.openOutputPeek",_.RefreshTestsAction="testing.refreshTests",_.ReRunFailedTests="testing.reRunFailTests",_.ReRunLastRun="testing.reRunLastRun",_.RunAction="testing.run",_.RunAllAction="testing.runAll",_.RunAllWithCoverageAction="testing.coverageAll",_.RunAtCursor="testing.runAtCursor",_.RunByUri="testing.run.uri",_.RunCurrentFile="testing.runCurrentFile",_.RunSelectedAction="testing.runSelected",_.RunUsingProfileAction="testing.runUsing",_.RunWithCoverageAction="testing.coverage",_.SearchForTestExtension="testing.searchForTestExtension",_.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",_.ShowMostRecentOutputAction="testing.showMostRecentOutput",_.StartContinousRun="testing.startContinuousRun",_.StopContinousRun="testing.stopContinuousRun",_.TestingSortByDurationAction="testing.sortByDuration",_.TestingSortByLocationAction="testing.sortByLocation",_.TestingSortByStatusAction="testing.sortByStatus",_.TestingViewAsListAction="testing.viewAsList",_.TestingViewAsTreeAction="testing.viewAsTree",_.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",_.ToggleInlineTestOutput="testing.toggleInlineTestOutput",_.UnhideAllTestsAction="testing.unhideAllTests",_.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(_e[121],ye([1,0,9,4,3,66,75,74]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const a=(g,n)=>g===n,_=Object.entries({range:(g,n)=>g===n?!0:!g||!n?!1:g.equalsRange(n),busy:a,label:a,description:a,error:a,sortText:a,tags:(g,n)=>!(g.length!==n.length||g.some(o=>!n.includes(o)))}),c=(g,n)=>{let o;for(const[t,i]of _)i(g[t],n[t])||(o?o[t]=n[t]:o={[t]:n[t]});return o};class C extends T.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new d.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const o of this.tree.values())this.updateExpandability(o)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.diff)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const o=this.diff[this.diff.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,L.applyTestItemUpdate)(o.item,n.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,L.applyTestItemUpdate)(o.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,o){const t=this.tree.get(n);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===L.TestItemExpandState.Expandable){const i=this.resolveChildren(t);return i.isOpen()?this.expandChildren(t,o-1):i.wait().then(()=>this.expandChildren(t,o-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,o-1)):this.expandChildren(t,o-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,o){switch(o.op){case p.RemoveChild:this.removeItem(A.TestId.joinToString(n.fullId,o.id));break;case p.Upsert:this.upsertItem(o.item,n);break;case p.Bulk:for(const t of o.ops)this.onTestItemEvent(n,t);break;case p.SetTags:this.diffTagRefs(o.new,o.old,n.fullId.toString());break;case p.UpdateCanResolveChildren:this.updateExpandability(n);break;case p.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case p.DocumentSynced:this.documentSynced(n.actual.uri);break;default:(0,R.assertNever)(o)}}documentSynced(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,o){const t=A.TestId.fromExtHostTestItem(n,this.root.id,o?.actual),i=this.options.getApiFor(n);i.parent&&i.parent!==o?.actual&&this.options.getChildren(i.parent).delete(n.id);let r=this.tree.get(t.toString());if(!r){r={fullId:t,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(n,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,r,o);return}if(r.actual===n){this.connectItem(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(n,o);const f=this.options.getChildren(r.actual),u=r.actual,v=c(this.options.toITestItem(u),this.options.toITestItem(n));this.options.getApiFor(u).listener=void 0,r.actual=n,r.resolveBarrier=void 0,r.expand=L.TestItemExpandState.NotExpandable,v&&(v.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,u.tags,t.toString()),delete v.tags),this.onTestItemEvent(r,{op:p.SetProp,update:v})),this.connectItemAndChildren(n,r,o);for(const[D,w]of f)this.options.getChildren(n).get(w.id)||this.removeItem(A.TestId.joinToString(t,w.id));const y=r.expandLevels;y!==void 0&&queueMicrotask(()=>{r.expand===L.TestItemExpandState.Expandable&&(r.expandLevels=void 0,this.expand(t.toString(),y))}),this.documentSynced(r.actual.uri)}diffTagRefs(n,o,t){const i=new Set(o.map(r=>r.id));for(const r of n)i.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:n.map(r=>(0,L.namespaceTestTag)(this.options.controllerId,r.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const o=this.tags.get(n.id);o?o.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const o=this.tags.get(n);o&&!--o.refCount&&(this.tags.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,o){this.options.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}connectItem(n,o,t){this.setItemParent(n,t);const i=this.options.getApiFor(n);i.parent=t?.actual,i.listener=r=>this.onTestItemEvent(o,r),this.updateExpandability(o)}connectItemAndChildren(n,o,t){this.connectItem(n,o,t);for(const[i,r]of this.options.getChildren(n))this.upsertItem(r,o)}updateExpandability(n){let o;this._resolveHandler?n.resolveBarrier?o=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,o){if(o<0)return;const t=[];for(const[i,r]of this.options.getChildren(n.actual)){const f=this.expand(A.TestId.joinToString(n.fullId,r.id),o);(0,s.isThenable)(f)&&t.push(f)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const r=new s.Barrier;return r.open(),r}n.expand=L.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(n);const o=n.resolveBarrier=new s.Barrier,t=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let i;try{i=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(r){t(r)}return(0,s.isThenable)(i)?i.catch(t).then(()=>{o.open(),this.updateExpandability(n)}):(o.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const t=[o];for(;t.length;){const i=t.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(i.fullId.toString());for(const[r,f]of this.options.getChildren(i.actual))t.push(this.tree.get(A.TestId.joinToString(i.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=C;class b extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=b;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class m extends Error{constructor(n,o,t){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=m;const h=(g,n,o)=>{let t=new Map;return{get size(){return t.size},forEach(i,r){for(const f of t.values())i.call(r,f,this)},[Symbol.iterator](){return t.entries()},replace(i){const r=new Map,f=new Set(t.keys()),u={op:p.Bulk,ops:[]};for(const v of i){if(!(v instanceof o))throw new l(v.id);const y=n(v).controllerId;if(y!==g.controllerId)throw new m(v.id,y,g.controllerId);if(r.has(v.id))throw new b(v.id);r.set(v.id,v),f.delete(v.id),u.ops.push({op:p.Upsert,item:v})}for(const v of f.keys())u.ops.push({op:p.RemoveChild,id:v});g.listener?.(u),t=r},add(i){if(!(i instanceof o))throw new l(i.id);t.set(i.id,i),g.listener?.({op:p.Upsert,item:i})},delete(i){t.delete(i)&&g.listener?.({op:p.RemoveChild,id:i})},get(i){return t.get(i)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=h}),define(_e[155],ye([1,0,121]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const d=new WeakMap,T=(L,A)=>{const p={controllerId:A};return d.set(L,p),p};e.createPrivateApiFor=T;const R=L=>{const A=d.get(L);if(!A)throw new s.InvalidTestItemError(L?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(_e[122],ye([1,0,27,15,2]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=R,e.decodeAuthority=A,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function R(p,a){return p.scheme===d.Schemas.http||p.scheme===d.Schemas.https?p:(a&&a.authority&&a.isRemote&&p.scheme===d.Schemas.file&&(p=T.URI.from({scheme:d.Schemas.vscodeRemote,authority:a.authority,path:p.path})),T.URI.from({scheme:d.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.webviewRootResourceAuthority}`,path:p.path,fragment:p.fragment,query:p.query}))}function L(p){return p.replace(/./g,a=>{const I=a.charCodeAt(0);return I>=s.CharCode.a&&I<=s.CharCode.z||I>=s.CharCode.A&&I<=s.CharCode.Z||I>=s.CharCode.Digit0&&I<=s.CharCode.Digit9?a:"-"+I.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,(a,I)=>String.fromCharCode(parseInt(I,16)))}}),define(_e[316],ye([1,0,4,3,122]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,p,a){this._proxy=A,this._editors=p,this._remoteInfo=a,this._handlePool=0,this._disposables=new d.DisposableStore,this._insets=new Map,this._disposables.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const _ of this._insets.values())I.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,p,a,I,_){let c;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===A){c=n;break}if(!c)throw new Error("not a visible editor");const C=this,b=this._handlePool++,l=new s.Emitter,m=new s.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,T.asWebviewUri)(n,C._remoteInfo)}get cspSource(){return T.webviewGenericCspSource}set options(n){this._options=n,C._proxy.$setOptions(b,n)}get options(){return this._options}set html(n){this._html=n,C._proxy.$setHtml(b,n)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(n){return C._proxy.$postMessage(b,n)}},g=new class{constructor(){this.editor=A,this.line=p,this.height=a,this.webview=h,this.onDidDispose=m.event}dispose(){C._insets.has(b)&&(C._insets.delete(b),C._proxy.$disposeEditorInset(b),m.fire(),m.dispose(),l.dispose())}};return this._proxy.$createEditorInset(b,c.id,c.value.document.uri,p+1,a,I||{},_.identifier,_.extensionLocation),this._insets.set(b,{editor:A,inset:g,onDidReceiveMessage:l}),g}$onDidDispose(A){const p=this._insets.get(A);p&&p.inset.dispose()}$onDidReceiveMessage(A,p){this._insets.get(A)?.onDidReceiveMessage.fire(p)}}e.ExtHostEditorInsets=R}),define(_e[156],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,s.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,s.createDecorator)("IAuthenticationExtensionsService")}),define(_e[317],ye([1,0,5]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,s.createDecorator)("configurationResolverService");var d;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(d||(e.VariableKind=d={}));class T extends Error{constructor(L,A){super(A),this.variable=L}}e.VariableError=T}),define(_e[318],ye([1,0,17,56,18,25,11,110,258,317,13]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,s=ze(s),d=ze(d),T=ze(T),R=ze(R);class _{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,b,l,m){this._contributedVariables=new Map,this._context=C,this._labelService=b,this._userHomePromise=l,m&&(this._envVariablesPromise=m.then(h=>this.prepareEnv(h)))}prepareEnv(C){if(L.isWindows){const b=Object.create(null);return Object.keys(C).forEach(l=>{b[l.toLowerCase()]=C[l]}),b}return C}resolveWithEnvironment(C,b,l){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},b?b.uri:void 0,l)}async resolveAsync(C,b){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,C?C.uri:void 0,b)}async resolveAnyBase(C,b,l,m){const h=R.deepClone(b);L.isWindows&&h.windows?Object.keys(h.windows).forEach(n=>h[n]=h.windows[n]):L.isMacintosh&&h.osx?Object.keys(h.osx).forEach(n=>h[n]=h.osx[n]):L.isLinux&&h.linux&&Object.keys(h.linux).forEach(n=>h[n]=h.linux[n]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,C?C.uri:void 0,h,l,m)}async resolveAnyAsync(C,b,l){return this.resolveAnyBase(C,b,l)}async resolveAnyMap(C,b,l){const m=new Map;return{newConfig:await this.resolveAnyBase(C,b,l,m),resolvedVariables:m}}resolveWithInteractionReplace(C,b,l,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,b,l,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,b){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,b)}async recursiveResolve(C,b,l,m,h){if(T.isString(l))return this.resolveString(C,b,l,m,h);if(Array.isArray(l))return Promise.all(l.map(g=>this.recursiveResolve(C,b,g,m,h)));if(T.isObject(l)){const g=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.resolveString(C,b,o,m,h),await this.recursiveResolve(C,b,l[o],m,h)]));for(const[o,t]of n)g[o]=t;return g}return l}resolveString(C,b,l,m,h){return(0,I.replaceAsync)(l,_.VARIABLE_REGEXP,async(g,n)=>{if(n.includes(_.VARIABLE_LHS))return g;let o=await this.evaluateSingleVariable(C,g,n,b,m);return h?.set(n,o),o!==g&&T.isString(o)&&o.match(_.VARIABLE_REGEXP)&&(o=await this.resolveString(C,b,o,m,h)),o})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,b,l,m,h){let g;const n=l.split(":");n.length>1&&(l=n[0],g=n[1]);const o=r=>{const f=this._context.getFilePath();if(f)return(0,A.normalizeDriveLetter)(f);throw new a.VariableError(r,(0,p.localize)(0,null,b))},t=r=>{const f=o(r);if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return(0,A.normalizeDriveLetter)(u)}throw new a.VariableError(r,(0,p.localize)(1,null,b,s.basename(f)))},i=r=>{if(g){const f=this._context.getFolderUri(g);if(f)return f;throw new a.VariableError(r,(0,p.localize)(2,null,b,g))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new a.VariableError(r,(0,p.localize)(3,null,b)):new a.VariableError(r,(0,p.localize)(4,null,b))};switch(l){case"env":if(g){if(C.env){const r=C.env[L.isWindows?g.toLowerCase():g];if(T.isString(r))return r}return""}throw new a.VariableError(a.VariableKind.Env,(0,p.localize)(5,null,b));case"config":if(g){const r=this._context.getConfigurationValue(m,g);if(T.isUndefinedOrNull(r))throw new a.VariableError(a.VariableKind.Config,(0,p.localize)(6,null,b,g));if(T.isObject(r))throw new a.VariableError(a.VariableKind.Config,(0,p.localize)(7,null,b,g));return r}throw new a.VariableError(a.VariableKind.Config,(0,p.localize)(8,null,b));case"command":return this.resolveFromMap(a.VariableKind.Command,b,g,h,"command");case"input":return this.resolveFromMap(a.VariableKind.Input,b,g,h,"input");case"extensionInstallFolder":if(g){const r=await this._context.getExtension(g);if(!r)throw new a.VariableError(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,b,g));return this.fsPath(r.extensionLocation)}throw new a.VariableError(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,b));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(i(a.VariableKind.WorkspaceFolder)));case"cwd":return m||g?(0,A.normalizeDriveLetter)(this.fsPath(i(a.VariableKind.Cwd))):d.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(s.basename(this.fsPath(i(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new a.VariableError(a.VariableKind.UserHome,(0,p.localize)(11,null,b))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new a.VariableError(a.VariableKind.LineNumber,(0,p.localize)(12,null,b))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new a.VariableError(a.VariableKind.SelectedText,(0,p.localize)(13,null,b))}case"file":return o(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.basename(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||g?s.relative(this.fsPath(i(a.VariableKind.RelativeFile)),o(a.VariableKind.RelativeFile)):o(a.VariableKind.RelativeFile);case"relativeFileDirname":{const r=s.dirname(o(a.VariableKind.RelativeFileDirname));if(m||g){const f=s.relative(this.fsPath(i(a.VariableKind.RelativeFileDirname)),r);return f.length===0?".":f}return r}case"fileDirname":return s.dirname(o(a.VariableKind.FileDirname));case"fileExtname":return s.extname(o(a.VariableKind.FileExtname));case"fileBasename":return s.basename(o(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=s.basename(o(a.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-s.extname(r).length)}case"fileDirnameBasename":return s.basename(s.dirname(o(a.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||b}case"execInstallFolder":{const r=this._context.getAppRoot();return r||b}case"pathSeparator":case"/":return s.sep;default:try{const r=g?`${l}:${g}`:l;return this.resolveFromMap(a.VariableKind.Unknown,b,r,h,void 0)}catch{return b}}}}resolveFromMap(C,b,l,m,h){if(l&&m){const g=h===void 0?m[l]:m[h+":"+l];if(typeof g=="string")return g;throw new a.VariableError(C,(0,p.localize)(14,null,b))}return b}}e.AbstractVariableResolverService=_}),define(_e[157],ye([1,0,5,153]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=a,e.isEditorGroup=c,e.preferredSideBySideGroupDirection=C,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var T;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(T||(e.GroupDirection=T={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var A;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var p;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function a(b){const l=b;return(0,d.isEditorInput)(l?.editor)&&(0,d.isEditorInput)(l?.replacement)}var I;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var _;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(_||(e.OpenEditorContext=_={}));function c(b){const l=b;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}function C(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?T.DOWN:T.RIGHT}}),define(_e[319],ye([1,0,5,157]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=T,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function T(R){const L=R;return typeof R=="number"||(0,d.isEditorGroup)(L)}}),define(_e[158],ye([1,0,5,145]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(d.IEnvironmentService)}),define(_e[159],ye([1,0,24,4,17,3,9]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,T=ze(T);class A{constructor(g,n){this.versionId=g,this.removedDueToLooping=n}}e.DeltaExtensionsResult=A;class p{static isHostExtension(g,n,o){if(n.getExtensionDescription(g))return!1;const t=o.getExtensionDescription(g);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(g,n){this._activationEventsReader=g,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(l),this._extensionsMap=new s.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const g of this._extensionDescriptions){if(this._extensionsMap.has(g.identifier)){console.error("Extension `"+g.identifier.value+"` is already registered");continue}this._extensionsMap.set(g.identifier,g),this._extensionsArr.push(g);const n=this._activationEventsReader.readActivationEvents(g);for(const o of n)this._activationMap.has(o)||this._activationMap.set(o,[]),this._activationMap.get(o).push(g)}}set(g){return this._extensionDescriptions=g,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(g,n){this._extensionDescriptions=m(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(g);const o=p._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=m(this._extensionDescriptions,o.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new A(this._versionId,o)}static _findLoopingExtensions(g){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this._arcs.has(f)?this._arcs.get(f).push(u):this._arcs.set(f,[u])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,u){const v=n.getArcs(f);for(let y=0;y<v.length;y++)if(!u.has(v[y]))return!1;return!0}getNodes(){return this._nodesArr}},o=new s.ExtensionIdentifierMap;for(const f of g)if(o.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)n.addArc(s.ExtensionIdentifier.toKey(f.identifier),s.ExtensionIdentifier.toKey(u));const t=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>t.add(f));const i=n.getNodes().filter(f=>!t.has(f));let r;do{r=!1;for(let f=0;f<i.length;f++){const u=i[f];n.hasOnlyGoodArcs(u,t)&&(i.splice(f,1),f--,t.add(u),r=!0)}}while(r);return i.map(f=>o.get(f))}containsActivationEvent(g){return this._activationMap.has(g)}containsExtension(g){return this._extensionsMap.has(g)}getExtensionDescriptionsForActivationEvent(g){const n=this._activationMap.get(g);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new a(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(g){const n=this._extensionsMap.get(g);return n||void 0}getExtensionDescriptionByUUID(g){for(const n of this._extensionsArr)if(n.uuid===g)return n}getExtensionDescriptionByIdOrUUID(g,n){return this.getExtensionDescription(g)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=p;class a{constructor(g,n){this.versionId=g,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=a;class I{constructor(g){this._lock=new C,this._actual=new p(g,[])}async acquireLock(g){const n=await this._lock.acquire(g);return new _(this,n)}deltaExtensions(g,n,o){if(!g.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,o)}containsActivationEvent(g){return this._actual.containsActivationEvent(g)}containsExtension(g){return this._actual.containsExtension(g)}getExtensionDescriptionsForActivationEvent(g){return this._actual.getExtensionDescriptionsForActivationEvent(g)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(g){return this._actual.getExtensionDescription(g)}getExtensionDescriptionByUUID(g){return this._actual.getExtensionDescriptionByUUID(g)}getExtensionDescriptionByIdOrUUID(g,n){return this._actual.getExtensionDescriptionByIdOrUUID(g,n)}}e.LockableExtensionDescriptionRegistry=I;class _ extends R.Disposable{constructor(g,n){super(),this._registry=g,this._isDisposed=!1,this._register(n)}isAcquiredFor(g){return!this._isDisposed&&this._registry===g}}e.ExtensionDescriptionRegistryLock=_;class c{constructor(g){this.name=g;const n=(0,L.promiseWithResolvers)();this.promise=n.promise,this._resolve=n.resolve}resolve(g){this._resolve(g)}}class C{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(g){const n=new c(g);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const g=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${g.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{n&&(clearTimeout(o),n=!1,this._isLocked=!1,this._advance())};g.resolve((0,R.toDisposable)(t))}}var b;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(b||(b={}));function l(h,g){const n=h.isBuiltin?b.Builtin:h.isUnderDevelopment?b.Dev:b.User,o=g.isBuiltin?b.Builtin:g.isUnderDevelopment?b.Dev:b.User;if(n!==o)return n-o;const t=T.posix.basename(h.extensionLocation.path),i=T.posix.basename(g.extensionLocation.path);return t<i?-1:t>i?1:0}function m(h,g){const n=new s.ExtensionIdentifierSet(g);return h.filter(o=>!n.has(o.identifier))}}),define(_e[320],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=A,e.readExtHostConnection=p;var s;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class d{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(_){this.pipeName=_,this.type=s.IPC}serialize(_){_[d.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=d;class T{constructor(){this.type=s.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(_){_[T.ENV_KEY]="1"}}e.SocketExtHostConnection=T;class R{constructor(){this.type=s.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(_){_[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R;function L(I){delete I[d.ENV_KEY],delete I[T.ENV_KEY],delete I[R.ENV_KEY]}function A(I,_){L(_),I.serialize(_)}function p(I){if(I[d.ENV_KEY])return a(I,new d(I[d.ENV_KEY]));if(I[T.ENV_KEY])return a(I,new T);if(I[R.ENV_KEY])return a(I,new R);throw new Error("No connection information defined in environment!")}function a(I,_){return L(I),_}}),define(_e[94],ye([1,0,22]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=L,e.isMessageOfType=A;var d;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(d||(e.UIKind=d={}));var T;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(T||(e.ExtensionHostExitCode=T={}));var R;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(a){const I=s.VSBuffer.alloc(1);switch(a){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function A(a,I){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var p;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(_e[95],ye([1,0,5,4,150,12,30,94,91,92,25,2,3,241]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=m;let b=class extends c.Disposable{constructor(g,n){super(),this.initData=g,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new d.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new d.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=T.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=_.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:a.extensionTelemetryLogChannelId,name:(0,C.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(o=>{(0,R.isLogLevel)(o)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===T.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=T.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=T.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=T.TelemetryLevel.USAGE:!1}}instantiateLogger(g,n,o){const t=this.getTelemetryDetails(),i=new l(n,o,g,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(g),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),r=this._telemetryLoggers.get(g.identifier.value)??[];return this._telemetryLoggers.set(g.identifier.value,[...r,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(g,n,o){this._level=g,this._telemetryIsSupported=n,this._productConfig=o??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(g){const n=Object.create(null);switch(n["common.extname"]=`${g.publisher}.${g.name}`,n["common.extversion"]=g.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=m(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.getRemoteName)((0,a.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(g){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=g;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((o,t)=>{const i=o.filter(r=>!r.isDisposed);i.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,i)}),this._telemetryLoggers.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(g,n){const t=this._telemetryLoggers.get(g.value)?.filter(r=>!r.isDisposed);if(!t)return this._telemetryLoggers.delete(g.value),!1;let i=!1;for(const r of t)r.ignoreUnhandledExtHostErrors||(r.logError(n),i=!0);return i}};e.ExtHostTelemetry=b,e.ExtHostTelemetry=b=Xe([He(0,L.IExtHostInitDataService),He(1,R.ILoggerService)],b);class l{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,n,o,t,i,r,f){this._extension=o,this._logger=t,this._inLoggingOnlyMode=i,this._commonProperties=r,this._onDidChangeEnableStates=new d.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=g,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(g,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:g,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(g){let n="properties"in g?g.properties??{}:g;return n=(0,a.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,I.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,I.mixin)(n,this._commonProperties)),"properties"in g?g.properties=n:g=n,g}logEvent(g,n){this._sender&&(this._extension.publisher==="vscode"?g=this._extension.name+"/"+g:g=this._extension.identifier.value+"/"+g,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(g,n),this._logger.trace(g,n))}logUsage(g,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(g,n)}logError(g,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof g=="string")this.logEvent(g,n);else{const o={name:g.name,message:g.message,stack:g.stack,cause:g.cause},t=(0,a.cleanData)(o,[]),i=new Error(t.message,{cause:t.cause});i.stack=t.stack,i.name=t.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(i,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const g=this,n={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return g._telemetryEnablements.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g._onDidChangeEnableStates.event.bind(g)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let g=this._sender;this._sender=void 0,Promise.resolve(g.flush()).then(g=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=l;function m(h){const g=Date.now()-new Date(h).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(_e[26],ye([1,0,4,2,290,148,24,5]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=c,e.checkProposedApiEnabled=C,e.toExtension=h,e.toExtensionDescription=g,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:d.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class p{constructor(t){this.dependency=t}}e.MissingExtensionDependency=p;var a;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class I{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,i,r){this._versionId=t,this._allExtensions=i.slice(0),this._myExtensions=r.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,i,r){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const f=[],u=[],v=[],y=[],D=_(this._allExtensions),w=_(i),P=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this._allExtensions){const O=w.get(N.identifier);if(!O){f.push(N.identifier),D.delete(N.identifier);continue}if(!P(N,O)){f.push(N.identifier),D.delete(N.identifier);continue}}for(const N of i){const O=D.get(N.identifier);if(!O){u.push(N);continue}if(!P(O,N)){f.push(O.identifier),D.delete(O.identifier);continue}}const k=new L.ExtensionIdentifierSet(this._myExtensions),E=new L.ExtensionIdentifierSet(r);for(const N of this._myExtensions)E.has(N)||v.push(N);for(const N of r)k.has(N)||y.push(N);const S=R.ImplicitActivationEvents.createActivationEventsMap(u),M={versionId:t,toRemove:f,toAdd:u,addActivationEvents:S,myToRemove:v,myToAdd:y};return this.delta(M),M}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:f,myToAdd:u}=t,v=new L.ExtensionIdentifierSet(i),y=new L.ExtensionIdentifierSet(f);for(let D=0;D<this._allExtensions.length;D++)v.has(this._allExtensions[D].identifier)&&(this._allExtensions.splice(D,1),D--);for(let D=0;D<this._myExtensions.length;D++)y.has(this._myExtensions[D])&&(this._myExtensions.splice(D,1),D--);for(const D of r)this._allExtensions.push(D);for(const D of u)this._myExtensions.push(D);return this._myActivationEvents=null,t}containsExtension(t){for(const i of this._myExtensions)if(L.ExtensionIdentifier.equals(i,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const i of this._allExtensions){if(!this.containsExtension(i.identifier))continue;const r=R.ImplicitActivationEvents.readActivationEvents(i);for(const f of r)t.add(f)}return t}}e.ExtensionHostExtensions=I;function _(o){const t=new L.ExtensionIdentifierMap;for(const i of o)t.set(i.identifier,i);return t}function c(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function C(o,t){if(!c(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class b{constructor(t,i,r,f){this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=f}}e.ActivationTimes=b;class l{constructor(t,i){this.description=t,this.value=i}}e.ExtensionPointContribution=l;var m;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function h(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function g(o,t){const i=(0,T.getExtensionId)(o.manifest.publisher,o.manifest.name);return{id:i,identifier:new L.ExtensionIdentifier(i),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.onWillStop=s.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,i){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(_e[321],ye([1,0,14,159,24,26,12,9]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,s=ze(s);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(h,g,n,o){this.startup=h,this.codeLoadingTime=g,this.activateCallTime=n,this.activateResolvedTime=o}}e.ExtensionActivationTimes=p;class a{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,g){return h===-1||g===-1?-1:g-h}build(){return new p(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=a;class I{constructor(h,g,n,o,t,i){this.activationFailed=h,this.activationFailedError=g,this.activationTimes=n,this.module=o,this.exports=t,this.subscriptions=i}}e.ActivatedExtension=I;class _ extends I{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=_;class c extends I{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class C extends I{constructor(h){super(!0,h,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(h,g,n,o){this._logService=o,this._registry=h,this._globalRegistry=g,this._host=n,this._operations=new T.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,g]of this._operations)g.dispose()}async waitForActivatingExtensions(){const h=[];for(const[g,n]of this._operations)h.push(n.wait());await Promise.all(h)}isActivated(h){const g=this._operations.get(h);return!!(g&&g.value)}getActivatedExtension(h){const g=this._operations.get(h);if(!g||!g.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return g.value}async activateByEvent(h,g){if(this._alreadyActivatedEvents[h])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(n.map(o=>({id:o.identifier,reason:{startup:g,extensionId:o.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,g){const n=this._registry.getExtensionDescription(h);if(!n)throw new Error(`Extension '${h.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:g}])}async _activateExtensions(h){const g=h.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(g.map(n=>n.wait()))}_handleActivationRequest(h){if(this._operations.has(h.id))return this._operations.get(h.id);if(this._isHostExtension(h.id))return this._createAndSaveOperation(h,null,[],null);const g=this._registry.getExtensionDescription(h.id);if(!g){const t=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this._createAndSaveOperation(h,null,[],new C(t));return this._host.onExtensionActivationError(h.id,t,new R.MissingExtensionDependency(h.id.value)),i}const n=[],o=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const t of o){if(this._isResolvedExtension(t))continue;const i=this._operations.get(t);if(i){n.push(i);continue}if(this._isHostExtension(t)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(t).identifier,reason:h.reason}));continue}const r=this._registry.getExtensionDescription(t);if(r){if(!r.main&&!r.browser)continue;n.push(this._handleActivationRequest({id:r.identifier,reason:h.reason}));continue}const f=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${t}'`),v=this._createAndSaveOperation(h,g.displayName,[],new C(u));return this._host.onExtensionActivationError(g.identifier,u,new R.MissingExtensionDependency(t)),v}return this._createAndSaveOperation(h,g.displayName,n,null)}_createAndSaveOperation(h,g,n,o){const t=new l(h.id,g,h.reason,n,o,this._host,this._logService);return this._operations.set(h.id,t),t}_isHostExtension(h){return d.ExtensionDescriptionRegistry.isHostExtension(h,this._registry,this._globalRegistry)}_isResolvedExtension(h){const g=this._globalRegistry.getExtensionDescription(h);return g?!g.main&&!g.browser:!1}};e.ExtensionsActivator=b,e.ExtensionsActivator=b=Xe([He(3,L.ILogService)],b);let l=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(h,g,n,o,t,i,r){this._id=h,this._displayName=g,this._reason=n,this._deps=o,this._value=t,this._host=i,this._logService=r,this._barrier=new A.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const g=this._deps[h];if(g.value&&!g.value.activationFailed){this._deps.splice(h,1),h--;continue}if(g.value&&g.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);n.detail=g.value.activationFailedError,this._value=new C(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const g=new Error;if(h&&h.name&&(g.name=h.name),h&&h.message?g.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(g.stack=h.stack),this._value=new C(g),this._isDisposed&&s.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};l=Xe([He(6,L.ILogService)],l)});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[160],ye([1,0,260,14,44,147,117,37,24,116,148,144]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,s=ze(s),T=xt(T);const c=A.Registry.as(L.Extensions.JSONContribution);class C{constructor(t,i,r){this._messageHandler=t,this._extension=i,this._extensionPointId=r}_msg(t,i){this._messageHandler({type:t,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(T.default.Error,t)}warn(t){this._msg(T.default.Warning,t)}info(t){this._msg(T.default.Info,t)}}e.ExtensionMessageCollector=C;class b{static _toSet(t){const i=new p.ExtensionIdentifierSet;for(let r=0,f=t.length;r<f;r++)i.add(t[r].description.identifier);return i}static compute(t,i){if(!t||!t.length)return new b(i,[]);if(!i||!i.length)return new b([],t);const r=this._toSet(t),f=this._toSet(i),u=i.filter(y=>!r.has(y.description.identifier)),v=t.filter(y=>!f.has(y.description.identifier));return new b(u,v)}constructor(t,i){this.added=t,this.removed=i}}e.ExtensionPointUserDelta=b;class l{constructor(t,i){this.name=t,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=b.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,d.onUnexpectedError)(t)}}}e.ExtensionPoint=l;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(0,null),s.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:s.localize(2,null),properties:{vscode:{type:"string",description:s.localize(3,null),default:"^1.22.0"}}},publisher:{description:s.localize(4,null),type:"string"},displayName:{description:s.localize(5,null),type:"string"},categories:{description:s.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:s.localize(7,null)}]}},galleryBanner:{type:"object",description:s.localize(8,null),properties:{color:{description:s.localize(9,null),type:"string"},theme:{description:s.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(13,null)},enabledApiProposals:{markdownDescription:s.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(_.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:s.localize(15,null),type:"string",enum:["none"],enumDescriptions:[s.localize(16,null)]},activationEvents:{description:s.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(32,null)},{label:"onUri",body:"onUri",description:s.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(37,null)},{label:"onRenderer",description:s.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:s.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:s.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:s.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:s.localize(44,null)},{label:"*",description:s.localize(45,null),body:"*"}]}},badges:{type:"array",description:s.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(47,null)},href:{type:"string",description:s.localize(48,null)},description:{type:"string",description:s.localize(49,null)}}}},markdown:{type:"string",description:s.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:s.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:s.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(55,null)},{body:["workspace"],description:s.localize(56,null)},{body:["ui","workspace"],description:s.localize(57,null)},{body:["workspace","ui"],description:s.localize(58,null)},{body:[],description:s.localize(59,null)}]},capabilities:{description:s.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(63,null),s.localize(64,null),s.localize(65,null)]},description:{type:"string",markdownDescription:s.localize(66,null)}}},untrustedWorkspaces:{description:s.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(69,null),s.localize(70,null),s.localize(71,null)]},restrictedConfigurations:{description:s.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(73,null)}}}}},sponsor:{description:s.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(76,null),type:"string"},"vscode:uninstall":{description:s.localize(77,null),type:"string"}}},icon:{type:"string",description:s.localize(78,null)},l10n:{type:"string",description:s.localize(79,null)},pricing:{type:"string",markdownDescription:s.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const i=new l(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,i),t.activationEventsGenerator&&I.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,c.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=g;const n={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(n.ExtensionsRegistry,new g),e.ExtensionsRegistry=A.Registry.as(n.ExtensionsRegistry),c.registerSchema(h,e.schema),c.registerSchema(a.productSchemaId,{properties:{extensionEnabledApiProposals:{description:s.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals),markdownEnumDescriptions:Object.values(_.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(_e[322],ye([1,0,4,40,3,13,251,24,5,12,26,160]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var c;(function(l){l[l.System=0]="System",l[l.User=1]="User",l[l.Assistant=2]="Assistant"})(c||(e.ChatMessageRole=c={})),e.ILanguageModelsService=(0,p.createDecorator)("ILanguageModelsService");const C={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.languageModelExtensionPoint=_.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[C,{type:"array",items:C}]},activationEventsGenerator:(l,m)=>{for(const h of l)m.push(`onLanguageModelChat:${h.vendor}`)}});let b=class{constructor(m,h){this._extensionService=m,this._logService=h,this._store=new T.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new s.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(g=>{this._vendors.clear();for(const o of g){if(!(0,I.isProposedApiEnabled)(o.description,"chatProvider")){o.collector.error((0,L.localize)(2,null));continue}for(const t of d.Iterable.wrap(o.value)){if(this._vendors.has(t.vendor)){o.collector.error((0,L.localize)(3,null,t.vendor));continue}if((0,R.isFalsyOrWhitespace)(t.vendor)){o.collector.error((0,L.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,L.localize)(5,null));continue}this._vendors.add(t.vendor)}}const n=[];for(const[o,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(o),n.push(o));n.length>0&&this._onDidChangeProviders.fire({removed:n})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(m){return this._providers.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const g=Array.from(this._vendors).map(n=>this._extensionService.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(g)}const h=[];for(const[g,n]of this._providers)(m.vendor===void 0||n.metadata.vendor===m.vendor)&&(m.family===void 0||n.metadata.family===m.family)&&(m.version===void 0||n.metadata.version===m.version)&&(m.identifier===void 0||n.metadata.id===m.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>A.ExtensionIdentifier.equals(o,m.extension)))&&h.push(g);return this._logService.trace("[LM] selected language models",m,h),h}registerLanguageModelChat(m,h){if(this._logService.trace("[LM] registering language model chat",m,h.metadata),!this._vendors.has(h.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${h.metadata.vendor}.`);if(this._providers.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this._providers.set(m,h),this._onDidChangeProviders.fire({added:[{identifier:m,metadata:h.metadata}]}),(0,T.toDisposable)(()=>{this._providers.delete(m)&&(this._onDidChangeProviders.fire({removed:[m]}),this._logService.trace("[LM] UNregistered language model chat",m,h.metadata))})}async sendChatRequest(m,h,g,n,o){const t=this._providers.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(g,h,n,o)}computeTokenLength(m,h,g){const n=this._providers.get(m);if(!n)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return n.provideTokenCount(h,g)}};e.LanguageModelsService=b,e.LanguageModelsService=b=Xe([He(0,I.IExtensionService),He(1,a.ILogService)],b)}),define(_e[323],ye([1,0,255,18,25,160,36,4]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,s=ze(s),d=ze(d),T=ze(T);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(2,null),default:""}}};var a;(function(c){function C(b,l,m){if(!b)return;const h=d.isString(b.type)?b.type:void 0;if(!h||h.length===0){m.error(s.localize(3,null));return}const g=[];if(Array.isArray(b.required))for(const n of b.required)d.isString(n)&&g.push(n);return{extensionId:l.value,taskType:h,required:g,properties:b.properties?T.deepClone(b.properties):{},when:b.when?L.ContextKeyExpr.deserialize(b.when):void 0}}c.from=C})(a||(a={}));const I=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,C)=>{for(const b of c)b.type&&C.push(`onTaskType:${b.type}`)},jsonSchema:{description:s.localize(4,null),type:"array",items:p}});class _{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,b)=>{I.setHandler((l,m)=>{this._schema=void 0;try{for(const h of m.removed){const g=h.value;for(const n of g)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const h of m.added){const g=h.value;for(const n of g){const o=a.from(n,h.description.identifier,h.collector);o&&(this.taskTypes[o.taskType]=o)}}(m.removed.length>0||m.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const b of this.all()){const l={type:"object",additionalProperties:!1};b.required.length>0&&(l.required=b.required.slice(0)),b.properties!==void 0?l.properties=T.deepClone(b.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[b.taskType]},C.push(l)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistry=new _}),define(_e[324],ye([1,0,256,18,23,25,36,323,45]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,s=ze(s),d=ze(d),T=ze(T),R=ze(R),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new L.RawContextKey("taskRunning",!1,s.localize(0,null)),e.TASKS_CATEGORY=s.localize2(2,"Tasks");var a;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function H(j){if(!j)return F.Strong;switch(j.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=H}(a||(e.ShellQuoting=a={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var _;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(_||(e.RevealKind=_={})),function(F){function H(j){switch(j.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=H}(_||(e.RevealKind=_={}));var c;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(c||(e.RevealProblemKind=c={})),function(F){function H(j){switch(j.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=H}(c||(e.RevealProblemKind=c={}));var C;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(C||(e.PanelKind=C={})),function(F){function H(j){switch(j.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=H}(C||(e.PanelKind=C={}));var b;(function(F){F.defaults={echo:!0,reveal:_.Always,revealProblems:c.Never,focus:!1,panel:C.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var l;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(l||(e.RuntimeType=l={})),function(F){function H(re){switch(re.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=H;function j(re){switch(re){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=j}(l||(e.RuntimeType=l={}));var m;(function(F){function H(j){return d.isString(j)?j:j.value}F.value=H})(m||(e.CommandString=m={}));var h;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function H(re){return re===F.Clean._id||re===F.Build._id||re===F.Rebuild._id||re===F.Test._id}F.is=H;function j(re){if(re!==void 0)return d.isString(re)?H(re)?{_id:re,isDefault:!1}:void 0:re}F.from=j})(h||(e.TaskGroup=h={}));var g;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function H(j){switch(j){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=H})(n||(e.TaskSourceKind=n={}));var o;(function(F){F.parallel="parallel",F.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var i;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class r{constructor(H,j,re,B,V,X){this._label="",this._id=H,j&&(this._label=j),re&&(this.type=re),this.runOptions=B,this.configurationProperties=V,this._source=X}getDefinition(H){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const H={folder:this.getFolderId(),id:this._id};return JSON.stringify(H)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(H,j=!1){if(H===void 0)return!1;if(d.isString(H))return H===this._label||H===this.configurationProperties.identifier||j&&H===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===H._key}getQualifiedLabel(){const H=this.getWorkspaceFolder();return H?`${this._label} (${H.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(H){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),H&&(this._taskLoadMessages=this._taskLoadMessages.concat(H))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class f extends r{constructor(H,j,re,B,V,X,ee,he){super(H,re,void 0,ee,he,j),this.command={},this._source=j,this.hasDefinedMatchers=X,V&&(this.command=V)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(H=!1){if(H&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case l.Shell:j="shell";break;case l.Process:j="process";break;case l.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(H){return H instanceof f}getMapKey(){const H=this._source.config.workspaceFolder;return H?`${H.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const H=this.getFolderId();if(!H)return;let j=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(j+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:j};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(H){return new f(H._id,H._source,H._label,H.type,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.CustomTask=f;class u extends r{constructor(H,j,re,B,V,X,ee){super(H,re,B,X,ee,j),this._source=j,this.configures=V}static is(H){return H instanceof u}fromObject(H){return H}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const H=this.getFolderId();if(!H)return;let j=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(j+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:j};return JSON.stringify(re)}}e.ConfiguringTask=u;class v extends r{constructor(H,j,re,B,V,X,ee,he,ne){super(H,re,B,he,ne,j),this.defines=V,this.hasDefinedMatchers=ee,this.command=X,this.icon=ne.icon,this.hide=ne.hide}clone(){return new v(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(H){return H instanceof v}getMapKey(){const H=this._source.workspaceFolder;return H?`${this._source.scope.toString()}|${H.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===g.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const H={type:"contributed",scope:this._source.scope,id:this._id};return H.folder=this.getFolderId(),JSON.stringify(H)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(H){return new v(H._id,H._source,H._label,H.type,H.defines,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.ContributedTask=v;class y extends r{constructor(H,j,re,B,V,X){super(H,re,B,V,X,j),this._source=j}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(H){return H instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(H){return new y(H._id,H._source,H._label,H.type,H.runOptions,H.configurationProperties)}}e.InMemoryTask=y;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var w;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class P{constructor(H){this._order=new Map;for(let j=0;j<H.length;j++)this._order.set(H[j].uri.toString(),j)}compare(H,j){const re=H.getWorkspaceFolder(),B=j.getWorkspaceFolder();if(re&&B){let V=this._order.get(re.uri.toString());V=V===void 0?0:V+1;let X=this._order.get(B.uri.toString());return X=X===void 0?0:X+1,V===X?H._label.localeCompare(j._label):V-X}else return!re&&B?-1:re&&!B?1:0}}e.TaskSorter=P;var k;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(k||(e.TaskEventKind=k={}));var E;(function(F){F.SingleRun="singleRun",F.Background="background"})(E||(e.TaskRunType=E={}));var S;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var M;(function(F){function H(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?E.Background:E.SingleRun,group:he.configurationProperties.group,__task:he}}function j(he,ne,De){return{...H(he),kind:k.Start,terminalId:ne,resolvedVariables:De}}F.start=j;function re(he,ne,De){return{...H(he),kind:k.ProcessStarted,terminalId:ne,processId:De}}F.processStarted=re;function B(he,ne,De){return{...H(he),kind:k.ProcessEnded,terminalId:ne,exitCode:De}}F.processEnded=B;function V(he,ne,De){return{...H(he),kind:k.Terminated,exitReason:De,terminalId:ne}}F.terminated=V;function X(he,ne,De){return{...H(ne),kind:he,terminalId:De}}F.general=X;function ee(){return{kind:k.Changed}}F.changed=ee})(M||(e.TaskEvent=M={}));var N;(function(F){function H(re){const B=Object.keys(re).sort();let V="";for(const X of B){let ee=re[X];ee instanceof Object?ee=H(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),V+=X+","+ee+","}return V}function j(re){const V={_key:H(re),type:re.taskType};return Object.assign(V,re),V}F.create=j})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var x;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var U;(function(F){function H(j,re){const B=A.TaskDefinitionRegistry.get(j.type);if(B===void 0){const he=R.deepClone(j);return delete he._key,N.create(he)}const V=Object.create(null);V.type=B.taskType;const X=new Set;B.required.forEach(he=>X.add(he));const ee=B.properties;for(const he of Object.keys(ee)){const ne=j[he];if(ne!=null)V[he]=ne;else if(X.has(he)){const De=ee[he];if(De.default!==void 0)V[he]=R.deepClone(De.default);else switch(De.type){case"boolean":V[he]=!1;break;case"number":case"integer":V[he]=0;break;case"string":V[he]="";break;default:re.error(s.localize(1,null,JSON.stringify(j,void 0,0),he));return}}}return N.create(V)}F.createTaskIdentifier=H})(U||(e.TaskDefinition=U={}))}),define(_e[325],ye([1,0,14]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class d{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((L,A)=>{this._actualOk=L,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(L){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=L,this._actual&&this._actualOk(L))}resolveErr(L){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=L,this._actual?this._actualErr(L):(0,s.onUnexpectedError)(L))}then(L,A){return this._ensureActual().then(L,A)}catch(L){return this._ensureActual().then(void 0,L)}finally(L){return this._ensureActual().finally(L)}}e.LazyPromise=d;class T extends d{constructor(){super(),this._hasErr=!0,this._err=new s.CancellationError}}e.CanceledLazyPromise=T}),define(_e[52],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=T,e.getStringIdentifierForProxy=R;class s{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++s.count}}e.ProxyIdentifier=s;const d=[];function T(A){const p=new s(A);return d[p.nid]=p,p}function R(A){return d[A].sid}class L{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=L}),define(_e[6],ye([1,0,52]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var d;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(d||(e.TextEditorRevealType=d={}));var T;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput",l[l.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(T||(e.TabInputKind=T={}));var R;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var A;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var p;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var a;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output",l[l.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class _{static{this._n=0}static mixin(m){return m._id=_._n++,m}}e.IdObject=_;var c;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var C;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var b;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.MainContext={MainThreadAuthentication:(0,s.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,s.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,s.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,s.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,s.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,s.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,s.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,s.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,s.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,s.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,s.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,s.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,s.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,s.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,s.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,s.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,s.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,s.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,s.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,s.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,s.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,s.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,s.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,s.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,s.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,s.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,s.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,s.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,s.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,s.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,s.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,s.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,s.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,s.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,s.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,s.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,s.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,s.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,s.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,s.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,s.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,s.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,s.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,s.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,s.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,s.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,s.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,s.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,s.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,s.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,s.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,s.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,s.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,s.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,s.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,s.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,s.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,s.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,s.createProxyIdentifier)("ExtHostLocalization")}}),define(_e[96],ye([1,0,5,12,6,20]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,T=ze(T),e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let L=class{constructor(p,a){this._extHostLogService=a,this._reportedUsages=new Set,this._telemetryShape=p.getProxy(T.MainContext.MainThreadTelemetry)}report(p,a,I){const _=this.getUsageKey(p,a);this._reportedUsages.has(_)||(this._reportedUsages.add(_),a.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:p}))}getUsageKey(p,a){return`${p}-${a.identifier.value}`}};e.ExtHostApiDeprecationService=L,e.ExtHostApiDeprecationService=L=Xe([He(0,R.IExtHostRpcService),He(1,d.ILogService)],L),e.NullApiDeprecationService=Object.freeze(new class{report(A,p,a){}})}),define(_e[326],ye([1,0,6]),function(le,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class d{constructor(R){const L=R.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(A){return L.$writeText(A)}})}}e.ExtHostClipboard=d}),define(_e[327],ye([1,0,25,6,30,20]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let L=class{constructor(I,_){this._mainThreadConsole=I.getProxy(d.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(I,_){const c=this,C=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){c._handleConsoleCall(I,_,C,arguments)}})}_handleConsoleCall(I,_,c,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:p(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(I,c,C)}};e.AbstractExtHostConsoleForwarder=L,e.AbstractExtHostConsoleForwarder=L=Xe([He(0,R.IExtHostRpcService),He(1,T.IExtHostInitDataService)],L);const A=1e5;function p(a,I){const _=[];if(a.length)for(let c=0;c<a.length;c++){let C=a[c];if(typeof C>"u")C="undefined";else if(C instanceof Error){const b=C;b.stack?C=b.stack:C=b.toString()}_.push(C)}if(I){const c=new Error().stack;c&&_.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,s.safeStringify)(_);return c.length>A?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(_e[328],ye([1,0,2,6,26]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(A){this._proxy=A.getProxy(d.MainContext.MainThreadDialogs)}showOpenDialog(A,p){return p?.allowUIResources&&(0,T.checkProposedApiEnabled)(A,"showLocal"),this._proxy.$showOpenDialog(p).then(a=>a?a.map(I=>s.URI.revive(I)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(p=>p?s.URI.revive(p):void 0)}}e.ExtHostDialogs=R}),define(_e[329],ye([1,0,21,4,3,6]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class L{constructor(p){this._provider=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(p,a,I){if(this._allKnownModels.has(a))throw new Error("An embeddings provider for this model is already registered");const _=this._handlePool++;return this._proxy.$registerEmbeddingProvider(_,a),this._provider.set(_,{id:a,provider:I}),(0,T.toDisposable)(()=>{this._proxy.$unregisterEmbeddingProvider(_),this._provider.delete(_)})}async computeEmbeddings(p,a,I){I??=s.CancellationToken.None;let _=!1;typeof a=="string"&&(a=[a],_=!0);const c=await this._proxy.$computeEmbeddings(p,a,I);if(c.length!==a.length)throw new Error;if(_){if(c.length!==1)throw new Error;return c[0]}return c}async $provideEmbeddings(p,a,I){const _=this._provider.get(p);if(!_)return[];const c=await _.provider.provideEmbeddings(a,I);return c||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(p){this._allKnownModels=new Set(p),this._onDidChange.fire()}}e.ExtHostEmbeddings=L}),define(_e[330],ye([1,0,3,6]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(L){this._handlePool=0,this._proxy=L.getProxy(d.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(L){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,L),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(_e[123],ye([1,0,11,13,2,5,12,6,30,20]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let I=class{constructor(c,C,b){this.logService=b,this.bundleCache=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=c.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===s.LANGUAGE_DEFAULT}getMessage(c,C){const{message:b,args:l,comment:m}=C;if(this.isDefaultLanguage)return(0,d.format2)(b,l??{});let h=b;m&&m.length>0&&(h+=`/${Array.isArray(m)?m.join(""):m}`);const g=this.bundleCache.get(c)?.contents[h];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,d.format2)(g??b,l??{})}getBundle(c){return this.bundleCache.get(c)?.contents}getBundleUri(c){return this.bundleCache.get(c)?.uri}async initializeLocalizedMessages(c){if(this.isDefaultLanguage||!c.l10n&&!c.isBuiltin||this.bundleCache.has(c.identifier.value))return;let C;const b=await this.getBundleLocation(c);if(!b){this.logService.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const l=await this._proxy.$fetchBundleContents(b),m=JSON.parse(l);C=c.isBuiltin?m.contents?.bundle:m}catch(l){this.logService.error(`Failed to load translations for ${c.identifier.value} from ${b}: ${l.message}`);return}C&&this.bundleCache.set(c.identifier.value,{contents:C,uri:b})}async getBundleLocation(c){if(c.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(c.identifier.value,this.currentLanguage);return T.URI.revive(C)}return c.l10n?T.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=I,e.ExtHostLocalizationService=I=Xe([He(0,p.IExtHostInitDataService),He(1,a.IExtHostRpcService),He(2,L.ILogService)],I),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(_e[161],ye([1,0,12,6,30,20,2,57]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let p=class extends s.AbstractLoggerService{constructor(_,c){super(c.logLevel,c.logsLocation,c.loggers.map(C=>(0,A.revive)(C))),this._proxy=_.getProxy(d.MainContext.MainThreadLogger)}$setLogLevel(_,c){c?this.setLogLevel(L.URI.revive(c),_):this.setLogLevel(_)}setVisibility(_,c){super.setVisibility(_,c),this._proxy.$setVisibility(_,c)}doCreateLogger(_,c,C){return new a(this._proxy,_,c,C)}};e.ExtHostLoggerService=p,e.ExtHostLoggerService=p=Xe([He(0,R.IExtHostRpcService),He(1,T.IExtHostInitDataService)],p);class a extends s.AbstractMessageLogger{constructor(_,c,C,b){super(b?.logLevel==="always"),this.proxy=_,this.file=c,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(C),this.proxy.$createLogger(c,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,c){const C=[[_,c]];this.isLoggerCreated?this.doLog(C):this.buffer.push(...C)}doLog(_){this.proxy.$log(this.file,_)}flush(){this.proxy.$flush(this.file)}}}),define(_e[124],ye([1,0,6,5,3,20,22]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,d.createDecorator)("IExtHostManagedSockets");let A=class{constructor(_){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=_.getProxy(s.MainContext.MainThreadManagedSockets)}setFactory(_,c){for(const C of this._managedRemoteSockets.values())C.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new p(_,c),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(_){if(!this._factory||this._factory.socketFactoryId!==_)throw new Error(`No socket factory with id ${_}`);const c=++this._remoteSocketIdCounter,C=await this._factory.makeConnection(),b=new T.DisposableStore;return this._managedRemoteSockets.set(c,new a(c,C,b)),b.add((0,T.toDisposable)(()=>this._managedRemoteSockets.delete(c))),b.add(C.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(c),b.dispose()})),b.add(C.onDidClose(l=>{this._proxy.$onDidManagedSocketClose(c,l?.stack??l?.message),b.dispose()})),b.add(C.onDidReceiveMessage(l=>this._proxy.$onDidManagedSocketHaveData(c,L.VSBuffer.wrap(l)))),c}$remoteSocketWrite(_,c){this._managedRemoteSockets.get(_)?.actual.send(c.buffer)}$remoteSocketEnd(_){const c=this._managedRemoteSockets.get(_);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(_){await this._managedRemoteSockets.get(_)?.actual.drain?.()}};e.ExtHostManagedSockets=A,e.ExtHostManagedSockets=A=Xe([He(0,R.IExtHostRpcService)],A);class p{constructor(_,c){this.socketFactoryId=_,this.makeConnection=c}}class a extends T.Disposable{constructor(_,c,C){super(),this.socketId=_,this.actual=c,this._register(C)}}}),define(_e[331],ye([1,0,6,12,26]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let L=class{constructor(p,a){this._logService=a,this._proxy=p.getProxy(s.MainContext.MainThreadMessageService)}showMessage(p,a,I,_,c){const C={source:{identifier:p.identifier,label:p.displayName||p.name}};let b;typeof _=="string"||R(_)?b=[_,...c]:(C.modal=_?.modal,C.useCustom=_?.useCustom,C.detail=_?.detail,b=c),C.useCustom&&(0,T.checkProposedApiEnabled)(p,"resolvers");const l=[];let m=!1;for(let h=0;h<b.length;h++){const g=b[h];if(typeof g=="string")l.push({title:g,handle:h,isCloseAffordance:!1});else if(typeof g=="object"){const{title:n,isCloseAffordance:o}=g;l.push({title:n,isCloseAffordance:!!o,handle:h}),o&&(m?this._logService.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,g):m=!0)}else this._logService.warn(`[${p.identifier}] Invalid message item:`,g)}return this._proxy.$showMessage(a,I,C,l).then(h=>{if(typeof h=="number")return b[h]})}};e.ExtHostMessageService=L,e.ExtHostMessageService=L=Xe([He(1,d.ILogService)],L)}),define(_e[332],ye([1,0,3,18,2,26,6]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(a){this.handlers=new Map,this.proxy=a.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,I,_){if((0,R.checkProposedApiEnabled)(a,"profileContentHandlers"),this.handlers.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.handlers.set(I,_),this.proxy.$registerProfileContentHandler(I,_.name,_.description,a.identifier.value),(0,s.toDisposable)(()=>{this.handlers.delete(I),this.proxy.$unregisterProfileContentHandler(I)})}async $saveProfile(a,I,_,c){const C=this.handlers.get(a);if(!C)throw new Error(`Unknown handler with id: ${a}`);return C.saveProfile(I,_,c)}async $readProfile(a,I,_){const c=this.handlers.get(a);if(!c)throw new Error(`Unknown handler with id: ${a}`);return c.readProfile((0,d.isString)(I)?I:T.URI.revive(I),_)}}e.ExtHostProfileContentHandlers=A}),define(_e[125],ye([1,0,6,4,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this._onDidChangePassword=new d.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,p){return this._proxy.$getPassword(A,p)}store(A,p,a){return this._proxy.$setPassword(A,p,a)}delete(A,p){return this._proxy.$deletePassword(A,p)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(_e[333],ye([1,0,21,3,6]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class R{static{this.ID_POOL=1}constructor(A){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=A.getProxy(T.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(A,p,a){const I=this.providers.get(A);if(!I)return;const _=new d.DisposableStore,c=new s.CancellationTokenSource;this.sessions.set(p,c);const C=await I.provideSpeechToTextSession(c.token,a?{language:a}:void 0);C&&(_.add(C.onDidChange(b=>{c.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(p,b)})),_.add(c.token.onCancellationRequested(()=>_.dispose())))}async $cancelSpeechToTextSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A)}async $createTextToSpeechSession(A,p,a){const I=this.providers.get(A);if(!I)return;const _=new d.DisposableStore,c=new s.CancellationTokenSource;this.sessions.set(p,c);const C=await I.provideTextToSpeechSession(c.token,a?{language:a}:void 0);C&&(this.synthesizers.set(p,C),_.add(C.onDidChange(b=>{c.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(p,b)})),_.add(c.token.onCancellationRequested(()=>_.dispose())))}async $synthesizeSpeech(A,p){this.synthesizers.get(A)?.synthesize(p)}async $cancelTextToSpeechSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A),this.synthesizers.delete(A)}async $createKeywordRecognitionSession(A,p){const a=this.providers.get(A);if(!a)return;const I=new d.DisposableStore,_=new s.CancellationTokenSource;this.sessions.set(p,_);const c=await a.provideKeywordRecognitionSession(_.token);c&&(I.add(c.onDidChange(C=>{_.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(p,C)})),I.add(_.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(A){this.sessions.get(A)?.dispose(!0),this.sessions.delete(A)}registerProvider(A,p,a){const I=R.ID_POOL++;return this.providers.set(I,a),this.proxy.$registerProvider(I,p,{extension:A,displayName:A.value}),(0,d.toDisposable)(()=>{this.proxy.$unregisterProvider(I),this.providers.delete(I)})}}e.ExtHostSpeech=R}),define(_e[126],ye([1,0,6,4,5]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,p){this._logService=p,this._onDidChangeStorage=new d.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,p){this._proxy.$registerExtensionStorageKeysToSync(A,p)}async initializeExtensionStorage(A,p,a){const I=await this._proxy.$initializeExtensionStorage(A,p);let _;return I&&(_=this.safeParseValue(A,p,I)),_||a}setValue(A,p,a){return this._proxy.$setValue(A,p,a)}$acceptValue(A,p,a){const I=this.safeParseValue(A,p,a);I&&this._onDidChangeStorage.fire({shared:A,key:p,value:I})}safeParseValue(A,p,a){try{return JSON.parse(a)}catch(I){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${A}): ${I}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(_e[334],ye([1,0,3,15,2,6]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class L{static{this.supportedSchemes=new Set([d.Schemas.http,d.Schemas.https])}constructor(p){this._openers=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(p,a,I,_){if(this._openers.has(a))throw new Error(`Opener with id '${a}' already registered`);const c=_.schemes.find(C=>!L.supportedSchemes.has(C));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(a,I),this._proxy.$registerUriOpener(a,_.schemes,p,_.label),(0,s.toDisposable)(()=>{this._openers.delete(a),this._proxy.$unregisterUriOpener(a)})}async $canOpenUri(p,a,I){const _=this._openers.get(p);if(!_)throw new Error(`Unknown opener with id: ${p}`);const c=T.URI.revive(a);return _.canOpenExternalUri(c,I)}async $openUri(p,a,I){const _=this._openers.get(p);if(!_)throw new Error(`Unknown opener id: '${p}'`);return _.openExternalUri(T.URI.revive(a.resolvedUri),{sourceUri:T.URI.revive(a.sourceUri)},I)}}e.ExtHostUriOpeners=L}),define(_e[335],ye([1,0,6,2,3,14,24]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{static{this.HandlePool=0}constructor(a){this.handles=new L.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=a.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(a,I){const _=a.identifier;if(this.handles.has(_))throw new Error(`Protocol handler already registered for extension ${_}`);const c=A.HandlePool++;return this.handles.add(_),this.handlers.set(c,I),this._proxy.$registerUriHandler(c,_,a.displayName||a.name),(0,T.toDisposable)(()=>{this.handles.delete(_),this.handlers.delete(c),this._proxy.$unregisterUriHandler(c)})}$handleExternalUri(a,I){const _=this.handlers.get(a);if(!_)return Promise.resolve(void 0);try{_.handleUri(d.URI.revive(I))}catch(c){(0,R.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(a){return d.URI.revive(await this._proxy.$createAppUri(a))}}e.ExtHostUrls=A}),define(_e[336],ye([1,0,22,6]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=R,e.deserializeWebviewMessage=A,d=ze(d);class T{constructor(){this.buffers=[]}add(a){let I=this.buffers.indexOf(a);return I<0&&(I=this.buffers.length,this.buffers.push(a)),I}}function R(p,a){if(a.serializeBuffersForPostMessage){const I=new T,c=JSON.stringify(p,(b,l)=>{if(l instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(l)};if(ArrayBuffer.isView(l)){const m=L(l);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(l.buffer),view:{type:m,byteLength:l.byteLength,byteOffset:l.byteOffset}}}return l}),C=I.buffers.map(b=>{const l=new Uint8Array(b);return s.VSBuffer.wrap(l)});return{message:c,buffers:C}}else return{message:JSON.stringify(p),buffers:[]}}function L(p){switch(p.constructor.name){case"Int8Array":return d.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return d.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return d.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return d.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return d.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return d.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return d.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return d.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return d.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return d.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return d.WebviewMessageArrayBufferViewType.BigUint64Array}}function A(p,a){const I=a.map(C=>{const b=new ArrayBuffer(C.byteLength);return new Uint8Array(b).set(C.buffer),b}),_=a.length?(C,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const l=b,{index:m}=l,h=I[m];if(l.view)switch(l.view.type){case d.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(h,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(h,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(h,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(h,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(h,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(h,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(h,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(h,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(h,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(h,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(h,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return b}:void 0;return{message:JSON.parse(p,_),arrayBuffers:I}}}),define(_e[97],ye([1,0,4,3,15,25,2,285,336,122,6]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=c,e.toExtensionData=l,e.serializeWebviewOptions=m,R=ze(R),I=ze(I);class _{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(o,t,i,r,f,u,v){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new s.Emitter,this._onDidDispose=this.#d.event,this.#e=o,this.#t=t,this.#o=i,this.#n=r,this.#s=f,this.#r=u,this.#u=c(u),this.#h=C(u),this.#i=v}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#c=!0,(0,a.asWebviewUri)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===T.Schemas.https||o.scheme===T.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+a.webviewGenericCspSource}return a.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(o){this.assertNotDisposed(),this.#a!==o&&(this.#a=o,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(o)))}get options(){return this.assertNotDisposed(),this.#o}set options(o){this.assertNotDisposed(),R.equals(this.#o,o)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#l)return!1;const t=(0,p.serializeWebviewMessage)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(o){if(!this.#h)return o;const t=this.#r.extensionLocation?.scheme===T.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===T.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,f,u,v,y,D)=>{const w=L.URI.from({scheme:v||"file",path:decodeURIComponent(y)}),P=(0,a.asWebviewUri)(w,{isRemote:t,authority:i}).toString();return`${f}${P}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,f,u,v,y,D)=>{const w=L.URI.from({scheme:v||"file",path:decodeURIComponent(y)}),P=(0,a.asWebviewUri)(w,{isRemote:t,authority:i}).toString();return`${f}${P}${D}`})}}e.ExtHostWebview=_;function c(n){try{const o=(0,A.normalizeVersion)((0,A.parseVersion)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function C(n){try{const o=(0,A.normalizeVersion)((0,A.parseVersion)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class b extends d.Disposable{constructor(o,t,i,r,f){super(),this.remoteInfo=t,this.workspace=i,this._logService=r,this._deprecationService=f,this._webviews=new Map,this._webviewProxy=o.getProxy(I.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const o of this._webviews.values())o.dispose();this._webviews.clear()}$onMessage(o,t,i){const r=this.getWebview(o);if(r){const{message:f}=(0,p.deserializeWebviewMessage)(t,i.value);r._onMessageEmitter.fire(f)}}$onMissingCsp(o,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,i){const r=new _(o,this._webviewProxy,h(t),this.remoteInfo,this.workspace,i,this._deprecationService);this._webviews.set(o,r);const f=r._onDidDispose(()=>{f.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=b;function l(n){return{id:n.identifier,location:n.extensionLocation}}function m(n,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||g(n,o)}}function h(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function g(n,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),n.extensionLocation]}}),define(_e[162],ye([1,0,4,15,13,2,5,20,6]),function(le,e,s,d,T,R,L,A,p){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{a=this}static{this.InitialState={focused:!0,active:!0}}getState(){const c=this._state;return{get focused(){return c.focused},get active(){return c.active}}}constructor(c){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=a.InitialState,this._proxy=c.getProxy(p.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:b})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,C){C!==this._state[c]&&(this._state={...this._state,[c]:C},this._onDidChangeWindowState.fire(this._state))}openUri(c,C){let b;if(typeof c=="string"){b=c;try{c=R.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,T.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===d.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this._proxy.$openUri(c,b,C)}async asExternalUri(c,C){if((0,T.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(c,C);return R.URI.from(b)}};e.ExtHostWindow=I,e.ExtHostWindow=I=a=Xe([He(0,A.IExtHostRpcService)],I),e.IExtHostWindow=(0,L.createDecorator)("IExtHostWindow")}),define(_e[337],ye([1,0,327,30,20,94]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let A=class extends s.AbstractExtHostConsoleForwarder{constructor(a,I){super(a,I),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(a,I,_){const c=a==="error"||a==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,c.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,_),c.write(`
${R.NativeLogMarkers.End}
`),this._isMakingConsoleCall=!1}_wrapStream(a,I){const _=process[a],c=_.write;let C="";Object.defineProperty(_,"write",{set:()=>{},get:()=>(b,l,m)=>{if(!this._isMakingConsoleCall){C+=b.toString(l);const h=C.length>L?C.length:C.lastIndexOf(`
`);h!==-1&&(console[I](C.slice(0,h)),C=C.slice(h+1))}c.call(_,b,l,m)}})}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=Xe([He(0,T.IExtHostRpcService),He(1,d.IExtHostInitDataService)],A)}),define(_e[338],ye([1,0,161,15,279,32]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class L extends s.ExtHostLoggerService{doCreateLogger(p,a,I){return p.scheme===d.Schemas.file?new T.SpdLogLogger(I?.name||(0,R.generateUuid)(),p.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,a):super.doCreateLogger(p,a,I)}registerLogger(p){super.registerLogger(p),this._proxy.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this._proxy.$deregisterLogger(p)}}e.ExtHostLoggerService=L}),define(_e[339],ye([1,0,9,22,21,27,14,4,3,41,142,325,52]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=g,e.parseJsonAndRestoreBufferRefs=n,L=ze(L);function b(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const l="$$ref$$",m={[l]:-1};class h{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function g(M,N=null,O=!1){const x=[];return{jsonString:(O?b:JSON.stringify)(M,(F,H)=>{if(typeof H>"u")return m;if(typeof H=="object"){if(H instanceof d.VSBuffer){const j=x.push(H)-1;return{[l]:j}}if(N)return N(F,H)}return H}),referencedBuffers:x}}function n(M,N,O){return JSON.parse(M,(x,U)=>{if(U){const F=U[l];if(typeof F=="number")return N[F];if(O&&U.$mid===a.MarshalledId.Uri)return O.transformIncoming(U)}return U})}function o(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,O)=>O&&O.$mid===a.MarshalledId.Uri?M.transformOutgoing(O):O:null}var i;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var r;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const f=()=>{},u=Symbol.for("rpcProtocol"),v=Symbol.for("rpcProxy");class y extends p.Disposable{static{C=u}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(N,O=null,x=null){super(),this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=N,this._logger=O,this._uriTransformer=x,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,F=c.ProxyIdentifier.count;U<F;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=r.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(U=>this._receiveOneMessage(U)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(N=>{const O=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],O.resolveErr(L.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(N){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+y.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(N){this._unresponsiveTime=Date.now()+y.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(r.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(r.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(N){this._responsiveState!==N&&(this._responsiveState=N,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(N){return this._uriTransformer?(0,I.transformIncomingURIs)(N,this._uriTransformer):N}getProxy(N){const{nid:O,sid:x}=N;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,x)),this._proxies[O]}_createProxy(N,O){const x={get:(U,F)=>(typeof F=="string"&&!U[F]&&F.charCodeAt(0)===R.CharCode.DollarSign&&(U[F]=(...H)=>this._remoteCall(N,F,H)),F===v?O:U[F])};return new Proxy(Object.create(null),x)}set(N,O){return this._locals[N.nid]=O,O}assertRegistered(N){for(let O=0,x=N.length;O<x;O++){const U=N[O];if(!this._locals[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}_receiveOneMessage(N){if(this._isDisposed)return;const O=N.byteLength,x=w.read(N,0),U=x.readUInt8(),F=x.readUInt32();switch(U){case E.RequestJSONArgs:case E.RequestJSONArgsWithCancellation:{let{rpcId:H,method:j,args:re}=k.deserializeRequestJSONArgs(x);this._uriTransformer&&(re=(0,I.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,F,H,j,re,U===E.RequestJSONArgsWithCancellation);break}case E.RequestMixedArgs:case E.RequestMixedArgsWithCancellation:{let{rpcId:H,method:j,args:re}=k.deserializeRequestMixedArgs(x);this._uriTransformer&&(re=(0,I.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,F,H,j,re,U===E.RequestMixedArgsWithCancellation);break}case E.Acknowledged:{this._logger?.logIncoming(O,F,i.LocalSide,"ack"),this._onDidReceiveAcknowledge(F);break}case E.Cancel:{this._receiveCancel(O,F);break}case E.ReplyOKEmpty:{this._receiveReply(O,F,void 0);break}case E.ReplyOKJSON:{let H=k.deserializeReplyOKJSON(x);this._uriTransformer&&(H=(0,I.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(O,F,H);break}case E.ReplyOKJSONWithBuffers:{const H=k.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(O,F,H);break}case E.ReplyOKVSBuffer:{const H=k.deserializeReplyOKVSBuffer(x);this._receiveReply(O,F,H);break}case E.ReplyErrError:{let H=k.deserializeReplyErrError(x);this._uriTransformer&&(H=(0,I.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(O,F,H);break}case E.ReplyErrEmpty:{this._receiveReplyErr(O,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}_receiveRequest(N,O,x,U,F,H){this._logger?.logIncoming(N,O,i.OtherSide,`receiveRequest ${(0,c.getStringIdentifierForProxy)(x)}.${U}(`,F);const j=String(O);let re,B;if(H){const X=new T.CancellationTokenSource;F.push(X.token),re=this._invokeHandler(x,U,F),B=()=>X.cancel()}else re=this._invokeHandler(x,U,F),B=f;this._cancelInvokedHandlers[j]=B;const V=k.serializeAcknowledged(O);this._logger?.logOutgoing(V.byteLength,O,i.OtherSide,"ack"),this._protocol.send(V),re.then(X=>{delete this._cancelInvokedHandlers[j];const ee=k.serializeReplyOK(O,X,this._uriReplacer);this._logger?.logOutgoing(ee.byteLength,O,i.OtherSide,"reply:",X),this._protocol.send(ee)},X=>{delete this._cancelInvokedHandlers[j];const ee=k.serializeReplyErr(O,X);this._logger?.logOutgoing(ee.byteLength,O,i.OtherSide,"replyErr:",X),this._protocol.send(ee)})}_receiveCancel(N,O){this._logger?.logIncoming(N,O,i.OtherSide,"receiveCancel");const x=String(O);this._cancelInvokedHandlers[x]?.()}_receiveReply(N,O,x){this._logger?.logIncoming(N,O,i.LocalSide,"receiveReply:",x);const U=String(O);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],F.resolveOk(x)}_receiveReplyErr(N,O,x){this._logger?.logIncoming(N,O,i.LocalSide,"receiveReplyErr:",x);const U=String(O);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let H;x&&(x.$isError?(H=new Error,H.name=x.name,H.message=x.message,H.stack=x.stack):H=x),F.resolveErr(H)}_invokeHandler(N,O,x){try{return Promise.resolve(this._doInvokeHandler(N,O,x))}catch(U){return Promise.reject(U)}}_doInvokeHandler(N,O,x){const U=this._locals[N];if(!U)throw new Error("Unknown actor "+(0,c.getStringIdentifierForProxy)(N));const F=U[O];if(typeof F!="function")throw new Error("Unknown method "+O+" on actor "+(0,c.getStringIdentifierForProxy)(N));return F.apply(U,x)}_remoteCall(N,O,x){if(this._isDisposed)return new _.CanceledLazyPromise;let U=null;if(x.length>0&&T.CancellationToken.isCancellationToken(x[x.length-1])&&(U=x.pop()),U&&U.isCancellationRequested)return Promise.reject(L.canceled());const F=k.serializeRequestArguments(x,this._uriReplacer),H=++this._lastMessageId,j=String(H),re=new _.LazyPromise,B=new p.DisposableStore;U&&B.add(U.onCancellationRequested(()=>{const X=k.serializeCancel(H);this._logger?.logOutgoing(X.byteLength,H,i.LocalSide,"cancel"),this._protocol.send(k.serializeCancel(H))})),this._pendingRPCReplies[j]=new D(re,B),this._onWillSendRequest(H);const V=k.serializeRequest(H,N,O,F,!!U);return this._logger?.logOutgoing(V.byteLength,H,i.LocalSide,`request: ${(0,c.getStringIdentifierForProxy)(N)}.${O}(`,x),this._protocol.send(V),re}}e.RPCProtocol=y;class D{constructor(N,O){this._promise=N,this._disposable=O}resolveOk(N){this._promise.resolveOk(N),this._disposable.dispose()}resolveErr(N){this._promise.resolveErr(N),this._disposable.dispose()}}class w{static alloc(N,O,x){const U=new w(d.VSBuffer.alloc(x+1+4),0);return U.writeUInt8(N),U.writeUInt32(O),U}static read(N,O){return new w(N,O)}get buffer(){return this._buff}constructor(N,O){this._buff=N,this._offset=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this._buff.writeUInt8(N,this._offset),this._offset+=1}readUInt8(){const N=this._buff.readUInt8(this._offset);return this._offset+=1,N}writeUInt32(N){this._buff.writeUInt32BE(N,this._offset),this._offset+=4}readUInt32(){const N=this._buff.readUInt32BE(this._offset);return this._offset+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this._buff.writeUInt8(N.byteLength,this._offset),this._offset+=1,this._buff.set(N,this._offset),this._offset+=N.byteLength}readShortString(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,x}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readLongString(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,x}writeBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readVSBuffer(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+N);return this._offset+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let x=0,U=N.length;x<U;x++){const F=N[x];switch(O+=1,F.type){case S.String:O+=this.sizeLongString(F.value);break;case S.VSBuffer:O+=this.sizeVSBuffer(F.value);break;case S.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(F.value);for(let H=0;H<F.buffers.length;++H)O+=this.sizeVSBuffer(F.buffers[H]);break;case S.Undefined:break}}return O}writeMixedArray(N){this._buff.writeUInt8(N.length,this._offset),this._offset+=1;for(let O=0,x=N.length;O<x;O++){const U=N[O];switch(U.type){case S.String:this.writeUInt8(S.String),this.writeLongString(U.value);break;case S.VSBuffer:this.writeUInt8(S.VSBuffer),this.writeVSBuffer(U.value);break;case S.SerializedObjectWithBuffers:this.writeUInt8(S.SerializedObjectWithBuffers),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let F=0;F<U.buffers.length;++F)this.writeBuffer(U.buffers[F]);break;case S.Undefined:this.writeUInt8(S.Undefined);break}}}readMixedArray(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(N);for(let x=0;x<N;x++)switch(this.readUInt8()){case S.String:O[x]=this.readLongString();break;case S.VSBuffer:O[x]=this.readVSBuffer();break;case S.SerializedObjectWithBuffers:{const F=this.readUInt32(),H=this.readLongString(),j=[];for(let re=0;re<F;++re)j.push(this.readVSBuffer());O[x]=new c.SerializableObjectWithBuffers(n(H,j,null));break}case S.Undefined:O[x]=void 0;break}return O}}var P;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(P||(P={}));class k{static _useMixedArgSerialization(N){for(let O=0,x=N.length;O<x;O++)if(N[O]instanceof d.VSBuffer||N[O]instanceof c.SerializableObjectWithBuffers||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this._useMixedArgSerialization(N)){const x=[];for(let U=0,F=N.length;U<F;U++){const H=N[U];if(H instanceof d.VSBuffer)x[U]={type:S.VSBuffer,value:H};else if(typeof H>"u")x[U]={type:S.Undefined};else if(H instanceof c.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:re}=g(H.value,O);x[U]={type:S.SerializedObjectWithBuffers,value:d.VSBuffer.fromString(j),buffers:re}}else x[U]={type:S.String,value:d.VSBuffer.fromString(o(H,O))}}return{type:P.Mixed,args:x}}return{type:P.Simple,args:o(N,O)}}static serializeRequest(N,O,x,U,F){switch(U.type){case P.Simple:return this._requestJSONArgs(N,O,x,U.args,F);case P.Mixed:return this._requestMixedArgs(N,O,x,U.args,F)}}static _requestJSONArgs(N,O,x,U,F){const H=d.VSBuffer.fromString(x),j=d.VSBuffer.fromString(U);let re=0;re+=w.sizeUInt8(),re+=w.sizeShortString(H),re+=w.sizeLongString(j);const B=w.alloc(F?E.RequestJSONArgsWithCancellation:E.RequestJSONArgs,N,re);return B.writeUInt8(O),B.writeShortString(H),B.writeLongString(j),B.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),x=N.readShortString(),U=N.readLongString();return{rpcId:O,method:x,args:JSON.parse(U)}}static _requestMixedArgs(N,O,x,U,F){const H=d.VSBuffer.fromString(x);let j=0;j+=w.sizeUInt8(),j+=w.sizeShortString(H),j+=w.sizeMixedArray(U);const re=w.alloc(F?E.RequestMixedArgsWithCancellation:E.RequestMixedArgs,N,j);return re.writeUInt8(O),re.writeShortString(H),re.writeMixedArray(U),re.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),x=N.readShortString(),U=N.readMixedArray(),F=new Array(U.length);for(let H=0,j=U.length;H<j;H++){const re=U[H];typeof re=="string"?F[H]=JSON.parse(re):F[H]=re}return{rpcId:O,method:x,args:F}}static serializeAcknowledged(N){return w.alloc(E.Acknowledged,N,0).buffer}static serializeCancel(N){return w.alloc(E.Cancel,N,0).buffer}static serializeReplyOK(N,O,x){if(typeof O>"u")return this._serializeReplyOKEmpty(N);if(O instanceof d.VSBuffer)return this._serializeReplyOKVSBuffer(N,O);if(O instanceof c.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:F}=g(O.value,x,!0);return this._serializeReplyOKJSONWithBuffers(N,U,F)}else return this._serializeReplyOKJSON(N,b(O,x))}static _serializeReplyOKEmpty(N){return w.alloc(E.ReplyOKEmpty,N,0).buffer}static _serializeReplyOKVSBuffer(N,O){let x=0;x+=w.sizeVSBuffer(O);const U=w.alloc(E.ReplyOKVSBuffer,N,x);return U.writeVSBuffer(O),U.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static _serializeReplyOKJSON(N,O){const x=d.VSBuffer.fromString(O);let U=0;U+=w.sizeLongString(x);const F=w.alloc(E.ReplyOKJSON,N,U);return F.writeLongString(x),F.buffer}static _serializeReplyOKJSONWithBuffers(N,O,x){const U=d.VSBuffer.fromString(O);let F=0;F+=w.sizeUInt32,F+=w.sizeLongString(U);for(const j of x)F+=w.sizeVSBuffer(j);const H=w.alloc(E.ReplyOKJSONWithBuffers,N,F);H.writeUInt32(x.length),H.writeLongString(U);for(const j of x)H.writeBuffer(j);return H.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const x=N.readUInt32(),U=N.readLongString(),F=[];for(let H=0;H<x;++H)F.push(N.readVSBuffer());return new c.SerializableObjectWithBuffers(n(U,F,O))}static serializeReplyErr(N,O){const x=O?b(L.transformErrorForSerialization(O),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(N);const U=d.VSBuffer.fromString(x);let F=0;F+=w.sizeLongString(U);const H=w.alloc(E.ReplyErrError,N,F);return H.writeLongString(U),H.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(N){return w.alloc(E.ReplyErrEmpty,N,0).buffer}}var E;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var S;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(S||(S={}))}),define(_e[340],ye([1,0,22,29,15,89,5]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=I,e.generate=_,e.INotebookDocumentService=(0,L.createDecorator)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${A.join("")}]+`),a=7;function I(C){if(C.scheme!==T.Schemas.vscodeNotebookCell)return;const b=C.fragment.indexOf("s");if(b<0)return;const l=parseInt(C.fragment.substring(0,b).replace(p,""),a),m=(0,s.decodeBase64)(C.fragment.substring(b+1)).toString();if(!isNaN(l))return{handle:l,notebook:C.with({scheme:m,fragment:null})}}function _(C,b){const l=b.toString(a),h=`${l.length<A.length?A[l.length-1]:"z"}${l}s${(0,s.encodeBase64)(s.VSBuffer.fromString(C.scheme),!0,!0)}`;return C.with({scheme:T.Schemas.vscodeNotebookCell,fragment:h})}class c{constructor(){this._documents=new d.ResourceMap}getNotebook(b){if(b.scheme===T.Schemas.vscodeNotebookCell){const l=I(b);if(l){const m=this._documents.get(l.notebook);if(m)return m}}return this._documents.get(b)}addNotebookDocument(b){this._documents.set(b.uri,b)}removeNotebookDocument(b){this._documents.delete(b.uri)}}e.NotebookDocumentWorkbenchService=c,(0,R.registerSingleton)(e.INotebookDocumentService,c,R.InstantiationType.Delayed)}),define(_e[127],ye([1,0,22,39,40,108,15,17,11,36,340]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=r,e.isDocumentExcludePattern=v,e.notebookDocumentFilterMatch=y,e.isTextStreamMime=P,e.compressOutputItemStreams=E,d=ze(d),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var _;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(_||(e.CellKind=_={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var c;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(c||(e.NotebookRunState=c={}));var C;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var b;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var l;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var m;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var h;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var g;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var n;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(j){j.scheme=L.Schemas.vscodeNotebookCell;function re(ne,De){return(0,I.generate)(ne,De)}j.generate=re;function B(ne){return(0,I.parse)(ne)}j.parse=B;function V(ne,De){return ne.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${ne.scheme!==L.Schemas.file?ne.scheme:""}`})}j.generateCellOutputUri=V;function X(ne){if(ne.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!De)return;const pe=De[1]&&De[1]!==""?De[1]:void 0,G=De[2];return{outputId:pe,notebook:ne.with({scheme:G||L.Schemas.file,fragment:null})}}j.parseCellOutputUri=X;function ee(ne,De,pe){return j.generate(ne,De).with({scheme:pe})}j.generateCellPropertyUri=ee;function he(ne,De){if(ne.scheme===De)return j.parse(ne.with({scheme:j.scheme}))}j.parseCellPropertyUri=he})(o||(e.CellUri=o={}));const t=j=>p.isWindows?j.replace(/\//g,"\\"):j;class i{constructor(re=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=B,this.order=[...new Set(re)].map(V=>({pattern:V,matches:d.parse(t(V))}))}sort(re){const B=new Map(T.Iterable.map(re,X=>[X,t(X)]));let V=[];for(const{matches:X}of this.order)for(const[ee,he]of B)if(X(he)){V.push(ee),B.delete(ee);break}return B.size&&(V=V.concat([...B.keys()].sort((X,ee)=>this.defaultOrder.indexOf(X)-this.defaultOrder.indexOf(ee)))),V}prioritize(re,B){const V=this.findIndex(re);if(V===-1){this.order.unshift({pattern:re,matches:d.parse(t(re))});return}const X=new Set(B.map(he=>this.findIndex(he,V)));X.delete(-1);const ee=Array.from(X).sort();this.order.splice(V+1,0,...ee.map(he=>this.order[he]));for(let he=ee.length-1;he>=0;he--)this.order.splice(ee[he],1)}toArray(){return this.order.map(re=>re.pattern)}findIndex(re,B=this.order.length){const V=t(re);for(let X=0;X<B;X++)if(this.order[X].matches(V))return X;return-1}}e.MimeTypeDisplayOrder=i;function r(j,re,B,V=(X,ee)=>X===ee){const X=[];function ee(De,pe,G){if(pe===0&&G.length===0)return;const W=X[X.length-1];W&&W.start+W.deleteCount===De?(W.deleteCount+=pe,W.toInsert.push(...G)):X.push({start:De,deleteCount:pe,toInsert:G})}let he=0,ne=0;for(;;){if(he===j.length){ee(he,0,re.slice(ne));break}if(ne===re.length){ee(he,j.length-he,[]);break}const De=j[he],pe=re[ne];if(V(De,pe)){he+=1,ne+=1;continue}B(pe)?(ee(he,1,[]),he+=1):(ee(he,0,[pe]),ne+=1)}return X}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new a.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new a.RawContextKey("notebookEditorCursorAtLineBoundary","none");var f;(function(j){j.default="default",j.option="option"})(f||(e.NotebookEditorPriority=f={}));var u;(function(j){j.Cells="cells",j.Text="text",j.None="none"})(u||(e.NotebookFindScopeType=u={}));function v(j){const re=j;return!!((typeof re.include=="string"||d.isRelativePattern(re.include))&&(typeof re.exclude=="string"||d.isRelativePattern(re.exclude)))}function y(j,re,B){if(Array.isArray(j.viewType)&&j.viewType.indexOf(re)>=0||j.viewType===re)return!0;if(j.filenamePattern){const V=v(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,X=v(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(d.match(V,(0,A.basename)(B.fsPath).toLowerCase()))return!(X&&d.match(X,(0,A.basename)(B.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class w{static{this._prefix="notebook/"}static create(re){return`${w._prefix}${re}`}static parse(re){if(re.startsWith(w._prefix))return re.substring(w._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=w;function P(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}const k=new TextDecoder;function E(j){const re=[];let B=!1;for(const he of j)(re.length===0||B)&&(re.push(he),B=!0);let V=N(re);const X=s.VSBuffer.concat(re.map(he=>s.VSBuffer.wrap(he))),ee=H(X);return V=V||ee.byteLength!==X.byteLength,{data:ee,didCompression:V}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(j=>j.charCodeAt(0)),M=10;function N(j){let re=!1;return j.forEach((B,V)=>{if(V===0||B.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const X=j[V-1],ee=B.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(ee[0]===S[0]&&ee[1]===S[1]&&ee[2]===S[2]){const he=X.lastIndexOf(M);if(he===-1)return;re=!0,j[V-1]=X.subarray(0,he),j[V]=B.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),re}function O(j){let re=j;do j=re,re=j.replace(/[^\n]\x08/gm,"");while(re.length<j.length);return j}function x(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const re=j.match(/^(.*)\r+/m)[1];let B=j.match(/\r+(.*)$/m)[1];B=B+re.slice(B.length,re.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return j}const U=8,F=13;function H(j){return!j.buffer.includes(U)&&!j.buffer.includes(F)?j:s.VSBuffer.fromString(x(O(k.decode(j.buffer))))}}),define(_e[10],ye([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b){"use strict";var l,m,h,g,n,o,t,i,r,f,u,v,y,D,w,P,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelFunctionUsePart=e.LanguageModelChatMessage=e.LanguageModelFunctionResultPart=e.LanguageModelChatMessageRole=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=et,e.setBreakpointId=Di,e.validateTestCoverageCount=Ai;function E(K){return Object.assign(K,{apply:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(K,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const[Le,...Ye]=me;return Reflect.construct(K,Ye,Le.constructor)}}})}var S;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(S||(e.TerminalOutputAnchor=S={}));var M;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=l=class{static from(...q){let me=q;return new l(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=N,e.Disposable=N=l=Xe([E],N);let O=m=class{static Min(...q){if(q.length===0)throw new TypeError;let me=q[0];for(let Le=1;Le<q.length;Le++){const Ye=q[Le];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...q){if(q.length===0)throw new TypeError;let me=q[0];for(let Le=1;Le<q.length;Le++){const Ye=q[Le];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:me,character:Le}=q;return typeof me=="number"&&typeof Le=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(q,me){if(q<0)throw(0,d.illegalArgument)("line must be non-negative");if(me<0)throw(0,d.illegalArgument)("character must be non-negative");this._line=q,this._character=me}isBefore(q){return this._line<q._line?!0:q._line<this._line?!1:this._character<q._character}isBeforeOrEqual(q){return this._line<q._line?!0:q._line<this._line?!1:this._character<=q._character}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this._line===q._line&&this._character===q._character}compareTo(q){return this._line<q._line?-1:this._line>q.line?1:this._character<q._character?-1:this._character>q._character?1:0}translate(q,me=0){if(q===null||me===null)throw(0,d.illegalArgument)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,me=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&me===0?this:new m(this.line+Le,this.character+me)}with(q,me=this.character){if(q===null||me===null)throw(0,d.illegalArgument)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,me=typeof q.character=="number"?q.character:this.character),Le===this.line&&me===this.character?this:new m(Le,me)}toJSON(){return{line:this.line,character:this.character}}};e.Position=O,e.Position=O=m=Xe([E],O);let x=h=class{static isRange(q){return q instanceof h?!0:q?O.isPosition(q.start)&&O.isPosition(q.end):!1}static of(q){if(q instanceof h)return q;if(this.isRange(q))return new h(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(q,me,Le,Ye){let st,pt;if(typeof q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(st=new O(q,me),pt=new O(Le,Ye)):O.isPosition(q)&&O.isPosition(me)&&(st=O.of(q),pt=O.of(me)),!st||!pt)throw new Error("Invalid arguments");st.isBefore(pt)?(this._start=st,this._end=pt):(this._start=pt,this._end=st)}contains(q){return h.isRange(q)?this.contains(q.start)&&this.contains(q.end):O.isPosition(q)?!(O.of(q).isBefore(this._start)||this._end.isBefore(q)):!1}isEqual(q){return this._start.isEqual(q._start)&&this._end.isEqual(q._end)}intersection(q){const me=O.Max(q.start,this._start),Le=O.Min(q.end,this._end);if(!me.isAfter(Le))return new h(me,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const me=O.Min(q.start,this._start),Le=O.Max(q.end,this.end);return new h(me,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(q,me=this.end){if(q===null||me===null)throw(0,d.illegalArgument)();let Le;return q?O.isPosition(q)?Le=q:(Le=q.start||this.start,me=q.end||this.end):Le=this.start,Le.isEqual(this._start)&&me.isEqual(this.end)?this:new h(Le,me)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=h=Xe([E],x);let U=g=class extends x{static isSelection(q){return q instanceof g?!0:q?x.isRange(q)&&O.isPosition(q.anchor)&&O.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(q,me,Le,Ye){let st,pt;if(typeof q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(st=new O(q,me),pt=new O(Le,Ye)):O.isPosition(q)&&O.isPosition(me)&&(st=O.of(q),pt=O.of(me)),!st||!pt)throw new Error("Invalid arguments");super(st,pt),this._anchor=st,this._active=pt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=U,e.Selection=U=g=Xe([E],U);const F=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,d.illegalArgument)("connectionToken")};class H{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,me,Le){if(typeof q!="string"||q.length===0)throw(0,d.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,d.illegalArgument)("port");typeof Le<"u"&&F(Le),this.host=q,this.port=Math.round(me),this.connectionToken=Le}}e.ResolvedAuthority=H;class j{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,me){this.makeConnection=q,this.connectionToken=me,typeof me<"u"&&F(me)}}e.ManagedResolvedAuthority=j;class re extends Error{static NotAvailable(q,me){return new re(q,C.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(q){return new re(q,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,me=C.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=me,this._detail=Le,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var B;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(B||(e.EndOfLine=B={}));var V;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let X=n=class{static isTextEdit(q){return q instanceof n?!0:q?x.isRange(q)&&typeof q.newText=="string":!1}static replace(q,me){return new n(q,me)}static insert(q,me){return n.replace(new x(q,q),me)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const me=new n(new x(new O(0,0),new O(0,0)),"");return me.newEol=q,me}get range(){return this._range}set range(q){if(q&&!x.isRange(q))throw(0,d.illegalArgument)("range");this._range=q}get newText(){return this._newText||""}set newText(q){if(q&&typeof q!="string")throw(0,d.illegalArgument)("newText");this._newText=q}get newEol(){return this._newEol}set newEol(q){if(q&&typeof q!="number")throw(0,d.illegalArgument)("newEol");this._newEol=q}constructor(q,me){this._range=q,this._newText=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=X,e.TextEdit=X=n=Xe([E],X);let ee=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?Et.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,me){return new o(q,me)}static insertCells(q,me){return new o(new Et(q,q),me)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,me){const Le=new o(new Et(q,q),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(q){const me=new o(new Et(0,0),[]);return me.newNotebookMetadata=q,me}constructor(q,me){this.range=q,this.newCells=me}};e.NotebookEdit=ee,e.NotebookEdit=ee=o=Xe([E],ee);class he{static isSnippetTextEdit(q){return q instanceof he?!0:q?x.isRange(q.range)&&pe.isSnippetString(q.snippet):!1}static replace(q,me){return new he(q,me)}static insert(q,me){return he.replace(new x(q,q),me)}constructor(q,me){this.range=q,this.snippet=me}}e.SnippetTextEdit=he;var ne;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(q,me,Le,Ye){this._edits.push({_type:ne.File,from:q,to:me,options:Le,metadata:Ye})}createFile(q,me,Le){this._edits.push({_type:ne.File,from:void 0,to:q,options:me,metadata:Le})}deleteFile(q,me,Le){this._edits.push({_type:ne.File,from:q,to:void 0,options:me,metadata:Le})}replaceNotebookMetadata(q,me,Le){this._edits.push({_type:ne.Cell,metadata:Le,uri:q,edit:{editType:b.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}replaceNotebookCells(q,me,Le,Ye){const st=me.start,pt=me.end;(st!==pt||Le.length>0)&&this._edits.push({_type:ne.CellReplace,uri:q,index:st,count:pt-st,cells:Le,metadata:Ye})}replaceNotebookCellMetadata(q,me,Le,Ye){this._edits.push({_type:ne.Cell,metadata:Ye,uri:q,edit:{editType:b.CellEditType.Metadata,index:me,metadata:Le}})}replace(q,me,Le,Ye){this._edits.push({_type:ne.Text,uri:q,edit:new X(me,Le),metadata:Ye})}insert(q,me,Le,Ye){this.replace(q,new x(me,me),Le,Ye)}delete(q,me,Le){this.replace(q,me,"",Le)}has(q){return this._edits.some(me=>me._type===ne.Text&&me.uri.toString()===q.toString())}set(q,me){if(me)for(const Le of me){if(!Le)continue;let Ye,st;Array.isArray(Le)?(Ye=Le[0],st=Le[1]):Ye=Le,ee.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata(q,Ye.range.start,Ye.newCellMetadata,st):Ye.newNotebookMetadata?this.replaceNotebookMetadata(q,Ye.newNotebookMetadata,st):this.replaceNotebookCells(q,Ye.range,Ye.newCells,st):he.isSnippetTextEdit(Ye)?this._edits.push({_type:ne.Snippet,uri:q,range:Ye.range,edit:Ye.snippet,metadata:st}):this._edits.push({_type:ne.Text,uri:q,edit:Ye,metadata:st})}else{for(let Le=0;Le<this._edits.length;Le++){const Ye=this._edits[Le];switch(Ye._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ye.uri.toString()===q.toString()&&(this._edits[Le]=void 0);break}}(0,s.coalesceInPlace)(this._edits)}}get(q){const me=[];for(const Le of this._edits)Le._type===ne.Text&&Le.uri.toString()===q.toString()&&me.push(Le.edit);return me}entries(){const q=new R.ResourceMap;for(const me of this._edits)if(me._type===ne.Text){let Le=q.get(me.uri);Le||(Le=[me.uri,[]],q.set(me.uri,Le)),Le[1].push(me.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=De,e.WorkspaceEdit=De=Xe([E],De);let pe=t=class{static isSnippetString(q){return q instanceof t?!0:q?typeof q.value=="string":!1}static _escape(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this._tabstop=1,this.value=q||""}appendText(q){return this.value+=t._escape(q),this}appendTabstop(q=this._tabstop++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,me=this._tabstop++){if(typeof q=="function"){const Le=new t;Le._tabstop=this._tabstop,q(Le),this._tabstop=Le._tabstop,q=Le.value}else q=t._escape(q);return this.value+="${",this.value+=me,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,me=this._tabstop++){const Le=q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,me){if(typeof me=="function"){const Le=new t;Le._tabstop=this._tabstop,me(Le),this._tabstop=Le._tabstop,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.SnippetString=pe,e.SnippetString=pe=t=Xe([E],pe);var G;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(G||(e.DiagnosticTag=G={}));var W;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=i=class{static isLocation(q){return q instanceof i?!0:q?x.isRange(q.range)&&a.URI.isUri(q.uri):!1}constructor(q,me){if(this.uri=q,me)if(x.isRange(me))this.range=x.of(me);else if(O.isPosition(me))this.range=new x(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=se,e.Location=se=i=Xe([E],se);let ae=class{static is(q){return q?typeof q.message=="string"&&q.location&&x.isRange(q.location.range)&&a.URI.isUri(q.location.uri):!1}constructor(q,me){this.location=q,this.message=me}static isEqual(q,me){return q===me?!0:!q||!me?!1:q.message===me.message&&q.location.range.isEqual(me.location.range)&&q.location.uri.toString()===me.location.uri.toString()}};e.DiagnosticRelatedInformation=ae,e.DiagnosticRelatedInformation=ae=Xe([E],ae);let te=class{constructor(q,me,Le=W.Error){if(!x.isRange(q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=q,this.message=me,this.severity=Le}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,me){return q===me?!0:!q||!me?!1:q.message===me.message&&q.severity===me.severity&&q.code===me.code&&q.severity===me.severity&&q.source===me.source&&q.range.isEqual(me.range)&&(0,s.equals)(q.tags,me.tags)&&(0,s.equals)(q.relatedInformation,me.relatedInformation,ae.isEqual)}};e.Diagnostic=te,e.Diagnostic=te=Xe([E],te);let ce=class{constructor(q,me){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=me}};e.Hover=ce,e.Hover=ce=Xe([E],ce);let ue=class extends ce{constructor(q,me,Le,Ye){super(q,me),this.canIncreaseHover=Le,this.canDecreaseHover=Ye}};e.VerboseHover=ue,e.VerboseHover=ue=Xe([E],ue);var Y;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(Y||(e.HoverVerbosityAction=Y={}));var oe;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let ve=class{constructor(q,me=oe.Text){this.range=q,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.DocumentHighlight=ve,e.DocumentHighlight=ve=Xe([E],ve);let be=class{constructor(q,me){this.uri=q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.MultiDocumentHighlight=be,e.MultiDocumentHighlight=be=Xe([E],be);var Fe;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var We;(function(K){K[K.Deprecated=1]="Deprecated"})(We||(e.SymbolTag=We={}));let Ce=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,me,Le,Ye,st){this.name=q,this.kind=me,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),Ye instanceof se?this.location=Ye:Le instanceof x&&(this.location=new se(Ye,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ce,e.SymbolInformation=Ce=r=Xe([E],Ce);let Ie=f=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(f.validate)}constructor(q,me,Le,Ye,st){this.name=q,this.detail=me,this.kind=Le,this.range=Ye,this.selectionRange=st,this.children=[],f.validate(this)}};e.DocumentSymbol=Ie,e.DocumentSymbol=Ie=f=Xe([E],Ie);var Re;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Re||(e.CodeActionTriggerKind=Re={}));let z=class{constructor(q,me){this.title=q,this.kind=me}};e.CodeAction=z,e.CodeAction=z=Xe([E],z);let $=class{static{u=this}static{this.sep="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.sep+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.sep)}};e.CodeActionKind=$,e.CodeActionKind=$=u=Xe([E],$),$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorMove=$.Refactor.append("move"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll"),$.Notebook=$.Empty.append("notebook");let Q=class{constructor(q,me){if(this.range=q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=Q,e.SelectionRange=Q=Xe([E],Q);class Z{constructor(q,me,Le,Ye,st,pt){this.kind=q,this.name=me,this.detail=Le,this.uri=Ye,this.range=st,this.selectionRange=pt}}e.CallHierarchyItem=Z;class fe{constructor(q,me){this.fromRanges=me,this.from=q}}e.CallHierarchyIncomingCall=fe;class Ee{constructor(q,me){this.fromRanges=me,this.to=q}}e.CallHierarchyOutgoingCall=Ee;var Ne;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ve=class{constructor(q,me){this.range=q,this.command=me}get isResolved(){return!!this.command}};e.CodeLens=Ve,e.CodeLens=Ve=Xe([E],Ve);let je=v=class{#e;static isMarkdownString(q){return q instanceof v?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,me=!1){this.#e=new T.MarkdownString(q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,me){return this.#e.appendCodeblock(me??"",q),this}};e.MarkdownString=je,e.MarkdownString=je=v=Xe([E],je);let tt=class{constructor(q,me){this.label=q,this.documentation=me}};e.ParameterInformation=tt,e.ParameterInformation=tt=Xe([E],tt);let rt=class{constructor(q,me){this.label=q,this.documentation=me,this.parameters=[]}};e.SignatureInformation=rt,e.SignatureInformation=rt=Xe([E],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=ot,e.SignatureHelp=ot=Xe([E],ot);var nt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let mt=class{constructor(q){this.value=q}};e.InlayHintLabelPart=mt,e.InlayHintLabelPart=mt=Xe([E],mt);let dt=class{constructor(q,me,Le){this.position=q,this.label=me,this.kind=Le}};e.InlayHint=dt,e.InlayHint=dt=Xe([E],dt);var lt;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(lt||(e.CompletionTriggerKind=lt={}));var Te;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Te||(e.CompletionItemKind=Te={}));var Ue;(function(K){K[K.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let qe=class{constructor(q,me){this.label=q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=qe,e.CompletionItem=qe=Xe([E],qe);let Oe=class{constructor(q=[],me=!1){this.items=q,this.isIncomplete=me}};e.CompletionList=Oe,e.CompletionList=Oe=Xe([E],Oe);let xe=class{constructor(q,me,Le){this.insertText=q,this.range=me,this.command=Le}};e.InlineSuggestion=xe,e.InlineSuggestion=xe=Xe([E],xe);let de=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.InlineSuggestionList=de,e.InlineSuggestionList=de=Xe([E],de);var J;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(J||(e.PartialAcceptTriggerKind=J={}));var Pe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Pe||(e.ViewColumn=Pe={}));var Qe;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Qe||(e.StatusBarAlignment=Qe={}));function et(K,q){return`${_.ExtensionIdentifier.toKey(K)}.${q}`}var ut;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var Dt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Dt||(e.TextEditorRevealType=Dt={}));var Ot;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var zt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var ui;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(K){function q(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var ti;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(K){function q(me){switch(me){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(ti||(e.SyntaxTokenType=ti={}));let Ze=class{constructor(q,me){if(me&&!a.URI.isUri(me))throw(0,d.illegalArgument)("target");if(!x.isRange(q)||q.isEmpty)throw(0,d.illegalArgument)("range");this.range=q,this.target=me}};e.DocumentLink=Ze,e.DocumentLink=Ze=Xe([E],Ze);let jt=class{constructor(q,me,Le,Ye){this.red=q,this.green=me,this.blue=Le,this.alpha=Ye}};e.Color=jt,e.Color=jt=Xe([E],jt);let Kt=class{constructor(q,me){if(me&&!(me instanceof jt))throw(0,d.illegalArgument)("color");if(!x.isRange(q)||q.isEmpty)throw(0,d.illegalArgument)("range");this.range=q,this.color=me}};e.ColorInformation=Kt,e.ColorInformation=Kt=Xe([E],Kt);let vt=class{constructor(q){if(!q||typeof q!="string")throw(0,d.illegalArgument)("label");this.label=q}};e.ColorPresentation=vt,e.ColorPresentation=vt=Xe([E],vt);var Tt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Tt||(e.ColorFormat=Tt={}));var ii;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Yt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Yt||(e.TerminalExitReason=Yt={}));var $t;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})($t||(e.TerminalShellExecutionCommandLineConfidence=$t={}));class St{constructor(q,me,Le){if(this.startIndex=q,this.length=me,this.tooltip=Le,typeof q!="number"||q<0)throw(0,d.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,d.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,d.illegalArgument)("tooltip")}}e.TerminalLink=St;class Nt{constructor(q){this.uri=q}}e.TerminalQuickFixOpener=Nt;class di{constructor(q){this.terminalCommand=q}}e.TerminalQuickFixCommand=di;var Ht;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Ht||(e.TerminalLocation=Ht={}));class Je{constructor(q){if(this.options=q,typeof q!="object")throw(0,d.illegalArgument)("options")}}e.TerminalProfile=Je;var Jt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var ni;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let hi=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(q){switch(q){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(q,me){if(this.label=me,typeof q!="string"||typeof me!="string")throw(0,d.illegalArgument)("name");this._id=q}get id(){return this._id}};e.TaskGroup=hi,e.TaskGroup=hi=y=Xe([E],hi);function Ct(K){let q="";for(let me=0;me<K.length;me++)q+=K[me].replace(/,/g,",,")+",";return q}let Ft=class{constructor(q,me,Le){if(typeof q!="string")throw(0,d.illegalArgument)("process");this._args=[],this._process=q,me!==void 0&&(Array.isArray(me)?(this._args=me,this._options=Le):this._options=me)}get process(){return this._process}set process(q){if(typeof q!="string")throw(0,d.illegalArgument)("process");this._process=q}get args(){return this._args}set args(q){Array.isArray(q)||(q=[]),this._args=q}get options(){return this._options}set options(q){this._options=q}computeId(){const q=[];if(q.push("process"),this._process!==void 0&&q.push(this._process),this._args&&this._args.length>0)for(const me of this._args)q.push(me);return Ct(q)}};e.ProcessExecution=Ft,e.ProcessExecution=Ft=Xe([E],Ft);let At=class{constructor(q,me,Le){if(this._args=[],Array.isArray(me)){if(!q)throw(0,d.illegalArgument)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,d.illegalArgument)("command");this._command=q,this._args=me,this._options=Le}else{if(typeof q!="string")throw(0,d.illegalArgument)("commandLine");this._commandLine=q,this._options=me}}get commandLine(){return this._commandLine}set commandLine(q){if(typeof q!="string")throw(0,d.illegalArgument)("commandLine");this._commandLine=q}get command(){return this._command?this._command:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,d.illegalArgument)("command");this._command=q}get args(){return this._args}set args(q){this._args=q||[]}get options(){return this._options}set options(q){this._options=q}computeId(){const q=[];if(q.push("shell"),this._commandLine!==void 0&&q.push(this._commandLine),this._command!==void 0&&q.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const me of this._args)q.push(typeof me=="string"?me:me.value);return Ct(q)}};e.ShellExecution=At,e.ShellExecution=At=Xe([E],At);var Ut;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Zt{constructor(q){this._callback=q}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(q){this._callback=q}get callback(){return this._callback}}e.CustomExecution=Zt;let si=class{static{D=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(q,me,Le,Ye,st,pt){this.__deprecated=!1,this._definition=this.definition=q;let wt;typeof me=="string"?(this._name=this.name=me,this._source=this.source=Le,this.execution=Ye,wt=st,this.__deprecated=!0):me===ri.Global||me===ri.Workspace?(this.target=me,this._name=this.name=Le,this._source=this.source=Ye,this.execution=st,wt=pt):(this.target=me,this._name=this.name=Le,this._source=this.source=Ye,this.execution=st,wt=pt),typeof wt=="string"?(this._problemMatchers=[wt],this._hasDefinedMatchers=!0):Array.isArray(wt)?(this._problemMatchers=wt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(q){this.__id=q}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ft?this._definition={type:D.ProcessType,id:this._execution.computeId()}:this._execution instanceof At?this._definition={type:D.ShellType,id:this._execution.computeId()}:this._execution instanceof Zt?this._definition={type:D.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:D.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(q){if(q==null)throw(0,d.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=q}get scope(){return this._scope}set target(q){this.clear(),this._scope=q}get name(){return this._name}set name(q){if(typeof q!="string")throw(0,d.illegalArgument)("name");this.clear(),this._name=q}get execution(){return this._execution}set execution(q){q===null&&(q=void 0),this.clear(),this._execution=q;const me=this._definition.type;(D.EmptyType===me||D.ProcessType===me||D.ShellType===me||D.ExtensionCallbackType===me)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(q){if(Array.isArray(q))this.clear(),this._problemMatchers=q,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.clear(),this._isBackground=q}get source(){return this._source}set source(q){if(typeof q!="string"||q.length===0)throw(0,d.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=q}get group(){return this._group}set group(q){q===null&&(q=void 0),this.clear(),this._group=q}get detail(){return this._detail}set detail(q){q===null&&(q=void 0),this._detail=q}get presentationOptions(){return this._presentationOptions}set presentationOptions(q){q==null&&(q=Object.create(null)),this.clear(),this._presentationOptions=q}get runOptions(){return this._runOptions}set runOptions(q){q==null&&(q=Object.create(null)),this.clear(),this._runOptions=q}};e.Task=si,e.Task=si=D=Xe([E],si);var Vt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Vt||(e.ProgressLocation=Vt={}));var Gt;(function(K){function q(me){const Le=me;return(0,p.isNumber)(Le.value)?Le.tooltip&&!(0,p.isString)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=q})(Gt||(e.ViewBadge=Gt={}));let oi=w=class{static isTreeItem(q,me){const Le=q;if(Le.checkboxState!==void 0){const Ye=(0,p.isNumber)(Le.checkboxState)?Le.checkboxState:(0,p.isObject)(Le.checkboxState)&&(0,p.isNumber)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,p.isNumber)(Le.checkboxState)&&(0,p.isObject)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==yt.Checked&&Ye!==yt.Unchecked||st!==void 0&&!(0,p.isString)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof w)return!0;if(Le.label!==void 0&&!(0,p.isString)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,p.isString)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,p.isString)(Le.iconPath)&&!a.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,p.isString)(Le.iconPath.id))){const Ye=Le.iconPath;if(!Ye||!(0,p.isString)(Ye.light)&&!a.URI.isUri(Ye.light)&&!(0,p.isString)(Ye.dark)&&!a.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,p.isString)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!a.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,p.isString)(Le.tooltip)&&!(Le.tooltip instanceof je)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<kt.None&&Le.collapsibleState>kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,p.isString)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,me=kt.None){this.collapsibleState=me,a.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.TreeItem=oi,e.TreeItem=oi=w=Xe([E],oi);var kt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(kt||(e.TreeItemCollapsibleState=kt={}));var yt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.DataTransferItem=bt,e.DataTransferItem=bt=Xe([E],bt);class ei extends bt{}e.InternalDataTransferItem=ei;class It extends ei{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.InternalFileDataTransferItem=It;class fi{constructor(q,me,Le,Ye){this.name=q,this.uri=me,this._itemId=Le,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=fi;let qt=class{#e=new Map;constructor(q){for(const[me,Le]of q??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Le):this.#e.set(this.#t(me),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,me){this.#e.set(this.#t(q),[me])}forEach(q,me){for(const[Le,Ye]of this.#e)for(const st of Ye)q.call(me,st,Le,this)}*[Symbol.iterator](){for(const[q,me]of this.#e)for(const Le of me)yield[q,Le]}#t(q){return q.toLowerCase()}};e.DataTransfer=qt,e.DataTransfer=qt=Xe([E],qt);let bi=class{constructor(q,me,Le){this.insertText=q,this.title=me,this.kind=Le}};e.DocumentDropEdit=bi,e.DocumentDropEdit=bi=Xe([E],bi);var Si;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Si||(e.DocumentPasteTriggerKind=Si={}));class gi{static{this.sep="."}constructor(q){this.value=q}append(...q){return new gi((this.value?[this.value,...q]:q).join(gi.sep))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+gi.sep)}}e.DocumentDropOrPasteEditKind=gi,gi.Empty=new gi("");class Bt{constructor(q,me,Le){this.title=me,this.insertText=q,this.kind=Le}}e.DocumentPasteEdit=Bt;let ai=class{constructor(q,me){this.id=q,this.color=me}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.ThemeIcon=ai,e.ThemeIcon=ai=Xe([E],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ti=class{constructor(q){this.id=q}};e.ThemeColor=Ti,e.ThemeColor=Ti=Xe([E],Ti);var Rt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Rt||(e.ConfigurationTarget=Rt={}));let yi=class{get base(){return this._base}set base(q){this._base=q,this._baseUri=a.URI.file(q)}get baseUri(){return this._baseUri}set baseUri(q){this._baseUri=q,this._base=q.fsPath}constructor(q,me){if(typeof q!="string"&&(!q||!a.URI.isUri(q)&&!a.URI.isUri(q.uri)))throw(0,d.illegalArgument)("base");if(typeof me!="string")throw(0,d.illegalArgument)("pattern");typeof q=="string"?this.baseUri=a.URI.file(q):a.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=yi,e.RelativePattern=yi=Xe([E],yi);const Pi=new WeakMap;function Di(K,q){Pi.set(K,q)}let pi=class{constructor(q,me,Le,Ye,st){this.enabled=typeof q=="boolean"?q:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye),typeof st=="string"&&(this.mode=st)}get id(){return this._id||(this._id=Pi.get(this)??(0,I.generateUuid)()),this._id}};e.Breakpoint=pi,e.Breakpoint=pi=Xe([E],pi);let ki=class extends pi{constructor(q,me,Le,Ye,st,pt){if(super(me,Le,Ye,st,pt),q===null)throw(0,d.illegalArgument)("location");this.location=q}};e.SourceBreakpoint=ki,e.SourceBreakpoint=ki=Xe([E],ki);let Wt=class extends pi{constructor(q,me,Le,Ye,st,pt){super(me,Le,Ye,st,pt),this.functionName=q}};e.FunctionBreakpoint=Wt,e.FunctionBreakpoint=Wt=Xe([E],Wt);let ke=class extends pi{constructor(q,me,Le,Ye,st,pt,wt,Qt){if(super(Ye,st,pt,wt,Qt),!me)throw(0,d.illegalArgument)("dataId");this.label=q,this.dataId=me,this.canPersist=Le}};e.DataBreakpoint=ke,e.DataBreakpoint=ke=Xe([E],ke);let Me=class{constructor(q,me,Le){this.command=q,this.args=me||[],this.options=Le}};e.DebugAdapterExecutable=Me,e.DebugAdapterExecutable=Me=Xe([E],Me);let Se=class{constructor(q,me){this.port=q,this.host=me}};e.DebugAdapterServer=Se,e.DebugAdapterServer=Se=Xe([E],Se);let ie=class{constructor(q){this.path=q}};e.DebugAdapterNamedPipeServer=ie,e.DebugAdapterNamedPipeServer=ie=Xe([E],ie);let Ae=class{constructor(q){this.implementation=q}};e.DebugAdapterInlineImplementation=Ae,e.DebugAdapterInlineImplementation=Ae=Xe([E],Ae);class Ke{constructor(q,me,Le){this.session=q,this.threadId=me,this.frameId=Le}}e.DebugStackFrame=Ke;class it{constructor(q,me){this.session=q,this.threadId=me}}e.DebugThread=it;let Ge=class{constructor(q,me){this.range=q,this.expression=me}};e.EvaluatableExpression=Ge,e.EvaluatableExpression=Ge=Xe([E],Ge);var ft;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Pt=class{constructor(q,me){this.range=q,this.text=me}};e.InlineValueText=Pt,e.InlineValueText=Pt=Xe([E],Pt);let Xt=class{constructor(q,me,Le=!0){this.range=q,this.variableName=me,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=Xt,e.InlineValueVariableLookup=Xt=Xe([E],Xt);let li=class{constructor(q,me){this.range=q,this.expression=me}};e.InlineValueEvaluatableExpression=li,e.InlineValueEvaluatableExpression=li=Xe([E],li);let Mt=class{constructor(q,me){this.frameId=q,this.stoppedLocation=me}};e.InlineValueContext=Mt,e.InlineValueContext=Mt=Xe([E],Mt);var ci;(function(K){K[K.AIGenerated=1]="AIGenerated"})(ci||(e.NewSymbolNameTag=ci={}));var $i;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})($i||(e.NewSymbolNameTriggerKind=$i={}));class vn{constructor(q,me){this.newSymbolName=q,this.tags=me}}e.NewSymbolName=vn;var Fi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Li=P=class extends Error{static FileExists(q){return new P(q,c.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(q){return new P(q,c.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(q){return new P(q,c.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(q){return new P(q,c.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(q){return new P(q,c.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(q){return new P(q,c.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(q,me=c.FileSystemProviderErrorCode.Unknown,Le){super(a.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=Li,e.FileSystemError=Li=P=Xe([E],Li);let Hi=class{constructor(q,me,Le){this.start=q,this.end=me,this.kind=Le}};e.FoldingRange=Hi,e.FoldingRange=Hi=Xe([E],Hi);var Ji;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ci;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Ci||(e.CommentThreadCollapsibleState=Ci={}));var Zi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var en;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Vi{constructor(q,me=[]){this.tokenTypes=q,this.tokenModifiers=me}}e.SemanticTokensLegend=Vi;function nn(K){return typeof K>"u"||(0,p.isStringArray)(K)}class qi{constructor(q){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,q){this._hasLegend=!0;for(let me=0,Le=q.tokenTypes.length;me<Le;me++)this._tokenTypeStrToInt.set(q.tokenTypes[me],me);for(let me=0,Le=q.tokenModifiers.length;me<Le;me++)this._tokenModifierStrToInt.set(q.tokenModifiers[me],me)}}push(q,me,Le,Ye,st){if(typeof q=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this._pushEncoded(q,me,Le,Ye,st);if(x.isRange(q)&&typeof me=="string"&&nn(Le))return this._push(q,me,Le);throw(0,d.illegalArgument)()}_push(q,me,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=q.start.line,st=q.start.character,pt=q.end.character-q.start.character,wt=this._tokenTypeStrToInt.get(me);let Qt=0;if(Le)for(const vi of Le){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this._tokenModifierStrToInt.get(vi);Qt|=1<<Ei>>>0}this._pushEncoded(Ye,st,pt,wt,Qt)}_pushEncoded(q,me,Le,Ye,st){if(this._dataIsSortedAndDeltaEncoded&&(q<this._prevLine||q===this._prevLine&&me<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Qt=this._data.length/5|0;let vi=0,Ei=0;for(let _i=0;_i<Qt;_i++){let Ii=this._data[5*_i],Qi=this._data[5*_i+1];Ii===0?(Ii=vi,Qi+=Ei):Ii+=vi,this._data[5*_i]=Ii,this._data[5*_i+1]=Qi,vi=Ii,Ei=Qi}}let pt=q,wt=me;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(pt-=this._prevLine,pt===0&&(wt-=this._prevChar)),this._data[this._dataLen++]=pt,this._data[this._dataLen++]=wt,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=st,this._prevLine=q,this._prevChar=me}static _sortAndDeltaEncode(q){const me=[],Le=q.length/5|0;for(let wt=0;wt<Le;wt++)me[wt]=wt;me.sort((wt,Qt)=>{const vi=q[5*wt],Ei=q[5*Qt];if(vi===Ei){const _i=q[5*wt+1],Ii=q[5*Qt+1];return _i-Ii}return vi-Ei});const Ye=new Uint32Array(q.length);let st=0,pt=0;for(let wt=0;wt<Le;wt++){const Qt=5*me[wt],vi=q[Qt+0],Ei=q[Qt+1],_i=q[Qt+2],Ii=q[Qt+3],Qi=q[Qt+4],Bn=vi-st,Cr=Bn===0?Ei-pt:Ei,Yi=5*wt;Ye[Yi+0]=Bn,Ye[Yi+1]=Cr,Ye[Yi+2]=_i,Ye[Yi+3]=Ii,Ye[Yi+4]=Qi,st=vi,pt=Ei}return Ye}build(q){return this._dataIsSortedAndDeltaEncoded?new xi(new Uint32Array(this._data),q):new xi(qi._sortAndDeltaEncode(this._data),q)}}e.SemanticTokensBuilder=qi;class xi{constructor(q,me){this.resultId=me,this.data=q}}e.SemanticTokens=xi;class En{constructor(q,me,Le){this.start=q,this.deleteCount=me,this.data=Le}}e.SemanticTokensEdit=En;class Oi{constructor(q,me){this.resultId=me,this.edits=q}}e.SemanticTokensEdits=Oi;var rn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(q){this.name=q}}e.DebugVisualization=bn;let ji=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.QuickInputButtons=ji,e.QuickInputButtons=ji=Xe([E],ji);var Ui;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Ki;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Ki||(e.InputBoxValidationSeverity=Ki={}));var $e;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})($e||(e.ExtensionKind=$e={}));class wi{static validate(q){if(typeof q.badge=="string"){let me=(0,A.nextCharLength)(q.badge,0);if(me<q.badge.length&&(me+=(0,A.nextCharLength)(q.badge,me)),q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!ai.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,me,Le){this.badge=q,this.tooltip=me,this.color=Le}}e.FileDecoration=wi;let Bi=class{constructor(q){this.kind=q}};e.ColorTheme=Bi,e.ColorTheme=Bi=Xe([E],Bi);var ct;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(ct||(e.ColorThemeKind=ct={}));class Et{static isNotebookRange(q){return q instanceof Et?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(q,me){if(q<0)throw(0,d.illegalArgument)("start must be positive");if(me<0)throw(0,d.illegalArgument)("end must be positive");q<=me?(this._start=q,this._end=me):(this._start=me,this._end=q)}with(q){let me=this._start,Le=this._end;return q.start!==void 0&&(me=q.start),q.end!==void 0&&(Le=q.end),me===this._start&&Le===this._end?this:new Et(me,Le)}}e.NotebookRange=Et;class Wi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(me=>Wi.isNotebookCellData(me))}static isNotebookCellData(q){return!0}constructor(q,me,Le,Ye,st,pt,wt){this.kind=q,this.value=me,this.languageId=Le,this.mime=Ye,this.outputs=st??[],this.metadata=pt,this.executionSummary=wt,Wi.validate(this)}}e.NotebookCellData=Wi;class Sn{constructor(q){this.cells=q}}e.NotebookData=Sn;class mi{static isNotebookCellOutputItem(q){return q instanceof mi?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const me={name:q.name,message:q.message,stack:q.stack};return mi.json(me,"application/vnd.code.notebook.error")}static stdout(q){return mi.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return mi.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,me="application/octet-stream"){return new mi(q,me)}static#e=new TextEncoder;static text(q,me=L.Mimes.text){const Le=mi.#e.encode(String(q));return new mi(Le,me)}static json(q,me="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return mi.text(Le,me)}constructor(q,me){this.data=q,this.mime=me;const Le=(0,L.normalizeMimeType)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=mi;class zi{static isNotebookCellOutput(q){return q instanceof zi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,me=!1){const Le=new Set,Ye=new Set;for(let st=0;st<q.length;st++){const pt=q[st],wt=(0,L.normalizeMimeType)(pt.mime);if(!Le.has(wt)||(0,b.isTextStreamMime)(wt)){Le.add(wt);continue}Ye.add(st),me&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ye.size===0?q:q.filter((st,pt)=>!Ye.has(pt))}constructor(q,me,Le){this.items=zi.ensureUniqueMimeTypes(q,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,I.generateUuid)(),this.metadata=me??Le)}}e.NotebookCellOutput=zi;var Ni;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Ni||(e.NotebookCellKind=Ni={}));var sn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class ln{constructor(q,me){this.text=q,this.alignment=me}}e.NotebookCellStatusBarItem=ln;var cn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class wn{constructor(q,me=[]){this.uri=q,this.provides=(0,s.asArray)(me)}}e.NotebookRendererScript=wn;class _n{constructor(q){this.label=q}}e.NotebookKernelSourceAction=_n;var dn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(dn||(e.NotebookVariablesRequestKind=dn={}));let Gi=class{constructor(q,me){this.label=q,this.timestamp=me}};e.TimelineItem=Gi,e.TimelineItem=Gi=Xe([E],Gi);var hn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var fn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class yn{constructor(q,me){this.ranges=q,this.wordPattern=me}}e.LinkedEditingRanges=yn;class Dn{constructor(q){this._autoForwardAction=q}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Dn;var ge;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ge||(e.TestResultState=ge={}));var we;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(we||(e.TestRunProfileKind=we={}));let Be=class{constructor(q=void 0,me=void 0,Le=void 0,Ye=!1,st=!0){this.include=q,this.exclude=me,this.profile=Le,this.continuous=Ye,this.preserveFocus=st}};e.TestRunRequest=Be,e.TestRunRequest=Be=Xe([E],Be);let ht=k=class{static diff(q,me,Le){const Ye=new k(q);return Ye.expectedOutput=me,Ye.actualOutput=Le,Ye}constructor(q){this.message=q}};e.TestMessage=ht,e.TestMessage=ht=k=Xe([E],ht);let _t=class{constructor(q){this.id=q}};e.TestTag=_t,e.TestTag=_t=Xe([E],_t);class Lt{constructor(q,me){this.covered=q,this.total=me,Ai(this)}}e.TestCoverageCount=Lt;function Ai(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Xi{static fromDetails(q,me){const Le=new Lt(0,0),Ye=new Lt(0,0),st=new Lt(0,0);for(const wt of me)if("branches"in wt){Le.total+=1,Le.covered+=wt.executed?1:0;for(const Qt of wt.branches)Ye.total+=1,Ye.covered+=Qt.executed?1:0}else st.total+=1,st.covered+=wt.executed?1:0;const pt=new Xi(q,Le,Ye.total>0?Ye:void 0,st.total>0?st:void 0);return pt.detailedCoverage=me,pt}constructor(q,me,Le,Ye,st=[]){this.uri=q,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Ye,this.fromTests=st}}e.FileCoverage=Xi;class $n{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Le=[]){this.executed=q,this.location=me,this.branches=Le}}e.StatementCoverage=$n;class Hn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Le){this.executed=q,this.location=me,this.label=Le}}e.BranchCoverage=Hn;class Vn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Le){this.name=q,this.executed=me,this.location=Le}}e.DeclarationCoverage=Vn;var Cn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var In;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Tn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class qn{constructor(q,me,Le,Ye,st,pt){this.kind=q,this.name=me,this.detail=Le,this.uri=Ye,this.range=st,this.selectionRange=pt}}e.TypeHierarchyItem=qn;class jn{constructor(q){this.uri=q}}e.TextTabInput=jn;class Kn{constructor(q,me){this.original=q,this.modified=me}}e.TextDiffTabInput=Kn;class Gn{constructor(q,me,Le,Ye){this.base=q,this.input1=me,this.input2=Le,this.result=Ye}}e.TextMergeTabInput=Gn;class Xn{constructor(q,me){this.uri=q,this.viewType=me}}e.CustomEditorTabInput=Xn;class Qn{constructor(q){this.viewType=q}}e.WebviewEditorTabInput=Qn;class Yn{constructor(q,me){this.uri=q,this.notebookType=me}}e.NotebookEditorTabInput=Yn;class Jn{constructor(q,me,Le){this.original=q,this.modified=me,this.notebookType=Le}}e.NotebookDiffEditorTabInput=Jn;class Zn{constructor(){}}e.TerminalEditorTabInput=Zn;class er{constructor(q,me){this.uri=q,this.inputBoxUri=me}}e.InteractiveWindowInput=er;class tr{constructor(){}}e.ChatEditorTabInput=tr;class ir{constructor(q){this.textDiffs=q}}e.TextMultiDiffTabInput=ir;var Pn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var kn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var An;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(q,me,Le){this.id=q,this.label=me,this.values=Le}}e.ChatCompletionItem=nr;var Rn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Rn||(e.InteractiveEditorResponseFeedbackKind=Rn={}));var Ln;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class rr{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new je(q):q}}e.ChatResponseMarkdownPart=rr;class sr{constructor(q,me){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new je(q):q,this.vulnerabilities=me}}e.ChatResponseMarkdownWithVulnerabilitiesPart=sr;class or{constructor(q,me){this.participant=q,this.command=me}}e.ChatResponseDetectedParticipantPart=or;class ar{constructor(q,me,Le){this.title=q,this.message=me,this.data=Le}}e.ChatResponseConfirmationPart=ar;class lr{constructor(q,me){this.value=q,this.baseUri=me}}e.ChatResponseFileTreePart=lr;class cr{constructor(q,me){this.value=q,this.title=me}}e.ChatResponseAnchorPart=cr;class ur{constructor(q){this.value=q}}e.ChatResponseProgressPart=ur;class dr{constructor(q,me){this.value=q,this.task=me}}e.ChatResponseProgressPart2=dr;class hr{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new je(q):q}}e.ChatResponseWarningPart=hr;class fr{constructor(q){this.value=q}}e.ChatResponseCommandButtonPart=fr;class gr{constructor(q,me){this.value=q,this.iconPath=me}}e.ChatResponseReferencePart=gr;class mr{constructor(q,me){this.uri=q,this.edits=Array.isArray(me)?me:[me]}}e.ChatResponseTextEditPart=mr;class pr{constructor(q,me,Le,Ye){this.prompt=q,this.command=me,this.references=Le,this.participant=Ye}}e.ChatRequestTurn=pr;class vr{constructor(q,me,Le,Ye){this.response=q,this.result=me,this.participant=Le,this.command=Ye}}e.ChatResponseTurn=vr;var On;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var mn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class Er{constructor(q,me,Le){this.name=q,this.content=me,this.isError=Le??!1}}e.LanguageModelFunctionResultPart=Er;class pn{static User(q,me){const Le=new pn(mn.User,typeof q=="string"?q:"",me);return Le.content2=q,Le}static Assistant(q,me){return new pn(mn.Assistant,q,me)}constructor(q,me,Le){this.role=q,this.content=me,this.content2=me,this.name=Le}}e.LanguageModelChatMessage=pn;class br{constructor(q,me){this.name=q,this.parameters=me}}e.LanguageModelFunctionUsePart=br;class Sr{constructor(q){this.value=q}}e.LanguageModelTextPart=Sr;class wr{constructor(q){this.content=q}}e.LanguageModelChatSystemMessage=wr;class _r{constructor(q,me){this.content=q,this.name=me}}e.LanguageModelChatUserMessage=_r;class yr{constructor(q,me){this.content=q,this.name=me}}e.LanguageModelChatAssistantMessage=yr;class Ri extends Error{static NotFound(q){return new Ri(q,Ri.NotFound.name)}static NoPermissions(q){return new Ri(q,Ri.NoPermissions.name)}static Blocked(q){return new Ri(q,Ri.Blocked.name)}constructor(q,me,Le){super(q,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.LanguageModelError=Ri;var Nn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Fn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var xn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(xn||(e.KeywordRecognitionStatus=xn={}));class Dr{constructor(q,me){this.text=q,this.range=me}}e.InlineEdit=Dr;var Un;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(_e[341],ye([1,0,6,10]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class T{constructor(L){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(s.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,A,p){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const a=this._relatedInformationProviders.get(L);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(A,p)??[]}getRelatedInformation(L,A,p){return this._proxy.$getAiRelatedInformation(A,p)}registerRelatedInformationProvider(L,A,p){const a=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(a,p),this._proxy.$registerAiRelatedInformationProvider(a,A),new d.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(a),this._relatedInformationProviders.delete(a)})}}e.ExtHostRelatedInformation=T}),define(_e[128],ye([1,0,4,6,10,24,156,5,20]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,A.createDecorator)("IExtHostAuthentication");let a=class{constructor(c){this._authenticationProviders=new Map,this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new I,this._proxy=c.getProxy(d.MainContext.MainThreadAuthentication)}async getSession(c,C,b,l={}){const m=R.ExtensionIdentifier.toKey(c.identifier),h=[...b].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${m} ${C} ${h}`,async()=>{await this._proxy.$ensureProvider(C);const g=c.displayName||c.name;return this._proxy.$getSession(C,b,m,g,l)})}async getAccounts(c){return await this._proxy.$ensureProvider(c),await this._proxy.$getAccounts(c)}async removeSession(c,C){const b=this._authenticationProviders.get(c);return b?b.provider.removeSession(C):this._proxy.$removeSession(c,C)}registerAuthenticationProvider(c,C,b,l){if(this._authenticationProviders.get(c))throw new Error(`An authentication provider with id '${c}' is already registered.`);this._authenticationProviders.set(c,{label:C,provider:b,options:l??{supportsMultipleAccounts:!1}});const m=b.onDidChangeSessions(h=>this._proxy.$sendDidChangeSessions(c,h));return this._proxy.$registerAuthenticationProvider(c,C,l?.supportsMultipleAccounts??!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(c),this._proxy.$unregisterAuthenticationProvider(c)})}async $createSession(c,C,b){const l=this._authenticationProviders.get(c);if(l)return await l.provider.createSession(C,b);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $removeSession(c,C){const b=this._authenticationProviders.get(c);if(b)return await b.provider.removeSession(C);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $getSessions(c,C,b){const l=this._authenticationProviders.get(c);if(l)return await l.provider.getSessions(C,b);throw new Error(`Unable to find authentication provider with handle: ${c}`)}$onDidChangeAuthenticationSessions(c,C){return c.startsWith(L.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:c,label:C}}),Promise.resolve()}};e.ExtHostAuthentication=a,e.ExtHostAuthentication=a=Xe([He(0,p.IExtHostRpcService)],a);class I{constructor(){this._inFlightPromises=new Map}getOrCreate(c,C){const b=this._inFlightPromises.get(c);if(b)return b;const l=C().finally(()=>this._inFlightPromises.delete(c));return this._inFlightPromises.set(c,l),l}}}),define(_e[163],ye([1,0,2,6,10,5,20,12,19,13,17,26]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class{static{c=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(l,m){this._logService=m,this._provider=new Map,this._proxy=l.getProxy(d.MainContext.MainThreadDecorations)}registerFileDecorationProvider(l,m){const h=c._handlePool++;this._provider.set(h,{provider:l,extensionDescription:m}),this._proxy.$registerDecorationProvider(h,m.identifier.value);const g=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(h,null);return}const o=(0,p.asArray)(n);if(o.length<=c._maxEventSize){this._proxy.$onDidChange(h,o);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,o.length);const t=o.map(f=>({uri:f,rank:(0,a.count)(f.path,"/")})),i=(0,p.groupBy)(t,(f,u)=>f.rank-u.rank||(0,a.compare)(f.uri.path,u.uri.path)),r=[];e:for(const f of i){let u;for(const v of f){const y=(0,I.dirname)(v.uri.path);if(u!==y&&(u=y,r.push(v.uri)>=c._maxEventSize))break e}}this._proxy.$onDidChange(h,r)});return new T.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(l,m,h){if(!this._provider.has(l))return Object.create(null);const g=Object.create(null),{provider:n,extensionDescription:o}=this._provider.get(l);return await Promise.all(m.map(async t=>{try{const{uri:i,id:r}=t,f=await Promise.resolve(n.provideFileDecoration(s.URI.revive(i),h));if(!f)return;try{T.FileDecoration.validate(f),f.badge&&typeof f.badge!="string"&&(0,_.checkProposedApiEnabled)(o,"codiconDecoration"),g[r]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(i){this._logService.error(i)}})),g}};e.ExtHostDecorations=C,e.ExtHostDecorations=C=c=Xe([He(0,L.IExtHostRpcService),He(1,A.ILogService)],C),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")}),define(_e[342],ye([1,0,14,2,10,6,15,21,13]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class a{static{this._handlePool=0}constructor(_,c,C){this._documentsAndEditors=c,this._logService=C,this._documentContentProviders=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,c){if(Object.keys(L.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const C=a._handlePool++;this._documentContentProviders.set(C,c),this._proxy.$registerTextContentProvider(C,_);let b;if(typeof c.onDidChange=="function"){let l;b=c.onDidChange(async m=>{if(m.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(m))return;l&&await l;const h=this.$provideTextDocumentContent(C,m).then(async g=>{if(!g&&typeof g!="string")return;const n=this._documentsAndEditors.getDocument(m);if(!n)return;const o=(0,p.splitLines)(g);if(!n.equalLines(o))return this._proxy.$onVirtualDocumentChange(m,g)}).catch(s.onUnexpectedError).finally(()=>{l===h&&(l=void 0)});l=h})}return new T.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(_,c){const C=this._documentContentProviders.get(_);return C?Promise.resolve(C.provideTextDocumentContent(d.URI.revive(c),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=a}),define(_e[164],ye([1,0,66,15,13,198,138,10,19]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=I;const a=new Map;function I(b,l){l?a.set(b,l):a.delete(b)}function _(b){return a.get(b)}class c extends R.MirrorTextModel{constructor(l,m,h,g,n,o,t){super(m,h,g,n),this._proxy=l,this._languageId=o,this._isDirty=t,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,p.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===d.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(m){return m?l._getTextInRange(m):l.getText()},get eol(){return l._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(m){return l._lineAt(m)},offsetAt(m){return l._offsetAt(m)},positionAt(m){return l._positionAt(m)},validateRange(m){return l._validateRange(m)},validatePosition(m){return l._validatePosition(m)},getWordRangeAtPosition(m,h){return l._getWordRangeAtPosition(m,h)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,s.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,s.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const m=this._validateRange(l);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const h=this._eol,g=m.start.line,n=m.end.line,o=[];o.push(this._lines[g].substring(m.start.character));for(let t=g+1;t<n;t++)o.push(this._lines[t]);return o.push(this._lines[n].substring(0,m.end.character)),o.join(h)}_lineAt(l){let m;if(l instanceof A.Position?m=l.line:typeof l=="number"&&(m=l),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this._lines[m],m===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(l),h=this._lines[m.index].length;return new A.Position(m.index,Math.min(m.remainder,h))}_validateRange(l){if(!(l instanceof A.Range))throw new Error("Invalid argument");const m=this._validatePosition(l.start),h=this._validatePosition(l.end);return m===l.start&&h===l.end?l:new A.Range(m.line,m.character,h.line,h.character)}_validatePosition(l){if(!(l instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:m,character:h}=l,g=!1;if(m<0)m=0,h=0,g=!0;else if(m>=this._lines.length)m=this._lines.length-1,h=this._lines[m].length,g=!0;else{const n=this._lines[m].length;h<0?(h=0,g=!0):h>n&&(h=n,g=!0)}return g?new A.Position(m,h):l}_getWordRangeAtPosition(l,m){const h=this._validatePosition(l);if(!m)m=_(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const g=(0,L.getWordAtText)(h.character+1,(0,L.ensureValidWordDefinition)(m),this._lines[h.line],0);if(g)return new A.Range(h.line,g.startColumn-1,h.line,g.endColumn-1)}}e.ExtHostDocumentData=c;class C{constructor(l,m,h){this._line=l,this._text=m,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(_e[343],ye([1,0,6,10]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class T{constructor(L){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(s.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,A,p){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const a=this._AiEmbeddingVectorProviders.get(L);if(!a)throw new Error("Embedding vector provider not found");const I=await a.provideEmbeddingVector(A,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,A,p){const a=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(a,p),this._proxy.$registerAiEmbeddingVectorProvider(A,a),new d.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(a),this._AiEmbeddingVectorProviders.delete(a)})}}e.ExtHostAiEmbeddingVector=T}),define(_e[76],ye([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,d=ze(d);let b=C=class{constructor(m,h){this._fileSystemProvider=new Map,this._writeQueue=new I.ResourceQueue,this._proxy=m.getProxy(s.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(n){try{let o;const t=g._fileSystemProvider.get(n.scheme);return t?(await g._proxy.$ensureActivation(n.scheme),o=await t.impl.stat(n)):o=await g._proxy.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===d.FilePermission.Readonly?1:void 0}}catch(o){C._handleError(o)}},async readDirectory(n){try{const o=g._fileSystemProvider.get(n.scheme);return o?(await g._proxy.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await g._proxy.$readdir(n)}catch(o){return C._handleError(o)}},async createDirectory(n){try{const o=g._fileSystemProvider.get(n.scheme);return o&&!o.isReadonly?(await g._proxy.$ensureActivation(n.scheme),await g.mkdirp(o.impl,o.extUri,n)):await g._proxy.$mkdir(n)}catch(o){return C._handleError(o)}},async readFile(n){try{const o=g._fileSystemProvider.get(n.scheme);return o?(await g._proxy.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await g._proxy.$readFile(n)).buffer}catch(o){return C._handleError(o)}},async writeFile(n,o){try{const t=g._fileSystemProvider.get(n.scheme);return t&&!t.isReadonly?(await g._proxy.$ensureActivation(n.scheme),await g.mkdirp(t.impl,t.extUri,t.extUri.dirname(n)),await g._writeQueue.queueFor(n,()=>Promise.resolve(t.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await g._proxy.$writeFile(n,R.VSBuffer.wrap(o))}catch(t){return C._handleError(t)}},async delete(n,o){try{const t=g._fileSystemProvider.get(n.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await g._proxy.$ensureActivation(n.scheme),await t.impl.delete(n,{recursive:!1,...o})):await g._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return C._handleError(t)}},async rename(n,o,t){try{return await g._proxy.$rename(n,o,{overwrite:!1,...t})}catch(i){return C._handleError(i)}},async copy(n,o,t){try{return await g._proxy.$copy(n,o,{overwrite:!1,...t})}catch(i){return C._handleError(i)}},isWritableFileSystem(n){const o=h.getCapabilities(n);if(typeof o=="number")return!(o&d.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(m,h,g){const n=[];for(;!h.isEqual(g,h.dirname(g));)try{if(!((await m.stat(g)).type&d.FileType.Directory))throw T.FileSystemError.FileExists(`Unable to create folder '${g.scheme===c.Schemas.file?g.fsPath:g.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(d.toFileSystemProviderErrorCode(o)!==d.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(h.basename(g)),g=h.dirname(g)}for(let o=n.length-1;o>=0;o--){g=h.joinPath(g,n[o]);try{await m.createDirectory(g)}catch(t){if(d.toFileSystemProviderErrorCode(t)!==d.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(m){if(m instanceof T.FileSystemError)throw m;if(m instanceof d.FileSystemProviderError)switch(m.code){case d.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(m.message);case d.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(m.message);case d.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(m.message);case d.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(m.message);case d.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(m.message);case d.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(m.message);default:throw new T.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new T.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(m.message);switch(m.name){case d.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(m.message);case d.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(m.message);case d.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(m.message);case d.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(m.message);case d.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(m.message);case d.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(m.message);default:throw new T.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,h,g){return this._fileSystemProvider.set(m,{impl:h,extUri:g?.isCaseSensitive?_.extUri:_.extUriIgnorePathCase,isReadonly:!!g?.isReadonly}),(0,a.toDisposable)(()=>this._fileSystemProvider.delete(m))}getFileSystemProviderExtUri(m){return this._fileSystemProvider.get(m)?.extUri??_.extUri}};e.ExtHostConsumerFileSystem=b,e.ExtHostConsumerFileSystem=b=C=Xe([He(0,A.IExtHostRpcService),He(1,p.IExtHostFileSystemInfo)],b),e.IExtHostConsumerFileSystem=(0,L.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[98],ye([1,0,5,30,12,76,2]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let A=class{constructor(a,I,_){this._logService=I,this._extHostFileSystem=_,this._workspace=a.workspace??void 0,this._environment=a.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(a){return L.URI.joinPath(this._environment.workspaceStorageHome,a)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const a=this._workspace.id,I=await this._getWorkspaceStorageURI(a);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:L.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),I}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(a){if(this._value)return L.URI.joinPath(this._value,a.identifier.value)}globalValue(a){return L.URI.joinPath(this._environment.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=A,e.ExtensionStoragePaths=A=Xe([He(0,d.IExtHostInitDataService),He(1,T.ILogService),He(2,R.IExtHostConsumerFileSystem)],A)}),define(_e[344],ye([1,0,10,20,4]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let p;switch(A){case"light":p=s.ColorThemeKind.Light;break;case"hcDark":p=s.ColorThemeKind.HighContrast;break;case"hcLight":p=s.ColorThemeKind.HighContrastLight;break;default:p=s.ColorThemeKind.Dark}this._actual=new s.ColorTheme(p),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R,e.ExtHostTheming=R=Xe([He(0,d.IExtHostRpcService)],R)}),define(_e[77],ye([1,0,21,4,3,244,5,12,93,6,30,20,10]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,R=ze(R),c=ze(c);class C extends p.DisposableTunnel{}var b;(function(m){function h(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=h;function g(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=g})(b||(e.TunnelDtoConverter=b={})),e.IExtHostTunnelService=(0,L.createDecorator)("IExtHostTunnelService");let l=class extends T.Disposable{constructor(h,g,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new d.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(a.MainContext.MainThreadTunnelService)}async openTunnel(h,g){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(g,h.displayName);if(n){const o=new C(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,g){h.portRange===void 0&&h.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:h,provider:g}),this._proxy.$registerPortsAttributesProvider(h,n),new c.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(h,g,n,o,t){const i=[];for(const f of h){const u=this._portAttributesProviders.get(f);if(!u)return[];i.push(...await Promise.all(g.map(async v=>{let y;try{y=await u.provider.providePortAttributes({port:v,pid:n,commandLine:o},t)}catch{y=await u.provider.providePortAttributes(v,n,o,t)}return{providedAttributes:y,port:v}})))}const r=i.filter(f=>!!f.providedAttributes);return r.length>0?r.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(h){}registerTunnelProvider(h,g){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(o,t)=>await h.provideTunnel(o,t,s.CancellationToken.None)??void 0;const n=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,privacyOptions:g.tunnelFeatures?.privacyOptions,protocol:g.tunnelFeatures.protocol===void 0?!0:g.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,T.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(h,g){if(h){h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter());const n=h.tunnelFactory??(g?this.makeManagedTunnelFactory(g):void 0);if(n){this._forwardPortProvider=n;let o=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(h){}async $closeTunnel(h,g){if(this._extensionTunnels.has(h.host)){const n=this._extensionTunnels.get(h.host);n.has(h.port)&&(g&&n.get(h.port).disposeListener.dispose(),await n.get(h.port).tunnel.dispose(),n.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,g){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(h,g);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const t=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:o,disposeListener:t}),b.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(h){const g=await Promise.all(h.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),n=h.filter((o,t)=>g[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.ExtHostTunnelService=l,e.ExtHostTunnelService=l=Xe([He(0,_.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,A.ILogService)],l)}),define(_e[16],ye([1,0,19,22,187,80,86,29,177,57,108,25,182,23,50,18,2,114,31,106,88,55,146,90,155,153,307,322,120,127,74,75,319,10]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u,v,y,D,w,P,k,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=ee,e.fromRangeOrRangeWithMessage=ne,e.pathOrURIToURI=De,L=ze(L),g=ze(g),n=ze(n),o=ze(o),y=ze(y),w=ze(w),S=ze(S);var M;(function(ke){function Me(ie){const{selectionStartLineNumber:Ae,selectionStartColumn:Ke,positionLineNumber:it,positionColumn:Ge}=ie,ft=new S.Position(Ae-1,Ke-1),Pt=new S.Position(it-1,Ge-1);return new S.Selection(ft,Pt)}ke.to=Me;function Se(ie){const{anchor:Ae,active:Ke}=ie;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}ke.from=Se})(M||(e.Selection=M={}));var N;(function(ke){function Me(ie){if(!ie)return;const{start:Ae,end:Ke}=ie;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}ke.from=Me;function Se(ie){if(!ie)return;const{startLineNumber:Ae,startColumn:Ke,endLineNumber:it,endColumn:Ge}=ie;return new S.Range(Ae-1,Ke-1,it-1,Ge-1)}ke.to=Se})(N||(e.Range=N={}));var O;(function(ke){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}ke.from=Me;function Se(ie){return new S.Location(m.URI.revive(ie.uri),N.to(ie.range))}ke.to=Se})(O||(e.Location=O={}));var x;(function(ke){function Me(Se){switch(Se){case n.StandardTokenType.Comment:return S.StandardTokenType.Comment;case n.StandardTokenType.Other:return S.StandardTokenType.Other;case n.StandardTokenType.RegEx:return S.StandardTokenType.RegEx;case n.StandardTokenType.String:return S.StandardTokenType.String}}ke.to=Me})(x||(e.TokenType=x={}));var U;(function(ke){function Me(ie){return new S.Position(ie.lineNumber-1,ie.column-1)}ke.to=Me;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}ke.from=Se})(U||(e.Position=U={}));var F;(function(ke){function Me(Ae,Ke,it){return(0,s.coalesce)((0,s.asArray)(Ae).map(Ge=>Se(Ge,Ke,it)))}ke.from=Me;function Se(Ae,Ke,it){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:it?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:ie(Ae.scheme,Ke),pattern:et.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:it?.isBuiltin}}function ie(Ae,Ke){return Ke&&typeof Ae=="string"?Ke.transformOutgoingScheme(Ae):Ae}})(F||(e.DocumentSelector=F={}));var H;(function(ke){function Me(ie){switch(ie){case S.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case S.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}ke.from=Me;function Se(ie){switch(ie){case i.MarkerTag.Unnecessary:return S.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return S.DiagnosticTag.Deprecated;default:return}}ke.to=Se})(H||(e.DiagnosticTag=H={}));var j;(function(ke){function Me(ie){let Ae;return ie.code&&((0,l.isString)(ie.code)||(0,l.isNumber)(ie.code)?Ae=String(ie.code):Ae={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Ae,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,s.coalesce)(ie.tags.map(H.from)):void 0}}ke.from=Me;function Se(ie){const Ae=new S.Diagnostic(N.to(ie),ie.message,B.to(ie.severity));return Ae.source=ie.source,Ae.code=(0,l.isString)(ie.code)?ie.code:ie.code?.value,Ae.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Ae.tags=ie.tags&&(0,s.coalesce)(ie.tags.map(H.to)),Ae}ke.to=Se})(j||(e.Diagnostic=j={}));var re;(function(ke){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}ke.from=Me;function Se(ie){return new S.DiagnosticRelatedInformation(new S.Location(ie.resource,N.to(ie)),ie.message)}ke.to=Se})(re||(e.DiagnosticRelatedInformation=re={}));var B;(function(ke){function Me(ie){switch(ie){case S.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ke.from=Me;function Se(ie){switch(ie){case i.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}ke.to=Se})(B||(e.DiagnosticSeverity=B={}));var V;(function(ke){function Me(ie){return typeof ie=="number"&&ie>=S.ViewColumn.One?ie-1:ie===S.ViewColumn.Beside?E.SIDE_GROUP:E.ACTIVE_GROUP}ke.from=Me;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=Se})(V||(e.ViewColumn=V={}));function X(ke){return typeof ke.range<"u"}function ee(ke){return ke.length===0?!0:!!X(ke[0])}var he;(function(ke){function Me(Ge){return Ge.map(ke.from)}ke.fromMany=Me;function Se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ie(Ge){let ft;if(Se(Ge)){const{language:Mt,value:ci}=Ge;ft={value:"```"+Mt+`
`+ci+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ge)?ft={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ft={value:Ge}:ft={value:""};const Pt=Object.create(null);ft.uris=Pt;const Xt=Mt=>{try{let ci=m.URI.parse(Mt,!0);ci=ci.with({query:Ae(ci.query,Pt)}),Pt[Mt]=ci}catch{}return""},li=new p.marked.Renderer;return li.link=Xt,li.image=Mt=>typeof Mt=="string"?Xt(L.parseHrefAndDimensions(Mt).href):"",(0,p.marked)(ft.value,{renderer:li}),ft}ke.from=ie;function Ae(Ge,ft){if(!Ge)return Ge;let Pt;try{Pt=(0,a.parse)(Ge)}catch{}if(!Pt)return Ge;let Xt=!1;return Pt=(0,_.cloneAndChange)(Pt,li=>{if(m.URI.isUri(li)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Mt]=li,Xt=!0,Mt}else return}),Xt?JSON.stringify(Pt):Ge}function Ke(Ge){const ft=new S.MarkdownString(Ge.value,Ge.supportThemeIcons);return ft.isTrusted=Ge.isTrusted,ft.supportHtml=Ge.supportHtml,ft.baseUri=Ge.baseUri?m.URI.from(Ge.baseUri):void 0,ft}ke.to=Ke;function it(Ge){if(Ge)return typeof Ge=="string"?Ge:ke.from(Ge)}ke.fromStrict=it})(he||(e.MarkdownString=he={}));function ne(ke){return ee(ke)?ke.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?he.fromMany(Me.hoverMessage):Me.hoverMessage?he.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):ke.map(Me=>({range:N.from(Me)}))}function De(ke){return typeof ke>"u"?ke:typeof ke=="string"?m.URI.file(ke):ke}var pe;(function(ke){function Me(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?De(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}ke.from=Me})(pe||(e.ThemableDecorationAttachmentRenderOptions=pe={}));var G;(function(ke){function Me(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?De(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?pe.from(Se.before):void 0,after:Se.after?pe.from(Se.after):void 0}}ke.from=Me})(G||(e.ThemableDecorationRenderOptions=G={}));var W;(function(ke){function Me(Se){if(typeof Se>"u")return Se;switch(Se){case S.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case S.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ke.from=Me})(W||(e.DecorationRangeBehavior=W={}));var se;(function(ke){function Me(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?W.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?G.from(Se.light):void 0,dark:Se.dark?G.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?De(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?pe.from(Se.before):void 0,after:Se.after?pe.from(Se.after):void 0}}ke.from=Me})(se||(e.DecorationRenderOptions=se={}));var ae;(function(ke){function Me(ie){return{text:ie.newText,eol:ie.newEol&&xe.from(ie.newEol),range:N.from(ie.range)}}ke.from=Me;function Se(ie){const Ae=new S.TextEdit(N.to(ie.range),ie.text);return Ae.newEol=typeof ie.eol>"u"?void 0:xe.to(ie.eol),Ae}ke.to=Se})(ae||(e.TextEdit=ae={}));var te;(function(ke){function Me(ie,Ae){const Ke={edits:[]};if(ie instanceof S.WorkspaceEdit){const it=new A.ResourceSet;for(const Ge of ie._allEntries())Ge._type===S.FileEditType.File&&m.URI.isUri(Ge.to)&&Ge.from===void 0&&it.add(Ge.to);for(const Ge of ie._allEntries())if(Ge._type===S.FileEditType.File){let ft;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ft={type:"base64",value:(0,d.encodeBase64)(d.VSBuffer.wrap(Ge.options.contents))}:ft={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ke.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ft},metadata:Ge.metadata})}else Ge._type===S.FileEditType.Text?Ke.edits.push({resource:Ge.uri,textEdit:ae.from(Ge.edit),versionId:it.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===S.FileEditType.Snippet?Ke.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:it.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===S.FileEditType.Cell?Ke.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===S.FileEditType.CellReplace&&Ke.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:w.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ze.from)}})}return Ke}ke.from=Me;function Se(ie){const Ae=new S.WorkspaceEdit,Ke=new A.ResourceMap;for(const it of ie.edits)if(it.textEdit){const Ge=it,ft=m.URI.revive(Ge.resource),Pt=N.to(Ge.textEdit.range),Xt=Ge.textEdit.text,li=Ge.textEdit.insertAsSnippet;let Mt;li?Mt=S.SnippetTextEdit.replace(Pt,new S.SnippetString(Xt)):Mt=S.TextEdit.replace(Pt,Xt);const ci=Ke.get(ft);ci?ci.push(Mt):Ke.set(ft,[Mt])}else Ae.renameFile(m.URI.revive(it.oldResource),m.URI.revive(it.newResource),it.options);for(const[it,Ge]of Ke)Ae.set(it,Ge);return Ae}ke.to=Se})(te||(e.WorkspaceEdit=te={}));var ce;(function(ke){const Me=Object.create(null);Me[S.SymbolKind.File]=o.SymbolKind.File,Me[S.SymbolKind.Module]=o.SymbolKind.Module,Me[S.SymbolKind.Namespace]=o.SymbolKind.Namespace,Me[S.SymbolKind.Package]=o.SymbolKind.Package,Me[S.SymbolKind.Class]=o.SymbolKind.Class,Me[S.SymbolKind.Method]=o.SymbolKind.Method,Me[S.SymbolKind.Property]=o.SymbolKind.Property,Me[S.SymbolKind.Field]=o.SymbolKind.Field,Me[S.SymbolKind.Constructor]=o.SymbolKind.Constructor,Me[S.SymbolKind.Enum]=o.SymbolKind.Enum,Me[S.SymbolKind.Interface]=o.SymbolKind.Interface,Me[S.SymbolKind.Function]=o.SymbolKind.Function,Me[S.SymbolKind.Variable]=o.SymbolKind.Variable,Me[S.SymbolKind.Constant]=o.SymbolKind.Constant,Me[S.SymbolKind.String]=o.SymbolKind.String,Me[S.SymbolKind.Number]=o.SymbolKind.Number,Me[S.SymbolKind.Boolean]=o.SymbolKind.Boolean,Me[S.SymbolKind.Array]=o.SymbolKind.Array,Me[S.SymbolKind.Object]=o.SymbolKind.Object,Me[S.SymbolKind.Key]=o.SymbolKind.Key,Me[S.SymbolKind.Null]=o.SymbolKind.Null,Me[S.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,Me[S.SymbolKind.Struct]=o.SymbolKind.Struct,Me[S.SymbolKind.Event]=o.SymbolKind.Event,Me[S.SymbolKind.Operator]=o.SymbolKind.Operator,Me[S.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function Se(Ae){return typeof Me[Ae]=="number"?Me[Ae]:o.SymbolKind.Property}ke.from=Se;function ie(Ae){for(const Ke in Me)if(Me[Ke]===Ae)return Number(Ke);return S.SymbolKind.Property}ke.to=ie})(ce||(e.SymbolKind=ce={}));var ue;(function(ke){function Me(ie){switch(ie){case S.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}ke.from=Me;function Se(ie){switch(ie){case o.SymbolTag.Deprecated:return S.SymbolTag.Deprecated}}ke.to=Se})(ue||(e.SymbolTag=ue={}));var Y;(function(ke){function Me(ie){return{name:ie.name,kind:ce.from(ie.kind),tags:ie.tags&&ie.tags.map(ue.from),containerName:ie.containerName,location:We.from(ie.location)}}ke.from=Me;function Se(ie){const Ae=new S.SymbolInformation(ie.name,ce.to(ie.kind),ie.containerName,We.to(ie.location));return Ae.tags=ie.tags&&ie.tags.map(ue.to),Ae}ke.to=Se})(Y||(e.WorkspaceSymbol=Y={}));var oe;(function(ke){function Me(ie){const Ae={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ce.from(ie.kind),tags:ie.tags?.map(ue.from)??[]};return ie.children&&(Ae.children=ie.children.map(Me)),Ae}ke.from=Me;function Se(ie){const Ae=new S.DocumentSymbol(ie.name,ie.detail,ce.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,s.isNonEmptyArray)(ie.tags)&&(Ae.tags=ie.tags.map(ue.to)),ie.children&&(Ae.children=ie.children.map(Se)),Ae}ke.to=Se})(oe||(e.DocumentSymbol=oe={}));var ve;(function(ke){function Me(ie){const Ae=new S.CallHierarchyItem(ce.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}ke.to=Me;function Se(ie,Ae,Ke){if(Ae=Ae??ie._sessionId,Ke=Ke??ie._itemId,Ae===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ke,name:ie.name,detail:ie.detail,kind:ce.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}ke.from=Se})(ve||(e.CallHierarchyItem=ve={}));var be;(function(ke){function Me(Se){return new S.CallHierarchyIncomingCall(ve.to(Se.from),Se.fromRanges.map(ie=>N.to(ie)))}ke.to=Me})(be||(e.CallHierarchyIncomingCall=be={}));var Fe;(function(ke){function Me(Se){return new S.CallHierarchyOutgoingCall(ve.to(Se.to),Se.fromRanges.map(ie=>N.to(ie)))}ke.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var We;(function(ke){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}ke.from=Me;function Se(ie){return new S.Location(m.URI.revive(ie.uri),N.to(ie.range))}ke.to=Se})(We||(e.location=We={}));var Ce;(function(ke){function Me(ie){const Ae=ie,Ke=ie;return{originSelectionRange:Ae.originSelectionRange?N.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ke.uri,range:N.from(Ae.targetRange?Ae.targetRange:Ke.range),targetSelectionRange:Ae.targetSelectionRange?N.from(Ae.targetSelectionRange):void 0}}ke.from=Me;function Se(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}ke.to=Se})(Ce||(e.DefinitionLink=Ce={}));var Ie;(function(ke){function Me(ie){return{range:N.from(ie.range),contents:he.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}ke.from=Me;function Se(ie){const Ae=ie.contents.map(he.to),Ke=N.to(ie.range),it=ie.canIncreaseVerbosity,Ge=ie.canDecreaseVerbosity;return new S.VerboseHover(Ae,Ke,it,Ge)}ke.to=Se})(Ie||(e.Hover=Ie={}));var Re;(function(ke){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}ke.from=Me;function Se(ie){return new S.EvaluatableExpression(N.to(ie.range),ie.expression)}ke.to=Se})(Re||(e.EvaluatableExpression=Re={}));var z;(function(ke){function Me(ie){if(ie instanceof S.InlineValueText)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof S.InlineValueVariableLookup)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Me;function Se(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}ke.to=Se})(z||(e.InlineValue=z={}));var $;(function(ke){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}ke.from=Me;function Se(ie){return new S.InlineValueContext(ie.frameId,N.to(ie.stoppedLocation))}ke.to=Se})($||(e.InlineValueContext=$={}));var Q;(function(ke){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}ke.from=Me;function Se(ie){return new S.DocumentHighlight(N.to(ie.range),ie.kind)}ke.to=Se})(Q||(e.DocumentHighlight=Q={}));var Z;(function(ke){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(Q.from)}}ke.from=Me;function Se(ie){return new S.MultiDocumentHighlight(m.URI.revive(ie.uri),ie.highlights.map(Q.to))}ke.to=Se})(Z||(e.MultiDocumentHighlight=Z={}));var fe;(function(ke){function Me(Se){switch(Se){case o.CompletionTriggerKind.TriggerCharacter:return S.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return S.CompletionTriggerKind.Invoke}}ke.to=Me})(fe||(e.CompletionTriggerKind=fe={}));var Ee;(function(ke){function Me(Se){return{triggerKind:fe.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}ke.to=Me})(Ee||(e.CompletionContext=Ee={}));var Ne;(function(ke){function Me(ie){switch(ie){case S.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}ke.from=Me;function Se(ie){switch(ie){case o.CompletionItemTag.Deprecated:return S.CompletionItemTag.Deprecated}}ke.to=Se})(Ne||(e.CompletionItemTag=Ne={}));var Ve;(function(ke){const Me=new Map([[S.CompletionItemKind.Method,o.CompletionItemKind.Method],[S.CompletionItemKind.Function,o.CompletionItemKind.Function],[S.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[S.CompletionItemKind.Field,o.CompletionItemKind.Field],[S.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[S.CompletionItemKind.Class,o.CompletionItemKind.Class],[S.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[S.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[S.CompletionItemKind.Module,o.CompletionItemKind.Module],[S.CompletionItemKind.Property,o.CompletionItemKind.Property],[S.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[S.CompletionItemKind.Value,o.CompletionItemKind.Value],[S.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[S.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[S.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[S.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[S.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[S.CompletionItemKind.Text,o.CompletionItemKind.Text],[S.CompletionItemKind.Color,o.CompletionItemKind.Color],[S.CompletionItemKind.File,o.CompletionItemKind.File],[S.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[S.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[S.CompletionItemKind.Event,o.CompletionItemKind.Event],[S.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[S.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[S.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[S.CompletionItemKind.User,o.CompletionItemKind.User]]);function Se(Ke){return Me.get(Ke)??o.CompletionItemKind.Property}ke.from=Se;const ie=new Map([[o.CompletionItemKind.Method,S.CompletionItemKind.Method],[o.CompletionItemKind.Function,S.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,S.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,S.CompletionItemKind.Field],[o.CompletionItemKind.Variable,S.CompletionItemKind.Variable],[o.CompletionItemKind.Class,S.CompletionItemKind.Class],[o.CompletionItemKind.Interface,S.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,S.CompletionItemKind.Struct],[o.CompletionItemKind.Module,S.CompletionItemKind.Module],[o.CompletionItemKind.Property,S.CompletionItemKind.Property],[o.CompletionItemKind.Unit,S.CompletionItemKind.Unit],[o.CompletionItemKind.Value,S.CompletionItemKind.Value],[o.CompletionItemKind.Constant,S.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,S.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,S.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,S.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,S.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,S.CompletionItemKind.Text],[o.CompletionItemKind.Color,S.CompletionItemKind.Color],[o.CompletionItemKind.File,S.CompletionItemKind.File],[o.CompletionItemKind.Reference,S.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,S.CompletionItemKind.Folder],[o.CompletionItemKind.Event,S.CompletionItemKind.Event],[o.CompletionItemKind.Operator,S.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,S.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,S.CompletionItemKind.User],[o.CompletionItemKind.Issue,S.CompletionItemKind.Issue]]);function Ae(Ke){return ie.get(Ke)??S.CompletionItemKind.Property}ke.to=Ae})(Ve||(e.CompletionItemKind=Ve={}));var je;(function(ke){function Me(Se,ie){const Ae=new S.CompletionItem(Se.label);return Ae.insertText=Se.insertText,Ae.kind=Ve.to(Se.kind),Ae.tags=Se.tags?.map(Ne.to),Ae.detail=Se.detail,Ae.documentation=L.isMarkdownString(Se.documentation)?he.to(Se.documentation):Se.documentation,Ae.sortText=Se.sortText,Ae.filterText=Se.filterText,Ae.preselect=Se.preselect,Ae.commitCharacters=Se.commitCharacters,g.Range.isIRange(Se.range)?Ae.range=N.to(Se.range):typeof Se.range=="object"&&(Ae.range={inserting:N.to(Se.range.insert),replacing:N.to(Se.range.replace)}),Ae.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new S.SnippetString(Se.insertText):(Ae.insertText=Se.insertText,Ae.textEdit=Ae.range instanceof S.Range?new S.TextEdit(Ae.range,Ae.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ae.additionalTextEdits=Se.additionalTextEdits.map(Ke=>ae.to(Ke))),Ae.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Ae}ke.to=Me})(je||(e.CompletionItem=je={}));var tt;(function(ke){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:he.fromStrict(ie.documentation)}}ke.from=Me;function Se(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?he.to(ie.documentation):ie.documentation}}ke.to=Se})(tt||(e.ParameterInformation=tt={}));var rt;(function(ke){function Me(ie){return{label:ie.label,documentation:he.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}ke.from=Me;function Se(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?he.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}ke.to=Se})(rt||(e.SignatureInformation=rt={}));var ot;(function(ke){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}ke.from=Me;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}ke.to=Se})(ot||(e.SignatureHelp=ot={}));var nt;(function(ke){function Me(Se,ie){const Ae=new S.InlayHint(U.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,Se)),ie.kind&&mt.to(ie.kind));return Ae.textEdits=ie.textEdits&&ie.textEdits.map(ae.to),Ae.tooltip=L.isMarkdownString(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,Ae.paddingLeft=ie.paddingLeft,Ae.paddingRight=ie.paddingRight,Ae}ke.to=Me})(nt||(e.InlayHint=nt={}));var at;(function(ke){function Me(Se,ie){const Ae=new S.InlayHintLabelPart(ie.label);return Ae.tooltip=L.isMarkdownString(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Ae.command=Se.fromInternal(ie.command)),ie.location&&(Ae.location=We.to(ie.location)),Ae}ke.to=Me})(at||(e.InlayHintLabelPart=at={}));var mt;(function(ke){function Me(ie){return ie}ke.from=Me;function Se(ie){return ie}ke.to=Se})(mt||(e.InlayHintKind=mt={}));var dt;(function(ke){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}ke.from=Me;function Se(ie){let Ae;if(ie.url)try{Ae=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ke=new S.DocumentLink(N.to(ie.range),Ae);return Ke.tooltip=ie.tooltip,Ke}ke.to=Se})(dt||(e.DocumentLink=dt={}));var lt;(function(ke){function Me(ie){const Ae=new S.ColorPresentation(ie.label);return ie.textEdit&&(Ae.textEdit=ae.to(ie.textEdit)),ie.additionalTextEdits&&(Ae.additionalTextEdits=ie.additionalTextEdits.map(Ke=>ae.to(Ke))),Ae}ke.to=Me;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?ae.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ae=>ae.from(Ae)):void 0}}ke.from=Se})(lt||(e.ColorPresentation=lt={}));var Te;(function(ke){function Me(ie){return new S.Color(ie[0],ie[1],ie[2],ie[3])}ke.to=Me;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}ke.from=Se})(Te||(e.Color=Te={}));var Ue;(function(ke){function Me(ie){return{range:N.from(ie.range)}}ke.from=Me;function Se(ie){return new S.SelectionRange(N.to(ie.range))}ke.to=Se})(Ue||(e.SelectionRange=Ue={}));var qe;(function(ke){function Me(Se){switch(Se){case u.SaveReason.AUTO:return S.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return S.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return S.TextDocumentSaveReason.FocusOut}}ke.to=Me})(qe||(e.TextDocumentSaveReason=qe={}));var Oe;(function(ke){function Me(ie){switch(ie){case S.TextEditorLineNumbersStyle.Off:return h.RenderLineNumbersType.Off;case S.TextEditorLineNumbersStyle.Relative:return h.RenderLineNumbersType.Relative;case S.TextEditorLineNumbersStyle.Interval:return h.RenderLineNumbersType.Interval;case S.TextEditorLineNumbersStyle.On:default:return h.RenderLineNumbersType.On}}ke.from=Me;function Se(ie){switch(ie){case h.RenderLineNumbersType.Off:return S.TextEditorLineNumbersStyle.Off;case h.RenderLineNumbersType.Relative:return S.TextEditorLineNumbersStyle.Relative;case h.RenderLineNumbersType.Interval:return S.TextEditorLineNumbersStyle.Interval;case h.RenderLineNumbersType.On:default:return S.TextEditorLineNumbersStyle.On}}ke.to=Se})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var xe;(function(ke){function Me(ie){if(ie===S.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===S.EndOfLine.LF)return t.EndOfLineSequence.LF}ke.from=Me;function Se(ie){if(ie===t.EndOfLineSequence.CRLF)return S.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return S.EndOfLine.LF}ke.to=Se})(xe||(e.EndOfLine=xe={}));var de;(function(ke){function Me(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case S.ProgressLocation.SourceControl:return r.ProgressLocation.Scm;case S.ProgressLocation.Window:return r.ProgressLocation.Window;case S.ProgressLocation.Notification:return r.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ke.from=Me})(de||(e.ProgressLocation=de={}));var J;(function(ke){function Me(ie){const Ae={start:ie.start+1,end:ie.end+1};return ie.kind&&(Ae.kind=Pe.from(ie.kind)),Ae}ke.from=Me;function Se(ie){const Ae={start:ie.start-1,end:ie.end-1};return ie.kind&&(Ae.kind=Pe.to(ie.kind)),Ae}ke.to=Se})(J||(e.FoldingRange=J={}));var Pe;(function(ke){function Me(ie){if(ie)switch(ie){case S.FoldingRangeKind.Comment:return o.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return o.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return o.FoldingRangeKind.Region}}ke.from=Me;function Se(ie){if(ie)switch(ie.value){case o.FoldingRangeKind.Comment.value:return S.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports.value:return S.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region.value:return S.FoldingRangeKind.Region}}ke.to=Se})(Pe||(e.FoldingRangeKind=Pe={}));var Qe;(function(ke){function Me(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?N.from(Se.selection):void 0,override:typeof Se.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ke.from=Me})(Qe||(e.TextEditorOpenOptions=Qe={}));var et;(function(ke){function Me(Ke){return Ke instanceof S.RelativePattern?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ie(Ke)?new S.RelativePattern(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}ke.from=Me;function Se(Ke){const it=Ke;return it?m.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function ie(Ke){const it=Ke;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Ae(Ke){return typeof Ke=="string"?Ke:new S.RelativePattern(m.URI.revive(Ke.baseUri),Ke.pattern)}ke.to=Ae})(et||(e.GlobPattern=et={}));var ut;(function(ke){function Me(Se){if(Se){if(Array.isArray(Se))return Se.map(Me);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:et.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}ke.from=Me})(ut||(e.LanguageSelector=ut={}));var gt;(function(ke){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&m.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(it=>it instanceof S.Range)))}ke.is=Me;function Se(ie){return{documents:ie.documents.map(Ae=>Ae.map(Ke=>({uri:m.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(it=>N.from(it))})))}}ke.from=Se})(gt||(e.MappedEditsContext=gt={}));var Dt;(function(ke){function Me(ie){return{start:ie.start,end:ie.end}}ke.from=Me;function Se(ie){return new S.NotebookRange(ie.start,ie.end)}ke.to=Se})(Dt||(e.NotebookRange=Dt={}));var Ot;(function(ke){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}ke.to=Me;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}ke.from=Se})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var zt;(function(ke){function Me(Se){if(Se===w.NotebookCellExecutionState.Unconfirmed)return S.NotebookCellExecutionState.Pending;if(Se===w.NotebookCellExecutionState.Pending)return;if(Se===w.NotebookCellExecutionState.Executing)return S.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}ke.to=Me})(zt||(e.NotebookCellExecutionState=zt={}));var ui;(function(ke){function Me(ie){switch(ie){case S.NotebookCellKind.Markup:return w.CellKind.Markup;case S.NotebookCellKind.Code:default:return w.CellKind.Code}}ke.from=Me;function Se(ie){switch(ie){case w.CellKind.Markup:return S.NotebookCellKind.Markup;case w.CellKind.Code:default:return S.NotebookCellKind.Code}}ke.to=Se})(ui||(e.NotebookCellKind=ui={}));var ti;(function(ke){function Me(ie){const Ae={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ke of ie.cells)S.NotebookCellData.validate(Ke),Ae.cells.push(Ze.from(Ke));return Ae}ke.from=Me;function Se(ie){const Ae=new S.NotebookData(ie.cells.map(Ze.to));return(0,l.isEmptyObject)(ie.metadata)||(Ae.metadata=ie.metadata),Ae}ke.to=Se})(ti||(e.NotebookData=ti={}));var Ze;(function(ke){function Me(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ot.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}ke.from=Me;function Se(ie){return new S.NotebookCellData(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Ot.to(ie.internalMetadata):void 0)}ke.to=Se})(Ze||(e.NotebookCellData=Ze={}));var jt;(function(ke){function Me(ie){return{mime:ie.mime,valueBytes:d.VSBuffer.wrap(ie.data)}}ke.from=Me;function Se(ie){return new S.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}ke.to=Se})(jt||(e.NotebookCellOutputItem=jt={}));var Kt;(function(ke){function Me(ie){return{outputId:ie.id,items:ie.items.map(jt.from),metadata:ie.metadata}}ke.from=Me;function Se(ie){const Ae=ie.items.map(jt.to);return new S.NotebookCellOutput(Ae,ie.outputId,ie.metadata)}ke.to=Se})(Kt||(e.NotebookCellOutput=Kt={}));var vt;(function(ke){function Me(Ae){return ie(Ae)?{include:et.from(Ae.include)??void 0,exclude:et.from(Ae.exclude)??void 0}:et.from(Ae)??void 0}ke.from=Me;function Se(Ae){return ie(Ae)?{include:et.to(Ae.include),exclude:et.to(Ae.exclude)}:et.to(Ae)}ke.to=Se;function ie(Ae){const Ke=Ae;return Ke?!(0,l.isUndefinedOrNull)(Ke.include)&&!(0,l.isUndefinedOrNull)(Ke.exclude):!1}})(vt||(e.NotebookExclusiveDocumentPattern=vt={}));var Tt;(function(ke){function Me(Se,ie,Ae){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===S.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:ie.toInternal(Ke,Ae),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}ke.from=Me})(Tt||(e.NotebookStatusBarItem=Tt={}));var ii;(function(ke){function Me(Se,ie,Ae){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(Ke,Ae),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}ke.from=Me})(ii||(e.NotebookKernelSourceAction=ii={}));var Yt;(function(ke){function Me(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}ke.from=Me})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var $t;(function(ke){function Me(ie){return{uri:ie.uri,provides:ie.provides}}ke.from=Me;function Se(ie){return new S.NotebookRendererScript(m.URI.revive(ie.uri),ie.provides)}ke.to=Se})($t||(e.NotebookRendererScript=$t={}));var St;(function(ke){function Me(ie){return{message:he.fromStrict(ie.message)||"",type:k.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri}}}ke.from=Me;function Se(ie){const Ae=new S.TestMessage(typeof ie.message=="string"?ie.message:he.to(ie.message));return Ae.actualOutput=ie.actual,Ae.expectedOutput=ie.expected,Ae.contextValue=ie.contextValue,Ae.location=ie.location?We.to(ie.location):void 0,Ae}ke.to=Se})(St||(e.TestMessage=St={}));var Nt;(function(ke){ke.namespace=k.namespaceTestTag,ke.denamespace=k.denamespaceTestTag})(Nt||(e.TestTag=Nt={}));var di;(function(ke){function Me(ie){const Ae=(0,f.getPrivateApiFor)(ie).controllerId;return{extId:P.TestId.fromExtHostTestItem(ie,Ae).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ke=>Nt.namespace(Ae,Ke.id)),range:g.Range.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&he.fromStrict(ie.error)||null}}ke.from=Me;function Se(ie){return{parent:void 0,error:void 0,id:P.TestId.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ae=>{const{tagId:Ke}=Nt.denamespace(Ae);return new S.TestTag(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}ke.toPlain=Se})(di||(e.TestItem=di={})),function(ke){function Me(ie){return{id:ie.id}}ke.from=Me;function Se(ie){return new S.TestTag(ie.id)}ke.to=Se}(Nt||(e.TestTag=Nt={}));var Ht;(function(ke){const Me=(ie,Ae)=>{const Ke=ie.value;if(!Ke)return;const it={...di.toPlain(Ke.item),parent:Ae,taskStates:Ke.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ft=>ft.type===k.TestMessageType.Error).map(St.to)})),children:[]};if(ie.children)for(const Ge of ie.children.values()){const ft=Me(Ge,it);ft&&it.children.push(ft)}return it};function Se(ie){const Ae=new c.WellDefinedPrefixTree;for(const Ge of ie.items)Ae.insert(P.TestId.fromString(Ge.item.extId).path,Ge);const Ke=[Ae.nodes],it=[];for(;Ke.length;)for(const Ge of Ke.pop())Ge.value?it.push(Ge):Ge.children&&Ke.push(Ge.children.values());return{completedAt:ie.completedAt,results:it.map(Ge=>Me(Ge)).filter(l.isDefined)}}ke.to=Se})(Ht||(e.TestResults=Ht={}));var Je;(function(ke){function Me(Ke){return{covered:Ke.covered,total:Ke.total}}function Se(Ke){return"line"in Ke?U.from(Ke):N.from(Ke)}function ie(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:Se(Ke.location),type:k.DetailType.Statement,branches:Ke.branches.length?Ke.branches.map(it=>({count:it.executed,location:it.location&&Se(it.location),label:it.label})):void 0}:{type:k.DetailType.Declaration,name:Ke.name,count:Ke.executed,location:Se(Ke.location)}}ke.fromDetails=ie;function Ae(Ke,it,Ge){return S.validateTestCoverageCount(Ge.statementCoverage),S.validateTestCoverageCount(Ge.branchCoverage),S.validateTestCoverageCount(Ge.declarationCoverage),{id:it,uri:Ge.uri,statement:Me(Ge.statementCoverage),branch:Ge.branchCoverage&&Me(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Me(Ge.declarationCoverage),testIds:Ge instanceof S.FileCoverage&&Ge.fromTests.length?Ge.fromTests.map(ft=>P.TestId.fromExtHostTestItem(ft,Ke).toString()):void 0}}ke.fromFile=Ae})(Je||(e.TestCoverage=Je={}));var Jt;(function(ke){function Me(Se){switch(Se){case o.CodeActionTriggerType.Invoke:return S.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return S.CodeActionTriggerKind.Automatic}}ke.to=Me})(Jt||(e.CodeActionTriggerKind=Jt={}));var ni;(function(ke){function Me(ie){const Ae=new S.TypeHierarchyItem(ce.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}ke.to=Me;function Se(ie,Ae,Ke){if(Ae=Ae??ie._sessionId,Ke=Ke??ie._itemId,Ae===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ke,kind:ce.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}ke.from=Se})(ni||(e.TypeHierarchyItem=ni={}));var hi;(function(ke){function Me(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}ke.from=Me})(hi||(e.ViewBadge=hi={}));var Ct;(function(ke){function Me(Ke,it,Ge){const ft=it.fileData;return ft?new S.InternalFileDataTransferItem(new S.DataTransferFile(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.createSingleCallFunction)(()=>Ge(ft.id)))):Ke===I.Mimes.uriList&&it.uriListData?new S.InternalDataTransferItem(Ae(it.uriListData)):new S.InternalDataTransferItem(it.asString)}ke.to=Me;async function Se(Ke,it){const Ge=await it.asString();if(Ke===I.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:ie(Ge)};const ft=it.asFile();return{asString:Ge,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}ke.from=Se;function ie(Ke){return T.UriList.split(Ke).map(it=>{if(it.startsWith("#"))return it;try{return m.URI.parse(it)}catch{}return it})}function Ae(Ke){return T.UriList.create(Ke.map(it=>typeof it=="string"?it:m.URI.revive(it)))}})(Ct||(e.DataTransferItem=Ct={}));var Ft;(function(ke){function Me(ie,Ae){const Ke=ie.items.map(([it,Ge])=>[it,Ct.to(it,Ge,Ae)]);return new S.DataTransfer(Ke)}ke.toDataTransfer=Me;async function Se(ie){const Ae={items:[]},Ke=[];for(const[it,Ge]of ie)Ke.push((async()=>{Ae.items.push([it,await Ct.from(it,Ge)])})());return await Promise.all(Ke),Ae}ke.from=Se})(Ft||(e.DataTransfer=Ft={}));var At;(function(ke){function Me(ie,Ae){return{kind:"reply",agentId:ie.participant??Ae?.agentId??"",subCommand:ie.command??Ae?.command,message:ie.prompt,title:ie.label}}ke.from=Me;function Se(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}ke.to=Se})(At||(e.ChatFollowup=At={}));var Ut;(function(ke){function Me(ie){switch(ie){case y.ChatMessageRole.System:return S.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return S.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return S.LanguageModelChatMessageRole.Assistant}}ke.to=Me;function Se(ie){switch(ie){case S.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case S.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case S.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}ke.from=Se})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(ke){function Me(ie){let Ae="",Ke;ie.content.type==="text"?Ae=ie.content.value:Ke=new S.LanguageModelFunctionResultPart(ie.content.name,ie.content.value,ie.content.isError);const it=Ut.to(ie.role),Ge=new S.LanguageModelChatMessage(it,Ae,ie.name);return Ke!==void 0&&(Ge.content2=Ke),Ge}ke.to=Me;function Se(ie){const Ae=Ut.from(ie.role),Ke=ie.name;let it;return ie.content2 instanceof S.LanguageModelFunctionResultPart?it={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:it={type:"text",value:ie.content},{role:Ae,name:Ke,content:it}}ke.from=Se})(ri||(e.LanguageModelChatMessage=ri={}));var Zt;(function(ke){function Me(ie){return{kind:"markdownContent",content:he.from(ie.value)}}ke.from=Me;function Se(ie){return new S.ChatResponseMarkdownPart(he.to(ie.content))}ke.to=Se})(Zt||(e.ChatResponseMarkdownPart=Zt={}));var si;(function(ke){function Me(ie){return{kind:"markdownVuln",content:he.from(ie.value),vulnerabilities:ie.vulnerabilities}}ke.from=Me;function Se(ie){return new S.ChatResponseMarkdownWithVulnerabilitiesPart(he.to(ie.content),ie.vulnerabilities)}ke.to=Se})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Vt;(function(ke){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}ke.from=Me;function Se(ie){return new S.ChatResponseDetectedParticipantPart(ie.agentId,ie.command)}ke.to=Se})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var Gt;(function(ke){function Me(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data}}ke.from=Me})(Gt||(e.ChatResponseConfirmationPart=Gt={}));var oi;(function(ke){function Me(ie){const{value:Ae,baseUri:Ke}=ie;function it(Ge,ft){return Ge.map(Pt=>{const Xt=m.URI.joinPath(ft,Pt.name);return{label:Pt.name,uri:Xt,children:Pt.children&&it(Pt.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,C.basename)(Ke),uri:Ke,children:it(Ae,Ke)}}}ke.from=Me;function Se(ie){const Ae=(0,a.revive)(ie.treeData);function Ke(ft){return ft.map(Pt=>({name:Pt.label,children:Pt.children&&Ke(Pt.children)}))}const it=Ae.uri,Ge=Ae.children?Ke(Ae.children):[];return new S.ChatResponseFileTreePart(Ge,it)}ke.to=Se})(oi||(e.ChatResponseFilesPart=oi={}));var kt;(function(ke){function Me(ie){const Ae=Ke=>m.URI.isUri(Ke);return{kind:"inlineReference",name:ie.title,inlineReference:Ae(ie.value)?ie.value:O.from(ie.value)}}ke.from=Me;function Se(ie){const Ae=(0,a.revive)(ie);return new S.ChatResponseAnchorPart(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:O.to(Ae.inlineReference),ie.name)}ke.to=Se})(kt||(e.ChatResponseAnchorPart=kt={}));var yt;(function(ke){function Me(ie){return{kind:"progressMessage",content:he.from(ie.value)}}ke.from=Me;function Se(ie){return new S.ChatResponseProgressPart(ie.content.value)}ke.to=Se})(yt||(e.ChatResponseProgressPart=yt={}));var bt;(function(ke){function Me(ie){return{kind:"warning",content:he.from(ie.value)}}ke.from=Me;function Se(ie){return new S.ChatResponseWarningPart(ie.content.value)}ke.to=Se})(bt||(e.ChatResponseWarningPart=bt={}));var ei;(function(ke){function Me(Se){return{kind:"progressTask",content:he.from(Se.value)}}ke.from=Me})(ei||(e.ChatTask=ei={}));var It;(function(ke){function Me(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?he.from(Se):void 0}}ke.from=Me})(It||(e.ChatTaskResult=It={}));var fi;(function(ke){function Me(ie,Ae,Ke){return{kind:"command",command:Ae.toInternal(ie.value,Ke)??{command:ie.value.command,title:ie.value.title}}}ke.from=Me;function Se(ie,Ae){return new S.ChatResponseCommandButtonPart(Ae.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}ke.to=Se})(fi||(e.ChatResponseCommandButtonPart=fi={}));var qt;(function(ke){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Ae=>ae.from(Ae))}}ke.from=Me;function Se(ie){return new S.ChatResponseTextEditPart(m.URI.revive(ie.uri),ie.edits.map(Ae=>ae.to(Ae)))}ke.to=Se})(qt||(e.ChatResponseTextEditPart=qt={}));var bi;(function(ke){function Me(ie){const Ae=b.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:O.from(ie.value.value)},iconPath:Ae}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:O.from(ie.value),iconPath:Ae}}ke.from=Me;function Se(ie){const Ae=(0,a.revive)(ie),Ke=it=>m.URI.isUri(it)?it:O.to(it);return new S.ChatResponseReferencePart("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Ke(Ae.reference.value)}:Ke(Ae.reference))}ke.to=Se})(bi||(e.ChatResponseReferencePart=bi={}));var Si;(function(ke){function Me(Ae,Ke,it){return Ae instanceof S.ChatResponseMarkdownPart?Zt.from(Ae):Ae instanceof S.ChatResponseAnchorPart?kt.from(Ae):Ae instanceof S.ChatResponseReferencePart?bi.from(Ae):Ae instanceof S.ChatResponseProgressPart?yt.from(Ae):Ae instanceof S.ChatResponseFileTreePart?oi.from(Ae):Ae instanceof S.ChatResponseCommandButtonPart?fi.from(Ae,Ke,it):Ae instanceof S.ChatResponseTextEditPart?qt.from(Ae):Ae instanceof S.ChatResponseMarkdownWithVulnerabilitiesPart?si.from(Ae):Ae instanceof S.ChatResponseDetectedParticipantPart?Vt.from(Ae):Ae instanceof S.ChatResponseWarningPart?bt.from(Ae):{kind:"markdownContent",content:he.from("")}}ke.from=Me;function Se(Ae,Ke){switch(Ae.kind){case"reference":return bi.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Ae,Ke)}}ke.to=Se;function ie(Ae,Ke){switch(Ae.kind){case"markdownContent":return Zt.to(Ae);case"inlineReference":return kt.to(Ae);case"progressMessage":return;case"treeData":return oi.to(Ae);case"command":return fi.to(Ae,Ke)}}ke.toContent=ie})(Si||(e.ChatResponsePart=Si={}));var gi;(function(ke){function Me(Se){return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,references:Se.variables.variables.map(ai.to),location:Bt.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData}}ke.to=Me})(gi||(e.ChatAgentRequest=gi={}));var Bt;(function(ke){function Me(ie){switch(ie){case v.ChatAgentLocation.Notebook:return S.ChatLocation.Notebook;case v.ChatAgentLocation.Terminal:return S.ChatLocation.Terminal;case v.ChatAgentLocation.Panel:return S.ChatLocation.Panel;case v.ChatAgentLocation.Editor:return S.ChatLocation.Editor}}ke.to=Me;function Se(ie){switch(ie){case S.ChatLocation.Notebook:return v.ChatAgentLocation.Notebook;case S.ChatLocation.Terminal:return v.ChatAgentLocation.Terminal;case S.ChatLocation.Panel:return v.ChatAgentLocation.Panel;case S.ChatLocation.Editor:return v.ChatAgentLocation.Editor}}ke.from=Se})(Bt||(e.ChatLocation=Bt={}));var ai;(function(ke){function Me(Se){const ie=Se.value;if(!ie)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,m.isUriComponents)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.isUriComponents)(ie.uri)?O.to((0,a.revive)(ie)):ie,modelDescription:Se.modelDescription}}ke.to=Me})(ai||(e.ChatAgentValueReference=ai={}));var Ti;(function(ke){function Me(Se,ie,Ae){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:ie.toInternal(Se.command,Ae)}}ke.from=Me})(Ti||(e.ChatAgentCompletionItem=Ti={}));var Rt;(function(ke){function Me(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}ke.to=Me})(Rt||(e.ChatAgentResult=Rt={}));var yi;(function(ke){function Me(Se,ie,Ae){if(ie.action.kind==="vote")return;const Ke=Rt.to(Se);if(ie.action.kind==="command"){const it=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(it)??{command:it.id,title:it.title}}},result:Ke}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(ie.action.followup)},result:Ke}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ke}:{action:ie.action,result:Ke}}ke.to=Me})(yi||(e.ChatAgentUserActionEvent=yi={}));var Pi;(function(ke){function Me(Se,ie,Ae){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Ae)}ke.from=Me})(Pi||(e.TerminalQuickFix=Pi={}));var Di;(function(ke){function Me(Se){return{kind:pi.to(Se.kind)}}ke.to=Me})(Di||(e.PartialAcceptInfo=Di={}));var pi;(function(ke){function Me(Se){switch(Se){case o.PartialAcceptTriggerKind.Word:return S.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return S.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return S.PartialAcceptTriggerKind.Suggest;default:return S.PartialAcceptTriggerKind.Unknown}}ke.to=Me})(pi||(e.PartialAcceptTriggerKind=pi={}));var ki;(function(ke){function Me(Se,ie){return{id:ie,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}ke.from=Me})(ki||(e.DebugTreeItem=ki={}));var Wt;(function(ke){function Me(Se){return{name:Se.name,description:Se.description,parametersSchema:Se.parametersSchema}}ke.to=Me})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(_e[345],ye([1,0,6,20,16,52]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(p,a){this._proxy=p.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>a.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,a,I){const _=new R.SerializableObjectWithBuffers(T.WorkspaceEdit.from(p,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(_,void 0,I?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Xe([He(0,d.IExtHostRpcService)],L)}),define(_e[346],ye([1,0,19,9,51,4,40,3,43,18,2,24,6,16,10,308,26]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,C=ze(C),b=ze(b);class h{constructor(t,i,r,f,u){this._extension=t,this._request=i,this._proxy=r,this._commandsConverter=f,this._sessionDisposables=u,this._stopWatch=p.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let i=function(f){if(t._isClosed){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const t=this;this._stopWatch.reset();const r=(f,u)=>{if(typeof this._firstProgress>"u"&&"content"in f&&(this._firstProgress=this._stopWatch.elapsed()),u){const v=this._proxy.$handleProgressChunk(this._request.requestId,f),y={report:D=>{v?.then(w=>{w&&(b.MarkdownString.isMarkdownString(D.value)?this._proxy.$handleProgressChunk(this._request.requestId,C.ChatResponseWarningPart.from(D),w):this._proxy.$handleProgressChunk(this._request.requestId,C.ChatResponseReferencePart.from(D),w))})}};Promise.all([v,u?.(y)]).then(([D,w])=>{D!==void 0&&w!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,C.ChatTaskResult.from(w),D)})}else this._proxy.$handleProgressChunk(this._request.requestId,f)};this._apiObject={markdown(f){i(this.markdown);const u=new b.ChatResponseMarkdownPart(f),v=C.ChatResponseMarkdownPart.from(u);return r(v),this},markdownWithVulnerabilities(f,u){i(this.markdown),u&&(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const v=new b.ChatResponseMarkdownWithVulnerabilitiesPart(f,u),y=C.ChatResponseMarkdownWithVulnerabilitiesPart.from(v);return r(y),this},filetree(f,u){i(this.filetree);const v=new b.ChatResponseFileTreePart(f,u),y=C.ChatResponseFilesPart.from(v);return r(y),this},anchor(f,u){i(this.anchor);const v=new b.ChatResponseAnchorPart(f,u),y=C.ChatResponseAnchorPart.from(v);return r(y),this},button(f){i(this.anchor);const u=new b.ChatResponseCommandButtonPart(f),v=C.ChatResponseCommandButtonPart.from(u,t._commandsConverter,t._sessionDisposables);return r(v),this},progress(f,u){i(this.progress);const v=new b.ChatResponseProgressPart2(f,u),y=u?C.ChatTask.from(v):C.ChatResponseProgressPart.from(v);return r(y,u),this},warning(f){i(this.progress),(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const u=new b.ChatResponseWarningPart(f),v=C.ChatResponseWarningPart.from(u);return r(v),this},reference(f,u){if(i(this.reference),"variableName"in f&&(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions"),"variableName"in f&&!f.value){const v=t._request.variables.variables.find(y=>y.name===f.variableName);if(v){let y;if(v.references?.length)y=v.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new b.ChatResponseReferencePart(f,u);y=[C.ChatResponseReferencePart.from(D)]}return y.forEach(D=>r(D)),this}}else{const v=new b.ChatResponseReferencePart(f,u),y=C.ChatResponseReferencePart.from(v);r(y)}return this},textEdit(f,u){i(this.textEdit),(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const v=new b.ChatResponseTextEditPart(f,u),y=C.ChatResponseTextEditPart.from(v);return r(y),this},detectedParticipant(f,u){i(this.detectedParticipant),(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const v=new b.ChatResponseDetectedParticipantPart(f,u),y=C.ChatResponseDetectedParticipantPart.from(v);return r(y),this},confirmation(f,u,v){i(this.confirmation),(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const y=new b.ChatResponseConfirmationPart(f,u,v),D=C.ChatResponseConfirmationPart.from(y);return r(D),this},push(f){if(i(this.push),(f instanceof b.ChatResponseTextEditPart||f instanceof b.ChatResponseMarkdownWithVulnerabilitiesPart||f instanceof b.ChatResponseDetectedParticipantPart||f instanceof b.ChatResponseWarningPart||f instanceof b.ChatResponseConfirmationPart)&&(0,m.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions"),f instanceof b.ChatResponseReferencePart)this.reference(f.value,f.iconPath);else{const u=C.ChatResponsePart.from(f,t._commandsConverter,t._sessionDisposables);r(u)}return this}}}return this._apiObject}}class g extends A.Disposable{static{this._idPool=0}constructor(t,i,r){super(),this._logService=i,this.commands=r,this._agents=new Map,this._sessionDisposables=this._register(new A.DisposableMap),this._completionDisposables=this._register(new A.DisposableMap),this._proxy=t.getProxy(c.MainContext.MainThreadChatAgents2)}transferActiveChat(t){this._proxy.$transferActiveChatSession(t)}createChatAgent(t,i,r){const f=g._idPool++,u=new n(t,i,this._proxy,f,r);return this._agents.set(f,u),this._proxy.$registerAgent(f,t.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(t,i,r,f){const u=g._idPool++,v=new n(t,i,this._proxy,u,f);return this._agents.set(u,v),this._proxy.$registerAgent(u,t.identifier,i,{isSticky:!0},r),v.apiAgent}async $invokeAgent(t,i,r,f){const u=this._agents.get(t);if(!u)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let v=this._sessionDisposables.get(i.sessionId);v||(v=new A.DisposableStore,this._sessionDisposables.set(i.sessionId,v));const y=new h(u.extension,i,this._proxy,this.commands.converter,v);try{const D=await this.prepareHistoryTurns(i.agentId,r),w=u.invoke(C.ChatAgentRequest.to(i),{history:D},y.apiObject,f);return await(0,d.raceCancellation)(Promise.resolve(w).then(P=>{if(P?.metadata)try{JSON.stringify(P.metadata)}catch(E){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this._logService.error(`[${u.extension.identifier.value}] [@${u.id}] ${S}`,u.extension),{errorDetails:{message:S},timings:y.timings}}let k;return P?.errorDetails&&(k={...P.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,m.checkProposedApiEnabled)(u.extension,"chatParticipantPrivate"),{errorDetails:k,timings:y.timings,metadata:P?.metadata}}),f)}catch(D){return this._logService.error(D,u.extension),D instanceof b.LanguageModelError&&D.cause&&(D=D.cause),{errorDetails:{message:(0,T.toErrorMessage)(D),responseIsIncomplete:!0}}}finally{y.close()}}async prepareHistoryTurns(t,i){const r=[];for(const f of i.history){const u=C.ChatAgentResult.to(f.result),v=t===f.request.agentId?u:{...u,metadata:void 0};r.push(new b.ChatRequestTurn(f.request.message,f.request.command,f.request.variables.variables.map(C.ChatAgentValueReference.to),f.request.agentId));const y=(0,s.coalesce)(f.response.map(D=>C.ChatResponsePart.toContent(D,this.commands.converter)));r.push(new b.ChatResponseTurn(y,v,f.request.agentId,f.request.command))}return r}$releaseSession(t){this._sessionDisposables.deleteAndDispose(t)}async $provideFollowups(t,i,r,f,u){const v=this._agents.get(i);if(!v)return Promise.resolve([]);const y=await this.prepareHistoryTurns(v.id,f),D=C.ChatAgentResult.to(r);return(await v.provideFollowups(D,{history:y},u)).filter(w=>{const P=!w.participant||L.Iterable.some(this._agents.values(),k=>k.id===w.participant&&_.ExtensionIdentifier.equals(k.extension.identifier,v.extension.identifier));return P||this._logService.warn(`[@${v.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),P}).map(w=>C.ChatFollowup.from(w,t))}$acceptFeedback(t,i,r,f){const u=this._agents.get(t);if(!u)return;const v=C.ChatAgentResult.to(i);let y;switch(r){case l.ChatAgentVoteDirection.Down:y=b.ChatResultFeedbackKind.Unhelpful;break;case l.ChatAgentVoteDirection.Up:y=b.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:v,kind:y,reportIssue:f}:{result:v,kind:y}))}$acceptAction(t,i,r){const f=this._agents.get(t);if(!f||r.action.kind==="vote")return;const u=C.ChatAgentUserActionEvent.to(i,r,this.commands.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(t,i,r){const f=this._agents.get(t);if(!f)return[];let u=this._completionDisposables.get(t);return u?u.clear():(u=new A.DisposableStore,this._completionDisposables.set(t,u)),(await f.invokeCompletionProvider(i,r)).map(y=>C.ChatAgentCompletionItem.from(y,this.commands.converter,u))}async $provideWelcomeMessage(t,i,r){const f=this._agents.get(t);if(f)return await f.provideWelcomeMessage(C.ChatLocation.to(i),r)}async $provideSampleQuestions(t,i,r){const f=this._agents.get(t);if(f)return(await f.provideSampleQuestions(C.ChatLocation.to(i),r)).map(u=>C.ChatFollowup.from(u,void 0))}}e.ExtHostChatAgents2=g;class n{constructor(t,i,r,f,u){this.extension=t,this.id=i,this._proxy=r,this._handle=f,this._requestHandler=u,this._onDidReceiveFeedback=new R.Emitter,this._onDidPerformAction=new R.Emitter}acceptFeedback(t){this._onDidReceiveFeedback.fire(t)}acceptAction(t){this._onDidPerformAction.fire(t)}async invokeCompletionProvider(t,i){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(t,i)??[]:[]}async provideFollowups(t,i,r){if(!this._followupProvider)return[];const f=await this._followupProvider.provideFollowups(t,i,r);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(t,i){if(!this._welcomeMessageProvider)return[];const r=await this._welcomeMessageProvider.provideWelcomeMessage(t,i);return r?r.map(f=>typeof f=="string"?f:C.MarkdownString.from(f)):[]}async provideSampleQuestions(t,i){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const r=await this._welcomeMessageProvider.provideSampleQuestions(t,i);return r||[]}get apiAgent(){let t=!1,i=!1;const r=()=>{t||i||(i=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof I.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof b.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:C.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:C.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:C.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),i=!1}))},f=this;return{get id(){return f.id},get iconPath(){return f._iconPath},set iconPath(u){f._iconPath=u,r()},get requestHandler(){return f._requestHandler},set requestHandler(u){(0,a.assertType)(typeof u=="function","Invalid request handler"),f._requestHandler=u},get followupProvider(){return f._followupProvider},set followupProvider(u){f._followupProvider=u,r()},get isDefault(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isDefault},set isDefault(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isDefault=u,r()},get helpTextPrefix(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPrefix},set helpTextPrefix(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPrefix=u,r()},get helpTextVariablesPrefix(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextVariablesPrefix},set helpTextVariablesPrefix(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextVariablesPrefix=u,r()},get helpTextPostfix(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPostfix},set helpTextPostfix(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._helpTextPostfix=u,r()},get isSecondary(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isSecondary},set isSecondary(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._isSecondary=u,r()},get supportIssueReporting(){return(0,m.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportIssueReporting},set supportIssueReporting(u){(0,m.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportIssueReporting=u,r()},get onDidReceiveFeedback(){return f._onDidReceiveFeedback.event},set participantVariableProvider(u){if((0,m.checkProposedApiEnabled)(f.extension,"chatParticipantAdditions"),f._agentVariableProvider=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f._proxy.$registerAgentCompletionsProvider(f._handle,f.id,u.triggerCharacters)}else f._proxy.$unregisterAgentCompletionsProvider(f._handle,f.id)},get participantVariableProvider(){return(0,m.checkProposedApiEnabled)(f.extension,"chatParticipantAdditions"),f._agentVariableProvider},set welcomeMessageProvider(u){(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._welcomeMessageProvider=u,r()},get welcomeMessageProvider(){return(0,m.checkProposedApiEnabled)(f.extension,"defaultChatParticipant"),f._welcomeMessageProvider},onDidPerformAction:(0,m.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(u){f._requester=u,r()},get requester(){return f._requester},set supportsSlowReferences(u){(0,m.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportsSlowReferences=u,r()},get supportsSlowReferences(){return(0,m.checkProposedApiEnabled)(f.extension,"chatParticipantPrivate"),f._supportsSlowReferences},dispose(){t=!0,f._followupProvider=void 0,f._onDidReceiveFeedback.dispose(),f._proxy.$unregisterAgent(f._handle)}}}invoke(t,i,r,f){return this._requestHandler(t,i,r,f)}}}),define(_e[347],ye([1,0,14,3,50,6,16,10,26]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,L=ze(L),A=ze(A);class a{static{this._idPool=0}constructor(c){this._resolver=new Map,this._proxy=c.getProxy(R.MainContext.MainThreadChatVariables)}async $resolveVariable(c,C,b,l){const m=this._resolver.get(c);if(m)try{if(m.resolver.resolve2){(0,p.checkProposedApiEnabled)(m.extension,"chatParticipantAdditions");const h=new I(C,this._proxy),g=await m.resolver.resolve2(m.data.name,{prompt:b},h.apiObject,l);if(g&&g[0])return g[0].value}else{const h=await m.resolver.resolve(m.data.name,{prompt:b},l);if(h&&h[0])return h[0].value}}catch(h){(0,s.onUnexpectedExternalError)(h)}}registerVariableResolver(c,C,b,l,m,h,g,n,o){const t=a._idPool++,i=o?T.ThemeIcon.fromId(o):void 0;return this._resolver.set(t,{extension:c,data:{id:C,name:b,description:l,modelDescription:m,icon:i},resolver:g}),this._proxy.$registerVariable(t,{id:C,name:b,description:l,modelDescription:m,isSlow:h,fullName:n,icon:i}),(0,d.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=a;class I{constructor(c,C){this._requestId=c,this._proxy=C,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let C=function(l){if(c._isClosed){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,l),m}};const c=this,b=l=>{this._proxy.$handleProgressChunk(this._requestId,l)};this._apiObject={progress(l){C(this.progress);const m=new A.ChatResponseProgressPart(l),h=L.ChatResponseProgressPart.from(m);return b(h),this},reference(l){C(this.reference);const m=new A.ChatResponseReferencePart(l),h=L.ChatResponseReferencePart.from(m);return b(h),this},push(l){return C(this.push),l instanceof A.ChatResponseReferencePart?b(L.ChatResponseReferencePart.from(l)):l instanceof A.ChatResponseProgressPart&&b(L.ChatResponseProgressPart.from(l)),this}}}return this._apiObject}}}),define(_e[348],ye([1,0,9,59,4,3,41,2,88,24,16,10,6,26]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=b,p=ze(p),I=ze(I),_=ze(_);function b(l,m,h){const g=l.getProxy(c.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new a.ExtensionIdentifierMap,m.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===L.MarshalledId.CommentController){const P=this._commentControllers.get(w.handle);return P?P.value:w}else if(w&&w.$mid===L.MarshalledId.CommentThread){const P=w,k=this._commentControllers.get(P.commentControlHandle);if(!k)return P;const E=k.getCommentThread(P.commentThreadHandle);return E?E.value:P}else if(w&&(w.$mid===L.MarshalledId.CommentThreadReply||w.$mid===L.MarshalledId.CommentThreadInstance)){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const k=P.getCommentThread(w.thread.commentThreadHandle);return k?w.$mid===L.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:w.text}:w}else if(w&&w.$mid===L.MarshalledId.CommentNode){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const k=P.getCommentThread(w.thread.commentThreadHandle);if(!k)return w;const E=w.commentUniqueId,S=k.getCommentByUniqueId(E);return S||w}else if(w&&w.$mid===L.MarshalledId.CommentThreadNode){const P=this._commentControllers.get(w.thread.commentControlHandle);if(!P)return w;const k=P.getCommentThread(w.thread.commentThreadHandle);if(!k)return w;const E=w.text,S=w.commentUniqueId,M=k.getCommentByUniqueId(S);return M?(typeof M.body=="string"?M.body=E:M.body=new _.MarkdownString(E),M):w}return w}})}createCommentController(w,P,k){const E=n.handlePool++,S=new t(w,E,P,k);this._commentControllers.set(S.handle,S);const M=this._commentControllersByExtension.get(w.identifier)||[];return M.push(S),this._commentControllersByExtension.set(w.identifier,M),S.value}async $createCommentThreadTemplate(w,P,k,E){const S=this._commentControllers.get(w);S&&S.$createCommentThreadTemplate(P,k,E)}async $setActiveComment(w,P){const k=this._commentControllers.get(w);k&&k.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(w,P,k){const E=this._commentControllers.get(w);E&&E.$updateCommentThreadTemplate(P,k)}$deleteCommentThread(w,P){this._commentControllers.get(w)?.$deleteCommentThread(P)}async $provideCommentingRanges(w,P,k){const E=this._commentControllers.get(w);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const S=await h.ensureDocumentData(A.URI.revive(P));return(0,s.asPromise)(async()=>{const M=await E.commentingRangeProvider.provideCommentingRanges(S.document,k);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(O=>I.Range.from(O)),fileComments:M.fileComments}),N})}$toggleReaction(w,P,k,E,S){const M=this._commentControllers.get(w);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const N=M.getCommentThread(P);if(N){const O=N.getCommentByUniqueId(E.uniqueIdInThread);if(M!==void 0&&O&&M.reactionHandler)return M.reactionHandler(O,f(S))}return Promise.resolve(void 0)})}}class o{static{this._handlePool=0}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){(w===void 0!=(this._range===void 0)||!w||!this._range||!w.isEqual(this._range))&&(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(w){this._state=w,typeof w=="object"?((0,C.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=w.resolved,this.modifications.applicability=w.applicability):this.modifications.state=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(w,P,k,E,S,M,N,O,x){this._commentControllerHandle=P,this._id=k,this._uri=E,this._range=S,this._comments=M,this.extensionDescription=N,this._isTemplate=O,this.handle=o._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),g.$createCommentThread(P,this.handle,this._id,this._uri,I.Range.from(this._range),this._comments.map(F=>i(this,F,this._commentsMap,this.extensionDescription)),N.identifier,this._isTemplate,x),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(P,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(F){U.range=F},get comments(){return U.comments},set comments(F){U.comments=F},get collapsibleState(){return U.collapsibleState},set collapsibleState(F){U.collapsibleState=F},get canReply(){return U.canReply},set canReply(F){U.canReply=F},get contextValue(){return U.contextValue},set contextValue(F){U.contextValue=F},get label(){return U.label},set label(F){U.label=F},get state(){return U.state},set state(F){U.state=F},reveal:F=>U.reveal(F),dispose:()=>{U.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const w=k=>Object.prototype.hasOwnProperty.call(this.modifications,k),P={};w("range")&&(P.range=I.Range.from(this._range)),w("label")&&(P.label=this.label),w("contextValue")&&(P.contextValue=this.contextValue??null),w("comments")&&(P.comments=this._comments.map(k=>i(this,k,this._commentsMap,this.extensionDescription))),w("collapsibleState")&&(P.collapseState=u(this._collapseState)),w("canReply")&&(P.canReply=this.canReply),w("state")&&(P.state=v(this._state)),w("applicability")&&(P.applicability=y(this._state)),w("isTemplate")&&(P.isTemplate=this._isTemplate),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,P)}getCommentByUniqueId(w){for(const P of this._commentsMap){const k=P[0],E=P[1];if(w===E)return k}}async reveal(w){return(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentReveal"),g.$revealCommentThread(this._commentControllerHandle,this.handle,{preserveFocus:!1,focusReply:!1,...w})}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}Xe([(0,d.debounce)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,w?.resourceHints&&(0,C.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),g.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,C.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(w,P,k,E){this._extension=w,this._handle=P,this._id=k,this._label=E,this._threads=new Map,g.$registerCommentController(this.handle,k,E,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(M){S.options=M},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(M){S.commentingRangeProvider=M},get reactionHandler(){return S.reactionHandler},set reactionHandler(M){S.reactionHandler=M},get activeCommentThread(){return S.activeCommentThread},createCommentThread(M,N,O){return S.createCommentThread(M,N,O).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(w,P,k){P===void 0&&(0,C.checkProposedApiEnabled)(this._extension,"fileComments");const E=new o(this.id,this.handle,void 0,w,P,k,this._extension,!1);return this._threads.set(E.handle,E),E}$setActiveComment(w){if(!w){this._activeComment=void 0,this._activeThread=void 0;return}const P=this._threads.get(w.commentThreadHandle);P&&(this._activeComment=w.uniqueIdInThread?P.getCommentByUniqueId(w.uniqueIdInThread):void 0,this._activeThread=P)}$createCommentThreadTemplate(w,P,k){const E=new o(this.id,this.handle,void 0,A.URI.revive(w),I.Range.to(P),[],this._extension,!0,k);return E.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this._threads.set(E.handle,E),E}$updateCommentThreadTemplate(w,P){const k=this._threads.get(w);k&&(k.range=I.Range.to(P))}$deleteCommentThread(w){this._threads.get(w)?.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function i(D,w,P,k){let E=P.get(w);return E||(E=++D.commentHandle,P.set(w,E)),w.state!==void 0&&(0,C.checkProposedApiEnabled)(k,"commentsDraftState"),w.reactions?.some(S=>S.reactors!==void 0)&&(0,C.checkProposedApiEnabled)(k,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:E,body:typeof w.body=="string"?w.body:I.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(S=>r(S)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function r(D){return{label:D.label,iconPath:D.iconPath?I.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(w=>w.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?A.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(w=>({name:w}))}}function u(D){if(D!==void 0)switch(D){case _.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case _.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function v(D){let w;if(typeof D=="object"?w=D.resolved:w=D,w!==void 0)switch(w){case _.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case _.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function y(D){let w;if(typeof D=="object"&&(w=D.applicability),w!==void 0)switch(w){case _.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case _.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(_e[349],ye([1,0,21,60,3,15,23,2,16,97,119,6,10]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,p=ze(p),_=ze(_),c=ze(c);class C{constructor(r,f){this.document=r,this._storagePath=f,this._backupCounter=1,this._edits=new I.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,f){await this.getEdit(r).undo(),f||this.disposeBackup()}async redo(r,f){await this.getEdit(r).redo(),f||this.disposeBackup()}disposeEdits(r){for(const f of r)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=t(this.document.uri)+this._backupCounter++;return(0,L.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const f=this._edits.get(r,0);if(!f)throw new Error("No edit found");return f}}class b{constructor(){this._documents=new Map}get(r,f){return this._documents.get(this.key(r,f))}add(r,f,u){const v=this.key(r,f.uri);if(this._documents.has(v))throw new Error(`Document already exists for viewType:${r} resource:${f.uri}`);const y=new C(f,u);return this._documents.set(v,y),y}delete(r,f){const u=this.key(r,f.uri);this._documents.delete(u)}key(r,f){return`${r}@@@${f}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class m{constructor(){this._providers=new Map}addTextProvider(r,f,u){return this.add(r,{type:l.Text,extension:f,provider:u})}addCustomProvider(r,f,u){return this.add(r,{type:l.Custom,extension:f,provider:u})}get(r){return this._providers.get(r)}add(r,f){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,f),new c.Disposable(()=>this._providers.delete(r))}}class h{constructor(r,f,u,v,y){this._extHostDocuments=f,this._extensionStoragePaths=u,this._extHostWebview=v,this._extHostWebviewPanels=y,this._editorProviders=new m,this._documents=new b,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,f,u,v){const y=new T.DisposableStore;return n(u)?(y.add(this._editorProviders.addTextProvider(f,r,u)),this._proxy.$registerTextEditorProvider((0,a.toExtensionData)(r),f,v.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,a.shouldSerializeBuffersForPostMessage)(r))):(y.add(this._editorProviders.addCustomProvider(f,r,u)),g(u)&&y.add(u.onDidChangeCustomDocument(D=>{const w=this.getCustomDocumentEntry(f,D.document.uri);if(o(D)){const P=w.addEdit(D);this._proxy.$onDidEdit(D.document.uri,f,P,D.label)}else this._proxy.$onContentChange(D.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,a.toExtensionData)(r),f,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,a.shouldSerializeBuffersForPostMessage)(r))),c.Disposable.from(y,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(r,f,u,v,y){const D=this._editorProviders.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==l.Custom)throw new Error(`Invalid provide type for '${f}'`);const w=A.URI.revive(r),P=await D.provider.openCustomDocument(w,{backupId:u,untitledDocumentData:v?.buffer},y);let k;return g(D.provider)&&this._extensionStoragePaths&&(k=this._extensionStoragePaths.workspaceValue(D.extension)??this._extensionStoragePaths.globalValue(D.extension)),this._documents.add(f,P,k),{editable:g(D.provider)}}async $disposeCustomDocument(r,f){const u=this._editorProviders.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==l.Custom)throw new Error(`Invalid provider type for '${f}'`);const v=A.URI.revive(r),{document:y}=this.getCustomDocumentEntry(f,v);this._documents.delete(f,y),y.dispose()}async $resolveCustomEditor(r,f,u,v,y,D){const w=this._editorProviders.get(u);if(!w)throw new Error(`No provider found for '${u}'`);const P=p.ViewColumn.to(y),k=this._extHostWebview.createNewWebview(f,v.contentOptions,w.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(f,u,v.title,P,v.options,k,v.active),S=A.URI.revive(r);switch(w.type){case l.Custom:{const{document:M}=this.getCustomDocumentEntry(u,S);return w.provider.resolveCustomEditor(M,E,D)}case l.Text:{const M=this._extHostDocuments.getDocument(S);return w.provider.resolveCustomTextEditor(M,E,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,f,u){this.getCustomDocumentEntry(f,r).disposeEdits(u)}async $onMoveCustomEditor(r,f,u){const v=this._editorProviders.get(u);if(!v)throw new Error(`No provider found for '${u}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const y=this._extHostWebviewPanels.getWebviewPanel(r);if(!y)throw new Error("No webview found");const D=A.URI.revive(f),w=this._extHostDocuments.getDocument(D);await v.provider.moveCustomTextEditor(w,y,s.CancellationToken.None)}async $undo(r,f,u,v){return this.getCustomDocumentEntry(f,r).undo(u,v)}async $redo(r,f,u,v){return this.getCustomDocumentEntry(f,r).redo(u,v)}async $revert(r,f,u){const v=this.getCustomDocumentEntry(f,r);await this.getCustomEditorProvider(f).revertCustomDocument(v.document,u),v.disposeBackup()}async $onSave(r,f,u){const v=this.getCustomDocumentEntry(f,r);await this.getCustomEditorProvider(f).saveCustomDocument(v.document,u),v.disposeBackup()}async $onSaveAs(r,f,u,v){const y=this.getCustomDocumentEntry(f,r);return this.getCustomEditorProvider(f).saveCustomDocumentAs(y.document,A.URI.revive(u),v)}async $backup(r,f,u){const v=this.getCustomDocumentEntry(f,r),D=await this.getCustomEditorProvider(f).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},u);return v.updateBackup(D),D.id}getCustomDocumentEntry(r,f){const u=this._documents.get(r,A.URI.revive(f));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(r){const u=this._editorProviders.get(r)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function g(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function o(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function t(i){const r=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,d.hash)(r)+""}}),define(_e[350],ye([1,0,234,146,2,6,10,16,4,12,29,63]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,A=ze(A);class C{#e;#t;#i;constructor(m,h,g,n,o,t,i,r){this._name=m,this._owner=h,this._maxDiagnosticsTotal=g,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=o,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,g),this.#i=new I.ResourceMap(f=>t.getComparisonKey(f)),this.#e=i,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,h){if(!m){this.clear();return}this._checkDisposed();let g=[];if(T.URI.isUri(m)){if(!h){this.delete(m);return}this.#i.set(m,h.slice()),g=[m]}else if(Array.isArray(m)){g=[];let t;m=[...m].sort(C._compareIndexedTuplesByUri);for(const i of m){const[r,f]=i;if((!t||r.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=r,g.push(r),this.#i.set(r,[])),f)this.#i.get(r)?.push(...f);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(g),!this.#e)return;const n=[];let o=0;for(const t of g){let i=[];const r=this.#i.get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){i=[];const f=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const v of r)if(v.severity===f[u]&&i.push({...A.Diagnostic.from(v),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;i.push({severity:d.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(f=>({...A.Diagnostic.from(f),modelVersionId:this._modelVersionIdProvider(t)}));if(n.push([t,i]),o+=i.length,o>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(m){this._checkDisposed(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(m,h){this._checkDisposed();for(const[g,n]of this)m.call(h,g,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const h=this.#i.get(m);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this.#i.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,h){return m[0].toString()<h[0].toString()?-1:m[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=C;let b=class{static{c=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*c._maxDiagnosticsPerFile}static _mapper(m){const h=new I.ResourceMap;for(const g of m)h.set(g,g);return{uris:Object.freeze(Array.from(h.values()))}}constructor(m,h,g,n){this._logService=h,this._fileSystemInfoService=g,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new p.DebounceEmitter({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this._onDidChangeDiagnostics.event,c._mapper),this._proxy=m.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,h){const{_collections:g,_proxy:n,_onDidChangeDiagnostics:o,_logService:t,_fileSystemInfoService:i,_extHostDocumentsAndEditors:r}=this,f=new class{$changeMany(y,D){n.$changeMany(y,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,y,D.length===0?"CLEARING":D)}$clear(y){n.$clear(y),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,y)}dispose(){n.dispose()}};let u;if(!h)h="_generated_diagnostic_collection_name_#"+c._idPool++,u=h;else if(!g.has(h))u=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do u=h+c._idPool++;while(g.has(u))}return new class extends C{constructor(){super(h,u,c._maxDiagnosticsTotal,c._maxDiagnosticsPerFile,y=>r.getDocument(y)?.version,i.extUri,f,o),g.set(u,this)}dispose(){super.dispose(),g.delete(u)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const h=new Map,g=[];for(const n of this._collections.values())n.forEach((o,t)=>{let i=h.get(o.toString());typeof i>"u"&&(i=g.length,h.set(o.toString(),i),g.push([o,[]])),g[i][1]=g[i][1].concat(...t)});return g}}_getDiagnostics(m){let h=[];for(const g of this._collections.values())g.has(m)&&(h=h.concat(g.get(m)));return h}$acceptMarkersChange(m){if(!this._mirrorCollection){const h="_generated_mirror",g=new C(h,h,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,g),this._mirrorCollection=g}for(const[h,g]of m)this._mirrorCollection.set(T.URI.revive(h),g.map(A.Diagnostic.to))}};e.ExtHostDiagnostics=b,e.ExtHostDiagnostics=b=c=Xe([He(1,a.ILogService),He(2,_.IExtHostFileSystemInfo)],b)}),define(_e[351],ye([1,0,2,14,10,16,81,52]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class p{constructor(I,_,c,C={timeout:1500,errors:3}){this._logService=I,this._documents=_,this._mainThreadBulkEdits=c,this._thresholds=C,this._callbacks=new L.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(_,c,C)=>{const l={dispose:this._callbacks.push([_,c,I])};return Array.isArray(C)&&C.push(l),l}}async $participateInSave(I,_){const c=s.URI.revive(I);let C=!1;const b=setTimeout(()=>C=!0,this._thresholds.timeout),l=[];try{for(const m of[...this._callbacks]){if(C)break;const h=this._documents.getDocument(c),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:h,reason:R.TextDocumentSaveReason.to(_)});l.push(g)}}finally{clearTimeout(b)}return l}_deliverEventAsyncAndBlameBadListeners([I,_,c],C){const b=this._badListeners.get(I);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(c,I,_,C).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const m=this._badListeners.get(I);this._badListeners.set(I,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,_,c,C){const b=[],l=Date.now(),{document:m,reason:h}=C,{version:g}=m,n=Object.freeze({document:m,reason:h,waitUntil(o){if(Object.isFrozen(b))throw(0,d.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{_.apply(c,[n])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,t)=>{const i=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(i),o(r)}).catch(r=>{clearTimeout(i),t(r)})}).then(o=>{const t={edits:[]};for(const i of o)if(Array.isArray(i)&&i.every(r=>r instanceof T.TextEdit))for(const{newText:r,newEol:f,range:u}of i)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:u&&R.Range.from(u),text:r,eol:f&&R.EndOfLine.from(f)}});if(t.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=p}),define(_e[352],ye([1,0,4,3,2,6,164,16,18,25,10]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,A=ze(A);class _{constructor(C,b){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new d.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=b,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const m of l)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const m of l)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const b=this._documentsAndEditors.getDocument(C);if(b)return b}getDocument(C){const b=this.getDocumentData(C);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return b.document}ensureDocumentData(C){const b=this._documentsAndEditors.getDocument(C);if(b)return Promise.resolve(b);let l=this._documentLoader.get(C.toString());return l||(l=this._proxy.$tryOpenDocument(C).then(m=>{this._documentLoader.delete(C.toString());const h=T.URI.revive(m);return(0,p.assertIsDefined)(this._documentsAndEditors.getDocument(h))},m=>(this._documentLoader.delete(C.toString()),Promise.reject(m))),this._documentLoader.set(C.toString(),l)),l}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(b=>T.URI.revive(b))}$acceptModelLanguageChanged(C,b){const l=T.URI.revive(C),m=this._documentsAndEditors.getDocument(l);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(b),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(C){const b=T.URI.revive(C),l=this._documentsAndEditors.getDocument(b);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(C,b){const l=T.URI.revive(C),m=this._documentsAndEditors.getDocument(l);if(!m)throw new Error("unknown document");m._acceptIsDirty(b),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,b,l){const m=T.URI.revive(C),h=this._documentsAndEditors.getDocument(m);if(!h)throw new Error("unknown document");h._acceptIsDirty(l),h.onEvents(b);let g;b.isUndoing?g=I.TextDocumentChangeReason.Undo:b.isRedoing&&(g=I.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,a.deepFreeze)({document:h.document,contentChanges:b.changes.map(n=>({range:A.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:g}))}setWordDefinitionFor(C,b){(0,L.setWordDefinitionFor)(C,b)}}e.ExtHostDocuments=_}),define(_e[78],ye([1,0,79,4,18,2,5,6,20,16,10]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,a=ze(a),e.IExtHostEditorTabs=(0,L.createDecorator)("IExtHostEditorTabs");class _{constructor(m,h,g){this._activeTabIdGetter=g,this._parentGroup=h,this.acceptDtoUpdate(m)}get apiObject(){if(!this._apiObject){const m=this,h={get isActive(){return m._dto.id===m._activeTabIdGetter()},get label(){return m._dto.label},get input(){return m._input},get isDirty(){return m._dto.isDirty},get isPinned(){return m._dto.isPinned},get isPreview(){return m._dto.isPreview},get group(){return m._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(m){this._dto=m,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case A.TabInputKind.TextInput:return new I.TextTabInput(R.URI.revive(this._dto.input.uri));case A.TabInputKind.TextDiffInput:return new I.TextDiffTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified));case A.TabInputKind.TextMergeInput:return new I.TextMergeTabInput(R.URI.revive(this._dto.input.base),R.URI.revive(this._dto.input.input1),R.URI.revive(this._dto.input.input2),R.URI.revive(this._dto.input.result));case A.TabInputKind.CustomEditorInput:return new I.CustomEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.viewType);case A.TabInputKind.WebviewEditorInput:return new I.WebviewEditorTabInput(this._dto.input.viewType);case A.TabInputKind.NotebookInput:return new I.NotebookEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case A.TabInputKind.NotebookDiffInput:return new I.NotebookDiffEditorTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case A.TabInputKind.TerminalEditorInput:return new I.TerminalEditorTabInput;case A.TabInputKind.InteractiveEditorInput:return new I.InteractiveWindowInput(R.URI.revive(this._dto.input.uri),R.URI.revive(this._dto.input.inputBoxUri));case A.TabInputKind.ChatEditorInput:return new I.ChatEditorTabInput;case A.TabInputKind.MultiDiffEditorInput:return new I.TextMultiDiffTabInput(this._dto.input.diffEditors.map(m=>new I.TextDiffTabInput(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class c{constructor(m,h){this._tabs=[],this._activeTabId="",this._dto=m,this._activeGroupIdGetter=h;for(const g of m.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new _(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const m=this,h={get isActive(){return m._dto.groupId===m._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(m._dto.viewColumn)},get activeTab(){return m._tabs.find(g=>g.tabId===m._activeTabId)?.apiObject},get tabs(){return Object.freeze(m._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(m){this._dto=m}acceptTabOperation(m){if(m.kind===A.TabModelOperationKind.TAB_OPEN){const g=new _(m.tabDto,this,()=>this.activeTabId());return this._tabs.splice(m.index,0,g),m.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(m.kind===A.TabModelOperationKind.TAB_CLOSE){const g=this._tabs.splice(m.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(m.kind===A.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(m.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this._tabs.splice(m.index,0,g),g}const h=this._tabs.find(g=>g.tabId===m.tabDto.id);if(!h)throw new Error("INVALID tab");return m.tabDto.isActive?this._activeTabId=m.tabDto.id:this._activeTabId===m.tabDto.id&&!m.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(m.tabDto),h}activeTabId(){return this._activeTabId}}let C=class{constructor(m){this._onDidChangeTabs=new d.Emitter,this._onDidChangeTabGroups=new d.Emitter,this._extHostTabGroups=[],this._proxy=m.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const m=this,h={onDidChangeTabGroups:m._onDidChangeTabGroups.event,onDidChangeTabs:m._onDidChangeTabs.event,get all(){return Object.freeze(m._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=m._activeGroupId;return(0,T.assertIsDefined)(m._extHostTabGroups.find(o=>o.groupId===g)?.apiObject)},close:async(g,n)=>{const o=Array.isArray(g)?g:[g];return o.length?b(o[0])?this._closeGroups(o,n):this._closeTabs(o,n):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(m){const h=new Set(this._extHostTabGroups.map(f=>f.groupId)),g=new Set(m.map(f=>f.groupId)),n=(0,s.diffSets)(h,g),o=this._extHostTabGroups.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),t=[],i=[];this._extHostTabGroups=m.map(f=>{const u=new c(f,()=>this._activeGroupId);return n.added.includes(u.groupId)?t.push(u.apiObject):i.push(u.apiObject),u});const r=(0,T.assertIsDefined)(m.find(f=>f.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:o,changed:i}))}$acceptTabGroupUpdate(m){const h=this._extHostTabGroups.find(g=>g.groupId===m.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(m),m.isActive&&(this._activeGroupId=m.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const h=this._extHostTabGroups.find(n=>n.groupId===m.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const g=h.acceptTabOperation(m);switch(m.kind){case A.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case A.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case A.TabModelOperationKind.TAB_MOVE:case A.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(m){for(const h of this._extHostTabGroups)for(const g of h.tabs)if(g.apiObject===m)return g}_findExtHostTabGroupFromApi(m){return this._extHostTabGroups.find(h=>h.apiObject===m)}async _closeTabs(m,h){const g=[];for(const n of m){const o=this._findExtHostTabFromApi(n);if(!o)throw new Error("Tab close: Invalid tab not found!");g.push(o.tabId)}return this._proxy.$closeTab(g,h)}async _closeGroups(m,h){const g=[];for(const n of m){const o=this._findExtHostTabGroupFromApi(n);if(!o)throw new Error("Group close: Invalid group not found!");g.push(o.groupId)}return this._proxy.$closeGroup(g,h)}};e.ExtHostEditorTabs=C,e.ExtHostEditorTabs=C=Xe([He(0,p.IExtHostRpcService)],C);function b(l){return l.tabs!==void 0}}),define(_e[353],ye([1,0,2,6,28,3,10,16,195,13,27,22,26,86]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,T=ze(T),A=ze(A);class b{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const g=this._schemes.indexOf(h);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),g=[];let n,o,t=p.State.LastKnownState,i=p.State.LastKnownState;for(const r of h){let f=n?(0,a.commonPrefixLength)(n,r):0;for(f===0?o=p.State.Start:o=i;f<r.length;f++)f+1===r.length?(t=i,i=p.State.BeforeColon):i+=1,g.push([o,r.toUpperCase().charCodeAt(f),i]),g.push([o,r.toLowerCase().charCodeAt(f),i]),o=i;n=r,i=t}g.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),g.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this._stateMachine=new p.StateMachine(g)}}provideDocumentLinks(h){this._initStateMachine();const g=[],n=p.LinkComputer.computeLinks({getLineContent(o){return h.lineAt(o-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const o of n){const t=A.DocumentLink.to(o);t.target&&g.push(t)}return g}}class l{constructor(h,g){this._extHostLanguageFeatures=g,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(d.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(h,g,n,o={}){if(l._validateFileSystemProvider(n),this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(h,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(t,n);let i=T.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(i+=T.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(i+=T.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(i+=T.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,c.checkProposedApiEnabled)(h,"fsChunks"),i+=T.FileSystemProviderCapabilities.FileOpenReadWriteClose);let r;o.isReadonly&&(0,C.isMarkdownString)(o.isReadonly)&&o.isReadonly.value!==""&&(r={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,g,i,r).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${g}`),console.error(u)});const f=n.onDidChangeFile(u=>{const v=[];for(const y of u){const{uri:D,type:w}=y;if(D.scheme!==g)continue;let P;switch(w){case L.FileChangeType.Changed:P=T.FileChangeType.UPDATED;break;case L.FileChangeType.Created:P=T.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:P=T.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:D,type:P})}this._proxy.$onFileSystemChange(t,v)});return(0,R.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(h){const{type:g,ctime:n,mtime:o,size:t,permissions:i}=h;return{type:g,ctime:n,mtime:o,size:t,permissions:i}}$stat(h,g){return Promise.resolve(this._getFsProvider(h).stat(s.URI.revive(g))).then(n=>l._asIStat(n))}$readdir(h,g){return Promise.resolve(this._getFsProvider(h).readDirectory(s.URI.revive(g)))}$readFile(h,g){return Promise.resolve(this._getFsProvider(h).readFile(s.URI.revive(g))).then(n=>_.VSBuffer.wrap(n))}$writeFile(h,g,n,o){return Promise.resolve(this._getFsProvider(h).writeFile(s.URI.revive(g),n.buffer,o))}$delete(h,g,n){return Promise.resolve(this._getFsProvider(h).delete(s.URI.revive(g),n))}$rename(h,g,n,o){return Promise.resolve(this._getFsProvider(h).rename(s.URI.revive(g),s.URI.revive(n),o))}$copy(h,g,n,o){const t=this._getFsProvider(h);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(s.URI.revive(g),s.URI.revive(n),o))}$mkdir(h,g){return Promise.resolve(this._getFsProvider(h).createDirectory(s.URI.revive(g)))}$watch(h,g,n,o){const t=this._getFsProvider(h).watch(s.URI.revive(n),o);this._watches.set(g,t)}$unwatch(h,g){const n=this._watches.get(g);n&&(n.dispose(),this._watches.delete(g))}$open(h,g,n){const o=this._getFsProvider(h);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(s.URI.revive(g),n))}$close(h,g){const n=this._getFsProvider(h);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(g))}$read(h,g,n,o){const t=this._getFsProvider(h);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const i=_.VSBuffer.alloc(o);return Promise.resolve(t.read(g,n,i.buffer,0,o)).then(r=>i.slice(0,r))}$write(h,g,n,o){const t=this._getFsProvider(h);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(g,n,o.buffer,0,o.byteLength))}_getFsProvider(h){const g=this._fsProvider.get(h);if(!g){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return g}}e.ExtHostFileSystem=l}),define(_e[354],ye([1,0,4,39,2,6,16,10,28,49]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,L=ze(L);class I{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(b,l,m,h,g,n){this.session=Math.random(),this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const o=(0,d.parse)(g),t=typeof g=="string",i=n?.correlate,r=h(f=>{if(!(typeof f.session=="number"&&f.session!==this.session)&&!(i&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const u of f.created){const v=T.URI.revive(u);o(v.fsPath)&&(!t||l.getWorkspaceFolder(v))&&this._onDidCreate.fire(v)}if(!n?.ignoreChangeEvents)for(const u of f.changed){const v=T.URI.revive(u);o(v.fsPath)&&(!t||l.getWorkspaceFolder(v))&&this._onDidChange.fire(v)}if(!n?.ignoreDeleteEvents)for(const u of f.deleted){const v=T.URI.revive(u);o(v.fsPath)&&(!t||l.getWorkspaceFolder(v))&&this._onDidDelete.fire(v)}}});this._disposable=A.Disposable.from(this.ensureWatching(b,m,g,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(b,l,m,h,g){const n=A.Disposable.from();if(typeof m=="string"||h?.ignoreChangeEvents&&h?.ignoreCreateEvents&&h?.ignoreDeleteEvents)return n;const o=b.getProxy(R.MainContext.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(d.GLOBSTAR)||m.pattern.includes(d.GLOB_SPLIT))&&(t=!0);let i;return g&&(h?.ignoreChangeEvents||h?.ignoreCreateEvents||h?.ignoreDeleteEvents)&&(i=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,h?.ignoreChangeEvents&&(i&=~p.FileChangeFilter.UPDATED),h?.ignoreCreateEvents&&(i&=~p.FileChangeFilter.ADDED),h?.ignoreDeleteEvents&&(i&=~p.FileChangeFilter.DELETED)),o.$watch(l.identifier.value,this.session,m.baseUri,{recursive:t,excludes:h?.excludes??[],filter:i},!!g),A.Disposable.from({dispose:()=>o.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(b){this._events=b,this.session=this._events.session,this._created=new a.Lazy(()=>this._events.created.map(T.URI.revive)),this._changed=new a.Lazy(()=>this._events.changed.map(T.URI.revive)),this._deleted=new a.Lazy(()=>this._events.deleted.map(T.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class c{constructor(b,l,m){this._mainContext=b,this._logService=l,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,l,m,h){return new I(this._mainContext,b,l,this._onFileSystemEvent.event,L.GlobPattern.from(m),h)}$onFileEvent(b){this._onFileSystemEvent.fire(new _(b))}$onDidRunFileOperation(b,l){switch(b){case p.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:l.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))}));break;case p.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:l.map(m=>T.URI.revive(m.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:l.map(m=>T.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,l){return(m,h,g)=>{const n=function(t){m.call(h,t)};return n.extension=b,l.event(n,void 0,g)}}async $onWillRunFileOperation(b,l,m,h){switch(b){case p.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(g=>({oldUri:T.URI.revive(g.source),newUri:T.URI.revive(g.target)}))},m,h);case p.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(g=>T.URI.revive(g.target))},m,h);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(g=>T.URI.revive(g.target))},m,h)}}async _fireWillEvent(b,l,m,h){const g=new Set,n=[];if(await b.fireAsync(l,h,async(t,i)=>{const r=Date.now(),f=await Promise.resolve(t);f instanceof A.WorkspaceEdit&&(n.push([i.extension,f]),g.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-r>m&&this._logService.warn("SLOW file-participant",i.extension.identifier)}),h.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,t]of n){const{edits:i}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(i)}return{edit:o,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=c}),define(_e[355],ye([1,0,19,9,21,14,133,3,25,43,13,18,2,31,191,88,143,236,24,16,10,26,119,6]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,l=ze(l),n=ze(n),r=ze(r);class f{constructor(z,$){this._documents=z,this._provider=$}async provideDocumentSymbols(z,$){const Q=this._documents.getDocument(z),Z=await this._provider.provideDocumentSymbols(Q,$);if(!(0,s.isFalsyOrEmpty)(Z))return Z[0]instanceof o.DocumentSymbol?Z.map(n.DocumentSymbol.from):f._asDocumentSymbolTree(Z)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((Z,fe)=>{let Ee=Z.location.range.start.compareTo(fe.location.range.start);return Ee===0&&(Ee=fe.location.range.end.compareTo(Z.location.range.end)),Ee});const $=[],Q=[];for(const Z of z){const fe={name:Z.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Z.kind),tags:Z.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:n.Range.from(Z.location.range),selectionRange:n.Range.from(Z.location.range),children:[]};for(;;){if(Q.length===0){Q.push(fe),$.push(fe);break}const Ee=Q[Q.length-1];if(C.Range.containsRange(Ee.range,fe.range)&&!C.Range.equalsRange(Ee.range,fe.range)){Ee.children?.push(fe),Q.push(fe);break}Q.pop()}}return $}}class u{constructor(z,$,Q,Z,fe,Ee){this._documents=z,this._commands=$,this._provider=Q,this._extension=Z,this._extTelemetry=fe,this._logService=Ee,this._cache=new i.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,$){const Q=this._documents.getDocument(z),Z=await this._provider.provideCodeLenses(Q,$);if(!Z||$.isCancellationRequested)return;const fe=this._cache.add(Z),Ee=new A.DisposableStore;this._disposables.set(fe,Ee);const Ne={cacheId:fe,lenses:[]};for(let Ve=0;Ve<Z.length;Ve++)Ne.lenses.push({cacheId:[fe,Ve],range:n.Range.from(Z[Ve].range),command:this._commands.toInternal(Z[Ve].command,Ee)});return Ne}async resolveCodeLens(z,$){const Q=z.cacheId&&this._cache.get(...z.cacheId);if(!Q)return;let Z;if(typeof this._provider.resolveCodeLens!="function"||Q.isResolved?Z=Q:Z=await this._provider.resolveCodeLens(Q,$),Z||(Z=Q),$.isCancellationRequested)return;const fe=z.cacheId&&this._disposables.get(z.cacheId[0]);if(fe){if(!Z.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,Ee),this._logService.error(Ee);return}return z.command=this._commands.toInternal(Z.command,fe),z}}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}function v(Re){return Array.isArray(Re)?Re.map(n.DefinitionLink.from):Re?[n.DefinitionLink.from(Re)]:[]}class y{constructor(z,$){this._documents=z,this._provider=$}async provideDefinition(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideDefinition(Z,fe,Q);return v(Ee)}}class D{constructor(z,$){this._documents=z,this._provider=$}async provideDeclaration(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideDeclaration(Z,fe,Q);return v(Ee)}}class w{constructor(z,$){this._documents=z,this._provider=$}async provideImplementation(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideImplementation(Z,fe,Q);return v(Ee)}}class P{constructor(z,$){this._documents=z,this._provider=$}async provideTypeDefinition(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideTypeDefinition(Z,fe,Q);return v(Ee)}}class k{static{this.HOVER_MAP_MAX_SIZE=10}constructor(z,$){this._documents=z,this._provider=$,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($);let Ne;if(Q&&Q.verbosityRequest){const rt=Q.verbosityRequest.previousHover.id,ot=this._hoverMap.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:Q.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this._provider.provideHover(fe,Ee,Z,nt)}else Ne=await this._provider.provideHover(fe,Ee,Z);if(!Ne||(0,s.isFalsyOrEmpty)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(Ee)),Ne.range||(Ne.range=new o.Range(Ee,Ee));const Ve=n.Hover.from(Ne),je=this._hoverCounter;if(this._hoverMap.size===k.HOVER_MAP_MAX_SIZE){const rt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(rt)}return this._hoverMap.set(je,Ne),this._hoverCounter+=1,{...Ve,id:je}}releaseHover(z){this._hoverMap.delete(z)}}class E{constructor(z,$){this._documents=z,this._provider=$}async provideEvaluatableExpression(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideEvaluatableExpression(Z,fe,Q);if(Ee)return n.EvaluatableExpression.from(Ee)}}class S{constructor(z,$){this._documents=z,this._provider=$}async provideInlineValues(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=await this._provider.provideInlineValues(fe,n.Range.to($),n.InlineValueContext.to(Q),Z);if(Array.isArray(Ee))return Ee.map(Ne=>n.InlineValue.from(Ne))}}class M{constructor(z,$){this._documents=z,this._provider=$}async provideDocumentHighlights(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideDocumentHighlights(Z,fe,Q);if(Array.isArray(Ee))return Ee.map(n.DocumentHighlight.from)}}class N{constructor(z,$){this._documents=z,this._provider=$}async provideMultiDocumentHighlights(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=Q.map(je=>this._documents.getDocument(je)),Ne=n.Position.to($),Ve=await this._provider.provideMultiDocumentHighlights(fe,Ne,Ee,Z);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class O{constructor(z,$){this._documents=z,this._provider=$}async provideLinkedEditingRanges(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.provideLinkedEditingRanges(Z,fe,Q);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,s.coalesce)(Ee.ranges.map(n.Range.from)),wordPattern:Ee.wordPattern}}}class x{constructor(z,$){this._documents=z,this._provider=$}async provideReferences(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($),Ne=await this._provider.provideReferences(fe,Ee,Q,Z);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class U{static{this._maxCodeActionsPerFile=1e3}constructor(z,$,Q,Z,fe,Ee,Ne){this._documents=z,this._commands=$,this._diagnostics=Q,this._provider=Z,this._logService=fe,this._extension=Ee,this._apiDeprecation=Ne,this._cache=new i.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=b.Selection.isISelection($)?n.Selection.to($):n.Range.to($),Ne=[];for(const nt of this._diagnostics.getDiagnostics(z))if(Ee.intersection(nt.range)&&Ne.push(nt)>U._maxCodeActionsPerFile)break;const Ve={diagnostics:Ne,only:Q.only?new o.CodeActionKind(Q.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Q.trigger)},je=await this._provider.provideCodeActions(fe,Ee,Ve,Z);if(!(0,s.isNonEmptyArray)(je)||Z.isCancellationRequested)return;const tt=this._cache.add(je),rt=new A.DisposableStore;this._disposables.set(tt,rt);const ot=[];for(let nt=0;nt<je.length;nt++){const at=je[nt];if(at)if(U._isCommand(at))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:at.title,command:this._commands.toInternal(at,rt)});else{Ve.only&&(at.kind?Ve.only.contains(at.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=at.ranges??[];ot.push({cacheId:[tt,nt],title:at.title,command:at.command&&this._commands.toInternal(at.command,rt),diagnostics:at.diagnostics&&at.diagnostics.map(n.Diagnostic.from),edit:at.edit&&n.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?at.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,s.coalesce)(mt.map(n.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(z,$){const[Q,Z]=z,fe=this._cache.get(Q,Z);if(!fe||U._isCommand(fe))return{};if(!this._provider.resolveCodeAction)return{};const Ee=await this._provider.resolveCodeAction(fe,$)??fe;let Ne;Ee.edit&&(Ne=n.WorkspaceEdit.from(Ee.edit,void 0));let Ve;if(Ee.command){const je=this._disposables.get(Q);je&&(Ve=this._commands.toInternal(Ee.command,je))}return{edit:Ne,command:Ve}}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}class F{constructor(z,$,Q,Z,fe){this._proxy=z,this._documents=$,this._provider=Q,this._handle=Z,this._extension=fe,this._cache=new i.Cache("DocumentPasteEdit")}async prepareDocumentPaste(z,$,Q,Z){if(!this._provider.prepareDocumentPaste)return;const fe=this._documents.getDocument(z),Ee=$.map(je=>n.Range.to(je)),Ne=n.DataTransfer.toDataTransfer(Q,()=>{throw new R.NotImplementedError});if(await this._provider.prepareDocumentPaste(fe,Ee,Ne,Z),Z.isCancellationRequested)return;const Ve=Array.from(Ne).filter(([,je])=>!(je instanceof o.InternalDataTransferItem));return n.DataTransfer.from(Ve)}async providePasteEdits(z,$,Q,Z,fe,Ee){if(!this._provider.provideDocumentPasteEdits)return[];const Ne=this._documents.getDocument($),Ve=Q.map(ot=>n.Range.to(ot)),je=n.DataTransfer.toDataTransfer(Z,async ot=>(await this._proxy.$resolvePasteFileData(this._handle,z,ot)).buffer),tt=await this._provider.provideDocumentPasteEdits(Ne,Ve,je,{only:fe.only?new o.DocumentDropOrPasteEditKind(fe.only):void 0,triggerKind:fe.triggerKind},Ee);if(!tt||Ee.isCancellationRequested)return[];const rt=this._cache.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,h.localize)(0,null,this._extension.displayName||this._extension.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,$){const[Q,Z]=z,fe=this._cache.get(Q,Z);if(!fe||!this._provider.resolveDocumentPasteEdit)return{};const Ee=await this._provider.resolveDocumentPasteEdit(fe,$)??fe;return{additionalEdit:Ee.additionalEdit?n.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(z){this._cache.delete(z)}}class H{constructor(z,$){this._documents=z,this._provider=$}async provideDocumentFormattingEdits(z,$,Q){const Z=this._documents.getDocument(z),fe=await this._provider.provideDocumentFormattingEdits(Z,$,Q);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class j{constructor(z,$){this._documents=z,this._provider=$}async provideDocumentRangeFormattingEdits(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Range.to($),Ne=await this._provider.provideDocumentRangeFormattingEdits(fe,Ee,Q,Z);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,$,Q,Z){(0,_.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this._documents.getDocument(z),Ee=$.map(n.Range.to),Ne=await this._provider.provideDocumentRangesFormattingEdits(fe,Ee,Q,Z);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class re{constructor(z,$){this._documents=z,this._provider=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,$,Q,Z,fe){const Ee=this._documents.getDocument(z),Ne=n.Position.to($),Ve=await this._provider.provideOnTypeFormattingEdits(Ee,Ne,Q,Z,fe);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class B{constructor(z,$){this._provider=z,this._logService=$,this._cache=new i.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,$){const Q=await this._provider.provideWorkspaceSymbols(z,$);if(!(0,s.isNonEmptyArray)(Q))return{symbols:[]};const Z=this._cache.add(Q),fe={cacheId:Z,symbols:[]};for(let Ee=0;Ee<Q.length;Ee++){const Ne=Q[Ee];if(!Ne||!Ne.name){this._logService.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[Z,Ee]})}return fe}async resolveWorkspaceSymbol(z,$){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const Q=this._cache.get(...z.cacheId);if(Q){const Z=await this._provider.resolveWorkspaceSymbol(Q,$);return Z&&(0,p.mixin)(z,n.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class V{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,$,Q){this._documents=z,this._provider=$,this._logService=Q}async provideRenameEdits(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($);try{const Ne=await this._provider.provideRenameEdits(fe,Ee,Q,Z);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ve=V._asMessage(Ne);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(z,$,Q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Z=this._documents.getDocument(z),fe=n.Position.to($);try{const Ee=await this._provider.prepareRename(Z,fe,Q);let Ne,Ve;if(o.Range.isRange(Ee)?(Ne=Ee,Ve=Z.getText(Ee)):(0,_.isObject)(Ee)&&(Ne=Ee.range,Ve=Ee.placeholder),!Ne||!Ve)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ve}}catch(Ee){const Ne=V._asMessage(Ee);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class X{static{this.languageTriggerKindToVSCodeTriggerKind={[l.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[l.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(z,$,Q){this._documents=z,this._provider=$,this._logService=Q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Range.to($);try{const Ne=X.languageTriggerKindToVSCodeTriggerKind[Q],Ve=await this._provider.provideNewSymbolNames(fe,Ee,Ne,Z);return Ve?Ve.map(je=>typeof je=="string"?{newSymbolName:je}:{newSymbolName:je.newSymbolName,tags:je.tags}):void 0}catch(Ne){this._logService.error(X._asMessage(Ne)??JSON.stringify(Ne,null,"	"));return}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ee{constructor(z,$){this.resultId=z,this.tokens=$}}class he{constructor(z,$){this._documents=z,this._provider=$,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,$,Q){const Z=this._documents.getDocument(z),fe=$!==0?this._previousResults.get($):null;let Ee=typeof fe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Z,fe.resultId,Q):await this._provider.provideDocumentSemanticTokens(Z,Q);return fe&&this._previousResults.delete($),Ee?(Ee=he._fixProvidedSemanticTokens(Ee),this._send(he._convertToEdits(fe,Ee),Ee)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return he._isSemanticTokens(z)?he._isCorrectSemanticTokens(z)?z:new o.SemanticTokens(new Uint32Array(z.data),z.resultId):he._isSemanticTokensEdits(z)?he._isCorrectSemanticTokensEdits(z)?z:new o.SemanticTokensEdits(z.edits.map($=>new o.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const $ of z.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,$){if(!he._isSemanticTokens($)||!z||!z.tokens)return $;const Q=z.tokens,Z=Q.length,fe=$.data,Ee=fe.length;let Ne=0;const Ve=Math.min(Z,Ee);for(;Ne<Ve&&Q[Ne]===fe[Ne];)Ne++;if(Ne===Z&&Ne===Ee)return new o.SemanticTokensEdits([],$.resultId);let je=0;const tt=Ve-Ne;for(;je<tt&&Q[Z-je-1]===fe[Ee-je-1];)je++;return new o.SemanticTokensEdits([{start:Ne,deleteCount:Z-Ne-je,data:fe.subarray(Ne,Ee-je)}],$.resultId)}_send(z,$){if(he._isSemanticTokens(z)){const Q=this._nextResultId++;return this._previousResults.set(Q,new ee(z.resultId,z.data)),(0,m.encodeSemanticTokensDto)({id:Q,type:"full",data:z.data})}if(he._isSemanticTokensEdits(z)){const Q=this._nextResultId++;return he._isSemanticTokens($)?this._previousResults.set(Q,new ee($.resultId,$.data)):this._previousResults.set(Q,new ee(z.resultId)),(0,m.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(z.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class ne{constructor(z,$){this._documents=z,this._provider=$}async provideDocumentRangeSemanticTokens(z,$,Q){const Z=this._documents.getDocument(z),fe=await this._provider.provideDocumentRangeSemanticTokens(Z,n.Range.to($),Q);return fe?this._send(fe):null}_send(z){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}class De{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,$,Q,Z,fe){this._documents=z,this._commands=$,this._provider=Q,this._apiDeprecation=Z,this._extension=fe,this._cache=new i.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($),Ne=fe.getWordRangeAtPosition(Ee)||new o.Range(Ee,Ee),Ve=Ne.with({end:Ee}),je=new a.StopWatch,tt=await this._provider.provideCompletionItems(fe,Ee,Z,n.CompletionContext.to(Q));if(!tt||Z.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.CompletionList(tt):tt,ot=De.supportsResolving(this._provider)?this._cache.add(rt.items):this._cache.add([]),nt=new A.DisposableStore;this._disposables.set(ot,nt);const at=[],mt={x:ot,[r.ISuggestResultDtoField.completions]:at,[r.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ne),insert:n.Range.from(Ve)},[r.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[r.ISuggestResultDtoField.duration]:je.elapsed()};for(let dt=0;dt<rt.items.length;dt++){const lt=rt.items[dt],Te=this._convertCompletionItem(lt,[ot,dt],Ve,Ne);at.push(Te)}return mt}async resolveCompletionItem(z,$){if(typeof this._provider.resolveCompletionItem!="function")return;const Q=this._cache.get(...z);if(!Q)return;const Z=this._convertCompletionItem(Q,z),fe=await this._provider.resolveCompletionItem(Q,$);if(!fe)return;const Ee=this._convertCompletionItem(fe,z);return(Z[r.ISuggestDataDtoField.insertText]!==Ee[r.ISuggestDataDtoField.insertText]||Z[r.ISuggestDataDtoField.insertTextRules]!==Ee[r.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z[r.ISuggestDataDtoField.commandIdent]!==Ee[r.ISuggestDataDtoField.commandIdent]||Z[r.ISuggestDataDtoField.commandId]!==Ee[r.ISuggestDataDtoField.commandId]||!(0,p.equals)(Z[r.ISuggestDataDtoField.commandArguments],Ee[r.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,[r.ISuggestDataDtoField.documentation]:Ee[r.ISuggestDataDtoField.documentation],[r.ISuggestDataDtoField.detail]:Ee[r.ISuggestDataDtoField.detail],[r.ISuggestDataDtoField.additionalTextEdits]:Ee[r.ISuggestDataDtoField.additionalTextEdits],[r.ISuggestDataDtoField.insertText]:Ee[r.ISuggestDataDtoField.insertText],[r.ISuggestDataDtoField.insertTextRules]:Ee[r.ISuggestDataDtoField.insertTextRules],[r.ISuggestDataDtoField.commandIdent]:Ee[r.ISuggestDataDtoField.commandIdent],[r.ISuggestDataDtoField.commandId]:Ee[r.ISuggestDataDtoField.commandId],[r.ISuggestDataDtoField.commandArguments]:Ee[r.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,$,Q,Z){const fe=this._disposables.get($[0]);if(!fe)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(z.command,fe),Ne={x:$,[r.ISuggestDataDtoField.label]:z.label,[r.ISuggestDataDtoField.kind]:z.kind!==void 0?n.CompletionItemKind.from(z.kind):void 0,[r.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(n.CompletionItemTag.from),[r.ISuggestDataDtoField.detail]:z.detail,[r.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:n.MarkdownString.fromStrict(z.documentation),[r.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[r.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[r.ISuggestDataDtoField.preselect]:z.preselect||void 0,[r.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?l.CompletionItemInsertTextRule.KeepWhitespace:l.CompletionItemInsertTextRule.None,[r.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[r.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(n.TextEdit.from),[r.ISuggestDataDtoField.commandIdent]:Ee?.$ident,[r.ISuggestDataDtoField.commandId]:Ee?.id,[r.ISuggestDataDtoField.commandArguments]:Ee?.$ident?void 0:Ee?.arguments};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[r.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ne[r.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof o.SnippetString&&(Ne[r.ISuggestDataDtoField.insertText]=z.insertText.value,Ne[r.ISuggestDataDtoField.insertTextRules]|=l.CompletionItemInsertTextRule.InsertAsSnippet);let Ve;return z.textEdit?Ve=z.textEdit.range:z.range&&(Ve=z.range),o.Range.isRange(Ve)?Ne[r.ISuggestDataDtoField.range]=n.Range.from(Ve):Ve&&(!Q?.isEqual(Ve.inserting)||!Z?.isEqual(Ve.replacing))&&(Ne[r.ISuggestDataDtoField.range]={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Ne}}class pe{async provideInlineCompletions(z,$,Q,Z){}async provideInlineEdits(z,$,Q,Z){}disposeCompletions(z){}handleDidShowCompletionItem(z,$,Q){}handlePartialAccept(z,$,Q,Z){}}class G extends pe{constructor(z,$,Q,Z){super(),this._extension=z,this._documents=$,this._provider=Q,this._commands=Z,this._references=new se,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[l.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($),Ne=await this._provider.provideInlineCompletionItems(fe,Ee,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:n.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Q.triggerKind]},Z);if(!Ne||Z.isCancellationRequested)return;const Ve=Array.isArray(Ne)?Ne:Ne.items,je=this._isAdditionsProposedApiEnabled?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this._references.createReferenceId({dispose(){rt?.dispose()},items:Ve}),items:Ve.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new A.DisposableStore),mt=this._commands.toInternal(nt.command,rt));const dt=nt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?nt.completeBracketPairs:!1}}),commands:je.map(nt=>(rt||(rt=new A.DisposableStore),this._commands.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}async provideInlineEdits(z,$,Q,Z){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const fe=this._documents.getDocument(z),Ee=n.Range.to($),Ne=await this._provider.provideInlineEdits(fe,Ee,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:n.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Q.triggerKind],userPrompt:Q.userPrompt},Z);if(!Ne||Z.isCancellationRequested)return;const Ve=Array.isArray(Ne)?Ne:Ne.items,je=this._isAdditionsProposedApiEnabled?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this._references.createReferenceId({dispose(){rt?.dispose()},items:Ve}),items:Ve.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new A.DisposableStore),mt=this._commands.toInternal(nt.command,rt));const dt=nt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?nt.completeBracketPairs:!1}}),commands:je.map(nt=>(rt||(rt=new A.DisposableStore),this._commands.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(z){this._references.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,$,Q){const Z=this._references.get(z)?.items[$];Z&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(Z,Q)}handlePartialAccept(z,$,Q,Z){const fe=this._references.get(z)?.items[$];fe&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(fe,Q),this._provider.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(Z)))}}class W{async provideInlineEdits(z,$,Q){const Z=this._documents.getDocument(z),fe=await this._provider.provideInlineEdit(Z,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},Q);if(!fe||Q.isCancellationRequested)return;let Ee;const Ne=this._references.createReferenceId({dispose(){Ee?.dispose()},item:fe});let Ve;fe.accepted&&(Ee||(Ee=new A.DisposableStore),Ve=this._commands.toInternal(fe.accepted,Ee));let je;return fe.rejected&&(Ee||(Ee=new A.DisposableStore),je=this._commands.toInternal(fe.rejected,Ee)),{pid:Ne,text:fe.text,range:n.Range.from(fe.range),accepted:Ve,rejected:je}}disposeEdit(z){this._references.disposeReferenceId(z)?.dispose()}constructor(z,$,Q,Z){this._documents=$,this._provider=Q,this._commands=Z,this._references=new se,this.languageTriggerKindToVSCodeTriggerKind={[l.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this._references=new Map,this._idPool=1}createReferenceId(z){const $=this._idPool++;return this._references.set($,z),$}disposeReferenceId(z){const $=this._references.get(z);return this._references.delete(z),$}get(z){return this._references.get(z)}}class ae{constructor(z,$){this._documents=z,this._provider=$,this._cache=new i.Cache("SignatureHelp")}async provideSignatureHelp(z,$,Q,Z){const fe=this._documents.getDocument(z),Ee=n.Position.to($),Ne=this.reviveContext(Q),Ve=await this._provider.provideSignatureHelp(fe,Ee,Z,Ne);if(Ve){const je=this._cache.add([Ve]);return{...n.SignatureHelp.from(Ve),id:je}}}reviveContext(z){let $;if(z.activeSignatureHelp){const Q=n.SignatureHelp.to(z.activeSignatureHelp),Z=this._cache.get(z.activeSignatureHelp.id,0);Z?($=Z,$.activeSignature=Q.activeSignature,$.activeParameter=Q.activeParameter):$=Q}return{...z,activeSignatureHelp:$}}releaseSignatureHelp(z){this._cache.delete(z)}}class te{constructor(z,$,Q,Z,fe){this._documents=z,this._commands=$,this._provider=Q,this._logService=Z,this._extension=fe,this._cache=new i.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Range.to($),Ee=await this._provider.provideInlayHints(Z,fe,Q);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify($)}`);return}if(Q.isCancellationRequested)return;const Ne=this._cache.add(Ee);this._disposables.set(Ne,new A.DisposableStore);const Ve={hints:[],cacheId:Ne};for(let je=0;je<Ee.length;je++)this._isValidInlayHint(Ee[je],fe)&&Ve.hints.push(this._convertInlayHint(Ee[je],[Ne,je]));return this._logService.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify($)}`),Ve}async resolveInlayHint(z,$){if(typeof this._provider.resolveInlayHint!="function")return;const Q=this._cache.get(...z);if(!Q)return;const Z=await this._provider.resolveInlayHint(Q,$);if(Z&&this._isValidInlayHint(Z))return this._convertInlayHint(Z,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,$){return z.label.length===0||Array.isArray(z.label)&&z.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!($&&!$.contains(z.position))}_convertInlayHint(z,$){const Q=this._disposables.get($[0]);if(!Q)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:$,tooltip:n.MarkdownString.fromStrict(z.tooltip),position:n.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(n.TextEdit.from),kind:z.kind&&n.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")Z.label=z.label;else{const fe=[];Z.label=fe;for(const Ee of z.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Ne={label:Ee.value,tooltip:n.MarkdownString.fromStrict(Ee.tooltip)};o.Location.isLocation(Ee.location)&&(Ne.location=n.location.from(Ee.location)),Ee.command&&(Ne.command=this._commands.toInternal(Ee.command,Q)),fe.push(Ne)}}return Z}}class ce{constructor(z,$){this._documents=z,this._provider=$,this._cache=new i.Cache("DocumentLink")}async provideLinks(z,$){const Q=this._documents.getDocument(z),Z=await this._provider.provideDocumentLinks(Q,$);if(!(!Array.isArray(Z)||Z.length===0)&&!$.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Z.filter(ce._validateLink).map(n.DocumentLink.from)};{const fe=this._cache.add(Z),Ee={links:[],cacheId:fe};for(let Ne=0;Ne<Z.length;Ne++){if(!ce._validateLink(Z[Ne]))continue;const Ve=n.DocumentLink.from(Z[Ne]);Ve.cacheId=[fe,Ne],Ee.links.push(Ve)}return Ee}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,$){if(typeof this._provider.resolveDocumentLink!="function")return;const Q=this._cache.get(...z);if(!Q)return;const Z=await this._provider.resolveDocumentLink(Q,$);if(!(!Z||!ce._validateLink(Z)))return n.DocumentLink.from(Z)}releaseLinks(z){this._cache.delete(z)}}class ue{constructor(z,$){this._documents=z,this._provider=$}async provideColors(z,$){const Q=this._documents.getDocument(z),Z=await this._provider.provideDocumentColors(Q,$);return Array.isArray(Z)?Z.map(Ee=>({color:n.Color.from(Ee.color),range:n.Range.from(Ee.range)})):[]}async provideColorPresentations(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Range.to($.range),Ee=n.Color.to($.color),Ne=await this._provider.provideColorPresentations(Ee,{document:Z,range:fe},Q);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class Y{constructor(z,$){this._documents=z,this._provider=$}async provideFoldingRanges(z,$,Q){const Z=this._documents.getDocument(z),fe=await this._provider.provideFoldingRanges(Z,$,Q);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(z,$,Q){this._documents=z,this._provider=$,this._logService=Q}async provideSelectionRanges(z,$,Q){const Z=this._documents.getDocument(z),fe=$.map(n.Position.to),Ee=await this._provider.provideSelectionRanges(Z,fe,Q);if(!(0,s.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ve=0;Ve<fe.length;Ve++){const je=[];Ne.push(je);let tt=fe[Ve],rt=Ee[Ve];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(je.push(n.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Ne}}class ve{constructor(z,$){this._documents=z,this._provider=$,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.prepareCallHierarchy(Z,fe,Q);if(!Ee)return;const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(Ee)?Ee.map(Ve=>this._cacheAndConvertItem(Ne,Ve)):[this._cacheAndConvertItem(Ne,Ee)]}async provideCallsTo(z,$,Q){const Z=this._itemFromCache(z,$);if(!Z)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(Z,Q);if(fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(z,Ee.from),fromRanges:Ee.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(z,$,Q){const Z=this._itemFromCache(z,$);if(!Z)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(Z,Q);if(fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(z,Ee.to),fromRanges:Ee.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,$){const Q=this._cache.get(z),Z=n.CallHierarchyItem.from($,z,Q.size.toString(36));return Q.set(Z._itemId,$),Z}_itemFromCache(z,$){return this._cache.get(z)?.get($)}}class be{constructor(z,$){this._documents=z,this._provider=$,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(z,$,Q){const Z=this._documents.getDocument(z),fe=n.Position.to($),Ee=await this._provider.prepareTypeHierarchy(Z,fe,Q);if(!Ee)return;const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(Ee)?Ee.map(Ve=>this._cacheAndConvertItem(Ne,Ve)):[this._cacheAndConvertItem(Ne,Ee)]}async provideSupertypes(z,$,Q){const Z=this._itemFromCache(z,$);if(!Z)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySupertypes(Z,Q);if(fe)return fe.map(Ee=>this._cacheAndConvertItem(z,Ee))}async provideSubtypes(z,$,Q){const Z=this._itemFromCache(z,$);if(!Z)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySubtypes(Z,Q);if(fe)return fe.map(Ee=>this._cacheAndConvertItem(z,Ee))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,$){const Q=this._cache.get(z),Z=n.TypeHierarchyItem.from($,z,Q.size.toString(36));return Q.set(Z._itemId,$),Z}_itemFromCache(z,$){return this._cache.get(z)?.get($)}}class Fe{constructor(z,$,Q,Z,fe){this._proxy=z,this._documents=$,this._provider=Q,this._handle=Z,this._extension=fe,this._cache=new i.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(z,$,Q,Z,fe){const Ee=this._documents.getDocument($),Ne=n.Position.to(Q),Ve=n.DataTransfer.toDataTransfer(Z,async ot=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,z,ot)).buffer),je=await this._provider.provideDocumentDropEdits(Ee,Ne,Ve,fe);if(!je)return;const tt=(0,s.asArray)(je),rt=this._cache.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,h.localize)(1,null,this._extension.displayName||this._extension.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,$){const[Q,Z]=z,fe=this._cache.get(Q,Z);if(!fe||!this._provider.resolveDocumentDropEdit)return{};const Ee=await this._provider.resolveDocumentDropEdit(fe,$)??fe;return{additionalEdit:Ee.additionalEdit?n.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releaseDropEdits(z){this._cache.delete(z)}}class We{constructor(z,$){this._documents=z,this._provider=$}async provideMappedEdits(z,$,Q,Z){const fe=c.URI.revive(z),Ee=this._documents.getDocument(fe),Ne=Q.documents.map(tt=>tt.map(rt=>({uri:c.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ve={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},je=await this._provider.provideMappedEdits(Ee,$,Ve,Z);return je?n.WorkspaceEdit.from(je):null}}class Ce{constructor(z,$){this.adapter=z,this.extension=$}}class Ie{static{this._handlePool=0}constructor(z,$,Q,Z,fe,Ee,Ne,Ve){this._uriTransformer=$,this._documents=Q,this._commands=Z,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=Ne,this._extensionTelemetry=Ve,this._adapter=new Map,this._proxy=z.getProxy(r.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(z,$){return n.DocumentSelector.from(z,this._uriTransformer,$)}_createDisposable(z){return new o.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ie._handlePool++}async _withAdapter(z,$,Q,Z,fe,Ee=!1){const Ne=this._adapter.get(z);if(!Ne||!(Ne.adapter instanceof $))return Z;const Ve=Date.now();Ee||this._logService.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const je=Q(Ne.adapter,Ne.extension);return Promise.resolve(je).catch(tt=>{(0,R.isCancellationError)(tt)||(this._logService.error(`[${Ne.extension.identifier.value}] provider FAILED`),this._logService.error(tt),this._extensionTelemetry.onExtensionError(Ne.extension.identifier,tt))}).finally(()=>{Ee||this._logService.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),T.CancellationToken.isCancellationToken(fe)?(0,d.raceCancellationError)(je,fe):je}_addNewAdapter(z,$){const Q=this._nextHandle();return this._adapter.set(Q,new Ce(z,$)),Q}static _extLabel(z){return z.displayName||z.name}static _extId(z){return z.identifier.value}registerDocumentSymbolProvider(z,$,Q,Z){const fe=this._addNewAdapter(new f(this._documents,Q),z),Ee=Z&&Z.label||Ie._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector($,z),Ee),this._createDisposable(fe)}$provideDocumentSymbols(z,$,Q){return this._withAdapter(z,f,Z=>Z.provideDocumentSymbols(c.URI.revive($),Q),void 0,Q)}registerCodeLensProvider(z,$,Q){const Z=this._nextHandle(),fe=typeof Q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Ce(new u(this._documents,this._commands.converter,Q,z,this._extensionTelemetry,this._logService),z)),this._proxy.$registerCodeLensSupport(Z,this._transformDocumentSelector($,z),fe);let Ee=this._createDisposable(Z);if(fe!==void 0){const Ne=Q.onDidChangeCodeLenses(Ve=>this._proxy.$emitCodeLensEvent(fe));Ee=o.Disposable.from(Ee,Ne)}return Ee}$provideCodeLenses(z,$,Q){return this._withAdapter(z,u,Z=>Z.provideCodeLenses(c.URI.revive($),Q),void 0,Q)}$resolveCodeLens(z,$,Q){return this._withAdapter(z,u,Z=>Z.resolveCodeLens($,Q),void 0,void 0)}$releaseCodeLenses(z,$){this._withAdapter(z,u,Q=>Promise.resolve(Q.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(z,$,Q){const Z=this._addNewAdapter(new y(this._documents,Q),z);return this._proxy.$registerDefinitionSupport(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideDefinition(z,$,Q,Z){return this._withAdapter(z,y,fe=>fe.provideDefinition(c.URI.revive($),Q,Z),[],Z)}registerDeclarationProvider(z,$,Q){const Z=this._addNewAdapter(new D(this._documents,Q),z);return this._proxy.$registerDeclarationSupport(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideDeclaration(z,$,Q,Z){return this._withAdapter(z,D,fe=>fe.provideDeclaration(c.URI.revive($),Q,Z),[],Z)}registerImplementationProvider(z,$,Q){const Z=this._addNewAdapter(new w(this._documents,Q),z);return this._proxy.$registerImplementationSupport(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideImplementation(z,$,Q,Z){return this._withAdapter(z,w,fe=>fe.provideImplementation(c.URI.revive($),Q,Z),[],Z)}registerTypeDefinitionProvider(z,$,Q){const Z=this._addNewAdapter(new P(this._documents,Q),z);return this._proxy.$registerTypeDefinitionSupport(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideTypeDefinition(z,$,Q,Z){return this._withAdapter(z,P,fe=>fe.provideTypeDefinition(c.URI.revive($),Q,Z),[],Z)}registerHoverProvider(z,$,Q,Z){const fe=this._addNewAdapter(new k(this._documents,Q),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector($,z)),this._createDisposable(fe)}$provideHover(z,$,Q,Z,fe){return this._withAdapter(z,k,Ee=>Ee.provideHover(c.URI.revive($),Q,Z,fe),void 0,fe)}$releaseHover(z,$){this._withAdapter(z,k,Q=>Promise.resolve(Q.releaseHover($)),void 0,void 0)}registerEvaluatableExpressionProvider(z,$,Q,Z){const fe=this._addNewAdapter(new E(this._documents,Q),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector($,z)),this._createDisposable(fe)}$provideEvaluatableExpression(z,$,Q,Z){return this._withAdapter(z,E,fe=>fe.provideEvaluatableExpression(c.URI.revive($),Q,Z),void 0,Z)}registerInlineValuesProvider(z,$,Q,Z){const fe=typeof Q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new S(this._documents,Q),z);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector($,z),fe);let Ne=this._createDisposable(Ee);if(fe!==void 0){const Ve=Q.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(fe));Ne=o.Disposable.from(Ne,Ve)}return Ne}$provideInlineValues(z,$,Q,Z,fe){return this._withAdapter(z,S,Ee=>Ee.provideInlineValues(c.URI.revive($),Q,Z,fe),void 0,fe)}registerDocumentHighlightProvider(z,$,Q){const Z=this._addNewAdapter(new M(this._documents,Q),z);return this._proxy.$registerDocumentHighlightProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}registerMultiDocumentHighlightProvider(z,$,Q){const Z=this._addNewAdapter(new N(this._documents,Q),z);return this._proxy.$registerMultiDocumentHighlightProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideDocumentHighlights(z,$,Q,Z){return this._withAdapter(z,M,fe=>fe.provideDocumentHighlights(c.URI.revive($),Q,Z),void 0,Z)}$provideMultiDocumentHighlights(z,$,Q,Z,fe){return this._withAdapter(z,N,Ee=>Ee.provideMultiDocumentHighlights(c.URI.revive($),Q,Z.map(Ne=>c.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(z,$,Q){const Z=this._addNewAdapter(new O(this._documents,Q),z);return this._proxy.$registerLinkedEditingRangeProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideLinkedEditingRanges(z,$,Q,Z){return this._withAdapter(z,O,async fe=>{const Ee=await fe.provideLinkedEditingRanges(c.URI.revive($),Q,Z);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Ie._serializeRegExp(Ee.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(z,$,Q){const Z=this._addNewAdapter(new x(this._documents,Q),z);return this._proxy.$registerReferenceSupport(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideReferences(z,$,Q,Z,fe){return this._withAdapter(z,x,Ee=>Ee.provideReferences(c.URI.revive($),Q,Z,fe),void 0,fe)}registerCodeActionProvider(z,$,Q,Z){const fe=new A.DisposableStore,Ee=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,Q,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerCodeActionSupport(Ee,this._transformDocumentSelector($,z),{providedKinds:Z?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:Z?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this._commands.converter.toInternal(Ne.command,fe)}))},Ie._extLabel(z),Ie._extId(z),!!Q.resolveCodeAction),fe.add(this._createDisposable(Ee)),fe}$provideCodeActions(z,$,Q,Z,fe){return this._withAdapter(z,U,Ee=>Ee.provideCodeActions(c.URI.revive($),Q,Z,fe),void 0,fe)}$resolveCodeAction(z,$,Q){return this._withAdapter(z,U,Z=>Z.resolveCodeAction($,Q),{},void 0)}$releaseCodeActions(z,$){this._withAdapter(z,U,Q=>Promise.resolve(Q.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(z,$,Q){const Z=this._addNewAdapter(new H(this._documents,Q),z);return this._proxy.$registerDocumentFormattingSupport(Z,this._transformDocumentSelector($,z),z.identifier,z.displayName||z.name),this._createDisposable(Z)}$provideDocumentFormattingEdits(z,$,Q,Z){return this._withAdapter(z,H,fe=>fe.provideDocumentFormattingEdits(c.URI.revive($),Q,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(z,$,Q){const Z=typeof Q.provideDocumentRangesFormattingEdits=="function",fe=this._addNewAdapter(new j(this._documents,Q),z);return this._proxy.$registerRangeFormattingSupport(fe,this._transformDocumentSelector($,z),z.identifier,z.displayName||z.name,Z),this._createDisposable(fe)}$provideDocumentRangeFormattingEdits(z,$,Q,Z,fe){return this._withAdapter(z,j,Ee=>Ee.provideDocumentRangeFormattingEdits(c.URI.revive($),Q,Z,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(z,$,Q,Z,fe){return this._withAdapter(z,j,Ee=>Ee.provideDocumentRangesFormattingEdits(c.URI.revive($),Q,Z,fe),void 0,fe)}registerOnTypeFormattingEditProvider(z,$,Q,Z){const fe=this._addNewAdapter(new re(this._documents,Q),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector($,z),Z,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,$,Q,Z,fe,Ee){return this._withAdapter(z,re,Ne=>Ne.provideOnTypeFormattingEdits(c.URI.revive($),Q,Z,fe,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(z,$){const Q=this._addNewAdapter(new B($,this._logService),z);return this._proxy.$registerNavigateTypeSupport(Q,typeof $.resolveWorkspaceSymbol=="function"),this._createDisposable(Q)}$provideWorkspaceSymbols(z,$,Q){return this._withAdapter(z,B,Z=>Z.provideWorkspaceSymbols($,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(z,$,Q){return this._withAdapter(z,B,Z=>Z.resolveWorkspaceSymbol($,Q),void 0,void 0)}$releaseWorkspaceSymbols(z,$){this._withAdapter(z,B,Q=>Q.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(z,$,Q){const Z=this._addNewAdapter(new V(this._documents,Q,this._logService),z);return this._proxy.$registerRenameSupport(Z,this._transformDocumentSelector($,z),V.supportsResolving(Q)),this._createDisposable(Z)}$provideRenameEdits(z,$,Q,Z,fe){return this._withAdapter(z,V,Ee=>Ee.provideRenameEdits(c.URI.revive($),Q,Z,fe),void 0,fe)}$resolveRenameLocation(z,$,Q,Z){return this._withAdapter(z,V,fe=>fe.resolveRenameLocation(c.URI.revive($),Q,Z),void 0,Z)}registerNewSymbolNamesProvider(z,$,Q){const Z=this._addNewAdapter(new X(this._documents,Q,this._logService),z);return this._proxy.$registerNewSymbolNamesProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this._withAdapter(z,X,$=>$.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,$,Q,Z,fe){return this._withAdapter(z,X,Ee=>Ee.provideNewSymbolNames(c.URI.revive($),Q,Z,fe),void 0,fe)}registerDocumentSemanticTokensProvider(z,$,Q,Z){const fe=this._addNewAdapter(new he(this._documents,Q),z),Ee=typeof Q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector($,z),Z,Ee);let Ne=this._createDisposable(fe);if(Ee){const Ve=Q.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Ne=o.Disposable.from(Ne,Ve)}return Ne}$provideDocumentSemanticTokens(z,$,Q,Z){return this._withAdapter(z,he,fe=>fe.provideDocumentSemanticTokens(c.URI.revive($),Q,Z),null,Z)}$releaseDocumentSemanticTokens(z,$){this._withAdapter(z,he,Q=>Q.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,$,Q,Z){const fe=this._addNewAdapter(new ne(this._documents,Q),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector($,z),Z),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,$,Q,Z){return this._withAdapter(z,ne,fe=>fe.provideDocumentRangeSemanticTokens(c.URI.revive($),Q,Z),null,Z)}registerCompletionItemProvider(z,$,Q,Z){const fe=this._addNewAdapter(new De(this._documents,this._commands.converter,Q,this._apiDeprecation,z),z);return this._proxy.$registerCompletionsProvider(fe,this._transformDocumentSelector($,z),Z,De.supportsResolving(Q),z.identifier),this._createDisposable(fe)}$provideCompletionItems(z,$,Q,Z,fe){return this._withAdapter(z,De,Ee=>Ee.provideCompletionItems(c.URI.revive($),Q,Z,fe),void 0,fe)}$resolveCompletionItem(z,$,Q){return this._withAdapter(z,De,Z=>Z.resolveCompletionItem($,Q),void 0,Q)}$releaseCompletionItems(z,$){this._withAdapter(z,De,Q=>Q.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(z,$,Q,Z){const fe=new G(z,this._documents,Q,this._commands.converter),Ee=this._addNewAdapter(fe,z);return this._proxy.$registerInlineCompletionsSupport(Ee,this._transformDocumentSelector($,z),fe.supportsHandleEvents,g.ExtensionIdentifier.toKey(z.identifier.value),Z?.yieldTo?.map(Ne=>g.ExtensionIdentifier.toKey(Ne))||[]),this._createDisposable(Ee)}$provideInlineCompletions(z,$,Q,Z,fe){return this._withAdapter(z,pe,Ee=>Ee.provideInlineCompletions(c.URI.revive($),Q,Z,fe),void 0,fe)}$provideInlineEdits(z,$,Q,Z,fe){return this._withAdapter(z,pe,Ee=>Ee.provideInlineEdits(c.URI.revive($),Q,Z,fe),void 0,fe)}$handleInlineCompletionDidShow(z,$,Q,Z){this._withAdapter(z,pe,async fe=>{fe.handleDidShowCompletionItem($,Q,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,$,Q,Z,fe){this._withAdapter(z,pe,async Ee=>{Ee.handlePartialAccept($,Q,Z,fe)},void 0,void 0)}$freeInlineCompletionsList(z,$){this._withAdapter(z,pe,async Q=>{Q.disposeCompletions($)},void 0,void 0)}registerInlineEditProvider(z,$,Q){const Z=new W(z,this._documents,Q,this._commands.converter),fe=this._addNewAdapter(Z,z);return this._proxy.$registerInlineEditProvider(fe,this._transformDocumentSelector($,z),z.identifier),this._createDisposable(fe)}$provideInlineEdit(z,$,Q,Z){return this._withAdapter(z,W,fe=>fe.provideInlineEdits(c.URI.revive($),Q,Z),void 0,Z)}$freeInlineEdit(z,$){this._withAdapter(z,W,async Q=>{Q.disposeEdit($)},void 0,void 0)}registerSignatureHelpProvider(z,$,Q,Z){const fe=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,Ee=this._addNewAdapter(new ae(this._documents,Q),z);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector($,z),fe),this._createDisposable(Ee)}$provideSignatureHelp(z,$,Q,Z,fe){return this._withAdapter(z,ae,Ee=>Ee.provideSignatureHelp(c.URI.revive($),Q,Z,fe),void 0,fe)}$releaseSignatureHelp(z,$){this._withAdapter(z,ae,Q=>Q.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(z,$,Q){const Z=typeof Q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new te(this._documents,this._commands.converter,Q,this._logService,z),z);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector($,z),typeof Q.resolveInlayHint=="function",Z,Ie._extLabel(z));let Ee=this._createDisposable(fe);if(Z!==void 0){const Ne=Q.onDidChangeInlayHints(Ve=>this._proxy.$emitInlayHintsEvent(Z));Ee=o.Disposable.from(Ee,Ne)}return Ee}$provideInlayHints(z,$,Q,Z){return this._withAdapter(z,te,fe=>fe.provideInlayHints(c.URI.revive($),Q,Z),void 0,Z)}$resolveInlayHint(z,$,Q){return this._withAdapter(z,te,Z=>Z.resolveInlayHint($,Q),void 0,Q)}$releaseInlayHints(z,$){this._withAdapter(z,te,Q=>Q.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(z,$,Q){const Z=this._addNewAdapter(new ce(this._documents,Q),z);return this._proxy.$registerDocumentLinkProvider(Z,this._transformDocumentSelector($,z),typeof Q.resolveDocumentLink=="function"),this._createDisposable(Z)}$provideDocumentLinks(z,$,Q){return this._withAdapter(z,ce,Z=>Z.provideLinks(c.URI.revive($),Q),void 0,Q,$.scheme==="output")}$resolveDocumentLink(z,$,Q){return this._withAdapter(z,ce,Z=>Z.resolveLink($,Q),void 0,void 0,!0)}$releaseDocumentLinks(z,$){this._withAdapter(z,ce,Q=>Q.releaseLinks($),void 0,void 0,!0)}registerColorProvider(z,$,Q){const Z=this._addNewAdapter(new ue(this._documents,Q),z);return this._proxy.$registerDocumentColorProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideDocumentColors(z,$,Q){return this._withAdapter(z,ue,Z=>Z.provideColors(c.URI.revive($),Q),[],Q)}$provideColorPresentations(z,$,Q,Z){return this._withAdapter(z,ue,fe=>fe.provideColorPresentations(c.URI.revive($),Q,Z),void 0,Z)}registerFoldingRangeProvider(z,$,Q){const Z=this._nextHandle(),fe=typeof Q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Ce(new Y(this._documents,Q),z)),this._proxy.$registerFoldingRangeProvider(Z,this._transformDocumentSelector($,z),z.identifier,fe);let Ee=this._createDisposable(Z);if(fe!==void 0){const Ne=Q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=o.Disposable.from(Ee,Ne)}return Ee}$provideFoldingRanges(z,$,Q,Z){return this._withAdapter(z,Y,fe=>fe.provideFoldingRanges(c.URI.revive($),Q,Z),void 0,Z)}registerSelectionRangeProvider(z,$,Q){const Z=this._addNewAdapter(new oe(this._documents,Q,this._logService),z);return this._proxy.$registerSelectionRangeProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideSelectionRanges(z,$,Q,Z){return this._withAdapter(z,oe,fe=>fe.provideSelectionRanges(c.URI.revive($),Q,Z),[],Z)}registerCallHierarchyProvider(z,$,Q){const Z=this._addNewAdapter(new ve(this._documents,Q),z);return this._proxy.$registerCallHierarchyProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$prepareCallHierarchy(z,$,Q,Z){return this._withAdapter(z,ve,fe=>Promise.resolve(fe.prepareSession(c.URI.revive($),Q,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(z,$,Q,Z){return this._withAdapter(z,ve,fe=>fe.provideCallsTo($,Q,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(z,$,Q,Z){return this._withAdapter(z,ve,fe=>fe.provideCallsFrom($,Q,Z),void 0,Z)}$releaseCallHierarchy(z,$){this._withAdapter(z,ve,Q=>Promise.resolve(Q.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(z,$,Q){const Z=this._addNewAdapter(new be(this._documents,Q),z);return this._proxy.$registerTypeHierarchyProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$prepareTypeHierarchy(z,$,Q,Z){return this._withAdapter(z,be,fe=>Promise.resolve(fe.prepareSession(c.URI.revive($),Q,Z)),void 0,Z)}$provideTypeHierarchySupertypes(z,$,Q,Z){return this._withAdapter(z,be,fe=>fe.provideSupertypes($,Q,Z),void 0,Z)}$provideTypeHierarchySubtypes(z,$,Q,Z){return this._withAdapter(z,be,fe=>fe.provideSubtypes($,Q,Z),void 0,Z)}$releaseTypeHierarchy(z,$){this._withAdapter(z,be,Q=>Promise.resolve(Q.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(z,$,Q,Z){const fe=this._nextHandle();return this._adapter.set(fe,new Ce(new Fe(this._proxy,this._documents,Q,fe,z),z)),this._proxy.$registerDocumentOnDropEditProvider(fe,this._transformDocumentSelector($,z),(0,t.isProposedApiEnabled)(z,"documentPaste")&&Z?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this._createDisposable(fe)}$provideDocumentOnDropEdits(z,$,Q,Z,fe,Ee){return this._withAdapter(z,Fe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits($,c.URI.revive(Q),Z,fe,Ee)),void 0,void 0)}$resolveDropEdit(z,$,Q){return this._withAdapter(z,Fe,Z=>Z.resolveDropEdit($,Q),{},void 0)}$releaseDocumentOnDropEdits(z,$){this._withAdapter(z,Fe,Q=>Promise.resolve(Q.releaseDropEdits($)),void 0,void 0)}registerMappedEditsProvider(z,$,Q){const Z=this._addNewAdapter(new We(this._documents,Q),z);return this._proxy.$registerMappedEditsProvider(Z,this._transformDocumentSelector($,z)),this._createDisposable(Z)}$provideMappedEdits(z,$,Q,Z,fe){return this._withAdapter(z,We,Ee=>Promise.resolve(Ee.provideMappedEdits($,Q,Z,fe)),null,fe)}registerDocumentPasteEditProvider(z,$,Q,Z){const fe=this._nextHandle();return this._adapter.set(fe,new Ce(new F(this._proxy,this._documents,Q,fe,z),z)),this._proxy.$registerPasteEditProvider(fe,this._transformDocumentSelector($,z),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this._createDisposable(fe)}$prepareDocumentPaste(z,$,Q,Z,fe){return this._withAdapter(z,F,Ee=>Ee.prepareDocumentPaste(c.URI.revive($),Q,Z,fe),void 0,fe)}$providePasteEdits(z,$,Q,Z,fe,Ee,Ne){return this._withAdapter(z,F,Ve=>Ve.providePasteEdits($,c.URI.revive(Q),Z,fe,Ee,Ne),void 0,Ne)}$resolvePasteEdit(z,$,Q){return this._withAdapter(z,F,Z=>Z.resolvePasteEdit($,Q),{},void 0)}$releasePasteEdits(z,$){this._withAdapter(z,F,Q=>Promise.resolve(Q.releasePasteEdits($)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:z.flags}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ie._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ie._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ie._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ie._serializeRegExp(z.beforeText),afterText:z.afterText?Ie._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ie._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ie._serializeOnEnterRule)}static _serializeAutoClosingPair(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map($=>o.SyntaxTokenType.toString($)):void 0}}static _serializeAutoClosingPairs(z){return z.map(Ie._serializeAutoClosingPair)}setLanguageConfiguration(z,$,Q){const{wordPattern:Z}=Q;if(Z&&(0,I.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this._documents.setWordDefinitionFor($,Z):this._documents.setWordDefinitionFor($,void 0),Q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),Q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),Ee={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ie._serializeRegExp(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ie._serializeIndentationRule(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ie._serializeOnEnterRules(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ie._serializeAutoClosingPairs(Q.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(fe,$,Ee),this._createDisposable(fe)}$setWordDefinitions(z){for(const $ of z)this._documents.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=Ie}),define(_e[356],ye([1,0,3,6,16]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,T=ze(T);class R{constructor(A){this._registeredTools=new Map,this._allTools=new Map,this._proxy=A.getProxy(d.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(p=>{for(const a of p)this._allTools.set(a.name,a)})}async invokeTool(A,p,a){return await this._proxy.$invokeTool(A,p,a)}async $acceptToolDelta(A){A.added&&this._allTools.set(A.added.name,A.added),A.removed&&this._allTools.delete(A.removed)}get tools(){return Array.from(this._allTools.values()).map(A=>T.LanguageModelToolDescription.to(A))}async $invokeTool(A,p,a){const I=this._registeredTools.get(A);if(!I)throw new Error(`Unknown tool ${A}`);return await I.tool.invoke(p,a)}registerTool(A,p,a){return this._registeredTools.set(p,{extension:A,tool:a}),this._proxy.$registerTool(p),(0,s.toDisposable)(()=>{this._registeredTools.delete(p),this._proxy.$unregisterTool(p)})}}e.ExtHostLanguageModelTools=R}),define(_e[129],ye([1,0,9,21,51,14,4,40,3,237,24,5,12,90,6,128,20,16,10,156,26]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,h=ze(h),g=ze(g),e.IExtHostLanguageModels=(0,_.createDecorator)("IExtHostLanguageModels");class i{constructor(v,y){this.option=v,this.stream=new s.AsyncIterableSource,this.stream=y??new s.AsyncIterableSource}}class r{constructor(){this._responseStreams=new Map,this._defaultStream=new s.AsyncIterableSource,this._isDone=!1;const v=this;this.apiObject={get stream(){return v._defaultStream.asyncIterable},get text(){return s.AsyncIterableObject.map(v._defaultStream.asyncIterable,y=>{if(y instanceof g.LanguageModelTextPart)return y.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,v]of this._responseStreams)yield v.stream;else yield this._defaultStream}handleFragment(v){if(this._isDone)return;let y=this._responseStreams.get(v.index);y||(this._responseStreams.size===0?y=new i(v.index,this._defaultStream):y=new i(v.index),this._responseStreams.set(v.index,y));let D;v.part.type==="text"?D=new g.LanguageModelTextPart(v.part.value):D=new g.LanguageModelFunctionUsePart(v.part.name,v.part.parameters),y.stream.emitOne(D)}reject(v){this._isDone=!0;for(const y of this._streams())y.reject(v)}resolve(){this._isDone=!0;for(const v of this._streams())v.resolve()}}let f=class{static{t=this}static{this._idPool=1}constructor(v,y,D){this._logService=y,this._extHostAuthentication=D,this._onDidChangeModelAccess=new L.Emitter,this._onDidChangeProviders=new L.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new I.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=v.getProxy(b.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(v,y,D,w){const P=t._idPool++;this._languageModels.set(P,{extension:v.identifier,provider:D,languageModelId:y});let k;w.auth&&(k={providerLabel:v.displayName||v.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(P,`${I.ExtensionIdentifier.toKey(v.identifier)}/${P}/${y}`,{extension:v.identifier,id:y,vendor:w.vendor??I.ExtensionIdentifier.toKey(v.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:k,targetExtensions:w.extensions});const E=D.onDidReceiveLanguageModelResponse2?.(({extensionId:S,participant:M,tokenCount:N})=>{this._proxy.$whenLanguageModelChatRequestMade(y,new I.ExtensionIdentifier(S),M,N)});return(0,p.toDisposable)(()=>{this._languageModels.delete(P),this._proxy.$unregisterProvider(P),E?.dispose()})}async $startChatRequest(v,y,D,w,P,k){const E=this._languageModels.get(v);if(!E)throw new Error("Provider not found");const S=new C.Progress(async N=>{if(k.isCancellationRequested){this._logService.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof g.LanguageModelFunctionUsePart?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof g.LanguageModelTextPart&&(O={type:"text",value:N.part.value}),!O){this._logService.warn(`[CHAT](${E.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this._proxy.$reportResponsePart(y,{index:N.index,part:O})});let M;if(E.provider.provideLanguageModelResponse2)M=Promise.resolve(E.provider.provideLanguageModelResponse2(w.map(h.LanguageModelChatMessage.to),P,I.ExtensionIdentifier.toKey(D),S,k));else{const N=new C.Progress(async O=>{S.report({index:O.index,part:new g.LanguageModelTextPart(O.part)})});M=Promise.resolve(E.provider.provideLanguageModelResponse(w.map(h.LanguageModelChatMessage.to),P?.modelOptions??{},I.ExtensionIdentifier.toKey(D),N,k))}M.then(()=>{this._proxy.$reportResponseDone(y,void 0)},N=>{this._proxy.$reportResponseDone(y,(0,R.transformErrorForSerialization)(N))})}$provideTokenLength(v,y,D){const w=this._languageModels.get(v);return w?Promise.resolve(w.provider.provideTokenCount(y,D)):Promise.resolve(0)}$acceptChatModelMetadata(v){if(v.added)for(const{identifier:y,metadata:D}of v.added)this._allLanguageModelData.set(y,{metadata:D,apiObjects:new I.ExtensionIdentifierMap});if(v.removed)for(const y of v.removed){this._allLanguageModelData.delete(y);for(const[D,w]of this._pendingRequest)w.languageModelId===y&&(w.res.reject(new R.CancellationError),this._pendingRequest.delete(D))}v.added?.forEach(y=>this._fakeAuthPopulate(y.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(v,y){const D=await this._proxy.$selectChatModels({...y,extension:v.identifier}),w=[],P=this;for(const k of D){const E=this._allLanguageModelData.get(k);if(!E)continue;this._isUsingAuth(v.identifier,E.metadata)&&await this._fakeAuthPopulate(E.metadata);let S=E.apiObjects.get(v.identifier);S||(S={id:k,vendor:E.metadata.vendor,family:E.metadata.family,version:E.metadata.version,name:E.metadata.name,maxInputTokens:E.metadata.maxInputTokens,countTokens(M,N){if(!P._allLanguageModelData.has(k))throw g.LanguageModelError.NotFound(k);return P._computeTokenLength(k,M,N??d.CancellationToken.None)},sendRequest(M,N,O){if(!P._allLanguageModelData.has(k))throw g.LanguageModelError.NotFound(k);return P._sendChatRequest(v,k,M,N??{},O??d.CancellationToken.None)}},Object.freeze(S),E.apiObjects.set(v.identifier,S)),w.push(S)}return w}async _sendChatRequest(v,y,D,w,P){const k=this._convertMessages(v,D),E=v.identifier,S=this._allLanguageModelData.get(y)?.metadata;if(!S||!this._allLanguageModelData.has(y))throw g.LanguageModelError.NotFound(`Language model '${y}' is unknown.`);if(this._isUsingAuth(E,S)&&(!await this._getAuthAccess(v,{identifier:S.extension,displayName:S.auth.providerLabel},w.justification,!1)||!this._modelAccessList.get(E)?.has(S.extension)))throw g.LanguageModelError.NoPermissions(`Language model '${y}' cannot be used by '${E.value}'.`);try{const M=Math.random()*1e6|0,N=new r;this._pendingRequest.set(M,{languageModelId:y,res:N});try{await this._proxy.$tryStartChatRequest(E,y,M,k,w,P)}catch(O){throw this._pendingRequest.delete(M),O}return N.apiObject}catch(M){throw M.name===g.LanguageModelError.name?M:new g.LanguageModelError(`Language model '${y}' errored: ${(0,T.toErrorMessage)(M)}`,"Unknown",M)}}_convertMessages(v,y){const D=[];for(const w of y)w.role===g.LanguageModelChatMessageRole.System&&(0,o.checkProposedApiEnabled)(v,"languageModelSystem"),w.content2 instanceof g.LanguageModelFunctionResultPart&&(0,o.checkProposedApiEnabled)(v,"lmTools"),D.push(h.LanguageModelChatMessage.from(w));return D}async $acceptResponsePart(v,y){const D=this._pendingRequest.get(v);D&&D.res.handleFragment(y)}async $acceptResponseDone(v,y){const D=this._pendingRequest.get(v);D&&(this._pendingRequest.delete(v),y?D.res.reject((0,R.transformErrorFromSerialization)(y)):D.res.resolve())}async _getAuthAccess(v,y,D,w){const P=n.INTERNAL_AUTH_PROVIDER_PREFIX+y.identifier.value;if(await this._extHostAuthentication.getSession(v,P,[],{silent:!0}))return this.$updateModelAccesslist([{from:v.identifier,to:y.identifier,enabled:!0}]),!0;if(w)return!1;try{const E=D?(0,a.localize)(0,null,y.displayName,D):void 0;return await this._extHostAuthentication.getSession(v,P,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:v.identifier,to:y.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(v,y){return!!y.auth&&!I.ExtensionIdentifier.equals(y.extension,v)}async _fakeAuthPopulate(v){if(v.auth)for(const y of this._languageAccessInformationExtensions)try{await this._getAuthAccess(y,{identifier:v.extension,displayName:""},void 0,!0)}catch(D){this._logService.error("Fake Auth request failed"),this._logService.error(D)}}async _computeTokenLength(v,y,D){if(!this._allLanguageModelData.get(v))throw g.LanguageModelError.NotFound(`Language model '${v}' is unknown.`);const P=A.Iterable.find(this._languageModels.values(),k=>k.languageModelId===v);return P?P.provider.provideTokenCount(y,D):this._proxy.$countTokens(v,typeof y=="string"?y:h.LanguageModelChatMessage.from(y),D)}$updateModelAccesslist(v){const y=new Array;for(const{from:D,to:w,enabled:P}of v){const k=this._modelAccessList.get(D)??new I.ExtensionIdentifierSet;if(k.has(w)!==P){P?k.add(w):k.delete(w),this._modelAccessList.set(D,k);const S={from:D,to:w};y.push(S),this._onDidChangeModelAccess.fire(S)}}}createLanguageModelAccessInformation(v){this._languageAccessInformationExtensions.add(v);const y=this,D=L.Event.signal(L.Event.filter(this._onDidChangeModelAccess.event,P=>I.ExtensionIdentifier.equals(P.from,v.identifier))),w=L.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return L.Event.any(D,w)},canSendRequest(P){let k;e:for(const[S,M]of y._allLanguageModelData)for(const N of M.apiObjects.values())if(N===P){k=M.metadata;break e}if(!k)return;if(!y._isUsingAuth(v.identifier,k))return!0;const E=y._modelAccessList.get(v.identifier);if(E)return E.has(k.extension)}}}};e.ExtHostLanguageModels=f,e.ExtHostLanguageModels=f=t=Xe([He(0,m.IExtHostRpcService),He(1,c.ILogService),He(2,l.IExtHostAuthentication)],f)});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[357],ye([1,0,6,16,10,44,9,3,26]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,d=ze(d),R=xt(R);class a{constructor(_,c,C,b){this._documents=c,this._commands=C,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=_.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(_){this._languageIds=_}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(_,c){await this._proxy.$changeLanguage(_,c);const C=this._documents.getDocumentData(_);if(!C)throw new Error(`document '${_.toString()}' NOT found`);return C.document}async tokenAtPosition(_,c){const C=_.version,b=d.Position.from(c),l=await this._proxy.$tokensAtPosition(_.uri,b),m={type:T.StandardTokenType.Other,range:_.getWordRangeAtPosition(c)??new T.Range(c.line,c.character,c.line,c.character)};if(!l)return m;const h={range:d.Range.to(l.range),type:d.TokenType.to(l.type)};return!h.range.contains(c)||C!==_.version?m:h}createLanguageStatusItem(_,c,C){const b=this._handlePool++,l=this._proxy,m=this._ids,h=`${_.identifier.value}/${c}`;if(m.has(h))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);m.add(h);const g={selector:C,id:c,name:_.displayName??_.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new A.DisposableStore,t=()=>{if(n?.dispose(),!m.has(h)){console.warn(`LanguageStatusItem (${c}) from ${_.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(b,{id:h,name:g.name??_.displayName??_.name,source:_.displayName??_.name,selector:d.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===T.LanguageStatusSeverity.Error?R.default.Error:g.severity===T.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:g.command&&this._commands.toInternal(g.command,o),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},i={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(b),m.delete(h)},get id(){return g.id},get name(){return g.name},set name(r){g.name=r,t()},get selector(){return g.selector},set selector(r){g.selector=r,t()},get text(){return g.text},set text(r){g.text=r,t()},set text2(r){(0,p.checkProposedApiEnabled)(_,"languageStatusText"),g.text=r,t()},get text2(){return(0,p.checkProposedApiEnabled)(_,"languageStatusText"),g.text},get detail(){return g.detail},set detail(r){g.detail=r,t()},get severity(){return g.severity},set severity(r){g.severity=r,t()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(r){g.accessibilityInformation=r,t()},get command(){return g.command},set command(r){g.command=r,t()},get busy(){return g.busy},set busy(r){g.busy=r,t()}};return t(),i}}e.ExtHostLanguages=a}),define(_e[358],ye([1,0,15,2,16,10,127]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,T=ze(T),L=ze(L);class A{constructor(_,c,C,b){this.start=_,this.deletedCount=c,this.deletedItems=C,this.items=b}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1}}constructor(_,c,C){this.notebook=_,this._extHostDocument=c,this._cellData=C,this.handle=C.handle,this.uri=d.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return _._mime},set mime(b){_._mime=b},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(_){this._outputs=_.map(T.NotebookCellOutput.to)}setOutputItems(_,c,C){const b=C.map(T.NotebookCellOutputItem.to),l=this._outputs.find(m=>m.id===_);if(l&&(c||(l.items.length=0),l.items.push(...b),l.items.length>1&&l.items.every(m=>L.isTextStreamMime(m.mime)))){const m=new Map,h=[];l.items.forEach(g=>{let n;m.has(g.mime)?n=m.get(g.mime):(n=[],m.set(g.mime,n),h.push(g.mime)),n.push(g.data)}),l.items.length=0,h.forEach(g=>{const n=L.compressOutputItemStreams(m.get(g));l.items.push({mime:g,data:n.data.buffer})})}}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=p;class a{static{this._handlePool=0}constructor(_,c,C,b,l){this._proxy=_,this._textDocumentsAndEditors=c,this._textDocuments=C,this.uri=b,this.handle=a._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const _=this,c={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===s.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(C){return C=_._validateIndex(C),_._cells[C].apiCell},getCells(C){return(C?_._getCells(C):_._cells).map(l=>l.apiCell)},save(){return _._save()}};this._notebook=Object.freeze(c)}return this._notebook}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,c,C){this._versionId=_.versionId,this._isDirty=c,this.acceptDocumentPropertiesChanged({metadata:C});const b={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},l=[];for(const h of _.rawEvents)h.kind===L.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,b.contentChanges):h.kind===L.NotebookCellsChangeType.Move?this._moveCells(h.index,h.length,h.newIdx,b.contentChanges):h.kind===L.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),l.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===L.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),l.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),l.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===L.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===L.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),l.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),l.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const m=new Map;for(let h=0;h<l.length;h++){const g=l[h],n=m.get(g.cell);if(n===void 0){const o=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});m.set(g.cell,o-1)}else b.cellChanges[n]={...b.cellChanges[n],...g}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let c=_.start|0,C=_.end|0;return c<0&&(c=0),C>this._cells.length&&(C=this._cells.length),_.with({start:c,end:C})}_getCells(_){_=this._validateRange(_);const c=[];for(let C=_.start;C<_.end;C++)c.push(this._cells[C]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,c,C){if(this._disposed)return;const b=[],l=[],m=[];if(_.reverse().forEach(h=>{const n=h[2].map(i=>{const r=new p(this,this._textDocumentsAndEditors,i);return c||l.push(p.asModelAddData(i)),r}),o=new A(h[0],h[1],[],n),t=this._cells.splice(h[0],h[1],...n);for(const i of t)m.push(i.uri),o.deletedItems.push(i.apiCell);b.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:m}),C)for(const h of b)C.push(h.asApiEvent())}_moveCells(_,c,C,b){const l=this._cells.splice(_,c);this._cells.splice(C,0,...l);const m=[new A(_,c,l.map(h=>h.apiCell),[]),new A(C,0,[],l)];for(const h of m)b.push(h.asApiEvent())}_setCellOutputs(_,c){this._cells[_].setOutputs(c)}_setCellOutputItems(_,c,C,b){this._cells[_].setOutputItems(c,C,b)}_changeCellLanguage(_,c){const C=this._cells[_];C.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(C.uri,c)}_changeCellMime(_,c){const C=this._cells[_];C.apiCell.mime=c}_changeCellMetadata(_,c){this._cells[_].setMetadata(c)}_changeCellInternalMetadata(_,c){this._cells[_].setInternalMetadata(c)}getCellFromApiCell(_){return this._cells.find(c=>c.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(c=>c.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=a}),define(_e[359],ye([1,0,4,2,16,10,52]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(a,I,_,c={timeout:1500,errors:3}){this._logService=a,this._notebooksAndEditors=I,this._mainThreadBulkEdits=_,this._thresholds=c,this._onWillSaveNotebookDocumentEvent=new s.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(I,_,c)=>{const C=function(l){I.call(_,l)};return C.extension=a,this._onWillSaveNotebookDocumentEvent.event(C,void 0,c)}}async $participateInSave(a,I,_){const c=d.URI.revive(a),C=this._notebooksAndEditors.getNotebookDocument(c);if(!C)throw new Error("Unable to resolve notebook document");const b=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:C.apiNotebook,reason:T.TextDocumentSaveReason.to(I)},_,async(m,h)=>{const g=Date.now(),n=await await Promise.resolve(m);Date.now()-g>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!_.isCancellationRequested&&n&&(n instanceof R.WorkspaceEdit?b.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),_.isCancellationRequested)return!1;if(b.length===0)return!0;const l={edits:[]};for(const m of b){const{edits:h}=T.WorkspaceEdit.from(m);l.edits=l.edits.concat(h)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new L.SerializableObjectWithBuffers(l))}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(_e[165],ye([1,0,14,16,10]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,d=ze(d),T=ze(T);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(A,p,a,I,_,c){this.id=A,this._proxy=p,this.notebookData=a,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=I,this._viewColumn=c}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(p){this.selections=[p]},get selections(){return A._selections},set selections(p){if(!Array.isArray(p)||!p.every(T.NotebookRange.isNotebookRange))throw(0,s.illegalArgument)("selections");A._selections=p,A._trySetSelections(p)},get visibleRanges(){return A._visibleRanges},revealRange(p,a){A._proxy.$tryRevealRange(A.id,d.NotebookRange.from(p),a??T.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(d.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=R}),define(_e[360],ye([1,0,4,12,16]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,T=ze(T);let R=class{constructor(A,p){this._logService=A,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,p);const a=this._notebooksAndEditors.getEditorById(A);p.visibleRanges&&a._acceptVisibleRanges(p.visibleRanges.ranges.map(T.NotebookRange.to)),p.selections&&a._acceptSelections(p.selections.selections.map(T.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const p in A)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(T.ViewColumn.to(A[p]))}};e.ExtHostNotebookEditors=R,e.ExtHostNotebookEditors=R=Xe([He(0,d.ILogService)],R)}),define(_e[361],ye([1,0,4,6,165]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,p){this._extHostNotebook=p,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(d.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,p,a){const I=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(p)?.fire({editor:I.apiEditor,message:a})}createRendererMessaging(A,p){if(!A.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,_,c)=>this.getOrCreateEmitterFor(p).event(I,_,c),postMessage:(I,_)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(I)&&([I,_]=[_,I]);const c=_&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(c?.id,p,I)}}}getOrCreateEmitterFor(A){let p=this._rendererMessageEmitters.get(A);return p||(p=new s.Emitter({onDidRemoveLastListener:()=>{p?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,p),p)}}e.ExtHostNotebookRenderers=R}),define(_e[362],ye([1,0,16,90,21,59,14]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,c,C){const b=this._handles++,{title:l,location:m,cancellable:h}=c,g={label:_.displayName||_.name,id:_.identifier.value};return this._proxy.$startProgress(b,{location:s.ProgressLocation.from(m),title:l,source:g,cancellable:h},_.isUnderDevelopment?void 0:_.identifier.value).catch(L.onUnexpectedExternalError),this._withProgress(b,C,!!h)}_withProgress(_,c,C){let b;C&&(b=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,b));const l=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),b?.dispose()};let m;try{m=c(new a(this._proxy,_),C&&b?b.token:T.CancellationToken.None)}catch(h){throw l(_),h}return m.then(h=>l(_),h=>l(_)),m}$acceptProgressCanceled(_){const c=this._mapHandleToCancellationSource.get(_);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=A;function p(I,_){return I.message=_.message,typeof _.increment=="number"&&(typeof I.increment=="number"?I.increment+=_.increment:I.increment=_.increment),I}class a extends d.Progress{constructor(_,c){super(C=>this.throttledReport(C)),this._proxy=_,this._handle=c}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Xe([(0,R.throttle)(100,(I,_)=>p(I,_),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(_e[363],ye([1,0,2,6,9,16]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class L{static{this.handlePool=0}constructor(p,a){this.uriTransformer=a,this.providers=new Map,this.proxy=p.getProxy(d.MainContext.MainThreadQuickDiff)}$provideOriginalResource(p,a,I){const _=s.URI.revive(a),c=this.providers.get(p);return c?(0,T.asPromise)(()=>c.provideOriginalResource(_,I)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(p,a,I,_){const c=L.handlePool++;return this.providers.set(c,a),this.proxy.$registerQuickDiffProvider(c,R.DocumentSelector.from(p,this.uriTransformer),I,_),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(c),this.providers.delete(c)}}}}e.ExtHostQuickDiff=L});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[364],ye([1,0,21,4,3,6,2,10,14,19,44,50,26,16]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=b,I=xt(I);function b(l,m,h){const g=l.getProxy(R.MainContext.MainThreadQuickOpen);class n{constructor(D,w){this._sessions=new Map,this._instances=0,this._workspace=D,this._commands=w}showQuickPick(D,w,P,k=s.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(w),S=++this._instances,M=g.$show(S,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},k),N={},O=M.then(()=>N);return Promise.race([O,E]).then(x=>{if(x===N)return;const U=(0,c.isProposedApiEnabled)(D,"quickPickItemTooltip");return E.then(F=>{const H=[];for(let j=0;j<F.length;j++){const re=F[j];if(typeof re=="string")H.push({label:re,handle:j});else if(re.kind===A.QuickPickItemKind.Separator)H.push({type:"separator",label:re.label});else{re.tooltip&&!U&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const B=re.iconPath?f(re.iconPath):void 0;H.push({label:re.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:U?C.MarkdownString.fromStrict(re.tooltip):void 0,handle:j})}}return P&&typeof P.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{P.onDidSelectItem(F[j])}),g.$setItems(S,H),M.then(j=>{if(typeof j=="number")return F[j];if(Array.isArray(j))return j.map(re=>F[re])})})}).then(void 0,x=>{if(!(0,p.isCancellationError)(x))return g.$setError(S,x),Promise.reject(x)})}$onItemSelected(D){this._onDidSelectItem?.(D)}showInput(D,w=s.CancellationToken.None){return this._validateInput=D?.validateInput,g.$input(D,typeof this._validateInput=="function",w).then(void 0,P=>{if(!(0,p.isCancellationError)(P))return Promise.reject(P)})}async $validateInput(D){if(!this._validateInput)return;const w=await this._validateInput(D);if(!w||typeof w=="string")return w;let P;switch(w.severity){case A.InputBoxValidationSeverity.Info:P=I.default.Info;break;case A.InputBoxValidationSeverity.Warning:P=I.default.Warning;break;case A.InputBoxValidationSeverity.Error:P=I.default.Error;break;default:P=w.message?I.default.Error:I.default.Ignore;break}return{content:w.message,severity:P}}async showWorkspaceFolderPick(D,w=s.CancellationToken.None){const P=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!P)return;const k=await this._workspace.getWorkspaceFolders2();if(k)return k.find(E=>E.uri.toString()===P.uri.toString())}createQuickPick(D){const w=new u(D,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(D){const w=new v(D,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(D,w){this._sessions.get(D)?._fireDidChangeValue(w)}$onDidAccept(D){this._sessions.get(D)?._fireDidAccept()}$onDidChangeActive(D,w){const P=this._sessions.get(D);P instanceof u&&P._fireDidChangeActive(w)}$onDidChangeSelection(D,w){const P=this._sessions.get(D);P instanceof u&&P._fireDidChangeSelection(w)}$onDidTriggerButton(D,w){this._sessions.get(D)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(D,w,P){const k=this._sessions.get(D);k instanceof u&&k._fireDidTriggerItemButton(w,P)}$onDidHide(D){this._sessions.get(D)?._fireDidHide()}}class o{static{this._nextId=1}constructor(D,w){this._extensionId=D,this._onDidDispose=w,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new d.Emitter,this._onDidChangeValueEmitter=new d.Emitter,this._onDidTriggerButtonEmitter=new d.Emitter,this._onDidHideEmitter=new d.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(D){this._title=D,this.update({title:D})}get step(){return this._steps}set step(D){this._steps=D,this.update({step:D})}get totalSteps(){return this._totalSteps}set totalSteps(D){this._totalSteps=D,this.update({totalSteps:D})}get enabled(){return this._enabled}set enabled(D){this._enabled=D,this.update({enabled:D})}get busy(){return this._busy}set busy(D){this._busy=D,this.update({busy:D})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(D){this._ignoreFocusOut=D,this.update({ignoreFocusOut:D})}get value(){return this._value}set value(D){this._value=D,this.update({value:D})}get placeholder(){return this._placeholder}set placeholder(D){this._placeholder=D,this.update({placeholder:D})}get buttons(){return this._buttons}set buttons(D){this._buttons=D.slice(),this._handlesToButtons.clear(),D.forEach((w,P)=>{const k=w===A.QuickInputButtons.Back?-1:P;this._handlesToButtons.set(k,w)}),this.update({buttons:D.map((w,P)=>({...f(w.iconPath),tooltip:w.tooltip,handle:w===A.QuickInputButtons.Back?-1:P}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(D){this._value=D,this._onDidChangeValueEmitter.fire(D)}_fireDidTriggerButton(D){const w=this._handlesToButtons.get(D);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(D){if(!this._disposed){for(const w of Object.keys(D)){const P=D[w];this._pendingUpdate[w]=P===void 0?null:P}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(y){if(y instanceof A.ThemeIcon)return{id:y.id};const D=r(y),w=i(y);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof w=="string"?L.URI.file(w):w}}function i(y){return typeof y=="object"&&"light"in y?y.light:y}function r(y){return typeof y=="object"&&"dark"in y?y.dark:y}function f(y){const D=t(y);let w,P;return"id"in D?P=_.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:P}}class u extends o{constructor(D,w){super(D.identifier,w),this.extension=D,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new d.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new d.Emitter,this._onDidTriggerItemButtonEmitter=new d.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(D){this._items=D.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),D.forEach((k,E)=>{this._handlesToItems.set(E,k),this._itemsToHandles.set(k,E)});const w=(0,c.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),P=[];for(let k=0;k<D.length;k++){const E=D[k];if(E.kind===A.QuickPickItemKind.Separator)P.push({type:"separator",label:E.label});else{E.tooltip&&!w&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const S=E.iconPath?f(E.iconPath):void 0;P.push({handle:k,label:E.label,iconPath:S?.iconPath,iconClass:S?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:w?C.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((M,N)=>({...f(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.update({items:P})}get canSelectMany(){return this._canSelectMany}set canSelectMany(D){this._canSelectMany=D,this.update({canSelectMany:D})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(D){this._matchOnDescription=D,this.update({matchOnDescription:D})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(D){this._matchOnDetail=D,this.update({matchOnDetail:D})}get sortByLabel(){return this._sortByLabel}set sortByLabel(D){this._sortByLabel=D,this.update({sortByLabel:D})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(D){this._keepScrollPosition=D,this.update({keepScrollPosition:D})}get activeItems(){return this._activeItems}set activeItems(D){this._activeItems=D.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(D){this._selectedItems=D.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(D){const w=(0,a.coalesce)(D.map(P=>this._handlesToItems.get(P)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(D){const w=(0,a.coalesce)(D.map(P=>this._handlesToItems.get(P)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(D,w){const P=this._handlesToItems.get(D);if(!P||!P.buttons||!P.buttons.length)return;const k=P.buttons[w];k&&this._onDidTriggerItemButtonEmitter.fire({button:k,item:P})}}class v extends o{constructor(D,w){super(D.identifier,w),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(D){this._password=D,this.update({password:D})}get prompt(){return this._prompt}set prompt(D){this._prompt=D,this.update({prompt:D})}get valueSelection(){return this._valueSelection}set valueSelection(D){this._valueSelection=D,this.update({valueSelection:D})}get validationMessage(){return this._validationMessage}set validationMessage(D){this._validationMessage=D,D?typeof D=="string"?this.update({validationMessage:D,severity:I.default.Error}):this.update({validationMessage:D.message,severity:D.severity??I.default.Error}):this.update({validationMessage:void 0,severity:I.default.Ignore})}}return new n(m,h)}}),define(_e[365],ye([1,0,2,4,59,3,9,6,19,140,12,24,41,50,16,26,15,11]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(N){return N instanceof s.URI}function o(N,O){return N.scheme===m.Schemas.file&&O.scheme===m.Schemas.file&&h.isLinux?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?s.URI.file(N.iconPath):s.URI.isUri(N.iconPath)||C.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function i(N){if(N){if(s.URI.isUri(N))return N;if(C.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function r(N){const O=i(N.icon),x=N.labels?.map(U=>({title:U.title,icon:i(U.icon)}));return{...N,icon:O,labels:x}}function f(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const x=typeof N.iconPath=="string"?N.iconPath:s.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,U=typeof O.iconPath=="string"?O.iconPath:s.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,a.comparePaths)(x,U)}function u(N,O){let x=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(x=f(N,O),x!==0)return x;if(N.light&&O.light)x=f(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(x!==0)return x;if(N.dark&&O.dark)x=f(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return x}function v(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let x=0;x<N.arguments.length;x++){const U=N.arguments[x],F=O.arguments[x];if(U!==F&&!(n(U)&&n(F)&&o(U,F)))return U<F?-1:1}return 0}function y(N,O){let x=(0,a.comparePaths)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(x!==0)return x;if(N.command&&O.command)x=v(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(x!==0)return x;if(N.decorations&&O.decorations)x=u(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)x=(0,a.comparePaths)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)x=(0,a.comparePaths)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return x}function D(N,O){for(let x=0;x<N.length;x++)if(N[x]!==O[x])return!1;return!0}function w(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?D(N.arguments,O.arguments):N.arguments===O.arguments)}function P(N,O){return(0,p.equals)(N,O,w)}class k{#e;#t;get value(){return this._value}set value(O){O=O??"",this.#e.$setInputBoxValue(this._sourceControlHandle,O),this.updateValue(O)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(O){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,O),this._placeholder=O}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(O){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=O,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!O)}get enabled(){return this._enabled}set enabled(O){O=!!O,this._enabled!==O&&(this._enabled=O,this.#e.$setInputBoxEnablement(this._sourceControlHandle,O))}get visible(){return this._visible}set visible(O){O=!!O,this._visible!==O&&(this._visible=O,this.#e.$setInputBoxVisibility(this._sourceControlHandle,O))}get document(){return(0,l.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(O,x,U,F,H){this._extension=O,this._sourceControlHandle=F,this._documentUri=H,this._value="",this._onDidChange=new d.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=x,this.#e=U}showValidationMessage(O,x){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,O,x)}$onInputBoxValueChange(O){this.updateValue(O)}updateValue(O){this._value=O,this._onDidChange.fire(O)}}e.ExtHostSCMInputBox=k;class E{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(O){this._label=O,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,O)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(O){this._hideWhenEmpty=O,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(O){this._resourceStates=[...O],this._onDidUpdateResourceStates.fire()}constructor(O,x,U,F,H,j,re){this._proxy=O,this._commands=x,this._sourceControlHandle=U,this._id=F,this._label=H,this.multiDiffEditorEnableViewChanges=j,this._extension=re,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new d.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new d.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=E._handlePool++}getResourceState(O){return this._resourceStatesMap.get(O)}$executeResourceCommand(O,x){const U=this._resourceStatesCommandsMap.get(O);return U?(0,L.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],x)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this._resourceStates].sort(y),U=(0,p.sortedDiff)(this._resourceSnapshot,O,y).map(j=>{const re=j.toInsert.map(B=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,B);const X=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const oe=new R.DisposableStore;ee=this._commands.converter.toInternal(B.command,oe),this._resourceStatesDisposablesMap.set(V,oe)}else this._resourceStatesCommandsMap.set(V,B.command);const he=(0,l.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ne=he?B.multiDiffEditorOriginalUri:void 0,De=he?B.multiFileDiffEditorModifiedUri:void 0,pe=t(B.decorations),G=B.decorations&&t(B.decorations.light)||pe,W=B.decorations&&t(B.decorations.dark)||pe,se=[G,W],ae=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,ce=B.decorations&&!!B.decorations.faded,ue=B.contextValue||"";return{rawResource:[V,X,se,ae,te,ce,ue,ee,ne,De],handle:V}});return{start:j.start,deleteCount:j.deleteCount,toInsert:re}}),F=U.map(({start:j,deleteCount:re,toInsert:B})=>[j,re,B.map(V=>V.rawResource)]),H=U.reverse();for(const{start:j,deleteCount:re,toInsert:B}of H){const V=B.map(ee=>ee.handle),X=this._handlesSnapshot.splice(j,re,...V);for(const ee of X)this._resourceStatesMap.delete(ee),this._resourceStatesCommandsMap.delete(ee),this._resourceStatesDisposablesMap.get(ee)?.dispose(),this._resourceStatesDisposablesMap.delete(ee)}return this._resourceSnapshot=O,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class S{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(O){this._count!==O&&(this._count=O,this.#e.$updateSourceControl(this.handle,{count:O}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(O){this._quickDiffProvider=O;let x;(0,l.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(x=O?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!O,quickDiffLabel:x})}get historyProvider(){return(0,l.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(O){(0,l.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=O,this._historyProviderDisposable.value=new R.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!O}),O&&this._historyProviderDisposable.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(O){O!==this._commitTemplate&&(this._commitTemplate=O,this.#e.$updateSourceControl(this.handle,{commitTemplate:O}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(O){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=O;const x=this._commands.converter.toInternal(O,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:x})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(O){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=O;const x=O!==void 0?{command:this._commands.converter.toInternal(O.command,this._actionButtonDisposables.value),secondaryCommands:O.secondaryCommands?.map(U=>U.map(F=>this._commands.converter.toInternal(F,this._actionButtonDisposables.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:x??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(O){if(this.logService.trace("ExtHostSourceControl#statusBarCommands",(O??[]).map(U=>U.command).join(", ")),this._statusBarCommands&&O&&P(this._statusBarCommands,O)){this.logService.trace("ExtHostSourceControl#statusBarCommands are equal");return}this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=O;const x=(O||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:x})}get selected(){return this._selected}constructor(O,x,U,F,H,j,re,B){this._extension=O,this._commands=F,this.logService=H,this._id=j,this._label=re,this._rootUri=B,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new R.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new d.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=S._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=U;const V=s.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${j}/scm${this.handle}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this._inputBox=new k(O,x,this.#e,this.handle,V),this.#e.$registerSourceControl(this.handle,j,re,B,V)}createResourceGroup(O,x,U){const F=(0,l.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&U?.multiDiffEditorEnableViewChanges===!0,H=new E(this.#e,this._commands,this.handle,O,x,F,this._extension),j=d.Event.once(H.onDidDispose)(()=>this.createdResourceGroups.delete(H));return this.createdResourceGroups.set(H,j),this.eventuallyAddResourceGroups(),H}eventuallyAddResourceGroups(){const O=[],x=[];for(const[U,F]of this.createdResourceGroups){F.dispose();const H=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});d.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),H.dispose(),this._groups.delete(U.handle),this.#e.$unregisterGroup(this.handle,U.handle)}),O.push([U.handle,U.id,U.label,U.features,U.multiDiffEditorEnableViewChanges]);const j=U._takeResourceStateSnapshot();j.length>0&&x.push([U.handle,j]),this._groups.set(U.handle,U)}this.#e.$registerGroups(this.handle,O,x),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const O=[];this.updatedResourceGroups.forEach(x=>{const U=x._takeResourceStateSnapshot();U.length!==0&&O.push([x.handle,U])}),O.length>0&&this.#e.$spliceResourceStates(this.handle,O),this.updatedResourceGroups.clear()}getResourceGroup(O){return this._groups.get(O)}setSelectionState(O){this._selected=O,this._onDidChangeSelection.fire(O)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Xe([(0,T.debounce)(100)],S.prototype,"eventuallyAddResourceGroups",null),Xe([(0,T.debounce)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{g=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(O,x,U,F){this._commands=x,this._extHostDocuments=U,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new _.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new d.Emitter,this._proxy=O.getProxy(A.MainContext.MainThreadSCM),this._telemetry=O.getProxy(A.MainContext.MainThreadTelemetry),x.registerArgumentProcessor({processArgument:H=>{if(H&&H.$mid===c.MarshalledId.ScmResource){const j=this._sourceControls.get(H.sourceControlHandle);if(!j)return H;const re=j.getResourceGroup(H.groupHandle);return re?re.getResourceState(H.handle):H}else if(H&&H.$mid===c.MarshalledId.ScmResourceGroup){const j=this._sourceControls.get(H.sourceControlHandle);return j?j.getResourceGroup(H.groupHandle):H}else if(H&&H.$mid===c.MarshalledId.ScmProvider){const j=this._sourceControls.get(H.handle);return j||H}return H}})}createSourceControl(O,x,U,F){this.logService.trace("ExtHostSCM#createSourceControl",O.identifier.value,x,U,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const H=g._handlePool++,j=new S(O,this._extHostDocuments,this._proxy,this._commands,this.logService,x,U,F);this._sourceControls.set(H,j);const re=this._sourceControlsByExtension.get(O.identifier)||[];return re.push(j),this._sourceControlsByExtension.set(O.identifier,re),j}getLastInputBox(O){this.logService.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const x=this._sourceControlsByExtension.get(O.identifier),U=x&&x[x.length-1];return U&&U.inputBox}$provideOriginalResource(O,x,U){const F=s.URI.revive(x);this.logService.trace("ExtHostSCM#$provideOriginalResource",O,F.toString());const H=this._sourceControls.get(O);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(F,U)).then(j=>j||null)}$onInputBoxValueChange(O,x){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",O);const U=this._sourceControls.get(O);return U&&U.inputBox.$onInputBoxValueChange(x),Promise.resolve(void 0)}$executeResourceCommand(O,x,U,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",O,x,U);const H=this._sourceControls.get(O);if(!H)return Promise.resolve(void 0);const j=H.getResourceGroup(x);return j?j.$executeResourceCommand(U,F):Promise.resolve(void 0)}$validateInput(O,x,U){this.logService.trace("ExtHostSCM#$validateInput",O);const F=this._sourceControls.get(O);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,L.asPromise)(()=>F.inputBox.validateInput(x,U)).then(H=>{if(!H)return Promise.resolve(void 0);const j=b.MarkdownString.fromStrict(H.message);return j?Promise.resolve([j,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this._sourceControls.get(O)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,x,U,F){return await this._sourceControls.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(x,U,F)??void 0}async $provideHistoryItems(O,x,U,F){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems(x,U,F))?.map(re=>r(re))??void 0}async $provideHistoryItems2(O,x,U){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems2(x,U))?.map(j=>r(j))??void 0}async $provideHistoryItemSummary(O,x,U,F){const H=this._sourceControls.get(O)?.historyProvider;if(typeof H?.provideHistoryItemSummary!="function")return;const j=await H.provideHistoryItemSummary(x,U,F);return j?r(j):void 0}async $provideHistoryItemChanges(O,x,U,F){return await this._sourceControls.get(O)?.historyProvider?.provideHistoryItemChanges(x,U,F)??void 0}};e.ExtHostSCM=M,e.ExtHostSCM=M=g=Xe([He(3,I.ILogService)],M)}),define(_e[366],ye([1,0,6,16,2]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class R{static{this.handlePool=0}constructor(A,p){this.uriTransformer=p,this.providers=new Map,this.proxy=A.getProxy(s.MainContext.MainThreadShare)}async $provideShare(A,p,a){return await this.providers.get(A)?.provideShare({selection:d.Range.to(p.selection),resourceUri:T.URI.revive(p.resourceUri)},a)??void 0}registerShareProvider(A,p){const a=R.handlePool++;return this.providers.set(a,p),this.proxy.$registerShareProvider(a,d.DocumentSelector.from(A,this.uriTransformer),p.id,p.label,p.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(a),this.providers.delete(a)}}}}e.ExtHostShare=R}),define(_e[367],ye([1,0,10,6,240,3,16,18]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class p{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(c,C,b,l,m,h=s.StatusBarAlignment.Left,g){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,this.#e=c,this.#t=C,m&&l){this._entryId=(0,s.asStatusBarItemIdentifier)(l.identifier,m);const n=b.get(this._entryId);n&&(h=n.alignLeft?s.StatusBarAlignment.Left:s.StatusBarAlignment.Right,g=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(p.ID_GEN++);this._extension=l,this._id=m,this._alignment=h,this._priority=this.validatePriority(g)}validatePriority(c){if((0,A.isNumber)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!p.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){this._command?.fromApi!==c&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof c=="string"?this._command={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this._latestCommandRegistration)}:c?this._command={fromApi:c,internal:this.#t.toInternal(c,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let C;this._name?C=this._name:C=(0,T.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=p.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=L.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,c,this._extension?.identifier.value,C,this._text,l,this._command?.internal,b,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=p;class a{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,T.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const C={message:c};return this._messages.unshift(C),this._update(),new s.Disposable(()=>{const b=this._messages.indexOf(C);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(c,C){this._existingItems=new Map,this._proxy=c.getProxy(d.MainContext.MainThreadStatusBar),this._commands=C,this._statusMessage=new a(this)}$acceptStaticEntries(c){for(const C of c)this._existingItems.set(C.entryId,C)}createStatusBarEntry(c,C,b,l){return new p(this._proxy,this._commands,this._existingItems,c,C,b,l)}setStatusBarMessage(c,C){const b=this._statusMessage.setMessage(c);let l;return typeof C=="number"?l=setTimeout(()=>b.dispose(),C):typeof C<"u"&&C.then(()=>b.dispose(),()=>b.dispose()),new s.Disposable(()=>{b.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=I}),define(_e[166],ye([1,0,31,155,74,121,75,16,2]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,s=ze(s),A=ze(A);const a=(n,o,t,i)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(f){if(!t(r,f)){const u=r;r=f,n.listener?.(i(f,u))}}}},I=(n,o)=>n===o,_={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(t=>!o.find(i=>t.id===i.id)))},c=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),C=(n,o)=>({range:(()=>{let t;const i=c(r=>({range:s.Range.lift(A.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return t},set(r){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),_.range(t,r)||(t=r,n.listener?.(i(r)))}}})(),label:a(n,o,_.label,c(t=>({label:t}))),description:a(n,void 0,_.description,c(t=>({description:t}))),sortText:a(n,void 0,_.sortText,c(t=>({sortText:t}))),canResolveChildren:a(n,!1,_.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(n,!1,_.busy,c(t=>({busy:t}))),error:a(n,void 0,_.error,c(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:a(n,[],_.tags,(t,i)=>({op:R.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),b=n=>{const o=T.TestId.fromString(n.extId),t=new m(o.controllerId,o.localId,n.label,p.URI.revive(n.uri)||void 0);return t.range=A.Range.to(n.range||void 0),t.description=n.description||void 0,t.sortText=n.sortText||void 0,t.tags=n.tags.map(i=>A.TestTag.to({id:(0,L.denamespaceTestTag)(i).tagId})),t},l=n=>{let o;for(const t of n.tests){const i=b(t.item);(0,d.getPrivateApiFor)(i).parent=o,o=i}return o};e.toItemFromContext=l;class m{constructor(o,t,i,r){if(t.includes(T.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const f=(0,d.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof h?void 0:f.parent}},children:{value:(0,R.createTestItemChildren)(f,d.getPrivateApiFor,m),enumerable:!0,writable:!1},...C(f,i)})}}e.TestItemImpl=m;class h extends m{constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class g extends R.TestItemCollection{constructor(o,t,i){super({controllerId:o,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:d.getPrivateApiFor,getChildren:r=>r.children,root:new h(o,t),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(_e[35],ye([1,0,18,10,16,25,6,19,12,57,31,54,2,3,5,20,166,22,52,51,43,92,95,32]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,d=ze(d),T=ze(T);let f=class{#e;#t;#i;constructor(P,k,E){this._commands=new Map,this._apiCommands=new Map,this.#e=P.getProxy(L.MainContext.MainThreadCommands),this._logService=k,this.#i=E,this.#t=P.getProxy(L.MainContext.MainThreadTelemetry),this.converter=new u(this,S=>{const M=this._apiCommands.get(S);return M?.result===y.Void?M:void 0},k),this._argumentProcessors=[{processArgument(S){return(0,a.revive)(S)}},{processArgument(S){return(0,R.cloneAndChange)(S,function(M){if(I.Range.isIRange(M))return T.Range.to(M);if(_.Position.isIPosition(M))return T.Position.to(M);if(I.Range.isIRange(M.range)&&c.URI.isUri(M.uri))return T.location.to(M);if(M instanceof h.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(P){this._argumentProcessors.push(P)}registerApiCommand(P){const k=this.registerCommand(!1,P.id,async(...E)=>{const S=P.args.map((N,O)=>{if(!N.validate(E[O]))throw new Error(`Invalid argument '${N.name}' when running '${P.id}', received: ${typeof E[O]=="object"?JSON.stringify(E[O],null,"	"):E[O]} `);return N.convert(E[O])}),M=await this.executeCommand(P.internalId,...S);return P.result.convert(M,E,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this._apiCommands.set(P.id,P),new d.Disposable(()=>{k.dispose(),this._apiCommands.delete(P.id)})}registerCommand(P,k,E,S,M,N){if(this._logService.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this._commands.has(k))throw new Error(`command '${k}' already exists`);return this._commands.set(k,{callback:E,thisArg:S,metadata:M,extension:N}),P&&this.#e.$registerCommand(k),new d.Disposable(()=>{this._commands.delete(k)&&P&&this.#e.$unregisterCommand(k)})}executeCommand(P,...k){return this._logService.trace("ExtHostCommands#executeCommand",P),this._doExecuteCommand(P,k,!0)}async _doExecuteCommand(P,k,E){if(this._commands.has(P))return this.#e.$fireCommandActivationEvent(P),this._executeContributedCommand(P,k,!1);{let S=!1;const M=(0,R.cloneAndChange)(k,function(N){if(N instanceof d.Position)return T.Position.from(N);if(N instanceof d.Range)return T.Range.from(N);if(N instanceof d.Location)return T.location.from(N);if(d.NotebookRange.isNotebookRange(N))return T.NotebookRange.from(N);if(N instanceof ArrayBuffer)return S=!0,h.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return S=!0,h.VSBuffer.wrap(N);if(N instanceof h.VSBuffer)return S=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(P,S?new g.SerializableObjectWithBuffers(M):M,E);return(0,a.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(P,k,!1);throw N}}}async _executeContributedCommand(P,k,E){const S=this._commands.get(P);if(!S)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:O}=S;if(O?.args)for(let U=0;U<O.args.length;U++)try{(0,s.validateConstraint)(k[U],O.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${O.args[U].name}' - ${O.args[U].description}`)}const x=o.StopWatch.create();try{return await M.apply(N,k)}catch(U){if(P===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(P=F.command)}if(this._logService.error(U,P,S.extension?.identifier),!E)throw U;if(S.extension?.identifier){const F=this.#i.onExtensionError(S.extension.identifier,U);this._logService.trace("forwarded error to extension?",F,S.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(U)),this.id=P,this.source=S.extension?.displayName??S.extension?.name}}}finally{this._reportTelemetry(S,P,x.elapsed())}}_reportTelemetry(P,k,E){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new t.TelemetryTrustedValue(k),duration:E})}$executeContributedCommand(P,...k){this._logService.trace("ExtHostCommands#$executeContributedCommand",P);const E=this._commands.get(P);return E?(k=k.map(S=>this._argumentProcessors.reduce((M,N)=>N.processArgument(M,E.extension?.identifier),S)),this._executeContributedCommand(P,k,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this._logService.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(k=>(P&&(k=k.filter(E=>E[0]!=="_")),k))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[k,E]of this._commands){const{metadata:S}=E;S&&(P[k]=S)}return Promise.resolve(P)}};e.ExtHostCommands=f,e.ExtHostCommands=f=Xe([He(0,l.IExtHostRpcService),He(1,p.ILogService),He(2,i.IExtHostTelemetry)],f),e.IExtHostCommands=(0,b.createDecorator)("IExtHostCommands");class u{constructor(P,k,E){this._commands=P,this._lookupApiCommand=k,this._logService=E,this.delegatingCommandId=`__vsc${(0,r.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(P,k){if(!P)return;const E={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return E;const S=this._lookupApiCommand(P.command);if(S)E.id=S.internalId,E.arguments=S.args.map((M,N)=>M.convert(P.arguments&&P.arguments[N]));else if((0,A.isNonEmptyArray)(P.arguments)){const M=`${P.command} /${++this._cachIdPool}`;this._cache.set(M,P),k.add((0,C.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),E.$ident=M,E.id=this.delegatingCommandId,E.arguments=[M],this._logService.trace("CommandsConverter#CREATE",P.command,M)}return E}fromInternal(P){return typeof P.$ident=="string"?this._cache.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this._cache.get(P[0])}_executeConvertedCommand(...P){const k=this.getActualCommand(...P);return this._logService.trace("CommandsConverter#EXECUTE",P[0],k?k.command:"MISSING"),k?this._commands.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.CommandsConverter=u;class v{static{this.Uri=new v("uri","Uri of a text document",P=>c.URI.isUri(P),P=>P)}static{this.Position=new v("position","A position in a text document",P=>d.Position.isPosition(P),T.Position.from)}static{this.Range=new v("range","A range in a text document",P=>d.Range.isRange(P),T.Range.from)}static{this.Selection=new v("selection","A selection in a text document",P=>d.Selection.isSelection(P),T.Selection.from)}static{this.Number=new v("number","",P=>typeof P=="number",P=>P)}static{this.String=new v("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=v.Arr(v.String)}static Arr(P){return new v(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,k=>Array.isArray(k)&&k.every(E=>P.validate(E)),k=>k.map(E=>P.convert(E)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",P=>P instanceof d.CallHierarchyItem,T.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",P=>P instanceof d.TypeHierarchyItem,T.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VSCodium TestItem",P=>P instanceof m.TestItemImpl,T.TestItem.from)}constructor(P,k,E,S){this.name=P,this.description=k,this.validate=E,this.convert=S}optional(){return new v(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,k){return new v(P??this.name,k??this.description,this.validate,this.convert)}}e.ApiCommandArgument=v;class y{static{this.Void=new y("no result",P=>P)}constructor(P,k){this.description=P,this.convert=k}}e.ApiCommandResult=y;class D{constructor(P,k,E,S,M){this.id=P,this.internalId=k,this.description=E,this.args=S,this.result=M}}e.ApiCommand=D}),define(_e[368],ye([1,0,19,15,2,88,143,36,35,16,10]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,R=ze(R),a=ze(a),I=ze(I);const _=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(a.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,m)=>{if((0,s.isFalsyOrEmpty)(l))return;class h extends I.SymbolInformation{static to(n){const o=new h(n.name,a.SymbolKind.to(n.kind),n.containerName||"",new I.Location(m[0],a.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=a.Range.to(n.selectionRange),o.children=n.children?n.children.map(h.to):[],o}}return l.map(h.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(a.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(a.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(a.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(a.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(a.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(m=>I.Position.isPosition(m)),l=>l.map(a.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(m=>{let h;for(const g of m.reverse())h=new I.SelectionRange(a.Range.to(g),h);return h}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(a.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(a.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(a.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(a.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:a.Range.to(l.range),placeholder:l.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return a.WorkspaceEdit.to(l)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(a.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=(0,L.decodeSemanticTokensDto)(l);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=(0,L.decodeSemanticTokensDto)(l);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,m,h)=>{if(!l)return new I.CompletionList([]);const g=l.suggestions.map(n=>a.CompletionItem.to(n,h));return new I.CompletionList(g,l.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return a.SignatureHelp.to(l)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,m,h)=>C(g=>new I.CodeLens(a.Range.to(g.range),g.command&&h.fromInternal(g.command)))(l))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>I.Range.isRange(l),l=>I.Selection.isSelection(l)?a.Selection.from(l):a.Range.from(l)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,m,h)=>C(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(g.command)}else{const n=new I.CodeAction(g.title,g.kind?new I.CodeActionKind(g.kind):void 0);return g.edit&&(n.edit=a.WorkspaceEdit.to(g.edit)),g.command&&(n.command=h.fromInternal(g.command)),n.isPreferred=g.isPreferred,n}})(l))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(m=>new I.ColorInformation(a.Range.to(m.range),a.Color.to(m.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",l=>l instanceof I.Color,a.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:a.Range.from(l.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(a.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,m,h)=>l.map(a.InlayHint.to.bind(void 0,h)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(l,m)=>{if(l)return l.map(a.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(m=>a.NotebookExclusiveDocumentPattern.to(m))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof I.Range,l=>a.InlineValueContext.from(l))],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(a.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",l=>T.URI.isUri(l)||typeof l=="string"&&(0,d.matchesSomeScheme)(l,d.Schemas.http,d.Schemas.https),l=>l),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[a.ViewColumn.from(l),void 0]:[a.ViewColumn.from(l.viewColumn),a.TextEditorOpenOptions.from(l)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[a.ViewColumn.from(l),void 0]:[a.ViewColumn.from(l.viewColumn),a.TextEditorOpenOptions.from(l)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[a.ViewColumn.from(l.viewColumn),a.TextEditorOpenOptions.from(l)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new p.ApiCommandArgument("resourceList","List of resources to compare",l=>{for(const m of l){if(m.length!==3)return!1;const[h,g,n]=m;if(!T.URI.isUri(h)||!T.URI.isUri(g)&&g!==void 0&&g!==null||!T.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(a.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(a.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(a.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,l=>l)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.StringArray,new p.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",l=>a.MappedEditsContext.is(l),l=>a.MappedEditsContext.from(l))],new p.ApiCommandResult("A promise that resolves to a workspace edit or null",l=>l?a.WorkspaceEdit.to(l):null)),new p.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.ApiCommandArgument("Run arguments","",l=>!0,l=>{if(l)return{initialRange:l.initialRange?a.Range.from(l.initialRange):void 0,initialSelection:I.Selection.isSelection(l.initialSelection)?a.Selection.from(l.initialSelection):void 0,message:l.message,autoSend:l.autoSend,position:l.position?a.Position.from(l.position):void 0}})],p.ApiCommandResult.Void)];class c{static register(m){_.forEach(m.registerApiCommand,m),this._registerValidateWhenClausesCommand(m)}static _registerValidateWhenClausesCommand(m){m.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=c;function C(l){return m=>{if(Array.isArray(m))return m.map(l)}}function b(l){if(!Array.isArray(l))return;const m=[];for(const h of l)R.isLocationLink(h)?m.push(a.DefinitionLink.to(h)):m.push(a.location.to(h));return m}}),define(_e[369],ye([1,0,2,35]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(L,A,p,a,I){this._extHostNotebooks=A,this._textDocumentsAndEditors=p,this._commands=a;const _=new d.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new d.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new d.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new d.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new d.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new d.ApiCommandResult("Notebook and input URI",c=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(c.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:s.URI.revive(c.notebookUri),inputUri:s.URI.revive(c.inputUri),notebookEditor:C.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:s.URI.revive(c.notebookUri),inputUri:s.URI.revive(c.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(L,A,p,a){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:p,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.ExtHostInteractive=T}),define(_e[370],ye([1,0,19,9,21,4,3,29,2,24,12,6,35,16,10,122,312,26,52,313]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=v,C=ze(C);let o=class{constructor(D,w,P,k,E){this._initData=w,this._extHostNotebook=P,this._commands=k,this._logService=E,this._activeExecutions=new A.ResourceMap,this._activeNotebookExecutions=new A.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=D.getProxy(_.MainContext.MainThreadNotebookKernels);const S=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this._extHostNotebook.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this._extHostNotebook.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],c.ApiCommandResult.Void),M=new c.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[c.ApiCommandArgument.Uri],new c.ApiCommandResult("A promise that resolves to an array of variables",(N,O)=>N.map(x=>({variable:{name:x.name,value:x.value,expression:x.expression,type:x.type,language:x.language},hasNamedChildren:x.hasNamedChildren,indexedChildrenCount:x.indexedChildrenCount}))));this._commands.registerApiCommand(S),this._commands.registerApiCommand(M)}createNotebookController(D,w,P,k,E,S){for(const ne of this._kernelData.values())if(ne.controller.id===w&&a.ExtensionIdentifier.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const M=this._handlePool++,N=this;this._logService.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${w}`);const O=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${D.identifier}'`);let x=!1;const U=new R.Emitter,F=new R.Emitter,H={id:v(D.identifier,w),notebookType:P,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:S?S.map(C.NotebookRendererScript.from):[]};let j=E??O,re,B;this._proxy.$addKernel(M,H).catch(ne=>{console.log(ne),x=!0});let V=0;const X=()=>{if(x)return;const ne=++V;Promise.resolve().then(()=>{ne===V&&this._proxy.$updateKernel(M,H)})},ee=new A.ResourceMap,he={get id(){return w},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return H.label},set label(ne){H.label=ne??D.displayName??D.name,X()},get detail(){return H.detail??""},set detail(ne){H.detail=ne,X()},get description(){return H.description??""},set description(ne){H.description=ne,X()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ne){H.supportedLanguages=ne,X()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){H.supportsExecutionOrder=ne,X()},get rendererScripts(){return H.preloads?H.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ne){j=ne??O},get interruptHandler(){return re},set interruptHandler(ne){re=ne,H.supportsInterrupt=!!ne,X()},set variableProvider(ne){(0,h.checkProposedApiEnabled)(D,"notebookVariableProvider"),B=ne,H.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>N._proxy.$variablesUpdated(De.uri)),X()},get variableProvider(){return B},createNotebookCellExecution(ne){if(x)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw N._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,v(D.identifier,this.id))},createNotebookExecution(ne){if((0,h.checkProposedApiEnabled)(D,"notebookExecution"),x)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw N._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,v(D.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${M}], DISPOSED`),x=!0,this._kernelData.delete(M),U.dispose(),F.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(ne,De){De===b.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(D,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(M,ne.uri,De)},onDidReceiveMessage:F.event,postMessage(ne,De){return(0,h.checkProposedApiEnabled)(D,"notebookMessaging"),N._proxy.$postMessage(M,De&&N._extHostNotebook.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,h.checkProposedApiEnabled)(D,"notebookMessaging"),(0,l.asWebviewUri)(ne,N._initData.remote)}};return this._kernelData.set(M,{extensionId:D.identifier,controller:he,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:ee}),he}getIdByController(D){for(const[w,P]of this._kernelData)if(P.controller===D)return v(P.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,w){const P=this._kernelDetectionTaskHandlePool++,k=this;this._logService.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelDetectionTask(P,w);const E={dispose:()=>{this._kernelDetectionTask.delete(P),k._proxy.$removeKernelDetectionTask(P)}};return this._kernelDetectionTask.set(P,E),E}registerKernelSourceActionProvider(D,w,P){const k=this._kernelSourceActionProviderHandlePool++,E=typeof P.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,S=this;this._kernelSourceActionProviders.set(k,P),this._logService.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelSourceActionProvider(k,k,w);let M;return E!==void 0&&(M=P.onDidChangeNotebookKernelSourceActions(N=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this._kernelSourceActionProviders.delete(k),S._proxy.$removeKernelSourceActionProvider(k,k),M?.dispose()}}}async $provideKernelSourceActions(D,w){const P=this._kernelSourceActionProviders.get(D);if(P){const k=new L.DisposableStore;return(await P.provideNotebookKernelSourceActions(w)??[]).map(S=>C.NotebookKernelSourceAction.from(S,this._commands.converter,k))}return[]}$acceptNotebookAssociation(D,w,P){const k=this._kernelData.get(D);if(k){const E=this._extHostNotebook.getNotebookDocument(p.URI.revive(w));P?k.associatedNotebooks.set(E.uri,!0):k.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${D}] ASSOCIATE notebook`,E.uri.toString(),P),k.onDidChangeSelection.fire({selected:P,notebook:E.apiNotebook})}}async $executeCells(D,w,P){const k=this._kernelData.get(D);if(!k)return;const E=this._extHostNotebook.getNotebookDocument(p.URI.revive(w)),S=[];for(const M of P){const N=E.getCell(M);N&&S.push(N.apiCell)}try{this._logService.trace(`NotebookController[${D}] EXECUTE cells`,E.uri.toString(),S.length),await k.controller.executeHandler.call(k.controller,S,E.apiNotebook,k.controller)}catch(M){this._logService.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,w,P){const k=this._kernelData.get(D);if(!k)return;const E=this._extHostNotebook.getNotebookDocument(p.URI.revive(w));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,E.apiNotebook);else for(const S of P){const M=E.getCell(S);M&&this._activeExecutions.get(M.uri)?.cancel()}if(k.controller.interruptHandler){const S=this._activeNotebookExecutions.get(E.uri);this._activeNotebookExecutions.delete(E.uri),P.length&&Array.isArray(S)&&S.length&&S.forEach(M=>M.dispose())}}async $provideVariables(D,w,P,k,E,S,M){const N=this._kernelData.get(D);if(!N)return;const O=this._extHostNotebook.getNotebookDocument(p.URI.revive(P)),x=N.controller.variableProvider;if(!x)return;let U;if(k!==void 0){if(U=this.variableStore[k],!U)return}else this.variableStore={};const F=E==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,H=x.provideVariables(O.apiNotebook,U,F,S,M);let j=0;for await(const re of H){if(M.isCancellationRequested)return;const B={id:this.id++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:N.extensionId.value};if(this.variableStore[B.id]=re.variable,this._proxy.$receiveVariable(w,B),j++>=n.variablePageSize)return}}$acceptKernelMessageFromRenderer(D,w,P){const k=this._kernelData.get(D);if(!k)return;const E=this._extHostNotebook.getEditorById(w);k.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:P}))}$cellExecutionChanged(D,w,P){const E=this._extHostNotebook.getNotebookDocument(p.URI.revive(D)).getCell(w);if(E){const S=P?C.NotebookCellExecutionState.to(P):b.NotebookCellExecutionState.Idle;S!==void 0&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:S})}}_createNotebookCellExecution(D,w){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this._extHostNotebook.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this._activeExecutions.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const E=new i(w,k,this._proxy);this._activeExecutions.set(k.uri,E);const S=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),S.dispose(),this._activeExecutions.delete(k.uri))});return E.asApiObject()}_createNotebookExecution(D,w){const P=this._extHostNotebook.getNotebookDocument(D.uri),k=D.getCells().find(M=>{const N=P.getCellFromApiCell(M);return N&&this._activeExecutions.has(N.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this._activeNotebookExecutions.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const E=new f(w,P,this._proxy),S=E.onDidChangeState(()=>{E.state===r.Resolved&&(E.dispose(),S.dispose(),this._activeNotebookExecutions.delete(P.uri))});return this._activeNotebookExecutions.set(P.uri,[E,S]),E.asApiObject()}};e.ExtHostNotebookKernels=o,e.ExtHostNotebookKernels=o=Xe([He(4,I.ILogService)],o);var t;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(t||(t={}));class i extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,w,P){super(),this._cell=w,this._proxy=P,this._handle=i.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new u(10,k=>this.update(k)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,D,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(D){await this._collector.addItem(D)}async update(D){const w=Array.isArray(D)?D:[D];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(D){let w=this._cell;if(D&&(w=this._cell.notebook.getCellFromApiCell(D)),!w)throw new Error("INVALID cell");return w.handle}validateAndConvertOutputs(D){return D.map(w=>{const P=b.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return P===w.items?C.NotebookCellOutput.from(w):C.NotebookCellOutput.from({items:P,id:w.id,metadata:w.metadata})})}async updateOutputs(D,w,P){const k=this.cellIndexToHandle(w),E=this.validateAndConvertOutputs((0,s.asArray)(D));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,cellHandle:k,append:P,outputs:E})}async updateOutputItems(D,w,P){return D=b.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(D),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(C.NotebookCellOutputItem.from),outputId:w.id,append:P})}asApiObject(){const D=this;return Object.freeze({get token(){return D._tokenSource.token},get cell(){return D._cell.apiCell},get executionOrder(){return D._executionOrder},set executionOrder(P){D._executionOrder=P,D.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D._executionOrder}])},start(P){if(D._state===t.Resolved||D._state===t.Started)throw new Error("Cannot call start again");D._state=t.Started,D._onDidChangeState.fire(),D.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,k,E){if(D._state===t.Resolved)throw new Error("Cannot call resolve twice");D._state=t.Resolved,D._onDidChangeState.fire(),D._collector.flush();const S=E?{message:E.message,stack:E.stack,location:E?.location?{startLineNumber:E.location.start.line,startColumn:E.location.start.character,endLineNumber:E.location.end.line,endColumn:E.location.end.character}:void 0,uri:E.uri}:void 0;D._proxy.$completeExecution(D._handle,new g.SerializableObjectWithBuffers({runEndTime:k,lastRunSuccess:P,error:S}))},clearOutput(P){return D.verifyStateForOutput(),D.updateOutputs([],P,!1)},appendOutput(P,k){return D.verifyStateForOutput(),D.updateOutputs(P,k,!0)},replaceOutput(P,k){return D.verifyStateForOutput(),D.updateOutputs(P,k,!1)},appendOutputItems(P,k){return D.verifyStateForOutput(),D.updateOutputItems(P,k,!0)},replaceOutputItems(P,k){return D.verifyStateForOutput(),D.updateOutputItems(P,k,!1)}})}}var r;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(r||(r={}));class f extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,w,P){super(),this._notebook=w,this._proxy=P,this._handle=f.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,D,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===r.Resolved||this._state===r.Started)throw new Error("Cannot call start again");this._state=r.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===r.Resolved)throw new Error("Cannot call resolve twice");this._state=r.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class u{constructor(D,w){this.delay=D,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(D){return this.batch.push(D),this.currentDeferred||(this.currentDeferred=new d.DeferredPromise,this.startedTimer=Date.now(),(0,d.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const D=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>D.complete())}}function v(y,D){return`${y.value}/${D}`}}),define(_e[47],ye([1,0,4,6,5,2,20,3,10,242,14,291,21,32,292,293,50,9,16,35,41]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class t extends A.Disposable{constructor(E,S,M,N){super(),this._proxy=E,this._id=S,this._creationOptions=M,this._name=N,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new s.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(x=>this._pidPromiseComplete=x);const O=this;this.value={get name(){return O._name||""},get processId(){return O._pidPromise},get creationOptions(){return O._creationOptions},get exitStatus(){return O._exitStatus},get state(){return O._state},get selection(){return O._selection},get shellIntegration(){return O.shellIntegration},sendText(x,U=!0){O._checkDisposed(),O._proxy.$sendText(O._id,x,U)},show(x){O._checkDisposed(),O._proxy.$show(O._id,x)},hide(){O._checkDisposed(),O._proxy.$hide(O._id)},dispose(){O._disposed||(O._disposed=!0,O._proxy.$dispose(O._id))},get dimensions(){if(!(O._cols===void 0||O._rows===void 0))return{columns:O._cols,rows:O._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(E,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:E.name,shellPath:E.shellPath??void 0,shellArgs:E.shellArgs??void 0,cwd:E.cwd??S?.cwd??void 0,env:E.env??void 0,icon:D(E.iconPath)??void 0,color:m.ThemeColor.isThemeColor(E.color)?E.color.id:void 0,initialText:E.message??void 0,strictEnv:E.strictEnv??void 0,hideFromUser:E.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this._serializeParentTerminal(E.location,S?.resolvedExtHostIdentifier),isTransient:E.isTransient??void 0})}async createExtensionTerminal(E,S,M,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(O)?O.id:void 0,location:S?.location||this._serializeParentTerminal(E,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(E,S){return typeof E=="object"?"parentTerminal"in E&&E.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in E?{viewColumn:g.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus}:void 0:E}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(E){this._name=E}setExitStatus(E,S){this._exitStatus=Object.freeze({code:E,reason:S})}setDimensions(E,S){return E===this._cols&&S===this._rows||E===0||S===0?!1:(this._cols=E,this._rows=S,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(E){this._selection=E}_setProcessId(E){this._pidPromiseComplete?(this._pidPromiseComplete(E),this._pidPromiseComplete=void 0):this._pidPromise.then(S=>{S!==E&&(this._pidPromise=Promise.resolve(E))})}}e.ExtHostTerminal=t;class i{get onProcessReady(){return this._onProcessReady.event}constructor(E){this._pty=E,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(E){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${E}`)}updateProperty(E,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${E}, value: ${S}`)}async start(){}shutdown(){this._pty.close()}input(E){this._pty.handleInput?.(E)}resize(E,S){this._pty.setDimensions?.({columns:E,rows:S})}clearBuffer(){}async processBinary(E){}acknowledgeDataEvent(E){}async setUnicodeVersion(E){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(E){this._pty.onDidWrite(S=>this._onProcessData.fire(S)),this._pty.onDidClose?.((S=void 0)=>{this._onProcessExit.fire(S===void 0?void 0:S)}),this._pty.onDidOverrideDimensions?.(S=>{S&&this._onDidChangeProperty.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:S.columns,rows:S.rows}})}),this._pty.onDidChangeName?.(S=>{this._onDidChangeProperty.fire({type:b.ProcessPropertyType.Title,value:S})}),this._pty.open(E||void 0),E&&this._pty.setDimensions?.(E),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,f=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(E=>E.value)}constructor(E,S,M){super(),this._extHostCommands=S,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new A.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new s.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new s.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new s.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=M.getProxy(d.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(E),this._extHostCommands.registerArgumentProcessor({processArgument:N=>{const O=x=>{const U=x;return this.getTerminalById(U.instanceId)?.value};switch(N?.$mid){case o.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let x=0;x<N.length&&N[x].$mid===o.MarshalledId.TerminalContext;x++)N[x]=O(N[x]);return N}}}}),this._register({dispose:()=>{for(const[N,O]of this._terminalProcesses)O.shutdown(!0)}})}getDefaultShell(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(E,S){const M=new t(this._proxy,(0,C.generateUuid)(),E,E.name),N=new i(E.pty);return M.createExtensionTerminal(E.location,S,this._serializeParentTerminal(E,S).resolvedExtHostIdentifier,D(E.iconPath),w(E.color)).then(O=>{const x=this._setupExtHostProcessListeners(O,N);this._terminalProcessDisposables[O]=x}),this._terminals.push(M),M.value}_serializeParentTerminal(E,S){if(S=S||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const M=E.location.parentTerminal;if(M){const N=this._terminals.find(O=>O.value===M);N&&(S.resolvedExtHostIdentifier=N._id)}}else E.location&&typeof E.location!="object"?S.location=E.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(E,S){if(!this.getTerminalById(E))throw new Error(`Cannot resolve terminal with id ${E} for virtual process`);const N=new i(S),O=this._setupExtHostProcessListeners(E,N);this._terminalProcessDisposables[E]=O}async $acceptActiveTerminalChanged(E){const S=this._activeTerminal;if(E===null){this._activeTerminal=void 0,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const M=this.getTerminalById(E);M&&(this._activeTerminal=M,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(E,S){const M=this.getTerminalById(E);M&&this._onDidWriteTerminalData.fire({terminal:M.value,data:S})}async $acceptTerminalDimensions(E,S,M){const N=this.getTerminalById(E);N&&N.setDimensions(S,M)&&this._onDidChangeTerminalDimensions.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(E,S){const M=this.getTerminalById(E);M&&this._onDidExecuteCommand.fire({terminal:M.value,...S})}async $acceptTerminalMaximumDimensions(E,S,M){this._terminalProcesses.get(E)?.resize(S,M)}async $acceptTerminalTitleChange(E,S){const M=this.getTerminalById(E);M&&(M.name=S)}async $acceptTerminalClosed(E,S,M){const N=this._getTerminalObjectIndexById(this._terminals,E);if(N!==null){const O=this._terminals.splice(N,1)[0];O.setExitStatus(S,M),this._onDidCloseTerminal.fire(O.value)}}$acceptTerminalOpened(E,S,M,N){if(S){const U=this._getTerminalObjectIndexById(this._terminals,S);if(U!==null){this._terminals[U]._id=E,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},x=new t(this._proxy,E,O,M);this._terminals.push(x),this._onDidOpenTerminal.fire(x.value),x.isOpen=!0}async $acceptTerminalProcessId(E,S){this.getTerminalById(E)?._setProcessId(S)}async $startExtensionTerminal(E,S){const M=this.getTerminalById(E);if(!M)return{message:(0,a.localize)(0,null,E)};M.isOpen||await new Promise(O=>{const x=this.onDidOpenTerminal(async U=>{U===M.value&&(x.dispose(),O())})});const N=this._terminalProcesses.get(E);N?N.startSendingEvents(S):this._extensionTerminalAwaitingStart[E]={initialDimensions:S}}_setupExtHostProcessListeners(E,S){const M=new A.DisposableStore;M.add(S.onProcessReady(O=>this._proxy.$sendProcessReady(E,O.pid,O.cwd,O.windowsPty))),M.add(S.onDidChangeProperty(O=>this._proxy.$sendProcessProperty(E,O))),this._bufferer.startBuffering(E,S.onProcessData),M.add(S.onProcessExit(O=>this._onProcessExit(E,O))),this._terminalProcesses.set(E,S);const N=this._extensionTerminalAwaitingStart[E];return N&&S instanceof i&&(S.startSendingEvents(N.initialDimensions),delete this._extensionTerminalAwaitingStart[E]),M}$acceptProcessAckDataEvent(E,S){this._terminalProcesses.get(E)?.acknowledgeDataEvent(S)}$acceptProcessInput(E,S){this._terminalProcesses.get(E)?.input(S)}$acceptTerminalInteraction(E){const S=this.getTerminalById(E);S?.setInteractedWith()&&this._onDidChangeTerminalState.fire(S.value)}$acceptTerminalSelection(E,S){this.getTerminalById(E)?.setSelection(S)}$acceptProcessResize(E,S,M){try{this._terminalProcesses.get(E)?.resize(S,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(E,S){this._terminalProcesses.get(E)?.shutdown(S)}$acceptProcessRequestInitialCwd(E){this._terminalProcesses.get(E)?.getInitialCwd().then(S=>this._proxy.$sendProcessProperty(E,{type:b.ProcessPropertyType.InitialCwd,value:S}))}$acceptProcessRequestCwd(E){this._terminalProcesses.get(E)?.getCwd().then(S=>this._proxy.$sendProcessProperty(E,{type:b.ProcessPropertyType.Cwd,value:S}))}$acceptProcessRequestLatency(E){return Promise.resolve(E)}registerLinkProvider(E){return this._linkProviders.add(E),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new p.Disposable(()=>{this._linkProviders.delete(E),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(E,S,M){if(this._profileProviders.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this._profileProviders.set(S,M),this._proxy.$registerProfileProvider(S,E.identifier.value),new p.Disposable(()=>{this._profileProviders.delete(S),this._proxy.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(E,S,M){if(this._quickFixProviders.has(E))throw new Error(`Terminal quick fix provider "${E}" is already registered`);return this._quickFixProviders.set(E,M),this._proxy.$registerQuickFixProvider(E,S),new p.Disposable(()=>{this._quickFixProviders.delete(E),this._proxy.$unregisterQuickFixProvider(E)})}async $provideTerminalQuickFixes(E,S){const M=new c.CancellationTokenSource().token;if(M.isCancellationRequested)return;const N=this._quickFixProviders.get(E);if(!N)return;const O=await N.provideTerminalQuickFixes(S,M);if(O===null||Array.isArray(O)&&O.length===0)return;const x=new A.DisposableStore;if(this._lastQuickFixCommands.value=x,!Array.isArray(O))return O?g.TerminalQuickFix.from(O,this._extHostCommands.converter,x):void 0;const U=[];for(const F of O){const H=g.TerminalQuickFix.from(F,this._extHostCommands.converter,x);H&&U.push(H)}return U}async $createContributedProfileTerminal(E,S){const M=new c.CancellationTokenSource().token;let N=await this._profileProviders.get(E)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${E}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,S);return}this.createTerminalFromOptions(N.options,S)}}async $provideLinks(E,S){const M=this.getTerminalById(E);if(!M)return[];this._terminalLinkCache.delete(E),this._terminalLinkCancellationSource.get(E)?.dispose(!0);const O=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(E,O);const x=[],U={terminal:M.value,line:S},F=[];for(const re of this._linkProviders)F.push(h.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:re,links:[]}));const V=await re.provideTerminalLinks(U,O.token)||[];O.token.isCancellationRequested||B({provider:re,links:V})}));const H=await Promise.all(F);if(O.token.isCancellationRequested)return[];const j=new Map;for(const re of H)re&&re.links.length>0&&x.push(...re.links.map(B=>{const V={id:r++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return j.set(V.id,{provider:re.provider,link:B}),V}));return this._terminalLinkCache.set(E,j),x}$activateLink(E,S){const M=this._terminalLinkCache.get(E)?.get(S);M&&M.provider.handleTerminalLink(M.link)}_onProcessExit(E,S){this._bufferer.stopBuffering(E),this._terminalProcesses.delete(E),delete this._extensionTerminalAwaitingStart[E];const M=this._terminalProcessDisposables[E];M&&(M.dispose(),delete this._terminalProcessDisposables[E]),this._proxy.$sendProcessExit(E,S)}getTerminalById(E){return this._getTerminalObjectById(this._terminals,E)}getTerminalIdByApiObject(E){const S=this._terminals.findIndex(M=>M.value===E);return S>=0?S:null}_getTerminalObjectById(E,S){const M=this._getTerminalObjectIndexById(E,S);return M!==null?E[M]:null}_getTerminalObjectIndexById(E,S){const M=E.findIndex(N=>N._id===S);return M>=0?M:null}getEnvironmentVariableCollection(E){let S=this._environmentVariableCollections.get(E.identifier.value);return S||(S=this._register(new u),this._setEnvironmentVariableCollection(E.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(E,S){const M=(0,_.serializeEnvironmentVariableCollection)(S.map),N=(0,_.serializeEnvironmentDescriptionMap)(S.descriptionMap);this._proxy.$setEnvironmentVariableCollection(E,S.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(E){E.forEach(S=>{const M=S[0],N=this._register(new u(S[1]));this._setEnvironmentVariableCollection(M,N)})}$acceptDefaultProfile(E,S){const M=this._defaultProfile;this._defaultProfile=E,this._defaultAutomationProfile=S,M?.path!==E.path&&this._onDidChangeShell.fire(E.path)}_setEnvironmentVariableCollection(E,S){this._environmentVariableCollections.set(E,S),this._register(S.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(E,S)}))}};e.BaseExtHostTerminalService=f,e.BaseExtHostTerminalService=f=Xe([He(1,n.IExtHostCommands),He(2,L.IExtHostRpcService)],f);class u extends A.Disposable{get persistent(){return this._persistent}set persistent(E){this._persistent=E,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(E){const S=this.getScopeKey(E);let M=this.scopedCollections.get(S);return M||(M=new v(this,E),this.scopedCollections.set(S,M),this._register(M.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),M}replace(E,S,M,N){this._setIfDiffers(E,{value:S,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(E,S,M,N){this._setIfDiffers(E,{value:S,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(E,S,M,N){this._setIfDiffers(E,{value:S,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}_setIfDiffers(E,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.getKey(E,S.scope),N=this.map.get(M),O=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==S.value||N.type!==S.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const x=this.getKey(E,S.scope),U={variable:E,...S,options:O};this.map.set(x,U),this._onDidChangeCollection.fire()}}get(E,S){const M=this.getKey(E,S),N=this.map.get(M);return N?P(N):void 0}getKey(E,S){const M=this.getScopeKey(S);return M.length?`${E}:::${M}`:E}getScopeKey(E){return this.getWorkspaceKey(E?.workspaceFolder)??""}getWorkspaceKey(E){return E?E.uri.toString():void 0}getVariableMap(E){const S=new Map;for(const[M,N]of this.map)this.getScopeKey(N.scope)===this.getScopeKey(E)&&S.set(N.variable,P(N));return S}delete(E,S){const M=this.getKey(E,S);this.map.delete(M),this._onDidChangeCollection.fire()}clear(E){if(E?.workspaceFolder){for(const[S,M]of this.map)M.scope?.workspaceFolder?.index===E.workspaceFolder.index&&this.map.delete(S);this.clearDescription(E)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(E,S){const M=this.getScopeKey(S),N=this.descriptionMap.get(M);if(!N||N.description!==E){let O;typeof E=="string"?O=E:O=E?.value.split(`

`)[0];const x={description:O,scope:S};this.descriptionMap.set(M,x),this._onDidChangeCollection.fire()}}getDescription(E){const S=this.getScopeKey(E);return this.descriptionMap.get(S)?.description}clearDescription(E){const S=this.getScopeKey(E);this.descriptionMap.delete(S)}}class v{get persistent(){return this.collection.persistent}set persistent(E){this.collection.persistent=E}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E,S){this.collection=E,this.scope=S,this._onDidChangeCollection=new s.Emitter}getScoped(E){return this.collection.getScopedEnvironmentVariableCollection(E)}replace(E,S,M){this.collection.replace(E,S,M,this.scope)}append(E,S,M){this.collection.append(E,S,M,this.scope)}prepend(E,S,M){this.collection.prepend(E,S,M,this.scope)}get(E){return this.collection.get(E,this.scope)}forEach(E,S){this.collection.getVariableMap(this.scope).forEach((M,N)=>E.call(S,N,M,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(E){this.collection.delete(E,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(E){this.collection.setDescription(E,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let y=class extends f{constructor(E,S){super(!1,E,S)}createTerminal(E,S,M){throw new I.NotSupportedError}createTerminalFromOptions(E,S){throw new I.NotSupportedError}};e.WorkerExtHostTerminalService=y,e.WorkerExtHostTerminalService=y=Xe([He(0,n.IExtHostCommands),He(1,L.IExtHostRpcService)],y);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function w(k){return m.ThemeColor.isThemeColor(k)?k:void 0}function P(k){const E={...k};return delete E.scope,E.options=E.options??void 0,delete E.variable,E}}),define(_e[167],ye([1,0,10,3,5,6,20,47,4,2,9]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,T.createDecorator)("IExtHostTerminalShellIntegration");let _=class extends d.Disposable{constructor(m,h){super(),this._extHostTerminalService=h,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new p.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new p.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new p.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=m.getProxy(R.MainContext.MainThreadTerminalShellIntegration),this._register((0,d.toDisposable)(()=>{for(const[g,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(m){const h=this._extHostTerminalService.getTerminalById(m);if(!h)return;const g=h.value;let n=this._activeShellIntegrations.get(m);n||(n=new c(h.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(m,n),n.store.add(h.onWillDispose(()=>this._activeShellIntegrations.get(m)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this._proxy.$executeCommand(m,o))),n.store.add(n.onDidRequestEndExecution(o=>this._onDidEndTerminalShellExecution.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this._onDidChangeTerminalShellIntegration.fire(o))),h.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:g,shellIntegration:n.value})}$shellExecutionStart(m,h,g,n,o){this._activeShellIntegrations.has(m)||this.$shellIntegrationChange(m);const t={value:h,confidence:g,isTrusted:n};this._activeShellIntegrations.get(m)?.startShellExecution(t,o)}$shellExecutionEnd(m,h,g,n,o){const t={value:h,confidence:g,isTrusted:n};this._activeShellIntegrations.get(m)?.endShellExecution(t,o)}$shellExecutionData(m,h){this._activeShellIntegrations.get(m)?.emitData(h)}$cwdChange(m,h){this._activeShellIntegrations.get(m)?.setCwd((0,a.isUriComponents)(h)?a.URI.revive(h):h)}$closeTerminal(m){this._activeShellIntegrations.get(m)?.dispose(),this._activeShellIntegrations.delete(m)}};e.ExtHostTerminalShellIntegration=_,e.ExtHostTerminalShellIntegration=_=Xe([He(0,L.IExtHostRpcService),He(1,A.IExtHostTerminalService)],_);class c extends d.Disposable{get currentExecution(){return this._currentExecution}constructor(m,h){super(),this._terminal=m,this._onDidStartTerminalShellExecution=h,this._ignoreNextExecution=!1,this.store=this._register(new d.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new p.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new p.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new p.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const g=this;this.value={get cwd(){return g._cwd},executeCommand(n,o){let t=n;o&&(t+=` "${o.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),g._onDidRequestShellExecution.fire(t);const i={value:t,confidence:s.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},r=g.startShellExecution(i,g._cwd,!0).value;return g._ignoreNextExecution=!0,r}}}startShellExecution(m,h,g){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const n=this._currentExecution=new C(m,h);g?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:n.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,h){this._currentExecution&&(this._currentExecution.endExecution(m),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:h}),this._currentExecution=void 0)}setCwd(m){let h=!1;a.URI.isUri(this._cwd)?h=!a.URI.isUri(m)||this._cwd.toString()!==m.toString():this._cwd!==m&&(h=!0),h&&(this._cwd=m,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class C{constructor(m,h){this._commandLine=m,this.cwd=h,this._ended=!1;const g=this;this.value={get commandLine(){return g._commandLine},get cwd(){return g.cwd},read(){return g._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return I.AsyncIterableObject.EMPTY;this._dataStream=new b}return this._dataStream.createIterable()}emitData(m){this._dataStream?.emitData(m)}endExecution(m){m&&(this._commandLine=m),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class b extends d.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new I.Barrier);const m=this._barrier;return new I.AsyncIterableObject(async g=>{this._emitters.push(g),await m.wait()})}emitData(m){for(const h of this._emitters)h.emitOne(m)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(_e[168],ye([1,0,66,14,133,16,10]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,R=ze(R);class A{static{this._Keys=new T.IdGenerator("TextEditorDecorationType")}constructor(c,C,b){const l=A._Keys.nextId();c.$registerTextEditorDecorationType(C.identifier,l,R.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:l,dispose(){c.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=A;class p{constructor(c,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,C){this._throwIfFinalized();let b=null;if(c instanceof L.Position)b=new L.Range(c,c);else if(c instanceof L.Range)b=c;else throw new Error("Unrecognized location");this._pushEdit(b,C,!1)}insert(c,C){this._throwIfFinalized(),this._pushEdit(new L.Range(c,c),C,!0)}delete(c){this._throwIfFinalized();let C=null;if(c instanceof L.Range)C=c;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(c,C,b){const l=this._document.validateRange(c);this._collectedEdits.push({range:l,text:C,forceMoveMarkers:b})}setEndOfLine(c){if(this._throwIfFinalized(),c!==L.EndOfLine.LF&&c!==L.EndOfLine.CRLF)throw(0,d.illegalArgument)("endOfLine");this._setEndOfLine=c}}class a{constructor(c,C,b,l){this._proxy=c,this._id=C,this._accept(b),this._logService=l;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(h){m._setTabSize(h)},get indentSize(){return m._indentSize},set indentSize(h){m._setIndentSize(h)},get insertSpaces(){return m._insertSpaces},set insertSpaces(h){m._setInsertSpaces(h)},get cursorStyle(){return m._cursorStyle},set cursorStyle(h){m._setCursorStyle(h)},get lineNumbers(){return m._lineNumbers},set lineNumbers(h){m._setLineNumbers(h)}}}_accept(c){this._tabSize=c.tabSize,this._indentSize=c.indentSize,this._originalIndentSize=c.originalIndentSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const C=Math.floor(c);return C>0?C:null}if(typeof c=="string"){const C=parseInt(c,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(c){const C=this._validateTabSize(c);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateIndentSize(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const C=Math.floor(c);return C>0?C:null}if(typeof c=="string"){const C=parseInt(c,10);return isNaN(C)?null:C>0?C:null}return null}_setIndentSize(c){const C=this._validateIndentSize(c);if(C!==null){if(typeof C=="number"){if(this._originalIndentSize===C)return;this._indentSize=C,this._originalIndentSize=C}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:C}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:!!c}_setInsertSpaces(c){const C=this._validateInsertSpaces(c);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(c)})))}assign(c){const C={};let b=!1;if(typeof c.tabSize<"u"){const l=this._validateTabSize(c.tabSize);l==="auto"?(b=!0,C.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,b=!0,C.tabSize=l)}if(typeof c.indentSize<"u"){const l=this._validateIndentSize(c.indentSize);l==="tabSize"?(b=!0,C.indentSize=l):typeof l=="number"&&this._originalIndentSize!==l&&(this._indentSize=l,this._originalIndentSize=l,b=!0,C.indentSize=l)}if(typeof c.insertSpaces<"u"){const l=this._validateInsertSpaces(c.insertSpaces);l==="auto"?(b=!0,C.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,b=!0,C.insertSpaces=l)}typeof c.cursorStyle<"u"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,b=!0,C.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,b=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(c.lineNumbers)),b&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(c,C){C.catch(b=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(b)})}}e.ExtHostTextEditorOptions=a;class I{constructor(c,C,b,l,m,h,g,n){this.id=c,this._proxy=C,this._logService=b,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new a(this._proxy,this.id,h,b),this._visibleRanges=g,this._viewColumn=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(t){throw new d.ReadonlyError("document")},get selection(){return o._selections&&o._selections[0]},set selection(t){if(!(t instanceof L.Selection))throw(0,d.illegalArgument)("selection");o._selections=[t],o._trySetSelection()},get selections(){return o._selections},set selections(t){if(!Array.isArray(t)||t.some(i=>!(i instanceof L.Selection)))throw(0,d.illegalArgument)("selections");o._selections=t,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(t){throw new d.ReadonlyError("visibleRanges")},get options(){return o._options.value},set options(t){o._disposed||o._options.assign(t)},get viewColumn(){return o._viewColumn},set viewColumn(t){throw new d.ReadonlyError("viewColumn")},edit(t,i={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new p(l.value,i);return t(r),o._applyEdit(r)},insertSnippet(t,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!i||Array.isArray(i)&&i.length===0)f=o._selections.map(u=>R.Range.from(u));else if(i instanceof L.Position){const{lineNumber:u,column:v}=R.Position.from(i);f=[{startLineNumber:u,startColumn:v,endLineNumber:u,endColumn:v}]}else if(i instanceof L.Range)f=[R.Range.from(i)];else{f=[];for(const u of i)if(u instanceof L.Range)f.push(R.Range.from(u));else{const{lineNumber:v,column:y}=R.Position.from(u);f.push({startLineNumber:v,startColumn:y,endLineNumber:v,endColumn:y})}}return C.$tryInsertSnippet(c,l.value.version,t.value,f,r)},setDecorations(t,i){const r=i.length===0;r&&!o._hasDecorationsForKey.has(t.key)||(r?o._hasDecorationsForKey.delete(t.key):o._hasDecorationsForKey.add(t.key),o._runOnProxy(()=>{if(R.isDecorationOptionsArr(i))return C.$trySetDecorations(c,t.key,R.fromRangeOrRangeWithMessage(i));{const f=new Array(4*i.length);for(let u=0,v=i.length;u<v;u++){const y=i[u];f[4*u]=y.start.line+1,f[4*u+1]=y.start.character+1,f[4*u+2]=y.end.line+1,f[4*u+3]=y.end.character+1}return C.$trySetDecorationsFast(c,t.key,f)}}))},revealRange(t,i){o._runOnProxy(()=>C.$tryRevealRange(c,R.Range.from(t),i||L.TextEditorRevealType.Default))},show(t){C.$tryShowEditor(c,R.ViewColumn.from(t))},hide(){C.$tryHideEditor(c)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,s.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,s.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,s.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,s.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const C=c.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const b=C.edits.map(m=>m.range);b.sort((m,h)=>m.end.line===h.end.line?m.end.character===h.end.character?m.start.line===h.start.line?m.start.character-h.start.character:m.start.line-h.start.line:m.end.character-h.end.character:m.end.line-h.end.line);for(let m=0,h=b.length-1;m<h;m++){const g=b[m].end;if(b[m+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=C.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,l,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=I}),define(_e[64],ye([1,0,66,4,3,2,5,6,164,20,168,16,12,29,15,40,49]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,s=ze(s),_=ze(_);class h{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(o,t){this._extHostRpc=o,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new d.Emitter,this._onDidRemoveDocuments=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],i=[],r=[];if(o.removedDocuments)for(const f of o.removedDocuments){const u=R.URI.revive(f),v=this._documents.get(u);v?.unref()&&(this._documents.delete(u),t.push(v.value))}if(o.addedDocuments)for(const f of o.addedDocuments){const u=R.URI.revive(f.uri);let v=this._documents.get(u);if(v&&u.scheme!==b.Schemas.vscodeNotebookCell&&u.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);v||(v=new h(new p.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this._documents.set(u,v),i.push(v.value)),v.ref()}if(o.removedEditors)for(const f of o.removedEditors){const u=this._editors.get(f);this._editors.delete(f),u&&r.push(u)}if(o.addedEditors)for(const f of o.addedEditors){const u=R.URI.revive(f.documentUri);s.ok(this._documents.has(u),`document '${u}' does not exist`),s.ok(!this._editors.has(f.id),`editor '${f.id}' already exists!`);const v=this._documents.get(u).value,y=new I.ExtHostTextEditor(f.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>v.document),f.selections.map(_.Selection.to),f.options,f.visibleRanges.map(D=>_.Range.to(D)),typeof f.editorPosition=="number"?_.ViewColumn.to(f.editorPosition):void 0);this._editors.set(f.id,y)}o.newActiveEditor!==void 0&&(s.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,T.dispose)(t),(0,T.dispose)(r),o.removedDocuments&&this._onDidRemoveDocuments.fire(t),o.addedDocuments&&this._onDidAddDocuments.fire(i),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(f=>f.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return o?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=g,e.ExtHostDocumentsAndEditors=g=Xe([He(0,a.IExtHostRpcService),He(1,c.ILogService)],g),e.IExtHostDocumentsAndEditors=(0,L.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[99],ye([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,166,16,10,315,74,121,75,26]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,n=ze(n);let v=0;const y=new WeakMap;e.IExtHostTesting=(0,c.createDecorator)("IExtHostTesting");let D=class extends p.Disposable{constructor(B,V,X,ee){super(),this.logService=V,this.commands=X,this.editors=ee,this.resultsChangedEmitter=this._register(new R.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new R.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(b.MainContext.MainThreadTesting),this.observer=new x(this.proxy),this.runTracker=new E(this.proxy,V),X.registerArgumentProcessor({processArgument:he=>{switch(he?.$mid){case a.MarshalledId.TestItemContext:{const ne=he,De=ne.tests[ne.tests.length-1].item.extId;return this.controllers.get(i.TestId.root(De))?.collection.tree.get(De)?.actual??(0,g.toItemFromContext)(he)}case a.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=he,pe=ne.item.extId;return{test:this.controllers.get(i.TestId.root(pe))?.collection.tree.get(pe)?.actual??(0,g.toItemFromContext)({$mid:a.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return he}}}),X.registerCommand(!1,"testing.getExplorerSelection",async()=>{const he=await X.executeCommand(t.TestCommandId.GetExplorerSelection),ne=De=>{const pe=this.controllers.get(i.TestId.root(De));if(pe)return i.TestId.isRoot(De)?pe.controller:pe.collection.tree.get(De)?.actual};return{include:he?.include.map(ne).filter(I.isDefined)||[],exclude:he?.exclude.map(ne).filter(I.isDefined)||[]}})}createTestController(B,V,X,ee){if(this.controllers.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const he=new p.DisposableStore,ne=he.add(new g.ExtHostTestItemCollection(V,X,this.editors));ne.root.label=X;const De=new Map,pe=new Set,G=this.proxy,W={items:ne.root.children,get label(){return X},set label(ae){X=ae,ne.root.label=ae,G.$updateController(V,{label:X})},get refreshHandler(){return ee},set refreshHandler(ae){ee=ae,G.$updateController(V,{canRefresh:!!ae})},get id(){return V},createRunProfile:(ae,te,ce,ue,Y,oe)=>{let ve=(0,A.hash)(ae);for(;De.has(ve);)ve++;return new F(this.proxy,De,pe,this.defaultProfilesChangedEmitter.event,V,ve,ae,te,ce,ue,Y,oe)},createTestItem(ae,te,ce){return new g.TestItemImpl(V,ae,te,ce)},createTestRun:(ae,te,ce=!0)=>this.runTracker.createTestRun(B,V,ne,ae,te,ce),invalidateTestResults:ae=>{if(ae===void 0)this.proxy.$markTestRetired(void 0);else{const te=ae instanceof Array?ae:[ae];this.proxy.$markTestRetired(te.map(ce=>i.TestId.fromExtHostTestItem(ce,V).toString()))}},set resolveHandler(ae){ne.resolveHandler=ae},get resolveHandler(){return ne.resolveHandler},dispose:()=>{he.dispose()}};G.$registerTestController(V,X,!!ee),he.add((0,p.toDisposable)(()=>G.$unregisterTestController(V)));const se={controller:W,collection:ne,profiles:De,extension:B,activeProfiles:pe};return this.controllers.set(V,se),he.add((0,p.toDisposable)(()=>this.controllers.delete(V))),he.add(ne.onDidGenerateDiff(ae=>G.$publishDiff(V,ae.map(f.TestsDiffOp.serialize)))),W}createTestObserver(){return this.observer.checkout()}async runTests(B,V=T.CancellationToken.None){const X=S(B);if(!X)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.controllers.get(X.controllerId);if(!ee)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:B.preserveFocus??!0,group:H[X.kind],targets:[{testIds:B.include?.map(he=>i.TestId.fromExtHostTestItem(he,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:X.profileId,controllerId:X.controllerId}],exclude:B.exclude?.map(he=>he.id)},V)}registerTestFollowupProvider(B){return this.followupProviders.add(B),{dispose:()=>{this.followupProviders.delete(B)}}}$syncTests(){for(const{collection:B}of this.controllers.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,V,X){return(await this.runTracker.getCoverageDetails(B,V,X))?.map(n.TestCoverage.fromDetails)}async $disposeRun(B){this.runTracker.disposeTestRun(B)}$configureRunProfile(B,V){this.controllers.get(B)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(B){const V=new Map;for(const[X,ee]of Object.entries(B)){const he=this.controllers.get(X);if(!he)continue;const ne=new Map,De=ee.filter(G=>!he.activeProfiles.has(G)),pe=[...he.activeProfiles].filter(G=>!ee.includes(G));for(const G of De)ne.set(G,!0),he.activeProfiles.add(G);for(const G of pe)ne.set(G,!1),he.activeProfiles.delete(G);ne.size&&V.set(X,ne)}this.defaultProfilesChangedEmitter.fire(V)}async $refreshTests(B,V){await this.controllers.get(B)?.controller.refreshHandler?.(V)}$publishTestResults(B){this.results=Object.freeze(B.map(V=>{const X=n.TestResults.to(V);return y.set(X,V.id),X}).concat(this.results).sort((V,X)=>X.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,V){const X=this.controllers.get(i.TestId.fromString(B).controllerId)?.collection;X&&(await X.expand(B,V<0?1/0:V),X.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(V=>f.TestsDiffOp.deserialize({asCanonicalUri:X=>X},V)))}async $runControllerTests(B,V){return Promise.all(B.map(X=>this.runControllerTestRequest(X,!1,V)))}async $startContinuousRun(B,V){const X=new T.CancellationTokenSource(V),ee=await Promise.all(B.map(he=>this.runControllerTestRequest(he,!0,X.token)));return!V.isCancellationRequested&&!ee.some(he=>he.error)&&await new Promise(he=>V.onCancellationRequested(he)),X.dispose(!0),ee}async $provideTestFollowups(B,V){const X=this.results.find(ne=>y.get(ne)===B.resultId),ee=X&&j(i.TestId.fromString(B.extId),X?.results);if(!ee)return[];let he=[];return await Promise.all([...this.followupProviders].map(async ne=>{try{const De=await ne.provideFollowup(X,ee,B.taskIndex,B.messageIndex,V);De&&(he=he.concat(De))}catch(De){this.logService.error("Error thrown while providing followup for test message",De)}})),V.isCancellationRequested?[]:he.map(ne=>{const De=v++;return this.testFollowups.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(B){for(const V of B)this.testFollowups.delete(V)}$executeTestFollowup(B){const V=this.testFollowups.get(B);return V?this.commands.executeCommand(V.command,...V.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}getMetadataForRun(B){for(const V of this.runTracker.trackers){const X=V.getTaskIdForRun(B);if(X)return{taskId:X,runId:V.id}}}async runControllerTestRequest(B,V,X){const ee=this.controllers.get(B.controllerId);if(!ee)return{};const{collection:he,profiles:ne,extension:De}=ee,pe=ne.get(B.profileId);if(!pe)return{};const G=B.testIds.map(te=>he.tree.get(te)).filter(I.isDefined),W=B.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.isDefined).filter(te=>G.some(ce=>ce.fullId.compare(te.fullId)===i.TestPosition.IsChild));if(!G.length)return{};const se=new o.TestRunRequest(G.some(te=>te.actual instanceof g.TestItemRootImpl)?void 0:G.map(te=>te.actual),W.map(te=>te.actual),pe,V),ae=(0,f.isStartControllerTests)(B)&&this.runTracker.prepareForMainThreadTestRun(De,se,M.fromInternal(B,ee.collection),pe,X);try{return await pe.runHandler(se,X),{}}catch(te){return{error:String(te)}}finally{ae&&ae.hasRunningTasks&&!X.isCancellationRequested&&await R.Event.toPromise(ae.onEnd)}}};e.ExtHostTesting=D,e.ExtHostTesting=D=Xe([He(0,h.IExtHostRpcService),He(1,C.ILogService),He(2,l.IExtHostCommands),He(3,m.IExtHostDocumentsAndEditors)],D);const w=1e4;var P;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(P||(P={}));class k extends p.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(B,V,X,ee,he,ne){super(),this.dto=B,this.proxy=V,this.logService=X,this.profile=ee,this.extension=he,this.state=P.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new T.CancellationTokenSource(ne));const De=this._register(new s.RunOnceScheduler(()=>this.forciblyEndTasks(),w));this._register(this.cts.token.onCancellationRequested(()=>De.schedule()));const pe=new R.Emitter;this.onDidDispose=pe.event,this._register((0,p.toDisposable)(()=>{pe.fire(),pe.dispose()}))}getTaskIdForRun(B){for(const[V,{run:X}]of this.tasks)if(X===B)return V}cancel(){this.state===P.Running?(this.cts.cancel(),this.state=P.Cancelling):this.state===P.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails(B,V,X){const[,ee]=i.TestId.fromString(B).path,he=this.publishedCoverage.get(B);if(!he)return[];const{report:ne,extIds:De}=he,pe=this.tasks.get(ee);if(!pe)throw new Error("unreachable: run task was not found");let G;if(V&&ne instanceof o.FileCoverage){const se=De.indexOf(V);if(se===-1)return[];G=ne.fromTests[se]}return await(G?this.profile?.loadDetailedCoverageForTest?.(pe.run,ne,G,X):this.profile?.loadDetailedCoverage?.(pe.run,ne,X))??[]}createRun(B){const V=this.dto.id,X=this.dto.controllerId,ee=(0,_.generateUuid)(),he=G=>(W,...se)=>{if(De){this.logService.warn(`Setting the state of test "${W.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown(W),G(W,...se)},ne=(G,W)=>{const se=W instanceof Array?W.map(n.TestMessage.from):[n.TestMessage.from(W)];if(G.uri&&G.range){const ae={range:n.Range.from(G.range),uri:G.uri};for(const te of se)te.location=te.location||ae}this.proxy.$appendTestMessagesInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),se)};let De=!1;const pe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,onDidDispose:this.onDidDispose,addCoverage:G=>{if(De)return;const W=G instanceof o.FileCoverage?G.fromTests:[];if(W.length){(0,u.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const te of W)this.ensureTestIsKnown(te)}const se=G.uri.toString(),ae=new i.TestId([V,ee,se]).toString();this.publishedCoverage.set(ae,{report:G,extIds:W.map(te=>i.TestId.fromExtHostTestItem(te,X).toString())}),this.proxy.$appendCoverage(V,ee,n.TestCoverage.fromFile(X,ae,G))},enqueued:he(G=>{this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),f.TestResultState.Queued)}),skipped:he(G=>{this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),f.TestResultState.Skipped)}),started:he(G=>{this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),f.TestResultState.Running)}),errored:he((G,W,se)=>{ne(G,W),this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),f.TestResultState.Errored,se)}),failed:he((G,W,se)=>{ne(G,W),this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,X).toString(),f.TestResultState.Failed,se)}),passed:he((G,W)=>{this.proxy.$updateTestStateInRun(V,ee,i.TestId.fromExtHostTestItem(G,this.dto.controllerId).toString(),f.TestResultState.Passed,W)}),appendOutput:(G,W,se)=>{De||(se&&this.ensureTestIsKnown(se),this.proxy.$appendOutputToRun(V,ee,d.VSBuffer.fromString(G),W&&n.location.from(W),se&&i.TestId.fromExtHostTestItem(se,X).toString()))},end:()=>{De||(De=!0,this.proxy.$finishedTestRunTask(V,ee),--this.running||this.markEnded())}};return this.running++,this.tasks.set(ee,{run:pe}),this.proxy.$startedTestRunTask(V,{id:ee,name:B,running:!0}),pe}forciblyEndTasks(){for(const{run:B}of this.tasks.values())B.end()}markEnded(){this.state!==P.Ended&&(this.state=P.Ended,this.endEmitter.fire())}ensureTestIsKnown(B){if(!(B instanceof g.TestItemImpl))throw new r.InvalidTestItemError(B.id);if(this.sharedTestIds.has(i.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const V=[],X=this.dto.colllection.root;for(;;){const ee=n.TestItem.from(B);if(V.unshift(ee),this.sharedTestIds.has(ee.extId)||(this.sharedTestIds.add(ee.extId),B===X))break;B=B.parent||X}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}dispose(){this.markEnded(),super.dispose()}}class E{get trackers(){return this.tracked.values()}constructor(B,V){this.proxy=B,this.logService=V,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(B,V,X){const ee=i.TestId.root(B);return this.trackedById.get(ee)?.getCoverageDetails(B,V,X)||[]}disposeTestRun(B){this.trackedById.get(B)?.dispose(),this.trackedById.delete(B);for(const[V,{id:X}]of this.tracked)X===B&&this.tracked.delete(V)}prepareForMainThreadTestRun(B,V,X,ee,he){return this.getTracker(V,X,ee,B,he)}cancelRunById(B){this.trackedById.get(B)?.cancel()}cancelAllRuns(){for(const B of this.tracked.values())B.cancel()}createTestRun(B,V,X,ee,he,ne){const De=this.tracked.get(ee);if(De)return De.createRun(he);const pe=M.fromPublic(V,X,ee,ne),G=S(ee);this.proxy.$startedExtensionTestRun({controllerId:V,continuous:!!ee.continuous,profile:G&&{group:H[G.kind],id:G.profileId},exclude:ee.exclude?.map(se=>i.TestId.fromExtHostTestItem(se,X.root.id).toString())??[],id:pe.id,include:ee.include?.map(se=>i.TestId.fromExtHostTestItem(se,X.root.id).toString())??[X.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const W=this.getTracker(ee,pe,ee.profile,B);return R.Event.once(W.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(pe.id)}),W.createRun(he)}getTracker(B,V,X,ee,he){const ne=new k(V,this.proxy,this.logService,X,ee,he);return this.tracked.set(B,ne),this.trackedById.set(ne.id,ne),ne}}e.TestRunCoordinator=E;const S=re=>{if(re.profile){if(!(re.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class M{static fromPublic(B,V,X,ee){return new M(B,(0,_.generateUuid)(),ee,V)}static fromInternal(B,V){return new M(B.controllerId,B.runId,!0,V)}constructor(B,V,X,ee){this.controllerId=B,this.id=V,this.isPersisted=X,this.colllection=ee}}e.TestRunDto=M;class N{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(B){this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(B){this.added.add(B)}update(B){Object.assign(B.revived,n.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}this.updated.delete(B);const V=i.TestId.parentId(B.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:V,removed:X}=this;return{get added(){return[...B].map(ee=>ee.revived)},get updated(){return[...V].map(ee=>ee.revived)},get removed(){return[...X].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class O extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,V){return{...B,revived:n.TestItem.toPlain(B.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new N(this.changeEmitter)}}class x{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(V=>V.revived)},dispose:(0,L.createSingleCallFunction)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new O({asCanonicalUri:V=>V});return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}const U=(re,B,V,X)=>{V?Object.assign(V,X):B.$updateTestRunConfig(re.controllerId,re.profileId,X)};class F{#e;#t;#i;#n;#s;get label(){return this._label}set label(B){B!==this._label&&(this._label=B,U(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(B){B!==this._supportsContinuousRun&&(this._supportsContinuousRun=B,U(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),U(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,U(this,this.#e,this.#n,{tag:B?n.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,U(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return R.Event.chain(this.#i,B=>B.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(I.isDefined))}constructor(B,V,X,ee,he,ne,De,pe,G,W=!1,se=void 0,ae=!1){this.controllerId=he,this.profileId=ne,this._label=De,this.kind=pe,this.runHandler=G,this._tag=se,this._supportsContinuousRun=ae,this.#e=B,this.#s=V,this.#t=X,this.#i=ee,V.set(ne,this);const te=H[pe];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${pe}`);W&&X.add(ne),this.#n={profileId:ne,controllerId:he,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=F;const H={[o.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function j(re,B){for(let V=0;V<re.path.length;V++){const X=B.find(ee=>ee.id===re.path[V]);if(!X)return;if(V===re.path.length-1)return X;B=X.children}}}),define(_e[371],ye([1,0,19,4,3,6,168,16,10]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,s=ze(s),A=ze(A);class a extends T.Disposable{constructor(_,c){super(),this._extHostDocumentsAndEditors=c,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=_.getProxy(R.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(C=>this._onDidChangeVisibleTextEditors.fire(C))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(C=>this._onDidChangeActiveTextEditor.fire(C)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(_){const c=this._extHostDocumentsAndEditors.allEditors();return _?c:c.map(C=>C.value)}async showTextDocument(_,c,C){let b;typeof c=="number"?b={position:A.ViewColumn.from(c),preserveFocus:C}:typeof c=="object"?b={position:A.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?A.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:b={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(_.uri,b),m=l&&this._extHostDocumentsAndEditors.getEditor(l);if(m)return m.value;throw l?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}createTextEditorDecorationType(_,c){return new L.TextEditorDecorationType(this._proxy,_,c).value}$acceptEditorPropertiesChanged(_,c){const C=this._extHostDocumentsAndEditors.getEditor(_);if(!C)throw new Error("unknown text editor");if(c.options&&C._acceptOptions(c.options),c.selections){const b=c.selections.selections.map(A.Selection.to);C._acceptSelections(b)}if(c.visibleRanges){const b=s.coalesce(c.visibleRanges.map(A.Range.to));C._acceptVisibleRanges(b)}if(c.options&&this._onDidChangeTextEditorOptions.fire({textEditor:C.value,options:{...c.options,lineNumbers:A.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const b=p.TextEditorSelectionChangeKind.fromValue(c.selections.source),l=c.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:C.value,selections:l,kind:b})}if(c.visibleRanges){const b=s.coalesce(c.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:C.value,visibleRanges:b})}}$acceptEditorPositionData(_){for(const c in _){const C=this._extHostDocumentsAndEditors.getEditor(c);if(!C)throw new Error("Unknown text editor");const b=A.ViewColumn.to(_[c]);C.value.viewColumn!==b&&(C._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:C.value,viewColumn:b}))}}getDiffInformation(_){return Promise.resolve(this._proxy.$getDiffInformation(_))}}e.ExtHostEditors=a}),define(_e[372],ye([1,0,2,5,6,3,10,16,24,41,18]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,d.createDecorator)("IExtHostTimeline");class _{constructor(b,l){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadTimeline),l.registerArgumentProcessor({processArgument:(m,h)=>{if(m&&m.$mid===a.MarshalledId.TimelineActionContext)if(this._providers.get(m.source)&&p.ExtensionIdentifier.equals(h,this._providers.get(m.source)?.extension)){const g=m.uri===void 0?void 0:s.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(c(g))?.get(m.handle)}else return;return m}})}async $getTimeline(b,l,m,h){return this._providers.get(b)?.provider.provideTimeline(s.URI.revive(l),m,h)}registerTimelineProvider(b,l,m,h){const g=new R.DisposableStore,n=this.convertTimelineItem(l.id,h,g).bind(this);let o;l.onDidChange&&(o=l.onDidChange(i=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:l.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...l,scheme:b,onDidChange:void 0,async provideTimeline(i,r,f){r?.resetCache&&(g.clear(),t.get(l.id)?.clear());const u=await l.provideTimeline(i,r,f);if(u==null)return;const v=n(i,r);return{...u,source:l.id,items:u.items.map(v)}},dispose(){for(const i of t.values())i.get(l.id)?.clear();o?.dispose(),g.dispose()}},m)}convertTimelineItem(b,l,m){return(h,g)=>{let n;if(g?.cacheResults){let o=this._itemsBySourceAndUriMap.get(b);o===void 0&&(o=new Map,this._itemsBySourceAndUriMap.set(b,o));const t=c(h);n=o.get(t),n===void 0&&(n=new Map,o.set(t,n))}return o=>{const{iconPath:t,...i}=o,r=`${b}|${o.id??o.timestamp}`;n?.set(r,o);let f,u,v;o.iconPath&&(t instanceof L.ThemeIcon?v={id:t.id,color:t.color}:s.URI.isUri(t)?(f=t,u=t):{light:f,dark:u}=t);let y;return L.MarkdownString.isMarkdownString(i.tooltip)?y=A.MarkdownString.from(i.tooltip):(0,I.isString)(i.tooltip)?y=i.tooltip:L.MarkdownString.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=A.MarkdownString.from(i.detail)):(0,I.isString)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=i.detail),{...i,id:i.id??void 0,handle:r,source:b,command:o.command?l.toInternal(o.command,m):void 0,icon:f,iconDark:u,themeIcon:v,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}registerTimelineProviderCore(b,l){if(this._providers.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this._proxy.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this._providers.set(b.id,{provider:b,extension:l}),(0,R.toDisposable)(()=>{for(const h of this._itemsBySourceAndUriMap.values())h.get(b.id)?.clear();this._providers.delete(b.id),this._proxy.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=_;function c(C){return C?.toString()}}),define(_e[373],ye([1,0,243,23,2,4,3,305,9,10,18,19,16,86,21,199,26]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,a=ze(a);function h(o,t){if((0,I.isString)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let i;return Array.isArray(o.highlights)&&(i=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:o.label,highlights:i}}}class g extends L.Disposable{constructor(t,i,r){super(),this._proxy=t,this.commands=i,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDnDService;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>f(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(v=>f(v)?this.convertArgument(v):v):u})}registerTreeDataProvider(t,i,r){const f=this.createTreeView(t,{treeDataProvider:i},r);return{dispose:()=>f.dispose()}}createTreeView(t,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],v=!!i.dragAndDropController?.handleDrag,y=!!i.dragAndDropController?.handleDrop,D=this.createExtHostTreeView(t,i,r),w={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:v,hasHandleDrop:y,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},P=this._proxy.$registerTreeViewDataProvider(t,w),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.checkProposedApiEnabled)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.checkProposedApiEnabled)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(E){(0,C.isMarkdownString)(E)&&(0,m.checkProposedApiEnabled)(r,"treeViewMarkdownMessage"),D.message=E},get title(){return D.title},set title(E){D.title=E},get description(){return D.description},set description(E){D.description=E},get badge(){return D.badge},set badge(E){E!==void 0&&a.ViewBadge.isViewBadge(E)?D.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(D.badge=void 0)},reveal:(E,S)=>D.reveal(E,S),dispose:async()=>{await P,this.treeViews.delete(t),D.dispose()}};return this._register(k),k}$getChildren(t,i){const r=this.treeViews.get(t);return r?r.getChildren(i):Promise.reject(new A.NoTreeViewError(t))}async $handleDrop(t,i,r,f,u,v,y,D){const w=this.treeViews.get(t);if(!w)return Promise.reject(new A.NoTreeViewError(t));const P=c.DataTransfer.toDataTransfer(r,async k=>(await this._proxy.$resolveDropFileData(t,i,k)).buffer);return y===t&&D&&await this.addAdditionalTransferItems(P,w,D,u,v),w.onDrop(P,f,u)}async addAdditionalTransferItems(t,i,r,f,u){const v=this.treeDragAndDropService.removeDragOperationTransfer(u);if(v)(await v)?.forEach((y,D)=>{y&&t.set(D,y)});else if(u&&i.handleDrag){const y=i.handleDrag(r,t,f);this.treeDragAndDropService.addDragOperationTransfer(u,y),await y}return t}async $handleDrag(t,i,r,f){const u=this.treeViews.get(t);if(!u)return Promise.reject(new A.NoTreeViewError(t));const v=await this.addAdditionalTransferItems(new a.DataTransfer,u,i,f,r);if(!(!v||f.isCancellationRequested))return c.DataTransfer.from(v)}async $hasResolve(t){const i=this.treeViews.get(t);if(!i)throw new A.NoTreeViewError(t);return i.hasResolve}$resolve(t,i,r){const f=this.treeViews.get(t);if(!f)throw new A.NoTreeViewError(t);return f.resolveTreeItem(i,r)}$setExpanded(t,i,r){const f=this.treeViews.get(t);if(!f)throw new A.NoTreeViewError(t);f.setExpanded(i,r)}$setSelectionAndFocus(t,i,r){const f=this.treeViews.get(t);if(!f)throw new A.NoTreeViewError(t);f.setSelectionAndFocus(i,r)}$setVisible(t,i){const r=this.treeViews.get(t);if(!r){if(!i)return;throw new A.NoTreeViewError(t)}r.setVisible(i)}$changeCheckboxState(t,i){const r=this.treeViews.get(t);if(!r)throw new A.NoTreeViewError(t);r.setCheckboxState(i)}createExtHostTreeView(t,i,r){const f=this._register(new n(t,i,this._proxy,this.commands.converter,this.logService,r));return this.treeViews.set(t,f),f}convertArgument(t){const i=this.treeViews.get(t.$treeViewId);return i&&"$treeItemHandle"in t?i.getExtensionElement(t.$treeItemHandle):i&&"$focusedTreeItem"in t&&t.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=g;class n extends L.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,i,r,f,u,v){if(super(),this.viewId=t,this.proxy=r,this.commands=f,this.logService=u,this.extension=v,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new R.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,v.contributes&&v.contributes.views)for(const P in v.contributes.views)for(const k of v.contributes.views[P])k.id===t&&(this._title=k.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this._onDidChangeData.fire({message:!1,element:P})}));let y,D;const w=R.Event.debounce(this._onDidChangeData.event,(P,k)=>(P||(P={message:!1,elements:[]}),k.element!==!1&&(y||(y=new Promise(E=>D=E),this.refreshPromise=this.refreshPromise.then(()=>y)),Array.isArray(k.element)?P.elements.push(...k.element):P.elements.push(k.element)),k.message&&(P.message=!0),P),200,!0);this._register(w(({message:P,elements:k})=>{k.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=D;return y=null,this.refresh(k).then(()=>E())})),P&&this.proxy.$setMessage(this.viewId,c.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const i=t?this.getExtensionElement(t):void 0;if(t&&!i)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(t);return r||(r=await this.fetchChildrenNodes(i)),r?r.map(f=>f.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,i){i=i||{select:!0,focus:!1};const r=(0,I.isUndefinedOrNull)(i.select)?!0:i.select,f=(0,I.isUndefinedOrNull)(i.focus)?!1:i.focus,u=(0,I.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(v=>this.resolveTreeNode(t,v[v.length-1]).then(y=>this.proxy.$reveal(this.viewId,{item:y.item,parentChain:v.map(D=>D.item)},{select:r,focus:f,expand:u})),v=>this.logService.error(v)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:f,expand:u})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=c.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,i){const r=this.getExtensionElement(t);r&&(i?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelectionAndFocus(t,i){const r=!(0,_.equals)(this._selectedHandles,t);this._selectedHandles=t;const f=this._focusedHandle!==i;this._focusedHandle=i,r&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),f&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const i=(await Promise.all(t.map(async r=>{const f=this.getExtensionElement(r.treeItemHandle);return f?{extensionItem:f,treeItem:await this.dataProvider.getTreeItem(f),newState:r.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(t,i,r){const f=[];for(const u of t){const v=this.getExtensionElement(u);v&&f.push(v)}if(!(!this.dndController?.handleDrag||f.length===0))return await this.dndController.handleDrag(f,i,r),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,i,r){const f=i?this.getExtensionElement(i):void 0;if(!(!f&&i||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(f,t,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,i){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(t);if(r){const f=this.nodes.get(r);if(f){const u=await this.dataProvider.resolveTreeItem(f.extensionItem,r,i)??f.extensionItem;return this.validateTreeItem(u),f.item.tooltip=this.getTooltip(u.tooltip),f.item.command=this.getCommand(f.disposableStore,u.command),f.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(i=>i?this.resolveUnknownParentChain(i).then(r=>this.resolveTreeNode(i,r[r.length-1]).then(f=>(r.push(f),r))):Promise.resolve([]))}resolveParent(t){const i=this.nodes.get(t);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,i){const r=this.nodes.get(t);return r?Promise.resolve(r):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(f=>this.createHandle(t,f,i,!0)).then(f=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const v=this.nodes.get(u);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let i;if(typeof t=="string"){const r=this.getExtensionElement(t);i=r?this.nodes.get(r):void 0}else i=t;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const i=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=t?this.nodes.get(t):void 0,f=await this.dataProvider.getChildren(t);if(i.token.isCancellationRequested)return;const u=(0,_.coalesce)(f||[]),v=await Promise.all((0,_.coalesce)(u).map(D=>this.dataProvider.getTreeItem(D)));if(i.token.isCancellationRequested)return;const y=v.map((D,w)=>D?this.createAndRegisterTreeNode(u[w],D,r):null);return(0,_.coalesce)(y)}finally{i.dispose()}}refresh(t){if(t.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(t);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const i=new Set,r=t.map(u=>this.nodes.get(u));for(const u of r)if(u&&!i.has(u.item.handle)){let v=u;for(;v&&v.parent&&r.findIndex(y=>v&&v.parent&&y&&y.item.handle===v.parent.item.handle)===-1;){const y=this.elements.get(v.parent.item.handle);v=y?this.nodes.get(y):void 0}v&&!v.parent&&i.add(u.item.handle)}const f=[];return i.forEach(u=>{const v=this.elements.get(u);if(v){const y=this.nodes.get(v);y&&(!y.parent||!i.has(y.parent.item.handle))&&f.push(u)}}),f}refreshHandles(t){const i={};return Promise.all(t.map(r=>this.refreshNode(r).then(f=>{f&&(i[r]=f.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(t){const i=this.getExtensionElement(t);if(i){const r=this.nodes.get(i);if(r)return this.clearChildren(i),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(f=>{if(f){const u=this.createTreeNode(i,f,r.parent);return this.updateNodeCache(i,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,i,r){const f=this.createTreeNode(t,i,r);if(i.id&&this.elements.has(f.item.handle))throw new Error((0,s.localize)(0,null,i.id));return this.addNodeToCache(t,f),this.addNodeToParentCache(f,r),f}getTooltip(t){return a.MarkdownString.isMarkdownString(t)?c.MarkdownString.from(t):t}getCommand(t,i){return i?{...this.commands.toInternal(i,t),originalId:i.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let i,r,f;return typeof t.checkboxState=="number"?i=t.checkboxState:(i=t.checkboxState.state,r=t.checkboxState.tooltip,f=t.checkboxState.accessibilityInformation),{isChecked:i===a.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:f}}validateTreeItem(t){if(!a.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,i,r){this.validateTreeItem(i);const f=this._register(new L.DisposableStore),u=this.createHandle(t,i,r),v=this.getLightIconPath(i);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:h(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(f,i.command),contextValue:i.contextValue,icon:v,iconDark:this.getDarkIconPath(i)||v,themeIcon:this.getThemeIcon(i),collapsibleState:(0,I.isUndefinedOrNull)(i.collapsibleState)?a.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:r,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(t){return t.iconPath instanceof a.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:i,label:r,resourceUri:f},u,v){if(i)return`${n.ID_HANDLE_PREFIX}/${i}`;const y=h(r,this.extension),D=u?u.item.handle:n.LABEL_HANDLE_PREFIX;let w=y?y.label:f?(0,d.basename)(f):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const P=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,k=this.getChildrenNodes(u)||[];let E,S=0;do{if(E=`${D}/${S}:${w}`,v||!this.elements.has(E)||P===E)break;S++}while(S<=k.length);return E}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof a.ThemeIcon))return typeof t.iconPath=="string"||T.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof a.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return T.URI.isUri(t)?t:T.URI.file(t)}addNodeToCache(t,i){this.elements.set(i.item.handle,t),this.nodes.set(t,i)}updateNodeCache(t,i,r,f){this.elements.delete(i.item.handle),this.nodes.delete(t),i.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(t,i);const u=this.getChildrenNodes(f)||[],v=u.filter(y=>y.item.handle===r.item.handle)[0];v&&u.splice(u.indexOf(v),1,i)}addNodeToParentCache(t,i){i?(i.children||(i.children=[]),i.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const i=this.nodes.get(t);if(i){if(i.children)for(const r of i.children){const f=this.elements.get(r.item.handle);f&&this.clear(f)}i.children=void 0}}else this.clearAll()}clear(t){const i=this.nodes.get(t);if(i){if(i.children)for(const r of i.children){const f=this.elements.get(r.item.handle);f&&this.clear(f)}this.nodes.delete(t),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(_e[374],ye([1,0,4,3,2,32,16,97,6,10]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,L=ze(L),p=ze(p),a=ze(a);class I extends d.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(b,l,m,h){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new s.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new s.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=b,this.#t=l,this.#n=m,this.#i=h.viewType,this.#s=h.panelOptions,this.#o=h.viewColumn,this.#r=h.title,this.#c=h.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(b){this.assertNotDisposed(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(b){this.assertNotDisposed(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,T.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#c=b.active,this.#l=b.visible,this.#o=b.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(b,l){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:L.ViewColumn.from(b),preserveFocus:!!l})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class _ extends d.Disposable{static newHandle(){return(0,R.generateUuid)()}constructor(b,l,m){super(),this.webviews=l,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=b.getProxy(p.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(b=>b.dispose()),this._webviewPanels.clear()}createWebviewPanel(b,l,m,h,g={}){const n=typeof h=="object"?h.viewColumn:h,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof h=="object"&&!!h.preserveFocus},t=(0,A.shouldSerializeBuffersForPostMessage)(b),i=_.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(b),i,l,{title:m,panelOptions:c(g),webviewOptions:(0,A.serializeWebviewOptions)(b,this.workspace,g),serializeBuffersForPostMessage:t},o);const r=this.webviews.createNewWebview(i,g,b);return this.createNewWebviewPanel(i,l,m,n,g,r,!0)}$onDidChangeWebviewPanelViewStates(b){const l=Object.keys(b);l.sort((m,h)=>{const g=b[m],n=b[h];return g.active?1:n.active?-1:+g.visible-+n.visible});for(const m of l){const h=this.getWebviewPanel(m);if(!h)continue;const g=b[m];h._updateViewState({active:g.active,visible:g.visible,viewColumn:L.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this._webviewPanels.delete(b),this.webviews.deleteWebview(b)}registerWebviewPanelSerializer(b,l,m){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:m,extension:b}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(b)}),new a.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(b,l,m,h){const g=this._serializers.get(l);if(!g)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:o}=g,t=this.webviews.createNewWebview(b,m.webviewOptions,o),i=this.createNewWebviewPanel(b,l,m.title,h,m.panelOptions,t,m.active);await n.deserializeWebviewPanel(i,m.state)}createNewWebviewPanel(b,l,m,h,g,n,o){const t=new I(b,this._proxy,n,{viewType:l,title:m,viewColumn:h,panelOptions:g,active:o});return this._webviewPanels.set(b,t),t}getWebviewPanel(b){return this._webviewPanels.get(b)}}e.ExtHostWebviewPanels=_;function c(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(_e[375],ye([1,0,4,3,97,16,6,10]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,L=ze(L),A=ze(A);class p extends d.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(_,c,C,b,l,m){super(),this.#s=!1,this.#c=this._register(new s.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new s.Emitter),this.onDidDispose=this.#u.event,this.#i=C,this.#a=b,this.#e=_,this.#t=c,this.#n=l,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(_){this.assertNotDisposed(),this.#a!==_&&(this.#a=_,this.#t.$setWebviewViewTitle(this.#e,_))}get description(){return this.assertNotDisposed(),this.#o}set description(_){this.assertNotDisposed(),this.#o!==_&&(this.#o=_,this.#t.$setWebviewViewDescription(this.#e,_))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(_){_===this.#r||this.#s||(this.#r=_,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(_){this.assertNotDisposed(),!(_?.value===this.#l?.value&&_?.tooltip===this.#l?.tooltip)&&(this.#l=R.ViewBadge.from(_),this.#t.$setWebviewViewBadge(this.#e,_))}show(_){this.assertNotDisposed(),this.#t.$show(this.#e,!!_)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(_,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,c,C,b){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:C,extension:_}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(_),c,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(_)}),new A.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(_,c,C,b,l){const m=this._viewProviders.get(c);if(!m)throw new Error(`No view provider found for '${c}'`);const{provider:h,extension:g}=m,n=this._extHostWebview.createNewWebview(_,{},g),o=new p(_,this._proxy,c,C,n,!0);this._webviewViews.set(_,o),await h.resolveWebviewView(o,{state:b},l)}async $onDidChangeWebviewViewVisibility(_,c){this.getWebviewView(_)._setVisible(c)}async $disposeWebviewView(_){const c=this.getWebviewView(_);this._webviewViews.delete(_),c.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const c=this._webviewViews.get(_);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=a}),define(_e[376],ye([1,0,76,15,12,277,28,11]),function(le,e,s,d,T,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let p=class{constructor(_,c){_.addFileSystemProvider(d.Schemas.file,new a(c),{isCaseSensitive:A.isLinux})}};e.ExtHostDiskFileSystemProvider=p,e.ExtHostDiskFileSystemProvider=p=Xe([He(0,s.IExtHostConsumerFileSystem),He(1,T.ILogService)],p);class a{constructor(_){this.logService=_,this.impl=new R.DiskFileSystemProvider(this.logService)}async stat(_){const c=await this.impl.stat(_);return{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(_){return this.impl.readdir(_)}createDirectory(_){return this.impl.mkdir(_)}readFile(_){return this.impl.readFile(_)}writeFile(_,c,C){return this.impl.writeFile(_,c,{...C,unlock:!1,atomic:!1})}delete(_,c){return this.impl.delete(_,{...c,useTrash:!1,atomic:!1})}rename(_,c,C){return this.impl.rename(_,c,C)}copy(_,c,C){return this.impl.copy(_,c,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(_,c){throw new Error("Method not implemented.")}}}),define(_e[377],ye([1,0,17,68,32,35,3,6,2,20]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let I=class extends L.Disposable{constructor(c,C){super();const b=c.getProxy(A.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async l=>{const m=p.URI.file((0,s.join)((0,d.tmpdir)(),(0,T.generateUuid)()));return await b.$download(l,m),m})}};e.ExtHostDownloadService=I,e.ExtHostDownloadService=I=Xe([He(0,a.IExtHostRpcService),He(1,R.IExtHostCommands)],I)}),define(_e[378],ye([1,0,61,17,2,98,3,15,9,34]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0,s=ze(s),d=ze(d);class I extends R.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const r=await super._getWorkspaceStorageURI(i);if(r.scheme!==A.Schemas.file)return r;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const f=r.fsPath;let u=0;do{let v;u===0?v=f:v=/[/\\]$/.test(f)?`${f.substr(0,f.length-1)}-${u}`:`${f}-${u}`,await _(v);const y=d.join(v,"vscode.lock"),D=await l(this._logService,y,!1);if(D)return this._workspaceStorageLock=D,process.on("exit",()=>{D.dispose()}),T.URI.file(v);u++}while(u<10);return r}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=I;async function _(t){try{await a.Promises.stat(t);return}catch{}try{await a.Promises.mkdir(t,{recursive:!0})}catch{}}const c=1e3,C=10*60*1e3;class b extends L.Disposable{constructor(i,r){super(),this.logService=i,this.filename=r,this._timer=this._register(new p.IntervalTimer),this._timer.cancelAndSet(async()=>{const f=await m(i,r);(!f||f.pid!==process.pid)&&(i.info(`Lock '${r}': The lock was lost unexpectedly.`),this._timer.cancel());try{await a.Promises.utimes(r,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${r}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{s.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+i};await a.Promises.writeFile(this.filename,JSON.stringify(r),{flag:"w"})}catch(r){this.logService.error(r)}}}async function l(t,i,r){try{const u={pid:process.pid,willReleaseAt:0};await a.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){t.error(u)}const f=await m(t,i);return!f||f.pid!==process.pid?r?(t.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),n(t,i)):(t.info(`Lock '${i}': Lock acquired.`),new b(t,i))}async function m(t,i){let r;try{r=await a.Promises.readFile(i)}catch(f){return t.error(f),null}try{return JSON.parse(String(r))}catch(f){return t.error(f),null}}async function h(t,i){let r;try{r=await a.Promises.stat(i)}catch(f){return t.error(f),0}return r.mtime.getTime()}function g(t){try{return process.kill(t,0),!0}catch{return!1}}async function n(t,i){const r=await m(t,i);if(!r)return t.info(`Lock '${i}': Could not read pid of lock holder.`),o(t,i);if(r.willReleaseAt){let D=r.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${i}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${i}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,p.timeout)(Math.min(100,D)),await h(t,i)===0)return o(t,i);D=r.willReleaseAt-Date.now()}return o(t,i)}}if(!g(r.pid))return t.info(`Lock '${i}': The pid ${r.pid} appears to be gone.`),o(t,i);const f=await h(t,i),u=Date.now()-f;if(u<=C)return t.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;t.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,p.timeout)(2e3);const v=await h(t,i),y=Date.now()-v;return y<=C?(t.info(`Lock '${i}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(t.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),o(t,i))}async function o(t,i){t.info(`Lock '${i}': Deleting a stale lock.`);try{await a.Promises.unlink(i)}catch{}return l(t,i,!0)}}),define(_e[379],ye([1,0,32,20,47,35]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=class extends T.BaseExtHostTerminalService{constructor(p,a){super(!0,p,a)}createTerminal(p,a,I){return this.createTerminalFromOptions({name:p,shellPath:a,shellArgs:I})}createTerminalFromOptions(p,a){const I=new T.ExtHostTerminal(this._proxy,(0,s.generateUuid)(),p,p.name);return this._terminals.push(I),I.create(p,this._serializeParentTerminal(p,a)),I.value}};e.ExtHostTerminalService=L,e.ExtHostTerminalService=L=Xe([He(0,R.IExtHostCommands),He(1,d.IExtHostRpcService)],L)}),define(_e[380],ye([1,0,4,37,36,5]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new T.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new T.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new T.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var L;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new s.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new s.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(a){this.channels.has(a.id)||(this.channels.set(a.id,a),this._onDidRegisterChannel.fire(a.id))}getChannels(){const a=[];return this.channels.forEach(I=>a.push(I)),a}getChannel(a){return this.channels.get(a)}removeChannel(a){this.channels.delete(a),this._onDidRemoveChannel.fire(a)}}d.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(_e[169],ye([1,0,6,5,20,24,12,380,76,30,63,204,22,18,28,4,3]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends L.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,i,r,f,u){super(),this.id=t,this.name=i,this.logger=r,this.proxy=f,this.extension=u,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(r.getLevel()),this._register(r.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,t)}replace(t){const i=this.offset;this.info(t),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(t,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:i))}hide(){this.proxy.$close(this.id)}log(t,i){this.offset+=c.VSBuffer.fromString(i).byteLength,(0,L.log)(this.logger,t,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class g extends h{appendLine(t){this.append(t)}}let n=class{constructor(t,i,r,f,u,v){this.initData=i,this.extHostFileSystem=r,this.extHostFileSystemInfo=f,this.loggerService=u,this.logService=v,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[i,r]of this.channels)r.visible=i===this.visibleChannelId}createOutputChannel(t,i,r){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const f=typeof i=="object"&&i.log,u=(0,C.isString)(i)?i:void 0;if((0,C.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const y=this.initData.environment.extensionLogLevel?.find(([w])=>R.ExtensionIdentifier.equals(r.identifier,w))?.[1];y&&(v=(0,L.parseLogLevel)(y));const D=f?this.doCreateLogOutputChannel(t,v,r):this.doCreateOutputChannel(t,u,r);return D.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),f?this.createExtHostLogOutputChannel(t,v??this.logService.getLevel(),D):this.createExtHostOutputChannel(t,D)}async doCreateOutputChannel(t,i,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const f=await this.outputDirectoryPromise,u=this.extHostFileSystemInfo.extUri.joinPath(f,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.loggerService.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.proxy.$register(t,u,i,r.identifier.value);return new h(y,t,v,this.proxy,r)}async doCreateLogOutputChannel(t,i,r){const f=await this.createExtensionLogDirectory(r),u=t.replace(/[\\/:\*\?"<>\|]/g,""),v=this.extHostFileSystemInfo.extUri.joinPath(f,`${u}.log`),y=`${r.identifier.value}.${u}`,D=this.loggerService.createLogger(v,{id:y,name:t,logLevel:i,extensionId:r.identifier.value});return new g(y,t,D,this.proxy,r)}createExtensionLogDirectory(t){let i=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!i){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(f){if((0,b.toFileSystemProviderErrorCode)(f)!==b.FileSystemProviderErrorCode.FileExists)throw f}return r})())}return i}createExtHostOutputChannel(t,i){let r=!1;const f=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return t},append(u){f(),i.then(v=>v.append(u))},appendLine(u){f(),i.then(v=>v.appendLine(u))},clear(){f(),i.then(u=>u.clear())},replace(u){f(),i.then(v=>v.replace(u))},show(u,v){f(),i.then(y=>y.show(u,v))},hide(){f(),i.then(u=>u.hide())},dispose(){r=!0,i.then(u=>u.dispose())}}}createExtHostLogOutputChannel(t,i,r){const f=new m.DisposableStore,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},v=f.add(new l.Emitter);function y(D){i=D,v.fire(D)}return r.then(D=>{f.add(D),D.logLevel!==i&&y(D.logLevel),f.add(D.onDidChangeLogLevel(w=>y(w)))}),{...this.createExtHostOutputChannel(t,r),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(D,...w){u(),r.then(P=>P.trace(D,...w))},debug(D,...w){u(),r.then(P=>P.debug(D,...w))},info(D,...w){u(),r.then(P=>P.info(D,...w))},warn(D,...w){u(),r.then(P=>P.warn(D,...w))},error(D,...w){u(),r.then(P=>P.error(D,...w))},dispose(){f.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Xe([He(0,T.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,p.IExtHostConsumerFileSystem),He(3,I.IExtHostFileSystemInfo),He(4,L.ILoggerService),He(5,L.ILogService)],n),e.IExtHostOutputService=(0,d.createDecorator)("IExtHostOutputService")}),define(_e[170],ye([1,0,5,9]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(T){let R=1/0;for(let A=0;A<this.maxSampleCount;A++){const p=await T.getRoundTripTime();if(p===void 0)return;R=Math.min(R,p/2),await(0,d.timeout)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((A,p)=>A+p,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((A,p)=>A+p,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(_e[381],ye([1,0,247,71,37,46,45,3,4,170,11,25,9,151]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,s.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,s.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:d.ConfigurationScope.APPLICATION,title:(0,s.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,s.localize)(3,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,s.localize)(4,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new p.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const l=new b;T.Registry.add(e.Extensions.ConfigurationMigration,l);let m=class extends A.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.configurationService=o,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async i=>{for(const r of i.added)await this.migrateConfigurationsForFolder(r,l.migrations)})),this.migrateConfigurations(l.migrations),this._register(l.onDidRegisterConfigurationMigration(i=>this.migrateConfigurations(i)))}async migrateConfigurations(o){await this.migrateConfigurationsForFolder(void 0,o);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,o)}async migrateConfigurationsForFolder(o,t){await Promise.all([t.map(i=>this.migrateConfigurationsForFolderAndOverride(i,o?.uri))])}async migrateConfigurationsForFolderAndOverride(o,t){const i=this.configurationService.inspect(o.key,{resource:t}),r=this.workspaceService.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[f,u]of r){const v=i[f];if(!v)continue;const y=[];if(v.value!==void 0){const D=await this.runMigration(o,f,v.value,t,void 0);for(const w of D??[])y.push([w,[]])}for(const{identifiers:D,value:w}of v.overrides??[])if(w!==void 0){const P=await this.runMigration(o,f,w,t,D);for(const k of P??[])y.push([k,D])}y.length&&await Promise.allSettled(y.map(async([[D,w],P])=>this.configurationService.updateValue(D,w.value,{resource:t,overrideIdentifiers:P},u)))}}async runMigration(o,t,i,r,f){const u=y=>{const w=this.configurationService.inspect(y,{resource:r})[t];if(w)return f?w.overrides?.find(({identifiers:P})=>(0,_.equals)(P,f))?.value:w.value},v=await o.migrateFn(i,u);return Array.isArray(v)?v:[[o.key,v]]}};e.ConfigurationMigrationWorkbenchContribution=m,e.ConfigurationMigrationWorkbenchContribution=m=Xe([He(0,L.IConfigurationService),He(1,R.IWorkspaceContextService)],m);let h=class extends A.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.remoteAgentService=o,this._ready=new c.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!I.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==I.OperatingSystem.Windows)return;T.Registry.as(d.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,s.localize)(5,null)},default:[],markdownDescription:(0,s.localize)(6,null),scope:d.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,s.localize)(7,null),scope:d.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=h,e.DynamicWorkbenchSecurityConfiguration=h=Xe([He(0,a.IRemoteAgentService)],h),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let g=class extends A.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.userDataProfilesService=o,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(i=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(i=>{i.source!==L.ConfigurationTarget.DEFAULT&&i.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const o=T.Registry.as(d.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(i=>i.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(i=>""),(0,s.localize)(8,null)],description:(0,s.localize)(9,null),scope:d.ConfigurationScope.APPLICATION}}};this.configurationNode?o.updateConfigurations({add:[t],remove:[this.configurationNode]}):o.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const o=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=o?this.userDataProfilesService.profiles.find(t=>t.name===o):void 0}checkAndResetNewWindowProfileConfig(){const o=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!o)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(i=>i.id===this.newWindowProfile.id):void 0;o!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=g,e.DynamicWindowConfiguration=g=Xe([He(0,C.IUserDataProfilesService),He(1,L.IConfigurationService)],g)}),define(_e[382],ye([1,0,39,15,17,23,259,381,71,5,37]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=l,e.globMatchesResource=m,s=ze(s),e.IEditorResolverService=(0,a.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const _=I.Registry.as(p.Extensions.Configuration),c={...A.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};_.registerConfiguration(c);var C;(function(h){h.builtin="builtin",h.option="option",h.exclusive="exclusive",h.default="default"})(C||(e.RegisteredEditorPriority=C={}));var b;(function(h){h[h.ABORT=1]="ABORT",h[h.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function l(h){switch(h){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m(h,g){if(new Set([d.Schemas.extension,d.Schemas.webviewPanel,d.Schemas.vscodeWorkspaceTrust,d.Schemas.vscodeSettings]).has(g.scheme))return!1;const t=typeof h=="string"&&h.indexOf(T.posix.sep)>=0?`${g.scheme}:${g.path}`:(0,R.basename)(g);return s.match(typeof h=="string"?h.toLowerCase():h,t.toLowerCase())}}),define(_e[383],ye([1,0,33,15,17,11,23,2,5,297,46,158,170]),function(le,e,s,d,T,R,L,A,p,a,I,_,c){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,p.createDecorator)("pathService");let b=C=class{constructor(m,h,g,n){this.localUserHome=m,this.remoteAgentService=h,this.environmentService=g,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=o?.userHome??m})()}hasValidBasename(m,h,g){return typeof h=="string"||typeof h>"u"?this.resolveOS.then(n=>this.doHasValidBasename(m,n,h)):this.doHasValidBasename(m,h,g)}doHasValidBasename(m,h,g){return m.scheme===d.Schemas.file||m.scheme===d.Schemas.vscodeRemote?(0,s.isValidBasename)(g??(0,L.basename)(m),h===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,h){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const g=(0,a.getVirtualWorkspaceScheme)(h.getWorkspace());if(g)return g;const n=h.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=h.getWorkspace().configuration;return o?o.scheme:d.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===R.OperatingSystem.Windows?T.win32:T.posix)}async fileURI(m){let h="";if(await this.resolveOS===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(h=m.substring(2),m="/"):(h=m.substring(2,n),m=m.substring(n)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:h,path:m,query:"",fragment:""})}};e.AbstractPathService=b,e.AbstractPathService=b=C=Xe([He(1,c.IRemoteAgentService),He(2,_.IWorkbenchEnvironmentService),He(3,I.IWorkspaceContextService)],b)}),define(_e[384],ye([1,0,261,59,4,60,3,2,45,266,12,72,152,93,46,158,26,21,18,25,36]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=u,e.mapHasAddress=D,e.mapHasAddressLocalhostOrAllInterfaces=w,e.makeAddress=P,e.isCandidatePort=E,s=ze(s);const t=10*1e3,i="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new o.RawContextKey("forwardedPortsViewEnabled",!1,s.localize(0,null));function u(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var v;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(v||(e.TunnelCloseReason=v={}));var y;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.UserTunnelSource={source:y.User,description:s.localize(1,null)},e.AutoTunnelSource={source:y.Auto,description:s.localize(2,null)};function D(N,O,x){const U=N.get(P(O,x));if(U)return U;if((0,C.isLocalhost)(O))for(const F of C.LOCALHOST_ADDRESSES){const H=P(F,x);if(N.has(H))return N.get(H)}else if((0,C.isAllInterfaces)(O))for(const F of C.ALL_INTERFACES_ADDRESSES){const H=P(F,x);if(N.has(H))return N.get(H)}}function w(N,O,x){const U=D(N,O,x);if(U)return U;const F=(0,C.isAllInterfaces)(O)?"localhost":(0,C.isLocalhost)(O)?"0.0.0.0":void 0;if(F)return D(N,F,x)}function P(N,O){return N+":"+O}var k;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(k||(e.OnPortForward=k={}));function E(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class S extends L.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.configurationService=O,this.portsAttributes=[],this._onDidChangeAttributes=new T.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(O.onDidChangeConfiguration(x=>{(x.affectsConfiguration(S.SETTING)||x.affectsConfiguration(S.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(O,x,U){let F=this.findNextIndex(O,x,U,this.portsAttributes,0);const H={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const j=this.portsAttributes[F];j.key===O?(H.onAutoForward=j.onAutoForward??H.onAutoForward,H.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:H.elevateIfNeeded,H.label=j.label??H.label,H.requireLocalPort=j.requireLocalPort,H.protocol=j.protocol):(H.onAutoForward=H.onAutoForward??j.onAutoForward,H.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:j.elevateIfNeeded,H.label=H.label??j.label,H.requireLocalPort=H.requireLocalPort!==void 0?H.requireLocalPort:void 0,H.protocol=H.protocol??j.protocol),F=this.findNextIndex(O,x,U,this.portsAttributes,F+1)}return H.onAutoForward!==void 0||H.elevateIfNeeded!==void 0||H.label!==void 0||H.requireLocalPort!==void 0||H.protocol!==void 0?H:this.getOtherAttributes()}hasStartEnd(O){return O.start!==void 0&&O.end!==void 0}hasHostAndPort(O){return O.host!==void 0&&O.port!==void 0&&(0,g.isString)(O.host)&&(0,g.isNumber)(O.port)}findNextIndex(O,x,U,F,H){if(H>=F.length)return-1;const j=!(0,C.isLocalhost)(x)&&!(0,C.isAllInterfaces)(x),B=F.slice(H).findIndex(V=>(0,g.isNumber)(V.key)?j?!1:V.key===O:this.hasStartEnd(V.key)?j?!1:O>=V.key.start&&O<=V.key.end:this.hasHostAndPort(V.key)?O===V.key.port&&x===V.key.host:U?V.key.test(U):!1);return B>=0?B+H:-1}readSetting(){const O=this.configurationService.getValue(S.SETTING);if(!O||!(0,g.isObject)(O))return[];const x=[];for(const F in O){if(F===void 0)continue;const H=O[F];let j;if(Number(F))j=Number(F);else if((0,g.isString)(F))if(S.RANGE.test(F)){const re=F.match(S.RANGE);j={start:Number(re[1]),end:Number(re[2])}}else if(S.HOST_AND_PORT.test(F)){const re=F.match(S.HOST_AND_PORT);j={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(F)}catch{}re&&(j=re)}j&&x.push({key:j,elevateIfNeeded:H.elevateIfNeeded,onAutoForward:H.onAutoForward,label:H.label,requireLocalPort:H.requireLocalPort,protocol:H.protocol})}const U=this.configurationService.getValue(S.DEFAULTS);return U&&(this.defaultPortAttributes={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.sortAttributes(x)}sortAttributes(O){function x(U,F){return(0,g.isNumber)(U.key)?U.key:F.hasStartEnd(U.key)?U.key.start:F.hasHostAndPort(U.key)?U.key.port:Number.MAX_VALUE}return O.sort((U,F)=>x(U,this)-x(F,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(O){switch(O){case C.ProvidedOnAutoForward.Notify:return k.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case C.ProvidedOnAutoForward.Silent:return k.Silent;case C.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(O,x,U){const H=this.configurationService.inspect(S.SETTING).userRemoteValue;let j;!H||!(0,g.isObject)(H)?j={}:j=(0,n.deepClone)(H),j[`${O}`]||(j[`${O}`]={});for(const re in x)j[`${O}`][re]=x[re];return this.configurationService.updateValue(S.SETTING,j,U)}}e.PortsAttributes=S;let M=class extends L.Disposable{constructor(O,x,U,F,H,j,re,B,V,X){super(),this.tunnelService=O,this.storageService=x,this.configurationService=U,this.environmentService=F,this.remoteAuthorityResolverService=H,this.workspaceContextService=j,this.logService=re,this.dialogService=B,this.extensionService=V,this.contextKeyService=X,this.inProgress=new Map,this._onForwardPort=new T.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new T.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new T.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new T.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new T.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new T.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new S(U),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async ee=>{const he=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=P(ne.tunnelRemoteHost,ne.tunnelRemotePort),pe=w(this._candidates??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:he?.get(ne.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(ne.localAddress,he?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:ne.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(De,ne)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async ee=>{const he=P(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!w(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!w(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!w(this.inProgress,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=w(this._candidates??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(he,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(he,ee),this._onForwardPort.fire(this.forwarded.get(he))})),this._register(this.tunnelService.onTunnelClosed(ee=>this.onTunnelClosed(ee,v.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(O=>O.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const O=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&O.dispose()}))}async onTunnelClosed(O,x){const U=P(O.host,O.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.storeForwarded(),this._onClosePort.fire(O))}makeLocalUri(O,x){if(O.startsWith("http"))return A.URI.parse(O);const U=x?.protocol??"http";return A.URI.parse(`${U}://${O}`)}async addStorageKeyPostfix(O){const x=this.workspaceContextService.getWorkspace(),U=x.configuration?(0,R.hash)(x.configuration.path):x.folders.length>0?(0,R.hash)(x.folders[0].uri.path):void 0;if(U===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.environmentService.remoteAuthority}.${U}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(i)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(r)}async getTunnelRestoreValue(){const O=this.storageService.get(i,c.StorageScope.WORKSPACE);if(O)return this.storageService.remove(i,c.StorageScope.WORKSPACE),await this.storeForwarded(),O;const x=await this.getTunnelRestoreStorageKey();if(x)return this.storageService.get(x,c.StorageScope.PROFILE)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const O=await this.tunnelRestoreValue;if(O&&O!==this.knownPortsRestoreValue){const x=JSON.parse(O)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${x.map(U=>U.remotePort).join(", ")}`);for(const U of x){const F=w(this.detected,U.remoteHost,U.remotePort);U.source.source!==y.Extension&&!F||U.source.source===y.Extension&&F?await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,elevateIfNeeded:!0,source:U.source}):U.source.source===y.Extension&&!F&&this.unrestoredExtensionTunnels.set(P(U.remoteHost,U.remotePort),U)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const O=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new L.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(c.StorageScope.PROFILE,void 0,this.restoreListener)(async x=>{x.key===O&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(O,c.StorageScope.PROFILE)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const O=this.storageService.keys(c.StorageScope.PROFILE,c.StorageTarget.USER).filter(x=>x.startsWith(r));for(const x of O){const U=this.storageService.getNumber(x,c.StorageScope.PROFILE);if(U&&U<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const F=x.replace(r,i);this.storageService.remove(x,c.StorageScope.PROFILE),this.storageService.remove(F,c.StorageScope.PROFILE)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),x=O.map(j=>({remoteHost:j.remoteHost,remotePort:j.remotePort,localPort:j.localPort,name:j.name,localAddress:j.localAddress,localUri:j.localUri,protocol:j.protocol,source:j.source}));let U;O.length>0&&(U=JSON.stringify(x));const F=await this.getTunnelRestoreStorageKey(),H=await this.getRestoreExpirationStorageKey();!U&&F&&H?(this.storageService.remove(F,c.StorageScope.PROFILE),this.storageService.remove(H,c.StorageScope.PROFILE)):U!==this.knownPortsRestoreValue&&F&&H&&(this.storageService.store(F,U,c.StorageScope.PROFILE,c.StorageTarget.USER),this.storageService.store(H,Date.now()+f,c.StorageScope.PROFILE,c.StorageTarget.USER)),this.knownPortsRestoreValue=U}}async showPortMismatchModalIfNeeded(O,x,U){if(!O.tunnelLocalPort||!U?.requireLocalPort||O.tunnelLocalPort===x)return;const F=new Date;if(this.mismatchCooldown.getTime()+t>F.getTime())return;this.mismatchCooldown=F;const H=s.localize(3,null,x,O.tunnelRemotePort,O.tunnelLocalPort);return this.dialogService.info(H)}async forward(O,x){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await T.Event.toPromise(this.onRestoreComplete.event),this.doForward(O,x)}async doForward(O,x){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const U=w(this.forwarded,O.remote.host,O.remote.port);x=x??(x!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const F=O.local!==void 0?O.local:O.remote.port;let H;if(U)return this.mergeAttributesIntoExistingTunnel(U,O,x);{const j=this.environmentService.remoteAuthority,re=j?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(j)).authority}:void 0,B=P(O.remote.host,O.remote.port);this.inProgress.set(B,!0),O=this.mergeCachedAndUnrestoredProperties(B,O);const V=await this.tunnelService.openTunnel(re,O.remote.host,O.remote.port,void 0,F,O.elevateIfNeeded?O.elevateIfNeeded:x?.elevateIfNeeded,O.privacy,x?.protocol);if(typeof V=="string")H=V;else if(V&&V.localAddress){const X=w(this._candidates??new Map,O.remote.host,O.remote.port),ee=V.protocol?V.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:x?.protocol??C.TunnelProtocol.Http,he={remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localPort:V.tunnelLocalPort,name:x?.label??O.name,closeable:!0,localAddress:V.localAddress,protocol:ee,localUri:await this.makeLocalUri(V.localAddress,x),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:O.source??e.UserTunnelSource,privacy:V.privacy};return this.forwarded.set(B,he),this.remoteTunnels.set(B,V),this.inProgress.delete(B),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(V,F,x),this._onForwardPort.fire(he),V}this.inProgress.delete(B)}return H}mergeCachedAndUnrestoredProperties(O,x){const U=this.unrestoredExtensionTunnels.has(O)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(O)?this.sessionCachedProperties:void 0;if(U){const F=U.get(O);U.delete(O),F&&(x.name=F.name??x.name,x.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??x.local,x.privacy=x.privacy)}return x}async mergeAttributesIntoExistingTunnel(O,x,U){const F=U?.label??x.name;let H;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(H||(H={}));let j=H.None;switch(F!==O.name&&(O.name=F,j=H.Fire),(U?.protocol||O.protocol!==C.TunnelProtocol.Http)&&U?.protocol!==O.protocol&&(x.source=O.source,j=H.Reopen),x.privacy&&O.privacy!==x.privacy&&(j=H.Reopen),j){case H.Fire:{this._onForwardPort.fire();break}case H.Reopen:await this.close(O.remoteHost,O.remotePort,v.User),await this.doForward(x,U)}return w(this.remoteTunnels,x.remote.host,x.remote.port)}async name(O,x,U){const F=w(this.forwarded,O,x),H=P(O,x);if(F){F.name=U,await this.storeForwarded(),this._onPortName.fire({host:O,port:x});return}else this.detected.has(H)&&(this.detected.get(H).name=U,this._onPortName.fire({host:O,port:x}))}async close(O,x,U){const F=P(O,x),H=this.forwarded.get(F);return U===v.AutoForwardEnd&&H&&H.source.source===y.Auto&&this.sessionCachedProperties.set(F,{local:H.localPort,name:H.name,privacy:H.privacy}),await this.tunnelService.closeTunnel(O,x),this.onTunnelClosed({host:O,port:x},U)}address(O,x){const U=P(O,x);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(O){if(O)for(const x of O){const U=w(this._candidates??new Map,x.remoteAddress.host,x.remoteAddress.port),F=typeof x.localAddress=="string"?x.localAddress:P(x.localAddress.host,x.localAddress.port);this.detected.set(P(x.remoteAddress.host,x.remoteAddress.port),{remoteHost:x.remoteAddress.host,remotePort:x.remoteAddress.port,localAddress:F,protocol:C.TunnelProtocol.Http,localUri:this.makeLocalUri(F),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:s.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(x.remoteAddress.host,x.remoteAddress.port,F,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(O){this._candidateFilter=O}async setCandidates(O){let x=O;this._candidateFilter&&(x=await this._candidateFilter(O));const U=this.updateInResponseToCandidates(x);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(F=>F.port).join(", ")}`),this._onCandidatesChanged.fire(U)}updateInResponseToCandidates(O){const x=this._candidates??new Map,U=new Map;return this._candidates=U,O.forEach(F=>{const H=P(F.host,F.port);U.set(H,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),x.has(H)&&x.delete(H);const j=w(this.forwarded,F.host,F.port);j&&(j.runningProcess=F.detail,j.hasRunningProcess=!0,j.pid=F.pid)}),x.forEach((F,H)=>{const j=u(H);if(!j)return;const re=w(this.forwarded,j.host,j.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const B=w(this.detected,j.host,j.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),x}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const O=Array.from(this.forwarded.values()),x=await this.getAttributes(O.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(x)for(const U of O){const F=x.get(U.remotePort);(F?.protocol||U.protocol!==C.TunnelProtocol.Http)&&F?.protocol!==U.protocol&&await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},F),F&&F.label&&F.label!==U.name&&await this.name(U.remoteHost,U.remotePort,F.label)}}async getAttributes(O,x=!0){const U=new Map,F=new Map;O.forEach(V=>{const X=w(this._candidates??new Map,C.LOCALHOST_ADDRESSES[0],V.port)??V;if(X){U.set(V.port,X);const ee=E(X)?X.pid:void 0;F.has(ee)||F.set(ee,[]),F.get(ee)?.push(V.port)}});const H=new Map;if(O.forEach(V=>{const X=this.configPortsAttributes.getAttributes(V.port,V.host,U.get(V.port)?.detail);X&&H.set(V.port,X)}),this.portAttributesProviders.length===0||!x)return H.size>0?H:void 0;const j=await Promise.all(this.portAttributesProviders.flatMap(V=>Array.from(F.entries()).map(X=>{const ee=X[1],he=U.get(ee[0]);return V.providePortAttributes(ee,he?.pid,he?.detail,h.CancellationToken.None)}))),re=new Map;if(j.forEach(V=>V.forEach(X=>{X&&re.set(X.port,X)})),!H&&!re)return;const B=new Map;return O.forEach(V=>{const X=H.get(V.port),ee=re.get(V.port);B.set(V.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??S.providedActionToAction(ee?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),B}addAttributesProvider(O){this.portAttributesProviders.push(O)}};e.TunnelModel=M,Xe([(0,d.debounce)(1e3)],M.prototype,"storeForwarded",null),e.TunnelModel=M=Xe([He(0,C.ITunnelService),He(1,c.IStorageService),He(2,p.IConfigurationService),He(3,l.IWorkbenchEnvironmentService),He(4,_.IRemoteAuthorityResolverService),He(5,b.IWorkspaceContextService),He(6,I.ILogService),He(7,a.IDialogService),He(8,m.IExtensionService),He(9,o.IContextKeyService)],M)}),define(_e[100],ye([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(L,A){this.line=L,this.character=A}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,A){return new s(0,0)}with(L){return new s(0,0)}}e.Position=s;class d{constructor(L,A,p,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(L,A),this.end=new s(p,a)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new d(0,0,0,0)}with(L){return new d(0,0,0,0)}}e.Range=d;var T;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}))}),define(_e[38],ye([1,0,19,39,25,33,13,5,17,14,100,9]),function(le,e,s,d,T,R,L,A,p,a,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=h,e.isFileMatch=g,e.isProgressMessage=n,e.getExcludes=D,e.pathIncludedInQuery=w,e.deserializeSearchError=E,e.serializeSearchError=S,e.isSerializedSearchComplete=M,e.isSerializedSearchSuccess=N,e.isSerializedFileMatch=O,e.isFilePatternMatch=x,e.resolvePatternsForProvider=F,e.hasSiblingPromiseFn=re,e.hasSiblingFn=B,d=ze(d),T=ze(T),R=ze(R),p=ze(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const c="\u27EA ",C=" characters skipped \u27EB",b=(c.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var l;(function(X){X[X.file=0]="file",X[X.text=1]="text",X[X.aiText=2]="aiText"})(l||(e.SearchProviderType=l={}));var m;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.aiText=3]="aiText"})(m||(e.QueryType=m={}));function h(X){return!!X.preview}function g(X){return!!X.resource}function n(X){return!!X.message}var o;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=t;class i{constructor(ee,he,ne,De){this.ranges=he,this.webviewIndex=De;const pe=Array.isArray(he)?he:[he];if(ne&&ne.matchLines===1&&r(pe)){ee=(0,L.getNLines)(ee,ne.matchLines);let G="",W=0,se=0;const ae=Math.floor(ne.charsPerLine/5),te=[];for(const ce of pe){const ue=Math.max(ce.startColumn-ae,0),Y=ce.startColumn+ne.charsPerLine;if(ue>se+ae+b){const oe=c+(ue-se)+C;G+=oe+ee.slice(ue,Y),W+=ue-(se+oe.length)}else G+=ee.slice(se,Y);te.push(new u(0,ce.startColumn-W,ce.endColumn-W)),se=Y}this.preview={text:G,matches:Array.isArray(this.ranges)?te:te[0]}}else{const G=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:ee,matches:(0,s.mapArrayOrNot)(he,W=>new f(W.startLineNumber-G,W.startColumn,W.endLineNumber-G,W.endColumn))}}}}e.TextSearchMatch=i;function r(X){const ee=X[0].startLineNumber;for(const he of X)if(he.startLineNumber!==ee||he.endLineNumber!==ee)return!1;return!0}class f{constructor(ee,he,ne,De){this.startLineNumber=ee,this.startColumn=he,this.endLineNumber=ne,this.endColumn=De}}e.SearchRange=f;class u extends f{constructor(ee,he,ne){super(ee,he,ee,ne)}}e.OneLineRange=u;var v;(function(X){X.List="list",X.Tree="tree"})(v||(e.ViewMode=v={}));var y;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function D(X,ee=!0){const he=X&&X.files&&X.files.exclude,ne=ee&&X&&X.search&&X.search.exclude;if(!he&&!ne)return;if(!he||!ne)return he||ne;let De=Object.create(null);return De=T.mixin(De,T.deepClone(he)),De=T.mixin(De,T.deepClone(ne),!0),De}function w(X,ee){return X.excludePattern&&d.match(X.excludePattern,ee)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&d.match(X.includePattern,ee)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(he=>{const ne=he.folder.fsPath;if(R.isEqualOrParent(ee,ne)){const De=p.relative(ne,ee);return!he.includePattern||!!d.match(he.includePattern,De)}else return!1}):!1:!0}var P;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class k extends Error{constructor(ee,he){super(ee),this.code=he}}e.SearchError=k;function E(X){const ee=X.message;if((0,a.isCancellationError)(X))return new k(ee,P.canceled);try{const he=JSON.parse(ee);return new k(he.message,he.code)}catch{return new k(ee,P.other)}}function S(X){const ee={message:X.message,code:X.code};return new Error(JSON.stringify(ee))}function M(X){return X.type==="error"?!0:X.type==="success"}function N(X){return X.type==="success"}function O(X){return!!X.path}function x(X,ee,he=!0){const ne=X.searchPath?X.searchPath:X.relativePath;return he?(0,L.fuzzyContains)(ne,ee):d.match(ee,ne)}class U{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function F(X,ee){const he={...X||{},...ee||{}};return Object.keys(he).filter(ne=>{const De=he[ne];return typeof De=="boolean"&&De})}class H{constructor(ee,he){this._parsedIncludeExpression=null,this._excludeExpression={...ee.excludePattern||{},...he.excludePattern||{}},this._parsedExcludeExpression=d.parse(this._excludeExpression);let ne=ee.includePattern;he.includePattern&&(ne?ne={...ne,...he.includePattern}:ne=he.includePattern),ne&&(this._parsedIncludeExpression=d.parse(ne))}matchesExcludesSync(ee,he,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,he,ne))}includedInQuerySync(ee,he,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,he,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ee,he,ne))}includedInQuery(ee,he,ne){const De=this._parsedExcludeExpression(ee,he,ne),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ee,he,ne):!0;return(0,_.isThenable)(De)?De.then(G=>G?!1:pe()):pe()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=H;function j(X){for(const ee in X)if(typeof X[ee]!="boolean")return!0;return!1}function re(X){if(!X)return;let ee;return he=>(ee||(ee=(X()||Promise.resolve([])).then(ne=>ne?V(ne):{})),ee.then(ne=>!!ne[he]))}function B(X){if(!X)return;let ee;return he=>{if(!ee){const ne=X();ee=ne?V(ne):{}}return!!ee[he]}}function V(X){const ee={};for(const he of X)ee[he]=!0;return ee}}),define(_e[48],ye([1,0,19,9,21,4,3,85,15,134,23,13,2,245,28,5,12,280,46,63,30,20,16,10,73,38,6,57]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D(O,x,U){return new I.ExtUri(F=>E(F,U)).isEqual(O,x)}function w(O,x,U){return D(O.uri,x.uri,U)?0:(0,_.compare)(O.uri.toString(),x.uri.toString())}function P(O,x,U){return O.index!==x.index?O.index<x.index?-1:1:D(O.uri,x.uri,U)?(0,_.compare)(O.name,x.name):(0,_.compare)(O.uri.toString(),x.uri.toString())}function k(O,x,U,F){const H=O.slice(0).sort((re,B)=>U(re,B,F)),j=x.slice(0).sort((re,B)=>U(re,B,F));return(0,s.delta)(H,j,(re,B)=>U(re,B,F))}function E(O,x){const U=x.getCapabilities(O.scheme);return!(U&&U&b.FileSystemProviderCapabilities.PathCaseSensitive)}class S extends g.Workspace{static toExtHostWorkspace(x,U,F,H){if(!x)return{workspace:null,added:[],removed:[]};const{id:j,name:re,folders:B,configuration:V,transient:X,isUntitled:ee}=x,he=[],ne=U;U?B.forEach((W,se)=>{const ae=c.URI.revive(W.uri),te=S._findFolder(F||U,ae,H);te?(te.name=W.name,te.index=W.index,he.push(te)):he.push({uri:ae,name:W.name,index:se})}):he.push(...B.map(({uri:W,name:se,index:ae})=>({uri:c.URI.revive(W),name:se,index:ae}))),he.sort((W,se)=>W.index<se.index?-1:1);const De=new S(j,re,he,!!X,V?c.URI.revive(V):null,!!ee,W=>E(W,H)),{added:pe,removed:G}=k(ne?ne.workspaceFolders:[],De.workspaceFolders,w,H);return{workspace:De,added:pe,removed:G}}static _findFolder(x,U,F){for(let H=0;H<x.folders.length;H++){const j=x.workspaceFolders[H];if(D(j.uri,U,F))return j}}constructor(x,U,F,H,j,re,B){super(x,F.map(V=>new g.WorkspaceFolder(V)),H,j,B),this._name=U,this._isUntitled=re,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(B,()=>!0),F.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,U){return U&&this._structure.get(x)&&(x=(0,I.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let M=class{constructor(x,U,F,H,j){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=H,this._extHostFileSystemInfo=F,this._uriTransformerService=j,this._requestIdProvider=new a.Counter,this._barrier=new d.Barrier,this._proxy=x.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(v.MainContext.MainThreadMessageService);const re=U.workspace;this._confirmedWorkspace=re?new S(re.id,re.name,[],!!re.transient,re.configuration?c.URI.revive(re.configuration):null,!!re.isUntitled,B=>E(B,F)):void 0}$initializeWorkspace(x,U){this._trusted=U,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:p.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,U,F,...H){const j=[];if(Array.isArray(H)&&H.forEach(ee=>{c.URI.isUri(ee.uri)&&!j.some(he=>D(he.uri,ee.uri,this._extHostFileSystemInfo))&&j.push({uri:ee.uri,name:ee.name||(0,I.basenameOrAuthority)(ee.uri)})}),this._unconfirmedWorkspace||[U,F].some(ee=>typeof ee!="number"||ee<0)||F===0&&j.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+F>re.length)return!1;const B=re.slice(0);B.splice(U,F,...j.map(ee=>({uri:ee.uri,name:ee.name||(0,I.basenameOrAuthority)(ee.uri),index:void 0})));for(let ee=0;ee<B.length;ee++){const he=B[ee];if(B.some((ne,De)=>De!==ee&&D(he.uri,ne.uri,this._extHostFileSystemInfo)))return!1}B.forEach((ee,he)=>ee.index=he);const{added:V,removed:X}=k(re,B,P,this._extHostFileSystemInfo);if(V.length===0&&X.length===0)return!1;if(this._proxy){const ee=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(ee,U,F,j).then(void 0,he=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(h.Severity.Error,(0,C.localize)(0,null,ee,he.toString()),ne,[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(x,U){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,U)}async getWorkspaceFolder2(x,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,U)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,U){let F,H="";if(typeof x=="string"?(F=c.URI.file(x),H=x):typeof x<"u"&&(F=x,H=x.fsPath),!F)return H;const j=this.getWorkspaceFolder(F,!0);if(!j)return H;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let re=(0,I.relativePath)(j.uri,F);return U&&j.name&&(re=`${j.name}/${re}`),re}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:U,added:F,removed:H}=S.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:H}))}findFiles(x,U,F,H,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let re="",B=!0;return U===null?B=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this._findFilesImpl(x,void 0,{exclude:re,maxResults:F,useDefaultExcludes:B,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},j)}findFiles2(x,U={},F,H=T.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,x,U,H)}async _findFilesImpl(x,U,F,H=T.CancellationToken.None){if(H&&H.isCancellationRequested)return Promise.resolve([]);const j=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:j,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let B;if(x){const{includePattern:V,folder:X}=N(i.GlobPattern.from(x));B=X,re.includePattern=V}else{const{includePattern:V,folder:X}=N(i.GlobPattern.from(U));B=X,re.filePattern=V}return this._proxy.$startFileSearch(B??null,re,H).then(V=>Array.isArray(V)?V.map(X=>c.URI.revive(X)):[])}async findTextInFiles(x,U,F,H,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),B=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:V,folder:X}=N(i.GlobPattern.from(U.include)),ee=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,he={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:B,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:V,excludePattern:ee},ne=!1;if(this._activeSearchCallbacks[re]=De=>{if(ne)return;const pe=c.URI.revive(De.resource);De.results.forEach(G=>{const W=(0,y.revive)(G);(0,u.resultIsMatch)(W)?F({uri:pe,preview:{text:W.preview.text,matches:(0,s.mapArrayOrNot)(W.preview.matches,se=>new r.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,s.mapArrayOrNot)(W.ranges,se=>new r.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):F({uri:pe,text:W.text,lineNumber:W.lineNumber})})},j.isCancellationRequested)return{};try{const De=await this._proxy.$startTextSearch(x,X??null,he,re,j);return delete this._activeSearchCallbacks[re],De||{}}catch(De){throw delete this._activeSearchCallbacks[re],De}}$handleTextSearchResult(x,U){this._activeSearchCallbacks[U]?.(x)}async save(x){const U=await this._proxy.$save(x,{saveAs:!1});return c.URI.revive(U)}async saveAs(x){const U=await this._proxy.$save(x,{saveAs:!0});return c.URI.revive(U)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,U){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,U);const F=this._uriTransformerService.transformOutgoingScheme(x),H=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(H,F),(0,L.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(H)})}async $getEditSessionIdentifier(x,U){this._logService.info("Getting edit session identifier for workspaceFolder",x);const F=await this.resolveWorkspaceFolder(c.URI.revive(x));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const H=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!H),!H)return;const j=await H.provideEditSessionIdentity(F,U);if(this._logService.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(x,U,F,H){this._logService.info("Getting edit session identifier for workspaceFolder",x);const j=await this.resolveWorkspaceFolder(c.URI.revive(x));if(!j){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const re=this._editSessionIdentityProviders.get(j.uri.scheme);if(this._logService.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!re),!re)return;const B=await re.provideEditSessionIdentityMatch?.(U,F,H);if(this._logService.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(x){return(U,F,H)=>{const j=function(B){U.call(F,B)};return j.extension=x,this._onWillCreateEditSessionIdentityEvent.event(j,void 0,H)}}async $onWillCreateEditSessionIdentity(x,U,F){const H=await this.resolveWorkspaceFolder(c.URI.revive(x));if(H===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:H},U,async(j,re)=>{const B=Date.now();await Promise.resolve(j),Date.now()-B>F&&this._logService.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(x,U){if(this._canonicalUriProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._canonicalUriProviders.set(x,U);const F=this._uriTransformerService.transformOutgoingScheme(x),H=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(H,F),(0,L.toDisposable)(()=>{this._canonicalUriProviders.delete(x),this._proxy.$unregisterCanonicalUriProvider(H)})}async provideCanonicalUri(x,U,F){const H=this._canonicalUriProviders.get(x.scheme);if(!H)return;const j=await H.provideCanonicalUri?.(c.URI.revive(x),U,F);if(j)return j}async $provideCanonicalUri(x,U,F){return this.provideCanonicalUri(c.URI.revive(x),{targetScheme:U},F)}};e.ExtHostWorkspace=M,e.ExtHostWorkspace=M=Xe([He(0,t.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,n.IExtHostFileSystemInfo),He(3,m.ILogService),He(4,f.IURITransformerService)],M),e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function N(O){let x,U;return O&&(typeof O=="string"?x=O:(x=O.pattern,U=c.URI.revive(O.baseUri))),{includePattern:x,folder:U}}}),define(_e[42],ye([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(f,u){if(u){const v=u.split(".");let y=f;for(let D=0;y&&D<v.length;D++)y=y[v[D]];return y}}function h(f){return f instanceof l.URI}function g(f){return f&&f.uri instanceof l.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof l.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function t(f){if(h(f))return{resource:f};if(g(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let i=class{constructor(u,v,y){this._proxy=u.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=v,this._logService=y,this._barrier=new _.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new r(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,v){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(u,v))}};e.ExtHostConfiguration=i,e.ExtHostConfiguration=i=Xe([He(0,C.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,b.ILogService)],i);class r{constructor(u,v,y,D){this._onDidChangeConfiguration=new d.Emitter,this._proxy=u,this._logService=D,this._extHostWorkspace=v,this._configuration=p.Configuration.parse(y,D),this._configurationScopes=this._toMap(y.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,v){const y={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=p.Configuration.parse(u,this._logService),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(v,y))}getConfiguration(u,v,y){const D=t(v)||{},w=this._toReadonlyValue(u?m(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,D,y?.identifier);function P(E){if(E==null)return null;if(typeof E=="boolean")return E?A.ConfigurationTarget.USER:A.ConfigurationTarget.WORKSPACE;switch(E){case L.ConfigurationTarget.Global:return A.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return A.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return A.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(E){return typeof m(w,E)<"u"},get:(E,S)=>{this._validateConfigurationAccess(u?`${u}.${E}`:E,D,y?.identifier);let M=m(w,E);if(typeof M>"u")M=S;else{let N;const O=(x,U)=>{if((0,I.isObject)(x)){let F;const H=()=>{N=N||(0,s.deepClone)(w),F=F||m(N,U)};return new Proxy(x,{get:(j,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return H(),()=>F;if(N)return F=F||m(N,U),F[re];const B=j[re];return typeof re=="string"?O(B,`${U}.${re}`):B},set:(j,re,B)=>(H(),F&&(F[re]=B),!0),deleteProperty:(j,re)=>(H(),F&&delete F[re],!0),defineProperty:(j,re,B)=>(H(),F&&Object.defineProperty(F,re,B),!0)})}return Array.isArray(x)?(0,s.deepClone)(x):x};M=O(M,E)}return M},update:(E,S,M,N)=>{E=u?`${u}.${E}`:E;const O=P(M);return S!==void 0?this._proxy.$updateConfigurationOption(O,E,S,D,N):this._proxy.$removeConfigurationOption(O,E,D,N)},inspect:E=>{E=u?`${u}.${E}`:E;const S=this._configuration.inspect(E,D,this._extHostWorkspace.workspace);if(S)return{key:E,defaultValue:(0,s.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,s.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,s.deepClone)(S.workspace?.value),workspaceFolderValue:(0,s.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,s.deepClone)(S.default?.override),globalLanguageValue:(0,s.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,s.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,s.deepClone)(S.workspaceFolder?.override),languageIds:(0,s.deepClone)(S.overrideIdentifiers)}}};return typeof w=="object"&&(0,s.mixin)(k,w,!1),Object.freeze(k)}_toReadonlyValue(u){const v=y=>(0,I.isObject)(y)?new Proxy(y,{get:(D,w)=>v(D[w]),set:(D,w,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(D,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(D,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return v(u)}_validateConfigurationAccess(u,v,y){const D=a.OVERRIDE_PROPERTY_REGEX.test(u)?a.ConfigurationScope.RESOURCE:this._configurationScopes.get(u),w=y?`[${y.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof v?.resource>"u"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){v?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,v){const y=new p.ConfigurationChangeEvent(u,v,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(D,w)=>y.affectsConfiguration(D,t(w))})}_toMap(u){return u.reduce((v,y)=>(v.set(y[0],y[1]),v),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,c.createDecorator)("IExtHostConfiguration")}),define(_e[101],ye([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=ze(L),m=ze(m);var t;(function(N){function O(U){if(U!=null)return U}N.from=O;function x(U){if(U!=null)return U}N.to=x})(t||(t={}));var i;(function(N){function O(U){if(U!=null)return U}N.from=O;function x(U){if(U!=null)return U}N.to=x})(i||(i={}));var r;(function(N){function O(U){if(U!=null)return U}N.from=O;function x(U){if(U!=null)return U}N.to=x})(r||(r={}));var f;(function(N){function O(F){if(F){const H=F;return H&&!!H.process}else return!1}N.is=O;function x(F){if(F==null)return;const H={process:F.process,args:F.args};return F.options&&(H.options=r.from(F.options)),H}N.from=x;function U(F){if(F!=null)return new L.ProcessExecution(F.process,F.args,F.options)}N.to=U})(f||(f={}));var u;(function(N){function O(U){if(U!=null)return U}N.from=O;function x(U){if(U!=null)return U}N.to=x})(u||(u={}));var v;(function(N){function O(F){if(F){const H=F;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=O;function x(F){if(F==null)return;const H={};return F.commandLine!==void 0?H.commandLine=F.commandLine:(H.command=F.command,H.args=F.args),F.options&&(H.options=u.from(F.options)),H}N.from=x;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.ShellExecution(F.commandLine,F.options):new L.ShellExecution(F.command,F.args?F.args:[],F.options)}N.to=U})(v||(v={}));var y;(function(N){function O(F){if(F){const H=F;return H&&H.customExecution==="customExecution"}else return!1}N.is=O;function x(F){return{customExecution:"customExecution"}}N.from=x;function U(F,H){return H.get(F)}N.to=U})(y||(e.CustomExecutionDTO=y={}));var D;(function(N){function O(x,U){let F;return x.scope!==void 0&&typeof x.scope!="number"?F=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===L.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=n.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:F}}N.from=O})(D||(e.TaskHandleDTO=D={}));var w;(function(N){function O(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}N.from=O})(w||(w={}));var P;(function(N){function O(F,H){if(F==null)return[];const j=[];for(const re of F){const B=x(re,H);B&&j.push(B)}return j}N.fromMany=O;function x(F,H){if(F==null)return;let j;F.execution instanceof L.ProcessExecution?j=f.from(F.execution):F.execution instanceof L.ShellExecution?j=v.from(F.execution):F.execution&&F.execution instanceof L.CustomExecution&&(j=y.from(F.execution));const re=t.from(F.definition);let B;return F.scope?typeof F.scope=="number"?B=F.scope:B=F.scope.uri:B=L.TaskScope.Workspace,!re||!B?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:H.identifier.value,label:F.source,scope:B},execution:j,isBackground:F.isBackground,group:w.from(F.group),presentationOptions:i.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=x;async function U(F,H,j){if(F==null)return;let re;f.is(F.execution)?re=f.to(F.execution):v.is(F.execution)?re=v.to(F.execution):y.is(F.execution)&&(re=y.to(F._id,j));const B=t.to(F.definition);let V;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?V=F.source.scope:V=await H.resolveWorkspaceFolder(s.URI.revive(F.source.scope)):V=L.TaskScope.Workspace),!B||!V)return;const X=new L.Task(B,V,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(X.isBackground=F.isBackground),F.group!==void 0&&(X.group=L.TaskGroup.from(F.group._id),X.group&&F.group.isDefault&&(X.group=new L.TaskGroup(X.group.id,X.group.label),F.group.isDefault===!0&&(X.group.isDefault=F.group.isDefault))),F.presentationOptions&&(X.presentationOptions=i.to(F.presentationOptions)),F._id&&(X._id=F._id),F.detail&&(X.detail=F.detail),X}N.to=U})(P||(e.TaskDTO=P={}));var k;(function(N){function O(U){return U}N.from=O;function x(U){if(U)return Object.assign(Object.create(null),U)}N.to=x})(k||(k={}));class E{#e;constructor(O,x,U){this._id=x,this._task=U,this.#e=O}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let S=class{constructor(O,x,U,F,H,j,re,B){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=O.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=H,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,x,U){if(!U)return new L.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:x,provider:U,extension:O}),this._proxy.$registerTaskProvider(F,x),new L.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(O,x){this._proxy.$registerTaskSystem(O,x)}fetchTasks(O){return this._proxy.$fetchTasks(k.from(O)).then(async x=>{const U=[];for(const F of x){const H=await P.to(F,this._workspaceProvider,this._providedCustomExecutions2);H&&U.push(H)}return U})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(x=>O.push(x)),O}terminateTask(O){if(!(O instanceof E))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,x,U){const F=this._providedCustomExecutions2.get(O.id);F&&(this._activeCustomExecutions2.set(O.id,F),this._terminalService.attachPtyToTerminal(x,await F.callback(U))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){if(!this._taskExecutionPromises.has(O.id))return;const x=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const x=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:x,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const x=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:O.exitCode})}$provideTasks(O,x){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));const F=[],H=(0,d.asPromise)(()=>U.provider.provideTasks(I.CancellationToken.None)).then(j=>this.provideTasksInternal(x,F,U,j));return new Promise(j=>{H.then(re=>{Promise.all(F).then(()=>{j(re)})})})}async $resolveTask(O,x){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));if(x.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await P.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const H=await U.provider.resolveTask(F,I.CancellationToken.None);if(!H)return;this.checkDeprecation(H,U);const j=P.from(H,U.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(j.execution)&&await this.addCustomExecution(j,H,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,x,U){const F=await this._proxy.$createTaskId(O);!U&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,x.execution)),this._providedCustomExecutions2.set(F,x.execution)}async getTaskExecution(O,x){if(typeof O=="string"){const H=this._taskExecutionPromises.get(O);if(!H)throw new o.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const U=this._taskExecutionPromises.get(O.id);if(U)return U;let F;return x?F=Promise.resolve(new E(this,O.id,x)):F=P.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>{if(!H)throw new o.ErrorNoTelemetry("Unexpected: Task does not exist.");return new E(this,O.id,H)}),this._taskExecutionPromises.set(O.id,F),F.then(H=>(this._taskExecutions.set(O.id,H),H))}checkDeprecation(O,x){O._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const U=this._notProvidedCustomExecutions.values();let F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};e.ExtHostTaskBase=S,e.ExtHostTaskBase=S=Xe([He(0,c.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,p.IExtHostDocumentsAndEditors),He(4,a.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,h.ILogService),He(7,g.IExtHostApiDeprecationService)],S);let M=class extends S{constructor(O,x,U,F,H,j,re,B){super(O,x,U,F,H,j,re,B),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(m.Platform.Web)})}async executeTask(O,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const U=P.from(x,O);if(U===void 0)throw new Error("Task is not valid");if(y.is(U.execution))await this.addCustomExecution(U,x,!1);else throw new o.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),x);return this._proxy.$executeTask(U).catch(H=>{throw new Error(H)}),F}provideTasksInternal(O,x,U,F){const H=[];if(F)for(const j of F){if(this.checkDeprecation(j,U),!j.definition||!O[j.definition.type]){const B=j.source?j.source:"No task source";this._logService.warn(`The task [${B}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=P.from(j,U.extension);re&&y.is(re.execution)?(H.push(re),x.push(this.addCustomExecution(re,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:U.extension}}async resolveTaskInternal(O){if(y.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,x,U){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=Xe([He(0,c.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,p.IExtHostDocumentsAndEditors),He(4,a.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,h.ILogService),He(7,g.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,b.createDecorator)("IExtHostTask")}),define(_e[385],ye([1,0,38,31]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=T,e.genericCellMatchesToTextSearchMatches=R;function T(L){return"cellResults"in L}e.rawCellPrefix="rawCell#";function R(L,A){let p=-1;const a=[];let I=[];return L.forEach(c=>{c.range.startLineNumber!==p&&I.length>0&&(a.push([...I]),I=[]),I.push(c),p=c.range.endLineNumber}),I.length>0&&a.push([...I]),a.map(c=>{const C=[],b=c[0].range.startLineNumber,l=c[c.length-1].range.endLineNumber;for(let m=b;m<=l;m++)C.push(A.getLineContent(m));return new s.TextSearchMatch(C.join(`
`)+`
`,c.map(m=>new d.Range(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(_e[386],ye([1,0,239,22,4,3,29,41,13,18,2,28,119,6,35,16,10,52,358,165,25,15,38,314,385,382]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,_=ze(_),l=ze(l),m=ze(m);class v{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(D=>D.apiEditor)}constructor(D,w,P,k,E,S,M){this._textDocumentsAndEditors=P,this._textDocuments=k,this._extHostFileSystem=E,this._extHostSearch=S,this._logService=M,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new c.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=D.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=D.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=D.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===A.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,x=N.cell.handle,F=this._documents.get(O)?.getCell(x);if(F)return F.apiCell}if(N&&N.$mid===A.MarshalledId.NotebookActionContext){const O=N.uri,x=this._documents.get(O);if(x)return x.apiNotebook}return N}}),v._registerApiCommands(w)}getEditorById(D){const w=this._editors.get(D);if(!w)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(D){for(const[w,P]of this._editors)if(P.apiEditor===D)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(D,w){const P=this._documents.get(D);if(!P&&!w)throw new Error(`NO notebook document for '${D}'`);return P}static _convertNotebookRegistrationData(D,w){if(!w)return;const P=w.filenamePattern.map(k=>l.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(w.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:w.displayName,filenamePattern:P,priority:w.exclusive?u.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,w,P){const k=v._notebookStatusBarItemProviderHandlePool++,E=typeof P.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(k,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(k,E,w);let S;return E!==void 0&&(S=P.onDidChangeCellStatusBarItems(M=>this._notebookProxy.$emitCellStatusBarEvent(E))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(k),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(k,E),S?.dispose()})}async createNotebookDocument(D){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:D.viewType,content:D.content&&l.NotebookData.from(D.content)});return I.URI.revive(w)}async openNotebookDocument(D){const w=this._documents.get(D);if(w)return w.apiNotebook;const P=await this._notebookDocumentsProxy.$tryOpenNotebook(D),k=this._documents.get(I.URI.revive(P));return(0,a.assertIsDefined)(k?.apiNotebook)}async showNotebookDocument(D,w){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let P;typeof w=="object"?P={position:l.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(l.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:P={preserveFocus:!1};const k=await this._notebookEditorsProxy.$tryShowNotebookDocument(D.uri,D.notebookType,P),E=k&&this._editors.get(k)?.apiEditor;if(E)return E;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,w,P,k){const E=this._notebookStatusBarItemProviders.get(D),S=I.URI.revive(w),M=this._documents.get(S);if(!M||!E)return;const N=M.getCellFromIndex(P);if(!N)return;const O=await E.provideCellStatusBarItems(N.apiCell,k);if(!O)return;const x=new R.DisposableStore,U=this._statusBarCache.add([x]),H=(Array.isArray(O)?O:[O]).map(j=>l.NotebookStatusBarItem.from(j,this._commandsConverter,x));return{cacheId:U,items:H}}$releaseNotebookCellStatusBarItems(D){this._statusBarCache.delete(D)}registerNotebookSerializer(D,w,P,k,E){if((0,p.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const S=this._handlePool++;return this._notebookSerializer.set(S,{viewType:w,serializer:P,options:k}),this._notebookProxy.$registerNotebookSerializer(S,{id:D.identifier,location:D.extensionLocation},w,l.NotebookDocumentContentOptions.from(k),v._convertNotebookRegistrationData(D,E)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(S)})}async $dataToNotebook(D,w,P){const k=this._notebookSerializer.get(D);if(!k)throw new Error("NO serializer found");const E=await k.serializer.deserializeNotebook(w.buffer,P);return new h.SerializableObjectWithBuffers(l.NotebookData.from(E))}async $notebookToData(D,w,P){const k=this._notebookSerializer.get(D);if(!k)throw new Error("NO serializer found");const E=await k.serializer.serializeNotebook(l.NotebookData.to(w.value),P);return d.VSBuffer.wrap(E)}async $saveNotebook(D,w,P,k,E){const S=I.URI.revive(w),M=this._notebookSerializer.get(D);if(this.trace(`enter saveNotebook(versionId: ${P}, ${S.toString()})`),!M)throw new Error("NO serializer found");const N=this._documents.get(S);if(!N)throw new Error("Document NOT found");if(N.versionId!==P)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(S.scheme))throw new _.FileOperationError((0,s.localize)(0,null,this._resourceForError(S)),_.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,o.filter)(N.apiNotebook.metadata,j=>!(M.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of N.apiNotebook.getCells()){const re=new m.NotebookCellData(j.kind,j.document.getText(),j.document.languageId,j.mime,M.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);re.metadata=(0,o.filter)(j.metadata,B=>!(M.options?.transientCellMetadata??{})[B]),O.cells.push(re)}if(await this._validateWriteFile(S,k),E.isCancellationRequested)throw new Error("canceled");const x=await M.serializer.serializeNotebook(O,E);if(E.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${P} ${S.toString()}`),await this._extHostFileSystem.value.writeFile(S,x),this.trace(`Finished write versionId: ${P} ${S.toString()}`);const U=this._extHostFileSystem.getFileSystemProviderExtUri(S.scheme),F=await this._extHostFileSystem.value.stat(S),H={name:U.basename(S),isFile:(F.type&_.FileType.File)!==0,isDirectory:(F.type&_.FileType.Directory)!==0,isSymbolicLink:(F.type&_.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&_.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(S.scheme),locked:!!((F.permissions??0)&_.FilePermission.Locked),etag:_.etag({mtime:F.mtime,size:F.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${P}, ${S.toString()})`),H}async $searchInNotebooks(D,w,P,k,E){const S=this._notebookSerializer.get(D)?.serializer;if(!S)return{limitHit:!1,results:[]};const M=new L.ResourceSet;await(async(F,H,j)=>{await Promise.all(F.map(async re=>await Promise.all(re.filenamePatterns.map(B=>{const V={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:i.QueryType.File,filePattern:B};return this._extHostSearch.doInternalFileSearchWithCustomCallback(V,H,X=>{X.forEach(ee=>{M.has(ee)||k.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,u.globMatchesResource)(De,ee)))||M.add(ee)})}).catch(X=>{if(X.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw X})}))))})(P,E,w);const O=new L.ResourceMap;let x=!1;const U=Array.from(M).map(async F=>{const H=[];try{if(E.isCancellationRequested)return;if(w.maxResults&&[...O.values()].reduce((V,X)=>V+X.cellResults.length,0)>w.maxResults){x=!0;return}const j=[],re=this._documents.get(F);if(re)re.apiNotebook.getCells().forEach(X=>j.push({input:X.document.getText(),outputs:X.outputs.flatMap(ee=>ee.items.map(he=>he.data.toString()))}));else{const V=await this._extHostFileSystem.value.readFile(F),X=d.VSBuffer.fromString(V.toString()),ee=await S.deserializeNotebook(X.buffer,E);if(E.isCancellationRequested)return;l.NotebookData.from(ee).cells.forEach(ne=>j.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map(pe=>pe.valueBytes.toString()))}))}if(E.isCancellationRequested)return;j.forEach((V,X)=>{const ee=w.contentPattern.pattern,he=new r.CellSearchModel(V.input,void 0,V.outputs),ne=he.findInInputs(ee),De=he.findInOutputs(ee),pe=De.flatMap(G=>(0,f.genericCellMatchesToTextSearchMatches)(G.matches,G.textBuffer)).map((G,W)=>(G.webviewIndex=W,G));if(ne.length>0||De.length>0){const G={index:X,contentResults:(0,f.genericCellMatchesToTextSearchMatches)(ne,he.inputTextBuffer),webviewResults:pe};H.push(G)}});const B={resource:F,cellResults:H};O.set(F,B);return}catch{return}});return await Promise.all(U),{limitHit:x,results:[...O.values()]}}async _validateWriteFile(D,w){const P=await this._extHostFileSystem.value.stat(D);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==_.ETAG_DISABLED&&typeof P.mtime=="number"&&typeof P.size=="number"&&w.mtime<P.mtime&&w.etag!==_.etag({mtime:w.mtime,size:P.size}))throw new _.FileOperationError((0,s.localize)(1,null),_.FileOperationResult.FILE_MODIFIED_SINCE,w)}_resourceForError(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}_createExtHostEditor(D,w,P){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const k=new n.ExtHostNotebookEditor(w,this._notebookEditorsProxy,D,P.visibleRanges.map(l.NotebookRange.to),P.selections.map(l.NotebookRange.to),typeof P.viewColumn=="number"?l.ViewColumn.to(P.viewColumn):void 0);this._editors.set(w,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const P of D.value.removedDocuments){const k=I.URI.revive(P),E=this._documents.get(k);E&&(E.dispose(),this._documents.delete(k),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===k.toString()&&this._editors.delete(S.id)}if(D.value.addedDocuments){const P=[];for(const k of D.value.addedDocuments){const E=I.URI.revive(k.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const S=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,E,k);P.push(...k.cells.map(M=>g.ExtHostCell.asModelAddData(M))),this._documents.get(E)?.dispose(),this._documents.set(E,S),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this._onDidOpenNotebookDocument.fire(S.apiNotebook)}}if(D.value.addedEditors)for(const P of D.value.addedEditors){if(this._editors.has(P.id))return;const k=I.URI.revive(P.documentUri),E=this._documents.get(k);E&&this._createExtHostEditor(E,P.id,P)}const w=[];if(D.value.removedEditors)for(const P of D.value.removedEditors){const k=this._editors.get(P);k&&(this._editors.delete(P),this._activeNotebookEditor?.id===k.id&&(this._activeNotebookEditor=void 0),w.push(k))}if(D.value.visibleEditors){this._visibleNotebookEditors=D.value.visibleEditors.map(k=>this._editors.get(k)).filter(k=>!!k);const P=new Set;this._visibleNotebookEditors.forEach(k=>P.add(k.id));for(const k of this._editors.values()){const E=P.has(k.id);k._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(k=>k).filter(k=>k.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this._activeNotebookEditor=void 0:D.value.newActiveEditor&&(this._editors.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(D){const w=b.ApiCommandArgument.String.with("notebookType","A notebook type"),P=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new b.ApiCommandArgument("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>d.VSBuffer.wrap(E))],new b.ApiCommandResult("Notebook Data",E=>l.NotebookData.to(E.value))),k=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new h.SerializableObjectWithBuffers(l.NotebookData.from(E)))],new b.ApiCommandResult("Bytes",E=>E.buffer));D.registerApiCommand(P),D.registerApiCommand(k)}trace(D){this._logService.trace(`[Extension Host Notebook] ${D}`)}}e.ExtHostNotebookController=v}),define(_e[387],ye([1,0,17,21,51,39,23,43,38]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,s=ze(s),R=ze(R),L=ze(L);class a{constructor(c,C,b){this.config=c,this.provider=C,this.sessionToken=b,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&R.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&R.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const C=this.config.folderQueries||[];return new Promise((b,l)=>{const m=h=>{this.resultCount++,c(h)};if(this.isCanceled)return b({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const g=h.toString(),n=s.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,n)||this.matchFile(m,{base:h,basename:n})}),Promise.all(C.map(h=>this.searchInFolder(h,m))).then(h=>{b({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{l(new Error((0,T.toErrorMessage)(h)))})})}async searchInFolder(c,C){const b=new d.CancellationTokenSource,l=this.getSearchOptionsForFolder(c),m=this.initDirectoryTree(),h=new p.QueryGlobTester(this.config,c),g=!h.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(b),n=A.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,b.token),t=n.elapsed(),i=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(r=>{const f=s.posix.relative(c.folder.path,r.path);if(g){const u=s.basename(r.path);this.matchFile(C,{base:c.folder,relativePath:f,basename:u});return}this.addDirectoryEntries(m,c.folder,f,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,h,C),{providerTime:t,postProcessTime:i.elapsed()})}finally{b.dispose(),this.activeCancellationTokens.delete(b)}}getSearchOptionsForFolder(c){const C=(0,p.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),b=(0,p.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:b,includes:C,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},C,b,l){if(b===this.filePattern){const h=s.basename(this.filePattern);this.matchFile(l,{base:C,relativePath:this.filePattern,basename:h})}function m(h){const g=s.basename(h),n=s.dirname(h);let o=c[n];o||(o=c[n]=[],m(n)),o.push({base:C,relativePath:h,basename:g})}m(b)}matchDirectoryTree({rootEntries:c,pathToEntries:C},b,l){const m=this,h=this.filePattern;function g(n){const o=(0,p.hasSiblingFn)(()=>n.map(t=>t.basename));for(let t=0,i=n.length;t<i;t++){const r=n[t],{relativePath:f,basename:u}=r;if(b.matchesExcludesSync(f,u,h!==u?o:void 0))continue;const v=C[f];if(v)g(v);else{if(f===h)continue;m.matchFile(l,r)}if(m.isLimitHit)break}}g(c)}matchFile(c,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(C))}}class I{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(c,C,b,l){const m=this.getSessionTokenSource(c.cacheKey),h=new a(c,C,m&&m.token);let g=0;const n=o=>{g+=o.length,b(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(h,I.BATCH_SIZE,n,l).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}:void 0,messages:[]}))}clearCache(c){this.getSessionTokenSource(c)?.cancel()}getSessionTokenSource(c){if(c)return this.sessions.has(c)||this.sessions.set(c,new d.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:L.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,C,b,l){const m=l.onCancellationRequested(()=>{c.cancel()}),h=n=>{n&&(g.push(n),C>0&&g.length>=C&&(b(g),g=[]))};let g=[];return c.search(h).then(n=>(g.length&&b(g),m.dispose(),n),n=>(g.length&&b(g),m.dispose(),Promise.reject(n)))}}e.FileSearchManager=I}),define(_e[388],ye([1,0,19,79,39,110,29,15,17,23,13,18,2,107,262,45,12,46,157,383,38]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=w,s=ze(s),d=ze(d),T=ze(T),p=ze(p),I=ze(I),b=ze(b);let t=class{constructor(k,E,S,M,N){this.configurationService=k,this.workspaceContextService=E,this.editorGroupsService=S,this.logService=M,this.pathService=N}text(k,E,S={}){k=this.getContentPattern(k,S);const M=this.configurationService.getValue(),N=E&&E.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(E?.map(h.toWorkspaceFolder),S),type:o.QueryType.Text,contentPattern:k,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}getContentPattern(k,E){const S=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const M={...k,wordSeparators:S.editor.wordSeparators};return this.isCaseSensitive(k,E)&&(M.isCaseSensitive=!0),this.isMultiline(k)&&(M.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),M}file(k,E={}){return{...this.commonQuery(k,E),type:o.QueryType.File,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey,shouldGlobMatchFilePattern:E.shouldGlobSearch}}handleIncludeExclude(k,E){return k?(k=Array.isArray(k)?k.map(v):v(k),E?this.parseSearchPaths(k):{pattern:r(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],E={}){const S=this.handleIncludeExclude(E.includePattern,E.expandPatterns),M=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),N=k.length>1,O=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,E,M)):k.map(F=>this.getFolderQueryForRoot(F,E,M,N))).filter(F=>!!F),x={_reason:E._reason,folderQueries:O,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:S.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=s.coalesce(this.editorGroupsService.groups.flatMap(re=>re.editors.map(B=>B.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const H=F.filter(re=>(0,o.pathIncludedInQuery)(x,re.fsPath)),j=this.commonQueryFromFileList(H);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...x,...j}}const U=E.extraFileResources&&E.extraFileResources.filter(F=>(0,o.pathIncludedInQuery)(x,F.fsPath));return x.extraFileResources=U&&U.length?U:void 0,x}commonQueryFromFileList(k){const E=[],S=new L.ResourceMap,M={};let N=!1;return k.forEach(O=>{if(O.scheme===A.Schemas.walkThrough)return;if((0,a.isAbsolutePath)(O)){const U=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:p.dirname(O.fsPath)});let F=S.get(U);F||(N=!0,F={folder:U,includePattern:{}},E.push(F),S.set(U,F));const H=p.relative(U.fsPath,O.fsPath);(0,_.assertIsDefined)(F.includePattern)[H.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,M[O.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(k,E){if(E.isSmartCase){if(k.isRegExp){if(I.containsUppercaseCharacter(k.pattern,!0))return!0}else if(I.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,C.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const E=j=>p.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),M=(Array.isArray(k)?k:f(k)).map(j=>{const re=this.pathService.resolvedUserHome;return re?(0,R.untildify)(j,re.scheme===A.Schemas.file?re.fsPath:re.path):j}),N=d.groupBy(M,j=>E(j)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(j=>I.rtrim(j,"/")).map(j=>I.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),u(j))),x={},U=this.expandSearchPathPatterns(N.searchPaths||[]);U&&U.length&&(x.searchPaths=U);const F=O.flat(),H=r(...F);return H&&(x.pattern=H),x}getExcludesForFolder(k,E){return E.disregardExcludeSettings?void 0:(0,o.getExcludes)(k,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const E=k.flatMap(M=>{let{pathPortion:N,globPortion:O}=i(M);return O&&(O=y(O)),this.expandOneSearchPath(N).flatMap(U=>this.resolveOneSearchPathPattern(U,O))}),S=new Map;return E.forEach(M=>{const N=M.searchPath.toString(),O=S.get(N);O?M.pattern&&(O.pattern=O.pattern||{},O.pattern[M.pattern]=!0):S.set(N,{searchPath:M.searchPath,pattern:M.pattern?r(M.pattern):void 0})}),Array.from(S.values())}expandOneSearchPath(k){if(p.isAbsolute(k)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:k})}]:[{searchPath:c.URI.file(p.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===h.WorkbenchState.FOLDER){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=v(k),k.startsWith("../")||k===".."){const M=p.posix.resolve(E.path,k);return[{searchPath:E.with({path:M})}]}const S=y(k);return[{searchPath:E,pattern:S}]}else{if(k==="./"||k===".\\")return[];{const E=k.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(N=>{const O=E.match(new RegExp(`^${I.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(_.isDefined);if(M.length)return M.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&y(O)}});{const N=k.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:k,x=b.localize(0,null,O);throw new Error(x)}}}}resolveOneSearchPathPattern(k,E){const S=k.pattern&&E?`${k.pattern}/${E}`:k.pattern||E,M=[{searchPath:k.searchPath,pattern:S}];return S&&!S.endsWith("**")&&M.push({searchPath:k.searchPath,pattern:S+"/**"}),M}getFolderQueryForSearchPath(k,E,S){const M=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(k.searchPath),E,S,!1);return M?{...M,includePattern:k.pattern}:null}getFolderQueryForRoot(k,E,S,M){let N;const O=c.URI.isUri(k)?k:k.uri;if(S.searchPaths){const j=S.searchPaths.filter(re=>(0,a.isEqual)(re.searchPath,O))[0];if(j&&!j.pattern)return null;j&&(N=j.pattern)}const x=this.configurationService.getValue({resource:O}),F={...this.getExcludesForFolder(x,E)||{},...N||{}},H=c.URI.isUri(k)?(0,a.basename)(k):k.name;return{folder:O,folderName:M?H:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=t,e.QueryBuilder=t=Xe([He(0,l.IConfigurationService),He(1,h.IWorkspaceContextService),He(2,g.IEditorGroupsService),He(3,m.ILogService),He(4,n.IPathService)],t);function i(P){const k=P.match(/[\*\{\}\(\)\[\]\?]/);if(k){const E=k.index,S=P.substr(0,E).match(/[/|\\][^/\\]*$/);if(S){let M=P.substr(0,S.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:P.substr((S.index||0)+1)}}}return{pathPortion:P}}function r(...P){return P.length?P.reduce((k,E)=>(k[E]=!0,k),Object.create(null)):void 0}function f(P){return T.splitGlobAware(P,",").map(k=>k.trim()).filter(k=>!!k.length)}function u(P){return[`**/${P}/**`,`**/${P}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function v(P){return P.replace(/\\/g,"/")}function y(P){return v(P).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(P){return P.replace(/([?*[\]])/g,"[$1]")}function w(P,k){P=s.distinct(P,M=>M.toString());const E=[],S=k.getWorkspace();return P&&P.forEach(M=>{let N;if(k.getWorkbenchState()===h.WorkbenchState.FOLDER)N=(0,a.relativePath)(S.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const O=k.getWorkspaceFolder(M);if(O){const x=O.name;if(S.folders.filter(F=>F.name===x).length===1){const F=(0,a.relativePath)(O.uri,M);F===""?N=`./${O.name}`:N=`./${O.name}/${F}`}else N=M.fsPath}}N&&E.push(D(N))}),E}}),define(_e[389],ye([1,0,23,2,21,14,5,388,38,46,9]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=c,e.checkGlobFileExists=l,s=ze(s),R=ze(R);const _=7e3;function c(m,h){const g=h.activationEvents;if(!g)return Promise.resolve(void 0);const n=[],o=[];for(const v of g)if(/^workspaceContains:/.test(v)){const y=v.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||m.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:i}=(0,I.promiseWithResolvers)(),r=v=>i({activationEvent:v}),f=Promise.all(n.map(v=>C(m,v,r))).then(()=>{}),u=b(m,h.identifier,o,r);return Promise.all([f,u]).then(()=>{i(void 0)}),t}async function C(m,h,g){for(const n of m.folders)if(await m.exists(s.joinPath(d.URI.revive(n),h))){g(`workspaceContains:${h}`);return}}async function b(m,h,g,n){if(g.length===0)return Promise.resolve(void 0);const o=new T.CancellationTokenSource,t=m.checkExists(m.folders,g,o.token),i=setTimeout(async()=>{o.cancel(),m.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},_);let r=!1;try{r=await t}catch(f){R.isCancellationError(f)||R.onUnexpectedError(f)}o.dispose(),clearTimeout(i),r&&n(`workspaceContains:${g.join(",")}`)}function l(m,h,g,n){const o=m.get(L.IInstantiationService),t=m.get(p.ISearchService),r=o.createInstance(A.QueryBuilder).file(h.map(f=>(0,a.toWorkspaceFolder)(d.URI.revive(f))),{_reason:"checkExists",includePattern:g,exists:!0});return t.fileSearch(r,n).then(f=>!!f.limitHit,f=>R.isCancellationError(f)?!1:Promise.reject(f))}}),define(_e[53],ye([1,0,235,17,62,23,9,3,85,2,12,6,42,321,126,48,26,159,14,24,22,299,10,72,5,30,98,20,115,77,47,129,4,389,125,301,15,123,43,11,124]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u,v,y,D,w,P,k,E,S,M,N,O,x,U,F,H){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,s=ze(s),d=ze(d),T=ze(T),g=ze(g),e.IHostUtils=(0,f.createDecorator)("IHostUtils");let re=j=class extends A.Disposable{constructor(G,W,se,ae,te,ce,ue,Y,oe,ve,be,Fe,We){super(),this._extHostManagedSockets=Fe,this._extHostLanguageModels=We,this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=W,this._extHostContext=se,this._initData=ue,this._extHostWorkspace=ae,this._extHostConfiguration=te,this._logService=ce,this._extHostTunnelService=oe,this._extHostTerminalService=ve,this._extHostLocalizationService=be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new L.Barrier,this._readyToStartExtensionHost=new L.Barrier,this._readyToRunExtensions=new L.Barrier,this._eagerExtensionsActivated=new L.Barrier,this._activationEventsReader=new De(this._initData.extensions.activationEvents),this._globalRegistry=new h.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Ce=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry(this._activationEventsReader,he(this._globalRegistry,Ce)),F.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${X(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${X(this._myRegistry)}`)),this._storage=new b.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Y,this._instaService=G.createChild(new D.ServiceCollection([b.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState])),this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ie,Re,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ie,g.transformErrorForSerialization(Re),z)},actualActivateExtension:async(Ie,Re)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(Ie,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ie,Re),new C.HostExtension;const z=this._myRegistry.getExtensionDescription(Ie);return this._activateExtension(z,Re)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){g.onUnexpectedError(G)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._myRegistry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch{}await Promise.all(G)}terminate(G,W=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${G}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ae=>{this._logService.error(ae)}),this._extHostContext.dispose();const se=this._deactivateAll();Promise.race([(0,L.timeout)(5e3),se]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`):this._logService.info(`Extension host exiting with code ${W}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(W)})}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}async getExtension(G){const W=await this._mainThreadExtensionsProxy.$getExtension(G);return W&&{...W,identifier:new n.ExtensionIdentifier(W.identifier.value),extensionLocation:a.URI.revive(W.extensionLocation)}}_activateByEvent(G,W){return this._activator.activateByEvent(G,W)}_activateById(G,W){return this._activator.activateById(G,W)}activateByIdWithErrors(G,W){return this._activateById(G,W).then(()=>{const se=this._activator.getActivatedExtension(G);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._myRegistry)}getExtensionExports(G){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(G).exports;try{return this._activator.getActivatedExtension(G).exports}catch{return null}}async _realPathExtensionUri(G){if(G.scheme===O.Schemas.file&&this._hostUtils.fsRealpath){const W=G.fsPath;this._realPathCache.has(W)||this._realPathCache.set(W,this._hostUtils.fsRealpath(W));const se=await this._realPathCache.get(W);return a.URI.file(se)}return G}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(G=>new ne(G))),this._extensionPathIndex}async _createExtensionPathIndex(G){const W=p.TernarySearchTree.forUris(se=>R.extUriBiasedIgnorePathCase.ignorePathCasing(se));return await Promise.all(G.map(async se=>{if(this._getEntryPoint(se)){const ae=await this._realPathExtensionUri(se.extensionLocation);W.set(ae,se)}})),W}_deactivate(G){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return W;const se=this._activator.getActivatedExtension(G);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this._logService.error(ae),Promise.resolve(void 0))))}catch(ae){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ae)}try{(0,A.dispose)(se.subscriptions)}catch(ae){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ae)}return W}async _activateExtension(G,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,W).then(se=>{const ae=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,W),this._logExtensionActivationTimes(G,W,"success",ae),se},se=>{throw this._logExtensionActivationTimes(G,W,"failure"),se})}_logExtensionActivationTimes(G,W,se,ae){const te=V(G,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...ae||{},outcome:se})}_doActivateExtension(G,W){const se=V(G,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ae=this._getEntryPoint(G);if(!ae)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${G.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const te=new C.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(G,(0,R.joinPath)(G.extensionLocation,ae),te),this._loadExtensionContext(G)]).then(ce=>(T.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),j._callActivate(this._logService,G.identifier,ce[0],ce[1],te))).then(ce=>(T.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ce))}_loadExtensionContext(G){const W=this._extHostLanguageModels.createLanguageModelAccessInformation(G),se=this._register(new t.ExtensionGlobalMemento(G,this._storage)),ae=this._register(new t.ExtensionMemento(G.identifier.value,!1,this._storage)),te=this._register(new N.ExtensionSecrets(G,this._secretState)),ce=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ue=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const Y=this;let oe,ve;const be=(0,m.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Fe){return d.join(G.extensionLocation.fsPath,Fe)},get storagePath(){return Y._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return Y._storagePath.globalValue(G).fsPath},get logPath(){return d.join(Y._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return a.URI.joinPath(Y._initData.logsLocation,G.identifier.value)},get storageUri(){return Y._storagePath.workspaceValue(G)},get globalStorageUri(){return Y._storagePath.globalValue(G)},get extensionMode(){return ce},get extension(){return oe===void 0&&(oe=new ee(Y,G.identifier,G,ue,!1)),oe},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(G,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ve){if(!be)return;const Fe=E.Event.buffer(E.Event.fromDOMEventEmitter(be,"message",We=>We.data));be.start(),ve={onDidReceiveMessage:Fe,postMessage:be.postMessage.bind(be)}}return ve}})})}static _callActivate(G,W,se,ae,te){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,W,se,ae,te).then(ce=>new C.ActivatedExtension(!1,null,te.build(),se,ce,ae.subscriptions))}static _callActivateOptional(G,W,se,ae,te){if(typeof se.activate=="function")try{te.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ce=typeof global=="object"?global:self,ue=se.activate.apply(ce,[ae]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ue).then(Y=>(te.activateResolveStop(),Y))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(se)}_activateOneStartupFinished(G,W){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:W}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinishedDeferred(G,W=0){const ae=Date.now();(0,F.setTimeout0)(()=>{for(let te=W;te<G.length;te+=1){const ce=G[te];for(const ue of ce.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ae>50){this._activateAllStartupFinishedDeferred(G,te);break}else this._activateOneStartupFinished(ce,ue)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks()),this._extHostConfiguration.getConfigProvider().then(G=>{const W=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this._myRegistry.getAllExtensionDescriptions();if(W)this._activateAllStartupFinishedDeferred(se);else for(const ae of se)if(ae.activationEvents)for(const te of ae.activationEvents)te==="onStartupFinished"&&this._activateOneStartupFinished(ae,te)})}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(W),ae=this._handleRemoteResolverEagerExtensions(),te=Promise.all([ae,G,se]).then(()=>{});return Promise.race([te,(0,L.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),te}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(G,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,W){if(this.isActivated(W.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ae={logService:this._logService,folders:G.map(ce=>ce.uri),forceUsingSearch:se||!this._hostUtils.fsExists,exists:ce=>this._hostUtils.fsExists(ce.fsPath),checkExists:(ce,ue,Y)=>this._mainThreadWorkspaceProxy.$checkExists(ce,ue,Y)},te=await(0,S.checkActivateWorkspaceContainsExtension)(ae,W);if(te)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:W}=this._initData.environment;if(!G||!W)throw new Error(s.localize(0,null));const se=await this._loadCommonJSModule(null,W,new C.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(s.localize(1,null,W.toString()));return new Promise((ae,te)=>{const ce=(oe,ve)=>{oe?(F.isCI&&this._logService.error("Test runner called back with error",oe),te(oe)):(F.isCI&&(ve?this._logService.info(`Test runner called back with ${ve} failures.`):this._logService.info("Test runner called back with successful outcome.")),ae(typeof ve=="number"&&ve>0?1:0))},ue=(0,R.originalFSPath)(W),Y=se.run(ue,ce);Y&&Y.then&&Y.then(()=>{F.isCI&&this._logService.info("Test runner finished successfully."),ae(0)}).catch(oe=>{F.isCI&&this._logService.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,L.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,W){return this._resolvers[G]=W,(0,A.toDisposable)(()=>{delete this._resolvers[G]})}async getRemoteExecServer(G){const{resolver:W}=await this._activateAndGetResolver(G);return W?.resolveExecServer?.(G,{resolveAttempt:0})}async _activateAndGetResolver(G){const W=G.indexOf("+");if(W===-1)throw new i.RemoteAuthorityResolverError("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=G.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(G,W){const se=U.StopWatch.create(!1),ae=()=>`[resolveAuthority(${(0,r.getRemoteAuthorityPrefix)(G)},${W})][${se.elapsed()}ms] `,te=$=>this._logService.info(`${ae()}${$}`),ce=$=>this._logService.warn(`${ae()}${$}`),ue=($,Q=void 0)=>this._logService.error(`${ae()}${$}`,Q),Y=$=>{if($ instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:$._code,message:$._message,detail:$._detail}};throw $},oe=async $=>{te(`activating resolver for ${$}...`);const{resolver:Q,authorityPrefix:Z}=await this._activateAndGetResolver($);if(!Q)throw ue(`no resolver for ${Z}`),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${Z}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:Z,remoteAuthority:$}},ve=G.split(/@|%40/g).reverse();te(`activating remote resolvers ${ve.join(" -> ")}`);let be;try{be=await Promise.all(ve.map(oe)).catch(async $=>{if(!($ instanceof i.RemoteAuthorityResolverError)||$._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw $;return ce(`resolving nested authorities failed: ${$.message}`),[await oe(G)]})}catch($){return Y($)}const Fe=new L.IntervalTimer;Fe.cancelAndSet(()=>te("waiting..."),1e3);let We,Ce;for(const[$,{authorityPrefix:Q,resolver:Z,remoteAuthority:fe}]of be.entries())try{if($===be.length-1)te("invoking final resolve()..."),T.mark(`code/extHost/willResolveAuthority/${Q}`),We=await Z.resolve(fe,{resolveAttempt:W,execServer:Ce}),T.mark(`code/extHost/didResolveAuthorityOK/${Q}`),te("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Z,i.ManagedResolvedAuthority.isManagedResolvedAuthority(We)?We:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),T.mark(`code/extHost/willResolveExecServer/${Q}`),Ce=await Z.resolveExecServer?.(fe,{resolveAttempt:W,execServer:Ce}),!Ce)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${fe}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);T.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(Ee){return T.mark(`code/extHost/didResolveAuthorityError/${Q}`),ue("returned an error",Ee),Fe.dispose(),Y(Ee)}Fe.dispose();const Ie={environmentTunnels:We.environmentTunnels,features:We.tunnelFeatures?{elevation:We.tunnelFeatures.elevation,privacyOptions:We.tunnelFeatures.privacyOptions,protocol:We.tunnelFeatures.protocol===void 0?!0:We.tunnelFeatures.protocol}:void 0},Re={extensionHostEnv:We.extensionHostEnv,isTrusted:We.isTrusted,authenticationSession:We.authenticationSessionForInitializingExtensions?{id:We.authenticationSessionForInitializingExtensions.id,providerId:We.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(We)?"managed authority":`${We.host}:${We.port}`}`);let z;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(We)){const $=W;this._extHostManagedSockets.setFactory($,We.makeConnection),z={authority:G,connectTo:new r.ManagedRemoteConnection($),connectionToken:We.connectionToken}}else z={authority:G,connectTo:new r.WebSocketRemoteConnection(We.host,We.port),connectionToken:We.connectionToken};return{type:"ok",value:{authority:z,options:Re,tunnelInformation:Ie}}}async $getCanonicalURI(G,W){this._logService.info(`$getCanonicalURI invoked for authority (${(0,r.getRemoteAuthorityPrefix)(G)})`);const{resolver:se}=await this._activateAndGetResolver(G);if(!se)return null;const ae=a.URI.revive(W);if(typeof se.getCanonicalURI>"u")return ae;const te=await(0,L.asPromise)(()=>se.getCanonicalURI(ae));return te||ae}async $startExtensionHost(G){G.toAdd.forEach(ce=>ce.extensionLocation=a.URI.revive(ce.extensionLocation));const{globalRegistry:W,myExtensions:se}=B(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),ae=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${X(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(G,W){return W===m.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1)):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1))}async $activate(G,W){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(G)?(await this._activateById(G,W),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ce=>ce.extensionLocation=a.URI.revive(ce.extensionLocation));const{globalRegistry:W,myExtensions:se}=B(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),ae=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(se),F.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${X(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const W=o.VSBuffer.alloc(G),se=Math.random()%256;for(let ae=0;ae<G;ae++)W.writeUInt8(se,ae);return W}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=re,e.AbstractExtHostExtensionService=re=j=Xe([He(0,f.IInstantiationService),He(1,e.IHostUtils),He(2,y.IExtHostRpcService),He(3,l.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,I.ILogService),He(6,u.IExtHostInitDataService),He(7,v.IExtensionStoragePaths),He(8,w.IExtHostTunnelService),He(9,P.IExtHostTerminalService),He(10,x.IExtHostLocalizationService),He(11,H.IExtHostManagedSockets),He(12,k.IExtHostLanguageModels)],re);function B(pe,G,W,se){pe.addActivationEvents(se.addActivationEvents);const ae=new h.ExtensionDescriptionRegistry(pe,G.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const te=new n.ExtensionIdentifierSet(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)te.delete(ue);for(const ue of se.myToAdd)te.add(ue);const ce=he(ae,te);return{globalRegistry:ae,myExtensions:ce}}function V(pe,G){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function X(pe){return pe.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.IExtHostExtensionService=(0,f.createDecorator)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(G,W,se,ae,te){this.#e=G,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=d.normalize((0,R.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ee;function he(pe,G){return pe.getAllExtensionDescriptions().filter(W=>G.has(W.identifier))}class ne{constructor(G){this._searchTree=G}setSearchTree(G){this._searchTree=G}findSubstr(G){return this._searchTree.findSubstr(G)}forEach(G){return this._searchTree.forEach(G)}}e.ExtensionPaths=ne;class De{constructor(G){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(G)}readActivationEvents(G){return this._map.get(G.identifier)??[]}addActivationEvents(G){for(const W of Object.keys(G))this._map.set(W,G[W])}}}),define(_e[390],ye([1,0,62,2,6,42,26,24,20,30,5,53,12,13]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,s=ze(s);let l=class{constructor(o,t,i,r,f,u,v){this._apiFactory=o,this._extensionRegistry=t,this._instaService=i,this._extHostConfiguration=r,this._extHostExtensionService=f,this._initData=u,this._logService=v,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,t,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,t,this._initData.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this._factories.set(t,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(t=>o.alternativeModuleName(t))}};e.RequireInterceptor=l,e.RequireInterceptor=l=Xe([He(2,I.IInstantiationService),He(3,R.IExtHostConfiguration),He(4,_.IExtHostExtensionService),He(5,a.IExtHostInitDataService),He(6,c.ILogService)],l);let m=class{static{b=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&b.aliased.size){const t=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(o.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${f}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(o));if(!t)return;const[,i,r,f]=t,u=b.aliased.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),i+u+f}forceForwardSlashes(o){return o.replace(/\\/g,"/")}};m=b=Xe([He(0,a.IExtHostInitDataService)],m);class h{constructor(o,t,i,r,f){this._apiFactory=o,this._extensionPaths=t,this._extensionRegistry=i,this._configProvider=r,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new A.ExtensionIdentifierMap}load(o,t){const i=this._extensionPaths.findSubstr(t);if(i){let r=this._extApiImpl.get(i.identifier);return r||(r=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(i.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((f,u)=>r+=`	${u} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(L.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(o,t,i){this._extensionPaths=o,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=i.getProxy(T.MainContext.MainThreadTelemetry);const r=i.getProxy(T.MainContext.MainThreadWindow);this._impl=(f,u)=>{const v=d.URI.parse(f);return u?this.callOriginal(f,u):v.scheme==="http"||v.scheme==="https"?r.$openUri(v,f,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this._appUriScheme?r.$openUri(v,f,{}):this.callOriginal(f,u)}}load(o,t,i){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=i(o),this._impl}callOriginal(o,t){return this.sendNoForwardTelemetry(),this._original(o,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=Xe([He(2,p.IExtHostRpcService)],g)}),define(_e[65],ye([1,0,49,3,17,56,5,64,78,53,10,48,318,42]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,T=ze(T),R=ze(R),e.IExtHostVariableResolverProvider=(0,L.createDecorator)("IExtHostVariableResolverProvider");class b extends c.AbstractVariableResolverService{constructor(h,g,n,o,t,i,r){function f(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const v=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof I.TextDiffTabInput||v.input instanceof I.NotebookDiffEditorTabInput)return v.input.modified;if(v.input instanceof I.TextTabInput||v.input instanceof I.NotebookEditorTabInput||v.input instanceof I.CustomEditorTabInput)return v.input.uri}}}super({getFolderUri:u=>{const v=i.folders.filter(y=>y.name===u);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,v)=>t.getConfiguration(void 0,u).get(v),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return T.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=f();if(u){const v=g.getWorkspaceFolder(u);if(v)return T.normalize(v.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(R.env))}}let l=class extends d.Disposable{constructor(h,g,n,o,t){super(),this.extensionService=h,this.workspaceService=g,this.editorService=n,this.configurationService=o,this.editorTabs=t,this._resolver=new s.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),f={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async u=>{f.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new b(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,f,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=l,e.ExtHostVariableResolverProviderService=l=Xe([He(0,a.IExtHostExtensionService),He(1,_.IExtHostWorkspace),He(2,A.IExtHostDocumentsAndEditors),He(3,C.IExtHostConfiguration),He(4,p.IExtHostEditorTabs)],l)}),define(_e[102],ye([1,0,9,4,2,3,24,5,6,78,53,20,10,48,154,120,309,42,65,50,35,16,19,99]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=ze(t),e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let f=class extends R.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(k,E,S,M,N,O,x,U){super(),this._workspaceService=E,this._extensionService=S,this._configurationService=M,this._editorTabs=N,this._variableResolver=O,this._commands=x,this._testing=U,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new d.Emitter),this._onDidTerminateDebugSession=this._register(new d.Emitter),this._onDidChangeActiveDebugSession=this._register(new d.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new d.Emitter),this._debugServiceProxy=k.getProxy(p.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new d.Emitter),this._onDidChangeActiveStackItem=this._register(new d.Emitter),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(F=>{this._register(F.onDidChange(H=>{this.registerAllDebugTypes(F)})),this.registerAllDebugTypes(F)})}async $getVisualizerTreeItem(k,E){const S=this.hydrateVisualizationContext(E);if(!S)return;const M=await this._debugVisualizationTrees.get(k)?.getTreeItem?.(S);return M?this.convertVisualizerTreeItem(k,M):void 0}registerDebugVisualizationTree(k,E,S){const M=L.ExtensionIdentifier.toKey(k.identifier),N=this.extensionVisKey(M,E);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this._debugVisualizationTrees.set(N,S),this._debugServiceProxy.$registerDebugVisualizerTree(N,!!S.editItem),(0,R.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(N),this._debugVisualizationTrees.delete(E)})}async $getVisualizerTreeItemChildren(k,E){const S=this._debugVisualizationElements.get(E)?.item;return S?(await this._debugVisualizationTrees.get(k)?.getChildren?.(S))?.map(N=>this.convertVisualizerTreeItem(k,N))||[]:[]}async $editVisualizerTreeItem(k,E){const S=this._debugVisualizationElements.get(k);if(!S)return;const M=await this._debugVisualizationTrees.get(S.provider)?.editItem?.(S.item,E);return this.convertVisualizerTreeItem(S.provider,M||S.item)}$disposeVisualizedTree(k){const E=this._debugVisualizationElements.get(k);if(!E)return;const S=[E.children];for(const M of S)if(M)for(const N of M)S.push(this._debugVisualizationElements.get(N)?.children),this._debugVisualizationElements.delete(N)}convertVisualizerTreeItem(k,E){let S=this._debugVisualizationTreeItemIds.get(E);return S||(S=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(E,S),this._debugVisualizationElements.set(S,{provider:k,item:E})),t.DebugTreeItem.from(E,S)}asDebugSourceUri(k,E){const S=k;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let M=`debug:${encodeURIComponent(S.path||"")}`,N="?";return E&&(M+=`${N}session=${encodeURIComponent(E.id)}`,N="&"),M+=`${N}ref=${S.sourceReference}`,T.URI.parse(M)}else{if(S.path)return T.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(k){const E=[];for(const S of k.getAllExtensionDescriptions())if(S.contributes){const M=S.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,m.isDebuggerMainContribution)(N)&&E.push(N.type)}this._debugServiceProxy.$registerDebugTypes(E)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const k=[];return this._breakpoints.forEach(E=>k.push(E)),k}async $resolveDebugVisualizer(k,E){const S=this._visualizers.get(k);if(!S)throw new Error(`No debug visualizer found with id '${k}'`);let{v:M,provider:N,extensionId:O}=S;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,E)||M,S.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.serializeVisualization(O,M.visualization)}async $executeDebugVisualizerCommand(k){const E=this._visualizers.get(k);if(!E)throw new Error(`No debug visualizer found with id '${k}'`);const S=E.v.visualization;S&&"command"in S&&this._commands.executeCommand(S.command,...S.arguments||[])}hydrateVisualizationContext(k){const E=this._debugSessions.get(k.sessionId);return E&&{session:E.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,E,S,M){const N=this.hydrateVisualizationContext(S),O=this.extensionVisKey(k,E),x=this._debugVisualizationProviders.get(O);if(!N||!x)return[];const U=await x.provideDebugVisualization(N,M);return U?U.map(F=>{const H=++this._visualizerIdCounter;this._visualizers.set(H,{v:F,provider:x,extensionId:k});const j=F.iconPath?this.getIconPathOrClass(F.iconPath):void 0;return{id:H,name:F.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.serializeVisualization(k,F.visualization)}}):[]}$disposeDebugVisualizers(k){for(const E of k)this._visualizers.delete(E)}registerDebugVisualizationProvider(k,E,S){if(!k.contributes?.debugVisualizers?.some(O=>O.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const M=L.ExtensionIdentifier.toKey(k.identifier),N=this.extensionVisKey(M,E);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this._debugVisualizationProviders.set(N,S),this._debugServiceProxy.$registerDebugVisualizer(M,E),(0,R.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(M,E),this._debugVisualizationProviders.delete(E)})}addBreakpoints(k){const E=k.filter(N=>{const O=N.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,N),!0)});this.fireBreakpointChanges(E,[],[]);const S=[],M=new Map;for(const N of E)if(N instanceof c.SourceBreakpoint){let O=M.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),O),S.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof c.FunctionBreakpoint&&S.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(k){const E=k.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const S=E.filter(O=>O instanceof c.SourceBreakpoint).map(O=>O.id),M=E.filter(O=>O instanceof c.FunctionBreakpoint).map(O=>O.id),N=E.filter(O=>O instanceof c.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(S,M,N)}startDebugging(k,E,S){const M=S.testRun&&this._testing.getMetadataForRun(S.testRun);return this._debugServiceProxy.$startDebugging(k?k.uri:void 0,E,{parentSessionID:S.parentSession?S.parentSession.id:void 0,lifecycleManagedByParent:S.lifecycleManagedByParent,repl:S.consoleMode===c.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact,suppressSaveBeforeStart:S.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:S.suppressDebugStatusbar??S.debugUI?.simple,suppressDebugToolbar:S.suppressDebugToolbar??S.debugUI?.simple,suppressDebugView:S.suppressDebugView??S.debugUI?.simple})}stopDebugging(k){return this._debugServiceProxy.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,E,S){if(!E)return new c.Disposable(()=>{});const M=this._configProviderHandleCounter++;return this._configProviders.push({type:k,handle:M,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(k,S,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,M),new c.Disposable(()=>{this._configProviders=this._configProviders.filter(N=>N.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(k,E,S){if(!S)return new c.Disposable(()=>{});if(!this.definesDebugType(k,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:M,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,M),new c.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(N=>N.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(k,E){if(!E)return new c.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:k,handle:S,factory:E}),new c.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(M=>M.factory!==E)})}async $runInTerminal(k,E){return Promise.resolve(void 0)}async $substituteVariables(k,E){let S;const M=await this.getFolder(k);return M&&(S={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(S,E)}createDebugAdapter(k,E){if(k.type==="implementation")return new D(k.implementation)}createSignService(){}async $startDASession(k,E){const S=this,M=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const O=this.convertToDto(N),x=this.createDebugAdapter(O,M);if(!x)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const U=x;return this._debugAdapters.set(k,U),this.getDebugAdapterTrackers(M).then(F=>(F&&this._debugAdaptersTrackers.set(k,F),U.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const j=H,re={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(j.arguments.value);re.body={signature:B},U.sendResponse(re)}else throw new Error("no signer")}catch(B){re.success=!1,re.message=B.message,U.sendResponse(re)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(H),H=(0,m.convertToVSCPaths)(H,!0),S._debugServiceProxy.$acceptDAMessage(k,H)}),U.onError(H=>{F&&F.onError&&F.onError(H),this._debugServiceProxy.$acceptDAError(k,H.name,H.message,H.stack)}),U.onExit(H=>{F&&F.onExit&&F.onExit(H??void 0,void 0),this._debugServiceProxy.$acceptDAExit(k,H??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),U.startSession()))})}$sendDAMessage(k,E){E=(0,m.convertToDAPaths)(E,!1);const S=this._debugAdaptersTrackers.get(k);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(E),this._debugAdapters.get(k)?.sendMessage(E)}$stopDASession(k){const E=this._debugAdaptersTrackers.get(k);this._debugAdaptersTrackers.delete(k),E&&E.onWillStopSession&&E.onWillStopSession();const S=this._debugAdapters.get(k);return this._debugAdapters.delete(k),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const E=[],S=[],M=[];if(k.added)for(const N of k.added){const O=N.id;if(O&&!this._breakpoints.has(O)){let x;if(N.type==="function")x=new c.FunctionBreakpoint(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")x=new c.DataBreakpoint(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const U=T.URI.revive(N.uri);x=new c.SourceBreakpoint(new c.Location(U,new c.Position(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,c.setBreakpointId)(x,O),this._breakpoints.set(O,x),E.push(x)}}if(k.removed)for(const N of k.removed){const O=this._breakpoints.get(N);O&&(this._breakpoints.delete(N),S.push(O))}if(k.changed){for(const N of k.changed)if(N.id){const O=this._breakpoints.get(N.id);if(O){if(O instanceof c.FunctionBreakpoint&&N.type==="function"){const x=O;x.enabled=N.enabled,x.condition=N.condition,x.hitCondition=N.hitCondition,x.logMessage=N.logMessage,x.functionName=N.functionName}else if(O instanceof c.SourceBreakpoint&&N.type==="source"){const x=O;x.enabled=N.enabled,x.condition=N.condition,x.hitCondition=N.hitCondition,x.logMessage=N.logMessage,x.location=new c.Location(T.URI.revive(N.uri),new c.Position(N.line,N.character))}M.push(O)}}}this.fireBreakpointChanges(E,S,M)}async $acceptStackFrameFocus(k){let E;if(k){const S=await this.getSession(k.sessionId);k.kind==="thread"?E=new c.DebugThread(S.api,k.threadId):E=new c.DebugStackFrame(S.api,k.threadId,k.frameId)}this._activeStackItem=E,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(k,E,S){return(0,s.asPromise)(async()=>{const M=this.getConfigProviderByHandle(k);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.getFolder(E);return M.provideDebugConfigurations(N,S)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(k,E,S,M){return(0,s.asPromise)(async()=>{const N=this.getConfigProviderByHandle(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return N.resolveDebugConfiguration(O,S,M)})}$resolveDebugConfigurationWithSubstitutedVariables(k,E,S,M){return(0,s.asPromise)(async()=>{const N=this.getConfigProviderByHandle(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return N.resolveDebugConfigurationWithSubstitutedVariables(O,S,M)})}async $provideDebugAdapter(k,E){const S=this.getAdapterDescriptorFactoryByHandle(k);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.getSession(E);return this.getAdapterDescriptor(S,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.convertToDto(N)})}async $acceptDebugSessionStarted(k){const E=await this.getSession(k);this._onDidStartDebugSession.fire(E.api)}async $acceptDebugSessionTerminated(k){const E=await this.getSession(k);E&&(this._onDidTerminateDebugSession.fire(E.api),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(k){this._activeDebugSession=k?await this.getSession(k):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(k,E){(await this.getSession(k))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(k,E){const M={session:(await this.getSession(k)).api,event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(M)}convertToDto(k){if(k instanceof c.DebugAdapterExecutable)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof c.DebugAdapterServer)return{type:"server",port:k.port,host:k.host};if(k instanceof c.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:k.path};if(k instanceof c.DebugAdapterInlineImplementation)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(k){const E=this._adapterFactories.filter(S=>S.type===k);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(k){const E=this._adapterFactories.filter(S=>S.handle===k);if(E.length>0)return E[0].factory}getConfigProviderByHandle(k){const E=this._configProviders.filter(S=>S.handle===k);if(E.length>0)return E[0].provider}definesDebugType(k,E){if(k.contributes){const S=k.contributes.debuggers;if(S&&S.length>0){for(const M of S)if(M.label&&M.type&&M.type===E)return!0}}return!1}getDebugAdapterTrackers(k){const S=k.configuration.type,M=this._trackerFactories.filter(N=>N.type===S||N.type==="*").map(N=>(0,s.asPromise)(()=>N.factory.createDebugAdapterTracker(k.api)).then(O=>O,O=>null));return Promise.race([Promise.all(M).then(N=>{const O=(0,i.coalesce)(N);if(O.length>0)return new y(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async getAdapterDescriptor(k,E){const S=E.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new c.DebugAdapterServer(S));if(k){const N=await this._extensionService.getExtensionRegistry();return(0,s.asPromise)(()=>k.createDebugAdapterDescriptor(E.api,this.daExecutableFromPackage(E,N))).then(O=>{if(O)return O})}const M=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,M))}daExecutableFromPackage(k,E){}fireBreakpointChanges(k,E,S){(k.length>0||E.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:k,removed:E,changed:S}))}async getSession(k){if(k)if(typeof k=="string"){const E=this._debugSessions.get(k);if(E)return E}else{let E=this._debugSessions.get(k.id);if(!E){const S=await this.getFolder(k.folderUri),M=k.parent?this._debugSessions.get(k.parent):void 0;E=new u(this._debugServiceProxy,k.id,k.type,k.name,S,k.configuration,M?.api),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(k){if(k){const E=T.URI.revive(k);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}extensionVisKey(k,E){return`${k}\0${E}`}serializeVisualization(k,E){if(E){if("title"in E&&"command"in E)return{type:l.DebugVisualizationType.Command};if("treeId"in E)return{type:l.DebugVisualizationType.Tree,id:`${k}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(k){const E=this.getIconUris(k);let S,M;return"id"in E?M=n.ThemeIcon.asClassName(E):S=E,{iconPath:S,iconClass:M}}getIconUris(k){if(k instanceof c.ThemeIcon)return{id:k.id};const E=typeof k=="object"&&"dark"in k?k.dark:k,S=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof E=="string"?T.URI.file(E):E,light:typeof S=="string"?T.URI.file(S):S}}};e.ExtHostDebugServiceBase=f,e.ExtHostDebugServiceBase=f=Xe([He(0,_.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,a.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider),He(6,o.IExtHostCommands),He(7,r.IExtHostTesting)],f);class u{constructor(k,E,S,M,N,O,x){this._debugServiceProxy=k,this._id=E,this._type=S,this._name=M,this._workspaceFolder=N,this._configuration=O,this._parentSession=x}get api(){const k=this;return this.apiSession??=Object.freeze({id:k._id,type:k._type,get name(){return k._name},set name(E){k._name=E,k._debugServiceProxy.$setDebugSessionName(k._id,E)},parentSession:k._parentSession,workspaceFolder:k._workspaceFolder,configuration:k._configuration,customRequest(E,S){return k._debugServiceProxy.$customDebugAdapterRequest(k._id,E,S)},getDebugProtocolBreakpoint(E){return k._debugServiceProxy.$getDebugProtocolBreakpoint(k._id,E.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(k){this._name=k}get configuration(){return this._configuration}}e.ExtHostDebugSession=u;class v{constructor(k){this.value=Object.freeze({append(E){k.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=v;class y{constructor(k){this.trackers=k}onWillStartSession(){this.trackers.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(k):void 0)}onWillStopSession(){this.trackers.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.trackers.forEach(E=>E.onError?E.onError(k):void 0)}onExit(k,E){this.trackers.forEach(S=>S.onExit?S.onExit(k,E):void 0)}}class D extends b.AbstractDebugAdapter{constructor(k){super(),this.implementation=k,k.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.implementation.handleMessage(k)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends f{constructor(k,E,S,M,N,O,x,U){super(k,E,S,M,N,O,x,U)}};e.WorkerExtHostDebugService=w,e.WorkerExtHostDebugService=w=Xe([He(0,_.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,a.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider),He(6,o.IExtHostCommands),He(7,r.IExtHostTesting)],w)}),define(_e[391],ye([1,0,14,62,2,6,339,12,89,115,30,275,20,73,53,95]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,s=ze(s),d=ze(d);class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(A.ILogService),i=n.get(c.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);s.setUnexpectedErrorHandler(r=>{o.error(r);const f=s.transformErrorForSerialization(r);i.$onUnexpectedError(f)})}static async installFullHandler(n){const o=n.get(A.ILogService),t=n.get(c.IExtHostRpcService),i=n.get(b.IExtHostExtensionService),r=n.get(l.IExtHostTelemetry),f=t.getProxy(R.MainContext.MainThreadExtensionService),u=t.getProxy(R.MainContext.MainThreadErrors),v=await i.getExtensionPathIndex(),y=new WeakMap;function D(k,E){if(y.has(k))return y.get(k).stack;let S="",M,N;for(const x of E)S+=`
	at ${x.toString()}`,N=x.getFileName(),!M&&N&&(M=v.findSubstr(T.URI.file(N)));const O=`${k.name||"Error"}: ${k.message||""}${S}`;return y.set(k,{extensionIdentifier:M?.identifier,stack:O}),O}const w=Symbol("prepareStackTrace wrapped");let P=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(k){if(k===D||!k||k[w]){P=k||D;return}P=function(E,S){return D(E,S),k.call(Error,E,S)},Object.assign(P,{[w]:!0})}}),s.setUnexpectedErrorHandler(k=>{o.error(k);const E=s.transformErrorForSerialization(k),S=y.get(k);if(!S?.extensionIdentifier){u.$onUnexpectedError(E);return}f.$onExtensionRuntimeError(S.extensionIdentifier,E);const M=r.onExtensionError(S.extensionIdentifier,k);o.trace("forwarded error to extension?",M,S)})}}e.ErrorHandler=m;class h{constructor(n,o,t,i,r){this._hostUtils=t,this._rpcProtocol=new L.RPCProtocol(n,null,i),o=h._transform(o,this._rpcProtocol);const f=new a.ServiceCollection(...(0,p.getSingletonServiceDescriptors)());f.set(I.IExtHostInitDataService,{_serviceBrand:void 0,...o,messagePorts:r}),f.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),f.set(C.IURITransformerService,new C.URITransformerService(i)),f.set(b.IHostUtils,t);const u=new _.InstantiationService(f,!0);u.invokeFunction(m.installEarlyHandler),this._logService=u.invokeFunction(v=>v.get(A.ILogService)),d.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",o),this._extensionService=u.invokeFunction(v=>v.get(b.IExtHostExtensionService)),this._extensionService.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const o=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return T.URI.revive(await o.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,o){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=T.URI.revive(o.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=T.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const t=n.environment.extensionDevelopmentLocationURI;return t&&(n.environment.extensionDevelopmentLocationURI=t.map(i=>T.URI.revive(o.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=T.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=T.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=T.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=T.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=T.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=T.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=h}),define(_e[392],ye([1,0,9,11,246,268,149,102,78,53,20,47,10,65,48,310,311,42,35,99]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0,d=ze(d),T=ze(T);let o=class extends A.ExtHostDebugServiceBase{constructor(u,v,y,D,w,P,k,E,S){super(u,v,y,D,P,k,E,S),this._terminalService=w,this._integratedTerminalInstances=new r}createDebugAdapter(u,v){switch(u.type){case"server":return new l.SocketDebugAdapter(u);case"pipeServer":return new l.NamedPipeDebugAdapter(u);case"executable":return new l.ExecutableDebugAdapter(u,v.type)}return super.createDebugAdapter(u,v)}daExecutableFromPackage(u,v){const y=l.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),u.type);if(y)return new c.DebugAdapterExecutable(y.command,y.args,y.options)}createSignService(){return new L.SignService}async $runInTerminal(u,v){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._register(this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)})));const y=await this._configurationService.getConfigProvider(),D=this._terminalService.getDefaultShell(!0),w=this._terminalService.getDefaultShellArgs(!0),P=u.title||T.localize(0,null),k=JSON.stringify({shell:D,shellArgs:w});let E=await this._integratedTerminalInstances.checkout(k,P),S,M=!1;if(E)S=u.cwd;else{const U={shellPath:D,shellArgs:w,cwd:u.cwd,name:P,iconPath:new c.ThemeIcon("debug")};M=!0,E=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(E,k)}E.show(!0);const N=await E.processId;M?await new Promise(U=>setTimeout(U,1e3)):(E.state.isInteractedWith&&(E.sendText(""),await(0,s.timeout)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?E.sendText("cls"):D.indexOf("bash")>=0?E.sendText("clear"):d.isWindows?E.sendText("cls"):E.sendText("clear")));const O=(0,m.prepareCommand)(D,u.args,!!u.argsCanBeInterpretedByShell,S,u.env);E.sendText(O);const x=this.onDidTerminateDebugSession(U=>{U.id===v&&(this._integratedTerminalInstances.free(E),x.dispose())});return N}else if(u.kind==="external")return i(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,v)}};e.ExtHostDebugService=o,e.ExtHostDebugService=o=Xe([He(0,I.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,a.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,_.IExtHostTerminalService),He(5,p.IExtHostEditorTabs),He(6,C.IExtHostVariableResolverProvider),He(7,g.IExtHostCommands),He(8,n.IExtHostTesting)],o);let t;function i(f,u){if(!t)if(d.isWindows)t=new R.WindowsExternalTerminalService;else if(d.isMacintosh)t=new R.MacExternalTerminalService;else if(d.isLinux)t=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const v=u.getConfiguration("terminal");return t.runInTerminal(f.title,f.cwd,f.args,f.env||{},v.external||{})}class r{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(u,v,y=!1){const w=[...this._terminalInstances.entries()].map(([P,k])=>(0,s.createCancelablePromise)(async E=>{if(P.name!==v||k.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await P.processId))return null;const S=Date.now();return k.lastUsedAt+r.minUseDelay>S||E.isCancellationRequested?null:k.config!==u?(y&&P.dispose(),null):(k.lastUsedAt=S,P)}));return await(0,s.firstParallel)(w,P=>!!P)}insert(u,v){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:v})}free(u){const v=this._terminalInstances.get(u);v&&(v.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}}),define(_e[393],ye([1,0,17,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0,s=ze(s),m=ze(m);let n=class extends c.ExtHostTaskBase{constructor(t,i,r,f,u,v,y,D,w){super(t,i,r,f,u,v,y,D),this.workspaceService=r,this.variableResolver=w,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,i){const r=i;if(!i.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const f=c.TaskHandleDTO.from(r,this.workspaceService),u=await this._proxy.$getTaskExecution(f);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const v=await this.getTaskExecution(u,i);return this._proxy.$executeTask(f).catch(()=>{}),v}else{const f=c.TaskDTO.from(i,t);if(f===void 0)return Promise.reject(new Error("Task is not valid"));c.CustomExecutionDTO.is(f.execution)&&await this.addCustomExecution(f,i,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(f),i);return this._proxy.$executeTask(f).catch(()=>{}),u}}provideTasksInternal(t,i,r,f){const u=[];if(f)for(const v of f){this.checkDeprecation(v,r),(!v.definition||!t[v.definition.type])&&this._logService.warn(`The task [${v.source}, ${v.name}] uses an undefined task type. The task will be ignored in the future.`);const y=c.TaskDTO.from(v,r.extension);y&&(u.push(y),c.CustomExecutionDTO.is(y.execution)&&i.push(this.addCustomExecution(y,v,!0)))}return{tasks:u,extension:r.extension}}async resolveTaskInternal(t){return t}async getAFolder(t){let i=t&&t.length>0?t[0]:void 0;if(!i){const r=d.URI.file((0,h.homedir)());i=new p.WorkspaceFolder({uri:r,name:m.basename(r),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,i){const r=d.URI.revive(t),f={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(r),v=await this._workspaceProvider.getWorkspaceFolders2()??[],y=await this.variableResolver.getResolver(),D=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(v);for(const w of i.variables)f.variables[w]=await y.resolveAsync(D,w);if(i.process!==void 0){let w;if(i.process.path!==void 0){w=i.process.path.split(s.delimiter);for(let P=0;P<w.length;P++)w[P]=await y.resolveAsync(D,w[P])}f.process=await T.win32.findExecutable(await y.resolveAsync(D,i.process.name),i.process.cwd!==void 0?await y.resolveAsync(D,i.process.cwd):void 0,w)}return f}async $jsonTasksSupported(){return!0}async $findExecutable(t,i,r){return T.win32.findExecutable(t,i,r)}};e.ExtHostTask=n,e.ExtHostTask=n=Xe([He(0,I.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,R.IExtHostWorkspace),He(3,L.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,a.IExtHostTerminalService),He(6,b.ILogService),He(7,l.IExtHostApiDeprecationService),He(8,g.IExtHostVariableResolverProvider)],n)}),define(_e[394],ye([1,0,68,65]),function(le,e,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class T extends d.ExtHostVariableResolverProviderService{homeDir(){return(0,s.homedir)()}}e.NodeExtHostVariableResolverProviderService=T}),define(_e[171],ye([1,0,19,9,21,51,15,17,23,2,38]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=l,A=ze(A),p=ze(p);class _{constructor(g,n,o){this.queryProviderPair=g,this.fileUtils=n,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(g,n){const o=this.query.folderQueries||[],t=new T.CancellationTokenSource(n);return new Promise((i,r)=>{this.collector=new C(g);let f=!1;const u=(v,y)=>{if(!f&&!this.isLimitHit){const D=this.resultSize(v);l(v)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,f=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const w=this.resultSize(v);this.resultCount+=w,(w>0||!l(v))&&this.collector.add(v,y)}};Promise.all(o.map((v,y)=>this.searchInFolder(v,D=>u(D,y),t.token))).then(v=>{t.dispose(),this.collector.flush();const y=v.some(D=>!!D&&!!D.limitHit);i({limitHit:this.isLimitHit||y,messages:v.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.processType}})},v=>{t.dispose();const y=(0,R.toErrorMessage)(v);r(new Error(y))})})}resultSize(g){return l(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,n){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,n),preview:{matches:t.slice(0,n),text:g.preview.text},uri:g.uri}}async searchInFolder(g,n,o){const t=new I.QueryGlobTester(this.query,g),i=[],r={report:v=>{if(!this.validateProviderResult(v))return;const y=g.folder.scheme===L.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(p.dirname(v.uri))):void 0,D=p.relativePath(g.folder,v.uri);if(D){const w=t.includedInQuery(D,A.basename(D),y);(0,d.isThenable)(w)?i.push(w.then(P=>{P&&n(v)})):w&&n(v)}}},f=this.getSearchOptionsForFolder(g);let u;return this.queryProviderPair.query.type===I.QueryType.aiText?u=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,f,r,o):u=await this.queryProviderPair.provider.provideTextSearchResults(c(this.queryProviderPair.query.contentPattern),f,r,o),i.length&&await Promise.all(i),u}validateProviderResult(g){if(l(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const n=(0,I.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),o=(0,I.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),t={folder:a.URI.from(g.folder),excludes:o,includes:n,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??I.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(t.usePCRE2=this.query.usePCRE2),t}}e.TextSearchManager=_;function c(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class C{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,n=>this.sendItems(n))}add(g,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!p.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(b(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=C;function b(h){return l(h)?{preview:{matches:(0,s.mapArrayOrNot)(h.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:h.preview.text},ranges:(0,s.mapArrayOrNot)(h.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function l(h){return!!h.preview}class m{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(g,n){this.maxBatchSize=g,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,n){g&&this.addItemToBatch(g,n)}addItems(g,n){g&&this.addItemsToBatch(g,n)}addItemToBatch(g,n){this.batch.push(g),this.batchSize+=n,this.onUpdate()}addItemsToBatch(g,n){this.batch=this.batch.concat(g),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m}),define(_e[103],ye([1,0,3,6,5,387,20,73,12,2,171]),function(le,e,s,d,T,R,L,A,p,a,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=c,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let _=class{constructor(l,m,h){this.extHostRpc=l,this._uriTransformer=m,this._logService=h,this._proxy=this.extHostRpc.getProxy(d.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,m){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const h=this._handlePool++;return this._textSearchProvider.set(h,m),this._proxy.$registerTextSearchProvider(h,this._transformScheme(l)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerAITextSearchProvider(l,m){if(this._aiTextSearchUsedSchemes.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this._aiTextSearchUsedSchemes.add(l);const h=this._handlePool++;return this._aiTextSearchProvider.set(h,m),this._proxy.$registerAITextSearchProvider(h,this._transformScheme(l)),(0,s.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(l),this._aiTextSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(l,m){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const h=this._handlePool++;return this._fileSearchProvider.set(h,m),this._proxy.$registerFileSearchProvider(h,this._transformScheme(l)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(l,m,h,g){const n=c(h),o=this._fileSearchProvider.get(l);if(o)return this._fileSearchManager.fileSearch(n,o,t=>{this._proxy.$handleFileMatch(l,m,t.map(i=>i.resource))},g);throw new Error("3 unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,m,h){return{messages:[]}}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,m,h,g){const n=this._textSearchProvider.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${l}`);const o=c(h);return this.createTextSearchManager(o,n).search(i=>this._proxy.$handleTextMatch(l,m,i),g)}$provideAITextSearchResults(l,m,h,g){const n=this._aiTextSearchProvider.get(l);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${l}`);const o=c(h);return this.createAITextSearchManager(o,n).search(i=>this._proxy.$handleTextMatch(l,m,i),g)}$enableExtensionHostSearch(){}createTextSearchManager(l,m){return new I.TextSearchManager({query:l,provider:m},{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}createAITextSearchManager(l,m){return new I.TextSearchManager({query:l,provider:m},{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"aiTextSearchProvider")}};e.ExtHostSearch=_,e.ExtHostSearch=_=Xe([He(0,L.IExtHostRpcService),He(1,A.IURITransformerService),He(2,p.ILogService)],_);function c(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(C),extraFileResources:b.extraFileResources&&b.extraFileResources.map(l=>a.URI.revive(l))}}function C(b){return{...b,folder:a.URI.revive(b.folder)}}});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[395],ye([1,0,21,14,4,3,15,44,2,114,213,194,55,24,28,12,91,92,296,6,341,368,96,128,345,346,347,326,316,35,348,42,349,102,163,350,328,342,351,352,64,78,329,343,53,353,76,354,63,30,369,330,355,356,129,357,123,124,331,386,359,300,360,370,361,169,332,362,363,364,20,365,103,125,366,333,367,126,98,101,95,47,167,99,371,344,372,373,77,16,10,334,73,335,97,374,375,162,48,120,94,26,100]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u,v,y,D,w,P,k,E,S,M,N,O,x,U,F,H,j,re,B,V,X,ee,he,ne,De,pe,G,W,se,ae,te,ce,ue,Y,oe,ve,be,Fe,We,Ce,Ie,Re,z,$,Q,Z,fe,Ee,Ne,Ve,je,tt,rt,ot,nt,at,mt,dt,lt,Te,Ue,qe,Oe,xe,de,J,Pe,Qe,et,ut,gt,Dt,Ot,zt,ui,ti,Ze,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=Kt,d=ze(d),A=xt(A),_=ze(_),b=ze(b),de=ze(de),J=ze(J);function Kt(vt){const Tt=vt.get(De.IExtHostInitDataService),ii=vt.get(ne.IExtHostFileSystemInfo),Yt=vt.get(ee.IExtHostConsumerFileSystem),$t=vt.get(V.IExtHostExtensionService),St=vt.get(zt.IExtHostWorkspace),Nt=vt.get(at.IExtHostTelemetry),di=vt.get(k.IExtHostConfiguration),Ht=vt.get(Qe.IURITransformerService),Je=vt.get(Z.IExtHostRpcService),Jt=vt.get(rt.IExtHostStorage),ni=vt.get(ot.IExtensionStoragePaths),hi=vt.get(l.ILoggerService),Ct=vt.get(l.ILogService),Ft=vt.get(xe.IExtHostTunnelService),At=vt.get(i.IExtHostApiDeprecationService),Ut=vt.get(Ot.IExtHostWindow),ri=vt.get(Ne.IExtHostSecretState),Zt=vt.get(j.IExtHostEditorTabs),si=vt.get(ue.IExtHostManagedSockets),Vt=vt.get(r.IExtHostAuthentication),Gt=vt.get(ae.IExtHostLanguageModels);Je.set(n.ExtHostContext.ExtHostFileSystemInfo,ii),Je.set(n.ExtHostContext.ExtHostLogLevelServiceShape,hi),Je.set(n.ExtHostContext.ExtHostWorkspace,St),Je.set(n.ExtHostContext.ExtHostConfiguration,di),Je.set(n.ExtHostContext.ExtHostExtensionService,$t),Je.set(n.ExtHostContext.ExtHostStorage,Jt),Je.set(n.ExtHostContext.ExtHostTunnelService,Ft),Je.set(n.ExtHostContext.ExtHostWindow,Ut),Je.set(n.ExtHostContext.ExtHostSecretState,ri),Je.set(n.ExtHostContext.ExtHostTelemetry,Nt),Je.set(n.ExtHostContext.ExtHostEditorTabs,Zt),Je.set(n.ExtHostContext.ExtHostManagedSockets,si),Je.set(n.ExtHostContext.ExtHostAuthentication,Vt),Je.set(n.ExtHostContext.ExtHostChatProvider,Gt);const oi=Je.set(n.ExtHostContext.ExtHostDecorations,vt.get(M.IExtHostDecorations)),kt=Je.set(n.ExtHostContext.ExtHostDocumentsAndEditors,vt.get(H.IExtHostDocumentsAndEditors)),yt=Je.set(n.ExtHostContext.ExtHostCommands,vt.get(w.IExtHostCommands)),bt=Je.set(n.ExtHostContext.ExtHostTerminalService,vt.get(mt.IExtHostTerminalService)),ei=Je.set(n.ExtHostContext.ExtHostTerminalShellIntegration,vt.get(dt.IExtHostTerminalShellIntegration)),It=Je.set(n.ExtHostContext.ExtHostDebugService,vt.get(S.IExtHostDebugService)),fi=Je.set(n.ExtHostContext.ExtHostSearch,vt.get(Ee.IExtHostSearch)),qt=Je.set(n.ExtHostContext.ExtHostTask,vt.get(nt.IExtHostTask)),bi=Je.set(n.ExtHostContext.ExtHostOutputService,vt.get(Ie.IExtHostOutputService)),Si=Je.set(n.ExtHostContext.ExtHostLocalization,vt.get(ce.IExtHostLocalizationService)),gi=Je.set(n.ExtHostContext.ExtHostUrls,new et.ExtHostUrls(Je)),Bt=Je.set(n.ExtHostContext.ExtHostDocuments,new F.ExtHostDocuments(Je,kt)),ai=Je.set(n.ExtHostContext.ExtHostDocumentContentProviders,new x.ExtHostDocumentContentProvider(Je,kt,Ct)),Ti=Je.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new U.ExtHostDocumentSaveParticipant(Ct,Bt,Je.getProxy(n.MainContext.MainThreadBulkEdits))),Rt=Je.set(n.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Je,yt,kt,Bt,Yt,fi,Ct)),yi=Je.set(n.ExtHostContext.ExtHostNotebookDocuments,new be.ExtHostNotebookDocuments(Rt)),Pi=Je.set(n.ExtHostContext.ExtHostNotebookEditors,new Fe.ExtHostNotebookEditors(Ct,Rt)),Di=Je.set(n.ExtHostContext.ExtHostNotebookKernels,new We.ExtHostNotebookKernels(Je,Tt,Rt,yt,Ct)),pi=Je.set(n.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers(Je,Rt)),ki=Je.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new ve.ExtHostNotebookDocumentSaveParticipant(Ct,Rt,Je.getProxy(n.MainContext.MainThreadBulkEdits))),Wt=Je.set(n.ExtHostContext.ExtHostEditors,new Te.ExtHostEditors(Je,kt)),ke=Je.set(n.ExtHostContext.ExtHostTreeViews,new Oe.ExtHostTreeViews(Je.getProxy(n.MainContext.MainThreadTreeViews),yt,Ct)),Me=Je.set(n.ExtHostContext.ExtHostEditorInsets,new D.ExtHostEditorInsets(Je.getProxy(n.MainContext.MainThreadEditorInsets),Wt,Tt.remote)),Se=Je.set(n.ExtHostContext.ExtHostDiagnostics,new N.ExtHostDiagnostics(Je,Ct,ii,kt)),ie=Je.set(n.ExtHostContext.ExtHostLanguages,new te.ExtHostLanguages(Je,Bt,yt.converter,Ht)),Ae=Je.set(n.ExtHostContext.ExtHostLanguageFeatures,new W.ExtHostLanguageFeatures(Je,Ht,Bt,yt,Se,Ct,At,Nt)),Ke=Je.set(n.ExtHostContext.ExtHostFileSystem,new X.ExtHostFileSystem(Je,Ae)),it=Je.set(n.ExtHostContext.ExtHostFileSystemEventService,new he.ExtHostFileSystemEventService(Je,Ct,kt)),Ge=Je.set(n.ExtHostContext.ExtHostQuickOpen,(0,Q.createExtHostQuickOpen)(Je,St,yt)),ft=Je.set(n.ExtHostContext.ExtHostSCM,new fe.ExtHostSCM(Je,yt,Bt,Ct)),Pt=Je.set(n.ExtHostContext.ExtHostQuickDiff,new $.ExtHostQuickDiff(Je,Ht)),Xt=Je.set(n.ExtHostContext.ExtHostShare,new Ve.ExtHostShare(Je,Ht)),li=Je.set(n.ExtHostContext.ExtHostComments,(0,P.createExtHostComments)(Je,yt,Bt)),Mt=Je.set(n.ExtHostContext.ExtHostProgress,new z.ExtHostProgress(Je.getProxy(n.MainContext.MainThreadProgress))),ci=Je.set(n.ExtHostContext.ExtHostLabelService,new G.ExtHostLabelService(Je)),$i=Je.set(n.ExtHostContext.ExtHostTheming,new Ue.ExtHostTheming(Je)),vn=Je.set(n.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(Je,yt)),Fi=Je.set(n.ExtHostContext.ExtHostWebviews,new ut.ExtHostWebviews(Je,Tt.remote,St,Ct,At)),Li=Je.set(n.ExtHostContext.ExtHostWebviewPanels,new gt.ExtHostWebviewPanels(Je,Fi,St)),Hi=Je.set(n.ExtHostContext.ExtHostCustomEditors,new E.ExtHostCustomEditors(Je,Bt,ni,Fi,Li)),Ji=Je.set(n.ExtHostContext.ExtHostWebviewViews,new Dt.ExtHostWebviewViews(Je,Fi)),Ci=Je.set(n.ExtHostContext.ExtHostTesting,vt.get(lt.IExtHostTesting)),Zi=Je.set(n.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(Je)),en=Je.set(n.ExtHostContext.ExtHostProfileContentHandlers,new Re.ExtHostProfileContentHandlers(Je));Je.set(n.ExtHostContext.ExtHostInteractive,new pe.ExtHostInteractive(Je,Rt,kt,yt,Ct));const Mi=Je.set(n.ExtHostContext.ExtHostChatAgents2,new u.ExtHostChatAgents2(Je,Ct,yt)),tn=Je.set(n.ExtHostContext.ExtHostChatVariables,new v.ExtHostChatVariables(Je)),Vi=Je.set(n.ExtHostContext.ExtHostLanguageModelTools,new se.ExtHostLanguageModelTools(Je)),nn=Je.set(n.ExtHostContext.ExtHostAiRelatedInformation,new o.ExtHostRelatedInformation(Je)),qi=Je.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new B.ExtHostAiEmbeddingVector(Je)),xi=Je.set(n.ExtHostContext.ExtHostStatusBar,new tt.ExtHostStatusBar(Je,yt.converter)),En=Je.set(n.ExtHostContext.ExtHostSpeech,new je.ExtHostSpeech(Je)),Oi=Je.set(n.ExtHostContext.ExtHostEmbeddings,new re.ExtHostEmbeddings(Je)),rn=Object.values(n.ExtHostContext);Je.assertRegistered(rn);const bn=new f.ExtHostBulkEdits(Je,kt),ji=new y.ExtHostClipboard(Je),Ui=new Y.ExtHostMessageService(Je,Ct),Ki=new O.ExtHostDialogs(Je);return t.ExtHostApiCommands.register(yt),function($e,wi,Bi){function ct(ge){return(we,Be,ht)=>{const _t=ge(Lt=>{try{we.call(Be,Lt)}catch(Ai){d.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${$e.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Nt.onExtensionError($e.identifier,Ai)}});return ht?.push(_t),_t}}const Et=function(){let ge=!$e.isUnderDevelopment;function we(){ge||(Ct.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(ht){if(Array.isArray(ht))ht.forEach(Be);else if(typeof ht=="string")we();else{const _t=ht;typeof _t.scheme>"u"&&we(),typeof _t.exclusive=="boolean"&&(0,Ze.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ht}}(),Wi={getSession(ge,we,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,Ze.checkProposedApiEnabled)($e,"authLearnMore"),Be?.account&&(0,Ze.checkProposedApiEnabled)($e,"authGetSessions"),Vt.getSession($e,ge,we,Be)},getAccounts(ge){return(0,Ze.checkProposedApiEnabled)($e,"authGetSessions"),Vt.getAccounts(ge)},async hasSession(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"authSession"),!!await Vt.getSession($e,ge,we,{silent:!0})},get onDidChangeSessions(){return ct(Vt.onDidChangeSessions)},registerAuthenticationProvider(ge,we,Be,ht){return Vt.registerAuthenticationProvider(ge,we,Be,ht)}},Sn={registerCommand(ge,we,Be){return yt.registerCommand(!0,ge,we,Be,void 0,$e)},registerTextEditorCommand(ge,we,Be){return yt.registerCommand(!0,ge,(...ht)=>{const _t=Wt.getActiveTextEditor();if(!_t){Ct.warn("Cannot execute "+ge+" because there is no active text editor.");return}return _t.edit(Lt=>{we.apply(Be,[_t,Lt,...ht])}).then(Lt=>{Lt||Ct.warn("Edits from command "+ge+" were not applied.")},Lt=>{Ct.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,$e)},registerDiffInformationCommand:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"diffCommand"),yt.registerCommand(!0,ge,async(...ht)=>{const _t=kt.activeEditor(!0);if(!_t){Ct.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Wt.getDiffInformation(_t.id);we.apply(Be,[Lt,...ht])},void 0,void 0,$e)),executeCommand(ge,...we){return yt.executeCommand(ge,...we)},getCommands(ge=!1){return yt.getCommands(ge)}},mi={get machineId(){return Tt.telemetryInfo.machineId},get sessionId(){return Tt.telemetryInfo.sessionId},get language(){return Tt.environment.appLanguage},get appName(){return Tt.environment.appName},get appRoot(){return Tt.environment.appRoot?.fsPath??""},get appHost(){return Tt.environment.appHost},get uriScheme(){return Tt.environment.appUriScheme},get clipboard(){return ji.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ct(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.checkProposedApiEnabled)($e,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.checkProposedApiEnabled)($e,"telemetry"),ct(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.isNewAppInstall)(Tt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,we){return at.ExtHostTelemetryLogger.validateSender(ge),Nt.instantiateLogger($e,ge,we)},openExternal(ge,we){return Ut.openUri(ge,{allowTunneling:!!Tt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===Tt.environment.appUriScheme)return gi.createAppUri(ge);try{return await Ut.asExternalUri(ge,{allowTunneling:!!Tt.remote.authority})}catch(we){if((0,L.matchesScheme)(ge,L.Schemas.http)||(0,L.matchesScheme)(ge,L.Schemas.https))return ge;throw we}},get remoteName(){return(0,m.getRemoteName)(Tt.remote.authority)},get remoteAuthority(){return(0,Ze.checkProposedApiEnabled)($e,"resolvers"),Tt.remote.authority},get uiKind(){return Tt.uiKind},get logLevel(){return Ct.getLevel()},get onDidChangeLogLevel(){return ct(Ct.onDidChangeLogLevel)},get appQuality(){return(0,Ze.checkProposedApiEnabled)($e,"resolvers"),Tt.quality},get appCommit(){return(0,Ze.checkProposedApiEnabled)($e,"resolvers"),Tt.commit}};Tt.environment.extensionTestsLocationURI||Object.freeze(mi);const zi={createTestController(ge,we,Be){return Ci.createTestController($e,ge,we,Be)},createTestObserver(){return(0,Ze.checkProposedApiEnabled)($e,"testObserver"),Ci.createTestObserver()},runTests(ge){return(0,Ze.checkProposedApiEnabled)($e,"testObserver"),Ci.runTests(ge)},registerTestFollowupProvider(ge){return(0,Ze.checkProposedApiEnabled)($e,"testObserver"),Ci.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,Ze.checkProposedApiEnabled)($e,"testObserver"),ct(Ci.onResultsChanged)},get testResults(){return(0,Ze.checkProposedApiEnabled)($e,"testObserver"),Ci.results}},Ni=Tt.remote.isRemote?J.ExtensionKind.Workspace:J.ExtensionKind.UI,sn={getExtension(ge,we){(0,Ze.isProposedApiEnabled)($e,"extensionsAny")||(we=!1);const Be=wi.mine.getExtensionDescription(ge);if(Be)return new V.Extension($t,$e.identifier,Be,Ni,!1);if(we){const ht=wi.all.getExtensionDescription(ge);if(ht)return new V.Extension($t,$e.identifier,ht,Ni,!0)}},get all(){const ge=[];for(const we of wi.mine.getAllExtensionDescriptions())ge.push(new V.Extension($t,$e.identifier,we,Ni,!1));return ge},get allAcrossExtensionHosts(){(0,Ze.checkProposedApiEnabled)($e,"extensionsAny");const ge=new C.ExtensionIdentifierSet(wi.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),we=[];for(const Be of wi.all.getAllExtensionDescriptions()){const ht=!ge.has(Be.identifier);we.push(new V.Extension($t,$e.identifier,Be,Ni,ht))}return we},get onDidChange(){return(0,Ze.isProposedApiEnabled)($e,"extensionsAny")?ct(T.Event.any(wi.mine.onDidChange,wi.all.onDidChange)):ct(wi.mine.onDidChange)}},on={createDiagnosticCollection(ge){return Se.createDiagnosticCollection($e.identifier,ge)},get onDidChangeDiagnostics(){return ct(Se.onDidChangeDiagnostics)},getDiagnostics:ge=>Se.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,we){return ie.changeLanguage(ge.uri,we)},match(ge,we){const Be=de.LanguageSelector.from(ge);let ht;return(0,I.targetsNotebooks)(Be)&&(ht=Rt.notebookDocuments.find(_t=>_t.apiNotebook.getCells().find(Lt=>Lt.document===we))?.apiNotebook),(0,I.score)(Be,we.uri,we.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(ge,we,Be){return Ae.registerCodeActionProvider($e,Et(ge),we,Be)},registerDocumentPasteEditProvider(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"documentPaste"),Ae.registerDocumentPasteEditProvider($e,Et(ge),we,Be)},registerCodeLensProvider(ge,we){return Ae.registerCodeLensProvider($e,Et(ge),we)},registerDefinitionProvider(ge,we){return Ae.registerDefinitionProvider($e,Et(ge),we)},registerDeclarationProvider(ge,we){return Ae.registerDeclarationProvider($e,Et(ge),we)},registerImplementationProvider(ge,we){return Ae.registerImplementationProvider($e,Et(ge),we)},registerTypeDefinitionProvider(ge,we){return Ae.registerTypeDefinitionProvider($e,Et(ge),we)},registerHoverProvider(ge,we){return Ae.registerHoverProvider($e,Et(ge),we,$e.identifier)},registerEvaluatableExpressionProvider(ge,we){return Ae.registerEvaluatableExpressionProvider($e,Et(ge),we,$e.identifier)},registerInlineValuesProvider(ge,we){return Ae.registerInlineValuesProvider($e,Et(ge),we,$e.identifier)},registerDocumentHighlightProvider(ge,we){return Ae.registerDocumentHighlightProvider($e,Et(ge),we)},registerMultiDocumentHighlightProvider(ge,we){return Ae.registerMultiDocumentHighlightProvider($e,Et(ge),we)},registerLinkedEditingRangeProvider(ge,we){return Ae.registerLinkedEditingRangeProvider($e,Et(ge),we)},registerReferenceProvider(ge,we){return Ae.registerReferenceProvider($e,Et(ge),we)},registerRenameProvider(ge,we){return Ae.registerRenameProvider($e,Et(ge),we)},registerNewSymbolNamesProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"newSymbolNamesProvider"),Ae.registerNewSymbolNamesProvider($e,Et(ge),we)},registerDocumentSymbolProvider(ge,we,Be){return Ae.registerDocumentSymbolProvider($e,Et(ge),we,Be)},registerWorkspaceSymbolProvider(ge){return Ae.registerWorkspaceSymbolProvider($e,ge)},registerDocumentFormattingEditProvider(ge,we){return Ae.registerDocumentFormattingEditProvider($e,Et(ge),we)},registerDocumentRangeFormattingEditProvider(ge,we){return Ae.registerDocumentRangeFormattingEditProvider($e,Et(ge),we)},registerOnTypeFormattingEditProvider(ge,we,Be,...ht){return Ae.registerOnTypeFormattingEditProvider($e,Et(ge),we,[Be].concat(ht))},registerDocumentSemanticTokensProvider(ge,we,Be){return Ae.registerDocumentSemanticTokensProvider($e,Et(ge),we,Be)},registerDocumentRangeSemanticTokensProvider(ge,we,Be){return Ae.registerDocumentRangeSemanticTokensProvider($e,Et(ge),we,Be)},registerSignatureHelpProvider(ge,we,Be,...ht){return typeof Be=="object"?Ae.registerSignatureHelpProvider($e,Et(ge),we,Be):Ae.registerSignatureHelpProvider($e,Et(ge),we,typeof Be>"u"?[]:[Be,...ht])},registerCompletionItemProvider(ge,we,...Be){return Ae.registerCompletionItemProvider($e,Et(ge),we,Be)},registerInlineCompletionItemProvider(ge,we,Be){return we.handleDidShowCompletionItem&&(0,Ze.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),we.handleDidPartiallyAcceptCompletionItem&&(0,Ze.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Be&&(0,Ze.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Ae.registerInlineCompletionsProvider($e,Et(ge),we,Be)},registerInlineEditProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"inlineEdit"),Ae.registerInlineEditProvider($e,Et(ge),we)},registerDocumentLinkProvider(ge,we){return Ae.registerDocumentLinkProvider($e,Et(ge),we)},registerColorProvider(ge,we){return Ae.registerColorProvider($e,Et(ge),we)},registerFoldingRangeProvider(ge,we){return Ae.registerFoldingRangeProvider($e,Et(ge),we)},registerSelectionRangeProvider(ge,we){return Ae.registerSelectionRangeProvider($e,ge,we)},registerCallHierarchyProvider(ge,we){return Ae.registerCallHierarchyProvider($e,ge,we)},registerTypeHierarchyProvider(ge,we){return Ae.registerTypeHierarchyProvider($e,ge,we)},setLanguageConfiguration:(ge,we)=>Ae.setLanguageConfiguration($e,ge,we),getTokenInformationAtPosition(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"tokenInformation"),ie.tokenAtPosition(ge,we)},registerInlayHintsProvider(ge,we){return Ae.registerInlayHintsProvider($e,ge,we)},createLanguageStatusItem(ge,we){return ie.createLanguageStatusItem($e,ge,we)},registerDocumentDropEditProvider(ge,we,Be){return Ae.registerDocumentOnDropEditProvider($e,ge,we,(0,Ze.isProposedApiEnabled)($e,"documentPaste")?Be:void 0)}},an={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ge,we,Be){p.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&At.report("workspace.showTextDocument",$e,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await(p.URI.isUri(ge)?Promise.resolve(ln.openTextDocument(ge)):Promise.resolve(ge));return Wt.showTextDocument(ht,we,Be)},createTextEditorDecorationType(ge){return Wt.createTextEditorDecorationType($e,ge)},onDidChangeActiveTextEditor(ge,we,Be){return ct(Wt.onDidChangeActiveTextEditor)(ge,we,Be)},onDidChangeVisibleTextEditors(ge,we,Be){return ct(Wt.onDidChangeVisibleTextEditors)(ge,we,Be)},onDidChangeTextEditorSelection(ge,we,Be){return ct(Wt.onDidChangeTextEditorSelection)(ge,we,Be)},onDidChangeTextEditorOptions(ge,we,Be){return ct(Wt.onDidChangeTextEditorOptions)(ge,we,Be)},onDidChangeTextEditorVisibleRanges(ge,we,Be){return ct(Wt.onDidChangeTextEditorVisibleRanges)(ge,we,Be)},onDidChangeTextEditorViewColumn(ge,we,Be){return ct(Wt.onDidChangeTextEditorViewColumn)(ge,we,Be)},onDidCloseTerminal(ge,we,Be){return ct(bt.onDidCloseTerminal)(ge,we,Be)},onDidOpenTerminal(ge,we,Be){return ct(bt.onDidOpenTerminal)(ge,we,Be)},onDidChangeActiveTerminal(ge,we,Be){return ct(bt.onDidChangeActiveTerminal)(ge,we,Be)},onDidChangeTerminalDimensions(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalDimensions"),ct(bt.onDidChangeTerminalDimensions)(ge,we,Be)},onDidChangeTerminalState(ge,we,Be){return ct(bt.onDidChangeTerminalState)(ge,we,Be)},onDidWriteTerminalData(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),ct(bt.onDidWriteTerminalData)(ge,we,Be)},onDidExecuteTerminalCommand(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalExecuteCommandEvent"),ct(bt.onDidExecuteTerminalCommand)(ge,we,Be)},onDidChangeTerminalShellIntegration(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalShellIntegration"),ct(ei.onDidChangeTerminalShellIntegration)(ge,we,Be)},onDidStartTerminalShellExecution(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalShellIntegration"),ct(ei.onDidStartTerminalShellExecution)(ge,we,Be)},onDidEndTerminalShellExecution(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"terminalShellIntegration"),ct(ei.onDidEndTerminalShellExecution)(ge,we,Be)},get state(){return Ut.getState()},onDidChangeWindowState(ge,we,Be){return ct(Ut.onDidChangeWindowState)(ge,we,Be)},showInformationMessage(ge,...we){return Ui.showMessage($e,A.default.Info,ge,we[0],we.slice(1))},showWarningMessage(ge,...we){return Ui.showMessage($e,A.default.Warning,ge,we[0],we.slice(1))},showErrorMessage(ge,...we){return Ui.showMessage($e,A.default.Error,ge,we[0],we.slice(1))},showQuickPick(ge,we,Be){return Ge.showQuickPick($e,ge,we,Be)},showWorkspaceFolderPick(ge){return Ge.showWorkspaceFolderPick(ge)},showInputBox(ge,we){return Ge.showInput(ge,we)},showOpenDialog(ge){return Ki.showOpenDialog($e,ge)},showSaveDialog(ge){return Ki.showSaveDialog(ge)},createStatusBarItem(ge,we,Be){let ht,_t,Lt;return typeof ge=="string"?(ht=ge,_t=we,Lt=Be):(_t=ge,Lt=we),xi.createStatusBarEntry($e,ht,_t,Lt)},setStatusBarMessage(ge,we){return xi.setStatusBarMessage(ge,we)},withScmProgress(ge){return At.report("window.withScmProgress",$e,"Use 'withProgress' instead."),Mt.withProgress($e,{location:J.ProgressLocation.SourceControl},(we,Be)=>ge({report(ht){}}))},withProgress(ge,we){return Mt.withProgress($e,ge,we)},createOutputChannel(ge,we){return bi.createOutputChannel(ge,we,$e)},createWebviewPanel(ge,we,Be,ht){return Li.createWebviewPanel($e,ge,we,Be,ht)},createWebviewTextEditorInset(ge,we,Be,ht){return(0,Ze.checkProposedApiEnabled)($e,"editorInsets"),Me.createWebviewEditorInset(ge,we,Be,ht,$e)},createTerminal(ge,we,Be){return typeof ge=="object"?"pty"in ge?bt.createExtensionTerminal(ge):bt.createTerminalFromOptions(ge):bt.createTerminal(ge,we,Be)},registerTerminalLinkProvider(ge){return bt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,we){return bt.registerProfileProvider($e,ge,we)},registerTerminalQuickFixProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ge,$e.identifier.value,we)},registerTreeDataProvider(ge,we){return ke.registerTreeDataProvider(ge,we,$e)},createTreeView(ge,we){return ke.createTreeView(ge,we,$e)},registerWebviewPanelSerializer:(ge,we)=>Li.registerWebviewPanelSerializer($e,ge,we),registerCustomEditorProvider:(ge,we,Be={})=>Hi.registerCustomEditorProvider($e,ge,we,Be),registerFileDecorationProvider(ge){return oi.registerFileDecorationProvider(ge,$e)},registerUriHandler(ge){return gi.registerUriHandler($e,ge)},createQuickPick(){return Ge.createQuickPick($e)},createInputBox(){return Ge.createInputBox($e)},get activeColorTheme(){return $i.activeColorTheme},onDidChangeActiveColorTheme(ge,we,Be){return ct($i.onDidChangeActiveColorTheme)(ge,we,Be)},registerWebviewViewProvider(ge,we,Be){return Ji.registerWebviewViewProvider($e,ge,we,Be?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,we,Be){return ct(Rt.onDidChangeActiveNotebookEditor)(ge,we,Be)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,we,Be){return ct(Pi.onDidChangeNotebookEditorSelection)(ge,we,Be)},onDidChangeNotebookEditorVisibleRanges(ge,we,Be){return ct(Pi.onDidChangeNotebookEditorVisibleRanges)(ge,we,Be)},showNotebookDocument(ge,we){return Rt.showNotebookDocument(ge,we)},registerExternalUriOpener(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"externalUriOpener"),Zi.registerExternalUriOpener($e.identifier,ge,we,Be)},registerProfileContentHandler(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"profileContentHandlers"),en.registerProfileContentHandler($e,ge,we)},registerQuickDiffProvider(ge,we,Be,ht){return(0,Ze.checkProposedApiEnabled)($e,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ge),we,Be,ht)},get tabGroups(){return Zt.tabGroups},registerShareProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"shareProvider"),Xt.registerShareProvider(Et(ge),we)}},ln={get rootPath(){return At.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),St.getPath()},set rootPath(ge){throw new d.ReadonlyError("rootPath")},getWorkspaceFolder(ge){return St.getWorkspaceFolder(ge)},get workspaceFolders(){return St.getWorkspaceFolders()},get name(){return St.name},set name(ge){throw new d.ReadonlyError("name")},get workspaceFile(){return St.workspaceFile},set workspaceFile(ge){throw new d.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ge,we,...Be)=>St.updateWorkspaceFolders($e,ge,we||0,...Be),onDidChangeWorkspaceFolders:function(ge,we,Be){return ct(St.onDidChangeWorkspace)(ge,we,Be)},asRelativePath:(ge,we)=>St.getRelativePath(ge,we),findFiles:(ge,we,Be,ht)=>St.findFiles(ge,we,Be,$e.identifier,ht),findFiles2:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"findFiles2"),St.findFiles2(ge,we,$e.identifier,Be)),findTextInFiles:(ge,we,Be,ht)=>{(0,Ze.checkProposedApiEnabled)($e,"findTextInFiles");let _t,Lt;return typeof we=="object"?(_t=we,Lt=Be):(_t={},Lt=we,ht=Be),St.findTextInFiles(ge,_t||{},Lt,$e.identifier,ht)},save:ge=>St.save(ge),saveAs:ge=>St.saveAs(ge),saveAll:ge=>St.saveAll(ge),applyEdit(ge,we){return bn.applyWorkspaceEdit(ge,$e,we)},createFileSystemWatcher:(ge,we,Be,ht)=>{let _t;return typeof we=="boolean"?_t={ignoreCreateEvents:!!we,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ht,correlate:!1}:we&&((0,Ze.checkProposedApiEnabled)($e,"createFileSystemWatcher"),_t={...we,correlate:!0}),it.createFileSystemWatcher(St,$e,ge,_t)},get textDocuments(){return Bt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new d.ReadonlyError("textDocuments")},openTextDocument(ge){let we;const Be=ge;if(typeof ge=="string")we=Promise.resolve(p.URI.file(ge));else if(p.URI.isUri(ge))we=Promise.resolve(ge);else if(!Be||typeof Be=="object")we=Bt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ht=>(ht.scheme===L.Schemas.vscodeRemote&&!ht.authority&&At.report("workspace.openTextDocument",$e,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(ht).then(_t=>_t.document)))},onDidOpenTextDocument:(ge,we,Be)=>ct(Bt.onDidAddDocument)(ge,we,Be),onDidCloseTextDocument:(ge,we,Be)=>ct(Bt.onDidRemoveDocument)(ge,we,Be),onDidChangeTextDocument:(ge,we,Be)=>ct(Bt.onDidChangeDocument)(ge,we,Be),onDidSaveTextDocument:(ge,we,Be)=>ct(Bt.onDidSaveDocument)(ge,we,Be),onWillSaveTextDocument:(ge,we,Be)=>ct(Ti.getOnWillSaveTextDocumentEvent($e))(ge,we,Be),get notebookDocuments(){return Rt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,we){let Be;if(p.URI.isUri(ge))Be=ge,await Rt.openNotebookDocument(ge);else if(typeof ge=="string")Be=p.URI.revive(await Rt.createNotebookDocument({viewType:ge,content:we}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,we,Be){return ct(yi.onDidSaveNotebookDocument)(ge,we,Be)},onDidChangeNotebookDocument(ge,we,Be){return ct(yi.onDidChangeNotebookDocument)(ge,we,Be)},onWillSaveNotebookDocument(ge,we,Be){return ct(ki.getOnWillSaveNotebookDocumentEvent($e))(ge,we,Be)},get onDidOpenNotebookDocument(){return ct(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,we,Be,ht){return Rt.registerNotebookSerializer($e,ge,we,Be,(0,Ze.isProposedApiEnabled)($e,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(ge,we,Be)=>ct(Bi.onDidChangeConfiguration)(ge,we,Be),getConfiguration(ge,we){return we=arguments.length===1?void 0:we,Bi.getConfiguration(ge,we,$e)},registerTextDocumentContentProvider(ge,we){return ai.registerTextDocumentContentProvider(ge,we)},registerTaskProvider:(ge,we)=>(At.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider($e,ge,we)),registerFileSystemProvider(ge,we,Be){return(0,R.combinedDisposable)(Ke.registerFileSystemProvider($e,ge,we,Be),Yt.addFileSystemProvider(ge,we,Be))},get fs(){return Yt.value},registerFileSearchProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"fileSearchProvider"),fi.registerFileSearchProvider(ge,we)),registerTextSearchProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"textSearchProvider"),fi.registerTextSearchProvider(ge,we)),registerAITextSearchProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"aiTextSearchProvider"),(0,Ze.checkProposedApiEnabled)($e,"textSearchProvider"),fi.registerAITextSearchProvider(ge,we)),registerRemoteAuthorityResolver:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"resolvers"),$t.registerRemoteAuthorityResolver(ge,we)),registerResourceLabelFormatter:ge=>((0,Ze.checkProposedApiEnabled)($e,"resolvers"),ci.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,Ze.checkProposedApiEnabled)($e,"resolvers"),$t.getRemoteExecServer(ge)),onDidCreateFiles:(ge,we,Be)=>ct(it.onDidCreateFile)(ge,we,Be),onDidDeleteFiles:(ge,we,Be)=>ct(it.onDidDeleteFile)(ge,we,Be),onDidRenameFiles:(ge,we,Be)=>ct(it.onDidRenameFile)(ge,we,Be),onWillCreateFiles:(ge,we,Be)=>ct(it.getOnWillCreateFileEvent($e))(ge,we,Be),onWillDeleteFiles:(ge,we,Be)=>ct(it.getOnWillDeleteFileEvent($e))(ge,we,Be),onWillRenameFiles:(ge,we,Be)=>ct(it.getOnWillRenameFileEvent($e))(ge,we,Be),openTunnel:ge=>((0,Ze.checkProposedApiEnabled)($e,"tunnels"),Ft.openTunnel($e,ge).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Ze.checkProposedApiEnabled)($e,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"tunnels"),ct(Ft.onDidChangeTunnels)(ge,we,Be)),registerPortAttributesProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"portsAttributes"),Ft.registerPortsAttributesProvider(ge,we)),registerTunnelProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"tunnelFactory"),Ft.registerTunnelProvider(ge,we)),registerTimelineProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"timeline"),vn.registerTimelineProvider(ge,we,$e.identifier,yt.converter)),get isTrusted(){return St.trusted},requestWorkspaceTrust:ge=>((0,Ze.checkProposedApiEnabled)($e,"workspaceTrust"),St.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,we,Be)=>ct(St.onDidGrantWorkspaceTrust)(ge,we,Be),registerEditSessionIdentityProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),St.registerEditSessionIdentityProvider(ge,we)),onWillCreateEditSessionIdentity:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ct(St.getOnWillCreateEditSessionIdentityEvent($e))(ge,we,Be)),registerCanonicalUriProvider:(ge,we)=>((0,Ze.checkProposedApiEnabled)($e,"canonicalUriProvider"),St.registerCanonicalUriProvider(ge,we)),getCanonicalUri:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"canonicalUriProvider"),St.provideCanonicalUri(ge,we,Be))},cn={get inputBox(){return At.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox($e)},createSourceControl(ge,we,Be){return ft.createSourceControl($e,ge,we,Be)}},un={createCommentController(ge,we){return li.createCommentController($e,ge,we)}},wn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"debugVisualization"),It.registerDebugVisualizationProvider($e,ge,we)},registerDebugVisualizationTreeProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"debugVisualization"),It.registerDebugVisualizationTree($e,ge,we)},onDidStartDebugSession(ge,we,Be){return ct(It.onDidStartDebugSession)(ge,we,Be)},onDidTerminateDebugSession(ge,we,Be){return ct(It.onDidTerminateDebugSession)(ge,we,Be)},onDidChangeActiveDebugSession(ge,we,Be){return ct(It.onDidChangeActiveDebugSession)(ge,we,Be)},onDidReceiveDebugSessionCustomEvent(ge,we,Be){return ct(It.onDidReceiveDebugSessionCustomEvent)(ge,we,Be)},onDidChangeBreakpoints(ge,we,Be){return ct(It.onDidChangeBreakpoints)(ge,we,Be)},onDidChangeActiveStackItem(ge,we,Be){return ct(It.onDidChangeActiveStackItem)(ge,we,Be)},registerDebugConfigurationProvider(ge,we,Be){return It.registerDebugConfigurationProvider(ge,we,Be||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,we){return It.registerDebugAdapterDescriptorFactory($e,ge,we)},registerDebugAdapterTrackerFactory(ge,we){return It.registerDebugAdapterTrackerFactory(ge,we)},startDebugging(ge,we,Be){return!Be||typeof Be=="object"&&"configuration"in Be?It.startDebugging(ge,we,{parentSession:Be}):It.startDebugging(ge,we,Be||{})},stopDebugging(ge){return It.stopDebugging(ge)},addBreakpoints(ge){return It.addBreakpoints(ge)},removeBreakpoints(ge){return It.removeBreakpoints(ge)},asDebugSourceUri(ge,we){return It.asDebugSourceUri(ge,we)}},_n={registerTaskProvider:(ge,we)=>qt.registerTaskProvider($e,ge,we),fetchTasks:ge=>qt.fetchTasks(ge),executeTask:ge=>qt.executeTask($e,ge),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ge,we,Be)=>ct(qt.onDidStartTask)(ge,we,Be),onDidEndTask:(ge,we,Be)=>ct(qt.onDidEndTask)(ge,we,Be),onDidStartTaskProcess:(ge,we,Be)=>ct(qt.onDidStartTaskProcess)(ge,we,Be),onDidEndTaskProcess:(ge,we,Be)=>ct(qt.onDidEndTaskProcess)(ge,we,Be)},dn={createNotebookController(ge,we,Be,ht,_t){return Di.createNotebookController($e,ge,we,Be,ht,(0,Ze.isProposedApiEnabled)($e,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ge,we)=>Rt.registerNotebookCellStatusBarItemProvider($e,ge,we),createRendererMessaging(ge){return pi.createRendererMessaging($e,ge)},createNotebookControllerDetectionTask(ge){return(0,Ze.checkProposedApiEnabled)($e,"notebookKernelSource"),Di.createNotebookControllerDetectionTask($e,ge)},registerKernelSourceActionProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"notebookKernelSource"),Di.registerKernelSourceActionProvider($e,ge,we)},onDidChangeNotebookCellExecutionState(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"notebookCellExecutionState"),ct(Di.onDidChangeNotebookCellExecutionState)(ge,we,Be)}},Gi={t(...ge){if(typeof ge[0]=="string"){const we=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return Si.getMessage($e.identifier.value,{message:we,args:Be})}return Si.getMessage($e.identifier.value,ge[0])},get bundle(){return Si.getBundle($e.identifier.value)},get uri(){return Si.getBundleUri($e.identifier.value)}},hn={_version:1,transferActiveChat(ge){return(0,Ze.checkProposedApiEnabled)($e,"interactive"),Mi.transferActiveChat(ge)}},fn={getRelatedInformation(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"aiRelatedInformation"),nn.getRelatedInformation($e,ge,we)},registerRelatedInformationProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"aiRelatedInformation"),nn.registerRelatedInformationProvider($e,ge,we)},registerEmbeddingVectorProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"aiRelatedInformation"),qi.registerEmbeddingVectorProvider($e,ge,we)}},gn={_version:1,registerChatResponseProvider(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"chatProvider"),Gt.registerLanguageModel($e,ge,we,Be)},registerChatVariableResolver(ge,we,Be,ht,_t,Lt,Ai,Xi){return(0,Ze.checkProposedApiEnabled)($e,"chatVariableResolver"),tn.registerVariableResolver($e,ge,we,Be,ht,_t,Lt,Ai,Xi?.id)},registerMappedEditsProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"mappedEditsProvider"),Ae.registerMappedEditsProvider($e,ge,we)},createChatParticipant(ge,we){return Mi.createChatAgent($e,ge,we)},createDynamicChatParticipant(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"chatParticipantPrivate"),Mi.createDynamicChatAgent($e,ge,we,Be)}},yn={selectChatModels:ge=>Gt.selectLanguageModels($e,ge??{}),onDidChangeChatModels:(ge,we,Be)=>Gt.onDidChangeProviders(ge,we,Be),registerChatModelProvider:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"chatProvider"),Gt.registerLanguageModel($e,ge,we,Be)),get embeddingModels(){return(0,Ze.checkProposedApiEnabled)($e,"embeddings"),Oi.embeddingsModels},onDidChangeEmbeddingModels:(ge,we,Be)=>((0,Ze.checkProposedApiEnabled)($e,"embeddings"),Oi.onDidChange(ge,we,Be)),registerEmbeddingsProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"embeddings"),Oi.registerEmbeddingsProvider($e,ge,we)},async computeEmbeddings(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"embeddings"),Oi.computeEmbeddings(ge,we,Be)},registerTool(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"lmTools"),Vi.registerTool($e,ge,we)},invokeTool(ge,we,Be){return(0,Ze.checkProposedApiEnabled)($e,"lmTools"),Vi.invokeTool(ge,we,Be)},get tools(){return(0,Ze.checkProposedApiEnabled)($e,"lmTools"),Vi.tools}},Dn={registerSpeechProvider(ge,we){return(0,Ze.checkProposedApiEnabled)($e,"speech"),En.registerProvider($e.identifier,ge,we)}};return{version:Tt.version,ai:fn,authentication:Wi,commands:Sn,comments:un,chat:gn,debug:wn,env:mi,extensions:sn,interactive:hn,l10n:Gi,languages:on,lm:yn,notebooks:dn,scm:cn,speech:Dn,tasks:_n,tests:zi,window:an,workspace:ln,Breakpoint:J.Breakpoint,TerminalOutputAnchor:J.TerminalOutputAnchor,ChatResultFeedbackKind:J.ChatResultFeedbackKind,ChatVariableLevel:J.ChatVariableLevel,ChatCompletionItem:J.ChatCompletionItem,CallHierarchyIncomingCall:J.CallHierarchyIncomingCall,CallHierarchyItem:J.CallHierarchyItem,CallHierarchyOutgoingCall:J.CallHierarchyOutgoingCall,CancellationError:d.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:J.CodeAction,CodeActionKind:J.CodeActionKind,CodeActionTriggerKind:J.CodeActionTriggerKind,CodeLens:J.CodeLens,Color:J.Color,ColorInformation:J.ColorInformation,ColorPresentation:J.ColorPresentation,ColorThemeKind:J.ColorThemeKind,CommentMode:J.CommentMode,CommentState:J.CommentState,CommentThreadCollapsibleState:J.CommentThreadCollapsibleState,CommentThreadState:J.CommentThreadState,CommentThreadApplicability:J.CommentThreadApplicability,CompletionItem:J.CompletionItem,CompletionItemKind:J.CompletionItemKind,CompletionItemTag:J.CompletionItemTag,CompletionList:J.CompletionList,CompletionTriggerKind:J.CompletionTriggerKind,ConfigurationTarget:J.ConfigurationTarget,CustomExecution:J.CustomExecution,DebugAdapterExecutable:J.DebugAdapterExecutable,DebugAdapterInlineImplementation:J.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:J.DebugAdapterNamedPipeServer,DebugAdapterServer:J.DebugAdapterServer,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:J.DebugConsoleMode,DebugVisualization:J.DebugVisualization,DecorationRangeBehavior:J.DecorationRangeBehavior,Diagnostic:J.Diagnostic,DiagnosticRelatedInformation:J.DiagnosticRelatedInformation,DiagnosticSeverity:J.DiagnosticSeverity,DiagnosticTag:J.DiagnosticTag,Disposable:J.Disposable,DocumentHighlight:J.DocumentHighlight,DocumentHighlightKind:J.DocumentHighlightKind,MultiDocumentHighlight:J.MultiDocumentHighlight,DocumentLink:J.DocumentLink,DocumentSymbol:J.DocumentSymbol,EndOfLine:J.EndOfLine,EnvironmentVariableMutatorType:J.EnvironmentVariableMutatorType,EvaluatableExpression:J.EvaluatableExpression,InlineValueText:J.InlineValueText,InlineValueVariableLookup:J.InlineValueVariableLookup,InlineValueEvaluatableExpression:J.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:J.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:J.ExtensionKind,ExtensionMode:J.ExtensionMode,ExternalUriOpenerPriority:J.ExternalUriOpenerPriority,FileChangeType:J.FileChangeType,FileDecoration:J.FileDecoration,FileDecoration2:J.FileDecoration,FileSystemError:J.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:J.FoldingRange,FoldingRangeKind:J.FoldingRangeKind,FunctionBreakpoint:J.FunctionBreakpoint,InlineCompletionItem:J.InlineSuggestion,InlineCompletionList:J.InlineSuggestionList,Hover:J.Hover,VerboseHover:J.VerboseHover,HoverVerbosityAction:J.HoverVerbosityAction,IndentAction:_.IndentAction,Location:J.Location,MarkdownString:J.MarkdownString,OverviewRulerLane:c.OverviewRulerLane,ParameterInformation:J.ParameterInformation,PortAutoForwardAction:J.PortAutoForwardAction,Position:J.Position,ProcessExecution:J.ProcessExecution,ProgressLocation:J.ProgressLocation,QuickInputButtons:J.QuickInputButtons,Range:J.Range,RelativePattern:J.RelativePattern,Selection:J.Selection,SelectionRange:J.SelectionRange,SemanticTokens:J.SemanticTokens,SemanticTokensBuilder:J.SemanticTokensBuilder,SemanticTokensEdit:J.SemanticTokensEdit,SemanticTokensEdits:J.SemanticTokensEdits,SemanticTokensLegend:J.SemanticTokensLegend,ShellExecution:J.ShellExecution,ShellQuoting:J.ShellQuoting,SignatureHelp:J.SignatureHelp,SignatureHelpTriggerKind:J.SignatureHelpTriggerKind,SignatureInformation:J.SignatureInformation,SnippetString:J.SnippetString,SourceBreakpoint:J.SourceBreakpoint,StandardTokenType:J.StandardTokenType,StatusBarAlignment:J.StatusBarAlignment,SymbolInformation:J.SymbolInformation,SymbolKind:J.SymbolKind,SymbolTag:J.SymbolTag,Task:J.Task,TaskGroup:J.TaskGroup,TaskPanelKind:J.TaskPanelKind,TaskRevealKind:J.TaskRevealKind,TaskScope:J.TaskScope,TerminalLink:J.TerminalLink,TerminalQuickFixTerminalCommand:J.TerminalQuickFixCommand,TerminalQuickFixOpener:J.TerminalQuickFixOpener,TerminalLocation:J.TerminalLocation,TerminalProfile:J.TerminalProfile,TerminalExitReason:J.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:J.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:J.TextDocumentSaveReason,TextEdit:J.TextEdit,SnippetTextEdit:J.SnippetTextEdit,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:J.TextEditorLineNumbersStyle,TextEditorRevealType:J.TextEditorRevealType,TextEditorSelectionChangeKind:J.TextEditorSelectionChangeKind,SyntaxTokenType:J.SyntaxTokenType,TextDocumentChangeReason:J.TextDocumentChangeReason,ThemeColor:J.ThemeColor,ThemeIcon:J.ThemeIcon,TreeItem:J.TreeItem,TreeItemCheckboxState:J.TreeItemCheckboxState,TreeItemCollapsibleState:J.TreeItemCollapsibleState,TypeHierarchyItem:J.TypeHierarchyItem,UIKind:ti.UIKind,Uri:p.URI,ViewColumn:J.ViewColumn,WorkspaceEdit:J.WorkspaceEdit,DocumentPasteTriggerKind:J.DocumentPasteTriggerKind,DocumentDropEdit:J.DocumentDropEdit,DocumentDropOrPasteEditKind:J.DocumentDropOrPasteEditKind,DocumentPasteEdit:J.DocumentPasteEdit,InlayHint:J.InlayHint,InlayHintLabelPart:J.InlayHintLabelPart,InlayHintKind:J.InlayHintKind,RemoteAuthorityResolverError:J.RemoteAuthorityResolverError,ResolvedAuthority:J.ResolvedAuthority,ManagedResolvedAuthority:J.ManagedResolvedAuthority,SourceControlInputBoxValidationType:J.SourceControlInputBoxValidationType,ExtensionRuntime:J.ExtensionRuntime,TimelineItem:J.TimelineItem,NotebookRange:J.NotebookRange,NotebookCellKind:J.NotebookCellKind,NotebookCellExecutionState:J.NotebookCellExecutionState,NotebookCellData:J.NotebookCellData,NotebookData:J.NotebookData,NotebookRendererScript:J.NotebookRendererScript,NotebookCellStatusBarAlignment:J.NotebookCellStatusBarAlignment,NotebookEditorRevealType:J.NotebookEditorRevealType,NotebookCellOutput:J.NotebookCellOutput,NotebookCellOutputItem:J.NotebookCellOutputItem,NotebookCellStatusBarItem:J.NotebookCellStatusBarItem,NotebookControllerAffinity:J.NotebookControllerAffinity,NotebookControllerAffinity2:J.NotebookControllerAffinity2,NotebookEdit:J.NotebookEdit,NotebookKernelSourceAction:J.NotebookKernelSourceAction,NotebookVariablesRequestKind:J.NotebookVariablesRequestKind,PortAttributes:J.PortAttributes,LinkedEditingRanges:J.LinkedEditingRanges,TestResultState:J.TestResultState,TestRunRequest:J.TestRunRequest,TestMessage:J.TestMessage,TestTag:J.TestTag,TestRunProfileKind:J.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:J.DataTransfer,DataTransferItem:J.DataTransferItem,TestCoverageCount:J.TestCoverageCount,FileCoverage:J.FileCoverage,FileCoverage2:J.FileCoverage,StatementCoverage:J.StatementCoverage,BranchCoverage:J.BranchCoverage,DeclarationCoverage:J.DeclarationCoverage,WorkspaceTrustState:J.WorkspaceTrustState,LanguageStatusSeverity:J.LanguageStatusSeverity,QuickPickItemKind:J.QuickPickItemKind,InputBoxValidationSeverity:J.InputBoxValidationSeverity,TabInputText:J.TextTabInput,TabInputTextDiff:J.TextDiffTabInput,TabInputTextMerge:J.TextMergeTabInput,TabInputCustom:J.CustomEditorTabInput,TabInputNotebook:J.NotebookEditorTabInput,TabInputNotebookDiff:J.NotebookDiffEditorTabInput,TabInputWebview:J.WebviewEditorTabInput,TabInputTerminal:J.TerminalEditorTabInput,TabInputInteractiveWindow:J.InteractiveWindowInput,TabInputChat:J.ChatEditorTabInput,TabInputTextMultiDiff:J.TextMultiDiffTabInput,TelemetryTrustedValue:h.TelemetryTrustedValue,LogLevel:l.LogLevel,EditSessionIdentityMatch:g.EditSessionIdentityMatch,InteractiveSessionVoteDirection:J.InteractiveSessionVoteDirection,ChatCopyKind:J.ChatCopyKind,InteractiveEditorResponseFeedbackKind:J.InteractiveEditorResponseFeedbackKind,DebugStackFrame:J.DebugStackFrame,DebugThread:J.DebugThread,RelatedInformationType:J.RelatedInformationType,SpeechToTextStatus:J.SpeechToTextStatus,TextToSpeechStatus:J.TextToSpeechStatus,PartialAcceptTriggerKind:J.PartialAcceptTriggerKind,KeywordRecognitionStatus:J.KeywordRecognitionStatus,ChatResponseMarkdownPart:J.ChatResponseMarkdownPart,ChatResponseFileTreePart:J.ChatResponseFileTreePart,ChatResponseAnchorPart:J.ChatResponseAnchorPart,ChatResponseProgressPart:J.ChatResponseProgressPart,ChatResponseProgressPart2:J.ChatResponseProgressPart2,ChatResponseReferencePart:J.ChatResponseReferencePart,ChatResponseWarningPart:J.ChatResponseWarningPart,ChatResponseTextEditPart:J.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:J.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:J.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:J.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:J.ChatResponseConfirmationPart,ChatRequestTurn:J.ChatRequestTurn,ChatResponseTurn:J.ChatResponseTurn,ChatLocation:J.ChatLocation,LanguageModelChatMessageRole:J.LanguageModelChatMessageRole,LanguageModelChatMessage:J.LanguageModelChatMessage,LanguageModelChatMessageFunctionResultPart:J.LanguageModelFunctionResultPart,LanguageModelChatResponseTextPart:J.LanguageModelTextPart,LanguageModelChatResponseFunctionUsePart:J.LanguageModelFunctionUsePart,LanguageModelChatMessage2:J.LanguageModelChatMessage,LanguageModelChatSystemMessage:J.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:J.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:J.LanguageModelChatAssistantMessage,LanguageModelError:J.LanguageModelError,NewSymbolName:J.NewSymbolName,NewSymbolNameTag:J.NewSymbolNameTag,NewSymbolNameTriggerKind:J.NewSymbolNameTriggerKind,InlineEdit:J.InlineEdit,InlineEditTriggerKind:J.InlineEditTriggerKind}}}}),define(_e[396],ye([1,0,89,169,48,163,42,35,64,47,101,102,103,126,77,96,162,76,63,125,95,78,161,12,65,123,124,128,129,167,99]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f,u,v,y,D,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(u.IExtHostLocalizationService,u.ExtHostLocalizationService,s.InstantiationType.Delayed),(0,s.registerSingleton)(r.ILoggerService,i.ExtHostLoggerService,s.InstantiationType.Delayed),(0,s.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,s.InstantiationType.Delayed),(0,s.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,s.InstantiationType.Eager),(0,s.registerSingleton)(y.IExtHostAuthentication,y.ExtHostAuthentication,s.InstantiationType.Eager),(0,s.registerSingleton)(D.IExtHostLanguageModels,D.ExtHostLanguageModels,s.InstantiationType.Eager),(0,s.registerSingleton)(L.IExtHostConfiguration,L.ExtHostConfiguration,s.InstantiationType.Eager),(0,s.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,s.InstantiationType.Eager),(0,s.registerSingleton)(P.IExtHostTesting,P.ExtHostTesting,s.InstantiationType.Eager),(0,s.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService,s.InstantiationType.Eager),(0,s.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,s.InstantiationType.Eager),(0,s.registerSingleton)(p.IExtHostDocumentsAndEditors,p.ExtHostDocumentsAndEditors,s.InstantiationType.Eager),(0,s.registerSingleton)(v.IExtHostManagedSockets,v.ExtHostManagedSockets,s.InstantiationType.Eager),(0,s.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,s.InstantiationType.Eager),(0,s.registerSingleton)(d.IExtHostOutputService,d.ExtHostOutputService,s.InstantiationType.Delayed),(0,s.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,s.InstantiationType.Eager),(0,s.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,s.InstantiationType.Eager),(0,s.registerSingleton)(I.IExtHostTask,I.WorkerExtHostTask,s.InstantiationType.Eager),(0,s.registerSingleton)(a.IExtHostTerminalService,a.WorkerExtHostTerminalService,s.InstantiationType.Eager),(0,s.registerSingleton)(w.IExtHostTerminalShellIntegration,w.ExtHostTerminalShellIntegration,s.InstantiationType.Eager),(0,s.registerSingleton)(b.IExtHostTunnelService,b.ExtHostTunnelService,s.InstantiationType.Eager),(0,s.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,s.InstantiationType.Eager),(0,s.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,s.InstantiationType.Eager),(0,s.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,s.InstantiationType.Eager),(0,s.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry,s.InstantiationType.Eager),(0,s.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,s.InstantiationType.Eager),(0,s.registerSingleton)(f.IExtHostVariableResolverProvider,f.ExtHostVariableResolverProviderService,s.InstantiationType.Eager)}),define(_e[130],ye([1,0,19,12,38,100]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=L,e.createTextSearchResult=A,R=ze(R);function L(_){return _.startsWith("**")||_.startsWith("/")?_:`/${_}`}function A(_,c,C,b){const l=(0,s.mapArrayOrNot)(C,p),m=new T.TextSearchMatch(c,l,b),h=m.preview.matches;return{ranges:(0,s.mapArrayOrNot)(l,a),uri:_,preview:{text:m.preview.text,matches:(0,s.mapArrayOrNot)(h,a)}}}function p(_){return new T.SearchRange(_.start.line,_.start.character,_.end.line,_.end.character)}function a(_){return new R.Range(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn)}let I=class{constructor(c,C){this.prefix=c,this.logService=C}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};e.OutputChannel=I,e.OutputChannel=I=Xe([He(1,d.ILogService)],I)}),define(_e[397],ye([1,0,58,17,82,33,11,13,130,398]),function(le,e,s,d,T,R,L,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=_,e.getAbsoluteGlob=m,e.fixDriveC=g,s=ze(s),d=ze(d),R=ze(R),A=ze(A);const I=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function _(n,o,t,i,r){const f=c(n,o,t,i,r),u=o.folder.fsPath;return{cmd:s.spawn(I,f.args,{cwd:u}),rgDiskPath:I,siblingClauses:f.siblingClauses,rgArgs:f,cwd:u}}function c(n,o,t,i,r){const f=["--files","--hidden","--case-sensitive","--no-require-git"];b([o],t,!1).forEach(v=>{const y=(0,p.anchorGlob)(v);if(f.push("-g",y),L.isMacintosh){const D=(0,T.normalizeNFD)(y);D!==y&&f.push("-g",D)}});const u=C([o],i,void 0,!1);return u.globArgs.forEach(v=>{const y=`!${(0,p.anchorGlob)(v)}`;if(f.push("-g",y),L.isMacintosh){const D=(0,T.normalizeNFD)(y);D!==y&&f.push("-g",D)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),r&&f.push("--threads",`${r}`),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:u.siblingClauses}}function C(n,o,t,i=!0){const r=[];let f={};return n.forEach(u=>{const v=Object.assign({},u.excludePattern||{},o||{}),y=l(v,i?u.folder.fsPath:void 0,t);r.push(...y.globArgs),y.siblingClauses&&(f=Object.assign(f,y.siblingClauses))}),{globArgs:r,siblingClauses:f}}function b(n,o,t=!0){const i=[];return n.forEach(r=>{const f=Object.assign({},o||{},r.includePattern||{}),u=l(f,t?r.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function l(n,o,t){const i=[],r={};return Object.keys(n).forEach(f=>{if(t&&t.has(f)||!f)return;const u=n[f];f=h(o?m(o,f):f),f.startsWith("\\\\")?f="\\\\"+f.substr(2).replace(/\\/g,"/"):f=f.replace(/\\/g,"/"),typeof u=="boolean"&&u?(f.startsWith("\\\\")&&(f+="**"),i.push(g(f))):u&&u.when&&(r[f]=u)}),{globArgs:i,siblingClauses:r}}function m(n,o){return d.isAbsolute(o)?o:d.join(n,o)}function h(n){return n=A.rtrim(n,"\\"),A.rtrim(n,"/")}function g(n){return R.getRoot(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(_e[399],ye([1,0,58,61,17,400,19,51,39,82,33,11,43,13,18,34,38,397,141]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0,s=ze(s),d=ze(d),T=ze(T),L=ze(L),p=ze(p),a=ze(a),_=ze(_),C=ze(C),b=ze(b);const n=new Set;process.on("exit",()=>{n.forEach(f=>f())});class o{constructor(u){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=u,this.filePattern=u.filePattern||"",this.includePattern=u.includePattern&&p.parse(u.includePattern),this.maxResults=u.maxResults||null,this.exists=!!u.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=u.shouldGlobMatchFilePattern?null:(0,g.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=u.excludePattern&&p.parse(u.excludePattern),this.folderExcludePatterns=new Map,u.folderQueries.forEach(v=>{const y=Object.assign({},v.excludePattern||{},this.config.excludePattern||{}),D=v.folder.fsPath;u.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==D).forEach(w=>{(0,I.isEqualOrParent)(w,D)&&(y[T.relative(D,w)]=!0)}),this.folderExcludePatterns.set(D,new i(y,D))})}cancel(){this.isCanceled=!0,n.forEach(u=>u())}walk(u,v,y,D,w,P){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return P(null,this.isLimitHit);v.forEach(k=>{const E=T.basename(k.fsPath);this.globalExcludePattern&&this.globalExcludePattern(k.fsPath,E)||this.matchFile(D,{relativePath:k.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(u,(k,E)=>{this.call(this.cmdTraversal,this,k,y,D,w,S=>{if(S){const M=(0,A.toErrorMessage)(S);console.error(M),this.errors.push(M),E(S,void 0)}else E(null,void 0)})},(k,E)=>{this.fileWalkSW.stop();const S=k?L.coalesce(k)[0]:null;P(S,this.isLimitHit)})}parallel(u,v,y){const D=new Array(u.length),w=new Array(u.length);let P=!1,k=0;if(u.length===0)return y(null,[]);u.forEach((E,S)=>{v(E,(M,N)=>{if(M?(P=!0,D[S]=null,w[S]=M):(D[S]=N,w[S]=null),++k===u.length)return y(P?w:null,D)})})}call(u,v,...y){try{u.apply(v,y)}catch(D){y[y.length-1](D)}}cmdTraversal(u,v,y,D,w){const P=u.folder.fsPath,k=_.isMacintosh,E=()=>x&&x.kill();n.add(E);let S=j=>{n.delete(E),S=()=>{},w(j)},M="";const N=this.initDirectoryTree(),O=(0,h.spawnRipgrepCmd)(this.config,u,this.config.includePattern,this.folderExcludePatterns.get(u.folder.fsPath).expression,v),x=O.cmd,U=!Object.keys(O.siblingClauses).length,F=O.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let H=`${O.rgDiskPath} ${F}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),D({message:H}),this.cmdResultCount=0,this.collectStdout(x,"utf8",D,(j,re,B)=>{if(j){S(j);return}if(this.isLimitHit){S();return}const X=(M+(k?a.normalizeNFC(re||""):re)).split(`
`);if(B){const ee=X.length;X[ee-1]=X[ee-1].trim(),X[ee-1]||X.pop()}else M=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=X.length,U){for(const ee of X)if(this.matchFile(y,{base:P,relativePath:ee,searchPath:this.getSearchPath(u,ee)}),this.isLimitHit){E();break}(B||this.isLimitHit)&&S();return}this.addDirectoryEntries(u,N,P,X,y),B&&(this.matchDirectoryTree(N,P,y),S())})}spawnFindCmd(u){const v=this.folderExcludePatterns.get(u.folder.fsPath),y=v.getBasenameTerms(),D=v.getPathTerms(),w=["-L","."];if(y.length||D.length){w.push("-not","(","(");for(const P of y)w.push("-name",P),w.push("-o");for(const P of D)w.push("-path",P),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),s.spawn("find",w,{cwd:u.folder.fsPath})}readStdout(u,v,y){let D="";this.collectStdout(u,v,()=>{},(w,P,k)=>{if(w){y(w);return}D+=P,k&&y(null,D)})}collectStdout(u,v,y,D){let w=(E,S,M)=>{(E||M)&&(w=()=>{},this.cmdSW?.stop()),D(E,S,M)},P=!1;u.stdout?(this.forwardData(u.stdout,v,w),u.stdout.once("data",()=>P=!0)):y({message:"stdout is null"});let k;u.stderr?k=this.collectData(u.stderr):y({message:"stderr is null"}),u.on("error",E=>{w(E)}),u.on("close",E=>{let S;!P&&(S=this.decodeData(k,v))&&r(S)?w(new Error(`command failed with error code ${E}: ${this.decodeData(k,v)}`)):(this.exists&&E===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(u,v,y){const D=new R.StringDecoder(v);return u.on("data",w=>{y(null,D.write(w))}),D}collectData(u){const v=[];return u.on("data",y=>{v.push(y)}),v}decodeData(u,v){const y=new R.StringDecoder(v);return u.map(D=>y.write(D)).join("")}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries(u,{pathToEntries:v},y,D,w){D.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:y,relativePath:this.filePattern,searchPath:this.getSearchPath(u,this.filePattern)});const P=k=>{const E=T.basename(k),S=T.dirname(k);let M=v[S];M||(M=v[S]=[],P(S)),M.push({base:y,relativePath:k,basename:E,searchPath:this.getSearchPath(u,k)})};D.forEach(P)}matchDirectoryTree({rootEntries:u,pathToEntries:v},y,D){const w=this,P=this.folderExcludePatterns.get(y),k=this.filePattern;function E(S){w.directoriesWalked++;const M=(0,m.hasSiblingFn)(()=>S.map(N=>N.basename));for(let N=0,O=S.length;N<O;N++){const x=S[N],{relativePath:U,basename:F}=x;if(P.test(U,F,k!==F?M:void 0))continue;const H=v[U];if(H)E(H);else{if(w.filesWalked++,U===k)continue;w.matchFile(D,x)}if(w.isLimitHit)break}}E(u)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(u,v,y,D,w){const P=u.folder,k=(0,m.hasSiblingFn)(()=>y);this.parallel(y,(E,S)=>{if(this.isCanceled||this.isLimitHit)return S(null);const M=v?[v,E].join(T.sep):E;if(this.folderExcludePatterns.get(u.folder.fsPath).test(M,E,this.config.filePattern!==E?k:void 0))return S(null);const N=[P.fsPath,M].join(T.sep);d.lstat(N,(O,x)=>{if(O||this.isCanceled||this.isLimitHit)return S(null);this.statLinkIfNeeded(N,x,(U,F)=>U||this.isCanceled||this.isLimitHit?S(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,x,(H,j)=>H||this.isCanceled||this.isLimitHit||(j=j||"",this.walkedPaths[j])?S(null):(this.walkedPaths[j]=!0,l.Promises.readdir(N).then(re=>{if(this.isCanceled||this.isLimitHit)return S(null);this.doWalk(u,M,re,D,B=>S(B||null))},re=>{S(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&b.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(D,{base:P.fsPath,relativePath:M,searchPath:this.getSearchPath(u,M)}),S(null,void 0)))})},E=>{const S=E&&L.coalesce(E);return w(S&&S.length>0?S[0]:void 0)})}matchFile(u,v){this.isFileMatch(v)&&(!this.includePattern||this.includePattern(v.relativePath,T.basename(v.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||u(v))}isFileMatch(u){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(u,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,m.isFilePatternMatch)(u,this.filePattern,!1)}return!0}statLinkIfNeeded(u,v,y){return v.isSymbolicLink()?d.stat(u,y):y(null,v)}realPathIfNeeded(u,v,y){return v.isSymbolicLink()?d.realpath(u,(D,w)=>D?y(D):y(null,w)):y(null,u)}getSearchPath(u,v){return u.folderName?T.join(u.folderName,v):v}}e.FileWalker=o;class t{constructor(u,v){this.folderQueries=u.folderQueries,this.extraFiles=u.extraFileResources||[],this.numThreads=v,this.walker=new o(u)}search(u,v,y){this.walker.walk(this.folderQueries,this.extraFiles,this.numThreads,u,v,(D,w)=>{y(D,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=t;class i{constructor(u,v){this.expression=u,this.root=v,this.init(u)}init(u){let v,y;Object.keys(u).filter(D=>u[D]).forEach(D=>{T.isAbsolute(D)?(v=v||p.getEmptyExpression(),v[D]=u[D]):(y=y||p.getEmptyExpression(),y[D]=u[D])}),this.absoluteParsedExpr=v&&p.parse(v,{trimForExclusions:!0}),this.relativeParsedExpr=y&&p.parse(y,{trimForExclusions:!0})}test(u,v,y){return this.relativeParsedExpr&&this.relativeParsedExpr(u,v,y)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,u),v,y)}getBasenameTerms(){const u=[];return this.absoluteParsedExpr&&u.push(...p.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&u.push(...p.getBasenameTerms(this.relativeParsedExpr)),u}getPathTerms(){const u=[];return this.absoluteParsedExpr&&u.push(...p.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&u.push(...p.getPathTerms(this.relativeParsedExpr)),u}}function r(f){const u=f.trim().split(`
`),v=u[0].trim();if(v.startsWith("Error parsing regex"))return v;if(v.startsWith("regex parse error"))return C.uppercaseFirstLetter(u[u.length-1].trim());if(v.startsWith("error parsing glob")||v.startsWith("unsupported encoding"))return v.charAt(0).toUpperCase()+v.substr(1);if(v==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(v.startsWith("Literal "))return v}}),define(_e[401],ye([1,0,104,22,208,21,19]),function(le,e,s,d,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GUESSABLE_ENCODINGS=e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=A,e.toDecodeStream=l,e.toEncodeReadable=m,e.encodingExists=h,e.toNodeEncoding=g,e.detectEncodingByBOMFromBuffer=n,e.toCanonicalName=y,e.detectEncodingFromBuffer=D,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(w){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(P=>P===w)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const p=512,a=512,I=512*8,_=512*128;var c;(function(w){w[w.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(c||(e.DecodeStreamErrorKind=c={}));class C extends Error{constructor(P,k){super(P),this.decodeStreamErrorKind=k}}e.DecodeStreamError=C;class b{static async create(P){let k;if(P!==e.UTF8)k=(await(0,T.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(g(P));else{const E=new TextDecoder;k={write(S){return E.decode(S,{stream:!0})},end(){return E.decode()}}}return new b(k)}constructor(P){this.iconvLiteDecoder=P}write(P){return this.iconvLiteDecoder.write(P)}end(){return this.iconvLiteDecoder.end()}}function l(w,P){const k=P.minBytesRequiredForDetection??P.guessEncoding?I:a;return new Promise((E,S)=>{const M=(0,s.newWriteableStream)(H=>H.join("")),N=[];let O=0,x;const U=new R.CancellationTokenSource,F=async()=>{try{const H=await D({buffer:d.VSBuffer.concat(N),bytesRead:O},P.guessEncoding,P.candidateGuessEncodings);if(H.seemsBinary&&P.acceptTextOnly)throw new C("Stream is binary but only text is accepted for decoding",c.STREAM_IS_BINARY);H.encoding=await P.overwriteEncoding(H.encoding),x=await b.create(H.encoding);const j=x.write(d.VSBuffer.concat(N).buffer);M.write(j),N.length=0,O=0,E({stream:M,detected:H})}catch(H){U.cancel(),M.destroy(),S(H)}};(0,s.listenStream)(w,{onData:async H=>{x?M.write(x.write(H.buffer)):(N.push(H),O+=H.byteLength,O>=k&&(w.pause(),await F(),setTimeout(()=>w.resume())))},onError:H=>M.error(H),onEnd:async()=>{x||await F(),M.end(x?.end())}},U.token)})}async function m(w,P,k){const S=(await(0,T.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(g(P),k);let M=!1,N=!1;return{read(){if(N)return null;const O=w.read();if(typeof O!="string"){if(N=!0,!M&&k?.addBOM)switch(P){case e.UTF8:case e.UTF8_with_bom:return d.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return d.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return d.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const x=S.end();return x&&x.length>0?(M=!0,d.VSBuffer.wrap(x)):null}return M=!0,d.VSBuffer.wrap(S.write(O))}}}async function h(w){return(await(0,T.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(g(w))}function g(w){return w===e.UTF8_with_bom||w===null?e.UTF8:w}function n(w,P){if(!w||P<e.UTF16be_BOM.length)return null;const k=w.readUInt8(0),E=w.readUInt8(1);if(k===e.UTF16be_BOM[0]&&E===e.UTF16be_BOM[1])return e.UTF16be;if(k===e.UTF16le_BOM[0]&&E===e.UTF16le_BOM[1])return e.UTF16le;if(P<e.UTF8_BOM.length)return null;const S=w.readUInt8(2);return k===e.UTF8_BOM[0]&&E===e.UTF8_BOM[1]&&S===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const o=["ascii","utf-16","utf-32"];async function t(w,P){const k=await(0,T.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),E=w.slice(0,_),S=v(E.buffer);P&&(P=(0,L.coalesce)(P.map(O=>u(O))),P.length===0&&(P=void 0));const M=k.detect(S,P?{detectEncodings:P}:void 0);if(!M||!M.encoding)return null;const N=M.encoding.toLowerCase();return 0<=o.indexOf(N)?null:f(M.encoding)}const i={ibm866:"cp866",big5:"cp950"};function r(w){return w.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function f(w){const P=r(w);return i[P]||P}function u(w){const P=r(w);return e.GUESSABLE_ENCODINGS[P].guessableName}function v(w){let P="";for(let k=0;k<w.length;k++)P+=String.fromCharCode(w[k]);return P}function y(w){switch(w){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const P=w.match(/windows(\d+)/);return P?"windows-"+P[1]:w}}}function D({buffer:w,bytesRead:P},k,E){let S=n(w,P),M=!1;if(S!==e.UTF16be&&S!==e.UTF16le&&w){let N=!0,O=!0,x=!1;for(let U=0;U<P&&U<p;U++){const F=U%2===1,H=w.readUInt8(U)===0;if(H&&(x=!0),N&&(F&&!H||!F&&H)&&(N=!1),O&&(F&&H||!F&&!H)&&(O=!1),H&&!N&&!O)break}x&&(N?S=e.UTF16le:O?S=e.UTF16be:M=!0)}return k&&!M&&!S&&w?t(w.slice(0,P),E).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:M,encoding:S}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.GUESSABLE_ENCODINGS=(()=>{const w={};for(const P in e.SUPPORTED_ENCODINGS)e.SUPPORTED_ENCODINGS[P].guessableName&&(w[P]=e.SUPPORTED_ENCODINGS[P]);return w})()}),define(_e[172],ye([1,0,401,34,171]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0,d=ze(d);class R extends T.TextSearchManager{constructor(A,p,a=d,I="searchProcess"){super({query:A,provider:p},{readdir:_=>a.Promises.readdir(_.fsPath),toCanonicalName:_=>(0,s.toCanonicalName)(_)},I)}}e.NativeTextSearchManager=R}),define(_e[173],ye([1,0,58,416,400,19,79,39,13,2,38,100,417,398,130]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=i,e.unicodeEscapesToPCRE2=f,e.fixRegexNewline=v,e.fixNewline=y,e.performBraceExpansionForRipgrep=w,s=ze(s);const l=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(k,E){this.outputChannel=k,this._numThreads=E}provideTextSearchResults(k,E,S,M){return this.outputChannel.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((N,O)=>{M.onCancellationRequested(()=>X());const x={...E,numThreads:this._numThreads},U=i(k,x),F=E.folder.fsPath,H=U.map(pe=>pe.match(/^-/)?pe:`'${pe}'`).join(" ");this.outputChannel.appendLine(`${l} ${H}
 - cwd: ${F}`);let j=s.spawn(l,U,{cwd:F});j.on("error",pe=>{console.error(pe),this.outputChannel.appendLine("Error: "+(pe&&pe.message)),O((0,I.serializeSearchError)(new I.SearchError(pe&&pe.message,I.SearchErrorCode.rgProcessError)))});let re=!1;const B=new n(E.maxResults,E.folder,E.previewOptions);B.on("result",pe=>{re=!0,he="",S.report(pe)});let V=!1;const X=()=>{V=!0,j?.kill(),B?.cancel()};let ee=!1;B.on("hitLimit",()=>{ee=!0,X()});let he="";j.stdout.on("data",pe=>{B.handleData(pe),re||(he+=pe)});let ne=!1;j.stdout.once("data",()=>ne=!0);let De="";j.stderr.on("data",pe=>{const G=pe.toString();this.outputChannel.appendLine(G),De.length+G.length<1e6&&(De+=G)}),j.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(re?"Got result from parser":"No result from parser"),he&&this.outputChannel.appendLine(`Got data without result: ${he}`),this.outputChannel.appendLine(""),V)N({limitHit:ee});else{B.flush(),j=null;let pe;De&&!ne&&(pe=h(De))?O((0,I.serializeSearchError)(new I.SearchError(pe.message,pe.code))):N({limitHit:ee})}})})}}e.RipgrepTextSearchEngine=m;function h(P){const k=P.split(`
`),E=k[0].trim();if(k.some(M=>M.startsWith("regex parse error")))return new I.SearchError(g(k),I.SearchErrorCode.regexParseError);const S=E.match(/grep config error: unknown encoding: (.*)/);if(S)return new I.SearchError(`Unknown encoding: ${S[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}function g(P){const k=["Regex parse error"],E=P.filter(S=>S.startsWith("PCRE2:"));if(E.length>=1){const S=E[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const M=S.split(":")[1];k.push(":"+M)}}return k.join("")}class n extends d.EventEmitter{constructor(k,E,S){super(),this.maxResults=k,this.root=E,this.previewOptions=S,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(k,E){return super.on(k,E),this}handleData(k){if(this.isDone)return;const E=typeof k=="string"?k:this.stringDecoder.write(k);this.handleDecodedData(E)}handleDecodedData(k){let E=k.indexOf(`
`);const S=this.remainder+k;if(E>=0)E+=this.remainder.length;else{this.remainder=S;return}let M=0;for(;E>=0;)this.handleLine(S.substring(M,E).trim()),M=E+1,E=S.indexOf(`
`,M);this.remainder=S.substring(M)}handleLine(k){if(this.isDone||!k)return;let E;try{E=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(E.type==="match"){const S=o(E.data.path),M=a.URI.joinPath(this.root,S),N=this.createTextSearchMatch(E.data,M);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const S=o(E.data.path),M=a.URI.joinPath(this.root,S);this.createTextSearchContext(E.data,M).forEach(O=>this.onResult(O))}}createTextSearchMatch(k,E){const S=k.line_number-1,M=o(k.lines),N=Buffer.from(M);let O=0,x=0,U=S;k.submatches.length===0&&k.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.coalesce)(k.submatches.map((H,j)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const re=o(H.match),B=N.slice(O,H.start).toString(),V=t(B),X=V.numLines>0?V.lastLineLength:V.lastLineLength+x,ee=t(re),he=V.numLines+U,ne=ee.numLines+he,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+X;return O=H.end,x=De,U=ne,new _.Range(he,X,ne,De)}));return(0,b.createTextSearchResult)(E,M,F,this.previewOptions)}createTextSearchContext(k,E){const S=o(k.lines),M=k.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:E,lineNumber:M+O}))}onResult(k){this.emit("result",k)}}e.RipgrepParser=n;function o(P){return P.bytes?Buffer.from(P.bytes,"base64").toString():P.text}function t(P){const k=/\n/g;let E=0,S=-1,M;for(;M=k.exec(P);)E++,S=M.index;const N=S>=0?P.length-S-1:P.length;return{numLines:E,lastLineLength:N}}function i(P,k){const E=["--hidden","--no-require-git"];E.push(P.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:M}=(0,L.groupBy)(k.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const O=new Set;M.forEach(x=>{O.add(x)}),E.push("-g","!*"),O.forEach(x=>{r(x).map(b.anchorGlob).forEach(U=>{E.push("-g",U)})})}S&&S.length&&S.forEach(O=>{E.push("-g",O)}),k.excludes.map(b.anchorGlob).forEach(O=>E.push("-g",`!${O}`)),k.maxFileSize&&E.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),k.followSymlinks&&E.push("--follow"),k.encoding&&k.encoding!=="utf8"&&E.push("--encoding",k.encoding),k.numThreads&&E.push("--threads",`${k.numThreads}`),P.pattern==="--"&&(P.isRegExp=!0,P.pattern="\\-\\-"),P.isMultiline&&!P.isRegExp&&(P.pattern=(0,p.escapeRegExpCharacters)(P.pattern),P.isRegExp=!0),k.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),P.isRegExp&&(P.pattern=f(P.pattern),E.push("--engine","auto"));let N;if(P.isWordMatch){const x=(0,p.createRegExp)(P.pattern,!!P.isRegExp,{wholeWord:P.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",x)}else if(P.isRegExp){let O=v(P.pattern);O=y(O),E.push("--regexp",O)}else N=P.pattern,E.push("--fixed-strings");return E.push("--no-config"),k.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),P.isMultiline&&E.push("--multiline"),k.beforeContext&&E.push("--before-context",k.beforeContext+""),k.afterContext&&E.push("--after-context",k.afterContext+""),E.push("--"),N&&E.push(N),E.push("."),E}function r(P){return w(P).flatMap(E=>{const S=(0,A.splitGlobAware)(E,"/");return S.map((M,N)=>S.slice(0,N+1).join("/"))})}function f(P){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;P.match(k);)P=P.replace(k,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;P.match(E);)P=P.replace(E,"$1\\x{$2}");return P}const u=P=>P.type==="Assertion"&&P.kind==="lookbehind";function v(P){let k;try{k=new c.RegExpParser().parsePattern(P)}catch{return P}let E="",S=0;const M=(x,U,F)=>{E+=P.slice(S,x)+F,S=U},N=[];return new c.RegExpVisitor({onCharacterEnter(x){if(x.raw!=="\\n")return;const U=N[0];if(!U)M(x.start,x.end,"\\r?\\n");else if(!N.some(u))if(U.type==="CharacterClass")if(U.negate){const F=P.slice(U.start+2,x.start)+P.slice(x.end,U.end-1);U.parent?.type==="Quantifier"?M(U.start,U.end,F?`[^${F}]`:"."):M(U.start,U.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=P.slice(U.start+1,x.start)+P.slice(x.end,U.end-1);M(U.start,U.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else U.type==="Quantifier"&&M(x.start,x.end,"(?:\\r?\\n)")},onQuantifierEnter(x){N.unshift(x)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(x){N.unshift(x)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(x){N.unshift(x)},onCharacterClassLeave(){N.shift()},onAssertionEnter(x){u(x)&&N.push(x)},onAssertionLeave(x){N[0]===x&&N.shift()}}).visit(k),E+=P.slice(S),E}function y(P){return P.replace(/\n/g,"\\r?\\n")}function D(P){let k=!1,E=!1,S="",M="";for(let N=0;N<P.length;N++){const O=P[N];switch(O){case"\\":E?(k?M+="\\"+O:S+="\\"+O,E=!1):E=!0;break;case"{":if(E)k?M+=O:S+=O,E=!1;else{if(k)return{strInBraces:S+"{"+M+"{"+P.substring(N+1)};k=!0}break;case"}":if(E)k?M+=O:S+=O,E=!1;else{if(k)return{fixedStart:S,strInBraces:M,fixedEnd:P.substring(N+1)};S+=O}break;default:k?M+=(E?"\\":"")+O:S+=(E?"\\":"")+O,E=!1;break}}return{strInBraces:S+(k?"{"+M:"")}}function w(P){const{fixedStart:k,strInBraces:E,fixedEnd:S}=D(P);if(k===void 0||S===void 0)return[E];let M=(0,A.splitGlobAware)(E,",");M.length||(M=[""]);const N=w(S);return M.flatMap(O=>{const x=k+O;return N.map(U=>x+U)})}}),define(_e[402],ye([1,0,21,173,90,15]),function(le,e,s,d,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class L{constructor(a,I){this.outputChannel=a,this.getNumThreads=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}async provideTextSearchResults(a,I,_,c){const C=await this.getNumThreads(),b=new d.RipgrepTextSearchEngine(this.outputChannel,C),l={...I,numThreads:C};if(I.folder.scheme===R.Schemas.vscodeUserData){const m={...l,folder:I.folder.with({scheme:R.Schemas.file})},h=new T.Progress(g=>_.report({...g,uri:g.uri.with({scheme:I.folder.scheme})}));return this.withToken(c,g=>b.provideTextSearchResults(a,m,h,g))}else return this.withToken(c,m=>b.provideTextSearchResults(a,l,_,m))}async withToken(a,I){const _=A(a);this.inProgress.add(_);const c=await I(_.token);return this.inProgress.delete(_),c}dispose(){this.inProgress.forEach(a=>a.cancel())}}e.RipgrepSearchProvider=L;function A(p){const a=new s.CancellationTokenSource;return p.onCancellationRequested(()=>a.cancel()),a}}),define(_e[403],ye([1,0,34,173,172]),function(le,e,s,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0,s=ze(s);class R{constructor(p,a){this.query=p,this.numThreads=a}search(p,a,I){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const _={appendLine(C){I({message:C})}},c=new T.NativeTextSearchManager(this.query,new d.RipgrepTextSearchEngine(_,this.numThreads),s);return new Promise((C,b)=>c.search(l=>{a(l.map(L))},p).then(l=>C({limitHit:l.limitHit??!1,type:"success",stats:l.stats,messages:[]}),b))}}e.TextSearchEngineAdapter=R;function L(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((p,a)=>{if(a.ranges){const I=a;return p+(Array.isArray(I.ranges)?I.ranges.length:1)}else return p+1},0)}}}),define(_e[404],ye([1,0,19,9,14,4,141,17,43,2,28,38,399,403]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,s=ze(s);class b{static{this.BATCH_SIZE=512}constructor(o="searchProcess",t){this.processType=o,this.getNumThreads=t,this.caches=Object.create(null)}fileSearch(o){let t;const i=h(o),r=new R.Emitter({onDidAddFirstListener:()=>{t=(0,d.createCancelablePromise)(async f=>{const u=await this.getNumThreads?.();return this.doFileSearchWithEngine(c.Engine,i,v=>r.fire(v),f,b.BATCH_SIZE,u)}),t.then(f=>r.fire(f),f=>r.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return r.event}textSearch(o){let t;const i=h(o),r=new R.Emitter({onDidAddFirstListener:()=>{t=(0,d.createCancelablePromise)(f=>this.ripgrepTextSearch(i,u=>r.fire(u),f)),t.then(f=>r.fire(f),f=>r.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return r.event}async ripgrepTextSearch(o,t,i){o.maxFileSize=this.getPlatformFileLimits().maxFileSize;const r=await this.getNumThreads?.();return new C.TextSearchEngineAdapter(o,r).search(i,t,t)}getPlatformFileLimits(){return{maxFileSize:16*I.ByteSize.GB}}doFileSearch(o,t,i,r){return this.doFileSearchWithEngine(c.Engine,o,i,r,b.BATCH_SIZE,t)}doFileSearchWithEngine(o,t,i,r,f=b.BATCH_SIZE,u){let v=0;const y=w=>{Array.isArray(w)?(v+=w.length,i(w.map(P=>this.rawMatchToSearchItem(P)))):w.relativePath?(v++,i(this.rawMatchToSearchItem(w))):i(w)};if(t.sortByScore){let w=this.trySortedSearchFromCache(t,y,r);if(!w){const P=t.maxResults?Object.assign({},t,{maxResults:null}):t,k=new o(P,u);w=this.doSortedSearch(k,t,i,y,r)}return new Promise((P,k)=>{w.then(([E,S])=>{const M=S.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(M,i,f),P(E)},k)})}const D=new o(t,u);return this.doSearch(D,y,f,r).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.processType,fromCache:!1,resultCount:v,sortingTime:void 0},messages:[]}))}rawMatchToSearchItem(o){return{path:o.base?(0,A.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,t,i,r,f){const u=new R.Emitter;let v=(0,d.createCancelablePromise)(D=>{let w=[];const P=k=>{Array.isArray(k)?w=k:(r(k),u.fire(k))};return this.doSearch(o,P,-1,D).then(k=>[k,w])}),y;if(t.cacheKey){y=this.getOrCreateCache(t.cacheKey);const D={promise:v,event:u.event,resolved:!1};y.resultsToSearchCache[t.filePattern||""]=D,v.then(()=>{D.resolved=!0},w=>{delete y.resultsToSearchCache[t.filePattern||""]}),v=this.preventCancellation(v)}return v.then(([D,w])=>{const P=y?y.scorerCache:Object.create(null),k=(typeof t.maxResults!="number"||t.maxResults>0)&&p.StopWatch.create(!1);return this.sortResults(t,w,P,f).then(E=>{const S=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:S,fromCache:!1,type:this.processType,resultCount:E.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&w.length>t.maxResults},E]})})}getOrCreateCache(o){const t=this.caches[o];return t||(this.caches[o]=new l)}trySortedSearchFromCache(o,t,i){const r=o.cacheKey&&this.caches[o.cacheKey];if(!r)return;const f=this.getResultsFromCache(r,o.filePattern||"",t,i);if(f)return f.then(([u,v,y])=>{const D=p.StopWatch.create(!1);return this.sortResults(o,v,r.scorerCache,i).then(w=>{const P=D.elapsed(),k={fromCache:!0,detailStats:y,type:this.processType,resultCount:v.length,sortingTime:P};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&v.length>o.maxResults,stats:k,messages:[]},w]})})}sortResults(o,t,i,r){const f=(0,L.prepareQuery)(o.filePattern||""),u=(y,D)=>(0,L.compareItemsByFuzzyScore)(y,D,f,!0,m,i),v=typeof o.maxResults=="number"?o.maxResults:_.DEFAULT_MAX_SEARCH_RESULTS;return s.topAsync(t,u,v,1e4,r)}sendProgress(o,t,i){if(i&&i>0)for(let r=0;r<o.length;r+=i)t(o.slice(r,r+i));else t(o)}getResultsFromCache(o,t,i,r){const f=p.StopWatch.create(!1),u=t.indexOf(A.sep)>=0;let v;for(const P in o.resultsToSearchCache)if(t.startsWith(P)){if(u&&P.indexOf(A.sep)<0&&P!=="")continue;const k=o.resultsToSearchCache[P];v={promise:this.preventCancellation(k.promise),event:k.event,resolved:k.resolved};break}if(!v)return null;const y=f.elapsed(),D=p.StopWatch.create(!1),w=v.event(i);return r&&r.onCancellationRequested(()=>{w.dispose()}),v.promise.then(([P,k])=>{if(r&&r.isCancellationRequested)throw(0,T.canceled)();const E=[],S=(0,L.prepareQuery)(t).normalizedLowercase;for(const M of k)(0,_.isFilePatternMatch)(M,S)&&E.push(M);return[P,E,{cacheWasResolved:v.resolved,cacheLookupTime:y,cacheFilterTime:D.elapsed(),cacheEntryCount:k.length}]})}doSearch(o,t,i,r){return new Promise((f,u)=>{let v=[];r?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(i?(v.push(y),i>0&&v.length>=i&&(t(v),v=[])):t(y))},y=>{t(y)},(y,D)=>{v.length&&t(v),y?(t({message:"Search finished. Error: "+y.message}),u(y)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),f(D))})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return o.then(t,i)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.SearchService=b;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,A.basename)(n.relativePath)}getItemDescription(n){return(0,A.dirname)(n.relativePath)}getItemPath(n){return n.relativePath}};function h(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(g),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>a.URI.revive(o))}}function g(n){return{...n,folder:a.URI.revive(n.folder)}}}),define(_e[405],ye([1,0,3,15,2,34,12,42,30,20,103,73,38,404,402,130,172]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0,R=ze(R);let h=class extends I.ExtHostSearch{constructor(n,o,t,i,r){super(n,t,r),this.configurationService=i,this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new s.DisposableStore,this.isDisposed=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.handleConfigurationChanged=this.handleConfigurationChanged.bind(this);const f=new l.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(d.Schemas.vscodeUserData,new b.RipgrepSearchProvider(f,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders(),i.getConfigProvider().then(u=>{this.isDisposed||this._disposables.add(u.onDidChangeConfiguration(this.handleConfigurationChanged))})}handleConfigurationChanged(n){n.affectsConfiguration("search")&&(this._numThreadsPromise=void 0)}async getNumThreads(){return(await this.configurationService.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this._numThreadsPromise||(this._numThreadsPromise=this.getNumThreads()),this._numThreadsPromise}dispose(){this.isDisposed=!0,this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const n=new l.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(d.Schemas.file,new b.RipgrepSearchProvider(n,this.getNumThreadsCached))),this._disposables.add(this.registerInternalFileSearchProvider(d.Schemas.file,new C.SearchService("fileSearchProvider",this.getNumThreadsCached)))}registerInternalFileSearchProvider(n,o){const t=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=t,this._proxy.$registerFileSearchProvider(t,this._transformScheme(n)),(0,s.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,i){const r=(0,I.reviveQuery)(t);if(n===this._internalFileSearchHandle){const f=Date.now();return this.doInternalFileSearch(n,o,r,i).then(u=>{const v=Date.now()-f;return this._logService.debug(`Ext host file search time: ${v}ms`),u})}return super.$provideFileSearchResults(n,o,t,i)}async doInternalFileSearchWithCustomCallback(n,o,t){const i=f=>{if((0,c.isSerializedFileMatch)(f)&&(f=[f]),Array.isArray(f)){t(f.map(u=>T.URI.file(u.path)));return}f.message&&this._logService.debug("ExtHostSearch",f.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");const r=await this.getNumThreadsCached();return this._internalFileSearchProvider.doFileSearch(n,r,i,o)}async doInternalFileSearch(n,o,t,i){return this.doInternalFileSearchWithCustomCallback(t,i,r=>{this._proxy.$handleFileMatch(n,o,r)})}$clearCache(n){return this._internalFileSearchProvider?.clearCache(n),super.$clearCache(n)}createTextSearchManager(n,o){return new m.NativeTextSearchManager(n,o,void 0,"textSearchProvider")}};e.NativeExtHostSearch=h,e.NativeExtHostSearch=h=Xe([He(0,a.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,_.IURITransformerService),He(3,A.IExtHostConfiguration),He(4,L.ILogService)],h)}),define(_e[131],ye([1,0,418,67,68,419,22,14,4,3,17,11,32,87,69]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=u,e.createStaticIPCHandle=v,e.serve=w,e.connect=P;const l=3e4;class m{traceSocketEvent(E,S){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,S)}constructor(E,S=""){this._canWrite=!0,this.debugLabel=S,this.socket=E,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,A.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener);let M;this._closeListener=N=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:N}),this._canWrite=!1,M&&clearTimeout(M)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,M=setTimeout(()=>E.destroy(),l)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(E){const S=M=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,M),E(L.VSBuffer.wrap(M))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(E){const S=M=>{E({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(E){const S=()=>{E()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(E){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,A.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,A.onUnexpectedError)(S)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=m;var h;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class n extends a.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,S){this.socket.traceSocketEvent(E,S)}constructor(E,S,M,N){super(),this._onData=this._register(new p.Emitter),this._onClose=this._register(new p.Emitter),this._isEnded=!1,this._state={state:g.PeekHeader,readLen:h.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:M?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new o(this,S,M,N,this._onData,(O,x)=>this._write(O,x))),this._register(this._flowManager.onError(O=>{console.error(O),(0,A.onUnexpectedError)(O),this._onClose.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(async O=>{this._flowManager.isProcessingReadQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(O)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let S=0;for(;S<E.byteLength;)this._flowManager.writeMessage(E.slice(S,Math.min(S+h.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),S+=h.MaxWebSocketMessageLength}_write(E,{compressed:S,opcode:M}){if(this._isEnded)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let N=h.MinHeaderByteSize;E.byteLength<126?N+=0:E.byteLength<2**16?N+=2:N+=8;const O=L.VSBuffer.alloc(N),x=S?64:0,U=M&15;if(O.writeUInt8(128|x|U,0),E.byteLength<126)O.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){O.writeUInt8(126,1);let F=1;O.writeUInt8(E.byteLength>>>8&255,++F),O.writeUInt8(E.byteLength>>>0&255,++F)}else{O.writeUInt8(127,1);let F=1;O.writeUInt8(0,++F),O.writeUInt8(0,++F),O.writeUInt8(0,++F),O.writeUInt8(0,++F),O.writeUInt8(E.byteLength>>>24&255,++F),O.writeUInt8(E.byteLength>>>16&255,++F),O.writeUInt8(E.byteLength>>>8&255,++F),O.writeUInt8(E.byteLength>>>0&255,++F)}this.socket.write(L.VSBuffer.concat([O,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===g.PeekHeader){const S=this._incomingData.peek(this._state.readLen),M=S.readUInt8(0),N=(M&128)>>>7,O=(M&64)>>>6,x=M&15,U=S.readUInt8(1),F=(U&128)>>>7,H=U&127;this._state.state=g.ReadHeader,this._state.readLen=h.MinHeaderByteSize+(F?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!O),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=x,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===g.ReadHeader){const S=this._incomingData.read(this._state.readLen),M=S.readUInt8(1),N=(M&128)>>>7;let O=M&127,x=1;O===126?O=S.readUInt8(++x)*2**8+S.readUInt8(++x):O===127&&(O=S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*2**24+S.readUInt8(++x)*2**16+S.readUInt8(++x)*2**8+S.readUInt8(++x));let U=0;N&&(U=S.readUInt8(++x)*2**24+S.readUInt8(++x)*2**16+S.readUInt8(++x)*2**8+S.readUInt8(++x)),this._state.state=g.ReadBody,this._state.readLen=O,this._state.mask=U,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===g.ReadBody){const S=this._incomingData.read(this._state.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,S),r(S,this._state.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,S),this._state.state=g.PeekHeader,this._state.readLen=h.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(S,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=n;class o extends a.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(E,S,M,N,O,x){super(),this._tracer=E,this._onData=O,this._writeFn=x,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new p.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new p.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,S?(this._zlibInflateStream=this._register(new t(this._tracer,N,M,{windowBits:15})),this._zlibDeflateStream=this._register(new i(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(E,S){this._writeQueue.push({data:E,options:S}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:E,options:S}=this._writeQueue.shift();if(this._zlibDeflateStream&&S.compressed){const M=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(M,S)}else this._writeFn(E,{...S,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,S){return new Promise((M,N)=>{E.write(S),E.flush(O=>M(O))})}acceptFrame(E,S,M){this._readQueue.push({data:E,isCompressed:S,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const S=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(S)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(E,S,M){return new Promise((N,O)=>{E.write(S),M&&E.write(L.VSBuffer.fromByteArray([0,0,255,255])),E.flush(x=>N(x))})}}class t extends a.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(E,S,M,N){super(),this._tracer=E,this._recordInflateBytes=S,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,R.createInflateRaw)(N),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,O),this._pendingInflateData.push(L.VSBuffer.wrap(O))}),M&&(this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const S=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(S)})}}class i extends a.Disposable{constructor(E,S){super(),this._tracer=E,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,R.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,M),this._pendingDeflateData.push(L.VSBuffer.wrap(M))})}write(E){this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let S=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.byteLength-4),E(S)})}}function r(k,E){if(E===0)return;const S=k.byteLength>>>2;for(let F=0;F<S;F++){const H=k.readUInt32BE(F*4);k.writeUInt32BE(H^E,F*4)}const M=S*4,N=k.byteLength-M,O=E>>>24&255,x=E>>>16&255,U=E>>>8&255;N>=1&&k.writeUInt8(k.readUInt8(M)^O,M),N>=2&&k.writeUInt8(k.readUInt8(M+1)^x,M+1),N>=3&&k.writeUInt8(k.readUInt8(M+2)^U,M+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[_.Platform.Linux]:107,[_.Platform.Mac]:103};function u(){const k=(0,c.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const E=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,T.tmpdir)(),S=(0,I.join)(E,`vscode-ipc-${k}.sock`);return y(S),S}function v(k,E,S){const N=(0,s.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${S}-${E}-sock`;const O=S.substr(0,4),x=E.substr(0,6);let U;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${O}-${x}.sock`):U=(0,I.join)(k,`${O}-${x}.sock`),y(U),U}function y(k){const E=f[_.platform];typeof E=="number"&&k.length>=E&&console.warn(`WARNING: IPC handle "${k}" is longer than ${E} chars, try a shorter --user-data-dir`)}class D extends C.IPCServer{static toClientConnectionEvent(E){const S=p.Event.fromNodeEventEmitter(E,"connection");return p.Event.map(S,M=>({protocol:new b.Protocol(new m(M,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(M,"close"))}))}constructor(E){super(D.toClientConnectionEvent(E)),this.server=E}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=D;function w(k){return new Promise((E,S)=>{const M=(0,d.createServer)();M.on("error",S),M.listen(k,()=>{M.removeListener("error",S),E(new D(M))})})}function P(k,E){return new Promise((S,M)=>{const N=(0,d.createConnection)(k,()=>{N.removeListener("error",M),S(b.Client.fromSocket(new m(N,`ipc-client${E}`),E))});N.once("error",M)})}}),define(_e[406],ye([1,0,67,68,188,131,9,3,11,45,12,116,284,286,118,93,22]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,s=ze(s),d=ze(d);async function h(i,r,f,u,v){let y;for(let D=3;D&&(y?.dispose(),y=await new g(i,r,f,u,v).waitForReady(),!(v&&T.BROWSER_RESTRICTED_PORTS[v]||!T.BROWSER_RESTRICTED_PORTS[y.tunnelLocalPort]));D--);return y}class g extends A.Disposable{constructor(r,f,u,v,y){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=y,this.privacy=l.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=s.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=D=>this._onConnection(D),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=v,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,f=(0,l.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let u=await(0,T.findFreePortFaster)(r,2,1e3,f),v=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address(),v||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address()),this.tunnelLocalPort=v.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${v.port}`,this}async _onConnection(r){r.pause();const f=(0,l.isLocalhost)(this.tunnelRemoteHost)||(0,l.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,c.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),v=u.getSocket(),y=u.readEntireBuffer();u.dispose(),y.byteLength>0&&r.write(y.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),v.end()}),r.on("close",()=>v.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),v instanceof R.NodeSocket?v.socket.destroy():v.end()}),v instanceof R.NodeSocket?this._mirrorNodeSocket(r,v):this._mirrorGenericSocket(r,v),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),v.end()})}_mirrorGenericSocket(r,f){f.onClose(()=>r.destroy()),f.onEnd(()=>r.end()),f.onData(u=>r.write(u.buffer)),r.on("data",u=>f.write(m.VSBuffer.wrap(u))),r.resume()}_mirrorNodeSocket(r,f){const u=f.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.NodeRemoteTunnel=g;let n=class extends l.AbstractTunnelService{constructor(r,f,u,v,y){super(f,y),this.remoteSocketFactoryService=r,this.signService=u,this.productService=v}isPortPrivileged(r){return(0,l.isPortPrivileged)(r,this.defaultTunnelHost,p.OS,d.release())}retainOrCreateTunnel(r,f,u,v,y,D,w,P){const k=this.getTunnelFromMap(f,u);if(k)return++k.refcount,k.value;if((0,l.isTunnelProvider)(r))return this.createWithProvider(r,f,u,y,D,w,P);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${y}.`);const E={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},S=h(E,v,f,u,y);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,u,S),S}}};e.BaseTunnelService=n,e.BaseTunnelService=n=Xe([He(0,C.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,b.ISignService),He(3,_.IProductService),He(4,a.IConfigurationService)],n);let o=class extends n{constructor(r,f,u,v,y){super(r,f,u,v,y)}};e.TunnelService=o,e.TunnelService=o=Xe([He(0,C.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,b.ISignService),He(3,_.IProductService),He(4,a.IConfigurationService)],o);let t=class extends A.Disposable{constructor(r,f,u,v,y){super(),this.remoteSocketFactoryService=r,this.logService=f,this.productService=u,this.signService=v,this.configurationService=y,this._tunnelServices=new Map}async openTunnel(r,f,u,v,y,D,w,P,k){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${v} on local port ${D}.`),!this._tunnelServices.has(r)){const E=new o(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(E),this._tunnelServices.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(f,u,v,y,D,w,P,k)}};e.SharedTunnelsService=t,e.SharedTunnelsService=t=Xe([He(0,C.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,_.IProductService),He(3,b.ISignService),He(4,a.IConfigurationService)],t)}),define(_e[407],ye([1,0,131,303,61,35,2,12,46]),function(le,e,s,d,T,R,L,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0,d=ze(d),T=ze(T);class a{constructor(c,C,b){this._commands=c,this.logService=C,this._ipcHandlePath=b,this._server=d.createServer((l,m)=>this.onRequest(l,m)),this.setup().catch(l=>(C.error(l),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,C){const b=(m,h)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify(h||null),g=>g&&this.logService.error(g))},l=[];c.setEncoding("utf8"),c.on("data",m=>l.push(m)),c.on("end",async()=>{try{const m=JSON.parse(l.join(""));let h;switch(m.type){case"open":h=await this.open(m);break;case"openExternal":h=await this.openExternal(m);break;case"status":h=await this.getStatus(m);break;case"extensionManagement":h=await this.manageExtensions(m);break;default:b(404,`Unknown message type: ${m.type}`);break}b(200,h)}catch(m){const h=m instanceof Error?m.message:JSON.stringify(m);b(500,h),this.logService.error("Error while processing pipe request",m)}})}async open(c){const{fileURIs:C,folderURIs:b,forceNewWindow:l,diffMode:m,mergeMode:h,addMode:g,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:i}=c,r=[];if(Array.isArray(b))for(const y of b)try{r.push({folderUri:L.URI.parse(y)})}catch{}if(Array.isArray(C))for(const y of C)try{(0,p.hasWorkspaceFileExtension)(y)?r.push({workspaceUri:L.URI.parse(y)}):r.push({fileUri:L.URI.parse(y)})}catch{}const f=t?L.URI.file(t):void 0,v={forceNewWindow:l,diffMode:m,mergeMode:h,addMode:g,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!f&&!g,waitMarkerFileURI:f,remoteAuthority:i};this._commands.executeCommand("_remoteCLI.windowOpen",r,v)}async openExternal(c){for(const C of c.uris){const b=L.URI.parse(C),l=b.scheme==="file"?b:C;await this._commands.executeCommand("_remoteCLI.openExternal",l)}}async manageExtensions(c){const C=l=>l?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),b={list:c.list,install:C(c.install),uninstall:C(c.uninstall),force:c.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",b)}async getStatus(c){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=a;let I=class extends a{constructor(c,C){super(c,C,(0,s.createRandomIPCHandle)())}};e.CLIServer=I,e.CLIServer=I=Xe([He(0,R.IExtHostCommands),He(1,A.ILogService)],I)}),define(_e[408],ye([1,0,62,395,390,302,53,377,2,15,10,407,111,337,376]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0,s=ze(s);class l extends T.RequireInterceptor{_installInterceptor(){const g=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(f,u,v){return f=i(f),g._factories.has(f)?g._factories.get(f).load(f,p.URI.file((0,c.realpathSync)(u.filename)),y=>o.apply(this,[y,u,v])):o.apply(this,arguments)};const t=n._resolveLookupPaths;n._resolveLookupPaths=(r,f)=>t.call(this,i(r),f);const i=r=>{for(const f of g._alternatives){const u=f(r);if(u){r=u;break}}return r}}}class m extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(C.ExtHostConsoleForwarder);const g=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(A.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(_.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this._instaService.createInstance(b.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(l,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),s.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),s.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(g){return g.main}async _loadCommonJSModule(g,n,o){if(n.scheme!==a.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this._logService.flush();const i=g?.identifier.value;g&&await this._extHostLocalizationService.initializeLocalizedMessages(g);try{i&&s.mark(`code/extHost/willLoadExtensionCode/${i}`),t=le.__$__nodeRequire(n.fsPath)}finally{i&&s.mark(`code/extHost/didLoadExtensionCode/${i}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(g){if(this._initData.remote.isRemote)for(const n in g){const o=g[n];o===null?delete process.env[n]:process.env[n]=o}}}e.ExtHostExtensionService=m}),define(_e[409],ye([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,406,30,20,77,384]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=i,e.loadListeningPorts=r,e.parseIpAddress=f,e.loadConnectionTable=u,e.getRootProcesses=y,e.findPorts=D,e.tryFindRootPorts=w,p=ze(p),I=ze(I);function i(E){const S=E.trim().split(`
`),M=[];return S.forEach(O=>{const x=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);x&&x.length>=3&&M.push({pid:parseInt(x[1],10),socket:parseInt(x[2],10)})}),M.reduce((O,x)=>(O[x.socket]=x,O),{})}function r(...E){const S=[].concat(...E.map(u));return[...new Map(S.filter(M=>M.st==="0A").map(M=>{const N=M.local_address.split(":");return{socket:parseInt(M.inode,10),ip:f(N[0]),port:parseInt(N[1],16)}}).map(M=>[M.ip+":"+M.port,M])).values()]}function f(E){let S="";if(E.length===8)for(let M=E.length-2;M>=0;M-=2)S+=parseInt(E.substr(M,2),16),M!==0&&(S+=".");else for(let M=0;M<E.length;M+=8){const N=E.substring(M,M+8);let O="";for(let x=8;x>=2;x-=2)O+=N.substring(x-2,x),(x===6||x===2)&&(O=parseInt(O,16).toString(16),S+=`${O}`,O="",M+x!==E.length-6&&(S+=":"))}return S}function u(E){const S=E.trim().split(`
`),M=S.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return S.map(O=>O.trim().split(/\s+/).reduce((x,U,F)=>(x[M[F]||F]=U,x),{}))}function v(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function y(E){const S=E.trim().split(`
`),M=[];return S.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&M.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),M}async function D(E,S,M){const N=M.reduce((x,U)=>(x[U.pid]=U,x),{}),O=[];return E.forEach(({socket:x,ip:U,port:F})=>{const H=S[x]?S[x].pid:void 0,j=H?N[H]?.cmd:void 0;H&&j&&!v(j)&&O.push({host:U,port:F,detail:j,pid:H})}),O}function w(E,S,M){const N=new Map,O=y(S);for(const x of E){const U=M.get(x.port);if(U){N.set(x.port,U);continue}const F=O.find(H=>H.cmd.includes(`${x.port}`));if(F){let H=F,j;do j=O.find(re=>re.ppid===H.pid),j&&(H=j);while(j);N.set(x.port,{host:x.ip,port:x.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else N.set(x.port,{host:x.ip,port:x.port,ppid:Number.MAX_VALUE})}return N}let P=class extends o.ExtHostTunnelService{constructor(S,M,N,O){super(S,M,N),this.initData=M,this.signService=O,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,A.isLinux&&M.remote.isRemote&&M.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(S){if(S&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=S;let M;this._initialCandidates&&(M=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const N=new L.MovingAverage;let O=0;for(;this._candidateFindingEnabled;){const x=new Date().getTime(),U=(await this.findCandidatePorts()).filter(j=>(0,m.isLocalhost)(j.host)||(0,m.isAllInterfaces)(j.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(j=>j.port).join(", ")}`);const F=new Date().getTime()-x;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),O++>3&&N.update(F),(!M||JSON.stringify(M)!==JSON.stringify(U))&&(M=U,await this._proxy.$onFoundNewCandidates(M));const H=this.calculateDelay(N.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${H} ms.`),await new Promise(j=>setTimeout(()=>j(),H))}}calculateDelay(S){return Math.max(S*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(S=>S.port).join(", ")}`)}async findCandidatePorts(){let S="",M="";try{S=await I.Promises.readFile("/proc/net/tcp","utf8"),M=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=r(S,M),O=await new Promise(V=>{(0,s.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,ee,he)=>{V(ee)})}),x=i(O),U=await I.Promises.readdir("/proc"),F=[];for(const V of U)try{const X=Number(V),ee=p.joinPath(a.URI.file("/proc"),V);if((await I.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(X)){const ne=await I.Promises.readlink(p.joinPath(ee,"cwd").fsPath),De=await I.Promises.readFile(p.joinPath(ee,"cmdline").fsPath,"utf8");F.push({pid:X,cwd:ne,cmd:De})}}catch{}const H=[],j=N.filter(V=>{const X=x[V.socket];return X||H.push(V),X}),re=D(j,x,F);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const V=await new Promise(X=>{(0,s.exec)("ps -F -A -l | grep root",(ee,he,ne)=>{X(he)})});this._foundRootPorts=w(H,V,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(X=>X.port).join(", ")}`)}return re.then(V=>B?V.concat(B):V)}makeManagedTunnelFactory(S){return async M=>{const N=new h.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(x,U,F,H){const j=await S.makeConnection();return k.connect(j,U,F,H)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new b.ManagedRemoteConnection(0),connectionToken:S.connectionToken})}},signService:this.signService},"localhost",M.remoteAddress.host||"localhost",M.remoteAddress.port,M.localAddressPort);await N.waitForReady();const O=new T.Emitter;return{localAddress:(0,t.parseAddress)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.NodeExtHostTunnelService=P,e.NodeExtHostTunnelService=P=Xe([He(0,n.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,c.ILogService),He(3,l.ISignService)],P);class k extends C.ManagedSocket{static connect(S,M,N,O){const x=new R.DisposableStore,U={onClose:x.add(new T.Emitter),onData:x.add(new T.Emitter),onEnd:x.add(new T.Emitter)};x.add(S.onDidReceiveMessage(H=>U.onData.fire(d.VSBuffer.wrap(H)))),x.add(S.onDidEnd(()=>U.onEnd.fire())),x.add(S.onDidClose(H=>U.onClose.fire({type:_.SocketCloseEventType.NodeSocketCloseEvent,error:H,hadError:!!H})));const F=new k(S,O,U);return F._register(x),(0,C.connectManagedSocket)(F,M,N,O,U)}constructor(S,M,N){super(M,N),this.passing=S}write(S){this.passing.send(S.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(_e[410],ye([1,0,89,379,393,392,405,408,409,102,53,103,101,47,77,98,378,338,12,394,65,298,113,118,149]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h,g,n,o,t,i,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(I.IExtHostExtensionService,A.ExtHostExtensionService,s.InstantiationType.Eager),(0,s.registerSingleton)(g.ILoggerService,h.ExtHostLoggerService,s.InstantiationType.Delayed),(0,s.registerSingleton)(g.ILogService,new i.SyncDescriptor(t.ExtHostLogService,[!1],!0)),(0,s.registerSingleton)(r.ISignService,f.SignService,s.InstantiationType.Delayed),(0,s.registerSingleton)(l.IExtensionStoragePaths,m.ExtensionStoragePaths,s.InstantiationType.Eager),(0,s.registerSingleton)(a.IExtHostDebugService,R.ExtHostDebugService,s.InstantiationType.Eager),(0,s.registerSingleton)(_.IExtHostSearch,L.NativeExtHostSearch,s.InstantiationType.Eager),(0,s.registerSingleton)(c.IExtHostTask,T.ExtHostTask,s.InstantiationType.Eager),(0,s.registerSingleton)(C.IExtHostTerminalService,d.ExtHostTerminalService,s.InstantiationType.Eager),(0,s.registerSingleton)(b.IExtHostTunnelService,p.NodeExtHostTunnelService,s.InstantiationType.Eager),(0,s.registerSingleton)(o.IExtHostVariableResolverProvider,n.NodeExtHostVariableResolverProviderService,s.InstantiationType.Eager)});var xt=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(_e[420],ye([1,0,421,67,9,22,14,62,111,34,69,131,114,281,391,304,320,94,396,410]),function(le,e,s,d,T,R,L,A,p,a,I,_,c,C,b,l,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=xt(s),d=ze(d),A=ze(A),C=xt(C),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const g=(0,s.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,D=y._load;y._load=function(w){if(w==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function t(y){process.exit=function(D){if(y)n(D);else{const w=new Error("An extension called process.exit() and this was prevented.");console.warn(w.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,w){D==="uncaughtException"&&(w=function(){try{return w.call(void 0,arguments)}catch{}}),o(D,w)}}let i=function(y){n()};function r(){const y=(0,m.readExtHostConnection)(process.env);if(y.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,w)=>{const P=k=>{const E=k[0],S=new I.BufferedEmitter;E.on("message",M=>S.fire(R.VSBuffer.wrap(M.data))),E.on("close",()=>{i("renderer closed the MessagePort")}),E.start(),D({onMessage:S.event,send:M=>E.postMessage(M.buffer)})};process.parentPort.on("message",k=>P(k.ports))});if(y.type===m.ExtHostConnectionType.Socket)return new Promise((D,w)=>{let P=null;const k=setTimeout(()=>{i("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=I.ProtocolConstants.ReconnectionGraceTime,S=I.ProtocolConstants.ReconnectionShortGraceTime,M=new T.ProcessTimeRunOnceScheduler(()=>i("renderer disconnected for too long (1)"),E),N=new T.ProcessTimeRunOnceScheduler(()=>i("renderer disconnected for too long (2)"),S);process.on("message",(x,U)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const F=R.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let H;if(x.skipWebSocketFrames)H=new _.NodeSocket(U,"extHost-socket");else{const j=R.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));H=new _.WebSocketNodeSocket(new _.NodeSocket(U,"extHost-socket"),x.permessageDeflate,j,!1)}P?(M.cancel(),N.cancel(),P.beginAcceptReconnection(H,F),P.endAcceptReconnection(),P.sendResume()):(clearTimeout(k),P=new I.PersistentProtocol({socket:H,initialChunk:F}),P.sendResume(),P.onDidDispose(()=>i("renderer disconnected")),D(P),P.onSocketClose(()=>{M.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;M.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const D=y.pipeName;return new Promise((w,P)=>{const k=d.createConnection(D,()=>{k.removeListener("error",P);const E=new I.PersistentProtocol({socket:new _.NodeSocket(k,"extHost-renderer")});E.sendResume(),w(E)});k.once("error",P),k.on("close",()=>{i("renderer closed the socket")})})}}async function f(){const y=await r();return new class{constructor(){this._onMessage=new I.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,this._protocolListener=y.onMessage(D=>{(0,h.isMessageOfType)(D,h.MessageType.Terminate)?(this._terminating=!0,this._protocolListener.dispose(),i("received terminate message from renderer")):this._onMessage.fire(D)})}send(D){this._terminating||y.send(D)}async drain(){if(y.drain)return y.drain()}}}function u(y){return new Promise(D=>{const w=y.onMessage(P=>{w.dispose();const k=JSON.parse(P.toString()),E=k.commit,S=C.default.commit;if(E&&S&&E!==S&&n(h.ExtensionHostExitCode.VersionMismatch),k.parentPid){let M=0;setInterval(function(){try{process.kill(k.parentPid,0),M=0}catch(O){O&&O.code==="EPERM"?(M++,M>=3&&i(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):i(`parent process ${k.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(k.parentPid)}catch(O){(0,L.onUnexpectedError)(O)}}y.send((0,h.createMessageOfType)(h.MessageType.Initialized)),D({protocol:y,initData:k})});y.send((0,h.createMessageOfType)(h.MessageType.Ready))})}async function v(){const y=[];process.on("unhandledRejection",(M,N)=>{y.push(N),setTimeout(()=>{const O=y.indexOf(N);O>=0&&N.catch(x=>{y.splice(O,1),(0,L.isCancellationError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),M&&(0,L.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const N=y.indexOf(M);N>=0&&y.splice(N,1)}),process.on("uncaughtException",function(M){(0,L.isSigPipeError)(M)||(0,L.onUnexpectedError)(M)}),A.mark("code/extHost/willConnectToRenderer");const D=await f();A.mark("code/extHost/didConnectToRenderer");const w=await u(D);A.mark("code/extHost/didWaitForInitData");const{initData:P}=w;t(!!P.environment.extensionTestsLocationURI),P.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,P.environment.skipWorkspaceStorageLock=(0,c.boolean)(g.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return a.Promises.exists(N)}fsRealpath(N){return(0,p.realpath)(N)}};let E=null;P.remote.authority&&g.transformURIs&&(E=(0,l.createURITransformer)(P.remote.authority));const S=new b.ExtensionHostMain(w.protocol,P,k,E);i=M=>S.terminate(M)}v().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/workbench/api/node/extensionHostProcess.js.map
