/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(ae){for(var e=[],S=0,T=ae.length;S<T;S++)e[S]=Te[ae[S]];return e};define(Te[72],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=T,e.debounce=I,e.throttle=O;function S(A){return(R,v,a)=>{let k=null,w=null;if(typeof a.value=="function"?(k="value",w=a.value):typeof a.get=="function"&&(k="get",w=a.get),!w)throw new Error("not supported");a[k]=A(w,v)}}function T(A,R,v){let a=null,k=null;if(typeof v.value=="function"?(a="value",k=v.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(a="get",k=v.get),!k)throw new Error("not supported");const w=`$memoize$${R}`;v[a]=function(...c){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,c)}),this[w]}}function I(A,R,v){return S((a,k)=>{const w=`$debounce$${k}`,c=`$debounce$result$${k}`;return function(..._){this[c]||(this[c]=v?v():void 0),clearTimeout(this[w]),R&&(this[c]=R(this[c],..._),_=[this[c]]),this[w]=setTimeout(()=>{a.apply(this,_),this[c]=v?v():void 0},A)}})}function O(A,R,v){return S((a,k)=>{const w=`$throttle$timer$${k}`,c=`$throttle$result$${k}`,_=`$throttle$lastRun$${k}`,h=`$throttle$pending$${k}`;return function(...n){if(this[c]||(this[c]=v?v():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),R&&(this[c]=R(this[c],...n)),this[h])return;const s=this[_]+A;s<=Date.now()?(this[_]=Date.now(),a.apply(this,[this[c]]),this[c]=v?v():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[_]=Date.now(),a.apply(this,[this[c]]),this[c]=v?v():void 0},s-Date.now()))}})}});var zn=this&&this.__createBinding||(Object.create?function(ae,e,S,T){T===void 0&&(T=S);var I=Object.getOwnPropertyDescriptor(e,S);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(ae,T,I)}:function(ae,e,S,T){T===void 0&&(T=S),ae[T]=e[S]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),$e=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var S in ae)S!=="default"&&Object.prototype.hasOwnProperty.call(ae,S)&&zn(e,ae,S);return Wn(e,ae),e};define(Te[135],Pe([1,0,18]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=I,e.jsonStringifyEquals=O,e.itemEquals=A,e.equalsIfDefined=R,e.structuralEquals=v,e.getStructuralKey=a,S=$e(S);const T=(_,h)=>_===h;e.strictEquals=T;function I(_=e.strictEquals){return(h,n)=>S.equals(h,n,_)}function O(){return(_,h)=>JSON.stringify(_)===JSON.stringify(h)}function A(){return(_,h)=>_.equals(h)}function R(_,h,n){if(n!==void 0){const s=_;return s==null||h===void 0||h===null?h===s:n(s,h)}else{const s=_;return(o,d)=>o==null||d===void 0||d===null?d===o:s(o,d)}}function v(_,h){if(_===h)return!0;if(Array.isArray(_)&&Array.isArray(h)){if(_.length!==h.length)return!1;for(let n=0;n<_.length;n++)if(!v(_[n],h[n]))return!1;return!0}if(_&&typeof _=="object"&&h&&typeof h=="object"&&Object.getPrototypeOf(_)===Object.prototype&&Object.getPrototypeOf(h)===Object.prototype){const n=_,s=h,o=Object.keys(n),d=Object.keys(s),i=new Set(d);if(o.length!==d.length)return!1;for(const r of o)if(!i.has(r)||!v(n[r],s[r]))return!1;return!0}return!1}function a(_){return JSON.stringify(c(_))}let k=0;const w=new WeakMap;function c(_){if(Array.isArray(_))return _.map(c);if(_&&typeof _=="object")if(Object.getPrototypeOf(_)===Object.prototype){const h=_,n=Object.create(null);for(const s of Object.keys(h).sort())n[s]=c(h[s]);return n}else{let h=w.get(_);return h===void 0&&(h=k++,w.set(_,h)),h+"----2b76a038c20c4bcc"}return _}}),define(Te[97],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(Te[136],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=w,e.parse=c,e.parseTree=_,e.findNodeAtLocation=h,e.getNodePath=n,e.getNodeValue=s,e.contains=o,e.findNodeAtOffset=d,e.visit=i,e.getNodeType=r;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,l=!1){let u=0;const g=t.length;let m="",p=0,y=T.Unknown,C=S.None;function b(M){let V=0,W=0;for(;V<M;){const N=t.charCodeAt(u);if(N>=k._0&&N<=k._9)W=W*16+N-k._0;else if(N>=k.A&&N<=k.F)W=W*16+N-k.A+10;else if(N>=k.a&&N<=k.f)W=W*16+N-k.a+10;else break;u++,V++}return V<M&&(W=-1),W}function D(M){u=M,m="",p=0,y=T.Unknown,C=S.None}function P(){const M=u;if(t.charCodeAt(u)===k._0)u++;else for(u++;u<t.length&&a(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===k.dot)if(u++,u<t.length&&a(t.charCodeAt(u)))for(u++;u<t.length&&a(t.charCodeAt(u));)u++;else return C=S.UnexpectedEndOfNumber,t.substring(M,u);let V=u;if(u<t.length&&(t.charCodeAt(u)===k.E||t.charCodeAt(u)===k.e))if(u++,(u<t.length&&t.charCodeAt(u)===k.plus||t.charCodeAt(u)===k.minus)&&u++,u<t.length&&a(t.charCodeAt(u))){for(u++;u<t.length&&a(t.charCodeAt(u));)u++;V=u}else C=S.UnexpectedEndOfNumber;return t.substring(M,V)}function f(){let M="",V=u;for(;;){if(u>=g){M+=t.substring(V,u),C=S.UnexpectedEndOfString;break}const W=t.charCodeAt(u);if(W===k.doubleQuote){M+=t.substring(V,u),u++;break}if(W===k.backslash){if(M+=t.substring(V,u),u++,u>=g){C=S.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case k.doubleQuote:M+='"';break;case k.backslash:M+="\\";break;case k.slash:M+="/";break;case k.b:M+="\b";break;case k.f:M+="\f";break;case k.n:M+=`
`;break;case k.r:M+="\r";break;case k.t:M+="	";break;case k.u:{const Q=b(4);Q>=0?M+=String.fromCharCode(Q):C=S.InvalidUnicode;break}default:C=S.InvalidEscapeCharacter}V=u;continue}if(W>=0&&W<=31)if(v(W)){M+=t.substring(V,u),C=S.UnexpectedEndOfString;break}else C=S.InvalidCharacter;u++}return M}function E(){if(m="",C=S.None,p=u,u>=g)return p=g,y=T.EOF;let M=t.charCodeAt(u);if(R(M)){do u++,m+=String.fromCharCode(M),M=t.charCodeAt(u);while(R(M));return y=T.Trivia}if(v(M))return u++,m+=String.fromCharCode(M),M===k.carriageReturn&&t.charCodeAt(u)===k.lineFeed&&(u++,m+=`
`),y=T.LineBreakTrivia;switch(M){case k.openBrace:return u++,y=T.OpenBraceToken;case k.closeBrace:return u++,y=T.CloseBraceToken;case k.openBracket:return u++,y=T.OpenBracketToken;case k.closeBracket:return u++,y=T.CloseBracketToken;case k.colon:return u++,y=T.ColonToken;case k.comma:return u++,y=T.CommaToken;case k.doubleQuote:return u++,m=f(),y=T.StringLiteral;case k.slash:{const V=u-1;if(t.charCodeAt(u+1)===k.slash){for(u+=2;u<g&&!v(t.charCodeAt(u));)u++;return m=t.substring(V,u),y=T.LineCommentTrivia}if(t.charCodeAt(u+1)===k.asterisk){u+=2;const W=g-1;let N=!1;for(;u<W;){if(t.charCodeAt(u)===k.asterisk&&t.charCodeAt(u+1)===k.slash){u+=2,N=!0;break}u++}return N||(u++,C=S.UnexpectedEndOfComment),m=t.substring(V,u),y=T.BlockCommentTrivia}return m+=String.fromCharCode(M),u++,y=T.Unknown}case k.minus:if(m+=String.fromCharCode(M),u++,u===g||!a(t.charCodeAt(u)))return y=T.Unknown;case k._0:case k._1:case k._2:case k._3:case k._4:case k._5:case k._6:case k._7:case k._8:case k._9:return m+=P(),y=T.NumericLiteral;default:for(;u<g&&F(M);)u++,M=t.charCodeAt(u);if(p!==u){switch(m=t.substring(p,u),m){case"true":return y=T.TrueKeyword;case"false":return y=T.FalseKeyword;case"null":return y=T.NullKeyword}return y=T.Unknown}return m+=String.fromCharCode(M),u++,y=T.Unknown}}function F(M){if(R(M)||v(M))return!1;switch(M){case k.closeBrace:case k.closeBracket:case k.openBrace:case k.openBracket:case k.doubleQuote:case k.colon:case k.comma:case k.slash:return!1}return!0}function L(){let M;do M=E();while(M>=T.LineCommentTrivia&&M<=T.Trivia);return M}return{setPosition:D,getPosition:()=>u,scan:l?L:E,getToken:()=>y,getTokenValue:()=>m,getTokenOffset:()=>p,getTokenLength:()=>u-p,getTokenError:()=>C}}function R(t){return t===k.space||t===k.tab||t===k.verticalTab||t===k.formFeed||t===k.nonBreakingSpace||t===k.ogham||t>=k.enQuad&&t<=k.zeroWidthSpace||t===k.narrowNoBreakSpace||t===k.mathematicalSpace||t===k.ideographicSpace||t===k.byteOrderMark}function v(t){return t===k.lineFeed||t===k.carriageReturn||t===k.lineSeparator||t===k.paragraphSeparator}function a(t){return t>=k._0&&t<=k._9}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function w(t,l){const u=[],g=new Object;let m;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function C(b,D,P,f){p.value=b,p.offset=D,p.length=P,p.type=f,p.colonOffset=void 0,m=p}try{i(t,{onObjectBegin:(b,D)=>{if(l<=b)throw g;m=void 0,y=l>b,u.push("")},onObjectProperty:(b,D,P)=>{if(l<D||(C(b,D,P,"property"),u[u.length-1]=b,l<=D+P))throw g},onObjectEnd:(b,D)=>{if(l<=b)throw g;m=void 0,u.pop()},onArrayBegin:(b,D)=>{if(l<=b)throw g;m=void 0,u.push(0)},onArrayEnd:(b,D)=>{if(l<=b)throw g;m=void 0,u.pop()},onLiteralValue:(b,D,P)=>{if(l<D||(C(b,D,P,r(b)),l<=D+P))throw g},onSeparator:(b,D,P)=>{if(l<=D)throw g;if(b===":"&&m&&m.type==="property")m.colonOffset=D,y=!1,m=void 0;else if(b===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(y=!0,u[u.length-1]=""),m=void 0}}})}catch(b){if(b!==g)throw b}return{path:u,previousNode:m,isAtPropertyKey:y,matches:b=>{let D=0;for(let P=0;D<b.length&&P<u.length;P++)if(b[D]===u[P]||b[D]==="*")D++;else if(b[D]!=="**")return!1;return D===b.length}}}function c(t,l=[],u=O.DEFAULT){let g=null,m=[];const p=[];function y(b){Array.isArray(m)?m.push(b):g!==null&&(m[g]=b)}return i(t,{onObjectBegin:()=>{const b={};y(b),p.push(m),m=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{m=p.pop()},onArrayBegin:()=>{const b=[];y(b),p.push(m),m=b,g=null},onArrayEnd:()=>{m=p.pop()},onLiteralValue:y,onError:(b,D,P)=>{l.push({error:b,offset:D,length:P})}},u),m[0]}function _(t,l=[],u=O.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(b){g.type==="property"&&(g.length=b-g.offset,g=g.parent)}function p(b){return g.children.push(b),b}i(t,{onObjectBegin:b=>{g=p({type:"object",offset:b,length:-1,parent:g,children:[]})},onObjectProperty:(b,D,P)=>{g=p({type:"property",offset:D,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:b,offset:D,length:P,parent:g})},onObjectEnd:(b,D)=>{g.length=b+D-g.offset,g=g.parent,m(b+D)},onArrayBegin:(b,D)=>{g=p({type:"array",offset:b,length:-1,parent:g,children:[]})},onArrayEnd:(b,D)=>{g.length=b+D-g.offset,g=g.parent,m(b+D)},onLiteralValue:(b,D,P)=>{p({type:r(b),offset:D,length:P,parent:g,value:b}),m(D+P)},onSeparator:(b,D,P)=>{g.type==="property"&&(b===":"?g.colonOffset=D:b===","&&m(D))},onError:(b,D,P)=>{l.push({error:b,offset:D,length:P})}},u);const C=g.children[0];return C&&delete C.parent,C}function h(t,l){if(!t)return;let u=t;for(const g of l)if(typeof g=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const p of u.children)if(Array.isArray(p.children)&&p.children[0].value===g){u=p.children[1],m=!0;break}if(!m)return}else{const m=g;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function n(t){if(!t.parent||!t.parent.children)return[];const l=n(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;l.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&l.push(u)}return l}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const l=Object.create(null);for(const u of t.children){const g=u.children[1];g&&(l[u.children[0].value]=s(g))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,l,u=!1){return l>=t.offset&&l<t.offset+t.length||u&&l===t.offset+t.length}function d(t,l,u=!1){if(o(t,l,u)){const g=t.children;if(Array.isArray(g))for(let m=0;m<g.length&&g[m].offset<=l;m++){const p=d(g[m],l,u);if(p)return p}return t}}function i(t,l,u=O.DEFAULT){const g=A(t,!1);function m(le){return le?()=>le(g.getTokenOffset(),g.getTokenLength()):()=>!0}function p(le){return le?Ee=>le(Ee,g.getTokenOffset(),g.getTokenLength()):()=>!0}const y=m(l.onObjectBegin),C=p(l.onObjectProperty),b=m(l.onObjectEnd),D=m(l.onArrayBegin),P=m(l.onArrayEnd),f=p(l.onLiteralValue),E=p(l.onSeparator),F=m(l.onComment),L=p(l.onError),M=u&&u.disallowComments,V=u&&u.allowTrailingComma;function W(){for(;;){const le=g.scan();switch(g.getTokenError()){case S.InvalidUnicode:N(I.InvalidUnicode);break;case S.InvalidEscapeCharacter:N(I.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:N(I.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:M||N(I.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:N(I.UnexpectedEndOfString);break;case S.InvalidCharacter:N(I.InvalidCharacter);break}switch(le){case T.LineCommentTrivia:case T.BlockCommentTrivia:M?N(I.InvalidCommentToken):F();break;case T.Unknown:N(I.InvalidSymbol);break;case T.Trivia:case T.LineBreakTrivia:break;default:return le}}}function N(le,Ee=[],oe=[]){if(L(le),Ee.length+oe.length>0){let Ie=g.getToken();for(;Ie!==T.EOF;){if(Ee.indexOf(Ie)!==-1){W();break}else if(oe.indexOf(Ie)!==-1)break;Ie=W()}}}function Q(le){const Ee=g.getTokenValue();return le?f(Ee):C(Ee),W(),!0}function Y(){switch(g.getToken()){case T.NumericLiteral:{let le=0;try{le=JSON.parse(g.getTokenValue()),typeof le!="number"&&(N(I.InvalidNumberFormat),le=0)}catch{N(I.InvalidNumberFormat)}f(le);break}case T.NullKeyword:f(null);break;case T.TrueKeyword:f(!0);break;case T.FalseKeyword:f(!1);break;default:return!1}return W(),!0}function ge(){return g.getToken()!==T.StringLiteral?(N(I.PropertyNameExpected,[],[T.CloseBraceToken,T.CommaToken]),!1):(Q(!1),g.getToken()===T.ColonToken?(E(":"),W(),se()||N(I.ValueExpected,[],[T.CloseBraceToken,T.CommaToken])):N(I.ColonExpected,[],[T.CloseBraceToken,T.CommaToken]),!0)}function Z(){y(),W();let le=!1;for(;g.getToken()!==T.CloseBraceToken&&g.getToken()!==T.EOF;){if(g.getToken()===T.CommaToken){if(le||N(I.ValueExpected,[],[]),E(","),W(),g.getToken()===T.CloseBraceToken&&V)break}else le&&N(I.CommaExpected,[],[]);ge()||N(I.ValueExpected,[],[T.CloseBraceToken,T.CommaToken]),le=!0}return b(),g.getToken()!==T.CloseBraceToken?N(I.CloseBraceExpected,[T.CloseBraceToken],[]):W(),!0}function me(){D(),W();let le=!1;for(;g.getToken()!==T.CloseBracketToken&&g.getToken()!==T.EOF;){if(g.getToken()===T.CommaToken){if(le||N(I.ValueExpected,[],[]),E(","),W(),g.getToken()===T.CloseBracketToken&&V)break}else le&&N(I.CommaExpected,[],[]);se()||N(I.ValueExpected,[],[T.CloseBracketToken,T.CommaToken]),le=!0}return P(),g.getToken()!==T.CloseBracketToken?N(I.CloseBracketExpected,[T.CloseBracketToken],[]):W(),!0}function se(){switch(g.getToken()){case T.OpenBracketToken:return me();case T.OpenBraceToken:return Z();case T.StringLiteral:return Q(!0);default:return Y()}}return W(),g.getToken()===T.EOF?u.allowEmptyContent?!0:(N(I.ValueExpected,[],[]),!1):se()?(g.getToken()!==T.EOF&&N(I.EndOfFileExpected,[],[]),!0):(N(I.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ae,e){typeof define=="function"&&define.amd?define(Te[137],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(ce,be){for(var he=0;he<be.length;he++){var G=be[he];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ce,G.key,G)}}function S(ce,be,he){return be&&e(ce.prototype,be),he&&e(ce,he),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function T(ce,be){if(ce){if(typeof ce=="string")return I(ce,be);var he=Object.prototype.toString.call(ce).slice(8,-1);if(he==="Object"&&ce.constructor&&(he=ce.constructor.name),he==="Map"||he==="Set")return Array.from(ce);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(ce,be)}}function I(ce,be){(be==null||be>ce.length)&&(be=ce.length);for(var he=0,G=new Array(be);he<be;he++)G[he]=ce[he];return G}function O(ce,be){var he=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(he)return(he=he.call(ce)).next.bind(he);if(Array.isArray(ce)||(he=T(ce))||be&&ce&&typeof ce.length=="number"){he&&(ce=he);var G=0;return function(){return G>=ce.length?{done:!0}:{done:!1,value:ce[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=A();function R(ce){ae.defaults=ce}var v=/[&<>"']/,a=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(be){return c[be]};function h(ce,be){if(be){if(v.test(ce))return ce.replace(a,_)}else if(k.test(ce))return ce.replace(w,_);return ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ce){return ce.replace(n,function(be,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var o=/(^|[^\[])\^/g;function d(ce,be){ce=typeof ce=="string"?ce:ce.source,be=be||"";var he={replace:function(J,pe){return pe=pe.source||pe,pe=pe.replace(o,"$1"),ce=ce.replace(J,pe),he},getRegex:function(){return new RegExp(ce,be)}};return he}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ce,be,he){if(ce){var G;try{G=decodeURIComponent(s(he)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}be&&!r.test(he)&&(he=p(be,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var l={},u=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(ce,be){l[" "+ce]||(u.test(ce)?l[" "+ce]=ce+"/":l[" "+ce]=D(ce,"/",!0)),ce=l[" "+ce];var he=ce.indexOf(":")===-1;return be.substring(0,2)==="//"?he?be:ce.replace(g,"$1")+be:be.charAt(0)==="/"?he?be:ce.replace(m,"$1")+be:ce+be}var y={exec:function(){}};function C(ce){for(var be=1,he,G;be<arguments.length;be++){he=arguments[be];for(G in he)Object.prototype.hasOwnProperty.call(he,G)&&(ce[G]=he[G])}return ce}function b(ce,be){var he=ce.replace(/\|/g,function(pe,ve,Oe){for(var Ue=!1,De=ve;--De>=0&&Oe[De]==="\\";)Ue=!Ue;return Ue?"|":" |"}),G=he.split(/ \|/),J=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>be)G.splice(be);else for(;G.length<be;)G.push("");for(;J<G.length;J++)G[J]=G[J].trim().replace(/\\\|/g,"|");return G}function D(ce,be,he){var G=ce.length;if(G===0)return"";for(var J=0;J<G;){var pe=ce.charAt(G-J-1);if(pe===be&&!he)J++;else if(pe!==be&&he)J++;else break}return ce.slice(0,G-J)}function P(ce,be){if(ce.indexOf(be[1])===-1)return-1;for(var he=ce.length,G=0,J=0;J<he;J++)if(ce[J]==="\\")J++;else if(ce[J]===be[0])G++;else if(ce[J]===be[1]&&(G--,G<0))return J;return-1}function f(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function E(ce,be){if(be<1)return"";for(var he="";be>1;)be&1&&(he+=ce),be>>=1,ce+=ce;return he+ce}function F(ce,be,he,G){var J=be.href,pe=be.title?h(be.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){G.state.inLink=!0;var Oe={type:"link",raw:he,href:J,title:pe,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Oe}return{type:"image",raw:he,href:J,title:pe,text:h(ve)}}function L(ce,be){var he=ce.match(/^(\s+)(?:```)/);if(he===null)return be;var G=he[1];return be.split(`
`).map(function(J){var pe=J.match(/^\s+/);if(pe===null)return J;var ve=pe[0];return ve.length>=G.length?J.slice(G.length):J}).join(`
`)}var M=function(){function ce(he){this.options=he||ae.defaults}var be=ce.prototype;return be.space=function(G){var J=this.rules.block.newline.exec(G);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},be.code=function(G){var J=this.rules.block.code.exec(G);if(J){var pe=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:D(pe,`
`)}}},be.fences=function(G){var J=this.rules.block.fences.exec(G);if(J){var pe=J[0],ve=L(pe,J[3]||"");return{type:"code",raw:pe,lang:J[2]?J[2].trim():J[2],text:ve}}},be.heading=function(G){var J=this.rules.block.heading.exec(G);if(J){var pe=J[2].trim();if(/#$/.test(pe)){var ve=D(pe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(pe=ve.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:pe,tokens:this.lexer.inline(pe)}}},be.hr=function(G){var J=this.rules.block.hr.exec(G);if(J)return{type:"hr",raw:J[0]}},be.blockquote=function(G){var J=this.rules.block.blockquote.exec(G);if(J){var pe=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},be.list=function(G){var J=this.rules.block.list.exec(G);if(J){var pe,ve,Oe,Ue,De,Ae,Le,B,x,H,j,ne,fe=J[1].trim(),ke=fe.length>1,xe={type:"list",raw:"",ordered:ke,start:ke?+fe.slice(0,-1):"",loose:!1,items:[]};fe=ke?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=ke?fe:"[*+-]");for(var qe=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(ne=!1,!(!(J=qe.exec(G))||this.rules.block.hr.test(G)));){if(pe=J[0],G=G.substring(pe.length),B=J[2].split(`
`,1)[0],x=G.split(`
`,1)[0],this.options.pedantic?(Ue=2,j=B.trimLeft()):(Ue=J[2].search(/[^ ]/),Ue=Ue>4?1:Ue,j=B.slice(Ue),Ue+=J[1].length),Ae=!1,!B&&/^ *$/.test(x)&&(pe+=x+`
`,G=G.substring(x.length+1),ne=!0),!ne)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");G&&(H=G.split(`
`,1)[0],B=H,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(B)||et.test(B)||Ze.test(B)||tt.test(G)));){if(B.search(/[^ ]/)>=Ue||!B.trim())j+=`
`+B.slice(Ue);else if(!Ae)j+=`
`+B;else break;!Ae&&!B.trim()&&(Ae=!0),pe+=H+`
`,G=G.substring(H.length+1)}xe.loose||(Le?xe.loose=!0:/\n *\n *$/.test(pe)&&(Le=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(j),ve&&(Oe=ve[0]!=="[ ] ",j=j.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:pe,task:!!ve,checked:Oe,loose:!1,text:j}),xe.raw+=pe}xe.items[xe.items.length-1].raw=pe.trimRight(),xe.items[xe.items.length-1].text=j.trimRight(),xe.raw=xe.raw.trimRight();var rt=xe.items.length;for(De=0;De<rt;De++){this.lexer.state.top=!1,xe.items[De].tokens=this.lexer.blockTokens(xe.items[De].text,[]);var ft=xe.items[De].tokens.filter(function(st){return st.type==="space"}),lt=ft.every(function(st){for(var ct=st.raw.split(""),gt=0,pt=O(ct),ze;!(ze=pt()).done;){var Be=ze.value;if(Be===`
`&&(gt+=1),gt>1)return!0}return!1});!xe.loose&&ft.length&&lt&&(xe.loose=!0,xe.items[De].loose=!0)}return xe}},be.html=function(G){var J=this.rules.block.html.exec(G);if(J){var pe={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]);pe.type="paragraph",pe.text=ve,pe.tokens=this.lexer.inline(ve)}return pe}},be.def=function(G){var J=this.rules.block.def.exec(G);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var pe=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:J[0],href:J[2],title:J[3]}}},be.table=function(G){var J=this.rules.block.table.exec(G);if(J){var pe={type:"table",header:b(J[1]).map(function(Le){return{text:Le}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=J[0];var ve=pe.align.length,Oe,Ue,De,Ae;for(Oe=0;Oe<ve;Oe++)/^ *-+: *$/.test(pe.align[Oe])?pe.align[Oe]="right":/^ *:-+: *$/.test(pe.align[Oe])?pe.align[Oe]="center":/^ *:-+ *$/.test(pe.align[Oe])?pe.align[Oe]="left":pe.align[Oe]=null;for(ve=pe.rows.length,Oe=0;Oe<ve;Oe++)pe.rows[Oe]=b(pe.rows[Oe],pe.header.length).map(function(Le){return{text:Le}});for(ve=pe.header.length,Ue=0;Ue<ve;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for(ve=pe.rows.length,Ue=0;Ue<ve;Ue++)for(Ae=pe.rows[Ue],De=0;De<Ae.length;De++)Ae[De].tokens=this.lexer.inline(Ae[De].text);return pe}}},be.lheading=function(G){var J=this.rules.block.lheading.exec(G);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},be.paragraph=function(G){var J=this.rules.block.paragraph.exec(G);if(J){var pe=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:pe,tokens:this.lexer.inline(pe)}}},be.text=function(G){var J=this.rules.block.text.exec(G);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},be.escape=function(G){var J=this.rules.inline.escape.exec(G);if(J)return{type:"escape",raw:J[0],text:h(J[1])}},be.tag=function(G){var J=this.rules.inline.tag.exec(G);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]):J[0]}},be.link=function(G){var J=this.rules.inline.link.exec(G);if(J){var pe=J[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var ve=D(pe.slice(0,-1),"\\");if((pe.length-ve.length)%2===0)return}else{var Oe=P(J[2],"()");if(Oe>-1){var Ue=J[0].indexOf("!")===0?5:4,De=Ue+J[1].length+Oe;J[2]=J[2].substring(0,Oe),J[0]=J[0].substring(0,De).trim(),J[3]=""}}var Ae=J[2],Le="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);B&&(Ae=B[1],Le=B[3])}else Le=J[3]?J[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),F(J,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},be.reflink=function(G,J){var pe;if((pe=this.rules.inline.reflink.exec(G))||(pe=this.rules.inline.nolink.exec(G))){var ve=(pe[2]||pe[1]).replace(/\s+/g," ");if(ve=J[ve.toLowerCase()],!ve||!ve.href){var Oe=pe[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return F(pe,ve,pe[0],this.lexer)}},be.emStrong=function(G,J,pe){pe===void 0&&(pe="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ve[1]||ve[2]||"";if(!Oe||Oe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=ve[0].length-1,De,Ae,Le=Ue,B=0,x=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(x.lastIndex=0,J=J.slice(-1*G.length+Ue);(ve=x.exec(J))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(Ae=De.length,ve[3]||ve[4]){Le+=Ae;continue}else if((ve[5]||ve[6])&&Ue%3&&!((Ue+Ae)%3)){B+=Ae;continue}if(Le-=Ae,!(Le>0)){if(Ae=Math.min(Ae,Ae+Le+B),Math.min(Ue,Ae)%2){var H=G.slice(1,Ue+ve.index+Ae);return{type:"em",raw:G.slice(0,Ue+ve.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}var j=G.slice(2,Ue+ve.index+Ae-1);return{type:"strong",raw:G.slice(0,Ue+ve.index+Ae+1),text:j,tokens:this.lexer.inlineTokens(j)}}}}}},be.codespan=function(G){var J=this.rules.inline.code.exec(G);if(J){var pe=J[2].replace(/\n/g," "),ve=/[^ ]/.test(pe),Oe=/^ /.test(pe)&&/ $/.test(pe);return ve&&Oe&&(pe=pe.substring(1,pe.length-1)),pe=h(pe,!0),{type:"codespan",raw:J[0],text:pe}}},be.br=function(G){var J=this.rules.inline.br.exec(G);if(J)return{type:"br",raw:J[0]}},be.del=function(G){var J=this.rules.inline.del.exec(G);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},be.autolink=function(G,J){var pe=this.rules.inline.autolink.exec(G);if(pe){var ve,Oe;return pe[2]==="@"?(ve=h(this.options.mangle?J(pe[1]):pe[1]),Oe="mailto:"+ve):(ve=h(pe[1]),Oe=ve),{type:"link",raw:pe[0],text:ve,href:Oe,tokens:[{type:"text",raw:ve,text:ve}]}}},be.url=function(G,J){var pe;if(pe=this.rules.inline.url.exec(G)){var ve,Oe;if(pe[2]==="@")ve=h(this.options.mangle?J(pe[0]):pe[0]),Oe="mailto:"+ve;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);ve=h(pe[0]),pe[1]==="www."?Oe="http://"+ve:Oe=ve}return{type:"link",raw:pe[0],text:ve,href:Oe,tokens:[{type:"text",raw:ve,text:ve}]}}},be.inlineText=function(G,J){var pe=this.rules.inline.text.exec(G);if(pe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):h(pe[0]):pe[0]:ve=h(this.options.smartypants?J(pe[0]):pe[0]),{type:"text",raw:pe[0],text:ve}}},ce}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=d(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=d(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=d(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=d(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=d(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=d(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=C({},V),V.gfm=C({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=d(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=d(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=C({},V.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:d(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=d(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=d(V._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=d(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=d(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=d(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=d(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=d(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=d(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=d(W.reflink).replace("label",W._label).replace("ref",V._label).getRegex(),W.nolink=d(W.nolink).replace("ref",V._label).getRegex(),W.reflinkSearch=d(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=C({},W),W.pedantic=C({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=C({},W.normal,{escape:d(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=d(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=C({},W.gfm,{br:d(W.br).replace("{2,}","*").getRegex(),text:d(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(ce){var be="",he,G,J=ce.length;for(he=0;he<J;he++)G=ce.charCodeAt(he),Math.random()>.5&&(G="x"+G.toString(16)),be+="&#"+G+";";return be}var Y=function(){function ce(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ae.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:V.normal,inline:W.normal};this.options.pedantic?(G.block=V.pedantic,G.inline=W.pedantic):this.options.gfm&&(G.block=V.gfm,this.options.breaks?G.inline=W.breaks:G.inline=W.gfm),this.tokenizer.rules=G}ce.lex=function(G,J){var pe=new ce(J);return pe.lex(G)},ce.lexInline=function(G,J){var pe=new ce(J);return pe.inlineTokens(G)};var be=ce.prototype;return be.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},be.blockTokens=function(G,J){var pe=this;J===void 0&&(J=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Le,B,x){return B+"    ".repeat(x.length)});for(var ve,Oe,Ue,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(ve=Le.call({lexer:pe},G,J))?(G=G.substring(ve.raw.length),J.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Oe=J[J.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):J.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Oe=J[J.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(Ue=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,B=G.slice(1),x=void 0;pe.options.extensions.startBlock.forEach(function(H){x=H.call({lexer:this},B),typeof x=="number"&&x>=0&&(Le=Math.min(Le,x))}),Le<1/0&&Le>=0&&(Ue=G.substring(0,Le+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(Ue))){Oe=J[J.length-1],De&&Oe.type==="paragraph"?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):J.push(ve),De=Ue.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Oe=J[J.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):J.push(ve);continue}if(G){var Ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,J},be.inline=function(G,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:G,tokens:J}),J},be.inlineTokens=function(G,J){var pe=this;J===void 0&&(J=[]);var ve,Oe,Ue,De=G,Ae,Le,B;if(this.tokens.links){var x=Object.keys(this.tokens.links);if(x.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)x.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ae.index)+"["+E("a",Ae[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ae.index)+"["+E("a",Ae[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ae.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Le||(B=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(j){return(ve=j.call({lexer:pe},G,J))?(G=G.substring(ve.raw.length),J.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Oe=J[J.length-1],Oe&&ve.type==="text"&&Oe.type==="text"?(Oe.raw+=ve.raw,Oe.text+=ve.text):J.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Oe=J[J.length-1],Oe&&ve.type==="text"&&Oe.type==="text"?(Oe.raw+=ve.raw,Oe.text+=ve.text):J.push(ve);continue}if(ve=this.tokenizer.emStrong(G,De,B)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.autolink(G,Q)){G=G.substring(ve.raw.length),J.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,Q))){G=G.substring(ve.raw.length),J.push(ve);continue}if(Ue=G,this.options.extensions&&this.options.extensions.startInline&&function(){var j=1/0,ne=G.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(ke){fe=ke.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(j=Math.min(j,fe))}),j<1/0&&j>=0&&(Ue=G.substring(0,j+1))}(),ve=this.tokenizer.inlineText(Ue,N)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(B=ve.raw.slice(-1)),Le=!0,Oe=J[J.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ve.raw,Oe.text+=ve.text):J.push(ve);continue}if(G){var H="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return J},S(ce,null,[{key:"rules",get:function(){return{block:V,inline:W}}}]),ce}(),ge=function(){function ce(he){this.options=he||ae.defaults}var be=ce.prototype;return be.code=function(G,J,pe){var ve=(J||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(G,ve);Oe!=null&&Oe!==G&&(pe=!0,G=Oe)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+h(ve,!0)+'">'+(pe?G:h(G,!0))+`</code></pre>
`:"<pre><code>"+(pe?G:h(G,!0))+`</code></pre>
`},be.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},be.html=function(G){return G},be.heading=function(G,J,pe,ve){if(this.options.headerIds){var Oe=this.options.headerPrefix+ve.slug(pe);return"<h"+J+' id="'+Oe+'">'+G+"</h"+J+`>
`}return"<h"+J+">"+G+"</h"+J+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(G,J,pe){var ve=J?"ol":"ul",Oe=J&&pe!==1?' start="'+pe+'"':"";return"<"+ve+Oe+`>
`+G+"</"+ve+`>
`},be.listitem=function(G){return"<li>"+G+`</li>
`},be.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(G){return"<p>"+G+`</p>
`},be.table=function(G,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+J+`</table>
`},be.tablerow=function(G){return`<tr>
`+G+`</tr>
`},be.tablecell=function(G,J){var pe=J.header?"th":"td",ve=J.align?"<"+pe+' align="'+J.align+'">':"<"+pe+">";return ve+G+("</"+pe+`>
`)},be.strong=function(G){return"<strong>"+G+"</strong>"},be.em=function(G){return"<em>"+G+"</em>"},be.codespan=function(G){return"<code>"+G+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(G){return"<del>"+G+"</del>"},be.link=function(G,J,pe){if(G=t(this.options.sanitize,this.options.baseUrl,G),G===null)return pe;var ve='<a href="'+h(G)+'"';return J&&(ve+=' title="'+J+'"'),ve+=">"+pe+"</a>",ve},be.image=function(G,J,pe){if(G=t(this.options.sanitize,this.options.baseUrl,G),G===null)return pe;var ve='<img src="'+G+'" alt="'+pe+'"';return J&&(ve+=' title="'+J+'"'),ve+=this.options.xhtml?"/>":">",ve},be.text=function(G){return G},ce}(),Z=function(){function ce(){}var be=ce.prototype;return be.strong=function(G){return G},be.em=function(G){return G},be.codespan=function(G){return G},be.del=function(G){return G},be.html=function(G){return G},be.text=function(G){return G},be.link=function(G,J,pe){return""+pe},be.image=function(G,J,pe){return""+pe},be.br=function(){return""},ce}(),me=function(){function ce(){this.seen={}}var be=ce.prototype;return be.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(G,J){var pe=G,ve=0;if(this.seen.hasOwnProperty(pe)){ve=this.seen[G];do ve++,pe=G+"-"+ve;while(this.seen.hasOwnProperty(pe))}return J||(this.seen[G]=ve,this.seen[pe]=0),pe},be.slug=function(G,J){J===void 0&&(J={});var pe=this.serialize(G);return this.getNextSafeSlug(pe,J.dryrun)},ce}(),se=function(){function ce(he){this.options=he||ae.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new me}ce.parse=function(G,J){var pe=new ce(J);return pe.parse(G)},ce.parseInline=function(G,J){var pe=new ce(J);return pe.parseInline(G)};var be=ce.prototype;return be.parse=function(G,J){J===void 0&&(J=!0);var pe="",ve,Oe,Ue,De,Ae,Le,B,x,H,j,ne,fe,ke,xe,qe,Ze,tt,nt,et,rt=G.length;for(ve=0;ve<rt;ve++){if(j=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(et=this.options.extensions.renderers[j.type].call({parser:this},j),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(j.type))){pe+=et||"";continue}switch(j.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(j.tokens),j.depth,s(this.parseInline(j.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(j.text,j.lang,j.escaped);continue}case"table":{for(x="",B="",De=j.header.length,Oe=0;Oe<De;Oe++)B+=this.renderer.tablecell(this.parseInline(j.header[Oe].tokens),{header:!0,align:j.align[Oe]});for(x+=this.renderer.tablerow(B),H="",De=j.rows.length,Oe=0;Oe<De;Oe++){for(Le=j.rows[Oe],B="",Ae=Le.length,Ue=0;Ue<Ae;Ue++)B+=this.renderer.tablecell(this.parseInline(Le[Ue].tokens),{header:!1,align:j.align[Ue]});H+=this.renderer.tablerow(B)}pe+=this.renderer.table(x,H);continue}case"blockquote":{H=this.parse(j.tokens),pe+=this.renderer.blockquote(H);continue}case"list":{for(ne=j.ordered,fe=j.start,ke=j.loose,De=j.items.length,H="",Oe=0;Oe<De;Oe++)qe=j.items[Oe],Ze=qe.checked,tt=qe.task,xe="",qe.task&&(nt=this.renderer.checkbox(Ze),ke?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=nt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=nt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:nt}):xe+=nt),xe+=this.parse(qe.tokens,ke),H+=this.renderer.listitem(xe,tt,Ze);pe+=this.renderer.list(H,ne,fe);continue}case"html":{pe+=this.renderer.html(j.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(j.tokens));continue}case"text":{for(H=j.tokens?this.parseInline(j.tokens):j.text;ve+1<rt&&G[ve+1].type==="text";)j=G[++ve],H+=`
`+(j.tokens?this.parseInline(j.tokens):j.text);pe+=J?this.renderer.paragraph(H):H;continue}default:{var ft='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return pe},be.parseInline=function(G,J){J=J||this.renderer;var pe="",ve,Oe,Ue,De=G.length;for(ve=0;ve<De;ve++){if(Oe=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ue=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){pe+=Ue||"";continue}switch(Oe.type){case"escape":{pe+=J.text(Oe.text);break}case"html":{pe+=J.html(Oe.text);break}case"link":{pe+=J.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,J));break}case"image":{pe+=J.image(Oe.href,Oe.title,Oe.text);break}case"strong":{pe+=J.strong(this.parseInline(Oe.tokens,J));break}case"em":{pe+=J.em(this.parseInline(Oe.tokens,J));break}case"codespan":{pe+=J.codespan(Oe.text);break}case"br":{pe+=J.br();break}case"del":{pe+=J.del(this.parseInline(Oe.tokens,J));break}case"text":{pe+=J.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return pe},ce}();function le(ce,be,he){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof be=="function"&&(he=be,be=null),be=C({},le.defaults,be||{}),f(be),he){var G=be.highlight,J;try{J=Y.lex(ce,be)}catch(De){return he(De)}var pe=function(Ae){var Le;if(!Ae)try{be.walkTokens&&le.walkTokens(J,be.walkTokens),Le=se.parse(J,be)}catch(B){Ae=B}return be.highlight=G,Ae?he(Ae):he(null,Le)};if(!G||G.length<3||(delete be.highlight,!J.length))return pe();var ve=0;le.walkTokens(J,function(De){De.type==="code"&&(ve++,setTimeout(function(){G(De.text,De.lang,function(Ae,Le){if(Ae)return pe(Ae);Le!=null&&Le!==De.text&&(De.text=Le,De.escaped=!0),ve--,ve===0&&pe()})},0))}),ve===0&&pe();return}function Oe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+h(De.message+"",!0)+"</pre>";throw De}try{var Ue=Y.lex(ce,be);if(be.walkTokens){if(be.async)return Promise.all(le.walkTokens(Ue,be.walkTokens)).then(function(){return se.parse(Ue,be)}).catch(Oe);le.walkTokens(Ue,be.walkTokens)}return se.parse(Ue,be)}catch(De){Oe(De)}}le.options=le.setOptions=function(ce){return C(le.defaults,ce),R(le.defaults),le},le.getDefaults=A,le.defaults=ae.defaults,le.use=function(){for(var ce=arguments.length,be=new Array(ce),he=0;he<ce;he++)be[he]=arguments[he];var G=C.apply(void 0,[{}].concat(be)),J=le.defaults.extensions||{renderers:{},childTokens:{}},pe;be.forEach(function(ve){if(ve.extensions&&(pe=!0,ve.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var De=J.renderers?J.renderers[Ue.name]:null;De?J.renderers[Ue.name]=function(){for(var Ae=arguments.length,Le=new Array(Ae),B=0;B<Ae;B++)Le[B]=arguments[B];var x=Ue.renderer.apply(this,Le);return x===!1&&(x=De.apply(this,Le)),x}:J.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[Ue.level]?J[Ue.level].unshift(Ue.tokenizer):J[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?J.startBlock?J.startBlock.push(Ue.start):J.startBlock=[Ue.start]:Ue.level==="inline"&&(J.startInline?J.startInline.push(Ue.start):J.startInline=[Ue.start]))}Ue.childTokens&&(J.childTokens[Ue.name]=Ue.childTokens)})),ve.renderer&&function(){var Ue=le.defaults.renderer||new ge,De=function(B){var x=Ue[B];Ue[B]=function(){for(var H=arguments.length,j=new Array(H),ne=0;ne<H;ne++)j[ne]=arguments[ne];var fe=ve.renderer[B].apply(Ue,j);return fe===!1&&(fe=x.apply(Ue,j)),fe}};for(var Ae in ve.renderer)De(Ae);G.renderer=Ue}(),ve.tokenizer&&function(){var Ue=le.defaults.tokenizer||new M,De=function(B){var x=Ue[B];Ue[B]=function(){for(var H=arguments.length,j=new Array(H),ne=0;ne<H;ne++)j[ne]=arguments[ne];var fe=ve.tokenizer[B].apply(Ue,j);return fe===!1&&(fe=x.apply(Ue,j)),fe}};for(var Ae in ve.tokenizer)De(Ae);G.tokenizer=Ue}(),ve.walkTokens){var Oe=le.defaults.walkTokens;G.walkTokens=function(Ue){var De=[];return De.push(ve.walkTokens.call(this,Ue)),Oe&&(De=De.concat(Oe.call(this,Ue))),De}}pe&&(G.extensions=J),le.setOptions(G)})},le.walkTokens=function(ce,be){for(var he=[],G=function(){var Oe=pe.value;switch(he=he.concat(be.call(le,Oe)),Oe.type){case"table":{for(var Ue=O(Oe.header),De;!(De=Ue()).done;){var Ae=De.value;he=he.concat(le.walkTokens(Ae.tokens,be))}for(var Le=O(Oe.rows),B;!(B=Le()).done;)for(var x=B.value,H=O(x),j;!(j=H()).done;){var ne=j.value;he=he.concat(le.walkTokens(ne.tokens,be))}break}case"list":{he=he.concat(le.walkTokens(Oe.items,be));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[Oe.type]?le.defaults.extensions.childTokens[Oe.type].forEach(function(fe){he=he.concat(le.walkTokens(Oe[fe],be))}):Oe.tokens&&(he=he.concat(le.walkTokens(Oe.tokens,be)))}},J=O(ce),pe;!(pe=J()).done;)G();return he},le.parseInline=function(ce,be){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");be=C({},le.defaults,be||{}),f(be);try{var he=Y.lexInline(ce,be);return be.walkTokens&&le.walkTokens(he,be.walkTokens),se.parseInline(he,be)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+h(G.message+"",!0)+"</pre>";throw G}},le.Parser=se,le.parser=se.parse,le.Renderer=ge,le.TextRenderer=Z,le.Lexer=Y,le.lexer=Y.lex,le.Tokenizer=M,le.Slugger=me,le.parse=le;var Ee=le.options,oe=le.setOptions,Ie=le.use,Me=le.walkTokens,X=le.parseInline,$=le,te=se.parse,Se=Y.lex;ae.Lexer=Y,ae.Parser=se,ae.Renderer=ge,ae.Slugger=me,ae.TextRenderer=Z,ae.Tokenizer=M,ae.getDefaults=A,ae.lexer=Se,ae.marked=le,ae.options=Ee,ae.parse=$,ae.parseInline=X,ae.parser=te,ae.setOptions=oe,ae.use=Ie,ae.walkTokens=Me,Object.defineProperty(ae,"__esModule",{value:!0})}),define(Te[138],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=S;function S(n){const s=O(n);if(s&&s.length>0)return new Uint32Array(s)}let T=0;const I=new Uint32Array(10);function O(n){if(T=0,A(n,w,v.InitialConsonant),T>0||(A(n,c,v.Vowel),T>0)||(A(n,_,v.FinalConsonant),T>0)||(A(n,h,v.CompatibilityJamo),T))return I.subarray(0,T);if(n>=44032&&n<=55203){const s=n-44032,o=s%588,d=Math.floor(s/588),i=Math.floor(o/28),r=o%28-1;if(d<w.length?A(d,w,0):v.InitialConsonant+d-v.CompatibilityJamo<h.length&&A(v.InitialConsonant+d,h,v.CompatibilityJamo),i<c.length?A(i,c,0):v.Vowel+i-v.CompatibilityJamo<h.length&&A(v.Vowel+i-v.CompatibilityJamo,h,v.CompatibilityJamo),r>=0&&(r<_.length?A(r,_,0):v.FinalConsonant+r-v.CompatibilityJamo<h.length&&A(v.FinalConsonant+r-v.CompatibilityJamo,h,v.CompatibilityJamo)),T>0)return I.subarray(0,T)}}function A(n,s,o){n>=o&&n<o+s.length&&R(s[n-o])}function R(n){n!==a.NUL&&(I[T++]=n&255,n>>8&&(I[T++]=n>>8&255),n>>16&&(I[T++]=n>>16&255))}var v;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var k;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(k||(k={}));const w=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),c=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,k.hk,k.ho,k.hl,a.y,a.n,k.nj,k.np,k.nl,a.b,a.m,k.ml,a.l]),_=new Uint16Array([a.r,a.R,k.rt,a.s,k.sw,k.sg,a.e,a.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,a.a,a.q,k.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),h=new Uint16Array([a.r,a.R,k.rt,a.s,k.sw,k.sg,a.e,a.E,a.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,a.a,a.q,a.Q,k.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,k.hk,k.ho,k.hl,a.y,a.n,k.nj,k.np,k.nl,a.b,a.m,k.ml,a.l])}),define(Te[139],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=S,e.rot=T,e.isPointWithinTriangle=R;function S(v,a,k){return Math.min(Math.max(v,a),k)}function T(v,a){return(a+v%a)%a}class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class O{constructor(){this._n=1,this._val=0}update(a){return this._val=this._val+(a-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class A{constructor(a){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(a),this._values.fill(0,0,a)}update(a){const k=this._values[this._index];return this._values[this._index]=a,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=a,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A;function R(v,a,k,w,c,_,h,n){const s=h-k,o=n-w,d=c-k,i=_-w,r=v-k,t=a-w,l=s*s+o*o,u=s*d+o*i,g=s*r+o*t,m=d*d+i*i,p=d*r+i*t,y=1/(l*m-u*u),C=(m*g-u*p)*y,b=(l*p-u*g)*y;return C>=0&&b>=0&&C+b<1}}),define(Te[140],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=O,e.getFunctionName=c;class S{constructor(h,n,s){this.owner=h,this.debugNameSource=n,this.referenceFn=s}getDebugName(h){return O(h,this)}}e.DebugNameData=S;const T=new Map,I=new WeakMap;function O(_,h){const n=I.get(_);if(n)return n;const s=A(_,h);if(s){let o=T.get(s)??0;o++,T.set(s,o);const d=o===1?s:`${s}#${o}`;return I.set(_,d),d}}function A(_,h){const n=I.get(_);if(n)return n;const s=h.owner?k(h.owner)+".":"";let o;const d=h.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(o=d(),o!==void 0)return s+o}else return s+d;const i=h.referenceFn;if(i!==void 0&&(o=c(i),o!==void 0))return s+o;if(h.owner!==void 0){const r=R(h.owner,_);if(r!==void 0)return s+r}}function R(_,h){for(const n in _)if(_[n]===h)return n}const v=new Map,a=new WeakMap;function k(_){const h=a.get(_);if(h)return h;const n=w(_);let s=v.get(n)??0;s++,v.set(n,s);const o=s===1?n:`${n}#${s}`;return a.set(_,o),o}function w(_){const h=_.constructor;return h?h.name:"Object"}function c(_){const h=_.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(h);return(s?s[1]:void 0)?.trim()}}),define(Te[141],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=T,e.getLogger=I;let S;function T(n){S=n}function I(){return S}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(s){return A([R(_("|  ",this.indentation)),s])}formatInfo(s){return s.hadValue?s.didChange?[R(" "),a(k(s.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),a(k(s.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),a(k(s.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(s,o){console.log(...this.textToConsoleArgs([v("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.formatInfo(o)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(d,i)=>(this.changedObservablesSets.get(s).add(d),o.apply(s,[d,i]))}handleDerivedRecomputed(s,o){const d=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([v("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.formatInfo(o),this.formatChanges(d),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.textToConsoleArgs([v("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.formatInfo(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(d,i)=>(this.changedObservablesSets.get(s).add(d),o.apply(s,[d,i]))}handleAutorunTriggered(s){const o=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([v("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),o.clear(),this.indentation++}handleAutorunFinished(s){this.indentation--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.textToConsoleArgs([v("transaction"),a(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function A(n){const s=new Array,o=[];let d="";function i(t){if("length"in t)for(const l of t)l&&i(l);else"text"in t?(d+=`%c${t.text}`,s.push(t.style),t.data&&o.push(...t.data)):"data"in t&&o.push(...t.data)}i(n);const r=[d,...s];return r.push(...o),r}function R(n){return a(n,{color:"black"})}function v(n){return a(h(`${n}: `,10),{color:"black",bold:!0})}function a(n,s={color:"black"}){function o(i){return Object.entries(i).reduce((r,[t,l])=>`${r}${t}:${l};`,"")}const d={color:s.color};return s.strikeThrough&&(d["text-decoration"]="line-through"),s.bold&&(d["font-weight"]="bold"),{text:n,style:o(d)}}function k(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?w(n,s):c(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function w(n,s){let o="[ ",d=!0;for(const i of n){if(d||(o+=", "),o.length-5>s){o+="...";break}d=!1,o+=`${k(i,s-o.length)}`}return o+=" ]",o}function c(n,s){let o="{ ",d=!0;for(const[i,r]of Object.entries(n)){if(d||(o+=", "),o.length-5>s){o+="...";break}d=!1,o+=`${i}: ${k(r,s-o.length)}`}return o+=" }",o}function _(n,s){let o="";for(let d=1;d<=s;d++)o+=n;return o}function h(n,s){for(;n.length<s;)n+=" ";return n}}),define(Te[142],Pe([1,0,135,140,141]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=A,e._setKeepObserved=v,e._setDerivedOpts=k,e.transaction=_,e.globalTransaction=n,e.asyncTransaction=s,e.subtransaction=o,e.observableValue=i,e.disposableObservableValue=t;let O;function A(u){O=u}let R;function v(u){R=u}let a;function k(u){a=u}class w{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,m){const p=m===void 0?void 0:g,y=m===void 0?g:m;return a({owner:p,debugName:()=>{const C=(0,T.getFunctionName)(y);if(C!==void 0)return C;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(D)return`${this.debugName}.${D[2]}`;if(!p)return`${this.debugName} (mapped)`},debugReferenceFn:y},C=>y(this.read(C),C))}recomputeInitiallyAndOnChange(g,m){return g.add(O(this,m)),this}keepObserved(g){return g.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=w;class c extends w{constructor(){super(...arguments),this.observers=new Set}addObserver(g){const m=this.observers.size;this.observers.add(g),m===0&&this.onFirstObserverAdded()}removeObserver(g){this.observers.delete(g)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=c;function _(u,g){const m=new d(u,g);try{u(m)}finally{m.finish()}}let h;function n(u){if(h)u(h);else{const g=new d(u,void 0);h=g;try{u(g)}finally{g.finish(),h=void 0}}}async function s(u,g){const m=new d(u,g);try{await u(m)}finally{m.finish()}}function o(u,g,m){u?g(u):_(g,m)}class d{constructor(g,m){this._fn=g,this._getDebugName=m,this.updatingObservers=[],(0,I.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,T.getFunctionName)(this._fn)}updateObserver(g,m){this.updatingObservers.push({observer:g,observable:m}),g.beginUpdate(m)}finish(){const g=this.updatingObservers;for(let m=0;m<g.length;m++){const{observer:p,observable:y}=g[m];p.endUpdate(y)}this.updatingObservers=null,(0,I.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=d;function i(u,g){let m;return typeof u=="string"?m=new T.DebugNameData(void 0,u,void 0):m=new T.DebugNameData(u,void 0,void 0),new r(m,g,S.strictEquals)}class r extends c{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(g,m,p){super(),this._debugNameData=g,this._equalityComparator=p,this._value=m}get(){return this._value}set(g,m,p){if(p===void 0&&this._equalityComparator(this._value,g))return;let y;m||(m=y=new d(()=>{},()=>`Setting ${this.debugName}`));try{const C=this._value;this._setValue(g),(0,I.getLogger)()?.handleObservableChanged(this,{oldValue:C,newValue:g,change:p,didChange:!0,hadValue:!0});for(const b of this.observers)m.updateObserver(b,this),b.handleChange(this,p)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(g){this._value=g}}e.ObservableValue=r;function t(u,g){let m;return typeof u=="string"?m=new T.DebugNameData(void 0,u,void 0):m=new T.DebugNameData(u,void 0,void 0),new l(m,g,S.strictEquals)}class l extends r{_setValue(g){this._value!==g&&(this._value&&this._value.dispose(),this._value=g)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=l}),function(){function ae(I){const O=[];typeof I=="number"&&O.push("code/timeOrigin",I);function A(v){O.push(v,Date.now())}function R(){const v=[];for(let a=0;a<O.length;a+=2)v.push({name:O[a],startTime:O[a+1]});return v}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(I+A.startTime)});return O}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=S(T))}(),define(Te[143],Pe([1,0,40]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const T=Symbol("unset");class I{constructor(){this.root=new A,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||S.Iterable.empty()}insert(v,a,k){this.opNode(v,w=>w._value=a,k)}mutate(v,a){this.opNode(v,k=>k._value=a(k._value===T?void 0:k._value))}mutatePath(v,a){this.opNode(v,()=>{},k=>a(k))}delete(v){const a=this.getPathToKey(v);if(!a)return;let k=a.length-1;const w=a[k].node._value;if(w!==T){for(this._size--,a[k].node._value=T;k>0;k--){const{node:c,part:_}=a[k];if(c.children?.size||c._value!==T)break;a[k-1].node.children.delete(_)}return w}}*deleteRecursive(v){const a=this.getPathToKey(v);if(!a)return;const k=a[a.length-1].node;for(let w=a.length-1;w>0;w--){const c=a[w-1];if(c.node.children.delete(a[w].part),c.node.children.size>0||c.node._value!==T)break}for(const w of O(k))w._value!==T&&(this._size--,yield w._value)}find(v){let a=this.root;for(const k of v){const w=a.children?.get(k);if(!w)return;a=w}return a._value===T?void 0:a._value}hasKeyOrParent(v){let a=this.root;for(const k of v){const w=a.children?.get(k);if(!w)return!1;if(w._value!==T)return!0;a=w}return!1}hasKeyOrChildren(v){let a=this.root;for(const k of v){const w=a.children?.get(k);if(!w)return!1;a=w}return!0}hasKey(v){let a=this.root;for(const k of v){const w=a.children?.get(k);if(!w)return!1;a=w}return a._value!==T}getPathToKey(v){const a=[{part:"",node:this.root}];let k=0;for(const w of v){const c=a[k].node.children?.get(w);if(!c)return;a.push({part:w,node:c}),k++}return a}opNode(v,a,k){let w=this.root;for(const h of v){if(w.children)if(w.children.has(h))w=w.children.get(h);else{const n=new A;w.children.set(h,n),w=n}else{const n=new A;w.children=new Map([[h,n]]),w=n}k?.(w)}const c=w._value===T?0:1;a(w);const _=w._value===T?0:1;this._size+=_-c}*values(){for(const{_value:v}of O(this.root))v!==T&&(yield v)}}e.WellDefinedPrefixTree=I;function*O(R){const v=[R];for(;v.length>0;){const a=v.pop();if(yield a,a.children)for(const k of a.children.values())v.push(k)}}class A{constructor(){this._value=T}get value(){return this._value===T?void 0:this._value}set value(v){this._value=v===void 0?T:v}}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var T in S)(typeof exports=="object"?exports:ae)[T]=S[T]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function S(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return ae[T].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=ae,S.c=e,S.d=function(T,I,O){S.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:O})},S.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},S.t=function(T,I){if(1&I&&(T=S(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var A in T)S.d(O,A,function(R){return T[R]}.bind(null,A));return O},S.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return S.d(I,"a",I),I},S.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},S.p="",S(S.s=0)}([function(ae,e,S){(function(T){var I;e=ae.exports=Ie,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],a=0,k=a++;v[k]="0|[1-9]\\d*";var w=a++;v[w]="[0-9]+";var c=a++;v[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=a++;v[_]="("+v[k]+")\\.("+v[k]+")\\.("+v[k]+")";var h=a++;v[h]="("+v[w]+")\\.("+v[w]+")\\.("+v[w]+")";var n=a++;v[n]="(?:"+v[k]+"|"+v[c]+")";var s=a++;v[s]="(?:"+v[w]+"|"+v[c]+")";var o=a++;v[o]="(?:-("+v[n]+"(?:\\."+v[n]+")*))";var d=a++;v[d]="(?:-?("+v[s]+"(?:\\."+v[s]+")*))";var i=a++;v[i]="[0-9A-Za-z-]+";var r=a++;v[r]="(?:\\+("+v[i]+"(?:\\."+v[i]+")*))";var t=a++,l="v?"+v[_]+v[o]+"?"+v[r]+"?";v[t]="^"+l+"$";var u="[v=\\s]*"+v[h]+v[d]+"?"+v[r]+"?",g=a++;v[g]="^"+u+"$";var m=a++;v[m]="((?:<|>)?=?)";var p=a++;v[p]=v[w]+"|x|X|\\*";var y=a++;v[y]=v[k]+"|x|X|\\*";var C=a++;v[C]="[v=\\s]*("+v[y]+")(?:\\.("+v[y]+")(?:\\.("+v[y]+")(?:"+v[o]+")?"+v[r]+"?)?)?";var b=a++;v[b]="[v=\\s]*("+v[p]+")(?:\\.("+v[p]+")(?:\\.("+v[p]+")(?:"+v[d]+")?"+v[r]+"?)?)?";var D=a++;v[D]="^"+v[m]+"\\s*"+v[C]+"$";var P=a++;v[P]="^"+v[m]+"\\s*"+v[b]+"$";var f=a++;v[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=a++;v[E]="(?:~>?)";var F=a++;v[F]="(\\s*)"+v[E]+"\\s+",R[F]=new RegExp(v[F],"g");var L=a++;v[L]="^"+v[E]+v[C]+"$";var M=a++;v[M]="^"+v[E]+v[b]+"$";var V=a++;v[V]="(?:\\^)";var W=a++;v[W]="(\\s*)"+v[V]+"\\s+",R[W]=new RegExp(v[W],"g");var N=a++;v[N]="^"+v[V]+v[C]+"$";var Q=a++;v[Q]="^"+v[V]+v[b]+"$";var Y=a++;v[Y]="^"+v[m]+"\\s*("+u+")$|^$";var ge=a++;v[ge]="^"+v[m]+"\\s*("+l+")$|^$";var Z=a++;v[Z]="(\\s*)"+v[m]+"\\s*("+u+"|"+v[C]+")",R[Z]=new RegExp(v[Z],"g");var me=a++;v[me]="^\\s*("+v[C]+")\\s+-\\s+("+v[C]+")\\s*$";var se=a++;v[se]="^\\s*("+v[b]+")\\s+-\\s+("+v[b]+")\\s*$";var le=a++;v[le]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)I(Ee,v[Ee]),R[Ee]||(R[Ee]=new RegExp(v[Ee]));function oe(x,H){if(x instanceof Ie)return x;if(typeof x!="string"||x.length>O||!(H?R[g]:R[t]).test(x))return null;try{return new Ie(x,H)}catch{return null}}function Ie(x,H){if(x instanceof Ie){if(x.loose===H)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ie))return new Ie(x,H);I("SemVer",x,H),this.loose=H;var j=x.trim().match(H?R[g]:R[t]);if(!j)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+j[1],this.minor=+j[2],this.patch=+j[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");j[4]?this.prerelease=j[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=j[5]?j[5].split("."):[],this.format()}e.parse=oe,e.valid=function(x,H){var j=oe(x,H);return j?j.version:null},e.clean=function(x,H){var j=oe(x.trim().replace(/^[=v]+/,""),H);return j?j.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof Ie||(x=new Ie(x,this.loose)),this.compareMain(x)||this.comparePre(x)},Ie.prototype.compareMain=function(x){return x instanceof Ie||(x=new Ie(x,this.loose)),X(this.major,x.major)||X(this.minor,x.minor)||X(this.patch,x.patch)},Ie.prototype.comparePre=function(x){if(x instanceof Ie||(x=new Ie(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var H=0;do{var j=this.prerelease[H],ne=x.prerelease[H];if(I("prerelease compare",H,j,ne),j===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(j===void 0)return-1;if(j!==ne)return X(j,ne)}while(++H)},Ie.prototype.inc=function(x,H){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var j=this.prerelease.length;--j>=0;)typeof this.prerelease[j]=="number"&&(this.prerelease[j]++,j=-2);j===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,H,j,ne){typeof j=="string"&&(ne=j,j=void 0);try{return new Ie(x,j).inc(H,ne).version}catch{return null}},e.diff=function(x,H){if(ce(x,H))return null;var j=oe(x),ne=oe(H);if(j.prerelease.length||ne.prerelease.length){for(var fe in j)if((fe==="major"||fe==="minor"||fe==="patch")&&j[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in j)if((fe==="major"||fe==="minor"||fe==="patch")&&j[fe]!==ne[fe])return fe},e.compareIdentifiers=X;var Me=/^[0-9]+$/;function X(x,H){var j=Me.test(x),ne=Me.test(H);return j&&ne&&(x=+x,H=+H),j&&!ne?-1:ne&&!j?1:x<H?-1:x>H?1:0}function $(x,H,j){return new Ie(x,j).compare(new Ie(H,j))}function te(x,H,j){return $(x,H,j)>0}function Se(x,H,j){return $(x,H,j)<0}function ce(x,H,j){return $(x,H,j)===0}function be(x,H,j){return $(x,H,j)!==0}function he(x,H,j){return $(x,H,j)>=0}function G(x,H,j){return $(x,H,j)<=0}function J(x,H,j,ne){var fe;switch(H){case"===":typeof x=="object"&&(x=x.version),typeof j=="object"&&(j=j.version),fe=x===j;break;case"!==":typeof x=="object"&&(x=x.version),typeof j=="object"&&(j=j.version),fe=x!==j;break;case"":case"=":case"==":fe=ce(x,j,ne);break;case"!=":fe=be(x,j,ne);break;case">":fe=te(x,j,ne);break;case">=":fe=he(x,j,ne);break;case"<":fe=Se(x,j,ne);break;case"<=":fe=G(x,j,ne);break;default:throw new TypeError("Invalid operator: "+H)}return fe}function pe(x,H){if(x instanceof pe){if(x.loose===H)return x;x=x.value}if(!(this instanceof pe))return new pe(x,H);I("comparator",x,H),this.loose=H,this.parse(x),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,H){return X(H,x)},e.major=function(x,H){return new Ie(x,H).major},e.minor=function(x,H){return new Ie(x,H).minor},e.patch=function(x,H){return new Ie(x,H).patch},e.compare=$,e.compareLoose=function(x,H){return $(x,H,!0)},e.rcompare=function(x,H,j){return $(H,x,j)},e.sort=function(x,H){return x.sort(function(j,ne){return e.compare(j,ne,H)})},e.rsort=function(x,H){return x.sort(function(j,ne){return e.rcompare(j,ne,H)})},e.gt=te,e.lt=Se,e.eq=ce,e.neq=be,e.gte=he,e.lte=G,e.cmp=J,e.Comparator=pe;var ve={};function Oe(x,H){if(x instanceof Oe)return x.loose===H?x:new Oe(x.raw,H);if(x instanceof pe)return new Oe(x.value,H);if(!(this instanceof Oe))return new Oe(x,H);if(this.loose=H,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(j){return this.parseRange(j.trim())},this).filter(function(j){return j.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ue(x){return!x||x.toLowerCase()==="x"||x==="*"}function De(x,H,j,ne,fe,ke,xe,qe,Ze,tt,nt,et,rt){return((H=Ue(j)?"":Ue(ne)?">="+j+".0.0":Ue(fe)?">="+j+"."+ne+".0":">="+H)+" "+(qe=Ue(Ze)?"":Ue(tt)?"<"+(+Ze+1)+".0.0":Ue(nt)?"<"+Ze+"."+(+tt+1)+".0":et?"<="+Ze+"."+tt+"."+nt+"-"+et:"<="+qe)).trim()}function Ae(x,H){for(var j=0;j<x.length;j++)if(!x[j].test(H))return!1;if(H.prerelease.length){for(j=0;j<x.length;j++)if(I(x[j].semver),x[j].semver!==ve&&x[j].semver.prerelease.length>0){var ne=x[j].semver;if(ne.major===H.major&&ne.minor===H.minor&&ne.patch===H.patch)return!0}return!1}return!0}function Le(x,H,j){try{H=new Oe(H,j)}catch{return!1}return H.test(x)}function B(x,H,j,ne){var fe,ke,xe,qe,Ze;switch(x=new Ie(x,ne),H=new Oe(H,ne),j){case">":fe=te,ke=G,xe=Se,qe=">",Ze=">=";break;case"<":fe=Se,ke=he,xe=te,qe="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(x,H,ne))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===ve&&(ft=new pe(">=0.0.0")),et=et||ft,rt=rt||ft,fe(ft.semver,et.semver,ne)?et=ft:xe(ft.semver,rt.semver,ne)&&(rt=ft)}),et.operator===qe||et.operator===Ze||(!rt.operator||rt.operator===qe)&&ke(x,rt.semver)||rt.operator===Ze&&xe(x,rt.semver))return!1}return!0}pe.prototype.parse=function(x){var H=this.loose?R[Y]:R[ge],j=x.match(H);if(!j)throw new TypeError("Invalid comparator: "+x);this.operator=j[1],this.operator==="="&&(this.operator=""),j[2]?this.semver=new Ie(j[2],this.loose):this.semver=ve},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===ve||(typeof x=="string"&&(x=new Ie(x,this.loose)),J(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,H){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var j;if(this.operator==="")return j=new Oe(x.value,H),Le(this.value,j,H);if(x.operator==="")return j=new Oe(this.value,H),Le(x.semver,j,H);var ne=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),ke=this.semver.version===x.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),qe=J(this.semver,"<",x.semver,H)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ze=J(this.semver,">",x.semver,H)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ne||fe||ke&&xe||qe||Ze},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(x){var H=this.loose;x=x.trim(),I("range",x,H);var j=H?R[se]:R[me];x=x.replace(j,De),I("hyphen replace",x),x=x.replace(R[Z],"$1$2$3"),I("comparator trim",x,R[Z]),x=(x=(x=x.replace(R[F],"$1~")).replace(R[W],"$1^")).split(/\s+/).join(" ");var ne=H?R[Y]:R[ge],fe=x.split(" ").map(function(ke){return function(xe,qe){return I("comp",xe),xe=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(nt){return function(et,rt){I("caret",et,rt);var ft=rt?R[Q]:R[N];return et.replace(ft,function(lt,st,ct,gt,pt){var ze;return I("caret",et,lt,st,ct,gt,pt),Ue(st)?ze="":Ue(ct)?ze=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?ze=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":pt?(I("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),ze=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+pt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+pt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+pt+" <"+(+st+1)+".0.0"):(I("no pr"),ze=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+" <"+(+st+1)+".0.0"),I("caret return",ze),ze})}(nt,tt)}).join(" ")}(xe,qe),I("caret",xe),xe=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?R[M]:R[L];return et.replace(ft,function(lt,st,ct,gt,pt){var ze;return I("tilde",et,lt,st,ct,gt,pt),Ue(st)?ze="":Ue(ct)?ze=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?ze=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":pt?(I("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),ze=">="+st+"."+ct+"."+gt+pt+" <"+st+"."+(+ct+1)+".0"):ze=">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0",I("tilde return",ze),ze})}(nt,tt)}).join(" ")}(xe,qe),I("tildes",xe),xe=function(Ze,tt){return I("replaceXRanges",Ze,tt),Ze.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?R[P]:R[D];return et.replace(ft,function(lt,st,ct,gt,pt,ze){I("xRange",et,lt,st,ct,gt,pt,ze);var Be=Ue(ct),ee=Be||Ue(gt),q=ee||Ue(pt);return st==="="&&q&&(st=""),Be?lt=st===">"||st==="<"?"<0.0.0":"*":st&&q?(ee&&(gt=0),q&&(pt=0),st===">"?(st=">=",ee?(ct=+ct+1,gt=0,pt=0):q&&(gt=+gt+1,pt=0)):st==="<="&&(st="<",ee?ct=+ct+1:gt=+gt+1),lt=st+ct+"."+gt+"."+pt):ee?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":q&&(lt=">="+ct+"."+gt+".0 <"+ct+"."+(+gt+1)+".0"),I("xRange return",lt),lt})}(nt,tt)}).join(" ")}(xe,qe),I("xrange",xe),xe=function(Ze,tt){return I("replaceStars",Ze,tt),Ze.trim().replace(R[le],"")}(xe,qe),I("stars",xe),xe}(ke,H)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(ke){return!!ke.match(ne)})),fe=fe.map(function(ke){return new pe(ke,H)})},Oe.prototype.intersects=function(x,H){if(!(x instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(j){return j.every(function(ne){return x.set.some(function(fe){return fe.every(function(ke){return ne.intersects(ke,H)})})})})},e.toComparators=function(x,H){return new Oe(x,H).set.map(function(j){return j.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new Ie(x,this.loose));for(var H=0;H<this.set.length;H++)if(Ae(this.set[H],x))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(x,H,j){var ne=null,fe=null;try{var ke=new Oe(H,j)}catch{return null}return x.forEach(function(xe){ke.test(xe)&&(ne&&fe.compare(xe)!==-1||(fe=new Ie(ne=xe,j)))}),ne},e.minSatisfying=function(x,H,j){var ne=null,fe=null;try{var ke=new Oe(H,j)}catch{return null}return x.forEach(function(xe){ke.test(xe)&&(ne&&fe.compare(xe)!==1||(fe=new Ie(ne=xe,j)))}),ne},e.validRange=function(x,H){try{return new Oe(x,H).range||"*"}catch{return null}},e.ltr=function(x,H,j){return B(x,H,"<",j)},e.gtr=function(x,H,j){return B(x,H,">",j)},e.outside=B,e.prerelease=function(x,H){var j=oe(x,H);return j&&j.prerelease.length?j.prerelease:null},e.intersects=function(x,H,j){return x=new Oe(x,j),H=new Oe(H,j),x.intersects(H)},e.coerce=function(x){if(x instanceof Ie)return x;if(typeof x!="string")return null;var H=x.match(R[f]);return H==null?null:oe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(ae,e){var S,T,I=ae.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(s){if(S===setTimeout)return setTimeout(s,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(s,0);try{return S(s,0)}catch{try{return S.call(null,s,0)}catch{return S.call(this,s,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var v,a=[],k=!1,w=-1;function c(){k&&v&&(k=!1,v.length?a=v.concat(a):w=-1,a.length&&_())}function _(){if(!k){var s=R(c);k=!0;for(var o=a.length;o;){for(v=a,a=[];++w<o;)v&&v[w].run();w=-1,o=a.length}v=null,k=!1,function(d){if(T===clearTimeout)return clearTimeout(d);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(d);try{T(d)}catch{try{return T.call(null,d)}catch{return T.call(this,d)}}}(s)}}function h(s,o){this.fun=s,this.array=o}function n(){}I.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)o[d-1]=arguments[d];a.push(new h(s,o)),a.length!==1||k||R(_)},h.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(s){return[]},I.binding=function(s){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(s){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Te[144],Pe([1,0,6,4]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var I;(function(_){_[_.Auto=1]="Auto",_[_.Hidden=2]="Hidden",_[_.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class O{constructor(h,n,s,o,d,i,r){this._forceIntegerValues=h,this._scrollStateBrand=void 0,this._forceIntegerValues&&(n=n|0,s=s|0,o=o|0,d=d|0,i=i|0,r=r|0),this.rawScrollLeft=o,this.rawScrollTop=r,n<0&&(n=0),o+n>s&&(o=s-n),o<0&&(o=0),d<0&&(d=0),r+d>i&&(r=i-d),r<0&&(r=0),this.width=n,this.scrollWidth=s,this.scrollLeft=o,this.height=d,this.scrollHeight=i,this.scrollTop=r}equals(h){return this.rawScrollLeft===h.rawScrollLeft&&this.rawScrollTop===h.rawScrollTop&&this.width===h.width&&this.scrollWidth===h.scrollWidth&&this.scrollLeft===h.scrollLeft&&this.height===h.height&&this.scrollHeight===h.scrollHeight&&this.scrollTop===h.scrollTop}withScrollDimensions(h,n){return new O(this._forceIntegerValues,typeof h.width<"u"?h.width:this.width,typeof h.scrollWidth<"u"?h.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof h.height<"u"?h.height:this.height,typeof h.scrollHeight<"u"?h.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(h){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof h.scrollLeft<"u"?h.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof h.scrollTop<"u"?h.scrollTop:this.rawScrollTop)}createScrollEvent(h,n){const s=this.width!==h.width,o=this.scrollWidth!==h.scrollWidth,d=this.scrollLeft!==h.scrollLeft,i=this.height!==h.height,r=this.scrollHeight!==h.scrollHeight,t=this.scrollTop!==h.scrollTop;return{inSmoothScrolling:n,oldWidth:h.width,oldScrollWidth:h.scrollWidth,oldScrollLeft:h.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:h.height,oldScrollHeight:h.scrollHeight,oldScrollTop:h.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:o,scrollLeftChanged:d,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.ScrollState=O;class A extends T.Disposable{constructor(h){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new S.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=h.smoothScrollDuration,this._scheduleAtNextAnimationFrame=h.scheduleAtNextAnimationFrame,this._state=new O(h.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(h){this._smoothScrollDuration=h}validateScrollPosition(h){return this._state.withScrollPosition(h)}getScrollDimensions(){return this._state}setScrollDimensions(h,n){const s=this._state.withScrollDimensions(h,n);this._setState(s,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(h){const n=this._state.withScrollPosition(h);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(n,!1)}setScrollPositionSmooth(h,n){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(h);if(this._smoothScrolling){h={scrollLeft:typeof h.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:h.scrollLeft,scrollTop:typeof h.scrollTop>"u"?this._smoothScrolling.to.scrollTop:h.scrollTop};const s=this._state.withScrollPosition(h);if(this._smoothScrolling.to.scrollLeft===s.scrollLeft&&this._smoothScrolling.to.scrollTop===s.scrollTop)return;let o;n?o=new k(this._smoothScrolling.from,s,this._smoothScrolling.startTime,this._smoothScrolling.duration):o=this._smoothScrolling.combine(this._state,s,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=o}else{const s=this._state.withScrollPosition(h);this._smoothScrolling=k.start(this._state,s,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const h=this._smoothScrolling.tick(),n=this._state.withScrollPosition(h);if(this._setState(n,!0),!!this._smoothScrolling){if(h.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(h,n){const s=this._state;s.equals(h)||(this._state=h,this._onScroll.fire(this._state.createScrollEvent(s,n)))}}e.Scrollable=A;class R{constructor(h,n,s){this.scrollLeft=h,this.scrollTop=n,this.isDone=s}}e.SmoothScrollingUpdate=R;function v(_,h){const n=h-_;return function(s){return _+n*c(s)}}function a(_,h,n){return function(s){return s<n?_(s/n):h((s-n)/(1-n))}}class k{constructor(h,n,s,o){this.from=h,this.to=n,this.duration=o,this.startTime=s,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(h,n,s){if(Math.abs(h-n)>2.5*s){let d,i;return h<n?(d=h+.75*s,i=n-.75*s):(d=h-.75*s,i=n+.75*s),a(v(h,d),v(i,n),.33)}return v(h,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(h){this.to=h.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(h){const n=(h-this.startTime)/this.duration;if(n<1){const s=this.scrollLeft(n),o=this.scrollTop(n);return new R(s,o,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(h,n,s){return k.start(h,n,s)}static start(h,n,s){s=s+10;const o=Date.now()-10;return new k(h,n,o,s)}}e.SmoothScrollingOperation=k;function w(_){return Math.pow(_,3)}function c(_){return 1-w(1-_)}}),define(Te[145],Pe([1,0,14,4]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=I,e.isReadableStream=O,e.isReadableBufferedStream=A,e.newWriteableStream=R,e.consumeReadable=a,e.peekReadable=k,e.consumeStream=w,e.listenStream=c,e.peekStream=_,e.toStream=h,e.emptyStream=n,e.toReadable=s,e.transform=o,e.prefixedReadable=d,e.prefixedStream=i;function I(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(l=>typeof l=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(r,t){return new v(r,t)}class v{constructor(t,l){this.reducer=t,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(l=>l(t))}emitError(t){this.listeners.error.length===0?(0,S.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(l=>l(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,l){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(t,l){if(this.state.destroyed)return;let u;switch(t){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const g=u.indexOf(l);g>=0&&u.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(r,t){const l=[];let u;for(;(u=r.read())!==null;)l.push(u);return t(l)}function k(r,t,l){const u=[];let g;for(;(g=r.read())!==null&&u.length<l;)u.push(g);return g===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof g<"u"){const m=g;return g=void 0,m}return r.read()}}}function w(r,t){return new Promise((l,u)=>{const g=[];c(r,{onData:m=>{t&&g.push(m)},onError:m=>{t?u(m):l(void 0)},onEnd:()=>{l(t?t(g):void 0)}})})}function c(r,t,l){r.on("error",u=>{l?.isCancellationRequested||t.onError(u)}),r.on("end",()=>{l?.isCancellationRequested||t.onEnd()}),r.on("data",u=>{l?.isCancellationRequested||t.onData(u)})}function _(r,t){return new Promise((l,u)=>{const g=new T.DisposableStore,m=[],p=b=>{if(m.push(b),m.length>t)return g.dispose(),r.pause(),l({stream:r,buffer:m,ended:!1})},y=b=>(g.dispose(),u(b)),C=()=>(g.dispose(),l({stream:r,buffer:m,ended:!0}));g.add((0,T.toDisposable)(()=>r.removeListener("error",y))),r.on("error",y),g.add((0,T.toDisposable)(()=>r.removeListener("end",C))),r.on("end",C),g.add((0,T.toDisposable)(()=>r.removeListener("data",p))),r.on("data",p)})}function h(r,t){const l=R(t);return l.end(r),l}function n(){const r=R(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function o(r,t,l){const u=R(l);return c(r,{onData:g=>u.write(t.data(g)),onError:g=>u.error(t.error?t.error(g):g),onEnd:()=>u.end()}),u}function d(r,t,l){let u=!1;return{read:()=>{const g=t.read();return u?g:(u=!0,g!==null?l([r,g]):r)}}}function i(r,t,l){let u=!1;const g=R(l);return c(t,{onData:m=>u?g.write(m):(u=!0,g.write(l([r,m]))),onError:m=>g.error(m),onEnd:()=>{u||(u=!0,g.write(r)),g.end()}}),g}}),define(Te[23],Pe([1,0,48,145]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=k,e.writeUInt16LE=w,e.readUInt32BE=c,e.writeUInt32BE=_,e.readUInt32LE=h,e.writeUInt32LE=n,e.readUInt8=s,e.writeUInt8=o,e.readableToBuffer=d,e.bufferToReadable=i,e.streamToBuffer=r,e.bufferedStreamToBuffer=t,e.bufferToStream=l,e.streamToBufferReadableStream=u,e.newWriteableBufferStream=g,e.prefixedBufferReadable=m,e.prefixedBufferStream=p,e.decodeBase64=y,e.encodeBase64=D,T=$e(T);const I=typeof Buffer<"u",O=new S.Lazy(()=>new Uint8Array(256));let A,R;class v{static alloc(f){return I?new v(Buffer.allocUnsafe(f)):new v(new Uint8Array(f))}static wrap(f){return I&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new v(f)}static fromString(f,E){return!(E?.dontUseNodeBuffer||!1)&&I?new v(Buffer.from(f)):(A||(A=new TextEncoder),new v(A.encode(f)))}static fromByteArray(f){const E=v.alloc(f.length);for(let F=0,L=f.length;F<L;F++)E.buffer[F]=f[F];return E}static concat(f,E){if(typeof E>"u"){E=0;for(let M=0,V=f.length;M<V;M++)E+=f[M].byteLength}const F=v.alloc(E);let L=0;for(let M=0,V=f.length;M<V;M++){const W=f[M];F.set(W,L),L+=W.byteLength}return F}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=v.alloc(this.byteLength);return f.set(this),f}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,E){return new v(this.buffer.subarray(f,E))}set(f,E){if(f instanceof v)this.buffer.set(f.buffer,E);else if(f instanceof Uint8Array)this.buffer.set(f,E);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),E);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return c(this.buffer,f)}writeUInt32BE(f,E){_(this.buffer,f,E)}readUInt32LE(f){return h(this.buffer,f)}writeUInt32LE(f,E){n(this.buffer,f,E)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,E){o(this.buffer,f,E)}indexOf(f,E=0){return a(this.buffer,f instanceof v?f.buffer:f,E)}}e.VSBuffer=v;function a(P,f,E=0){const F=f.byteLength,L=P.byteLength;if(F===0)return 0;if(F===1)return P.indexOf(f[0]);if(F>L-E)return-1;const M=O.value;M.fill(f.length);for(let Q=0;Q<f.length;Q++)M[f[Q]]=f.length-Q-1;let V=E+f.length-1,W=V,N=-1;for(;V<L;)if(P[V]===f[W]){if(W===0){N=V;break}V--,W--}else V+=Math.max(f.length-W,M[P[V]]),W=f.length-1;return N}function k(P,f){return P[f+0]<<0>>>0|P[f+1]<<8>>>0}function w(P,f,E){P[E+0]=f&255,f=f>>>8,P[E+1]=f&255}function c(P,f){return P[f]*2**24+P[f+1]*2**16+P[f+2]*2**8+P[f+3]}function _(P,f,E){P[E+3]=f,f=f>>>8,P[E+2]=f,f=f>>>8,P[E+1]=f,f=f>>>8,P[E]=f}function h(P,f){return P[f+0]<<0>>>0|P[f+1]<<8>>>0|P[f+2]<<16>>>0|P[f+3]<<24>>>0}function n(P,f,E){P[E+0]=f&255,f=f>>>8,P[E+1]=f&255,f=f>>>8,P[E+2]=f&255,f=f>>>8,P[E+3]=f&255}function s(P,f){return P[f]}function o(P,f,E){P[E]=f}function d(P){return T.consumeReadable(P,f=>v.concat(f))}function i(P){return T.toReadable(P)}function r(P){return T.consumeStream(P,f=>v.concat(f))}async function t(P){return P.ended?v.concat(P.buffer):v.concat([...P.buffer,await r(P.stream)])}function l(P){return T.toStream(P,f=>v.concat(f))}function u(P){return T.transform(P,{data:f=>typeof f=="string"?v.fromString(f):v.wrap(f)},f=>v.concat(f))}function g(P){return T.newWriteableStream(f=>v.concat(f),P)}function m(P,f){return T.prefixedReadable(P,f,E=>v.concat(E))}function p(P,f){return T.prefixedStream(P,f,E=>v.concat(E))}function y(P){let f=0,E=0,F=0;const L=new Uint8Array(Math.floor(P.length/4*3)),M=W=>{switch(E){case 3:L[F++]=f|W,E=0;break;case 2:L[F++]=f|W>>>2,f=W<<6,E=3;break;case 1:L[F++]=f|W>>>4,f=W<<4,E=2;break;default:f=W<<2,E=1}};for(let W=0;W<P.length;W++){const N=P.charCodeAt(W);if(N>=65&&N<=90)M(N-65);else if(N>=97&&N<=122)M(N-97+26);else if(N>=48&&N<=57)M(N-48+52);else if(N===43||N===45)M(62);else if(N===47||N===95)M(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${P[W]}`)}}const V=F;for(;E>0;)M(0);return v.wrap(L).slice(0,V)}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:P},f=!0,E=!1){const F=E?b:C;let L="";const M=P.byteLength%3;let V=0;for(;V<P.byteLength-M;V+=3){const W=P[V+0],N=P[V+1],Q=P[V+2];L+=F[W>>>2],L+=F[(W<<4|N>>>4)&63],L+=F[(N<<2|Q>>>6)&63],L+=F[Q&63]}if(M===1){const W=P[V+0];L+=F[W>>>2],L+=F[W<<4&63],f&&(L+="==")}else if(M===2){const W=P[V+0],N=P[V+1];L+=F[W>>>2],L+=F[(W<<4|N>>>4)&63],L+=F[N<<2&63],f&&(L+="=")}return L}}),define(Te[146],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[35],Pe([1,0,98]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=I;var T;(function(A){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}A.isThemeColor=R})(T||(e.ThemeColor=T={}));function I(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function v(d){const i=R.exec(d.id);if(!i)return v(S.Codicon.error);const[,r,t]=i,l=["codicon","codicon-"+r];return t&&l.push("codicon-modifier-"+t.substring(1)),l}A.asClassNameArray=v;function a(d){return v(d).join(" ")}A.asClassName=a;function k(d){return"."+v(d).join(".")}A.asCSSSelector=k;function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||T.isThemeColor(d.color))}A.isThemeIcon=w;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function _(d){const i=c.exec(d);if(!i)return;const[,r]=i;return{id:r}}A.fromString=_;function h(d){return{id:d}}A.fromId=h;function n(d,i){let r=d.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function s(d){const i=d.id.lastIndexOf("~");if(i!==-1)return d.id.substring(i+1)}A.getModifier=s;function o(d,i){return d.id===i.id&&d.color?.id===i.color?.id}A.isEqual=o})(O||(e.ThemeIcon=O={}))}),define(Te[147],Pe([1,0,28,29,138,13]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=A,e.matchesContiguousSubString=v,e.matchesSubString=a,e.isUpper=c,e.matchesCamelCase=C,e.matchesWords=b,e.matchesFuzzy=L,e.matchesFuzzy2=M,e.anyScore=V,e.createMatches=W,e.isPatternInWord=te,e.fuzzyScore=he,e.fuzzyScoreGracefulAggressive=pe,e.fuzzyScoreGraceful=ve,O=$e(O);function A(...De){return function(Ae,Le){for(let B=0,x=De.length;B<x;B++){const H=De[B](Ae,Le);if(H)return H}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(De,Ae,Le){if(!Le||Le.length<Ae.length)return null;let B;return De?B=O.startsWithIgnoreCase(Le,Ae):B=Le.indexOf(Ae)===0,B?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function v(De,Ae){const Le=Ae.toLowerCase().indexOf(De.toLowerCase());return Le===-1?null:[{start:Le,end:Le+De.length}]}function a(De,Ae){return k(De.toLowerCase(),Ae.toLowerCase(),0,0)}function k(De,Ae,Le,B){if(Le===De.length)return[];if(B===Ae.length)return null;if(De[Le]===Ae[B]){let x=null;return(x=k(De,Ae,Le+1,B+1))?t({start:B,end:B+1},x):null}return k(De,Ae,Le,B+1)}function w(De){return S.CharCode.a<=De&&De<=S.CharCode.z}function c(De){return S.CharCode.A<=De&&De<=S.CharCode.Z}function _(De){return S.CharCode.Digit0<=De&&De<=S.CharCode.Digit9}function h(De){return De===S.CharCode.Space||De===S.CharCode.Tab||De===S.CharCode.LineFeed||De===S.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(De=>n.add(De.charCodeAt(0)));function s(De){return h(De)||n.has(De)}function o(De,Ae){return De===Ae||s(De)&&s(Ae)}const d=new Map;function i(De){if(d.has(De))return d.get(De);let Ae;const Le=(0,I.getKoreanAltChars)(De);return Le&&(Ae=Le),d.set(De,Ae),Ae}function r(De){return w(De)||c(De)||_(De)}function t(De,Ae){return Ae.length===0?Ae=[De]:De.end===Ae[0].start?Ae[0].start=De.start:Ae.unshift(De),Ae}function l(De,Ae){for(let Le=Ae;Le<De.length;Le++){const B=De.charCodeAt(Le);if(c(B)||_(B)||Le>0&&!r(De.charCodeAt(Le-1)))return Le}return De.length}function u(De,Ae,Le,B){if(Le===De.length)return[];if(B===Ae.length)return null;if(De[Le]!==Ae[B].toLowerCase())return null;{let x=null,H=B+1;for(x=u(De,Ae,Le+1,B+1);!x&&(H=l(Ae,H))<Ae.length;)x=u(De,Ae,Le+1,H),H++;return x===null?null:t({start:B,end:B+1},x)}}function g(De){let Ae=0,Le=0,B=0,x=0,H=0;for(let xe=0;xe<De.length;xe++)H=De.charCodeAt(xe),c(H)&&Ae++,w(H)&&Le++,r(H)&&B++,_(H)&&x++;const j=Ae/De.length,ne=Le/De.length,fe=B/De.length,ke=x/De.length;return{upperPercent:j,lowerPercent:ne,alphaPercent:fe,numericPercent:ke}}function m(De){const{upperPercent:Ae,lowerPercent:Le}=De;return Le===0&&Ae>.6}function p(De){const{upperPercent:Ae,lowerPercent:Le,alphaPercent:B,numericPercent:x}=De;return Le>.2&&Ae<.8&&B>.6&&x<.2}function y(De){let Ae=0,Le=0,B=0,x=0;for(let H=0;H<De.length;H++)B=De.charCodeAt(H),c(B)&&Ae++,w(B)&&Le++,h(B)&&x++;return(Ae===0||Le===0)&&x===0?De.length<=30:Ae<=5}function C(De,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!y(De))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Le=g(Ae);if(!p(Le)){if(!m(Le))return null;Ae=Ae.toLowerCase()}let B=null,x=0;for(De=De.toLowerCase();x<Ae.length&&(B=u(De,Ae,0,x))===null;)x=l(Ae,x+1);return B}function b(De,Ae,Le=!1){if(!Ae||Ae.length===0)return null;let B=null,x=0;for(De=De.toLowerCase(),Ae=Ae.toLowerCase();x<Ae.length&&(B=D(De,Ae,0,x,Le),B===null);)x=P(Ae,x+1);return B}function D(De,Ae,Le,B,x){let H=0;if(Le===De.length)return[];if(B===Ae.length)return null;if(!o(De.charCodeAt(Le),Ae.charCodeAt(B))){const fe=i(De.charCodeAt(Le));if(!fe)return null;for(let ke=0;ke<fe.length;ke++)if(!o(fe[ke],Ae.charCodeAt(B+ke)))return null;H+=fe.length-1}let j=null,ne=B+H+1;if(j=D(De,Ae,Le+1,ne,x),!x)for(;!j&&(ne=P(Ae,ne))<Ae.length;)j=D(De,Ae,Le+1,ne,x),ne++;if(!j)return null;if(De.charCodeAt(Le)!==Ae.charCodeAt(B)){const fe=i(De.charCodeAt(Le));if(!fe)return j;for(let ke=0;ke<fe.length;ke++)if(fe[ke]!==Ae.charCodeAt(B+ke))return j}return t({start:B,end:B+H+1},j)}function P(De,Ae){for(let Le=Ae;Le<De.length;Le++)if(s(De.charCodeAt(Le))||Le>0&&s(De.charCodeAt(Le-1)))return Le;return De.length}const f=A(e.matchesPrefix,C,v),E=A(e.matchesPrefix,C,a),F=new T.LRUCache(1e4);function L(De,Ae,Le=!1){if(typeof De!="string"||typeof Ae!="string")return null;let B=F.get(De);B||(B=new RegExp(O.convertSimple2RegExpPattern(De),"i"),F.set(De,B));const x=B.exec(Ae);return x?[{start:x.index,end:x.index+x[0].length}]:Le?E(De,Ae):f(De,Ae)}function M(De,Ae){const Le=he(De,De.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?W(Le):null}function V(De,Ae,Le,B,x,H){const j=Math.min(13,De.length);for(;Le<j;Le++){const ne=he(De,Ae,Le,B,x,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,H]}function W(De){if(typeof De>"u")return[];const Ae=[],Le=De[1];for(let B=De.length-1;B>1;B--){const x=De[B]+Le,H=Ae[Ae.length-1];H&&H.end===x?H.end=x+1:Ae.push({start:x,end:x+1})}return Ae}const N=128;function Q(){const De=[],Ae=[];for(let Le=0;Le<=N;Le++)Ae[Le]=0;for(let Le=0;Le<=N;Le++)De.push(Ae.slice(0));return De}function Y(De){const Ae=[];for(let Le=0;Le<=De;Le++)Ae[Le]=0;return Ae}const ge=Y(2*N),Z=Y(2*N),me=Q(),se=Q(),le=Q(),Ee=!1;function oe(De,Ae,Le,B,x){function H(ne,fe,ke=" "){for(;ne.length<fe;)ne=ke+ne;return ne}let j=` |   |${B.split("").map(ne=>H(ne,3)).join("|")}
`;for(let ne=0;ne<=Le;ne++)ne===0?j+=" |":j+=`${Ae[ne-1]}|`,j+=De[ne].slice(0,x+1).map(fe=>H(fe.toString(),3)).join("|")+`
`;return j}function Ie(De,Ae,Le,B){De=De.substr(Ae),Le=Le.substr(B),console.log(oe(se,De,De.length,Le,Le.length)),console.log(oe(le,De,De.length,Le,Le.length)),console.log(oe(me,De,De.length,Le,Le.length))}function Me(De,Ae){if(Ae<0||Ae>=De.length)return!1;const Le=De.codePointAt(Ae);switch(Le){case S.CharCode.Underline:case S.CharCode.Dash:case S.CharCode.Period:case S.CharCode.Space:case S.CharCode.Slash:case S.CharCode.Backslash:case S.CharCode.SingleQuote:case S.CharCode.DoubleQuote:case S.CharCode.Colon:case S.CharCode.DollarSign:case S.CharCode.LessThan:case S.CharCode.GreaterThan:case S.CharCode.OpenParen:case S.CharCode.CloseParen:case S.CharCode.OpenSquareBracket:case S.CharCode.CloseSquareBracket:case S.CharCode.OpenCurlyBrace:case S.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(Le)}}function X(De,Ae){if(Ae<0||Ae>=De.length)return!1;switch(De.charCodeAt(Ae)){case S.CharCode.Space:case S.CharCode.Tab:return!0;default:return!1}}function $(De,Ae,Le){return Ae[De]!==Le[De]}function te(De,Ae,Le,B,x,H,j=!1){for(;Ae<Le&&x<H;)De[Ae]===B[x]&&(j&&(ge[Ae]=x),Ae+=1),x+=1;return Ae===Le}var Se;(function(De){De[De.Diag=1]="Diag",De[De.Left=2]="Left",De[De.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var ce;(function(De){De.Default=[-100,0];function Ae(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}De.isDefault=Ae})(ce||(e.FuzzyScore=ce={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Le){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Le}}e.FuzzyScoreOptions=be;function he(De,Ae,Le,B,x,H,j=be.default){const ne=De.length>N?N:De.length,fe=B.length>N?N:B.length;if(Le>=ne||H>=fe||ne-Le>fe-H||!te(Ae,Le,ne,x,H,fe,!0))return;G(ne,fe,Le,H,Ae,x);let ke=1,xe=1,qe=Le,Ze=H;const tt=[!1];for(ke=1,qe=Le;qe<ne;ke++,qe++){const lt=ge[qe],st=Z[qe],ct=qe+1<ne?Z[qe+1]:fe;for(xe=lt-H+1,Ze=lt;Ze<ct;xe++,Ze++){let gt=Number.MIN_SAFE_INTEGER,pt=!1;Ze<=st&&(gt=J(De,Ae,qe,Le,B,x,Ze,fe,H,me[ke-1][xe-1]===0,tt));let ze=0;gt!==Number.MAX_SAFE_INTEGER&&(pt=!0,ze=gt+se[ke-1][xe-1]);const Be=Ze>lt,ee=Be?se[ke][xe-1]+(me[ke][xe-1]>0?-5:0):0,q=Ze>lt+1&&me[ke][xe-1]>0,Ce=q?se[ke][xe-2]+(me[ke][xe-2]>0?-5:0):0;if(q&&(!Be||Ce>=ee)&&(!pt||Ce>=ze))se[ke][xe]=Ce,le[ke][xe]=Se.LeftLeft,me[ke][xe]=0;else if(Be&&(!pt||ee>=ze))se[ke][xe]=ee,le[ke][xe]=Se.Left,me[ke][xe]=0;else if(pt)se[ke][xe]=ze,le[ke][xe]=Se.Diag,me[ke][xe]=me[ke-1][xe-1]+1;else throw new Error("not possible")}}if(Ee&&Ie(De,Le,B,H),!tt[0]&&!j.firstMatchCanBeWeak)return;ke--,xe--;const nt=[se[ke][xe],H];let et=0,rt=0;for(;ke>=1;){let lt=xe;do{const st=le[ke][lt];if(st===Se.LeftLeft)lt=lt-2;else if(st===Se.Left)lt=lt-1;else break}while(lt>=1);et>1&&Ae[Le+ke-1]===x[H+xe-1]&&!$(lt+H-1,B,x)&&et+1>me[ke][lt]&&(lt=xe),lt===xe?et++:et=1,rt||(rt=lt),ke--,xe=lt-1,nt.push(xe)}fe-H===ne&&j.boostFullMatch&&(nt[0]+=2);const ft=rt-ne;return nt[0]-=ft,nt}function G(De,Ae,Le,B,x,H){let j=De-1,ne=Ae-1;for(;j>=Le&&ne>=B;)x[j]===H[ne]&&(Z[j]=ne,j--),ne--}function J(De,Ae,Le,B,x,H,j,ne,fe,ke,xe){if(Ae[Le]!==H[j])return Number.MIN_SAFE_INTEGER;let qe=1,Ze=!1;return j===Le-B?qe=De[Le]===x[j]?7:5:$(j,x,H)&&(j===0||!$(j-1,x,H))?(qe=De[Le]===x[j]?7:5,Ze=!0):Me(H,j)&&(j===0||!Me(H,j-1))?qe=5:(Me(H,j-1)||X(H,j-1))&&(qe=5,Ze=!0),qe>1&&Le===B&&(xe[0]=!0),Ze||(Ze=$(j,x,H)||Me(H,j-1)||X(H,j-1)),Le===B?j>fe&&(qe-=Ze?3:5):ke?qe+=Ze?2:0:qe+=Ze?0:1,j+1===ne&&(qe-=Ze?3:5),qe}function pe(De,Ae,Le,B,x,H,j){return Oe(De,Ae,Le,B,x,H,!0,j)}function ve(De,Ae,Le,B,x,H,j){return Oe(De,Ae,Le,B,x,H,!1,j)}function Oe(De,Ae,Le,B,x,H,j,ne){let fe=he(De,Ae,Le,B,x,H,ne);if(fe&&!j)return fe;if(De.length>=3){const ke=Math.min(7,De.length-1);for(let xe=Le+1;xe<ke;xe++){const qe=Ue(De,xe);if(qe){const Ze=he(qe,qe.toLowerCase(),Le,B,x,H,ne);Ze&&(Ze[0]-=3,(!fe||Ze[0]>fe[0])&&(fe=Ze))}}}return fe}function Ue(De,Ae){if(Ae+1>=De.length)return;const Le=De[Ae],B=De[Ae+1];if(Le!==B)return De.slice(0,Ae)+B+Le+De.slice(Ae+2)}}),define(Te[99],Pe([1,0,147,13,35]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=k,e.stripIcons=c,e.getCodiconAriaLabel=_,e.parseLabelWithIcons=n,e.matchesFuzzyIconAware=s;const O="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function v(o){return o.replace(R,(d,i)=>i?d:`\\${d}`)}const a=new RegExp(`\\\\${A.source}`,"g");function k(o){return o.replace(a,d=>`\\${d}`)}const w=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(o){return o.indexOf(O)===-1?o:o.replace(w,(d,i,r,t)=>r?d:i||t||"")}function _(o){return o?o.replace(/\$\((.*?)\)/g,(d,i)=>` ${i} `).trim():""}const h=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(o){h.lastIndex=0;let d="";const i=[];let r=0;for(;;){const t=h.lastIndex,l=h.exec(o),u=o.substring(t,l?.index);if(u.length>0){d+=u;for(let g=0;g<u.length;g++)i.push(r)}if(!l)break;r+=l[0].length}return{text:d,iconOffsets:i}}function s(o,d,i=!1){const{text:r,iconOffsets:t}=d;if(!t||t.length===0)return(0,S.matchesFuzzy)(o,r,i);const l=(0,T.ltrim)(r," "),u=r.length-l.length,g=(0,S.matchesFuzzy)(o,l,i);if(g)for(const m of g){const p=t[m.start+u]+u;m.start+=p,m.end+=p}return g}}),define(Te[36],Pe([1,0,13]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=$e(S);var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const O="error",A="warning",R="warn",v="info",a="ignore";function k(c){return c?S.equalsIgnoreCase(O,c)?I.Error:S.equalsIgnoreCase(A,c)||S.equalsIgnoreCase(R,c)?I.Warning:S.equalsIgnoreCase(v,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=k;function w(c){switch(c){case I.Error:return O;case I.Warning:return A;case I.Info:return v;default:return a}}I.toString=w}(T||(T={})),e.default=T}),define(Te[59],Pe([1,0,18,28,13]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const n=h.charCodeAt(0),s=this._value.charCodeAt(this._pos);return n-s}value(){return this._value[this._pos]}}e.StringIterator=O;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===T.CharCode.Period)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,I.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(h=!0,n=!0){this._splitOnBackslash=h,this._caseSensitive=n}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let n=h.length-1;n>=0;n--,this._valueLen--){const s=this._value.charCodeAt(n);if(!(s===T.CharCode.Slash||this._splitOnBackslash&&s===T.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===T.CharCode.Slash||this._splitOnBackslash&&n===T.CharCode.Backslash)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,I.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(v||(v={}));class a{constructor(h,n){this._ignorePathCasing=h,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===v.Scheme)return(0,I.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,I.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===v.Query)return(0,I.compare)(h,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,I.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=a;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(w||(w={}));class c{static forUris(h=()=>!1,n=()=>!1){return new c(new a(h,n))}static forPaths(h=!1){return new c(new R(void 0,!h))}static forStrings(){return new c(new O)}static forConfigKeys(){return new c(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,n){if(n){const s=n.slice(0);(0,S.shuffle)(s);for(const o of s)this.set(o,h)}else{const s=h.slice(0);(0,S.shuffle)(s);for(const o of s)this.set(o[0],o[1])}}set(h,n){const s=this._iter.reset(h);let o;this._root||(this._root=new k,this._root.segment=s.value());const d=[];for(o=this._root;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new k,o.left.segment=s.value()),d.push([w.Left,o]),o=o.left;else if(r<0)o.right||(o.right=new k,o.right.segment=s.value()),d.push([w.Right,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),d.push([w.Mid,o]),o=o.mid;else break}const i=o.value;o.value=n,o.key=h;for(let r=d.length-1;r>=0;r--){const t=d[r][1];t.updateHeight();const l=t.balanceFactor();if(l<-1||l>1){const u=d[r][0],g=d[r+1][0];if(u===w.Right&&g===w.Right)d[r][1]=t.rotateLeft();else if(u===w.Left&&g===w.Left)d[r][1]=t.rotateRight();else if(u===w.Right&&g===w.Left)t.right=d[r+1][1]=d[r+1][1].rotateRight(),d[r][1]=t.rotateLeft();else if(u===w.Left&&g===w.Right)t.left=d[r+1][1]=d[r+1][1].rotateLeft(),d[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(d[r-1][0]){case w.Left:d[r-1][1].left=d[r][1];break;case w.Right:d[r-1][1].right=d[r][1];break;case w.Mid:d[r-1][1].mid=d[r][1];break}else this._root=d[0][1]}}return i}get(h){return this._getNode(h)?.value}_getNode(h){const n=this._iter.reset(h);let s=this._root;for(;s;){const o=n.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(h){const n=this._getNode(h);return!(n?.value===void 0&&n?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,n){const s=this._iter.reset(h),o=[];let d=this._root;for(;d;){const i=s.cmp(d.segment);if(i>0)o.push([w.Left,d]),d=d.left;else if(i<0)o.push([w.Right,d]),d=d.right;else if(s.hasNext())s.next(),o.push([w.Mid,d]),d=d.mid;else break}if(d){if(n?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const i=this._min(d.right);if(i.key){const{key:r,value:t,segment:l}=i;this._delete(i.key,!1),d.key=r,d.value=t,d.segment=l}}else{const i=d.left??d.right;if(o.length>0){const[r,t]=o[o.length-1];switch(r){case w.Left:t.left=i;break;case w.Mid:t.mid=i;break;case w.Right:t.right=i;break}}else this._root=i}for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[i][1]=r.rotateRight()),i>0)switch(o[i-1][0]){case w.Left:o[i-1][1].left=o[i][1];break;case w.Right:o[i-1][1].right=o[i][1];break;case w.Mid:o[i-1][1].mid=o[i][1];break}else this._root=o[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const n=this._iter.reset(h);let s=this._root,o;for(;s;){const d=n.cmp(s.segment);if(d>0)s=s.left;else if(d<0)s=s.right;else if(n.hasNext())n.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,n){const s=this._iter.reset(h);let o=this._root;for(;o;){const d=s.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):n?o.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[n,s]of this)h(s,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const n=[];return this._dfsEntries(h,n),n[Symbol.iterator]()}_dfsEntries(h,n){h&&(h.left&&this._dfsEntries(h.left,n),h.value&&n.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,n),h.right&&this._dfsEntries(h.right,n))}_isBalanced(){const h=n=>{if(!n)return!0;const s=n.balanceFactor();return s<-1||s>1?!1:h(n.left)&&h(n.right)};return h(this._root)}}e.TernarySearchTree=c}),define(Te[37],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=T;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return S.test(I)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){I(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let v=0,a="";return a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a+="-",a+=A[O[v++]],a+=A[O[v++]],a+="-",a+=A[O[v++]],a+=A[O[v++]],a+="-",a+=A[O[v++]],a+=A[O[v++]],a+="-",a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a+=A[O[v++]],a}}()}),define(Te[148],Pe([1,0,18,40,37]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=O,e.createFileDataTransferItem=A,e.matchesMimeType=a;function O(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function A(w,c,_){const h={id:(0,I.generateUuid)(),name:w,uri:c,data:_};return{asString:async()=>"",asFile:()=>h,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let c=0;for(const _ of this._entries)c++;return c}has(c){return this._entries.has(this.toKey(c))}matches(c){const _=[...this._entries.keys()];return T.Iterable.some(this,([h,n])=>n.asFile())&&_.push("files"),k(v(c),_)}get(c){return this._entries.get(this.toKey(c))?.[0]}append(c,_){const h=this._entries.get(c);h?h.push(_):this._entries.set(this.toKey(c),[_])}replace(c,_){this._entries.set(this.toKey(c),[_])}delete(c){this._entries.delete(this.toKey(c))}*[Symbol.iterator](){for(const[c,_]of this._entries)for(const h of _)yield[c,h]}toKey(c){return v(c)}}e.VSDataTransfer=R;function v(w){return w.toLowerCase()}function a(w,c){return k(v(w),c.map(v))}function k(w,c){if(w==="*/*")return c.length>0;if(c.includes(w))return!0;const _=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!_)return!1;const[h,n,s]=_;return s==="*"?c.some(o=>o.startsWith(n+"/")):!1}e.UriList=Object.freeze({create:w=>(0,S.distinct)(w.map(c=>c.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.UriList.split(w).filter(c=>!c.startsWith("#"))})}),define(Te[149],Pe([1,0,28]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=I;var T;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function I(O){let A=0,R=0,v=0,a=T.Unknown;for(let k=0,w=O.length;k<w;k++){const c=O.charCodeAt(k);c===S.CharCode.CarriageReturn?(A===0&&(R=k),A++,k+1<w&&O.charCodeAt(k+1)===S.CharCode.LineFeed?(a|=T.CRLF,k++):a|=T.Invalid,v=k+1):c===S.CharCode.LineFeed&&(a|=T.LF,A===0&&(R=k),A++,v=k+1)}return A===0&&(R=O.length),[A,R,O.length-v,a]}}),define(Te[150],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[151],Pe([1,0,28,152]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(a){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=a.open,this.close=a.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(a.notIn))for(let k=0,w=a.notIn.length;k<w;k++)switch(a.notIn[k]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(a){switch(a){case T.StandardTokenType.Other:return!0;case T.StandardTokenType.Comment:return this._inComment;case T.StandardTokenType.String:return this._inString;case T.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(a,k){if(a.getTokenCount()===0)return!0;const w=a.findTokenIndexAtOffset(k-2),c=a.getStandardTokenType(w);return this.isOK(c)}_findNeutralCharacterInRange(a,k){for(let w=a;w<=k;w++){const c=String.fromCharCode(w);if(!this.open.includes(c)&&!this.close.includes(c))return c}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.Digit0,S.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.a,S.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.A,S.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of a)R(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),R(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),R(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),R(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&R(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.AutoClosingPairs=A;function R(v,a,k){v.has(a)?v.get(a).push(k):v.set(a,[k])}}),define(Te[153],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=I,e.righttest=O,e.leftRotate=a,e.rightRotate=k,e.rbDelete=w,e.fixInsert=c,e.updateTreeMetadata=_,e.recomputeTreeMetadata=h;class S{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return I(this.right);let s=this;for(;s.parent!==e.SENTINEL&&s.parent.left!==s;)s=s.parent;return s.parent===e.SENTINEL?e.SENTINEL:s.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let s=this;for(;s.parent!==e.SENTINEL&&s.parent.right!==s;)s=s.parent;return s.parent===e.SENTINEL?e.SENTINEL:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=S;var T;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(T||(e.NodeColor=T={})),e.SENTINEL=new S(null,T.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=T.Black;function I(n){for(;n.left!==e.SENTINEL;)n=n.left;return n}function O(n){for(;n.right!==e.SENTINEL;)n=n.right;return n}function A(n){return n===e.SENTINEL?0:n.size_left+n.piece.length+A(n.right)}function R(n){return n===e.SENTINEL?0:n.lf_left+n.piece.lineFeedCnt+R(n.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function a(n,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.SENTINEL&&(o.left.parent=s),o.parent=s.parent,s.parent===e.SENTINEL?n.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function k(n,s){const o=s.left;s.left=o.right,o.right!==e.SENTINEL&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.SENTINEL?n.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function w(n,s){let o,d;if(s.left===e.SENTINEL?(d=s,o=d.right):s.right===e.SENTINEL?(d=s,o=d.left):(d=I(s.right),o=d.right),d===n.root){n.root=o,o.color=T.Black,s.detach(),v(),n.root.parent=e.SENTINEL;return}const i=d.color===T.Red;if(d===d.parent.left?d.parent.left=o:d.parent.right=o,d===s?(o.parent=d.parent,h(n,o)):(d.parent===s?o.parent=d:o.parent=d.parent,h(n,o),d.left=s.left,d.right=s.right,d.parent=s.parent,d.color=s.color,s===n.root?n.root=d:s===s.parent.left?s.parent.left=d:s.parent.right=d,d.left!==e.SENTINEL&&(d.left.parent=d),d.right!==e.SENTINEL&&(d.right.parent=d),d.size_left=s.size_left,d.lf_left=s.lf_left,h(n,d)),s.detach(),o.parent.left===o){const t=A(o),l=R(o);if(t!==o.parent.size_left||l!==o.parent.lf_left){const u=t-o.parent.size_left,g=l-o.parent.lf_left;o.parent.size_left=t,o.parent.lf_left=l,_(n,o.parent,u,g)}}if(h(n,o.parent),i){v();return}let r;for(;o!==n.root&&o.color===T.Black;)o===o.parent.left?(r=o.parent.right,r.color===T.Red&&(r.color=T.Black,o.parent.color=T.Red,a(n,o.parent),r=o.parent.right),r.left.color===T.Black&&r.right.color===T.Black?(r.color=T.Red,o=o.parent):(r.right.color===T.Black&&(r.left.color=T.Black,r.color=T.Red,k(n,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=T.Black,r.right.color=T.Black,a(n,o.parent),o=n.root)):(r=o.parent.left,r.color===T.Red&&(r.color=T.Black,o.parent.color=T.Red,k(n,o.parent),r=o.parent.left),r.left.color===T.Black&&r.right.color===T.Black?(r.color=T.Red,o=o.parent):(r.left.color===T.Black&&(r.right.color=T.Black,r.color=T.Red,a(n,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=T.Black,r.left.color=T.Black,k(n,o.parent),o=n.root));o.color=T.Black,v()}function c(n,s){for(h(n,s);s!==n.root&&s.parent.color===T.Red;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===T.Red?(s.parent.color=T.Black,o.color=T.Black,s.parent.parent.color=T.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,a(n,s)),s.parent.color=T.Black,s.parent.parent.color=T.Red,k(n,s.parent.parent))}else{const o=s.parent.parent.left;o.color===T.Red?(s.parent.color=T.Black,o.color=T.Black,s.parent.parent.color=T.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,k(n,s)),s.parent.color=T.Black,s.parent.parent.color=T.Red,a(n,s.parent.parent))}n.root.color=T.Black}function _(n,s,o,d){for(;s!==n.root&&s!==e.SENTINEL;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=d),s=s.parent}function h(n,s){let o=0,d=0;if(s!==n.root){for(;s!==n.root&&s===s.parent.right;)s=s.parent;if(s!==n.root)for(s=s.parent,o=A(s.left)-s.size_left,d=R(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=d;s!==n.root&&(o!==0||d!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=d),s=s.parent}}}),define(Te[100],Pe([1,0,28,101,33,52,153,102]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=w,e.createLineStarts=c;const v=65535;function a(d){let i;return d[d.length-1]<65536?i=new Uint16Array(d.length):i=new Uint32Array(d.length),i.set(d,0),i}class k{constructor(i,r,t,l,u){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=l,this.isBasicASCII=u}}function w(d,i=!0){const r=[0];let t=1;for(let l=0,u=d.length;l<u;l++){const g=d.charCodeAt(l);g===S.CharCode.CarriageReturn?l+1<u&&d.charCodeAt(l+1)===S.CharCode.LineFeed?(r[t++]=l+2,l++):r[t++]=l+1:g===S.CharCode.LineFeed&&(r[t++]=l+1)}return i?a(r):r}function c(d,i){d.length=0,d[0]=0;let r=1,t=0,l=0,u=0,g=!0;for(let p=0,y=i.length;p<y;p++){const C=i.charCodeAt(p);C===S.CharCode.CarriageReturn?p+1<y&&i.charCodeAt(p+1)===S.CharCode.LineFeed?(u++,d[r++]=p+2,p++):(t++,d[r++]=p+1):C===S.CharCode.LineFeed?(l++,d[r++]=p+1):g&&C!==S.CharCode.Tab&&(C<32||C>126)&&(g=!1)}const m=new k(a(d),t,l,u,g);return d.length=0,m}class _{constructor(i,r,t,l,u){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=l,this.length=u}}e.Piece=_;class h{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.StringBuffer=h;class n{constructor(i,r){this._pieces=[],this._tree=i,this._BOM=r,this._index=0,i.root!==A.SENTINEL&&i.iterate(i.root,t=>(t!==A.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class s{constructor(i){this._limit=i,this._cache=[]}get(i){for(let r=this._cache.length-1;r>=0;r--){const t=this._cache[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this._cache.length-1;r>=0;r--){const t=this._cache[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let r=!1;const t=this._cache;for(let l=0;l<t.length;l++){const u=t[l];if(u.node.parent===null||u.nodeStartOffset>=i){t[l]=null,r=!0;continue}}if(r){const l=[];for(const u of t)u!==null&&l.push(u);this._cache=l}}}class o{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this._buffers=[new h("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=A.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=r,this._EOLLength=r.length,this._EOLNormalized=t;let l=null;for(let u=0,g=i.length;u<g;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=w(i[u].buffer));const m=new _(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this._buffers.push(i[u]),l=this.rbInsertRight(l,m)}this._searchCache=new s(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const r=v,t=r-Math.floor(r/3),l=t*2;let u="",g=0;const m=[];if(this.iterate(this.root,p=>{const y=this.getNodeContent(p),C=y.length;if(g<=t||g+C<l)return u+=y,g+=C,!0;const b=u.replace(/\r\n|\r|\n/g,i);return m.push(new h(b,w(b))),u=y,g=C,!0}),g>0){const p=u.replace(/\r\n|\r|\n/g,i);m.push(new h(p,w(p)))}this.create(m,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,l=>{if(l===A.SENTINEL)return!0;const u=this.getNodeContent(l),g=u.length,m=i.nodeAt(r),p=i.nodeAt(r+g),y=i.getValueInRange2(m,p);return r+=g,u===y})}getOffsetAt(i,r){let t=0,l=this.root;for(;l!==A.SENTINEL;)if(l.left!==A.SENTINEL&&l.lf_left+1>=i)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=i){t+=l.size_left;const u=this.getAccumulatedValue(l,i-l.lf_left-2);return t+=u+r-1}else i-=l.lf_left+l.piece.lineFeedCnt,t+=l.size_left+l.piece.length,l=l.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const l=i;for(;r!==A.SENTINEL;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const u=this.getIndexOf(r,i-r.size_left);if(t+=r.lf_left+u.index,u.index===0){const g=this.getOffsetAt(t+1,1),m=l-g;return new T.Position(t+1,m+1)}return new T.Position(t+1,u.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.SENTINEL){const u=this.getOffsetAt(t+1,1),g=l-i-u;return new T.Position(t+1,g+1)}else r=r.right;return new T.Position(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.nodeAt2(i.startLineNumber,i.startColumn),l=this.nodeAt2(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,l);return r?r!==this._EOL||!this._EOLNormalized?u.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this._EOLNormalized?u:u.replace(/\r\n|\r|\n/g,r):u}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,p=this._buffers[m.piece.bufferIndex].buffer,y=this.offsetInBuffer(m.piece.bufferIndex,m.piece.start);return p.substring(y+i.remainder,y+r.remainder)}let t=i.node;const l=this._buffers[t.piece.bufferIndex].buffer,u=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let g=l.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.SENTINEL;){const m=this._buffers[t.piece.bufferIndex].buffer,p=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===r.node){g+=m.substring(p,p+r.remainder);break}else g+=m.substr(p,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let r=0,t="",l=!1;return this.iterate(this.root,u=>{if(u===A.SENTINEL)return!0;const g=u.piece;let m=g.length;if(m===0)return!0;const p=this._buffers[g.bufferIndex].buffer,y=this._buffers[g.bufferIndex].lineStarts,C=g.start.line,b=g.end.line;let D=y[C]+g.start.column;if(l&&(p.charCodeAt(D)===S.CharCode.LineFeed&&(D++,m--),i[r++]=t,t="",l=!1,m===0))return!0;if(C===b)return!this._EOLNormalized&&p.charCodeAt(D+m-1)===S.CharCode.CarriageReturn?(l=!0,t+=p.substr(D,m-1)):t+=p.substr(D,m),!0;t+=this._EOLNormalized?p.substring(D,Math.max(D,y[C+1]-this._EOLLength)):p.substring(D,y[C+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=C+1;P<b;P++)t=this._EOLNormalized?p.substring(y[P],y[P+1]-this._EOLLength):p.substring(y[P],y[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this._EOLNormalized&&p.charCodeAt(y[b]+g.end.column-1)===S.CharCode.CarriageReturn?(l=!0,g.end.column===0?r--:t=p.substr(y[b],g.end.column-1)):t=p.substr(y[b],g.end.column),!0}),l&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this._buffers[r.piece.bufferIndex],l=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(l)}else{const r=this._buffers[i.node.piece.bufferIndex],l=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(l)}}getLineCharCode(i,r){const t=this.nodeAt2(i,r+1);return this._getCharCode(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const r=this.nodeAt(i);return this._getCharCode(r)}getNearestChunk(i){const r=this.nodeAt(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.SENTINEL)return"";const l=this._buffers[t.piece.bufferIndex],u=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return l.buffer.substring(u,u+t.piece.length)}else{const t=this._buffers[r.node.piece.bufferIndex],l=this.offsetInBuffer(r.node.piece.bufferIndex,r.node.piece.start),u=l+r.remainder,g=l+r.node.piece.length;return t.buffer.substring(u,g)}}findMatchesInNode(i,r,t,l,u,g,m,p,y,C,b){const D=this._buffers[i.piece.bufferIndex],P=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),f=this.offsetInBuffer(i.piece.bufferIndex,u),E=this.offsetInBuffer(i.piece.bufferIndex,g);let F;const L={line:0,column:0};let M,V;r._wordSeparators?(M=D.buffer.substring(f,E),V=W=>W+f,r.reset(0)):(M=D.buffer,V=W=>W,r.reset(f));do if(F=r.next(M),F){if(V(F.index)>=E)return C;this.positionInBuffer(i,V(F.index)-P,L);const W=this.getLineFeedCnt(i.piece.bufferIndex,u,L),N=L.line===u.line?L.column-u.column+l:L.column+1,Q=N+F[0].length;if(b[C++]=(0,R.createFindMatch)(new I.Range(t+W,N,t+W,Q),F,p),V(F.index)+F[0].length>=E||C>=y)return C}while(F);return C}findMatchesLineByLine(i,r,t,l){const u=[];let g=0;const m=new R.Searcher(r.wordSeparators,r.regex);let p=this.nodeAt2(i.startLineNumber,i.startColumn);if(p===null)return[];const y=this.nodeAt2(i.endLineNumber,i.endColumn);if(y===null)return[];let C=this.positionInBuffer(p.node,p.remainder);const b=this.positionInBuffer(y.node,y.remainder);if(p.node===y.node)return this.findMatchesInNode(p.node,m,i.startLineNumber,i.startColumn,C,b,r,t,l,g,u),u;let D=i.startLineNumber,P=p.node;for(;P!==y.node;){const E=this.getLineFeedCnt(P.piece.bufferIndex,C,P.piece.end);if(E>=1){const L=this._buffers[P.piece.bufferIndex].lineStarts,M=this.offsetInBuffer(P.piece.bufferIndex,P.piece.start),V=L[C.line+E],W=D===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(P,m,D,W,C,this.positionInBuffer(P,V-M),r,t,l,g,u),g>=l)return u;D+=E}const F=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const L=this.getLineContent(D).substring(F,i.endColumn-1);return g=this._findMatchesInLine(r,m,L,i.endLineNumber,F,g,u,t,l),u}if(g=this._findMatchesInLine(r,m,this.getLineContent(D).substr(F),D,F,g,u,t,l),g>=l)return u;D++,p=this.nodeAt2(D,1),P=p.node,C=this.positionInBuffer(p.node,p.remainder)}if(D===i.endLineNumber){const E=D===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(D).substring(E,i.endColumn-1);return g=this._findMatchesInLine(r,m,F,i.endLineNumber,E,g,u,t,l),u}const f=D===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(y.node,m,D,f,C,b,r,t,l,g,u),u}_findMatchesInLine(i,r,t,l,u,g,m,p,y){const C=i.wordSeparators;if(!p&&i.simpleSearch){const D=i.simpleSearch,P=D.length,f=t.length;let E=-P;for(;(E=t.indexOf(D,E+P))!==-1;)if((!C||(0,R.isValidMatch)(C,t,f,E,P))&&(m[g++]=new O.FindMatch(new I.Range(l,E+1+u,l,E+1+P+u),null),g>=y))return g;return g}let b;r.reset(0);do if(b=r.next(t),b&&(m[g++]=(0,R.createFindMatch)(new I.Range(l,b.index+1+u,l,b.index+1+b[0].length+u),b,p),g>=y))return g;while(b);return g}insert(i,r,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==A.SENTINEL){const{node:l,remainder:u,nodeStartOffset:g}=this.nodeAt(i),m=l.piece,p=m.bufferIndex,y=this.positionInBuffer(l,u);if(l.piece.bufferIndex===0&&m.end.line===this._lastChangeBufferPos.line&&m.end.column===this._lastChangeBufferPos.column&&g+m.length===i&&r.length<v){this.appendToNode(l,r),this.computeBufferMetadata();return}if(g===i)this.insertContentToNodeLeft(r,l),this._searchCache.validate(i);else if(g+l.piece.length>i){const C=[];let b=new _(m.bufferIndex,y,m.end,this.getLineFeedCnt(m.bufferIndex,y,m.end),this.offsetInBuffer(p,m.end)-this.offsetInBuffer(p,y));if(this.shouldCheckCRLF()&&this.endWithCR(r)&&this.nodeCharCodeAt(l,u)===10){const E={line:b.start.line+1,column:0};b=new _(b.bufferIndex,E,b.end,this.getLineFeedCnt(b.bufferIndex,E,b.end),b.length-1),r+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(r))if(this.nodeCharCodeAt(l,u-1)===13){const E=this.positionInBuffer(l,u-1);this.deleteNodeTail(l,E),r="\r"+r,l.piece.length===0&&C.push(l)}else this.deleteNodeTail(l,y);else this.deleteNodeTail(l,y);const D=this.createNewPieces(r);b.length>0&&this.rbInsertRight(l,b);let P=l;for(let f=0;f<D.length;f++)P=this.rbInsertRight(P,D[f]);this.deleteNodes(C)}else this.insertContentToNodeRight(r,l)}else{const l=this.createNewPieces(r);let u=this.rbInsertLeft(null,l[0]);for(let g=1;g<l.length;g++)u=this.rbInsertRight(u,l[g])}this.computeBufferMetadata()}delete(i,r){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",r<=0||this.root===A.SENTINEL)return;const t=this.nodeAt(i),l=this.nodeAt(i+r),u=t.node,g=l.node;if(u===g){const D=this.positionInBuffer(u,t.remainder),P=this.positionInBuffer(u,l.remainder);if(t.nodeStartOffset===i){if(r===u.piece.length){const f=u.next();(0,A.rbDelete)(this,u),this.validateCRLFWithPrevNode(f),this.computeBufferMetadata();return}this.deleteNodeHead(u,P),this._searchCache.validate(i),this.validateCRLFWithPrevNode(u),this.computeBufferMetadata();return}if(t.nodeStartOffset+u.piece.length===i+r){this.deleteNodeTail(u,D),this.validateCRLFWithNextNode(u),this.computeBufferMetadata();return}this.shrinkNode(u,D,P),this.computeBufferMetadata();return}const m=[],p=this.positionInBuffer(u,t.remainder);this.deleteNodeTail(u,p),this._searchCache.validate(i),u.piece.length===0&&m.push(u);const y=this.positionInBuffer(g,l.remainder);this.deleteNodeHead(g,y),g.piece.length===0&&m.push(g);const C=u.next();for(let D=C;D!==A.SENTINEL&&D!==g;D=D.next())m.push(D);const b=u.piece.length===0?u.prev():u;this.deleteNodes(m),this.validateCRLFWithNextNode(b),this.computeBufferMetadata()}insertContentToNodeLeft(i,r){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(r)){const g=r.piece,m={line:g.start.line+1,column:0},p=new _(g.bufferIndex,m,g.end,this.getLineFeedCnt(g.bufferIndex,m,g.end),g.length-1);r.piece=p,i+=`
`,(0,A.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const l=this.createNewPieces(i);let u=this.rbInsertLeft(r,l[l.length-1]);for(let g=l.length-2;g>=0;g--)u=this.rbInsertLeft(u,l[g]);this.validateCRLFWithPrevNode(u),this.deleteNodes(t)}insertContentToNodeRight(i,r){this.adjustCarriageReturnFromNext(i,r)&&(i+=`
`);const t=this.createNewPieces(i),l=this.rbInsertRight(r,t[0]);let u=l;for(let g=1;g<t.length;g++)u=this.rbInsertRight(u,t[g]);this.validateCRLFWithPrevNode(l)}positionInBuffer(i,r,t){const l=i.piece,u=i.piece.bufferIndex,g=this._buffers[u].lineStarts,p=g[l.start.line]+l.start.column+r;let y=l.start.line,C=l.end.line,b=0,D=0,P=0;for(;y<=C&&(b=y+(C-y)/2|0,P=g[b],b!==C);)if(D=g[b+1],p<P)C=b-1;else if(p>=D)y=b+1;else break;return t?(t.line=b,t.column=p-P,null):{line:b,column:p-P}}getLineFeedCnt(i,r,t){if(t.column===0)return t.line-r.line;const l=this._buffers[i].lineStarts;if(t.line===l.length-1)return t.line-r.line;const u=l[t.line+1],g=l[t.line]+t.column;if(u>g+1)return t.line-r.line;const m=g-1;return this._buffers[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}offsetInBuffer(i,r){return this._buffers[i].lineStarts[r.line]+r.column}deleteNodes(i){for(let r=0;r<i.length;r++)(0,A.rbDelete)(this,i[r])}createNewPieces(i){if(i.length>v){const C=[];for(;i.length>v;){const D=i.charCodeAt(v-1);let P;D===S.CharCode.CarriageReturn||D>=55296&&D<=56319?(P=i.substring(0,v-1),i=i.substring(v-1)):(P=i.substring(0,v),i=i.substring(v));const f=w(P);C.push(new _(this._buffers.length,{line:0,column:0},{line:f.length-1,column:P.length-f[f.length-1]},f.length-1,P.length)),this._buffers.push(new h(P,f))}const b=w(i);return C.push(new _(this._buffers.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this._buffers.push(new h(i,b)),C}let r=this._buffers[0].buffer.length;const t=w(i,!1);let l=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===r&&r!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},l=this._lastChangeBufferPos;for(let C=0;C<t.length;C++)t[C]+=r+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let C=0;C<t.length;C++)t[C]+=r;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=i}const u=this._buffers[0].buffer.length,g=this._buffers[0].lineStarts.length-1,m=u-this._buffers[0].lineStarts[g],p={line:g,column:m},y=new _(0,l,p,this.getLineFeedCnt(0,l,p),u-r);return this._lastChangeBufferPos=p,[y]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,r=0){let t=this.root,l="";const u=this._searchCache.get2(i);if(u){t=u.node;const g=this.getAccumulatedValue(t,i-u.nodeStartLineNumber-1),m=this._buffers[t.piece.bufferIndex].buffer,p=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)l=m.substring(p+g,p+t.piece.length);else{const y=this.getAccumulatedValue(t,i-u.nodeStartLineNumber);return m.substring(p+g,p+y-r)}}else{let g=0;const m=i;for(;t!==A.SENTINEL;)if(t.left!==A.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const p=this.getAccumulatedValue(t,i-t.lf_left-2),y=this.getAccumulatedValue(t,i-t.lf_left-1),C=this._buffers[t.piece.bufferIndex].buffer,b=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:g,nodeStartLineNumber:m-(i-1-t.lf_left)}),C.substring(b+p,b+y-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const p=this.getAccumulatedValue(t,i-t.lf_left-2),y=this._buffers[t.piece.bufferIndex].buffer,C=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);l=y.substring(C+p,C+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.SENTINEL;){const g=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.getAccumulatedValue(t,0),p=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return l+=g.substring(p,p+m-r),l}else{const m=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);l+=g.substr(m,t.piece.length)}t=t.next()}return l}computeBufferMetadata(){let i=this.root,r=1,t=0;for(;i!==A.SENTINEL;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this._lineCnt=r,this._length=t,this._searchCache.validate(this._length)}getIndexOf(i,r){const t=i.piece,l=this.positionInBuffer(i,r),u=l.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===r){const g=this.getLineFeedCnt(i.piece.bufferIndex,t.start,l);if(g!==u)return{index:g,remainder:0}}return{index:u,remainder:l.column}}getAccumulatedValue(i,r){if(r<0)return 0;const t=i.piece,l=this._buffers[t.bufferIndex].lineStarts,u=t.start.line+r+1;return u>t.end.line?l[t.end.line]+t.end.column-l[t.start.line]-t.start.column:l[u]-l[t.start.line]-t.start.column}deleteNodeTail(i,r){const t=i.piece,l=t.lineFeedCnt,u=this.offsetInBuffer(t.bufferIndex,t.end),g=r,m=this.offsetInBuffer(t.bufferIndex,g),p=this.getLineFeedCnt(t.bufferIndex,t.start,g),y=p-l,C=m-u,b=t.length+C;i.piece=new _(t.bufferIndex,t.start,g,p,b),(0,A.updateTreeMetadata)(this,i,C,y)}deleteNodeHead(i,r){const t=i.piece,l=t.lineFeedCnt,u=this.offsetInBuffer(t.bufferIndex,t.start),g=r,m=this.getLineFeedCnt(t.bufferIndex,g,t.end),p=this.offsetInBuffer(t.bufferIndex,g),y=m-l,C=u-p,b=t.length+C;i.piece=new _(t.bufferIndex,g,t.end,m,b),(0,A.updateTreeMetadata)(this,i,C,y)}shrinkNode(i,r,t){const l=i.piece,u=l.start,g=l.end,m=l.length,p=l.lineFeedCnt,y=r,C=this.getLineFeedCnt(l.bufferIndex,l.start,y),b=this.offsetInBuffer(l.bufferIndex,r)-this.offsetInBuffer(l.bufferIndex,u);i.piece=new _(l.bufferIndex,l.start,y,C,b),(0,A.updateTreeMetadata)(this,i,b-m,C-p);const D=new _(l.bufferIndex,t,g,this.getLineFeedCnt(l.bufferIndex,t,g),this.offsetInBuffer(l.bufferIndex,g)-this.offsetInBuffer(l.bufferIndex,t)),P=this.rbInsertRight(i,D);this.validateCRLFWithPrevNode(P)}appendToNode(i,r){this.adjustCarriageReturnFromNext(r,i)&&(r+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(r)&&this.endWithCR(i),l=this._buffers[0].buffer.length;this._buffers[0].buffer+=r;const u=w(r,!1);for(let P=0;P<u.length;P++)u[P]+=l;if(t){const P=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:l-P}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(u.slice(1));const g=this._buffers[0].lineStarts.length-1,m=this._buffers[0].buffer.length-this._buffers[0].lineStarts[g],p={line:g,column:m},y=i.piece.length+r.length,C=i.piece.lineFeedCnt,b=this.getLineFeedCnt(0,i.piece.start,p),D=b-C;i.piece=new _(i.piece.bufferIndex,i.piece.start,p,b,y),this._lastChangeBufferPos=p,(0,A.updateTreeMetadata)(this,i,r.length,D)}nodeAt(i){let r=this.root;const t=this._searchCache.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let l=0;for(;r!==A.SENTINEL;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){l+=r.size_left;const u={node:r,remainder:i-r.size_left,nodeStartOffset:l};return this._searchCache.set(u),u}else i-=r.size_left+r.piece.length,l+=r.size_left+r.piece.length,r=r.right;return null}nodeAt2(i,r){let t=this.root,l=0;for(;t!==A.SENTINEL;)if(t.left!==A.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.getAccumulatedValue(t,i-t.lf_left-2),g=this.getAccumulatedValue(t,i-t.lf_left-1);return l+=t.size_left,{node:t,remainder:Math.min(u+r-1,g),nodeStartOffset:l}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.getAccumulatedValue(t,i-t.lf_left-2);if(u+r-1<=t.piece.length)return{node:t,remainder:u+r-1,nodeStartOffset:l};r-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,l+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.SENTINEL;){if(t.piece.lineFeedCnt>0){const u=this.getAccumulatedValue(t,0),g=this.offsetOfNode(t);return{node:t,remainder:Math.min(r-1,u),nodeStartOffset:g}}else if(t.piece.length>=r-1){const u=this.offsetOfNode(t);return{node:t,remainder:r-1,nodeStartOffset:u}}else r-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this._buffers[i.piece.bufferIndex],l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(l)}offsetOfNode(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.SENTINEL||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this._buffers[r.bufferIndex].lineStarts,l=r.start.line,u=t[l]+r.start.column;return l===t.length-1||t[l+1]>u+1?!1:this._buffers[r.bufferIndex].buffer.charCodeAt(u)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const r=i.prev();this.endWithCR(r)&&this.fixCRLF(r,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const r=i.next();this.startWithLF(r)&&this.fixCRLF(i,r)}}fixCRLF(i,r){const t=[],l=this._buffers[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:l[i.piece.end.line]-l[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new _(i.piece.bufferIndex,i.piece.start,u,m,g),(0,A.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&t.push(i);const p={line:r.piece.start.line+1,column:0},y=r.piece.length-1,C=this.getLineFeedCnt(r.piece.bufferIndex,p,r.piece.end);r.piece=new _(r.piece.bufferIndex,p,r.piece.end,C,y),(0,A.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.createNewPieces(`\r
`);this.rbInsertRight(i,b[0]);for(let D=0;D<t.length;D++)(0,A.rbDelete)(this,t[D])}adjustCarriageReturnFromNext(i,r){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const t=r.next();if(this.startWithLF(t)){if(i+=`
`,t.piece.length===1)(0,A.rbDelete)(this,t);else{const l=t.piece,u={line:l.start.line+1,column:0},g=l.length-1,m=this.getLineFeedCnt(l.bufferIndex,u,l.end);t.piece=new _(l.bufferIndex,u,l.end,m,g),(0,A.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.SENTINEL)return r(A.SENTINEL);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}getNodeContent(i){if(i===A.SENTINEL)return"";const r=this._buffers[i.piece.bufferIndex],t=i.piece,l=this.offsetInBuffer(t.bufferIndex,t.start),u=this.offsetInBuffer(t.bufferIndex,t.end);return r.buffer.substring(l,u)}getPieceContent(i){const r=this._buffers[i.bufferIndex],t=this.offsetInBuffer(i.bufferIndex,i.start),l=this.offsetInBuffer(i.bufferIndex,i.end);return r.buffer.substring(t,l)}rbInsertRight(i,r){const t=new A.TreeNode(r,A.NodeColor.Red);if(t.left=A.SENTINEL,t.right=A.SENTINEL,t.parent=A.SENTINEL,t.size_left=0,t.lf_left=0,this.root===A.SENTINEL)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.SENTINEL)i.right=t,t.parent=i;else{const u=(0,A.leftest)(i.right);u.left=t,t.parent=u}return(0,A.fixInsert)(this,t),t}rbInsertLeft(i,r){const t=new A.TreeNode(r,A.NodeColor.Red);if(t.left=A.SENTINEL,t.right=A.SENTINEL,t.parent=A.SENTINEL,t.size_left=0,t.lf_left=0,this.root===A.SENTINEL)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.SENTINEL)i.left=t,t.parent=i;else{const l=(0,A.righttest)(i.left);l.right=t,t.parent=l}return(0,A.fixInsert)(this,t),t}getContentOfSubTree(i){let r="";return this.iterate(i,t=>(r+=this.getNodeContent(t),!0)),r}}e.PieceTreeBase=o}),define(Te[154],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const A=this._dragOperations.get(O);return this._dragOperations.delete(O),A}}addDragOperationTransfer(O,A){this._dragOperations.set(O,A)}}e.TreeViewsDnDService=S;class T{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=T}),define(Te[155],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(Te[156],Pe([1,0,6,4,155]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=k,I=$e(I);class O extends T.Disposable{constructor(c,_="",h="",n=!0,s){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=_,this._cssClass=h,this._enabled=n,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,_){this._actionCallback&&await this._actionCallback(c)}}e.Action=O;class A extends T.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(c,_){if(!c.enabled)return;this._onWillRun.fire({action:c});let h;try{await this.runAction(c,_)}catch(n){h=n}this._onDidRun.fire({action:c,error:h})}async runAction(c,_){await c.run(_)}}e.ActionRunner=A;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let _=[];for(const h of c)h.length&&(_.length?_=[..._,new R,...h]:_=h);return _}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class v{get actions(){return this._actions}constructor(c,_,h,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=_,this.class=n,this._actions=h}async run(){}}e.SubmenuAction=v;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,I.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=a;function k(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...c)=>w.run(...c)}}}),define(Te[157],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(Te[158],Pe([1,0,157]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=k,e.toLocalISOString=w;const T=60,I=T*60,O=I*24,A=O*7,R=O*30,v=O*365;function a(c,_,h,n){typeof c!="number"&&(c=c.getTime());const s=Math.round((new Date().getTime()-c)/1e3);if(s<-30)return(0,S.localize)(0,null,a(new Date().getTime()+s*1e3,!1));if(!n&&s<30)return(0,S.localize)(1,null);let o;return s<T?(o=s,_?o===1?h?(0,S.localize)(2,null,o):(0,S.localize)(3,null,o):h?(0,S.localize)(4,null,o):(0,S.localize)(5,null,o):o===1?h?(0,S.localize)(6,null,o):(0,S.localize)(7,null,o):h?(0,S.localize)(8,null,o):(0,S.localize)(9,null,o)):s<I?(o=Math.floor(s/T),_?o===1?h?(0,S.localize)(10,null,o):(0,S.localize)(11,null,o):h?(0,S.localize)(12,null,o):(0,S.localize)(13,null,o):o===1?h?(0,S.localize)(14,null,o):(0,S.localize)(15,null,o):h?(0,S.localize)(16,null,o):(0,S.localize)(17,null,o)):s<O?(o=Math.floor(s/I),_?o===1?h?(0,S.localize)(18,null,o):(0,S.localize)(19,null,o):h?(0,S.localize)(20,null,o):(0,S.localize)(21,null,o):o===1?h?(0,S.localize)(22,null,o):(0,S.localize)(23,null,o):h?(0,S.localize)(24,null,o):(0,S.localize)(25,null,o)):s<A?(o=Math.floor(s/O),_?o===1?(0,S.localize)(26,null,o):(0,S.localize)(27,null,o):o===1?(0,S.localize)(28,null,o):(0,S.localize)(29,null,o)):s<R?(o=Math.floor(s/A),_?o===1?h?(0,S.localize)(30,null,o):(0,S.localize)(31,null,o):h?(0,S.localize)(32,null,o):(0,S.localize)(33,null,o):o===1?h?(0,S.localize)(34,null,o):(0,S.localize)(35,null,o):h?(0,S.localize)(36,null,o):(0,S.localize)(37,null,o)):s<v?(o=Math.floor(s/R),_?o===1?h?(0,S.localize)(38,null,o):(0,S.localize)(39,null,o):h?(0,S.localize)(40,null,o):(0,S.localize)(41,null,o):o===1?h?(0,S.localize)(42,null,o):(0,S.localize)(43,null,o):h?(0,S.localize)(44,null,o):(0,S.localize)(45,null,o)):(o=Math.floor(s/v),_?o===1?h?(0,S.localize)(46,null,o):(0,S.localize)(47,null,o):h?(0,S.localize)(48,null,o):(0,S.localize)(49,null,o):o===1?h?(0,S.localize)(50,null,o):(0,S.localize)(51,null,o):h?(0,S.localize)(52,null,o):(0,S.localize)(53,null,o))}function k(c,_){const h=Math.abs(c/1e3);return h<1?_?(0,S.localize)(54,null,c):(0,S.localize)(55,null,c):h<T?_?(0,S.localize)(56,null,Math.round(c)/1e3):(0,S.localize)(57,null,Math.round(c)/1e3):h<I?_?(0,S.localize)(58,null,Math.round(c/(1e3*T))):(0,S.localize)(59,null,Math.round(c/(1e3*T))):h<O?_?(0,S.localize)(60,null,Math.round(c/(1e3*I))):(0,S.localize)(61,null,Math.round(c/(1e3*I))):(0,S.localize)(62,null,Math.round(c/(1e3*O)))}function w(c){return c.getFullYear()+"-"+String(c.getMonth()+1).padStart(2,"0")+"-"+String(c.getDate()).padStart(2,"0")+"T"+String(c.getHours()).padStart(2,"0")+":"+String(c.getMinutes()).padStart(2,"0")+":"+String(c.getSeconds()).padStart(2,"0")+"."+(c.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Te[159],Pe([9,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(Te[41],Pe([1,0,18,15,159]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=a,e.createErrorWithActions=k,S=$e(S),T=$e(T),I=$e(I);function O(w,c){return c&&(w.stack||w.stacktrace)?I.localize(0,null,R(w),A(w.stack)||A(w.stacktrace)):R(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?I.localize(1,null,w.message):w.message||I.localize(2,null)}function v(w=null,c=!1){if(!w)return I.localize(3,null);if(Array.isArray(w)){const _=S.coalesce(w),h=v(_[0],c);return _.length>1?I.localize(4,null,h,_.length):h}if(T.isString(w))return w;if(w.detail){const _=w.detail;if(_.error)return O(_.error,c);if(_.exception)return O(_.exception,c)}return w.stack?O(w,c):w.message?w.message:I.localize(5,null)}function a(w){const c=w;return c instanceof Error&&Array.isArray(c.actions)}function k(w,c){let _;return typeof w=="string"?_=new Error(w):_=w,_.actions=c,_}}),define(Te[160],Pe([1,0,48,20]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=v,e.compareFileNamesUpper=a,e.compareFileNamesLower=k,e.compareFileNamesUnicode=w,e.compareFileExtensions=c,e.compareFileExtensionsDefault=_,e.compareFileExtensionsUpper=h,e.compareFileExtensionsLower=n,e.compareFileExtensionsUnicode=s,e.comparePaths=p,e.compareAnything=y,e.compareByPrefix=C;const I=new S.Lazy(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(b,D,P=!1){const f=b||"",E=D||"",F=I.value.collator.compare(f,E);return I.value.collatorIsNumeric&&F===0&&f!==E?f<E?-1:1:F}function v(b,D){const P=O.value.collator;return b=b||"",D=D||"",r(P,b,D)}function a(b,D){const P=O.value.collator;return b=b||"",D=D||"",g(b,D)||r(P,b,D)}function k(b,D){const P=O.value.collator;return b=b||"",D=D||"",u(b,D)||r(P,b,D)}function w(b,D){return b=b||"",D=D||"",b===D?0:b<D?-1:1}function c(b,D){const[P,f]=d(b),[E,F]=d(D);let L=I.value.collator.compare(f,F);if(L===0){if(I.value.collatorIsNumeric&&f!==F)return f<F?-1:1;if(L=I.value.collator.compare(P,E),I.value.collatorIsNumeric&&L===0&&P!==E)return P<E?-1:1}return L}function _(b,D){b=b||"",D=D||"";const P=i(b),f=i(D),E=O.value.collator,F=A.value.collator;return r(F,P,f)||r(E,b,D)}function h(b,D){b=b||"",D=D||"";const P=i(b),f=i(D),E=O.value.collator,F=A.value.collator;return r(F,P,f)||g(b,D)||r(E,b,D)}function n(b,D){b=b||"",D=D||"";const P=i(b),f=i(D),E=O.value.collator,F=A.value.collator;return r(F,P,f)||u(b,D)||r(E,b,D)}function s(b,D){b=b||"",D=D||"";const P=i(b).toLowerCase(),f=i(D).toLowerCase();return P!==f?P<f?-1:1:b!==D?b<D?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function d(b,D=!1){const P=b?o.exec(b):[];let f=[P&&P[1]||"",P&&P[3]||""];return D&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const D=b?o.exec(b):[];return D&&D[1]&&D[1].charAt(0)!=="."&&D[3]||""}function r(b,D,P){const f=b.compare(D,P);return f!==0?f:D.length!==P.length?D.length<P.length?-1:1:0}function t(b){const D=b.charAt(0);return D.toLocaleUpperCase()!==D}function l(b){const D=b.charAt(0);return D.toLocaleLowerCase()!==D}function u(b,D){return t(b)&&l(D)?-1:l(b)&&t(D)?1:0}function g(b,D){return l(b)&&t(D)?-1:t(b)&&l(D)?1:0}function m(b,D,P=!1){return P||(b=b&&b.toLowerCase(),D=D&&D.toLowerCase()),b===D?0:b<D?-1:1}function p(b,D,P=!1){const f=b.split(T.sep),E=D.split(T.sep),F=f.length-1,L=E.length-1;let M,V;for(let W=0;;W++){if(M=F===W,V=L===W,M&&V)return R(f[W],E[W],P);if(M)return-1;if(V)return 1;const N=m(f[W],E[W],P);if(N!==0)return N}}function y(b,D,P){const f=b.toLowerCase(),E=D.toLowerCase(),F=C(b,D,P);if(F)return F;const L=f.endsWith(P),M=E.endsWith(P);if(L!==M)return L?-1:1;const V=R(f,E);return V!==0?V:f.localeCompare(E)}function C(b,D,P){const f=b.toLowerCase(),E=D.toLowerCase(),F=f.startsWith(P),L=E.startsWith(P);if(F!==L)return F?-1:1;if(F&&L){if(f.length<E.length)return-1;if(f.length>E.length)return 1}return 0}}),define(Te[53],Pe([1,0,28,20,21,13,15]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=v,e.toPosixPath=a,e.getRoot=k,e.isUNC=w,e.isValidBasename=n,e.isEqual=s,e.isEqualOrParent=o,e.isWindowsDriveLetter=d,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=r,e.isRootOrDriveLetter=t,e.hasDriveLetter=l,e.getDriveLetter=u,e.indexOfPath=g,e.parseLineAndColumnAware=m,e.randomPath=C;function R(b){return b===S.CharCode.Slash||b===S.CharCode.Backslash}function v(b){return b.replace(/[\\/]/g,T.posix.sep)}function a(b){return b.indexOf("/")===-1&&(b=v(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function k(b,D=T.posix.sep){if(!b)return"";const P=b.length,f=b.charCodeAt(0);if(R(f)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let F=3;const L=F;for(;F<P&&!R(b.charCodeAt(F));F++);if(L!==F&&!R(b.charCodeAt(F+1))){for(F+=1;F<P;F++)if(R(b.charCodeAt(F)))return b.slice(0,F+1).replace(/[\\/]/g,D)}}return D}else if(d(f)&&b.charCodeAt(1)===S.CharCode.Colon)return R(b.charCodeAt(2))?b.slice(0,2)+D:b.slice(0,2);let E=b.indexOf("://");if(E!==-1){for(E+=3;E<P;E++)if(R(b.charCodeAt(E)))return b.slice(0,E+1)}return""}function w(b){if(!I.isWindows||!b||b.length<5)return!1;let D=b.charCodeAt(0);if(D!==S.CharCode.Backslash||(D=b.charCodeAt(1),D!==S.CharCode.Backslash))return!1;let P=2;const f=P;for(;P<b.length&&(D=b.charCodeAt(P),D!==S.CharCode.Backslash);P++);return!(f===P||(D=b.charCodeAt(P+1),isNaN(D)||D===S.CharCode.Backslash))}const c=/[\\/:\*\?"<>\|]/g,_=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,D=I.isWindows){const P=D?c:_;return!(!b||b.length===0||/^\s+$/.test(b)||(P.lastIndex=0,P.test(b))||D&&h.test(b)||b==="."||b===".."||D&&b[b.length-1]==="."||D&&b.length!==b.trim().length||b.length>255)}function s(b,D,P){const f=b===D;return!P||f?f:!b||!D?!1:(0,O.equalsIgnoreCase)(b,D)}function o(b,D,P,f=T.sep){if(b===D)return!0;if(!b||!D||D.length>b.length)return!1;if(P){if(!(0,O.startsWithIgnoreCase)(b,D))return!1;if(D.length===b.length)return!0;let F=D.length;return D.charAt(D.length-1)===f&&F--,b.charAt(F)===f}return D.charAt(D.length-1)!==f&&(D+=f),b.indexOf(D)===0}function d(b){return b>=S.CharCode.A&&b<=S.CharCode.Z||b>=S.CharCode.a&&b<=S.CharCode.z}function i(b,D){return I.isWindows&&b.endsWith(":")&&(b+=T.sep),(0,T.isAbsolute)(b)||(b=(0,T.join)(D,b)),b=(0,T.normalize)(b),r(b)}function r(b){return I.isWindows?(b=(0,O.rtrim)(b,T.sep),b.endsWith(":")&&(b+=T.sep)):(b=(0,O.rtrim)(b,T.sep),b||(b=T.sep)),b}function t(b){const D=(0,T.normalize)(b);return I.isWindows?b.length>3?!1:l(D)&&(b.length===2||D.charCodeAt(2)===S.CharCode.Backslash):D===T.posix.sep}function l(b,D=I.isWindows){return D?d(b.charCodeAt(0))&&b.charCodeAt(1)===S.CharCode.Colon:!1}function u(b,D=I.isWindows){return l(b,D)?b[0]:void 0}function g(b,D,P){return D.length>b.length?-1:b===D?0:(P&&(b=b.toLowerCase(),D=D.toLowerCase()),b.indexOf(D))}function m(b){const D=b.split(":");let P,f,E;for(const F of D){const L=Number(F);(0,A.isNumber)(L)?f===void 0?f=L:E===void 0&&(E=L):P=P?[P,F].join(":"):F}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:f!==void 0?f:void 0,column:E!==void 0?E:f!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(b,D,P=8){let f="";for(let F=0;F<P;F++){let L;F===0&&I.isWindows&&!D&&(P===3||P===4)?L=y:L=p,f+=L.charAt(Math.floor(Math.random()*L.length))}let E;return D?E=`${D}-${f}`:E=f,b?(0,T.join)(b,E):E}}),define(Te[73],Pe([1,0,20]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=A,e.getExtensionForMimeType=R,e.normalizeMimeType=a,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(k){const w=(0,S.extname)(k),c=T[w.toLowerCase()];return c!==void 0?c:A(k)}function A(k){const w=(0,S.extname)(k);return I[w.toLowerCase()]}function R(k){for(const w in I)if(I[w]===k)return w}const v=/^(.+)\/(.+?)(;.+)?$/;function a(k,w){const c=v.exec(k);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:w?void 0:k}}),define(Te[49],Pe([1,0,23,2,38]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=O,e.parse=A,e.revive=v;function O(a){return JSON.stringify(a,R)}function A(a){let k=JSON.parse(a);return k=v(k),k}function R(a,k){return k instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function v(a,k=0){if(!a||k>200)return a;if(typeof a=="object"){switch(a.$mid){case I.MarshalledId.Uri:return T.URI.revive(a);case I.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case I.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let w=0;w<a.length;++w)a[w]=v(a[w],k+1);else for(const w in a)Object.hasOwnProperty.call(a,w)&&(a[w]=v(a[w],k+1))}return a}}),define(Te[16],Pe([1,0,14,21,13,2,20]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=a,e.getServerRootPath=w,S=$e(S),T=$e(T),A=$e(A);var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function v(h,n){return O.URI.isUri(h)?(0,I.equalsIgnoreCase)(h.scheme,n):(0,I.startsWithIgnoreCase)(h,n+":")}function a(h,...n){return n.some(s=>v(h,s))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(n){this._preferredWebSchema=n}setDelegate(n){this._delegate=n}setServerRootPath(n,s){this._serverRootPath=w(n,s)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(n,s,o){this._hosts[n]=s,this._ports[n]=o}setConnectionToken(n,s){this._connectionTokens[n]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(n){if(this._delegate)try{return this._delegate(n)}catch(t){return S.onUnexpectedError(t),n}const s=n.authority;let o=this._hosts[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const d=this._ports[s],i=this._connectionTokens[s];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),O.URI.from({scheme:T.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${o}:${d}`,path:this._remoteResourcesPath,query:r})}}e.RemoteAuthorities=new k;function w(h,n){return A.posix.join(n??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class c{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(n){const s=this.toUri(n,ae);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===R.file&&(T.isNative||T.webWorkerOrigin===`${R.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?n.with({scheme:R.vscodeFileResource,authority:n.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(n){const s=this.toUri(n,ae);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==c.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(n,s){return O.URI.isUri(n)?n:O.URI.parse(s.toUrl(n))}}e.FileAccess=new c;var _;(function(h){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(s);if(t)return n.get(t)}h.getHeadersFromQuery=o;function d(i,r,t){if(!globalThis.crossOriginIsolated)return;const l=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,l):i[s]=l}h.addSearchParam=d})(_||(e.COI=_={}))}),define(Te[24],Pe([1,0,28,53,16,20,21,13,2]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=a,e.distinctParents=w,e.toLocalResource=_,T=$e(T),O=$e(O);function a(h){return(0,v.uriToFsPath)(h,!0)}class k{constructor(n){this._ignorePathCasing=n}compare(n,s,o=!1){return n===s?0:(0,R.compare)(this.getComparisonKey(n,o),this.getComparisonKey(s,o))}isEqual(n,s,o=!1){return n===s?!0:!n||!s?!1:this.getComparisonKey(n,o)===this.getComparisonKey(s,o)}getComparisonKey(n,s=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,s,o=!1){if(n.scheme===s.scheme){if(n.scheme===I.Schemas.file)return T.isEqualOrParent(a(n),a(s),this._ignorePathCasing(n))&&n.query===s.query&&(o||n.fragment===s.fragment);if((0,e.isEqualAuthority)(n.authority,s.authority))return T.isEqualOrParent(n.path,s.path,this._ignorePathCasing(n),"/")&&n.query===s.query&&(o||n.fragment===s.fragment)}return!1}joinPath(n,...s){return v.URI.joinPath(n,...s)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return O.posix.basename(n.path)}extname(n){return O.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let s;return n.scheme===I.Schemas.file?s=v.URI.file(O.dirname(a(n))).path:(s=O.posix.dirname(n.path),n.authority&&s.length&&s.charCodeAt(0)!==S.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),s="/")),n.with({path:s})}normalizePath(n){if(!n.path.length)return n;let s;return n.scheme===I.Schemas.file?s=v.URI.file(O.normalize(a(n))).path:s=O.posix.normalize(n.path),n.with({path:s})}relativePath(n,s){if(n.scheme!==s.scheme||!(0,e.isEqualAuthority)(n.authority,s.authority))return;if(n.scheme===I.Schemas.file){const i=O.relative(a(n),a(s));return A.isWindows?T.toSlashes(i):i}let o=n.path||"/";const d=s.path||"/";if(this._ignorePathCasing(n)){let i=0;for(const r=Math.min(o.length,d.length);i<r&&!(o.charCodeAt(i)!==d.charCodeAt(i)&&o.charAt(i).toLowerCase()!==d.charAt(i).toLowerCase());i++);o=d.substr(0,i)+o.substr(i)}return O.posix.relative(o,d)}resolvePath(n,s){if(n.scheme===I.Schemas.file){const o=v.URI.file(O.resolve(a(n),s));return n.with({authority:o.authority,path:o.path})}return s=T.toPosixPath(s),n.with({path:O.posix.resolve(n.path,s)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,s){return n===s||n!==void 0&&s!==void 0&&(0,R.equalsIgnoreCase)(n,s)}hasTrailingPathSeparator(n,s=O.sep){if(n.scheme===I.Schemas.file){const o=a(n);return o.length>T.getRoot(o).length&&o[o.length-1]===s}else{const o=n.path;return o.length>1&&o.charCodeAt(o.length-1)===S.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,s=O.sep){return(0,e.hasTrailingPathSeparator)(n,s)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,s=O.sep){let o=!1;if(n.scheme===I.Schemas.file){const d=a(n);o=d!==void 0&&d.length===T.getRoot(d).length&&d[d.length-1]===s}else{s="/";const d=n.path;o=d.length===1&&d.charCodeAt(d.length-1)===S.CharCode.Slash}return!o&&!(0,e.hasTrailingPathSeparator)(n,s)?n.with({path:n.path+"/"}):n}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===I.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(h,n){const s=[];for(let o=0;o<h.length;o++){const d=n(h[o]);h.some((i,r)=>r===o?!1:(0,e.isEqualOrParent)(d,n(i)))||s.push(h[o])}return s}var c;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function n(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,l]=r.split(":");t&&l&&o.set(t,l)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&o.set(h.META_DATA_MIME,i),o}h.parseMetaData=n})(c||(e.DataUri=c={}));function _(h,n,s){if(n){let o=h.path;return o&&o[0]!==O.posix.sep&&(o=O.posix.sep+o),h.with({scheme:s,authority:n,path:o})}return h.with({scheme:s})}}),define(Te[11],Pe([1,0,22,14,6,4,24,21,146,48]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=k,e.createCancelablePromise=w,e.raceCancellation=c,e.raceCancellationError=_,e.raceCancellablePromises=h,e.raceTimeout=n,e.asPromise=s,e.promiseWithResolvers=o,e.timeout=y,e.disposableTimeout=C,e.sequence=b,e.first=D,e.firstParallel=P,e.retry=me,e.createCancelableAsyncIterable=ce;function k(he){return!!he&&typeof he.then=="function"}function w(he){const G=new S.CancellationTokenSource,J=he(G.token),pe=new Promise((ve,Oe)=>{const Ue=G.token.onCancellationRequested(()=>{Ue.dispose(),Oe(new T.CancellationError)});Promise.resolve(J).then(De=>{Ue.dispose(),G.dispose(),ve(De)},De=>{Ue.dispose(),G.dispose(),Oe(De)})});return new class{cancel(){G.cancel(),G.dispose()}then(ve,Oe){return pe.then(ve,Oe)}catch(ve){return this.then(void 0,ve)}finally(ve){return pe.finally(ve)}}}function c(he,G,J){return new Promise((pe,ve)=>{const Oe=G.onCancellationRequested(()=>{Oe.dispose(),pe(J)});he.then(pe,ve).finally(()=>Oe.dispose())})}function _(he,G){return new Promise((J,pe)=>{const ve=G.onCancellationRequested(()=>{ve.dispose(),pe(new T.CancellationError)});he.then(J,pe).finally(()=>ve.dispose())})}async function h(he){let G=-1;const J=he.map((pe,ve)=>pe.then(Oe=>(G=ve,Oe)));try{return await Promise.race(J)}finally{he.forEach((pe,ve)=>{ve!==G&&pe.cancel()})}}function n(he,G,J){let pe;const ve=setTimeout(()=>{pe?.(void 0),J?.()},G);return Promise.race([he.finally(()=>clearTimeout(ve)),new Promise(Oe=>pe=Oe)])}function s(he){return new Promise((G,J)=>{const pe=he();k(pe)?pe.then(G,J):G(pe)})}function o(){let he,G;return{promise:new Promise((pe,ve)=>{he=pe,G=ve}),resolve:he,reject:G}}class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,pe};this.queuedPromise=new Promise(pe=>{this.activePromise.then(J,J).then(pe)})}return new Promise((J,pe)=>{this.queuedPromise.then(J,pe)})}return this.activePromise=G(),new Promise((J,pe)=>{this.activePromise.then(ve=>{this.activePromise=null,J(ve)},ve=>{this.activePromise=null,pe(ve)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class i{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=i;class r{constructor(){this.promiseMap=new Map}queue(G,J){const ve=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(G)===ve&&this.promiseMap.delete(G)});return this.promiseMap.set(G,ve),ve}}e.SequencerByKey=r;const t=(he,G)=>{let J=!0;const pe=setTimeout(()=>{J=!1,G()},he);return{isTriggered:()=>J,dispose:()=>{clearTimeout(pe),J=!1}}},l=he=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,he())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class u{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,J=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ve,Oe)=>{this.doResolve=ve,this.doReject=Oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ve=this.task;return this.task=null,ve()}}));const pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===v.MicrotaskDelay?l(pe):t(J,pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class g{constructor(G){this.delayer=new u(G),this.throttler=new d}trigger(G,J){return this.delayer.trigger(()=>this.throttler.queue(G),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=g;class m{constructor(){this._isOpen=!1,this._promise=new Promise((G,J)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class p extends m{constructor(G){super(),this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function y(he,G){return G?new Promise((J,pe)=>{const ve=setTimeout(()=>{Oe.dispose(),J()},he),Oe=G.onCancellationRequested(()=>{clearTimeout(ve),Oe.dispose(),pe(new T.CancellationError)})}):w(J=>y(he,J))}function C(he,G=0,J){const pe=setTimeout(()=>{he(),J&&ve.dispose()},G),ve=(0,O.toDisposable)(()=>{clearTimeout(pe),J?.deleteAndLeak(ve)});return J?.add(ve),ve}function b(he){const G=[];let J=0;const pe=he.length;function ve(){return J<pe?he[J++]():null}function Oe(Ue){Ue!=null&&G.push(Ue);const De=ve();return De?De.then(Oe):Promise.resolve(G)}return Promise.resolve(null).then(Oe)}function D(he,G=pe=>!!pe,J=null){let pe=0;const ve=he.length,Oe=()=>{if(pe>=ve)return Promise.resolve(J);const Ue=he[pe++];return Promise.resolve(Ue()).then(Ae=>G(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function P(he,G=pe=>!!pe,J=null){if(he.length===0)return Promise.resolve(J);let pe=he.length;const ve=()=>{pe=-1;for(const Oe of he)Oe.cancel?.()};return new Promise((Oe,Ue)=>{for(const De of he)De.then(Ae=>{--pe>=0&&G(Ae)?(ve(),Oe(Ae)):pe===0&&Oe(J)}).catch(Ae=>{--pe>=0&&(ve(),Ue(Ae))})})}class f{constructor(G){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((J,pe)=>{this.outstandingPromises.push({factory:G,c:J,e:pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const J=G.factory();J.then(G.c,G.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=f;class E extends f{constructor(){super(1)}}e.Queue=E;class F{constructor(){this.sequentializer=new se,this.tasks=0}queue(G){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,G())):this.sequentializer.run(this.tasks++,G())}}e.LimitedQueue=F;class L{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const G=new oe;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueSize(G,J=A.extUri){const pe=J.getComparisonKey(G);return this.queues.get(pe)?.size??0}queueFor(G,J,pe=A.extUri){const ve=pe.getComparisonKey(G);let Oe=this.queues.get(ve);if(!Oe){Oe=new E;const Ue=this.drainListenerCount++,De=I.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.queues.delete(ve),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ue),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(Ue,De),this.queues.set(ve,Oe)}return Oe.queue(J)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=L;class M{constructor(G,J){this._isDisposed=!1,this._token=-1,typeof G=="function"&&typeof J=="number"&&this.setIfNotSet(G,J)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,J){if(this._isDisposed)throw new T.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},J)}setIfNotSet(G,J){if(this._isDisposed)throw new T.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},J))}}e.TimeoutTimer=M;class V{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(G,J,pe=globalThis){if(this.isDisposed)throw new T.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ve=pe.setInterval(()=>{G()},J);this.disposable=(0,O.toDisposable)(()=>{pe.clearInterval(ve),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=V;class W{constructor(G,J){this.timeoutToken=-1,this.runner=G,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class N{constructor(G,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class Q extends W{constructor(G,J){super(G,J),this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner?.(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class Y extends O.Disposable{constructor(G,J){super(),this.options=G,this.handler=J,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of G)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(he,G)=>{(0,R.setTimeout0)(()=>{if(J)return;const pe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e._runWhenIdle=(he,G,J)=>{const pe=he.requestIdleCallback(G,typeof J=="number"?{timeout:J}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,he.cancelIdleCallback(pe))}}},e.runWhenGlobalIdle=he=>(0,e._runWhenIdle)(globalThis,he)}();class ge{constructor(G,J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(G,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ge;class Z extends ge{constructor(G){super(globalThis,G)}}e.GlobalIdleValue=Z;async function me(he,G,J){let pe;for(let ve=0;ve<J;ve++)try{return await he()}catch(Oe){pe=Oe,await y(G)}throw pe}class se{isRunning(G){return typeof G=="number"?this._running?.taskId===G:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(G,J,pe){return this._running={taskId:G,cancel:()=>pe?.(),promise:J},J.then(()=>this.doneRunning(G),()=>this.doneRunning(G)),J}doneRunning(G){this._running&&G===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const G=this._queued;this._queued=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this._queued)this._queued.run=G;else{const{promise:J,resolve:pe,reject:ve}=o();this._queued={run:G,promise:J,promiseResolve:pe,promiseReject:ve}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=se;class le{constructor(G,J=()=>Date.now()){this.interval=G,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var Ee;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(Ee||(Ee={}));class oe{get isRejected(){return this.outcome?.outcome===Ee.Rejected}get isResolved(){return this.outcome?.outcome===Ee.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Ee.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((G,J)=>{this.completeCallback=G,this.errorCallback=J})}complete(G){return new Promise(J=>{this.completeCallback(G),this.outcome={outcome:Ee.Resolved,value:G},J()})}error(G){return new Promise(J=>{this.errorCallback(G),this.outcome={outcome:Ee.Rejected,value:G},J()})}cancel(){return this.error(new T.CancellationError)}}e.DeferredPromise=oe;var Ie;(function(he){async function G(pe){let ve;const Oe=await Promise.all(pe.map(Ue=>Ue.then(De=>De,De=>{ve||(ve=De)})));if(typeof ve<"u")throw ve;return Oe}he.settled=G;function J(pe){return new Promise(async(ve,Oe)=>{try{await pe(ve,Oe)}catch(Ue){Oe(Ue)}})}he.withAsyncBody=J})(Ie||(e.Promises=Ie={}));class Me{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(G){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=G.then(J=>(this._value=J,this._isResolved=!0,J),J=>{throw this._error=J,this._isResolved=!0,J})}requireValue(){if(!this._isResolved)throw new T.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=Me;class X{constructor(G){this._compute=G,this._promise=new a.Lazy(()=>new Me(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=X;var $;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})($||($={}));class te{static fromArray(G){return new te(J=>{J.emitMany(G)})}static fromPromise(G){return new te(async J=>{J.emitMany(await G)})}static fromPromises(G){return new te(async J=>{await Promise.all(G.map(async pe=>J.emitOne(await pe)))})}static merge(G){return new te(async J=>{await Promise.all(G.map(async pe=>{for await(const ve of pe)J.emitOne(ve)}))})}static{this.EMPTY=te.fromArray([])}constructor(G,J){this._state=$.Initial,this._results=[],this._error=null,this._onReturn=J,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const pe={emitOne:ve=>this.emitOne(ve),emitMany:ve=>this.emitMany(ve),reject:ve=>this.reject(ve)};try{await Promise.resolve(G(pe)),this.resolve()}catch(ve){this.reject(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===$.DoneError)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===$.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(G,J){return new te(async pe=>{for await(const ve of G)pe.emitOne(J(ve))})}map(G){return te.map(this,G)}static filter(G,J){return new te(async pe=>{for await(const ve of G)J(ve)&&pe.emitOne(ve)})}filter(G){return te.filter(this,G)}static coalesce(G){return te.filter(G,J=>!!J)}coalesce(){return te.coalesce(this)}static async toPromise(G){const J=[];for await(const pe of G)J.push(pe);return J}toPromise(){return te.toPromise(this)}emitOne(G){this._state===$.Initial&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===$.Initial&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===$.Initial&&(this._state=$.DoneOK,this._onStateChanged.fire())}reject(G){this._state===$.Initial&&(this._state=$.DoneError,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=te;class Se extends te{constructor(G,J){super(J),this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Se;function ce(he){const G=new S.CancellationTokenSource,J=he(G.token);return new Se(G,async pe=>{const ve=G.token.onCancellationRequested(()=>{ve.dispose(),G.dispose(),pe.reject(new T.CancellationError)});try{for await(const Oe of J){if(G.token.isCancellationRequested)return;pe.emitOne(Oe)}ve.dispose(),G.dispose()}catch(Oe){ve.dispose(),G.dispose(),pe.reject(Oe)}})}class be{constructor(G){this._deferred=new oe,this._asyncIterable=new te(ve=>{if(J){ve.reject(J);return}return pe&&ve.emitMany(pe),this._errorFn=Oe=>ve.reject(Oe),this._emitFn=Oe=>ve.emitOne(Oe),this._deferred.p},G);let J,pe;this._emitFn=ve=>{pe||(pe=[]),pe.push(ve)},this._errorFn=ve=>{J||(J=ve)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(G){this._errorFn(G),this._deferred.complete()}emitOne(G){this._emitFn(G)}}e.AsyncIterableSource=be}),define(Te[42],Pe([1,0,18,11,28,53,29,20,21,13]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=k,e.splitGlobAware=n,e.match=F,e.parse=L,e.isRelativePattern=M,e.getBasenameTerms=V,e.getPathTerms=W,e.patternsEquals=ge;function k(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",c="[^/\\\\]",_=/\//g;function h(Z,me){switch(Z){case 0:return"";case 1:return`${c}*?`;default:return`(?:${w}|${c}+${w}${me?`|${w}${c}+`:""})*?`}}function n(Z,me){if(!Z)return[];const se=[];let le=!1,Ee=!1,oe="";for(const Ie of Z){switch(Ie){case me:if(!le&&!Ee){se.push(oe),oe="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}oe+=Ie}return oe&&se.push(oe),se}function s(Z){if(!Z)return"";let me="";const se=n(Z,e.GLOB_SPLIT);if(se.every(le=>le===e.GLOBSTAR))me=".*";else{let le=!1;se.forEach((Ee,oe)=>{if(Ee===e.GLOBSTAR){if(le)return;me+=h(2,oe===se.length-1)}else{let Ie=!1,Me="",X=!1,$="";for(const te of Ee){if(te!=="}"&&Ie){Me+=te;continue}if(X&&(te!=="]"||!$)){let Se;te==="-"?Se=te:(te==="^"||te==="!")&&!$?Se="^":te===e.GLOB_SPLIT?Se="":Se=(0,a.escapeRegExpCharacters)(te),$+=Se;continue}switch(te){case"{":Ie=!0;continue;case"[":X=!0;continue;case"}":{const ce=`(?:${n(Me,",").map(be=>s(be)).join("|")})`;me+=ce,Ie=!1,Me="";break}case"]":{me+="["+$+"]",X=!1,$="";break}case"?":me+=c;continue;case"*":me+=h(1);continue;default:me+=(0,a.escapeRegExpCharacters)(te)}}oe<se.length-1&&(se[oe+1]!==e.GLOBSTAR||oe+2<se.length)&&(me+=w)}le=Ee===e.GLOBSTAR})}return me}const o=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.LRUCache(1e4),g=function(){return!1},m=function(){return null};function p(Z,me){if(!Z)return m;let se;typeof Z!="string"?se=Z.pattern:se=Z,se=se.trim();const le=`${se}_${!!me.trimForExclusions}`;let Ee=u.get(le);if(Ee)return y(Ee,Z);let oe;return o.test(se)?Ee=b(se.substr(4),se):(oe=d.exec(C(se,me)))?Ee=D(oe[1],se):(me.trimForExclusions?r:i).test(se)?Ee=P(se,me):(oe=t.exec(C(se,me)))?Ee=f(oe[1].substr(1),se,!0):(oe=l.exec(C(se,me)))?Ee=f(oe[1],se,!1):Ee=E(se),u.set(le,Ee),y(Ee,Z)}function y(Z,me){if(typeof me=="string")return Z;const se=function(le,Ee){return(0,O.isEqualOrParent)(le,me.base,!v.isLinux)?Z((0,a.ltrim)(le.substr(me.base.length),R.sep),Ee):null};return se.allBasenames=Z.allBasenames,se.allPaths=Z.allPaths,se.basenames=Z.basenames,se.patterns=Z.patterns,se}function C(Z,me){return me.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function b(Z,me){return function(se,le){return typeof se=="string"&&se.endsWith(Z)?me:null}}function D(Z,me){const se=`/${Z}`,le=`\\${Z}`,Ee=function(Ie,Me){return typeof Ie!="string"?null:Me?Me===Z?me:null:Ie===Z||Ie.endsWith(se)||Ie.endsWith(le)?me:null},oe=[Z];return Ee.basenames=oe,Ee.patterns=[me],Ee.allBasenames=oe,Ee}function P(Z,me){const se=Y(Z.slice(1,-1).split(",").map(Me=>p(Me,me)).filter(Me=>Me!==m),Z),le=se.length;if(!le)return m;if(le===1)return se[0];const Ee=function(Me,X){for(let $=0,te=se.length;$<te;$++)if(se[$](Me,X))return Z;return null},oe=se.find(Me=>!!Me.allBasenames);oe&&(Ee.allBasenames=oe.allBasenames);const Ie=se.reduce((Me,X)=>X.allPaths?Me.concat(X.allPaths):Me,[]);return Ie.length&&(Ee.allPaths=Ie),Ee}function f(Z,me,se){const le=R.sep===R.posix.sep,Ee=le?Z:Z.replace(_,R.sep),oe=R.sep+Ee,Ie=R.posix.sep+Z;let Me;return se?Me=function(X,$){return typeof X=="string"&&(X===Ee||X.endsWith(oe)||!le&&(X===Z||X.endsWith(Ie)))?me:null}:Me=function(X,$){return typeof X=="string"&&(X===Ee||!le&&X===Z)?me:null},Me.allPaths=[(se?"*/":"./")+Z],Me}function E(Z){try{const me=new RegExp(`^${s(Z)}$`);return function(se){return me.lastIndex=0,typeof se=="string"&&me.test(se)?Z:null}}catch{return m}}function F(Z,me,se){return!Z||typeof me!="string"?!1:L(Z)(me,void 0,se)}function L(Z,me={}){if(!Z)return g;if(typeof Z=="string"||M(Z)){const se=p(Z,me);if(se===m)return g;const le=function(Ee,oe){return!!se(Ee,oe)};return se.allBasenames&&(le.allBasenames=se.allBasenames),se.allPaths&&(le.allPaths=se.allPaths),le}return N(Z,me)}function M(Z){const me=Z;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function V(Z){return Z.allBasenames||[]}function W(Z){return Z.allPaths||[]}function N(Z,me){const se=Y(Object.getOwnPropertyNames(Z).map(Me=>Q(Me,Z[Me],me)).filter(Me=>Me!==m)),le=se.length;if(!le)return m;if(!se.some(Me=>!!Me.requiresSiblings)){if(le===1)return se[0];const Me=function(te,Se){let ce;for(let be=0,he=se.length;be<he;be++){const G=se[be](te,Se);if(typeof G=="string")return G;(0,T.isThenable)(G)&&(ce||(ce=[]),ce.push(G))}return ce?(async()=>{for(const be of ce){const he=await be;if(typeof he=="string")return he}return null})():null},X=se.find(te=>!!te.allBasenames);X&&(Me.allBasenames=X.allBasenames);const $=se.reduce((te,Se)=>Se.allPaths?te.concat(Se.allPaths):te,[]);return $.length&&(Me.allPaths=$),Me}const Ee=function(Me,X,$){let te,Se;for(let ce=0,be=se.length;ce<be;ce++){const he=se[ce];he.requiresSiblings&&$&&(X||(X=(0,R.basename)(Me)),te||(te=X.substr(0,X.length-(0,R.extname)(Me).length)));const G=he(Me,X,te,$);if(typeof G=="string")return G;(0,T.isThenable)(G)&&(Se||(Se=[]),Se.push(G))}return Se?(async()=>{for(const ce of Se){const be=await ce;if(typeof be=="string")return be}return null})():null},oe=se.find(Me=>!!Me.allBasenames);oe&&(Ee.allBasenames=oe.allBasenames);const Ie=se.reduce((Me,X)=>X.allPaths?Me.concat(X.allPaths):Me,[]);return Ie.length&&(Ee.allPaths=Ie),Ee}function Q(Z,me,se){if(me===!1)return m;const le=p(Z,se);if(le===m)return m;if(typeof me=="boolean")return le;if(me){const Ee=me.when;if(typeof Ee=="string"){const oe=(Ie,Me,X,$)=>{if(!$||!le(Ie,Me))return null;const te=Ee.replace("$(basename)",()=>X),Se=$(te);return(0,T.isThenable)(Se)?Se.then(ce=>ce?Z:null):Se?Z:null};return oe.requiresSiblings=!0,oe}}return le}function Y(Z,me){const se=Z.filter(Me=>!!Me.basenames);if(se.length<2)return Z;const le=se.reduce((Me,X)=>{const $=X.basenames;return $?Me.concat($):Me},[]);let Ee;if(me){Ee=[];for(let Me=0,X=le.length;Me<X;Me++)Ee.push(me)}else Ee=se.reduce((Me,X)=>{const $=X.patterns;return $?Me.concat($):Me},[]);const oe=function(Me,X){if(typeof Me!="string")return null;if(!X){let te;for(te=Me.length;te>0;te--){const Se=Me.charCodeAt(te-1);if(Se===I.CharCode.Slash||Se===I.CharCode.Backslash)break}X=Me.substr(te)}const $=le.indexOf(X);return $!==-1?Ee[$]:null};oe.basenames=le,oe.patterns=Ee,oe.allBasenames=le;const Ie=Z.filter(Me=>!Me.basenames);return Ie.push(oe),Ie}function ge(Z,me){return(0,S.equals)(Z,me,(se,le)=>typeof se=="string"&&typeof le=="string"?se===le:typeof se!="string"&&typeof le!="string"?se.base===le.base&&se.pattern===le.pattern:!1)}}),define(Te[60],Pe([1,0,14,99,24,13,2]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=a,e.isMarkdownString=k,e.markdownStringEqual=w,e.escapeMarkdownSyntaxTokens=c,e.appendEscapedMarkdownCodeBlockFence=_,e.escapeDoubleQuotes=h,e.removeMarkdownEscapes=n,e.parseHrefAndDimensions=s;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(d="",i=!1){if(this.value=d,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(d,i=R.Paragraph){return this.value+=c(this.supportThemeIcons?(0,T.escapeIcons)(d):d).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,i){return this.value+=`
${_(i,d)}
`,this}appendLink(d,i,r){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(d),")"),r&&(this.value+=` "${this._escape(this._escape(r,'"'),")")}"`),this.value+=")",this}_escape(d,i){const r=new RegExp((0,O.escapeRegExpCharacters)(i),"g");return d.replace(r,(t,l)=>d.charAt(l-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=v;function a(o){return k(o)?!o.value:Array.isArray(o)?o.every(a):!0}function k(o){return o instanceof v?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function w(o,d){return o===d?!0:!o||!d?!1:o.value===d.value&&o.isTrusted===d.isTrusted&&o.supportThemeIcons===d.supportThemeIcons&&o.supportHtml===d.supportHtml&&(o.baseUri===d.baseUri||!!o.baseUri&&!!d.baseUri&&(0,I.isEqual)(A.URI.from(o.baseUri),A.URI.from(d.baseUri)))}function c(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function _(o,d){const i=o.match(/^`+/gm)?.reduce((t,l)=>t.length>l.length?t:l).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${d}`,o,`${"`".repeat(r)}`].join(`
`)}function h(o){return o.replace(/"/g,"&quot;")}function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const d=[],i=o.split("|").map(t=>t.trim());o=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),l=/width=(\d+)/.exec(r),u=t?t[1]:"",g=l?l[1]:"",m=isFinite(parseInt(g)),p=isFinite(parseInt(u));m&&d.push(`width="${g}"`),p&&d.push(`height="${u}"`)}return{href:o,dimensions:d}}}),define(Te[103],Pe([1,0,18,53,20,21,24,13]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=k,e.tildify=c,e.untildify=_,e.shorten=o,e.template=i,e.mnemonicMenuLabel=r,e.mnemonicButtonLabel=t,e.unmnemonicLabel=l,e.splitRecentLabel=u;function v(m,p){const{os:y,tildify:C,relative:b}=p;if(b){const f=a(m,b,y);if(typeof f=="string")return f}let D=m.fsPath;if(y===O.OperatingSystem.Windows&&!O.isWindows?D=D.replace(/\//g,"\\"):y!==O.OperatingSystem.Windows&&O.isWindows&&(D=D.replace(/\\/g,"/")),y!==O.OperatingSystem.Windows&&C?.userHome){const f=C.userHome.fsPath;let E;m.scheme!==C.userHome.scheme&&m.path[0]===I.posix.sep&&m.path[1]!==I.posix.sep?E=C.userHome.with({path:m.path}).fsPath:E=D,D=c(E,f,y)}return(y===O.OperatingSystem.Windows?I.win32:I.posix).normalize(k(D,y===O.OperatingSystem.Windows))}function a(m,p,y){const C=y===O.OperatingSystem.Windows?I.win32:I.posix,b=y===O.OperatingSystem.Linux?A.extUri:A.extUriIgnorePathCase,D=p.getWorkspace(),P=(0,S.firstOrDefault)(D.folders);if(!P)return;m.scheme!==P.uri.scheme&&m.path[0]===I.posix.sep&&m.path[1]!==I.posix.sep&&(m=P.uri.with({path:m.path}));const f=p.getWorkspaceFolder(m);if(!f)return;let E;if(b.isEqual(f.uri,m)?E="":E=b.relativePath(f.uri,m)??"",E&&(E=C.normalize(E)),D.folders.length>1&&!p.noPrefix){const F=f.name?f.name:b.basenameOrAuthority(f.uri);E=E?`${F} \u2022 ${E}`:F}return E}function k(m,p=O.isWindows){return(0,T.hasDriveLetter)(m,p)?m.charAt(0).toUpperCase()+m.slice(1):m}let w=Object.create(null);function c(m,p,y=O.OS){if(y===O.OperatingSystem.Windows||!m||!p)return m;let C=w.original===p?w.normalized:void 0;C||(C=p,O.isWindows&&(C=(0,T.toSlashes)(C)),C=`${(0,R.rtrim)(C,I.posix.sep)}${I.posix.sep}`,w={original:p,normalized:C});let b=m;return O.isWindows&&(b=(0,T.toSlashes)(b)),(y===O.OperatingSystem.Linux?b.startsWith(C):(0,R.startsWithIgnoreCase)(b,C))?`~/${b.substr(C.length)}`:m}function _(m,p){return m.replace(/^~($|\/|\\)/,`${p}$1`)}const h="\u2026",n="\\\\",s="~";function o(m,p=I.sep){const y=new Array(m.length);let C=!1;for(let b=0;b<m.length;b++){const D=m[b];if(D===""){y[b]=`.${p}`;continue}if(!D){y[b]=D;continue}C=!0;let P="",f=D;f.indexOf(n)===0?(P=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf(p)===0?(P=f.substr(0,f.indexOf(p)+p.length),f=f.substr(f.indexOf(p)+p.length)):f.indexOf(s)===0&&(P=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const E=f.split(p);for(let F=1;C&&F<=E.length;F++)for(let L=E.length-F;C&&L>=0;L--){C=!1;let M=E.slice(L,L+F).join(p);for(let V=0;!C&&V<m.length;V++)if(V!==b&&m[V]&&m[V].indexOf(M)>-1){const W=L+F===E.length,N=L>0&&m[V].indexOf(p)>-1?p+M:M,Q=m[V].endsWith(N);C=!W||Q}if(!C){let V="";(E[0].endsWith(":")||P!=="")&&(L===1&&(L=0,F++,M=E[0]+p+M),L>0&&(V=E[0]+p),V=P+V),L>0&&(V=V+h+p),V=V+M,L+F<E.length&&(V=V+p+h),y[b]=V}}C&&(y[b]=D)}return y}var d;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function i(m,p=Object.create(null)){const y=[];let C=!1,b="";for(const D of m)if(D==="$"||C&&D==="{")b&&y.push({value:b,type:d.TEXT}),b="",C=!0;else if(D==="}"&&C){const P=p[b];if(typeof P=="string")P.length&&y.push({value:P,type:d.VARIABLE});else if(P){const f=y[y.length-1];(!f||f.type!==d.SEPARATOR)&&y.push({value:P.label,type:d.SEPARATOR})}b="",C=!1}else b+=D;return b&&!C&&y.push({value:b,type:d.TEXT}),y.filter((D,P)=>{if(D.type===d.SEPARATOR){const f=y[P-1],E=y[P+1];return[f,E].every(F=>F&&(F.type===d.VARIABLE||F.type===d.TEXT)&&F.value.length>0)}return!0}).map(D=>D.value).join("")}function r(m,p){return O.isMacintosh||p?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):m.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function t(m,p){return O.isMacintosh||p?m.replace(/\(&&\w\)|&&/g,""):O.isWindows?m.replace(/&&|&/g,y=>y==="&"?"&&":"&"):m.replace(/&&/g,"_")}function l(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const p=m.lastIndexOf(" [",m.length-2);if(p!==-1){const y=g(m.substring(0,p)),C=m.substring(p);return{name:y.name+C,parentPath:y.parentPath}}}return g(m)}function g(m){const p=m.indexOf("/")!==-1?I.posix:I.win32,y=p.basename(m),C=p.dirname(m);return y.length?{name:y,parentPath:C}:{name:C,parentPath:""}}}),define(Te[161],Pe([1,0,23,38,2]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=k,e.transformAndReviveIncomingURIs=w;function O(c){return c.toJSON()}class A{constructor(_){this._uriTransformer=_}transformIncoming(_){const h=this._uriTransformer.transformIncoming(_);return h===_?_:O(I.URI.from(h))}transformOutgoing(_){const h=this._uriTransformer.transformOutgoing(_);return h===_?_:O(I.URI.from(h))}transformOutgoingURI(_){const h=this._uriTransformer.transformOutgoing(_);return h===_?_:I.URI.from(h)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function R(c,_,h){if(!c||h>200)return null;if(typeof c=="object"){if(c instanceof I.URI)return _.transformOutgoing(c);for(const n in c)if(Object.hasOwnProperty.call(c,n)){const s=R(c[n],_,h+1);s!==null&&(c[n]=s)}}return null}function v(c,_){const h=R(c,_,0);return h===null?c:h}function a(c,_,h,n){if(!c||n>200)return null;if(typeof c=="object"){if(c.$mid===T.MarshalledId.Uri)return h?I.URI.revive(_.transformIncoming(c)):_.transformIncoming(c);if(c instanceof S.VSBuffer)return null;for(const s in c)if(Object.hasOwnProperty.call(c,s)){const o=a(c[s],_,h,n+1);o!==null&&(c[s]=o)}}return null}function k(c,_){const h=a(c,_,!1,0);return h===null?c:h}function w(c,_){const h=a(c,_,!0,0);return h===null?c:h}}),define(Te[162],Pe([1,0,11,6,4,49,15]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var R;(function(c){c[c.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",c[c.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(c){const _=c;return _?.changed instanceof Map||_?.deleted instanceof Set}var a;(function(c){c[c.None=0]="None",c[c.Initialized=1]="Initialized",c[c.Closed=2]="Closed"})(a||(e.StorageState=a={}));class k extends I.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(_,h=Object.create(null)){super(),this.database=_,this.options=h,this._onDidChangeStorage=this._register(new T.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new S.ThrottledDelayer(k.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(_=>this.onDidChangeItemsExternal(_)))}onDidChangeItemsExternal(_){this._onDidChangeStorage.pause();try{_.changed?.forEach((h,n)=>this.acceptExternal(n,h)),_.deleted?.forEach(h=>this.acceptExternal(h,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(_,h){if(this.state===a.Closed)return;let n=!1;(0,A.isUndefinedOrNull)(h)?n=this.cache.delete(_):this.cache.get(_)!==h&&(this.cache.set(_,h),n=!0),n&&this._onDidChangeStorage.fire({key:_,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(_,h){const n=this.cache.get(_);return(0,A.isUndefinedOrNull)(n)?h:n}getBoolean(_,h){const n=this.get(_);return(0,A.isUndefinedOrNull)(n)?h:n==="true"}getNumber(_,h){const n=this.get(_);return(0,A.isUndefinedOrNull)(n)?h:parseInt(n,10)}getObject(_,h){const n=this.get(_);return(0,A.isUndefinedOrNull)(n)?h:(0,O.parse)(n)}async set(_,h,n=!1){if(this.state===a.Closed)return;if((0,A.isUndefinedOrNull)(h))return this.delete(_,n);const s=(0,A.isObject)(h)||Array.isArray(h)?(0,O.stringify)(h):String(h);if(this.cache.get(_)!==s)return this.cache.set(_,s),this.pendingInserts.set(_,s),this.pendingDeletes.delete(_),this._onDidChangeStorage.fire({key:_,external:n}),this.doFlush()}async delete(_,h=!1){if(!(this.state===a.Closed||!this.cache.delete(_)))return this.pendingDeletes.has(_)||this.pendingDeletes.add(_),this.pendingInserts.delete(_),this._onDidChangeStorage.fire({key:_,external:h}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const _={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(_).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(_){if(!(this.state===a.Closed||this.pendingClose))return this.doFlush(_)}async doFlush(_){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),_)}async whenFlushed(){if(this.hasPending)return new Promise(_=>this.whenFlushedCallbacks.push(_))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=k;class w{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(_){_.insert?.forEach((h,n)=>this.items.set(n,h)),_.delete?.forEach(h=>this.items.delete(h))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(Te[163],Pe([1,0,13,21,23]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=k,e.decodeUTF16LE=w,S=$e(S),T=$e(T),I=$e(I);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let R;function v(){return R||(R=new TextDecoder("UTF-16BE")),R}let a;function k(){return a||(a=T.isLittleEndian()?A():v()),a}function w(h,n,s){const o=new Uint16Array(h.buffer,n,s);return s>0&&(o[0]===65279||o[0]===65534)?c(h,n,s):A().decode(o)}function c(h,n,s){const o=[];let d=0;for(let i=0;i<s;i++){const r=I.readUInt16LE(h,n);n+=2,o[d++]=String.fromCharCode(r)}return o.join("")}class _{constructor(n){this._capacity=n|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const n=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return k().decode(n)}_flushBuffer(){const n=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[n]:this._completedStrings[this._completedStrings.length]=n}appendCharCode(n){const s=this._capacity-this._bufferLength;s<=1&&(s===0||S.isHighSurrogate(n))&&this._flushBuffer(),this._buffer[this._bufferLength++]=n}appendASCIICharCode(n){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=n}appendString(n){const s=n.length;if(this._bufferLength+s>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=n;return}for(let o=0;o<s;o++)this._buffer[this._bufferLength++]=n.charCodeAt(o)}}e.StringBuilder=_}),define(Te[164],Pe([1,0,23,163]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=A,S=$e(S);function I(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,k,w,c){this.oldPosition=a,this.oldText=k,this.newPosition=w,this.newText=c}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static _writeStringSize(a){return 4+2*a.length}static _writeString(a,k,w){const c=k.length;S.writeUInt32BE(a,c,w),w+=4;for(let _=0;_<c;_++)S.writeUInt16LE(a,k.charCodeAt(_),w),w+=2;return w}static _readString(a,k){const w=S.readUInt32BE(a,k);return k+=4,(0,T.decodeUTF16LE)(a,k,w)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(a,k){return S.writeUInt32BE(a,this.oldPosition,k),k+=4,S.writeUInt32BE(a,this.newPosition,k),k+=4,k=O._writeString(a,this.oldText,k),k=O._writeString(a,this.newText,k),k}static read(a,k,w){const c=S.readUInt32BE(a,k);k+=4;const _=S.readUInt32BE(a,k);k+=4;const h=O._readString(a,k);k+=O._writeStringSize(h);const n=O._readString(a,k);return k+=O._writeStringSize(n),w.push(new O(c,h,_,n)),k}}e.TextChange=O;function A(v,a){return v===null||v.length===0?a:new R(v,a).compress()}class R{constructor(a,k){this._prevEdits=a,this._currEdits=k,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let a=0,k=0,w=this._getPrev(a),c=this._getCurr(k);for(;a<this._prevLen||k<this._currLen;){if(w===null){this._acceptCurr(c),c=this._getCurr(++k);continue}if(c===null){this._acceptPrev(w),w=this._getPrev(++a);continue}if(c.oldEnd<=w.newPosition){this._acceptCurr(c),c=this._getCurr(++k);continue}if(w.newEnd<=c.oldPosition){this._acceptPrev(w),w=this._getPrev(++a);continue}if(c.oldPosition<w.newPosition){const[o,d]=R._splitCurr(c,w.newPosition-c.oldPosition);this._acceptCurr(o),c=d;continue}if(w.newPosition<c.oldPosition){const[o,d]=R._splitPrev(w,c.oldPosition-w.newPosition);this._acceptPrev(o),w=d;continue}let n,s;if(c.oldEnd===w.newEnd)n=w,s=c,w=this._getPrev(++a),c=this._getCurr(++k);else if(c.oldEnd<w.newEnd){const[o,d]=R._splitPrev(w,c.oldLength);n=o,s=c,w=d,c=this._getCurr(++k)}else{const[o,d]=R._splitCurr(c,w.newLength);n=w,s=o,w=this._getPrev(++a),c=d}this._result[this._resultLen++]=new O(n.oldPosition,n.oldText,s.newPosition,s.newText),this._prevDeltaOffset+=n.newLength-n.oldLength,this._currDeltaOffset+=s.newLength-s.oldLength}const _=R._merge(this._result);return R._removeNoOps(_)}_acceptCurr(a){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,a),this._currDeltaOffset+=a.newLength-a.oldLength}_getCurr(a){return a<this._currLen?this._currEdits[a]:null}_acceptPrev(a){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,a),this._prevDeltaOffset+=a.newLength-a.oldLength}_getPrev(a){return a<this._prevLen?this._prevEdits[a]:null}static _rebaseCurr(a,k){return new O(k.oldPosition-a,k.oldText,k.newPosition,k.newText)}static _rebasePrev(a,k){return new O(k.oldPosition,k.oldText,k.newPosition+a,k.newText)}static _splitPrev(a,k){const w=a.newText.substr(0,k),c=a.newText.substr(k);return[new O(a.oldPosition,a.oldText,a.newPosition,w),new O(a.oldEnd,"",a.newPosition+k,c)]}static _splitCurr(a,k){const w=a.oldText.substr(0,k),c=a.oldText.substr(k);return[new O(a.oldPosition,w,a.newPosition,a.newText),new O(a.oldPosition+k,c,a.newEnd,"")]}static _merge(a){if(a.length===0)return a;const k=[];let w=0,c=a[0];for(let _=1;_<a.length;_++){const h=a[_];c.oldEnd===h.oldPosition?c=new O(c.oldPosition,c.oldText+h.oldText,c.newPosition,c.newText+h.newText):(k[w++]=c,c=h)}return k[w++]=c,k}static _removeNoOps(a){if(a.length===0)return a;const k=[];let w=0;for(let c=0;c<a.length;c++){const _=a[c];_.oldText!==_.newText&&(k[w++]=_)}return k}}}),define(Te[165],Pe([1,0,42,20]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=I,e.targetsNotebooks=O;function I(A,R,v,a,k,w){if(Array.isArray(A)){let c=0;for(const _ of A){const h=I(_,R,v,a,k,w);if(h===10)return h;h>c&&(c=h)}return c}else{if(typeof A=="string")return a?A==="*"?5:A===v?10:0:0;if(A){const{language:c,pattern:_,scheme:h,hasAccessToAllModels:n,notebookType:s}=A;if(!a&&!n)return 0;s&&k&&(R=k);let o=0;if(h)if(h===R.scheme)o=10;else if(h==="*")o=5;else return 0;if(c)if(c===v)o=10;else if(c==="*")o=Math.max(o,5);else return 0;if(s)if(s===w)o=10;else if(s==="*"&&w!==void 0)o=Math.max(o,5);else return 0;if(_){let d;if(typeof _=="string"?d=_:d={..._,base:(0,T.normalize)(_.base)},d===R.fsPath||(0,S.match)(d,R.fsPath))o=10;else return 0}return o}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Te[166],Pe([1,0,6,13,33,52,100,149,164,4]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,T=$e(T);class k extends a.Disposable{constructor(c,_,h,n,s,o,d){super(),this._onDidChangeContent=this._register(new S.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=_,this._mightContainNonBasicASCII=!o,this._mightContainRTL=n,this._mightContainUnusualLineTerminators=s,this._pieceTree=new A.PieceTreeBase(c,h,d)}equals(c){return!(c instanceof k)||this._BOM!==c._BOM||this.getEOL()!==c.getEOL()?!1:this._pieceTree.equal(c._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(c){return this._pieceTree.createSnapshot(c?this._BOM:"")}getOffsetAt(c,_){return this._pieceTree.getOffsetAt(c,_)}getPositionAt(c){return this._pieceTree.getPositionAt(c)}getRangeAt(c,_){const h=c+_,n=this.getPositionAt(c),s=this.getPositionAt(h);return new I.Range(n.lineNumber,n.column,s.lineNumber,s.column)}getValueInRange(c,_=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return"";const h=this._getEndOfLine(_);return this._pieceTree.getValueInRange(c,h)}getValueLengthInRange(c,_=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return 0;if(c.startLineNumber===c.endLineNumber)return c.endColumn-c.startColumn;const h=this.getOffsetAt(c.startLineNumber,c.startColumn),n=this.getOffsetAt(c.endLineNumber,c.endColumn);let s=0;const o=this._getEndOfLine(_),d=this.getEOL();if(o.length!==d.length){const i=o.length-d.length,r=c.endLineNumber-c.startLineNumber;s=i*r}return n-h+s}getCharacterCountInRange(c,_=O.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let h=0;const n=c.startLineNumber,s=c.endLineNumber;for(let o=n;o<=s;o++){const d=this.getLineContent(o),i=o===n?c.startColumn-1:0,r=o===s?c.endColumn-1:d.length;for(let t=i;t<r;t++)T.isHighSurrogate(d.charCodeAt(t))?(h=h+1,t=t+1):h=h+1}return h+=this._getEndOfLine(_).length*(s-n),h}return this.getValueLengthInRange(c,_)}getNearestChunk(c){return this._pieceTree.getNearestChunk(c)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(c){return this._pieceTree.getLineContent(c)}getLineCharCode(c,_){return this._pieceTree.getLineCharCode(c,_)}getCharCode(c){return this._pieceTree.getCharCode(c)}getLineLength(c){return this._pieceTree.getLineLength(c)}getLineMinColumn(c){return 1}getLineMaxColumn(c){return this.getLineLength(c)+1}getLineFirstNonWhitespaceColumn(c){const _=T.firstNonWhitespaceIndex(this.getLineContent(c));return _===-1?0:_+1}getLineLastNonWhitespaceColumn(c){const _=T.lastNonWhitespaceIndex(this.getLineContent(c));return _===-1?0:_+2}_getEndOfLine(c){switch(c){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(c){this._pieceTree.setEOL(c)}applyEdits(c,_,h){let n=this._mightContainRTL,s=this._mightContainUnusualLineTerminators,o=this._mightContainNonBasicASCII,d=!0,i=[];for(let p=0;p<c.length;p++){const y=c[p];d&&y._isTracked&&(d=!1);const C=y.range;if(y.text){let E=!0;o||(E=!T.isBasicASCII(y.text),o=E),!n&&E&&(n=T.containsRTL(y.text)),!s&&E&&(s=T.containsUnusualLineTerminators(y.text))}let b="",D=0,P=0,f=0;if(y.text){let E;[D,P,f,E]=(0,R.countEOL)(y.text);const F=this.getEOL(),L=F===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;E===R.StringEOL.Unknown||E===L?b=y.text:b=y.text.replace(/\r\n|\r|\n/g,F)}i[p]={sortIndex:p,identifier:y.identifier||null,range:C,rangeOffset:this.getOffsetAt(C.startLineNumber,C.startColumn),rangeLength:this.getValueLengthInRange(C),text:b,eolCount:D,firstLineLength:P,lastLineLength:f,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}i.sort(k._sortOpsAscending);let r=!1;for(let p=0,y=i.length-1;p<y;p++){const C=i[p].range.getEndPosition(),b=i[p+1].range.getStartPosition();if(b.isBeforeOrEqual(C)){if(b.isBefore(C))throw new Error("Overlapping ranges are not allowed!");r=!0}}d&&(i=this._reduceOperations(i));const t=h||_?k._getInverseEditRanges(i):[],l=[];if(_)for(let p=0;p<i.length;p++){const y=i[p],C=t[p];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let b=C.startLineNumber;b<=C.endLineNumber;b++){let D="";b===C.startLineNumber&&(D=this.getLineContent(y.range.startLineNumber),T.firstNonWhitespaceIndex(D)!==-1)||l.push({lineNumber:b,oldContent:D})}}let u=null;if(h){let p=0;u=[];for(let y=0;y<i.length;y++){const C=i[y],b=t[y],D=this.getValueInRange(C.range),P=C.rangeOffset+p;p+=C.text.length-D.length,u[y]={sortIndex:C.sortIndex,identifier:C.identifier,range:b,text:D,textChange:new v.TextChange(C.rangeOffset,D,P,C.text)}}r||u.sort((y,C)=>y.sortIndex-C.sortIndex)}this._mightContainRTL=n,this._mightContainUnusualLineTerminators=s,this._mightContainNonBasicASCII=o;const g=this._doApplyEdits(i);let m=null;if(_&&l.length>0){l.sort((p,y)=>y.lineNumber-p.lineNumber),m=[];for(let p=0,y=l.length;p<y;p++){const C=l[p].lineNumber;if(p>0&&l[p-1].lineNumber===C)continue;const b=l[p].oldContent,D=this.getLineContent(C);D.length===0||D===b||T.firstNonWhitespaceIndex(D)!==-1||m.push(C)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(u,g,m)}_reduceOperations(c){return c.length<1e3?c:[this._toSingleEditOperation(c)]}_toSingleEditOperation(c){let _=!1;const h=c[0].range,n=c[c.length-1].range,s=new I.Range(h.startLineNumber,h.startColumn,n.endLineNumber,n.endColumn);let o=h.startLineNumber,d=h.startColumn;const i=[];for(let g=0,m=c.length;g<m;g++){const p=c[g],y=p.range;_=_||p.forceMoveMarkers,i.push(this.getValueInRange(new I.Range(o,d,y.startLineNumber,y.startColumn))),p.text.length>0&&i.push(p.text),o=y.endLineNumber,d=y.endColumn}const r=i.join(""),[t,l,u]=(0,R.countEOL)(r);return{sortIndex:0,identifier:c[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:l,lastLineLength:u,forceMoveMarkers:_,isAutoWhitespaceEdit:!1}}_doApplyEdits(c){c.sort(k._sortOpsDescending);const _=[];for(let h=0;h<c.length;h++){const n=c[h],s=n.range.startLineNumber,o=n.range.startColumn,d=n.range.endLineNumber,i=n.range.endColumn;if(s===d&&o===i&&n.text.length===0)continue;n.text?(this._pieceTree.delete(n.rangeOffset,n.rangeLength),this._pieceTree.insert(n.rangeOffset,n.text,!0)):this._pieceTree.delete(n.rangeOffset,n.rangeLength);const r=new I.Range(s,o,d,i);_.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return _}findMatchesLineByLine(c,_,h,n){return this._pieceTree.findMatchesLineByLine(c,_,h,n)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(c,_){const h=c.startLineNumber,n=c.startColumn,[s,o,d]=(0,R.countEOL)(_);let i;if(_.length>0){const r=s+1;r===1?i=new I.Range(h,n,h,n+o):i=new I.Range(h,n,h+r-1,d+1)}else i=new I.Range(h,n,h,n);return i}static _getInverseEditRanges(c){const _=[];let h=0,n=0,s=null;for(let o=0,d=c.length;o<d;o++){const i=c[o];let r,t;s?s.range.endLineNumber===i.range.startLineNumber?(r=h,t=n+(i.range.startColumn-s.range.endColumn)):(r=h+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let l;if(i.text.length>0){const u=i.eolCount+1;u===1?l=new I.Range(r,t,r,t+i.firstLineLength):l=new I.Range(r,t,r+u-1,i.lastLineLength+1)}else l=new I.Range(r,t,r,t);h=l.endLineNumber,n=l.endColumn,_.push(l),s=i}return _}static _sortOpsAscending(c,_){const h=I.Range.compareRangesUsingEnds(c.range,_.range);return h===0?c.sortIndex-_.sortIndex:h}static _sortOpsDescending(c,_){const h=I.Range.compareRangesUsingEnds(c.range,_.range);return h===0?_.sortIndex-c.sortIndex:-h}}e.PieceTreeTextBuffer=k}),define(Te[167],Pe([1,0,28,13,52,100,166]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,T=$e(T);class R{constructor(k,w,c,_,h,n,s,o,d){this._chunks=k,this._bom=w,this._cr=c,this._lf=_,this._crlf=h,this._containsRTL=n,this._containsUnusualLineTerminators=s,this._isBasicASCII=o,this._normalizeEOL=d}_getEOL(k){const w=this._cr+this._lf+this._crlf,c=this._cr+this._crlf;return w===0?k===I.DefaultEndOfLine.LF?`
`:`\r
`:c>w/2?`\r
`:`
`}create(k){const w=this._getEOL(k),c=this._chunks;if(this._normalizeEOL&&(w===`\r
`&&(this._cr>0||this._lf>0)||w===`
`&&(this._cr>0||this._crlf>0)))for(let h=0,n=c.length;h<n;h++){const s=c[h].buffer.replace(/\r\n|\r|\n/g,w),o=(0,O.createLineStartsFast)(s);c[h]=new O.StringBuffer(s,o)}const _=new A.PieceTreeTextBuffer(c,this._bom,w,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:_,disposable:_}}getFirstLineText(k){return this._chunks[0].buffer.substr(0,k).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(k){if(k.length===0)return;this.chunks.length===0&&T.startsWithUTF8BOM(k)&&(this.BOM=T.UTF8_BOM_CHARACTER,k=k.substr(1));const w=k.charCodeAt(k.length-1);w===S.CharCode.CarriageReturn||w>=55296&&w<=56319?(this._acceptChunk1(k.substr(0,k.length-1),!1),this._hasPreviousChar=!0,this._previousChar=w):(this._acceptChunk1(k,!1),this._hasPreviousChar=!1,this._previousChar=w)}_acceptChunk1(k,w){!w&&k.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+k):this._acceptChunk2(k))}_acceptChunk2(k){const w=(0,O.createLineStarts)(this._tmpLineStarts,k);this.chunks.push(new O.StringBuffer(k,w.lineStarts)),this.cr+=w.cr,this.lf+=w.lf,this.crlf+=w.crlf,w.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=T.containsRTL(k)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=T.containsUnusualLineTerminators(k)))}finish(k=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,k)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const k=this.chunks[this.chunks.length-1];k.buffer+=String.fromCharCode(this._previousChar);const w=(0,O.createLineStartsFast)(k.buffer);k.lineStarts=w,this._previousChar===S.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=v}),define(Te[104],Pe([1,0,23,21]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=k,T=$e(T);var I;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(I||(I={}));function O(w){for(let c=0,_=w.length;c<_;c+=4){const h=w[c+0],n=w[c+1],s=w[c+2],o=w[c+3];w[c+0]=o,w[c+1]=s,w[c+2]=n,w[c+3]=h}}function A(w){const c=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return T.isLittleEndian()||O(c),S.VSBuffer.wrap(c)}function R(w){const c=w.buffer;if(T.isLittleEndian()||O(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const _=new Uint8Array(c.byteLength);return _.set(c),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function v(w){const c=new Uint32Array(a(w));let _=0;if(c[_++]=w.id,w.type==="full")c[_++]=I.Full,c[_++]=w.data.length,c.set(w.data,_),_+=w.data.length;else{c[_++]=I.Delta,c[_++]=w.deltas.length;for(const h of w.deltas)c[_++]=h.start,c[_++]=h.deleteCount,h.data?(c[_++]=h.data.length,c.set(h.data,_),_+=h.data.length):c[_++]=0}return A(c)}function a(w){let c=0;if(c+=2,w.type==="full")c+=1+w.data.length;else{c+=1,c+=3*w.deltas.length;for(const _ of w.deltas)_.data&&(c+=_.data.length)}return c}function k(w){const c=R(w);let _=0;const h=c[_++];if(c[_++]===I.Full){const d=c[_++],i=c.subarray(_,_+d);return _+=d,{id:h,type:"full",data:i}}const s=c[_++],o=[];for(let d=0;d<s;d++){const i=c[_++],r=c[_++],t=c[_++];let l;t>0&&(l=c.subarray(_,_+t),_+=t),o[d]={start:i,deleteCount:r,data:l}}return{id:h,type:"delta",deltas:o}}}),define(Te[168],Pe([9,10]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(Te[169],Pe([9,10]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[170],Pe([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(Te[171],Pe([9,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(Te[172],Pe([9,10]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[173],Pe([9,10]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[174],Pe([9,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(Te[175],Pe([9,10]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(Te[176],Pe([9,10]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(Te[177],Pe([9,10]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(Te[178],Pe([9,10]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[179],Pe([9,10]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Te[180],Pe([9,10]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(Te[181],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[182],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[183],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Te[184],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Te[185],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLogService",e)}),define(Te[186],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostNotebook",e)}),define(Te[187],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[188],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[189],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[190],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[191],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Te[192],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[193],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/configuration",e)}),define(Te[194],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(Te[195],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(Te[196],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Te[197],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Te[198],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[199],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[200],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[201],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[202],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/contrib/testing/common/constants",e)}),define(Te[203],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[204],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Te[205],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[206],Pe([9,10]),function(ae,e){return ae.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[207],Pe([1,0,28,14,171]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...k){switch(k.length){case 1:return(0,I.localize)(0,null,k[0]);case 2:return(0,I.localize)(1,null,k[0],k[1]);case 3:return(0,I.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,I.localize)(3,null),v=(0,I.localize)(4,null);class a{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return w.isTripleEq?"===":"==";case O.NotEq:return w.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return w.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return w.lexeme;case O.QuotedStr:return w.lexeme;case O.Error:return w.lexeme;case O.EOF:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this._keywords=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this._errors}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case S.CharCode.OpenParen:this._addToken(O.LParen);break;case S.CharCode.CloseParen:this._addToken(O.RParen);break;case S.CharCode.ExclamationMark:if(this._match(S.CharCode.Equals)){const c=this._match(S.CharCode.Equals);this._tokens.push({type:O.NotEq,offset:this._start,isTripleEq:c})}else this._addToken(O.Neg);break;case S.CharCode.SingleQuote:this._quotedString();break;case S.CharCode.Slash:this._regex();break;case S.CharCode.Equals:if(this._match(S.CharCode.Equals)){const c=this._match(S.CharCode.Equals);this._tokens.push({type:O.Eq,offset:this._start,isTripleEq:c})}else this._match(S.CharCode.Tilde)?this._addToken(O.RegexOp):this._error(A("==","=~"));break;case S.CharCode.LessThan:this._addToken(this._match(S.CharCode.Equals)?O.LtEq:O.Lt);break;case S.CharCode.GreaterThan:this._addToken(this._match(S.CharCode.Equals)?O.GtEq:O.Gt);break;case S.CharCode.Ampersand:this._match(S.CharCode.Ampersand)?this._addToken(O.And):this._error(A("&&"));break;case S.CharCode.Pipe:this._match(S.CharCode.Pipe)?this._addToken(O.Or):this._error(A("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(O.EOF),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?S.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(w){const c=this._start,_=this._input.substring(this._start,this._current),h={type:O.Error,offset:this._start,lexeme:_};this._errors.push({offset:c,lexeme:_,additionalInfo:w}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const c=this._input.substring(this._start,this._current),_=a._keywords.get(c);_?this._addToken(_):this._tokens.push({type:O.Str,lexeme:c,offset:this._start})}}_quotedString(){for(;this._peek()!==S.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:O.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,c=!1,_=!1;for(;;){if(w>=this._input.length){this._current=w,this._error(v);return}const n=this._input.charCodeAt(w);if(c)c=!1;else if(n===S.CharCode.Slash&&!_){w++;break}else n===S.CharCode.OpenSquareBracket?_=!0:n===S.CharCode.Backslash?c=!0:n===S.CharCode.CloseSquareBracket&&(_=!1);w++}for(;w<this._input.length&&a._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const h=this._input.substring(this._start,this._current);this._tokens.push({type:O.RegexStr,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=a}),define(Te[105],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(Te[74],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(I,O=[],A=!1){this.ctor=I,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(Te[61],Pe([1,0,74]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=A;const T=[];var I;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function O(R,v,a){v instanceof S.SyncDescriptor||(v=new S.SyncDescriptor(v,[],!!a)),T.push([R,v])}function A(){return T}}),define(Te[208],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class T{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const A of this._nodes.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const R=this.lookupOrInsertNode(O),v=this.lookupOrInsertNode(A);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(O){const A=this._hashFn(O);this._nodes.delete(A);for(const R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(O){const A=this._hashFn(O);let R=this._nodes.get(A);return R||(R=new S(A,O),this._nodes.set(A,R)),R}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[A,R]of this._nodes)O.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this._nodes){const R=new Set([O]),v=this._findCycle(A,R);if(v)return v}}_findCycle(O,A){for(const[R,v]of O.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const a=this._findCycle(v,A);if(a)return a;A.delete(R)}}}e.Graph=T}),define(Te[3],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=O;var S;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(S||(e._util=S={})),e.IInstantiationService=I("instantiationService");function T(A,R,v){R[S.DI_TARGET]===R?R[S.DI_DEPENDENCIES].push({id:A,index:v}):(R[S.DI_DEPENDENCIES]=[{id:A,index:v}],R[S.DI_TARGET]=R)}function I(A){if(S.serviceIds.has(A))return S.serviceIds.get(A);const R=function(v,a,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(R,v,k)};return R.toString=()=>A,S.serviceIds.set(A,R),R}function O(A){return A}}),define(Te[43],Pe([1,0,15,2,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=v,e.isConfigured=a,e.toValuesTree=k,e.addToValueTree=w,e.removeFromValueTree=c,e.getConfigurationValue=h,e.merge=n,e.getLanguageTagSettingPlainKey=s,S=$e(S),e.IConfigurationService=(0,I.createDecorator)("configurationService");function O(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(o){switch(o){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function a(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function k(o,d){const i=Object.create(null);for(const r in o)w(i,r,o[r],d);return i}function w(o,d,i,r){const t=d.split("."),l=t.pop();let u=o;for(let g=0;g<t.length;g++){const m=t[g];let p=u[m];switch(typeof p){case"undefined":p=u[m]=Object.create(null);break;case"object":if(p===null){r(`Ignoring ${d} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:r(`Ignoring ${d} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(p)}`);return}u=p}if(typeof u=="object"&&u!==null)try{u[l]=i}catch{r(`Ignoring ${d} as ${t.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${d} as ${t.join(".")} is ${JSON.stringify(u)}`)}function c(o,d){const i=d.split(".");_(o,i)}function _(o,d){const i=d.shift();if(d.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(_(r,d),Object.keys(r).length===0&&delete o[i])}}function h(o,d,i){function r(u,g){let m=u;for(const p of g){if(typeof m!="object"||m===null)return;m=m[p]}return m}const t=d.split("."),l=r(o,t);return typeof l>"u"?i:l}function n(o,d,i){Object.keys(d).forEach(r=>{r!=="__proto__"&&(r in o?S.isObject(o[r])&&S.isObject(d[r])?n(o[r],d[r],i):i&&(o[r]=d[r]):o[r]=d[r])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Te[32],Pe([1,0,28,21,13,207,3,170,14]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=k,e.validateWhenClauses=g,e.expressionsAreEqualWithConstantSubstitution=m,e.implies=oe;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",T.isMacintosh),a.set("isLinux",T.isLinux),a.set("isWindows",T.isWindows),a.set("isWeb",T.isWeb),a.set("isMacNative",T.isMacintosh&&!T.isWeb),a.set("isEdge",T.isEdge),a.set("isFirefox",T.isFirefox),a.set("isChrome",T.isChrome),a.set("isSafari",T.isSafari);function k(X,$){if(a.get(X)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(X,$)}const w=Object.prototype.hasOwnProperty;var c;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const _={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),n=(0,R.localize)(1,null),s=(0,R.localize)(2,null),o=(0,R.localize)(3,null),d=(0,R.localize)(4,null),i=(0,R.localize)(5,null),r=(0,R.localize)(6,null),t=(0,R.localize)(7,null);class l{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor($=_){this._config=$,this._scanner=new O.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse($){if($===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:n});return}this._tokens=this._scanner.reset($).scan(),this._current=0,this._parsingErrors=[];try{const te=this._expr();if(!this._isAtEnd()){const Se=this._peek(),ce=Se.type===O.TokenType.Str?i:void 0;throw this._parsingErrors.push({message:d,offset:Se.offset,lexeme:O.Scanner.getLexeme(Se),additionalInfo:ce}),l._parseError}return te}catch(te){if(te!==l._parseError)throw te;return}}_expr(){return this._or()}_or(){const $=[this._and()];for(;this._matchOne(O.TokenType.Or);){const te=this._and();$.push(te)}return $.length===1?$[0]:u.or(...$)}_and(){const $=[this._term()];for(;this._matchOne(O.TokenType.And);){const te=this._term();$.push(te)}return $.length===1?$[0]:u.and(...$)}_term(){if(this._matchOne(O.TokenType.Neg)){const $=this._peek();switch($.type){case O.TokenType.True:return this._advance(),y.INSTANCE;case O.TokenType.False:return this._advance(),C.INSTANCE;case O.TokenType.LParen:{this._advance();const te=this._expr();return this._consume(O.TokenType.RParen,o),te?.negate()}case O.TokenType.Str:return this._advance(),F.create($.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",$)}}return this._primary()}_primary(){const $=this._peek();switch($.type){case O.TokenType.True:return this._advance(),u.true();case O.TokenType.False:return this._advance(),u.false();case O.TokenType.LParen:{this._advance();const te=this._expr();return this._consume(O.TokenType.RParen,o),te}case O.TokenType.Str:{const te=$.lexeme;if(this._advance(),this._matchOne(O.TokenType.RegexOp)){const ce=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ce.type!==O.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",ce);const be=ce.lexeme,he=be.lastIndexOf("/"),G=he===be.length-1?void 0:this._removeFlagsGY(be.substring(he+1));let J;try{J=new RegExp(be.substring(1,he),G)}catch{throw this._errExpectedButGot("REGEX",ce)}return Q.create(te,J)}switch(ce.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[ce.lexeme];this._advance();let he=this._peek(),G=0;for(let Ue=0;Ue<ce.lexeme.length;Ue++)ce.lexeme.charCodeAt(Ue)===S.CharCode.OpenParen?G++:ce.lexeme.charCodeAt(Ue)===S.CharCode.CloseParen&&G--;for(;!this._isAtEnd()&&he.type!==O.TokenType.And&&he.type!==O.TokenType.Or;){switch(he.type){case O.TokenType.LParen:G++;break;case O.TokenType.RParen:G--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<he.lexeme.length;Ue++)he.lexeme.charCodeAt(Ue)===S.CharCode.OpenParen?G++:ce.lexeme.charCodeAt(Ue)===S.CharCode.CloseParen&&G--}if(G<0)break;be.push(O.Scanner.getLexeme(he)),this._advance(),he=this._peek()}const J=be.join(""),pe=J.lastIndexOf("/"),ve=pe===J.length-1?void 0:this._removeFlagsGY(J.substring(pe+1));let Oe;try{Oe=new RegExp(J.substring(1,pe),ve)}catch{throw this._errExpectedButGot("REGEX",ce)}return u.regex(te,Oe)}case O.TokenType.QuotedStr:{const be=ce.lexeme;this._advance();let he=null;if(!(0,I.isFalsyOrWhitespace)(be)){const G=be.indexOf("/"),J=be.lastIndexOf("/");if(G!==J&&G>=0){const pe=be.slice(G+1,J),ve=be[J+1]==="i"?"i":"";try{he=new RegExp(pe,ve)}catch{throw this._errExpectedButGot("REGEX",ce)}}}if(he===null)throw this._errExpectedButGot("REGEX",ce);return Q.create(te,he)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(O.TokenType.Not)){this._consume(O.TokenType.In,s);const ce=this._value();return u.notIn(te,ce)}switch(this._peek().type){case O.TokenType.Eq:{this._advance();const ce=this._value();if(this._previous().type===O.TokenType.QuotedStr)return u.equals(te,ce);switch(ce){case"true":return u.has(te);case"false":return u.not(te);default:return u.equals(te,ce)}}case O.TokenType.NotEq:{this._advance();const ce=this._value();if(this._previous().type===O.TokenType.QuotedStr)return u.notEquals(te,ce);switch(ce){case"true":return u.not(te);case"false":return u.has(te);default:return u.notEquals(te,ce)}}case O.TokenType.Lt:return this._advance(),W.create(te,this._value());case O.TokenType.LtEq:return this._advance(),N.create(te,this._value());case O.TokenType.Gt:return this._advance(),M.create(te,this._value());case O.TokenType.GtEq:return this._advance(),V.create(te,this._value());case O.TokenType.In:return this._advance(),u.in(te,this._value());default:return u.has(te)}}case O.TokenType.EOF:throw this._parsingErrors.push({message:r,offset:$.offset,lexeme:"",additionalInfo:t}),l._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const $=this._peek();switch($.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this._advance(),$.lexeme;case O.TokenType.True:return this._advance(),"true";case O.TokenType.False:return this._advance(),"false";case O.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY($){return $.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne($){return this._check($)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume($,te){if(this._check($))return this._advance();throw this._errExpectedButGot(te,this._peek())}_errExpectedButGot($,te,Se){const ce=(0,R.localize)(8,null,$,O.Scanner.getLexeme(te)),be=te.offset,he=O.Scanner.getLexeme(te);return this._parsingErrors.push({message:ce,offset:be,lexeme:he,additionalInfo:Se}),l._parseError}_check($){return this._peek().type===$}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===O.TokenType.EOF}}e.Parser=l;class u{static false(){return y.INSTANCE}static true(){return C.INSTANCE}static has($){return b.create($)}static equals($,te){return D.create($,te)}static notEquals($,te){return E.create($,te)}static regex($,te){return Q.create($,te)}static in($,te){return P.create($,te)}static notIn($,te){return f.create($,te)}static not($){return F.create($)}static and(...$){return Z.create($,null,!0)}static or(...$){return me.create($,null,!0)}static greater($,te){return M.create($,te)}static greaterEquals($,te){return V.create($,te)}static smaller($,te){return W.create($,te)}static smallerEquals($,te){return N.create($,te)}static{this._parser=new l({regexParsingWithErrorRecovery:!1})}static deserialize($){return $==null?void 0:this._parser.parse($)}}e.ContextKeyExpr=u;function g(X){const $=new l({regexParsingWithErrorRecovery:!1});return X.map(te=>($.parse(te),$.lexingErrors.length>0?$.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,R.localize)(9,null,Se.additionalInfo):(0,R.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):$.parsingErrors.length>0?$.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}function m(X,$){const te=X?X.substituteConstants():void 0,Se=$?$.substituteConstants():void 0;return!te&&!Se?!0:!te||!Se?!1:te.equals(Se)}function p(X,$){return X.cmp($)}class y{static{this.INSTANCE=new y}constructor(){this.type=c.False}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!1}serialize(){return"false"}keys(){return[]}map($){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=y;class C{static{this.INSTANCE=new C}constructor(){this.type=c.True}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!0}serialize(){return"true"}keys(){return[]}map($){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=C;class b{static create($,te=null){const Se=a.get($);return typeof Se=="boolean"?Se?C.INSTANCE:y.INSTANCE:new b($,te)}constructor($,te){this.key=$,this.negated=te,this.type=c.Defined}cmp($){return $.type!==this.type?this.type-$.type:le(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=a.get(this.key);return typeof $=="boolean"?$?C.INSTANCE:y.INSTANCE:this}evaluate($){return!!$.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map($){return $.mapDefined(this.key)}negate(){return this.negated||(this.negated=F.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class D{static create($,te,Se=null){if(typeof te=="boolean")return te?b.create($,Se):F.create($,Se);const ce=a.get($);return typeof ce=="boolean"?te===(ce?"true":"false")?C.INSTANCE:y.INSTANCE:new D($,te,Se)}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.Equals}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=a.get(this.key);if(typeof $=="boolean"){const te=$?"true":"false";return this.value===te?C.INSTANCE:y.INSTANCE}return this}evaluate($){return $.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map($){return $.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class P{static create($,te){return new P($,te)}constructor($,te){this.key=$,this.valueKey=te,this.type=c.In,this.negated=null}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.valueKey,$.key,$.valueKey)}equals($){return $.type===this.type?this.key===$.key&&this.valueKey===$.valueKey:!1}substituteConstants(){return this}evaluate($){const te=$.getValue(this.valueKey),Se=$.getValue(this.key);return Array.isArray(te)?te.includes(Se):typeof Se=="string"&&typeof te=="object"&&te!==null?w.call(te,Se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map($){return $.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=P;class f{static create($,te){return new f($,te)}constructor($,te){this.key=$,this.valueKey=te,this.type=c.NotIn,this._negated=P.create($,te)}cmp($){return $.type!==this.type?this.type-$.type:this._negated.cmp($._negated)}equals($){return $.type===this.type?this._negated.equals($._negated):!1}substituteConstants(){return this}evaluate($){return!this._negated.evaluate($)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map($){return $.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=f;class E{static create($,te,Se=null){if(typeof te=="boolean")return te?F.create($,Se):b.create($,Se);const ce=a.get($);return typeof ce=="boolean"?te===(ce?"true":"false")?y.INSTANCE:C.INSTANCE:new E($,te,Se)}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.NotEquals}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=a.get(this.key);if(typeof $=="boolean"){const te=$?"true":"false";return this.value===te?y.INSTANCE:C.INSTANCE}return this}evaluate($){return $.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map($){return $.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class F{static create($,te=null){const Se=a.get($);return typeof Se=="boolean"?Se?y.INSTANCE:C.INSTANCE:new F($,te)}constructor($,te){this.key=$,this.negated=te,this.type=c.Not}cmp($){return $.type!==this.type?this.type-$.type:le(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=a.get(this.key);return typeof $=="boolean"?$?y.INSTANCE:C.INSTANCE:this}evaluate($){return!$.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map($){return $.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=F;function L(X,$){if(typeof X=="string"){const te=parseFloat(X);isNaN(te)||(X=te)}return typeof X=="string"||typeof X=="number"?$(X):y.INSTANCE}class M{static create($,te,Se=null){return L(te,ce=>new M($,ce,Se))}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.Greater}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map($){return $.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class V{static create($,te,Se=null){return L(te,ce=>new V($,ce,Se))}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.GreaterEquals}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map($){return $.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class W{static create($,te,Se=null){return L(te,ce=>new W($,ce,Se))}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.Smaller}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map($){return $.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=W;class N{static create($,te,Se=null){return L(te,ce=>new N($,ce,Se))}constructor($,te,Se){this.key=$,this.value=te,this.negated=Se,this.type=c.SmallerEquals}cmp($){return $.type!==this.type?this.type-$.type:Ee(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map($){return $.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class Q{static create($,te){return new Q($,te)}constructor($,te){this.key=$,this.regexp=te,this.type=c.Regex,this.negated=null}cmp($){if($.type!==this.type)return this.type-$.type;if(this.key<$.key)return-1;if(this.key>$.key)return 1;const te=this.regexp?this.regexp.source:"",Se=$.regexp?$.regexp.source:"";return te<Se?-1:te>Se?1:0}equals($){if($.type===this.type){const te=this.regexp?this.regexp.source:"",Se=$.regexp?$.regexp.source:"";return this.key===$.key&&te===Se}return!1}substituteConstants(){return this}evaluate($){const te=$.getValue(this.key);return this.regexp?this.regexp.test(te):!1}serialize(){const $=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${$}`}keys(){return[this.key]}map($){return $.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Y.create(this)),this.negated}}e.ContextKeyRegexExpr=Q;class Y{static create($){return new Y($)}constructor($){this._actual=$,this.type=c.NotRegex}cmp($){return $.type!==this.type?this.type-$.type:this._actual.cmp($._actual)}equals($){return $.type===this.type?this._actual.equals($._actual):!1}substituteConstants(){return this}evaluate($){return!this._actual.evaluate($)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map($){return new Y(this._actual.map($))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Y;function ge(X){let $=null;for(let te=0,Se=X.length;te<Se;te++){const ce=X[te].substituteConstants();if(X[te]!==ce&&$===null){$=[];for(let be=0;be<te;be++)$[be]=X[be]}$!==null&&($[te]=ce)}return $===null?X:$}class Z{static create($,te,Se){return Z._normalizeArr($,te,Se)}constructor($,te){this.expr=$,this.negated=te,this.type=c.And}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let te=0,Se=this.expr.length;te<Se;te++){const ce=p(this.expr[te],$.expr[te]);if(ce!==0)return ce}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let te=0,Se=this.expr.length;te<Se;te++)if(!this.expr[te].equals($.expr[te]))return!1;return!0}return!1}substituteConstants(){const $=ge(this.expr);return $===this.expr?this:Z.create($,this.negated,!1)}evaluate($){for(let te=0,Se=this.expr.length;te<Se;te++)if(!this.expr[te].evaluate($))return!1;return!0}static _normalizeArr($,te,Se){const ce=[];let be=!1;for(const he of $)if(he){if(he.type===c.True){be=!0;continue}if(he.type===c.False)return y.INSTANCE;if(he.type===c.And){ce.push(...he.expr);continue}ce.push(he)}if(ce.length===0&&be)return C.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(p);for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];for(;ce.length>1;){const he=ce[ce.length-1];if(he.type!==c.Or)break;ce.pop();const G=ce.pop(),J=ce.length===0,pe=me.create(he.expr.map(ve=>Z.create([ve,G],null,Se)),null,J);pe&&(ce.push(pe),ce.sort(p))}if(ce.length===1)return ce[0];if(Se){for(let he=0;he<ce.length;he++)for(let G=he+1;G<ce.length;G++)if(ce[he].negate().equals(ce[G]))return y.INSTANCE;if(ce.length===1)return ce[0]}return new Z(ce,te)}}serialize(){return this.expr.map($=>$.serialize()).join(" && ")}keys(){const $=[];for(const te of this.expr)$.push(...te.keys());return $}map($){return new Z(this.expr.map(te=>te.map($)),null)}negate(){if(!this.negated){const $=[];for(const te of this.expr)$.push(te.negate());this.negated=me.create($,this,!0)}return this.negated}}e.ContextKeyAndExpr=Z;class me{static create($,te,Se){return me._normalizeArr($,te,Se)}constructor($,te){this.expr=$,this.negated=te,this.type=c.Or}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let te=0,Se=this.expr.length;te<Se;te++){const ce=p(this.expr[te],$.expr[te]);if(ce!==0)return ce}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let te=0,Se=this.expr.length;te<Se;te++)if(!this.expr[te].equals($.expr[te]))return!1;return!0}return!1}substituteConstants(){const $=ge(this.expr);return $===this.expr?this:me.create($,this.negated,!1)}evaluate($){for(let te=0,Se=this.expr.length;te<Se;te++)if(this.expr[te].evaluate($))return!0;return!1}static _normalizeArr($,te,Se){let ce=[],be=!1;if($){for(let he=0,G=$.length;he<G;he++){const J=$[he];if(J){if(J.type===c.False){be=!0;continue}if(J.type===c.True)return C.INSTANCE;if(J.type===c.Or){ce=ce.concat(J.expr);continue}ce.push(J)}}if(ce.length===0&&be)return y.INSTANCE;ce.sort(p)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];if(Se){for(let he=0;he<ce.length;he++)for(let G=he+1;G<ce.length;G++)if(ce[he].negate().equals(ce[G]))return C.INSTANCE;if(ce.length===1)return ce[0]}return new me(ce,te)}}serialize(){return this.expr.map($=>$.serialize()).join(" || ")}keys(){const $=[];for(const te of this.expr)$.push(...te.keys());return $}map($){return new me(this.expr.map(te=>te.map($)),null)}negate(){if(!this.negated){const $=[];for(const te of this.expr)$.push(te.negate());for(;$.length>1;){const te=$.shift(),Se=$.shift(),ce=[];for(const be of Me(te))for(const he of Me(Se))ce.push(Z.create([be,he],null,!1));$.unshift(me.create(ce,null,!1))}this.negated=me.create($,this,!0)}return this.negated}}e.ContextKeyOrExpr=me;class se extends b{static{this._info=[]}static all(){return se._info.values()}constructor($,te,Se){super($,null),this._defaultValue=te,typeof Se=="object"?se._info.push({...Se,key:$}):Se!==!0&&se._info.push({key:$,description:Se,type:te!=null?typeof te:void 0})}bindTo($){return $.createKey(this.key,this._defaultValue)}getValue($){return $.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo($){return D.create(this.key,$)}notEqualsTo($){return E.create(this.key,$)}}e.RawContextKey=se,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function le(X,$){return X<$?-1:X>$?1:0}function Ee(X,$,te,Se){return X<te?-1:X>te?1:$<Se?-1:$>Se?1:0}function oe(X,$){if(X.type===c.False||$.type===c.True)return!0;if(X.type===c.Or)return $.type===c.Or?Ie(X.expr,$.expr):!1;if($.type===c.Or){for(const te of $.expr)if(oe(X,te))return!0;return!1}if(X.type===c.And){if($.type===c.And)return Ie($.expr,X.expr);for(const te of X.expr)if(oe(te,$))return!0;return!1}return X.equals($)}function Ie(X,$){let te=0,Se=0;for(;te<X.length&&Se<$.length;){const ce=X[te].cmp($[Se]);if(ce<0)return!1;ce===0&&te++,Se++}return te===X.length}function Me(X){return X.type===c.Or?X.expr:[X]}}),define(Te[209],Pe([1,0,32,3]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=O,e.IAccessibilityService=(0,T.createDecorator)("accessibilityService");var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new S.RawContextKey("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(Te[106],Pe([1,0,18,26,21,144,322,150,210,168,209]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=p,e.cursorStyleToString=L,e.filterValidationDecorations=Ae,S=$e(S),T=$e(T),I=$e(I),a=$e(a);var w;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class c{constructor(q){this._values=q}hasChanged(q){return this._values[q]}}e.ConfigurationChangedEvent=c;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class h{constructor(q,Ce,Ge,Je){this.id=q,this.name=Ce,this.defaultValue=Ge,this.schema=Je}applyUpdate(q,Ce){return s(q,Ce)}compute(q,Ce,Ge){return Ge}}class n{constructor(q,Ce){this.newValue=q,this.didChange=Ce}}e.ApplyUpdateResult=n;function s(ee,q){if(typeof ee!="object"||typeof q!="object"||!ee||!q)return new n(q,ee!==q);if(Array.isArray(ee)||Array.isArray(q)){const Ge=Array.isArray(ee)&&Array.isArray(q)&&S.equals(ee,q);return new n(q,!Ge)}let Ce=!1;for(const Ge in q)if(q.hasOwnProperty(Ge)){const Je=s(ee[Ge],q[Ge]);Je.didChange&&(ee[Ge]=Je.newValue,Ce=!0)}return new n(ee,Ce)}class o{constructor(q){this.schema=void 0,this.id=q,this.name="_never_",this.defaultValue=void 0}applyUpdate(q,Ce){return s(q,Ce)}validate(q){return this.defaultValue}}class d{constructor(q,Ce,Ge,Je){this.id=q,this.name=Ce,this.defaultValue=Ge,this.schema=Je}applyUpdate(q,Ce){return s(q,Ce)}validate(q){return typeof q>"u"?this.defaultValue:q}compute(q,Ce,Ge){return Ge}}function i(ee,q){return typeof ee>"u"?q:ee==="false"?!1:!!ee}class r extends d{constructor(q,Ce,Ge,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=Ge),super(q,Ce,Ge,Je)}validate(q){return i(q,this.defaultValue)}}function t(ee,q,Ce,Ge){if(typeof ee>"u")return q;let Je=parseInt(ee,10);return isNaN(Je)?q:(Je=Math.max(Ce,Je),Je=Math.min(Ge,Je),Je|0)}class l extends d{static clampedInt(q,Ce,Ge,Je){return t(q,Ce,Ge,Je)}constructor(q,Ce,Ge,Je,dt,vt=void 0){typeof vt<"u"&&(vt.type="integer",vt.default=Ge,vt.minimum=Je,vt.maximum=dt),super(q,Ce,Ge,vt),this.minimum=Je,this.maximum=dt}validate(q){return l.clampedInt(q,this.defaultValue,this.minimum,this.maximum)}}function u(ee,q,Ce,Ge){if(typeof ee>"u")return q;const Je=g.float(ee,q);return g.clamp(Je,Ce,Ge)}class g extends d{static clamp(q,Ce,Ge){return q<Ce?Ce:q>Ge?Ge:q}static float(q,Ce){if(typeof q=="number")return q;if(typeof q>"u")return Ce;const Ge=parseFloat(q);return isNaN(Ge)?Ce:Ge}constructor(q,Ce,Ge,Je,dt){typeof dt<"u"&&(dt.type="number",dt.default=Ge),super(q,Ce,Ge,dt),this.validationFn=Je}validate(q){return this.validationFn(g.float(q,this.defaultValue))}}class m extends d{static string(q,Ce){return typeof q!="string"?Ce:q}constructor(q,Ce,Ge,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=Ge),super(q,Ce,Ge,Je)}validate(q){return m.string(q,this.defaultValue)}}function p(ee,q,Ce,Ge){return typeof ee!="string"?q:Ge&&ee in Ge?Ge[ee]:Ce.indexOf(ee)===-1?q:ee}class y extends d{constructor(q,Ce,Ge,Je,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Je,dt.default=Ge),super(q,Ce,Ge,dt),this._allowedValues=Je}validate(q){return p(q,this.defaultValue,this._allowedValues)}}class C extends h{constructor(q,Ce,Ge,Je,dt,vt,Lt=void 0){typeof Lt<"u"&&(Lt.type="string",Lt.enum=dt,Lt.default=Je),super(q,Ce,Ge,Lt),this._allowedValues=dt,this._convert=vt}validate(q){return typeof q!="string"?this.defaultValue:this._allowedValues.indexOf(q)===-1?this.defaultValue:this._convert(q)}}function b(ee){switch(ee){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class D extends h{constructor(){super(Be.accessibilitySupport,"accessibilitySupport",k.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(q){switch(q){case"auto":return k.AccessibilitySupport.Unknown;case"off":return k.AccessibilitySupport.Disabled;case"on":return k.AccessibilitySupport.Enabled}return this.defaultValue}compute(q,Ce,Ge){return Ge===k.AccessibilitySupport.Unknown?q.accessibilitySupport:Ge}}class P extends h{constructor(){const q={insertSpace:!0,ignoreEmptyLines:!0};super(Be.comments,"comments",q,{"editor.comments.insertSpace":{type:"boolean",default:q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{insertSpace:i(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function E(ee){switch(ee){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var F;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function L(ee){switch(ee){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function M(ee){switch(ee){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class V extends o{constructor(){super(Be.editorClassName)}compute(q,Ce,Ge){const Je=["monaco-editor"];return Ce.get(Be.extraEditorClassName)&&Je.push(Ce.get(Be.extraEditorClassName)),q.extraEditorClassName&&Je.push(q.extraEditorClassName),Ce.get(Be.mouseStyle)==="default"?Je.push("mouse-default"):Ce.get(Be.mouseStyle)==="copy"&&Je.push("mouse-copy"),Ce.get(Be.showUnused)&&Je.push("showUnused"),Ce.get(Be.showDeprecated)&&Je.push("showDeprecated"),Je.join(" ")}}class W extends r{constructor(){super(Be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(q,Ce,Ge){return Ge&&q.emptySelectionClipboard}}class N extends h{constructor(){const q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Be.find,"find",q,{"editor.find.cursorMoveOnType":{type:"boolean",default:q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:q.globalFindClipboard,description:a.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:q.loop,description:a.localize(18,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{cursorMoveOnType:i(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof q.seedSearchStringFromSelection=="boolean"?q.seedSearchStringFromSelection?"always":"never":p(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof q.autoFindInSelection=="boolean"?q.autoFindInSelection?"always":"never":p(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ce.loop,this.defaultValue.loop)}}}class Q extends h{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Be.fontLigatures,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"||q.length===0?Q.OFF:q==="true"?Q.ON:q:q?Q.ON:Q.OFF}}e.EditorFontLigatures=Q;class Y extends h{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Be.fontVariations,"fontVariations",Y.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"?Y.OFF:q==="true"?Y.TRANSLATE:q:q?Y.TRANSLATE:Y.OFF}compute(q,Ce,Ge){return q.fontInfo.fontVariationSettings}}e.EditorFontVariations=Y;class ge extends o{constructor(){super(Be.fontInfo)}compute(q,Ce,Ge){return q.fontInfo}}class Z extends d{constructor(){super(Be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(q){const Ce=g.float(q,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Ce,6,100)}compute(q,Ce,Ge){return q.fontInfo.fontSize}}class me extends h{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.MINIMUM_VALUE,maximum:me.MAXIMUM_VALUE,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(q){return q==="normal"||q==="bold"?q:String(l.clampedInt(q,e.EDITOR_FONT_DEFAULTS.fontWeight,me.MINIMUM_VALUE,me.MAXIMUM_VALUE))}}class se extends h{constructor(){const q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:q.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Be.gotoLocation,"gotoLocation",q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:q.alternativeDefinitionCommand,enum:Ge,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:q.alternativeTypeDefinitionCommand,enum:Ge,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:q.alternativeDeclarationCommand,enum:Ge,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:q.alternativeImplementationCommand,enum:Ge,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:q.alternativeReferenceCommand,enum:Ge,description:a.localize(41,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{multiple:p(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??p(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??p(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??p(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??p(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??p(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends h{constructor(){const q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Be.hover,"hover",q,{"editor.hover.enabled":{type:"boolean",default:q.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:q.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:q.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:q.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:q.above,description:a.localize(46,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),delay:l.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:i(Ce.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Ce.above,this.defaultValue.above)}}}var Ee;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(Ee||(e.RenderMinimap=Ee={}));class oe extends o{constructor(){super(Be.layoutInfo)}compute(q,Ce,Ge){return oe.computeLayout(Ce,{memory:q.memory,outerWidth:q.outerWidth,outerHeight:q.outerHeight,isDominatedByLongLines:q.isDominatedByLongLines,lineHeight:q.fontInfo.lineHeight,viewLineCount:q.viewLineCount,lineNumbersDigitCount:q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:q.fontInfo.maxDigitWidth,pixelRatio:q.pixelRatio,glyphMarginDecorationLaneCount:q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(q){const Ce=q.height/q.lineHeight,Ge=Math.floor(q.paddingTop/q.lineHeight);let Je=Math.floor(q.paddingBottom/q.lineHeight);q.scrollBeyondLastLine&&(Je=Math.max(Je,Ce-1));const dt=(Ge+q.viewLineCount+Je)/(q.pixelRatio*q.height),vt=Math.floor(q.viewLineCount/dt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Je,desiredRatio:dt,minimapLineCount:vt}}static _computeMinimapLayout(q,Ce){const Ge=q.outerWidth,Je=q.outerHeight,dt=q.pixelRatio;if(!q.minimap.enabled)return{renderMinimap:Ee.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(dt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const vt=Ce.stableMinimapLayoutInput,Lt=vt&&q.outerHeight===vt.outerHeight&&q.lineHeight===vt.lineHeight&&q.typicalHalfwidthCharacterWidth===vt.typicalHalfwidthCharacterWidth&&q.pixelRatio===vt.pixelRatio&&q.scrollBeyondLastLine===vt.scrollBeyondLastLine&&q.paddingTop===vt.paddingTop&&q.paddingBottom===vt.paddingBottom&&q.minimap.enabled===vt.minimap.enabled&&q.minimap.side===vt.minimap.side&&q.minimap.size===vt.minimap.size&&q.minimap.showSlider===vt.minimap.showSlider&&q.minimap.renderCharacters===vt.minimap.renderCharacters&&q.minimap.maxColumn===vt.minimap.maxColumn&&q.minimap.scale===vt.minimap.scale&&q.verticalScrollbarWidth===vt.verticalScrollbarWidth&&q.isViewportWrapping===vt.isViewportWrapping,Ft=q.lineHeight,ei=q.typicalHalfwidthCharacterWidth,ui=q.scrollBeyondLastLine,ti=q.minimap.renderCharacters;let Qe=dt>=2?Math.round(q.minimap.scale*2):q.minimap.scale;const Ht=q.minimap.maxColumn,qt=q.minimap.size,mt=q.minimap.side,It=q.verticalScrollbarWidth,ii=q.viewLineCount,Xt=q.remainingWidth,zt=q.isViewportWrapping,St=ti?2:3;let Ot=Math.floor(dt*Je);const di=Ot/dt;let Wt=!1,Xe=!1,Qt=St*Qe,ni=Qe/dt,hi=1;if(qt==="fill"||qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:$t,extraLinesBeyondLastLine:jt,desiredRatio:oi,minimapLineCount:Pt}=oe.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:ui,paddingTop:q.paddingTop,paddingBottom:q.paddingBottom,height:Je,lineHeight:Ft,pixelRatio:dt});if(ii/Pt>1)Wt=!0,Xe=!0,Qe=1,Qt=1,ni=Qe/dt;else{let bt=!1,Jt=Qe+1;if(qt==="fit"){const Dt=Math.ceil(($t+ii+jt)*Qt);zt&&Lt&&Xt<=Ce.stableFitRemainingWidth?(bt=!0,Jt=Ce.stableFitMaxMinimapScale):bt=Dt>Ot}if(qt==="fill"||bt){Wt=!0;const Dt=Qe;Qt=Math.min(Ft*dt,Math.max(1,Math.floor(1/oi))),zt&&Lt&&Xt<=Ce.stableFitRemainingWidth&&(Jt=Ce.stableFitMaxMinimapScale),Qe=Math.min(Jt,Math.max(1,Math.floor(Qt/St))),Qe>Dt&&(hi=Math.min(2,Qe/Dt)),ni=Qe/dt/hi,Ot=Math.ceil(Math.max(si,$t+ii+jt)*Qt),zt?(Ce.stableMinimapLayoutInput=q,Ce.stableFitRemainingWidth=Xt,Ce.stableFitMaxMinimapScale=Qe):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const yt=Math.floor(Ht*ni),Nt=Math.min(yt,Math.max(0,Math.floor((Xt-It-2)*ni/(ei+ni)))+e.MINIMAP_GUTTER_WIDTH);let kt=Math.floor(dt*Nt);const Ut=kt/dt;kt=Math.floor(kt*hi);const ri=ti?Ee.Text:Ee.Blocks,Yt=mt==="left"?0:Ge-Nt-It;return{renderMinimap:ri,minimapLeft:Yt,minimapWidth:Nt,minimapHeightIsEditorHeight:Wt,minimapIsSampling:Xe,minimapScale:Qe,minimapLineHeight:Qt,minimapCanvasInnerWidth:kt,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:di}}static computeLayout(q,Ce){const Ge=Ce.outerWidth|0,Je=Ce.outerHeight|0,dt=Ce.lineHeight|0,vt=Ce.lineNumbersDigitCount|0,Lt=Ce.typicalHalfwidthCharacterWidth,Ft=Ce.maxDigitWidth,ei=Ce.pixelRatio,ui=Ce.viewLineCount,ti=q.get(Be.wordWrapOverride2),Qe=ti==="inherit"?q.get(Be.wordWrapOverride1):ti,Ht=Qe==="inherit"?q.get(Be.wordWrap):Qe,qt=q.get(Be.wordWrapColumn),mt=Ce.isDominatedByLongLines,It=q.get(Be.glyphMargin),ii=q.get(Be.lineNumbers).renderType!==Ue.Off,Xt=q.get(Be.lineNumbersMinChars),zt=q.get(Be.scrollBeyondLastLine),St=q.get(Be.padding),Ot=q.get(Be.minimap),di=q.get(Be.scrollbar),Wt=di.verticalScrollbarSize,Xe=di.verticalHasArrows,Qt=di.arrowSize,ni=di.horizontalScrollbarSize,hi=q.get(Be.folding),yt=q.get(Be.showFoldingControls)!=="never";let Nt=q.get(Be.lineDecorationsWidth);hi&&yt&&(Nt+=16);let kt=0;if(ii){const Vt=Math.max(vt,Xt);kt=Math.round(Vt*Ft)}let Ut=0;It&&(Ut=dt*Ce.glyphMarginDecorationLaneCount);let ri=0,Yt=ri+Ut,si=Yt+kt,$t=si+Nt;const jt=Ge-Ut-kt-Nt;let oi=!1,Pt=!1,Ct=-1;Qe==="inherit"&&mt?(oi=!0,Pt=!0):Ht==="on"||Ht==="bounded"?Pt=!0:Ht==="wordWrapColumn"&&(Ct=qt);const bt=oe._computeMinimapLayout({outerWidth:Ge,outerHeight:Je,lineHeight:dt,typicalHalfwidthCharacterWidth:Lt,pixelRatio:ei,scrollBeyondLastLine:zt,paddingTop:St.top,paddingBottom:St.bottom,minimap:Ot,verticalScrollbarWidth:Wt,viewLineCount:ui,remainingWidth:jt,isViewportWrapping:Pt},Ce.memory||new _);bt.renderMinimap!==Ee.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,Yt+=bt.minimapWidth,si+=bt.minimapWidth,$t+=bt.minimapWidth);const Jt=jt-bt.minimapWidth,Dt=Math.max(1,Math.floor((Jt-Wt-2)/Lt)),fi=Xe?Qt:0;return Pt&&(Ct=Math.max(1,Dt),Ht==="bounded"&&(Ct=Math.min(Ct,qt))),{width:Ge,height:Je,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Yt,lineNumbersWidth:kt,decorationsLeft:si,decorationsWidth:Nt,contentLeft:$t,contentWidth:Jt,minimap:bt,viewportColumn:Dt,isWordWrapMinified:oi,isViewportWrapping:Pt,wrappingColumn:Ct,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Wt,height:Je-2*fi,right:0}}}}e.EditorLayoutInfoComputer=oe;class Ie extends h{constructor(){super(Be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(q){return p(q,"simple",["simple","advanced"])}compute(q,Ce,Ge){return Ce.get(Be.accessibilitySupport)===k.AccessibilitySupport.Enabled?"advanced":Ge}}var Me;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class X extends h{constructor(){const q={enabled:Me.On};super(Be.lightbulb,"lightbulb",q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:q.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{enabled:p(q.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class $ extends h{constructor(){const q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Be.stickyScroll,"stickyScroll",q,{"editor.stickyScroll.enabled":{type:"boolean",default:q.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:q.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:q.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:q.scrollWithEditor,description:a.localize(57,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends h{constructor(){const q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Be.inlayHints,"inlayHints",q,{"editor.inlayHints.enabled":{type:"string",default:q.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:q.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:q.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:q.padding,description:a.localize(65,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:p(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:i(Ce.padding,this.defaultValue.padding)}}}class Se extends h{constructor(){super(Be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(q){return typeof q=="string"&&/^\d+(\.\d+)?ch$/.test(q)?-parseFloat(q.substring(0,q.length-2)):l.clampedInt(q,this.defaultValue,0,1e3)}compute(q,Ce,Ge){return Ge<0?l.clampedInt(-Ge*q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ce extends g{constructor(){super(Be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,q=>g.clamp(q,0,150),{markdownDescription:a.localize(66,null)})}compute(q,Ce,Ge){return q.fontInfo.lineHeight}}class be extends h{constructor(){const q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Be.minimap,"minimap",q,{"editor.minimap.enabled":{type:"boolean",default:q.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:q.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:q.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:q.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:q.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:q.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:q.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:q.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:q.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:q.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:q.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),autohide:i(Ce.autohide,this.defaultValue.autohide),size:p(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Ce.side,this.defaultValue.side,["right","left"]),showSlider:p(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Ce.scale,1,1,3),maxColumn:l.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ee){return ee==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends h{constructor(){super(Be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{top:l.clampedInt(Ce.top,0,0,1e3),bottom:l.clampedInt(Ce.bottom,0,0,1e3)}}}class J extends h{constructor(){const q={enabled:!0,cycle:!0};super(Be.parameterHints,"parameterHints",q,{"editor.parameterHints.enabled":{type:"boolean",default:q.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:q.cycle,description:a.localize(85,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),cycle:i(Ce.cycle,this.defaultValue.cycle)}}}class pe extends o{constructor(){super(Be.pixelRatio)}compute(q,Ce,Ge){return q.pixelRatio}}class ve extends h{constructor(){super(Be.placeholder,"placeholder",void 0)}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q:this.defaultValue}}class Oe extends h{constructor(){const q={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(Be.quickSuggestions,"quickSuggestions",q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:q.strings,description:a.localize(89,null)},comments:{anyOf:Ce,default:q.comments,description:a.localize(90,null)},other:{anyOf:Ce,default:q.other,description:a.localize(91,null)}},default:q,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=q}validate(q){if(typeof q=="boolean"){const ei=q?"on":"off";return{comments:ei,strings:ei,other:ei}}if(!q||typeof q!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:Je}=q,dt=["on","inline","off"];let vt,Lt,Ft;return typeof Ce=="boolean"?vt=Ce?"on":"off":vt=p(Ce,this.defaultValue.other,dt),typeof Ge=="boolean"?Lt=Ge?"on":"off":Lt=p(Ge,this.defaultValue.comments,dt),typeof Je=="boolean"?Ft=Je?"on":"off":Ft=p(Je,this.defaultValue.strings,dt),{other:vt,comments:Lt,strings:Ft}}}var Ue;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class De extends h{constructor(){super(Be.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(q){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof q<"u"&&(typeof q=="function"?(Ce=Ue.Custom,Ge=q):q==="interval"?Ce=Ue.Interval:q==="relative"?Ce=Ue.Relative:q==="on"?Ce=Ue.On:Ce=Ue.Off),{renderType:Ce,renderFn:Ge}}}function Ae(ee){const q=ee.get(Be.renderValidationDecorations);return q==="editable"?ee.get(Be.readOnly):q!=="on"}class Le extends h{constructor(){const q=[],Ce={type:"number",description:a.localize(98,null)};super(Be.rulers,"rulers",q,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:q,description:a.localize(100,null)})}validate(q){if(Array.isArray(q)){const Ce=[];for(const Ge of q)if(typeof Ge=="number")Ce.push({column:l.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Je=Ge;Ce.push({column:l.clampedInt(Je.column,0,0,1e4),color:Je.color})}return Ce.sort((Ge,Je)=>Ge.column-Je.column),Ce}return this.defaultValue}}class B extends h{constructor(){super(Be.readOnlyMessage,"readOnlyMessage",void 0)}validate(q){return!q||typeof q!="object"?this.defaultValue:q}}function x(ee,q){if(typeof ee!="string")return q;switch(ee){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends h{constructor(){const q={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Be.scrollbar,"scrollbar",q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:q.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:q.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:q.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:q.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q,Ge=l.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=l.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(Ce.vertical,this.defaultValue.vertical),horizontal:x(Ce.horizontal,this.defaultValue.horizontal),useShadows:i(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:l.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:l.clampedInt(Ce.verticalSliderSize,Je,0,1e3),scrollByPage:i(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class j extends h{constructor(){const q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Be.unicodeHighlighting,"unicodeHighlight",q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:q.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:q.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:q.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:q.allowedLocales,description:a.localize(119,null)}})}applyUpdate(q,Ce){let Ge=!1;Ce.allowedCharacters&&q&&(T.equals(q.allowedCharacters,Ce.allowedCharacters)||(q={...q,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&q&&(T.equals(q.allowedLocales,Ce.allowedLocales)||(q={...q,allowedLocales:Ce.allowedLocales},Ge=!0));const Je=super.applyUpdate(q,Ce);return Ge?new n(Je.newValue,!0):Je}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{nonBasicASCII:qe(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:qe(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:qe(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(q,Ce){if(typeof q!="object"||!q)return Ce;const Ge={};for(const[Je,dt]of Object.entries(q))dt===!0&&(Ge[Je]=!0);return Ge}}class ne extends h{constructor(){const q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Be.inlineSuggest,"inlineSuggest",q,{"editor.inlineSuggest.enabled":{type:"boolean",default:q.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:q.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:q.fontFamily,description:a.localize(126,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),mode:p(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class fe extends h{constructor(){const q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Be.inlineEdit,"experimentalInlineEdit",q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:q.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:q.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:q.backgroundColoring,description:a.localize(133,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showToolbar:p(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class ke extends h{constructor(){const q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Be.bracketPairColorization,"bracketPairColorization",q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:q.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class xe extends h{constructor(){const q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Be.guides,"guides",q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:q.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:q.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:q.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:q.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:q.highlightActiveIndentation,description:a.localize(149,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{bracketPairs:qe(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:qe(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:qe(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function qe(ee,q,Ce){const Ge=Ce.indexOf(ee);return Ge===-1?q:Ce[Ge]}class Ze extends h{constructor(){const q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Be.suggest,"suggest",q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:q.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:q.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:q.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:q.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:q.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:q.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:q.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:q.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:q.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:q.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{insertMode:p(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ce.preview,this.defaultValue.preview),previewMode:p(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ce.showMethods,this.defaultValue.showMethods),showFunctions:i(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ce.showFields,this.defaultValue.showFields),showVariables:i(Ce.showVariables,this.defaultValue.showVariables),showClasses:i(Ce.showClasses,this.defaultValue.showClasses),showStructs:i(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ce.showModules,this.defaultValue.showModules),showProperties:i(Ce.showProperties,this.defaultValue.showProperties),showEvents:i(Ce.showEvents,this.defaultValue.showEvents),showOperators:i(Ce.showOperators,this.defaultValue.showOperators),showUnits:i(Ce.showUnits,this.defaultValue.showUnits),showValues:i(Ce.showValues,this.defaultValue.showValues),showConstants:i(Ce.showConstants,this.defaultValue.showConstants),showEnums:i(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ce.showKeywords,this.defaultValue.showKeywords),showWords:i(Ce.showWords,this.defaultValue.showWords),showColors:i(Ce.showColors,this.defaultValue.showColors),showFiles:i(Ce.showFiles,this.defaultValue.showFiles),showReferences:i(Ce.showReferences,this.defaultValue.showReferences),showFolders:i(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ce.showUsers,this.defaultValue.showUsers),showIssues:i(Ce.showIssues,this.defaultValue.showIssues)}}}class tt extends h{constructor(){super(Be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends h{constructor(){const q=[];super(Be.wordSegmenterLocales,"wordSegmenterLocales",q,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(q){if(typeof q=="string"&&(q=[q]),Array.isArray(q)){const Ce=[];for(const Ge of q)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ce.push(Ge)}catch{}return Ce}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends h{constructor(){super(Be.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(q){switch(q){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(q,Ce,Ge){return Ce.get(Be.accessibilitySupport)===k.AccessibilitySupport.Enabled?et.None:Ge}}class ft extends o{constructor(){super(Be.wrappingInfo)}compute(q,Ce,Ge){const Je=Ce.get(Be.layoutInfo);return{isDominatedByLongLines:q.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class lt extends h{constructor(){const q={enabled:!0,showDropSelector:"afterDrop"};super(Be.dropIntoEditor,"dropIntoEditor",q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showDropSelector:p(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends h{constructor(){const q={enabled:!0,showPasteSelector:"afterPaste"};super(Be.pasteAs,"pasteAs",q,{"editor.pasteAs.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ce=q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showPasteSelector:p(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?gt:I.isLinux?pt:ct,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Be;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new r(Be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:ze(new y(Be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:ze(new D),accessibilityPageSize:ze(new l(Be.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:ze(new m(Be.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:ze(new r(Be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new r(Be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ze(new y(Be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:ze(new y(Be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:ze(new y(Be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:ze(new y(Be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:ze(new y(Be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:ze(new C(Be.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:ze(new r(Be.automaticLayout,"automaticLayout",!1)),autoSurround:ze(new y(Be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:ze(new ke),bracketPairGuides:ze(new xe),stickyTabStops:ze(new r(Be.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:ze(new r(Be.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:ze(new m(Be.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:ze(new l(Be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:ze(new r(Be.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:ze(new y(Be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:ze(new l(Be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:ze(new r(Be.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:ze(new P),contextmenu:ze(new r(Be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new r(Be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:ze(new C(Be.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],E,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:ze(new y(Be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:ze(new C(Be.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:a.localize(261,null)})),cursorSurroundingLines:ze(new l(Be.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:ze(new y(Be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:ze(new l(Be.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:ze(new r(Be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new r(Be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new r(Be.domReadOnly,"domReadOnly",!1)),dragAndDrop:ze(new r(Be.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:ze(new W),dropIntoEditor:ze(new lt),stickyScroll:ze(new $),experimentalWhitespaceRendering:ze(new y(Be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:ze(new m(Be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ze(new g(Be.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:a.localize(272,null)})),find:ze(new N),fixedOverflowWidgets:ze(new r(Be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ze(new r(Be.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:ze(new y(Be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:ze(new r(Be.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:ze(new r(Be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:ze(new l(Be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:ze(new r(Be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:ze(new m(Be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:ze(new ge),fontLigatures2:ze(new Q),fontSize:ze(new Z),fontWeight:ze(new me),fontVariations:ze(new Y),formatOnPaste:ze(new r(Be.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:ze(new r(Be.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:ze(new r(Be.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:ze(new se),hideCursorInOverviewRuler:ze(new r(Be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:ze(new le),inDiffEditor:ze(new r(Be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ze(new g(Be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>g.clamp(ee,-5,20),{description:a.localize(286,null)})),lightbulb:ze(new X),lineDecorationsWidth:ze(new Se),lineHeight:ze(new ce),lineNumbers:ze(new De),lineNumbersMinChars:ze(new l(Be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new r(Be.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:ze(new r(Be.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:ze(new y(Be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:ze(new be),mouseStyle:ze(new y(Be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new g(Be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:ze(new r(Be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.isMacintosh?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:ze(new r(Be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:ze(new C(Be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:ze(new y(Be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:ze(new l(Be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:ze(new y(Be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:ze(new r(Be.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:ze(new l(Be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ze(new G),pasteAs:ze(new st),parameterHints:ze(new J),peekWidgetDefaultFocus:ze(new y(Be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:ze(new ve),definitionLinkOpensInPeek:ze(new r(Be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:ze(new Oe),quickSuggestionsDelay:ze(new l(Be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:ze(new r(Be.readOnly,"readOnly",!1)),readOnlyMessage:ze(new B),renameOnType:ze(new r(Be.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:ze(new r(Be.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:ze(new y(Be.renderFinalNewline,"renderFinalNewline",I.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:ze(new y(Be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ze(new r(Be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:ze(new y(Be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new y(Be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:ze(new l(Be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new r(Be.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:ze(new Le),scrollbar:ze(new H),scrollBeyondLastColumn:ze(new l(Be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:ze(new r(Be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:ze(new r(Be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:ze(new r(Be.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:I.isLinux})),selectionHighlight:ze(new r(Be.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:ze(new r(Be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ze(new y(Be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:ze(new r(Be.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:ze(new r(Be.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:ze(new te),snippetSuggestions:ze(new y(Be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:ze(new tt),smoothScrolling:ze(new r(Be.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:ze(new l(Be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ze(new Ze),inlineSuggest:ze(new ne),inlineEdit:ze(new fe),inlineCompletionsAccessibilityVerbose:ze(new r(Be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:ze(new l(Be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new l(Be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new r(Be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:ze(new y(Be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:ze(new y(Be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:ze(new l(Be.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ze(new j),unusualLineTerminators:ze(new y(Be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:ze(new r(Be.useShadowDOM,"useShadowDOM",!0)),useTabStops:ze(new r(Be.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:ze(new y(Be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:ze(new nt),wordSeparators:ze(new m(Be.wordSeparators,"wordSeparators",v.USUAL_WORD_SEPARATORS,{description:a.localize(360,null)})),wordWrap:ze(new y(Be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:ze(new m(Be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new m(Be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new l(Be.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:ze(new y(Be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new y(Be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new V),defaultColorDecorators:ze(new r(Be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:ze(new pe),tabFocusMode:ze(new r(Be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:ze(new oe),wrappingInfo:ze(new ft),wrappingIndent:ze(new rt),wrappingStrategy:ze(new Ie)}}),define(Te[107],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[30],Pe([1,0,59,20,13,15,2,174,3,21,16,48]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=c,e.isFileSystemWatcher=s,e.hasReadWriteCapability=d,e.hasFileFolderCopyCapability=i,e.hasFileCloneCapability=r,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=l,e.hasFileAtomicReadCapability=u,e.hasFileAtomicWriteCapability=g,e.hasFileAtomicDeleteCapability=m,e.hasReadonlyCapability=p,e.createFileSystemProviderError=b,e.ensureFileSystemProviderError=D,e.markAsFileSystemProviderError=P,e.toFileSystemProviderErrorCode=f,e.toFileOperationResult=E,e.isParent=W,e.etag=me,e.whenProviderRegistered=se,e.getLargeFileConfirmationLimit=Ee,e.IFileService=(0,v.createDecorator)("fileService");function c(oe){return oe.create===!0}var _;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(_||(e.FileType=_={}));var h;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function s(oe){const Ie=oe;return!!Ie&&typeof Ie.onDidChange=="function"}var o;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function d(oe){return!!(oe.capabilities&o.FileReadWrite)}function i(oe){return!!(oe.capabilities&o.FileFolderCopy)}function r(oe){return!!(oe.capabilities&o.FileClone)}function t(oe){return!!(oe.capabilities&o.FileOpenReadWriteClose)}function l(oe){return!!(oe.capabilities&o.FileReadStream)}function u(oe){return d(oe)?!!(oe.capabilities&o.FileAtomicRead):!1}function g(oe){return d(oe)?!!(oe.capabilities&o.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&o.FileAtomicDelete)}function p(oe){return!!(oe.capabilities&o.Readonly)}var y;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class C extends Error{static create(Ie,Me){const X=new C(Ie.toString(),Me);return P(X,Me),X}constructor(Ie,Me){super(Ie),this.code=Me}}e.FileSystemProviderError=C;function b(oe,Ie){return C.create(oe,Ie)}function D(oe){return oe||b((0,R.localize)(0,null),y.Unknown)}function P(oe,Ie){return oe.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return y.Unknown;if(oe instanceof C)return oe.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Ie)return y.Unknown;switch(Ie[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function E(oe){if(oe instanceof N)return oe.fileOperationResult;switch(f(oe)){case y.FileNotFound:return ge.FILE_NOT_FOUND;case y.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case y.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case y.NoPermissions:return ge.FILE_PERMISSION_DENIED;case y.FileExists:return ge.FILE_MOVE_CONFLICT;case y.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class L{constructor(Ie,Me,X){this.resource=Ie,this.operation=Me,this.target=X}isOperation(Ie){return this.operation===Ie}}e.FileOperationEvent=L;var M;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class V{static{this.MIXED_CORRELATION=null}constructor(Ie,Me){this.ignorePathCasing=Me,this.correlationId=void 0,this.added=new w.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawAdded.map($=>[$,!0])),X}),this.updated=new w.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawUpdated.map($=>[$,!0])),X}),this.deleted=new w.Lazy(()=>{const X=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawDeleted.map($=>[$,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ie){switch(X.type){case M.ADDED:this.rawAdded.push(X.resource);break;case M.UPDATED:this.rawUpdated.push(X.resource);break;case M.DELETED:this.rawDeleted.push(X.resource);break}this.correlationId!==V.MIXED_CORRELATION&&(typeof X.cId=="number"?this.correlationId===void 0?this.correlationId=X.cId:this.correlationId!==X.cId&&(this.correlationId=V.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=V.MIXED_CORRELATION))}}contains(Ie,...Me){return this.doContains(Ie,{includeChildren:!1},...Me)}affects(Ie,...Me){return this.doContains(Ie,{includeChildren:!0},...Me)}doContains(Ie,Me,...X){if(!Ie)return!1;const $=X.length>0;return!!((!$||X.includes(M.ADDED))&&(this.added.value.get(Ie)||Me.includeChildren&&this.added.value.findSuperstr(Ie))||(!$||X.includes(M.UPDATED))&&(this.updated.value.get(Ie)||Me.includeChildren&&this.updated.value.findSuperstr(Ie))||(!$||X.includes(M.DELETED))&&(this.deleted.value.findSubstr(Ie)||Me.includeChildren&&this.deleted.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.correlationId===Ie}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=V;function W(oe,Ie,Me){return!oe||!Ie||oe===Ie||Ie.length>oe.length?!1:(Ie.charAt(Ie.length-1)!==T.sep&&(Ie+=T.sep),Me?(0,I.startsWithIgnoreCase)(oe,Ie):oe.indexOf(Ie)===0)}class N extends Error{constructor(Ie,Me,X){super(Ie),this.fileOperationResult=Me,this.options=X}}e.FileOperationError=N;class Q extends N{constructor(Ie,Me,X,$){super(Ie,Me,$),this.fileOperationResult=Me,this.size=X}}e.TooLargeFileOperationError=Q;class Y extends N{constructor(Ie,Me,X){super(Ie,ge.FILE_NOT_MODIFIED_SINCE,X),this.stat=Me}}e.NotModifiedSinceFileOperationError=Y;var ge;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Z;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.ETAG_DISABLED="";function me(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,Ie){if(!Ie.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Me=>{const X=Ie.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===oe.scheme&&$.added&&(X.dispose(),Me())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Ie){return(0,O.isNumber)(Ie)||(Ie=0),Ie<le.KB?(0,R.localize)(1,null,Ie.toFixed(0)):Ie<le.MB?(0,R.localize)(2,null,(Ie/le.KB).toFixed(2)):Ie<le.GB?(0,R.localize)(3,null,(Ie/le.MB).toFixed(2)):Ie<le.TB?(0,R.localize)(4,null,(Ie/le.GB).toFixed(2)):(0,R.localize)(5,null,(Ie/le.TB).toFixed(2))}}e.ByteSize=le;function Ee(oe){const Ie=typeof oe=="string"||oe?.scheme===k.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===k.Schemas.file?1024*le.MB:Ie?10*le.MB:a.isWeb?50*le.MB:1024*le.MB}}),define(Te[75],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...I){this._entries=new Map;for(const[O,A]of I)this.set(O,A)}set(I,O){const A=this._entries.get(I);return this._entries.set(I,O),A}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=S}),define(Te[211],Pe([1,0,11,14,4,74,208,3,75,212]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const k=!1;class w extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class c{constructor(s=new v.ServiceCollection,o=!1,d,i=k){this._services=s,this._strict=o,this._parent=d,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=i?d?._globalGraph??new A.Graph(r=>r):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,I.dispose)(this._children),this._children.clear();for(const s of this._servicesToMaybeDispose)(0,I.isDisposable)(s)&&s.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(s,o){this._throwIfDisposed();const d=this,i=new class extends c{dispose(){d._children.delete(i),super.dispose()}}(s,this._strict,this,this._enableTracing);return this._children.add(i),o?.add(i),i}invokeFunction(s,...o){this._throwIfDisposed();const d=h.traceInvocation(this._enableTracing,s);let i=!1;try{return s({get:t=>{if(i)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(t,d);if(!l)throw new Error(`[invokeFunction] unknown service '${t}'`);return l}},...o)}finally{i=!0,d.stop()}}createInstance(s,...o){this._throwIfDisposed();let d,i;return s instanceof O.SyncDescriptor?(d=h.traceCreation(this._enableTracing,s.ctor),i=this._createInstance(s.ctor,s.staticArguments.concat(o),d)):(d=h.traceCreation(this._enableTracing,s),i=this._createInstance(s,o,d)),d.stop(),i}_createInstance(s,o=[],d){const i=R._util.getServiceDependencies(s).sort((l,u)=>l.index-u.index),r=[];for(const l of i){const u=this._getOrCreateServiceInstance(l.id,d);u||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${l.id}.`,!1),r.push(u)}const t=i.length>0?i[0].index:o.length;if(o.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${o.length} static arguments`);const l=t-o.length;l>0?o=o.concat(new Array(l)):o=o.slice(0,t)}return Reflect.construct(s,o.concat(r))}_setCreatedServiceInstance(s,o){if(this._services.get(s)instanceof O.SyncDescriptor)this._services.set(s,o);else if(this._parent)this._parent._setCreatedServiceInstance(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const o=this._services.get(s);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):o}_getOrCreateServiceInstance(s,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const d=this._getServiceInstanceOrDescriptor(s);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,d,o.branch(s,!0)):(o.branch(s,!1),d)}_safeCreateAndCacheServiceInstance(s,o,d){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,o,d)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,o,d){const i=new A.Graph(l=>l.id.toString());let r=0;const t=[{id:s,desc:o,_trace:d}];for(;t.length;){const l=t.pop();if(i.lookupOrInsertNode(l),r++>1e3)throw new w(i);for(const u of R._util.getServiceDependencies(l.desc.ctor)){const g=this._getServiceInstanceOrDescriptor(u.id);if(g||this._throwIfStrict(`[createInstance] ${s} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(u.id)),g instanceof O.SyncDescriptor){const m={id:u.id,desc:g,_trace:l._trace.branch(u.id,!0)};i.insertEdge(l,m),t.push(m)}}}for(;;){const l=i.roots();if(l.length===0){if(!i.isEmpty())throw new w(i);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof O.SyncDescriptor){const m=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setCreatedServiceInstance(u.id,m)}i.removeNode(u)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,o,d=[],i,r){if(this._services.get(s)instanceof O.SyncDescriptor)return this._createServiceInstance(s,o,d,i,r,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,o,d,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(s,o,d=[],i,r,t){if(i){const l=new c(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(s);const u=new Map,g=new S.GlobalIdleValue(()=>{const m=l._createInstance(o,d,r);for(const[p,y]of u){const C=m[p];if(typeof C=="function")for(const b of y)b.disposable=C.apply(m,b.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,p){if(!g.isInitialized&&typeof p=="string"&&(p.startsWith("onDid")||p.startsWith("onWill"))){let b=u.get(p);return b||(b=new a.LinkedList,u.set(p,b)),(P,f,E)=>{if(g.isInitialized)return g.value[p](P,f,E);{const F={listener:[P,f,E],disposable:void 0},L=b.push(F);return(0,I.toDisposable)(()=>{L(),F.disposable?.dispose()})}}}if(p in m)return m[p];const y=g.value;let C=y[p];return typeof C!="function"||(C=C.bind(y),m[p]=C),C},set(m,p,y){return g.value[p]=y,!0},getPrototypeOf(m){return o.prototype}})}else{const l=this._createInstance(o,d,r);return t.add(l),l}}_throwIfStrict(s,o){if(o&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=c;var _;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(_||(_={}));class h{static{this.all=new Set}static{this._None=new class extends h{constructor(){super(_.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new h(_.Invocation,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(s,o){return s?new h(_.Creation,o.name):h._None}static{this._totals=0}constructor(s,o){this.type=s,this.name=o,this._start=Date.now(),this._dep=[]}branch(s,o){const d=new h(_.Branch,s.toString());return this._dep.push([s,o,d]),d}stop(){const s=Date.now()-this._start;h._totals+=s;let o=!1;function d(r,t){const l=[],u=new Array(r+1).join("	");for(const[g,m,p]of t._dep)if(m&&p){o=!0,l.push(`${u}CREATES -> ${g}`);const y=d(r+1,p);y&&l.push(y)}else l.push(`${u}uses -> ${g}`);return l.join(`
`)}const i=[`${this.type===_.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(s>2||o)&&h.all.add(i.join(`
`))}}e.Trace=h}),define(Te[12],Pe([1,0,175,41,6,76,4,29,21,24,15,2,32,3]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=n,e.log=o,e.getLogLevel=C,e.LogLevelToString=b,e.LogLevelToLocalizedString=D,e.parseLogLevel=P,S=$e(S),e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function h(){return new Date().toISOString()}function n(f){return(0,k.isNumber)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.DEFAULT_LOG_LEVEL=s.Info;function o(f,E,F){switch(E){case s.Trace:f.trace(F);break;case s.Debug:f.debug(F);break;case s.Info:f.info(F);break;case s.Warning:f.warn(F);break;case s.Error:f.error(F);break;case s.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function d(f,E=!1){let F="";for(let L=0;L<f.length;L++){let M=f[L];if(M instanceof Error&&(M=(0,T.toErrorMessage)(M,E)),typeof M=="object")try{M=JSON.stringify(M)}catch{}F+=(L>0?" ":"")+M}return F}class i extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==s.Off&&this.level<=E}}e.AbstractLogger=i;class r extends i{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...F){this.checkLogLevel(s.Trace)&&this.log(s.Trace,d([E,...F],!0))}debug(E,...F){this.checkLogLevel(s.Debug)&&this.log(s.Debug,d([E,...F]))}info(E,...F){this.checkLogLevel(s.Info)&&this.log(s.Info,d([E,...F]))}warn(E,...F){this.checkLogLevel(s.Warning)&&this.log(s.Warning,d([E,...F]))}error(E,...F){if(this.checkLogLevel(s.Error))if(E instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=E.stack,this.log(s.Error,d(L))}else this.log(s.Error,d([E,...F]))}flush(){}}e.AbstractMessageLogger=r;class t extends i{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!v.isWindows}trace(E,...F){this.checkLogLevel(s.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...F):console.log(`[main ${h()}]`,E,...F))}debug(E,...F){this.checkLogLevel(s.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...F):console.log(`[main ${h()}]`,E,...F))}info(E,...F){this.checkLogLevel(s.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...F):console.log(`[main ${h()}]`,E,...F))}warn(E,...F){this.checkLogLevel(s.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,E,...F):console.warn(`[main ${h()}]`,E,...F))}error(E,...F){this.checkLogLevel(s.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,E,...F):console.error(`[main ${h()}]`,E,...F))}flush(){}}e.ConsoleMainLogger=t;class l extends i{constructor(E=e.DEFAULT_LOG_LEVEL,F=!0){super(),this.useColors=F,this.setLevel(E)}trace(E,...F){this.checkLogLevel(s.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...F):console.log(E,...F))}debug(E,...F){this.checkLogLevel(s.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...F):console.log(E,...F))}info(E,...F){this.checkLogLevel(s.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...F):console.log(E,...F))}warn(E,...F){this.checkLogLevel(s.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...F):console.log(E,...F))}error(E,...F){this.checkLogLevel(s.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...F):console.error(E,...F))}flush(){}}e.ConsoleLogger=l;class u extends i{constructor(E,F=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(F)}trace(E,...F){this.checkLogLevel(s.Trace)&&this.adapter.log(s.Trace,[this.extractMessage(E),...F])}debug(E,...F){this.checkLogLevel(s.Debug)&&this.adapter.log(s.Debug,[this.extractMessage(E),...F])}info(E,...F){this.checkLogLevel(s.Info)&&this.adapter.log(s.Info,[this.extractMessage(E),...F])}warn(E,...F){this.checkLogLevel(s.Warning)&&this.adapter.log(s.Warning,[this.extractMessage(E),...F])}error(E,...F){this.checkLogLevel(s.Error)&&this.adapter.log(s.Error,[this.extractMessage(E),...F])}extractMessage(E){return typeof E=="string"?E:(0,T.toErrorMessage)(E,this.checkLogLevel(s.Trace))}flush(){}}e.AdapterLogger=u;class g extends i{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const F of this.loggers)F.setLevel(E);super.setLevel(E)}trace(E,...F){for(const L of this.loggers)L.trace(E,...F)}debug(E,...F){for(const L of this.loggers)L.debug(E,...F)}info(E,...F){for(const L of this.loggers)L.info(E,...F)}warn(E,...F){for(const L of this.loggers)L.warn(E,...F)}error(E,...F){for(const L of this.loggers)L.error(E,...F)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose();super.dispose()}}e.MultiplexLogger=g;class m extends A.Disposable{constructor(E,F,L){if(super(),this.logLevel=E,this.logsHome=F,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new I.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const M of L)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(E){return(0,k.isString)(E)?[...this._loggers.values()].find(F=>F.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,F){const L=this.toResource(E),M=(0,k.isString)(E)?E:F?.id??(0,O.hash)(L.toString()).toString(16);let V=this._loggers.get(L)?.logger;const W=F?.logLevel==="always"?s.Trace:F?.logLevel;V||(V=this.doCreateLogger(L,W??this.getLogLevel(L)??this.logLevel,{...F,id:M}));const N={logger:V,info:{resource:L,id:M,logLevel:W,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(N.info),this._loggers.set(L,N),V}toResource(E){return(0,k.isString)(E)?(0,a.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,F){if(w.URI.isUri(E)){const L=E,M=F,V=this._loggers.get(L);V&&M!==V.info.logLevel&&(V.info.logLevel=M===this.logLevel?void 0:M,V.logger?.setLevel(M),this._loggers.set(V.info.resource,V),this._onDidChangeLogLevel.fire([L,M]))}else{this.logLevel=E;for(const[L,M]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,F){const L=this.getLoggerEntry(E);L&&F!==!L.info.hidden&&(L.info.hidden=!F,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,F]))}getLogLevel(E){let F;return E&&(F=this._loggers.get(E)?.info.logLevel),F??this.logLevel}registerLogger(E){const F=this._loggers.get(E.resource);F?F.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const F=this._loggers.get(E);F&&(F.logger&&F.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class p{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(E){}getLevel(){return s.Info}trace(E,...F){}debug(E,...F){}info(E,...F){}warn(E,...F){}error(E,...F){}critical(E,...F){}dispose(){}flush(){}}e.NullLogger=p;class y extends p{}e.NullLogService=y;function C(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const E=P(f.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}function b(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function D(f){switch(f){case s.Trace:return{original:"Trace",value:S.localize(0,null)};case s.Debug:return{original:"Debug",value:S.localize(1,null)};case s.Info:return{original:"Info",value:S.localize(2,null)};case s.Warning:return{original:"Warning",value:S.localize(3,null)};case s.Error:return{original:"Error",value:S.localize(4,null)};case s.Off:return{original:"Off",value:S.localize(5,null)}}}function P(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.CONTEXT_LOG_LEVEL=new c.RawContextKey("logLevel",b(s.Info))}),define(Te[213],Pe([1,0,4,12]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends S.Disposable{constructor(A,R=[]){super(),this.logger=new T.MultiplexLogger([A,...R]),this._register(A.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}flush(){this.logger.flush()}}e.LogService=I});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[108],Pe([1,0,36,176,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,S=Zt(S);var O;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(v){function a(h,n){return n-h}v.compare=a;const k=Object.create(null);k[v.Error]=(0,T.localize)(0,null),k[v.Warning]=(0,T.localize)(1,null),k[v.Info]=(0,T.localize)(2,null);function w(h){return k[h]||""}v.toString=w;function c(h){switch(h){case S.default.Error:return v.Error;case S.default.Warning:return v.Warning;case S.default.Info:return v.Info;case S.default.Ignore:return v.Hint}}v.fromSeverity=c;function _(h){switch(h){case v.Error:return S.default.Error;case v.Warning:return S.default.Warning;case v.Info:return S.default.Info;case v.Hint:return S.default.Ignore}}v.toSeverity=_}(A||(e.MarkerSeverity=A={}));var R;(function(v){const a="";function k(c){return w(c,!0)}v.makeKey=k;function w(c,_){const h=[a];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(a),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(a),c.severity!==void 0&&c.severity!==null?h.push(A.toString(c.severity)):h.push(a),c.message&&_?h.push(c.message.replace("\xA6","\\\xA6")):h.push(a),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(a),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(a),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(a),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(a),h.push(a),h.join("\xA6")}v.makeKeyOptionalMessage=w})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,I.createDecorator)("markerService")});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[214],Pe([1,0,6,36,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,T=Zt(T),e.Severity=T.default,e.INotificationService=(0,I.createDecorator)("notificationService");var O;(function(w){w[w.DEFAULT=0]="DEFAULT",w[w.SILENT=1]="SILENT",w[w.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.PROFILE=1]="PROFILE",w[w.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function R(w){if(w){const c=w;return typeof c.id=="string"&&typeof c.label=="string"}return!1}var v;(function(w){w[w.OFF=0]="OFF",w[w.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class a{constructor(){this.progress=new k,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(c){}updateMessage(c){}updateActions(c){}close(){}}e.NoOpNotification=a;class k{infinite(){}done(){}total(c){}worked(c){}}e.NoOpProgress=k}),define(Te[109],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(ae,e,S,T){var I=arguments.length,O=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,S):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ae,e,S,T);else for(var R=ae.length-1;R>=0;R--)(A=ae[R])&&(O=(I<3?A(O):I>3?A(e,S,O):A(e,S))||O);return I>3&&O&&Object.defineProperty(e,S,O),O},Ve=this&&this.__param||function(ae,e){return function(S,T){e(S,T,ae)}};define(Te[77],Pe([1,0,11,22,4,3]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var A;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(c){this.callback=c}report(c){this._value=c,this.callback(this._value)}}e.Progress=R;class v{get value(){return this._value}constructor(c){this.callback=c}report(c){this._asyncQueue?this._asyncQueue.push(c):this._asyncQueue=[c],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const c=this._asyncQueue.shift();this._value=c,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const c=this._drainListener;this._drainListener=void 0,c?.()}}drain(){return this._processingAsyncQueue?new Promise(c=>{const _=this._drainListener;this._drainListener=()=>{_?.(),c()}}):Promise.resolve()}}e.AsyncProgress=v;let a=class extends I.Disposable{constructor(c,_){super(),this.deferred=new S.DeferredPromise,_.withProgress(c,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(c){this.reporter?this.reporter.report(c):this.lastStep=c}};e.UnmanagedProgress=a,e.UnmanagedProgress=a=je([Ve(1,e.IProgressService)],a);class k extends I.Disposable{constructor(c){super(),this.progressIndicator=c,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(c){this.stop();const _=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},c),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:h.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(c){this.currentOperationId===c&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(Te[31],Pe([1,0,62,15]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,S=$e(S),T=$e(T);class I{constructor(){this.data=new Map}add(A,R){S.ok(T.isString(A)),S.ok(T.isObject(R)),S.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new I}),define(Te[78],Pe([1,0,6,31]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,T=$e(T),e.Extensions={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,a){this.schemasById[I(v)]=a,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new O;T.Registry.add(e.Extensions.JSONContribution,A)}),define(Te[54],Pe([1,0,18,6,15,169,43,78,31]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=n,e.keyFromOverrideIdentifiers=s,e.getDefaultValue=o,e.validateProperty=i,e.getScopes=r,I=$e(I),O=$e(O);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=v.Registry.as(R.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,u=!0){this.registerConfigurations([l],u)}registerConfigurations(l,u=!0){const g=new Set;this.doRegisterConfigurations(l,u,g),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}deregisterConfigurations(l){const u=new Set;this.doDeregisterConfigurations(l,u),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:l,remove:u}){const g=new Set;this.doDeregisterConfigurations(u,g),this.doRegisterConfigurations(l,!1,g),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}registerDefaultConfigurations(l){const u=new Set;this.doRegisterDefaultConfigurations(l,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(l,u){const g=[];for(const{overrides:m,source:p}of l)for(const y in m)if(u.add(y),e.OVERRIDE_PROPERTY_REGEX.test(y)){const C=this.configurationDefaultsOverrides.get(y),b=C?.valuesSources??new Map,D=C?.value||{};for(const E of Object.keys(m[y])){const F=m[y][E];if(I.isObject(F)&&(I.isUndefined(D[E])||I.isObject(D[E]))){if(D[E]={...D[E]??{},...F},p){let M=b.get(E);if(M||(M=new Map,b.set(E,M)),!(M instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const V in F)M.set(V,p)}}else D[E]=F,p&&b.set(E,p)}this.configurationDefaultsOverrides.set(y,{source:p,value:D,valuesSources:b});const P=(0,A.getLanguageTagSettingPlainKey)(y),f={type:"object",default:D,description:O.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:I.isString(p)?void 0:p,defaultValueSource:p};g.push(...n(y)),this.configurationProperties[y]=f,this.defaultLanguageConfigurationOverridesNode.properties[y]=f}else{const C=this.configurationProperties[y],b=this.configurationDefaultsOverrides.get(y);let D=b?.value??C?.defaultDefaultValue,P=m[y],f=p;if(I.isObject(P)&&(C!==void 0&&C.type==="object"||C===void 0&&(I.isUndefined(D)||I.isObject(D)))){if(I.isObject(D)||(D={}),P={...D,...P},f=b?.source??new Map,!(f instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const F in m[y])p?f.set(F,p):f.delete(F)}this.configurationDefaultsOverrides.set(y,{value:P,source:f}),C&&(this.updatePropertyDefaultValue(y,C),this.updateSchema(y,C))}this.doRegisterOverrideIdentifiers(g)}deregisterDefaultConfigurations(l){const u=new Set;this.doDeregisterDefaultConfigurations(l,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(l,u){for(const{overrides:g,source:m}of l)for(const p in g){const y=I.isString(m)?m:m?.id,C=this.configurationDefaultsOverrides.get(p);if(C){if(e.OVERRIDE_PROPERTY_REGEX.test(p)){for(const D of Object.keys(g[p])){const P=g[p][D];if(I.isObject(P)){const f=C.valuesSources?.get(D);for(const E of Object.keys(P)){const F=f?.get(E);(I.isString(F)?F:F?.id)===y&&(f?.delete(E),delete C.value[D][E])}Object.keys(C.value[D]).length===0&&(delete C.value[D],C.valuesSources?.delete(D))}else{const f=C.valuesSources?.get(D);(I.isString(f)?f:f?.id)===y&&(C.valuesSources?.delete(D),delete C.value[D])}}const b=this.configurationDefaultsOverrides.get(p);b&&Object.keys(b.value).length===0&&(this.configurationDefaultsOverrides.delete(p),delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p])}else{if(C.source instanceof Map){const D=C.source;for(const P in g[p]){const f=D.get(P);(I.isString(f)?f:f?.id)===y&&(D.delete(P),delete C.value[P])}D.size===0&&this.configurationDefaultsOverrides.delete(p)}else{const D=I.isString(C.source)?C.source:C.source?.id;if(y!==D)continue;this.configurationDefaultsOverrides.delete(p)}const b=this.configurationProperties[p];b&&(this.updatePropertyDefaultValue(p,b),this.updateSchema(p,b))}u.add(p)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(l){let u=!1;const g=new Set;l.removedDefaults&&(this.doDeregisterDefaultConfigurations(l.removedDefaults,g),u=!0),l.addedDefaults&&(this.doRegisterDefaultConfigurations(l.addedDefaults,g),u=!0),l.removedConfigurations&&this.doDeregisterConfigurations(l.removedConfigurations,g),l.addedConfigurations&&this.doRegisterConfigurations(l.addedConfigurations,!1,g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){this.doRegisterOverrideIdentifiers(l),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(l){for(const u of l)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,u,g){l.forEach(m=>{this.validateAndRegisterProperties(m,u,m.extensionInfo,m.restrictedProperties,void 0,g),this.configurationContributors.push(m),this.registerJSONConfiguration(m)})}doDeregisterConfigurations(l,u){const g=m=>{if(m.properties)for(const p in m.properties){u.add(p);const y=this.configurationProperties[p];y?.policy?.name&&this.policyConfigurations.delete(y.policy.name),delete this.configurationProperties[p],this.removeFromSchema(p,m.properties[p])}m.allOf?.forEach(p=>g(p))};for(const m of l){g(m);const p=this.configurationContributors.indexOf(m);p!==-1&&this.configurationContributors.splice(p,1)}}validateAndRegisterProperties(l,u=!0,g,m,p=k.WINDOW,y){p=I.isUndefinedOrNull(l.scope)?p:l.scope;const C=l.properties;if(C)for(const D in C){const P=C[D];if(u&&i(D,P)){delete C[D];continue}if(P.source=g,P.defaultDefaultValue=C[D].default,this.updatePropertyDefaultValue(D,P),e.OVERRIDE_PROPERTY_REGEX.test(D)?P.scope=void 0:(P.scope=I.isUndefinedOrNull(P.scope)?p:P.scope,P.restricted=I.isUndefinedOrNull(P.restricted)?!!m?.includes(D):P.restricted),C[D].hasOwnProperty("included")&&!C[D].included){this.excludedConfigurationProperties[D]=C[D],delete C[D];continue}else this.configurationProperties[D]=C[D],C[D].policy?.name&&this.policyConfigurations.set(C[D].policy.name,D);!C[D].deprecationMessage&&C[D].markdownDeprecationMessage&&(C[D].deprecationMessage=C[D].markdownDeprecationMessage),y.add(D)}const b=l.allOf;if(b)for(const D of b)this.validateAndRegisterProperties(D,u,g,m,p,y)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const u=g=>{const m=g.properties;if(m)for(const y in m)this.updateSchema(y,m[y]);g.allOf?.forEach(u)};u(l)}updateSchema(l,u){switch(e.allSettings.properties[l]=u,u.scope){case k.APPLICATION:e.applicationSettings.properties[l]=u;break;case k.MACHINE:e.machineSettings.properties[l]=u;break;case k.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[l]=u;break;case k.WINDOW:e.windowSettings.properties[l]=u;break;case k.RESOURCE:e.resourceSettings.properties[l]=u;break;case k.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[l]=u,this.resourceLanguageSettingsSchema.properties[l]=u;break}}removeFromSchema(l,u){switch(delete e.allSettings.properties[l],u.scope){case k.APPLICATION:delete e.applicationSettings.properties[l];break;case k.MACHINE:delete e.machineSettings.properties[l];break;case k.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[l];break;case k.WINDOW:delete e.windowSettings.properties[l];break;case k.RESOURCE:case k.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const u=`[${l}]`,g={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,g),e.allSettings.properties[u]=g,e.applicationSettings.properties[u]=g,e.machineSettings.properties[u]=g,e.machineOverridableSettings.properties[u]=g,e.windowSettings.properties[u]=g,e.resourceSettings.properties[u]=g}}registerOverridePropertyPatternKey(){const l={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,u){const g=this.configurationDefaultsOverrides.get(l);let m=g?.value,p=g?.source;I.isUndefined(m)&&(m=u.defaultDefaultValue,p=void 0),I.isUndefined(m)&&(m=o(u.type)),u.default=m,u.defaultValueSource=p}}const _="\\[([^\\]]+)\\]",h=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function n(t){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let u=h.exec(t);for(;u?.length;){const g=u[1].trim();g&&l.push(g),u=h.exec(t)}}return(0,S.distinct)(l)}function s(t){return t.reduce((l,u)=>`${l}[${u}]`,"")}function o(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new c;v.Registry.add(e.Extensions.Configuration,d);function i(t,l){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?O.localize(7,null,t):d.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):l.policy?.name&&d.getPolicyConfigurations().get(l.policy?.name)!==void 0?O.localize(9,null,t,l.policy?.name,d.getPolicyConfigurations().get(l.policy?.name)):null:O.localize(6,null)}function r(){const t=[],l=d.getConfigurationProperties();for(const u of Object.keys(l))t.push([u,l[u].scope]);return t.push(["launch",k.RESOURCE]),t.push(["task",k.RESOURCE]),t}}),define(Te[215],Pe([1,0,18,6,136,4,29,26,15,2,43,54,30,31]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=r,S=$e(S),I=$e(I),R=$e(R),v=$e(v);function h(g){return Object.isFrozen(g)?g:R.deepFreeze(g)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,p,y,C,b){this._contents=m,this._keys=p,this._overrides=y,this.raw=C,this.logService=b,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const m=this.raw.map(p=>{if(p instanceof n)return p;const y=new s("",this.logService);return y.parseRaw(p),y.configurationModel});this._rawConfiguration=m.reduce((p,y)=>y===p?y:p.merge(y),m[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(m){return m?(0,k.getConfigurationValue)(this.contents,m):this.contents}inspect(m,p){const y=this;return{get value(){return h(y.rawConfiguration.getValue(m))},get override(){return p?h(y.rawConfiguration.getOverrideValue(m,p)):void 0},get merged(){return h(p?y.rawConfiguration.override(p).getValue(m):y.rawConfiguration.getValue(m))},get overrides(){const C=[];for(const{contents:b,identifiers:D,keys:P}of y.rawConfiguration.overrides){const f=new n(b,P,[],void 0,y.logService).getValue(m);f!==void 0&&C.push({identifiers:D,value:f})}return C.length?h(C):void 0}}}getOverrideValue(m,p){const y=this.getContentsForOverrideIdentifer(p);return y?m?(0,k.getConfigurationValue)(y,m):y:void 0}getKeysForOverrideIdentifier(m){const p=[];for(const y of this.overrides)y.identifiers.includes(m)&&p.push(...y.keys);return S.distinct(p)}getAllOverrideIdentifiers(){const m=[];for(const p of this.overrides)m.push(...p.identifiers);return S.distinct(m)}override(m){let p=this.overrideConfigurations.get(m);return p||(p=this.createOverrideConfigurationModel(m),this.overrideConfigurations.set(m,p)),p}merge(...m){const p=R.deepClone(this.contents),y=R.deepClone(this.overrides),C=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of m)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(p,D.contents);for(const P of D.overrides){const[f]=y.filter(E=>S.equals(E.identifiers,P.identifiers));f?(this.mergeContents(f.contents,P.contents),f.keys.push(...P.keys),f.keys=S.distinct(f.keys)):y.push(R.deepClone(P))}for(const P of D.keys)C.indexOf(P)===-1&&C.push(P)}return new n(p,C,y,b.every(D=>D instanceof n)?void 0:b,this.logService)}createOverrideConfigurationModel(m){const p=this.getContentsForOverrideIdentifer(m);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const y={};for(const C of S.distinct([...Object.keys(this.contents),...Object.keys(p)])){let b=this.contents[C];const D=p[C];D&&(typeof b=="object"&&typeof D=="object"?(b=R.deepClone(b),this.mergeContents(b,D)):b=D),y[C]=b}return new n(y,this.keys,this.overrides,void 0,this.logService)}mergeContents(m,p){for(const y of Object.keys(p)){if(y in m&&v.isObject(m[y])&&v.isObject(p[y])){this.mergeContents(m[y],p[y]);continue}m[y]=R.deepClone(p[y])}}getContentsForOverrideIdentifer(m){let p=null,y=null;const C=b=>{b&&(y?this.mergeContents(y,b):y=R.deepClone(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===m?p=b.contents:b.identifiers.includes(m)&&C(b.contents);return C(p),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,p){this.updateValue(m,p,!0)}setValue(m,p){this.updateValue(m,p,!1)}removeValue(m){const p=this.keys.indexOf(m);p!==-1&&(this.keys.splice(p,1),(0,k.removeFromValueTree)(this.contents,m),w.OVERRIDE_PROPERTY_REGEX.test(m)&&this.overrides.splice(this.overrides.findIndex(y=>S.equals(y.identifiers,(0,w.overrideIdentifiersFromKey)(m))),1))}updateValue(m,p,y){(0,k.addToValueTree)(this.contents,m,p,C=>this.logService.error(C)),y=y||this.keys.indexOf(m)===-1,y&&this.keys.push(m),w.OVERRIDE_PROPERTY_REGEX.test(m)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(m),keys:Object.keys(this.contents[m]),contents:(0,k.toValuesTree)(this.contents[m],C=>this.logService.error(C))})}}e.ConfigurationModel=n;class s{constructor(m,p){this._name=m,this.logService=p,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||n.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(m,p){if(!v.isUndefinedOrNull(m)){const y=this.doParseContent(m);this.parseRaw(y,p)}}reparse(m){this._raw&&this.parseRaw(this._raw,m)}parseRaw(m,p){this._raw=m;const{contents:y,keys:C,overrides:b,restricted:D,hasExcludedProperties:P}=this.doParseRaw(m,p);this._configurationModel=new n(y,C,b,P?[m]:void 0,this.logService),this._restrictedConfigurations=D||[]}doParseContent(m){let p={},y=null,C=[];const b=[],D=[];function P(E){Array.isArray(C)?C.push(E):y!==null&&(C[y]=E)}const f={onObjectBegin:()=>{const E={};P(E),b.push(C),C=E,y=null},onObjectProperty:E=>{y=E},onObjectEnd:()=>{C=b.pop()},onArrayBegin:()=>{const E=[];P(E),b.push(C),C=E,y=null},onArrayEnd:()=>{C=b.pop()},onLiteralValue:P,onError:(E,F,L)=>{D.push({error:E,offset:F,length:L})}};if(m)try{I.visit(m,f),p=C[0]||{}}catch(E){this.logService.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return p}doParseRaw(m,p){const y=_.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),C=this.filter(m,y,!0,p);m=C.raw;const b=(0,k.toValuesTree)(m,f=>this.logService.error(`Conflict in settings file ${this._name}: ${f}`)),D=Object.keys(m),P=this.toOverrides(m,f=>this.logService.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:b,keys:D,overrides:P,restricted:C.restricted,hasExcludedProperties:C.hasExcludedProperties}}filter(m,p,y,C){let b=!1;if(!C?.scopes&&!C?.skipRestricted&&!C?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:b};const D={},P=[];for(const f in m)if(w.OVERRIDE_PROPERTY_REGEX.test(f)&&y){const E=this.filter(m[f],p,!1,C);D[f]=E.raw,b=b||E.hasExcludedProperties,P.push(...E.restricted)}else{const E=p[f],F=E?typeof E.scope<"u"?E.scope:w.ConfigurationScope.WINDOW:void 0;E?.restricted&&P.push(f),!C.exclude?.includes(f)&&(C.include?.includes(f)||(F===void 0||C.scopes===void 0||C.scopes.includes(F))&&!(C.skipRestricted&&E?.restricted))?D[f]=m[f]:b=!0}return{raw:D,restricted:P,hasExcludedProperties:b}}toOverrides(m,p){const y=[];for(const C of Object.keys(m))if(w.OVERRIDE_PROPERTY_REGEX.test(C)){const b={};for(const D in m[C])b[D]=m[C][D];y.push({identifiers:(0,w.overrideIdentifiersFromKey)(C),keys:Object.keys(b),contents:(0,k.toValuesTree)(b,p)})}return y}}e.ConfigurationModelParser=s;class o extends O.Disposable{constructor(m,p,y,C,b){super(),this.userSettingsResource=m,this.parseOptions=p,this.fileService=C,this.logService=b,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString(),b),this._register(this.fileService.watch(y.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,D=>D.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,D=>(D.isOperation(c.FileOperation.CREATE)||D.isOperation(c.FileOperation.COPY)||D.isOperation(c.FileOperation.DELETE)||D.isOperation(c.FileOperation.WRITE))&&y.isEqual(D.resource,m)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const m=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(m.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return n.createEmptyModel(this.logService)}}reparse(m){return m&&(this.parseOptions=m),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class d{constructor(m,p,y,C,b,D,P,f,E,F,L,M,V){this.key=m,this.overrides=p,this._value=y,this.overrideIdentifiers=C,this.defaultConfiguration=b,this.policyConfiguration=D,this.applicationConfiguration=P,this.userConfiguration=f,this.localUserConfiguration=E,this.remoteUserConfiguration=F,this.workspaceConfiguration=L,this.folderConfigurationModel=M,this.memoryConfigurationModel=V}get value(){return h(this._value)}toInspectValue(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(m,p,y,C,b,D,P,f,E,F){this._defaultConfiguration=m,this._policyConfiguration=p,this._applicationConfiguration=y,this._localUserConfiguration=C,this._remoteUserConfiguration=b,this._workspaceConfiguration=D,this._folderConfigurations=P,this._memoryConfiguration=f,this._memoryConfigurationByResource=E,this.logService=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(m,p,y){return this.getConsolidatedConfigurationModel(m,p,y).getValue(m)}updateValue(m,p,y={}){let C;y.resource?(C=this._memoryConfigurationByResource.get(y.resource),C||(C=n.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(y.resource,C))):C=this._memoryConfiguration,p===void 0?C.removeValue(m):C.setValue(m,p),y.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(m,p,y){const C=this.getConsolidatedConfigurationModel(m,p,y),b=this.getFolderConfigurationModelForResource(p.resource,y),D=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,P=new Set;for(const f of C.overrides)for(const E of f.identifiers)C.getOverrideValue(m,E)!==void 0&&P.add(E);return new d(m,p,C.getValue(m),P.size?[...P]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this._workspaceConfiguration:void 0,b||void 0,D)}keys(m){const p=this.getFolderConfigurationModelForResource(void 0,m);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(m){this._defaultConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(m){this._policyConfiguration=m}updateApplicationConfiguration(m){this._applicationConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(m){this._localUserConfiguration=m,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(m){this._remoteUserConfiguration=m,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(m){this._workspaceConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(m,p){this._folderConfigurations.set(m,p),this._foldersConsolidatedConfigurations.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this._foldersConsolidatedConfigurations.delete(m)}compareAndUpdateDefaultConfiguration(m,p){const y=[];if(!p){const{added:C,updated:b,removed:D}=l(this._defaultConfiguration,m);p=[...C,...b,...D]}for(const C of p)for(const b of(0,w.overrideIdentifiersFromKey)(C)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(b),P=m.getKeysForOverrideIdentifier(b),f=[...P.filter(E=>D.indexOf(E)===-1),...D.filter(E=>P.indexOf(E)===-1),...D.filter(E=>!R.equals(this._defaultConfiguration.override(b).getValue(E),m.override(b).getValue(E)))];y.push([b,f])}return this.updateDefaultConfiguration(m),{keys:p,overrides:y}}compareAndUpdatePolicyConfiguration(m){const{added:p,updated:y,removed:C}=l(this._policyConfiguration,m),b=[...p,...y,...C];return b.length&&this.updatePolicyConfiguration(m),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:p,updated:y,removed:C,overrides:b}=l(this.applicationConfiguration,m),D=[...p,...y,...C];return D.length&&this.updateApplicationConfiguration(m),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(m){const{added:p,updated:y,removed:C,overrides:b}=l(this.localUserConfiguration,m),D=[...p,...y,...C];return D.length&&this.updateLocalUserConfiguration(m),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(m){const{added:p,updated:y,removed:C,overrides:b}=l(this.remoteUserConfiguration,m),D=[...p,...y,...C];return D.length&&this.updateRemoteUserConfiguration(m),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(m){const{added:p,updated:y,removed:C,overrides:b}=l(this.workspaceConfiguration,m),D=[...p,...y,...C];return D.length&&this.updateWorkspaceConfiguration(m),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(m,p){const y=this.folderConfigurations.get(m),{added:C,updated:b,removed:D,overrides:P}=l(y,p),f=[...C,...b,...D];return(f.length||!y)&&this.updateFolderConfiguration(m,p),{keys:f,overrides:P}}compareAndDeleteFolderConfiguration(m){const p=this.folderConfigurations.get(m);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:y,updated:C,removed:b,overrides:D}=l(p,void 0);return{keys:[...y,...C,...b],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(m,p,y){let C=this.getConsolidatedConfigurationModelForResource(p,y);return p.overrideIdentifier&&(C=C.override(p.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(m)!==void 0&&(C=C.merge(this._policyConfiguration)),C}getConsolidatedConfigurationModelForResource({resource:m},p){let y=this.getWorkspaceConsolidatedConfiguration();if(p&&m){const C=p.getFolder(m);C&&(y=this.getFolderConsolidatedConfiguration(C.uri)||y);const b=this._memoryConfigurationByResource.get(m);b&&(y=y.merge(b))}return y}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(m){let p=this._foldersConsolidatedConfigurations.get(m);if(!p){const y=this.getWorkspaceConsolidatedConfiguration(),C=this._folderConfigurations.get(m);C?(p=y.merge(C),this._foldersConsolidatedConfigurations.set(m,p)):p=y}return p}getFolderConfigurationModelForResource(m,p){if(p&&m){const y=p.getFolder(m);if(y)return this._folderConfigurations.get(y.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((m,p)=>{const{contents:y,overrides:C,keys:b}=this._folderConfigurations.get(p);return m.push([p,{contents:y,overrides:C,keys:b}]),m},[])}}allKeys(){const m=new Set;return this._defaultConfiguration.keys.forEach(p=>m.add(p)),this.userConfiguration.keys.forEach(p=>m.add(p)),this._workspaceConfiguration.keys.forEach(p=>m.add(p)),this._folderConfigurations.forEach(p=>p.keys.forEach(y=>m.add(y))),[...m.values()]}allOverrideIdentifiers(){const m=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(p=>m.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>m.add(p)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(p=>m.add(p)),this._folderConfigurations.forEach(p=>p.getAllOverrideIdentifiers().forEach(y=>m.add(y))),[...m.values()]}getAllKeysForOverrideIdentifier(m){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(m).forEach(y=>p.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(y=>p.add(y)),this._workspaceConfiguration.getKeysForOverrideIdentifier(m).forEach(y=>p.add(y)),this._folderConfigurations.forEach(y=>y.getKeysForOverrideIdentifier(m).forEach(C=>p.add(C))),[...p.values()]}static parse(m,p){const y=this.parseConfigurationModel(m.defaults,p),C=this.parseConfigurationModel(m.policy,p),b=this.parseConfigurationModel(m.application,p),D=this.parseConfigurationModel(m.user,p),P=this.parseConfigurationModel(m.workspace,p),f=m.folders.reduce((E,F)=>(E.set(a.URI.revive(F[0]),this.parseConfigurationModel(F[1],p)),E),new A.ResourceMap);return new i(y,C,b,D,n.createEmptyModel(p),P,f,n.createEmptyModel(p),new A.ResourceMap,p)}static parseConfigurationModel(m,p){return new n(m.contents,m.keys,m.overrides,void 0,p)}}e.Configuration=i;function r(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const m=new Set,p=new Map;for(const C of g)C.keys.forEach(b=>m.add(b)),C.overrides.forEach(([b,D])=>{const P=(0,A.getOrSet)(p,b,new Set);D.forEach(f=>P.add(f))});const y=[];return p.forEach((C,b)=>y.push([b,[...C.values()]])),{keys:[...m.values()],overrides:y}}class t{constructor(m,p,y,C,b){this.change=m,this.previous=p,this.currentConfiguraiton=y,this.currentWorkspace=C,this.logService=b,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const D of m.keys)this.affectedKeys.add(D);for(const[,D]of m.overrides)for(const P of D)this.affectedKeys.add(P);this._affectsConfigStr=this._marker;for(const D of this.affectedKeys)this._affectsConfigStr+=D+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(m,p){const y=this._marker+m,C=this._affectsConfigStr.indexOf(y);if(C<0)return!1;const b=C+y.length;if(b>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(b);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(p){const P=this.previousConfiguration?this.previousConfiguration.getValue(m,p,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(m,p,this.currentWorkspace);return!R.equals(P,f)}return!0}}e.ConfigurationChangeEvent=t;function l(g,m){const{added:p,removed:y,updated:C}=u(m?.rawConfiguration,g?.rawConfiguration),b=[],D=g?.getAllOverrideIdentifiers()||[],P=m?.getAllOverrideIdentifiers()||[];if(m){const f=P.filter(E=>!D.includes(E));for(const E of f)b.push([E,m.getKeysForOverrideIdentifier(E)])}if(g){const f=D.filter(E=>!P.includes(E));for(const E of f)b.push([E,g.getKeysForOverrideIdentifier(E)])}if(m&&g){for(const f of D)if(P.includes(f)){const E=u({contents:g.getOverrideValue(void 0,f)||{},keys:g.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});b.push([f,[...E.added,...E.removed,...E.updated]])}}return{added:p,removed:y,updated:C,overrides:b}}function u(g,m){const p=g?m?g.keys.filter(b=>m.keys.indexOf(b)===-1):[...g.keys]:[],y=m?g?m.keys.filter(b=>g.keys.indexOf(b)===-1):[...m.keys]:[],C=[];if(g&&m){for(const b of m.keys)if(g.keys.indexOf(b)!==-1){const D=(0,k.getConfigurationValue)(m.contents,b),P=(0,k.getConfigurationValue)(g.contents,b);R.equals(D,P)||C.push(b)}}return{added:p,removed:y,updated:C}}}),define(Te[110],Pe([1,0,14,3]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=a,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var I;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class O{constructor(w){this.id=w,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class A{constructor(w,c){this.host=w,this.port=c,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var R;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends S.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof v&&w._code===R.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof v&&w._code===R.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof v&&w._code===R.NoResolverFound}static isInvalidAuthority(w){return w instanceof v&&w._code===R.InvalidAuthority}static isHandled(w){return w instanceof v&&w.isHandled}constructor(w,c=R.Unknown,_){super(w),this._message=w,this._code=c,this._detail=_,this.isHandled=c===R.NotAvailable&&_===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function a(k){const w=k.indexOf("+");return w===-1?k:k.substring(0,w)}}),define(Te[63],Pe([1,0,16]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=T,e.getRemoteName=I,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=A;function T(v){return v.scheme===S.Schemas.vscodeRemote?v.authority:void 0}function I(v){if(!v)return;const a=v.indexOf("+");return a<0?v:v.substr(0,a)}function O(v){const{host:a,port:k}=R(v);if(typeof k>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:k}}function A(v,a){let{host:k,port:w}=R(v);return typeof w>"u"&&(w=a),{host:k,port:w}}function R(v){const a=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const k=v.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const w=v.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:v,port:void 0}}}),define(Te[19],Pe([1,0,13,3,63]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=w,e.isLanguagePackExtension=c,e.isAuthenticationProviderExtension=_,e.isResolverExtension=h,e.parseApiProposals=n,e.parseEnabledApiProposalNames=s,S=$e(S),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(o){o.WIN32_X64="win32-x64",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.LINUX_PPC64LE="linux-ppc64le",o.LINUX_RISCV64="linux-riscv64",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,i){if(typeof d>"u"||d===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof d=="string"||typeof i=="string"){const r=typeof d=="string"?d:d.value,t=typeof i=="string"?i:i.value;return S.equalsIgnoreCase(r,t)}return d._lower===i._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=v;class a{get size(){return this._set.size}constructor(d){if(this._set=new Set,d)for(const i of d)this.add(i)}add(d){this._set.add(v.toKey(d))}delete(d){return this._set.delete(v.toKey(d))}has(d){return this._set.has(v.toKey(d))}}e.ExtensionIdentifierSet=a;class k{constructor(){this._map=new Map}clear(){this._map.clear()}delete(d){this._map.delete(v.toKey(d))}get(d){return this._map.get(v.toKey(d))}has(d){return this._map.has(v.toKey(d))}set(d,i){this._map.set(v.toKey(d),i)}values(){return this._map.values()}forEach(d){this._map.forEach(d)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=k;function w(o){return c(o)}function c(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}function _(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}function h(o,d){if(d){const i=`onResolveRemoteAuthority:${(0,I.getRemoteName)(d)}`;return!!o.activationEvents?.includes(i)}return!1}function n(o){return o.map(d=>{const[i,r]=d.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function s(o){return o.map(d=>d.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[111],Pe([1,0,21,172,19,3]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=v,e.getTargetPlatform=a,e.isNotWebExtensionInWebTargetPlatform=k,e.isTargetPlatformCompatible=w,e.isIExtensionIdentifier=c,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(t){switch(t){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case I.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function v(t){switch(t){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.LINUX_PPC64LE:return I.TargetPlatform.LINUX_PPC64LE;case I.TargetPlatform.LINUX_RISCV64:return I.TargetPlatform.LINUX_RISCV64;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function a(t,l){switch(t){case S.Platform.Windows:return l==="x64"?I.TargetPlatform.WIN32_X64:l==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?I.TargetPlatform.LINUX_X64:l==="arm64"?I.TargetPlatform.LINUX_ARM64:l==="arm"?I.TargetPlatform.LINUX_ARMHF:l==="ppc64le"?I.TargetPlatform.LINUX_PPC64LE:l==="riscv64"?I.TargetPlatform.LINUX_RISCV64:I.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?I.TargetPlatform.ALPINE_X64:l==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?I.TargetPlatform.DARWIN_X64:l==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case S.Platform.Web:return I.TargetPlatform.WEB}}function k(t,l){return l===I.TargetPlatform.WEB&&!t.includes(I.TargetPlatform.WEB)}function w(t,l,u){return k(l,u)?!1:t===I.TargetPlatform.UNDEFINED||t===I.TargetPlatform.UNIVERSAL?!0:t===I.TargetPlatform.UNKNOWN?!1:t===u}function c(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var _;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(_||(e.SortBy=_={}));var h;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class d extends Error{constructor(l,u){super(l),this.code=u,this.name=u}}e.ExtensionGalleryError=d;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(l,u){super(l),this.code=u,this.name=u}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,T.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,T.localize2)(1,"Preferences")}),define(Te[112],Pe([1,0,14,19]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class I{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,R){this._generators.set(A,R)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const R=Object.create(null);for(const v of A){const a=this.readActivationEvents(v);a.length>0&&(R[T.ExtensionIdentifier.toKey(v.identifier)]=a)}return R}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const R=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${T.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return R;for(const v in A.contributes){const a=this._generators.get(v);if(!a)continue;const k=A.contributes[v],w=Array.isArray(k)?k:[k];try{a(w,R)}catch(c){(0,S.onUnexpectedError)(c)}}return R}}e.ImplicitActivationEventsImpl=I,e.ImplicitActivationEvents=new I});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[216],Pe([1,0,24,36,173,323,19,105]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=k,e.parseVersion=w,e.normalizeVersion=c,e.isValidVersion=_,e.validateExtensionManifest=h,e.isValidExtensionVersion=n,e.isEngineValid=s,e.areApiProposalsCompatible=o,T=Zt(T),I=$e(I),O=$e(O);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function k(r){return r=r.trim(),r==="*"||v.test(r)}function w(r){if(!k(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(v);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function c(r){if(!r)return null;const t=r.majorBase,l=r.majorMustEqual,u=r.minorBase;let g=r.minorMustEqual;const m=r.patchBase;let p=r.patchMustEqual;r.hasCaret&&(t===0||(g=!1),p=!1);let y=0;if(r.preRelease){const C=a.exec(r.preRelease);if(C){const[,b,D,P]=C;y=Date.UTC(Number(b),Number(D)-1,Number(P))}}return{majorBase:t,majorMustEqual:l,minorBase:u,minorMustEqual:g,patchBase:m,patchMustEqual:p,isMinimum:r.hasGreaterEquals,notBefore:y}}function _(r,t,l){let u;typeof r=="string"?u=c(w(r)):u=r;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let m;if(typeof l=="string"?m=c(w(l)):m=l,!u||!m)return!1;const p=u.majorBase,y=u.minorBase,C=u.patchBase;let b=m.majorBase,D=m.minorBase,P=m.patchBase;const f=m.notBefore;let E=m.majorMustEqual,F=m.minorMustEqual,L=m.patchMustEqual;return m.isMinimum?p>b?!0:p<b?!1:y>D?!0:y<D||g&&g<f?!1:C>=P:(p===1&&b===0&&(!E||!F||!L)&&(b=1,D=0,P=0,E=!0,F=!1,L=!1),p<b?!1:p>b?!E:y<D?!1:y>D?!F:C<P?!1:C>P?!L:!(g&&g<f))}function h(r,t,l,u,g,m){const p=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return p.push([T.default.Error,I.localize(0,null)]),p;if(typeof u.name!="string")return p.push([T.default.Error,I.localize(1,null,"name")]),p;if(typeof u.version!="string")return p.push([T.default.Error,I.localize(2,null,"version")]),p;if(!u.engines)return p.push([T.default.Error,I.localize(3,null,"engines")]),p;if(typeof u.engines.vscode!="string")return p.push([T.default.Error,I.localize(4,null,"engines.vscode")]),p;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return p.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),p;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return p.push([T.default.Error,I.localize(6,null,"activationEvents")]),p;if(typeof u.main>"u"&&typeof u.browser>"u")return p.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),p}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&p.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return p.push([T.default.Error,I.localize(9,null,"main")]),p;{const b=(0,S.joinPath)(l,u.main);(0,S.isEqualOrParent)(b,l)||p.push([T.default.Warning,I.localize(10,null,b.path,l.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return p.push([T.default.Error,I.localize(11,null,"browser")]),p;{const b=(0,S.joinPath)(l,u.browser);(0,S.isEqualOrParent)(b,l)||p.push([T.default.Warning,I.localize(12,null,b.path,l.path)])}}if(!O.valid(u.version))return p.push([T.default.Error,I.localize(13,null)]),p;const y=[];if(!n(r,t,u,g,y))for(const b of y)p.push([T.default.Error,b]);if(m&&u.enabledApiProposals?.length){const b=[];if(!o([...u.enabledApiProposals],b))for(const D of b)p.push([T.default.Error,D])}return p}function n(r,t,l,u,g){return u||typeof l.main>"u"&&typeof l.browser>"u"?!0:d(r,t,l.engines.vscode,g)}function s(r,t,l){return r==="*"||d(t,l,r)}function o(r,t){if(r.length===0)return!0;const l=Array.isArray(t)?t:void 0,u=(l?void 0:t)??R.allApiProposals,g=[],m=(0,A.parseApiProposals)(r);for(const{proposalName:p,version:y}of m){const C=u[p];C&&y&&C.version!==y&&g.push(I.localize(14,null,p))}return l?.push(...g),g.length===0}function d(r,t,l,u=[]){const g=c(w(l));if(!g)return u.push(I.localize(15,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(I.localize(16,null,l)),!1}else if(!g.majorMustEqual)return u.push(I.localize(17,null,l)),!1;return _(r,t,g)?!0:(u.push(I.localize(18,null,r,l)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,l=r.length;t<l;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Te[217],Pe([1,0,23,14,4,177,54,3,12,31]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=c,e.hasNoContent=_,e.asText=h,e.asTextOrError=n,e.asJson=s,e.updateProxyConfigurationsScope=o,e.IRequestService=(0,R.createDecorator)("requestService");class k{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const l in this.original)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?t[l]="*****":t[l]=this.original[l];this.headers=t}return this.headers}}class w extends I.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,O.localize)(0,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(t,l,u){const g=`${t} #${++this.counter}: ${l.url}`;this.logger.trace(`${g} - begin`,l.type,new k(l.headers??{}));try{const m=await u();return this.logger.trace(`${g} - end`,l.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.logger.error(`${g} - error`,l.type,(0,T.getErrorMessage)(m)),m}}}e.AbstractRequestService=w;function c(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function _(r){return r.res.statusCode===204}async function h(r){return _(r)?null:(await(0,S.streamToBuffer)(r.stream)).toString()}async function n(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);return h(r)}async function s(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);if(_(r))return null;const l=(await(0,S.streamToBuffer)(r.stream)).toString();try{return JSON.parse(l)}catch(u){throw u.message+=`:
`+l,u}}function o(r){i(r)}let d;function i(r){const t=a.Registry.as(A.Extensions.Configuration),l=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null),(0,O.localize)(10,null)],default:"override",description:(0,O.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[d],remove:l?[l]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Te[218],Pe([1,0,21,79,37]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=R;function O(v){if(S.platform===S.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function A(v,a,k,w,c,_,h,n,s,o){const d=Object.create(null);d["common.machineId"]=_,d["common.sqmId"]=h,d["common.devDeviceId"]=n,d.sessionID=(0,I.generateUuid)()+Date.now(),d.commitHash=w,d.version=c,d["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,S.PlatformToString)(S.platform),d["common.nodePlatform"]=T.platform,d["common.nodeArch"]=k,d["common.product"]=o||"desktop",s&&(d["common.msftInternal"]=s);let i=0;const r=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.isLinuxSnap&&(d["common.snap"]="true");const t=O(a);return t&&(d["common.platformDetail"]=t),d}function R(v){const a=T.env.USERDNSDOMAIN;if(!a)return!1;const k=a.toLowerCase();return v.some(w=>k===w)}}),define(Te[113],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Te[64],Pe([1,0,26,15,63,218,113]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=k,e.isLoggingOnly=w,e.getTelemetryLevel=c,e.validateTelemetryData=_,e.cleanRemoteAuthority=n,e.isInternalTelemetry=o,e.getPiiPathsFromEnvironment=d,e.cleanData=t;class R{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class v{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class a{async publicLog(u,g,m){}async publicLogError(u,g,m){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function k(l,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!l.enableTelemetry)}function w(l,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function c(l){const u=l.getValue(A.TELEMETRY_SETTING_ID),g=l.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function _(l){const u={},g={},m={};s(l,m);for(let p in m){p=p.length>150?p.substr(p.length-149):p;const y=m[p];typeof y=="number"?g[p]=y:typeof y=="boolean"?g[p]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${y.length}`),u[p]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(u[p]=y)}return{properties:u,measurements:g}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(l){if(!l)return"none";const u=(0,I.getRemoteName)(l);return h.has(u)?u:"other"}function s(l,u,g=0,m){if(l)for(const p of Object.getOwnPropertyNames(l)){const y=l[p],C=m?m+p:p;Array.isArray(y)?u[C]=(0,S.safeStringify)(y):y instanceof Date?u[C]=y.toISOString():(0,T.isObject)(y)?g<2?s(y,u,g+1,C+"."):u[C]=(0,S.safeStringify)(y):u[C]=y}}function o(l,u){const g=l.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(g)||m}function d(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function i(l,u){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let g=l;const m=[];for(const b of u)for(;;){const D=b.exec(l);if(!D)break;m.push([D.index,b.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(g="";;){const b=y.exec(l);if(!b)break;const D=m.some(([P,f])=>b.index<f&&P<y.lastIndex);!p.test(b[0])&&!D&&(g+=l.substring(C,b.index)+"<REDACTED: user-file-path>",C=y.lastIndex)}return C<l.length&&(g+=l.substr(C)),g}function r(l){if(!l)return l;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of u)if(g.regex.test(l))return`<REDACTED: ${g.label}>`;return l}function t(l,u){return(0,S.cloneAndChange)(l,g=>{if(g instanceof R||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let m=g.replaceAll("%20"," ");m=i(m,u);for(const p of u)m=m.replace(p,"");return m=r(m),m}})}}),define(Te[219],Pe([1,0,13,111,19,21,2,14,79,64]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=k,e.getIdAndVersion=h,e.getExtensionId=n,e.adoptToGalleryExtensionId=s,e.getGalleryExtensionId=o,e.groupByExtension=d,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=r,e.getExtensionDependencies=t,e.computeTargetPlatform=u;function k(g,m){return g.uuid&&m.uuid?g.uuid===m.uuid:g.id===m.id?!0:(0,S.compareIgnoreCase)(g.id,m.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(m){const p=m.manifest?m.manifest.version:m.version,y=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new c(m.identifier,p,y)}static parse(m){const p=w.exec(m);return p&&p[1]&&p[2]?new c({id:p[1]},p[2],p[4]||void 0):null}constructor(m,p,y=I.TargetPlatform.UNDEFINED){this.identifier=m,this.version=p,this.targetPlatform=y,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof c?k(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.ExtensionKey=c;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(g){const m=_.exec(g);return m&&m[1]?[s(m[1]),m[2]]:[s(g),void 0]}function n(g,m){return`${g}.${m}`}function s(g){return g.toLowerCase()}function o(g,m){return s(n(g??I.UNDEFINED_PUBLISHER,m))}function d(g,m){const p=[],y=C=>{for(const b of p)if(b.some(D=>k(m(D),m(C))))return b;return null};for(const C of g){const b=y(C);b?b.push(C):p.push([C])}return p}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function r(g){return{id:new a.TelemetryTrustedValue(g.identifier.id),name:new a.TelemetryTrustedValue(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function t(g,m){const p=[],y=m.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const C=y.shift();if(C&&p.every(b=>!k(b.identifier,{id:C}))){const b=g.filter(D=>k(D.identifier,{id:C}));b.length===1&&(p.push(b[0]),y.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}async function l(g,m){if(!O.isLinux)return!1;let p;try{p=(await g.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await g.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){m.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(C))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(g,m){const p=await l(g,m),y=(0,T.getTargetPlatform)(p?"alpine":O.platform,v.arch);return m.debug("ComputeTargetPlatform:",y),y}}),define(Te[220],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=S,e.serializeEnvironmentDescriptionMap=T,e.deserializeEnvironmentVariableCollection=I,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=R;function S(v){return[...v.entries()]}function T(v){return v?[...v.entries()]:[]}function I(v){return new Map(v)}function O(v){return new Map(v??[])}function A(v){return Array.from(v.entries()).map(a=>[a[0],S(a[1].map),T(a[1].descriptionMap)])}function R(v){return new Map(v.map(a=>[a[0],{map:I(a[1]),descriptionMap:O(a[2])}]))}}),define(Te[221],Pe([1,0,3,32,31]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new T.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var v;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(v||(e.WindowsShellType=v={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var k;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(k||(e.TerminalIpcChannels=k={}));var w;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.IPtyService=(0,S.createDecorator)("ptyService");var c;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(c||(e.HeartbeatConstants=c={}));var _;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(_||(e.TerminalLocation=_={}));var h;(function(t){t.TerminalView="view",t.Editor="editor"})(h||(e.TerminalLocationString=h={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var o;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(o||(e.ProfileSource=o={}));var d;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(l){const u=this._sanitizeRemoteAuthority(l.remoteAuthority);if(this._backends.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this._backends.set(u,l)}getTerminalBackend(l){return this._backends.get(this._sanitizeRemoteAuthority(l))}_sanitizeRemoteAuthority(l){return l?.toLowerCase()??""}}I.Registry.add(e.TerminalExtensions.Backend,new r),e.ILocalPtyService=(0,S.createDecorator)("localPtyService"),e.ITerminalLogService=(0,S.createDecorator)("terminalLogService")}),define(Te[222],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,O,A=5){const R=O(v=>{const a=typeof v=="string"?v:v.data;let k=this._terminalBufferMap.get(I);if(k){k.data.push(a);return}const w=setTimeout(()=>this.flushBuffer(I),A);k={data:[a],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(I),R.dispose()}},this._terminalBufferMap.set(I,k)});return R}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const O=this._terminalBufferMap.get(I);O&&(this._terminalBufferMap.delete(I),this._callback(I,O.data.join("")))}}e.TerminalDataBufferer=S}),define(Te[223],Pe([1,0,11,98,324,35,6,15,2,178,78,31]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=s,e.getIconRegistry=o,w=$e(w),e.Extensions={IconContribution:"base.contributions.icons"};var c;(function(t){function l(u,g){let m=u.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const p=n.getIcon(m.id);if(!p)return;m=p.defaults}return m}t.getDefinition=l})(c||(e.IconContribution=c={}));var _;(function(t){function l(g){return{weight:g.weight,style:g.style,src:g.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=l;function u(g){const m=p=>(0,R.isString)(p)?p:void 0;if(g&&Array.isArray(g.src)&&g.src.every(p=>(0,R.isString)(p.format)&&(0,R.isString)(p.location)))return{weight:m(g.weight),style:m(g.style),src:g.src.map(p=>({format:p.format,location:v.URI.parse(p.location)}))}}t.fromJSONObject=u})(_||(e.IconFontDefinition=_={}));class h{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(l,u,g,m){const p=this.iconsById[l];if(p){if(g&&!p.description){p.description=g,this.iconSchema.properties[l].markdownDescription=`${g} $(${l})`;const b=this.iconReferenceSchema.enum.indexOf(l);b!==-1&&(this.iconReferenceSchema.enumDescriptions[b]=g),this._onDidChange.fire()}return p}const y={id:l,description:g,defaults:u,deprecationMessage:m};this.iconsById[l]=y;const C={$ref:"#/definitions/icons"};return m&&(C.deprecationMessage=m),g&&(C.markdownDescription=`${g}: $(${l})`),this.iconSchema.properties[l]=C,this.iconReferenceSchema.enum.push(l),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:l}}deregisterIcon(l){delete this.iconsById[l],delete this.iconSchema.properties[l];const u=this.iconReferenceSchema.enum.indexOf(l);u!==-1&&(this.iconReferenceSchema.enum.splice(u,1),this.iconReferenceSchema.enumDescriptions.splice(u,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(l=>this.iconsById[l])}getIcon(l){return this.iconsById[l]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(l,u){const g=this.iconFontsById[l];return g||(this.iconFontsById[l]=u,this._onDidChange.fire(),u)}deregisterIconFont(l){delete this.iconFontsById[l]}getIconFont(l){return this.iconFontsById[l]}toString(){const l=(p,y)=>p.id.localeCompare(y.id),u=p=>{for(;O.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of m.filter(y=>!!y.description).sort(l))g.push(`|<i class="${u(p)}"></i>|${p.id}|${O.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const p of m.filter(y=>!O.ThemeIcon.isThemeIcon(y.defaults)).sort(l))g.push(`|<i class="${u(p)}"></i>|${p.id}|`);return g.join(`
`)}}const n=new h;w.Registry.add(e.Extensions.IconContribution,n);function s(t,l,u,g){return n.registerIcon(t,l,u,g)}function o(){return n}function d(){const t=(0,I.getCodiconFontCharacters)();for(const l in t){const u="\\"+t[l].toString(16);n.registerIcon(l,{fontCharacter:u})}}d(),e.iconsSchemaId="vscode://schemas/icons";const i=w.Registry.as(k.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,n.getIconSchema());const r=new S.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.widgetClose=s("widget-close",T.Codicon.close,(0,a.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",T.Codicon.arrowUp,(0,a.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",T.Codicon.arrowDown,(0,a.localize)(4,null)),e.syncing=O.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(Te[224],Pe([1,0,6,4,21,2,43,3,12]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=w,e.extractLocalHostUriMetaDataForPortMapping=_,e.extractQueryLocalHostUriMetaDataForPortMapping=h,e.isLocalhost=n,e.isAllInterfaces=s,e.isPortPrivileged=o,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var k;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(k||(e.TunnelPrivacyId=k={}));function w(r){return!!r.forwardPort}var c;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function _(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function h(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const l of t){const u=l.split("=")[1];if(/^https?:/.exec(u)){const g=_(O.URI.parse(u));if(g)return g}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}function o(r,t,l,u){if(l===I.OperatingSystem.Windows)return!1;if(l===I.OperatingSystem.Macintosh&&s(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(g?.length===4&&parseInt(g[1])>=18)return!1}return r<1024}class d{constructor(t,l,u){this.remoteAddress=t,this.localAddress=l,this._dispose=u,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let i=class extends T.Disposable{constructor(t,l){super(),this.logService=t,this.configurationService=l,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],l=Array.from(this._tunnels.values());for(const u of l){const g=Array.from(u.values());for(const m of g){const p=await m.value;p&&typeof p!="string"&&t.push(p)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:l}of t.values())await l.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,l,u,g,m){this.addTunnelToMap(t,l,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:l,localAddress:u,privacy:g,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,l){(s(t)||n(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(t,l);if(u)return++u.refcount,u.value}openTunnel(t,l,u,g,m,p=!1,y,C){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${u} on local port ${m}.`);const b=this._tunnelProvider??t;if(!b)return;if(l||(l="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.retainOrCreateTunnel(b,l,u,g,m,p,y,C);return D?D.then(P=>{if(P){if(typeof P=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(l,u),P}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(l,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.makeTunnel(P);return(P.tunnelRemoteHost!==l||P.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&P.privacy!==y&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(f),f}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const l=this._tunnels.get(t.tunnelRemoteHost);if(l){const u=l.get(t.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async tryDisposeTunnel(t,l,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${l}.`);const g=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(l),g}}async closeTunnel(t,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${l} `);const u=this._tunnels.get(t);if(u&&u.has(l)){const g=u.get(l);g.refcount=0,await this.tryDisposeTunnel(t,l,g)}}addTunnelToMap(t,l,u){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(l,{refcount:1,value:u})}async removeEmptyOrErrorTunnelFromMap(t,l){const u=this._tunnels.get(t);if(u){const g=u.get(l),m=g?await g.value:void 0;(!m||typeof m=="string")&&u.delete(l),u.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,l){const u=[t];n(t)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):s(t)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const g=u.map(m=>this._tunnels.get(m));for(const m of g){const p=m?.get(l);if(p)return p}}canTunnel(t){return!!_(t)}createWithProvider(t,l,u,g,m,p,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${u} on local port ${g}.`);const C=u;this._factoryInProgress.add(C);const b=g===void 0?u:g,D={elevationRequired:m?this.isPortPrivileged(b):!1},P={remoteAddress:{host:l,port:u},localAddressPort:g,privacy:p,public:p?p!==k.Private:void 0,protocol:y},f=t.forwardPort(P,D);return f?(this.addTunnelToMap(l,u,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(C)})):this._factoryInProgress.delete(C),f}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=je([Ve(0,v.ILogService),Ve(1,A.IConfigurationService)],i)}),define(Te[225],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(Te[226],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,S.createDecorator)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Te[227],Pe([1,0,16]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=T,e.getVirtualWorkspaceLocation=I,e.getVirtualWorkspaceScheme=O,e.getVirtualWorkspaceAuthority=A,e.isVirtualWorkspace=R;function T(v){return v.scheme!==S.Schemas.file&&v.scheme!==S.Schemas.vscodeRemote}function I(v){if(v.folders.length)return v.folders.every(a=>T(a.uri))?v.folders[0].uri:void 0;if(v.configuration&&T(v.configuration))return v.configuration}function O(v){return I(v)?.scheme}function A(v){return I(v)?.authority}function R(v){return I(v)!==void 0}}),define(Te[50],Pe([1,0,180,20,59,24,2,3,16]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=k,e.toWorkspaceIdentifier=w,e.isWorkspaceIdentifier=c,e.reviveIdentifier=_,e.isWorkspace=n,e.isWorkspaceFolder=s,e.toWorkspaceFolder=i,e.isUntitledWorkspace=r,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=l,e.isSavedWorkspace=u,e.hasWorkspaceFileExtension=g,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function a(m){const p=m;return typeof p?.id=="string"&&A.URI.isUri(p.uri)}function k(m){return typeof m?.id=="string"&&!a(m)&&!c(m)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(m,p){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,T.basename)(m)}:p?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const y=m;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function c(m){const p=m;return typeof p?.id=="string"&&A.URI.isUri(p.configPath)}function _(m){const p=m;if(p?.uri)return{id:p.id,uri:A.URI.revive(p.uri)};const y=m;if(y?.configPath)return{id:y.id,configPath:A.URI.revive(y.configPath)};if(m?.id)return{id:m.id}}var h;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function n(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}function s(m){const p=m;return!!(p&&typeof p=="object"&&A.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}class o{constructor(p,y,C,b,D){this._id=p,this._transient=C,this._configuration=b,this._ignorePathCasing=D,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=y}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class d{constructor(p,y){this.raw=y,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,O.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function i(m){return new d({uri:m,index:0,name:(0,O.basenameOrAuthority)(m)},{uri:m.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function r(m,p){return O.extUriBiasedIgnorePathCase.isEqualOrParent(m,p.untitledWorkspacesHome)}function t(m){let p;return A.URI.isUri(m)?p=m:p=m.configuration,p?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(m){return m.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function u(m,p){return!r(m,p)&&!t(m)}function g(m){return(typeof m=="string"?(0,T.extname)(m):(0,O.extname)(m))===e.WORKSPACE_SUFFIX}}),define(Te[114],Pe([1,0,76,6,4,24,2,179,107,30,3,12,50,29,225,11,37,13,15]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=r,e.reviveProfile=t,e.toUserDataProfile=l;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&typeof p.isDefault=="boolean"&&typeof p.name=="string"&&A.URI.isUri(p.location)&&A.URI.isUri(p.globalStorageHome)&&A.URI.isUri(p.settingsResource)&&A.URI.isUri(p.keybindingsResource)&&A.URI.isUri(p.tasksResource)&&A.URI.isUri(p.snippetsHome)&&A.URI.isUri(p.extensionsResource))}e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function t(m,p){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:p}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:p}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:p}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:p}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:p}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:p}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:p}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:p}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function l(m,p,y,C,b,D){return{id:m,name:p,location:y,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:D&&b?.useDefaultFlags?.globalState?D.globalStorageHome:(0,O.joinPath)(y,"globalStorage"),settingsResource:D&&b?.useDefaultFlags?.settings?D.settingsResource:(0,O.joinPath)(y,"settings.json"),keybindingsResource:D&&b?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,O.joinPath)(y,"keybindings.json"),tasksResource:D&&b?.useDefaultFlags?.tasks?D.tasksResource:(0,O.joinPath)(y,"tasks.json"),snippetsHome:D&&b?.useDefaultFlags?.snippets?D.snippetsHome:(0,O.joinPath)(y,"snippets"),extensionsResource:D&&b?.useDefaultFlags?.extensions?D.extensionsResource:(0,O.joinPath)(y,"extensions.json"),cacheHome:(0,O.joinPath)(C,m),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let u=class extends I.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(p,y,C,b){super(),this.environmentService=p,this.fileService=y,this.uriIdentityService=C,this.logService=b,this.enabled=!0,this._onDidChangeProfiles=this._register(new T.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new T.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new T.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new T.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new _.ResourceMap,workspaces:new _.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(p){this.enabled!==p&&(this._profilesObject=void 0,this.enabled=p)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const p=this.createDefaultProfile(),y=[p];if(this.enabled)try{for(const D of this.getStoredProfiles()){if(!D.name||!(0,d.isString)(D.name)||!D.location){this.logService.warn("Skipping the invalid stored profile",D.location||D.name);continue}y.push(l((0,O.basename)(D.location),D.name,D.location,this.profilesCacheHome,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},p))}}catch(D){this.logService.error(D)}const C=new _.ResourceMap,b=new Map;if(y.length)try{const D=this.getStoredProfileAssociations();if(D.workspaces)for(const[P,f]of Object.entries(D.workspaces)){const E=A.URI.parse(P),F=y.find(L=>L.id===f);F&&C.set(E,F)}if(D.emptyWindows)for(const[P,f]of Object.entries(D.emptyWindows)){const E=y.find(F=>F.id===f);E&&b.set(P,E)}}catch(D){this.logService.error(D)}this._profilesObject={profiles:y,workspaces:C,emptyWindows:b}}return this._profilesObject}createDefaultProfile(){const p=l("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...p,extensionsResource:this.getDefaultProfileExtensionsLocation()??p.extensionsResource,isDefault:!0}}async createTransientProfile(p){const y="Temp",C=new RegExp(`${(0,o.escapeRegExpCharacters)(y)}\\s(\\d+)`);let b=0;for(const P of this.profiles){const f=C.exec(P.name),E=f?parseInt(f[1]):0;b=E>b?E:b}const D=`${y} ${b+1}`;return this.createProfile((0,S.hash)((0,s.generateUuid)()).toString(16),D,{transient:!0},p)}async createNamedProfile(p,y,C){return this.createProfile((0,S.hash)((0,s.generateUuid)()).toString(16),p,y,C)}async createProfile(p,y,C,b){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=await this.doCreateProfile(p,y,C);return b&&await this.setProfileForWorkspace(b,D),D}async doCreateProfile(p,y,C){if(!(0,d.isString)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.profileCreationPromises.get(y);return b||(b=(async()=>{try{if(this.profiles.find(E=>E.name===y||E.id===p))throw new Error(`Profile with ${y} name already exists`);const P=l(p,y,(0,O.joinPath)(this.profilesHome,p),this.profilesCacheHome,C,this.defaultProfile);await this.fileService.createFolder(P.location);const f=[];return this._onWillCreateProfile.fire({profile:P,join(E){f.push(E)}}),await n.Promises.settled(f),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(y)}})(),this.profileCreationPromises.set(y,b)),b}async updateProfile(p,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let C=this.profiles.find(b=>b.id===p.id);if(!C)throw new Error(`Profile '${p.name}' does not exist`);return C=l(C.id,y.name??C.name,C.location,this.profilesCacheHome,{shortName:y.shortName??C.shortName,icon:y.icon===null?void 0:y.icon??C.icon,transient:y.transient??C.isTransient,useDefaultFlags:y.useDefaultFlags??C.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[C]),C}async removeProfile(p){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(p.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(b=>b.id===p.id);if(!y)throw new Error(`Profile '${p.name}' does not exist`);const C=[];this._onWillRemoveProfile.fire({profile:y,join(b){C.push(b)}});try{await Promise.allSettled(C)}catch(b){this.logService.error(b)}for(const b of[...this.profilesObject.emptyWindows.keys()])y.id===this.profilesObject.emptyWindows.get(b)?.id&&this.profilesObject.emptyWindows.delete(b);for(const b of[...this.profilesObject.workspaces.keys()])y.id===this.profilesObject.workspaces.get(b)?.id&&this.profilesObject.workspaces.delete(b);this.updateStoredProfileAssociations(),this.updateProfiles([],[y],[]);try{await this.fileService.del(y.cacheHome,{recursive:!0})}catch(b){(0,a.toFileOperationResult)(b)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(b)}}async setProfileForWorkspace(p,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=this.profiles.find(b=>b.id===y.id);if(!C)throw new Error(`Profile '${y.name}' does not exist`);this.updateWorkspaceAssociation(p,C)}unsetWorkspace(p,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(p,void 0,y)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const p=await this.fileService.resolve(this.profilesHome);await Promise.all((p.children||[]).filter(y=>y.isDirectory&&this.profiles.every(C=>!this.uriIdentityService.extUri.isEqual(C.location,y.resource))).map(y=>this.fileService.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const p=this.transientProfilesObject.profiles.filter(y=>!this.isProfileAssociatedToWorkspace(y));await Promise.allSettled(p.map(y=>this.removeProfile(y)))}getProfileForWorkspace(p){const y=this.getWorkspace(p),C=A.URI.isUri(y)?this.profilesObject.workspaces.get(y):this.profilesObject.emptyWindows.get(y);return C||((0,c.isSingleFolderWorkspaceIdentifier)(p)?this.transientProfilesObject.folders.get(p.uri):(0,c.isWorkspaceIdentifier)(p)?this.transientProfilesObject.workspaces.get(p.configPath):this.transientProfilesObject.emptyWindows.get(p.id))}getWorkspace(p){return(0,c.isSingleFolderWorkspaceIdentifier)(p)?p.uri:(0,c.isWorkspaceIdentifier)(p)?p.configPath:p.id}isProfileAssociatedToWorkspace(p){return!!([...this.profilesObject.emptyWindows.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,p.location))||[...this.profilesObject.workspaces.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,p.location))||[...this.transientProfilesObject.emptyWindows.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,p.location))||[...this.transientProfilesObject.workspaces.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,p.location))||[...this.transientProfilesObject.folders.values()].some(y=>this.uriIdentityService.extUri.isEqual(y.location,p.location)))}updateProfiles(p,y,C){const b=[...this.profiles,...p],D=[],P=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let f of b){if(f.isDefault||y.some(F=>f.id===F.id))continue;f=C.find(F=>f.id===F.id)??f;const E=P.find(F=>f.id===F.id);if(f.isTransient)this.transientProfilesObject.profiles.push(f);else{if(E){for(const[F,L]of this.transientProfilesObject.emptyWindows.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:F},f);break}for(const[F,L]of this.transientProfilesObject.workspaces.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:"",configPath:F},f);break}for(const[F,L]of this.transientProfilesObject.folders.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:"",uri:F},f);break}}D.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.saveStoredProfiles(D),this._profilesObject=void 0,this.triggerProfilesChanges(p,y,C)}triggerProfilesChanges(p,y,C){this._onDidChangeProfiles.fire({added:p,removed:y,updated:C,all:this.profiles})}updateWorkspaceAssociation(p,y,C){if(C=y?.isTransient?!0:C,C)(0,c.isSingleFolderWorkspaceIdentifier)(p)?(this.transientProfilesObject.folders.delete(p.uri),y&&this.transientProfilesObject.folders.set(p.uri,y)):(0,c.isWorkspaceIdentifier)(p)?(this.transientProfilesObject.workspaces.delete(p.configPath),y&&this.transientProfilesObject.workspaces.set(p.configPath,y)):(this.transientProfilesObject.emptyWindows.delete(p.id),y&&this.transientProfilesObject.emptyWindows.set(p.id,y));else{this.updateWorkspaceAssociation(p,void 0,!0);const b=this.getWorkspace(p);A.URI.isUri(b)?(this.profilesObject.workspaces.delete(b),y&&this.profilesObject.workspaces.set(b,y)):(this.profilesObject.emptyWindows.delete(b),y&&this.profilesObject.emptyWindows.set(b,y)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const p={};for(const[C,b]of this.profilesObject.workspaces.entries())p[C.toString()]=b.id;const y={};for(const[C,b]of this.profilesObject.emptyWindows.entries())y[C.toString()]=b.id;this.saveStoredProfileAssociations({workspaces:p,emptyWindows:y}),this._profilesObject=void 0}migrateStoredProfileAssociations(p){const y={},C=this.createDefaultProfile();if(p.workspaces)for(const[D,P]of Object.entries(p.workspaces)){const f=A.URI.parse(P);y[D]=this.uriIdentityService.extUri.isEqual(f,C.location)?C.id:this.uriIdentityService.extUri.basename(f)}const b={};if(p.emptyWindows)for(const[D,P]of Object.entries(p.emptyWindows)){const f=A.URI.parse(P);b[D]=this.uriIdentityService.extUri.isEqual(f,C.location)?C.id:this.uriIdentityService.extUri.basename(f)}return{workspaces:y,emptyWindows:b}}getStoredProfiles(){return[]}saveStoredProfiles(p){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(p){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=u,e.UserDataProfilesService=u=je([Ve(0,v.IEnvironmentService),Ve(1,a.IFileService),Ve(2,h.IUriIdentityService),Ve(3,w.ILogService)],u);class g extends u{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(p){this.storedProfiles=p}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(p){this.storedProfileAssociations=p}}e.InMemoryUserDataProfilesService=g}),define(Te[228],Pe([1,0,11,6,4,65,15,162,3,114]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=_,e.isProfileUsingDefaultStorage=n,e.logStorage=o,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var k;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var c;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(c||(e.StorageTarget=c={}));function _(d){const i=d.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class h extends I.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new T.PauseableEmitter),this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,r,t){return T.Event.filter(this._onDidChangeValue.event,l=>l.scope===i&&(r===void 0||l.key===r),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,r){const{key:t,external:l}=r;if(t===e.TARGET_KEY){switch(i){case w.APPLICATION:this._applicationKeyTargets=void 0;break;case w.PROFILE:this._profileKeyTargets=void 0;break;case w.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:t,target:this.getKeyTargets(i)[t],external:l})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,r,t){return this.getStorage(r)?.get(i,t)}getBoolean(i,r,t){return this.getStorage(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.getStorage(r)?.getNumber(i,t)}getObject(i,r,t){return this.getStorage(r)?.getObject(i,t)}storeAll(i,r){this.withPausedEmitters(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,l,u=!1){if((0,A.isUndefinedOrNull)(r)){this.remove(i,t,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,t,l),this.getStorage(t)?.set(i,r,u)})}remove(i,r,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,r,void 0),this.getStorage(r)?.delete(i,t)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,r){const t=[],l=this.getKeyTargets(i);for(const u of Object.keys(l))l[u]===r&&t.push(u);return t}updateKeyTarget(i,r,t,l=!1){const u=this.getKeyTargets(r);typeof t=="number"?u[i]!==t&&(u[i]=t,this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(u),l)):typeof u[i]=="number"&&(delete u[i],this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(u),l))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(w.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(w.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(w.APPLICATION)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case w.APPLICATION:return this.applicationKeyTargets;case w.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const r=this.getStorage(i);return r?_(r):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=k.NONE){this._onWillSaveState.fire({reason:i});const r=this.getStorage(w.APPLICATION),t=this.getStorage(w.PROFILE),l=this.getStorage(w.WORKSPACE);switch(i){case k.NONE:await S.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await S.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(w.APPLICATION)?.items??new Map,r=this.getStorage(w.PROFILE)?.items??new Map,t=this.getStorage(w.WORKSPACE)?.items??new Map;return o(i,r,t,this.getLogDetails(w.APPLICATION)??"",this.getLogDetails(w.PROFILE)??"",this.getLogDetails(w.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,r){return this.emitWillSaveState(k.NONE),(0,a.isUserDataProfile)(i)?this.switchToProfile(i,r):this.switchToWorkspace(i,r)}canSwitchProfile(i,r){return!(i.id===r.id||n(r)&&n(i))}switchData(i,r,t){this.withPausedEmitters(()=>{const l=new Set;for(const[u,g]of i)l.add(u),r.get(u)!==g&&this.emitDidChangeValue(t,{key:u,external:!0});for(const[u]of r.items)l.has(u)||this.emitDidChangeValue(t,{key:u,external:!0})})}}e.AbstractStorageService=h;function n(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class s extends h{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.WORKSPACE,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.PROFILE,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.APPLICATION,i)))}getStorage(i){switch(i){case w.APPLICATION:return this.applicationStorage;case w.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=s;async function o(d,i,r,t,l,u){const g=E=>{try{return JSON.parse(E)}catch{return E}},m=new Map,p=new Map;d.forEach((E,F)=>{m.set(F,E),p.set(F,g(E))});const y=new Map,C=new Map;i.forEach((E,F)=>{y.set(F,E),C.set(F,g(E))});const b=new Map,D=new Map;r.forEach((E,F)=>{b.set(F,E),D.set(F,g(E))}),console.group(t!==l?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(m.forEach((E,F)=>{P.push({key:F,value:E})}),console.table(P),console.groupEnd(),console.log(p),t!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const E=[];y.forEach((F,L)=>{E.push({key:L,value:F})}),console.table(E),console.groupEnd(),console.log(C)}console.group(`Storage: Workspace (path: ${u})`);const f=[];b.forEach((E,F)=>{f.push({key:F,value:E})}),console.table(f),console.groupEnd(),console.log(D)}}),define(Te[80],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class S{static{this.enableDebugLogging=!1}constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const O=this._idPool++;return this._data.set(O,I),this.logDebugInfo(),O}get(I,O){return this._data.has(I)?this._data.get(I)[O]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){S.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=S}),define(Te[51],Pe([1,0,16,24,30,3]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(S.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(v=>{const a=this._providerInfo.get(v.scheme);return!(a===void 0||a&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,a){a===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,a)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,O.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(Te[229],Pe([1,0,185,12,213,27]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends I.LogService{constructor(v,a,k){const w=k.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",c=k.remote.isRemote?(0,S.localize)(0,null):v?(0,S.localize)(1,null):(0,S.localize)(2,null);super(a.createLogger(w,{name:c}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=je([Ve(1,T.ILoggerService),Ve(2,O.IExtHostInitDataService)],A)}),define(Te[230],Pe([1,0,11]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(A,R,v){this._deferredPromises=new Map,this._id=A,this._shared=R,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(a=>(this._value=a,this)),this._storageListener=this._storage.onDidChangeStorage(a=>{a.shared===this._shared&&a.key===this._id&&(this._value=a.value)}),this._scheduler=new S.RunOnceScheduler(()=>{const a=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const k of a.values())k.complete()}catch(k){for(const w of a.values())w.error(k)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,R){let v=this._value[A];return typeof v>"u"&&(v=R),v}update(A,R){this._value[A]=R;const v=this._deferredPromises.get(A);if(v!==void 0)return v.p;const a=new S.DeferredPromise;return this._deferredPromises.set(A,a),this._scheduler.isScheduled()||this._scheduler.schedule(),a.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class I extends T{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,R){super(A.identifier.value,!0,R),this._extension=A}}e.ExtensionGlobalMemento=I}),define(Te[231],Pe([1,0,6,2]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new S.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,R,v,a){const w=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(R.value,v,a);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(A,R){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptDirty(R)}$acceptModelSaved(A){const R=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Te[17],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class T{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=T}),define(Te[232],Pe([1,0,19,6,4]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class O{#e;constructor(R,v){this.disposables=new I.DisposableStore,this._id=S.ExtensionIdentifier.toKey(R.identifier),this.#e=v,this.onDidChange=T.Event.map(T.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this._id),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this._id,R)}store(R,v){return this.#e.store(this._id,R,v)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=O}),define(Te[66],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,S.createDecorator)("IURITransformerService");class T{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=T});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[115],Pe([1,0,194,15,2,4,3,31,30,16,41,156,36]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=n,e.isEditorPaneWithScrolling=s,e.findViewStateForEditor=o,e.isResourceEditorInput=d,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=r,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=l,e.isResourceMergeEditorInput=u,e.isEditorInput=b,e.isSideBySideEditorInput=P,e.isDiffEditorInput=f,e.createTooLargeFileError=E,e.isEditorInputWithOptions=F,e.isEditorInputWithOptionsAndGroup=L,e.isEditorIdentifier=M,e.isEditorCommandsContext=V,e.preventEditorClose=Z,e.pathsToEditors=le,e.isTextEditorViewState=oe,e.isEditorOpenError=Ie,e.createEditorOpenError=Me,c=Zt(c),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var _;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(_||(e.EditorPaneSelectionChangeReason=_={}));var h;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(h||(e.EditorPaneSelectionCompareResult=h={}));function n(X){const $=X;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}function s(X){const $=X;return!!$&&typeof $.getScrollPosition=="function"&&typeof $.setScrollPosition=="function"&&!!$.onDidChangeScroll}function o(X,$,te){for(const Se of te.visibleEditorPanes)if(Se.group.id===$&&X.matches(Se.input))return Se.getViewState()}function d(X){if(b(X))return!1;const $=X;return I.URI.isUri($?.resource)}function i(X){if(b(X))return!1;const $=X;return $?.original!==void 0&&$.modified!==void 0}function r(X){if(b(X))return!1;const $=X;return!$||$.resources&&!Array.isArray($.resources)?!1:!!$.resources||!!$.multiDiffSource}function t(X){if(b(X)||i(X))return!1;const $=X;return $?.primary!==void 0&&$.secondary!==void 0}function l(X){if(b(X))return!1;const $=X;return $?$.resource===void 0||$.resource.scheme===a.Schemas.untitled||$.forceUntitled===!0:!1}function u(X){if(b(X))return!1;const $=X;return I.URI.isUri($?.base?.resource)&&I.URI.isUri($?.input1?.resource)&&I.URI.isUri($?.input2?.resource)&&I.URI.isUri($?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var m;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class p{constructor(){this.mapIdToSaveSource=new Map}registerSource($,te){let Se=this.mapIdToSaveSource.get($);return Se||(Se={source:$,label:te},this.mapIdToSaveSource.set($,Se)),Se.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new p;var y;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class C extends O.Disposable{}e.AbstractEditorInput=C;function b(X){return X instanceof C}function D(X){const $=X;return I.URI.isUri($?.preferredResource)}function P(X){const $=X;return b($?.primary)&&b($?.secondary)}function f(X){const $=X;return b($?.modified)&&b($?.original)}function E(X,$,te,Se,ce){return Me(Se,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const be={...te,limits:{size:Number.MAX_VALUE}};X.openEditor($,be)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}function F(X){return b(X?.editor)}function L(X){const $=X;return F(X)&&$?.group!==void 0}function M(X){const $=X;return typeof $?.groupId=="number"&&b($.editor)}function V(X){return typeof X?.groupId=="number"}var W;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var N;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var Q;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(Q||(e.SideBySideEditor=Q={}));class Y{getOriginalUri($,te){if(!$)return;if(u($))return e.EditorResourceAccessor.getOriginalUri($.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:be}=this.getSideEditors($);if(ce&&be){if(te?.supportSideBySide===Q.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Q.ANY)return this.getOriginalUri(ce,{filterByScheme:te.filterByScheme})??this.getOriginalUri(be,{filterByScheme:te.filterByScheme});$=te.supportSideBySide===Q.PRIMARY?ce:be}}if(i($)||r($)||t($)||u($))return;const Se=D($)?$.preferredResource:$.resource;return!Se||!te||!te.filterByScheme?Se:this.filterUri(Se,te.filterByScheme)}getSideEditors($){return P($)||t($)?{primary:$.primary,secondary:$.secondary}:f($)||i($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,te){if(!$)return;if(u($))return e.EditorResourceAccessor.getCanonicalUri($.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:be}=this.getSideEditors($);if(ce&&be){if(te?.supportSideBySide===Q.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Q.ANY)return this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:te.filterByScheme});$=te.supportSideBySide===Q.PRIMARY?ce:be}}if(i($)||r($)||t($)||u($))return;const Se=$.resource;return!Se||!te||!te.filterByScheme?Se:this.filterUri(Se,te.filterByScheme)}filterUri($,te){if(Array.isArray(te)){if(te.some(Se=>$.scheme===Se))return $}else if(te===$.scheme)return $}}var ge;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function Z(X,$,te,Se){if(!X.isSticky($))return!1;switch(Se.preventPinnedEditorClose){case"keyboardAndMouse":return te===ge.MOUSE||te===ge.KEYBOARD;case"mouse":return te===ge.MOUSE;case"keyboard":return te===ge.KEYBOARD}return!1}e.EditorResourceAccessor=new Y;var me;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class se{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const te=this.instantiationService=$.get(A.IInstantiationService);for(const[Se,ce]of this.editorSerializerConstructors)this.createEditorSerializer(Se,ce,te);this.editorSerializerConstructors.clear()}createEditorSerializer($,te,Se){const ce=Se.createInstance(te);this.editorSerializerInstances.set($,ce)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,te){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,te,this.instantiationService):this.editorSerializerConstructors.set($,te),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new se);async function le(X,$,te){return!X||!X.length?[]:await Promise.all(X.map(async Se=>{const ce=I.URI.revive(Se.fileUri);if(!ce){te.info("Cannot resolve the path because it is not valid.",Se);return}if(!await $.canHandleResource(ce)){te.info("Cannot resolve the path because it cannot be handled",Se);return}let he=Se.exists,G=Se.type;if(typeof he!="boolean"||typeof G!="number")try{G=(await $.stat(ce)).isDirectory?v.FileType.Directory:v.FileType.Unknown,he=!0}catch(pe){te.error(pe),he=!1}if(!he&&Se.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",Se);return}if(G===v.FileType.Directory){te.info("Cannot resolve the path because it is a directory",Se);return}const J={...Se.options,pinned:!0};return he?{resource:ce,options:J}:{resource:ce,options:J,forceUntitled:!0}}))}var Ee;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(Ee||(e.EditorsOrder=Ee={}));function oe(X){const $=X;if(!$)return!1;const te=$;if(te.modified)return oe(te.modified);const Se=$;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}function Ie(X){return(0,k.isErrorWithActions)(X)}function Me(X,$,te){const Se=(0,k.createErrorWithActions)(X,$);return Se.forceMessage=te?.forceMessage,Se.forceSeverity=te?.forceSeverity,Se.allowDialog=te?.allowDialog,Se}}),define(Te[233],Pe([1,0,6,195,3,4,29,31,26,98,223]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=_,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,T.localize)(0,null),e.defaultViewIcon=(0,k.registerIcon)("default-view-icon",a.Codicon.window,(0,T.localize)(1,null));var w;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var c;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(c||(e.ViewContainerLocation=c={})),e.ViewContainerLocations=[c.Sidebar,c.Panel,c.AuxiliaryBar];function _(l){switch(l){case c.Sidebar:return"sidebar";case c.Panel:return"panel";case c.AuxiliaryBar:return"auxiliarybar"}}class h extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new S.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new S.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(u,g,m){const p=this.get(u.id);if(p)return p;const y=u;return y.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,A.getOrSet)(this.viewContainers,g,[]).push(y),m?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:g}),y}deregisterViewContainer(u){for(const g of this.viewContainers.keys()){const m=this.viewContainers.get(g),p=m?.indexOf(u);if(p!==-1){m?.splice(p,1),m.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:g});return}}}get(u){return this.all.filter(g=>g.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===u)}}R.Registry.add(w.ViewContainersRegistry,new h);var n;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(n||(e.ViewContentGroups=n={}));function s(l,u){const g=l.group??n.More,m=u.group??n.More;return g!==m?g.localeCompare(m):(l.order??5)-(u.order??5)}class o extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new S.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new S.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new S.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new S.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(u,g){this.registerViews2([{views:u,viewContainer:g}])}registerViews2(u){u.forEach(({views:g,viewContainer:m})=>this.addViews(g,m)),this._onViewsRegistered.fire(u)}deregisterViews(u,g){const m=this.removeViews(u,g);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:g})}moveViews(u,g){for(const m of this._views.keys())if(m!==g){const p=this.removeViews(u,m);p.length&&(this.addViews(p,g),this._onDidChangeContainer.fire({views:p,from:m,to:g}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const g of this._viewContainers){const m=(this._views.get(g)||[]).filter(p=>p.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(p=>p.id===u)[0])return g;return null}registerViewWelcomeContent(u,g){return this._viewWelcomeContents.add(u,g),this._onDidChangeViewWelcomeContent.fire(u),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(u,g),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,g){const m=new Map;for(const[p,y]of g)this._viewWelcomeContents.add(u,y),m.set(p,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(u,y),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),m}getViewWelcomeContent(u){const g=[];return this._viewWelcomeContents.forEach(u,m=>g.push(m)),g.sort(s)}addViews(u,g){let m=this._views.get(g);m||(m=[],this._views.set(g,m),this._viewContainers.push(g));for(const p of u){if(this.getView(p.id)!==null)throw new Error((0,T.localize)(2,null,p.id));m.push(p)}}removeViews(u,g){const m=this._views.get(g);if(!m)return[];const p=[],y=[];for(const C of m)u.includes(C)?p.push(C):y.push(C);return p.length&&(y.length?this._views.set(g,y):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),p}}R.Registry.add(w.ViewsRegistry,new o),e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var d;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(d||(e.ViewVisibilityState=d={}));var i;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(u,g){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,u),this._hasResolve=!!g,this.resolve=async m=>{if(g&&!this.resolved){const p=await g(m);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r;class t extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Te[234],Pe([1,0,196,32]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new T.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,S.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new T.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,S.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new T.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,S.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new T.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,S.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new T.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,S.localize)(4,null)}),e.CONTEXT_RESPONSE=new T.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,S.localize)(5,null)}),e.CONTEXT_REQUEST=new T.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,S.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new T.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,S.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new T.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,S.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new T.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,S.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new T.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,S.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new T.RawContextKey("inChat",!1,{type:"boolean",description:(0,S.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new T.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,S.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new T.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new T.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new T.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new T.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,S.localize)(13,null)})}),define(Te[235],Pe([1,0,325,11,22,6,40,4,49,142,13,32,19,3,12,109,217,228,234]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=g,e.reviveSerializedAgent=m;var r;(function(p){p.Panel="panel",p.Terminal="terminal",p.Notebook="notebook",p.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function(p){function y(C){switch(C){case"panel":return p.Panel;case"terminal":return p.Terminal;case"notebook":return p.Notebook;case"editor":return p.Editor}return p.Panel}p.fromRaw=y}(r||(e.ChatAgentLocation=r={})),e.IChatAgentService=(0,_.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(y){this.contextKeyService=y,this._agents=new Map,this._onDidChangeAgents=new O.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=d.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(y,C){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const D=this,P=C.slashCommands;C={...C,get slashCommands(){return P.filter(E=>!E.when||D.contextKeyService.contextMatchesRules(w.ContextKeyExpr.deserialize(E.when)))}};const f={data:C};return this._agents.set(y,f),(0,R.toDisposable)(()=>{this._agents.delete(y),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(y,C){const b=this._agents.get(y);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return b.data.isDefault&&this._hasDefaultAgent.set(!0),b.impl=C,this._onDidChangeAgents.fire(new l(b.data,C)),(0,R.toDisposable)(()=>{b.impl=void 0,this._onDidChangeAgents.fire(void 0),b.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(y,C){y.isDynamic=!0;const b={data:y,impl:C};return this._agents.set(y.id,b),this._onDidChangeAgents.fire(new l(y,C)),(0,R.toDisposable)(()=>{this._agents.delete(y.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(y,C){return this._agentCompletionProviders.set(y,C),{dispose:()=>{this._agentCompletionProviders.delete(y)}}}async getAgentCompletionItems(y,C,b){return await this._agentCompletionProviders.get(y)?.(C,b)??[]}updateAgent(y,C){const b=this._agents.get(y);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);b.data.metadata={...b.data.metadata,...C},this._onDidChangeAgents.fire(new l(b.data,b.impl))}getDefaultAgent(y){return(0,S.findLast)(this.getActivatedAgents(),C=>!!C.isDefault&&C.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(C=>!!C.isDefault&&C.locations.includes(y))}getSecondaryAgent(){return A.Iterable.find(this._agents.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this._agentIsEnabled(y))return this._agents.get(y)?.data}_agentIsEnabled(y){const C=this._agents.get(y);return!C?.data.when||this.contextKeyService.contextMatchesRules(w.ContextKeyExpr.deserialize(C.data.when))}getAgentByFullyQualifiedId(y){const C=A.Iterable.find(this._agents.values(),b=>g(b.data)===y)?.data;if(!(C&&!this._agentIsEnabled(C.id)))return C}getAgents(){return Array.from(this._agents.values()).map(y=>y.data).filter(y=>this._agentIsEnabled(y.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(y=>!!y.impl).filter(y=>this._agentIsEnabled(y.data.id)).map(y=>new l(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(C=>C.name===y)}agentHasDupeName(y){const C=this.getAgent(y);return C?this.getAgentsByName(C.name).filter(b=>b.extensionId.value!==C.extensionId.value).length>0:!1}async invokeAgent(y,C,b,D,P){const f=this._agents.get(y);if(!f?.impl)throw new Error(`No activated agent with id "${y}"`);return await f.impl.invoke(C,b,D,P)}async getFollowups(y,C,b,D,P){const f=this._agents.get(y);if(!f?.impl)throw new Error(`No activated agent with id "${y}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(C,b,D,P):[]}};e.ChatAgentService=t,e.ChatAgentService=t=je([Ve(0,w.IContextKeyService)],t);class l{constructor(y,C){this.data=y,this.impl=C}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(y,C,b,D){return this.impl.invoke(y,C,b,D)}async provideFollowups(y,C,b,D){return this.impl.provideFollowups?this.impl.provideFollowups(y,C,b,D):[]}provideWelcomeMessage(y,C){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(y,C)}provideSampleQuestions(y,C){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(y,C)}}e.MergedChatAgent=l,e.IChatAgentNameService=(0,_.createDecorator)("chatAgentNameService");let u=class{static{i=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(y,C,b,D){if(this.requestService=C,this.logService=b,this.storageService=D,this.registry=(0,a.observableValue)(this,Object.create(null)),this.disposed=!1,!y.chatParticipantRegistry)return;this.url=y.chatParticipantRegistry;const P=D.get(i.StorageKey,o.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(P??"{}"),void 0)}catch{D.remove(i.StorageKey,o.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(y=>this.logService.warn("Failed to fetch chat participant registry",y)).then(()=>(0,T.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const y=await this.requestService.request({type:"GET",url:this.url},I.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,s.asJson)(y);if(!C||C.version!==1)throw new Error("Unexpected chat participant registry response.");const b=C.restrictedChatParticipants;this.registry.set(b,void 0),this.storageService.store(i.StorageKey,JSON.stringify(b),o.StorageScope.APPLICATION,o.StorageTarget.MACHINE)}getAgentNameRestriction(y){const C=this.checkAgentNameRestriction(y.name,y).get(),b=!y.fullName||this.checkAgentNameRestriction(y.fullName.replace(/\s/g,""),y).get();return C&&b}checkAgentNameRestriction(y,C){return this.registry.map(D=>D[y.toLowerCase()]).map(D=>D?D.some(P=>(0,k.equalsIgnoreCase)(P,P.includes(".")?C.extensionId.value:C.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=u,e.ChatAgentNameService=u=i=je([Ve(0,n.IProductService),Ve(1,s.IRequestService),Ve(2,h.ILogService),Ve(3,o.IStorageService)],u);function g(p){return`${p.extensionId.value}.${p.id}`}function m(p){const y="name"in p?p:{...p,name:p.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new c.ExtensionIdentifier("")),(0,v.revive)(y)}}),define(Te[236],Pe([1,0,2,33,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.isIDocumentContext=O,e.isIUsedContext=A;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof S.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(T.Range.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var R;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var v;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(v||(e.ChatCopyKind=v={})),e.IChatService=(0,I.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Te[237],Pe([1,0,6,11,198]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new S.Emitter,this._onExit=new S.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,v,a,k){const w={command:R};if(v&&Object.keys(v).length>0&&(w.arguments=v),this.internalSend("request",w),typeof k=="number"){const c=setTimeout(()=>{clearTimeout(c);const _=this.pendingRequests.get(w.seq);if(_){this.pendingRequests.delete(w.seq);const h={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,I.localize)(0,null,k,R)};_(h)}},k)}return a&&this.pendingRequests.set(w.seq,a),w.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,v){return R.type!=="event"||v.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,T.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const v=R,a=this.pendingRequests.get(v.request_seq);a&&(this.pendingRequests.delete(v.request_seq),a(v));break}}}}internalSend(R,v){v.type=R,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((v,a)=>R.set(a,v)),await(0,T.timeout)(500),R.forEach((v,a)=>{v({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(a)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(Te[81],Pe([1,0,2,199,32,3]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=k,T=$e(T),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:T.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:T.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:T.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:T.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new I.RawContextKey("hasDebugged",!1,{type:"boolean",description:T.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:T.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:T.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:T.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:T.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:T.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:T.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:T.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:T.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:T.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:T.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:T.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:T.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:T.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:T.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:T.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:T.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:T.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new I.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:T.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new I.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:T.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:T.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:T.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:T.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:T.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new I.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:T.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:T.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:T.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:T.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:T.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:T.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:T.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:T.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:T.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:T.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:T.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new I.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:T.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:T.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:T.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:T.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:T.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:T.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new I.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:T.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:T.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:T.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new I.RawContextKey("variableValue",!1,{type:"string",description:T.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new I.RawContextKey("variableType",!1,{type:"string",description:T.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new I.RawContextKey("variableInterfaces",!1,{type:"array",description:T.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new I.RawContextKey("variableName",!1,{type:"string",description:T.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new I.RawContextKey("variableLanguage",!1,{type:"string",description:T.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new I.RawContextKey("variableExtensionId",!1,{type:"string",description:T.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:T.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:T.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:T.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:T.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:T.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:T.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:T.localize(60,null)});const A=i=>T.localize(61,null,i);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:T.localize(62,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function v(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function k(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var w;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var c;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(c||(e.DebugConfigurationProviderTriggerKind=c={}));var _;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(_||(e.DebuggerString=_={})),e.IDebugService=(0,O.createDecorator)("debugService");var h;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var d;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:S.URI.revive(r.iconPath.light),dark:S.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(d||(e.IDebugVisualization=d={}))}),define(Te[238],Pe([1,0,13,2,20,26,16,33,22,18]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=w,e.filterExceptionsFromTelemetry=c,e.isSessionAttach=_,e.getExtensionHostDebugSession=h,e.isDebuggerMainContribution=n,e.getExactExpressionStartAndEnd=s,e.getEvaluatableExpressionAtPosition=o,e.isUri=i,e.convertToDAPaths=l,e.convertToVSCPaths=u,e.getVisibleAndSorted=m,e.saveAllBeforeDebugStart=y;const k=/{([^}]+)}/g;function w(b,D,P){return b.replace(k,function(f,E){return D&&E.length>0&&E[0]!=="_"?f:P&&P.hasOwnProperty(E)?P[E]:f})}function c(b){const D={};for(const P of Object.keys(b))P.startsWith("!")||(D[P]=b[P]);return D}function _(b){return b.configuration.request==="attach"&&!h(b)&&(!b.parentSession||_(b.parentSession))}function h(b){let D=b.configuration.type;if(D)return D==="vslsShare"&&(D=b.configuration.adapterProxy.configuration.type),(0,S.equalsIgnoreCase)(D,"extensionhost")||(0,S.equalsIgnoreCase)(D,"pwa-extensionhost")?b:b.parentSession?h(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function s(b,D,P){let f,E=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=F.exec(b);){const M=L.index+1,V=M+L[0].length;if(M<=D&&V>=P){f=L[0],E=M;break}}if(f){const M=/\w+/g;let V=null;for(;(V=M.exec(f))&&!(V.index+1+E+V[0].length>=P););V&&(f=f.substring(0,M.lastIndex))}return f?{start:E,end:E+f.length-1}:{start:0,end:0}}async function o(b,D,P,f){if(b.evaluatableExpressionProvider.has(D)){const E=b.evaluatableExpressionProvider.ordered(D),F=(0,a.coalesce)(await Promise.all(E.map(async L=>{try{return await L.provideEvaluatableExpression(D,P,f??v.CancellationToken.None)}catch{return}})));if(F.length>0){let L=F[0].expression;const M=F[0].range;return L||(L=D.getLineContent(P.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:L}}}else{const E=D.getLineContent(P.lineNumber),{start:F,end:L}=s(E,P.column,P.column),M=E.substring(F-1,L);return{matchingExpression:M,range:new R.Range(P.lineNumber,F,P.lineNumber,F+M.length)}}return null}const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(d))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return T.URI.parse(b.path);if((0,I.isAbsolute)(b.path))return T.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const D=T.URI.revive(b.path);if(D)return D.scheme===A.Schemas.file?D.fsPath:D.toString()}return b.path}function l(b,D){const P=D?r:t,f=(0,O.deepClone)(b);return g(f,(E,F)=>{E&&F&&(F.path=P(F))}),f}function u(b,D){const P=D?r:t,f=(0,O.deepClone)(b);return g(f,(E,F)=>{!E&&F&&(F.path=P(F))}),f}function g(b,D){switch(b.type){case"event":{const P=b;switch(P.event){case"output":D(!1,P.body.source);break;case"loadedSource":D(!1,P.body.source);break;case"breakpoint":D(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=b;switch(P.command){case"setBreakpoints":D(!0,P.arguments.source);break;case"breakpointLocations":D(!0,P.arguments.source);break;case"source":D(!0,P.arguments.source);break;case"gotoTargets":D(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(f=>D(!1,f));break;default:break}break}case"response":{const P=b;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(f=>D(!1,f.source));break;case"loadedSources":P.body.sources.forEach(f=>D(!1,f));break;case"scopes":P.body.scopes.forEach(f=>D(!1,f.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(f=>D(!1,f.source));break;case"setBreakpoints":P.body.breakpoints.forEach(f=>D(!1,f.source));break;case"disassemble":P.body?.instructions.forEach(E=>D(!1,E.location));break;default:break}break}}}function m(b){return b.filter(D=>!D.presentation?.hidden).sort((D,P)=>D.presentation?P.presentation?D.presentation.group?P.presentation.group?D.presentation.group!==P.presentation.group?D.presentation.group.localeCompare(P.presentation.group):p(D.presentation.order,P.presentation.order):-1:P.presentation.group?1:p(D.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function p(b,D){return typeof b!="number"?typeof D!="number"?0:1:typeof D!="number"?-1:b-D}async function y(b,D){const P=b.getValue("debug.saveBeforeStart",{overrideIdentifier:D.activeTextEditorLanguageId});if(P!=="none"&&(await D.saveAll(),P==="allEditorsInActiveGroup")){const f=D.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await D.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const C=(b,D)=>!b||!D?b===D:b.name===D.name&&b.path===D.path&&b.sourceReference===D.sourceReference;e.sourcesEqual=C}),define(Te[239],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.INotebookExecutionService=(0,S.createDecorator)("INotebookExecutionService")}),define(Te[240],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var T;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(T||(e.ProxyKernelState=T={})),e.INotebookKernelService=(0,S.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,S.createDecorator)("INotebookKernelHistoryService")}),define(Te[241],Pe([1,0,4,33,52,167,102]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends S.Disposable{constructor(a,k,w){super(),this._source=a,this._inputTextBuffer=k,this._outputs=w,this._outputTextBuffers=void 0}_getFullModelRange(a){const k=a.getLineCount();return new T.Range(1,1,k,this._getLineMaxColumn(a,k))}_getLineMaxColumn(a,k){if(k<1||k>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(k)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const a=new O.PieceTreeTextBufferBuilder;a.acceptChunk(this._source);const k=a.finish(!0),{textBuffer:w,disposable:c}=k.create(I.DefaultEndOfLine.LF);this._inputTextBuffer=w,this._register(c)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(a=>{const k=new O.PieceTreeTextBufferBuilder;k.acceptChunk(a);const w=k.finish(!0),{textBuffer:c,disposable:_}=w.create(I.DefaultEndOfLine.LF);return this._register(_),c})),this._outputTextBuffers}findInInputs(a){const w=new A.SearchParams(a,!1,!1,null).parseSearchRequest();if(!w)return[];const c=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(c,w,!0,5e3)}findInOutputs(a){const w=new A.SearchParams(a,!1,!1,null).parseSearchRequest();return w?this.outputTextBuffers.map(c=>{const _=c.findMatchesLineByLine(this._getFullModelRange(c),w,!0,5e3);if(_.length!==0)return{textBuffer:c,matches:_}}).filter(c=>!!c):[]}}e.CellSearchModel=R}),define(Te[55],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var T;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(A,R,v=A.parent){if(A._isRoot)return new I([R]);const a=[A.id];for(let k=v;k&&k.id!==R;k=k.parent)a.push(k.id);return a.push(R),new I(a.reverse())}static isRoot(A){return!A.includes(S.Delimiter)}static root(A){const R=A.indexOf(S.Delimiter);return R===-1?A:A.slice(0,R)}static fromString(A){return new I(A.split(S.Delimiter))}static join(A,R){return new I([...A.path,R])}static joinToString(A,R){return A.toString()+S.Delimiter+R}static parentId(A){const R=A.lastIndexOf(S.Delimiter);return R===-1?void 0:A.slice(0,R)}static localId(A){const R=A.lastIndexOf(S.Delimiter);return R===-1?A:A.slice(R+S.Delimiter.length)}static isChild(A,R){return R.startsWith(A)&&R[A.length]===S.Delimiter}static compare(A,R){return A===R?T.IsSame:I.isChild(A,R)?T.IsChild:I.isChild(R,A)?T.IsParent:T.Disconnected}static getLengthOfCommonPrefix(A,R){if(A===0)return 0;let v=0;for(;v<A-1;){for(let a=1;a<A;a++){const k=R(a-1),w=R(a);if(k.path[v]!==w.path[v])return v}v++}return v}constructor(A,R=A.length){if(this.path=A,this.viewEnd=R,A.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let R=0;R<A.viewEnd&&R<this.viewEnd;R++)if(A.path[R]!==this.path[R])return T.Disconnected;return A.viewEnd>this.viewEnd?T.IsChild:A.viewEnd<this.viewEnd?T.IsParent:T.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+=S.Delimiter,this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=I}),define(Te[56],Pe([1,0,2,101,33,55]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.testResultStateToContextValues={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var R;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.testRunProfileBitsetList=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const a=W=>"runId"in W;e.isStartControllerTests=a;var k;(function(W){W.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),W.deserialize=(N,Q)=>({range:I.Range.lift(Q.range),uri:N.asCanonicalUri(S.URI.revive(Q.uri))})})(k||(e.IRichLocation=k={}));var w;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(w||(e.TestMessageType=w={}));var c;(function(W){W.serialize=N=>({message:N.message,type:w.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&k.serialize(N.location)}),W.deserialize=(N,Q)=>({message:Q.message,type:w.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&k.deserialize(N,Q.location)})})(c||(e.ITestErrorMessage=c={}));const _=(W,N)=>`${N?"s":"e"}${W}`;e.getMarkId=_;var h;(function(W){W.serialize=N=>({message:N.message,type:w.Output,offset:N.offset,length:N.length,location:N.location&&k.serialize(N.location)}),W.deserialize=(N,Q)=>({message:Q.message,type:w.Output,offset:Q.offset,length:Q.length,location:Q.location&&k.deserialize(N,Q.location)})})(h||(e.ITestOutputMessage=h={}));var n;(function(W){W.serialize=N=>N.type===w.Error?c.serialize(N):h.serialize(N),W.deserialize=(N,Q)=>Q.type===w.Error?c.deserialize(N,Q):h.deserialize(N,Q)})(n||(e.ITestMessage=n={}));var s;(function(W){W.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),W.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(n.serialize)}),W.deserialize=(N,Q)=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(Y=>n.deserialize(N,Y))})})(s||(e.ITestTaskState=s={}));const o="\0",d=(W,N)=>W+o+N;e.namespaceTestTag=d;const i=W=>{const N=W.indexOf(o);return{ctrlId:W.slice(0,N),tagId:W.slice(N+1)}};e.denamespaceTestTag=i;var r;(function(W){W.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),W.deserialize=(N,Q)=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?N.asCanonicalUri(S.URI.revive(Q.uri)):void 0,range:Q.range?I.Range.lift(Q.range):null,description:Q.description,error:Q.error,sortText:Q.sortText})})(r||(e.ITestItem=r={}));var t;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var l;(function(W){W.serialize=N=>({expand:N.expand,item:r.serialize(N.item)}),W.deserialize=(N,Q)=>({controllerId:O.TestId.root(Q.item.extId),expand:Q.expand,item:r.deserialize(N,Q.item)})})(l||(e.InternalTestItem=l={}));var u;(function(W){W.serialize=N=>{let Q;return N.item&&(Q={},N.item.label!==void 0&&(Q.label=N.item.label),N.item.tags!==void 0&&(Q.tags=N.item.tags),N.item.busy!==void 0&&(Q.busy=N.item.busy),N.item.uri!==void 0&&(Q.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(Q.range=N.item.range?.toJSON()),N.item.description!==void 0&&(Q.description=N.item.description),N.item.error!==void 0&&(Q.error=N.item.error),N.item.sortText!==void 0&&(Q.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:Q}},W.deserialize=N=>{let Q;return N.item&&(Q={},N.item.label!==void 0&&(Q.label=N.item.label),N.item.tags!==void 0&&(Q.tags=N.item.tags),N.item.busy!==void 0&&(Q.busy=N.item.busy),N.item.range!==void 0&&(Q.range=N.item.range?I.Range.lift(N.item.range):null),N.item.description!==void 0&&(Q.description=N.item.description),N.item.error!==void 0&&(Q.error=N.item.error),N.item.sortText!==void 0&&(Q.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:Q}}})(u||(e.ITestItemUpdate=u={}));const g=(W,N)=>{N.expand!==void 0&&(W.expand=N.expand),N.item!==void 0&&(W.item=W.item?Object.assign(W.item,N.item):N.item)};e.applyTestItemUpdate=g;var m;(function(W){W.serializeWithoutMessages=N=>({...l.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(s.serializeWithoutMessages)}),W.serialize=N=>({...l.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(s.serialize)}),W.deserialize=(N,Q)=>({...l.deserialize(N,Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(Y=>s.deserialize(N,Y)),retired:!0})})(m||(e.TestResultItem=m={}));var p;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(N,Q)=>{N.covered+=Q.covered,N.total+=Q.total}})(p||(e.ICoverageCount=p={}));var y;(function(W){W.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testIds:N.testIds,uri:N.uri.toJSON()}),W.deserialize=(N,Q)=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:N.asCanonicalUri(S.URI.revive(Q.uri))}),W.empty=(N,Q)=>({id:N,uri:Q,statement:p.empty()})})(y||(e.IFileCoverage=y={}));function C(W){return{...W,location:W.location?.toJSON()}}function b(W){return W.location=W.location?T.Position.isIPosition(W.location)?T.Position.lift(W.location):I.Range.lift(W.location):void 0,W}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var D;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(D||(e.DetailType=D={}));var P;(function(W){W.serialize=N=>N.type===D.Declaration?E.serialize(N):F.serialize(N),W.deserialize=N=>N.type===D.Declaration?E.deserialize(N):F.deserialize(N)})(P||(e.CoverageDetails=P={}));var f;(function(W){W.serialize=C,W.deserialize=b})(f||(e.IBranchCoverage=f={}));var E;(function(W){W.serialize=C,W.deserialize=b})(E||(e.IDeclarationCoverage=E={}));var F;(function(W){W.serialize=N=>({...C(N),branches:N.branches?.map(f.serialize)}),W.deserialize=N=>({...b(N),branches:N.branches?.map(f.deserialize)})})(F||(e.IStatementCoverage=F={}));var L;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var M;(function(W){W.deserialize=(N,Q)=>Q.op===L.Add?{op:Q.op,item:l.deserialize(N,Q.item)}:Q.op===L.Update?{op:Q.op,item:u.deserialize(Q.item)}:Q.op===L.DocumentSynced?{op:Q.op,uri:N.asCanonicalUri(S.URI.revive(Q.uri)),docv:Q.docv}:Q,W.serialize=N=>N.op===L.Add?{op:N.op,item:l.serialize(N.item)}:N.op===L.Update?{op:N.op,item:u.serialize(N.item)}:N})(M||(e.TestsDiffOp=M={}));class V{constructor(N){this.uriIdentity=N,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(N){const Q=this.createChangeCollector();for(const Y of N)switch(Y.op){case L.Add:this.add(l.deserialize(this.uriIdentity,Y.item),Q);break;case L.Update:this.update(u.deserialize(Y.item),Q);break;case L.Remove:this.remove(Y.itemId,Q);break;case L.Retire:this.retireTest(Y.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(Y.amount);break;case L.AddTag:this._tags.set(Y.tag.id,Y.tag);break;case L.RemoveTag:this._tags.delete(Y.id);break}Q.complete?.()}add(N,Q){const Y=O.TestId.parentId(N.item.extId)?.toString();let ge;if(!Y)ge=this.createItem(N),this.roots.add(ge),this.items.set(N.item.extId,ge);else if(this.items.has(Y)){const Z=this.items.get(Y);Z.children.add(N.item.extId),ge=this.createItem(N,Z),this.items.set(N.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return Q.add?.(ge),N.expand===t.BusyExpanding&&this.busyControllerCount++,ge}update(N,Q){const Y=this.items.get(N.extId);if(Y)return N.expand!==void 0&&(Y.expand===t.BusyExpanding&&this.busyControllerCount--,N.expand===t.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(Y,N),Q.update?.(Y),Y}remove(N,Q){const Y=this.items.get(N);if(!Y)return;const ge=O.TestId.parentId(Y.item.extId)?.toString();ge?this.items.get(ge).children.delete(Y.item.extId):this.roots.delete(Y);const Z=[[N]];for(;Z.length;)for(const me of Z.pop()){const se=this.items.get(me);se&&(Z.push(se.children),this.items.delete(me),Q.remove?.(se,se!==Y),se.expand===t.BusyExpanding&&this.busyControllerCount--)}}retireTest(N){}updatePendingRoots(N){this.pendingRootCount+=N}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=V}),define(Te[242],Pe([1,0,99,202,56]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(w){w.ViewletId="workbench.view.extension.test",w.ExplorerViewId="workbench.view.testing",w.OutputPeekContributionId="editor.contrib.testingOutputPeek",w.DecorationsContributionId="editor.contrib.testingDecorations",w.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",w.CoverageViewId="workbench.view.testCoverage",w.ResultsPanelId="workbench.panel.testResults",w.ResultsViewId="workbench.panel.testResults.view",w.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(w){w.List="list",w.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var R;(function(w){w.ByLocation="location",w.ByStatus="status",w.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const v={[I.TestResultState.Errored]:(0,T.localize)(0,null),[I.TestResultState.Failed]:(0,T.localize)(1,null),[I.TestResultState.Passed]:(0,T.localize)(2,null),[I.TestResultState.Queued]:(0,T.localize)(3,null),[I.TestResultState.Running]:(0,T.localize)(4,null),[I.TestResultState.Skipped]:(0,T.localize)(5,null),[I.TestResultState.Unset]:(0,T.localize)(6,null)},a=(w,c)=>(0,T.localize)(7,null,(0,S.stripIcons)(w),v[c]);e.labelForTestInState=a,e.testConfigurationGroupNames={[I.TestRunProfileBitset.Debug]:(0,T.localize)(8,null),[I.TestRunProfileBitset.Run]:(0,T.localize)(9,null),[I.TestRunProfileBitset.Coverage]:(0,T.localize)(10,null)};var k;(function(w){w.CancelTestRefreshAction="testing.cancelTestRefresh",w.CancelTestRunAction="testing.cancelRun",w.ClearTestResultsAction="testing.clearTestResults",w.CollapseAllAction="testing.collapseAll",w.ConfigureTestProfilesAction="testing.configureProfile",w.ContinousRunUsingForTest="testing.continuousRunUsingForTest",w.CoverageAtCursor="testing.coverageAtCursor",w.CoverageByUri="testing.coverage.uri",w.CoverageClear="testing.coverage.close",w.CoverageCurrentFile="testing.coverageCurrentFile",w.CoverageFilterToTest="testing.coverageFilterToTest",w.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",w.CoverageLastRun="testing.coverageLastRun",w.CoverageSelectedAction="testing.coverageSelected",w.CoverageToggleToolbar="testing.coverageToggleToolbar",w.CoverageViewChangeSorting="testing.coverageViewChangeSorting",w.DebugAction="testing.debug",w.DebugAllAction="testing.debugAll",w.DebugAtCursor="testing.debugAtCursor",w.DebugByUri="testing.debug.uri",w.DebugCurrentFile="testing.debugCurrentFile",w.DebugFailedTests="testing.debugFailTests",w.DebugLastRun="testing.debugLastRun",w.DebugSelectedAction="testing.debugSelected",w.FilterAction="workbench.actions.treeView.testExplorer.filter",w.GetExplorerSelection="_testing.getExplorerSelection",w.GetSelectedProfiles="testing.getSelectedProfiles",w.GoToTest="testing.editFocusedTest",w.HideTestAction="testing.hideTest",w.OpenCoverage="testing.openCoverage",w.OpenOutputPeek="testing.openOutputPeek",w.RefreshTestsAction="testing.refreshTests",w.ReRunFailedTests="testing.reRunFailTests",w.ReRunLastRun="testing.reRunLastRun",w.RunAction="testing.run",w.RunAllAction="testing.runAll",w.RunAllWithCoverageAction="testing.coverageAll",w.RunAtCursor="testing.runAtCursor",w.RunByUri="testing.run.uri",w.RunCurrentFile="testing.runCurrentFile",w.RunSelectedAction="testing.runSelected",w.RunUsingProfileAction="testing.runUsing",w.RunWithCoverageAction="testing.coverage",w.SearchForTestExtension="testing.searchForTestExtension",w.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",w.ShowMostRecentOutputAction="testing.showMostRecentOutput",w.StartContinousRun="testing.startContinuousRun",w.StopContinousRun="testing.stopContinuousRun",w.TestingSortByDurationAction="testing.sortByDuration",w.TestingSortByLocationAction="testing.sortByLocation",w.TestingSortByStatusAction="testing.sortByStatus",w.TestingViewAsListAction="testing.viewAsList",w.TestingViewAsTreeAction="testing.viewAsTree",w.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",w.ToggleInlineTestOutput="testing.toggleInlineTestOutput",w.UnhideAllTestsAction="testing.unhideAllTests",w.UnhideTestAction="testing.unhideTest"})(k||(e.TestCommandId=k={}))}),define(Te[82],Pe([1,0,11,6,4,62,56,55]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const a=(d,i)=>d===i,w=Object.entries({range:(d,i)=>d===i?!0:!d||!i?!1:d.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(d,i)=>!(d.length!==i.length||d.some(r=>!i.includes(r)))}),c=(d,i)=>{let r;for(const[t,l]of w)l(d[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class _ extends I.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const r of this.tree.values())this.updateExpandability(r)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.diff)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.diff[this.diff.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.applyTestItemUpdate)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.applyTestItemUpdate)(r.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const l=this.resolveChildren(t);return l.isOpen()?this.expandChildren(t,r-1):l.wait().then(()=>this.expandChildren(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,r-1)):this.expandChildren(t,r-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,r){switch(r.op){case v.RemoveChild:this.removeItem(R.TestId.joinToString(i.fullId,r.id));break;case v.Upsert:this.upsertItem(r.item,i);break;case v.Bulk:for(const t of r.ops)this.onTestItemEvent(i,t);break;case v.SetTags:this.diffTagRefs(r.new,r.old,i.fullId.toString());break;case v.UpdateCanResolveChildren:this.updateExpandability(i);break;case v.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case v.DocumentSynced:this.documentSynced(i.actual.uri);break;default:(0,O.assertNever)(r)}}documentSynced(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,r){const t=R.TestId.fromExtHostTestItem(i,this.root.id,r?.actual),l=this.options.getApiFor(i);l.parent&&l.parent!==r?.actual&&this.options.getChildren(l.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:u.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,u,r);return}if(u.actual===i){this.connectItem(i,u,r);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(i,r);const g=this.options.getChildren(u.actual),m=u.actual,p=c(this.options.toITestItem(m),this.options.toITestItem(i));this.options.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,p&&(p.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,m.tags,t.toString()),delete p.tags),this.onTestItemEvent(u,{op:v.SetProp,update:p})),this.connectItemAndChildren(i,u,r);for(const[C,b]of g)this.options.getChildren(i).get(b.id)||this.removeItem(R.TestId.joinToString(t,b.id));const y=u.expandLevels;y!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),y))}),this.documentSynced(u.actual.uri)}diffTagRefs(i,r,t){const l=new Set(r.map(u=>u.id));for(const u of i)l.delete(u.id)||this.incrementTagRefs(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.namespaceTestTag)(this.options.controllerId,u.id))}}}),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const r=this.tags.get(i.id);r?r.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const r=this.tags.get(i);r&&!--r.refCount&&(this.tags.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,r){this.options.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}connectItem(i,r,t){this.setItemParent(i,t);const l=this.options.getApiFor(i);l.parent=t?.actual,l.listener=u=>this.onTestItemEvent(r,u),this.updateExpandability(r)}connectItemAndChildren(i,r,t){this.connectItem(i,r,t);for(const[l,u]of this.options.getChildren(i))this.upsertItem(u,r)}updateExpandability(i){let r;this._resolveHandler?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,r){if(r<0)return;const t=[];for(const[l,u]of this.options.getChildren(i.actual)){const g=this.expand(R.TestId.joinToString(i.fullId,u.id),r);(0,S.isThenable)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const u=new S.Barrier;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(i);const r=i.resolveBarrier=new S.Barrier,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,u)};let l;try{l=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,S.isThenable)(l)?l.catch(t).then(()=>{r.open(),this.updateExpandability(i)}):(r.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const l=t.pop();if(l){this.options.getApiFor(l.actual).listener=void 0;for(const u of l.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(l.fullId.toString());for(const[u,g]of this.options.getChildren(l.actual))t.push(this.tree.get(R.TestId.joinToString(l.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=_;class h extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=h;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=n;class s extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=s;const o=(d,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(l,u){for(const g of t.values())l.call(u,g,this)},[Symbol.iterator](){return t.entries()},replace(l){const u=new Map,g=new Set(t.keys()),m={op:v.Bulk,ops:[]};for(const p of l){if(!(p instanceof r))throw new n(p.id);const y=i(p).controllerId;if(y!==d.controllerId)throw new s(p.id,y,d.controllerId);if(u.has(p.id))throw new h(p.id);u.set(p.id,p),g.delete(p.id),m.ops.push({op:v.Upsert,item:p})}for(const p of g.keys())m.ops.push({op:v.RemoveChild,id:p});d.listener?.(m),t=u},add(l){if(!(l instanceof r))throw new n(l.id);t.set(l.id,l),d.listener?.({op:v.Upsert,item:l})},delete(l){t.delete(l)&&d.listener?.({op:v.RemoveChild,id:l})},get(l){return t.get(l)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=o}),define(Te[116],Pe([1,0,82]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,I=(A,R)=>{const v={controllerId:R};return T.set(A,v),v};e.createPrivateApiFor=I;const O=A=>{const R=T.get(A);if(!R)throw new S.InvalidTestItemError(A?.id||"<unknown>");return R};e.getPrivateApiFor=O}),define(Te[83],Pe([1,0,28,16,2]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=O,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function O(v,a){return v.scheme===T.Schemas.http||v.scheme===T.Schemas.https?v:(a&&a.authority&&a.isRemote&&v.scheme===T.Schemas.file&&(v=I.URI.from({scheme:T.Schemas.vscodeRemote,authority:a.authority,path:v.path})),I.URI.from({scheme:T.Schemas.https,authority:`${v.scheme}+${A(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}function A(v){return v.replace(/./g,a=>{const k=a.charCodeAt(0);return k>=S.CharCode.a&&k<=S.CharCode.z||k>=S.CharCode.A&&k<=S.CharCode.Z||k>=S.CharCode.Digit0&&k<=S.CharCode.Digit9?a:"-"+k.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(a,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Te[243],Pe([1,0,6,4,83]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(R,v,a){this._proxy=R,this._editors=v,this._remoteInfo=a,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const k=v.getVisibleTextEditors();for(const w of this._insets.values())k.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,v,a,k,w){let c;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===R){c=i;break}if(!c)throw new Error("not a visible editor");const _=this,h=this._handlePool++,n=new S.Emitter,s=new S.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,I.asWebviewUri)(i,_._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(i){this._options=i,_._proxy.$setOptions(h,i)}get options(){return this._options}set html(i){this._html=i,_._proxy.$setHtml(h,i)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(i){return _._proxy.$postMessage(h,i)}},d=new class{constructor(){this.editor=R,this.line=v,this.height=a,this.webview=o,this.onDidDispose=s.event}dispose(){_._insets.has(h)&&(_._insets.delete(h),_._proxy.$disposeEditorInset(h),s.fire(),s.dispose(),n.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,v+1,a,k||{},w.identifier,w.extensionLocation),this._insets.set(h,{editor:R,inset:d,onDidReceiveMessage:n}),d}$onDidDispose(R){const v=this._insets.get(R);v&&v.inset.dispose()}$onDidReceiveMessage(R,v){this._insets.get(R)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=O}),define(Te[117],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,S.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,S.createDecorator)("IAuthenticationExtensionsService")}),define(Te[244],Pe([1,0,3]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var T;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class I extends Error{constructor(A,R){super(R),this.variable=A}}e.VariableError=I}),define(Te[245],Pe([1,0,20,79,15,26,21,103,203,244,13]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,S=$e(S),T=$e(T),I=$e(I),O=$e(O);class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(_,h,n,s){this._contributedVariables=new Map,this._context=_,this._labelService=h,this._userHomePromise=n,s&&(this._envVariablesPromise=s.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(A.isWindows){const h=Object.create(null);return Object.keys(_).forEach(n=>{h[n.toLowerCase()]=_[n]}),h}return _}resolveWithEnvironment(_,h,n){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},h?h.uri:void 0,n)}async resolveAsync(_,h){const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,_?_.uri:void 0,h)}async resolveAnyBase(_,h,n,s){const o=O.deepClone(h);A.isWindows&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,_?_.uri:void 0,o,n,s)}async resolveAnyAsync(_,h,n){return this.resolveAnyBase(_,h,n)}async resolveAnyMap(_,h,n){const s=new Map;return{newConfig:await this.resolveAnyBase(_,h,n,s),resolvedVariables:s}}resolveWithInteractionReplace(_,h,n,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,h,n,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,h){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,h)}async recursiveResolve(_,h,n,s,o){if(I.isString(n))return this.resolveString(_,h,n,s,o);if(Array.isArray(n))return Promise.all(n.map(d=>this.recursiveResolve(_,h,d,s,o)));if(I.isObject(n)){const d=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.resolveString(_,h,r,s,o),await this.recursiveResolve(_,h,n[r],s,o)]));for(const[r,t]of i)d[r]=t;return d}return n}resolveString(_,h,n,s,o){return(0,k.replaceAsync)(n,w.VARIABLE_REGEXP,async(d,i)=>{if(i.includes(w.VARIABLE_LHS))return d;let r=await this.evaluateSingleVariable(_,d,i,h,s);return o?.set(i,r),r!==d&&I.isString(r)&&r.match(w.VARIABLE_REGEXP)&&(r=await this.resolveString(_,h,r,s,o)),r})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,h,n,s,o){let d;const i=n.split(":");i.length>1&&(n=i[0],d=i[1]);const r=u=>{const g=this._context.getFilePath();if(g)return(0,R.normalizeDriveLetter)(g);throw new a.VariableError(u,(0,v.localize)(0,null,h))},t=u=>{const g=r(u);if(this._context.getWorkspaceFolderPathForFile){const m=this._context.getWorkspaceFolderPathForFile();if(m)return(0,R.normalizeDriveLetter)(m)}throw new a.VariableError(u,(0,v.localize)(1,null,h,S.basename(g)))},l=u=>{if(d){const g=this._context.getFolderUri(d);if(g)return g;throw new a.VariableError(u,(0,v.localize)(2,null,h,d))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new a.VariableError(u,(0,v.localize)(3,null,h)):new a.VariableError(u,(0,v.localize)(4,null,h))};switch(n){case"env":if(d){if(_.env){const u=_.env[A.isWindows?d.toLowerCase():d];if(I.isString(u))return u}return""}throw new a.VariableError(a.VariableKind.Env,(0,v.localize)(5,null,h));case"config":if(d){const u=this._context.getConfigurationValue(s,d);if(I.isUndefinedOrNull(u))throw new a.VariableError(a.VariableKind.Config,(0,v.localize)(6,null,h,d));if(I.isObject(u))throw new a.VariableError(a.VariableKind.Config,(0,v.localize)(7,null,h,d));return u}throw new a.VariableError(a.VariableKind.Config,(0,v.localize)(8,null,h));case"command":return this.resolveFromMap(a.VariableKind.Command,h,d,o,"command");case"input":return this.resolveFromMap(a.VariableKind.Input,h,d,o,"input");case"extensionInstallFolder":if(d){const u=await this._context.getExtension(d);if(!u)throw new a.VariableError(a.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,h,d));return this.fsPath(u.extensionLocation)}throw new a.VariableError(a.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,h));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(l(a.VariableKind.WorkspaceFolder)));case"cwd":return s||d?(0,R.normalizeDriveLetter)(this.fsPath(l(a.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(S.basename(this.fsPath(l(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(_.userHome)return _.userHome;throw new a.VariableError(a.VariableKind.UserHome,(0,v.localize)(11,null,h))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new a.VariableError(a.VariableKind.LineNumber,(0,v.localize)(12,null,h))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new a.VariableError(a.VariableKind.SelectedText,(0,v.localize)(13,null,h))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.basename(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||d?S.relative(this.fsPath(l(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const u=S.dirname(r(a.VariableKind.RelativeFileDirname));if(s||d){const g=S.relative(this.fsPath(l(a.VariableKind.RelativeFileDirname)),u);return g.length===0?".":g}return u}case"fileDirname":return S.dirname(r(a.VariableKind.FileDirname));case"fileExtname":return S.extname(r(a.VariableKind.FileExtname));case"fileBasename":return S.basename(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=S.basename(r(a.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-S.extname(u).length)}case"fileDirnameBasename":return S.basename(S.dirname(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||h}case"execInstallFolder":{const u=this._context.getAppRoot();return u||h}case"pathSeparator":case"/":return S.sep;default:try{const u=d?`${n}:${d}`:n;return this.resolveFromMap(a.VariableKind.Unknown,h,u,o,void 0)}catch{return h}}}}resolveFromMap(_,h,n,s,o){if(n&&s){const d=o===void 0?s[n]:s[o+":"+n];if(typeof d=="string")return d;throw new a.VariableError(_,(0,v.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=w}),define(Te[118],Pe([1,0,3,115]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=a,e.isEditorGroup=c,e.preferredSideBySideGroupDirection=_,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var I;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var O;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var R;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EXPAND=1]="EXPAND",h[h.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function a(h){const n=h;return(0,T.isEditorInput)(n?.editor)&&(0,T.isEditorInput)(n?.replacement)}var k;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k||(e.GroupsOrder=k={}));var w;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function c(h){const n=h;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function _(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Te[246],Pe([1,0,3,118]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=I,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function I(O){const A=O;return typeof O=="number"||(0,T.isEditorGroup)(A)}}),define(Te[247],Pe([1,0,3,107]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,S.refineServiceDecorator)(T.IEnvironmentService)}),define(Te[119],Pe([1,0,19,6,20,4,11]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,I=$e(I);class R{constructor(d,i){this.versionId=d,this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class v{static isHostExtension(d,i,r){if(i.getExtensionDescription(d))return!1;const t=r.getExtensionDescription(d);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(d,i){this._activationEventsReader=d,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(n),this._extensionsMap=new S.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const d of this._extensionDescriptions){if(this._extensionsMap.has(d.identifier)){console.error("Extension `"+d.identifier.value+"` is already registered");continue}this._extensionsMap.set(d.identifier,d),this._extensionsArr.push(d);const i=this._activationEventsReader.readActivationEvents(d);for(const r of i)this._activationMap.has(r)||this._activationMap.set(r,[]),this._activationMap.get(r).push(d)}}set(d){return this._extensionDescriptions=d,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(d,i){this._extensionDescriptions=s(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(d);const r=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=s(this._extensionDescriptions,r.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,r)}static _findLoopingExtensions(d){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this._arcs.has(g)?this._arcs.get(g).push(m):this._arcs.set(g,[m])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,m){const p=i.getArcs(g);for(let y=0;y<p.length;y++)if(!m.has(p[y]))return!1;return!0}getNodes(){return this._nodesArr}},r=new S.ExtensionIdentifierMap;for(const g of d)if(r.set(g.identifier,g),g.extensionDependencies)for(const m of g.extensionDependencies)i.addArc(S.ExtensionIdentifier.toKey(g.identifier),S.ExtensionIdentifier.toKey(m));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const l=i.getNodes().filter(g=>!t.has(g));let u;do{u=!1;for(let g=0;g<l.length;g++){const m=l[g];i.hasOnlyGoodArcs(m,t)&&(l.splice(g,1),g--,t.add(m),u=!0)}}while(u);return l.map(g=>r.get(g))}containsActivationEvent(d){return this._activationMap.has(d)}containsExtension(d){return this._extensionsMap.has(d)}getExtensionDescriptionsForActivationEvent(d){const i=this._activationMap.get(d);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new a(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(d){const i=this._extensionsMap.get(d);return i||void 0}getExtensionDescriptionByUUID(d){for(const i of this._extensionsArr)if(i.uuid===d)return i}getExtensionDescriptionByIdOrUUID(d,i){return this.getExtensionDescription(d)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=v;class a{constructor(d,i){this.versionId=d,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=a;class k{constructor(d){this._lock=new _,this._actual=new v(d,[])}async acquireLock(d){const i=await this._lock.acquire(d);return new w(this,i)}deltaExtensions(d,i,r){if(!d.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,r)}containsActivationEvent(d){return this._actual.containsActivationEvent(d)}containsExtension(d){return this._actual.containsExtension(d)}getExtensionDescriptionsForActivationEvent(d){return this._actual.getExtensionDescriptionsForActivationEvent(d)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(d){return this._actual.getExtensionDescription(d)}getExtensionDescriptionByUUID(d){return this._actual.getExtensionDescriptionByUUID(d)}getExtensionDescriptionByIdOrUUID(d,i){return this._actual.getExtensionDescriptionByIdOrUUID(d,i)}}e.LockableExtensionDescriptionRegistry=k;class w extends O.Disposable{constructor(d,i){super(),this._registry=d,this._isDisposed=!1,this._register(i)}isAcquiredFor(d){return!this._isDisposed&&this._registry===d}}e.ExtensionDescriptionRegistryLock=w;class c{constructor(d){this.name=d;const i=(0,A.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(d){this._resolve(d)}}class _{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(d){const i=new c(d);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const d=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${d.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this._isLocked=!1,this._advance())};d.resolve((0,O.toDisposable)(t))}}var h;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(h||(h={}));function n(o,d){const i=o.isBuiltin?h.Builtin:o.isUnderDevelopment?h.Dev:h.User,r=d.isBuiltin?h.Builtin:d.isUnderDevelopment?h.Dev:h.User;if(i!==r)return i-r;const t=I.posix.basename(o.extensionLocation.path),l=I.posix.basename(d.extensionLocation.path);return t<l?-1:t>l?1:0}function s(o,d){const i=new S.ExtensionIdentifierSet(d);return o.filter(r=>!i.has(r.identifier))}}),define(Te[84],Pe([1,0,23]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=A,e.isMessageOfType=R;var T;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(a){const k=S.VSBuffer.alloc(1);switch(a){case O.Initialized:k.writeUInt8(1,0);break;case O.Ready:k.writeUInt8(2,0);break;case O.Terminate:k.writeUInt8(3,0);break}return k}function R(a,k){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return k===O.Initialized;case 2:return k===O.Ready;case 3:return k===O.Terminate;default:return!1}}var v;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Te[67],Pe([1,0,3,6,113,12,27,84,63,64,26,2,4,188]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=s;let h=class extends c.Disposable{constructor(d,i){super(),this.initData=d,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new T.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new T.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=I.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=w.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:a.extensionTelemetryLogChannelId,name:(0,_.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(r=>{(0,O.isLogLevel)(r)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=I.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(d,i,r){const t=this.getTelemetryDetails(),l=new n(i,r,d,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(d),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this._telemetryLoggers.get(d.identifier.value)??[];return this._telemetryLoggers.set(d.identifier.value,[...u,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(d,i,r){this._level=d,this._telemetryIsSupported=i,this._productConfig=r??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(d){const i=Object.create(null);switch(i["common.extname"]=`${d.publisher}.${d.name}`,i["common.extversion"]=d.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=s(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.getRemoteName)((0,a.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(d){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=d;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((r,t)=>{const l=r.filter(u=>!u.isDisposed);l.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,l)}),this._telemetryLoggers.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(d,i){const t=this._telemetryLoggers.get(d.value)?.filter(u=>!u.isDisposed);if(!t)return this._telemetryLoggers.delete(d.value),!1;let l=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),l=!0);return l}};e.ExtHostTelemetry=h,e.ExtHostTelemetry=h=je([Ve(0,A.IExtHostInitDataService),Ve(1,O.ILoggerService)],h);class n{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,i,r,t,l,u,g){this._extension=r,this._logger=t,this._inLoggingOnlyMode=l,this._commonProperties=u,this._onDidChangeEnableStates=new T.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=d,this._telemetryEnablements={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(d,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:d,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(d){let i="properties"in d?d.properties??{}:d;return i=(0,a.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,k.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,k.mixin)(i,this._commonProperties)),"properties"in d?d.properties=i:d=i,d}logEvent(d,i){this._sender&&(this._extension.publisher==="vscode"?d=this._extension.name+"/"+d:d=this._extension.identifier.value+"/"+d,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(d,i),this._logger.trace(d,i))}logUsage(d,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(d,i)}logError(d,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof d=="string")this.logEvent(d,i);else{const r={name:d.name,message:d.message,stack:d.stack,cause:d.cause},t=(0,a.cleanData)(r,[]),l=new Error(t.message,{cause:t.cause});l.stack=t.stack,l.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(l,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const d=this,i={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return d._telemetryEnablements.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d._onDidChangeEnableStates.event.bind(d)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let d=this._sender;this._sender=void 0,Promise.resolve(d.flush()).then(d=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=n;function s(o){const d=Date.now()-new Date(o).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(Te[25],Pe([1,0,6,2,219,112,19,3]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=c,e.checkProposedApiEnabled=_,e.toExtension=o,e.toExtensionDescription=d,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class v{constructor(t){this.dependency=t}}e.MissingExtensionDependency=v;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class k{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,l,u){this._versionId=t,this._allExtensions=l.slice(0),this._myExtensions=u.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,l,u){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const g=[],m=[],p=[],y=[],C=w(this._allExtensions),b=w(l),D=(L,M)=>L.extensionLocation.toString()===M.extensionLocation.toString()||L.isBuiltin===M.isBuiltin||L.isUserBuiltin===M.isUserBuiltin||L.isUnderDevelopment===M.isUnderDevelopment;for(const L of this._allExtensions){const M=b.get(L.identifier);if(!M){g.push(L.identifier),C.delete(L.identifier);continue}if(!D(L,M)){g.push(L.identifier),C.delete(L.identifier);continue}}for(const L of l){const M=C.get(L.identifier);if(!M){m.push(L);continue}if(!D(M,L)){g.push(M.identifier),C.delete(M.identifier);continue}}const P=new A.ExtensionIdentifierSet(this._myExtensions),f=new A.ExtensionIdentifierSet(u);for(const L of this._myExtensions)f.has(L)||p.push(L);for(const L of u)P.has(L)||y.push(L);const E=O.ImplicitActivationEvents.createActivationEventsMap(m),F={versionId:t,toRemove:g,toAdd:m,addActivationEvents:E,myToRemove:p,myToAdd:y};return this.delta(F),F}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:l,toAdd:u,myToRemove:g,myToAdd:m}=t,p=new A.ExtensionIdentifierSet(l),y=new A.ExtensionIdentifierSet(g);for(let C=0;C<this._allExtensions.length;C++)p.has(this._allExtensions[C].identifier)&&(this._allExtensions.splice(C,1),C--);for(let C=0;C<this._myExtensions.length;C++)y.has(this._myExtensions[C])&&(this._myExtensions.splice(C,1),C--);for(const C of u)this._allExtensions.push(C);for(const C of m)this._myExtensions.push(C);return this._myActivationEvents=null,t}containsExtension(t){for(const l of this._myExtensions)if(A.ExtensionIdentifier.equals(l,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const l of this._allExtensions){if(!this.containsExtension(l.identifier))continue;const u=O.ImplicitActivationEvents.readActivationEvents(l);for(const g of u)t.add(g)}return t}}e.ExtensionHostExtensions=k;function w(r){const t=new A.ExtensionIdentifierMap;for(const l of r)t.set(l.identifier,l);return t}function c(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function _(r,t){if(!c(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class h{constructor(t,l,u,g){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=u,this.activationReason=g}}e.ActivationTimes=h;class n{constructor(t,l){this.description=t,this.value=l}}e.ExtensionPointContribution=n;var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function d(r,t){const l=(0,I.getExtensionId)(r.manifest.publisher,r.manifest.name);return{id:l,identifier:new A.ExtensionIdentifier(l),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,l){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(Te[248],Pe([1,0,14,119,19,25,12,11]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,S=$e(S);class v{static{this.NONE=new v(!1,-1,-1,-1)}constructor(o,d,i,r){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=r}}e.ExtensionActivationTimes=v;class a{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,d){return o===-1||d===-1?-1:d-o}build(){return new v(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=a;class k{constructor(o,d,i,r,t,l){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=l}}e.ActivatedExtension=k;class w extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class c extends k{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=c;class _ extends k{constructor(o){super(!0,o,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let h=class{constructor(o,d,i,r){this._logService=r,this._registry=o,this._globalRegistry=d,this._host=i,this._operations=new I.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,d]of this._operations)d.dispose()}async waitForActivatingExtensions(){const o=[];for(const[d,i]of this._operations)o.push(i.wait());await Promise.all(o)}isActivated(o){const d=this._operations.get(o);return!!(d&&d.value)}getActivatedExtension(o){const d=this._operations.get(o);if(!d||!d.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return d.value}async activateByEvent(o,d){if(this._alreadyActivatedEvents[o])return;const i=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(i.map(r=>({id:r.identifier,reason:{startup:d,extensionId:r.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,d){const i=this._registry.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this._activateExtensions([{id:i.identifier,reason:d}])}async _activateExtensions(o){const d=o.filter(i=>!this.isActivated(i.id)).map(i=>this._handleActivationRequest(i));await Promise.all(d.map(i=>i.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const d=this._registry.getExtensionDescription(o.id);if(!d){const t=new Error(`Cannot activate unknown extension '${o.id.value}'`),l=this._createAndSaveOperation(o,null,[],new _(t));return this._host.onExtensionActivationError(o.id,t,new O.MissingExtensionDependency(o.id.value)),l}const i=[],r=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const t of r){if(this._isResolvedExtension(t))continue;const l=this._operations.get(t);if(l){i.push(l);continue}if(this._isHostExtension(t)){i.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(t).identifier,reason:o.reason}));continue}const u=this._registry.getExtensionDescription(t);if(u){if(!u.main&&!u.browser)continue;i.push(this._handleActivationRequest({id:u.identifier,reason:o.reason}));continue}const g=d.displayName||d.identifier.value,m=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${t}'`),p=this._createAndSaveOperation(o,d.displayName,[],new _(m));return this._host.onExtensionActivationError(d.identifier,m,new O.MissingExtensionDependency(t)),p}return this._createAndSaveOperation(o,d.displayName,i,null)}_createAndSaveOperation(o,d,i,r){const t=new n(o.id,d,o.reason,i,r,this._host,this._logService);return this._operations.set(o.id,t),t}_isHostExtension(o){return T.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const d=this._globalRegistry.getExtensionDescription(o);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=h,e.ExtensionsActivator=h=je([Ve(3,A.ILogService)],h);let n=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,d,i,r,t,l,u){this._id=o,this._displayName=d,this._reason=i,this._deps=r,this._value=t,this._host=l,this._logService=u,this._barrier=new R.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const d=this._deps[o];if(d.value&&!d.value.activationFailed){this._deps.splice(o,1),o--;continue}if(d.value&&d.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);i.detail=d.value.activationFailedError,this._value=new _(i),this._host.onExtensionActivationError(this._id,i,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const d=new Error;if(o&&o.name&&(d.name=o.name),o&&o.message?d.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(d.stack=o.stack),this._value=new _(d),this._isDisposed&&S.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};n=je([Ve(6,A.ILogService)],n)});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[120],Pe([1,0,205,14,36,111,78,31,19,109,112,105]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,S=$e(S),I=Zt(I);const c=R.Registry.as(A.Extensions.JSONContribution);class _{constructor(t,l,u){this._messageHandler=t,this._extension=l,this._extensionPointId=u}_msg(t,l){this._messageHandler({type:t,message:l,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(I.default.Error,t)}warn(t){this._msg(I.default.Warning,t)}info(t){this._msg(I.default.Info,t)}}e.ExtensionMessageCollector=_;class h{static _toSet(t){const l=new v.ExtensionIdentifierSet;for(let u=0,g=t.length;u<g;u++)l.add(t[u].description.identifier);return l}static compute(t,l){if(!t||!t.length)return new h(l,[]);if(!l||!l.length)return new h([],t);const u=this._toSet(t),g=this._toSet(l),m=l.filter(y=>!u.has(y.description.identifier)),p=t.filter(y=>!g.has(y.description.identifier));return new h(m,p)}constructor(t,l){this.added=t,this.removed=l}}e.ExtensionPointUserDelta=h;class n{constructor(t,l){this.name=t,this.defaultExtensionKind=l,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=h.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,T.onUnexpectedError)(t)}}}e.ExtensionPoint=n;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(w.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:S.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:S.localize(44,null)},{label:"*",description:S.localize(45,null),body:"*"}]}},badges:{type:"array",description:S.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(47,null)},href:{type:"string",description:S.localize(48,null)},description:{type:"string",description:S.localize(49,null)}}}},markdown:{type:"string",description:S.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(54,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(55,null)},{body:["workspace"],description:S.localize(56,null)},{body:["ui","workspace"],description:S.localize(57,null)},{body:["workspace","ui"],description:S.localize(58,null)},{body:[],description:S.localize(59,null)}]},capabilities:{description:S.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(63,null),S.localize(64,null),S.localize(65,null)]},description:{type:"string",markdownDescription:S.localize(66,null)}}},untrustedWorkspaces:{description:S.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(69,null),S.localize(70,null),S.localize(71,null)]},restrictedConfigurations:{description:S.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(73,null)}}}}},sponsor:{description:S.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(76,null),type:"string"},"vscode:uninstall":{description:S.localize(77,null),type:"string"}}},icon:{type:"string",description:S.localize(78,null)},l10n:{type:"string",description:S.localize(79,null)},pricing:{type:"string",markdownDescription:S.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const l=new n(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,l),t.activationEventsGenerator&&k.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,c.registerSchema(o,e.schema),l}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(i.ExtensionsRegistry,new d),e.ExtensionsRegistry=R.Registry.as(i.ExtensionsRegistry),c.registerSchema(o,e.schema),c.registerSchema(a.productSchemaId,{properties:{extensionEnabledApiProposals:{description:S.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Te[249],Pe([1,0,6,40,4,13,197,19,3,12,25,120]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var c;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(c||(e.ChatMessageRole=c={})),e.ILanguageModelsService=(0,v.createDecorator)("ILanguageModelsService");const _={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.languageModelExtensionPoint=w.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[_,{type:"array",items:_}]},activationEventsGenerator:(n,s)=>{for(const o of n)s.push(`onLanguageModelChat:${o.vendor}`)}});let h=class{constructor(s,o){this._extensionService=s,this._logService=o,this._store=new I.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new S.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(d=>{this._vendors.clear();for(const r of d){if(!(0,k.isProposedApiEnabled)(r.description,"chatProvider")){r.collector.error((0,A.localize)(2,null));continue}for(const t of T.Iterable.wrap(r.value)){if(this._vendors.has(t.vendor)){r.collector.error((0,A.localize)(3,null,t.vendor));continue}if((0,O.isFalsyOrWhitespace)(t.vendor)){r.collector.error((0,A.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(5,null));continue}this._vendors.add(t.vendor)}}const i=[];for(const[r,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(r),i.push(r));i.length>0&&this._onDidChangeProviders.fire({removed:i})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(s){return this._providers.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const d=Array.from(this._vendors).map(i=>this._extensionService.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(d)}const o=[];for(const[d,i]of this._providers)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>R.ExtensionIdentifier.equals(r,s.extension)))&&o.push(d);return this._logService.trace("[LM] selected language models",s,o),o}registerLanguageModelChat(s,o){if(this._logService.trace("[LM] registering language model chat",s,o.metadata),!this._vendors.has(o.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${o.metadata.vendor}.`);if(this._providers.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this._providers.set(s,o),this._onDidChangeProviders.fire({added:[{identifier:s,metadata:o.metadata}]}),(0,I.toDisposable)(()=>{this._providers.delete(s)&&(this._onDidChangeProviders.fire({removed:[s]}),this._logService.trace("[LM] UNregistered language model chat",s,o.metadata))})}async sendChatRequest(s,o,d,i,r){const t=this._providers.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(d,o,i,r)}computeTokenLength(s,o,d){const i=this._providers.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(o,d)}};e.LanguageModelsService=h,e.LanguageModelsService=h=je([Ve(0,k.IExtensionService),Ve(1,a.ILogService)],h)}),define(Te[250],Pe([1,0,200,15,26,120,32,6]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,S=$e(S),T=$e(T),I=$e(I);const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var a;(function(c){function _(h,n,s){if(!h)return;const o=T.isString(h.type)?h.type:void 0;if(!o||o.length===0){s.error(S.localize(3,null));return}const d=[];if(Array.isArray(h.required))for(const i of h.required)T.isString(i)&&d.push(i);return{extensionId:n.value,taskType:o,required:d,properties:h.properties?I.deepClone(h.properties):{},when:h.when?A.ContextKeyExpr.deserialize(h.when):void 0}}c.from=_})(a||(a={}));const k=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,_)=>{for(const h of c)h.type&&_.push(`onTaskType:${h.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:v}});class w{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,h)=>{k.setHandler((n,s)=>{this._schema=void 0;try{for(const o of s.removed){const d=o.value;for(const i of d)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const o of s.added){const d=o.value;for(const i of d){const r=a.from(i,o.description.identifier,o.collector);r&&(this.taskTypes[r.taskType]=r)}}(s.removed.length>0||s.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const h of this.all()){const n={type:"object",additionalProperties:!1};h.required.length>0&&(n.required=h.required.slice(0)),h.properties!==void 0?n.properties=I.deepClone(h.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[h.taskType]},_.push(n)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistry=new w}),define(Te[251],Pe([1,0,201,15,24,26,32,250,43]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,S=$e(S),T=$e(T),I=$e(I),O=$e(O),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,S.localize(0,null)),e.TASKS_CATEGORY=S.localize2(2,"Tasks");var a;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function Q(Y){if(!Y)return N.Strong;switch(Y.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=Q}(a||(e.ShellQuoting=a={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var w;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(w||(e.RevealKind=w={})),function(N){function Q(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=Q}(w||(e.RevealKind=w={}));var c;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(c||(e.RevealProblemKind=c={})),function(N){function Q(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=Q}(c||(e.RevealProblemKind=c={}));var _;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(_||(e.PanelKind=_={})),function(N){function Q(Y){switch(Y.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=Q}(_||(e.PanelKind=_={}));var h;(function(N){N.defaults={echo:!0,reveal:w.Always,revealProblems:c.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(h||(e.PresentationOptions=h={}));var n;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(N){function Q(ge){switch(ge.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=Q;function Y(ge){switch(ge){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=Y}(n||(e.RuntimeType=n={}));var s;(function(N){function Q(Y){return T.isString(Y)?Y:Y.value}N.value=Q})(s||(e.CommandString=s={}));var o;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function Q(ge){return ge===N.Clean._id||ge===N.Build._id||ge===N.Rebuild._id||ge===N.Test._id}N.is=Q;function Y(ge){if(ge!==void 0)return T.isString(ge)?Q(ge)?{_id:ge,isDefault:!1}:void 0:ge}N.from=Y})(o||(e.TaskGroup=o={}));var d;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(d||(e.TaskScope=d={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function Q(Y){switch(Y){case N.User:return v.ConfigurationTarget.USER;case N.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=Q})(i||(e.TaskSourceKind=i={}));var r;(function(N){N.parallel="parallel",N.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var l;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class u{constructor(Q,Y,ge,Z,me,se){this._label="",this._id=Q,Y&&(this._label=Y),ge&&(this.type=ge),this.runOptions=Z,this.configurationProperties=me,this._source=se}getDefinition(Q){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Q={folder:this.getFolderId(),id:this._id};return JSON.stringify(Q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Q,Y=!1){if(Q===void 0)return!1;if(T.isString(Q))return Q===this._label||Q===this.configurationProperties.identifier||Y&&Q===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===Q._key}getQualifiedLabel(){const Q=this.getWorkspaceFolder();return Q?`${this._label} (${Q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),Q&&(this._taskLoadMessages=this._taskLoadMessages.concat(Q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=u;class g extends u{constructor(Q,Y,ge,Z,me,se,le,Ee){super(Q,ge,void 0,le,Ee,Y),this.command={},this._source=Y,this.hasDefinedMatchers=se,me&&(this.command=me)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Q=!1){if(Q&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case n.Shell:Y="shell";break;case n.Process:Y="process";break;case n.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(Q){return Q instanceof g}getMapKey(){const Q=this._source.config.workspaceFolder;return Q?`${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Q=this.getFolderId();if(!Q)return;let Y=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Y+=this._source.kind);const ge={type:e.CUSTOMIZED_TASK_TYPE,folder:Q,id:Y};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(Q){return new g(Q._id,Q._source,Q._label,Q.type,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.CustomTask=g;class m extends u{constructor(Q,Y,ge,Z,me,se,le){super(Q,ge,Z,se,le,Y),this._source=Y,this.configures=me}static is(Q){return Q instanceof m}fromObject(Q){return Q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Q=this.getFolderId();if(!Q)return;let Y=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Y+=this._source.kind);const ge={type:e.CUSTOMIZED_TASK_TYPE,folder:Q,id:Y};return JSON.stringify(ge)}}e.ConfiguringTask=m;class p extends u{constructor(Q,Y,ge,Z,me,se,le,Ee,oe){super(Q,ge,Z,Ee,oe,Y),this.defines=me,this.hasDefinedMatchers=le,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Q){return Q instanceof p}getMapKey(){const Q=this._source.workspaceFolder;return Q?`${this._source.scope.toString()}|${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===d.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Q={type:"contributed",scope:this._source.scope,id:this._id};return Q.folder=this.getFolderId(),JSON.stringify(Q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(Q){return new p(Q._id,Q._source,Q._label,Q.type,Q.defines,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.ContributedTask=p;class y extends u{constructor(Q,Y,ge,Z,me,se){super(Q,ge,Z,me,se,Y),this._source=Y}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Q){return Q instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(Q){return new y(Q._id,Q._source,Q._label,Q.type,Q.runOptions,Q.configurationProperties)}}e.InMemoryTask=y;var C;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(C||(e.ExecutionEngine=C={})),function(N){N._default=N.Terminal}(C||(e.ExecutionEngine=C={}));var b;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class D{constructor(Q){this._order=new Map;for(let Y=0;Y<Q.length;Y++)this._order.set(Q[Y].uri.toString(),Y)}compare(Q,Y){const ge=Q.getWorkspaceFolder(),Z=Y.getWorkspaceFolder();if(ge&&Z){let me=this._order.get(ge.uri.toString());me=me===void 0?0:me+1;let se=this._order.get(Z.uri.toString());return se=se===void 0?0:se+1,me===se?Q._label.localeCompare(Y._label):me-se}else return!ge&&Z?-1:ge&&!Z?1:0}}e.TaskSorter=D;var P;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(P||(e.TaskEventKind=P={}));var f;(function(N){N.SingleRun="singleRun",N.Background="background"})(f||(e.TaskRunType=f={}));var E;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var F;(function(N){function Q(Ee){return{taskId:Ee._id,taskName:Ee.configurationProperties.name,runType:Ee.configurationProperties.isBackground?f.Background:f.SingleRun,group:Ee.configurationProperties.group,__task:Ee}}function Y(Ee,oe,Ie){return{...Q(Ee),kind:P.Start,terminalId:oe,resolvedVariables:Ie}}N.start=Y;function ge(Ee,oe,Ie){return{...Q(Ee),kind:P.ProcessStarted,terminalId:oe,processId:Ie}}N.processStarted=ge;function Z(Ee,oe,Ie){return{...Q(Ee),kind:P.ProcessEnded,terminalId:oe,exitCode:Ie}}N.processEnded=Z;function me(Ee,oe,Ie){return{...Q(Ee),kind:P.Terminated,exitReason:Ie,terminalId:oe}}N.terminated=me;function se(Ee,oe,Ie){return{...Q(oe),kind:Ee,terminalId:Ie}}N.general=se;function le(){return{kind:P.Changed}}N.changed=le})(F||(e.TaskEvent=F={}));var L;(function(N){function Q(ge){const Z=Object.keys(ge).sort();let me="";for(const se of Z){let le=ge[se];le instanceof Object?le=Q(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),me+=se+","+le+","}return me}function Y(ge){const me={_key:Q(ge),type:ge.taskType};return Object.assign(me,ge),me}N.create=Y})(L||(e.KeyedTaskIdentifier=L={}));var M;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var W;(function(N){function Q(Y,ge){const Z=R.TaskDefinitionRegistry.get(Y.type);if(Z===void 0){const Ee=O.deepClone(Y);return delete Ee._key,L.create(Ee)}const me=Object.create(null);me.type=Z.taskType;const se=new Set;Z.required.forEach(Ee=>se.add(Ee));const le=Z.properties;for(const Ee of Object.keys(le)){const oe=Y[Ee];if(oe!=null)me[Ee]=oe;else if(se.has(Ee)){const Ie=le[Ee];if(Ie.default!==void 0)me[Ee]=O.deepClone(Ie.default);else switch(Ie.type){case"boolean":me[Ee]=!1;break;case"number":case"integer":me[Ee]=0;break;case"string":me[Ee]="";break;default:ge.error(S.localize(1,null,JSON.stringify(Y,void 0,0),Ee));return}}}return L.create(me)}N.createTaskIdentifier=Q})(W||(e.TaskDefinition=W={}))}),define(Te[252],Pe([1,0,14]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,S.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T;class I extends T{constructor(){super(),this._hasErr=!0,this._err=new S.CancellationError}}e.CanceledLazyPromise=I}),define(Te[39],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=I,e.getStringIdentifierForProxy=O;class S{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++S.count}}e.ProxyIdentifier=S;const T=[];function I(R){const v=new S(R);return T[v.nid]=v,v}function O(R){return T[R].sid}class A{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=A}),define(Te[5],Pe([1,0,39]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var R;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var k;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(k||(e.CandidatePortSource=k={}));class w{static{this._n=0}static mixin(s){return s._id=w._n++,s}}e.IdObject=w;var c;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var _;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(_||(e.ISuggestResultDtoField=_={}));var h;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(h||(e.ExtHostTestingResource=h={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,S.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,S.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,S.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,S.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,S.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,S.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,S.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,S.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,S.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,S.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,S.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,S.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization")}}),define(Te[85],Pe([1,0,3,12,5,17]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,I=$e(I),e.IExtHostApiDeprecationService=(0,S.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(v,a){this._extHostLogService=a,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(I.MainContext.MainThreadTelemetry)}report(v,a,k){const w=this.getUsageKey(v,a);this._reportedUsages.has(w)||(this._reportedUsages.add(w),a.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${k}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:v}))}getUsageKey(v,a){return`${v}-${a.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=je([Ve(0,O.IExtHostRpcService),Ve(1,T.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(R,v,a){}})}),define(Te[253],Pe([1,0,5]),function(ae,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(O){const A=O.getProxy(S.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(R){return A.$writeText(R)}})}}e.ExtHostClipboard=T}),define(Te[254],Pe([1,0,26,5,27,17]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(k,w){this._mainThreadConsole=k.getProxy(T.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(k,w){const c=this,_=console[k];Object.defineProperty(console,k,{set:()=>{},get:()=>function(){c._handleConsoleCall(k,w,_,arguments)}})}_handleConsoleCall(k,w,c,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:v(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(k,c,_)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=je([Ve(0,O.IExtHostRpcService),Ve(1,I.IExtHostInitDataService)],A);const R=1e5;function v(a,k){const w=[];if(a.length)for(let c=0;c<a.length;c++){let _=a[c];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const h=_;h.stack?_=h.stack:_=h.toString()}w.push(_)}if(k){const c=new Error().stack;c&&w.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,S.safeStringify)(w);return c.length>R?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Te[255],Pe([1,0,2,5,25]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(R){this._proxy=R.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(R,v){return v?.allowUIResources&&(0,I.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(v).then(a=>a?a.map(k=>S.URI.revive(k)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(v=>v?S.URI.revive(v):void 0)}}e.ExtHostDialogs=O}),define(Te[256],Pe([1,0,22,6,4,5]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class A{constructor(v){this._provider=new Map,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=v.getProxy(O.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(v,a,k){if(this._allKnownModels.has(a))throw new Error("An embeddings provider for this model is already registered");const w=this._handlePool++;return this._proxy.$registerEmbeddingProvider(w,a),this._provider.set(w,{id:a,provider:k}),(0,I.toDisposable)(()=>{this._proxy.$unregisterEmbeddingProvider(w),this._provider.delete(w)})}async computeEmbeddings(v,a,k){k??=S.CancellationToken.None;let w=!1;typeof a=="string"&&(a=[a],w=!0);const c=await this._proxy.$computeEmbeddings(v,a,k);if(c.length!==a.length)throw new Error;if(w){if(c.length!==1)throw new Error;return c[0]}return c}async $provideEmbeddings(v,a,k){const w=this._provider.get(v);if(!w)return[];const c=await w.provider.provideEmbeddings(a,k);return c||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(v){this._allKnownModels=new Set(v),this._onDidChange.fire()}}e.ExtHostEmbeddings=A}),define(Te[257],Pe([1,0,4,5]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(A){this._handlePool=0,this._proxy=A.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,A),(0,S.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=I}),define(Te[86],Pe([1,0,21,13,2,3,12,5,27,17]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let k=class{constructor(c,_,h){this.logService=h,this.bundleCache=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=c.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===S.LANGUAGE_DEFAULT}getMessage(c,_){const{message:h,args:n,comment:s}=_;if(this.isDefaultLanguage)return(0,T.format2)(h,n??{});let o=h;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const d=this.bundleCache.get(c)?.contents[o];return d||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.format2)(d??h,n??{})}getBundle(c){return this.bundleCache.get(c)?.contents}getBundleUri(c){return this.bundleCache.get(c)?.uri}async initializeLocalizedMessages(c){if(this.isDefaultLanguage||!c.l10n&&!c.isBuiltin||this.bundleCache.has(c.identifier.value))return;let _;const h=await this.getBundleLocation(c);if(!h){this.logService.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const n=await this._proxy.$fetchBundleContents(h),s=JSON.parse(n);_=c.isBuiltin?s.contents?.bundle:s}catch(n){this.logService.error(`Failed to load translations for ${c.identifier.value} from ${h}: ${n.message}`);return}_&&this.bundleCache.set(c.identifier.value,{contents:_,uri:h})}async getBundleLocation(c){if(c.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(c.identifier.value,this.currentLanguage);return I.URI.revive(_)}return c.l10n?I.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=k,e.ExtHostLocalizationService=k=je([Ve(0,v.IExtHostInitDataService),Ve(1,a.IExtHostRpcService),Ve(2,A.ILogService)],k),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(Te[258],Pe([1,0,12,5,27,17,2,49]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends S.AbstractLoggerService{constructor(w,c){super(c.logLevel,c.logsLocation,c.loggers.map(_=>(0,R.revive)(_))),this._proxy=w.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(w,c){c?this.setLogLevel(A.URI.revive(c),w):this.setLogLevel(w)}setVisibility(w,c){super.setVisibility(w,c),this._proxy.$setVisibility(w,c)}doCreateLogger(w,c,_){return new a(this._proxy,w,c,_)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=je([Ve(0,O.IExtHostRpcService),Ve(1,I.IExtHostInitDataService)],v);class a extends S.AbstractMessageLogger{constructor(w,c,_,h){super(h?.logLevel==="always"),this.proxy=w,this.file=c,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(c,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,c){const _=[[w,c]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(w){this.proxy.$log(this.file,w)}flush(){this.proxy.$flush(this.file)}}}),define(Te[87],Pe([1,0,5,3,4,17,23]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,T.createDecorator)("IExtHostManagedSockets");let R=class{constructor(w){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadManagedSockets)}setFactory(w,c){for(const _ of this._managedRemoteSockets.values())_.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(w,c),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(w){if(!this._factory||this._factory.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const c=++this._remoteSocketIdCounter,_=await this._factory.makeConnection(),h=new I.DisposableStore;return this._managedRemoteSockets.set(c,new a(c,_,h)),h.add((0,I.toDisposable)(()=>this._managedRemoteSockets.delete(c))),h.add(_.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(c),h.dispose()})),h.add(_.onDidClose(n=>{this._proxy.$onDidManagedSocketClose(c,n?.stack??n?.message),h.dispose()})),h.add(_.onDidReceiveMessage(n=>this._proxy.$onDidManagedSocketHaveData(c,A.VSBuffer.wrap(n)))),c}$remoteSocketWrite(w,c){this._managedRemoteSockets.get(w)?.actual.send(c.buffer)}$remoteSocketEnd(w){const c=this._managedRemoteSockets.get(w);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(w){await this._managedRemoteSockets.get(w)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=je([Ve(0,O.IExtHostRpcService)],R);class v{constructor(w,c){this.socketFactoryId=w,this.makeConnection=c}}class a extends I.Disposable{constructor(w,c,_){super(),this.socketId=w,this.actual=c,this._register(_)}}}),define(Te[259],Pe([1,0,5,12,25]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(R){return R&&R.title}let A=class{constructor(v,a){this._logService=a,this._proxy=v.getProxy(S.MainContext.MainThreadMessageService)}showMessage(v,a,k,w,c){const _={source:{identifier:v.identifier,label:v.displayName||v.name}};let h;typeof w=="string"||O(w)?h=[w,...c]:(_.modal=w?.modal,_.useCustom=w?.useCustom,_.detail=w?.detail,h=c),_.useCustom&&(0,I.checkProposedApiEnabled)(v,"resolvers");const n=[];let s=!1;for(let o=0;o<h.length;o++){const d=h[o];if(typeof d=="string")n.push({title:d,handle:o,isCloseAffordance:!1});else if(typeof d=="object"){const{title:i,isCloseAffordance:r}=d;n.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(s?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,d):s=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,d)}return this._proxy.$showMessage(a,k,_,n).then(o=>{if(typeof o=="number")return h[o]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=je([Ve(1,T.ILogService)],A)}),define(Te[260],Pe([1,0,4,15,2,25,5]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(a){this.handlers=new Map,this.proxy=a.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,k,w){if((0,O.checkProposedApiEnabled)(a,"profileContentHandlers"),this.handlers.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.handlers.set(k,w),this.proxy.$registerProfileContentHandler(k,w.name,w.description,a.identifier.value),(0,S.toDisposable)(()=>{this.handlers.delete(k),this.proxy.$unregisterProfileContentHandler(k)})}async $saveProfile(a,k,w,c){const _=this.handlers.get(a);if(!_)throw new Error(`Unknown handler with id: ${a}`);return _.saveProfile(k,w,c)}async $readProfile(a,k,w){const c=this.handlers.get(a);if(!c)throw new Error(`Unknown handler with id: ${a}`);return c.readProfile((0,T.isString)(k)?k:I.URI.revive(k),w)}}e.ExtHostProfileContentHandlers=R}),define(Te[88],Pe([1,0,5,6,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(R){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(S.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,v){return this._proxy.$getPassword(R,v)}store(R,v,a){return this._proxy.$setPassword(R,v,a)}delete(R,v){return this._proxy.$deletePassword(R,v)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(Te[261],Pe([1,0,22,4,5]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(I.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,v,a){const k=this.providers.get(R);if(!k)return;const w=new T.DisposableStore,c=new S.CancellationTokenSource;this.sessions.set(v,c);const _=await k.provideSpeechToTextSession(c.token,a?{language:a}:void 0);_&&(w.add(_.onDidChange(h=>{c.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,h)})),w.add(c.token.onCancellationRequested(()=>w.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,v,a){const k=this.providers.get(R);if(!k)return;const w=new T.DisposableStore,c=new S.CancellationTokenSource;this.sessions.set(v,c);const _=await k.provideTextToSpeechSession(c.token,a?{language:a}:void 0);_&&(this.synthesizers.set(v,_),w.add(_.onDidChange(h=>{c.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(v,h)})),w.add(c.token.onCancellationRequested(()=>w.dispose())))}async $synthesizeSpeech(R,v){this.synthesizers.get(R)?.synthesize(v)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,v){const a=this.providers.get(R);if(!a)return;const k=new T.DisposableStore,w=new S.CancellationTokenSource;this.sessions.set(v,w);const c=await a.provideKeywordRecognitionSession(w.token);c&&(k.add(c.onDidChange(_=>{w.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,_)})),k.add(w.token.onCancellationRequested(()=>k.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,v,a){const k=O.ID_POOL++;return this.providers.set(k,a),this.proxy.$registerProvider(k,v,{extension:R,displayName:R.value}),(0,T.toDisposable)(()=>{this.proxy.$unregisterProvider(k),this.providers.delete(k)})}}e.ExtHostSpeech=O}),define(Te[89],Pe([1,0,5,6,3]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(R,v){this._logService=v,this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(S.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,v){this._proxy.$registerExtensionStorageKeysToSync(R,v)}async initializeExtensionStorage(R,v,a){const k=await this._proxy.$initializeExtensionStorage(R,v);let w;return k&&(w=this.safeParseValue(R,v,k)),w||a}setValue(R,v,a){return this._proxy.$setValue(R,v,a)}$acceptValue(R,v,a){const k=this.safeParseValue(R,v,a);k&&this._onDidChangeStorage.fire({shared:R,key:v,value:k})}safeParseValue(R,v,a){try{return JSON.parse(a)}catch(k){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${R}): ${k}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Te[262],Pe([1,0,4,16,2,5]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,a,k,w){if(this._openers.has(a))throw new Error(`Opener with id '${a}' already registered`);const c=w.schemes.find(_=>!A.supportedSchemes.has(_));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(a,k),this._proxy.$registerUriOpener(a,w.schemes,v,w.label),(0,S.toDisposable)(()=>{this._openers.delete(a),this._proxy.$unregisterUriOpener(a)})}async $canOpenUri(v,a,k){const w=this._openers.get(v);if(!w)throw new Error(`Unknown opener with id: ${v}`);const c=I.URI.revive(a);return w.canOpenExternalUri(c,k)}async $openUri(v,a,k){const w=this._openers.get(v);if(!w)throw new Error(`Unknown opener id: '${v}'`);return w.openExternalUri(I.URI.revive(a.resolvedUri),{sourceUri:I.URI.revive(a.sourceUri)},k)}}e.ExtHostUriOpeners=A}),define(Te[263],Pe([1,0,5,2,4,14,19]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(a){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=a.getProxy(S.MainContext.MainThreadUrls)}registerUriHandler(a,k){const w=a.identifier;if(this.handles.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const c=R.HandlePool++;return this.handles.add(w),this.handlers.set(c,k),this._proxy.$registerUriHandler(c,w,a.displayName||a.name),(0,I.toDisposable)(()=>{this.handles.delete(w),this.handlers.delete(c),this._proxy.$unregisterUriHandler(c)})}$handleExternalUri(a,k){const w=this.handlers.get(a);if(!w)return Promise.resolve(void 0);try{w.handleUri(T.URI.revive(k))}catch(c){(0,O.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(a){return T.URI.revive(await this._proxy.$createAppUri(a))}}e.ExtHostUrls=R}),define(Te[264],Pe([1,0,23,5]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=O,e.deserializeWebviewMessage=R,T=$e(T);class I{constructor(){this.buffers=[]}add(a){let k=this.buffers.indexOf(a);return k<0&&(k=this.buffers.length,this.buffers.push(a)),k}}function O(v,a){if(a.serializeBuffersForPostMessage){const k=new I,c=JSON.stringify(v,(h,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(n)};if(ArrayBuffer.isView(n)){const s=A(n);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(n.buffer),view:{type:s,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),_=k.buffers.map(h=>{const n=new Uint8Array(h);return S.VSBuffer.wrap(n)});return{message:c,buffers:_}}else return{message:JSON.stringify(v),buffers:[]}}function A(v){switch(v.constructor.name){case"Int8Array":return T.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return T.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return T.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return T.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return T.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return T.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return T.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return T.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return T.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return T.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return T.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(v,a){const k=a.map(_=>{const h=new ArrayBuffer(_.byteLength);return new Uint8Array(h).set(_.buffer),h}),w=a.length?(_,h)=>{if(h&&typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const n=h,{index:s}=n,o=k[s];if(n.view)switch(n.view.type){case T.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(o,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(o,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(o,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(o,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(o,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(o,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(o,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(o,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(o,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(o,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case T.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(o,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return h}:void 0;return{message:JSON.parse(v,w),arrayBuffers:k}}}),define(Te[68],Pe([1,0,6,4,16,26,2,216,264,83,5]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=c,e.toExtensionData=n,e.serializeWebviewOptions=s,O=$e(O),k=$e(k);class w{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(r,t,l,u,g,m,p){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new S.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new S.Emitter,this._onDidDispose=this.#d.event,this.#e=r,this.#t=t,this.#o=l,this.#n=u,this.#s=g,this.#r=m,this.#u=c(m),this.#h=_(m),this.#i=p}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#c=!0,(0,a.asWebviewUri)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===I.Schemas.https||r.scheme===I.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.webviewGenericCspSource}return a.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(r){this.assertNotDisposed(),this.#a!==r&&(this.#a=r,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(r)))}get options(){return this.assertNotDisposed(),this.#o}set options(r){this.assertNotDisposed(),O.equals(this.#o,r)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#l)return!1;const t=(0,v.serializeWebviewMessage)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(r){if(!this.#h)return r;const t=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,l=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,g,m,p,y,C)=>{const b=A.URI.from({scheme:p||"file",path:decodeURIComponent(y)}),D=(0,a.asWebviewUri)(b,{isRemote:t,authority:l}).toString();return`${g}${D}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,g,m,p,y,C)=>{const b=A.URI.from({scheme:p||"file",path:decodeURIComponent(y)}),D=(0,a.asWebviewUri)(b,{isRemote:t,authority:l}).toString();return`${g}${D}${C}`})}}e.ExtHostWebview=w;function c(i){try{const r=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function _(i){try{const r=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class h extends T.Disposable{constructor(r,t,l,u,g){super(),this.remoteInfo=t,this.workspace=l,this._logService=u,this._deprecationService=g,this._webviews=new Map,this._webviewProxy=r.getProxy(k.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const r of this._webviews.values())r.dispose();this._webviews.clear()}$onMessage(r,t,l){const u=this.getWebview(r);if(u){const{message:g}=(0,v.deserializeWebviewMessage)(t,l.value);u._onMessageEmitter.fire(g)}}$onMissingCsp(r,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,l){const u=new w(r,this._webviewProxy,o(t),this.remoteInfo,this.workspace,l,this._deprecationService);this._webviews.set(r,u);const g=u._onDidDispose(()=>{g.dispose(),this.deleteWebview(r)});return u}deleteWebview(r){this._webviews.delete(r)}getWebview(r){return this._webviews.get(r)}}e.ExtHostWebviews=h;function n(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||d(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function d(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Te[121],Pe([1,0,6,16,13,2,3,17,5]),function(ae,e,S,T,I,O,A,R,v){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class{static{a=this}static{this.InitialState={focused:!0,active:!0}}getState(){const c=this._state;return{get focused(){return c.focused},get active(){return c.active}}}constructor(c){this._onDidChangeWindowState=new S.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=a.InitialState,this._proxy=c.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:_,isActive:h})=>{this.onDidChangeWindowProperty("focused",_),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,_){_!==this._state[c]&&(this._state={...this._state,[c]:_},this._onDidChangeWindowState.fire(this._state))}openUri(c,_){let h;if(typeof c=="string"){h=c;try{c=O.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,I.isFalsyOrWhitespace)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this._proxy.$openUri(c,h,_)}async asExternalUri(c,_){if((0,I.isFalsyOrWhitespace)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(c,_);return O.URI.from(h)}};e.ExtHostWindow=k,e.ExtHostWindow=k=a=je([Ve(0,R.IExtHostRpcService)],k),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Te[265],Pe([1,0,254,27,17]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends S.AbstractExtHostConsoleForwarder{constructor(R,v){super(R,v)}_nativeConsoleLogMessage(R,v,a){v.apply(console,a)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=je([Ve(0,I.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],O)}),define(Te[266],Pe([1,0,11,23,22,28,14,6,4,38,161,252,39]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=d,e.parseJsonAndRestoreBufferRefs=i,A=$e(A);function h(F,L){try{return JSON.stringify(F,L)}catch{return"null"}}const n="$$ref$$",s={[n]:-1};class o{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function d(F,L=null,M=!1){const V=[];return{jsonString:(M?h:JSON.stringify)(F,(N,Q)=>{if(typeof Q>"u")return s;if(typeof Q=="object"){if(Q instanceof T.VSBuffer){const Y=V.push(Q)-1;return{[n]:Y}}if(L)return L(N,Q)}return Q}),referencedBuffers:V}}function i(F,L,M){return JSON.parse(F,(V,W)=>{if(W){const N=W[n];if(typeof N=="number")return L[N];if(M&&W.$mid===a.MarshalledId.Uri)return M.transformIncoming(W)}return W})}function r(F,L){return JSON.stringify(F,L)}function t(F){return F?(L,M)=>M&&M.$mid===a.MarshalledId.Uri?F.transformOutgoing(M):M:null}var l;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(l||(e.RequestInitiator=l={}));var u;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const g=()=>{},m=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class y extends v.Disposable{static{_=m}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(L,M=null,V=null){super(),this[_]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=V,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let W=0,N=c.ProxyIdentifier.count;W<N;W++)this._locals[W]=null,this._proxies[W]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=u.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new S.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(W=>this._receiveOneMessage(W)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{const M=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],M.resolveErr(A.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+y.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+y.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(u.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(u.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,k.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:V}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,V)),this._proxies[M]}_createProxy(L,M){const V={get:(W,N)=>(typeof N=="string"&&!W[N]&&N.charCodeAt(0)===O.CharCode.DollarSign&&(W[N]=(...Q)=>this._remoteCall(L,N,Q)),N===p?M:W[N])};return new Proxy(Object.create(null),V)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,V=L.length;M<V;M++){const W=L[M];if(!this._locals[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,V=b.read(L,0),W=V.readUInt8(),N=V.readUInt32();switch(W){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:Q,method:Y,args:ge}=P.deserializeRequestJSONArgs(V);this._uriTransformer&&(ge=(0,k.transformIncomingURIs)(ge,this._uriTransformer)),this._receiveRequest(M,N,Q,Y,ge,W===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:Q,method:Y,args:ge}=P.deserializeRequestMixedArgs(V);this._uriTransformer&&(ge=(0,k.transformIncomingURIs)(ge,this._uriTransformer)),this._receiveRequest(M,N,Q,Y,ge,W===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this._logger?.logIncoming(M,N,l.LocalSide,"ack"),this._onDidReceiveAcknowledge(N);break}case f.Cancel:{this._receiveCancel(M,N);break}case f.ReplyOKEmpty:{this._receiveReply(M,N,void 0);break}case f.ReplyOKJSON:{let Q=P.deserializeReplyOKJSON(V);this._uriTransformer&&(Q=(0,k.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReply(M,N,Q);break}case f.ReplyOKJSONWithBuffers:{const Q=P.deserializeReplyOKJSONWithBuffers(V,this._uriTransformer);this._receiveReply(M,N,Q);break}case f.ReplyOKVSBuffer:{const Q=P.deserializeReplyOKVSBuffer(V);this._receiveReply(M,N,Q);break}case f.ReplyErrError:{let Q=P.deserializeReplyErrError(V);this._uriTransformer&&(Q=(0,k.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReplyErr(M,N,Q);break}case f.ReplyErrEmpty:{this._receiveReplyErr(M,N,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,V,W,N,Q){this._logger?.logIncoming(L,M,l.OtherSide,`receiveRequest ${(0,c.getStringIdentifierForProxy)(V)}.${W}(`,N);const Y=String(M);let ge,Z;if(Q){const se=new I.CancellationTokenSource;N.push(se.token),ge=this._invokeHandler(V,W,N),Z=()=>se.cancel()}else ge=this._invokeHandler(V,W,N),Z=g;this._cancelInvokedHandlers[Y]=Z;const me=P.serializeAcknowledged(M);this._logger?.logOutgoing(me.byteLength,M,l.OtherSide,"ack"),this._protocol.send(me),ge.then(se=>{delete this._cancelInvokedHandlers[Y];const le=P.serializeReplyOK(M,se,this._uriReplacer);this._logger?.logOutgoing(le.byteLength,M,l.OtherSide,"reply:",se),this._protocol.send(le)},se=>{delete this._cancelInvokedHandlers[Y];const le=P.serializeReplyErr(M,se);this._logger?.logOutgoing(le.byteLength,M,l.OtherSide,"replyErr:",se),this._protocol.send(le)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,l.OtherSide,"receiveCancel");const V=String(M);this._cancelInvokedHandlers[V]?.()}_receiveReply(L,M,V){this._logger?.logIncoming(L,M,l.LocalSide,"receiveReply:",V);const W=String(M);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const N=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W],N.resolveOk(V)}_receiveReplyErr(L,M,V){this._logger?.logIncoming(L,M,l.LocalSide,"receiveReplyErr:",V);const W=String(M);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const N=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W];let Q;V&&(V.$isError?(Q=new Error,Q.name=V.name,Q.message=V.message,Q.stack=V.stack):Q=V),N.resolveErr(Q)}_invokeHandler(L,M,V){try{return Promise.resolve(this._doInvokeHandler(L,M,V))}catch(W){return Promise.reject(W)}}_doInvokeHandler(L,M,V){const W=this._locals[L];if(!W)throw new Error("Unknown actor "+(0,c.getStringIdentifierForProxy)(L));const N=W[M];if(typeof N!="function")throw new Error("Unknown method "+M+" on actor "+(0,c.getStringIdentifierForProxy)(L));return N.apply(W,V)}_remoteCall(L,M,V){if(this._isDisposed)return new w.CanceledLazyPromise;let W=null;if(V.length>0&&I.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(A.canceled());const N=P.serializeRequestArguments(V,this._uriReplacer),Q=++this._lastMessageId,Y=String(Q),ge=new w.LazyPromise,Z=new v.DisposableStore;W&&Z.add(W.onCancellationRequested(()=>{const se=P.serializeCancel(Q);this._logger?.logOutgoing(se.byteLength,Q,l.LocalSide,"cancel"),this._protocol.send(P.serializeCancel(Q))})),this._pendingRPCReplies[Y]=new C(ge,Z),this._onWillSendRequest(Q);const me=P.serializeRequest(Q,L,M,N,!!W);return this._logger?.logOutgoing(me.byteLength,Q,l.LocalSide,`request: ${(0,c.getStringIdentifierForProxy)(L)}.${M}(`,V),this._protocol.send(me),ge}}e.RPCProtocol=y;class C{constructor(L,M){this._promise=L,this._disposable=M}resolveOk(L){this._promise.resolveOk(L),this._disposable.dispose()}resolveErr(L){this._promise.resolveErr(L),this._disposable.dispose()}}class b{static alloc(L,M,V){const W=new b(T.VSBuffer.alloc(V+1+4),0);return W.writeUInt8(L),W.writeUInt32(M),W}static read(L,M){return new b(L,M)}get buffer(){return this._buff}constructor(L,M){this._buff=L,this._offset=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let V=0,W=L.length;V<W;V++){const N=L[V];switch(M+=1,N.type){case E.String:M+=this.sizeLongString(N.value);break;case E.VSBuffer:M+=this.sizeVSBuffer(N.value);break;case E.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(N.value);for(let Q=0;Q<N.buffers.length;++Q)M+=this.sizeVSBuffer(N.buffers[Q]);break;case E.Undefined:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,V=L.length;M<V;M++){const W=L[M];switch(W.type){case E.String:this.writeUInt8(E.String),this.writeLongString(W.value);break;case E.VSBuffer:this.writeUInt8(E.VSBuffer),this.writeVSBuffer(W.value);break;case E.SerializedObjectWithBuffers:this.writeUInt8(E.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let N=0;N<W.buffers.length;++N)this.writeBuffer(W.buffers[N]);break;case E.Undefined:this.writeUInt8(E.Undefined);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let V=0;V<L;V++)switch(this.readUInt8()){case E.String:M[V]=this.readLongString();break;case E.VSBuffer:M[V]=this.readVSBuffer();break;case E.SerializedObjectWithBuffers:{const N=this.readUInt32(),Q=this.readLongString(),Y=[];for(let ge=0;ge<N;++ge)Y.push(this.readVSBuffer());M[V]=new c.SerializableObjectWithBuffers(i(Q,Y,null));break}case E.Undefined:M[V]=void 0;break}return M}}var D;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(D||(D={}));class P{static _useMixedArgSerialization(L){for(let M=0,V=L.length;M<V;M++)if(L[M]instanceof T.VSBuffer||L[M]instanceof c.SerializableObjectWithBuffers||typeof L[M]>"u")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const V=[];for(let W=0,N=L.length;W<N;W++){const Q=L[W];if(Q instanceof T.VSBuffer)V[W]={type:E.VSBuffer,value:Q};else if(typeof Q>"u")V[W]={type:E.Undefined};else if(Q instanceof c.SerializableObjectWithBuffers){const{jsonString:Y,referencedBuffers:ge}=d(Q.value,M);V[W]={type:E.SerializedObjectWithBuffers,value:T.VSBuffer.fromString(Y),buffers:ge}}else V[W]={type:E.String,value:T.VSBuffer.fromString(r(Q,M))}}return{type:D.Mixed,args:V}}return{type:D.Simple,args:r(L,M)}}static serializeRequest(L,M,V,W,N){switch(W.type){case D.Simple:return this._requestJSONArgs(L,M,V,W.args,N);case D.Mixed:return this._requestMixedArgs(L,M,V,W.args,N)}}static _requestJSONArgs(L,M,V,W,N){const Q=T.VSBuffer.fromString(V),Y=T.VSBuffer.fromString(W);let ge=0;ge+=b.sizeUInt8(),ge+=b.sizeShortString(Q),ge+=b.sizeLongString(Y);const Z=b.alloc(N?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,L,ge);return Z.writeUInt8(M),Z.writeShortString(Q),Z.writeLongString(Y),Z.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),V=L.readShortString(),W=L.readLongString();return{rpcId:M,method:V,args:JSON.parse(W)}}static _requestMixedArgs(L,M,V,W,N){const Q=T.VSBuffer.fromString(V);let Y=0;Y+=b.sizeUInt8(),Y+=b.sizeShortString(Q),Y+=b.sizeMixedArray(W);const ge=b.alloc(N?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,L,Y);return ge.writeUInt8(M),ge.writeShortString(Q),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),V=L.readShortString(),W=L.readMixedArray(),N=new Array(W.length);for(let Q=0,Y=W.length;Q<Y;Q++){const ge=W[Q];typeof ge=="string"?N[Q]=JSON.parse(ge):N[Q]=ge}return{rpcId:M,method:V,args:N}}static serializeAcknowledged(L){return b.alloc(f.Acknowledged,L,0).buffer}static serializeCancel(L){return b.alloc(f.Cancel,L,0).buffer}static serializeReplyOK(L,M,V){if(typeof M>"u")return this._serializeReplyOKEmpty(L);if(M instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof c.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:N}=d(M.value,V,!0);return this._serializeReplyOKJSONWithBuffers(L,W,N)}else return this._serializeReplyOKJSON(L,h(M,V))}static _serializeReplyOKEmpty(L){return b.alloc(f.ReplyOKEmpty,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let V=0;V+=b.sizeVSBuffer(M);const W=b.alloc(f.ReplyOKVSBuffer,L,V);return W.writeVSBuffer(M),W.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const V=T.VSBuffer.fromString(M);let W=0;W+=b.sizeLongString(V);const N=b.alloc(f.ReplyOKJSON,L,W);return N.writeLongString(V),N.buffer}static _serializeReplyOKJSONWithBuffers(L,M,V){const W=T.VSBuffer.fromString(M);let N=0;N+=b.sizeUInt32,N+=b.sizeLongString(W);for(const Y of V)N+=b.sizeVSBuffer(Y);const Q=b.alloc(f.ReplyOKJSONWithBuffers,L,N);Q.writeUInt32(V.length),Q.writeLongString(W);for(const Y of V)Q.writeBuffer(Y);return Q.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const V=L.readUInt32(),W=L.readLongString(),N=[];for(let Q=0;Q<V;++Q)N.push(L.readVSBuffer());return new c.SerializableObjectWithBuffers(i(W,N,M))}static serializeReplyErr(L,M){const V=M?h(A.transformErrorForSerialization(M),null):void 0;if(typeof V!="string")return this._serializeReplyErrEmpty(L);const W=T.VSBuffer.fromString(V);let N=0;N+=b.sizeLongString(W);const Q=b.alloc(f.ReplyErrError,L,N);return Q.writeLongString(W),Q.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return b.alloc(f.ReplyErrEmpty,L,0).buffer}}var f;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var E;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(E||(E={}))}),define(Te[267],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const S=function(O){const A=R=>{globalThis.removeEventListener("message",A);const v=R.data;Object.defineProperties(globalThis,{postMessage:{value(a,k){v.postMessage(a,k)}},onmessage:{get(){return v.onmessage},set(a){v.onmessage=a}}}),v.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),v.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(O,A,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const v=`((${S})('${A}'))`,a=new Blob([v],{type:"application/javascript"}),k=URL.createObjectURL(a),w=new MessageChannel,c=k,_={type:"_newWorker",id:c,port:w.port2,url:k,options:R};O(_,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{O({type:"_terminateWorker",id:c}),URL.revokeObjectURL(k),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(h){w.port1.onmessage=h}},onmessageerror:{get(){return w.port1.onmessageerror},set(h){w.port1.onmessageerror=h}}}),w.port1.addEventListener("messageerror",h=>{const n=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(n)}),w.port1.addEventListener("message",h=>{const n=new MessageEvent("message",{data:h.data});this.dispatchEvent(n)}),w.port1.start()}}e.NestedWorker=T}),define(Te[268],Pe([1,0,23,29,16,61,3]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=k,e.generate=w,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),a=7;function k(_){if(_.scheme!==I.Schemas.vscodeNotebookCell)return;const h=_.fragment.indexOf("s");if(h<0)return;const n=parseInt(_.fragment.substring(0,h).replace(v,""),a),s=(0,S.decodeBase64)(_.fragment.substring(h+1)).toString();if(!isNaN(n))return{handle:n,notebook:_.with({scheme:s,fragment:null})}}function w(_,h){const n=h.toString(a),o=`${n.length<R.length?R[n.length-1]:"z"}${n}s${(0,S.encodeBase64)(S.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:I.Schemas.vscodeNotebookCell,fragment:o})}class c{constructor(){this._documents=new T.ResourceMap}getNotebook(h){if(h.scheme===I.Schemas.vscodeNotebookCell){const n=k(h);if(n){const s=this._documents.get(n.notebook);if(s)return s}}return this._documents.get(h)}addNotebookDocument(h){this._documents.set(h.uri,h)}removeNotebookDocument(h){this._documents.delete(h.uri)}}e.NotebookDocumentWorkbenchService=c,(0,O.registerSingleton)(e.INotebookDocumentService,c,O.InstantiationType.Delayed)}),define(Te[90],Pe([1,0,23,42,40,73,16,20,21,32,268]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=u,e.isDocumentExcludePattern=p,e.notebookDocumentFilterMatch=y,e.isTextStreamMime=D,e.compressOutputItemStreams=f,T=$e(T),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var w;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(w||(e.CellKind=w={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var c;(function(Y){Y[Y.Running=1]="Running",Y[Y.Idle=2]="Idle"})(c||(e.NotebookRunState=c={}));var _;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(_||(e.NotebookCellExecutionState=_={}));var h;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var n;(function(Y){Y[Y.WithHardKernelDependency=0]="WithHardKernelDependency",Y[Y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Y[Y.Pure=2]="Pure",Y[Y.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var s;(function(Y){Y.Always="always",Y.Never="never",Y.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(Y){Y[Y.ModelChange=1]="ModelChange",Y[Y.Move=2]="Move",Y[Y.ChangeCellLanguage=5]="ChangeCellLanguage",Y[Y.Initialize=6]="Initialize",Y[Y.ChangeCellMetadata=7]="ChangeCellMetadata",Y[Y.Output=8]="Output",Y[Y.OutputItem=9]="OutputItem",Y[Y.ChangeCellContent=10]="ChangeCellContent",Y[Y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Y[Y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Y[Y.ChangeCellMime=13]="ChangeCellMime",Y[Y.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var d;(function(Y){Y[Y.Handle=0]="Handle",Y[Y.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var i;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Output=2]="Output",Y[Y.Metadata=3]="Metadata",Y[Y.CellLanguage=4]="CellLanguage",Y[Y.DocumentMetadata=5]="DocumentMetadata",Y[Y.Move=6]="Move",Y[Y.OutputItems=7]="OutputItems",Y[Y.PartialMetadata=8]="PartialMetadata",Y[Y.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Y){Y.scheme=A.Schemas.vscodeNotebookCell;function ge(oe,Ie){return(0,k.generate)(oe,Ie)}Y.generate=ge;function Z(oe){return(0,k.parse)(oe)}Y.parse=Z;function me(oe,Ie){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Y.generateCellOutputUri=me;function se(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Ie)return;const Me=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,X=Ie[2];return{outputId:Me,notebook:oe.with({scheme:X||A.Schemas.file,fragment:null})}}Y.parseCellOutputUri=se;function le(oe,Ie,Me){return Y.generate(oe,Ie).with({scheme:Me})}Y.generateCellPropertyUri=le;function Ee(oe,Ie){if(oe.scheme===Ie)return Y.parse(oe.with({scheme:Y.scheme}))}Y.parseCellPropertyUri=Ee})(r||(e.CellUri=r={}));const t=Y=>v.isWindows?Y.replace(/\//g,"\\"):Y;class l{constructor(ge=[],Z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Z,this.order=[...new Set(ge)].map(me=>({pattern:me,matches:T.parse(t(me))}))}sort(ge){const Z=new Map(I.Iterable.map(ge,se=>[se,t(se)]));let me=[];for(const{matches:se}of this.order)for(const[le,Ee]of Z)if(se(Ee)){me.push(le),Z.delete(le);break}return Z.size&&(me=me.concat([...Z.keys()].sort((se,le)=>this.defaultOrder.indexOf(se)-this.defaultOrder.indexOf(le)))),me}prioritize(ge,Z){const me=this.findIndex(ge);if(me===-1){this.order.unshift({pattern:ge,matches:T.parse(t(ge))});return}const se=new Set(Z.map(Ee=>this.findIndex(Ee,me)));se.delete(-1);const le=Array.from(se).sort();this.order.splice(me+1,0,...le.map(Ee=>this.order[Ee]));for(let Ee=le.length-1;Ee>=0;Ee--)this.order.splice(le[Ee],1)}toArray(){return this.order.map(ge=>ge.pattern)}findIndex(ge,Z=this.order.length){const me=t(ge);for(let se=0;se<Z;se++)if(this.order[se].matches(me))return se;return-1}}e.MimeTypeDisplayOrder=l;function u(Y,ge,Z,me=(se,le)=>se===le){const se=[];function le(Ie,Me,X){if(Me===0&&X.length===0)return;const $=se[se.length-1];$&&$.start+$.deleteCount===Ie?($.deleteCount+=Me,$.toInsert.push(...X)):se.push({start:Ie,deleteCount:Me,toInsert:X})}let Ee=0,oe=0;for(;;){if(Ee===Y.length){le(Ee,0,ge.slice(oe));break}if(oe===ge.length){le(Ee,Y.length-Ee,[]);break}const Ie=Y[Ee],Me=ge[oe];if(me(Ie,Me)){Ee+=1,oe+=1;continue}Z(Me)?(le(Ee,1,[]),Ee+=1):(le(Ee,0,[Me]),oe+=1)}return se}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new a.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new a.RawContextKey("notebookEditorCursorAtLineBoundary","none");var g;(function(Y){Y.default="default",Y.option="option"})(g||(e.NotebookEditorPriority=g={}));var m;(function(Y){Y.Cells="cells",Y.Text="text",Y.None="none"})(m||(e.NotebookFindScopeType=m={}));function p(Y){const ge=Y;return!!((typeof ge.include=="string"||T.isRelativePattern(ge.include))&&(typeof ge.exclude=="string"||T.isRelativePattern(ge.exclude)))}function y(Y,ge,Z){if(Array.isArray(Y.viewType)&&Y.viewType.indexOf(ge)>=0||Y.viewType===ge)return!0;if(Y.filenamePattern){const me=p(Y.filenamePattern)?Y.filenamePattern.include:Y.filenamePattern,se=p(Y.filenamePattern)?Y.filenamePattern.exclude:void 0;if(T.match(me,(0,R.basename)(Z.fsPath).toLowerCase()))return!(se&&T.match(se,(0,R.basename)(Z.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var C;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(C||(e.CellStatusbarAlignment=C={}));class b{static{this._prefix="notebook/"}static create(ge){return`${b._prefix}${ge}`}static parse(ge){if(ge.startsWith(b._prefix))return ge.substring(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b;function D(Y){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Y)}const P=new TextDecoder;function f(Y){const ge=[];let Z=!1;for(const Ee of Y)(ge.length===0||Z)&&(ge.push(Ee),Z=!0);let me=L(ge);const se=S.VSBuffer.concat(ge.map(Ee=>S.VSBuffer.wrap(Ee))),le=Q(se);return me=me||le.byteLength!==se.byteLength,{data:le,didCompression:me}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const E=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(Y=>Y.charCodeAt(0)),F=10;function L(Y){let ge=!1;return Y.forEach((Z,me)=>{if(me===0||Z.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const se=Y[me-1],le=Z.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(le[0]===E[0]&&le[1]===E[1]&&le[2]===E[2]){const Ee=se.lastIndexOf(F);if(Ee===-1)return;ge=!0,Y[me-1]=se.subarray(0,Ee),Y[me]=Z.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ge}function M(Y){let ge=Y;do Y=ge,ge=Y.replace(/[^\n]\x08/gm,"");while(ge.length<Y.length);return Y}function V(Y){for(Y=Y.replace(/\r+\n/gm,`
`);Y.search(/\r[^$]/g)>-1;){const ge=Y.match(/^(.*)\r+/m)[1];let Z=Y.match(/\r+(.*)$/m)[1];Z=Z+ge.slice(Z.length,ge.length),Y=Y.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return Y}const W=8,N=13;function Q(Y){return!Y.buffer.includes(W)&&!Y.buffer.includes(N)?Y:S.VSBuffer.fromString(V(M(P.decode(Y.buffer))))}}),define(Te[7],Pe([1,0,18,14,60,29,73,13,15,2,37,19,30,110,90]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h){"use strict";var n,s,o,d,i,r,t,l,u,g,m,p,y,C,b,D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelFunctionUsePart=e.LanguageModelChatMessage=e.LanguageModelFunctionResultPart=e.LanguageModelChatMessageRole=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=Je,e.setBreakpointId=yi,e.validateTestCoverageCount=Ai;function f(z){return Object.assign(z,{apply:function(...re){if(re.length===0)return Reflect.construct(z,[]);{const ye=re.length===1?[]:re[1];return Reflect.construct(z,ye,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(z,[]);{const[ye,...Ke]=re;return Reflect.construct(z,Ke,ye.constructor)}}})}var E;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(E||(e.TerminalOutputAnchor=E={}));var F;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let L=n=class{static from(...U){let re=U;return new n(function(){if(re){for(const ye of re)ye&&typeof ye.dispose=="function"&&ye.dispose();re=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=n=je([f],L);let M=s=class{static Min(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let ye=1;ye<U.length;ye++){const Ke=U[ye];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let ye=1;ye<U.length;ye++){const Ke=U[ye];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(U){if(!U)return!1;if(U instanceof s)return!0;const{line:re,character:ye}=U;return typeof re=="number"&&typeof ye=="number"}static of(U){if(U instanceof s)return U;if(this.isPosition(U))return new s(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,re){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(re<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=U,this._character=re}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,re=0){if(U===null||re===null)throw(0,T.illegalArgument)();let ye;return typeof U>"u"?ye=0:typeof U=="number"?ye=U:(ye=typeof U.lineDelta=="number"?U.lineDelta:0,re=typeof U.characterDelta=="number"?U.characterDelta:0),ye===0&&re===0?this:new s(this.line+ye,this.character+re)}with(U,re=this.character){if(U===null||re===null)throw(0,T.illegalArgument)();let ye;return typeof U>"u"?ye=this.line:typeof U=="number"?ye=U:(ye=typeof U.line=="number"?U.line:this.line,re=typeof U.character=="number"?U.character:this.character),ye===this.line&&re===this.character?this:new s(ye,re)}toJSON(){return{line:this.line,character:this.character}}};e.Position=M,e.Position=M=s=je([f],M);let V=o=class{static isRange(U){return U instanceof o?!0:U?M.isPosition(U.start)&&M.isPosition(U.end):!1}static of(U){if(U instanceof o)return U;if(this.isRange(U))return new o(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,re,ye,Ke){let it,ht;if(typeof U=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ke=="number"?(it=new M(U,re),ht=new M(ye,Ke)):M.isPosition(U)&&M.isPosition(re)&&(it=M.of(U),ht=M.of(re)),!it||!ht)throw new Error("Invalid arguments");it.isBefore(ht)?(this._start=it,this._end=ht):(this._start=ht,this._end=it)}contains(U){return o.isRange(U)?this.contains(U.start)&&this.contains(U.end):M.isPosition(U)?!(M.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const re=M.Max(U.start,this._start),ye=M.Min(U.end,this._end);if(!re.isAfter(ye))return new o(re,ye)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const re=M.Min(U.start,this._start),ye=M.Max(U.end,this.end);return new o(re,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,re=this.end){if(U===null||re===null)throw(0,T.illegalArgument)();let ye;return U?M.isPosition(U)?ye=U:(ye=U.start||this.start,re=U.end||this.end):ye=this.start,ye.isEqual(this._start)&&re.isEqual(this.end)?this:new o(ye,re)}toJSON(){return[this.start,this.end]}};e.Range=V,e.Range=V=o=je([f],V);let W=d=class extends V{static isSelection(U){return U instanceof d?!0:U?V.isRange(U)&&M.isPosition(U.anchor)&&M.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,re,ye,Ke){let it,ht;if(typeof U=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ke=="number"?(it=new M(U,re),ht=new M(ye,Ke)):M.isPosition(U)&&M.isPosition(re)&&(it=M.of(U),ht=M.of(re)),!it||!ht)throw new Error("Invalid arguments");super(it,ht),this._anchor=it,this._active=ht}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=W,e.Selection=W=d=je([f],W);const N=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,T.illegalArgument)("connectionToken")};class Q{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,re,ye){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,T.illegalArgument)("port");typeof ye<"u"&&N(ye),this.host=U,this.port=Math.round(re),this.connectionToken=ye}}e.ResolvedAuthority=Q;class Y{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,re){this.makeConnection=U,this.connectionToken=re,typeof re<"u"&&N(re)}}e.ManagedResolvedAuthority=Y;class ge extends Error{static NotAvailable(U,re){return new ge(U,_.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(U){return new ge(U,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,re=_.RemoteAuthorityResolverErrorCode.Unknown,ye){super(U),this._message=U,this._code=re,this._detail=ye,Object.setPrototypeOf(this,ge.prototype)}}e.RemoteAuthorityResolverError=ge;var Z;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var me;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let se=i=class{static isTextEdit(U){return U instanceof i?!0:U?V.isRange(U)&&typeof U.newText=="string":!1}static replace(U,re){return new i(U,re)}static insert(U,re){return i.replace(new V(U,U),re)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const re=new i(new V(new M(0,0),new M(0,0)),"");return re.newEol=U,re}get range(){return this._range}set range(U){if(U&&!V.isRange(U))throw(0,T.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this._newEol=U}constructor(U,re){this._range=U,this._newText=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=se,e.TextEdit=se=i=je([f],se);let le=r=class{static isNotebookCellEdit(U){return U instanceof r?!0:U?Et.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,re){return new r(U,re)}static insertCells(U,re){return new r(new Et(U,U),re)}static deleteCells(U){return new r(U,[])}static updateCellMetadata(U,re){const ye=new r(new Et(U,U),[]);return ye.newCellMetadata=re,ye}static updateNotebookMetadata(U){const re=new r(new Et(0,0),[]);return re.newNotebookMetadata=U,re}constructor(U,re){this.range=U,this.newCells=re}};e.NotebookEdit=le,e.NotebookEdit=le=r=je([f],le);class Ee{static isSnippetTextEdit(U){return U instanceof Ee?!0:U?V.isRange(U.range)&&Me.isSnippetString(U.snippet):!1}static replace(U,re){return new Ee(U,re)}static insert(U,re){return Ee.replace(new V(U,U),re)}constructor(U,re){this.range=U,this.snippet=re}}e.SnippetTextEdit=Ee;var oe;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let Ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,re,ye,Ke){this._edits.push({_type:oe.File,from:U,to:re,options:ye,metadata:Ke})}createFile(U,re,ye){this._edits.push({_type:oe.File,from:void 0,to:U,options:re,metadata:ye})}deleteFile(U,re,ye){this._edits.push({_type:oe.File,from:U,to:void 0,options:re,metadata:ye})}replaceNotebookMetadata(U,re,ye){this._edits.push({_type:oe.Cell,metadata:ye,uri:U,edit:{editType:h.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}replaceNotebookCells(U,re,ye,Ke){const it=re.start,ht=re.end;(it!==ht||ye.length>0)&&this._edits.push({_type:oe.CellReplace,uri:U,index:it,count:ht-it,cells:ye,metadata:Ke})}replaceNotebookCellMetadata(U,re,ye,Ke){this._edits.push({_type:oe.Cell,metadata:Ke,uri:U,edit:{editType:h.CellEditType.Metadata,index:re,metadata:ye}})}replace(U,re,ye,Ke){this._edits.push({_type:oe.Text,uri:U,edit:new se(re,ye),metadata:Ke})}insert(U,re,ye,Ke){this.replace(U,new V(re,re),ye,Ke)}delete(U,re,ye){this.replace(U,re,"",ye)}has(U){return this._edits.some(re=>re._type===oe.Text&&re.uri.toString()===U.toString())}set(U,re){if(re)for(const ye of re){if(!ye)continue;let Ke,it;Array.isArray(ye)?(Ke=ye[0],it=ye[1]):Ke=ye,le.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(U,Ke.range.start,Ke.newCellMetadata,it):Ke.newNotebookMetadata?this.replaceNotebookMetadata(U,Ke.newNotebookMetadata,it):this.replaceNotebookCells(U,Ke.range,Ke.newCells,it):Ee.isSnippetTextEdit(Ke)?this._edits.push({_type:oe.Snippet,uri:U,range:Ke.range,edit:Ke.snippet,metadata:it}):this._edits.push({_type:oe.Text,uri:U,edit:Ke,metadata:it})}else{for(let ye=0;ye<this._edits.length;ye++){const Ke=this._edits[ye];switch(Ke._type){case oe.Text:case oe.Snippet:case oe.Cell:case oe.CellReplace:Ke.uri.toString()===U.toString()&&(this._edits[ye]=void 0);break}}(0,S.coalesceInPlace)(this._edits)}}get(U){const re=[];for(const ye of this._edits)ye._type===oe.Text&&ye.uri.toString()===U.toString()&&re.push(ye.edit);return re}entries(){const U=new O.ResourceMap;for(const re of this._edits)if(re._type===oe.Text){let ye=U.get(re.uri);ye||(ye=[re.uri,[]],U.set(re.uri,ye)),ye[1].push(re.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Ie,e.WorkspaceEdit=Ie=je([f],Ie);let Me=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=t._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,re=this._tabstop++){if(typeof U=="function"){const ye=new t;ye._tabstop=this._tabstop,U(ye),this._tabstop=ye._tabstop,U=ye.value}else U=t._escape(U);return this.value+="${",this.value+=re,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,re=this._tabstop++){const ye=U.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(U,re){if(typeof re=="function"){const ye=new t;ye._tabstop=this._tabstop,re(ye),this._tabstop=ye._tabstop,re=ye.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.SnippetString=Me,e.SnippetString=Me=t=je([f],Me);var X;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var $;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})($||(e.DiagnosticSeverity=$={}));let te=l=class{static isLocation(U){return U instanceof l?!0:U?V.isRange(U.range)&&a.URI.isUri(U.uri):!1}constructor(U,re){if(this.uri=U,re)if(V.isRange(re))this.range=V.of(re);else if(M.isPosition(re))this.range=new V(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=te,e.Location=te=l=je([f],te);let Se=class{static is(U){return U?typeof U.message=="string"&&U.location&&V.isRange(U.location.range)&&a.URI.isUri(U.location.uri):!1}constructor(U,re){this.location=U,this.message=re}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.location.range.isEqual(re.location.range)&&U.location.uri.toString()===re.location.uri.toString()}};e.DiagnosticRelatedInformation=Se,e.DiagnosticRelatedInformation=Se=je([f],Se);let ce=class{constructor(U,re,ye=$.Error){if(!V.isRange(U))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=U,this.message=re,this.severity=ye}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.severity===re.severity&&U.code===re.code&&U.severity===re.severity&&U.source===re.source&&U.range.isEqual(re.range)&&(0,S.equals)(U.tags,re.tags)&&(0,S.equals)(U.relatedInformation,re.relatedInformation,Se.isEqual)}};e.Diagnostic=ce,e.Diagnostic=ce=je([f],ce);let be=class{constructor(U,re){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=re}};e.Hover=be,e.Hover=be=je([f],be);let he=class extends be{constructor(U,re,ye,Ke){super(U,re),this.canIncreaseHover=ye,this.canDecreaseHover=Ke}};e.VerboseHover=he,e.VerboseHover=he=je([f],he);var G;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(G||(e.HoverVerbosityAction=G={}));var J;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(J||(e.DocumentHighlightKind=J={}));let pe=class{constructor(U,re=J.Text){this.range=U,this.kind=re}toJSON(){return{range:this.range,kind:J[this.kind]}}};e.DocumentHighlight=pe,e.DocumentHighlight=pe=je([f],pe);let ve=class{constructor(U,re){this.uri=U,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.MultiDocumentHighlight=ve,e.MultiDocumentHighlight=ve=je([f],ve);var Oe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var Ue;(function(z){z[z.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let De=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,re,ye,Ke,it){this.name=U,this.kind=re,this.containerName=it,typeof ye=="string"&&(this.containerName=ye),Ke instanceof te?this.location=Ke:ye instanceof V&&(this.location=new te(Ke,ye)),u.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=De,e.SymbolInformation=De=u=je([f],De);let Ae=g=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(g.validate)}constructor(U,re,ye,Ke,it){this.name=U,this.detail=re,this.kind=ye,this.range=Ke,this.selectionRange=it,this.children=[],g.validate(this)}};e.DocumentSymbol=Ae,e.DocumentSymbol=Ae=g=je([f],Ae);var Le;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let B=class{constructor(U,re){this.title=U,this.kind=re}};e.CodeAction=B,e.CodeAction=B=je([f],B);let x=class{static{m=this}static{this.sep="."}constructor(U){this.value=U}append(U){return new m(this.value?this.value+m.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+m.sep)}};e.CodeActionKind=x,e.CodeActionKind=x=m=je([f],x),x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let H=class{constructor(U,re){if(this.range=U,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=H,e.SelectionRange=H=je([f],H);class j{constructor(U,re,ye,Ke,it,ht){this.kind=U,this.name=re,this.detail=ye,this.uri=Ke,this.range=it,this.selectionRange=ht}}e.CallHierarchyItem=j;class ne{constructor(U,re){this.fromRanges=re,this.from=U}}e.CallHierarchyIncomingCall=ne;class fe{constructor(U,re){this.fromRanges=re,this.to=U}}e.CallHierarchyOutgoingCall=fe;var ke;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(ke||(e.LanguageStatusSeverity=ke={}));let xe=class{constructor(U,re){this.range=U,this.command=re}get isResolved(){return!!this.command}};e.CodeLens=xe,e.CodeLens=xe=je([f],xe);let qe=p=class{#e;static isMarkdownString(U){return U instanceof p?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,re=!1){this.#e=new I.MarkdownString(U,{supportThemeIcons:re})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,re){return this.#e.appendCodeblock(re??"",U),this}};e.MarkdownString=qe,e.MarkdownString=qe=p=je([f],qe);let Ze=class{constructor(U,re){this.label=U,this.documentation=re}};e.ParameterInformation=Ze,e.ParameterInformation=Ze=je([f],Ze);let tt=class{constructor(U,re){this.label=U,this.documentation=re,this.parameters=[]}};e.SignatureInformation=tt,e.SignatureInformation=tt=je([f],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=nt,e.SignatureHelp=nt=je([f],nt);var et;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ft=class{constructor(U){this.value=U}};e.InlayHintLabelPart=ft,e.InlayHintLabelPart=ft=je([f],ft);let lt=class{constructor(U,re,ye){this.position=U,this.label=re,this.kind=ye}};e.InlayHint=lt,e.InlayHint=lt=je([f],lt);var st;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var gt;(function(z){z[z.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let pt=class{constructor(U,re){this.label=U,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=pt,e.CompletionItem=pt=je([f],pt);let ze=class{constructor(U=[],re=!1){this.items=U,this.isIncomplete=re}};e.CompletionList=ze,e.CompletionList=ze=je([f],ze);let Be=class{constructor(U,re,ye){this.insertText=U,this.range=re,this.command=ye}};e.InlineSuggestion=Be,e.InlineSuggestion=Be=je([f],Be);let ee=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.InlineSuggestionList=ee,e.InlineSuggestionList=ee=je([f],ee);var q;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(q||(e.PartialAcceptTriggerKind=q={}));var Ce;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Ge;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ge||(e.StatusBarAlignment=Ge={}));function Je(z,U){return`${w.ExtensionIdentifier.toKey(z)}.${U}`}var dt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(dt||(e.TextEditorLineNumbersStyle=dt={}));var vt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(vt||(e.TextDocumentSaveReason=vt={}));var Lt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Lt||(e.TextEditorRevealType=Lt={}));var Ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var ei;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var ui;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(z){function U(re){switch(re){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var ti;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(z){function U(re){switch(re){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(ti||(e.SyntaxTokenType=ti={}));let Qe=class{constructor(U,re){if(re&&!a.URI.isUri(re))throw(0,T.illegalArgument)("target");if(!V.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=re}};e.DocumentLink=Qe,e.DocumentLink=Qe=je([f],Qe);let Ht=class{constructor(U,re,ye,Ke){this.red=U,this.green=re,this.blue=ye,this.alpha=Ke}};e.Color=Ht,e.Color=Ht=je([f],Ht);let qt=class{constructor(U,re){if(re&&!(re instanceof Ht))throw(0,T.illegalArgument)("color");if(!V.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=re}};e.ColorInformation=qt,e.ColorInformation=qt=je([f],qt);let mt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};e.ColorPresentation=mt,e.ColorPresentation=mt=je([f],mt);var It;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(It||(e.ColorFormat=It={}));var ii;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Xt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Xt||(e.TerminalExitReason=Xt={}));var zt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(zt||(e.TerminalShellExecutionCommandLineConfidence=zt={}));class St{constructor(U,re,ye){if(this.startIndex=U,this.length=re,this.tooltip=ye,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,T.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=St;class Ot{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ot;class di{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=di;var Wt;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Xe{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Xe;var Qt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Qt||(e.TaskRevealKind=Qt={}));var ni;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let hi=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(U){switch(U){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(U,re){if(this.label=re,typeof U!="string"||typeof re!="string")throw(0,T.illegalArgument)("name");this._id=U}get id(){return this._id}};e.TaskGroup=hi,e.TaskGroup=hi=y=je([f],hi);function yt(z){let U="";for(let re=0;re<z.length;re++)U+=z[re].replace(/,/g,",,")+",";return U}let Nt=class{constructor(U,re,ye){if(typeof U!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=U,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ye):this._options=re)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const re of this._args)U.push(re);return yt(U)}};e.ProcessExecution=Nt,e.ProcessExecution=Nt=je([f],Nt);let kt=class{constructor(U,re,ye){if(this._args=[],Array.isArray(re)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this._command=U,this._args=re,this._options=ye}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=U,this._options=re}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const re of this._args)U.push(typeof re=="string"?re:re.value);return yt(U)}};e.ShellExecution=kt,e.ShellExecution=kt=je([f],kt);var Ut;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Yt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=Yt;let si=class{static{C=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(U,re,ye,Ke,it,ht){this.__deprecated=!1,this._definition=this.definition=U;let wt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ye,this.execution=Ke,wt=it,this.__deprecated=!0):re===ri.Global||re===ri.Workspace?(this.target=re,this._name=this.name=ye,this._source=this.source=Ke,this.execution=it,wt=ht):(this.target=re,this._name=this.name=ye,this._source=this.source=Ke,this.execution=it,wt=ht),typeof wt=="string"?(this._problemMatchers=[wt],this._hasDefinedMatchers=!0):Array.isArray(wt)?(this._problemMatchers=wt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Nt?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof Yt?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const re=this._definition.type;(C.EmptyType===re||C.ProcessType===re||C.ShellType===re||C.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};e.Task=si,e.Task=si=C=je([f],si);var $t;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})($t||(e.ProgressLocation=$t={}));var jt;(function(z){function U(re){const ye=re;return(0,v.isNumber)(ye.value)?ye.tooltip&&!(0,v.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=U})(jt||(e.ViewBadge=jt={}));let oi=b=class{static isTreeItem(U,re){const ye=U;if(ye.checkboxState!==void 0){const Ke=(0,v.isNumber)(ye.checkboxState)?ye.checkboxState:(0,v.isObject)(ye.checkboxState)&&(0,v.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,it=!(0,v.isNumber)(ye.checkboxState)&&(0,v.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Ct.Checked&&Ke!==Ct.Unchecked||it!==void 0&&!(0,v.isString)(it))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(U instanceof b)return!0;if(ye.label!==void 0&&!(0,v.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,v.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,v.isString)(ye.iconPath)&&!a.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,v.isString)(ye.iconPath.id))){const Ke=ye.iconPath;if(!Ke||!(0,v.isString)(Ke.light)&&!a.URI.isUri(Ke.light)&&!(0,v.isString)(Ke.dark)&&!a.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,v.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!a.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,v.isString)(ye.tooltip)&&!(ye.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<Pt.None&&ye.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,v.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(U,re=Pt.None){this.collapsibleState=re,a.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.TreeItem=oi,e.TreeItem=oi=b=je([f],oi);var Pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var Ct;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.DataTransferItem=bt,e.DataTransferItem=bt=je([f],bt);class Jt extends bt{}e.InternalDataTransferItem=Jt;class Dt extends Jt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.InternalFileDataTransferItem=Dt;class fi{constructor(U,re,ye,Ke){this.name=U,this.uri=re,this._itemId=ye,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=fi;let Vt=class{#e=new Map;constructor(U){for(const[re,ye]of U??[]){const Ke=this.#e.get(this.#t(re));Ke?Ke.push(ye):this.#e.set(this.#t(re),[ye])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,re){this.#e.set(this.#t(U),[re])}forEach(U,re){for(const[ye,Ke]of this.#e)for(const it of Ke)U.call(re,it,ye,this)}*[Symbol.iterator](){for(const[U,re]of this.#e)for(const ye of re)yield[U,ye]}#t(U){return U.toLowerCase()}};e.DataTransfer=Vt,e.DataTransfer=Vt=je([f],Vt);let bi=class{constructor(U,re,ye){this.insertText=U,this.title=re,this.kind=ye}};e.DocumentDropEdit=bi,e.DocumentDropEdit=bi=je([f],bi);var Si;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Si||(e.DocumentPasteTriggerKind=Si={}));class gi{static{this.sep="."}constructor(U){this.value=U}append(...U){return new gi((this.value?[this.value,...U]:U).join(gi.sep))}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+gi.sep)}}e.DocumentDropOrPasteEditKind=gi,gi.Empty=new gi("");class xt{constructor(U,re,ye){this.title=re,this.insertText=U,this.kind=ye}}e.DocumentPasteEdit=xt;let ai=class{constructor(U,re){this.id=U,this.color=re}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.ThemeIcon=ai,e.ThemeIcon=ai=je([f],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ti=class{constructor(U){this.id=U}};e.ThemeColor=Ti,e.ThemeColor=Ti=je([f],Ti);var At;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Ci=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=a.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,re){if(typeof U!="string"&&(!U||!a.URI.isUri(U)&&!a.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof re!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=a.URI.file(U):a.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ci,e.RelativePattern=Ci=je([f],Ci);const Pi=new WeakMap;function yi(z,U){Pi.set(z,U)}let pi=class{constructor(U,re,ye,Ke,it){this.enabled=typeof U=="boolean"?U:!0,typeof re=="string"&&(this.condition=re),typeof ye=="string"&&(this.hitCondition=ye),typeof Ke=="string"&&(this.logMessage=Ke),typeof it=="string"&&(this.mode=it)}get id(){return this._id||(this._id=Pi.get(this)??(0,k.generateUuid)()),this._id}};e.Breakpoint=pi,e.Breakpoint=pi=je([f],pi);let ki=class extends pi{constructor(U,re,ye,Ke,it,ht){if(super(re,ye,Ke,it,ht),U===null)throw(0,T.illegalArgument)("location");this.location=U}};e.SourceBreakpoint=ki,e.SourceBreakpoint=ki=je([f],ki);let Bt=class extends pi{constructor(U,re,ye,Ke,it,ht){super(re,ye,Ke,it,ht),this.functionName=U}};e.FunctionBreakpoint=Bt,e.FunctionBreakpoint=Bt=je([f],Bt);let we=class extends pi{constructor(U,re,ye,Ke,it,ht,wt,Gt){if(super(Ke,it,ht,wt,Gt),!re)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=re,this.canPersist=ye}};e.DataBreakpoint=we,e.DataBreakpoint=we=je([f],we);let Re=class{constructor(U,re,ye){this.command=U,this.args=re||[],this.options=ye}};e.DebugAdapterExecutable=Re,e.DebugAdapterExecutable=Re=je([f],Re);let ue=class{constructor(U,re){this.port=U,this.host=re}};e.DebugAdapterServer=ue,e.DebugAdapterServer=ue=je([f],ue);let K=class{constructor(U){this.path=U}};e.DebugAdapterNamedPipeServer=K,e.DebugAdapterNamedPipeServer=K=je([f],K);let _e=class{constructor(U){this.implementation=U}};e.DebugAdapterInlineImplementation=_e,e.DebugAdapterInlineImplementation=_e=je([f],_e);class We{constructor(U,re,ye){this.session=U,this.threadId=re,this.frameId=ye}}e.DebugStackFrame=We;class Ye{constructor(U,re){this.session=U,this.threadId=re}}e.DebugThread=Ye;let He=class{constructor(U,re){this.range=U,this.expression=re}};e.EvaluatableExpression=He,e.EvaluatableExpression=He=je([f],He);var ut;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let Tt=class{constructor(U,re){this.range=U,this.text=re}};e.InlineValueText=Tt,e.InlineValueText=Tt=je([f],Tt);let Kt=class{constructor(U,re,ye=!0){this.range=U,this.variableName=re,this.caseSensitiveLookup=ye}};e.InlineValueVariableLookup=Kt,e.InlineValueVariableLookup=Kt=je([f],Kt);let li=class{constructor(U,re){this.range=U,this.expression=re}};e.InlineValueEvaluatableExpression=li,e.InlineValueEvaluatableExpression=li=je([f],li);let Mt=class{constructor(U,re){this.frameId=U,this.stoppedLocation=re}};e.InlineValueContext=Mt,e.InlineValueContext=Mt=je([f],Mt);var ci;(function(z){z[z.AIGenerated=1]="AIGenerated"})(ci||(e.NewSymbolNameTag=ci={}));var $i;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})($i||(e.NewSymbolNameTriggerKind=$i={}));class vn{constructor(U,re){this.newSymbolName=U,this.tags=re}}e.NewSymbolName=vn;var Mi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let Oi=D=class extends Error{static FileExists(U){return new D(U,c.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(U){return new D(U,c.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(U){return new D(U,c.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(U){return new D(U,c.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(U){return new D(U,c.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(U){return new D(U,c.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(U,re=c.FileSystemProviderErrorCode.Unknown,ye){super(a.URI.isUri(U)?U.toString(!0):U),this.code=ye?.name??"Unknown",(0,c.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.FileSystemError=Oi,e.FileSystemError=Oi=D=je([f],Oi);let Vi=class{constructor(U,re,ye){this.start=U,this.end=re,this.kind=ye}};e.FoldingRange=Vi,e.FoldingRange=Vi=je([f],Vi);var Ji;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Di;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Di||(e.CommentThreadCollapsibleState=Di={}));var Zi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var en;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Fi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Fi||(e.CommentThreadState=Fi={}));var tn;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Hi{constructor(U,re=[]){this.tokenTypes=U,this.tokenModifiers=re}}e.SemanticTokensLegend=Hi;function nn(z){return typeof z>"u"||(0,v.isStringArray)(z)}class qi{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let re=0,ye=U.tokenTypes.length;re<ye;re++)this._tokenTypeStrToInt.set(U.tokenTypes[re],re);for(let re=0,ye=U.tokenModifiers.length;re<ye;re++)this._tokenModifierStrToInt.set(U.tokenModifiers[re],re)}}push(U,re,ye,Ke,it){if(typeof U=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this._pushEncoded(U,re,ye,Ke,it);if(V.isRange(U)&&typeof re=="string"&&nn(ye))return this._push(U,re,ye);throw(0,T.illegalArgument)()}_push(U,re,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,it=U.start.character,ht=U.end.character-U.start.character,wt=this._tokenTypeStrToInt.get(re);let Gt=0;if(ye)for(const vi of ye){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this._tokenModifierStrToInt.get(vi);Gt|=1<<Ei>>>0}this._pushEncoded(Ke,it,ht,wt,Gt)}_pushEncoded(U,re,ye,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Gt=this._data.length/5|0;let vi=0,Ei=0;for(let _i=0;_i<Gt;_i++){let Ii=this._data[5*_i],Qi=this._data[5*_i+1];Ii===0?(Ii=vi,Qi+=Ei):Ii+=vi,this._data[5*_i]=Ii,this._data[5*_i+1]=Qi,vi=Ii,Ei=Qi}}let ht=U,wt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(wt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=wt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=U,this._prevChar=re}static _sortAndDeltaEncode(U){const re=[],ye=U.length/5|0;for(let wt=0;wt<ye;wt++)re[wt]=wt;re.sort((wt,Gt)=>{const vi=U[5*wt],Ei=U[5*Gt];if(vi===Ei){const _i=U[5*wt+1],Ii=U[5*Gt+1];return _i-Ii}return vi-Ei});const Ke=new Uint32Array(U.length);let it=0,ht=0;for(let wt=0;wt<ye;wt++){const Gt=5*re[wt],vi=U[Gt+0],Ei=U[Gt+1],_i=U[Gt+2],Ii=U[Gt+3],Qi=U[Gt+4],Bn=vi-it,Dr=Bn===0?Ei-ht:Ei,Yi=5*wt;Ke[Yi+0]=Bn,Ke[Yi+1]=Dr,Ke[Yi+2]=_i,Ke[Yi+3]=Ii,Ke[Yi+4]=Qi,it=vi,ht=Ei}return Ke}build(U){return this._dataIsSortedAndDeltaEncoded?new Ui(new Uint32Array(this._data),U):new Ui(qi._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=qi;class Ui{constructor(U,re){this.resultId=re,this.data=U}}e.SemanticTokens=Ui;class En{constructor(U,re,ye){this.start=U,this.deleteCount=re,this.data=ye}}e.SemanticTokensEdit=En;class Li{constructor(U,re){this.resultId=re,this.edits=U}}e.SemanticTokensEdits=Li;var rn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(U){this.name=U}}e.DebugVisualization=bn;let ji=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.QuickInputButtons=ji,e.QuickInputButtons=ji=je([f],ji);var xi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var Ki;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Ki||(e.InputBoxValidationSeverity=Ki={}));var Fe;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Fe||(e.ExtensionKind=Fe={}));class wi{static validate(U){if(typeof U.badge=="string"){let re=(0,R.nextCharLength)(U.badge,0);if(re<U.badge.length&&(re+=(0,R.nextCharLength)(U.badge,re)),U.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!ai.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,re,ye){this.badge=U,this.tooltip=re,this.color=ye}}e.FileDecoration=wi;let Bi=class{constructor(U){this.kind=U}};e.ColorTheme=Bi,e.ColorTheme=Bi=je([f],Bi);var ot;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class Et{static isNotebookRange(U){return U instanceof Et?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,re){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(re<0)throw(0,T.illegalArgument)("end must be positive");U<=re?(this._start=U,this._end=re):(this._start=re,this._end=U)}with(U){let re=this._start,ye=this._end;return U.start!==void 0&&(re=U.start),U.end!==void 0&&(ye=U.end),re===this._start&&ye===this._end?this:new Et(re,ye)}}e.NotebookRange=Et;class zi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(re=>zi.isNotebookCellData(re))}static isNotebookCellData(U){return!0}constructor(U,re,ye,Ke,it,ht,wt){this.kind=U,this.value=re,this.languageId=ye,this.mime=Ke,this.outputs=it??[],this.metadata=ht,this.executionSummary=wt,zi.validate(this)}}e.NotebookCellData=zi;class Sn{constructor(U){this.cells=U}}e.NotebookData=Sn;class mi{static isNotebookCellOutputItem(U){return U instanceof mi?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const re={name:U.name,message:U.message,stack:U.stack};return mi.json(re,"application/vnd.code.notebook.error")}static stdout(U){return mi.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return mi.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,re="application/octet-stream"){return new mi(U,re)}static#e=new TextEncoder;static text(U,re=A.Mimes.text){const ye=mi.#e.encode(String(U));return new mi(ye,re)}static json(U,re="text/x-json"){const ye=JSON.stringify(U,void 0,"	");return mi.text(ye,re)}constructor(U,re){this.data=U,this.mime=re;const ye=(0,A.normalizeMimeType)(re,!0);if(!ye)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.NotebookCellOutputItem=mi;class Wi{static isNotebookCellOutput(U){return U instanceof Wi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,re=!1){const ye=new Set,Ke=new Set;for(let it=0;it<U.length;it++){const ht=U[it],wt=(0,A.normalizeMimeType)(ht.mime);if(!ye.has(wt)||(0,h.isTextStreamMime)(wt)){ye.add(wt);continue}Ke.add(it),re&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?U:U.filter((it,ht)=>!Ke.has(ht))}constructor(U,re,ye){this.items=Wi.ensureUniqueMimeTypes(U,!0),typeof re=="string"?(this.id=re,this.metadata=ye):(this.id=(0,k.generateUuid)(),this.metadata=re??ye)}}e.NotebookCellOutput=Wi;var Ni;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Ni||(e.NotebookCellKind=Ni={}));var sn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class ln{constructor(U,re){this.text=U,this.alignment=re}}e.NotebookCellStatusBarItem=ln;var cn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class wn{constructor(U,re=[]){this.uri=U,this.provides=(0,S.asArray)(re)}}e.NotebookRendererScript=wn;class _n{constructor(U){this.label=U}}e.NotebookKernelSourceAction=_n;var dn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(dn||(e.NotebookVariablesRequestKind=dn={}));let Gi=class{constructor(U,re){this.label=U,this.timestamp=re}};e.TimelineItem=Gi,e.TimelineItem=Gi=je([f],Gi);var hn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var fn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Cn{constructor(U,re){this.ranges=U,this.wordPattern=re}}e.LinkedEditingRanges=Cn;class yn{constructor(U){this._autoForwardAction=U}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=yn;var ie;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(ie||(e.TestResultState=ie={}));var de;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let Ne=class{constructor(U=void 0,re=void 0,ye=void 0,Ke=!1,it=!0){this.include=U,this.exclude=re,this.profile=ye,this.continuous=Ke,this.preserveFocus=it}};e.TestRunRequest=Ne,e.TestRunRequest=Ne=je([f],Ne);let at=P=class{static diff(U,re,ye){const Ke=new P(U);return Ke.expectedOutput=re,Ke.actualOutput=ye,Ke}constructor(U){this.message=U}};e.TestMessage=at,e.TestMessage=at=P=je([f],at);let _t=class{constructor(U){this.id=U}};e.TestTag=_t,e.TestTag=_t=je([f],_t);class Rt{constructor(U,re){this.covered=U,this.total=re,Ai(this)}}e.TestCoverageCount=Rt;function Ai(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Xi{static fromDetails(U,re){const ye=new Rt(0,0),Ke=new Rt(0,0),it=new Rt(0,0);for(const wt of re)if("branches"in wt){ye.total+=1,ye.covered+=wt.executed?1:0;for(const Gt of wt.branches)Ke.total+=1,Ke.covered+=Gt.executed?1:0}else it.total+=1,it.covered+=wt.executed?1:0;const ht=new Xi(U,ye,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return ht.detailedCoverage=re,ht}constructor(U,re,ye,Ke,it=[]){this.uri=U,this.statementCoverage=re,this.branchCoverage=ye,this.declarationCoverage=Ke,this.fromTests=it}}e.FileCoverage=Xi;class $n{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,ye=[]){this.executed=U,this.location=re,this.branches=ye}}e.StatementCoverage=$n;class Vn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,ye){this.executed=U,this.location=re,this.label=ye}}e.BranchCoverage=Vn;class Hn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,ye){this.name=U,this.executed=re,this.location=ye}}e.DeclarationCoverage=Hn;var Dn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var In;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Tn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class qn{constructor(U,re,ye,Ke,it,ht){this.kind=U,this.name=re,this.detail=ye,this.uri=Ke,this.range=it,this.selectionRange=ht}}e.TypeHierarchyItem=qn;class jn{constructor(U){this.uri=U}}e.TextTabInput=jn;class Kn{constructor(U,re){this.original=U,this.modified=re}}e.TextDiffTabInput=Kn;class Gn{constructor(U,re,ye,Ke){this.base=U,this.input1=re,this.input2=ye,this.result=Ke}}e.TextMergeTabInput=Gn;class Xn{constructor(U,re){this.uri=U,this.viewType=re}}e.CustomEditorTabInput=Xn;class Qn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Qn;class Yn{constructor(U,re){this.uri=U,this.notebookType=re}}e.NotebookEditorTabInput=Yn;class Jn{constructor(U,re,ye){this.original=U,this.modified=re,this.notebookType=ye}}e.NotebookDiffEditorTabInput=Jn;class Zn{constructor(){}}e.TerminalEditorTabInput=Zn;class er{constructor(U,re){this.uri=U,this.inputBoxUri=re}}e.InteractiveWindowInput=er;class tr{constructor(){}}e.ChatEditorTabInput=tr;class ir{constructor(U){this.textDiffs=U}}e.TextMultiDiffTabInput=ir;var Pn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var kn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var An;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(U,re,ye){this.id=U,this.label=re,this.values=ye}}e.ChatCompletionItem=nr;var Rn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Rn||(e.InteractiveEditorResponseFeedbackKind=Rn={}));var On;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(On||(e.ChatResultFeedbackKind=On={}));class rr{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new qe(U):U}}e.ChatResponseMarkdownPart=rr;class sr{constructor(U,re){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new qe(U):U,this.vulnerabilities=re}}e.ChatResponseMarkdownWithVulnerabilitiesPart=sr;class or{constructor(U,re){this.participant=U,this.command=re}}e.ChatResponseDetectedParticipantPart=or;class ar{constructor(U,re,ye){this.title=U,this.message=re,this.data=ye}}e.ChatResponseConfirmationPart=ar;class lr{constructor(U,re){this.value=U,this.baseUri=re}}e.ChatResponseFileTreePart=lr;class cr{constructor(U,re){this.value=U,this.title=re}}e.ChatResponseAnchorPart=cr;class ur{constructor(U){this.value=U}}e.ChatResponseProgressPart=ur;class dr{constructor(U,re){this.value=U,this.task=re}}e.ChatResponseProgressPart2=dr;class hr{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new qe(U):U}}e.ChatResponseWarningPart=hr;class fr{constructor(U){this.value=U}}e.ChatResponseCommandButtonPart=fr;class gr{constructor(U,re){this.value=U,this.iconPath=re}}e.ChatResponseReferencePart=gr;class mr{constructor(U,re){this.uri=U,this.edits=Array.isArray(re)?re:[re]}}e.ChatResponseTextEditPart=mr;class pr{constructor(U,re,ye,Ke){this.prompt=U,this.command=re,this.references=ye,this.participant=Ke}}e.ChatRequestTurn=pr;class vr{constructor(U,re,ye,Ke){this.response=U,this.result=re,this.participant=ye,this.command=Ke}}e.ChatResponseTurn=vr;var Ln;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Ln||(e.ChatLocation=Ln={}));var mn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class Er{constructor(U,re,ye){this.name=U,this.content=re,this.isError=ye??!1}}e.LanguageModelFunctionResultPart=Er;class pn{static User(U,re){const ye=new pn(mn.User,typeof U=="string"?U:"",re);return ye.content2=U,ye}static Assistant(U,re){return new pn(mn.Assistant,U,re)}constructor(U,re,ye){this.role=U,this.content=re,this.content2=re,this.name=ye}}e.LanguageModelChatMessage=pn;class br{constructor(U,re){this.name=U,this.parameters=re}}e.LanguageModelFunctionUsePart=br;class Sr{constructor(U){this.value=U}}e.LanguageModelTextPart=Sr;class wr{constructor(U){this.content=U}}e.LanguageModelChatSystemMessage=wr;class _r{constructor(U,re){this.content=U,this.name=re}}e.LanguageModelChatUserMessage=_r;class Cr{constructor(U,re){this.content=U,this.name=re}}e.LanguageModelChatAssistantMessage=Cr;class Ri extends Error{static NotFound(U){return new Ri(U,Ri.NotFound.name)}static NoPermissions(U){return new Ri(U,Ri.NoPermissions.name)}static Blocked(U){return new Ri(U,Ri.Blocked.name)}constructor(U,re,ye){super(U,{cause:ye}),this.name="LanguageModelError",this.code=re??""}}e.LanguageModelError=Ri;var Nn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Mn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Mn||(e.SpeechToTextStatus=Mn={}));var Fn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var Un;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Un||(e.KeywordRecognitionStatus=Un={}));class yr{constructor(U,re){this.text=U,this.range=re}}e.InlineEdit=yr;var xn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(xn||(e.InlineEditTriggerKind=xn={}))}),define(Te[269],Pe([1,0,5,7]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class I{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(S.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,R,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const a=this._relatedInformationProviders.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(R,v)??[]}getRelatedInformation(A,R,v){return this._proxy.$getAiRelatedInformation(R,v)}registerRelatedInformationProvider(A,R,v){const a=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(a,v),this._proxy.$registerAiRelatedInformationProvider(a,R),new T.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(a),this._relatedInformationProviders.delete(a)})}}e.ExtHostRelatedInformation=I}),define(Te[91],Pe([1,0,6,5,7,19,117,3,17]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let a=class{constructor(c){this._authenticationProviders=new Map,this._onDidChangeSessions=new S.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new k,this._proxy=c.getProxy(T.MainContext.MainThreadAuthentication)}async getSession(c,_,h,n={}){const s=O.ExtensionIdentifier.toKey(c.identifier),o=[...h].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${s} ${_} ${o}`,async()=>{await this._proxy.$ensureProvider(_);const d=c.displayName||c.name;return this._proxy.$getSession(_,h,s,d,n)})}async getAccounts(c){return await this._proxy.$ensureProvider(c),await this._proxy.$getAccounts(c)}async removeSession(c,_){const h=this._authenticationProviders.get(c);return h?h.provider.removeSession(_):this._proxy.$removeSession(c,_)}registerAuthenticationProvider(c,_,h,n){if(this._authenticationProviders.get(c))throw new Error(`An authentication provider with id '${c}' is already registered.`);this._authenticationProviders.set(c,{label:_,provider:h,options:n??{supportsMultipleAccounts:!1}});const s=h.onDidChangeSessions(o=>this._proxy.$sendDidChangeSessions(c,o));return this._proxy.$registerAuthenticationProvider(c,_,n?.supportsMultipleAccounts??!1),new I.Disposable(()=>{s.dispose(),this._authenticationProviders.delete(c),this._proxy.$unregisterAuthenticationProvider(c)})}async $createSession(c,_,h){const n=this._authenticationProviders.get(c);if(n)return await n.provider.createSession(_,h);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $removeSession(c,_){const h=this._authenticationProviders.get(c);if(h)return await h.provider.removeSession(_);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $getSessions(c,_,h){const n=this._authenticationProviders.get(c);if(n)return await n.provider.getSessions(_,h);throw new Error(`Unable to find authentication provider with handle: ${c}`)}$onDidChangeAuthenticationSessions(c,_){return c.startsWith(A.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:c,label:_}}),Promise.resolve()}};e.ExtHostAuthentication=a,e.ExtHostAuthentication=a=je([Ve(0,v.IExtHostRpcService)],a);class k{constructor(){this._inFlightPromises=new Map}getOrCreate(c,_){const h=this._inFlightPromises.get(c);if(h)return h;const n=_().finally(()=>this._inFlightPromises.delete(c));return this._inFlightPromises.set(c,n),n}}}),define(Te[122],Pe([1,0,2,5,7,3,17,12,18,13,20,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class{static{c=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(n,s){this._logService=s,this._provider=new Map,this._proxy=n.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(n,s){const o=c._handlePool++;this._provider.set(o,{provider:n,extensionDescription:s}),this._proxy.$registerDecorationProvider(o,s.identifier.value);const d=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(o,null);return}const r=(0,v.asArray)(i);if(r.length<=c._maxEventSize){this._proxy.$onDidChange(o,r);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,r.length);const t=r.map(g=>({uri:g,rank:(0,a.count)(g.path,"/")})),l=(0,v.groupBy)(t,(g,m)=>g.rank-m.rank||(0,a.compare)(g.uri.path,m.uri.path)),u=[];e:for(const g of l){let m;for(const p of g){const y=(0,k.dirname)(p.uri.path);if(m!==y&&(m=y,u.push(p.uri)>=c._maxEventSize))break e}}this._proxy.$onDidChange(o,u)});return new I.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(n,s,o){if(!this._provider.has(n))return Object.create(null);const d=Object.create(null),{provider:i,extensionDescription:r}=this._provider.get(n);return await Promise.all(s.map(async t=>{try{const{uri:l,id:u}=t,g=await Promise.resolve(i.provideFileDecoration(S.URI.revive(l),o));if(!g)return;try{I.FileDecoration.validate(g),g.badge&&typeof g.badge!="string"&&(0,w.checkProposedApiEnabled)(r,"codiconDecoration"),d[u]=[g.propagate,g.tooltip,g.badge,g.color]}catch(m){this._logService.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(l){this._logService.error(l)}})),d}};e.ExtHostDecorations=_,e.ExtHostDecorations=_=c=je([Ve(0,A.IExtHostRpcService),Ve(1,R.ILogService)],_),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(Te[270],Pe([1,0,14,2,7,5,16,22,13]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class a{static{this._handlePool=0}constructor(w,c,_){this._documentsAndEditors=c,this._logService=_,this._documentContentProviders=new Map,this._proxy=w.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,c){if(Object.keys(A.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const _=a._handlePool++;this._documentContentProviders.set(_,c),this._proxy.$registerTextContentProvider(_,w);let h;if(typeof c.onDidChange=="function"){let n;h=c.onDidChange(async s=>{if(s.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(s))return;n&&await n;const o=this.$provideTextDocumentContent(_,s).then(async d=>{if(!d&&typeof d!="string")return;const i=this._documentsAndEditors.getDocument(s);if(!i)return;const r=(0,v.splitLines)(d);if(!i.equalLines(r))return this._proxy.$onVirtualDocumentChange(s,d)}).catch(S.onUnexpectedError).finally(()=>{n===o&&(n=void 0)});n=o})}return new I.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(w,c){const _=this._documentContentProviders.get(w);return _?Promise.resolve(_.provideTextDocumentContent(T.URI.revive(c),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=a}),define(Te[123],Pe([1,0,62,16,13,326,210,7,18]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=k;const a=new Map;function k(h,n){n?a.set(h,n):a.delete(h)}function w(h){return a.get(h)}class c extends O.MirrorTextModel{constructor(n,s,o,d,i,r,t){super(s,o,d,i),this._proxy=n,this._languageId=r,this._isDirty=t,this._isDisposed=!1}dispose(){(0,S.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,v.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===T.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},save(){return n._save()},getText(s){return s?n._getTextInRange(s):n.getText()},get eol(){return n._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(s){return n._lineAt(s)},offsetAt(s){return n._offsetAt(s)},positionAt(s){return n._positionAt(s)},validateRange(s){return n._validateRange(s)},validatePosition(s){return n._validatePosition(s)},getWordRangeAtPosition(s,o){return n._getWordRangeAtPosition(s,o)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,S.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,S.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const s=this._validateRange(n);if(s.isEmpty)return"";if(s.isSingleLine)return this._lines[s.start.line].substring(s.start.character,s.end.character);const o=this._eol,d=s.start.line,i=s.end.line,r=[];r.push(this._lines[d].substring(s.start.character));for(let t=d+1;t<i;t++)r.push(this._lines[t]);return r.push(this._lines[i].substring(0,s.end.character)),r.join(o)}_lineAt(n){let s;if(n instanceof R.Position?s=n.line:typeof n=="number"&&(s=n),typeof s!="number"||s<0||s>=this._lines.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new _(s,this._lines[s],s===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(n),o=this._lines[s.index].length;return new R.Position(s.index,Math.min(s.remainder,o))}_validateRange(n){if(!(n instanceof R.Range))throw new Error("Invalid argument");const s=this._validatePosition(n.start),o=this._validatePosition(n.end);return s===n.start&&o===n.end?n:new R.Range(s.line,s.character,o.line,o.character)}_validatePosition(n){if(!(n instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:s,character:o}=n,d=!1;if(s<0)s=0,o=0,d=!0;else if(s>=this._lines.length)s=this._lines.length-1,o=this._lines[s].length,d=!0;else{const i=this._lines[s].length;o<0?(o=0,d=!0):o>i&&(o=i,d=!0)}return d?new R.Position(s,o):n}_getWordRangeAtPosition(n,s){const o=this._validatePosition(n);if(!s)s=w(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const d=(0,A.getWordAtText)(o.character+1,(0,A.ensureValidWordDefinition)(s),this._lines[o.line],0);if(d)return new R.Range(o.line,d.startColumn-1,o.line,d.endColumn-1)}}e.ExtHostDocumentData=c;class _{constructor(n,s,o){this._line=n,this._text=s,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(Te[271],Pe([1,0,5,7]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class I{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(S.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,R,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const a=this._AiEmbeddingVectorProviders.get(A);if(!a)throw new Error("Embedding vector provider not found");const k=await a.provideEmbeddingVector(R,v);if(!k)throw new Error("Embedding vector provider returned undefined");return k}registerEmbeddingVectorProvider(A,R,v){const a=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(a,v),this._proxy.$registerAiEmbeddingVectorProvider(R,a),new T.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(a),this._AiEmbeddingVectorProviders.delete(a)})}}e.ExtHostAiEmbeddingVector=I}),define(Te[69],Pe([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,T=$e(T);let h=_=class{constructor(s,o){this._fileSystemProvider=new Map,this._writeQueue=new k.ResourceQueue,this._proxy=s.getProxy(S.MainContext.MainThreadFileSystem);const d=this;this.value=Object.freeze({async stat(i){try{let r;const t=d._fileSystemProvider.get(i.scheme);return t?(await d._proxy.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await d._proxy.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===T.FilePermission.Readonly?1:void 0}}catch(r){_._handleError(r)}},async readDirectory(i){try{const r=d._fileSystemProvider.get(i.scheme);return r?(await d._proxy.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await d._proxy.$readdir(i)}catch(r){return _._handleError(r)}},async createDirectory(i){try{const r=d._fileSystemProvider.get(i.scheme);return r&&!r.isReadonly?(await d._proxy.$ensureActivation(i.scheme),await d.mkdirp(r.impl,r.extUri,i)):await d._proxy.$mkdir(i)}catch(r){return _._handleError(r)}},async readFile(i){try{const r=d._fileSystemProvider.get(i.scheme);return r?(await d._proxy.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await d._proxy.$readFile(i)).buffer}catch(r){return _._handleError(r)}},async writeFile(i,r){try{const t=d._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly?(await d._proxy.$ensureActivation(i.scheme),await d.mkdirp(t.impl,t.extUri,t.extUri.dirname(i)),await d._writeQueue.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await d._proxy.$writeFile(i,O.VSBuffer.wrap(r))}catch(t){return _._handleError(t)}},async delete(i,r){try{const t=d._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await d._proxy.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await d._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return _._handleError(t)}},async rename(i,r,t){try{return await d._proxy.$rename(i,r,{overwrite:!1,...t})}catch(l){return _._handleError(l)}},async copy(i,r,t){try{return await d._proxy.$copy(i,r,{overwrite:!1,...t})}catch(l){return _._handleError(l)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&T.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(s,o,d){const i=[];for(;!o.isEqual(d,o.dirname(d));)try{if(!((await s.stat(d)).type&T.FileType.Directory))throw I.FileSystemError.FileExists(`Unable to create folder '${d.scheme===c.Schemas.file?d.fsPath:d.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(T.toFileSystemProviderErrorCode(r)!==T.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(d)),d=o.dirname(d)}for(let r=i.length-1;r>=0;r--){d=o.joinPath(d,i[r]);try{await s.createDirectory(d)}catch(t){if(T.toFileSystemProviderErrorCode(t)!==T.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(s){if(s instanceof I.FileSystemError)throw s;if(s instanceof T.FileSystemProviderError)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(s.message);default:throw new I.FileSystemError(s.message,s.name)}if(!(s instanceof Error))throw new I.FileSystemError(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw I.FileSystemError.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(s.message);default:throw new I.FileSystemError(s.message,s.name)}}addFileSystemProvider(s,o,d){return this._fileSystemProvider.set(s,{impl:o,extUri:d?.isCaseSensitive?w.extUri:w.extUriIgnorePathCase,isReadonly:!!d?.isReadonly}),(0,a.toDisposable)(()=>this._fileSystemProvider.delete(s))}getFileSystemProviderExtUri(s){return this._fileSystemProvider.get(s)?.extUri??w.extUri}};e.ExtHostConsumerFileSystem=h,e.ExtHostConsumerFileSystem=h=_=je([Ve(0,R.IExtHostRpcService),Ve(1,v.IExtHostFileSystemInfo)],h),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[92],Pe([1,0,3,27,12,69,2]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,S.createDecorator)("IExtensionStoragePaths");let R=class{constructor(a,k,w){this._logService=k,this._extHostFileSystem=w,this._workspace=a.workspace??void 0,this._environment=a.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(a){return A.URI.joinPath(this._environment.workspaceStorageHome,a)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const a=this._workspace.id,k=await this._getWorkspaceStorageURI(a);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),k}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(a){if(this._value)return A.URI.joinPath(this._value,a.identifier.value)}globalValue(a){return A.URI.joinPath(this._environment.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=je([Ve(0,T.IExtHostInitDataService),Ve(1,I.ILogService),Ve(2,O.IExtHostConsumerFileSystem)],R)}),define(Te[272],Pe([1,0,7,17,6]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(R){this._actual=new S.ColorTheme(S.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let v;switch(R){case"light":v=S.ColorThemeKind.Light;break;case"hcDark":v=S.ColorThemeKind.HighContrast;break;case"hcLight":v=S.ColorThemeKind.HighContrastLight;break;default:v=S.ColorThemeKind.Dark}this._actual=new S.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=je([Ve(0,T.IExtHostRpcService)],O)}),define(Te[93],Pe([1,0,22,6,4,191,3,12,224,5,27,17,7]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,O=$e(O),c=$e(c);class _ extends v.DisposableTunnel{}var h;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function d(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==v.TunnelPrivacyId.ConstantPrivate&&i.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=d})(h||(e.TunnelDtoConverter=h={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let n=class extends I.Disposable{constructor(o,d,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new T.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(a.MainContext.MainThreadTunnelService)}async openTunnel(o,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(d,o.displayName);if(i){const r=new _(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(r),r}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,d){o.portRange===void 0&&o.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:o,provider:d}),this._proxy.$registerPortsAttributesProvider(o,i),new c.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,d,i,r,t){const l=[];for(const g of o){const m=this._portAttributesProviders.get(g);if(!m)return[];l.push(...await Promise.all(d.map(async p=>{let y;try{y=await m.provider.providePortAttributes({port:p,pid:i,commandLine:r},t)}catch{y=await m.provider.providePortAttributes(p,i,r,t)}return{providedAttributes:y,port:p}})))}const u=l.filter(g=>!!g.providedAttributes);return u.length>0?u.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,d){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(r,t)=>await o.provideTunnel(r,t,S.CancellationToken.None)??void 0;const i=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,privacyOptions:d.tunnelFeatures?.privacyOptions,protocol:d.tunnelFeatures.protocol===void 0?!0:d.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,I.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,d){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const i=o.tunnelFactory??(d?this.makeManagedTunnelFactory(d):void 0);if(i){this._forwardPortProvider=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,d){if(this._extensionTunnels.has(o.host)){const i=this._extensionTunnels.get(o.host);i.has(o.port)&&(d&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(o,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const t=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:t}),h.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const d=await Promise.all(o.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),i=o.filter((r,t)=>d[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.ExtHostTunnelService=n,e.ExtHostTunnelService=n=je([Ve(0,w.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,R.ILogService)],n)}),define(Te[8],Pe([1,0,18,23,148,273,60,29,137,49,73,26,143,24,35,15,2,106,33,152,94,52,108,77,116,115,235,249,81,90,55,56,246,7]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m,p,y,C,b,D,P,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=le,e.fromRangeOrRangeWithMessage=oe,e.pathOrURIToURI=Ie,A=$e(A),d=$e(d),i=$e(i),r=$e(r),y=$e(y),b=$e(b),E=$e(E);var F;(function(we){function Re(K){const{selectionStartLineNumber:_e,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:He}=K,ut=new E.Position(_e-1,We-1),Tt=new E.Position(Ye-1,He-1);return new E.Selection(ut,Tt)}we.to=Re;function ue(K){const{anchor:_e,active:We}=K;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}we.from=ue})(F||(e.Selection=F={}));var L;(function(we){function Re(K){if(!K)return;const{start:_e,end:We}=K;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}we.from=Re;function ue(K){if(!K)return;const{startLineNumber:_e,startColumn:We,endLineNumber:Ye,endColumn:He}=K;return new E.Range(_e-1,We-1,Ye-1,He-1)}we.to=ue})(L||(e.Range=L={}));var M;(function(we){function Re(K){return{uri:K.uri,range:L.from(K.range)}}we.from=Re;function ue(K){return new E.Location(s.URI.revive(K.uri),L.to(K.range))}we.to=ue})(M||(e.Location=M={}));var V;(function(we){function Re(ue){switch(ue){case i.StandardTokenType.Comment:return E.StandardTokenType.Comment;case i.StandardTokenType.Other:return E.StandardTokenType.Other;case i.StandardTokenType.RegEx:return E.StandardTokenType.RegEx;case i.StandardTokenType.String:return E.StandardTokenType.String}}we.to=Re})(V||(e.TokenType=V={}));var W;(function(we){function Re(K){return new E.Position(K.lineNumber-1,K.column-1)}we.to=Re;function ue(K){return{lineNumber:K.line+1,column:K.character+1}}we.from=ue})(W||(e.Position=W={}));var N;(function(we){function Re(_e,We,Ye){return(0,S.coalesce)((0,S.asArray)(_e).map(He=>ue(He,We,Ye)))}we.from=Re;function ue(_e,We,Ye){if(typeof _e=="string")return{$serialized:!0,language:_e,isBuiltin:Ye?.isBuiltin};if(_e)return{$serialized:!0,language:_e.language,scheme:K(_e.scheme,We),pattern:Je.from(_e.pattern)??void 0,exclusive:_e.exclusive,notebookType:_e.notebookType,isBuiltin:Ye?.isBuiltin}}function K(_e,We){return We&&typeof _e=="string"?We.transformOutgoingScheme(_e):_e}})(N||(e.DocumentSelector=N={}));var Q;(function(we){function Re(K){switch(K){case E.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case E.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}we.from=Re;function ue(K){switch(K){case l.MarkerTag.Unnecessary:return E.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return E.DiagnosticTag.Deprecated;default:return}}we.to=ue})(Q||(e.DiagnosticTag=Q={}));var Y;(function(we){function Re(K){let _e;return K.code&&((0,n.isString)(K.code)||(0,n.isNumber)(K.code)?_e=String(K.code):_e={value:String(K.code.value),target:K.code.target}),{...L.from(K.range),message:K.message,source:K.source,code:_e,severity:Z.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ge.from),tags:Array.isArray(K.tags)?(0,S.coalesce)(K.tags.map(Q.from)):void 0}}we.from=Re;function ue(K){const _e=new E.Diagnostic(L.to(K),K.message,Z.to(K.severity));return _e.source=K.source,_e.code=(0,n.isString)(K.code)?K.code:K.code?.value,_e.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ge.to),_e.tags=K.tags&&(0,S.coalesce)(K.tags.map(Q.to)),_e}we.to=ue})(Y||(e.Diagnostic=Y={}));var ge;(function(we){function Re(K){return{...L.from(K.location.range),message:K.message,resource:K.location.uri}}we.from=Re;function ue(K){return new E.DiagnosticRelatedInformation(new E.Location(K.resource,L.to(K)),K.message)}we.to=ue})(ge||(e.DiagnosticRelatedInformation=ge={}));var Z;(function(we){function Re(K){switch(K){case E.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}we.from=Re;function ue(K){switch(K){case l.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}we.to=ue})(Z||(e.DiagnosticSeverity=Z={}));var me;(function(we){function Re(K){return typeof K=="number"&&K>=E.ViewColumn.One?K-1:K===E.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}we.from=Re;function ue(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ue})(me||(e.ViewColumn=me={}));function se(we){return typeof we.range<"u"}function le(we){return we.length===0?!0:!!se(we[0])}var Ee;(function(we){function Re(He){return He.map(we.from)}we.fromMany=Re;function ue(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function K(He){let ut;if(ue(He)){const{language:Mt,value:ci}=He;ut={value:"```"+Mt+`
`+ci+"\n```\n"}}else E.MarkdownString.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const Tt=Object.create(null);ut.uris=Tt;const Kt=Mt=>{try{let ci=s.URI.parse(Mt,!0);ci=ci.with({query:_e(ci.query,Tt)}),Tt[Mt]=ci}catch{}return""},li=new v.marked.Renderer;return li.link=Kt,li.image=Mt=>typeof Mt=="string"?Kt(A.parseHrefAndDimensions(Mt).href):"",(0,v.marked)(ut.value,{renderer:li}),ut}we.from=K;function _e(He,ut){if(!He)return He;let Tt;try{Tt=(0,a.parse)(He)}catch{}if(!Tt)return He;let Kt=!1;return Tt=(0,w.cloneAndChange)(Tt,li=>{if(s.URI.isUri(li)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Mt]=li,Kt=!0,Mt}else return}),Kt?JSON.stringify(Tt):He}function We(He){const ut=new E.MarkdownString(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?s.URI.from(He.baseUri):void 0,ut}we.to=We;function Ye(He){if(He)return typeof He=="string"?He:we.from(He)}we.fromStrict=Ye})(Ee||(e.MarkdownString=Ee={}));function oe(we){return le(we)?we.map(Re=>({range:L.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?Ee.fromMany(Re.hoverMessage):Re.hoverMessage?Ee.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):we.map(Re=>({range:L.from(Re)}))}function Ie(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var Me;(function(we){function Re(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?Ie(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}we.from=Re})(Me||(e.ThemableDecorationAttachmentRenderOptions=Me={}));var X;(function(we){function Re(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Ie(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Me.from(ue.before):void 0,after:ue.after?Me.from(ue.after):void 0}}we.from=Re})(X||(e.ThemableDecorationRenderOptions=X={}));var $;(function(we){function Re(ue){if(typeof ue>"u")return ue;switch(ue){case E.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case E.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}we.from=Re})($||(e.DecorationRangeBehavior=$={}));var te;(function(we){function Re(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?$.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?X.from(ue.light):void 0,dark:ue.dark?X.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Ie(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Me.from(ue.before):void 0,after:ue.after?Me.from(ue.after):void 0}}we.from=Re})(te||(e.DecorationRenderOptions=te={}));var Se;(function(we){function Re(K){return{text:K.newText,eol:K.newEol&&Be.from(K.newEol),range:L.from(K.range)}}we.from=Re;function ue(K){const _e=new E.TextEdit(L.to(K.range),K.text);return _e.newEol=typeof K.eol>"u"?void 0:Be.to(K.eol),_e}we.to=ue})(Se||(e.TextEdit=Se={}));var ce;(function(we){function Re(K,_e){const We={edits:[]};if(K instanceof E.WorkspaceEdit){const Ye=new R.ResourceSet;for(const He of K._allEntries())He._type===E.FileEditType.File&&s.URI.isUri(He.to)&&He.from===void 0&&Ye.add(He.to);for(const He of K._allEntries())if(He._type===E.FileEditType.File){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,T.encodeBase64)(T.VSBuffer.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),We.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===E.FileEditType.Text?We.edits.push({resource:He.uri,textEdit:Se.from(He.edit),versionId:Ye.has(He.uri)?void 0:_e?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===E.FileEditType.Snippet?We.edits.push({resource:He.uri,textEdit:{range:L.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ye.has(He.uri)?void 0:_e?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===E.FileEditType.Cell?We.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:_e?.getNotebookDocumentVersion(He.uri)}):He._type===E.FileEditType.CellReplace&&We.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:_e?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:b.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(Qe.from)}})}return We}we.from=Re;function ue(K){const _e=new E.WorkspaceEdit,We=new R.ResourceMap;for(const Ye of K.edits)if(Ye.textEdit){const He=Ye,ut=s.URI.revive(He.resource),Tt=L.to(He.textEdit.range),Kt=He.textEdit.text,li=He.textEdit.insertAsSnippet;let Mt;li?Mt=E.SnippetTextEdit.replace(Tt,new E.SnippetString(Kt)):Mt=E.TextEdit.replace(Tt,Kt);const ci=We.get(ut);ci?ci.push(Mt):We.set(ut,[Mt])}else _e.renameFile(s.URI.revive(Ye.oldResource),s.URI.revive(Ye.newResource),Ye.options);for(const[Ye,He]of We)_e.set(Ye,He);return _e}we.to=ue})(ce||(e.WorkspaceEdit=ce={}));var be;(function(we){const Re=Object.create(null);Re[E.SymbolKind.File]=r.SymbolKind.File,Re[E.SymbolKind.Module]=r.SymbolKind.Module,Re[E.SymbolKind.Namespace]=r.SymbolKind.Namespace,Re[E.SymbolKind.Package]=r.SymbolKind.Package,Re[E.SymbolKind.Class]=r.SymbolKind.Class,Re[E.SymbolKind.Method]=r.SymbolKind.Method,Re[E.SymbolKind.Property]=r.SymbolKind.Property,Re[E.SymbolKind.Field]=r.SymbolKind.Field,Re[E.SymbolKind.Constructor]=r.SymbolKind.Constructor,Re[E.SymbolKind.Enum]=r.SymbolKind.Enum,Re[E.SymbolKind.Interface]=r.SymbolKind.Interface,Re[E.SymbolKind.Function]=r.SymbolKind.Function,Re[E.SymbolKind.Variable]=r.SymbolKind.Variable,Re[E.SymbolKind.Constant]=r.SymbolKind.Constant,Re[E.SymbolKind.String]=r.SymbolKind.String,Re[E.SymbolKind.Number]=r.SymbolKind.Number,Re[E.SymbolKind.Boolean]=r.SymbolKind.Boolean,Re[E.SymbolKind.Array]=r.SymbolKind.Array,Re[E.SymbolKind.Object]=r.SymbolKind.Object,Re[E.SymbolKind.Key]=r.SymbolKind.Key,Re[E.SymbolKind.Null]=r.SymbolKind.Null,Re[E.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Re[E.SymbolKind.Struct]=r.SymbolKind.Struct,Re[E.SymbolKind.Event]=r.SymbolKind.Event,Re[E.SymbolKind.Operator]=r.SymbolKind.Operator,Re[E.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function ue(_e){return typeof Re[_e]=="number"?Re[_e]:r.SymbolKind.Property}we.from=ue;function K(_e){for(const We in Re)if(Re[We]===_e)return Number(We);return E.SymbolKind.Property}we.to=K})(be||(e.SymbolKind=be={}));var he;(function(we){function Re(K){switch(K){case E.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}we.from=Re;function ue(K){switch(K){case r.SymbolTag.Deprecated:return E.SymbolTag.Deprecated}}we.to=ue})(he||(e.SymbolTag=he={}));var G;(function(we){function Re(K){return{name:K.name,kind:be.from(K.kind),tags:K.tags&&K.tags.map(he.from),containerName:K.containerName,location:Ue.from(K.location)}}we.from=Re;function ue(K){const _e=new E.SymbolInformation(K.name,be.to(K.kind),K.containerName,Ue.to(K.location));return _e.tags=K.tags&&K.tags.map(he.to),_e}we.to=ue})(G||(e.WorkspaceSymbol=G={}));var J;(function(we){function Re(K){const _e={name:K.name||"!!MISSING: name!!",detail:K.detail,range:L.from(K.range),selectionRange:L.from(K.selectionRange),kind:be.from(K.kind),tags:K.tags?.map(he.from)??[]};return K.children&&(_e.children=K.children.map(Re)),_e}we.from=Re;function ue(K){const _e=new E.DocumentSymbol(K.name,K.detail,be.to(K.kind),L.to(K.range),L.to(K.selectionRange));return(0,S.isNonEmptyArray)(K.tags)&&(_e.tags=K.tags.map(he.to)),K.children&&(_e.children=K.children.map(ue)),_e}we.to=ue})(J||(e.DocumentSymbol=J={}));var pe;(function(we){function Re(K){const _e=new E.CallHierarchyItem(be.to(K.kind),K.name,K.detail||"",s.URI.revive(K.uri),L.to(K.range),L.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}we.to=Re;function ue(K,_e,We){if(_e=_e??K._sessionId,We=We??K._itemId,_e===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:We,name:K.name,detail:K.detail,kind:be.from(K.kind),uri:K.uri,range:L.from(K.range),selectionRange:L.from(K.selectionRange),tags:K.tags?.map(he.from)}}we.from=ue})(pe||(e.CallHierarchyItem=pe={}));var ve;(function(we){function Re(ue){return new E.CallHierarchyIncomingCall(pe.to(ue.from),ue.fromRanges.map(K=>L.to(K)))}we.to=Re})(ve||(e.CallHierarchyIncomingCall=ve={}));var Oe;(function(we){function Re(ue){return new E.CallHierarchyOutgoingCall(pe.to(ue.to),ue.fromRanges.map(K=>L.to(K)))}we.to=Re})(Oe||(e.CallHierarchyOutgoingCall=Oe={}));var Ue;(function(we){function Re(K){return{range:K.range&&L.from(K.range),uri:K.uri}}we.from=Re;function ue(K){return new E.Location(s.URI.revive(K.uri),L.to(K.range))}we.to=ue})(Ue||(e.location=Ue={}));var De;(function(we){function Re(K){const _e=K,We=K;return{originSelectionRange:_e.originSelectionRange?L.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:We.uri,range:L.from(_e.targetRange?_e.targetRange:We.range),targetSelectionRange:_e.targetSelectionRange?L.from(_e.targetSelectionRange):void 0}}we.from=Re;function ue(K){return{targetUri:s.URI.revive(K.uri),targetRange:L.to(K.range),targetSelectionRange:K.targetSelectionRange?L.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?L.to(K.originSelectionRange):void 0}}we.to=ue})(De||(e.DefinitionLink=De={}));var Ae;(function(we){function Re(K){return{range:L.from(K.range),contents:Ee.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}we.from=Re;function ue(K){const _e=K.contents.map(Ee.to),We=L.to(K.range),Ye=K.canIncreaseVerbosity,He=K.canDecreaseVerbosity;return new E.VerboseHover(_e,We,Ye,He)}we.to=ue})(Ae||(e.Hover=Ae={}));var Le;(function(we){function Re(K){return{range:L.from(K.range),expression:K.expression}}we.from=Re;function ue(K){return new E.EvaluatableExpression(L.to(K.range),K.expression)}we.to=ue})(Le||(e.EvaluatableExpression=Le={}));var B;(function(we){function Re(K){if(K instanceof E.InlineValueText)return{type:"text",range:L.from(K.range),text:K.text};if(K instanceof E.InlineValueVariableLookup)return{type:"variable",range:L.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:L.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Re;function ue(K){switch(K.type){case"text":return{range:L.to(K.range),text:K.text};case"variable":return{range:L.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:L.to(K.range),expression:K.expression}}}we.to=ue})(B||(e.InlineValue=B={}));var x;(function(we){function Re(K){return{frameId:K.frameId,stoppedLocation:L.from(K.stoppedLocation)}}we.from=Re;function ue(K){return new E.InlineValueContext(K.frameId,L.to(K.stoppedLocation))}we.to=ue})(x||(e.InlineValueContext=x={}));var H;(function(we){function Re(K){return{range:L.from(K.range),kind:K.kind}}we.from=Re;function ue(K){return new E.DocumentHighlight(L.to(K.range),K.kind)}we.to=ue})(H||(e.DocumentHighlight=H={}));var j;(function(we){function Re(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}we.from=Re;function ue(K){return new E.MultiDocumentHighlight(s.URI.revive(K.uri),K.highlights.map(H.to))}we.to=ue})(j||(e.MultiDocumentHighlight=j={}));var ne;(function(we){function Re(ue){switch(ue){case r.CompletionTriggerKind.TriggerCharacter:return E.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return E.CompletionTriggerKind.Invoke}}we.to=Re})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(we){function Re(ue){return{triggerKind:ne.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}we.to=Re})(fe||(e.CompletionContext=fe={}));var ke;(function(we){function Re(K){switch(K){case E.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}we.from=Re;function ue(K){switch(K){case r.CompletionItemTag.Deprecated:return E.CompletionItemTag.Deprecated}}we.to=ue})(ke||(e.CompletionItemTag=ke={}));var xe;(function(we){const Re=new Map([[E.CompletionItemKind.Method,r.CompletionItemKind.Method],[E.CompletionItemKind.Function,r.CompletionItemKind.Function],[E.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[E.CompletionItemKind.Field,r.CompletionItemKind.Field],[E.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[E.CompletionItemKind.Class,r.CompletionItemKind.Class],[E.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[E.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[E.CompletionItemKind.Module,r.CompletionItemKind.Module],[E.CompletionItemKind.Property,r.CompletionItemKind.Property],[E.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[E.CompletionItemKind.Value,r.CompletionItemKind.Value],[E.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[E.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[E.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[E.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[E.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[E.CompletionItemKind.Text,r.CompletionItemKind.Text],[E.CompletionItemKind.Color,r.CompletionItemKind.Color],[E.CompletionItemKind.File,r.CompletionItemKind.File],[E.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[E.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[E.CompletionItemKind.Event,r.CompletionItemKind.Event],[E.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[E.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[E.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[E.CompletionItemKind.User,r.CompletionItemKind.User]]);function ue(We){return Re.get(We)??r.CompletionItemKind.Property}we.from=ue;const K=new Map([[r.CompletionItemKind.Method,E.CompletionItemKind.Method],[r.CompletionItemKind.Function,E.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,E.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,E.CompletionItemKind.Field],[r.CompletionItemKind.Variable,E.CompletionItemKind.Variable],[r.CompletionItemKind.Class,E.CompletionItemKind.Class],[r.CompletionItemKind.Interface,E.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,E.CompletionItemKind.Struct],[r.CompletionItemKind.Module,E.CompletionItemKind.Module],[r.CompletionItemKind.Property,E.CompletionItemKind.Property],[r.CompletionItemKind.Unit,E.CompletionItemKind.Unit],[r.CompletionItemKind.Value,E.CompletionItemKind.Value],[r.CompletionItemKind.Constant,E.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,E.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,E.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,E.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,E.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,E.CompletionItemKind.Text],[r.CompletionItemKind.Color,E.CompletionItemKind.Color],[r.CompletionItemKind.File,E.CompletionItemKind.File],[r.CompletionItemKind.Reference,E.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,E.CompletionItemKind.Folder],[r.CompletionItemKind.Event,E.CompletionItemKind.Event],[r.CompletionItemKind.Operator,E.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,E.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,E.CompletionItemKind.User],[r.CompletionItemKind.Issue,E.CompletionItemKind.Issue]]);function _e(We){return K.get(We)??E.CompletionItemKind.Property}we.to=_e})(xe||(e.CompletionItemKind=xe={}));var qe;(function(we){function Re(ue,K){const _e=new E.CompletionItem(ue.label);return _e.insertText=ue.insertText,_e.kind=xe.to(ue.kind),_e.tags=ue.tags?.map(ke.to),_e.detail=ue.detail,_e.documentation=A.isMarkdownString(ue.documentation)?Ee.to(ue.documentation):ue.documentation,_e.sortText=ue.sortText,_e.filterText=ue.filterText,_e.preselect=ue.preselect,_e.commitCharacters=ue.commitCharacters,d.Range.isIRange(ue.range)?_e.range=L.to(ue.range):typeof ue.range=="object"&&(_e.range={inserting:L.to(ue.range.insert),replacing:L.to(ue.range.replace)}),_e.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof ue.insertTextRules<"u"&&ue.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?_e.insertText=new E.SnippetString(ue.insertText):(_e.insertText=ue.insertText,_e.textEdit=_e.range instanceof E.Range?new E.TextEdit(_e.range,_e.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(_e.additionalTextEdits=ue.additionalTextEdits.map(We=>Se.to(We))),_e.command=K&&ue.command?K.fromInternal(ue.command):void 0,_e}we.to=Re})(qe||(e.CompletionItem=qe={}));var Ze;(function(we){function Re(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:Ee.fromStrict(K.documentation)}}we.from=Re;function ue(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?Ee.to(K.documentation):K.documentation}}we.to=ue})(Ze||(e.ParameterInformation=Ze={}));var tt;(function(we){function Re(K){return{label:K.label,documentation:Ee.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Ze.from):[],activeParameter:K.activeParameter}}we.from=Re;function ue(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?Ee.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Ze.to):[],activeParameter:K.activeParameter}}we.to=ue})(tt||(e.SignatureInformation=tt={}));var nt;(function(we){function Re(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.from):[]}}we.from=Re;function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.to):[]}}we.to=ue})(nt||(e.SignatureHelp=nt={}));var et;(function(we){function Re(ue,K){const _e=new E.InlayHint(W.to(K.position),typeof K.label=="string"?K.label:K.label.map(rt.to.bind(void 0,ue)),K.kind&&ft.to(K.kind));return _e.textEdits=K.textEdits&&K.textEdits.map(Se.to),_e.tooltip=A.isMarkdownString(K.tooltip)?Ee.to(K.tooltip):K.tooltip,_e.paddingLeft=K.paddingLeft,_e.paddingRight=K.paddingRight,_e}we.to=Re})(et||(e.InlayHint=et={}));var rt;(function(we){function Re(ue,K){const _e=new E.InlayHintLabelPart(K.label);return _e.tooltip=A.isMarkdownString(K.tooltip)?Ee.to(K.tooltip):K.tooltip,r.Command.is(K.command)&&(_e.command=ue.fromInternal(K.command)),K.location&&(_e.location=Ue.to(K.location)),_e}we.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(we){function Re(K){return K}we.from=Re;function ue(K){return K}we.to=ue})(ft||(e.InlayHintKind=ft={}));var lt;(function(we){function Re(K){return{range:L.from(K.range),url:K.target,tooltip:K.tooltip}}we.from=Re;function ue(K){let _e;if(K.url)try{_e=typeof K.url=="string"?s.URI.parse(K.url,!0):s.URI.revive(K.url)}catch{}const We=new E.DocumentLink(L.to(K.range),_e);return We.tooltip=K.tooltip,We}we.to=ue})(lt||(e.DocumentLink=lt={}));var st;(function(we){function Re(K){const _e=new E.ColorPresentation(K.label);return K.textEdit&&(_e.textEdit=Se.to(K.textEdit)),K.additionalTextEdits&&(_e.additionalTextEdits=K.additionalTextEdits.map(We=>Se.to(We))),_e}we.to=Re;function ue(K){return{label:K.label,textEdit:K.textEdit?Se.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(_e=>Se.from(_e)):void 0}}we.from=ue})(st||(e.ColorPresentation=st={}));var ct;(function(we){function Re(K){return new E.Color(K[0],K[1],K[2],K[3])}we.to=Re;function ue(K){return[K.red,K.green,K.blue,K.alpha]}we.from=ue})(ct||(e.Color=ct={}));var gt;(function(we){function Re(K){return{range:L.from(K.range)}}we.from=Re;function ue(K){return new E.SelectionRange(L.to(K.range))}we.to=ue})(gt||(e.SelectionRange=gt={}));var pt;(function(we){function Re(ue){switch(ue){case m.SaveReason.AUTO:return E.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return E.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return E.TextDocumentSaveReason.FocusOut}}we.to=Re})(pt||(e.TextDocumentSaveReason=pt={}));var ze;(function(we){function Re(K){switch(K){case E.TextEditorLineNumbersStyle.Off:return o.RenderLineNumbersType.Off;case E.TextEditorLineNumbersStyle.Relative:return o.RenderLineNumbersType.Relative;case E.TextEditorLineNumbersStyle.Interval:return o.RenderLineNumbersType.Interval;case E.TextEditorLineNumbersStyle.On:default:return o.RenderLineNumbersType.On}}we.from=Re;function ue(K){switch(K){case o.RenderLineNumbersType.Off:return E.TextEditorLineNumbersStyle.Off;case o.RenderLineNumbersType.Relative:return E.TextEditorLineNumbersStyle.Relative;case o.RenderLineNumbersType.Interval:return E.TextEditorLineNumbersStyle.Interval;case o.RenderLineNumbersType.On:default:return E.TextEditorLineNumbersStyle.On}}we.to=ue})(ze||(e.TextEditorLineNumbersStyle=ze={}));var Be;(function(we){function Re(K){if(K===E.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===E.EndOfLine.LF)return t.EndOfLineSequence.LF}we.from=Re;function ue(K){if(K===t.EndOfLineSequence.CRLF)return E.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return E.EndOfLine.LF}we.to=ue})(Be||(e.EndOfLine=Be={}));var ee;(function(we){function Re(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case E.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case E.ProgressLocation.Window:return u.ProgressLocation.Window;case E.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}we.from=Re})(ee||(e.ProgressLocation=ee={}));var q;(function(we){function Re(K){const _e={start:K.start+1,end:K.end+1};return K.kind&&(_e.kind=Ce.from(K.kind)),_e}we.from=Re;function ue(K){const _e={start:K.start-1,end:K.end-1};return K.kind&&(_e.kind=Ce.to(K.kind)),_e}we.to=ue})(q||(e.FoldingRange=q={}));var Ce;(function(we){function Re(K){if(K)switch(K){case E.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}we.from=Re;function ue(K){if(K)switch(K.value){case r.FoldingRangeKind.Comment.value:return E.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports.value:return E.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region.value:return E.FoldingRangeKind.Region}}we.to=ue})(Ce||(e.FoldingRangeKind=Ce={}));var Ge;(function(we){function Re(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?L.from(ue.selection):void 0,override:typeof ue.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=Re})(Ge||(e.TextEditorOpenOptions=Ge={}));var Je;(function(we){function Re(We){return We instanceof E.RelativePattern?We.toJSON():typeof We=="string"?We:ue(We)||K(We)?new E.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}we.from=Re;function ue(We){const Ye=We;return Ye?s.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function K(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function _e(We){return typeof We=="string"?We:new E.RelativePattern(s.URI.revive(We.baseUri),We.pattern)}we.to=_e})(Je||(e.GlobPattern=Je={}));var dt;(function(we){function Re(ue){if(ue){if(Array.isArray(ue))return ue.map(Re);if(typeof ue=="string")return ue;{const K=ue;return{language:K.language,scheme:K.scheme,pattern:Je.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}we.from=Re})(dt||(e.LanguageSelector=dt={}));var vt;(function(we){function Re(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(_e=>Array.isArray(_e)&&_e.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof E.Range)))}we.is=Re;function ue(K){return{documents:K.documents.map(_e=>_e.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>L.from(Ye))})))}}we.from=ue})(vt||(e.MappedEditsContext=vt={}));var Lt;(function(we){function Re(K){return{start:K.start,end:K.end}}we.from=Re;function ue(K){return new E.NotebookRange(K.start,K.end)}we.to=ue})(Lt||(e.NotebookRange=Lt={}));var Ft;(function(we){function Re(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}we.to=Re;function ue(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}we.from=ue})(Ft||(e.NotebookCellExecutionSummary=Ft={}));var ei;(function(we){function Re(ue){if(ue===b.NotebookCellExecutionState.Unconfirmed)return E.NotebookCellExecutionState.Pending;if(ue===b.NotebookCellExecutionState.Pending)return;if(ue===b.NotebookCellExecutionState.Executing)return E.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}we.to=Re})(ei||(e.NotebookCellExecutionState=ei={}));var ui;(function(we){function Re(K){switch(K){case E.NotebookCellKind.Markup:return b.CellKind.Markup;case E.NotebookCellKind.Code:default:return b.CellKind.Code}}we.from=Re;function ue(K){switch(K){case b.CellKind.Markup:return E.NotebookCellKind.Markup;case b.CellKind.Code:default:return E.NotebookCellKind.Code}}we.to=ue})(ui||(e.NotebookCellKind=ui={}));var ti;(function(we){function Re(K){const _e={metadata:K.metadata??Object.create(null),cells:[]};for(const We of K.cells)E.NotebookCellData.validate(We),_e.cells.push(Qe.from(We));return _e}we.from=Re;function ue(K){const _e=new E.NotebookData(K.cells.map(Qe.to));return(0,n.isEmptyObject)(K.metadata)||(_e.metadata=K.metadata),_e}we.to=ue})(ti||(e.NotebookData=ti={}));var Qe;(function(we){function Re(K){return{cellKind:ui.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ft.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(qt.from):[]}}we.from=Re;function ue(K){return new E.NotebookCellData(ui.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(qt.to):void 0,K.metadata,K.internalMetadata?Ft.to(K.internalMetadata):void 0)}we.to=ue})(Qe||(e.NotebookCellData=Qe={}));var Ht;(function(we){function Re(K){return{mime:K.mime,valueBytes:T.VSBuffer.wrap(K.data)}}we.from=Re;function ue(K){return new E.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}we.to=ue})(Ht||(e.NotebookCellOutputItem=Ht={}));var qt;(function(we){function Re(K){return{outputId:K.id,items:K.items.map(Ht.from),metadata:K.metadata}}we.from=Re;function ue(K){const _e=K.items.map(Ht.to);return new E.NotebookCellOutput(_e,K.outputId,K.metadata)}we.to=ue})(qt||(e.NotebookCellOutput=qt={}));var mt;(function(we){function Re(_e){return K(_e)?{include:Je.from(_e.include)??void 0,exclude:Je.from(_e.exclude)??void 0}:Je.from(_e)??void 0}we.from=Re;function ue(_e){return K(_e)?{include:Je.to(_e.include),exclude:Je.to(_e.exclude)}:Je.to(_e)}we.to=ue;function K(_e){const We=_e;return We?!(0,n.isUndefinedOrNull)(We.include)&&!(0,n.isUndefinedOrNull)(We.exclude):!1}})(mt||(e.NotebookExclusiveDocumentPattern=mt={}));var It;(function(we){function Re(ue,K,_e){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===E.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:K.toInternal(We,_e),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}we.from=Re})(It||(e.NotebookStatusBarItem=It={}));var ii;(function(we){function Re(ue,K,_e){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:K.toInternal(We,_e),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}we.from=Re})(ii||(e.NotebookKernelSourceAction=ii={}));var Xt;(function(we){function Re(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}we.from=Re})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var zt;(function(we){function Re(K){return{uri:K.uri,provides:K.provides}}we.from=Re;function ue(K){return new E.NotebookRendererScript(s.URI.revive(K.uri),K.provides)}we.to=ue})(zt||(e.NotebookRendererScript=zt={}));var St;(function(we){function Re(K){return{message:Ee.fromStrict(K.message)||"",type:P.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:L.from(K.location.range),uri:K.location.uri}}}we.from=Re;function ue(K){const _e=new E.TestMessage(typeof K.message=="string"?K.message:Ee.to(K.message));return _e.actualOutput=K.actual,_e.expectedOutput=K.expected,_e.contextValue=K.contextValue,_e.location=K.location?Ue.to(K.location):void 0,_e}we.to=ue})(St||(e.TestMessage=St={}));var Ot;(function(we){we.namespace=P.namespaceTestTag,we.denamespace=P.denamespaceTestTag})(Ot||(e.TestTag=Ot={}));var di;(function(we){function Re(K){const _e=(0,g.getPrivateApiFor)(K).controllerId;return{extId:D.TestId.fromExtHostTestItem(K,_e).toString(),label:K.label,uri:s.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(We=>Ot.namespace(_e,We.id)),range:d.Range.lift(L.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&Ee.fromStrict(K.error)||null}}we.from=Re;function ue(K){return{parent:void 0,error:void 0,id:D.TestId.fromString(K.extId).localId,label:K.label,uri:s.URI.revive(K.uri),tags:(K.tags||[]).map(_e=>{const{tagId:We}=Ot.denamespace(_e);return new E.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}we.toPlain=ue})(di||(e.TestItem=di={})),function(we){function Re(K){return{id:K.id}}we.from=Re;function ue(K){return new E.TestTag(K.id)}we.to=ue}(Ot||(e.TestTag=Ot={}));var Wt;(function(we){const Re=(K,_e)=>{const We=K.value;if(!We)return;const Ye={...di.toPlain(We.item),parent:_e,taskStates:We.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===P.TestMessageType.Error).map(St.to)})),children:[]};if(K.children)for(const He of K.children.values()){const ut=Re(He,Ye);ut&&Ye.children.push(ut)}return Ye};function ue(K){const _e=new c.WellDefinedPrefixTree;for(const He of K.items)_e.insert(D.TestId.fromString(He.item.extId).path,He);const We=[_e.nodes],Ye=[];for(;We.length;)for(const He of We.pop())He.value?Ye.push(He):He.children&&We.push(He.children.values());return{completedAt:K.completedAt,results:Ye.map(He=>Re(He)).filter(n.isDefined)}}we.to=ue})(Wt||(e.TestResults=Wt={}));var Xe;(function(we){function Re(We){return{covered:We.covered,total:We.total}}function ue(We){return"line"in We?W.from(We):L.from(We)}function K(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ue(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ue(Ye.location),label:Ye.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:ue(We.location)}}we.fromDetails=K;function _e(We,Ye,He){return E.validateTestCoverageCount(He.statementCoverage),E.validateTestCoverageCount(He.branchCoverage),E.validateTestCoverageCount(He.declarationCoverage),{id:Ye,uri:He.uri,statement:Re(He.statementCoverage),branch:He.branchCoverage&&Re(He.branchCoverage),declaration:He.declarationCoverage&&Re(He.declarationCoverage),testIds:He instanceof E.FileCoverage&&He.fromTests.length?He.fromTests.map(ut=>D.TestId.fromExtHostTestItem(ut,We).toString()):void 0}}we.fromFile=_e})(Xe||(e.TestCoverage=Xe={}));var Qt;(function(we){function Re(ue){switch(ue){case r.CodeActionTriggerType.Invoke:return E.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return E.CodeActionTriggerKind.Automatic}}we.to=Re})(Qt||(e.CodeActionTriggerKind=Qt={}));var ni;(function(we){function Re(K){const _e=new E.TypeHierarchyItem(be.to(K.kind),K.name,K.detail||"",s.URI.revive(K.uri),L.to(K.range),L.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}we.to=Re;function ue(K,_e,We){if(_e=_e??K._sessionId,We=We??K._itemId,_e===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:We,kind:be.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:L.from(K.range),selectionRange:L.from(K.selectionRange),tags:K.tags?.map(he.from)}}we.from=ue})(ni||(e.TypeHierarchyItem=ni={}));var hi;(function(we){function Re(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}we.from=Re})(hi||(e.ViewBadge=hi={}));var yt;(function(we){function Re(We,Ye,He){const ut=Ye.fileData;return ut?new E.InternalFileDataTransferItem(new E.DataTransferFile(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.createSingleCallFunction)(()=>He(ut.id)))):We===k.Mimes.uriList&&Ye.uriListData?new E.InternalDataTransferItem(_e(Ye.uriListData)):new E.InternalDataTransferItem(Ye.asString)}we.to=Re;async function ue(We,Ye){const He=await Ye.asString();if(We===k.Mimes.uriList)return{asString:He,fileData:void 0,uriListData:K(He)};const ut=Ye.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=ue;function K(We){return I.UriList.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return s.URI.parse(Ye)}catch{}return Ye})}function _e(We){return I.UriList.create(We.map(Ye=>typeof Ye=="string"?Ye:s.URI.revive(Ye)))}})(yt||(e.DataTransferItem=yt={}));var Nt;(function(we){function Re(K,_e){const We=K.items.map(([Ye,He])=>[Ye,yt.to(Ye,He,_e)]);return new E.DataTransfer(We)}we.toDataTransfer=Re;async function ue(K){const _e={items:[]},We=[];for(const[Ye,He]of K)We.push((async()=>{_e.items.push([Ye,await yt.from(Ye,He)])})());return await Promise.all(We),_e}we.from=ue})(Nt||(e.DataTransfer=Nt={}));var kt;(function(we){function Re(K,_e){return{kind:"reply",agentId:K.participant??_e?.agentId??"",subCommand:K.command??_e?.command,message:K.prompt,title:K.label}}we.from=Re;function ue(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}we.to=ue})(kt||(e.ChatFollowup=kt={}));var Ut;(function(we){function Re(K){switch(K){case y.ChatMessageRole.System:return E.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return E.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return E.LanguageModelChatMessageRole.Assistant}}we.to=Re;function ue(K){switch(K){case E.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case E.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case E.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}we.from=ue})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(we){function Re(K){let _e="",We;K.content.type==="text"?_e=K.content.value:We=new E.LanguageModelFunctionResultPart(K.content.name,K.content.value,K.content.isError);const Ye=Ut.to(K.role),He=new E.LanguageModelChatMessage(Ye,_e,K.name);return We!==void 0&&(He.content2=We),He}we.to=Re;function ue(K){const _e=Ut.from(K.role),We=K.name;let Ye;return K.content2 instanceof E.LanguageModelFunctionResultPart?Ye={type:"function_result",name:K.content2.name,value:K.content2.content,isError:K.content2.isError}:Ye={type:"text",value:K.content},{role:_e,name:We,content:Ye}}we.from=ue})(ri||(e.LanguageModelChatMessage=ri={}));var Yt;(function(we){function Re(K){return{kind:"markdownContent",content:Ee.from(K.value)}}we.from=Re;function ue(K){return new E.ChatResponseMarkdownPart(Ee.to(K.content))}we.to=ue})(Yt||(e.ChatResponseMarkdownPart=Yt={}));var si;(function(we){function Re(K){return{kind:"markdownVuln",content:Ee.from(K.value),vulnerabilities:K.vulnerabilities}}we.from=Re;function ue(K){return new E.ChatResponseMarkdownWithVulnerabilitiesPart(Ee.to(K.content),K.vulnerabilities)}we.to=ue})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var $t;(function(we){function Re(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}we.from=Re;function ue(K){return new E.ChatResponseDetectedParticipantPart(K.agentId,K.command)}we.to=ue})($t||(e.ChatResponseDetectedParticipantPart=$t={}));var jt;(function(we){function Re(ue){return{kind:"confirmation",title:ue.title,message:ue.message,data:ue.data}}we.from=Re})(jt||(e.ChatResponseConfirmationPart=jt={}));var oi;(function(we){function Re(K){const{value:_e,baseUri:We}=K;function Ye(He,ut){return He.map(Tt=>{const Kt=s.URI.joinPath(ut,Tt.name);return{label:Tt.name,uri:Kt,children:Tt.children&&Ye(Tt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,_.basename)(We),uri:We,children:Ye(_e,We)}}}we.from=Re;function ue(K){const _e=(0,a.revive)(K.treeData);function We(ut){return ut.map(Tt=>({name:Tt.label,children:Tt.children&&We(Tt.children)}))}const Ye=_e.uri,He=_e.children?We(_e.children):[];return new E.ChatResponseFileTreePart(He,Ye)}we.to=ue})(oi||(e.ChatResponseFilesPart=oi={}));var Pt;(function(we){function Re(K){const _e=We=>s.URI.isUri(We);return{kind:"inlineReference",name:K.title,inlineReference:_e(K.value)?K.value:M.from(K.value)}}we.from=Re;function ue(K){const _e=(0,a.revive)(K);return new E.ChatResponseAnchorPart(s.URI.isUri(_e.inlineReference)?_e.inlineReference:M.to(_e.inlineReference),K.name)}we.to=ue})(Pt||(e.ChatResponseAnchorPart=Pt={}));var Ct;(function(we){function Re(K){return{kind:"progressMessage",content:Ee.from(K.value)}}we.from=Re;function ue(K){return new E.ChatResponseProgressPart(K.content.value)}we.to=ue})(Ct||(e.ChatResponseProgressPart=Ct={}));var bt;(function(we){function Re(K){return{kind:"warning",content:Ee.from(K.value)}}we.from=Re;function ue(K){return new E.ChatResponseWarningPart(K.content.value)}we.to=ue})(bt||(e.ChatResponseWarningPart=bt={}));var Jt;(function(we){function Re(ue){return{kind:"progressTask",content:Ee.from(ue.value)}}we.from=Re})(Jt||(e.ChatTask=Jt={}));var Dt;(function(we){function Re(ue){return{kind:"progressTaskResult",content:typeof ue=="string"?Ee.from(ue):void 0}}we.from=Re})(Dt||(e.ChatTaskResult=Dt={}));var fi;(function(we){function Re(K,_e,We){return{kind:"command",command:_e.toInternal(K.value,We)??{command:K.value.command,title:K.value.title}}}we.from=Re;function ue(K,_e){return new E.ChatResponseCommandButtonPart(_e.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}we.to=ue})(fi||(e.ChatResponseCommandButtonPart=fi={}));var Vt;(function(we){function Re(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(_e=>Se.from(_e))}}we.from=Re;function ue(K){return new E.ChatResponseTextEditPart(s.URI.revive(K.uri),K.edits.map(_e=>Se.to(_e)))}we.to=ue})(Vt||(e.ChatResponseTextEditPart=Vt={}));var bi;(function(we){function Re(K){const _e=h.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:s.URI.isUri(K.iconPath)?{light:s.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&s.URI.isUri(K.iconPath.light)&&s.URI.isUri(K.iconPath.dark)?{light:s.URI.revive(K.iconPath.light),dark:s.URI.revive(K.iconPath.dark)}:void 0;return"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:s.URI.isUri(K.value.value)||!K.value.value?K.value.value:M.from(K.value.value)},iconPath:_e}:{kind:"reference",reference:s.URI.isUri(K.value)?K.value:M.from(K.value),iconPath:_e}}we.from=Re;function ue(K){const _e=(0,a.revive)(K),We=Ye=>s.URI.isUri(Ye)?Ye:M.to(Ye);return new E.ChatResponseReferencePart("variableName"in _e.reference?{variableName:_e.reference.variableName,value:_e.reference.value&&We(_e.reference.value)}:We(_e.reference))}we.to=ue})(bi||(e.ChatResponseReferencePart=bi={}));var Si;(function(we){function Re(_e,We,Ye){return _e instanceof E.ChatResponseMarkdownPart?Yt.from(_e):_e instanceof E.ChatResponseAnchorPart?Pt.from(_e):_e instanceof E.ChatResponseReferencePart?bi.from(_e):_e instanceof E.ChatResponseProgressPart?Ct.from(_e):_e instanceof E.ChatResponseFileTreePart?oi.from(_e):_e instanceof E.ChatResponseCommandButtonPart?fi.from(_e,We,Ye):_e instanceof E.ChatResponseTextEditPart?Vt.from(_e):_e instanceof E.ChatResponseMarkdownWithVulnerabilitiesPart?si.from(_e):_e instanceof E.ChatResponseDetectedParticipantPart?$t.from(_e):_e instanceof E.ChatResponseWarningPart?bt.from(_e):{kind:"markdownContent",content:Ee.from("")}}we.from=Re;function ue(_e,We){switch(_e.kind){case"reference":return bi.to(_e);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(_e,We)}}we.to=ue;function K(_e,We){switch(_e.kind){case"markdownContent":return Yt.to(_e);case"inlineReference":return Pt.to(_e);case"progressMessage":return;case"treeData":return oi.to(_e);case"command":return fi.to(_e,We)}}we.toContent=K})(Si||(e.ChatResponsePart=Si={}));var gi;(function(we){function Re(ue){return{prompt:ue.message,command:ue.command,attempt:ue.attempt??0,enableCommandDetection:ue.enableCommandDetection??!0,references:ue.variables.variables.map(ai.to),location:xt.to(ue.location),acceptedConfirmationData:ue.acceptedConfirmationData,rejectedConfirmationData:ue.rejectedConfirmationData}}we.to=Re})(gi||(e.ChatAgentRequest=gi={}));var xt;(function(we){function Re(K){switch(K){case p.ChatAgentLocation.Notebook:return E.ChatLocation.Notebook;case p.ChatAgentLocation.Terminal:return E.ChatLocation.Terminal;case p.ChatAgentLocation.Panel:return E.ChatLocation.Panel;case p.ChatAgentLocation.Editor:return E.ChatLocation.Editor}}we.to=Re;function ue(K){switch(K){case E.ChatLocation.Notebook:return p.ChatAgentLocation.Notebook;case E.ChatLocation.Terminal:return p.ChatAgentLocation.Terminal;case E.ChatLocation.Panel:return p.ChatAgentLocation.Panel;case E.ChatLocation.Editor:return p.ChatAgentLocation.Editor}}we.from=ue})(xt||(e.ChatLocation=xt={}));var ai;(function(we){function Re(ue){const K=ue.value;if(!K)throw new Error("Invalid value reference");return{id:ue.id,name:ue.name,range:ue.range&&[ue.range.start,ue.range.endExclusive],value:(0,s.isUriComponents)(K)?s.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,s.isUriComponents)(K.uri)?M.to((0,a.revive)(K)):K,modelDescription:ue.modelDescription}}we.to=Re})(ai||(e.ChatAgentValueReference=ai={}));var Ti;(function(we){function Re(ue,K,_e){return{id:ue.id,label:ue.label,fullName:ue.fullName,icon:ue.icon?.id,value:ue.values[0].value,insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation,command:K.toInternal(ue.command,_e)}}we.from=Re})(Ti||(e.ChatAgentCompletionItem=Ti={}));var At;(function(we){function Re(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}we.to=Re})(At||(e.ChatAgentResult=At={}));var Ci;(function(we){function Re(ue,K,_e){if(K.action.kind==="vote")return;const We=At.to(ue);if(K.action.kind==="command"){const Ye=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:_e.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:kt.to(K.action.followup)},result:We}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:We}:{action:K.action,result:We}}we.to=Re})(Ci||(e.ChatAgentUserActionEvent=Ci={}));var Pi;(function(we){function Re(ue,K,_e){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:K.toInternal(ue,_e)}we.from=Re})(Pi||(e.TerminalQuickFix=Pi={}));var yi;(function(we){function Re(ue){return{kind:pi.to(ue.kind)}}we.to=Re})(yi||(e.PartialAcceptInfo=yi={}));var pi;(function(we){function Re(ue){switch(ue){case r.PartialAcceptTriggerKind.Word:return E.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return E.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return E.PartialAcceptTriggerKind.Suggest;default:return E.PartialAcceptTriggerKind.Unknown}}we.to=Re})(pi||(e.PartialAcceptTriggerKind=pi={}));var ki;(function(we){function Re(ue,K){return{id:K,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||C.DebugTreeItemCollapsibleState.None,contextValue:ue.contextValue}}we.from=Re})(ki||(e.DebugTreeItem=ki={}));var Bt;(function(we){function Re(ue){return{name:ue.name,description:ue.description,parametersSchema:ue.parametersSchema}}we.to=Re})(Bt||(e.LanguageModelToolDescription=Bt={}))}),define(Te[274],Pe([1,0,5,17,8,39]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(v,a){this._proxy=v.getProxy(S.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>a.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,a,k){const w=new O.SerializableObjectWithBuffers(I.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(w,void 0,k?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=je([Ve(0,T.IExtHostRpcService)],A)}),define(Te[275],Pe([1,0,18,11,41,6,40,4,70,15,2,19,5,8,7,236,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,_=$e(_),h=$e(h);class o{constructor(t,l,u,g,m){this._extension=t,this._request=l,this._proxy=u,this._commandsConverter=g,this._sessionDisposables=m,this._stopWatch=v.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let l=function(g){if(t._isClosed){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,g),m}};const t=this;this._stopWatch.reset();const u=(g,m)=>{if(typeof this._firstProgress>"u"&&"content"in g&&(this._firstProgress=this._stopWatch.elapsed()),m){const p=this._proxy.$handleProgressChunk(this._request.requestId,g),y={report:C=>{p?.then(b=>{b&&(h.MarkdownString.isMarkdownString(C.value)?this._proxy.$handleProgressChunk(this._request.requestId,_.ChatResponseWarningPart.from(C),b):this._proxy.$handleProgressChunk(this._request.requestId,_.ChatResponseReferencePart.from(C),b))})}};Promise.all([p,m?.(y)]).then(([C,b])=>{C!==void 0&&b!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,_.ChatTaskResult.from(b),C)})}else this._proxy.$handleProgressChunk(this._request.requestId,g)};this._apiObject={markdown(g){l(this.markdown);const m=new h.ChatResponseMarkdownPart(g),p=_.ChatResponseMarkdownPart.from(m);return u(p),this},markdownWithVulnerabilities(g,m){l(this.markdown),m&&(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const p=new h.ChatResponseMarkdownWithVulnerabilitiesPart(g,m),y=_.ChatResponseMarkdownWithVulnerabilitiesPart.from(p);return u(y),this},filetree(g,m){l(this.filetree);const p=new h.ChatResponseFileTreePart(g,m),y=_.ChatResponseFilesPart.from(p);return u(y),this},anchor(g,m){l(this.anchor);const p=new h.ChatResponseAnchorPart(g,m),y=_.ChatResponseAnchorPart.from(p);return u(y),this},button(g){l(this.anchor);const m=new h.ChatResponseCommandButtonPart(g),p=_.ChatResponseCommandButtonPart.from(m,t._commandsConverter,t._sessionDisposables);return u(p),this},progress(g,m){l(this.progress);const p=new h.ChatResponseProgressPart2(g,m),y=m?_.ChatTask.from(p):_.ChatResponseProgressPart.from(p);return u(y,m),this},warning(g){l(this.progress),(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const m=new h.ChatResponseWarningPart(g),p=_.ChatResponseWarningPart.from(m);return u(p),this},reference(g,m){if(l(this.reference),"variableName"in g&&(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions"),"variableName"in g&&!g.value){const p=t._request.variables.variables.find(y=>y.name===g.variableName);if(p){let y;if(p.references?.length)y=p.references.map(C=>({kind:"reference",reference:{variableName:g.variableName,value:C.reference}}));else{const C=new h.ChatResponseReferencePart(g,m);y=[_.ChatResponseReferencePart.from(C)]}return y.forEach(C=>u(C)),this}}else{const p=new h.ChatResponseReferencePart(g,m),y=_.ChatResponseReferencePart.from(p);u(y)}return this},textEdit(g,m){l(this.textEdit),(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const p=new h.ChatResponseTextEditPart(g,m),y=_.ChatResponseTextEditPart.from(p);return u(y),this},detectedParticipant(g,m){l(this.detectedParticipant),(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const p=new h.ChatResponseDetectedParticipantPart(g,m),y=_.ChatResponseDetectedParticipantPart.from(p);return u(y),this},confirmation(g,m,p){l(this.confirmation),(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions");const y=new h.ChatResponseConfirmationPart(g,m,p),C=_.ChatResponseConfirmationPart.from(y);return u(C),this},push(g){if(l(this.push),(g instanceof h.ChatResponseTextEditPart||g instanceof h.ChatResponseMarkdownWithVulnerabilitiesPart||g instanceof h.ChatResponseDetectedParticipantPart||g instanceof h.ChatResponseWarningPart||g instanceof h.ChatResponseConfirmationPart)&&(0,s.checkProposedApiEnabled)(t._extension,"chatParticipantAdditions"),g instanceof h.ChatResponseReferencePart)this.reference(g.value,g.iconPath);else{const m=_.ChatResponsePart.from(g,t._commandsConverter,t._sessionDisposables);u(m)}return this}}}return this._apiObject}}class d extends R.Disposable{static{this._idPool=0}constructor(t,l,u){super(),this._logService=l,this.commands=u,this._agents=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=t.getProxy(c.MainContext.MainThreadChatAgents2)}transferActiveChat(t){this._proxy.$transferActiveChatSession(t)}createChatAgent(t,l,u){const g=d._idPool++,m=new i(t,l,this._proxy,g,u);return this._agents.set(g,m),this._proxy.$registerAgent(g,t.identifier,l,{},void 0),m.apiAgent}createDynamicChatAgent(t,l,u,g){const m=d._idPool++,p=new i(t,l,this._proxy,m,g);return this._agents.set(m,p),this._proxy.$registerAgent(m,t.identifier,l,{isSticky:!0},u),p.apiAgent}async $invokeAgent(t,l,u,g){const m=this._agents.get(t);if(!m)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this._sessionDisposables.get(l.sessionId);p||(p=new R.DisposableStore,this._sessionDisposables.set(l.sessionId,p));const y=new o(m.extension,l,this._proxy,this.commands.converter,p);try{const C=await this.prepareHistoryTurns(l.agentId,u),b=m.invoke(_.ChatAgentRequest.to(l),{history:C},y.apiObject,g);return await(0,T.raceCancellation)(Promise.resolve(b).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(f){const E=`result.metadata MUST be JSON.stringify-able. Got error: ${f.message}`;return this._logService.error(`[${m.extension.identifier.value}] [@${m.id}] ${E}`,m.extension),{errorDetails:{message:E},timings:y.timings}}let P;return D?.errorDetails&&(P={...D.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,s.checkProposedApiEnabled)(m.extension,"chatParticipantPrivate"),{errorDetails:P,timings:y.timings,metadata:D?.metadata}}),g)}catch(C){return this._logService.error(C,m.extension),C instanceof h.LanguageModelError&&C.cause&&(C=C.cause),{errorDetails:{message:(0,I.toErrorMessage)(C),responseIsIncomplete:!0}}}finally{y.close()}}async prepareHistoryTurns(t,l){const u=[];for(const g of l.history){const m=_.ChatAgentResult.to(g.result),p=t===g.request.agentId?m:{...m,metadata:void 0};u.push(new h.ChatRequestTurn(g.request.message,g.request.command,g.request.variables.variables.map(_.ChatAgentValueReference.to),g.request.agentId));const y=(0,S.coalesce)(g.response.map(C=>_.ChatResponsePart.toContent(C,this.commands.converter)));u.push(new h.ChatResponseTurn(y,p,g.request.agentId,g.request.command))}return u}$releaseSession(t){this._sessionDisposables.deleteAndDispose(t)}async $provideFollowups(t,l,u,g,m){const p=this._agents.get(l);if(!p)return Promise.resolve([]);const y=await this.prepareHistoryTurns(p.id,g),C=_.ChatAgentResult.to(u);return(await p.provideFollowups(C,{history:y},m)).filter(b=>{const D=!b.participant||A.Iterable.some(this._agents.values(),P=>P.id===b.participant&&w.ExtensionIdentifier.equals(P.extension.identifier,p.extension.identifier));return D||this._logService.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),D}).map(b=>_.ChatFollowup.from(b,t))}$acceptFeedback(t,l,u,g){const m=this._agents.get(t);if(!m)return;const p=_.ChatAgentResult.to(l);let y;switch(u){case n.ChatAgentVoteDirection.Down:y=h.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:y=h.ChatResultFeedbackKind.Helpful;break}m.acceptFeedback(Object.freeze(g?{result:p,kind:y,reportIssue:g}:{result:p,kind:y}))}$acceptAction(t,l,u){const g=this._agents.get(t);if(!g||u.action.kind==="vote")return;const m=_.ChatAgentUserActionEvent.to(l,u,this.commands.converter);m&&g.acceptAction(Object.freeze(m))}async $invokeCompletionProvider(t,l,u){const g=this._agents.get(t);if(!g)return[];let m=this._completionDisposables.get(t);return m?m.clear():(m=new R.DisposableStore,this._completionDisposables.set(t,m)),(await g.invokeCompletionProvider(l,u)).map(y=>_.ChatAgentCompletionItem.from(y,this.commands.converter,m))}async $provideWelcomeMessage(t,l,u){const g=this._agents.get(t);if(g)return await g.provideWelcomeMessage(_.ChatLocation.to(l),u)}async $provideSampleQuestions(t,l,u){const g=this._agents.get(t);if(g)return(await g.provideSampleQuestions(_.ChatLocation.to(l),u)).map(m=>_.ChatFollowup.from(m,void 0))}}e.ExtHostChatAgents2=d;class i{constructor(t,l,u,g,m){this.extension=t,this.id=l,this._proxy=u,this._handle=g,this._requestHandler=m,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(t){this._onDidReceiveFeedback.fire(t)}acceptAction(t){this._onDidPerformAction.fire(t)}async invokeCompletionProvider(t,l){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(t,l)??[]:[]}async provideFollowups(t,l,u){if(!this._followupProvider)return[];const g=await this._followupProvider.provideFollowups(t,l,u);return g?g.filter(m=>!(m&&"commandId"in m)).filter(m=>!(m&&"message"in m)):[]}async provideWelcomeMessage(t,l){if(!this._welcomeMessageProvider)return[];const u=await this._welcomeMessageProvider.provideWelcomeMessage(t,l);return u?u.map(g=>typeof g=="string"?g:_.MarkdownString.from(g)):[]}async provideSampleQuestions(t,l){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const u=await this._welcomeMessageProvider.provideSampleQuestions(t,l);return u||[]}get apiAgent(){let t=!1,l=!1;const u=()=>{t||l||(l=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof k.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof h.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:_.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:_.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:_.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),l=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g._iconPath},set iconPath(m){g._iconPath=m,u()},get requestHandler(){return g._requestHandler},set requestHandler(m){(0,a.assertType)(typeof m=="function","Invalid request handler"),g._requestHandler=m},get followupProvider(){return g._followupProvider},set followupProvider(m){g._followupProvider=m,u()},get isDefault(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isDefault},set isDefault(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isDefault=m,u()},get helpTextPrefix(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix},set helpTextPrefix(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix=m,u()},get helpTextVariablesPrefix(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix},set helpTextVariablesPrefix(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix=m,u()},get helpTextPostfix(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix},set helpTextPostfix(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix=m,u()},get isSecondary(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary},set isSecondary(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary=m,u()},get supportIssueReporting(){return(0,s.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting},set supportIssueReporting(m){(0,s.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting=m,u()},get onDidReceiveFeedback(){return g._onDidReceiveFeedback.event},set participantVariableProvider(m){if((0,s.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider=m,m){if(!m.triggerCharacters.length)throw new Error("triggerCharacters are required");g._proxy.$registerAgentCompletionsProvider(g._handle,g.id,m.triggerCharacters)}else g._proxy.$unregisterAgentCompletionsProvider(g._handle,g.id)},get participantVariableProvider(){return(0,s.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider},set welcomeMessageProvider(m){(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider=m,u()},get welcomeMessageProvider(){return(0,s.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider},onDidPerformAction:(0,s.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(m){g._requester=m,u()},get requester(){return g._requester},set supportsSlowReferences(m){(0,s.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences=m,u()},get supportsSlowReferences(){return(0,s.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences},dispose(){t=!0,g._followupProvider=void 0,g._onDidReceiveFeedback.dispose(),g._proxy.$unregisterAgent(g._handle)}}}invoke(t,l,u,g){return this._requestHandler(t,l,u,g)}}}),define(Te[276],Pe([1,0,14,4,35,5,8,7,25]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,A=$e(A),R=$e(R);class a{static{this._idPool=0}constructor(c){this._resolver=new Map,this._proxy=c.getProxy(O.MainContext.MainThreadChatVariables)}async $resolveVariable(c,_,h,n){const s=this._resolver.get(c);if(s)try{if(s.resolver.resolve2){(0,v.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions");const o=new k(_,this._proxy),d=await s.resolver.resolve2(s.data.name,{prompt:h},o.apiObject,n);if(d&&d[0])return d[0].value}else{const o=await s.resolver.resolve(s.data.name,{prompt:h},n);if(o&&o[0])return o[0].value}}catch(o){(0,S.onUnexpectedExternalError)(o)}}registerVariableResolver(c,_,h,n,s,o,d,i,r){const t=a._idPool++,l=r?I.ThemeIcon.fromId(r):void 0;return this._resolver.set(t,{extension:c,data:{id:_,name:h,description:n,modelDescription:s,icon:l},resolver:d}),this._proxy.$registerVariable(t,{id:_,name:h,description:n,modelDescription:s,isSlow:o,fullName:i,icon:l}),(0,T.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=a;class k{constructor(c,_){this._requestId=c,this._proxy=_,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let _=function(n){if(c._isClosed){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,n),s}};const c=this,h=n=>{this._proxy.$handleProgressChunk(this._requestId,n)};this._apiObject={progress(n){_(this.progress);const s=new R.ChatResponseProgressPart(n),o=A.ChatResponseProgressPart.from(s);return h(o),this},reference(n){_(this.reference);const s=new R.ChatResponseReferencePart(n),o=A.ChatResponseReferencePart.from(s);return h(o),this},push(n){return _(this.push),n instanceof R.ChatResponseReferencePart?h(A.ChatResponseReferencePart.from(n)):n instanceof R.ChatResponseProgressPart&&h(A.ChatResponseProgressPart.from(n)),this}}}return this._apiObject}}}),define(Te[277],Pe([1,0,11,72,6,4,38,2,94,19,8,7,5,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=h,v=$e(v),k=$e(k),w=$e(w);function h(n,s,o){const d=n.getProxy(c.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new a.ExtensionIdentifierMap,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===A.MarshalledId.CommentController){const D=this._commentControllers.get(b.handle);return D?D.value:b}else if(b&&b.$mid===A.MarshalledId.CommentThread){const D=b,P=this._commentControllers.get(D.commentControlHandle);if(!P)return D;const f=P.getCommentThread(D.commentThreadHandle);return f?f.value:D}else if(b&&(b.$mid===A.MarshalledId.CommentThreadReply||b.$mid===A.MarshalledId.CommentThreadInstance)){const D=this._commentControllers.get(b.thread.commentControlHandle);if(!D)return b;const P=D.getCommentThread(b.thread.commentThreadHandle);return P?b.$mid===A.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:b.text}:b}else if(b&&b.$mid===A.MarshalledId.CommentNode){const D=this._commentControllers.get(b.thread.commentControlHandle);if(!D)return b;const P=D.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const f=b.commentUniqueId,E=P.getCommentByUniqueId(f);return E||b}else if(b&&b.$mid===A.MarshalledId.CommentThreadNode){const D=this._commentControllers.get(b.thread.commentControlHandle);if(!D)return b;const P=D.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const f=b.text,E=b.commentUniqueId,F=P.getCommentByUniqueId(E);return F?(typeof F.body=="string"?F.body=f:F.body=new w.MarkdownString(f),F):b}return b}})}createCommentController(b,D,P){const f=i.handlePool++,E=new t(b,f,D,P);this._commentControllers.set(E.handle,E);const F=this._commentControllersByExtension.get(b.identifier)||[];return F.push(E),this._commentControllersByExtension.set(b.identifier,F),E.value}async $createCommentThreadTemplate(b,D,P,f){const E=this._commentControllers.get(b);E&&E.$createCommentThreadTemplate(D,P,f)}async $setActiveComment(b,D){const P=this._commentControllers.get(b);P&&P.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(b,D,P){const f=this._commentControllers.get(b);f&&f.$updateCommentThreadTemplate(D,P)}$deleteCommentThread(b,D){this._commentControllers.get(b)?.$deleteCommentThread(D)}async $provideCommentingRanges(b,D,P){const f=this._commentControllers.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const E=await o.ensureDocumentData(R.URI.revive(D));return(0,S.asPromise)(async()=>{const F=await f.commentingRangeProvider.provideCommentingRanges(E.document,P);let L;return Array.isArray(F)?L={ranges:F,fileComments:!1}:F?L={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:L=F??void 0,L}).then(F=>{let L;return F&&(L={ranges:F.ranges.map(M=>k.Range.from(M)),fileComments:F.fileComments}),L})}$toggleReaction(b,D,P,f,E){const F=this._commentControllers.get(b);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,S.asPromise)(()=>{const L=F.getCommentThread(D);if(L){const M=L.getCommentByUniqueId(f.uniqueIdInThread);if(F!==void 0&&M&&F.reactionHandler)return F.reactionHandler(M,g(E))}return Promise.resolve(void 0)})}}class r{static{this._handlePool=0}set threadId(b){this._id=b}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(b){(b===void 0!=(this._range===void 0)||!b||!this._range||!b.isEqual(this._range))&&(this._range=b,this.modifications.range=b,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(b){this._canReply!==b&&(this._canReply=b,this.modifications.canReply=b,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(b){this._label=b,this.modifications.label=b,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(b){this._contextValue=b,this.modifications.contextValue=b,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(b){this._comments=b,this.modifications.comments=b,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(b){this._collapseState=b,this.modifications.collapsibleState=b,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(b){this._state=b,typeof b=="object"?((0,_.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=b.resolved,this.modifications.applicability=b.applicability):this.modifications.state=b,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(b,D,P,f,E,F,L,M,V){this._commentControllerHandle=D,this._id=P,this._uri=f,this._range=E,this._comments=F,this.extensionDescription=L,this._isTemplate=M,this.handle=r._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${b}.${this.handle}`),d.$createCommentThread(D,this.handle,this._id,this._uri,k.Range.from(this._range),this._comments.map(N=>l(this,N,this._commentsMap,this.extensionDescription)),L.identifier,this._isTemplate,V),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(D,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(N){W.range=N},get comments(){return W.comments},set comments(N){W.comments=N},get collapsibleState(){return W.collapsibleState},set collapsibleState(N){W.collapsibleState=N},get canReply(){return W.canReply},set canReply(N){W.canReply=N},get contextValue(){return W.contextValue},set contextValue(N){W.contextValue=N},get label(){return W.label},set label(N){W.label=N},get state(){return W.state},set state(N){W.state=N},reveal:N=>W.reveal(N),dispose:()=>{W.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const b=P=>Object.prototype.hasOwnProperty.call(this.modifications,P),D={};b("range")&&(D.range=k.Range.from(this._range)),b("label")&&(D.label=this.label),b("contextValue")&&(D.contextValue=this.contextValue??null),b("comments")&&(D.comments=this._comments.map(P=>l(this,P,this._commentsMap,this.extensionDescription))),b("collapsibleState")&&(D.collapseState=m(this._collapseState)),b("canReply")&&(D.canReply=this.canReply),b("state")&&(D.state=p(this._state)),b("applicability")&&(D.applicability=y(this._state)),b("isTemplate")&&(D.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,D)}getCommentByUniqueId(b){for(const D of this._commentsMap){const P=D[0],f=D[1];if(b===f)return P}}async reveal(b){return(0,_.checkProposedApiEnabled)(this.extensionDescription,"commentReveal"),d.$revealCommentThread(this._commentControllerHandle,this.handle,{preserveFocus:!1,focusReply:!1,...b})}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(b=>b.dispose())}}je([(0,T.debounce)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(b){this._commentingRangeProvider=b,b?.resourceHints&&(0,_.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),d.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(b){this._reactionHandler=b,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this._options}set options(b){this._options=b,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,_.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,_.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(b,D,P,f){this._extension=b,this._handle=D,this._id=P,this._label=f,this._threads=new Map,d.$registerCommentController(this.handle,P,f,this._extension.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(F){E.options=F},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(F){E.commentingRangeProvider=F},get reactionHandler(){return E.reactionHandler},set reactionHandler(F){E.reactionHandler=F},get activeCommentThread(){return E.activeCommentThread},createCommentThread(F,L,M){return E.createCommentThread(F,L,M).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(b,D,P){D===void 0&&(0,_.checkProposedApiEnabled)(this._extension,"fileComments");const f=new r(this.id,this.handle,void 0,b,D,P,this._extension,!1);return this._threads.set(f.handle,f),f}$setActiveComment(b){if(!b){this._activeComment=void 0,this._activeThread=void 0;return}const D=this._threads.get(b.commentThreadHandle);D&&(this._activeComment=b.uniqueIdInThread?D.getCommentByUniqueId(b.uniqueIdInThread):void 0,this._activeThread=D)}$createCommentThreadTemplate(b,D,P){const f=new r(this.id,this.handle,void 0,R.URI.revive(b),k.Range.to(D),[],this._extension,!0,P);return f.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(b,D){const P=this._threads.get(b);P&&(P.range=k.Range.to(D))}$deleteCommentThread(b){this._threads.get(b)?.dispose(),this._threads.delete(b)}getCommentThread(b){return this._threads.get(b)}dispose(){this._threads.forEach(b=>{b.dispose()}),this._localDisposables.forEach(b=>b.dispose())}}function l(C,b,D,P){let f=D.get(b);return f||(f=++C.commentHandle,D.set(b,f)),b.state!==void 0&&(0,_.checkProposedApiEnabled)(P,"commentsDraftState"),b.reactions?.some(E=>E.reactors!==void 0)&&(0,_.checkProposedApiEnabled)(P,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(E=>u(E)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function u(C){return{label:C.label,iconPath:C.iconPath?k.pathOrURIToURI(C.iconPath):void 0,count:C.count,hasReacted:C.authorHasReacted,reactors:C.reactors&&C.reactors.length>0&&typeof C.reactors[0]!="string"?C.reactors.map(b=>b.name):C.reactors}}function g(C){return{label:C.label||"",count:C.count||0,iconPath:C.iconPath?R.URI.revive(C.iconPath):"",authorHasReacted:C.hasReacted||!1,reactors:C.reactors?.map(b=>({name:b}))}}function m(C){if(C!==void 0)switch(C){case w.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case w.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function p(C){let b;if(typeof C=="object"?b=C.resolved:b=C,b!==void 0)switch(b){case w.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case w.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function y(C){let b;if(typeof C=="object"&&(b=C.applicability),b!==void 0)switch(b){case w.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case w.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new i}}),define(Te[278],Pe([1,0,22,76,4,16,24,2,8,68,80,5,7]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,v=$e(v),w=$e(w),c=$e(c);class _{constructor(u,g){this.document=u,this._storagePath=g,this._backupCounter=1,this._edits=new k.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,g){await this.getEdit(u).undo(),g||this.disposeBackup()}async redo(u,g){await this.getEdit(u).redo(),g||this.disposeBackup()}disposeEdits(u){for(const g of u)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const g=this._edits.get(u,0);if(!g)throw new Error("No edit found");return g}}class h{constructor(){this._documents=new Map}get(u,g){return this._documents.get(this.key(u,g))}add(u,g,m){const p=this.key(u,g.uri);if(this._documents.has(p))throw new Error(`Document already exists for viewType:${u} resource:${g.uri}`);const y=new _(g,m);return this._documents.set(p,y),y}delete(u,g){const m=this.key(u,g.uri);this._documents.delete(m)}key(u,g){return`${u}@@@${g}`}}var n;(function(l){l[l.Text=0]="Text",l[l.Custom=1]="Custom"})(n||(n={}));class s{constructor(){this._providers=new Map}addTextProvider(u,g,m){return this.add(u,{type:n.Text,extension:g,provider:m})}addCustomProvider(u,g,m){return this.add(u,{type:n.Custom,extension:g,provider:m})}get(u){return this._providers.get(u)}add(u,g){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,g),new c.Disposable(()=>this._providers.delete(u))}}class o{constructor(u,g,m,p,y){this._extHostDocuments=g,this._extensionStoragePaths=m,this._extHostWebview=p,this._extHostWebviewPanels=y,this._editorProviders=new s,this._documents=new h,this._proxy=u.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,g,m,p){const y=new I.DisposableStore;return i(m)?(y.add(this._editorProviders.addTextProvider(g,u,m)),this._proxy.$registerTextEditorProvider((0,a.toExtensionData)(u),g,p.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,a.shouldSerializeBuffersForPostMessage)(u))):(y.add(this._editorProviders.addCustomProvider(g,u,m)),d(m)&&y.add(m.onDidChangeCustomDocument(C=>{const b=this.getCustomDocumentEntry(g,C.document.uri);if(r(C)){const D=b.addEdit(C);this._proxy.$onDidEdit(C.document.uri,g,D,C.label)}else this._proxy.$onContentChange(C.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,a.toExtensionData)(u),g,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,a.shouldSerializeBuffersForPostMessage)(u))),c.Disposable.from(y,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(u,g,m,p,y){const C=this._editorProviders.get(g);if(!C)throw new Error(`No provider found for '${g}'`);if(C.type!==n.Custom)throw new Error(`Invalid provide type for '${g}'`);const b=R.URI.revive(u),D=await C.provider.openCustomDocument(b,{backupId:m,untitledDocumentData:p?.buffer},y);let P;return d(C.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(C.extension)??this._extensionStoragePaths.globalValue(C.extension)),this._documents.add(g,D,P),{editable:d(C.provider)}}async $disposeCustomDocument(u,g){const m=this._editorProviders.get(g);if(!m)throw new Error(`No provider found for '${g}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${g}'`);const p=R.URI.revive(u),{document:y}=this.getCustomDocumentEntry(g,p);this._documents.delete(g,y),y.dispose()}async $resolveCustomEditor(u,g,m,p,y,C){const b=this._editorProviders.get(m);if(!b)throw new Error(`No provider found for '${m}'`);const D=v.ViewColumn.to(y),P=this._extHostWebview.createNewWebview(g,p.contentOptions,b.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(g,m,p.title,D,p.options,P,p.active),E=R.URI.revive(u);switch(b.type){case n.Custom:{const{document:F}=this.getCustomDocumentEntry(m,E);return b.provider.resolveCustomEditor(F,f,C)}case n.Text:{const F=this._extHostDocuments.getDocument(E);return b.provider.resolveCustomTextEditor(F,f,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,g,m){this.getCustomDocumentEntry(g,u).disposeEdits(m)}async $onMoveCustomEditor(u,g,m){const p=this._editorProviders.get(m);if(!p)throw new Error(`No provider found for '${m}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const y=this._extHostWebviewPanels.getWebviewPanel(u);if(!y)throw new Error("No webview found");const C=R.URI.revive(g),b=this._extHostDocuments.getDocument(C);await p.provider.moveCustomTextEditor(b,y,S.CancellationToken.None)}async $undo(u,g,m,p){return this.getCustomDocumentEntry(g,u).undo(m,p)}async $redo(u,g,m,p){return this.getCustomDocumentEntry(g,u).redo(m,p)}async $revert(u,g,m){const p=this.getCustomDocumentEntry(g,u);await this.getCustomEditorProvider(g).revertCustomDocument(p.document,m),p.disposeBackup()}async $onSave(u,g,m){const p=this.getCustomDocumentEntry(g,u);await this.getCustomEditorProvider(g).saveCustomDocument(p.document,m),p.disposeBackup()}async $onSaveAs(u,g,m,p){const y=this.getCustomDocumentEntry(g,u);return this.getCustomEditorProvider(g).saveCustomDocumentAs(y.document,R.URI.revive(m),p)}async $backup(u,g,m){const p=this.getCustomDocumentEntry(g,u),C=await this.getCustomEditorProvider(g).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},m);return p.updateBackup(C),C.id}getCustomDocumentEntry(u,g){const m=this._documents.get(u,R.URI.revive(g));if(!m)throw new Error("No custom document found");return m}getCustomEditorProvider(u){const m=this._editorProviders.get(u)?.provider;if(!m||!d(m))throw new Error("Custom document is not editable");return m}}e.ExtHostCustomEditors=o;function d(l){return!!l.onDidChangeCustomDocument}function i(l){return typeof l.resolveCustomTextEditor=="function"}function r(l){return typeof l.undo=="function"&&typeof l.redo=="function"}function t(l){const u=l.scheme===O.Schemas.file||l.scheme===O.Schemas.untitled?l.fsPath:l.toString();return(0,T.hash)(u)+""}}),define(Te[279],Pe([1,0,181,108,2,5,7,8,6,12,29,51]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,R=$e(R);class _{#e;#t;#i;constructor(s,o,d,i,r,t,l,u){this._name=s,this._owner=o,this._maxDiagnosticsTotal=d,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=r,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,d),this.#i=new k.ResourceMap(g=>t.getComparisonKey(g)),this.#e=l,this.#t=u}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,o){if(!s){this.clear();return}this._checkDisposed();let d=[];if(I.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),d=[s]}else if(Array.isArray(s)){d=[];let t;s=[...s].sort(_._compareIndexedTuplesByUri);for(const l of s){const[u,g]=l;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,d.push(u),this.#i.set(u,[])),g)this.#i.get(u)?.push(...g);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(d),!this.#e)return;const i=[];let r=0;for(const t of d){let l=[];const u=this.#i.get(t);if(u)if(u.length>this._maxDiagnosticsPerFile){l=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const p of u)if(p.severity===g[m]&&l.push({...R.Diagnostic.from(p),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;l.push({severity:T.MarkerSeverity.Info,message:(0,S.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=u.map(g=>({...R.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(t)}));if(i.push([t,l]),r+=l.length,r>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(s){this._checkDisposed(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(s,o){this._checkDisposed();for(const[d,i]of this)s.call(o,d,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this._checkDisposed();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this.#i.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=_;let h=class{static{c=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*c._maxDiagnosticsPerFile}static _mapper(s){const o=new k.ResourceMap;for(const d of s)o.set(d,d);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,d,i){this._logService=o,this._fileSystemInfoService=d,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,c._mapper),this._proxy=s.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{_collections:d,_proxy:i,_onDidChangeDiagnostics:r,_logService:t,_fileSystemInfoService:l,_extHostDocumentsAndEditors:u}=this,g=new class{$changeMany(y,C){i.$changeMany(y,C),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,y,C.length===0?"CLEARING":C)}$clear(y){i.$clear(y),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,y)}dispose(){i.dispose()}};let m;if(!o)o="_generated_diagnostic_collection_name_#"+c._idPool++,m=o;else if(!d.has(o))m=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do m=o+c._idPool++;while(d.has(m))}return new class extends _{constructor(){super(o,m,c._maxDiagnosticsTotal,c._maxDiagnosticsPerFile,y=>u.getDocument(y)?.version,l.extUri,g,r),d.set(m,this)}dispose(){super.dispose(),d.delete(m)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const o=new Map,d=[];for(const i of this._collections.values())i.forEach((r,t)=>{let l=o.get(r.toString());typeof l>"u"&&(l=d.length,o.set(r.toString(),l),d.push([r,[]])),d[l][1]=d[l][1].concat(...t)});return d}}_getDiagnostics(s){let o=[];for(const d of this._collections.values())d.has(s)&&(o=o.concat(d.get(s)));return o}$acceptMarkersChange(s){if(!this._mirrorCollection){const o="_generated_mirror",d=new _(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,d),this._mirrorCollection=d}for(const[o,d]of s)this._mirrorCollection.set(I.URI.revive(o),d.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=h,e.ExtHostDiagnostics=h=c=je([Ve(1,a.ILogService),Ve(2,w.IExtHostFileSystemInfo)],h)}),define(Te[280],Pe([1,0,2,14,7,8,212,39]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(k,w,c,_={timeout:1500,errors:3}){this._logService=k,this._documents=w,this._mainThreadBulkEdits=c,this._thresholds=_,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(w,c,_)=>{const n={dispose:this._callbacks.push([w,c,k])};return Array.isArray(_)&&_.push(n),n}}async $participateInSave(k,w){const c=S.URI.revive(k);let _=!1;const h=setTimeout(()=>_=!0,this._thresholds.timeout),n=[];try{for(const s of[...this._callbacks]){if(_)break;const o=this._documents.getDocument(c),d=await this._deliverEventAsyncAndBlameBadListeners(s,{document:o,reason:O.TextDocumentSaveReason.to(w)});n.push(d)}}finally{clearTimeout(h)}return n}_deliverEventAsyncAndBlameBadListeners([k,w,c],_){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(c,k,w,_).then(()=>!0,n=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' threw ERROR`),this._logService.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const s=this._badListeners.get(k);this._badListeners.set(k,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,w,c,_){const h=[],n=Date.now(),{document:s,reason:o}=_,{version:d}=s,i=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(h))throw(0,T.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(r))}});try{w.apply(c,[i])}catch(r){return Promise.reject(r)}return Object.freeze(h),new Promise((r,t)=>{const l=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(u=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(l),r(u)}).catch(u=>{clearTimeout(l),t(u)})}).then(r=>{const t={edits:[]};for(const l of r)if(Array.isArray(l)&&l.every(u=>u instanceof I.TextEdit))for(const{newText:u,newEol:g,range:m}of l)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:u,eol:g&&O.EndOfLine.from(g)}});if(t.edits.length!==0)return d===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(Te[281],Pe([1,0,6,4,2,5,123,8,15,26,7]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,R=$e(R);class w{constructor(_,h){this._onDidAddDocument=new S.Emitter,this._onDidRemoveDocument=new S.Emitter,this._onDidChangeDocument=new S.Emitter,this._onDidSaveDocument=new S.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const s of n)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const s of n)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const h=this._documentsAndEditors.getDocument(_);if(h)return h}getDocument(_){const h=this.getDocumentData(_);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return h.document}ensureDocumentData(_){const h=this._documentsAndEditors.getDocument(_);if(h)return Promise.resolve(h);let n=this._documentLoader.get(_.toString());return n||(n=this._proxy.$tryOpenDocument(_).then(s=>{this._documentLoader.delete(_.toString());const o=I.URI.revive(s);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(o))},s=>(this._documentLoader.delete(_.toString()),Promise.reject(s))),this._documentLoader.set(_.toString(),n)),n}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(h=>I.URI.revive(h))}$acceptModelLanguageChanged(_,h){const n=I.URI.revive(_),s=this._documentsAndEditors.getDocument(n);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(h),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(_){const h=I.URI.revive(_),n=this._documentsAndEditors.getDocument(h);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(_,h){const n=I.URI.revive(_),s=this._documentsAndEditors.getDocument(n);if(!s)throw new Error("unknown document");s._acceptIsDirty(h),this._onDidChangeDocument.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,h,n){const s=I.URI.revive(_),o=this._documentsAndEditors.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(n),o.onEvents(h);let d;h.isUndoing?d=k.TextDocumentChangeReason.Undo:h.isRedoing&&(d=k.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,a.deepFreeze)({document:o.document,contentChanges:h.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:d}))}setWordDefinitionFor(_,h){(0,A.setWordDefinitionFor)(_,h)}}e.ExtHostDocuments=w}),define(Te[71],Pe([1,0,282,6,15,2,3,5,17,8,7]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,a=$e(a),e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class w{constructor(s,o,d){this._activeTabIdGetter=d,this._parentGroup=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this._apiObject){const s=this,o={get isActive(){return s._dto.id===s._activeTabIdGetter()},get label(){return s._dto.label},get input(){return s._input},get isDirty(){return s._dto.isDirty},get isPinned(){return s._dto.isPinned},get isPreview(){return s._dto.isPreview},get group(){return s._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(s){this._dto=s,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new k.TextTabInput(O.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new k.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new k.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new k.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new k.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new k.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new k.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new k.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new k.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new k.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new k.TextMultiDiffTabInput(this._dto.input.diffEditors.map(s=>new k.TextDiffTabInput(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class c{constructor(s,o){this._tabs=[],this._activeTabId="",this._dto=s,this._activeGroupIdGetter=o;for(const d of s.tabs)d.isActive&&(this._activeTabId=d.id),this._tabs.push(new w(d,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const s=this,o={get isActive(){return s._dto.groupId===s._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(s._dto.viewColumn)},get activeTab(){return s._tabs.find(d=>d.tabId===s._activeTabId)?.apiObject},get tabs(){return Object.freeze(s._tabs.map(d=>d.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(s){this._dto=s}acceptTabOperation(s){if(s.kind===R.TabModelOperationKind.TAB_OPEN){const d=new w(s.tabDto,this,()=>this.activeTabId());return this._tabs.splice(s.index,0,d),s.tabDto.isActive&&(this._activeTabId=d.tabId),d}else if(s.kind===R.TabModelOperationKind.TAB_CLOSE){const d=this._tabs.splice(s.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return d.tabId===this._activeTabId&&(this._activeTabId=""),d}else if(s.kind===R.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this._tabs.splice(s.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this._tabs.splice(s.index,0,d),d}const o=this._tabs.find(d=>d.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this._activeTabId=s.tabDto.id:this._activeTabId===s.tabDto.id&&!s.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this._activeTabId}}let _=class{constructor(s){this._onDidChangeTabs=new T.Emitter,this._onDidChangeTabGroups=new T.Emitter,this._extHostTabGroups=[],this._proxy=s.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const s=this,o={onDidChangeTabGroups:s._onDidChangeTabGroups.event,onDidChangeTabs:s._onDidChangeTabs.event,get all(){return Object.freeze(s._extHostTabGroups.map(d=>d.apiObject))},get activeTabGroup(){const d=s._activeGroupId;return(0,I.assertIsDefined)(s._extHostTabGroups.find(r=>r.groupId===d)?.apiObject)},close:async(d,i)=>{const r=Array.isArray(d)?d:[d];return r.length?h(r[0])?this._closeGroups(r,i):this._closeTabs(r,i):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(s){const o=new Set(this._extHostTabGroups.map(g=>g.groupId)),d=new Set(s.map(g=>g.groupId)),i=(0,S.diffSets)(o,d),r=this._extHostTabGroups.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],l=[];this._extHostTabGroups=s.map(g=>{const m=new c(g,()=>this._activeGroupId);return i.added.includes(m.groupId)?t.push(m.apiObject):l.push(m.apiObject),m});const u=(0,I.assertIsDefined)(s.find(g=>g.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:r,changed:l}))}$acceptTabGroupUpdate(s){const o=this._extHostTabGroups.find(d=>d.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this._activeGroupId=s.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this._extHostTabGroups.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const d=o.acceptTabOperation(s);switch(s.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}_findExtHostTabFromApi(s){for(const o of this._extHostTabGroups)for(const d of o.tabs)if(d.apiObject===s)return d}_findExtHostTabGroupFromApi(s){return this._extHostTabGroups.find(o=>o.apiObject===s)}async _closeTabs(s,o){const d=[];for(const i of s){const r=this._findExtHostTabFromApi(i);if(!r)throw new Error("Tab close: Invalid tab not found!");d.push(r.tabId)}return this._proxy.$closeTab(d,o)}async _closeGroups(s,o){const d=[];for(const i of s){const r=this._findExtHostTabGroupFromApi(i);if(!r)throw new Error("Group close: Invalid group not found!");d.push(r.groupId)}return this._proxy.$closeGroup(d,o)}};e.ExtHostEditorTabs=_,e.ExtHostEditorTabs=_=je([Ve(0,v.IExtHostRpcService)],_);function h(n){return n.tabs!==void 0}}),define(Te[283],Pe([1,0,2,5,30,4,7,8,327,13,28,23,25,60]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,I=$e(I),R=$e(R);class h{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const d=this._schemes.indexOf(o);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),d=[];let i,r,t=v.State.LastKnownState,l=v.State.LastKnownState;for(const u of o){let g=i?(0,a.commonPrefixLength)(i,u):0;for(g===0?r=v.State.Start:r=l;g<u.length;g++)g+1===u.length?(t=l,l=v.State.BeforeColon):l+=1,d.push([r,u.toUpperCase().charCodeAt(g),l]),d.push([r,u.toLowerCase().charCodeAt(g),l]),r=l;i=u,l=t}d.push([v.State.BeforeColon,k.CharCode.Colon,v.State.AfterColon]),d.push([v.State.AfterColon,k.CharCode.Slash,v.State.End]),this._stateMachine=new v.StateMachine(d)}}provideDocumentLinks(o){this._initStateMachine();const d=[],i=v.LinkComputer.computeLinks({getLineContent(r){return o.lineAt(r-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const r of i){const t=R.DocumentLink.to(r);t.target&&d.push(t)}return d}}class n{constructor(o,d){this._extHostLanguageFeatures=d,this._linkProvider=new h,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(o,d,i,r={}){if(n._validateFileSystemProvider(i),this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(o,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(t,i);let l=I.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(l+=I.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(l+=I.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(l+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,c.checkProposedApiEnabled)(o,"fsChunks"),l+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;r.isReadonly&&(0,_.isMarkdownString)(r.isReadonly)&&r.isReadonly.value!==""&&(u={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,d,l,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${d}`),console.error(m)});const g=i.onDidChangeFile(m=>{const p=[];for(const y of m){const{uri:C,type:b}=y;if(C.scheme!==d)continue;let D;switch(b){case A.FileChangeType.Changed:D=I.FileChangeType.UPDATED;break;case A.FileChangeType.Created:D=I.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:D=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:C,type:D})}this._proxy.$onFileSystemChange(t,p)});return(0,O.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(o){const{type:d,ctime:i,mtime:r,size:t,permissions:l}=o;return{type:d,ctime:i,mtime:r,size:t,permissions:l}}$stat(o,d){return Promise.resolve(this._getFsProvider(o).stat(S.URI.revive(d))).then(i=>n._asIStat(i))}$readdir(o,d){return Promise.resolve(this._getFsProvider(o).readDirectory(S.URI.revive(d)))}$readFile(o,d){return Promise.resolve(this._getFsProvider(o).readFile(S.URI.revive(d))).then(i=>w.VSBuffer.wrap(i))}$writeFile(o,d,i,r){return Promise.resolve(this._getFsProvider(o).writeFile(S.URI.revive(d),i.buffer,r))}$delete(o,d,i){return Promise.resolve(this._getFsProvider(o).delete(S.URI.revive(d),i))}$rename(o,d,i,r){return Promise.resolve(this._getFsProvider(o).rename(S.URI.revive(d),S.URI.revive(i),r))}$copy(o,d,i,r){const t=this._getFsProvider(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(S.URI.revive(d),S.URI.revive(i),r))}$mkdir(o,d){return Promise.resolve(this._getFsProvider(o).createDirectory(S.URI.revive(d)))}$watch(o,d,i,r){const t=this._getFsProvider(o).watch(S.URI.revive(i),r);this._watches.set(d,t)}$unwatch(o,d){const i=this._watches.get(d);i&&(i.dispose(),this._watches.delete(d))}$open(o,d,i){const r=this._getFsProvider(o);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(S.URI.revive(d),i))}$close(o,d){const i=this._getFsProvider(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(d))}$read(o,d,i,r){const t=this._getFsProvider(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const l=w.VSBuffer.alloc(r);return Promise.resolve(t.read(d,i,l.buffer,0,r)).then(u=>l.slice(0,u))}$write(o,d,i,r){const t=this._getFsProvider(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(d,i,r.buffer,0,r.byteLength))}_getFsProvider(o){const d=this._fsProvider.get(o);if(!d){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return d}}e.ExtHostFileSystem=n}),define(Te[284],Pe([1,0,6,42,2,5,8,7,30,48]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,A=$e(A);class k{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(h,n,s,o,d,i){this.session=Math.random(),this._onDidCreate=new S.Emitter,this._onDidChange=new S.Emitter,this._onDidDelete=new S.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const r=(0,T.parse)(d),t=typeof d=="string",l=i?.correlate,u=o(g=>{if(!(typeof g.session=="number"&&g.session!==this.session)&&!(l&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const m of g.created){const p=I.URI.revive(m);r(p.fsPath)&&(!t||n.getWorkspaceFolder(p))&&this._onDidCreate.fire(p)}if(!i?.ignoreChangeEvents)for(const m of g.changed){const p=I.URI.revive(m);r(p.fsPath)&&(!t||n.getWorkspaceFolder(p))&&this._onDidChange.fire(p)}if(!i?.ignoreDeleteEvents)for(const m of g.deleted){const p=I.URI.revive(m);r(p.fsPath)&&(!t||n.getWorkspaceFolder(p))&&this._onDidDelete.fire(p)}}});this._disposable=R.Disposable.from(this.ensureWatching(h,s,d,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,u)}ensureWatching(h,n,s,o,d){const i=R.Disposable.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const r=h.getProxy(O.MainContext.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(T.GLOBSTAR)||s.pattern.includes(T.GLOB_SPLIT))&&(t=!0);let l;return d&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(l=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,o?.ignoreChangeEvents&&(l&=~v.FileChangeFilter.UPDATED),o?.ignoreCreateEvents&&(l&=~v.FileChangeFilter.ADDED),o?.ignoreDeleteEvents&&(l&=~v.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.session,s.baseUri,{recursive:t,excludes:o?.excludes??[],filter:l},!!d),R.Disposable.from({dispose:()=>r.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class w{constructor(h){this._events=h,this.session=this._events.session,this._created=new a.Lazy(()=>this._events.created.map(I.URI.revive)),this._changed=new a.Lazy(()=>this._events.changed.map(I.URI.revive)),this._deleted=new a.Lazy(()=>this._events.deleted.map(I.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class c{constructor(h,n,s){this._mainContext=h,this._logService=n,this._extHostDocumentsAndEditors=s,this._onFileSystemEvent=new S.Emitter,this._onDidRenameFile=new S.Emitter,this._onDidCreateFile=new S.Emitter,this._onDidDeleteFile=new S.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(h,n,s,o){return new k(this._mainContext,h,n,this._onFileSystemEvent.event,A.GlobPattern.from(s),o)}$onFileEvent(h){this._onFileSystemEvent.fire(new w(h))}$onDidRunFileOperation(h,n){switch(h){case v.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:n.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))}));break;case v.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:n.map(s=>I.URI.revive(s.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:n.map(s=>I.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(h){return this._createWillExecuteEvent(h,this._onWillRenameFile)}getOnWillCreateFileEvent(h){return this._createWillExecuteEvent(h,this._onWillCreateFile)}getOnWillDeleteFileEvent(h){return this._createWillExecuteEvent(h,this._onWillDeleteFile)}_createWillExecuteEvent(h,n){return(s,o,d)=>{const i=function(t){s.call(o,t)};return i.extension=h,n.event(i,void 0,d)}}async $onWillRunFileOperation(h,n,s,o){switch(h){case v.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:n.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},s,o);case v.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:n.map(d=>I.URI.revive(d.target))},s,o);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:n.map(d=>I.URI.revive(d.target))},s,o)}}async _fireWillEvent(h,n,s,o){const d=new Set,i=[];if(await h.fireAsync(n,o,async(t,l)=>{const u=Date.now(),g=await Promise.resolve(t);g instanceof R.WorkspaceEdit&&(i.push([l.extension,g]),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-u>s&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:l}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this._extHostDocumentsAndEditors.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(l)}return{edit:r,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=c}),define(Te[285],Pe([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,183,19,8,7,25,80,5]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,n=$e(n),i=$e(i),u=$e(u);class g{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentSymbols(B,x){const H=this._documents.getDocument(B),j=await this._provider.provideDocumentSymbols(H,x);if(!(0,S.isFalsyOrEmpty)(j))return j[0]instanceof r.DocumentSymbol?j.map(i.DocumentSymbol.from):g._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((j,ne)=>{let fe=j.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(j.location.range.end)),fe});const x=[],H=[];for(const j of B){const ne={name:j.name||"!!MISSING: name!!",kind:i.SymbolKind.from(j.kind),tags:j.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:i.Range.from(j.location.range),selectionRange:i.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(ne),x.push(ne);break}const fe=H[H.length-1];if(_.Range.containsRange(fe.range,ne.range)&&!_.Range.equalsRange(fe.range,ne.range)){fe.children?.push(ne),H.push(ne);break}H.pop()}}return x}}class m{constructor(B,x,H,j,ne,fe){this._documents=B,this._commands=x,this._provider=H,this._extension=j,this._extTelemetry=ne,this._logService=fe,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,x){const H=this._documents.getDocument(B),j=await this._provider.provideCodeLenses(H,x);if(!j||x.isCancellationRequested)return;const ne=this._cache.add(j),fe=new R.DisposableStore;this._disposables.set(ne,fe);const ke={cacheId:ne,lenses:[]};for(let xe=0;xe<j.length;xe++)ke.lenses.push({cacheId:[ne,xe],range:i.Range.from(j[xe].range),command:this._commands.toInternal(j[xe].command,fe)});return ke}async resolveCodeLens(B,x){const H=B.cacheId&&this._cache.get(...B.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,x),j||(j=H),x.isCancellationRequested)return;const ne=B.cacheId&&this._disposables.get(B.cacheId[0]);if(ne){if(!j.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,fe),this._logService.error(fe);return}return B.command=this._commands.toInternal(j.command,ne),B}}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function p(Le){return Array.isArray(Le)?Le.map(i.DefinitionLink.from):Le?[i.DefinitionLink.from(Le)]:[]}class y{constructor(B,x){this._documents=B,this._provider=x}async provideDefinition(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideDefinition(j,ne,H);return p(fe)}}class C{constructor(B,x){this._documents=B,this._provider=x}async provideDeclaration(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideDeclaration(j,ne,H);return p(fe)}}class b{constructor(B,x){this._documents=B,this._provider=x}async provideImplementation(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideImplementation(j,ne,H);return p(fe)}}class D{constructor(B,x){this._documents=B,this._provider=x}async provideTypeDefinition(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideTypeDefinition(j,ne,H);return p(fe)}}class P{static{this.HOVER_MAP_MAX_SIZE=10}constructor(B,x){this._documents=B,this._provider=x,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x);let ke;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this._hoverMap.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};ke=await this._provider.provideHover(ne,fe,j,et)}else ke=await this._provider.provideHover(ne,fe,j);if(!ke||(0,S.isFalsyOrEmpty)(ke.contents))return;ke.range||(ke.range=ne.getWordRangeAtPosition(fe)),ke.range||(ke.range=new r.Range(fe,fe));const xe=i.Hover.from(ke),qe=this._hoverCounter;if(this._hoverMap.size===P.HOVER_MAP_MAX_SIZE){const tt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(tt)}return this._hoverMap.set(qe,ke),this._hoverCounter+=1,{...xe,id:qe}}releaseHover(B){this._hoverMap.delete(B)}}class f{constructor(B,x){this._documents=B,this._provider=x}async provideEvaluatableExpression(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideEvaluatableExpression(j,ne,H);if(fe)return i.EvaluatableExpression.from(fe)}}class E{constructor(B,x){this._documents=B,this._provider=x}async provideInlineValues(B,x,H,j){const ne=this._documents.getDocument(B),fe=await this._provider.provideInlineValues(ne,i.Range.to(x),i.InlineValueContext.to(H),j);if(Array.isArray(fe))return fe.map(ke=>i.InlineValue.from(ke))}}class F{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentHighlights(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideDocumentHighlights(j,ne,H);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class L{constructor(B,x){this._documents=B,this._provider=x}async provideMultiDocumentHighlights(B,x,H,j){const ne=this._documents.getDocument(B),fe=H.map(qe=>this._documents.getDocument(qe)),ke=i.Position.to(x),xe=await this._provider.provideMultiDocumentHighlights(ne,ke,fe,j);if(Array.isArray(xe))return xe.map(i.MultiDocumentHighlight.from)}}class M{constructor(B,x){this._documents=B,this._provider=x}async provideLinkedEditingRanges(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.provideLinkedEditingRanges(j,ne,H);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,S.coalesce)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class V{constructor(B,x){this._documents=B,this._provider=x}async provideReferences(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x),ke=await this._provider.provideReferences(ne,fe,H,j);if(Array.isArray(ke))return ke.map(i.location.from)}}class W{static{this._maxCodeActionsPerFile=1e3}constructor(B,x,H,j,ne,fe,ke){this._documents=B,this._commands=x,this._diagnostics=H,this._provider=j,this._logService=ne,this._extension=fe,this._apiDeprecation=ke,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,x,H,j){const ne=this._documents.getDocument(B),fe=h.Selection.isISelection(x)?i.Selection.to(x):i.Range.to(x),ke=[];for(const et of this._diagnostics.getDiagnostics(B))if(fe.intersection(et.range)&&ke.push(et)>W._maxCodeActionsPerFile)break;const xe={diagnostics:ke,only:H.only?new r.CodeActionKind(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},qe=await this._provider.provideCodeActions(ne,fe,xe,j);if(!(0,S.isNonEmptyArray)(qe)||j.isCancellationRequested)return;const Ze=this._cache.add(qe),tt=new R.DisposableStore;this._disposables.set(Ze,tt);const nt=[];for(let et=0;et<qe.length;et++){const rt=qe[et];if(rt)if(W._isCommand(rt))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,tt)});else{xe.only&&(rt.kind?xe.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[Ze,et],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?rt.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,S.coalesce)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Ze,actions:nt}}async resolveCodeAction(B,x){const[H,j]=B,ne=this._cache.get(H,j);if(!ne||W._isCommand(ne))return{};if(!this._provider.resolveCodeAction)return{};const fe=await this._provider.resolveCodeAction(ne,x)??ne;let ke;fe.edit&&(ke=i.WorkspaceEdit.from(fe.edit,void 0));let xe;if(fe.command){const qe=this._disposables.get(H);qe&&(xe=this._commands.toInternal(fe.command,qe))}return{edit:ke,command:xe}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class N{constructor(B,x,H,j,ne){this._proxy=B,this._documents=x,this._provider=H,this._handle=j,this._extension=ne,this._cache=new l.Cache("DocumentPasteEdit")}async prepareDocumentPaste(B,x,H,j){if(!this._provider.prepareDocumentPaste)return;const ne=this._documents.getDocument(B),fe=x.map(qe=>i.Range.to(qe)),ke=i.DataTransfer.toDataTransfer(H,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(ne,fe,ke,j),j.isCancellationRequested)return;const xe=Array.from(ke).filter(([,qe])=>!(qe instanceof r.InternalDataTransferItem));return i.DataTransfer.from(xe)}async providePasteEdits(B,x,H,j,ne,fe){if(!this._provider.provideDocumentPasteEdits)return[];const ke=this._documents.getDocument(x),xe=H.map(nt=>i.Range.to(nt)),qe=i.DataTransfer.toDataTransfer(j,async nt=>(await this._proxy.$resolvePasteFileData(this._handle,B,nt)).buffer),Ze=await this._provider.provideDocumentPasteEdits(ke,xe,qe,{only:ne.only?new r.DocumentDropOrPasteEditKind(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!Ze||fe.isCancellationRequested)return[];const tt=this._cache.add(Ze);return Ze.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(0,null,this._extension.displayName||this._extension.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,x){const[H,j]=B,ne=this._cache.get(H,j);if(!ne||!this._provider.resolveDocumentPasteEdit)return{};const fe=await this._provider.resolveDocumentPasteEdit(ne,x)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(B){this._cache.delete(B)}}class Q{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentFormattingEdits(B,x,H){const j=this._documents.getDocument(B),ne=await this._provider.provideDocumentFormattingEdits(j,x,H);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class Y{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeFormattingEdits(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Range.to(x),ke=await this._provider.provideDocumentRangeFormattingEdits(ne,fe,H,j);if(Array.isArray(ke))return ke.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,x,H,j){(0,w.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this._documents.getDocument(B),fe=x.map(i.Range.to),ke=await this._provider.provideDocumentRangesFormattingEdits(ne,fe,H,j);if(Array.isArray(ke))return ke.map(i.TextEdit.from)}}class ge{constructor(B,x){this._documents=B,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,x,H,j,ne){const fe=this._documents.getDocument(B),ke=i.Position.to(x),xe=await this._provider.provideOnTypeFormattingEdits(fe,ke,H,j,ne);if(Array.isArray(xe))return xe.map(i.TextEdit.from)}}class Z{constructor(B,x){this._provider=B,this._logService=x,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,x){const H=await this._provider.provideWorkspaceSymbols(B,x);if(!(0,S.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),ne={cacheId:j,symbols:[]};for(let fe=0;fe<H.length;fe++){const ke=H[fe];if(!ke||!ke.name){this._logService.warn("INVALID SymbolInformation",ke);continue}ne.symbols.push({...i.WorkspaceSymbol.from(ke),cacheId:[j,fe]})}return ne}async resolveWorkspaceSymbol(B,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this._cache.get(...B.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,x);return j&&(0,v.mixin)(B,i.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class me{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,x,H){this._documents=B,this._provider=x,this._logService=H}async provideRenameEdits(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x);try{const ke=await this._provider.provideRenameEdits(ne,fe,H,j);return ke?i.WorkspaceEdit.from(ke):void 0}catch(ke){const xe=me._asMessage(ke);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(B,x,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(B),ne=i.Position.to(x);try{const fe=await this._provider.prepareRename(j,ne,H);let ke,xe;if(r.Range.isRange(fe)?(ke=fe,xe=j.getText(fe)):(0,w.isObject)(fe)&&(ke=fe.range,xe=fe.placeholder),!ke||!xe)return;if(ke.start.line>ne.line||ke.end.line<ne.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ke),text:xe}}catch(fe){const ke=me._asMessage(fe);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(fe)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class se{static{this.languageTriggerKindToVSCodeTriggerKind={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(B,x,H){this._documents=B,this._provider=x,this._logService=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Range.to(x);try{const ke=se.languageTriggerKindToVSCodeTriggerKind[H],xe=await this._provider.provideNewSymbolNames(ne,fe,ke,j);return xe?xe.map(qe=>typeof qe=="string"?{newSymbolName:qe}:{newSymbolName:qe.newSymbolName,tags:qe.tags}):void 0}catch(ke){this._logService.error(se._asMessage(ke)??JSON.stringify(ke,null,"	"));return}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class le{constructor(B,x){this.resultId=B,this.tokens=x}}class Ee{constructor(B,x){this._documents=B,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,x,H){const j=this._documents.getDocument(B),ne=x!==0?this._previousResults.get(x):null;let fe=typeof ne?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ne.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return ne&&this._previousResults.delete(x),fe?(fe=Ee._fixProvidedSemanticTokens(fe),this._send(Ee._convertToEdits(ne,fe),fe)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return Ee._isSemanticTokens(B)?Ee._isCorrectSemanticTokens(B)?B:new r.SemanticTokens(new Uint32Array(B.data),B.resultId):Ee._isSemanticTokensEdits(B)?Ee._isCorrectSemanticTokensEdits(B)?B:new r.SemanticTokensEdits(B.edits.map(x=>new r.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const x of B.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,x){if(!Ee._isSemanticTokens(x)||!B||!B.tokens)return x;const H=B.tokens,j=H.length,ne=x.data,fe=ne.length;let ke=0;const xe=Math.min(j,fe);for(;ke<xe&&H[ke]===ne[ke];)ke++;if(ke===j&&ke===fe)return new r.SemanticTokensEdits([],x.resultId);let qe=0;const Ze=xe-ke;for(;qe<Ze&&H[j-qe-1]===ne[fe-qe-1];)qe++;return new r.SemanticTokensEdits([{start:ke,deleteCount:j-ke-qe,data:ne.subarray(ke,fe-qe)}],x.resultId)}_send(B,x){if(Ee._isSemanticTokens(B)){const H=this._nextResultId++;return this._previousResults.set(H,new le(B.resultId,B.data)),(0,s.encodeSemanticTokensDto)({id:H,type:"full",data:B.data})}if(Ee._isSemanticTokensEdits(B)){const H=this._nextResultId++;return Ee._isSemanticTokens(x)?this._previousResults.set(H,new le(x.resultId,x.data)):this._previousResults.set(H,new le(B.resultId)),(0,s.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(B.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class oe{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeSemanticTokens(B,x,H){const j=this._documents.getDocument(B),ne=await this._provider.provideDocumentRangeSemanticTokens(j,i.Range.to(x),H);return ne?this._send(ne):null}_send(B){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class Ie{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,x,H,j,ne){this._documents=B,this._commands=x,this._provider=H,this._apiDeprecation=j,this._extension=ne,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x),ke=ne.getWordRangeAtPosition(fe)||new r.Range(fe,fe),xe=ke.with({end:fe}),qe=new a.StopWatch,Ze=await this._provider.provideCompletionItems(ne,fe,j,i.CompletionContext.to(H));if(!Ze||j.isCancellationRequested)return;const tt=Array.isArray(Ze)?new r.CompletionList(Ze):Ze,nt=Ie.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),et=new R.DisposableStore;this._disposables.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(ke),insert:i.Range.from(xe)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:qe.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this._convertCompletionItem(st,[nt,lt],xe,ke);rt.push(ct)}return ft}async resolveCompletionItem(B,x){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...B);if(!H)return;const j=this._convertCompletionItem(H,B),ne=await this._provider.resolveCompletionItem(H,x);if(!ne)return;const fe=this._convertCompletionItem(ne,B);return(j[u.ISuggestDataDtoField.insertText]!==fe[u.ISuggestDataDtoField.insertText]||j[u.ISuggestDataDtoField.insertTextRules]!==fe[u.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j[u.ISuggestDataDtoField.commandIdent]!==fe[u.ISuggestDataDtoField.commandIdent]||j[u.ISuggestDataDtoField.commandId]!==fe[u.ISuggestDataDtoField.commandId]||!(0,v.equals)(j[u.ISuggestDataDtoField.commandArguments],fe[u.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,[u.ISuggestDataDtoField.documentation]:fe[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:fe[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:fe[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:fe[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:fe[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:fe[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:fe[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:fe[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,x,H,j){const ne=this._disposables.get(x[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this._commands.toInternal(B.command,ne),ke={x,[u.ISuggestDataDtoField.label]:B.label,[u.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:B.detail,[u.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[u.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[u.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[u.ISuggestDataDtoField.preselect]:B.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:fe?.$ident,[u.ISuggestDataDtoField.commandId]:fe?.id,[u.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke[u.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?ke[u.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof r.SnippetString&&(ke[u.ISuggestDataDtoField.insertText]=B.insertText.value,ke[u.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let xe;return B.textEdit?xe=B.textEdit.range:B.range&&(xe=B.range),r.Range.isRange(xe)?ke[u.ISuggestDataDtoField.range]=i.Range.from(xe):xe&&(!H?.isEqual(xe.inserting)||!j?.isEqual(xe.replacing))&&(ke[u.ISuggestDataDtoField.range]={insert:i.Range.from(xe.inserting),replace:i.Range.from(xe.replacing)}),ke}}class Me{async provideInlineCompletions(B,x,H,j){}async provideInlineEdits(B,x,H,j){}disposeCompletions(B){}handleDidShowCompletionItem(B,x,H){}handlePartialAccept(B,x,H,j){}}class X extends Me{constructor(B,x,H,j){super(),this._extension=B,this._documents=x,this._provider=H,this._commands=j,this._references=new te,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x),ke=await this._provider.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!ke||j.isCancellationRequested)return;const xe=Array.isArray(ke)?ke:ke.items,qe=this._isAdditionsProposedApiEnabled?Array.isArray(ke)?[]:ke.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:xe}),items:xe.map((et,rt)=>{let ft;et.command&&(tt||(tt=new R.DisposableStore),ft=this._commands.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:qe.map(et=>(tt||(tt=new R.DisposableStore),this._commands.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}async provideInlineEdits(B,x,H,j){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const ne=this._documents.getDocument(B),fe=i.Range.to(x),ke=await this._provider.provideInlineEdits(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind],userPrompt:H.userPrompt},j);if(!ke||j.isCancellationRequested)return;const xe=Array.isArray(ke)?ke:ke.items,qe=this._isAdditionsProposedApiEnabled?Array.isArray(ke)?[]:ke.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:xe}),items:xe.map((et,rt)=>{let ft;et.command&&(tt||(tt=new R.DisposableStore),ft=this._commands.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:qe.map(et=>(tt||(tt=new R.DisposableStore),this._commands.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,x,H){const j=this._references.get(B)?.items[x];j&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(j,H)}handlePartialAccept(B,x,H,j){const ne=this._references.get(B)?.items[x];ne&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(ne,H),this._provider.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(j)))}}class ${async provideInlineEdits(B,x,H){const j=this._documents.getDocument(B),ne=await this._provider.provideInlineEdit(j,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[x.triggerKind]},H);if(!ne||H.isCancellationRequested)return;let fe;const ke=this._references.createReferenceId({dispose(){fe?.dispose()},item:ne});let xe;ne.accepted&&(fe||(fe=new R.DisposableStore),xe=this._commands.toInternal(ne.accepted,fe));let qe;return ne.rejected&&(fe||(fe=new R.DisposableStore),qe=this._commands.toInternal(ne.rejected,fe)),{pid:ke,text:ne.text,range:i.Range.from(ne.range),accepted:xe,rejected:qe}}disposeEdit(B){this._references.disposeReferenceId(B)?.dispose()}constructor(B,x,H,j){this._documents=x,this._provider=H,this._commands=j,this._references=new te,this.languageTriggerKindToVSCodeTriggerKind={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const x=this._idPool++;return this._references.set(x,B),x}disposeReferenceId(B){const x=this._references.get(B);return this._references.delete(B),x}get(B){return this._references.get(B)}}class Se{constructor(B,x){this._documents=B,this._provider=x,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(B,x,H,j){const ne=this._documents.getDocument(B),fe=i.Position.to(x),ke=this.reviveContext(H),xe=await this._provider.provideSignatureHelp(ne,fe,j,ke);if(xe){const qe=this._cache.add([xe]);return{...i.SignatureHelp.from(xe),id:qe}}}reviveContext(B){let x;if(B.activeSignatureHelp){const H=i.SignatureHelp.to(B.activeSignatureHelp),j=this._cache.get(B.activeSignatureHelp.id,0);j?(x=j,x.activeSignature=H.activeSignature,x.activeParameter=H.activeParameter):x=H}return{...B,activeSignatureHelp:x}}releaseSignatureHelp(B){this._cache.delete(B)}}class ce{constructor(B,x,H,j,ne){this._documents=B,this._commands=x,this._provider=H,this._logService=j,this._extension=ne,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,x,H){const j=this._documents.getDocument(B),ne=i.Range.to(x),fe=await this._provider.provideInlayHints(j,ne,H);if(!Array.isArray(fe)||fe.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`);return}if(H.isCancellationRequested)return;const ke=this._cache.add(fe);this._disposables.set(ke,new R.DisposableStore);const xe={hints:[],cacheId:ke};for(let qe=0;qe<fe.length;qe++)this._isValidInlayHint(fe[qe],ne)&&xe.hints.push(this._convertInlayHint(fe[qe],[ke,qe]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`),xe}async resolveInlayHint(B,x){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...B);if(!H)return;const j=await this._provider.resolveInlayHint(H,x);if(j&&this._isValidInlayHint(j))return this._convertInlayHint(j,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,x){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(x&&!x.contains(B.position))}_convertInlayHint(B,x){const H=this._disposables.get(x[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:x,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")j.label=B.label;else{const ne=[];j.label=ne;for(const fe of B.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const ke={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.Location.isLocation(fe.location)&&(ke.location=i.location.from(fe.location)),fe.command&&(ke.command=this._commands.toInternal(fe.command,H)),ne.push(ke)}}return j}}class be{constructor(B,x){this._documents=B,this._provider=x,this._cache=new l.Cache("DocumentLink")}async provideLinks(B,x){const H=this._documents.getDocument(B),j=await this._provider.provideDocumentLinks(H,x);if(!(!Array.isArray(j)||j.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(be._validateLink).map(i.DocumentLink.from)};{const ne=this._cache.add(j),fe={links:[],cacheId:ne};for(let ke=0;ke<j.length;ke++){if(!be._validateLink(j[ke]))continue;const xe=i.DocumentLink.from(j[ke]);xe.cacheId=[ne,ke],fe.links.push(xe)}return fe}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,x){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...B);if(!H)return;const j=await this._provider.resolveDocumentLink(H,x);if(!(!j||!be._validateLink(j)))return i.DocumentLink.from(j)}releaseLinks(B){this._cache.delete(B)}}class he{constructor(B,x){this._documents=B,this._provider=x}async provideColors(B,x){const H=this._documents.getDocument(B),j=await this._provider.provideDocumentColors(H,x);return Array.isArray(j)?j.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(B,x,H){const j=this._documents.getDocument(B),ne=i.Range.to(x.range),fe=i.Color.to(x.color),ke=await this._provider.provideColorPresentations(fe,{document:j,range:ne},H);if(Array.isArray(ke))return ke.map(i.ColorPresentation.from)}}class G{constructor(B,x){this._documents=B,this._provider=x}async provideFoldingRanges(B,x,H){const j=this._documents.getDocument(B),ne=await this._provider.provideFoldingRanges(j,x,H);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class J{constructor(B,x,H){this._documents=B,this._provider=x,this._logService=H}async provideSelectionRanges(B,x,H){const j=this._documents.getDocument(B),ne=x.map(i.Position.to),fe=await this._provider.provideSelectionRanges(j,ne,H);if(!(0,S.isNonEmptyArray)(fe))return[];if(fe.length!==ne.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let xe=0;xe<ne.length;xe++){const qe=[];ke.push(qe);let Ze=ne[xe],tt=fe[xe];for(;;){if(!tt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(i.SelectionRange.from(tt)),!tt.parent)break;Ze=tt.range,tt=tt.parent}}return ke}}class pe{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.prepareCallHierarchy(j,ne,H);if(!fe)return;const ke=this._idPool.nextId();return this._cache.set(ke,new Map),Array.isArray(fe)?fe.map(xe=>this._cacheAndConvertItem(ke,xe)):[this._cacheAndConvertItem(ke,fe)]}async provideCallsTo(B,x,H){const j=this._itemFromCache(B,x);if(!j)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(ne)return ne.map(fe=>({from:this._cacheAndConvertItem(B,fe.from),fromRanges:fe.fromRanges.map(ke=>i.Range.from(ke))}))}async provideCallsFrom(B,x,H){const j=this._itemFromCache(B,x);if(!j)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(ne)return ne.map(fe=>({to:this._cacheAndConvertItem(B,fe.to),fromRanges:fe.fromRanges.map(ke=>i.Range.from(ke))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const H=this._cache.get(B),j=i.CallHierarchyItem.from(x,B,H.size.toString(36));return H.set(j._itemId,x),j}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class ve{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,H){const j=this._documents.getDocument(B),ne=i.Position.to(x),fe=await this._provider.prepareTypeHierarchy(j,ne,H);if(!fe)return;const ke=this._idPool.nextId();return this._cache.set(ke,new Map),Array.isArray(fe)?fe.map(xe=>this._cacheAndConvertItem(ke,xe)):[this._cacheAndConvertItem(ke,fe)]}async provideSupertypes(B,x,H){const j=this._itemFromCache(B,x);if(!j)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySupertypes(j,H);if(ne)return ne.map(fe=>this._cacheAndConvertItem(B,fe))}async provideSubtypes(B,x,H){const j=this._itemFromCache(B,x);if(!j)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySubtypes(j,H);if(ne)return ne.map(fe=>this._cacheAndConvertItem(B,fe))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const H=this._cache.get(B),j=i.TypeHierarchyItem.from(x,B,H.size.toString(36));return H.set(j._itemId,x),j}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class Oe{constructor(B,x,H,j,ne){this._proxy=B,this._documents=x,this._provider=H,this._handle=j,this._extension=ne,this._cache=new l.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(B,x,H,j,ne){const fe=this._documents.getDocument(x),ke=i.Position.to(H),xe=i.DataTransfer.toDataTransfer(j,async nt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,nt)).buffer),qe=await this._provider.provideDocumentDropEdits(fe,ke,xe,ne);if(!qe)return;const Ze=(0,S.asArray)(qe),tt=this._cache.add(Ze);return Ze.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,o.localize)(1,null,this._extension.displayName||this._extension.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,x){const[H,j]=B,ne=this._cache.get(H,j);if(!ne||!this._provider.resolveDocumentDropEdit)return{};const fe=await this._provider.resolveDocumentDropEdit(ne,x)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(B){this._cache.delete(B)}}class Ue{constructor(B,x){this._documents=B,this._provider=x}async provideMappedEdits(B,x,H,j){const ne=c.URI.revive(B),fe=this._documents.getDocument(ne),ke=H.documents.map(Ze=>Ze.map(tt=>({uri:c.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),xe={documents:ke,selections:ke[0]?.[0]?.ranges??[]},qe=await this._provider.provideMappedEdits(fe,x,xe,j);return qe?i.WorkspaceEdit.from(qe):null}}class De{constructor(B,x){this.adapter=B,this.extension=x}}class Ae{static{this._handlePool=0}constructor(B,x,H,j,ne,fe,ke,xe){this._uriTransformer=x,this._documents=H,this._commands=j,this._diagnostics=ne,this._logService=fe,this._apiDeprecation=ke,this._extensionTelemetry=xe,this._adapter=new Map,this._proxy=B.getProxy(u.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,x){return i.DocumentSelector.from(B,this._uriTransformer,x)}_createDisposable(B){return new r.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Ae._handlePool++}async _withAdapter(B,x,H,j,ne,fe=!1){const ke=this._adapter.get(B);if(!ke||!(ke.adapter instanceof x))return j;const xe=Date.now();fe||this._logService.trace(`[${ke.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const qe=H(ke.adapter,ke.extension);return Promise.resolve(qe).catch(Ze=>{(0,O.isCancellationError)(Ze)||(this._logService.error(`[${ke.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(ke.extension.identifier,Ze))}).finally(()=>{fe||this._logService.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-xe}ms`)}),I.CancellationToken.isCancellationToken(ne)?(0,T.raceCancellationError)(qe,ne):qe}_addNewAdapter(B,x){const H=this._nextHandle();return this._adapter.set(H,new De(B,x)),H}static _extLabel(B){return B.displayName||B.name}static _extId(B){return B.identifier.value}registerDocumentSymbolProvider(B,x,H,j){const ne=this._addNewAdapter(new g(this._documents,H),B),fe=j&&j.label||Ae._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(ne,this._transformDocumentSelector(x,B),fe),this._createDisposable(ne)}$provideDocumentSymbols(B,x,H){return this._withAdapter(B,g,j=>j.provideDocumentSymbols(c.URI.revive(x),H),void 0,H)}registerCodeLensProvider(B,x,H){const j=this._nextHandle(),ne=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new De(new m(this._documents,this._commands.converter,H,B,this._extensionTelemetry,this._logService),B)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(x,B),ne);let fe=this._createDisposable(j);if(ne!==void 0){const ke=H.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(ne));fe=r.Disposable.from(fe,ke)}return fe}$provideCodeLenses(B,x,H){return this._withAdapter(B,m,j=>j.provideCodeLenses(c.URI.revive(x),H),void 0,H)}$resolveCodeLens(B,x,H){return this._withAdapter(B,m,j=>j.resolveCodeLens(x,H),void 0,void 0)}$releaseCodeLenses(B,x){this._withAdapter(B,m,H=>Promise.resolve(H.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(B,x,H){const j=this._addNewAdapter(new y(this._documents,H),B);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideDefinition(B,x,H,j){return this._withAdapter(B,y,ne=>ne.provideDefinition(c.URI.revive(x),H,j),[],j)}registerDeclarationProvider(B,x,H){const j=this._addNewAdapter(new C(this._documents,H),B);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideDeclaration(B,x,H,j){return this._withAdapter(B,C,ne=>ne.provideDeclaration(c.URI.revive(x),H,j),[],j)}registerImplementationProvider(B,x,H){const j=this._addNewAdapter(new b(this._documents,H),B);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideImplementation(B,x,H,j){return this._withAdapter(B,b,ne=>ne.provideImplementation(c.URI.revive(x),H,j),[],j)}registerTypeDefinitionProvider(B,x,H){const j=this._addNewAdapter(new D(this._documents,H),B);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideTypeDefinition(B,x,H,j){return this._withAdapter(B,D,ne=>ne.provideTypeDefinition(c.URI.revive(x),H,j),[],j)}registerHoverProvider(B,x,H,j){const ne=this._addNewAdapter(new P(this._documents,H),B);return this._proxy.$registerHoverProvider(ne,this._transformDocumentSelector(x,B)),this._createDisposable(ne)}$provideHover(B,x,H,j,ne){return this._withAdapter(B,P,fe=>fe.provideHover(c.URI.revive(x),H,j,ne),void 0,ne)}$releaseHover(B,x){this._withAdapter(B,P,H=>Promise.resolve(H.releaseHover(x)),void 0,void 0)}registerEvaluatableExpressionProvider(B,x,H,j){const ne=this._addNewAdapter(new f(this._documents,H),B);return this._proxy.$registerEvaluatableExpressionProvider(ne,this._transformDocumentSelector(x,B)),this._createDisposable(ne)}$provideEvaluatableExpression(B,x,H,j){return this._withAdapter(B,f,ne=>ne.provideEvaluatableExpression(c.URI.revive(x),H,j),void 0,j)}registerInlineValuesProvider(B,x,H,j){const ne=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new E(this._documents,H),B);this._proxy.$registerInlineValuesProvider(fe,this._transformDocumentSelector(x,B),ne);let ke=this._createDisposable(fe);if(ne!==void 0){const xe=H.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(ne));ke=r.Disposable.from(ke,xe)}return ke}$provideInlineValues(B,x,H,j,ne){return this._withAdapter(B,E,fe=>fe.provideInlineValues(c.URI.revive(x),H,j,ne),void 0,ne)}registerDocumentHighlightProvider(B,x,H){const j=this._addNewAdapter(new F(this._documents,H),B);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}registerMultiDocumentHighlightProvider(B,x,H){const j=this._addNewAdapter(new L(this._documents,H),B);return this._proxy.$registerMultiDocumentHighlightProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideDocumentHighlights(B,x,H,j){return this._withAdapter(B,F,ne=>ne.provideDocumentHighlights(c.URI.revive(x),H,j),void 0,j)}$provideMultiDocumentHighlights(B,x,H,j,ne){return this._withAdapter(B,L,fe=>fe.provideMultiDocumentHighlights(c.URI.revive(x),H,j.map(ke=>c.URI.revive(ke)),ne),void 0,ne)}registerLinkedEditingRangeProvider(B,x,H){const j=this._addNewAdapter(new M(this._documents,H),B);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideLinkedEditingRanges(B,x,H,j){return this._withAdapter(B,M,async ne=>{const fe=await ne.provideLinkedEditingRanges(c.URI.revive(x),H,j);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Ae._serializeRegExp(fe.wordPattern):void 0}},void 0,j)}registerReferenceProvider(B,x,H){const j=this._addNewAdapter(new V(this._documents,H),B);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideReferences(B,x,H,j,ne){return this._withAdapter(B,V,fe=>fe.provideReferences(c.URI.revive(x),H,j,ne),void 0,ne)}registerCodeActionProvider(B,x,H,j){const ne=new R.DisposableStore,fe=this._addNewAdapter(new W(this._documents,this._commands.converter,this._diagnostics,H,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerCodeActionSupport(fe,this._transformDocumentSelector(x,B),{providedKinds:j?.providedCodeActionKinds?.map(ke=>ke.value),documentation:j?.documentation?.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,ne)}))},Ae._extLabel(B),Ae._extId(B),!!H.resolveCodeAction),ne.add(this._createDisposable(fe)),ne}$provideCodeActions(B,x,H,j,ne){return this._withAdapter(B,W,fe=>fe.provideCodeActions(c.URI.revive(x),H,j,ne),void 0,ne)}$resolveCodeAction(B,x,H){return this._withAdapter(B,W,j=>j.resolveCodeAction(x,H),{},void 0)}$releaseCodeActions(B,x){this._withAdapter(B,W,H=>Promise.resolve(H.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(B,x,H){const j=this._addNewAdapter(new Q(this._documents,H),B);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name),this._createDisposable(j)}$provideDocumentFormattingEdits(B,x,H,j){return this._withAdapter(B,Q,ne=>ne.provideDocumentFormattingEdits(c.URI.revive(x),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(B,x,H){const j=typeof H.provideDocumentRangesFormattingEdits=="function",ne=this._addNewAdapter(new Y(this._documents,H),B);return this._proxy.$registerRangeFormattingSupport(ne,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name,j),this._createDisposable(ne)}$provideDocumentRangeFormattingEdits(B,x,H,j,ne){return this._withAdapter(B,Y,fe=>fe.provideDocumentRangeFormattingEdits(c.URI.revive(x),H,j,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(B,x,H,j,ne){return this._withAdapter(B,Y,fe=>fe.provideDocumentRangesFormattingEdits(c.URI.revive(x),H,j,ne),void 0,ne)}registerOnTypeFormattingEditProvider(B,x,H,j){const ne=this._addNewAdapter(new ge(this._documents,H),B);return this._proxy.$registerOnTypeFormattingSupport(ne,this._transformDocumentSelector(x,B),j,B.identifier),this._createDisposable(ne)}$provideOnTypeFormattingEdits(B,x,H,j,ne,fe){return this._withAdapter(B,ge,ke=>ke.provideOnTypeFormattingEdits(c.URI.revive(x),H,j,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(B,x){const H=this._addNewAdapter(new Z(x,this._logService),B);return this._proxy.$registerNavigateTypeSupport(H,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(B,x,H){return this._withAdapter(B,Z,j=>j.provideWorkspaceSymbols(x,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,x,H){return this._withAdapter(B,Z,j=>j.resolveWorkspaceSymbol(x,H),void 0,void 0)}$releaseWorkspaceSymbols(B,x){this._withAdapter(B,Z,H=>H.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(B,x,H){const j=this._addNewAdapter(new me(this._documents,H,this._logService),B);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(x,B),me.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(B,x,H,j,ne){return this._withAdapter(B,me,fe=>fe.provideRenameEdits(c.URI.revive(x),H,j,ne),void 0,ne)}$resolveRenameLocation(B,x,H,j){return this._withAdapter(B,me,ne=>ne.resolveRenameLocation(c.URI.revive(x),H,j),void 0,j)}registerNewSymbolNamesProvider(B,x,H){const j=this._addNewAdapter(new se(this._documents,H,this._logService),B);return this._proxy.$registerNewSymbolNamesProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this._withAdapter(B,se,x=>x.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,x,H,j,ne){return this._withAdapter(B,se,fe=>fe.provideNewSymbolNames(c.URI.revive(x),H,j,ne),void 0,ne)}registerDocumentSemanticTokensProvider(B,x,H,j){const ne=this._addNewAdapter(new Ee(this._documents,H),B),fe=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ne,this._transformDocumentSelector(x,B),j,fe);let ke=this._createDisposable(ne);if(fe){const xe=H.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(fe));ke=r.Disposable.from(ke,xe)}return ke}$provideDocumentSemanticTokens(B,x,H,j){return this._withAdapter(B,Ee,ne=>ne.provideDocumentSemanticTokens(c.URI.revive(x),H,j),null,j)}$releaseDocumentSemanticTokens(B,x){this._withAdapter(B,Ee,H=>H.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,x,H,j){const ne=this._addNewAdapter(new oe(this._documents,H),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ne,this._transformDocumentSelector(x,B),j),this._createDisposable(ne)}$provideDocumentRangeSemanticTokens(B,x,H,j){return this._withAdapter(B,oe,ne=>ne.provideDocumentRangeSemanticTokens(c.URI.revive(x),H,j),null,j)}registerCompletionItemProvider(B,x,H,j){const ne=this._addNewAdapter(new Ie(this._documents,this._commands.converter,H,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(ne,this._transformDocumentSelector(x,B),j,Ie.supportsResolving(H),B.identifier),this._createDisposable(ne)}$provideCompletionItems(B,x,H,j,ne){return this._withAdapter(B,Ie,fe=>fe.provideCompletionItems(c.URI.revive(x),H,j,ne),void 0,ne)}$resolveCompletionItem(B,x,H){return this._withAdapter(B,Ie,j=>j.resolveCompletionItem(x,H),void 0,H)}$releaseCompletionItems(B,x){this._withAdapter(B,Ie,H=>H.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(B,x,H,j){const ne=new X(B,this._documents,H,this._commands.converter),fe=this._addNewAdapter(ne,B);return this._proxy.$registerInlineCompletionsSupport(fe,this._transformDocumentSelector(x,B),ne.supportsHandleEvents,d.ExtensionIdentifier.toKey(B.identifier.value),j?.yieldTo?.map(ke=>d.ExtensionIdentifier.toKey(ke))||[]),this._createDisposable(fe)}$provideInlineCompletions(B,x,H,j,ne){return this._withAdapter(B,Me,fe=>fe.provideInlineCompletions(c.URI.revive(x),H,j,ne),void 0,ne)}$provideInlineEdits(B,x,H,j,ne){return this._withAdapter(B,Me,fe=>fe.provideInlineEdits(c.URI.revive(x),H,j,ne),void 0,ne)}$handleInlineCompletionDidShow(B,x,H,j){this._withAdapter(B,Me,async ne=>{ne.handleDidShowCompletionItem(x,H,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,x,H,j,ne){this._withAdapter(B,Me,async fe=>{fe.handlePartialAccept(x,H,j,ne)},void 0,void 0)}$freeInlineCompletionsList(B,x){this._withAdapter(B,Me,async H=>{H.disposeCompletions(x)},void 0,void 0)}registerInlineEditProvider(B,x,H){const j=new $(B,this._documents,H,this._commands.converter),ne=this._addNewAdapter(j,B);return this._proxy.$registerInlineEditProvider(ne,this._transformDocumentSelector(x,B),B.identifier),this._createDisposable(ne)}$provideInlineEdit(B,x,H,j){return this._withAdapter(B,$,ne=>ne.provideInlineEdits(c.URI.revive(x),H,j),void 0,j)}$freeInlineEdit(B,x){this._withAdapter(B,$,async H=>{H.disposeEdit(x)},void 0,void 0)}registerSignatureHelpProvider(B,x,H,j){const ne=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,fe=this._addNewAdapter(new Se(this._documents,H),B);return this._proxy.$registerSignatureHelpProvider(fe,this._transformDocumentSelector(x,B),ne),this._createDisposable(fe)}$provideSignatureHelp(B,x,H,j,ne){return this._withAdapter(B,Se,fe=>fe.provideSignatureHelp(c.URI.revive(x),H,j,ne),void 0,ne)}$releaseSignatureHelp(B,x){this._withAdapter(B,Se,H=>H.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(B,x,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new ce(this._documents,this._commands.converter,H,this._logService,B),B);this._proxy.$registerInlayHintsProvider(ne,this._transformDocumentSelector(x,B),typeof H.resolveInlayHint=="function",j,Ae._extLabel(B));let fe=this._createDisposable(ne);if(j!==void 0){const ke=H.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(j));fe=r.Disposable.from(fe,ke)}return fe}$provideInlayHints(B,x,H,j){return this._withAdapter(B,ce,ne=>ne.provideInlayHints(c.URI.revive(x),H,j),void 0,j)}$resolveInlayHint(B,x,H){return this._withAdapter(B,ce,j=>j.resolveInlayHint(x,H),void 0,H)}$releaseInlayHints(B,x){this._withAdapter(B,ce,H=>H.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(B,x,H){const j=this._addNewAdapter(new be(this._documents,H),B);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(x,B),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(B,x,H){return this._withAdapter(B,be,j=>j.provideLinks(c.URI.revive(x),H),void 0,H,x.scheme==="output")}$resolveDocumentLink(B,x,H){return this._withAdapter(B,be,j=>j.resolveLink(x,H),void 0,void 0,!0)}$releaseDocumentLinks(B,x){this._withAdapter(B,be,H=>H.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(B,x,H){const j=this._addNewAdapter(new he(this._documents,H),B);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideDocumentColors(B,x,H){return this._withAdapter(B,he,j=>j.provideColors(c.URI.revive(x),H),[],H)}$provideColorPresentations(B,x,H,j){return this._withAdapter(B,he,ne=>ne.provideColorPresentations(c.URI.revive(x),H,j),void 0,j)}registerFoldingRangeProvider(B,x,H){const j=this._nextHandle(),ne=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new De(new G(this._documents,H),B)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(x,B),B.identifier,ne);let fe=this._createDisposable(j);if(ne!==void 0){const ke=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ne));fe=r.Disposable.from(fe,ke)}return fe}$provideFoldingRanges(B,x,H,j){return this._withAdapter(B,G,ne=>ne.provideFoldingRanges(c.URI.revive(x),H,j),void 0,j)}registerSelectionRangeProvider(B,x,H){const j=this._addNewAdapter(new J(this._documents,H,this._logService),B);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideSelectionRanges(B,x,H,j){return this._withAdapter(B,J,ne=>ne.provideSelectionRanges(c.URI.revive(x),H,j),[],j)}registerCallHierarchyProvider(B,x,H){const j=this._addNewAdapter(new pe(this._documents,H),B);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$prepareCallHierarchy(B,x,H,j){return this._withAdapter(B,pe,ne=>Promise.resolve(ne.prepareSession(c.URI.revive(x),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(B,x,H,j){return this._withAdapter(B,pe,ne=>ne.provideCallsTo(x,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(B,x,H,j){return this._withAdapter(B,pe,ne=>ne.provideCallsFrom(x,H,j),void 0,j)}$releaseCallHierarchy(B,x){this._withAdapter(B,pe,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(B,x,H){const j=this._addNewAdapter(new ve(this._documents,H),B);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$prepareTypeHierarchy(B,x,H,j){return this._withAdapter(B,ve,ne=>Promise.resolve(ne.prepareSession(c.URI.revive(x),H,j)),void 0,j)}$provideTypeHierarchySupertypes(B,x,H,j){return this._withAdapter(B,ve,ne=>ne.provideSupertypes(x,H,j),void 0,j)}$provideTypeHierarchySubtypes(B,x,H,j){return this._withAdapter(B,ve,ne=>ne.provideSubtypes(x,H,j),void 0,j)}$releaseTypeHierarchy(B,x){this._withAdapter(B,ve,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(B,x,H,j){const ne=this._nextHandle();return this._adapter.set(ne,new De(new Oe(this._proxy,this._documents,H,ne,B),B)),this._proxy.$registerDocumentOnDropEditProvider(ne,this._transformDocumentSelector(x,B),(0,t.isProposedApiEnabled)(B,"documentPaste")&&j?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:j.dropMimeTypes}:void 0),this._createDisposable(ne)}$provideDocumentOnDropEdits(B,x,H,j,ne,fe){return this._withAdapter(B,Oe,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(x,c.URI.revive(H),j,ne,fe)),void 0,void 0)}$resolveDropEdit(B,x,H){return this._withAdapter(B,Oe,j=>j.resolveDropEdit(x,H),{},void 0)}$releaseDocumentOnDropEdits(B,x){this._withAdapter(B,Oe,H=>Promise.resolve(H.releaseDropEdits(x)),void 0,void 0)}registerMappedEditsProvider(B,x,H){const j=this._addNewAdapter(new Ue(this._documents,H),B);return this._proxy.$registerMappedEditsProvider(j,this._transformDocumentSelector(x,B)),this._createDisposable(j)}$provideMappedEdits(B,x,H,j,ne){return this._withAdapter(B,Ue,fe=>Promise.resolve(fe.provideMappedEdits(x,H,j,ne)),null,ne)}registerDocumentPasteEditProvider(B,x,H,j){const ne=this._nextHandle();return this._adapter.set(ne,new De(new N(this._proxy,this._documents,H,ne,B),B)),this._proxy.$registerPasteEditProvider(ne,this._transformDocumentSelector(x,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:j.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this._createDisposable(ne)}$prepareDocumentPaste(B,x,H,j,ne){return this._withAdapter(B,N,fe=>fe.prepareDocumentPaste(c.URI.revive(x),H,j,ne),void 0,ne)}$providePasteEdits(B,x,H,j,ne,fe,ke){return this._withAdapter(B,N,xe=>xe.providePasteEdits(x,c.URI.revive(H),j,ne,fe,ke),void 0,ke)}$resolvePasteEdit(B,x,H){return this._withAdapter(B,N,j=>j.resolvePasteEdit(x,H),{},void 0)}$releasePasteEdits(B,x){this._withAdapter(B,N,H=>Promise.resolve(H.releasePasteEdits(x)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Ae._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ae._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ae._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Ae._serializeRegExp(B.beforeText),afterText:B.afterText?Ae._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Ae._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Ae._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(x=>r.SyntaxTokenType.toString(x)):void 0}}static _serializeAutoClosingPairs(B){return B.map(Ae._serializeAutoClosingPair)}setLanguageConfiguration(B,x,H){const{wordPattern:j}=H;if(j&&(0,k.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(x,j):this._documents.setWordDefinitionFor(x,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ne=this._nextHandle(),fe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ae._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Ae._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ae._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ae._serializeAutoClosingPairs(H.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ne,x,fe),this._createDisposable(ne)}$setWordDefinitions(B){for(const x of B)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=Ae}),define(Te[286],Pe([1,0,4,5,8]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,I=$e(I);class O{constructor(R){this._registeredTools=new Map,this._allTools=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(v=>{for(const a of v)this._allTools.set(a.name,a)})}async invokeTool(R,v,a){return await this._proxy.$invokeTool(R,v,a)}async $acceptToolDelta(R){R.added&&this._allTools.set(R.added.name,R.added),R.removed&&this._allTools.delete(R.removed)}get tools(){return Array.from(this._allTools.values()).map(R=>I.LanguageModelToolDescription.to(R))}async $invokeTool(R,v,a){const k=this._registeredTools.get(R);if(!k)throw new Error(`Unknown tool ${R}`);return await k.tool.invoke(v,a)}registerTool(R,v,a){return this._registeredTools.set(v,{extension:R,tool:a}),this._proxy.$registerTool(v),(0,S.toDisposable)(()=>{this._registeredTools.delete(v),this._proxy.$unregisterTool(v)})}}e.ExtHostLanguageModelTools=O}),define(Te[95],Pe([1,0,11,22,41,14,6,40,4,184,19,3,12,77,5,91,17,8,7,117,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,o=$e(o),d=$e(d),e.IExtHostLanguageModels=(0,w.createDecorator)("IExtHostLanguageModels");class l{constructor(p,y){this.option=p,this.stream=new S.AsyncIterableSource,this.stream=y??new S.AsyncIterableSource}}class u{constructor(){this._responseStreams=new Map,this._defaultStream=new S.AsyncIterableSource,this._isDone=!1;const p=this;this.apiObject={get stream(){return p._defaultStream.asyncIterable},get text(){return S.AsyncIterableObject.map(p._defaultStream.asyncIterable,y=>{if(y instanceof d.LanguageModelTextPart)return y.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,p]of this._responseStreams)yield p.stream;else yield this._defaultStream}handleFragment(p){if(this._isDone)return;let y=this._responseStreams.get(p.index);y||(this._responseStreams.size===0?y=new l(p.index,this._defaultStream):y=new l(p.index),this._responseStreams.set(p.index,y));let C;p.part.type==="text"?C=new d.LanguageModelTextPart(p.part.value):C=new d.LanguageModelFunctionUsePart(p.part.name,p.part.parameters),y.stream.emitOne(C)}reject(p){this._isDone=!0;for(const y of this._streams())y.reject(p)}resolve(){this._isDone=!0;for(const p of this._streams())p.resolve()}}let g=class{static{t=this}static{this._idPool=1}constructor(p,y,C){this._logService=y,this._extHostAuthentication=C,this._onDidChangeModelAccess=new A.Emitter,this._onDidChangeProviders=new A.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new k.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=p.getProxy(h.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(p,y,C,b){const D=t._idPool++;this._languageModels.set(D,{extension:p.identifier,provider:C,languageModelId:y});let P;b.auth&&(P={providerLabel:p.displayName||p.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(D,`${k.ExtensionIdentifier.toKey(p.identifier)}/${D}/${y}`,{extension:p.identifier,id:y,vendor:b.vendor??k.ExtensionIdentifier.toKey(p.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:P,targetExtensions:b.extensions});const f=C.onDidReceiveLanguageModelResponse2?.(({extensionId:E,participant:F,tokenCount:L})=>{this._proxy.$whenLanguageModelChatRequestMade(y,new k.ExtensionIdentifier(E),F,L)});return(0,v.toDisposable)(()=>{this._languageModels.delete(D),this._proxy.$unregisterProvider(D),f?.dispose()})}async $startChatRequest(p,y,C,b,D,P){const f=this._languageModels.get(p);if(!f)throw new Error("Provider not found");const E=new _.Progress(async L=>{if(P.isCancellationRequested){this._logService.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(L.part instanceof d.LanguageModelFunctionUsePart?M={type:"function_use",name:L.part.name,parameters:L.part.parameters}:L.part instanceof d.LanguageModelTextPart&&(M={type:"text",value:L.part.value}),!M){this._logService.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this._proxy.$reportResponsePart(y,{index:L.index,part:M})});let F;if(f.provider.provideLanguageModelResponse2)F=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(o.LanguageModelChatMessage.to),D,k.ExtensionIdentifier.toKey(C),E,P));else{const L=new _.Progress(async M=>{E.report({index:M.index,part:new d.LanguageModelTextPart(M.part)})});F=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(o.LanguageModelChatMessage.to),D?.modelOptions??{},k.ExtensionIdentifier.toKey(C),L,P))}F.then(()=>{this._proxy.$reportResponseDone(y,void 0)},L=>{this._proxy.$reportResponseDone(y,(0,O.transformErrorForSerialization)(L))})}$provideTokenLength(p,y,C){const b=this._languageModels.get(p);return b?Promise.resolve(b.provider.provideTokenCount(y,C)):Promise.resolve(0)}$acceptChatModelMetadata(p){if(p.added)for(const{identifier:y,metadata:C}of p.added)this._allLanguageModelData.set(y,{metadata:C,apiObjects:new k.ExtensionIdentifierMap});if(p.removed)for(const y of p.removed){this._allLanguageModelData.delete(y);for(const[C,b]of this._pendingRequest)b.languageModelId===y&&(b.res.reject(new O.CancellationError),this._pendingRequest.delete(C))}p.added?.forEach(y=>this._fakeAuthPopulate(y.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(p,y){const C=await this._proxy.$selectChatModels({...y,extension:p.identifier}),b=[],D=this;for(const P of C){const f=this._allLanguageModelData.get(P);if(!f)continue;this._isUsingAuth(p.identifier,f.metadata)&&await this._fakeAuthPopulate(f.metadata);let E=f.apiObjects.get(p.identifier);E||(E={id:P,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(F,L){if(!D._allLanguageModelData.has(P))throw d.LanguageModelError.NotFound(P);return D._computeTokenLength(P,F,L??T.CancellationToken.None)},sendRequest(F,L,M){if(!D._allLanguageModelData.has(P))throw d.LanguageModelError.NotFound(P);return D._sendChatRequest(p,P,F,L??{},M??T.CancellationToken.None)}},Object.freeze(E),f.apiObjects.set(p.identifier,E)),b.push(E)}return b}async _sendChatRequest(p,y,C,b,D){const P=this._convertMessages(p,C),f=p.identifier,E=this._allLanguageModelData.get(y)?.metadata;if(!E||!this._allLanguageModelData.has(y))throw d.LanguageModelError.NotFound(`Language model '${y}' is unknown.`);if(this._isUsingAuth(f,E)&&(!await this._getAuthAccess(p,{identifier:E.extension,displayName:E.auth.providerLabel},b.justification,!1)||!this._modelAccessList.get(f)?.has(E.extension)))throw d.LanguageModelError.NoPermissions(`Language model '${y}' cannot be used by '${f.value}'.`);try{const F=Math.random()*1e6|0,L=new u;this._pendingRequest.set(F,{languageModelId:y,res:L});try{await this._proxy.$tryStartChatRequest(f,y,F,P,b,D)}catch(M){throw this._pendingRequest.delete(F),M}return L.apiObject}catch(F){throw F.name===d.LanguageModelError.name?F:new d.LanguageModelError(`Language model '${y}' errored: ${(0,I.toErrorMessage)(F)}`,"Unknown",F)}}_convertMessages(p,y){const C=[];for(const b of y)b.role===d.LanguageModelChatMessageRole.System&&(0,r.checkProposedApiEnabled)(p,"languageModelSystem"),b.content2 instanceof d.LanguageModelFunctionResultPart&&(0,r.checkProposedApiEnabled)(p,"lmTools"),C.push(o.LanguageModelChatMessage.from(b));return C}async $acceptResponsePart(p,y){const C=this._pendingRequest.get(p);C&&C.res.handleFragment(y)}async $acceptResponseDone(p,y){const C=this._pendingRequest.get(p);C&&(this._pendingRequest.delete(p),y?C.res.reject((0,O.transformErrorFromSerialization)(y)):C.res.resolve())}async _getAuthAccess(p,y,C,b){const D=i.INTERNAL_AUTH_PROVIDER_PREFIX+y.identifier.value;if(await this._extHostAuthentication.getSession(p,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:p.identifier,to:y.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=C?(0,a.localize)(0,null,y.displayName,C):void 0;return await this._extHostAuthentication.getSession(p,D,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:p.identifier,to:y.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(p,y){return!!y.auth&&!k.ExtensionIdentifier.equals(y.extension,p)}async _fakeAuthPopulate(p){if(p.auth)for(const y of this._languageAccessInformationExtensions)try{await this._getAuthAccess(y,{identifier:p.extension,displayName:""},void 0,!0)}catch(C){this._logService.error("Fake Auth request failed"),this._logService.error(C)}}async _computeTokenLength(p,y,C){if(!this._allLanguageModelData.get(p))throw d.LanguageModelError.NotFound(`Language model '${p}' is unknown.`);const D=R.Iterable.find(this._languageModels.values(),P=>P.languageModelId===p);return D?D.provider.provideTokenCount(y,C):this._proxy.$countTokens(p,typeof y=="string"?y:o.LanguageModelChatMessage.from(y),C)}$updateModelAccesslist(p){const y=new Array;for(const{from:C,to:b,enabled:D}of p){const P=this._modelAccessList.get(C)??new k.ExtensionIdentifierSet;if(P.has(b)!==D){D?P.add(b):P.delete(b),this._modelAccessList.set(C,P);const E={from:C,to:b};y.push(E),this._onDidChangeModelAccess.fire(E)}}}createLanguageModelAccessInformation(p){this._languageAccessInformationExtensions.add(p);const y=this,C=A.Event.signal(A.Event.filter(this._onDidChangeModelAccess.event,D=>k.ExtensionIdentifier.equals(D.from,p.identifier))),b=A.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return A.Event.any(C,b)},canSendRequest(D){let P;e:for(const[E,F]of y._allLanguageModelData)for(const L of F.apiObjects.values())if(L===D){P=F.metadata;break e}if(!P)return;if(!y._isUsingAuth(p.identifier,P))return!0;const f=y._modelAccessList.get(p.identifier);if(f)return f.has(P.extension)}}}};e.ExtHostLanguageModels=g,e.ExtHostLanguageModels=g=t=je([Ve(0,s.IExtHostRpcService),Ve(1,c.ILogService),Ve(2,n.IExtHostAuthentication)],g)});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[287],Pe([1,0,5,8,7,36,11,4,25]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,T=$e(T),O=Zt(O);class a{constructor(w,c,_,h){this._documents=c,this._commands=_,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=w.getProxy(S.MainContext.MainThreadLanguages)}$acceptLanguageIds(w){this._languageIds=w}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(w,c){await this._proxy.$changeLanguage(w,c);const _=this._documents.getDocumentData(w);if(!_)throw new Error(`document '${w.toString()}' NOT found`);return _.document}async tokenAtPosition(w,c){const _=w.version,h=T.Position.from(c),n=await this._proxy.$tokensAtPosition(w.uri,h),s={type:I.StandardTokenType.Other,range:w.getWordRangeAtPosition(c)??new I.Range(c.line,c.character,c.line,c.character)};if(!n)return s;const o={range:T.Range.to(n.range),type:T.TokenType.to(n.type)};return!o.range.contains(c)||_!==w.version?s:o}createLanguageStatusItem(w,c,_){const h=this._handlePool++,n=this._proxy,s=this._ids,o=`${w.identifier.value}/${c}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);s.add(o);const d={selector:_,id:c,name:w.displayName??w.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new R.DisposableStore,t=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${c}) from ${w.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.disposableTimeout)(()=>{r.clear(),this._proxy.$setLanguageStatus(h,{id:o,name:d.name??w.displayName??w.name,source:w.displayName??w.name,selector:T.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===I.LanguageStatusSeverity.Error?O.default.Error:d.severity===I.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:d.command&&this._commands.toInternal(d.command,r),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},l={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(h),s.delete(o)},get id(){return d.id},get name(){return d.name},set name(u){d.name=u,t()},get selector(){return d.selector},set selector(u){d.selector=u,t()},get text(){return d.text},set text(u){d.text=u,t()},set text2(u){(0,v.checkProposedApiEnabled)(w,"languageStatusText"),d.text=u,t()},get text2(){return(0,v.checkProposedApiEnabled)(w,"languageStatusText"),d.text},get detail(){return d.detail},set detail(u){d.detail=u,t()},get severity(){return d.severity},set severity(u){d.severity=u,t()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(u){d.accessibilityInformation=u,t()},get command(){return d.command},set command(u){d.command=u,t()},get busy(){return d.busy},set busy(u){d.busy=u,t()}};return t(),l}}e.ExtHostLanguages=a}),define(Te[288],Pe([1,0,16,2,8,7,90]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,I=$e(I),A=$e(A);class R{constructor(w,c,_,h){this.start=w,this.deletedCount=c,this.deletedItems=_,this.items=h}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1}}constructor(w,c,_){this.notebook=w,this._extHostDocument=c,this._cellData=_,this.handle=_.handle,this.uri=T.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return w._mime},set mime(h){w._mime=h},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(w){this._outputs=w.map(I.NotebookCellOutput.to)}setOutputItems(w,c,_){const h=_.map(I.NotebookCellOutputItem.to),n=this._outputs.find(s=>s.id===w);if(n&&(c||(n.items.length=0),n.items.push(...h),n.items.length>1&&n.items.every(s=>A.isTextStreamMime(s.mime)))){const s=new Map,o=[];n.items.forEach(d=>{let i;s.has(d.mime)?i=s.get(d.mime):(i=[],s.set(d.mime,i),o.push(d.mime)),i.push(d.data)}),n.items.length=0,o.forEach(d=>{const i=A.compressOutputItemStreams(s.get(d));n.items.push({mime:d,data:i.data.buffer})})}}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=v;class a{static{this._handlePool=0}constructor(w,c,_,h,n){this._proxy=w,this._textDocumentsAndEditors=c,this._textDocuments=_,this.uri=h,this.handle=a._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=n.viewType,this._metadata=Object.freeze(n.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,n.cells]],!0,void 0),this._versionId=n.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const w=this,c={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===S.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(_){return _=w._validateIndex(_),w._cells[_].apiCell},getCells(_){return(_?w._getCells(_):w._cells).map(n=>n.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(c)}return this._notebook}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,c,_){this._versionId=w.versionId,this._isDirty=c,this.acceptDocumentPropertiesChanged({metadata:_});const h={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},n=[];for(const o of w.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,h.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,h.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),n.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),n.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),n.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),n.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),n.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<n.length;o++){const d=n[o],i=s.get(d.cell);if(i===void 0){const r=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});s.set(d.cell,r-1)}else h.cellChanges[i]={...h.cellChanges[i],...d}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let c=w.start|0,_=w.end|0;return c<0&&(c=0),_>this._cells.length&&(_=this._cells.length),w.with({start:c,end:_})}_getCells(w){w=this._validateRange(w);const c=[];for(let _=w.start;_<w.end;_++)c.push(this._cells[_]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,c,_){if(this._disposed)return;const h=[],n=[],s=[];if(w.reverse().forEach(o=>{const i=o[2].map(l=>{const u=new v(this,this._textDocumentsAndEditors,l);return c||n.push(v.asModelAddData(l)),u}),r=new R(o[0],o[1],[],i),t=this._cells.splice(o[0],o[1],...i);for(const l of t)s.push(l.uri),r.deletedItems.push(l.apiCell);h.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:s}),_)for(const o of h)_.push(o.asApiEvent())}_moveCells(w,c,_,h){const n=this._cells.splice(w,c);this._cells.splice(_,0,...n);const s=[new R(w,c,n.map(o=>o.apiCell),[]),new R(_,0,[],n)];for(const o of s)h.push(o.asApiEvent())}_setCellOutputs(w,c){this._cells[w].setOutputs(c)}_setCellOutputItems(w,c,_,h){this._cells[w].setOutputItems(c,_,h)}_changeCellLanguage(w,c){const _=this._cells[w];_.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(_.uri,c)}_changeCellMime(w,c){const _=this._cells[w];_.apiCell.mime=c}_changeCellMetadata(w,c){this._cells[w].setMetadata(c)}_changeCellInternalMetadata(w,c){this._cells[w].setInternalMetadata(c)}getCellFromApiCell(w){return this._cells.find(c=>c.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(c=>c.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=a}),define(Te[289],Pe([1,0,6,2,8,7,39]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(a,k,w,c={timeout:1500,errors:3}){this._logService=a,this._notebooksAndEditors=k,this._mainThreadBulkEdits=w,this._thresholds=c,this._onWillSaveNotebookDocumentEvent=new S.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(k,w,c)=>{const _=function(n){k.call(w,n)};return _.extension=a,this._onWillSaveNotebookDocumentEvent.event(_,void 0,c)}}async $participateInSave(a,k,w){const c=T.URI.revive(a),_=this._notebooksAndEditors.getNotebookDocument(c);if(!_)throw new Error("Unable to resolve notebook document");const h=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:_.apiNotebook,reason:I.TextDocumentSaveReason.to(k)},w,async(s,o)=>{const d=Date.now(),i=await await Promise.resolve(s);Date.now()-d>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!w.isCancellationRequested&&i&&(i instanceof O.WorkspaceEdit?h.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),w.isCancellationRequested)return!1;if(h.length===0)return!0;const n={edits:[]};for(const s of h){const{edits:o}=I.WorkspaceEdit.from(s);n.edits=n.edits.concat(o)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(n))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Te[124],Pe([1,0,14,8,7]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,T=$e(T),I=$e(I);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,v,a,k,w,c){this.id=R,this._proxy=v,this.notebookData=a,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=k,this._viewColumn=c}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(v){this.selections=[v]},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||!v.every(I.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");R._selections=v,R._trySetSelections(v)},get visibleRanges(){return R._visibleRanges},revealRange(v,a){R._proxy.$tryRevealRange(R.id,T.NotebookRange.from(v),a??I.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(T.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=O}),define(Te[290],Pe([1,0,6,12,8]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,I=$e(I);let O=class{constructor(R,v){this._logService=R,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new S.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,v);const a=this._notebooksAndEditors.getEditorById(R);v.visibleRanges&&a._acceptVisibleRanges(v.visibleRanges.ranges.map(I.NotebookRange.to)),v.selections&&a._acceptSelections(v.selections.selections.map(I.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const v in R)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(I.ViewColumn.to(R[v]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=je([Ve(0,T.ILogService)],O)}),define(Te[291],Pe([1,0,6,5,124]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(R,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,v,a){const k=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(v)?.fire({editor:k.apiEditor,message:a})}createRendererMessaging(R,v){if(!R.contributes?.notebookRenderer?.some(k=>k.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(k,w,c)=>this.getOrCreateEmitterFor(v).event(k,w,c),postMessage:(k,w)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(k)&&([k,w]=[w,k]);const c=w&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(c?.id,v,k)}}}getOrCreateEmitterFor(R){let v=this._rendererMessageEmitters.get(R);return v||(v=new S.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,v),v)}}e.ExtHostNotebookRenderers=O}),define(Te[292],Pe([1,0,8,77,22,72,14]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(w){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=w}async withProgress(w,c,_){const h=this._handles++,{title:n,location:s,cancellable:o}=c,d={label:w.displayName||w.name,id:w.identifier.value};return this._proxy.$startProgress(h,{location:S.ProgressLocation.from(s),title:n,source:d,cancellable:o},w.isUnderDevelopment?void 0:w.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(h,_,!!o)}_withProgress(w,c,_){let h;_&&(h=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(w,h));const n=o=>{this._proxy.$progressEnd(o),this._mapHandleToCancellationSource.delete(o),h?.dispose()};let s;try{s=c(new a(this._proxy,w),_&&h?h.token:I.CancellationToken.None)}catch(o){throw n(w),o}return s.then(o=>n(w),o=>n(w)),s}$acceptProgressCanceled(w){const c=this._mapHandleToCancellationSource.get(w);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(w))}}e.ExtHostProgress=R;function v(k,w){return k.message=w.message,typeof w.increment=="number"&&(typeof k.increment=="number"?k.increment+=w.increment:k.increment=w.increment),k}class a extends T.Progress{constructor(w,c){super(_=>this.throttledReport(_)),this._proxy=w,this._handle=c}throttledReport(w){this._proxy.$progressReport(this._handle,w)}}je([(0,O.throttle)(100,(k,w)=>v(k,w),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Te[293],Pe([1,0,2,5,11,8]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(v,a){this.uriTransformer=a,this.providers=new Map,this.proxy=v.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,a,k){const w=S.URI.revive(a),c=this.providers.get(v);return c?(0,I.asPromise)(()=>c.provideOriginalResource(w,k)).then(_=>_||null):Promise.resolve(null)}registerQuickDiffProvider(v,a,k,w){const c=A.handlePool++;return this.providers.set(c,a),this.proxy.$registerQuickDiffProvider(c,O.DocumentSelector.from(v,this.uriTransformer),k,w),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(c),this.providers.delete(c)}}}}e.ExtHostQuickDiff=A});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[294],Pe([1,0,22,6,4,5,2,7,14,18,36,35,25,8]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=h,k=Zt(k);function h(n,s,o){const d=n.getProxy(O.MainContext.MainThreadQuickOpen);class i{constructor(C,b){this._sessions=new Map,this._instances=0,this._workspace=C,this._commands=b}showQuickPick(C,b,D,P=S.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(b),E=++this._instances,F=d.$show(E,{title:D?.title,placeHolder:D?.placeHolder,matchOnDescription:D?.matchOnDescription,matchOnDetail:D?.matchOnDetail,ignoreFocusLost:D?.ignoreFocusOut,canPickMany:D?.canPickMany},P),L={},M=F.then(()=>L);return Promise.race([M,f]).then(V=>{if(V===L)return;const W=(0,c.isProposedApiEnabled)(C,"quickPickItemTooltip");return f.then(N=>{const Q=[];for(let Y=0;Y<N.length;Y++){const ge=N[Y];if(typeof ge=="string")Q.push({label:ge,handle:Y});else if(ge.kind===R.QuickPickItemKind.Separator)Q.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const Z=ge.iconPath?g(ge.iconPath):void 0;Q.push({label:ge.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?_.MarkdownString.fromStrict(ge.tooltip):void 0,handle:Y})}}return D&&typeof D.onDidSelectItem=="function"&&(this._onDidSelectItem=Y=>{D.onDidSelectItem(N[Y])}),d.$setItems(E,Q),F.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(ge=>N[ge])})})}).then(void 0,V=>{if(!(0,v.isCancellationError)(V))return d.$setError(E,V),Promise.reject(V)})}$onItemSelected(C){this._onDidSelectItem?.(C)}showInput(C,b=S.CancellationToken.None){return this._validateInput=C?.validateInput,d.$input(C,typeof this._validateInput=="function",b).then(void 0,D=>{if(!(0,v.isCancellationError)(D))return Promise.reject(D)})}async $validateInput(C){if(!this._validateInput)return;const b=await this._validateInput(C);if(!b||typeof b=="string")return b;let D;switch(b.severity){case R.InputBoxValidationSeverity.Info:D=k.default.Info;break;case R.InputBoxValidationSeverity.Warning:D=k.default.Warning;break;case R.InputBoxValidationSeverity.Error:D=k.default.Error;break;default:D=b.message?k.default.Error:k.default.Ignore;break}return{content:b.message,severity:D}}async showWorkspaceFolderPick(C,b=S.CancellationToken.None){const D=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!D)return;const P=await this._workspace.getWorkspaceFolders2();if(P)return P.find(f=>f.uri.toString()===D.uri.toString())}createQuickPick(C){const b=new m(C,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(C){const b=new p(C,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(C,b){this._sessions.get(C)?._fireDidChangeValue(b)}$onDidAccept(C){this._sessions.get(C)?._fireDidAccept()}$onDidChangeActive(C,b){const D=this._sessions.get(C);D instanceof m&&D._fireDidChangeActive(b)}$onDidChangeSelection(C,b){const D=this._sessions.get(C);D instanceof m&&D._fireDidChangeSelection(b)}$onDidTriggerButton(C,b){this._sessions.get(C)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(C,b,D){const P=this._sessions.get(C);P instanceof m&&P._fireDidTriggerItemButton(b,D)}$onDidHide(C){this._sessions.get(C)?._fireDidHide()}}class r{static{this._nextId=1}constructor(C,b){this._extensionId=C,this._onDidDispose=b,this._id=m._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(C){this._title=C,this.update({title:C})}get step(){return this._steps}set step(C){this._steps=C,this.update({step:C})}get totalSteps(){return this._totalSteps}set totalSteps(C){this._totalSteps=C,this.update({totalSteps:C})}get enabled(){return this._enabled}set enabled(C){this._enabled=C,this.update({enabled:C})}get busy(){return this._busy}set busy(C){this._busy=C,this.update({busy:C})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(C){this._ignoreFocusOut=C,this.update({ignoreFocusOut:C})}get value(){return this._value}set value(C){this._value=C,this.update({value:C})}get placeholder(){return this._placeholder}set placeholder(C){this._placeholder=C,this.update({placeholder:C})}get buttons(){return this._buttons}set buttons(C){this._buttons=C.slice(),this._handlesToButtons.clear(),C.forEach((b,D)=>{const P=b===R.QuickInputButtons.Back?-1:D;this._handlesToButtons.set(P,b)}),this.update({buttons:C.map((b,D)=>({...g(b.iconPath),tooltip:b.tooltip,handle:b===R.QuickInputButtons.Back?-1:D}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(C){this._value=C,this._onDidChangeValueEmitter.fire(C)}_fireDidTriggerButton(C){const b=this._handlesToButtons.get(C);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(C){if(!this._disposed){for(const b of Object.keys(C)){const D=C[b];this._pendingUpdate[b]=D===void 0?null:D}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(y){if(y instanceof R.ThemeIcon)return{id:y.id};const C=u(y),b=l(y);return{dark:typeof C=="string"?A.URI.file(C):C,light:typeof b=="string"?A.URI.file(b):b}}function l(y){return typeof y=="object"&&"light"in y?y.light:y}function u(y){return typeof y=="object"&&"dark"in y?y.dark:y}function g(y){const C=t(y);let b,D;return"id"in C?D=w.ThemeIcon.asClassName(C):b=C,{iconPath:b,iconClass:D}}class m extends r{constructor(C,b){super(C.identifier,b),this.extension=C,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this._onDidTriggerItemButtonEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(C){this._items=C.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),C.forEach((P,f)=>{this._handlesToItems.set(f,P),this._itemsToHandles.set(P,f)});const b=(0,c.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),D=[];for(let P=0;P<C.length;P++){const f=C[P];if(f.kind===R.QuickPickItemKind.Separator)D.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const E=f.iconPath?g(f.iconPath):void 0;D.push({handle:P,label:f.label,iconPath:E?.iconPath,iconClass:E?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?_.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((F,L)=>({...g(F.iconPath),tooltip:F.tooltip,handle:L}))})}}this.update({items:D})}get canSelectMany(){return this._canSelectMany}set canSelectMany(C){this._canSelectMany=C,this.update({canSelectMany:C})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(C){this._matchOnDescription=C,this.update({matchOnDescription:C})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(C){this._matchOnDetail=C,this.update({matchOnDetail:C})}get sortByLabel(){return this._sortByLabel}set sortByLabel(C){this._sortByLabel=C,this.update({sortByLabel:C})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(C){this._keepScrollPosition=C,this.update({keepScrollPosition:C})}get activeItems(){return this._activeItems}set activeItems(C){this._activeItems=C.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(C){this._selectedItems=C.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(C){const b=(0,a.coalesce)(C.map(D=>this._handlesToItems.get(D)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(C){const b=(0,a.coalesce)(C.map(D=>this._handlesToItems.get(D)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(C,b){const D=this._handlesToItems.get(C);if(!D||!D.buttons||!D.buttons.length)return;const P=D.buttons[b];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:D})}}class p extends r{constructor(C,b){super(C.identifier,b),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(C){this._password=C,this.update({password:C})}get prompt(){return this._prompt}set prompt(C){this._prompt=C,this.update({prompt:C})}get valueSelection(){return this._valueSelection}set valueSelection(C){this._valueSelection=C,this.update({valueSelection:C})}get validationMessage(){return this._validationMessage}set validationMessage(C){this._validationMessage=C,C?typeof C=="string"?this.update({validationMessage:C,severity:k.default.Error}):this.update({validationMessage:C.message,severity:C.severity??k.default.Error}):this.update({validationMessage:void 0,severity:k.default.Ignore})}}return new i(s,o)}}),define(Te[295],Pe([1,0,2,6,72,4,11,5,18,160,12,19,38,35,8,25,16,21]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(L){return L instanceof S.URI}function r(L,M){return L.scheme===s.Schemas.file&&M.scheme===s.Schemas.file&&o.isLinux?L.toString()===M.toString():L.toString().toLowerCase()===M.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?S.URI.file(L.iconPath):S.URI.isUri(L.iconPath)||_.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function l(L){if(L){if(S.URI.isUri(L))return L;if(_.ThemeIcon.isThemeIcon(L))return L;{const M=L;return{light:M.light,dark:M.dark}}}else return}function u(L){const M=l(L.icon),V=L.labels?.map(W=>({title:W.title,icon:l(W.icon)}));return{...L,icon:M,labels:V}}function g(L,M){if(!L.iconPath&&!M.iconPath)return 0;if(L.iconPath){if(!M.iconPath)return 1}else return-1;const V=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,W=typeof M.iconPath=="string"?M.iconPath:S.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,a.comparePaths)(V,W)}function m(L,M){let V=0;if(L.strikeThrough!==M.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==M.faded)return L.faded?1:-1;if(L.tooltip!==M.tooltip)return(L.tooltip||"").localeCompare(M.tooltip||"");if(V=g(L,M),V!==0)return V;if(L.light&&M.light)V=g(L.light,M.light);else{if(L.light)return 1;if(M.light)return-1}if(V!==0)return V;if(L.dark&&M.dark)V=g(L.dark,M.dark);else{if(L.dark)return 1;if(M.dark)return-1}return V}function p(L,M){if(L.command!==M.command)return L.command<M.command?-1:1;if(L.title!==M.title)return L.title<M.title?-1:1;if(L.tooltip!==M.tooltip){if(L.tooltip!==void 0&&M.tooltip!==void 0)return L.tooltip<M.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(L.arguments===M.arguments)return 0;if(L.arguments)if(M.arguments){if(L.arguments.length!==M.arguments.length)return L.arguments.length-M.arguments.length}else return 1;else return-1;for(let V=0;V<L.arguments.length;V++){const W=L.arguments[V],N=M.arguments[V];if(W!==N&&!(i(W)&&i(N)&&r(W,N)))return W<N?-1:1}return 0}function y(L,M){let V=(0,a.comparePaths)(L.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(V!==0)return V;if(L.command&&M.command)V=p(L.command,M.command);else{if(L.command)return 1;if(M.command)return-1}if(V!==0)return V;if(L.decorations&&M.decorations)V=m(L.decorations,M.decorations);else{if(L.decorations)return 1;if(M.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)V=(0,a.comparePaths)(L.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)V=(0,a.comparePaths)(L.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return V}function C(L,M){for(let V=0;V<L.length;V++)if(L[V]!==M[V])return!1;return!0}function b(L,M){return L.command===M.command&&L.title===M.title&&L.tooltip===M.tooltip&&(L.arguments&&M.arguments?C(L.arguments,M.arguments):L.arguments===M.arguments)}function D(L,M){return(0,v.equals)(L,M,b)}class P{#e;#t;get value(){return this._value}set value(M){M=M??"",this.#e.$setInputBoxValue(this._sourceControlHandle,M),this.updateValue(M)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(M){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,M),this._placeholder=M}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(M){if((0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=M,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!M)}get enabled(){return this._enabled}set enabled(M){M=!!M,this._enabled!==M&&(this._enabled=M,this.#e.$setInputBoxEnablement(this._sourceControlHandle,M))}get visible(){return this._visible}set visible(M){M=!!M,this._visible!==M&&(this._visible=M,this.#e.$setInputBoxVisibility(this._sourceControlHandle,M))}get document(){return(0,n.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(M,V,W,N,Q){this._extension=M,this._sourceControlHandle=N,this._documentUri=Q,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=V,this.#e=W}showValidationMessage(M,V){(0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,M,V)}$onInputBoxValueChange(M){this.updateValue(M)}updateValue(M){this._value=M,this._onDidChange.fire(M)}}e.ExtHostSCMInputBox=P;class f{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(M){this._label=M,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,M)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(M){this._hideWhenEmpty=M,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(M){this._resourceStates=[...M],this._onDidUpdateResourceStates.fire()}constructor(M,V,W,N,Q,Y,ge){this._proxy=M,this._commands=V,this._sourceControlHandle=W,this._id=N,this._label=Q,this.multiDiffEditorEnableViewChanges=Y,this._extension=ge,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}getResourceState(M){return this._resourceStatesMap.get(M)}$executeResourceCommand(M,V){const W=this._resourceStatesCommandsMap.get(M);return W?(0,A.asPromise)(()=>this._commands.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this._resourceStates].sort(y),W=(0,v.sortedDiff)(this._resourceSnapshot,M,y).map(Y=>{const ge=Y.toInsert.map(Z=>{const me=this._resourceHandlePool++;this._resourceStatesMap.set(me,Z);const se=Z.resourceUri;let le;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const J=new O.DisposableStore;le=this._commands.converter.toInternal(Z.command,J),this._resourceStatesDisposablesMap.set(me,J)}else this._resourceStatesCommandsMap.set(me,Z.command);const Ee=(0,n.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),oe=Ee?Z.multiDiffEditorOriginalUri:void 0,Ie=Ee?Z.multiFileDiffEditorModifiedUri:void 0,Me=t(Z.decorations),X=Z.decorations&&t(Z.decorations.light)||Me,$=Z.decorations&&t(Z.decorations.dark)||Me,te=[X,$],Se=Z.decorations&&Z.decorations.tooltip||"",ce=Z.decorations&&!!Z.decorations.strikeThrough,be=Z.decorations&&!!Z.decorations.faded,he=Z.contextValue||"";return{rawResource:[me,se,te,Se,ce,be,he,le,oe,Ie],handle:me}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:ge}}),N=W.map(({start:Y,deleteCount:ge,toInsert:Z})=>[Y,ge,Z.map(me=>me.rawResource)]),Q=W.reverse();for(const{start:Y,deleteCount:ge,toInsert:Z}of Q){const me=Z.map(le=>le.handle),se=this._handlesSnapshot.splice(Y,ge,...me);for(const le of se)this._resourceStatesMap.delete(le),this._resourceStatesCommandsMap.delete(le),this._resourceStatesDisposablesMap.get(le)?.dispose(),this._resourceStatesDisposablesMap.delete(le)}return this._resourceSnapshot=M,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class E{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(M){this._count!==M&&(this._count=M,this.#e.$updateSourceControl(this.handle,{count:M}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(M){this._quickDiffProvider=M;let V;(0,n.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(V=M?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!M,quickDiffLabel:V})}get historyProvider(){return(0,n.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(M){(0,n.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=M,this._historyProviderDisposable.value=new O.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!M}),M&&this._historyProviderDisposable.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(M){M!==this._commitTemplate&&(this._commitTemplate=M,this.#e.$updateSourceControl(this.handle,{commitTemplate:M}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(M){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=M;const V=this._commands.converter.toInternal(M,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:V})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(M){(0,n.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=M;const V=M!==void 0?{command:this._commands.converter.toInternal(M.command,this._actionButtonDisposables.value),secondaryCommands:M.secondaryCommands?.map(W=>W.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:V??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(M){if(this.logService.trace("ExtHostSourceControl#statusBarCommands",(M??[]).map(W=>W.command).join(", ")),this._statusBarCommands&&M&&D(this._statusBarCommands,M)){this.logService.trace("ExtHostSourceControl#statusBarCommands are equal");return}this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=M;const V=(M||[]).map(W=>this._commands.converter.toInternal(W,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:V})}get selected(){return this._selected}constructor(M,V,W,N,Q,Y,ge,Z){this._extension=M,this._commands=N,this.logService=Q,this._id=Y,this._label=ge,this._rootUri=Z,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=E._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=W;const me=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${Y}/scm${this.handle}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this._inputBox=new P(M,V,this.#e,this.handle,me),this.#e.$registerSourceControl(this.handle,Y,ge,Z,me)}createResourceGroup(M,V,W){const N=(0,n.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,Q=new f(this.#e,this._commands,this.handle,M,V,N,this._extension),Y=T.Event.once(Q.onDidDispose)(()=>this.createdResourceGroups.delete(Q));return this.createdResourceGroups.set(Q,Y),this.eventuallyAddResourceGroups(),Q}eventuallyAddResourceGroups(){const M=[],V=[];for(const[W,N]of this.createdResourceGroups){N.dispose();const Q=W.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.updatedResourceGroups.delete(W),Q.dispose(),this._groups.delete(W.handle),this.#e.$unregisterGroup(this.handle,W.handle)}),M.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const Y=W._takeResourceStateSnapshot();Y.length>0&&V.push([W.handle,Y]),this._groups.set(W.handle,W)}this.#e.$registerGroups(this.handle,M,V),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const M=[];this.updatedResourceGroups.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&M.push([V.handle,W])}),M.length>0&&this.#e.$spliceResourceStates(this.handle,M),this.updatedResourceGroups.clear()}getResourceGroup(M){return this._groups.get(M)}setSelectionState(M){this._selected=M,this._onDidChangeSelection.fire(M)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,I.debounce)(100)],E.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{d=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(M,V,W,N){this._commands=V,this._extHostDocuments=W,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new w.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=M.getProxy(R.MainContext.MainThreadSCM),this._telemetry=M.getProxy(R.MainContext.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:Q=>{if(Q&&Q.$mid===c.MarshalledId.ScmResource){const Y=this._sourceControls.get(Q.sourceControlHandle);if(!Y)return Q;const ge=Y.getResourceGroup(Q.groupHandle);return ge?ge.getResourceState(Q.handle):Q}else if(Q&&Q.$mid===c.MarshalledId.ScmResourceGroup){const Y=this._sourceControls.get(Q.sourceControlHandle);return Y?Y.getResourceGroup(Q.groupHandle):Q}else if(Q&&Q.$mid===c.MarshalledId.ScmProvider){const Y=this._sourceControls.get(Q.handle);return Y||Q}return Q}})}createSourceControl(M,V,W,N){this.logService.trace("ExtHostSCM#createSourceControl",M.identifier.value,V,W,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const Q=d._handlePool++,Y=new E(M,this._extHostDocuments,this._proxy,this._commands,this.logService,V,W,N);this._sourceControls.set(Q,Y);const ge=this._sourceControlsByExtension.get(M.identifier)||[];return ge.push(Y),this._sourceControlsByExtension.set(M.identifier,ge),Y}getLastInputBox(M){this.logService.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const V=this._sourceControlsByExtension.get(M.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(M,V,W){const N=S.URI.revive(V);this.logService.trace("ExtHostSCM#$provideOriginalResource",M,N.toString());const Q=this._sourceControls.get(M);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>Q.quickDiffProvider.provideOriginalResource(N,W)).then(Y=>Y||null)}$onInputBoxValueChange(M,V){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",M);const W=this._sourceControls.get(M);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(M,V,W,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",M,V,W);const Q=this._sourceControls.get(M);if(!Q)return Promise.resolve(void 0);const Y=Q.getResourceGroup(V);return Y?Y.$executeResourceCommand(W,N):Promise.resolve(void 0)}$validateInput(M,V,W){this.logService.trace("ExtHostSCM#$validateInput",M);const N=this._sourceControls.get(M);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>N.inputBox.validateInput(V,W)).then(Q=>{if(!Q)return Promise.resolve(void 0);const Y=h.MarkdownString.fromStrict(Q.message);return Y?Promise.resolve([Y,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this._sourceControls.get(M)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,V,W,N){return await this._sourceControls.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,N)??void 0}async $provideHistoryItems(M,V,W,N){return(await this._sourceControls.get(M)?.historyProvider?.provideHistoryItems(V,W,N))?.map(ge=>u(ge))??void 0}async $provideHistoryItems2(M,V,W){return(await this._sourceControls.get(M)?.historyProvider?.provideHistoryItems2(V,W))?.map(Y=>u(Y))??void 0}async $provideHistoryItemSummary(M,V,W,N){const Q=this._sourceControls.get(M)?.historyProvider;if(typeof Q?.provideHistoryItemSummary!="function")return;const Y=await Q.provideHistoryItemSummary(V,W,N);return Y?u(Y):void 0}async $provideHistoryItemChanges(M,V,W,N){return await this._sourceControls.get(M)?.historyProvider?.provideHistoryItemChanges(V,W,N)??void 0}};e.ExtHostSCM=F,e.ExtHostSCM=F=d=je([Ve(3,k.ILogService)],F)}),define(Te[296],Pe([1,0,5,8,2]),function(ae,e,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(R,v){this.uriTransformer=v,this.providers=new Map,this.proxy=R.getProxy(S.MainContext.MainThreadShare)}async $provideShare(R,v,a){return await this.providers.get(R)?.provideShare({selection:T.Range.to(v.selection),resourceUri:I.URI.revive(v.resourceUri)},a)??void 0}registerShareProvider(R,v){const a=O.handlePool++;return this.providers.set(a,v),this.proxy.$registerShareProvider(a,T.DocumentSelector.from(R,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(a),this.providers.delete(a)}}}}e.ExtHostShare=O}),define(Te[297],Pe([1,0,7,5,187,4,8,15]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new S.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(c,_,h,n,s,o=S.StatusBarAlignment.Left,d){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=c,this.#t=_,s&&n){this._entryId=(0,S.asStatusBarItemIdentifier)(n.identifier,s);const i=h.get(this._entryId);i&&(o=i.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,d=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=n,this._id=s,this._alignment=o,this._priority=this.validatePriority(d)}validatePriority(c){if((0,R.isNumber)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!v.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){this._command?.fromApi!==c&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof c=="string"?this._command={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this._latestCommandRegistration)}:c?this._command={fromApi:c,internal:this.#t.toInternal(c,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let _;this._name?_=this._name:_=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const n=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,c,this._extension?.identifier.value,_,this._text,n,this._command?.internal,h,this._backgroundColor,this._alignment===S.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class a{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const _={message:c};return this._messages.unshift(_),this._update(),new S.Disposable(()=>{const h=this._messages.indexOf(_);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class k{constructor(c,_){this._existingItems=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadStatusBar),this._commands=_,this._statusMessage=new a(this)}$acceptStaticEntries(c){for(const _ of c)this._existingItems.set(_.entryId,_)}createStatusBarEntry(c,_,h,n){return new v(this._proxy,this._commands,this._existingItems,c,_,h,n)}setStatusBarMessage(c,_){const h=this._statusMessage.setMessage(c);let n;return typeof _=="number"?n=setTimeout(()=>h.dispose(),_):typeof _<"u"&&_.then(()=>h.dispose(),()=>h.dispose()),new S.Disposable(()=>{h.dispose(),clearTimeout(n)})}}e.ExtHostStatusBar=k}),define(Te[125],Pe([1,0,33,116,55,82,56,8,2]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,S=$e(S),R=$e(R);const a=(i,r,t,l)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(g){if(!t(u,g)){const m=u;u=g,i.listener?.(l(g,m))}}}},k=(i,r)=>i===r,w={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(l=>t.id===l.id)))},c=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),_=(i,r)=>({range:(()=>{let t;const l=c(u=>({range:S.Range.lift(R.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),w.range(t,u)||(t=u,i.listener?.(l(u)))}}})(),label:a(i,r,w.label,c(t=>({label:t}))),description:a(i,void 0,w.description,c(t=>({description:t}))),sortText:a(i,void 0,w.sortText,c(t=>({sortText:t}))),canResolveChildren:a(i,!1,w.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,w.busy,c(t=>({busy:t}))),error:a(i,void 0,w.error,c(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],w.tags,(t,l)=>({op:O.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:l.map(R.TestTag.from)}))}),h=i=>{const r=I.TestId.fromString(i.extId),t=new s(r.controllerId,r.localId,i.label,v.URI.revive(i.uri)||void 0);return t.range=R.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(l=>R.TestTag.to({id:(0,A.denamespaceTestTag)(l).tagId})),t},n=i=>{let r;for(const t of i.tests){const l=h(t.item);(0,T.getPrivateApiFor)(l).parent=r,r=l}return r};e.toItemFromContext=n;class s{constructor(r,t,l,u){if(t.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,T.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof o?void 0:g.parent}},children:{value:(0,O.createTestItemChildren)(g,T.getPrivateApiFor,s),enumerable:!0,writable:!1},..._(g,l)})}}e.TestItemImpl=s;class o extends s{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class d extends O.TestItemCollection{constructor(r,t,l){super({controllerId:r,getDocumentVersion:u=>u&&l.getDocument(u)?.version,getApiFor:T.getPrivateApiFor,getChildren:u=>u.children,root:new o(r,t),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Te[34],Pe([1,0,15,7,8,26,5,18,12,49,33,101,2,4,3,17,125,23,39,41,70,64,67,37]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,T=$e(T),I=$e(I);let g=class{#e;#t;#i;constructor(D,P,f){this._commands=new Map,this._apiCommands=new Map,this.#e=D.getProxy(A.MainContext.MainThreadCommands),this._logService=P,this.#i=f,this.#t=D.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new m(this,E=>{const F=this._apiCommands.get(E);return F?.result===y.Void?F:void 0},P),this._argumentProcessors=[{processArgument(E){return(0,a.revive)(E)}},{processArgument(E){return(0,O.cloneAndChange)(E,function(F){if(k.Range.isIRange(F))return I.Range.to(F);if(w.Position.isIPosition(F))return I.Position.to(F);if(k.Range.isIRange(F.range)&&c.URI.isUri(F.uri))return I.location.to(F);if(F instanceof o.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(D){this._argumentProcessors.push(D)}registerApiCommand(D){const P=this.registerCommand(!1,D.id,async(...f)=>{const E=D.args.map((L,M)=>{if(!L.validate(f[M]))throw new Error(`Invalid argument '${L.name}' when running '${D.id}', received: ${typeof f[M]=="object"?JSON.stringify(f[M],null,"	"):f[M]} `);return L.convert(f[M])}),F=await this.executeCommand(D.internalId,...E);return D.result.convert(F,f,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this._apiCommands.set(D.id,D),new T.Disposable(()=>{P.dispose(),this._apiCommands.delete(D.id)})}registerCommand(D,P,f,E,F,L){if(this._logService.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this._commands.has(P))throw new Error(`command '${P}' already exists`);return this._commands.set(P,{callback:f,thisArg:E,metadata:F,extension:L}),D&&this.#e.$registerCommand(P),new T.Disposable(()=>{this._commands.delete(P)&&D&&this.#e.$unregisterCommand(P)})}executeCommand(D,...P){return this._logService.trace("ExtHostCommands#executeCommand",D),this._doExecuteCommand(D,P,!0)}async _doExecuteCommand(D,P,f){if(this._commands.has(D))return this.#e.$fireCommandActivationEvent(D),this._executeContributedCommand(D,P,!1);{let E=!1;const F=(0,O.cloneAndChange)(P,function(L){if(L instanceof T.Position)return I.Position.from(L);if(L instanceof T.Range)return I.Range.from(L);if(L instanceof T.Location)return I.location.from(L);if(T.NotebookRange.isNotebookRange(L))return I.NotebookRange.from(L);if(L instanceof ArrayBuffer)return E=!0,o.VSBuffer.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return E=!0,o.VSBuffer.wrap(L);if(L instanceof o.VSBuffer)return E=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(D,E?new d.SerializableObjectWithBuffers(F):F,f);return(0,a.revive)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this._doExecuteCommand(D,P,!1);throw L}}}async _executeContributedCommand(D,P,f){const E=this._commands.get(D);if(!E)throw new Error("Unknown command");const{callback:F,thisArg:L,metadata:M}=E;if(M?.args)for(let W=0;W<M.args.length;W++)try{(0,S.validateConstraint)(P[W],M.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${M.args[W].name}' - ${M.args[W].description}`)}const V=r.StopWatch.create();try{return await F.apply(L,P)}catch(W){if(D===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...P);N&&(D=N.command)}if(this._logService.error(W,D,E.extension?.identifier),!f)throw W;if(E.extension?.identifier){const N=this.#i.onExtensionError(E.extension.identifier,W);this._logService.trace("forwarded error to extension?",N,E.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(W)),this.id=D,this.source=E.extension?.displayName??E.extension?.name}}}finally{this._reportTelemetry(E,D,V.elapsed())}}_reportTelemetry(D,P,f){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new t.TelemetryTrustedValue(P),duration:f})}$executeContributedCommand(D,...P){this._logService.trace("ExtHostCommands#$executeContributedCommand",D);const f=this._commands.get(D);return f?(P=P.map(E=>this._argumentProcessors.reduce((F,L)=>L.processArgument(F,f.extension?.identifier),E)),this._executeContributedCommand(D,P,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this._logService.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(P=>(D&&(P=P.filter(f=>f[0]!=="_")),P))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[P,f]of this._commands){const{metadata:E}=f;E&&(D[P]=E)}return Promise.resolve(D)}};e.ExtHostCommands=g,e.ExtHostCommands=g=je([Ve(0,n.IExtHostRpcService),Ve(1,v.ILogService),Ve(2,l.IExtHostTelemetry)],g),e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class m{constructor(D,P,f){this._commands=D,this._lookupApiCommand=P,this._logService=f,this.delegatingCommandId=`__vsc${(0,u.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(D,P){if(!D)return;const f={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return f;const E=this._lookupApiCommand(D.command);if(E)f.id=E.internalId,f.arguments=E.args.map((F,L)=>F.convert(D.arguments&&D.arguments[L]));else if((0,R.isNonEmptyArray)(D.arguments)){const F=`${D.command} /${++this._cachIdPool}`;this._cache.set(F,D),P.add((0,_.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),f.$ident=F,f.id=this.delegatingCommandId,f.arguments=[F],this._logService.trace("CommandsConverter#CREATE",D.command,F)}return f}fromInternal(D){return typeof D.$ident=="string"?this._cache.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this._cache.get(D[0])}_executeConvertedCommand(...D){const P=this.getActualCommand(...D);return this._logService.trace("CommandsConverter#EXECUTE",D[0],P?P.command:"MISSING"),P?this._commands.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.CommandsConverter=m;class p{static{this.Uri=new p("uri","Uri of a text document",D=>c.URI.isUri(D),D=>D)}static{this.Position=new p("position","A position in a text document",D=>T.Position.isPosition(D),I.Position.from)}static{this.Range=new p("range","A range in a text document",D=>T.Range.isRange(D),I.Range.from)}static{this.Selection=new p("selection","A selection in a text document",D=>T.Selection.isSelection(D),I.Selection.from)}static{this.Number=new p("number","",D=>typeof D=="number",D=>D)}static{this.String=new p("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=p.Arr(p.String)}static Arr(D){return new p(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,P=>Array.isArray(P)&&P.every(f=>D.validate(f)),P=>P.map(f=>D.convert(f)))}static{this.CallHierarchyItem=new p("item","A call hierarchy item",D=>D instanceof T.CallHierarchyItem,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new p("item","A type hierarchy item",D=>D instanceof T.TypeHierarchyItem,I.TypeHierarchyItem.from)}static{this.TestItem=new p("testItem","A VSCodium TestItem",D=>D instanceof s.TestItemImpl,I.TestItem.from)}constructor(D,P,f,E){this.name=D,this.description=P,this.validate=f,this.convert=E}optional(){return new p(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,P){return new p(D??this.name,P??this.description,this.validate,this.convert)}}e.ApiCommandArgument=p;class y{static{this.Void=new y("no result",D=>D)}constructor(D,P){this.description=D,this.convert=P}}e.ApiCommandResult=y;class C{constructor(D,P,f,E,F){this.id=D,this.internalId=P,this.description=f,this.args=E,this.result=F}}e.ApiCommand=C}),define(Te[298],Pe([1,0,18,16,2,94,104,32,34,8,7]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,O=$e(O),a=$e(a),k=$e(k);const w=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(a.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,s)=>{if((0,S.isFalsyOrEmpty)(n))return;class o extends k.SymbolInformation{static to(i){const r=new o(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new k.Location(s[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return n.map(o.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(a.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(a.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(a.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(a.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(a.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(s=>k.Position.isPosition(s)),n=>n.map(a.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(s=>{let o;for(const d of s.reverse())o=new k.SelectionRange(a.Range.to(d),o);return o}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.decodeSemanticTokensDto)(n);if(s.type==="full")return new k.SemanticTokens(s.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.decodeSemanticTokensDto)(n);if(s.type==="full")return new k.SemanticTokens(s.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,s,o)=>{if(!n)return new k.CompletionList([]);const d=n.suggestions.map(i=>a.CompletionItem.to(i,o));return new k.CompletionList(d,n.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,s,o)=>_(d=>new k.CodeLens(a.Range.to(d.range),d.command&&o.fromInternal(d.command)))(n))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>k.Range.isRange(n),n=>k.Selection.isSelection(n)?a.Selection.from(n):a.Range.from(n)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,s,o)=>_(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(d.command)}else{const i=new k.CodeAction(d.title,d.kind?new k.CodeActionKind(d.kind):void 0);return d.edit&&(i.edit=a.WorkspaceEdit.to(d.edit)),d.command&&(i.command=o.fromInternal(d.command)),i.isPreferred=d.isPreferred,i}})(n))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(s=>new k.ColorInformation(a.Range.to(s.range),a.Color.to(s.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",n=>n instanceof k.Color,a.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,s,o)=>n.map(a.InlayHint.to.bind(void 0,o)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,s)=>{if(n)return n.map(a.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.to(s))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof k.Range,n=>a.InlineValueContext.from(n))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,T.matchesSomeScheme)(n,T.Schemas.http,T.Schemas.https),n=>n),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",n=>{for(const s of n){if(s.length!==3)return!1;const[o,d,i]=s;if(!I.URI.isUri(o)||!I.URI.isUri(d)&&d!==void 0&&d!==null||!I.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:k.Selection.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],v.ApiCommandResult.Void)];class c{static register(s){w.forEach(s.registerApiCommand,s),this._registerValidateWhenClausesCommand(s)}static _registerValidateWhenClausesCommand(s){s.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=c;function _(n){return s=>{if(Array.isArray(s))return s.map(n)}}function h(n){if(!Array.isArray(n))return;const s=[];for(const o of n)O.isLocationLink(o)?s.push(a.DefinitionLink.to(o)):s.push(a.location.to(o));return s}}),define(Te[299],Pe([1,0,2,34]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(A,R,v,a,k){this._extHostNotebooks=R,this._textDocumentsAndEditors=v,this._commands=a;const w=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",c=>!0,c=>c),new T.ApiCommandArgument("resource","Interactive resource Uri",c=>!0,c=>c),new T.ApiCommandArgument("controllerId","Notebook controller Id",c=>!0,c=>c),new T.ApiCommandArgument("title","Interactive editor title",c=>!0,c=>c)],new T.ApiCommandResult("Notebook and input URI",c=>{if(k.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(c.notebookEditorId);return k.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:S.URI.revive(c.notebookUri),inputUri:S.URI.revive(c.inputUri),notebookEditor:_.apiEditor}}return k.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:S.URI.revive(c.notebookUri),inputUri:S.URI.revive(c.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(A,R,v,a){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:v,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=I}),define(Te[300],Pe([1,0,18,11,22,6,4,29,2,19,12,5,34,8,7,83,239,25,39,240]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=p,_=$e(_);let r=class{constructor(C,b,D,P,f){this._initData=b,this._extHostNotebook=D,this._commands=P,this._logService=f,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=C.getProxy(w.MainContext.MainThreadNotebookKernels);const E=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const M=this._extHostNotebook.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:M}}else if(L&&"notebookEditor"in L){const M=this._extHostNotebook.getIdByEditor(L.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return L})],c.ApiCommandResult.Void),F=new c.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[c.ApiCommandArgument.Uri],new c.ApiCommandResult("A promise that resolves to an array of variables",(L,M)=>L.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this._commands.registerApiCommand(E),this._commands.registerApiCommand(F)}createNotebookController(C,b,D,P,f,E){for(const oe of this._kernelData.values())if(oe.controller.id===b&&a.ExtensionIdentifier.equals(C.identifier,oe.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const F=this._handlePool++,L=this;this._logService.trace(`NotebookController[${F}], CREATED by ${C.identifier.value}, ${b}`);const M=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${C.identifier}'`);let V=!1;const W=new O.Emitter,N=new O.Emitter,Q={id:p(C.identifier,b),notebookType:D,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:P||C.identifier.value,preloads:E?E.map(_.NotebookRendererScript.from):[]};let Y=f??M,ge,Z;this._proxy.$addKernel(F,Q).catch(oe=>{console.log(oe),V=!0});let me=0;const se=()=>{if(V)return;const oe=++me;Promise.resolve().then(()=>{oe===me&&this._proxy.$updateKernel(F,Q)})},le=new R.ResourceMap,Ee={get id(){return b},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return Q.label},set label(oe){Q.label=oe??C.displayName??C.name,se()},get detail(){return Q.detail??""},set detail(oe){Q.detail=oe,se()},get description(){return Q.description??""},set description(oe){Q.description=oe,se()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(oe){Q.supportedLanguages=oe,se()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){Q.supportsExecutionOrder=oe,se()},get rendererScripts(){return Q.preloads?Q.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(oe){Y=oe??M},get interruptHandler(){return ge},set interruptHandler(oe){ge=oe,Q.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,o.checkProposedApiEnabled)(C,"notebookVariableProvider"),Z=oe,Q.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Ie=>L._proxy.$variablesUpdated(Ie.uri)),se()},get variableProvider(){return Z},createNotebookCellExecution(oe){if(V)throw new Error("notebook controller is DISPOSED");if(!le.has(oe.notebook.uri))throw L._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return L._createNotebookCellExecution(oe,p(C.identifier,this.id))},createNotebookExecution(oe){if((0,o.checkProposedApiEnabled)(C,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!le.has(oe.uri))throw L._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return L._createNotebookExecution(oe,p(C.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${F}], DISPOSED`),V=!0,this._kernelData.delete(F),W.dispose(),N.dispose(),this._proxy.$removeKernel(F))},updateNotebookAffinity(oe,Ie){Ie===h.NotebookControllerAffinity2.Hidden&&(0,o.checkProposedApiEnabled)(C,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(F,oe.uri,Ie)},onDidReceiveMessage:N.event,postMessage(oe,Ie){return(0,o.checkProposedApiEnabled)(C,"notebookMessaging"),L._proxy.$postMessage(F,Ie&&L._extHostNotebook.getIdByEditor(Ie),oe)},asWebviewUri(oe){return(0,o.checkProposedApiEnabled)(C,"notebookMessaging"),(0,n.asWebviewUri)(oe,L._initData.remote)}};return this._kernelData.set(F,{extensionId:C.identifier,controller:Ee,onDidReceiveMessage:N,onDidChangeSelection:W,associatedNotebooks:le}),Ee}getIdByController(C){for(const[b,D]of this._kernelData)if(D.controller===C)return p(D.extensionId,C.id);return null}createNotebookControllerDetectionTask(C,b){const D=this._kernelDetectionTaskHandlePool++,P=this;this._logService.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${C.identifier.value}`),this._proxy.$addKernelDetectionTask(D,b);const f={dispose:()=>{this._kernelDetectionTask.delete(D),P._proxy.$removeKernelDetectionTask(D)}};return this._kernelDetectionTask.set(D,f),f}registerKernelSourceActionProvider(C,b,D){const P=this._kernelSourceActionProviderHandlePool++,f=typeof D.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,E=this;this._kernelSourceActionProviders.set(P,D),this._logService.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${C.identifier.value}`),this._proxy.$addKernelSourceActionProvider(P,P,b);let F;return f!==void 0&&(F=D.onDidChangeNotebookKernelSourceActions(L=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this._kernelSourceActionProviders.delete(P),E._proxy.$removeKernelSourceActionProvider(P,P),F?.dispose()}}}async $provideKernelSourceActions(C,b){const D=this._kernelSourceActionProviders.get(C);if(D){const P=new A.DisposableStore;return(await D.provideNotebookKernelSourceActions(b)??[]).map(E=>_.NotebookKernelSourceAction.from(E,this._commands.converter,P))}return[]}$acceptNotebookAssociation(C,b,D){const P=this._kernelData.get(C);if(P){const f=this._extHostNotebook.getNotebookDocument(v.URI.revive(b));D?P.associatedNotebooks.set(f.uri,!0):P.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${C}] ASSOCIATE notebook`,f.uri.toString(),D),P.onDidChangeSelection.fire({selected:D,notebook:f.apiNotebook})}}async $executeCells(C,b,D){const P=this._kernelData.get(C);if(!P)return;const f=this._extHostNotebook.getNotebookDocument(v.URI.revive(b)),E=[];for(const F of D){const L=f.getCell(F);L&&E.push(L.apiCell)}try{this._logService.trace(`NotebookController[${C}] EXECUTE cells`,f.uri.toString(),E.length),await P.controller.executeHandler.call(P.controller,E,f.apiNotebook,P.controller)}catch(F){this._logService.error(`NotebookController[${C}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(C,b,D){const P=this._kernelData.get(C);if(!P)return;const f=this._extHostNotebook.getNotebookDocument(v.URI.revive(b));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,f.apiNotebook);else for(const E of D){const F=f.getCell(E);F&&this._activeExecutions.get(F.uri)?.cancel()}if(P.controller.interruptHandler){const E=this._activeNotebookExecutions.get(f.uri);this._activeNotebookExecutions.delete(f.uri),D.length&&Array.isArray(E)&&E.length&&E.forEach(F=>F.dispose())}}async $provideVariables(C,b,D,P,f,E,F){const L=this._kernelData.get(C);if(!L)return;const M=this._extHostNotebook.getNotebookDocument(v.URI.revive(D)),V=L.controller.variableProvider;if(!V)return;let W;if(P!==void 0){if(W=this.variableStore[P],!W)return}else this.variableStore={};const N=f==="named"?h.NotebookVariablesRequestKind.Named:h.NotebookVariablesRequestKind.Indexed,Q=V.provideVariables(M.apiNotebook,W,N,E,F);let Y=0;for await(const ge of Q){if(F.isCancellationRequested)return;const Z={id:this.id++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:L.extensionId.value};if(this.variableStore[Z.id]=ge.variable,this._proxy.$receiveVariable(b,Z),Y++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(C,b,D){const P=this._kernelData.get(C);if(!P)return;const f=this._extHostNotebook.getEditorById(b);P.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:D}))}$cellExecutionChanged(C,b,D){const f=this._extHostNotebook.getNotebookDocument(v.URI.revive(C)).getCell(b);if(f){const E=D?_.NotebookCellExecutionState.to(D):h.NotebookCellExecutionState.Idle;E!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:E})}}_createNotebookCellExecution(C,b){if(C.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this._extHostNotebook.getNotebookDocument(C.notebook.uri).getCellFromApiCell(C);if(!P)throw new Error("invalid cell");if(this._activeExecutions.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const f=new l(b,P,this._proxy);this._activeExecutions.set(P.uri,f);const E=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),E.dispose(),this._activeExecutions.delete(P.uri))});return f.asApiObject()}_createNotebookExecution(C,b){const D=this._extHostNotebook.getNotebookDocument(C.uri),P=C.getCells().find(F=>{const L=D.getCellFromApiCell(F);return L&&this._activeExecutions.has(L.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this._activeNotebookExecutions.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const f=new g(b,D,this._proxy),E=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),E.dispose(),this._activeNotebookExecutions.delete(D.uri))});return this._activeNotebookExecutions.set(D.uri,[f,E]),f.asApiObject()}};e.ExtHostNotebookKernels=r,e.ExtHostNotebookKernels=r=je([Ve(4,k.ILogService)],r);var t;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(t||(t={}));class l extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(C,b,D){super(),this._cell=b,this._proxy=D,this._handle=l.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new m(10,P=>this.update(P)),this._executionOrder=b.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,C,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(C){await this._collector.addItem(C)}async update(C){const b=Array.isArray(C)?C:[C];return this._proxy.$updateExecution(this._handle,new d.SerializableObjectWithBuffers(b))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(C){let b=this._cell;if(C&&(b=this._cell.notebook.getCellFromApiCell(C)),!b)throw new Error("INVALID cell");return b.handle}validateAndConvertOutputs(C){return C.map(b=>{const D=h.NotebookCellOutput.ensureUniqueMimeTypes(b.items,!0);return D===b.items?_.NotebookCellOutput.from(b):_.NotebookCellOutput.from({items:D,id:b.id,metadata:b.metadata})})}async updateOutputs(C,b,D){const P=this.cellIndexToHandle(b),f=this.validateAndConvertOutputs((0,S.asArray)(C));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,cellHandle:P,append:D,outputs:f})}async updateOutputItems(C,b,D){return C=h.NotebookCellOutput.ensureUniqueMimeTypes((0,S.asArray)(C),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,items:C.map(_.NotebookCellOutputItem.from),outputId:b.id,append:D})}asApiObject(){const C=this;return Object.freeze({get token(){return C._tokenSource.token},get cell(){return C._cell.apiCell},get executionOrder(){return C._executionOrder},set executionOrder(D){C._executionOrder=D,C.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:C._executionOrder}])},start(D){if(C._state===t.Resolved||C._state===t.Started)throw new Error("Cannot call start again");C._state=t.Started,C._onDidChangeState.fire(),C.update({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,P,f){if(C._state===t.Resolved)throw new Error("Cannot call resolve twice");C._state=t.Resolved,C._onDidChangeState.fire(),C._collector.flush();const E=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;C._proxy.$completeExecution(C._handle,new d.SerializableObjectWithBuffers({runEndTime:P,lastRunSuccess:D,error:E}))},clearOutput(D){return C.verifyStateForOutput(),C.updateOutputs([],D,!1)},appendOutput(D,P){return C.verifyStateForOutput(),C.updateOutputs(D,P,!0)},replaceOutput(D,P){return C.verifyStateForOutput(),C.updateOutputs(D,P,!1)},appendOutputItems(D,P){return C.verifyStateForOutput(),C.updateOutputItems(D,P,!0)},replaceOutputItems(D,P){return C.verifyStateForOutput(),C.updateOutputItems(D,P,!1)}})}}var u;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(u||(u={}));class g extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(C,b,D){super(),this._notebook=b,this._proxy=D,this._handle=g.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,C,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===u.Resolved||this._state===u.Started)throw new Error("Cannot call start again");this._state=u.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===u.Resolved)throw new Error("Cannot call resolve twice");this._state=u.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class m{constructor(C,b){this.delay=C,this.callback=b,this.batch=[],this.startedTimer=Date.now()}addItem(C){return this.batch.push(C),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const C=this.currentDeferred;this.currentDeferred=void 0;const b=this.batch;return this.batch=[],this.callback(b).finally(()=>C.complete())}}function p(y,C){return`${y.value}/${C}`}}),define(Te[57],Pe([1,0,6,5,3,2,17,4,7,189,14,220,22,37,221,222,35,11,8,34,38]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class t extends R.Disposable{constructor(f,E,F,L){super(),this._proxy=f,this._id=E,this._creationOptions=F,this._name=L,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new S.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},get selection(){return M._selection},get shellIntegration(){return M.shellIntegration},sendText(V,W=!0){M._checkDisposed(),M._proxy.$sendText(M._id,V,W)},show(V){M._checkDisposed(),M._proxy.$show(M._id,V)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(f,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??E?.cwd??void 0,env:f.env??void 0,icon:C(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this._serializeParentTerminal(f.location,E?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,E,F,L,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:L,color:s.ThemeColor.isThemeColor(M)?M.id:void 0,location:E?.location||this._serializeParentTerminal(f,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,E){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in f?{viewColumn:d.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitStatus(f,E){this._exitStatus=Object.freeze({code:f,reason:E})}setDimensions(f,E){return f===this._cols&&E===this._rows||f===0||E===0?!1:(this._cols=f,this._rows=E,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(f){this._selection=f}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(E=>{E!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=t;class l{get onProcessReady(){return this._onProcessReady.event}constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new S.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new S.Emitter,this._onDidChangeProperty=new S.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new S.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${E}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,E){this._pty.setDimensions?.({columns:f,rows:E})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this._pty.onDidWrite(E=>this._onProcessData.fire(E)),this._pty.onDidClose?.((E=void 0)=>{this._onProcessExit.fire(E===void 0?void 0:E)}),this._pty.onDidOverrideDimensions?.(E=>{E&&this._onDidChangeProperty.fire({type:h.ProcessPropertyType.OverrideDimensions,value:{cols:E.columns,rows:E.rows}})}),this._pty.onDidChangeName?.(E=>{this._onDidChangeProperty.fire({type:h.ProcessPropertyType.Title,value:E})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,g=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}constructor(f,E,F){super(),this._extHostCommands=E,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new S.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new S.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new S.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new S.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new S.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new S.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=F.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new n.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(f),this._extHostCommands.registerArgumentProcessor({processArgument:L=>{const M=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(L?.$mid){case r.MarshalledId.TerminalContext:return M(L);default:{if(Array.isArray(L))for(let V=0;V<L.length&&L[V].$mid===r.MarshalledId.TerminalContext;V++)L[V]=M(L[V]);return L}}}}),this._register({dispose:()=>{for(const[L,M]of this._terminalProcesses)M.shutdown(!0)}})}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,E){const F=new t(this._proxy,(0,_.generateUuid)(),f,f.name),L=new l(f.pty);return F.createExtensionTerminal(f.location,E,this._serializeParentTerminal(f,E).resolvedExtHostIdentifier,C(f.iconPath),b(f.color)).then(M=>{const V=this._setupExtHostProcessListeners(M,L);this._terminalProcessDisposables[M]=V}),this._terminals.push(F),F.value}_serializeParentTerminal(f,E){if(E=E||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const F=f.location.parentTerminal;if(F){const L=this._terminals.find(M=>M.value===F);L&&(E.resolvedExtHostIdentifier=L._id)}}else f.location&&typeof f.location!="object"?E.location=f.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(f,E){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const L=new l(E),M=this._setupExtHostProcessListeners(f,L);this._terminalProcessDisposables[f]=M}async $acceptActiveTerminalChanged(f){const E=this._activeTerminal;if(f===null){this._activeTerminal=void 0,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const F=this.getTerminalById(f);F&&(this._activeTerminal=F,E!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,E){const F=this.getTerminalById(f);F&&this._onDidWriteTerminalData.fire({terminal:F.value,data:E})}async $acceptTerminalDimensions(f,E,F){const L=this.getTerminalById(f);L&&L.setDimensions(E,F)&&this._onDidChangeTerminalDimensions.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(f,E){const F=this.getTerminalById(f);F&&this._onDidExecuteCommand.fire({terminal:F.value,...E})}async $acceptTerminalMaximumDimensions(f,E,F){this._terminalProcesses.get(f)?.resize(E,F)}async $acceptTerminalTitleChange(f,E){const F=this.getTerminalById(f);F&&(F.name=E)}async $acceptTerminalClosed(f,E,F){const L=this._getTerminalObjectIndexById(this._terminals,f);if(L!==null){const M=this._terminals.splice(L,1)[0];M.setExitStatus(E,F),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(f,E,F,L){if(E){const W=this._getTerminalObjectIndexById(this._terminals,E);if(W!==null){this._terminals[W]._id=f,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const M={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},V=new t(this._proxy,f,M,F);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(f,E){this.getTerminalById(f)?._setProcessId(E)}async $startExtensionTerminal(f,E){const F=this.getTerminalById(f);if(!F)return{message:(0,a.localize)(0,null,f)};F.isOpen||await new Promise(M=>{const V=this.onDidOpenTerminal(async W=>{W===F.value&&(V.dispose(),M())})});const L=this._terminalProcesses.get(f);L?L.startSendingEvents(E):this._extensionTerminalAwaitingStart[f]={initialDimensions:E}}_setupExtHostProcessListeners(f,E){const F=new R.DisposableStore;F.add(E.onProcessReady(M=>this._proxy.$sendProcessReady(f,M.pid,M.cwd,M.windowsPty))),F.add(E.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(f,M))),this._bufferer.startBuffering(f,E.onProcessData),F.add(E.onProcessExit(M=>this._onProcessExit(f,M))),this._terminalProcesses.set(f,E);const L=this._extensionTerminalAwaitingStart[f];return L&&E instanceof l&&(E.startSendingEvents(L.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),F}$acceptProcessAckDataEvent(f,E){this._terminalProcesses.get(f)?.acknowledgeDataEvent(E)}$acceptProcessInput(f,E){this._terminalProcesses.get(f)?.input(E)}$acceptTerminalInteraction(f){const E=this.getTerminalById(f);E?.setInteractedWith()&&this._onDidChangeTerminalState.fire(E.value)}$acceptTerminalSelection(f,E){this.getTerminalById(f)?.setSelection(E)}$acceptProcessResize(f,E,F){try{this._terminalProcesses.get(f)?.resize(E,F)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(f,E){this._terminalProcesses.get(f)?.shutdown(E)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(E=>this._proxy.$sendProcessProperty(f,{type:h.ProcessPropertyType.InitialCwd,value:E}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(E=>this._proxy.$sendProcessProperty(f,{type:h.ProcessPropertyType.Cwd,value:E}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,E,F){if(this._profileProviders.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this._profileProviders.set(E,F),this._proxy.$registerProfileProvider(E,f.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(E),this._proxy.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(f,E,F){if(this._quickFixProviders.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this._quickFixProviders.set(f,F),this._proxy.$registerQuickFixProvider(f,E),new v.Disposable(()=>{this._quickFixProviders.delete(f),this._proxy.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,E){const F=new c.CancellationTokenSource().token;if(F.isCancellationRequested)return;const L=this._quickFixProviders.get(f);if(!L)return;const M=await L.provideTerminalQuickFixes(E,F);if(M===null||Array.isArray(M)&&M.length===0)return;const V=new R.DisposableStore;if(this._lastQuickFixCommands.value=V,!Array.isArray(M))return M?d.TerminalQuickFix.from(M,this._extHostCommands.converter,V):void 0;const W=[];for(const N of M){const Q=d.TerminalQuickFix.from(N,this._extHostCommands.converter,V);Q&&W.push(Q)}return W}async $createContributedProfileTerminal(f,E){const F=new c.CancellationTokenSource().token;let L=await this._profileProviders.get(f)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,E);return}this.createTerminalFromOptions(L.options,E)}}async $provideLinks(f,E){const F=this.getTerminalById(f);if(!F)return[];this._terminalLinkCache.delete(f),this._terminalLinkCancellationSource.get(f)?.dispose(!0);const M=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,M);const V=[],W={terminal:F.value,line:E},N=[];for(const ge of this._linkProviders)N.push(o.Promises.withAsyncBody(async Z=>{M.token.onCancellationRequested(()=>Z({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(W,M.token)||[];M.token.isCancellationRequested||Z({provider:ge,links:me})}));const Q=await Promise.all(N);if(M.token.isCancellationRequested)return[];const Y=new Map;for(const ge of Q)ge&&ge.links.length>0&&V.push(...ge.links.map(Z=>{const me={id:u++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return Y.set(me.id,{provider:ge.provider,link:Z}),me}));return this._terminalLinkCache.set(f,Y),V}$activateLink(f,E){const F=this._terminalLinkCache.get(f)?.get(E);F&&F.provider.handleTerminalLink(F.link)}_onProcessExit(f,E){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const F=this._terminalProcessDisposables[f];F&&(F.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,E)}getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}getTerminalIdByApiObject(f){const E=this._terminals.findIndex(F=>F.value===f);return E>=0?E:null}_getTerminalObjectById(f,E){const F=this._getTerminalObjectIndexById(f,E);return F!==null?f[F]:null}_getTerminalObjectIndexById(f,E){const F=f.findIndex(L=>L._id===E);return F>=0?F:null}getEnvironmentVariableCollection(f){let E=this._environmentVariableCollections.get(f.identifier.value);return E||(E=this._register(new m),this._setEnvironmentVariableCollection(f.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(f,E){const F=(0,w.serializeEnvironmentVariableCollection)(E.map),L=(0,w.serializeEnvironmentDescriptionMap)(E.descriptionMap);this._proxy.$setEnvironmentVariableCollection(f,E.persistent,F.length===0?void 0:F,L)}$initEnvironmentVariableCollections(f){f.forEach(E=>{const F=E[0],L=this._register(new m(E[1]));this._setEnvironmentVariableCollection(F,L)})}$acceptDefaultProfile(f,E){const F=this._defaultProfile;this._defaultProfile=f,this._defaultAutomationProfile=E,F?.path!==f.path&&this._onDidChangeShell.fire(f.path)}_setEnvironmentVariableCollection(f,E){this._environmentVariableCollections.set(f,E),this._register(E.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,E)}))}};e.BaseExtHostTerminalService=g,e.BaseExtHostTerminalService=g=je([Ve(1,i.IExtHostCommands),Ve(2,A.IExtHostRpcService)],g);class m extends R.Disposable{get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new S.Emitter,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const E=this.getScopeKey(f);let F=this.scopedCollections.get(E);return F||(F=new p(this,f),this.scopedCollections.set(E,F),this._register(F.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),F}replace(f,E,F,L){this._setIfDiffers(f,{value:E,type:v.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:L})}append(f,E,F,L){this._setIfDiffers(f,{value:E,type:v.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:L})}prepend(f,E,F,L){this._setIfDiffers(f,{value:E,type:v.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:L})}_setIfDiffers(f,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.getKey(f,E.scope),L=this.map.get(F),M=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==E.value||L.type!==E.type||L.options?.applyAtProcessCreation!==M.applyAtProcessCreation||L.options?.applyAtShellIntegration!==M.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const V=this.getKey(f,E.scope),W={variable:f,...E,options:M};this.map.set(V,W),this._onDidChangeCollection.fire()}}get(f,E){const F=this.getKey(f,E),L=this.map.get(F);return L?D(L):void 0}getKey(f,E){const F=this.getScopeKey(E);return F.length?`${f}:::${F}`:f}getScopeKey(f){return this.getWorkspaceKey(f?.workspaceFolder)??""}getWorkspaceKey(f){return f?f.uri.toString():void 0}getVariableMap(f){const E=new Map;for(const[F,L]of this.map)this.getScopeKey(L.scope)===this.getScopeKey(f)&&E.set(L.variable,D(L));return E}delete(f,E){const F=this.getKey(f,E);this.map.delete(F),this._onDidChangeCollection.fire()}clear(f){if(f?.workspaceFolder){for(const[E,F]of this.map)F.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(E);this.clearDescription(f)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(f,E){const F=this.getScopeKey(E),L=this.descriptionMap.get(F);if(!L||L.description!==f){let M;typeof f=="string"?M=f:M=f?.value.split(`

`)[0];const V={description:M,scope:E};this.descriptionMap.set(F,V),this._onDidChangeCollection.fire()}}getDescription(f){const E=this.getScopeKey(f);return this.descriptionMap.get(E)?.description}clearDescription(f){const E=this.getScopeKey(f);this.descriptionMap.delete(E)}}class p{get persistent(){return this.collection.persistent}set persistent(f){this.collection.persistent=f}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f,E){this.collection=f,this.scope=E,this._onDidChangeCollection=new S.Emitter}getScoped(f){return this.collection.getScopedEnvironmentVariableCollection(f)}replace(f,E,F){this.collection.replace(f,E,F,this.scope)}append(f,E,F){this.collection.append(f,E,F,this.scope)}prepend(f,E,F){this.collection.prepend(f,E,F,this.scope)}get(f){return this.collection.get(f,this.scope)}forEach(f,E){this.collection.getVariableMap(this.scope).forEach((F,L)=>f.call(E,L,F,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(f){this.collection.delete(f,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(f){this.collection.setDescription(f,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let y=class extends g{constructor(f,E){super(!1,f,E)}createTerminal(f,E,F){throw new k.NotSupportedError}createTerminalFromOptions(f,E){throw new k.NotSupportedError}};e.WorkerExtHostTerminalService=y,e.WorkerExtHostTerminalService=y=je([Ve(0,i.IExtHostCommands),Ve(1,A.IExtHostRpcService)],y);function C(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function b(P){return s.ThemeColor.isThemeColor(P)?P:void 0}function D(P){const f={...P};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Te[126],Pe([1,0,7,4,3,5,17,57,6,2,11]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,I.createDecorator)("IExtHostTerminalShellIntegration");let w=class extends T.Disposable{constructor(s,o){super(),this._extHostTerminalService=o,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=s.getProxy(O.MainContext.MainThreadTerminalShellIntegration),this._register((0,T.toDisposable)(()=>{for(const[d,i]of this._activeShellIntegrations)i.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(s){const o=this._extHostTerminalService.getTerminalById(s);if(!o)return;const d=o.value;let i=this._activeShellIntegrations.get(s);i||(i=new c(o.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(s,i),i.store.add(o.onWillDispose(()=>this._activeShellIntegrations.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this._proxy.$executeCommand(s,r))),i.store.add(i.onDidRequestEndExecution(r=>this._onDidEndTerminalShellExecution.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this._onDidChangeTerminalShellIntegration.fire(r))),o.shellIntegration=i.value),this._onDidChangeTerminalShellIntegration.fire({terminal:d,shellIntegration:i.value})}$shellExecutionStart(s,o,d,i,r){this._activeShellIntegrations.has(s)||this.$shellIntegrationChange(s);const t={value:o,confidence:d,isTrusted:i};this._activeShellIntegrations.get(s)?.startShellExecution(t,r)}$shellExecutionEnd(s,o,d,i,r){const t={value:o,confidence:d,isTrusted:i};this._activeShellIntegrations.get(s)?.endShellExecution(t,r)}$shellExecutionData(s,o){this._activeShellIntegrations.get(s)?.emitData(o)}$cwdChange(s,o){this._activeShellIntegrations.get(s)?.setCwd((0,a.isUriComponents)(o)?a.URI.revive(o):o)}$closeTerminal(s){this._activeShellIntegrations.get(s)?.dispose(),this._activeShellIntegrations.delete(s)}};e.ExtHostTerminalShellIntegration=w,e.ExtHostTerminalShellIntegration=w=je([Ve(0,A.IExtHostRpcService),Ve(1,R.IExtHostTerminalService)],w);class c extends T.Disposable{get currentExecution(){return this._currentExecution}constructor(s,o){super(),this._terminal=s,this._onDidStartTerminalShellExecution=o,this._ignoreNextExecution=!1,this.store=this._register(new T.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const d=this;this.value={get cwd(){return d._cwd},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),d._onDidRequestShellExecution.fire(t);const l={value:t,confidence:S.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=d.startShellExecution(l,d._cwd,!0).value;return d._ignoreNextExecution=!0,u}}}startShellExecution(s,o,d){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const i=this._currentExecution=new _(s,o);d?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:i.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this._currentExecution&&(this._currentExecution.endExecution(s),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:o}),this._currentExecution=void 0)}setCwd(s){let o=!1;a.URI.isUri(this._cwd)?o=!a.URI.isUri(s)||this._cwd.toString()!==s.toString():this._cwd!==s&&(o=!0),o&&(this._cwd=s,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class _{constructor(s,o){this._commandLine=s,this.cwd=o,this._ended=!1;const d=this;this.value={get commandLine(){return d._commandLine},get cwd(){return d.cwd},read(){return d._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return k.AsyncIterableObject.EMPTY;this._dataStream=new h}return this._dataStream.createIterable()}emitData(s){this._dataStream?.emitData(s)}endExecution(s){s&&(this._commandLine=s),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class h extends T.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new k.Barrier);const s=this._barrier;return new k.AsyncIterableObject(async d=>{this._emitters.push(d),await s.wait()})}emitData(s){for(const o of this._emitters)o.emitOne(s)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Te[127],Pe([1,0,62,14,97,8,7]),function(ae,e,S,T,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,O=$e(O);class R{static{this._Keys=new I.IdGenerator("TextEditorDecorationType")}constructor(c,_,h){const n=R._Keys.nextId();c.$registerTextEditorDecorationType(_.identifier,n,O.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:n,dispose(){c.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=R;class v{constructor(c,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,_){this._throwIfFinalized();let h=null;if(c instanceof A.Position)h=new A.Range(c,c);else if(c instanceof A.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,_,!1)}insert(c,_){this._throwIfFinalized(),this._pushEdit(new A.Range(c,c),_,!0)}delete(c){this._throwIfFinalized();let _=null;if(c instanceof A.Range)_=c;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(c,_,h){const n=this._document.validateRange(c);this._collectedEdits.push({range:n,text:_,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=c}}class a{constructor(c,_,h,n){this._proxy=c,this._id=_,this._accept(h),this._logService=n;const s=this;this.value={get tabSize(){return s._tabSize},set tabSize(o){s._setTabSize(o)},get indentSize(){return s._indentSize},set indentSize(o){s._setIndentSize(o)},get insertSpaces(){return s._insertSpaces},set insertSpaces(o){s._setInsertSpaces(o)},get cursorStyle(){return s._cursorStyle},set cursorStyle(o){s._setCursorStyle(o)},get lineNumbers(){return s._lineNumbers},set lineNumbers(o){s._setLineNumbers(o)}}}_accept(c){this._tabSize=c.tabSize,this._indentSize=c.indentSize,this._originalIndentSize=c.originalIndentSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const _=Math.floor(c);return _>0?_:null}if(typeof c=="string"){const _=parseInt(c,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(c){const _=this._validateTabSize(c);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateIndentSize(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const _=Math.floor(c);return _>0?_:null}if(typeof c=="string"){const _=parseInt(c,10);return isNaN(_)?null:_>0?_:null}return null}_setIndentSize(c){const _=this._validateIndentSize(c);if(_!==null){if(typeof _=="number"){if(this._originalIndentSize===_)return;this._indentSize=_,this._originalIndentSize=_}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:_}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:!!c}_setInsertSpaces(c){const _=this._validateInsertSpaces(c);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(c)})))}assign(c){const _={};let h=!1;if(typeof c.tabSize<"u"){const n=this._validateTabSize(c.tabSize);n==="auto"?(h=!0,_.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,h=!0,_.tabSize=n)}if(typeof c.indentSize<"u"){const n=this._validateIndentSize(c.indentSize);n==="tabSize"?(h=!0,_.indentSize=n):typeof n=="number"&&this._originalIndentSize!==n&&(this._indentSize=n,this._originalIndentSize=n,h=!0,_.indentSize=n)}if(typeof c.insertSpaces<"u"){const n=this._validateInsertSpaces(c.insertSpaces);n==="auto"?(h=!0,_.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,h=!0,_.insertSpaces=n)}typeof c.cursorStyle<"u"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,_.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,_.lineNumbers=O.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(c,_){_.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=a;class k{constructor(c,_,h,n,s,o,d,i){this.id=c,this._proxy=_,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=s,this._options=new a(this._proxy,this.id,o,h),this._visibleRanges=d,this._viewColumn=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new T.ReadonlyError("document")},get selection(){return r._selections&&r._selections[0]},set selection(t){if(!(t instanceof A.Selection))throw(0,T.illegalArgument)("selection");r._selections=[t],r._trySetSelection()},get selections(){return r._selections},set selections(t){if(!Array.isArray(t)||t.some(l=>!(l instanceof A.Selection)))throw(0,T.illegalArgument)("selections");r._selections=t,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(t){throw new T.ReadonlyError("visibleRanges")},get options(){return r._options.value},set options(t){r._disposed||r._options.assign(t)},get viewColumn(){return r._viewColumn},set viewColumn(t){throw new T.ReadonlyError("viewColumn")},edit(t,l={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new v(n.value,l);return t(u),r._applyEdit(u)},insertSnippet(t,l,u={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!l||Array.isArray(l)&&l.length===0)g=r._selections.map(m=>O.Range.from(m));else if(l instanceof A.Position){const{lineNumber:m,column:p}=O.Position.from(l);g=[{startLineNumber:m,startColumn:p,endLineNumber:m,endColumn:p}]}else if(l instanceof A.Range)g=[O.Range.from(l)];else{g=[];for(const m of l)if(m instanceof A.Range)g.push(O.Range.from(m));else{const{lineNumber:p,column:y}=O.Position.from(m);g.push({startLineNumber:p,startColumn:y,endLineNumber:p,endColumn:y})}}return _.$tryInsertSnippet(c,n.value.version,t.value,g,u)},setDecorations(t,l){const u=l.length===0;u&&!r._hasDecorationsForKey.has(t.key)||(u?r._hasDecorationsForKey.delete(t.key):r._hasDecorationsForKey.add(t.key),r._runOnProxy(()=>{if(O.isDecorationOptionsArr(l))return _.$trySetDecorations(c,t.key,O.fromRangeOrRangeWithMessage(l));{const g=new Array(4*l.length);for(let m=0,p=l.length;m<p;m++){const y=l[m];g[4*m]=y.start.line+1,g[4*m+1]=y.start.character+1,g[4*m+2]=y.end.line+1,g[4*m+3]=y.end.character+1}return _.$trySetDecorationsFast(c,t.key,g)}}))},revealRange(t,l){r._runOnProxy(()=>_.$tryRevealRange(c,O.Range.from(t),l||A.TextEditorRevealType.Default))},show(t){_.$tryShowEditor(c,O.ViewColumn.from(t))},hide(){_.$tryHideEditor(c)}})}dispose(){(0,S.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,S.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,S.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,S.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,S.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const _=c.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const h=_.edits.map(s=>s.range);h.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=h.length-1;s<o;s++){const d=h[s].end;if(h[s+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=_.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,n,{setEndOfLine:typeof _.setEndOfLine=="number"?O.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=k}),define(Te[58],Pe([1,0,62,6,4,2,3,5,123,17,127,8,12,29,16,40,48]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,S=$e(S),w=$e(w);class o{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let d=class{constructor(r,t){this._extHostRpc=r,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],l=[],u=[];if(r.removedDocuments)for(const g of r.removedDocuments){const m=O.URI.revive(g),p=this._documents.get(m);p?.unref()&&(this._documents.delete(m),t.push(p.value))}if(r.addedDocuments)for(const g of r.addedDocuments){const m=O.URI.revive(g.uri);let p=this._documents.get(m);if(p&&m.scheme!==h.Schemas.vscodeNotebookCell&&m.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);p||(p=new o(new v.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),m,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this._documents.set(m,p),l.push(p.value)),p.ref()}if(r.removedEditors)for(const g of r.removedEditors){const m=this._editors.get(g);this._editors.delete(g),m&&u.push(m)}if(r.addedEditors)for(const g of r.addedEditors){const m=O.URI.revive(g.documentUri);S.ok(this._documents.has(m),`document '${m}' does not exist`),S.ok(!this._editors.has(g.id),`editor '${g.id}' already exists!`);const p=this._documents.get(m).value,y=new k.ExtHostTextEditor(g.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new s.Lazy(()=>p.document),g.selections.map(w.Selection.to),g.options,g.visibleRanges.map(C=>w.Range.to(C)),typeof g.editorPosition=="number"?w.ViewColumn.to(g.editorPosition):void 0);this._editors.set(g.id,y)}r.newActiveEditor!==void 0&&(S.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,I.dispose)(t),(0,I.dispose)(u),r.removedDocuments&&this._onDidRemoveDocuments.fire(t),r.addedDocuments&&this._onDidAddDocuments.fire(l),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(g=>g.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return r?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=d,e.ExtHostDocumentsAndEditors=d=je([Ve(0,a.IExtHostRpcService),Ve(1,c.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[96],Pe([1,0,11,23,22,6,273,76,4,38,15,37,3,12,5,34,58,17,125,8,7,242,55,82,56,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,i=$e(i);let p=0;const y=new WeakMap;e.IExtHostTesting=(0,c.createDecorator)("IExtHostTesting");let C=class extends v.Disposable{constructor(Z,me,se,le){super(),this.logService=me,this.commands=se,this.editors=le,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=Z.getProxy(h.MainContext.MainThreadTesting),this.observer=new V(this.proxy),this.runTracker=new f(this.proxy,me),se.registerArgumentProcessor({processArgument:Ee=>{switch(Ee?.$mid){case a.MarshalledId.TestItemContext:{const oe=Ee,Ie=oe.tests[oe.tests.length-1].item.extId;return this.controllers.get(l.TestId.root(Ie))?.collection.tree.get(Ie)?.actual??(0,d.toItemFromContext)(Ee)}case a.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:Ie}=Ee,Me=oe.item.extId;return{test:this.controllers.get(l.TestId.root(Me))?.collection.tree.get(Me)?.actual??(0,d.toItemFromContext)({$mid:a.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(Ie)}}default:return Ee}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Ee=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=Ie=>{const Me=this.controllers.get(l.TestId.root(Ie));if(Me)return l.TestId.isRoot(Ie)?Me.controller:Me.collection.tree.get(Ie)?.actual};return{include:Ee?.include.map(oe).filter(k.isDefined)||[],exclude:Ee?.exclude.map(oe).filter(k.isDefined)||[]}})}createTestController(Z,me,se,le){if(this.controllers.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const Ee=new v.DisposableStore,oe=Ee.add(new d.ExtHostTestItemCollection(me,se,this.editors));oe.root.label=se;const Ie=new Map,Me=new Set,X=this.proxy,$={items:oe.root.children,get label(){return se},set label(Se){se=Se,oe.root.label=Se,X.$updateController(me,{label:se})},get refreshHandler(){return le},set refreshHandler(Se){le=Se,X.$updateController(me,{canRefresh:!!Se})},get id(){return me},createRunProfile:(Se,ce,be,he,G,J)=>{let pe=(0,R.hash)(Se);for(;Ie.has(pe);)pe++;return new N(this.proxy,Ie,Me,this.defaultProfilesChangedEmitter.event,me,pe,Se,ce,be,he,G,J)},createTestItem(Se,ce,be){return new d.TestItemImpl(me,Se,ce,be)},createTestRun:(Se,ce,be=!0)=>this.runTracker.createTestRun(Z,me,oe,Se,ce,be),invalidateTestResults:Se=>{if(Se===void 0)this.proxy.$markTestRetired(void 0);else{const ce=Se instanceof Array?Se:[Se];this.proxy.$markTestRetired(ce.map(be=>l.TestId.fromExtHostTestItem(be,me).toString()))}},set resolveHandler(Se){oe.resolveHandler=Se},get resolveHandler(){return oe.resolveHandler},dispose:()=>{Ee.dispose()}};X.$registerTestController(me,se,!!le),Ee.add((0,v.toDisposable)(()=>X.$unregisterTestController(me)));const te={controller:$,collection:oe,profiles:Ie,extension:Z,activeProfiles:Me};return this.controllers.set(me,te),Ee.add((0,v.toDisposable)(()=>this.controllers.delete(me))),Ee.add(oe.onDidGenerateDiff(Se=>X.$publishDiff(me,Se.map(g.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(Z,me=I.CancellationToken.None){const se=E(Z);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const le=this.controllers.get(se.controllerId);if(!le)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:Z.preserveFocus??!0,group:Q[se.kind],targets:[{testIds:Z.include?.map(Ee=>l.TestId.fromExtHostTestItem(Ee,le.collection.root.id).toString())??[le.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:Z.exclude?.map(Ee=>Ee.id)},me)}registerTestFollowupProvider(Z){return this.followupProviders.add(Z),{dispose:()=>{this.followupProviders.delete(Z)}}}$syncTests(){for(const{collection:Z}of this.controllers.values())Z.flushDiff();return Promise.resolve()}async $getCoverageDetails(Z,me,se){return(await this.runTracker.getCoverageDetails(Z,me,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(Z){this.runTracker.disposeTestRun(Z)}$configureRunProfile(Z,me){this.controllers.get(Z)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(Z){const me=new Map;for(const[se,le]of Object.entries(Z)){const Ee=this.controllers.get(se);if(!Ee)continue;const oe=new Map,Ie=le.filter(X=>!Ee.activeProfiles.has(X)),Me=[...Ee.activeProfiles].filter(X=>!le.includes(X));for(const X of Ie)oe.set(X,!0),Ee.activeProfiles.add(X);for(const X of Me)oe.set(X,!1),Ee.activeProfiles.delete(X);oe.size&&me.set(se,oe)}this.defaultProfilesChangedEmitter.fire(me)}async $refreshTests(Z,me){await this.controllers.get(Z)?.controller.refreshHandler?.(me)}$publishTestResults(Z){this.results=Object.freeze(Z.map(me=>{const se=i.TestResults.to(me);return y.set(se,me.id),se}).concat(this.results).sort((me,se)=>se.completedAt-me.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(Z,me){const se=this.controllers.get(l.TestId.fromString(Z).controllerId)?.collection;se&&(await se.expand(Z,me<0?1/0:me),se.flushDiff())}$acceptDiff(Z){this.observer.applyDiff(Z.map(me=>g.TestsDiffOp.deserialize({asCanonicalUri:se=>se},me)))}async $runControllerTests(Z,me){return Promise.all(Z.map(se=>this.runControllerTestRequest(se,!1,me)))}async $startContinuousRun(Z,me){const se=new I.CancellationTokenSource(me),le=await Promise.all(Z.map(Ee=>this.runControllerTestRequest(Ee,!0,se.token)));return!me.isCancellationRequested&&!le.some(Ee=>Ee.error)&&await new Promise(Ee=>me.onCancellationRequested(Ee)),se.dispose(!0),le}async $provideTestFollowups(Z,me){const se=this.results.find(oe=>y.get(oe)===Z.resultId),le=se&&Y(l.TestId.fromString(Z.extId),se?.results);if(!le)return[];let Ee=[];return await Promise.all([...this.followupProviders].map(async oe=>{try{const Ie=await oe.provideFollowup(se,le,Z.taskIndex,Z.messageIndex,me);Ie&&(Ee=Ee.concat(Ie))}catch(Ie){this.logService.error("Error thrown while providing followup for test message",Ie)}})),me.isCancellationRequested?[]:Ee.map(oe=>{const Ie=p++;return this.testFollowups.set(Ie,oe),{title:oe.title,id:Ie}})}$disposeTestFollowups(Z){for(const me of Z)this.testFollowups.delete(me)}$executeTestFollowup(Z){const me=this.testFollowups.get(Z);return me?this.commands.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(Z){Z===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(Z)}getMetadataForRun(Z){for(const me of this.runTracker.trackers){const se=me.getTaskIdForRun(Z);if(se)return{taskId:se,runId:me.id}}}async runControllerTestRequest(Z,me,se){const le=this.controllers.get(Z.controllerId);if(!le)return{};const{collection:Ee,profiles:oe,extension:Ie}=le,Me=oe.get(Z.profileId);if(!Me)return{};const X=Z.testIds.map(ce=>Ee.tree.get(ce)).filter(k.isDefined),$=Z.excludeExtIds.map(ce=>le.collection.tree.get(ce)).filter(k.isDefined).filter(ce=>X.some(be=>be.fullId.compare(ce.fullId)===l.TestPosition.IsChild));if(!X.length)return{};const te=new r.TestRunRequest(X.some(ce=>ce.actual instanceof d.TestItemRootImpl)?void 0:X.map(ce=>ce.actual),$.map(ce=>ce.actual),Me,me),Se=(0,g.isStartControllerTests)(Z)&&this.runTracker.prepareForMainThreadTestRun(Ie,te,F.fromInternal(Z,le.collection),Me,se);try{return await Me.runHandler(te,se),{}}catch(ce){return{error:String(ce)}}finally{Se&&Se.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(Se.onEnd)}}};e.ExtHostTesting=C,e.ExtHostTesting=C=je([Ve(0,o.IExtHostRpcService),Ve(1,_.ILogService),Ve(2,n.IExtHostCommands),Ve(3,s.IExtHostDocumentsAndEditors)],C);const b=1e4;var D;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(D||(D={}));class P extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(Z,me,se,le,Ee,oe){super(),this.dto=Z,this.proxy=me,this.logService=se,this.profile=le,this.extension=Ee,this.state=D.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(oe));const Ie=this._register(new S.RunOnceScheduler(()=>this.forciblyEndTasks(),b));this._register(this.cts.token.onCancellationRequested(()=>Ie.schedule()));const Me=new O.Emitter;this.onDidDispose=Me.event,this._register((0,v.toDisposable)(()=>{Me.fire(),Me.dispose()}))}getTaskIdForRun(Z){for(const[me,{run:se}]of this.tasks)if(se===Z)return me}cancel(){this.state===D.Running?(this.cts.cancel(),this.state=D.Cancelling):this.state===D.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails(Z,me,se){const[,le]=l.TestId.fromString(Z).path,Ee=this.publishedCoverage.get(Z);if(!Ee)return[];const{report:oe,extIds:Ie}=Ee,Me=this.tasks.get(le);if(!Me)throw new Error("unreachable: run task was not found");let X;if(me&&oe instanceof r.FileCoverage){const te=Ie.indexOf(me);if(te===-1)return[];X=oe.fromTests[te]}return await(X?this.profile?.loadDetailedCoverageForTest?.(Me.run,oe,X,se):this.profile?.loadDetailedCoverage?.(Me.run,oe,se))??[]}createRun(Z){const me=this.dto.id,se=this.dto.controllerId,le=(0,w.generateUuid)(),Ee=X=>($,...te)=>{if(Ie){this.logService.warn(`Setting the state of test "${$.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown($),X($,...te)},oe=(X,$)=>{const te=$ instanceof Array?$.map(i.TestMessage.from):[i.TestMessage.from($)];if(X.uri&&X.range){const Se={range:i.Range.from(X.range),uri:X.uri};for(const ce of te)ce.location=ce.location||Se}this.proxy.$appendTestMessagesInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),te)};let Ie=!1;const Me={isPersisted:this.dto.isPersisted,token:this.cts.token,name:Z,onDidDispose:this.onDidDispose,addCoverage:X=>{if(Ie)return;const $=X instanceof r.FileCoverage?X.fromTests:[];if($.length){(0,m.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const ce of $)this.ensureTestIsKnown(ce)}const te=X.uri.toString(),Se=new l.TestId([me,le,te]).toString();this.publishedCoverage.set(Se,{report:X,extIds:$.map(ce=>l.TestId.fromExtHostTestItem(ce,se).toString())}),this.proxy.$appendCoverage(me,le,i.TestCoverage.fromFile(se,Se,X))},enqueued:Ee(X=>{this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),g.TestResultState.Queued)}),skipped:Ee(X=>{this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),g.TestResultState.Skipped)}),started:Ee(X=>{this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),g.TestResultState.Running)}),errored:Ee((X,$,te)=>{oe(X,$),this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),g.TestResultState.Errored,te)}),failed:Ee((X,$,te)=>{oe(X,$),this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,se).toString(),g.TestResultState.Failed,te)}),passed:Ee((X,$)=>{this.proxy.$updateTestStateInRun(me,le,l.TestId.fromExtHostTestItem(X,this.dto.controllerId).toString(),g.TestResultState.Passed,$)}),appendOutput:(X,$,te)=>{Ie||(te&&this.ensureTestIsKnown(te),this.proxy.$appendOutputToRun(me,le,T.VSBuffer.fromString(X),$&&i.location.from($),te&&l.TestId.fromExtHostTestItem(te,se).toString()))},end:()=>{Ie||(Ie=!0,this.proxy.$finishedTestRunTask(me,le),--this.running||this.markEnded())}};return this.running++,this.tasks.set(le,{run:Me}),this.proxy.$startedTestRunTask(me,{id:le,name:Z,running:!0}),Me}forciblyEndTasks(){for(const{run:Z}of this.tasks.values())Z.end()}markEnded(){this.state!==D.Ended&&(this.state=D.Ended,this.endEmitter.fire())}ensureTestIsKnown(Z){if(!(Z instanceof d.TestItemImpl))throw new u.InvalidTestItemError(Z.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(Z,this.dto.controllerId).toString()))return;const me=[],se=this.dto.colllection.root;for(;;){const le=i.TestItem.from(Z);if(me.unshift(le),this.sharedTestIds.has(le.extId)||(this.sharedTestIds.add(le.extId),Z===se))break;Z=Z.parent||se}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,me)}dispose(){this.markEnded(),super.dispose()}}class f{get trackers(){return this.tracked.values()}constructor(Z,me){this.proxy=Z,this.logService=me,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(Z,me,se){const le=l.TestId.root(Z);return this.trackedById.get(le)?.getCoverageDetails(Z,me,se)||[]}disposeTestRun(Z){this.trackedById.get(Z)?.dispose(),this.trackedById.delete(Z);for(const[me,{id:se}]of this.tracked)se===Z&&this.tracked.delete(me)}prepareForMainThreadTestRun(Z,me,se,le,Ee){return this.getTracker(me,se,le,Z,Ee)}cancelRunById(Z){this.trackedById.get(Z)?.cancel()}cancelAllRuns(){for(const Z of this.tracked.values())Z.cancel()}createTestRun(Z,me,se,le,Ee,oe){const Ie=this.tracked.get(le);if(Ie)return Ie.createRun(Ee);const Me=F.fromPublic(me,se,le,oe),X=E(le);this.proxy.$startedExtensionTestRun({controllerId:me,continuous:!!le.continuous,profile:X&&{group:Q[X.kind],id:X.profileId},exclude:le.exclude?.map(te=>l.TestId.fromExtHostTestItem(te,se.root.id).toString())??[],id:Me.id,include:le.include?.map(te=>l.TestId.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:le.preserveFocus??!0,persist:oe});const $=this.getTracker(le,Me,le.profile,Z);return O.Event.once($.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Me.id)}),$.createRun(Ee)}getTracker(Z,me,se,le,Ee){const oe=new P(me,this.proxy,this.logService,se,le,Ee);return this.tracked.set(Z,oe),this.trackedById.set(oe.id,oe),oe}}e.TestRunCoordinator=f;const E=ge=>{if(ge.profile){if(!(ge.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class F{static fromPublic(Z,me,se,le){return new F(Z,(0,w.generateUuid)(),le,me)}static fromInternal(Z,me){return new F(Z.controllerId,Z.runId,!0,me)}constructor(Z,me,se,le){this.controllerId=Z,this.id=me,this.isPersisted=se,this.colllection=le}}e.TestRunDto=F;class L{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(Z){this.emitter=Z,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(Z){this.added.add(Z)}update(Z){Object.assign(Z.revived,i.TestItem.toPlain(Z.item)),this.added.has(Z)||this.updated.add(Z)}remove(Z){if(this.added.has(Z)){this.added.delete(Z);return}this.updated.delete(Z);const me=l.TestId.parentId(Z.item.extId);if(me&&this.alreadyRemoved.has(me.toString())){this.alreadyRemoved.add(Z.item.extId);return}this.removed.add(Z)}getChangeEvent(){const{added:Z,updated:me,removed:se}=this;return{get added(){return[...Z].map(le=>le.revived)},get updated(){return[...me].map(le=>le.revived)},get removed(){return[...se].map(le=>le.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class M extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(Z){return this.items.get(Z)}getMirroredTestDataByReference(Z){return this.items.get(Z.id)}createItem(Z,me){return{...Z,revived:i.TestItem.toPlain(Z.item),depth:me?me.depth+1:0,children:new Set}}createChangeCollector(){return new L(this.changeEmitter)}}class V{constructor(Z){this.proxy=Z}checkout(){this.current||(this.current=this.createObserverData());const Z=this.current;return Z.observers++,{onDidChangeTest:Z.tests.onDidChangeTests,get tests(){return[...Z.tests.rootTests].map(me=>me.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--Z.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(Z){return this.current?.tests.getMirroredTestDataByReference(Z)}applyDiff(Z){this.current?.tests.apply(Z)}createObserverData(){const Z=new M({asCanonicalUri:me=>me});return this.proxy.$subscribeToDiffs(),{observers:0,tests:Z}}}const W=(ge,Z,me,se)=>{me?Object.assign(me,se):Z.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class N{#e;#t;#i;#n;#s;get label(){return this._label}set label(Z){Z!==this._label&&(this._label=Z,W(this,this.#e,this.#n,{label:Z}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(Z){Z!==this._supportsContinuousRun&&(this._supportsContinuousRun=Z,W(this,this.#e,this.#n,{supportsContinuousRun:Z}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(Z){Z!==this.isDefault&&(Z?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:Z}))}get tag(){return this._tag}set tag(Z){Z?.id!==this._tag?.id&&(this._tag=Z,W(this,this.#e,this.#n,{tag:Z?i.TestTag.namespace(this.controllerId,Z.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(Z){Z!==this._configureHandler&&(this._configureHandler=Z,W(this,this.#e,this.#n,{hasConfigurationHandler:!!Z}))}get onDidChangeDefault(){return O.Event.chain(this.#i,Z=>Z.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(k.isDefined))}constructor(Z,me,se,le,Ee,oe,Ie,Me,X,$=!1,te=void 0,Se=!1){this.controllerId=Ee,this.profileId=oe,this._label=Ie,this.kind=Me,this.runHandler=X,this._tag=te,this._supportsContinuousRun=Se,this.#e=Z,this.#s=me,this.#t=se,this.#i=le,me.set(oe,this);const ce=Q[Me];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Me}`);$&&se.add(oe),this.#n={profileId:oe,controllerId:Ee,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:Ie,group:ce,isDefault:$,hasConfigurationHandler:!1,supportsContinuousRun:Se},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=N;const Q={[r.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function Y(ge,Z){for(let me=0;me<ge.path.length;me++){const se=Z.find(le=>le.id===ge.path[me]);if(!se)return;if(me===ge.path.length-1)return se;Z=se.children}}}),define(Te[301],Pe([1,0,18,6,4,5,127,8,7]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,S=$e(S),R=$e(R);class a extends I.Disposable{constructor(w,c){super(),this._extHostDocumentsAndEditors=c,this._onDidChangeTextEditorSelection=new T.Emitter,this._onDidChangeTextEditorOptions=new T.Emitter,this._onDidChangeTextEditorVisibleRanges=new T.Emitter,this._onDidChangeTextEditorViewColumn=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=w.getProxy(O.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(w){const c=this._extHostDocumentsAndEditors.allEditors();return w?c:c.map(_=>_.value)}async showTextDocument(w,c,_){let h;typeof c=="number"?h={position:R.ViewColumn.from(c),preserveFocus:_}:typeof c=="object"?h={position:R.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?R.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:h={preserveFocus:!1};const n=await this._proxy.$tryShowTextDocument(w.uri,h),s=n&&this._extHostDocumentsAndEditors.getEditor(n);if(s)return s.value;throw n?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,c){return new A.TextEditorDecorationType(this._proxy,w,c).value}$acceptEditorPropertiesChanged(w,c){const _=this._extHostDocumentsAndEditors.getEditor(w);if(!_)throw new Error("unknown text editor");if(c.options&&_._acceptOptions(c.options),c.selections){const h=c.selections.selections.map(R.Selection.to);_._acceptSelections(h)}if(c.visibleRanges){const h=S.coalesce(c.visibleRanges.map(R.Range.to));_._acceptVisibleRanges(h)}if(c.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...c.options,lineNumbers:R.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const h=v.TextEditorSelectionChangeKind.fromValue(c.selections.source),n=c.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:n,kind:h})}if(c.visibleRanges){const h=S.coalesce(c.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:h})}}$acceptEditorPositionData(w){for(const c in w){const _=this._extHostDocumentsAndEditors.getEditor(c);if(!_)throw new Error("Unknown text editor");const h=R.ViewColumn.to(w[c]);_.value.viewColumn!==h&&(_._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:h}))}}getDiffInformation(w){return Promise.resolve(this._proxy.$getDiffInformation(w))}}e.ExtHostEditors=a}),define(Te[302],Pe([1,0,2,3,5,4,7,8,19,38,15]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class w{constructor(h,n){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===a.MarshalledId.TimelineActionContext)if(this._providers.get(s.source)&&v.ExtensionIdentifier.equals(o,this._providers.get(s.source)?.extension)){const d=s.uri===void 0?void 0:S.URI.revive(s.uri);return this._itemsBySourceAndUriMap.get(s.source)?.get(c(d))?.get(s.handle)}else return;return s}})}async $getTimeline(h,n,s,o){return this._providers.get(h)?.provider.provideTimeline(S.URI.revive(n),s,o)}registerTimelineProvider(h,n,s,o){const d=new O.DisposableStore,i=this.convertTimelineItem(n.id,o,d).bind(this);let r;n.onDidChange&&(r=n.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:n.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...n,scheme:h,onDidChange:void 0,async provideTimeline(l,u,g){u?.resetCache&&(d.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(l,u,g);if(m==null)return;const p=i(l,u);return{...m,source:n.id,items:m.items.map(p)}},dispose(){for(const l of t.values())l.get(n.id)?.clear();r?.dispose(),d.dispose()}},s)}convertTimelineItem(h,n,s){return(o,d)=>{let i;if(d?.cacheResults){let r=this._itemsBySourceAndUriMap.get(h);r===void 0&&(r=new Map,this._itemsBySourceAndUriMap.set(h,r));const t=c(o);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...l}=r,u=`${h}|${r.id??r.timestamp}`;i?.set(u,r);let g,m,p;r.iconPath&&(t instanceof A.ThemeIcon?p={id:t.id,color:t.color}:S.URI.isUri(t)?(g=t,m=t):{light:g,dark:m}=t);let y;return A.MarkdownString.isMarkdownString(l.tooltip)?y=R.MarkdownString.from(l.tooltip):(0,k.isString)(l.tooltip)?y=l.tooltip:A.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=R.MarkdownString.from(l.detail)):(0,k.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.detail),{...l,id:l.id??void 0,handle:u,source:h,command:r.command?n.toInternal(r.command,s):void 0,icon:g,iconDark:m,themeIcon:p,tooltip:y,accessibilityInformation:r.accessibilityInformation}}}}registerTimelineProviderCore(h,n){if(this._providers.get(h.id))throw new Error(`Timeline Provider ${h.id} already exists.`);return this._proxy.$registerTimelineProvider({id:h.id,label:h.label,scheme:h.scheme}),this._providers.set(h.id,{provider:h,extension:n}),(0,O.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(h.id)?.clear();this._providers.delete(h.id),this._proxy.$unregisterTimelineProvider(h.id),h.dispose()})}}e.ExtHostTimeline=w;function c(_){return _?.toString()}}),define(Te[303],Pe([1,0,190,24,2,6,4,233,11,7,15,18,8,60,22,154,25]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,a=$e(a);function o(r,t){if((0,k.isString)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let l;return Array.isArray(r.highlights)&&(l=r.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),l=l.length?l:void 0),{label:r.label,highlights:l}}}class d extends A.Disposable{constructor(t,l,u){super(),this._proxy=t,this.commands=l,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDnDService;function g(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}l.registerArgumentProcessor({processArgument:m=>g(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(p=>g(p)?this.convertArgument(p):p):m})}registerTreeDataProvider(t,l,u){const g=this.createTreeView(t,{treeDataProvider:l},u);return{dispose:()=>g.dispose()}}createTreeView(t,l,u){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=l.dragAndDropController?.dropMimeTypes??[],m=l.dragAndDropController?.dragMimeTypes??[],p=!!l.dragAndDropController?.handleDrag,y=!!l.dragAndDropController?.handleDrop,C=this.createExtHostTreeView(t,l,u),b={showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,dropMimeTypes:g,dragMimeTypes:m,hasHandleDrag:p,hasHandleDrop:y,manuallyManageCheckboxes:!!l.manageCheckboxStateManually},D=this._proxy.$registerTreeViewDataProvider(t,b),P={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,s.checkProposedApiEnabled)(u,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,s.checkProposedApiEnabled)(u,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(f){(0,_.isMarkdownString)(f)&&(0,s.checkProposedApiEnabled)(u,"treeViewMarkdownMessage"),C.message=f},get title(){return C.title},set title(f){C.title=f},get description(){return C.description},set description(f){C.description=f},get badge(){return C.badge},set badge(f){f!==void 0&&a.ViewBadge.isViewBadge(f)?C.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(C.badge=void 0)},reveal:(f,E)=>C.reveal(f,E),dispose:async()=>{await D,this.treeViews.delete(t),C.dispose()}};return this._register(P),P}$getChildren(t,l){const u=this.treeViews.get(t);return u?u.getChildren(l):Promise.reject(new R.NoTreeViewError(t))}async $handleDrop(t,l,u,g,m,p,y,C){const b=this.treeViews.get(t);if(!b)return Promise.reject(new R.NoTreeViewError(t));const D=c.DataTransfer.toDataTransfer(u,async P=>(await this._proxy.$resolveDropFileData(t,l,P)).buffer);return y===t&&C&&await this.addAdditionalTransferItems(D,b,C,m,p),b.onDrop(D,g,m)}async addAdditionalTransferItems(t,l,u,g,m){const p=this.treeDragAndDropService.removeDragOperationTransfer(m);if(p)(await p)?.forEach((y,C)=>{y&&t.set(C,y)});else if(m&&l.handleDrag){const y=l.handleDrag(u,t,g);this.treeDragAndDropService.addDragOperationTransfer(m,y),await y}return t}async $handleDrag(t,l,u,g){const m=this.treeViews.get(t);if(!m)return Promise.reject(new R.NoTreeViewError(t));const p=await this.addAdditionalTransferItems(new a.DataTransfer,m,l,g,u);if(!(!p||g.isCancellationRequested))return c.DataTransfer.from(p)}async $hasResolve(t){const l=this.treeViews.get(t);if(!l)throw new R.NoTreeViewError(t);return l.hasResolve}$resolve(t,l,u){const g=this.treeViews.get(t);if(!g)throw new R.NoTreeViewError(t);return g.resolveTreeItem(l,u)}$setExpanded(t,l,u){const g=this.treeViews.get(t);if(!g)throw new R.NoTreeViewError(t);g.setExpanded(l,u)}$setSelectionAndFocus(t,l,u){const g=this.treeViews.get(t);if(!g)throw new R.NoTreeViewError(t);g.setSelectionAndFocus(l,u)}$setVisible(t,l){const u=this.treeViews.get(t);if(!u){if(!l)return;throw new R.NoTreeViewError(t)}u.setVisible(l)}$changeCheckboxState(t,l){const u=this.treeViews.get(t);if(!u)throw new R.NoTreeViewError(t);u.setCheckboxState(l)}createExtHostTreeView(t,l,u){const g=this._register(new i(t,l,this._proxy,this.commands.converter,this.logService,u));return this.treeViews.set(t,g),g}convertArgument(t){const l=this.treeViews.get(t.$treeViewId);return l&&"$treeItemHandle"in t?l.getExtensionElement(t.$treeItemHandle):l&&"$focusedTreeItem"in t&&t.$focusedTreeItem?l.focusedElement:null}}e.ExtHostTreeViews=d;class i extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,l,u,g,m,p){if(super(),this.viewId=t,this.proxy=u,this.commands=g,this.logService=m,this.extension=p,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,p.contributes&&p.contributes.views)for(const D in p.contributes.views)for(const P of p.contributes.views[D])P.id===t&&(this._title=P.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(D=>{Array.isArray(D)&&D.length===0||this._onDidChangeData.fire({message:!1,element:D})}));let y,C;const b=O.Event.debounce(this._onDidChangeData.event,(D,P)=>(D||(D={message:!1,elements:[]}),P.element!==!1&&(y||(y=new Promise(f=>C=f),this.refreshPromise=this.refreshPromise.then(()=>y)),Array.isArray(P.element)?D.elements.push(...P.element):D.elements.push(P.element)),P.message&&(D.message=!0),D),200,!0);this._register(b(({message:D,elements:P})=>{P.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=C;return y=null,this.refresh(P).then(()=>f())})),D&&this.proxy.$setMessage(this.viewId,c.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const l=t?this.getExtensionElement(t):void 0;if(t&&!l)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(t);return u||(u=await this.fetchChildrenNodes(l)),u?u.map(g=>g.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,l){l=l||{select:!0,focus:!1};const u=(0,k.isUndefinedOrNull)(l.select)?!0:l.select,g=(0,k.isUndefinedOrNull)(l.focus)?!1:l.focus,m=(0,k.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(p=>this.resolveTreeNode(t,p[p.length-1]).then(y=>this.proxy.$reveal(this.viewId,{item:y.item,parentChain:p.map(C=>C.item)},{select:u,focus:g,expand:m})),p=>this.logService.error(p)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:g,expand:m})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=c.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,l){const u=this.getExtensionElement(t);u&&(l?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,l){const u=!(0,w.equals)(this._selectedHandles,t);this._selectedHandles=t;const g=this._focusedHandle!==l;this._focusedHandle=l,u&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),g&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const l=(await Promise.all(t.map(async u=>{const g=this.getExtensionElement(u.treeItemHandle);return g?{extensionItem:g,treeItem:await this.dataProvider.getTreeItem(g),newState:u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);l.forEach(u=>{u.treeItem.checkboxState=u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:l.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,l,u){const g=[];for(const m of t){const p=this.getExtensionElement(m);p&&g.push(p)}if(!(!this.dndController?.handleDrag||g.length===0))return await this.dndController.handleDrag(g,l,u),l}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,l,u){const g=l?this.getExtensionElement(l):void 0;if(!(!g&&l||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(g,t,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,l){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(t);if(u){const g=this.nodes.get(u);if(g){const m=await this.dataProvider.resolveTreeItem(g.extensionItem,u,l)??g.extensionItem;return this.validateTreeItem(m),g.item.tooltip=this.getTooltip(m.tooltip),g.item.command=this.getCommand(g.disposableStore,m.command),g.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(l=>l?this.resolveUnknownParentChain(l).then(u=>this.resolveTreeNode(l,u[u.length-1]).then(g=>(u.push(g),u))):Promise.resolve([]))}resolveParent(t){const l=this.nodes.get(t);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,l){const u=this.nodes.get(t);return u?Promise.resolve(u):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(g=>this.createHandle(t,g,l,!0)).then(g=>this.getChildren(l?l.item.handle:void 0).then(()=>{const m=this.getExtensionElement(g);if(m){const p=this.nodes.get(m);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let l;if(typeof t=="string"){const u=this.getExtensionElement(t);l=u?this.nodes.get(u):void 0}else l=t;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const l=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=t?this.nodes.get(t):void 0,g=await this.dataProvider.getChildren(t);if(l.token.isCancellationRequested)return;const m=(0,w.coalesce)(g||[]),p=await Promise.all((0,w.coalesce)(m).map(C=>this.dataProvider.getTreeItem(C)));if(l.token.isCancellationRequested)return;const y=p.map((C,b)=>C?this.createAndRegisterTreeNode(m[b],C,u):null);return(0,w.coalesce)(y)}finally{l.dispose()}}refresh(t){if(t.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(t);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const l=new Set,u=t.map(m=>this.nodes.get(m));for(const m of u)if(m&&!l.has(m.item.handle)){let p=m;for(;p&&p.parent&&u.findIndex(y=>p&&p.parent&&y&&y.item.handle===p.parent.item.handle)===-1;){const y=this.elements.get(p.parent.item.handle);p=y?this.nodes.get(y):void 0}p&&!p.parent&&l.add(m.item.handle)}const g=[];return l.forEach(m=>{const p=this.elements.get(m);if(p){const y=this.nodes.get(p);y&&(!y.parent||!l.has(y.parent.item.handle))&&g.push(m)}}),g}refreshHandles(t){const l={};return Promise.all(t.map(u=>this.refreshNode(u).then(g=>{g&&(l[u]=g.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(t){const l=this.getExtensionElement(t);if(l){const u=this.nodes.get(l);if(u)return this.clearChildren(l),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(g=>{if(g){const m=this.createTreeNode(l,g,u.parent);return this.updateNodeCache(l,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,l,u){const g=this.createTreeNode(t,l,u);if(l.id&&this.elements.has(g.item.handle))throw new Error((0,S.localize)(0,null,l.id));return this.addNodeToCache(t,g),this.addNodeToParentCache(g,u),g}getTooltip(t){return a.MarkdownString.isMarkdownString(t)?c.MarkdownString.from(t):t}getCommand(t,l){return l?{...this.commands.toInternal(l,t),originalId:l.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let l,u,g;return typeof t.checkboxState=="number"?l=t.checkboxState:(l=t.checkboxState.state,u=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:l===a.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:g}}validateTreeItem(t){if(!a.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,l,u){this.validateTreeItem(l);const g=this._register(new A.DisposableStore),m=this.createHandle(t,l,u),p=this.getLightIconPath(l);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:o(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(g,l.command),contextValue:l.contextValue,icon:p,iconDark:this.getDarkIconPath(l)||p,themeIcon:this.getThemeIcon(l),collapsibleState:(0,k.isUndefinedOrNull)(l.collapsibleState)?a.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation,checkbox:this.getCheckbox(l)},extensionItem:l,parent:u,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(t){return t.iconPath instanceof a.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:l,label:u,resourceUri:g},m,p){if(l)return`${i.ID_HANDLE_PREFIX}/${l}`;const y=o(u,this.extension),C=m?m.item.handle:i.LABEL_HANDLE_PREFIX;let b=y?y.label:g?(0,T.basename)(g):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const D=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,P=this.getChildrenNodes(m)||[];let f,E=0;do{if(f=`${C}/${E}:${b}`,p||!this.elements.has(f)||D===f)break;E++}while(E<=P.length);return f}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof a.ThemeIcon))return typeof t.iconPath=="string"||I.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof a.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return I.URI.isUri(t)?t:I.URI.file(t)}addNodeToCache(t,l){this.elements.set(l.item.handle,t),this.nodes.set(t,l)}updateNodeCache(t,l,u,g){this.elements.delete(l.item.handle),this.nodes.delete(t),l.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(t,l);const m=this.getChildrenNodes(g)||[],p=m.filter(y=>y.item.handle===u.item.handle)[0];p&&m.splice(m.indexOf(p),1,l)}addNodeToParentCache(t,l){l?(l.children||(l.children=[]),l.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const l=this.nodes.get(t);if(l){if(l.children)for(const u of l.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}l.children=void 0}}else this.clearAll()}clear(t){const l=this.nodes.get(t);if(l){if(l.children)for(const u of l.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}this.nodes.delete(t),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Te[304],Pe([1,0,6,4,2,37,8,68,5,7]),function(ae,e,S,T,I,O,A,R,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,A=$e(A),v=$e(v),a=$e(a);class k extends T.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(h,n,s,o){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new S.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new S.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=h,this.#t=n,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#c=o.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(h){this.assertNotDisposed(),this.#r!==h&&(this.#r=h,this.#t.$setTitle(this.#e,h))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(h){this.assertNotDisposed(),this.#a!==h&&(this.#a=h,this.#t.$setIconPath(this.#e,I.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(h){this.#u||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(this.#c=h.active,this.#l=h.visible,this.#o=h.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(h,n){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof h>"u"?void 0:A.ViewColumn.from(h),preserveFocus:!!n})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class w extends T.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(h,n,s){super(),this.webviews=n,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(h=>h.dispose()),this._webviewPanels.clear()}createWebviewPanel(h,n,s,o,d={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},t=(0,R.shouldSerializeBuffersForPostMessage)(h),l=w.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(h),l,n,{title:s,panelOptions:c(d),webviewOptions:(0,R.serializeWebviewOptions)(h,this.workspace,d),serializeBuffersForPostMessage:t},r);const u=this.webviews.createNewWebview(l,d,h);return this.createNewWebviewPanel(l,n,s,i,d,u,!0)}$onDidChangeWebviewPanelViewStates(h){const n=Object.keys(h);n.sort((s,o)=>{const d=h[s],i=h[o];return d.active?1:i.active?-1:+d.visible-+i.visible});for(const s of n){const o=this.getWebviewPanel(s);if(!o)continue;const d=h[s];o._updateViewState({active:d.active,visible:d.visible,viewColumn:A.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,n,s){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:s,extension:h}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(h)}),new a.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(h,n,s,o){const d=this._serializers.get(n);if(!d)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=d,t=this.webviews.createNewWebview(h,s.webviewOptions,r),l=this.createNewWebviewPanel(h,n,s.title,o,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(l,s.state)}createNewWebviewPanel(h,n,s,o,d,i,r){const t=new k(h,this._proxy,i,{viewType:n,title:s,viewColumn:o,panelOptions:d,active:r});return this._webviewPanels.set(h,t),t}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=w;function c(_){return{enableFindWidget:_.enableFindWidget,retainContextWhenHidden:_.retainContextWhenHidden}}}),define(Te[305],Pe([1,0,6,4,68,8,5,7]),function(ae,e,S,T,I,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,A=$e(A),R=$e(R);class v extends T.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(w,c,_,h,n,s){super(),this.#s=!1,this.#c=this._register(new S.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new S.Emitter),this.onDidDispose=this.#u.event,this.#i=_,this.#a=h,this.#e=w,this.#t=c,this.#n=n,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(w){this.assertNotDisposed(),this.#a!==w&&(this.#a=w,this.#t.$setWebviewViewTitle(this.#e,w))}get description(){return this.assertNotDisposed(),this.#o}set description(w){this.assertNotDisposed(),this.#o!==w&&(this.#o=w,this.#t.$setWebviewViewDescription(this.#e,w))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(w){w===this.#r||this.#s||(this.#r=w,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(w){this.assertNotDisposed(),!(w?.value===this.#l?.value&&w?.tooltip===this.#l?.tooltip)&&(this.#l=O.ViewBadge.from(w),this.#t.$setWebviewViewBadge(this.#e,w))}show(w){this.assertNotDisposed(),this.#t.$show(this.#e,!!w)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(w,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(w,c,_,h){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:_,extension:w}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(w),c,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(w)}),new R.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(w,c,_,h,n){const s=this._viewProviders.get(c);if(!s)throw new Error(`No view provider found for '${c}'`);const{provider:o,extension:d}=s,i=this._extHostWebview.createNewWebview(w,{},d),r=new v(w,this._proxy,c,_,i,!0);this._webviewViews.set(w,r),await o.resolveWebviewView(r,{state:h},n)}async $onDidChangeWebviewViewVisibility(w,c){this.getWebviewView(w)._setVisible(c)}async $disposeWebviewView(w){const c=this.getWebviewView(w);this._webviewViews.delete(w),c.dispose(),this._extHostWebview.deleteWebview(w)}getWebviewView(w){const c=this._webviewViews.get(w);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=a}),define(Te[306],Pe([1,0,6,31,32,3]),function(ae,e,S,T,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new I.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new I.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new I.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var A;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new S.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new S.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(a){this.channels.has(a.id)||(this.channels.set(a.id,a),this._onDidRegisterChannel.fire(a.id))}getChannels(){const a=[];return this.channels.forEach(k=>a.push(k)),a}getChannel(a){return this.channels.get(a)}removeChannel(a){this.channels.delete(a),this._onDidRemoveChannel.fire(a)}}T.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Te[128],Pe([1,0,5,3,17,19,12,306,69,27,51,158,23,15,30,6,4]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,l,u,g,m){super(),this.id=t,this.name=l,this.logger=u,this.proxy=g,this.extension=m,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(u.getLevel()),this._register(u.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const l=this.offset;this.info(t),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,l),this.visible&&this.logger.flush()}show(t,l){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:l))}hide(){this.proxy.$close(this.id)}log(t,l){this.offset+=c.VSBuffer.fromString(l).byteLength,(0,A.log)(this.logger,t,l),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class d extends o{appendLine(t){this.append(t)}}let i=class{constructor(t,l,u,g,m,p){this.initData=l,this.extHostFileSystem=u,this.extHostFileSystemInfo=g,this.loggerService=m,this.logService=p,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(S.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(l.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[l,u]of this.channels)u.visible=l===this.visibleChannelId}createOutputChannel(t,l,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof l=="object"&&l.log,m=(0,_.isString)(l)?l:void 0;if((0,_.isString)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const y=this.initData.environment.extensionLogLevel?.find(([b])=>O.ExtensionIdentifier.equals(u.identifier,b))?.[1];y&&(p=(0,A.parseLogLevel)(y));const C=g?this.doCreateLogOutputChannel(t,p,u):this.doCreateOutputChannel(t,m,u);return C.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),g?this.createExtHostLogOutputChannel(t,p??this.logService.getLevel(),C):this.createExtHostOutputChannel(t,C)}async doCreateOutputChannel(t,l,u){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const g=await this.outputDirectoryPromise,m=this.extHostFileSystemInfo.extUri.joinPath(g,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.proxy.$register(t,m,l,u.identifier.value);return new o(y,t,p,this.proxy,u)}async doCreateLogOutputChannel(t,l,u){const g=await this.createExtensionLogDirectory(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),p=this.extHostFileSystemInfo.extUri.joinPath(g,`${m}.log`),y=`${u.identifier.value}.${m}`,C=this.loggerService.createLogger(p,{id:y,name:t,logLevel:l,extensionId:u.identifier.value});return new d(y,t,C,this.proxy,u)}createExtensionLogDirectory(t){let l=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!l){const u=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,l=(async()=>{try{await this.extHostFileSystem.value.createDirectory(u)}catch(g){if((0,h.toFileSystemProviderErrorCode)(g)!==h.FileSystemProviderErrorCode.FileExists)throw g}return u})())}return l}createExtHostOutputChannel(t,l){let u=!1;const g=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){g(),l.then(p=>p.append(m))},appendLine(m){g(),l.then(p=>p.appendLine(m))},clear(){g(),l.then(m=>m.clear())},replace(m){g(),l.then(p=>p.replace(m))},show(m,p){g(),l.then(y=>y.show(m,p))},hide(){g(),l.then(m=>m.hide())},dispose(){u=!0,l.then(m=>m.dispose())}}}createExtHostLogOutputChannel(t,l,u){const g=new s.DisposableStore,m=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},p=g.add(new n.Emitter);function y(C){l=C,p.fire(C)}return u.then(C=>{g.add(C),C.logLevel!==l&&y(C.logLevel),g.add(C.onDidChangeLogLevel(b=>y(b)))}),{...this.createExtHostOutputChannel(t,u),get logLevel(){return l},onDidChangeLogLevel:p.event,trace(C,...b){m(),u.then(D=>D.trace(C,...b))},debug(C,...b){m(),u.then(D=>D.debug(C,...b))},info(C,...b){m(),u.then(D=>D.info(C,...b))},warn(C,...b){m(),u.then(D=>D.warn(C,...b))},error(C,...b){m(),u.then(D=>D.error(C,...b))},dispose(){g.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=je([Ve(0,I.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,v.IExtHostConsumerFileSystem),Ve(3,k.IExtHostFileSystemInfo),Ve(4,A.ILoggerService),Ve(5,A.ILogService)],i),e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Te[129],Pe([1,0,3,11]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let O=1/0;for(let R=0;R<this.maxSampleCount;R++){const v=await I.getRoundTripTime();if(v===void 0)return;O=Math.min(O,v/2),await(0,T.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((R,v)=>R+v,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((R,v)=>R+v,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Te[307],Pe([1,0,193,54,31,50,43,4,6,129,21,26,11,114]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:T.ConfigurationScope.APPLICATION,title:(0,S.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,S.localize)(4,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class h{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new h;I.Registry.add(e.Extensions.ConfigurationMigration,n);let s=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.configurationService=r,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async l=>{for(const u of l.added)await this.migrateConfigurationsForFolder(u,n.migrations)})),this.migrateConfigurations(n.migrations),this._register(n.onDidRegisterConfigurationMigration(l=>this.migrateConfigurations(l)))}async migrateConfigurations(r){await this.migrateConfigurationsForFolder(void 0,r);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,r)}async migrateConfigurationsForFolder(r,t){await Promise.all([t.map(l=>this.migrateConfigurationsForFolderAndOverride(l,r?.uri))])}async migrateConfigurationsForFolderAndOverride(r,t){const l=this.configurationService.inspect(r.key,{resource:t}),u=this.workspaceService.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[g,m]of u){const p=l[g];if(!p)continue;const y=[];if(p.value!==void 0){const C=await this.runMigration(r,g,p.value,t,void 0);for(const b of C??[])y.push([b,[]])}for(const{identifiers:C,value:b}of p.overrides??[])if(b!==void 0){const D=await this.runMigration(r,g,b,t,C);for(const P of D??[])y.push([P,C])}y.length&&await Promise.allSettled(y.map(async([[C,b],D])=>this.configurationService.updateValue(C,b.value,{resource:t,overrideIdentifiers:D},m)))}}async runMigration(r,t,l,u,g){const m=y=>{const b=this.configurationService.inspect(y,{resource:u})[t];if(b)return g?b.overrides?.find(({identifiers:D})=>(0,w.equals)(D,g))?.value:b.value},p=await r.migrateFn(l,m);return Array.isArray(p)?p:[[r.key,p]]}};e.ConfigurationMigrationWorkbenchContribution=s,e.ConfigurationMigrationWorkbenchContribution=s=je([Ve(0,A.IConfigurationService),Ve(1,O.IWorkspaceContextService)],s);let o=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.remoteAgentService=r,this._ready=new c.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!k.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==k.OperatingSystem.Windows)return;I.Registry.as(T.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(5,null)},default:[],markdownDescription:(0,S.localize)(6,null),scope:T.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(7,null),scope:T.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=o,e.DynamicWorkbenchSecurityConfiguration=o=je([Ve(0,a.IRemoteAgentService)],o),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let d=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.userDataProfilesService=r,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(l=>{l.source!==A.ConfigurationTarget.DEFAULT&&l.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const r=I.Registry.as(T.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(l=>l.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(l=>""),(0,S.localize)(8,null)],description:(0,S.localize)(9,null),scope:T.ConfigurationScope.APPLICATION}}};this.configurationNode?r.updateConfigurations({add:[t],remove:[this.configurationNode]}):r.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const r=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=r?this.userDataProfilesService.profiles.find(t=>t.name===r):void 0}checkAndResetNewWindowProfileConfig(){const r=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!r)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(l=>l.id===this.newWindowProfile.id):void 0;r!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=d,e.DynamicWindowConfiguration=d=je([Ve(0,_.IUserDataProfilesService),Ve(1,A.IConfigurationService)],d)}),define(Te[308],Pe([1,0,42,16,20,24,204,307,54,3,31]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=n,e.globMatchesResource=s,S=$e(S),e.IEditorResolverService=(0,a.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const w=k.Registry.as(v.Extensions.Configuration),c={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};w.registerConfiguration(c);var _;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(_||(e.RegisteredEditorPriority=_={}));var h;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(h||(e.ResolvedStatus=h={}));function n(o){switch(o){case _.exclusive:return 5;case _.default:return 4;case _.builtin:return 3;case _.option:default:return 1}}function s(o,d){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(d.scheme))return!1;const t=typeof o=="string"&&o.indexOf(I.posix.sep)>=0?`${d.scheme}:${d.path}`:(0,O.basename)(d);return S.match(typeof o=="string"?o.toLowerCase():o,t.toLowerCase())}}),define(Te[309],Pe([1,0,53,16,20,21,24,2,3,227,50,247,129]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let h=_=class{constructor(s,o,d,i){this.localUserHome=s,this.remoteAgentService=o,this.environmentService=d,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const r=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=r?.userHome??s})()}hasValidBasename(s,o,d){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(i=>this.doHasValidBasename(s,i,o)):this.doHasValidBasename(s,o,d)}doHasValidBasename(s,o,d){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,S.isValidBasename)(d??(0,A.basename)(s),o===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return _.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const d=(0,a.getVirtualWorkspaceScheme)(o.getWorkspace());if(d)return d;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===O.OperatingSystem.Windows?I.win32:I.posix)}async fileURI(s){let o="";if(await this.resolveOS===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return R.URI.from({scheme:T.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.AbstractPathService=h,e.AbstractPathService=h=_=je([Ve(1,c.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,k.IWorkspaceContextService)],h)}),define(Te[130],Pe([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class S{constructor(A,R){this.line=A,this.character=R}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,R){return new S(0,0)}with(A){return new S(0,0)}}e.Position=S;class T{constructor(A,R,v,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(A,R),this.end=new S(v,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.Range=T;var I;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Te[44],Pe([1,0,18,42,26,53,13,3,20,14,130,11]),function(ae,e,S,T,I,O,A,R,v,a,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=o,e.isFileMatch=d,e.isProgressMessage=i,e.getExcludes=C,e.pathIncludedInQuery=b,e.deserializeSearchError=f,e.serializeSearchError=E,e.isSerializedSearchComplete=F,e.isSerializedSearchSuccess=L,e.isSerializedFileMatch=M,e.isFilePatternMatch=V,e.resolvePatternsForProvider=N,e.hasSiblingPromiseFn=ge,e.hasSiblingFn=Z,T=$e(T),I=$e(I),O=$e(O),v=$e(v),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return k.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const c="\u27EA ",_=" characters skipped \u27EB",h=(c.length+_.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var s;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(se){return!!se.preview}function d(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=t;class l{constructor(le,Ee,oe,Ie){this.ranges=Ee,this.webviewIndex=Ie;const Me=Array.isArray(Ee)?Ee:[Ee];if(oe&&oe.matchLines===1&&u(Me)){le=(0,A.getNLines)(le,oe.matchLines);let X="",$=0,te=0;const Se=Math.floor(oe.charsPerLine/5),ce=[];for(const be of Me){const he=Math.max(be.startColumn-Se,0),G=be.startColumn+oe.charsPerLine;if(he>te+Se+h){const J=c+(he-te)+_;X+=J+le.slice(he,G),$+=he-(te+J.length)}else X+=le.slice(te,G);ce.push(new m(0,be.startColumn-$,be.endColumn-$)),te=G}this.preview={text:X,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const X=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:le,matches:(0,S.mapArrayOrNot)(Ee,$=>new g($.startLineNumber-X,$.startColumn,$.endLineNumber-X,$.endColumn))}}}}e.TextSearchMatch=l;function u(se){const le=se[0].startLineNumber;for(const Ee of se)if(Ee.startLineNumber!==le||Ee.endLineNumber!==le)return!1;return!0}class g{constructor(le,Ee,oe,Ie){this.startLineNumber=le,this.startColumn=Ee,this.endLineNumber=oe,this.endColumn=Ie}}e.SearchRange=g;class m extends g{constructor(le,Ee,oe){super(le,Ee,le,oe)}}e.OneLineRange=m;var p;(function(se){se.List="list",se.Tree="tree"})(p||(e.ViewMode=p={}));var y;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function C(se,le=!0){const Ee=se&&se.files&&se.files.exclude,oe=le&&se&&se.search&&se.search.exclude;if(!Ee&&!oe)return;if(!Ee||!oe)return Ee||oe;let Ie=Object.create(null);return Ie=I.mixin(Ie,I.deepClone(Ee)),Ie=I.mixin(Ie,I.deepClone(oe),!0),Ie}function b(se,le){return se.excludePattern&&T.match(se.excludePattern,le)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&T.match(se.includePattern,le)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(Ee=>{const oe=Ee.folder.fsPath;if(O.isEqualOrParent(le,oe)){const Ie=v.relative(oe,le);return!Ee.includePattern||!!T.match(Ee.includePattern,Ie)}else return!1}):!1:!0}var D;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(D||(e.SearchErrorCode=D={}));class P extends Error{constructor(le,Ee){super(le),this.code=Ee}}e.SearchError=P;function f(se){const le=se.message;if((0,a.isCancellationError)(se))return new P(le,D.canceled);try{const Ee=JSON.parse(le);return new P(Ee.message,Ee.code)}catch{return new P(le,D.other)}}function E(se){const le={message:se.message,code:se.code};return new Error(JSON.stringify(le))}function F(se){return se.type==="error"?!0:se.type==="success"}function L(se){return se.type==="success"}function M(se){return!!se.path}function V(se,le,Ee=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return Ee?(0,A.fuzzyContains)(oe,le):T.match(le,oe)}class W{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function N(se,le){const Ee={...se||{},...le||{}};return Object.keys(Ee).filter(oe=>{const Ie=Ee[oe];return typeof Ie=="boolean"&&Ie})}class Q{constructor(le,Ee){this._parsedIncludeExpression=null,this._excludeExpression={...le.excludePattern||{},...Ee.excludePattern||{}},this._parsedExcludeExpression=T.parse(this._excludeExpression);let oe=le.includePattern;Ee.includePattern&&(oe?oe={...oe,...Ee.includePattern}:oe=Ee.includePattern),oe&&(this._parsedIncludeExpression=T.parse(oe))}matchesExcludesSync(le,Ee,oe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,Ee,oe))}includedInQuerySync(le,Ee,oe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,Ee,oe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(le,Ee,oe))}includedInQuery(le,Ee,oe){const Ie=this._parsedExcludeExpression(le,Ee,oe),Me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(le,Ee,oe):!0;return(0,w.isThenable)(Ie)?Ie.then(X=>X?!1:Me()):Me()}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=Q;function Y(se){for(const le in se)if(typeof se[le]!="boolean")return!0;return!1}function ge(se){if(!se)return;let le;return Ee=>(le||(le=(se()||Promise.resolve([])).then(oe=>oe?me(oe):{})),le.then(oe=>!!oe[Ee]))}function Z(se){if(!se)return;let le;return Ee=>{if(!le){const oe=se();le=oe?me(oe):{}}return!!le[Ee]}}function me(se){const le={};for(const Ee of se)le[Ee]=!0;return le}}),define(Te[45],Pe([1,0,18,11,22,6,4,59,16,139,24,13,2,192,30,3,12,214,50,51,27,17,8,7,66,44,5,49]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function C(M,V,W){return new k.ExtUri(N=>f(N,W)).isEqual(M,V)}function b(M,V,W){return C(M.uri,V.uri,W)?0:(0,w.compare)(M.uri.toString(),V.uri.toString())}function D(M,V,W){return M.index!==V.index?M.index<V.index?-1:1:C(M.uri,V.uri,W)?(0,w.compare)(M.name,V.name):(0,w.compare)(M.uri.toString(),V.uri.toString())}function P(M,V,W,N){const Q=M.slice(0).sort((ge,Z)=>W(ge,Z,N)),Y=V.slice(0).sort((ge,Z)=>W(ge,Z,N));return(0,S.delta)(Q,Y,(ge,Z)=>W(ge,Z,N))}function f(M,V){const W=V.getCapabilities(M.scheme);return!(W&&W&h.FileSystemProviderCapabilities.PathCaseSensitive)}class E extends d.Workspace{static toExtHostWorkspace(V,W,N,Q){if(!V)return{workspace:null,added:[],removed:[]};const{id:Y,name:ge,folders:Z,configuration:me,transient:se,isUntitled:le}=V,Ee=[],oe=W;W?Z.forEach(($,te)=>{const Se=c.URI.revive($.uri),ce=E._findFolder(N||W,Se,Q);ce?(ce.name=$.name,ce.index=$.index,Ee.push(ce)):Ee.push({uri:Se,name:$.name,index:te})}):Ee.push(...Z.map(({uri:$,name:te,index:Se})=>({uri:c.URI.revive($),name:te,index:Se}))),Ee.sort(($,te)=>$.index<te.index?-1:1);const Ie=new E(Y,ge,Ee,!!se,me?c.URI.revive(me):null,!!le,$=>f($,Q)),{added:Me,removed:X}=P(oe?oe.workspaceFolders:[],Ie.workspaceFolders,b,Q);return{workspace:Ie,added:Me,removed:X}}static _findFolder(V,W,N){for(let Q=0;Q<V.folders.length;Q++){const Y=V.workspaceFolders[Q];if(C(Y.uri,W,N))return Y}}constructor(V,W,N,Q,Y,ge,Z){super(V,N.map(me=>new d.WorkspaceFolder(me)),Q,Y,Z),this._name=W,this._isUntitled=ge,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(Z,()=>!0),N.forEach(me=>{this._workspaceFolders.push(me),this._structure.set(me.uri,me)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(V,W){return W&&this._structure.get(V)&&(V=(0,k.dirname)(V)),this._structure.findSubstr(V)}resolveWorkspaceFolder(V){return this._structure.get(V)}}let F=class{constructor(V,W,N,Q,Y){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=Q,this._extHostFileSystemInfo=N,this._uriTransformerService=Y,this._requestIdProvider=new a.Counter,this._barrier=new T.Barrier,this._proxy=V.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=V.getProxy(p.MainContext.MainThreadMessageService);const ge=W.workspace;this._confirmedWorkspace=ge?new E(ge.id,ge.name,[],!!ge.transient,ge.configuration?c.URI.revive(ge.configuration):null,!!ge.isUntitled,Z=>f(Z,N)):void 0}$initializeWorkspace(V,W){this._trusted=W,this.$acceptWorkspaceData(V),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:v.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(V,W,N,...Q){const Y=[];if(Array.isArray(Q)&&Q.forEach(le=>{c.URI.isUri(le.uri)&&!Y.some(Ee=>C(Ee.uri,le.uri,this._extHostFileSystemInfo))&&Y.push({uri:le.uri,name:le.name||(0,k.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[W,N].some(le=>typeof le!="number"||le<0)||N===0&&Y.length===0)return!1;const ge=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+N>ge.length)return!1;const Z=ge.slice(0);Z.splice(W,N,...Y.map(le=>({uri:le.uri,name:le.name||(0,k.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<Z.length;le++){const Ee=Z[le];if(Z.some((oe,Ie)=>Ie!==le&&C(Ee.uri,oe.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((le,Ee)=>le.index=Ee);const{added:me,removed:se}=P(ge,Z,D,this._extHostFileSystemInfo);if(me.length===0&&se.length===0)return!1;if(this._proxy){const le=V.displayName||V.name;this._proxy.$updateWorkspaceFolders(le,W,N,Y).then(void 0,Ee=>{this._unconfirmedWorkspace=void 0;const oe={source:{identifier:V.identifier,label:V.displayName||V.name}};this._messageService.$showMessage(o.Severity.Error,(0,_.localize)(0,null,le,Ee.toString()),oe,[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(V,W){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,W)}async getWorkspaceFolder2(V,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(V,W)}async resolveWorkspaceFolder(V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(V)}getPath(){if(!this._actualWorkspace)return;const{folders:V}=this._actualWorkspace;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,W){let N,Q="";if(typeof V=="string"?(N=c.URI.file(V),Q=V):typeof V<"u"&&(N=V,Q=V.fsPath),!N)return Q;const Y=this.getWorkspaceFolder(N,!0);if(!Y)return Q;typeof W>"u"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let ge=(0,k.relativePath)(Y.uri,N);return W&&Y.name&&(ge=`${Y.name}/${ge}`),ge}trySetWorkspaceFolders(V){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:V,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:W,added:N,removed:Q}=E.toExtHostWorkspace(V,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:Q}))}findFiles(V,W,N,Q,Y=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let ge="",Z=!0;return W===null?Z=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this._findFilesImpl(V,void 0,{exclude:ge,maxResults:N,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Y)}findFiles2(V,W={},N,Q=I.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,V,W,Q)}async _findFilesImpl(V,W,N,Q=I.CancellationToken.None){if(Q&&Q.isCancellationRequested)return Promise.resolve([]);const Y=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ge={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:Y,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let Z;if(V){const{includePattern:me,folder:se}=L(l.GlobPattern.from(V));Z=se,ge.includePattern=me}else{const{includePattern:me,folder:se}=L(l.GlobPattern.from(W));Z=se,ge.filePattern=me}return this._proxy.$startFileSearch(Z??null,ge,Q).then(me=>Array.isArray(me)?me.map(se=>c.URI.revive(se)):[])}async findTextInFiles(V,W,N,Q,Y=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const ge=this._requestIdProvider.getNext(),Z=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:me,folder:se}=L(l.GlobPattern.from(W.include)),le=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:Z,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:me,excludePattern:le},oe=!1;if(this._activeSearchCallbacks[ge]=Ie=>{if(oe)return;const Me=c.URI.revive(Ie.resource);Ie.results.forEach(X=>{const $=(0,y.revive)(X);(0,m.resultIsMatch)($)?N({uri:Me,preview:{text:$.preview.text,matches:(0,S.mapArrayOrNot)($.preview.matches,te=>new u.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,S.mapArrayOrNot)($.ranges,te=>new u.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):N({uri:Me,text:$.text,lineNumber:$.lineNumber})})},Y.isCancellationRequested)return{};try{const Ie=await this._proxy.$startTextSearch(V,se??null,Ee,ge,Y);return delete this._activeSearchCallbacks[ge],Ie||{}}catch(Ie){throw delete this._activeSearchCallbacks[ge],Ie}}$handleTextSearchResult(V,W){this._activeSearchCallbacks[W]?.(V)}async save(V){const W=await this._proxy.$save(V,{saveAs:!1});return c.URI.revive(W)}async saveAs(V){const W=await this._proxy.$save(V,{saveAs:!0});return c.URI.revive(W)}saveAll(V){return this._proxy.$saveAll(V)}resolveProxy(V){return this._proxy.$resolveProxy(V)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(V){return this._proxy.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(V,W){if(this._editSessionIdentityProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._editSessionIdentityProviders.set(V,W);const N=this._uriTransformerService.transformOutgoingScheme(V),Q=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(Q,N),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(V),this._proxy.$unregisterEditSessionIdentityProvider(Q)})}async $getEditSessionIdentifier(V,W){this._logService.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const Q=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!Q),!Q)return;const Y=await Q.provideEditSessionIdentity(N,W);if(this._logService.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(V,W,N,Q){this._logService.info("Getting edit session identifier for workspaceFolder",V);const Y=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!Y){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const ge=this._editSessionIdentityProviders.get(Y.uri.scheme);if(this._logService.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!ge),!ge)return;const Z=await ge.provideEditSessionIdentityMatch?.(W,N,Q);if(this._logService.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(V){return(W,N,Q)=>{const Y=function(Z){W.call(N,Z)};return Y.extension=V,this._onWillCreateEditSessionIdentityEvent.event(Y,void 0,Q)}}async $onWillCreateEditSessionIdentity(V,W,N){const Q=await this.resolveWorkspaceFolder(c.URI.revive(V));if(Q===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:Q},W,async(Y,ge)=>{const Z=Date.now();await Promise.resolve(Y),Date.now()-Z>N&&this._logService.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(V,W){if(this._canonicalUriProviders.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this._canonicalUriProviders.set(V,W);const N=this._uriTransformerService.transformOutgoingScheme(V),Q=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(Q,N),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(V),this._proxy.$unregisterCanonicalUriProvider(Q)})}async provideCanonicalUri(V,W,N){const Q=this._canonicalUriProviders.get(V.scheme);if(!Q)return;const Y=await Q.provideCanonicalUri?.(c.URI.revive(V),W,N);if(Y)return Y}async $provideCanonicalUri(V,W,N){return this.provideCanonicalUri(c.URI.revive(V),{targetScheme:W},N)}};e.ExtHostWorkspace=F,e.ExtHostWorkspace=F=je([Ve(0,t.IExtHostRpcService),Ve(1,r.IExtHostInitDataService),Ve(2,i.IExtHostFileSystemInfo),Ve(3,s.ILogService),Ve(4,g.IURITransformerService)],F),e.IExtHostWorkspace=(0,n.createDecorator)("IExtHostWorkspace");function L(M){let V,W;return M&&(typeof M=="string"?V=M:(V=M.pattern,W=c.URI.revive(M.baseUri))),{includePattern:V,folder:W}}}),define(Te[46],Pe([1,0,26,6,45,5,7,43,215,54,15,11,3,17,12,2]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(g,m){if(m){const p=m.split(".");let y=g;for(let C=0;y&&C<p.length;C++)y=y[p[C]];return y}}function o(g){return g instanceof n.URI}function d(g){return g&&g.uri instanceof n.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function r(g){return g&&g.uri instanceof n.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(o(g))return{resource:g};if(d(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(r(g))return{resource:g.uri};if(g===null)return{resource:null}}let l=class{constructor(m,p,y){this._proxy=m.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=p,this._logService=y,this._barrier=new w.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(m=>this._actual)}$initializeConfiguration(m){this._actual=new u(this._proxy,this._extHostWorkspace,m,this._logService),this._barrier.open()}$acceptConfigurationChanged(m,p){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(m,p))}};e.ExtHostConfiguration=l,e.ExtHostConfiguration=l=je([Ve(0,_.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,h.ILogService)],l);class u{constructor(m,p,y,C){this._onDidChangeConfiguration=new T.Emitter,this._proxy=m,this._logService=C,this._extHostWorkspace=p,this._configuration=v.Configuration.parse(y,C),this._configurationScopes=this._toMap(y.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(m,p){const y={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(m,this._logService),this._configurationScopes=this._toMap(m.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(p,y))}getConfiguration(m,p,y){const C=t(p)||{},b=this._toReadonlyValue(m?s(this._configuration.getValue(void 0,C,this._extHostWorkspace.workspace),m):this._configuration.getValue(void 0,C,this._extHostWorkspace.workspace));m&&this._validateConfigurationAccess(m,C,y?.identifier);function D(f){if(f==null)return null;if(typeof f=="boolean")return f?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(f){return typeof s(b,f)<"u"},get:(f,E)=>{this._validateConfigurationAccess(m?`${m}.${f}`:f,C,y?.identifier);let F=s(b,f);if(typeof F>"u")F=E;else{let L;const M=(V,W)=>{if((0,k.isObject)(V)){let N;const Q=()=>{L=L||(0,S.deepClone)(b),N=N||s(L,W)};return new Proxy(V,{get:(Y,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return Q(),()=>N;if(L)return N=N||s(L,W),N[ge];const Z=Y[ge];return typeof ge=="string"?M(Z,`${W}.${ge}`):Z},set:(Y,ge,Z)=>(Q(),N&&(N[ge]=Z),!0),deleteProperty:(Y,ge)=>(Q(),N&&delete N[ge],!0),defineProperty:(Y,ge,Z)=>(Q(),N&&Object.defineProperty(N,ge,Z),!0)})}return Array.isArray(V)?(0,S.deepClone)(V):V};F=M(F,f)}return F},update:(f,E,F,L)=>{f=m?`${m}.${f}`:f;const M=D(F);return E!==void 0?this._proxy.$updateConfigurationOption(M,f,E,C,L):this._proxy.$removeConfigurationOption(M,f,C,L)},inspect:f=>{f=m?`${m}.${f}`:f;const E=this._configuration.inspect(f,C,this._extHostWorkspace.workspace);if(E)return{key:f,defaultValue:(0,S.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,S.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,S.deepClone)(E.workspace?.value),workspaceFolderValue:(0,S.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,S.deepClone)(E.default?.override),globalLanguageValue:(0,S.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,S.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,S.deepClone)(E.workspaceFolder?.override),languageIds:(0,S.deepClone)(E.overrideIdentifiers)}}};return typeof b=="object"&&(0,S.mixin)(P,b,!1),Object.freeze(P)}_toReadonlyValue(m){const p=y=>(0,k.isObject)(y)?new Proxy(y,{get:(C,b)=>p(C[b]),set:(C,b,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(C,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(C,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:C=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return p(m)}_validateConfigurationAccess(m,p,y){const C=a.OVERRIDE_PROPERTY_REGEX.test(m)?a.ConfigurationScope.RESOURCE:this._configurationScopes.get(m),b=y?`[${y.value}] `:"";if(a.ConfigurationScope.RESOURCE===C){typeof p?.resource>"u"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===C){p?.resource&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(m,p){const y=new v.ConfigurationChangeEvent(m,p,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(C,b)=>y.affectsConfiguration(C,t(b))})}_toMap(m){return m.reduce((p,y)=>(p.set(y[0],y[1]),p),new Map)}}e.ExtHostConfigProvider=u,e.IExtHostConfiguration=(0,c.createDecorator)("IExtHostConfiguration")}),define(Te[131],Pe([1,0,2,11,6,5,7,45,58,46,22,57,17,27,3,16,21,12,85,251,14]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=$e(A),s=$e(s);var t;(function(L){function M(W){if(W!=null)return W}L.from=M;function V(W){if(W!=null)return W}L.to=V})(t||(t={}));var l;(function(L){function M(W){if(W!=null)return W}L.from=M;function V(W){if(W!=null)return W}L.to=V})(l||(l={}));var u;(function(L){function M(W){if(W!=null)return W}L.from=M;function V(W){if(W!=null)return W}L.to=V})(u||(u={}));var g;(function(L){function M(N){if(N){const Q=N;return Q&&!!Q.process}else return!1}L.is=M;function V(N){if(N==null)return;const Q={process:N.process,args:N.args};return N.options&&(Q.options=u.from(N.options)),Q}L.from=V;function W(N){if(N!=null)return new A.ProcessExecution(N.process,N.args,N.options)}L.to=W})(g||(g={}));var m;(function(L){function M(W){if(W!=null)return W}L.from=M;function V(W){if(W!=null)return W}L.to=V})(m||(m={}));var p;(function(L){function M(N){if(N){const Q=N;return Q&&(!!Q.commandLine||!!Q.command)}else return!1}L.is=M;function V(N){if(N==null)return;const Q={};return N.commandLine!==void 0?Q.commandLine=N.commandLine:(Q.command=N.command,Q.args=N.args),N.options&&(Q.options=m.from(N.options)),Q}L.from=V;function W(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.ShellExecution(N.commandLine,N.options):new A.ShellExecution(N.command,N.args?N.args:[],N.options)}L.to=W})(p||(p={}));var y;(function(L){function M(N){if(N){const Q=N;return Q&&Q.customExecution==="customExecution"}else return!1}L.is=M;function V(N){return{customExecution:"customExecution"}}L.from=V;function W(N,Q){return Q.get(N)}L.to=W})(y||(e.CustomExecutionDTO=y={}));var C;(function(L){function M(V,W){let N;return V.scope!==void 0&&typeof V.scope!="number"?N=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?N=W.workspaceFile:N=i.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:N}}L.from=M})(C||(e.TaskHandleDTO=C={}));var b;(function(L){function M(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}L.from=M})(b||(b={}));var D;(function(L){function M(N,Q){if(N==null)return[];const Y=[];for(const ge of N){const Z=V(ge,Q);Z&&Y.push(Z)}return Y}L.fromMany=M;function V(N,Q){if(N==null)return;let Y;N.execution instanceof A.ProcessExecution?Y=g.from(N.execution):N.execution instanceof A.ShellExecution?Y=p.from(N.execution):N.execution&&N.execution instanceof A.CustomExecution&&(Y=y.from(N.execution));const ge=t.from(N.definition);let Z;return N.scope?typeof N.scope=="number"?Z=N.scope:Z=N.scope.uri:Z=A.TaskScope.Workspace,!ge||!Z?void 0:{_id:N._id,definition:ge,name:N.name,source:{extensionId:Q.identifier.value,label:N.source,scope:Z},execution:Y,isBackground:N.isBackground,group:b.from(N.group),presentationOptions:l.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}L.from=V;async function W(N,Q,Y){if(N==null)return;let ge;g.is(N.execution)?ge=g.to(N.execution):p.is(N.execution)?ge=p.to(N.execution):y.is(N.execution)&&(ge=y.to(N._id,Y));const Z=t.to(N.definition);let me;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?me=N.source.scope:me=await Q.resolveWorkspaceFolder(S.URI.revive(N.source.scope)):me=A.TaskScope.Workspace),!Z||!me)return;const se=new A.Task(Z,me,N.name,N.source.label,ge,N.problemMatchers);return N.isBackground!==void 0&&(se.isBackground=N.isBackground),N.group!==void 0&&(se.group=A.TaskGroup.from(N.group._id),se.group&&N.group.isDefault&&(se.group=new A.TaskGroup(se.group.id,se.group.label),N.group.isDefault===!0&&(se.group.isDefault=N.group.isDefault))),N.presentationOptions&&(se.presentationOptions=l.to(N.presentationOptions)),N._id&&(se._id=N._id),N.detail&&(se.detail=N.detail),se}L.to=W})(D||(e.TaskDTO=D={}));var P;(function(L){function M(W){return W}L.from=M;function V(W){if(W)return Object.assign(Object.create(null),W)}L.to=V})(P||(P={}));class f{#e;constructor(M,V,W){this._id=V,this._task=W,this.#e=M}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let E=class{constructor(M,V,W,N,Q,Y,ge,Z){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=M.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=N,this._configurationService=Q,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,V,W){if(!W)return new A.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:V,provider:W,extension:M}),this._proxy.$registerTaskProvider(N,V),new A.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(M,V){this._proxy.$registerTaskSystem(M,V)}fetchTasks(M){return this._proxy.$fetchTasks(P.from(M)).then(async V=>{const W=[];for(const N of V){const Q=await D.to(N,this._workspaceProvider,this._providedCustomExecutions2);Q&&W.push(Q)}return W})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(V=>M.push(V)),M}terminateTask(M){if(!(M instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,V,W){const N=this._providedCustomExecutions2.get(M.id);N&&(this._activeCustomExecutions2.set(M.id,N),this._terminalService.attachPtyToTerminal(V,await N.callback(W))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){if(!this._taskExecutionPromises.has(M.id))return;const V=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const V=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:V,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const V=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:M.exitCode})}$provideTasks(M,V){const W=this._handlers.get(M);if(!W)return Promise.reject(new Error("no handler found"));const N=[],Q=(0,T.asPromise)(()=>W.provider.provideTasks(k.CancellationToken.None)).then(Y=>this.provideTasksInternal(V,N,W,Y));return new Promise(Y=>{Q.then(ge=>{Promise.all(N).then(()=>{Y(ge)})})})}async $resolveTask(M,V){const W=this._handlers.get(M);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const N=await D.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const Q=await W.provider.resolveTask(N,k.CancellationToken.None);if(!Q)return;this.checkDeprecation(Q,W);const Y=D.from(Q,W.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(Q.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(Y.execution)&&await this.addCustomExecution(Y,Q,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,V,W){const N=await this._proxy.$createTaskId(M);!W&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,V.execution)),this._providedCustomExecutions2.set(N,V.execution)}async getTaskExecution(M,V){if(typeof M=="string"){const Q=this._taskExecutionPromises.get(M);if(!Q)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return Q}const W=this._taskExecutionPromises.get(M.id);if(W)return W;let N;return V?N=Promise.resolve(new f(this,M.id,V)):N=D.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(Q=>{if(!Q)throw new r.ErrorNoTelemetry("Unexpected: Task does not exist.");return new f(this,M.id,Q)}),this._taskExecutionPromises.set(M.id,N),N.then(Q=>(this._taskExecutions.set(M.id,Q),Q))}checkDeprecation(M,V){M._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));const W=this._notProvidedCustomExecutions.values();let N=W.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=W.next()}};e.ExtHostTaskBase=E,e.ExtHostTaskBase=E=je([Ve(0,c.IExtHostRpcService),Ve(1,_.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,v.IExtHostDocumentsAndEditors),Ve(4,a.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,o.ILogService),Ve(7,d.IExtHostApiDeprecationService)],E);let F=class extends E{constructor(M,V,W,N,Q,Y,ge,Z){super(M,V,W,N,Q,Y,ge,Z),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(s.Platform.Web)})}async executeTask(M,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=D.from(V,M);if(W===void 0)throw new Error("Task is not valid");if(y.is(W.execution))await this.addCustomExecution(W,V,!1);else throw new r.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),V);return this._proxy.$executeTask(W).catch(Q=>{throw new Error(Q)}),N}provideTasksInternal(M,V,W,N){const Q=[];if(N)for(const Y of N){if(this.checkDeprecation(Y,W),!Y.definition||!M[Y.definition.type]){const Z=Y.source?Y.source:"No task source";this._logService.warn(`The task [${Z}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=D.from(Y,W.extension);ge&&y.is(ge.execution)?(Q.push(ge),V.push(this.addCustomExecution(ge,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Q,extension:W.extension}}async resolveTaskInternal(M){if(y.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,V,W){}};e.WorkerExtHostTask=F,e.WorkerExtHostTask=F=je([Ve(0,c.IExtHostRpcService),Ve(1,_.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,v.IExtHostDocumentsAndEditors),Ve(4,a.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,o.ILogService),Ve(7,d.IExtHostApiDeprecationService)],F),e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(Te[310],Pe([1,0,44,33]),function(ae,e,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=I,e.genericCellMatchesToTextSearchMatches=O;function I(A){return"cellResults"in A}e.rawCellPrefix="rawCell#";function O(A,R){let v=-1;const a=[];let k=[];return A.forEach(c=>{c.range.startLineNumber!==v&&k.length>0&&(a.push([...k]),k=[]),k.push(c),v=c.range.endLineNumber}),k.length>0&&a.push([...k]),a.map(c=>{const _=[],h=c[0].range.startLineNumber,n=c[c.length-1].range.endLineNumber;for(let s=h;s<=n;s++)_.push(R.getLineContent(s));return new S.TextSearchMatch(_.join(`
`)+`
`,c.map(s=>new T.Range(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Te[311],Pe([1,0,186,23,6,4,29,38,13,15,2,30,80,5,34,8,7,39,288,124,26,16,44,241,310,308]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,w=$e(w),n=$e(n),s=$e(s);class p{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(C=>C.apiEditor)}constructor(C,b,D,P,f,E,F){this._textDocumentsAndEditors=D,this._textDocuments=P,this._extHostFileSystem=f,this._extHostSearch=E,this._logService=F,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new c.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=C.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=C.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=C.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=b.converter,b.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===R.MarshalledId.NotebookCellActionContext){const M=L.notebookEditor?.notebookUri,V=L.cell.handle,N=this._documents.get(M)?.getCell(V);if(N)return N.apiCell}if(L&&L.$mid===R.MarshalledId.NotebookActionContext){const M=L.uri,V=this._documents.get(M);if(V)return V.apiNotebook}return L}}),p._registerApiCommands(b)}getEditorById(C){const b=this._editors.get(C);if(!b)throw new Error(`unknown text editor: ${C}. known editors: ${[...this._editors.keys()]} `);return b}getIdByEditor(C){for(const[b,D]of this._editors)if(D.apiEditor===C)return b}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(C,b){const D=this._documents.get(C);if(!D&&!b)throw new Error(`NO notebook document for '${C}'`);return D}static _convertNotebookRegistrationData(C,b){if(!b)return;const D=b.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(b.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:C.identifier,providerDisplayName:C.displayName||C.name,displayName:b.displayName,filenamePattern:D,priority:b.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(C,b,D){const P=p._notebookStatusBarItemProviderHandlePool++,f=typeof D.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(P,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(P,f,b);let E;return f!==void 0&&(E=D.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(f))),new s.Disposable(()=>{this._notebookStatusBarItemProviders.delete(P),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(P,f),E?.dispose()})}async createNotebookDocument(C){const b=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:C.viewType,content:C.content&&n.NotebookData.from(C.content)});return k.URI.revive(b)}async openNotebookDocument(C){const b=this._documents.get(C);if(b)return b.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(C),P=this._documents.get(k.URI.revive(D));return(0,a.assertIsDefined)(P?.apiNotebook)}async showNotebookDocument(C,b){k.URI.isUri(C)&&(C=await this.openNotebookDocument(C));let D;typeof b=="object"?D={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:D={preserveFocus:!1};const P=await this._notebookEditorsProxy.$tryShowNotebookDocument(C.uri,C.notebookType,D),f=P&&this._editors.get(P)?.apiEditor;if(f)return f;throw P?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(C,b,D,P){const f=this._notebookStatusBarItemProviders.get(C),E=k.URI.revive(b),F=this._documents.get(E);if(!F||!f)return;const L=F.getCellFromIndex(D);if(!L)return;const M=await f.provideCellStatusBarItems(L.apiCell,P);if(!M)return;const V=new O.DisposableStore,W=this._statusBarCache.add([V]),Q=(Array.isArray(M)?M:[M]).map(Y=>n.NotebookStatusBarItem.from(Y,this._commandsConverter,V));return{cacheId:W,items:Q}}$releaseNotebookCellStatusBarItems(C){this._statusBarCache.delete(C)}registerNotebookSerializer(C,b,D,P,f){if((0,v.isFalsyOrWhitespace)(b))throw new Error("viewType cannot be empty or just whitespace");const E=this._handlePool++;return this._notebookSerializer.set(E,{viewType:b,serializer:D,options:P}),this._notebookProxy.$registerNotebookSerializer(E,{id:C.identifier,location:C.extensionLocation},b,n.NotebookDocumentContentOptions.from(P),p._convertNotebookRegistrationData(C,f)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(E)})}async $dataToNotebook(C,b,D){const P=this._notebookSerializer.get(C);if(!P)throw new Error("NO serializer found");const f=await P.serializer.deserializeNotebook(b.buffer,D);return new o.SerializableObjectWithBuffers(n.NotebookData.from(f))}async $notebookToData(C,b,D){const P=this._notebookSerializer.get(C);if(!P)throw new Error("NO serializer found");const f=await P.serializer.serializeNotebook(n.NotebookData.to(b.value),D);return T.VSBuffer.wrap(f)}async $saveNotebook(C,b,D,P,f){const E=k.URI.revive(b),F=this._notebookSerializer.get(C);if(this.trace(`enter saveNotebook(versionId: ${D}, ${E.toString()})`),!F)throw new Error("NO serializer found");const L=this._documents.get(E);if(!L)throw new Error("Document NOT found");if(L.versionId!==D)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(E.scheme))throw new w.FileOperationError((0,S.localize)(0,null,this._resourceForError(E)),w.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,r.filter)(L.apiNotebook.metadata,Y=>!(F.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of L.apiNotebook.getCells()){const ge=new s.NotebookCellData(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,F.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);ge.metadata=(0,r.filter)(Y.metadata,Z=>!(F.options?.transientCellMetadata??{})[Z]),M.cells.push(ge)}if(await this._validateWriteFile(E,P),f.isCancellationRequested)throw new Error("canceled");const V=await F.serializer.serializeNotebook(M,f);if(f.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${D} ${E.toString()}`),await this._extHostFileSystem.value.writeFile(E,V),this.trace(`Finished write versionId: ${D} ${E.toString()}`);const W=this._extHostFileSystem.getFileSystemProviderExtUri(E.scheme),N=await this._extHostFileSystem.value.stat(E),Q={name:W.basename(E),isFile:(N.type&w.FileType.File)!==0,isDirectory:(N.type&w.FileType.Directory)!==0,isSymbolicLink:(N.type&w.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&w.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(E.scheme),locked:!!((N.permissions??0)&w.FilePermission.Locked),etag:w.etag({mtime:N.mtime,size:N.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${D}, ${E.toString()})`),Q}async $searchInNotebooks(C,b,D,P,f){const E=this._notebookSerializer.get(C)?.serializer;if(!E)return{limitHit:!1,results:[]};const F=new A.ResourceSet;await(async(N,Q,Y)=>{await Promise.all(N.map(async ge=>await Promise.all(ge.filenamePatterns.map(Z=>{const me={_reason:Y._reason,folderQueries:Y.folderQueries,includePattern:Y.includePattern,excludePattern:Y.excludePattern,maxResults:Y.maxResults,type:l.QueryType.File,filePattern:Z};return this._extHostSearch.doInternalFileSearchWithCustomCallback(me,Q,se=>{se.forEach(le=>{F.has(le)||P.some(oe=>ge.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Ie=>(0,m.globMatchesResource)(Ie,le)))||F.add(le)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(D,f,b);const M=new A.ResourceMap;let V=!1;const W=Array.from(F).map(async N=>{const Q=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...M.values()].reduce((me,se)=>me+se.cellResults.length,0)>b.maxResults){V=!0;return}const Y=[],ge=this._documents.get(N);if(ge)ge.apiNotebook.getCells().forEach(se=>Y.push({input:se.document.getText(),outputs:se.outputs.flatMap(le=>le.items.map(Ee=>Ee.data.toString()))}));else{const me=await this._extHostFileSystem.value.readFile(N),se=T.VSBuffer.fromString(me.toString()),le=await E.deserializeNotebook(se.buffer,f);if(f.isCancellationRequested)return;n.NotebookData.from(le).cells.forEach(oe=>Y.push({input:oe.source,outputs:oe.outputs.flatMap(Ie=>Ie.items.map(Me=>Me.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Y.forEach((me,se)=>{const le=b.contentPattern.pattern,Ee=new u.CellSearchModel(me.input,void 0,me.outputs),oe=Ee.findInInputs(le),Ie=Ee.findInOutputs(le),Me=Ie.flatMap(X=>(0,g.genericCellMatchesToTextSearchMatches)(X.matches,X.textBuffer)).map((X,$)=>(X.webviewIndex=$,X));if(oe.length>0||Ie.length>0){const X={index:se,contentResults:(0,g.genericCellMatchesToTextSearchMatches)(oe,Ee.inputTextBuffer),webviewResults:Me};Q.push(X)}});const Z={resource:N,cellResults:Q};M.set(N,Z);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...M.values()]}}async _validateWriteFile(C,b){const D=await this._extHostFileSystem.value.stat(C);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==w.ETAG_DISABLED&&typeof D.mtime=="number"&&typeof D.size=="number"&&b.mtime<D.mtime&&b.etag!==w.etag({mtime:b.mtime,size:D.size}))throw new w.FileOperationError((0,S.localize)(1,null),w.FileOperationResult.FILE_MODIFIED_SINCE,b)}_resourceForError(C){return C.scheme===t.Schemas.file?C.fsPath:C.toString()}_createExtHostEditor(C,b,D){if(this._editors.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const P=new i.ExtHostNotebookEditor(b,this._notebookEditorsProxy,C,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(b,P)}$acceptDocumentAndEditorsDelta(C){if(C.value.removedDocuments)for(const D of C.value.removedDocuments){const P=k.URI.revive(D),f=this._documents.get(P);f&&(f.dispose(),this._documents.delete(P),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(E=>E.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const E of this._editors.values())E.notebookData.uri.toString()===P.toString()&&this._editors.delete(E.id)}if(C.value.addedDocuments){const D=[];for(const P of C.value.addedDocuments){const f=k.URI.revive(P.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const E=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,f,P);D.push(...P.cells.map(F=>d.ExtHostCell.asModelAddData(F))),this._documents.get(f)?.dispose(),this._documents.set(f,E),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(E.apiNotebook)}}if(C.value.addedEditors)for(const D of C.value.addedEditors){if(this._editors.has(D.id))return;const P=k.URI.revive(D.documentUri),f=this._documents.get(P);f&&this._createExtHostEditor(f,D.id,D)}const b=[];if(C.value.removedEditors)for(const D of C.value.removedEditors){const P=this._editors.get(D);P&&(this._editors.delete(D),this._activeNotebookEditor?.id===P.id&&(this._activeNotebookEditor=void 0),b.push(P))}if(C.value.visibleEditors){this._visibleNotebookEditors=C.value.visibleEditors.map(P=>this._editors.get(P)).filter(P=>!!P);const D=new Set;this._visibleNotebookEditors.forEach(P=>D.add(P.id));for(const P of this._editors.values()){const f=D.has(P.id);P._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(P=>P).filter(P=>P.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}C.value.newActiveEditor===null?this._activeNotebookEditor=void 0:C.value.newActiveEditor&&(this._editors.get(C.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${C.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(C.value.newActiveEditor)),C.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(C){const b=h.ApiCommandArgument.String.with("notebookType","A notebook type"),D=new h.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new h.ApiCommandArgument("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>T.VSBuffer.wrap(f))],new h.ApiCommandResult("Notebook Data",f=>n.NotebookData.to(f.value))),P=new h.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new h.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.SerializableObjectWithBuffers(n.NotebookData.from(f)))],new h.ApiCommandResult("Bytes",f=>f.buffer));C.registerApiCommand(D),C.registerApiCommand(P)}trace(C){this._logService.trace(`[Extension Host Notebook] ${C}`)}}e.ExtHostNotebookController=p}),define(Te[312],Pe([1,0,20,22,41,42,24,70,44]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,S=$e(S),O=$e(O),A=$e(A);class a{constructor(c,_,h){this.config=c,this.provider=_,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&O.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&O.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const _=this.config.folderQueries||[];return new Promise((h,n)=>{const s=o=>{this.resultCount++,c(o)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const d=o.toString(),i=S.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,i)||this.matchFile(s,{base:o,basename:i})}),Promise.all(_.map(o=>this.searchInFolder(o,s))).then(o=>{h({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{n(new Error((0,I.toErrorMessage)(o)))})})}async searchInFolder(c,_){const h=new T.CancellationTokenSource,n=this.getSearchOptionsForFolder(c),s=this.initDirectoryTree(),o=new v.QueryGlobTester(this.config,c),d=!o.hasSiblingExcludeClauses();let i;try{this.activeCancellationTokens.add(h),i=R.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,h.token),t=i.elapsed(),l=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(u=>{const g=S.posix.relative(c.folder.path,u.path);if(d){const m=S.basename(u.path);this.matchFile(_,{base:c.folder,relativePath:g,basename:m});return}this.addDirectoryEntries(s,c.folder,g,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(s,o,_),{providerTime:t,postProcessTime:l.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const _=(0,v.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,v.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:_,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},_,h,n){if(h===this.filePattern){const o=S.basename(this.filePattern);this.matchFile(n,{base:_,relativePath:this.filePattern,basename:o})}function s(o){const d=S.basename(o),i=S.dirname(o);let r=c[i];r||(r=c[i]=[],s(i)),r.push({base:_,relativePath:o,basename:d})}s(h)}matchDirectoryTree({rootEntries:c,pathToEntries:_},h,n){const s=this,o=this.filePattern;function d(i){const r=(0,v.hasSiblingFn)(()=>i.map(t=>t.basename));for(let t=0,l=i.length;t<l;t++){const u=i[t],{relativePath:g,basename:m}=u;if(h.matchesExcludesSync(g,m,o!==m?r:void 0))continue;const p=_[g];if(p)d(p);else{if(g===o)continue;s.matchFile(n,u)}if(s.isLimitHit)break}}d(c)}matchFile(c,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(_))}}class k{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(c,_,h,n){const s=this.getSessionTokenSource(c.cacheKey),o=new a(c,_,s&&s.token);let d=0;const i=r=>{d+=r.length,h(r.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(o,k.BATCH_SIZE,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:r.stats}:void 0,messages:[]}))}clearCache(c){this.getSessionTokenSource(c)?.cancel()}getSessionTokenSource(c){if(c)return this.sessions.has(c)||this.sessions.set(c,new T.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:A.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,_,h,n){const s=n.onCancellationRequested(()=>{c.cancel()}),o=i=>{i&&(d.push(i),_>0&&d.length>=_&&(h(d),d=[]))};let d=[];return c.search(o).then(i=>(d.length&&h(d),s.dispose(),i),i=>(d.length&&h(d),s.dispose(),Promise.reject(i)))}}e.FileSearchManager=k}),define(Te[313],Pe([1,0,18,282,42,103,29,16,20,24,13,15,2,102,206,43,12,50,118,309,44]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=b,S=$e(S),T=$e(T),I=$e(I),v=$e(v),k=$e(k),h=$e(h);let t=class{constructor(P,f,E,F,L){this.configurationService=P,this.workspaceContextService=f,this.editorGroupsService=E,this.logService=F,this.pathService=L}text(P,f,E={}){P=this.getContentPattern(P,E);const F=this.configurationService.getValue(),L=f&&f.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(f?.map(o.toWorkspaceFolder),E),type:r.QueryType.Text,contentPattern:P,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:F.search.usePCRE2||L||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(P,f){const E=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const F={...P,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(P,f)&&(F.isCaseSensitive=!0),this.isMultiline(P)&&(F.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),F}file(P,f={}){return{...this.commonQuery(P,f),type:r.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}handleIncludeExclude(P,f){return P?(P=Array.isArray(P)?P.map(p):p(P),f?this.parseSearchPaths(P):{pattern:u(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],f={}){const E=this.handleIncludeExclude(f.includePattern,f.expandPatterns),F=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=P.length>1,M=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,f,F)):P.map(N=>this.getFolderQueryForRoot(N,f,F,L))).filter(N=>!!N),V={_reason:f._reason,folderQueries:M,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:E.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const N=S.coalesce(this.editorGroupsService.groups.flatMap(ge=>ge.editors.map(Z=>Z.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const Q=N.filter(ge=>(0,r.pathIncludedInQuery)(V,ge.fsPath)),Y=this.commonQueryFromFileList(Q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...V,...Y}}const W=f.extraFileResources&&f.extraFileResources.filter(N=>(0,r.pathIncludedInQuery)(V,N.fsPath));return V.extraFileResources=W&&W.length?W:void 0,V}commonQueryFromFileList(P){const f=[],E=new A.ResourceMap,F={};let L=!1;return P.forEach(M=>{if(M.scheme===R.Schemas.walkThrough)return;if((0,a.isAbsolutePath)(M)){const W=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:v.dirname(M.fsPath)});let N=E.get(W);N||(L=!0,N={folder:W,includePattern:{}},f.push(N),E.set(W,N));const Q=v.relative(W.fsPath,M.fsPath);(0,w.assertIsDefined)(N.includePattern)[Q.replace(/\\/g,"/")]=!0}else M.fsPath&&(L=!0,F[M.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(P,f){if(f.isSmartCase){if(P.isRegExp){if(k.containsUppercaseCharacter(P.pattern,!0))return!0}else if(k.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&(0,_.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const f=Y=>v.isAbsolute(Y)||/^\.\.?([\/\\]|$)/.test(Y),F=(Array.isArray(P)?P:g(P)).map(Y=>{const ge=this.pathService.resolvedUserHome;return ge?(0,O.untildify)(Y,ge.scheme===R.Schemas.file?ge.fsPath:ge.path):Y}),L=T.groupBy(F,Y=>f(Y)?"searchPaths":"exprSegments"),M=(L.exprSegments||[]).map(Y=>k.rtrim(Y,"/")).map(Y=>k.rtrim(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),m(Y))),V={},W=this.expandSearchPathPatterns(L.searchPaths||[]);W&&W.length&&(V.searchPaths=W);const N=M.flat(),Q=u(...N);return Q&&(V.pattern=Q),V}getExcludesForFolder(P,f){return f.disregardExcludeSettings?void 0:(0,r.getExcludes)(P,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const f=P.flatMap(F=>{let{pathPortion:L,globPortion:M}=l(F);return M&&(M=y(M)),this.expandOneSearchPath(L).flatMap(W=>this.resolveOneSearchPathPattern(W,M))}),E=new Map;return f.forEach(F=>{const L=F.searchPath.toString(),M=E.get(L);M?F.pattern&&(M.pattern=M.pattern||{},M.pattern[F.pattern]=!0):E.set(L,{searchPath:F.searchPath,pattern:F.pattern?u(F.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(P){if(v.isAbsolute(P)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==R.Schemas.file?[{searchPath:f[0].uri.with({path:P})}]:[{searchPath:c.URI.file(v.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===o.WorkbenchState.FOLDER){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=p(P),P.startsWith("../")||P===".."){const F=v.posix.resolve(f.path,P);return[{searchPath:f.with({path:F})}]}const E=y(P);return[{searchPath:f,pattern:E}]}else{if(P==="./"||P===".\\")return[];{const f=P.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(L=>{const M=f.match(new RegExp(`^${k.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return M?{match:M,folder:L}:null}).filter(w.isDefined);if(F.length)return F.map(L=>{const M=L.match[1];return{searchPath:L.folder.uri,pattern:M&&y(M)}});{const L=P.match(/\.[\/\\](.+)[\/\\]?/),M=L?L[1]:P,V=h.localize(0,null,M);throw new Error(V)}}}}resolveOneSearchPathPattern(P,f){const E=P.pattern&&f?`${P.pattern}/${f}`:P.pattern||f,F=[{searchPath:P.searchPath,pattern:E}];return E&&!E.endsWith("**")&&F.push({searchPath:P.searchPath,pattern:E+"/**"}),F}getFolderQueryForSearchPath(P,f,E){const F=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(P.searchPath),f,E,!1);return F?{...F,includePattern:P.pattern}:null}getFolderQueryForRoot(P,f,E,F){let L;const M=c.URI.isUri(P)?P:P.uri;if(E.searchPaths){const Y=E.searchPaths.filter(ge=>(0,a.isEqual)(ge.searchPath,M))[0];if(Y&&!Y.pattern)return null;Y&&(L=Y.pattern)}const V=this.configurationService.getValue({resource:M}),N={...this.getExcludesForFolder(V,f)||{},...L||{}},Q=c.URI.isUri(P)?(0,a.basename)(P):P.name;return{folder:M,folderName:F?Q:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!V.search.followSymlinks}}};e.QueryBuilder=t,e.QueryBuilder=t=je([Ve(0,n.IConfigurationService),Ve(1,o.IWorkspaceContextService),Ve(2,d.IEditorGroupsService),Ve(3,s.ILogService),Ve(4,i.IPathService)],t);function l(D){const P=D.match(/[\*\{\}\(\)\[\]\?]/);if(P){const f=P.index,E=D.substr(0,f).match(/[/|\\][^/\\]*$/);if(E){let F=D.substr(0,E.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:D.substr((E.index||0)+1)}}}return{pathPortion:D}}function u(...D){return D.length?D.reduce((P,f)=>(P[f]=!0,P),Object.create(null)):void 0}function g(D){return I.splitGlobAware(D,",").map(P=>P.trim()).filter(P=>!!P.length)}function m(D){return[`**/${D}/**`,`**/${D}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function p(D){return D.replace(/\\/g,"/")}function y(D){return p(D).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(D){return D.replace(/([?*[\]])/g,"[$1]")}function b(D,P){D=S.distinct(D,F=>F.toString());const f=[],E=P.getWorkspace();return D&&D.forEach(F=>{let L;if(P.getWorkbenchState()===o.WorkbenchState.FOLDER)L=(0,a.relativePath)(E.folders[0].uri,F),L&&L!=="."&&(L="./"+L);else{const M=P.getWorkspaceFolder(F);if(M){const V=M.name;if(E.folders.filter(N=>N.name===V).length===1){const N=(0,a.relativePath)(M.uri,F);N===""?L=`./${M.name}`:L=`./${M.name}/${N}`}else L=F.fsPath}}L&&f.push(C(L))}),f}}),define(Te[314],Pe([1,0,24,2,22,14,3,313,44,50,11]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=c,e.checkGlobFileExists=n,S=$e(S),O=$e(O);const w=7e3;function c(s,o){const d=o.activationEvents;if(!d)return Promise.resolve(void 0);const i=[],r=[];for(const p of d)if(/^workspaceContains:/.test(p)){const y=p.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||s.forceUsingSearch?r.push(y):i.push(y)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:l}=(0,k.promiseWithResolvers)(),u=p=>l({activationEvent:p}),g=Promise.all(i.map(p=>_(s,p,u))).then(()=>{}),m=h(s,o.identifier,r,u);return Promise.all([g,m]).then(()=>{l(void 0)}),t}async function _(s,o,d){for(const i of s.folders)if(await s.exists(S.joinPath(T.URI.revive(i),o))){d(`workspaceContains:${o}`);return}}async function h(s,o,d,i){if(d.length===0)return Promise.resolve(void 0);const r=new I.CancellationTokenSource,t=s.checkExists(s.folders,d,r.token),l=setTimeout(async()=>{r.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},w);let u=!1;try{u=await t}catch(g){O.isCancellationError(g)||O.onUnexpectedError(g)}r.dispose(),clearTimeout(l),u&&i(`workspaceContains:${d.join(",")}`)}function n(s,o,d,i){const r=s.get(A.IInstantiationService),t=s.get(v.ISearchService),u=r.createInstance(R.QueryBuilder).file(o.map(g=>(0,a.toWorkspaceFolder)(T.URI.revive(g))),{_reason:"checkExists",includePattern:d,exists:!0});return t.fileSearch(u,i).then(g=>!!g.limitHit,g=>O.isCancellationError(g)?!1:Promise.reject(g))}}),define(Te[47],Pe([1,0,182,20,65,24,11,4,59,2,12,5,46,248,89,45,25,119,14,19,23,230,7,110,3,27,92,17,75,93,57,95,6,314,88,232,16,86,70,21,87]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m,p,y,C,b,D,P,f,E,F,L,M,V,W,N,Q){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,S=$e(S),T=$e(T),I=$e(I),d=$e(d),e.IHostUtils=(0,g.createDecorator)("IHostUtils");let ge=Y=class extends R.Disposable{constructor(X,$,te,Se,ce,be,he,G,J,pe,ve,Oe,Ue){super(),this._extHostManagedSockets=Oe,this._extHostLanguageModels=Ue,this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=$,this._extHostContext=te,this._initData=he,this._extHostWorkspace=Se,this._extHostConfiguration=ce,this._logService=be,this._extHostTunnelService=J,this._extHostTerminalService=pe,this._extHostLocalizationService=ve,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new Ie(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const De=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,Ee(this._globalRegistry,De)),N.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${se(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${se(this._myRegistry)}`)),this._storage=new h.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=G,this._instaService=X.createChild(new C.ServiceCollection([h.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState])),this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ae,Le,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ae,d.transformErrorForSerialization(Le),B)},actualActivateExtension:async(Ae,Le)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(Ae,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ae,Le),new _.HostExtension;const B=this._myRegistry.getExtensionDescription(Ae);return this._activateExtension(B,Le)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){d.onUnexpectedError(X)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._myRegistry.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this._deactivate(ce))}catch{}await Promise.all(X)}terminate(X,$=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${X}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),d.setUnexpectedErrorHandler(Se=>{this._logService.error(Se)}),this._extHostContext.dispose();const te=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),te]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${$}`):this._logService.info(`Extension host exiting with code ${$}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit($)})}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}async getExtension(X){const $=await this._mainThreadExtensionsProxy.$getExtension(X);return $&&{...$,identifier:new i.ExtensionIdentifier($.identifier.value),extensionLocation:a.URI.revive($.extensionLocation)}}_activateByEvent(X,$){return this._activator.activateByEvent(X,$)}_activateById(X,$){return this._activator.activateById(X,$)}activateByIdWithErrors(X,$){return this._activateById(X,$).then(()=>{const te=this._activator.getActivatedExtension(X);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._myRegistry)}getExtensionExports(X){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(X).exports;try{return this._activator.getActivatedExtension(X).exports}catch{return null}}async _realPathExtensionUri(X){if(X.scheme===M.Schemas.file&&this._hostUtils.fsRealpath){const $=X.fsPath;this._realPathCache.has($)||this._realPathCache.set($,this._hostUtils.fsRealpath($));const te=await this._realPathCache.get($);return a.URI.file(te)}return X}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(X=>new oe(X))),this._extensionPathIndex}async _createExtensionPathIndex(X){const $=v.TernarySearchTree.forUris(te=>O.extUriBiasedIgnorePathCase.ignorePathCasing(te));return await Promise.all(X.map(async te=>{if(this._getEntryPoint(te)){const Se=await this._realPathExtensionUri(te.extensionLocation);$.set(Se,te)}})),$}_deactivate(X){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return $;const te=this._activator.getActivatedExtension(X);if(!te)return $;try{typeof te.module.deactivate=="function"&&($=Promise.resolve(te.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(Se)}try{(0,R.dispose)(te.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(Se)}return $}async _activateExtension(X,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,$).then(te=>{const Se=te.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,$),this._logExtensionActivationTimes(X,$,"success",Se),te},te=>{throw this._logExtensionActivationTimes(X,$,"failure"),te})}_logExtensionActivationTimes(X,$,te,Se){const ce=me(X,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ce,...Se||{},outcome:te})}_doActivateExtension(X,$){const te=me(X,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",te);const Se=this._getEntryPoint(X);if(!Se)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${$.startup}, activationEvent: '${$.activationEvent}'${X.identifier.value!==$.extensionId.value?`, root cause: ${$.extensionId.value}`:""}`),this._logService.flush();const ce=new _.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(X,(0,O.joinPath)(X.extensionLocation,Se),ce),this._loadExtensionContext(X)]).then(be=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Y._callActivate(this._logService,X.identifier,be[0],be[1],ce))).then(be=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),be))}_loadExtensionContext(X){const $=this._extHostLanguageModels.createLanguageModelAccessInformation(X),te=this._register(new t.ExtensionGlobalMemento(X,this._storage)),Se=this._register(new t.ExtensionMemento(X.identifier.value,!1,this._storage)),ce=this._register(new L.ExtensionSecrets(X,this._secretState)),be=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,he=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([te.whenReady,Se.whenReady,this._storagePath.whenReady]).then(()=>{const G=this;let J,pe;const ve=(0,s.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:te,workspaceState:Se,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return $},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Oe){return T.join(X.extensionLocation.fsPath,Oe)},get storagePath(){return G._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return G._storagePath.globalValue(X).fsPath},get logPath(){return T.join(G._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return a.URI.joinPath(G._initData.logsLocation,X.identifier.value)},get storageUri(){return G._storagePath.workspaceValue(X)},get globalStorageUri(){return G._storagePath.globalValue(X)},get extensionMode(){return be},get extension(){return J===void 0&&(J=new le(G,X.identifier,X,he,!1)),J},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(X,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!pe){if(!ve)return;const Oe=f.Event.buffer(f.Event.fromDOMEventEmitter(ve,"message",Ue=>Ue.data));ve.start(),pe={onDidReceiveMessage:Oe,postMessage:ve.postMessage.bind(ve)}}return pe}})})}static _callActivate(X,$,te,Se,ce){return te=te||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,$,te,Se,ce).then(be=>new _.ActivatedExtension(!1,null,ce.build(),te,be,Se.subscriptions))}static _callActivateOptional(X,$,te,Se,ce){if(typeof te.activate=="function")try{ce.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${$.value}`);const be=typeof global=="object"?global:self,he=te.activate.apply(be,[Se]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(he).then(G=>(ce.activateResolveStop(),G))}catch(be){return Promise.reject(be)}else return Promise.resolve(te)}_activateOneStartupFinished(X,$){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:$}).then(void 0,te=>{this._logService.error(te)})}_activateAllStartupFinishedDeferred(X,$=0){const Se=Date.now();(0,N.setTimeout0)(()=>{for(let ce=$;ce<X.length;ce+=1){const be=X[ce];for(const he of be.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-Se>50){this._activateAllStartupFinishedDeferred(X,ce);break}else this._activateOneStartupFinished(be,he)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks()),this._extHostConfiguration.getConfigProvider().then(X=>{const $=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this._myRegistry.getAllExtensionDescriptions();if($)this._activateAllStartupFinishedDeferred(te);else for(const Se of te)if(Se.activationEvents)for(const ce of Se.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(Se,ce)})}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],te=this._handleWorkspaceContainsEagerExtensions($),Se=this._handleRemoteResolverEagerExtensions(),ce=Promise.all([Se,X,te]).then(()=>{});return Promise.race([ce,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(X,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,$){if(this.isActivated($.identifier))return;const te=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:X.map(be=>be.uri),forceUsingSearch:te||!this._hostUtils.fsExists,exists:be=>this._hostUtils.fsExists(be.fsPath),checkExists:(be,he,G)=>this._mainThreadWorkspaceProxy.$checkExists(be,he,G)},ce=await(0,E.checkActivateWorkspaceContainsExtension)(Se,$);if(ce)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:ce.activationEvent}).then(void 0,be=>this._logService.error(be))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:$}=this._initData.environment;if(!X||!$)throw new Error(S.localize(0,null));const te=await this._loadCommonJSModule(null,$,new _.ExtensionActivationTimesBuilder(!1));if(!te||typeof te.run!="function")throw new Error(S.localize(1,null,$.toString()));return new Promise((Se,ce)=>{const be=(J,pe)=>{J?(N.isCI&&this._logService.error("Test runner called back with error",J),ce(J)):(N.isCI&&(pe?this._logService.info(`Test runner called back with ${pe} failures.`):this._logService.info("Test runner called back with successful outcome.")),Se(typeof pe=="number"&&pe>0?1:0))},he=(0,O.originalFSPath)($),G=te.run(he,be);G&&G.then&&G.then(()=>{N.isCI&&this._logService.info("Test runner finished successfully."),Se(0)}).catch(J=>{N.isCI&&this._logService.error("Test runner finished with error",J),ce(J instanceof Error&&J.stack?J.stack:String(J))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,$){return this._resolvers[X]=$,(0,R.toDisposable)(()=>{delete this._resolvers[X]})}async getRemoteExecServer(X){const{resolver:$}=await this._activateAndGetResolver(X);return $?.resolveExecServer?.(X,{resolveAttempt:0})}async _activateAndGetResolver(X){const $=X.indexOf("+");if($===-1)throw new l.RemoteAuthorityResolverError("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=X.substr(0,$);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this._resolvers[te]}}async $resolveAuthority(X,$){const te=W.StopWatch.create(!1),Se=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(X)},${$})][${te.elapsed()}ms] `,ce=x=>this._logService.info(`${Se()}${x}`),be=x=>this._logService.warn(`${Se()}${x}`),he=(x,H=void 0)=>this._logService.error(`${Se()}${x}`,H),G=x=>{if(x instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},J=async x=>{ce(`activating resolver for ${x}...`);const{resolver:H,authorityPrefix:j}=await this._activateAndGetResolver(x);if(!H)throw he(`no resolver for ${j}`),new l.RemoteAuthorityResolverError(`No remote extension installed to resolve ${j}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:j,remoteAuthority:x}},pe=X.split(/@|%40/g).reverse();ce(`activating remote resolvers ${pe.join(" -> ")}`);let ve;try{ve=await Promise.all(pe.map(J)).catch(async x=>{if(!(x instanceof l.RemoteAuthorityResolverError)||x._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return be(`resolving nested authorities failed: ${x.message}`),[await J(X)]})}catch(x){return G(x)}const Oe=new A.IntervalTimer;Oe.cancelAndSet(()=>ce("waiting..."),1e3);let Ue,De;for(const[x,{authorityPrefix:H,resolver:j,remoteAuthority:ne}]of ve.entries())try{if(x===ve.length-1)ce("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${H}`),Ue=await j.resolve(ne,{resolveAttempt:$,execServer:De}),I.mark(`code/extHost/didResolveAuthorityOK/${H}`),ce("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(j,l.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(ce(`invoking resolveExecServer() for ${ne}`),I.mark(`code/extHost/willResolveExecServer/${H}`),De=await j.resolveExecServer?.(ne,{resolveAttempt:$,execServer:De}),!De)throw new l.RemoteAuthorityResolverError(`Exec server was not available for ${ne}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(fe){return I.mark(`code/extHost/didResolveAuthorityError/${H}`),he("returned an error",fe),Oe.dispose(),G(fe)}Oe.dispose();const Ae={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${l.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let B;if(l.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)){const x=$;this._extHostManagedSockets.setFactory(x,Ue.makeConnection),B={authority:X,connectTo:new u.ManagedRemoteConnection(x),connectionToken:Ue.connectionToken}}else B={authority:X,connectTo:new u.WebSocketRemoteConnection(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:B,options:Le,tunnelInformation:Ae}}}async $getCanonicalURI(X,$){this._logService.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(X)})`);const{resolver:te}=await this._activateAndGetResolver(X);if(!te)return null;const Se=a.URI.revive($);if(typeof te.getCanonicalURI>"u")return Se;const ce=await(0,A.asPromise)(()=>te.getCanonicalURI(Se));return ce||Se}async $startExtensionHost(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:$,myExtensions:te}=Z(this._activationEventsReader,this._globalRegistry,this._myRegistry,X),Se=await this._createExtensionPathIndex(te);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set($.getAllExtensionDescriptions()),this._myRegistry.set(te),N.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${se(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${se(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(X,$){return $===s.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(te=>this._activateByEvent(X,!1)):this._readyToRunExtensions.wait().then(te=>this._activateByEvent(X,!1))}async $activate(X,$){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(X)?(await this._activateById(X,$),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:$,myExtensions:te}=Z(this._activationEventsReader,this._globalRegistry,this._myRegistry,X),Se=await this._createExtensionPathIndex(te);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set($.getAllExtensionDescriptions()),this._myRegistry.set(te),N.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${se(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${se(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const $=r.VSBuffer.alloc(X),te=Math.random()%256;for(let Se=0;Se<X;Se++)$.writeUInt8(te,Se);return $}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ge,e.AbstractExtHostExtensionService=ge=Y=je([Ve(0,g.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,y.IExtHostRpcService),Ve(3,n.IExtHostWorkspace),Ve(4,c.IExtHostConfiguration),Ve(5,k.ILogService),Ve(6,m.IExtHostInitDataService),Ve(7,p.IExtensionStoragePaths),Ve(8,b.IExtHostTunnelService),Ve(9,D.IExtHostTerminalService),Ve(10,V.IExtHostLocalizationService),Ve(11,Q.IExtHostManagedSockets),Ve(12,P.IExtHostLanguageModels)],ge);function Z(Me,X,$,te){Me.addActivationEvents(te.addActivationEvents);const Se=new o.ExtensionDescriptionRegistry(Me,X.getAllExtensionDescriptions());Se.deltaExtensions(te.toAdd,te.toRemove);const ce=new i.ExtensionIdentifierSet($.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of te.myToRemove)ce.delete(he);for(const he of te.myToAdd)ce.add(he);const be=Ee(Se,ce);return{globalRegistry:Se,myExtensions:be}}function me(Me,X){return{id:Me.identifier.value,name:Me.name,extensionVersion:Me.version,publisherDisplayName:Me.publisher,activationEvents:Me.activationEvents?Me.activationEvents.join(","):null,isBuiltin:Me.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function se(Me){return Me.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.IExtHostExtensionService=(0,g.createDecorator)("IExtHostExtensionService");class le{#e;#t;#i;constructor(X,$,te,Se,ce){this.#e=X,this.#t=$,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=T.normalize((0,O.originalFSPath)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=Se,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=le;function Ee(Me,X){return Me.getAllExtensionDescriptions().filter($=>X.has($.identifier))}class oe{constructor(X){this._searchTree=X}setSearchTree(X){this._searchTree=X}findSubstr(X){return this._searchTree.findSubstr(X)}forEach(X){return this._searchTree.forEach(X)}}e.ExtensionPaths=oe;class Ie{constructor(X){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(X)}readActivationEvents(X){return this._map.get(X.identifier)??[]}addActivationEvents(X){for(const $ of Object.keys(X))this._map.set($,X[$])}}}),define(Te[315],Pe([1,0,65,2,5,46,25,19,17,27,3,47,12,13]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,S=$e(S);let n=class{constructor(r,t,l,u,g,m,p){this._apiFactory=r,this._extensionRegistry=t,this._instaService=l,this._extHostConfiguration=u,this._extHostExtensionService=g,this._initData=m,this._logService=p,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),S.mark("code/extHost/willWaitForConfig");const r=await this._extHostConfiguration.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,t,this._extensionRegistry,r,this._logService)),this.register(this._instaService.createInstance(s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,t,this._initData.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this._factories.set(t,r);else this._factories.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this._alternatives.push(t=>r.alternativeModuleName(t))}};e.RequireInterceptor=n,e.RequireInterceptor=n=je([Ve(2,k.IInstantiationService),Ve(3,O.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,a.IExtHostInitDataService),Ve(6,c.ILogService)],n);let s=class{static{h=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&h.aliased.size){const t=(0,_.escapeRegExpCharacters)(this.forceForwardSlashes(r.environment.appRoot.fsPath)),l="[a-z0-9_.-]",u=`@${l}+\\/${l}+|${l}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${g}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(r){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(r));if(!t)return;const[,l,u,g]=t,m=h.aliased.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),l+m+g}forceForwardSlashes(r){return r.replace(/\\/g,"/")}};s=h=je([Ve(0,a.IExtHostInitDataService)],s);class o{constructor(r,t,l,u,g){this._apiFactory=r,this._extensionPaths=t,this._extensionRegistry=l,this._configProvider=u,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(r,t){const l=this._extensionPaths.findSubstr(t);if(l){let u=this._extApiImpl.get(l.identifier);return u||(u=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(l.identifier,u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((g,m)=>u+=`	${m} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(r,t,l){this._extensionPaths=r,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(I.MainContext.MainThreadTelemetry);const u=l.getProxy(I.MainContext.MainThreadWindow);this._impl=(g,m)=>{const p=T.URI.parse(g);return m?this.callOriginal(g,m):p.scheme==="http"||p.scheme==="https"?u.$openUri(p,g,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this._appUriScheme?u.$openUri(p,g,{}):this.callOriginal(g,m)}}load(r,t,l){const u=this._extensionPaths.findSubstr(t);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=l(r),this._impl}callOriginal(r,t){return this.sendNoForwardTelemetry(),this._original(r,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=je([Ve(2,v.IExtHostRpcService)],d)}),define(Te[132],Pe([1,0,48,4,20,79,3,58,71,47,7,45,245,46]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,I=$e(I),O=$e(O),e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class h extends c.AbstractVariableResolverService{constructor(o,d,i,r,t,l,u){function g(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const p=r.tabGroups.all.find(y=>y.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof k.TextDiffTabInput||p.input instanceof k.NotebookDiffEditorTabInput)return p.input.modified;if(p.input instanceof k.TextTabInput||p.input instanceof k.NotebookEditorTabInput||p.input instanceof k.CustomEditorTabInput)return p.input.uri}}}super({getFolderUri:m=>{const p=l.folders.filter(y=>y.name===m);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>l.folders.length,getConfigurationValue:(m,p)=>t.getConfiguration(void 0,m).get(p),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=g();if(m)return I.normalize(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const m=g();if(m){const p=d.getWorkspaceFolder(m);if(p)return I.normalize(p.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>o.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let n=class extends T.Disposable{constructor(o,d,i,r,t){super(),this.extensionService=o,this.workspaceService=d,this.editorService=i,this.configurationService=r,this.editorTabs=t,this._resolver=new S.Lazy(async()=>{const l=await this.configurationService.getConfigProvider(),g={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async m=>{g.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new h(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,l,g,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=n,e.ExtHostVariableResolverProviderService=n=je([Ve(0,a.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,_.IExtHostConfiguration),Ve(4,v.IExtHostEditorTabs)],n)}),define(Te[133],Pe([1,0,11,6,2,4,19,3,5,71,47,17,7,45,237,81,238,46,132,35,34,8,18,96]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=$e(t),e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let g=class extends O.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(P,f,E,F,L,M,V,W){super(),this._workspaceService=f,this._extensionService=E,this._configurationService=F,this._editorTabs=L,this._variableResolver=M,this._commands=V,this._testing=W,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new T.Emitter),this._onDidTerminateDebugSession=this._register(new T.Emitter),this._onDidChangeActiveDebugSession=this._register(new T.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new T.Emitter),this._debugServiceProxy=P.getProxy(v.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new T.Emitter),this._onDidChangeActiveStackItem=this._register(new T.Emitter),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(N=>{this._register(N.onDidChange(Q=>{this.registerAllDebugTypes(N)})),this.registerAllDebugTypes(N)})}async $getVisualizerTreeItem(P,f){const E=this.hydrateVisualizationContext(f);if(!E)return;const F=await this._debugVisualizationTrees.get(P)?.getTreeItem?.(E);return F?this.convertVisualizerTreeItem(P,F):void 0}registerDebugVisualizationTree(P,f,E){const F=A.ExtensionIdentifier.toKey(P.identifier),L=this.extensionVisKey(F,f);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this._debugVisualizationTrees.set(L,E),this._debugServiceProxy.$registerDebugVisualizerTree(L,!!E.editItem),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(L),this._debugVisualizationTrees.delete(f)})}async $getVisualizerTreeItemChildren(P,f){const E=this._debugVisualizationElements.get(f)?.item;return E?(await this._debugVisualizationTrees.get(P)?.getChildren?.(E))?.map(L=>this.convertVisualizerTreeItem(P,L))||[]:[]}async $editVisualizerTreeItem(P,f){const E=this._debugVisualizationElements.get(P);if(!E)return;const F=await this._debugVisualizationTrees.get(E.provider)?.editItem?.(E.item,f);return this.convertVisualizerTreeItem(E.provider,F||E.item)}$disposeVisualizedTree(P){const f=this._debugVisualizationElements.get(P);if(!f)return;const E=[f.children];for(const F of E)if(F)for(const L of F)E.push(this._debugVisualizationElements.get(L)?.children),this._debugVisualizationElements.delete(L)}convertVisualizerTreeItem(P,f){let E=this._debugVisualizationTreeItemIds.get(f);return E||(E=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(f,E),this._debugVisualizationElements.set(E,{provider:P,item:f})),t.DebugTreeItem.from(f,E)}asDebugSourceUri(P,f){const E=P;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let F=`debug:${encodeURIComponent(E.path||"")}`,L="?";return f&&(F+=`${L}session=${encodeURIComponent(f.id)}`,L="&"),F+=`${L}ref=${E.sourceReference}`,I.URI.parse(F)}else{if(E.path)return I.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(P){const f=[];for(const E of P.getAllExtensionDescriptions())if(E.contributes){const F=E.contributes.debuggers;if(F&&F.length>0)for(const L of F)(0,s.isDebuggerMainContribution)(L)&&f.push(L.type)}this._debugServiceProxy.$registerDebugTypes(f)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const P=[];return this._breakpoints.forEach(f=>P.push(f)),P}async $resolveDebugVisualizer(P,f){const E=this._visualizers.get(P);if(!E)throw new Error(`No debug visualizer found with id '${P}'`);let{v:F,provider:L,extensionId:M}=E;if(F.visualization||(F=await L.resolveDebugVisualization?.(F,f)||F,E.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.serializeVisualization(M,F.visualization)}async $executeDebugVisualizerCommand(P){const f=this._visualizers.get(P);if(!f)throw new Error(`No debug visualizer found with id '${P}'`);const E=f.v.visualization;E&&"command"in E&&this._commands.executeCommand(E.command,...E.arguments||[])}hydrateVisualizationContext(P){const f=this._debugSessions.get(P.sessionId);return f&&{session:f.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,f,E,F){const L=this.hydrateVisualizationContext(E),M=this.extensionVisKey(P,f),V=this._debugVisualizationProviders.get(M);if(!L||!V)return[];const W=await V.provideDebugVisualization(L,F);return W?W.map(N=>{const Q=++this._visualizerIdCounter;this._visualizers.set(Q,{v:N,provider:V,extensionId:P});const Y=N.iconPath?this.getIconPathOrClass(N.iconPath):void 0;return{id:Q,name:N.name,iconClass:Y?.iconClass,iconPath:Y?.iconPath,visualization:this.serializeVisualization(P,N.visualization)}}):[]}$disposeDebugVisualizers(P){for(const f of P)this._visualizers.delete(f)}registerDebugVisualizationProvider(P,f,E){if(!P.contributes?.debugVisualizers?.some(M=>M.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const F=A.ExtensionIdentifier.toKey(P.identifier),L=this.extensionVisKey(F,f);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this._debugVisualizationProviders.set(L,E),this._debugServiceProxy.$registerDebugVisualizer(F,f),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(F,f),this._debugVisualizationProviders.delete(f)})}addBreakpoints(P){const f=P.filter(L=>{const M=L.id;return this._breakpoints.has(M)?!1:(this._breakpoints.set(M,L),!0)});this.fireBreakpointChanges(f,[],[]);const E=[],F=new Map;for(const L of f)if(L instanceof c.SourceBreakpoint){let M=F.get(L.location.uri.toString());M||(M={type:"sourceMulti",uri:L.location.uri,lines:[]},F.set(L.location.uri.toString(),M),E.push(M)),M.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof c.FunctionBreakpoint&&E.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(P){const f=P.filter(M=>this._breakpoints.delete(M.id));this.fireBreakpointChanges([],f,[]);const E=f.filter(M=>M instanceof c.SourceBreakpoint).map(M=>M.id),F=f.filter(M=>M instanceof c.FunctionBreakpoint).map(M=>M.id),L=f.filter(M=>M instanceof c.DataBreakpoint).map(M=>M.id);return this._debugServiceProxy.$unregisterBreakpoints(E,F,L)}startDebugging(P,f,E){const F=E.testRun&&this._testing.getMetadataForRun(E.testRun);return this._debugServiceProxy.$startDebugging(P?P.uri:void 0,f,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===c.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(P){return this._debugServiceProxy.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,f,E){if(!f)return new c.Disposable(()=>{});const F=this._configProviderHandleCounter++;return this._configProviders.push({type:P,handle:F,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(P,E,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,F),new c.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(P,f,E){if(!E)return new c.Disposable(()=>{});if(!this.definesDebugType(P,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:F,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,F),new c.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(P,f){if(!f)return new c.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:P,handle:E,factory:f}),new c.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(F=>F.factory!==f)})}async $runInTerminal(P,f){return Promise.resolve(void 0)}async $substituteVariables(P,f){let E;const F=await this.getFolder(P);return F&&(E={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(E,f)}createDebugAdapter(P,f){if(P.type==="implementation")return new C(P.implementation)}createSignService(){}async $startDASession(P,f){const E=this,F=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(F.type),F).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const M=this.convertToDto(L),V=this.createDebugAdapter(M,F);if(!V)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const W=V;return this._debugAdapters.set(P,W),this.getDebugAdapterTrackers(F).then(N=>(N&&this._debugAdaptersTrackers.set(P,N),W.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const Y=Q,ge={type:"response",seq:0,command:Y.command,request_seq:Y.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Z=await this._signService.sign(Y.arguments.value);ge.body={signature:Z},W.sendResponse(ge)}else throw new Error("no signer")}catch(Z){ge.success=!1,ge.message=Z.message,W.sendResponse(ge)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(Q),Q=(0,s.convertToVSCPaths)(Q,!0),E._debugServiceProxy.$acceptDAMessage(P,Q)}),W.onError(Q=>{N&&N.onError&&N.onError(Q),this._debugServiceProxy.$acceptDAError(P,Q.name,Q.message,Q.stack)}),W.onExit(Q=>{N&&N.onExit&&N.onExit(Q??void 0,void 0),this._debugServiceProxy.$acceptDAExit(P,Q??void 0,void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),W.startSession()))})}$sendDAMessage(P,f){f=(0,s.convertToDAPaths)(f,!1);const E=this._debugAdaptersTrackers.get(P);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(f),this._debugAdapters.get(P)?.sendMessage(f)}$stopDASession(P){const f=this._debugAdaptersTrackers.get(P);this._debugAdaptersTrackers.delete(P),f&&f.onWillStopSession&&f.onWillStopSession();const E=this._debugAdapters.get(P);return this._debugAdapters.delete(P),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const f=[],E=[],F=[];if(P.added)for(const L of P.added){const M=L.id;if(M&&!this._breakpoints.has(M)){let V;if(L.type==="function")V=new c.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")V=new c.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const W=I.URI.revive(L.uri);V=new c.SourceBreakpoint(new c.Location(W,new c.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,c.setBreakpointId)(V,M),this._breakpoints.set(M,V),f.push(V)}}if(P.removed)for(const L of P.removed){const M=this._breakpoints.get(L);M&&(this._breakpoints.delete(L),E.push(M))}if(P.changed){for(const L of P.changed)if(L.id){const M=this._breakpoints.get(L.id);if(M){if(M instanceof c.FunctionBreakpoint&&L.type==="function"){const V=M;V.enabled=L.enabled,V.condition=L.condition,V.hitCondition=L.hitCondition,V.logMessage=L.logMessage,V.functionName=L.functionName}else if(M instanceof c.SourceBreakpoint&&L.type==="source"){const V=M;V.enabled=L.enabled,V.condition=L.condition,V.hitCondition=L.hitCondition,V.logMessage=L.logMessage,V.location=new c.Location(I.URI.revive(L.uri),new c.Position(L.line,L.character))}F.push(M)}}}this.fireBreakpointChanges(f,E,F)}async $acceptStackFrameFocus(P){let f;if(P){const E=await this.getSession(P.sessionId);P.kind==="thread"?f=new c.DebugThread(E.api,P.threadId):f=new c.DebugStackFrame(E.api,P.threadId,P.frameId)}this._activeStackItem=f,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(P,f,E){return(0,S.asPromise)(async()=>{const F=this.getConfigProviderByHandle(P);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(f);return F.provideDebugConfigurations(L,E)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(P,f,E,F){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(P);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.getFolder(f);return L.resolveDebugConfiguration(M,E,F)})}$resolveDebugConfigurationWithSubstitutedVariables(P,f,E,F){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(P);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.getFolder(f);return L.resolveDebugConfigurationWithSubstitutedVariables(M,E,F)})}async $provideDebugAdapter(P,f){const E=this.getAdapterDescriptorFactoryByHandle(P);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.getSession(f);return this.getAdapterDescriptor(E,F).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(P){const f=await this.getSession(P);this._onDidStartDebugSession.fire(f.api)}async $acceptDebugSessionTerminated(P){const f=await this.getSession(P);f&&(this._onDidTerminateDebugSession.fire(f.api),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(P){this._activeDebugSession=P?await this.getSession(P):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(P,f){(await this.getSession(P))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(P,f){const F={session:(await this.getSession(P)).api,event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(F)}convertToDto(P){if(P instanceof c.DebugAdapterExecutable)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof c.DebugAdapterServer)return{type:"server",port:P.port,host:P.host};if(P instanceof c.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:P.path};if(P instanceof c.DebugAdapterInlineImplementation)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(P){const f=this._adapterFactories.filter(E=>E.type===P);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(P){const f=this._adapterFactories.filter(E=>E.handle===P);if(f.length>0)return f[0].factory}getConfigProviderByHandle(P){const f=this._configProviders.filter(E=>E.handle===P);if(f.length>0)return f[0].provider}definesDebugType(P,f){if(P.contributes){const E=P.contributes.debuggers;if(E&&E.length>0){for(const F of E)if(F.label&&F.type&&F.type===f)return!0}}return!1}getDebugAdapterTrackers(P){const E=P.configuration.type,F=this._trackerFactories.filter(L=>L.type===E||L.type==="*").map(L=>(0,S.asPromise)(()=>L.factory.createDebugAdapterTracker(P.api)).then(M=>M,M=>null));return Promise.race([Promise.all(F).then(L=>{const M=(0,l.coalesce)(L);if(M.length>0)return new y(M)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async getAdapterDescriptor(P,f){const E=f.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new c.DebugAdapterServer(E));if(P){const L=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>P.createDebugAdapterDescriptor(f.api,this.daExecutableFromPackage(f,L))).then(M=>{if(M)return M})}const F=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,F))}daExecutableFromPackage(P,f){}fireBreakpointChanges(P,f,E){(P.length>0||f.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:P,removed:f,changed:E}))}async getSession(P){if(P)if(typeof P=="string"){const f=this._debugSessions.get(P);if(f)return f}else{let f=this._debugSessions.get(P.id);if(!f){const E=await this.getFolder(P.folderUri),F=P.parent?this._debugSessions.get(P.parent):void 0;f=new m(this._debugServiceProxy,P.id,P.type,P.name,E,P.configuration,F?.api),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(P){if(P){const f=I.URI.revive(P);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}extensionVisKey(P,f){return`${P}\0${f}`}serializeVisualization(P,f){if(f){if("title"in f&&"command"in f)return{type:n.DebugVisualizationType.Command};if("treeId"in f)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(P){const f=this.getIconUris(P);let E,F;return"id"in f?F=i.ThemeIcon.asClassName(f):E=f,{iconPath:E,iconClass:F}}getIconUris(P){if(P instanceof c.ThemeIcon)return{id:P.id};const f=typeof P=="object"&&"dark"in P?P.dark:P,E=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof f=="string"?I.URI.file(f):f,light:typeof E=="string"?I.URI.file(E):E}}};e.ExtHostDebugServiceBase=g,e.ExtHostDebugServiceBase=g=je([Ve(0,w.IExtHostRpcService),Ve(1,_.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,o.IExtHostConfiguration),Ve(4,a.IExtHostEditorTabs),Ve(5,d.IExtHostVariableResolverProvider),Ve(6,r.IExtHostCommands),Ve(7,u.IExtHostTesting)],g);class m{constructor(P,f,E,F,L,M,V){this._debugServiceProxy=P,this._id=f,this._type=E,this._name=F,this._workspaceFolder=L,this._configuration=M,this._parentSession=V}get api(){const P=this;return this.apiSession??=Object.freeze({id:P._id,type:P._type,get name(){return P._name},set name(f){P._name=f,P._debugServiceProxy.$setDebugSessionName(P._id,f)},parentSession:P._parentSession,workspaceFolder:P._workspaceFolder,configuration:P._configuration,customRequest(f,E){return P._debugServiceProxy.$customDebugAdapterRequest(P._id,f,E)},getDebugProtocolBreakpoint(f){return P._debugServiceProxy.$getDebugProtocolBreakpoint(P._id,f.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(P){this._name=P}get configuration(){return this._configuration}}e.ExtHostDebugSession=m;class p{constructor(P){this.value=Object.freeze({append(f){P.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=p;class y{constructor(P){this.trackers=P}onWillStartSession(){this.trackers.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(P):void 0)}onWillStopSession(){this.trackers.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.trackers.forEach(f=>f.onError?f.onError(P):void 0)}onExit(P,f){this.trackers.forEach(E=>E.onExit?E.onExit(P,f):void 0)}}class C extends h.AbstractDebugAdapter{constructor(P){super(),this.implementation=P,P.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.implementation.handleMessage(P)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends g{constructor(P,f,E,F,L,M,V,W){super(P,f,E,F,L,M,V,W)}};e.WorkerExtHostDebugService=b,e.WorkerExtHostDebugService=b=je([Ve(0,w.IExtHostRpcService),Ve(1,_.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,o.IExtHostConfiguration),Ve(4,a.IExtHostEditorTabs),Ve(5,d.IExtHostVariableResolverProvider),Ve(6,r.IExtHostCommands),Ve(7,u.IExtHostTesting)],b)}),define(Te[316],Pe([1,0,14,65,2,5,266,12,61,75,27,211,17,66,47,67]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,S=$e(S),T=$e(T);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(R.ILogService),l=i.get(c.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(u=>{r.error(u);const g=S.transformErrorForSerialization(u);l.$onUnexpectedError(g)})}static async installFullHandler(i){const r=i.get(R.ILogService),t=i.get(c.IExtHostRpcService),l=i.get(h.IExtHostExtensionService),u=i.get(n.IExtHostTelemetry),g=t.getProxy(O.MainContext.MainThreadExtensionService),m=t.getProxy(O.MainContext.MainThreadErrors),p=await l.getExtensionPathIndex(),y=new WeakMap;function C(P,f){if(y.has(P))return y.get(P).stack;let E="",F,L;for(const V of f)E+=`
	at ${V.toString()}`,L=V.getFileName(),!F&&L&&(F=p.findSubstr(I.URI.file(L)));const M=`${P.name||"Error"}: ${P.message||""}${E}`;return y.set(P,{extensionIdentifier:F?.identifier,stack:M}),M}const b=Symbol("prepareStackTrace wrapped");let D=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return D},set(P){if(P===C||!P||P[b]){D=P||C;return}D=function(f,E){return C(f,E),P.call(Error,f,E)},Object.assign(D,{[b]:!0})}}),S.setUnexpectedErrorHandler(P=>{r.error(P);const f=S.transformErrorForSerialization(P),E=y.get(P);if(!E?.extensionIdentifier){m.$onUnexpectedError(f);return}g.$onExtensionRuntimeError(E.extensionIdentifier,f);const F=u.onExtensionError(E.extensionIdentifier,P);r.trace("forwarded error to extension?",F,E)})}}e.ErrorHandler=s;class o{constructor(i,r,t,l,u){this._hostUtils=t,this._rpcProtocol=new A.RPCProtocol(i,null,l),r=o._transform(r,this._rpcProtocol);const g=new a.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());g.set(k.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:u}),g.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),g.set(_.IURITransformerService,new _.URITransformerService(l)),g.set(h.IHostUtils,t);const m=new w.InstantiationService(g,!0);m.invokeFunction(s.installEarlyHandler),this._logService=m.invokeFunction(p=>p.get(R.ILogService)),T.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=m.invokeFunction(p=>p.get(h.IExtHostExtensionService)),this._extensionService.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const r=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,r){i.extensions.allExtensions.forEach(l=>{l.extensionLocation=I.URI.revive(r.transformIncomingURIs(l.extensionLocation))}),i.environment.appRoot=I.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(l=>I.URI.revive(r.transformIncomingURIs(l)))),i.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=I.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=I.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=o}),define(Te[317],Pe([1,0,18,11,22,41,16,20,24,2,44]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=n,R=$e(R),v=$e(v);class w{constructor(d,i,r){this.queryProviderPair=d,this.fileUtils=i,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(d,i){const r=this.query.folderQueries||[],t=new I.CancellationTokenSource(i);return new Promise((l,u)=>{this.collector=new _(d);let g=!1;const m=(p,y)=>{if(!g&&!this.isLimitHit){const C=this.resultSize(p);n(p)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,g=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const b=this.resultSize(p);this.resultCount+=b,(b>0||!n(p))&&this.collector.add(p,y)}};Promise.all(r.map((p,y)=>this.searchInFolder(p,C=>m(C,y),t.token))).then(p=>{t.dispose(),this.collector.flush();const y=p.some(C=>!!C&&!!C.limitHit);l({limitHit:this.isLimitHit||y,messages:p.flatMap(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[]),stats:{type:this.processType}})},p=>{t.dispose();const y=(0,O.toErrorMessage)(p);u(new Error(y))})})}resultSize(d){return n(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,i){const r=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:d.preview.text},uri:d.uri}}async searchInFolder(d,i,r){const t=new k.QueryGlobTester(this.query,d),l=[],u={report:p=>{if(!this.validateProviderResult(p))return;const y=d.folder.scheme===A.Schemas.file?(0,k.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(v.dirname(p.uri))):void 0,C=v.relativePath(d.folder,p.uri);if(C){const b=t.includedInQuery(C,R.basename(C),y);(0,T.isThenable)(b)?l.push(b.then(D=>{D&&i(p)})):b&&i(p)}}},g=this.getSearchOptionsForFolder(d);let m;return this.queryProviderPair.query.type===k.QueryType.aiText?m=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,g,u,r):m=await this.queryProviderPair.provider.provideTextSearchResults(c(this.queryProviderPair.query.contentPattern),g,u,r),l.length&&await Promise.all(l),m}validateProviderResult(d){if(n(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const i=(0,k.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),r=(0,k.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:a.URI.from(d.folder),excludes:r,includes:i,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??k.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(t.usePCRE2=this.query.usePCRE2),t}}e.TextSearchManager=w;function c(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class _{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new s(512,i=>this.sendItems(i))}add(d,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!v.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=_;function h(o){return n(o)?{preview:{matches:(0,S.mapArrayOrNot)(o.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:o.preview.text},ranges:(0,S.mapArrayOrNot)(o.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function n(o){return!!o.preview}class s{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(d,i){this.maxBatchSize=d,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,i){d&&this.addItemToBatch(d,i)}addItems(d,i){d&&this.addItemsToBatch(d,i)}addItemToBatch(d,i){this.batch.push(d),this.batchSize+=i,this.onUpdate()}addItemsToBatch(d,i){this.batch=this.batch.concat(d),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<s.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},s.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=s}),define(Te[134],Pe([1,0,4,5,3,312,17,66,12,2,317]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=c,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let w=class{constructor(n,s,o){this.extHostRpc=n,this._uriTransformer=s,this._logService=o,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,s){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const o=this._handlePool++;return this._textSearchProvider.set(o,s),this._proxy.$registerTextSearchProvider(o,this._transformScheme(n)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerAITextSearchProvider(n,s){if(this._aiTextSearchUsedSchemes.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this._aiTextSearchUsedSchemes.add(n);const o=this._handlePool++;return this._aiTextSearchProvider.set(o,s),this._proxy.$registerAITextSearchProvider(o,this._transformScheme(n)),(0,S.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(n),this._aiTextSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(n,s){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const o=this._handlePool++;return this._fileSearchProvider.set(o,s),this._proxy.$registerFileSearchProvider(o,this._transformScheme(n)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(n,s,o,d){const i=c(o),r=this._fileSearchProvider.get(n);if(r)return this._fileSearchManager.fileSearch(i,r,t=>{this._proxy.$handleFileMatch(n,s,t.map(l=>l.resource))},d);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,s,o){return{messages:[]}}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,s,o,d){const i=this._textSearchProvider.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=c(o);return this.createTextSearchManager(r,i).search(l=>this._proxy.$handleTextMatch(n,s,l),d)}$provideAITextSearchResults(n,s,o,d){const i=this._aiTextSearchProvider.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=c(o);return this.createAITextSearchManager(r,i).search(l=>this._proxy.$handleTextMatch(n,s,l),d)}$enableExtensionHostSearch(){}createTextSearchManager(n,s){return new k.TextSearchManager({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}createAITextSearchManager(n,s){return new k.TextSearchManager({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.ExtHostSearch=w,e.ExtHostSearch=w=je([Ve(0,A.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,v.ILogService)],w);function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(_),extraFileResources:h.extraFileResources&&h.extraFileResources.map(n=>a.URI.revive(n))}}function _(h){return{...h,folder:a.URI.revive(h.folder)}}});var Zt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(Te[318],Pe([1,0,22,14,6,4,16,36,2,106,165,151,52,19,30,12,63,64,226,5,269,298,85,91,274,275,276,253,243,34,277,46,278,133,122,279,255,270,280,281,58,71,256,271,47,283,69,284,51,27,299,257,285,286,95,287,86,87,259,311,289,231,290,300,291,128,260,292,293,294,17,295,134,88,296,261,297,89,92,131,67,57,126,96,301,272,302,303,93,8,7,262,66,263,68,304,305,121,45,81,84,25,130]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m,p,y,C,b,D,P,f,E,F,L,M,V,W,N,Q,Y,ge,Z,me,se,le,Ee,oe,Ie,Me,X,$,te,Se,ce,be,he,G,J,pe,ve,Oe,Ue,De,Ae,Le,B,x,H,j,ne,fe,ke,xe,qe,Ze,tt,nt,et,rt,ft,lt,st,ct,gt,pt,ze,Be,ee,q,Ce,Ge,Je,dt,vt,Lt,Ft,ei,ui,ti,Qe,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=qt,T=$e(T),R=Zt(R),w=$e(w),h=$e(h),ee=$e(ee),q=$e(q);function qt(mt){const It=mt.get(Ie.IExtHostInitDataService),ii=mt.get(oe.IExtHostFileSystemInfo),Xt=mt.get(le.IExtHostConsumerFileSystem),zt=mt.get(me.IExtHostExtensionService),St=mt.get(ei.IExtHostWorkspace),Ot=mt.get(rt.IExtHostTelemetry),di=mt.get(P.IExtHostConfiguration),Wt=mt.get(Ge.IURITransformerService),Xe=mt.get(j.IExtHostRpcService),Qt=mt.get(tt.IExtHostStorage),ni=mt.get(nt.IExtensionStoragePaths),hi=mt.get(n.ILoggerService),yt=mt.get(n.ILogService),Nt=mt.get(Be.IExtHostTunnelService),kt=mt.get(l.IExtHostApiDeprecationService),Ut=mt.get(Ft.IExtHostWindow),ri=mt.get(ke.IExtHostSecretState),Yt=mt.get(Y.IExtHostEditorTabs),si=mt.get(he.IExtHostManagedSockets),$t=mt.get(u.IExtHostAuthentication),jt=mt.get(Se.IExtHostLanguageModels);Xe.set(i.ExtHostContext.ExtHostFileSystemInfo,ii),Xe.set(i.ExtHostContext.ExtHostLogLevelServiceShape,hi),Xe.set(i.ExtHostContext.ExtHostWorkspace,St),Xe.set(i.ExtHostContext.ExtHostConfiguration,di),Xe.set(i.ExtHostContext.ExtHostExtensionService,zt),Xe.set(i.ExtHostContext.ExtHostStorage,Qt),Xe.set(i.ExtHostContext.ExtHostTunnelService,Nt),Xe.set(i.ExtHostContext.ExtHostWindow,Ut),Xe.set(i.ExtHostContext.ExtHostSecretState,ri),Xe.set(i.ExtHostContext.ExtHostTelemetry,Ot),Xe.set(i.ExtHostContext.ExtHostEditorTabs,Yt),Xe.set(i.ExtHostContext.ExtHostManagedSockets,si),Xe.set(i.ExtHostContext.ExtHostAuthentication,$t),Xe.set(i.ExtHostContext.ExtHostChatProvider,jt);const oi=Xe.set(i.ExtHostContext.ExtHostDecorations,mt.get(F.IExtHostDecorations)),Pt=Xe.set(i.ExtHostContext.ExtHostDocumentsAndEditors,mt.get(Q.IExtHostDocumentsAndEditors)),Ct=Xe.set(i.ExtHostContext.ExtHostCommands,mt.get(b.IExtHostCommands)),bt=Xe.set(i.ExtHostContext.ExtHostTerminalService,mt.get(ft.IExtHostTerminalService)),Jt=Xe.set(i.ExtHostContext.ExtHostTerminalShellIntegration,mt.get(lt.IExtHostTerminalShellIntegration)),Dt=Xe.set(i.ExtHostContext.ExtHostDebugService,mt.get(E.IExtHostDebugService)),fi=Xe.set(i.ExtHostContext.ExtHostSearch,mt.get(fe.IExtHostSearch)),Vt=Xe.set(i.ExtHostContext.ExtHostTask,mt.get(et.IExtHostTask)),bi=Xe.set(i.ExtHostContext.ExtHostOutputService,mt.get(Ae.IExtHostOutputService)),Si=Xe.set(i.ExtHostContext.ExtHostLocalization,mt.get(be.IExtHostLocalizationService)),gi=Xe.set(i.ExtHostContext.ExtHostUrls,new Je.ExtHostUrls(Xe)),xt=Xe.set(i.ExtHostContext.ExtHostDocuments,new N.ExtHostDocuments(Xe,Pt)),ai=Xe.set(i.ExtHostContext.ExtHostDocumentContentProviders,new V.ExtHostDocumentContentProvider(Xe,Pt,yt)),Ti=Xe.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new W.ExtHostDocumentSaveParticipant(yt,xt,Xe.getProxy(i.MainContext.MainThreadBulkEdits))),At=Xe.set(i.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(Xe,Ct,Pt,xt,Xt,fi,yt)),Ci=Xe.set(i.ExtHostContext.ExtHostNotebookDocuments,new ve.ExtHostNotebookDocuments(At)),Pi=Xe.set(i.ExtHostContext.ExtHostNotebookEditors,new Oe.ExtHostNotebookEditors(yt,At)),yi=Xe.set(i.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(Xe,It,At,Ct,yt)),pi=Xe.set(i.ExtHostContext.ExtHostNotebookRenderers,new De.ExtHostNotebookRenderers(Xe,At)),ki=Xe.set(i.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new pe.ExtHostNotebookDocumentSaveParticipant(yt,At,Xe.getProxy(i.MainContext.MainThreadBulkEdits))),Bt=Xe.set(i.ExtHostContext.ExtHostEditors,new ct.ExtHostEditors(Xe,Pt)),we=Xe.set(i.ExtHostContext.ExtHostTreeViews,new ze.ExtHostTreeViews(Xe.getProxy(i.MainContext.MainThreadTreeViews),Ct,yt)),Re=Xe.set(i.ExtHostContext.ExtHostEditorInsets,new C.ExtHostEditorInsets(Xe.getProxy(i.MainContext.MainThreadEditorInsets),Bt,It.remote)),ue=Xe.set(i.ExtHostContext.ExtHostDiagnostics,new L.ExtHostDiagnostics(Xe,yt,ii,Pt)),K=Xe.set(i.ExtHostContext.ExtHostLanguages,new ce.ExtHostLanguages(Xe,xt,Ct.converter,Wt)),_e=Xe.set(i.ExtHostContext.ExtHostLanguageFeatures,new $.ExtHostLanguageFeatures(Xe,Wt,xt,Ct,ue,yt,kt,Ot)),We=Xe.set(i.ExtHostContext.ExtHostFileSystem,new se.ExtHostFileSystem(Xe,_e)),Ye=Xe.set(i.ExtHostContext.ExtHostFileSystemEventService,new Ee.ExtHostFileSystemEventService(Xe,yt,Pt)),He=Xe.set(i.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Xe,St,Ct)),ut=Xe.set(i.ExtHostContext.ExtHostSCM,new ne.ExtHostSCM(Xe,Ct,xt,yt)),Tt=Xe.set(i.ExtHostContext.ExtHostQuickDiff,new x.ExtHostQuickDiff(Xe,Wt)),Kt=Xe.set(i.ExtHostContext.ExtHostShare,new xe.ExtHostShare(Xe,Wt)),li=Xe.set(i.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(Xe,Ct,xt)),Mt=Xe.set(i.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(Xe.getProxy(i.MainContext.MainThreadProgress))),ci=Xe.set(i.ExtHostContext.ExtHostLabelService,new X.ExtHostLabelService(Xe)),$i=Xe.set(i.ExtHostContext.ExtHostTheming,new gt.ExtHostTheming(Xe)),vn=Xe.set(i.ExtHostContext.ExtHostTimeline,new pt.ExtHostTimeline(Xe,Ct)),Mi=Xe.set(i.ExtHostContext.ExtHostWebviews,new dt.ExtHostWebviews(Xe,It.remote,St,yt,kt)),Oi=Xe.set(i.ExtHostContext.ExtHostWebviewPanels,new vt.ExtHostWebviewPanels(Xe,Mi,St)),Vi=Xe.set(i.ExtHostContext.ExtHostCustomEditors,new f.ExtHostCustomEditors(Xe,xt,ni,Mi,Oi)),Ji=Xe.set(i.ExtHostContext.ExtHostWebviewViews,new Lt.ExtHostWebviewViews(Xe,Mi)),Di=Xe.set(i.ExtHostContext.ExtHostTesting,mt.get(st.IExtHostTesting)),Zi=Xe.set(i.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(Xe)),en=Xe.set(i.ExtHostContext.ExtHostProfileContentHandlers,new Le.ExtHostProfileContentHandlers(Xe));Xe.set(i.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Xe,At,Pt,Ct,yt));const Fi=Xe.set(i.ExtHostContext.ExtHostChatAgents2,new m.ExtHostChatAgents2(Xe,yt,Ct)),tn=Xe.set(i.ExtHostContext.ExtHostChatVariables,new p.ExtHostChatVariables(Xe)),Hi=Xe.set(i.ExtHostContext.ExtHostLanguageModelTools,new te.ExtHostLanguageModelTools(Xe)),nn=Xe.set(i.ExtHostContext.ExtHostAiRelatedInformation,new r.ExtHostRelatedInformation(Xe)),qi=Xe.set(i.ExtHostContext.ExtHostAiEmbeddingVector,new Z.ExtHostAiEmbeddingVector(Xe)),Ui=Xe.set(i.ExtHostContext.ExtHostStatusBar,new Ze.ExtHostStatusBar(Xe,Ct.converter)),En=Xe.set(i.ExtHostContext.ExtHostSpeech,new qe.ExtHostSpeech(Xe)),Li=Xe.set(i.ExtHostContext.ExtHostEmbeddings,new ge.ExtHostEmbeddings(Xe)),rn=Object.values(i.ExtHostContext);Xe.assertRegistered(rn);const bn=new g.ExtHostBulkEdits(Xe,Pt),ji=new y.ExtHostClipboard(Xe),xi=new G.ExtHostMessageService(Xe,yt),Ki=new M.ExtHostDialogs(Xe);return t.ExtHostApiCommands.register(Ct),function(Fe,wi,Bi){function ot(ie){return(de,Ne,at)=>{const _t=ie(Rt=>{try{de.call(Ne,Rt)}catch(Ai){T.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Ot.onExtensionError(Fe.identifier,Ai)}});return at?.push(_t),_t}}const Et=function(){let ie=!Fe.isUnderDevelopment;function de(){ie||(yt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")de();else{const _t=at;typeof _t.scheme>"u"&&de(),typeof _t.exclusive=="boolean"&&(0,Qe.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return at}}(),zi={getSession(ie,de,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,Qe.checkProposedApiEnabled)(Fe,"authLearnMore"),Ne?.account&&(0,Qe.checkProposedApiEnabled)(Fe,"authGetSessions"),$t.getSession(Fe,ie,de,Ne)},getAccounts(ie){return(0,Qe.checkProposedApiEnabled)(Fe,"authGetSessions"),$t.getAccounts(ie)},async hasSession(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"authSession"),!!await $t.getSession(Fe,ie,de,{silent:!0})},get onDidChangeSessions(){return ot($t.onDidChangeSessions)},registerAuthenticationProvider(ie,de,Ne,at){return $t.registerAuthenticationProvider(ie,de,Ne,at)}},Sn={registerCommand(ie,de,Ne){return Ct.registerCommand(!0,ie,de,Ne,void 0,Fe)},registerTextEditorCommand(ie,de,Ne){return Ct.registerCommand(!0,ie,(...at)=>{const _t=Bt.getActiveTextEditor();if(!_t){yt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return _t.edit(Rt=>{de.apply(Ne,[_t,Rt,...at])}).then(Rt=>{Rt||yt.warn("Edits from command "+ie+" were not applied.")},Rt=>{yt.warn("An error occurred while running command "+ie,Rt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"diffCommand"),Ct.registerCommand(!0,ie,async(...at)=>{const _t=Pt.activeEditor(!0);if(!_t){yt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Rt=await Bt.getDiffInformation(_t.id);de.apply(Ne,[Rt,...at])},void 0,void 0,Fe)),executeCommand(ie,...de){return Ct.executeCommand(ie,...de)},getCommands(ie=!1){return Ct.getCommands(ie)}},mi={get machineId(){return It.telemetryInfo.machineId},get sessionId(){return It.telemetryInfo.sessionId},get language(){return It.environment.appLanguage},get appName(){return It.environment.appName},get appRoot(){return It.environment.appRoot?.fsPath??""},get appHost(){return It.environment.appHost},get uriScheme(){return It.environment.appUriScheme},get clipboard(){return ji.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(Fe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(Fe,"telemetry"),ot(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.isNewAppInstall)(It.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,de){return rt.ExtHostTelemetryLogger.validateSender(ie),Ot.instantiateLogger(Fe,ie,de)},openExternal(ie,de){return Ut.openUri(ie,{allowTunneling:!!It.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===It.environment.appUriScheme)return gi.createAppUri(ie);try{return await Ut.asExternalUri(ie,{allowTunneling:!!It.remote.authority})}catch(de){if((0,A.matchesScheme)(ie,A.Schemas.http)||(0,A.matchesScheme)(ie,A.Schemas.https))return ie;throw de}},get remoteName(){return(0,s.getRemoteName)(It.remote.authority)},get remoteAuthority(){return(0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),It.remote.authority},get uiKind(){return It.uiKind},get logLevel(){return yt.getLevel()},get onDidChangeLogLevel(){return ot(yt.onDidChangeLogLevel)},get appQuality(){return(0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),It.quality},get appCommit(){return(0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),It.commit}};It.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(ie,de,Ne){return Di.createTestController(Fe,ie,de,Ne)},createTestObserver(){return(0,Qe.checkProposedApiEnabled)(Fe,"testObserver"),Di.createTestObserver()},runTests(ie){return(0,Qe.checkProposedApiEnabled)(Fe,"testObserver"),Di.runTests(ie)},registerTestFollowupProvider(ie){return(0,Qe.checkProposedApiEnabled)(Fe,"testObserver"),Di.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Qe.checkProposedApiEnabled)(Fe,"testObserver"),ot(Di.onResultsChanged)},get testResults(){return(0,Qe.checkProposedApiEnabled)(Fe,"testObserver"),Di.results}},Ni=It.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,sn={getExtension(ie,de){(0,Qe.isProposedApiEnabled)(Fe,"extensionsAny")||(de=!1);const Ne=wi.mine.getExtensionDescription(ie);if(Ne)return new me.Extension(zt,Fe.identifier,Ne,Ni,!1);if(de){const at=wi.all.getExtensionDescription(ie);if(at)return new me.Extension(zt,Fe.identifier,at,Ni,!0)}},get all(){const ie=[];for(const de of wi.mine.getAllExtensionDescriptions())ie.push(new me.Extension(zt,Fe.identifier,de,Ni,!1));return ie},get allAcrossExtensionHosts(){(0,Qe.checkProposedApiEnabled)(Fe,"extensionsAny");const ie=new _.ExtensionIdentifierSet(wi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),de=[];for(const Ne of wi.all.getAllExtensionDescriptions()){const at=!ie.has(Ne.identifier);de.push(new me.Extension(zt,Fe.identifier,Ne,Ni,at))}return de},get onDidChange(){return(0,Qe.isProposedApiEnabled)(Fe,"extensionsAny")?ot(I.Event.any(wi.mine.onDidChange,wi.all.onDidChange)):ot(wi.mine.onDidChange)}},on={createDiagnosticCollection(ie){return ue.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return ot(ue.onDidChangeDiagnostics)},getDiagnostics:ie=>ue.getDiagnostics(ie),getLanguages(){return K.getLanguages()},setTextDocumentLanguage(ie,de){return K.changeLanguage(ie.uri,de)},match(ie,de){const Ne=ee.LanguageSelector.from(ie);let at;return(0,k.targetsNotebooks)(Ne)&&(at=At.notebookDocuments.find(_t=>_t.apiNotebook.getCells().find(Rt=>Rt.document===de))?.apiNotebook),(0,k.score)(Ne,de.uri,de.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,de,Ne){return _e.registerCodeActionProvider(Fe,Et(ie),de,Ne)},registerDocumentPasteEditProvider(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"documentPaste"),_e.registerDocumentPasteEditProvider(Fe,Et(ie),de,Ne)},registerCodeLensProvider(ie,de){return _e.registerCodeLensProvider(Fe,Et(ie),de)},registerDefinitionProvider(ie,de){return _e.registerDefinitionProvider(Fe,Et(ie),de)},registerDeclarationProvider(ie,de){return _e.registerDeclarationProvider(Fe,Et(ie),de)},registerImplementationProvider(ie,de){return _e.registerImplementationProvider(Fe,Et(ie),de)},registerTypeDefinitionProvider(ie,de){return _e.registerTypeDefinitionProvider(Fe,Et(ie),de)},registerHoverProvider(ie,de){return _e.registerHoverProvider(Fe,Et(ie),de,Fe.identifier)},registerEvaluatableExpressionProvider(ie,de){return _e.registerEvaluatableExpressionProvider(Fe,Et(ie),de,Fe.identifier)},registerInlineValuesProvider(ie,de){return _e.registerInlineValuesProvider(Fe,Et(ie),de,Fe.identifier)},registerDocumentHighlightProvider(ie,de){return _e.registerDocumentHighlightProvider(Fe,Et(ie),de)},registerMultiDocumentHighlightProvider(ie,de){return _e.registerMultiDocumentHighlightProvider(Fe,Et(ie),de)},registerLinkedEditingRangeProvider(ie,de){return _e.registerLinkedEditingRangeProvider(Fe,Et(ie),de)},registerReferenceProvider(ie,de){return _e.registerReferenceProvider(Fe,Et(ie),de)},registerRenameProvider(ie,de){return _e.registerRenameProvider(Fe,Et(ie),de)},registerNewSymbolNamesProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"newSymbolNamesProvider"),_e.registerNewSymbolNamesProvider(Fe,Et(ie),de)},registerDocumentSymbolProvider(ie,de,Ne){return _e.registerDocumentSymbolProvider(Fe,Et(ie),de,Ne)},registerWorkspaceSymbolProvider(ie){return _e.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,de){return _e.registerDocumentFormattingEditProvider(Fe,Et(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return _e.registerDocumentRangeFormattingEditProvider(Fe,Et(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Ne,...at){return _e.registerOnTypeFormattingEditProvider(Fe,Et(ie),de,[Ne].concat(at))},registerDocumentSemanticTokensProvider(ie,de,Ne){return _e.registerDocumentSemanticTokensProvider(Fe,Et(ie),de,Ne)},registerDocumentRangeSemanticTokensProvider(ie,de,Ne){return _e.registerDocumentRangeSemanticTokensProvider(Fe,Et(ie),de,Ne)},registerSignatureHelpProvider(ie,de,Ne,...at){return typeof Ne=="object"?_e.registerSignatureHelpProvider(Fe,Et(ie),de,Ne):_e.registerSignatureHelpProvider(Fe,Et(ie),de,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(ie,de,...Ne){return _e.registerCompletionItemProvider(Fe,Et(ie),de,Ne)},registerInlineCompletionItemProvider(ie,de,Ne){return de.handleDidShowCompletionItem&&(0,Qe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Qe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),Ne&&(0,Qe.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),_e.registerInlineCompletionsProvider(Fe,Et(ie),de,Ne)},registerInlineEditProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"inlineEdit"),_e.registerInlineEditProvider(Fe,Et(ie),de)},registerDocumentLinkProvider(ie,de){return _e.registerDocumentLinkProvider(Fe,Et(ie),de)},registerColorProvider(ie,de){return _e.registerColorProvider(Fe,Et(ie),de)},registerFoldingRangeProvider(ie,de){return _e.registerFoldingRangeProvider(Fe,Et(ie),de)},registerSelectionRangeProvider(ie,de){return _e.registerSelectionRangeProvider(Fe,ie,de)},registerCallHierarchyProvider(ie,de){return _e.registerCallHierarchyProvider(Fe,ie,de)},registerTypeHierarchyProvider(ie,de){return _e.registerTypeHierarchyProvider(Fe,ie,de)},setLanguageConfiguration:(ie,de)=>_e.setLanguageConfiguration(Fe,ie,de),getTokenInformationAtPosition(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"tokenInformation"),K.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return _e.registerInlayHintsProvider(Fe,ie,de)},createLanguageStatusItem(ie,de){return K.createLanguageStatusItem(Fe,ie,de)},registerDocumentDropEditProvider(ie,de,Ne){return _e.registerDocumentOnDropEditProvider(Fe,ie,de,(0,Qe.isProposedApiEnabled)(Fe,"documentPaste")?Ne:void 0)}},an={get activeTextEditor(){return Bt.getActiveTextEditor()},get visibleTextEditors(){return Bt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,de,Ne){v.URI.isUri(ie)&&ie.scheme===A.Schemas.vscodeRemote&&!ie.authority&&kt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(v.URI.isUri(ie)?Promise.resolve(ln.openTextDocument(ie)):Promise.resolve(ie));return Bt.showTextDocument(at,de,Ne)},createTextEditorDecorationType(ie){return Bt.createTextEditorDecorationType(Fe,ie)},onDidChangeActiveTextEditor(ie,de,Ne){return ot(Bt.onDidChangeActiveTextEditor)(ie,de,Ne)},onDidChangeVisibleTextEditors(ie,de,Ne){return ot(Bt.onDidChangeVisibleTextEditors)(ie,de,Ne)},onDidChangeTextEditorSelection(ie,de,Ne){return ot(Bt.onDidChangeTextEditorSelection)(ie,de,Ne)},onDidChangeTextEditorOptions(ie,de,Ne){return ot(Bt.onDidChangeTextEditorOptions)(ie,de,Ne)},onDidChangeTextEditorVisibleRanges(ie,de,Ne){return ot(Bt.onDidChangeTextEditorVisibleRanges)(ie,de,Ne)},onDidChangeTextEditorViewColumn(ie,de,Ne){return ot(Bt.onDidChangeTextEditorViewColumn)(ie,de,Ne)},onDidCloseTerminal(ie,de,Ne){return ot(bt.onDidCloseTerminal)(ie,de,Ne)},onDidOpenTerminal(ie,de,Ne){return ot(bt.onDidOpenTerminal)(ie,de,Ne)},onDidChangeActiveTerminal(ie,de,Ne){return ot(bt.onDidChangeActiveTerminal)(ie,de,Ne)},onDidChangeTerminalDimensions(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ie,de,Ne)},onDidChangeTerminalState(ie,de,Ne){return ot(bt.onDidChangeTerminalState)(ie,de,Ne)},onDidWriteTerminalData(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ie,de,Ne)},onDidExecuteTerminalCommand(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ie,de,Ne)},onDidChangeTerminalShellIntegration(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Jt.onDidChangeTerminalShellIntegration)(ie,de,Ne)},onDidStartTerminalShellExecution(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Jt.onDidStartTerminalShellExecution)(ie,de,Ne)},onDidEndTerminalShellExecution(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Jt.onDidEndTerminalShellExecution)(ie,de,Ne)},get state(){return Ut.getState()},onDidChangeWindowState(ie,de,Ne){return ot(Ut.onDidChangeWindowState)(ie,de,Ne)},showInformationMessage(ie,...de){return xi.showMessage(Fe,R.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return xi.showMessage(Fe,R.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return xi.showMessage(Fe,R.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Ne){return He.showQuickPick(Fe,ie,de,Ne)},showWorkspaceFolderPick(ie){return He.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return He.showInput(ie,de)},showOpenDialog(ie){return Ki.showOpenDialog(Fe,ie)},showSaveDialog(ie){return Ki.showSaveDialog(ie)},createStatusBarItem(ie,de,Ne){let at,_t,Rt;return typeof ie=="string"?(at=ie,_t=de,Rt=Ne):(_t=ie,Rt=de),Ui.createStatusBarEntry(Fe,at,_t,Rt)},setStatusBarMessage(ie,de){return Ui.setStatusBarMessage(ie,de)},withScmProgress(ie){return kt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Mt.withProgress(Fe,{location:q.ProgressLocation.SourceControl},(de,Ne)=>ie({report(at){}}))},withProgress(ie,de){return Mt.withProgress(Fe,ie,de)},createOutputChannel(ie,de){return bi.createOutputChannel(ie,de,Fe)},createWebviewPanel(ie,de,Ne,at){return Oi.createWebviewPanel(Fe,ie,de,Ne,at)},createWebviewTextEditorInset(ie,de,Ne,at){return(0,Qe.checkProposedApiEnabled)(Fe,"editorInsets"),Re.createWebviewEditorInset(ie,de,Ne,at,Fe)},createTerminal(ie,de,Ne){return typeof ie=="object"?"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie):bt.createTerminal(ie,de,Ne)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return bt.registerProfileProvider(Fe,ie,de)},registerTerminalQuickFixProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ie,Fe.identifier.value,de)},registerTreeDataProvider(ie,de){return we.registerTreeDataProvider(ie,de,Fe)},createTreeView(ie,de){return we.createTreeView(ie,de,Fe)},registerWebviewPanelSerializer:(ie,de)=>Oi.registerWebviewPanelSerializer(Fe,ie,de),registerCustomEditorProvider:(ie,de,Ne={})=>Vi.registerCustomEditorProvider(Fe,ie,de,Ne),registerFileDecorationProvider(ie){return oi.registerFileDecorationProvider(ie,Fe)},registerUriHandler(ie){return gi.registerUriHandler(Fe,ie)},createQuickPick(){return He.createQuickPick(Fe)},createInputBox(){return He.createInputBox(Fe)},get activeColorTheme(){return $i.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Ne){return ot($i.onDidChangeActiveColorTheme)(ie,de,Ne)},registerWebviewViewProvider(ie,de,Ne){return Ji.registerWebviewViewProvider(Fe,ie,de,Ne?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Ne){return ot(At.onDidChangeActiveNotebookEditor)(ie,de,Ne)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,de,Ne){return ot(Pi.onDidChangeNotebookEditorSelection)(ie,de,Ne)},onDidChangeNotebookEditorVisibleRanges(ie,de,Ne){return ot(Pi.onDidChangeNotebookEditorVisibleRanges)(ie,de,Ne)},showNotebookDocument(ie,de){return At.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"externalUriOpener"),Zi.registerExternalUriOpener(Fe.identifier,ie,de,Ne)},registerProfileContentHandler(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"profileContentHandlers"),en.registerProfileContentHandler(Fe,ie,de)},registerQuickDiffProvider(ie,de,Ne,at){return(0,Qe.checkProposedApiEnabled)(Fe,"quickDiffProvider"),Tt.registerQuickDiffProvider(Et(ie),de,Ne,at)},get tabGroups(){return Yt.tabGroups},registerShareProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"shareProvider"),Kt.registerShareProvider(Et(ie),de)}},ln={get rootPath(){return kt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),St.getPath()},set rootPath(ie){throw new T.ReadonlyError("rootPath")},getWorkspaceFolder(ie){return St.getWorkspaceFolder(ie)},get workspaceFolders(){return St.getWorkspaceFolders()},get name(){return St.name},set name(ie){throw new T.ReadonlyError("name")},get workspaceFile(){return St.workspaceFile},set workspaceFile(ie){throw new T.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ie,de,...Ne)=>St.updateWorkspaceFolders(Fe,ie,de||0,...Ne),onDidChangeWorkspaceFolders:function(ie,de,Ne){return ot(St.onDidChangeWorkspace)(ie,de,Ne)},asRelativePath:(ie,de)=>St.getRelativePath(ie,de),findFiles:(ie,de,Ne,at)=>St.findFiles(ie,de,Ne,Fe.identifier,at),findFiles2:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"findFiles2"),St.findFiles2(ie,de,Fe.identifier,Ne)),findTextInFiles:(ie,de,Ne,at)=>{(0,Qe.checkProposedApiEnabled)(Fe,"findTextInFiles");let _t,Rt;return typeof de=="object"?(_t=de,Rt=Ne):(_t={},Rt=de,at=Ne),St.findTextInFiles(ie,_t||{},Rt,Fe.identifier,at)},save:ie=>St.save(ie),saveAs:ie=>St.saveAs(ie),saveAll:ie=>St.saveAll(ie),applyEdit(ie,de){return bn.applyWorkspaceEdit(ie,Fe,de)},createFileSystemWatcher:(ie,de,Ne,at)=>{let _t;return typeof de=="boolean"?_t={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!at,correlate:!1}:de&&((0,Qe.checkProposedApiEnabled)(Fe,"createFileSystemWatcher"),_t={...de,correlate:!0}),Ye.createFileSystemWatcher(St,Fe,ie,_t)},get textDocuments(){return xt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new T.ReadonlyError("textDocuments")},openTextDocument(ie){let de;const Ne=ie;if(typeof ie=="string")de=Promise.resolve(v.URI.file(ie));else if(v.URI.isUri(ie))de=Promise.resolve(ie);else if(!Ne||typeof Ne=="object")de=xt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&kt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),xt.ensureDocumentData(at).then(_t=>_t.document)))},onDidOpenTextDocument:(ie,de,Ne)=>ot(xt.onDidAddDocument)(ie,de,Ne),onDidCloseTextDocument:(ie,de,Ne)=>ot(xt.onDidRemoveDocument)(ie,de,Ne),onDidChangeTextDocument:(ie,de,Ne)=>ot(xt.onDidChangeDocument)(ie,de,Ne),onDidSaveTextDocument:(ie,de,Ne)=>ot(xt.onDidSaveDocument)(ie,de,Ne),onWillSaveTextDocument:(ie,de,Ne)=>ot(Ti.getOnWillSaveTextDocumentEvent(Fe))(ie,de,Ne),get notebookDocuments(){return At.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Ne;if(v.URI.isUri(ie))Ne=ie,await At.openNotebookDocument(ie);else if(typeof ie=="string")Ne=v.URI.revive(await At.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return At.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ie,de,Ne){return ot(Ci.onDidSaveNotebookDocument)(ie,de,Ne)},onDidChangeNotebookDocument(ie,de,Ne){return ot(Ci.onDidChangeNotebookDocument)(ie,de,Ne)},onWillSaveNotebookDocument(ie,de,Ne){return ot(ki.getOnWillSaveNotebookDocumentEvent(Fe))(ie,de,Ne)},get onDidOpenNotebookDocument(){return ot(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(At.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,de,Ne,at){return At.registerNotebookSerializer(Fe,ie,de,Ne,(0,Qe.isProposedApiEnabled)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,de,Ne)=>ot(Bi.onDidChangeConfiguration)(ie,de,Ne),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,Bi.getConfiguration(ie,de,Fe)},registerTextDocumentContentProvider(ie,de){return ai.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(kt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Vt.registerTaskProvider(Fe,ie,de)),registerFileSystemProvider(ie,de,Ne){return(0,O.combinedDisposable)(We.registerFileSystemProvider(Fe,ie,de,Ne),Xt.addFileSystemProvider(ie,de,Ne))},get fs(){return Xt.value},registerFileSearchProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"fileSearchProvider"),fi.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"textSearchProvider"),fi.registerTextSearchProvider(ie,de)),registerAITextSearchProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"aiTextSearchProvider"),(0,Qe.checkProposedApiEnabled)(Fe,"textSearchProvider"),fi.registerAITextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),zt.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),ci.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Qe.checkProposedApiEnabled)(Fe,"resolvers"),zt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,de,Ne)=>ot(Ye.onDidCreateFile)(ie,de,Ne),onDidDeleteFiles:(ie,de,Ne)=>ot(Ye.onDidDeleteFile)(ie,de,Ne),onDidRenameFiles:(ie,de,Ne)=>ot(Ye.onDidRenameFile)(ie,de,Ne),onWillCreateFiles:(ie,de,Ne)=>ot(Ye.getOnWillCreateFileEvent(Fe))(ie,de,Ne),onWillDeleteFiles:(ie,de,Ne)=>ot(Ye.getOnWillDeleteFileEvent(Fe))(ie,de,Ne),onWillRenameFiles:(ie,de,Ne)=>ot(Ye.getOnWillRenameFileEvent(Fe))(ie,de,Ne),openTunnel:ie=>((0,Qe.checkProposedApiEnabled)(Fe,"tunnels"),Nt.openTunnel(Fe,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Qe.checkProposedApiEnabled)(Fe,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"tunnels"),ot(Nt.onDidChangeTunnels)(ie,de,Ne)),registerPortAttributesProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"portsAttributes"),Nt.registerPortsAttributesProvider(ie,de)),registerTunnelProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"tunnelFactory"),Nt.registerTunnelProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"timeline"),vn.registerTimelineProvider(ie,de,Fe.identifier,Ct.converter)),get isTrusted(){return St.trusted},requestWorkspaceTrust:ie=>((0,Qe.checkProposedApiEnabled)(Fe,"workspaceTrust"),St.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Ne)=>ot(St.onDidGrantWorkspaceTrust)(ie,de,Ne),registerEditSessionIdentityProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),St.registerEditSessionIdentityProvider(ie,de)),onWillCreateEditSessionIdentity:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),ot(St.getOnWillCreateEditSessionIdentityEvent(Fe))(ie,de,Ne)),registerCanonicalUriProvider:(ie,de)=>((0,Qe.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),St.registerCanonicalUriProvider(ie,de)),getCanonicalUri:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),St.provideCanonicalUri(ie,de,Ne))},cn={get inputBox(){return kt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Fe)},createSourceControl(ie,de,Ne){return ut.createSourceControl(Fe,ie,de,Ne)}},un={createCommentController(ie,de){return li.createCommentController(Fe,ie,de)}},wn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"debugVisualization"),Dt.registerDebugVisualizationProvider(Fe,ie,de)},registerDebugVisualizationTreeProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"debugVisualization"),Dt.registerDebugVisualizationTree(Fe,ie,de)},onDidStartDebugSession(ie,de,Ne){return ot(Dt.onDidStartDebugSession)(ie,de,Ne)},onDidTerminateDebugSession(ie,de,Ne){return ot(Dt.onDidTerminateDebugSession)(ie,de,Ne)},onDidChangeActiveDebugSession(ie,de,Ne){return ot(Dt.onDidChangeActiveDebugSession)(ie,de,Ne)},onDidReceiveDebugSessionCustomEvent(ie,de,Ne){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(ie,de,Ne)},onDidChangeBreakpoints(ie,de,Ne){return ot(Dt.onDidChangeBreakpoints)(ie,de,Ne)},onDidChangeActiveStackItem(ie,de,Ne){return ot(Dt.onDidChangeActiveStackItem)(ie,de,Ne)},registerDebugConfigurationProvider(ie,de,Ne){return Dt.registerDebugConfigurationProvider(ie,de,Ne||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return Dt.registerDebugAdapterDescriptorFactory(Fe,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return Dt.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Dt.startDebugging(ie,de,{parentSession:Ne}):Dt.startDebugging(ie,de,Ne||{})},stopDebugging(ie){return Dt.stopDebugging(ie)},addBreakpoints(ie){return Dt.addBreakpoints(ie)},removeBreakpoints(ie){return Dt.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return Dt.asDebugSourceUri(ie,de)}},_n={registerTaskProvider:(ie,de)=>Vt.registerTaskProvider(Fe,ie,de),fetchTasks:ie=>Vt.fetchTasks(ie),executeTask:ie=>Vt.executeTask(Fe,ie),get taskExecutions(){return Vt.taskExecutions},onDidStartTask:(ie,de,Ne)=>ot(Vt.onDidStartTask)(ie,de,Ne),onDidEndTask:(ie,de,Ne)=>ot(Vt.onDidEndTask)(ie,de,Ne),onDidStartTaskProcess:(ie,de,Ne)=>ot(Vt.onDidStartTaskProcess)(ie,de,Ne),onDidEndTaskProcess:(ie,de,Ne)=>ot(Vt.onDidEndTaskProcess)(ie,de,Ne)},dn={createNotebookController(ie,de,Ne,at,_t){return yi.createNotebookController(Fe,ie,de,Ne,at,(0,Qe.isProposedApiEnabled)(Fe,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>At.registerNotebookCellStatusBarItemProvider(Fe,ie,de),createRendererMessaging(ie){return pi.createRendererMessaging(Fe,ie)},createNotebookControllerDetectionTask(ie){return(0,Qe.checkProposedApiEnabled)(Fe,"notebookKernelSource"),yi.createNotebookControllerDetectionTask(Fe,ie)},registerKernelSourceActionProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"notebookKernelSource"),yi.registerKernelSourceActionProvider(Fe,ie,de)},onDidChangeNotebookCellExecutionState(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),ot(yi.onDidChangeNotebookCellExecutionState)(ie,de,Ne)}},Gi={t(...ie){if(typeof ie[0]=="string"){const de=ie.shift(),Ne=!ie||typeof ie[0]!="object"?ie:ie[0];return Si.getMessage(Fe.identifier.value,{message:de,args:Ne})}return Si.getMessage(Fe.identifier.value,ie[0])},get bundle(){return Si.getBundle(Fe.identifier.value)},get uri(){return Si.getBundleUri(Fe.identifier.value)}},hn={_version:1,transferActiveChat(ie){return(0,Qe.checkProposedApiEnabled)(Fe,"interactive"),Fi.transferActiveChat(ie)}},fn={getRelatedInformation(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),nn.getRelatedInformation(Fe,ie,de)},registerRelatedInformationProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Fe,ie,de)},registerEmbeddingVectorProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),qi.registerEmbeddingVectorProvider(Fe,ie,de)}},gn={_version:1,registerChatResponseProvider(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"chatProvider"),jt.registerLanguageModel(Fe,ie,de,Ne)},registerChatVariableResolver(ie,de,Ne,at,_t,Rt,Ai,Xi){return(0,Qe.checkProposedApiEnabled)(Fe,"chatVariableResolver"),tn.registerVariableResolver(Fe,ie,de,Ne,at,_t,Rt,Ai,Xi?.id)},registerMappedEditsProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"mappedEditsProvider"),_e.registerMappedEditsProvider(Fe,ie,de)},createChatParticipant(ie,de){return Fi.createChatAgent(Fe,ie,de)},createDynamicChatParticipant(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"chatParticipantPrivate"),Fi.createDynamicChatAgent(Fe,ie,de,Ne)}},Cn={selectChatModels:ie=>jt.selectLanguageModels(Fe,ie??{}),onDidChangeChatModels:(ie,de,Ne)=>jt.onDidChangeProviders(ie,de,Ne),registerChatModelProvider:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"chatProvider"),jt.registerLanguageModel(Fe,ie,de,Ne)),get embeddingModels(){return(0,Qe.checkProposedApiEnabled)(Fe,"embeddings"),Li.embeddingsModels},onDidChangeEmbeddingModels:(ie,de,Ne)=>((0,Qe.checkProposedApiEnabled)(Fe,"embeddings"),Li.onDidChange(ie,de,Ne)),registerEmbeddingsProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"embeddings"),Li.registerEmbeddingsProvider(Fe,ie,de)},async computeEmbeddings(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"embeddings"),Li.computeEmbeddings(ie,de,Ne)},registerTool(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"lmTools"),Hi.registerTool(Fe,ie,de)},invokeTool(ie,de,Ne){return(0,Qe.checkProposedApiEnabled)(Fe,"lmTools"),Hi.invokeTool(ie,de,Ne)},get tools(){return(0,Qe.checkProposedApiEnabled)(Fe,"lmTools"),Hi.tools}},yn={registerSpeechProvider(ie,de){return(0,Qe.checkProposedApiEnabled)(Fe,"speech"),En.registerProvider(Fe.identifier,ie,de)}};return{version:It.version,ai:fn,authentication:zi,commands:Sn,comments:un,chat:gn,debug:wn,env:mi,extensions:sn,interactive:hn,l10n:Gi,languages:on,lm:Cn,notebooks:dn,scm:cn,speech:yn,tasks:_n,tests:Wi,window:an,workspace:ln,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatResultFeedbackKind:q.ChatResultFeedbackKind,ChatVariableLevel:q.ChatVariableLevel,ChatCompletionItem:q.ChatCompletionItem,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CommentThreadApplicability:q.CommentThreadApplicability,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DebugVisualization:q.DebugVisualization,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,MultiDocumentHighlight:q.MultiDocumentHighlight,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:h.FileType,FilePermission:h.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,VerboseHover:q.VerboseHover,HoverVerbosityAction:q.HoverVerbosityAction,IndentAction:w.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:c.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixTerminalCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:ti.UIKind,Uri:v.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentPasteTriggerKind:q.DocumentPasteTriggerKind,DocumentDropEdit:q.DocumentDropEdit,DocumentDropOrPasteEditKind:q.DocumentDropOrPasteEditKind,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,ManagedResolvedAuthority:q.ManagedResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,NotebookVariablesRequestKind:q.NotebookVariablesRequestKind,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestMessage:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,TestCoverageCount:q.TestCoverageCount,FileCoverage:q.FileCoverage,FileCoverage2:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,DeclarationCoverage:q.DeclarationCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TabInputChat:q.ChatEditorTabInput,TabInputTextMultiDiff:q.TextMultiDiffTabInput,TelemetryTrustedValue:o.TelemetryTrustedValue,LogLevel:n.LogLevel,EditSessionIdentityMatch:d.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,ChatCopyKind:q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:q.DebugStackFrame,DebugThread:q.DebugThread,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus,TextToSpeechStatus:q.TextToSpeechStatus,PartialAcceptTriggerKind:q.PartialAcceptTriggerKind,KeywordRecognitionStatus:q.KeywordRecognitionStatus,ChatResponseMarkdownPart:q.ChatResponseMarkdownPart,ChatResponseFileTreePart:q.ChatResponseFileTreePart,ChatResponseAnchorPart:q.ChatResponseAnchorPart,ChatResponseProgressPart:q.ChatResponseProgressPart,ChatResponseProgressPart2:q.ChatResponseProgressPart2,ChatResponseReferencePart:q.ChatResponseReferencePart,ChatResponseWarningPart:q.ChatResponseWarningPart,ChatResponseTextEditPart:q.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:q.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:q.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:q.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:q.ChatResponseConfirmationPart,ChatRequestTurn:q.ChatRequestTurn,ChatResponseTurn:q.ChatResponseTurn,ChatLocation:q.ChatLocation,LanguageModelChatMessageRole:q.LanguageModelChatMessageRole,LanguageModelChatMessage:q.LanguageModelChatMessage,LanguageModelChatMessageFunctionResultPart:q.LanguageModelFunctionResultPart,LanguageModelChatResponseTextPart:q.LanguageModelTextPart,LanguageModelChatResponseFunctionUsePart:q.LanguageModelFunctionUsePart,LanguageModelChatMessage2:q.LanguageModelChatMessage,LanguageModelChatSystemMessage:q.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:q.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:q.LanguageModelChatAssistantMessage,LanguageModelError:q.LanguageModelError,NewSymbolName:q.NewSymbolName,NewSymbolNameTag:q.NewSymbolNameTag,NewSymbolNameTriggerKind:q.NewSymbolNameTriggerKind,InlineEdit:q.InlineEdit,InlineEditTriggerKind:q.InlineEditTriggerKind}}}}),define(Te[319],Pe([1,0,61,128,45,122,46,34,58,57,131,133,134,89,93,85,121,69,51,88,67,71,258,12,132,86,87,91,95,126,96]),function(ae,e,S,T,I,O,A,R,v,a,k,w,c,_,h,n,s,o,d,i,r,t,l,u,g,m,p,y,C,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.registerSingleton)(m.IExtHostLocalizationService,m.ExtHostLocalizationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(u.ILoggerService,l.ExtHostLoggerService,S.InstantiationType.Delayed),(0,S.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,S.InstantiationType.Eager),(0,S.registerSingleton)(y.IExtHostAuthentication,y.ExtHostAuthentication,S.InstantiationType.Eager),(0,S.registerSingleton)(C.IExtHostLanguageModels,C.ExtHostLanguageModels,S.InstantiationType.Eager),(0,S.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,S.InstantiationType.Eager),(0,S.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,S.InstantiationType.Eager),(0,S.registerSingleton)(D.IExtHostTesting,D.ExtHostTesting,S.InstantiationType.Eager),(0,S.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,S.InstantiationType.Eager),(0,S.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,S.InstantiationType.Eager),(0,S.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,S.InstantiationType.Eager),(0,S.registerSingleton)(p.IExtHostManagedSockets,p.ExtHostManagedSockets,S.InstantiationType.Eager),(0,S.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,S.InstantiationType.Eager),(0,S.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,S.InstantiationType.Delayed),(0,S.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch,S.InstantiationType.Eager),(0,S.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,S.InstantiationType.Eager),(0,S.registerSingleton)(k.IExtHostTask,k.WorkerExtHostTask,S.InstantiationType.Eager),(0,S.registerSingleton)(a.IExtHostTerminalService,a.WorkerExtHostTerminalService,S.InstantiationType.Eager),(0,S.registerSingleton)(b.IExtHostTerminalShellIntegration,b.ExtHostTerminalShellIntegration,S.InstantiationType.Eager),(0,S.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,S.InstantiationType.Eager),(0,S.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,S.InstantiationType.Eager),(0,S.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,S.InstantiationType.Eager),(0,S.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,S.InstantiationType.Eager),(0,S.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,S.InstantiationType.Eager),(0,S.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,S.InstantiationType.Eager),(0,S.registerSingleton)(g.IExtHostVariableResolverProvider,g.ExtHostVariableResolverProviderService,S.InstantiationType.Eager)}),define(Te[320],Pe([1,0,318,47,2,315,7,11,265]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends O.RequireInterceptor{_installInterceptor(){}getModule(_,h){for(const n of this._alternatives){const s=n(_);if(s){_=s;break}}if(this._factories.has(_))return this._factories.get(_).load(_,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(v.ExtHostConsoleForwarder);const _=this._instaService.invokeFunction(S.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(a,_,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(_){return _.browser}async _loadCommonJSModule(_,h,n){h=h.with({path:w(h.path,".js")});const s=_?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=I.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),d=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),d.status!==200)throw new Error(d.statusText);const i=await d.text(),r=`${h.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let l;try{l=new Function("module","exports","require",t)}catch(p){throw console.error(s?`Loading code for extension ${s} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${h.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}_&&await this._extHostLocalizationService.initializeLocalizedMessages(_);const u={},g={exports:u},m=p=>{const y=this._fakeModules.getModule(p,h);if(y===void 0)throw new Error(`Cannot load module '${p}'`);return y};try{return n.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),l(g,u,m),g.exports!==u?g.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}}async $setRemoteEnvironment(_){}async _waitForDebuggerAttachment(_=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+_;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=k;function w(c,_){return c.endsWith(_)?c:c+_}}),define(Te[321],Pe([1,0,74,61,12,47,229,92,320]),function(ae,e,S,T,I,O,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.registerSingleton)(I.ILogService,new S.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,T.registerSingleton)(O.IExtHostExtensionService,v.ExtHostExtensionService,T.InstantiationType.Eager),(0,T.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths,T.InstantiationType.Eager)}),define(Te[329],Pe([1,0,23,6,84,316,267,20,65,16,2,319,321]),function(ae,e,S,T,I,O,A,R,v,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,R=$e(R),v=$e(v);const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function _(l){return/^(file|vscode-remote):/i.test(l)}const h=fetch.bind(self);function n(l){self.fetch=async function(u,g){return u instanceof Request||_(String(u))&&(u=(await l(k.URI.parse(String(u)))).toString(!0)),h(u,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,g,m,p,y){(async()=>(_(g.toString())&&(g=(await l(k.URI.parse(g.toString()))).toString(!0)),super.open(u,g,m??!0,p,y)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const l=self.Worker;Worker=function(u,g){if(/^file:/i.test(u.toString()))u=a.FileAccess.uriToBrowserUri(k.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(D){function P(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const f=fetch.bind(self);self.fetch=function(F,L){return F instanceof Request?f(F,L):f(P(F),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,L,M,V,W){return super.open(F,P(L),M??!0,V,W)}};const E=importScripts.bind(self);self.importScripts=(...F)=>{E(...F.map(P))},E(D)}.toString()}('${u}'))`;g=g||{},g.name=`${name} -> ${g.name||R.basename(u.toString())}`;const y=new Blob([p],{type:"application/javascript"}),C=URL.createObjectURL(y);return new l(C,g)}}else self.Worker=class extends A.NestedWorker{constructor(l,u){super(c,l,{name:R.basename(l.toString()),...u})}};const s=new class{constructor(){this.pid=void 0}exit(l){w()}};class o{constructor(){const u=new MessageChannel,g=new T.Emitter;let m=!1;c(u.port2,[u.port2]),u.port1.onmessage=p=>{const{data:y}=p;if(!(y instanceof ArrayBuffer)){console.warn("UNKNOWN data received",y);return}const C=S.VSBuffer.wrap(new Uint8Array(y,0,y.byteLength));if((0,I.isMessageOfType)(C,I.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}g.fire(C)},this.protocol={onMessage:g.event,send:p=>{if(!m){const y=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);u.port1.postMessage(y,[y])}}}}}function d(l){return new Promise(u=>{const g=l.onMessage(m=>{g.dispose();const p=JSON.parse(m.toString());l.send((0,I.createMessageOfType)(I.MessageType.Initialized)),u({protocol:l,initData:p})});l.send((0,I.createMessageOfType)(I.MessageType.Ready))})}let i=l=>w();function r(l){return!!l&&typeof l=="object"&&l.type==="vscode.init"&&l.data instanceof Map}function t(){v.mark("code/extHost/willConnectToRenderer");const l=new o;return{onmessage(u){r(u)&&d(l.protocol).then(g=>{v.mark("code/extHost/didWaitForInitData");const m=new O.ExtensionHostMain(g.protocol,g.initData,s,null,u.data);n(p=>m.asBrowserUri(p)),i=p=>m.terminate(p)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/workbench/api/worker/extensionHostWorker.js.map
